------------------------------------------------------------------------------
--                                                                          --
--                            Matreshka Project                             --
--                                                                          --
--                          Ada Modeling Framework                          --
--                                                                          --
--                        Runtime Library Component                         --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2011, Vadim Godunko <vgodunko@gmail.com>                     --
-- All rights reserved.                                                     --
--                                                                          --
-- Redistribution and use in source and binary forms, with or without       --
-- modification, are permitted provided that the following conditions       --
-- are met:                                                                 --
--                                                                          --
--  * Redistributions of source code must retain the above copyright        --
--    notice, this list of conditions and the following disclaimer.         --
--                                                                          --
--  * Redistributions in binary form must reproduce the above copyright     --
--    notice, this list of conditions and the following disclaimer in the   --
--    documentation and/or other materials provided with the distribution.  --
--                                                                          --
--  * Neither the name of the Vadim Godunko, IE nor the names of its        --
--    contributors may be used to endorse or promote products derived from  --
--    this software without specific prior written permission.              --
--                                                                          --
-- THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS      --
-- "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT        --
-- LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR    --
-- A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT     --
-- HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,   --
-- SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED --
-- TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR   --
-- PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF   --
-- LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING     --
-- NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS       --
-- SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.             --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 3344 $ $Date: 2012-11-10 20:36:27 +0100 (Sat, 10 Nov 2012) $
------------------------------------------------------------------------------
--  This package provides subprogram to store/retrieve values with multiplicity
--  [0..1] of data types into/from holders. League.Holders already have empty
--  state and it is used to represent empty element.
------------------------------------------------------------------------------
with League.Holders;

package AMF.Holders is

   pragma Preelaborate;

   --  Boolean [0..1]

   function To_Holder (Item : Optional_Boolean) return League.Holders.Holder;
   function Element (Holder : League.Holders.Holder) return Optional_Boolean;

   --  String [0..1]

   function To_Holder (Item : Optional_String) return League.Holders.Holder;
   function Element (Holder : League.Holders.Holder) return Optional_String;

   --  Integer [0..1]

   function To_Holder (Item : Optional_Integer) return League.Holders.Holder;
   function Element (Holder : League.Holders.Holder) return Optional_Integer;

   --  UnlimitedNatural [0..1]

   function To_Holder
    (Item : Optional_Unlimited_Natural) return League.Holders.Holder;
   function Element
    (Holder : League.Holders.Holder) return Optional_Unlimited_Natural;

   --  Real [0..1]

   function To_Holder (Item : Optional_Real) return League.Holders.Holder;
   function Element (Holder : League.Holders.Holder) return Optional_Real;

end AMF.Holders;
