------------------------------------------------------------------------------
--                                                                          --
--                            Matreshka Project                             --
--                                                                          --
--                          Ada Modeling Framework                          --
--                                                                          --
--                        Runtime Library Component                         --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2010-2012, Vadim Godunko <vgodunko@gmail.com>                --
-- All rights reserved.                                                     --
--                                                                          --
-- Redistribution and use in source and binary forms, with or without       --
-- modification, are permitted provided that the following conditions       --
-- are met:                                                                 --
--                                                                          --
--  * Redistributions of source code must retain the above copyright        --
--    notice, this list of conditions and the following disclaimer.         --
--                                                                          --
--  * Redistributions in binary form must reproduce the above copyright     --
--    notice, this list of conditions and the following disclaimer in the   --
--    documentation and/or other materials provided with the distribution.  --
--                                                                          --
--  * Neither the name of the Vadim Godunko, IE nor the names of its        --
--    contributors may be used to endorse or promote products derived from  --
--    this software without specific prior written permission.              --
--                                                                          --
-- THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS      --
-- "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT        --
-- LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR    --
-- A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT     --
-- HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,   --
-- SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED --
-- TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR   --
-- PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF   --
-- LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING     --
-- NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS       --
-- SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.             --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 2747 $ $Date: 2012-03-27 22:47:17 +0200 (Tue, 27 Mar 2012) $
------------------------------------------------------------------------------
--  This package provides implementation of proxy to map collection of elements
--  into internal representation used to represent value of object's attribute.
------------------------------------------------------------------------------

package AMF.Internals.Collections.Elements.Proxies is

   type Shared_Element_Collection_Proxy is
     new Shared_Element_Collection with record
      Collection : AMF.Internals.AMF_Collection_Of_Element;
   end record;

   type Shared_Element_Collection_Proxy_Access is
     access all Shared_Element_Collection_Proxy'Class;

   overriding function Length
    (Self : not null access constant Shared_Element_Collection_Proxy)
       return Natural;

   overriding procedure Clear
    (Self : not null access Shared_Element_Collection_Proxy);

   overriding function Element
    (Self  : not null access constant Shared_Element_Collection_Proxy;
     Index : Positive) return not null AMF.Elements.Element_Access;

   overriding procedure Add
    (Self : not null access Shared_Element_Collection_Proxy;
     Item : not null AMF.Elements.Element_Access);

   overriding procedure Reference
    (Self : not null access Shared_Element_Collection_Proxy) is null;
   overriding procedure Unreference
    (Self : not null access Shared_Element_Collection_Proxy) is null;
   --  Reference to the proxy is owned by the collection table, reference
   --  counting is not used.

end AMF.Internals.Collections.Elements.Proxies;
