------------------------------------------------------------------------------
--                                                                          --
--                            Matreshka Project                             --
--                                                                          --
--                          Ada Modeling Framework                          --
--                                                                          --
--                        Runtime Library Component                         --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2012, Vadim Godunko <vgodunko@gmail.com>                     --
-- All rights reserved.                                                     --
--                                                                          --
-- Redistribution and use in source and binary forms, with or without       --
-- modification, are permitted provided that the following conditions       --
-- are met:                                                                 --
--                                                                          --
--  * Redistributions of source code must retain the above copyright        --
--    notice, this list of conditions and the following disclaimer.         --
--                                                                          --
--  * Redistributions in binary form must reproduce the above copyright     --
--    notice, this list of conditions and the following disclaimer in the   --
--    documentation and/or other materials provided with the distribution.  --
--                                                                          --
--  * Neither the name of the Vadim Godunko, IE nor the names of its        --
--    contributors may be used to endorse or promote products derived from  --
--    this software without specific prior written permission.              --
--                                                                          --
-- THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS      --
-- "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT        --
-- LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR    --
-- A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT     --
-- HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,   --
-- SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED --
-- TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR   --
-- PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF   --
-- LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING     --
-- NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS       --
-- SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.             --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 2927 $ $Date: 2012-05-01 10:40:03 +0200 (Tue, 01 May 2012) $
------------------------------------------------------------------------------
with AMF.Internals.Factories.CMOF_Factories;
with AMF.Internals.Factories.CMOF_Module_Factory;
with AMF.Internals.Tables.CMOF_Element_Table;
with AMF.Internals.Tables.CMOF_Metamodel.Objects;
with AMF.Internals.Tables.CMOF_Metamodel.Properties;
with AMF.Internals.Tables.CMOF_Metamodel.Links;

package body AMF.Internals.Modules.CMOF_Module is

   Module_Factory : aliased
     AMF.Internals.Factories.CMOF_Module_Factory.CMOF_Module_Factory;
   Module         : AMF_Metamodel;

begin
   --  Register module's factory, it should be registered before initialization
   --  of metamodel to be able to bootstrap CMOF module.

   AMF.Internals.Factories.Register (Module_Factory'Access, Module);

   --  Initialize element table.

   AMF.Internals.Tables.CMOF_Element_Table.Initialize (Module);

   --  Initialize metamodel.

   AMF.Internals.Tables.CMOF_Metamodel.Objects.Initialize;
   AMF.Internals.Tables.CMOF_Metamodel.Properties.Initialize;
   AMF.Internals.Tables.CMOF_Metamodel.Links.Initialize;

   --  Register factory's constructor.

   AMF.Internals.Factories.Register
    (AMF.Internals.Factories.CMOF_Factories.Get_Package,
     AMF.Internals.Factories.CMOF_Factories.Constructor'Access);
end AMF.Internals.Modules.CMOF_Module;
