------------------------------------------------------------------------------
--                                                                          --
--                            Matreshka Project                             --
--                                                                          --
--                          Ada Modeling Framework                          --
--                                                                          --
--                        Runtime Library Component                         --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2012-2013, Vadim Godunko <vgodunko@gmail.com>                --
-- All rights reserved.                                                     --
--                                                                          --
-- Redistribution and use in source and binary forms, with or without       --
-- modification, are permitted provided that the following conditions       --
-- are met:                                                                 --
--                                                                          --
--  * Redistributions of source code must retain the above copyright        --
--    notice, this list of conditions and the following disclaimer.         --
--                                                                          --
--  * Redistributions in binary form must reproduce the above copyright     --
--    notice, this list of conditions and the following disclaimer in the   --
--    documentation and/or other materials provided with the distribution.  --
--                                                                          --
--  * Neither the name of the Vadim Godunko, IE nor the names of its        --
--    contributors may be used to endorse or promote products derived from  --
--    this software without specific prior written permission.              --
--                                                                          --
-- THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS      --
-- "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT        --
-- LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR    --
-- A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT     --
-- HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,   --
-- SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED --
-- TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR   --
-- PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF   --
-- LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING     --
-- NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS       --
-- SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.             --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 3646 $ $Date: 2013-01-07 19:05:34 +0100 (Mon, 07 Jan 2013) $
------------------------------------------------------------------------------
--  This file is generated, don't edit it.
------------------------------------------------------------------------------
with AMF.OCL.Ocl_Expressions;
limited with AMF.OCL.Ocl_Expressions.Collections;
limited with AMF.UML.Call_Operation_Actions;
limited with AMF.UML.Send_Signal_Actions;

package AMF.OCL.Message_Exps is

   pragma Preelaborate;

   type OCL_Message_Exp is limited interface
     and AMF.OCL.Ocl_Expressions.OCL_Ocl_Expression;

   type OCL_Message_Exp_Access is
     access all OCL_Message_Exp'Class;
   for OCL_Message_Exp_Access'Storage_Size use 0;

   not overriding function Get_Target
    (Self : not null access constant OCL_Message_Exp)
       return AMF.OCL.Ocl_Expressions.OCL_Ocl_Expression_Access is abstract;
   --  Getter of MessageExp::target.
   --

   not overriding procedure Set_Target
    (Self : not null access OCL_Message_Exp;
     To   : AMF.OCL.Ocl_Expressions.OCL_Ocl_Expression_Access) is abstract;
   --  Setter of MessageExp::target.
   --

   not overriding function Get_Argument
    (Self : not null access constant OCL_Message_Exp)
       return AMF.OCL.Ocl_Expressions.Collections.Ordered_Set_Of_OCL_Ocl_Expression is abstract;
   --  Getter of MessageExp::argument.
   --

   not overriding function Get_Called_Operation
    (Self : not null access constant OCL_Message_Exp)
       return AMF.UML.Call_Operation_Actions.UML_Call_Operation_Action_Access is abstract;
   --  Getter of MessageExp::calledOperation.
   --

   not overriding procedure Set_Called_Operation
    (Self : not null access OCL_Message_Exp;
     To   : AMF.UML.Call_Operation_Actions.UML_Call_Operation_Action_Access) is abstract;
   --  Setter of MessageExp::calledOperation.
   --

   not overriding function Get_Sent_Signal
    (Self : not null access constant OCL_Message_Exp)
       return AMF.UML.Send_Signal_Actions.UML_Send_Signal_Action_Access is abstract;
   --  Getter of MessageExp::sentSignal.
   --

   not overriding procedure Set_Sent_Signal
    (Self : not null access OCL_Message_Exp;
     To   : AMF.UML.Send_Signal_Actions.UML_Send_Signal_Action_Access) is abstract;
   --  Setter of MessageExp::sentSignal.
   --

end AMF.OCL.Message_Exps;
