------------------------------------------------------------------------------
--                                                                          --
--                            Matreshka Project                             --
--                                                                          --
--        Localization, Internationalization, Globalization for Ada         --
--                                                                          --
--                        Runtime Library Component                         --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2010-2013, Vadim Godunko <vgodunko@gmail.com>                --
-- All rights reserved.                                                     --
--                                                                          --
-- Redistribution and use in source and binary forms, with or without       --
-- modification, are permitted provided that the following conditions       --
-- are met:                                                                 --
--                                                                          --
--  * Redistributions of source code must retain the above copyright        --
--    notice, this list of conditions and the following disclaimer.         --
--                                                                          --
--  * Redistributions in binary form must reproduce the above copyright     --
--    notice, this list of conditions and the following disclaimer in the   --
--    documentation and/or other materials provided with the distribution.  --
--                                                                          --
--  * Neither the name of the Vadim Godunko, IE nor the names of its        --
--    contributors may be used to endorse or promote products derived from  --
--    this software without specific prior written permission.              --
--                                                                          --
-- THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS      --
-- "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT        --
-- LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR    --
-- A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT     --
-- HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,   --
-- SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED --
-- TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR   --
-- PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF   --
-- LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING     --
-- NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS       --
-- SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.             --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 4369 $ $Date: 2013-12-21 10:11:53 +0100 (Sat, 21 Dec 2013) $
------------------------------------------------------------------------------
pragma Style_Checks ("-t");
--  GNAT: Disable check for token separation rules, because format of the
--  tables is not compatible with them.
with Matreshka.Internals.Unicode;

private package Matreshka.Internals.Regexps.Compiler.Scanner.Tables is

   pragma Preelaborate;

   subtype YY_Secondary_Index is
     Matreshka.Internals.Unicode.Code_Point range 0 .. 16#FF#;
   subtype YY_Primary_Index is
     Matreshka.Internals.Unicode.Code_Point range 0 .. 16#10FF#;
   type YY_Secondary_Array is
     array (YY_Secondary_Index) of Integer;
   type YY_Secondary_Array_Access is
     not null access constant YY_Secondary_Array;

   YY_End_Of_Buffer  : constant := 155;
   YY_Jam_State      : constant := 1268;
   YY_First_Template : constant := 1269;

   INITIAL                        : constant := 0;
   LITERAL                        : constant := 1;
   CHARACTER_CLASS                : constant := 2;
   MULTIPLICITY                   : constant := 3;
   COMMENT                        : constant := 4;
   PROPERTY_SPECIFICATION_UNICODE : constant := 5;
   PROPERTY_SPECIFICATION_POSIX   : constant := 6;

   YY_Accept : constant array (0 .. 1268) of Integer :=
    (    0,    0,    0,    0,    0,    0,    0,    0,
         0,    0,    0,    0,    0,    0,    0,  155,
       151,  150,  152,   12,   13,   14,   19,   21,
         1,   17,   22,  152,   11,   27,   15,    4,
         4,   25,  152,  152,   23,   24,   32,   30,
        31,   28,    9,    8,  154,  148,  154,  154,
       110,  154,  154,  154,  154,  154,  154,  154,
       116,  154,  127,  154,  131,  154,  154,  139,
       154,  154,  154,  154,  154,  144,  139,  154,
        49,  148,  150,    0,   18,   20,   16,   46,
        34,    0,    2,    0,   38,    0,   39,   40,
        35,    0,   36,   37,    0,   41,    3,   31,
        29,    0,    0,    0,    0,    0,  111,   63,
       112,    0,   56,    0,  113,  114,  115,    0,
         0,    0,    0,   67,    0,    0,    0,    0,
         0,    0,    0,    0,    0,    0,    0,  117,
         0,    0,  118,  119,  120,  121,  122,    0,
       124,  125,  126,    0,    0,  128,  129,  130,
         0,    0,    0,    0,    0,    0,    0,    0,
         0,    0,    0,  132,  133,  134,  135,  136,
       137,    0,  138,    0,    0,    0,    0,  140,
        97,    0,  141,  142,  143,    0,    0,    0,
         0,    0,    0,    0,    0,    0,    0,  102,
         0,    0,    0,    0,  145,  146,  147,   50,
         7,    6,   48,   47,    0,   42,   45,    0,
         0,    0,    0,    0,    0,    0,    0,    0,
         0,    0,    0,    0,    0,   59,   61,   62,
         0,    0,    0,   66,   68,    0,    0,    0,
        69,    0,    0,    0,    0,    0,    0,    0,
         0,    0,   73,    0,    0,    0,   75,    0,
        77,    0,    0,    0,    0,   81,    0,    0,
         0,    0,    0,    0,    0,    0,    0,   86,
         0,    0,    0,    0,    0,    0,    0,    0,
         0,    0,    0,    0,    0,    0,    0,    0,
         0,    0,    0,    0,    0,    0,    0,    0,
         0,    0,    0,    0,    0,    0,    0,    0,
         0,    0,    0,   51,    0,    0,    0,    0,
         0,    0,    0,    0,    0,    0,    0,   57,
        58,    0,   65,    0,    0,    0,    0,    0,
         0,    0,    0,    0,    0,    0,    0,    0,
         0,    0,    0,    0,    0,    0,    0,    0,
         0,   76,    0,    0,   78,   79,    0,    0,
         0,    0,    0,    0,  123,   83,    0,    0,
         0,    0,    0,    0,    0,    0,    0,   88,
        89,    0,    0,    0,    0,    0,    0,    0,
         0,    0,    0,    0,    0,    0,    0,    0,
         0,    0,    0,    0,    0,    0,    0,   99,
         0,    0,    0,    0,    0,    0,    0,    0,
         0,    0,  104,  105,    0,    0,    0,   52,
         0,    0,    0,   53,   54,    0,    0,    0,
        55,    0,    0,    0,    0,    0,    0,    0,
         0,    0,    0,   60,    0,    0,    0,    0,
         0,    0,    0,    0,    0,    0,    0,    0,
         0,    0,    0,    0,    0,   71,    0,    0,
         0,    0,    0,    0,    0,    0,    0,    0,
         0,    0,    0,    0,   80,    0,    0,    0,
         0,    0,    0,   82,    0,    0,    0,    0,
        84,    0,    0,    0,    0,    0,    0,   91,
         0,    0,    0,  110,    0,    0,    0,    0,
        94,    0,  131,   95,    0,    0,    0,    0,
         0,    0,  103,    0,   98,    0,    0,    0,
         0,  100,    0,    0,  101,    0,    0,    0,
         0,    0,    0,    0,  106,  107,    0,    0,
        43,    0,    0,    0,    0,    0,    0,    0,
         0,    0,    0,    0,    0,    0,    0,    0,
         0,   64,    0,    0,    0,    0,    0,    0,
         0,    0,    0,    0,    0,    0,    0,    0,
         0,    0,    0,   70,   72,    0,   74,    0,
         0,    0,    0,    0,    0,    0,    0,  116,
         0,    0,    0,    0,    0,    0,    0,  127,
        85,   87,   90,    0,    0,    0,    0,    0,
         0,    0,    0,    0,    0,    0,    0,    0,
        92,    0,   93,    0,    0,    0,    0,    0,
         0,    0,    0,    0,    0,    0,    0,  139,
         0,    0,    0,    0,    0,    0,    0,    0,
         0,  103,    0,    0,  108,  109,    0,    0,
         0,    0,    0,    0,    0,    0,    0,    0,
         0,    0,    0,    0,    0,    0,    0,    0,
         0,    0,    0,    0,    0,    0,    0,    0,
         0,   77,    0,    0,    0,    0,    0,    0,
         0,    0,    0,    0,    0,    0,    0,    0,
         0,    0,    0,    0,    0,    0,    0,    0,
         0,    0,    0,    0,    0,    0,    0,    0,
        96,    0,    0,    0,    0,    0,    0,    0,
         0,    0,    0,    0,    0,    0,    0,    0,
         0,    0,    0,    0,    0,    0,    0,    0,
         0,    0,    0,    0,    0,    0,    0,    0,
         0,    0,    0,    0,    0,    0,    0,    0,
         0,    0,   69,    0,    0,    0,   73,    0,
         0,    0,    0,    0,    0,    0,    0,    0,
         0,    0,    0,    0,    0,    0,    0,    0,
         0,    0,    0,    0,    0,    0,    0,    0,
         0,    0,    0,    0,    0,    0,    0,    0,
         0,    0,    0,    0,    0,    0,    0,    0,
         0,    0,    0,    0,    0,    0,    0,    0,
         0,    0,    0,    0,    0,    0,    0,    0,
         0,    0,    0,  105,    0,    0,    0,    0,
         0,    0,    0,    0,    0,    0,    0,    0,
         0,    0,    0,    0,    0,    0,    0,    0,
        68,    0,    0,    0,    0,    0,    0,    0,
         0,    0,    0,    0,    0,    0,    0,    0,
         0,    0,    0,   82,    0,    0,    0,    0,
         0,    0,    0,    0,    0,    0,    0,    0,
         0,    0,    0,    0,    0,    0,    0,    0,
         0,    0,    0,    0,    0,  144,    0,    0,
         0,    0,    0,    0,    0,    0,    0,  101,
         0,    0,    0,   44,   52,    0,    0,    0,
         0,    0,    0,    0,    0,    0,    0,    0,
         0,    0,    0,    0,   66,    0,    0,    0,
         0,    0,    0,    0,    0,    0,    0,    0,
        75,    0,    0,    0,    0,    0,    0,    0,
         0,    0,    0,    0,    0,    0,    0,    0,
         0,    0,    0,    0,    0,    0,    0,    0,
         0,    0,    0,    0,    0,    0,    0,    0,
         0,    0,    0,  114,    0,    0,    0,    0,
         0,    0,    0,    0,    0,    0,  113,    0,
         0,    0,    0,    0,    0,    0,    0,    0,
        53,    0,    0,    0,    0,    0,    0,    0,
         0,    0,    0,    0,    0,    0,    0,    0,
         0,    0,   76,    0,    0,    0,    0,    0,
        80,    0,    0,    0,    0,    0,    0,    0,
         0,    0,    0,    0,    0,    0,    0,    0,
         0,  120,    0,  130,    0,  143,    0,    0,
         0,    0,  131,    0,    0,    0,    0,    0,
         0,    0,  104,    0,   54,    0,    0,    0,
         0,    0,    0,    0,    0,    0,    0,    0,
         0,    0,    0,    0,    0,    0,    0,    0,
         0,    0,    0,    0,    0,    0,    0,    0,
         0,    0,    0,    0,    0,    0,    0,    0,
         0,    0,    0,    0,    0,    0,    0,    0,
         0,    0,    0,    0,    0,    0,    0,    0,
         0,    0,    0,    0,    0,    0,    0,    0,
         0,    0,    0,    0,    0,    0,    0,    0,
         0,    0,    0,    0,    0,    0,    0,    0,
         0,    0,    0,    0,    0,    0,    0,    0,
         0,    0,    0,    0,    0,    0,    0,    0,
         0,    0,    0,    0,    0,    0,    0,    0,
         0,    0,    0,    0,    0,    0,    0,    0,
         0,    0,    0,    0,    0,    0,    0,    0,
         0,    0,    0,    0,    0,    0,    0,    0,
         0,    0,    0,    0,    0,    0,    0,    0,
         0,    0,    0,    0,    0,    0,    0,    0,
         0,    0,    0,    0,    0,    0,    0,    0,
         0,    0,    0,    0,    0,    0,    0,    0,
         0,    0,    0,    0,    0,    0,    0,  134,
         0,    0,    0,    0,    0,    0,    0,    0,
         0,    0,    0,    0,    0,    0,    0,    0,
         0,    0,    0,    0,    0,    0,    0,    0,
         0,    0,    0,    0,    0,   78,    0,    0,
         0,    0,    0,    0,    0,    0,    0,    0,
         0,    0,    0,    0,    0,    0,    0,    0,
         0,    0,   79,    0,    0,    0,    0,    0,
         0,    0,    0,    0,    0,    0,    0,    0,
         0,    0,    0,    0,    0,   99,    0,    0,
         0,    0,    0,    0,    0,    0,    0,    0,
         0,    0,    0,    0,    0,    0,    0,    0,
         0,    0,    0,    0,    0,    0,    0,    0,
         0,    0,    0,    0,   67,    0,    0,    0,
         0,    0,    0,    0,    0);

   YY_Meta : constant array (0 .. 77) of Integer :=
    (    0,    1,    2,    2,    2,    2,    2,    2,
         2,    2,    2,    2,    2,    2,    3,    2,
         2,    4,    4,    4,    4,    4,    4,    5,
         5,    5,    5,    5,    5,    5,    5,    5,
         6,    6,    5,    5,    5,    6,    5,    5,
         5,    5,    5,    2,    2,    2,    2,    1,
         7,    3,    7,    3,    7,    7,    1,    1,
         1,    1,    1,    1,    1,    2,    1,    2,
         1,    2,    1,    2,    2,    2,    1,    1,
         1,    1,    2,    2,    2,    3);

   YY_Base : constant array (0 .. 1286) of Integer :=
    (    0,    0,   75,  350,  348,  146,  216,   16,
        18,  373,  369,  291,    0,   13,   19,  376,
      3358,   20, 3358, 3358,  359, 3358,  357,  355,
      3358,  273,  248,  337, 3358, 3358, 3358, 3358,
       210, 3358,  215,  375, 3358, 3358, 3358, 3358,
       192,  177, 3358, 3358, 3358, 3358,    7,    0,
       428,   16,   63,   71,    2,   76,   79,    7,
       480,  146,  150,  532,  584,   69,    0,  634,
        79,   80,  109,  144,   76,  205,    4,    0,
      3358,  116,   47,   42, 3358, 3358, 3358,   77,
      3358,   48, 3358,    0, 3358,    0, 3358, 3358,
      3358,   39, 3358, 3358,    0, 3358, 3358,    0,
      3358,   19,   79,   95,   95,   81, 3358, 3358,
      3358,  147, 3358,  135,  135,  143, 3358,  140,
       208,  145,  219,  165,  164,  207,  154,  151,
       158,  610,  194,  210,  427,  221,  222, 3358,
       212,  219, 3358, 3358,  412, 3358, 3358,  216,
      3358, 3358, 3358,  233,  230, 3358, 3358,  225,
       227,  229,  347,  344,  359,  349,  365,  362,
       360,  354,  357, 3358, 3358, 3358, 3358, 3358,
      3358,  363, 3358,  365,  384,  406,  421, 3358,
      3358,  422, 3358, 3358,  433,  440,  439,  427,
       440,  437,  437,  455,  478,  465,  473, 3358,
       485,  480,  493,  516, 3358, 3358, 3358, 3358,
      3358, 3358, 3358, 3358,    0, 3358, 3358,    0,
       474,  496,  497,  498,  504,  497,  496,  501,
       518,  529,  533,  588,  552, 3358, 3358, 3358,
       552,  560,  572,  559,  575,  583,  583,  597,
       608,  616,  614,  619,  670,  619,  639,  628,
       651,  662,  706,  655,  701,  681,  650,  662,
       725,  677,  685,  681,  702, 3358,  700,  711,
       706,  710,  710,  721,  720,  722,  710, 3358,
       747,  740,  706,  716,  728,  739,  730,  760,
       776,  744,  766,  753,  752,  770,  779,  761,
       779,  766,  767,  784,  774,  776,  784,  772,
       787,  789,  789,  781,  803,  847,  822,  800,
       800,    0,    0, 3358,  820,  814,  852,  860,
       821,  826,  828,  874,  836,  824,  839, 3358,
      3358,  843,  898,  838,  836,  863,  852,  856,
       862,  873,  876,  880,  892,  916,  896,  887,
       889,  897,  929,  909,  908,  917,  910,  906,
       913,  921,  952,  929,  921,  933,  923,  980,
       938,  982,  943,  937, 3358, 1002,  954,  953,
       965,  959,  974,  973, 1010,  963,  987, 3358,
      3358,  988,  986, 1013,  977, 1000, 1000, 1030,
       983, 1014, 1001, 1008, 1027, 1010, 1023, 1034,
      1034, 1022, 1068, 1038, 1029, 1030, 1033, 1047,
      1052, 1048, 1048, 1060, 1052, 1074, 1072, 1078,
      1099, 1086, 1067, 1063, 1093,    0,    0, 1088,
      1123, 1129, 1104, 1076, 1083, 1121, 1143, 1086,
      1154, 1118, 1132, 1171, 1159, 1115, 1124, 1139,
      1144, 1136, 1139, 3358, 1173, 1145, 1148, 1171,
      1164, 1174, 1170, 1161, 1177, 1182, 1218, 1168,
      1212, 1187, 1176, 1188, 1189, 3358, 1185, 1194,
      1192, 1208, 1193, 1198, 1214, 1208, 1214, 1211,
      1221, 1230, 1249, 1230, 1223, 1236, 1223, 1256,
      1226, 1243, 1249, 1248, 1269, 1234, 1233, 1254,
      3358, 1265, 1266, 1250, 1270, 1253, 1256, 3358,
      1291, 1264, 1264, 1353, 1268, 1269, 1276, 1273,
      3358, 1272, 1272, 3358, 1275, 1295, 1299, 1326,
      1297, 1288, 1349, 1296, 3358, 1308, 1308, 1311,
      1325, 3358, 1324, 1337, 1341, 1327, 1390, 1343,
      1335, 1332, 1344, 1362, 3358, 3358, 1367,    0,
      3358, 1377, 1420, 1379, 1387, 1380, 1395, 1394,
      1392, 1425, 1402, 1410, 1402, 1398, 1433, 1406,
      1403, 3358, 1416, 1407, 1417, 1427, 1417, 1420,
      1413, 1433, 1416, 1429, 1423, 1438, 1465, 1428,
      1433, 1444, 1453, 3358, 3358, 1461, 3358, 1462,
      1471, 1475, 1457, 1464, 1467, 1467, 1469, 1503,
      1468, 1475, 1490, 1479, 1488, 1476, 1492, 3358,
      3358, 3358, 3358, 1482,   14, 1533, 1488, 1499,
      1487, 1502, 1506, 1515, 1507, 1509, 1507, 1522,
      3358, 1538, 3358, 1526, 1536, 1542, 1535, 1533,
      1526, 1529, 1564, 1534, 1549, 1548, 1555, 3358,
      1556, 1557, 1553, 1558, 1564, 1557, 1581, 1554,
      1562, 3358, 1559, 1563, 3358, 3358,    0, 1562,
      1566, 1572, 1576, 1575, 1583, 1615, 1585, 1583,
      1590, 1581, 1605, 1631, 1646, 1596, 1610, 1606,
      1657, 1610, 1621, 1624, 1643, 1629, 1638, 1638,
      1638, 3358, 1657, 1674, 1643, 1678, 1653, 1647,
      1672, 1695, 1656, 1676, 1666, 1692, 1687, 1694,
      1684, 1695, 1701, 1726, 1687, 1685, 1691, 1703,
      1703, 1705, 1703, 1704, 1748, 1766, 1705, 1715,
      3358, 1722, 1723, 1730, 1768, 1738, 1747, 1744,
      1751, 1786, 1750, 1755, 1774, 1769, 1760,    0,
      1774, 1799, 1766, 1773, 1771, 1774, 1818, 1770,
      1799, 1805, 1804, 1798, 1846, 1800, 1841, 1807,
      1804, 1849, 1820, 1824, 1832, 1837, 1836, 1863,
      1830, 1834, 3358, 1850, 1839, 1895, 3358, 1836,
      1851, 1836, 1845, 1883, 1848, 1846, 1855, 1862,
      1862, 1926, 1868, 1869, 1888, 1886, 1933, 1899,
      1889, 1885, 1900, 1914, 1900, 1956, 1902, 1902,
      1932, 1903, 1920, 1919, 1935, 1937, 1947, 1945,
      1947, 1974, 1944, 1932, 1957, 1983, 1953, 1958,
      1969, 1965, 1966, 1980, 1986, 2013, 1976, 1990,
      1987, 2015, 1998, 2002, 2027, 2003, 2013, 2014,
      2007, 2022, 2013, 3358,    0, 2026, 2055, 2021,
      2028, 2018, 2019, 2034, 2039, 2039, 2025, 2032,
      2086, 2068, 2030, 2028, 2044, 2053, 2055, 2070,
      3358, 2099, 2105, 2057, 2060, 2102, 2101, 2092,
      2070, 2089, 2096, 2100, 2134, 2086, 2101, 2101,
      2120, 2122, 2122, 2165, 2115, 2169, 2129, 2123,
      2106, 2119, 2153, 2142, 2163, 2145, 2159, 2154,
      2168, 2166, 2155, 2169, 2155, 2161, 2160, 2196,
      2171, 2177, 2182, 2174, 2227, 3358, 2186, 2175,
      2183, 2239, 2187, 2189, 2242, 2207, 2217, 2249,
      2263, 2226, 2212, 3358, 3358, 2230, 2227, 2238,
      2226, 2245, 2234, 2231, 2242, 2279, 2241, 2239,
      2254, 2268, 2270, 2261, 3358, 2303, 2264, 2280,
      2310, 2278, 2285, 2280, 2293, 2285, 2285, 2292,
      3358, 2306, 2324, 2298, 2302, 2334, 2316, 2310,
      2318, 2305, 2322, 2355, 2316, 2324, 2311, 2325,
      2338, 2365, 2343, 2344, 2345, 2358, 2344, 2348,
      2350, 2368, 2354, 2352, 2364, 2376, 2395, 2365,
      2380, 2366, 2367, 3358, 2375, 2406, 2377, 2390,
      2399, 2390, 2391, 2425, 2396, 2408, 3358, 2408,
      2439, 2412, 2422, 2442, 2414, 2429, 2430, 2429,
      3358, 2436, 2429, 2507, 2441, 2493, 2429, 2444,
      2427, 2447, 2435, 2438, 2497, 2456, 2439, 2455,
      2470, 2465, 3358, 2476, 2499, 2479, 2484, 2482,
      3358, 2486, 2490, 2491, 2491, 2493, 2513, 2498,
      2510, 2504, 2517, 2500, 2517, 2505, 2521, 2528,
      2523, 3358, 2554, 3358, 2556, 3358, 2559, 2545,
      2561, 2558, 3358, 2546, 2546, 2564, 2549, 2563,
      2551, 2560, 3358, 2553, 3358, 2570,  113, 2593,
      2576, 2563, 2573, 2571, 2565, 2564, 2630, 2582,
      2565, 2587, 2584, 2610, 2604, 2622, 2613, 2622,
      2608, 2620, 2617, 2614, 2628, 2613, 2619, 2653,
      2621, 2637, 2628, 2683, 2628, 2638, 2629, 2689,
      2646, 2638, 2642, 2651, 2662, 2684, 2663, 2704,
      2677, 2678, 2674, 2675, 2678, 2677, 2694, 2681,
      2678, 2692, 2685, 2690, 2698, 2705, 2689, 2698,
      2696, 2711, 2706, 2706, 2718, 2732, 2725, 2744,
      2761, 2725, 2745, 2746, 2737, 2744, 2772, 2754,
      2745, 2750, 2747, 2754, 2781, 2758, 2760, 2784,
      2751, 2768, 2768, 2773, 2761, 2797, 2779, 2779,
      2781, 2780, 2797, 2804, 2802, 2808, 2807, 2808,
      2811, 2805, 2813, 2804, 2810, 2802, 2810, 2813,
      2812, 2814, 2811, 2833, 2815, 2834, 2821, 2836,
      2827, 2843, 2837, 2874, 2828, 2852, 2858, 2849,
      2866, 2868, 2872, 2856, 2859, 2858, 2858, 2874,
      2863, 2905, 2879, 2867, 2872, 2868, 2889, 2888,
      2882, 2927, 2882, 2879, 2893, 2898, 2914, 2907,
      2903, 2911, 2906, 2926, 2911, 2927, 2922, 2923,
      2939, 2938, 2956, 2941, 2944, 2943, 2944, 3358,
      2929, 2929, 2978, 2965, 2931, 2956, 2949, 2958,
      2959, 2966, 2998, 2969, 2983, 2974, 2986, 2984,
      2976, 2983, 2980, 2996, 2980, 2999, 3001, 2994,
      2997, 3029, 2992, 3005, 3007, 3358, 2993, 3003,
      3001, 3049, 3008, 3024, 3042, 3030, 3028, 3032,
      3045, 3034, 3032, 3048, 3036, 3037, 3042, 3043,
      3055, 3048, 3358, 3052, 3053, 3062, 3062, 3053,
      3063, 3064, 3065, 3066, 3068, 3071, 3065, 3069,
      3080, 3073, 3087, 3091, 3094, 3358, 3104, 3105,
      3107, 3097, 3109, 3111, 3131, 3100, 3106, 3101,
      3117, 3111, 3140, 3109, 3112, 3120, 3145, 3126,
      3125, 3120, 3171, 3123, 3138, 3144, 3149, 3150,
      3163, 3164, 3150, 3166, 3358, 3195, 3197, 3158,
      3159, 3168, 3171, 3166, 3358, 3260, 3267, 3274,
      3281, 3287, 3292, 3296, 3300, 3305, 3310, 3315,
      3320, 3325, 3330, 3335, 3340, 3345, 3350);

   YY_Def : constant array (0 .. 1286) of Integer :=
    (    0, 1269, 1269, 1270, 1270,    2,    2, 1271,
      1271, 1272, 1272, 1268,   11,   11,   11, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1273, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1273, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268,   63, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1274, 1268, 1275, 1268, 1268,
      1268, 1268, 1268, 1268, 1276, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1277, 1268, 1268, 1278,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1279, 1280, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1281, 1282, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1283,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268,  467,  467, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1284, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1285,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1286, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268,  939, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268,    0, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268);

   YY_Nxt : constant array (0 .. 3435) of Integer :=
    (    0, 1268,   17,   17,   18,   18,   19,   20,
        21,   22,   23,   18,   18,   24,   95,   18,
        25,  166,   17,   17,   17,   17,   74,   74,
       184,  100, 1268,   39,   73,   39,   40,   97,
        40,  113,   73,   98,  121,  114,  126,  185,
       200,  115,   99,   26,   27,   18,   28,  192,
       166,   74,   74, 1268, 1268, 1268, 1268,  184,
       100,  193, 1268, 1268, 1268, 1268,   97, 1268,
       113, 1268,   98,  121,  114,  126,  185,  200,
       115,   99,   29,   30,   18,   17,   17,   18,
        18,   19,   20,   21,   22,   23,   18,   18,
        24,   45,   18,   25,   41,  116,   41,   45,
       118,  122,  164,  124,  177,  186,  119,  117,
       178,  179,  165,  187,  120,  125,  180,  201,
       181,  198,  202,  203,  204,  123,   26,   27,
        18,   28,  195,  194,  116, 1268,  182,  118,
       122,  164,  124,  177,  186,  119,  117,  178,
       179,  165,  187,  120,  125,  180,  201,  181,
       183,  202,  203,  204,  123,   29,   30,   18,
        18,   18,   18,   18,   18,  182,   33,   18,
      1268,  191,   18,  135,  205,  136,  206,  137,
       184,  140,  141,  207,  208,  209,  210,  183,
       138,  139,  142,  185,  216,  143,  220,  222,
       225,  226,  227,  144,  221,   34,   35,   36,
        37,   96,  135,  205,  136,  206,  137,  184,
       140,  141,  207,  208,  209,  210,   95,  138,
       139,  142,  185,  216,  143,  220,  222,  225,
       226,  227,  144,  221,   18,   18,   18,   18,
        18,   18,   18,  211,   33,   18,   79,   94,
        18,  188,  234,  212,  213,  189,  217,  223,
       190,  218,  235,  224,  214,  215,  241,  242,
       243,  244,  248,  219,  249,  250,  251,  252,
       253,  254,  211,   34,   35,   36,   37,   79,
       188,  234,  212,  213,  189,  217,  223,  190,
       218,  235,  224,  214,  215,  241,  242,  243,
       244,  248,  219,  249,  250,  251,  252,  253,
       254,   78,   18,   18,   44,   17,   17,   45,
        45,   45,   45,   45,   45,   45,   45,   45,
        45,   44,   45,   45,   46,   47,   48,   49,
        50,   51,   52,   53,   54,   55,   44,   56,
        57,   58,   59,   60,   61,   62,   63,   64,
        65,   66,   67,   68,   44,   69,   45,   45,
        45,   45,   44,   46,   47,   48,   49,   50,
        51,   52,   53,   54,   55,   44,   56,   57,
        58,   59,   60,   61,   62,   70,   64,   65,
        66,   71,   68,   44,   69,   45,   45,   72,
        44,   81,   82,   77,  255,   76,   83,   75,
      1268,   43,  256,  257,  258,   43,  259,  260,
       261,   84,  262,   85,  265,   86,   87,  263,
        32,  264,   32,  266, 1268, 1268,   88, 1268,
        89,  267,   90,  255,   91,   92,   93,   81,
      1268,  256,  257,  258,   83,  259,  260,  261,
      1268,  262, 1268,  265, 1268, 1268,  263,   84,
       264,   85,  266,   86,   87,  236,  236, 1268,
       267,  245, 1268,  246,   88,  268,   89,  237,
        90,  269,   91,   92,   93,  101,  238,  102,
       239,  103,  104,  247,  105,  106,  270,  271,
       107,  272,  108,  109,  273,  274,  240,  110,
       245,  111,  246,  112,  268,  275, 1268,  276,
       269,  277,  237,  278,  101,  238,  102,  239,
       103,  104,  247,  105,  106,  270,  271,  107,
       272,  108,  109,  273,  274,  240,  110,  279,
       111,  281,  112,  127,  275,  128,  276,  280,
       277,  129,  278,  282,  130,  131,  283,  132,
       284,  285,  291, 1268,  133,  134,  286,  286,
       292, 1268,  293,  294, 1268,  295,  279,  296,
       281, 1268,  127,  297,  128, 1268,  280,  298,
       129, 1268,  282,  130,  131,  283,  132,  284,
       285,  291,  287,  133,  134,  145,  299,  292,
       146,  293,  294,  147,  295,  148,  296,  300,
       149,  150,  297,  288,  151,  301,  298,  302,
       152,  153, 1268,  305, 1268, 1268, 1268, 1268,
       306,  287, 1268, 1268,  145,  299, 1268,  146,
      1268,  307,  147, 1268,  148,  308,  300,  149,
       150,  309,  310,  151,  301, 1268,  302,  152,
       153,  154,  305,  155,  156,  157,  158,  306,
       311,  159,  303,  312,  228,  228,  313,  160,
       307,  304,  161,  162,  308,  163, 1268, 1268,
       309,  310, 1268,  229,  230,  314, 1268,  231,
       154,  315,  155,  156,  157,  158,  232,  311,
       159,  303,  312,  316, 1268,  313,  160,  317,
       304,  161,  162,  318,  163,  167,  168,  169,
       319,  233,  229,  230,  314,  170,  231,  171,
       315,  172,  173, 1268,  320,  232,  174,  175,
       228,  228,  316,  176,  321, 1268,  317,  325,
       230,  328,  318,  231,  167,  168,  169,  319,
       230, 1268,  232,  231,  170,  329,  171, 1268,
       172,  173,  232,  320,  326,  174,  175,  236,
       236, 1268,  176,  321,  322,  322,  325,  230,
       328,  334,  231,  335,  327,  336,  323,  230,
       326,  232,  231,  337,  329,  338,  324,  330,
       330,  232, 1268,  326,  339,  340,  341,  342,
       327,  331,  343,  344,  346, 1268,  347,  332,
       334,  353,  335,  327,  336,  348,  348,  326,
       354,  323,  337,  345,  338,  324,  355,  351,
       356,  333,  357,  339,  340,  341,  342,  327,
       349,  343,  344,  346,  331,  347,  332,  352,
       353,  358,  359,  359, 1268, 1268,  364,  354,
      1268,  365,  345,  366,  367,  355,  351,  356,
       333,  357,  350,  368,  369,  370,  371,  349,
       372,  373,  374,  375,  376,  377,  352,  378,
       358,  379,  380,  360,  361,  364,  381,  362,
       365,  382,  366,  367,  383, 1268,  388,  363,
       286,  286,  368,  369,  370,  371,  287,  372,
       373,  374,  375,  376,  377,  391,  378,  392,
       379,  380,  360,  361,  402,  381,  362,  403,
       382,  384,  384,  383,  287,  388,  393,  393,
       102,  408,  409,  385,  410,  287,  398,  398,
       394,  411,  386,  415,  391, 1268,  392,  395,
       399,  416, 1268,  402,  404,  404,  403, 1268,
       400,  396,  387,  287,  417,  401,  418,  102,
       408,  409, 1268,  410,  141,  419,  385,  405,
       411,  386,  415,  397,  412,  412,  395,  420,
       416,  406,  421,  399,  422,  423,  413,  400,
       396,  387, 1268,  417,  401,  418,  424,  424,
       427,  407,  428,  141,  419,  429,  405,  430,
       425,  324,  414,  322,  322,  431,  420,  426,
       406,  421,  432,  422,  423,  328,  433,  434,
       435,  413,  438,  436,  441,  324,  439,  427,
      1268,  428,  330,  330,  429, 1268,  430,  446,
       324,  414,  450,  425,  431,  437,  426,  440,
      1268,  432,  436,  451,  328,  433,  434,  435,
       455,  438,  436,  441,  324,  439,  442,  442,
       447,  447, 1268,  456,  437,  457,  446,  458,
       443,  450,  448,  459,  437,  460,  440,  444,
      1268,  436,  451,  461,  452,  452, 1268,  455,
       349,  462,  463,  467,  348,  348,  453,  464,
       464,  449,  456,  437,  457,  468,  458,  469,
       470,  465,  459,  445,  460,  448,  444,  349,
       359,  359,  461,  471,  472,  454, 1268,  349,
       462,  463,  467,  360,  473,  466,  474,  362,
       449,  453,  475,  476,  468,  477,  469,  470,
       478, 1268,  484,  482,  465,  485,  349,  483,
       486,  360,  471,  472,  454,  362,  479,  479,
       487,  488,  360,  473,  466,  474,  362,  489,
       480,  475,  476,  490,  477,  491,  492,  478,
       481,  484,  482,  493,  485,  494,  483,  486,
       360,  495,  498,  499,  362,  384,  384,  487,
       488,  496,  505,  511,  512, 1268,  489,  401,
       500,  501,  490,  480,  491,  492,  496,  481,
       502,  497,  493,  509,  494,  506,  506, 1268,
       495,  498,  499,  393,  393,  510,  497,  507,
       496,  505,  511,  512,  395,  516,  401,  500,
       501,  398,  398,  508,  395,  496,  396,  502,
       497,  517,  509,  521,  513,  513,  396,  522,
       405,  404,  404,  523,  510,  497,  514,  524,
       401,  525,  507,  395,  516,  518,  518,  412,
       412,  414,  508,  395,  405,  396,  515,  519,
       517,  526,  521, 1268,  527,  396,  522,  405,
       528,  529,  523,  530,  531,  532,  524,  401,
       525,  514,  533,  520,  104,  414,  426,  537,
       414,  538,  539,  405,  540,  515,  424,  424,
       526,  541,  519,  527,  534,  534,  542,  528,
       529,  439,  530,  531,  532,  543,  535,  426,
       544,  533,  520,  104,  414,  426,  537,  438,
       538,  539,  440,  540,  545,  546,  547,  548,
       541,  549,  536,  442,  442,  542,  550,  444,
       439,  551,  447,  447,  543,  449,  426,  544,
       552,  535,  553,  554,  444,  454,  438,  452,
       452,  440,  555,  545,  546,  547,  548,  556,
       549,  536,  557,  558,  559,  550,  444,  560,
       551,  561,  562,  449,  449,  464,  464,  552,
       466,  553,  554,  444,  454,  563,  576,  577,
       454,  555,  578,  579,  580,  581,  556,  582,
       583,  557,  558,  559,  584,  481,  560,  585,
       561,  562,  449,  466, 1268, 1268,  589,  466,
       479,  479, 1268,  590,  563,  576,  577,  454,
       591,  578,  579,  580,  581,  592,  582,  583,
       593, 1268,  481,  584,  481,  594,  585,  586,
       586, 1268,  466,  564,  564,  589,  595, 1268,
       596,  587,  590,  597,  601,  565,  498,  591,
       499, 1268,  566, 1268,  592,  567,  602,  593,
       568,  481,  569,  603,  594,  570,  571,  572,
       588,  573,  604,  605,  574,  595,  575,  596,
       598,  598,  597,  601,  587,  498,  607,  499,
       565,  566,  599,  508,  567,  602, 1268,  568,
       608,  569,  603,  511,  570,  571,  572,  588,
       573,  604,  605,  574,  512,  575,  506,  506,
       609,  600,  610,  513,  513,  607,  515,  611,
       612,  613,  508,  518,  518,  599,  520,  608,
       614,  615,  511,  616,  508,  102,  617,  618,
       619,  620,  621,  512,  622,  515,  623,  609,
       600,  610,  624,  625,  536,  515,  611,  612,
       613,  520, 1268,  534,  534,  520,  626,  614,
       615,  627,  616,  508,  102,  617,  618,  619,
       620,  621,  628,  622,  515,  623,  629,  630,
       631,  624,  625,  536,  632,  633,  634,  635,
       520,  536,  550,  636,  640,  626, 1268,  641,
       627,  637,  637,  642,  643,  644,  645,  646,
       647,  628, 1268,  638,  648,  629,  630,  631,
       649,  650,  651,  632,  633,  634,  635,  652,
       536,  550,  636,  640,  654,  639,  641, 1268,
      1268,  653,  642,  643,  644,  645,  646,  647,
       655, 1268,  656,  648,  657, 1268,  638,  649,
       650,  651,  658,  659,  660,  661,  652,  662,
       663,  664,  665,  654,  639,  666,  586,  586,
       653,  588,  667,  668,  669,  670,  671,  655,
       672,  656,  673,  657, 1268,  674,  675,  598,
       598,  658,  659,  660,  661,  600,  662,  663,
       664,  665,  676,  677,  666,  678,  680,  588,
       588,  667,  668,  669,  670,  671,  681,  672,
       682,  673,  683,  684,  674,  675,  685,  689,
       600,  686,  686,  690,  600,  691,  692, 1268,
       693,  676,  677,  687,  678,  680,  588, 1268,
       700,  694,  694,  701,  702,  681, 1268,  682,
      1268,  683,  684,  695,  706,  685,  689,  600,
       697,  697,  690,  707,  691,  692,  688,  693,
       708, 1268,  698,  703,  703,  696,  687,  700,
       709,  710,  701,  702,  711,  704,  712,  699,
       713, 1268,  714,  706,  715,  715,  695,  718,
       637,  637,  707,  639,  719,  688,  716,  708,
       705,  720, 1268,  724,  696,  698,  725,  709,
       710,  721,  721,  711,  726,  712,  699,  713,
       704,  714,  717,  722,  639,  727,  718, 1268,
       728,  729,  639,  719,  730,  731,  732,  705,
       720,  716,  724,  737,  738,  725,  723,  739,
       733,  733, 1268,  726,  740,  741,  742,  743,
       744,  717, 1268,  639,  727,  752,  722,  728,
       729,  734,  753,  730,  731,  732,  745,  745,
      1268,  754,  737,  738, 1268,  723,  739,  755,
       746,  735,  756,  740,  741,  742,  743,  744,
       749,  749,  757,  757,  752,  736,  760,  761,
       734,  753,  750,  762,  758,  763, 1268,  747,
       754,  767,  768,  748,  764,  764,  755,  769,
       735,  756,  770,  746,  771,  759,  765,  773,
       777,  774,  774,  751,  778,  760,  761,  779,
       780,  688,  762,  766,  763,  750,  747,  758,
       767,  768,  748,  775,  686,  686,  769,  781,
       782,  770, 1268,  771,  759,  783,  773,  777,
       784,  765,  751,  778,  788,  696,  779,  780,
       688,  789,  766,  694,  694,  699,  776,  790,
       785,  785,  775,  697,  697,  791,  781,  782,
       792,  688,  786,  793,  783,  705, 1268,  784,
       794,  703,  703,  788,  696,  795,  796,  696,
       789,  802,  699,  803,  699,  804,  790,  805,
       717,  787, 1268,  806,  791,  715,  715,  792,
       688,  807,  793,  808,  705,  786,  705,  794,
       809,  797,  797,  723,  795,  796,  696,  810,
       802,  699,  803,  798,  804,  811,  805,  717,
       787,  799,  806,  717,  800,  812,  817,  818,
       807,  819,  808,  801,  820,  705, 1268,  809,
       721,  721,  723,  821,  822,  823,  810,  813,
       813, 1268,  824,  825,  811,  826,  798,  463,
       799,  814,  717,  800,  812,  817,  818,  734,
       819,  827,  801,  820,  828,  723,  733,  733,
      1268,  815,  821,  822,  823,  829,  830,  735,
       816,  824,  825,  831,  826,  832,  463,  734,
       745,  745, 1268,  747,  814,  833,  734,  748,
       827,  749,  749,  828,  723, 1268,  751,  735,
       815,  834,  835,  836,  829,  830,  735,  816,
       837,  838,  831,  839,  832,  759,  734,  840,
       110,  747,  747, 1268,  833,  748,  748,  757,
       757,  841,  841,  844,  751,  751,  735,  845,
       834,  835,  836,  842,  766,  764,  764,  837,
       838,  846,  839,  847,  759,  848,  840,  110,
       747,  849,  759,  850,  748,  852,  853,  843,
       775,  854,  844,  751,  766,  855,  845,  856,
       857,  774,  774,  766,  858,  859,  842,  860,
       846,  787,  847, 1268,  848,  864,  785,  785,
       849,  759,  850,  775,  852,  853,  843,  775,
       854,  865,  866,  766,  855,  867,  856,  857,
       861,  861,  868,  858,  859,  875,  860,  876,
       787, 1268,  862, 1268,  864,  869,  869,  787,
       797,  797,  775,  872,  872,  877,  878,  870,
       865,  866,  879, 1268,  867,  880,  863,  799,
       799,  868,  800,  800,  875,  881,  876,  885,
       871,  801,  801,  886,  887,  862,  787,  873,
       882,  882,  888,  889,  877,  878,  890,  171,
       894,  879,  870,  895,  880,  863,  799,  799,
       874,  800,  800,  896,  881,  815,  885,  871,
       801,  801,  886,  887,  816,  883,  873,  891,
       891,  888,  889,  813,  813,  890,  171,  894,
       897,  892,  895,  898,  899,  884,  900,  901,
       902,  903,  896,  904,  815,  905,  906,  907,
       908,  893,  909,  816,  883,  815,  910,  910,
      1268,  913,  914,  915,  816,  916,  168,  897,
       911,  920,  898,  899,  892,  900,  901,  902,
       903,  921,  904,  843,  905,  906,  907,  908,
       893,  909,  922,  926,  815,  917,  917,  912,
       913,  914,  915,  816,  916,  168,  927,  918,
       920,  841,  841,  911,  923,  923, 1268,  601,
       921,  934,  843,  928,  928,  935,  924,  936,
       919,  922,  926,  937,  127,  929,  912,  938,
       939,  931,  931, 1268,  940,  927,  925,  843,
       941,  863,  918,  932,  942,  930,  601, 1268,
       934,  861,  861,  943,  935,  944,  936,  919,
       945,  924,  937,  127,  946,  871,  938,  939,
       929,  947,  933,  940,  948,  925,  843,  941,
       863,  869,  869,  942,  930, 1268,  932,  863,
       872,  872,  943,  873,  944,  949,  950,  945,
       951,  952,  953,  946,  871,  954,  882,  882,
       947,  933,  955,  948,  871,  883, 1268,  959,
       956,  956,  960,  961,  873,  962,  863,  963,
       893,  964,  873,  965,  949,  950, 1268,  951,
       952,  953,  966,  883,  954,  891,  891,  967,
       971,  955,  972,  871,  883,  957,  959,  968,
       968,  960,  961,  873,  962,  973,  963,  893,
       964,  969,  965,  974,  975,  958,  976,  893,
       977,  966,  883,  978,  979,  980,  967,  971,
       981,  972,  970,  982,  957,  910,  910, 1268,
       912,  983,  984,  985,  973,  986,  919,  987,
       917,  917,  974,  975,  969,  976,  893,  977,
       988,  136,  978,  979,  980,  989, 1268,  981,
       925,  970,  982,  923,  923,  990,  912,  912,
       983,  984,  985,  919,  986,  919,  987,  991,
       930,  928,  928,  992,  931,  931, 1268,  988,
       136,  933,  993,  994,  989,  925,  995,  925,
       996,  997, 1005, 1009,  990,  912, 1010, 1011,
      1268, 1268,  919,  930, 1012, 1013,  991,  930,
      1014, 1016,  992, 1017,  539,  933, 1268, 1268,
       933,  993,  994, 1268,  925,  995, 1268,  996,
       997, 1005, 1009, 1018,  540, 1010, 1011, 1006,
      1006, 1019,  930, 1012, 1013,  956,  956, 1014,
      1016, 1007, 1017,  539,  933,  998,  998, 1020,
       968,  968, 1008,  957,  500,  501, 1021,  999,
       142, 1022, 1018,  540, 1015, 1023, 1000, 1024,
      1019, 1025,  957, 1026, 1027,  970, 1028, 1001,
      1029, 1002, 1030,  970, 1007, 1031, 1020, 1003,
      1004, 1008,  957,  500,  501, 1021, 1032,  142,
      1022, 1033,  999, 1015, 1023, 1000, 1024,  352,
      1025,  957, 1026, 1027,  970, 1028, 1001, 1029,
      1002, 1030,  970, 1034, 1031, 1035, 1003, 1004,
      1036, 1037, 1038, 1039, 1040, 1032, 1041, 1042,
      1033, 1043, 1044, 1045, 1046,  291,  352,  106,
      1268, 1047, 1048, 1049, 1050, 1051, 1268, 1268,
      1052, 1268, 1034, 1008, 1035, 1053, 1054, 1036,
      1037, 1038, 1039, 1040, 1000, 1041, 1042, 1055,
      1043, 1044, 1045, 1046,  291, 1001,  106, 1002,
      1047, 1048, 1049, 1050, 1051, 1003, 1004, 1052,
      1006, 1006, 1008, 1056, 1053, 1054,  141, 1057,
       137,  604,  605, 1000, 1058, 1059, 1055, 1060,
      1061, 1062, 1063, 1008, 1001,  188, 1002, 1064,
      1064, 1067, 1068, 1069, 1003, 1004, 1073, 1074,
      1268, 1075, 1056, 1079, 1080,  141, 1057,  137,
       604,  605, 1065, 1058, 1059, 1081, 1060, 1061,
      1062, 1063, 1008, 1268,  188, 1070, 1070, 1082,
      1067, 1068, 1069, 1076, 1076, 1073, 1074, 1071,
      1075, 1083, 1079, 1080, 1066, 1084, 1072,  578,
       475, 1065, 1085, 1085, 1081, 1088, 1089, 1090,
      1091, 1092, 1077, 1093, 1094, 1095, 1082, 1096,
      1268, 1097, 1098, 1099, 1100, 1101,  167, 1102,
      1083, 1103, 1071, 1104, 1084, 1072,  578,  475,
      1078, 1105,  429, 1086, 1088, 1089, 1090, 1091,
      1092, 1077, 1093, 1094, 1095, 1106, 1096, 1087,
      1097, 1098, 1099, 1100, 1101,  167, 1102, 1107,
      1103, 1108, 1104, 1064, 1064, 1109, 1065, 1110,
      1105,  429, 1086,  131,  170, 1072, 1070, 1070,
      1111,  138, 1112, 1113, 1106, 1114, 1065, 1076,
      1076, 1077, 1115, 1115, 1118,  562, 1107, 1072,
      1108, 1119,  576, 1120, 1109, 1065, 1110, 1085,
      1085, 1268,  131,  170, 1072, 1116, 1077, 1111,
       138, 1112, 1113, 1121, 1114, 1065, 1086,  190,
      1077, 1122, 1123, 1118,  562, 1124, 1072, 1125,
      1119,  576, 1120, 1126, 1127, 1128, 1129, 1117,
      1086, 1130, 1131, 1132, 1116, 1077, 1133, 1134,
       156, 1135, 1121, 1136, 1137, 1086,  190, 1138,
      1122, 1123, 1139, 1140, 1124, 1141, 1125,  130,
      1142,  162, 1126, 1127, 1128, 1129,  560, 1086,
      1130, 1131, 1132, 1143, 1144, 1133, 1134,  156,
      1135, 1116, 1136, 1137, 1115, 1115, 1138,  351,
      1145, 1139, 1140, 1146, 1141, 1147,  130, 1142,
       162, 1148,  133, 1149,  134,  560, 1150, 1116,
      1151, 1153, 1143, 1144, 1157, 1158, 1159, 1152,
      1116, 1160, 1161, 1154, 1154, 1162,  351, 1145,
       158, 1166, 1146, 1167, 1147, 1155, 1168, 1169,
      1148,  133, 1149,  134, 1156, 1150, 1116, 1151,
      1153, 1163, 1163, 1157, 1158, 1159, 1152, 1170,
      1160, 1161, 1171, 1172, 1162,  160, 1173,  158,
      1166, 1174, 1167, 1175, 1164, 1168, 1169,  489,
      1155, 1176, 1177, 1156, 1178, 1179, 1154, 1154,
      1156, 1180, 1181, 1182, 1183, 1184, 1170, 1163,
      1163, 1171, 1172, 1188,  160, 1173, 1165, 1156,
      1174, 1164, 1175, 1164, 1185, 1185,  489, 1189,
      1176, 1177, 1164, 1178, 1179, 1190, 1191, 1156,
      1180, 1181, 1182, 1183, 1184, 1186, 1192, 1268,
      1193, 1193, 1188, 1196, 1197, 1198, 1156,  472,
      1164, 1199,  183, 1200, 1201, 1202, 1189, 1203,
      1204, 1164, 1205, 1206, 1190, 1191, 1207, 1208,
      1186, 1187, 1209, 1210, 1186, 1192, 1194, 1185,
      1185,  159, 1196, 1197, 1198, 1211,  472, 1212,
      1199,  183, 1200, 1201, 1202, 1195, 1203, 1204,
      1186, 1205, 1206, 1193, 1193, 1207, 1208, 1186,
      1194, 1209, 1210, 1213, 1214, 1194,  189, 1215,
       159, 1216, 1217, 1218, 1211, 1219, 1212, 1220,
      1221, 1222, 1223, 1224, 1225, 1226, 1227, 1186,
      1228, 1194,  561, 1229, 1230, 1231, 1232, 1194,
      1233, 1234, 1213, 1214, 1235,  189, 1215,  103,
      1216, 1217, 1218,  155, 1219, 1236, 1220, 1221,
      1222, 1223, 1224, 1225, 1226, 1227, 1237, 1228,
      1194,  561, 1229, 1230, 1231, 1232, 1238, 1233,
      1234, 1239, 1240, 1235,  303,  304,  103,  213,
      1241,  214,  155,  215, 1236, 1242, 1242, 1245,
       245,  456, 1246, 1247, 1248, 1237, 1242, 1242,
      1243, 1249, 1253, 1250, 1250, 1238, 1254, 1255,
      1239, 1240, 1256,  303,  304, 1251,  213, 1241,
       214, 1268,  215, 1243, 1251, 1257, 1245,  245,
       456, 1246, 1247, 1248, 1243, 1250, 1250, 1243,
      1249, 1253, 1244, 1258,  521, 1254, 1255, 1259,
       411, 1256, 1260, 1261, 1251, 1265, 1251, 1263,
      1252, 1266, 1243, 1251, 1257, 1262, 1262, 1262,
      1262, 1267,  255, 1243, 1268, 1268, 1268, 1268,
      1268, 1268, 1258,  521, 1268, 1268, 1259,  411,
      1268, 1260, 1261, 1268, 1265, 1251, 1263, 1268,
      1266, 1268, 1268, 1263, 1268, 1263, 1268, 1268,
      1267,  255, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1264, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1263, 1268, 1263,   16,   16,   16,
        16,   16,   16,   16,   31,   31,   31,   31,
        31,   31,   31,   38,   38,   38,   38,   38,
        38,   38,   42,   42,   42,   42,   42,   42,
        42,   80, 1268, 1268, 1268,   80,   80,  196,
       196, 1268, 1268,  196,  197,  197,  197,  199,
       199, 1268, 1268,  199,  289,  289, 1268, 1268,
       289,  290,  290, 1268, 1268,  290,  389,  389,
      1268, 1268,  389,  390,  390, 1268, 1268,  390,
       503,  503, 1268, 1268,  503,  504,  504, 1268,
      1268,  504,  606,  606, 1268, 1268,  606,  679,
       679, 1268, 1268,  679,  772,  772, 1268, 1268,
       772,  851,  851, 1268, 1268,  851,   15, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268);

   YY_Chk : constant array (0 .. 3435) of Integer :=
    (    0,    0,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,   95,    1,
         1,   62,    7,    7,    8,    8,   17,   17,
        71,   47,  564,    7,   13,    8,    7,   46,
         8,   49,   14,   46,   52,   49,   55,   70,
        97,   49,   46,    1,    1,    1,    1,   75,
        62,   74,   74,    0,    0,    0,    0,   71,
        47,   75,    0,    0,    0,  564,   46,    0,
        49,    0,   46,   52,   49,   55,   70,   97,
        49,   46,    1,    1,    1,    2,    2,    2,
         2,    2,    2,    2,    2,    2,    2,    2,
         2,   13,    2,    2,    7,   50,    8,   14,
        51,   53,   61,   54,   64,   68,   51,   50,
        64,   65,   61,   68,   51,   54,   65,   98,
        65,   89,   99,  100,  101,   53,    2,    2,
         2,    2,   81,   79,   50,  998,   66,   51,
        53,   61,   54,   64,   68,   51,   50,   64,
        65,   61,   68,   51,   54,   65,   98,   65,
        66,   99,  100,  101,   53,    2,    2,    2,
         5,    5,    5,    5,    5,   66,    5,    5,
       998,   73,    5,   57,  105,   57,  107,   57,
        67,   58,   58,  108,  109,  109,  111,   66,
        57,   57,   58,   67,  113,   58,  115,  116,
       118,  119,  120,   58,  115,    5,    5,    5,
         5,   41,   57,  105,   57,  107,   57,   67,
        58,   58,  108,  109,  109,  111,   40,   57,
        57,   58,   67,  113,   58,  115,  116,  118,
       119,  120,   58,  115,    5,    5,    6,    6,
         6,    6,    6,  112,    6,    6,   34,   32,
         6,   69,  122,  112,  112,   69,  114,  117,
        69,  114,  123,  117,  112,  112,  125,  126,
       128,  129,  135,  114,  135,  139,  140,  143,
       144,  145,  112,    6,    6,    6,    6,   26,
        69,  122,  112,  112,   69,  114,  117,   69,
       114,  123,  117,  112,  112,  125,  126,  128,
       129,  135,  114,  135,  139,  140,  143,  144,
       145,   25,    6,    6,   11,   11,   11,   11,
        11,   11,   11,   11,   11,   11,   11,   11,
        11,   11,   11,   11,   11,   11,   11,   11,
        11,   11,   11,   11,   11,   11,   11,   11,
        11,   11,   11,   11,   11,   11,   11,   11,
        11,   11,   11,   11,   11,   11,   11,   11,
        11,   11,   11,   11,   11,   11,   11,   11,
        11,   11,   11,   11,   11,   11,   11,   11,
        11,   11,   11,   11,   11,   11,   11,   11,
        11,   11,   11,   11,   11,   11,   11,   11,
        11,   27,   27,   23,  146,   22,   27,   20,
        15,   10,  147,  148,  149,    9,  150,  151,
       152,   27,  153,   27,  161,   27,   27,  154,
         4,  154,    3,  163,    0,    0,   27,    0,
        27,  164,   27,  146,   27,   27,   27,   35,
        35,  147,  148,  149,   35,  150,  151,  152,
         0,  153,    0,  161,    0,    0,  154,   35,
       154,   35,  163,   35,   35,  124,  124,    0,
       164,  132,    0,  132,   35,  165,   35,  124,
        35,  166,   35,   35,   35,   48,  124,   48,
       124,   48,   48,  132,   48,   48,  169,  172,
        48,  173,   48,   48,  174,  175,  124,   48,
       132,   48,  132,   48,  165,  176,    0,  177,
       166,  178,  124,  179,   48,  124,   48,  124,
        48,   48,  132,   48,   48,  169,  172,   48,
       173,   48,   48,  174,  175,  124,   48,  180,
        48,  181,   48,   56,  176,   56,  177,  180,
       178,   56,  179,  182,   56,   56,  184,   56,
       185,  186,  200,    0,   56,   56,  187,  187,
       201,    0,  202,  203,    0,  204,  180,  205,
       181,    0,   56,  206,   56,    0,  180,  207,
        56,    0,  182,   56,   56,  184,   56,  185,
       186,  200,  187,   56,   56,   59,  208,  201,
        59,  202,  203,   59,  204,   59,  205,  209,
        59,   59,  206,  187,   59,  209,  207,  210,
        59,   59,    0,  212,    0,    0,    0,    0,
       216,  187,    0,    0,   59,  208,    0,   59,
         0,  217,   59,    0,   59,  218,  209,   59,
        59,  219,  220,   59,  209,    0,  210,   59,
        59,   60,  212,   60,   60,   60,   60,  216,
       221,   60,  211,  222,  121,  121,  223,   60,
       217,  211,   60,   60,  218,   60,    0,    0,
       219,  220,    0,  121,  121,  224,    0,  121,
        60,  225,   60,   60,   60,   60,  121,  221,
        60,  211,  222,  226,    0,  223,   60,  227,
       211,   60,   60,  229,   60,   63,   63,   63,
       230,  121,  121,  121,  224,   63,  121,   63,
       225,   63,   63,    0,  231,  121,   63,   63,
       228,  228,  226,   63,  232,    0,  227,  235,
       233,  238,  229,  233,   63,   63,   63,  230,
       228,    0,  233,  228,   63,  239,   63,    0,
        63,   63,  228,  231,  237,   63,   63,  236,
       236,    0,   63,  232,  234,  234,  235,  233,
       238,  241,  233,  242,  237,  243,  234,  228,
       236,  233,  228,  244,  239,  246,  234,  240,
       240,  228,    0,  237,  247,  248,  249,  250,
       236,  240,  251,  252,  253,    0,  254,  240,
       241,  258,  242,  237,  243,  256,  256,  236,
       259,  234,  244,  252,  246,  234,  260,  257,
       261,  240,  262,  247,  248,  249,  250,  236,
       256,  251,  252,  253,  240,  254,  240,  257,
       258,  263,  264,  264,    0,    0,  265,  259,
         0,  266,  252,  267,  268,  260,  257,  261,
       240,  262,  256,  269,  270,  271,  272,  256,
       273,  274,  275,  276,  277,  278,  257,  279,
       263,  280,  281,  264,  264,  265,  282,  264,
       266,  283,  267,  268,  284,    0,  287,  264,
       286,  286,  269,  270,  271,  272,  288,  273,
       274,  275,  276,  277,  278,  292,  279,  293,
       280,  281,  264,  264,  296,  282,  264,  297,
       283,  285,  285,  284,  286,  287,  294,  294,
       298,  300,  301,  285,  302,  288,  295,  295,
       294,  305,  285,  307,  292,    0,  293,  294,
       295,  308,    0,  296,  299,  299,  297,    0,
       295,  294,  285,  286,  309,  295,  310,  298,
       300,  301,    0,  302,  311,  312,  285,  299,
       305,  285,  307,  294,  306,  306,  294,  313,
       308,  299,  314,  295,  315,  316,  306,  295,
       294,  285,    0,  309,  295,  310,  317,  317,
       318,  299,  319,  311,  312,  320,  299,  321,
       317,  323,  306,  322,  322,  324,  313,  317,
       299,  314,  325,  315,  316,  326,  327,  328,
       329,  306,  332,  331,  334,  322,  333,  318,
         0,  319,  330,  330,  320,    0,  321,  336,
       323,  306,  338,  317,  324,  331,  317,  333,
         0,  325,  330,  339,  326,  327,  328,  329,
       342,  332,  331,  334,  322,  333,  335,  335,
       337,  337,    0,  343,  330,  344,  336,  345,
       335,  338,  337,  346,  331,  347,  333,  335,
         0,  330,  339,  349,  341,  341,    0,  342,
       350,  353,  354,  356,  348,  348,  341,  355,
       355,  337,  343,  330,  344,  357,  345,  358,
       360,  355,  346,  335,  347,  337,  335,  348,
       359,  359,  349,  361,  362,  341,    0,  350,
       353,  354,  356,  363,  364,  355,  365,  363,
       337,  341,  366,  367,  357,  368,  358,  360,
       369,    0,  372,  371,  355,  373,  348,  371,
       374,  359,  361,  362,  341,  359,  370,  370,
       375,  376,  363,  364,  355,  365,  363,  377,
       370,  366,  367,  378,  368,  379,  380,  369,
       370,  372,  371,  381,  373,  382,  371,  374,
       359,  383,  386,  387,  359,  384,  384,  375,
       376,  385,  391,  395,  396,    0,  377,  399,
       388,  388,  378,  370,  379,  380,  384,  370,
       388,  385,  381,  394,  382,  392,  392,    0,
       383,  386,  387,  393,  393,  394,  384,  392,
       385,  391,  395,  396,  397,  401,  399,  388,
       388,  398,  398,  392,  393,  384,  397,  388,
       385,  402,  394,  405,  400,  400,  393,  406,
       407,  404,  404,  408,  394,  384,  400,  409,
       398,  410,  392,  397,  401,  403,  403,  412,
       412,  413,  392,  393,  404,  397,  400,  403,
       402,  414,  405,    0,  415,  393,  406,  407,
       416,  417,  408,  418,  419,  420,  409,  398,
       410,  400,  421,  403,  423,  412,  425,  426,
       413,  427,  428,  404,  430,  400,  424,  424,
       414,  431,  403,  415,  422,  422,  432,  416,
       417,  433,  418,  419,  420,  434,  422,  424,
       435,  421,  403,  423,  412,  425,  426,  436,
       427,  428,  437,  430,  438,  439,  440,  441,
       431,  443,  422,  442,  442,  432,  444,  445,
       433,  446,  447,  447,  434,  448,  424,  435,
       449,  422,  450,  451,  442,  453,  436,  452,
       452,  437,  454,  438,  439,  440,  441,  455,
       443,  422,  457,  458,  459,  444,  445,  460,
       446,  461,  462,  447,  448,  464,  464,  449,
       465,  450,  451,  442,  453,  466,  468,  469,
       452,  454,  470,  471,  473,  474,  455,  476,
       477,  457,  458,  459,  478,  480,  460,  481,
       461,  462,  447,  464,    0,    0,  483,  465,
       479,  479,    0,  485,  466,  468,  469,  452,
       486,  470,  471,  473,  474,  487,  476,  477,
       488,    0,  479,  478,  480,  490,  481,  482,
       482,    0,  464,  467,  467,  483,  491,    0,
       492,  482,  485,  493,  495,  467,  496,  486,
       497,    0,  467,    0,  487,  467,  498,  488,
       467,  479,  467,  499,  490,  467,  467,  467,
       482,  467,  502,  502,  467,  491,  467,  492,
       494,  494,  493,  495,  482,  496,  505,  497,
       467,  467,  494,  507,  467,  498,    0,  467,
       508,  467,  499,  509,  467,  467,  467,  482,
       467,  502,  502,  467,  510,  467,  506,  506,
       511,  494,  512,  513,  513,  505,  514,  515,
       516,  517,  507,  518,  518,  494,  519,  508,
       520,  522,  509,  523,  506,  524,  525,  526,
       527,  528,  529,  510,  530,  513,  531,  511,
       494,  512,  532,  533,  535,  514,  515,  516,
       517,  518,    0,  534,  534,  519,  536,  520,
       522,  537,  523,  506,  524,  525,  526,  527,
       528,  529,  538,  530,  513,  531,  541,  543,
       544,  532,  533,  535,  545,  546,  547,  548,
       518,  534,  549,  550,  552,  536,    0,  553,
       537,  551,  551,  554,  555,  556,  557,  558,
       563,  538,    0,  551,  566,  541,  543,  544,
       567,  568,  569,  545,  546,  547,  548,  570,
       534,  549,  550,  552,  571,  551,  553,  565,
       565,  570,  554,  555,  556,  557,  558,  563,
       572,  565,  573,  566,  574,    0,  551,  567,
       568,  569,  575,  577,  579,  580,  570,  581,
       582,  583,  584,  571,  551,  585,  586,  586,
       570,  587,  588,  589,  590,  592,  593,  572,
       594,  573,  595,  574,  565,  596,  597,  598,
       598,  575,  577,  579,  580,  599,  581,  582,
       583,  584,  600,  602,  585,  603,  607,  586,
       587,  588,  589,  590,  592,  593,  608,  594,
       609,  595,  610,  611,  596,  597,  612,  614,
       598,  613,  613,  615,  599,  616,  617,    0,
       618,  600,  602,  613,  603,  607,  586,    0,
       621,  619,  619,  622,  623,  608,    0,  609,
         0,  610,  611,  619,  625,  612,  614,  598,
       620,  620,  615,  626,  616,  617,  613,  618,
       627,    0,  620,  624,  624,  619,  613,  621,
       628,  629,  622,  623,  630,  624,  631,  620,
       632,    0,  634,  625,  635,  635,  619,  636,
       637,  637,  626,  638,  639,  613,  635,  627,
       624,  640,    0,  642,  619,  620,  643,  628,
       629,  641,  641,  630,  644,  631,  620,  632,
       624,  634,  635,  641,  637,  645,  636,    0,
       646,  647,  638,  639,  648,  649,  650,  624,
       640,  635,  642,  652,  653,  643,  641,  654,
       651,  651,    0,  644,  655,  656,  657,  658,
       659,  635,    0,  637,  645,  662,  641,  646,
       647,  651,  663,  648,  649,  650,  660,  660,
         0,  665,  652,  653,    0,  641,  654,  666,
       660,  651,  667,  655,  656,  657,  658,  659,
       661,  661,  668,  668,  662,  651,  669,  670,
       651,  663,  661,  671,  668,  672,    0,  660,
       665,  674,  675,  660,  673,  673,  666,  676,
       651,  667,  677,  660,  678,  668,  673,  680,
       682,  681,  681,  661,  683,  669,  670,  684,
       685,  687,  671,  673,  672,  661,  660,  668,
       674,  675,  660,  681,  686,  686,  676,  688,
       689,  677,    0,  678,  668,  690,  680,  682,
       691,  673,  661,  683,  693,  695,  684,  685,
       687,  696,  673,  694,  694,  698,  681,  699,
       692,  692,  681,  697,  697,  700,  688,  689,
       701,  686,  692,  702,  690,  704,    0,  691,
       705,  703,  703,  693,  695,  707,  708,  694,
       696,  711,  697,  712,  698,  713,  699,  714,
       716,  692,    0,  717,  700,  715,  715,  701,
       686,  718,  702,  719,  704,  692,  703,  705,
       720,  709,  709,  722,  707,  708,  694,  723,
       711,  697,  712,  709,  713,  724,  714,  716,
       692,  709,  717,  715,  709,  725,  727,  728,
       718,  729,  719,  709,  730,  703,    0,  720,
       721,  721,  722,  731,  732,  734,  723,  726,
       726,    0,  735,  737,  724,  738,  709,  739,
       709,  726,  715,  709,  725,  727,  728,  736,
       729,  740,  709,  730,  741,  721,  733,  733,
         0,  726,  731,  732,  734,  742,  743,  736,
       726,  735,  737,  744,  738,  747,  739,  733,
       745,  745,    0,  746,  726,  748,  736,  746,
       740,  749,  749,  741,  721,    0,  750,  733,
       726,  751,  752,  753,  742,  743,  736,  726,
       754,  755,  744,  756,  747,  758,  733,  759,
       760,  745,  746,    0,  748,  745,  746,  757,
       757,  761,  761,  762,  749,  750,  733,  763,
       751,  752,  753,  761,  765,  764,  764,  754,
       755,  766,  756,  767,  758,  768,  759,  760,
       745,  769,  757,  770,  745,  773,  775,  761,
       776,  777,  762,  749,  764,  778,  763,  779,
       780,  774,  774,  765,  781,  782,  761,  783,
       766,  786,  767,    0,  768,  787,  785,  785,
       769,  757,  770,  774,  773,  775,  761,  776,
       777,  788,  789,  764,  778,  790,  779,  780,
       784,  784,  791,  781,  782,  795,  783,  796,
       786,    0,  784,    0,  787,  793,  793,  785,
       797,  797,  774,  794,  794,  799,  800,  793,
       788,  789,  801,    0,  790,  802,  784,  798,
       797,  791,  798,  797,  795,  803,  796,  805,
       793,  798,  797,  806,  807,  784,  785,  794,
       804,  804,  808,  809,  799,  800,  810,  812,
       815,  801,  793,  816,  802,  784,  798,  797,
       794,  798,  797,  817,  803,  814,  805,  793,
       798,  797,  806,  807,  814,  804,  794,  811,
       811,  808,  809,  813,  813,  810,  812,  815,
       818,  811,  816,  819,  820,  804,  821,  822,
       823,  824,  817,  825,  814,  826,  827,  828,
       829,  811,  830,  814,  804,  813,  831,  831,
         0,  832,  833,  834,  813,  835,  838,  818,
       831,  839,  819,  820,  811,  821,  822,  823,
       824,  840,  825,  842,  826,  827,  828,  829,
       811,  830,  843,  845,  813,  836,  836,  831,
       832,  833,  834,  813,  835,  838,  846,  836,
       839,  841,  841,  831,  844,  844,    0,  849,
       840,  850,  842,  847,  847,  853,  844,  854,
       836,  843,  845,  855,  856,  847,  831,  857,
       858,  848,  848,    0,  859,  846,  844,  841,
       860,  862,  836,  848,  863,  847,  849,    0,
       850,  861,  861,  864,  853,  865,  854,  836,
       866,  844,  855,  856,  867,  870,  857,  858,
       847,  871,  848,  859,  873,  844,  841,  860,
       862,  869,  869,  863,  847,    0,  848,  861,
       872,  872,  864,  874,  865,  875,  876,  866,
       877,  878,  879,  867,  870,  881,  882,  882,
       871,  848,  883,  873,  869,  884,    0,  886,
       885,  885,  887,  888,  872,  889,  861,  890,
       892,  893,  874,  894,  875,  876,    0,  877,
       878,  879,  895,  882,  881,  891,  891,  896,
       898,  883,  899,  869,  884,  885,  886,  897,
       897,  887,  888,  872,  889,  900,  890,  892,
       893,  897,  894,  901,  902,  885,  903,  891,
       904,  895,  882,  905,  906,  907,  896,  898,
       908,  899,  897,  909,  885,  910,  910,    0,
       911,  912,  913,  914,  900,  916,  918,  919,
       917,  917,  901,  902,  897,  903,  891,  904,
       920,  921,  905,  906,  907,  922,    0,  908,
       924,  897,  909,  923,  923,  925,  910,  911,
       912,  913,  914,  917,  916,  918,  919,  927,
       929,  928,  928,  930,  931,  931,    0,  920,
       921,  932,  933,  934,  922,  923,  935,  924,
       937,  938,  940,  942,  925,  910,  943,  944,
         0,    0,  917,  928,  945,  946,  927,  929,
       947,  949,  930,  950,  951,  931,    0,    0,
       932,  933,  934,    0,  923,  935,    0,  937,
       938,  940,  942,  952,  953,  943,  944,  941,
       941,  955,  928,  945,  946,  956,  956,  947,
       949,  941,  950,  951,  931,  939,  939,  957,
       968,  968,  941,  958,  948,  948,  959,  939,
       961,  962,  952,  953,  948,  963,  939,  964,
       955,  965,  956,  966,  967,  969,  970,  939,
       971,  939,  972,  968,  941,  973,  957,  939,
       939,  941,  958,  948,  948,  959,  974,  961,
       962,  975,  939,  948,  963,  939,  964,  976,
       965,  956,  966,  967,  969,  970,  939,  971,
       939,  972,  968,  978,  973,  980,  939,  939,
       982,  983,  984,  985,  987,  974,  988,  989,
       975,  990,  991,  992,  993,  995,  976,  997,
         0, 1000, 1001, 1002, 1003, 1004,    0,    0,
      1005,    0,  978, 1007,  980, 1008, 1009,  982,
       983,  984,  985,  987,  999,  988,  989, 1010,
       990,  991,  992,  993,  995,  999,  997,  999,
      1000, 1001, 1002, 1003, 1004,  999,  999, 1005,
      1006, 1006, 1007, 1011, 1008, 1009, 1012, 1013,
      1014, 1015, 1015,  999, 1016, 1017, 1010, 1018,
      1019, 1020, 1021, 1006,  999, 1022,  999, 1023,
      1023, 1024, 1025, 1026,  999,  999, 1028, 1029,
         0, 1030, 1011, 1032, 1033, 1012, 1013, 1014,
      1015, 1015, 1023, 1016, 1017, 1034, 1018, 1019,
      1020, 1021, 1006,    0, 1022, 1027, 1027, 1035,
      1024, 1025, 1026, 1031, 1031, 1028, 1029, 1027,
      1030, 1036, 1032, 1033, 1023, 1037, 1027, 1038,
      1040, 1023, 1039, 1039, 1034, 1041, 1042, 1043,
      1044, 1045, 1031, 1046, 1047, 1048, 1035, 1049,
         0, 1050, 1051, 1052, 1053, 1054, 1055, 1056,
      1036, 1057, 1027, 1058, 1037, 1027, 1038, 1040,
      1031, 1059, 1060, 1039, 1041, 1042, 1043, 1044,
      1045, 1031, 1046, 1047, 1048, 1061, 1049, 1039,
      1050, 1051, 1052, 1053, 1054, 1055, 1056, 1062,
      1057, 1063, 1058, 1064, 1064, 1065, 1066, 1067,
      1059, 1060, 1039, 1068, 1069, 1071, 1070, 1070,
      1072, 1073, 1074, 1075, 1061, 1077, 1064, 1076,
      1076, 1078, 1079, 1079, 1080, 1081, 1062, 1070,
      1063, 1082, 1083, 1084, 1065, 1066, 1067, 1085,
      1085,    0, 1068, 1069, 1071, 1079, 1076, 1072,
      1073, 1074, 1075, 1086, 1077, 1064, 1087, 1088,
      1078, 1089, 1090, 1080, 1081, 1091, 1070, 1092,
      1082, 1083, 1084, 1093, 1094, 1095, 1096, 1079,
      1085, 1097, 1098, 1099, 1079, 1076, 1100, 1101,
      1102, 1103, 1086, 1104, 1105, 1087, 1088, 1106,
      1089, 1090, 1107, 1108, 1091, 1109, 1092, 1110,
      1111, 1112, 1093, 1094, 1095, 1096, 1113, 1085,
      1097, 1098, 1099, 1114, 1116, 1100, 1101, 1102,
      1103, 1117, 1104, 1105, 1115, 1115, 1106, 1118,
      1119, 1107, 1108, 1120, 1109, 1121, 1110, 1111,
      1112, 1122, 1123, 1124, 1125, 1113, 1126, 1115,
      1127, 1128, 1114, 1116, 1130, 1131, 1132, 1127,
      1117, 1133, 1134, 1129, 1129, 1135, 1118, 1119,
      1136, 1138, 1120, 1139, 1121, 1129, 1140, 1141,
      1122, 1123, 1124, 1125, 1129, 1126, 1115, 1127,
      1128, 1137, 1137, 1130, 1131, 1132, 1127, 1142,
      1133, 1134, 1143, 1144, 1135, 1145, 1146, 1136,
      1138, 1147, 1139, 1148, 1137, 1140, 1141, 1149,
      1129, 1150, 1151, 1129, 1152, 1153, 1154, 1154,
      1155, 1156, 1157, 1158, 1160, 1161, 1142, 1163,
      1163, 1143, 1144, 1164, 1145, 1146, 1137, 1154,
      1147, 1165, 1148, 1137, 1162, 1162, 1149, 1166,
      1150, 1151, 1163, 1152, 1153, 1167, 1168, 1155,
      1156, 1157, 1158, 1160, 1161, 1162, 1169,    0,
      1170, 1170, 1164, 1171, 1172, 1173, 1154, 1174,
      1165, 1175, 1176, 1177, 1178, 1179, 1166, 1180,
      1181, 1163, 1182, 1183, 1167, 1168, 1184, 1186,
      1187, 1162, 1188, 1190, 1162, 1169, 1170, 1185,
      1185, 1191, 1171, 1172, 1173, 1192, 1174, 1194,
      1175, 1176, 1177, 1178, 1179, 1170, 1180, 1181,
      1185, 1182, 1183, 1193, 1193, 1184, 1186, 1187,
      1195, 1188, 1190, 1196, 1197, 1170, 1198, 1199,
      1191, 1200, 1201, 1202, 1192, 1203, 1194, 1204,
      1205, 1206, 1207, 1208, 1209, 1211, 1212, 1185,
      1213, 1193, 1214, 1215, 1216, 1217, 1218, 1195,
      1219, 1220, 1196, 1197, 1221, 1198, 1199, 1222,
      1200, 1201, 1202, 1223, 1203, 1224, 1204, 1205,
      1206, 1207, 1208, 1209, 1211, 1212, 1225, 1213,
      1193, 1214, 1215, 1216, 1217, 1218, 1226, 1219,
      1220, 1227, 1228, 1221, 1230, 1231, 1222, 1232,
      1233, 1234, 1223, 1235, 1224, 1236, 1236, 1237,
      1238, 1239, 1240, 1241, 1243, 1225, 1242, 1242,
      1244, 1245, 1247, 1246, 1246, 1226, 1248, 1249,
      1227, 1228, 1251, 1230, 1231, 1252, 1232, 1233,
      1234,    0, 1235, 1236, 1246, 1253, 1237, 1238,
      1239, 1240, 1241, 1243, 1242, 1250, 1250, 1244,
      1245, 1247, 1236, 1254, 1255, 1248, 1249, 1256,
      1257, 1251, 1258, 1259, 1252, 1263, 1250, 1264,
      1246, 1265, 1236, 1246, 1253, 1261, 1261, 1262,
      1262, 1266, 1267, 1242,    0,    0,    0,    0,
         0,    0, 1254, 1255,    0,    0, 1256, 1257,
         0, 1258, 1259,    0, 1263, 1250, 1264,    0,
      1265,    0,    0, 1261,    0, 1262,    0,    0,
      1266, 1267,    0,    0,    0,    0,    0,    0,
         0,    0, 1261,    0,    0,    0,    0,    0,
         0,    0,    0,    0,    0,    0,    0,    0,
         0,    0, 1261,    0, 1262, 1269, 1269, 1269,
      1269, 1269, 1269, 1269, 1270, 1270, 1270, 1270,
      1270, 1270, 1270, 1271, 1271, 1271, 1271, 1271,
      1271, 1271, 1272, 1272, 1272, 1272, 1272, 1272,
      1272, 1273,    0,    0,    0, 1273, 1273, 1274,
      1274,    0,    0, 1274, 1275, 1275, 1275, 1276,
      1276,    0,    0, 1276, 1277, 1277,    0,    0,
      1277, 1278, 1278,    0,    0, 1278, 1279, 1279,
         0,    0, 1279, 1280, 1280,    0,    0, 1280,
      1281, 1281,    0,    0, 1281, 1282, 1282,    0,
         0, 1282, 1283, 1283,    0,    0, 1283, 1284,
      1284,    0,    0, 1284, 1285, 1285,    0,    0,
      1285, 1286, 1286,    0,    0, 1286, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268, 1268, 1268, 1268, 1268,
      1268, 1268, 1268, 1268);

   YY_EC_0000 : aliased constant YY_Secondary_Array :=
    (    0,    1,    1,    1,    1,    1,    1,    1,
         1,    2,    3,    2,    2,    2,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         2,    4,    4,    5,    6,    4,    4,    4,
         7,    8,    9,   10,   11,   12,   13,    4,
        14,   14,   14,   14,   14,   14,   14,   14,
        14,   14,   15,    4,    4,    4,    4,   16,
         4,   17,   18,   19,   20,   21,   22,   23,
        24,   25,   26,   27,   28,   29,   30,   31,
        32,   33,   34,   35,   36,   37,   38,   39,
        40,   41,   42,   43,   44,   45,   46,   47,
         4,   48,   49,   50,   51,   52,   53,   54,
        55,   56,   57,   58,   59,   60,   61,   62,
        63,   64,   65,   66,   67,   68,   69,   70,
        71,   72,   73,   74,   75,   76,    4,    1,
         1,    1,    1,    1,    1,    2,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    4,    4,    4,    4,    4,    4,    4,
         1,    4,    1,    4,    4,    1,    4,    1,
         4,    4,    1,    1,    1,    1,    4,    1,
         1,    1,    1,    4,    1,    1,    1,    4,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    4,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    4,
         1,    1,    1,    1,    1,    1,    1,    1);

   YY_EC_0001 : aliased constant YY_Secondary_Array :=
    (    1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1);

   YY_EC_0020 : aliased constant YY_Secondary_Array :=
    (    1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    2,    2,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         2,    2,    1,    1,    1,    1,    1,    1,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    1,
         1,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    1,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1);

   YY_EC_0021 : aliased constant YY_Secondary_Array :=
    (    1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4);

   YY_EC_0022 : aliased constant YY_Secondary_Array :=
    (    4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4);

   YY_EC_0024 : aliased constant YY_Secondary_Array :=
    (    4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1);

   YY_EC_0027 : aliased constant YY_Secondary_Array :=
    (    4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4);

   YY_EC_002E : aliased constant YY_Secondary_Array :=
    (    4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1);

   YY_EC_0030 : aliased constant YY_Secondary_Array :=
    (    1,    4,    4,    4,    1,    1,    1,    1,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    4,    4,    4,    4,    4,    4,    4,
         4,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         4,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1);

   YY_EC_00FD : aliased constant YY_Secondary_Array :=
    (    1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    4,    4,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1);

   YY_EC_00FE : aliased constant YY_Secondary_Array :=
    (    1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    4,    4,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1);

   YY_EC_00FF : aliased constant YY_Secondary_Array :=
    (    1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
        77,   77,   77,   77,   77,   77,   77,   77,
        77,   77,    1,    1,    1,    1,    1,    1,
         1,   77,   77,   77,   77,   77,   77,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,   77,   77,   77,   77,   77,   77,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1);

   YY_EC_Base : constant
     array (YY_Primary_Index) of YY_Secondary_Array_Access :=
     (16#0000# => YY_EC_0000'Access, 16#0020# => YY_EC_0020'Access,
      16#0021# => YY_EC_0021'Access, 16#0022# => YY_EC_0022'Access,
      16#0023# => YY_EC_0022'Access, 16#0024# => YY_EC_0024'Access,
      16#0025# => YY_EC_0022'Access, 16#0026# => YY_EC_0022'Access,
      16#0027# => YY_EC_0027'Access, 16#0028# => YY_EC_0022'Access,
      16#0029# => YY_EC_0022'Access, 16#002A# => YY_EC_0022'Access,
      16#002B# => YY_EC_0022'Access, 16#002E# => YY_EC_002E'Access,
      16#0030# => YY_EC_0030'Access, 16#00FD# => YY_EC_00FD'Access,
      16#00FE# => YY_EC_00FE'Access, 16#00FF# => YY_EC_00FF'Access,
      others   => YY_EC_0001'Access);

end Matreshka.Internals.Regexps.Compiler.Scanner.Tables;
