------------------------------------------------------------------------------
--                                                                          --
--                            Matreshka Project                             --
--                                                                          --
--        Localization, Internationalization, Globalization for Ada         --
--                                                                          --
--                        Runtime Library Component                         --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2012-2015, Vadim Godunko <vgodunko@gmail.com>                --
-- All rights reserved.                                                     --
--                                                                          --
-- Redistribution and use in source and binary forms, with or without       --
-- modification, are permitted provided that the following conditions       --
-- are met:                                                                 --
--                                                                          --
--  * Redistributions of source code must retain the above copyright        --
--    notice, this list of conditions and the following disclaimer.         --
--                                                                          --
--  * Redistributions in binary form must reproduce the above copyright     --
--    notice, this list of conditions and the following disclaimer in the   --
--    documentation and/or other materials provided with the distribution.  --
--                                                                          --
--  * Neither the name of the Vadim Godunko, IE nor the names of its        --
--    contributors may be used to endorse or promote products derived from  --
--    this software without specific prior written permission.              --
--                                                                          --
-- THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS      --
-- "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT        --
-- LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR    --
-- A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT     --
-- HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,   --
-- SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED --
-- TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR   --
-- PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF   --
-- LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING     --
-- NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS       --
-- SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.             --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 5318 $ $Date: 2015-05-16 01:29:51 +0200 (Sat, 16 May 2015) $
------------------------------------------------------------------------------

pragma Restrictions (No_Elaboration_Code);
--  GNAT: enforce generation of preinitialized data section instead of
--  generation of elaboration code.

package Matreshka.Internals.Unicode.Ucd.Core_000A is

   pragma Preelaborate;

   Group_000A : aliased constant Core_Second_Stage
     := (16#00#           =>  --  0A00
          (Unassigned, Neutral,
           Other, Other, Other, Unknown,
           (others => False)),
         16#01# .. 16#02# =>  --  0A01 .. 0A02
          (Nonspacing_Mark, Neutral,
           Extend, Extend, Extend, Combining_Mark,
           (Other_Alphabetic
              | Alphabetic
              | Case_Ignorable
              | Grapheme_Extend
              | ID_Continue
              | XID_Continue => True,
            others => False)),
         16#03#           =>  --  0A03
          (Spacing_Mark, Neutral,
           Spacing_Mark, Extend, Extend, Combining_Mark,
           (Other_Alphabetic
              | Alphabetic
              | Grapheme_Base
              | ID_Continue
              | XID_Continue => True,
            others => False)),
         16#04#           =>  --  0A04
          (Unassigned, Neutral,
           Other, Other, Other, Unknown,
           (others => False)),
         16#0B# .. 16#0E# =>  --  0A0B .. 0A0E
          (Unassigned, Neutral,
           Other, Other, Other, Unknown,
           (others => False)),
         16#11# .. 16#12# =>  --  0A11 .. 0A12
          (Unassigned, Neutral,
           Other, Other, Other, Unknown,
           (others => False)),
         16#29#           =>  --  0A29
          (Unassigned, Neutral,
           Other, Other, Other, Unknown,
           (others => False)),
         16#31#           =>  --  0A31
          (Unassigned, Neutral,
           Other, Other, Other, Unknown,
           (others => False)),
         16#33#           =>  --  0A33
          (Other_Letter, Neutral,
           Other, A_Letter, O_Letter, Alphabetic,
           (Alphabetic
              | Grapheme_Base
              | ID_Continue
              | ID_Start
              | XID_Continue
              | XID_Start
              | Changes_When_NFKC_Casefolded => True,
            others => False)),
         16#34#           =>  --  0A34
          (Unassigned, Neutral,
           Other, Other, Other, Unknown,
           (others => False)),
         16#36#           =>  --  0A36
          (Other_Letter, Neutral,
           Other, A_Letter, O_Letter, Alphabetic,
           (Alphabetic
              | Grapheme_Base
              | ID_Continue
              | ID_Start
              | XID_Continue
              | XID_Start
              | Changes_When_NFKC_Casefolded => True,
            others => False)),
         16#37#           =>  --  0A37
          (Unassigned, Neutral,
           Other, Other, Other, Unknown,
           (others => False)),
         16#3A# .. 16#3B# =>  --  0A3A .. 0A3B
          (Unassigned, Neutral,
           Other, Other, Other, Unknown,
           (others => False)),
         16#3C#           =>  --  0A3C
          (Nonspacing_Mark, Neutral,
           Extend, Extend, Extend, Combining_Mark,
           (Diacritic
              | Case_Ignorable
              | Grapheme_Extend
              | ID_Continue
              | XID_Continue => True,
            others => False)),
         16#3D#           =>  --  0A3D
          (Unassigned, Neutral,
           Other, Other, Other, Unknown,
           (others => False)),
         16#3E# .. 16#40# =>  --  0A3E .. 0A40
          (Spacing_Mark, Neutral,
           Spacing_Mark, Extend, Extend, Combining_Mark,
           (Other_Alphabetic
              | Alphabetic
              | Grapheme_Base
              | ID_Continue
              | XID_Continue => True,
            others => False)),
         16#41# .. 16#42# =>  --  0A41 .. 0A42
          (Nonspacing_Mark, Neutral,
           Extend, Extend, Extend, Combining_Mark,
           (Other_Alphabetic
              | Alphabetic
              | Case_Ignorable
              | Grapheme_Extend
              | ID_Continue
              | XID_Continue => True,
            others => False)),
         16#43# .. 16#46# =>  --  0A43 .. 0A46
          (Unassigned, Neutral,
           Other, Other, Other, Unknown,
           (others => False)),
         16#47# .. 16#48# =>  --  0A47 .. 0A48
          (Nonspacing_Mark, Neutral,
           Extend, Extend, Extend, Combining_Mark,
           (Other_Alphabetic
              | Alphabetic
              | Case_Ignorable
              | Grapheme_Extend
              | ID_Continue
              | XID_Continue => True,
            others => False)),
         16#49# .. 16#4A# =>  --  0A49 .. 0A4A
          (Unassigned, Neutral,
           Other, Other, Other, Unknown,
           (others => False)),
         16#4B# .. 16#4C# =>  --  0A4B .. 0A4C
          (Nonspacing_Mark, Neutral,
           Extend, Extend, Extend, Combining_Mark,
           (Other_Alphabetic
              | Alphabetic
              | Case_Ignorable
              | Grapheme_Extend
              | ID_Continue
              | XID_Continue => True,
            others => False)),
         16#4D#           =>  --  0A4D
          (Nonspacing_Mark, Neutral,
           Extend, Extend, Extend, Combining_Mark,
           (Diacritic
              | Case_Ignorable
              | Grapheme_Extend
              | Grapheme_Link
              | ID_Continue
              | XID_Continue => True,
            others => False)),
         16#4E# .. 16#50# =>  --  0A4E .. 0A50
          (Unassigned, Neutral,
           Other, Other, Other, Unknown,
           (others => False)),
         16#51#           =>  --  0A51
          (Nonspacing_Mark, Neutral,
           Extend, Extend, Extend, Combining_Mark,
           (Other_Alphabetic
              | Alphabetic
              | Case_Ignorable
              | Grapheme_Extend
              | ID_Continue
              | XID_Continue => True,
            others => False)),
         16#52# .. 16#58# =>  --  0A52 .. 0A58
          (Unassigned, Neutral,
           Other, Other, Other, Unknown,
           (others => False)),
         16#59# .. 16#5B# =>  --  0A59 .. 0A5B
          (Other_Letter, Neutral,
           Other, A_Letter, O_Letter, Alphabetic,
           (Alphabetic
              | Grapheme_Base
              | ID_Continue
              | ID_Start
              | XID_Continue
              | XID_Start
              | Changes_When_NFKC_Casefolded => True,
            others => False)),
         16#5D#           =>  --  0A5D
          (Unassigned, Neutral,
           Other, Other, Other, Unknown,
           (others => False)),
         16#5E#           =>  --  0A5E
          (Other_Letter, Neutral,
           Other, A_Letter, O_Letter, Alphabetic,
           (Alphabetic
              | Grapheme_Base
              | ID_Continue
              | ID_Start
              | XID_Continue
              | XID_Start
              | Changes_When_NFKC_Casefolded => True,
            others => False)),
         16#5F# .. 16#65# =>  --  0A5F .. 0A65
          (Unassigned, Neutral,
           Other, Other, Other, Unknown,
           (others => False)),
         16#66# .. 16#6F# =>  --  0A66 .. 0A6F
          (Decimal_Number, Neutral,
           Other, Numeric, Numeric, Numeric,
           (Grapheme_Base
              | ID_Continue
              | XID_Continue => True,
            others => False)),
         16#70# .. 16#71# =>  --  0A70 .. 0A71
          (Nonspacing_Mark, Neutral,
           Extend, Extend, Extend, Combining_Mark,
           (Other_Alphabetic
              | Alphabetic
              | Case_Ignorable
              | Grapheme_Extend
              | ID_Continue
              | XID_Continue => True,
            others => False)),
         16#75#           =>  --  0A75
          (Nonspacing_Mark, Neutral,
           Extend, Extend, Extend, Combining_Mark,
           (Other_Alphabetic
              | Alphabetic
              | Case_Ignorable
              | Grapheme_Extend
              | ID_Continue
              | XID_Continue => True,
            others => False)),
         16#76# .. 16#80# =>  --  0A76 .. 0A80
          (Unassigned, Neutral,
           Other, Other, Other, Unknown,
           (others => False)),
         16#81# .. 16#82# =>  --  0A81 .. 0A82
          (Nonspacing_Mark, Neutral,
           Extend, Extend, Extend, Combining_Mark,
           (Other_Alphabetic
              | Alphabetic
              | Case_Ignorable
              | Grapheme_Extend
              | ID_Continue
              | XID_Continue => True,
            others => False)),
         16#83#           =>  --  0A83
          (Spacing_Mark, Neutral,
           Spacing_Mark, Extend, Extend, Combining_Mark,
           (Other_Alphabetic
              | Alphabetic
              | Grapheme_Base
              | ID_Continue
              | XID_Continue => True,
            others => False)),
         16#84#           =>  --  0A84
          (Unassigned, Neutral,
           Other, Other, Other, Unknown,
           (others => False)),
         16#8E#           =>  --  0A8E
          (Unassigned, Neutral,
           Other, Other, Other, Unknown,
           (others => False)),
         16#92#           =>  --  0A92
          (Unassigned, Neutral,
           Other, Other, Other, Unknown,
           (others => False)),
         16#A9#           =>  --  0AA9
          (Unassigned, Neutral,
           Other, Other, Other, Unknown,
           (others => False)),
         16#B1#           =>  --  0AB1
          (Unassigned, Neutral,
           Other, Other, Other, Unknown,
           (others => False)),
         16#B4#           =>  --  0AB4
          (Unassigned, Neutral,
           Other, Other, Other, Unknown,
           (others => False)),
         16#BA# .. 16#BB# =>  --  0ABA .. 0ABB
          (Unassigned, Neutral,
           Other, Other, Other, Unknown,
           (others => False)),
         16#BC#           =>  --  0ABC
          (Nonspacing_Mark, Neutral,
           Extend, Extend, Extend, Combining_Mark,
           (Diacritic
              | Case_Ignorable
              | Grapheme_Extend
              | ID_Continue
              | XID_Continue => True,
            others => False)),
         16#BE# .. 16#C0# =>  --  0ABE .. 0AC0
          (Spacing_Mark, Neutral,
           Spacing_Mark, Extend, Extend, Combining_Mark,
           (Other_Alphabetic
              | Alphabetic
              | Grapheme_Base
              | ID_Continue
              | XID_Continue => True,
            others => False)),
         16#C1# .. 16#C5# =>  --  0AC1 .. 0AC5
          (Nonspacing_Mark, Neutral,
           Extend, Extend, Extend, Combining_Mark,
           (Other_Alphabetic
              | Alphabetic
              | Case_Ignorable
              | Grapheme_Extend
              | ID_Continue
              | XID_Continue => True,
            others => False)),
         16#C6#           =>  --  0AC6
          (Unassigned, Neutral,
           Other, Other, Other, Unknown,
           (others => False)),
         16#C7# .. 16#C8# =>  --  0AC7 .. 0AC8
          (Nonspacing_Mark, Neutral,
           Extend, Extend, Extend, Combining_Mark,
           (Other_Alphabetic
              | Alphabetic
              | Case_Ignorable
              | Grapheme_Extend
              | ID_Continue
              | XID_Continue => True,
            others => False)),
         16#C9#           =>  --  0AC9
          (Spacing_Mark, Neutral,
           Spacing_Mark, Extend, Extend, Combining_Mark,
           (Other_Alphabetic
              | Alphabetic
              | Grapheme_Base
              | ID_Continue
              | XID_Continue => True,
            others => False)),
         16#CA#           =>  --  0ACA
          (Unassigned, Neutral,
           Other, Other, Other, Unknown,
           (others => False)),
         16#CB# .. 16#CC# =>  --  0ACB .. 0ACC
          (Spacing_Mark, Neutral,
           Spacing_Mark, Extend, Extend, Combining_Mark,
           (Other_Alphabetic
              | Alphabetic
              | Grapheme_Base
              | ID_Continue
              | XID_Continue => True,
            others => False)),
         16#CD#           =>  --  0ACD
          (Nonspacing_Mark, Neutral,
           Extend, Extend, Extend, Combining_Mark,
           (Diacritic
              | Case_Ignorable
              | Grapheme_Extend
              | Grapheme_Link
              | ID_Continue
              | XID_Continue => True,
            others => False)),
         16#CE# .. 16#CF# =>  --  0ACE .. 0ACF
          (Unassigned, Neutral,
           Other, Other, Other, Unknown,
           (others => False)),
         16#D1# .. 16#DF# =>  --  0AD1 .. 0ADF
          (Unassigned, Neutral,
           Other, Other, Other, Unknown,
           (others => False)),
         16#E2# .. 16#E3# =>  --  0AE2 .. 0AE3
          (Nonspacing_Mark, Neutral,
           Extend, Extend, Extend, Combining_Mark,
           (Other_Alphabetic
              | Alphabetic
              | Case_Ignorable
              | Grapheme_Extend
              | ID_Continue
              | XID_Continue => True,
            others => False)),
         16#E4# .. 16#E5# =>  --  0AE4 .. 0AE5
          (Unassigned, Neutral,
           Other, Other, Other, Unknown,
           (others => False)),
         16#E6# .. 16#EF# =>  --  0AE6 .. 0AEF
          (Decimal_Number, Neutral,
           Other, Numeric, Numeric, Numeric,
           (Grapheme_Base
              | ID_Continue
              | XID_Continue => True,
            others => False)),
         16#F0#           =>  --  0AF0
          (Other_Punctuation, Neutral,
           Other, Other, Other, Alphabetic,
           (Grapheme_Base => True,
            others => False)),
         16#F1#           =>  --  0AF1
          (Currency_Symbol, Neutral,
           Other, Other, Other, Prefix_Numeric,
           (Grapheme_Base => True,
            others => False)),
         16#F2# .. 16#FF# =>  --  0AF2 .. 0AFF
          (Unassigned, Neutral,
           Other, Other, Other, Unknown,
           (others => False)),
         others           =>
          (Other_Letter, Neutral,
           Other, A_Letter, O_Letter, Alphabetic,
           (Alphabetic
              | Grapheme_Base
              | ID_Continue
              | ID_Start
              | XID_Continue
              | XID_Start => True,
            others => False)));

end Matreshka.Internals.Unicode.Ucd.Core_000A;
