------------------------------------------------------------------------------
--                                                                          --
--                            Matreshka Project                             --
--                                                                          --
--        Localization, Internationalization, Globalization for Ada         --
--                                                                          --
--                        Runtime Library Component                         --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2012-2015, Vadim Godunko <vgodunko@gmail.com>                --
-- All rights reserved.                                                     --
--                                                                          --
-- Redistribution and use in source and binary forms, with or without       --
-- modification, are permitted provided that the following conditions       --
-- are met:                                                                 --
--                                                                          --
--  * Redistributions of source code must retain the above copyright        --
--    notice, this list of conditions and the following disclaimer.         --
--                                                                          --
--  * Redistributions in binary form must reproduce the above copyright     --
--    notice, this list of conditions and the following disclaimer in the   --
--    documentation and/or other materials provided with the distribution.  --
--                                                                          --
--  * Neither the name of the Vadim Godunko, IE nor the names of its        --
--    contributors may be used to endorse or promote products derived from  --
--    this software without specific prior written permission.              --
--                                                                          --
-- THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS      --
-- "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT        --
-- LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR    --
-- A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT     --
-- HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,   --
-- SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED --
-- TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR   --
-- PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF   --
-- LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING     --
-- NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS       --
-- SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.             --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 5305 $ $Date: 2015-05-15 23:48:34 +0200 (Fri, 15 May 2015) $
------------------------------------------------------------------------------

pragma Restrictions (No_Elaboration_Code);
--  GNAT: enforce generation of preinitialized data section instead of
--  generation of elaboration code.

package Matreshka.Internals.Unicode.Ucd.Core_0012 is

   pragma Preelaborate;

   Group_0012 : aliased constant Core_Second_Stage
     := (16#49#           =>  --  1249
          (Unassigned, Neutral,
           Other, Other, Other, Unknown,
           (others => False)),
         16#4E# .. 16#4F# =>  --  124E .. 124F
          (Unassigned, Neutral,
           Other, Other, Other, Unknown,
           (others => False)),
         16#57#           =>  --  1257
          (Unassigned, Neutral,
           Other, Other, Other, Unknown,
           (others => False)),
         16#59#           =>  --  1259
          (Unassigned, Neutral,
           Other, Other, Other, Unknown,
           (others => False)),
         16#5E# .. 16#5F# =>  --  125E .. 125F
          (Unassigned, Neutral,
           Other, Other, Other, Unknown,
           (others => False)),
         16#89#           =>  --  1289
          (Unassigned, Neutral,
           Other, Other, Other, Unknown,
           (others => False)),
         16#8E# .. 16#8F# =>  --  128E .. 128F
          (Unassigned, Neutral,
           Other, Other, Other, Unknown,
           (others => False)),
         16#B1#           =>  --  12B1
          (Unassigned, Neutral,
           Other, Other, Other, Unknown,
           (others => False)),
         16#B6# .. 16#B7# =>  --  12B6 .. 12B7
          (Unassigned, Neutral,
           Other, Other, Other, Unknown,
           (others => False)),
         16#BF#           =>  --  12BF
          (Unassigned, Neutral,
           Other, Other, Other, Unknown,
           (others => False)),
         16#C1#           =>  --  12C1
          (Unassigned, Neutral,
           Other, Other, Other, Unknown,
           (others => False)),
         16#C6# .. 16#C7# =>  --  12C6 .. 12C7
          (Unassigned, Neutral,
           Other, Other, Other, Unknown,
           (others => False)),
         16#D7#           =>  --  12D7
          (Unassigned, Neutral,
           Other, Other, Other, Unknown,
           (others => False)),
         others           =>
          (Other_Letter, Neutral,
           Other, A_Letter, O_Letter, Alphabetic,
           (Alphabetic
              | Grapheme_Base
              | ID_Continue
              | ID_Start
              | XID_Continue
              | XID_Start => True,
            others => False)));

end Matreshka.Internals.Unicode.Ucd.Core_0012;
