------------------------------------------------------------------------------
--                                                                          --
--                            Matreshka Project                             --
--                                                                          --
--        Localization, Internationalization, Globalization for Ada         --
--                                                                          --
--                        Runtime Library Component                         --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2012-2015, Vadim Godunko <vgodunko@gmail.com>                --
-- All rights reserved.                                                     --
--                                                                          --
-- Redistribution and use in source and binary forms, with or without       --
-- modification, are permitted provided that the following conditions       --
-- are met:                                                                 --
--                                                                          --
--  * Redistributions of source code must retain the above copyright        --
--    notice, this list of conditions and the following disclaimer.         --
--                                                                          --
--  * Redistributions in binary form must reproduce the above copyright     --
--    notice, this list of conditions and the following disclaimer in the   --
--    documentation and/or other materials provided with the distribution.  --
--                                                                          --
--  * Neither the name of the Vadim Godunko, IE nor the names of its        --
--    contributors may be used to endorse or promote products derived from  --
--    this software without specific prior written permission.              --
--                                                                          --
-- THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS      --
-- "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT        --
-- LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR    --
-- A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT     --
-- HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,   --
-- SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED --
-- TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR   --
-- PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF   --
-- LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING     --
-- NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS       --
-- SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.             --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 5305 $ $Date: 2015-05-15 23:48:34 +0200 (Fri, 15 May 2015) $
------------------------------------------------------------------------------

pragma Restrictions (No_Elaboration_Code);
--  GNAT: enforce generation of preinitialized data section instead of
--  generation of elaboration code.

package Matreshka.Internals.Unicode.Ucd.Core_0031 is

   pragma Preelaborate;

   Group_0031 : aliased constant Core_Second_Stage
     := (16#00# .. 16#04# =>  --  3100 .. 3104
          (Unassigned, Neutral,
           Other, Other, Other, Unknown,
           (others => False)),
         16#05# .. 16#2D# =>  --  3105 .. 312D
          (Other_Letter, Wide,
           Other, A_Letter, O_Letter, Ideographic,
           (Alphabetic
              | Grapheme_Base
              | ID_Continue
              | ID_Start
              | XID_Continue
              | XID_Start => True,
            others => False)),
         16#2E# .. 16#30# =>  --  312E .. 3130
          (Unassigned, Neutral,
           Other, Other, Other, Unknown,
           (others => False)),
         16#64#           =>  --  3164
          (Other_Letter, Wide,
           Other, A_Letter, O_Letter, Ideographic,
           (Other_Default_Ignorable_Code_Point
              | Alphabetic
              | Default_Ignorable_Code_Point
              | Grapheme_Base
              | ID_Continue
              | ID_Start
              | XID_Continue
              | XID_Start
              | Changes_When_NFKC_Casefolded => True,
            others => False)),
         16#8F#           =>  --  318F
          (Unassigned, Neutral,
           Other, Other, Other, Unknown,
           (others => False)),
         16#90# .. 16#91# =>  --  3190 .. 3191
          (Other_Symbol, Wide,
           Other, Other, Other, Ideographic,
           (Grapheme_Base => True,
            others => False)),
         16#92# .. 16#95# =>  --  3192 .. 3195
          (Other_Number, Wide,
           Other, Other, Other, Ideographic,
           (Grapheme_Base
              | Changes_When_NFKC_Casefolded => True,
            others => False)),
         16#96# .. 16#9F# =>  --  3196 .. 319F
          (Other_Symbol, Wide,
           Other, Other, Other, Ideographic,
           (Grapheme_Base
              | Changes_When_NFKC_Casefolded => True,
            others => False)),
         16#A0# .. 16#BA# =>  --  31A0 .. 31BA
          (Other_Letter, Wide,
           Other, A_Letter, O_Letter, Ideographic,
           (Alphabetic
              | Grapheme_Base
              | ID_Continue
              | ID_Start
              | XID_Continue
              | XID_Start => True,
            others => False)),
         16#BB# .. 16#BF# =>  --  31BB .. 31BF
          (Unassigned, Neutral,
           Other, Other, Other, Unknown,
           (others => False)),
         16#C0# .. 16#E3# =>  --  31C0 .. 31E3
          (Other_Symbol, Wide,
           Other, Other, Other, Ideographic,
           (Grapheme_Base => True,
            others => False)),
         16#E4# .. 16#EF# =>  --  31E4 .. 31EF
          (Unassigned, Neutral,
           Other, Other, Other, Unknown,
           (others => False)),
         16#F0# .. 16#FF# =>  --  31F0 .. 31FF
          (Other_Letter, Wide,
           Other, Katakana, O_Letter, Conditional_Japanese_Starter,
           (Alphabetic
              | Grapheme_Base
              | ID_Continue
              | ID_Start
              | XID_Continue
              | XID_Start => True,
            others => False)),
         others           =>
          (Other_Letter, Wide,
           Other, A_Letter, O_Letter, Ideographic,
           (Alphabetic
              | Grapheme_Base
              | ID_Continue
              | ID_Start
              | XID_Continue
              | XID_Start
              | Changes_When_NFKC_Casefolded => True,
            others => False)));

end Matreshka.Internals.Unicode.Ucd.Core_0031;
