------------------------------------------------------------------------------
--                                                                          --
--                            Matreshka Project                             --
--                                                                          --
--        Localization, Internationalization, Globalization for Ada         --
--                                                                          --
--                        Runtime Library Component                         --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2011, Vadim Godunko <vgodunko@gmail.com>                     --
-- All rights reserved.                                                     --
--                                                                          --
-- Redistribution and use in source and binary forms, with or without       --
-- modification, are permitted provided that the following conditions       --
-- are met:                                                                 --
--                                                                          --
--  * Redistributions of source code must retain the above copyright        --
--    notice, this list of conditions and the following disclaimer.         --
--                                                                          --
--  * Redistributions in binary form must reproduce the above copyright     --
--    notice, this list of conditions and the following disclaimer in the   --
--    documentation and/or other materials provided with the distribution.  --
--                                                                          --
--  * Neither the name of the Vadim Godunko, IE nor the names of its        --
--    contributors may be used to endorse or promote products derived from  --
--    this software without specific prior written permission.              --
--                                                                          --
-- THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS      --
-- "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT        --
-- LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR    --
-- A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT     --
-- HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,   --
-- SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED --
-- TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR   --
-- PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF   --
-- LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING     --
-- NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS       --
-- SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.             --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 5307 $ $Date: 2015-05-16 00:04:40 +0200 (Sat, 16 May 2015) $
------------------------------------------------------------------------------

pragma Restrictions (No_Elaboration_Code);
--  GNAT: enforce generation of preinitialized data section instead of
--  generation of elaboration code.

package Matreshka.Internals.Unicode.Ucd.Indexes is

   pragma Preelaborate;

   Group_Index : constant array (First_Stage_Index) of First_Stage_Index
     := (16#0000# => 16#0000#, 16#0001# => 16#0001#, 16#0002# => 16#0002#,
         16#0003# => 16#0003#, 16#0004# => 16#0004#, 16#0005# => 16#0005#,
         16#0006# => 16#0006#, 16#0007# => 16#0007#, 16#0008# => 16#0008#,
         16#0009# => 16#0009#, 16#000A# => 16#000A#, 16#000B# => 16#000B#,
         16#000C# => 16#000C#, 16#000D# => 16#000D#, 16#000E# => 16#000E#,
         16#000F# => 16#000F#, 16#0010# => 16#0010#, 16#0011# => 16#0011#,
         16#0012# => 16#0012#, 16#0013# => 16#0013#, 16#0014# => 16#0014#,
         16#0015# => 16#0015#, 16#0016# => 16#0016#, 16#0017# => 16#0017#,
         16#0018# => 16#0018#, 16#0019# => 16#0019#, 16#001A# => 16#001A#,
         16#001B# => 16#001B#, 16#001C# => 16#001C#, 16#001D# => 16#001D#,
         16#001E# => 16#001E#, 16#001F# => 16#001F#, 16#0020# => 16#0020#,
         16#0021# => 16#0021#, 16#0022# => 16#0022#, 16#0023# => 16#0023#,
         16#0024# => 16#0024#, 16#0025# => 16#0025#, 16#0026# => 16#0026#,
         16#0027# => 16#0027#, 16#0028# => 16#0028#, 16#0029# => 16#0029#,
         16#002A# => 16#002A#, 16#002B# => 16#002B#, 16#002C# => 16#002C#,
         16#002D# => 16#002D#, 16#002E# => 16#002E#, 16#002F# => 16#002F#,
         16#0030# => 16#0030#, 16#0031# => 16#0031#, 16#0032# => 16#0032#,
         16#0033# => 16#0033#, 16#0034# => 16#0034#, 16#0035# => 16#0034#,
         16#0036# => 16#0034#, 16#0037# => 16#0034#, 16#0038# => 16#0034#,
         16#0039# => 16#0034#, 16#003A# => 16#0034#, 16#003B# => 16#0034#,
         16#003C# => 16#0034#, 16#003D# => 16#0034#, 16#003E# => 16#0034#,
         16#003F# => 16#0034#, 16#0040# => 16#0034#, 16#0041# => 16#0034#,
         16#0042# => 16#0034#, 16#0043# => 16#0034#, 16#0044# => 16#0034#,
         16#0045# => 16#0034#, 16#0046# => 16#0034#, 16#0047# => 16#0034#,
         16#0048# => 16#0034#, 16#0049# => 16#0034#, 16#004A# => 16#0034#,
         16#004B# => 16#0034#, 16#004C# => 16#0034#, 16#004D# => 16#0035#,
         16#004E# => 16#0034#, 16#004F# => 16#0034#, 16#0050# => 16#0034#,
         16#0051# => 16#0034#, 16#0052# => 16#0034#, 16#0053# => 16#0034#,
         16#0054# => 16#0034#, 16#0055# => 16#0034#, 16#0056# => 16#0034#,
         16#0057# => 16#0034#, 16#0058# => 16#0034#, 16#0059# => 16#0034#,
         16#005A# => 16#0034#, 16#005B# => 16#0034#, 16#005C# => 16#0034#,
         16#005D# => 16#0034#, 16#005E# => 16#0034#, 16#005F# => 16#0034#,
         16#0060# => 16#0034#, 16#0061# => 16#0034#, 16#0062# => 16#0034#,
         16#0063# => 16#0034#, 16#0064# => 16#0034#, 16#0065# => 16#0034#,
         16#0066# => 16#0034#, 16#0067# => 16#0034#, 16#0068# => 16#0034#,
         16#0069# => 16#0034#, 16#006A# => 16#0034#, 16#006B# => 16#0034#,
         16#006C# => 16#0034#, 16#006D# => 16#0034#, 16#006E# => 16#0034#,
         16#006F# => 16#0034#, 16#0070# => 16#0034#, 16#0071# => 16#0034#,
         16#0072# => 16#0034#, 16#0073# => 16#0034#, 16#0074# => 16#0034#,
         16#0075# => 16#0034#, 16#0076# => 16#0034#, 16#0077# => 16#0034#,
         16#0078# => 16#0034#, 16#0079# => 16#0034#, 16#007A# => 16#0034#,
         16#007B# => 16#0034#, 16#007C# => 16#0034#, 16#007D# => 16#0034#,
         16#007E# => 16#0034#, 16#007F# => 16#0034#, 16#0080# => 16#0034#,
         16#0081# => 16#0034#, 16#0082# => 16#0034#, 16#0083# => 16#0034#,
         16#0084# => 16#0034#, 16#0085# => 16#0034#, 16#0086# => 16#0034#,
         16#0087# => 16#0034#, 16#0088# => 16#0034#, 16#0089# => 16#0034#,
         16#008A# => 16#0034#, 16#008B# => 16#0034#, 16#008C# => 16#0034#,
         16#008D# => 16#0034#, 16#008E# => 16#0034#, 16#008F# => 16#0034#,
         16#0090# => 16#0034#, 16#0091# => 16#0034#, 16#0092# => 16#0034#,
         16#0093# => 16#0034#, 16#0094# => 16#0034#, 16#0095# => 16#0034#,
         16#0096# => 16#0034#, 16#0097# => 16#0034#, 16#0098# => 16#0034#,
         16#0099# => 16#0034#, 16#009A# => 16#0034#, 16#009B# => 16#0034#,
         16#009C# => 16#0034#, 16#009D# => 16#0034#, 16#009E# => 16#0034#,
         16#009F# => 16#0036#, 16#00A0# => 16#0037#, 16#00A1# => 16#0038#,
         16#00A2# => 16#0038#, 16#00A3# => 16#0038#, 16#00A4# => 16#0039#,
         16#00A5# => 16#0015#, 16#00A6# => 16#003A#, 16#00A7# => 16#003B#,
         16#00A8# => 16#003C#, 16#00A9# => 16#003D#, 16#00AA# => 16#003E#,
         16#00AB# => 16#003F#, 16#00AC# => 16#0040#, 16#00AD# => 16#0041#,
         16#00AE# => 16#0042#, 16#00AF# => 16#0043#, 16#00B0# => 16#0044#,
         16#00B1# => 16#0045#, 16#00B2# => 16#0046#, 16#00B3# => 16#0040#,
         16#00B4# => 16#0041#, 16#00B5# => 16#0042#, 16#00B6# => 16#0043#,
         16#00B7# => 16#0044#, 16#00B8# => 16#0045#, 16#00B9# => 16#0046#,
         16#00BA# => 16#0040#, 16#00BB# => 16#0041#, 16#00BC# => 16#0042#,
         16#00BD# => 16#0043#, 16#00BE# => 16#0044#, 16#00BF# => 16#0045#,
         16#00C0# => 16#0046#, 16#00C1# => 16#0040#, 16#00C2# => 16#0041#,
         16#00C3# => 16#0042#, 16#00C4# => 16#0043#, 16#00C5# => 16#0044#,
         16#00C6# => 16#0045#, 16#00C7# => 16#0046#, 16#00C8# => 16#0040#,
         16#00C9# => 16#0041#, 16#00CA# => 16#0042#, 16#00CB# => 16#0043#,
         16#00CC# => 16#0044#, 16#00CD# => 16#0045#, 16#00CE# => 16#0046#,
         16#00CF# => 16#0040#, 16#00D0# => 16#0041#, 16#00D1# => 16#0042#,
         16#00D2# => 16#0043#, 16#00D3# => 16#0044#, 16#00D4# => 16#0045#,
         16#00D5# => 16#0046#, 16#00D6# => 16#0040#, 16#00D7# => 16#0047#,
         16#00D8# => 16#0048#, 16#00D9# => 16#0048#, 16#00DA# => 16#0048#,
         16#00DB# => 16#0048#, 16#00DC# => 16#0048#, 16#00DD# => 16#0048#,
         16#00DE# => 16#0048#, 16#00DF# => 16#0048#, 16#00E0# => 16#0049#,
         16#00E1# => 16#0049#, 16#00E2# => 16#0049#, 16#00E3# => 16#0049#,
         16#00E4# => 16#0049#, 16#00E5# => 16#0049#, 16#00E6# => 16#0049#,
         16#00E7# => 16#0049#, 16#00E8# => 16#0049#, 16#00E9# => 16#0049#,
         16#00EA# => 16#0049#, 16#00EB# => 16#0049#, 16#00EC# => 16#0049#,
         16#00ED# => 16#0049#, 16#00EE# => 16#0049#, 16#00EF# => 16#0049#,
         16#00F0# => 16#0049#, 16#00F1# => 16#0049#, 16#00F2# => 16#0049#,
         16#00F3# => 16#0049#, 16#00F4# => 16#0049#, 16#00F5# => 16#0049#,
         16#00F6# => 16#0049#, 16#00F7# => 16#0049#, 16#00F8# => 16#0049#,
         16#00F9# => 16#004A#, 16#00FA# => 16#004B#, 16#00FB# => 16#004C#,
         16#00FC# => 16#004D#, 16#00FD# => 16#004E#, 16#00FE# => 16#004F#,
         16#00FF# => 16#0050#, 16#0100# => 16#0051#, 16#0101# => 16#0052#,
         16#0102# => 16#0053#, 16#0103# => 16#0054#, 16#0104# => 16#0055#,
         16#0105# => 16#0056#, 16#0106# => 16#0015#, 16#0107# => 16#0057#,
         16#0108# => 16#0058#, 16#0109# => 16#0059#, 16#010A# => 16#005A#,
         16#010B# => 16#005B#, 16#010C# => 16#005C#, 16#010E# => 16#005E#,
         16#0110# => 16#005F#, 16#0111# => 16#0060#, 16#0112# => 16#0061#,
         16#0113# => 16#0062#, 16#0114# => 16#0063#, 16#0115# => 16#0064#,
         16#0116# => 16#0065#, 16#0118# => 16#0066#, 16#011A# => 16#0067#,
         16#0120# => 16#0015#, 16#0121# => 16#0015#, 16#0122# => 16#0015#,
         16#0123# => 16#0068#, 16#0124# => 16#0069#, 16#0130# => 16#0015#,
         16#0131# => 16#0015#, 16#0132# => 16#006A#, 16#0133# => 16#006B#,
         16#0134# => 16#006C#, 16#0168# => 16#0015#, 16#0169# => 16#0015#,
         16#016A# => 16#006D#, 16#016B# => 16#006E#, 16#016F# => 16#006F#,
         16#01B0# => 16#0070#, 16#01BC# => 16#0071#, 16#01D0# => 16#0072#,
         16#01D1# => 16#0073#, 16#01D2# => 16#0074#, 16#01D3# => 16#0075#,
         16#01D4# => 16#0076#, 16#01D5# => 16#0077#, 16#01D6# => 16#0078#,
         16#01D7# => 16#0079#, 16#01E8# => 16#007A#, 16#01EE# => 16#007B#,
         16#01F0# => 16#007C#, 16#01F1# => 16#007D#, 16#01F2# => 16#007E#,
         16#01F3# => 16#007F#, 16#01F4# => 16#0080#, 16#01F5# => 16#0081#,
         16#01F6# => 16#0082#, 16#01F7# => 16#0083#, 16#01F8# => 16#0084#,
         16#01FF# => 16#0085#, 16#0200# => 16#0034#, 16#0201# => 16#0034#,
         16#0202# => 16#0034#, 16#0203# => 16#0034#, 16#0204# => 16#0034#,
         16#0205# => 16#0034#, 16#0206# => 16#0034#, 16#0207# => 16#0034#,
         16#0208# => 16#0034#, 16#0209# => 16#0034#, 16#020A# => 16#0034#,
         16#020B# => 16#0034#, 16#020C# => 16#0034#, 16#020D# => 16#0034#,
         16#020E# => 16#0034#, 16#020F# => 16#0034#, 16#0210# => 16#0034#,
         16#0211# => 16#0034#, 16#0212# => 16#0034#, 16#0213# => 16#0034#,
         16#0214# => 16#0034#, 16#0215# => 16#0034#, 16#0216# => 16#0034#,
         16#0217# => 16#0034#, 16#0218# => 16#0034#, 16#0219# => 16#0034#,
         16#021A# => 16#0034#, 16#021B# => 16#0034#, 16#021C# => 16#0034#,
         16#021D# => 16#0034#, 16#021E# => 16#0034#, 16#021F# => 16#0034#,
         16#0220# => 16#0034#, 16#0221# => 16#0034#, 16#0222# => 16#0034#,
         16#0223# => 16#0034#, 16#0224# => 16#0034#, 16#0225# => 16#0034#,
         16#0226# => 16#0034#, 16#0227# => 16#0034#, 16#0228# => 16#0034#,
         16#0229# => 16#0034#, 16#022A# => 16#0034#, 16#022B# => 16#0034#,
         16#022C# => 16#0034#, 16#022D# => 16#0034#, 16#022E# => 16#0034#,
         16#022F# => 16#0034#, 16#0230# => 16#0034#, 16#0231# => 16#0034#,
         16#0232# => 16#0034#, 16#0233# => 16#0034#, 16#0234# => 16#0034#,
         16#0235# => 16#0034#, 16#0236# => 16#0034#, 16#0237# => 16#0034#,
         16#0238# => 16#0034#, 16#0239# => 16#0034#, 16#023A# => 16#0034#,
         16#023B# => 16#0034#, 16#023C# => 16#0034#, 16#023D# => 16#0034#,
         16#023E# => 16#0034#, 16#023F# => 16#0034#, 16#0240# => 16#0034#,
         16#0241# => 16#0034#, 16#0242# => 16#0034#, 16#0243# => 16#0034#,
         16#0244# => 16#0034#, 16#0245# => 16#0034#, 16#0246# => 16#0034#,
         16#0247# => 16#0034#, 16#0248# => 16#0034#, 16#0249# => 16#0034#,
         16#024A# => 16#0034#, 16#024B# => 16#0034#, 16#024C# => 16#0034#,
         16#024D# => 16#0034#, 16#024E# => 16#0034#, 16#024F# => 16#0034#,
         16#0250# => 16#0034#, 16#0251# => 16#0034#, 16#0252# => 16#0034#,
         16#0253# => 16#0034#, 16#0254# => 16#0034#, 16#0255# => 16#0034#,
         16#0256# => 16#0034#, 16#0257# => 16#0034#, 16#0258# => 16#0034#,
         16#0259# => 16#0034#, 16#025A# => 16#0034#, 16#025B# => 16#0034#,
         16#025C# => 16#0034#, 16#025D# => 16#0034#, 16#025E# => 16#0034#,
         16#025F# => 16#0034#, 16#0260# => 16#0034#, 16#0261# => 16#0034#,
         16#0262# => 16#0034#, 16#0263# => 16#0034#, 16#0264# => 16#0034#,
         16#0265# => 16#0034#, 16#0266# => 16#0034#, 16#0267# => 16#0034#,
         16#0268# => 16#0034#, 16#0269# => 16#0034#, 16#026A# => 16#0034#,
         16#026B# => 16#0034#, 16#026C# => 16#0034#, 16#026D# => 16#0034#,
         16#026E# => 16#0034#, 16#026F# => 16#0034#, 16#0270# => 16#0034#,
         16#0271# => 16#0034#, 16#0272# => 16#0034#, 16#0273# => 16#0034#,
         16#0274# => 16#0034#, 16#0275# => 16#0034#, 16#0276# => 16#0034#,
         16#0277# => 16#0034#, 16#0278# => 16#0034#, 16#0279# => 16#0034#,
         16#027A# => 16#0034#, 16#027B# => 16#0034#, 16#027C# => 16#0034#,
         16#027D# => 16#0034#, 16#027E# => 16#0034#, 16#027F# => 16#0034#,
         16#0280# => 16#0034#, 16#0281# => 16#0034#, 16#0282# => 16#0034#,
         16#0283# => 16#0034#, 16#0284# => 16#0034#, 16#0285# => 16#0034#,
         16#0286# => 16#0034#, 16#0287# => 16#0034#, 16#0288# => 16#0034#,
         16#0289# => 16#0034#, 16#028A# => 16#0034#, 16#028B# => 16#0034#,
         16#028C# => 16#0034#, 16#028D# => 16#0034#, 16#028E# => 16#0034#,
         16#028F# => 16#0034#, 16#0290# => 16#0034#, 16#0291# => 16#0034#,
         16#0292# => 16#0034#, 16#0293# => 16#0034#, 16#0294# => 16#0034#,
         16#0295# => 16#0034#, 16#0296# => 16#0034#, 16#0297# => 16#0034#,
         16#0298# => 16#0034#, 16#0299# => 16#0034#, 16#029A# => 16#0034#,
         16#029B# => 16#0034#, 16#029C# => 16#0034#, 16#029D# => 16#0034#,
         16#029E# => 16#0034#, 16#029F# => 16#0034#, 16#02A0# => 16#0034#,
         16#02A1# => 16#0034#, 16#02A2# => 16#0034#, 16#02A3# => 16#0034#,
         16#02A4# => 16#0034#, 16#02A5# => 16#0034#, 16#02A6# => 16#0086#,
         16#02A7# => 16#0034#, 16#02A8# => 16#0034#, 16#02A9# => 16#0034#,
         16#02AA# => 16#0034#, 16#02AB# => 16#0034#, 16#02AC# => 16#0034#,
         16#02AD# => 16#0034#, 16#02AE# => 16#0034#, 16#02AF# => 16#0034#,
         16#02B0# => 16#0034#, 16#02B1# => 16#0034#, 16#02B2# => 16#0034#,
         16#02B3# => 16#0034#, 16#02B4# => 16#0034#, 16#02B5# => 16#0034#,
         16#02B6# => 16#0034#, 16#02B7# => 16#0087#, 16#02B8# => 16#0088#,
         16#02B9# => 16#0089#, 16#02BA# => 16#0089#, 16#02BB# => 16#0089#,
         16#02BC# => 16#0089#, 16#02BD# => 16#0089#, 16#02BE# => 16#0089#,
         16#02BF# => 16#0089#, 16#02C0# => 16#0089#, 16#02C1# => 16#0089#,
         16#02C2# => 16#0089#, 16#02C3# => 16#0089#, 16#02C4# => 16#0089#,
         16#02C5# => 16#0089#, 16#02C6# => 16#0089#, 16#02C7# => 16#0089#,
         16#02C8# => 16#0089#, 16#02C9# => 16#0089#, 16#02CA# => 16#0089#,
         16#02CB# => 16#0089#, 16#02CC# => 16#0089#, 16#02CD# => 16#0089#,
         16#02CE# => 16#0089#, 16#02CF# => 16#0089#, 16#02D0# => 16#0089#,
         16#02D1# => 16#0089#, 16#02D2# => 16#0089#, 16#02D3# => 16#0089#,
         16#02D4# => 16#0089#, 16#02D5# => 16#0089#, 16#02D6# => 16#0089#,
         16#02D7# => 16#0089#, 16#02D8# => 16#0089#, 16#02D9# => 16#0089#,
         16#02DA# => 16#0089#, 16#02DB# => 16#0089#, 16#02DC# => 16#0089#,
         16#02DD# => 16#0089#, 16#02DE# => 16#0089#, 16#02DF# => 16#0089#,
         16#02E0# => 16#0089#, 16#02E1# => 16#0089#, 16#02E2# => 16#0089#,
         16#02E3# => 16#0089#, 16#02E4# => 16#0089#, 16#02E5# => 16#0089#,
         16#02E6# => 16#0089#, 16#02E7# => 16#0089#, 16#02E8# => 16#0089#,
         16#02E9# => 16#0089#, 16#02EA# => 16#0089#, 16#02EB# => 16#0089#,
         16#02EC# => 16#0089#, 16#02ED# => 16#0089#, 16#02EE# => 16#0089#,
         16#02EF# => 16#0089#, 16#02F0# => 16#0089#, 16#02F1# => 16#0089#,
         16#02F2# => 16#0089#, 16#02F3# => 16#0089#, 16#02F4# => 16#0089#,
         16#02F5# => 16#0089#, 16#02F6# => 16#0089#, 16#02F7# => 16#0089#,
         16#02F8# => 16#004A#, 16#02F9# => 16#004A#, 16#02FA# => 16#008A#,
         16#02FB# => 16#0089#, 16#02FC# => 16#0089#, 16#02FD# => 16#0089#,
         16#02FE# => 16#0089#, 16#02FF# => 16#008B#, 16#0300# => 16#0089#,
         16#0301# => 16#0089#, 16#0302# => 16#0089#, 16#0303# => 16#0089#,
         16#0304# => 16#0089#, 16#0305# => 16#0089#, 16#0306# => 16#0089#,
         16#0307# => 16#0089#, 16#0308# => 16#0089#, 16#0309# => 16#0089#,
         16#030A# => 16#0089#, 16#030B# => 16#0089#, 16#030C# => 16#0089#,
         16#030D# => 16#0089#, 16#030E# => 16#0089#, 16#030F# => 16#0089#,
         16#0310# => 16#0089#, 16#0311# => 16#0089#, 16#0312# => 16#0089#,
         16#0313# => 16#0089#, 16#0314# => 16#0089#, 16#0315# => 16#0089#,
         16#0316# => 16#0089#, 16#0317# => 16#0089#, 16#0318# => 16#0089#,
         16#0319# => 16#0089#, 16#031A# => 16#0089#, 16#031B# => 16#0089#,
         16#031C# => 16#0089#, 16#031D# => 16#0089#, 16#031E# => 16#0089#,
         16#031F# => 16#0089#, 16#0320# => 16#0089#, 16#0321# => 16#0089#,
         16#0322# => 16#0089#, 16#0323# => 16#0089#, 16#0324# => 16#0089#,
         16#0325# => 16#0089#, 16#0326# => 16#0089#, 16#0327# => 16#0089#,
         16#0328# => 16#0089#, 16#0329# => 16#0089#, 16#032A# => 16#0089#,
         16#032B# => 16#0089#, 16#032C# => 16#0089#, 16#032D# => 16#0089#,
         16#032E# => 16#0089#, 16#032F# => 16#0089#, 16#0330# => 16#0089#,
         16#0331# => 16#0089#, 16#0332# => 16#0089#, 16#0333# => 16#0089#,
         16#0334# => 16#0089#, 16#0335# => 16#0089#, 16#0336# => 16#0089#,
         16#0337# => 16#0089#, 16#0338# => 16#0089#, 16#0339# => 16#0089#,
         16#033A# => 16#0089#, 16#033B# => 16#0089#, 16#033C# => 16#0089#,
         16#033D# => 16#0089#, 16#033E# => 16#0089#, 16#033F# => 16#0089#,
         16#0340# => 16#0089#, 16#0341# => 16#0089#, 16#0342# => 16#0089#,
         16#0343# => 16#0089#, 16#0344# => 16#0089#, 16#0345# => 16#0089#,
         16#0346# => 16#0089#, 16#0347# => 16#0089#, 16#0348# => 16#0089#,
         16#0349# => 16#0089#, 16#034A# => 16#0089#, 16#034B# => 16#0089#,
         16#034C# => 16#0089#, 16#034D# => 16#0089#, 16#034E# => 16#0089#,
         16#034F# => 16#0089#, 16#0350# => 16#0089#, 16#0351# => 16#0089#,
         16#0352# => 16#0089#, 16#0353# => 16#0089#, 16#0354# => 16#0089#,
         16#0355# => 16#0089#, 16#0356# => 16#0089#, 16#0357# => 16#0089#,
         16#0358# => 16#0089#, 16#0359# => 16#0089#, 16#035A# => 16#0089#,
         16#035B# => 16#0089#, 16#035C# => 16#0089#, 16#035D# => 16#0089#,
         16#035E# => 16#0089#, 16#035F# => 16#0089#, 16#0360# => 16#0089#,
         16#0361# => 16#0089#, 16#0362# => 16#0089#, 16#0363# => 16#0089#,
         16#0364# => 16#0089#, 16#0365# => 16#0089#, 16#0366# => 16#0089#,
         16#0367# => 16#0089#, 16#0368# => 16#0089#, 16#0369# => 16#0089#,
         16#036A# => 16#0089#, 16#036B# => 16#0089#, 16#036C# => 16#0089#,
         16#036D# => 16#0089#, 16#036E# => 16#0089#, 16#036F# => 16#0089#,
         16#0370# => 16#0089#, 16#0371# => 16#0089#, 16#0372# => 16#0089#,
         16#0373# => 16#0089#, 16#0374# => 16#0089#, 16#0375# => 16#0089#,
         16#0376# => 16#0089#, 16#0377# => 16#0089#, 16#0378# => 16#0089#,
         16#0379# => 16#0089#, 16#037A# => 16#0089#, 16#037B# => 16#0089#,
         16#037C# => 16#0089#, 16#037D# => 16#0089#, 16#037E# => 16#0089#,
         16#037F# => 16#0089#, 16#0380# => 16#0089#, 16#0381# => 16#0089#,
         16#0382# => 16#0089#, 16#0383# => 16#0089#, 16#0384# => 16#0089#,
         16#0385# => 16#0089#, 16#0386# => 16#0089#, 16#0387# => 16#0089#,
         16#0388# => 16#0089#, 16#0389# => 16#0089#, 16#038A# => 16#0089#,
         16#038B# => 16#0089#, 16#038C# => 16#0089#, 16#038D# => 16#0089#,
         16#038E# => 16#0089#, 16#038F# => 16#0089#, 16#0390# => 16#0089#,
         16#0391# => 16#0089#, 16#0392# => 16#0089#, 16#0393# => 16#0089#,
         16#0394# => 16#0089#, 16#0395# => 16#0089#, 16#0396# => 16#0089#,
         16#0397# => 16#0089#, 16#0398# => 16#0089#, 16#0399# => 16#0089#,
         16#039A# => 16#0089#, 16#039B# => 16#0089#, 16#039C# => 16#0089#,
         16#039D# => 16#0089#, 16#039E# => 16#0089#, 16#039F# => 16#0089#,
         16#03A0# => 16#0089#, 16#03A1# => 16#0089#, 16#03A2# => 16#0089#,
         16#03A3# => 16#0089#, 16#03A4# => 16#0089#, 16#03A5# => 16#0089#,
         16#03A6# => 16#0089#, 16#03A7# => 16#0089#, 16#03A8# => 16#0089#,
         16#03A9# => 16#0089#, 16#03AA# => 16#0089#, 16#03AB# => 16#0089#,
         16#03AC# => 16#0089#, 16#03AD# => 16#0089#, 16#03AE# => 16#0089#,
         16#03AF# => 16#0089#, 16#03B0# => 16#0089#, 16#03B1# => 16#0089#,
         16#03B2# => 16#0089#, 16#03B3# => 16#0089#, 16#03B4# => 16#0089#,
         16#03B5# => 16#0089#, 16#03B6# => 16#0089#, 16#03B7# => 16#0089#,
         16#03B8# => 16#0089#, 16#03B9# => 16#0089#, 16#03BA# => 16#0089#,
         16#03BB# => 16#0089#, 16#03BC# => 16#0089#, 16#03BD# => 16#0089#,
         16#03BE# => 16#0089#, 16#03BF# => 16#0089#, 16#03C0# => 16#0089#,
         16#03C1# => 16#0089#, 16#03C2# => 16#0089#, 16#03C3# => 16#0089#,
         16#03C4# => 16#0089#, 16#03C5# => 16#0089#, 16#03C6# => 16#0089#,
         16#03C7# => 16#0089#, 16#03C8# => 16#0089#, 16#03C9# => 16#0089#,
         16#03CA# => 16#0089#, 16#03CB# => 16#0089#, 16#03CC# => 16#0089#,
         16#03CD# => 16#0089#, 16#03CE# => 16#0089#, 16#03CF# => 16#0089#,
         16#03D0# => 16#0089#, 16#03D1# => 16#0089#, 16#03D2# => 16#0089#,
         16#03D3# => 16#0089#, 16#03D4# => 16#0089#, 16#03D5# => 16#0089#,
         16#03D6# => 16#0089#, 16#03D7# => 16#0089#, 16#03D8# => 16#0089#,
         16#03D9# => 16#0089#, 16#03DA# => 16#0089#, 16#03DB# => 16#0089#,
         16#03DC# => 16#0089#, 16#03DD# => 16#0089#, 16#03DE# => 16#0089#,
         16#03DF# => 16#0089#, 16#03E0# => 16#0089#, 16#03E1# => 16#0089#,
         16#03E2# => 16#0089#, 16#03E3# => 16#0089#, 16#03E4# => 16#0089#,
         16#03E5# => 16#0089#, 16#03E6# => 16#0089#, 16#03E7# => 16#0089#,
         16#03E8# => 16#0089#, 16#03E9# => 16#0089#, 16#03EA# => 16#0089#,
         16#03EB# => 16#0089#, 16#03EC# => 16#0089#, 16#03ED# => 16#0089#,
         16#03EE# => 16#0089#, 16#03EF# => 16#0089#, 16#03F0# => 16#0089#,
         16#03F1# => 16#0089#, 16#03F2# => 16#0089#, 16#03F3# => 16#0089#,
         16#03F4# => 16#0089#, 16#03F5# => 16#0089#, 16#03F6# => 16#0089#,
         16#03F7# => 16#0089#, 16#03F8# => 16#0089#, 16#03F9# => 16#0089#,
         16#03FA# => 16#0089#, 16#03FB# => 16#0089#, 16#03FC# => 16#0089#,
         16#03FD# => 16#0089#, 16#03FE# => 16#0089#, 16#03FF# => 16#008B#,
         16#04FF# => 16#0085#, 16#05FF# => 16#0085#, 16#06FF# => 16#0085#,
         16#07FF# => 16#0085#, 16#08FF# => 16#0085#, 16#09FF# => 16#0085#,
         16#0AFF# => 16#0085#, 16#0BFF# => 16#0085#, 16#0CFF# => 16#0085#,
         16#0DFF# => 16#0085#, 16#0E00# => 16#008C#, 16#0E01# => 16#008D#,
         16#0E02# => 16#008E#, 16#0E03# => 16#008E#, 16#0E04# => 16#008E#,
         16#0E05# => 16#008E#, 16#0E06# => 16#008E#, 16#0E07# => 16#008E#,
         16#0E08# => 16#008E#, 16#0E09# => 16#008E#, 16#0E0A# => 16#008E#,
         16#0E0B# => 16#008E#, 16#0E0C# => 16#008E#, 16#0E0D# => 16#008E#,
         16#0E0E# => 16#008E#, 16#0E0F# => 16#008E#, 16#0EFF# => 16#0085#,
         16#0F00# => 16#0049#, 16#0F01# => 16#0049#, 16#0F02# => 16#0049#,
         16#0F03# => 16#0049#, 16#0F04# => 16#0049#, 16#0F05# => 16#0049#,
         16#0F06# => 16#0049#, 16#0F07# => 16#0049#, 16#0F08# => 16#0049#,
         16#0F09# => 16#0049#, 16#0F0A# => 16#0049#, 16#0F0B# => 16#0049#,
         16#0F0C# => 16#0049#, 16#0F0D# => 16#0049#, 16#0F0E# => 16#0049#,
         16#0F0F# => 16#0049#, 16#0F10# => 16#0049#, 16#0F11# => 16#0049#,
         16#0F12# => 16#0049#, 16#0F13# => 16#0049#, 16#0F14# => 16#0049#,
         16#0F15# => 16#0049#, 16#0F16# => 16#0049#, 16#0F17# => 16#0049#,
         16#0F18# => 16#0049#, 16#0F19# => 16#0049#, 16#0F1A# => 16#0049#,
         16#0F1B# => 16#0049#, 16#0F1C# => 16#0049#, 16#0F1D# => 16#0049#,
         16#0F1E# => 16#0049#, 16#0F1F# => 16#0049#, 16#0F20# => 16#0049#,
         16#0F21# => 16#0049#, 16#0F22# => 16#0049#, 16#0F23# => 16#0049#,
         16#0F24# => 16#0049#, 16#0F25# => 16#0049#, 16#0F26# => 16#0049#,
         16#0F27# => 16#0049#, 16#0F28# => 16#0049#, 16#0F29# => 16#0049#,
         16#0F2A# => 16#0049#, 16#0F2B# => 16#0049#, 16#0F2C# => 16#0049#,
         16#0F2D# => 16#0049#, 16#0F2E# => 16#0049#, 16#0F2F# => 16#0049#,
         16#0F30# => 16#0049#, 16#0F31# => 16#0049#, 16#0F32# => 16#0049#,
         16#0F33# => 16#0049#, 16#0F34# => 16#0049#, 16#0F35# => 16#0049#,
         16#0F36# => 16#0049#, 16#0F37# => 16#0049#, 16#0F38# => 16#0049#,
         16#0F39# => 16#0049#, 16#0F3A# => 16#0049#, 16#0F3B# => 16#0049#,
         16#0F3C# => 16#0049#, 16#0F3D# => 16#0049#, 16#0F3E# => 16#0049#,
         16#0F3F# => 16#0049#, 16#0F40# => 16#0049#, 16#0F41# => 16#0049#,
         16#0F42# => 16#0049#, 16#0F43# => 16#0049#, 16#0F44# => 16#0049#,
         16#0F45# => 16#0049#, 16#0F46# => 16#0049#, 16#0F47# => 16#0049#,
         16#0F48# => 16#0049#, 16#0F49# => 16#0049#, 16#0F4A# => 16#0049#,
         16#0F4B# => 16#0049#, 16#0F4C# => 16#0049#, 16#0F4D# => 16#0049#,
         16#0F4E# => 16#0049#, 16#0F4F# => 16#0049#, 16#0F50# => 16#0049#,
         16#0F51# => 16#0049#, 16#0F52# => 16#0049#, 16#0F53# => 16#0049#,
         16#0F54# => 16#0049#, 16#0F55# => 16#0049#, 16#0F56# => 16#0049#,
         16#0F57# => 16#0049#, 16#0F58# => 16#0049#, 16#0F59# => 16#0049#,
         16#0F5A# => 16#0049#, 16#0F5B# => 16#0049#, 16#0F5C# => 16#0049#,
         16#0F5D# => 16#0049#, 16#0F5E# => 16#0049#, 16#0F5F# => 16#0049#,
         16#0F60# => 16#0049#, 16#0F61# => 16#0049#, 16#0F62# => 16#0049#,
         16#0F63# => 16#0049#, 16#0F64# => 16#0049#, 16#0F65# => 16#0049#,
         16#0F66# => 16#0049#, 16#0F67# => 16#0049#, 16#0F68# => 16#0049#,
         16#0F69# => 16#0049#, 16#0F6A# => 16#0049#, 16#0F6B# => 16#0049#,
         16#0F6C# => 16#0049#, 16#0F6D# => 16#0049#, 16#0F6E# => 16#0049#,
         16#0F6F# => 16#0049#, 16#0F70# => 16#0049#, 16#0F71# => 16#0049#,
         16#0F72# => 16#0049#, 16#0F73# => 16#0049#, 16#0F74# => 16#0049#,
         16#0F75# => 16#0049#, 16#0F76# => 16#0049#, 16#0F77# => 16#0049#,
         16#0F78# => 16#0049#, 16#0F79# => 16#0049#, 16#0F7A# => 16#0049#,
         16#0F7B# => 16#0049#, 16#0F7C# => 16#0049#, 16#0F7D# => 16#0049#,
         16#0F7E# => 16#0049#, 16#0F7F# => 16#0049#, 16#0F80# => 16#0049#,
         16#0F81# => 16#0049#, 16#0F82# => 16#0049#, 16#0F83# => 16#0049#,
         16#0F84# => 16#0049#, 16#0F85# => 16#0049#, 16#0F86# => 16#0049#,
         16#0F87# => 16#0049#, 16#0F88# => 16#0049#, 16#0F89# => 16#0049#,
         16#0F8A# => 16#0049#, 16#0F8B# => 16#0049#, 16#0F8C# => 16#0049#,
         16#0F8D# => 16#0049#, 16#0F8E# => 16#0049#, 16#0F8F# => 16#0049#,
         16#0F90# => 16#0049#, 16#0F91# => 16#0049#, 16#0F92# => 16#0049#,
         16#0F93# => 16#0049#, 16#0F94# => 16#0049#, 16#0F95# => 16#0049#,
         16#0F96# => 16#0049#, 16#0F97# => 16#0049#, 16#0F98# => 16#0049#,
         16#0F99# => 16#0049#, 16#0F9A# => 16#0049#, 16#0F9B# => 16#0049#,
         16#0F9C# => 16#0049#, 16#0F9D# => 16#0049#, 16#0F9E# => 16#0049#,
         16#0F9F# => 16#0049#, 16#0FA0# => 16#0049#, 16#0FA1# => 16#0049#,
         16#0FA2# => 16#0049#, 16#0FA3# => 16#0049#, 16#0FA4# => 16#0049#,
         16#0FA5# => 16#0049#, 16#0FA6# => 16#0049#, 16#0FA7# => 16#0049#,
         16#0FA8# => 16#0049#, 16#0FA9# => 16#0049#, 16#0FAA# => 16#0049#,
         16#0FAB# => 16#0049#, 16#0FAC# => 16#0049#, 16#0FAD# => 16#0049#,
         16#0FAE# => 16#0049#, 16#0FAF# => 16#0049#, 16#0FB0# => 16#0049#,
         16#0FB1# => 16#0049#, 16#0FB2# => 16#0049#, 16#0FB3# => 16#0049#,
         16#0FB4# => 16#0049#, 16#0FB5# => 16#0049#, 16#0FB6# => 16#0049#,
         16#0FB7# => 16#0049#, 16#0FB8# => 16#0049#, 16#0FB9# => 16#0049#,
         16#0FBA# => 16#0049#, 16#0FBB# => 16#0049#, 16#0FBC# => 16#0049#,
         16#0FBD# => 16#0049#, 16#0FBE# => 16#0049#, 16#0FBF# => 16#0049#,
         16#0FC0# => 16#0049#, 16#0FC1# => 16#0049#, 16#0FC2# => 16#0049#,
         16#0FC3# => 16#0049#, 16#0FC4# => 16#0049#, 16#0FC5# => 16#0049#,
         16#0FC6# => 16#0049#, 16#0FC7# => 16#0049#, 16#0FC8# => 16#0049#,
         16#0FC9# => 16#0049#, 16#0FCA# => 16#0049#, 16#0FCB# => 16#0049#,
         16#0FCC# => 16#0049#, 16#0FCD# => 16#0049#, 16#0FCE# => 16#0049#,
         16#0FCF# => 16#0049#, 16#0FD0# => 16#0049#, 16#0FD1# => 16#0049#,
         16#0FD2# => 16#0049#, 16#0FD3# => 16#0049#, 16#0FD4# => 16#0049#,
         16#0FD5# => 16#0049#, 16#0FD6# => 16#0049#, 16#0FD7# => 16#0049#,
         16#0FD8# => 16#0049#, 16#0FD9# => 16#0049#, 16#0FDA# => 16#0049#,
         16#0FDB# => 16#0049#, 16#0FDC# => 16#0049#, 16#0FDD# => 16#0049#,
         16#0FDE# => 16#0049#, 16#0FDF# => 16#0049#, 16#0FE0# => 16#0049#,
         16#0FE1# => 16#0049#, 16#0FE2# => 16#0049#, 16#0FE3# => 16#0049#,
         16#0FE4# => 16#0049#, 16#0FE5# => 16#0049#, 16#0FE6# => 16#0049#,
         16#0FE7# => 16#0049#, 16#0FE8# => 16#0049#, 16#0FE9# => 16#0049#,
         16#0FEA# => 16#0049#, 16#0FEB# => 16#0049#, 16#0FEC# => 16#0049#,
         16#0FED# => 16#0049#, 16#0FEE# => 16#0049#, 16#0FEF# => 16#0049#,
         16#0FF0# => 16#0049#, 16#0FF1# => 16#0049#, 16#0FF2# => 16#0049#,
         16#0FF3# => 16#0049#, 16#0FF4# => 16#0049#, 16#0FF5# => 16#0049#,
         16#0FF6# => 16#0049#, 16#0FF7# => 16#0049#, 16#0FF8# => 16#0049#,
         16#0FF9# => 16#0049#, 16#0FFA# => 16#0049#, 16#0FFB# => 16#0049#,
         16#0FFC# => 16#0049#, 16#0FFD# => 16#0049#, 16#0FFE# => 16#0049#,
         16#0FFF# => 16#008F#, 16#1000# => 16#0049#, 16#1001# => 16#0049#,
         16#1002# => 16#0049#, 16#1003# => 16#0049#, 16#1004# => 16#0049#,
         16#1005# => 16#0049#, 16#1006# => 16#0049#, 16#1007# => 16#0049#,
         16#1008# => 16#0049#, 16#1009# => 16#0049#, 16#100A# => 16#0049#,
         16#100B# => 16#0049#, 16#100C# => 16#0049#, 16#100D# => 16#0049#,
         16#100E# => 16#0049#, 16#100F# => 16#0049#, 16#1010# => 16#0049#,
         16#1011# => 16#0049#, 16#1012# => 16#0049#, 16#1013# => 16#0049#,
         16#1014# => 16#0049#, 16#1015# => 16#0049#, 16#1016# => 16#0049#,
         16#1017# => 16#0049#, 16#1018# => 16#0049#, 16#1019# => 16#0049#,
         16#101A# => 16#0049#, 16#101B# => 16#0049#, 16#101C# => 16#0049#,
         16#101D# => 16#0049#, 16#101E# => 16#0049#, 16#101F# => 16#0049#,
         16#1020# => 16#0049#, 16#1021# => 16#0049#, 16#1022# => 16#0049#,
         16#1023# => 16#0049#, 16#1024# => 16#0049#, 16#1025# => 16#0049#,
         16#1026# => 16#0049#, 16#1027# => 16#0049#, 16#1028# => 16#0049#,
         16#1029# => 16#0049#, 16#102A# => 16#0049#, 16#102B# => 16#0049#,
         16#102C# => 16#0049#, 16#102D# => 16#0049#, 16#102E# => 16#0049#,
         16#102F# => 16#0049#, 16#1030# => 16#0049#, 16#1031# => 16#0049#,
         16#1032# => 16#0049#, 16#1033# => 16#0049#, 16#1034# => 16#0049#,
         16#1035# => 16#0049#, 16#1036# => 16#0049#, 16#1037# => 16#0049#,
         16#1038# => 16#0049#, 16#1039# => 16#0049#, 16#103A# => 16#0049#,
         16#103B# => 16#0049#, 16#103C# => 16#0049#, 16#103D# => 16#0049#,
         16#103E# => 16#0049#, 16#103F# => 16#0049#, 16#1040# => 16#0049#,
         16#1041# => 16#0049#, 16#1042# => 16#0049#, 16#1043# => 16#0049#,
         16#1044# => 16#0049#, 16#1045# => 16#0049#, 16#1046# => 16#0049#,
         16#1047# => 16#0049#, 16#1048# => 16#0049#, 16#1049# => 16#0049#,
         16#104A# => 16#0049#, 16#104B# => 16#0049#, 16#104C# => 16#0049#,
         16#104D# => 16#0049#, 16#104E# => 16#0049#, 16#104F# => 16#0049#,
         16#1050# => 16#0049#, 16#1051# => 16#0049#, 16#1052# => 16#0049#,
         16#1053# => 16#0049#, 16#1054# => 16#0049#, 16#1055# => 16#0049#,
         16#1056# => 16#0049#, 16#1057# => 16#0049#, 16#1058# => 16#0049#,
         16#1059# => 16#0049#, 16#105A# => 16#0049#, 16#105B# => 16#0049#,
         16#105C# => 16#0049#, 16#105D# => 16#0049#, 16#105E# => 16#0049#,
         16#105F# => 16#0049#, 16#1060# => 16#0049#, 16#1061# => 16#0049#,
         16#1062# => 16#0049#, 16#1063# => 16#0049#, 16#1064# => 16#0049#,
         16#1065# => 16#0049#, 16#1066# => 16#0049#, 16#1067# => 16#0049#,
         16#1068# => 16#0049#, 16#1069# => 16#0049#, 16#106A# => 16#0049#,
         16#106B# => 16#0049#, 16#106C# => 16#0049#, 16#106D# => 16#0049#,
         16#106E# => 16#0049#, 16#106F# => 16#0049#, 16#1070# => 16#0049#,
         16#1071# => 16#0049#, 16#1072# => 16#0049#, 16#1073# => 16#0049#,
         16#1074# => 16#0049#, 16#1075# => 16#0049#, 16#1076# => 16#0049#,
         16#1077# => 16#0049#, 16#1078# => 16#0049#, 16#1079# => 16#0049#,
         16#107A# => 16#0049#, 16#107B# => 16#0049#, 16#107C# => 16#0049#,
         16#107D# => 16#0049#, 16#107E# => 16#0049#, 16#107F# => 16#0049#,
         16#1080# => 16#0049#, 16#1081# => 16#0049#, 16#1082# => 16#0049#,
         16#1083# => 16#0049#, 16#1084# => 16#0049#, 16#1085# => 16#0049#,
         16#1086# => 16#0049#, 16#1087# => 16#0049#, 16#1088# => 16#0049#,
         16#1089# => 16#0049#, 16#108A# => 16#0049#, 16#108B# => 16#0049#,
         16#108C# => 16#0049#, 16#108D# => 16#0049#, 16#108E# => 16#0049#,
         16#108F# => 16#0049#, 16#1090# => 16#0049#, 16#1091# => 16#0049#,
         16#1092# => 16#0049#, 16#1093# => 16#0049#, 16#1094# => 16#0049#,
         16#1095# => 16#0049#, 16#1096# => 16#0049#, 16#1097# => 16#0049#,
         16#1098# => 16#0049#, 16#1099# => 16#0049#, 16#109A# => 16#0049#,
         16#109B# => 16#0049#, 16#109C# => 16#0049#, 16#109D# => 16#0049#,
         16#109E# => 16#0049#, 16#109F# => 16#0049#, 16#10A0# => 16#0049#,
         16#10A1# => 16#0049#, 16#10A2# => 16#0049#, 16#10A3# => 16#0049#,
         16#10A4# => 16#0049#, 16#10A5# => 16#0049#, 16#10A6# => 16#0049#,
         16#10A7# => 16#0049#, 16#10A8# => 16#0049#, 16#10A9# => 16#0049#,
         16#10AA# => 16#0049#, 16#10AB# => 16#0049#, 16#10AC# => 16#0049#,
         16#10AD# => 16#0049#, 16#10AE# => 16#0049#, 16#10AF# => 16#0049#,
         16#10B0# => 16#0049#, 16#10B1# => 16#0049#, 16#10B2# => 16#0049#,
         16#10B3# => 16#0049#, 16#10B4# => 16#0049#, 16#10B5# => 16#0049#,
         16#10B6# => 16#0049#, 16#10B7# => 16#0049#, 16#10B8# => 16#0049#,
         16#10B9# => 16#0049#, 16#10BA# => 16#0049#, 16#10BB# => 16#0049#,
         16#10BC# => 16#0049#, 16#10BD# => 16#0049#, 16#10BE# => 16#0049#,
         16#10BF# => 16#0049#, 16#10C0# => 16#0049#, 16#10C1# => 16#0049#,
         16#10C2# => 16#0049#, 16#10C3# => 16#0049#, 16#10C4# => 16#0049#,
         16#10C5# => 16#0049#, 16#10C6# => 16#0049#, 16#10C7# => 16#0049#,
         16#10C8# => 16#0049#, 16#10C9# => 16#0049#, 16#10CA# => 16#0049#,
         16#10CB# => 16#0049#, 16#10CC# => 16#0049#, 16#10CD# => 16#0049#,
         16#10CE# => 16#0049#, 16#10CF# => 16#0049#, 16#10D0# => 16#0049#,
         16#10D1# => 16#0049#, 16#10D2# => 16#0049#, 16#10D3# => 16#0049#,
         16#10D4# => 16#0049#, 16#10D5# => 16#0049#, 16#10D6# => 16#0049#,
         16#10D7# => 16#0049#, 16#10D8# => 16#0049#, 16#10D9# => 16#0049#,
         16#10DA# => 16#0049#, 16#10DB# => 16#0049#, 16#10DC# => 16#0049#,
         16#10DD# => 16#0049#, 16#10DE# => 16#0049#, 16#10DF# => 16#0049#,
         16#10E0# => 16#0049#, 16#10E1# => 16#0049#, 16#10E2# => 16#0049#,
         16#10E3# => 16#0049#, 16#10E4# => 16#0049#, 16#10E5# => 16#0049#,
         16#10E6# => 16#0049#, 16#10E7# => 16#0049#, 16#10E8# => 16#0049#,
         16#10E9# => 16#0049#, 16#10EA# => 16#0049#, 16#10EB# => 16#0049#,
         16#10EC# => 16#0049#, 16#10ED# => 16#0049#, 16#10EE# => 16#0049#,
         16#10EF# => 16#0049#, 16#10F0# => 16#0049#, 16#10F1# => 16#0049#,
         16#10F2# => 16#0049#, 16#10F3# => 16#0049#, 16#10F4# => 16#0049#,
         16#10F5# => 16#0049#, 16#10F6# => 16#0049#, 16#10F7# => 16#0049#,
         16#10F8# => 16#0049#, 16#10F9# => 16#0049#, 16#10FA# => 16#0049#,
         16#10FB# => 16#0049#, 16#10FC# => 16#0049#, 16#10FD# => 16#0049#,
         16#10FE# => 16#0049#, 16#10FF# => 16#008F#, others   => 16#005D#);

   Base : constant array (First_Stage_Index range <>) of First_Stage_Index
     := (16#0000#, 16#0001#, 16#0002#, 16#0003#, 16#0004#, 16#0005#, 16#0006#,
         16#0007#, 16#0008#, 16#0009#, 16#000A#, 16#000B#, 16#000C#, 16#000D#,
         16#000E#, 16#000F#, 16#0010#, 16#0011#, 16#0012#, 16#0013#, 16#0014#,
         16#0015#, 16#0016#, 16#0017#, 16#0018#, 16#0019#, 16#001A#, 16#001B#,
         16#001C#, 16#001D#, 16#001E#, 16#001F#, 16#0020#, 16#0021#, 16#0022#,
         16#0023#, 16#0024#, 16#0025#, 16#0026#, 16#0027#, 16#0028#, 16#0029#,
         16#002A#, 16#002B#, 16#002C#, 16#002D#, 16#002E#, 16#002F#, 16#0030#,
         16#0031#, 16#0032#, 16#0033#, 16#0034#, 16#004D#, 16#009F#, 16#00A0#,
         16#00A1#, 16#00A4#, 16#00A6#, 16#00A7#, 16#00A8#, 16#00A9#, 16#00AA#,
         16#00AB#, 16#00AC#, 16#00AD#, 16#00AE#, 16#00AF#, 16#00B0#, 16#00B1#,
         16#00B2#, 16#00D7#, 16#00D8#, 16#00E0#, 16#00F9#, 16#00FA#, 16#00FB#,
         16#00FC#, 16#00FD#, 16#00FE#, 16#00FF#, 16#0100#, 16#0101#, 16#0102#,
         16#0103#, 16#0104#, 16#0105#, 16#0107#, 16#0108#, 16#0109#, 16#010A#,
         16#010B#, 16#010C#, 16#010D#, 16#010E#, 16#0110#, 16#0111#, 16#0112#,
         16#0113#, 16#0114#, 16#0115#, 16#0116#, 16#0118#, 16#011A#, 16#0123#,
         16#0124#, 16#0132#, 16#0133#, 16#0134#, 16#016A#, 16#016B#, 16#016F#,
         16#01B0#, 16#01BC#, 16#01D0#, 16#01D1#, 16#01D2#, 16#01D3#, 16#01D4#,
         16#01D5#, 16#01D6#, 16#01D7#, 16#01E8#, 16#01EE#, 16#01F0#, 16#01F1#,
         16#01F2#, 16#01F3#, 16#01F4#, 16#01F5#, 16#01F6#, 16#01F7#, 16#01F8#,
         16#01FF#, 16#02A6#, 16#02B7#, 16#02B8#, 16#02B9#, 16#02FA#, 16#02FF#,
         16#0E00#, 16#0E01#, 16#0E02#, 16#0FFF#);

   Base_Last : constant First_Stage_Index := 143;

end Matreshka.Internals.Unicode.Ucd.Indexes;
