------------------------------------------------------------------------------
--                                                                          --
--                            Matreshka Project                             --
--                                                                          --
--                               Web Framework                              --
--                                                                          --
--                        Runtime Library Component                         --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2010-2011, Vadim Godunko <vgodunko@gmail.com>                --
-- All rights reserved.                                                     --
--                                                                          --
-- Redistribution and use in source and binary forms, with or without       --
-- modification, are permitted provided that the following conditions       --
-- are met:                                                                 --
--                                                                          --
--  * Redistributions of source code must retain the above copyright        --
--    notice, this list of conditions and the following disclaimer.         --
--                                                                          --
--  * Redistributions in binary form must reproduce the above copyright     --
--    notice, this list of conditions and the following disclaimer in the   --
--    documentation and/or other materials provided with the distribution.  --
--                                                                          --
--  * Neither the name of the Vadim Godunko, IE nor the names of its        --
--    contributors may be used to endorse or promote products derived from  --
--    this software without specific prior written permission.              --
--                                                                          --
-- THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS      --
-- "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT        --
-- LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR    --
-- A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT     --
-- HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,   --
-- SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED --
-- TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR   --
-- PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF   --
-- LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING     --
-- NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS       --
-- SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.             --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 1380 $ $Date: 2011-02-03 20:51:04 +0100 (Thu, 03 Feb 2011) $
------------------------------------------------------------------------------
with Ada.Containers.Hashed_Maps;

with League.Stream_Element_Vectors;

package Matreshka.FastCGI is

   pragma Preelaborate;

   type FCGI_Request_Identifier is mod 2 ** 16;

   function Hash
    (Item : League.Stream_Element_Vectors.Stream_Element_Vector)
       return Ada.Containers.Hash_Type;

   package Maps is
     new Ada.Containers.Hashed_Maps
          (League.Stream_Element_Vectors.Stream_Element_Vector,
           League.Stream_Element_Vectors.Stream_Element_Vector,
           Hash,
           League.Stream_Element_Vectors."=",
           League.Stream_Element_Vectors."=");

   type Descriptor is record
      Request_Id      : FCGI_Request_Identifier;
      Request_Headers : Maps.Map;
      Stdin           : League.Stream_Element_Vectors.Stream_Element_Vector;
      Query_Items     : Maps.Map;
      Reply_Headers   : Maps.Map;
      Stdout          : League.Stream_Element_Vectors.Stream_Element_Vector;
      Stderr          : League.Stream_Element_Vectors.Stream_Element_Vector;
   end record;

   type Descriptor_Access is access all Descriptor;

end Matreshka.FastCGI;
