------------------------------------------------------------------------------
--                                                                          --
--                            Matreshka Project                             --
--                                                                          --
--                               Web Framework                              --
--                                                                          --
--                        Runtime Library Component                         --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2016, Vadim Godunko <vgodunko@gmail.com>                     --
-- All rights reserved.                                                     --
--                                                                          --
-- Redistribution and use in source and binary forms, with or without       --
-- modification, are permitted provided that the following conditions       --
-- are met:                                                                 --
--                                                                          --
--  * Redistributions of source code must retain the above copyright        --
--    notice, this list of conditions and the following disclaimer.         --
--                                                                          --
--  * Redistributions in binary form must reproduce the above copyright     --
--    notice, this list of conditions and the following disclaimer in the   --
--    documentation and/or other materials provided with the distribution.  --
--                                                                          --
--  * Neither the name of the Vadim Godunko, IE nor the names of its        --
--    contributors may be used to endorse or promote products derived from  --
--    this software without specific prior written permission.              --
--                                                                          --
-- THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS      --
-- "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT        --
-- LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR    --
-- A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT     --
-- HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,   --
-- SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED --
-- TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR   --
-- PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF   --
-- LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING     --
-- NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS       --
-- SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.             --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 5614 $ $Date: 2016-09-04 18:54:44 +0200 (Sun, 04 Sep 2016) $
------------------------------------------------------------------------------
with Ada.Containers.Vectors;

with League.Strings;
with League.String_Vectors;

package Matreshka.Spikedog_Deployment_Descriptors is

   type Servlet_Descriptor is record
      Name : League.Strings.Universal_String;
      Tag  : League.Strings.Universal_String;
   end record;

   package Servlet_Vectors is
     new Ada.Containers.Vectors (Positive, Servlet_Descriptor);

   type Servlet_Mapping_Descriptor is record
      Name         : League.Strings.Universal_String;
      URL_Patterns : League.String_Vectors.Universal_String_Vector;
   end record;

   package Servlet_Mapping_Vectors is
     new Ada.Containers.Vectors (Positive, Servlet_Mapping_Descriptor);

   type Deployment_Descriptor is limited record
      Library_Name     : League.Strings.Universal_String;
      Servlets         : Servlet_Vectors.Vector;
      Servlet_Mappings : Servlet_Mapping_Vectors.Vector;
   end record;

   type Deployment_Descriptor_Access is access all Deployment_Descriptor;

end Matreshka.Spikedog_Deployment_Descriptors;
