------------------------------------------------------------------------------
--                                                                          --
--                            Matreshka Project                             --
--                                                                          --
--                               Web Framework                              --
--                                                                          --
--                        Runtime Library Component                         --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2012, Vadim Godunko <vgodunko@gmail.com>                     --
-- All rights reserved.                                                     --
--                                                                          --
-- Redistribution and use in source and binary forms, with or without       --
-- modification, are permitted provided that the following conditions       --
-- are met:                                                                 --
--                                                                          --
--  * Redistributions of source code must retain the above copyright        --
--    notice, this list of conditions and the following disclaimer.         --
--                                                                          --
--  * Redistributions in binary form must reproduce the above copyright     --
--    notice, this list of conditions and the following disclaimer in the   --
--    documentation and/or other materials provided with the distribution.  --
--                                                                          --
--  * Neither the name of the Vadim Godunko, IE nor the names of its        --
--    contributors may be used to endorse or promote products derived from  --
--    this software without specific prior written permission.              --
--                                                                          --
-- THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS      --
-- "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT        --
-- LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR    --
-- A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT     --
-- HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,   --
-- SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED --
-- TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR   --
-- PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF   --
-- LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING     --
-- NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS       --
-- SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.             --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 3493 $ $Date: 2012-11-26 10:36:47 +0100 (Mon, 26 Nov 2012) $
------------------------------------------------------------------------------
with Web_Services.SOAP.Headers.Encoders.Registry;
with Web_Services.SOAP.Headers.Decoders.Registry;
with Web_Services.SOAP.Modules.Registry;
with Web_Services.SOAP.Security.Constants;
with Web_Services.SOAP.Security.Headers.Encoders;
with Web_Services.SOAP.Security.Headers.Decoders;
with Web_Services.SOAP.Security.Modules;
with Web_Services.SOAP.Security.Password_Digest_Utilities;

package body Web_Services.SOAP.Security.Setup is

   Module : aliased Web_Services.SOAP.Security.Modules.Security_Module;

begin
   Web_Services.SOAP.Headers.Decoders.Registry.Register
    (Web_Services.SOAP.Security.Constants.WSSE_Namespace_URI,
     Web_Services.SOAP.Security.Headers.Decoders.Security_Header_Decoder'Tag);
   Web_Services.SOAP.Headers.Encoders.Registry.Register
    (Web_Services.SOAP.Security.Headers.Username_Token_Header'Tag,
     Web_Services.SOAP.Security.Headers.Encoders.Security_Header_Encoder'Tag);
   Web_Services.SOAP.Modules.Registry.Register (Module'Access);
   Web_Services.SOAP.Security.Password_Digest_Utilities.Initialize;
end Web_Services.SOAP.Security.Setup;
