------------------------------------------------------------------------------
--                                                                          --
--                            Matreshka Project                             --
--                                                                          --
--                               XML Processor                              --
--                                                                          --
--                        Runtime Library Component                         --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2012-2013, Vadim Godunko <vgodunko@gmail.com>                --
-- All rights reserved.                                                     --
--                                                                          --
-- Redistribution and use in source and binary forms, with or without       --
-- modification, are permitted provided that the following conditions       --
-- are met:                                                                 --
--                                                                          --
--  * Redistributions of source code must retain the above copyright        --
--    notice, this list of conditions and the following disclaimer.         --
--                                                                          --
--  * Redistributions in binary form must reproduce the above copyright     --
--    notice, this list of conditions and the following disclaimer in the   --
--    documentation and/or other materials provided with the distribution.  --
--                                                                          --
--  * Neither the name of the Vadim Godunko, IE nor the names of its        --
--    contributors may be used to endorse or promote products derived from  --
--    this software without specific prior written permission.              --
--                                                                          --
-- THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS      --
-- "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT        --
-- LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR    --
-- A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT     --
-- HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,   --
-- SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED --
-- TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR   --
-- PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF   --
-- LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING     --
-- NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS       --
-- SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.             --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 3929 $ $Date: 2013-05-22 15:16:05 +0200 (Wed, 22 May 2013) $
------------------------------------------------------------------------------

package body XML.SAX.Input_Sources.Streams.Element_Arrays is

   ----------
   -- Read --
   ----------

   overriding procedure Read
    (Self        : in out Stream_Element_Array_Input_Source;
     Buffer      : out Ada.Streams.Stream_Element_Array;
     Last        : out Ada.Streams.Stream_Element_Offset;
     End_Of_Data : out Boolean)
   is
      pragma Unreferenced (Self);
      pragma Warnings (Off, Buffer);

   begin
      Last := Buffer'First - 1;
      End_Of_Data := True;
   end Read;

   ------------------------------
   -- Set_Stream_Element_Array --
   ------------------------------

   procedure Set_Stream_Element_Array
    (Self : in out Stream_Element_Array_Input_Source'Class;
     Data : Ada.Streams.Stream_Element_Array) is
   begin
      Free (Self.Buffer);
      Self.Buffer :=
        new Ada.Streams.Stream_Element_Array (0 .. Data'Length - 1);
      Self.Buffer.all := Data;
      Self.First := 0;
      Self.Last := Data'Length - 1;
   end Set_Stream_Element_Array;

   -------------------------------
   -- Set_Stream_Element_Vector --
   -------------------------------

   procedure Set_Stream_Element_Vector
    (Self : in out Stream_Element_Array_Input_Source'Class;
     Data : League.Stream_Element_Vectors.Stream_Element_Vector) is
   begin
      Self.Set_Stream_Element_Array (Data.To_Stream_Element_Array);
   end Set_Stream_Element_Vector;

end XML.SAX.Input_Sources.Streams.Element_Arrays;
