------------------------------------------------------------------------------
--                                                                          --
--                            Matreshka Project                             --
--                                                                          --
--         Localization, Internationalization, Globalization for Ada        --
--                                                                          --
--                        Runtime Library Component                         --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2010, Vadim Godunko <vgodunko@gmail.com>                     --
-- All rights reserved.                                                     --
--                                                                          --
-- Redistribution and use in source and binary forms, with or without       --
-- modification, are permitted provided that the following conditions       --
-- are met:                                                                 --
--                                                                          --
--  * Redistributions of source code must retain the above copyright        --
--    notice, this list of conditions and the following disclaimer.         --
--                                                                          --
--  * Redistributions in binary form must reproduce the above copyright     --
--    notice, this list of conditions and the following disclaimer in the   --
--    documentation and/or other materials provided with the distribution.  --
--                                                                          --
--  * Neither the name of the Vadim Godunko, IE nor the names of its        --
--    contributors may be used to endorse or promote products derived from  --
--    this software without specific prior written permission.              --
--                                                                          --
-- THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS      --
-- "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT        --
-- LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR    --
-- A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT     --
-- HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,   --
-- SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED --
-- TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR   --
-- PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF   --
-- LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING     --
-- NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS       --
-- SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.             --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 1059 $ $Date: 2010-10-31 22:15:44 +0100 (Sun, 31 Oct 2010) $
------------------------------------------------------------------------------

private package Matreshka.Internals.Text_Codecs.SHIFTJIS.Tables is

   pragma Preelaborate;

   Meta_Class :
     constant array (Ada.Streams.Stream_Element)
       of SHIFTJIS_Meta_Class
         := (1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
             1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
             1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
             1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
             0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
             0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
             0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
             0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
             4, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2,
             2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2,
             4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
             0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
             0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
             0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
             2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2,
             2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 5, 5, 5);

   Decode_Single :
     constant array (Ada.Streams.Stream_Element)
       of Matreshka.Internals.Unicode.Code_Point
         := (16#0000#, 16#0001#, 16#0002#, 16#0003#,
             16#0004#, 16#0005#, 16#0006#, 16#0007#,
             16#0008#, 16#0009#, 16#000A#, 16#000B#,
             16#000C#, 16#000D#, 16#000E#, 16#000F#,
             16#0010#, 16#0011#, 16#0012#, 16#0013#,
             16#0014#, 16#0015#, 16#0016#, 16#0017#,
             16#0018#, 16#0019#, 16#001A#, 16#001B#,
             16#001C#, 16#001D#, 16#001E#, 16#001F#,
             16#0020#, 16#0021#, 16#0022#, 16#0023#,
             16#0024#, 16#0025#, 16#0026#, 16#0027#,
             16#0028#, 16#0029#, 16#002A#, 16#002B#,
             16#002C#, 16#002D#, 16#002E#, 16#002F#,
             16#0030#, 16#0031#, 16#0032#, 16#0033#,
             16#0034#, 16#0035#, 16#0036#, 16#0037#,
             16#0038#, 16#0039#, 16#003A#, 16#003B#,
             16#003C#, 16#003D#, 16#003E#, 16#003F#,
             16#0040#, 16#0041#, 16#0042#, 16#0043#,
             16#0044#, 16#0045#, 16#0046#, 16#0047#,
             16#0048#, 16#0049#, 16#004A#, 16#004B#,
             16#004C#, 16#004D#, 16#004E#, 16#004F#,
             16#0050#, 16#0051#, 16#0052#, 16#0053#,
             16#0054#, 16#0055#, 16#0056#, 16#0057#,
             16#0058#, 16#0059#, 16#005A#, 16#005B#,
             16#00A5#, 16#005D#, 16#005E#, 16#005F#,
             16#0060#, 16#0061#, 16#0062#, 16#0063#,
             16#0064#, 16#0065#, 16#0066#, 16#0067#,
             16#0068#, 16#0069#, 16#006A#, 16#006B#,
             16#006C#, 16#006D#, 16#006E#, 16#006F#,
             16#0070#, 16#0071#, 16#0072#, 16#0073#,
             16#0074#, 16#0075#, 16#0076#, 16#0077#,
             16#0078#, 16#0079#, 16#007A#, 16#007B#,
             16#007C#, 16#007D#, 16#203E#, 16#007F#,
             16#0000#, 16#0000#, 16#0000#, 16#0000#,
             16#0000#, 16#0000#, 16#0000#, 16#0000#,
             16#0000#, 16#0000#, 16#0000#, 16#0000#,
             16#0000#, 16#0000#, 16#0000#, 16#0000#,
             16#0000#, 16#0000#, 16#0000#, 16#0000#,
             16#0000#, 16#0000#, 16#0000#, 16#0000#,
             16#0000#, 16#0000#, 16#0000#, 16#0000#,
             16#0000#, 16#0000#, 16#0000#, 16#0000#,
             16#0000#, 16#FF61#, 16#FF62#, 16#FF63#,
             16#FF64#, 16#FF65#, 16#FF66#, 16#FF67#,
             16#FF68#, 16#FF69#, 16#FF6A#, 16#FF6B#,
             16#FF6C#, 16#FF6D#, 16#FF6E#, 16#FF6F#,
             16#FF70#, 16#FF71#, 16#FF72#, 16#FF73#,
             16#FF74#, 16#FF75#, 16#FF76#, 16#FF77#,
             16#FF78#, 16#FF79#, 16#FF7A#, 16#FF7B#,
             16#FF7C#, 16#FF7D#, 16#FF7E#, 16#FF7F#,
             16#FF80#, 16#FF81#, 16#FF82#, 16#FF83#,
             16#FF84#, 16#FF85#, 16#FF86#, 16#FF87#,
             16#FF88#, 16#FF89#, 16#FF8A#, 16#FF8B#,
             16#FF8C#, 16#FF8D#, 16#FF8E#, 16#FF8F#,
             16#FF90#, 16#FF91#, 16#FF92#, 16#FF93#,
             16#FF94#, 16#FF95#, 16#FF96#, 16#FF97#,
             16#FF98#, 16#FF99#, 16#FF9A#, 16#FF9B#,
             16#FF9C#, 16#FF9D#, 16#FF9E#, 16#FF9F#,
             16#0000#, 16#0000#, 16#0000#, 16#0000#,
             16#0000#, 16#0000#, 16#0000#, 16#0000#,
             16#0000#, 16#0000#, 16#0000#, 16#0000#,
             16#0000#, 16#0000#, 16#0000#, 16#0000#,
             16#0000#, 16#0000#, 16#0000#, 16#0000#,
             16#0000#, 16#0000#, 16#0000#, 16#0000#,
             16#0000#, 16#0000#, 16#0000#, 16#0000#,
             16#0000#, 16#0000#, 16#0000#, 16#0000#);

   Decode_Double_Invalid : aliased constant SHIFTJIS_Code_Point_Array
     := (16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#);

   Decode_Double_81 : aliased constant SHIFTJIS_Code_Point_Array
     := (16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#3000#, 16#3001#, 16#3002#, 16#FF0C#,
         16#FF0E#, 16#30FB#, 16#FF1A#, 16#FF1B#,
         16#FF1F#, 16#FF01#, 16#309B#, 16#309C#,
         16#00B4#, 16#FF40#, 16#00A8#, 16#FF3E#,
         16#FFE3#, 16#FF3F#, 16#30FD#, 16#30FE#,
         16#309D#, 16#309E#, 16#3003#, 16#4EDD#,
         16#3005#, 16#3006#, 16#3007#, 16#30FC#,
         16#2014#, 16#2010#, 16#FF0F#, 16#005C#,
         16#301C#, 16#2016#, 16#FF5C#, 16#2026#,
         16#2025#, 16#2018#, 16#2019#, 16#201C#,
         16#201D#, 16#FF08#, 16#FF09#, 16#3014#,
         16#3015#, 16#FF3B#, 16#FF3D#, 16#FF5B#,
         16#FF5D#, 16#3008#, 16#3009#, 16#300A#,
         16#300B#, 16#300C#, 16#300D#, 16#300E#,
         16#300F#, 16#3010#, 16#3011#, 16#FF0B#,
         16#2212#, 16#00B1#, 16#00D7#, 16#0000#,
         16#00F7#, 16#FF1D#, 16#2260#, 16#FF1C#,
         16#FF1E#, 16#2266#, 16#2267#, 16#221E#,
         16#2234#, 16#2642#, 16#2640#, 16#00B0#,
         16#2032#, 16#2033#, 16#2103#, 16#FFE5#,
         16#FF04#, 16#00A2#, 16#00A3#, 16#FF05#,
         16#FF03#, 16#FF06#, 16#FF0A#, 16#FF20#,
         16#00A7#, 16#2606#, 16#2605#, 16#25CB#,
         16#25CF#, 16#25CE#, 16#25C7#, 16#25C6#,
         16#25A1#, 16#25A0#, 16#25B3#, 16#25B2#,
         16#25BD#, 16#25BC#, 16#203B#, 16#3012#,
         16#2192#, 16#2190#, 16#2191#, 16#2193#,
         16#3013#, 16#FF07#, 16#FF02#, 16#FF0D#,
         16#007E#, 16#3033#, 16#3034#, 16#3035#,
         16#303B#, 16#303C#, 16#30FF#, 16#309F#,
         16#2208#, 16#220B#, 16#2286#, 16#2287#,
         16#2282#, 16#2283#, 16#222A#, 16#2229#,
         16#2284#, 16#2285#, 16#228A#, 16#228B#,
         16#2209#, 16#2205#, 16#2305#, 16#2306#,
         16#2227#, 16#2228#, 16#00AC#, 16#21D2#,
         16#21D4#, 16#2200#, 16#2203#, 16#2295#,
         16#2296#, 16#2297#, 16#2225#, 16#2226#,
         16#FF5F#, 16#FF60#, 16#3018#, 16#3019#,
         16#3016#, 16#3017#, 16#2220#, 16#22A5#,
         16#2312#, 16#2202#, 16#2207#, 16#2261#,
         16#2252#, 16#226A#, 16#226B#, 16#221A#,
         16#223D#, 16#221D#, 16#2235#, 16#222B#,
         16#222C#, 16#2262#, 16#2243#, 16#2245#,
         16#2248#, 16#2276#, 16#2277#, 16#2194#,
         16#212B#, 16#2030#, 16#266F#, 16#266D#,
         16#266A#, 16#2020#, 16#2021#, 16#00B6#,
         16#266E#, 16#266B#, 16#266C#, 16#2669#,
         16#25EF#, 16#0000#, 16#0000#, 16#0000#);

   Decode_Double_82 : aliased constant SHIFTJIS_Code_Point_Array
     := (16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#25B7#, 16#25B6#, 16#25C1#, 16#25C0#,
         16#2197#, 16#2198#, 16#2196#, 16#2199#,
         16#21C4#, 16#21E8#, 16#21E6#, 16#21E7#,
         16#21E9#, 16#2934#, 16#2935#, 16#FF10#,
         16#FF11#, 16#FF12#, 16#FF13#, 16#FF14#,
         16#FF15#, 16#FF16#, 16#FF17#, 16#FF18#,
         16#FF19#, 16#29BF#, 16#25C9#, 16#303D#,
         16#FE46#, 16#FE45#, 16#25E6#, 16#2022#,
         16#FF21#, 16#FF22#, 16#FF23#, 16#FF24#,
         16#FF25#, 16#FF26#, 16#FF27#, 16#FF28#,
         16#FF29#, 16#FF2A#, 16#FF2B#, 16#FF2C#,
         16#FF2D#, 16#FF2E#, 16#FF2F#, 16#FF30#,
         16#FF31#, 16#FF32#, 16#FF33#, 16#FF34#,
         16#FF35#, 16#FF36#, 16#FF37#, 16#FF38#,
         16#FF39#, 16#FF3A#, 16#2213#, 16#2135#,
         16#210F#, 16#33CB#, 16#2113#, 16#0000#,
         16#2127#, 16#FF41#, 16#FF42#, 16#FF43#,
         16#FF44#, 16#FF45#, 16#FF46#, 16#FF47#,
         16#FF48#, 16#FF49#, 16#FF4A#, 16#FF4B#,
         16#FF4C#, 16#FF4D#, 16#FF4E#, 16#FF4F#,
         16#FF50#, 16#FF51#, 16#FF52#, 16#FF53#,
         16#FF54#, 16#FF55#, 16#FF56#, 16#FF57#,
         16#FF58#, 16#FF59#, 16#FF5A#, 16#30A0#,
         16#2013#, 16#29FA#, 16#29FB#, 16#3041#,
         16#3042#, 16#3043#, 16#3044#, 16#3045#,
         16#3046#, 16#3047#, 16#3048#, 16#3049#,
         16#304A#, 16#304B#, 16#304C#, 16#304D#,
         16#304E#, 16#304F#, 16#3050#, 16#3051#,
         16#3052#, 16#3053#, 16#3054#, 16#3055#,
         16#3056#, 16#3057#, 16#3058#, 16#3059#,
         16#305A#, 16#305B#, 16#305C#, 16#305D#,
         16#305E#, 16#305F#, 16#3060#, 16#3061#,
         16#3062#, 16#3063#, 16#3064#, 16#3065#,
         16#3066#, 16#3067#, 16#3068#, 16#3069#,
         16#306A#, 16#306B#, 16#306C#, 16#306D#,
         16#306E#, 16#306F#, 16#3070#, 16#3071#,
         16#3072#, 16#3073#, 16#3074#, 16#3075#,
         16#3076#, 16#3077#, 16#3078#, 16#3079#,
         16#307A#, 16#307B#, 16#307C#, 16#307D#,
         16#307E#, 16#307F#, 16#3080#, 16#3081#,
         16#3082#, 16#3083#, 16#3084#, 16#3085#,
         16#3086#, 16#3087#, 16#3088#, 16#3089#,
         16#308A#, 16#308B#, 16#308C#, 16#308D#,
         16#308E#, 16#308F#, 16#3090#, 16#3091#,
         16#3092#, 16#3093#, 16#3094#, 16#3095#,
         16#3096#, 16#0001#, 16#0002#, 16#0003#,
         16#0004#, 16#0005#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#);

   Decode_Double_83 : aliased constant SHIFTJIS_Code_Point_Array
     := (16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#30A1#, 16#30A2#, 16#30A3#, 16#30A4#,
         16#30A5#, 16#30A6#, 16#30A7#, 16#30A8#,
         16#30A9#, 16#30AA#, 16#30AB#, 16#30AC#,
         16#30AD#, 16#30AE#, 16#30AF#, 16#30B0#,
         16#30B1#, 16#30B2#, 16#30B3#, 16#30B4#,
         16#30B5#, 16#30B6#, 16#30B7#, 16#30B8#,
         16#30B9#, 16#30BA#, 16#30BB#, 16#30BC#,
         16#30BD#, 16#30BE#, 16#30BF#, 16#30C0#,
         16#30C1#, 16#30C2#, 16#30C3#, 16#30C4#,
         16#30C5#, 16#30C6#, 16#30C7#, 16#30C8#,
         16#30C9#, 16#30CA#, 16#30CB#, 16#30CC#,
         16#30CD#, 16#30CE#, 16#30CF#, 16#30D0#,
         16#30D1#, 16#30D2#, 16#30D3#, 16#30D4#,
         16#30D5#, 16#30D6#, 16#30D7#, 16#30D8#,
         16#30D9#, 16#30DA#, 16#30DB#, 16#30DC#,
         16#30DD#, 16#30DE#, 16#30DF#, 16#0000#,
         16#30E0#, 16#30E1#, 16#30E2#, 16#30E3#,
         16#30E4#, 16#30E5#, 16#30E6#, 16#30E7#,
         16#30E8#, 16#30E9#, 16#30EA#, 16#30EB#,
         16#30EC#, 16#30ED#, 16#30EE#, 16#30EF#,
         16#30F0#, 16#30F1#, 16#30F2#, 16#30F3#,
         16#30F4#, 16#30F5#, 16#30F6#, 16#0006#,
         16#0007#, 16#0008#, 16#0009#, 16#000A#,
         16#000B#, 16#000C#, 16#000D#, 16#0391#,
         16#0392#, 16#0393#, 16#0394#, 16#0395#,
         16#0396#, 16#0397#, 16#0398#, 16#0399#,
         16#039A#, 16#039B#, 16#039C#, 16#039D#,
         16#039E#, 16#039F#, 16#03A0#, 16#03A1#,
         16#03A3#, 16#03A4#, 16#03A5#, 16#03A6#,
         16#03A7#, 16#03A8#, 16#03A9#, 16#2664#,
         16#2660#, 16#2662#, 16#2666#, 16#2661#,
         16#2665#, 16#2667#, 16#2663#, 16#03B1#,
         16#03B2#, 16#03B3#, 16#03B4#, 16#03B5#,
         16#03B6#, 16#03B7#, 16#03B8#, 16#03B9#,
         16#03BA#, 16#03BB#, 16#03BC#, 16#03BD#,
         16#03BE#, 16#03BF#, 16#03C0#, 16#03C1#,
         16#03C3#, 16#03C4#, 16#03C5#, 16#03C6#,
         16#03C7#, 16#03C8#, 16#03C9#, 16#03C2#,
         16#24F5#, 16#24F6#, 16#24F7#, 16#24F8#,
         16#24F9#, 16#24FA#, 16#24FB#, 16#24FC#,
         16#24FD#, 16#24FE#, 16#2616#, 16#2617#,
         16#3020#, 16#260E#, 16#2600#, 16#2601#,
         16#2602#, 16#2603#, 16#2668#, 16#25B1#,
         16#31F0#, 16#31F1#, 16#31F2#, 16#31F3#,
         16#31F4#, 16#31F5#, 16#31F6#, 16#31F7#,
         16#31F8#, 16#31F9#, 16#000E#, 16#31FA#,
         16#31FB#, 16#31FC#, 16#31FD#, 16#31FE#,
         16#31FF#, 16#0000#, 16#0000#, 16#0000#);

   Decode_Double_84 : aliased constant SHIFTJIS_Code_Point_Array
     := (16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0410#, 16#0411#, 16#0412#, 16#0413#,
         16#0414#, 16#0415#, 16#0401#, 16#0416#,
         16#0417#, 16#0418#, 16#0419#, 16#041A#,
         16#041B#, 16#041C#, 16#041D#, 16#041E#,
         16#041F#, 16#0420#, 16#0421#, 16#0422#,
         16#0423#, 16#0424#, 16#0425#, 16#0426#,
         16#0427#, 16#0428#, 16#0429#, 16#042A#,
         16#042B#, 16#042C#, 16#042D#, 16#042E#,
         16#042F#, 16#23BE#, 16#23BF#, 16#23C0#,
         16#23C1#, 16#23C2#, 16#23C3#, 16#23C4#,
         16#23C5#, 16#23C6#, 16#23C7#, 16#23C8#,
         16#23C9#, 16#23CA#, 16#23CB#, 16#23CC#,
         16#0430#, 16#0431#, 16#0432#, 16#0433#,
         16#0434#, 16#0435#, 16#0451#, 16#0436#,
         16#0437#, 16#0438#, 16#0439#, 16#043A#,
         16#043B#, 16#043C#, 16#043D#, 16#0000#,
         16#043E#, 16#043F#, 16#0440#, 16#0441#,
         16#0442#, 16#0443#, 16#0444#, 16#0445#,
         16#0446#, 16#0447#, 16#0448#, 16#0449#,
         16#044A#, 16#044B#, 16#044C#, 16#044D#,
         16#044E#, 16#044F#, 16#30F7#, 16#30F8#,
         16#30F9#, 16#30FA#, 16#22DA#, 16#22DB#,
         16#2153#, 16#2154#, 16#2155#, 16#2713#,
         16#2318#, 16#2423#, 16#23CE#, 16#2500#,
         16#2502#, 16#250C#, 16#2510#, 16#2518#,
         16#2514#, 16#251C#, 16#252C#, 16#2524#,
         16#2534#, 16#253C#, 16#2501#, 16#2503#,
         16#250F#, 16#2513#, 16#251B#, 16#2517#,
         16#2523#, 16#2533#, 16#252B#, 16#253B#,
         16#254B#, 16#2520#, 16#252F#, 16#2528#,
         16#2537#, 16#253F#, 16#251D#, 16#2530#,
         16#2525#, 16#2538#, 16#2542#, 16#3251#,
         16#3252#, 16#3253#, 16#3254#, 16#3255#,
         16#3256#, 16#3257#, 16#3258#, 16#3259#,
         16#325A#, 16#325B#, 16#325C#, 16#325D#,
         16#325E#, 16#325F#, 16#32B1#, 16#32B2#,
         16#32B3#, 16#32B4#, 16#32B5#, 16#32B6#,
         16#32B7#, 16#32B8#, 16#32B9#, 16#32BA#,
         16#32BB#, 16#32BC#, 16#32BD#, 16#32BE#,
         16#32BF#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#25D0#, 16#25D1#, 16#25D2#,
         16#25D3#, 16#203C#, 16#2047#, 16#2048#,
         16#2049#, 16#01CD#, 16#01CE#, 16#01D0#,
         16#1E3E#, 16#1E3F#, 16#01F8#, 16#01F9#,
         16#01D1#, 16#01D2#, 16#01D4#, 16#01D6#,
         16#01D8#, 16#01DA#, 16#01DC#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#);

   Decode_Double_85 : aliased constant SHIFTJIS_Code_Point_Array
     := (16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#20AC#, 16#00A0#, 16#00A1#, 16#00A4#,
         16#00A6#, 16#00A9#, 16#00AA#, 16#00AB#,
         16#00AD#, 16#00AE#, 16#00AF#, 16#00B2#,
         16#00B3#, 16#00B7#, 16#00B8#, 16#00B9#,
         16#00BA#, 16#00BB#, 16#00BC#, 16#00BD#,
         16#00BE#, 16#00BF#, 16#00C0#, 16#00C1#,
         16#00C2#, 16#00C3#, 16#00C4#, 16#00C5#,
         16#00C6#, 16#00C7#, 16#00C8#, 16#00C9#,
         16#00CA#, 16#00CB#, 16#00CC#, 16#00CD#,
         16#00CE#, 16#00CF#, 16#00D0#, 16#00D1#,
         16#00D2#, 16#00D3#, 16#00D4#, 16#00D5#,
         16#00D6#, 16#00D8#, 16#00D9#, 16#00DA#,
         16#00DB#, 16#00DC#, 16#00DD#, 16#00DE#,
         16#00DF#, 16#00E0#, 16#00E1#, 16#00E2#,
         16#00E3#, 16#00E4#, 16#00E5#, 16#00E6#,
         16#00E7#, 16#00E8#, 16#00E9#, 16#0000#,
         16#00EA#, 16#00EB#, 16#00EC#, 16#00ED#,
         16#00EE#, 16#00EF#, 16#00F0#, 16#00F1#,
         16#00F2#, 16#00F3#, 16#00F4#, 16#00F5#,
         16#00F6#, 16#00F8#, 16#00F9#, 16#00FA#,
         16#00FB#, 16#00FC#, 16#00FD#, 16#00FE#,
         16#00FF#, 16#0100#, 16#012A#, 16#016A#,
         16#0112#, 16#014C#, 16#0101#, 16#012B#,
         16#016B#, 16#0113#, 16#014D#, 16#0104#,
         16#02D8#, 16#0141#, 16#013D#, 16#015A#,
         16#0160#, 16#015E#, 16#0164#, 16#0179#,
         16#017D#, 16#017B#, 16#0105#, 16#02DB#,
         16#0142#, 16#013E#, 16#015B#, 16#02C7#,
         16#0161#, 16#015F#, 16#0165#, 16#017A#,
         16#02DD#, 16#017E#, 16#017C#, 16#0154#,
         16#0102#, 16#0139#, 16#0106#, 16#010C#,
         16#0118#, 16#011A#, 16#010E#, 16#0143#,
         16#0147#, 16#0150#, 16#0158#, 16#016E#,
         16#0170#, 16#0162#, 16#0155#, 16#0103#,
         16#013A#, 16#0107#, 16#010D#, 16#0119#,
         16#011B#, 16#010F#, 16#0111#, 16#0144#,
         16#0148#, 16#0151#, 16#0159#, 16#016F#,
         16#0171#, 16#0163#, 16#02D9#, 16#0108#,
         16#011C#, 16#0124#, 16#0134#, 16#015C#,
         16#016C#, 16#0109#, 16#011D#, 16#0125#,
         16#0135#, 16#015D#, 16#016D#, 16#0271#,
         16#028B#, 16#027E#, 16#0283#, 16#0292#,
         16#026C#, 16#026E#, 16#0279#, 16#0288#,
         16#0256#, 16#0273#, 16#027D#, 16#0282#,
         16#0290#, 16#027B#, 16#026D#, 16#025F#,
         16#0272#, 16#029D#, 16#028E#, 16#0261#,
         16#014B#, 16#0270#, 16#0281#, 16#0127#,
         16#0295#, 16#0000#, 16#0000#, 16#0000#);

   Decode_Double_86 : aliased constant SHIFTJIS_Code_Point_Array
     := (16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0294#, 16#0266#, 16#0298#, 16#01C2#,
         16#0253#, 16#0257#, 16#0284#, 16#0260#,
         16#0193#, 16#0153#, 16#0152#, 16#0268#,
         16#0289#, 16#0258#, 16#0275#, 16#0259#,
         16#025C#, 16#025E#, 16#0250#, 16#026F#,
         16#028A#, 16#0264#, 16#028C#, 16#0254#,
         16#0251#, 16#0252#, 16#028D#, 16#0265#,
         16#02A2#, 16#02A1#, 16#0255#, 16#0291#,
         16#027A#, 16#0267#, 16#025A#, 16#000F#,
         16#01FD#, 16#1F70#, 16#1F71#, 16#0010#,
         16#0011#, 16#0012#, 16#0013#, 16#0014#,
         16#0015#, 16#0016#, 16#0017#, 16#1F72#,
         16#1F73#, 16#0361#, 16#02C8#, 16#02CC#,
         16#02D0#, 16#02D1#, 16#0306#, 16#203F#,
         16#030B#, 16#0301#, 16#0304#, 16#0300#,
         16#030F#, 16#030C#, 16#0302#, 16#0000#,
         16#02E5#, 16#02E6#, 16#02E7#, 16#02E8#,
         16#02E9#, 16#0018#, 16#0019#, 16#0325#,
         16#032C#, 16#0339#, 16#031C#, 16#031F#,
         16#0320#, 16#0308#, 16#033D#, 16#0329#,
         16#032F#, 16#02DE#, 16#0324#, 16#0330#,
         16#033C#, 16#0334#, 16#031D#, 16#031E#,
         16#0318#, 16#0319#, 16#032A#, 16#033A#,
         16#033B#, 16#0303#, 16#031A#, 16#2776#,
         16#2777#, 16#2778#, 16#2779#, 16#277A#,
         16#277B#, 16#277C#, 16#277D#, 16#277E#,
         16#277F#, 16#24EB#, 16#24EC#, 16#24ED#,
         16#24EE#, 16#24EF#, 16#24F0#, 16#24F1#,
         16#24F2#, 16#24F3#, 16#24F4#, 16#2170#,
         16#2171#, 16#2172#, 16#2173#, 16#2174#,
         16#2175#, 16#2176#, 16#2177#, 16#2178#,
         16#2179#, 16#217A#, 16#217B#, 16#24D0#,
         16#24D1#, 16#24D2#, 16#24D3#, 16#24D4#,
         16#24D5#, 16#24D6#, 16#24D7#, 16#24D8#,
         16#24D9#, 16#24DA#, 16#24DB#, 16#24DC#,
         16#24DD#, 16#24DE#, 16#24DF#, 16#24E0#,
         16#24E1#, 16#24E2#, 16#24E3#, 16#24E4#,
         16#24E5#, 16#24E6#, 16#24E7#, 16#24E8#,
         16#24E9#, 16#32D0#, 16#32D1#, 16#32D2#,
         16#32D3#, 16#32D4#, 16#32D5#, 16#32D6#,
         16#32D7#, 16#32D8#, 16#32D9#, 16#32DA#,
         16#32DB#, 16#32DC#, 16#32DD#, 16#32DE#,
         16#32DF#, 16#32E0#, 16#32E1#, 16#32E2#,
         16#32E3#, 16#32FA#, 16#32E9#, 16#32E5#,
         16#32ED#, 16#32EC#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#2051#,
         16#2042#, 16#0000#, 16#0000#, 16#0000#);

   Decode_Double_87 : aliased constant SHIFTJIS_Code_Point_Array
     := (16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#2460#, 16#2461#, 16#2462#, 16#2463#,
         16#2464#, 16#2465#, 16#2466#, 16#2467#,
         16#2468#, 16#2469#, 16#246A#, 16#246B#,
         16#246C#, 16#246D#, 16#246E#, 16#246F#,
         16#2470#, 16#2471#, 16#2472#, 16#2473#,
         16#2160#, 16#2161#, 16#2162#, 16#2163#,
         16#2164#, 16#2165#, 16#2166#, 16#2167#,
         16#2168#, 16#2169#, 16#216A#, 16#3349#,
         16#3314#, 16#3322#, 16#334D#, 16#3318#,
         16#3327#, 16#3303#, 16#3336#, 16#3351#,
         16#3357#, 16#330D#, 16#3326#, 16#3323#,
         16#332B#, 16#334A#, 16#333B#, 16#339C#,
         16#339D#, 16#339E#, 16#338E#, 16#338F#,
         16#33C4#, 16#33A1#, 16#216B#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#337B#, 16#0000#,
         16#301D#, 16#301F#, 16#2116#, 16#33CD#,
         16#2121#, 16#32A4#, 16#32A5#, 16#32A6#,
         16#32A7#, 16#32A8#, 16#3231#, 16#3232#,
         16#3239#, 16#337E#, 16#337D#, 16#337C#,
         16#0000#, 16#0000#, 16#0000#, 16#222E#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#221F#, 16#22BF#, 16#0000#, 16#0000#,
         16#0000#, 16#2756#, 16#261E#, 16#4FF1#,
         16#02_000B#, 16#3402#, 16#4E28#, 16#4E2F#,
         16#4E30#, 16#4E8D#, 16#4EE1#, 16#4EFD#,
         16#4EFF#, 16#4F03#, 16#4F0B#, 16#4F60#,
         16#4F48#, 16#4F49#, 16#4F56#, 16#4F5F#,
         16#4F6A#, 16#4F6C#, 16#4F7E#, 16#4F8A#,
         16#4F94#, 16#4F97#, 16#FA30#, 16#4FC9#,
         16#4FE0#, 16#5001#, 16#5002#, 16#500E#,
         16#5018#, 16#5027#, 16#502E#, 16#5040#,
         16#503B#, 16#5041#, 16#5094#, 16#50CC#,
         16#50F2#, 16#50D0#, 16#50E6#, 16#FA31#,
         16#5106#, 16#5103#, 16#510B#, 16#511E#,
         16#5135#, 16#514A#, 16#FA32#, 16#5155#,
         16#5157#, 16#34B5#, 16#519D#, 16#51C3#,
         16#51CA#, 16#51DE#, 16#51E2#, 16#51EE#,
         16#5201#, 16#34DB#, 16#5213#, 16#5215#,
         16#5249#, 16#5257#, 16#5261#, 16#5293#,
         16#52C8#, 16#FA33#, 16#52CC#, 16#52D0#,
         16#52D6#, 16#52DB#, 16#FA34#, 16#52F0#,
         16#52FB#, 16#5300#, 16#5307#, 16#531C#,
         16#FA35#, 16#5361#, 16#5363#, 16#537D#,
         16#5393#, 16#539D#, 16#53B2#, 16#5412#,
         16#5427#, 16#544D#, 16#549C#, 16#546B#,
         16#5474#, 16#547F#, 16#5488#, 16#5496#,
         16#54A1#, 16#0000#, 16#0000#, 16#0000#);

   Decode_Double_88 : aliased constant SHIFTJIS_Code_Point_Array
     := (16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#54A9#, 16#54C6#, 16#54FF#, 16#550E#,
         16#552B#, 16#5535#, 16#5550#, 16#555E#,
         16#5581#, 16#5586#, 16#558E#, 16#FA36#,
         16#55AD#, 16#55CE#, 16#FA37#, 16#5608#,
         16#560E#, 16#563B#, 16#5649#, 16#5676#,
         16#5666#, 16#FA38#, 16#566F#, 16#5671#,
         16#5672#, 16#5699#, 16#569E#, 16#56A9#,
         16#56AC#, 16#56B3#, 16#56C9#, 16#56CA#,
         16#570A#, 16#02_123D#, 16#5721#, 16#572F#,
         16#5733#, 16#5734#, 16#5770#, 16#5777#,
         16#577C#, 16#579C#, 16#FA0F#, 16#02_131B#,
         16#57B8#, 16#57C7#, 16#57C8#, 16#57CF#,
         16#57E4#, 16#57ED#, 16#57F5#, 16#57F6#,
         16#57FF#, 16#5809#, 16#FA10#, 16#5861#,
         16#5864#, 16#FA39#, 16#587C#, 16#5889#,
         16#589E#, 16#FA3A#, 16#58A9#, 16#0000#,
         16#02_146E#, 16#58D2#, 16#58CE#, 16#58D4#,
         16#58DA#, 16#58E0#, 16#58E9#, 16#590C#,
         16#8641#, 16#595D#, 16#596D#, 16#598B#,
         16#5992#, 16#59A4#, 16#59C3#, 16#59D2#,
         16#59DD#, 16#5A13#, 16#5A23#, 16#5A67#,
         16#5A6D#, 16#5A77#, 16#5A7E#, 16#5A84#,
         16#5A9E#, 16#5AA7#, 16#5AC4#, 16#02_18BD#,
         16#5B19#, 16#5B25#, 16#525D#, 16#4E9C#,
         16#5516#, 16#5A03#, 16#963F#, 16#54C0#,
         16#611B#, 16#6328#, 16#59F6#, 16#9022#,
         16#8475#, 16#831C#, 16#7A50#, 16#60AA#,
         16#63E1#, 16#6E25#, 16#65ED#, 16#8466#,
         16#82A6#, 16#9BF5#, 16#6893#, 16#5727#,
         16#65A1#, 16#6271#, 16#5B9B#, 16#59D0#,
         16#867B#, 16#98F4#, 16#7D62#, 16#7DBE#,
         16#9B8E#, 16#6216#, 16#7C9F#, 16#88B7#,
         16#5B89#, 16#5EB5#, 16#6309#, 16#6697#,
         16#6848#, 16#95C7#, 16#978D#, 16#674F#,
         16#4EE5#, 16#4F0A#, 16#4F4D#, 16#4F9D#,
         16#5049#, 16#56F2#, 16#5937#, 16#59D4#,
         16#5A01#, 16#5C09#, 16#60DF#, 16#610F#,
         16#6170#, 16#6613#, 16#6905#, 16#70BA#,
         16#754F#, 16#7570#, 16#79FB#, 16#7DAD#,
         16#7DEF#, 16#80C3#, 16#840E#, 16#8863#,
         16#8B02#, 16#9055#, 16#907A#, 16#533B#,
         16#4E95#, 16#4EA5#, 16#57DF#, 16#80B2#,
         16#90C1#, 16#78EF#, 16#4E00#, 16#58F1#,
         16#6EA2#, 16#9038#, 16#7A32#, 16#8328#,
         16#828B#, 16#9C2F#, 16#5141#, 16#5370#,
         16#54BD#, 16#54E1#, 16#56E0#, 16#59FB#,
         16#5F15#, 16#98F2#, 16#6DEB#, 16#80E4#,
         16#852D#, 16#0000#, 16#0000#, 16#0000#);

   Decode_Double_89 : aliased constant SHIFTJIS_Code_Point_Array
     := (16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#9662#, 16#9670#, 16#96A0#, 16#97FB#,
         16#540B#, 16#53F3#, 16#5B87#, 16#70CF#,
         16#7FBD#, 16#8FC2#, 16#96E8#, 16#536F#,
         16#9D5C#, 16#7ABA#, 16#4E11#, 16#7893#,
         16#81FC#, 16#6E26#, 16#5618#, 16#5504#,
         16#6B1D#, 16#851A#, 16#9C3B#, 16#59E5#,
         16#53A9#, 16#6D66#, 16#74DC#, 16#958F#,
         16#5642#, 16#4E91#, 16#904B#, 16#96F2#,
         16#834F#, 16#990C#, 16#53E1#, 16#55B6#,
         16#5B30#, 16#5F71#, 16#6620#, 16#66F3#,
         16#6804#, 16#6C38#, 16#6CF3#, 16#6D29#,
         16#745B#, 16#76C8#, 16#7A4E#, 16#9834#,
         16#82F1#, 16#885B#, 16#8A60#, 16#92ED#,
         16#6DB2#, 16#75AB#, 16#76CA#, 16#99C5#,
         16#60A6#, 16#8B01#, 16#8D8A#, 16#95B2#,
         16#698E#, 16#53AD#, 16#5186#, 16#0000#,
         16#5712#, 16#5830#, 16#5944#, 16#5BB4#,
         16#5EF6#, 16#6028#, 16#63A9#, 16#63F4#,
         16#6CBF#, 16#6F14#, 16#708E#, 16#7114#,
         16#7159#, 16#71D5#, 16#733F#, 16#7E01#,
         16#8276#, 16#82D1#, 16#8597#, 16#9060#,
         16#925B#, 16#9D1B#, 16#5869#, 16#65BC#,
         16#6C5A#, 16#7525#, 16#51F9#, 16#592E#,
         16#5965#, 16#5F80#, 16#5FDC#, 16#62BC#,
         16#65FA#, 16#6A2A#, 16#6B27#, 16#6BB4#,
         16#738B#, 16#7FC1#, 16#8956#, 16#9D2C#,
         16#9D0E#, 16#9EC4#, 16#5CA1#, 16#6C96#,
         16#837B#, 16#5104#, 16#5C4B#, 16#61B6#,
         16#81C6#, 16#6876#, 16#7261#, 16#4E59#,
         16#4FFA#, 16#5378#, 16#6069#, 16#6E29#,
         16#7A4F#, 16#97F3#, 16#4E0B#, 16#5316#,
         16#4EEE#, 16#4F55#, 16#4F3D#, 16#4FA1#,
         16#4F73#, 16#52A0#, 16#53EF#, 16#5609#,
         16#590F#, 16#5AC1#, 16#5BB6#, 16#5BE1#,
         16#79D1#, 16#6687#, 16#679C#, 16#67B6#,
         16#6B4C#, 16#6CB3#, 16#706B#, 16#73C2#,
         16#798D#, 16#79BE#, 16#7A3C#, 16#7B87#,
         16#82B1#, 16#82DB#, 16#8304#, 16#8377#,
         16#83EF#, 16#83D3#, 16#8766#, 16#8AB2#,
         16#5629#, 16#8CA8#, 16#8FE6#, 16#904E#,
         16#971E#, 16#868A#, 16#4FC4#, 16#5CE8#,
         16#6211#, 16#7259#, 16#753B#, 16#81E5#,
         16#82BD#, 16#86FE#, 16#8CC0#, 16#96C5#,
         16#9913#, 16#99D5#, 16#4ECB#, 16#4F1A#,
         16#89E3#, 16#56DE#, 16#584A#, 16#58CA#,
         16#5EFB#, 16#5FEB#, 16#602A#, 16#6094#,
         16#6062#, 16#61D0#, 16#6212#, 16#62D0#,
         16#6539#, 16#0000#, 16#0000#, 16#0000#);

   Decode_Double_8A : aliased constant SHIFTJIS_Code_Point_Array
     := (16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#9B41#, 16#6666#, 16#68B0#, 16#6D77#,
         16#7070#, 16#754C#, 16#7686#, 16#7D75#,
         16#82A5#, 16#87F9#, 16#958B#, 16#968E#,
         16#8C9D#, 16#51F1#, 16#52BE#, 16#5916#,
         16#54B3#, 16#5BB3#, 16#5D16#, 16#6168#,
         16#6982#, 16#6DAF#, 16#788D#, 16#84CB#,
         16#8857#, 16#8A72#, 16#93A7#, 16#9AB8#,
         16#6D6C#, 16#99A8#, 16#86D9#, 16#57A3#,
         16#67FF#, 16#86CE#, 16#920E#, 16#5283#,
         16#5687#, 16#5404#, 16#5ED3#, 16#62E1#,
         16#64B9#, 16#683C#, 16#6838#, 16#6BBB#,
         16#7372#, 16#78BA#, 16#7A6B#, 16#899A#,
         16#89D2#, 16#8D6B#, 16#8F03#, 16#90ED#,
         16#95A3#, 16#9694#, 16#9769#, 16#5B66#,
         16#5CB3#, 16#697D#, 16#984D#, 16#984E#,
         16#639B#, 16#7B20#, 16#6A2B#, 16#0000#,
         16#6A7F#, 16#68B6#, 16#9C0D#, 16#6F5F#,
         16#5272#, 16#559D#, 16#6070#, 16#62EC#,
         16#6D3B#, 16#6E07#, 16#6ED1#, 16#845B#,
         16#8910#, 16#8F44#, 16#4E14#, 16#9C39#,
         16#53F6#, 16#691B#, 16#6A3A#, 16#9784#,
         16#682A#, 16#515C#, 16#7AC3#, 16#84B2#,
         16#91DC#, 16#938C#, 16#565B#, 16#9D28#,
         16#6822#, 16#8305#, 16#8431#, 16#7CA5#,
         16#5208#, 16#82C5#, 16#74E6#, 16#4E7E#,
         16#4F83#, 16#51A0#, 16#5BD2#, 16#520A#,
         16#52D8#, 16#52E7#, 16#5DFB#, 16#559A#,
         16#582A#, 16#59E6#, 16#5B8C#, 16#5B98#,
         16#5BDB#, 16#5E72#, 16#5E79#, 16#60A3#,
         16#611F#, 16#6163#, 16#61BE#, 16#63DB#,
         16#6562#, 16#67D1#, 16#6853#, 16#68FA#,
         16#6B3E#, 16#6B53#, 16#6C57#, 16#6F22#,
         16#6F97#, 16#6F45#, 16#74B0#, 16#7518#,
         16#76E3#, 16#770B#, 16#7AFF#, 16#7BA1#,
         16#7C21#, 16#7DE9#, 16#7F36#, 16#7FF0#,
         16#809D#, 16#8266#, 16#839E#, 16#89B3#,
         16#8ACC#, 16#8CAB#, 16#9084#, 16#9451#,
         16#9593#, 16#9591#, 16#95A2#, 16#9665#,
         16#97D3#, 16#9928#, 16#8218#, 16#4E38#,
         16#542B#, 16#5CB8#, 16#5DCC#, 16#73A9#,
         16#764C#, 16#773C#, 16#5CA9#, 16#7FEB#,
         16#8D0B#, 16#96C1#, 16#9811#, 16#9854#,
         16#9858#, 16#4F01#, 16#4F0E#, 16#5371#,
         16#559C#, 16#5668#, 16#57FA#, 16#5947#,
         16#5B09#, 16#5BC4#, 16#5C90#, 16#5E0C#,
         16#5E7E#, 16#5FCC#, 16#63EE#, 16#673A#,
         16#65D7#, 16#65E2#, 16#671F#, 16#68CB#,
         16#68C4#, 16#0000#, 16#0000#, 16#0000#);

   Decode_Double_8B : aliased constant SHIFTJIS_Code_Point_Array
     := (16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#6A5F#, 16#5E30#, 16#6BC5#, 16#6C17#,
         16#6C7D#, 16#757F#, 16#7948#, 16#5B63#,
         16#7A00#, 16#7D00#, 16#5FBD#, 16#898F#,
         16#8A18#, 16#8CB4#, 16#8D77#, 16#8ECC#,
         16#8F1D#, 16#98E2#, 16#9A0E#, 16#9B3C#,
         16#4E80#, 16#507D#, 16#5100#, 16#5993#,
         16#5B9C#, 16#622F#, 16#6280#, 16#64EC#,
         16#6B3A#, 16#72A0#, 16#7591#, 16#7947#,
         16#7FA9#, 16#87FB#, 16#8ABC#, 16#8B70#,
         16#63AC#, 16#83CA#, 16#97A0#, 16#5409#,
         16#5403#, 16#55AB#, 16#6854#, 16#6A58#,
         16#8A70#, 16#7827#, 16#6775#, 16#9ECD#,
         16#5374#, 16#5BA2#, 16#811A#, 16#8650#,
         16#9006#, 16#4E18#, 16#4E45#, 16#4EC7#,
         16#4F11#, 16#53CA#, 16#5438#, 16#5BAE#,
         16#5F13#, 16#6025#, 16#6551#, 16#0000#,
         16#673D#, 16#6C42#, 16#6C72#, 16#6CE3#,
         16#7078#, 16#7403#, 16#7A76#, 16#7AAE#,
         16#7B08#, 16#7D1A#, 16#7CFE#, 16#7D66#,
         16#65E7#, 16#725B#, 16#53BB#, 16#5C45#,
         16#5DE8#, 16#62D2#, 16#62E0#, 16#6319#,
         16#6E20#, 16#865A#, 16#8A31#, 16#8DDD#,
         16#92F8#, 16#6F01#, 16#79A6#, 16#9B5A#,
         16#4EA8#, 16#4EAB#, 16#4EAC#, 16#4F9B#,
         16#4FA0#, 16#50D1#, 16#5147#, 16#7AF6#,
         16#5171#, 16#51F6#, 16#5354#, 16#5321#,
         16#537F#, 16#53EB#, 16#55AC#, 16#5883#,
         16#5CE1#, 16#5F37#, 16#5F4A#, 16#602F#,
         16#6050#, 16#606D#, 16#631F#, 16#6559#,
         16#6A4B#, 16#6CC1#, 16#72C2#, 16#72ED#,
         16#77EF#, 16#80F8#, 16#8105#, 16#8208#,
         16#854E#, 16#90F7#, 16#93E1#, 16#97FF#,
         16#9957#, 16#9A5A#, 16#4EF0#, 16#51DD#,
         16#5C2D#, 16#6681#, 16#696D#, 16#5C40#,
         16#66F2#, 16#6975#, 16#7389#, 16#6850#,
         16#7C81#, 16#50C5#, 16#52E4#, 16#5747#,
         16#5DFE#, 16#9326#, 16#65A4#, 16#6B23#,
         16#6B3D#, 16#7434#, 16#7981#, 16#79BD#,
         16#7B4B#, 16#7DCA#, 16#82B9#, 16#83CC#,
         16#887F#, 16#895F#, 16#8B39#, 16#8FD1#,
         16#91D1#, 16#541F#, 16#9280#, 16#4E5D#,
         16#5036#, 16#53E5#, 16#533A#, 16#72D7#,
         16#7396#, 16#77E9#, 16#82E6#, 16#8EAF#,
         16#99C6#, 16#99C8#, 16#99D2#, 16#5177#,
         16#611A#, 16#865E#, 16#55B0#, 16#7A7A#,
         16#5076#, 16#5BD3#, 16#9047#, 16#9685#,
         16#4E32#, 16#6ADB#, 16#91E7#, 16#5C51#,
         16#5C48#, 16#0000#, 16#0000#, 16#0000#);

   Decode_Double_8C : aliased constant SHIFTJIS_Code_Point_Array
     := (16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#6398#, 16#7A9F#, 16#6C93#, 16#9774#,
         16#8F61#, 16#7AAA#, 16#718A#, 16#9688#,
         16#7C82#, 16#6817#, 16#7E70#, 16#6851#,
         16#936C#, 16#52F2#, 16#541B#, 16#85AB#,
         16#8A13#, 16#7FA4#, 16#8ECD#, 16#90E1#,
         16#5366#, 16#8888#, 16#7941#, 16#4FC2#,
         16#50BE#, 16#5211#, 16#5144#, 16#5553#,
         16#572D#, 16#73EA#, 16#578B#, 16#5951#,
         16#5F62#, 16#5F84#, 16#6075#, 16#6176#,
         16#6167#, 16#61A9#, 16#63B2#, 16#643A#,
         16#656C#, 16#666F#, 16#6842#, 16#6E13#,
         16#7566#, 16#7A3D#, 16#7CFB#, 16#7D4C#,
         16#7D99#, 16#7E4B#, 16#7F6B#, 16#830E#,
         16#834A#, 16#86CD#, 16#8A08#, 16#8A63#,
         16#8B66#, 16#8EFD#, 16#981A#, 16#9D8F#,
         16#82B8#, 16#8FCE#, 16#9BE8#, 16#0000#,
         16#5287#, 16#621F#, 16#6483#, 16#6FC0#,
         16#9699#, 16#6841#, 16#5091#, 16#6B20#,
         16#6C7A#, 16#6F54#, 16#7A74#, 16#7D50#,
         16#8840#, 16#8A23#, 16#6708#, 16#4EF6#,
         16#5039#, 16#5026#, 16#5065#, 16#517C#,
         16#5238#, 16#5263#, 16#55A7#, 16#570F#,
         16#5805#, 16#5ACC#, 16#5EFA#, 16#61B2#,
         16#61F8#, 16#62F3#, 16#6372#, 16#691C#,
         16#6A29#, 16#727D#, 16#72AC#, 16#732E#,
         16#7814#, 16#786F#, 16#7D79#, 16#770C#,
         16#80A9#, 16#898B#, 16#8B19#, 16#8CE2#,
         16#8ED2#, 16#9063#, 16#9375#, 16#967A#,
         16#9855#, 16#9A13#, 16#9E78#, 16#5143#,
         16#539F#, 16#53B3#, 16#5E7B#, 16#5F26#,
         16#6E1B#, 16#6E90#, 16#7384#, 16#73FE#,
         16#7D43#, 16#8237#, 16#8A00#, 16#8AFA#,
         16#9650#, 16#4E4E#, 16#500B#, 16#53E4#,
         16#547C#, 16#56FA#, 16#59D1#, 16#5B64#,
         16#5DF1#, 16#5EAB#, 16#5F27#, 16#6238#,
         16#6545#, 16#67AF#, 16#6E56#, 16#72D0#,
         16#7CCA#, 16#88B4#, 16#80A1#, 16#80E1#,
         16#83F0#, 16#864E#, 16#8A87#, 16#8DE8#,
         16#9237#, 16#96C7#, 16#9867#, 16#9F13#,
         16#4E94#, 16#4E92#, 16#4F0D#, 16#5348#,
         16#5449#, 16#543E#, 16#5A2F#, 16#5F8C#,
         16#5FA1#, 16#609F#, 16#68A7#, 16#6A8E#,
         16#745A#, 16#7881#, 16#8A9E#, 16#8AA4#,
         16#8B77#, 16#9190#, 16#4E5E#, 16#9BC9#,
         16#4EA4#, 16#4F7C#, 16#4FAF#, 16#5019#,
         16#5016#, 16#5149#, 16#516C#, 16#529F#,
         16#52B9#, 16#52FE#, 16#539A#, 16#53E3#,
         16#5411#, 16#0000#, 16#0000#, 16#0000#);

   Decode_Double_8D : aliased constant SHIFTJIS_Code_Point_Array
     := (16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#540E#, 16#5589#, 16#5751#, 16#57A2#,
         16#597D#, 16#5B54#, 16#5B5D#, 16#5B8F#,
         16#5DE5#, 16#5DE7#, 16#5DF7#, 16#5E78#,
         16#5E83#, 16#5E9A#, 16#5EB7#, 16#5F18#,
         16#6052#, 16#614C#, 16#6297#, 16#62D8#,
         16#63A7#, 16#653B#, 16#6602#, 16#6643#,
         16#66F4#, 16#676D#, 16#6821#, 16#6897#,
         16#69CB#, 16#6C5F#, 16#6D2A#, 16#6D69#,
         16#6E2F#, 16#6E9D#, 16#7532#, 16#7687#,
         16#786C#, 16#7A3F#, 16#7CE0#, 16#7D05#,
         16#7D18#, 16#7D5E#, 16#7DB1#, 16#8015#,
         16#8003#, 16#80AF#, 16#80B1#, 16#8154#,
         16#818F#, 16#822A#, 16#8352#, 16#884C#,
         16#8861#, 16#8B1B#, 16#8CA2#, 16#8CFC#,
         16#90CA#, 16#9175#, 16#9271#, 16#783F#,
         16#92FC#, 16#95A4#, 16#964D#, 16#0000#,
         16#9805#, 16#9999#, 16#9AD8#, 16#9D3B#,
         16#525B#, 16#52AB#, 16#53F7#, 16#5408#,
         16#58D5#, 16#62F7#, 16#6FE0#, 16#8C6A#,
         16#8F5F#, 16#9EB9#, 16#514B#, 16#523B#,
         16#544A#, 16#56FD#, 16#7A40#, 16#9177#,
         16#9D60#, 16#9ED2#, 16#7344#, 16#6F09#,
         16#8170#, 16#7511#, 16#5FFD#, 16#60DA#,
         16#9AA8#, 16#72DB#, 16#8FBC#, 16#6B64#,
         16#9803#, 16#4ECA#, 16#56F0#, 16#5764#,
         16#58BE#, 16#5A5A#, 16#6068#, 16#61C7#,
         16#660F#, 16#6606#, 16#6839#, 16#68B1#,
         16#6DF7#, 16#75D5#, 16#7D3A#, 16#826E#,
         16#9B42#, 16#4E9B#, 16#4F50#, 16#53C9#,
         16#5506#, 16#5D6F#, 16#5DE6#, 16#5DEE#,
         16#67FB#, 16#6C99#, 16#7473#, 16#7802#,
         16#8A50#, 16#9396#, 16#88DF#, 16#5750#,
         16#5EA7#, 16#632B#, 16#50B5#, 16#50AC#,
         16#518D#, 16#6700#, 16#54C9#, 16#585E#,
         16#59BB#, 16#5BB0#, 16#5F69#, 16#624D#,
         16#63A1#, 16#683D#, 16#6B73#, 16#6E08#,
         16#707D#, 16#91C7#, 16#7280#, 16#7815#,
         16#7826#, 16#796D#, 16#658E#, 16#7D30#,
         16#83DC#, 16#88C1#, 16#8F09#, 16#969B#,
         16#5264#, 16#5728#, 16#6750#, 16#7F6A#,
         16#8CA1#, 16#51B4#, 16#5742#, 16#962A#,
         16#583A#, 16#698A#, 16#80B4#, 16#54B2#,
         16#5D0E#, 16#57FC#, 16#7895#, 16#9DFA#,
         16#4F5C#, 16#524A#, 16#548B#, 16#643E#,
         16#6628#, 16#6714#, 16#67F5#, 16#7A84#,
         16#7B56#, 16#7D22#, 16#932F#, 16#685C#,
         16#9BAD#, 16#7B39#, 16#5319#, 16#518A#,
         16#5237#, 16#0000#, 16#0000#, 16#0000#);

   Decode_Double_8E : aliased constant SHIFTJIS_Code_Point_Array
     := (16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#5BDF#, 16#62F6#, 16#64AE#, 16#64E6#,
         16#672D#, 16#6BBA#, 16#85A9#, 16#96D1#,
         16#7690#, 16#9BD6#, 16#634C#, 16#9306#,
         16#9BAB#, 16#76BF#, 16#6652#, 16#4E09#,
         16#5098#, 16#53C2#, 16#5C71#, 16#60E8#,
         16#6492#, 16#6563#, 16#685F#, 16#71E6#,
         16#73CA#, 16#7523#, 16#7B97#, 16#7E82#,
         16#8695#, 16#8B83#, 16#8CDB#, 16#9178#,
         16#9910#, 16#65AC#, 16#66AB#, 16#6B8B#,
         16#4ED5#, 16#4ED4#, 16#4F3A#, 16#4F7F#,
         16#523A#, 16#53F8#, 16#53F2#, 16#55E3#,
         16#56DB#, 16#58EB#, 16#59CB#, 16#59C9#,
         16#59FF#, 16#5B50#, 16#5C4D#, 16#5E02#,
         16#5E2B#, 16#5FD7#, 16#601D#, 16#6307#,
         16#652F#, 16#5B5C#, 16#65AF#, 16#65BD#,
         16#65E8#, 16#679D#, 16#6B62#, 16#0000#,
         16#6B7B#, 16#6C0F#, 16#7345#, 16#7949#,
         16#79C1#, 16#7CF8#, 16#7D19#, 16#7D2B#,
         16#80A2#, 16#8102#, 16#81F3#, 16#8996#,
         16#8A5E#, 16#8A69#, 16#8A66#, 16#8A8C#,
         16#8AEE#, 16#8CC7#, 16#8CDC#, 16#96CC#,
         16#98FC#, 16#6B6F#, 16#4E8B#, 16#4F3C#,
         16#4F8D#, 16#5150#, 16#5B57#, 16#5BFA#,
         16#6148#, 16#6301#, 16#6642#, 16#6B21#,
         16#6ECB#, 16#6CBB#, 16#723E#, 16#74BD#,
         16#75D4#, 16#78C1#, 16#793A#, 16#800C#,
         16#8033#, 16#81EA#, 16#8494#, 16#8F9E#,
         16#6C50#, 16#9E7F#, 16#5F0F#, 16#8B58#,
         16#9D2B#, 16#7AFA#, 16#8EF8#, 16#5B8D#,
         16#96EB#, 16#4E03#, 16#53F1#, 16#57F7#,
         16#5931#, 16#5AC9#, 16#5BA4#, 16#6089#,
         16#6E7F#, 16#6F06#, 16#75BE#, 16#8CEA#,
         16#5B9F#, 16#8500#, 16#7BE0#, 16#5072#,
         16#67F4#, 16#829D#, 16#5C61#, 16#854A#,
         16#7E1E#, 16#820E#, 16#5199#, 16#5C04#,
         16#6368#, 16#8D66#, 16#659C#, 16#716E#,
         16#793E#, 16#7D17#, 16#8005#, 16#8B1D#,
         16#8ECA#, 16#906E#, 16#86C7#, 16#90AA#,
         16#501F#, 16#52FA#, 16#5C3A#, 16#6753#,
         16#707C#, 16#7235#, 16#914C#, 16#91C8#,
         16#932B#, 16#82E5#, 16#5BC2#, 16#5F31#,
         16#60F9#, 16#4E3B#, 16#53D6#, 16#5B88#,
         16#624B#, 16#6731#, 16#6B8A#, 16#72E9#,
         16#73E0#, 16#7A2E#, 16#816B#, 16#8DA3#,
         16#9152#, 16#9996#, 16#5112#, 16#53D7#,
         16#546A#, 16#5BFF#, 16#6388#, 16#6A39#,
         16#7DAC#, 16#9700#, 16#56DA#, 16#53CE#,
         16#5468#, 16#0000#, 16#0000#, 16#0000#);

   Decode_Double_8F : aliased constant SHIFTJIS_Code_Point_Array
     := (16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#5B97#, 16#5C31#, 16#5DDE#, 16#4FEE#,
         16#6101#, 16#62FE#, 16#6D32#, 16#79C0#,
         16#79CB#, 16#7D42#, 16#7E4D#, 16#7FD2#,
         16#81ED#, 16#821F#, 16#8490#, 16#8846#,
         16#8972#, 16#8B90#, 16#8E74#, 16#8F2F#,
         16#9031#, 16#914B#, 16#916C#, 16#96C6#,
         16#919C#, 16#4EC0#, 16#4F4F#, 16#5145#,
         16#5341#, 16#5F93#, 16#620E#, 16#67D4#,
         16#6C41#, 16#6E0B#, 16#7363#, 16#7E26#,
         16#91CD#, 16#9283#, 16#53D4#, 16#5919#,
         16#5BBF#, 16#6DD1#, 16#795D#, 16#7E2E#,
         16#7C9B#, 16#587E#, 16#719F#, 16#51FA#,
         16#8853#, 16#8FF0#, 16#4FCA#, 16#5CFB#,
         16#6625#, 16#77AC#, 16#7AE3#, 16#821C#,
         16#99FF#, 16#51C6#, 16#5FAA#, 16#65EC#,
         16#696F#, 16#6B89#, 16#6DF3#, 16#0000#,
         16#6E96#, 16#6F64#, 16#76FE#, 16#7D14#,
         16#5DE1#, 16#9075#, 16#9187#, 16#9806#,
         16#51E6#, 16#521D#, 16#6240#, 16#6691#,
         16#66D9#, 16#6E1A#, 16#5EB6#, 16#7DD2#,
         16#7F72#, 16#66F8#, 16#85AF#, 16#85F7#,
         16#8AF8#, 16#52A9#, 16#53D9#, 16#5973#,
         16#5E8F#, 16#5F90#, 16#6055#, 16#92E4#,
         16#9664#, 16#50B7#, 16#511F#, 16#52DD#,
         16#5320#, 16#5347#, 16#53EC#, 16#54E8#,
         16#5546#, 16#5531#, 16#5617#, 16#5968#,
         16#59BE#, 16#5A3C#, 16#5BB5#, 16#5C06#,
         16#5C0F#, 16#5C11#, 16#5C1A#, 16#5E84#,
         16#5E8A#, 16#5EE0#, 16#5F70#, 16#627F#,
         16#6284#, 16#62DB#, 16#638C#, 16#6377#,
         16#6607#, 16#660C#, 16#662D#, 16#6676#,
         16#677E#, 16#68A2#, 16#6A1F#, 16#6A35#,
         16#6CBC#, 16#6D88#, 16#6E09#, 16#6E58#,
         16#713C#, 16#7126#, 16#7167#, 16#75C7#,
         16#7701#, 16#785D#, 16#7901#, 16#7965#,
         16#79F0#, 16#7AE0#, 16#7B11#, 16#7CA7#,
         16#7D39#, 16#8096#, 16#83D6#, 16#848B#,
         16#8549#, 16#885D#, 16#88F3#, 16#8A1F#,
         16#8A3C#, 16#8A54#, 16#8A73#, 16#8C61#,
         16#8CDE#, 16#91A4#, 16#9266#, 16#937E#,
         16#9418#, 16#969C#, 16#9798#, 16#4E0A#,
         16#4E08#, 16#4E1E#, 16#4E57#, 16#5197#,
         16#5270#, 16#57CE#, 16#5834#, 16#58CC#,
         16#5B22#, 16#5E38#, 16#60C5#, 16#64FE#,
         16#6761#, 16#6756#, 16#6D44#, 16#72B6#,
         16#7573#, 16#7A63#, 16#84B8#, 16#8B72#,
         16#91B8#, 16#9320#, 16#5631#, 16#57F4#,
         16#98FE#, 16#0000#, 16#0000#, 16#0000#);

   Decode_Double_90 : aliased constant SHIFTJIS_Code_Point_Array
     := (16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#62ED#, 16#690D#, 16#6B96#, 16#71ED#,
         16#7E54#, 16#8077#, 16#8272#, 16#89E6#,
         16#98DF#, 16#8755#, 16#8FB1#, 16#5C3B#,
         16#4F38#, 16#4FE1#, 16#4FB5#, 16#5507#,
         16#5A20#, 16#5BDD#, 16#5BE9#, 16#5FC3#,
         16#614E#, 16#632F#, 16#65B0#, 16#664B#,
         16#68EE#, 16#699B#, 16#6D78#, 16#6DF1#,
         16#7533#, 16#75B9#, 16#771F#, 16#795E#,
         16#79E6#, 16#7D33#, 16#81E3#, 16#82AF#,
         16#85AA#, 16#89AA#, 16#8A3A#, 16#8EAB#,
         16#8F9B#, 16#9032#, 16#91DD#, 16#9707#,
         16#4EBA#, 16#4EC1#, 16#5203#, 16#5875#,
         16#58EC#, 16#5C0B#, 16#751A#, 16#5C3D#,
         16#814E#, 16#8A0A#, 16#8FC5#, 16#9663#,
         16#976D#, 16#7B25#, 16#8ACF#, 16#9808#,
         16#9162#, 16#56F3#, 16#53A8#, 16#0000#,
         16#9017#, 16#5439#, 16#5782#, 16#5E25#,
         16#63A8#, 16#6C34#, 16#708A#, 16#7761#,
         16#7C8B#, 16#7FE0#, 16#8870#, 16#9042#,
         16#9154#, 16#9310#, 16#9318#, 16#968F#,
         16#745E#, 16#9AC4#, 16#5D07#, 16#5D69#,
         16#6570#, 16#67A2#, 16#8DA8#, 16#96DB#,
         16#636E#, 16#6749#, 16#6919#, 16#83C5#,
         16#9817#, 16#96C0#, 16#88FE#, 16#6F84#,
         16#647A#, 16#5BF8#, 16#4E16#, 16#702C#,
         16#755D#, 16#662F#, 16#51C4#, 16#5236#,
         16#52E2#, 16#59D3#, 16#5F81#, 16#6027#,
         16#6210#, 16#653F#, 16#6574#, 16#661F#,
         16#6674#, 16#68F2#, 16#6816#, 16#6B63#,
         16#6E05#, 16#7272#, 16#751F#, 16#76DB#,
         16#7CBE#, 16#8056#, 16#58F0#, 16#88FD#,
         16#897F#, 16#8AA0#, 16#8A93#, 16#8ACB#,
         16#901D#, 16#9192#, 16#9752#, 16#9759#,
         16#6589#, 16#7A0E#, 16#8106#, 16#96BB#,
         16#5E2D#, 16#60DC#, 16#621A#, 16#65A5#,
         16#6614#, 16#6790#, 16#77F3#, 16#7A4D#,
         16#7C4D#, 16#7E3E#, 16#810A#, 16#8CAC#,
         16#8D64#, 16#8DE1#, 16#8E5F#, 16#78A9#,
         16#5207#, 16#62D9#, 16#63A5#, 16#6442#,
         16#6298#, 16#8A2D#, 16#7A83#, 16#7BC0#,
         16#8AAC#, 16#96EA#, 16#7D76#, 16#820C#,
         16#8749#, 16#4ED9#, 16#5148#, 16#5343#,
         16#5360#, 16#5BA3#, 16#5C02#, 16#5C16#,
         16#5DDD#, 16#6226#, 16#6247#, 16#64B0#,
         16#6813#, 16#6834#, 16#6CC9#, 16#6D45#,
         16#6D17#, 16#67D3#, 16#6F5C#, 16#714E#,
         16#717D#, 16#65CB#, 16#7A7F#, 16#7BAD#,
         16#7DDA#, 16#0000#, 16#0000#, 16#0000#);

   Decode_Double_91 : aliased constant SHIFTJIS_Code_Point_Array
     := (16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#7E4A#, 16#7FA8#, 16#817A#, 16#821B#,
         16#8239#, 16#85A6#, 16#8A6E#, 16#8CCE#,
         16#8DF5#, 16#9078#, 16#9077#, 16#92AD#,
         16#9291#, 16#9583#, 16#9BAE#, 16#524D#,
         16#5584#, 16#6F38#, 16#7136#, 16#5168#,
         16#7985#, 16#7E55#, 16#81B3#, 16#7CCE#,
         16#564C#, 16#5851#, 16#5CA8#, 16#63AA#,
         16#66FE#, 16#66FD#, 16#695A#, 16#72D9#,
         16#758F#, 16#758E#, 16#790E#, 16#7956#,
         16#79DF#, 16#7C97#, 16#7D20#, 16#7D44#,
         16#8607#, 16#8A34#, 16#963B#, 16#9061#,
         16#9F20#, 16#50E7#, 16#5275#, 16#53CC#,
         16#53E2#, 16#5009#, 16#55AA#, 16#58EE#,
         16#594F#, 16#723D#, 16#5B8B#, 16#5C64#,
         16#531D#, 16#60E3#, 16#60F3#, 16#635C#,
         16#6383#, 16#633F#, 16#63BB#, 16#0000#,
         16#64CD#, 16#65E9#, 16#66F9#, 16#5DE3#,
         16#69CD#, 16#69FD#, 16#6F15#, 16#71E5#,
         16#4E89#, 16#75E9#, 16#76F8#, 16#7A93#,
         16#7CDF#, 16#7DCF#, 16#7D9C#, 16#8061#,
         16#8349#, 16#8358#, 16#846C#, 16#84BC#,
         16#85FB#, 16#88C5#, 16#8D70#, 16#9001#,
         16#906D#, 16#9397#, 16#971C#, 16#9A12#,
         16#50CF#, 16#5897#, 16#618E#, 16#81D3#,
         16#8535#, 16#8D08#, 16#9020#, 16#4FC3#,
         16#5074#, 16#5247#, 16#5373#, 16#606F#,
         16#6349#, 16#675F#, 16#6E2C#, 16#8DB3#,
         16#901F#, 16#4FD7#, 16#5C5E#, 16#8CCA#,
         16#65CF#, 16#7D9A#, 16#5352#, 16#8896#,
         16#5176#, 16#63C3#, 16#5B58#, 16#5B6B#,
         16#5C0A#, 16#640D#, 16#6751#, 16#905C#,
         16#4ED6#, 16#591A#, 16#592A#, 16#6C70#,
         16#8A51#, 16#553E#, 16#5815#, 16#59A5#,
         16#60F0#, 16#6253#, 16#67C1#, 16#8235#,
         16#6955#, 16#9640#, 16#99C4#, 16#9A28#,
         16#4F53#, 16#5806#, 16#5BFE#, 16#8010#,
         16#5CB1#, 16#5E2F#, 16#5F85#, 16#6020#,
         16#614B#, 16#6234#, 16#66FF#, 16#6CF0#,
         16#6EDE#, 16#80CE#, 16#817F#, 16#82D4#,
         16#888B#, 16#8CB8#, 16#9000#, 16#902E#,
         16#968A#, 16#9EDB#, 16#9BDB#, 16#4EE3#,
         16#53F0#, 16#5927#, 16#7B2C#, 16#918D#,
         16#984C#, 16#9DF9#, 16#6EDD#, 16#7027#,
         16#5353#, 16#5544#, 16#5B85#, 16#6258#,
         16#629E#, 16#62D3#, 16#6CA2#, 16#6FEF#,
         16#7422#, 16#8A17#, 16#9438#, 16#6FC1#,
         16#8AFE#, 16#8338#, 16#51E7#, 16#86F8#,
         16#53EA#, 16#0000#, 16#0000#, 16#0000#);

   Decode_Double_92 : aliased constant SHIFTJIS_Code_Point_Array
     := (16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#53E9#, 16#4F46#, 16#9054#, 16#8FB0#,
         16#596A#, 16#8131#, 16#5DFD#, 16#7AEA#,
         16#8FBF#, 16#68DA#, 16#8C37#, 16#72F8#,
         16#9C48#, 16#6A3D#, 16#8AB0#, 16#4E39#,
         16#5358#, 16#5606#, 16#5766#, 16#62C5#,
         16#63A2#, 16#65E6#, 16#6B4E#, 16#6DE1#,
         16#6E5B#, 16#70AD#, 16#77ED#, 16#7AEF#,
         16#7BAA#, 16#7DBB#, 16#803D#, 16#80C6#,
         16#86CB#, 16#8A95#, 16#935B#, 16#56E3#,
         16#58C7#, 16#5F3E#, 16#65AD#, 16#6696#,
         16#6A80#, 16#6BB5#, 16#7537#, 16#8AC7#,
         16#5024#, 16#77E5#, 16#5730#, 16#5F1B#,
         16#6065#, 16#667A#, 16#6C60#, 16#75F4#,
         16#7A1A#, 16#7F6E#, 16#81F4#, 16#8718#,
         16#9045#, 16#99B3#, 16#7BC9#, 16#755C#,
         16#7AF9#, 16#7B51#, 16#84C4#, 16#0000#,
         16#9010#, 16#79E9#, 16#7A92#, 16#8336#,
         16#5AE1#, 16#7740#, 16#4E2D#, 16#4EF2#,
         16#5B99#, 16#5FE0#, 16#62BD#, 16#663C#,
         16#67F1#, 16#6CE8#, 16#866B#, 16#8877#,
         16#8A3B#, 16#914E#, 16#92F3#, 16#99D0#,
         16#6A17#, 16#7026#, 16#732A#, 16#82E7#,
         16#8457#, 16#8CAF#, 16#4E01#, 16#5146#,
         16#51CB#, 16#558B#, 16#5BF5#, 16#5E16#,
         16#5E33#, 16#5E81#, 16#5F14#, 16#5F35#,
         16#5F6B#, 16#5FB4#, 16#61F2#, 16#6311#,
         16#66A2#, 16#671D#, 16#6F6E#, 16#7252#,
         16#753A#, 16#773A#, 16#8074#, 16#8139#,
         16#8178#, 16#8776#, 16#8ABF#, 16#8ADC#,
         16#8D85#, 16#8DF3#, 16#929A#, 16#9577#,
         16#9802#, 16#9CE5#, 16#52C5#, 16#6357#,
         16#76F4#, 16#6715#, 16#6C88#, 16#73CD#,
         16#8CC3#, 16#93AE#, 16#9673#, 16#6D25#,
         16#589C#, 16#690E#, 16#69CC#, 16#8FFD#,
         16#939A#, 16#75DB#, 16#901A#, 16#585A#,
         16#6802#, 16#63B4#, 16#69FB#, 16#4F43#,
         16#6F2C#, 16#67D8#, 16#8FBB#, 16#8526#,
         16#7DB4#, 16#9354#, 16#693F#, 16#6F70#,
         16#576A#, 16#58F7#, 16#5B2C#, 16#7D2C#,
         16#722A#, 16#540A#, 16#91E3#, 16#9DB4#,
         16#4EAD#, 16#4F4E#, 16#505C#, 16#5075#,
         16#5243#, 16#8C9E#, 16#5448#, 16#5824#,
         16#5B9A#, 16#5E1D#, 16#5E95#, 16#5EAD#,
         16#5EF7#, 16#5F1F#, 16#608C#, 16#62B5#,
         16#633A#, 16#63D0#, 16#68AF#, 16#6C40#,
         16#7887#, 16#798E#, 16#7A0B#, 16#7DE0#,
         16#8247#, 16#8A02#, 16#8AE6#, 16#8E44#,
         16#9013#, 16#0000#, 16#0000#, 16#0000#);

   Decode_Double_93 : aliased constant SHIFTJIS_Code_Point_Array
     := (16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#90B8#, 16#912D#, 16#91D8#, 16#9F0E#,
         16#6CE5#, 16#6458#, 16#64E2#, 16#6575#,
         16#6EF4#, 16#7684#, 16#7B1B#, 16#9069#,
         16#93D1#, 16#6EBA#, 16#54F2#, 16#5FB9#,
         16#64A4#, 16#8F4D#, 16#8FED#, 16#9244#,
         16#5178#, 16#586B#, 16#5929#, 16#5C55#,
         16#5E97#, 16#6DFB#, 16#7E8F#, 16#751C#,
         16#8CBC#, 16#8EE2#, 16#985B#, 16#70B9#,
         16#4F1D#, 16#6BBF#, 16#6FB1#, 16#7530#,
         16#96FB#, 16#514E#, 16#5410#, 16#5835#,
         16#5857#, 16#59AC#, 16#5C60#, 16#5F92#,
         16#6597#, 16#675C#, 16#6E21#, 16#767B#,
         16#83DF#, 16#8CED#, 16#9014#, 16#90FD#,
         16#934D#, 16#7825#, 16#783A#, 16#52AA#,
         16#5EA6#, 16#571F#, 16#5974#, 16#6012#,
         16#5012#, 16#515A#, 16#51AC#, 16#0000#,
         16#51CD#, 16#5200#, 16#5510#, 16#5854#,
         16#5858#, 16#5957#, 16#5B95#, 16#5CF6#,
         16#5D8B#, 16#60BC#, 16#6295#, 16#642D#,
         16#6771#, 16#6843#, 16#68BC#, 16#68DF#,
         16#76D7#, 16#6DD8#, 16#6E6F#, 16#6D9B#,
         16#706F#, 16#71C8#, 16#5F53#, 16#75D8#,
         16#7977#, 16#7B49#, 16#7B54#, 16#7B52#,
         16#7CD6#, 16#7D71#, 16#5230#, 16#8463#,
         16#8569#, 16#85E4#, 16#8A0E#, 16#8B04#,
         16#8C46#, 16#8E0F#, 16#9003#, 16#900F#,
         16#9419#, 16#9676#, 16#982D#, 16#9A30#,
         16#95D8#, 16#50CD#, 16#52D5#, 16#540C#,
         16#5802#, 16#5C0E#, 16#61A7#, 16#649E#,
         16#6D1E#, 16#77B3#, 16#7AE5#, 16#80F4#,
         16#8404#, 16#9053#, 16#9285#, 16#5CE0#,
         16#9D07#, 16#533F#, 16#5F97#, 16#5FB3#,
         16#6D9C#, 16#7279#, 16#7763#, 16#79BF#,
         16#7BE4#, 16#6BD2#, 16#72EC#, 16#8AAD#,
         16#6803#, 16#6A61#, 16#51F8#, 16#7A81#,
         16#6934#, 16#5C4A#, 16#9CF6#, 16#82EB#,
         16#5BC5#, 16#9149#, 16#701E#, 16#5678#,
         16#5C6F#, 16#60C7#, 16#6566#, 16#6C8C#,
         16#8C5A#, 16#9041#, 16#9813#, 16#5451#,
         16#66C7#, 16#920D#, 16#5948#, 16#90A3#,
         16#5185#, 16#4E4D#, 16#51EA#, 16#8599#,
         16#8B0E#, 16#7058#, 16#637A#, 16#934B#,
         16#6962#, 16#99B4#, 16#7E04#, 16#7577#,
         16#5357#, 16#6960#, 16#8EDF#, 16#96E3#,
         16#6C5D#, 16#4E8C#, 16#5C3C#, 16#5F10#,
         16#8FE9#, 16#5302#, 16#8CD1#, 16#8089#,
         16#8679#, 16#5EFF#, 16#65E5#, 16#4E73#,
         16#5165#, 16#0000#, 16#0000#, 16#0000#);

   Decode_Double_94 : aliased constant SHIFTJIS_Code_Point_Array
     := (16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#5982#, 16#5C3F#, 16#97EE#, 16#4EFB#,
         16#598A#, 16#5FCD#, 16#8A8D#, 16#6FE1#,
         16#79B0#, 16#7962#, 16#5BE7#, 16#8471#,
         16#732B#, 16#71B1#, 16#5E74#, 16#5FF5#,
         16#637B#, 16#649A#, 16#71C3#, 16#7C98#,
         16#4E43#, 16#5EFC#, 16#4E4B#, 16#57DC#,
         16#56A2#, 16#60A9#, 16#6FC3#, 16#7D0D#,
         16#80FD#, 16#8133#, 16#81BF#, 16#8FB2#,
         16#8997#, 16#86A4#, 16#5DF4#, 16#628A#,
         16#64AD#, 16#8987#, 16#6777#, 16#6CE2#,
         16#6D3E#, 16#7436#, 16#7834#, 16#5A46#,
         16#7F75#, 16#82AD#, 16#99AC#, 16#4FF3#,
         16#5EC3#, 16#62DD#, 16#6392#, 16#6557#,
         16#676F#, 16#76C3#, 16#724C#, 16#80CC#,
         16#80BA#, 16#8F29#, 16#914D#, 16#500D#,
         16#57F9#, 16#5A92#, 16#6885#, 16#0000#,
         16#6973#, 16#7164#, 16#72FD#, 16#8CB7#,
         16#58F2#, 16#8CE0#, 16#966A#, 16#9019#,
         16#877F#, 16#79E4#, 16#77E7#, 16#8429#,
         16#4F2F#, 16#5265#, 16#535A#, 16#62CD#,
         16#67CF#, 16#6CCA#, 16#767D#, 16#7B94#,
         16#7C95#, 16#8236#, 16#8584#, 16#8FEB#,
         16#66DD#, 16#6F20#, 16#7206#, 16#7E1B#,
         16#83AB#, 16#99C1#, 16#9EA6#, 16#51FD#,
         16#7BB1#, 16#7872#, 16#7BB8#, 16#8087#,
         16#7B48#, 16#6AE8#, 16#5E61#, 16#808C#,
         16#7551#, 16#7560#, 16#516B#, 16#9262#,
         16#6E8C#, 16#767A#, 16#9197#, 16#9AEA#,
         16#4F10#, 16#7F70#, 16#629C#, 16#7B4F#,
         16#95A5#, 16#9CE9#, 16#567A#, 16#5859#,
         16#86E4#, 16#96BC#, 16#4F34#, 16#5224#,
         16#534A#, 16#53CD#, 16#53DB#, 16#5E06#,
         16#642C#, 16#6591#, 16#677F#, 16#6C3E#,
         16#6C4E#, 16#7248#, 16#72AF#, 16#73ED#,
         16#7554#, 16#7E41#, 16#822C#, 16#85E9#,
         16#8CA9#, 16#7BC4#, 16#91C6#, 16#7169#,
         16#9812#, 16#98EF#, 16#633D#, 16#6669#,
         16#756A#, 16#76E4#, 16#78D0#, 16#8543#,
         16#86EE#, 16#532A#, 16#5351#, 16#5426#,
         16#5983#, 16#5E87#, 16#5F7C#, 16#60B2#,
         16#6249#, 16#6279#, 16#62AB#, 16#6590#,
         16#6BD4#, 16#6CCC#, 16#75B2#, 16#76AE#,
         16#7891#, 16#79D8#, 16#7DCB#, 16#7F77#,
         16#80A5#, 16#88AB#, 16#8AB9#, 16#8CBB#,
         16#907F#, 16#975E#, 16#98DB#, 16#6A0B#,
         16#7C38#, 16#5099#, 16#5C3E#, 16#5FAE#,
         16#6787#, 16#6BD8#, 16#7435#, 16#7709#,
         16#7F8E#, 16#0000#, 16#0000#, 16#0000#);

   Decode_Double_95 : aliased constant SHIFTJIS_Code_Point_Array
     := (16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#9F3B#, 16#67CA#, 16#7A17#, 16#5339#,
         16#758B#, 16#9AED#, 16#5F66#, 16#819D#,
         16#83F1#, 16#8098#, 16#5F3C#, 16#5FC5#,
         16#7562#, 16#7B46#, 16#903C#, 16#6867#,
         16#59EB#, 16#5A9B#, 16#7D10#, 16#767E#,
         16#8B2C#, 16#4FF5#, 16#5F6A#, 16#6A19#,
         16#6C37#, 16#6F02#, 16#74E2#, 16#7968#,
         16#8868#, 16#8A55#, 16#8C79#, 16#5EDF#,
         16#63CF#, 16#75C5#, 16#79D2#, 16#82D7#,
         16#9328#, 16#92F2#, 16#849C#, 16#86ED#,
         16#9C2D#, 16#54C1#, 16#5F6C#, 16#658C#,
         16#6D5C#, 16#7015#, 16#8CA7#, 16#8CD3#,
         16#983B#, 16#654F#, 16#74F6#, 16#4E0D#,
         16#4ED8#, 16#57E0#, 16#592B#, 16#5A66#,
         16#5BCC#, 16#51A8#, 16#5E03#, 16#5E9C#,
         16#6016#, 16#6276#, 16#6577#, 16#0000#,
         16#65A7#, 16#666E#, 16#6D6E#, 16#7236#,
         16#7B26#, 16#8150#, 16#819A#, 16#8299#,
         16#8B5C#, 16#8CA0#, 16#8CE6#, 16#8D74#,
         16#961C#, 16#9644#, 16#4FAE#, 16#64AB#,
         16#6B66#, 16#821E#, 16#8461#, 16#856A#,
         16#90E8#, 16#5C01#, 16#6953#, 16#98A8#,
         16#847A#, 16#8557#, 16#4F0F#, 16#526F#,
         16#5FA9#, 16#5E45#, 16#670D#, 16#798F#,
         16#8179#, 16#8907#, 16#8986#, 16#6DF5#,
         16#5F17#, 16#6255#, 16#6CB8#, 16#4ECF#,
         16#7269#, 16#9B92#, 16#5206#, 16#543B#,
         16#5674#, 16#58B3#, 16#61A4#, 16#626E#,
         16#711A#, 16#596E#, 16#7C89#, 16#7CDE#,
         16#7D1B#, 16#96F0#, 16#6587#, 16#805E#,
         16#4E19#, 16#4F75#, 16#5175#, 16#5840#,
         16#5E63#, 16#5E73#, 16#5F0A#, 16#67C4#,
         16#4E26#, 16#853D#, 16#9589#, 16#965B#,
         16#7C73#, 16#9801#, 16#50FB#, 16#58C1#,
         16#7656#, 16#78A7#, 16#5225#, 16#77A5#,
         16#8511#, 16#7B86#, 16#504F#, 16#5909#,
         16#7247#, 16#7BC7#, 16#7DE8#, 16#8FBA#,
         16#8FD4#, 16#904D#, 16#4FBF#, 16#52C9#,
         16#5A29#, 16#5F01#, 16#97AD#, 16#4FDD#,
         16#8217#, 16#92EA#, 16#5703#, 16#6355#,
         16#6B69#, 16#752B#, 16#88DC#, 16#8F14#,
         16#7A42#, 16#52DF#, 16#5893#, 16#6155#,
         16#620A#, 16#66AE#, 16#6BCD#, 16#7C3F#,
         16#83E9#, 16#5023#, 16#4FF8#, 16#5305#,
         16#5446#, 16#5831#, 16#5949#, 16#5B9D#,
         16#5CF0#, 16#5CEF#, 16#5D29#, 16#5E96#,
         16#62B1#, 16#6367#, 16#653E#, 16#65B9#,
         16#670B#, 16#0000#, 16#0000#, 16#0000#);

   Decode_Double_96 : aliased constant SHIFTJIS_Code_Point_Array
     := (16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#6CD5#, 16#6CE1#, 16#70F9#, 16#7832#,
         16#7E2B#, 16#80DE#, 16#82B3#, 16#840C#,
         16#84EC#, 16#8702#, 16#8912#, 16#8A2A#,
         16#8C4A#, 16#90A6#, 16#92D2#, 16#98FD#,
         16#9CF3#, 16#9D6C#, 16#4E4F#, 16#4EA1#,
         16#508D#, 16#5256#, 16#574A#, 16#59A8#,
         16#5E3D#, 16#5FD8#, 16#5FD9#, 16#623F#,
         16#66B4#, 16#671B#, 16#67D0#, 16#68D2#,
         16#5192#, 16#7D21#, 16#80AA#, 16#81A8#,
         16#8B00#, 16#8C8C#, 16#8CBF#, 16#927E#,
         16#9632#, 16#5420#, 16#982C#, 16#5317#,
         16#50D5#, 16#535C#, 16#58A8#, 16#64B2#,
         16#6734#, 16#7267#, 16#7766#, 16#7A46#,
         16#91E6#, 16#52C3#, 16#6CA1#, 16#6B86#,
         16#5800#, 16#5E4C#, 16#5954#, 16#672C#,
         16#7FFB#, 16#51E1#, 16#76C6#, 16#0000#,
         16#6469#, 16#78E8#, 16#9B54#, 16#9EBB#,
         16#57CB#, 16#59B9#, 16#6627#, 16#679A#,
         16#6BCE#, 16#54E9#, 16#69D9#, 16#5E55#,
         16#819C#, 16#6795#, 16#9BAA#, 16#67FE#,
         16#9C52#, 16#685D#, 16#4EA6#, 16#4FE3#,
         16#53C8#, 16#62B9#, 16#672B#, 16#6CAB#,
         16#8FC4#, 16#4FAD#, 16#7E6D#, 16#9EBF#,
         16#4E07#, 16#6162#, 16#6E80#, 16#6F2B#,
         16#8513#, 16#5473#, 16#672A#, 16#9B45#,
         16#5DF3#, 16#7B95#, 16#5CAC#, 16#5BC6#,
         16#871C#, 16#6E4A#, 16#84D1#, 16#7A14#,
         16#8108#, 16#5999#, 16#7C8D#, 16#6C11#,
         16#7720#, 16#52D9#, 16#5922#, 16#7121#,
         16#725F#, 16#77DB#, 16#9727#, 16#9D61#,
         16#690B#, 16#5A7F#, 16#5A18#, 16#51A5#,
         16#540D#, 16#547D#, 16#660E#, 16#76DF#,
         16#8FF7#, 16#9298#, 16#9CF4#, 16#59EA#,
         16#725D#, 16#6EC5#, 16#514D#, 16#68C9#,
         16#7DBF#, 16#7DEC#, 16#9762#, 16#9EBA#,
         16#6478#, 16#6A21#, 16#8302#, 16#5984#,
         16#5B5F#, 16#6BDB#, 16#731B#, 16#76F2#,
         16#7DB2#, 16#8017#, 16#8499#, 16#5132#,
         16#6728#, 16#9ED9#, 16#76EE#, 16#6762#,
         16#52FF#, 16#9905#, 16#5C24#, 16#623B#,
         16#7C7E#, 16#8CB0#, 16#554F#, 16#60B6#,
         16#7D0B#, 16#9580#, 16#5301#, 16#4E5F#,
         16#51B6#, 16#591C#, 16#723A#, 16#8036#,
         16#91CE#, 16#5F25#, 16#77E2#, 16#5384#,
         16#5F79#, 16#7D04#, 16#85AC#, 16#8A33#,
         16#8E8D#, 16#9756#, 16#67F3#, 16#85AE#,
         16#9453#, 16#6109#, 16#6108#, 16#6CB9#,
         16#7652#, 16#0000#, 16#0000#, 16#0000#);

   Decode_Double_97 : aliased constant SHIFTJIS_Code_Point_Array
     := (16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#8AED#, 16#8F38#, 16#552F#, 16#4F51#,
         16#512A#, 16#52C7#, 16#53CB#, 16#5BA5#,
         16#5E7D#, 16#60A0#, 16#6182#, 16#63D6#,
         16#6709#, 16#67DA#, 16#6E67#, 16#6D8C#,
         16#7336#, 16#7337#, 16#7531#, 16#7950#,
         16#88D5#, 16#8A98#, 16#904A#, 16#9091#,
         16#90F5#, 16#96C4#, 16#878D#, 16#5915#,
         16#4E88#, 16#4F59#, 16#4E0E#, 16#8A89#,
         16#8F3F#, 16#9810#, 16#50AD#, 16#5E7C#,
         16#5996#, 16#5BB9#, 16#5EB8#, 16#63DA#,
         16#63FA#, 16#64C1#, 16#66DC#, 16#694A#,
         16#69D8#, 16#6D0B#, 16#6EB6#, 16#7194#,
         16#7528#, 16#7AAF#, 16#7F8A#, 16#8000#,
         16#8449#, 16#84C9#, 16#8981#, 16#8B21#,
         16#8E0A#, 16#9065#, 16#967D#, 16#990A#,
         16#617E#, 16#6291#, 16#6B32#, 16#0000#,
         16#6C83#, 16#6D74#, 16#7FCC#, 16#7FFC#,
         16#6DC0#, 16#7F85#, 16#87BA#, 16#88F8#,
         16#6765#, 16#83B1#, 16#983C#, 16#96F7#,
         16#6D1B#, 16#7D61#, 16#843D#, 16#916A#,
         16#4E71#, 16#5375#, 16#5D50#, 16#6B04#,
         16#6FEB#, 16#85CD#, 16#862D#, 16#89A7#,
         16#5229#, 16#540F#, 16#5C65#, 16#674E#,
         16#68A8#, 16#7406#, 16#7483#, 16#75E2#,
         16#88CF#, 16#88E1#, 16#91CC#, 16#96E2#,
         16#9678#, 16#5F8B#, 16#7387#, 16#7ACB#,
         16#844E#, 16#63A0#, 16#7565#, 16#5289#,
         16#6D41#, 16#6E9C#, 16#7409#, 16#7559#,
         16#786B#, 16#7C92#, 16#9686#, 16#7ADC#,
         16#9F8D#, 16#4FB6#, 16#616E#, 16#65C5#,
         16#865C#, 16#4E86#, 16#4EAE#, 16#50DA#,
         16#4E21#, 16#51CC#, 16#5BEE#, 16#6599#,
         16#6881#, 16#6DBC#, 16#731F#, 16#7642#,
         16#77AD#, 16#7A1C#, 16#7CE7#, 16#826F#,
         16#8AD2#, 16#907C#, 16#91CF#, 16#9675#,
         16#9818#, 16#529B#, 16#7DD1#, 16#502B#,
         16#5398#, 16#6797#, 16#6DCB#, 16#71D0#,
         16#7433#, 16#81E8#, 16#8F2A#, 16#96A3#,
         16#9C57#, 16#9E9F#, 16#7460#, 16#5841#,
         16#6D99#, 16#7D2F#, 16#985E#, 16#4EE4#,
         16#4F36#, 16#4F8B#, 16#51B7#, 16#52B1#,
         16#5DBA#, 16#601C#, 16#73B2#, 16#793C#,
         16#82D3#, 16#9234#, 16#96B7#, 16#96F6#,
         16#970A#, 16#9E97#, 16#9F62#, 16#66A6#,
         16#6B74#, 16#5217#, 16#52A3#, 16#70C8#,
         16#88C2#, 16#5EC9#, 16#604B#, 16#6190#,
         16#6F23#, 16#7149#, 16#7C3E#, 16#7DF4#,
         16#806F#, 16#0000#, 16#0000#, 16#0000#);

   Decode_Double_98 : aliased constant SHIFTJIS_Code_Point_Array
     := (16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#84EE#, 16#9023#, 16#932C#, 16#5442#,
         16#9B6F#, 16#6AD3#, 16#7089#, 16#8CC2#,
         16#8DEF#, 16#9732#, 16#52B4#, 16#5A41#,
         16#5ECA#, 16#5F04#, 16#6717#, 16#697C#,
         16#6994#, 16#6D6A#, 16#6F0F#, 16#7262#,
         16#72FC#, 16#7BED#, 16#8001#, 16#807E#,
         16#874B#, 16#90CE#, 16#516D#, 16#9E93#,
         16#7984#, 16#808B#, 16#9332#, 16#8AD6#,
         16#502D#, 16#548C#, 16#8A71#, 16#6B6A#,
         16#8CC4#, 16#8107#, 16#60D1#, 16#67A0#,
         16#9DF2#, 16#4E99#, 16#4E98#, 16#9C10#,
         16#8A6B#, 16#85C1#, 16#8568#, 16#6900#,
         16#6E7E#, 16#7897#, 16#8155#, 16#02_0B9F#,
         16#5B41#, 16#5B56#, 16#5B7D#, 16#5B93#,
         16#5BD8#, 16#5BEC#, 16#5C12#, 16#5C1E#,
         16#5C23#, 16#5C2B#, 16#378D#, 16#0000#,
         16#5C62#, 16#FA3B#, 16#FA3C#, 16#02_16B4#,
         16#5C7A#, 16#5C8F#, 16#5C9F#, 16#5CA3#,
         16#5CAA#, 16#5CBA#, 16#5CCB#, 16#5CD0#,
         16#5CD2#, 16#5CF4#, 16#02_1E34#, 16#37E2#,
         16#5D0D#, 16#5D27#, 16#FA11#, 16#5D46#,
         16#5D47#, 16#5D53#, 16#5D4A#, 16#5D6D#,
         16#5D81#, 16#5DA0#, 16#5DA4#, 16#5DA7#,
         16#5DB8#, 16#5DCB#, 16#541E#, 16#5F0C#,
         16#4E10#, 16#4E15#, 16#4E2A#, 16#4E31#,
         16#4E36#, 16#4E3C#, 16#4E3F#, 16#4E42#,
         16#4E56#, 16#4E58#, 16#4E82#, 16#4E85#,
         16#8C6B#, 16#4E8A#, 16#8212#, 16#5F0D#,
         16#4E8E#, 16#4E9E#, 16#4E9F#, 16#4EA0#,
         16#4EA2#, 16#4EB0#, 16#4EB3#, 16#4EB6#,
         16#4ECE#, 16#4ECD#, 16#4EC4#, 16#4EC6#,
         16#4EC2#, 16#4ED7#, 16#4EDE#, 16#4EED#,
         16#4EDF#, 16#4EF7#, 16#4F09#, 16#4F5A#,
         16#4F30#, 16#4F5B#, 16#4F5D#, 16#4F57#,
         16#4F47#, 16#4F76#, 16#4F88#, 16#4F8F#,
         16#4F98#, 16#4F7B#, 16#4F69#, 16#4F70#,
         16#4F91#, 16#4F6F#, 16#4F86#, 16#4F96#,
         16#5118#, 16#4FD4#, 16#4FDF#, 16#4FCE#,
         16#4FD8#, 16#4FDB#, 16#4FD1#, 16#4FDA#,
         16#4FD0#, 16#4FE4#, 16#4FE5#, 16#501A#,
         16#5028#, 16#5014#, 16#502A#, 16#5025#,
         16#5005#, 16#4F1C#, 16#4FF6#, 16#5021#,
         16#5029#, 16#502C#, 16#4FFE#, 16#4FEF#,
         16#5011#, 16#5006#, 16#5043#, 16#5047#,
         16#6703#, 16#5055#, 16#5050#, 16#5048#,
         16#505A#, 16#5056#, 16#506C#, 16#5078#,
         16#5080#, 16#509A#, 16#5085#, 16#50B4#,
         16#50B2#, 16#0000#, 16#0000#, 16#0000#);

   Decode_Double_99 : aliased constant SHIFTJIS_Code_Point_Array
     := (16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#50C9#, 16#50CA#, 16#50B3#, 16#50C2#,
         16#50D6#, 16#50DE#, 16#50E5#, 16#50ED#,
         16#50E3#, 16#50EE#, 16#50F9#, 16#50F5#,
         16#5109#, 16#5101#, 16#5102#, 16#5116#,
         16#5115#, 16#5114#, 16#511A#, 16#5121#,
         16#513A#, 16#5137#, 16#513C#, 16#513B#,
         16#513F#, 16#5140#, 16#5152#, 16#514C#,
         16#5154#, 16#5162#, 16#7AF8#, 16#5169#,
         16#516A#, 16#516E#, 16#5180#, 16#5182#,
         16#56D8#, 16#518C#, 16#5189#, 16#518F#,
         16#5191#, 16#5193#, 16#5195#, 16#5196#,
         16#51A4#, 16#51A6#, 16#51A2#, 16#51A9#,
         16#51AA#, 16#51AB#, 16#51B3#, 16#51B1#,
         16#51B2#, 16#51B0#, 16#51B5#, 16#51BD#,
         16#51C5#, 16#51C9#, 16#51DB#, 16#51E0#,
         16#8655#, 16#51E9#, 16#51ED#, 16#0000#,
         16#51F0#, 16#51F5#, 16#51FE#, 16#5204#,
         16#520B#, 16#5214#, 16#520E#, 16#5227#,
         16#522A#, 16#522E#, 16#5233#, 16#5239#,
         16#524F#, 16#5244#, 16#524B#, 16#524C#,
         16#525E#, 16#5254#, 16#526A#, 16#5274#,
         16#5269#, 16#5273#, 16#527F#, 16#527D#,
         16#528D#, 16#5294#, 16#5292#, 16#5271#,
         16#5288#, 16#5291#, 16#8FA8#, 16#8FA7#,
         16#52AC#, 16#52AD#, 16#52BC#, 16#52B5#,
         16#52C1#, 16#52CD#, 16#52D7#, 16#52DE#,
         16#52E3#, 16#52E6#, 16#98ED#, 16#52E0#,
         16#52F3#, 16#52F5#, 16#52F8#, 16#52F9#,
         16#5306#, 16#5308#, 16#7538#, 16#530D#,
         16#5310#, 16#530F#, 16#5315#, 16#531A#,
         16#5323#, 16#532F#, 16#5331#, 16#5333#,
         16#5338#, 16#5340#, 16#5346#, 16#5345#,
         16#4E17#, 16#5349#, 16#534D#, 16#51D6#,
         16#535E#, 16#5369#, 16#536E#, 16#5918#,
         16#537B#, 16#5377#, 16#5382#, 16#5396#,
         16#53A0#, 16#53A6#, 16#53A5#, 16#53AE#,
         16#53B0#, 16#53B6#, 16#53C3#, 16#7C12#,
         16#96D9#, 16#53DF#, 16#66FC#, 16#71EE#,
         16#53EE#, 16#53E8#, 16#53ED#, 16#53FA#,
         16#5401#, 16#543D#, 16#5440#, 16#542C#,
         16#542D#, 16#543C#, 16#542E#, 16#5436#,
         16#5429#, 16#541D#, 16#544E#, 16#548F#,
         16#5475#, 16#548E#, 16#545F#, 16#5471#,
         16#5477#, 16#5470#, 16#5492#, 16#547B#,
         16#5480#, 16#5476#, 16#5484#, 16#5490#,
         16#5486#, 16#54C7#, 16#54A2#, 16#54B8#,
         16#54A5#, 16#54AC#, 16#54C4#, 16#54C8#,
         16#54A8#, 16#0000#, 16#0000#, 16#0000#);

   Decode_Double_9A : aliased constant SHIFTJIS_Code_Point_Array
     := (16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#54AB#, 16#54C2#, 16#54A4#, 16#54BE#,
         16#54BC#, 16#54D8#, 16#54E5#, 16#54E6#,
         16#550F#, 16#5514#, 16#54FD#, 16#54EE#,
         16#54ED#, 16#54FA#, 16#54E2#, 16#5539#,
         16#5540#, 16#5563#, 16#554C#, 16#552E#,
         16#555C#, 16#5545#, 16#5556#, 16#5557#,
         16#5538#, 16#5533#, 16#555D#, 16#5599#,
         16#5580#, 16#54AF#, 16#558A#, 16#559F#,
         16#557B#, 16#557E#, 16#5598#, 16#559E#,
         16#55AE#, 16#557C#, 16#5583#, 16#55A9#,
         16#5587#, 16#55A8#, 16#55DA#, 16#55C5#,
         16#55DF#, 16#55C4#, 16#55DC#, 16#55E4#,
         16#55D4#, 16#5614#, 16#55F7#, 16#5616#,
         16#55FE#, 16#55FD#, 16#561B#, 16#55F9#,
         16#564E#, 16#5650#, 16#71DF#, 16#5634#,
         16#5636#, 16#5632#, 16#5638#, 16#0000#,
         16#566B#, 16#5664#, 16#562F#, 16#566C#,
         16#566A#, 16#5686#, 16#5680#, 16#568A#,
         16#56A0#, 16#5694#, 16#568F#, 16#56A5#,
         16#56AE#, 16#56B6#, 16#56B4#, 16#56C2#,
         16#56BC#, 16#56C1#, 16#56C3#, 16#56C0#,
         16#56C8#, 16#56CE#, 16#56D1#, 16#56D3#,
         16#56D7#, 16#56EE#, 16#56F9#, 16#5700#,
         16#56FF#, 16#5704#, 16#5709#, 16#5708#,
         16#570B#, 16#570D#, 16#5713#, 16#5718#,
         16#5716#, 16#55C7#, 16#571C#, 16#5726#,
         16#5737#, 16#5738#, 16#574E#, 16#573B#,
         16#5740#, 16#574F#, 16#5769#, 16#57C0#,
         16#5788#, 16#5761#, 16#577F#, 16#5789#,
         16#5793#, 16#57A0#, 16#57B3#, 16#57A4#,
         16#57AA#, 16#57B0#, 16#57C3#, 16#57C6#,
         16#57D4#, 16#57D2#, 16#57D3#, 16#580A#,
         16#57D6#, 16#57E3#, 16#580B#, 16#5819#,
         16#581D#, 16#5872#, 16#5821#, 16#5862#,
         16#584B#, 16#5870#, 16#6BC0#, 16#5852#,
         16#583D#, 16#5879#, 16#5885#, 16#58B9#,
         16#589F#, 16#58AB#, 16#58BA#, 16#58DE#,
         16#58BB#, 16#58B8#, 16#58AE#, 16#58C5#,
         16#58D3#, 16#58D1#, 16#58D7#, 16#58D9#,
         16#58D8#, 16#58E5#, 16#58DC#, 16#58E4#,
         16#58DF#, 16#58EF#, 16#58FA#, 16#58F9#,
         16#58FB#, 16#58FC#, 16#58FD#, 16#5902#,
         16#590A#, 16#5910#, 16#591B#, 16#68A6#,
         16#5925#, 16#592C#, 16#592D#, 16#5932#,
         16#5938#, 16#593E#, 16#7AD2#, 16#5955#,
         16#5950#, 16#594E#, 16#595A#, 16#5958#,
         16#5962#, 16#5960#, 16#5967#, 16#596C#,
         16#5969#, 16#0000#, 16#0000#, 16#0000#);

   Decode_Double_9B : aliased constant SHIFTJIS_Code_Point_Array
     := (16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#5978#, 16#5981#, 16#599D#, 16#4F5E#,
         16#4FAB#, 16#59A3#, 16#59B2#, 16#59C6#,
         16#59E8#, 16#59DC#, 16#598D#, 16#59D9#,
         16#59DA#, 16#5A25#, 16#5A1F#, 16#5A11#,
         16#5A1C#, 16#5A09#, 16#5A1A#, 16#5A40#,
         16#5A6C#, 16#5A49#, 16#5A35#, 16#5A36#,
         16#5A62#, 16#5A6A#, 16#5A9A#, 16#5ABC#,
         16#5ABE#, 16#5ACB#, 16#5AC2#, 16#5ABD#,
         16#5AE3#, 16#5AD7#, 16#5AE6#, 16#5AE9#,
         16#5AD6#, 16#5AFA#, 16#5AFB#, 16#5B0C#,
         16#5B0B#, 16#5B16#, 16#5B32#, 16#5AD0#,
         16#5B2A#, 16#5B36#, 16#5B3E#, 16#5B43#,
         16#5B45#, 16#5B40#, 16#5B51#, 16#5B55#,
         16#5B5A#, 16#5B5B#, 16#5B65#, 16#5B69#,
         16#5B70#, 16#5B73#, 16#5B75#, 16#5B78#,
         16#6588#, 16#5B7A#, 16#5B80#, 16#0000#,
         16#5B83#, 16#5BA6#, 16#5BB8#, 16#5BC3#,
         16#5BC7#, 16#5BC9#, 16#5BD4#, 16#5BD0#,
         16#5BE4#, 16#5BE6#, 16#5BE2#, 16#5BDE#,
         16#5BE5#, 16#5BEB#, 16#5BF0#, 16#5BF6#,
         16#5BF3#, 16#5C05#, 16#5C07#, 16#5C08#,
         16#5C0D#, 16#5C13#, 16#5C20#, 16#5C22#,
         16#5C28#, 16#5C38#, 16#5C39#, 16#5C41#,
         16#5C46#, 16#5C4E#, 16#5C53#, 16#5C50#,
         16#5C4F#, 16#5B71#, 16#5C6C#, 16#5C6E#,
         16#4E62#, 16#5C76#, 16#5C79#, 16#5C8C#,
         16#5C91#, 16#5C94#, 16#599B#, 16#5CAB#,
         16#5CBB#, 16#5CB6#, 16#5CBC#, 16#5CB7#,
         16#5CC5#, 16#5CBE#, 16#5CC7#, 16#5CD9#,
         16#5CE9#, 16#5CFD#, 16#5CFA#, 16#5CED#,
         16#5D8C#, 16#5CEA#, 16#5D0B#, 16#5D15#,
         16#5D17#, 16#5D5C#, 16#5D1F#, 16#5D1B#,
         16#5D11#, 16#5D14#, 16#5D22#, 16#5D1A#,
         16#5D19#, 16#5D18#, 16#5D4C#, 16#5D52#,
         16#5D4E#, 16#5D4B#, 16#5D6C#, 16#5D73#,
         16#5D76#, 16#5D87#, 16#5D84#, 16#5D82#,
         16#5DA2#, 16#5D9D#, 16#5DAC#, 16#5DAE#,
         16#5DBD#, 16#5D90#, 16#5DB7#, 16#5DBC#,
         16#5DC9#, 16#5DCD#, 16#5DD3#, 16#5DD2#,
         16#5DD6#, 16#5DDB#, 16#5DEB#, 16#5DF2#,
         16#5DF5#, 16#5E0B#, 16#5E1A#, 16#5E19#,
         16#5E11#, 16#5E1B#, 16#5E36#, 16#5E37#,
         16#5E44#, 16#5E43#, 16#5E40#, 16#5E4E#,
         16#5E57#, 16#5E54#, 16#5E5F#, 16#5E62#,
         16#5E64#, 16#5E47#, 16#5E75#, 16#5E76#,
         16#5E7A#, 16#9EBC#, 16#5E7F#, 16#5EA0#,
         16#5EC1#, 16#5EC2#, 16#5EC8#, 16#5ED0#,
         16#5ECF#, 16#0000#, 16#0000#, 16#0000#);

   Decode_Double_9C : aliased constant SHIFTJIS_Code_Point_Array
     := (16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#5ED6#, 16#5EE3#, 16#5EDD#, 16#5EDA#,
         16#5EDB#, 16#5EE2#, 16#5EE1#, 16#5EE8#,
         16#5EE9#, 16#5EEC#, 16#5EF1#, 16#5EF3#,
         16#5EF0#, 16#5EF4#, 16#5EF8#, 16#5EFE#,
         16#5F03#, 16#5F09#, 16#5F5D#, 16#5F5C#,
         16#5F0B#, 16#5F11#, 16#5F16#, 16#5F29#,
         16#5F2D#, 16#5F38#, 16#5F41#, 16#5F48#,
         16#5F4C#, 16#5F4E#, 16#5F2F#, 16#5F51#,
         16#5F56#, 16#5F57#, 16#5F59#, 16#5F61#,
         16#5F6D#, 16#5F73#, 16#5F77#, 16#5F83#,
         16#5F82#, 16#5F7F#, 16#5F8A#, 16#5F88#,
         16#5F91#, 16#5F87#, 16#5F9E#, 16#5F99#,
         16#5F98#, 16#5FA0#, 16#5FA8#, 16#5FAD#,
         16#5FBC#, 16#5FD6#, 16#5FFB#, 16#5FE4#,
         16#5FF8#, 16#5FF1#, 16#5FDD#, 16#60B3#,
         16#5FFF#, 16#6021#, 16#6060#, 16#0000#,
         16#6019#, 16#6010#, 16#6029#, 16#600E#,
         16#6031#, 16#601B#, 16#6015#, 16#602B#,
         16#6026#, 16#600F#, 16#603A#, 16#605A#,
         16#6041#, 16#606A#, 16#6077#, 16#605F#,
         16#604A#, 16#6046#, 16#604D#, 16#6063#,
         16#6043#, 16#6064#, 16#6042#, 16#606C#,
         16#606B#, 16#6059#, 16#6081#, 16#608D#,
         16#60E7#, 16#6083#, 16#609A#, 16#6084#,
         16#609B#, 16#6096#, 16#6097#, 16#6092#,
         16#60A7#, 16#608B#, 16#60E1#, 16#60B8#,
         16#60E0#, 16#60D3#, 16#60B4#, 16#5FF0#,
         16#60BD#, 16#60C6#, 16#60B5#, 16#60D8#,
         16#614D#, 16#6115#, 16#6106#, 16#60F6#,
         16#60F7#, 16#6100#, 16#60F4#, 16#60FA#,
         16#6103#, 16#6121#, 16#60FB#, 16#60F1#,
         16#610D#, 16#610E#, 16#6147#, 16#613E#,
         16#6128#, 16#6127#, 16#614A#, 16#613F#,
         16#613C#, 16#612C#, 16#6134#, 16#613D#,
         16#6142#, 16#6144#, 16#6173#, 16#6177#,
         16#6158#, 16#6159#, 16#615A#, 16#616B#,
         16#6174#, 16#616F#, 16#6165#, 16#6171#,
         16#615F#, 16#615D#, 16#6153#, 16#6175#,
         16#6199#, 16#6196#, 16#6187#, 16#61AC#,
         16#6194#, 16#619A#, 16#618A#, 16#6191#,
         16#61AB#, 16#61AE#, 16#61CC#, 16#61CA#,
         16#61C9#, 16#61F7#, 16#61C8#, 16#61C3#,
         16#61C6#, 16#61BA#, 16#61CB#, 16#7F79#,
         16#61CD#, 16#61E6#, 16#61E3#, 16#61F6#,
         16#61FA#, 16#61F4#, 16#61FF#, 16#61FD#,
         16#61FC#, 16#61FE#, 16#6200#, 16#6208#,
         16#6209#, 16#620D#, 16#620C#, 16#6214#,
         16#621B#, 16#0000#, 16#0000#, 16#0000#);

   Decode_Double_9D : aliased constant SHIFTJIS_Code_Point_Array
     := (16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#621E#, 16#6221#, 16#622A#, 16#622E#,
         16#6230#, 16#6232#, 16#6233#, 16#6241#,
         16#624E#, 16#625E#, 16#6263#, 16#625B#,
         16#6260#, 16#6268#, 16#627C#, 16#6282#,
         16#6289#, 16#627E#, 16#6292#, 16#6293#,
         16#6296#, 16#62D4#, 16#6283#, 16#6294#,
         16#62D7#, 16#62D1#, 16#62BB#, 16#62CF#,
         16#62FF#, 16#62C6#, 16#64D4#, 16#62C8#,
         16#62DC#, 16#62CC#, 16#62CA#, 16#62C2#,
         16#62C7#, 16#629B#, 16#62C9#, 16#630C#,
         16#62EE#, 16#62F1#, 16#6327#, 16#6302#,
         16#6308#, 16#62EF#, 16#62F5#, 16#6350#,
         16#633E#, 16#634D#, 16#641C#, 16#634F#,
         16#6396#, 16#638E#, 16#6380#, 16#63AB#,
         16#6376#, 16#63A3#, 16#638F#, 16#6389#,
         16#639F#, 16#63B5#, 16#636B#, 16#0000#,
         16#6369#, 16#63BE#, 16#63E9#, 16#63C0#,
         16#63C6#, 16#63E3#, 16#63C9#, 16#63D2#,
         16#63F6#, 16#63C4#, 16#6416#, 16#6434#,
         16#6406#, 16#6413#, 16#6426#, 16#6436#,
         16#651D#, 16#6417#, 16#6428#, 16#640F#,
         16#6467#, 16#646F#, 16#6476#, 16#644E#,
         16#652A#, 16#6495#, 16#6493#, 16#64A5#,
         16#64A9#, 16#6488#, 16#64BC#, 16#64DA#,
         16#64D2#, 16#64C5#, 16#64C7#, 16#64BB#,
         16#64D8#, 16#64C2#, 16#64F1#, 16#64E7#,
         16#8209#, 16#64E0#, 16#64E1#, 16#62AC#,
         16#64E3#, 16#64EF#, 16#652C#, 16#64F6#,
         16#64F4#, 16#64F2#, 16#64FA#, 16#6500#,
         16#64FD#, 16#6518#, 16#651C#, 16#6505#,
         16#6524#, 16#6523#, 16#652B#, 16#6534#,
         16#6535#, 16#6537#, 16#6536#, 16#6538#,
         16#754B#, 16#6548#, 16#6556#, 16#6555#,
         16#654D#, 16#6558#, 16#655E#, 16#655D#,
         16#6572#, 16#6578#, 16#6582#, 16#6583#,
         16#8B8A#, 16#659B#, 16#659F#, 16#65AB#,
         16#65B7#, 16#65C3#, 16#65C6#, 16#65C1#,
         16#65C4#, 16#65CC#, 16#65D2#, 16#65DB#,
         16#65D9#, 16#65E0#, 16#65E1#, 16#65F1#,
         16#6772#, 16#660A#, 16#6603#, 16#65FB#,
         16#6773#, 16#6635#, 16#6636#, 16#6634#,
         16#661C#, 16#664F#, 16#6644#, 16#6649#,
         16#6641#, 16#665E#, 16#665D#, 16#6664#,
         16#6667#, 16#6668#, 16#665F#, 16#6662#,
         16#6670#, 16#6683#, 16#6688#, 16#668E#,
         16#6689#, 16#6684#, 16#6698#, 16#669D#,
         16#66C1#, 16#66B9#, 16#66C9#, 16#66BE#,
         16#66BC#, 16#0000#, 16#0000#, 16#0000#);

   Decode_Double_9E : aliased constant SHIFTJIS_Code_Point_Array
     := (16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#66C4#, 16#66B8#, 16#66D6#, 16#66DA#,
         16#66E0#, 16#663F#, 16#66E6#, 16#66E9#,
         16#66F0#, 16#66F5#, 16#66F7#, 16#670F#,
         16#6716#, 16#671E#, 16#6726#, 16#6727#,
         16#9738#, 16#672E#, 16#673F#, 16#6736#,
         16#6741#, 16#6738#, 16#6737#, 16#6746#,
         16#675E#, 16#6760#, 16#6759#, 16#6763#,
         16#6764#, 16#6789#, 16#6770#, 16#67A9#,
         16#677C#, 16#676A#, 16#678C#, 16#678B#,
         16#67A6#, 16#67A1#, 16#6785#, 16#67B7#,
         16#67EF#, 16#67B4#, 16#67EC#, 16#67B3#,
         16#67E9#, 16#67B8#, 16#67E4#, 16#67DE#,
         16#67DD#, 16#67E2#, 16#67EE#, 16#67B9#,
         16#67CE#, 16#67C6#, 16#67E7#, 16#6A9C#,
         16#681E#, 16#6846#, 16#6829#, 16#6840#,
         16#684D#, 16#6832#, 16#684E#, 16#0000#,
         16#68B3#, 16#682B#, 16#6859#, 16#6863#,
         16#6877#, 16#687F#, 16#689F#, 16#688F#,
         16#68AD#, 16#6894#, 16#689D#, 16#689B#,
         16#6883#, 16#6AAE#, 16#68B9#, 16#6874#,
         16#68B5#, 16#68A0#, 16#68BA#, 16#690F#,
         16#688D#, 16#687E#, 16#6901#, 16#68CA#,
         16#6908#, 16#68D8#, 16#6922#, 16#6926#,
         16#68E1#, 16#690C#, 16#68CD#, 16#68D4#,
         16#68E7#, 16#68D5#, 16#6936#, 16#6912#,
         16#6904#, 16#68D7#, 16#68E3#, 16#6925#,
         16#68F9#, 16#68E0#, 16#68EF#, 16#6928#,
         16#692A#, 16#691A#, 16#6923#, 16#6921#,
         16#68C6#, 16#6979#, 16#6977#, 16#695C#,
         16#6978#, 16#696B#, 16#6954#, 16#697E#,
         16#696E#, 16#6939#, 16#6974#, 16#693D#,
         16#6959#, 16#6930#, 16#6961#, 16#695E#,
         16#695D#, 16#6981#, 16#696A#, 16#69B2#,
         16#69AE#, 16#69D0#, 16#69BF#, 16#69C1#,
         16#69D3#, 16#69BE#, 16#69CE#, 16#5BE8#,
         16#69CA#, 16#69DD#, 16#69BB#, 16#69C3#,
         16#69A7#, 16#6A2E#, 16#6991#, 16#69A0#,
         16#699C#, 16#6995#, 16#69B4#, 16#69DE#,
         16#69E8#, 16#6A02#, 16#6A1B#, 16#69FF#,
         16#6B0A#, 16#69F9#, 16#69F2#, 16#69E7#,
         16#6A05#, 16#69B1#, 16#6A1E#, 16#69ED#,
         16#6A14#, 16#69EB#, 16#6A0A#, 16#6A12#,
         16#6AC1#, 16#6A23#, 16#6A13#, 16#6A44#,
         16#6A0C#, 16#6A72#, 16#6A36#, 16#6A78#,
         16#6A47#, 16#6A62#, 16#6A59#, 16#6A66#,
         16#6A48#, 16#6A38#, 16#6A22#, 16#6A90#,
         16#6A8D#, 16#6AA0#, 16#6A84#, 16#6AA2#,
         16#6AA3#, 16#0000#, 16#0000#, 16#0000#);

   Decode_Double_9F : aliased constant SHIFTJIS_Code_Point_Array
     := (16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#6A97#, 16#8617#, 16#6ABB#, 16#6AC3#,
         16#6AC2#, 16#6AB8#, 16#6AB3#, 16#6AAC#,
         16#6ADE#, 16#6AD1#, 16#6ADF#, 16#6AAA#,
         16#6ADA#, 16#6AEA#, 16#6AFB#, 16#6B05#,
         16#8616#, 16#6AFA#, 16#6B12#, 16#6B16#,
         16#9B31#, 16#6B1F#, 16#6B38#, 16#6B37#,
         16#76DC#, 16#6B39#, 16#98EE#, 16#6B47#,
         16#6B43#, 16#6B49#, 16#6B50#, 16#6B59#,
         16#6B54#, 16#6B5B#, 16#6B5F#, 16#6B61#,
         16#6B78#, 16#6B79#, 16#6B7F#, 16#6B80#,
         16#6B84#, 16#6B83#, 16#6B8D#, 16#6B98#,
         16#6B95#, 16#6B9E#, 16#6BA4#, 16#6BAA#,
         16#6BAB#, 16#6BAF#, 16#6BB2#, 16#6BB1#,
         16#6BB3#, 16#6BB7#, 16#6BBC#, 16#6BC6#,
         16#6BCB#, 16#6BD3#, 16#6BDF#, 16#6BEC#,
         16#6BEB#, 16#6BF3#, 16#6BEF#, 16#0000#,
         16#9EBE#, 16#6C08#, 16#6C13#, 16#6C14#,
         16#6C1B#, 16#6C24#, 16#6C23#, 16#6C5E#,
         16#6C55#, 16#6C62#, 16#6C6A#, 16#6C82#,
         16#6C8D#, 16#6C9A#, 16#6C81#, 16#6C9B#,
         16#6C7E#, 16#6C68#, 16#6C73#, 16#6C92#,
         16#6C90#, 16#6CC4#, 16#6CF1#, 16#6CD3#,
         16#6CBD#, 16#6CD7#, 16#6CC5#, 16#6CDD#,
         16#6CAE#, 16#6CB1#, 16#6CBE#, 16#6CBA#,
         16#6CDB#, 16#6CEF#, 16#6CD9#, 16#6CEA#,
         16#6D1F#, 16#884D#, 16#6D36#, 16#6D2B#,
         16#6D3D#, 16#6D38#, 16#6D19#, 16#6D35#,
         16#6D33#, 16#6D12#, 16#6D0C#, 16#6D63#,
         16#6D93#, 16#6D64#, 16#6D5A#, 16#6D79#,
         16#6D59#, 16#6D8E#, 16#6D95#, 16#6FE4#,
         16#6D85#, 16#6DF9#, 16#6E15#, 16#6E0A#,
         16#6DB5#, 16#6DC7#, 16#6DE6#, 16#6DB8#,
         16#6DC6#, 16#6DEC#, 16#6DDE#, 16#6DCC#,
         16#6DE8#, 16#6DD2#, 16#6DC5#, 16#6DFA#,
         16#6DD9#, 16#6DE4#, 16#6DD5#, 16#6DEA#,
         16#6DEE#, 16#6E2D#, 16#6E6E#, 16#6E2E#,
         16#6E19#, 16#6E72#, 16#6E5F#, 16#6E3E#,
         16#6E23#, 16#6E6B#, 16#6E2B#, 16#6E76#,
         16#6E4D#, 16#6E1F#, 16#6E43#, 16#6E3A#,
         16#6E4E#, 16#6E24#, 16#6EFF#, 16#6E1D#,
         16#6E38#, 16#6E82#, 16#6EAA#, 16#6E98#,
         16#6EC9#, 16#6EB7#, 16#6ED3#, 16#6EBD#,
         16#6EAF#, 16#6EC4#, 16#6EB2#, 16#6ED4#,
         16#6ED5#, 16#6E8F#, 16#6EA5#, 16#6EC2#,
         16#6E9F#, 16#6F41#, 16#6F11#, 16#704C#,
         16#6EEC#, 16#6EF8#, 16#6EFE#, 16#6F3F#,
         16#6EF2#, 16#6F31#, 16#6EEF#, 16#6F32#,
         16#6ECC#, 16#0000#, 16#0000#, 16#0000#);

   Decode_Double_E0 : aliased constant SHIFTJIS_Code_Point_Array
     := (16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#6F3E#, 16#6F13#, 16#6EF7#, 16#6F86#,
         16#6F7A#, 16#6F78#, 16#6F81#, 16#6F80#,
         16#6F6F#, 16#6F5B#, 16#6FF3#, 16#6F6D#,
         16#6F82#, 16#6F7C#, 16#6F58#, 16#6F8E#,
         16#6F91#, 16#6FC2#, 16#6F66#, 16#6FB3#,
         16#6FA3#, 16#6FA1#, 16#6FA4#, 16#6FB9#,
         16#6FC6#, 16#6FAA#, 16#6FDF#, 16#6FD5#,
         16#6FEC#, 16#6FD4#, 16#6FD8#, 16#6FF1#,
         16#6FEE#, 16#6FDB#, 16#7009#, 16#700B#,
         16#6FFA#, 16#7011#, 16#7001#, 16#700F#,
         16#6FFE#, 16#701B#, 16#701A#, 16#6F74#,
         16#701D#, 16#7018#, 16#701F#, 16#7030#,
         16#703E#, 16#7032#, 16#7051#, 16#7063#,
         16#7099#, 16#7092#, 16#70AF#, 16#70F1#,
         16#70AC#, 16#70B8#, 16#70B3#, 16#70AE#,
         16#70DF#, 16#70CB#, 16#70DD#, 16#0000#,
         16#70D9#, 16#7109#, 16#70FD#, 16#711C#,
         16#7119#, 16#7165#, 16#7155#, 16#7188#,
         16#7166#, 16#7162#, 16#714C#, 16#7156#,
         16#716C#, 16#718F#, 16#71FB#, 16#7184#,
         16#7195#, 16#71A8#, 16#71AC#, 16#71D7#,
         16#71B9#, 16#71BE#, 16#71D2#, 16#71C9#,
         16#71D4#, 16#71CE#, 16#71E0#, 16#71EC#,
         16#71E7#, 16#71F5#, 16#71FC#, 16#71F9#,
         16#71FF#, 16#720D#, 16#7210#, 16#721B#,
         16#7228#, 16#722D#, 16#722C#, 16#7230#,
         16#7232#, 16#723B#, 16#723C#, 16#723F#,
         16#7240#, 16#7246#, 16#724B#, 16#7258#,
         16#7274#, 16#727E#, 16#7282#, 16#7281#,
         16#7287#, 16#7292#, 16#7296#, 16#72A2#,
         16#72A7#, 16#72B9#, 16#72B2#, 16#72C3#,
         16#72C6#, 16#72C4#, 16#72CE#, 16#72D2#,
         16#72E2#, 16#72E0#, 16#72E1#, 16#72F9#,
         16#72F7#, 16#500F#, 16#7317#, 16#730A#,
         16#731C#, 16#7316#, 16#731D#, 16#7334#,
         16#732F#, 16#7329#, 16#7325#, 16#733E#,
         16#734E#, 16#734F#, 16#9ED8#, 16#7357#,
         16#736A#, 16#7368#, 16#7370#, 16#7378#,
         16#7375#, 16#737B#, 16#737A#, 16#73C8#,
         16#73B3#, 16#73CE#, 16#73BB#, 16#73C0#,
         16#73E5#, 16#73EE#, 16#73DE#, 16#74A2#,
         16#7405#, 16#746F#, 16#7425#, 16#73F8#,
         16#7432#, 16#743A#, 16#7455#, 16#743F#,
         16#745F#, 16#7459#, 16#7441#, 16#745C#,
         16#7469#, 16#7470#, 16#7463#, 16#746A#,
         16#7476#, 16#747E#, 16#748B#, 16#749E#,
         16#74A7#, 16#74CA#, 16#74CF#, 16#74D4#,
         16#73F1#, 16#0000#, 16#0000#, 16#0000#);

   Decode_Double_E1 : aliased constant SHIFTJIS_Code_Point_Array
     := (16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#74E0#, 16#74E3#, 16#74E7#, 16#74E9#,
         16#74EE#, 16#74F2#, 16#74F0#, 16#74F1#,
         16#74F8#, 16#74F7#, 16#7504#, 16#7503#,
         16#7505#, 16#750C#, 16#750E#, 16#750D#,
         16#7515#, 16#7513#, 16#751E#, 16#7526#,
         16#752C#, 16#753C#, 16#7544#, 16#754D#,
         16#754A#, 16#7549#, 16#755B#, 16#7546#,
         16#755A#, 16#7569#, 16#7564#, 16#7567#,
         16#756B#, 16#756D#, 16#7578#, 16#7576#,
         16#7586#, 16#7587#, 16#7574#, 16#758A#,
         16#7589#, 16#7582#, 16#7594#, 16#759A#,
         16#759D#, 16#75A5#, 16#75A3#, 16#75C2#,
         16#75B3#, 16#75C3#, 16#75B5#, 16#75BD#,
         16#75B8#, 16#75BC#, 16#75B1#, 16#75CD#,
         16#75CA#, 16#75D2#, 16#75D9#, 16#75E3#,
         16#75DE#, 16#75FE#, 16#75FF#, 16#0000#,
         16#75FC#, 16#7601#, 16#75F0#, 16#75FA#,
         16#75F2#, 16#75F3#, 16#760B#, 16#760D#,
         16#7609#, 16#761F#, 16#7627#, 16#7620#,
         16#7621#, 16#7622#, 16#7624#, 16#7634#,
         16#7630#, 16#763B#, 16#7647#, 16#7648#,
         16#7646#, 16#765C#, 16#7658#, 16#7661#,
         16#7662#, 16#7668#, 16#7669#, 16#766A#,
         16#7667#, 16#766C#, 16#7670#, 16#7672#,
         16#7676#, 16#7678#, 16#767C#, 16#7680#,
         16#7683#, 16#7688#, 16#768B#, 16#768E#,
         16#7696#, 16#7693#, 16#7699#, 16#769A#,
         16#76B0#, 16#76B4#, 16#76B8#, 16#76B9#,
         16#76BA#, 16#76C2#, 16#76CD#, 16#76D6#,
         16#76D2#, 16#76DE#, 16#76E1#, 16#76E5#,
         16#76E7#, 16#76EA#, 16#862F#, 16#76FB#,
         16#7708#, 16#7707#, 16#7704#, 16#7729#,
         16#7724#, 16#771E#, 16#7725#, 16#7726#,
         16#771B#, 16#7737#, 16#7738#, 16#7747#,
         16#775A#, 16#7768#, 16#776B#, 16#775B#,
         16#7765#, 16#777F#, 16#777E#, 16#7779#,
         16#778E#, 16#778B#, 16#7791#, 16#77A0#,
         16#779E#, 16#77B0#, 16#77B6#, 16#77B9#,
         16#77BF#, 16#77BC#, 16#77BD#, 16#77BB#,
         16#77C7#, 16#77CD#, 16#77D7#, 16#77DA#,
         16#77DC#, 16#77E3#, 16#77EE#, 16#77FC#,
         16#780C#, 16#7812#, 16#7926#, 16#7820#,
         16#792A#, 16#7845#, 16#788E#, 16#7874#,
         16#7886#, 16#787C#, 16#789A#, 16#788C#,
         16#78A3#, 16#78B5#, 16#78AA#, 16#78AF#,
         16#78D1#, 16#78C6#, 16#78CB#, 16#78D4#,
         16#78BE#, 16#78BC#, 16#78C5#, 16#78CA#,
         16#78EC#, 16#0000#, 16#0000#, 16#0000#);

   Decode_Double_E2 : aliased constant SHIFTJIS_Code_Point_Array
     := (16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#78E7#, 16#78DA#, 16#78FD#, 16#78F4#,
         16#7907#, 16#7912#, 16#7911#, 16#7919#,
         16#792C#, 16#792B#, 16#7940#, 16#7960#,
         16#7957#, 16#795F#, 16#795A#, 16#7955#,
         16#7953#, 16#797A#, 16#797F#, 16#798A#,
         16#799D#, 16#79A7#, 16#9F4B#, 16#79AA#,
         16#79AE#, 16#79B3#, 16#79B9#, 16#79BA#,
         16#79C9#, 16#79D5#, 16#79E7#, 16#79EC#,
         16#79E1#, 16#79E3#, 16#7A08#, 16#7A0D#,
         16#7A18#, 16#7A19#, 16#7A20#, 16#7A1F#,
         16#7980#, 16#7A31#, 16#7A3B#, 16#7A3E#,
         16#7A37#, 16#7A43#, 16#7A57#, 16#7A49#,
         16#7A61#, 16#7A62#, 16#7A69#, 16#9F9D#,
         16#7A70#, 16#7A79#, 16#7A7D#, 16#7A88#,
         16#7A97#, 16#7A95#, 16#7A98#, 16#7A96#,
         16#7AA9#, 16#7AC8#, 16#7AB0#, 16#0000#,
         16#7AB6#, 16#7AC5#, 16#7AC4#, 16#7ABF#,
         16#9083#, 16#7AC7#, 16#7ACA#, 16#7ACD#,
         16#7ACF#, 16#7AD5#, 16#7AD3#, 16#7AD9#,
         16#7ADA#, 16#7ADD#, 16#7AE1#, 16#7AE2#,
         16#7AE6#, 16#7AED#, 16#7AF0#, 16#7B02#,
         16#7B0F#, 16#7B0A#, 16#7B06#, 16#7B33#,
         16#7B18#, 16#7B19#, 16#7B1E#, 16#7B35#,
         16#7B28#, 16#7B36#, 16#7B50#, 16#7B7A#,
         16#7B04#, 16#7B4D#, 16#7B0B#, 16#7B4C#,
         16#7B45#, 16#7B75#, 16#7B65#, 16#7B74#,
         16#7B67#, 16#7B70#, 16#7B71#, 16#7B6C#,
         16#7B6E#, 16#7B9D#, 16#7B98#, 16#7B9F#,
         16#7B8D#, 16#7B9C#, 16#7B9A#, 16#7B8B#,
         16#7B92#, 16#7B8F#, 16#7B5D#, 16#7B99#,
         16#7BCB#, 16#7BC1#, 16#7BCC#, 16#7BCF#,
         16#7BB4#, 16#7BC6#, 16#7BDD#, 16#7BE9#,
         16#7C11#, 16#7C14#, 16#7BE6#, 16#7BE5#,
         16#7C60#, 16#7C00#, 16#7C07#, 16#7C13#,
         16#7BF3#, 16#7BF7#, 16#7C17#, 16#7C0D#,
         16#7BF6#, 16#7C23#, 16#7C27#, 16#7C2A#,
         16#7C1F#, 16#7C37#, 16#7C2B#, 16#7C3D#,
         16#7C4C#, 16#7C43#, 16#7C54#, 16#7C4F#,
         16#7C40#, 16#7C50#, 16#7C58#, 16#7C5F#,
         16#7C64#, 16#7C56#, 16#7C65#, 16#7C6C#,
         16#7C75#, 16#7C83#, 16#7C90#, 16#7CA4#,
         16#7CAD#, 16#7CA2#, 16#7CAB#, 16#7CA1#,
         16#7CA8#, 16#7CB3#, 16#7CB2#, 16#7CB1#,
         16#7CAE#, 16#7CB9#, 16#7CBD#, 16#7CC0#,
         16#7CC5#, 16#7CC2#, 16#7CD8#, 16#7CD2#,
         16#7CDC#, 16#7CE2#, 16#9B3B#, 16#7CEF#,
         16#7CF2#, 16#7CF4#, 16#7CF6#, 16#7CFA#,
         16#7D06#, 16#0000#, 16#0000#, 16#0000#);

   Decode_Double_E3 : aliased constant SHIFTJIS_Code_Point_Array
     := (16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#7D02#, 16#7D1C#, 16#7D15#, 16#7D0A#,
         16#7D45#, 16#7D4B#, 16#7D2E#, 16#7D32#,
         16#7D3F#, 16#7D35#, 16#7D46#, 16#7D73#,
         16#7D56#, 16#7D4E#, 16#7D72#, 16#7D68#,
         16#7D6E#, 16#7D4F#, 16#7D63#, 16#7D93#,
         16#7D89#, 16#7D5B#, 16#7D8F#, 16#7D7D#,
         16#7D9B#, 16#7DBA#, 16#7DAE#, 16#7DA3#,
         16#7DB5#, 16#7DC7#, 16#7DBD#, 16#7DAB#,
         16#7E3D#, 16#7DA2#, 16#7DAF#, 16#7DDC#,
         16#7DB8#, 16#7D9F#, 16#7DB0#, 16#7DD8#,
         16#7DDD#, 16#7DE4#, 16#7DDE#, 16#7DFB#,
         16#7DF2#, 16#7DE1#, 16#7E05#, 16#7E0A#,
         16#7E23#, 16#7E21#, 16#7E12#, 16#7E31#,
         16#7E1F#, 16#7E09#, 16#7E0B#, 16#7E22#,
         16#7E46#, 16#7E66#, 16#7E3B#, 16#7E35#,
         16#7E39#, 16#7E43#, 16#7E37#, 16#0000#,
         16#7E32#, 16#7E3A#, 16#7E67#, 16#7E5D#,
         16#7E56#, 16#7E5E#, 16#7E59#, 16#7E5A#,
         16#7E79#, 16#7E6A#, 16#7E69#, 16#7E7C#,
         16#7E7B#, 16#7E83#, 16#7DD5#, 16#7E7D#,
         16#8FAE#, 16#7E7F#, 16#7E88#, 16#7E89#,
         16#7E8C#, 16#7E92#, 16#7E90#, 16#7E93#,
         16#7E94#, 16#7E96#, 16#7E8E#, 16#7E9B#,
         16#7E9C#, 16#7F38#, 16#7F3A#, 16#7F45#,
         16#7F4C#, 16#7F4D#, 16#7F4E#, 16#7F50#,
         16#7F51#, 16#7F55#, 16#7F54#, 16#7F58#,
         16#7F5F#, 16#7F60#, 16#7F68#, 16#7F69#,
         16#7F67#, 16#7F78#, 16#7F82#, 16#7F86#,
         16#7F83#, 16#7F88#, 16#7F87#, 16#7F8C#,
         16#7F94#, 16#7F9E#, 16#7F9D#, 16#7F9A#,
         16#7FA3#, 16#7FAF#, 16#7FB2#, 16#7FB9#,
         16#7FAE#, 16#7FB6#, 16#7FB8#, 16#8B71#,
         16#7FC5#, 16#7FC6#, 16#7FCA#, 16#7FD5#,
         16#7FD4#, 16#7FE1#, 16#7FE6#, 16#7FE9#,
         16#7FF3#, 16#7FF9#, 16#98DC#, 16#8006#,
         16#8004#, 16#800B#, 16#8012#, 16#8018#,
         16#8019#, 16#801C#, 16#8021#, 16#8028#,
         16#803F#, 16#803B#, 16#804A#, 16#8046#,
         16#8052#, 16#8058#, 16#805A#, 16#805F#,
         16#8062#, 16#8068#, 16#8073#, 16#8072#,
         16#8070#, 16#8076#, 16#8079#, 16#807D#,
         16#807F#, 16#8084#, 16#8086#, 16#8085#,
         16#809B#, 16#8093#, 16#809A#, 16#80AD#,
         16#5190#, 16#80AC#, 16#80DB#, 16#80E5#,
         16#80D9#, 16#80DD#, 16#80C4#, 16#80DA#,
         16#80D6#, 16#8109#, 16#80EF#, 16#80F1#,
         16#811B#, 16#8129#, 16#8123#, 16#812F#,
         16#814B#, 16#0000#, 16#0000#, 16#0000#);

   Decode_Double_E4 : aliased constant SHIFTJIS_Code_Point_Array
     := (16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#968B#, 16#8146#, 16#813E#, 16#8153#,
         16#8151#, 16#80FC#, 16#8171#, 16#816E#,
         16#8165#, 16#8166#, 16#8174#, 16#8183#,
         16#8188#, 16#818A#, 16#8180#, 16#8182#,
         16#81A0#, 16#8195#, 16#81A4#, 16#81A3#,
         16#815F#, 16#8193#, 16#81A9#, 16#81B0#,
         16#81B5#, 16#81BE#, 16#81B8#, 16#81BD#,
         16#81C0#, 16#81C2#, 16#81BA#, 16#81C9#,
         16#81CD#, 16#81D1#, 16#81D9#, 16#81D8#,
         16#81C8#, 16#81DA#, 16#81DF#, 16#81E0#,
         16#81E7#, 16#81FA#, 16#81FB#, 16#81FE#,
         16#8201#, 16#8202#, 16#8205#, 16#8207#,
         16#820A#, 16#820D#, 16#8210#, 16#8216#,
         16#8229#, 16#822B#, 16#8238#, 16#8233#,
         16#8240#, 16#8259#, 16#8258#, 16#825D#,
         16#825A#, 16#825F#, 16#8264#, 16#0000#,
         16#8262#, 16#8268#, 16#826A#, 16#826B#,
         16#822E#, 16#8271#, 16#8277#, 16#8278#,
         16#827E#, 16#828D#, 16#8292#, 16#82AB#,
         16#829F#, 16#82BB#, 16#82AC#, 16#82E1#,
         16#82E3#, 16#82DF#, 16#82D2#, 16#82F4#,
         16#82F3#, 16#82FA#, 16#8393#, 16#8303#,
         16#82FB#, 16#82F9#, 16#82DE#, 16#8306#,
         16#82DC#, 16#8309#, 16#82D9#, 16#8335#,
         16#8334#, 16#8316#, 16#8332#, 16#8331#,
         16#8340#, 16#8339#, 16#8350#, 16#8345#,
         16#832F#, 16#832B#, 16#8317#, 16#8318#,
         16#8385#, 16#839A#, 16#83AA#, 16#839F#,
         16#83A2#, 16#8396#, 16#8323#, 16#838E#,
         16#8387#, 16#838A#, 16#837C#, 16#83B5#,
         16#8373#, 16#8375#, 16#83A0#, 16#8389#,
         16#83A8#, 16#83F4#, 16#8413#, 16#83EB#,
         16#83CE#, 16#83FD#, 16#8403#, 16#83D8#,
         16#840B#, 16#83C1#, 16#83F7#, 16#8407#,
         16#83E0#, 16#83F2#, 16#840D#, 16#8422#,
         16#8420#, 16#83BD#, 16#8438#, 16#8506#,
         16#83FB#, 16#846D#, 16#842A#, 16#843C#,
         16#855A#, 16#8484#, 16#8477#, 16#846B#,
         16#84AD#, 16#846E#, 16#8482#, 16#8469#,
         16#8446#, 16#842C#, 16#846F#, 16#8479#,
         16#8435#, 16#84CA#, 16#8462#, 16#84B9#,
         16#84BF#, 16#849F#, 16#84D9#, 16#84CD#,
         16#84BB#, 16#84DA#, 16#84D0#, 16#84C1#,
         16#84C6#, 16#84D6#, 16#84A1#, 16#8521#,
         16#84FF#, 16#84F4#, 16#8517#, 16#8518#,
         16#852C#, 16#851F#, 16#8515#, 16#8514#,
         16#84FC#, 16#8540#, 16#8563#, 16#8558#,
         16#8548#, 16#0000#, 16#0000#, 16#0000#);

   Decode_Double_E5 : aliased constant SHIFTJIS_Code_Point_Array
     := (16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#8541#, 16#8602#, 16#854B#, 16#8555#,
         16#8580#, 16#85A4#, 16#8588#, 16#8591#,
         16#858A#, 16#85A8#, 16#856D#, 16#8594#,
         16#859B#, 16#85EA#, 16#8587#, 16#859C#,
         16#8577#, 16#857E#, 16#8590#, 16#85C9#,
         16#85BA#, 16#85CF#, 16#85B9#, 16#85D0#,
         16#85D5#, 16#85DD#, 16#85E5#, 16#85DC#,
         16#85F9#, 16#860A#, 16#8613#, 16#860B#,
         16#85FE#, 16#85FA#, 16#8606#, 16#8622#,
         16#861A#, 16#8630#, 16#863F#, 16#864D#,
         16#4E55#, 16#8654#, 16#865F#, 16#8667#,
         16#8671#, 16#8693#, 16#86A3#, 16#86A9#,
         16#86AA#, 16#868B#, 16#868C#, 16#86B6#,
         16#86AF#, 16#86C4#, 16#86C6#, 16#86B0#,
         16#86C9#, 16#8823#, 16#86AB#, 16#86D4#,
         16#86DE#, 16#86E9#, 16#86EC#, 16#0000#,
         16#86DF#, 16#86DB#, 16#86EF#, 16#8712#,
         16#8706#, 16#8708#, 16#8700#, 16#8703#,
         16#86FB#, 16#8711#, 16#8709#, 16#870D#,
         16#86F9#, 16#870A#, 16#8734#, 16#873F#,
         16#8737#, 16#873B#, 16#8725#, 16#8729#,
         16#871A#, 16#8760#, 16#875F#, 16#8778#,
         16#874C#, 16#874E#, 16#8774#, 16#8757#,
         16#8768#, 16#876E#, 16#8759#, 16#8753#,
         16#8763#, 16#876A#, 16#8805#, 16#87A2#,
         16#879F#, 16#8782#, 16#87AF#, 16#87CB#,
         16#87BD#, 16#87C0#, 16#87D0#, 16#96D6#,
         16#87AB#, 16#87C4#, 16#87B3#, 16#87C7#,
         16#87C6#, 16#87BB#, 16#87EF#, 16#87F2#,
         16#87E0#, 16#880F#, 16#880D#, 16#87FE#,
         16#87F6#, 16#87F7#, 16#880E#, 16#87D2#,
         16#8811#, 16#8816#, 16#8815#, 16#8822#,
         16#8821#, 16#8831#, 16#8836#, 16#8839#,
         16#8827#, 16#883B#, 16#8844#, 16#8842#,
         16#8852#, 16#8859#, 16#885E#, 16#8862#,
         16#886B#, 16#8881#, 16#887E#, 16#889E#,
         16#8875#, 16#887D#, 16#88B5#, 16#8872#,
         16#8882#, 16#8897#, 16#8892#, 16#88AE#,
         16#8899#, 16#88A2#, 16#888D#, 16#88A4#,
         16#88B0#, 16#88BF#, 16#88B1#, 16#88C3#,
         16#88C4#, 16#88D4#, 16#88D8#, 16#88D9#,
         16#88DD#, 16#88F9#, 16#8902#, 16#88FC#,
         16#88F4#, 16#88E8#, 16#88F2#, 16#8904#,
         16#890C#, 16#890A#, 16#8913#, 16#8943#,
         16#891E#, 16#8925#, 16#892A#, 16#892B#,
         16#8941#, 16#8944#, 16#893B#, 16#8936#,
         16#8938#, 16#894C#, 16#891D#, 16#8960#,
         16#895E#, 16#0000#, 16#0000#, 16#0000#);

   Decode_Double_E6 : aliased constant SHIFTJIS_Code_Point_Array
     := (16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#8966#, 16#8964#, 16#896D#, 16#896A#,
         16#896F#, 16#8974#, 16#8977#, 16#897E#,
         16#8983#, 16#8988#, 16#898A#, 16#8993#,
         16#8998#, 16#89A1#, 16#89A9#, 16#89A6#,
         16#89AC#, 16#89AF#, 16#89B2#, 16#89BA#,
         16#89BD#, 16#89BF#, 16#89C0#, 16#89DA#,
         16#89DC#, 16#89DD#, 16#89E7#, 16#89F4#,
         16#89F8#, 16#8A03#, 16#8A16#, 16#8A10#,
         16#8A0C#, 16#8A1B#, 16#8A1D#, 16#8A25#,
         16#8A36#, 16#8A41#, 16#8A5B#, 16#8A52#,
         16#8A46#, 16#8A48#, 16#8A7C#, 16#8A6D#,
         16#8A6C#, 16#8A62#, 16#8A85#, 16#8A82#,
         16#8A84#, 16#8AA8#, 16#8AA1#, 16#8A91#,
         16#8AA5#, 16#8AA6#, 16#8A9A#, 16#8AA3#,
         16#8AC4#, 16#8ACD#, 16#8AC2#, 16#8ADA#,
         16#8AEB#, 16#8AF3#, 16#8AE7#, 16#0000#,
         16#8AE4#, 16#8AF1#, 16#8B14#, 16#8AE0#,
         16#8AE2#, 16#8AF7#, 16#8ADE#, 16#8ADB#,
         16#8B0C#, 16#8B07#, 16#8B1A#, 16#8AE1#,
         16#8B16#, 16#8B10#, 16#8B17#, 16#8B20#,
         16#8B33#, 16#97AB#, 16#8B26#, 16#8B2B#,
         16#8B3E#, 16#8B28#, 16#8B41#, 16#8B4C#,
         16#8B4F#, 16#8B4E#, 16#8B49#, 16#8B56#,
         16#8B5B#, 16#8B5A#, 16#8B6B#, 16#8B5F#,
         16#8B6C#, 16#8B6F#, 16#8B74#, 16#8B7D#,
         16#8B80#, 16#8B8C#, 16#8B8E#, 16#8B92#,
         16#8B93#, 16#8B96#, 16#8B99#, 16#8B9A#,
         16#8C3A#, 16#8C41#, 16#8C3F#, 16#8C48#,
         16#8C4C#, 16#8C4E#, 16#8C50#, 16#8C55#,
         16#8C62#, 16#8C6C#, 16#8C78#, 16#8C7A#,
         16#8C82#, 16#8C89#, 16#8C85#, 16#8C8A#,
         16#8C8D#, 16#8C8E#, 16#8C94#, 16#8C7C#,
         16#8C98#, 16#621D#, 16#8CAD#, 16#8CAA#,
         16#8CBD#, 16#8CB2#, 16#8CB3#, 16#8CAE#,
         16#8CB6#, 16#8CC8#, 16#8CC1#, 16#8CE4#,
         16#8CE3#, 16#8CDA#, 16#8CFD#, 16#8CFA#,
         16#8CFB#, 16#8D04#, 16#8D05#, 16#8D0A#,
         16#8D07#, 16#8D0F#, 16#8D0D#, 16#8D10#,
         16#9F4E#, 16#8D13#, 16#8CCD#, 16#8D14#,
         16#8D16#, 16#8D67#, 16#8D6D#, 16#8D71#,
         16#8D73#, 16#8D81#, 16#8D99#, 16#8DC2#,
         16#8DBE#, 16#8DBA#, 16#8DCF#, 16#8DDA#,
         16#8DD6#, 16#8DCC#, 16#8DDB#, 16#8DCB#,
         16#8DEA#, 16#8DEB#, 16#8DDF#, 16#8DE3#,
         16#8DFC#, 16#8E08#, 16#8E09#, 16#8DFF#,
         16#8E1D#, 16#8E1E#, 16#8E10#, 16#8E1F#,
         16#8E42#, 16#8E35#, 16#8E30#, 16#8E34#,
         16#8E4A#, 16#0000#, 16#0000#, 16#0000#);

   Decode_Double_E7 : aliased constant SHIFTJIS_Code_Point_Array
     := (16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#8E47#, 16#8E49#, 16#8E4C#, 16#8E50#,
         16#8E48#, 16#8E59#, 16#8E64#, 16#8E60#,
         16#8E2A#, 16#8E63#, 16#8E55#, 16#8E76#,
         16#8E72#, 16#8E7C#, 16#8E81#, 16#8E87#,
         16#8E85#, 16#8E84#, 16#8E8B#, 16#8E8A#,
         16#8E93#, 16#8E91#, 16#8E94#, 16#8E99#,
         16#8EAA#, 16#8EA1#, 16#8EAC#, 16#8EB0#,
         16#8EC6#, 16#8EB1#, 16#8EBE#, 16#8EC5#,
         16#8EC8#, 16#8ECB#, 16#8EDB#, 16#8EE3#,
         16#8EFC#, 16#8EFB#, 16#8EEB#, 16#8EFE#,
         16#8F0A#, 16#8F05#, 16#8F15#, 16#8F12#,
         16#8F19#, 16#8F13#, 16#8F1C#, 16#8F1F#,
         16#8F1B#, 16#8F0C#, 16#8F26#, 16#8F33#,
         16#8F3B#, 16#8F39#, 16#8F45#, 16#8F42#,
         16#8F3E#, 16#8F4C#, 16#8F49#, 16#8F46#,
         16#8F4E#, 16#8F57#, 16#8F5C#, 16#0000#,
         16#8F62#, 16#8F63#, 16#8F64#, 16#8F9C#,
         16#8F9F#, 16#8FA3#, 16#8FAD#, 16#8FAF#,
         16#8FB7#, 16#8FDA#, 16#8FE5#, 16#8FE2#,
         16#8FEA#, 16#8FEF#, 16#9087#, 16#8FF4#,
         16#9005#, 16#8FF9#, 16#8FFA#, 16#9011#,
         16#9015#, 16#9021#, 16#900D#, 16#901E#,
         16#9016#, 16#900B#, 16#9027#, 16#9036#,
         16#9035#, 16#9039#, 16#8FF8#, 16#904F#,
         16#9050#, 16#9051#, 16#9052#, 16#900E#,
         16#9049#, 16#903E#, 16#9056#, 16#9058#,
         16#905E#, 16#9068#, 16#906F#, 16#9076#,
         16#96A8#, 16#9072#, 16#9082#, 16#907D#,
         16#9081#, 16#9080#, 16#908A#, 16#9089#,
         16#908F#, 16#90A8#, 16#90AF#, 16#90B1#,
         16#90B5#, 16#90E2#, 16#90E4#, 16#6248#,
         16#90DB#, 16#9102#, 16#9112#, 16#9119#,
         16#9132#, 16#9130#, 16#914A#, 16#9156#,
         16#9158#, 16#9163#, 16#9165#, 16#9169#,
         16#9173#, 16#9172#, 16#918B#, 16#9189#,
         16#9182#, 16#91A2#, 16#91AB#, 16#91AF#,
         16#91AA#, 16#91B5#, 16#91B4#, 16#91BA#,
         16#91C0#, 16#91C1#, 16#91C9#, 16#91CB#,
         16#91D0#, 16#91D6#, 16#91DF#, 16#91E1#,
         16#91DB#, 16#91FC#, 16#91F5#, 16#91F6#,
         16#921E#, 16#91FF#, 16#9214#, 16#922C#,
         16#9215#, 16#9211#, 16#925E#, 16#9257#,
         16#9245#, 16#9249#, 16#9264#, 16#9248#,
         16#9295#, 16#923F#, 16#924B#, 16#9250#,
         16#929C#, 16#9296#, 16#9293#, 16#929B#,
         16#925A#, 16#92CF#, 16#92B9#, 16#92B7#,
         16#92E9#, 16#930F#, 16#92FA#, 16#9344#,
         16#932E#, 16#0000#, 16#0000#, 16#0000#);

   Decode_Double_E8 : aliased constant SHIFTJIS_Code_Point_Array
     := (16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#9319#, 16#9322#, 16#931A#, 16#9323#,
         16#933A#, 16#9335#, 16#933B#, 16#935C#,
         16#9360#, 16#937C#, 16#936E#, 16#9356#,
         16#93B0#, 16#93AC#, 16#93AD#, 16#9394#,
         16#93B9#, 16#93D6#, 16#93D7#, 16#93E8#,
         16#93E5#, 16#93D8#, 16#93C3#, 16#93DD#,
         16#93D0#, 16#93C8#, 16#93E4#, 16#941A#,
         16#9414#, 16#9413#, 16#9403#, 16#9407#,
         16#9410#, 16#9436#, 16#942B#, 16#9435#,
         16#9421#, 16#943A#, 16#9441#, 16#9452#,
         16#9444#, 16#945B#, 16#9460#, 16#9462#,
         16#945E#, 16#946A#, 16#9229#, 16#9470#,
         16#9475#, 16#9477#, 16#947D#, 16#945A#,
         16#947C#, 16#947E#, 16#9481#, 16#947F#,
         16#9582#, 16#9587#, 16#958A#, 16#9594#,
         16#9596#, 16#9598#, 16#9599#, 16#0000#,
         16#95A0#, 16#95A8#, 16#95A7#, 16#95AD#,
         16#95BC#, 16#95BB#, 16#95B9#, 16#95BE#,
         16#95CA#, 16#6FF6#, 16#95C3#, 16#95CD#,
         16#95CC#, 16#95D5#, 16#95D4#, 16#95D6#,
         16#95DC#, 16#95E1#, 16#95E5#, 16#95E2#,
         16#9621#, 16#9628#, 16#962E#, 16#962F#,
         16#9642#, 16#964C#, 16#964F#, 16#964B#,
         16#9677#, 16#965C#, 16#965E#, 16#965D#,
         16#965F#, 16#9666#, 16#9672#, 16#966C#,
         16#968D#, 16#9698#, 16#9695#, 16#9697#,
         16#96AA#, 16#96A7#, 16#96B1#, 16#96B2#,
         16#96B0#, 16#96B4#, 16#96B6#, 16#96B8#,
         16#96B9#, 16#96CE#, 16#96CB#, 16#96C9#,
         16#96CD#, 16#894D#, 16#96DC#, 16#970D#,
         16#96D5#, 16#96F9#, 16#9704#, 16#9706#,
         16#9708#, 16#9713#, 16#970E#, 16#9711#,
         16#970F#, 16#9716#, 16#9719#, 16#9724#,
         16#972A#, 16#9730#, 16#9739#, 16#973D#,
         16#973E#, 16#9744#, 16#9746#, 16#9748#,
         16#9742#, 16#9749#, 16#975C#, 16#9760#,
         16#9764#, 16#9766#, 16#9768#, 16#52D2#,
         16#976B#, 16#9771#, 16#9779#, 16#9785#,
         16#977C#, 16#9781#, 16#977A#, 16#9786#,
         16#978B#, 16#978F#, 16#9790#, 16#979C#,
         16#97A8#, 16#97A6#, 16#97A3#, 16#97B3#,
         16#97B4#, 16#97C3#, 16#97C6#, 16#97C8#,
         16#97CB#, 16#97DC#, 16#97ED#, 16#9F4F#,
         16#97F2#, 16#7ADF#, 16#97F6#, 16#97F5#,
         16#980F#, 16#980C#, 16#9838#, 16#9824#,
         16#9821#, 16#9837#, 16#983D#, 16#9846#,
         16#984F#, 16#984B#, 16#986B#, 16#986F#,
         16#9870#, 16#0000#, 16#0000#, 16#0000#);

   Decode_Double_E9 : aliased constant SHIFTJIS_Code_Point_Array
     := (16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#9871#, 16#9874#, 16#9873#, 16#98AA#,
         16#98AF#, 16#98B1#, 16#98B6#, 16#98C4#,
         16#98C3#, 16#98C6#, 16#98E9#, 16#98EB#,
         16#9903#, 16#9909#, 16#9912#, 16#9914#,
         16#9918#, 16#9921#, 16#991D#, 16#991E#,
         16#9924#, 16#9920#, 16#992C#, 16#992E#,
         16#993D#, 16#993E#, 16#9942#, 16#9949#,
         16#9945#, 16#9950#, 16#994B#, 16#9951#,
         16#9952#, 16#994C#, 16#9955#, 16#9997#,
         16#9998#, 16#99A5#, 16#99AD#, 16#99AE#,
         16#99BC#, 16#99DF#, 16#99DB#, 16#99DD#,
         16#99D8#, 16#99D1#, 16#99ED#, 16#99EE#,
         16#99F1#, 16#99F2#, 16#99FB#, 16#99F8#,
         16#9A01#, 16#9A0F#, 16#9A05#, 16#99E2#,
         16#9A19#, 16#9A2B#, 16#9A37#, 16#9A45#,
         16#9A42#, 16#9A40#, 16#9A43#, 16#0000#,
         16#9A3E#, 16#9A55#, 16#9A4D#, 16#9A5B#,
         16#9A57#, 16#9A5F#, 16#9A62#, 16#9A65#,
         16#9A64#, 16#9A69#, 16#9A6B#, 16#9A6A#,
         16#9AAD#, 16#9AB0#, 16#9ABC#, 16#9AC0#,
         16#9ACF#, 16#9AD1#, 16#9AD3#, 16#9AD4#,
         16#9ADE#, 16#9ADF#, 16#9AE2#, 16#9AE3#,
         16#9AE6#, 16#9AEF#, 16#9AEB#, 16#9AEE#,
         16#9AF4#, 16#9AF1#, 16#9AF7#, 16#9AFB#,
         16#9B06#, 16#9B18#, 16#9B1A#, 16#9B1F#,
         16#9B22#, 16#9B23#, 16#9B25#, 16#9B27#,
         16#9B28#, 16#9B29#, 16#9B2A#, 16#9B2E#,
         16#9B2F#, 16#9B32#, 16#9B44#, 16#9B43#,
         16#9B4F#, 16#9B4D#, 16#9B4E#, 16#9B51#,
         16#9B58#, 16#9B74#, 16#9B93#, 16#9B83#,
         16#9B91#, 16#9B96#, 16#9B97#, 16#9B9F#,
         16#9BA0#, 16#9BA8#, 16#9BB4#, 16#9BC0#,
         16#9BCA#, 16#9BB9#, 16#9BC6#, 16#9BCF#,
         16#9BD1#, 16#9BD2#, 16#9BE3#, 16#9BE2#,
         16#9BE4#, 16#9BD4#, 16#9BE1#, 16#9C3A#,
         16#9BF2#, 16#9BF1#, 16#9BF0#, 16#9C15#,
         16#9C14#, 16#9C09#, 16#9C13#, 16#9C0C#,
         16#9C06#, 16#9C08#, 16#9C12#, 16#9C0A#,
         16#9C04#, 16#9C2E#, 16#9C1B#, 16#9C25#,
         16#9C24#, 16#9C21#, 16#9C30#, 16#9C47#,
         16#9C32#, 16#9C46#, 16#9C3E#, 16#9C5A#,
         16#9C60#, 16#9C67#, 16#9C76#, 16#9C78#,
         16#9CE7#, 16#9CEC#, 16#9CF0#, 16#9D09#,
         16#9D08#, 16#9CEB#, 16#9D03#, 16#9D06#,
         16#9D2A#, 16#9D26#, 16#9DAF#, 16#9D23#,
         16#9D1F#, 16#9D44#, 16#9D15#, 16#9D12#,
         16#9D41#, 16#9D3F#, 16#9D3E#, 16#9D46#,
         16#9D48#, 16#0000#, 16#0000#, 16#0000#);

   Decode_Double_EA : aliased constant SHIFTJIS_Code_Point_Array
     := (16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#9D5D#, 16#9D5E#, 16#9D64#, 16#9D51#,
         16#9D50#, 16#9D59#, 16#9D72#, 16#9D89#,
         16#9D87#, 16#9DAB#, 16#9D6F#, 16#9D7A#,
         16#9D9A#, 16#9DA4#, 16#9DA9#, 16#9DB2#,
         16#9DC4#, 16#9DC1#, 16#9DBB#, 16#9DB8#,
         16#9DBA#, 16#9DC6#, 16#9DCF#, 16#9DC2#,
         16#9DD9#, 16#9DD3#, 16#9DF8#, 16#9DE6#,
         16#9DED#, 16#9DEF#, 16#9DFD#, 16#9E1A#,
         16#9E1B#, 16#9E1E#, 16#9E75#, 16#9E79#,
         16#9E7D#, 16#9E81#, 16#9E88#, 16#9E8B#,
         16#9E8C#, 16#9E92#, 16#9E95#, 16#9E91#,
         16#9E9D#, 16#9EA5#, 16#9EA9#, 16#9EB8#,
         16#9EAA#, 16#9EAD#, 16#9761#, 16#9ECC#,
         16#9ECE#, 16#9ECF#, 16#9ED0#, 16#9ED4#,
         16#9EDC#, 16#9EDE#, 16#9EDD#, 16#9EE0#,
         16#9EE5#, 16#9EE8#, 16#9EEF#, 16#0000#,
         16#9EF4#, 16#9EF6#, 16#9EF7#, 16#9EF9#,
         16#9EFB#, 16#9EFC#, 16#9EFD#, 16#9F07#,
         16#9F08#, 16#76B7#, 16#9F15#, 16#9F21#,
         16#9F2C#, 16#9F3E#, 16#9F4A#, 16#9F52#,
         16#9F54#, 16#9F63#, 16#9F5F#, 16#9F60#,
         16#9F61#, 16#9F66#, 16#9F67#, 16#9F6C#,
         16#9F6A#, 16#9F77#, 16#9F72#, 16#9F76#,
         16#9F95#, 16#9F9C#, 16#9FA0#, 16#582F#,
         16#69C7#, 16#9059#, 16#7464#, 16#51DC#,
         16#7199#, 16#5653#, 16#5DE2#, 16#5E14#,
         16#5E18#, 16#5E58#, 16#5E5E#, 16#5EBE#,
         16#F928#, 16#5ECB#, 16#5EF9#, 16#5F00#,
         16#5F02#, 16#5F07#, 16#5F1D#, 16#5F23#,
         16#5F34#, 16#5F36#, 16#5F3D#, 16#5F40#,
         16#5F45#, 16#5F54#, 16#5F58#, 16#5F64#,
         16#5F67#, 16#5F7D#, 16#5F89#, 16#5F9C#,
         16#5FA7#, 16#5FAF#, 16#5FB5#, 16#5FB7#,
         16#5FC9#, 16#5FDE#, 16#5FE1#, 16#5FE9#,
         16#600D#, 16#6014#, 16#6018#, 16#6033#,
         16#6035#, 16#6047#, 16#FA3D#, 16#609D#,
         16#609E#, 16#60CB#, 16#60D4#, 16#60D5#,
         16#60DD#, 16#60F8#, 16#611C#, 16#612B#,
         16#6130#, 16#6137#, 16#FA3E#, 16#618D#,
         16#FA3F#, 16#61BC#, 16#61B9#, 16#FA40#,
         16#6222#, 16#623E#, 16#6243#, 16#6256#,
         16#625A#, 16#626F#, 16#6285#, 16#62C4#,
         16#62D6#, 16#62FC#, 16#630A#, 16#6318#,
         16#6339#, 16#6343#, 16#6365#, 16#637C#,
         16#63E5#, 16#63ED#, 16#63F5#, 16#6410#,
         16#6414#, 16#6422#, 16#6479#, 16#6451#,
         16#6460#, 16#646D#, 16#64CE#, 16#64BE#,
         16#64BF#, 16#0000#, 16#0000#, 16#0000#);

   Decode_Double_EB : aliased constant SHIFTJIS_Code_Point_Array
     := (16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#64C4#, 16#64CA#, 16#64D0#, 16#64F7#,
         16#64FB#, 16#6522#, 16#6529#, 16#FA41#,
         16#6567#, 16#659D#, 16#FA42#, 16#6600#,
         16#6609#, 16#6615#, 16#661E#, 16#663A#,
         16#6622#, 16#6624#, 16#662B#, 16#6630#,
         16#6631#, 16#6633#, 16#66FB#, 16#6648#,
         16#664C#, 16#02_31C4#, 16#6659#, 16#665A#,
         16#6661#, 16#6665#, 16#6673#, 16#6677#,
         16#6678#, 16#668D#, 16#FA43#, 16#66A0#,
         16#66B2#, 16#66BB#, 16#66C6#, 16#66C8#,
         16#3B22#, 16#66DB#, 16#66E8#, 16#66FA#,
         16#6713#, 16#F929#, 16#6733#, 16#6766#,
         16#6747#, 16#6748#, 16#677B#, 16#6781#,
         16#6793#, 16#6798#, 16#679B#, 16#67BB#,
         16#67F9#, 16#67C0#, 16#67D7#, 16#67FC#,
         16#6801#, 16#6852#, 16#681D#, 16#0000#,
         16#682C#, 16#6831#, 16#685B#, 16#6872#,
         16#6875#, 16#FA44#, 16#68A3#, 16#68A5#,
         16#68B2#, 16#68C8#, 16#68D0#, 16#68E8#,
         16#68ED#, 16#68F0#, 16#68F1#, 16#68FC#,
         16#690A#, 16#6949#, 16#02_35C4#, 16#6935#,
         16#6942#, 16#6957#, 16#6963#, 16#6964#,
         16#6968#, 16#6980#, 16#FA14#, 16#69A5#,
         16#69AD#, 16#69CF#, 16#3BB6#, 16#3BC3#,
         16#69E2#, 16#69E9#, 16#69EA#, 16#69F5#,
         16#69F6#, 16#6A0F#, 16#6A15#, 16#02_373F#,
         16#6A3B#, 16#6A3E#, 16#6A45#, 16#6A50#,
         16#6A56#, 16#6A5B#, 16#6A6B#, 16#6A73#,
         16#02_3763#, 16#6A89#, 16#6A94#, 16#6A9D#,
         16#6A9E#, 16#6AA5#, 16#6AE4#, 16#6AE7#,
         16#3C0F#, 16#F91D#, 16#6B1B#, 16#6B1E#,
         16#6B2C#, 16#6B35#, 16#6B46#, 16#6B56#,
         16#6B60#, 16#6B65#, 16#6B67#, 16#6B77#,
         16#6B82#, 16#6BA9#, 16#6BAD#, 16#F970#,
         16#6BCF#, 16#6BD6#, 16#6BD7#, 16#6BFF#,
         16#6C05#, 16#6C10#, 16#6C33#, 16#6C59#,
         16#6C5C#, 16#6CAA#, 16#6C74#, 16#6C76#,
         16#6C85#, 16#6C86#, 16#6C98#, 16#6C9C#,
         16#6CFB#, 16#6CC6#, 16#6CD4#, 16#6CE0#,
         16#6CEB#, 16#6CEE#, 16#02_3CFE#, 16#6D04#,
         16#6D0E#, 16#6D2E#, 16#6D31#, 16#6D39#,
         16#6D3F#, 16#6D58#, 16#6D65#, 16#FA45#,
         16#6D82#, 16#6D87#, 16#6D89#, 16#6D94#,
         16#6DAA#, 16#6DAC#, 16#6DBF#, 16#6DC4#,
         16#6DD6#, 16#6DDA#, 16#6DDB#, 16#6DDD#,
         16#6DFC#, 16#FA46#, 16#6E34#, 16#6E44#,
         16#6E5C#, 16#6E5E#, 16#6EAB#, 16#6EB1#,
         16#6EC1#, 16#0000#, 16#0000#, 16#0000#);

   Decode_Double_EC : aliased constant SHIFTJIS_Code_Point_Array
     := (16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#6EC7#, 16#6ECE#, 16#6F10#, 16#6F1A#,
         16#FA47#, 16#6F2A#, 16#6F2F#, 16#6F33#,
         16#6F51#, 16#6F59#, 16#6F5E#, 16#6F61#,
         16#6F62#, 16#6F7E#, 16#6F88#, 16#6F8C#,
         16#6F8D#, 16#6F94#, 16#6FA0#, 16#6FA7#,
         16#6FB6#, 16#6FBC#, 16#6FC7#, 16#6FCA#,
         16#6FF9#, 16#6FF0#, 16#6FF5#, 16#7005#,
         16#7006#, 16#7028#, 16#704A#, 16#705D#,
         16#705E#, 16#704E#, 16#7064#, 16#7075#,
         16#7085#, 16#70A4#, 16#70AB#, 16#70B7#,
         16#70D4#, 16#70D8#, 16#70E4#, 16#710F#,
         16#712B#, 16#711E#, 16#7120#, 16#712E#,
         16#7130#, 16#7146#, 16#7147#, 16#7151#,
         16#FA48#, 16#7152#, 16#715C#, 16#7160#,
         16#7168#, 16#FA15#, 16#7185#, 16#7187#,
         16#7192#, 16#71C1#, 16#71BA#, 16#0000#,
         16#71C4#, 16#71FE#, 16#7200#, 16#7215#,
         16#7255#, 16#7256#, 16#3E3F#, 16#728D#,
         16#729B#, 16#72BE#, 16#72C0#, 16#72FB#,
         16#02_47F1#, 16#7327#, 16#7328#, 16#FA16#,
         16#7350#, 16#7366#, 16#737C#, 16#7395#,
         16#739F#, 16#73A0#, 16#73A2#, 16#73A6#,
         16#73AB#, 16#73C9#, 16#73CF#, 16#73D6#,
         16#73D9#, 16#73E3#, 16#73E9#, 16#7407#,
         16#740A#, 16#741A#, 16#741B#, 16#FA4A#,
         16#7426#, 16#7428#, 16#742A#, 16#742B#,
         16#742C#, 16#742E#, 16#742F#, 16#7430#,
         16#7444#, 16#7446#, 16#7447#, 16#744B#,
         16#7457#, 16#7462#, 16#746B#, 16#746D#,
         16#7486#, 16#7487#, 16#7489#, 16#7498#,
         16#749C#, 16#749F#, 16#74A3#, 16#7490#,
         16#74A6#, 16#74A8#, 16#74A9#, 16#74B5#,
         16#74BF#, 16#74C8#, 16#74C9#, 16#74DA#,
         16#74FF#, 16#7501#, 16#7517#, 16#752F#,
         16#756F#, 16#7579#, 16#7592#, 16#3F72#,
         16#75CE#, 16#75E4#, 16#7600#, 16#7602#,
         16#7608#, 16#7615#, 16#7616#, 16#7619#,
         16#761E#, 16#762D#, 16#7635#, 16#7643#,
         16#764B#, 16#7664#, 16#7665#, 16#766D#,
         16#766F#, 16#7671#, 16#7681#, 16#769B#,
         16#769D#, 16#769E#, 16#76A6#, 16#76AA#,
         16#76B6#, 16#76C5#, 16#76CC#, 16#76CE#,
         16#76D4#, 16#76E6#, 16#76F1#, 16#76FC#,
         16#770A#, 16#7719#, 16#7734#, 16#7736#,
         16#7746#, 16#774D#, 16#774E#, 16#775C#,
         16#775F#, 16#7762#, 16#777A#, 16#7780#,
         16#7794#, 16#77AA#, 16#77E0#, 16#782D#,
         16#02_548E#, 16#0000#, 16#0000#, 16#0000#);

   Decode_Double_ED : aliased constant SHIFTJIS_Code_Point_Array
     := (16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#7843#, 16#784E#, 16#784F#, 16#7851#,
         16#7868#, 16#786E#, 16#FA4B#, 16#78B0#,
         16#02_550E#, 16#78AD#, 16#78E4#, 16#78F2#,
         16#7900#, 16#78F7#, 16#791C#, 16#792E#,
         16#7931#, 16#7934#, 16#FA4C#, 16#FA4D#,
         16#7945#, 16#7946#, 16#FA4E#, 16#FA4F#,
         16#FA50#, 16#795C#, 16#FA51#, 16#FA19#,
         16#FA1A#, 16#7979#, 16#FA52#, 16#FA53#,
         16#FA1B#, 16#7998#, 16#79B1#, 16#79B8#,
         16#79C8#, 16#79CA#, 16#02_5771#, 16#79D4#,
         16#79DE#, 16#79EB#, 16#79ED#, 16#7A03#,
         16#FA54#, 16#7A39#, 16#7A5D#, 16#7A6D#,
         16#FA55#, 16#7A85#, 16#7AA0#, 16#02_59C4#,
         16#7AB3#, 16#7ABB#, 16#7ACE#, 16#7AEB#,
         16#7AFD#, 16#7B12#, 16#7B2D#, 16#7B3B#,
         16#7B47#, 16#7B4E#, 16#7B60#, 16#0000#,
         16#7B6D#, 16#7B6F#, 16#7B72#, 16#7B9E#,
         16#FA56#, 16#7BD7#, 16#7BD9#, 16#7C01#,
         16#7C31#, 16#7C1E#, 16#7C20#, 16#7C33#,
         16#7C36#, 16#4264#, 16#02_5DA1#, 16#7C59#,
         16#7C6D#, 16#7C79#, 16#7C8F#, 16#7C94#,
         16#7CA0#, 16#7CBC#, 16#7CD5#, 16#7CD9#,
         16#7CDD#, 16#7D07#, 16#7D08#, 16#7D13#,
         16#7D1D#, 16#7D23#, 16#7D31#, 16#7D41#,
         16#7D48#, 16#7D53#, 16#7D5C#, 16#7D7A#,
         16#7D83#, 16#7D8B#, 16#7DA0#, 16#7DA6#,
         16#7DC2#, 16#7DCC#, 16#7DD6#, 16#7DE3#,
         16#FA57#, 16#7E28#, 16#7E08#, 16#7E11#,
         16#7E15#, 16#FA59#, 16#7E47#, 16#7E52#,
         16#7E61#, 16#7E8A#, 16#7E8D#, 16#7F47#,
         16#FA5A#, 16#7F91#, 16#7F97#, 16#7FBF#,
         16#7FCE#, 16#7FDB#, 16#7FDF#, 16#7FEC#,
         16#7FEE#, 16#7FFA#, 16#FA5B#, 16#8014#,
         16#8026#, 16#8035#, 16#8037#, 16#803C#,
         16#80CA#, 16#80D7#, 16#80E0#, 16#80F3#,
         16#8118#, 16#814A#, 16#8160#, 16#8167#,
         16#8168#, 16#816D#, 16#81BB#, 16#81CA#,
         16#81CF#, 16#81D7#, 16#FA5C#, 16#4453#,
         16#445B#, 16#8260#, 16#8274#, 16#02_6AFF#,
         16#828E#, 16#82A1#, 16#82A3#, 16#82A4#,
         16#82A9#, 16#82AE#, 16#82B7#, 16#82BE#,
         16#82BF#, 16#82C6#, 16#82D5#, 16#82FD#,
         16#82FE#, 16#8300#, 16#8301#, 16#8362#,
         16#8322#, 16#832D#, 16#833A#, 16#8343#,
         16#8347#, 16#8351#, 16#8355#, 16#837D#,
         16#8386#, 16#8392#, 16#8398#, 16#83A7#,
         16#83A9#, 16#83BF#, 16#83C0#, 16#83C7#,
         16#83CF#, 16#0000#, 16#0000#, 16#0000#);

   Decode_Double_EE : aliased constant SHIFTJIS_Code_Point_Array
     := (16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#83D1#, 16#83E1#, 16#83EA#, 16#8401#,
         16#8406#, 16#840A#, 16#FA5F#, 16#8448#,
         16#845F#, 16#8470#, 16#8473#, 16#8485#,
         16#849E#, 16#84AF#, 16#84B4#, 16#84BA#,
         16#84C0#, 16#84C2#, 16#02_6E40#, 16#8532#,
         16#851E#, 16#8523#, 16#852F#, 16#8559#,
         16#8564#, 16#FA1F#, 16#85AD#, 16#857A#,
         16#858C#, 16#858F#, 16#85A2#, 16#85B0#,
         16#85CB#, 16#85CE#, 16#85ED#, 16#8612#,
         16#85FF#, 16#8604#, 16#8605#, 16#8610#,
         16#02_70F4#, 16#8618#, 16#8629#, 16#8638#,
         16#8657#, 16#865B#, 16#F936#, 16#8662#,
         16#459D#, 16#866C#, 16#8675#, 16#8698#,
         16#86B8#, 16#86FA#, 16#86FC#, 16#86FD#,
         16#870B#, 16#8771#, 16#8787#, 16#8788#,
         16#87AC#, 16#87AD#, 16#87B5#, 16#0000#,
         16#45EA#, 16#87D6#, 16#87EC#, 16#8806#,
         16#880A#, 16#8810#, 16#8814#, 16#881F#,
         16#8898#, 16#88AA#, 16#88CA#, 16#88CE#,
         16#02_7684#, 16#88F5#, 16#891C#, 16#FA60#,
         16#8918#, 16#8919#, 16#891A#, 16#8927#,
         16#8930#, 16#8932#, 16#8939#, 16#8940#,
         16#8994#, 16#FA61#, 16#89D4#, 16#89E5#,
         16#89F6#, 16#8A12#, 16#8A15#, 16#8A22#,
         16#8A37#, 16#8A47#, 16#8A4E#, 16#8A5D#,
         16#8A61#, 16#8A75#, 16#8A79#, 16#8AA7#,
         16#8AD0#, 16#8ADF#, 16#8AF4#, 16#8AF6#,
         16#FA22#, 16#FA62#, 16#FA63#, 16#8B46#,
         16#8B54#, 16#8B59#, 16#8B69#, 16#8B9D#,
         16#8C49#, 16#8C68#, 16#FA64#, 16#8CE1#,
         16#8CF4#, 16#8CF8#, 16#8CFE#, 16#FA65#,
         16#8D12#, 16#8D1B#, 16#8DAF#, 16#8DCE#,
         16#8DD1#, 16#8DD7#, 16#8E20#, 16#8E23#,
         16#8E3D#, 16#8E70#, 16#8E7B#, 16#02_8277#,
         16#8EC0#, 16#4844#, 16#8EFA#, 16#8F1E#,
         16#8F2D#, 16#8F36#, 16#8F54#, 16#02_83CD#,
         16#8FA6#, 16#8FB5#, 16#8FE4#, 16#8FE8#,
         16#8FEE#, 16#9008#, 16#902D#, 16#FA67#,
         16#9088#, 16#9095#, 16#9097#, 16#9099#,
         16#909B#, 16#90A2#, 16#90B3#, 16#90BE#,
         16#90C4#, 16#90C5#, 16#90C7#, 16#90D7#,
         16#90DD#, 16#90DE#, 16#90EF#, 16#90F4#,
         16#FA26#, 16#9114#, 16#9115#, 16#9116#,
         16#9122#, 16#9123#, 16#9127#, 16#912F#,
         16#9131#, 16#9134#, 16#913D#, 16#9148#,
         16#915B#, 16#9183#, 16#919E#, 16#91AC#,
         16#91B1#, 16#91BC#, 16#91D7#, 16#91FB#,
         16#91E4#, 16#0000#, 16#0000#, 16#0000#);

   Decode_Double_EF : aliased constant SHIFTJIS_Code_Point_Array
     := (16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#91E5#, 16#91ED#, 16#91F1#, 16#9207#,
         16#9210#, 16#9238#, 16#9239#, 16#923A#,
         16#923C#, 16#9240#, 16#9243#, 16#924F#,
         16#9278#, 16#9288#, 16#92C2#, 16#92CB#,
         16#92CC#, 16#92D3#, 16#92E0#, 16#92FF#,
         16#9304#, 16#931F#, 16#9321#, 16#9325#,
         16#9348#, 16#9349#, 16#934A#, 16#9364#,
         16#9365#, 16#936A#, 16#9370#, 16#939B#,
         16#93A3#, 16#93BA#, 16#93C6#, 16#93DE#,
         16#93DF#, 16#9404#, 16#93FD#, 16#9433#,
         16#944A#, 16#9463#, 16#946B#, 16#9471#,
         16#9472#, 16#958E#, 16#959F#, 16#95A6#,
         16#95A9#, 16#95AC#, 16#95B6#, 16#95BD#,
         16#95CB#, 16#95D0#, 16#95D3#, 16#49B0#,
         16#95DA#, 16#95DE#, 16#9658#, 16#9684#,
         16#F9DC#, 16#969D#, 16#96A4#, 16#0000#,
         16#96A5#, 16#96D2#, 16#96DE#, 16#FA68#,
         16#96E9#, 16#96EF#, 16#9733#, 16#973B#,
         16#974D#, 16#974E#, 16#974F#, 16#975A#,
         16#976E#, 16#9773#, 16#9795#, 16#97AE#,
         16#97BA#, 16#97C1#, 16#97C9#, 16#97DE#,
         16#97DB#, 16#97F4#, 16#FA69#, 16#980A#,
         16#981E#, 16#982B#, 16#9830#, 16#FA6A#,
         16#9852#, 16#9853#, 16#9856#, 16#9857#,
         16#9859#, 16#985A#, 16#F9D0#, 16#9865#,
         16#986C#, 16#98BA#, 16#98C8#, 16#98E7#,
         16#9958#, 16#999E#, 16#9A02#, 16#9A03#,
         16#9A24#, 16#9A2D#, 16#9A2E#, 16#9A38#,
         16#9A4A#, 16#9A4E#, 16#9A52#, 16#9AB6#,
         16#9AC1#, 16#9AC3#, 16#9ACE#, 16#9AD6#,
         16#9AF9#, 16#9B02#, 16#9B08#, 16#9B20#,
         16#4C17#, 16#9B2D#, 16#9B5E#, 16#9B79#,
         16#9B66#, 16#9B72#, 16#9B75#, 16#9B84#,
         16#9B8A#, 16#9B8F#, 16#9B9E#, 16#9BA7#,
         16#9BC1#, 16#9BCE#, 16#9BE5#, 16#9BF8#,
         16#9BFD#, 16#9C00#, 16#9C23#, 16#9C41#,
         16#9C4F#, 16#9C50#, 16#9C53#, 16#9C63#,
         16#9C65#, 16#9C77#, 16#9D1D#, 16#9D1E#,
         16#9D43#, 16#9D47#, 16#9D52#, 16#9D63#,
         16#9D70#, 16#9D7C#, 16#9D8A#, 16#9D96#,
         16#9DC0#, 16#9DAC#, 16#9DBC#, 16#9DD7#,
         16#02_A190#, 16#9DE7#, 16#9E07#, 16#9E15#,
         16#9E7C#, 16#9E9E#, 16#9EA4#, 16#9EAC#,
         16#9EAF#, 16#9EB4#, 16#9EB5#, 16#9EC3#,
         16#9ED1#, 16#9F10#, 16#9F39#, 16#9F57#,
         16#9F90#, 16#9F94#, 16#9F97#, 16#9FA2#,
         16#59F8#, 16#5C5B#, 16#5E77#, 16#7626#,
         16#7E6B#, 16#0000#, 16#0000#, 16#0000#);

   Decode_Double_F0 : aliased constant SHIFTJIS_Code_Point_Array
     := (16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#02_0089#, 16#4E02#, 16#4E0F#, 16#4E12#,
         16#4E29#, 16#4E2B#, 16#4E2E#, 16#4E40#,
         16#4E47#, 16#4E48#, 16#02_00A2#, 16#4E51#,
         16#3406#, 16#02_00A4#, 16#4E5A#, 16#4E69#,
         16#4E9D#, 16#342C#, 16#342E#, 16#4EB9#,
         16#4EBB#, 16#02_01A2#, 16#4EBC#, 16#4EC3#,
         16#4EC8#, 16#4ED0#, 16#4EEB#, 16#4EDA#,
         16#4EF1#, 16#4EF5#, 16#4F00#, 16#4F16#,
         16#4F64#, 16#4F37#, 16#4F3E#, 16#4F54#,
         16#4F58#, 16#02_0213#, 16#4F77#, 16#4F78#,
         16#4F7A#, 16#4F7D#, 16#4F82#, 16#4F85#,
         16#4F92#, 16#4F9A#, 16#4FE6#, 16#4FB2#,
         16#4FBE#, 16#4FC5#, 16#4FCB#, 16#4FCF#,
         16#4FD2#, 16#346A#, 16#4FF2#, 16#5000#,
         16#5010#, 16#5013#, 16#501C#, 16#501E#,
         16#5022#, 16#3468#, 16#5042#, 16#0000#,
         16#5046#, 16#504E#, 16#5053#, 16#5057#,
         16#5063#, 16#5066#, 16#506A#, 16#5070#,
         16#50A3#, 16#5088#, 16#5092#, 16#5093#,
         16#5095#, 16#5096#, 16#509C#, 16#50AA#,
         16#02_032B#, 16#50B1#, 16#50BA#, 16#50BB#,
         16#50C4#, 16#50C7#, 16#50F3#, 16#02_0381#,
         16#50CE#, 16#02_0371#, 16#50D4#, 16#50D9#,
         16#50E1#, 16#50E9#, 16#3492#, 16#5B96#,
         16#5BAC#, 16#3761#, 16#5BC0#, 16#3762#,
         16#5BCE#, 16#5BD6#, 16#376C#, 16#376B#,
         16#5BF1#, 16#5BFD#, 16#3775#, 16#5C03#,
         16#5C29#, 16#5C30#, 16#02_1C56#, 16#5C5F#,
         16#5C63#, 16#5C67#, 16#5C68#, 16#5C69#,
         16#5C70#, 16#02_1D2D#, 16#02_1D45#, 16#5C7C#,
         16#02_1D78#, 16#02_1D62#, 16#5C88#, 16#5C8A#,
         16#37C1#, 16#02_1DA1#, 16#02_1D9C#, 16#5CA0#,
         16#5CA2#, 16#5CA6#, 16#5CA7#, 16#02_1D92#,
         16#5CAD#, 16#5CB5#, 16#02_1DB7#, 16#5CC9#,
         16#02_1DE0#, 16#02_1E33#, 16#5D06#, 16#5D10#,
         16#5D2B#, 16#5D1D#, 16#5D20#, 16#5D24#,
         16#5D26#, 16#5D31#, 16#5D39#, 16#5D42#,
         16#37E8#, 16#5D61#, 16#5D6A#, 16#37F4#,
         16#5D70#, 16#02_1F1E#, 16#37FD#, 16#5D88#,
         16#3800#, 16#5D92#, 16#5D94#, 16#5D97#,
         16#5D99#, 16#5DB0#, 16#5DB2#, 16#5DB4#,
         16#02_1F76#, 16#5DB9#, 16#5DD1#, 16#5DD7#,
         16#5DD8#, 16#5DE0#, 16#02_1FFA#, 16#5DE4#,
         16#5DE9#, 16#382F#, 16#5E00#, 16#3836#,
         16#5E12#, 16#5E15#, 16#3840#, 16#5E1F#,
         16#5E2E#, 16#5E3E#, 16#5E49#, 16#385C#,
         16#5E56#, 16#3861#, 16#5E6B#, 16#5E6C#,
         16#5E6D#, 16#0000#, 16#0000#, 16#0000#);

   Decode_Double_F1 : aliased constant SHIFTJIS_Code_Point_Array
     := (16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#5108#, 16#02_03F9#, 16#5117#, 16#511B#,
         16#02_044A#, 16#5160#, 16#02_0509#, 16#5173#,
         16#5183#, 16#518B#, 16#34BC#, 16#5198#,
         16#51A3#, 16#51AD#, 16#34C7#, 16#51BC#,
         16#02_05D6#, 16#02_0628#, 16#51F3#, 16#51F4#,
         16#5202#, 16#5212#, 16#5216#, 16#02_074F#,
         16#5255#, 16#525C#, 16#526C#, 16#5277#,
         16#5284#, 16#5282#, 16#02_0807#, 16#5298#,
         16#02_083A#, 16#52A4#, 16#52A6#, 16#52AF#,
         16#52BA#, 16#52BB#, 16#52CA#, 16#351F#,
         16#52D1#, 16#02_08B9#, 16#52F7#, 16#530A#,
         16#530B#, 16#5324#, 16#5335#, 16#533E#,
         16#5342#, 16#02_097C#, 16#02_099D#, 16#5367#,
         16#536C#, 16#537A#, 16#53A4#, 16#53B4#,
         16#02_0AD3#, 16#53B7#, 16#53C0#, 16#02_0B1D#,
         16#355D#, 16#355E#, 16#53D5#, 16#0000#,
         16#53DA#, 16#3563#, 16#53F4#, 16#53F5#,
         16#5455#, 16#5424#, 16#5428#, 16#356E#,
         16#5443#, 16#5462#, 16#5466#, 16#546C#,
         16#548A#, 16#548D#, 16#5495#, 16#54A0#,
         16#54A6#, 16#54AD#, 16#54AE#, 16#54B7#,
         16#54BA#, 16#54BF#, 16#54C3#, 16#02_0D45#,
         16#54EC#, 16#54EF#, 16#54F1#, 16#54F3#,
         16#5500#, 16#5501#, 16#5509#, 16#553C#,
         16#5541#, 16#35A6#, 16#5547#, 16#554A#,
         16#35A8#, 16#5560#, 16#5561#, 16#5564#,
         16#02_0DE1#, 16#557D#, 16#5582#, 16#5588#,
         16#5591#, 16#35C5#, 16#55D2#, 16#02_0E95#,
         16#02_0E6D#, 16#55BF#, 16#55C9#, 16#55CC#,
         16#55D1#, 16#55DD#, 16#35DA#, 16#55E2#,
         16#02_0E64#, 16#55E9#, 16#5628#, 16#02_0F5F#,
         16#5607#, 16#5610#, 16#5630#, 16#5637#,
         16#35F4#, 16#563D#, 16#563F#, 16#5640#,
         16#5647#, 16#565E#, 16#5660#, 16#566D#,
         16#3605#, 16#5688#, 16#568C#, 16#5695#,
         16#569A#, 16#569D#, 16#56A8#, 16#56AD#,
         16#56B2#, 16#56C5#, 16#56CD#, 16#56DF#,
         16#56E8#, 16#56F6#, 16#56F7#, 16#02_1201#,
         16#5715#, 16#5723#, 16#02_1255#, 16#5729#,
         16#02_127B#, 16#5745#, 16#5746#, 16#574C#,
         16#574D#, 16#02_1274#, 16#5768#, 16#576F#,
         16#5773#, 16#5774#, 16#5775#, 16#577B#,
         16#02_12E4#, 16#02_12D7#, 16#57AC#, 16#579A#,
         16#579D#, 16#579E#, 16#57A8#, 16#57D7#,
         16#02_12FD#, 16#57CC#, 16#02_1336#, 16#02_1344#,
         16#57DE#, 16#57E6#, 16#57F0#, 16#364A#,
         16#57F8#, 16#57FB#, 16#57FD#, 16#5804#,
         16#581E#, 16#0000#, 16#0000#, 16#0000#);

   Decode_Double_F2 : aliased constant SHIFTJIS_Code_Point_Array
     := (16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#5820#, 16#5827#, 16#5832#, 16#5839#,
         16#02_13C4#, 16#5849#, 16#584C#, 16#5867#,
         16#588A#, 16#588B#, 16#588D#, 16#588F#,
         16#5890#, 16#5894#, 16#589D#, 16#58AA#,
         16#58B1#, 16#02_146D#, 16#58C3#, 16#58CD#,
         16#58E2#, 16#58F3#, 16#58F4#, 16#5905#,
         16#5906#, 16#590B#, 16#590D#, 16#5914#,
         16#5924#, 16#02_15D7#, 16#3691#, 16#593D#,
         16#3699#, 16#5946#, 16#3696#, 16#02_6C29#,
         16#595B#, 16#595F#, 16#02_1647#, 16#5975#,
         16#5976#, 16#597C#, 16#599F#, 16#59AE#,
         16#59BC#, 16#59C8#, 16#59CD#, 16#59DE#,
         16#59E3#, 16#59E4#, 16#59E7#, 16#59EE#,
         16#02_1706#, 16#02_1742#, 16#36CF#, 16#5A0C#,
         16#5A0D#, 16#5A17#, 16#5A27#, 16#5A2D#,
         16#5A55#, 16#5A65#, 16#5A7A#, 16#0000#,
         16#5A8B#, 16#5A9C#, 16#5A9F#, 16#5AA0#,
         16#5AA2#, 16#5AB1#, 16#5AB3#, 16#5AB5#,
         16#5ABA#, 16#5ABF#, 16#5ADA#, 16#5ADC#,
         16#5AE0#, 16#5AE5#, 16#5AF0#, 16#5AEE#,
         16#5AF5#, 16#5B00#, 16#5B08#, 16#5B17#,
         16#5B34#, 16#5B2D#, 16#5B4C#, 16#5B52#,
         16#5B68#, 16#5B6F#, 16#5B7C#, 16#5B7F#,
         16#5B81#, 16#5B84#, 16#02_19C3#, 16#5E6E#,
         16#02_217B#, 16#5EA5#, 16#5EAA#, 16#5EAC#,
         16#5EB9#, 16#5EBF#, 16#5EC6#, 16#5ED2#,
         16#5ED9#, 16#02_231E#, 16#5EFD#, 16#5F08#,
         16#5F0E#, 16#5F1C#, 16#02_23AD#, 16#5F1E#,
         16#5F47#, 16#5F63#, 16#5F72#, 16#5F7E#,
         16#5F8F#, 16#5FA2#, 16#5FA4#, 16#5FB8#,
         16#5FC4#, 16#38FA#, 16#5FC7#, 16#5FCB#,
         16#5FD2#, 16#5FD3#, 16#5FD4#, 16#5FE2#,
         16#5FEE#, 16#5FEF#, 16#5FF3#, 16#5FFC#,
         16#3917#, 16#6017#, 16#6022#, 16#6024#,
         16#391A#, 16#604C#, 16#607F#, 16#608A#,
         16#6095#, 16#60A8#, 16#02_26F3#, 16#60B0#,
         16#60B1#, 16#60BE#, 16#60C8#, 16#60D9#,
         16#60DB#, 16#60EE#, 16#60F2#, 16#60F5#,
         16#6110#, 16#6112#, 16#6113#, 16#6119#,
         16#611E#, 16#613A#, 16#396F#, 16#6141#,
         16#6146#, 16#6160#, 16#617C#, 16#02_285B#,
         16#6192#, 16#6193#, 16#6197#, 16#6198#,
         16#61A5#, 16#61A8#, 16#61AD#, 16#02_28AB#,
         16#61D5#, 16#61DD#, 16#61DF#, 16#61F5#,
         16#02_298F#, 16#6215#, 16#6223#, 16#6229#,
         16#6246#, 16#624C#, 16#6251#, 16#6252#,
         16#6261#, 16#6264#, 16#627B#, 16#626D#,
         16#6273#, 16#0000#, 16#0000#, 16#0000#);

   Decode_Double_F3 : aliased constant SHIFTJIS_Code_Point_Array
     := (16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#6299#, 16#62A6#, 16#62D5#, 16#02_2AB8#,
         16#62FD#, 16#6303#, 16#630D#, 16#6310#,
         16#02_2B4F#, 16#02_2B50#, 16#6332#, 16#6335#,
         16#633B#, 16#633C#, 16#6341#, 16#6344#,
         16#634E#, 16#02_2B46#, 16#6359#, 16#02_2C1D#,
         16#02_2BA6#, 16#636C#, 16#6384#, 16#6399#,
         16#02_2C24#, 16#6394#, 16#63BD#, 16#63F7#,
         16#63D4#, 16#63D5#, 16#63DC#, 16#63E0#,
         16#63EB#, 16#63EC#, 16#63F2#, 16#6409#,
         16#641E#, 16#6425#, 16#6429#, 16#642F#,
         16#645A#, 16#645B#, 16#645D#, 16#6473#,
         16#647D#, 16#6487#, 16#6491#, 16#649D#,
         16#649F#, 16#64CB#, 16#64CC#, 16#64D5#,
         16#64D7#, 16#02_2DE1#, 16#64E4#, 16#64E5#,
         16#64FF#, 16#6504#, 16#3A6E#, 16#650F#,
         16#6514#, 16#6516#, 16#3A73#, 16#0000#,
         16#651E#, 16#6532#, 16#6544#, 16#6554#,
         16#656B#, 16#657A#, 16#6581#, 16#6584#,
         16#6585#, 16#658A#, 16#65B2#, 16#65B5#,
         16#65B8#, 16#65BF#, 16#65C2#, 16#65C9#,
         16#65D4#, 16#3AD6#, 16#65F2#, 16#65F9#,
         16#65FC#, 16#6604#, 16#6608#, 16#6621#,
         16#662A#, 16#6645#, 16#6651#, 16#664E#,
         16#3AEA#, 16#02_31C3#, 16#6657#, 16#665B#,
         16#6663#, 16#02_31F5#, 16#02_31B6#, 16#666A#,
         16#666B#, 16#666C#, 16#666D#, 16#667B#,
         16#6680#, 16#6690#, 16#6692#, 16#6699#,
         16#3B0E#, 16#66AD#, 16#66B1#, 16#66B5#,
         16#3B1A#, 16#66BF#, 16#3B1C#, 16#66EC#,
         16#3AD7#, 16#6701#, 16#6705#, 16#6712#,
         16#02_3372#, 16#6719#, 16#02_33D3#, 16#02_33D2#,
         16#674C#, 16#674D#, 16#6754#, 16#675D#,
         16#02_33D0#, 16#02_33E4#, 16#02_33D5#, 16#6774#,
         16#6776#, 16#02_33DA#, 16#6792#, 16#02_33DF#,
         16#8363#, 16#6810#, 16#67B0#, 16#67B2#,
         16#67C3#, 16#67C8#, 16#67D2#, 16#67D9#,
         16#67DB#, 16#67F0#, 16#67F7#, 16#02_344A#,
         16#02_3451#, 16#02_344B#, 16#6818#, 16#681F#,
         16#682D#, 16#02_3465#, 16#6833#, 16#683B#,
         16#683E#, 16#6844#, 16#6845#, 16#6849#,
         16#684C#, 16#6855#, 16#6857#, 16#3B77#,
         16#686B#, 16#686E#, 16#687A#, 16#687C#,
         16#6882#, 16#6890#, 16#6896#, 16#3B6D#,
         16#6898#, 16#6899#, 16#689A#, 16#689C#,
         16#68AA#, 16#68AB#, 16#68B4#, 16#68BB#,
         16#68FB#, 16#02_34E4#, 16#02_355A#, 16#FA13#,
         16#68C3#, 16#68C5#, 16#68CC#, 16#68CF#,
         16#68D6#, 16#0000#, 16#0000#, 16#0000#);

   Decode_Double_F4 : aliased constant SHIFTJIS_Code_Point_Array
     := (16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#68D9#, 16#68E4#, 16#68E5#, 16#68EC#,
         16#68F7#, 16#6903#, 16#6907#, 16#3B87#,
         16#3B88#, 16#02_3594#, 16#693B#, 16#3B8D#,
         16#6946#, 16#6969#, 16#696C#, 16#6972#,
         16#697A#, 16#697F#, 16#6992#, 16#3BA4#,
         16#6996#, 16#6998#, 16#69A6#, 16#69B0#,
         16#69B7#, 16#69BA#, 16#69BC#, 16#69C0#,
         16#69D1#, 16#69D6#, 16#02_3639#, 16#02_3647#,
         16#6A30#, 16#02_3638#, 16#02_363A#, 16#69E3#,
         16#69EE#, 16#69EF#, 16#69F3#, 16#3BCD#,
         16#69F4#, 16#69FE#, 16#6A11#, 16#6A1A#,
         16#6A1D#, 16#02_371C#, 16#6A32#, 16#6A33#,
         16#6A34#, 16#6A3F#, 16#6A46#, 16#6A49#,
         16#6A7A#, 16#6A4E#, 16#6A52#, 16#6A64#,
         16#02_370C#, 16#6A7E#, 16#6A83#, 16#6A8B#,
         16#3BF0#, 16#6A91#, 16#6A9F#, 16#0000#,
         16#6AA1#, 16#02_3764#, 16#6AAB#, 16#6ABD#,
         16#6AC6#, 16#6AD4#, 16#6AD0#, 16#6ADC#,
         16#6ADD#, 16#02_37FF#, 16#02_37E7#, 16#6AEC#,
         16#6AF1#, 16#6AF2#, 16#6AF3#, 16#6AFD#,
         16#02_3824#, 16#6B0B#, 16#6B0F#, 16#6B10#,
         16#6B11#, 16#02_383D#, 16#6B17#, 16#3C26#,
         16#6B2F#, 16#6B4A#, 16#6B58#, 16#6B6C#,
         16#6B75#, 16#6B7A#, 16#6B81#, 16#6B9B#,
         16#6BAE#, 16#02_3A98#, 16#6BBD#, 16#6BBE#,
         16#6BC7#, 16#6BC8#, 16#6BC9#, 16#6BDA#,
         16#6BE6#, 16#6BE7#, 16#6BEE#, 16#6BF1#,
         16#6C02#, 16#6C0A#, 16#6C0E#, 16#6C35#,
         16#6C36#, 16#6C3A#, 16#02_3C7F#, 16#6C3F#,
         16#6C4D#, 16#6C5B#, 16#6C6D#, 16#6C84#,
         16#6C89#, 16#3CC3#, 16#6C94#, 16#6C95#,
         16#6C97#, 16#6CAD#, 16#6CC2#, 16#6CD0#,
         16#3CD2#, 16#6CD6#, 16#6CDA#, 16#6CDC#,
         16#6CE9#, 16#6CEC#, 16#6CED#, 16#02_3D00#,
         16#6D00#, 16#6D0A#, 16#6D24#, 16#6D26#,
         16#6D27#, 16#6C67#, 16#6D2F#, 16#6D3C#,
         16#6D5B#, 16#6D5E#, 16#6D60#, 16#6D70#,
         16#6D80#, 16#6D81#, 16#6D8A#, 16#6D8D#,
         16#6D91#, 16#6D98#, 16#02_3D40#, 16#6E17#,
         16#02_3DFA#, 16#02_3DF9#, 16#02_3DD3#, 16#6DAB#,
         16#6DAE#, 16#6DB4#, 16#6DC2#, 16#6D34#,
         16#6DC8#, 16#6DCE#, 16#6DCF#, 16#6DD0#,
         16#6DDF#, 16#6DE9#, 16#6DF6#, 16#6E36#,
         16#6E1E#, 16#6E22#, 16#6E27#, 16#3D11#,
         16#6E32#, 16#6E3C#, 16#6E48#, 16#6E49#,
         16#6E4B#, 16#6E4C#, 16#6E4F#, 16#6E51#,
         16#6E53#, 16#6E54#, 16#6E57#, 16#6E63#,
         16#3D1E#, 16#0000#, 16#0000#, 16#0000#);

   Decode_Double_F5 : aliased constant SHIFTJIS_Code_Point_Array
     := (16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#6E93#, 16#6EA7#, 16#6EB4#, 16#6EBF#,
         16#6EC3#, 16#6ECA#, 16#6ED9#, 16#6F35#,
         16#6EEB#, 16#6EF9#, 16#6EFB#, 16#6F0A#,
         16#6F0C#, 16#6F18#, 16#6F25#, 16#6F36#,
         16#6F3C#, 16#02_3F7E#, 16#6F52#, 16#6F57#,
         16#6F5A#, 16#6F60#, 16#6F68#, 16#6F98#,
         16#6F7D#, 16#6F90#, 16#6F96#, 16#6FBE#,
         16#6F9F#, 16#6FA5#, 16#6FAF#, 16#3D64#,
         16#6FB5#, 16#6FC8#, 16#6FC9#, 16#6FDA#,
         16#6FDE#, 16#6FE9#, 16#02_4096#, 16#6FFC#,
         16#7000#, 16#7007#, 16#700A#, 16#7023#,
         16#02_4103#, 16#7039#, 16#703A#, 16#703C#,
         16#7043#, 16#7047#, 16#704B#, 16#3D9A#,
         16#7054#, 16#7065#, 16#7069#, 16#706C#,
         16#706E#, 16#7076#, 16#707E#, 16#7081#,
         16#7086#, 16#7095#, 16#7097#, 16#0000#,
         16#70BB#, 16#02_41C6#, 16#709F#, 16#70B1#,
         16#02_41FE#, 16#70EC#, 16#70CA#, 16#70D1#,
         16#70D3#, 16#70DC#, 16#7103#, 16#7104#,
         16#7106#, 16#7107#, 16#7108#, 16#710C#,
         16#3DC0#, 16#712F#, 16#7131#, 16#7150#,
         16#714A#, 16#7153#, 16#715E#, 16#3DD4#,
         16#7196#, 16#7180#, 16#719B#, 16#71A0#,
         16#71A2#, 16#71AE#, 16#71AF#, 16#71B3#,
         16#02_43BC#, 16#71CB#, 16#71D3#, 16#71D9#,
         16#71DC#, 16#7207#, 16#3E05#, 16#FA49#,
         16#722B#, 16#7234#, 16#7238#, 16#7239#,
         16#4E2C#, 16#7242#, 16#7253#, 16#7257#,
         16#7263#, 16#02_4629#, 16#726E#, 16#726F#,
         16#7278#, 16#727F#, 16#728E#, 16#02_46A5#,
         16#72AD#, 16#72AE#, 16#72B0#, 16#72B1#,
         16#72C1#, 16#3E60#, 16#72CC#, 16#3E66#,
         16#3E68#, 16#72F3#, 16#72FA#, 16#7307#,
         16#7312#, 16#7318#, 16#7319#, 16#3E83#,
         16#7339#, 16#732C#, 16#7331#, 16#7333#,
         16#733D#, 16#7352#, 16#3E94#, 16#736B#,
         16#736C#, 16#02_4896#, 16#736E#, 16#736F#,
         16#7371#, 16#7377#, 16#7381#, 16#7385#,
         16#738A#, 16#7394#, 16#7398#, 16#739C#,
         16#739E#, 16#73A5#, 16#73A8#, 16#73B5#,
         16#73B7#, 16#73B9#, 16#73BC#, 16#73BF#,
         16#73C5#, 16#73CB#, 16#73E1#, 16#73E7#,
         16#73F9#, 16#7413#, 16#73FA#, 16#7401#,
         16#7424#, 16#7431#, 16#7439#, 16#7453#,
         16#7440#, 16#7443#, 16#744D#, 16#7452#,
         16#745D#, 16#7471#, 16#7481#, 16#7485#,
         16#7488#, 16#02_4A4D#, 16#7492#, 16#7497#,
         16#7499#, 16#0000#, 16#0000#, 16#0000#);

   Decode_Double_F6 : aliased constant SHIFTJIS_Code_Point_Array
     := (16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#74A0#, 16#74A1#, 16#74A5#, 16#74AA#,
         16#74AB#, 16#74B9#, 16#74BB#, 16#74BA#,
         16#74D6#, 16#74D8#, 16#74DE#, 16#74EF#,
         16#74EB#, 16#02_4B56#, 16#74FA#, 16#02_4B6F#,
         16#7520#, 16#7524#, 16#752A#, 16#3F57#,
         16#02_4C16#, 16#753D#, 16#753E#, 16#7540#,
         16#7548#, 16#754E#, 16#7550#, 16#7552#,
         16#756C#, 16#7572#, 16#7571#, 16#757A#,
         16#757D#, 16#757E#, 16#7581#, 16#02_4D14#,
         16#758C#, 16#3F75#, 16#75A2#, 16#3F77#,
         16#75B0#, 16#75B7#, 16#75BF#, 16#75C0#,
         16#75C6#, 16#75CF#, 16#75D3#, 16#75DD#,
         16#75DF#, 16#75E0#, 16#75E7#, 16#75EC#,
         16#75EE#, 16#75F1#, 16#75F9#, 16#7603#,
         16#7618#, 16#7607#, 16#760F#, 16#3FAE#,
         16#02_4E0E#, 16#7613#, 16#761B#, 16#0000#,
         16#761C#, 16#02_4E37#, 16#7625#, 16#7628#,
         16#763C#, 16#7633#, 16#02_4E6A#, 16#3FC9#,
         16#7641#, 16#02_4E8B#, 16#7649#, 16#7655#,
         16#3FD7#, 16#766E#, 16#7695#, 16#769C#,
         16#76A1#, 16#76A0#, 16#76A7#, 16#76A8#,
         16#76AF#, 16#02_504A#, 16#76C9#, 16#02_5055#,
         16#76E8#, 16#76EC#, 16#02_5122#, 16#7717#,
         16#771A#, 16#772D#, 16#7735#, 16#02_51A9#,
         16#4039#, 16#02_51E5#, 16#02_51CD#, 16#7758#,
         16#7760#, 16#776A#, 16#02_521E#, 16#7772#,
         16#777C#, 16#777D#, 16#02_524C#, 16#4058#,
         16#779A#, 16#779F#, 16#77A2#, 16#77A4#,
         16#77A9#, 16#77DE#, 16#77DF#, 16#77E4#,
         16#77E6#, 16#77EA#, 16#77EC#, 16#4093#,
         16#77F0#, 16#77F4#, 16#77FB#, 16#02_542E#,
         16#7805#, 16#7806#, 16#7809#, 16#780D#,
         16#7819#, 16#7821#, 16#782C#, 16#7847#,
         16#7864#, 16#786A#, 16#02_54D9#, 16#788A#,
         16#7894#, 16#78A4#, 16#789D#, 16#789E#,
         16#789F#, 16#78BB#, 16#78C8#, 16#78CC#,
         16#78CE#, 16#78D5#, 16#78E0#, 16#78E1#,
         16#78E6#, 16#78F9#, 16#78FA#, 16#78FB#,
         16#78FE#, 16#02_55A7#, 16#7910#, 16#791B#,
         16#7930#, 16#7925#, 16#793B#, 16#794A#,
         16#7958#, 16#795B#, 16#4105#, 16#7967#,
         16#7972#, 16#7994#, 16#7995#, 16#7996#,
         16#799B#, 16#79A1#, 16#79A9#, 16#79B4#,
         16#79BB#, 16#79C2#, 16#79C7#, 16#79CC#,
         16#79CD#, 16#79D6#, 16#4148#, 16#02_57A9#,
         16#02_57B4#, 16#414F#, 16#7A0A#, 16#7A11#,
         16#7A15#, 16#7A1B#, 16#7A1E#, 16#4163#,
         16#7A2D#, 16#0000#, 16#0000#, 16#0000#);

   Decode_Double_F7 : aliased constant SHIFTJIS_Code_Point_Array
     := (16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#7A38#, 16#7A47#, 16#7A4C#, 16#7A56#,
         16#7A59#, 16#7A5C#, 16#7A5F#, 16#7A60#,
         16#7A67#, 16#7A6A#, 16#7A75#, 16#7A78#,
         16#7A82#, 16#7A8A#, 16#7A90#, 16#7AA3#,
         16#7AAC#, 16#02_59D4#, 16#41B4#, 16#7AB9#,
         16#7ABC#, 16#7ABE#, 16#41BF#, 16#7ACC#,
         16#7AD1#, 16#7AE7#, 16#7AE8#, 16#7AF4#,
         16#02_5AE4#, 16#02_5AE3#, 16#7B07#, 16#02_5AF1#,
         16#7B3D#, 16#7B27#, 16#7B2A#, 16#7B2E#,
         16#7B2F#, 16#7B31#, 16#41E6#, 16#41F3#,
         16#7B7F#, 16#7B41#, 16#41EE#, 16#7B55#,
         16#7B79#, 16#7B64#, 16#7B66#, 16#7B69#,
         16#7B73#, 16#02_5BB2#, 16#4207#, 16#7B90#,
         16#7B91#, 16#7B9B#, 16#420E#, 16#7BAF#,
         16#7BB5#, 16#7BBC#, 16#7BC5#, 16#7BCA#,
         16#02_5C4B#, 16#02_5C64#, 16#7BD4#, 16#0000#,
         16#7BD6#, 16#7BDA#, 16#7BEA#, 16#7BF0#,
         16#7C03#, 16#7C0B#, 16#7C0E#, 16#7C0F#,
         16#7C26#, 16#7C45#, 16#7C4A#, 16#7C51#,
         16#7C57#, 16#7C5E#, 16#7C61#, 16#7C69#,
         16#7C6E#, 16#7C6F#, 16#7C70#, 16#02_5E2E#,
         16#02_5E56#, 16#02_5E65#, 16#7CA6#, 16#02_5E62#,
         16#7CB6#, 16#7CB7#, 16#7CBF#, 16#02_5ED8#,
         16#7CC4#, 16#02_5EC2#, 16#7CC8#, 16#7CCD#,
         16#02_5EE8#, 16#7CD7#, 16#02_5F23#, 16#7CE6#,
         16#7CEB#, 16#02_5F5C#, 16#7CF5#, 16#7D03#,
         16#7D09#, 16#42C6#, 16#7D12#, 16#7D1E#,
         16#02_5FE0#, 16#02_5FD4#, 16#7D3D#, 16#7D3E#,
         16#7D40#, 16#7D47#, 16#02_600C#, 16#02_5FFB#,
         16#42D6#, 16#7D59#, 16#7D5A#, 16#7D6A#,
         16#7D70#, 16#42DD#, 16#7D7F#, 16#02_6017#,
         16#7D86#, 16#7D88#, 16#7D8C#, 16#7D97#,
         16#02_6060#, 16#7D9D#, 16#7DA7#, 16#7DAA#,
         16#7DB6#, 16#7DB7#, 16#7DC0#, 16#7DD7#,
         16#7DD9#, 16#7DE6#, 16#7DF1#, 16#7DF9#,
         16#4302#, 16#02_60ED#, 16#FA58#, 16#7E10#,
         16#7E17#, 16#7E1D#, 16#7E20#, 16#7E27#,
         16#7E2C#, 16#7E45#, 16#7E73#, 16#7E75#,
         16#7E7E#, 16#7E86#, 16#7E87#, 16#432B#,
         16#7E91#, 16#7E98#, 16#7E9A#, 16#4343#,
         16#7F3C#, 16#7F3B#, 16#7F3E#, 16#7F43#,
         16#7F44#, 16#7F4F#, 16#34C1#, 16#02_6270#,
         16#7F52#, 16#02_6286#, 16#7F61#, 16#7F63#,
         16#7F64#, 16#7F6D#, 16#7F7D#, 16#7F7E#,
         16#02_634C#, 16#7F90#, 16#517B#, 16#02_3D0E#,
         16#7F96#, 16#7F9C#, 16#7FAD#, 16#02_6402#,
         16#7FC3#, 16#7FCF#, 16#7FE3#, 16#7FE5#,
         16#7FEF#, 16#0000#, 16#0000#, 16#0000#);

   Decode_Double_F8 : aliased constant SHIFTJIS_Code_Point_Array
     := (16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#7FF2#, 16#8002#, 16#800A#, 16#8008#,
         16#800E#, 16#8011#, 16#8016#, 16#8024#,
         16#802C#, 16#8030#, 16#8043#, 16#8066#,
         16#8071#, 16#8075#, 16#807B#, 16#8099#,
         16#809C#, 16#80A4#, 16#80A7#, 16#80B8#,
         16#02_667E#, 16#80C5#, 16#80D5#, 16#80D8#,
         16#80E6#, 16#02_66B0#, 16#810D#, 16#80F5#,
         16#80FB#, 16#43EE#, 16#8135#, 16#8116#,
         16#811E#, 16#43F0#, 16#8124#, 16#8127#,
         16#812C#, 16#02_671D#, 16#813D#, 16#4408#,
         16#8169#, 16#4417#, 16#8181#, 16#441C#,
         16#8184#, 16#8185#, 16#4422#, 16#8198#,
         16#81B2#, 16#81C1#, 16#81C3#, 16#81D6#,
         16#81DB#, 16#02_68DD#, 16#81E4#, 16#02_68EA#,
         16#81EC#, 16#02_6951#, 16#81FD#, 16#81FF#,
         16#02_696F#, 16#8204#, 16#02_69DD#, 16#0000#,
         16#8219#, 16#8221#, 16#8222#, 16#02_6A1E#,
         16#8232#, 16#8234#, 16#823C#, 16#8246#,
         16#8249#, 16#8245#, 16#02_6A58#, 16#824B#,
         16#4476#, 16#824F#, 16#447A#, 16#8257#,
         16#02_6A8C#, 16#825C#, 16#8263#, 16#02_6AB7#,
         16#FA5D#, 16#FA5E#, 16#8279#, 16#4491#,
         16#827D#, 16#827F#, 16#8283#, 16#828A#,
         16#8293#, 16#82A7#, 16#82A8#, 16#82B2#,
         16#82B4#, 16#82BA#, 16#82BC#, 16#82E2#,
         16#82E8#, 16#82F7#, 16#8307#, 16#8308#,
         16#830C#, 16#8354#, 16#831B#, 16#831D#,
         16#8330#, 16#833C#, 16#8344#, 16#8357#,
         16#44BE#, 16#837F#, 16#44D4#, 16#44B3#,
         16#838D#, 16#8394#, 16#8395#, 16#839B#,
         16#839D#, 16#83C9#, 16#83D0#, 16#83D4#,
         16#83DD#, 16#83E5#, 16#83F9#, 16#840F#,
         16#8411#, 16#8415#, 16#02_6C73#, 16#8417#,
         16#8439#, 16#844A#, 16#844F#, 16#8451#,
         16#8452#, 16#8459#, 16#845A#, 16#845C#,
         16#02_6CDD#, 16#8465#, 16#8476#, 16#8478#,
         16#847C#, 16#8481#, 16#450D#, 16#84DC#,
         16#8497#, 16#84A6#, 16#84BE#, 16#4508#,
         16#84CE#, 16#84CF#, 16#84D3#, 16#02_6E65#,
         16#84E7#, 16#84EA#, 16#84EF#, 16#84F0#,
         16#84F1#, 16#84FA#, 16#84FD#, 16#850C#,
         16#851B#, 16#8524#, 16#8525#, 16#852B#,
         16#8534#, 16#854F#, 16#856F#, 16#4525#,
         16#4543#, 16#853E#, 16#8551#, 16#8553#,
         16#855E#, 16#8561#, 16#8562#, 16#02_6F94#,
         16#857B#, 16#857D#, 16#857F#, 16#8581#,
         16#8586#, 16#8593#, 16#859D#, 16#859F#,
         16#02_6FF8#, 16#0000#, 16#0000#, 16#0000#);

   Decode_Double_F9 : aliased constant SHIFTJIS_Code_Point_Array
     := (16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#02_6FF6#, 16#02_6FF7#, 16#85B7#, 16#85BC#,
         16#85C7#, 16#85CA#, 16#85D8#, 16#85D9#,
         16#85DF#, 16#85E1#, 16#85E6#, 16#85F6#,
         16#8600#, 16#8611#, 16#861E#, 16#8621#,
         16#8624#, 16#8627#, 16#02_710D#, 16#8639#,
         16#863C#, 16#02_7139#, 16#8640#, 16#FA20#,
         16#8653#, 16#8656#, 16#866F#, 16#8677#,
         16#867A#, 16#8687#, 16#8689#, 16#868D#,
         16#8691#, 16#869C#, 16#869D#, 16#86A8#,
         16#FA21#, 16#86B1#, 16#86B3#, 16#86C1#,
         16#86C3#, 16#86D1#, 16#86D5#, 16#86D7#,
         16#86E3#, 16#86E6#, 16#45B8#, 16#8705#,
         16#8707#, 16#870E#, 16#8710#, 16#8713#,
         16#8719#, 16#871F#, 16#8721#, 16#8723#,
         16#8731#, 16#873A#, 16#873E#, 16#8740#,
         16#8743#, 16#8751#, 16#8758#, 16#0000#,
         16#8764#, 16#8765#, 16#8772#, 16#877C#,
         16#02_73DB#, 16#02_73DA#, 16#87A7#, 16#8789#,
         16#878B#, 16#8793#, 16#87A0#, 16#02_73FE#,
         16#45E5#, 16#87BE#, 16#02_7410#, 16#87C1#,
         16#87CE#, 16#87F5#, 16#87DF#, 16#02_7449#,
         16#87E3#, 16#87E5#, 16#87E6#, 16#87EA#,
         16#87EB#, 16#87ED#, 16#8801#, 16#8803#,
         16#880B#, 16#8813#, 16#8828#, 16#882E#,
         16#8832#, 16#883C#, 16#460F#, 16#884A#,
         16#8858#, 16#885F#, 16#8864#, 16#02_7615#,
         16#02_7614#, 16#8869#, 16#02_7631#, 16#886F#,
         16#88A0#, 16#88BC#, 16#88BD#, 16#88BE#,
         16#88C0#, 16#88D2#, 16#02_7693#, 16#88D1#,
         16#88D3#, 16#88DB#, 16#88F0#, 16#88F1#,
         16#4641#, 16#8901#, 16#02_770E#, 16#8937#,
         16#02_7723#, 16#8942#, 16#8945#, 16#8949#,
         16#02_7752#, 16#4665#, 16#8962#, 16#8980#,
         16#8989#, 16#8990#, 16#899F#, 16#89B0#,
         16#89B7#, 16#89D6#, 16#89D8#, 16#89EB#,
         16#46A1#, 16#89F1#, 16#89F3#, 16#89FD#,
         16#89FF#, 16#46AF#, 16#8A11#, 16#8A14#,
         16#02_7985#, 16#8A21#, 16#8A35#, 16#8A3E#,
         16#8A45#, 16#8A4D#, 16#8A58#, 16#8AAE#,
         16#8A90#, 16#8AB7#, 16#8ABE#, 16#8AD7#,
         16#8AFC#, 16#02_7A84#, 16#8B0A#, 16#8B05#,
         16#8B0D#, 16#8B1C#, 16#8B1F#, 16#8B2D#,
         16#8B43#, 16#470C#, 16#8B51#, 16#8B5E#,
         16#8B76#, 16#8B7F#, 16#8B81#, 16#8B8B#,
         16#8B94#, 16#8B95#, 16#8B9C#, 16#8B9E#,
         16#8C39#, 16#02_7BB3#, 16#8C3D#, 16#02_7BBE#,
         16#02_7BC7#, 16#8C45#, 16#8C47#, 16#8C4F#,
         16#8C54#, 16#0000#, 16#0000#, 16#0000#);

   Decode_Double_FA : aliased constant SHIFTJIS_Code_Point_Array
     := (16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#8C57#, 16#8C69#, 16#8C6D#, 16#8C73#,
         16#02_7CB8#, 16#8C93#, 16#8C92#, 16#8C99#,
         16#4764#, 16#8C9B#, 16#8CA4#, 16#8CD6#,
         16#8CD5#, 16#8CD9#, 16#02_7DA0#, 16#8CF0#,
         16#8CF1#, 16#02_7E10#, 16#8D09#, 16#8D0E#,
         16#8D6C#, 16#8D84#, 16#8D95#, 16#8DA6#,
         16#02_7FB7#, 16#8DC6#, 16#8DC8#, 16#8DD9#,
         16#8DEC#, 16#8E0C#, 16#47FD#, 16#8DFD#,
         16#8E06#, 16#02_808A#, 16#8E14#, 16#8E16#,
         16#8E21#, 16#8E22#, 16#8E27#, 16#02_80BB#,
         16#4816#, 16#8E36#, 16#8E39#, 16#8E4B#,
         16#8E54#, 16#8E62#, 16#8E6C#, 16#8E6D#,
         16#8E6F#, 16#8E98#, 16#8E9E#, 16#8EAE#,
         16#8EB3#, 16#8EB5#, 16#8EB6#, 16#8EBB#,
         16#02_8282#, 16#8ED1#, 16#8ED4#, 16#484E#,
         16#8EF9#, 16#02_82F3#, 16#8F00#, 16#0000#,
         16#8F08#, 16#8F17#, 16#8F2B#, 16#8F40#,
         16#8F4A#, 16#8F58#, 16#02_840C#, 16#8FA4#,
         16#8FB4#, 16#FA66#, 16#8FB6#, 16#02_8455#,
         16#8FC1#, 16#8FC6#, 16#FA24#, 16#8FCA#,
         16#8FCD#, 16#8FD3#, 16#8FD5#, 16#8FE0#,
         16#8FF1#, 16#8FF5#, 16#8FFB#, 16#9002#,
         16#900C#, 16#9037#, 16#02_856B#, 16#9043#,
         16#9044#, 16#905D#, 16#02_85C8#, 16#02_85C9#,
         16#9085#, 16#908C#, 16#9090#, 16#961D#,
         16#90A1#, 16#48B5#, 16#90B0#, 16#90B6#,
         16#90C3#, 16#90C8#, 16#02_86D7#, 16#90DC#,
         16#90DF#, 16#02_86FA#, 16#90F6#, 16#90F2#,
         16#9100#, 16#90EB#, 16#90FE#, 16#90FF#,
         16#9104#, 16#9106#, 16#9118#, 16#911C#,
         16#911E#, 16#9137#, 16#9139#, 16#913A#,
         16#9146#, 16#9147#, 16#9157#, 16#9159#,
         16#9161#, 16#9164#, 16#9174#, 16#9179#,
         16#9185#, 16#918E#, 16#91A8#, 16#91AE#,
         16#91B3#, 16#91B6#, 16#91C3#, 16#91C4#,
         16#91DA#, 16#02_8949#, 16#02_8946#, 16#91EC#,
         16#91EE#, 16#9201#, 16#920A#, 16#9216#,
         16#9217#, 16#02_896B#, 16#9233#, 16#9242#,
         16#9247#, 16#924A#, 16#924E#, 16#9251#,
         16#9256#, 16#9259#, 16#9260#, 16#9261#,
         16#9265#, 16#9267#, 16#9268#, 16#02_8987#,
         16#02_8988#, 16#927C#, 16#927D#, 16#927F#,
         16#9289#, 16#928D#, 16#9297#, 16#9299#,
         16#929F#, 16#92A7#, 16#92AB#, 16#02_89BA#,
         16#02_89BB#, 16#92B2#, 16#92BF#, 16#92C0#,
         16#92C6#, 16#92CE#, 16#92D0#, 16#92D7#,
         16#92D9#, 16#92E5#, 16#92E7#, 16#9311#,
         16#02_8A1E#, 16#0000#, 16#0000#, 16#0000#);

   Decode_Double_FB : aliased constant SHIFTJIS_Code_Point_Array
     := (16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#02_8A29#, 16#92F7#, 16#92F9#, 16#92FB#,
         16#9302#, 16#930D#, 16#9315#, 16#931D#,
         16#931E#, 16#9327#, 16#9329#, 16#02_8A71#,
         16#02_8A43#, 16#9347#, 16#9351#, 16#9357#,
         16#935A#, 16#936B#, 16#9371#, 16#9373#,
         16#93A1#, 16#02_8A99#, 16#02_8ACD#, 16#9388#,
         16#938B#, 16#938F#, 16#939E#, 16#93F5#,
         16#02_8AE4#, 16#02_8ADD#, 16#93F1#, 16#93C1#,
         16#93C7#, 16#93DC#, 16#93E2#, 16#93E7#,
         16#9409#, 16#940F#, 16#9416#, 16#9417#,
         16#93FB#, 16#9432#, 16#9434#, 16#943B#,
         16#9445#, 16#02_8BC1#, 16#02_8BEF#, 16#946D#,
         16#946F#, 16#9578#, 16#9579#, 16#9586#,
         16#958C#, 16#958D#, 16#02_8D10#, 16#95AB#,
         16#95B4#, 16#02_8D71#, 16#95C8#, 16#02_8DFB#,
         16#02_8E1F#, 16#962C#, 16#9633#, 16#0000#,
         16#9634#, 16#02_8E36#, 16#963C#, 16#9641#,
         16#9661#, 16#02_8E89#, 16#9682#, 16#02_8EEB#,
         16#969A#, 16#02_8F32#, 16#49E7#, 16#96A9#,
         16#96AF#, 16#96B3#, 16#96BA#, 16#96BD#,
         16#49FA#, 16#02_8FF8#, 16#96D8#, 16#96DA#,
         16#96DD#, 16#4A04#, 16#9714#, 16#9723#,
         16#4A29#, 16#9736#, 16#9741#, 16#9747#,
         16#9755#, 16#9757#, 16#975B#, 16#976A#,
         16#02_92A0#, 16#02_92B1#, 16#9796#, 16#979A#,
         16#979E#, 16#97A2#, 16#97B1#, 16#97B2#,
         16#97BE#, 16#97CC#, 16#97D1#, 16#97D4#,
         16#97D8#, 16#97D9#, 16#97E1#, 16#97F1#,
         16#9804#, 16#980D#, 16#980E#, 16#9814#,
         16#9816#, 16#4ABC#, 16#02_9490#, 16#9823#,
         16#9832#, 16#9833#, 16#9825#, 16#9847#,
         16#9866#, 16#98AB#, 16#98AD#, 16#98B0#,
         16#02_95CF#, 16#98B7#, 16#98B8#, 16#98BB#,
         16#98BC#, 16#98BF#, 16#98C2#, 16#98C7#,
         16#98CB#, 16#98E0#, 16#02_967F#, 16#98E1#,
         16#98E3#, 16#98E5#, 16#98EA#, 16#98F0#,
         16#98F1#, 16#98F3#, 16#9908#, 16#4B3B#,
         16#02_96F0#, 16#9916#, 16#9917#, 16#02_9719#,
         16#991A#, 16#991B#, 16#991C#, 16#02_9750#,
         16#9931#, 16#9932#, 16#9933#, 16#993A#,
         16#993B#, 16#993C#, 16#9940#, 16#9941#,
         16#9946#, 16#994D#, 16#994E#, 16#995C#,
         16#995F#, 16#9960#, 16#99A3#, 16#99A6#,
         16#99B9#, 16#99BD#, 16#99BF#, 16#99C3#,
         16#99C9#, 16#99D4#, 16#99D9#, 16#99DE#,
         16#02_98C6#, 16#99F0#, 16#99F9#, 16#99FC#,
         16#9A0A#, 16#9A11#, 16#9A16#, 16#9A1A#,
         16#9A20#, 16#0000#, 16#0000#, 16#0000#);

   Decode_Double_FC : aliased constant SHIFTJIS_Code_Point_Array
     := (16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#9A31#, 16#9A36#, 16#9A44#, 16#9A4C#,
         16#9A58#, 16#4BC2#, 16#9AAF#, 16#4BCA#,
         16#9AB7#, 16#4BD2#, 16#9AB9#, 16#02_9A72#,
         16#9AC6#, 16#9AD0#, 16#9AD2#, 16#9AD5#,
         16#4BE8#, 16#9ADC#, 16#9AE0#, 16#9AE5#,
         16#9AE9#, 16#9B03#, 16#9B0C#, 16#9B10#,
         16#9B12#, 16#9B16#, 16#9B1C#, 16#9B2B#,
         16#9B33#, 16#9B3D#, 16#4C20#, 16#9B4B#,
         16#9B63#, 16#9B65#, 16#9B6B#, 16#9B6C#,
         16#9B73#, 16#9B76#, 16#9B77#, 16#9BA6#,
         16#9BAC#, 16#9BB1#, 16#02_9DDB#, 16#02_9E3D#,
         16#9BB2#, 16#9BB8#, 16#9BBE#, 16#9BC7#,
         16#9BF3#, 16#9BD8#, 16#9BDD#, 16#9BE7#,
         16#9BEA#, 16#9BEB#, 16#9BEF#, 16#9BEE#,
         16#02_9E15#, 16#9BFA#, 16#02_9E8A#, 16#9BF7#,
         16#02_9E49#, 16#9C16#, 16#9C18#, 16#0000#,
         16#9C19#, 16#9C1A#, 16#9C1D#, 16#9C22#,
         16#9C27#, 16#9C29#, 16#9C2A#, 16#02_9EC4#,
         16#9C31#, 16#9C36#, 16#9C37#, 16#9C45#,
         16#9C5C#, 16#02_9EE9#, 16#9C49#, 16#9C4A#,
         16#02_9EDB#, 16#9C54#, 16#9C58#, 16#9C5B#,
         16#9C5D#, 16#9C5F#, 16#9C69#, 16#9C6A#,
         16#9C6B#, 16#9C6D#, 16#9C6E#, 16#9C70#,
         16#9C72#, 16#9C75#, 16#9C7A#, 16#9CE6#,
         16#9CF2#, 16#9D0B#, 16#9D02#, 16#02_9FCE#,
         16#9D11#, 16#9D17#, 16#9D18#, 16#02_A02F#,
         16#4CC4#, 16#02_A01A#, 16#9D32#, 16#4CD1#,
         16#9D42#, 16#9D4A#, 16#9D5F#, 16#9D62#,
         16#02_A0F9#, 16#9D69#, 16#9D6B#, 16#02_A082#,
         16#9D73#, 16#9D76#, 16#9D77#, 16#9D7E#,
         16#9D84#, 16#9D8D#, 16#9D99#, 16#9DA1#,
         16#9DBF#, 16#9DB5#, 16#9DB9#, 16#9DBD#,
         16#9DC3#, 16#9DC7#, 16#9DC9#, 16#9DD6#,
         16#9DDA#, 16#9DDF#, 16#9DE0#, 16#9DE3#,
         16#9DF4#, 16#4D07#, 16#9E0A#, 16#9E02#,
         16#9E0D#, 16#9E19#, 16#9E1C#, 16#9E1D#,
         16#9E7B#, 16#02_2218#, 16#9E80#, 16#9E85#,
         16#9E9B#, 16#9EA8#, 16#02_A38C#, 16#9EBD#,
         16#02_A437#, 16#9EDF#, 16#9EE7#, 16#9EEE#,
         16#9EFF#, 16#9F02#, 16#4D77#, 16#9F03#,
         16#9F17#, 16#9F19#, 16#9F2F#, 16#9F37#,
         16#9F3A#, 16#9F3D#, 16#9F41#, 16#9F45#,
         16#9F46#, 16#9F53#, 16#9F55#, 16#9F58#,
         16#02_A5F1#, 16#9F5D#, 16#02_A602#, 16#9F69#,
         16#02_A61A#, 16#9F6D#, 16#9F70#, 16#9F75#,
         16#02_A6B2#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#,
         16#0000#, 16#0000#, 16#0000#, 16#0000#);

   Decode_Double :
     constant array (Ada.Streams.Stream_Element)
       of not null SHIFTJIS_Code_Point_Array_Access
         := (Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_81'Access,
             Decode_Double_82'Access, Decode_Double_83'Access,
             Decode_Double_84'Access, Decode_Double_85'Access,
             Decode_Double_86'Access, Decode_Double_87'Access,
             Decode_Double_88'Access, Decode_Double_89'Access,
             Decode_Double_8A'Access, Decode_Double_8B'Access,
             Decode_Double_8C'Access, Decode_Double_8D'Access,
             Decode_Double_8E'Access, Decode_Double_8F'Access,
             Decode_Double_90'Access, Decode_Double_91'Access,
             Decode_Double_92'Access, Decode_Double_93'Access,
             Decode_Double_94'Access, Decode_Double_95'Access,
             Decode_Double_96'Access, Decode_Double_97'Access,
             Decode_Double_98'Access, Decode_Double_99'Access,
             Decode_Double_9A'Access, Decode_Double_9B'Access,
             Decode_Double_9C'Access, Decode_Double_9D'Access,
             Decode_Double_9E'Access, Decode_Double_9F'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access,
             Decode_Double_E0'Access, Decode_Double_E1'Access,
             Decode_Double_E2'Access, Decode_Double_E3'Access,
             Decode_Double_E4'Access, Decode_Double_E5'Access,
             Decode_Double_E6'Access, Decode_Double_E7'Access,
             Decode_Double_E8'Access, Decode_Double_E9'Access,
             Decode_Double_EA'Access, Decode_Double_EB'Access,
             Decode_Double_EC'Access, Decode_Double_ED'Access,
             Decode_Double_EE'Access, Decode_Double_EF'Access,
             Decode_Double_F0'Access, Decode_Double_F1'Access,
             Decode_Double_F2'Access, Decode_Double_F3'Access,
             Decode_Double_F4'Access, Decode_Double_F5'Access,
             Decode_Double_F6'Access, Decode_Double_F7'Access,
             Decode_Double_F8'Access, Decode_Double_F9'Access,
             Decode_Double_FA'Access, Decode_Double_FB'Access,
             Decode_Double_FC'Access, Decode_Double_Invalid'Access,
             Decode_Double_Invalid'Access, Decode_Double_Invalid'Access);

   Expansion :
     constant array (Matreshka.Internals.Unicode.Code_Unit_32 range 1 .. 25)
       of SHIFTJIS_Expansion_Pair
         := ((16#304B#, 16#309A#), (16#304D#, 16#309A#),
             (16#304F#, 16#309A#), (16#3051#, 16#309A#),
             (16#3053#, 16#309A#), (16#30AB#, 16#309A#),
             (16#30AD#, 16#309A#), (16#30AF#, 16#309A#),
             (16#30B1#, 16#309A#), (16#30B3#, 16#309A#),
             (16#30BB#, 16#309A#), (16#30C4#, 16#309A#),
             (16#30C8#, 16#309A#), (16#31F7#, 16#309A#),
             (16#00E6#, 16#0300#), (16#0254#, 16#0300#),
             (16#0254#, 16#0301#), (16#028C#, 16#0300#),
             (16#028C#, 16#0301#), (16#0259#, 16#0300#),
             (16#0259#, 16#0301#), (16#025A#, 16#0300#),
             (16#025A#, 16#0301#), (16#02E9#, 16#02E5#),
             (16#02E5#, 16#02E9#));

end Matreshka.Internals.Text_Codecs.SHIFTJIS.Tables;
