------------------------------------------------------------------------------
--                                                                          --
--                            Matreshka Project                             --
--                                                                          --
--        Localization, Internationalization, Globalization for Ada         --
--                                                                          --
--                        Runtime Library Component                         --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2009-2013, Vadim Godunko <vgodunko@gmail.com>                --
-- All rights reserved.                                                     --
--                                                                          --
-- Redistribution and use in source and binary forms, with or without       --
-- modification, are permitted provided that the following conditions       --
-- are met:                                                                 --
--                                                                          --
--  * Redistributions of source code must retain the above copyright        --
--    notice, this list of conditions and the following disclaimer.         --
--                                                                          --
--  * Redistributions in binary form must reproduce the above copyright     --
--    notice, this list of conditions and the following disclaimer in the   --
--    documentation and/or other materials provided with the distribution.  --
--                                                                          --
--  * Neither the name of the Vadim Godunko, IE nor the names of its        --
--    contributors may be used to endorse or promote products derived from  --
--    this software without specific prior written permission.              --
--                                                                          --
-- THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS      --
-- "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT        --
-- LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR    --
-- A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT     --
-- HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,   --
-- SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED --
-- TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR   --
-- PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF   --
-- LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING     --
-- NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS       --
-- SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.             --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 5307 $ $Date: 2015-05-16 00:04:40 +0200 (Sat, 16 May 2015) $
------------------------------------------------------------------------------

pragma Restrictions (No_Elaboration_Code);
--  GNAT: enforce generation of preinitialized data section instead of
--  generation of elaboration code.

package Matreshka.Internals.Unicode.Ucd.Cases is

   pragma Preelaborate;

   Data : aliased constant Code_Point_Sequence
     := (16#000061#, 16#000062#, 16#000063#, 16#000064#, 16#000065#,
         16#000066#, 16#000067#, 16#000068#, 16#000069#, 16#00006A#,
         16#00006B#, 16#00006C#, 16#00006D#, 16#00006E#, 16#00006F#,
         16#000070#, 16#000071#, 16#000072#, 16#000073#, 16#000074#,
         16#000075#, 16#000076#, 16#000077#, 16#000078#, 16#000079#,
         16#00007A#, 16#000041#, 16#000042#, 16#000043#, 16#000044#,
         16#000045#, 16#000046#, 16#000047#, 16#000048#, 16#000049#,
         16#00004A#, 16#00004B#, 16#00004C#, 16#00004D#, 16#00004E#,
         16#00004F#, 16#000050#, 16#000051#, 16#000052#, 16#000053#,
         16#000054#, 16#000055#, 16#000056#, 16#000057#, 16#000058#,
         16#000059#, 16#00005A#, 16#00039C#, 16#0003BC#, 16#0000E0#,
         16#0000E1#, 16#0000E2#, 16#0000E3#, 16#0000E4#, 16#0000E5#,
         16#0000E6#, 16#0000E7#, 16#0000E8#, 16#0000E9#, 16#0000EA#,
         16#0000EB#, 16#0000EC#, 16#0000ED#, 16#0000EE#, 16#0000EF#,
         16#0000F0#, 16#0000F1#, 16#0000F2#, 16#0000F3#, 16#0000F4#,
         16#0000F5#, 16#0000F6#, 16#0000F8#, 16#0000F9#, 16#0000FA#,
         16#0000FB#, 16#0000FC#, 16#0000FD#, 16#0000FE#, 16#000053#,
         16#000073#, 16#000053#, 16#000053#, 16#000073#, 16#000073#,
         16#0000C0#, 16#0000C1#, 16#0000C2#, 16#0000C3#, 16#0000C4#,
         16#0000C5#, 16#0000C6#, 16#0000C7#, 16#0000C8#, 16#0000C9#,
         16#0000CA#, 16#0000CB#, 16#0000CC#, 16#0000CD#, 16#0000CE#,
         16#0000CF#, 16#0000D0#, 16#0000D1#, 16#0000D2#, 16#0000D3#,
         16#0000D4#, 16#0000D5#, 16#0000D6#, 16#0000D8#, 16#0000D9#,
         16#0000DA#, 16#0000DB#, 16#0000DC#, 16#0000DD#, 16#0000DE#,
         16#000178#, 16#000101#, 16#000100#, 16#000103#, 16#000102#,
         16#000105#, 16#000104#, 16#000107#, 16#000106#, 16#000109#,
         16#000108#, 16#00010B#, 16#00010A#, 16#00010D#, 16#00010C#,
         16#00010F#, 16#00010E#, 16#000111#, 16#000110#, 16#000113#,
         16#000112#, 16#000115#, 16#000114#, 16#000117#, 16#000116#,
         16#000119#, 16#000118#, 16#00011B#, 16#00011A#, 16#00011D#,
         16#00011C#, 16#00011F#, 16#00011E#, 16#000121#, 16#000120#,
         16#000123#, 16#000122#, 16#000125#, 16#000124#, 16#000127#,
         16#000126#, 16#000129#, 16#000128#, 16#00012B#, 16#00012A#,
         16#00012D#, 16#00012C#, 16#00012F#, 16#00012E#, 16#000069#,
         16#000307#, 16#000133#, 16#000132#, 16#000135#, 16#000134#,
         16#000137#, 16#000136#, 16#00013A#, 16#000139#, 16#00013C#,
         16#00013B#, 16#00013E#, 16#00013D#, 16#000140#, 16#00013F#,
         16#000142#, 16#000141#, 16#000144#, 16#000143#, 16#000146#,
         16#000145#, 16#000148#, 16#000147#, 16#0002BC#, 16#00004E#,
         16#0002BC#, 16#00006E#, 16#00014B#, 16#00014A#, 16#00014D#,
         16#00014C#, 16#00014F#, 16#00014E#, 16#000151#, 16#000150#,
         16#000153#, 16#000152#, 16#000155#, 16#000154#, 16#000157#,
         16#000156#, 16#000159#, 16#000158#, 16#00015B#, 16#00015A#,
         16#00015D#, 16#00015C#, 16#00015F#, 16#00015E#, 16#000161#,
         16#000160#, 16#000163#, 16#000162#, 16#000165#, 16#000164#,
         16#000167#, 16#000166#, 16#000169#, 16#000168#, 16#00016B#,
         16#00016A#, 16#00016D#, 16#00016C#, 16#00016F#, 16#00016E#,
         16#000171#, 16#000170#, 16#000173#, 16#000172#, 16#000175#,
         16#000174#, 16#000177#, 16#000176#, 16#0000FF#, 16#00017A#,
         16#000179#, 16#00017C#, 16#00017B#, 16#00017E#, 16#00017D#,
         16#000243#, 16#000253#, 16#000183#, 16#000182#, 16#000185#,
         16#000184#, 16#000254#, 16#000188#, 16#000187#, 16#000256#,
         16#000257#, 16#00018C#, 16#00018B#, 16#0001DD#, 16#000259#,
         16#00025B#, 16#000192#, 16#000191#, 16#000260#, 16#000263#,
         16#0001F6#, 16#000269#, 16#000268#, 16#000199#, 16#000198#,
         16#00023D#, 16#00026F#, 16#000272#, 16#000220#, 16#000275#,
         16#0001A1#, 16#0001A0#, 16#0001A3#, 16#0001A2#, 16#0001A5#,
         16#0001A4#, 16#000280#, 16#0001A8#, 16#0001A7#, 16#000283#,
         16#0001AD#, 16#0001AC#, 16#000288#, 16#0001B0#, 16#0001AF#,
         16#00028A#, 16#00028B#, 16#0001B4#, 16#0001B3#, 16#0001B6#,
         16#0001B5#, 16#000292#, 16#0001B9#, 16#0001B8#, 16#0001BD#,
         16#0001BC#, 16#0001F7#, 16#0001C6#, 16#0001C5#, 16#0001C4#,
         16#0001C9#, 16#0001C8#, 16#0001C7#, 16#0001CC#, 16#0001CB#,
         16#0001CA#, 16#0001CE#, 16#0001CD#, 16#0001D0#, 16#0001CF#,
         16#0001D2#, 16#0001D1#, 16#0001D4#, 16#0001D3#, 16#0001D6#,
         16#0001D5#, 16#0001D8#, 16#0001D7#, 16#0001DA#, 16#0001D9#,
         16#0001DC#, 16#0001DB#, 16#00018E#, 16#0001DF#, 16#0001DE#,
         16#0001E1#, 16#0001E0#, 16#0001E3#, 16#0001E2#, 16#0001E5#,
         16#0001E4#, 16#0001E7#, 16#0001E6#, 16#0001E9#, 16#0001E8#,
         16#0001EB#, 16#0001EA#, 16#0001ED#, 16#0001EC#, 16#0001EF#,
         16#0001EE#, 16#00004A#, 16#00030C#, 16#00006A#, 16#00030C#,
         16#0001F3#, 16#0001F2#, 16#0001F1#, 16#0001F5#, 16#0001F4#,
         16#000195#, 16#0001BF#, 16#0001F9#, 16#0001F8#, 16#0001FB#,
         16#0001FA#, 16#0001FD#, 16#0001FC#, 16#0001FF#, 16#0001FE#,
         16#000201#, 16#000200#, 16#000203#, 16#000202#, 16#000205#,
         16#000204#, 16#000207#, 16#000206#, 16#000209#, 16#000208#,
         16#00020B#, 16#00020A#, 16#00020D#, 16#00020C#, 16#00020F#,
         16#00020E#, 16#000211#, 16#000210#, 16#000213#, 16#000212#,
         16#000215#, 16#000214#, 16#000217#, 16#000216#, 16#000219#,
         16#000218#, 16#00021B#, 16#00021A#, 16#00021D#, 16#00021C#,
         16#00021F#, 16#00021E#, 16#00019E#, 16#000223#, 16#000222#,
         16#000225#, 16#000224#, 16#000227#, 16#000226#, 16#000229#,
         16#000228#, 16#00022B#, 16#00022A#, 16#00022D#, 16#00022C#,
         16#00022F#, 16#00022E#, 16#000231#, 16#000230#, 16#000233#,
         16#000232#, 16#002C65#, 16#00023C#, 16#00023B#, 16#00019A#,
         16#002C66#, 16#002C7E#, 16#002C7F#, 16#000242#, 16#000241#,
         16#000180#, 16#000289#, 16#00028C#, 16#000247#, 16#000246#,
         16#000249#, 16#000248#, 16#00024B#, 16#00024A#, 16#00024D#,
         16#00024C#, 16#00024F#, 16#00024E#, 16#002C6F#, 16#002C6D#,
         16#002C70#, 16#000181#, 16#000186#, 16#000189#, 16#00018A#,
         16#00018F#, 16#000190#, 16#00A7AB#, 16#000193#, 16#00A7AC#,
         16#000194#, 16#00A78D#, 16#00A7AA#, 16#000197#, 16#000196#,
         16#002C62#, 16#00A7AD#, 16#00019C#, 16#002C6E#, 16#00019D#,
         16#00019F#, 16#002C64#, 16#0001A6#, 16#0001A9#, 16#00A7B1#,
         16#0001AE#, 16#000244#, 16#0001B1#, 16#0001B2#, 16#000245#,
         16#0001B7#, 16#00A7B0#, 16#000399#, 16#0003B9#, 16#000371#,
         16#000370#, 16#000373#, 16#000372#, 16#000377#, 16#000376#,
         16#0003FD#, 16#0003FE#, 16#0003FF#, 16#0003F3#, 16#0003AC#,
         16#0003AD#, 16#0003AE#, 16#0003AF#, 16#0003CC#, 16#0003CD#,
         16#0003CE#, 16#000399#, 16#000308#, 16#000301#, 16#0003B9#,
         16#000308#, 16#000301#, 16#0003B1#, 16#0003B2#, 16#0003B3#,
         16#0003B4#, 16#0003B5#, 16#0003B6#, 16#0003B7#, 16#0003B8#,
         16#0003BA#, 16#0003BB#, 16#0003BD#, 16#0003BE#, 16#0003BF#,
         16#0003C0#, 16#0003C1#, 16#0003C3#, 16#0003C2#, 16#0003C4#,
         16#0003C5#, 16#0003C6#, 16#0003C7#, 16#0003C8#, 16#0003C9#,
         16#0003CA#, 16#0003CB#, 16#000386#, 16#000388#, 16#000389#,
         16#00038A#, 16#0003A5#, 16#000308#, 16#000301#, 16#0003C5#,
         16#000308#, 16#000301#, 16#000391#, 16#000392#, 16#000393#,
         16#000394#, 16#000395#, 16#000396#, 16#000397#, 16#000398#,
         16#00039A#, 16#00039B#, 16#00039D#, 16#00039E#, 16#00039F#,
         16#0003A0#, 16#0003A1#, 16#0003A3#, 16#0003A4#, 16#0003A6#,
         16#0003A7#, 16#0003A8#, 16#0003A9#, 16#0003AA#, 16#0003AB#,
         16#00038C#, 16#00038E#, 16#00038F#, 16#0003D7#, 16#0003CF#,
         16#0003D9#, 16#0003D8#, 16#0003DB#, 16#0003DA#, 16#0003DD#,
         16#0003DC#, 16#0003DF#, 16#0003DE#, 16#0003E1#, 16#0003E0#,
         16#0003E3#, 16#0003E2#, 16#0003E5#, 16#0003E4#, 16#0003E7#,
         16#0003E6#, 16#0003E9#, 16#0003E8#, 16#0003EB#, 16#0003EA#,
         16#0003ED#, 16#0003EC#, 16#0003EF#, 16#0003EE#, 16#0003F9#,
         16#00037F#, 16#0003F8#, 16#0003F7#, 16#0003F2#, 16#0003FB#,
         16#0003FA#, 16#00037B#, 16#00037C#, 16#00037D#, 16#000450#,
         16#000451#, 16#000452#, 16#000453#, 16#000454#, 16#000455#,
         16#000456#, 16#000457#, 16#000458#, 16#000459#, 16#00045A#,
         16#00045B#, 16#00045C#, 16#00045D#, 16#00045E#, 16#00045F#,
         16#000430#, 16#000431#, 16#000432#, 16#000433#, 16#000434#,
         16#000435#, 16#000436#, 16#000437#, 16#000438#, 16#000439#,
         16#00043A#, 16#00043B#, 16#00043C#, 16#00043D#, 16#00043E#,
         16#00043F#, 16#000440#, 16#000441#, 16#000442#, 16#000443#,
         16#000444#, 16#000445#, 16#000446#, 16#000447#, 16#000448#,
         16#000449#, 16#00044A#, 16#00044B#, 16#00044C#, 16#00044D#,
         16#00044E#, 16#00044F#, 16#000410#, 16#000411#, 16#000412#,
         16#000413#, 16#000414#, 16#000415#, 16#000416#, 16#000417#,
         16#000418#, 16#000419#, 16#00041A#, 16#00041B#, 16#00041C#,
         16#00041D#, 16#00041E#, 16#00041F#, 16#000420#, 16#000421#,
         16#000422#, 16#000423#, 16#000424#, 16#000425#, 16#000426#,
         16#000427#, 16#000428#, 16#000429#, 16#00042A#, 16#00042B#,
         16#00042C#, 16#00042D#, 16#00042E#, 16#00042F#, 16#000400#,
         16#000401#, 16#000402#, 16#000403#, 16#000404#, 16#000405#,
         16#000406#, 16#000407#, 16#000408#, 16#000409#, 16#00040A#,
         16#00040B#, 16#00040C#, 16#00040D#, 16#00040E#, 16#00040F#,
         16#000461#, 16#000460#, 16#000463#, 16#000462#, 16#000465#,
         16#000464#, 16#000467#, 16#000466#, 16#000469#, 16#000468#,
         16#00046B#, 16#00046A#, 16#00046D#, 16#00046C#, 16#00046F#,
         16#00046E#, 16#000471#, 16#000470#, 16#000473#, 16#000472#,
         16#000475#, 16#000474#, 16#000477#, 16#000476#, 16#000479#,
         16#000478#, 16#00047B#, 16#00047A#, 16#00047D#, 16#00047C#,
         16#00047F#, 16#00047E#, 16#000481#, 16#000480#, 16#00048B#,
         16#00048A#, 16#00048D#, 16#00048C#, 16#00048F#, 16#00048E#,
         16#000491#, 16#000490#, 16#000493#, 16#000492#, 16#000495#,
         16#000494#, 16#000497#, 16#000496#, 16#000499#, 16#000498#,
         16#00049B#, 16#00049A#, 16#00049D#, 16#00049C#, 16#00049F#,
         16#00049E#, 16#0004A1#, 16#0004A0#, 16#0004A3#, 16#0004A2#,
         16#0004A5#, 16#0004A4#, 16#0004A7#, 16#0004A6#, 16#0004A9#,
         16#0004A8#, 16#0004AB#, 16#0004AA#, 16#0004AD#, 16#0004AC#,
         16#0004AF#, 16#0004AE#, 16#0004B1#, 16#0004B0#, 16#0004B3#,
         16#0004B2#, 16#0004B5#, 16#0004B4#, 16#0004B7#, 16#0004B6#,
         16#0004B9#, 16#0004B8#, 16#0004BB#, 16#0004BA#, 16#0004BD#,
         16#0004BC#, 16#0004BF#, 16#0004BE#, 16#0004CF#, 16#0004C2#,
         16#0004C1#, 16#0004C4#, 16#0004C3#, 16#0004C6#, 16#0004C5#,
         16#0004C8#, 16#0004C7#, 16#0004CA#, 16#0004C9#, 16#0004CC#,
         16#0004CB#, 16#0004CE#, 16#0004CD#, 16#0004C0#, 16#0004D1#,
         16#0004D0#, 16#0004D3#, 16#0004D2#, 16#0004D5#, 16#0004D4#,
         16#0004D7#, 16#0004D6#, 16#0004D9#, 16#0004D8#, 16#0004DB#,
         16#0004DA#, 16#0004DD#, 16#0004DC#, 16#0004DF#, 16#0004DE#,
         16#0004E1#, 16#0004E0#, 16#0004E3#, 16#0004E2#, 16#0004E5#,
         16#0004E4#, 16#0004E7#, 16#0004E6#, 16#0004E9#, 16#0004E8#,
         16#0004EB#, 16#0004EA#, 16#0004ED#, 16#0004EC#, 16#0004EF#,
         16#0004EE#, 16#0004F1#, 16#0004F0#, 16#0004F3#, 16#0004F2#,
         16#0004F5#, 16#0004F4#, 16#0004F7#, 16#0004F6#, 16#0004F9#,
         16#0004F8#, 16#0004FB#, 16#0004FA#, 16#0004FD#, 16#0004FC#,
         16#0004FF#, 16#0004FE#, 16#000501#, 16#000500#, 16#000503#,
         16#000502#, 16#000505#, 16#000504#, 16#000507#, 16#000506#,
         16#000509#, 16#000508#, 16#00050B#, 16#00050A#, 16#00050D#,
         16#00050C#, 16#00050F#, 16#00050E#, 16#000511#, 16#000510#,
         16#000513#, 16#000512#, 16#000515#, 16#000514#, 16#000517#,
         16#000516#, 16#000519#, 16#000518#, 16#00051B#, 16#00051A#,
         16#00051D#, 16#00051C#, 16#00051F#, 16#00051E#, 16#000521#,
         16#000520#, 16#000523#, 16#000522#, 16#000525#, 16#000524#,
         16#000527#, 16#000526#, 16#000529#, 16#000528#, 16#00052B#,
         16#00052A#, 16#00052D#, 16#00052C#, 16#00052F#, 16#00052E#,
         16#000561#, 16#000562#, 16#000563#, 16#000564#, 16#000565#,
         16#000566#, 16#000567#, 16#000568#, 16#000569#, 16#00056A#,
         16#00056B#, 16#00056C#, 16#00056D#, 16#00056E#, 16#00056F#,
         16#000570#, 16#000571#, 16#000572#, 16#000573#, 16#000574#,
         16#000575#, 16#000576#, 16#000577#, 16#000578#, 16#000579#,
         16#00057A#, 16#00057B#, 16#00057C#, 16#00057D#, 16#00057E#,
         16#00057F#, 16#000580#, 16#000581#, 16#000582#, 16#000583#,
         16#000584#, 16#000585#, 16#000586#, 16#000531#, 16#000532#,
         16#000533#, 16#000534#, 16#000535#, 16#000536#, 16#000537#,
         16#000538#, 16#000539#, 16#00053A#, 16#00053B#, 16#00053C#,
         16#00053D#, 16#00053E#, 16#00053F#, 16#000540#, 16#000541#,
         16#000542#, 16#000543#, 16#000544#, 16#000545#, 16#000546#,
         16#000547#, 16#000548#, 16#000549#, 16#00054A#, 16#00054B#,
         16#00054C#, 16#00054D#, 16#00054E#, 16#00054F#, 16#000550#,
         16#000551#, 16#000552#, 16#000553#, 16#000554#, 16#000555#,
         16#000556#, 16#000535#, 16#000582#, 16#000535#, 16#000552#,
         16#000565#, 16#000582#, 16#002D00#, 16#002D01#, 16#002D02#,
         16#002D03#, 16#002D04#, 16#002D05#, 16#002D06#, 16#002D07#,
         16#002D08#, 16#002D09#, 16#002D0A#, 16#002D0B#, 16#002D0C#,
         16#002D0D#, 16#002D0E#, 16#002D0F#, 16#002D10#, 16#002D11#,
         16#002D12#, 16#002D13#, 16#002D14#, 16#002D15#, 16#002D16#,
         16#002D17#, 16#002D18#, 16#002D19#, 16#002D1A#, 16#002D1B#,
         16#002D1C#, 16#002D1D#, 16#002D1E#, 16#002D1F#, 16#002D20#,
         16#002D21#, 16#002D22#, 16#002D23#, 16#002D24#, 16#002D25#,
         16#002D27#, 16#002D2D#, 16#00A77D#, 16#002C63#, 16#001E01#,
         16#001E00#, 16#001E03#, 16#001E02#, 16#001E05#, 16#001E04#,
         16#001E07#, 16#001E06#, 16#001E09#, 16#001E08#, 16#001E0B#,
         16#001E0A#, 16#001E0D#, 16#001E0C#, 16#001E0F#, 16#001E0E#,
         16#001E11#, 16#001E10#, 16#001E13#, 16#001E12#, 16#001E15#,
         16#001E14#, 16#001E17#, 16#001E16#, 16#001E19#, 16#001E18#,
         16#001E1B#, 16#001E1A#, 16#001E1D#, 16#001E1C#, 16#001E1F#,
         16#001E1E#, 16#001E21#, 16#001E20#, 16#001E23#, 16#001E22#,
         16#001E25#, 16#001E24#, 16#001E27#, 16#001E26#, 16#001E29#,
         16#001E28#, 16#001E2B#, 16#001E2A#, 16#001E2D#, 16#001E2C#,
         16#001E2F#, 16#001E2E#, 16#001E31#, 16#001E30#, 16#001E33#,
         16#001E32#, 16#001E35#, 16#001E34#, 16#001E37#, 16#001E36#,
         16#001E39#, 16#001E38#, 16#001E3B#, 16#001E3A#, 16#001E3D#,
         16#001E3C#, 16#001E3F#, 16#001E3E#, 16#001E41#, 16#001E40#,
         16#001E43#, 16#001E42#, 16#001E45#, 16#001E44#, 16#001E47#,
         16#001E46#, 16#001E49#, 16#001E48#, 16#001E4B#, 16#001E4A#,
         16#001E4D#, 16#001E4C#, 16#001E4F#, 16#001E4E#, 16#001E51#,
         16#001E50#, 16#001E53#, 16#001E52#, 16#001E55#, 16#001E54#,
         16#001E57#, 16#001E56#, 16#001E59#, 16#001E58#, 16#001E5B#,
         16#001E5A#, 16#001E5D#, 16#001E5C#, 16#001E5F#, 16#001E5E#,
         16#001E61#, 16#001E60#, 16#001E63#, 16#001E62#, 16#001E65#,
         16#001E64#, 16#001E67#, 16#001E66#, 16#001E69#, 16#001E68#,
         16#001E6B#, 16#001E6A#, 16#001E6D#, 16#001E6C#, 16#001E6F#,
         16#001E6E#, 16#001E71#, 16#001E70#, 16#001E73#, 16#001E72#,
         16#001E75#, 16#001E74#, 16#001E77#, 16#001E76#, 16#001E79#,
         16#001E78#, 16#001E7B#, 16#001E7A#, 16#001E7D#, 16#001E7C#,
         16#001E7F#, 16#001E7E#, 16#001E81#, 16#001E80#, 16#001E83#,
         16#001E82#, 16#001E85#, 16#001E84#, 16#001E87#, 16#001E86#,
         16#001E89#, 16#001E88#, 16#001E8B#, 16#001E8A#, 16#001E8D#,
         16#001E8C#, 16#001E8F#, 16#001E8E#, 16#001E91#, 16#001E90#,
         16#001E93#, 16#001E92#, 16#001E95#, 16#001E94#, 16#000048#,
         16#000331#, 16#000068#, 16#000331#, 16#000054#, 16#000308#,
         16#000074#, 16#000308#, 16#000057#, 16#00030A#, 16#000077#,
         16#00030A#, 16#000059#, 16#00030A#, 16#000079#, 16#00030A#,
         16#000041#, 16#0002BE#, 16#000061#, 16#0002BE#, 16#0000DF#,
         16#001EA1#, 16#001EA0#, 16#001EA3#, 16#001EA2#, 16#001EA5#,
         16#001EA4#, 16#001EA7#, 16#001EA6#, 16#001EA9#, 16#001EA8#,
         16#001EAB#, 16#001EAA#, 16#001EAD#, 16#001EAC#, 16#001EAF#,
         16#001EAE#, 16#001EB1#, 16#001EB0#, 16#001EB3#, 16#001EB2#,
         16#001EB5#, 16#001EB4#, 16#001EB7#, 16#001EB6#, 16#001EB9#,
         16#001EB8#, 16#001EBB#, 16#001EBA#, 16#001EBD#, 16#001EBC#,
         16#001EBF#, 16#001EBE#, 16#001EC1#, 16#001EC0#, 16#001EC3#,
         16#001EC2#, 16#001EC5#, 16#001EC4#, 16#001EC7#, 16#001EC6#,
         16#001EC9#, 16#001EC8#, 16#001ECB#, 16#001ECA#, 16#001ECD#,
         16#001ECC#, 16#001ECF#, 16#001ECE#, 16#001ED1#, 16#001ED0#,
         16#001ED3#, 16#001ED2#, 16#001ED5#, 16#001ED4#, 16#001ED7#,
         16#001ED6#, 16#001ED9#, 16#001ED8#, 16#001EDB#, 16#001EDA#,
         16#001EDD#, 16#001EDC#, 16#001EDF#, 16#001EDE#, 16#001EE1#,
         16#001EE0#, 16#001EE3#, 16#001EE2#, 16#001EE5#, 16#001EE4#,
         16#001EE7#, 16#001EE6#, 16#001EE9#, 16#001EE8#, 16#001EEB#,
         16#001EEA#, 16#001EED#, 16#001EEC#, 16#001EEF#, 16#001EEE#,
         16#001EF1#, 16#001EF0#, 16#001EF3#, 16#001EF2#, 16#001EF5#,
         16#001EF4#, 16#001EF7#, 16#001EF6#, 16#001EF9#, 16#001EF8#,
         16#001EFB#, 16#001EFA#, 16#001EFD#, 16#001EFC#, 16#001EFF#,
         16#001EFE#, 16#001F08#, 16#001F09#, 16#001F0A#, 16#001F0B#,
         16#001F0C#, 16#001F0D#, 16#001F0E#, 16#001F0F#, 16#001F00#,
         16#001F01#, 16#001F02#, 16#001F03#, 16#001F04#, 16#001F05#,
         16#001F06#, 16#001F07#, 16#001F18#, 16#001F19#, 16#001F1A#,
         16#001F1B#, 16#001F1C#, 16#001F1D#, 16#001F10#, 16#001F11#,
         16#001F12#, 16#001F13#, 16#001F14#, 16#001F15#, 16#001F28#,
         16#001F29#, 16#001F2A#, 16#001F2B#, 16#001F2C#, 16#001F2D#,
         16#001F2E#, 16#001F2F#, 16#001F20#, 16#001F21#, 16#001F22#,
         16#001F23#, 16#001F24#, 16#001F25#, 16#001F26#, 16#001F27#,
         16#001F38#, 16#001F39#, 16#001F3A#, 16#001F3B#, 16#001F3C#,
         16#001F3D#, 16#001F3E#, 16#001F3F#, 16#001F30#, 16#001F31#,
         16#001F32#, 16#001F33#, 16#001F34#, 16#001F35#, 16#001F36#,
         16#001F37#, 16#001F48#, 16#001F49#, 16#001F4A#, 16#001F4B#,
         16#001F4C#, 16#001F4D#, 16#001F40#, 16#001F41#, 16#001F42#,
         16#001F43#, 16#001F44#, 16#001F45#, 16#0003A5#, 16#000313#,
         16#0003C5#, 16#000313#, 16#001F59#, 16#0003A5#, 16#000313#,
         16#000300#, 16#0003C5#, 16#000313#, 16#000300#, 16#001F5B#,
         16#0003A5#, 16#000313#, 16#000301#, 16#0003C5#, 16#000313#,
         16#000301#, 16#001F5D#, 16#0003A5#, 16#000313#, 16#000342#,
         16#0003C5#, 16#000313#, 16#000342#, 16#001F5F#, 16#001F51#,
         16#001F53#, 16#001F55#, 16#001F57#, 16#001F68#, 16#001F69#,
         16#001F6A#, 16#001F6B#, 16#001F6C#, 16#001F6D#, 16#001F6E#,
         16#001F6F#, 16#001F60#, 16#001F61#, 16#001F62#, 16#001F63#,
         16#001F64#, 16#001F65#, 16#001F66#, 16#001F67#, 16#001FBA#,
         16#001FBB#, 16#001FC8#, 16#001FC9#, 16#001FCA#, 16#001FCB#,
         16#001FDA#, 16#001FDB#, 16#001FF8#, 16#001FF9#, 16#001FEA#,
         16#001FEB#, 16#001FFA#, 16#001FFB#, 16#001F88#, 16#001F08#,
         16#000399#, 16#001F00#, 16#0003B9#, 16#001F89#, 16#001F09#,
         16#000399#, 16#001F01#, 16#0003B9#, 16#001F8A#, 16#001F0A#,
         16#000399#, 16#001F02#, 16#0003B9#, 16#001F8B#, 16#001F0B#,
         16#000399#, 16#001F03#, 16#0003B9#, 16#001F8C#, 16#001F0C#,
         16#000399#, 16#001F04#, 16#0003B9#, 16#001F8D#, 16#001F0D#,
         16#000399#, 16#001F05#, 16#0003B9#, 16#001F8E#, 16#001F0E#,
         16#000399#, 16#001F06#, 16#0003B9#, 16#001F8F#, 16#001F0F#,
         16#000399#, 16#001F07#, 16#0003B9#, 16#001F80#, 16#001F81#,
         16#001F82#, 16#001F83#, 16#001F84#, 16#001F85#, 16#001F86#,
         16#001F87#, 16#001F98#, 16#001F28#, 16#000399#, 16#001F20#,
         16#0003B9#, 16#001F99#, 16#001F29#, 16#000399#, 16#001F21#,
         16#0003B9#, 16#001F9A#, 16#001F2A#, 16#000399#, 16#001F22#,
         16#0003B9#, 16#001F9B#, 16#001F2B#, 16#000399#, 16#001F23#,
         16#0003B9#, 16#001F9C#, 16#001F2C#, 16#000399#, 16#001F24#,
         16#0003B9#, 16#001F9D#, 16#001F2D#, 16#000399#, 16#001F25#,
         16#0003B9#, 16#001F9E#, 16#001F2E#, 16#000399#, 16#001F26#,
         16#0003B9#, 16#001F9F#, 16#001F2F#, 16#000399#, 16#001F27#,
         16#0003B9#, 16#001F90#, 16#001F91#, 16#001F92#, 16#001F93#,
         16#001F94#, 16#001F95#, 16#001F96#, 16#001F97#, 16#001FA8#,
         16#001F68#, 16#000399#, 16#001F60#, 16#0003B9#, 16#001FA9#,
         16#001F69#, 16#000399#, 16#001F61#, 16#0003B9#, 16#001FAA#,
         16#001F6A#, 16#000399#, 16#001F62#, 16#0003B9#, 16#001FAB#,
         16#001F6B#, 16#000399#, 16#001F63#, 16#0003B9#, 16#001FAC#,
         16#001F6C#, 16#000399#, 16#001F64#, 16#0003B9#, 16#001FAD#,
         16#001F6D#, 16#000399#, 16#001F65#, 16#0003B9#, 16#001FAE#,
         16#001F6E#, 16#000399#, 16#001F66#, 16#0003B9#, 16#001FAF#,
         16#001F6F#, 16#000399#, 16#001F67#, 16#0003B9#, 16#001FA0#,
         16#001FA1#, 16#001FA2#, 16#001FA3#, 16#001FA4#, 16#001FA5#,
         16#001FA6#, 16#001FA7#, 16#001FB8#, 16#001FB9#, 16#001FBA#,
         16#000345#, 16#001FBA#, 16#000399#, 16#001F70#, 16#0003B9#,
         16#001FBC#, 16#000391#, 16#000399#, 16#0003B1#, 16#0003B9#,
         16#000386#, 16#000345#, 16#000386#, 16#000399#, 16#0003AC#,
         16#0003B9#, 16#000391#, 16#000342#, 16#0003B1#, 16#000342#,
         16#000391#, 16#000342#, 16#000345#, 16#000391#, 16#000342#,
         16#000399#, 16#0003B1#, 16#000342#, 16#0003B9#, 16#001FB0#,
         16#001FB1#, 16#001F71#, 16#001FB3#, 16#001FCA#, 16#000345#,
         16#001FCA#, 16#000399#, 16#001F74#, 16#0003B9#, 16#001FCC#,
         16#000397#, 16#000399#, 16#0003B7#, 16#0003B9#, 16#000389#,
         16#000345#, 16#000389#, 16#000399#, 16#0003AE#, 16#0003B9#,
         16#000397#, 16#000342#, 16#0003B7#, 16#000342#, 16#000397#,
         16#000342#, 16#000345#, 16#000397#, 16#000342#, 16#000399#,
         16#0003B7#, 16#000342#, 16#0003B9#, 16#001F72#, 16#001F73#,
         16#001F75#, 16#001FC3#, 16#001FD8#, 16#001FD9#, 16#000399#,
         16#000308#, 16#000300#, 16#0003B9#, 16#000308#, 16#000300#,
         16#000399#, 16#000342#, 16#0003B9#, 16#000342#, 16#000399#,
         16#000308#, 16#000342#, 16#0003B9#, 16#000308#, 16#000342#,
         16#001FD0#, 16#001FD1#, 16#001F76#, 16#001F77#, 16#001FE8#,
         16#001FE9#, 16#0003A5#, 16#000308#, 16#000300#, 16#0003C5#,
         16#000308#, 16#000300#, 16#0003A1#, 16#000313#, 16#0003C1#,
         16#000313#, 16#001FEC#, 16#0003A5#, 16#000342#, 16#0003C5#,
         16#000342#, 16#0003A5#, 16#000308#, 16#000342#, 16#0003C5#,
         16#000308#, 16#000342#, 16#001FE0#, 16#001FE1#, 16#001F7A#,
         16#001F7B#, 16#001FE5#, 16#001FFA#, 16#000345#, 16#001FFA#,
         16#000399#, 16#001F7C#, 16#0003B9#, 16#001FFC#, 16#0003A9#,
         16#000399#, 16#0003C9#, 16#0003B9#, 16#00038F#, 16#000345#,
         16#00038F#, 16#000399#, 16#0003CE#, 16#0003B9#, 16#0003A9#,
         16#000342#, 16#0003C9#, 16#000342#, 16#0003A9#, 16#000342#,
         16#000345#, 16#0003A9#, 16#000342#, 16#000399#, 16#0003C9#,
         16#000342#, 16#0003B9#, 16#001F78#, 16#001F79#, 16#001F7D#,
         16#001FF3#, 16#00214E#, 16#002132#, 16#002170#, 16#002171#,
         16#002172#, 16#002173#, 16#002174#, 16#002175#, 16#002176#,
         16#002177#, 16#002178#, 16#002179#, 16#00217A#, 16#00217B#,
         16#00217C#, 16#00217D#, 16#00217E#, 16#00217F#, 16#002160#,
         16#002161#, 16#002162#, 16#002163#, 16#002164#, 16#002165#,
         16#002166#, 16#002167#, 16#002168#, 16#002169#, 16#00216A#,
         16#00216B#, 16#00216C#, 16#00216D#, 16#00216E#, 16#00216F#,
         16#002184#, 16#002183#, 16#0024D0#, 16#0024D1#, 16#0024D2#,
         16#0024D3#, 16#0024D4#, 16#0024D5#, 16#0024D6#, 16#0024D7#,
         16#0024D8#, 16#0024D9#, 16#0024DA#, 16#0024DB#, 16#0024DC#,
         16#0024DD#, 16#0024DE#, 16#0024DF#, 16#0024E0#, 16#0024E1#,
         16#0024E2#, 16#0024E3#, 16#0024E4#, 16#0024E5#, 16#0024E6#,
         16#0024E7#, 16#0024E8#, 16#0024E9#, 16#0024B6#, 16#0024B7#,
         16#0024B8#, 16#0024B9#, 16#0024BA#, 16#0024BB#, 16#0024BC#,
         16#0024BD#, 16#0024BE#, 16#0024BF#, 16#0024C0#, 16#0024C1#,
         16#0024C2#, 16#0024C3#, 16#0024C4#, 16#0024C5#, 16#0024C6#,
         16#0024C7#, 16#0024C8#, 16#0024C9#, 16#0024CA#, 16#0024CB#,
         16#0024CC#, 16#0024CD#, 16#0024CE#, 16#0024CF#, 16#002C30#,
         16#002C31#, 16#002C32#, 16#002C33#, 16#002C34#, 16#002C35#,
         16#002C36#, 16#002C37#, 16#002C38#, 16#002C39#, 16#002C3A#,
         16#002C3B#, 16#002C3C#, 16#002C3D#, 16#002C3E#, 16#002C3F#,
         16#002C40#, 16#002C41#, 16#002C42#, 16#002C43#, 16#002C44#,
         16#002C45#, 16#002C46#, 16#002C47#, 16#002C48#, 16#002C49#,
         16#002C4A#, 16#002C4B#, 16#002C4C#, 16#002C4D#, 16#002C4E#,
         16#002C4F#, 16#002C50#, 16#002C51#, 16#002C52#, 16#002C53#,
         16#002C54#, 16#002C55#, 16#002C56#, 16#002C57#, 16#002C58#,
         16#002C59#, 16#002C5A#, 16#002C5B#, 16#002C5C#, 16#002C5D#,
         16#002C5E#, 16#002C00#, 16#002C01#, 16#002C02#, 16#002C03#,
         16#002C04#, 16#002C05#, 16#002C06#, 16#002C07#, 16#002C08#,
         16#002C09#, 16#002C0A#, 16#002C0B#, 16#002C0C#, 16#002C0D#,
         16#002C0E#, 16#002C0F#, 16#002C10#, 16#002C11#, 16#002C12#,
         16#002C13#, 16#002C14#, 16#002C15#, 16#002C16#, 16#002C17#,
         16#002C18#, 16#002C19#, 16#002C1A#, 16#002C1B#, 16#002C1C#,
         16#002C1D#, 16#002C1E#, 16#002C1F#, 16#002C20#, 16#002C21#,
         16#002C22#, 16#002C23#, 16#002C24#, 16#002C25#, 16#002C26#,
         16#002C27#, 16#002C28#, 16#002C29#, 16#002C2A#, 16#002C2B#,
         16#002C2C#, 16#002C2D#, 16#002C2E#, 16#002C61#, 16#002C60#,
         16#00026B#, 16#001D7D#, 16#00027D#, 16#00023A#, 16#00023E#,
         16#002C68#, 16#002C67#, 16#002C6A#, 16#002C69#, 16#002C6C#,
         16#002C6B#, 16#000251#, 16#000271#, 16#000250#, 16#000252#,
         16#002C73#, 16#002C72#, 16#002C76#, 16#002C75#, 16#00023F#,
         16#000240#, 16#002C81#, 16#002C80#, 16#002C83#, 16#002C82#,
         16#002C85#, 16#002C84#, 16#002C87#, 16#002C86#, 16#002C89#,
         16#002C88#, 16#002C8B#, 16#002C8A#, 16#002C8D#, 16#002C8C#,
         16#002C8F#, 16#002C8E#, 16#002C91#, 16#002C90#, 16#002C93#,
         16#002C92#, 16#002C95#, 16#002C94#, 16#002C97#, 16#002C96#,
         16#002C99#, 16#002C98#, 16#002C9B#, 16#002C9A#, 16#002C9D#,
         16#002C9C#, 16#002C9F#, 16#002C9E#, 16#002CA1#, 16#002CA0#,
         16#002CA3#, 16#002CA2#, 16#002CA5#, 16#002CA4#, 16#002CA7#,
         16#002CA6#, 16#002CA9#, 16#002CA8#, 16#002CAB#, 16#002CAA#,
         16#002CAD#, 16#002CAC#, 16#002CAF#, 16#002CAE#, 16#002CB1#,
         16#002CB0#, 16#002CB3#, 16#002CB2#, 16#002CB5#, 16#002CB4#,
         16#002CB7#, 16#002CB6#, 16#002CB9#, 16#002CB8#, 16#002CBB#,
         16#002CBA#, 16#002CBD#, 16#002CBC#, 16#002CBF#, 16#002CBE#,
         16#002CC1#, 16#002CC0#, 16#002CC3#, 16#002CC2#, 16#002CC5#,
         16#002CC4#, 16#002CC7#, 16#002CC6#, 16#002CC9#, 16#002CC8#,
         16#002CCB#, 16#002CCA#, 16#002CCD#, 16#002CCC#, 16#002CCF#,
         16#002CCE#, 16#002CD1#, 16#002CD0#, 16#002CD3#, 16#002CD2#,
         16#002CD5#, 16#002CD4#, 16#002CD7#, 16#002CD6#, 16#002CD9#,
         16#002CD8#, 16#002CDB#, 16#002CDA#, 16#002CDD#, 16#002CDC#,
         16#002CDF#, 16#002CDE#, 16#002CE1#, 16#002CE0#, 16#002CE3#,
         16#002CE2#, 16#002CEC#, 16#002CEB#, 16#002CEE#, 16#002CED#,
         16#002CF3#, 16#002CF2#, 16#0010A0#, 16#0010A1#, 16#0010A2#,
         16#0010A3#, 16#0010A4#, 16#0010A5#, 16#0010A6#, 16#0010A7#,
         16#0010A8#, 16#0010A9#, 16#0010AA#, 16#0010AB#, 16#0010AC#,
         16#0010AD#, 16#0010AE#, 16#0010AF#, 16#0010B0#, 16#0010B1#,
         16#0010B2#, 16#0010B3#, 16#0010B4#, 16#0010B5#, 16#0010B6#,
         16#0010B7#, 16#0010B8#, 16#0010B9#, 16#0010BA#, 16#0010BB#,
         16#0010BC#, 16#0010BD#, 16#0010BE#, 16#0010BF#, 16#0010C0#,
         16#0010C1#, 16#0010C2#, 16#0010C3#, 16#0010C4#, 16#0010C5#,
         16#0010C7#, 16#0010CD#, 16#00A641#, 16#00A640#, 16#00A643#,
         16#00A642#, 16#00A645#, 16#00A644#, 16#00A647#, 16#00A646#,
         16#00A649#, 16#00A648#, 16#00A64B#, 16#00A64A#, 16#00A64D#,
         16#00A64C#, 16#00A64F#, 16#00A64E#, 16#00A651#, 16#00A650#,
         16#00A653#, 16#00A652#, 16#00A655#, 16#00A654#, 16#00A657#,
         16#00A656#, 16#00A659#, 16#00A658#, 16#00A65B#, 16#00A65A#,
         16#00A65D#, 16#00A65C#, 16#00A65F#, 16#00A65E#, 16#00A661#,
         16#00A660#, 16#00A663#, 16#00A662#, 16#00A665#, 16#00A664#,
         16#00A667#, 16#00A666#, 16#00A669#, 16#00A668#, 16#00A66B#,
         16#00A66A#, 16#00A66D#, 16#00A66C#, 16#00A681#, 16#00A680#,
         16#00A683#, 16#00A682#, 16#00A685#, 16#00A684#, 16#00A687#,
         16#00A686#, 16#00A689#, 16#00A688#, 16#00A68B#, 16#00A68A#,
         16#00A68D#, 16#00A68C#, 16#00A68F#, 16#00A68E#, 16#00A691#,
         16#00A690#, 16#00A693#, 16#00A692#, 16#00A695#, 16#00A694#,
         16#00A697#, 16#00A696#, 16#00A699#, 16#00A698#, 16#00A69B#,
         16#00A69A#, 16#00A723#, 16#00A722#, 16#00A725#, 16#00A724#,
         16#00A727#, 16#00A726#, 16#00A729#, 16#00A728#, 16#00A72B#,
         16#00A72A#, 16#00A72D#, 16#00A72C#, 16#00A72F#, 16#00A72E#,
         16#00A733#, 16#00A732#, 16#00A735#, 16#00A734#, 16#00A737#,
         16#00A736#, 16#00A739#, 16#00A738#, 16#00A73B#, 16#00A73A#,
         16#00A73D#, 16#00A73C#, 16#00A73F#, 16#00A73E#, 16#00A741#,
         16#00A740#, 16#00A743#, 16#00A742#, 16#00A745#, 16#00A744#,
         16#00A747#, 16#00A746#, 16#00A749#, 16#00A748#, 16#00A74B#,
         16#00A74A#, 16#00A74D#, 16#00A74C#, 16#00A74F#, 16#00A74E#,
         16#00A751#, 16#00A750#, 16#00A753#, 16#00A752#, 16#00A755#,
         16#00A754#, 16#00A757#, 16#00A756#, 16#00A759#, 16#00A758#,
         16#00A75B#, 16#00A75A#, 16#00A75D#, 16#00A75C#, 16#00A75F#,
         16#00A75E#, 16#00A761#, 16#00A760#, 16#00A763#, 16#00A762#,
         16#00A765#, 16#00A764#, 16#00A767#, 16#00A766#, 16#00A769#,
         16#00A768#, 16#00A76B#, 16#00A76A#, 16#00A76D#, 16#00A76C#,
         16#00A76F#, 16#00A76E#, 16#00A77A#, 16#00A779#, 16#00A77C#,
         16#00A77B#, 16#001D79#, 16#00A77F#, 16#00A77E#, 16#00A781#,
         16#00A780#, 16#00A783#, 16#00A782#, 16#00A785#, 16#00A784#,
         16#00A787#, 16#00A786#, 16#00A78C#, 16#00A78B#, 16#000265#,
         16#00A791#, 16#00A790#, 16#00A793#, 16#00A792#, 16#00A797#,
         16#00A796#, 16#00A799#, 16#00A798#, 16#00A79B#, 16#00A79A#,
         16#00A79D#, 16#00A79C#, 16#00A79F#, 16#00A79E#, 16#00A7A1#,
         16#00A7A0#, 16#00A7A3#, 16#00A7A2#, 16#00A7A5#, 16#00A7A4#,
         16#00A7A7#, 16#00A7A6#, 16#00A7A9#, 16#00A7A8#, 16#000266#,
         16#00025C#, 16#000261#, 16#00026C#, 16#00029E#, 16#000287#,
         16#000046#, 16#000066#, 16#000046#, 16#000046#, 16#000066#,
         16#000066#, 16#000046#, 16#000069#, 16#000046#, 16#000049#,
         16#000066#, 16#000069#, 16#000046#, 16#00006C#, 16#000046#,
         16#00004C#, 16#000066#, 16#00006C#, 16#000046#, 16#000066#,
         16#000069#, 16#000046#, 16#000046#, 16#000049#, 16#000066#,
         16#000066#, 16#000069#, 16#000046#, 16#000066#, 16#00006C#,
         16#000046#, 16#000046#, 16#00004C#, 16#000066#, 16#000066#,
         16#00006C#, 16#000053#, 16#000074#, 16#000544#, 16#000576#,
         16#000544#, 16#000546#, 16#000574#, 16#000576#, 16#000544#,
         16#000565#, 16#000544#, 16#000535#, 16#000574#, 16#000565#,
         16#000544#, 16#00056B#, 16#000544#, 16#00053B#, 16#000574#,
         16#00056B#, 16#00054E#, 16#000576#, 16#00054E#, 16#000546#,
         16#00057E#, 16#000576#, 16#000544#, 16#00056D#, 16#000544#,
         16#00053D#, 16#000574#, 16#00056D#, 16#00FF41#, 16#00FF42#,
         16#00FF43#, 16#00FF44#, 16#00FF45#, 16#00FF46#, 16#00FF47#,
         16#00FF48#, 16#00FF49#, 16#00FF4A#, 16#00FF4B#, 16#00FF4C#,
         16#00FF4D#, 16#00FF4E#, 16#00FF4F#, 16#00FF50#, 16#00FF51#,
         16#00FF52#, 16#00FF53#, 16#00FF54#, 16#00FF55#, 16#00FF56#,
         16#00FF57#, 16#00FF58#, 16#00FF59#, 16#00FF5A#, 16#00FF21#,
         16#00FF22#, 16#00FF23#, 16#00FF24#, 16#00FF25#, 16#00FF26#,
         16#00FF27#, 16#00FF28#, 16#00FF29#, 16#00FF2A#, 16#00FF2B#,
         16#00FF2C#, 16#00FF2D#, 16#00FF2E#, 16#00FF2F#, 16#00FF30#,
         16#00FF31#, 16#00FF32#, 16#00FF33#, 16#00FF34#, 16#00FF35#,
         16#00FF36#, 16#00FF37#, 16#00FF38#, 16#00FF39#, 16#00FF3A#,
         16#010428#, 16#010429#, 16#01042A#, 16#01042B#, 16#01042C#,
         16#01042D#, 16#01042E#, 16#01042F#, 16#010430#, 16#010431#,
         16#010432#, 16#010433#, 16#010434#, 16#010435#, 16#010436#,
         16#010437#, 16#010438#, 16#010439#, 16#01043A#, 16#01043B#,
         16#01043C#, 16#01043D#, 16#01043E#, 16#01043F#, 16#010440#,
         16#010441#, 16#010442#, 16#010443#, 16#010444#, 16#010445#,
         16#010446#, 16#010447#, 16#010448#, 16#010449#, 16#01044A#,
         16#01044B#, 16#01044C#, 16#01044D#, 16#01044E#, 16#01044F#,
         16#010400#, 16#010401#, 16#010402#, 16#010403#, 16#010404#,
         16#010405#, 16#010406#, 16#010407#, 16#010408#, 16#010409#,
         16#01040A#, 16#01040B#, 16#01040C#, 16#01040D#, 16#01040E#,
         16#01040F#, 16#010410#, 16#010411#, 16#010412#, 16#010413#,
         16#010414#, 16#010415#, 16#010416#, 16#010417#, 16#010418#,
         16#010419#, 16#01041A#, 16#01041B#, 16#01041C#, 16#01041D#,
         16#01041E#, 16#01041F#, 16#010420#, 16#010421#, 16#010422#,
         16#010423#, 16#010424#, 16#010425#, 16#010426#, 16#010427#,
         16#0118C0#, 16#0118C1#, 16#0118C2#, 16#0118C3#, 16#0118C4#,
         16#0118C5#, 16#0118C6#, 16#0118C7#, 16#0118C8#, 16#0118C9#,
         16#0118CA#, 16#0118CB#, 16#0118CC#, 16#0118CD#, 16#0118CE#,
         16#0118CF#, 16#0118D0#, 16#0118D1#, 16#0118D2#, 16#0118D3#,
         16#0118D4#, 16#0118D5#, 16#0118D6#, 16#0118D7#, 16#0118D8#,
         16#0118D9#, 16#0118DA#, 16#0118DB#, 16#0118DC#, 16#0118DD#,
         16#0118DE#, 16#0118DF#, 16#0118A0#, 16#0118A1#, 16#0118A2#,
         16#0118A3#, 16#0118A4#, 16#0118A5#, 16#0118A6#, 16#0118A7#,
         16#0118A8#, 16#0118A9#, 16#0118AA#, 16#0118AB#, 16#0118AC#,
         16#0118AD#, 16#0118AE#, 16#0118AF#, 16#0118B0#, 16#0118B1#,
         16#0118B2#, 16#0118B3#, 16#0118B4#, 16#0118B5#, 16#0118B6#,
         16#0118B7#, 16#0118B8#, 16#0118B9#, 16#0118BA#, 16#0118BB#,
         16#0118BC#, 16#0118BD#, 16#0118BE#, 16#0118BF#);

   Context : aliased constant Casing_Context_Mapping_Sequence
     := (1 => (Final_Sigma, False, ((519, 519), (0, 0), (0, 0))));

   Group_0000 : aliased constant Case_Mapping_Second_Stage
     := (16#41#           =>  --  0041
          ((16#0061#, 16#0000#, 16#0000#, 16#0061#),
           ((1, 1), (0, 0), (0, 0), (1, 1)), 0, 0),
         16#42#           =>  --  0042
          ((16#0062#, 16#0000#, 16#0000#, 16#0062#),
           ((2, 2), (0, 0), (0, 0), (2, 2)), 0, 0),
         16#43#           =>  --  0043
          ((16#0063#, 16#0000#, 16#0000#, 16#0063#),
           ((3, 3), (0, 0), (0, 0), (3, 3)), 0, 0),
         16#44#           =>  --  0044
          ((16#0064#, 16#0000#, 16#0000#, 16#0064#),
           ((4, 4), (0, 0), (0, 0), (4, 4)), 0, 0),
         16#45#           =>  --  0045
          ((16#0065#, 16#0000#, 16#0000#, 16#0065#),
           ((5, 5), (0, 0), (0, 0), (5, 5)), 0, 0),
         16#46#           =>  --  0046
          ((16#0066#, 16#0000#, 16#0000#, 16#0066#),
           ((6, 6), (0, 0), (0, 0), (6, 6)), 0, 0),
         16#47#           =>  --  0047
          ((16#0067#, 16#0000#, 16#0000#, 16#0067#),
           ((7, 7), (0, 0), (0, 0), (7, 7)), 0, 0),
         16#48#           =>  --  0048
          ((16#0068#, 16#0000#, 16#0000#, 16#0068#),
           ((8, 8), (0, 0), (0, 0), (8, 8)), 0, 0),
         16#49#           =>  --  0049
          ((16#0069#, 16#0000#, 16#0000#, 16#0069#),
           ((9, 9), (0, 0), (0, 0), (9, 9)), 0, 0),
         16#4A#           =>  --  004A
          ((16#006A#, 16#0000#, 16#0000#, 16#006A#),
           ((10, 10), (0, 0), (0, 0), (10, 10)), 0, 0),
         16#4B#           =>  --  004B
          ((16#006B#, 16#0000#, 16#0000#, 16#006B#),
           ((11, 11), (0, 0), (0, 0), (11, 11)), 0, 0),
         16#4C#           =>  --  004C
          ((16#006C#, 16#0000#, 16#0000#, 16#006C#),
           ((12, 12), (0, 0), (0, 0), (12, 12)), 0, 0),
         16#4D#           =>  --  004D
          ((16#006D#, 16#0000#, 16#0000#, 16#006D#),
           ((13, 13), (0, 0), (0, 0), (13, 13)), 0, 0),
         16#4E#           =>  --  004E
          ((16#006E#, 16#0000#, 16#0000#, 16#006E#),
           ((14, 14), (0, 0), (0, 0), (14, 14)), 0, 0),
         16#4F#           =>  --  004F
          ((16#006F#, 16#0000#, 16#0000#, 16#006F#),
           ((15, 15), (0, 0), (0, 0), (15, 15)), 0, 0),
         16#50#           =>  --  0050
          ((16#0070#, 16#0000#, 16#0000#, 16#0070#),
           ((16, 16), (0, 0), (0, 0), (16, 16)), 0, 0),
         16#51#           =>  --  0051
          ((16#0071#, 16#0000#, 16#0000#, 16#0071#),
           ((17, 17), (0, 0), (0, 0), (17, 17)), 0, 0),
         16#52#           =>  --  0052
          ((16#0072#, 16#0000#, 16#0000#, 16#0072#),
           ((18, 18), (0, 0), (0, 0), (18, 18)), 0, 0),
         16#53#           =>  --  0053
          ((16#0073#, 16#0000#, 16#0000#, 16#0073#),
           ((19, 19), (0, 0), (0, 0), (19, 19)), 0, 0),
         16#54#           =>  --  0054
          ((16#0074#, 16#0000#, 16#0000#, 16#0074#),
           ((20, 20), (0, 0), (0, 0), (20, 20)), 0, 0),
         16#55#           =>  --  0055
          ((16#0075#, 16#0000#, 16#0000#, 16#0075#),
           ((21, 21), (0, 0), (0, 0), (21, 21)), 0, 0),
         16#56#           =>  --  0056
          ((16#0076#, 16#0000#, 16#0000#, 16#0076#),
           ((22, 22), (0, 0), (0, 0), (22, 22)), 0, 0),
         16#57#           =>  --  0057
          ((16#0077#, 16#0000#, 16#0000#, 16#0077#),
           ((23, 23), (0, 0), (0, 0), (23, 23)), 0, 0),
         16#58#           =>  --  0058
          ((16#0078#, 16#0000#, 16#0000#, 16#0078#),
           ((24, 24), (0, 0), (0, 0), (24, 24)), 0, 0),
         16#59#           =>  --  0059
          ((16#0079#, 16#0000#, 16#0000#, 16#0079#),
           ((25, 25), (0, 0), (0, 0), (25, 25)), 0, 0),
         16#5A#           =>  --  005A
          ((16#007A#, 16#0000#, 16#0000#, 16#007A#),
           ((26, 26), (0, 0), (0, 0), (26, 26)), 0, 0),
         16#61#           =>  --  0061
          ((16#0000#, 16#0041#, 16#0041#, 16#0000#),
           ((0, 0), (27, 27), (27, 27), (0, 0)), 0, 0),
         16#62#           =>  --  0062
          ((16#0000#, 16#0042#, 16#0042#, 16#0000#),
           ((0, 0), (28, 28), (28, 28), (0, 0)), 0, 0),
         16#63#           =>  --  0063
          ((16#0000#, 16#0043#, 16#0043#, 16#0000#),
           ((0, 0), (29, 29), (29, 29), (0, 0)), 0, 0),
         16#64#           =>  --  0064
          ((16#0000#, 16#0044#, 16#0044#, 16#0000#),
           ((0, 0), (30, 30), (30, 30), (0, 0)), 0, 0),
         16#65#           =>  --  0065
          ((16#0000#, 16#0045#, 16#0045#, 16#0000#),
           ((0, 0), (31, 31), (31, 31), (0, 0)), 0, 0),
         16#66#           =>  --  0066
          ((16#0000#, 16#0046#, 16#0046#, 16#0000#),
           ((0, 0), (32, 32), (32, 32), (0, 0)), 0, 0),
         16#67#           =>  --  0067
          ((16#0000#, 16#0047#, 16#0047#, 16#0000#),
           ((0, 0), (33, 33), (33, 33), (0, 0)), 0, 0),
         16#68#           =>  --  0068
          ((16#0000#, 16#0048#, 16#0048#, 16#0000#),
           ((0, 0), (34, 34), (34, 34), (0, 0)), 0, 0),
         16#69#           =>  --  0069
          ((16#0000#, 16#0049#, 16#0049#, 16#0000#),
           ((0, 0), (35, 35), (35, 35), (0, 0)), 0, 0),
         16#6A#           =>  --  006A
          ((16#0000#, 16#004A#, 16#004A#, 16#0000#),
           ((0, 0), (36, 36), (36, 36), (0, 0)), 0, 0),
         16#6B#           =>  --  006B
          ((16#0000#, 16#004B#, 16#004B#, 16#0000#),
           ((0, 0), (37, 37), (37, 37), (0, 0)), 0, 0),
         16#6C#           =>  --  006C
          ((16#0000#, 16#004C#, 16#004C#, 16#0000#),
           ((0, 0), (38, 38), (38, 38), (0, 0)), 0, 0),
         16#6D#           =>  --  006D
          ((16#0000#, 16#004D#, 16#004D#, 16#0000#),
           ((0, 0), (39, 39), (39, 39), (0, 0)), 0, 0),
         16#6E#           =>  --  006E
          ((16#0000#, 16#004E#, 16#004E#, 16#0000#),
           ((0, 0), (40, 40), (40, 40), (0, 0)), 0, 0),
         16#6F#           =>  --  006F
          ((16#0000#, 16#004F#, 16#004F#, 16#0000#),
           ((0, 0), (41, 41), (41, 41), (0, 0)), 0, 0),
         16#70#           =>  --  0070
          ((16#0000#, 16#0050#, 16#0050#, 16#0000#),
           ((0, 0), (42, 42), (42, 42), (0, 0)), 0, 0),
         16#71#           =>  --  0071
          ((16#0000#, 16#0051#, 16#0051#, 16#0000#),
           ((0, 0), (43, 43), (43, 43), (0, 0)), 0, 0),
         16#72#           =>  --  0072
          ((16#0000#, 16#0052#, 16#0052#, 16#0000#),
           ((0, 0), (44, 44), (44, 44), (0, 0)), 0, 0),
         16#73#           =>  --  0073
          ((16#0000#, 16#0053#, 16#0053#, 16#0000#),
           ((0, 0), (45, 45), (45, 45), (0, 0)), 0, 0),
         16#74#           =>  --  0074
          ((16#0000#, 16#0054#, 16#0054#, 16#0000#),
           ((0, 0), (46, 46), (46, 46), (0, 0)), 0, 0),
         16#75#           =>  --  0075
          ((16#0000#, 16#0055#, 16#0055#, 16#0000#),
           ((0, 0), (47, 47), (47, 47), (0, 0)), 0, 0),
         16#76#           =>  --  0076
          ((16#0000#, 16#0056#, 16#0056#, 16#0000#),
           ((0, 0), (48, 48), (48, 48), (0, 0)), 0, 0),
         16#77#           =>  --  0077
          ((16#0000#, 16#0057#, 16#0057#, 16#0000#),
           ((0, 0), (49, 49), (49, 49), (0, 0)), 0, 0),
         16#78#           =>  --  0078
          ((16#0000#, 16#0058#, 16#0058#, 16#0000#),
           ((0, 0), (50, 50), (50, 50), (0, 0)), 0, 0),
         16#79#           =>  --  0079
          ((16#0000#, 16#0059#, 16#0059#, 16#0000#),
           ((0, 0), (51, 51), (51, 51), (0, 0)), 0, 0),
         16#7A#           =>  --  007A
          ((16#0000#, 16#005A#, 16#005A#, 16#0000#),
           ((0, 0), (52, 52), (52, 52), (0, 0)), 0, 0),
         16#B5#           =>  --  00B5
          ((16#0000#, 16#039C#, 16#039C#, 16#03BC#),
           ((0, 0), (53, 53), (53, 53), (54, 54)), 0, 0),
         16#C0#           =>  --  00C0
          ((16#00E0#, 16#0000#, 16#0000#, 16#00E0#),
           ((55, 55), (0, 0), (0, 0), (55, 55)), 0, 0),
         16#C1#           =>  --  00C1
          ((16#00E1#, 16#0000#, 16#0000#, 16#00E1#),
           ((56, 56), (0, 0), (0, 0), (56, 56)), 0, 0),
         16#C2#           =>  --  00C2
          ((16#00E2#, 16#0000#, 16#0000#, 16#00E2#),
           ((57, 57), (0, 0), (0, 0), (57, 57)), 0, 0),
         16#C3#           =>  --  00C3
          ((16#00E3#, 16#0000#, 16#0000#, 16#00E3#),
           ((58, 58), (0, 0), (0, 0), (58, 58)), 0, 0),
         16#C4#           =>  --  00C4
          ((16#00E4#, 16#0000#, 16#0000#, 16#00E4#),
           ((59, 59), (0, 0), (0, 0), (59, 59)), 0, 0),
         16#C5#           =>  --  00C5
          ((16#00E5#, 16#0000#, 16#0000#, 16#00E5#),
           ((60, 60), (0, 0), (0, 0), (60, 60)), 0, 0),
         16#C6#           =>  --  00C6
          ((16#00E6#, 16#0000#, 16#0000#, 16#00E6#),
           ((61, 61), (0, 0), (0, 0), (61, 61)), 0, 0),
         16#C7#           =>  --  00C7
          ((16#00E7#, 16#0000#, 16#0000#, 16#00E7#),
           ((62, 62), (0, 0), (0, 0), (62, 62)), 0, 0),
         16#C8#           =>  --  00C8
          ((16#00E8#, 16#0000#, 16#0000#, 16#00E8#),
           ((63, 63), (0, 0), (0, 0), (63, 63)), 0, 0),
         16#C9#           =>  --  00C9
          ((16#00E9#, 16#0000#, 16#0000#, 16#00E9#),
           ((64, 64), (0, 0), (0, 0), (64, 64)), 0, 0),
         16#CA#           =>  --  00CA
          ((16#00EA#, 16#0000#, 16#0000#, 16#00EA#),
           ((65, 65), (0, 0), (0, 0), (65, 65)), 0, 0),
         16#CB#           =>  --  00CB
          ((16#00EB#, 16#0000#, 16#0000#, 16#00EB#),
           ((66, 66), (0, 0), (0, 0), (66, 66)), 0, 0),
         16#CC#           =>  --  00CC
          ((16#00EC#, 16#0000#, 16#0000#, 16#00EC#),
           ((67, 67), (0, 0), (0, 0), (67, 67)), 0, 0),
         16#CD#           =>  --  00CD
          ((16#00ED#, 16#0000#, 16#0000#, 16#00ED#),
           ((68, 68), (0, 0), (0, 0), (68, 68)), 0, 0),
         16#CE#           =>  --  00CE
          ((16#00EE#, 16#0000#, 16#0000#, 16#00EE#),
           ((69, 69), (0, 0), (0, 0), (69, 69)), 0, 0),
         16#CF#           =>  --  00CF
          ((16#00EF#, 16#0000#, 16#0000#, 16#00EF#),
           ((70, 70), (0, 0), (0, 0), (70, 70)), 0, 0),
         16#D0#           =>  --  00D0
          ((16#00F0#, 16#0000#, 16#0000#, 16#00F0#),
           ((71, 71), (0, 0), (0, 0), (71, 71)), 0, 0),
         16#D1#           =>  --  00D1
          ((16#00F1#, 16#0000#, 16#0000#, 16#00F1#),
           ((72, 72), (0, 0), (0, 0), (72, 72)), 0, 0),
         16#D2#           =>  --  00D2
          ((16#00F2#, 16#0000#, 16#0000#, 16#00F2#),
           ((73, 73), (0, 0), (0, 0), (73, 73)), 0, 0),
         16#D3#           =>  --  00D3
          ((16#00F3#, 16#0000#, 16#0000#, 16#00F3#),
           ((74, 74), (0, 0), (0, 0), (74, 74)), 0, 0),
         16#D4#           =>  --  00D4
          ((16#00F4#, 16#0000#, 16#0000#, 16#00F4#),
           ((75, 75), (0, 0), (0, 0), (75, 75)), 0, 0),
         16#D5#           =>  --  00D5
          ((16#00F5#, 16#0000#, 16#0000#, 16#00F5#),
           ((76, 76), (0, 0), (0, 0), (76, 76)), 0, 0),
         16#D6#           =>  --  00D6
          ((16#00F6#, 16#0000#, 16#0000#, 16#00F6#),
           ((77, 77), (0, 0), (0, 0), (77, 77)), 0, 0),
         16#D8#           =>  --  00D8
          ((16#00F8#, 16#0000#, 16#0000#, 16#00F8#),
           ((78, 78), (0, 0), (0, 0), (78, 78)), 0, 0),
         16#D9#           =>  --  00D9
          ((16#00F9#, 16#0000#, 16#0000#, 16#00F9#),
           ((79, 79), (0, 0), (0, 0), (79, 79)), 0, 0),
         16#DA#           =>  --  00DA
          ((16#00FA#, 16#0000#, 16#0000#, 16#00FA#),
           ((80, 80), (0, 0), (0, 0), (80, 80)), 0, 0),
         16#DB#           =>  --  00DB
          ((16#00FB#, 16#0000#, 16#0000#, 16#00FB#),
           ((81, 81), (0, 0), (0, 0), (81, 81)), 0, 0),
         16#DC#           =>  --  00DC
          ((16#00FC#, 16#0000#, 16#0000#, 16#00FC#),
           ((82, 82), (0, 0), (0, 0), (82, 82)), 0, 0),
         16#DD#           =>  --  00DD
          ((16#00FD#, 16#0000#, 16#0000#, 16#00FD#),
           ((83, 83), (0, 0), (0, 0), (83, 83)), 0, 0),
         16#DE#           =>  --  00DE
          ((16#00FE#, 16#0000#, 16#0000#, 16#00FE#),
           ((84, 84), (0, 0), (0, 0), (84, 84)), 0, 0),
         16#DF#           =>  --  00DF
          ((16#0000#, 16#0000#, 16#0000#, 16#0000#),
           ((0, 0), (85, 86), (87, 88), (89, 90)), 0, 0),
         16#E0#           =>  --  00E0
          ((16#0000#, 16#00C0#, 16#00C0#, 16#0000#),
           ((0, 0), (91, 91), (91, 91), (0, 0)), 0, 0),
         16#E1#           =>  --  00E1
          ((16#0000#, 16#00C1#, 16#00C1#, 16#0000#),
           ((0, 0), (92, 92), (92, 92), (0, 0)), 0, 0),
         16#E2#           =>  --  00E2
          ((16#0000#, 16#00C2#, 16#00C2#, 16#0000#),
           ((0, 0), (93, 93), (93, 93), (0, 0)), 0, 0),
         16#E3#           =>  --  00E3
          ((16#0000#, 16#00C3#, 16#00C3#, 16#0000#),
           ((0, 0), (94, 94), (94, 94), (0, 0)), 0, 0),
         16#E4#           =>  --  00E4
          ((16#0000#, 16#00C4#, 16#00C4#, 16#0000#),
           ((0, 0), (95, 95), (95, 95), (0, 0)), 0, 0),
         16#E5#           =>  --  00E5
          ((16#0000#, 16#00C5#, 16#00C5#, 16#0000#),
           ((0, 0), (96, 96), (96, 96), (0, 0)), 0, 0),
         16#E6#           =>  --  00E6
          ((16#0000#, 16#00C6#, 16#00C6#, 16#0000#),
           ((0, 0), (97, 97), (97, 97), (0, 0)), 0, 0),
         16#E7#           =>  --  00E7
          ((16#0000#, 16#00C7#, 16#00C7#, 16#0000#),
           ((0, 0), (98, 98), (98, 98), (0, 0)), 0, 0),
         16#E8#           =>  --  00E8
          ((16#0000#, 16#00C8#, 16#00C8#, 16#0000#),
           ((0, 0), (99, 99), (99, 99), (0, 0)), 0, 0),
         16#E9#           =>  --  00E9
          ((16#0000#, 16#00C9#, 16#00C9#, 16#0000#),
           ((0, 0), (100, 100), (100, 100), (0, 0)), 0, 0),
         16#EA#           =>  --  00EA
          ((16#0000#, 16#00CA#, 16#00CA#, 16#0000#),
           ((0, 0), (101, 101), (101, 101), (0, 0)), 0, 0),
         16#EB#           =>  --  00EB
          ((16#0000#, 16#00CB#, 16#00CB#, 16#0000#),
           ((0, 0), (102, 102), (102, 102), (0, 0)), 0, 0),
         16#EC#           =>  --  00EC
          ((16#0000#, 16#00CC#, 16#00CC#, 16#0000#),
           ((0, 0), (103, 103), (103, 103), (0, 0)), 0, 0),
         16#ED#           =>  --  00ED
          ((16#0000#, 16#00CD#, 16#00CD#, 16#0000#),
           ((0, 0), (104, 104), (104, 104), (0, 0)), 0, 0),
         16#EE#           =>  --  00EE
          ((16#0000#, 16#00CE#, 16#00CE#, 16#0000#),
           ((0, 0), (105, 105), (105, 105), (0, 0)), 0, 0),
         16#EF#           =>  --  00EF
          ((16#0000#, 16#00CF#, 16#00CF#, 16#0000#),
           ((0, 0), (106, 106), (106, 106), (0, 0)), 0, 0),
         16#F0#           =>  --  00F0
          ((16#0000#, 16#00D0#, 16#00D0#, 16#0000#),
           ((0, 0), (107, 107), (107, 107), (0, 0)), 0, 0),
         16#F1#           =>  --  00F1
          ((16#0000#, 16#00D1#, 16#00D1#, 16#0000#),
           ((0, 0), (108, 108), (108, 108), (0, 0)), 0, 0),
         16#F2#           =>  --  00F2
          ((16#0000#, 16#00D2#, 16#00D2#, 16#0000#),
           ((0, 0), (109, 109), (109, 109), (0, 0)), 0, 0),
         16#F3#           =>  --  00F3
          ((16#0000#, 16#00D3#, 16#00D3#, 16#0000#),
           ((0, 0), (110, 110), (110, 110), (0, 0)), 0, 0),
         16#F4#           =>  --  00F4
          ((16#0000#, 16#00D4#, 16#00D4#, 16#0000#),
           ((0, 0), (111, 111), (111, 111), (0, 0)), 0, 0),
         16#F5#           =>  --  00F5
          ((16#0000#, 16#00D5#, 16#00D5#, 16#0000#),
           ((0, 0), (112, 112), (112, 112), (0, 0)), 0, 0),
         16#F6#           =>  --  00F6
          ((16#0000#, 16#00D6#, 16#00D6#, 16#0000#),
           ((0, 0), (113, 113), (113, 113), (0, 0)), 0, 0),
         16#F8#           =>  --  00F8
          ((16#0000#, 16#00D8#, 16#00D8#, 16#0000#),
           ((0, 0), (114, 114), (114, 114), (0, 0)), 0, 0),
         16#F9#           =>  --  00F9
          ((16#0000#, 16#00D9#, 16#00D9#, 16#0000#),
           ((0, 0), (115, 115), (115, 115), (0, 0)), 0, 0),
         16#FA#           =>  --  00FA
          ((16#0000#, 16#00DA#, 16#00DA#, 16#0000#),
           ((0, 0), (116, 116), (116, 116), (0, 0)), 0, 0),
         16#FB#           =>  --  00FB
          ((16#0000#, 16#00DB#, 16#00DB#, 16#0000#),
           ((0, 0), (117, 117), (117, 117), (0, 0)), 0, 0),
         16#FC#           =>  --  00FC
          ((16#0000#, 16#00DC#, 16#00DC#, 16#0000#),
           ((0, 0), (118, 118), (118, 118), (0, 0)), 0, 0),
         16#FD#           =>  --  00FD
          ((16#0000#, 16#00DD#, 16#00DD#, 16#0000#),
           ((0, 0), (119, 119), (119, 119), (0, 0)), 0, 0),
         16#FE#           =>  --  00FE
          ((16#0000#, 16#00DE#, 16#00DE#, 16#0000#),
           ((0, 0), (120, 120), (120, 120), (0, 0)), 0, 0),
         16#FF#           =>  --  00FF
          ((16#0000#, 16#0178#, 16#0178#, 16#0000#),
           ((0, 0), (121, 121), (121, 121), (0, 0)), 0, 0),
         others           =>
          ((16#0000#, 16#0000#, 16#0000#, 16#0000#),
           ((0, 0), (0, 0), (0, 0), (0, 0)), 0, 0));

   Group_0001 : aliased constant Case_Mapping_Second_Stage
     := (16#00#           =>  --  0100
          ((16#0101#, 16#0000#, 16#0000#, 16#0101#),
           ((122, 122), (0, 0), (0, 0), (122, 122)), 0, 0),
         16#01#           =>  --  0101
          ((16#0000#, 16#0100#, 16#0100#, 16#0000#),
           ((0, 0), (123, 123), (123, 123), (0, 0)), 0, 0),
         16#02#           =>  --  0102
          ((16#0103#, 16#0000#, 16#0000#, 16#0103#),
           ((124, 124), (0, 0), (0, 0), (124, 124)), 0, 0),
         16#03#           =>  --  0103
          ((16#0000#, 16#0102#, 16#0102#, 16#0000#),
           ((0, 0), (125, 125), (125, 125), (0, 0)), 0, 0),
         16#04#           =>  --  0104
          ((16#0105#, 16#0000#, 16#0000#, 16#0105#),
           ((126, 126), (0, 0), (0, 0), (126, 126)), 0, 0),
         16#05#           =>  --  0105
          ((16#0000#, 16#0104#, 16#0104#, 16#0000#),
           ((0, 0), (127, 127), (127, 127), (0, 0)), 0, 0),
         16#06#           =>  --  0106
          ((16#0107#, 16#0000#, 16#0000#, 16#0107#),
           ((128, 128), (0, 0), (0, 0), (128, 128)), 0, 0),
         16#07#           =>  --  0107
          ((16#0000#, 16#0106#, 16#0106#, 16#0000#),
           ((0, 0), (129, 129), (129, 129), (0, 0)), 0, 0),
         16#08#           =>  --  0108
          ((16#0109#, 16#0000#, 16#0000#, 16#0109#),
           ((130, 130), (0, 0), (0, 0), (130, 130)), 0, 0),
         16#09#           =>  --  0109
          ((16#0000#, 16#0108#, 16#0108#, 16#0000#),
           ((0, 0), (131, 131), (131, 131), (0, 0)), 0, 0),
         16#0A#           =>  --  010A
          ((16#010B#, 16#0000#, 16#0000#, 16#010B#),
           ((132, 132), (0, 0), (0, 0), (132, 132)), 0, 0),
         16#0B#           =>  --  010B
          ((16#0000#, 16#010A#, 16#010A#, 16#0000#),
           ((0, 0), (133, 133), (133, 133), (0, 0)), 0, 0),
         16#0C#           =>  --  010C
          ((16#010D#, 16#0000#, 16#0000#, 16#010D#),
           ((134, 134), (0, 0), (0, 0), (134, 134)), 0, 0),
         16#0D#           =>  --  010D
          ((16#0000#, 16#010C#, 16#010C#, 16#0000#),
           ((0, 0), (135, 135), (135, 135), (0, 0)), 0, 0),
         16#0E#           =>  --  010E
          ((16#010F#, 16#0000#, 16#0000#, 16#010F#),
           ((136, 136), (0, 0), (0, 0), (136, 136)), 0, 0),
         16#0F#           =>  --  010F
          ((16#0000#, 16#010E#, 16#010E#, 16#0000#),
           ((0, 0), (137, 137), (137, 137), (0, 0)), 0, 0),
         16#10#           =>  --  0110
          ((16#0111#, 16#0000#, 16#0000#, 16#0111#),
           ((138, 138), (0, 0), (0, 0), (138, 138)), 0, 0),
         16#11#           =>  --  0111
          ((16#0000#, 16#0110#, 16#0110#, 16#0000#),
           ((0, 0), (139, 139), (139, 139), (0, 0)), 0, 0),
         16#12#           =>  --  0112
          ((16#0113#, 16#0000#, 16#0000#, 16#0113#),
           ((140, 140), (0, 0), (0, 0), (140, 140)), 0, 0),
         16#13#           =>  --  0113
          ((16#0000#, 16#0112#, 16#0112#, 16#0000#),
           ((0, 0), (141, 141), (141, 141), (0, 0)), 0, 0),
         16#14#           =>  --  0114
          ((16#0115#, 16#0000#, 16#0000#, 16#0115#),
           ((142, 142), (0, 0), (0, 0), (142, 142)), 0, 0),
         16#15#           =>  --  0115
          ((16#0000#, 16#0114#, 16#0114#, 16#0000#),
           ((0, 0), (143, 143), (143, 143), (0, 0)), 0, 0),
         16#16#           =>  --  0116
          ((16#0117#, 16#0000#, 16#0000#, 16#0117#),
           ((144, 144), (0, 0), (0, 0), (144, 144)), 0, 0),
         16#17#           =>  --  0117
          ((16#0000#, 16#0116#, 16#0116#, 16#0000#),
           ((0, 0), (145, 145), (145, 145), (0, 0)), 0, 0),
         16#18#           =>  --  0118
          ((16#0119#, 16#0000#, 16#0000#, 16#0119#),
           ((146, 146), (0, 0), (0, 0), (146, 146)), 0, 0),
         16#19#           =>  --  0119
          ((16#0000#, 16#0118#, 16#0118#, 16#0000#),
           ((0, 0), (147, 147), (147, 147), (0, 0)), 0, 0),
         16#1A#           =>  --  011A
          ((16#011B#, 16#0000#, 16#0000#, 16#011B#),
           ((148, 148), (0, 0), (0, 0), (148, 148)), 0, 0),
         16#1B#           =>  --  011B
          ((16#0000#, 16#011A#, 16#011A#, 16#0000#),
           ((0, 0), (149, 149), (149, 149), (0, 0)), 0, 0),
         16#1C#           =>  --  011C
          ((16#011D#, 16#0000#, 16#0000#, 16#011D#),
           ((150, 150), (0, 0), (0, 0), (150, 150)), 0, 0),
         16#1D#           =>  --  011D
          ((16#0000#, 16#011C#, 16#011C#, 16#0000#),
           ((0, 0), (151, 151), (151, 151), (0, 0)), 0, 0),
         16#1E#           =>  --  011E
          ((16#011F#, 16#0000#, 16#0000#, 16#011F#),
           ((152, 152), (0, 0), (0, 0), (152, 152)), 0, 0),
         16#1F#           =>  --  011F
          ((16#0000#, 16#011E#, 16#011E#, 16#0000#),
           ((0, 0), (153, 153), (153, 153), (0, 0)), 0, 0),
         16#20#           =>  --  0120
          ((16#0121#, 16#0000#, 16#0000#, 16#0121#),
           ((154, 154), (0, 0), (0, 0), (154, 154)), 0, 0),
         16#21#           =>  --  0121
          ((16#0000#, 16#0120#, 16#0120#, 16#0000#),
           ((0, 0), (155, 155), (155, 155), (0, 0)), 0, 0),
         16#22#           =>  --  0122
          ((16#0123#, 16#0000#, 16#0000#, 16#0123#),
           ((156, 156), (0, 0), (0, 0), (156, 156)), 0, 0),
         16#23#           =>  --  0123
          ((16#0000#, 16#0122#, 16#0122#, 16#0000#),
           ((0, 0), (157, 157), (157, 157), (0, 0)), 0, 0),
         16#24#           =>  --  0124
          ((16#0125#, 16#0000#, 16#0000#, 16#0125#),
           ((158, 158), (0, 0), (0, 0), (158, 158)), 0, 0),
         16#25#           =>  --  0125
          ((16#0000#, 16#0124#, 16#0124#, 16#0000#),
           ((0, 0), (159, 159), (159, 159), (0, 0)), 0, 0),
         16#26#           =>  --  0126
          ((16#0127#, 16#0000#, 16#0000#, 16#0127#),
           ((160, 160), (0, 0), (0, 0), (160, 160)), 0, 0),
         16#27#           =>  --  0127
          ((16#0000#, 16#0126#, 16#0126#, 16#0000#),
           ((0, 0), (161, 161), (161, 161), (0, 0)), 0, 0),
         16#28#           =>  --  0128
          ((16#0129#, 16#0000#, 16#0000#, 16#0129#),
           ((162, 162), (0, 0), (0, 0), (162, 162)), 0, 0),
         16#29#           =>  --  0129
          ((16#0000#, 16#0128#, 16#0128#, 16#0000#),
           ((0, 0), (163, 163), (163, 163), (0, 0)), 0, 0),
         16#2A#           =>  --  012A
          ((16#012B#, 16#0000#, 16#0000#, 16#012B#),
           ((164, 164), (0, 0), (0, 0), (164, 164)), 0, 0),
         16#2B#           =>  --  012B
          ((16#0000#, 16#012A#, 16#012A#, 16#0000#),
           ((0, 0), (165, 165), (165, 165), (0, 0)), 0, 0),
         16#2C#           =>  --  012C
          ((16#012D#, 16#0000#, 16#0000#, 16#012D#),
           ((166, 166), (0, 0), (0, 0), (166, 166)), 0, 0),
         16#2D#           =>  --  012D
          ((16#0000#, 16#012C#, 16#012C#, 16#0000#),
           ((0, 0), (167, 167), (167, 167), (0, 0)), 0, 0),
         16#2E#           =>  --  012E
          ((16#012F#, 16#0000#, 16#0000#, 16#012F#),
           ((168, 168), (0, 0), (0, 0), (168, 168)), 0, 0),
         16#2F#           =>  --  012F
          ((16#0000#, 16#012E#, 16#012E#, 16#0000#),
           ((0, 0), (169, 169), (169, 169), (0, 0)), 0, 0),
         16#30#           =>  --  0130
          ((16#0069#, 16#0000#, 16#0000#, 16#0000#),
           ((170, 171), (0, 0), (0, 0), (170, 171)), 0, 0),
         16#31#           =>  --  0131
          ((16#0000#, 16#0049#, 16#0049#, 16#0000#),
           ((0, 0), (35, 35), (35, 35), (0, 0)), 0, 0),
         16#32#           =>  --  0132
          ((16#0133#, 16#0000#, 16#0000#, 16#0133#),
           ((172, 172), (0, 0), (0, 0), (172, 172)), 0, 0),
         16#33#           =>  --  0133
          ((16#0000#, 16#0132#, 16#0132#, 16#0000#),
           ((0, 0), (173, 173), (173, 173), (0, 0)), 0, 0),
         16#34#           =>  --  0134
          ((16#0135#, 16#0000#, 16#0000#, 16#0135#),
           ((174, 174), (0, 0), (0, 0), (174, 174)), 0, 0),
         16#35#           =>  --  0135
          ((16#0000#, 16#0134#, 16#0134#, 16#0000#),
           ((0, 0), (175, 175), (175, 175), (0, 0)), 0, 0),
         16#36#           =>  --  0136
          ((16#0137#, 16#0000#, 16#0000#, 16#0137#),
           ((176, 176), (0, 0), (0, 0), (176, 176)), 0, 0),
         16#37#           =>  --  0137
          ((16#0000#, 16#0136#, 16#0136#, 16#0000#),
           ((0, 0), (177, 177), (177, 177), (0, 0)), 0, 0),
         16#39#           =>  --  0139
          ((16#013A#, 16#0000#, 16#0000#, 16#013A#),
           ((178, 178), (0, 0), (0, 0), (178, 178)), 0, 0),
         16#3A#           =>  --  013A
          ((16#0000#, 16#0139#, 16#0139#, 16#0000#),
           ((0, 0), (179, 179), (179, 179), (0, 0)), 0, 0),
         16#3B#           =>  --  013B
          ((16#013C#, 16#0000#, 16#0000#, 16#013C#),
           ((180, 180), (0, 0), (0, 0), (180, 180)), 0, 0),
         16#3C#           =>  --  013C
          ((16#0000#, 16#013B#, 16#013B#, 16#0000#),
           ((0, 0), (181, 181), (181, 181), (0, 0)), 0, 0),
         16#3D#           =>  --  013D
          ((16#013E#, 16#0000#, 16#0000#, 16#013E#),
           ((182, 182), (0, 0), (0, 0), (182, 182)), 0, 0),
         16#3E#           =>  --  013E
          ((16#0000#, 16#013D#, 16#013D#, 16#0000#),
           ((0, 0), (183, 183), (183, 183), (0, 0)), 0, 0),
         16#3F#           =>  --  013F
          ((16#0140#, 16#0000#, 16#0000#, 16#0140#),
           ((184, 184), (0, 0), (0, 0), (184, 184)), 0, 0),
         16#40#           =>  --  0140
          ((16#0000#, 16#013F#, 16#013F#, 16#0000#),
           ((0, 0), (185, 185), (185, 185), (0, 0)), 0, 0),
         16#41#           =>  --  0141
          ((16#0142#, 16#0000#, 16#0000#, 16#0142#),
           ((186, 186), (0, 0), (0, 0), (186, 186)), 0, 0),
         16#42#           =>  --  0142
          ((16#0000#, 16#0141#, 16#0141#, 16#0000#),
           ((0, 0), (187, 187), (187, 187), (0, 0)), 0, 0),
         16#43#           =>  --  0143
          ((16#0144#, 16#0000#, 16#0000#, 16#0144#),
           ((188, 188), (0, 0), (0, 0), (188, 188)), 0, 0),
         16#44#           =>  --  0144
          ((16#0000#, 16#0143#, 16#0143#, 16#0000#),
           ((0, 0), (189, 189), (189, 189), (0, 0)), 0, 0),
         16#45#           =>  --  0145
          ((16#0146#, 16#0000#, 16#0000#, 16#0146#),
           ((190, 190), (0, 0), (0, 0), (190, 190)), 0, 0),
         16#46#           =>  --  0146
          ((16#0000#, 16#0145#, 16#0145#, 16#0000#),
           ((0, 0), (191, 191), (191, 191), (0, 0)), 0, 0),
         16#47#           =>  --  0147
          ((16#0148#, 16#0000#, 16#0000#, 16#0148#),
           ((192, 192), (0, 0), (0, 0), (192, 192)), 0, 0),
         16#48#           =>  --  0148
          ((16#0000#, 16#0147#, 16#0147#, 16#0000#),
           ((0, 0), (193, 193), (193, 193), (0, 0)), 0, 0),
         16#49#           =>  --  0149
          ((16#0000#, 16#0000#, 16#0000#, 16#0000#),
           ((0, 0), (194, 195), (194, 195), (196, 197)), 0, 0),
         16#4A#           =>  --  014A
          ((16#014B#, 16#0000#, 16#0000#, 16#014B#),
           ((198, 198), (0, 0), (0, 0), (198, 198)), 0, 0),
         16#4B#           =>  --  014B
          ((16#0000#, 16#014A#, 16#014A#, 16#0000#),
           ((0, 0), (199, 199), (199, 199), (0, 0)), 0, 0),
         16#4C#           =>  --  014C
          ((16#014D#, 16#0000#, 16#0000#, 16#014D#),
           ((200, 200), (0, 0), (0, 0), (200, 200)), 0, 0),
         16#4D#           =>  --  014D
          ((16#0000#, 16#014C#, 16#014C#, 16#0000#),
           ((0, 0), (201, 201), (201, 201), (0, 0)), 0, 0),
         16#4E#           =>  --  014E
          ((16#014F#, 16#0000#, 16#0000#, 16#014F#),
           ((202, 202), (0, 0), (0, 0), (202, 202)), 0, 0),
         16#4F#           =>  --  014F
          ((16#0000#, 16#014E#, 16#014E#, 16#0000#),
           ((0, 0), (203, 203), (203, 203), (0, 0)), 0, 0),
         16#50#           =>  --  0150
          ((16#0151#, 16#0000#, 16#0000#, 16#0151#),
           ((204, 204), (0, 0), (0, 0), (204, 204)), 0, 0),
         16#51#           =>  --  0151
          ((16#0000#, 16#0150#, 16#0150#, 16#0000#),
           ((0, 0), (205, 205), (205, 205), (0, 0)), 0, 0),
         16#52#           =>  --  0152
          ((16#0153#, 16#0000#, 16#0000#, 16#0153#),
           ((206, 206), (0, 0), (0, 0), (206, 206)), 0, 0),
         16#53#           =>  --  0153
          ((16#0000#, 16#0152#, 16#0152#, 16#0000#),
           ((0, 0), (207, 207), (207, 207), (0, 0)), 0, 0),
         16#54#           =>  --  0154
          ((16#0155#, 16#0000#, 16#0000#, 16#0155#),
           ((208, 208), (0, 0), (0, 0), (208, 208)), 0, 0),
         16#55#           =>  --  0155
          ((16#0000#, 16#0154#, 16#0154#, 16#0000#),
           ((0, 0), (209, 209), (209, 209), (0, 0)), 0, 0),
         16#56#           =>  --  0156
          ((16#0157#, 16#0000#, 16#0000#, 16#0157#),
           ((210, 210), (0, 0), (0, 0), (210, 210)), 0, 0),
         16#57#           =>  --  0157
          ((16#0000#, 16#0156#, 16#0156#, 16#0000#),
           ((0, 0), (211, 211), (211, 211), (0, 0)), 0, 0),
         16#58#           =>  --  0158
          ((16#0159#, 16#0000#, 16#0000#, 16#0159#),
           ((212, 212), (0, 0), (0, 0), (212, 212)), 0, 0),
         16#59#           =>  --  0159
          ((16#0000#, 16#0158#, 16#0158#, 16#0000#),
           ((0, 0), (213, 213), (213, 213), (0, 0)), 0, 0),
         16#5A#           =>  --  015A
          ((16#015B#, 16#0000#, 16#0000#, 16#015B#),
           ((214, 214), (0, 0), (0, 0), (214, 214)), 0, 0),
         16#5B#           =>  --  015B
          ((16#0000#, 16#015A#, 16#015A#, 16#0000#),
           ((0, 0), (215, 215), (215, 215), (0, 0)), 0, 0),
         16#5C#           =>  --  015C
          ((16#015D#, 16#0000#, 16#0000#, 16#015D#),
           ((216, 216), (0, 0), (0, 0), (216, 216)), 0, 0),
         16#5D#           =>  --  015D
          ((16#0000#, 16#015C#, 16#015C#, 16#0000#),
           ((0, 0), (217, 217), (217, 217), (0, 0)), 0, 0),
         16#5E#           =>  --  015E
          ((16#015F#, 16#0000#, 16#0000#, 16#015F#),
           ((218, 218), (0, 0), (0, 0), (218, 218)), 0, 0),
         16#5F#           =>  --  015F
          ((16#0000#, 16#015E#, 16#015E#, 16#0000#),
           ((0, 0), (219, 219), (219, 219), (0, 0)), 0, 0),
         16#60#           =>  --  0160
          ((16#0161#, 16#0000#, 16#0000#, 16#0161#),
           ((220, 220), (0, 0), (0, 0), (220, 220)), 0, 0),
         16#61#           =>  --  0161
          ((16#0000#, 16#0160#, 16#0160#, 16#0000#),
           ((0, 0), (221, 221), (221, 221), (0, 0)), 0, 0),
         16#62#           =>  --  0162
          ((16#0163#, 16#0000#, 16#0000#, 16#0163#),
           ((222, 222), (0, 0), (0, 0), (222, 222)), 0, 0),
         16#63#           =>  --  0163
          ((16#0000#, 16#0162#, 16#0162#, 16#0000#),
           ((0, 0), (223, 223), (223, 223), (0, 0)), 0, 0),
         16#64#           =>  --  0164
          ((16#0165#, 16#0000#, 16#0000#, 16#0165#),
           ((224, 224), (0, 0), (0, 0), (224, 224)), 0, 0),
         16#65#           =>  --  0165
          ((16#0000#, 16#0164#, 16#0164#, 16#0000#),
           ((0, 0), (225, 225), (225, 225), (0, 0)), 0, 0),
         16#66#           =>  --  0166
          ((16#0167#, 16#0000#, 16#0000#, 16#0167#),
           ((226, 226), (0, 0), (0, 0), (226, 226)), 0, 0),
         16#67#           =>  --  0167
          ((16#0000#, 16#0166#, 16#0166#, 16#0000#),
           ((0, 0), (227, 227), (227, 227), (0, 0)), 0, 0),
         16#68#           =>  --  0168
          ((16#0169#, 16#0000#, 16#0000#, 16#0169#),
           ((228, 228), (0, 0), (0, 0), (228, 228)), 0, 0),
         16#69#           =>  --  0169
          ((16#0000#, 16#0168#, 16#0168#, 16#0000#),
           ((0, 0), (229, 229), (229, 229), (0, 0)), 0, 0),
         16#6A#           =>  --  016A
          ((16#016B#, 16#0000#, 16#0000#, 16#016B#),
           ((230, 230), (0, 0), (0, 0), (230, 230)), 0, 0),
         16#6B#           =>  --  016B
          ((16#0000#, 16#016A#, 16#016A#, 16#0000#),
           ((0, 0), (231, 231), (231, 231), (0, 0)), 0, 0),
         16#6C#           =>  --  016C
          ((16#016D#, 16#0000#, 16#0000#, 16#016D#),
           ((232, 232), (0, 0), (0, 0), (232, 232)), 0, 0),
         16#6D#           =>  --  016D
          ((16#0000#, 16#016C#, 16#016C#, 16#0000#),
           ((0, 0), (233, 233), (233, 233), (0, 0)), 0, 0),
         16#6E#           =>  --  016E
          ((16#016F#, 16#0000#, 16#0000#, 16#016F#),
           ((234, 234), (0, 0), (0, 0), (234, 234)), 0, 0),
         16#6F#           =>  --  016F
          ((16#0000#, 16#016E#, 16#016E#, 16#0000#),
           ((0, 0), (235, 235), (235, 235), (0, 0)), 0, 0),
         16#70#           =>  --  0170
          ((16#0171#, 16#0000#, 16#0000#, 16#0171#),
           ((236, 236), (0, 0), (0, 0), (236, 236)), 0, 0),
         16#71#           =>  --  0171
          ((16#0000#, 16#0170#, 16#0170#, 16#0000#),
           ((0, 0), (237, 237), (237, 237), (0, 0)), 0, 0),
         16#72#           =>  --  0172
          ((16#0173#, 16#0000#, 16#0000#, 16#0173#),
           ((238, 238), (0, 0), (0, 0), (238, 238)), 0, 0),
         16#73#           =>  --  0173
          ((16#0000#, 16#0172#, 16#0172#, 16#0000#),
           ((0, 0), (239, 239), (239, 239), (0, 0)), 0, 0),
         16#74#           =>  --  0174
          ((16#0175#, 16#0000#, 16#0000#, 16#0175#),
           ((240, 240), (0, 0), (0, 0), (240, 240)), 0, 0),
         16#75#           =>  --  0175
          ((16#0000#, 16#0174#, 16#0174#, 16#0000#),
           ((0, 0), (241, 241), (241, 241), (0, 0)), 0, 0),
         16#76#           =>  --  0176
          ((16#0177#, 16#0000#, 16#0000#, 16#0177#),
           ((242, 242), (0, 0), (0, 0), (242, 242)), 0, 0),
         16#77#           =>  --  0177
          ((16#0000#, 16#0176#, 16#0176#, 16#0000#),
           ((0, 0), (243, 243), (243, 243), (0, 0)), 0, 0),
         16#78#           =>  --  0178
          ((16#00FF#, 16#0000#, 16#0000#, 16#00FF#),
           ((244, 244), (0, 0), (0, 0), (244, 244)), 0, 0),
         16#79#           =>  --  0179
          ((16#017A#, 16#0000#, 16#0000#, 16#017A#),
           ((245, 245), (0, 0), (0, 0), (245, 245)), 0, 0),
         16#7A#           =>  --  017A
          ((16#0000#, 16#0179#, 16#0179#, 16#0000#),
           ((0, 0), (246, 246), (246, 246), (0, 0)), 0, 0),
         16#7B#           =>  --  017B
          ((16#017C#, 16#0000#, 16#0000#, 16#017C#),
           ((247, 247), (0, 0), (0, 0), (247, 247)), 0, 0),
         16#7C#           =>  --  017C
          ((16#0000#, 16#017B#, 16#017B#, 16#0000#),
           ((0, 0), (248, 248), (248, 248), (0, 0)), 0, 0),
         16#7D#           =>  --  017D
          ((16#017E#, 16#0000#, 16#0000#, 16#017E#),
           ((249, 249), (0, 0), (0, 0), (249, 249)), 0, 0),
         16#7E#           =>  --  017E
          ((16#0000#, 16#017D#, 16#017D#, 16#0000#),
           ((0, 0), (250, 250), (250, 250), (0, 0)), 0, 0),
         16#7F#           =>  --  017F
          ((16#0000#, 16#0053#, 16#0053#, 16#0073#),
           ((0, 0), (45, 45), (45, 45), (19, 19)), 0, 0),
         16#80#           =>  --  0180
          ((16#0000#, 16#0243#, 16#0243#, 16#0000#),
           ((0, 0), (251, 251), (251, 251), (0, 0)), 0, 0),
         16#81#           =>  --  0181
          ((16#0253#, 16#0000#, 16#0000#, 16#0253#),
           ((252, 252), (0, 0), (0, 0), (252, 252)), 0, 0),
         16#82#           =>  --  0182
          ((16#0183#, 16#0000#, 16#0000#, 16#0183#),
           ((253, 253), (0, 0), (0, 0), (253, 253)), 0, 0),
         16#83#           =>  --  0183
          ((16#0000#, 16#0182#, 16#0182#, 16#0000#),
           ((0, 0), (254, 254), (254, 254), (0, 0)), 0, 0),
         16#84#           =>  --  0184
          ((16#0185#, 16#0000#, 16#0000#, 16#0185#),
           ((255, 255), (0, 0), (0, 0), (255, 255)), 0, 0),
         16#85#           =>  --  0185
          ((16#0000#, 16#0184#, 16#0184#, 16#0000#),
           ((0, 0), (256, 256), (256, 256), (0, 0)), 0, 0),
         16#86#           =>  --  0186
          ((16#0254#, 16#0000#, 16#0000#, 16#0254#),
           ((257, 257), (0, 0), (0, 0), (257, 257)), 0, 0),
         16#87#           =>  --  0187
          ((16#0188#, 16#0000#, 16#0000#, 16#0188#),
           ((258, 258), (0, 0), (0, 0), (258, 258)), 0, 0),
         16#88#           =>  --  0188
          ((16#0000#, 16#0187#, 16#0187#, 16#0000#),
           ((0, 0), (259, 259), (259, 259), (0, 0)), 0, 0),
         16#89#           =>  --  0189
          ((16#0256#, 16#0000#, 16#0000#, 16#0256#),
           ((260, 260), (0, 0), (0, 0), (260, 260)), 0, 0),
         16#8A#           =>  --  018A
          ((16#0257#, 16#0000#, 16#0000#, 16#0257#),
           ((261, 261), (0, 0), (0, 0), (261, 261)), 0, 0),
         16#8B#           =>  --  018B
          ((16#018C#, 16#0000#, 16#0000#, 16#018C#),
           ((262, 262), (0, 0), (0, 0), (262, 262)), 0, 0),
         16#8C#           =>  --  018C
          ((16#0000#, 16#018B#, 16#018B#, 16#0000#),
           ((0, 0), (263, 263), (263, 263), (0, 0)), 0, 0),
         16#8E#           =>  --  018E
          ((16#01DD#, 16#0000#, 16#0000#, 16#01DD#),
           ((264, 264), (0, 0), (0, 0), (264, 264)), 0, 0),
         16#8F#           =>  --  018F
          ((16#0259#, 16#0000#, 16#0000#, 16#0259#),
           ((265, 265), (0, 0), (0, 0), (265, 265)), 0, 0),
         16#90#           =>  --  0190
          ((16#025B#, 16#0000#, 16#0000#, 16#025B#),
           ((266, 266), (0, 0), (0, 0), (266, 266)), 0, 0),
         16#91#           =>  --  0191
          ((16#0192#, 16#0000#, 16#0000#, 16#0192#),
           ((267, 267), (0, 0), (0, 0), (267, 267)), 0, 0),
         16#92#           =>  --  0192
          ((16#0000#, 16#0191#, 16#0191#, 16#0000#),
           ((0, 0), (268, 268), (268, 268), (0, 0)), 0, 0),
         16#93#           =>  --  0193
          ((16#0260#, 16#0000#, 16#0000#, 16#0260#),
           ((269, 269), (0, 0), (0, 0), (269, 269)), 0, 0),
         16#94#           =>  --  0194
          ((16#0263#, 16#0000#, 16#0000#, 16#0263#),
           ((270, 270), (0, 0), (0, 0), (270, 270)), 0, 0),
         16#95#           =>  --  0195
          ((16#0000#, 16#01F6#, 16#01F6#, 16#0000#),
           ((0, 0), (271, 271), (271, 271), (0, 0)), 0, 0),
         16#96#           =>  --  0196
          ((16#0269#, 16#0000#, 16#0000#, 16#0269#),
           ((272, 272), (0, 0), (0, 0), (272, 272)), 0, 0),
         16#97#           =>  --  0197
          ((16#0268#, 16#0000#, 16#0000#, 16#0268#),
           ((273, 273), (0, 0), (0, 0), (273, 273)), 0, 0),
         16#98#           =>  --  0198
          ((16#0199#, 16#0000#, 16#0000#, 16#0199#),
           ((274, 274), (0, 0), (0, 0), (274, 274)), 0, 0),
         16#99#           =>  --  0199
          ((16#0000#, 16#0198#, 16#0198#, 16#0000#),
           ((0, 0), (275, 275), (275, 275), (0, 0)), 0, 0),
         16#9A#           =>  --  019A
          ((16#0000#, 16#023D#, 16#023D#, 16#0000#),
           ((0, 0), (276, 276), (276, 276), (0, 0)), 0, 0),
         16#9C#           =>  --  019C
          ((16#026F#, 16#0000#, 16#0000#, 16#026F#),
           ((277, 277), (0, 0), (0, 0), (277, 277)), 0, 0),
         16#9D#           =>  --  019D
          ((16#0272#, 16#0000#, 16#0000#, 16#0272#),
           ((278, 278), (0, 0), (0, 0), (278, 278)), 0, 0),
         16#9E#           =>  --  019E
          ((16#0000#, 16#0220#, 16#0220#, 16#0000#),
           ((0, 0), (279, 279), (279, 279), (0, 0)), 0, 0),
         16#9F#           =>  --  019F
          ((16#0275#, 16#0000#, 16#0000#, 16#0275#),
           ((280, 280), (0, 0), (0, 0), (280, 280)), 0, 0),
         16#A0#           =>  --  01A0
          ((16#01A1#, 16#0000#, 16#0000#, 16#01A1#),
           ((281, 281), (0, 0), (0, 0), (281, 281)), 0, 0),
         16#A1#           =>  --  01A1
          ((16#0000#, 16#01A0#, 16#01A0#, 16#0000#),
           ((0, 0), (282, 282), (282, 282), (0, 0)), 0, 0),
         16#A2#           =>  --  01A2
          ((16#01A3#, 16#0000#, 16#0000#, 16#01A3#),
           ((283, 283), (0, 0), (0, 0), (283, 283)), 0, 0),
         16#A3#           =>  --  01A3
          ((16#0000#, 16#01A2#, 16#01A2#, 16#0000#),
           ((0, 0), (284, 284), (284, 284), (0, 0)), 0, 0),
         16#A4#           =>  --  01A4
          ((16#01A5#, 16#0000#, 16#0000#, 16#01A5#),
           ((285, 285), (0, 0), (0, 0), (285, 285)), 0, 0),
         16#A5#           =>  --  01A5
          ((16#0000#, 16#01A4#, 16#01A4#, 16#0000#),
           ((0, 0), (286, 286), (286, 286), (0, 0)), 0, 0),
         16#A6#           =>  --  01A6
          ((16#0280#, 16#0000#, 16#0000#, 16#0280#),
           ((287, 287), (0, 0), (0, 0), (287, 287)), 0, 0),
         16#A7#           =>  --  01A7
          ((16#01A8#, 16#0000#, 16#0000#, 16#01A8#),
           ((288, 288), (0, 0), (0, 0), (288, 288)), 0, 0),
         16#A8#           =>  --  01A8
          ((16#0000#, 16#01A7#, 16#01A7#, 16#0000#),
           ((0, 0), (289, 289), (289, 289), (0, 0)), 0, 0),
         16#A9#           =>  --  01A9
          ((16#0283#, 16#0000#, 16#0000#, 16#0283#),
           ((290, 290), (0, 0), (0, 0), (290, 290)), 0, 0),
         16#AC#           =>  --  01AC
          ((16#01AD#, 16#0000#, 16#0000#, 16#01AD#),
           ((291, 291), (0, 0), (0, 0), (291, 291)), 0, 0),
         16#AD#           =>  --  01AD
          ((16#0000#, 16#01AC#, 16#01AC#, 16#0000#),
           ((0, 0), (292, 292), (292, 292), (0, 0)), 0, 0),
         16#AE#           =>  --  01AE
          ((16#0288#, 16#0000#, 16#0000#, 16#0288#),
           ((293, 293), (0, 0), (0, 0), (293, 293)), 0, 0),
         16#AF#           =>  --  01AF
          ((16#01B0#, 16#0000#, 16#0000#, 16#01B0#),
           ((294, 294), (0, 0), (0, 0), (294, 294)), 0, 0),
         16#B0#           =>  --  01B0
          ((16#0000#, 16#01AF#, 16#01AF#, 16#0000#),
           ((0, 0), (295, 295), (295, 295), (0, 0)), 0, 0),
         16#B1#           =>  --  01B1
          ((16#028A#, 16#0000#, 16#0000#, 16#028A#),
           ((296, 296), (0, 0), (0, 0), (296, 296)), 0, 0),
         16#B2#           =>  --  01B2
          ((16#028B#, 16#0000#, 16#0000#, 16#028B#),
           ((297, 297), (0, 0), (0, 0), (297, 297)), 0, 0),
         16#B3#           =>  --  01B3
          ((16#01B4#, 16#0000#, 16#0000#, 16#01B4#),
           ((298, 298), (0, 0), (0, 0), (298, 298)), 0, 0),
         16#B4#           =>  --  01B4
          ((16#0000#, 16#01B3#, 16#01B3#, 16#0000#),
           ((0, 0), (299, 299), (299, 299), (0, 0)), 0, 0),
         16#B5#           =>  --  01B5
          ((16#01B6#, 16#0000#, 16#0000#, 16#01B6#),
           ((300, 300), (0, 0), (0, 0), (300, 300)), 0, 0),
         16#B6#           =>  --  01B6
          ((16#0000#, 16#01B5#, 16#01B5#, 16#0000#),
           ((0, 0), (301, 301), (301, 301), (0, 0)), 0, 0),
         16#B7#           =>  --  01B7
          ((16#0292#, 16#0000#, 16#0000#, 16#0292#),
           ((302, 302), (0, 0), (0, 0), (302, 302)), 0, 0),
         16#B8#           =>  --  01B8
          ((16#01B9#, 16#0000#, 16#0000#, 16#01B9#),
           ((303, 303), (0, 0), (0, 0), (303, 303)), 0, 0),
         16#B9#           =>  --  01B9
          ((16#0000#, 16#01B8#, 16#01B8#, 16#0000#),
           ((0, 0), (304, 304), (304, 304), (0, 0)), 0, 0),
         16#BC#           =>  --  01BC
          ((16#01BD#, 16#0000#, 16#0000#, 16#01BD#),
           ((305, 305), (0, 0), (0, 0), (305, 305)), 0, 0),
         16#BD#           =>  --  01BD
          ((16#0000#, 16#01BC#, 16#01BC#, 16#0000#),
           ((0, 0), (306, 306), (306, 306), (0, 0)), 0, 0),
         16#BF#           =>  --  01BF
          ((16#0000#, 16#01F7#, 16#01F7#, 16#0000#),
           ((0, 0), (307, 307), (307, 307), (0, 0)), 0, 0),
         16#C4#           =>  --  01C4
          ((16#01C6#, 16#0000#, 16#01C5#, 16#01C6#),
           ((308, 308), (0, 0), (309, 309), (308, 308)), 0, 0),
         16#C5#           =>  --  01C5
          ((16#01C6#, 16#01C4#, 16#0000#, 16#01C6#),
           ((308, 308), (310, 310), (0, 0), (308, 308)), 0, 0),
         16#C6#           =>  --  01C6
          ((16#0000#, 16#01C4#, 16#01C5#, 16#0000#),
           ((0, 0), (310, 310), (309, 309), (0, 0)), 0, 0),
         16#C7#           =>  --  01C7
          ((16#01C9#, 16#0000#, 16#01C8#, 16#01C9#),
           ((311, 311), (0, 0), (312, 312), (311, 311)), 0, 0),
         16#C8#           =>  --  01C8
          ((16#01C9#, 16#01C7#, 16#0000#, 16#01C9#),
           ((311, 311), (313, 313), (0, 0), (311, 311)), 0, 0),
         16#C9#           =>  --  01C9
          ((16#0000#, 16#01C7#, 16#01C8#, 16#0000#),
           ((0, 0), (313, 313), (312, 312), (0, 0)), 0, 0),
         16#CA#           =>  --  01CA
          ((16#01CC#, 16#0000#, 16#01CB#, 16#01CC#),
           ((314, 314), (0, 0), (315, 315), (314, 314)), 0, 0),
         16#CB#           =>  --  01CB
          ((16#01CC#, 16#01CA#, 16#0000#, 16#01CC#),
           ((314, 314), (316, 316), (0, 0), (314, 314)), 0, 0),
         16#CC#           =>  --  01CC
          ((16#0000#, 16#01CA#, 16#01CB#, 16#0000#),
           ((0, 0), (316, 316), (315, 315), (0, 0)), 0, 0),
         16#CD#           =>  --  01CD
          ((16#01CE#, 16#0000#, 16#0000#, 16#01CE#),
           ((317, 317), (0, 0), (0, 0), (317, 317)), 0, 0),
         16#CE#           =>  --  01CE
          ((16#0000#, 16#01CD#, 16#01CD#, 16#0000#),
           ((0, 0), (318, 318), (318, 318), (0, 0)), 0, 0),
         16#CF#           =>  --  01CF
          ((16#01D0#, 16#0000#, 16#0000#, 16#01D0#),
           ((319, 319), (0, 0), (0, 0), (319, 319)), 0, 0),
         16#D0#           =>  --  01D0
          ((16#0000#, 16#01CF#, 16#01CF#, 16#0000#),
           ((0, 0), (320, 320), (320, 320), (0, 0)), 0, 0),
         16#D1#           =>  --  01D1
          ((16#01D2#, 16#0000#, 16#0000#, 16#01D2#),
           ((321, 321), (0, 0), (0, 0), (321, 321)), 0, 0),
         16#D2#           =>  --  01D2
          ((16#0000#, 16#01D1#, 16#01D1#, 16#0000#),
           ((0, 0), (322, 322), (322, 322), (0, 0)), 0, 0),
         16#D3#           =>  --  01D3
          ((16#01D4#, 16#0000#, 16#0000#, 16#01D4#),
           ((323, 323), (0, 0), (0, 0), (323, 323)), 0, 0),
         16#D4#           =>  --  01D4
          ((16#0000#, 16#01D3#, 16#01D3#, 16#0000#),
           ((0, 0), (324, 324), (324, 324), (0, 0)), 0, 0),
         16#D5#           =>  --  01D5
          ((16#01D6#, 16#0000#, 16#0000#, 16#01D6#),
           ((325, 325), (0, 0), (0, 0), (325, 325)), 0, 0),
         16#D6#           =>  --  01D6
          ((16#0000#, 16#01D5#, 16#01D5#, 16#0000#),
           ((0, 0), (326, 326), (326, 326), (0, 0)), 0, 0),
         16#D7#           =>  --  01D7
          ((16#01D8#, 16#0000#, 16#0000#, 16#01D8#),
           ((327, 327), (0, 0), (0, 0), (327, 327)), 0, 0),
         16#D8#           =>  --  01D8
          ((16#0000#, 16#01D7#, 16#01D7#, 16#0000#),
           ((0, 0), (328, 328), (328, 328), (0, 0)), 0, 0),
         16#D9#           =>  --  01D9
          ((16#01DA#, 16#0000#, 16#0000#, 16#01DA#),
           ((329, 329), (0, 0), (0, 0), (329, 329)), 0, 0),
         16#DA#           =>  --  01DA
          ((16#0000#, 16#01D9#, 16#01D9#, 16#0000#),
           ((0, 0), (330, 330), (330, 330), (0, 0)), 0, 0),
         16#DB#           =>  --  01DB
          ((16#01DC#, 16#0000#, 16#0000#, 16#01DC#),
           ((331, 331), (0, 0), (0, 0), (331, 331)), 0, 0),
         16#DC#           =>  --  01DC
          ((16#0000#, 16#01DB#, 16#01DB#, 16#0000#),
           ((0, 0), (332, 332), (332, 332), (0, 0)), 0, 0),
         16#DD#           =>  --  01DD
          ((16#0000#, 16#018E#, 16#018E#, 16#0000#),
           ((0, 0), (333, 333), (333, 333), (0, 0)), 0, 0),
         16#DE#           =>  --  01DE
          ((16#01DF#, 16#0000#, 16#0000#, 16#01DF#),
           ((334, 334), (0, 0), (0, 0), (334, 334)), 0, 0),
         16#DF#           =>  --  01DF
          ((16#0000#, 16#01DE#, 16#01DE#, 16#0000#),
           ((0, 0), (335, 335), (335, 335), (0, 0)), 0, 0),
         16#E0#           =>  --  01E0
          ((16#01E1#, 16#0000#, 16#0000#, 16#01E1#),
           ((336, 336), (0, 0), (0, 0), (336, 336)), 0, 0),
         16#E1#           =>  --  01E1
          ((16#0000#, 16#01E0#, 16#01E0#, 16#0000#),
           ((0, 0), (337, 337), (337, 337), (0, 0)), 0, 0),
         16#E2#           =>  --  01E2
          ((16#01E3#, 16#0000#, 16#0000#, 16#01E3#),
           ((338, 338), (0, 0), (0, 0), (338, 338)), 0, 0),
         16#E3#           =>  --  01E3
          ((16#0000#, 16#01E2#, 16#01E2#, 16#0000#),
           ((0, 0), (339, 339), (339, 339), (0, 0)), 0, 0),
         16#E4#           =>  --  01E4
          ((16#01E5#, 16#0000#, 16#0000#, 16#01E5#),
           ((340, 340), (0, 0), (0, 0), (340, 340)), 0, 0),
         16#E5#           =>  --  01E5
          ((16#0000#, 16#01E4#, 16#01E4#, 16#0000#),
           ((0, 0), (341, 341), (341, 341), (0, 0)), 0, 0),
         16#E6#           =>  --  01E6
          ((16#01E7#, 16#0000#, 16#0000#, 16#01E7#),
           ((342, 342), (0, 0), (0, 0), (342, 342)), 0, 0),
         16#E7#           =>  --  01E7
          ((16#0000#, 16#01E6#, 16#01E6#, 16#0000#),
           ((0, 0), (343, 343), (343, 343), (0, 0)), 0, 0),
         16#E8#           =>  --  01E8
          ((16#01E9#, 16#0000#, 16#0000#, 16#01E9#),
           ((344, 344), (0, 0), (0, 0), (344, 344)), 0, 0),
         16#E9#           =>  --  01E9
          ((16#0000#, 16#01E8#, 16#01E8#, 16#0000#),
           ((0, 0), (345, 345), (345, 345), (0, 0)), 0, 0),
         16#EA#           =>  --  01EA
          ((16#01EB#, 16#0000#, 16#0000#, 16#01EB#),
           ((346, 346), (0, 0), (0, 0), (346, 346)), 0, 0),
         16#EB#           =>  --  01EB
          ((16#0000#, 16#01EA#, 16#01EA#, 16#0000#),
           ((0, 0), (347, 347), (347, 347), (0, 0)), 0, 0),
         16#EC#           =>  --  01EC
          ((16#01ED#, 16#0000#, 16#0000#, 16#01ED#),
           ((348, 348), (0, 0), (0, 0), (348, 348)), 0, 0),
         16#ED#           =>  --  01ED
          ((16#0000#, 16#01EC#, 16#01EC#, 16#0000#),
           ((0, 0), (349, 349), (349, 349), (0, 0)), 0, 0),
         16#EE#           =>  --  01EE
          ((16#01EF#, 16#0000#, 16#0000#, 16#01EF#),
           ((350, 350), (0, 0), (0, 0), (350, 350)), 0, 0),
         16#EF#           =>  --  01EF
          ((16#0000#, 16#01EE#, 16#01EE#, 16#0000#),
           ((0, 0), (351, 351), (351, 351), (0, 0)), 0, 0),
         16#F0#           =>  --  01F0
          ((16#0000#, 16#0000#, 16#0000#, 16#0000#),
           ((0, 0), (352, 353), (352, 353), (354, 355)), 0, 0),
         16#F1#           =>  --  01F1
          ((16#01F3#, 16#0000#, 16#01F2#, 16#01F3#),
           ((356, 356), (0, 0), (357, 357), (356, 356)), 0, 0),
         16#F2#           =>  --  01F2
          ((16#01F3#, 16#01F1#, 16#0000#, 16#01F3#),
           ((356, 356), (358, 358), (0, 0), (356, 356)), 0, 0),
         16#F3#           =>  --  01F3
          ((16#0000#, 16#01F1#, 16#01F2#, 16#0000#),
           ((0, 0), (358, 358), (357, 357), (0, 0)), 0, 0),
         16#F4#           =>  --  01F4
          ((16#01F5#, 16#0000#, 16#0000#, 16#01F5#),
           ((359, 359), (0, 0), (0, 0), (359, 359)), 0, 0),
         16#F5#           =>  --  01F5
          ((16#0000#, 16#01F4#, 16#01F4#, 16#0000#),
           ((0, 0), (360, 360), (360, 360), (0, 0)), 0, 0),
         16#F6#           =>  --  01F6
          ((16#0195#, 16#0000#, 16#0000#, 16#0195#),
           ((361, 361), (0, 0), (0, 0), (361, 361)), 0, 0),
         16#F7#           =>  --  01F7
          ((16#01BF#, 16#0000#, 16#0000#, 16#01BF#),
           ((362, 362), (0, 0), (0, 0), (362, 362)), 0, 0),
         16#F8#           =>  --  01F8
          ((16#01F9#, 16#0000#, 16#0000#, 16#01F9#),
           ((363, 363), (0, 0), (0, 0), (363, 363)), 0, 0),
         16#F9#           =>  --  01F9
          ((16#0000#, 16#01F8#, 16#01F8#, 16#0000#),
           ((0, 0), (364, 364), (364, 364), (0, 0)), 0, 0),
         16#FA#           =>  --  01FA
          ((16#01FB#, 16#0000#, 16#0000#, 16#01FB#),
           ((365, 365), (0, 0), (0, 0), (365, 365)), 0, 0),
         16#FB#           =>  --  01FB
          ((16#0000#, 16#01FA#, 16#01FA#, 16#0000#),
           ((0, 0), (366, 366), (366, 366), (0, 0)), 0, 0),
         16#FC#           =>  --  01FC
          ((16#01FD#, 16#0000#, 16#0000#, 16#01FD#),
           ((367, 367), (0, 0), (0, 0), (367, 367)), 0, 0),
         16#FD#           =>  --  01FD
          ((16#0000#, 16#01FC#, 16#01FC#, 16#0000#),
           ((0, 0), (368, 368), (368, 368), (0, 0)), 0, 0),
         16#FE#           =>  --  01FE
          ((16#01FF#, 16#0000#, 16#0000#, 16#01FF#),
           ((369, 369), (0, 0), (0, 0), (369, 369)), 0, 0),
         16#FF#           =>  --  01FF
          ((16#0000#, 16#01FE#, 16#01FE#, 16#0000#),
           ((0, 0), (370, 370), (370, 370), (0, 0)), 0, 0),
         others           =>
          ((16#0000#, 16#0000#, 16#0000#, 16#0000#),
           ((0, 0), (0, 0), (0, 0), (0, 0)), 0, 0));

   Group_0002 : aliased constant Case_Mapping_Second_Stage
     := (16#00#           =>  --  0200
          ((16#0201#, 16#0000#, 16#0000#, 16#0201#),
           ((371, 371), (0, 0), (0, 0), (371, 371)), 0, 0),
         16#01#           =>  --  0201
          ((16#0000#, 16#0200#, 16#0200#, 16#0000#),
           ((0, 0), (372, 372), (372, 372), (0, 0)), 0, 0),
         16#02#           =>  --  0202
          ((16#0203#, 16#0000#, 16#0000#, 16#0203#),
           ((373, 373), (0, 0), (0, 0), (373, 373)), 0, 0),
         16#03#           =>  --  0203
          ((16#0000#, 16#0202#, 16#0202#, 16#0000#),
           ((0, 0), (374, 374), (374, 374), (0, 0)), 0, 0),
         16#04#           =>  --  0204
          ((16#0205#, 16#0000#, 16#0000#, 16#0205#),
           ((375, 375), (0, 0), (0, 0), (375, 375)), 0, 0),
         16#05#           =>  --  0205
          ((16#0000#, 16#0204#, 16#0204#, 16#0000#),
           ((0, 0), (376, 376), (376, 376), (0, 0)), 0, 0),
         16#06#           =>  --  0206
          ((16#0207#, 16#0000#, 16#0000#, 16#0207#),
           ((377, 377), (0, 0), (0, 0), (377, 377)), 0, 0),
         16#07#           =>  --  0207
          ((16#0000#, 16#0206#, 16#0206#, 16#0000#),
           ((0, 0), (378, 378), (378, 378), (0, 0)), 0, 0),
         16#08#           =>  --  0208
          ((16#0209#, 16#0000#, 16#0000#, 16#0209#),
           ((379, 379), (0, 0), (0, 0), (379, 379)), 0, 0),
         16#09#           =>  --  0209
          ((16#0000#, 16#0208#, 16#0208#, 16#0000#),
           ((0, 0), (380, 380), (380, 380), (0, 0)), 0, 0),
         16#0A#           =>  --  020A
          ((16#020B#, 16#0000#, 16#0000#, 16#020B#),
           ((381, 381), (0, 0), (0, 0), (381, 381)), 0, 0),
         16#0B#           =>  --  020B
          ((16#0000#, 16#020A#, 16#020A#, 16#0000#),
           ((0, 0), (382, 382), (382, 382), (0, 0)), 0, 0),
         16#0C#           =>  --  020C
          ((16#020D#, 16#0000#, 16#0000#, 16#020D#),
           ((383, 383), (0, 0), (0, 0), (383, 383)), 0, 0),
         16#0D#           =>  --  020D
          ((16#0000#, 16#020C#, 16#020C#, 16#0000#),
           ((0, 0), (384, 384), (384, 384), (0, 0)), 0, 0),
         16#0E#           =>  --  020E
          ((16#020F#, 16#0000#, 16#0000#, 16#020F#),
           ((385, 385), (0, 0), (0, 0), (385, 385)), 0, 0),
         16#0F#           =>  --  020F
          ((16#0000#, 16#020E#, 16#020E#, 16#0000#),
           ((0, 0), (386, 386), (386, 386), (0, 0)), 0, 0),
         16#10#           =>  --  0210
          ((16#0211#, 16#0000#, 16#0000#, 16#0211#),
           ((387, 387), (0, 0), (0, 0), (387, 387)), 0, 0),
         16#11#           =>  --  0211
          ((16#0000#, 16#0210#, 16#0210#, 16#0000#),
           ((0, 0), (388, 388), (388, 388), (0, 0)), 0, 0),
         16#12#           =>  --  0212
          ((16#0213#, 16#0000#, 16#0000#, 16#0213#),
           ((389, 389), (0, 0), (0, 0), (389, 389)), 0, 0),
         16#13#           =>  --  0213
          ((16#0000#, 16#0212#, 16#0212#, 16#0000#),
           ((0, 0), (390, 390), (390, 390), (0, 0)), 0, 0),
         16#14#           =>  --  0214
          ((16#0215#, 16#0000#, 16#0000#, 16#0215#),
           ((391, 391), (0, 0), (0, 0), (391, 391)), 0, 0),
         16#15#           =>  --  0215
          ((16#0000#, 16#0214#, 16#0214#, 16#0000#),
           ((0, 0), (392, 392), (392, 392), (0, 0)), 0, 0),
         16#16#           =>  --  0216
          ((16#0217#, 16#0000#, 16#0000#, 16#0217#),
           ((393, 393), (0, 0), (0, 0), (393, 393)), 0, 0),
         16#17#           =>  --  0217
          ((16#0000#, 16#0216#, 16#0216#, 16#0000#),
           ((0, 0), (394, 394), (394, 394), (0, 0)), 0, 0),
         16#18#           =>  --  0218
          ((16#0219#, 16#0000#, 16#0000#, 16#0219#),
           ((395, 395), (0, 0), (0, 0), (395, 395)), 0, 0),
         16#19#           =>  --  0219
          ((16#0000#, 16#0218#, 16#0218#, 16#0000#),
           ((0, 0), (396, 396), (396, 396), (0, 0)), 0, 0),
         16#1A#           =>  --  021A
          ((16#021B#, 16#0000#, 16#0000#, 16#021B#),
           ((397, 397), (0, 0), (0, 0), (397, 397)), 0, 0),
         16#1B#           =>  --  021B
          ((16#0000#, 16#021A#, 16#021A#, 16#0000#),
           ((0, 0), (398, 398), (398, 398), (0, 0)), 0, 0),
         16#1C#           =>  --  021C
          ((16#021D#, 16#0000#, 16#0000#, 16#021D#),
           ((399, 399), (0, 0), (0, 0), (399, 399)), 0, 0),
         16#1D#           =>  --  021D
          ((16#0000#, 16#021C#, 16#021C#, 16#0000#),
           ((0, 0), (400, 400), (400, 400), (0, 0)), 0, 0),
         16#1E#           =>  --  021E
          ((16#021F#, 16#0000#, 16#0000#, 16#021F#),
           ((401, 401), (0, 0), (0, 0), (401, 401)), 0, 0),
         16#1F#           =>  --  021F
          ((16#0000#, 16#021E#, 16#021E#, 16#0000#),
           ((0, 0), (402, 402), (402, 402), (0, 0)), 0, 0),
         16#20#           =>  --  0220
          ((16#019E#, 16#0000#, 16#0000#, 16#019E#),
           ((403, 403), (0, 0), (0, 0), (403, 403)), 0, 0),
         16#22#           =>  --  0222
          ((16#0223#, 16#0000#, 16#0000#, 16#0223#),
           ((404, 404), (0, 0), (0, 0), (404, 404)), 0, 0),
         16#23#           =>  --  0223
          ((16#0000#, 16#0222#, 16#0222#, 16#0000#),
           ((0, 0), (405, 405), (405, 405), (0, 0)), 0, 0),
         16#24#           =>  --  0224
          ((16#0225#, 16#0000#, 16#0000#, 16#0225#),
           ((406, 406), (0, 0), (0, 0), (406, 406)), 0, 0),
         16#25#           =>  --  0225
          ((16#0000#, 16#0224#, 16#0224#, 16#0000#),
           ((0, 0), (407, 407), (407, 407), (0, 0)), 0, 0),
         16#26#           =>  --  0226
          ((16#0227#, 16#0000#, 16#0000#, 16#0227#),
           ((408, 408), (0, 0), (0, 0), (408, 408)), 0, 0),
         16#27#           =>  --  0227
          ((16#0000#, 16#0226#, 16#0226#, 16#0000#),
           ((0, 0), (409, 409), (409, 409), (0, 0)), 0, 0),
         16#28#           =>  --  0228
          ((16#0229#, 16#0000#, 16#0000#, 16#0229#),
           ((410, 410), (0, 0), (0, 0), (410, 410)), 0, 0),
         16#29#           =>  --  0229
          ((16#0000#, 16#0228#, 16#0228#, 16#0000#),
           ((0, 0), (411, 411), (411, 411), (0, 0)), 0, 0),
         16#2A#           =>  --  022A
          ((16#022B#, 16#0000#, 16#0000#, 16#022B#),
           ((412, 412), (0, 0), (0, 0), (412, 412)), 0, 0),
         16#2B#           =>  --  022B
          ((16#0000#, 16#022A#, 16#022A#, 16#0000#),
           ((0, 0), (413, 413), (413, 413), (0, 0)), 0, 0),
         16#2C#           =>  --  022C
          ((16#022D#, 16#0000#, 16#0000#, 16#022D#),
           ((414, 414), (0, 0), (0, 0), (414, 414)), 0, 0),
         16#2D#           =>  --  022D
          ((16#0000#, 16#022C#, 16#022C#, 16#0000#),
           ((0, 0), (415, 415), (415, 415), (0, 0)), 0, 0),
         16#2E#           =>  --  022E
          ((16#022F#, 16#0000#, 16#0000#, 16#022F#),
           ((416, 416), (0, 0), (0, 0), (416, 416)), 0, 0),
         16#2F#           =>  --  022F
          ((16#0000#, 16#022E#, 16#022E#, 16#0000#),
           ((0, 0), (417, 417), (417, 417), (0, 0)), 0, 0),
         16#30#           =>  --  0230
          ((16#0231#, 16#0000#, 16#0000#, 16#0231#),
           ((418, 418), (0, 0), (0, 0), (418, 418)), 0, 0),
         16#31#           =>  --  0231
          ((16#0000#, 16#0230#, 16#0230#, 16#0000#),
           ((0, 0), (419, 419), (419, 419), (0, 0)), 0, 0),
         16#32#           =>  --  0232
          ((16#0233#, 16#0000#, 16#0000#, 16#0233#),
           ((420, 420), (0, 0), (0, 0), (420, 420)), 0, 0),
         16#33#           =>  --  0233
          ((16#0000#, 16#0232#, 16#0232#, 16#0000#),
           ((0, 0), (421, 421), (421, 421), (0, 0)), 0, 0),
         16#3A#           =>  --  023A
          ((16#2C65#, 16#0000#, 16#0000#, 16#2C65#),
           ((422, 422), (0, 0), (0, 0), (422, 422)), 0, 0),
         16#3B#           =>  --  023B
          ((16#023C#, 16#0000#, 16#0000#, 16#023C#),
           ((423, 423), (0, 0), (0, 0), (423, 423)), 0, 0),
         16#3C#           =>  --  023C
          ((16#0000#, 16#023B#, 16#023B#, 16#0000#),
           ((0, 0), (424, 424), (424, 424), (0, 0)), 0, 0),
         16#3D#           =>  --  023D
          ((16#019A#, 16#0000#, 16#0000#, 16#019A#),
           ((425, 425), (0, 0), (0, 0), (425, 425)), 0, 0),
         16#3E#           =>  --  023E
          ((16#2C66#, 16#0000#, 16#0000#, 16#2C66#),
           ((426, 426), (0, 0), (0, 0), (426, 426)), 0, 0),
         16#3F#           =>  --  023F
          ((16#0000#, 16#2C7E#, 16#2C7E#, 16#0000#),
           ((0, 0), (427, 427), (427, 427), (0, 0)), 0, 0),
         16#40#           =>  --  0240
          ((16#0000#, 16#2C7F#, 16#2C7F#, 16#0000#),
           ((0, 0), (428, 428), (428, 428), (0, 0)), 0, 0),
         16#41#           =>  --  0241
          ((16#0242#, 16#0000#, 16#0000#, 16#0242#),
           ((429, 429), (0, 0), (0, 0), (429, 429)), 0, 0),
         16#42#           =>  --  0242
          ((16#0000#, 16#0241#, 16#0241#, 16#0000#),
           ((0, 0), (430, 430), (430, 430), (0, 0)), 0, 0),
         16#43#           =>  --  0243
          ((16#0180#, 16#0000#, 16#0000#, 16#0180#),
           ((431, 431), (0, 0), (0, 0), (431, 431)), 0, 0),
         16#44#           =>  --  0244
          ((16#0289#, 16#0000#, 16#0000#, 16#0289#),
           ((432, 432), (0, 0), (0, 0), (432, 432)), 0, 0),
         16#45#           =>  --  0245
          ((16#028C#, 16#0000#, 16#0000#, 16#028C#),
           ((433, 433), (0, 0), (0, 0), (433, 433)), 0, 0),
         16#46#           =>  --  0246
          ((16#0247#, 16#0000#, 16#0000#, 16#0247#),
           ((434, 434), (0, 0), (0, 0), (434, 434)), 0, 0),
         16#47#           =>  --  0247
          ((16#0000#, 16#0246#, 16#0246#, 16#0000#),
           ((0, 0), (435, 435), (435, 435), (0, 0)), 0, 0),
         16#48#           =>  --  0248
          ((16#0249#, 16#0000#, 16#0000#, 16#0249#),
           ((436, 436), (0, 0), (0, 0), (436, 436)), 0, 0),
         16#49#           =>  --  0249
          ((16#0000#, 16#0248#, 16#0248#, 16#0000#),
           ((0, 0), (437, 437), (437, 437), (0, 0)), 0, 0),
         16#4A#           =>  --  024A
          ((16#024B#, 16#0000#, 16#0000#, 16#024B#),
           ((438, 438), (0, 0), (0, 0), (438, 438)), 0, 0),
         16#4B#           =>  --  024B
          ((16#0000#, 16#024A#, 16#024A#, 16#0000#),
           ((0, 0), (439, 439), (439, 439), (0, 0)), 0, 0),
         16#4C#           =>  --  024C
          ((16#024D#, 16#0000#, 16#0000#, 16#024D#),
           ((440, 440), (0, 0), (0, 0), (440, 440)), 0, 0),
         16#4D#           =>  --  024D
          ((16#0000#, 16#024C#, 16#024C#, 16#0000#),
           ((0, 0), (441, 441), (441, 441), (0, 0)), 0, 0),
         16#4E#           =>  --  024E
          ((16#024F#, 16#0000#, 16#0000#, 16#024F#),
           ((442, 442), (0, 0), (0, 0), (442, 442)), 0, 0),
         16#4F#           =>  --  024F
          ((16#0000#, 16#024E#, 16#024E#, 16#0000#),
           ((0, 0), (443, 443), (443, 443), (0, 0)), 0, 0),
         16#50#           =>  --  0250
          ((16#0000#, 16#2C6F#, 16#2C6F#, 16#0000#),
           ((0, 0), (444, 444), (444, 444), (0, 0)), 0, 0),
         16#51#           =>  --  0251
          ((16#0000#, 16#2C6D#, 16#2C6D#, 16#0000#),
           ((0, 0), (445, 445), (445, 445), (0, 0)), 0, 0),
         16#52#           =>  --  0252
          ((16#0000#, 16#2C70#, 16#2C70#, 16#0000#),
           ((0, 0), (446, 446), (446, 446), (0, 0)), 0, 0),
         16#53#           =>  --  0253
          ((16#0000#, 16#0181#, 16#0181#, 16#0000#),
           ((0, 0), (447, 447), (447, 447), (0, 0)), 0, 0),
         16#54#           =>  --  0254
          ((16#0000#, 16#0186#, 16#0186#, 16#0000#),
           ((0, 0), (448, 448), (448, 448), (0, 0)), 0, 0),
         16#56#           =>  --  0256
          ((16#0000#, 16#0189#, 16#0189#, 16#0000#),
           ((0, 0), (449, 449), (449, 449), (0, 0)), 0, 0),
         16#57#           =>  --  0257
          ((16#0000#, 16#018A#, 16#018A#, 16#0000#),
           ((0, 0), (450, 450), (450, 450), (0, 0)), 0, 0),
         16#59#           =>  --  0259
          ((16#0000#, 16#018F#, 16#018F#, 16#0000#),
           ((0, 0), (451, 451), (451, 451), (0, 0)), 0, 0),
         16#5B#           =>  --  025B
          ((16#0000#, 16#0190#, 16#0190#, 16#0000#),
           ((0, 0), (452, 452), (452, 452), (0, 0)), 0, 0),
         16#5C#           =>  --  025C
          ((16#0000#, 16#A7AB#, 16#A7AB#, 16#0000#),
           ((0, 0), (453, 453), (453, 453), (0, 0)), 0, 0),
         16#60#           =>  --  0260
          ((16#0000#, 16#0193#, 16#0193#, 16#0000#),
           ((0, 0), (454, 454), (454, 454), (0, 0)), 0, 0),
         16#61#           =>  --  0261
          ((16#0000#, 16#A7AC#, 16#A7AC#, 16#0000#),
           ((0, 0), (455, 455), (455, 455), (0, 0)), 0, 0),
         16#63#           =>  --  0263
          ((16#0000#, 16#0194#, 16#0194#, 16#0000#),
           ((0, 0), (456, 456), (456, 456), (0, 0)), 0, 0),
         16#65#           =>  --  0265
          ((16#0000#, 16#A78D#, 16#A78D#, 16#0000#),
           ((0, 0), (457, 457), (457, 457), (0, 0)), 0, 0),
         16#66#           =>  --  0266
          ((16#0000#, 16#A7AA#, 16#A7AA#, 16#0000#),
           ((0, 0), (458, 458), (458, 458), (0, 0)), 0, 0),
         16#68#           =>  --  0268
          ((16#0000#, 16#0197#, 16#0197#, 16#0000#),
           ((0, 0), (459, 459), (459, 459), (0, 0)), 0, 0),
         16#69#           =>  --  0269
          ((16#0000#, 16#0196#, 16#0196#, 16#0000#),
           ((0, 0), (460, 460), (460, 460), (0, 0)), 0, 0),
         16#6B#           =>  --  026B
          ((16#0000#, 16#2C62#, 16#2C62#, 16#0000#),
           ((0, 0), (461, 461), (461, 461), (0, 0)), 0, 0),
         16#6C#           =>  --  026C
          ((16#0000#, 16#A7AD#, 16#A7AD#, 16#0000#),
           ((0, 0), (462, 462), (462, 462), (0, 0)), 0, 0),
         16#6F#           =>  --  026F
          ((16#0000#, 16#019C#, 16#019C#, 16#0000#),
           ((0, 0), (463, 463), (463, 463), (0, 0)), 0, 0),
         16#71#           =>  --  0271
          ((16#0000#, 16#2C6E#, 16#2C6E#, 16#0000#),
           ((0, 0), (464, 464), (464, 464), (0, 0)), 0, 0),
         16#72#           =>  --  0272
          ((16#0000#, 16#019D#, 16#019D#, 16#0000#),
           ((0, 0), (465, 465), (465, 465), (0, 0)), 0, 0),
         16#75#           =>  --  0275
          ((16#0000#, 16#019F#, 16#019F#, 16#0000#),
           ((0, 0), (466, 466), (466, 466), (0, 0)), 0, 0),
         16#7D#           =>  --  027D
          ((16#0000#, 16#2C64#, 16#2C64#, 16#0000#),
           ((0, 0), (467, 467), (467, 467), (0, 0)), 0, 0),
         16#80#           =>  --  0280
          ((16#0000#, 16#01A6#, 16#01A6#, 16#0000#),
           ((0, 0), (468, 468), (468, 468), (0, 0)), 0, 0),
         16#83#           =>  --  0283
          ((16#0000#, 16#01A9#, 16#01A9#, 16#0000#),
           ((0, 0), (469, 469), (469, 469), (0, 0)), 0, 0),
         16#87#           =>  --  0287
          ((16#0000#, 16#A7B1#, 16#A7B1#, 16#0000#),
           ((0, 0), (470, 470), (470, 470), (0, 0)), 0, 0),
         16#88#           =>  --  0288
          ((16#0000#, 16#01AE#, 16#01AE#, 16#0000#),
           ((0, 0), (471, 471), (471, 471), (0, 0)), 0, 0),
         16#89#           =>  --  0289
          ((16#0000#, 16#0244#, 16#0244#, 16#0000#),
           ((0, 0), (472, 472), (472, 472), (0, 0)), 0, 0),
         16#8A#           =>  --  028A
          ((16#0000#, 16#01B1#, 16#01B1#, 16#0000#),
           ((0, 0), (473, 473), (473, 473), (0, 0)), 0, 0),
         16#8B#           =>  --  028B
          ((16#0000#, 16#01B2#, 16#01B2#, 16#0000#),
           ((0, 0), (474, 474), (474, 474), (0, 0)), 0, 0),
         16#8C#           =>  --  028C
          ((16#0000#, 16#0245#, 16#0245#, 16#0000#),
           ((0, 0), (475, 475), (475, 475), (0, 0)), 0, 0),
         16#92#           =>  --  0292
          ((16#0000#, 16#01B7#, 16#01B7#, 16#0000#),
           ((0, 0), (476, 476), (476, 476), (0, 0)), 0, 0),
         16#9E#           =>  --  029E
          ((16#0000#, 16#A7B0#, 16#A7B0#, 16#0000#),
           ((0, 0), (477, 477), (477, 477), (0, 0)), 0, 0),
         others           =>
          ((16#0000#, 16#0000#, 16#0000#, 16#0000#),
           ((0, 0), (0, 0), (0, 0), (0, 0)), 0, 0));

   Group_0003 : aliased constant Case_Mapping_Second_Stage
     := (16#45#           =>  --  0345
          ((16#0000#, 16#0399#, 16#0399#, 16#03B9#),
           ((0, 0), (478, 478), (478, 478), (479, 479)), 0, 0),
         16#70#           =>  --  0370
          ((16#0371#, 16#0000#, 16#0000#, 16#0371#),
           ((480, 480), (0, 0), (0, 0), (480, 480)), 0, 0),
         16#71#           =>  --  0371
          ((16#0000#, 16#0370#, 16#0370#, 16#0000#),
           ((0, 0), (481, 481), (481, 481), (0, 0)), 0, 0),
         16#72#           =>  --  0372
          ((16#0373#, 16#0000#, 16#0000#, 16#0373#),
           ((482, 482), (0, 0), (0, 0), (482, 482)), 0, 0),
         16#73#           =>  --  0373
          ((16#0000#, 16#0372#, 16#0372#, 16#0000#),
           ((0, 0), (483, 483), (483, 483), (0, 0)), 0, 0),
         16#76#           =>  --  0376
          ((16#0377#, 16#0000#, 16#0000#, 16#0377#),
           ((484, 484), (0, 0), (0, 0), (484, 484)), 0, 0),
         16#77#           =>  --  0377
          ((16#0000#, 16#0376#, 16#0376#, 16#0000#),
           ((0, 0), (485, 485), (485, 485), (0, 0)), 0, 0),
         16#7B#           =>  --  037B
          ((16#0000#, 16#03FD#, 16#03FD#, 16#0000#),
           ((0, 0), (486, 486), (486, 486), (0, 0)), 0, 0),
         16#7C#           =>  --  037C
          ((16#0000#, 16#03FE#, 16#03FE#, 16#0000#),
           ((0, 0), (487, 487), (487, 487), (0, 0)), 0, 0),
         16#7D#           =>  --  037D
          ((16#0000#, 16#03FF#, 16#03FF#, 16#0000#),
           ((0, 0), (488, 488), (488, 488), (0, 0)), 0, 0),
         16#7F#           =>  --  037F
          ((16#03F3#, 16#0000#, 16#0000#, 16#03F3#),
           ((489, 489), (0, 0), (0, 0), (489, 489)), 0, 0),
         16#86#           =>  --  0386
          ((16#03AC#, 16#0000#, 16#0000#, 16#03AC#),
           ((490, 490), (0, 0), (0, 0), (490, 490)), 0, 0),
         16#88#           =>  --  0388
          ((16#03AD#, 16#0000#, 16#0000#, 16#03AD#),
           ((491, 491), (0, 0), (0, 0), (491, 491)), 0, 0),
         16#89#           =>  --  0389
          ((16#03AE#, 16#0000#, 16#0000#, 16#03AE#),
           ((492, 492), (0, 0), (0, 0), (492, 492)), 0, 0),
         16#8A#           =>  --  038A
          ((16#03AF#, 16#0000#, 16#0000#, 16#03AF#),
           ((493, 493), (0, 0), (0, 0), (493, 493)), 0, 0),
         16#8C#           =>  --  038C
          ((16#03CC#, 16#0000#, 16#0000#, 16#03CC#),
           ((494, 494), (0, 0), (0, 0), (494, 494)), 0, 0),
         16#8E#           =>  --  038E
          ((16#03CD#, 16#0000#, 16#0000#, 16#03CD#),
           ((495, 495), (0, 0), (0, 0), (495, 495)), 0, 0),
         16#8F#           =>  --  038F
          ((16#03CE#, 16#0000#, 16#0000#, 16#03CE#),
           ((496, 496), (0, 0), (0, 0), (496, 496)), 0, 0),
         16#90#           =>  --  0390
          ((16#0000#, 16#0000#, 16#0000#, 16#0000#),
           ((0, 0), (497, 499), (497, 499), (500, 502)), 0, 0),
         16#91#           =>  --  0391
          ((16#03B1#, 16#0000#, 16#0000#, 16#03B1#),
           ((503, 503), (0, 0), (0, 0), (503, 503)), 0, 0),
         16#92#           =>  --  0392
          ((16#03B2#, 16#0000#, 16#0000#, 16#03B2#),
           ((504, 504), (0, 0), (0, 0), (504, 504)), 0, 0),
         16#93#           =>  --  0393
          ((16#03B3#, 16#0000#, 16#0000#, 16#03B3#),
           ((505, 505), (0, 0), (0, 0), (505, 505)), 0, 0),
         16#94#           =>  --  0394
          ((16#03B4#, 16#0000#, 16#0000#, 16#03B4#),
           ((506, 506), (0, 0), (0, 0), (506, 506)), 0, 0),
         16#95#           =>  --  0395
          ((16#03B5#, 16#0000#, 16#0000#, 16#03B5#),
           ((507, 507), (0, 0), (0, 0), (507, 507)), 0, 0),
         16#96#           =>  --  0396
          ((16#03B6#, 16#0000#, 16#0000#, 16#03B6#),
           ((508, 508), (0, 0), (0, 0), (508, 508)), 0, 0),
         16#97#           =>  --  0397
          ((16#03B7#, 16#0000#, 16#0000#, 16#03B7#),
           ((509, 509), (0, 0), (0, 0), (509, 509)), 0, 0),
         16#98#           =>  --  0398
          ((16#03B8#, 16#0000#, 16#0000#, 16#03B8#),
           ((510, 510), (0, 0), (0, 0), (510, 510)), 0, 0),
         16#99#           =>  --  0399
          ((16#03B9#, 16#0000#, 16#0000#, 16#03B9#),
           ((479, 479), (0, 0), (0, 0), (479, 479)), 0, 0),
         16#9A#           =>  --  039A
          ((16#03BA#, 16#0000#, 16#0000#, 16#03BA#),
           ((511, 511), (0, 0), (0, 0), (511, 511)), 0, 0),
         16#9B#           =>  --  039B
          ((16#03BB#, 16#0000#, 16#0000#, 16#03BB#),
           ((512, 512), (0, 0), (0, 0), (512, 512)), 0, 0),
         16#9C#           =>  --  039C
          ((16#03BC#, 16#0000#, 16#0000#, 16#03BC#),
           ((54, 54), (0, 0), (0, 0), (54, 54)), 0, 0),
         16#9D#           =>  --  039D
          ((16#03BD#, 16#0000#, 16#0000#, 16#03BD#),
           ((513, 513), (0, 0), (0, 0), (513, 513)), 0, 0),
         16#9E#           =>  --  039E
          ((16#03BE#, 16#0000#, 16#0000#, 16#03BE#),
           ((514, 514), (0, 0), (0, 0), (514, 514)), 0, 0),
         16#9F#           =>  --  039F
          ((16#03BF#, 16#0000#, 16#0000#, 16#03BF#),
           ((515, 515), (0, 0), (0, 0), (515, 515)), 0, 0),
         16#A0#           =>  --  03A0
          ((16#03C0#, 16#0000#, 16#0000#, 16#03C0#),
           ((516, 516), (0, 0), (0, 0), (516, 516)), 0, 0),
         16#A1#           =>  --  03A1
          ((16#03C1#, 16#0000#, 16#0000#, 16#03C1#),
           ((517, 517), (0, 0), (0, 0), (517, 517)), 0, 0),
         16#A3#           =>  --  03A3
          ((16#03C3#, 16#0000#, 16#0000#, 16#03C3#),
           ((518, 518), (0, 0), (0, 0), (518, 518)), 1, 1),
         16#A4#           =>  --  03A4
          ((16#03C4#, 16#0000#, 16#0000#, 16#03C4#),
           ((520, 520), (0, 0), (0, 0), (520, 520)), 0, 0),
         16#A5#           =>  --  03A5
          ((16#03C5#, 16#0000#, 16#0000#, 16#03C5#),
           ((521, 521), (0, 0), (0, 0), (521, 521)), 0, 0),
         16#A6#           =>  --  03A6
          ((16#03C6#, 16#0000#, 16#0000#, 16#03C6#),
           ((522, 522), (0, 0), (0, 0), (522, 522)), 0, 0),
         16#A7#           =>  --  03A7
          ((16#03C7#, 16#0000#, 16#0000#, 16#03C7#),
           ((523, 523), (0, 0), (0, 0), (523, 523)), 0, 0),
         16#A8#           =>  --  03A8
          ((16#03C8#, 16#0000#, 16#0000#, 16#03C8#),
           ((524, 524), (0, 0), (0, 0), (524, 524)), 0, 0),
         16#A9#           =>  --  03A9
          ((16#03C9#, 16#0000#, 16#0000#, 16#03C9#),
           ((525, 525), (0, 0), (0, 0), (525, 525)), 0, 0),
         16#AA#           =>  --  03AA
          ((16#03CA#, 16#0000#, 16#0000#, 16#03CA#),
           ((526, 526), (0, 0), (0, 0), (526, 526)), 0, 0),
         16#AB#           =>  --  03AB
          ((16#03CB#, 16#0000#, 16#0000#, 16#03CB#),
           ((527, 527), (0, 0), (0, 0), (527, 527)), 0, 0),
         16#AC#           =>  --  03AC
          ((16#0000#, 16#0386#, 16#0386#, 16#0000#),
           ((0, 0), (528, 528), (528, 528), (0, 0)), 0, 0),
         16#AD#           =>  --  03AD
          ((16#0000#, 16#0388#, 16#0388#, 16#0000#),
           ((0, 0), (529, 529), (529, 529), (0, 0)), 0, 0),
         16#AE#           =>  --  03AE
          ((16#0000#, 16#0389#, 16#0389#, 16#0000#),
           ((0, 0), (530, 530), (530, 530), (0, 0)), 0, 0),
         16#AF#           =>  --  03AF
          ((16#0000#, 16#038A#, 16#038A#, 16#0000#),
           ((0, 0), (531, 531), (531, 531), (0, 0)), 0, 0),
         16#B0#           =>  --  03B0
          ((16#0000#, 16#0000#, 16#0000#, 16#0000#),
           ((0, 0), (532, 534), (532, 534), (535, 537)), 0, 0),
         16#B1#           =>  --  03B1
          ((16#0000#, 16#0391#, 16#0391#, 16#0000#),
           ((0, 0), (538, 538), (538, 538), (0, 0)), 0, 0),
         16#B2#           =>  --  03B2
          ((16#0000#, 16#0392#, 16#0392#, 16#0000#),
           ((0, 0), (539, 539), (539, 539), (0, 0)), 0, 0),
         16#B3#           =>  --  03B3
          ((16#0000#, 16#0393#, 16#0393#, 16#0000#),
           ((0, 0), (540, 540), (540, 540), (0, 0)), 0, 0),
         16#B4#           =>  --  03B4
          ((16#0000#, 16#0394#, 16#0394#, 16#0000#),
           ((0, 0), (541, 541), (541, 541), (0, 0)), 0, 0),
         16#B5#           =>  --  03B5
          ((16#0000#, 16#0395#, 16#0395#, 16#0000#),
           ((0, 0), (542, 542), (542, 542), (0, 0)), 0, 0),
         16#B6#           =>  --  03B6
          ((16#0000#, 16#0396#, 16#0396#, 16#0000#),
           ((0, 0), (543, 543), (543, 543), (0, 0)), 0, 0),
         16#B7#           =>  --  03B7
          ((16#0000#, 16#0397#, 16#0397#, 16#0000#),
           ((0, 0), (544, 544), (544, 544), (0, 0)), 0, 0),
         16#B8#           =>  --  03B8
          ((16#0000#, 16#0398#, 16#0398#, 16#0000#),
           ((0, 0), (545, 545), (545, 545), (0, 0)), 0, 0),
         16#B9#           =>  --  03B9
          ((16#0000#, 16#0399#, 16#0399#, 16#0000#),
           ((0, 0), (478, 478), (478, 478), (0, 0)), 0, 0),
         16#BA#           =>  --  03BA
          ((16#0000#, 16#039A#, 16#039A#, 16#0000#),
           ((0, 0), (546, 546), (546, 546), (0, 0)), 0, 0),
         16#BB#           =>  --  03BB
          ((16#0000#, 16#039B#, 16#039B#, 16#0000#),
           ((0, 0), (547, 547), (547, 547), (0, 0)), 0, 0),
         16#BC#           =>  --  03BC
          ((16#0000#, 16#039C#, 16#039C#, 16#0000#),
           ((0, 0), (53, 53), (53, 53), (0, 0)), 0, 0),
         16#BD#           =>  --  03BD
          ((16#0000#, 16#039D#, 16#039D#, 16#0000#),
           ((0, 0), (548, 548), (548, 548), (0, 0)), 0, 0),
         16#BE#           =>  --  03BE
          ((16#0000#, 16#039E#, 16#039E#, 16#0000#),
           ((0, 0), (549, 549), (549, 549), (0, 0)), 0, 0),
         16#BF#           =>  --  03BF
          ((16#0000#, 16#039F#, 16#039F#, 16#0000#),
           ((0, 0), (550, 550), (550, 550), (0, 0)), 0, 0),
         16#C0#           =>  --  03C0
          ((16#0000#, 16#03A0#, 16#03A0#, 16#0000#),
           ((0, 0), (551, 551), (551, 551), (0, 0)), 0, 0),
         16#C1#           =>  --  03C1
          ((16#0000#, 16#03A1#, 16#03A1#, 16#0000#),
           ((0, 0), (552, 552), (552, 552), (0, 0)), 0, 0),
         16#C2#           =>  --  03C2
          ((16#0000#, 16#03A3#, 16#03A3#, 16#03C3#),
           ((0, 0), (553, 553), (553, 553), (518, 518)), 0, 0),
         16#C3#           =>  --  03C3
          ((16#0000#, 16#03A3#, 16#03A3#, 16#0000#),
           ((0, 0), (553, 553), (553, 553), (0, 0)), 0, 0),
         16#C4#           =>  --  03C4
          ((16#0000#, 16#03A4#, 16#03A4#, 16#0000#),
           ((0, 0), (554, 554), (554, 554), (0, 0)), 0, 0),
         16#C5#           =>  --  03C5
          ((16#0000#, 16#03A5#, 16#03A5#, 16#0000#),
           ((0, 0), (532, 532), (532, 532), (0, 0)), 0, 0),
         16#C6#           =>  --  03C6
          ((16#0000#, 16#03A6#, 16#03A6#, 16#0000#),
           ((0, 0), (555, 555), (555, 555), (0, 0)), 0, 0),
         16#C7#           =>  --  03C7
          ((16#0000#, 16#03A7#, 16#03A7#, 16#0000#),
           ((0, 0), (556, 556), (556, 556), (0, 0)), 0, 0),
         16#C8#           =>  --  03C8
          ((16#0000#, 16#03A8#, 16#03A8#, 16#0000#),
           ((0, 0), (557, 557), (557, 557), (0, 0)), 0, 0),
         16#C9#           =>  --  03C9
          ((16#0000#, 16#03A9#, 16#03A9#, 16#0000#),
           ((0, 0), (558, 558), (558, 558), (0, 0)), 0, 0),
         16#CA#           =>  --  03CA
          ((16#0000#, 16#03AA#, 16#03AA#, 16#0000#),
           ((0, 0), (559, 559), (559, 559), (0, 0)), 0, 0),
         16#CB#           =>  --  03CB
          ((16#0000#, 16#03AB#, 16#03AB#, 16#0000#),
           ((0, 0), (560, 560), (560, 560), (0, 0)), 0, 0),
         16#CC#           =>  --  03CC
          ((16#0000#, 16#038C#, 16#038C#, 16#0000#),
           ((0, 0), (561, 561), (561, 561), (0, 0)), 0, 0),
         16#CD#           =>  --  03CD
          ((16#0000#, 16#038E#, 16#038E#, 16#0000#),
           ((0, 0), (562, 562), (562, 562), (0, 0)), 0, 0),
         16#CE#           =>  --  03CE
          ((16#0000#, 16#038F#, 16#038F#, 16#0000#),
           ((0, 0), (563, 563), (563, 563), (0, 0)), 0, 0),
         16#CF#           =>  --  03CF
          ((16#03D7#, 16#0000#, 16#0000#, 16#03D7#),
           ((564, 564), (0, 0), (0, 0), (564, 564)), 0, 0),
         16#D0#           =>  --  03D0
          ((16#0000#, 16#0392#, 16#0392#, 16#03B2#),
           ((0, 0), (539, 539), (539, 539), (504, 504)), 0, 0),
         16#D1#           =>  --  03D1
          ((16#0000#, 16#0398#, 16#0398#, 16#03B8#),
           ((0, 0), (545, 545), (545, 545), (510, 510)), 0, 0),
         16#D5#           =>  --  03D5
          ((16#0000#, 16#03A6#, 16#03A6#, 16#03C6#),
           ((0, 0), (555, 555), (555, 555), (522, 522)), 0, 0),
         16#D6#           =>  --  03D6
          ((16#0000#, 16#03A0#, 16#03A0#, 16#03C0#),
           ((0, 0), (551, 551), (551, 551), (516, 516)), 0, 0),
         16#D7#           =>  --  03D7
          ((16#0000#, 16#03CF#, 16#03CF#, 16#0000#),
           ((0, 0), (565, 565), (565, 565), (0, 0)), 0, 0),
         16#D8#           =>  --  03D8
          ((16#03D9#, 16#0000#, 16#0000#, 16#03D9#),
           ((566, 566), (0, 0), (0, 0), (566, 566)), 0, 0),
         16#D9#           =>  --  03D9
          ((16#0000#, 16#03D8#, 16#03D8#, 16#0000#),
           ((0, 0), (567, 567), (567, 567), (0, 0)), 0, 0),
         16#DA#           =>  --  03DA
          ((16#03DB#, 16#0000#, 16#0000#, 16#03DB#),
           ((568, 568), (0, 0), (0, 0), (568, 568)), 0, 0),
         16#DB#           =>  --  03DB
          ((16#0000#, 16#03DA#, 16#03DA#, 16#0000#),
           ((0, 0), (569, 569), (569, 569), (0, 0)), 0, 0),
         16#DC#           =>  --  03DC
          ((16#03DD#, 16#0000#, 16#0000#, 16#03DD#),
           ((570, 570), (0, 0), (0, 0), (570, 570)), 0, 0),
         16#DD#           =>  --  03DD
          ((16#0000#, 16#03DC#, 16#03DC#, 16#0000#),
           ((0, 0), (571, 571), (571, 571), (0, 0)), 0, 0),
         16#DE#           =>  --  03DE
          ((16#03DF#, 16#0000#, 16#0000#, 16#03DF#),
           ((572, 572), (0, 0), (0, 0), (572, 572)), 0, 0),
         16#DF#           =>  --  03DF
          ((16#0000#, 16#03DE#, 16#03DE#, 16#0000#),
           ((0, 0), (573, 573), (573, 573), (0, 0)), 0, 0),
         16#E0#           =>  --  03E0
          ((16#03E1#, 16#0000#, 16#0000#, 16#03E1#),
           ((574, 574), (0, 0), (0, 0), (574, 574)), 0, 0),
         16#E1#           =>  --  03E1
          ((16#0000#, 16#03E0#, 16#03E0#, 16#0000#),
           ((0, 0), (575, 575), (575, 575), (0, 0)), 0, 0),
         16#E2#           =>  --  03E2
          ((16#03E3#, 16#0000#, 16#0000#, 16#03E3#),
           ((576, 576), (0, 0), (0, 0), (576, 576)), 0, 0),
         16#E3#           =>  --  03E3
          ((16#0000#, 16#03E2#, 16#03E2#, 16#0000#),
           ((0, 0), (577, 577), (577, 577), (0, 0)), 0, 0),
         16#E4#           =>  --  03E4
          ((16#03E5#, 16#0000#, 16#0000#, 16#03E5#),
           ((578, 578), (0, 0), (0, 0), (578, 578)), 0, 0),
         16#E5#           =>  --  03E5
          ((16#0000#, 16#03E4#, 16#03E4#, 16#0000#),
           ((0, 0), (579, 579), (579, 579), (0, 0)), 0, 0),
         16#E6#           =>  --  03E6
          ((16#03E7#, 16#0000#, 16#0000#, 16#03E7#),
           ((580, 580), (0, 0), (0, 0), (580, 580)), 0, 0),
         16#E7#           =>  --  03E7
          ((16#0000#, 16#03E6#, 16#03E6#, 16#0000#),
           ((0, 0), (581, 581), (581, 581), (0, 0)), 0, 0),
         16#E8#           =>  --  03E8
          ((16#03E9#, 16#0000#, 16#0000#, 16#03E9#),
           ((582, 582), (0, 0), (0, 0), (582, 582)), 0, 0),
         16#E9#           =>  --  03E9
          ((16#0000#, 16#03E8#, 16#03E8#, 16#0000#),
           ((0, 0), (583, 583), (583, 583), (0, 0)), 0, 0),
         16#EA#           =>  --  03EA
          ((16#03EB#, 16#0000#, 16#0000#, 16#03EB#),
           ((584, 584), (0, 0), (0, 0), (584, 584)), 0, 0),
         16#EB#           =>  --  03EB
          ((16#0000#, 16#03EA#, 16#03EA#, 16#0000#),
           ((0, 0), (585, 585), (585, 585), (0, 0)), 0, 0),
         16#EC#           =>  --  03EC
          ((16#03ED#, 16#0000#, 16#0000#, 16#03ED#),
           ((586, 586), (0, 0), (0, 0), (586, 586)), 0, 0),
         16#ED#           =>  --  03ED
          ((16#0000#, 16#03EC#, 16#03EC#, 16#0000#),
           ((0, 0), (587, 587), (587, 587), (0, 0)), 0, 0),
         16#EE#           =>  --  03EE
          ((16#03EF#, 16#0000#, 16#0000#, 16#03EF#),
           ((588, 588), (0, 0), (0, 0), (588, 588)), 0, 0),
         16#EF#           =>  --  03EF
          ((16#0000#, 16#03EE#, 16#03EE#, 16#0000#),
           ((0, 0), (589, 589), (589, 589), (0, 0)), 0, 0),
         16#F0#           =>  --  03F0
          ((16#0000#, 16#039A#, 16#039A#, 16#03BA#),
           ((0, 0), (546, 546), (546, 546), (511, 511)), 0, 0),
         16#F1#           =>  --  03F1
          ((16#0000#, 16#03A1#, 16#03A1#, 16#03C1#),
           ((0, 0), (552, 552), (552, 552), (517, 517)), 0, 0),
         16#F2#           =>  --  03F2
          ((16#0000#, 16#03F9#, 16#03F9#, 16#0000#),
           ((0, 0), (590, 590), (590, 590), (0, 0)), 0, 0),
         16#F3#           =>  --  03F3
          ((16#0000#, 16#037F#, 16#037F#, 16#0000#),
           ((0, 0), (591, 591), (591, 591), (0, 0)), 0, 0),
         16#F4#           =>  --  03F4
          ((16#03B8#, 16#0000#, 16#0000#, 16#03B8#),
           ((510, 510), (0, 0), (0, 0), (510, 510)), 0, 0),
         16#F5#           =>  --  03F5
          ((16#0000#, 16#0395#, 16#0395#, 16#03B5#),
           ((0, 0), (542, 542), (542, 542), (507, 507)), 0, 0),
         16#F7#           =>  --  03F7
          ((16#03F8#, 16#0000#, 16#0000#, 16#03F8#),
           ((592, 592), (0, 0), (0, 0), (592, 592)), 0, 0),
         16#F8#           =>  --  03F8
          ((16#0000#, 16#03F7#, 16#03F7#, 16#0000#),
           ((0, 0), (593, 593), (593, 593), (0, 0)), 0, 0),
         16#F9#           =>  --  03F9
          ((16#03F2#, 16#0000#, 16#0000#, 16#03F2#),
           ((594, 594), (0, 0), (0, 0), (594, 594)), 0, 0),
         16#FA#           =>  --  03FA
          ((16#03FB#, 16#0000#, 16#0000#, 16#03FB#),
           ((595, 595), (0, 0), (0, 0), (595, 595)), 0, 0),
         16#FB#           =>  --  03FB
          ((16#0000#, 16#03FA#, 16#03FA#, 16#0000#),
           ((0, 0), (596, 596), (596, 596), (0, 0)), 0, 0),
         16#FD#           =>  --  03FD
          ((16#037B#, 16#0000#, 16#0000#, 16#037B#),
           ((597, 597), (0, 0), (0, 0), (597, 597)), 0, 0),
         16#FE#           =>  --  03FE
          ((16#037C#, 16#0000#, 16#0000#, 16#037C#),
           ((598, 598), (0, 0), (0, 0), (598, 598)), 0, 0),
         16#FF#           =>  --  03FF
          ((16#037D#, 16#0000#, 16#0000#, 16#037D#),
           ((599, 599), (0, 0), (0, 0), (599, 599)), 0, 0),
         others           =>
          ((16#0000#, 16#0000#, 16#0000#, 16#0000#),
           ((0, 0), (0, 0), (0, 0), (0, 0)), 0, 0));

   Group_0004 : aliased constant Case_Mapping_Second_Stage
     := (16#00#           =>  --  0400
          ((16#0450#, 16#0000#, 16#0000#, 16#0450#),
           ((600, 600), (0, 0), (0, 0), (600, 600)), 0, 0),
         16#01#           =>  --  0401
          ((16#0451#, 16#0000#, 16#0000#, 16#0451#),
           ((601, 601), (0, 0), (0, 0), (601, 601)), 0, 0),
         16#02#           =>  --  0402
          ((16#0452#, 16#0000#, 16#0000#, 16#0452#),
           ((602, 602), (0, 0), (0, 0), (602, 602)), 0, 0),
         16#03#           =>  --  0403
          ((16#0453#, 16#0000#, 16#0000#, 16#0453#),
           ((603, 603), (0, 0), (0, 0), (603, 603)), 0, 0),
         16#04#           =>  --  0404
          ((16#0454#, 16#0000#, 16#0000#, 16#0454#),
           ((604, 604), (0, 0), (0, 0), (604, 604)), 0, 0),
         16#05#           =>  --  0405
          ((16#0455#, 16#0000#, 16#0000#, 16#0455#),
           ((605, 605), (0, 0), (0, 0), (605, 605)), 0, 0),
         16#06#           =>  --  0406
          ((16#0456#, 16#0000#, 16#0000#, 16#0456#),
           ((606, 606), (0, 0), (0, 0), (606, 606)), 0, 0),
         16#07#           =>  --  0407
          ((16#0457#, 16#0000#, 16#0000#, 16#0457#),
           ((607, 607), (0, 0), (0, 0), (607, 607)), 0, 0),
         16#08#           =>  --  0408
          ((16#0458#, 16#0000#, 16#0000#, 16#0458#),
           ((608, 608), (0, 0), (0, 0), (608, 608)), 0, 0),
         16#09#           =>  --  0409
          ((16#0459#, 16#0000#, 16#0000#, 16#0459#),
           ((609, 609), (0, 0), (0, 0), (609, 609)), 0, 0),
         16#0A#           =>  --  040A
          ((16#045A#, 16#0000#, 16#0000#, 16#045A#),
           ((610, 610), (0, 0), (0, 0), (610, 610)), 0, 0),
         16#0B#           =>  --  040B
          ((16#045B#, 16#0000#, 16#0000#, 16#045B#),
           ((611, 611), (0, 0), (0, 0), (611, 611)), 0, 0),
         16#0C#           =>  --  040C
          ((16#045C#, 16#0000#, 16#0000#, 16#045C#),
           ((612, 612), (0, 0), (0, 0), (612, 612)), 0, 0),
         16#0D#           =>  --  040D
          ((16#045D#, 16#0000#, 16#0000#, 16#045D#),
           ((613, 613), (0, 0), (0, 0), (613, 613)), 0, 0),
         16#0E#           =>  --  040E
          ((16#045E#, 16#0000#, 16#0000#, 16#045E#),
           ((614, 614), (0, 0), (0, 0), (614, 614)), 0, 0),
         16#0F#           =>  --  040F
          ((16#045F#, 16#0000#, 16#0000#, 16#045F#),
           ((615, 615), (0, 0), (0, 0), (615, 615)), 0, 0),
         16#10#           =>  --  0410
          ((16#0430#, 16#0000#, 16#0000#, 16#0430#),
           ((616, 616), (0, 0), (0, 0), (616, 616)), 0, 0),
         16#11#           =>  --  0411
          ((16#0431#, 16#0000#, 16#0000#, 16#0431#),
           ((617, 617), (0, 0), (0, 0), (617, 617)), 0, 0),
         16#12#           =>  --  0412
          ((16#0432#, 16#0000#, 16#0000#, 16#0432#),
           ((618, 618), (0, 0), (0, 0), (618, 618)), 0, 0),
         16#13#           =>  --  0413
          ((16#0433#, 16#0000#, 16#0000#, 16#0433#),
           ((619, 619), (0, 0), (0, 0), (619, 619)), 0, 0),
         16#14#           =>  --  0414
          ((16#0434#, 16#0000#, 16#0000#, 16#0434#),
           ((620, 620), (0, 0), (0, 0), (620, 620)), 0, 0),
         16#15#           =>  --  0415
          ((16#0435#, 16#0000#, 16#0000#, 16#0435#),
           ((621, 621), (0, 0), (0, 0), (621, 621)), 0, 0),
         16#16#           =>  --  0416
          ((16#0436#, 16#0000#, 16#0000#, 16#0436#),
           ((622, 622), (0, 0), (0, 0), (622, 622)), 0, 0),
         16#17#           =>  --  0417
          ((16#0437#, 16#0000#, 16#0000#, 16#0437#),
           ((623, 623), (0, 0), (0, 0), (623, 623)), 0, 0),
         16#18#           =>  --  0418
          ((16#0438#, 16#0000#, 16#0000#, 16#0438#),
           ((624, 624), (0, 0), (0, 0), (624, 624)), 0, 0),
         16#19#           =>  --  0419
          ((16#0439#, 16#0000#, 16#0000#, 16#0439#),
           ((625, 625), (0, 0), (0, 0), (625, 625)), 0, 0),
         16#1A#           =>  --  041A
          ((16#043A#, 16#0000#, 16#0000#, 16#043A#),
           ((626, 626), (0, 0), (0, 0), (626, 626)), 0, 0),
         16#1B#           =>  --  041B
          ((16#043B#, 16#0000#, 16#0000#, 16#043B#),
           ((627, 627), (0, 0), (0, 0), (627, 627)), 0, 0),
         16#1C#           =>  --  041C
          ((16#043C#, 16#0000#, 16#0000#, 16#043C#),
           ((628, 628), (0, 0), (0, 0), (628, 628)), 0, 0),
         16#1D#           =>  --  041D
          ((16#043D#, 16#0000#, 16#0000#, 16#043D#),
           ((629, 629), (0, 0), (0, 0), (629, 629)), 0, 0),
         16#1E#           =>  --  041E
          ((16#043E#, 16#0000#, 16#0000#, 16#043E#),
           ((630, 630), (0, 0), (0, 0), (630, 630)), 0, 0),
         16#1F#           =>  --  041F
          ((16#043F#, 16#0000#, 16#0000#, 16#043F#),
           ((631, 631), (0, 0), (0, 0), (631, 631)), 0, 0),
         16#20#           =>  --  0420
          ((16#0440#, 16#0000#, 16#0000#, 16#0440#),
           ((632, 632), (0, 0), (0, 0), (632, 632)), 0, 0),
         16#21#           =>  --  0421
          ((16#0441#, 16#0000#, 16#0000#, 16#0441#),
           ((633, 633), (0, 0), (0, 0), (633, 633)), 0, 0),
         16#22#           =>  --  0422
          ((16#0442#, 16#0000#, 16#0000#, 16#0442#),
           ((634, 634), (0, 0), (0, 0), (634, 634)), 0, 0),
         16#23#           =>  --  0423
          ((16#0443#, 16#0000#, 16#0000#, 16#0443#),
           ((635, 635), (0, 0), (0, 0), (635, 635)), 0, 0),
         16#24#           =>  --  0424
          ((16#0444#, 16#0000#, 16#0000#, 16#0444#),
           ((636, 636), (0, 0), (0, 0), (636, 636)), 0, 0),
         16#25#           =>  --  0425
          ((16#0445#, 16#0000#, 16#0000#, 16#0445#),
           ((637, 637), (0, 0), (0, 0), (637, 637)), 0, 0),
         16#26#           =>  --  0426
          ((16#0446#, 16#0000#, 16#0000#, 16#0446#),
           ((638, 638), (0, 0), (0, 0), (638, 638)), 0, 0),
         16#27#           =>  --  0427
          ((16#0447#, 16#0000#, 16#0000#, 16#0447#),
           ((639, 639), (0, 0), (0, 0), (639, 639)), 0, 0),
         16#28#           =>  --  0428
          ((16#0448#, 16#0000#, 16#0000#, 16#0448#),
           ((640, 640), (0, 0), (0, 0), (640, 640)), 0, 0),
         16#29#           =>  --  0429
          ((16#0449#, 16#0000#, 16#0000#, 16#0449#),
           ((641, 641), (0, 0), (0, 0), (641, 641)), 0, 0),
         16#2A#           =>  --  042A
          ((16#044A#, 16#0000#, 16#0000#, 16#044A#),
           ((642, 642), (0, 0), (0, 0), (642, 642)), 0, 0),
         16#2B#           =>  --  042B
          ((16#044B#, 16#0000#, 16#0000#, 16#044B#),
           ((643, 643), (0, 0), (0, 0), (643, 643)), 0, 0),
         16#2C#           =>  --  042C
          ((16#044C#, 16#0000#, 16#0000#, 16#044C#),
           ((644, 644), (0, 0), (0, 0), (644, 644)), 0, 0),
         16#2D#           =>  --  042D
          ((16#044D#, 16#0000#, 16#0000#, 16#044D#),
           ((645, 645), (0, 0), (0, 0), (645, 645)), 0, 0),
         16#2E#           =>  --  042E
          ((16#044E#, 16#0000#, 16#0000#, 16#044E#),
           ((646, 646), (0, 0), (0, 0), (646, 646)), 0, 0),
         16#2F#           =>  --  042F
          ((16#044F#, 16#0000#, 16#0000#, 16#044F#),
           ((647, 647), (0, 0), (0, 0), (647, 647)), 0, 0),
         16#30#           =>  --  0430
          ((16#0000#, 16#0410#, 16#0410#, 16#0000#),
           ((0, 0), (648, 648), (648, 648), (0, 0)), 0, 0),
         16#31#           =>  --  0431
          ((16#0000#, 16#0411#, 16#0411#, 16#0000#),
           ((0, 0), (649, 649), (649, 649), (0, 0)), 0, 0),
         16#32#           =>  --  0432
          ((16#0000#, 16#0412#, 16#0412#, 16#0000#),
           ((0, 0), (650, 650), (650, 650), (0, 0)), 0, 0),
         16#33#           =>  --  0433
          ((16#0000#, 16#0413#, 16#0413#, 16#0000#),
           ((0, 0), (651, 651), (651, 651), (0, 0)), 0, 0),
         16#34#           =>  --  0434
          ((16#0000#, 16#0414#, 16#0414#, 16#0000#),
           ((0, 0), (652, 652), (652, 652), (0, 0)), 0, 0),
         16#35#           =>  --  0435
          ((16#0000#, 16#0415#, 16#0415#, 16#0000#),
           ((0, 0), (653, 653), (653, 653), (0, 0)), 0, 0),
         16#36#           =>  --  0436
          ((16#0000#, 16#0416#, 16#0416#, 16#0000#),
           ((0, 0), (654, 654), (654, 654), (0, 0)), 0, 0),
         16#37#           =>  --  0437
          ((16#0000#, 16#0417#, 16#0417#, 16#0000#),
           ((0, 0), (655, 655), (655, 655), (0, 0)), 0, 0),
         16#38#           =>  --  0438
          ((16#0000#, 16#0418#, 16#0418#, 16#0000#),
           ((0, 0), (656, 656), (656, 656), (0, 0)), 0, 0),
         16#39#           =>  --  0439
          ((16#0000#, 16#0419#, 16#0419#, 16#0000#),
           ((0, 0), (657, 657), (657, 657), (0, 0)), 0, 0),
         16#3A#           =>  --  043A
          ((16#0000#, 16#041A#, 16#041A#, 16#0000#),
           ((0, 0), (658, 658), (658, 658), (0, 0)), 0, 0),
         16#3B#           =>  --  043B
          ((16#0000#, 16#041B#, 16#041B#, 16#0000#),
           ((0, 0), (659, 659), (659, 659), (0, 0)), 0, 0),
         16#3C#           =>  --  043C
          ((16#0000#, 16#041C#, 16#041C#, 16#0000#),
           ((0, 0), (660, 660), (660, 660), (0, 0)), 0, 0),
         16#3D#           =>  --  043D
          ((16#0000#, 16#041D#, 16#041D#, 16#0000#),
           ((0, 0), (661, 661), (661, 661), (0, 0)), 0, 0),
         16#3E#           =>  --  043E
          ((16#0000#, 16#041E#, 16#041E#, 16#0000#),
           ((0, 0), (662, 662), (662, 662), (0, 0)), 0, 0),
         16#3F#           =>  --  043F
          ((16#0000#, 16#041F#, 16#041F#, 16#0000#),
           ((0, 0), (663, 663), (663, 663), (0, 0)), 0, 0),
         16#40#           =>  --  0440
          ((16#0000#, 16#0420#, 16#0420#, 16#0000#),
           ((0, 0), (664, 664), (664, 664), (0, 0)), 0, 0),
         16#41#           =>  --  0441
          ((16#0000#, 16#0421#, 16#0421#, 16#0000#),
           ((0, 0), (665, 665), (665, 665), (0, 0)), 0, 0),
         16#42#           =>  --  0442
          ((16#0000#, 16#0422#, 16#0422#, 16#0000#),
           ((0, 0), (666, 666), (666, 666), (0, 0)), 0, 0),
         16#43#           =>  --  0443
          ((16#0000#, 16#0423#, 16#0423#, 16#0000#),
           ((0, 0), (667, 667), (667, 667), (0, 0)), 0, 0),
         16#44#           =>  --  0444
          ((16#0000#, 16#0424#, 16#0424#, 16#0000#),
           ((0, 0), (668, 668), (668, 668), (0, 0)), 0, 0),
         16#45#           =>  --  0445
          ((16#0000#, 16#0425#, 16#0425#, 16#0000#),
           ((0, 0), (669, 669), (669, 669), (0, 0)), 0, 0),
         16#46#           =>  --  0446
          ((16#0000#, 16#0426#, 16#0426#, 16#0000#),
           ((0, 0), (670, 670), (670, 670), (0, 0)), 0, 0),
         16#47#           =>  --  0447
          ((16#0000#, 16#0427#, 16#0427#, 16#0000#),
           ((0, 0), (671, 671), (671, 671), (0, 0)), 0, 0),
         16#48#           =>  --  0448
          ((16#0000#, 16#0428#, 16#0428#, 16#0000#),
           ((0, 0), (672, 672), (672, 672), (0, 0)), 0, 0),
         16#49#           =>  --  0449
          ((16#0000#, 16#0429#, 16#0429#, 16#0000#),
           ((0, 0), (673, 673), (673, 673), (0, 0)), 0, 0),
         16#4A#           =>  --  044A
          ((16#0000#, 16#042A#, 16#042A#, 16#0000#),
           ((0, 0), (674, 674), (674, 674), (0, 0)), 0, 0),
         16#4B#           =>  --  044B
          ((16#0000#, 16#042B#, 16#042B#, 16#0000#),
           ((0, 0), (675, 675), (675, 675), (0, 0)), 0, 0),
         16#4C#           =>  --  044C
          ((16#0000#, 16#042C#, 16#042C#, 16#0000#),
           ((0, 0), (676, 676), (676, 676), (0, 0)), 0, 0),
         16#4D#           =>  --  044D
          ((16#0000#, 16#042D#, 16#042D#, 16#0000#),
           ((0, 0), (677, 677), (677, 677), (0, 0)), 0, 0),
         16#4E#           =>  --  044E
          ((16#0000#, 16#042E#, 16#042E#, 16#0000#),
           ((0, 0), (678, 678), (678, 678), (0, 0)), 0, 0),
         16#4F#           =>  --  044F
          ((16#0000#, 16#042F#, 16#042F#, 16#0000#),
           ((0, 0), (679, 679), (679, 679), (0, 0)), 0, 0),
         16#50#           =>  --  0450
          ((16#0000#, 16#0400#, 16#0400#, 16#0000#),
           ((0, 0), (680, 680), (680, 680), (0, 0)), 0, 0),
         16#51#           =>  --  0451
          ((16#0000#, 16#0401#, 16#0401#, 16#0000#),
           ((0, 0), (681, 681), (681, 681), (0, 0)), 0, 0),
         16#52#           =>  --  0452
          ((16#0000#, 16#0402#, 16#0402#, 16#0000#),
           ((0, 0), (682, 682), (682, 682), (0, 0)), 0, 0),
         16#53#           =>  --  0453
          ((16#0000#, 16#0403#, 16#0403#, 16#0000#),
           ((0, 0), (683, 683), (683, 683), (0, 0)), 0, 0),
         16#54#           =>  --  0454
          ((16#0000#, 16#0404#, 16#0404#, 16#0000#),
           ((0, 0), (684, 684), (684, 684), (0, 0)), 0, 0),
         16#55#           =>  --  0455
          ((16#0000#, 16#0405#, 16#0405#, 16#0000#),
           ((0, 0), (685, 685), (685, 685), (0, 0)), 0, 0),
         16#56#           =>  --  0456
          ((16#0000#, 16#0406#, 16#0406#, 16#0000#),
           ((0, 0), (686, 686), (686, 686), (0, 0)), 0, 0),
         16#57#           =>  --  0457
          ((16#0000#, 16#0407#, 16#0407#, 16#0000#),
           ((0, 0), (687, 687), (687, 687), (0, 0)), 0, 0),
         16#58#           =>  --  0458
          ((16#0000#, 16#0408#, 16#0408#, 16#0000#),
           ((0, 0), (688, 688), (688, 688), (0, 0)), 0, 0),
         16#59#           =>  --  0459
          ((16#0000#, 16#0409#, 16#0409#, 16#0000#),
           ((0, 0), (689, 689), (689, 689), (0, 0)), 0, 0),
         16#5A#           =>  --  045A
          ((16#0000#, 16#040A#, 16#040A#, 16#0000#),
           ((0, 0), (690, 690), (690, 690), (0, 0)), 0, 0),
         16#5B#           =>  --  045B
          ((16#0000#, 16#040B#, 16#040B#, 16#0000#),
           ((0, 0), (691, 691), (691, 691), (0, 0)), 0, 0),
         16#5C#           =>  --  045C
          ((16#0000#, 16#040C#, 16#040C#, 16#0000#),
           ((0, 0), (692, 692), (692, 692), (0, 0)), 0, 0),
         16#5D#           =>  --  045D
          ((16#0000#, 16#040D#, 16#040D#, 16#0000#),
           ((0, 0), (693, 693), (693, 693), (0, 0)), 0, 0),
         16#5E#           =>  --  045E
          ((16#0000#, 16#040E#, 16#040E#, 16#0000#),
           ((0, 0), (694, 694), (694, 694), (0, 0)), 0, 0),
         16#5F#           =>  --  045F
          ((16#0000#, 16#040F#, 16#040F#, 16#0000#),
           ((0, 0), (695, 695), (695, 695), (0, 0)), 0, 0),
         16#60#           =>  --  0460
          ((16#0461#, 16#0000#, 16#0000#, 16#0461#),
           ((696, 696), (0, 0), (0, 0), (696, 696)), 0, 0),
         16#61#           =>  --  0461
          ((16#0000#, 16#0460#, 16#0460#, 16#0000#),
           ((0, 0), (697, 697), (697, 697), (0, 0)), 0, 0),
         16#62#           =>  --  0462
          ((16#0463#, 16#0000#, 16#0000#, 16#0463#),
           ((698, 698), (0, 0), (0, 0), (698, 698)), 0, 0),
         16#63#           =>  --  0463
          ((16#0000#, 16#0462#, 16#0462#, 16#0000#),
           ((0, 0), (699, 699), (699, 699), (0, 0)), 0, 0),
         16#64#           =>  --  0464
          ((16#0465#, 16#0000#, 16#0000#, 16#0465#),
           ((700, 700), (0, 0), (0, 0), (700, 700)), 0, 0),
         16#65#           =>  --  0465
          ((16#0000#, 16#0464#, 16#0464#, 16#0000#),
           ((0, 0), (701, 701), (701, 701), (0, 0)), 0, 0),
         16#66#           =>  --  0466
          ((16#0467#, 16#0000#, 16#0000#, 16#0467#),
           ((702, 702), (0, 0), (0, 0), (702, 702)), 0, 0),
         16#67#           =>  --  0467
          ((16#0000#, 16#0466#, 16#0466#, 16#0000#),
           ((0, 0), (703, 703), (703, 703), (0, 0)), 0, 0),
         16#68#           =>  --  0468
          ((16#0469#, 16#0000#, 16#0000#, 16#0469#),
           ((704, 704), (0, 0), (0, 0), (704, 704)), 0, 0),
         16#69#           =>  --  0469
          ((16#0000#, 16#0468#, 16#0468#, 16#0000#),
           ((0, 0), (705, 705), (705, 705), (0, 0)), 0, 0),
         16#6A#           =>  --  046A
          ((16#046B#, 16#0000#, 16#0000#, 16#046B#),
           ((706, 706), (0, 0), (0, 0), (706, 706)), 0, 0),
         16#6B#           =>  --  046B
          ((16#0000#, 16#046A#, 16#046A#, 16#0000#),
           ((0, 0), (707, 707), (707, 707), (0, 0)), 0, 0),
         16#6C#           =>  --  046C
          ((16#046D#, 16#0000#, 16#0000#, 16#046D#),
           ((708, 708), (0, 0), (0, 0), (708, 708)), 0, 0),
         16#6D#           =>  --  046D
          ((16#0000#, 16#046C#, 16#046C#, 16#0000#),
           ((0, 0), (709, 709), (709, 709), (0, 0)), 0, 0),
         16#6E#           =>  --  046E
          ((16#046F#, 16#0000#, 16#0000#, 16#046F#),
           ((710, 710), (0, 0), (0, 0), (710, 710)), 0, 0),
         16#6F#           =>  --  046F
          ((16#0000#, 16#046E#, 16#046E#, 16#0000#),
           ((0, 0), (711, 711), (711, 711), (0, 0)), 0, 0),
         16#70#           =>  --  0470
          ((16#0471#, 16#0000#, 16#0000#, 16#0471#),
           ((712, 712), (0, 0), (0, 0), (712, 712)), 0, 0),
         16#71#           =>  --  0471
          ((16#0000#, 16#0470#, 16#0470#, 16#0000#),
           ((0, 0), (713, 713), (713, 713), (0, 0)), 0, 0),
         16#72#           =>  --  0472
          ((16#0473#, 16#0000#, 16#0000#, 16#0473#),
           ((714, 714), (0, 0), (0, 0), (714, 714)), 0, 0),
         16#73#           =>  --  0473
          ((16#0000#, 16#0472#, 16#0472#, 16#0000#),
           ((0, 0), (715, 715), (715, 715), (0, 0)), 0, 0),
         16#74#           =>  --  0474
          ((16#0475#, 16#0000#, 16#0000#, 16#0475#),
           ((716, 716), (0, 0), (0, 0), (716, 716)), 0, 0),
         16#75#           =>  --  0475
          ((16#0000#, 16#0474#, 16#0474#, 16#0000#),
           ((0, 0), (717, 717), (717, 717), (0, 0)), 0, 0),
         16#76#           =>  --  0476
          ((16#0477#, 16#0000#, 16#0000#, 16#0477#),
           ((718, 718), (0, 0), (0, 0), (718, 718)), 0, 0),
         16#77#           =>  --  0477
          ((16#0000#, 16#0476#, 16#0476#, 16#0000#),
           ((0, 0), (719, 719), (719, 719), (0, 0)), 0, 0),
         16#78#           =>  --  0478
          ((16#0479#, 16#0000#, 16#0000#, 16#0479#),
           ((720, 720), (0, 0), (0, 0), (720, 720)), 0, 0),
         16#79#           =>  --  0479
          ((16#0000#, 16#0478#, 16#0478#, 16#0000#),
           ((0, 0), (721, 721), (721, 721), (0, 0)), 0, 0),
         16#7A#           =>  --  047A
          ((16#047B#, 16#0000#, 16#0000#, 16#047B#),
           ((722, 722), (0, 0), (0, 0), (722, 722)), 0, 0),
         16#7B#           =>  --  047B
          ((16#0000#, 16#047A#, 16#047A#, 16#0000#),
           ((0, 0), (723, 723), (723, 723), (0, 0)), 0, 0),
         16#7C#           =>  --  047C
          ((16#047D#, 16#0000#, 16#0000#, 16#047D#),
           ((724, 724), (0, 0), (0, 0), (724, 724)), 0, 0),
         16#7D#           =>  --  047D
          ((16#0000#, 16#047C#, 16#047C#, 16#0000#),
           ((0, 0), (725, 725), (725, 725), (0, 0)), 0, 0),
         16#7E#           =>  --  047E
          ((16#047F#, 16#0000#, 16#0000#, 16#047F#),
           ((726, 726), (0, 0), (0, 0), (726, 726)), 0, 0),
         16#7F#           =>  --  047F
          ((16#0000#, 16#047E#, 16#047E#, 16#0000#),
           ((0, 0), (727, 727), (727, 727), (0, 0)), 0, 0),
         16#80#           =>  --  0480
          ((16#0481#, 16#0000#, 16#0000#, 16#0481#),
           ((728, 728), (0, 0), (0, 0), (728, 728)), 0, 0),
         16#81#           =>  --  0481
          ((16#0000#, 16#0480#, 16#0480#, 16#0000#),
           ((0, 0), (729, 729), (729, 729), (0, 0)), 0, 0),
         16#8A#           =>  --  048A
          ((16#048B#, 16#0000#, 16#0000#, 16#048B#),
           ((730, 730), (0, 0), (0, 0), (730, 730)), 0, 0),
         16#8B#           =>  --  048B
          ((16#0000#, 16#048A#, 16#048A#, 16#0000#),
           ((0, 0), (731, 731), (731, 731), (0, 0)), 0, 0),
         16#8C#           =>  --  048C
          ((16#048D#, 16#0000#, 16#0000#, 16#048D#),
           ((732, 732), (0, 0), (0, 0), (732, 732)), 0, 0),
         16#8D#           =>  --  048D
          ((16#0000#, 16#048C#, 16#048C#, 16#0000#),
           ((0, 0), (733, 733), (733, 733), (0, 0)), 0, 0),
         16#8E#           =>  --  048E
          ((16#048F#, 16#0000#, 16#0000#, 16#048F#),
           ((734, 734), (0, 0), (0, 0), (734, 734)), 0, 0),
         16#8F#           =>  --  048F
          ((16#0000#, 16#048E#, 16#048E#, 16#0000#),
           ((0, 0), (735, 735), (735, 735), (0, 0)), 0, 0),
         16#90#           =>  --  0490
          ((16#0491#, 16#0000#, 16#0000#, 16#0491#),
           ((736, 736), (0, 0), (0, 0), (736, 736)), 0, 0),
         16#91#           =>  --  0491
          ((16#0000#, 16#0490#, 16#0490#, 16#0000#),
           ((0, 0), (737, 737), (737, 737), (0, 0)), 0, 0),
         16#92#           =>  --  0492
          ((16#0493#, 16#0000#, 16#0000#, 16#0493#),
           ((738, 738), (0, 0), (0, 0), (738, 738)), 0, 0),
         16#93#           =>  --  0493
          ((16#0000#, 16#0492#, 16#0492#, 16#0000#),
           ((0, 0), (739, 739), (739, 739), (0, 0)), 0, 0),
         16#94#           =>  --  0494
          ((16#0495#, 16#0000#, 16#0000#, 16#0495#),
           ((740, 740), (0, 0), (0, 0), (740, 740)), 0, 0),
         16#95#           =>  --  0495
          ((16#0000#, 16#0494#, 16#0494#, 16#0000#),
           ((0, 0), (741, 741), (741, 741), (0, 0)), 0, 0),
         16#96#           =>  --  0496
          ((16#0497#, 16#0000#, 16#0000#, 16#0497#),
           ((742, 742), (0, 0), (0, 0), (742, 742)), 0, 0),
         16#97#           =>  --  0497
          ((16#0000#, 16#0496#, 16#0496#, 16#0000#),
           ((0, 0), (743, 743), (743, 743), (0, 0)), 0, 0),
         16#98#           =>  --  0498
          ((16#0499#, 16#0000#, 16#0000#, 16#0499#),
           ((744, 744), (0, 0), (0, 0), (744, 744)), 0, 0),
         16#99#           =>  --  0499
          ((16#0000#, 16#0498#, 16#0498#, 16#0000#),
           ((0, 0), (745, 745), (745, 745), (0, 0)), 0, 0),
         16#9A#           =>  --  049A
          ((16#049B#, 16#0000#, 16#0000#, 16#049B#),
           ((746, 746), (0, 0), (0, 0), (746, 746)), 0, 0),
         16#9B#           =>  --  049B
          ((16#0000#, 16#049A#, 16#049A#, 16#0000#),
           ((0, 0), (747, 747), (747, 747), (0, 0)), 0, 0),
         16#9C#           =>  --  049C
          ((16#049D#, 16#0000#, 16#0000#, 16#049D#),
           ((748, 748), (0, 0), (0, 0), (748, 748)), 0, 0),
         16#9D#           =>  --  049D
          ((16#0000#, 16#049C#, 16#049C#, 16#0000#),
           ((0, 0), (749, 749), (749, 749), (0, 0)), 0, 0),
         16#9E#           =>  --  049E
          ((16#049F#, 16#0000#, 16#0000#, 16#049F#),
           ((750, 750), (0, 0), (0, 0), (750, 750)), 0, 0),
         16#9F#           =>  --  049F
          ((16#0000#, 16#049E#, 16#049E#, 16#0000#),
           ((0, 0), (751, 751), (751, 751), (0, 0)), 0, 0),
         16#A0#           =>  --  04A0
          ((16#04A1#, 16#0000#, 16#0000#, 16#04A1#),
           ((752, 752), (0, 0), (0, 0), (752, 752)), 0, 0),
         16#A1#           =>  --  04A1
          ((16#0000#, 16#04A0#, 16#04A0#, 16#0000#),
           ((0, 0), (753, 753), (753, 753), (0, 0)), 0, 0),
         16#A2#           =>  --  04A2
          ((16#04A3#, 16#0000#, 16#0000#, 16#04A3#),
           ((754, 754), (0, 0), (0, 0), (754, 754)), 0, 0),
         16#A3#           =>  --  04A3
          ((16#0000#, 16#04A2#, 16#04A2#, 16#0000#),
           ((0, 0), (755, 755), (755, 755), (0, 0)), 0, 0),
         16#A4#           =>  --  04A4
          ((16#04A5#, 16#0000#, 16#0000#, 16#04A5#),
           ((756, 756), (0, 0), (0, 0), (756, 756)), 0, 0),
         16#A5#           =>  --  04A5
          ((16#0000#, 16#04A4#, 16#04A4#, 16#0000#),
           ((0, 0), (757, 757), (757, 757), (0, 0)), 0, 0),
         16#A6#           =>  --  04A6
          ((16#04A7#, 16#0000#, 16#0000#, 16#04A7#),
           ((758, 758), (0, 0), (0, 0), (758, 758)), 0, 0),
         16#A7#           =>  --  04A7
          ((16#0000#, 16#04A6#, 16#04A6#, 16#0000#),
           ((0, 0), (759, 759), (759, 759), (0, 0)), 0, 0),
         16#A8#           =>  --  04A8
          ((16#04A9#, 16#0000#, 16#0000#, 16#04A9#),
           ((760, 760), (0, 0), (0, 0), (760, 760)), 0, 0),
         16#A9#           =>  --  04A9
          ((16#0000#, 16#04A8#, 16#04A8#, 16#0000#),
           ((0, 0), (761, 761), (761, 761), (0, 0)), 0, 0),
         16#AA#           =>  --  04AA
          ((16#04AB#, 16#0000#, 16#0000#, 16#04AB#),
           ((762, 762), (0, 0), (0, 0), (762, 762)), 0, 0),
         16#AB#           =>  --  04AB
          ((16#0000#, 16#04AA#, 16#04AA#, 16#0000#),
           ((0, 0), (763, 763), (763, 763), (0, 0)), 0, 0),
         16#AC#           =>  --  04AC
          ((16#04AD#, 16#0000#, 16#0000#, 16#04AD#),
           ((764, 764), (0, 0), (0, 0), (764, 764)), 0, 0),
         16#AD#           =>  --  04AD
          ((16#0000#, 16#04AC#, 16#04AC#, 16#0000#),
           ((0, 0), (765, 765), (765, 765), (0, 0)), 0, 0),
         16#AE#           =>  --  04AE
          ((16#04AF#, 16#0000#, 16#0000#, 16#04AF#),
           ((766, 766), (0, 0), (0, 0), (766, 766)), 0, 0),
         16#AF#           =>  --  04AF
          ((16#0000#, 16#04AE#, 16#04AE#, 16#0000#),
           ((0, 0), (767, 767), (767, 767), (0, 0)), 0, 0),
         16#B0#           =>  --  04B0
          ((16#04B1#, 16#0000#, 16#0000#, 16#04B1#),
           ((768, 768), (0, 0), (0, 0), (768, 768)), 0, 0),
         16#B1#           =>  --  04B1
          ((16#0000#, 16#04B0#, 16#04B0#, 16#0000#),
           ((0, 0), (769, 769), (769, 769), (0, 0)), 0, 0),
         16#B2#           =>  --  04B2
          ((16#04B3#, 16#0000#, 16#0000#, 16#04B3#),
           ((770, 770), (0, 0), (0, 0), (770, 770)), 0, 0),
         16#B3#           =>  --  04B3
          ((16#0000#, 16#04B2#, 16#04B2#, 16#0000#),
           ((0, 0), (771, 771), (771, 771), (0, 0)), 0, 0),
         16#B4#           =>  --  04B4
          ((16#04B5#, 16#0000#, 16#0000#, 16#04B5#),
           ((772, 772), (0, 0), (0, 0), (772, 772)), 0, 0),
         16#B5#           =>  --  04B5
          ((16#0000#, 16#04B4#, 16#04B4#, 16#0000#),
           ((0, 0), (773, 773), (773, 773), (0, 0)), 0, 0),
         16#B6#           =>  --  04B6
          ((16#04B7#, 16#0000#, 16#0000#, 16#04B7#),
           ((774, 774), (0, 0), (0, 0), (774, 774)), 0, 0),
         16#B7#           =>  --  04B7
          ((16#0000#, 16#04B6#, 16#04B6#, 16#0000#),
           ((0, 0), (775, 775), (775, 775), (0, 0)), 0, 0),
         16#B8#           =>  --  04B8
          ((16#04B9#, 16#0000#, 16#0000#, 16#04B9#),
           ((776, 776), (0, 0), (0, 0), (776, 776)), 0, 0),
         16#B9#           =>  --  04B9
          ((16#0000#, 16#04B8#, 16#04B8#, 16#0000#),
           ((0, 0), (777, 777), (777, 777), (0, 0)), 0, 0),
         16#BA#           =>  --  04BA
          ((16#04BB#, 16#0000#, 16#0000#, 16#04BB#),
           ((778, 778), (0, 0), (0, 0), (778, 778)), 0, 0),
         16#BB#           =>  --  04BB
          ((16#0000#, 16#04BA#, 16#04BA#, 16#0000#),
           ((0, 0), (779, 779), (779, 779), (0, 0)), 0, 0),
         16#BC#           =>  --  04BC
          ((16#04BD#, 16#0000#, 16#0000#, 16#04BD#),
           ((780, 780), (0, 0), (0, 0), (780, 780)), 0, 0),
         16#BD#           =>  --  04BD
          ((16#0000#, 16#04BC#, 16#04BC#, 16#0000#),
           ((0, 0), (781, 781), (781, 781), (0, 0)), 0, 0),
         16#BE#           =>  --  04BE
          ((16#04BF#, 16#0000#, 16#0000#, 16#04BF#),
           ((782, 782), (0, 0), (0, 0), (782, 782)), 0, 0),
         16#BF#           =>  --  04BF
          ((16#0000#, 16#04BE#, 16#04BE#, 16#0000#),
           ((0, 0), (783, 783), (783, 783), (0, 0)), 0, 0),
         16#C0#           =>  --  04C0
          ((16#04CF#, 16#0000#, 16#0000#, 16#04CF#),
           ((784, 784), (0, 0), (0, 0), (784, 784)), 0, 0),
         16#C1#           =>  --  04C1
          ((16#04C2#, 16#0000#, 16#0000#, 16#04C2#),
           ((785, 785), (0, 0), (0, 0), (785, 785)), 0, 0),
         16#C2#           =>  --  04C2
          ((16#0000#, 16#04C1#, 16#04C1#, 16#0000#),
           ((0, 0), (786, 786), (786, 786), (0, 0)), 0, 0),
         16#C3#           =>  --  04C3
          ((16#04C4#, 16#0000#, 16#0000#, 16#04C4#),
           ((787, 787), (0, 0), (0, 0), (787, 787)), 0, 0),
         16#C4#           =>  --  04C4
          ((16#0000#, 16#04C3#, 16#04C3#, 16#0000#),
           ((0, 0), (788, 788), (788, 788), (0, 0)), 0, 0),
         16#C5#           =>  --  04C5
          ((16#04C6#, 16#0000#, 16#0000#, 16#04C6#),
           ((789, 789), (0, 0), (0, 0), (789, 789)), 0, 0),
         16#C6#           =>  --  04C6
          ((16#0000#, 16#04C5#, 16#04C5#, 16#0000#),
           ((0, 0), (790, 790), (790, 790), (0, 0)), 0, 0),
         16#C7#           =>  --  04C7
          ((16#04C8#, 16#0000#, 16#0000#, 16#04C8#),
           ((791, 791), (0, 0), (0, 0), (791, 791)), 0, 0),
         16#C8#           =>  --  04C8
          ((16#0000#, 16#04C7#, 16#04C7#, 16#0000#),
           ((0, 0), (792, 792), (792, 792), (0, 0)), 0, 0),
         16#C9#           =>  --  04C9
          ((16#04CA#, 16#0000#, 16#0000#, 16#04CA#),
           ((793, 793), (0, 0), (0, 0), (793, 793)), 0, 0),
         16#CA#           =>  --  04CA
          ((16#0000#, 16#04C9#, 16#04C9#, 16#0000#),
           ((0, 0), (794, 794), (794, 794), (0, 0)), 0, 0),
         16#CB#           =>  --  04CB
          ((16#04CC#, 16#0000#, 16#0000#, 16#04CC#),
           ((795, 795), (0, 0), (0, 0), (795, 795)), 0, 0),
         16#CC#           =>  --  04CC
          ((16#0000#, 16#04CB#, 16#04CB#, 16#0000#),
           ((0, 0), (796, 796), (796, 796), (0, 0)), 0, 0),
         16#CD#           =>  --  04CD
          ((16#04CE#, 16#0000#, 16#0000#, 16#04CE#),
           ((797, 797), (0, 0), (0, 0), (797, 797)), 0, 0),
         16#CE#           =>  --  04CE
          ((16#0000#, 16#04CD#, 16#04CD#, 16#0000#),
           ((0, 0), (798, 798), (798, 798), (0, 0)), 0, 0),
         16#CF#           =>  --  04CF
          ((16#0000#, 16#04C0#, 16#04C0#, 16#0000#),
           ((0, 0), (799, 799), (799, 799), (0, 0)), 0, 0),
         16#D0#           =>  --  04D0
          ((16#04D1#, 16#0000#, 16#0000#, 16#04D1#),
           ((800, 800), (0, 0), (0, 0), (800, 800)), 0, 0),
         16#D1#           =>  --  04D1
          ((16#0000#, 16#04D0#, 16#04D0#, 16#0000#),
           ((0, 0), (801, 801), (801, 801), (0, 0)), 0, 0),
         16#D2#           =>  --  04D2
          ((16#04D3#, 16#0000#, 16#0000#, 16#04D3#),
           ((802, 802), (0, 0), (0, 0), (802, 802)), 0, 0),
         16#D3#           =>  --  04D3
          ((16#0000#, 16#04D2#, 16#04D2#, 16#0000#),
           ((0, 0), (803, 803), (803, 803), (0, 0)), 0, 0),
         16#D4#           =>  --  04D4
          ((16#04D5#, 16#0000#, 16#0000#, 16#04D5#),
           ((804, 804), (0, 0), (0, 0), (804, 804)), 0, 0),
         16#D5#           =>  --  04D5
          ((16#0000#, 16#04D4#, 16#04D4#, 16#0000#),
           ((0, 0), (805, 805), (805, 805), (0, 0)), 0, 0),
         16#D6#           =>  --  04D6
          ((16#04D7#, 16#0000#, 16#0000#, 16#04D7#),
           ((806, 806), (0, 0), (0, 0), (806, 806)), 0, 0),
         16#D7#           =>  --  04D7
          ((16#0000#, 16#04D6#, 16#04D6#, 16#0000#),
           ((0, 0), (807, 807), (807, 807), (0, 0)), 0, 0),
         16#D8#           =>  --  04D8
          ((16#04D9#, 16#0000#, 16#0000#, 16#04D9#),
           ((808, 808), (0, 0), (0, 0), (808, 808)), 0, 0),
         16#D9#           =>  --  04D9
          ((16#0000#, 16#04D8#, 16#04D8#, 16#0000#),
           ((0, 0), (809, 809), (809, 809), (0, 0)), 0, 0),
         16#DA#           =>  --  04DA
          ((16#04DB#, 16#0000#, 16#0000#, 16#04DB#),
           ((810, 810), (0, 0), (0, 0), (810, 810)), 0, 0),
         16#DB#           =>  --  04DB
          ((16#0000#, 16#04DA#, 16#04DA#, 16#0000#),
           ((0, 0), (811, 811), (811, 811), (0, 0)), 0, 0),
         16#DC#           =>  --  04DC
          ((16#04DD#, 16#0000#, 16#0000#, 16#04DD#),
           ((812, 812), (0, 0), (0, 0), (812, 812)), 0, 0),
         16#DD#           =>  --  04DD
          ((16#0000#, 16#04DC#, 16#04DC#, 16#0000#),
           ((0, 0), (813, 813), (813, 813), (0, 0)), 0, 0),
         16#DE#           =>  --  04DE
          ((16#04DF#, 16#0000#, 16#0000#, 16#04DF#),
           ((814, 814), (0, 0), (0, 0), (814, 814)), 0, 0),
         16#DF#           =>  --  04DF
          ((16#0000#, 16#04DE#, 16#04DE#, 16#0000#),
           ((0, 0), (815, 815), (815, 815), (0, 0)), 0, 0),
         16#E0#           =>  --  04E0
          ((16#04E1#, 16#0000#, 16#0000#, 16#04E1#),
           ((816, 816), (0, 0), (0, 0), (816, 816)), 0, 0),
         16#E1#           =>  --  04E1
          ((16#0000#, 16#04E0#, 16#04E0#, 16#0000#),
           ((0, 0), (817, 817), (817, 817), (0, 0)), 0, 0),
         16#E2#           =>  --  04E2
          ((16#04E3#, 16#0000#, 16#0000#, 16#04E3#),
           ((818, 818), (0, 0), (0, 0), (818, 818)), 0, 0),
         16#E3#           =>  --  04E3
          ((16#0000#, 16#04E2#, 16#04E2#, 16#0000#),
           ((0, 0), (819, 819), (819, 819), (0, 0)), 0, 0),
         16#E4#           =>  --  04E4
          ((16#04E5#, 16#0000#, 16#0000#, 16#04E5#),
           ((820, 820), (0, 0), (0, 0), (820, 820)), 0, 0),
         16#E5#           =>  --  04E5
          ((16#0000#, 16#04E4#, 16#04E4#, 16#0000#),
           ((0, 0), (821, 821), (821, 821), (0, 0)), 0, 0),
         16#E6#           =>  --  04E6
          ((16#04E7#, 16#0000#, 16#0000#, 16#04E7#),
           ((822, 822), (0, 0), (0, 0), (822, 822)), 0, 0),
         16#E7#           =>  --  04E7
          ((16#0000#, 16#04E6#, 16#04E6#, 16#0000#),
           ((0, 0), (823, 823), (823, 823), (0, 0)), 0, 0),
         16#E8#           =>  --  04E8
          ((16#04E9#, 16#0000#, 16#0000#, 16#04E9#),
           ((824, 824), (0, 0), (0, 0), (824, 824)), 0, 0),
         16#E9#           =>  --  04E9
          ((16#0000#, 16#04E8#, 16#04E8#, 16#0000#),
           ((0, 0), (825, 825), (825, 825), (0, 0)), 0, 0),
         16#EA#           =>  --  04EA
          ((16#04EB#, 16#0000#, 16#0000#, 16#04EB#),
           ((826, 826), (0, 0), (0, 0), (826, 826)), 0, 0),
         16#EB#           =>  --  04EB
          ((16#0000#, 16#04EA#, 16#04EA#, 16#0000#),
           ((0, 0), (827, 827), (827, 827), (0, 0)), 0, 0),
         16#EC#           =>  --  04EC
          ((16#04ED#, 16#0000#, 16#0000#, 16#04ED#),
           ((828, 828), (0, 0), (0, 0), (828, 828)), 0, 0),
         16#ED#           =>  --  04ED
          ((16#0000#, 16#04EC#, 16#04EC#, 16#0000#),
           ((0, 0), (829, 829), (829, 829), (0, 0)), 0, 0),
         16#EE#           =>  --  04EE
          ((16#04EF#, 16#0000#, 16#0000#, 16#04EF#),
           ((830, 830), (0, 0), (0, 0), (830, 830)), 0, 0),
         16#EF#           =>  --  04EF
          ((16#0000#, 16#04EE#, 16#04EE#, 16#0000#),
           ((0, 0), (831, 831), (831, 831), (0, 0)), 0, 0),
         16#F0#           =>  --  04F0
          ((16#04F1#, 16#0000#, 16#0000#, 16#04F1#),
           ((832, 832), (0, 0), (0, 0), (832, 832)), 0, 0),
         16#F1#           =>  --  04F1
          ((16#0000#, 16#04F0#, 16#04F0#, 16#0000#),
           ((0, 0), (833, 833), (833, 833), (0, 0)), 0, 0),
         16#F2#           =>  --  04F2
          ((16#04F3#, 16#0000#, 16#0000#, 16#04F3#),
           ((834, 834), (0, 0), (0, 0), (834, 834)), 0, 0),
         16#F3#           =>  --  04F3
          ((16#0000#, 16#04F2#, 16#04F2#, 16#0000#),
           ((0, 0), (835, 835), (835, 835), (0, 0)), 0, 0),
         16#F4#           =>  --  04F4
          ((16#04F5#, 16#0000#, 16#0000#, 16#04F5#),
           ((836, 836), (0, 0), (0, 0), (836, 836)), 0, 0),
         16#F5#           =>  --  04F5
          ((16#0000#, 16#04F4#, 16#04F4#, 16#0000#),
           ((0, 0), (837, 837), (837, 837), (0, 0)), 0, 0),
         16#F6#           =>  --  04F6
          ((16#04F7#, 16#0000#, 16#0000#, 16#04F7#),
           ((838, 838), (0, 0), (0, 0), (838, 838)), 0, 0),
         16#F7#           =>  --  04F7
          ((16#0000#, 16#04F6#, 16#04F6#, 16#0000#),
           ((0, 0), (839, 839), (839, 839), (0, 0)), 0, 0),
         16#F8#           =>  --  04F8
          ((16#04F9#, 16#0000#, 16#0000#, 16#04F9#),
           ((840, 840), (0, 0), (0, 0), (840, 840)), 0, 0),
         16#F9#           =>  --  04F9
          ((16#0000#, 16#04F8#, 16#04F8#, 16#0000#),
           ((0, 0), (841, 841), (841, 841), (0, 0)), 0, 0),
         16#FA#           =>  --  04FA
          ((16#04FB#, 16#0000#, 16#0000#, 16#04FB#),
           ((842, 842), (0, 0), (0, 0), (842, 842)), 0, 0),
         16#FB#           =>  --  04FB
          ((16#0000#, 16#04FA#, 16#04FA#, 16#0000#),
           ((0, 0), (843, 843), (843, 843), (0, 0)), 0, 0),
         16#FC#           =>  --  04FC
          ((16#04FD#, 16#0000#, 16#0000#, 16#04FD#),
           ((844, 844), (0, 0), (0, 0), (844, 844)), 0, 0),
         16#FD#           =>  --  04FD
          ((16#0000#, 16#04FC#, 16#04FC#, 16#0000#),
           ((0, 0), (845, 845), (845, 845), (0, 0)), 0, 0),
         16#FE#           =>  --  04FE
          ((16#04FF#, 16#0000#, 16#0000#, 16#04FF#),
           ((846, 846), (0, 0), (0, 0), (846, 846)), 0, 0),
         16#FF#           =>  --  04FF
          ((16#0000#, 16#04FE#, 16#04FE#, 16#0000#),
           ((0, 0), (847, 847), (847, 847), (0, 0)), 0, 0),
         others           =>
          ((16#0000#, 16#0000#, 16#0000#, 16#0000#),
           ((0, 0), (0, 0), (0, 0), (0, 0)), 0, 0));

   Group_0005 : aliased constant Case_Mapping_Second_Stage
     := (16#00#           =>  --  0500
          ((16#0501#, 16#0000#, 16#0000#, 16#0501#),
           ((848, 848), (0, 0), (0, 0), (848, 848)), 0, 0),
         16#01#           =>  --  0501
          ((16#0000#, 16#0500#, 16#0500#, 16#0000#),
           ((0, 0), (849, 849), (849, 849), (0, 0)), 0, 0),
         16#02#           =>  --  0502
          ((16#0503#, 16#0000#, 16#0000#, 16#0503#),
           ((850, 850), (0, 0), (0, 0), (850, 850)), 0, 0),
         16#03#           =>  --  0503
          ((16#0000#, 16#0502#, 16#0502#, 16#0000#),
           ((0, 0), (851, 851), (851, 851), (0, 0)), 0, 0),
         16#04#           =>  --  0504
          ((16#0505#, 16#0000#, 16#0000#, 16#0505#),
           ((852, 852), (0, 0), (0, 0), (852, 852)), 0, 0),
         16#05#           =>  --  0505
          ((16#0000#, 16#0504#, 16#0504#, 16#0000#),
           ((0, 0), (853, 853), (853, 853), (0, 0)), 0, 0),
         16#06#           =>  --  0506
          ((16#0507#, 16#0000#, 16#0000#, 16#0507#),
           ((854, 854), (0, 0), (0, 0), (854, 854)), 0, 0),
         16#07#           =>  --  0507
          ((16#0000#, 16#0506#, 16#0506#, 16#0000#),
           ((0, 0), (855, 855), (855, 855), (0, 0)), 0, 0),
         16#08#           =>  --  0508
          ((16#0509#, 16#0000#, 16#0000#, 16#0509#),
           ((856, 856), (0, 0), (0, 0), (856, 856)), 0, 0),
         16#09#           =>  --  0509
          ((16#0000#, 16#0508#, 16#0508#, 16#0000#),
           ((0, 0), (857, 857), (857, 857), (0, 0)), 0, 0),
         16#0A#           =>  --  050A
          ((16#050B#, 16#0000#, 16#0000#, 16#050B#),
           ((858, 858), (0, 0), (0, 0), (858, 858)), 0, 0),
         16#0B#           =>  --  050B
          ((16#0000#, 16#050A#, 16#050A#, 16#0000#),
           ((0, 0), (859, 859), (859, 859), (0, 0)), 0, 0),
         16#0C#           =>  --  050C
          ((16#050D#, 16#0000#, 16#0000#, 16#050D#),
           ((860, 860), (0, 0), (0, 0), (860, 860)), 0, 0),
         16#0D#           =>  --  050D
          ((16#0000#, 16#050C#, 16#050C#, 16#0000#),
           ((0, 0), (861, 861), (861, 861), (0, 0)), 0, 0),
         16#0E#           =>  --  050E
          ((16#050F#, 16#0000#, 16#0000#, 16#050F#),
           ((862, 862), (0, 0), (0, 0), (862, 862)), 0, 0),
         16#0F#           =>  --  050F
          ((16#0000#, 16#050E#, 16#050E#, 16#0000#),
           ((0, 0), (863, 863), (863, 863), (0, 0)), 0, 0),
         16#10#           =>  --  0510
          ((16#0511#, 16#0000#, 16#0000#, 16#0511#),
           ((864, 864), (0, 0), (0, 0), (864, 864)), 0, 0),
         16#11#           =>  --  0511
          ((16#0000#, 16#0510#, 16#0510#, 16#0000#),
           ((0, 0), (865, 865), (865, 865), (0, 0)), 0, 0),
         16#12#           =>  --  0512
          ((16#0513#, 16#0000#, 16#0000#, 16#0513#),
           ((866, 866), (0, 0), (0, 0), (866, 866)), 0, 0),
         16#13#           =>  --  0513
          ((16#0000#, 16#0512#, 16#0512#, 16#0000#),
           ((0, 0), (867, 867), (867, 867), (0, 0)), 0, 0),
         16#14#           =>  --  0514
          ((16#0515#, 16#0000#, 16#0000#, 16#0515#),
           ((868, 868), (0, 0), (0, 0), (868, 868)), 0, 0),
         16#15#           =>  --  0515
          ((16#0000#, 16#0514#, 16#0514#, 16#0000#),
           ((0, 0), (869, 869), (869, 869), (0, 0)), 0, 0),
         16#16#           =>  --  0516
          ((16#0517#, 16#0000#, 16#0000#, 16#0517#),
           ((870, 870), (0, 0), (0, 0), (870, 870)), 0, 0),
         16#17#           =>  --  0517
          ((16#0000#, 16#0516#, 16#0516#, 16#0000#),
           ((0, 0), (871, 871), (871, 871), (0, 0)), 0, 0),
         16#18#           =>  --  0518
          ((16#0519#, 16#0000#, 16#0000#, 16#0519#),
           ((872, 872), (0, 0), (0, 0), (872, 872)), 0, 0),
         16#19#           =>  --  0519
          ((16#0000#, 16#0518#, 16#0518#, 16#0000#),
           ((0, 0), (873, 873), (873, 873), (0, 0)), 0, 0),
         16#1A#           =>  --  051A
          ((16#051B#, 16#0000#, 16#0000#, 16#051B#),
           ((874, 874), (0, 0), (0, 0), (874, 874)), 0, 0),
         16#1B#           =>  --  051B
          ((16#0000#, 16#051A#, 16#051A#, 16#0000#),
           ((0, 0), (875, 875), (875, 875), (0, 0)), 0, 0),
         16#1C#           =>  --  051C
          ((16#051D#, 16#0000#, 16#0000#, 16#051D#),
           ((876, 876), (0, 0), (0, 0), (876, 876)), 0, 0),
         16#1D#           =>  --  051D
          ((16#0000#, 16#051C#, 16#051C#, 16#0000#),
           ((0, 0), (877, 877), (877, 877), (0, 0)), 0, 0),
         16#1E#           =>  --  051E
          ((16#051F#, 16#0000#, 16#0000#, 16#051F#),
           ((878, 878), (0, 0), (0, 0), (878, 878)), 0, 0),
         16#1F#           =>  --  051F
          ((16#0000#, 16#051E#, 16#051E#, 16#0000#),
           ((0, 0), (879, 879), (879, 879), (0, 0)), 0, 0),
         16#20#           =>  --  0520
          ((16#0521#, 16#0000#, 16#0000#, 16#0521#),
           ((880, 880), (0, 0), (0, 0), (880, 880)), 0, 0),
         16#21#           =>  --  0521
          ((16#0000#, 16#0520#, 16#0520#, 16#0000#),
           ((0, 0), (881, 881), (881, 881), (0, 0)), 0, 0),
         16#22#           =>  --  0522
          ((16#0523#, 16#0000#, 16#0000#, 16#0523#),
           ((882, 882), (0, 0), (0, 0), (882, 882)), 0, 0),
         16#23#           =>  --  0523
          ((16#0000#, 16#0522#, 16#0522#, 16#0000#),
           ((0, 0), (883, 883), (883, 883), (0, 0)), 0, 0),
         16#24#           =>  --  0524
          ((16#0525#, 16#0000#, 16#0000#, 16#0525#),
           ((884, 884), (0, 0), (0, 0), (884, 884)), 0, 0),
         16#25#           =>  --  0525
          ((16#0000#, 16#0524#, 16#0524#, 16#0000#),
           ((0, 0), (885, 885), (885, 885), (0, 0)), 0, 0),
         16#26#           =>  --  0526
          ((16#0527#, 16#0000#, 16#0000#, 16#0527#),
           ((886, 886), (0, 0), (0, 0), (886, 886)), 0, 0),
         16#27#           =>  --  0527
          ((16#0000#, 16#0526#, 16#0526#, 16#0000#),
           ((0, 0), (887, 887), (887, 887), (0, 0)), 0, 0),
         16#28#           =>  --  0528
          ((16#0529#, 16#0000#, 16#0000#, 16#0529#),
           ((888, 888), (0, 0), (0, 0), (888, 888)), 0, 0),
         16#29#           =>  --  0529
          ((16#0000#, 16#0528#, 16#0528#, 16#0000#),
           ((0, 0), (889, 889), (889, 889), (0, 0)), 0, 0),
         16#2A#           =>  --  052A
          ((16#052B#, 16#0000#, 16#0000#, 16#052B#),
           ((890, 890), (0, 0), (0, 0), (890, 890)), 0, 0),
         16#2B#           =>  --  052B
          ((16#0000#, 16#052A#, 16#052A#, 16#0000#),
           ((0, 0), (891, 891), (891, 891), (0, 0)), 0, 0),
         16#2C#           =>  --  052C
          ((16#052D#, 16#0000#, 16#0000#, 16#052D#),
           ((892, 892), (0, 0), (0, 0), (892, 892)), 0, 0),
         16#2D#           =>  --  052D
          ((16#0000#, 16#052C#, 16#052C#, 16#0000#),
           ((0, 0), (893, 893), (893, 893), (0, 0)), 0, 0),
         16#2E#           =>  --  052E
          ((16#052F#, 16#0000#, 16#0000#, 16#052F#),
           ((894, 894), (0, 0), (0, 0), (894, 894)), 0, 0),
         16#2F#           =>  --  052F
          ((16#0000#, 16#052E#, 16#052E#, 16#0000#),
           ((0, 0), (895, 895), (895, 895), (0, 0)), 0, 0),
         16#31#           =>  --  0531
          ((16#0561#, 16#0000#, 16#0000#, 16#0561#),
           ((896, 896), (0, 0), (0, 0), (896, 896)), 0, 0),
         16#32#           =>  --  0532
          ((16#0562#, 16#0000#, 16#0000#, 16#0562#),
           ((897, 897), (0, 0), (0, 0), (897, 897)), 0, 0),
         16#33#           =>  --  0533
          ((16#0563#, 16#0000#, 16#0000#, 16#0563#),
           ((898, 898), (0, 0), (0, 0), (898, 898)), 0, 0),
         16#34#           =>  --  0534
          ((16#0564#, 16#0000#, 16#0000#, 16#0564#),
           ((899, 899), (0, 0), (0, 0), (899, 899)), 0, 0),
         16#35#           =>  --  0535
          ((16#0565#, 16#0000#, 16#0000#, 16#0565#),
           ((900, 900), (0, 0), (0, 0), (900, 900)), 0, 0),
         16#36#           =>  --  0536
          ((16#0566#, 16#0000#, 16#0000#, 16#0566#),
           ((901, 901), (0, 0), (0, 0), (901, 901)), 0, 0),
         16#37#           =>  --  0537
          ((16#0567#, 16#0000#, 16#0000#, 16#0567#),
           ((902, 902), (0, 0), (0, 0), (902, 902)), 0, 0),
         16#38#           =>  --  0538
          ((16#0568#, 16#0000#, 16#0000#, 16#0568#),
           ((903, 903), (0, 0), (0, 0), (903, 903)), 0, 0),
         16#39#           =>  --  0539
          ((16#0569#, 16#0000#, 16#0000#, 16#0569#),
           ((904, 904), (0, 0), (0, 0), (904, 904)), 0, 0),
         16#3A#           =>  --  053A
          ((16#056A#, 16#0000#, 16#0000#, 16#056A#),
           ((905, 905), (0, 0), (0, 0), (905, 905)), 0, 0),
         16#3B#           =>  --  053B
          ((16#056B#, 16#0000#, 16#0000#, 16#056B#),
           ((906, 906), (0, 0), (0, 0), (906, 906)), 0, 0),
         16#3C#           =>  --  053C
          ((16#056C#, 16#0000#, 16#0000#, 16#056C#),
           ((907, 907), (0, 0), (0, 0), (907, 907)), 0, 0),
         16#3D#           =>  --  053D
          ((16#056D#, 16#0000#, 16#0000#, 16#056D#),
           ((908, 908), (0, 0), (0, 0), (908, 908)), 0, 0),
         16#3E#           =>  --  053E
          ((16#056E#, 16#0000#, 16#0000#, 16#056E#),
           ((909, 909), (0, 0), (0, 0), (909, 909)), 0, 0),
         16#3F#           =>  --  053F
          ((16#056F#, 16#0000#, 16#0000#, 16#056F#),
           ((910, 910), (0, 0), (0, 0), (910, 910)), 0, 0),
         16#40#           =>  --  0540
          ((16#0570#, 16#0000#, 16#0000#, 16#0570#),
           ((911, 911), (0, 0), (0, 0), (911, 911)), 0, 0),
         16#41#           =>  --  0541
          ((16#0571#, 16#0000#, 16#0000#, 16#0571#),
           ((912, 912), (0, 0), (0, 0), (912, 912)), 0, 0),
         16#42#           =>  --  0542
          ((16#0572#, 16#0000#, 16#0000#, 16#0572#),
           ((913, 913), (0, 0), (0, 0), (913, 913)), 0, 0),
         16#43#           =>  --  0543
          ((16#0573#, 16#0000#, 16#0000#, 16#0573#),
           ((914, 914), (0, 0), (0, 0), (914, 914)), 0, 0),
         16#44#           =>  --  0544
          ((16#0574#, 16#0000#, 16#0000#, 16#0574#),
           ((915, 915), (0, 0), (0, 0), (915, 915)), 0, 0),
         16#45#           =>  --  0545
          ((16#0575#, 16#0000#, 16#0000#, 16#0575#),
           ((916, 916), (0, 0), (0, 0), (916, 916)), 0, 0),
         16#46#           =>  --  0546
          ((16#0576#, 16#0000#, 16#0000#, 16#0576#),
           ((917, 917), (0, 0), (0, 0), (917, 917)), 0, 0),
         16#47#           =>  --  0547
          ((16#0577#, 16#0000#, 16#0000#, 16#0577#),
           ((918, 918), (0, 0), (0, 0), (918, 918)), 0, 0),
         16#48#           =>  --  0548
          ((16#0578#, 16#0000#, 16#0000#, 16#0578#),
           ((919, 919), (0, 0), (0, 0), (919, 919)), 0, 0),
         16#49#           =>  --  0549
          ((16#0579#, 16#0000#, 16#0000#, 16#0579#),
           ((920, 920), (0, 0), (0, 0), (920, 920)), 0, 0),
         16#4A#           =>  --  054A
          ((16#057A#, 16#0000#, 16#0000#, 16#057A#),
           ((921, 921), (0, 0), (0, 0), (921, 921)), 0, 0),
         16#4B#           =>  --  054B
          ((16#057B#, 16#0000#, 16#0000#, 16#057B#),
           ((922, 922), (0, 0), (0, 0), (922, 922)), 0, 0),
         16#4C#           =>  --  054C
          ((16#057C#, 16#0000#, 16#0000#, 16#057C#),
           ((923, 923), (0, 0), (0, 0), (923, 923)), 0, 0),
         16#4D#           =>  --  054D
          ((16#057D#, 16#0000#, 16#0000#, 16#057D#),
           ((924, 924), (0, 0), (0, 0), (924, 924)), 0, 0),
         16#4E#           =>  --  054E
          ((16#057E#, 16#0000#, 16#0000#, 16#057E#),
           ((925, 925), (0, 0), (0, 0), (925, 925)), 0, 0),
         16#4F#           =>  --  054F
          ((16#057F#, 16#0000#, 16#0000#, 16#057F#),
           ((926, 926), (0, 0), (0, 0), (926, 926)), 0, 0),
         16#50#           =>  --  0550
          ((16#0580#, 16#0000#, 16#0000#, 16#0580#),
           ((927, 927), (0, 0), (0, 0), (927, 927)), 0, 0),
         16#51#           =>  --  0551
          ((16#0581#, 16#0000#, 16#0000#, 16#0581#),
           ((928, 928), (0, 0), (0, 0), (928, 928)), 0, 0),
         16#52#           =>  --  0552
          ((16#0582#, 16#0000#, 16#0000#, 16#0582#),
           ((929, 929), (0, 0), (0, 0), (929, 929)), 0, 0),
         16#53#           =>  --  0553
          ((16#0583#, 16#0000#, 16#0000#, 16#0583#),
           ((930, 930), (0, 0), (0, 0), (930, 930)), 0, 0),
         16#54#           =>  --  0554
          ((16#0584#, 16#0000#, 16#0000#, 16#0584#),
           ((931, 931), (0, 0), (0, 0), (931, 931)), 0, 0),
         16#55#           =>  --  0555
          ((16#0585#, 16#0000#, 16#0000#, 16#0585#),
           ((932, 932), (0, 0), (0, 0), (932, 932)), 0, 0),
         16#56#           =>  --  0556
          ((16#0586#, 16#0000#, 16#0000#, 16#0586#),
           ((933, 933), (0, 0), (0, 0), (933, 933)), 0, 0),
         16#61#           =>  --  0561
          ((16#0000#, 16#0531#, 16#0531#, 16#0000#),
           ((0, 0), (934, 934), (934, 934), (0, 0)), 0, 0),
         16#62#           =>  --  0562
          ((16#0000#, 16#0532#, 16#0532#, 16#0000#),
           ((0, 0), (935, 935), (935, 935), (0, 0)), 0, 0),
         16#63#           =>  --  0563
          ((16#0000#, 16#0533#, 16#0533#, 16#0000#),
           ((0, 0), (936, 936), (936, 936), (0, 0)), 0, 0),
         16#64#           =>  --  0564
          ((16#0000#, 16#0534#, 16#0534#, 16#0000#),
           ((0, 0), (937, 937), (937, 937), (0, 0)), 0, 0),
         16#65#           =>  --  0565
          ((16#0000#, 16#0535#, 16#0535#, 16#0000#),
           ((0, 0), (938, 938), (938, 938), (0, 0)), 0, 0),
         16#66#           =>  --  0566
          ((16#0000#, 16#0536#, 16#0536#, 16#0000#),
           ((0, 0), (939, 939), (939, 939), (0, 0)), 0, 0),
         16#67#           =>  --  0567
          ((16#0000#, 16#0537#, 16#0537#, 16#0000#),
           ((0, 0), (940, 940), (940, 940), (0, 0)), 0, 0),
         16#68#           =>  --  0568
          ((16#0000#, 16#0538#, 16#0538#, 16#0000#),
           ((0, 0), (941, 941), (941, 941), (0, 0)), 0, 0),
         16#69#           =>  --  0569
          ((16#0000#, 16#0539#, 16#0539#, 16#0000#),
           ((0, 0), (942, 942), (942, 942), (0, 0)), 0, 0),
         16#6A#           =>  --  056A
          ((16#0000#, 16#053A#, 16#053A#, 16#0000#),
           ((0, 0), (943, 943), (943, 943), (0, 0)), 0, 0),
         16#6B#           =>  --  056B
          ((16#0000#, 16#053B#, 16#053B#, 16#0000#),
           ((0, 0), (944, 944), (944, 944), (0, 0)), 0, 0),
         16#6C#           =>  --  056C
          ((16#0000#, 16#053C#, 16#053C#, 16#0000#),
           ((0, 0), (945, 945), (945, 945), (0, 0)), 0, 0),
         16#6D#           =>  --  056D
          ((16#0000#, 16#053D#, 16#053D#, 16#0000#),
           ((0, 0), (946, 946), (946, 946), (0, 0)), 0, 0),
         16#6E#           =>  --  056E
          ((16#0000#, 16#053E#, 16#053E#, 16#0000#),
           ((0, 0), (947, 947), (947, 947), (0, 0)), 0, 0),
         16#6F#           =>  --  056F
          ((16#0000#, 16#053F#, 16#053F#, 16#0000#),
           ((0, 0), (948, 948), (948, 948), (0, 0)), 0, 0),
         16#70#           =>  --  0570
          ((16#0000#, 16#0540#, 16#0540#, 16#0000#),
           ((0, 0), (949, 949), (949, 949), (0, 0)), 0, 0),
         16#71#           =>  --  0571
          ((16#0000#, 16#0541#, 16#0541#, 16#0000#),
           ((0, 0), (950, 950), (950, 950), (0, 0)), 0, 0),
         16#72#           =>  --  0572
          ((16#0000#, 16#0542#, 16#0542#, 16#0000#),
           ((0, 0), (951, 951), (951, 951), (0, 0)), 0, 0),
         16#73#           =>  --  0573
          ((16#0000#, 16#0543#, 16#0543#, 16#0000#),
           ((0, 0), (952, 952), (952, 952), (0, 0)), 0, 0),
         16#74#           =>  --  0574
          ((16#0000#, 16#0544#, 16#0544#, 16#0000#),
           ((0, 0), (953, 953), (953, 953), (0, 0)), 0, 0),
         16#75#           =>  --  0575
          ((16#0000#, 16#0545#, 16#0545#, 16#0000#),
           ((0, 0), (954, 954), (954, 954), (0, 0)), 0, 0),
         16#76#           =>  --  0576
          ((16#0000#, 16#0546#, 16#0546#, 16#0000#),
           ((0, 0), (955, 955), (955, 955), (0, 0)), 0, 0),
         16#77#           =>  --  0577
          ((16#0000#, 16#0547#, 16#0547#, 16#0000#),
           ((0, 0), (956, 956), (956, 956), (0, 0)), 0, 0),
         16#78#           =>  --  0578
          ((16#0000#, 16#0548#, 16#0548#, 16#0000#),
           ((0, 0), (957, 957), (957, 957), (0, 0)), 0, 0),
         16#79#           =>  --  0579
          ((16#0000#, 16#0549#, 16#0549#, 16#0000#),
           ((0, 0), (958, 958), (958, 958), (0, 0)), 0, 0),
         16#7A#           =>  --  057A
          ((16#0000#, 16#054A#, 16#054A#, 16#0000#),
           ((0, 0), (959, 959), (959, 959), (0, 0)), 0, 0),
         16#7B#           =>  --  057B
          ((16#0000#, 16#054B#, 16#054B#, 16#0000#),
           ((0, 0), (960, 960), (960, 960), (0, 0)), 0, 0),
         16#7C#           =>  --  057C
          ((16#0000#, 16#054C#, 16#054C#, 16#0000#),
           ((0, 0), (961, 961), (961, 961), (0, 0)), 0, 0),
         16#7D#           =>  --  057D
          ((16#0000#, 16#054D#, 16#054D#, 16#0000#),
           ((0, 0), (962, 962), (962, 962), (0, 0)), 0, 0),
         16#7E#           =>  --  057E
          ((16#0000#, 16#054E#, 16#054E#, 16#0000#),
           ((0, 0), (963, 963), (963, 963), (0, 0)), 0, 0),
         16#7F#           =>  --  057F
          ((16#0000#, 16#054F#, 16#054F#, 16#0000#),
           ((0, 0), (964, 964), (964, 964), (0, 0)), 0, 0),
         16#80#           =>  --  0580
          ((16#0000#, 16#0550#, 16#0550#, 16#0000#),
           ((0, 0), (965, 965), (965, 965), (0, 0)), 0, 0),
         16#81#           =>  --  0581
          ((16#0000#, 16#0551#, 16#0551#, 16#0000#),
           ((0, 0), (966, 966), (966, 966), (0, 0)), 0, 0),
         16#82#           =>  --  0582
          ((16#0000#, 16#0552#, 16#0552#, 16#0000#),
           ((0, 0), (967, 967), (967, 967), (0, 0)), 0, 0),
         16#83#           =>  --  0583
          ((16#0000#, 16#0553#, 16#0553#, 16#0000#),
           ((0, 0), (968, 968), (968, 968), (0, 0)), 0, 0),
         16#84#           =>  --  0584
          ((16#0000#, 16#0554#, 16#0554#, 16#0000#),
           ((0, 0), (969, 969), (969, 969), (0, 0)), 0, 0),
         16#85#           =>  --  0585
          ((16#0000#, 16#0555#, 16#0555#, 16#0000#),
           ((0, 0), (970, 970), (970, 970), (0, 0)), 0, 0),
         16#86#           =>  --  0586
          ((16#0000#, 16#0556#, 16#0556#, 16#0000#),
           ((0, 0), (971, 971), (971, 971), (0, 0)), 0, 0),
         16#87#           =>  --  0587
          ((16#0000#, 16#0000#, 16#0000#, 16#0000#),
           ((0, 0), (972, 973), (974, 975), (976, 977)), 0, 0),
         others           =>
          ((16#0000#, 16#0000#, 16#0000#, 16#0000#),
           ((0, 0), (0, 0), (0, 0), (0, 0)), 0, 0));

   Group_0006 : aliased constant Case_Mapping_Second_Stage
     := (others           =>
          ((16#0000#, 16#0000#, 16#0000#, 16#0000#),
           ((0, 0), (0, 0), (0, 0), (0, 0)), 0, 0));

   Group_0010 : aliased constant Case_Mapping_Second_Stage
     := (16#A0#           =>  --  10A0
          ((16#2D00#, 16#0000#, 16#0000#, 16#2D00#),
           ((978, 978), (0, 0), (0, 0), (978, 978)), 0, 0),
         16#A1#           =>  --  10A1
          ((16#2D01#, 16#0000#, 16#0000#, 16#2D01#),
           ((979, 979), (0, 0), (0, 0), (979, 979)), 0, 0),
         16#A2#           =>  --  10A2
          ((16#2D02#, 16#0000#, 16#0000#, 16#2D02#),
           ((980, 980), (0, 0), (0, 0), (980, 980)), 0, 0),
         16#A3#           =>  --  10A3
          ((16#2D03#, 16#0000#, 16#0000#, 16#2D03#),
           ((981, 981), (0, 0), (0, 0), (981, 981)), 0, 0),
         16#A4#           =>  --  10A4
          ((16#2D04#, 16#0000#, 16#0000#, 16#2D04#),
           ((982, 982), (0, 0), (0, 0), (982, 982)), 0, 0),
         16#A5#           =>  --  10A5
          ((16#2D05#, 16#0000#, 16#0000#, 16#2D05#),
           ((983, 983), (0, 0), (0, 0), (983, 983)), 0, 0),
         16#A6#           =>  --  10A6
          ((16#2D06#, 16#0000#, 16#0000#, 16#2D06#),
           ((984, 984), (0, 0), (0, 0), (984, 984)), 0, 0),
         16#A7#           =>  --  10A7
          ((16#2D07#, 16#0000#, 16#0000#, 16#2D07#),
           ((985, 985), (0, 0), (0, 0), (985, 985)), 0, 0),
         16#A8#           =>  --  10A8
          ((16#2D08#, 16#0000#, 16#0000#, 16#2D08#),
           ((986, 986), (0, 0), (0, 0), (986, 986)), 0, 0),
         16#A9#           =>  --  10A9
          ((16#2D09#, 16#0000#, 16#0000#, 16#2D09#),
           ((987, 987), (0, 0), (0, 0), (987, 987)), 0, 0),
         16#AA#           =>  --  10AA
          ((16#2D0A#, 16#0000#, 16#0000#, 16#2D0A#),
           ((988, 988), (0, 0), (0, 0), (988, 988)), 0, 0),
         16#AB#           =>  --  10AB
          ((16#2D0B#, 16#0000#, 16#0000#, 16#2D0B#),
           ((989, 989), (0, 0), (0, 0), (989, 989)), 0, 0),
         16#AC#           =>  --  10AC
          ((16#2D0C#, 16#0000#, 16#0000#, 16#2D0C#),
           ((990, 990), (0, 0), (0, 0), (990, 990)), 0, 0),
         16#AD#           =>  --  10AD
          ((16#2D0D#, 16#0000#, 16#0000#, 16#2D0D#),
           ((991, 991), (0, 0), (0, 0), (991, 991)), 0, 0),
         16#AE#           =>  --  10AE
          ((16#2D0E#, 16#0000#, 16#0000#, 16#2D0E#),
           ((992, 992), (0, 0), (0, 0), (992, 992)), 0, 0),
         16#AF#           =>  --  10AF
          ((16#2D0F#, 16#0000#, 16#0000#, 16#2D0F#),
           ((993, 993), (0, 0), (0, 0), (993, 993)), 0, 0),
         16#B0#           =>  --  10B0
          ((16#2D10#, 16#0000#, 16#0000#, 16#2D10#),
           ((994, 994), (0, 0), (0, 0), (994, 994)), 0, 0),
         16#B1#           =>  --  10B1
          ((16#2D11#, 16#0000#, 16#0000#, 16#2D11#),
           ((995, 995), (0, 0), (0, 0), (995, 995)), 0, 0),
         16#B2#           =>  --  10B2
          ((16#2D12#, 16#0000#, 16#0000#, 16#2D12#),
           ((996, 996), (0, 0), (0, 0), (996, 996)), 0, 0),
         16#B3#           =>  --  10B3
          ((16#2D13#, 16#0000#, 16#0000#, 16#2D13#),
           ((997, 997), (0, 0), (0, 0), (997, 997)), 0, 0),
         16#B4#           =>  --  10B4
          ((16#2D14#, 16#0000#, 16#0000#, 16#2D14#),
           ((998, 998), (0, 0), (0, 0), (998, 998)), 0, 0),
         16#B5#           =>  --  10B5
          ((16#2D15#, 16#0000#, 16#0000#, 16#2D15#),
           ((999, 999), (0, 0), (0, 0), (999, 999)), 0, 0),
         16#B6#           =>  --  10B6
          ((16#2D16#, 16#0000#, 16#0000#, 16#2D16#),
           ((1000, 1000), (0, 0), (0, 0), (1000, 1000)), 0, 0),
         16#B7#           =>  --  10B7
          ((16#2D17#, 16#0000#, 16#0000#, 16#2D17#),
           ((1001, 1001), (0, 0), (0, 0), (1001, 1001)), 0, 0),
         16#B8#           =>  --  10B8
          ((16#2D18#, 16#0000#, 16#0000#, 16#2D18#),
           ((1002, 1002), (0, 0), (0, 0), (1002, 1002)), 0, 0),
         16#B9#           =>  --  10B9
          ((16#2D19#, 16#0000#, 16#0000#, 16#2D19#),
           ((1003, 1003), (0, 0), (0, 0), (1003, 1003)), 0, 0),
         16#BA#           =>  --  10BA
          ((16#2D1A#, 16#0000#, 16#0000#, 16#2D1A#),
           ((1004, 1004), (0, 0), (0, 0), (1004, 1004)), 0, 0),
         16#BB#           =>  --  10BB
          ((16#2D1B#, 16#0000#, 16#0000#, 16#2D1B#),
           ((1005, 1005), (0, 0), (0, 0), (1005, 1005)), 0, 0),
         16#BC#           =>  --  10BC
          ((16#2D1C#, 16#0000#, 16#0000#, 16#2D1C#),
           ((1006, 1006), (0, 0), (0, 0), (1006, 1006)), 0, 0),
         16#BD#           =>  --  10BD
          ((16#2D1D#, 16#0000#, 16#0000#, 16#2D1D#),
           ((1007, 1007), (0, 0), (0, 0), (1007, 1007)), 0, 0),
         16#BE#           =>  --  10BE
          ((16#2D1E#, 16#0000#, 16#0000#, 16#2D1E#),
           ((1008, 1008), (0, 0), (0, 0), (1008, 1008)), 0, 0),
         16#BF#           =>  --  10BF
          ((16#2D1F#, 16#0000#, 16#0000#, 16#2D1F#),
           ((1009, 1009), (0, 0), (0, 0), (1009, 1009)), 0, 0),
         16#C0#           =>  --  10C0
          ((16#2D20#, 16#0000#, 16#0000#, 16#2D20#),
           ((1010, 1010), (0, 0), (0, 0), (1010, 1010)), 0, 0),
         16#C1#           =>  --  10C1
          ((16#2D21#, 16#0000#, 16#0000#, 16#2D21#),
           ((1011, 1011), (0, 0), (0, 0), (1011, 1011)), 0, 0),
         16#C2#           =>  --  10C2
          ((16#2D22#, 16#0000#, 16#0000#, 16#2D22#),
           ((1012, 1012), (0, 0), (0, 0), (1012, 1012)), 0, 0),
         16#C3#           =>  --  10C3
          ((16#2D23#, 16#0000#, 16#0000#, 16#2D23#),
           ((1013, 1013), (0, 0), (0, 0), (1013, 1013)), 0, 0),
         16#C4#           =>  --  10C4
          ((16#2D24#, 16#0000#, 16#0000#, 16#2D24#),
           ((1014, 1014), (0, 0), (0, 0), (1014, 1014)), 0, 0),
         16#C5#           =>  --  10C5
          ((16#2D25#, 16#0000#, 16#0000#, 16#2D25#),
           ((1015, 1015), (0, 0), (0, 0), (1015, 1015)), 0, 0),
         16#C7#           =>  --  10C7
          ((16#2D27#, 16#0000#, 16#0000#, 16#2D27#),
           ((1016, 1016), (0, 0), (0, 0), (1016, 1016)), 0, 0),
         16#CD#           =>  --  10CD
          ((16#2D2D#, 16#0000#, 16#0000#, 16#2D2D#),
           ((1017, 1017), (0, 0), (0, 0), (1017, 1017)), 0, 0),
         others           =>
          ((16#0000#, 16#0000#, 16#0000#, 16#0000#),
           ((0, 0), (0, 0), (0, 0), (0, 0)), 0, 0));

   Group_001D : aliased constant Case_Mapping_Second_Stage
     := (16#79#           =>  --  1D79
          ((16#0000#, 16#A77D#, 16#A77D#, 16#0000#),
           ((0, 0), (1018, 1018), (1018, 1018), (0, 0)), 0, 0),
         16#7D#           =>  --  1D7D
          ((16#0000#, 16#2C63#, 16#2C63#, 16#0000#),
           ((0, 0), (1019, 1019), (1019, 1019), (0, 0)), 0, 0),
         others           =>
          ((16#0000#, 16#0000#, 16#0000#, 16#0000#),
           ((0, 0), (0, 0), (0, 0), (0, 0)), 0, 0));

   Group_001E : aliased constant Case_Mapping_Second_Stage
     := (16#00#           =>  --  1E00
          ((16#1E01#, 16#0000#, 16#0000#, 16#1E01#),
           ((1020, 1020), (0, 0), (0, 0), (1020, 1020)), 0, 0),
         16#01#           =>  --  1E01
          ((16#0000#, 16#1E00#, 16#1E00#, 16#0000#),
           ((0, 0), (1021, 1021), (1021, 1021), (0, 0)), 0, 0),
         16#02#           =>  --  1E02
          ((16#1E03#, 16#0000#, 16#0000#, 16#1E03#),
           ((1022, 1022), (0, 0), (0, 0), (1022, 1022)), 0, 0),
         16#03#           =>  --  1E03
          ((16#0000#, 16#1E02#, 16#1E02#, 16#0000#),
           ((0, 0), (1023, 1023), (1023, 1023), (0, 0)), 0, 0),
         16#04#           =>  --  1E04
          ((16#1E05#, 16#0000#, 16#0000#, 16#1E05#),
           ((1024, 1024), (0, 0), (0, 0), (1024, 1024)), 0, 0),
         16#05#           =>  --  1E05
          ((16#0000#, 16#1E04#, 16#1E04#, 16#0000#),
           ((0, 0), (1025, 1025), (1025, 1025), (0, 0)), 0, 0),
         16#06#           =>  --  1E06
          ((16#1E07#, 16#0000#, 16#0000#, 16#1E07#),
           ((1026, 1026), (0, 0), (0, 0), (1026, 1026)), 0, 0),
         16#07#           =>  --  1E07
          ((16#0000#, 16#1E06#, 16#1E06#, 16#0000#),
           ((0, 0), (1027, 1027), (1027, 1027), (0, 0)), 0, 0),
         16#08#           =>  --  1E08
          ((16#1E09#, 16#0000#, 16#0000#, 16#1E09#),
           ((1028, 1028), (0, 0), (0, 0), (1028, 1028)), 0, 0),
         16#09#           =>  --  1E09
          ((16#0000#, 16#1E08#, 16#1E08#, 16#0000#),
           ((0, 0), (1029, 1029), (1029, 1029), (0, 0)), 0, 0),
         16#0A#           =>  --  1E0A
          ((16#1E0B#, 16#0000#, 16#0000#, 16#1E0B#),
           ((1030, 1030), (0, 0), (0, 0), (1030, 1030)), 0, 0),
         16#0B#           =>  --  1E0B
          ((16#0000#, 16#1E0A#, 16#1E0A#, 16#0000#),
           ((0, 0), (1031, 1031), (1031, 1031), (0, 0)), 0, 0),
         16#0C#           =>  --  1E0C
          ((16#1E0D#, 16#0000#, 16#0000#, 16#1E0D#),
           ((1032, 1032), (0, 0), (0, 0), (1032, 1032)), 0, 0),
         16#0D#           =>  --  1E0D
          ((16#0000#, 16#1E0C#, 16#1E0C#, 16#0000#),
           ((0, 0), (1033, 1033), (1033, 1033), (0, 0)), 0, 0),
         16#0E#           =>  --  1E0E
          ((16#1E0F#, 16#0000#, 16#0000#, 16#1E0F#),
           ((1034, 1034), (0, 0), (0, 0), (1034, 1034)), 0, 0),
         16#0F#           =>  --  1E0F
          ((16#0000#, 16#1E0E#, 16#1E0E#, 16#0000#),
           ((0, 0), (1035, 1035), (1035, 1035), (0, 0)), 0, 0),
         16#10#           =>  --  1E10
          ((16#1E11#, 16#0000#, 16#0000#, 16#1E11#),
           ((1036, 1036), (0, 0), (0, 0), (1036, 1036)), 0, 0),
         16#11#           =>  --  1E11
          ((16#0000#, 16#1E10#, 16#1E10#, 16#0000#),
           ((0, 0), (1037, 1037), (1037, 1037), (0, 0)), 0, 0),
         16#12#           =>  --  1E12
          ((16#1E13#, 16#0000#, 16#0000#, 16#1E13#),
           ((1038, 1038), (0, 0), (0, 0), (1038, 1038)), 0, 0),
         16#13#           =>  --  1E13
          ((16#0000#, 16#1E12#, 16#1E12#, 16#0000#),
           ((0, 0), (1039, 1039), (1039, 1039), (0, 0)), 0, 0),
         16#14#           =>  --  1E14
          ((16#1E15#, 16#0000#, 16#0000#, 16#1E15#),
           ((1040, 1040), (0, 0), (0, 0), (1040, 1040)), 0, 0),
         16#15#           =>  --  1E15
          ((16#0000#, 16#1E14#, 16#1E14#, 16#0000#),
           ((0, 0), (1041, 1041), (1041, 1041), (0, 0)), 0, 0),
         16#16#           =>  --  1E16
          ((16#1E17#, 16#0000#, 16#0000#, 16#1E17#),
           ((1042, 1042), (0, 0), (0, 0), (1042, 1042)), 0, 0),
         16#17#           =>  --  1E17
          ((16#0000#, 16#1E16#, 16#1E16#, 16#0000#),
           ((0, 0), (1043, 1043), (1043, 1043), (0, 0)), 0, 0),
         16#18#           =>  --  1E18
          ((16#1E19#, 16#0000#, 16#0000#, 16#1E19#),
           ((1044, 1044), (0, 0), (0, 0), (1044, 1044)), 0, 0),
         16#19#           =>  --  1E19
          ((16#0000#, 16#1E18#, 16#1E18#, 16#0000#),
           ((0, 0), (1045, 1045), (1045, 1045), (0, 0)), 0, 0),
         16#1A#           =>  --  1E1A
          ((16#1E1B#, 16#0000#, 16#0000#, 16#1E1B#),
           ((1046, 1046), (0, 0), (0, 0), (1046, 1046)), 0, 0),
         16#1B#           =>  --  1E1B
          ((16#0000#, 16#1E1A#, 16#1E1A#, 16#0000#),
           ((0, 0), (1047, 1047), (1047, 1047), (0, 0)), 0, 0),
         16#1C#           =>  --  1E1C
          ((16#1E1D#, 16#0000#, 16#0000#, 16#1E1D#),
           ((1048, 1048), (0, 0), (0, 0), (1048, 1048)), 0, 0),
         16#1D#           =>  --  1E1D
          ((16#0000#, 16#1E1C#, 16#1E1C#, 16#0000#),
           ((0, 0), (1049, 1049), (1049, 1049), (0, 0)), 0, 0),
         16#1E#           =>  --  1E1E
          ((16#1E1F#, 16#0000#, 16#0000#, 16#1E1F#),
           ((1050, 1050), (0, 0), (0, 0), (1050, 1050)), 0, 0),
         16#1F#           =>  --  1E1F
          ((16#0000#, 16#1E1E#, 16#1E1E#, 16#0000#),
           ((0, 0), (1051, 1051), (1051, 1051), (0, 0)), 0, 0),
         16#20#           =>  --  1E20
          ((16#1E21#, 16#0000#, 16#0000#, 16#1E21#),
           ((1052, 1052), (0, 0), (0, 0), (1052, 1052)), 0, 0),
         16#21#           =>  --  1E21
          ((16#0000#, 16#1E20#, 16#1E20#, 16#0000#),
           ((0, 0), (1053, 1053), (1053, 1053), (0, 0)), 0, 0),
         16#22#           =>  --  1E22
          ((16#1E23#, 16#0000#, 16#0000#, 16#1E23#),
           ((1054, 1054), (0, 0), (0, 0), (1054, 1054)), 0, 0),
         16#23#           =>  --  1E23
          ((16#0000#, 16#1E22#, 16#1E22#, 16#0000#),
           ((0, 0), (1055, 1055), (1055, 1055), (0, 0)), 0, 0),
         16#24#           =>  --  1E24
          ((16#1E25#, 16#0000#, 16#0000#, 16#1E25#),
           ((1056, 1056), (0, 0), (0, 0), (1056, 1056)), 0, 0),
         16#25#           =>  --  1E25
          ((16#0000#, 16#1E24#, 16#1E24#, 16#0000#),
           ((0, 0), (1057, 1057), (1057, 1057), (0, 0)), 0, 0),
         16#26#           =>  --  1E26
          ((16#1E27#, 16#0000#, 16#0000#, 16#1E27#),
           ((1058, 1058), (0, 0), (0, 0), (1058, 1058)), 0, 0),
         16#27#           =>  --  1E27
          ((16#0000#, 16#1E26#, 16#1E26#, 16#0000#),
           ((0, 0), (1059, 1059), (1059, 1059), (0, 0)), 0, 0),
         16#28#           =>  --  1E28
          ((16#1E29#, 16#0000#, 16#0000#, 16#1E29#),
           ((1060, 1060), (0, 0), (0, 0), (1060, 1060)), 0, 0),
         16#29#           =>  --  1E29
          ((16#0000#, 16#1E28#, 16#1E28#, 16#0000#),
           ((0, 0), (1061, 1061), (1061, 1061), (0, 0)), 0, 0),
         16#2A#           =>  --  1E2A
          ((16#1E2B#, 16#0000#, 16#0000#, 16#1E2B#),
           ((1062, 1062), (0, 0), (0, 0), (1062, 1062)), 0, 0),
         16#2B#           =>  --  1E2B
          ((16#0000#, 16#1E2A#, 16#1E2A#, 16#0000#),
           ((0, 0), (1063, 1063), (1063, 1063), (0, 0)), 0, 0),
         16#2C#           =>  --  1E2C
          ((16#1E2D#, 16#0000#, 16#0000#, 16#1E2D#),
           ((1064, 1064), (0, 0), (0, 0), (1064, 1064)), 0, 0),
         16#2D#           =>  --  1E2D
          ((16#0000#, 16#1E2C#, 16#1E2C#, 16#0000#),
           ((0, 0), (1065, 1065), (1065, 1065), (0, 0)), 0, 0),
         16#2E#           =>  --  1E2E
          ((16#1E2F#, 16#0000#, 16#0000#, 16#1E2F#),
           ((1066, 1066), (0, 0), (0, 0), (1066, 1066)), 0, 0),
         16#2F#           =>  --  1E2F
          ((16#0000#, 16#1E2E#, 16#1E2E#, 16#0000#),
           ((0, 0), (1067, 1067), (1067, 1067), (0, 0)), 0, 0),
         16#30#           =>  --  1E30
          ((16#1E31#, 16#0000#, 16#0000#, 16#1E31#),
           ((1068, 1068), (0, 0), (0, 0), (1068, 1068)), 0, 0),
         16#31#           =>  --  1E31
          ((16#0000#, 16#1E30#, 16#1E30#, 16#0000#),
           ((0, 0), (1069, 1069), (1069, 1069), (0, 0)), 0, 0),
         16#32#           =>  --  1E32
          ((16#1E33#, 16#0000#, 16#0000#, 16#1E33#),
           ((1070, 1070), (0, 0), (0, 0), (1070, 1070)), 0, 0),
         16#33#           =>  --  1E33
          ((16#0000#, 16#1E32#, 16#1E32#, 16#0000#),
           ((0, 0), (1071, 1071), (1071, 1071), (0, 0)), 0, 0),
         16#34#           =>  --  1E34
          ((16#1E35#, 16#0000#, 16#0000#, 16#1E35#),
           ((1072, 1072), (0, 0), (0, 0), (1072, 1072)), 0, 0),
         16#35#           =>  --  1E35
          ((16#0000#, 16#1E34#, 16#1E34#, 16#0000#),
           ((0, 0), (1073, 1073), (1073, 1073), (0, 0)), 0, 0),
         16#36#           =>  --  1E36
          ((16#1E37#, 16#0000#, 16#0000#, 16#1E37#),
           ((1074, 1074), (0, 0), (0, 0), (1074, 1074)), 0, 0),
         16#37#           =>  --  1E37
          ((16#0000#, 16#1E36#, 16#1E36#, 16#0000#),
           ((0, 0), (1075, 1075), (1075, 1075), (0, 0)), 0, 0),
         16#38#           =>  --  1E38
          ((16#1E39#, 16#0000#, 16#0000#, 16#1E39#),
           ((1076, 1076), (0, 0), (0, 0), (1076, 1076)), 0, 0),
         16#39#           =>  --  1E39
          ((16#0000#, 16#1E38#, 16#1E38#, 16#0000#),
           ((0, 0), (1077, 1077), (1077, 1077), (0, 0)), 0, 0),
         16#3A#           =>  --  1E3A
          ((16#1E3B#, 16#0000#, 16#0000#, 16#1E3B#),
           ((1078, 1078), (0, 0), (0, 0), (1078, 1078)), 0, 0),
         16#3B#           =>  --  1E3B
          ((16#0000#, 16#1E3A#, 16#1E3A#, 16#0000#),
           ((0, 0), (1079, 1079), (1079, 1079), (0, 0)), 0, 0),
         16#3C#           =>  --  1E3C
          ((16#1E3D#, 16#0000#, 16#0000#, 16#1E3D#),
           ((1080, 1080), (0, 0), (0, 0), (1080, 1080)), 0, 0),
         16#3D#           =>  --  1E3D
          ((16#0000#, 16#1E3C#, 16#1E3C#, 16#0000#),
           ((0, 0), (1081, 1081), (1081, 1081), (0, 0)), 0, 0),
         16#3E#           =>  --  1E3E
          ((16#1E3F#, 16#0000#, 16#0000#, 16#1E3F#),
           ((1082, 1082), (0, 0), (0, 0), (1082, 1082)), 0, 0),
         16#3F#           =>  --  1E3F
          ((16#0000#, 16#1E3E#, 16#1E3E#, 16#0000#),
           ((0, 0), (1083, 1083), (1083, 1083), (0, 0)), 0, 0),
         16#40#           =>  --  1E40
          ((16#1E41#, 16#0000#, 16#0000#, 16#1E41#),
           ((1084, 1084), (0, 0), (0, 0), (1084, 1084)), 0, 0),
         16#41#           =>  --  1E41
          ((16#0000#, 16#1E40#, 16#1E40#, 16#0000#),
           ((0, 0), (1085, 1085), (1085, 1085), (0, 0)), 0, 0),
         16#42#           =>  --  1E42
          ((16#1E43#, 16#0000#, 16#0000#, 16#1E43#),
           ((1086, 1086), (0, 0), (0, 0), (1086, 1086)), 0, 0),
         16#43#           =>  --  1E43
          ((16#0000#, 16#1E42#, 16#1E42#, 16#0000#),
           ((0, 0), (1087, 1087), (1087, 1087), (0, 0)), 0, 0),
         16#44#           =>  --  1E44
          ((16#1E45#, 16#0000#, 16#0000#, 16#1E45#),
           ((1088, 1088), (0, 0), (0, 0), (1088, 1088)), 0, 0),
         16#45#           =>  --  1E45
          ((16#0000#, 16#1E44#, 16#1E44#, 16#0000#),
           ((0, 0), (1089, 1089), (1089, 1089), (0, 0)), 0, 0),
         16#46#           =>  --  1E46
          ((16#1E47#, 16#0000#, 16#0000#, 16#1E47#),
           ((1090, 1090), (0, 0), (0, 0), (1090, 1090)), 0, 0),
         16#47#           =>  --  1E47
          ((16#0000#, 16#1E46#, 16#1E46#, 16#0000#),
           ((0, 0), (1091, 1091), (1091, 1091), (0, 0)), 0, 0),
         16#48#           =>  --  1E48
          ((16#1E49#, 16#0000#, 16#0000#, 16#1E49#),
           ((1092, 1092), (0, 0), (0, 0), (1092, 1092)), 0, 0),
         16#49#           =>  --  1E49
          ((16#0000#, 16#1E48#, 16#1E48#, 16#0000#),
           ((0, 0), (1093, 1093), (1093, 1093), (0, 0)), 0, 0),
         16#4A#           =>  --  1E4A
          ((16#1E4B#, 16#0000#, 16#0000#, 16#1E4B#),
           ((1094, 1094), (0, 0), (0, 0), (1094, 1094)), 0, 0),
         16#4B#           =>  --  1E4B
          ((16#0000#, 16#1E4A#, 16#1E4A#, 16#0000#),
           ((0, 0), (1095, 1095), (1095, 1095), (0, 0)), 0, 0),
         16#4C#           =>  --  1E4C
          ((16#1E4D#, 16#0000#, 16#0000#, 16#1E4D#),
           ((1096, 1096), (0, 0), (0, 0), (1096, 1096)), 0, 0),
         16#4D#           =>  --  1E4D
          ((16#0000#, 16#1E4C#, 16#1E4C#, 16#0000#),
           ((0, 0), (1097, 1097), (1097, 1097), (0, 0)), 0, 0),
         16#4E#           =>  --  1E4E
          ((16#1E4F#, 16#0000#, 16#0000#, 16#1E4F#),
           ((1098, 1098), (0, 0), (0, 0), (1098, 1098)), 0, 0),
         16#4F#           =>  --  1E4F
          ((16#0000#, 16#1E4E#, 16#1E4E#, 16#0000#),
           ((0, 0), (1099, 1099), (1099, 1099), (0, 0)), 0, 0),
         16#50#           =>  --  1E50
          ((16#1E51#, 16#0000#, 16#0000#, 16#1E51#),
           ((1100, 1100), (0, 0), (0, 0), (1100, 1100)), 0, 0),
         16#51#           =>  --  1E51
          ((16#0000#, 16#1E50#, 16#1E50#, 16#0000#),
           ((0, 0), (1101, 1101), (1101, 1101), (0, 0)), 0, 0),
         16#52#           =>  --  1E52
          ((16#1E53#, 16#0000#, 16#0000#, 16#1E53#),
           ((1102, 1102), (0, 0), (0, 0), (1102, 1102)), 0, 0),
         16#53#           =>  --  1E53
          ((16#0000#, 16#1E52#, 16#1E52#, 16#0000#),
           ((0, 0), (1103, 1103), (1103, 1103), (0, 0)), 0, 0),
         16#54#           =>  --  1E54
          ((16#1E55#, 16#0000#, 16#0000#, 16#1E55#),
           ((1104, 1104), (0, 0), (0, 0), (1104, 1104)), 0, 0),
         16#55#           =>  --  1E55
          ((16#0000#, 16#1E54#, 16#1E54#, 16#0000#),
           ((0, 0), (1105, 1105), (1105, 1105), (0, 0)), 0, 0),
         16#56#           =>  --  1E56
          ((16#1E57#, 16#0000#, 16#0000#, 16#1E57#),
           ((1106, 1106), (0, 0), (0, 0), (1106, 1106)), 0, 0),
         16#57#           =>  --  1E57
          ((16#0000#, 16#1E56#, 16#1E56#, 16#0000#),
           ((0, 0), (1107, 1107), (1107, 1107), (0, 0)), 0, 0),
         16#58#           =>  --  1E58
          ((16#1E59#, 16#0000#, 16#0000#, 16#1E59#),
           ((1108, 1108), (0, 0), (0, 0), (1108, 1108)), 0, 0),
         16#59#           =>  --  1E59
          ((16#0000#, 16#1E58#, 16#1E58#, 16#0000#),
           ((0, 0), (1109, 1109), (1109, 1109), (0, 0)), 0, 0),
         16#5A#           =>  --  1E5A
          ((16#1E5B#, 16#0000#, 16#0000#, 16#1E5B#),
           ((1110, 1110), (0, 0), (0, 0), (1110, 1110)), 0, 0),
         16#5B#           =>  --  1E5B
          ((16#0000#, 16#1E5A#, 16#1E5A#, 16#0000#),
           ((0, 0), (1111, 1111), (1111, 1111), (0, 0)), 0, 0),
         16#5C#           =>  --  1E5C
          ((16#1E5D#, 16#0000#, 16#0000#, 16#1E5D#),
           ((1112, 1112), (0, 0), (0, 0), (1112, 1112)), 0, 0),
         16#5D#           =>  --  1E5D
          ((16#0000#, 16#1E5C#, 16#1E5C#, 16#0000#),
           ((0, 0), (1113, 1113), (1113, 1113), (0, 0)), 0, 0),
         16#5E#           =>  --  1E5E
          ((16#1E5F#, 16#0000#, 16#0000#, 16#1E5F#),
           ((1114, 1114), (0, 0), (0, 0), (1114, 1114)), 0, 0),
         16#5F#           =>  --  1E5F
          ((16#0000#, 16#1E5E#, 16#1E5E#, 16#0000#),
           ((0, 0), (1115, 1115), (1115, 1115), (0, 0)), 0, 0),
         16#60#           =>  --  1E60
          ((16#1E61#, 16#0000#, 16#0000#, 16#1E61#),
           ((1116, 1116), (0, 0), (0, 0), (1116, 1116)), 0, 0),
         16#61#           =>  --  1E61
          ((16#0000#, 16#1E60#, 16#1E60#, 16#0000#),
           ((0, 0), (1117, 1117), (1117, 1117), (0, 0)), 0, 0),
         16#62#           =>  --  1E62
          ((16#1E63#, 16#0000#, 16#0000#, 16#1E63#),
           ((1118, 1118), (0, 0), (0, 0), (1118, 1118)), 0, 0),
         16#63#           =>  --  1E63
          ((16#0000#, 16#1E62#, 16#1E62#, 16#0000#),
           ((0, 0), (1119, 1119), (1119, 1119), (0, 0)), 0, 0),
         16#64#           =>  --  1E64
          ((16#1E65#, 16#0000#, 16#0000#, 16#1E65#),
           ((1120, 1120), (0, 0), (0, 0), (1120, 1120)), 0, 0),
         16#65#           =>  --  1E65
          ((16#0000#, 16#1E64#, 16#1E64#, 16#0000#),
           ((0, 0), (1121, 1121), (1121, 1121), (0, 0)), 0, 0),
         16#66#           =>  --  1E66
          ((16#1E67#, 16#0000#, 16#0000#, 16#1E67#),
           ((1122, 1122), (0, 0), (0, 0), (1122, 1122)), 0, 0),
         16#67#           =>  --  1E67
          ((16#0000#, 16#1E66#, 16#1E66#, 16#0000#),
           ((0, 0), (1123, 1123), (1123, 1123), (0, 0)), 0, 0),
         16#68#           =>  --  1E68
          ((16#1E69#, 16#0000#, 16#0000#, 16#1E69#),
           ((1124, 1124), (0, 0), (0, 0), (1124, 1124)), 0, 0),
         16#69#           =>  --  1E69
          ((16#0000#, 16#1E68#, 16#1E68#, 16#0000#),
           ((0, 0), (1125, 1125), (1125, 1125), (0, 0)), 0, 0),
         16#6A#           =>  --  1E6A
          ((16#1E6B#, 16#0000#, 16#0000#, 16#1E6B#),
           ((1126, 1126), (0, 0), (0, 0), (1126, 1126)), 0, 0),
         16#6B#           =>  --  1E6B
          ((16#0000#, 16#1E6A#, 16#1E6A#, 16#0000#),
           ((0, 0), (1127, 1127), (1127, 1127), (0, 0)), 0, 0),
         16#6C#           =>  --  1E6C
          ((16#1E6D#, 16#0000#, 16#0000#, 16#1E6D#),
           ((1128, 1128), (0, 0), (0, 0), (1128, 1128)), 0, 0),
         16#6D#           =>  --  1E6D
          ((16#0000#, 16#1E6C#, 16#1E6C#, 16#0000#),
           ((0, 0), (1129, 1129), (1129, 1129), (0, 0)), 0, 0),
         16#6E#           =>  --  1E6E
          ((16#1E6F#, 16#0000#, 16#0000#, 16#1E6F#),
           ((1130, 1130), (0, 0), (0, 0), (1130, 1130)), 0, 0),
         16#6F#           =>  --  1E6F
          ((16#0000#, 16#1E6E#, 16#1E6E#, 16#0000#),
           ((0, 0), (1131, 1131), (1131, 1131), (0, 0)), 0, 0),
         16#70#           =>  --  1E70
          ((16#1E71#, 16#0000#, 16#0000#, 16#1E71#),
           ((1132, 1132), (0, 0), (0, 0), (1132, 1132)), 0, 0),
         16#71#           =>  --  1E71
          ((16#0000#, 16#1E70#, 16#1E70#, 16#0000#),
           ((0, 0), (1133, 1133), (1133, 1133), (0, 0)), 0, 0),
         16#72#           =>  --  1E72
          ((16#1E73#, 16#0000#, 16#0000#, 16#1E73#),
           ((1134, 1134), (0, 0), (0, 0), (1134, 1134)), 0, 0),
         16#73#           =>  --  1E73
          ((16#0000#, 16#1E72#, 16#1E72#, 16#0000#),
           ((0, 0), (1135, 1135), (1135, 1135), (0, 0)), 0, 0),
         16#74#           =>  --  1E74
          ((16#1E75#, 16#0000#, 16#0000#, 16#1E75#),
           ((1136, 1136), (0, 0), (0, 0), (1136, 1136)), 0, 0),
         16#75#           =>  --  1E75
          ((16#0000#, 16#1E74#, 16#1E74#, 16#0000#),
           ((0, 0), (1137, 1137), (1137, 1137), (0, 0)), 0, 0),
         16#76#           =>  --  1E76
          ((16#1E77#, 16#0000#, 16#0000#, 16#1E77#),
           ((1138, 1138), (0, 0), (0, 0), (1138, 1138)), 0, 0),
         16#77#           =>  --  1E77
          ((16#0000#, 16#1E76#, 16#1E76#, 16#0000#),
           ((0, 0), (1139, 1139), (1139, 1139), (0, 0)), 0, 0),
         16#78#           =>  --  1E78
          ((16#1E79#, 16#0000#, 16#0000#, 16#1E79#),
           ((1140, 1140), (0, 0), (0, 0), (1140, 1140)), 0, 0),
         16#79#           =>  --  1E79
          ((16#0000#, 16#1E78#, 16#1E78#, 16#0000#),
           ((0, 0), (1141, 1141), (1141, 1141), (0, 0)), 0, 0),
         16#7A#           =>  --  1E7A
          ((16#1E7B#, 16#0000#, 16#0000#, 16#1E7B#),
           ((1142, 1142), (0, 0), (0, 0), (1142, 1142)), 0, 0),
         16#7B#           =>  --  1E7B
          ((16#0000#, 16#1E7A#, 16#1E7A#, 16#0000#),
           ((0, 0), (1143, 1143), (1143, 1143), (0, 0)), 0, 0),
         16#7C#           =>  --  1E7C
          ((16#1E7D#, 16#0000#, 16#0000#, 16#1E7D#),
           ((1144, 1144), (0, 0), (0, 0), (1144, 1144)), 0, 0),
         16#7D#           =>  --  1E7D
          ((16#0000#, 16#1E7C#, 16#1E7C#, 16#0000#),
           ((0, 0), (1145, 1145), (1145, 1145), (0, 0)), 0, 0),
         16#7E#           =>  --  1E7E
          ((16#1E7F#, 16#0000#, 16#0000#, 16#1E7F#),
           ((1146, 1146), (0, 0), (0, 0), (1146, 1146)), 0, 0),
         16#7F#           =>  --  1E7F
          ((16#0000#, 16#1E7E#, 16#1E7E#, 16#0000#),
           ((0, 0), (1147, 1147), (1147, 1147), (0, 0)), 0, 0),
         16#80#           =>  --  1E80
          ((16#1E81#, 16#0000#, 16#0000#, 16#1E81#),
           ((1148, 1148), (0, 0), (0, 0), (1148, 1148)), 0, 0),
         16#81#           =>  --  1E81
          ((16#0000#, 16#1E80#, 16#1E80#, 16#0000#),
           ((0, 0), (1149, 1149), (1149, 1149), (0, 0)), 0, 0),
         16#82#           =>  --  1E82
          ((16#1E83#, 16#0000#, 16#0000#, 16#1E83#),
           ((1150, 1150), (0, 0), (0, 0), (1150, 1150)), 0, 0),
         16#83#           =>  --  1E83
          ((16#0000#, 16#1E82#, 16#1E82#, 16#0000#),
           ((0, 0), (1151, 1151), (1151, 1151), (0, 0)), 0, 0),
         16#84#           =>  --  1E84
          ((16#1E85#, 16#0000#, 16#0000#, 16#1E85#),
           ((1152, 1152), (0, 0), (0, 0), (1152, 1152)), 0, 0),
         16#85#           =>  --  1E85
          ((16#0000#, 16#1E84#, 16#1E84#, 16#0000#),
           ((0, 0), (1153, 1153), (1153, 1153), (0, 0)), 0, 0),
         16#86#           =>  --  1E86
          ((16#1E87#, 16#0000#, 16#0000#, 16#1E87#),
           ((1154, 1154), (0, 0), (0, 0), (1154, 1154)), 0, 0),
         16#87#           =>  --  1E87
          ((16#0000#, 16#1E86#, 16#1E86#, 16#0000#),
           ((0, 0), (1155, 1155), (1155, 1155), (0, 0)), 0, 0),
         16#88#           =>  --  1E88
          ((16#1E89#, 16#0000#, 16#0000#, 16#1E89#),
           ((1156, 1156), (0, 0), (0, 0), (1156, 1156)), 0, 0),
         16#89#           =>  --  1E89
          ((16#0000#, 16#1E88#, 16#1E88#, 16#0000#),
           ((0, 0), (1157, 1157), (1157, 1157), (0, 0)), 0, 0),
         16#8A#           =>  --  1E8A
          ((16#1E8B#, 16#0000#, 16#0000#, 16#1E8B#),
           ((1158, 1158), (0, 0), (0, 0), (1158, 1158)), 0, 0),
         16#8B#           =>  --  1E8B
          ((16#0000#, 16#1E8A#, 16#1E8A#, 16#0000#),
           ((0, 0), (1159, 1159), (1159, 1159), (0, 0)), 0, 0),
         16#8C#           =>  --  1E8C
          ((16#1E8D#, 16#0000#, 16#0000#, 16#1E8D#),
           ((1160, 1160), (0, 0), (0, 0), (1160, 1160)), 0, 0),
         16#8D#           =>  --  1E8D
          ((16#0000#, 16#1E8C#, 16#1E8C#, 16#0000#),
           ((0, 0), (1161, 1161), (1161, 1161), (0, 0)), 0, 0),
         16#8E#           =>  --  1E8E
          ((16#1E8F#, 16#0000#, 16#0000#, 16#1E8F#),
           ((1162, 1162), (0, 0), (0, 0), (1162, 1162)), 0, 0),
         16#8F#           =>  --  1E8F
          ((16#0000#, 16#1E8E#, 16#1E8E#, 16#0000#),
           ((0, 0), (1163, 1163), (1163, 1163), (0, 0)), 0, 0),
         16#90#           =>  --  1E90
          ((16#1E91#, 16#0000#, 16#0000#, 16#1E91#),
           ((1164, 1164), (0, 0), (0, 0), (1164, 1164)), 0, 0),
         16#91#           =>  --  1E91
          ((16#0000#, 16#1E90#, 16#1E90#, 16#0000#),
           ((0, 0), (1165, 1165), (1165, 1165), (0, 0)), 0, 0),
         16#92#           =>  --  1E92
          ((16#1E93#, 16#0000#, 16#0000#, 16#1E93#),
           ((1166, 1166), (0, 0), (0, 0), (1166, 1166)), 0, 0),
         16#93#           =>  --  1E93
          ((16#0000#, 16#1E92#, 16#1E92#, 16#0000#),
           ((0, 0), (1167, 1167), (1167, 1167), (0, 0)), 0, 0),
         16#94#           =>  --  1E94
          ((16#1E95#, 16#0000#, 16#0000#, 16#1E95#),
           ((1168, 1168), (0, 0), (0, 0), (1168, 1168)), 0, 0),
         16#95#           =>  --  1E95
          ((16#0000#, 16#1E94#, 16#1E94#, 16#0000#),
           ((0, 0), (1169, 1169), (1169, 1169), (0, 0)), 0, 0),
         16#96#           =>  --  1E96
          ((16#0000#, 16#0000#, 16#0000#, 16#0000#),
           ((0, 0), (1170, 1171), (1170, 1171), (1172, 1173)), 0, 0),
         16#97#           =>  --  1E97
          ((16#0000#, 16#0000#, 16#0000#, 16#0000#),
           ((0, 0), (1174, 1175), (1174, 1175), (1176, 1177)), 0, 0),
         16#98#           =>  --  1E98
          ((16#0000#, 16#0000#, 16#0000#, 16#0000#),
           ((0, 0), (1178, 1179), (1178, 1179), (1180, 1181)), 0, 0),
         16#99#           =>  --  1E99
          ((16#0000#, 16#0000#, 16#0000#, 16#0000#),
           ((0, 0), (1182, 1183), (1182, 1183), (1184, 1185)), 0, 0),
         16#9A#           =>  --  1E9A
          ((16#0000#, 16#0000#, 16#0000#, 16#0000#),
           ((0, 0), (1186, 1187), (1186, 1187), (1188, 1189)), 0, 0),
         16#9B#           =>  --  1E9B
          ((16#0000#, 16#1E60#, 16#1E60#, 16#1E61#),
           ((0, 0), (1117, 1117), (1117, 1117), (1116, 1116)), 0, 0),
         16#9E#           =>  --  1E9E
          ((16#00DF#, 16#0000#, 16#0000#, 16#00DF#),
           ((1190, 1190), (0, 0), (0, 0), (89, 90)), 0, 0),
         16#A0#           =>  --  1EA0
          ((16#1EA1#, 16#0000#, 16#0000#, 16#1EA1#),
           ((1191, 1191), (0, 0), (0, 0), (1191, 1191)), 0, 0),
         16#A1#           =>  --  1EA1
          ((16#0000#, 16#1EA0#, 16#1EA0#, 16#0000#),
           ((0, 0), (1192, 1192), (1192, 1192), (0, 0)), 0, 0),
         16#A2#           =>  --  1EA2
          ((16#1EA3#, 16#0000#, 16#0000#, 16#1EA3#),
           ((1193, 1193), (0, 0), (0, 0), (1193, 1193)), 0, 0),
         16#A3#           =>  --  1EA3
          ((16#0000#, 16#1EA2#, 16#1EA2#, 16#0000#),
           ((0, 0), (1194, 1194), (1194, 1194), (0, 0)), 0, 0),
         16#A4#           =>  --  1EA4
          ((16#1EA5#, 16#0000#, 16#0000#, 16#1EA5#),
           ((1195, 1195), (0, 0), (0, 0), (1195, 1195)), 0, 0),
         16#A5#           =>  --  1EA5
          ((16#0000#, 16#1EA4#, 16#1EA4#, 16#0000#),
           ((0, 0), (1196, 1196), (1196, 1196), (0, 0)), 0, 0),
         16#A6#           =>  --  1EA6
          ((16#1EA7#, 16#0000#, 16#0000#, 16#1EA7#),
           ((1197, 1197), (0, 0), (0, 0), (1197, 1197)), 0, 0),
         16#A7#           =>  --  1EA7
          ((16#0000#, 16#1EA6#, 16#1EA6#, 16#0000#),
           ((0, 0), (1198, 1198), (1198, 1198), (0, 0)), 0, 0),
         16#A8#           =>  --  1EA8
          ((16#1EA9#, 16#0000#, 16#0000#, 16#1EA9#),
           ((1199, 1199), (0, 0), (0, 0), (1199, 1199)), 0, 0),
         16#A9#           =>  --  1EA9
          ((16#0000#, 16#1EA8#, 16#1EA8#, 16#0000#),
           ((0, 0), (1200, 1200), (1200, 1200), (0, 0)), 0, 0),
         16#AA#           =>  --  1EAA
          ((16#1EAB#, 16#0000#, 16#0000#, 16#1EAB#),
           ((1201, 1201), (0, 0), (0, 0), (1201, 1201)), 0, 0),
         16#AB#           =>  --  1EAB
          ((16#0000#, 16#1EAA#, 16#1EAA#, 16#0000#),
           ((0, 0), (1202, 1202), (1202, 1202), (0, 0)), 0, 0),
         16#AC#           =>  --  1EAC
          ((16#1EAD#, 16#0000#, 16#0000#, 16#1EAD#),
           ((1203, 1203), (0, 0), (0, 0), (1203, 1203)), 0, 0),
         16#AD#           =>  --  1EAD
          ((16#0000#, 16#1EAC#, 16#1EAC#, 16#0000#),
           ((0, 0), (1204, 1204), (1204, 1204), (0, 0)), 0, 0),
         16#AE#           =>  --  1EAE
          ((16#1EAF#, 16#0000#, 16#0000#, 16#1EAF#),
           ((1205, 1205), (0, 0), (0, 0), (1205, 1205)), 0, 0),
         16#AF#           =>  --  1EAF
          ((16#0000#, 16#1EAE#, 16#1EAE#, 16#0000#),
           ((0, 0), (1206, 1206), (1206, 1206), (0, 0)), 0, 0),
         16#B0#           =>  --  1EB0
          ((16#1EB1#, 16#0000#, 16#0000#, 16#1EB1#),
           ((1207, 1207), (0, 0), (0, 0), (1207, 1207)), 0, 0),
         16#B1#           =>  --  1EB1
          ((16#0000#, 16#1EB0#, 16#1EB0#, 16#0000#),
           ((0, 0), (1208, 1208), (1208, 1208), (0, 0)), 0, 0),
         16#B2#           =>  --  1EB2
          ((16#1EB3#, 16#0000#, 16#0000#, 16#1EB3#),
           ((1209, 1209), (0, 0), (0, 0), (1209, 1209)), 0, 0),
         16#B3#           =>  --  1EB3
          ((16#0000#, 16#1EB2#, 16#1EB2#, 16#0000#),
           ((0, 0), (1210, 1210), (1210, 1210), (0, 0)), 0, 0),
         16#B4#           =>  --  1EB4
          ((16#1EB5#, 16#0000#, 16#0000#, 16#1EB5#),
           ((1211, 1211), (0, 0), (0, 0), (1211, 1211)), 0, 0),
         16#B5#           =>  --  1EB5
          ((16#0000#, 16#1EB4#, 16#1EB4#, 16#0000#),
           ((0, 0), (1212, 1212), (1212, 1212), (0, 0)), 0, 0),
         16#B6#           =>  --  1EB6
          ((16#1EB7#, 16#0000#, 16#0000#, 16#1EB7#),
           ((1213, 1213), (0, 0), (0, 0), (1213, 1213)), 0, 0),
         16#B7#           =>  --  1EB7
          ((16#0000#, 16#1EB6#, 16#1EB6#, 16#0000#),
           ((0, 0), (1214, 1214), (1214, 1214), (0, 0)), 0, 0),
         16#B8#           =>  --  1EB8
          ((16#1EB9#, 16#0000#, 16#0000#, 16#1EB9#),
           ((1215, 1215), (0, 0), (0, 0), (1215, 1215)), 0, 0),
         16#B9#           =>  --  1EB9
          ((16#0000#, 16#1EB8#, 16#1EB8#, 16#0000#),
           ((0, 0), (1216, 1216), (1216, 1216), (0, 0)), 0, 0),
         16#BA#           =>  --  1EBA
          ((16#1EBB#, 16#0000#, 16#0000#, 16#1EBB#),
           ((1217, 1217), (0, 0), (0, 0), (1217, 1217)), 0, 0),
         16#BB#           =>  --  1EBB
          ((16#0000#, 16#1EBA#, 16#1EBA#, 16#0000#),
           ((0, 0), (1218, 1218), (1218, 1218), (0, 0)), 0, 0),
         16#BC#           =>  --  1EBC
          ((16#1EBD#, 16#0000#, 16#0000#, 16#1EBD#),
           ((1219, 1219), (0, 0), (0, 0), (1219, 1219)), 0, 0),
         16#BD#           =>  --  1EBD
          ((16#0000#, 16#1EBC#, 16#1EBC#, 16#0000#),
           ((0, 0), (1220, 1220), (1220, 1220), (0, 0)), 0, 0),
         16#BE#           =>  --  1EBE
          ((16#1EBF#, 16#0000#, 16#0000#, 16#1EBF#),
           ((1221, 1221), (0, 0), (0, 0), (1221, 1221)), 0, 0),
         16#BF#           =>  --  1EBF
          ((16#0000#, 16#1EBE#, 16#1EBE#, 16#0000#),
           ((0, 0), (1222, 1222), (1222, 1222), (0, 0)), 0, 0),
         16#C0#           =>  --  1EC0
          ((16#1EC1#, 16#0000#, 16#0000#, 16#1EC1#),
           ((1223, 1223), (0, 0), (0, 0), (1223, 1223)), 0, 0),
         16#C1#           =>  --  1EC1
          ((16#0000#, 16#1EC0#, 16#1EC0#, 16#0000#),
           ((0, 0), (1224, 1224), (1224, 1224), (0, 0)), 0, 0),
         16#C2#           =>  --  1EC2
          ((16#1EC3#, 16#0000#, 16#0000#, 16#1EC3#),
           ((1225, 1225), (0, 0), (0, 0), (1225, 1225)), 0, 0),
         16#C3#           =>  --  1EC3
          ((16#0000#, 16#1EC2#, 16#1EC2#, 16#0000#),
           ((0, 0), (1226, 1226), (1226, 1226), (0, 0)), 0, 0),
         16#C4#           =>  --  1EC4
          ((16#1EC5#, 16#0000#, 16#0000#, 16#1EC5#),
           ((1227, 1227), (0, 0), (0, 0), (1227, 1227)), 0, 0),
         16#C5#           =>  --  1EC5
          ((16#0000#, 16#1EC4#, 16#1EC4#, 16#0000#),
           ((0, 0), (1228, 1228), (1228, 1228), (0, 0)), 0, 0),
         16#C6#           =>  --  1EC6
          ((16#1EC7#, 16#0000#, 16#0000#, 16#1EC7#),
           ((1229, 1229), (0, 0), (0, 0), (1229, 1229)), 0, 0),
         16#C7#           =>  --  1EC7
          ((16#0000#, 16#1EC6#, 16#1EC6#, 16#0000#),
           ((0, 0), (1230, 1230), (1230, 1230), (0, 0)), 0, 0),
         16#C8#           =>  --  1EC8
          ((16#1EC9#, 16#0000#, 16#0000#, 16#1EC9#),
           ((1231, 1231), (0, 0), (0, 0), (1231, 1231)), 0, 0),
         16#C9#           =>  --  1EC9
          ((16#0000#, 16#1EC8#, 16#1EC8#, 16#0000#),
           ((0, 0), (1232, 1232), (1232, 1232), (0, 0)), 0, 0),
         16#CA#           =>  --  1ECA
          ((16#1ECB#, 16#0000#, 16#0000#, 16#1ECB#),
           ((1233, 1233), (0, 0), (0, 0), (1233, 1233)), 0, 0),
         16#CB#           =>  --  1ECB
          ((16#0000#, 16#1ECA#, 16#1ECA#, 16#0000#),
           ((0, 0), (1234, 1234), (1234, 1234), (0, 0)), 0, 0),
         16#CC#           =>  --  1ECC
          ((16#1ECD#, 16#0000#, 16#0000#, 16#1ECD#),
           ((1235, 1235), (0, 0), (0, 0), (1235, 1235)), 0, 0),
         16#CD#           =>  --  1ECD
          ((16#0000#, 16#1ECC#, 16#1ECC#, 16#0000#),
           ((0, 0), (1236, 1236), (1236, 1236), (0, 0)), 0, 0),
         16#CE#           =>  --  1ECE
          ((16#1ECF#, 16#0000#, 16#0000#, 16#1ECF#),
           ((1237, 1237), (0, 0), (0, 0), (1237, 1237)), 0, 0),
         16#CF#           =>  --  1ECF
          ((16#0000#, 16#1ECE#, 16#1ECE#, 16#0000#),
           ((0, 0), (1238, 1238), (1238, 1238), (0, 0)), 0, 0),
         16#D0#           =>  --  1ED0
          ((16#1ED1#, 16#0000#, 16#0000#, 16#1ED1#),
           ((1239, 1239), (0, 0), (0, 0), (1239, 1239)), 0, 0),
         16#D1#           =>  --  1ED1
          ((16#0000#, 16#1ED0#, 16#1ED0#, 16#0000#),
           ((0, 0), (1240, 1240), (1240, 1240), (0, 0)), 0, 0),
         16#D2#           =>  --  1ED2
          ((16#1ED3#, 16#0000#, 16#0000#, 16#1ED3#),
           ((1241, 1241), (0, 0), (0, 0), (1241, 1241)), 0, 0),
         16#D3#           =>  --  1ED3
          ((16#0000#, 16#1ED2#, 16#1ED2#, 16#0000#),
           ((0, 0), (1242, 1242), (1242, 1242), (0, 0)), 0, 0),
         16#D4#           =>  --  1ED4
          ((16#1ED5#, 16#0000#, 16#0000#, 16#1ED5#),
           ((1243, 1243), (0, 0), (0, 0), (1243, 1243)), 0, 0),
         16#D5#           =>  --  1ED5
          ((16#0000#, 16#1ED4#, 16#1ED4#, 16#0000#),
           ((0, 0), (1244, 1244), (1244, 1244), (0, 0)), 0, 0),
         16#D6#           =>  --  1ED6
          ((16#1ED7#, 16#0000#, 16#0000#, 16#1ED7#),
           ((1245, 1245), (0, 0), (0, 0), (1245, 1245)), 0, 0),
         16#D7#           =>  --  1ED7
          ((16#0000#, 16#1ED6#, 16#1ED6#, 16#0000#),
           ((0, 0), (1246, 1246), (1246, 1246), (0, 0)), 0, 0),
         16#D8#           =>  --  1ED8
          ((16#1ED9#, 16#0000#, 16#0000#, 16#1ED9#),
           ((1247, 1247), (0, 0), (0, 0), (1247, 1247)), 0, 0),
         16#D9#           =>  --  1ED9
          ((16#0000#, 16#1ED8#, 16#1ED8#, 16#0000#),
           ((0, 0), (1248, 1248), (1248, 1248), (0, 0)), 0, 0),
         16#DA#           =>  --  1EDA
          ((16#1EDB#, 16#0000#, 16#0000#, 16#1EDB#),
           ((1249, 1249), (0, 0), (0, 0), (1249, 1249)), 0, 0),
         16#DB#           =>  --  1EDB
          ((16#0000#, 16#1EDA#, 16#1EDA#, 16#0000#),
           ((0, 0), (1250, 1250), (1250, 1250), (0, 0)), 0, 0),
         16#DC#           =>  --  1EDC
          ((16#1EDD#, 16#0000#, 16#0000#, 16#1EDD#),
           ((1251, 1251), (0, 0), (0, 0), (1251, 1251)), 0, 0),
         16#DD#           =>  --  1EDD
          ((16#0000#, 16#1EDC#, 16#1EDC#, 16#0000#),
           ((0, 0), (1252, 1252), (1252, 1252), (0, 0)), 0, 0),
         16#DE#           =>  --  1EDE
          ((16#1EDF#, 16#0000#, 16#0000#, 16#1EDF#),
           ((1253, 1253), (0, 0), (0, 0), (1253, 1253)), 0, 0),
         16#DF#           =>  --  1EDF
          ((16#0000#, 16#1EDE#, 16#1EDE#, 16#0000#),
           ((0, 0), (1254, 1254), (1254, 1254), (0, 0)), 0, 0),
         16#E0#           =>  --  1EE0
          ((16#1EE1#, 16#0000#, 16#0000#, 16#1EE1#),
           ((1255, 1255), (0, 0), (0, 0), (1255, 1255)), 0, 0),
         16#E1#           =>  --  1EE1
          ((16#0000#, 16#1EE0#, 16#1EE0#, 16#0000#),
           ((0, 0), (1256, 1256), (1256, 1256), (0, 0)), 0, 0),
         16#E2#           =>  --  1EE2
          ((16#1EE3#, 16#0000#, 16#0000#, 16#1EE3#),
           ((1257, 1257), (0, 0), (0, 0), (1257, 1257)), 0, 0),
         16#E3#           =>  --  1EE3
          ((16#0000#, 16#1EE2#, 16#1EE2#, 16#0000#),
           ((0, 0), (1258, 1258), (1258, 1258), (0, 0)), 0, 0),
         16#E4#           =>  --  1EE4
          ((16#1EE5#, 16#0000#, 16#0000#, 16#1EE5#),
           ((1259, 1259), (0, 0), (0, 0), (1259, 1259)), 0, 0),
         16#E5#           =>  --  1EE5
          ((16#0000#, 16#1EE4#, 16#1EE4#, 16#0000#),
           ((0, 0), (1260, 1260), (1260, 1260), (0, 0)), 0, 0),
         16#E6#           =>  --  1EE6
          ((16#1EE7#, 16#0000#, 16#0000#, 16#1EE7#),
           ((1261, 1261), (0, 0), (0, 0), (1261, 1261)), 0, 0),
         16#E7#           =>  --  1EE7
          ((16#0000#, 16#1EE6#, 16#1EE6#, 16#0000#),
           ((0, 0), (1262, 1262), (1262, 1262), (0, 0)), 0, 0),
         16#E8#           =>  --  1EE8
          ((16#1EE9#, 16#0000#, 16#0000#, 16#1EE9#),
           ((1263, 1263), (0, 0), (0, 0), (1263, 1263)), 0, 0),
         16#E9#           =>  --  1EE9
          ((16#0000#, 16#1EE8#, 16#1EE8#, 16#0000#),
           ((0, 0), (1264, 1264), (1264, 1264), (0, 0)), 0, 0),
         16#EA#           =>  --  1EEA
          ((16#1EEB#, 16#0000#, 16#0000#, 16#1EEB#),
           ((1265, 1265), (0, 0), (0, 0), (1265, 1265)), 0, 0),
         16#EB#           =>  --  1EEB
          ((16#0000#, 16#1EEA#, 16#1EEA#, 16#0000#),
           ((0, 0), (1266, 1266), (1266, 1266), (0, 0)), 0, 0),
         16#EC#           =>  --  1EEC
          ((16#1EED#, 16#0000#, 16#0000#, 16#1EED#),
           ((1267, 1267), (0, 0), (0, 0), (1267, 1267)), 0, 0),
         16#ED#           =>  --  1EED
          ((16#0000#, 16#1EEC#, 16#1EEC#, 16#0000#),
           ((0, 0), (1268, 1268), (1268, 1268), (0, 0)), 0, 0),
         16#EE#           =>  --  1EEE
          ((16#1EEF#, 16#0000#, 16#0000#, 16#1EEF#),
           ((1269, 1269), (0, 0), (0, 0), (1269, 1269)), 0, 0),
         16#EF#           =>  --  1EEF
          ((16#0000#, 16#1EEE#, 16#1EEE#, 16#0000#),
           ((0, 0), (1270, 1270), (1270, 1270), (0, 0)), 0, 0),
         16#F0#           =>  --  1EF0
          ((16#1EF1#, 16#0000#, 16#0000#, 16#1EF1#),
           ((1271, 1271), (0, 0), (0, 0), (1271, 1271)), 0, 0),
         16#F1#           =>  --  1EF1
          ((16#0000#, 16#1EF0#, 16#1EF0#, 16#0000#),
           ((0, 0), (1272, 1272), (1272, 1272), (0, 0)), 0, 0),
         16#F2#           =>  --  1EF2
          ((16#1EF3#, 16#0000#, 16#0000#, 16#1EF3#),
           ((1273, 1273), (0, 0), (0, 0), (1273, 1273)), 0, 0),
         16#F3#           =>  --  1EF3
          ((16#0000#, 16#1EF2#, 16#1EF2#, 16#0000#),
           ((0, 0), (1274, 1274), (1274, 1274), (0, 0)), 0, 0),
         16#F4#           =>  --  1EF4
          ((16#1EF5#, 16#0000#, 16#0000#, 16#1EF5#),
           ((1275, 1275), (0, 0), (0, 0), (1275, 1275)), 0, 0),
         16#F5#           =>  --  1EF5
          ((16#0000#, 16#1EF4#, 16#1EF4#, 16#0000#),
           ((0, 0), (1276, 1276), (1276, 1276), (0, 0)), 0, 0),
         16#F6#           =>  --  1EF6
          ((16#1EF7#, 16#0000#, 16#0000#, 16#1EF7#),
           ((1277, 1277), (0, 0), (0, 0), (1277, 1277)), 0, 0),
         16#F7#           =>  --  1EF7
          ((16#0000#, 16#1EF6#, 16#1EF6#, 16#0000#),
           ((0, 0), (1278, 1278), (1278, 1278), (0, 0)), 0, 0),
         16#F8#           =>  --  1EF8
          ((16#1EF9#, 16#0000#, 16#0000#, 16#1EF9#),
           ((1279, 1279), (0, 0), (0, 0), (1279, 1279)), 0, 0),
         16#F9#           =>  --  1EF9
          ((16#0000#, 16#1EF8#, 16#1EF8#, 16#0000#),
           ((0, 0), (1280, 1280), (1280, 1280), (0, 0)), 0, 0),
         16#FA#           =>  --  1EFA
          ((16#1EFB#, 16#0000#, 16#0000#, 16#1EFB#),
           ((1281, 1281), (0, 0), (0, 0), (1281, 1281)), 0, 0),
         16#FB#           =>  --  1EFB
          ((16#0000#, 16#1EFA#, 16#1EFA#, 16#0000#),
           ((0, 0), (1282, 1282), (1282, 1282), (0, 0)), 0, 0),
         16#FC#           =>  --  1EFC
          ((16#1EFD#, 16#0000#, 16#0000#, 16#1EFD#),
           ((1283, 1283), (0, 0), (0, 0), (1283, 1283)), 0, 0),
         16#FD#           =>  --  1EFD
          ((16#0000#, 16#1EFC#, 16#1EFC#, 16#0000#),
           ((0, 0), (1284, 1284), (1284, 1284), (0, 0)), 0, 0),
         16#FE#           =>  --  1EFE
          ((16#1EFF#, 16#0000#, 16#0000#, 16#1EFF#),
           ((1285, 1285), (0, 0), (0, 0), (1285, 1285)), 0, 0),
         16#FF#           =>  --  1EFF
          ((16#0000#, 16#1EFE#, 16#1EFE#, 16#0000#),
           ((0, 0), (1286, 1286), (1286, 1286), (0, 0)), 0, 0),
         others           =>
          ((16#0000#, 16#0000#, 16#0000#, 16#0000#),
           ((0, 0), (0, 0), (0, 0), (0, 0)), 0, 0));

   Group_001F : aliased constant Case_Mapping_Second_Stage
     := (16#00#           =>  --  1F00
          ((16#0000#, 16#1F08#, 16#1F08#, 16#0000#),
           ((0, 0), (1287, 1287), (1287, 1287), (0, 0)), 0, 0),
         16#01#           =>  --  1F01
          ((16#0000#, 16#1F09#, 16#1F09#, 16#0000#),
           ((0, 0), (1288, 1288), (1288, 1288), (0, 0)), 0, 0),
         16#02#           =>  --  1F02
          ((16#0000#, 16#1F0A#, 16#1F0A#, 16#0000#),
           ((0, 0), (1289, 1289), (1289, 1289), (0, 0)), 0, 0),
         16#03#           =>  --  1F03
          ((16#0000#, 16#1F0B#, 16#1F0B#, 16#0000#),
           ((0, 0), (1290, 1290), (1290, 1290), (0, 0)), 0, 0),
         16#04#           =>  --  1F04
          ((16#0000#, 16#1F0C#, 16#1F0C#, 16#0000#),
           ((0, 0), (1291, 1291), (1291, 1291), (0, 0)), 0, 0),
         16#05#           =>  --  1F05
          ((16#0000#, 16#1F0D#, 16#1F0D#, 16#0000#),
           ((0, 0), (1292, 1292), (1292, 1292), (0, 0)), 0, 0),
         16#06#           =>  --  1F06
          ((16#0000#, 16#1F0E#, 16#1F0E#, 16#0000#),
           ((0, 0), (1293, 1293), (1293, 1293), (0, 0)), 0, 0),
         16#07#           =>  --  1F07
          ((16#0000#, 16#1F0F#, 16#1F0F#, 16#0000#),
           ((0, 0), (1294, 1294), (1294, 1294), (0, 0)), 0, 0),
         16#08#           =>  --  1F08
          ((16#1F00#, 16#0000#, 16#0000#, 16#1F00#),
           ((1295, 1295), (0, 0), (0, 0), (1295, 1295)), 0, 0),
         16#09#           =>  --  1F09
          ((16#1F01#, 16#0000#, 16#0000#, 16#1F01#),
           ((1296, 1296), (0, 0), (0, 0), (1296, 1296)), 0, 0),
         16#0A#           =>  --  1F0A
          ((16#1F02#, 16#0000#, 16#0000#, 16#1F02#),
           ((1297, 1297), (0, 0), (0, 0), (1297, 1297)), 0, 0),
         16#0B#           =>  --  1F0B
          ((16#1F03#, 16#0000#, 16#0000#, 16#1F03#),
           ((1298, 1298), (0, 0), (0, 0), (1298, 1298)), 0, 0),
         16#0C#           =>  --  1F0C
          ((16#1F04#, 16#0000#, 16#0000#, 16#1F04#),
           ((1299, 1299), (0, 0), (0, 0), (1299, 1299)), 0, 0),
         16#0D#           =>  --  1F0D
          ((16#1F05#, 16#0000#, 16#0000#, 16#1F05#),
           ((1300, 1300), (0, 0), (0, 0), (1300, 1300)), 0, 0),
         16#0E#           =>  --  1F0E
          ((16#1F06#, 16#0000#, 16#0000#, 16#1F06#),
           ((1301, 1301), (0, 0), (0, 0), (1301, 1301)), 0, 0),
         16#0F#           =>  --  1F0F
          ((16#1F07#, 16#0000#, 16#0000#, 16#1F07#),
           ((1302, 1302), (0, 0), (0, 0), (1302, 1302)), 0, 0),
         16#10#           =>  --  1F10
          ((16#0000#, 16#1F18#, 16#1F18#, 16#0000#),
           ((0, 0), (1303, 1303), (1303, 1303), (0, 0)), 0, 0),
         16#11#           =>  --  1F11
          ((16#0000#, 16#1F19#, 16#1F19#, 16#0000#),
           ((0, 0), (1304, 1304), (1304, 1304), (0, 0)), 0, 0),
         16#12#           =>  --  1F12
          ((16#0000#, 16#1F1A#, 16#1F1A#, 16#0000#),
           ((0, 0), (1305, 1305), (1305, 1305), (0, 0)), 0, 0),
         16#13#           =>  --  1F13
          ((16#0000#, 16#1F1B#, 16#1F1B#, 16#0000#),
           ((0, 0), (1306, 1306), (1306, 1306), (0, 0)), 0, 0),
         16#14#           =>  --  1F14
          ((16#0000#, 16#1F1C#, 16#1F1C#, 16#0000#),
           ((0, 0), (1307, 1307), (1307, 1307), (0, 0)), 0, 0),
         16#15#           =>  --  1F15
          ((16#0000#, 16#1F1D#, 16#1F1D#, 16#0000#),
           ((0, 0), (1308, 1308), (1308, 1308), (0, 0)), 0, 0),
         16#18#           =>  --  1F18
          ((16#1F10#, 16#0000#, 16#0000#, 16#1F10#),
           ((1309, 1309), (0, 0), (0, 0), (1309, 1309)), 0, 0),
         16#19#           =>  --  1F19
          ((16#1F11#, 16#0000#, 16#0000#, 16#1F11#),
           ((1310, 1310), (0, 0), (0, 0), (1310, 1310)), 0, 0),
         16#1A#           =>  --  1F1A
          ((16#1F12#, 16#0000#, 16#0000#, 16#1F12#),
           ((1311, 1311), (0, 0), (0, 0), (1311, 1311)), 0, 0),
         16#1B#           =>  --  1F1B
          ((16#1F13#, 16#0000#, 16#0000#, 16#1F13#),
           ((1312, 1312), (0, 0), (0, 0), (1312, 1312)), 0, 0),
         16#1C#           =>  --  1F1C
          ((16#1F14#, 16#0000#, 16#0000#, 16#1F14#),
           ((1313, 1313), (0, 0), (0, 0), (1313, 1313)), 0, 0),
         16#1D#           =>  --  1F1D
          ((16#1F15#, 16#0000#, 16#0000#, 16#1F15#),
           ((1314, 1314), (0, 0), (0, 0), (1314, 1314)), 0, 0),
         16#20#           =>  --  1F20
          ((16#0000#, 16#1F28#, 16#1F28#, 16#0000#),
           ((0, 0), (1315, 1315), (1315, 1315), (0, 0)), 0, 0),
         16#21#           =>  --  1F21
          ((16#0000#, 16#1F29#, 16#1F29#, 16#0000#),
           ((0, 0), (1316, 1316), (1316, 1316), (0, 0)), 0, 0),
         16#22#           =>  --  1F22
          ((16#0000#, 16#1F2A#, 16#1F2A#, 16#0000#),
           ((0, 0), (1317, 1317), (1317, 1317), (0, 0)), 0, 0),
         16#23#           =>  --  1F23
          ((16#0000#, 16#1F2B#, 16#1F2B#, 16#0000#),
           ((0, 0), (1318, 1318), (1318, 1318), (0, 0)), 0, 0),
         16#24#           =>  --  1F24
          ((16#0000#, 16#1F2C#, 16#1F2C#, 16#0000#),
           ((0, 0), (1319, 1319), (1319, 1319), (0, 0)), 0, 0),
         16#25#           =>  --  1F25
          ((16#0000#, 16#1F2D#, 16#1F2D#, 16#0000#),
           ((0, 0), (1320, 1320), (1320, 1320), (0, 0)), 0, 0),
         16#26#           =>  --  1F26
          ((16#0000#, 16#1F2E#, 16#1F2E#, 16#0000#),
           ((0, 0), (1321, 1321), (1321, 1321), (0, 0)), 0, 0),
         16#27#           =>  --  1F27
          ((16#0000#, 16#1F2F#, 16#1F2F#, 16#0000#),
           ((0, 0), (1322, 1322), (1322, 1322), (0, 0)), 0, 0),
         16#28#           =>  --  1F28
          ((16#1F20#, 16#0000#, 16#0000#, 16#1F20#),
           ((1323, 1323), (0, 0), (0, 0), (1323, 1323)), 0, 0),
         16#29#           =>  --  1F29
          ((16#1F21#, 16#0000#, 16#0000#, 16#1F21#),
           ((1324, 1324), (0, 0), (0, 0), (1324, 1324)), 0, 0),
         16#2A#           =>  --  1F2A
          ((16#1F22#, 16#0000#, 16#0000#, 16#1F22#),
           ((1325, 1325), (0, 0), (0, 0), (1325, 1325)), 0, 0),
         16#2B#           =>  --  1F2B
          ((16#1F23#, 16#0000#, 16#0000#, 16#1F23#),
           ((1326, 1326), (0, 0), (0, 0), (1326, 1326)), 0, 0),
         16#2C#           =>  --  1F2C
          ((16#1F24#, 16#0000#, 16#0000#, 16#1F24#),
           ((1327, 1327), (0, 0), (0, 0), (1327, 1327)), 0, 0),
         16#2D#           =>  --  1F2D
          ((16#1F25#, 16#0000#, 16#0000#, 16#1F25#),
           ((1328, 1328), (0, 0), (0, 0), (1328, 1328)), 0, 0),
         16#2E#           =>  --  1F2E
          ((16#1F26#, 16#0000#, 16#0000#, 16#1F26#),
           ((1329, 1329), (0, 0), (0, 0), (1329, 1329)), 0, 0),
         16#2F#           =>  --  1F2F
          ((16#1F27#, 16#0000#, 16#0000#, 16#1F27#),
           ((1330, 1330), (0, 0), (0, 0), (1330, 1330)), 0, 0),
         16#30#           =>  --  1F30
          ((16#0000#, 16#1F38#, 16#1F38#, 16#0000#),
           ((0, 0), (1331, 1331), (1331, 1331), (0, 0)), 0, 0),
         16#31#           =>  --  1F31
          ((16#0000#, 16#1F39#, 16#1F39#, 16#0000#),
           ((0, 0), (1332, 1332), (1332, 1332), (0, 0)), 0, 0),
         16#32#           =>  --  1F32
          ((16#0000#, 16#1F3A#, 16#1F3A#, 16#0000#),
           ((0, 0), (1333, 1333), (1333, 1333), (0, 0)), 0, 0),
         16#33#           =>  --  1F33
          ((16#0000#, 16#1F3B#, 16#1F3B#, 16#0000#),
           ((0, 0), (1334, 1334), (1334, 1334), (0, 0)), 0, 0),
         16#34#           =>  --  1F34
          ((16#0000#, 16#1F3C#, 16#1F3C#, 16#0000#),
           ((0, 0), (1335, 1335), (1335, 1335), (0, 0)), 0, 0),
         16#35#           =>  --  1F35
          ((16#0000#, 16#1F3D#, 16#1F3D#, 16#0000#),
           ((0, 0), (1336, 1336), (1336, 1336), (0, 0)), 0, 0),
         16#36#           =>  --  1F36
          ((16#0000#, 16#1F3E#, 16#1F3E#, 16#0000#),
           ((0, 0), (1337, 1337), (1337, 1337), (0, 0)), 0, 0),
         16#37#           =>  --  1F37
          ((16#0000#, 16#1F3F#, 16#1F3F#, 16#0000#),
           ((0, 0), (1338, 1338), (1338, 1338), (0, 0)), 0, 0),
         16#38#           =>  --  1F38
          ((16#1F30#, 16#0000#, 16#0000#, 16#1F30#),
           ((1339, 1339), (0, 0), (0, 0), (1339, 1339)), 0, 0),
         16#39#           =>  --  1F39
          ((16#1F31#, 16#0000#, 16#0000#, 16#1F31#),
           ((1340, 1340), (0, 0), (0, 0), (1340, 1340)), 0, 0),
         16#3A#           =>  --  1F3A
          ((16#1F32#, 16#0000#, 16#0000#, 16#1F32#),
           ((1341, 1341), (0, 0), (0, 0), (1341, 1341)), 0, 0),
         16#3B#           =>  --  1F3B
          ((16#1F33#, 16#0000#, 16#0000#, 16#1F33#),
           ((1342, 1342), (0, 0), (0, 0), (1342, 1342)), 0, 0),
         16#3C#           =>  --  1F3C
          ((16#1F34#, 16#0000#, 16#0000#, 16#1F34#),
           ((1343, 1343), (0, 0), (0, 0), (1343, 1343)), 0, 0),
         16#3D#           =>  --  1F3D
          ((16#1F35#, 16#0000#, 16#0000#, 16#1F35#),
           ((1344, 1344), (0, 0), (0, 0), (1344, 1344)), 0, 0),
         16#3E#           =>  --  1F3E
          ((16#1F36#, 16#0000#, 16#0000#, 16#1F36#),
           ((1345, 1345), (0, 0), (0, 0), (1345, 1345)), 0, 0),
         16#3F#           =>  --  1F3F
          ((16#1F37#, 16#0000#, 16#0000#, 16#1F37#),
           ((1346, 1346), (0, 0), (0, 0), (1346, 1346)), 0, 0),
         16#40#           =>  --  1F40
          ((16#0000#, 16#1F48#, 16#1F48#, 16#0000#),
           ((0, 0), (1347, 1347), (1347, 1347), (0, 0)), 0, 0),
         16#41#           =>  --  1F41
          ((16#0000#, 16#1F49#, 16#1F49#, 16#0000#),
           ((0, 0), (1348, 1348), (1348, 1348), (0, 0)), 0, 0),
         16#42#           =>  --  1F42
          ((16#0000#, 16#1F4A#, 16#1F4A#, 16#0000#),
           ((0, 0), (1349, 1349), (1349, 1349), (0, 0)), 0, 0),
         16#43#           =>  --  1F43
          ((16#0000#, 16#1F4B#, 16#1F4B#, 16#0000#),
           ((0, 0), (1350, 1350), (1350, 1350), (0, 0)), 0, 0),
         16#44#           =>  --  1F44
          ((16#0000#, 16#1F4C#, 16#1F4C#, 16#0000#),
           ((0, 0), (1351, 1351), (1351, 1351), (0, 0)), 0, 0),
         16#45#           =>  --  1F45
          ((16#0000#, 16#1F4D#, 16#1F4D#, 16#0000#),
           ((0, 0), (1352, 1352), (1352, 1352), (0, 0)), 0, 0),
         16#48#           =>  --  1F48
          ((16#1F40#, 16#0000#, 16#0000#, 16#1F40#),
           ((1353, 1353), (0, 0), (0, 0), (1353, 1353)), 0, 0),
         16#49#           =>  --  1F49
          ((16#1F41#, 16#0000#, 16#0000#, 16#1F41#),
           ((1354, 1354), (0, 0), (0, 0), (1354, 1354)), 0, 0),
         16#4A#           =>  --  1F4A
          ((16#1F42#, 16#0000#, 16#0000#, 16#1F42#),
           ((1355, 1355), (0, 0), (0, 0), (1355, 1355)), 0, 0),
         16#4B#           =>  --  1F4B
          ((16#1F43#, 16#0000#, 16#0000#, 16#1F43#),
           ((1356, 1356), (0, 0), (0, 0), (1356, 1356)), 0, 0),
         16#4C#           =>  --  1F4C
          ((16#1F44#, 16#0000#, 16#0000#, 16#1F44#),
           ((1357, 1357), (0, 0), (0, 0), (1357, 1357)), 0, 0),
         16#4D#           =>  --  1F4D
          ((16#1F45#, 16#0000#, 16#0000#, 16#1F45#),
           ((1358, 1358), (0, 0), (0, 0), (1358, 1358)), 0, 0),
         16#50#           =>  --  1F50
          ((16#0000#, 16#0000#, 16#0000#, 16#0000#),
           ((0, 0), (1359, 1360), (1359, 1360), (1361, 1362)), 0, 0),
         16#51#           =>  --  1F51
          ((16#0000#, 16#1F59#, 16#1F59#, 16#0000#),
           ((0, 0), (1363, 1363), (1363, 1363), (0, 0)), 0, 0),
         16#52#           =>  --  1F52
          ((16#0000#, 16#0000#, 16#0000#, 16#0000#),
           ((0, 0), (1364, 1366), (1364, 1366), (1367, 1369)), 0, 0),
         16#53#           =>  --  1F53
          ((16#0000#, 16#1F5B#, 16#1F5B#, 16#0000#),
           ((0, 0), (1370, 1370), (1370, 1370), (0, 0)), 0, 0),
         16#54#           =>  --  1F54
          ((16#0000#, 16#0000#, 16#0000#, 16#0000#),
           ((0, 0), (1371, 1373), (1371, 1373), (1374, 1376)), 0, 0),
         16#55#           =>  --  1F55
          ((16#0000#, 16#1F5D#, 16#1F5D#, 16#0000#),
           ((0, 0), (1377, 1377), (1377, 1377), (0, 0)), 0, 0),
         16#56#           =>  --  1F56
          ((16#0000#, 16#0000#, 16#0000#, 16#0000#),
           ((0, 0), (1378, 1380), (1378, 1380), (1381, 1383)), 0, 0),
         16#57#           =>  --  1F57
          ((16#0000#, 16#1F5F#, 16#1F5F#, 16#0000#),
           ((0, 0), (1384, 1384), (1384, 1384), (0, 0)), 0, 0),
         16#59#           =>  --  1F59
          ((16#1F51#, 16#0000#, 16#0000#, 16#1F51#),
           ((1385, 1385), (0, 0), (0, 0), (1385, 1385)), 0, 0),
         16#5B#           =>  --  1F5B
          ((16#1F53#, 16#0000#, 16#0000#, 16#1F53#),
           ((1386, 1386), (0, 0), (0, 0), (1386, 1386)), 0, 0),
         16#5D#           =>  --  1F5D
          ((16#1F55#, 16#0000#, 16#0000#, 16#1F55#),
           ((1387, 1387), (0, 0), (0, 0), (1387, 1387)), 0, 0),
         16#5F#           =>  --  1F5F
          ((16#1F57#, 16#0000#, 16#0000#, 16#1F57#),
           ((1388, 1388), (0, 0), (0, 0), (1388, 1388)), 0, 0),
         16#60#           =>  --  1F60
          ((16#0000#, 16#1F68#, 16#1F68#, 16#0000#),
           ((0, 0), (1389, 1389), (1389, 1389), (0, 0)), 0, 0),
         16#61#           =>  --  1F61
          ((16#0000#, 16#1F69#, 16#1F69#, 16#0000#),
           ((0, 0), (1390, 1390), (1390, 1390), (0, 0)), 0, 0),
         16#62#           =>  --  1F62
          ((16#0000#, 16#1F6A#, 16#1F6A#, 16#0000#),
           ((0, 0), (1391, 1391), (1391, 1391), (0, 0)), 0, 0),
         16#63#           =>  --  1F63
          ((16#0000#, 16#1F6B#, 16#1F6B#, 16#0000#),
           ((0, 0), (1392, 1392), (1392, 1392), (0, 0)), 0, 0),
         16#64#           =>  --  1F64
          ((16#0000#, 16#1F6C#, 16#1F6C#, 16#0000#),
           ((0, 0), (1393, 1393), (1393, 1393), (0, 0)), 0, 0),
         16#65#           =>  --  1F65
          ((16#0000#, 16#1F6D#, 16#1F6D#, 16#0000#),
           ((0, 0), (1394, 1394), (1394, 1394), (0, 0)), 0, 0),
         16#66#           =>  --  1F66
          ((16#0000#, 16#1F6E#, 16#1F6E#, 16#0000#),
           ((0, 0), (1395, 1395), (1395, 1395), (0, 0)), 0, 0),
         16#67#           =>  --  1F67
          ((16#0000#, 16#1F6F#, 16#1F6F#, 16#0000#),
           ((0, 0), (1396, 1396), (1396, 1396), (0, 0)), 0, 0),
         16#68#           =>  --  1F68
          ((16#1F60#, 16#0000#, 16#0000#, 16#1F60#),
           ((1397, 1397), (0, 0), (0, 0), (1397, 1397)), 0, 0),
         16#69#           =>  --  1F69
          ((16#1F61#, 16#0000#, 16#0000#, 16#1F61#),
           ((1398, 1398), (0, 0), (0, 0), (1398, 1398)), 0, 0),
         16#6A#           =>  --  1F6A
          ((16#1F62#, 16#0000#, 16#0000#, 16#1F62#),
           ((1399, 1399), (0, 0), (0, 0), (1399, 1399)), 0, 0),
         16#6B#           =>  --  1F6B
          ((16#1F63#, 16#0000#, 16#0000#, 16#1F63#),
           ((1400, 1400), (0, 0), (0, 0), (1400, 1400)), 0, 0),
         16#6C#           =>  --  1F6C
          ((16#1F64#, 16#0000#, 16#0000#, 16#1F64#),
           ((1401, 1401), (0, 0), (0, 0), (1401, 1401)), 0, 0),
         16#6D#           =>  --  1F6D
          ((16#1F65#, 16#0000#, 16#0000#, 16#1F65#),
           ((1402, 1402), (0, 0), (0, 0), (1402, 1402)), 0, 0),
         16#6E#           =>  --  1F6E
          ((16#1F66#, 16#0000#, 16#0000#, 16#1F66#),
           ((1403, 1403), (0, 0), (0, 0), (1403, 1403)), 0, 0),
         16#6F#           =>  --  1F6F
          ((16#1F67#, 16#0000#, 16#0000#, 16#1F67#),
           ((1404, 1404), (0, 0), (0, 0), (1404, 1404)), 0, 0),
         16#70#           =>  --  1F70
          ((16#0000#, 16#1FBA#, 16#1FBA#, 16#0000#),
           ((0, 0), (1405, 1405), (1405, 1405), (0, 0)), 0, 0),
         16#71#           =>  --  1F71
          ((16#0000#, 16#1FBB#, 16#1FBB#, 16#0000#),
           ((0, 0), (1406, 1406), (1406, 1406), (0, 0)), 0, 0),
         16#72#           =>  --  1F72
          ((16#0000#, 16#1FC8#, 16#1FC8#, 16#0000#),
           ((0, 0), (1407, 1407), (1407, 1407), (0, 0)), 0, 0),
         16#73#           =>  --  1F73
          ((16#0000#, 16#1FC9#, 16#1FC9#, 16#0000#),
           ((0, 0), (1408, 1408), (1408, 1408), (0, 0)), 0, 0),
         16#74#           =>  --  1F74
          ((16#0000#, 16#1FCA#, 16#1FCA#, 16#0000#),
           ((0, 0), (1409, 1409), (1409, 1409), (0, 0)), 0, 0),
         16#75#           =>  --  1F75
          ((16#0000#, 16#1FCB#, 16#1FCB#, 16#0000#),
           ((0, 0), (1410, 1410), (1410, 1410), (0, 0)), 0, 0),
         16#76#           =>  --  1F76
          ((16#0000#, 16#1FDA#, 16#1FDA#, 16#0000#),
           ((0, 0), (1411, 1411), (1411, 1411), (0, 0)), 0, 0),
         16#77#           =>  --  1F77
          ((16#0000#, 16#1FDB#, 16#1FDB#, 16#0000#),
           ((0, 0), (1412, 1412), (1412, 1412), (0, 0)), 0, 0),
         16#78#           =>  --  1F78
          ((16#0000#, 16#1FF8#, 16#1FF8#, 16#0000#),
           ((0, 0), (1413, 1413), (1413, 1413), (0, 0)), 0, 0),
         16#79#           =>  --  1F79
          ((16#0000#, 16#1FF9#, 16#1FF9#, 16#0000#),
           ((0, 0), (1414, 1414), (1414, 1414), (0, 0)), 0, 0),
         16#7A#           =>  --  1F7A
          ((16#0000#, 16#1FEA#, 16#1FEA#, 16#0000#),
           ((0, 0), (1415, 1415), (1415, 1415), (0, 0)), 0, 0),
         16#7B#           =>  --  1F7B
          ((16#0000#, 16#1FEB#, 16#1FEB#, 16#0000#),
           ((0, 0), (1416, 1416), (1416, 1416), (0, 0)), 0, 0),
         16#7C#           =>  --  1F7C
          ((16#0000#, 16#1FFA#, 16#1FFA#, 16#0000#),
           ((0, 0), (1417, 1417), (1417, 1417), (0, 0)), 0, 0),
         16#7D#           =>  --  1F7D
          ((16#0000#, 16#1FFB#, 16#1FFB#, 16#0000#),
           ((0, 0), (1418, 1418), (1418, 1418), (0, 0)), 0, 0),
         16#80#           =>  --  1F80
          ((16#0000#, 16#1F88#, 16#1F88#, 16#0000#),
           ((0, 0), (1419, 1419), (1420, 1421), (1422, 1423)), 0, 0),
         16#81#           =>  --  1F81
          ((16#0000#, 16#1F89#, 16#1F89#, 16#0000#),
           ((0, 0), (1424, 1424), (1425, 1426), (1427, 1428)), 0, 0),
         16#82#           =>  --  1F82
          ((16#0000#, 16#1F8A#, 16#1F8A#, 16#0000#),
           ((0, 0), (1429, 1429), (1430, 1431), (1432, 1433)), 0, 0),
         16#83#           =>  --  1F83
          ((16#0000#, 16#1F8B#, 16#1F8B#, 16#0000#),
           ((0, 0), (1434, 1434), (1435, 1436), (1437, 1438)), 0, 0),
         16#84#           =>  --  1F84
          ((16#0000#, 16#1F8C#, 16#1F8C#, 16#0000#),
           ((0, 0), (1439, 1439), (1440, 1441), (1442, 1443)), 0, 0),
         16#85#           =>  --  1F85
          ((16#0000#, 16#1F8D#, 16#1F8D#, 16#0000#),
           ((0, 0), (1444, 1444), (1445, 1446), (1447, 1448)), 0, 0),
         16#86#           =>  --  1F86
          ((16#0000#, 16#1F8E#, 16#1F8E#, 16#0000#),
           ((0, 0), (1449, 1449), (1450, 1451), (1452, 1453)), 0, 0),
         16#87#           =>  --  1F87
          ((16#0000#, 16#1F8F#, 16#1F8F#, 16#0000#),
           ((0, 0), (1454, 1454), (1455, 1456), (1457, 1458)), 0, 0),
         16#88#           =>  --  1F88
          ((16#1F80#, 16#0000#, 16#0000#, 16#1F80#),
           ((1459, 1459), (0, 0), (1420, 1421), (1422, 1423)), 0, 0),
         16#89#           =>  --  1F89
          ((16#1F81#, 16#0000#, 16#0000#, 16#1F81#),
           ((1460, 1460), (0, 0), (1425, 1426), (1427, 1428)), 0, 0),
         16#8A#           =>  --  1F8A
          ((16#1F82#, 16#0000#, 16#0000#, 16#1F82#),
           ((1461, 1461), (0, 0), (1430, 1431), (1432, 1433)), 0, 0),
         16#8B#           =>  --  1F8B
          ((16#1F83#, 16#0000#, 16#0000#, 16#1F83#),
           ((1462, 1462), (0, 0), (1435, 1436), (1437, 1438)), 0, 0),
         16#8C#           =>  --  1F8C
          ((16#1F84#, 16#0000#, 16#0000#, 16#1F84#),
           ((1463, 1463), (0, 0), (1440, 1441), (1442, 1443)), 0, 0),
         16#8D#           =>  --  1F8D
          ((16#1F85#, 16#0000#, 16#0000#, 16#1F85#),
           ((1464, 1464), (0, 0), (1445, 1446), (1447, 1448)), 0, 0),
         16#8E#           =>  --  1F8E
          ((16#1F86#, 16#0000#, 16#0000#, 16#1F86#),
           ((1465, 1465), (0, 0), (1450, 1451), (1452, 1453)), 0, 0),
         16#8F#           =>  --  1F8F
          ((16#1F87#, 16#0000#, 16#0000#, 16#1F87#),
           ((1466, 1466), (0, 0), (1455, 1456), (1457, 1458)), 0, 0),
         16#90#           =>  --  1F90
          ((16#0000#, 16#1F98#, 16#1F98#, 16#0000#),
           ((0, 0), (1467, 1467), (1468, 1469), (1470, 1471)), 0, 0),
         16#91#           =>  --  1F91
          ((16#0000#, 16#1F99#, 16#1F99#, 16#0000#),
           ((0, 0), (1472, 1472), (1473, 1474), (1475, 1476)), 0, 0),
         16#92#           =>  --  1F92
          ((16#0000#, 16#1F9A#, 16#1F9A#, 16#0000#),
           ((0, 0), (1477, 1477), (1478, 1479), (1480, 1481)), 0, 0),
         16#93#           =>  --  1F93
          ((16#0000#, 16#1F9B#, 16#1F9B#, 16#0000#),
           ((0, 0), (1482, 1482), (1483, 1484), (1485, 1486)), 0, 0),
         16#94#           =>  --  1F94
          ((16#0000#, 16#1F9C#, 16#1F9C#, 16#0000#),
           ((0, 0), (1487, 1487), (1488, 1489), (1490, 1491)), 0, 0),
         16#95#           =>  --  1F95
          ((16#0000#, 16#1F9D#, 16#1F9D#, 16#0000#),
           ((0, 0), (1492, 1492), (1493, 1494), (1495, 1496)), 0, 0),
         16#96#           =>  --  1F96
          ((16#0000#, 16#1F9E#, 16#1F9E#, 16#0000#),
           ((0, 0), (1497, 1497), (1498, 1499), (1500, 1501)), 0, 0),
         16#97#           =>  --  1F97
          ((16#0000#, 16#1F9F#, 16#1F9F#, 16#0000#),
           ((0, 0), (1502, 1502), (1503, 1504), (1505, 1506)), 0, 0),
         16#98#           =>  --  1F98
          ((16#1F90#, 16#0000#, 16#0000#, 16#1F90#),
           ((1507, 1507), (0, 0), (1468, 1469), (1470, 1471)), 0, 0),
         16#99#           =>  --  1F99
          ((16#1F91#, 16#0000#, 16#0000#, 16#1F91#),
           ((1508, 1508), (0, 0), (1473, 1474), (1475, 1476)), 0, 0),
         16#9A#           =>  --  1F9A
          ((16#1F92#, 16#0000#, 16#0000#, 16#1F92#),
           ((1509, 1509), (0, 0), (1478, 1479), (1480, 1481)), 0, 0),
         16#9B#           =>  --  1F9B
          ((16#1F93#, 16#0000#, 16#0000#, 16#1F93#),
           ((1510, 1510), (0, 0), (1483, 1484), (1485, 1486)), 0, 0),
         16#9C#           =>  --  1F9C
          ((16#1F94#, 16#0000#, 16#0000#, 16#1F94#),
           ((1511, 1511), (0, 0), (1488, 1489), (1490, 1491)), 0, 0),
         16#9D#           =>  --  1F9D
          ((16#1F95#, 16#0000#, 16#0000#, 16#1F95#),
           ((1512, 1512), (0, 0), (1493, 1494), (1495, 1496)), 0, 0),
         16#9E#           =>  --  1F9E
          ((16#1F96#, 16#0000#, 16#0000#, 16#1F96#),
           ((1513, 1513), (0, 0), (1498, 1499), (1500, 1501)), 0, 0),
         16#9F#           =>  --  1F9F
          ((16#1F97#, 16#0000#, 16#0000#, 16#1F97#),
           ((1514, 1514), (0, 0), (1503, 1504), (1505, 1506)), 0, 0),
         16#A0#           =>  --  1FA0
          ((16#0000#, 16#1FA8#, 16#1FA8#, 16#0000#),
           ((0, 0), (1515, 1515), (1516, 1517), (1518, 1519)), 0, 0),
         16#A1#           =>  --  1FA1
          ((16#0000#, 16#1FA9#, 16#1FA9#, 16#0000#),
           ((0, 0), (1520, 1520), (1521, 1522), (1523, 1524)), 0, 0),
         16#A2#           =>  --  1FA2
          ((16#0000#, 16#1FAA#, 16#1FAA#, 16#0000#),
           ((0, 0), (1525, 1525), (1526, 1527), (1528, 1529)), 0, 0),
         16#A3#           =>  --  1FA3
          ((16#0000#, 16#1FAB#, 16#1FAB#, 16#0000#),
           ((0, 0), (1530, 1530), (1531, 1532), (1533, 1534)), 0, 0),
         16#A4#           =>  --  1FA4
          ((16#0000#, 16#1FAC#, 16#1FAC#, 16#0000#),
           ((0, 0), (1535, 1535), (1536, 1537), (1538, 1539)), 0, 0),
         16#A5#           =>  --  1FA5
          ((16#0000#, 16#1FAD#, 16#1FAD#, 16#0000#),
           ((0, 0), (1540, 1540), (1541, 1542), (1543, 1544)), 0, 0),
         16#A6#           =>  --  1FA6
          ((16#0000#, 16#1FAE#, 16#1FAE#, 16#0000#),
           ((0, 0), (1545, 1545), (1546, 1547), (1548, 1549)), 0, 0),
         16#A7#           =>  --  1FA7
          ((16#0000#, 16#1FAF#, 16#1FAF#, 16#0000#),
           ((0, 0), (1550, 1550), (1551, 1552), (1553, 1554)), 0, 0),
         16#A8#           =>  --  1FA8
          ((16#1FA0#, 16#0000#, 16#0000#, 16#1FA0#),
           ((1555, 1555), (0, 0), (1516, 1517), (1518, 1519)), 0, 0),
         16#A9#           =>  --  1FA9
          ((16#1FA1#, 16#0000#, 16#0000#, 16#1FA1#),
           ((1556, 1556), (0, 0), (1521, 1522), (1523, 1524)), 0, 0),
         16#AA#           =>  --  1FAA
          ((16#1FA2#, 16#0000#, 16#0000#, 16#1FA2#),
           ((1557, 1557), (0, 0), (1526, 1527), (1528, 1529)), 0, 0),
         16#AB#           =>  --  1FAB
          ((16#1FA3#, 16#0000#, 16#0000#, 16#1FA3#),
           ((1558, 1558), (0, 0), (1531, 1532), (1533, 1534)), 0, 0),
         16#AC#           =>  --  1FAC
          ((16#1FA4#, 16#0000#, 16#0000#, 16#1FA4#),
           ((1559, 1559), (0, 0), (1536, 1537), (1538, 1539)), 0, 0),
         16#AD#           =>  --  1FAD
          ((16#1FA5#, 16#0000#, 16#0000#, 16#1FA5#),
           ((1560, 1560), (0, 0), (1541, 1542), (1543, 1544)), 0, 0),
         16#AE#           =>  --  1FAE
          ((16#1FA6#, 16#0000#, 16#0000#, 16#1FA6#),
           ((1561, 1561), (0, 0), (1546, 1547), (1548, 1549)), 0, 0),
         16#AF#           =>  --  1FAF
          ((16#1FA7#, 16#0000#, 16#0000#, 16#1FA7#),
           ((1562, 1562), (0, 0), (1551, 1552), (1553, 1554)), 0, 0),
         16#B0#           =>  --  1FB0
          ((16#0000#, 16#1FB8#, 16#1FB8#, 16#0000#),
           ((0, 0), (1563, 1563), (1563, 1563), (0, 0)), 0, 0),
         16#B1#           =>  --  1FB1
          ((16#0000#, 16#1FB9#, 16#1FB9#, 16#0000#),
           ((0, 0), (1564, 1564), (1564, 1564), (0, 0)), 0, 0),
         16#B2#           =>  --  1FB2
          ((16#0000#, 16#0000#, 16#0000#, 16#0000#),
           ((0, 0), (1565, 1566), (1567, 1568), (1569, 1570)), 0, 0),
         16#B3#           =>  --  1FB3
          ((16#0000#, 16#1FBC#, 16#1FBC#, 16#0000#),
           ((0, 0), (1571, 1571), (1572, 1573), (1574, 1575)), 0, 0),
         16#B4#           =>  --  1FB4
          ((16#0000#, 16#0000#, 16#0000#, 16#0000#),
           ((0, 0), (1576, 1577), (1578, 1579), (1580, 1581)), 0, 0),
         16#B6#           =>  --  1FB6
          ((16#0000#, 16#0000#, 16#0000#, 16#0000#),
           ((0, 0), (1582, 1583), (1582, 1583), (1584, 1585)), 0, 0),
         16#B7#           =>  --  1FB7
          ((16#0000#, 16#0000#, 16#0000#, 16#0000#),
           ((0, 0), (1586, 1588), (1589, 1591), (1592, 1594)), 0, 0),
         16#B8#           =>  --  1FB8
          ((16#1FB0#, 16#0000#, 16#0000#, 16#1FB0#),
           ((1595, 1595), (0, 0), (0, 0), (1595, 1595)), 0, 0),
         16#B9#           =>  --  1FB9
          ((16#1FB1#, 16#0000#, 16#0000#, 16#1FB1#),
           ((1596, 1596), (0, 0), (0, 0), (1596, 1596)), 0, 0),
         16#BA#           =>  --  1FBA
          ((16#1F70#, 16#0000#, 16#0000#, 16#1F70#),
           ((1569, 1569), (0, 0), (0, 0), (1569, 1569)), 0, 0),
         16#BB#           =>  --  1FBB
          ((16#1F71#, 16#0000#, 16#0000#, 16#1F71#),
           ((1597, 1597), (0, 0), (0, 0), (1597, 1597)), 0, 0),
         16#BC#           =>  --  1FBC
          ((16#1FB3#, 16#0000#, 16#0000#, 16#1FB3#),
           ((1598, 1598), (0, 0), (1572, 1573), (1574, 1575)), 0, 0),
         16#BE#           =>  --  1FBE
          ((16#0000#, 16#0399#, 16#0399#, 16#03B9#),
           ((0, 0), (478, 478), (478, 478), (479, 479)), 0, 0),
         16#C2#           =>  --  1FC2
          ((16#0000#, 16#0000#, 16#0000#, 16#0000#),
           ((0, 0), (1599, 1600), (1601, 1602), (1603, 1604)), 0, 0),
         16#C3#           =>  --  1FC3
          ((16#0000#, 16#1FCC#, 16#1FCC#, 16#0000#),
           ((0, 0), (1605, 1605), (1606, 1607), (1608, 1609)), 0, 0),
         16#C4#           =>  --  1FC4
          ((16#0000#, 16#0000#, 16#0000#, 16#0000#),
           ((0, 0), (1610, 1611), (1612, 1613), (1614, 1615)), 0, 0),
         16#C6#           =>  --  1FC6
          ((16#0000#, 16#0000#, 16#0000#, 16#0000#),
           ((0, 0), (1616, 1617), (1616, 1617), (1618, 1619)), 0, 0),
         16#C7#           =>  --  1FC7
          ((16#0000#, 16#0000#, 16#0000#, 16#0000#),
           ((0, 0), (1620, 1622), (1623, 1625), (1626, 1628)), 0, 0),
         16#C8#           =>  --  1FC8
          ((16#1F72#, 16#0000#, 16#0000#, 16#1F72#),
           ((1629, 1629), (0, 0), (0, 0), (1629, 1629)), 0, 0),
         16#C9#           =>  --  1FC9
          ((16#1F73#, 16#0000#, 16#0000#, 16#1F73#),
           ((1630, 1630), (0, 0), (0, 0), (1630, 1630)), 0, 0),
         16#CA#           =>  --  1FCA
          ((16#1F74#, 16#0000#, 16#0000#, 16#1F74#),
           ((1603, 1603), (0, 0), (0, 0), (1603, 1603)), 0, 0),
         16#CB#           =>  --  1FCB
          ((16#1F75#, 16#0000#, 16#0000#, 16#1F75#),
           ((1631, 1631), (0, 0), (0, 0), (1631, 1631)), 0, 0),
         16#CC#           =>  --  1FCC
          ((16#1FC3#, 16#0000#, 16#0000#, 16#1FC3#),
           ((1632, 1632), (0, 0), (1606, 1607), (1608, 1609)), 0, 0),
         16#D0#           =>  --  1FD0
          ((16#0000#, 16#1FD8#, 16#1FD8#, 16#0000#),
           ((0, 0), (1633, 1633), (1633, 1633), (0, 0)), 0, 0),
         16#D1#           =>  --  1FD1
          ((16#0000#, 16#1FD9#, 16#1FD9#, 16#0000#),
           ((0, 0), (1634, 1634), (1634, 1634), (0, 0)), 0, 0),
         16#D2#           =>  --  1FD2
          ((16#0000#, 16#0000#, 16#0000#, 16#0000#),
           ((0, 0), (1635, 1637), (1635, 1637), (1638, 1640)), 0, 0),
         16#D3#           =>  --  1FD3
          ((16#0000#, 16#0000#, 16#0000#, 16#0000#),
           ((0, 0), (497, 499), (497, 499), (500, 502)), 0, 0),
         16#D6#           =>  --  1FD6
          ((16#0000#, 16#0000#, 16#0000#, 16#0000#),
           ((0, 0), (1641, 1642), (1641, 1642), (1643, 1644)), 0, 0),
         16#D7#           =>  --  1FD7
          ((16#0000#, 16#0000#, 16#0000#, 16#0000#),
           ((0, 0), (1645, 1647), (1645, 1647), (1648, 1650)), 0, 0),
         16#D8#           =>  --  1FD8
          ((16#1FD0#, 16#0000#, 16#0000#, 16#1FD0#),
           ((1651, 1651), (0, 0), (0, 0), (1651, 1651)), 0, 0),
         16#D9#           =>  --  1FD9
          ((16#1FD1#, 16#0000#, 16#0000#, 16#1FD1#),
           ((1652, 1652), (0, 0), (0, 0), (1652, 1652)), 0, 0),
         16#DA#           =>  --  1FDA
          ((16#1F76#, 16#0000#, 16#0000#, 16#1F76#),
           ((1653, 1653), (0, 0), (0, 0), (1653, 1653)), 0, 0),
         16#DB#           =>  --  1FDB
          ((16#1F77#, 16#0000#, 16#0000#, 16#1F77#),
           ((1654, 1654), (0, 0), (0, 0), (1654, 1654)), 0, 0),
         16#E0#           =>  --  1FE0
          ((16#0000#, 16#1FE8#, 16#1FE8#, 16#0000#),
           ((0, 0), (1655, 1655), (1655, 1655), (0, 0)), 0, 0),
         16#E1#           =>  --  1FE1
          ((16#0000#, 16#1FE9#, 16#1FE9#, 16#0000#),
           ((0, 0), (1656, 1656), (1656, 1656), (0, 0)), 0, 0),
         16#E2#           =>  --  1FE2
          ((16#0000#, 16#0000#, 16#0000#, 16#0000#),
           ((0, 0), (1657, 1659), (1657, 1659), (1660, 1662)), 0, 0),
         16#E3#           =>  --  1FE3
          ((16#0000#, 16#0000#, 16#0000#, 16#0000#),
           ((0, 0), (532, 534), (532, 534), (535, 537)), 0, 0),
         16#E4#           =>  --  1FE4
          ((16#0000#, 16#0000#, 16#0000#, 16#0000#),
           ((0, 0), (1663, 1664), (1663, 1664), (1665, 1666)), 0, 0),
         16#E5#           =>  --  1FE5
          ((16#0000#, 16#1FEC#, 16#1FEC#, 16#0000#),
           ((0, 0), (1667, 1667), (1667, 1667), (0, 0)), 0, 0),
         16#E6#           =>  --  1FE6
          ((16#0000#, 16#0000#, 16#0000#, 16#0000#),
           ((0, 0), (1668, 1669), (1668, 1669), (1670, 1671)), 0, 0),
         16#E7#           =>  --  1FE7
          ((16#0000#, 16#0000#, 16#0000#, 16#0000#),
           ((0, 0), (1672, 1674), (1672, 1674), (1675, 1677)), 0, 0),
         16#E8#           =>  --  1FE8
          ((16#1FE0#, 16#0000#, 16#0000#, 16#1FE0#),
           ((1678, 1678), (0, 0), (0, 0), (1678, 1678)), 0, 0),
         16#E9#           =>  --  1FE9
          ((16#1FE1#, 16#0000#, 16#0000#, 16#1FE1#),
           ((1679, 1679), (0, 0), (0, 0), (1679, 1679)), 0, 0),
         16#EA#           =>  --  1FEA
          ((16#1F7A#, 16#0000#, 16#0000#, 16#1F7A#),
           ((1680, 1680), (0, 0), (0, 0), (1680, 1680)), 0, 0),
         16#EB#           =>  --  1FEB
          ((16#1F7B#, 16#0000#, 16#0000#, 16#1F7B#),
           ((1681, 1681), (0, 0), (0, 0), (1681, 1681)), 0, 0),
         16#EC#           =>  --  1FEC
          ((16#1FE5#, 16#0000#, 16#0000#, 16#1FE5#),
           ((1682, 1682), (0, 0), (0, 0), (1682, 1682)), 0, 0),
         16#F2#           =>  --  1FF2
          ((16#0000#, 16#0000#, 16#0000#, 16#0000#),
           ((0, 0), (1683, 1684), (1685, 1686), (1687, 1688)), 0, 0),
         16#F3#           =>  --  1FF3
          ((16#0000#, 16#1FFC#, 16#1FFC#, 16#0000#),
           ((0, 0), (1689, 1689), (1690, 1691), (1692, 1693)), 0, 0),
         16#F4#           =>  --  1FF4
          ((16#0000#, 16#0000#, 16#0000#, 16#0000#),
           ((0, 0), (1694, 1695), (1696, 1697), (1698, 1699)), 0, 0),
         16#F6#           =>  --  1FF6
          ((16#0000#, 16#0000#, 16#0000#, 16#0000#),
           ((0, 0), (1700, 1701), (1700, 1701), (1702, 1703)), 0, 0),
         16#F7#           =>  --  1FF7
          ((16#0000#, 16#0000#, 16#0000#, 16#0000#),
           ((0, 0), (1704, 1706), (1707, 1709), (1710, 1712)), 0, 0),
         16#F8#           =>  --  1FF8
          ((16#1F78#, 16#0000#, 16#0000#, 16#1F78#),
           ((1713, 1713), (0, 0), (0, 0), (1713, 1713)), 0, 0),
         16#F9#           =>  --  1FF9
          ((16#1F79#, 16#0000#, 16#0000#, 16#1F79#),
           ((1714, 1714), (0, 0), (0, 0), (1714, 1714)), 0, 0),
         16#FA#           =>  --  1FFA
          ((16#1F7C#, 16#0000#, 16#0000#, 16#1F7C#),
           ((1687, 1687), (0, 0), (0, 0), (1687, 1687)), 0, 0),
         16#FB#           =>  --  1FFB
          ((16#1F7D#, 16#0000#, 16#0000#, 16#1F7D#),
           ((1715, 1715), (0, 0), (0, 0), (1715, 1715)), 0, 0),
         16#FC#           =>  --  1FFC
          ((16#1FF3#, 16#0000#, 16#0000#, 16#1FF3#),
           ((1716, 1716), (0, 0), (1690, 1691), (1692, 1693)), 0, 0),
         others           =>
          ((16#0000#, 16#0000#, 16#0000#, 16#0000#),
           ((0, 0), (0, 0), (0, 0), (0, 0)), 0, 0));

   Group_0021 : aliased constant Case_Mapping_Second_Stage
     := (16#26#           =>  --  2126
          ((16#03C9#, 16#0000#, 16#0000#, 16#03C9#),
           ((525, 525), (0, 0), (0, 0), (525, 525)), 0, 0),
         16#2A#           =>  --  212A
          ((16#006B#, 16#0000#, 16#0000#, 16#006B#),
           ((11, 11), (0, 0), (0, 0), (11, 11)), 0, 0),
         16#2B#           =>  --  212B
          ((16#00E5#, 16#0000#, 16#0000#, 16#00E5#),
           ((60, 60), (0, 0), (0, 0), (60, 60)), 0, 0),
         16#32#           =>  --  2132
          ((16#214E#, 16#0000#, 16#0000#, 16#214E#),
           ((1717, 1717), (0, 0), (0, 0), (1717, 1717)), 0, 0),
         16#4E#           =>  --  214E
          ((16#0000#, 16#2132#, 16#2132#, 16#0000#),
           ((0, 0), (1718, 1718), (1718, 1718), (0, 0)), 0, 0),
         16#60#           =>  --  2160
          ((16#2170#, 16#0000#, 16#0000#, 16#2170#),
           ((1719, 1719), (0, 0), (0, 0), (1719, 1719)), 0, 0),
         16#61#           =>  --  2161
          ((16#2171#, 16#0000#, 16#0000#, 16#2171#),
           ((1720, 1720), (0, 0), (0, 0), (1720, 1720)), 0, 0),
         16#62#           =>  --  2162
          ((16#2172#, 16#0000#, 16#0000#, 16#2172#),
           ((1721, 1721), (0, 0), (0, 0), (1721, 1721)), 0, 0),
         16#63#           =>  --  2163
          ((16#2173#, 16#0000#, 16#0000#, 16#2173#),
           ((1722, 1722), (0, 0), (0, 0), (1722, 1722)), 0, 0),
         16#64#           =>  --  2164
          ((16#2174#, 16#0000#, 16#0000#, 16#2174#),
           ((1723, 1723), (0, 0), (0, 0), (1723, 1723)), 0, 0),
         16#65#           =>  --  2165
          ((16#2175#, 16#0000#, 16#0000#, 16#2175#),
           ((1724, 1724), (0, 0), (0, 0), (1724, 1724)), 0, 0),
         16#66#           =>  --  2166
          ((16#2176#, 16#0000#, 16#0000#, 16#2176#),
           ((1725, 1725), (0, 0), (0, 0), (1725, 1725)), 0, 0),
         16#67#           =>  --  2167
          ((16#2177#, 16#0000#, 16#0000#, 16#2177#),
           ((1726, 1726), (0, 0), (0, 0), (1726, 1726)), 0, 0),
         16#68#           =>  --  2168
          ((16#2178#, 16#0000#, 16#0000#, 16#2178#),
           ((1727, 1727), (0, 0), (0, 0), (1727, 1727)), 0, 0),
         16#69#           =>  --  2169
          ((16#2179#, 16#0000#, 16#0000#, 16#2179#),
           ((1728, 1728), (0, 0), (0, 0), (1728, 1728)), 0, 0),
         16#6A#           =>  --  216A
          ((16#217A#, 16#0000#, 16#0000#, 16#217A#),
           ((1729, 1729), (0, 0), (0, 0), (1729, 1729)), 0, 0),
         16#6B#           =>  --  216B
          ((16#217B#, 16#0000#, 16#0000#, 16#217B#),
           ((1730, 1730), (0, 0), (0, 0), (1730, 1730)), 0, 0),
         16#6C#           =>  --  216C
          ((16#217C#, 16#0000#, 16#0000#, 16#217C#),
           ((1731, 1731), (0, 0), (0, 0), (1731, 1731)), 0, 0),
         16#6D#           =>  --  216D
          ((16#217D#, 16#0000#, 16#0000#, 16#217D#),
           ((1732, 1732), (0, 0), (0, 0), (1732, 1732)), 0, 0),
         16#6E#           =>  --  216E
          ((16#217E#, 16#0000#, 16#0000#, 16#217E#),
           ((1733, 1733), (0, 0), (0, 0), (1733, 1733)), 0, 0),
         16#6F#           =>  --  216F
          ((16#217F#, 16#0000#, 16#0000#, 16#217F#),
           ((1734, 1734), (0, 0), (0, 0), (1734, 1734)), 0, 0),
         16#70#           =>  --  2170
          ((16#0000#, 16#2160#, 16#2160#, 16#0000#),
           ((0, 0), (1735, 1735), (1735, 1735), (0, 0)), 0, 0),
         16#71#           =>  --  2171
          ((16#0000#, 16#2161#, 16#2161#, 16#0000#),
           ((0, 0), (1736, 1736), (1736, 1736), (0, 0)), 0, 0),
         16#72#           =>  --  2172
          ((16#0000#, 16#2162#, 16#2162#, 16#0000#),
           ((0, 0), (1737, 1737), (1737, 1737), (0, 0)), 0, 0),
         16#73#           =>  --  2173
          ((16#0000#, 16#2163#, 16#2163#, 16#0000#),
           ((0, 0), (1738, 1738), (1738, 1738), (0, 0)), 0, 0),
         16#74#           =>  --  2174
          ((16#0000#, 16#2164#, 16#2164#, 16#0000#),
           ((0, 0), (1739, 1739), (1739, 1739), (0, 0)), 0, 0),
         16#75#           =>  --  2175
          ((16#0000#, 16#2165#, 16#2165#, 16#0000#),
           ((0, 0), (1740, 1740), (1740, 1740), (0, 0)), 0, 0),
         16#76#           =>  --  2176
          ((16#0000#, 16#2166#, 16#2166#, 16#0000#),
           ((0, 0), (1741, 1741), (1741, 1741), (0, 0)), 0, 0),
         16#77#           =>  --  2177
          ((16#0000#, 16#2167#, 16#2167#, 16#0000#),
           ((0, 0), (1742, 1742), (1742, 1742), (0, 0)), 0, 0),
         16#78#           =>  --  2178
          ((16#0000#, 16#2168#, 16#2168#, 16#0000#),
           ((0, 0), (1743, 1743), (1743, 1743), (0, 0)), 0, 0),
         16#79#           =>  --  2179
          ((16#0000#, 16#2169#, 16#2169#, 16#0000#),
           ((0, 0), (1744, 1744), (1744, 1744), (0, 0)), 0, 0),
         16#7A#           =>  --  217A
          ((16#0000#, 16#216A#, 16#216A#, 16#0000#),
           ((0, 0), (1745, 1745), (1745, 1745), (0, 0)), 0, 0),
         16#7B#           =>  --  217B
          ((16#0000#, 16#216B#, 16#216B#, 16#0000#),
           ((0, 0), (1746, 1746), (1746, 1746), (0, 0)), 0, 0),
         16#7C#           =>  --  217C
          ((16#0000#, 16#216C#, 16#216C#, 16#0000#),
           ((0, 0), (1747, 1747), (1747, 1747), (0, 0)), 0, 0),
         16#7D#           =>  --  217D
          ((16#0000#, 16#216D#, 16#216D#, 16#0000#),
           ((0, 0), (1748, 1748), (1748, 1748), (0, 0)), 0, 0),
         16#7E#           =>  --  217E
          ((16#0000#, 16#216E#, 16#216E#, 16#0000#),
           ((0, 0), (1749, 1749), (1749, 1749), (0, 0)), 0, 0),
         16#7F#           =>  --  217F
          ((16#0000#, 16#216F#, 16#216F#, 16#0000#),
           ((0, 0), (1750, 1750), (1750, 1750), (0, 0)), 0, 0),
         16#83#           =>  --  2183
          ((16#2184#, 16#0000#, 16#0000#, 16#2184#),
           ((1751, 1751), (0, 0), (0, 0), (1751, 1751)), 0, 0),
         16#84#           =>  --  2184
          ((16#0000#, 16#2183#, 16#2183#, 16#0000#),
           ((0, 0), (1752, 1752), (1752, 1752), (0, 0)), 0, 0),
         others           =>
          ((16#0000#, 16#0000#, 16#0000#, 16#0000#),
           ((0, 0), (0, 0), (0, 0), (0, 0)), 0, 0));

   Group_0024 : aliased constant Case_Mapping_Second_Stage
     := (16#B6#           =>  --  24B6
          ((16#24D0#, 16#0000#, 16#0000#, 16#24D0#),
           ((1753, 1753), (0, 0), (0, 0), (1753, 1753)), 0, 0),
         16#B7#           =>  --  24B7
          ((16#24D1#, 16#0000#, 16#0000#, 16#24D1#),
           ((1754, 1754), (0, 0), (0, 0), (1754, 1754)), 0, 0),
         16#B8#           =>  --  24B8
          ((16#24D2#, 16#0000#, 16#0000#, 16#24D2#),
           ((1755, 1755), (0, 0), (0, 0), (1755, 1755)), 0, 0),
         16#B9#           =>  --  24B9
          ((16#24D3#, 16#0000#, 16#0000#, 16#24D3#),
           ((1756, 1756), (0, 0), (0, 0), (1756, 1756)), 0, 0),
         16#BA#           =>  --  24BA
          ((16#24D4#, 16#0000#, 16#0000#, 16#24D4#),
           ((1757, 1757), (0, 0), (0, 0), (1757, 1757)), 0, 0),
         16#BB#           =>  --  24BB
          ((16#24D5#, 16#0000#, 16#0000#, 16#24D5#),
           ((1758, 1758), (0, 0), (0, 0), (1758, 1758)), 0, 0),
         16#BC#           =>  --  24BC
          ((16#24D6#, 16#0000#, 16#0000#, 16#24D6#),
           ((1759, 1759), (0, 0), (0, 0), (1759, 1759)), 0, 0),
         16#BD#           =>  --  24BD
          ((16#24D7#, 16#0000#, 16#0000#, 16#24D7#),
           ((1760, 1760), (0, 0), (0, 0), (1760, 1760)), 0, 0),
         16#BE#           =>  --  24BE
          ((16#24D8#, 16#0000#, 16#0000#, 16#24D8#),
           ((1761, 1761), (0, 0), (0, 0), (1761, 1761)), 0, 0),
         16#BF#           =>  --  24BF
          ((16#24D9#, 16#0000#, 16#0000#, 16#24D9#),
           ((1762, 1762), (0, 0), (0, 0), (1762, 1762)), 0, 0),
         16#C0#           =>  --  24C0
          ((16#24DA#, 16#0000#, 16#0000#, 16#24DA#),
           ((1763, 1763), (0, 0), (0, 0), (1763, 1763)), 0, 0),
         16#C1#           =>  --  24C1
          ((16#24DB#, 16#0000#, 16#0000#, 16#24DB#),
           ((1764, 1764), (0, 0), (0, 0), (1764, 1764)), 0, 0),
         16#C2#           =>  --  24C2
          ((16#24DC#, 16#0000#, 16#0000#, 16#24DC#),
           ((1765, 1765), (0, 0), (0, 0), (1765, 1765)), 0, 0),
         16#C3#           =>  --  24C3
          ((16#24DD#, 16#0000#, 16#0000#, 16#24DD#),
           ((1766, 1766), (0, 0), (0, 0), (1766, 1766)), 0, 0),
         16#C4#           =>  --  24C4
          ((16#24DE#, 16#0000#, 16#0000#, 16#24DE#),
           ((1767, 1767), (0, 0), (0, 0), (1767, 1767)), 0, 0),
         16#C5#           =>  --  24C5
          ((16#24DF#, 16#0000#, 16#0000#, 16#24DF#),
           ((1768, 1768), (0, 0), (0, 0), (1768, 1768)), 0, 0),
         16#C6#           =>  --  24C6
          ((16#24E0#, 16#0000#, 16#0000#, 16#24E0#),
           ((1769, 1769), (0, 0), (0, 0), (1769, 1769)), 0, 0),
         16#C7#           =>  --  24C7
          ((16#24E1#, 16#0000#, 16#0000#, 16#24E1#),
           ((1770, 1770), (0, 0), (0, 0), (1770, 1770)), 0, 0),
         16#C8#           =>  --  24C8
          ((16#24E2#, 16#0000#, 16#0000#, 16#24E2#),
           ((1771, 1771), (0, 0), (0, 0), (1771, 1771)), 0, 0),
         16#C9#           =>  --  24C9
          ((16#24E3#, 16#0000#, 16#0000#, 16#24E3#),
           ((1772, 1772), (0, 0), (0, 0), (1772, 1772)), 0, 0),
         16#CA#           =>  --  24CA
          ((16#24E4#, 16#0000#, 16#0000#, 16#24E4#),
           ((1773, 1773), (0, 0), (0, 0), (1773, 1773)), 0, 0),
         16#CB#           =>  --  24CB
          ((16#24E5#, 16#0000#, 16#0000#, 16#24E5#),
           ((1774, 1774), (0, 0), (0, 0), (1774, 1774)), 0, 0),
         16#CC#           =>  --  24CC
          ((16#24E6#, 16#0000#, 16#0000#, 16#24E6#),
           ((1775, 1775), (0, 0), (0, 0), (1775, 1775)), 0, 0),
         16#CD#           =>  --  24CD
          ((16#24E7#, 16#0000#, 16#0000#, 16#24E7#),
           ((1776, 1776), (0, 0), (0, 0), (1776, 1776)), 0, 0),
         16#CE#           =>  --  24CE
          ((16#24E8#, 16#0000#, 16#0000#, 16#24E8#),
           ((1777, 1777), (0, 0), (0, 0), (1777, 1777)), 0, 0),
         16#CF#           =>  --  24CF
          ((16#24E9#, 16#0000#, 16#0000#, 16#24E9#),
           ((1778, 1778), (0, 0), (0, 0), (1778, 1778)), 0, 0),
         16#D0#           =>  --  24D0
          ((16#0000#, 16#24B6#, 16#24B6#, 16#0000#),
           ((0, 0), (1779, 1779), (1779, 1779), (0, 0)), 0, 0),
         16#D1#           =>  --  24D1
          ((16#0000#, 16#24B7#, 16#24B7#, 16#0000#),
           ((0, 0), (1780, 1780), (1780, 1780), (0, 0)), 0, 0),
         16#D2#           =>  --  24D2
          ((16#0000#, 16#24B8#, 16#24B8#, 16#0000#),
           ((0, 0), (1781, 1781), (1781, 1781), (0, 0)), 0, 0),
         16#D3#           =>  --  24D3
          ((16#0000#, 16#24B9#, 16#24B9#, 16#0000#),
           ((0, 0), (1782, 1782), (1782, 1782), (0, 0)), 0, 0),
         16#D4#           =>  --  24D4
          ((16#0000#, 16#24BA#, 16#24BA#, 16#0000#),
           ((0, 0), (1783, 1783), (1783, 1783), (0, 0)), 0, 0),
         16#D5#           =>  --  24D5
          ((16#0000#, 16#24BB#, 16#24BB#, 16#0000#),
           ((0, 0), (1784, 1784), (1784, 1784), (0, 0)), 0, 0),
         16#D6#           =>  --  24D6
          ((16#0000#, 16#24BC#, 16#24BC#, 16#0000#),
           ((0, 0), (1785, 1785), (1785, 1785), (0, 0)), 0, 0),
         16#D7#           =>  --  24D7
          ((16#0000#, 16#24BD#, 16#24BD#, 16#0000#),
           ((0, 0), (1786, 1786), (1786, 1786), (0, 0)), 0, 0),
         16#D8#           =>  --  24D8
          ((16#0000#, 16#24BE#, 16#24BE#, 16#0000#),
           ((0, 0), (1787, 1787), (1787, 1787), (0, 0)), 0, 0),
         16#D9#           =>  --  24D9
          ((16#0000#, 16#24BF#, 16#24BF#, 16#0000#),
           ((0, 0), (1788, 1788), (1788, 1788), (0, 0)), 0, 0),
         16#DA#           =>  --  24DA
          ((16#0000#, 16#24C0#, 16#24C0#, 16#0000#),
           ((0, 0), (1789, 1789), (1789, 1789), (0, 0)), 0, 0),
         16#DB#           =>  --  24DB
          ((16#0000#, 16#24C1#, 16#24C1#, 16#0000#),
           ((0, 0), (1790, 1790), (1790, 1790), (0, 0)), 0, 0),
         16#DC#           =>  --  24DC
          ((16#0000#, 16#24C2#, 16#24C2#, 16#0000#),
           ((0, 0), (1791, 1791), (1791, 1791), (0, 0)), 0, 0),
         16#DD#           =>  --  24DD
          ((16#0000#, 16#24C3#, 16#24C3#, 16#0000#),
           ((0, 0), (1792, 1792), (1792, 1792), (0, 0)), 0, 0),
         16#DE#           =>  --  24DE
          ((16#0000#, 16#24C4#, 16#24C4#, 16#0000#),
           ((0, 0), (1793, 1793), (1793, 1793), (0, 0)), 0, 0),
         16#DF#           =>  --  24DF
          ((16#0000#, 16#24C5#, 16#24C5#, 16#0000#),
           ((0, 0), (1794, 1794), (1794, 1794), (0, 0)), 0, 0),
         16#E0#           =>  --  24E0
          ((16#0000#, 16#24C6#, 16#24C6#, 16#0000#),
           ((0, 0), (1795, 1795), (1795, 1795), (0, 0)), 0, 0),
         16#E1#           =>  --  24E1
          ((16#0000#, 16#24C7#, 16#24C7#, 16#0000#),
           ((0, 0), (1796, 1796), (1796, 1796), (0, 0)), 0, 0),
         16#E2#           =>  --  24E2
          ((16#0000#, 16#24C8#, 16#24C8#, 16#0000#),
           ((0, 0), (1797, 1797), (1797, 1797), (0, 0)), 0, 0),
         16#E3#           =>  --  24E3
          ((16#0000#, 16#24C9#, 16#24C9#, 16#0000#),
           ((0, 0), (1798, 1798), (1798, 1798), (0, 0)), 0, 0),
         16#E4#           =>  --  24E4
          ((16#0000#, 16#24CA#, 16#24CA#, 16#0000#),
           ((0, 0), (1799, 1799), (1799, 1799), (0, 0)), 0, 0),
         16#E5#           =>  --  24E5
          ((16#0000#, 16#24CB#, 16#24CB#, 16#0000#),
           ((0, 0), (1800, 1800), (1800, 1800), (0, 0)), 0, 0),
         16#E6#           =>  --  24E6
          ((16#0000#, 16#24CC#, 16#24CC#, 16#0000#),
           ((0, 0), (1801, 1801), (1801, 1801), (0, 0)), 0, 0),
         16#E7#           =>  --  24E7
          ((16#0000#, 16#24CD#, 16#24CD#, 16#0000#),
           ((0, 0), (1802, 1802), (1802, 1802), (0, 0)), 0, 0),
         16#E8#           =>  --  24E8
          ((16#0000#, 16#24CE#, 16#24CE#, 16#0000#),
           ((0, 0), (1803, 1803), (1803, 1803), (0, 0)), 0, 0),
         16#E9#           =>  --  24E9
          ((16#0000#, 16#24CF#, 16#24CF#, 16#0000#),
           ((0, 0), (1804, 1804), (1804, 1804), (0, 0)), 0, 0),
         others           =>
          ((16#0000#, 16#0000#, 16#0000#, 16#0000#),
           ((0, 0), (0, 0), (0, 0), (0, 0)), 0, 0));

   Group_002C : aliased constant Case_Mapping_Second_Stage
     := (16#00#           =>  --  2C00
          ((16#2C30#, 16#0000#, 16#0000#, 16#2C30#),
           ((1805, 1805), (0, 0), (0, 0), (1805, 1805)), 0, 0),
         16#01#           =>  --  2C01
          ((16#2C31#, 16#0000#, 16#0000#, 16#2C31#),
           ((1806, 1806), (0, 0), (0, 0), (1806, 1806)), 0, 0),
         16#02#           =>  --  2C02
          ((16#2C32#, 16#0000#, 16#0000#, 16#2C32#),
           ((1807, 1807), (0, 0), (0, 0), (1807, 1807)), 0, 0),
         16#03#           =>  --  2C03
          ((16#2C33#, 16#0000#, 16#0000#, 16#2C33#),
           ((1808, 1808), (0, 0), (0, 0), (1808, 1808)), 0, 0),
         16#04#           =>  --  2C04
          ((16#2C34#, 16#0000#, 16#0000#, 16#2C34#),
           ((1809, 1809), (0, 0), (0, 0), (1809, 1809)), 0, 0),
         16#05#           =>  --  2C05
          ((16#2C35#, 16#0000#, 16#0000#, 16#2C35#),
           ((1810, 1810), (0, 0), (0, 0), (1810, 1810)), 0, 0),
         16#06#           =>  --  2C06
          ((16#2C36#, 16#0000#, 16#0000#, 16#2C36#),
           ((1811, 1811), (0, 0), (0, 0), (1811, 1811)), 0, 0),
         16#07#           =>  --  2C07
          ((16#2C37#, 16#0000#, 16#0000#, 16#2C37#),
           ((1812, 1812), (0, 0), (0, 0), (1812, 1812)), 0, 0),
         16#08#           =>  --  2C08
          ((16#2C38#, 16#0000#, 16#0000#, 16#2C38#),
           ((1813, 1813), (0, 0), (0, 0), (1813, 1813)), 0, 0),
         16#09#           =>  --  2C09
          ((16#2C39#, 16#0000#, 16#0000#, 16#2C39#),
           ((1814, 1814), (0, 0), (0, 0), (1814, 1814)), 0, 0),
         16#0A#           =>  --  2C0A
          ((16#2C3A#, 16#0000#, 16#0000#, 16#2C3A#),
           ((1815, 1815), (0, 0), (0, 0), (1815, 1815)), 0, 0),
         16#0B#           =>  --  2C0B
          ((16#2C3B#, 16#0000#, 16#0000#, 16#2C3B#),
           ((1816, 1816), (0, 0), (0, 0), (1816, 1816)), 0, 0),
         16#0C#           =>  --  2C0C
          ((16#2C3C#, 16#0000#, 16#0000#, 16#2C3C#),
           ((1817, 1817), (0, 0), (0, 0), (1817, 1817)), 0, 0),
         16#0D#           =>  --  2C0D
          ((16#2C3D#, 16#0000#, 16#0000#, 16#2C3D#),
           ((1818, 1818), (0, 0), (0, 0), (1818, 1818)), 0, 0),
         16#0E#           =>  --  2C0E
          ((16#2C3E#, 16#0000#, 16#0000#, 16#2C3E#),
           ((1819, 1819), (0, 0), (0, 0), (1819, 1819)), 0, 0),
         16#0F#           =>  --  2C0F
          ((16#2C3F#, 16#0000#, 16#0000#, 16#2C3F#),
           ((1820, 1820), (0, 0), (0, 0), (1820, 1820)), 0, 0),
         16#10#           =>  --  2C10
          ((16#2C40#, 16#0000#, 16#0000#, 16#2C40#),
           ((1821, 1821), (0, 0), (0, 0), (1821, 1821)), 0, 0),
         16#11#           =>  --  2C11
          ((16#2C41#, 16#0000#, 16#0000#, 16#2C41#),
           ((1822, 1822), (0, 0), (0, 0), (1822, 1822)), 0, 0),
         16#12#           =>  --  2C12
          ((16#2C42#, 16#0000#, 16#0000#, 16#2C42#),
           ((1823, 1823), (0, 0), (0, 0), (1823, 1823)), 0, 0),
         16#13#           =>  --  2C13
          ((16#2C43#, 16#0000#, 16#0000#, 16#2C43#),
           ((1824, 1824), (0, 0), (0, 0), (1824, 1824)), 0, 0),
         16#14#           =>  --  2C14
          ((16#2C44#, 16#0000#, 16#0000#, 16#2C44#),
           ((1825, 1825), (0, 0), (0, 0), (1825, 1825)), 0, 0),
         16#15#           =>  --  2C15
          ((16#2C45#, 16#0000#, 16#0000#, 16#2C45#),
           ((1826, 1826), (0, 0), (0, 0), (1826, 1826)), 0, 0),
         16#16#           =>  --  2C16
          ((16#2C46#, 16#0000#, 16#0000#, 16#2C46#),
           ((1827, 1827), (0, 0), (0, 0), (1827, 1827)), 0, 0),
         16#17#           =>  --  2C17
          ((16#2C47#, 16#0000#, 16#0000#, 16#2C47#),
           ((1828, 1828), (0, 0), (0, 0), (1828, 1828)), 0, 0),
         16#18#           =>  --  2C18
          ((16#2C48#, 16#0000#, 16#0000#, 16#2C48#),
           ((1829, 1829), (0, 0), (0, 0), (1829, 1829)), 0, 0),
         16#19#           =>  --  2C19
          ((16#2C49#, 16#0000#, 16#0000#, 16#2C49#),
           ((1830, 1830), (0, 0), (0, 0), (1830, 1830)), 0, 0),
         16#1A#           =>  --  2C1A
          ((16#2C4A#, 16#0000#, 16#0000#, 16#2C4A#),
           ((1831, 1831), (0, 0), (0, 0), (1831, 1831)), 0, 0),
         16#1B#           =>  --  2C1B
          ((16#2C4B#, 16#0000#, 16#0000#, 16#2C4B#),
           ((1832, 1832), (0, 0), (0, 0), (1832, 1832)), 0, 0),
         16#1C#           =>  --  2C1C
          ((16#2C4C#, 16#0000#, 16#0000#, 16#2C4C#),
           ((1833, 1833), (0, 0), (0, 0), (1833, 1833)), 0, 0),
         16#1D#           =>  --  2C1D
          ((16#2C4D#, 16#0000#, 16#0000#, 16#2C4D#),
           ((1834, 1834), (0, 0), (0, 0), (1834, 1834)), 0, 0),
         16#1E#           =>  --  2C1E
          ((16#2C4E#, 16#0000#, 16#0000#, 16#2C4E#),
           ((1835, 1835), (0, 0), (0, 0), (1835, 1835)), 0, 0),
         16#1F#           =>  --  2C1F
          ((16#2C4F#, 16#0000#, 16#0000#, 16#2C4F#),
           ((1836, 1836), (0, 0), (0, 0), (1836, 1836)), 0, 0),
         16#20#           =>  --  2C20
          ((16#2C50#, 16#0000#, 16#0000#, 16#2C50#),
           ((1837, 1837), (0, 0), (0, 0), (1837, 1837)), 0, 0),
         16#21#           =>  --  2C21
          ((16#2C51#, 16#0000#, 16#0000#, 16#2C51#),
           ((1838, 1838), (0, 0), (0, 0), (1838, 1838)), 0, 0),
         16#22#           =>  --  2C22
          ((16#2C52#, 16#0000#, 16#0000#, 16#2C52#),
           ((1839, 1839), (0, 0), (0, 0), (1839, 1839)), 0, 0),
         16#23#           =>  --  2C23
          ((16#2C53#, 16#0000#, 16#0000#, 16#2C53#),
           ((1840, 1840), (0, 0), (0, 0), (1840, 1840)), 0, 0),
         16#24#           =>  --  2C24
          ((16#2C54#, 16#0000#, 16#0000#, 16#2C54#),
           ((1841, 1841), (0, 0), (0, 0), (1841, 1841)), 0, 0),
         16#25#           =>  --  2C25
          ((16#2C55#, 16#0000#, 16#0000#, 16#2C55#),
           ((1842, 1842), (0, 0), (0, 0), (1842, 1842)), 0, 0),
         16#26#           =>  --  2C26
          ((16#2C56#, 16#0000#, 16#0000#, 16#2C56#),
           ((1843, 1843), (0, 0), (0, 0), (1843, 1843)), 0, 0),
         16#27#           =>  --  2C27
          ((16#2C57#, 16#0000#, 16#0000#, 16#2C57#),
           ((1844, 1844), (0, 0), (0, 0), (1844, 1844)), 0, 0),
         16#28#           =>  --  2C28
          ((16#2C58#, 16#0000#, 16#0000#, 16#2C58#),
           ((1845, 1845), (0, 0), (0, 0), (1845, 1845)), 0, 0),
         16#29#           =>  --  2C29
          ((16#2C59#, 16#0000#, 16#0000#, 16#2C59#),
           ((1846, 1846), (0, 0), (0, 0), (1846, 1846)), 0, 0),
         16#2A#           =>  --  2C2A
          ((16#2C5A#, 16#0000#, 16#0000#, 16#2C5A#),
           ((1847, 1847), (0, 0), (0, 0), (1847, 1847)), 0, 0),
         16#2B#           =>  --  2C2B
          ((16#2C5B#, 16#0000#, 16#0000#, 16#2C5B#),
           ((1848, 1848), (0, 0), (0, 0), (1848, 1848)), 0, 0),
         16#2C#           =>  --  2C2C
          ((16#2C5C#, 16#0000#, 16#0000#, 16#2C5C#),
           ((1849, 1849), (0, 0), (0, 0), (1849, 1849)), 0, 0),
         16#2D#           =>  --  2C2D
          ((16#2C5D#, 16#0000#, 16#0000#, 16#2C5D#),
           ((1850, 1850), (0, 0), (0, 0), (1850, 1850)), 0, 0),
         16#2E#           =>  --  2C2E
          ((16#2C5E#, 16#0000#, 16#0000#, 16#2C5E#),
           ((1851, 1851), (0, 0), (0, 0), (1851, 1851)), 0, 0),
         16#30#           =>  --  2C30
          ((16#0000#, 16#2C00#, 16#2C00#, 16#0000#),
           ((0, 0), (1852, 1852), (1852, 1852), (0, 0)), 0, 0),
         16#31#           =>  --  2C31
          ((16#0000#, 16#2C01#, 16#2C01#, 16#0000#),
           ((0, 0), (1853, 1853), (1853, 1853), (0, 0)), 0, 0),
         16#32#           =>  --  2C32
          ((16#0000#, 16#2C02#, 16#2C02#, 16#0000#),
           ((0, 0), (1854, 1854), (1854, 1854), (0, 0)), 0, 0),
         16#33#           =>  --  2C33
          ((16#0000#, 16#2C03#, 16#2C03#, 16#0000#),
           ((0, 0), (1855, 1855), (1855, 1855), (0, 0)), 0, 0),
         16#34#           =>  --  2C34
          ((16#0000#, 16#2C04#, 16#2C04#, 16#0000#),
           ((0, 0), (1856, 1856), (1856, 1856), (0, 0)), 0, 0),
         16#35#           =>  --  2C35
          ((16#0000#, 16#2C05#, 16#2C05#, 16#0000#),
           ((0, 0), (1857, 1857), (1857, 1857), (0, 0)), 0, 0),
         16#36#           =>  --  2C36
          ((16#0000#, 16#2C06#, 16#2C06#, 16#0000#),
           ((0, 0), (1858, 1858), (1858, 1858), (0, 0)), 0, 0),
         16#37#           =>  --  2C37
          ((16#0000#, 16#2C07#, 16#2C07#, 16#0000#),
           ((0, 0), (1859, 1859), (1859, 1859), (0, 0)), 0, 0),
         16#38#           =>  --  2C38
          ((16#0000#, 16#2C08#, 16#2C08#, 16#0000#),
           ((0, 0), (1860, 1860), (1860, 1860), (0, 0)), 0, 0),
         16#39#           =>  --  2C39
          ((16#0000#, 16#2C09#, 16#2C09#, 16#0000#),
           ((0, 0), (1861, 1861), (1861, 1861), (0, 0)), 0, 0),
         16#3A#           =>  --  2C3A
          ((16#0000#, 16#2C0A#, 16#2C0A#, 16#0000#),
           ((0, 0), (1862, 1862), (1862, 1862), (0, 0)), 0, 0),
         16#3B#           =>  --  2C3B
          ((16#0000#, 16#2C0B#, 16#2C0B#, 16#0000#),
           ((0, 0), (1863, 1863), (1863, 1863), (0, 0)), 0, 0),
         16#3C#           =>  --  2C3C
          ((16#0000#, 16#2C0C#, 16#2C0C#, 16#0000#),
           ((0, 0), (1864, 1864), (1864, 1864), (0, 0)), 0, 0),
         16#3D#           =>  --  2C3D
          ((16#0000#, 16#2C0D#, 16#2C0D#, 16#0000#),
           ((0, 0), (1865, 1865), (1865, 1865), (0, 0)), 0, 0),
         16#3E#           =>  --  2C3E
          ((16#0000#, 16#2C0E#, 16#2C0E#, 16#0000#),
           ((0, 0), (1866, 1866), (1866, 1866), (0, 0)), 0, 0),
         16#3F#           =>  --  2C3F
          ((16#0000#, 16#2C0F#, 16#2C0F#, 16#0000#),
           ((0, 0), (1867, 1867), (1867, 1867), (0, 0)), 0, 0),
         16#40#           =>  --  2C40
          ((16#0000#, 16#2C10#, 16#2C10#, 16#0000#),
           ((0, 0), (1868, 1868), (1868, 1868), (0, 0)), 0, 0),
         16#41#           =>  --  2C41
          ((16#0000#, 16#2C11#, 16#2C11#, 16#0000#),
           ((0, 0), (1869, 1869), (1869, 1869), (0, 0)), 0, 0),
         16#42#           =>  --  2C42
          ((16#0000#, 16#2C12#, 16#2C12#, 16#0000#),
           ((0, 0), (1870, 1870), (1870, 1870), (0, 0)), 0, 0),
         16#43#           =>  --  2C43
          ((16#0000#, 16#2C13#, 16#2C13#, 16#0000#),
           ((0, 0), (1871, 1871), (1871, 1871), (0, 0)), 0, 0),
         16#44#           =>  --  2C44
          ((16#0000#, 16#2C14#, 16#2C14#, 16#0000#),
           ((0, 0), (1872, 1872), (1872, 1872), (0, 0)), 0, 0),
         16#45#           =>  --  2C45
          ((16#0000#, 16#2C15#, 16#2C15#, 16#0000#),
           ((0, 0), (1873, 1873), (1873, 1873), (0, 0)), 0, 0),
         16#46#           =>  --  2C46
          ((16#0000#, 16#2C16#, 16#2C16#, 16#0000#),
           ((0, 0), (1874, 1874), (1874, 1874), (0, 0)), 0, 0),
         16#47#           =>  --  2C47
          ((16#0000#, 16#2C17#, 16#2C17#, 16#0000#),
           ((0, 0), (1875, 1875), (1875, 1875), (0, 0)), 0, 0),
         16#48#           =>  --  2C48
          ((16#0000#, 16#2C18#, 16#2C18#, 16#0000#),
           ((0, 0), (1876, 1876), (1876, 1876), (0, 0)), 0, 0),
         16#49#           =>  --  2C49
          ((16#0000#, 16#2C19#, 16#2C19#, 16#0000#),
           ((0, 0), (1877, 1877), (1877, 1877), (0, 0)), 0, 0),
         16#4A#           =>  --  2C4A
          ((16#0000#, 16#2C1A#, 16#2C1A#, 16#0000#),
           ((0, 0), (1878, 1878), (1878, 1878), (0, 0)), 0, 0),
         16#4B#           =>  --  2C4B
          ((16#0000#, 16#2C1B#, 16#2C1B#, 16#0000#),
           ((0, 0), (1879, 1879), (1879, 1879), (0, 0)), 0, 0),
         16#4C#           =>  --  2C4C
          ((16#0000#, 16#2C1C#, 16#2C1C#, 16#0000#),
           ((0, 0), (1880, 1880), (1880, 1880), (0, 0)), 0, 0),
         16#4D#           =>  --  2C4D
          ((16#0000#, 16#2C1D#, 16#2C1D#, 16#0000#),
           ((0, 0), (1881, 1881), (1881, 1881), (0, 0)), 0, 0),
         16#4E#           =>  --  2C4E
          ((16#0000#, 16#2C1E#, 16#2C1E#, 16#0000#),
           ((0, 0), (1882, 1882), (1882, 1882), (0, 0)), 0, 0),
         16#4F#           =>  --  2C4F
          ((16#0000#, 16#2C1F#, 16#2C1F#, 16#0000#),
           ((0, 0), (1883, 1883), (1883, 1883), (0, 0)), 0, 0),
         16#50#           =>  --  2C50
          ((16#0000#, 16#2C20#, 16#2C20#, 16#0000#),
           ((0, 0), (1884, 1884), (1884, 1884), (0, 0)), 0, 0),
         16#51#           =>  --  2C51
          ((16#0000#, 16#2C21#, 16#2C21#, 16#0000#),
           ((0, 0), (1885, 1885), (1885, 1885), (0, 0)), 0, 0),
         16#52#           =>  --  2C52
          ((16#0000#, 16#2C22#, 16#2C22#, 16#0000#),
           ((0, 0), (1886, 1886), (1886, 1886), (0, 0)), 0, 0),
         16#53#           =>  --  2C53
          ((16#0000#, 16#2C23#, 16#2C23#, 16#0000#),
           ((0, 0), (1887, 1887), (1887, 1887), (0, 0)), 0, 0),
         16#54#           =>  --  2C54
          ((16#0000#, 16#2C24#, 16#2C24#, 16#0000#),
           ((0, 0), (1888, 1888), (1888, 1888), (0, 0)), 0, 0),
         16#55#           =>  --  2C55
          ((16#0000#, 16#2C25#, 16#2C25#, 16#0000#),
           ((0, 0), (1889, 1889), (1889, 1889), (0, 0)), 0, 0),
         16#56#           =>  --  2C56
          ((16#0000#, 16#2C26#, 16#2C26#, 16#0000#),
           ((0, 0), (1890, 1890), (1890, 1890), (0, 0)), 0, 0),
         16#57#           =>  --  2C57
          ((16#0000#, 16#2C27#, 16#2C27#, 16#0000#),
           ((0, 0), (1891, 1891), (1891, 1891), (0, 0)), 0, 0),
         16#58#           =>  --  2C58
          ((16#0000#, 16#2C28#, 16#2C28#, 16#0000#),
           ((0, 0), (1892, 1892), (1892, 1892), (0, 0)), 0, 0),
         16#59#           =>  --  2C59
          ((16#0000#, 16#2C29#, 16#2C29#, 16#0000#),
           ((0, 0), (1893, 1893), (1893, 1893), (0, 0)), 0, 0),
         16#5A#           =>  --  2C5A
          ((16#0000#, 16#2C2A#, 16#2C2A#, 16#0000#),
           ((0, 0), (1894, 1894), (1894, 1894), (0, 0)), 0, 0),
         16#5B#           =>  --  2C5B
          ((16#0000#, 16#2C2B#, 16#2C2B#, 16#0000#),
           ((0, 0), (1895, 1895), (1895, 1895), (0, 0)), 0, 0),
         16#5C#           =>  --  2C5C
          ((16#0000#, 16#2C2C#, 16#2C2C#, 16#0000#),
           ((0, 0), (1896, 1896), (1896, 1896), (0, 0)), 0, 0),
         16#5D#           =>  --  2C5D
          ((16#0000#, 16#2C2D#, 16#2C2D#, 16#0000#),
           ((0, 0), (1897, 1897), (1897, 1897), (0, 0)), 0, 0),
         16#5E#           =>  --  2C5E
          ((16#0000#, 16#2C2E#, 16#2C2E#, 16#0000#),
           ((0, 0), (1898, 1898), (1898, 1898), (0, 0)), 0, 0),
         16#60#           =>  --  2C60
          ((16#2C61#, 16#0000#, 16#0000#, 16#2C61#),
           ((1899, 1899), (0, 0), (0, 0), (1899, 1899)), 0, 0),
         16#61#           =>  --  2C61
          ((16#0000#, 16#2C60#, 16#2C60#, 16#0000#),
           ((0, 0), (1900, 1900), (1900, 1900), (0, 0)), 0, 0),
         16#62#           =>  --  2C62
          ((16#026B#, 16#0000#, 16#0000#, 16#026B#),
           ((1901, 1901), (0, 0), (0, 0), (1901, 1901)), 0, 0),
         16#63#           =>  --  2C63
          ((16#1D7D#, 16#0000#, 16#0000#, 16#1D7D#),
           ((1902, 1902), (0, 0), (0, 0), (1902, 1902)), 0, 0),
         16#64#           =>  --  2C64
          ((16#027D#, 16#0000#, 16#0000#, 16#027D#),
           ((1903, 1903), (0, 0), (0, 0), (1903, 1903)), 0, 0),
         16#65#           =>  --  2C65
          ((16#0000#, 16#023A#, 16#023A#, 16#0000#),
           ((0, 0), (1904, 1904), (1904, 1904), (0, 0)), 0, 0),
         16#66#           =>  --  2C66
          ((16#0000#, 16#023E#, 16#023E#, 16#0000#),
           ((0, 0), (1905, 1905), (1905, 1905), (0, 0)), 0, 0),
         16#67#           =>  --  2C67
          ((16#2C68#, 16#0000#, 16#0000#, 16#2C68#),
           ((1906, 1906), (0, 0), (0, 0), (1906, 1906)), 0, 0),
         16#68#           =>  --  2C68
          ((16#0000#, 16#2C67#, 16#2C67#, 16#0000#),
           ((0, 0), (1907, 1907), (1907, 1907), (0, 0)), 0, 0),
         16#69#           =>  --  2C69
          ((16#2C6A#, 16#0000#, 16#0000#, 16#2C6A#),
           ((1908, 1908), (0, 0), (0, 0), (1908, 1908)), 0, 0),
         16#6A#           =>  --  2C6A
          ((16#0000#, 16#2C69#, 16#2C69#, 16#0000#),
           ((0, 0), (1909, 1909), (1909, 1909), (0, 0)), 0, 0),
         16#6B#           =>  --  2C6B
          ((16#2C6C#, 16#0000#, 16#0000#, 16#2C6C#),
           ((1910, 1910), (0, 0), (0, 0), (1910, 1910)), 0, 0),
         16#6C#           =>  --  2C6C
          ((16#0000#, 16#2C6B#, 16#2C6B#, 16#0000#),
           ((0, 0), (1911, 1911), (1911, 1911), (0, 0)), 0, 0),
         16#6D#           =>  --  2C6D
          ((16#0251#, 16#0000#, 16#0000#, 16#0251#),
           ((1912, 1912), (0, 0), (0, 0), (1912, 1912)), 0, 0),
         16#6E#           =>  --  2C6E
          ((16#0271#, 16#0000#, 16#0000#, 16#0271#),
           ((1913, 1913), (0, 0), (0, 0), (1913, 1913)), 0, 0),
         16#6F#           =>  --  2C6F
          ((16#0250#, 16#0000#, 16#0000#, 16#0250#),
           ((1914, 1914), (0, 0), (0, 0), (1914, 1914)), 0, 0),
         16#70#           =>  --  2C70
          ((16#0252#, 16#0000#, 16#0000#, 16#0252#),
           ((1915, 1915), (0, 0), (0, 0), (1915, 1915)), 0, 0),
         16#72#           =>  --  2C72
          ((16#2C73#, 16#0000#, 16#0000#, 16#2C73#),
           ((1916, 1916), (0, 0), (0, 0), (1916, 1916)), 0, 0),
         16#73#           =>  --  2C73
          ((16#0000#, 16#2C72#, 16#2C72#, 16#0000#),
           ((0, 0), (1917, 1917), (1917, 1917), (0, 0)), 0, 0),
         16#75#           =>  --  2C75
          ((16#2C76#, 16#0000#, 16#0000#, 16#2C76#),
           ((1918, 1918), (0, 0), (0, 0), (1918, 1918)), 0, 0),
         16#76#           =>  --  2C76
          ((16#0000#, 16#2C75#, 16#2C75#, 16#0000#),
           ((0, 0), (1919, 1919), (1919, 1919), (0, 0)), 0, 0),
         16#7E#           =>  --  2C7E
          ((16#023F#, 16#0000#, 16#0000#, 16#023F#),
           ((1920, 1920), (0, 0), (0, 0), (1920, 1920)), 0, 0),
         16#7F#           =>  --  2C7F
          ((16#0240#, 16#0000#, 16#0000#, 16#0240#),
           ((1921, 1921), (0, 0), (0, 0), (1921, 1921)), 0, 0),
         16#80#           =>  --  2C80
          ((16#2C81#, 16#0000#, 16#0000#, 16#2C81#),
           ((1922, 1922), (0, 0), (0, 0), (1922, 1922)), 0, 0),
         16#81#           =>  --  2C81
          ((16#0000#, 16#2C80#, 16#2C80#, 16#0000#),
           ((0, 0), (1923, 1923), (1923, 1923), (0, 0)), 0, 0),
         16#82#           =>  --  2C82
          ((16#2C83#, 16#0000#, 16#0000#, 16#2C83#),
           ((1924, 1924), (0, 0), (0, 0), (1924, 1924)), 0, 0),
         16#83#           =>  --  2C83
          ((16#0000#, 16#2C82#, 16#2C82#, 16#0000#),
           ((0, 0), (1925, 1925), (1925, 1925), (0, 0)), 0, 0),
         16#84#           =>  --  2C84
          ((16#2C85#, 16#0000#, 16#0000#, 16#2C85#),
           ((1926, 1926), (0, 0), (0, 0), (1926, 1926)), 0, 0),
         16#85#           =>  --  2C85
          ((16#0000#, 16#2C84#, 16#2C84#, 16#0000#),
           ((0, 0), (1927, 1927), (1927, 1927), (0, 0)), 0, 0),
         16#86#           =>  --  2C86
          ((16#2C87#, 16#0000#, 16#0000#, 16#2C87#),
           ((1928, 1928), (0, 0), (0, 0), (1928, 1928)), 0, 0),
         16#87#           =>  --  2C87
          ((16#0000#, 16#2C86#, 16#2C86#, 16#0000#),
           ((0, 0), (1929, 1929), (1929, 1929), (0, 0)), 0, 0),
         16#88#           =>  --  2C88
          ((16#2C89#, 16#0000#, 16#0000#, 16#2C89#),
           ((1930, 1930), (0, 0), (0, 0), (1930, 1930)), 0, 0),
         16#89#           =>  --  2C89
          ((16#0000#, 16#2C88#, 16#2C88#, 16#0000#),
           ((0, 0), (1931, 1931), (1931, 1931), (0, 0)), 0, 0),
         16#8A#           =>  --  2C8A
          ((16#2C8B#, 16#0000#, 16#0000#, 16#2C8B#),
           ((1932, 1932), (0, 0), (0, 0), (1932, 1932)), 0, 0),
         16#8B#           =>  --  2C8B
          ((16#0000#, 16#2C8A#, 16#2C8A#, 16#0000#),
           ((0, 0), (1933, 1933), (1933, 1933), (0, 0)), 0, 0),
         16#8C#           =>  --  2C8C
          ((16#2C8D#, 16#0000#, 16#0000#, 16#2C8D#),
           ((1934, 1934), (0, 0), (0, 0), (1934, 1934)), 0, 0),
         16#8D#           =>  --  2C8D
          ((16#0000#, 16#2C8C#, 16#2C8C#, 16#0000#),
           ((0, 0), (1935, 1935), (1935, 1935), (0, 0)), 0, 0),
         16#8E#           =>  --  2C8E
          ((16#2C8F#, 16#0000#, 16#0000#, 16#2C8F#),
           ((1936, 1936), (0, 0), (0, 0), (1936, 1936)), 0, 0),
         16#8F#           =>  --  2C8F
          ((16#0000#, 16#2C8E#, 16#2C8E#, 16#0000#),
           ((0, 0), (1937, 1937), (1937, 1937), (0, 0)), 0, 0),
         16#90#           =>  --  2C90
          ((16#2C91#, 16#0000#, 16#0000#, 16#2C91#),
           ((1938, 1938), (0, 0), (0, 0), (1938, 1938)), 0, 0),
         16#91#           =>  --  2C91
          ((16#0000#, 16#2C90#, 16#2C90#, 16#0000#),
           ((0, 0), (1939, 1939), (1939, 1939), (0, 0)), 0, 0),
         16#92#           =>  --  2C92
          ((16#2C93#, 16#0000#, 16#0000#, 16#2C93#),
           ((1940, 1940), (0, 0), (0, 0), (1940, 1940)), 0, 0),
         16#93#           =>  --  2C93
          ((16#0000#, 16#2C92#, 16#2C92#, 16#0000#),
           ((0, 0), (1941, 1941), (1941, 1941), (0, 0)), 0, 0),
         16#94#           =>  --  2C94
          ((16#2C95#, 16#0000#, 16#0000#, 16#2C95#),
           ((1942, 1942), (0, 0), (0, 0), (1942, 1942)), 0, 0),
         16#95#           =>  --  2C95
          ((16#0000#, 16#2C94#, 16#2C94#, 16#0000#),
           ((0, 0), (1943, 1943), (1943, 1943), (0, 0)), 0, 0),
         16#96#           =>  --  2C96
          ((16#2C97#, 16#0000#, 16#0000#, 16#2C97#),
           ((1944, 1944), (0, 0), (0, 0), (1944, 1944)), 0, 0),
         16#97#           =>  --  2C97
          ((16#0000#, 16#2C96#, 16#2C96#, 16#0000#),
           ((0, 0), (1945, 1945), (1945, 1945), (0, 0)), 0, 0),
         16#98#           =>  --  2C98
          ((16#2C99#, 16#0000#, 16#0000#, 16#2C99#),
           ((1946, 1946), (0, 0), (0, 0), (1946, 1946)), 0, 0),
         16#99#           =>  --  2C99
          ((16#0000#, 16#2C98#, 16#2C98#, 16#0000#),
           ((0, 0), (1947, 1947), (1947, 1947), (0, 0)), 0, 0),
         16#9A#           =>  --  2C9A
          ((16#2C9B#, 16#0000#, 16#0000#, 16#2C9B#),
           ((1948, 1948), (0, 0), (0, 0), (1948, 1948)), 0, 0),
         16#9B#           =>  --  2C9B
          ((16#0000#, 16#2C9A#, 16#2C9A#, 16#0000#),
           ((0, 0), (1949, 1949), (1949, 1949), (0, 0)), 0, 0),
         16#9C#           =>  --  2C9C
          ((16#2C9D#, 16#0000#, 16#0000#, 16#2C9D#),
           ((1950, 1950), (0, 0), (0, 0), (1950, 1950)), 0, 0),
         16#9D#           =>  --  2C9D
          ((16#0000#, 16#2C9C#, 16#2C9C#, 16#0000#),
           ((0, 0), (1951, 1951), (1951, 1951), (0, 0)), 0, 0),
         16#9E#           =>  --  2C9E
          ((16#2C9F#, 16#0000#, 16#0000#, 16#2C9F#),
           ((1952, 1952), (0, 0), (0, 0), (1952, 1952)), 0, 0),
         16#9F#           =>  --  2C9F
          ((16#0000#, 16#2C9E#, 16#2C9E#, 16#0000#),
           ((0, 0), (1953, 1953), (1953, 1953), (0, 0)), 0, 0),
         16#A0#           =>  --  2CA0
          ((16#2CA1#, 16#0000#, 16#0000#, 16#2CA1#),
           ((1954, 1954), (0, 0), (0, 0), (1954, 1954)), 0, 0),
         16#A1#           =>  --  2CA1
          ((16#0000#, 16#2CA0#, 16#2CA0#, 16#0000#),
           ((0, 0), (1955, 1955), (1955, 1955), (0, 0)), 0, 0),
         16#A2#           =>  --  2CA2
          ((16#2CA3#, 16#0000#, 16#0000#, 16#2CA3#),
           ((1956, 1956), (0, 0), (0, 0), (1956, 1956)), 0, 0),
         16#A3#           =>  --  2CA3
          ((16#0000#, 16#2CA2#, 16#2CA2#, 16#0000#),
           ((0, 0), (1957, 1957), (1957, 1957), (0, 0)), 0, 0),
         16#A4#           =>  --  2CA4
          ((16#2CA5#, 16#0000#, 16#0000#, 16#2CA5#),
           ((1958, 1958), (0, 0), (0, 0), (1958, 1958)), 0, 0),
         16#A5#           =>  --  2CA5
          ((16#0000#, 16#2CA4#, 16#2CA4#, 16#0000#),
           ((0, 0), (1959, 1959), (1959, 1959), (0, 0)), 0, 0),
         16#A6#           =>  --  2CA6
          ((16#2CA7#, 16#0000#, 16#0000#, 16#2CA7#),
           ((1960, 1960), (0, 0), (0, 0), (1960, 1960)), 0, 0),
         16#A7#           =>  --  2CA7
          ((16#0000#, 16#2CA6#, 16#2CA6#, 16#0000#),
           ((0, 0), (1961, 1961), (1961, 1961), (0, 0)), 0, 0),
         16#A8#           =>  --  2CA8
          ((16#2CA9#, 16#0000#, 16#0000#, 16#2CA9#),
           ((1962, 1962), (0, 0), (0, 0), (1962, 1962)), 0, 0),
         16#A9#           =>  --  2CA9
          ((16#0000#, 16#2CA8#, 16#2CA8#, 16#0000#),
           ((0, 0), (1963, 1963), (1963, 1963), (0, 0)), 0, 0),
         16#AA#           =>  --  2CAA
          ((16#2CAB#, 16#0000#, 16#0000#, 16#2CAB#),
           ((1964, 1964), (0, 0), (0, 0), (1964, 1964)), 0, 0),
         16#AB#           =>  --  2CAB
          ((16#0000#, 16#2CAA#, 16#2CAA#, 16#0000#),
           ((0, 0), (1965, 1965), (1965, 1965), (0, 0)), 0, 0),
         16#AC#           =>  --  2CAC
          ((16#2CAD#, 16#0000#, 16#0000#, 16#2CAD#),
           ((1966, 1966), (0, 0), (0, 0), (1966, 1966)), 0, 0),
         16#AD#           =>  --  2CAD
          ((16#0000#, 16#2CAC#, 16#2CAC#, 16#0000#),
           ((0, 0), (1967, 1967), (1967, 1967), (0, 0)), 0, 0),
         16#AE#           =>  --  2CAE
          ((16#2CAF#, 16#0000#, 16#0000#, 16#2CAF#),
           ((1968, 1968), (0, 0), (0, 0), (1968, 1968)), 0, 0),
         16#AF#           =>  --  2CAF
          ((16#0000#, 16#2CAE#, 16#2CAE#, 16#0000#),
           ((0, 0), (1969, 1969), (1969, 1969), (0, 0)), 0, 0),
         16#B0#           =>  --  2CB0
          ((16#2CB1#, 16#0000#, 16#0000#, 16#2CB1#),
           ((1970, 1970), (0, 0), (0, 0), (1970, 1970)), 0, 0),
         16#B1#           =>  --  2CB1
          ((16#0000#, 16#2CB0#, 16#2CB0#, 16#0000#),
           ((0, 0), (1971, 1971), (1971, 1971), (0, 0)), 0, 0),
         16#B2#           =>  --  2CB2
          ((16#2CB3#, 16#0000#, 16#0000#, 16#2CB3#),
           ((1972, 1972), (0, 0), (0, 0), (1972, 1972)), 0, 0),
         16#B3#           =>  --  2CB3
          ((16#0000#, 16#2CB2#, 16#2CB2#, 16#0000#),
           ((0, 0), (1973, 1973), (1973, 1973), (0, 0)), 0, 0),
         16#B4#           =>  --  2CB4
          ((16#2CB5#, 16#0000#, 16#0000#, 16#2CB5#),
           ((1974, 1974), (0, 0), (0, 0), (1974, 1974)), 0, 0),
         16#B5#           =>  --  2CB5
          ((16#0000#, 16#2CB4#, 16#2CB4#, 16#0000#),
           ((0, 0), (1975, 1975), (1975, 1975), (0, 0)), 0, 0),
         16#B6#           =>  --  2CB6
          ((16#2CB7#, 16#0000#, 16#0000#, 16#2CB7#),
           ((1976, 1976), (0, 0), (0, 0), (1976, 1976)), 0, 0),
         16#B7#           =>  --  2CB7
          ((16#0000#, 16#2CB6#, 16#2CB6#, 16#0000#),
           ((0, 0), (1977, 1977), (1977, 1977), (0, 0)), 0, 0),
         16#B8#           =>  --  2CB8
          ((16#2CB9#, 16#0000#, 16#0000#, 16#2CB9#),
           ((1978, 1978), (0, 0), (0, 0), (1978, 1978)), 0, 0),
         16#B9#           =>  --  2CB9
          ((16#0000#, 16#2CB8#, 16#2CB8#, 16#0000#),
           ((0, 0), (1979, 1979), (1979, 1979), (0, 0)), 0, 0),
         16#BA#           =>  --  2CBA
          ((16#2CBB#, 16#0000#, 16#0000#, 16#2CBB#),
           ((1980, 1980), (0, 0), (0, 0), (1980, 1980)), 0, 0),
         16#BB#           =>  --  2CBB
          ((16#0000#, 16#2CBA#, 16#2CBA#, 16#0000#),
           ((0, 0), (1981, 1981), (1981, 1981), (0, 0)), 0, 0),
         16#BC#           =>  --  2CBC
          ((16#2CBD#, 16#0000#, 16#0000#, 16#2CBD#),
           ((1982, 1982), (0, 0), (0, 0), (1982, 1982)), 0, 0),
         16#BD#           =>  --  2CBD
          ((16#0000#, 16#2CBC#, 16#2CBC#, 16#0000#),
           ((0, 0), (1983, 1983), (1983, 1983), (0, 0)), 0, 0),
         16#BE#           =>  --  2CBE
          ((16#2CBF#, 16#0000#, 16#0000#, 16#2CBF#),
           ((1984, 1984), (0, 0), (0, 0), (1984, 1984)), 0, 0),
         16#BF#           =>  --  2CBF
          ((16#0000#, 16#2CBE#, 16#2CBE#, 16#0000#),
           ((0, 0), (1985, 1985), (1985, 1985), (0, 0)), 0, 0),
         16#C0#           =>  --  2CC0
          ((16#2CC1#, 16#0000#, 16#0000#, 16#2CC1#),
           ((1986, 1986), (0, 0), (0, 0), (1986, 1986)), 0, 0),
         16#C1#           =>  --  2CC1
          ((16#0000#, 16#2CC0#, 16#2CC0#, 16#0000#),
           ((0, 0), (1987, 1987), (1987, 1987), (0, 0)), 0, 0),
         16#C2#           =>  --  2CC2
          ((16#2CC3#, 16#0000#, 16#0000#, 16#2CC3#),
           ((1988, 1988), (0, 0), (0, 0), (1988, 1988)), 0, 0),
         16#C3#           =>  --  2CC3
          ((16#0000#, 16#2CC2#, 16#2CC2#, 16#0000#),
           ((0, 0), (1989, 1989), (1989, 1989), (0, 0)), 0, 0),
         16#C4#           =>  --  2CC4
          ((16#2CC5#, 16#0000#, 16#0000#, 16#2CC5#),
           ((1990, 1990), (0, 0), (0, 0), (1990, 1990)), 0, 0),
         16#C5#           =>  --  2CC5
          ((16#0000#, 16#2CC4#, 16#2CC4#, 16#0000#),
           ((0, 0), (1991, 1991), (1991, 1991), (0, 0)), 0, 0),
         16#C6#           =>  --  2CC6
          ((16#2CC7#, 16#0000#, 16#0000#, 16#2CC7#),
           ((1992, 1992), (0, 0), (0, 0), (1992, 1992)), 0, 0),
         16#C7#           =>  --  2CC7
          ((16#0000#, 16#2CC6#, 16#2CC6#, 16#0000#),
           ((0, 0), (1993, 1993), (1993, 1993), (0, 0)), 0, 0),
         16#C8#           =>  --  2CC8
          ((16#2CC9#, 16#0000#, 16#0000#, 16#2CC9#),
           ((1994, 1994), (0, 0), (0, 0), (1994, 1994)), 0, 0),
         16#C9#           =>  --  2CC9
          ((16#0000#, 16#2CC8#, 16#2CC8#, 16#0000#),
           ((0, 0), (1995, 1995), (1995, 1995), (0, 0)), 0, 0),
         16#CA#           =>  --  2CCA
          ((16#2CCB#, 16#0000#, 16#0000#, 16#2CCB#),
           ((1996, 1996), (0, 0), (0, 0), (1996, 1996)), 0, 0),
         16#CB#           =>  --  2CCB
          ((16#0000#, 16#2CCA#, 16#2CCA#, 16#0000#),
           ((0, 0), (1997, 1997), (1997, 1997), (0, 0)), 0, 0),
         16#CC#           =>  --  2CCC
          ((16#2CCD#, 16#0000#, 16#0000#, 16#2CCD#),
           ((1998, 1998), (0, 0), (0, 0), (1998, 1998)), 0, 0),
         16#CD#           =>  --  2CCD
          ((16#0000#, 16#2CCC#, 16#2CCC#, 16#0000#),
           ((0, 0), (1999, 1999), (1999, 1999), (0, 0)), 0, 0),
         16#CE#           =>  --  2CCE
          ((16#2CCF#, 16#0000#, 16#0000#, 16#2CCF#),
           ((2000, 2000), (0, 0), (0, 0), (2000, 2000)), 0, 0),
         16#CF#           =>  --  2CCF
          ((16#0000#, 16#2CCE#, 16#2CCE#, 16#0000#),
           ((0, 0), (2001, 2001), (2001, 2001), (0, 0)), 0, 0),
         16#D0#           =>  --  2CD0
          ((16#2CD1#, 16#0000#, 16#0000#, 16#2CD1#),
           ((2002, 2002), (0, 0), (0, 0), (2002, 2002)), 0, 0),
         16#D1#           =>  --  2CD1
          ((16#0000#, 16#2CD0#, 16#2CD0#, 16#0000#),
           ((0, 0), (2003, 2003), (2003, 2003), (0, 0)), 0, 0),
         16#D2#           =>  --  2CD2
          ((16#2CD3#, 16#0000#, 16#0000#, 16#2CD3#),
           ((2004, 2004), (0, 0), (0, 0), (2004, 2004)), 0, 0),
         16#D3#           =>  --  2CD3
          ((16#0000#, 16#2CD2#, 16#2CD2#, 16#0000#),
           ((0, 0), (2005, 2005), (2005, 2005), (0, 0)), 0, 0),
         16#D4#           =>  --  2CD4
          ((16#2CD5#, 16#0000#, 16#0000#, 16#2CD5#),
           ((2006, 2006), (0, 0), (0, 0), (2006, 2006)), 0, 0),
         16#D5#           =>  --  2CD5
          ((16#0000#, 16#2CD4#, 16#2CD4#, 16#0000#),
           ((0, 0), (2007, 2007), (2007, 2007), (0, 0)), 0, 0),
         16#D6#           =>  --  2CD6
          ((16#2CD7#, 16#0000#, 16#0000#, 16#2CD7#),
           ((2008, 2008), (0, 0), (0, 0), (2008, 2008)), 0, 0),
         16#D7#           =>  --  2CD7
          ((16#0000#, 16#2CD6#, 16#2CD6#, 16#0000#),
           ((0, 0), (2009, 2009), (2009, 2009), (0, 0)), 0, 0),
         16#D8#           =>  --  2CD8
          ((16#2CD9#, 16#0000#, 16#0000#, 16#2CD9#),
           ((2010, 2010), (0, 0), (0, 0), (2010, 2010)), 0, 0),
         16#D9#           =>  --  2CD9
          ((16#0000#, 16#2CD8#, 16#2CD8#, 16#0000#),
           ((0, 0), (2011, 2011), (2011, 2011), (0, 0)), 0, 0),
         16#DA#           =>  --  2CDA
          ((16#2CDB#, 16#0000#, 16#0000#, 16#2CDB#),
           ((2012, 2012), (0, 0), (0, 0), (2012, 2012)), 0, 0),
         16#DB#           =>  --  2CDB
          ((16#0000#, 16#2CDA#, 16#2CDA#, 16#0000#),
           ((0, 0), (2013, 2013), (2013, 2013), (0, 0)), 0, 0),
         16#DC#           =>  --  2CDC
          ((16#2CDD#, 16#0000#, 16#0000#, 16#2CDD#),
           ((2014, 2014), (0, 0), (0, 0), (2014, 2014)), 0, 0),
         16#DD#           =>  --  2CDD
          ((16#0000#, 16#2CDC#, 16#2CDC#, 16#0000#),
           ((0, 0), (2015, 2015), (2015, 2015), (0, 0)), 0, 0),
         16#DE#           =>  --  2CDE
          ((16#2CDF#, 16#0000#, 16#0000#, 16#2CDF#),
           ((2016, 2016), (0, 0), (0, 0), (2016, 2016)), 0, 0),
         16#DF#           =>  --  2CDF
          ((16#0000#, 16#2CDE#, 16#2CDE#, 16#0000#),
           ((0, 0), (2017, 2017), (2017, 2017), (0, 0)), 0, 0),
         16#E0#           =>  --  2CE0
          ((16#2CE1#, 16#0000#, 16#0000#, 16#2CE1#),
           ((2018, 2018), (0, 0), (0, 0), (2018, 2018)), 0, 0),
         16#E1#           =>  --  2CE1
          ((16#0000#, 16#2CE0#, 16#2CE0#, 16#0000#),
           ((0, 0), (2019, 2019), (2019, 2019), (0, 0)), 0, 0),
         16#E2#           =>  --  2CE2
          ((16#2CE3#, 16#0000#, 16#0000#, 16#2CE3#),
           ((2020, 2020), (0, 0), (0, 0), (2020, 2020)), 0, 0),
         16#E3#           =>  --  2CE3
          ((16#0000#, 16#2CE2#, 16#2CE2#, 16#0000#),
           ((0, 0), (2021, 2021), (2021, 2021), (0, 0)), 0, 0),
         16#EB#           =>  --  2CEB
          ((16#2CEC#, 16#0000#, 16#0000#, 16#2CEC#),
           ((2022, 2022), (0, 0), (0, 0), (2022, 2022)), 0, 0),
         16#EC#           =>  --  2CEC
          ((16#0000#, 16#2CEB#, 16#2CEB#, 16#0000#),
           ((0, 0), (2023, 2023), (2023, 2023), (0, 0)), 0, 0),
         16#ED#           =>  --  2CED
          ((16#2CEE#, 16#0000#, 16#0000#, 16#2CEE#),
           ((2024, 2024), (0, 0), (0, 0), (2024, 2024)), 0, 0),
         16#EE#           =>  --  2CEE
          ((16#0000#, 16#2CED#, 16#2CED#, 16#0000#),
           ((0, 0), (2025, 2025), (2025, 2025), (0, 0)), 0, 0),
         16#F2#           =>  --  2CF2
          ((16#2CF3#, 16#0000#, 16#0000#, 16#2CF3#),
           ((2026, 2026), (0, 0), (0, 0), (2026, 2026)), 0, 0),
         16#F3#           =>  --  2CF3
          ((16#0000#, 16#2CF2#, 16#2CF2#, 16#0000#),
           ((0, 0), (2027, 2027), (2027, 2027), (0, 0)), 0, 0),
         others           =>
          ((16#0000#, 16#0000#, 16#0000#, 16#0000#),
           ((0, 0), (0, 0), (0, 0), (0, 0)), 0, 0));

   Group_002D : aliased constant Case_Mapping_Second_Stage
     := (16#00#           =>  --  2D00
          ((16#0000#, 16#10A0#, 16#10A0#, 16#0000#),
           ((0, 0), (2028, 2028), (2028, 2028), (0, 0)), 0, 0),
         16#01#           =>  --  2D01
          ((16#0000#, 16#10A1#, 16#10A1#, 16#0000#),
           ((0, 0), (2029, 2029), (2029, 2029), (0, 0)), 0, 0),
         16#02#           =>  --  2D02
          ((16#0000#, 16#10A2#, 16#10A2#, 16#0000#),
           ((0, 0), (2030, 2030), (2030, 2030), (0, 0)), 0, 0),
         16#03#           =>  --  2D03
          ((16#0000#, 16#10A3#, 16#10A3#, 16#0000#),
           ((0, 0), (2031, 2031), (2031, 2031), (0, 0)), 0, 0),
         16#04#           =>  --  2D04
          ((16#0000#, 16#10A4#, 16#10A4#, 16#0000#),
           ((0, 0), (2032, 2032), (2032, 2032), (0, 0)), 0, 0),
         16#05#           =>  --  2D05
          ((16#0000#, 16#10A5#, 16#10A5#, 16#0000#),
           ((0, 0), (2033, 2033), (2033, 2033), (0, 0)), 0, 0),
         16#06#           =>  --  2D06
          ((16#0000#, 16#10A6#, 16#10A6#, 16#0000#),
           ((0, 0), (2034, 2034), (2034, 2034), (0, 0)), 0, 0),
         16#07#           =>  --  2D07
          ((16#0000#, 16#10A7#, 16#10A7#, 16#0000#),
           ((0, 0), (2035, 2035), (2035, 2035), (0, 0)), 0, 0),
         16#08#           =>  --  2D08
          ((16#0000#, 16#10A8#, 16#10A8#, 16#0000#),
           ((0, 0), (2036, 2036), (2036, 2036), (0, 0)), 0, 0),
         16#09#           =>  --  2D09
          ((16#0000#, 16#10A9#, 16#10A9#, 16#0000#),
           ((0, 0), (2037, 2037), (2037, 2037), (0, 0)), 0, 0),
         16#0A#           =>  --  2D0A
          ((16#0000#, 16#10AA#, 16#10AA#, 16#0000#),
           ((0, 0), (2038, 2038), (2038, 2038), (0, 0)), 0, 0),
         16#0B#           =>  --  2D0B
          ((16#0000#, 16#10AB#, 16#10AB#, 16#0000#),
           ((0, 0), (2039, 2039), (2039, 2039), (0, 0)), 0, 0),
         16#0C#           =>  --  2D0C
          ((16#0000#, 16#10AC#, 16#10AC#, 16#0000#),
           ((0, 0), (2040, 2040), (2040, 2040), (0, 0)), 0, 0),
         16#0D#           =>  --  2D0D
          ((16#0000#, 16#10AD#, 16#10AD#, 16#0000#),
           ((0, 0), (2041, 2041), (2041, 2041), (0, 0)), 0, 0),
         16#0E#           =>  --  2D0E
          ((16#0000#, 16#10AE#, 16#10AE#, 16#0000#),
           ((0, 0), (2042, 2042), (2042, 2042), (0, 0)), 0, 0),
         16#0F#           =>  --  2D0F
          ((16#0000#, 16#10AF#, 16#10AF#, 16#0000#),
           ((0, 0), (2043, 2043), (2043, 2043), (0, 0)), 0, 0),
         16#10#           =>  --  2D10
          ((16#0000#, 16#10B0#, 16#10B0#, 16#0000#),
           ((0, 0), (2044, 2044), (2044, 2044), (0, 0)), 0, 0),
         16#11#           =>  --  2D11
          ((16#0000#, 16#10B1#, 16#10B1#, 16#0000#),
           ((0, 0), (2045, 2045), (2045, 2045), (0, 0)), 0, 0),
         16#12#           =>  --  2D12
          ((16#0000#, 16#10B2#, 16#10B2#, 16#0000#),
           ((0, 0), (2046, 2046), (2046, 2046), (0, 0)), 0, 0),
         16#13#           =>  --  2D13
          ((16#0000#, 16#10B3#, 16#10B3#, 16#0000#),
           ((0, 0), (2047, 2047), (2047, 2047), (0, 0)), 0, 0),
         16#14#           =>  --  2D14
          ((16#0000#, 16#10B4#, 16#10B4#, 16#0000#),
           ((0, 0), (2048, 2048), (2048, 2048), (0, 0)), 0, 0),
         16#15#           =>  --  2D15
          ((16#0000#, 16#10B5#, 16#10B5#, 16#0000#),
           ((0, 0), (2049, 2049), (2049, 2049), (0, 0)), 0, 0),
         16#16#           =>  --  2D16
          ((16#0000#, 16#10B6#, 16#10B6#, 16#0000#),
           ((0, 0), (2050, 2050), (2050, 2050), (0, 0)), 0, 0),
         16#17#           =>  --  2D17
          ((16#0000#, 16#10B7#, 16#10B7#, 16#0000#),
           ((0, 0), (2051, 2051), (2051, 2051), (0, 0)), 0, 0),
         16#18#           =>  --  2D18
          ((16#0000#, 16#10B8#, 16#10B8#, 16#0000#),
           ((0, 0), (2052, 2052), (2052, 2052), (0, 0)), 0, 0),
         16#19#           =>  --  2D19
          ((16#0000#, 16#10B9#, 16#10B9#, 16#0000#),
           ((0, 0), (2053, 2053), (2053, 2053), (0, 0)), 0, 0),
         16#1A#           =>  --  2D1A
          ((16#0000#, 16#10BA#, 16#10BA#, 16#0000#),
           ((0, 0), (2054, 2054), (2054, 2054), (0, 0)), 0, 0),
         16#1B#           =>  --  2D1B
          ((16#0000#, 16#10BB#, 16#10BB#, 16#0000#),
           ((0, 0), (2055, 2055), (2055, 2055), (0, 0)), 0, 0),
         16#1C#           =>  --  2D1C
          ((16#0000#, 16#10BC#, 16#10BC#, 16#0000#),
           ((0, 0), (2056, 2056), (2056, 2056), (0, 0)), 0, 0),
         16#1D#           =>  --  2D1D
          ((16#0000#, 16#10BD#, 16#10BD#, 16#0000#),
           ((0, 0), (2057, 2057), (2057, 2057), (0, 0)), 0, 0),
         16#1E#           =>  --  2D1E
          ((16#0000#, 16#10BE#, 16#10BE#, 16#0000#),
           ((0, 0), (2058, 2058), (2058, 2058), (0, 0)), 0, 0),
         16#1F#           =>  --  2D1F
          ((16#0000#, 16#10BF#, 16#10BF#, 16#0000#),
           ((0, 0), (2059, 2059), (2059, 2059), (0, 0)), 0, 0),
         16#20#           =>  --  2D20
          ((16#0000#, 16#10C0#, 16#10C0#, 16#0000#),
           ((0, 0), (2060, 2060), (2060, 2060), (0, 0)), 0, 0),
         16#21#           =>  --  2D21
          ((16#0000#, 16#10C1#, 16#10C1#, 16#0000#),
           ((0, 0), (2061, 2061), (2061, 2061), (0, 0)), 0, 0),
         16#22#           =>  --  2D22
          ((16#0000#, 16#10C2#, 16#10C2#, 16#0000#),
           ((0, 0), (2062, 2062), (2062, 2062), (0, 0)), 0, 0),
         16#23#           =>  --  2D23
          ((16#0000#, 16#10C3#, 16#10C3#, 16#0000#),
           ((0, 0), (2063, 2063), (2063, 2063), (0, 0)), 0, 0),
         16#24#           =>  --  2D24
          ((16#0000#, 16#10C4#, 16#10C4#, 16#0000#),
           ((0, 0), (2064, 2064), (2064, 2064), (0, 0)), 0, 0),
         16#25#           =>  --  2D25
          ((16#0000#, 16#10C5#, 16#10C5#, 16#0000#),
           ((0, 0), (2065, 2065), (2065, 2065), (0, 0)), 0, 0),
         16#27#           =>  --  2D27
          ((16#0000#, 16#10C7#, 16#10C7#, 16#0000#),
           ((0, 0), (2066, 2066), (2066, 2066), (0, 0)), 0, 0),
         16#2D#           =>  --  2D2D
          ((16#0000#, 16#10CD#, 16#10CD#, 16#0000#),
           ((0, 0), (2067, 2067), (2067, 2067), (0, 0)), 0, 0),
         others           =>
          ((16#0000#, 16#0000#, 16#0000#, 16#0000#),
           ((0, 0), (0, 0), (0, 0), (0, 0)), 0, 0));

   Group_00A6 : aliased constant Case_Mapping_Second_Stage
     := (16#40#           =>  --  A640
          ((16#A641#, 16#0000#, 16#0000#, 16#A641#),
           ((2068, 2068), (0, 0), (0, 0), (2068, 2068)), 0, 0),
         16#41#           =>  --  A641
          ((16#0000#, 16#A640#, 16#A640#, 16#0000#),
           ((0, 0), (2069, 2069), (2069, 2069), (0, 0)), 0, 0),
         16#42#           =>  --  A642
          ((16#A643#, 16#0000#, 16#0000#, 16#A643#),
           ((2070, 2070), (0, 0), (0, 0), (2070, 2070)), 0, 0),
         16#43#           =>  --  A643
          ((16#0000#, 16#A642#, 16#A642#, 16#0000#),
           ((0, 0), (2071, 2071), (2071, 2071), (0, 0)), 0, 0),
         16#44#           =>  --  A644
          ((16#A645#, 16#0000#, 16#0000#, 16#A645#),
           ((2072, 2072), (0, 0), (0, 0), (2072, 2072)), 0, 0),
         16#45#           =>  --  A645
          ((16#0000#, 16#A644#, 16#A644#, 16#0000#),
           ((0, 0), (2073, 2073), (2073, 2073), (0, 0)), 0, 0),
         16#46#           =>  --  A646
          ((16#A647#, 16#0000#, 16#0000#, 16#A647#),
           ((2074, 2074), (0, 0), (0, 0), (2074, 2074)), 0, 0),
         16#47#           =>  --  A647
          ((16#0000#, 16#A646#, 16#A646#, 16#0000#),
           ((0, 0), (2075, 2075), (2075, 2075), (0, 0)), 0, 0),
         16#48#           =>  --  A648
          ((16#A649#, 16#0000#, 16#0000#, 16#A649#),
           ((2076, 2076), (0, 0), (0, 0), (2076, 2076)), 0, 0),
         16#49#           =>  --  A649
          ((16#0000#, 16#A648#, 16#A648#, 16#0000#),
           ((0, 0), (2077, 2077), (2077, 2077), (0, 0)), 0, 0),
         16#4A#           =>  --  A64A
          ((16#A64B#, 16#0000#, 16#0000#, 16#A64B#),
           ((2078, 2078), (0, 0), (0, 0), (2078, 2078)), 0, 0),
         16#4B#           =>  --  A64B
          ((16#0000#, 16#A64A#, 16#A64A#, 16#0000#),
           ((0, 0), (2079, 2079), (2079, 2079), (0, 0)), 0, 0),
         16#4C#           =>  --  A64C
          ((16#A64D#, 16#0000#, 16#0000#, 16#A64D#),
           ((2080, 2080), (0, 0), (0, 0), (2080, 2080)), 0, 0),
         16#4D#           =>  --  A64D
          ((16#0000#, 16#A64C#, 16#A64C#, 16#0000#),
           ((0, 0), (2081, 2081), (2081, 2081), (0, 0)), 0, 0),
         16#4E#           =>  --  A64E
          ((16#A64F#, 16#0000#, 16#0000#, 16#A64F#),
           ((2082, 2082), (0, 0), (0, 0), (2082, 2082)), 0, 0),
         16#4F#           =>  --  A64F
          ((16#0000#, 16#A64E#, 16#A64E#, 16#0000#),
           ((0, 0), (2083, 2083), (2083, 2083), (0, 0)), 0, 0),
         16#50#           =>  --  A650
          ((16#A651#, 16#0000#, 16#0000#, 16#A651#),
           ((2084, 2084), (0, 0), (0, 0), (2084, 2084)), 0, 0),
         16#51#           =>  --  A651
          ((16#0000#, 16#A650#, 16#A650#, 16#0000#),
           ((0, 0), (2085, 2085), (2085, 2085), (0, 0)), 0, 0),
         16#52#           =>  --  A652
          ((16#A653#, 16#0000#, 16#0000#, 16#A653#),
           ((2086, 2086), (0, 0), (0, 0), (2086, 2086)), 0, 0),
         16#53#           =>  --  A653
          ((16#0000#, 16#A652#, 16#A652#, 16#0000#),
           ((0, 0), (2087, 2087), (2087, 2087), (0, 0)), 0, 0),
         16#54#           =>  --  A654
          ((16#A655#, 16#0000#, 16#0000#, 16#A655#),
           ((2088, 2088), (0, 0), (0, 0), (2088, 2088)), 0, 0),
         16#55#           =>  --  A655
          ((16#0000#, 16#A654#, 16#A654#, 16#0000#),
           ((0, 0), (2089, 2089), (2089, 2089), (0, 0)), 0, 0),
         16#56#           =>  --  A656
          ((16#A657#, 16#0000#, 16#0000#, 16#A657#),
           ((2090, 2090), (0, 0), (0, 0), (2090, 2090)), 0, 0),
         16#57#           =>  --  A657
          ((16#0000#, 16#A656#, 16#A656#, 16#0000#),
           ((0, 0), (2091, 2091), (2091, 2091), (0, 0)), 0, 0),
         16#58#           =>  --  A658
          ((16#A659#, 16#0000#, 16#0000#, 16#A659#),
           ((2092, 2092), (0, 0), (0, 0), (2092, 2092)), 0, 0),
         16#59#           =>  --  A659
          ((16#0000#, 16#A658#, 16#A658#, 16#0000#),
           ((0, 0), (2093, 2093), (2093, 2093), (0, 0)), 0, 0),
         16#5A#           =>  --  A65A
          ((16#A65B#, 16#0000#, 16#0000#, 16#A65B#),
           ((2094, 2094), (0, 0), (0, 0), (2094, 2094)), 0, 0),
         16#5B#           =>  --  A65B
          ((16#0000#, 16#A65A#, 16#A65A#, 16#0000#),
           ((0, 0), (2095, 2095), (2095, 2095), (0, 0)), 0, 0),
         16#5C#           =>  --  A65C
          ((16#A65D#, 16#0000#, 16#0000#, 16#A65D#),
           ((2096, 2096), (0, 0), (0, 0), (2096, 2096)), 0, 0),
         16#5D#           =>  --  A65D
          ((16#0000#, 16#A65C#, 16#A65C#, 16#0000#),
           ((0, 0), (2097, 2097), (2097, 2097), (0, 0)), 0, 0),
         16#5E#           =>  --  A65E
          ((16#A65F#, 16#0000#, 16#0000#, 16#A65F#),
           ((2098, 2098), (0, 0), (0, 0), (2098, 2098)), 0, 0),
         16#5F#           =>  --  A65F
          ((16#0000#, 16#A65E#, 16#A65E#, 16#0000#),
           ((0, 0), (2099, 2099), (2099, 2099), (0, 0)), 0, 0),
         16#60#           =>  --  A660
          ((16#A661#, 16#0000#, 16#0000#, 16#A661#),
           ((2100, 2100), (0, 0), (0, 0), (2100, 2100)), 0, 0),
         16#61#           =>  --  A661
          ((16#0000#, 16#A660#, 16#A660#, 16#0000#),
           ((0, 0), (2101, 2101), (2101, 2101), (0, 0)), 0, 0),
         16#62#           =>  --  A662
          ((16#A663#, 16#0000#, 16#0000#, 16#A663#),
           ((2102, 2102), (0, 0), (0, 0), (2102, 2102)), 0, 0),
         16#63#           =>  --  A663
          ((16#0000#, 16#A662#, 16#A662#, 16#0000#),
           ((0, 0), (2103, 2103), (2103, 2103), (0, 0)), 0, 0),
         16#64#           =>  --  A664
          ((16#A665#, 16#0000#, 16#0000#, 16#A665#),
           ((2104, 2104), (0, 0), (0, 0), (2104, 2104)), 0, 0),
         16#65#           =>  --  A665
          ((16#0000#, 16#A664#, 16#A664#, 16#0000#),
           ((0, 0), (2105, 2105), (2105, 2105), (0, 0)), 0, 0),
         16#66#           =>  --  A666
          ((16#A667#, 16#0000#, 16#0000#, 16#A667#),
           ((2106, 2106), (0, 0), (0, 0), (2106, 2106)), 0, 0),
         16#67#           =>  --  A667
          ((16#0000#, 16#A666#, 16#A666#, 16#0000#),
           ((0, 0), (2107, 2107), (2107, 2107), (0, 0)), 0, 0),
         16#68#           =>  --  A668
          ((16#A669#, 16#0000#, 16#0000#, 16#A669#),
           ((2108, 2108), (0, 0), (0, 0), (2108, 2108)), 0, 0),
         16#69#           =>  --  A669
          ((16#0000#, 16#A668#, 16#A668#, 16#0000#),
           ((0, 0), (2109, 2109), (2109, 2109), (0, 0)), 0, 0),
         16#6A#           =>  --  A66A
          ((16#A66B#, 16#0000#, 16#0000#, 16#A66B#),
           ((2110, 2110), (0, 0), (0, 0), (2110, 2110)), 0, 0),
         16#6B#           =>  --  A66B
          ((16#0000#, 16#A66A#, 16#A66A#, 16#0000#),
           ((0, 0), (2111, 2111), (2111, 2111), (0, 0)), 0, 0),
         16#6C#           =>  --  A66C
          ((16#A66D#, 16#0000#, 16#0000#, 16#A66D#),
           ((2112, 2112), (0, 0), (0, 0), (2112, 2112)), 0, 0),
         16#6D#           =>  --  A66D
          ((16#0000#, 16#A66C#, 16#A66C#, 16#0000#),
           ((0, 0), (2113, 2113), (2113, 2113), (0, 0)), 0, 0),
         16#80#           =>  --  A680
          ((16#A681#, 16#0000#, 16#0000#, 16#A681#),
           ((2114, 2114), (0, 0), (0, 0), (2114, 2114)), 0, 0),
         16#81#           =>  --  A681
          ((16#0000#, 16#A680#, 16#A680#, 16#0000#),
           ((0, 0), (2115, 2115), (2115, 2115), (0, 0)), 0, 0),
         16#82#           =>  --  A682
          ((16#A683#, 16#0000#, 16#0000#, 16#A683#),
           ((2116, 2116), (0, 0), (0, 0), (2116, 2116)), 0, 0),
         16#83#           =>  --  A683
          ((16#0000#, 16#A682#, 16#A682#, 16#0000#),
           ((0, 0), (2117, 2117), (2117, 2117), (0, 0)), 0, 0),
         16#84#           =>  --  A684
          ((16#A685#, 16#0000#, 16#0000#, 16#A685#),
           ((2118, 2118), (0, 0), (0, 0), (2118, 2118)), 0, 0),
         16#85#           =>  --  A685
          ((16#0000#, 16#A684#, 16#A684#, 16#0000#),
           ((0, 0), (2119, 2119), (2119, 2119), (0, 0)), 0, 0),
         16#86#           =>  --  A686
          ((16#A687#, 16#0000#, 16#0000#, 16#A687#),
           ((2120, 2120), (0, 0), (0, 0), (2120, 2120)), 0, 0),
         16#87#           =>  --  A687
          ((16#0000#, 16#A686#, 16#A686#, 16#0000#),
           ((0, 0), (2121, 2121), (2121, 2121), (0, 0)), 0, 0),
         16#88#           =>  --  A688
          ((16#A689#, 16#0000#, 16#0000#, 16#A689#),
           ((2122, 2122), (0, 0), (0, 0), (2122, 2122)), 0, 0),
         16#89#           =>  --  A689
          ((16#0000#, 16#A688#, 16#A688#, 16#0000#),
           ((0, 0), (2123, 2123), (2123, 2123), (0, 0)), 0, 0),
         16#8A#           =>  --  A68A
          ((16#A68B#, 16#0000#, 16#0000#, 16#A68B#),
           ((2124, 2124), (0, 0), (0, 0), (2124, 2124)), 0, 0),
         16#8B#           =>  --  A68B
          ((16#0000#, 16#A68A#, 16#A68A#, 16#0000#),
           ((0, 0), (2125, 2125), (2125, 2125), (0, 0)), 0, 0),
         16#8C#           =>  --  A68C
          ((16#A68D#, 16#0000#, 16#0000#, 16#A68D#),
           ((2126, 2126), (0, 0), (0, 0), (2126, 2126)), 0, 0),
         16#8D#           =>  --  A68D
          ((16#0000#, 16#A68C#, 16#A68C#, 16#0000#),
           ((0, 0), (2127, 2127), (2127, 2127), (0, 0)), 0, 0),
         16#8E#           =>  --  A68E
          ((16#A68F#, 16#0000#, 16#0000#, 16#A68F#),
           ((2128, 2128), (0, 0), (0, 0), (2128, 2128)), 0, 0),
         16#8F#           =>  --  A68F
          ((16#0000#, 16#A68E#, 16#A68E#, 16#0000#),
           ((0, 0), (2129, 2129), (2129, 2129), (0, 0)), 0, 0),
         16#90#           =>  --  A690
          ((16#A691#, 16#0000#, 16#0000#, 16#A691#),
           ((2130, 2130), (0, 0), (0, 0), (2130, 2130)), 0, 0),
         16#91#           =>  --  A691
          ((16#0000#, 16#A690#, 16#A690#, 16#0000#),
           ((0, 0), (2131, 2131), (2131, 2131), (0, 0)), 0, 0),
         16#92#           =>  --  A692
          ((16#A693#, 16#0000#, 16#0000#, 16#A693#),
           ((2132, 2132), (0, 0), (0, 0), (2132, 2132)), 0, 0),
         16#93#           =>  --  A693
          ((16#0000#, 16#A692#, 16#A692#, 16#0000#),
           ((0, 0), (2133, 2133), (2133, 2133), (0, 0)), 0, 0),
         16#94#           =>  --  A694
          ((16#A695#, 16#0000#, 16#0000#, 16#A695#),
           ((2134, 2134), (0, 0), (0, 0), (2134, 2134)), 0, 0),
         16#95#           =>  --  A695
          ((16#0000#, 16#A694#, 16#A694#, 16#0000#),
           ((0, 0), (2135, 2135), (2135, 2135), (0, 0)), 0, 0),
         16#96#           =>  --  A696
          ((16#A697#, 16#0000#, 16#0000#, 16#A697#),
           ((2136, 2136), (0, 0), (0, 0), (2136, 2136)), 0, 0),
         16#97#           =>  --  A697
          ((16#0000#, 16#A696#, 16#A696#, 16#0000#),
           ((0, 0), (2137, 2137), (2137, 2137), (0, 0)), 0, 0),
         16#98#           =>  --  A698
          ((16#A699#, 16#0000#, 16#0000#, 16#A699#),
           ((2138, 2138), (0, 0), (0, 0), (2138, 2138)), 0, 0),
         16#99#           =>  --  A699
          ((16#0000#, 16#A698#, 16#A698#, 16#0000#),
           ((0, 0), (2139, 2139), (2139, 2139), (0, 0)), 0, 0),
         16#9A#           =>  --  A69A
          ((16#A69B#, 16#0000#, 16#0000#, 16#A69B#),
           ((2140, 2140), (0, 0), (0, 0), (2140, 2140)), 0, 0),
         16#9B#           =>  --  A69B
          ((16#0000#, 16#A69A#, 16#A69A#, 16#0000#),
           ((0, 0), (2141, 2141), (2141, 2141), (0, 0)), 0, 0),
         others           =>
          ((16#0000#, 16#0000#, 16#0000#, 16#0000#),
           ((0, 0), (0, 0), (0, 0), (0, 0)), 0, 0));

   Group_00A7 : aliased constant Case_Mapping_Second_Stage
     := (16#22#           =>  --  A722
          ((16#A723#, 16#0000#, 16#0000#, 16#A723#),
           ((2142, 2142), (0, 0), (0, 0), (2142, 2142)), 0, 0),
         16#23#           =>  --  A723
          ((16#0000#, 16#A722#, 16#A722#, 16#0000#),
           ((0, 0), (2143, 2143), (2143, 2143), (0, 0)), 0, 0),
         16#24#           =>  --  A724
          ((16#A725#, 16#0000#, 16#0000#, 16#A725#),
           ((2144, 2144), (0, 0), (0, 0), (2144, 2144)), 0, 0),
         16#25#           =>  --  A725
          ((16#0000#, 16#A724#, 16#A724#, 16#0000#),
           ((0, 0), (2145, 2145), (2145, 2145), (0, 0)), 0, 0),
         16#26#           =>  --  A726
          ((16#A727#, 16#0000#, 16#0000#, 16#A727#),
           ((2146, 2146), (0, 0), (0, 0), (2146, 2146)), 0, 0),
         16#27#           =>  --  A727
          ((16#0000#, 16#A726#, 16#A726#, 16#0000#),
           ((0, 0), (2147, 2147), (2147, 2147), (0, 0)), 0, 0),
         16#28#           =>  --  A728
          ((16#A729#, 16#0000#, 16#0000#, 16#A729#),
           ((2148, 2148), (0, 0), (0, 0), (2148, 2148)), 0, 0),
         16#29#           =>  --  A729
          ((16#0000#, 16#A728#, 16#A728#, 16#0000#),
           ((0, 0), (2149, 2149), (2149, 2149), (0, 0)), 0, 0),
         16#2A#           =>  --  A72A
          ((16#A72B#, 16#0000#, 16#0000#, 16#A72B#),
           ((2150, 2150), (0, 0), (0, 0), (2150, 2150)), 0, 0),
         16#2B#           =>  --  A72B
          ((16#0000#, 16#A72A#, 16#A72A#, 16#0000#),
           ((0, 0), (2151, 2151), (2151, 2151), (0, 0)), 0, 0),
         16#2C#           =>  --  A72C
          ((16#A72D#, 16#0000#, 16#0000#, 16#A72D#),
           ((2152, 2152), (0, 0), (0, 0), (2152, 2152)), 0, 0),
         16#2D#           =>  --  A72D
          ((16#0000#, 16#A72C#, 16#A72C#, 16#0000#),
           ((0, 0), (2153, 2153), (2153, 2153), (0, 0)), 0, 0),
         16#2E#           =>  --  A72E
          ((16#A72F#, 16#0000#, 16#0000#, 16#A72F#),
           ((2154, 2154), (0, 0), (0, 0), (2154, 2154)), 0, 0),
         16#2F#           =>  --  A72F
          ((16#0000#, 16#A72E#, 16#A72E#, 16#0000#),
           ((0, 0), (2155, 2155), (2155, 2155), (0, 0)), 0, 0),
         16#32#           =>  --  A732
          ((16#A733#, 16#0000#, 16#0000#, 16#A733#),
           ((2156, 2156), (0, 0), (0, 0), (2156, 2156)), 0, 0),
         16#33#           =>  --  A733
          ((16#0000#, 16#A732#, 16#A732#, 16#0000#),
           ((0, 0), (2157, 2157), (2157, 2157), (0, 0)), 0, 0),
         16#34#           =>  --  A734
          ((16#A735#, 16#0000#, 16#0000#, 16#A735#),
           ((2158, 2158), (0, 0), (0, 0), (2158, 2158)), 0, 0),
         16#35#           =>  --  A735
          ((16#0000#, 16#A734#, 16#A734#, 16#0000#),
           ((0, 0), (2159, 2159), (2159, 2159), (0, 0)), 0, 0),
         16#36#           =>  --  A736
          ((16#A737#, 16#0000#, 16#0000#, 16#A737#),
           ((2160, 2160), (0, 0), (0, 0), (2160, 2160)), 0, 0),
         16#37#           =>  --  A737
          ((16#0000#, 16#A736#, 16#A736#, 16#0000#),
           ((0, 0), (2161, 2161), (2161, 2161), (0, 0)), 0, 0),
         16#38#           =>  --  A738
          ((16#A739#, 16#0000#, 16#0000#, 16#A739#),
           ((2162, 2162), (0, 0), (0, 0), (2162, 2162)), 0, 0),
         16#39#           =>  --  A739
          ((16#0000#, 16#A738#, 16#A738#, 16#0000#),
           ((0, 0), (2163, 2163), (2163, 2163), (0, 0)), 0, 0),
         16#3A#           =>  --  A73A
          ((16#A73B#, 16#0000#, 16#0000#, 16#A73B#),
           ((2164, 2164), (0, 0), (0, 0), (2164, 2164)), 0, 0),
         16#3B#           =>  --  A73B
          ((16#0000#, 16#A73A#, 16#A73A#, 16#0000#),
           ((0, 0), (2165, 2165), (2165, 2165), (0, 0)), 0, 0),
         16#3C#           =>  --  A73C
          ((16#A73D#, 16#0000#, 16#0000#, 16#A73D#),
           ((2166, 2166), (0, 0), (0, 0), (2166, 2166)), 0, 0),
         16#3D#           =>  --  A73D
          ((16#0000#, 16#A73C#, 16#A73C#, 16#0000#),
           ((0, 0), (2167, 2167), (2167, 2167), (0, 0)), 0, 0),
         16#3E#           =>  --  A73E
          ((16#A73F#, 16#0000#, 16#0000#, 16#A73F#),
           ((2168, 2168), (0, 0), (0, 0), (2168, 2168)), 0, 0),
         16#3F#           =>  --  A73F
          ((16#0000#, 16#A73E#, 16#A73E#, 16#0000#),
           ((0, 0), (2169, 2169), (2169, 2169), (0, 0)), 0, 0),
         16#40#           =>  --  A740
          ((16#A741#, 16#0000#, 16#0000#, 16#A741#),
           ((2170, 2170), (0, 0), (0, 0), (2170, 2170)), 0, 0),
         16#41#           =>  --  A741
          ((16#0000#, 16#A740#, 16#A740#, 16#0000#),
           ((0, 0), (2171, 2171), (2171, 2171), (0, 0)), 0, 0),
         16#42#           =>  --  A742
          ((16#A743#, 16#0000#, 16#0000#, 16#A743#),
           ((2172, 2172), (0, 0), (0, 0), (2172, 2172)), 0, 0),
         16#43#           =>  --  A743
          ((16#0000#, 16#A742#, 16#A742#, 16#0000#),
           ((0, 0), (2173, 2173), (2173, 2173), (0, 0)), 0, 0),
         16#44#           =>  --  A744
          ((16#A745#, 16#0000#, 16#0000#, 16#A745#),
           ((2174, 2174), (0, 0), (0, 0), (2174, 2174)), 0, 0),
         16#45#           =>  --  A745
          ((16#0000#, 16#A744#, 16#A744#, 16#0000#),
           ((0, 0), (2175, 2175), (2175, 2175), (0, 0)), 0, 0),
         16#46#           =>  --  A746
          ((16#A747#, 16#0000#, 16#0000#, 16#A747#),
           ((2176, 2176), (0, 0), (0, 0), (2176, 2176)), 0, 0),
         16#47#           =>  --  A747
          ((16#0000#, 16#A746#, 16#A746#, 16#0000#),
           ((0, 0), (2177, 2177), (2177, 2177), (0, 0)), 0, 0),
         16#48#           =>  --  A748
          ((16#A749#, 16#0000#, 16#0000#, 16#A749#),
           ((2178, 2178), (0, 0), (0, 0), (2178, 2178)), 0, 0),
         16#49#           =>  --  A749
          ((16#0000#, 16#A748#, 16#A748#, 16#0000#),
           ((0, 0), (2179, 2179), (2179, 2179), (0, 0)), 0, 0),
         16#4A#           =>  --  A74A
          ((16#A74B#, 16#0000#, 16#0000#, 16#A74B#),
           ((2180, 2180), (0, 0), (0, 0), (2180, 2180)), 0, 0),
         16#4B#           =>  --  A74B
          ((16#0000#, 16#A74A#, 16#A74A#, 16#0000#),
           ((0, 0), (2181, 2181), (2181, 2181), (0, 0)), 0, 0),
         16#4C#           =>  --  A74C
          ((16#A74D#, 16#0000#, 16#0000#, 16#A74D#),
           ((2182, 2182), (0, 0), (0, 0), (2182, 2182)), 0, 0),
         16#4D#           =>  --  A74D
          ((16#0000#, 16#A74C#, 16#A74C#, 16#0000#),
           ((0, 0), (2183, 2183), (2183, 2183), (0, 0)), 0, 0),
         16#4E#           =>  --  A74E
          ((16#A74F#, 16#0000#, 16#0000#, 16#A74F#),
           ((2184, 2184), (0, 0), (0, 0), (2184, 2184)), 0, 0),
         16#4F#           =>  --  A74F
          ((16#0000#, 16#A74E#, 16#A74E#, 16#0000#),
           ((0, 0), (2185, 2185), (2185, 2185), (0, 0)), 0, 0),
         16#50#           =>  --  A750
          ((16#A751#, 16#0000#, 16#0000#, 16#A751#),
           ((2186, 2186), (0, 0), (0, 0), (2186, 2186)), 0, 0),
         16#51#           =>  --  A751
          ((16#0000#, 16#A750#, 16#A750#, 16#0000#),
           ((0, 0), (2187, 2187), (2187, 2187), (0, 0)), 0, 0),
         16#52#           =>  --  A752
          ((16#A753#, 16#0000#, 16#0000#, 16#A753#),
           ((2188, 2188), (0, 0), (0, 0), (2188, 2188)), 0, 0),
         16#53#           =>  --  A753
          ((16#0000#, 16#A752#, 16#A752#, 16#0000#),
           ((0, 0), (2189, 2189), (2189, 2189), (0, 0)), 0, 0),
         16#54#           =>  --  A754
          ((16#A755#, 16#0000#, 16#0000#, 16#A755#),
           ((2190, 2190), (0, 0), (0, 0), (2190, 2190)), 0, 0),
         16#55#           =>  --  A755
          ((16#0000#, 16#A754#, 16#A754#, 16#0000#),
           ((0, 0), (2191, 2191), (2191, 2191), (0, 0)), 0, 0),
         16#56#           =>  --  A756
          ((16#A757#, 16#0000#, 16#0000#, 16#A757#),
           ((2192, 2192), (0, 0), (0, 0), (2192, 2192)), 0, 0),
         16#57#           =>  --  A757
          ((16#0000#, 16#A756#, 16#A756#, 16#0000#),
           ((0, 0), (2193, 2193), (2193, 2193), (0, 0)), 0, 0),
         16#58#           =>  --  A758
          ((16#A759#, 16#0000#, 16#0000#, 16#A759#),
           ((2194, 2194), (0, 0), (0, 0), (2194, 2194)), 0, 0),
         16#59#           =>  --  A759
          ((16#0000#, 16#A758#, 16#A758#, 16#0000#),
           ((0, 0), (2195, 2195), (2195, 2195), (0, 0)), 0, 0),
         16#5A#           =>  --  A75A
          ((16#A75B#, 16#0000#, 16#0000#, 16#A75B#),
           ((2196, 2196), (0, 0), (0, 0), (2196, 2196)), 0, 0),
         16#5B#           =>  --  A75B
          ((16#0000#, 16#A75A#, 16#A75A#, 16#0000#),
           ((0, 0), (2197, 2197), (2197, 2197), (0, 0)), 0, 0),
         16#5C#           =>  --  A75C
          ((16#A75D#, 16#0000#, 16#0000#, 16#A75D#),
           ((2198, 2198), (0, 0), (0, 0), (2198, 2198)), 0, 0),
         16#5D#           =>  --  A75D
          ((16#0000#, 16#A75C#, 16#A75C#, 16#0000#),
           ((0, 0), (2199, 2199), (2199, 2199), (0, 0)), 0, 0),
         16#5E#           =>  --  A75E
          ((16#A75F#, 16#0000#, 16#0000#, 16#A75F#),
           ((2200, 2200), (0, 0), (0, 0), (2200, 2200)), 0, 0),
         16#5F#           =>  --  A75F
          ((16#0000#, 16#A75E#, 16#A75E#, 16#0000#),
           ((0, 0), (2201, 2201), (2201, 2201), (0, 0)), 0, 0),
         16#60#           =>  --  A760
          ((16#A761#, 16#0000#, 16#0000#, 16#A761#),
           ((2202, 2202), (0, 0), (0, 0), (2202, 2202)), 0, 0),
         16#61#           =>  --  A761
          ((16#0000#, 16#A760#, 16#A760#, 16#0000#),
           ((0, 0), (2203, 2203), (2203, 2203), (0, 0)), 0, 0),
         16#62#           =>  --  A762
          ((16#A763#, 16#0000#, 16#0000#, 16#A763#),
           ((2204, 2204), (0, 0), (0, 0), (2204, 2204)), 0, 0),
         16#63#           =>  --  A763
          ((16#0000#, 16#A762#, 16#A762#, 16#0000#),
           ((0, 0), (2205, 2205), (2205, 2205), (0, 0)), 0, 0),
         16#64#           =>  --  A764
          ((16#A765#, 16#0000#, 16#0000#, 16#A765#),
           ((2206, 2206), (0, 0), (0, 0), (2206, 2206)), 0, 0),
         16#65#           =>  --  A765
          ((16#0000#, 16#A764#, 16#A764#, 16#0000#),
           ((0, 0), (2207, 2207), (2207, 2207), (0, 0)), 0, 0),
         16#66#           =>  --  A766
          ((16#A767#, 16#0000#, 16#0000#, 16#A767#),
           ((2208, 2208), (0, 0), (0, 0), (2208, 2208)), 0, 0),
         16#67#           =>  --  A767
          ((16#0000#, 16#A766#, 16#A766#, 16#0000#),
           ((0, 0), (2209, 2209), (2209, 2209), (0, 0)), 0, 0),
         16#68#           =>  --  A768
          ((16#A769#, 16#0000#, 16#0000#, 16#A769#),
           ((2210, 2210), (0, 0), (0, 0), (2210, 2210)), 0, 0),
         16#69#           =>  --  A769
          ((16#0000#, 16#A768#, 16#A768#, 16#0000#),
           ((0, 0), (2211, 2211), (2211, 2211), (0, 0)), 0, 0),
         16#6A#           =>  --  A76A
          ((16#A76B#, 16#0000#, 16#0000#, 16#A76B#),
           ((2212, 2212), (0, 0), (0, 0), (2212, 2212)), 0, 0),
         16#6B#           =>  --  A76B
          ((16#0000#, 16#A76A#, 16#A76A#, 16#0000#),
           ((0, 0), (2213, 2213), (2213, 2213), (0, 0)), 0, 0),
         16#6C#           =>  --  A76C
          ((16#A76D#, 16#0000#, 16#0000#, 16#A76D#),
           ((2214, 2214), (0, 0), (0, 0), (2214, 2214)), 0, 0),
         16#6D#           =>  --  A76D
          ((16#0000#, 16#A76C#, 16#A76C#, 16#0000#),
           ((0, 0), (2215, 2215), (2215, 2215), (0, 0)), 0, 0),
         16#6E#           =>  --  A76E
          ((16#A76F#, 16#0000#, 16#0000#, 16#A76F#),
           ((2216, 2216), (0, 0), (0, 0), (2216, 2216)), 0, 0),
         16#6F#           =>  --  A76F
          ((16#0000#, 16#A76E#, 16#A76E#, 16#0000#),
           ((0, 0), (2217, 2217), (2217, 2217), (0, 0)), 0, 0),
         16#79#           =>  --  A779
          ((16#A77A#, 16#0000#, 16#0000#, 16#A77A#),
           ((2218, 2218), (0, 0), (0, 0), (2218, 2218)), 0, 0),
         16#7A#           =>  --  A77A
          ((16#0000#, 16#A779#, 16#A779#, 16#0000#),
           ((0, 0), (2219, 2219), (2219, 2219), (0, 0)), 0, 0),
         16#7B#           =>  --  A77B
          ((16#A77C#, 16#0000#, 16#0000#, 16#A77C#),
           ((2220, 2220), (0, 0), (0, 0), (2220, 2220)), 0, 0),
         16#7C#           =>  --  A77C
          ((16#0000#, 16#A77B#, 16#A77B#, 16#0000#),
           ((0, 0), (2221, 2221), (2221, 2221), (0, 0)), 0, 0),
         16#7D#           =>  --  A77D
          ((16#1D79#, 16#0000#, 16#0000#, 16#1D79#),
           ((2222, 2222), (0, 0), (0, 0), (2222, 2222)), 0, 0),
         16#7E#           =>  --  A77E
          ((16#A77F#, 16#0000#, 16#0000#, 16#A77F#),
           ((2223, 2223), (0, 0), (0, 0), (2223, 2223)), 0, 0),
         16#7F#           =>  --  A77F
          ((16#0000#, 16#A77E#, 16#A77E#, 16#0000#),
           ((0, 0), (2224, 2224), (2224, 2224), (0, 0)), 0, 0),
         16#80#           =>  --  A780
          ((16#A781#, 16#0000#, 16#0000#, 16#A781#),
           ((2225, 2225), (0, 0), (0, 0), (2225, 2225)), 0, 0),
         16#81#           =>  --  A781
          ((16#0000#, 16#A780#, 16#A780#, 16#0000#),
           ((0, 0), (2226, 2226), (2226, 2226), (0, 0)), 0, 0),
         16#82#           =>  --  A782
          ((16#A783#, 16#0000#, 16#0000#, 16#A783#),
           ((2227, 2227), (0, 0), (0, 0), (2227, 2227)), 0, 0),
         16#83#           =>  --  A783
          ((16#0000#, 16#A782#, 16#A782#, 16#0000#),
           ((0, 0), (2228, 2228), (2228, 2228), (0, 0)), 0, 0),
         16#84#           =>  --  A784
          ((16#A785#, 16#0000#, 16#0000#, 16#A785#),
           ((2229, 2229), (0, 0), (0, 0), (2229, 2229)), 0, 0),
         16#85#           =>  --  A785
          ((16#0000#, 16#A784#, 16#A784#, 16#0000#),
           ((0, 0), (2230, 2230), (2230, 2230), (0, 0)), 0, 0),
         16#86#           =>  --  A786
          ((16#A787#, 16#0000#, 16#0000#, 16#A787#),
           ((2231, 2231), (0, 0), (0, 0), (2231, 2231)), 0, 0),
         16#87#           =>  --  A787
          ((16#0000#, 16#A786#, 16#A786#, 16#0000#),
           ((0, 0), (2232, 2232), (2232, 2232), (0, 0)), 0, 0),
         16#8B#           =>  --  A78B
          ((16#A78C#, 16#0000#, 16#0000#, 16#A78C#),
           ((2233, 2233), (0, 0), (0, 0), (2233, 2233)), 0, 0),
         16#8C#           =>  --  A78C
          ((16#0000#, 16#A78B#, 16#A78B#, 16#0000#),
           ((0, 0), (2234, 2234), (2234, 2234), (0, 0)), 0, 0),
         16#8D#           =>  --  A78D
          ((16#0265#, 16#0000#, 16#0000#, 16#0265#),
           ((2235, 2235), (0, 0), (0, 0), (2235, 2235)), 0, 0),
         16#90#           =>  --  A790
          ((16#A791#, 16#0000#, 16#0000#, 16#A791#),
           ((2236, 2236), (0, 0), (0, 0), (2236, 2236)), 0, 0),
         16#91#           =>  --  A791
          ((16#0000#, 16#A790#, 16#A790#, 16#0000#),
           ((0, 0), (2237, 2237), (2237, 2237), (0, 0)), 0, 0),
         16#92#           =>  --  A792
          ((16#A793#, 16#0000#, 16#0000#, 16#A793#),
           ((2238, 2238), (0, 0), (0, 0), (2238, 2238)), 0, 0),
         16#93#           =>  --  A793
          ((16#0000#, 16#A792#, 16#A792#, 16#0000#),
           ((0, 0), (2239, 2239), (2239, 2239), (0, 0)), 0, 0),
         16#96#           =>  --  A796
          ((16#A797#, 16#0000#, 16#0000#, 16#A797#),
           ((2240, 2240), (0, 0), (0, 0), (2240, 2240)), 0, 0),
         16#97#           =>  --  A797
          ((16#0000#, 16#A796#, 16#A796#, 16#0000#),
           ((0, 0), (2241, 2241), (2241, 2241), (0, 0)), 0, 0),
         16#98#           =>  --  A798
          ((16#A799#, 16#0000#, 16#0000#, 16#A799#),
           ((2242, 2242), (0, 0), (0, 0), (2242, 2242)), 0, 0),
         16#99#           =>  --  A799
          ((16#0000#, 16#A798#, 16#A798#, 16#0000#),
           ((0, 0), (2243, 2243), (2243, 2243), (0, 0)), 0, 0),
         16#9A#           =>  --  A79A
          ((16#A79B#, 16#0000#, 16#0000#, 16#A79B#),
           ((2244, 2244), (0, 0), (0, 0), (2244, 2244)), 0, 0),
         16#9B#           =>  --  A79B
          ((16#0000#, 16#A79A#, 16#A79A#, 16#0000#),
           ((0, 0), (2245, 2245), (2245, 2245), (0, 0)), 0, 0),
         16#9C#           =>  --  A79C
          ((16#A79D#, 16#0000#, 16#0000#, 16#A79D#),
           ((2246, 2246), (0, 0), (0, 0), (2246, 2246)), 0, 0),
         16#9D#           =>  --  A79D
          ((16#0000#, 16#A79C#, 16#A79C#, 16#0000#),
           ((0, 0), (2247, 2247), (2247, 2247), (0, 0)), 0, 0),
         16#9E#           =>  --  A79E
          ((16#A79F#, 16#0000#, 16#0000#, 16#A79F#),
           ((2248, 2248), (0, 0), (0, 0), (2248, 2248)), 0, 0),
         16#9F#           =>  --  A79F
          ((16#0000#, 16#A79E#, 16#A79E#, 16#0000#),
           ((0, 0), (2249, 2249), (2249, 2249), (0, 0)), 0, 0),
         16#A0#           =>  --  A7A0
          ((16#A7A1#, 16#0000#, 16#0000#, 16#A7A1#),
           ((2250, 2250), (0, 0), (0, 0), (2250, 2250)), 0, 0),
         16#A1#           =>  --  A7A1
          ((16#0000#, 16#A7A0#, 16#A7A0#, 16#0000#),
           ((0, 0), (2251, 2251), (2251, 2251), (0, 0)), 0, 0),
         16#A2#           =>  --  A7A2
          ((16#A7A3#, 16#0000#, 16#0000#, 16#A7A3#),
           ((2252, 2252), (0, 0), (0, 0), (2252, 2252)), 0, 0),
         16#A3#           =>  --  A7A3
          ((16#0000#, 16#A7A2#, 16#A7A2#, 16#0000#),
           ((0, 0), (2253, 2253), (2253, 2253), (0, 0)), 0, 0),
         16#A4#           =>  --  A7A4
          ((16#A7A5#, 16#0000#, 16#0000#, 16#A7A5#),
           ((2254, 2254), (0, 0), (0, 0), (2254, 2254)), 0, 0),
         16#A5#           =>  --  A7A5
          ((16#0000#, 16#A7A4#, 16#A7A4#, 16#0000#),
           ((0, 0), (2255, 2255), (2255, 2255), (0, 0)), 0, 0),
         16#A6#           =>  --  A7A6
          ((16#A7A7#, 16#0000#, 16#0000#, 16#A7A7#),
           ((2256, 2256), (0, 0), (0, 0), (2256, 2256)), 0, 0),
         16#A7#           =>  --  A7A7
          ((16#0000#, 16#A7A6#, 16#A7A6#, 16#0000#),
           ((0, 0), (2257, 2257), (2257, 2257), (0, 0)), 0, 0),
         16#A8#           =>  --  A7A8
          ((16#A7A9#, 16#0000#, 16#0000#, 16#A7A9#),
           ((2258, 2258), (0, 0), (0, 0), (2258, 2258)), 0, 0),
         16#A9#           =>  --  A7A9
          ((16#0000#, 16#A7A8#, 16#A7A8#, 16#0000#),
           ((0, 0), (2259, 2259), (2259, 2259), (0, 0)), 0, 0),
         16#AA#           =>  --  A7AA
          ((16#0266#, 16#0000#, 16#0000#, 16#0266#),
           ((2260, 2260), (0, 0), (0, 0), (2260, 2260)), 0, 0),
         16#AB#           =>  --  A7AB
          ((16#025C#, 16#0000#, 16#0000#, 16#025C#),
           ((2261, 2261), (0, 0), (0, 0), (2261, 2261)), 0, 0),
         16#AC#           =>  --  A7AC
          ((16#0261#, 16#0000#, 16#0000#, 16#0261#),
           ((2262, 2262), (0, 0), (0, 0), (2262, 2262)), 0, 0),
         16#AD#           =>  --  A7AD
          ((16#026C#, 16#0000#, 16#0000#, 16#026C#),
           ((2263, 2263), (0, 0), (0, 0), (2263, 2263)), 0, 0),
         16#B0#           =>  --  A7B0
          ((16#029E#, 16#0000#, 16#0000#, 16#029E#),
           ((2264, 2264), (0, 0), (0, 0), (2264, 2264)), 0, 0),
         16#B1#           =>  --  A7B1
          ((16#0287#, 16#0000#, 16#0000#, 16#0287#),
           ((2265, 2265), (0, 0), (0, 0), (2265, 2265)), 0, 0),
         others           =>
          ((16#0000#, 16#0000#, 16#0000#, 16#0000#),
           ((0, 0), (0, 0), (0, 0), (0, 0)), 0, 0));

   Group_00FB : aliased constant Case_Mapping_Second_Stage
     := (16#00#           =>  --  FB00
          ((16#0000#, 16#0000#, 16#0000#, 16#0000#),
           ((0, 0), (2266, 2267), (2268, 2269), (2270, 2271)), 0, 0),
         16#01#           =>  --  FB01
          ((16#0000#, 16#0000#, 16#0000#, 16#0000#),
           ((0, 0), (2272, 2273), (2274, 2275), (2276, 2277)), 0, 0),
         16#02#           =>  --  FB02
          ((16#0000#, 16#0000#, 16#0000#, 16#0000#),
           ((0, 0), (2278, 2279), (2280, 2281), (2282, 2283)), 0, 0),
         16#03#           =>  --  FB03
          ((16#0000#, 16#0000#, 16#0000#, 16#0000#),
           ((0, 0), (2284, 2286), (2287, 2289), (2290, 2292)), 0, 0),
         16#04#           =>  --  FB04
          ((16#0000#, 16#0000#, 16#0000#, 16#0000#),
           ((0, 0), (2293, 2295), (2296, 2298), (2299, 2301)), 0, 0),
         16#05# .. 16#06# =>  --  FB05 .. FB06
          ((16#0000#, 16#0000#, 16#0000#, 16#0000#),
           ((0, 0), (2302, 2303), (45, 46), (19, 20)), 0, 0),
         16#13#           =>  --  FB13
          ((16#0000#, 16#0000#, 16#0000#, 16#0000#),
           ((0, 0), (2304, 2305), (2306, 2307), (2308, 2309)), 0, 0),
         16#14#           =>  --  FB14
          ((16#0000#, 16#0000#, 16#0000#, 16#0000#),
           ((0, 0), (2310, 2311), (2312, 2313), (2314, 2315)), 0, 0),
         16#15#           =>  --  FB15
          ((16#0000#, 16#0000#, 16#0000#, 16#0000#),
           ((0, 0), (2316, 2317), (2318, 2319), (2320, 2321)), 0, 0),
         16#16#           =>  --  FB16
          ((16#0000#, 16#0000#, 16#0000#, 16#0000#),
           ((0, 0), (2322, 2323), (2324, 2325), (2326, 2327)), 0, 0),
         16#17#           =>  --  FB17
          ((16#0000#, 16#0000#, 16#0000#, 16#0000#),
           ((0, 0), (2328, 2329), (2330, 2331), (2332, 2333)), 0, 0),
         others           =>
          ((16#0000#, 16#0000#, 16#0000#, 16#0000#),
           ((0, 0), (0, 0), (0, 0), (0, 0)), 0, 0));

   Group_00FF : aliased constant Case_Mapping_Second_Stage
     := (16#21#           =>  --  FF21
          ((16#FF41#, 16#0000#, 16#0000#, 16#FF41#),
           ((2334, 2334), (0, 0), (0, 0), (2334, 2334)), 0, 0),
         16#22#           =>  --  FF22
          ((16#FF42#, 16#0000#, 16#0000#, 16#FF42#),
           ((2335, 2335), (0, 0), (0, 0), (2335, 2335)), 0, 0),
         16#23#           =>  --  FF23
          ((16#FF43#, 16#0000#, 16#0000#, 16#FF43#),
           ((2336, 2336), (0, 0), (0, 0), (2336, 2336)), 0, 0),
         16#24#           =>  --  FF24
          ((16#FF44#, 16#0000#, 16#0000#, 16#FF44#),
           ((2337, 2337), (0, 0), (0, 0), (2337, 2337)), 0, 0),
         16#25#           =>  --  FF25
          ((16#FF45#, 16#0000#, 16#0000#, 16#FF45#),
           ((2338, 2338), (0, 0), (0, 0), (2338, 2338)), 0, 0),
         16#26#           =>  --  FF26
          ((16#FF46#, 16#0000#, 16#0000#, 16#FF46#),
           ((2339, 2339), (0, 0), (0, 0), (2339, 2339)), 0, 0),
         16#27#           =>  --  FF27
          ((16#FF47#, 16#0000#, 16#0000#, 16#FF47#),
           ((2340, 2340), (0, 0), (0, 0), (2340, 2340)), 0, 0),
         16#28#           =>  --  FF28
          ((16#FF48#, 16#0000#, 16#0000#, 16#FF48#),
           ((2341, 2341), (0, 0), (0, 0), (2341, 2341)), 0, 0),
         16#29#           =>  --  FF29
          ((16#FF49#, 16#0000#, 16#0000#, 16#FF49#),
           ((2342, 2342), (0, 0), (0, 0), (2342, 2342)), 0, 0),
         16#2A#           =>  --  FF2A
          ((16#FF4A#, 16#0000#, 16#0000#, 16#FF4A#),
           ((2343, 2343), (0, 0), (0, 0), (2343, 2343)), 0, 0),
         16#2B#           =>  --  FF2B
          ((16#FF4B#, 16#0000#, 16#0000#, 16#FF4B#),
           ((2344, 2344), (0, 0), (0, 0), (2344, 2344)), 0, 0),
         16#2C#           =>  --  FF2C
          ((16#FF4C#, 16#0000#, 16#0000#, 16#FF4C#),
           ((2345, 2345), (0, 0), (0, 0), (2345, 2345)), 0, 0),
         16#2D#           =>  --  FF2D
          ((16#FF4D#, 16#0000#, 16#0000#, 16#FF4D#),
           ((2346, 2346), (0, 0), (0, 0), (2346, 2346)), 0, 0),
         16#2E#           =>  --  FF2E
          ((16#FF4E#, 16#0000#, 16#0000#, 16#FF4E#),
           ((2347, 2347), (0, 0), (0, 0), (2347, 2347)), 0, 0),
         16#2F#           =>  --  FF2F
          ((16#FF4F#, 16#0000#, 16#0000#, 16#FF4F#),
           ((2348, 2348), (0, 0), (0, 0), (2348, 2348)), 0, 0),
         16#30#           =>  --  FF30
          ((16#FF50#, 16#0000#, 16#0000#, 16#FF50#),
           ((2349, 2349), (0, 0), (0, 0), (2349, 2349)), 0, 0),
         16#31#           =>  --  FF31
          ((16#FF51#, 16#0000#, 16#0000#, 16#FF51#),
           ((2350, 2350), (0, 0), (0, 0), (2350, 2350)), 0, 0),
         16#32#           =>  --  FF32
          ((16#FF52#, 16#0000#, 16#0000#, 16#FF52#),
           ((2351, 2351), (0, 0), (0, 0), (2351, 2351)), 0, 0),
         16#33#           =>  --  FF33
          ((16#FF53#, 16#0000#, 16#0000#, 16#FF53#),
           ((2352, 2352), (0, 0), (0, 0), (2352, 2352)), 0, 0),
         16#34#           =>  --  FF34
          ((16#FF54#, 16#0000#, 16#0000#, 16#FF54#),
           ((2353, 2353), (0, 0), (0, 0), (2353, 2353)), 0, 0),
         16#35#           =>  --  FF35
          ((16#FF55#, 16#0000#, 16#0000#, 16#FF55#),
           ((2354, 2354), (0, 0), (0, 0), (2354, 2354)), 0, 0),
         16#36#           =>  --  FF36
          ((16#FF56#, 16#0000#, 16#0000#, 16#FF56#),
           ((2355, 2355), (0, 0), (0, 0), (2355, 2355)), 0, 0),
         16#37#           =>  --  FF37
          ((16#FF57#, 16#0000#, 16#0000#, 16#FF57#),
           ((2356, 2356), (0, 0), (0, 0), (2356, 2356)), 0, 0),
         16#38#           =>  --  FF38
          ((16#FF58#, 16#0000#, 16#0000#, 16#FF58#),
           ((2357, 2357), (0, 0), (0, 0), (2357, 2357)), 0, 0),
         16#39#           =>  --  FF39
          ((16#FF59#, 16#0000#, 16#0000#, 16#FF59#),
           ((2358, 2358), (0, 0), (0, 0), (2358, 2358)), 0, 0),
         16#3A#           =>  --  FF3A
          ((16#FF5A#, 16#0000#, 16#0000#, 16#FF5A#),
           ((2359, 2359), (0, 0), (0, 0), (2359, 2359)), 0, 0),
         16#41#           =>  --  FF41
          ((16#0000#, 16#FF21#, 16#FF21#, 16#0000#),
           ((0, 0), (2360, 2360), (2360, 2360), (0, 0)), 0, 0),
         16#42#           =>  --  FF42
          ((16#0000#, 16#FF22#, 16#FF22#, 16#0000#),
           ((0, 0), (2361, 2361), (2361, 2361), (0, 0)), 0, 0),
         16#43#           =>  --  FF43
          ((16#0000#, 16#FF23#, 16#FF23#, 16#0000#),
           ((0, 0), (2362, 2362), (2362, 2362), (0, 0)), 0, 0),
         16#44#           =>  --  FF44
          ((16#0000#, 16#FF24#, 16#FF24#, 16#0000#),
           ((0, 0), (2363, 2363), (2363, 2363), (0, 0)), 0, 0),
         16#45#           =>  --  FF45
          ((16#0000#, 16#FF25#, 16#FF25#, 16#0000#),
           ((0, 0), (2364, 2364), (2364, 2364), (0, 0)), 0, 0),
         16#46#           =>  --  FF46
          ((16#0000#, 16#FF26#, 16#FF26#, 16#0000#),
           ((0, 0), (2365, 2365), (2365, 2365), (0, 0)), 0, 0),
         16#47#           =>  --  FF47
          ((16#0000#, 16#FF27#, 16#FF27#, 16#0000#),
           ((0, 0), (2366, 2366), (2366, 2366), (0, 0)), 0, 0),
         16#48#           =>  --  FF48
          ((16#0000#, 16#FF28#, 16#FF28#, 16#0000#),
           ((0, 0), (2367, 2367), (2367, 2367), (0, 0)), 0, 0),
         16#49#           =>  --  FF49
          ((16#0000#, 16#FF29#, 16#FF29#, 16#0000#),
           ((0, 0), (2368, 2368), (2368, 2368), (0, 0)), 0, 0),
         16#4A#           =>  --  FF4A
          ((16#0000#, 16#FF2A#, 16#FF2A#, 16#0000#),
           ((0, 0), (2369, 2369), (2369, 2369), (0, 0)), 0, 0),
         16#4B#           =>  --  FF4B
          ((16#0000#, 16#FF2B#, 16#FF2B#, 16#0000#),
           ((0, 0), (2370, 2370), (2370, 2370), (0, 0)), 0, 0),
         16#4C#           =>  --  FF4C
          ((16#0000#, 16#FF2C#, 16#FF2C#, 16#0000#),
           ((0, 0), (2371, 2371), (2371, 2371), (0, 0)), 0, 0),
         16#4D#           =>  --  FF4D
          ((16#0000#, 16#FF2D#, 16#FF2D#, 16#0000#),
           ((0, 0), (2372, 2372), (2372, 2372), (0, 0)), 0, 0),
         16#4E#           =>  --  FF4E
          ((16#0000#, 16#FF2E#, 16#FF2E#, 16#0000#),
           ((0, 0), (2373, 2373), (2373, 2373), (0, 0)), 0, 0),
         16#4F#           =>  --  FF4F
          ((16#0000#, 16#FF2F#, 16#FF2F#, 16#0000#),
           ((0, 0), (2374, 2374), (2374, 2374), (0, 0)), 0, 0),
         16#50#           =>  --  FF50
          ((16#0000#, 16#FF30#, 16#FF30#, 16#0000#),
           ((0, 0), (2375, 2375), (2375, 2375), (0, 0)), 0, 0),
         16#51#           =>  --  FF51
          ((16#0000#, 16#FF31#, 16#FF31#, 16#0000#),
           ((0, 0), (2376, 2376), (2376, 2376), (0, 0)), 0, 0),
         16#52#           =>  --  FF52
          ((16#0000#, 16#FF32#, 16#FF32#, 16#0000#),
           ((0, 0), (2377, 2377), (2377, 2377), (0, 0)), 0, 0),
         16#53#           =>  --  FF53
          ((16#0000#, 16#FF33#, 16#FF33#, 16#0000#),
           ((0, 0), (2378, 2378), (2378, 2378), (0, 0)), 0, 0),
         16#54#           =>  --  FF54
          ((16#0000#, 16#FF34#, 16#FF34#, 16#0000#),
           ((0, 0), (2379, 2379), (2379, 2379), (0, 0)), 0, 0),
         16#55#           =>  --  FF55
          ((16#0000#, 16#FF35#, 16#FF35#, 16#0000#),
           ((0, 0), (2380, 2380), (2380, 2380), (0, 0)), 0, 0),
         16#56#           =>  --  FF56
          ((16#0000#, 16#FF36#, 16#FF36#, 16#0000#),
           ((0, 0), (2381, 2381), (2381, 2381), (0, 0)), 0, 0),
         16#57#           =>  --  FF57
          ((16#0000#, 16#FF37#, 16#FF37#, 16#0000#),
           ((0, 0), (2382, 2382), (2382, 2382), (0, 0)), 0, 0),
         16#58#           =>  --  FF58
          ((16#0000#, 16#FF38#, 16#FF38#, 16#0000#),
           ((0, 0), (2383, 2383), (2383, 2383), (0, 0)), 0, 0),
         16#59#           =>  --  FF59
          ((16#0000#, 16#FF39#, 16#FF39#, 16#0000#),
           ((0, 0), (2384, 2384), (2384, 2384), (0, 0)), 0, 0),
         16#5A#           =>  --  FF5A
          ((16#0000#, 16#FF3A#, 16#FF3A#, 16#0000#),
           ((0, 0), (2385, 2385), (2385, 2385), (0, 0)), 0, 0),
         others           =>
          ((16#0000#, 16#0000#, 16#0000#, 16#0000#),
           ((0, 0), (0, 0), (0, 0), (0, 0)), 0, 0));

   Group_0104 : aliased constant Case_Mapping_Second_Stage
     := (16#00#           =>  --  010400
          ((16#010428#, 16#0000#, 16#0000#, 16#010428#),
           ((2386, 2386), (0, 0), (0, 0), (2386, 2386)), 0, 0),
         16#01#           =>  --  010401
          ((16#010429#, 16#0000#, 16#0000#, 16#010429#),
           ((2387, 2387), (0, 0), (0, 0), (2387, 2387)), 0, 0),
         16#02#           =>  --  010402
          ((16#01042A#, 16#0000#, 16#0000#, 16#01042A#),
           ((2388, 2388), (0, 0), (0, 0), (2388, 2388)), 0, 0),
         16#03#           =>  --  010403
          ((16#01042B#, 16#0000#, 16#0000#, 16#01042B#),
           ((2389, 2389), (0, 0), (0, 0), (2389, 2389)), 0, 0),
         16#04#           =>  --  010404
          ((16#01042C#, 16#0000#, 16#0000#, 16#01042C#),
           ((2390, 2390), (0, 0), (0, 0), (2390, 2390)), 0, 0),
         16#05#           =>  --  010405
          ((16#01042D#, 16#0000#, 16#0000#, 16#01042D#),
           ((2391, 2391), (0, 0), (0, 0), (2391, 2391)), 0, 0),
         16#06#           =>  --  010406
          ((16#01042E#, 16#0000#, 16#0000#, 16#01042E#),
           ((2392, 2392), (0, 0), (0, 0), (2392, 2392)), 0, 0),
         16#07#           =>  --  010407
          ((16#01042F#, 16#0000#, 16#0000#, 16#01042F#),
           ((2393, 2393), (0, 0), (0, 0), (2393, 2393)), 0, 0),
         16#08#           =>  --  010408
          ((16#010430#, 16#0000#, 16#0000#, 16#010430#),
           ((2394, 2394), (0, 0), (0, 0), (2394, 2394)), 0, 0),
         16#09#           =>  --  010409
          ((16#010431#, 16#0000#, 16#0000#, 16#010431#),
           ((2395, 2395), (0, 0), (0, 0), (2395, 2395)), 0, 0),
         16#0A#           =>  --  01040A
          ((16#010432#, 16#0000#, 16#0000#, 16#010432#),
           ((2396, 2396), (0, 0), (0, 0), (2396, 2396)), 0, 0),
         16#0B#           =>  --  01040B
          ((16#010433#, 16#0000#, 16#0000#, 16#010433#),
           ((2397, 2397), (0, 0), (0, 0), (2397, 2397)), 0, 0),
         16#0C#           =>  --  01040C
          ((16#010434#, 16#0000#, 16#0000#, 16#010434#),
           ((2398, 2398), (0, 0), (0, 0), (2398, 2398)), 0, 0),
         16#0D#           =>  --  01040D
          ((16#010435#, 16#0000#, 16#0000#, 16#010435#),
           ((2399, 2399), (0, 0), (0, 0), (2399, 2399)), 0, 0),
         16#0E#           =>  --  01040E
          ((16#010436#, 16#0000#, 16#0000#, 16#010436#),
           ((2400, 2400), (0, 0), (0, 0), (2400, 2400)), 0, 0),
         16#0F#           =>  --  01040F
          ((16#010437#, 16#0000#, 16#0000#, 16#010437#),
           ((2401, 2401), (0, 0), (0, 0), (2401, 2401)), 0, 0),
         16#10#           =>  --  010410
          ((16#010438#, 16#0000#, 16#0000#, 16#010438#),
           ((2402, 2402), (0, 0), (0, 0), (2402, 2402)), 0, 0),
         16#11#           =>  --  010411
          ((16#010439#, 16#0000#, 16#0000#, 16#010439#),
           ((2403, 2403), (0, 0), (0, 0), (2403, 2403)), 0, 0),
         16#12#           =>  --  010412
          ((16#01043A#, 16#0000#, 16#0000#, 16#01043A#),
           ((2404, 2404), (0, 0), (0, 0), (2404, 2404)), 0, 0),
         16#13#           =>  --  010413
          ((16#01043B#, 16#0000#, 16#0000#, 16#01043B#),
           ((2405, 2405), (0, 0), (0, 0), (2405, 2405)), 0, 0),
         16#14#           =>  --  010414
          ((16#01043C#, 16#0000#, 16#0000#, 16#01043C#),
           ((2406, 2406), (0, 0), (0, 0), (2406, 2406)), 0, 0),
         16#15#           =>  --  010415
          ((16#01043D#, 16#0000#, 16#0000#, 16#01043D#),
           ((2407, 2407), (0, 0), (0, 0), (2407, 2407)), 0, 0),
         16#16#           =>  --  010416
          ((16#01043E#, 16#0000#, 16#0000#, 16#01043E#),
           ((2408, 2408), (0, 0), (0, 0), (2408, 2408)), 0, 0),
         16#17#           =>  --  010417
          ((16#01043F#, 16#0000#, 16#0000#, 16#01043F#),
           ((2409, 2409), (0, 0), (0, 0), (2409, 2409)), 0, 0),
         16#18#           =>  --  010418
          ((16#010440#, 16#0000#, 16#0000#, 16#010440#),
           ((2410, 2410), (0, 0), (0, 0), (2410, 2410)), 0, 0),
         16#19#           =>  --  010419
          ((16#010441#, 16#0000#, 16#0000#, 16#010441#),
           ((2411, 2411), (0, 0), (0, 0), (2411, 2411)), 0, 0),
         16#1A#           =>  --  01041A
          ((16#010442#, 16#0000#, 16#0000#, 16#010442#),
           ((2412, 2412), (0, 0), (0, 0), (2412, 2412)), 0, 0),
         16#1B#           =>  --  01041B
          ((16#010443#, 16#0000#, 16#0000#, 16#010443#),
           ((2413, 2413), (0, 0), (0, 0), (2413, 2413)), 0, 0),
         16#1C#           =>  --  01041C
          ((16#010444#, 16#0000#, 16#0000#, 16#010444#),
           ((2414, 2414), (0, 0), (0, 0), (2414, 2414)), 0, 0),
         16#1D#           =>  --  01041D
          ((16#010445#, 16#0000#, 16#0000#, 16#010445#),
           ((2415, 2415), (0, 0), (0, 0), (2415, 2415)), 0, 0),
         16#1E#           =>  --  01041E
          ((16#010446#, 16#0000#, 16#0000#, 16#010446#),
           ((2416, 2416), (0, 0), (0, 0), (2416, 2416)), 0, 0),
         16#1F#           =>  --  01041F
          ((16#010447#, 16#0000#, 16#0000#, 16#010447#),
           ((2417, 2417), (0, 0), (0, 0), (2417, 2417)), 0, 0),
         16#20#           =>  --  010420
          ((16#010448#, 16#0000#, 16#0000#, 16#010448#),
           ((2418, 2418), (0, 0), (0, 0), (2418, 2418)), 0, 0),
         16#21#           =>  --  010421
          ((16#010449#, 16#0000#, 16#0000#, 16#010449#),
           ((2419, 2419), (0, 0), (0, 0), (2419, 2419)), 0, 0),
         16#22#           =>  --  010422
          ((16#01044A#, 16#0000#, 16#0000#, 16#01044A#),
           ((2420, 2420), (0, 0), (0, 0), (2420, 2420)), 0, 0),
         16#23#           =>  --  010423
          ((16#01044B#, 16#0000#, 16#0000#, 16#01044B#),
           ((2421, 2421), (0, 0), (0, 0), (2421, 2421)), 0, 0),
         16#24#           =>  --  010424
          ((16#01044C#, 16#0000#, 16#0000#, 16#01044C#),
           ((2422, 2422), (0, 0), (0, 0), (2422, 2422)), 0, 0),
         16#25#           =>  --  010425
          ((16#01044D#, 16#0000#, 16#0000#, 16#01044D#),
           ((2423, 2423), (0, 0), (0, 0), (2423, 2423)), 0, 0),
         16#26#           =>  --  010426
          ((16#01044E#, 16#0000#, 16#0000#, 16#01044E#),
           ((2424, 2424), (0, 0), (0, 0), (2424, 2424)), 0, 0),
         16#27#           =>  --  010427
          ((16#01044F#, 16#0000#, 16#0000#, 16#01044F#),
           ((2425, 2425), (0, 0), (0, 0), (2425, 2425)), 0, 0),
         16#28#           =>  --  010428
          ((16#0000#, 16#010400#, 16#010400#, 16#0000#),
           ((0, 0), (2426, 2426), (2426, 2426), (0, 0)), 0, 0),
         16#29#           =>  --  010429
          ((16#0000#, 16#010401#, 16#010401#, 16#0000#),
           ((0, 0), (2427, 2427), (2427, 2427), (0, 0)), 0, 0),
         16#2A#           =>  --  01042A
          ((16#0000#, 16#010402#, 16#010402#, 16#0000#),
           ((0, 0), (2428, 2428), (2428, 2428), (0, 0)), 0, 0),
         16#2B#           =>  --  01042B
          ((16#0000#, 16#010403#, 16#010403#, 16#0000#),
           ((0, 0), (2429, 2429), (2429, 2429), (0, 0)), 0, 0),
         16#2C#           =>  --  01042C
          ((16#0000#, 16#010404#, 16#010404#, 16#0000#),
           ((0, 0), (2430, 2430), (2430, 2430), (0, 0)), 0, 0),
         16#2D#           =>  --  01042D
          ((16#0000#, 16#010405#, 16#010405#, 16#0000#),
           ((0, 0), (2431, 2431), (2431, 2431), (0, 0)), 0, 0),
         16#2E#           =>  --  01042E
          ((16#0000#, 16#010406#, 16#010406#, 16#0000#),
           ((0, 0), (2432, 2432), (2432, 2432), (0, 0)), 0, 0),
         16#2F#           =>  --  01042F
          ((16#0000#, 16#010407#, 16#010407#, 16#0000#),
           ((0, 0), (2433, 2433), (2433, 2433), (0, 0)), 0, 0),
         16#30#           =>  --  010430
          ((16#0000#, 16#010408#, 16#010408#, 16#0000#),
           ((0, 0), (2434, 2434), (2434, 2434), (0, 0)), 0, 0),
         16#31#           =>  --  010431
          ((16#0000#, 16#010409#, 16#010409#, 16#0000#),
           ((0, 0), (2435, 2435), (2435, 2435), (0, 0)), 0, 0),
         16#32#           =>  --  010432
          ((16#0000#, 16#01040A#, 16#01040A#, 16#0000#),
           ((0, 0), (2436, 2436), (2436, 2436), (0, 0)), 0, 0),
         16#33#           =>  --  010433
          ((16#0000#, 16#01040B#, 16#01040B#, 16#0000#),
           ((0, 0), (2437, 2437), (2437, 2437), (0, 0)), 0, 0),
         16#34#           =>  --  010434
          ((16#0000#, 16#01040C#, 16#01040C#, 16#0000#),
           ((0, 0), (2438, 2438), (2438, 2438), (0, 0)), 0, 0),
         16#35#           =>  --  010435
          ((16#0000#, 16#01040D#, 16#01040D#, 16#0000#),
           ((0, 0), (2439, 2439), (2439, 2439), (0, 0)), 0, 0),
         16#36#           =>  --  010436
          ((16#0000#, 16#01040E#, 16#01040E#, 16#0000#),
           ((0, 0), (2440, 2440), (2440, 2440), (0, 0)), 0, 0),
         16#37#           =>  --  010437
          ((16#0000#, 16#01040F#, 16#01040F#, 16#0000#),
           ((0, 0), (2441, 2441), (2441, 2441), (0, 0)), 0, 0),
         16#38#           =>  --  010438
          ((16#0000#, 16#010410#, 16#010410#, 16#0000#),
           ((0, 0), (2442, 2442), (2442, 2442), (0, 0)), 0, 0),
         16#39#           =>  --  010439
          ((16#0000#, 16#010411#, 16#010411#, 16#0000#),
           ((0, 0), (2443, 2443), (2443, 2443), (0, 0)), 0, 0),
         16#3A#           =>  --  01043A
          ((16#0000#, 16#010412#, 16#010412#, 16#0000#),
           ((0, 0), (2444, 2444), (2444, 2444), (0, 0)), 0, 0),
         16#3B#           =>  --  01043B
          ((16#0000#, 16#010413#, 16#010413#, 16#0000#),
           ((0, 0), (2445, 2445), (2445, 2445), (0, 0)), 0, 0),
         16#3C#           =>  --  01043C
          ((16#0000#, 16#010414#, 16#010414#, 16#0000#),
           ((0, 0), (2446, 2446), (2446, 2446), (0, 0)), 0, 0),
         16#3D#           =>  --  01043D
          ((16#0000#, 16#010415#, 16#010415#, 16#0000#),
           ((0, 0), (2447, 2447), (2447, 2447), (0, 0)), 0, 0),
         16#3E#           =>  --  01043E
          ((16#0000#, 16#010416#, 16#010416#, 16#0000#),
           ((0, 0), (2448, 2448), (2448, 2448), (0, 0)), 0, 0),
         16#3F#           =>  --  01043F
          ((16#0000#, 16#010417#, 16#010417#, 16#0000#),
           ((0, 0), (2449, 2449), (2449, 2449), (0, 0)), 0, 0),
         16#40#           =>  --  010440
          ((16#0000#, 16#010418#, 16#010418#, 16#0000#),
           ((0, 0), (2450, 2450), (2450, 2450), (0, 0)), 0, 0),
         16#41#           =>  --  010441
          ((16#0000#, 16#010419#, 16#010419#, 16#0000#),
           ((0, 0), (2451, 2451), (2451, 2451), (0, 0)), 0, 0),
         16#42#           =>  --  010442
          ((16#0000#, 16#01041A#, 16#01041A#, 16#0000#),
           ((0, 0), (2452, 2452), (2452, 2452), (0, 0)), 0, 0),
         16#43#           =>  --  010443
          ((16#0000#, 16#01041B#, 16#01041B#, 16#0000#),
           ((0, 0), (2453, 2453), (2453, 2453), (0, 0)), 0, 0),
         16#44#           =>  --  010444
          ((16#0000#, 16#01041C#, 16#01041C#, 16#0000#),
           ((0, 0), (2454, 2454), (2454, 2454), (0, 0)), 0, 0),
         16#45#           =>  --  010445
          ((16#0000#, 16#01041D#, 16#01041D#, 16#0000#),
           ((0, 0), (2455, 2455), (2455, 2455), (0, 0)), 0, 0),
         16#46#           =>  --  010446
          ((16#0000#, 16#01041E#, 16#01041E#, 16#0000#),
           ((0, 0), (2456, 2456), (2456, 2456), (0, 0)), 0, 0),
         16#47#           =>  --  010447
          ((16#0000#, 16#01041F#, 16#01041F#, 16#0000#),
           ((0, 0), (2457, 2457), (2457, 2457), (0, 0)), 0, 0),
         16#48#           =>  --  010448
          ((16#0000#, 16#010420#, 16#010420#, 16#0000#),
           ((0, 0), (2458, 2458), (2458, 2458), (0, 0)), 0, 0),
         16#49#           =>  --  010449
          ((16#0000#, 16#010421#, 16#010421#, 16#0000#),
           ((0, 0), (2459, 2459), (2459, 2459), (0, 0)), 0, 0),
         16#4A#           =>  --  01044A
          ((16#0000#, 16#010422#, 16#010422#, 16#0000#),
           ((0, 0), (2460, 2460), (2460, 2460), (0, 0)), 0, 0),
         16#4B#           =>  --  01044B
          ((16#0000#, 16#010423#, 16#010423#, 16#0000#),
           ((0, 0), (2461, 2461), (2461, 2461), (0, 0)), 0, 0),
         16#4C#           =>  --  01044C
          ((16#0000#, 16#010424#, 16#010424#, 16#0000#),
           ((0, 0), (2462, 2462), (2462, 2462), (0, 0)), 0, 0),
         16#4D#           =>  --  01044D
          ((16#0000#, 16#010425#, 16#010425#, 16#0000#),
           ((0, 0), (2463, 2463), (2463, 2463), (0, 0)), 0, 0),
         16#4E#           =>  --  01044E
          ((16#0000#, 16#010426#, 16#010426#, 16#0000#),
           ((0, 0), (2464, 2464), (2464, 2464), (0, 0)), 0, 0),
         16#4F#           =>  --  01044F
          ((16#0000#, 16#010427#, 16#010427#, 16#0000#),
           ((0, 0), (2465, 2465), (2465, 2465), (0, 0)), 0, 0),
         others           =>
          ((16#0000#, 16#0000#, 16#0000#, 16#0000#),
           ((0, 0), (0, 0), (0, 0), (0, 0)), 0, 0));

   Group_0118 : aliased constant Case_Mapping_Second_Stage
     := (16#A0#           =>  --  0118A0
          ((16#0118C0#, 16#0000#, 16#0000#, 16#0118C0#),
           ((2466, 2466), (0, 0), (0, 0), (2466, 2466)), 0, 0),
         16#A1#           =>  --  0118A1
          ((16#0118C1#, 16#0000#, 16#0000#, 16#0118C1#),
           ((2467, 2467), (0, 0), (0, 0), (2467, 2467)), 0, 0),
         16#A2#           =>  --  0118A2
          ((16#0118C2#, 16#0000#, 16#0000#, 16#0118C2#),
           ((2468, 2468), (0, 0), (0, 0), (2468, 2468)), 0, 0),
         16#A3#           =>  --  0118A3
          ((16#0118C3#, 16#0000#, 16#0000#, 16#0118C3#),
           ((2469, 2469), (0, 0), (0, 0), (2469, 2469)), 0, 0),
         16#A4#           =>  --  0118A4
          ((16#0118C4#, 16#0000#, 16#0000#, 16#0118C4#),
           ((2470, 2470), (0, 0), (0, 0), (2470, 2470)), 0, 0),
         16#A5#           =>  --  0118A5
          ((16#0118C5#, 16#0000#, 16#0000#, 16#0118C5#),
           ((2471, 2471), (0, 0), (0, 0), (2471, 2471)), 0, 0),
         16#A6#           =>  --  0118A6
          ((16#0118C6#, 16#0000#, 16#0000#, 16#0118C6#),
           ((2472, 2472), (0, 0), (0, 0), (2472, 2472)), 0, 0),
         16#A7#           =>  --  0118A7
          ((16#0118C7#, 16#0000#, 16#0000#, 16#0118C7#),
           ((2473, 2473), (0, 0), (0, 0), (2473, 2473)), 0, 0),
         16#A8#           =>  --  0118A8
          ((16#0118C8#, 16#0000#, 16#0000#, 16#0118C8#),
           ((2474, 2474), (0, 0), (0, 0), (2474, 2474)), 0, 0),
         16#A9#           =>  --  0118A9
          ((16#0118C9#, 16#0000#, 16#0000#, 16#0118C9#),
           ((2475, 2475), (0, 0), (0, 0), (2475, 2475)), 0, 0),
         16#AA#           =>  --  0118AA
          ((16#0118CA#, 16#0000#, 16#0000#, 16#0118CA#),
           ((2476, 2476), (0, 0), (0, 0), (2476, 2476)), 0, 0),
         16#AB#           =>  --  0118AB
          ((16#0118CB#, 16#0000#, 16#0000#, 16#0118CB#),
           ((2477, 2477), (0, 0), (0, 0), (2477, 2477)), 0, 0),
         16#AC#           =>  --  0118AC
          ((16#0118CC#, 16#0000#, 16#0000#, 16#0118CC#),
           ((2478, 2478), (0, 0), (0, 0), (2478, 2478)), 0, 0),
         16#AD#           =>  --  0118AD
          ((16#0118CD#, 16#0000#, 16#0000#, 16#0118CD#),
           ((2479, 2479), (0, 0), (0, 0), (2479, 2479)), 0, 0),
         16#AE#           =>  --  0118AE
          ((16#0118CE#, 16#0000#, 16#0000#, 16#0118CE#),
           ((2480, 2480), (0, 0), (0, 0), (2480, 2480)), 0, 0),
         16#AF#           =>  --  0118AF
          ((16#0118CF#, 16#0000#, 16#0000#, 16#0118CF#),
           ((2481, 2481), (0, 0), (0, 0), (2481, 2481)), 0, 0),
         16#B0#           =>  --  0118B0
          ((16#0118D0#, 16#0000#, 16#0000#, 16#0118D0#),
           ((2482, 2482), (0, 0), (0, 0), (2482, 2482)), 0, 0),
         16#B1#           =>  --  0118B1
          ((16#0118D1#, 16#0000#, 16#0000#, 16#0118D1#),
           ((2483, 2483), (0, 0), (0, 0), (2483, 2483)), 0, 0),
         16#B2#           =>  --  0118B2
          ((16#0118D2#, 16#0000#, 16#0000#, 16#0118D2#),
           ((2484, 2484), (0, 0), (0, 0), (2484, 2484)), 0, 0),
         16#B3#           =>  --  0118B3
          ((16#0118D3#, 16#0000#, 16#0000#, 16#0118D3#),
           ((2485, 2485), (0, 0), (0, 0), (2485, 2485)), 0, 0),
         16#B4#           =>  --  0118B4
          ((16#0118D4#, 16#0000#, 16#0000#, 16#0118D4#),
           ((2486, 2486), (0, 0), (0, 0), (2486, 2486)), 0, 0),
         16#B5#           =>  --  0118B5
          ((16#0118D5#, 16#0000#, 16#0000#, 16#0118D5#),
           ((2487, 2487), (0, 0), (0, 0), (2487, 2487)), 0, 0),
         16#B6#           =>  --  0118B6
          ((16#0118D6#, 16#0000#, 16#0000#, 16#0118D6#),
           ((2488, 2488), (0, 0), (0, 0), (2488, 2488)), 0, 0),
         16#B7#           =>  --  0118B7
          ((16#0118D7#, 16#0000#, 16#0000#, 16#0118D7#),
           ((2489, 2489), (0, 0), (0, 0), (2489, 2489)), 0, 0),
         16#B8#           =>  --  0118B8
          ((16#0118D8#, 16#0000#, 16#0000#, 16#0118D8#),
           ((2490, 2490), (0, 0), (0, 0), (2490, 2490)), 0, 0),
         16#B9#           =>  --  0118B9
          ((16#0118D9#, 16#0000#, 16#0000#, 16#0118D9#),
           ((2491, 2491), (0, 0), (0, 0), (2491, 2491)), 0, 0),
         16#BA#           =>  --  0118BA
          ((16#0118DA#, 16#0000#, 16#0000#, 16#0118DA#),
           ((2492, 2492), (0, 0), (0, 0), (2492, 2492)), 0, 0),
         16#BB#           =>  --  0118BB
          ((16#0118DB#, 16#0000#, 16#0000#, 16#0118DB#),
           ((2493, 2493), (0, 0), (0, 0), (2493, 2493)), 0, 0),
         16#BC#           =>  --  0118BC
          ((16#0118DC#, 16#0000#, 16#0000#, 16#0118DC#),
           ((2494, 2494), (0, 0), (0, 0), (2494, 2494)), 0, 0),
         16#BD#           =>  --  0118BD
          ((16#0118DD#, 16#0000#, 16#0000#, 16#0118DD#),
           ((2495, 2495), (0, 0), (0, 0), (2495, 2495)), 0, 0),
         16#BE#           =>  --  0118BE
          ((16#0118DE#, 16#0000#, 16#0000#, 16#0118DE#),
           ((2496, 2496), (0, 0), (0, 0), (2496, 2496)), 0, 0),
         16#BF#           =>  --  0118BF
          ((16#0118DF#, 16#0000#, 16#0000#, 16#0118DF#),
           ((2497, 2497), (0, 0), (0, 0), (2497, 2497)), 0, 0),
         16#C0#           =>  --  0118C0
          ((16#0000#, 16#0118A0#, 16#0118A0#, 16#0000#),
           ((0, 0), (2498, 2498), (2498, 2498), (0, 0)), 0, 0),
         16#C1#           =>  --  0118C1
          ((16#0000#, 16#0118A1#, 16#0118A1#, 16#0000#),
           ((0, 0), (2499, 2499), (2499, 2499), (0, 0)), 0, 0),
         16#C2#           =>  --  0118C2
          ((16#0000#, 16#0118A2#, 16#0118A2#, 16#0000#),
           ((0, 0), (2500, 2500), (2500, 2500), (0, 0)), 0, 0),
         16#C3#           =>  --  0118C3
          ((16#0000#, 16#0118A3#, 16#0118A3#, 16#0000#),
           ((0, 0), (2501, 2501), (2501, 2501), (0, 0)), 0, 0),
         16#C4#           =>  --  0118C4
          ((16#0000#, 16#0118A4#, 16#0118A4#, 16#0000#),
           ((0, 0), (2502, 2502), (2502, 2502), (0, 0)), 0, 0),
         16#C5#           =>  --  0118C5
          ((16#0000#, 16#0118A5#, 16#0118A5#, 16#0000#),
           ((0, 0), (2503, 2503), (2503, 2503), (0, 0)), 0, 0),
         16#C6#           =>  --  0118C6
          ((16#0000#, 16#0118A6#, 16#0118A6#, 16#0000#),
           ((0, 0), (2504, 2504), (2504, 2504), (0, 0)), 0, 0),
         16#C7#           =>  --  0118C7
          ((16#0000#, 16#0118A7#, 16#0118A7#, 16#0000#),
           ((0, 0), (2505, 2505), (2505, 2505), (0, 0)), 0, 0),
         16#C8#           =>  --  0118C8
          ((16#0000#, 16#0118A8#, 16#0118A8#, 16#0000#),
           ((0, 0), (2506, 2506), (2506, 2506), (0, 0)), 0, 0),
         16#C9#           =>  --  0118C9
          ((16#0000#, 16#0118A9#, 16#0118A9#, 16#0000#),
           ((0, 0), (2507, 2507), (2507, 2507), (0, 0)), 0, 0),
         16#CA#           =>  --  0118CA
          ((16#0000#, 16#0118AA#, 16#0118AA#, 16#0000#),
           ((0, 0), (2508, 2508), (2508, 2508), (0, 0)), 0, 0),
         16#CB#           =>  --  0118CB
          ((16#0000#, 16#0118AB#, 16#0118AB#, 16#0000#),
           ((0, 0), (2509, 2509), (2509, 2509), (0, 0)), 0, 0),
         16#CC#           =>  --  0118CC
          ((16#0000#, 16#0118AC#, 16#0118AC#, 16#0000#),
           ((0, 0), (2510, 2510), (2510, 2510), (0, 0)), 0, 0),
         16#CD#           =>  --  0118CD
          ((16#0000#, 16#0118AD#, 16#0118AD#, 16#0000#),
           ((0, 0), (2511, 2511), (2511, 2511), (0, 0)), 0, 0),
         16#CE#           =>  --  0118CE
          ((16#0000#, 16#0118AE#, 16#0118AE#, 16#0000#),
           ((0, 0), (2512, 2512), (2512, 2512), (0, 0)), 0, 0),
         16#CF#           =>  --  0118CF
          ((16#0000#, 16#0118AF#, 16#0118AF#, 16#0000#),
           ((0, 0), (2513, 2513), (2513, 2513), (0, 0)), 0, 0),
         16#D0#           =>  --  0118D0
          ((16#0000#, 16#0118B0#, 16#0118B0#, 16#0000#),
           ((0, 0), (2514, 2514), (2514, 2514), (0, 0)), 0, 0),
         16#D1#           =>  --  0118D1
          ((16#0000#, 16#0118B1#, 16#0118B1#, 16#0000#),
           ((0, 0), (2515, 2515), (2515, 2515), (0, 0)), 0, 0),
         16#D2#           =>  --  0118D2
          ((16#0000#, 16#0118B2#, 16#0118B2#, 16#0000#),
           ((0, 0), (2516, 2516), (2516, 2516), (0, 0)), 0, 0),
         16#D3#           =>  --  0118D3
          ((16#0000#, 16#0118B3#, 16#0118B3#, 16#0000#),
           ((0, 0), (2517, 2517), (2517, 2517), (0, 0)), 0, 0),
         16#D4#           =>  --  0118D4
          ((16#0000#, 16#0118B4#, 16#0118B4#, 16#0000#),
           ((0, 0), (2518, 2518), (2518, 2518), (0, 0)), 0, 0),
         16#D5#           =>  --  0118D5
          ((16#0000#, 16#0118B5#, 16#0118B5#, 16#0000#),
           ((0, 0), (2519, 2519), (2519, 2519), (0, 0)), 0, 0),
         16#D6#           =>  --  0118D6
          ((16#0000#, 16#0118B6#, 16#0118B6#, 16#0000#),
           ((0, 0), (2520, 2520), (2520, 2520), (0, 0)), 0, 0),
         16#D7#           =>  --  0118D7
          ((16#0000#, 16#0118B7#, 16#0118B7#, 16#0000#),
           ((0, 0), (2521, 2521), (2521, 2521), (0, 0)), 0, 0),
         16#D8#           =>  --  0118D8
          ((16#0000#, 16#0118B8#, 16#0118B8#, 16#0000#),
           ((0, 0), (2522, 2522), (2522, 2522), (0, 0)), 0, 0),
         16#D9#           =>  --  0118D9
          ((16#0000#, 16#0118B9#, 16#0118B9#, 16#0000#),
           ((0, 0), (2523, 2523), (2523, 2523), (0, 0)), 0, 0),
         16#DA#           =>  --  0118DA
          ((16#0000#, 16#0118BA#, 16#0118BA#, 16#0000#),
           ((0, 0), (2524, 2524), (2524, 2524), (0, 0)), 0, 0),
         16#DB#           =>  --  0118DB
          ((16#0000#, 16#0118BB#, 16#0118BB#, 16#0000#),
           ((0, 0), (2525, 2525), (2525, 2525), (0, 0)), 0, 0),
         16#DC#           =>  --  0118DC
          ((16#0000#, 16#0118BC#, 16#0118BC#, 16#0000#),
           ((0, 0), (2526, 2526), (2526, 2526), (0, 0)), 0, 0),
         16#DD#           =>  --  0118DD
          ((16#0000#, 16#0118BD#, 16#0118BD#, 16#0000#),
           ((0, 0), (2527, 2527), (2527, 2527), (0, 0)), 0, 0),
         16#DE#           =>  --  0118DE
          ((16#0000#, 16#0118BE#, 16#0118BE#, 16#0000#),
           ((0, 0), (2528, 2528), (2528, 2528), (0, 0)), 0, 0),
         16#DF#           =>  --  0118DF
          ((16#0000#, 16#0118BF#, 16#0118BF#, 16#0000#),
           ((0, 0), (2529, 2529), (2529, 2529), (0, 0)), 0, 0),
         others           =>
          ((16#0000#, 16#0000#, 16#0000#, 16#0000#),
           ((0, 0), (0, 0), (0, 0), (0, 0)), 0, 0));

   Mapping : aliased constant Case_Mapping_First_Stage
     := (16#0000# => Group_0000'Access, 16#0001# => Group_0001'Access,
         16#0002# => Group_0002'Access, 16#0003# => Group_0003'Access,
         16#0004# => Group_0004'Access, 16#0005# => Group_0005'Access,
         16#0010# => Group_0010'Access, 16#001D# => Group_001D'Access,
         16#001E# => Group_001E'Access, 16#001F# => Group_001F'Access,
         16#0021# => Group_0021'Access, 16#0024# => Group_0024'Access,
         16#002C# => Group_002C'Access, 16#002D# => Group_002D'Access,
         16#00A6# => Group_00A6'Access, 16#00A7# => Group_00A7'Access,
         16#00FB# => Group_00FB'Access, 16#00FF# => Group_00FF'Access,
         16#0104# => Group_0104'Access, 16#0118# => Group_0118'Access,
         others   => Group_0006'Access);

end Matreshka.Internals.Unicode.Ucd.Cases;
