------------------------------------------------------------------------------
--                                                                          --
--                            Matreshka Project                             --
--                                                                          --
--        Localization, Internationalization, Globalization for Ada         --
--                                                                          --
--                        Runtime Library Component                         --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2009-2015, Vadim Godunko <vgodunko@gmail.com>                --
-- All rights reserved.                                                     --
--                                                                          --
-- Redistribution and use in source and binary forms, with or without       --
-- modification, are permitted provided that the following conditions       --
-- are met:                                                                 --
--                                                                          --
--  * Redistributions of source code must retain the above copyright        --
--    notice, this list of conditions and the following disclaimer.         --
--                                                                          --
--  * Redistributions in binary form must reproduce the above copyright     --
--    notice, this list of conditions and the following disclaimer in the   --
--    documentation and/or other materials provided with the distribution.  --
--                                                                          --
--  * Neither the name of the Vadim Godunko, IE nor the names of its        --
--    contributors may be used to endorse or promote products derived from  --
--    this software without specific prior written permission.              --
--                                                                          --
-- THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS      --
-- "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT        --
-- LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR    --
-- A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT     --
-- HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,   --
-- SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED --
-- TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR   --
-- PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF   --
-- LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING     --
-- NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS       --
-- SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.             --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 5315 $ $Date: 2015-05-16 00:33:36 +0200 (Sat, 16 May 2015) $
------------------------------------------------------------------------------

pragma Restrictions (No_Elaboration_Code);
--  GNAT: enforce generation of preinitialized data section instead of
--  generation of elaboration code.

package Matreshka.Internals.Unicode.Ucd.Colls is

   pragma Preelaborate;

   Last_Variable : constant Collation_Weight := 16#0345#;

   Expansion_Data : aliased constant Collation_Element_Sequence
     := (1 => (16#0000#, 16#0000#, 16#0000#),
         2 => (16#0100#, 16#0020#, 16#0002#),
         3 => (16#0101#, 16#0020#, 16#0002#),
         4 => (16#0102#, 16#0020#, 16#0002#),
         5 => (16#0103#, 16#0020#, 16#0002#),
         6 => (16#0104#, 16#0020#, 16#0002#),
         7 => (16#0108#, 16#0020#, 16#0002#),
         8 => (16#015E#, 16#0020#, 16#0002#),
         9 => (16#01FE#, 16#0020#, 16#0002#),
         10 => (16#028A#, 16#0020#, 16#0002#),
         11 => (16#16CA#, 16#0020#, 16#0002#),
         12 => (16#028B#, 16#0020#, 16#0002#),
         13 => (16#0288#, 16#0020#, 16#0002#),
         14 => (16#01F7#, 16#0020#, 16#0002#),
         15 => (16#0209#, 16#0020#, 16#0002#),
         16 => (16#020A#, 16#0020#, 16#0002#),
         17 => (16#0281#, 16#0020#, 16#0002#),
         18 => (16#04D6#, 16#0020#, 16#0002#),
         19 => (16#0120#, 16#0020#, 16#0002#),
         20 => (16#010C#, 16#0020#, 16#0002#),
         21 => (16#0173#, 16#0020#, 16#0002#),
         22 => (16#0286#, 16#0020#, 16#0002#),
         23 => (16#1803#, 16#0020#, 16#0002#),
         24 => (16#1804#, 16#0020#, 16#0002#),
         25 => (16#1805#, 16#0020#, 16#0002#),
         26 => (16#1806#, 16#0020#, 16#0002#),
         27 => (16#1807#, 16#0020#, 16#0002#),
         28 => (16#1808#, 16#0020#, 16#0002#),
         29 => (16#1809#, 16#0020#, 16#0002#),
         30 => (16#180A#, 16#0020#, 16#0002#),
         31 => (16#180B#, 16#0020#, 16#0002#),
         32 => (16#180C#, 16#0020#, 16#0002#),
         33 => (16#0137#, 16#0020#, 16#0002#),
         34 => (16#0132#, 16#0020#, 16#0002#),
         35 => (16#04DA#, 16#0020#, 16#0002#),
         36 => (16#04DB#, 16#0020#, 16#0002#),
         37 => (16#04DC#, 16#0020#, 16#0002#),
         38 => (16#0163#, 16#0020#, 16#0002#),
         39 => (16#0280#, 16#0020#, 16#0002#),
         40 => (16#190C#, 16#0020#, 16#0008#),
         41 => (16#1925#, 16#0020#, 16#0008#),
         42 => (16#193E#, 16#0020#, 16#0008#),
         43 => (16#1953#, 16#0020#, 16#0008#),
         44 => (16#196E#, 16#0020#, 16#0008#),
         45 => (16#19A9#, 16#0020#, 16#0008#),
         46 => (16#19B8#, 16#0020#, 16#0008#),
         47 => (16#19DC#, 16#0020#, 16#0008#),
         48 => (16#19F6#, 16#0020#, 16#0008#),
         49 => (16#1A10#, 16#0020#, 16#0008#),
         50 => (16#1A29#, 16#0020#, 16#0008#),
         51 => (16#1A3B#, 16#0020#, 16#0008#),
         52 => (16#1A3B#, 16#0020#, 16#0008#),
         53 => (16#0000#, 16#0108#, 16#0002#),
         54 => (16#1A6E#, 16#0020#, 16#0008#),
         55 => (16#1A7D#, 16#0020#, 16#0008#),
         56 => (16#1AA1#, 16#0020#, 16#0008#),
         57 => (16#1ACE#, 16#0020#, 16#0008#),
         58 => (16#1AE3#, 16#0020#, 16#0008#),
         59 => (16#1AF5#, 16#0020#, 16#0008#),
         60 => (16#1B33#, 16#0020#, 16#0008#),
         61 => (16#1B57#, 16#0020#, 16#0008#),
         62 => (16#1B77#, 16#0020#, 16#0008#),
         63 => (16#1BA5#, 16#0020#, 16#0008#),
         64 => (16#1BB7#, 16#0020#, 16#0008#),
         65 => (16#1BC1#, 16#0020#, 16#0008#),
         66 => (16#1BCD#, 16#0020#, 16#0008#),
         67 => (16#1BE3#, 16#0020#, 16#0008#),
         68 => (16#020B#, 16#0020#, 16#0002#),
         69 => (16#0287#, 16#0020#, 16#0002#),
         70 => (16#020C#, 16#0020#, 16#0002#),
         71 => (16#0349#, 16#0020#, 16#0002#),
         72 => (16#010A#, 16#0020#, 16#0002#),
         73 => (16#0346#, 16#0020#, 16#0002#),
         74 => (16#190C#, 16#0020#, 16#0002#),
         75 => (16#1925#, 16#0020#, 16#0002#),
         76 => (16#193E#, 16#0020#, 16#0002#),
         77 => (16#1953#, 16#0020#, 16#0002#),
         78 => (16#196E#, 16#0020#, 16#0002#),
         79 => (16#19A9#, 16#0020#, 16#0002#),
         80 => (16#19B8#, 16#0020#, 16#0002#),
         81 => (16#19DC#, 16#0020#, 16#0002#),
         82 => (16#19F6#, 16#0020#, 16#0002#),
         83 => (16#1A10#, 16#0020#, 16#0002#),
         84 => (16#1A29#, 16#0020#, 16#0002#),
         85 => (16#1A3B#, 16#0020#, 16#0002#),
         86 => (16#1A3B#, 16#0020#, 16#0002#),
         87 => (16#0000#, 16#0108#, 16#0002#),
         88 => (16#1A6E#, 16#0020#, 16#0002#),
         89 => (16#1A7D#, 16#0020#, 16#0002#),
         90 => (16#1AA1#, 16#0020#, 16#0002#),
         91 => (16#1ACE#, 16#0020#, 16#0002#),
         92 => (16#1AE3#, 16#0020#, 16#0002#),
         93 => (16#1AF5#, 16#0020#, 16#0002#),
         94 => (16#1B33#, 16#0020#, 16#0002#),
         95 => (16#1B57#, 16#0020#, 16#0002#),
         96 => (16#1B77#, 16#0020#, 16#0002#),
         97 => (16#1BA5#, 16#0020#, 16#0002#),
         98 => (16#1BB7#, 16#0020#, 16#0002#),
         99 => (16#1BC1#, 16#0020#, 16#0002#),
         100 => (16#1BCD#, 16#0020#, 16#0002#),
         101 => (16#1BE3#, 16#0020#, 16#0002#),
         102 => (16#020D#, 16#0020#, 16#0002#),
         103 => (16#04DE#, 16#0020#, 16#0002#),
         104 => (16#020E#, 16#0020#, 16#0002#),
         105 => (16#04E0#, 16#0020#, 16#0002#),
         106 => (16#0105#, 16#0020#, 16#0002#),
         107 => (16#0108#, 16#0020#, 16#001B#),
         108 => (16#015F#, 16#0020#, 16#0002#),
         109 => (16#16C9#, 16#0020#, 16#0002#),
         110 => (16#16CB#, 16#0020#, 16#0002#),
         111 => (16#16C8#, 16#0020#, 16#0002#),
         112 => (16#16CC#, 16#0020#, 16#0002#),
         113 => (16#04DF#, 16#0020#, 16#0002#),
         114 => (16#027B#, 16#0020#, 16#0002#),
         115 => (16#034D#, 16#0020#, 16#0002#),
         116 => (16#0446#, 16#0020#, 16#0002#),
         117 => (16#190C#, 16#0020#, 16#0014#),
         118 => (16#0207#, 16#0020#, 16#0002#),
         119 => (16#04DD#, 16#0020#, 16#0002#),
         120 => (16#0447#, 16#0020#, 16#0002#),
         121 => (16#034A#, 16#0020#, 16#0002#),
         122 => (16#03BA#, 16#0020#, 16#0002#),
         123 => (16#04D7#, 16#0020#, 16#0002#),
         124 => (16#1805#, 16#0020#, 16#0014#),
         125 => (16#1806#, 16#0020#, 16#0014#),
         126 => (16#0347#, 16#0020#, 16#0002#),
         127 => (16#1C89#, 16#0020#, 16#0004#),
         128 => (16#027D#, 16#0020#, 16#0002#),
         129 => (16#0187#, 16#0020#, 16#0002#),
         130 => (16#0350#, 16#0020#, 16#0002#),
         131 => (16#1804#, 16#0020#, 16#0014#),
         132 => (16#1AA1#, 16#0020#, 16#0014#),
         133 => (16#0208#, 16#0020#, 16#0002#),
         134 => (16#1804#, 16#0020#, 16#001E#),
         135 => (16#04E6#, 16#0020#, 16#001E#),
         136 => (16#1807#, 16#0020#, 16#001E#),
         137 => (16#1804#, 16#0020#, 16#001E#),
         138 => (16#04E6#, 16#0020#, 16#001E#),
         139 => (16#1805#, 16#0020#, 16#001E#),
         140 => (16#1806#, 16#0020#, 16#001E#),
         141 => (16#04E6#, 16#0020#, 16#001E#),
         142 => (16#1807#, 16#0020#, 16#001E#),
         143 => (16#0164#, 16#0020#, 16#0002#),
         144 => (16#190C#, 16#0020#, 16#0008#),
         145 => (16#0000#, 16#0025#, 16#0002#),
         146 => (16#190C#, 16#0020#, 16#0008#),
         147 => (16#0000#, 16#0024#, 16#0002#),
         148 => (16#190C#, 16#0020#, 16#0008#),
         149 => (16#0000#, 16#0027#, 16#0002#),
         150 => (16#190C#, 16#0020#, 16#0008#),
         151 => (16#0000#, 16#002D#, 16#0002#),
         152 => (16#190C#, 16#0020#, 16#0008#),
         153 => (16#0000#, 16#002B#, 16#0002#),
         154 => (16#190C#, 16#0020#, 16#0008#),
         155 => (16#0000#, 16#0029#, 16#0002#),
         156 => (16#190C#, 16#0020#, 16#000A#),
         157 => (16#0000#, 16#0108#, 16#0004#),
         158 => (16#196E#, 16#0020#, 16#000A#),
         159 => (16#193E#, 16#0020#, 16#0008#),
         160 => (16#0000#, 16#0030#, 16#0002#),
         161 => (16#196E#, 16#0020#, 16#0008#),
         162 => (16#0000#, 16#0025#, 16#0002#),
         163 => (16#196E#, 16#0020#, 16#0008#),
         164 => (16#0000#, 16#0024#, 16#0002#),
         165 => (16#196E#, 16#0020#, 16#0008#),
         166 => (16#0000#, 16#0027#, 16#0002#),
         167 => (16#196E#, 16#0020#, 16#0008#),
         168 => (16#0000#, 16#002B#, 16#0002#),
         169 => (16#19F6#, 16#0020#, 16#0008#),
         170 => (16#0000#, 16#0025#, 16#0002#),
         171 => (16#19F6#, 16#0020#, 16#0008#),
         172 => (16#0000#, 16#0024#, 16#0002#),
         173 => (16#19F6#, 16#0020#, 16#0008#),
         174 => (16#0000#, 16#0027#, 16#0002#),
         175 => (16#19F6#, 16#0020#, 16#0008#),
         176 => (16#0000#, 16#002B#, 16#0002#),
         177 => (16#1953#, 16#0020#, 16#000A#),
         178 => (16#0000#, 16#0108#, 16#0004#),
         179 => (16#1A7D#, 16#0020#, 16#0008#),
         180 => (16#0000#, 16#002D#, 16#0002#),
         181 => (16#1AA1#, 16#0020#, 16#0008#),
         182 => (16#0000#, 16#0025#, 16#0002#),
         183 => (16#1AA1#, 16#0020#, 16#0008#),
         184 => (16#0000#, 16#0024#, 16#0002#),
         185 => (16#1AA1#, 16#0020#, 16#0008#),
         186 => (16#0000#, 16#0027#, 16#0002#),
         187 => (16#1AA1#, 16#0020#, 16#0008#),
         188 => (16#0000#, 16#002D#, 16#0002#),
         189 => (16#1AA1#, 16#0020#, 16#0008#),
         190 => (16#0000#, 16#002B#, 16#0002#),
         191 => (16#04D9#, 16#0020#, 16#0002#),
         192 => (16#1AA1#, 16#0020#, 16#0008#),
         193 => (16#0000#, 16#002F#, 16#0002#),
         194 => (16#1B77#, 16#0020#, 16#0008#),
         195 => (16#0000#, 16#0025#, 16#0002#),
         196 => (16#1B77#, 16#0020#, 16#0008#),
         197 => (16#0000#, 16#0024#, 16#0002#),
         198 => (16#1B77#, 16#0020#, 16#0008#),
         199 => (16#0000#, 16#0027#, 16#0002#),
         200 => (16#1B77#, 16#0020#, 16#0008#),
         201 => (16#0000#, 16#002B#, 16#0002#),
         202 => (16#1BCD#, 16#0020#, 16#0008#),
         203 => (16#0000#, 16#0024#, 16#0002#),
         204 => (16#1C12#, 16#0020#, 16#0008#),
         205 => (16#1B33#, 16#0020#, 16#0004#),
         206 => (16#0000#, 16#0108#, 16#0004#),
         207 => (16#1B33#, 16#0020#, 16#0004#),
         208 => (16#190C#, 16#0020#, 16#0002#),
         209 => (16#0000#, 16#0025#, 16#0002#),
         210 => (16#190C#, 16#0020#, 16#0002#),
         211 => (16#0000#, 16#0024#, 16#0002#),
         212 => (16#190C#, 16#0020#, 16#0002#),
         213 => (16#0000#, 16#0027#, 16#0002#),
         214 => (16#190C#, 16#0020#, 16#0002#),
         215 => (16#0000#, 16#002D#, 16#0002#),
         216 => (16#190C#, 16#0020#, 16#0002#),
         217 => (16#0000#, 16#002B#, 16#0002#),
         218 => (16#190C#, 16#0020#, 16#0002#),
         219 => (16#0000#, 16#0029#, 16#0002#),
         220 => (16#190C#, 16#0020#, 16#0004#),
         221 => (16#0000#, 16#0108#, 16#0004#),
         222 => (16#196E#, 16#0020#, 16#0004#),
         223 => (16#193E#, 16#0020#, 16#0002#),
         224 => (16#0000#, 16#0030#, 16#0002#),
         225 => (16#196E#, 16#0020#, 16#0002#),
         226 => (16#0000#, 16#0025#, 16#0002#),
         227 => (16#196E#, 16#0020#, 16#0002#),
         228 => (16#0000#, 16#0024#, 16#0002#),
         229 => (16#196E#, 16#0020#, 16#0002#),
         230 => (16#0000#, 16#0027#, 16#0002#),
         231 => (16#196E#, 16#0020#, 16#0002#),
         232 => (16#0000#, 16#002B#, 16#0002#),
         233 => (16#19F6#, 16#0020#, 16#0002#),
         234 => (16#0000#, 16#0025#, 16#0002#),
         235 => (16#19F6#, 16#0020#, 16#0002#),
         236 => (16#0000#, 16#0024#, 16#0002#),
         237 => (16#19F6#, 16#0020#, 16#0002#),
         238 => (16#0000#, 16#0027#, 16#0002#),
         239 => (16#19F6#, 16#0020#, 16#0002#),
         240 => (16#0000#, 16#002B#, 16#0002#),
         241 => (16#1953#, 16#0020#, 16#0004#),
         242 => (16#0000#, 16#0108#, 16#0004#),
         243 => (16#1A7D#, 16#0020#, 16#0002#),
         244 => (16#0000#, 16#002D#, 16#0002#),
         245 => (16#1AA1#, 16#0020#, 16#0002#),
         246 => (16#0000#, 16#0025#, 16#0002#),
         247 => (16#1AA1#, 16#0020#, 16#0002#),
         248 => (16#0000#, 16#0024#, 16#0002#),
         249 => (16#1AA1#, 16#0020#, 16#0002#),
         250 => (16#0000#, 16#0027#, 16#0002#),
         251 => (16#1AA1#, 16#0020#, 16#0002#),
         252 => (16#0000#, 16#002D#, 16#0002#),
         253 => (16#1AA1#, 16#0020#, 16#0002#),
         254 => (16#0000#, 16#002B#, 16#0002#),
         255 => (16#04D8#, 16#0020#, 16#0002#),
         256 => (16#1AA1#, 16#0020#, 16#0002#),
         257 => (16#0000#, 16#002F#, 16#0002#),
         258 => (16#1B77#, 16#0020#, 16#0002#),
         259 => (16#0000#, 16#0025#, 16#0002#),
         260 => (16#1B77#, 16#0020#, 16#0002#),
         261 => (16#0000#, 16#0024#, 16#0002#),
         262 => (16#1B77#, 16#0020#, 16#0002#),
         263 => (16#0000#, 16#0027#, 16#0002#),
         264 => (16#1B77#, 16#0020#, 16#0002#),
         265 => (16#0000#, 16#002B#, 16#0002#),
         266 => (16#1BCD#, 16#0020#, 16#0002#),
         267 => (16#0000#, 16#0024#, 16#0002#),
         268 => (16#1C12#, 16#0020#, 16#0002#),
         269 => (16#1BCD#, 16#0020#, 16#0002#),
         270 => (16#0000#, 16#002B#, 16#0002#),
         271 => (16#190C#, 16#0020#, 16#0008#),
         272 => (16#0000#, 16#0032#, 16#0002#),
         273 => (16#190C#, 16#0020#, 16#0002#),
         274 => (16#0000#, 16#0032#, 16#0002#),
         275 => (16#190C#, 16#0020#, 16#0008#),
         276 => (16#0000#, 16#0026#, 16#0002#),
         277 => (16#190C#, 16#0020#, 16#0002#),
         278 => (16#0000#, 16#0026#, 16#0002#),
         279 => (16#190C#, 16#0020#, 16#0008#),
         280 => (16#0000#, 16#0031#, 16#0002#),
         281 => (16#190C#, 16#0020#, 16#0002#),
         282 => (16#0000#, 16#0031#, 16#0002#),
         283 => (16#193E#, 16#0020#, 16#0008#),
         284 => (16#0000#, 16#0024#, 16#0002#),
         285 => (16#193E#, 16#0020#, 16#0002#),
         286 => (16#0000#, 16#0024#, 16#0002#),
         287 => (16#193E#, 16#0020#, 16#0008#),
         288 => (16#0000#, 16#0027#, 16#0002#),
         289 => (16#193E#, 16#0020#, 16#0002#),
         290 => (16#0000#, 16#0027#, 16#0002#),
         291 => (16#193E#, 16#0020#, 16#0008#),
         292 => (16#0000#, 16#002E#, 16#0002#),
         293 => (16#193E#, 16#0020#, 16#0002#),
         294 => (16#0000#, 16#002E#, 16#0002#),
         295 => (16#193E#, 16#0020#, 16#0008#),
         296 => (16#0000#, 16#0028#, 16#0002#),
         297 => (16#193E#, 16#0020#, 16#0002#),
         298 => (16#0000#, 16#0028#, 16#0002#),
         299 => (16#1953#, 16#0020#, 16#0008#),
         300 => (16#0000#, 16#0028#, 16#0002#),
         301 => (16#1953#, 16#0020#, 16#0002#),
         302 => (16#0000#, 16#0028#, 16#0002#),
         303 => (16#1953#, 16#0020#, 16#0008#),
         304 => (16#0000#, 16#0039#, 16#0002#),
         305 => (16#1953#, 16#0020#, 16#0002#),
         306 => (16#0000#, 16#0039#, 16#0002#),
         307 => (16#196E#, 16#0020#, 16#0008#),
         308 => (16#0000#, 16#0032#, 16#0002#),
         309 => (16#196E#, 16#0020#, 16#0002#),
         310 => (16#0000#, 16#0032#, 16#0002#),
         311 => (16#196E#, 16#0020#, 16#0008#),
         312 => (16#0000#, 16#0026#, 16#0002#),
         313 => (16#196E#, 16#0020#, 16#0002#),
         314 => (16#0000#, 16#0026#, 16#0002#),
         315 => (16#196E#, 16#0020#, 16#0008#),
         316 => (16#0000#, 16#002E#, 16#0002#),
         317 => (16#196E#, 16#0020#, 16#0002#),
         318 => (16#0000#, 16#002E#, 16#0002#),
         319 => (16#196E#, 16#0020#, 16#0008#),
         320 => (16#0000#, 16#0031#, 16#0002#),
         321 => (16#196E#, 16#0020#, 16#0002#),
         322 => (16#0000#, 16#0031#, 16#0002#),
         323 => (16#196E#, 16#0020#, 16#0008#),
         324 => (16#0000#, 16#0028#, 16#0002#),
         325 => (16#196E#, 16#0020#, 16#0002#),
         326 => (16#0000#, 16#0028#, 16#0002#),
         327 => (16#19B8#, 16#0020#, 16#0008#),
         328 => (16#0000#, 16#0027#, 16#0002#),
         329 => (16#19B8#, 16#0020#, 16#0002#),
         330 => (16#0000#, 16#0027#, 16#0002#),
         331 => (16#19B8#, 16#0020#, 16#0008#),
         332 => (16#0000#, 16#0026#, 16#0002#),
         333 => (16#19B8#, 16#0020#, 16#0002#),
         334 => (16#0000#, 16#0026#, 16#0002#),
         335 => (16#19B8#, 16#0020#, 16#0008#),
         336 => (16#0000#, 16#002E#, 16#0002#),
         337 => (16#19B8#, 16#0020#, 16#0002#),
         338 => (16#0000#, 16#002E#, 16#0002#),
         339 => (16#19B8#, 16#0020#, 16#0008#),
         340 => (16#0000#, 16#0030#, 16#0002#),
         341 => (16#19B8#, 16#0020#, 16#0002#),
         342 => (16#0000#, 16#0030#, 16#0002#),
         343 => (16#19DC#, 16#0020#, 16#0008#),
         344 => (16#0000#, 16#0027#, 16#0002#),
         345 => (16#19DC#, 16#0020#, 16#0002#),
         346 => (16#0000#, 16#0027#, 16#0002#),
         347 => (16#19DC#, 16#0020#, 16#0008#),
         348 => (16#0000#, 16#0039#, 16#0002#),
         349 => (16#19DC#, 16#0020#, 16#0002#),
         350 => (16#0000#, 16#0039#, 16#0002#),
         351 => (16#19F6#, 16#0020#, 16#0008#),
         352 => (16#0000#, 16#002D#, 16#0002#),
         353 => (16#19F6#, 16#0020#, 16#0002#),
         354 => (16#0000#, 16#002D#, 16#0002#),
         355 => (16#19F6#, 16#0020#, 16#0008#),
         356 => (16#0000#, 16#0032#, 16#0002#),
         357 => (16#19F6#, 16#0020#, 16#0002#),
         358 => (16#0000#, 16#0032#, 16#0002#),
         359 => (16#19F6#, 16#0020#, 16#0008#),
         360 => (16#0000#, 16#0026#, 16#0002#),
         361 => (16#19F6#, 16#0020#, 16#0002#),
         362 => (16#0000#, 16#0026#, 16#0002#),
         363 => (16#19F6#, 16#0020#, 16#0008#),
         364 => (16#0000#, 16#0031#, 16#0002#),
         365 => (16#19F6#, 16#0020#, 16#0002#),
         366 => (16#0000#, 16#0031#, 16#0002#),
         367 => (16#19F6#, 16#0020#, 16#0008#),
         368 => (16#0000#, 16#002E#, 16#0002#),
         369 => (16#19FA#, 16#0020#, 16#0002#),
         370 => (16#19F6#, 16#0020#, 16#000A#),
         371 => (16#1A10#, 16#0020#, 16#000A#),
         372 => (16#19F6#, 16#0020#, 16#0004#),
         373 => (16#1A10#, 16#0020#, 16#0004#),
         374 => (16#1A10#, 16#0020#, 16#0008#),
         375 => (16#0000#, 16#0027#, 16#0002#),
         376 => (16#1A10#, 16#0020#, 16#0002#),
         377 => (16#0000#, 16#0027#, 16#0002#),
         378 => (16#1A29#, 16#0020#, 16#0008#),
         379 => (16#0000#, 16#0030#, 16#0002#),
         380 => (16#1A29#, 16#0020#, 16#0002#),
         381 => (16#0000#, 16#0030#, 16#0002#),
         382 => (16#1AF1#, 16#0020#, 16#0002#),
         383 => (16#1A3B#, 16#0020#, 16#0008#),
         384 => (16#0000#, 16#0024#, 16#0002#),
         385 => (16#1A3B#, 16#0020#, 16#0002#),
         386 => (16#0000#, 16#0024#, 16#0002#),
         387 => (16#1A3B#, 16#0020#, 16#0008#),
         388 => (16#0000#, 16#0030#, 16#0002#),
         389 => (16#1A3B#, 16#0020#, 16#0002#),
         390 => (16#0000#, 16#0030#, 16#0002#),
         391 => (16#1A3B#, 16#0020#, 16#0008#),
         392 => (16#0000#, 16#0028#, 16#0002#),
         393 => (16#1A3B#, 16#0020#, 16#0002#),
         394 => (16#0000#, 16#0028#, 16#0002#),
         395 => (16#1A3B#, 16#0020#, 16#0008#),
         396 => (16#0000#, 16#0039#, 16#0002#),
         397 => (16#1A3B#, 16#0020#, 16#0002#),
         398 => (16#0000#, 16#0039#, 16#0002#),
         399 => (16#1A7D#, 16#0020#, 16#0008#),
         400 => (16#0000#, 16#0024#, 16#0002#),
         401 => (16#1A7D#, 16#0020#, 16#0002#),
         402 => (16#0000#, 16#0024#, 16#0002#),
         403 => (16#1A7D#, 16#0020#, 16#0008#),
         404 => (16#0000#, 16#0030#, 16#0002#),
         405 => (16#1A7D#, 16#0020#, 16#0002#),
         406 => (16#0000#, 16#0030#, 16#0002#),
         407 => (16#1A7D#, 16#0020#, 16#0008#),
         408 => (16#0000#, 16#0028#, 16#0002#),
         409 => (16#1A7D#, 16#0020#, 16#0002#),
         410 => (16#0000#, 16#0028#, 16#0002#),
         411 => (16#1C3D#, 16#0020#, 16#0004#),
         412 => (16#1A7D#, 16#0020#, 16#0004#),
         413 => (16#1A9C#, 16#0020#, 16#0008#),
         414 => (16#1A9C#, 16#0020#, 16#0002#),
         415 => (16#1AA1#, 16#0020#, 16#0008#),
         416 => (16#0000#, 16#0032#, 16#0002#),
         417 => (16#1AA1#, 16#0020#, 16#0002#),
         418 => (16#0000#, 16#0032#, 16#0002#),
         419 => (16#1AA1#, 16#0020#, 16#0008#),
         420 => (16#0000#, 16#0026#, 16#0002#),
         421 => (16#1AA1#, 16#0020#, 16#0002#),
         422 => (16#0000#, 16#0026#, 16#0002#),
         423 => (16#1AA1#, 16#0020#, 16#0008#),
         424 => (16#0000#, 16#002C#, 16#0002#),
         425 => (16#1AA1#, 16#0020#, 16#0002#),
         426 => (16#0000#, 16#002C#, 16#0002#),
         427 => (16#1AA1#, 16#0020#, 16#000A#),
         428 => (16#0000#, 16#0108#, 16#0004#),
         429 => (16#196E#, 16#0020#, 16#000A#),
         430 => (16#1AA1#, 16#0020#, 16#0004#),
         431 => (16#0000#, 16#0108#, 16#0004#),
         432 => (16#196E#, 16#0020#, 16#0004#),
         433 => (16#1AF5#, 16#0020#, 16#0008#),
         434 => (16#0000#, 16#0024#, 16#0002#),
         435 => (16#1AF5#, 16#0020#, 16#0002#),
         436 => (16#0000#, 16#0024#, 16#0002#),
         437 => (16#1AF5#, 16#0020#, 16#0008#),
         438 => (16#0000#, 16#0030#, 16#0002#),
         439 => (16#1AF5#, 16#0020#, 16#0002#),
         440 => (16#0000#, 16#0030#, 16#0002#),
         441 => (16#1AF5#, 16#0020#, 16#0008#),
         442 => (16#0000#, 16#0028#, 16#0002#),
         443 => (16#1AF5#, 16#0020#, 16#0002#),
         444 => (16#0000#, 16#0028#, 16#0002#),
         445 => (16#1B33#, 16#0020#, 16#0008#),
         446 => (16#0000#, 16#0024#, 16#0002#),
         447 => (16#1B33#, 16#0020#, 16#0002#),
         448 => (16#0000#, 16#0024#, 16#0002#),
         449 => (16#1B33#, 16#0020#, 16#0008#),
         450 => (16#0000#, 16#0027#, 16#0002#),
         451 => (16#1B33#, 16#0020#, 16#0002#),
         452 => (16#0000#, 16#0027#, 16#0002#),
         453 => (16#1B33#, 16#0020#, 16#0008#),
         454 => (16#0000#, 16#0030#, 16#0002#),
         455 => (16#1B33#, 16#0020#, 16#0002#),
         456 => (16#0000#, 16#0030#, 16#0002#),
         457 => (16#1B33#, 16#0020#, 16#0008#),
         458 => (16#0000#, 16#0028#, 16#0002#),
         459 => (16#1B33#, 16#0020#, 16#0002#),
         460 => (16#0000#, 16#0028#, 16#0002#),
         461 => (16#1B57#, 16#0020#, 16#0008#),
         462 => (16#0000#, 16#0030#, 16#0002#),
         463 => (16#1B57#, 16#0020#, 16#0002#),
         464 => (16#0000#, 16#0030#, 16#0002#),
         465 => (16#1B57#, 16#0020#, 16#0008#),
         466 => (16#0000#, 16#0028#, 16#0002#),
         467 => (16#1B57#, 16#0020#, 16#0002#),
         468 => (16#0000#, 16#0028#, 16#0002#),
         469 => (16#1B5C#, 16#0020#, 16#0008#),
         470 => (16#1B5C#, 16#0020#, 16#0002#),
         471 => (16#1B77#, 16#0020#, 16#0008#),
         472 => (16#0000#, 16#002D#, 16#0002#),
         473 => (16#1B77#, 16#0020#, 16#0002#),
         474 => (16#0000#, 16#002D#, 16#0002#),
         475 => (16#1B77#, 16#0020#, 16#0008#),
         476 => (16#0000#, 16#0032#, 16#0002#),
         477 => (16#1B77#, 16#0020#, 16#0002#),
         478 => (16#0000#, 16#0032#, 16#0002#),
         479 => (16#1B77#, 16#0020#, 16#0008#),
         480 => (16#0000#, 16#0026#, 16#0002#),
         481 => (16#1B77#, 16#0020#, 16#0002#),
         482 => (16#0000#, 16#0026#, 16#0002#),
         483 => (16#1B77#, 16#0020#, 16#0008#),
         484 => (16#0000#, 16#0029#, 16#0002#),
         485 => (16#1B77#, 16#0020#, 16#0002#),
         486 => (16#0000#, 16#0029#, 16#0002#),
         487 => (16#1B77#, 16#0020#, 16#0008#),
         488 => (16#0000#, 16#002C#, 16#0002#),
         489 => (16#1B77#, 16#0020#, 16#0002#),
         490 => (16#0000#, 16#002C#, 16#0002#),
         491 => (16#1B77#, 16#0020#, 16#0008#),
         492 => (16#0000#, 16#0031#, 16#0002#),
         493 => (16#1B77#, 16#0020#, 16#0002#),
         494 => (16#0000#, 16#0031#, 16#0002#),
         495 => (16#1BB7#, 16#0020#, 16#0008#),
         496 => (16#0000#, 16#0027#, 16#0002#),
         497 => (16#1BB7#, 16#0020#, 16#0002#),
         498 => (16#0000#, 16#0027#, 16#0002#),
         499 => (16#1BCD#, 16#0020#, 16#0008#),
         500 => (16#0000#, 16#0027#, 16#0002#),
         501 => (16#1BCD#, 16#0020#, 16#0002#),
         502 => (16#0000#, 16#0027#, 16#0002#),
         503 => (16#1BCD#, 16#0020#, 16#0008#),
         504 => (16#0000#, 16#002B#, 16#0002#),
         505 => (16#1BE3#, 16#0020#, 16#0008#),
         506 => (16#0000#, 16#0024#, 16#0002#),
         507 => (16#1BE3#, 16#0020#, 16#0002#),
         508 => (16#0000#, 16#0024#, 16#0002#),
         509 => (16#1BE3#, 16#0020#, 16#0008#),
         510 => (16#0000#, 16#002E#, 16#0002#),
         511 => (16#1BE3#, 16#0020#, 16#0002#),
         512 => (16#0000#, 16#002E#, 16#0002#),
         513 => (16#1BE3#, 16#0020#, 16#0008#),
         514 => (16#0000#, 16#0028#, 16#0002#),
         515 => (16#1BE3#, 16#0020#, 16#0002#),
         516 => (16#0000#, 16#0028#, 16#0002#),
         517 => (16#1B33#, 16#0020#, 16#0004#),
         518 => (16#0000#, 16#0109#, 16#0004#),
         519 => (16#192D#, 16#0020#, 16#0002#),
         520 => (16#1936#, 16#0020#, 16#0008#),
         521 => (16#193A#, 16#0020#, 16#0008#),
         522 => (16#193A#, 16#0020#, 16#0002#),
         523 => (16#1C30#, 16#0020#, 16#0008#),
         524 => (16#1C30#, 16#0020#, 16#0002#),
         525 => (16#1AB4#, 16#0020#, 16#0008#),
         526 => (16#1949#, 16#0020#, 16#0008#),
         527 => (16#1949#, 16#0020#, 16#0002#),
         528 => (16#195B#, 16#0020#, 16#0008#),
         529 => (16#195F#, 16#0020#, 16#0008#),
         530 => (16#1964#, 16#0020#, 16#0008#),
         531 => (16#1964#, 16#0020#, 16#0002#),
         532 => (16#1BE3#, 16#0020#, 16#0004#),
         533 => (16#1BB7#, 16#0020#, 16#0004#),
         534 => (16#197C#, 16#0020#, 16#0008#),
         535 => (16#1981#, 16#0020#, 16#0008#),
         536 => (16#1986#, 16#0020#, 16#0008#),
         537 => (16#19B2#, 16#0020#, 16#0008#),
         538 => (16#19B2#, 16#0020#, 16#0002#),
         539 => (16#19CA#, 16#0020#, 16#0008#),
         540 => (16#19D4#, 16#0020#, 16#0008#),
         541 => (16#19E4#, 16#0020#, 16#0002#),
         542 => (16#1A0B#, 16#0020#, 16#0008#),
         543 => (16#1A05#, 16#0020#, 16#0008#),
         544 => (16#1A2F#, 16#0020#, 16#0008#),
         545 => (16#1A2F#, 16#0020#, 16#0002#),
         546 => (16#1A46#, 16#0020#, 16#0002#),
         547 => (16#1A66#, 16#0020#, 16#0002#),
         548 => (16#1B96#, 16#0020#, 16#0008#),
         549 => (16#1A88#, 16#0020#, 16#0008#),
         550 => (16#1A8C#, 16#0020#, 16#0002#),
         551 => (16#1AC0#, 16#0020#, 16#0008#),
         552 => (16#1AA1#, 16#0020#, 16#0008#),
         553 => (16#0000#, 16#003F#, 16#0002#),
         554 => (16#1AA1#, 16#0020#, 16#0002#),
         555 => (16#0000#, 16#003F#, 16#0002#),
         556 => (16#19D8#, 16#0020#, 16#0008#),
         557 => (16#19D8#, 16#0020#, 16#0002#),
         558 => (16#1AD7#, 16#0020#, 16#0008#),
         559 => (16#1AD7#, 16#0020#, 16#0002#),
         560 => (16#1AFA#, 16#0020#, 16#0008#),
         561 => (16#1C28#, 16#0020#, 16#0008#),
         562 => (16#1C28#, 16#0020#, 16#0002#),
         563 => (16#1B44#, 16#0020#, 16#0008#),
         564 => (16#1B4A#, 16#0020#, 16#0002#),
         565 => (16#1B62#, 16#0020#, 16#0002#),
         566 => (16#1B66#, 16#0020#, 16#0008#),
         567 => (16#1B66#, 16#0020#, 16#0002#),
         568 => (16#1B6A#, 16#0020#, 16#0008#),
         569 => (16#1B77#, 16#0020#, 16#0008#),
         570 => (16#0000#, 16#003F#, 16#0002#),
         571 => (16#1B77#, 16#0020#, 16#0002#),
         572 => (16#0000#, 16#003F#, 16#0002#),
         573 => (16#1BA0#, 16#0020#, 16#0008#),
         574 => (16#1BAC#, 16#0020#, 16#0008#),
         575 => (16#1BD9#, 16#0020#, 16#0008#),
         576 => (16#1BD9#, 16#0020#, 16#0002#),
         577 => (16#1BE8#, 16#0020#, 16#0008#),
         578 => (16#1BE8#, 16#0020#, 16#0002#),
         579 => (16#1C00#, 16#0020#, 16#0008#),
         580 => (16#1C05#, 16#0020#, 16#0008#),
         581 => (16#1C05#, 16#0020#, 16#0002#),
         582 => (16#1C0A#, 16#0020#, 16#0002#),
         583 => (16#1C21#, 16#0020#, 16#0002#),
         584 => (16#1C2C#, 16#0020#, 16#0008#),
         585 => (16#1C2C#, 16#0020#, 16#0002#),
         586 => (16#1B57#, 16#0020#, 16#0004#),
         587 => (16#1B33#, 16#0020#, 16#0004#),
         588 => (16#1C18#, 16#0020#, 16#0002#),
         589 => (16#1C57#, 16#0020#, 16#0002#),
         590 => (16#1C5B#, 16#0020#, 16#0002#),
         591 => (16#1C5F#, 16#0020#, 16#0002#),
         592 => (16#1C63#, 16#0020#, 16#0002#),
         593 => (16#1953#, 16#0020#, 16#000A#),
         594 => (16#1BE3#, 16#0020#, 16#000A#),
         595 => (16#0000#, 16#0028#, 16#0004#),
         596 => (16#1953#, 16#0020#, 16#000A#),
         597 => (16#1BE3#, 16#0020#, 16#0004#),
         598 => (16#0000#, 16#0028#, 16#0004#),
         599 => (16#1953#, 16#0020#, 16#0004#),
         600 => (16#1BE3#, 16#0020#, 16#0004#),
         601 => (16#0000#, 16#0028#, 16#0004#),
         602 => (16#1A3B#, 16#0020#, 16#000A#),
         603 => (16#1A10#, 16#0020#, 16#000A#),
         604 => (16#1A3B#, 16#0020#, 16#000A#),
         605 => (16#1A10#, 16#0020#, 16#0004#),
         606 => (16#1A3B#, 16#0020#, 16#0004#),
         607 => (16#1A10#, 16#0020#, 16#0004#),
         608 => (16#1A7D#, 16#0020#, 16#000A#),
         609 => (16#1A10#, 16#0020#, 16#000A#),
         610 => (16#1A7D#, 16#0020#, 16#000A#),
         611 => (16#1A10#, 16#0020#, 16#0004#),
         612 => (16#1A7D#, 16#0020#, 16#0004#),
         613 => (16#1A10#, 16#0020#, 16#0004#),
         614 => (16#190C#, 16#0020#, 16#0008#),
         615 => (16#0000#, 16#0028#, 16#0002#),
         616 => (16#190C#, 16#0020#, 16#0002#),
         617 => (16#0000#, 16#0028#, 16#0002#),
         618 => (16#19F6#, 16#0020#, 16#0008#),
         619 => (16#0000#, 16#0028#, 16#0002#),
         620 => (16#19F6#, 16#0020#, 16#0002#),
         621 => (16#0000#, 16#0028#, 16#0002#),
         622 => (16#1AA1#, 16#0020#, 16#0008#),
         623 => (16#0000#, 16#0028#, 16#0002#),
         624 => (16#1AA1#, 16#0020#, 16#0002#),
         625 => (16#0000#, 16#0028#, 16#0002#),
         626 => (16#1B77#, 16#0020#, 16#0008#),
         627 => (16#0000#, 16#0028#, 16#0002#),
         628 => (16#1B77#, 16#0020#, 16#0002#),
         629 => (16#0000#, 16#0028#, 16#0002#),
         630 => (16#1B77#, 16#0020#, 16#0008#),
         631 => (16#0000#, 16#002B#, 16#0002#),
         632 => (16#0000#, 16#0032#, 16#0002#),
         633 => (16#1B77#, 16#0020#, 16#0002#),
         634 => (16#0000#, 16#002B#, 16#0002#),
         635 => (16#0000#, 16#0032#, 16#0002#),
         636 => (16#1B77#, 16#0020#, 16#0008#),
         637 => (16#0000#, 16#002B#, 16#0002#),
         638 => (16#0000#, 16#0024#, 16#0002#),
         639 => (16#1B77#, 16#0020#, 16#0002#),
         640 => (16#0000#, 16#002B#, 16#0002#),
         641 => (16#0000#, 16#0024#, 16#0002#),
         642 => (16#1B77#, 16#0020#, 16#0008#),
         643 => (16#0000#, 16#002B#, 16#0002#),
         644 => (16#0000#, 16#0028#, 16#0002#),
         645 => (16#1B77#, 16#0020#, 16#0002#),
         646 => (16#0000#, 16#002B#, 16#0002#),
         647 => (16#0000#, 16#0028#, 16#0002#),
         648 => (16#1B77#, 16#0020#, 16#0008#),
         649 => (16#0000#, 16#002B#, 16#0002#),
         650 => (16#0000#, 16#0025#, 16#0002#),
         651 => (16#1B77#, 16#0020#, 16#0002#),
         652 => (16#0000#, 16#002B#, 16#0002#),
         653 => (16#0000#, 16#0025#, 16#0002#),
         654 => (16#197C#, 16#0020#, 16#0002#),
         655 => (16#190C#, 16#0020#, 16#0008#),
         656 => (16#0000#, 16#002B#, 16#0002#),
         657 => (16#0000#, 16#0032#, 16#0002#),
         658 => (16#190C#, 16#0020#, 16#0002#),
         659 => (16#0000#, 16#002B#, 16#0002#),
         660 => (16#0000#, 16#0032#, 16#0002#),
         661 => (16#190C#, 16#0020#, 16#0008#),
         662 => (16#0000#, 16#002E#, 16#0002#),
         663 => (16#0000#, 16#0032#, 16#0002#),
         664 => (16#190C#, 16#0020#, 16#0002#),
         665 => (16#0000#, 16#002E#, 16#0002#),
         666 => (16#0000#, 16#0032#, 16#0002#),
         667 => (16#190C#, 16#0020#, 16#000A#),
         668 => (16#0000#, 16#0108#, 16#0004#),
         669 => (16#196E#, 16#0020#, 16#000A#),
         670 => (16#0000#, 16#0032#, 16#0002#),
         671 => (16#190C#, 16#0020#, 16#0004#),
         672 => (16#0000#, 16#0108#, 16#0004#),
         673 => (16#196E#, 16#0020#, 16#0004#),
         674 => (16#0000#, 16#0032#, 16#0002#),
         675 => (16#19C5#, 16#0020#, 16#0008#),
         676 => (16#19C5#, 16#0020#, 16#0002#),
         677 => (16#19B8#, 16#0020#, 16#0008#),
         678 => (16#0000#, 16#0028#, 16#0002#),
         679 => (16#19B8#, 16#0020#, 16#0002#),
         680 => (16#0000#, 16#0028#, 16#0002#),
         681 => (16#1A29#, 16#0020#, 16#0008#),
         682 => (16#0000#, 16#0028#, 16#0002#),
         683 => (16#1A29#, 16#0020#, 16#0002#),
         684 => (16#0000#, 16#0028#, 16#0002#),
         685 => (16#1AA1#, 16#0020#, 16#0008#),
         686 => (16#0000#, 16#0031#, 16#0002#),
         687 => (16#1AA1#, 16#0020#, 16#0002#),
         688 => (16#0000#, 16#0031#, 16#0002#),
         689 => (16#1AA1#, 16#0020#, 16#0008#),
         690 => (16#0000#, 16#0031#, 16#0002#),
         691 => (16#0000#, 16#0032#, 16#0002#),
         692 => (16#1AA1#, 16#0020#, 16#0002#),
         693 => (16#0000#, 16#0031#, 16#0002#),
         694 => (16#0000#, 16#0032#, 16#0002#),
         695 => (16#1C00#, 16#0020#, 16#0008#),
         696 => (16#0000#, 16#0028#, 16#0002#),
         697 => (16#1C00#, 16#0020#, 16#0002#),
         698 => (16#0000#, 16#0028#, 16#0002#),
         699 => (16#1A10#, 16#0020#, 16#0002#),
         700 => (16#0000#, 16#0028#, 16#0002#),
         701 => (16#19B8#, 16#0020#, 16#0008#),
         702 => (16#0000#, 16#0024#, 16#0002#),
         703 => (16#19B8#, 16#0020#, 16#0002#),
         704 => (16#0000#, 16#0024#, 16#0002#),
         705 => (16#19E4#, 16#0020#, 16#0008#),
         706 => (16#1C18#, 16#0020#, 16#0008#),
         707 => (16#1A7D#, 16#0020#, 16#0008#),
         708 => (16#0000#, 16#0025#, 16#0002#),
         709 => (16#1A7D#, 16#0020#, 16#0002#),
         710 => (16#0000#, 16#0025#, 16#0002#),
         711 => (16#190C#, 16#0020#, 16#0008#),
         712 => (16#0000#, 16#0029#, 16#0002#),
         713 => (16#0000#, 16#0024#, 16#0002#),
         714 => (16#190C#, 16#0020#, 16#0002#),
         715 => (16#0000#, 16#0029#, 16#0002#),
         716 => (16#0000#, 16#0024#, 16#0002#),
         717 => (16#190C#, 16#0020#, 16#000A#),
         718 => (16#0000#, 16#0108#, 16#0004#),
         719 => (16#196E#, 16#0020#, 16#000A#),
         720 => (16#0000#, 16#0024#, 16#0002#),
         721 => (16#190C#, 16#0020#, 16#0004#),
         722 => (16#0000#, 16#0108#, 16#0004#),
         723 => (16#196E#, 16#0020#, 16#0004#),
         724 => (16#0000#, 16#0024#, 16#0002#),
         725 => (16#1AA1#, 16#0020#, 16#0008#),
         726 => (16#0000#, 16#002F#, 16#0002#),
         727 => (16#0000#, 16#0024#, 16#0002#),
         728 => (16#1AA1#, 16#0020#, 16#0002#),
         729 => (16#0000#, 16#002F#, 16#0002#),
         730 => (16#0000#, 16#0024#, 16#0002#),
         731 => (16#190C#, 16#0020#, 16#0008#),
         732 => (16#0000#, 16#003C#, 16#0002#),
         733 => (16#190C#, 16#0020#, 16#0002#),
         734 => (16#0000#, 16#003C#, 16#0002#),
         735 => (16#190C#, 16#0020#, 16#0008#),
         736 => (16#0000#, 16#003E#, 16#0002#),
         737 => (16#190C#, 16#0020#, 16#0002#),
         738 => (16#0000#, 16#003E#, 16#0002#),
         739 => (16#196E#, 16#0020#, 16#0008#),
         740 => (16#0000#, 16#003C#, 16#0002#),
         741 => (16#196E#, 16#0020#, 16#0002#),
         742 => (16#0000#, 16#003C#, 16#0002#),
         743 => (16#196E#, 16#0020#, 16#0008#),
         744 => (16#0000#, 16#003E#, 16#0002#),
         745 => (16#196E#, 16#0020#, 16#0002#),
         746 => (16#0000#, 16#003E#, 16#0002#),
         747 => (16#19F6#, 16#0020#, 16#0008#),
         748 => (16#0000#, 16#003C#, 16#0002#),
         749 => (16#19F6#, 16#0020#, 16#0002#),
         750 => (16#0000#, 16#003C#, 16#0002#),
         751 => (16#19F6#, 16#0020#, 16#0008#),
         752 => (16#0000#, 16#003E#, 16#0002#),
         753 => (16#19F6#, 16#0020#, 16#0002#),
         754 => (16#0000#, 16#003E#, 16#0002#),
         755 => (16#1AA1#, 16#0020#, 16#0008#),
         756 => (16#0000#, 16#003C#, 16#0002#),
         757 => (16#1AA1#, 16#0020#, 16#0002#),
         758 => (16#0000#, 16#003C#, 16#0002#),
         759 => (16#1AA1#, 16#0020#, 16#0008#),
         760 => (16#0000#, 16#003E#, 16#0002#),
         761 => (16#1AA1#, 16#0020#, 16#0002#),
         762 => (16#0000#, 16#003E#, 16#0002#),
         763 => (16#1AF5#, 16#0020#, 16#0008#),
         764 => (16#0000#, 16#003C#, 16#0002#),
         765 => (16#1AF5#, 16#0020#, 16#0002#),
         766 => (16#0000#, 16#003C#, 16#0002#),
         767 => (16#1AF5#, 16#0020#, 16#0008#),
         768 => (16#0000#, 16#003E#, 16#0002#),
         769 => (16#1AF5#, 16#0020#, 16#0002#),
         770 => (16#0000#, 16#003E#, 16#0002#),
         771 => (16#1B77#, 16#0020#, 16#0008#),
         772 => (16#0000#, 16#003C#, 16#0002#),
         773 => (16#1B77#, 16#0020#, 16#0002#),
         774 => (16#0000#, 16#003C#, 16#0002#),
         775 => (16#1B77#, 16#0020#, 16#0008#),
         776 => (16#0000#, 16#003E#, 16#0002#),
         777 => (16#1B77#, 16#0020#, 16#0002#),
         778 => (16#0000#, 16#003E#, 16#0002#),
         779 => (16#1B33#, 16#0020#, 16#0008#),
         780 => (16#0000#, 16#0045#, 16#0002#),
         781 => (16#1B33#, 16#0020#, 16#0002#),
         782 => (16#0000#, 16#0045#, 16#0002#),
         783 => (16#1B57#, 16#0020#, 16#0008#),
         784 => (16#0000#, 16#0045#, 16#0002#),
         785 => (16#1B57#, 16#0020#, 16#0002#),
         786 => (16#0000#, 16#0045#, 16#0002#),
         787 => (16#1BDF#, 16#0020#, 16#0008#),
         788 => (16#1BDF#, 16#0020#, 16#0002#),
         789 => (16#19DC#, 16#0020#, 16#0008#),
         790 => (16#0000#, 16#0028#, 16#0002#),
         791 => (16#19DC#, 16#0020#, 16#0002#),
         792 => (16#0000#, 16#0028#, 16#0002#),
         793 => (16#1A8C#, 16#0020#, 16#0008#),
         794 => (16#1968#, 16#0020#, 16#0002#),
         795 => (16#1AC9#, 16#0020#, 16#0008#),
         796 => (16#1AC9#, 16#0020#, 16#0002#),
         797 => (16#1BEE#, 16#0020#, 16#0008#),
         798 => (16#1BEE#, 16#0020#, 16#0002#),
         799 => (16#196E#, 16#0020#, 16#0008#),
         800 => (16#0000#, 16#0030#, 16#0002#),
         801 => (16#196E#, 16#0020#, 16#0002#),
         802 => (16#0000#, 16#0030#, 16#0002#),
         803 => (16#1AA1#, 16#0020#, 16#0008#),
         804 => (16#0000#, 16#002B#, 16#0002#),
         805 => (16#0000#, 16#0032#, 16#0002#),
         806 => (16#1AA1#, 16#0020#, 16#0002#),
         807 => (16#0000#, 16#002B#, 16#0002#),
         808 => (16#0000#, 16#0032#, 16#0002#),
         809 => (16#1AA1#, 16#0020#, 16#0008#),
         810 => (16#0000#, 16#002D#, 16#0002#),
         811 => (16#0000#, 16#0032#, 16#0002#),
         812 => (16#1AA1#, 16#0020#, 16#0002#),
         813 => (16#0000#, 16#002D#, 16#0002#),
         814 => (16#0000#, 16#0032#, 16#0002#),
         815 => (16#1AA1#, 16#0020#, 16#0008#),
         816 => (16#0000#, 16#002E#, 16#0002#),
         817 => (16#1AA1#, 16#0020#, 16#0002#),
         818 => (16#0000#, 16#002E#, 16#0002#),
         819 => (16#1AA1#, 16#0020#, 16#0008#),
         820 => (16#0000#, 16#002E#, 16#0002#),
         821 => (16#0000#, 16#0032#, 16#0002#),
         822 => (16#1AA1#, 16#0020#, 16#0002#),
         823 => (16#0000#, 16#002E#, 16#0002#),
         824 => (16#0000#, 16#0032#, 16#0002#),
         825 => (16#1BCD#, 16#0020#, 16#0008#),
         826 => (16#0000#, 16#0032#, 16#0002#),
         827 => (16#1BCD#, 16#0020#, 16#0002#),
         828 => (16#0000#, 16#0032#, 16#0002#),
         829 => (16#1A5C#, 16#0020#, 16#0002#),
         830 => (16#1A96#, 16#0020#, 16#0002#),
         831 => (16#1B6E#, 16#0020#, 16#0002#),
         832 => (16#1A14#, 16#0020#, 16#0002#),
         833 => (16#1953#, 16#0020#, 16#0004#),
         834 => (16#1925#, 16#0020#, 16#0004#),
         835 => (16#1AE3#, 16#0020#, 16#0004#),
         836 => (16#1ACE#, 16#0020#, 16#0004#),
         837 => (16#1911#, 16#0020#, 16#0008#),
         838 => (16#1943#, 16#0020#, 16#0008#),
         839 => (16#1943#, 16#0020#, 16#0002#),
         840 => (16#1A46#, 16#0020#, 16#0008#),
         841 => (16#1B60#, 16#0020#, 16#0008#),
         842 => (16#1B3E#, 16#0020#, 16#0002#),
         843 => (16#1BFA#, 16#0020#, 16#0002#),
         844 => (16#1C38#, 16#0020#, 16#0008#),
         845 => (16#1C38#, 16#0020#, 16#0002#),
         846 => (16#192D#, 16#0020#, 16#0008#),
         847 => (16#1B82#, 16#0020#, 16#0008#),
         848 => (16#1BB3#, 16#0020#, 16#0008#),
         849 => (16#1975#, 16#0020#, 16#0008#),
         850 => (16#1975#, 16#0020#, 16#0002#),
         851 => (16#1A19#, 16#0020#, 16#0008#),
         852 => (16#1A19#, 16#0020#, 16#0002#),
         853 => (16#1AED#, 16#0020#, 16#0008#),
         854 => (16#1AED#, 16#0020#, 16#0002#),
         855 => (16#1B01#, 16#0020#, 16#0008#),
         856 => (16#1B01#, 16#0020#, 16#0002#),
         857 => (16#1BD5#, 16#0020#, 16#0008#),
         858 => (16#1BD5#, 16#0020#, 16#0002#),
         859 => (16#1916#, 16#0020#, 16#0002#),
         860 => (16#191A#, 16#0020#, 16#0002#),
         861 => (16#1920#, 16#0020#, 16#0002#),
         862 => (16#1936#, 16#0020#, 16#0002#),
         863 => (16#1AB4#, 16#0020#, 16#0002#),
         864 => (16#194D#, 16#0020#, 16#0002#),
         865 => (16#195B#, 16#0020#, 16#0002#),
         866 => (16#195F#, 16#0020#, 16#0002#),
         867 => (16#198B#, 16#0020#, 16#0002#),
         868 => (16#1981#, 16#0020#, 16#0002#),
         869 => (16#198F#, 16#0020#, 16#0002#),
         870 => (16#1986#, 16#0020#, 16#0002#),
         871 => (16#1993#, 16#0020#, 16#0002#),
         872 => (16#1999#, 16#0020#, 16#0002#),
         873 => (16#199D#, 16#0020#, 16#0002#),
         874 => (16#1A21#, 16#0020#, 16#0002#),
         875 => (16#19CA#, 16#0020#, 16#0002#),
         876 => (16#19BC#, 16#0020#, 16#0002#),
         877 => (16#19C1#, 16#0020#, 16#0002#),
         878 => (16#19D4#, 16#0020#, 16#0002#),
         879 => (16#19A5#, 16#0020#, 16#0002#),
         880 => (16#1B8A#, 16#0020#, 16#0002#),
         881 => (16#19E9#, 16#0020#, 16#0002#),
         882 => (16#19F0#, 16#0020#, 16#0002#),
         883 => (16#1A05#, 16#0020#, 16#0002#),
         884 => (16#1A0B#, 16#0020#, 16#0002#),
         885 => (16#19FE#, 16#0020#, 16#0002#),
         886 => (16#1A4B#, 16#0020#, 16#0002#),
         887 => (16#1A51#, 16#0020#, 16#0002#),
         888 => (16#1A57#, 16#0020#, 16#0002#),
         889 => (16#1A61#, 16#0020#, 16#0002#),
         890 => (16#1B96#, 16#0020#, 16#0002#),
         891 => (16#1B9C#, 16#0020#, 16#0002#),
         892 => (16#1A75#, 16#0020#, 16#0002#),
         893 => (16#1A88#, 16#0020#, 16#0002#),
         894 => (16#1A92#, 16#0020#, 16#0002#),
         895 => (16#1A81#, 16#0020#, 16#0002#),
         896 => (16#1AC0#, 16#0020#, 16#0002#),
         897 => (16#1AA8#, 16#0020#, 16#0002#),
         898 => (16#1AC5#, 16#0020#, 16#0002#),
         899 => (16#1ADE#, 16#0020#, 16#0002#),
         900 => (16#1B06#, 16#0020#, 16#0002#),
         901 => (16#1B0B#, 16#0020#, 16#0002#),
         902 => (16#1B10#, 16#0020#, 16#0002#),
         903 => (16#1B15#, 16#0020#, 16#0002#),
         904 => (16#1B19#, 16#0020#, 16#0002#),
         905 => (16#1B1E#, 16#0020#, 16#0002#),
         906 => (16#1B23#, 16#0020#, 16#0002#),
         907 => (16#1AFA#, 16#0020#, 16#0002#),
         908 => (16#1B2C#, 16#0020#, 16#0002#),
         909 => (16#1B3A#, 16#0020#, 16#0002#),
         910 => (16#1B44#, 16#0020#, 16#0002#),
         911 => (16#1A25#, 16#0020#, 16#0002#),
         912 => (16#1B4E#, 16#0020#, 16#0002#),
         913 => (16#1B53#, 16#0020#, 16#0002#),
         914 => (16#1B73#, 16#0020#, 16#0002#),
         915 => (16#1B6A#, 16#0020#, 16#0002#),
         916 => (16#1B82#, 16#0020#, 16#0002#),
         917 => (16#1BA0#, 16#0020#, 16#0002#),
         918 => (16#1BAC#, 16#0020#, 16#0002#),
         919 => (16#1BB3#, 16#0020#, 16#0002#),
         920 => (16#1BBD#, 16#0020#, 16#0002#),
         921 => (16#1A6A#, 16#0020#, 16#0002#),
         922 => (16#1BD1#, 16#0020#, 16#0002#),
         923 => (16#1BF2#, 16#0020#, 16#0002#),
         924 => (16#1BF6#, 16#0020#, 16#0002#),
         925 => (16#1C0E#, 16#0020#, 16#0002#),
         926 => (16#1C34#, 16#0020#, 16#0002#),
         927 => (16#1C42#, 16#0020#, 16#0002#),
         928 => (16#1C53#, 16#0020#, 16#0002#),
         929 => (16#1C67#, 16#0020#, 16#0002#),
         930 => (16#1C6B#, 16#0020#, 16#0002#),
         931 => (16#1929#, 16#0020#, 16#0002#),
         932 => (16#19A1#, 16#0020#, 16#0002#),
         933 => (16#19CE#, 16#0020#, 16#0002#),
         934 => (16#19E0#, 16#0020#, 16#0002#),
         935 => (16#1A1D#, 16#0020#, 16#0002#),
         936 => (16#1A37#, 16#0020#, 16#0002#),
         937 => (16#1A3F#, 16#0020#, 16#0002#),
         938 => (16#1AE9#, 16#0020#, 16#0002#),
         939 => (16#1C4B#, 16#0020#, 16#0002#),
         940 => (16#1C4F#, 16#0020#, 16#0002#),
         941 => (16#1953#, 16#0020#, 16#0004#),
         942 => (16#1C00#, 16#0020#, 16#0004#),
         943 => (16#1953#, 16#0020#, 16#0004#),
         944 => (16#1BF6#, 16#0020#, 16#0004#),
         945 => (16#1B57#, 16#0020#, 16#0004#),
         946 => (16#1B44#, 16#0020#, 16#0004#),
         947 => (16#1B57#, 16#0020#, 16#0004#),
         948 => (16#194D#, 16#0020#, 16#0004#),
         949 => (16#19A9#, 16#0020#, 16#0004#),
         950 => (16#1A9C#, 16#0020#, 16#0004#),
         951 => (16#1A3B#, 16#0020#, 16#0004#),
         952 => (16#1B33#, 16#0020#, 16#0004#),
         953 => (16#1A3B#, 16#0020#, 16#0004#),
         954 => (16#1BE3#, 16#0020#, 16#0004#),
         955 => (16#1C6F#, 16#0020#, 16#0002#),
         956 => (16#1C73#, 16#0020#, 16#0002#),
         957 => (16#1B8E#, 16#0020#, 16#0002#),
         958 => (16#1B92#, 16#0020#, 16#0002#),
         959 => (16#19DC#, 16#0020#, 16#0014#),
         960 => (16#19E9#, 16#0020#, 16#0014#),
         961 => (16#1A10#, 16#0020#, 16#0014#),
         962 => (16#1AF5#, 16#0020#, 16#0014#),
         963 => (16#1B06#, 16#0020#, 16#0014#),
         964 => (16#1B10#, 16#0020#, 16#0014#),
         965 => (16#1B2C#, 16#0020#, 16#0014#),
         966 => (16#1BB7#, 16#0020#, 16#0014#),
         967 => (16#1BCD#, 16#0020#, 16#0014#),
         968 => (16#0357#, 16#0020#, 16#0002#),
         969 => (16#0359#, 16#0020#, 16#0002#),
         970 => (16#19F4#, 16#0020#, 16#0002#),
         971 => (16#1C3D#, 16#0020#, 16#0002#),
         972 => (16#19F5#, 16#0020#, 16#0002#),
         973 => (16#1C3F#, 16#0020#, 16#0002#),
         974 => (16#1C46#, 16#0020#, 16#0002#),
         975 => (16#1C3C#, 16#0020#, 16#0002#),
         976 => (16#1C47#, 16#0020#, 16#0002#),
         977 => (16#035A#, 16#0020#, 16#0002#),
         978 => (16#035B#, 16#0020#, 16#0002#),
         979 => (16#035C#, 16#0020#, 16#0002#),
         980 => (16#035D#, 16#0020#, 16#0002#),
         981 => (16#035E#, 16#0020#, 16#0002#),
         982 => (16#035F#, 16#0020#, 16#0002#),
         983 => (16#0360#, 16#0020#, 16#0002#),
         984 => (16#0361#, 16#0020#, 16#0002#),
         985 => (16#0362#, 16#0020#, 16#0002#),
         986 => (16#0363#, 16#0020#, 16#0002#),
         987 => (16#0364#, 16#0020#, 16#0002#),
         988 => (16#0365#, 16#0020#, 16#0002#),
         989 => (16#0366#, 16#0020#, 16#0002#),
         990 => (16#0367#, 16#0020#, 16#0002#),
         991 => (16#16B1#, 16#0020#, 16#0002#),
         992 => (16#16B2#, 16#0020#, 16#0002#),
         993 => (16#0368#, 16#0020#, 16#0002#),
         994 => (16#0369#, 16#0020#, 16#0002#),
         995 => (16#036A#, 16#0020#, 16#0002#),
         996 => (16#036B#, 16#0020#, 16#0002#),
         997 => (16#036C#, 16#0020#, 16#0002#),
         998 => (16#036D#, 16#0020#, 16#0002#),
         999 => (16#034B#, 16#0020#, 16#0002#),
         1000 => (16#034C#, 16#0020#, 16#0002#),
         1001 => (16#034E#, 16#0020#, 16#0002#),
         1002 => (16#0351#, 16#0020#, 16#0002#),
         1003 => (16#0348#, 16#0020#, 16#0002#),
         1004 => (16#034F#, 16#0020#, 16#0002#),
         1005 => (16#036E#, 16#0020#, 16#0002#),
         1006 => (16#036F#, 16#0020#, 16#0002#),
         1007 => (16#19D4#, 16#0020#, 16#0014#),
         1008 => (16#1A3B#, 16#0020#, 16#0014#),
         1009 => (16#1B33#, 16#0020#, 16#0014#),
         1010 => (16#1BC1#, 16#0020#, 16#0014#),
         1011 => (16#1C42#, 16#0020#, 16#0014#),
         1012 => (16#0370#, 16#0020#, 16#0002#),
         1013 => (16#0371#, 16#0020#, 16#0002#),
         1014 => (16#0372#, 16#0020#, 16#0002#),
         1015 => (16#0373#, 16#0020#, 16#0002#),
         1016 => (16#0374#, 16#0020#, 16#0002#),
         1017 => (16#0375#, 16#0020#, 16#0002#),
         1018 => (16#0376#, 16#0020#, 16#0002#),
         1019 => (16#0377#, 16#0020#, 16#0002#),
         1020 => (16#0378#, 16#0020#, 16#0002#),
         1021 => (16#1C3E#, 16#0020#, 16#0002#),
         1022 => (16#0379#, 16#0020#, 16#0002#),
         1023 => (16#037A#, 16#0020#, 16#0002#),
         1024 => (16#037B#, 16#0020#, 16#0002#),
         1025 => (16#037C#, 16#0020#, 16#0002#),
         1026 => (16#037D#, 16#0020#, 16#0002#),
         1027 => (16#037E#, 16#0020#, 16#0002#),
         1028 => (16#037F#, 16#0020#, 16#0002#),
         1029 => (16#0380#, 16#0020#, 16#0002#),
         1030 => (16#0381#, 16#0020#, 16#0002#),
         1031 => (16#0382#, 16#0020#, 16#0002#),
         1032 => (16#0383#, 16#0020#, 16#0002#),
         1033 => (16#0384#, 16#0020#, 16#0002#),
         1034 => (16#0385#, 16#0020#, 16#0002#),
         1035 => (16#0386#, 16#0020#, 16#0002#),
         1036 => (16#0387#, 16#0020#, 16#0002#),
         1037 => (16#0388#, 16#0020#, 16#0002#),
         1038 => (16#0389#, 16#0020#, 16#0002#),
         1039 => (16#0000#, 16#003A#, 16#0002#),
         1040 => (16#0000#, 16#003B#, 16#0002#),
         1041 => (16#0000#, 16#0033#, 16#0002#),
         1042 => (16#0000#, 16#003D#, 16#0002#),
         1043 => (16#0000#, 16#0022#, 16#0002#),
         1044 => (16#0000#, 16#0023#, 16#0002#),
         1045 => (16#0000#, 16#0034#, 16#0002#),
         1046 => (16#0000#, 16#0040#, 16#0002#),
         1047 => (16#0000#, 16#0041#, 16#0002#),
         1048 => (16#0000#, 16#0042#, 16#0002#),
         1049 => (16#0000#, 16#0043#, 16#0002#),
         1050 => (16#0000#, 16#0044#, 16#0002#),
         1051 => (16#0000#, 16#0046#, 16#0002#),
         1052 => (16#0000#, 16#0047#, 16#0002#),
         1053 => (16#0000#, 16#0048#, 16#0002#),
         1054 => (16#0000#, 16#0049#, 16#0002#),
         1055 => (16#0000#, 16#0021#, 16#0002#),
         1056 => (16#0000#, 16#004A#, 16#0002#),
         1057 => (16#0000#, 16#0035#, 16#0002#),
         1058 => (16#0000#, 16#004B#, 16#0002#),
         1059 => (16#0000#, 16#002A#, 16#0002#),
         1060 => (16#0000#, 16#004C#, 16#0002#),
         1061 => (16#0000#, 16#004D#, 16#0002#),
         1062 => (16#0000#, 16#004E#, 16#0002#),
         1063 => (16#0000#, 16#004F#, 16#0002#),
         1064 => (16#1B77#, 16#0020#, 16#0004#),
         1065 => (16#193E#, 16#0020#, 16#0004#),
         1066 => (16#19DC#, 16#0020#, 16#0004#),
         1067 => (16#1A6E#, 16#0020#, 16#0004#),
         1068 => (16#1AF5#, 16#0020#, 16#0004#),
         1069 => (16#1BA5#, 16#0020#, 16#0004#),
         1070 => (16#1BC1#, 16#0020#, 16#0004#),
         1071 => (16#1C81#, 16#0020#, 16#0008#),
         1072 => (16#1C81#, 16#0020#, 16#0002#),
         1073 => (16#1CA2#, 16#0020#, 16#0008#),
         1074 => (16#1CA2#, 16#0020#, 16#0002#),
         1075 => (16#0358#, 16#0020#, 16#0002#),
         1076 => (16#1C7E#, 16#0020#, 16#0008#),
         1077 => (16#1C7E#, 16#0020#, 16#0002#),
         1078 => (16#1C84#, 16#0020#, 16#0004#),
         1079 => (16#1C97#, 16#0020#, 16#0002#),
         1080 => (16#1C96#, 16#0020#, 16#0002#),
         1081 => (16#1C98#, 16#0020#, 16#0002#),
         1082 => (16#1C85#, 16#0020#, 16#0008#),
         1083 => (16#034D#, 16#0020#, 16#0002#),
         1084 => (16#0000#, 16#0024#, 16#0002#),
         1085 => (16#1C77#, 16#0020#, 16#0008#),
         1086 => (16#0000#, 16#0024#, 16#0002#),
         1087 => (16#1C7C#, 16#0020#, 16#0008#),
         1088 => (16#0000#, 16#0024#, 16#0002#),
         1089 => (16#1C82#, 16#0020#, 16#0008#),
         1090 => (16#0000#, 16#0024#, 16#0002#),
         1091 => (16#1C84#, 16#0020#, 16#0008#),
         1092 => (16#0000#, 16#0024#, 16#0002#),
         1093 => (16#1C8C#, 16#0020#, 16#0008#),
         1094 => (16#0000#, 16#0024#, 16#0002#),
         1095 => (16#1C9A#, 16#0020#, 16#0008#),
         1096 => (16#0000#, 16#0024#, 16#0002#),
         1097 => (16#1C9F#, 16#0020#, 16#0008#),
         1098 => (16#0000#, 16#0024#, 16#0002#),
         1099 => (16#1C84#, 16#0020#, 16#0002#),
         1100 => (16#0000#, 16#002B#, 16#0002#),
         1101 => (16#0000#, 16#0024#, 16#0002#),
         1102 => (16#1C78#, 16#0020#, 16#0008#),
         1103 => (16#1C79#, 16#0020#, 16#0008#),
         1104 => (16#1C7B#, 16#0020#, 16#0008#),
         1105 => (16#1C80#, 16#0020#, 16#0008#),
         1106 => (16#1C83#, 16#0020#, 16#0008#),
         1107 => (16#1C86#, 16#0020#, 16#0008#),
         1108 => (16#1C87#, 16#0020#, 16#0008#),
         1109 => (16#1C89#, 16#0020#, 16#0008#),
         1110 => (16#1C8A#, 16#0020#, 16#0008#),
         1111 => (16#1C8B#, 16#0020#, 16#0008#),
         1112 => (16#1C8D#, 16#0020#, 16#0008#),
         1113 => (16#1C92#, 16#0020#, 16#0008#),
         1114 => (16#1C95#, 16#0020#, 16#0008#),
         1115 => (16#1C99#, 16#0020#, 16#0008#),
         1116 => (16#1C9B#, 16#0020#, 16#0008#),
         1117 => (16#1C9C#, 16#0020#, 16#0008#),
         1118 => (16#1C9D#, 16#0020#, 16#0008#),
         1119 => (16#1C84#, 16#0020#, 16#0008#),
         1120 => (16#0000#, 16#002B#, 16#0002#),
         1121 => (16#1C9A#, 16#0020#, 16#0008#),
         1122 => (16#0000#, 16#002B#, 16#0002#),
         1123 => (16#1C77#, 16#0020#, 16#0002#),
         1124 => (16#0000#, 16#0024#, 16#0002#),
         1125 => (16#1C7C#, 16#0020#, 16#0002#),
         1126 => (16#0000#, 16#0024#, 16#0002#),
         1127 => (16#1C82#, 16#0020#, 16#0002#),
         1128 => (16#0000#, 16#0024#, 16#0002#),
         1129 => (16#1C84#, 16#0020#, 16#0002#),
         1130 => (16#0000#, 16#0024#, 16#0002#),
         1131 => (16#1C9A#, 16#0020#, 16#0002#),
         1132 => (16#0000#, 16#002B#, 16#0002#),
         1133 => (16#0000#, 16#0024#, 16#0002#),
         1134 => (16#1C78#, 16#0020#, 16#0002#),
         1135 => (16#1C79#, 16#0020#, 16#0002#),
         1136 => (16#1C7B#, 16#0020#, 16#0002#),
         1137 => (16#1C80#, 16#0020#, 16#0002#),
         1138 => (16#1C83#, 16#0020#, 16#0002#),
         1139 => (16#1C86#, 16#0020#, 16#0002#),
         1140 => (16#1C87#, 16#0020#, 16#0002#),
         1141 => (16#1C89#, 16#0020#, 16#0002#),
         1142 => (16#1C8A#, 16#0020#, 16#0002#),
         1143 => (16#1C8B#, 16#0020#, 16#0002#),
         1144 => (16#1C8C#, 16#0020#, 16#0002#),
         1145 => (16#1C8D#, 16#0020#, 16#0002#),
         1146 => (16#1C92#, 16#0020#, 16#0002#),
         1147 => (16#1C95#, 16#0020#, 16#0019#),
         1148 => (16#1C95#, 16#0020#, 16#0002#),
         1149 => (16#1C99#, 16#0020#, 16#0002#),
         1150 => (16#1C9B#, 16#0020#, 16#0002#),
         1151 => (16#1C9C#, 16#0020#, 16#0002#),
         1152 => (16#1C9D#, 16#0020#, 16#0002#),
         1153 => (16#1C9F#, 16#0020#, 16#0002#),
         1154 => (16#1C8C#, 16#0020#, 16#0002#),
         1155 => (16#0000#, 16#0024#, 16#0002#),
         1156 => (16#1C9A#, 16#0020#, 16#0002#),
         1157 => (16#0000#, 16#0024#, 16#0002#),
         1158 => (16#1C9F#, 16#0020#, 16#0002#),
         1159 => (16#0000#, 16#0024#, 16#0002#),
         1160 => (16#1C86#, 16#0020#, 16#000A#),
         1161 => (16#1C77#, 16#0020#, 16#0004#),
         1162 => (16#1C84#, 16#0020#, 16#0004#),
         1163 => (16#1C78#, 16#0020#, 16#0004#),
         1164 => (16#1C83#, 16#0020#, 16#0004#),
         1165 => (16#1C9A#, 16#0020#, 16#000A#),
         1166 => (16#1C9A#, 16#0020#, 16#000A#),
         1167 => (16#0000#, 16#0024#, 16#0002#),
         1168 => (16#1C9A#, 16#0020#, 16#000A#),
         1169 => (16#0000#, 16#002B#, 16#0002#),
         1170 => (16#1C9B#, 16#0020#, 16#0004#),
         1171 => (16#1C8D#, 16#0020#, 16#0004#),
         1172 => (16#1C86#, 16#0020#, 16#0004#),
         1173 => (16#1C77#, 16#0020#, 16#0004#),
         1174 => (16#1C84#, 16#0020#, 16#0004#),
         1175 => (16#1C91#, 16#0020#, 16#0008#),
         1176 => (16#1C91#, 16#0020#, 16#0002#),
         1177 => (16#1C7F#, 16#0020#, 16#0008#),
         1178 => (16#1C7F#, 16#0020#, 16#0002#),
         1179 => (16#1C7D#, 16#0020#, 16#0008#),
         1180 => (16#1C7D#, 16#0020#, 16#0002#),
         1181 => (16#1C90#, 16#0020#, 16#0008#),
         1182 => (16#1C90#, 16#0020#, 16#0002#),
         1183 => (16#1CA1#, 16#0020#, 16#0008#),
         1184 => (16#1CA1#, 16#0020#, 16#0002#),
         1185 => (16#1CC3#, 16#0020#, 16#0008#),
         1186 => (16#1CC3#, 16#0020#, 16#0002#),
         1187 => (16#1CC8#, 16#0020#, 16#0008#),
         1188 => (16#1CC8#, 16#0020#, 16#0002#),
         1189 => (16#1CC9#, 16#0020#, 16#0008#),
         1190 => (16#1CC9#, 16#0020#, 16#0002#),
         1191 => (16#1CCC#, 16#0020#, 16#0008#),
         1192 => (16#1CCC#, 16#0020#, 16#0002#),
         1193 => (16#1CD3#, 16#0020#, 16#0008#),
         1194 => (16#1CD3#, 16#0020#, 16#0002#),
         1195 => (16#1CD6#, 16#0020#, 16#0008#),
         1196 => (16#1CD6#, 16#0020#, 16#0002#),
         1197 => (16#1CDA#, 16#0020#, 16#0008#),
         1198 => (16#1CDA#, 16#0020#, 16#0002#),
         1199 => (16#1C92#, 16#0020#, 16#0004#),
         1200 => (16#1C95#, 16#0020#, 16#0004#),
         1201 => (16#1C85#, 16#0020#, 16#0002#),
         1202 => (16#1C83#, 16#0020#, 16#000A#),
         1203 => (16#1C7C#, 16#0020#, 16#0004#),
         1204 => (16#04D1#, 16#0020#, 16#0002#),
         1205 => (16#1CA3#, 16#0020#, 16#0008#),
         1206 => (16#1CA3#, 16#0020#, 16#0002#),
         1207 => (16#1C95#, 16#0020#, 16#000A#),
         1208 => (16#1C8F#, 16#0020#, 16#0008#),
         1209 => (16#1C8F#, 16#0020#, 16#0002#),
         1210 => (16#1C94#, 16#0020#, 16#0002#),
         1211 => (16#1C97#, 16#0020#, 16#0008#),
         1212 => (16#1C96#, 16#0020#, 16#0008#),
         1213 => (16#1C98#, 16#0020#, 16#0008#),
         1214 => (16#1D18#, 16#0020#, 16#0008#),
         1215 => (16#0000#, 16#0025#, 16#0002#),
         1216 => (16#1D18#, 16#0020#, 16#0008#),
         1217 => (16#0000#, 16#002B#, 16#0002#),
         1218 => (16#1D0E#, 16#0020#, 16#0008#),
         1219 => (16#1CF4#, 16#0020#, 16#0008#),
         1220 => (16#0000#, 16#0024#, 16#0002#),
         1221 => (16#1D1C#, 16#0020#, 16#0008#),
         1222 => (16#1D32#, 16#0020#, 16#0008#),
         1223 => (16#1D46#, 16#0020#, 16#0008#),
         1224 => (16#1D46#, 16#0020#, 16#0008#),
         1225 => (16#0000#, 16#002B#, 16#0002#),
         1226 => (16#1D4F#, 16#0020#, 16#0008#),
         1227 => (16#1D7A#, 16#0020#, 16#0008#),
         1228 => (16#1DA0#, 16#0020#, 16#0008#),
         1229 => (16#1DD7#, 16#0020#, 16#0008#),
         1230 => (16#1D54#, 16#0020#, 16#0008#),
         1231 => (16#0000#, 16#0024#, 16#0002#),
         1232 => (16#1D3E#, 16#0020#, 16#0008#),
         1233 => (16#0000#, 16#0025#, 16#0002#),
         1234 => (16#1DDB#, 16#0020#, 16#0008#),
         1235 => (16#0000#, 16#0026#, 16#0002#),
         1236 => (16#1E3D#, 16#0020#, 16#0008#),
         1237 => (16#1CE0#, 16#0020#, 16#0008#),
         1238 => (16#1CEC#, 16#0020#, 16#0008#),
         1239 => (16#1CF0#, 16#0020#, 16#0008#),
         1240 => (16#1D08#, 16#0020#, 16#0008#),
         1241 => (16#1D20#, 16#0020#, 16#0008#),
         1242 => (16#1D2A#, 16#0020#, 16#0008#),
         1243 => (16#1D4B#, 16#0020#, 16#0008#),
         1244 => (16#1D6E#, 16#0020#, 16#0008#),
         1245 => (16#1D81#, 16#0020#, 16#0008#),
         1246 => (16#1D8A#, 16#0020#, 16#0008#),
         1247 => (16#1DA5#, 16#0020#, 16#0008#),
         1248 => (16#1DAD#, 16#0020#, 16#0008#),
         1249 => (16#1DBA#, 16#0020#, 16#0008#),
         1250 => (16#1DC3#, 16#0020#, 16#0008#),
         1251 => (16#1DCC#, 16#0020#, 16#0008#),
         1252 => (16#1DEC#, 16#0020#, 16#0008#),
         1253 => (16#1DF0#, 16#0020#, 16#0008#),
         1254 => (16#1E17#, 16#0020#, 16#0008#),
         1255 => (16#1E22#, 16#0020#, 16#0008#),
         1256 => (16#1E41#, 16#0020#, 16#0008#),
         1257 => (16#1E46#, 16#0020#, 16#0008#),
         1258 => (16#1E4D#, 16#0020#, 16#0008#),
         1259 => (16#1E52#, 16#0020#, 16#0008#),
         1260 => (16#1E56#, 16#0020#, 16#0008#),
         1261 => (16#1E63#, 16#0020#, 16#0008#),
         1262 => (16#1E67#, 16#0020#, 16#0008#),
         1263 => (16#1E6D#, 16#0020#, 16#0008#),
         1264 => (16#1CE0#, 16#0020#, 16#0002#),
         1265 => (16#1CEC#, 16#0020#, 16#0002#),
         1266 => (16#1CF0#, 16#0020#, 16#0002#),
         1267 => (16#1CF4#, 16#0020#, 16#0002#),
         1268 => (16#1D08#, 16#0020#, 16#0002#),
         1269 => (16#1D18#, 16#0020#, 16#0002#),
         1270 => (16#1D20#, 16#0020#, 16#0002#),
         1271 => (16#1D2A#, 16#0020#, 16#0002#),
         1272 => (16#1D3E#, 16#0020#, 16#0002#),
         1273 => (16#1D4B#, 16#0020#, 16#0002#),
         1274 => (16#1D54#, 16#0020#, 16#0002#),
         1275 => (16#1D6E#, 16#0020#, 16#0002#),
         1276 => (16#1D81#, 16#0020#, 16#0002#),
         1277 => (16#1D8A#, 16#0020#, 16#0002#),
         1278 => (16#1DA5#, 16#0020#, 16#0002#),
         1279 => (16#1DAD#, 16#0020#, 16#0002#),
         1280 => (16#1DBA#, 16#0020#, 16#0002#),
         1281 => (16#1DC3#, 16#0020#, 16#0002#),
         1282 => (16#1DCC#, 16#0020#, 16#0002#),
         1283 => (16#1DDB#, 16#0020#, 16#0002#),
         1284 => (16#1DEC#, 16#0020#, 16#0002#),
         1285 => (16#1DF0#, 16#0020#, 16#0002#),
         1286 => (16#1E17#, 16#0020#, 16#0002#),
         1287 => (16#1E22#, 16#0020#, 16#0002#),
         1288 => (16#1E41#, 16#0020#, 16#0002#),
         1289 => (16#1E46#, 16#0020#, 16#0002#),
         1290 => (16#1E4D#, 16#0020#, 16#0002#),
         1291 => (16#1E52#, 16#0020#, 16#0002#),
         1292 => (16#1E56#, 16#0020#, 16#0002#),
         1293 => (16#1E63#, 16#0020#, 16#0002#),
         1294 => (16#1E67#, 16#0020#, 16#0002#),
         1295 => (16#1E6D#, 16#0020#, 16#0002#),
         1296 => (16#1D18#, 16#0020#, 16#0002#),
         1297 => (16#0000#, 16#0025#, 16#0002#),
         1298 => (16#1D18#, 16#0020#, 16#0002#),
         1299 => (16#0000#, 16#002B#, 16#0002#),
         1300 => (16#1D0E#, 16#0020#, 16#0002#),
         1301 => (16#1CF4#, 16#0020#, 16#0002#),
         1302 => (16#0000#, 16#0024#, 16#0002#),
         1303 => (16#1D1C#, 16#0020#, 16#0002#),
         1304 => (16#1D32#, 16#0020#, 16#0002#),
         1305 => (16#1D46#, 16#0020#, 16#0002#),
         1306 => (16#1D46#, 16#0020#, 16#0002#),
         1307 => (16#0000#, 16#002B#, 16#0002#),
         1308 => (16#1D4F#, 16#0020#, 16#0002#),
         1309 => (16#1D7A#, 16#0020#, 16#0002#),
         1310 => (16#1DA0#, 16#0020#, 16#0002#),
         1311 => (16#1DD7#, 16#0020#, 16#0002#),
         1312 => (16#1D54#, 16#0020#, 16#0002#),
         1313 => (16#0000#, 16#0024#, 16#0002#),
         1314 => (16#1D3E#, 16#0020#, 16#0002#),
         1315 => (16#0000#, 16#0025#, 16#0002#),
         1316 => (16#1DDB#, 16#0020#, 16#0002#),
         1317 => (16#0000#, 16#0026#, 16#0002#),
         1318 => (16#1E3D#, 16#0020#, 16#0002#),
         1319 => (16#1E06#, 16#0020#, 16#0008#),
         1320 => (16#1E06#, 16#0020#, 16#0002#),
         1321 => (16#1E5E#, 16#0020#, 16#0008#),
         1322 => (16#1E5E#, 16#0020#, 16#0002#),
         1323 => (16#1E72#, 16#0020#, 16#0008#),
         1324 => (16#1E72#, 16#0020#, 16#0002#),
         1325 => (16#1E76#, 16#0020#, 16#0008#),
         1326 => (16#1E76#, 16#0020#, 16#0002#),
         1327 => (16#1E80#, 16#0020#, 16#0008#),
         1328 => (16#1E80#, 16#0020#, 16#0002#),
         1329 => (16#1E7B#, 16#0020#, 16#0008#),
         1330 => (16#1E7B#, 16#0020#, 16#0002#),
         1331 => (16#1E85#, 16#0020#, 16#0008#),
         1332 => (16#1E85#, 16#0020#, 16#0002#),
         1333 => (16#1E89#, 16#0020#, 16#0008#),
         1334 => (16#1E89#, 16#0020#, 16#0002#),
         1335 => (16#1E8D#, 16#0020#, 16#0008#),
         1336 => (16#1E8D#, 16#0020#, 16#0002#),
         1337 => (16#1E91#, 16#0020#, 16#0008#),
         1338 => (16#1E91#, 16#0020#, 16#0002#),
         1339 => (16#1E95#, 16#0020#, 16#0008#),
         1340 => (16#1E95#, 16#0020#, 16#0002#),
         1341 => (16#1E95#, 16#0020#, 16#0008#),
         1342 => (16#0000#, 16#003C#, 16#0002#),
         1343 => (16#1E95#, 16#0020#, 16#0002#),
         1344 => (16#0000#, 16#003C#, 16#0002#),
         1345 => (16#1DE8#, 16#0020#, 16#0008#),
         1346 => (16#1DE8#, 16#0020#, 16#0002#),
         1347 => (16#1E13#, 16#0020#, 16#0008#),
         1348 => (16#1E13#, 16#0020#, 16#0002#),
         1349 => (16#1E0F#, 16#0020#, 16#0008#),
         1350 => (16#1E0F#, 16#0020#, 16#0002#),
         1351 => (16#1E0A#, 16#0020#, 16#0008#),
         1352 => (16#1E0A#, 16#0020#, 16#0002#),
         1353 => (16#1DB6#, 16#0020#, 16#0008#),
         1354 => (16#1DB6#, 16#0020#, 16#0002#),
         1355 => (16#03BB#, 16#0020#, 16#0002#),
         1356 => (16#0000#, 16#0050#, 16#0002#),
         1357 => (16#1D42#, 16#0020#, 16#0008#),
         1358 => (16#1D42#, 16#0020#, 16#0002#),
         1359 => (16#1E5A#, 16#0020#, 16#0008#),
         1360 => (16#1E5A#, 16#0020#, 16#0002#),
         1361 => (16#1DBE#, 16#0020#, 16#0008#),
         1362 => (16#1DBE#, 16#0020#, 16#0002#),
         1363 => (16#1CF4#, 16#0020#, 16#000A#),
         1364 => (16#0000#, 16#0109#, 16#0004#),
         1365 => (16#1CF4#, 16#0020#, 16#0004#),
         1366 => (16#0000#, 16#0109#, 16#0004#),
         1367 => (16#1CF8#, 16#0020#, 16#0008#),
         1368 => (16#1CF8#, 16#0020#, 16#0002#),
         1369 => (16#1D00#, 16#0020#, 16#0008#),
         1370 => (16#1D00#, 16#0020#, 16#0002#),
         1371 => (16#1D26#, 16#0020#, 16#0008#),
         1372 => (16#1D26#, 16#0020#, 16#0002#),
         1373 => (16#1D14#, 16#0020#, 16#0008#),
         1374 => (16#1D14#, 16#0020#, 16#0002#),
         1375 => (16#1D58#, 16#0020#, 16#0008#),
         1376 => (16#1D58#, 16#0020#, 16#0002#),
         1377 => (16#1D68#, 16#0020#, 16#0008#),
         1378 => (16#1D68#, 16#0020#, 16#0002#),
         1379 => (16#1D64#, 16#0020#, 16#0008#),
         1380 => (16#1D64#, 16#0020#, 16#0002#),
         1381 => (16#1D60#, 16#0020#, 16#0008#),
         1382 => (16#1D60#, 16#0020#, 16#0002#),
         1383 => (16#1D93#, 16#0020#, 16#0008#),
         1384 => (16#1D93#, 16#0020#, 16#0002#),
         1385 => (16#1D9C#, 16#0020#, 16#0008#),
         1386 => (16#1D9C#, 16#0020#, 16#0002#),
         1387 => (16#1DB2#, 16#0020#, 16#0008#),
         1388 => (16#1DB2#, 16#0020#, 16#0002#),
         1389 => (16#1E9A#, 16#0020#, 16#0008#),
         1390 => (16#1E9A#, 16#0020#, 16#0002#),
         1391 => (16#1DC8#, 16#0020#, 16#0008#),
         1392 => (16#1DC8#, 16#0020#, 16#0002#),
         1393 => (16#1DD2#, 16#0020#, 16#0008#),
         1394 => (16#1DD2#, 16#0020#, 16#0002#),
         1395 => (16#1DDF#, 16#0020#, 16#0008#),
         1396 => (16#1DDF#, 16#0020#, 16#0002#),
         1397 => (16#1DE3#, 16#0020#, 16#0008#),
         1398 => (16#1DE3#, 16#0020#, 16#0002#),
         1399 => (16#1DFC#, 16#0020#, 16#0008#),
         1400 => (16#1DFC#, 16#0020#, 16#0002#),
         1401 => (16#1E1D#, 16#0020#, 16#0008#),
         1402 => (16#1E1D#, 16#0020#, 16#0002#),
         1403 => (16#1E28#, 16#0020#, 16#0008#),
         1404 => (16#1E28#, 16#0020#, 16#0002#),
         1405 => (16#1E30#, 16#0020#, 16#0008#),
         1406 => (16#1E30#, 16#0020#, 16#0002#),
         1407 => (16#1E00#, 16#0020#, 16#0008#),
         1408 => (16#1E00#, 16#0020#, 16#0002#),
         1409 => (16#1E35#, 16#0020#, 16#0008#),
         1410 => (16#1E35#, 16#0020#, 16#0002#),
         1411 => (16#1E39#, 16#0020#, 16#0008#),
         1412 => (16#1E39#, 16#0020#, 16#0002#),
         1413 => (16#1E9F#, 16#0020#, 16#0008#),
         1414 => (16#1D20#, 16#0020#, 16#0008#),
         1415 => (16#0000#, 16#0026#, 16#0002#),
         1416 => (16#1D20#, 16#0020#, 16#0002#),
         1417 => (16#0000#, 16#0026#, 16#0002#),
         1418 => (16#1D5C#, 16#0020#, 16#0008#),
         1419 => (16#1D5C#, 16#0020#, 16#0002#),
         1420 => (16#1D73#, 16#0020#, 16#0008#),
         1421 => (16#1D73#, 16#0020#, 16#0002#),
         1422 => (16#1D97#, 16#0020#, 16#0008#),
         1423 => (16#1D97#, 16#0020#, 16#0002#),
         1424 => (16#1D8F#, 16#0020#, 16#0008#),
         1425 => (16#1D8F#, 16#0020#, 16#0002#),
         1426 => (16#1E2C#, 16#0020#, 16#0008#),
         1427 => (16#1E2C#, 16#0020#, 16#0002#),
         1428 => (16#1D85#, 16#0020#, 16#0008#),
         1429 => (16#1D85#, 16#0020#, 16#0002#),
         1430 => (16#1E9F#, 16#0020#, 16#0002#),
         1431 => (16#1CE0#, 16#0020#, 16#0008#),
         1432 => (16#0000#, 16#0026#, 16#0002#),
         1433 => (16#1CE0#, 16#0020#, 16#0002#),
         1434 => (16#0000#, 16#0026#, 16#0002#),
         1435 => (16#1CE0#, 16#0020#, 16#0008#),
         1436 => (16#0000#, 16#002B#, 16#0002#),
         1437 => (16#1CE0#, 16#0020#, 16#0002#),
         1438 => (16#0000#, 16#002B#, 16#0002#),
         1439 => (16#1CE8#, 16#0020#, 16#0008#),
         1440 => (16#1CE8#, 16#0020#, 16#0002#),
         1441 => (16#1D18#, 16#0020#, 16#0008#),
         1442 => (16#0000#, 16#0026#, 16#0002#),
         1443 => (16#1D18#, 16#0020#, 16#0002#),
         1444 => (16#0000#, 16#0026#, 16#0002#),
         1445 => (16#1CE4#, 16#0020#, 16#0008#),
         1446 => (16#1CE4#, 16#0020#, 16#0002#),
         1447 => (16#1CE4#, 16#0020#, 16#0008#),
         1448 => (16#0000#, 16#002B#, 16#0002#),
         1449 => (16#1CE4#, 16#0020#, 16#0002#),
         1450 => (16#0000#, 16#002B#, 16#0002#),
         1451 => (16#1D20#, 16#0020#, 16#0008#),
         1452 => (16#0000#, 16#002B#, 16#0002#),
         1453 => (16#1D20#, 16#0020#, 16#0002#),
         1454 => (16#0000#, 16#002B#, 16#0002#),
         1455 => (16#1D2A#, 16#0020#, 16#0008#),
         1456 => (16#0000#, 16#002B#, 16#0002#),
         1457 => (16#1D2A#, 16#0020#, 16#0002#),
         1458 => (16#0000#, 16#002B#, 16#0002#),
         1459 => (16#1D37#, 16#0020#, 16#0008#),
         1460 => (16#1D37#, 16#0020#, 16#0002#),
         1461 => (16#1D3E#, 16#0020#, 16#0008#),
         1462 => (16#0000#, 16#0032#, 16#0002#),
         1463 => (16#1D3E#, 16#0020#, 16#0002#),
         1464 => (16#0000#, 16#0032#, 16#0002#),
         1465 => (16#1D3E#, 16#0020#, 16#0008#),
         1466 => (16#0000#, 16#002B#, 16#0002#),
         1467 => (16#1D3E#, 16#0020#, 16#0002#),
         1468 => (16#0000#, 16#002B#, 16#0002#),
         1469 => (16#1DA5#, 16#0020#, 16#0008#),
         1470 => (16#0000#, 16#002B#, 16#0002#),
         1471 => (16#1DA5#, 16#0020#, 16#0002#),
         1472 => (16#0000#, 16#002B#, 16#0002#),
         1473 => (16#1DA9#, 16#0020#, 16#0008#),
         1474 => (16#1DA9#, 16#0020#, 16#0002#),
         1475 => (16#1DA9#, 16#0020#, 16#0008#),
         1476 => (16#0000#, 16#002B#, 16#0002#),
         1477 => (16#1DA9#, 16#0020#, 16#0002#),
         1478 => (16#0000#, 16#002B#, 16#0002#),
         1479 => (16#1E63#, 16#0020#, 16#0008#),
         1480 => (16#0000#, 16#002B#, 16#0002#),
         1481 => (16#1E63#, 16#0020#, 16#0002#),
         1482 => (16#0000#, 16#002B#, 16#0002#),
         1483 => (16#1DDB#, 16#0020#, 16#0008#),
         1484 => (16#0000#, 16#0032#, 16#0002#),
         1485 => (16#1DDB#, 16#0020#, 16#0002#),
         1486 => (16#0000#, 16#0032#, 16#0002#),
         1487 => (16#1DDB#, 16#0020#, 16#0008#),
         1488 => (16#0000#, 16#002B#, 16#0002#),
         1489 => (16#1DDB#, 16#0020#, 16#0002#),
         1490 => (16#0000#, 16#002B#, 16#0002#),
         1491 => (16#1DDB#, 16#0020#, 16#0008#),
         1492 => (16#0000#, 16#002C#, 16#0002#),
         1493 => (16#1DDB#, 16#0020#, 16#0002#),
         1494 => (16#0000#, 16#002C#, 16#0002#),
         1495 => (16#1E22#, 16#0020#, 16#0008#),
         1496 => (16#0000#, 16#002B#, 16#0002#),
         1497 => (16#1E22#, 16#0020#, 16#0002#),
         1498 => (16#0000#, 16#002B#, 16#0002#),
         1499 => (16#1D04#, 16#0020#, 16#0008#),
         1500 => (16#1D04#, 16#0020#, 16#0002#),
         1501 => (16#1E52#, 16#0020#, 16#0008#),
         1502 => (16#0000#, 16#002B#, 16#0002#),
         1503 => (16#1E52#, 16#0020#, 16#0002#),
         1504 => (16#0000#, 16#002B#, 16#0002#),
         1505 => (16#1CFC#, 16#0020#, 16#0008#),
         1506 => (16#1CFC#, 16#0020#, 16#0002#),
         1507 => (16#1DF4#, 16#0020#, 16#0008#),
         1508 => (16#1DF4#, 16#0020#, 16#0002#),
         1509 => (16#1DF8#, 16#0020#, 16#0008#),
         1510 => (16#1DF8#, 16#0020#, 16#0002#),
         1511 => (16#1D0C#, 16#0020#, 16#0008#),
         1512 => (16#1D0C#, 16#0020#, 16#0002#),
         1513 => (16#1D13#, 16#0020#, 16#0008#),
         1514 => (16#1D13#, 16#0020#, 16#0002#),
         1515 => (16#1D2F#, 16#0020#, 16#0008#),
         1516 => (16#1D2F#, 16#0020#, 16#0002#),
         1517 => (16#1D3C#, 16#0020#, 16#0008#),
         1518 => (16#1D3C#, 16#0020#, 16#0002#),
         1519 => (16#1D7F#, 16#0020#, 16#0008#),
         1520 => (16#1D7F#, 16#0020#, 16#0002#),
         1521 => (16#1DA4#, 16#0020#, 16#0008#),
         1522 => (16#1DA4#, 16#0020#, 16#0002#),
         1523 => (16#1DC7#, 16#0020#, 16#0008#),
         1524 => (16#1DC7#, 16#0020#, 16#0002#),
         1525 => (16#1DD1#, 16#0020#, 16#0008#),
         1526 => (16#1DD1#, 16#0020#, 16#0002#),
         1527 => (16#1D30#, 16#0020#, 16#0008#),
         1528 => (16#1D30#, 16#0020#, 16#0002#),
         1529 => (16#1D78#, 16#0020#, 16#0008#),
         1530 => (16#1D78#, 16#0020#, 16#0002#),
         1531 => (16#1D80#, 16#0020#, 16#0008#),
         1532 => (16#1D80#, 16#0020#, 16#0002#),
         1533 => (16#1DC2#, 16#0020#, 16#0008#),
         1534 => (16#1DC2#, 16#0020#, 16#0002#),
         1535 => (16#1E71#, 16#0020#, 16#0008#),
         1536 => (16#1E71#, 16#0020#, 16#0002#),
         1537 => (16#1D6D#, 16#0020#, 16#0008#),
         1538 => (16#1D6D#, 16#0020#, 16#0002#),
         1539 => (16#1E9E#, 16#0020#, 16#0008#),
         1540 => (16#1E9E#, 16#0020#, 16#0002#),
         1541 => (16#1D6C#, 16#0020#, 16#0008#),
         1542 => (16#1D6C#, 16#0020#, 16#0002#),
         1543 => (16#1D79#, 16#0020#, 16#0008#),
         1544 => (16#1D79#, 16#0020#, 16#0002#),
         1545 => (16#1D9B#, 16#0020#, 16#0008#),
         1546 => (16#1D9B#, 16#0020#, 16#0002#),
         1547 => (16#1DB1#, 16#0020#, 16#0008#),
         1548 => (16#1DB1#, 16#0020#, 16#0002#),
         1549 => (16#1E04#, 16#0020#, 16#0008#),
         1550 => (16#1E04#, 16#0020#, 16#0002#),
         1551 => (16#1D8E#, 16#0020#, 16#0008#),
         1552 => (16#1D8E#, 16#0020#, 16#0002#),
         1553 => (16#1D24#, 16#0020#, 16#0008#),
         1554 => (16#1D24#, 16#0020#, 16#0002#),
         1555 => (16#1E26#, 16#0020#, 16#0008#),
         1556 => (16#1E26#, 16#0020#, 16#0002#),
         1557 => (16#1D77#, 16#0020#, 16#0008#),
         1558 => (16#1D77#, 16#0020#, 16#0002#),
         1559 => (16#1F4E#, 16#0020#, 16#0008#),
         1560 => (16#1F4F#, 16#0020#, 16#0008#),
         1561 => (16#1F50#, 16#0020#, 16#0008#),
         1562 => (16#1F51#, 16#0020#, 16#0008#),
         1563 => (16#1F52#, 16#0020#, 16#0008#),
         1564 => (16#1F53#, 16#0020#, 16#0008#),
         1565 => (16#1F54#, 16#0020#, 16#0008#),
         1566 => (16#1F55#, 16#0020#, 16#0008#),
         1567 => (16#1F56#, 16#0020#, 16#0008#),
         1568 => (16#1F57#, 16#0020#, 16#0008#),
         1569 => (16#1F58#, 16#0020#, 16#0008#),
         1570 => (16#1F59#, 16#0020#, 16#0008#),
         1571 => (16#1F5A#, 16#0020#, 16#0008#),
         1572 => (16#1F5B#, 16#0020#, 16#0008#),
         1573 => (16#1F5C#, 16#0020#, 16#0008#),
         1574 => (16#1F5D#, 16#0020#, 16#0008#),
         1575 => (16#1F5E#, 16#0020#, 16#0008#),
         1576 => (16#1F5F#, 16#0020#, 16#0008#),
         1577 => (16#1F60#, 16#0020#, 16#0008#),
         1578 => (16#1F61#, 16#0020#, 16#0008#),
         1579 => (16#1F62#, 16#0020#, 16#0008#),
         1580 => (16#1F63#, 16#0020#, 16#0008#),
         1581 => (16#1F64#, 16#0020#, 16#0008#),
         1582 => (16#1F65#, 16#0020#, 16#0008#),
         1583 => (16#1F66#, 16#0020#, 16#0008#),
         1584 => (16#1F67#, 16#0020#, 16#0008#),
         1585 => (16#1F68#, 16#0020#, 16#0008#),
         1586 => (16#1F69#, 16#0020#, 16#0008#),
         1587 => (16#1F6A#, 16#0020#, 16#0008#),
         1588 => (16#1F6B#, 16#0020#, 16#0008#),
         1589 => (16#1F6C#, 16#0020#, 16#0008#),
         1590 => (16#1F6D#, 16#0020#, 16#0008#),
         1591 => (16#1F6E#, 16#0020#, 16#0008#),
         1592 => (16#1F6F#, 16#0020#, 16#0008#),
         1593 => (16#1F70#, 16#0020#, 16#0008#),
         1594 => (16#1F71#, 16#0020#, 16#0008#),
         1595 => (16#1F72#, 16#0020#, 16#0008#),
         1596 => (16#1F73#, 16#0020#, 16#0008#),
         1597 => (16#1F74#, 16#0020#, 16#0002#),
         1598 => (16#02BC#, 16#0020#, 16#0002#),
         1599 => (16#02BD#, 16#0020#, 16#0002#),
         1600 => (16#0160#, 16#0020#, 16#0002#),
         1601 => (16#0124#, 16#0020#, 16#0002#),
         1602 => (16#0166#, 16#0020#, 16#0002#),
         1603 => (16#02BE#, 16#0020#, 16#0002#),
         1604 => (16#1F4E#, 16#0020#, 16#0002#),
         1605 => (16#1F4F#, 16#0020#, 16#0002#),
         1606 => (16#1F50#, 16#0020#, 16#0002#),
         1607 => (16#1F51#, 16#0020#, 16#0002#),
         1608 => (16#1F52#, 16#0020#, 16#0002#),
         1609 => (16#1F53#, 16#0020#, 16#0002#),
         1610 => (16#1F54#, 16#0020#, 16#0002#),
         1611 => (16#1F55#, 16#0020#, 16#0002#),
         1612 => (16#1F56#, 16#0020#, 16#0002#),
         1613 => (16#1F57#, 16#0020#, 16#0002#),
         1614 => (16#1F58#, 16#0020#, 16#0002#),
         1615 => (16#1F59#, 16#0020#, 16#0002#),
         1616 => (16#1F5A#, 16#0020#, 16#0002#),
         1617 => (16#1F5B#, 16#0020#, 16#0002#),
         1618 => (16#1F5C#, 16#0020#, 16#0002#),
         1619 => (16#1F5D#, 16#0020#, 16#0002#),
         1620 => (16#1F5E#, 16#0020#, 16#0002#),
         1621 => (16#1F5F#, 16#0020#, 16#0002#),
         1622 => (16#1F60#, 16#0020#, 16#0002#),
         1623 => (16#1F61#, 16#0020#, 16#0002#),
         1624 => (16#1F62#, 16#0020#, 16#0002#),
         1625 => (16#1F63#, 16#0020#, 16#0002#),
         1626 => (16#1F64#, 16#0020#, 16#0002#),
         1627 => (16#1F65#, 16#0020#, 16#0002#),
         1628 => (16#1F66#, 16#0020#, 16#0002#),
         1629 => (16#1F67#, 16#0020#, 16#0002#),
         1630 => (16#1F68#, 16#0020#, 16#0002#),
         1631 => (16#1F69#, 16#0020#, 16#0002#),
         1632 => (16#1F6A#, 16#0020#, 16#0002#),
         1633 => (16#1F6B#, 16#0020#, 16#0002#),
         1634 => (16#1F6C#, 16#0020#, 16#0002#),
         1635 => (16#1F6D#, 16#0020#, 16#0002#),
         1636 => (16#1F6E#, 16#0020#, 16#0002#),
         1637 => (16#1F6F#, 16#0020#, 16#0002#),
         1638 => (16#1F70#, 16#0020#, 16#0002#),
         1639 => (16#1F71#, 16#0020#, 16#0002#),
         1640 => (16#1F72#, 16#0020#, 16#0002#),
         1641 => (16#1F73#, 16#0020#, 16#0002#),
         1642 => (16#1F52#, 16#0020#, 16#0004#),
         1643 => (16#1F6F#, 16#0020#, 16#0004#),
         1644 => (16#0138#, 16#0020#, 16#0002#),
         1645 => (16#010D#, 16#0020#, 16#0002#),
         1646 => (16#03BC#, 16#0020#, 16#0002#),
         1647 => (16#03BD#, 16#0020#, 16#0002#),
         1648 => (16#16CD#, 16#0020#, 16#0002#),
         1649 => (16#0000#, 16#0052#, 16#0002#),
         1650 => (16#0000#, 16#0053#, 16#0002#),
         1651 => (16#0000#, 16#0054#, 16#0002#),
         1652 => (16#0000#, 16#0055#, 16#0002#),
         1653 => (16#0000#, 16#0056#, 16#0002#),
         1654 => (16#0000#, 16#0057#, 16#0002#),
         1655 => (16#0000#, 16#0058#, 16#0002#),
         1656 => (16#0000#, 16#0059#, 16#0002#),
         1657 => (16#0000#, 16#005A#, 16#0002#),
         1658 => (16#0000#, 16#005B#, 16#0002#),
         1659 => (16#0000#, 16#005C#, 16#0002#),
         1660 => (16#0000#, 16#005F#, 16#0002#),
         1661 => (16#02BF#, 16#0020#, 16#0002#),
         1662 => (16#0000#, 16#0060#, 16#0002#),
         1663 => (16#02C0#, 16#0020#, 16#0002#),
         1664 => (16#0000#, 16#005E#, 16#0002#),
         1665 => (16#0000#, 16#005D#, 16#0002#),
         1666 => (16#02C1#, 16#0020#, 16#0002#),
         1667 => (16#02C2#, 16#0020#, 16#0002#),
         1668 => (16#1F75#, 16#0020#, 16#0002#),
         1669 => (16#1F76#, 16#0020#, 16#0002#),
         1670 => (16#1F77#, 16#0020#, 16#0002#),
         1671 => (16#1F78#, 16#0020#, 16#0002#),
         1672 => (16#1F79#, 16#0020#, 16#0002#),
         1673 => (16#1F7A#, 16#0020#, 16#0002#),
         1674 => (16#1F7B#, 16#0020#, 16#0002#),
         1675 => (16#1F7C#, 16#0020#, 16#0002#),
         1676 => (16#1F7D#, 16#0020#, 16#0002#),
         1677 => (16#1F7E#, 16#0020#, 16#0002#),
         1678 => (16#1F7F#, 16#0020#, 16#0019#),
         1679 => (16#1F7F#, 16#0020#, 16#0002#),
         1680 => (16#1F80#, 16#0020#, 16#0002#),
         1681 => (16#1F81#, 16#0020#, 16#0019#),
         1682 => (16#1F81#, 16#0020#, 16#0002#),
         1683 => (16#1F82#, 16#0020#, 16#0019#),
         1684 => (16#1F82#, 16#0020#, 16#0002#),
         1685 => (16#1F83#, 16#0020#, 16#0002#),
         1686 => (16#1F84#, 16#0020#, 16#0002#),
         1687 => (16#1F85#, 16#0020#, 16#0019#),
         1688 => (16#1F85#, 16#0020#, 16#0002#),
         1689 => (16#1F86#, 16#0020#, 16#0019#),
         1690 => (16#1F86#, 16#0020#, 16#0002#),
         1691 => (16#1F87#, 16#0020#, 16#0002#),
         1692 => (16#1F88#, 16#0020#, 16#0002#),
         1693 => (16#1F89#, 16#0020#, 16#0002#),
         1694 => (16#1F8A#, 16#0020#, 16#0002#),
         1695 => (16#1F7A#, 16#0020#, 16#0004#),
         1696 => (16#1F7A#, 16#0020#, 16#0004#),
         1697 => (16#1F7A#, 16#0020#, 16#0004#),
         1698 => (16#1F7E#, 16#0020#, 16#0004#),
         1699 => (16#1F7E#, 16#0020#, 16#0004#),
         1700 => (16#1F7E#, 16#0020#, 16#0004#),
         1701 => (16#02C3#, 16#0020#, 16#0002#),
         1702 => (16#02C4#, 16#0020#, 16#0002#),
         1703 => (16#04ED#, 16#0020#, 16#0002#),
         1704 => (16#04EF#, 16#0020#, 16#0002#),
         1705 => (16#03BE#, 16#0020#, 16#0002#),
         1706 => (16#028E#, 16#0020#, 16#0002#),
         1707 => (16#0290#, 16#0020#, 16#0002#),
         1708 => (16#16CE#, 16#0020#, 16#0002#),
         1709 => (16#0125#, 16#0020#, 16#0002#),
         1710 => (16#0126#, 16#0020#, 16#0002#),
         1711 => (16#03C1#, 16#0020#, 16#0002#),
         1712 => (16#03C2#, 16#0020#, 16#0002#),
         1713 => (16#0133#, 16#0020#, 16#0002#),
         1714 => (16#0139#, 16#0020#, 16#0002#),
         1715 => (16#0167#, 16#0020#, 16#0002#),
         1716 => (16#2084#, 16#0020#, 16#0002#),
         1717 => (16#1FBB#, 16#0020#, 16#0002#),
         1718 => (16#1FBC#, 16#0020#, 16#0002#),
         1719 => (16#1FBD#, 16#0020#, 16#0002#),
         1720 => (16#1FC0#, 16#0020#, 16#0002#),
         1721 => (16#1FC1#, 16#0020#, 16#0002#),
         1722 => (16#1FC5#, 16#0020#, 16#0002#),
         1723 => (16#1FC9#, 16#0020#, 16#0002#),
         1724 => (16#1FCB#, 16#0020#, 16#0002#),
         1725 => (16#1FD8#, 16#0020#, 16#0002#),
         1726 => (16#1FD9#, 16#0020#, 16#0002#),
         1727 => (16#1FDA#, 16#0020#, 16#0002#),
         1728 => (16#1FE0#, 16#0020#, 16#0002#),
         1729 => (16#1FE7#, 16#0020#, 16#0002#),
         1730 => (16#1FE8#, 16#0020#, 16#0002#),
         1731 => (16#1FF2#, 16#0020#, 16#0002#),
         1732 => (16#1FF3#, 16#0020#, 16#0002#),
         1733 => (16#2001#, 16#0020#, 16#0002#),
         1734 => (16#2002#, 16#0020#, 16#0002#),
         1735 => (16#2013#, 16#0020#, 16#0002#),
         1736 => (16#2014#, 16#0020#, 16#0002#),
         1737 => (16#201E#, 16#0020#, 16#0002#),
         1738 => (16#201F#, 16#0020#, 16#0002#),
         1739 => (16#2024#, 16#0020#, 16#0002#),
         1740 => (16#2025#, 16#0020#, 16#0002#),
         1741 => (16#2028#, 16#0020#, 16#0002#),
         1742 => (16#2029#, 16#0020#, 16#0002#),
         1743 => (16#204E#, 16#0020#, 16#0002#),
         1744 => (16#204F#, 16#0020#, 16#0002#),
         1745 => (16#2081#, 16#0020#, 16#0002#),
         1746 => (16#2082#, 16#0020#, 16#0002#),
         1747 => (16#2083#, 16#0020#, 16#0002#),
         1748 => (16#202F#, 16#0020#, 16#0002#),
         1749 => (16#203A#, 16#0020#, 16#0002#),
         1750 => (16#203E#, 16#0020#, 16#0002#),
         1751 => (16#2052#, 16#0020#, 16#0002#),
         1752 => (16#2059#, 16#0020#, 16#0002#),
         1753 => (16#205D#, 16#0020#, 16#0002#),
         1754 => (16#2066#, 16#0020#, 16#0002#),
         1755 => (16#206C#, 16#0020#, 16#0002#),
         1756 => (16#207A#, 16#0020#, 16#0002#),
         1757 => (16#207B#, 16#0020#, 16#0002#),
         1758 => (16#0000#, 16#006D#, 16#0002#),
         1759 => (16#0000#, 16#0070#, 16#0002#),
         1760 => (16#0000#, 16#0073#, 16#0002#),
         1761 => (16#0000#, 16#0076#, 16#0002#),
         1762 => (16#0000#, 16#007A#, 16#0002#),
         1763 => (16#0000#, 16#007D#, 16#0002#),
         1764 => (16#0000#, 16#0080#, 16#0002#),
         1765 => (16#0000#, 16#0081#, 16#0002#),
         1766 => (16#0000#, 16#0082#, 16#0002#),
         1767 => (16#0000#, 16#0083#, 16#0002#),
         1768 => (16#0000#, 16#0084#, 16#0002#),
         1769 => (16#0000#, 16#0086#, 16#0002#),
         1770 => (16#0000#, 16#0087#, 16#0002#),
         1771 => (16#0000#, 16#0088#, 16#0002#),
         1772 => (16#0000#, 16#008A#, 16#0002#),
         1773 => (16#0000#, 16#008B#, 16#0002#),
         1774 => (16#0000#, 16#008C#, 16#0002#),
         1775 => (16#0000#, 16#008D#, 16#0002#),
         1776 => (16#0000#, 16#008E#, 16#0002#),
         1777 => (16#0000#, 16#008F#, 16#0002#),
         1778 => (16#0000#, 16#0085#, 16#0002#),
         1779 => (16#028C#, 16#0020#, 16#0002#),
         1780 => (16#0127#, 16#0020#, 16#0002#),
         1781 => (16#0128#, 16#0020#, 16#0002#),
         1782 => (16#0284#, 16#0020#, 16#0002#),
         1783 => (16#1FCA#, 16#0020#, 16#0002#),
         1784 => (16#2039#, 16#0020#, 16#0002#),
         1785 => (16#0000#, 16#0097#, 16#0002#),
         1786 => (16#1FBF#, 16#0020#, 16#0002#),
         1787 => (16#1FBE#, 16#0020#, 16#0002#),
         1788 => (16#1FC2#, 16#0020#, 16#0002#),
         1789 => (16#1FBB#, 16#0020#, 16#0004#),
         1790 => (16#1FC9#, 16#0020#, 16#0004#),
         1791 => (16#1FBB#, 16#0020#, 16#0004#),
         1792 => (16#206C#, 16#0020#, 16#0004#),
         1793 => (16#1FBB#, 16#0020#, 16#0004#),
         1794 => (16#2070#, 16#0020#, 16#0004#),
         1795 => (16#1FBB#, 16#0020#, 16#0004#),
         1796 => (16#207B#, 16#0020#, 16#0004#),
         1797 => (16#1FBB#, 16#0020#, 16#0004#),
         1798 => (16#1FDB#, 16#0020#, 16#0002#),
         1799 => (16#1FDC#, 16#0020#, 16#0002#),
         1800 => (16#1FCC#, 16#0020#, 16#0002#),
         1801 => (16#1FDD#, 16#0020#, 16#0002#),
         1802 => (16#1FDE#, 16#0020#, 16#0002#),
         1803 => (16#1FCD#, 16#0020#, 16#0002#),
         1804 => (16#1FDF#, 16#0020#, 16#0002#),
         1805 => (16#1FCE#, 16#0020#, 16#0002#),
         1806 => (16#1FE9#, 16#0020#, 16#0002#),
         1807 => (16#1FEA#, 16#0020#, 16#0002#),
         1808 => (16#1FE1#, 16#0020#, 16#0002#),
         1809 => (16#1FE2#, 16#0020#, 16#0002#),
         1810 => (16#1FEB#, 16#0020#, 16#0002#),
         1811 => (16#1FE3#, 16#0020#, 16#0002#),
         1812 => (16#1FE5#, 16#0020#, 16#0002#),
         1813 => (16#1FF4#, 16#0020#, 16#0002#),
         1814 => (16#1FF5#, 16#0020#, 16#0002#),
         1815 => (16#1FF6#, 16#0020#, 16#0002#),
         1816 => (16#1FF7#, 16#0020#, 16#0002#),
         1817 => (16#1FF8#, 16#0020#, 16#0002#),
         1818 => (16#1FF9#, 16#0020#, 16#0002#),
         1819 => (16#1FFB#, 16#0020#, 16#0002#),
         1820 => (16#1FFC#, 16#0020#, 16#0002#),
         1821 => (16#1FFD#, 16#0020#, 16#0002#),
         1822 => (16#2003#, 16#0020#, 16#0002#),
         1823 => (16#2004#, 16#0020#, 16#0002#),
         1824 => (16#2005#, 16#0020#, 16#0002#),
         1825 => (16#2006#, 16#0020#, 16#0002#),
         1826 => (16#2007#, 16#0020#, 16#0002#),
         1827 => (16#2008#, 16#0020#, 16#0002#),
         1828 => (16#2009#, 16#0020#, 16#0002#),
         1829 => (16#200A#, 16#0020#, 16#0002#),
         1830 => (16#200B#, 16#0020#, 16#0002#),
         1831 => (16#2015#, 16#0020#, 16#0002#),
         1832 => (16#2016#, 16#0020#, 16#0002#),
         1833 => (16#2017#, 16#0020#, 16#0002#),
         1834 => (16#2020#, 16#0020#, 16#0002#),
         1835 => (16#2022#, 16#0020#, 16#0002#),
         1836 => (16#2026#, 16#0020#, 16#0002#),
         1837 => (16#202A#, 16#0020#, 16#0002#),
         1838 => (16#2030#, 16#0020#, 16#0002#),
         1839 => (16#2031#, 16#0020#, 16#0002#),
         1840 => (16#2032#, 16#0020#, 16#0002#),
         1841 => (16#2033#, 16#0020#, 16#0002#),
         1842 => (16#2035#, 16#0020#, 16#0002#),
         1843 => (16#2036#, 16#0020#, 16#0002#),
         1844 => (16#203B#, 16#0020#, 16#0002#),
         1845 => (16#203C#, 16#0020#, 16#0002#),
         1846 => (16#203F#, 16#0020#, 16#0002#),
         1847 => (16#2040#, 16#0020#, 16#0002#),
         1848 => (16#2041#, 16#0020#, 16#0002#),
         1849 => (16#2042#, 16#0020#, 16#0002#),
         1850 => (16#2044#, 16#0020#, 16#0002#),
         1851 => (16#2045#, 16#0020#, 16#0002#),
         1852 => (16#2046#, 16#0020#, 16#0002#),
         1853 => (16#2048#, 16#0020#, 16#0002#),
         1854 => (16#2049#, 16#0020#, 16#0002#),
         1855 => (16#204A#, 16#0020#, 16#0002#),
         1856 => (16#204B#, 16#0020#, 16#0002#),
         1857 => (16#204C#, 16#0020#, 16#0002#),
         1858 => (16#2053#, 16#0020#, 16#0002#),
         1859 => (16#2054#, 16#0020#, 16#0002#),
         1860 => (16#2055#, 16#0020#, 16#0002#),
         1861 => (16#2056#, 16#0020#, 16#0002#),
         1862 => (16#2062#, 16#0020#, 16#0002#),
         1863 => (16#205E#, 16#0020#, 16#0002#),
         1864 => (16#205F#, 16#0020#, 16#0002#),
         1865 => (16#2060#, 16#0020#, 16#0002#),
         1866 => (16#2061#, 16#0020#, 16#0002#),
         1867 => (16#2067#, 16#0020#, 16#0002#),
         1868 => (16#1FE4#, 16#0020#, 16#0002#),
         1869 => (16#206B#, 16#0020#, 16#0002#),
         1870 => (16#0000#, 16#0083#, 16#0002#),
         1871 => (16#2068#, 16#0020#, 16#0002#),
         1872 => (16#2068#, 16#0020#, 16#0002#),
         1873 => (16#0000#, 16#0083#, 16#0002#),
         1874 => (16#2069#, 16#0020#, 16#0002#),
         1875 => (16#206D#, 16#0020#, 16#0002#),
         1876 => (16#206E#, 16#0020#, 16#0002#),
         1877 => (16#206F#, 16#0020#, 16#0002#),
         1878 => (16#2070#, 16#0020#, 16#0002#),
         1879 => (16#2071#, 16#0020#, 16#0002#),
         1880 => (16#2072#, 16#0020#, 16#0002#),
         1881 => (16#2073#, 16#0020#, 16#0002#),
         1882 => (16#2074#, 16#0020#, 16#0002#),
         1883 => (16#207C#, 16#0020#, 16#0002#),
         1884 => (16#207D#, 16#0020#, 16#0002#),
         1885 => (16#207E#, 16#0020#, 16#0002#),
         1886 => (16#2076#, 16#0020#, 16#0002#),
         1887 => (16#207F#, 16#0020#, 16#0002#),
         1888 => (16#2080#, 16#0020#, 16#0002#),
         1889 => (16#2088#, 16#0020#, 16#0002#),
         1890 => (16#2088#, 16#0020#, 16#0002#),
         1891 => (16#0000#, 16#0083#, 16#0002#),
         1892 => (16#0175#, 16#0020#, 16#0002#),
         1893 => (16#03C3#, 16#0020#, 16#0002#),
         1894 => (16#03C4#, 16#0020#, 16#0002#),
         1895 => (16#1FFE#, 16#0020#, 16#0002#),
         1896 => (16#200C#, 16#0020#, 16#0002#),
         1897 => (16#2018#, 16#0020#, 16#0002#),
         1898 => (16#2023#, 16#0020#, 16#0002#),
         1899 => (16#202B#, 16#0020#, 16#0002#),
         1900 => (16#1FBB#, 16#0020#, 16#0004#),
         1901 => (16#0000#, 16#0109#, 16#0004#),
         1902 => (16#2059#, 16#0020#, 16#0004#),
         1903 => (16#0000#, 16#0109#, 16#0004#),
         1904 => (16#206A#, 16#0020#, 16#0002#),
         1905 => (16#01BA#, 16#0020#, 16#0002#),
         1906 => (16#0176#, 16#0020#, 16#0002#),
         1907 => (16#0177#, 16#0020#, 16#0002#),
         1908 => (16#013A#, 16#0020#, 16#0002#),
         1909 => (16#013B#, 16#0020#, 16#0002#),
         1910 => (16#013C#, 16#0020#, 16#0002#),
         1911 => (16#013D#, 16#0020#, 16#0002#),
         1912 => (16#013E#, 16#0020#, 16#0002#),
         1913 => (16#013F#, 16#0020#, 16#0002#),
         1914 => (16#0168#, 16#0020#, 16#0002#),
         1915 => (16#02C5#, 16#0020#, 16#0002#),
         1916 => (16#02C6#, 16#0020#, 16#0002#),
         1917 => (16#02C7#, 16#0020#, 16#0002#),
         1918 => (16#02C8#, 16#0020#, 16#0002#),
         1919 => (16#208B#, 16#0020#, 16#0002#),
         1920 => (16#0000#, 16#0098#, 16#0002#),
         1921 => (16#208C#, 16#0020#, 16#0002#),
         1922 => (16#208D#, 16#0020#, 16#0002#),
         1923 => (16#208D#, 16#0020#, 16#0004#),
         1924 => (16#0000#, 16#0109#, 16#0004#),
         1925 => (16#208F#, 16#0020#, 16#0002#),
         1926 => (16#208E#, 16#0020#, 16#0002#),
         1927 => (16#2090#, 16#0020#, 16#0002#),
         1928 => (16#2091#, 16#0020#, 16#0002#),
         1929 => (16#2092#, 16#0020#, 16#0002#),
         1930 => (16#2094#, 16#0020#, 16#0002#),
         1931 => (16#2095#, 16#0020#, 16#0002#),
         1932 => (16#2095#, 16#0020#, 16#0004#),
         1933 => (16#0000#, 16#0109#, 16#0004#),
         1934 => (16#2096#, 16#0020#, 16#0002#),
         1935 => (16#2097#, 16#0020#, 16#0002#),
         1936 => (16#2098#, 16#0020#, 16#0002#),
         1937 => (16#209A#, 16#0020#, 16#0002#),
         1938 => (16#209B#, 16#0020#, 16#0002#),
         1939 => (16#209C#, 16#0020#, 16#0002#),
         1940 => (16#209D#, 16#0020#, 16#0002#),
         1941 => (16#209D#, 16#0020#, 16#0019#),
         1942 => (16#209E#, 16#0020#, 16#0002#),
         1943 => (16#209F#, 16#0020#, 16#0002#),
         1944 => (16#209F#, 16#0020#, 16#0004#),
         1945 => (16#0000#, 16#0109#, 16#0004#),
         1946 => (16#20A1#, 16#0020#, 16#0002#),
         1947 => (16#20A2#, 16#0020#, 16#0002#),
         1948 => (16#20A3#, 16#0020#, 16#0002#),
         1949 => (16#20A4#, 16#0020#, 16#0002#),
         1950 => (16#20A5#, 16#0020#, 16#0002#),
         1951 => (16#208C#, 16#0020#, 16#0004#),
         1952 => (16#0000#, 16#010A#, 16#0004#),
         1953 => (16#208D#, 16#0020#, 16#0004#),
         1954 => (16#0000#, 16#010A#, 16#0004#),
         1955 => (16#208F#, 16#0020#, 16#0004#),
         1956 => (16#0000#, 16#010A#, 16#0004#),
         1957 => (16#0000#, 16#0099#, 16#0002#),
         1958 => (16#0000#, 16#009A#, 16#0002#),
         1959 => (16#0000#, 16#009B#, 16#0002#),
         1960 => (16#0000#, 16#009C#, 16#0002#),
         1961 => (16#0000#, 16#009D#, 16#0002#),
         1962 => (16#0000#, 16#009E#, 16#0002#),
         1963 => (16#0000#, 16#009F#, 16#0002#),
         1964 => (16#0000#, 16#00A0#, 16#0002#),
         1965 => (16#0000#, 16#00A1#, 16#0002#),
         1966 => (16#0000#, 16#00A2#, 16#0002#),
         1967 => (16#0000#, 16#00A3#, 16#0002#),
         1968 => (16#0000#, 16#00A4#, 16#0002#),
         1969 => (16#0000#, 16#00A5#, 16#0002#),
         1970 => (16#0000#, 16#00A6#, 16#0002#),
         1971 => (16#0000#, 16#00A7#, 16#0002#),
         1972 => (16#0000#, 16#00A8#, 16#0002#),
         1973 => (16#2093#, 16#0020#, 16#0002#),
         1974 => (16#2099#, 16#0020#, 16#0002#),
         1975 => (16#20A0#, 16#0020#, 16#0002#),
         1976 => (16#1FCF#, 16#0020#, 16#0002#),
         1977 => (16#1FD0#, 16#0020#, 16#0002#),
         1978 => (16#1FD1#, 16#0020#, 16#0002#),
         1979 => (16#1FD2#, 16#0020#, 16#0002#),
         1980 => (16#1FD3#, 16#0020#, 16#0002#),
         1981 => (16#1FD4#, 16#0020#, 16#0002#),
         1982 => (16#1FD6#, 16#0020#, 16#0002#),
         1983 => (16#1FEC#, 16#0020#, 16#0002#),
         1984 => (16#1FED#, 16#0020#, 16#0002#),
         1985 => (16#1FFF#, 16#0020#, 16#0002#),
         1986 => (16#2000#, 16#0020#, 16#0002#),
         1987 => (16#200D#, 16#0020#, 16#0002#),
         1988 => (16#2019#, 16#0020#, 16#0002#),
         1989 => (16#202C#, 16#0020#, 16#0002#),
         1990 => (16#202D#, 16#0020#, 16#0002#),
         1991 => (16#202E#, 16#0020#, 16#0002#),
         1992 => (16#2037#, 16#0020#, 16#0002#),
         1993 => (16#2038#, 16#0020#, 16#0002#),
         1994 => (16#204D#, 16#0020#, 16#0002#),
         1995 => (16#2050#, 16#0020#, 16#0002#),
         1996 => (16#2051#, 16#0020#, 16#0002#),
         1997 => (16#205A#, 16#0020#, 16#0002#),
         1998 => (16#205B#, 16#0020#, 16#0002#),
         1999 => (16#2063#, 16#0020#, 16#0002#),
         2000 => (16#2064#, 16#0020#, 16#0002#),
         2001 => (16#2065#, 16#0020#, 16#0002#),
         2002 => (16#2057#, 16#0020#, 16#0002#),
         2003 => (16#200E#, 16#0020#, 16#0002#),
         2004 => (16#200F#, 16#0020#, 16#0002#),
         2005 => (16#201A#, 16#0020#, 16#0002#),
         2006 => (16#1FEE#, 16#0020#, 16#0002#),
         2007 => (16#1FEF#, 16#0020#, 16#0002#),
         2008 => (16#201B#, 16#0020#, 16#0002#),
         2009 => (16#2010#, 16#0020#, 16#0002#),
         2010 => (16#1FF0#, 16#0020#, 16#0002#),
         2011 => (16#1FC3#, 16#0020#, 16#0002#),
         2012 => (16#1FC4#, 16#0020#, 16#0002#),
         2013 => (16#2085#, 16#0020#, 16#0002#),
         2014 => (16#2086#, 16#0020#, 16#0002#),
         2015 => (16#2087#, 16#0020#, 16#0002#),
         2016 => (16#2077#, 16#0020#, 16#0002#),
         2017 => (16#2078#, 16#0020#, 16#0002#),
         2018 => (16#2089#, 16#0020#, 16#0002#),
         2019 => (16#208A#, 16#0020#, 16#0002#),
         2020 => (16#1FF1#, 16#0020#, 16#0002#),
         2021 => (16#201C#, 16#0020#, 16#0002#),
         2022 => (16#201D#, 16#0020#, 16#0002#),
         2023 => (16#2043#, 16#0020#, 16#0002#),
         2024 => (16#20BF#, 16#0020#, 16#0002#),
         2025 => (16#20C2#, 16#0020#, 16#0002#),
         2026 => (16#20C3#, 16#0020#, 16#0002#),
         2027 => (16#20C4#, 16#0020#, 16#0002#),
         2028 => (16#20C6#, 16#0020#, 16#0002#),
         2029 => (16#20C7#, 16#0020#, 16#0002#),
         2030 => (16#20C8#, 16#0020#, 16#0002#),
         2031 => (16#20C9#, 16#0020#, 16#0002#),
         2032 => (16#20CC#, 16#0020#, 16#0002#),
         2033 => (16#20CE#, 16#0020#, 16#0002#),
         2034 => (16#20CF#, 16#0020#, 16#0002#),
         2035 => (16#20D0#, 16#0020#, 16#0002#),
         2036 => (16#20D2#, 16#0020#, 16#0002#),
         2037 => (16#20D6#, 16#0020#, 16#0002#),
         2038 => (16#20D7#, 16#0020#, 16#0002#),
         2039 => (16#20D9#, 16#0020#, 16#0002#),
         2040 => (16#20DA#, 16#0020#, 16#0002#),
         2041 => (16#20DE#, 16#0020#, 16#0002#),
         2042 => (16#20DF#, 16#0020#, 16#0002#),
         2043 => (16#20E0#, 16#0020#, 16#0002#),
         2044 => (16#20E1#, 16#0020#, 16#0002#),
         2045 => (16#20E2#, 16#0020#, 16#0002#),
         2046 => (16#20E3#, 16#0020#, 16#0002#),
         2047 => (16#20E4#, 16#0020#, 16#0002#),
         2048 => (16#20D3#, 16#0020#, 16#0002#),
         2049 => (16#20C0#, 16#0020#, 16#0002#),
         2050 => (16#20C1#, 16#0020#, 16#0002#),
         2051 => (16#20D1#, 16#0020#, 16#0002#),
         2052 => (16#20C5#, 16#0020#, 16#0002#),
         2053 => (16#20DB#, 16#0020#, 16#0002#),
         2054 => (16#20DC#, 16#0020#, 16#0002#),
         2055 => (16#20DD#, 16#0020#, 16#0002#),
         2056 => (16#20D4#, 16#0020#, 16#0002#),
         2057 => (16#20D5#, 16#0020#, 16#0002#),
         2058 => (16#20CA#, 16#0020#, 16#0002#),
         2059 => (16#20CB#, 16#0020#, 16#0002#),
         2060 => (16#20D8#, 16#0020#, 16#0002#),
         2061 => (16#20CD#, 16#0020#, 16#0002#),
         2062 => (16#20E6#, 16#0020#, 16#0002#),
         2063 => (16#20E7#, 16#0020#, 16#0002#),
         2064 => (16#20E8#, 16#0020#, 16#0002#),
         2065 => (16#20E9#, 16#0020#, 16#0002#),
         2066 => (16#20EA#, 16#0020#, 16#0002#),
         2067 => (16#20EB#, 16#0020#, 16#0002#),
         2068 => (16#20EC#, 16#0020#, 16#0002#),
         2069 => (16#20ED#, 16#0020#, 16#0002#),
         2070 => (16#20EE#, 16#0020#, 16#0002#),
         2071 => (16#20EF#, 16#0020#, 16#0002#),
         2072 => (16#20F0#, 16#0020#, 16#0002#),
         2073 => (16#20E5#, 16#0020#, 16#0002#),
         2074 => (16#20F1#, 16#0020#, 16#0002#),
         2075 => (16#20F2#, 16#0020#, 16#0002#),
         2076 => (16#20F3#, 16#0020#, 16#0002#),
         2077 => (16#20F4#, 16#0020#, 16#0002#),
         2078 => (16#20F5#, 16#0020#, 16#0002#),
         2079 => (16#20F6#, 16#0020#, 16#0002#),
         2080 => (16#20F7#, 16#0020#, 16#0002#),
         2081 => (16#20F8#, 16#0020#, 16#0002#),
         2082 => (16#20F9#, 16#0020#, 16#0002#),
         2083 => (16#20FA#, 16#0020#, 16#0002#),
         2084 => (16#20FB#, 16#0020#, 16#0002#),
         2085 => (16#20FC#, 16#0020#, 16#0002#),
         2086 => (16#20FD#, 16#0020#, 16#0002#),
         2087 => (16#20FE#, 16#0020#, 16#0002#),
         2088 => (16#20FF#, 16#0020#, 16#0002#),
         2089 => (16#2100#, 16#0020#, 16#0002#),
         2090 => (16#2101#, 16#0020#, 16#0002#),
         2091 => (16#2102#, 16#0020#, 16#0002#),
         2092 => (16#2103#, 16#0020#, 16#0002#),
         2093 => (16#2104#, 16#0020#, 16#0002#),
         2094 => (16#2105#, 16#0020#, 16#0002#),
         2095 => (16#2106#, 16#0020#, 16#0002#),
         2096 => (16#2107#, 16#0020#, 16#0002#),
         2097 => (16#2108#, 16#0020#, 16#0002#),
         2098 => (16#2109#, 16#0020#, 16#0002#),
         2099 => (16#210A#, 16#0020#, 16#0002#),
         2100 => (16#210B#, 16#0020#, 16#0002#),
         2101 => (16#210C#, 16#0020#, 16#0002#),
         2102 => (16#210D#, 16#0020#, 16#0002#),
         2103 => (16#210E#, 16#0020#, 16#0002#),
         2104 => (16#20FD#, 16#0020#, 16#0004#),
         2105 => (16#0000#, 16#0108#, 16#0004#),
         2106 => (16#20FE#, 16#0020#, 16#0004#),
         2107 => (16#0000#, 16#0108#, 16#0004#),
         2108 => (16#2100#, 16#0020#, 16#0004#),
         2109 => (16#0000#, 16#0108#, 16#0004#),
         2110 => (16#0000#, 16#00A9#, 16#0002#),
         2111 => (16#0000#, 16#00AA#, 16#0002#),
         2112 => (16#0000#, 16#00AB#, 16#0002#),
         2113 => (16#0000#, 16#00AC#, 16#0002#),
         2114 => (16#0000#, 16#00AD#, 16#0002#),
         2115 => (16#0000#, 16#00AE#, 16#0002#),
         2116 => (16#0000#, 16#00AF#, 16#0002#),
         2117 => (16#0000#, 16#00B0#, 16#0002#),
         2118 => (16#0000#, 16#00B1#, 16#0002#),
         2119 => (16#210F#, 16#0020#, 16#0002#),
         2120 => (16#2110#, 16#0020#, 16#0002#),
         2121 => (16#03D6#, 16#0020#, 16#0002#),
         2122 => (16#01BB#, 16#0020#, 16#0002#),
         2123 => (16#0129#, 16#0020#, 16#0002#),
         2124 => (16#0161#, 16#0020#, 16#0002#),
         2125 => (16#1FA1#, 16#0020#, 16#0002#),
         2126 => (16#1FA2#, 16#0020#, 16#0002#),
         2127 => (16#1FA3#, 16#0020#, 16#0002#),
         2128 => (16#1FA4#, 16#0020#, 16#0002#),
         2129 => (16#1FA5#, 16#0020#, 16#0002#),
         2130 => (16#1FA6#, 16#0020#, 16#0002#),
         2131 => (16#1FA7#, 16#0020#, 16#0002#),
         2132 => (16#1FA8#, 16#0020#, 16#0002#),
         2133 => (16#1FA9#, 16#0020#, 16#0002#),
         2134 => (16#1FAA#, 16#0020#, 16#0002#),
         2135 => (16#1FAB#, 16#0020#, 16#0002#),
         2136 => (16#1FAC#, 16#0020#, 16#0002#),
         2137 => (16#1FAD#, 16#0020#, 16#0002#),
         2138 => (16#1FAE#, 16#0020#, 16#0002#),
         2139 => (16#1FAF#, 16#0020#, 16#0002#),
         2140 => (16#1FB0#, 16#0020#, 16#0002#),
         2141 => (16#1FB1#, 16#0020#, 16#0002#),
         2142 => (16#1FB2#, 16#0020#, 16#0002#),
         2143 => (16#1FB3#, 16#0020#, 16#0002#),
         2144 => (16#1FB4#, 16#0020#, 16#0002#),
         2145 => (16#1FB5#, 16#0020#, 16#0002#),
         2146 => (16#1FB6#, 16#0020#, 16#0002#),
         2147 => (16#1FB7#, 16#0020#, 16#0002#),
         2148 => (16#1FB8#, 16#0020#, 16#0002#),
         2149 => (16#0000#, 16#006A#, 16#0002#),
         2150 => (16#0000#, 16#006B#, 16#0002#),
         2151 => (16#1FB9#, 16#0020#, 16#0002#),
         2152 => (16#1FBA#, 16#0020#, 16#0002#),
         2153 => (16#0000#, 16#0062#, 16#0002#),
         2154 => (16#0000#, 16#0063#, 16#0002#),
         2155 => (16#0000#, 16#0064#, 16#0002#),
         2156 => (16#0000#, 16#0065#, 16#0002#),
         2157 => (16#0000#, 16#0066#, 16#0002#),
         2158 => (16#0000#, 16#0067#, 16#0002#),
         2159 => (16#0000#, 16#0068#, 16#0002#),
         2160 => (16#0000#, 16#0069#, 16#0002#),
         2161 => (16#0000#, 16#006C#, 16#0002#),
         2162 => (16#0140#, 16#0020#, 16#0002#),
         2163 => (16#0141#, 16#0020#, 16#0002#),
         2164 => (16#0142#, 16#0020#, 16#0002#),
         2165 => (16#0143#, 16#0020#, 16#0002#),
         2166 => (16#0144#, 16#0020#, 16#0002#),
         2167 => (16#0145#, 16#0020#, 16#0002#),
         2168 => (16#0146#, 16#0020#, 16#0002#),
         2169 => (16#0147#, 16#0020#, 16#0002#),
         2170 => (16#0148#, 16#0020#, 16#0002#),
         2171 => (16#0149#, 16#0020#, 16#0002#),
         2172 => (16#014A#, 16#0020#, 16#0002#),
         2173 => (16#014B#, 16#0020#, 16#0002#),
         2174 => (16#014C#, 16#0020#, 16#0002#),
         2175 => (16#014D#, 16#0020#, 16#0002#),
         2176 => (16#014E#, 16#0020#, 16#0002#),
         2177 => (16#20A6#, 16#0020#, 16#0002#),
         2178 => (16#20A7#, 16#0020#, 16#0002#),
         2179 => (16#20A8#, 16#0020#, 16#0002#),
         2180 => (16#20A9#, 16#0020#, 16#0002#),
         2181 => (16#20AA#, 16#0020#, 16#0002#),
         2182 => (16#20AB#, 16#0020#, 16#0002#),
         2183 => (16#20AC#, 16#0020#, 16#0002#),
         2184 => (16#20AD#, 16#0020#, 16#0002#),
         2185 => (16#20AE#, 16#0020#, 16#0002#),
         2186 => (16#20AF#, 16#0020#, 16#0002#),
         2187 => (16#20B0#, 16#0020#, 16#0002#),
         2188 => (16#20B1#, 16#0020#, 16#0002#),
         2189 => (16#20B2#, 16#0020#, 16#0002#),
         2190 => (16#20B3#, 16#0020#, 16#0002#),
         2191 => (16#20B4#, 16#0020#, 16#0002#),
         2192 => (16#20B5#, 16#0020#, 16#0002#),
         2193 => (16#20B6#, 16#0020#, 16#0002#),
         2194 => (16#20B7#, 16#0020#, 16#0002#),
         2195 => (16#20B8#, 16#0020#, 16#0002#),
         2196 => (16#20B9#, 16#0020#, 16#0002#),
         2197 => (16#20BA#, 16#0020#, 16#0002#),
         2198 => (16#20BB#, 16#0020#, 16#0002#),
         2199 => (16#20BC#, 16#0020#, 16#0002#),
         2200 => (16#20BD#, 16#0020#, 16#0002#),
         2201 => (16#20BE#, 16#0020#, 16#0002#),
         2202 => (16#02C9#, 16#0020#, 16#0002#),
         2203 => (16#1FD5#, 16#0020#, 16#0002#),
         2204 => (16#1FD7#, 16#0020#, 16#0002#),
         2205 => (16#1FE6#, 16#0020#, 16#0002#),
         2206 => (16#2027#, 16#0020#, 16#0002#),
         2207 => (16#2034#, 16#0020#, 16#0002#),
         2208 => (16#203D#, 16#0020#, 16#0002#),
         2209 => (16#2058#, 16#0020#, 16#0002#),
         2210 => (16#205C#, 16#0020#, 16#0002#),
         2211 => (16#1FC6#, 16#0020#, 16#0002#),
         2212 => (16#1FC7#, 16#0020#, 16#0002#),
         2213 => (16#2011#, 16#0020#, 16#0002#),
         2214 => (16#2079#, 16#0020#, 16#0002#),
         2215 => (16#1FC8#, 16#0020#, 16#0002#),
         2216 => (16#1FFA#, 16#0020#, 16#0002#),
         2217 => (16#2021#, 16#0020#, 16#0002#),
         2218 => (16#2047#, 16#0020#, 16#0002#),
         2219 => (16#2075#, 16#0020#, 16#0002#),
         2220 => (16#2012#, 16#0020#, 16#0002#),
         2221 => (16#0000#, 16#0077#, 16#0002#),
         2222 => (16#0000#, 16#007B#, 16#0002#),
         2223 => (16#0000#, 16#007E#, 16#0002#),
         2224 => (16#0000#, 16#006F#, 16#0002#),
         2225 => (16#0000#, 16#0072#, 16#0002#),
         2226 => (16#0000#, 16#0075#, 16#0002#),
         2227 => (16#0000#, 16#006E#, 16#0002#),
         2228 => (16#0000#, 16#0071#, 16#0002#),
         2229 => (16#0000#, 16#0074#, 16#0002#),
         2230 => (16#0000#, 16#0078#, 16#0002#),
         2231 => (16#0000#, 16#0079#, 16#0002#),
         2232 => (16#0000#, 16#007F#, 16#0002#),
         2233 => (16#0000#, 16#0090#, 16#0002#),
         2234 => (16#0000#, 16#0091#, 16#0002#),
         2235 => (16#0000#, 16#0095#, 16#0002#),
         2236 => (16#0000#, 16#0096#, 16#0002#),
         2237 => (16#0000#, 16#0093#, 16#0002#),
         2238 => (16#0000#, 16#0094#, 16#0002#),
         2239 => (16#0000#, 16#0092#, 16#0002#),
         2240 => (16#0000#, 16#007C#, 16#0002#),
         2241 => (16#0000#, 16#0089#, 16#0002#),
         2242 => (16#0000#, 16#00BD#, 16#0002#),
         2243 => (16#0000#, 16#00BE#, 16#0002#),
         2244 => (16#0000#, 16#00BF#, 16#0002#),
         2245 => (16#2311#, 16#0020#, 16#0002#),
         2246 => (16#2312#, 16#0020#, 16#0002#),
         2247 => (16#2313#, 16#0020#, 16#0002#),
         2248 => (16#2319#, 16#0020#, 16#0002#),
         2249 => (16#231A#, 16#0020#, 16#0002#),
         2250 => (16#231B#, 16#0020#, 16#0002#),
         2251 => (16#231C#, 16#0020#, 16#0002#),
         2252 => (16#231D#, 16#0020#, 16#0002#),
         2253 => (16#231F#, 16#0020#, 16#0002#),
         2254 => (16#2321#, 16#0020#, 16#0002#),
         2255 => (16#2322#, 16#0020#, 16#0002#),
         2256 => (16#2323#, 16#0020#, 16#0002#),
         2257 => (16#2324#, 16#0020#, 16#0002#),
         2258 => (16#2325#, 16#0020#, 16#0002#),
         2259 => (16#2326#, 16#0020#, 16#0002#),
         2260 => (16#2327#, 16#0020#, 16#0002#),
         2261 => (16#2328#, 16#0020#, 16#0002#),
         2262 => (16#2329#, 16#0020#, 16#0002#),
         2263 => (16#232A#, 16#0020#, 16#0002#),
         2264 => (16#232B#, 16#0020#, 16#0002#),
         2265 => (16#232D#, 16#0020#, 16#0002#),
         2266 => (16#232E#, 16#0020#, 16#0002#),
         2267 => (16#232F#, 16#0020#, 16#0002#),
         2268 => (16#2330#, 16#0020#, 16#0002#),
         2269 => (16#2331#, 16#0020#, 16#0002#),
         2270 => (16#2334#, 16#0020#, 16#0002#),
         2271 => (16#2335#, 16#0020#, 16#0002#),
         2272 => (16#2336#, 16#0020#, 16#0002#),
         2273 => (16#2337#, 16#0020#, 16#0002#),
         2274 => (16#2339#, 16#0020#, 16#0002#),
         2275 => (16#233B#, 16#0020#, 16#0002#),
         2276 => (16#233C#, 16#0020#, 16#0002#),
         2277 => (16#233D#, 16#0020#, 16#0002#),
         2278 => (16#233E#, 16#0020#, 16#0002#),
         2279 => (16#233F#, 16#0020#, 16#0002#),
         2280 => (16#2340#, 16#0020#, 16#0002#),
         2281 => (16#2341#, 16#0020#, 16#0002#),
         2282 => (16#2341#, 16#0020#, 16#0002#),
         2283 => (16#0000#, 16#00BC#, 16#0002#),
         2284 => (16#2342#, 16#0020#, 16#0002#),
         2285 => (16#2343#, 16#0020#, 16#0002#),
         2286 => (16#2344#, 16#0020#, 16#0002#),
         2287 => (16#2346#, 16#0020#, 16#0002#),
         2288 => (16#2347#, 16#0020#, 16#0002#),
         2289 => (16#2348#, 16#0020#, 16#0002#),
         2290 => (16#234A#, 16#0020#, 16#0002#),
         2291 => (16#234A#, 16#0020#, 16#0002#),
         2292 => (16#0000#, 16#00BC#, 16#0002#),
         2293 => (16#234B#, 16#0020#, 16#0002#),
         2294 => (16#234C#, 16#0020#, 16#0002#),
         2295 => (16#234C#, 16#0020#, 16#0002#),
         2296 => (16#0000#, 16#00BC#, 16#0002#),
         2297 => (16#234D#, 16#0020#, 16#0002#),
         2298 => (16#234E#, 16#0020#, 16#0002#),
         2299 => (16#234F#, 16#0020#, 16#0002#),
         2300 => (16#2350#, 16#0020#, 16#0002#),
         2301 => (16#2351#, 16#0020#, 16#0002#),
         2302 => (16#235A#, 16#0020#, 16#0002#),
         2303 => (16#235B#, 16#0020#, 16#0002#),
         2304 => (16#2352#, 16#0020#, 16#0002#),
         2305 => (16#2359#, 16#0020#, 16#0002#),
         2306 => (16#235F#, 16#0020#, 16#0002#),
         2307 => (16#2360#, 16#0020#, 16#0002#),
         2308 => (16#2361#, 16#0020#, 16#0002#),
         2309 => (16#2362#, 16#0020#, 16#0002#),
         2310 => (16#2363#, 16#0020#, 16#0002#),
         2311 => (16#2364#, 16#0020#, 16#0002#),
         2312 => (16#2367#, 16#0020#, 16#0002#),
         2313 => (16#2369#, 16#0020#, 16#0002#),
         2314 => (16#236A#, 16#0020#, 16#0002#),
         2315 => (16#236C#, 16#0020#, 16#0002#),
         2316 => (16#236D#, 16#0020#, 16#0002#),
         2317 => (16#236E#, 16#0020#, 16#0002#),
         2318 => (16#236F#, 16#0020#, 16#0002#),
         2319 => (16#2370#, 16#0020#, 16#0002#),
         2320 => (16#2371#, 16#0020#, 16#0002#),
         2321 => (16#236B#, 16#0020#, 16#0002#),
         2322 => (16#235C#, 16#0020#, 16#0002#),
         2323 => (16#230F#, 16#0020#, 16#0002#),
         2324 => (16#2368#, 16#0020#, 16#0002#),
         2325 => (16#235D#, 16#0020#, 16#0002#),
         2326 => (16#235E#, 16#0020#, 16#0002#),
         2327 => (16#2329#, 16#0020#, 16#0002#),
         2328 => (16#0000#, 16#00BC#, 16#0002#),
         2329 => (16#232A#, 16#0020#, 16#0002#),
         2330 => (16#0000#, 16#00BC#, 16#0002#),
         2331 => (16#232B#, 16#0020#, 16#0002#),
         2332 => (16#0000#, 16#00BC#, 16#0002#),
         2333 => (16#2331#, 16#0020#, 16#0002#),
         2334 => (16#0000#, 16#00BC#, 16#0002#),
         2335 => (16#2339#, 16#0020#, 16#0002#),
         2336 => (16#0000#, 16#00BC#, 16#0002#),
         2337 => (16#233B#, 16#0020#, 16#0002#),
         2338 => (16#0000#, 16#00BC#, 16#0002#),
         2339 => (16#2343#, 16#0020#, 16#0002#),
         2340 => (16#0000#, 16#00BC#, 16#0002#),
         2341 => (16#2348#, 16#0020#, 16#0002#),
         2342 => (16#0000#, 16#00BC#, 16#0002#),
         2343 => (16#231E#, 16#0020#, 16#0002#),
         2344 => (16#2320#, 16#0020#, 16#0002#),
         2345 => (16#2365#, 16#0020#, 16#0002#),
         2346 => (16#2366#, 16#0020#, 16#0002#),
         2347 => (16#018A#, 16#0020#, 16#0002#),
         2348 => (16#018B#, 16#0020#, 16#0002#),
         2349 => (16#02CB#, 16#0020#, 16#0002#),
         2350 => (16#16B3#, 16#0020#, 16#0002#),
         2351 => (16#2310#, 16#0020#, 16#0002#),
         2352 => (16#2314#, 16#0020#, 16#0002#),
         2353 => (16#2315#, 16#0020#, 16#0002#),
         2354 => (16#2316#, 16#0020#, 16#0002#),
         2355 => (16#2317#, 16#0020#, 16#0002#),
         2356 => (16#2318#, 16#0020#, 16#0002#),
         2357 => (16#2338#, 16#0020#, 16#0002#),
         2358 => (16#2332#, 16#0020#, 16#0002#),
         2359 => (16#2349#, 16#0020#, 16#0002#),
         2360 => (16#232C#, 16#0020#, 16#0002#),
         2361 => (16#2333#, 16#0020#, 16#0002#),
         2362 => (16#2353#, 16#0020#, 16#0002#),
         2363 => (16#233A#, 16#0020#, 16#0002#),
         2364 => (16#2345#, 16#0020#, 16#0002#),
         2365 => (16#2372#, 16#0020#, 16#0002#),
         2366 => (16#2373#, 16#0020#, 16#0002#),
         2367 => (16#2374#, 16#0020#, 16#0002#),
         2368 => (16#2375#, 16#0020#, 16#0002#),
         2369 => (16#2376#, 16#0020#, 16#0002#),
         2370 => (16#2377#, 16#0020#, 16#0002#),
         2371 => (16#2378#, 16#0020#, 16#0002#),
         2372 => (16#2379#, 16#0020#, 16#0002#),
         2373 => (16#237B#, 16#0020#, 16#0002#),
         2374 => (16#237D#, 16#0020#, 16#0002#),
         2375 => (16#237E#, 16#0020#, 16#0002#),
         2376 => (16#237F#, 16#0020#, 16#0002#),
         2377 => (16#2380#, 16#0020#, 16#0002#),
         2378 => (16#2381#, 16#0020#, 16#0002#),
         2379 => (16#2382#, 16#0020#, 16#0002#),
         2380 => (16#2383#, 16#0020#, 16#0002#),
         2381 => (16#2384#, 16#0020#, 16#0002#),
         2382 => (16#2385#, 16#0020#, 16#0002#),
         2383 => (16#2386#, 16#0020#, 16#0002#),
         2384 => (16#2387#, 16#0020#, 16#0002#),
         2385 => (16#2388#, 16#0020#, 16#0002#),
         2386 => (16#2389#, 16#0020#, 16#0002#),
         2387 => (16#238A#, 16#0020#, 16#0002#),
         2388 => (16#238B#, 16#0020#, 16#0002#),
         2389 => (16#238C#, 16#0020#, 16#0002#),
         2390 => (16#238D#, 16#0020#, 16#0002#),
         2391 => (16#238E#, 16#0020#, 16#0002#),
         2392 => (16#238F#, 16#0020#, 16#0002#),
         2393 => (16#2390#, 16#0020#, 16#0002#),
         2394 => (16#2391#, 16#0020#, 16#0002#),
         2395 => (16#2392#, 16#0020#, 16#0002#),
         2396 => (16#2393#, 16#0020#, 16#0002#),
         2397 => (16#2394#, 16#0020#, 16#0002#),
         2398 => (16#2395#, 16#0020#, 16#0002#),
         2399 => (16#2396#, 16#0020#, 16#0002#),
         2400 => (16#2397#, 16#0020#, 16#0002#),
         2401 => (16#2398#, 16#0020#, 16#0002#),
         2402 => (16#2399#, 16#0020#, 16#0002#),
         2403 => (16#239A#, 16#0020#, 16#0002#),
         2404 => (16#239B#, 16#0020#, 16#0002#),
         2405 => (16#239D#, 16#0020#, 16#0002#),
         2406 => (16#239F#, 16#0020#, 16#0002#),
         2407 => (16#23A0#, 16#0020#, 16#0002#),
         2408 => (16#23A1#, 16#0020#, 16#0002#),
         2409 => (16#23A2#, 16#0020#, 16#0002#),
         2410 => (16#23A3#, 16#0020#, 16#0002#),
         2411 => (16#23A4#, 16#0020#, 16#0002#),
         2412 => (16#23A5#, 16#0020#, 16#0002#),
         2413 => (16#23A6#, 16#0020#, 16#0002#),
         2414 => (16#23A7#, 16#0020#, 16#0002#),
         2415 => (16#23A8#, 16#0020#, 16#0002#),
         2416 => (16#23A9#, 16#0020#, 16#0002#),
         2417 => (16#23AA#, 16#0020#, 16#0002#),
         2418 => (16#23AD#, 16#0020#, 16#0002#),
         2419 => (16#23AF#, 16#0020#, 16#0002#),
         2420 => (16#23B0#, 16#0020#, 16#0002#),
         2421 => (16#23AE#, 16#0020#, 16#0002#),
         2422 => (16#23B1#, 16#0020#, 16#0002#),
         2423 => (16#2390#, 16#0020#, 16#0004#),
         2424 => (16#23B1#, 16#0020#, 16#0004#),
         2425 => (16#23B2#, 16#0020#, 16#0002#),
         2426 => (16#238D#, 16#0020#, 16#0002#),
         2427 => (16#0000#, 16#00BC#, 16#0002#),
         2428 => (16#238E#, 16#0020#, 16#0002#),
         2429 => (16#0000#, 16#00BC#, 16#0002#),
         2430 => (16#239A#, 16#0020#, 16#0002#),
         2431 => (16#0000#, 16#00BC#, 16#0002#),
         2432 => (16#237A#, 16#0020#, 16#0002#),
         2433 => (16#237C#, 16#0020#, 16#0002#),
         2434 => (16#23AB#, 16#0020#, 16#0002#),
         2435 => (16#23AC#, 16#0020#, 16#0002#),
         2436 => (16#239C#, 16#0020#, 16#0002#),
         2437 => (16#239E#, 16#0020#, 16#0002#),
         2438 => (16#16CF#, 16#0020#, 16#0002#),
         2439 => (16#16D0#, 16#0020#, 16#0002#),
         2440 => (16#16F6#, 16#0020#, 16#0002#),
         2441 => (16#16F7#, 16#0020#, 16#0002#),
         2442 => (16#16F8#, 16#0020#, 16#0002#),
         2443 => (16#16F9#, 16#0020#, 16#0002#),
         2444 => (16#16FA#, 16#0020#, 16#0002#),
         2445 => (16#16FB#, 16#0020#, 16#0002#),
         2446 => (16#03D7#, 16#0020#, 16#0002#),
         2447 => (16#16D1#, 16#0020#, 16#0002#),
         2448 => (16#23B8#, 16#0020#, 16#0002#),
         2449 => (16#23B9#, 16#0020#, 16#0002#),
         2450 => (16#23BD#, 16#0020#, 16#0002#),
         2451 => (16#23BE#, 16#0020#, 16#0002#),
         2452 => (16#23B5#, 16#0020#, 16#0002#),
         2453 => (16#23B6#, 16#0020#, 16#0002#),
         2454 => (16#23BF#, 16#0020#, 16#0002#),
         2455 => (16#23BA#, 16#0020#, 16#0002#),
         2456 => (16#23B7#, 16#0020#, 16#0002#),
         2457 => (16#23BB#, 16#0020#, 16#0002#),
         2458 => (16#23C3#, 16#0020#, 16#0002#),
         2459 => (16#23C4#, 16#0020#, 16#0002#),
         2460 => (16#23C5#, 16#0020#, 16#0002#),
         2461 => (16#23C6#, 16#0020#, 16#0002#),
         2462 => (16#23C7#, 16#0020#, 16#0002#),
         2463 => (16#23C8#, 16#0020#, 16#0002#),
         2464 => (16#23C9#, 16#0020#, 16#0002#),
         2465 => (16#23CA#, 16#0020#, 16#0002#),
         2466 => (16#23CB#, 16#0020#, 16#0002#),
         2467 => (16#23CC#, 16#0020#, 16#0002#),
         2468 => (16#23CD#, 16#0020#, 16#0002#),
         2469 => (16#23CE#, 16#0020#, 16#0002#),
         2470 => (16#23CF#, 16#0020#, 16#0002#),
         2471 => (16#23D0#, 16#0020#, 16#0002#),
         2472 => (16#23D1#, 16#0020#, 16#0002#),
         2473 => (16#23D2#, 16#0020#, 16#0002#),
         2474 => (16#23D3#, 16#0020#, 16#0002#),
         2475 => (16#23D4#, 16#0020#, 16#0002#),
         2476 => (16#23D5#, 16#0020#, 16#0002#),
         2477 => (16#23D6#, 16#0020#, 16#0002#),
         2478 => (16#23D7#, 16#0020#, 16#0002#),
         2479 => (16#23D8#, 16#0020#, 16#0002#),
         2480 => (16#23D9#, 16#0020#, 16#0002#),
         2481 => (16#23DA#, 16#0020#, 16#0002#),
         2482 => (16#23DB#, 16#0020#, 16#0002#),
         2483 => (16#23DC#, 16#0020#, 16#0002#),
         2484 => (16#23DE#, 16#0020#, 16#0002#),
         2485 => (16#23DF#, 16#0020#, 16#0002#),
         2486 => (16#23DF#, 16#0020#, 16#0002#),
         2487 => (16#0000#, 16#00BC#, 16#0002#),
         2488 => (16#23E0#, 16#0020#, 16#0002#),
         2489 => (16#23C0#, 16#0020#, 16#0002#),
         2490 => (16#0000#, 16#00BC#, 16#0002#),
         2491 => (16#23C1#, 16#0020#, 16#0002#),
         2492 => (16#23E2#, 16#0020#, 16#0002#),
         2493 => (16#23E3#, 16#0020#, 16#0002#),
         2494 => (16#23E4#, 16#0020#, 16#0002#),
         2495 => (16#23E5#, 16#0020#, 16#0002#),
         2496 => (16#23E6#, 16#0020#, 16#0002#),
         2497 => (16#23E7#, 16#0020#, 16#0002#),
         2498 => (16#23E8#, 16#0020#, 16#0002#),
         2499 => (16#23E9#, 16#0020#, 16#0002#),
         2500 => (16#23EA#, 16#0020#, 16#0002#),
         2501 => (16#23EB#, 16#0020#, 16#0002#),
         2502 => (16#23C2#, 16#0020#, 16#0002#),
         2503 => (16#23C4#, 16#0020#, 16#0002#),
         2504 => (16#0000#, 16#00BC#, 16#0002#),
         2505 => (16#23C5#, 16#0020#, 16#0002#),
         2506 => (16#0000#, 16#00BC#, 16#0002#),
         2507 => (16#23CA#, 16#0020#, 16#0002#),
         2508 => (16#0000#, 16#00BC#, 16#0002#),
         2509 => (16#23E1#, 16#0020#, 16#0002#),
         2510 => (16#23D8#, 16#0020#, 16#0002#),
         2511 => (16#0000#, 16#00BC#, 16#0002#),
         2512 => (16#0000#, 16#00C0#, 16#0002#),
         2513 => (16#0000#, 16#00C1#, 16#0002#),
         2514 => (16#23BC#, 16#0020#, 16#0002#),
         2515 => (16#23B4#, 16#0020#, 16#0002#),
         2516 => (16#23B3#, 16#0020#, 16#0002#),
         2517 => (16#23DD#, 16#0020#, 16#0002#),
         2518 => (16#23ED#, 16#0020#, 16#0002#),
         2519 => (16#23EE#, 16#0020#, 16#0002#),
         2520 => (16#23EF#, 16#0020#, 16#0002#),
         2521 => (16#23F0#, 16#0020#, 16#0002#),
         2522 => (16#23F1#, 16#0020#, 16#0002#),
         2523 => (16#23F2#, 16#0020#, 16#0002#),
         2524 => (16#23F3#, 16#0020#, 16#0002#),
         2525 => (16#23F5#, 16#0020#, 16#0002#),
         2526 => (16#23F7#, 16#0020#, 16#0002#),
         2527 => (16#23F8#, 16#0020#, 16#0002#),
         2528 => (16#23F9#, 16#0020#, 16#0002#),
         2529 => (16#23FA#, 16#0020#, 16#0002#),
         2530 => (16#23FB#, 16#0020#, 16#0002#),
         2531 => (16#23FC#, 16#0020#, 16#0002#),
         2532 => (16#23FD#, 16#0020#, 16#0002#),
         2533 => (16#23FE#, 16#0020#, 16#0002#),
         2534 => (16#23FF#, 16#0020#, 16#0002#),
         2535 => (16#2400#, 16#0020#, 16#0002#),
         2536 => (16#2401#, 16#0020#, 16#0002#),
         2537 => (16#2402#, 16#0020#, 16#0002#),
         2538 => (16#2403#, 16#0020#, 16#0002#),
         2539 => (16#2404#, 16#0020#, 16#0002#),
         2540 => (16#2405#, 16#0020#, 16#0002#),
         2541 => (16#2406#, 16#0020#, 16#0002#),
         2542 => (16#2407#, 16#0020#, 16#0002#),
         2543 => (16#2408#, 16#0020#, 16#0002#),
         2544 => (16#2409#, 16#0020#, 16#0002#),
         2545 => (16#240A#, 16#0020#, 16#0002#),
         2546 => (16#240B#, 16#0020#, 16#0002#),
         2547 => (16#240C#, 16#0020#, 16#0002#),
         2548 => (16#240D#, 16#0020#, 16#0002#),
         2549 => (16#240E#, 16#0020#, 16#0002#),
         2550 => (16#240F#, 16#0020#, 16#0002#),
         2551 => (16#2410#, 16#0020#, 16#0002#),
         2552 => (16#2411#, 16#0020#, 16#0002#),
         2553 => (16#2412#, 16#0020#, 16#0002#),
         2554 => (16#2413#, 16#0020#, 16#0002#),
         2555 => (16#2414#, 16#0020#, 16#0002#),
         2556 => (16#2415#, 16#0020#, 16#0002#),
         2557 => (16#2416#, 16#0020#, 16#0002#),
         2558 => (16#2417#, 16#0020#, 16#0002#),
         2559 => (16#2418#, 16#0020#, 16#0002#),
         2560 => (16#241E#, 16#0020#, 16#0002#),
         2561 => (16#2419#, 16#0020#, 16#0002#),
         2562 => (16#241A#, 16#0020#, 16#0002#),
         2563 => (16#241B#, 16#0020#, 16#0002#),
         2564 => (16#241C#, 16#0020#, 16#0002#),
         2565 => (16#241D#, 16#0020#, 16#0002#),
         2566 => (16#241F#, 16#0020#, 16#0002#),
         2567 => (16#2420#, 16#0020#, 16#0002#),
         2568 => (16#2421#, 16#0020#, 16#0002#),
         2569 => (16#2422#, 16#0020#, 16#0002#),
         2570 => (16#2423#, 16#0020#, 16#0002#),
         2571 => (16#2424#, 16#0020#, 16#0002#),
         2572 => (16#2425#, 16#0020#, 16#0002#),
         2573 => (16#2426#, 16#0020#, 16#0002#),
         2574 => (16#2429#, 16#0020#, 16#0002#),
         2575 => (16#242A#, 16#0020#, 16#0002#),
         2576 => (16#242B#, 16#0020#, 16#0002#),
         2577 => (16#242C#, 16#0020#, 16#0002#),
         2578 => (16#242D#, 16#0020#, 16#0002#),
         2579 => (16#242E#, 16#0020#, 16#0002#),
         2580 => (16#242F#, 16#0020#, 16#0002#),
         2581 => (16#23EC#, 16#0020#, 16#0002#),
         2582 => (16#23F4#, 16#0020#, 16#0002#),
         2583 => (16#23F6#, 16#0020#, 16#0002#),
         2584 => (16#2427#, 16#0020#, 16#0002#),
         2585 => (16#2428#, 16#0020#, 16#0002#),
         2586 => (16#02CF#, 16#0020#, 16#0002#),
         2587 => (16#16D2#, 16#0020#, 16#0002#),
         2588 => (16#2430#, 16#0020#, 16#0002#),
         2589 => (16#2431#, 16#0020#, 16#0002#),
         2590 => (16#2432#, 16#0020#, 16#0002#),
         2591 => (16#2433#, 16#0020#, 16#0002#),
         2592 => (16#2434#, 16#0020#, 16#0002#),
         2593 => (16#2435#, 16#0020#, 16#0002#),
         2594 => (16#2436#, 16#0020#, 16#0002#),
         2595 => (16#2438#, 16#0020#, 16#0002#),
         2596 => (16#243A#, 16#0020#, 16#0002#),
         2597 => (16#243B#, 16#0020#, 16#0002#),
         2598 => (16#243C#, 16#0020#, 16#0002#),
         2599 => (16#243D#, 16#0020#, 16#0002#),
         2600 => (16#243E#, 16#0020#, 16#0002#),
         2601 => (16#243F#, 16#0020#, 16#0002#),
         2602 => (16#2440#, 16#0020#, 16#0002#),
         2603 => (16#2441#, 16#0020#, 16#0002#),
         2604 => (16#2442#, 16#0020#, 16#0002#),
         2605 => (16#2443#, 16#0020#, 16#0002#),
         2606 => (16#2444#, 16#0020#, 16#0002#),
         2607 => (16#2445#, 16#0020#, 16#0002#),
         2608 => (16#2446#, 16#0020#, 16#0002#),
         2609 => (16#2447#, 16#0020#, 16#0002#),
         2610 => (16#2448#, 16#0020#, 16#0002#),
         2611 => (16#2449#, 16#0020#, 16#0002#),
         2612 => (16#244A#, 16#0020#, 16#0002#),
         2613 => (16#244B#, 16#0020#, 16#0002#),
         2614 => (16#244C#, 16#0020#, 16#0002#),
         2615 => (16#244D#, 16#0020#, 16#0002#),
         2616 => (16#244E#, 16#0020#, 16#0002#),
         2617 => (16#244F#, 16#0020#, 16#0002#),
         2618 => (16#2450#, 16#0020#, 16#0002#),
         2619 => (16#2451#, 16#0020#, 16#0002#),
         2620 => (16#2452#, 16#0020#, 16#0002#),
         2621 => (16#2453#, 16#0020#, 16#0002#),
         2622 => (16#2454#, 16#0020#, 16#0002#),
         2623 => (16#2455#, 16#0020#, 16#0002#),
         2624 => (16#2456#, 16#0020#, 16#0002#),
         2625 => (16#2457#, 16#0020#, 16#0002#),
         2626 => (16#2459#, 16#0020#, 16#0002#),
         2627 => (16#245A#, 16#0020#, 16#0002#),
         2628 => (16#245B#, 16#0020#, 16#0002#),
         2629 => (16#245C#, 16#0020#, 16#0002#),
         2630 => (16#245E#, 16#0020#, 16#0002#),
         2631 => (16#245F#, 16#0020#, 16#0002#),
         2632 => (16#2460#, 16#0020#, 16#0002#),
         2633 => (16#2461#, 16#0020#, 16#0002#),
         2634 => (16#2462#, 16#0020#, 16#0002#),
         2635 => (16#2463#, 16#0020#, 16#0002#),
         2636 => (16#2464#, 16#0020#, 16#0002#),
         2637 => (16#2465#, 16#0020#, 16#0002#),
         2638 => (16#2466#, 16#0020#, 16#0002#),
         2639 => (16#2467#, 16#0020#, 16#0002#),
         2640 => (16#2468#, 16#0020#, 16#0002#),
         2641 => (16#2469#, 16#0020#, 16#0002#),
         2642 => (16#246C#, 16#0020#, 16#0002#),
         2643 => (16#246D#, 16#0020#, 16#0002#),
         2644 => (16#246E#, 16#0020#, 16#0002#),
         2645 => (16#246F#, 16#0020#, 16#0002#),
         2646 => (16#2470#, 16#0020#, 16#0002#),
         2647 => (16#2471#, 16#0020#, 16#0002#),
         2648 => (16#2472#, 16#0020#, 16#0002#),
         2649 => (16#244A#, 16#0020#, 16#0002#),
         2650 => (16#0000#, 16#00BC#, 16#0002#),
         2651 => (16#244B#, 16#0020#, 16#0002#),
         2652 => (16#0000#, 16#00BC#, 16#0002#),
         2653 => (16#2458#, 16#0020#, 16#0002#),
         2654 => (16#2437#, 16#0020#, 16#0002#),
         2655 => (16#2439#, 16#0020#, 16#0002#),
         2656 => (16#246A#, 16#0020#, 16#0002#),
         2657 => (16#246B#, 16#0020#, 16#0002#),
         2658 => (16#03D8#, 16#0020#, 16#0002#),
         2659 => (16#245D#, 16#0020#, 16#0002#),
         2660 => (16#16FC#, 16#0020#, 16#0002#),
         2661 => (16#16FD#, 16#0020#, 16#0002#),
         2662 => (16#16FE#, 16#0020#, 16#0002#),
         2663 => (16#16FF#, 16#0020#, 16#0002#),
         2664 => (16#1700#, 16#0020#, 16#0002#),
         2665 => (16#1701#, 16#0020#, 16#0002#),
         2666 => (16#2480#, 16#0020#, 16#0002#),
         2667 => (16#2474#, 16#0020#, 16#0002#),
         2668 => (16#2475#, 16#0020#, 16#0002#),
         2669 => (16#2476#, 16#0020#, 16#0002#),
         2670 => (16#2477#, 16#0020#, 16#0002#),
         2671 => (16#2478#, 16#0020#, 16#0002#),
         2672 => (16#2479#, 16#0020#, 16#0002#),
         2673 => (16#247A#, 16#0020#, 16#0002#),
         2674 => (16#247B#, 16#0020#, 16#0002#),
         2675 => (16#247C#, 16#0020#, 16#0002#),
         2676 => (16#247D#, 16#0020#, 16#0002#),
         2677 => (16#247F#, 16#0020#, 16#0002#),
         2678 => (16#247E#, 16#0020#, 16#0002#),
         2679 => (16#2481#, 16#0020#, 16#0002#),
         2680 => (16#2482#, 16#0020#, 16#0002#),
         2681 => (16#2483#, 16#0020#, 16#0002#),
         2682 => (16#2493#, 16#0020#, 16#0002#),
         2683 => (16#2484#, 16#0020#, 16#0002#),
         2684 => (16#2485#, 16#0020#, 16#0002#),
         2685 => (16#2486#, 16#0020#, 16#0002#),
         2686 => (16#2487#, 16#0020#, 16#0002#),
         2687 => (16#2488#, 16#0020#, 16#0002#),
         2688 => (16#2492#, 16#0020#, 16#0002#),
         2689 => (16#2489#, 16#0020#, 16#0002#),
         2690 => (16#248A#, 16#0020#, 16#0002#),
         2691 => (16#248B#, 16#0020#, 16#0002#),
         2692 => (16#248C#, 16#0020#, 16#0002#),
         2693 => (16#2491#, 16#0020#, 16#0002#),
         2694 => (16#248D#, 16#0020#, 16#0002#),
         2695 => (16#2490#, 16#0020#, 16#0002#),
         2696 => (16#248F#, 16#0020#, 16#0002#),
         2697 => (16#248E#, 16#0020#, 16#0002#),
         2698 => (16#2494#, 16#0020#, 16#0002#),
         2699 => (16#2495#, 16#0020#, 16#0002#),
         2700 => (16#2496#, 16#0020#, 16#0002#),
         2701 => (16#2497#, 16#0020#, 16#0002#),
         2702 => (16#2498#, 16#0020#, 16#0002#),
         2703 => (16#2499#, 16#0020#, 16#0002#),
         2704 => (16#249A#, 16#0020#, 16#0002#),
         2705 => (16#249B#, 16#0020#, 16#0002#),
         2706 => (16#249C#, 16#0020#, 16#0002#),
         2707 => (16#249D#, 16#0020#, 16#0002#),
         2708 => (16#24A0#, 16#0020#, 16#0002#),
         2709 => (16#24A2#, 16#0020#, 16#0002#),
         2710 => (16#249E#, 16#0020#, 16#0002#),
         2711 => (16#24A1#, 16#0020#, 16#0002#),
         2712 => (16#249F#, 16#0020#, 16#0002#),
         2713 => (16#24A3#, 16#0020#, 16#0002#),
         2714 => (16#2473#, 16#0020#, 16#0002#),
         2715 => (16#24A4#, 16#0020#, 16#0002#),
         2716 => (16#1708#, 16#0020#, 16#0002#),
         2717 => (16#1709#, 16#0020#, 16#0002#),
         2718 => (16#170A#, 16#0020#, 16#0002#),
         2719 => (16#03D9#, 16#0020#, 16#0002#),
         2720 => (16#03DA#, 16#0020#, 16#0002#),
         2721 => (16#03DB#, 16#0020#, 16#0002#),
         2722 => (16#03DC#, 16#0020#, 16#0002#),
         2723 => (16#03DD#, 16#0020#, 16#0002#),
         2724 => (16#03DE#, 16#0020#, 16#0002#),
         2725 => (16#16D4#, 16#0020#, 16#0002#),
         2726 => (16#03DF#, 16#0020#, 16#0002#),
         2727 => (16#24A5#, 16#0020#, 16#0002#),
         2728 => (16#24A6#, 16#0020#, 16#0002#),
         2729 => (16#24A7#, 16#0020#, 16#0002#),
         2730 => (16#24A8#, 16#0020#, 16#0002#),
         2731 => (16#24A9#, 16#0020#, 16#0002#),
         2732 => (16#24AA#, 16#0020#, 16#0002#),
         2733 => (16#24AB#, 16#0020#, 16#0002#),
         2734 => (16#24AD#, 16#0020#, 16#0002#),
         2735 => (16#24AF#, 16#0020#, 16#0002#),
         2736 => (16#24B0#, 16#0020#, 16#0002#),
         2737 => (16#24B1#, 16#0020#, 16#0002#),
         2738 => (16#24B2#, 16#0020#, 16#0002#),
         2739 => (16#24B3#, 16#0020#, 16#0002#),
         2740 => (16#24B4#, 16#0020#, 16#0002#),
         2741 => (16#24B5#, 16#0020#, 16#0002#),
         2742 => (16#24B6#, 16#0020#, 16#0002#),
         2743 => (16#24B7#, 16#0020#, 16#0002#),
         2744 => (16#24B8#, 16#0020#, 16#0002#),
         2745 => (16#24B9#, 16#0020#, 16#0002#),
         2746 => (16#24BA#, 16#0020#, 16#0002#),
         2747 => (16#24BC#, 16#0020#, 16#0002#),
         2748 => (16#24BD#, 16#0020#, 16#0002#),
         2749 => (16#24BF#, 16#0020#, 16#0002#),
         2750 => (16#24C0#, 16#0020#, 16#0002#),
         2751 => (16#24C1#, 16#0020#, 16#0002#),
         2752 => (16#24C2#, 16#0020#, 16#0002#),
         2753 => (16#24C3#, 16#0020#, 16#0002#),
         2754 => (16#24C4#, 16#0020#, 16#0002#),
         2755 => (16#24C5#, 16#0020#, 16#0002#),
         2756 => (16#24C6#, 16#0020#, 16#0002#),
         2757 => (16#24C7#, 16#0020#, 16#0002#),
         2758 => (16#24C8#, 16#0020#, 16#0002#),
         2759 => (16#24C9#, 16#0020#, 16#0002#),
         2760 => (16#24CA#, 16#0020#, 16#0002#),
         2761 => (16#24CB#, 16#0020#, 16#0002#),
         2762 => (16#24CC#, 16#0020#, 16#0002#),
         2763 => (16#24CD#, 16#0020#, 16#0002#),
         2764 => (16#24CE#, 16#0020#, 16#0002#),
         2765 => (16#24CF#, 16#0020#, 16#0002#),
         2766 => (16#24D0#, 16#0020#, 16#0002#),
         2767 => (16#24D1#, 16#0020#, 16#0002#),
         2768 => (16#24D2#, 16#0020#, 16#0002#),
         2769 => (16#24D3#, 16#0020#, 16#0002#),
         2770 => (16#24D9#, 16#0020#, 16#0002#),
         2771 => (16#24DA#, 16#0020#, 16#0002#),
         2772 => (16#24D4#, 16#0020#, 16#0002#),
         2773 => (16#24D5#, 16#0020#, 16#0002#),
         2774 => (16#24D6#, 16#0020#, 16#0002#),
         2775 => (16#24D7#, 16#0020#, 16#0002#),
         2776 => (16#24D8#, 16#0020#, 16#0002#),
         2777 => (16#24DB#, 16#0020#, 16#0002#),
         2778 => (16#24DC#, 16#0020#, 16#0002#),
         2779 => (16#24DD#, 16#0020#, 16#0002#),
         2780 => (16#24DE#, 16#0020#, 16#0002#),
         2781 => (16#24DF#, 16#0020#, 16#0002#),
         2782 => (16#24E0#, 16#0020#, 16#0002#),
         2783 => (16#24E1#, 16#0020#, 16#0002#),
         2784 => (16#24E2#, 16#0020#, 16#0002#),
         2785 => (16#24E5#, 16#0020#, 16#0002#),
         2786 => (16#24E7#, 16#0020#, 16#0002#),
         2787 => (16#24E6#, 16#0020#, 16#0002#),
         2788 => (16#24E8#, 16#0020#, 16#0002#),
         2789 => (16#24E9#, 16#0020#, 16#0002#),
         2790 => (16#24EA#, 16#0020#, 16#0002#),
         2791 => (16#24EB#, 16#0020#, 16#0002#),
         2792 => (16#24EC#, 16#0020#, 16#0002#),
         2793 => (16#24ED#, 16#0020#, 16#0002#),
         2794 => (16#24BB#, 16#0020#, 16#0002#),
         2795 => (16#24BE#, 16#0020#, 16#0002#),
         2796 => (16#24AC#, 16#0020#, 16#0002#),
         2797 => (16#24AE#, 16#0020#, 16#0002#),
         2798 => (16#24E3#, 16#0020#, 16#0002#),
         2799 => (16#24E4#, 16#0020#, 16#0002#),
         2800 => (16#03E0#, 16#0020#, 16#0002#),
         2801 => (16#24EE#, 16#0020#, 16#0002#),
         2802 => (16#24EF#, 16#0020#, 16#0002#),
         2803 => (16#24F0#, 16#0020#, 16#0002#),
         2804 => (16#24F1#, 16#0020#, 16#0002#),
         2805 => (16#24F2#, 16#0020#, 16#0002#),
         2806 => (16#24F3#, 16#0020#, 16#0002#),
         2807 => (16#24F4#, 16#0020#, 16#0002#),
         2808 => (16#24F6#, 16#0020#, 16#0002#),
         2809 => (16#24F8#, 16#0020#, 16#0002#),
         2810 => (16#24F9#, 16#0020#, 16#0002#),
         2811 => (16#24FA#, 16#0020#, 16#0002#),
         2812 => (16#24FB#, 16#0020#, 16#0002#),
         2813 => (16#24FC#, 16#0020#, 16#0002#),
         2814 => (16#24FD#, 16#0020#, 16#0002#),
         2815 => (16#24FE#, 16#0020#, 16#0002#),
         2816 => (16#24FF#, 16#0020#, 16#0002#),
         2817 => (16#2500#, 16#0020#, 16#0002#),
         2818 => (16#2501#, 16#0020#, 16#0002#),
         2819 => (16#2502#, 16#0020#, 16#0002#),
         2820 => (16#2503#, 16#0020#, 16#0002#),
         2821 => (16#2504#, 16#0020#, 16#0002#),
         2822 => (16#2505#, 16#0020#, 16#0002#),
         2823 => (16#2506#, 16#0020#, 16#0002#),
         2824 => (16#2507#, 16#0020#, 16#0002#),
         2825 => (16#2508#, 16#0020#, 16#0002#),
         2826 => (16#2509#, 16#0020#, 16#0002#),
         2827 => (16#250A#, 16#0020#, 16#0002#),
         2828 => (16#250B#, 16#0020#, 16#0002#),
         2829 => (16#250C#, 16#0020#, 16#0002#),
         2830 => (16#250D#, 16#0020#, 16#0002#),
         2831 => (16#250E#, 16#0020#, 16#0002#),
         2832 => (16#250F#, 16#0020#, 16#0002#),
         2833 => (16#2510#, 16#0020#, 16#0002#),
         2834 => (16#2511#, 16#0020#, 16#0002#),
         2835 => (16#2512#, 16#0020#, 16#0002#),
         2836 => (16#2513#, 16#0020#, 16#0002#),
         2837 => (16#2514#, 16#0020#, 16#0002#),
         2838 => (16#2515#, 16#0020#, 16#0002#),
         2839 => (16#2516#, 16#0020#, 16#0002#),
         2840 => (16#2517#, 16#0020#, 16#0002#),
         2841 => (16#2518#, 16#0020#, 16#0002#),
         2842 => (16#2519#, 16#0020#, 16#0002#),
         2843 => (16#251A#, 16#0020#, 16#0002#),
         2844 => (16#2520#, 16#0020#, 16#0002#),
         2845 => (16#251B#, 16#0020#, 16#0002#),
         2846 => (16#251C#, 16#0020#, 16#0002#),
         2847 => (16#251D#, 16#0020#, 16#0002#),
         2848 => (16#251E#, 16#0020#, 16#0002#),
         2849 => (16#251F#, 16#0020#, 16#0002#),
         2850 => (16#2522#, 16#0020#, 16#0002#),
         2851 => (16#2525#, 16#0020#, 16#0002#),
         2852 => (16#2526#, 16#0020#, 16#0002#),
         2853 => (16#2527#, 16#0020#, 16#0002#),
         2854 => (16#2528#, 16#0020#, 16#0002#),
         2855 => (16#2529#, 16#0020#, 16#0002#),
         2856 => (16#252A#, 16#0020#, 16#0002#),
         2857 => (16#252B#, 16#0020#, 16#0002#),
         2858 => (16#252E#, 16#0020#, 16#0002#),
         2859 => (16#252F#, 16#0020#, 16#0002#),
         2860 => (16#2530#, 16#0020#, 16#0002#),
         2861 => (16#2531#, 16#0020#, 16#0002#),
         2862 => (16#2532#, 16#0020#, 16#0002#),
         2863 => (16#2533#, 16#0020#, 16#0002#),
         2864 => (16#2534#, 16#0020#, 16#0002#),
         2865 => (16#2535#, 16#0020#, 16#0002#),
         2866 => (16#2536#, 16#0020#, 16#0002#),
         2867 => (16#2521#, 16#0020#, 16#0002#),
         2868 => (16#24F5#, 16#0020#, 16#0002#),
         2869 => (16#24F7#, 16#0020#, 16#0002#),
         2870 => (16#252C#, 16#0020#, 16#0002#),
         2871 => (16#252D#, 16#0020#, 16#0002#),
         2872 => (16#2523#, 16#0020#, 16#0002#),
         2873 => (16#2524#, 16#0020#, 16#0002#),
         2874 => (16#2537#, 16#0020#, 16#0002#),
         2875 => (16#2538#, 16#0020#, 16#0002#),
         2876 => (16#2539#, 16#0020#, 16#0002#),
         2877 => (16#253A#, 16#0020#, 16#0002#),
         2878 => (16#253B#, 16#0020#, 16#0002#),
         2879 => (16#253C#, 16#0020#, 16#0002#),
         2880 => (16#253D#, 16#0020#, 16#0002#),
         2881 => (16#253F#, 16#0020#, 16#0002#),
         2882 => (16#2541#, 16#0020#, 16#0002#),
         2883 => (16#2542#, 16#0020#, 16#0002#),
         2884 => (16#2543#, 16#0020#, 16#0002#),
         2885 => (16#2544#, 16#0020#, 16#0002#),
         2886 => (16#2545#, 16#0020#, 16#0002#),
         2887 => (16#2546#, 16#0020#, 16#0002#),
         2888 => (16#2547#, 16#0020#, 16#0002#),
         2889 => (16#2548#, 16#0020#, 16#0002#),
         2890 => (16#2549#, 16#0020#, 16#0002#),
         2891 => (16#254A#, 16#0020#, 16#0002#),
         2892 => (16#254B#, 16#0020#, 16#0002#),
         2893 => (16#254C#, 16#0020#, 16#0002#),
         2894 => (16#254D#, 16#0020#, 16#0002#),
         2895 => (16#254E#, 16#0020#, 16#0002#),
         2896 => (16#254F#, 16#0020#, 16#0002#),
         2897 => (16#2550#, 16#0020#, 16#0002#),
         2898 => (16#2551#, 16#0020#, 16#0002#),
         2899 => (16#2552#, 16#0020#, 16#0002#),
         2900 => (16#2553#, 16#0020#, 16#0002#),
         2901 => (16#2554#, 16#0020#, 16#0002#),
         2902 => (16#2555#, 16#0020#, 16#0002#),
         2903 => (16#2556#, 16#0020#, 16#0002#),
         2904 => (16#2557#, 16#0020#, 16#0002#),
         2905 => (16#2558#, 16#0020#, 16#0002#),
         2906 => (16#2559#, 16#0020#, 16#0002#),
         2907 => (16#255A#, 16#0020#, 16#0002#),
         2908 => (16#255B#, 16#0020#, 16#0002#),
         2909 => (16#255C#, 16#0020#, 16#0002#),
         2910 => (16#255D#, 16#0020#, 16#0002#),
         2911 => (16#255E#, 16#0020#, 16#0002#),
         2912 => (16#255F#, 16#0020#, 16#0002#),
         2913 => (16#2560#, 16#0020#, 16#0002#),
         2914 => (16#2561#, 16#0020#, 16#0002#),
         2915 => (16#2562#, 16#0020#, 16#0002#),
         2916 => (16#256B#, 16#0020#, 16#0002#),
         2917 => (16#2563#, 16#0020#, 16#0002#),
         2918 => (16#2569#, 16#0020#, 16#0002#),
         2919 => (16#256A#, 16#0020#, 16#0002#),
         2920 => (16#2564#, 16#0020#, 16#0002#),
         2921 => (16#2565#, 16#0020#, 16#0002#),
         2922 => (16#2566#, 16#0020#, 16#0002#),
         2923 => (16#2567#, 16#0020#, 16#0002#),
         2924 => (16#2568#, 16#0020#, 16#0002#),
         2925 => (16#256C#, 16#0020#, 16#0002#),
         2926 => (16#256D#, 16#0020#, 16#0002#),
         2927 => (16#256E#, 16#0020#, 16#0002#),
         2928 => (16#256F#, 16#0020#, 16#0002#),
         2929 => (16#2570#, 16#0020#, 16#0002#),
         2930 => (16#2571#, 16#0020#, 16#0002#),
         2931 => (16#2572#, 16#0020#, 16#0002#),
         2932 => (16#2573#, 16#0020#, 16#0002#),
         2933 => (16#2574#, 16#0020#, 16#0002#),
         2934 => (16#2577#, 16#0020#, 16#0002#),
         2935 => (16#257A#, 16#0020#, 16#0002#),
         2936 => (16#257C#, 16#0020#, 16#0002#),
         2937 => (16#2578#, 16#0020#, 16#0002#),
         2938 => (16#257B#, 16#0020#, 16#0002#),
         2939 => (16#2579#, 16#0020#, 16#0002#),
         2940 => (16#257E#, 16#0020#, 16#0002#),
         2941 => (16#2562#, 16#0020#, 16#0004#),
         2942 => (16#257E#, 16#0020#, 16#0004#),
         2943 => (16#257D#, 16#0020#, 16#0002#),
         2944 => (16#253E#, 16#0020#, 16#0002#),
         2945 => (16#2540#, 16#0020#, 16#0002#),
         2946 => (16#2575#, 16#0020#, 16#0002#),
         2947 => (16#2576#, 16#0020#, 16#0002#),
         2948 => (16#170B#, 16#0020#, 16#0002#),
         2949 => (16#170C#, 16#0020#, 16#0002#),
         2950 => (16#170D#, 16#0020#, 16#0002#),
         2951 => (16#170E#, 16#0020#, 16#0002#),
         2952 => (16#170F#, 16#0020#, 16#0002#),
         2953 => (16#1710#, 16#0020#, 16#0002#),
         2954 => (16#03E1#, 16#0020#, 16#0002#),
         2955 => (16#2555#, 16#0020#, 16#0004#),
         2956 => (16#257E#, 16#0020#, 16#0004#),
         2957 => (16#255A#, 16#0020#, 16#0004#),
         2958 => (16#257E#, 16#0020#, 16#0004#),
         2959 => (16#2563#, 16#0020#, 16#0004#),
         2960 => (16#257E#, 16#0020#, 16#0004#),
         2961 => (16#2569#, 16#0020#, 16#0004#),
         2962 => (16#257E#, 16#0020#, 16#0004#),
         2963 => (16#2547#, 16#0020#, 16#0004#),
         2964 => (16#257E#, 16#0020#, 16#0004#),
         2965 => (16#257F#, 16#0020#, 16#0002#),
         2966 => (16#2580#, 16#0020#, 16#0002#),
         2967 => (16#2581#, 16#0020#, 16#0002#),
         2968 => (16#2582#, 16#0020#, 16#0002#),
         2969 => (16#2583#, 16#0020#, 16#0002#),
         2970 => (16#2584#, 16#0020#, 16#0002#),
         2971 => (16#2585#, 16#0020#, 16#0002#),
         2972 => (16#2586#, 16#0020#, 16#0002#),
         2973 => (16#2587#, 16#0020#, 16#0002#),
         2974 => (16#2588#, 16#0020#, 16#0002#),
         2975 => (16#2589#, 16#0020#, 16#0002#),
         2976 => (16#258A#, 16#0020#, 16#0002#),
         2977 => (16#258B#, 16#0020#, 16#0002#),
         2978 => (16#258C#, 16#0020#, 16#0002#),
         2979 => (16#258D#, 16#0020#, 16#0002#),
         2980 => (16#258E#, 16#0020#, 16#0002#),
         2981 => (16#258F#, 16#0020#, 16#0002#),
         2982 => (16#2590#, 16#0020#, 16#0002#),
         2983 => (16#2591#, 16#0020#, 16#0002#),
         2984 => (16#2592#, 16#0020#, 16#0002#),
         2985 => (16#2593#, 16#0020#, 16#0002#),
         2986 => (16#2594#, 16#0020#, 16#0002#),
         2987 => (16#2595#, 16#0020#, 16#0002#),
         2988 => (16#2596#, 16#0020#, 16#0002#),
         2989 => (16#2597#, 16#0020#, 16#0002#),
         2990 => (16#2598#, 16#0020#, 16#0002#),
         2991 => (16#2599#, 16#0020#, 16#0002#),
         2992 => (16#259A#, 16#0020#, 16#0002#),
         2993 => (16#259B#, 16#0020#, 16#0002#),
         2994 => (16#259C#, 16#0020#, 16#0002#),
         2995 => (16#259D#, 16#0020#, 16#0002#),
         2996 => (16#259E#, 16#0020#, 16#0002#),
         2997 => (16#259F#, 16#0020#, 16#0002#),
         2998 => (16#25A0#, 16#0020#, 16#0002#),
         2999 => (16#25A1#, 16#0020#, 16#0002#),
         3000 => (16#25A2#, 16#0020#, 16#0002#),
         3001 => (16#25A3#, 16#0020#, 16#0002#),
         3002 => (16#25A4#, 16#0020#, 16#0002#),
         3003 => (16#25A5#, 16#0020#, 16#0002#),
         3004 => (16#25A6#, 16#0020#, 16#0002#),
         3005 => (16#25A7#, 16#0020#, 16#0002#),
         3006 => (16#25A8#, 16#0020#, 16#0002#),
         3007 => (16#25A9#, 16#0020#, 16#0002#),
         3008 => (16#25AA#, 16#0020#, 16#0002#),
         3009 => (16#25AB#, 16#0020#, 16#0002#),
         3010 => (16#25AC#, 16#0020#, 16#0002#),
         3011 => (16#25AD#, 16#0020#, 16#0002#),
         3012 => (16#25AE#, 16#0020#, 16#0002#),
         3013 => (16#25AF#, 16#0020#, 16#0002#),
         3014 => (16#25B0#, 16#0020#, 16#0002#),
         3015 => (16#25B1#, 16#0020#, 16#0002#),
         3016 => (16#25B2#, 16#0020#, 16#0002#),
         3017 => (16#25B3#, 16#0020#, 16#0002#),
         3018 => (16#25B4#, 16#0020#, 16#0002#),
         3019 => (16#25B5#, 16#0020#, 16#0002#),
         3020 => (16#25B6#, 16#0020#, 16#0002#),
         3021 => (16#25B7#, 16#0020#, 16#0002#),
         3022 => (16#25B8#, 16#0020#, 16#0002#),
         3023 => (16#25B9#, 16#0020#, 16#0002#),
         3024 => (16#25CB#, 16#0020#, 16#0002#),
         3025 => (16#25BA#, 16#0020#, 16#0002#),
         3026 => (16#25BB#, 16#0020#, 16#0002#),
         3027 => (16#25BC#, 16#0020#, 16#0002#),
         3028 => (16#25BD#, 16#0020#, 16#0002#),
         3029 => (16#25BE#, 16#0020#, 16#0002#),
         3030 => (16#25BF#, 16#0020#, 16#0002#),
         3031 => (16#25C0#, 16#0020#, 16#0002#),
         3032 => (16#25C1#, 16#0020#, 16#0002#),
         3033 => (16#25C5#, 16#0020#, 16#0002#),
         3034 => (16#25C6#, 16#0020#, 16#0002#),
         3035 => (16#25C8#, 16#0020#, 16#0002#),
         3036 => (16#25CA#, 16#0020#, 16#0002#),
         3037 => (16#25C9#, 16#0020#, 16#0002#),
         3038 => (16#25C7#, 16#0020#, 16#0002#),
         3039 => (16#25C3#, 16#0020#, 16#0002#),
         3040 => (16#25C2#, 16#0020#, 16#0002#),
         3041 => (16#25C4#, 16#0020#, 16#0002#),
         3042 => (16#02D0#, 16#0020#, 16#0002#),
         3043 => (16#2951#, 16#0020#, 16#0002#),
         3044 => (16#2952#, 16#0020#, 16#0002#),
         3045 => (16#2953#, 16#0020#, 16#0002#),
         3046 => (16#2954#, 16#0020#, 16#0002#),
         3047 => (16#2955#, 16#0020#, 16#0002#),
         3048 => (16#2956#, 16#0020#, 16#0002#),
         3049 => (16#2957#, 16#0020#, 16#0002#),
         3050 => (16#2958#, 16#0020#, 16#0002#),
         3051 => (16#2959#, 16#0020#, 16#0002#),
         3052 => (16#295A#, 16#0020#, 16#0002#),
         3053 => (16#295B#, 16#0020#, 16#0002#),
         3054 => (16#295C#, 16#0020#, 16#0002#),
         3055 => (16#295D#, 16#0020#, 16#0002#),
         3056 => (16#295E#, 16#0020#, 16#0002#),
         3057 => (16#295F#, 16#0020#, 16#0002#),
         3058 => (16#2960#, 16#0020#, 16#0002#),
         3059 => (16#2961#, 16#0020#, 16#0002#),
         3060 => (16#2962#, 16#0020#, 16#0002#),
         3061 => (16#2963#, 16#0020#, 16#0002#),
         3062 => (16#2964#, 16#0020#, 16#0002#),
         3063 => (16#2965#, 16#0020#, 16#0002#),
         3064 => (16#2966#, 16#0020#, 16#0002#),
         3065 => (16#2967#, 16#0020#, 16#0002#),
         3066 => (16#2968#, 16#0020#, 16#0002#),
         3067 => (16#2969#, 16#0020#, 16#0002#),
         3068 => (16#296A#, 16#0020#, 16#0002#),
         3069 => (16#296B#, 16#0020#, 16#0002#),
         3070 => (16#296C#, 16#0020#, 16#0002#),
         3071 => (16#296D#, 16#0020#, 16#0002#),
         3072 => (16#296E#, 16#0020#, 16#0002#),
         3073 => (16#296F#, 16#0020#, 16#0002#),
         3074 => (16#2970#, 16#0020#, 16#0002#),
         3075 => (16#2971#, 16#0020#, 16#0002#),
         3076 => (16#2972#, 16#0020#, 16#0002#),
         3077 => (16#2973#, 16#0020#, 16#0002#),
         3078 => (16#2974#, 16#0020#, 16#0002#),
         3079 => (16#2975#, 16#0020#, 16#0002#),
         3080 => (16#2976#, 16#0020#, 16#0002#),
         3081 => (16#2977#, 16#0020#, 16#0002#),
         3082 => (16#2978#, 16#0020#, 16#0002#),
         3083 => (16#2979#, 16#0020#, 16#0002#),
         3084 => (16#297A#, 16#0020#, 16#0002#),
         3085 => (16#297B#, 16#0020#, 16#0002#),
         3086 => (16#297C#, 16#0020#, 16#0002#),
         3087 => (16#297D#, 16#0020#, 16#0002#),
         3088 => (16#297E#, 16#0020#, 16#0002#),
         3089 => (16#297F#, 16#0020#, 16#0002#),
         3090 => (16#2980#, 16#0020#, 16#0002#),
         3091 => (16#2981#, 16#0020#, 16#0002#),
         3092 => (16#2982#, 16#0020#, 16#0002#),
         3093 => (16#2983#, 16#0020#, 16#0002#),
         3094 => (16#2984#, 16#0020#, 16#0002#),
         3095 => (16#2985#, 16#0020#, 16#0002#),
         3096 => (16#2986#, 16#0020#, 16#0002#),
         3097 => (16#2987#, 16#0020#, 16#0002#),
         3098 => (16#2988#, 16#0020#, 16#0002#),
         3099 => (16#2989#, 16#0020#, 16#0002#),
         3100 => (16#298A#, 16#0020#, 16#0002#),
         3101 => (16#16D5#, 16#0020#, 16#0002#),
         3102 => (16#298B#, 16#0020#, 16#0002#),
         3103 => (16#2951#, 16#0020#, 16#0002#),
         3104 => (16#298B#, 16#0020#, 16#0002#),
         3105 => (16#2952#, 16#0020#, 16#0002#),
         3106 => (16#298B#, 16#0020#, 16#0002#),
         3107 => (16#2953#, 16#0020#, 16#0002#),
         3108 => (16#298B#, 16#0020#, 16#0002#),
         3109 => (16#2954#, 16#0020#, 16#0002#),
         3110 => (16#298B#, 16#0020#, 16#0002#),
         3111 => (16#2955#, 16#0020#, 16#0002#),
         3112 => (16#298B#, 16#0020#, 16#0002#),
         3113 => (16#2956#, 16#0020#, 16#0002#),
         3114 => (16#298B#, 16#0020#, 16#0002#),
         3115 => (16#2957#, 16#0020#, 16#0002#),
         3116 => (16#298B#, 16#0020#, 16#0002#),
         3117 => (16#2958#, 16#0020#, 16#0002#),
         3118 => (16#298B#, 16#0020#, 16#0002#),
         3119 => (16#2959#, 16#0020#, 16#0002#),
         3120 => (16#298B#, 16#0020#, 16#0002#),
         3121 => (16#295A#, 16#0020#, 16#0002#),
         3122 => (16#298B#, 16#0020#, 16#0002#),
         3123 => (16#295B#, 16#0020#, 16#0002#),
         3124 => (16#298B#, 16#0020#, 16#0002#),
         3125 => (16#295C#, 16#0020#, 16#0002#),
         3126 => (16#298B#, 16#0020#, 16#0002#),
         3127 => (16#295D#, 16#0020#, 16#0002#),
         3128 => (16#298B#, 16#0020#, 16#0002#),
         3129 => (16#295E#, 16#0020#, 16#0002#),
         3130 => (16#298B#, 16#0020#, 16#0002#),
         3131 => (16#295F#, 16#0020#, 16#0002#),
         3132 => (16#298B#, 16#0020#, 16#0002#),
         3133 => (16#2960#, 16#0020#, 16#0002#),
         3134 => (16#298B#, 16#0020#, 16#0002#),
         3135 => (16#2961#, 16#0020#, 16#0002#),
         3136 => (16#298B#, 16#0020#, 16#0002#),
         3137 => (16#2962#, 16#0020#, 16#0002#),
         3138 => (16#298B#, 16#0020#, 16#0002#),
         3139 => (16#2963#, 16#0020#, 16#0002#),
         3140 => (16#298B#, 16#0020#, 16#0002#),
         3141 => (16#2964#, 16#0020#, 16#0002#),
         3142 => (16#298B#, 16#0020#, 16#0002#),
         3143 => (16#2965#, 16#0020#, 16#0002#),
         3144 => (16#298B#, 16#0020#, 16#0002#),
         3145 => (16#2966#, 16#0020#, 16#0002#),
         3146 => (16#298B#, 16#0020#, 16#0002#),
         3147 => (16#2967#, 16#0020#, 16#0002#),
         3148 => (16#298B#, 16#0020#, 16#0002#),
         3149 => (16#2968#, 16#0020#, 16#0002#),
         3150 => (16#298B#, 16#0020#, 16#0002#),
         3151 => (16#2969#, 16#0020#, 16#0002#),
         3152 => (16#298B#, 16#0020#, 16#0002#),
         3153 => (16#296A#, 16#0020#, 16#0002#),
         3154 => (16#298B#, 16#0020#, 16#0002#),
         3155 => (16#296B#, 16#0020#, 16#0002#),
         3156 => (16#298B#, 16#0020#, 16#0002#),
         3157 => (16#296C#, 16#0020#, 16#0002#),
         3158 => (16#298B#, 16#0020#, 16#0002#),
         3159 => (16#296D#, 16#0020#, 16#0002#),
         3160 => (16#298B#, 16#0020#, 16#0002#),
         3161 => (16#296E#, 16#0020#, 16#0002#),
         3162 => (16#298B#, 16#0020#, 16#0002#),
         3163 => (16#296F#, 16#0020#, 16#0002#),
         3164 => (16#298B#, 16#0020#, 16#0002#),
         3165 => (16#2970#, 16#0020#, 16#0002#),
         3166 => (16#298B#, 16#0020#, 16#0002#),
         3167 => (16#2971#, 16#0020#, 16#0002#),
         3168 => (16#298B#, 16#0020#, 16#0002#),
         3169 => (16#2972#, 16#0020#, 16#0002#),
         3170 => (16#298B#, 16#0020#, 16#0002#),
         3171 => (16#2973#, 16#0020#, 16#0002#),
         3172 => (16#298B#, 16#0020#, 16#0002#),
         3173 => (16#2974#, 16#0020#, 16#0002#),
         3174 => (16#298B#, 16#0020#, 16#0002#),
         3175 => (16#2975#, 16#0020#, 16#0002#),
         3176 => (16#298B#, 16#0020#, 16#0002#),
         3177 => (16#2976#, 16#0020#, 16#0002#),
         3178 => (16#298B#, 16#0020#, 16#0002#),
         3179 => (16#2977#, 16#0020#, 16#0002#),
         3180 => (16#298B#, 16#0020#, 16#0002#),
         3181 => (16#2978#, 16#0020#, 16#0002#),
         3182 => (16#298B#, 16#0020#, 16#0002#),
         3183 => (16#2979#, 16#0020#, 16#0002#),
         3184 => (16#298B#, 16#0020#, 16#0002#),
         3185 => (16#297A#, 16#0020#, 16#0002#),
         3186 => (16#298B#, 16#0020#, 16#0002#),
         3187 => (16#297B#, 16#0020#, 16#0002#),
         3188 => (16#298B#, 16#0020#, 16#0002#),
         3189 => (16#297C#, 16#0020#, 16#0002#),
         3190 => (16#298B#, 16#0020#, 16#0002#),
         3191 => (16#297D#, 16#0020#, 16#0002#),
         3192 => (16#298B#, 16#0020#, 16#0002#),
         3193 => (16#297E#, 16#0020#, 16#0002#),
         3194 => (16#298B#, 16#0020#, 16#0002#),
         3195 => (16#298C#, 16#0020#, 16#0002#),
         3196 => (16#2951#, 16#0020#, 16#0002#),
         3197 => (16#298C#, 16#0020#, 16#0002#),
         3198 => (16#2952#, 16#0020#, 16#0002#),
         3199 => (16#298C#, 16#0020#, 16#0002#),
         3200 => (16#2953#, 16#0020#, 16#0002#),
         3201 => (16#298C#, 16#0020#, 16#0002#),
         3202 => (16#2954#, 16#0020#, 16#0002#),
         3203 => (16#298C#, 16#0020#, 16#0002#),
         3204 => (16#2955#, 16#0020#, 16#0002#),
         3205 => (16#298C#, 16#0020#, 16#0002#),
         3206 => (16#2956#, 16#0020#, 16#0002#),
         3207 => (16#298C#, 16#0020#, 16#0002#),
         3208 => (16#2957#, 16#0020#, 16#0002#),
         3209 => (16#298C#, 16#0020#, 16#0002#),
         3210 => (16#2958#, 16#0020#, 16#0002#),
         3211 => (16#298C#, 16#0020#, 16#0002#),
         3212 => (16#2959#, 16#0020#, 16#0002#),
         3213 => (16#298C#, 16#0020#, 16#0002#),
         3214 => (16#295A#, 16#0020#, 16#0002#),
         3215 => (16#298C#, 16#0020#, 16#0002#),
         3216 => (16#295B#, 16#0020#, 16#0002#),
         3217 => (16#298C#, 16#0020#, 16#0002#),
         3218 => (16#295C#, 16#0020#, 16#0002#),
         3219 => (16#298C#, 16#0020#, 16#0002#),
         3220 => (16#295D#, 16#0020#, 16#0002#),
         3221 => (16#298C#, 16#0020#, 16#0002#),
         3222 => (16#295E#, 16#0020#, 16#0002#),
         3223 => (16#298C#, 16#0020#, 16#0002#),
         3224 => (16#295F#, 16#0020#, 16#0002#),
         3225 => (16#298C#, 16#0020#, 16#0002#),
         3226 => (16#2960#, 16#0020#, 16#0002#),
         3227 => (16#298C#, 16#0020#, 16#0002#),
         3228 => (16#2961#, 16#0020#, 16#0002#),
         3229 => (16#298C#, 16#0020#, 16#0002#),
         3230 => (16#2962#, 16#0020#, 16#0002#),
         3231 => (16#298C#, 16#0020#, 16#0002#),
         3232 => (16#2963#, 16#0020#, 16#0002#),
         3233 => (16#298C#, 16#0020#, 16#0002#),
         3234 => (16#2964#, 16#0020#, 16#0002#),
         3235 => (16#298C#, 16#0020#, 16#0002#),
         3236 => (16#2965#, 16#0020#, 16#0002#),
         3237 => (16#298C#, 16#0020#, 16#0002#),
         3238 => (16#2966#, 16#0020#, 16#0002#),
         3239 => (16#298C#, 16#0020#, 16#0002#),
         3240 => (16#2967#, 16#0020#, 16#0002#),
         3241 => (16#298C#, 16#0020#, 16#0002#),
         3242 => (16#2968#, 16#0020#, 16#0002#),
         3243 => (16#298C#, 16#0020#, 16#0002#),
         3244 => (16#2969#, 16#0020#, 16#0002#),
         3245 => (16#298C#, 16#0020#, 16#0002#),
         3246 => (16#296A#, 16#0020#, 16#0002#),
         3247 => (16#298C#, 16#0020#, 16#0002#),
         3248 => (16#296B#, 16#0020#, 16#0002#),
         3249 => (16#298C#, 16#0020#, 16#0002#),
         3250 => (16#296C#, 16#0020#, 16#0002#),
         3251 => (16#298C#, 16#0020#, 16#0002#),
         3252 => (16#296D#, 16#0020#, 16#0002#),
         3253 => (16#298C#, 16#0020#, 16#0002#),
         3254 => (16#296E#, 16#0020#, 16#0002#),
         3255 => (16#298C#, 16#0020#, 16#0002#),
         3256 => (16#296F#, 16#0020#, 16#0002#),
         3257 => (16#298C#, 16#0020#, 16#0002#),
         3258 => (16#2970#, 16#0020#, 16#0002#),
         3259 => (16#298C#, 16#0020#, 16#0002#),
         3260 => (16#2971#, 16#0020#, 16#0002#),
         3261 => (16#298C#, 16#0020#, 16#0002#),
         3262 => (16#2972#, 16#0020#, 16#0002#),
         3263 => (16#298C#, 16#0020#, 16#0002#),
         3264 => (16#2973#, 16#0020#, 16#0002#),
         3265 => (16#298C#, 16#0020#, 16#0002#),
         3266 => (16#2974#, 16#0020#, 16#0002#),
         3267 => (16#298C#, 16#0020#, 16#0002#),
         3268 => (16#2975#, 16#0020#, 16#0002#),
         3269 => (16#298C#, 16#0020#, 16#0002#),
         3270 => (16#2976#, 16#0020#, 16#0002#),
         3271 => (16#298C#, 16#0020#, 16#0002#),
         3272 => (16#2977#, 16#0020#, 16#0002#),
         3273 => (16#298C#, 16#0020#, 16#0002#),
         3274 => (16#2978#, 16#0020#, 16#0002#),
         3275 => (16#298C#, 16#0020#, 16#0002#),
         3276 => (16#2979#, 16#0020#, 16#0002#),
         3277 => (16#298C#, 16#0020#, 16#0002#),
         3278 => (16#297A#, 16#0020#, 16#0002#),
         3279 => (16#298C#, 16#0020#, 16#0002#),
         3280 => (16#297B#, 16#0020#, 16#0002#),
         3281 => (16#298C#, 16#0020#, 16#0002#),
         3282 => (16#297C#, 16#0020#, 16#0002#),
         3283 => (16#298C#, 16#0020#, 16#0002#),
         3284 => (16#297D#, 16#0020#, 16#0002#),
         3285 => (16#298C#, 16#0020#, 16#0002#),
         3286 => (16#297E#, 16#0020#, 16#0002#),
         3287 => (16#298C#, 16#0020#, 16#0002#),
         3288 => (16#298D#, 16#0020#, 16#0002#),
         3289 => (16#2951#, 16#0020#, 16#0002#),
         3290 => (16#298D#, 16#0020#, 16#0002#),
         3291 => (16#2952#, 16#0020#, 16#0002#),
         3292 => (16#298D#, 16#0020#, 16#0002#),
         3293 => (16#2953#, 16#0020#, 16#0002#),
         3294 => (16#298D#, 16#0020#, 16#0002#),
         3295 => (16#2954#, 16#0020#, 16#0002#),
         3296 => (16#298D#, 16#0020#, 16#0002#),
         3297 => (16#2955#, 16#0020#, 16#0002#),
         3298 => (16#298D#, 16#0020#, 16#0002#),
         3299 => (16#2956#, 16#0020#, 16#0002#),
         3300 => (16#298D#, 16#0020#, 16#0002#),
         3301 => (16#2957#, 16#0020#, 16#0002#),
         3302 => (16#298D#, 16#0020#, 16#0002#),
         3303 => (16#2958#, 16#0020#, 16#0002#),
         3304 => (16#298D#, 16#0020#, 16#0002#),
         3305 => (16#2959#, 16#0020#, 16#0002#),
         3306 => (16#298D#, 16#0020#, 16#0002#),
         3307 => (16#295A#, 16#0020#, 16#0002#),
         3308 => (16#298D#, 16#0020#, 16#0002#),
         3309 => (16#295B#, 16#0020#, 16#0002#),
         3310 => (16#298D#, 16#0020#, 16#0002#),
         3311 => (16#295C#, 16#0020#, 16#0002#),
         3312 => (16#298D#, 16#0020#, 16#0002#),
         3313 => (16#295D#, 16#0020#, 16#0002#),
         3314 => (16#298D#, 16#0020#, 16#0002#),
         3315 => (16#295E#, 16#0020#, 16#0002#),
         3316 => (16#298D#, 16#0020#, 16#0002#),
         3317 => (16#295F#, 16#0020#, 16#0002#),
         3318 => (16#298D#, 16#0020#, 16#0002#),
         3319 => (16#2960#, 16#0020#, 16#0002#),
         3320 => (16#298D#, 16#0020#, 16#0002#),
         3321 => (16#2961#, 16#0020#, 16#0002#),
         3322 => (16#298D#, 16#0020#, 16#0002#),
         3323 => (16#2962#, 16#0020#, 16#0002#),
         3324 => (16#298D#, 16#0020#, 16#0002#),
         3325 => (16#2963#, 16#0020#, 16#0002#),
         3326 => (16#298D#, 16#0020#, 16#0002#),
         3327 => (16#2964#, 16#0020#, 16#0002#),
         3328 => (16#298D#, 16#0020#, 16#0002#),
         3329 => (16#2965#, 16#0020#, 16#0002#),
         3330 => (16#298D#, 16#0020#, 16#0002#),
         3331 => (16#2966#, 16#0020#, 16#0002#),
         3332 => (16#298D#, 16#0020#, 16#0002#),
         3333 => (16#2967#, 16#0020#, 16#0002#),
         3334 => (16#298D#, 16#0020#, 16#0002#),
         3335 => (16#2968#, 16#0020#, 16#0002#),
         3336 => (16#298D#, 16#0020#, 16#0002#),
         3337 => (16#2969#, 16#0020#, 16#0002#),
         3338 => (16#298D#, 16#0020#, 16#0002#),
         3339 => (16#296A#, 16#0020#, 16#0002#),
         3340 => (16#298D#, 16#0020#, 16#0002#),
         3341 => (16#296B#, 16#0020#, 16#0002#),
         3342 => (16#298D#, 16#0020#, 16#0002#),
         3343 => (16#296C#, 16#0020#, 16#0002#),
         3344 => (16#298D#, 16#0020#, 16#0002#),
         3345 => (16#296D#, 16#0020#, 16#0002#),
         3346 => (16#298D#, 16#0020#, 16#0002#),
         3347 => (16#296E#, 16#0020#, 16#0002#),
         3348 => (16#298D#, 16#0020#, 16#0002#),
         3349 => (16#296F#, 16#0020#, 16#0002#),
         3350 => (16#298D#, 16#0020#, 16#0002#),
         3351 => (16#2970#, 16#0020#, 16#0002#),
         3352 => (16#298D#, 16#0020#, 16#0002#),
         3353 => (16#2971#, 16#0020#, 16#0002#),
         3354 => (16#298D#, 16#0020#, 16#0002#),
         3355 => (16#2972#, 16#0020#, 16#0002#),
         3356 => (16#298D#, 16#0020#, 16#0002#),
         3357 => (16#2973#, 16#0020#, 16#0002#),
         3358 => (16#298D#, 16#0020#, 16#0002#),
         3359 => (16#2974#, 16#0020#, 16#0002#),
         3360 => (16#298D#, 16#0020#, 16#0002#),
         3361 => (16#2975#, 16#0020#, 16#0002#),
         3362 => (16#298D#, 16#0020#, 16#0002#),
         3363 => (16#2976#, 16#0020#, 16#0002#),
         3364 => (16#298D#, 16#0020#, 16#0002#),
         3365 => (16#2977#, 16#0020#, 16#0002#),
         3366 => (16#298D#, 16#0020#, 16#0002#),
         3367 => (16#2978#, 16#0020#, 16#0002#),
         3368 => (16#298D#, 16#0020#, 16#0002#),
         3369 => (16#2979#, 16#0020#, 16#0002#),
         3370 => (16#298D#, 16#0020#, 16#0002#),
         3371 => (16#297A#, 16#0020#, 16#0002#),
         3372 => (16#298D#, 16#0020#, 16#0002#),
         3373 => (16#297B#, 16#0020#, 16#0002#),
         3374 => (16#298D#, 16#0020#, 16#0002#),
         3375 => (16#297C#, 16#0020#, 16#0002#),
         3376 => (16#298D#, 16#0020#, 16#0002#),
         3377 => (16#297D#, 16#0020#, 16#0002#),
         3378 => (16#298D#, 16#0020#, 16#0002#),
         3379 => (16#297E#, 16#0020#, 16#0002#),
         3380 => (16#298D#, 16#0020#, 16#0002#),
         3381 => (16#298E#, 16#0020#, 16#0002#),
         3382 => (16#2951#, 16#0020#, 16#0002#),
         3383 => (16#298E#, 16#0020#, 16#0002#),
         3384 => (16#2952#, 16#0020#, 16#0002#),
         3385 => (16#298E#, 16#0020#, 16#0002#),
         3386 => (16#2953#, 16#0020#, 16#0002#),
         3387 => (16#298E#, 16#0020#, 16#0002#),
         3388 => (16#2954#, 16#0020#, 16#0002#),
         3389 => (16#298E#, 16#0020#, 16#0002#),
         3390 => (16#2955#, 16#0020#, 16#0002#),
         3391 => (16#298E#, 16#0020#, 16#0002#),
         3392 => (16#2956#, 16#0020#, 16#0002#),
         3393 => (16#298E#, 16#0020#, 16#0002#),
         3394 => (16#2957#, 16#0020#, 16#0002#),
         3395 => (16#298E#, 16#0020#, 16#0002#),
         3396 => (16#2958#, 16#0020#, 16#0002#),
         3397 => (16#298E#, 16#0020#, 16#0002#),
         3398 => (16#2959#, 16#0020#, 16#0002#),
         3399 => (16#298E#, 16#0020#, 16#0002#),
         3400 => (16#295A#, 16#0020#, 16#0002#),
         3401 => (16#298E#, 16#0020#, 16#0002#),
         3402 => (16#295B#, 16#0020#, 16#0002#),
         3403 => (16#298E#, 16#0020#, 16#0002#),
         3404 => (16#295C#, 16#0020#, 16#0002#),
         3405 => (16#298E#, 16#0020#, 16#0002#),
         3406 => (16#295D#, 16#0020#, 16#0002#),
         3407 => (16#298E#, 16#0020#, 16#0002#),
         3408 => (16#295E#, 16#0020#, 16#0002#),
         3409 => (16#298E#, 16#0020#, 16#0002#),
         3410 => (16#295F#, 16#0020#, 16#0002#),
         3411 => (16#298E#, 16#0020#, 16#0002#),
         3412 => (16#2960#, 16#0020#, 16#0002#),
         3413 => (16#298E#, 16#0020#, 16#0002#),
         3414 => (16#2961#, 16#0020#, 16#0002#),
         3415 => (16#298E#, 16#0020#, 16#0002#),
         3416 => (16#2962#, 16#0020#, 16#0002#),
         3417 => (16#298E#, 16#0020#, 16#0002#),
         3418 => (16#2963#, 16#0020#, 16#0002#),
         3419 => (16#298E#, 16#0020#, 16#0002#),
         3420 => (16#2964#, 16#0020#, 16#0002#),
         3421 => (16#298E#, 16#0020#, 16#0002#),
         3422 => (16#2965#, 16#0020#, 16#0002#),
         3423 => (16#298E#, 16#0020#, 16#0002#),
         3424 => (16#2966#, 16#0020#, 16#0002#),
         3425 => (16#298E#, 16#0020#, 16#0002#),
         3426 => (16#2967#, 16#0020#, 16#0002#),
         3427 => (16#298E#, 16#0020#, 16#0002#),
         3428 => (16#2968#, 16#0020#, 16#0002#),
         3429 => (16#298E#, 16#0020#, 16#0002#),
         3430 => (16#2969#, 16#0020#, 16#0002#),
         3431 => (16#298E#, 16#0020#, 16#0002#),
         3432 => (16#296A#, 16#0020#, 16#0002#),
         3433 => (16#298E#, 16#0020#, 16#0002#),
         3434 => (16#296B#, 16#0020#, 16#0002#),
         3435 => (16#298E#, 16#0020#, 16#0002#),
         3436 => (16#296C#, 16#0020#, 16#0002#),
         3437 => (16#298E#, 16#0020#, 16#0002#),
         3438 => (16#296D#, 16#0020#, 16#0002#),
         3439 => (16#298E#, 16#0020#, 16#0002#),
         3440 => (16#296E#, 16#0020#, 16#0002#),
         3441 => (16#298E#, 16#0020#, 16#0002#),
         3442 => (16#296F#, 16#0020#, 16#0002#),
         3443 => (16#298E#, 16#0020#, 16#0002#),
         3444 => (16#2970#, 16#0020#, 16#0002#),
         3445 => (16#298E#, 16#0020#, 16#0002#),
         3446 => (16#2971#, 16#0020#, 16#0002#),
         3447 => (16#298E#, 16#0020#, 16#0002#),
         3448 => (16#2972#, 16#0020#, 16#0002#),
         3449 => (16#298E#, 16#0020#, 16#0002#),
         3450 => (16#2973#, 16#0020#, 16#0002#),
         3451 => (16#298E#, 16#0020#, 16#0002#),
         3452 => (16#2974#, 16#0020#, 16#0002#),
         3453 => (16#298E#, 16#0020#, 16#0002#),
         3454 => (16#2975#, 16#0020#, 16#0002#),
         3455 => (16#298E#, 16#0020#, 16#0002#),
         3456 => (16#2976#, 16#0020#, 16#0002#),
         3457 => (16#298E#, 16#0020#, 16#0002#),
         3458 => (16#2977#, 16#0020#, 16#0002#),
         3459 => (16#298E#, 16#0020#, 16#0002#),
         3460 => (16#2978#, 16#0020#, 16#0002#),
         3461 => (16#298E#, 16#0020#, 16#0002#),
         3462 => (16#2979#, 16#0020#, 16#0002#),
         3463 => (16#298E#, 16#0020#, 16#0002#),
         3464 => (16#297A#, 16#0020#, 16#0002#),
         3465 => (16#298E#, 16#0020#, 16#0002#),
         3466 => (16#297B#, 16#0020#, 16#0002#),
         3467 => (16#298E#, 16#0020#, 16#0002#),
         3468 => (16#297C#, 16#0020#, 16#0002#),
         3469 => (16#298E#, 16#0020#, 16#0002#),
         3470 => (16#297D#, 16#0020#, 16#0002#),
         3471 => (16#298E#, 16#0020#, 16#0002#),
         3472 => (16#297E#, 16#0020#, 16#0002#),
         3473 => (16#298E#, 16#0020#, 16#0002#),
         3474 => (16#298F#, 16#0020#, 16#0002#),
         3475 => (16#2951#, 16#0020#, 16#0002#),
         3476 => (16#298F#, 16#0020#, 16#0002#),
         3477 => (16#2952#, 16#0020#, 16#0002#),
         3478 => (16#298F#, 16#0020#, 16#0002#),
         3479 => (16#2953#, 16#0020#, 16#0002#),
         3480 => (16#298F#, 16#0020#, 16#0002#),
         3481 => (16#2954#, 16#0020#, 16#0002#),
         3482 => (16#298F#, 16#0020#, 16#0002#),
         3483 => (16#2955#, 16#0020#, 16#0002#),
         3484 => (16#298F#, 16#0020#, 16#0002#),
         3485 => (16#2956#, 16#0020#, 16#0002#),
         3486 => (16#298F#, 16#0020#, 16#0002#),
         3487 => (16#2957#, 16#0020#, 16#0002#),
         3488 => (16#298F#, 16#0020#, 16#0002#),
         3489 => (16#2958#, 16#0020#, 16#0002#),
         3490 => (16#298F#, 16#0020#, 16#0002#),
         3491 => (16#2959#, 16#0020#, 16#0002#),
         3492 => (16#298F#, 16#0020#, 16#0002#),
         3493 => (16#295A#, 16#0020#, 16#0002#),
         3494 => (16#298F#, 16#0020#, 16#0002#),
         3495 => (16#295B#, 16#0020#, 16#0002#),
         3496 => (16#298F#, 16#0020#, 16#0002#),
         3497 => (16#295C#, 16#0020#, 16#0002#),
         3498 => (16#298F#, 16#0020#, 16#0002#),
         3499 => (16#295D#, 16#0020#, 16#0002#),
         3500 => (16#298F#, 16#0020#, 16#0002#),
         3501 => (16#295E#, 16#0020#, 16#0002#),
         3502 => (16#298F#, 16#0020#, 16#0002#),
         3503 => (16#295F#, 16#0020#, 16#0002#),
         3504 => (16#298F#, 16#0020#, 16#0002#),
         3505 => (16#2960#, 16#0020#, 16#0002#),
         3506 => (16#298F#, 16#0020#, 16#0002#),
         3507 => (16#2961#, 16#0020#, 16#0002#),
         3508 => (16#298F#, 16#0020#, 16#0002#),
         3509 => (16#2962#, 16#0020#, 16#0002#),
         3510 => (16#298F#, 16#0020#, 16#0002#),
         3511 => (16#2963#, 16#0020#, 16#0002#),
         3512 => (16#298F#, 16#0020#, 16#0002#),
         3513 => (16#2964#, 16#0020#, 16#0002#),
         3514 => (16#298F#, 16#0020#, 16#0002#),
         3515 => (16#2965#, 16#0020#, 16#0002#),
         3516 => (16#298F#, 16#0020#, 16#0002#),
         3517 => (16#2966#, 16#0020#, 16#0002#),
         3518 => (16#298F#, 16#0020#, 16#0002#),
         3519 => (16#2967#, 16#0020#, 16#0002#),
         3520 => (16#298F#, 16#0020#, 16#0002#),
         3521 => (16#2968#, 16#0020#, 16#0002#),
         3522 => (16#298F#, 16#0020#, 16#0002#),
         3523 => (16#2969#, 16#0020#, 16#0002#),
         3524 => (16#298F#, 16#0020#, 16#0002#),
         3525 => (16#296A#, 16#0020#, 16#0002#),
         3526 => (16#298F#, 16#0020#, 16#0002#),
         3527 => (16#296B#, 16#0020#, 16#0002#),
         3528 => (16#298F#, 16#0020#, 16#0002#),
         3529 => (16#296C#, 16#0020#, 16#0002#),
         3530 => (16#298F#, 16#0020#, 16#0002#),
         3531 => (16#296D#, 16#0020#, 16#0002#),
         3532 => (16#298F#, 16#0020#, 16#0002#),
         3533 => (16#296E#, 16#0020#, 16#0002#),
         3534 => (16#298F#, 16#0020#, 16#0002#),
         3535 => (16#296F#, 16#0020#, 16#0002#),
         3536 => (16#298F#, 16#0020#, 16#0002#),
         3537 => (16#2970#, 16#0020#, 16#0002#),
         3538 => (16#298F#, 16#0020#, 16#0002#),
         3539 => (16#2971#, 16#0020#, 16#0002#),
         3540 => (16#298F#, 16#0020#, 16#0002#),
         3541 => (16#2972#, 16#0020#, 16#0002#),
         3542 => (16#298F#, 16#0020#, 16#0002#),
         3543 => (16#2973#, 16#0020#, 16#0002#),
         3544 => (16#298F#, 16#0020#, 16#0002#),
         3545 => (16#2974#, 16#0020#, 16#0002#),
         3546 => (16#298F#, 16#0020#, 16#0002#),
         3547 => (16#2975#, 16#0020#, 16#0002#),
         3548 => (16#298F#, 16#0020#, 16#0002#),
         3549 => (16#2976#, 16#0020#, 16#0002#),
         3550 => (16#298F#, 16#0020#, 16#0002#),
         3551 => (16#2977#, 16#0020#, 16#0002#),
         3552 => (16#298F#, 16#0020#, 16#0002#),
         3553 => (16#2978#, 16#0020#, 16#0002#),
         3554 => (16#298F#, 16#0020#, 16#0002#),
         3555 => (16#2979#, 16#0020#, 16#0002#),
         3556 => (16#298F#, 16#0020#, 16#0002#),
         3557 => (16#297A#, 16#0020#, 16#0002#),
         3558 => (16#298F#, 16#0020#, 16#0002#),
         3559 => (16#297B#, 16#0020#, 16#0002#),
         3560 => (16#298F#, 16#0020#, 16#0002#),
         3561 => (16#297C#, 16#0020#, 16#0002#),
         3562 => (16#298F#, 16#0020#, 16#0002#),
         3563 => (16#297D#, 16#0020#, 16#0002#),
         3564 => (16#298F#, 16#0020#, 16#0002#),
         3565 => (16#297E#, 16#0020#, 16#0002#),
         3566 => (16#298F#, 16#0020#, 16#0002#),
         3567 => (16#2990#, 16#0020#, 16#0002#),
         3568 => (16#16B4#, 16#0020#, 16#0002#),
         3569 => (16#0000#, 16#00CA#, 16#0002#),
         3570 => (16#0000#, 16#00CB#, 16#0002#),
         3571 => (16#0000#, 16#00CC#, 16#0002#),
         3572 => (16#0000#, 16#00CD#, 16#0002#),
         3573 => (16#0000#, 16#00CE#, 16#0002#),
         3574 => (16#0000#, 16#00CF#, 16#0002#),
         3575 => (16#0000#, 16#00D0#, 16#0002#),
         3576 => (16#0000#, 16#00C9#, 16#0002#),
         3577 => (16#02D1#, 16#0020#, 16#0002#),
         3578 => (16#02D2#, 16#0020#, 16#0002#),
         3579 => (16#02D3#, 16#0020#, 16#0002#),
         3580 => (16#2992#, 16#0020#, 16#0002#),
         3581 => (16#2993#, 16#0020#, 16#0002#),
         3582 => (16#2994#, 16#0020#, 16#0002#),
         3583 => (16#2995#, 16#0020#, 16#0002#),
         3584 => (16#2996#, 16#0020#, 16#0002#),
         3585 => (16#2998#, 16#0020#, 16#0002#),
         3586 => (16#299A#, 16#0020#, 16#0002#),
         3587 => (16#299B#, 16#0020#, 16#0002#),
         3588 => (16#299C#, 16#0020#, 16#0002#),
         3589 => (16#299D#, 16#0020#, 16#0002#),
         3590 => (16#299E#, 16#0020#, 16#0002#),
         3591 => (16#299F#, 16#0020#, 16#0002#),
         3592 => (16#29A0#, 16#0020#, 16#0002#),
         3593 => (16#29A1#, 16#0020#, 16#0002#),
         3594 => (16#29A2#, 16#0020#, 16#0002#),
         3595 => (16#29A3#, 16#0020#, 16#0002#),
         3596 => (16#29A4#, 16#0020#, 16#0002#),
         3597 => (16#29A5#, 16#0020#, 16#0002#),
         3598 => (16#29A6#, 16#0020#, 16#0002#),
         3599 => (16#29A7#, 16#0020#, 16#0002#),
         3600 => (16#29A8#, 16#0020#, 16#0002#),
         3601 => (16#29A9#, 16#0020#, 16#0002#),
         3602 => (16#29AA#, 16#0020#, 16#0002#),
         3603 => (16#2997#, 16#0020#, 16#0002#),
         3604 => (16#29AB#, 16#0020#, 16#0002#),
         3605 => (16#29AC#, 16#0020#, 16#0002#),
         3606 => (16#29AD#, 16#0020#, 16#0002#),
         3607 => (16#29AE#, 16#0020#, 16#0002#),
         3608 => (16#29AF#, 16#0020#, 16#0002#),
         3609 => (16#29B0#, 16#0020#, 16#0002#),
         3610 => (16#29B1#, 16#0020#, 16#0002#),
         3611 => (16#29B2#, 16#0020#, 16#0002#),
         3612 => (16#29B3#, 16#0020#, 16#0002#),
         3613 => (16#29B4#, 16#0020#, 16#0002#),
         3614 => (16#29B5#, 16#0020#, 16#0002#),
         3615 => (16#29B6#, 16#0020#, 16#0002#),
         3616 => (16#29B7#, 16#0020#, 16#0002#),
         3617 => (16#29B8#, 16#0020#, 16#0002#),
         3618 => (16#29B9#, 16#0020#, 16#0002#),
         3619 => (16#29BA#, 16#0020#, 16#0002#),
         3620 => (16#29BB#, 16#0020#, 16#0002#),
         3621 => (16#29BC#, 16#0020#, 16#0002#),
         3622 => (16#2991#, 16#0020#, 16#0002#),
         3623 => (16#29BC#, 16#0020#, 16#0002#),
         3624 => (16#2992#, 16#0020#, 16#0002#),
         3625 => (16#29BC#, 16#0020#, 16#0002#),
         3626 => (16#2993#, 16#0020#, 16#0002#),
         3627 => (16#29BC#, 16#0020#, 16#0002#),
         3628 => (16#2994#, 16#0020#, 16#0002#),
         3629 => (16#29BC#, 16#0020#, 16#0002#),
         3630 => (16#2995#, 16#0020#, 16#0002#),
         3631 => (16#29BC#, 16#0020#, 16#0002#),
         3632 => (16#2996#, 16#0020#, 16#0002#),
         3633 => (16#29BC#, 16#0020#, 16#0002#),
         3634 => (16#2997#, 16#0020#, 16#0002#),
         3635 => (16#29BC#, 16#0020#, 16#0002#),
         3636 => (16#2998#, 16#0020#, 16#0002#),
         3637 => (16#29BC#, 16#0020#, 16#0002#),
         3638 => (16#2999#, 16#0020#, 16#0002#),
         3639 => (16#29BC#, 16#0020#, 16#0002#),
         3640 => (16#299A#, 16#0020#, 16#0002#),
         3641 => (16#29BC#, 16#0020#, 16#0002#),
         3642 => (16#299B#, 16#0020#, 16#0002#),
         3643 => (16#29BC#, 16#0020#, 16#0002#),
         3644 => (16#299C#, 16#0020#, 16#0002#),
         3645 => (16#29BC#, 16#0020#, 16#0002#),
         3646 => (16#299D#, 16#0020#, 16#0002#),
         3647 => (16#29BC#, 16#0020#, 16#0002#),
         3648 => (16#299E#, 16#0020#, 16#0002#),
         3649 => (16#29BC#, 16#0020#, 16#0002#),
         3650 => (16#299F#, 16#0020#, 16#0002#),
         3651 => (16#29BC#, 16#0020#, 16#0002#),
         3652 => (16#29A0#, 16#0020#, 16#0002#),
         3653 => (16#29BC#, 16#0020#, 16#0002#),
         3654 => (16#29A1#, 16#0020#, 16#0002#),
         3655 => (16#29BC#, 16#0020#, 16#0002#),
         3656 => (16#29A2#, 16#0020#, 16#0002#),
         3657 => (16#29BC#, 16#0020#, 16#0002#),
         3658 => (16#29A3#, 16#0020#, 16#0002#),
         3659 => (16#29BC#, 16#0020#, 16#0002#),
         3660 => (16#29A4#, 16#0020#, 16#0002#),
         3661 => (16#29BC#, 16#0020#, 16#0002#),
         3662 => (16#29A5#, 16#0020#, 16#0002#),
         3663 => (16#29BC#, 16#0020#, 16#0002#),
         3664 => (16#29A6#, 16#0020#, 16#0002#),
         3665 => (16#29BC#, 16#0020#, 16#0002#),
         3666 => (16#29A7#, 16#0020#, 16#0002#),
         3667 => (16#29BC#, 16#0020#, 16#0002#),
         3668 => (16#29A8#, 16#0020#, 16#0002#),
         3669 => (16#29BC#, 16#0020#, 16#0002#),
         3670 => (16#29A9#, 16#0020#, 16#0002#),
         3671 => (16#29BC#, 16#0020#, 16#0002#),
         3672 => (16#29AA#, 16#0020#, 16#0002#),
         3673 => (16#29BC#, 16#0020#, 16#0002#),
         3674 => (16#29AB#, 16#0020#, 16#0004#),
         3675 => (16#299F#, 16#0020#, 16#0004#),
         3676 => (16#29BC#, 16#0020#, 16#0002#),
         3677 => (16#29AB#, 16#0020#, 16#0004#),
         3678 => (16#29A6#, 16#0020#, 16#0004#),
         3679 => (16#29BC#, 16#0020#, 16#0002#),
         3680 => (16#29AB#, 16#0020#, 16#0002#),
         3681 => (16#29BC#, 16#0020#, 16#0002#),
         3682 => (16#29AC#, 16#0020#, 16#0002#),
         3683 => (16#29BC#, 16#0020#, 16#0002#),
         3684 => (16#29AD#, 16#0020#, 16#0002#),
         3685 => (16#29BC#, 16#0020#, 16#0002#),
         3686 => (16#29BD#, 16#0020#, 16#0002#),
         3687 => (16#2991#, 16#0020#, 16#0002#),
         3688 => (16#29BD#, 16#0020#, 16#0002#),
         3689 => (16#2992#, 16#0020#, 16#0002#),
         3690 => (16#29BD#, 16#0020#, 16#0002#),
         3691 => (16#2993#, 16#0020#, 16#0002#),
         3692 => (16#29BD#, 16#0020#, 16#0002#),
         3693 => (16#2994#, 16#0020#, 16#0002#),
         3694 => (16#29BD#, 16#0020#, 16#0002#),
         3695 => (16#2995#, 16#0020#, 16#0002#),
         3696 => (16#29BD#, 16#0020#, 16#0002#),
         3697 => (16#2996#, 16#0020#, 16#0002#),
         3698 => (16#29BD#, 16#0020#, 16#0002#),
         3699 => (16#2997#, 16#0020#, 16#0002#),
         3700 => (16#29BD#, 16#0020#, 16#0002#),
         3701 => (16#2998#, 16#0020#, 16#0002#),
         3702 => (16#29BD#, 16#0020#, 16#0002#),
         3703 => (16#2999#, 16#0020#, 16#0002#),
         3704 => (16#29BD#, 16#0020#, 16#0002#),
         3705 => (16#299A#, 16#0020#, 16#0002#),
         3706 => (16#29BD#, 16#0020#, 16#0002#),
         3707 => (16#299B#, 16#0020#, 16#0002#),
         3708 => (16#29BD#, 16#0020#, 16#0002#),
         3709 => (16#299C#, 16#0020#, 16#0002#),
         3710 => (16#29BD#, 16#0020#, 16#0002#),
         3711 => (16#299D#, 16#0020#, 16#0002#),
         3712 => (16#29BD#, 16#0020#, 16#0002#),
         3713 => (16#299E#, 16#0020#, 16#0002#),
         3714 => (16#29BD#, 16#0020#, 16#0002#),
         3715 => (16#299F#, 16#0020#, 16#0002#),
         3716 => (16#29BD#, 16#0020#, 16#0002#),
         3717 => (16#29A0#, 16#0020#, 16#0002#),
         3718 => (16#29BD#, 16#0020#, 16#0002#),
         3719 => (16#29A1#, 16#0020#, 16#0002#),
         3720 => (16#29BD#, 16#0020#, 16#0002#),
         3721 => (16#29A2#, 16#0020#, 16#0002#),
         3722 => (16#29BD#, 16#0020#, 16#0002#),
         3723 => (16#29A3#, 16#0020#, 16#0002#),
         3724 => (16#29BD#, 16#0020#, 16#0002#),
         3725 => (16#29A4#, 16#0020#, 16#0002#),
         3726 => (16#29BD#, 16#0020#, 16#0002#),
         3727 => (16#29A5#, 16#0020#, 16#0002#),
         3728 => (16#29BD#, 16#0020#, 16#0002#),
         3729 => (16#29A6#, 16#0020#, 16#0002#),
         3730 => (16#29BD#, 16#0020#, 16#0002#),
         3731 => (16#29A7#, 16#0020#, 16#0002#),
         3732 => (16#29BD#, 16#0020#, 16#0002#),
         3733 => (16#29A8#, 16#0020#, 16#0002#),
         3734 => (16#29BD#, 16#0020#, 16#0002#),
         3735 => (16#29A9#, 16#0020#, 16#0002#),
         3736 => (16#29BD#, 16#0020#, 16#0002#),
         3737 => (16#29AA#, 16#0020#, 16#0002#),
         3738 => (16#29BD#, 16#0020#, 16#0002#),
         3739 => (16#29AB#, 16#0020#, 16#0004#),
         3740 => (16#299F#, 16#0020#, 16#0004#),
         3741 => (16#29BD#, 16#0020#, 16#0002#),
         3742 => (16#29AB#, 16#0020#, 16#0004#),
         3743 => (16#29A6#, 16#0020#, 16#0004#),
         3744 => (16#29BD#, 16#0020#, 16#0002#),
         3745 => (16#29AB#, 16#0020#, 16#0002#),
         3746 => (16#29BD#, 16#0020#, 16#0002#),
         3747 => (16#29AC#, 16#0020#, 16#0002#),
         3748 => (16#29BD#, 16#0020#, 16#0002#),
         3749 => (16#29AD#, 16#0020#, 16#0002#),
         3750 => (16#29BD#, 16#0020#, 16#0002#),
         3751 => (16#29BE#, 16#0020#, 16#0002#),
         3752 => (16#2991#, 16#0020#, 16#0002#),
         3753 => (16#29BE#, 16#0020#, 16#0002#),
         3754 => (16#2992#, 16#0020#, 16#0002#),
         3755 => (16#29BE#, 16#0020#, 16#0002#),
         3756 => (16#2993#, 16#0020#, 16#0002#),
         3757 => (16#29BE#, 16#0020#, 16#0002#),
         3758 => (16#2994#, 16#0020#, 16#0002#),
         3759 => (16#29BE#, 16#0020#, 16#0002#),
         3760 => (16#2995#, 16#0020#, 16#0002#),
         3761 => (16#29BE#, 16#0020#, 16#0002#),
         3762 => (16#2996#, 16#0020#, 16#0002#),
         3763 => (16#29BE#, 16#0020#, 16#0002#),
         3764 => (16#2997#, 16#0020#, 16#0002#),
         3765 => (16#29BE#, 16#0020#, 16#0002#),
         3766 => (16#2998#, 16#0020#, 16#0002#),
         3767 => (16#29BE#, 16#0020#, 16#0002#),
         3768 => (16#2999#, 16#0020#, 16#0002#),
         3769 => (16#29BE#, 16#0020#, 16#0002#),
         3770 => (16#299A#, 16#0020#, 16#0002#),
         3771 => (16#29BE#, 16#0020#, 16#0002#),
         3772 => (16#299B#, 16#0020#, 16#0002#),
         3773 => (16#29BE#, 16#0020#, 16#0002#),
         3774 => (16#299C#, 16#0020#, 16#0002#),
         3775 => (16#29BE#, 16#0020#, 16#0002#),
         3776 => (16#299D#, 16#0020#, 16#0002#),
         3777 => (16#29BE#, 16#0020#, 16#0002#),
         3778 => (16#299E#, 16#0020#, 16#0002#),
         3779 => (16#29BE#, 16#0020#, 16#0002#),
         3780 => (16#299F#, 16#0020#, 16#0002#),
         3781 => (16#29BE#, 16#0020#, 16#0002#),
         3782 => (16#29A0#, 16#0020#, 16#0002#),
         3783 => (16#29BE#, 16#0020#, 16#0002#),
         3784 => (16#29A1#, 16#0020#, 16#0002#),
         3785 => (16#29BE#, 16#0020#, 16#0002#),
         3786 => (16#29A2#, 16#0020#, 16#0002#),
         3787 => (16#29BE#, 16#0020#, 16#0002#),
         3788 => (16#29A3#, 16#0020#, 16#0002#),
         3789 => (16#29BE#, 16#0020#, 16#0002#),
         3790 => (16#29A4#, 16#0020#, 16#0002#),
         3791 => (16#29BE#, 16#0020#, 16#0002#),
         3792 => (16#29A5#, 16#0020#, 16#0002#),
         3793 => (16#29BE#, 16#0020#, 16#0002#),
         3794 => (16#29A6#, 16#0020#, 16#0002#),
         3795 => (16#29BE#, 16#0020#, 16#0002#),
         3796 => (16#29A7#, 16#0020#, 16#0002#),
         3797 => (16#29BE#, 16#0020#, 16#0002#),
         3798 => (16#29A8#, 16#0020#, 16#0002#),
         3799 => (16#29BE#, 16#0020#, 16#0002#),
         3800 => (16#29A9#, 16#0020#, 16#0002#),
         3801 => (16#29BE#, 16#0020#, 16#0002#),
         3802 => (16#29AA#, 16#0020#, 16#0002#),
         3803 => (16#29BE#, 16#0020#, 16#0002#),
         3804 => (16#29AB#, 16#0020#, 16#0004#),
         3805 => (16#299F#, 16#0020#, 16#0004#),
         3806 => (16#29BE#, 16#0020#, 16#0002#),
         3807 => (16#29AB#, 16#0020#, 16#0004#),
         3808 => (16#29A6#, 16#0020#, 16#0004#),
         3809 => (16#29BE#, 16#0020#, 16#0002#),
         3810 => (16#29AB#, 16#0020#, 16#0002#),
         3811 => (16#29BE#, 16#0020#, 16#0002#),
         3812 => (16#29AC#, 16#0020#, 16#0002#),
         3813 => (16#29BE#, 16#0020#, 16#0002#),
         3814 => (16#29AD#, 16#0020#, 16#0002#),
         3815 => (16#29BE#, 16#0020#, 16#0002#),
         3816 => (16#29BF#, 16#0020#, 16#0002#),
         3817 => (16#2991#, 16#0020#, 16#0002#),
         3818 => (16#29BF#, 16#0020#, 16#0002#),
         3819 => (16#2992#, 16#0020#, 16#0002#),
         3820 => (16#29BF#, 16#0020#, 16#0002#),
         3821 => (16#2993#, 16#0020#, 16#0002#),
         3822 => (16#29BF#, 16#0020#, 16#0002#),
         3823 => (16#2994#, 16#0020#, 16#0002#),
         3824 => (16#29BF#, 16#0020#, 16#0002#),
         3825 => (16#2995#, 16#0020#, 16#0002#),
         3826 => (16#29BF#, 16#0020#, 16#0002#),
         3827 => (16#2996#, 16#0020#, 16#0002#),
         3828 => (16#29BF#, 16#0020#, 16#0002#),
         3829 => (16#2997#, 16#0020#, 16#0002#),
         3830 => (16#29BF#, 16#0020#, 16#0002#),
         3831 => (16#2998#, 16#0020#, 16#0002#),
         3832 => (16#29BF#, 16#0020#, 16#0002#),
         3833 => (16#2999#, 16#0020#, 16#0002#),
         3834 => (16#29BF#, 16#0020#, 16#0002#),
         3835 => (16#299A#, 16#0020#, 16#0002#),
         3836 => (16#29BF#, 16#0020#, 16#0002#),
         3837 => (16#299B#, 16#0020#, 16#0002#),
         3838 => (16#29BF#, 16#0020#, 16#0002#),
         3839 => (16#299C#, 16#0020#, 16#0002#),
         3840 => (16#29BF#, 16#0020#, 16#0002#),
         3841 => (16#299D#, 16#0020#, 16#0002#),
         3842 => (16#29BF#, 16#0020#, 16#0002#),
         3843 => (16#299E#, 16#0020#, 16#0002#),
         3844 => (16#29BF#, 16#0020#, 16#0002#),
         3845 => (16#299F#, 16#0020#, 16#0002#),
         3846 => (16#29BF#, 16#0020#, 16#0002#),
         3847 => (16#29A0#, 16#0020#, 16#0002#),
         3848 => (16#29BF#, 16#0020#, 16#0002#),
         3849 => (16#29A1#, 16#0020#, 16#0002#),
         3850 => (16#29BF#, 16#0020#, 16#0002#),
         3851 => (16#29A2#, 16#0020#, 16#0002#),
         3852 => (16#29BF#, 16#0020#, 16#0002#),
         3853 => (16#29A3#, 16#0020#, 16#0002#),
         3854 => (16#29BF#, 16#0020#, 16#0002#),
         3855 => (16#29A4#, 16#0020#, 16#0002#),
         3856 => (16#29BF#, 16#0020#, 16#0002#),
         3857 => (16#29A5#, 16#0020#, 16#0002#),
         3858 => (16#29BF#, 16#0020#, 16#0002#),
         3859 => (16#29A6#, 16#0020#, 16#0002#),
         3860 => (16#29BF#, 16#0020#, 16#0002#),
         3861 => (16#29A7#, 16#0020#, 16#0002#),
         3862 => (16#29BF#, 16#0020#, 16#0002#),
         3863 => (16#29A8#, 16#0020#, 16#0002#),
         3864 => (16#29BF#, 16#0020#, 16#0002#),
         3865 => (16#29A9#, 16#0020#, 16#0002#),
         3866 => (16#29BF#, 16#0020#, 16#0002#),
         3867 => (16#29AA#, 16#0020#, 16#0002#),
         3868 => (16#29BF#, 16#0020#, 16#0002#),
         3869 => (16#29AB#, 16#0020#, 16#0004#),
         3870 => (16#299F#, 16#0020#, 16#0004#),
         3871 => (16#29BF#, 16#0020#, 16#0002#),
         3872 => (16#29AB#, 16#0020#, 16#0004#),
         3873 => (16#29A6#, 16#0020#, 16#0004#),
         3874 => (16#29BF#, 16#0020#, 16#0002#),
         3875 => (16#29AB#, 16#0020#, 16#0002#),
         3876 => (16#29BF#, 16#0020#, 16#0002#),
         3877 => (16#29AC#, 16#0020#, 16#0002#),
         3878 => (16#29BF#, 16#0020#, 16#0002#),
         3879 => (16#29AD#, 16#0020#, 16#0002#),
         3880 => (16#29BF#, 16#0020#, 16#0002#),
         3881 => (16#29C0#, 16#0020#, 16#0002#),
         3882 => (16#2991#, 16#0020#, 16#0002#),
         3883 => (16#29C0#, 16#0020#, 16#0002#),
         3884 => (16#2992#, 16#0020#, 16#0002#),
         3885 => (16#29C0#, 16#0020#, 16#0002#),
         3886 => (16#2993#, 16#0020#, 16#0002#),
         3887 => (16#29C0#, 16#0020#, 16#0002#),
         3888 => (16#2994#, 16#0020#, 16#0002#),
         3889 => (16#29C0#, 16#0020#, 16#0002#),
         3890 => (16#2995#, 16#0020#, 16#0002#),
         3891 => (16#29C0#, 16#0020#, 16#0002#),
         3892 => (16#2996#, 16#0020#, 16#0002#),
         3893 => (16#29C0#, 16#0020#, 16#0002#),
         3894 => (16#2997#, 16#0020#, 16#0002#),
         3895 => (16#29C0#, 16#0020#, 16#0002#),
         3896 => (16#2998#, 16#0020#, 16#0002#),
         3897 => (16#29C0#, 16#0020#, 16#0002#),
         3898 => (16#2999#, 16#0020#, 16#0002#),
         3899 => (16#29C0#, 16#0020#, 16#0002#),
         3900 => (16#299A#, 16#0020#, 16#0002#),
         3901 => (16#29C0#, 16#0020#, 16#0002#),
         3902 => (16#299B#, 16#0020#, 16#0002#),
         3903 => (16#29C0#, 16#0020#, 16#0002#),
         3904 => (16#299C#, 16#0020#, 16#0002#),
         3905 => (16#29C0#, 16#0020#, 16#0002#),
         3906 => (16#299D#, 16#0020#, 16#0002#),
         3907 => (16#29C0#, 16#0020#, 16#0002#),
         3908 => (16#299E#, 16#0020#, 16#0002#),
         3909 => (16#29C0#, 16#0020#, 16#0002#),
         3910 => (16#299F#, 16#0020#, 16#0002#),
         3911 => (16#29C0#, 16#0020#, 16#0002#),
         3912 => (16#29A0#, 16#0020#, 16#0002#),
         3913 => (16#29C0#, 16#0020#, 16#0002#),
         3914 => (16#29A1#, 16#0020#, 16#0002#),
         3915 => (16#29C0#, 16#0020#, 16#0002#),
         3916 => (16#29A2#, 16#0020#, 16#0002#),
         3917 => (16#29C0#, 16#0020#, 16#0002#),
         3918 => (16#29A3#, 16#0020#, 16#0002#),
         3919 => (16#29C0#, 16#0020#, 16#0002#),
         3920 => (16#29A4#, 16#0020#, 16#0002#),
         3921 => (16#29C0#, 16#0020#, 16#0002#),
         3922 => (16#29A5#, 16#0020#, 16#0002#),
         3923 => (16#29C0#, 16#0020#, 16#0002#),
         3924 => (16#29A6#, 16#0020#, 16#0002#),
         3925 => (16#29C0#, 16#0020#, 16#0002#),
         3926 => (16#29A7#, 16#0020#, 16#0002#),
         3927 => (16#29C0#, 16#0020#, 16#0002#),
         3928 => (16#29A8#, 16#0020#, 16#0002#),
         3929 => (16#29C0#, 16#0020#, 16#0002#),
         3930 => (16#29A9#, 16#0020#, 16#0002#),
         3931 => (16#29C0#, 16#0020#, 16#0002#),
         3932 => (16#29AA#, 16#0020#, 16#0002#),
         3933 => (16#29C0#, 16#0020#, 16#0002#),
         3934 => (16#29AB#, 16#0020#, 16#0004#),
         3935 => (16#299F#, 16#0020#, 16#0004#),
         3936 => (16#29C0#, 16#0020#, 16#0002#),
         3937 => (16#29AB#, 16#0020#, 16#0004#),
         3938 => (16#29A6#, 16#0020#, 16#0004#),
         3939 => (16#29C0#, 16#0020#, 16#0002#),
         3940 => (16#29AB#, 16#0020#, 16#0002#),
         3941 => (16#29C0#, 16#0020#, 16#0002#),
         3942 => (16#29AC#, 16#0020#, 16#0002#),
         3943 => (16#29C0#, 16#0020#, 16#0002#),
         3944 => (16#29AD#, 16#0020#, 16#0002#),
         3945 => (16#29C0#, 16#0020#, 16#0002#),
         3946 => (16#16B5#, 16#0020#, 16#0002#),
         3947 => (16#0000#, 16#00D1#, 16#0002#),
         3948 => (16#0000#, 16#00D2#, 16#0002#),
         3949 => (16#0000#, 16#00D3#, 16#0002#),
         3950 => (16#0000#, 16#00D4#, 16#0002#),
         3951 => (16#0000#, 16#00D5#, 16#0002#),
         3952 => (16#0000#, 16#00D6#, 16#0002#),
         3953 => (16#2A4A#, 16#0020#, 16#0004#),
         3954 => (16#2A61#, 16#0020#, 16#0004#),
         3955 => (16#0000#, 16#00BE#, 16#0004#),
         3956 => (16#03E9#, 16#0020#, 16#0002#),
         3957 => (16#03EA#, 16#0020#, 16#0002#),
         3958 => (16#03EB#, 16#0020#, 16#0002#),
         3959 => (16#02D6#, 16#0020#, 16#0002#),
         3960 => (16#02D7#, 16#0020#, 16#0002#),
         3961 => (16#02D8#, 16#0020#, 16#0002#),
         3962 => (16#02D9#, 16#0020#, 16#0002#),
         3963 => (16#02DA#, 16#0020#, 16#0002#),
         3964 => (16#02DB#, 16#0020#, 16#0002#),
         3965 => (16#02DC#, 16#0020#, 16#0002#),
         3966 => (16#02DF#, 16#0020#, 16#0002#),
         3967 => (16#02DF#, 16#0020#, 16#001B#),
         3968 => (16#02E0#, 16#0020#, 16#0002#),
         3969 => (16#02E1#, 16#0020#, 16#0002#),
         3970 => (16#02E2#, 16#0020#, 16#0002#),
         3971 => (16#02E3#, 16#0020#, 16#0002#),
         3972 => (16#02E4#, 16#0020#, 16#0002#),
         3973 => (16#02E5#, 16#0020#, 16#0002#),
         3974 => (16#03EC#, 16#0020#, 16#0002#),
         3975 => (16#0156#, 16#0020#, 16#0002#),
         3976 => (16#03ED#, 16#0020#, 16#0002#),
         3977 => (16#03EE#, 16#0020#, 16#0002#),
         3978 => (16#03EF#, 16#0020#, 16#0002#),
         3979 => (16#03F0#, 16#0020#, 16#0002#),
         3980 => (16#03F1#, 16#0020#, 16#0002#),
         3981 => (16#03F2#, 16#0020#, 16#0002#),
         3982 => (16#03F3#, 16#0020#, 16#0002#),
         3983 => (16#03F4#, 16#0020#, 16#0002#),
         3984 => (16#03F5#, 16#0020#, 16#0002#),
         3985 => (16#1804#, 16#0020#, 16#0004#),
         3986 => (16#1805#, 16#0020#, 16#0004#),
         3987 => (16#1806#, 16#0020#, 16#0004#),
         3988 => (16#1807#, 16#0020#, 16#0004#),
         3989 => (16#1808#, 16#0020#, 16#0004#),
         3990 => (16#1809#, 16#0020#, 16#0004#),
         3991 => (16#180A#, 16#0020#, 16#0004#),
         3992 => (16#180B#, 16#0020#, 16#0004#),
         3993 => (16#180C#, 16#0020#, 16#0004#),
         3994 => (16#1803#, 16#0020#, 16#0004#),
         3995 => (16#03F6#, 16#0020#, 16#0002#),
         3996 => (16#03F7#, 16#0020#, 16#0002#),
         3997 => (16#03F8#, 16#0020#, 16#0002#),
         3998 => (16#0000#, 16#00D9#, 16#0002#),
         3999 => (16#020F#, 16#0020#, 16#0002#),
         4000 => (16#0210#, 16#0020#, 16#0002#),
         4001 => (16#0211#, 16#0020#, 16#0002#),
         4002 => (16#0212#, 16#0020#, 16#0002#),
         4003 => (16#2A04#, 16#0020#, 16#0002#),
         4004 => (16#2A07#, 16#0020#, 16#0002#),
         4005 => (16#2A09#, 16#0020#, 16#0002#),
         4006 => (16#2A09#, 16#0020#, 16#0002#),
         4007 => (16#2A49#, 16#0020#, 16#0002#),
         4008 => (16#2A0B#, 16#0020#, 16#0002#),
         4009 => (16#2A0D#, 16#0020#, 16#0002#),
         4010 => (16#2A0F#, 16#0020#, 16#0002#),
         4011 => (16#2A11#, 16#0020#, 16#0002#),
         4012 => (16#2A13#, 16#0020#, 16#0002#),
         4013 => (16#2A15#, 16#0020#, 16#0002#),
         4014 => (16#2A17#, 16#0020#, 16#0002#),
         4015 => (16#2A19#, 16#0020#, 16#0002#),
         4016 => (16#2A19#, 16#0020#, 16#0002#),
         4017 => (16#2A49#, 16#0020#, 16#0002#),
         4018 => (16#2A1B#, 16#0020#, 16#0002#),
         4019 => (16#2A1D#, 16#0020#, 16#0002#),
         4020 => (16#2A1F#, 16#0020#, 16#0002#),
         4021 => (16#2A21#, 16#0020#, 16#0002#),
         4022 => (16#2A21#, 16#0020#, 16#0002#),
         4023 => (16#2A49#, 16#0020#, 16#0002#),
         4024 => (16#2A23#, 16#0020#, 16#0002#),
         4025 => (16#2A25#, 16#0020#, 16#0002#),
         4026 => (16#2A27#, 16#0020#, 16#0002#),
         4027 => (16#2A29#, 16#0020#, 16#0002#),
         4028 => (16#2A29#, 16#0020#, 16#0002#),
         4029 => (16#2A49#, 16#0020#, 16#0002#),
         4030 => (16#2A2B#, 16#0020#, 16#0002#),
         4031 => (16#2A2D#, 16#0020#, 16#0002#),
         4032 => (16#2A2F#, 16#0020#, 16#0002#),
         4033 => (16#2A31#, 16#0020#, 16#0002#),
         4034 => (16#2A31#, 16#0020#, 16#0002#),
         4035 => (16#2A49#, 16#0020#, 16#0002#),
         4036 => (16#2A33#, 16#0020#, 16#0002#),
         4037 => (16#2A35#, 16#0020#, 16#0002#),
         4038 => (16#2A37#, 16#0020#, 16#0002#),
         4039 => (16#2A39#, 16#0020#, 16#0002#),
         4040 => (16#2A3B#, 16#0020#, 16#0002#),
         4041 => (16#2A3D#, 16#0020#, 16#0002#),
         4042 => (16#2A40#, 16#0020#, 16#0002#),
         4043 => (16#2A42#, 16#0020#, 16#0002#),
         4044 => (16#2A44#, 16#0020#, 16#0002#),
         4045 => (16#2A46#, 16#0020#, 16#0002#),
         4046 => (16#2A48#, 16#0020#, 16#0002#),
         4047 => (16#2A4A#, 16#0020#, 16#0002#),
         4048 => (16#2A04#, 16#0020#, 16#0002#),
         4049 => (16#2A45#, 16#0020#, 16#0002#),
         4050 => (16#2A3D#, 16#0020#, 16#0004#),
         4051 => (16#0000#, 16#0109#, 16#0004#),
         4052 => (16#2A06#, 16#0020#, 16#0002#),
         4053 => (16#2A3F#, 16#0020#, 16#0002#),
         4054 => (16#2A54#, 16#0020#, 16#0002#),
         4055 => (16#2A56#, 16#0020#, 16#0002#),
         4056 => (16#2A58#, 16#0020#, 16#0002#),
         4057 => (16#2A5A#, 16#0020#, 16#0002#),
         4058 => (16#2A55#, 16#0020#, 16#0002#),
         4059 => (16#2A59#, 16#0020#, 16#0002#),
         4060 => (16#2A5B#, 16#0020#, 16#0002#),
         4061 => (16#2A5C#, 16#0020#, 16#0002#),
         4062 => (16#2A5D#, 16#0020#, 16#0002#),
         4063 => (16#2A5E#, 16#0020#, 16#0002#),
         4064 => (16#2A5F#, 16#0020#, 16#0002#),
         4065 => (16#2A60#, 16#0020#, 16#0002#),
         4066 => (16#2A61#, 16#0020#, 16#0002#),
         4067 => (16#2A62#, 16#0020#, 16#0002#),
         4068 => (16#2A57#, 16#0020#, 16#0002#),
         4069 => (16#2A63#, 16#0020#, 16#0002#),
         4070 => (16#02E6#, 16#0020#, 16#0002#),
         4071 => (16#2A4C#, 16#0020#, 16#0002#),
         4072 => (16#2A4E#, 16#0020#, 16#0002#),
         4073 => (16#2A52#, 16#0020#, 16#0002#),
         4074 => (16#2A53#, 16#0020#, 16#0002#),
         4075 => (16#2A50#, 16#0020#, 16#0002#),
         4076 => (16#2A4D#, 16#0020#, 16#0002#),
         4077 => (16#2A4F#, 16#0020#, 16#0002#),
         4078 => (16#2A51#, 16#0020#, 16#0002#),
         4079 => (16#2A05#, 16#0020#, 16#0002#),
         4080 => (16#2A08#, 16#0020#, 16#0002#),
         4081 => (16#2A0A#, 16#0020#, 16#0002#),
         4082 => (16#2A0A#, 16#0020#, 16#0002#),
         4083 => (16#2A49#, 16#0020#, 16#0002#),
         4084 => (16#2A0C#, 16#0020#, 16#0002#),
         4085 => (16#2A0E#, 16#0020#, 16#0002#),
         4086 => (16#2A10#, 16#0020#, 16#0002#),
         4087 => (16#2A12#, 16#0020#, 16#0002#),
         4088 => (16#2A14#, 16#0020#, 16#0002#),
         4089 => (16#2A16#, 16#0020#, 16#0002#),
         4090 => (16#2A18#, 16#0020#, 16#0002#),
         4091 => (16#2A1A#, 16#0020#, 16#0002#),
         4092 => (16#2A1A#, 16#0020#, 16#0002#),
         4093 => (16#2A49#, 16#0020#, 16#0002#),
         4094 => (16#2A1C#, 16#0020#, 16#0002#),
         4095 => (16#2A1E#, 16#0020#, 16#0002#),
         4096 => (16#2A20#, 16#0020#, 16#0002#),
         4097 => (16#2A22#, 16#0020#, 16#0002#),
         4098 => (16#2A22#, 16#0020#, 16#0002#),
         4099 => (16#2A49#, 16#0020#, 16#0002#),
         4100 => (16#2A24#, 16#0020#, 16#0002#),
         4101 => (16#2A26#, 16#0020#, 16#0002#),
         4102 => (16#2A28#, 16#0020#, 16#0002#),
         4103 => (16#2A2A#, 16#0020#, 16#0002#),
         4104 => (16#2A2A#, 16#0020#, 16#0002#),
         4105 => (16#2A49#, 16#0020#, 16#0002#),
         4106 => (16#2A2C#, 16#0020#, 16#0002#),
         4107 => (16#2A2E#, 16#0020#, 16#0002#),
         4108 => (16#2A30#, 16#0020#, 16#0002#),
         4109 => (16#2A32#, 16#0020#, 16#0002#),
         4110 => (16#2A32#, 16#0020#, 16#0002#),
         4111 => (16#2A49#, 16#0020#, 16#0002#),
         4112 => (16#2A34#, 16#0020#, 16#0002#),
         4113 => (16#2A36#, 16#0020#, 16#0002#),
         4114 => (16#2A38#, 16#0020#, 16#0002#),
         4115 => (16#2A3A#, 16#0020#, 16#0002#),
         4116 => (16#2A3C#, 16#0020#, 16#0002#),
         4117 => (16#2A3E#, 16#0020#, 16#0002#),
         4118 => (16#2A3E#, 16#0020#, 16#0002#),
         4119 => (16#2A54#, 16#0020#, 16#0002#),
         4120 => (16#2A3E#, 16#0020#, 16#0002#),
         4121 => (16#2A56#, 16#0020#, 16#0002#),
         4122 => (16#2A3E#, 16#0020#, 16#0002#),
         4123 => (16#2A5A#, 16#0020#, 16#0002#),
         4124 => (16#2A41#, 16#0020#, 16#0002#),
         4125 => (16#2A41#, 16#0020#, 16#0002#),
         4126 => (16#2A54#, 16#0020#, 16#0002#),
         4127 => (16#2A41#, 16#0020#, 16#0002#),
         4128 => (16#2A56#, 16#0020#, 16#0002#),
         4129 => (16#2A41#, 16#0020#, 16#0002#),
         4130 => (16#2A5A#, 16#0020#, 16#0002#),
         4131 => (16#2A43#, 16#0020#, 16#0002#),
         4132 => (16#2A47#, 16#0020#, 16#0002#),
         4133 => (16#2A4B#, 16#0020#, 16#0002#),
         4134 => (16#2A05#, 16#0020#, 16#0002#),
         4135 => (16#2A45#, 16#0020#, 16#0002#),
         4136 => (16#2A34#, 16#0020#, 16#0004#),
         4137 => (16#0000#, 16#0109#, 16#0004#),
         4138 => (16#2A3C#, 16#0020#, 16#0004#),
         4139 => (16#0000#, 16#0109#, 16#0004#),
         4140 => (16#2A3E#, 16#0020#, 16#0004#),
         4141 => (16#0000#, 16#0109#, 16#0004#),
         4142 => (16#03F9#, 16#0020#, 16#0002#),
         4143 => (16#03FA#, 16#0020#, 16#0002#),
         4144 => (16#03FB#, 16#0020#, 16#0002#),
         4145 => (16#03FC#, 16#0020#, 16#0002#),
         4146 => (16#03FD#, 16#0020#, 16#0002#),
         4147 => (16#03FE#, 16#0020#, 16#0002#),
         4148 => (16#03FF#, 16#0020#, 16#0002#),
         4149 => (16#0400#, 16#0020#, 16#0002#),
         4150 => (16#0401#, 16#0020#, 16#0002#),
         4151 => (16#0402#, 16#0020#, 16#0002#),
         4152 => (16#0403#, 16#0020#, 16#0002#),
         4153 => (16#0404#, 16#0020#, 16#0002#),
         4154 => (16#0405#, 16#0020#, 16#0002#),
         4155 => (16#0406#, 16#0020#, 16#0002#),
         4156 => (16#0407#, 16#0020#, 16#0002#),
         4157 => (16#0408#, 16#0020#, 16#0002#),
         4158 => (16#02DD#, 16#0020#, 16#0002#),
         4159 => (16#02DE#, 16#0020#, 16#0002#),
         4160 => (16#02E7#, 16#0020#, 16#0002#),
         4161 => (16#02E8#, 16#0020#, 16#0002#),
         4162 => (16#02E9#, 16#0020#, 16#0002#),
         4163 => (16#0409#, 16#0020#, 16#0002#),
         4164 => (16#040A#, 16#0020#, 16#0002#),
         4165 => (16#040B#, 16#0020#, 16#0002#),
         4166 => (16#040C#, 16#0020#, 16#0002#),
         4167 => (16#02EA#, 16#0020#, 16#0002#),
         4168 => (16#02EB#, 16#0020#, 16#0002#),
         4169 => (16#2BD3#, 16#0020#, 16#0002#),
         4170 => (16#2BD5#, 16#0020#, 16#0002#),
         4171 => (16#2BD7#, 16#0020#, 16#0002#),
         4172 => (16#2BDB#, 16#0020#, 16#0002#),
         4173 => (16#2BDE#, 16#0020#, 16#0002#),
         4174 => (16#2BE0#, 16#0020#, 16#0002#),
         4175 => (16#2BE3#, 16#0020#, 16#0002#),
         4176 => (16#2BE7#, 16#0020#, 16#0002#),
         4177 => (16#2BEC#, 16#0020#, 16#0002#),
         4178 => (16#2BF3#, 16#0020#, 16#0002#),
         4179 => (16#2BF7#, 16#0020#, 16#0002#),
         4180 => (16#2BF8#, 16#0020#, 16#0002#),
         4181 => (16#2BFA#, 16#0020#, 16#0002#),
         4182 => (16#2BFC#, 16#0020#, 16#0002#),
         4183 => (16#2BFF#, 16#0020#, 16#0002#),
         4184 => (16#2C02#, 16#0020#, 16#0002#),
         4185 => (16#2C06#, 16#0020#, 16#0002#),
         4186 => (16#2C07#, 16#0020#, 16#0002#),
         4187 => (16#2C08#, 16#0020#, 16#0002#),
         4188 => (16#2C0B#, 16#0020#, 16#0002#),
         4189 => (16#2C0E#, 16#0020#, 16#0002#),
         4190 => (16#2C12#, 16#0020#, 16#0002#),
         4191 => (16#2C13#, 16#0020#, 16#0002#),
         4192 => (16#2C19#, 16#0020#, 16#0002#),
         4193 => (16#2C1C#, 16#0020#, 16#0002#),
         4194 => (16#2C1F#, 16#0020#, 16#0002#),
         4195 => (16#2C21#, 16#0020#, 16#0002#),
         4196 => (16#2C23#, 16#0020#, 16#0002#),
         4197 => (16#2C27#, 16#0020#, 16#0002#),
         4198 => (16#2C29#, 16#0020#, 16#0002#),
         4199 => (16#2C30#, 16#0020#, 16#0002#),
         4200 => (16#2C32#, 16#0020#, 16#0002#),
         4201 => (16#2C38#, 16#0020#, 16#0002#),
         4202 => (16#2C3F#, 16#0020#, 16#0002#),
         4203 => (16#2C40#, 16#0020#, 16#0002#),
         4204 => (16#2C41#, 16#0020#, 16#0002#),
         4205 => (16#2C42#, 16#0020#, 16#0002#),
         4206 => (16#2C43#, 16#0020#, 16#0002#),
         4207 => (16#2C44#, 16#0020#, 16#0002#),
         4208 => (16#2C49#, 16#0020#, 16#0002#),
         4209 => (16#2C4A#, 16#0020#, 16#0002#),
         4210 => (16#2C4B#, 16#0020#, 16#0002#),
         4211 => (16#2C4C#, 16#0020#, 16#0002#),
         4212 => (16#2C4D#, 16#0020#, 16#0004#),
         4213 => (16#2C4D#, 16#0020#, 16#0002#),
         4214 => (16#2C51#, 16#0020#, 16#0002#),
         4215 => (16#2C53#, 16#0020#, 16#0002#),
         4216 => (16#2C55#, 16#0020#, 16#0002#),
         4217 => (16#2C58#, 16#0020#, 16#0002#),
         4218 => (16#2C5D#, 16#0020#, 16#0002#),
         4219 => (16#2C61#, 16#0020#, 16#0002#),
         4220 => (16#2C54#, 16#0020#, 16#0002#),
         4221 => (16#2C63#, 16#0020#, 16#0002#),
         4222 => (16#2C5F#, 16#0020#, 16#0002#),
         4223 => (16#0000#, 16#00DD#, 16#0002#),
         4224 => (16#2C69#, 16#0020#, 16#0002#),
         4225 => (16#2C6A#, 16#0020#, 16#0002#),
         4226 => (16#2C22#, 16#0020#, 16#0002#),
         4227 => (16#2C26#, 16#0020#, 16#0002#),
         4228 => (16#2C2A#, 16#0020#, 16#0002#),
         4229 => (16#2C35#, 16#0020#, 16#0002#),
         4230 => (16#2C30#, 16#0020#, 16#0004#),
         4231 => (16#2C69#, 16#0020#, 16#0004#),
         4232 => (16#2C30#, 16#0020#, 16#0004#),
         4233 => (16#0195#, 16#0020#, 16#0002#),
         4234 => (16#0196#, 16#0020#, 16#0002#),
         4235 => (16#02EF#, 16#0020#, 16#0002#),
         4236 => (16#02F0#, 16#0020#, 16#0002#),
         4237 => (16#02F1#, 16#0020#, 16#0002#),
         4238 => (16#02F2#, 16#0020#, 16#0002#),
         4239 => (16#2C2D#, 16#0020#, 16#0002#),
         4240 => (16#2C2E#, 16#0020#, 16#0002#),
         4241 => (16#2C45#, 16#0020#, 16#0002#),
         4242 => (16#2C46#, 16#0020#, 16#0002#),
         4243 => (16#2C47#, 16#0020#, 16#0002#),
         4244 => (16#2C48#, 16#0020#, 16#0002#),
         4245 => (16#2C59#, 16#0020#, 16#0002#),
         4246 => (16#2C5A#, 16#0020#, 16#0002#),
         4247 => (16#2C5B#, 16#0020#, 16#0002#),
         4248 => (16#2C5C#, 16#0020#, 16#0002#),
         4249 => (16#2BDF#, 16#0020#, 16#0002#),
         4250 => (16#2BED#, 16#0020#, 16#0002#),
         4251 => (16#2C3A#, 16#0020#, 16#0002#),
         4252 => (16#2C3B#, 16#0020#, 16#0002#),
         4253 => (16#2C11#, 16#0020#, 16#0002#),
         4254 => (16#2C20#, 16#0020#, 16#0002#),
         4255 => (16#2C28#, 16#0020#, 16#0002#),
         4256 => (16#2BF1#, 16#0020#, 16#0002#),
         4257 => (16#2C64#, 16#0020#, 16#0002#),
         4258 => (16#2C6B#, 16#0020#, 16#0002#),
         4259 => (16#2C6C#, 16#0020#, 16#0002#),
         4260 => (16#2C2F#, 16#0020#, 16#0002#),
         4261 => (16#2C3E#, 16#0020#, 16#0002#),
         4262 => (16#2C65#, 16#0020#, 16#0002#),
         4263 => (16#2C66#, 16#0020#, 16#0002#),
         4264 => (16#2C6D#, 16#0020#, 16#0002#),
         4265 => (16#2C6E#, 16#0020#, 16#0002#),
         4266 => (16#2C6F#, 16#0020#, 16#0002#),
         4267 => (16#2C70#, 16#0020#, 16#0002#),
         4268 => (16#2C71#, 16#0020#, 16#0002#),
         4269 => (16#2C03#, 16#0020#, 16#0002#),
         4270 => (16#2C3C#, 16#0020#, 16#0002#),
         4271 => (16#2C3D#, 16#0020#, 16#0002#),
         4272 => (16#2C52#, 16#0020#, 16#0002#),
         4273 => (16#2C4F#, 16#0020#, 16#0002#),
         4274 => (16#2C56#, 16#0020#, 16#0002#),
         4275 => (16#2C57#, 16#0020#, 16#0002#),
         4276 => (16#2BD4#, 16#0020#, 16#0002#),
         4277 => (16#2BD6#, 16#0020#, 16#0002#),
         4278 => (16#2BD8#, 16#0020#, 16#0002#),
         4279 => (16#2BE1#, 16#0020#, 16#0002#),
         4280 => (16#2BEA#, 16#0020#, 16#0002#),
         4281 => (16#2BF4#, 16#0020#, 16#0002#),
         4282 => (16#2C09#, 16#0020#, 16#0002#),
         4283 => (16#2C0F#, 16#0020#, 16#0002#),
         4284 => (16#2C14#, 16#0020#, 16#0002#),
         4285 => (16#2C15#, 16#0020#, 16#0002#),
         4286 => (16#2C1A#, 16#0020#, 16#0002#),
         4287 => (16#2C2C#, 16#0020#, 16#0002#),
         4288 => (16#2C33#, 16#0020#, 16#0002#),
         4289 => (16#2C2B#, 16#0020#, 16#0002#),
         4290 => (16#2C4E#, 16#0020#, 16#0002#),
         4291 => (16#2C5E#, 16#0020#, 16#0002#),
         4292 => (16#2C60#, 16#0020#, 16#0002#),
         4293 => (16#2C68#, 16#0020#, 16#0002#),
         4294 => (16#2C72#, 16#0020#, 16#0002#),
         4295 => (16#2C74#, 16#0020#, 16#0002#),
         4296 => (16#2C77#, 16#0020#, 16#0002#),
         4297 => (16#2C78#, 16#0020#, 16#0002#),
         4298 => (16#2C73#, 16#0020#, 16#0002#),
         4299 => (16#2C75#, 16#0020#, 16#0002#),
         4300 => (16#2C76#, 16#0020#, 16#0002#),
         4301 => (16#2C17#, 16#0020#, 16#0002#),
         4302 => (16#2C79#, 16#0020#, 16#0002#),
         4303 => (16#2C7A#, 16#0020#, 16#0002#),
         4304 => (16#2C7B#, 16#0020#, 16#0002#),
         4305 => (16#2C50#, 16#0020#, 16#0002#),
         4306 => (16#2C62#, 16#0020#, 16#0002#),
         4307 => (16#040E#, 16#0020#, 16#0002#),
         4308 => (16#040F#, 16#0020#, 16#0002#),
         4309 => (16#1EF9#, 16#0020#, 16#0008#),
         4310 => (16#1EFB#, 16#0020#, 16#0008#),
         4311 => (16#1EFD#, 16#0020#, 16#0008#),
         4312 => (16#1EFF#, 16#0020#, 16#0008#),
         4313 => (16#1F01#, 16#0020#, 16#0008#),
         4314 => (16#1F03#, 16#0020#, 16#0008#),
         4315 => (16#1F05#, 16#0020#, 16#0008#),
         4316 => (16#1F09#, 16#0020#, 16#0008#),
         4317 => (16#1F0B#, 16#0020#, 16#0008#),
         4318 => (16#1F0D#, 16#0020#, 16#0008#),
         4319 => (16#1F0F#, 16#0020#, 16#0008#),
         4320 => (16#1F11#, 16#0020#, 16#0008#),
         4321 => (16#1F13#, 16#0020#, 16#0008#),
         4322 => (16#1F17#, 16#0020#, 16#0008#),
         4323 => (16#1F19#, 16#0020#, 16#0008#),
         4324 => (16#1F1B#, 16#0020#, 16#0008#),
         4325 => (16#1F1D#, 16#0020#, 16#0008#),
         4326 => (16#1F1F#, 16#0020#, 16#0008#),
         4327 => (16#1F21#, 16#0020#, 16#0008#),
         4328 => (16#1F25#, 16#0020#, 16#0008#),
         4329 => (16#1F27#, 16#0020#, 16#0008#),
         4330 => (16#1F29#, 16#0020#, 16#0008#),
         4331 => (16#1F2B#, 16#0020#, 16#0008#),
         4332 => (16#1F2D#, 16#0020#, 16#0008#),
         4333 => (16#1F2F#, 16#0020#, 16#0008#),
         4334 => (16#1F31#, 16#0020#, 16#0008#),
         4335 => (16#1F33#, 16#0020#, 16#0008#),
         4336 => (16#1F35#, 16#0020#, 16#0008#),
         4337 => (16#1F37#, 16#0020#, 16#0008#),
         4338 => (16#1F39#, 16#0020#, 16#0008#),
         4339 => (16#1F3B#, 16#0020#, 16#0008#),
         4340 => (16#1F3F#, 16#0020#, 16#0008#),
         4341 => (16#1F41#, 16#0020#, 16#0008#),
         4342 => (16#1F07#, 16#0020#, 16#0008#),
         4343 => (16#1F15#, 16#0020#, 16#0008#),
         4344 => (16#1F23#, 16#0020#, 16#0008#),
         4345 => (16#1F3D#, 16#0020#, 16#0008#),
         4346 => (16#1F43#, 16#0020#, 16#0008#),
         4347 => (16#1F46#, 16#0020#, 16#0008#),
         4348 => (16#1F4B#, 16#0020#, 16#0008#),
         4349 => (16#1EF8#, 16#0020#, 16#0002#),
         4350 => (16#1EFA#, 16#0020#, 16#0002#),
         4351 => (16#1EFC#, 16#0020#, 16#0002#),
         4352 => (16#1EFE#, 16#0020#, 16#0002#),
         4353 => (16#1F00#, 16#0020#, 16#0002#),
         4354 => (16#1F02#, 16#0020#, 16#0002#),
         4355 => (16#1F04#, 16#0020#, 16#0002#),
         4356 => (16#1F08#, 16#0020#, 16#0002#),
         4357 => (16#1F0A#, 16#0020#, 16#0002#),
         4358 => (16#1F0C#, 16#0020#, 16#0002#),
         4359 => (16#1F0E#, 16#0020#, 16#0002#),
         4360 => (16#1F10#, 16#0020#, 16#0002#),
         4361 => (16#1F12#, 16#0020#, 16#0002#),
         4362 => (16#1F16#, 16#0020#, 16#0002#),
         4363 => (16#1F18#, 16#0020#, 16#0002#),
         4364 => (16#1F1A#, 16#0020#, 16#0002#),
         4365 => (16#1F1C#, 16#0020#, 16#0002#),
         4366 => (16#1F1E#, 16#0020#, 16#0002#),
         4367 => (16#1F20#, 16#0020#, 16#0002#),
         4368 => (16#1F24#, 16#0020#, 16#0002#),
         4369 => (16#1F26#, 16#0020#, 16#0002#),
         4370 => (16#1F28#, 16#0020#, 16#0002#),
         4371 => (16#1F2A#, 16#0020#, 16#0002#),
         4372 => (16#1F2C#, 16#0020#, 16#0002#),
         4373 => (16#1F2E#, 16#0020#, 16#0002#),
         4374 => (16#1F30#, 16#0020#, 16#0002#),
         4375 => (16#1F32#, 16#0020#, 16#0002#),
         4376 => (16#1F34#, 16#0020#, 16#0002#),
         4377 => (16#1F36#, 16#0020#, 16#0002#),
         4378 => (16#1F38#, 16#0020#, 16#0002#),
         4379 => (16#1F3A#, 16#0020#, 16#0002#),
         4380 => (16#1F3E#, 16#0020#, 16#0002#),
         4381 => (16#1F40#, 16#0020#, 16#0002#),
         4382 => (16#1F06#, 16#0020#, 16#0002#),
         4383 => (16#1F14#, 16#0020#, 16#0002#),
         4384 => (16#1F22#, 16#0020#, 16#0002#),
         4385 => (16#1F3C#, 16#0020#, 16#0002#),
         4386 => (16#1F42#, 16#0020#, 16#0002#),
         4387 => (16#1F44#, 16#0020#, 16#0002#),
         4388 => (16#1F45#, 16#0020#, 16#0002#),
         4389 => (16#1F47#, 16#0020#, 16#0002#),
         4390 => (16#1F48#, 16#0020#, 16#0002#),
         4391 => (16#1F49#, 16#0020#, 16#0002#),
         4392 => (16#01BC#, 16#0020#, 16#0002#),
         4393 => (16#1F12#, 16#0020#, 16#0014#),
         4394 => (16#1F4A#, 16#0020#, 16#0002#),
         4395 => (16#1F4C#, 16#0020#, 16#0002#),
         4396 => (16#1F4D#, 16#0020#, 16#0002#),
         4397 => (16#3723#, 16#0020#, 16#0002#),
         4398 => (16#3724#, 16#0020#, 16#0002#),
         4399 => (16#3725#, 16#0020#, 16#0002#),
         4400 => (16#3726#, 16#0020#, 16#0002#),
         4401 => (16#3727#, 16#0020#, 16#0002#),
         4402 => (16#3728#, 16#0020#, 16#0002#),
         4403 => (16#3729#, 16#0020#, 16#0002#),
         4404 => (16#372A#, 16#0020#, 16#0002#),
         4405 => (16#372B#, 16#0020#, 16#0002#),
         4406 => (16#372C#, 16#0020#, 16#0002#),
         4407 => (16#372D#, 16#0020#, 16#0002#),
         4408 => (16#372E#, 16#0020#, 16#0002#),
         4409 => (16#372F#, 16#0020#, 16#0002#),
         4410 => (16#3730#, 16#0020#, 16#0002#),
         4411 => (16#3731#, 16#0020#, 16#0002#),
         4412 => (16#3732#, 16#0020#, 16#0002#),
         4413 => (16#3733#, 16#0020#, 16#0002#),
         4414 => (16#3734#, 16#0020#, 16#0002#),
         4415 => (16#3735#, 16#0020#, 16#0002#),
         4416 => (16#3736#, 16#0020#, 16#0002#),
         4417 => (16#3737#, 16#0020#, 16#0002#),
         4418 => (16#3738#, 16#0020#, 16#0002#),
         4419 => (16#3739#, 16#0020#, 16#0002#),
         4420 => (16#373A#, 16#0020#, 16#0002#),
         4421 => (16#373B#, 16#0020#, 16#0002#),
         4422 => (16#373C#, 16#0020#, 16#0002#),
         4423 => (16#373D#, 16#0020#, 16#0002#),
         4424 => (16#373E#, 16#0020#, 16#0002#),
         4425 => (16#373F#, 16#0020#, 16#0002#),
         4426 => (16#3740#, 16#0020#, 16#0002#),
         4427 => (16#3741#, 16#0020#, 16#0002#),
         4428 => (16#3742#, 16#0020#, 16#0002#),
         4429 => (16#3743#, 16#0020#, 16#0002#),
         4430 => (16#3744#, 16#0020#, 16#0002#),
         4431 => (16#3745#, 16#0020#, 16#0002#),
         4432 => (16#3746#, 16#0020#, 16#0002#),
         4433 => (16#3747#, 16#0020#, 16#0002#),
         4434 => (16#3748#, 16#0020#, 16#0002#),
         4435 => (16#3749#, 16#0020#, 16#0002#),
         4436 => (16#374A#, 16#0020#, 16#0002#),
         4437 => (16#374B#, 16#0020#, 16#0002#),
         4438 => (16#374C#, 16#0020#, 16#0002#),
         4439 => (16#374D#, 16#0020#, 16#0002#),
         4440 => (16#374E#, 16#0020#, 16#0002#),
         4441 => (16#374F#, 16#0020#, 16#0002#),
         4442 => (16#3750#, 16#0020#, 16#0002#),
         4443 => (16#3751#, 16#0020#, 16#0002#),
         4444 => (16#3752#, 16#0020#, 16#0002#),
         4445 => (16#3753#, 16#0020#, 16#0002#),
         4446 => (16#3754#, 16#0020#, 16#0002#),
         4447 => (16#3755#, 16#0020#, 16#0002#),
         4448 => (16#3756#, 16#0020#, 16#0002#),
         4449 => (16#3757#, 16#0020#, 16#0002#),
         4450 => (16#3758#, 16#0020#, 16#0002#),
         4451 => (16#3759#, 16#0020#, 16#0002#),
         4452 => (16#375A#, 16#0020#, 16#0002#),
         4453 => (16#375B#, 16#0020#, 16#0002#),
         4454 => (16#375C#, 16#0020#, 16#0002#),
         4455 => (16#375D#, 16#0020#, 16#0002#),
         4456 => (16#375E#, 16#0020#, 16#0002#),
         4457 => (16#375F#, 16#0020#, 16#0002#),
         4458 => (16#3760#, 16#0020#, 16#0002#),
         4459 => (16#3761#, 16#0020#, 16#0002#),
         4460 => (16#3762#, 16#0020#, 16#0002#),
         4461 => (16#3763#, 16#0020#, 16#0002#),
         4462 => (16#3764#, 16#0020#, 16#0002#),
         4463 => (16#3765#, 16#0020#, 16#0002#),
         4464 => (16#3766#, 16#0020#, 16#0002#),
         4465 => (16#3767#, 16#0020#, 16#0002#),
         4466 => (16#3768#, 16#0020#, 16#0002#),
         4467 => (16#3769#, 16#0020#, 16#0002#),
         4468 => (16#376A#, 16#0020#, 16#0002#),
         4469 => (16#376B#, 16#0020#, 16#0002#),
         4470 => (16#376C#, 16#0020#, 16#0002#),
         4471 => (16#376D#, 16#0020#, 16#0002#),
         4472 => (16#376E#, 16#0020#, 16#0002#),
         4473 => (16#376F#, 16#0020#, 16#0002#),
         4474 => (16#3770#, 16#0020#, 16#0002#),
         4475 => (16#3771#, 16#0020#, 16#0002#),
         4476 => (16#3772#, 16#0020#, 16#0002#),
         4477 => (16#3773#, 16#0020#, 16#0002#),
         4478 => (16#3774#, 16#0020#, 16#0002#),
         4479 => (16#3775#, 16#0020#, 16#0002#),
         4480 => (16#3776#, 16#0020#, 16#0002#),
         4481 => (16#3777#, 16#0020#, 16#0002#),
         4482 => (16#3778#, 16#0020#, 16#0002#),
         4483 => (16#3779#, 16#0020#, 16#0002#),
         4484 => (16#377A#, 16#0020#, 16#0002#),
         4485 => (16#377B#, 16#0020#, 16#0002#),
         4486 => (16#377C#, 16#0020#, 16#0002#),
         4487 => (16#377D#, 16#0020#, 16#0002#),
         4488 => (16#377E#, 16#0020#, 16#0002#),
         4489 => (16#377F#, 16#0020#, 16#0002#),
         4490 => (16#3780#, 16#0020#, 16#0002#),
         4491 => (16#3781#, 16#0020#, 16#0002#),
         4492 => (16#379F#, 16#0020#, 16#0002#),
         4493 => (16#37A0#, 16#0020#, 16#0002#),
         4494 => (16#37A1#, 16#0020#, 16#0002#),
         4495 => (16#37A2#, 16#0020#, 16#0002#),
         4496 => (16#37A3#, 16#0020#, 16#0002#),
         4497 => (16#37A4#, 16#0020#, 16#0002#),
         4498 => (16#37A5#, 16#0020#, 16#0002#),
         4499 => (16#37A6#, 16#0020#, 16#0002#),
         4500 => (16#37A7#, 16#0020#, 16#0002#),
         4501 => (16#37A8#, 16#0020#, 16#0002#),
         4502 => (16#37A9#, 16#0020#, 16#0002#),
         4503 => (16#37AA#, 16#0020#, 16#0002#),
         4504 => (16#37AB#, 16#0020#, 16#0002#),
         4505 => (16#37AC#, 16#0020#, 16#0002#),
         4506 => (16#37AD#, 16#0020#, 16#0002#),
         4507 => (16#37AE#, 16#0020#, 16#0002#),
         4508 => (16#37AF#, 16#0020#, 16#0002#),
         4509 => (16#37B0#, 16#0020#, 16#0002#),
         4510 => (16#37B1#, 16#0020#, 16#0002#),
         4511 => (16#37B2#, 16#0020#, 16#0002#),
         4512 => (16#37B3#, 16#0020#, 16#0002#),
         4513 => (16#37B4#, 16#0020#, 16#0002#),
         4514 => (16#37B5#, 16#0020#, 16#0002#),
         4515 => (16#37B6#, 16#0020#, 16#0002#),
         4516 => (16#37B7#, 16#0020#, 16#0002#),
         4517 => (16#37B8#, 16#0020#, 16#0002#),
         4518 => (16#37B9#, 16#0020#, 16#0002#),
         4519 => (16#37BA#, 16#0020#, 16#0002#),
         4520 => (16#37BB#, 16#0020#, 16#0002#),
         4521 => (16#37BC#, 16#0020#, 16#0002#),
         4522 => (16#37BD#, 16#0020#, 16#0002#),
         4523 => (16#37BE#, 16#0020#, 16#0002#),
         4524 => (16#37BF#, 16#0020#, 16#0002#),
         4525 => (16#37C0#, 16#0020#, 16#0002#),
         4526 => (16#37C1#, 16#0020#, 16#0002#),
         4527 => (16#37C2#, 16#0020#, 16#0002#),
         4528 => (16#37C3#, 16#0020#, 16#0002#),
         4529 => (16#37C4#, 16#0020#, 16#0002#),
         4530 => (16#37C5#, 16#0020#, 16#0002#),
         4531 => (16#37C6#, 16#0020#, 16#0002#),
         4532 => (16#37C7#, 16#0020#, 16#0002#),
         4533 => (16#37C8#, 16#0020#, 16#0002#),
         4534 => (16#37C9#, 16#0020#, 16#0002#),
         4535 => (16#37CA#, 16#0020#, 16#0002#),
         4536 => (16#37CB#, 16#0020#, 16#0002#),
         4537 => (16#37CC#, 16#0020#, 16#0002#),
         4538 => (16#37CD#, 16#0020#, 16#0002#),
         4539 => (16#37CE#, 16#0020#, 16#0002#),
         4540 => (16#37CF#, 16#0020#, 16#0002#),
         4541 => (16#37D0#, 16#0020#, 16#0002#),
         4542 => (16#37D1#, 16#0020#, 16#0002#),
         4543 => (16#37D2#, 16#0020#, 16#0002#),
         4544 => (16#37D3#, 16#0020#, 16#0002#),
         4545 => (16#37D4#, 16#0020#, 16#0002#),
         4546 => (16#37D5#, 16#0020#, 16#0002#),
         4547 => (16#37D6#, 16#0020#, 16#0002#),
         4548 => (16#37D7#, 16#0020#, 16#0002#),
         4549 => (16#37D8#, 16#0020#, 16#0002#),
         4550 => (16#37D9#, 16#0020#, 16#0002#),
         4551 => (16#37DA#, 16#0020#, 16#0002#),
         4552 => (16#37DB#, 16#0020#, 16#0002#),
         4553 => (16#37DC#, 16#0020#, 16#0002#),
         4554 => (16#37DD#, 16#0020#, 16#0002#),
         4555 => (16#37DE#, 16#0020#, 16#0002#),
         4556 => (16#37DF#, 16#0020#, 16#0002#),
         4557 => (16#37E0#, 16#0020#, 16#0002#),
         4558 => (16#37E1#, 16#0020#, 16#0002#),
         4559 => (16#37E2#, 16#0020#, 16#0002#),
         4560 => (16#37E3#, 16#0020#, 16#0002#),
         4561 => (16#37E4#, 16#0020#, 16#0002#),
         4562 => (16#37E5#, 16#0020#, 16#0002#),
         4563 => (16#37E6#, 16#0020#, 16#0002#),
         4564 => (16#37E7#, 16#0020#, 16#0002#),
         4565 => (16#37FF#, 16#0020#, 16#0002#),
         4566 => (16#3800#, 16#0020#, 16#0002#),
         4567 => (16#3801#, 16#0020#, 16#0002#),
         4568 => (16#3802#, 16#0020#, 16#0002#),
         4569 => (16#3803#, 16#0020#, 16#0002#),
         4570 => (16#3804#, 16#0020#, 16#0002#),
         4571 => (16#3805#, 16#0020#, 16#0002#),
         4572 => (16#3806#, 16#0020#, 16#0002#),
         4573 => (16#3807#, 16#0020#, 16#0002#),
         4574 => (16#3808#, 16#0020#, 16#0002#),
         4575 => (16#3809#, 16#0020#, 16#0002#),
         4576 => (16#380A#, 16#0020#, 16#0002#),
         4577 => (16#380B#, 16#0020#, 16#0002#),
         4578 => (16#380C#, 16#0020#, 16#0002#),
         4579 => (16#380D#, 16#0020#, 16#0002#),
         4580 => (16#380E#, 16#0020#, 16#0002#),
         4581 => (16#380F#, 16#0020#, 16#0002#),
         4582 => (16#3810#, 16#0020#, 16#0002#),
         4583 => (16#3811#, 16#0020#, 16#0002#),
         4584 => (16#3812#, 16#0020#, 16#0002#),
         4585 => (16#3813#, 16#0020#, 16#0002#),
         4586 => (16#3814#, 16#0020#, 16#0002#),
         4587 => (16#3815#, 16#0020#, 16#0002#),
         4588 => (16#3816#, 16#0020#, 16#0002#),
         4589 => (16#3817#, 16#0020#, 16#0002#),
         4590 => (16#3818#, 16#0020#, 16#0002#),
         4591 => (16#3819#, 16#0020#, 16#0002#),
         4592 => (16#381A#, 16#0020#, 16#0002#),
         4593 => (16#381B#, 16#0020#, 16#0002#),
         4594 => (16#381C#, 16#0020#, 16#0002#),
         4595 => (16#381D#, 16#0020#, 16#0002#),
         4596 => (16#381E#, 16#0020#, 16#0002#),
         4597 => (16#381F#, 16#0020#, 16#0002#),
         4598 => (16#3820#, 16#0020#, 16#0002#),
         4599 => (16#3821#, 16#0020#, 16#0002#),
         4600 => (16#3822#, 16#0020#, 16#0002#),
         4601 => (16#3823#, 16#0020#, 16#0002#),
         4602 => (16#3824#, 16#0020#, 16#0002#),
         4603 => (16#3825#, 16#0020#, 16#0002#),
         4604 => (16#3826#, 16#0020#, 16#0002#),
         4605 => (16#3827#, 16#0020#, 16#0002#),
         4606 => (16#3828#, 16#0020#, 16#0002#),
         4607 => (16#3829#, 16#0020#, 16#0002#),
         4608 => (16#382A#, 16#0020#, 16#0002#),
         4609 => (16#382B#, 16#0020#, 16#0002#),
         4610 => (16#382C#, 16#0020#, 16#0002#),
         4611 => (16#382D#, 16#0020#, 16#0002#),
         4612 => (16#382E#, 16#0020#, 16#0002#),
         4613 => (16#382F#, 16#0020#, 16#0002#),
         4614 => (16#3830#, 16#0020#, 16#0002#),
         4615 => (16#3831#, 16#0020#, 16#0002#),
         4616 => (16#3832#, 16#0020#, 16#0002#),
         4617 => (16#3833#, 16#0020#, 16#0002#),
         4618 => (16#3834#, 16#0020#, 16#0002#),
         4619 => (16#3835#, 16#0020#, 16#0002#),
         4620 => (16#3836#, 16#0020#, 16#0002#),
         4621 => (16#3837#, 16#0020#, 16#0002#),
         4622 => (16#3838#, 16#0020#, 16#0002#),
         4623 => (16#3839#, 16#0020#, 16#0002#),
         4624 => (16#383A#, 16#0020#, 16#0002#),
         4625 => (16#383B#, 16#0020#, 16#0002#),
         4626 => (16#383C#, 16#0020#, 16#0002#),
         4627 => (16#383D#, 16#0020#, 16#0002#),
         4628 => (16#383E#, 16#0020#, 16#0002#),
         4629 => (16#383F#, 16#0020#, 16#0002#),
         4630 => (16#3840#, 16#0020#, 16#0002#),
         4631 => (16#3841#, 16#0020#, 16#0002#),
         4632 => (16#3842#, 16#0020#, 16#0002#),
         4633 => (16#3843#, 16#0020#, 16#0002#),
         4634 => (16#3844#, 16#0020#, 16#0002#),
         4635 => (16#3845#, 16#0020#, 16#0002#),
         4636 => (16#3846#, 16#0020#, 16#0002#),
         4637 => (16#3847#, 16#0020#, 16#0002#),
         4638 => (16#3848#, 16#0020#, 16#0002#),
         4639 => (16#3849#, 16#0020#, 16#0002#),
         4640 => (16#384A#, 16#0020#, 16#0002#),
         4641 => (16#384B#, 16#0020#, 16#0002#),
         4642 => (16#384C#, 16#0020#, 16#0002#),
         4643 => (16#384D#, 16#0020#, 16#0002#),
         4644 => (16#384E#, 16#0020#, 16#0002#),
         4645 => (16#384F#, 16#0020#, 16#0002#),
         4646 => (16#3850#, 16#0020#, 16#0002#),
         4647 => (16#3851#, 16#0020#, 16#0002#),
         4648 => (16#3852#, 16#0020#, 16#0002#),
         4649 => (16#3853#, 16#0020#, 16#0002#),
         4650 => (16#3854#, 16#0020#, 16#0002#),
         4651 => (16#3855#, 16#0020#, 16#0002#),
         4652 => (16#3856#, 16#0020#, 16#0002#),
         4653 => (16#214A#, 16#0020#, 16#0002#),
         4654 => (16#214B#, 16#0020#, 16#0002#),
         4655 => (16#214C#, 16#0020#, 16#0002#),
         4656 => (16#214D#, 16#0020#, 16#0002#),
         4657 => (16#214E#, 16#0020#, 16#0002#),
         4658 => (16#214F#, 16#0020#, 16#0002#),
         4659 => (16#2150#, 16#0020#, 16#0002#),
         4660 => (16#2151#, 16#0020#, 16#0002#),
         4661 => (16#2152#, 16#0020#, 16#0002#),
         4662 => (16#2153#, 16#0020#, 16#0002#),
         4663 => (16#2154#, 16#0020#, 16#0002#),
         4664 => (16#2155#, 16#0020#, 16#0002#),
         4665 => (16#2156#, 16#0020#, 16#0002#),
         4666 => (16#2157#, 16#0020#, 16#0002#),
         4667 => (16#2158#, 16#0020#, 16#0002#),
         4668 => (16#2159#, 16#0020#, 16#0002#),
         4669 => (16#215B#, 16#0020#, 16#0002#),
         4670 => (16#215C#, 16#0020#, 16#0002#),
         4671 => (16#215D#, 16#0020#, 16#0002#),
         4672 => (16#215E#, 16#0020#, 16#0002#),
         4673 => (16#215F#, 16#0020#, 16#0002#),
         4674 => (16#2160#, 16#0020#, 16#0002#),
         4675 => (16#2161#, 16#0020#, 16#0002#),
         4676 => (16#2162#, 16#0020#, 16#0002#),
         4677 => (16#2163#, 16#0020#, 16#0002#),
         4678 => (16#2164#, 16#0020#, 16#0002#),
         4679 => (16#2165#, 16#0020#, 16#0002#),
         4680 => (16#2166#, 16#0020#, 16#0002#),
         4681 => (16#2167#, 16#0020#, 16#0002#),
         4682 => (16#2168#, 16#0020#, 16#0002#),
         4683 => (16#2169#, 16#0020#, 16#0002#),
         4684 => (16#216A#, 16#0020#, 16#0002#),
         4685 => (16#2170#, 16#0020#, 16#0002#),
         4686 => (16#2171#, 16#0020#, 16#0002#),
         4687 => (16#2172#, 16#0020#, 16#0002#),
         4688 => (16#2173#, 16#0020#, 16#0002#),
         4689 => (16#2174#, 16#0020#, 16#0002#),
         4690 => (16#2175#, 16#0020#, 16#0002#),
         4691 => (16#2176#, 16#0020#, 16#0002#),
         4692 => (16#2177#, 16#0020#, 16#0002#),
         4693 => (16#2178#, 16#0020#, 16#0002#),
         4694 => (16#2179#, 16#0020#, 16#0002#),
         4695 => (16#217A#, 16#0020#, 16#0002#),
         4696 => (16#217B#, 16#0020#, 16#0002#),
         4697 => (16#217C#, 16#0020#, 16#0002#),
         4698 => (16#217D#, 16#0020#, 16#0002#),
         4699 => (16#217E#, 16#0020#, 16#0002#),
         4700 => (16#217F#, 16#0020#, 16#0002#),
         4701 => (16#2181#, 16#0020#, 16#0002#),
         4702 => (16#2182#, 16#0020#, 16#0002#),
         4703 => (16#2183#, 16#0020#, 16#0002#),
         4704 => (16#2184#, 16#0020#, 16#0002#),
         4705 => (16#2185#, 16#0020#, 16#0002#),
         4706 => (16#2186#, 16#0020#, 16#0002#),
         4707 => (16#2187#, 16#0020#, 16#0002#),
         4708 => (16#2188#, 16#0020#, 16#0002#),
         4709 => (16#2190#, 16#0020#, 16#0002#),
         4710 => (16#2191#, 16#0020#, 16#0002#),
         4711 => (16#2192#, 16#0020#, 16#0002#),
         4712 => (16#2193#, 16#0020#, 16#0002#),
         4713 => (16#2194#, 16#0020#, 16#0002#),
         4714 => (16#2195#, 16#0020#, 16#0002#),
         4715 => (16#2196#, 16#0020#, 16#0002#),
         4716 => (16#2197#, 16#0020#, 16#0002#),
         4717 => (16#2199#, 16#0020#, 16#0002#),
         4718 => (16#219A#, 16#0020#, 16#0002#),
         4719 => (16#219B#, 16#0020#, 16#0002#),
         4720 => (16#219C#, 16#0020#, 16#0002#),
         4721 => (16#219D#, 16#0020#, 16#0002#),
         4722 => (16#219E#, 16#0020#, 16#0002#),
         4723 => (16#219F#, 16#0020#, 16#0002#),
         4724 => (16#21A0#, 16#0020#, 16#0002#),
         4725 => (16#21A1#, 16#0020#, 16#0002#),
         4726 => (16#21A2#, 16#0020#, 16#0002#),
         4727 => (16#21A3#, 16#0020#, 16#0002#),
         4728 => (16#21A4#, 16#0020#, 16#0002#),
         4729 => (16#21A5#, 16#0020#, 16#0002#),
         4730 => (16#21A6#, 16#0020#, 16#0002#),
         4731 => (16#21A7#, 16#0020#, 16#0002#),
         4732 => (16#21A8#, 16#0020#, 16#0002#),
         4733 => (16#21A9#, 16#0020#, 16#0002#),
         4734 => (16#21AA#, 16#0020#, 16#0002#),
         4735 => (16#21AB#, 16#0020#, 16#0002#),
         4736 => (16#21AC#, 16#0020#, 16#0002#),
         4737 => (16#21AD#, 16#0020#, 16#0002#),
         4738 => (16#21AE#, 16#0020#, 16#0002#),
         4739 => (16#21AF#, 16#0020#, 16#0002#),
         4740 => (16#21B0#, 16#0020#, 16#0002#),
         4741 => (16#21B1#, 16#0020#, 16#0002#),
         4742 => (16#21B2#, 16#0020#, 16#0002#),
         4743 => (16#21B3#, 16#0020#, 16#0002#),
         4744 => (16#21B4#, 16#0020#, 16#0002#),
         4745 => (16#21B5#, 16#0020#, 16#0002#),
         4746 => (16#21B6#, 16#0020#, 16#0002#),
         4747 => (16#21B7#, 16#0020#, 16#0002#),
         4748 => (16#21B8#, 16#0020#, 16#0002#),
         4749 => (16#21B9#, 16#0020#, 16#0002#),
         4750 => (16#21BF#, 16#0020#, 16#0002#),
         4751 => (16#21C0#, 16#0020#, 16#0002#),
         4752 => (16#21C1#, 16#0020#, 16#0002#),
         4753 => (16#21C2#, 16#0020#, 16#0002#),
         4754 => (16#21C3#, 16#0020#, 16#0002#),
         4755 => (16#21C4#, 16#0020#, 16#0002#),
         4756 => (16#21C5#, 16#0020#, 16#0002#),
         4757 => (16#21C6#, 16#0020#, 16#0002#),
         4758 => (16#21C7#, 16#0020#, 16#0002#),
         4759 => (16#21C8#, 16#0020#, 16#0002#),
         4760 => (16#21C9#, 16#0020#, 16#0002#),
         4761 => (16#21CA#, 16#0020#, 16#0002#),
         4762 => (16#21CB#, 16#0020#, 16#0002#),
         4763 => (16#21CC#, 16#0020#, 16#0002#),
         4764 => (16#21CD#, 16#0020#, 16#0002#),
         4765 => (16#21CE#, 16#0020#, 16#0002#),
         4766 => (16#21D0#, 16#0020#, 16#0002#),
         4767 => (16#21D1#, 16#0020#, 16#0002#),
         4768 => (16#21D2#, 16#0020#, 16#0002#),
         4769 => (16#21D3#, 16#0020#, 16#0002#),
         4770 => (16#21D4#, 16#0020#, 16#0002#),
         4771 => (16#21D5#, 16#0020#, 16#0002#),
         4772 => (16#21D6#, 16#0020#, 16#0002#),
         4773 => (16#21D7#, 16#0020#, 16#0002#),
         4774 => (16#21D9#, 16#0020#, 16#0002#),
         4775 => (16#21DA#, 16#0020#, 16#0002#),
         4776 => (16#21DB#, 16#0020#, 16#0002#),
         4777 => (16#21DC#, 16#0020#, 16#0002#),
         4778 => (16#21DD#, 16#0020#, 16#0002#),
         4779 => (16#21DE#, 16#0020#, 16#0002#),
         4780 => (16#21DF#, 16#0020#, 16#0002#),
         4781 => (16#21E0#, 16#0020#, 16#0002#),
         4782 => (16#21E1#, 16#0020#, 16#0002#),
         4783 => (16#21E2#, 16#0020#, 16#0002#),
         4784 => (16#21E3#, 16#0020#, 16#0002#),
         4785 => (16#21E4#, 16#0020#, 16#0002#),
         4786 => (16#21E5#, 16#0020#, 16#0002#),
         4787 => (16#21E6#, 16#0020#, 16#0002#),
         4788 => (16#21E7#, 16#0020#, 16#0002#),
         4789 => (16#21E8#, 16#0020#, 16#0002#),
         4790 => (16#21E9#, 16#0020#, 16#0002#),
         4791 => (16#21EA#, 16#0020#, 16#0002#),
         4792 => (16#21EB#, 16#0020#, 16#0002#),
         4793 => (16#21EC#, 16#0020#, 16#0002#),
         4794 => (16#21ED#, 16#0020#, 16#0002#),
         4795 => (16#21EF#, 16#0020#, 16#0002#),
         4796 => (16#21F0#, 16#0020#, 16#0002#),
         4797 => (16#21F1#, 16#0020#, 16#0002#),
         4798 => (16#21F2#, 16#0020#, 16#0002#),
         4799 => (16#21F3#, 16#0020#, 16#0002#),
         4800 => (16#21F4#, 16#0020#, 16#0002#),
         4801 => (16#21F5#, 16#0020#, 16#0002#),
         4802 => (16#21F6#, 16#0020#, 16#0002#),
         4803 => (16#21F8#, 16#0020#, 16#0002#),
         4804 => (16#21F9#, 16#0020#, 16#0002#),
         4805 => (16#21FA#, 16#0020#, 16#0002#),
         4806 => (16#21FB#, 16#0020#, 16#0002#),
         4807 => (16#21FC#, 16#0020#, 16#0002#),
         4808 => (16#21FD#, 16#0020#, 16#0002#),
         4809 => (16#21FE#, 16#0020#, 16#0002#),
         4810 => (16#21FF#, 16#0020#, 16#0002#),
         4811 => (16#2201#, 16#0020#, 16#0002#),
         4812 => (16#2202#, 16#0020#, 16#0002#),
         4813 => (16#2203#, 16#0020#, 16#0002#),
         4814 => (16#2204#, 16#0020#, 16#0002#),
         4815 => (16#2205#, 16#0020#, 16#0002#),
         4816 => (16#2206#, 16#0020#, 16#0002#),
         4817 => (16#2207#, 16#0020#, 16#0002#),
         4818 => (16#2208#, 16#0020#, 16#0002#),
         4819 => (16#2209#, 16#0020#, 16#0002#),
         4820 => (16#220A#, 16#0020#, 16#0002#),
         4821 => (16#220B#, 16#0020#, 16#0002#),
         4822 => (16#220C#, 16#0020#, 16#0002#),
         4823 => (16#220D#, 16#0020#, 16#0002#),
         4824 => (16#220E#, 16#0020#, 16#0002#),
         4825 => (16#220F#, 16#0020#, 16#0002#),
         4826 => (16#2210#, 16#0020#, 16#0002#),
         4827 => (16#2211#, 16#0020#, 16#0002#),
         4828 => (16#2212#, 16#0020#, 16#0002#),
         4829 => (16#2213#, 16#0020#, 16#0002#),
         4830 => (16#2214#, 16#0020#, 16#0002#),
         4831 => (16#2215#, 16#0020#, 16#0002#),
         4832 => (16#2216#, 16#0020#, 16#0002#),
         4833 => (16#2217#, 16#0020#, 16#0002#),
         4834 => (16#2218#, 16#0020#, 16#0002#),
         4835 => (16#2219#, 16#0020#, 16#0002#),
         4836 => (16#221A#, 16#0020#, 16#0002#),
         4837 => (16#221B#, 16#0020#, 16#0002#),
         4838 => (16#221C#, 16#0020#, 16#0002#),
         4839 => (16#221D#, 16#0020#, 16#0002#),
         4840 => (16#221E#, 16#0020#, 16#0002#),
         4841 => (16#221F#, 16#0020#, 16#0002#),
         4842 => (16#2220#, 16#0020#, 16#0002#),
         4843 => (16#2221#, 16#0020#, 16#0002#),
         4844 => (16#2222#, 16#0020#, 16#0002#),
         4845 => (16#2223#, 16#0020#, 16#0002#),
         4846 => (16#2224#, 16#0020#, 16#0002#),
         4847 => (16#2225#, 16#0020#, 16#0002#),
         4848 => (16#2226#, 16#0020#, 16#0002#),
         4849 => (16#2227#, 16#0020#, 16#0002#),
         4850 => (16#2228#, 16#0020#, 16#0002#),
         4851 => (16#2229#, 16#0020#, 16#0002#),
         4852 => (16#222A#, 16#0020#, 16#0002#),
         4853 => (16#222B#, 16#0020#, 16#0002#),
         4854 => (16#222C#, 16#0020#, 16#0002#),
         4855 => (16#222D#, 16#0020#, 16#0002#),
         4856 => (16#222E#, 16#0020#, 16#0002#),
         4857 => (16#222F#, 16#0020#, 16#0002#),
         4858 => (16#2230#, 16#0020#, 16#0002#),
         4859 => (16#2238#, 16#0020#, 16#0002#),
         4860 => (16#2239#, 16#0020#, 16#0002#),
         4861 => (16#223A#, 16#0020#, 16#0002#),
         4862 => (16#223B#, 16#0020#, 16#0002#),
         4863 => (16#223C#, 16#0020#, 16#0002#),
         4864 => (16#223D#, 16#0020#, 16#0002#),
         4865 => (16#223E#, 16#0020#, 16#0002#),
         4866 => (16#223F#, 16#0020#, 16#0002#),
         4867 => (16#2240#, 16#0020#, 16#0002#),
         4868 => (16#2241#, 16#0020#, 16#0002#),
         4869 => (16#2242#, 16#0020#, 16#0002#),
         4870 => (16#2243#, 16#0020#, 16#0002#),
         4871 => (16#2244#, 16#0020#, 16#0002#),
         4872 => (16#2245#, 16#0020#, 16#0002#),
         4873 => (16#2246#, 16#0020#, 16#0002#),
         4874 => (16#2247#, 16#0020#, 16#0002#),
         4875 => (16#2248#, 16#0020#, 16#0002#),
         4876 => (16#2249#, 16#0020#, 16#0002#),
         4877 => (16#224A#, 16#0020#, 16#0002#),
         4878 => (16#224B#, 16#0020#, 16#0002#),
         4879 => (16#224C#, 16#0020#, 16#0002#),
         4880 => (16#224D#, 16#0020#, 16#0002#),
         4881 => (16#224E#, 16#0020#, 16#0002#),
         4882 => (16#224F#, 16#0020#, 16#0002#),
         4883 => (16#2257#, 16#0020#, 16#0002#),
         4884 => (16#2258#, 16#0020#, 16#0002#),
         4885 => (16#2259#, 16#0020#, 16#0002#),
         4886 => (16#225A#, 16#0020#, 16#0002#),
         4887 => (16#225B#, 16#0020#, 16#0002#),
         4888 => (16#225C#, 16#0020#, 16#0002#),
         4889 => (16#225D#, 16#0020#, 16#0002#),
         4890 => (16#225E#, 16#0020#, 16#0002#),
         4891 => (16#2260#, 16#0020#, 16#0002#),
         4892 => (16#2261#, 16#0020#, 16#0002#),
         4893 => (16#2262#, 16#0020#, 16#0002#),
         4894 => (16#2263#, 16#0020#, 16#0002#),
         4895 => (16#2264#, 16#0020#, 16#0002#),
         4896 => (16#2265#, 16#0020#, 16#0002#),
         4897 => (16#2266#, 16#0020#, 16#0002#),
         4898 => (16#2267#, 16#0020#, 16#0002#),
         4899 => (16#2269#, 16#0020#, 16#0002#),
         4900 => (16#226A#, 16#0020#, 16#0002#),
         4901 => (16#226B#, 16#0020#, 16#0002#),
         4902 => (16#226C#, 16#0020#, 16#0002#),
         4903 => (16#226D#, 16#0020#, 16#0002#),
         4904 => (16#226E#, 16#0020#, 16#0002#),
         4905 => (16#226F#, 16#0020#, 16#0002#),
         4906 => (16#2270#, 16#0020#, 16#0002#),
         4907 => (16#2271#, 16#0020#, 16#0002#),
         4908 => (16#2272#, 16#0020#, 16#0002#),
         4909 => (16#2273#, 16#0020#, 16#0002#),
         4910 => (16#2274#, 16#0020#, 16#0002#),
         4911 => (16#2275#, 16#0020#, 16#0002#),
         4912 => (16#2276#, 16#0020#, 16#0002#),
         4913 => (16#2277#, 16#0020#, 16#0002#),
         4914 => (16#2278#, 16#0020#, 16#0002#),
         4915 => (16#2279#, 16#0020#, 16#0002#),
         4916 => (16#227A#, 16#0020#, 16#0002#),
         4917 => (16#227B#, 16#0020#, 16#0002#),
         4918 => (16#227C#, 16#0020#, 16#0002#),
         4919 => (16#227D#, 16#0020#, 16#0002#),
         4920 => (16#2282#, 16#0020#, 16#0002#),
         4921 => (16#2283#, 16#0020#, 16#0002#),
         4922 => (16#2284#, 16#0020#, 16#0002#),
         4923 => (16#2285#, 16#0020#, 16#0002#),
         4924 => (16#2286#, 16#0020#, 16#0002#),
         4925 => (16#2287#, 16#0020#, 16#0002#),
         4926 => (16#2288#, 16#0020#, 16#0002#),
         4927 => (16#2289#, 16#0020#, 16#0002#),
         4928 => (16#228B#, 16#0020#, 16#0002#),
         4929 => (16#228C#, 16#0020#, 16#0002#),
         4930 => (16#228D#, 16#0020#, 16#0002#),
         4931 => (16#228E#, 16#0020#, 16#0002#),
         4932 => (16#228F#, 16#0020#, 16#0002#),
         4933 => (16#2290#, 16#0020#, 16#0002#),
         4934 => (16#2291#, 16#0020#, 16#0002#),
         4935 => (16#2292#, 16#0020#, 16#0002#),
         4936 => (16#229B#, 16#0020#, 16#0002#),
         4937 => (16#229C#, 16#0020#, 16#0002#),
         4938 => (16#229D#, 16#0020#, 16#0002#),
         4939 => (16#229E#, 16#0020#, 16#0002#),
         4940 => (16#229F#, 16#0020#, 16#0002#),
         4941 => (16#22A0#, 16#0020#, 16#0002#),
         4942 => (16#22A1#, 16#0020#, 16#0002#),
         4943 => (16#22A2#, 16#0020#, 16#0002#),
         4944 => (16#22A4#, 16#0020#, 16#0002#),
         4945 => (16#22A5#, 16#0020#, 16#0002#),
         4946 => (16#22A6#, 16#0020#, 16#0002#),
         4947 => (16#22A7#, 16#0020#, 16#0002#),
         4948 => (16#22A8#, 16#0020#, 16#0002#),
         4949 => (16#22A9#, 16#0020#, 16#0002#),
         4950 => (16#22AA#, 16#0020#, 16#0002#),
         4951 => (16#22AB#, 16#0020#, 16#0002#),
         4952 => (16#22B3#, 16#0020#, 16#0002#),
         4953 => (16#22B4#, 16#0020#, 16#0002#),
         4954 => (16#22B5#, 16#0020#, 16#0002#),
         4955 => (16#22B6#, 16#0020#, 16#0002#),
         4956 => (16#22B7#, 16#0020#, 16#0002#),
         4957 => (16#22B8#, 16#0020#, 16#0002#),
         4958 => (16#22B9#, 16#0020#, 16#0002#),
         4959 => (16#22BA#, 16#0020#, 16#0002#),
         4960 => (16#22BB#, 16#0020#, 16#0002#),
         4961 => (16#22BC#, 16#0020#, 16#0002#),
         4962 => (16#22BD#, 16#0020#, 16#0002#),
         4963 => (16#22BE#, 16#0020#, 16#0002#),
         4964 => (16#22BF#, 16#0020#, 16#0002#),
         4965 => (16#22C0#, 16#0020#, 16#0002#),
         4966 => (16#22C1#, 16#0020#, 16#0002#),
         4967 => (16#22C2#, 16#0020#, 16#0002#),
         4968 => (16#22C7#, 16#0020#, 16#0002#),
         4969 => (16#22C8#, 16#0020#, 16#0002#),
         4970 => (16#22C9#, 16#0020#, 16#0002#),
         4971 => (16#22CA#, 16#0020#, 16#0002#),
         4972 => (16#22CB#, 16#0020#, 16#0002#),
         4973 => (16#22CC#, 16#0020#, 16#0002#),
         4974 => (16#22CD#, 16#0020#, 16#0002#),
         4975 => (16#22CE#, 16#0020#, 16#0002#),
         4976 => (16#22D4#, 16#0020#, 16#0002#),
         4977 => (16#22D5#, 16#0020#, 16#0002#),
         4978 => (16#22D6#, 16#0020#, 16#0002#),
         4979 => (16#0000#, 16#00B4#, 16#0002#),
         4980 => (16#0000#, 16#00B3#, 16#0002#),
         4981 => (16#0000#, 16#00B2#, 16#0002#),
         4982 => (16#01BD#, 16#0020#, 16#0002#),
         4983 => (16#014F#, 16#0020#, 16#0002#),
         4984 => (16#0178#, 16#0020#, 16#0002#),
         4985 => (16#0150#, 16#0020#, 16#0002#),
         4986 => (16#0151#, 16#0020#, 16#0002#),
         4987 => (16#0152#, 16#0020#, 16#0002#),
         4988 => (16#0153#, 16#0020#, 16#0002#),
         4989 => (16#0169#, 16#0020#, 16#0002#),
         4990 => (16#01BE#, 16#0020#, 16#0002#),
         4991 => (16#1711#, 16#0020#, 16#0002#),
         4992 => (16#1712#, 16#0020#, 16#0002#),
         4993 => (16#1713#, 16#0020#, 16#0002#),
         4994 => (16#1714#, 16#0020#, 16#0002#),
         4995 => (16#1715#, 16#0020#, 16#0002#),
         4996 => (16#1716#, 16#0020#, 16#0002#),
         4997 => (16#1717#, 16#0020#, 16#0002#),
         4998 => (16#1718#, 16#0020#, 16#0002#),
         4999 => (16#1719#, 16#0020#, 16#0002#),
         5000 => (16#171A#, 16#0020#, 16#0002#),
         5001 => (16#171B#, 16#0020#, 16#0002#),
         5002 => (16#216B#, 16#0020#, 16#0002#),
         5003 => (16#216C#, 16#0020#, 16#0002#),
         5004 => (16#216D#, 16#0020#, 16#0002#),
         5005 => (16#216E#, 16#0020#, 16#0002#),
         5006 => (16#21BA#, 16#0020#, 16#0002#),
         5007 => (16#21BB#, 16#0020#, 16#0002#),
         5008 => (16#21BC#, 16#0020#, 16#0002#),
         5009 => (16#21BD#, 16#0020#, 16#0002#),
         5010 => (16#22C3#, 16#0020#, 16#0002#),
         5011 => (16#22C4#, 16#0020#, 16#0002#),
         5012 => (16#22C5#, 16#0020#, 16#0002#),
         5013 => (16#22C6#, 16#0020#, 16#0002#),
         5014 => (16#22CF#, 16#0020#, 16#0002#),
         5015 => (16#22D0#, 16#0020#, 16#0002#),
         5016 => (16#22D1#, 16#0020#, 16#0002#),
         5017 => (16#22D2#, 16#0020#, 16#0002#),
         5018 => (16#038A#, 16#0020#, 16#0002#),
         5019 => (16#038B#, 16#0020#, 16#0002#),
         5020 => (16#038C#, 16#0020#, 16#0002#),
         5021 => (16#038D#, 16#0020#, 16#0002#),
         5022 => (16#038E#, 16#0020#, 16#0002#),
         5023 => (16#038F#, 16#0020#, 16#0002#),
         5024 => (16#0390#, 16#0020#, 16#0002#),
         5025 => (16#0391#, 16#0020#, 16#0002#),
         5026 => (16#0392#, 16#0020#, 16#0002#),
         5027 => (16#0393#, 16#0020#, 16#0002#),
         5028 => (16#2F1D#, 16#0020#, 16#0002#),
         5029 => (16#2F1E#, 16#0020#, 16#0002#),
         5030 => (16#2F1F#, 16#0020#, 16#0002#),
         5031 => (16#2F20#, 16#0020#, 16#0002#),
         5032 => (16#2F21#, 16#0020#, 16#0002#),
         5033 => (16#2F22#, 16#0020#, 16#0002#),
         5034 => (16#2F23#, 16#0020#, 16#0002#),
         5035 => (16#2F24#, 16#0020#, 16#0002#),
         5036 => (16#2F25#, 16#0020#, 16#0002#),
         5037 => (16#2F26#, 16#0020#, 16#0002#),
         5038 => (16#2F27#, 16#0020#, 16#0002#),
         5039 => (16#2F28#, 16#0020#, 16#0002#),
         5040 => (16#2F29#, 16#0020#, 16#0002#),
         5041 => (16#2F2A#, 16#0020#, 16#0002#),
         5042 => (16#2F2B#, 16#0020#, 16#0002#),
         5043 => (16#2F2C#, 16#0020#, 16#0002#),
         5044 => (16#2F2D#, 16#0020#, 16#0002#),
         5045 => (16#2F2E#, 16#0020#, 16#0002#),
         5046 => (16#2F2F#, 16#0020#, 16#0002#),
         5047 => (16#2F30#, 16#0020#, 16#0002#),
         5048 => (16#2F31#, 16#0020#, 16#0002#),
         5049 => (16#2F32#, 16#0020#, 16#0002#),
         5050 => (16#2F33#, 16#0020#, 16#0002#),
         5051 => (16#2F34#, 16#0020#, 16#0002#),
         5052 => (16#2F35#, 16#0020#, 16#0002#),
         5053 => (16#2F36#, 16#0020#, 16#0002#),
         5054 => (16#2F37#, 16#0020#, 16#0002#),
         5055 => (16#2F38#, 16#0020#, 16#0002#),
         5056 => (16#2F39#, 16#0020#, 16#0002#),
         5057 => (16#2F3A#, 16#0020#, 16#0002#),
         5058 => (16#2F3B#, 16#0020#, 16#0002#),
         5059 => (16#2F3C#, 16#0020#, 16#0002#),
         5060 => (16#2F3D#, 16#0020#, 16#0002#),
         5061 => (16#2F3E#, 16#0020#, 16#0002#),
         5062 => (16#2F3F#, 16#0020#, 16#0002#),
         5063 => (16#2F40#, 16#0020#, 16#0002#),
         5064 => (16#2F41#, 16#0020#, 16#0002#),
         5065 => (16#2F42#, 16#0020#, 16#0002#),
         5066 => (16#2F43#, 16#0020#, 16#0002#),
         5067 => (16#2F44#, 16#0020#, 16#0002#),
         5068 => (16#2F45#, 16#0020#, 16#0002#),
         5069 => (16#2F46#, 16#0020#, 16#0002#),
         5070 => (16#2F47#, 16#0020#, 16#0002#),
         5071 => (16#2F48#, 16#0020#, 16#0002#),
         5072 => (16#2F49#, 16#0020#, 16#0002#),
         5073 => (16#2F4A#, 16#0020#, 16#0002#),
         5074 => (16#2F4B#, 16#0020#, 16#0002#),
         5075 => (16#2F4C#, 16#0020#, 16#0002#),
         5076 => (16#2F4D#, 16#0020#, 16#0002#),
         5077 => (16#2F4E#, 16#0020#, 16#0002#),
         5078 => (16#2F4F#, 16#0020#, 16#0002#),
         5079 => (16#2F50#, 16#0020#, 16#0002#),
         5080 => (16#2F51#, 16#0020#, 16#0002#),
         5081 => (16#2F52#, 16#0020#, 16#0002#),
         5082 => (16#2F53#, 16#0020#, 16#0002#),
         5083 => (16#2F54#, 16#0020#, 16#0002#),
         5084 => (16#2F55#, 16#0020#, 16#0002#),
         5085 => (16#2F56#, 16#0020#, 16#0002#),
         5086 => (16#2F57#, 16#0020#, 16#0002#),
         5087 => (16#2F58#, 16#0020#, 16#0002#),
         5088 => (16#2F59#, 16#0020#, 16#0002#),
         5089 => (16#2F5A#, 16#0020#, 16#0002#),
         5090 => (16#2F5B#, 16#0020#, 16#0002#),
         5091 => (16#2F5C#, 16#0020#, 16#0002#),
         5092 => (16#2F5D#, 16#0020#, 16#0002#),
         5093 => (16#2F5E#, 16#0020#, 16#0002#),
         5094 => (16#2F5F#, 16#0020#, 16#0002#),
         5095 => (16#2F60#, 16#0020#, 16#0002#),
         5096 => (16#2F61#, 16#0020#, 16#0002#),
         5097 => (16#2F62#, 16#0020#, 16#0002#),
         5098 => (16#2F63#, 16#0020#, 16#0002#),
         5099 => (16#2F64#, 16#0020#, 16#0002#),
         5100 => (16#2F65#, 16#0020#, 16#0002#),
         5101 => (16#2F66#, 16#0020#, 16#0002#),
         5102 => (16#2F67#, 16#0020#, 16#0002#),
         5103 => (16#2F68#, 16#0020#, 16#0002#),
         5104 => (16#2F69#, 16#0020#, 16#0002#),
         5105 => (16#2F6A#, 16#0020#, 16#0002#),
         5106 => (16#2F6B#, 16#0020#, 16#0002#),
         5107 => (16#2F6C#, 16#0020#, 16#0002#),
         5108 => (16#2F6D#, 16#0020#, 16#0002#),
         5109 => (16#2F6E#, 16#0020#, 16#0002#),
         5110 => (16#2F6F#, 16#0020#, 16#0002#),
         5111 => (16#2F70#, 16#0020#, 16#0002#),
         5112 => (16#2F71#, 16#0020#, 16#0002#),
         5113 => (16#010E#, 16#0020#, 16#0002#),
         5114 => (16#2F72#, 16#0020#, 16#0002#),
         5115 => (16#2F73#, 16#0020#, 16#0002#),
         5116 => (16#2F74#, 16#0020#, 16#0002#),
         5117 => (16#2F75#, 16#0020#, 16#0002#),
         5118 => (16#2F76#, 16#0020#, 16#0002#),
         5119 => (16#2F77#, 16#0020#, 16#0002#),
         5120 => (16#2F78#, 16#0020#, 16#0002#),
         5121 => (16#2F79#, 16#0020#, 16#0002#),
         5122 => (16#2F7A#, 16#0020#, 16#0002#),
         5123 => (16#2F7B#, 16#0020#, 16#0002#),
         5124 => (16#2F7C#, 16#0020#, 16#0002#),
         5125 => (16#2F7D#, 16#0020#, 16#0002#),
         5126 => (16#2F7E#, 16#0020#, 16#0002#),
         5127 => (16#2F7F#, 16#0020#, 16#0002#),
         5128 => (16#2F80#, 16#0020#, 16#0002#),
         5129 => (16#2F81#, 16#0020#, 16#0002#),
         5130 => (16#2F82#, 16#0020#, 16#0002#),
         5131 => (16#2F83#, 16#0020#, 16#0002#),
         5132 => (16#2F84#, 16#0020#, 16#0002#),
         5133 => (16#2F85#, 16#0020#, 16#0002#),
         5134 => (16#2F86#, 16#0020#, 16#0002#),
         5135 => (16#2F87#, 16#0020#, 16#0002#),
         5136 => (16#2F88#, 16#0020#, 16#0002#),
         5137 => (16#2F89#, 16#0020#, 16#0002#),
         5138 => (16#2F8A#, 16#0020#, 16#0002#),
         5139 => (16#2F8B#, 16#0020#, 16#0002#),
         5140 => (16#2F8C#, 16#0020#, 16#0002#),
         5141 => (16#2F8D#, 16#0020#, 16#0002#),
         5142 => (16#2F8E#, 16#0020#, 16#0002#),
         5143 => (16#2F8F#, 16#0020#, 16#0002#),
         5144 => (16#2F90#, 16#0020#, 16#0002#),
         5145 => (16#2F91#, 16#0020#, 16#0002#),
         5146 => (16#2F92#, 16#0020#, 16#0002#),
         5147 => (16#2F93#, 16#0020#, 16#0002#),
         5148 => (16#2F94#, 16#0020#, 16#0002#),
         5149 => (16#2F95#, 16#0020#, 16#0002#),
         5150 => (16#2F96#, 16#0020#, 16#0002#),
         5151 => (16#2F97#, 16#0020#, 16#0002#),
         5152 => (16#2F98#, 16#0020#, 16#0002#),
         5153 => (16#2F99#, 16#0020#, 16#0002#),
         5154 => (16#2F9A#, 16#0020#, 16#0002#),
         5155 => (16#2F9B#, 16#0020#, 16#0002#),
         5156 => (16#2F9C#, 16#0020#, 16#0002#),
         5157 => (16#2F9D#, 16#0020#, 16#0002#),
         5158 => (16#2F9E#, 16#0020#, 16#0002#),
         5159 => (16#2F9F#, 16#0020#, 16#0002#),
         5160 => (16#2FA0#, 16#0020#, 16#0002#),
         5161 => (16#2FA1#, 16#0020#, 16#0002#),
         5162 => (16#2FA2#, 16#0020#, 16#0002#),
         5163 => (16#2FA3#, 16#0020#, 16#0002#),
         5164 => (16#2FA4#, 16#0020#, 16#0002#),
         5165 => (16#2FA5#, 16#0020#, 16#0002#),
         5166 => (16#2FA6#, 16#0020#, 16#0002#),
         5167 => (16#2FA7#, 16#0020#, 16#0002#),
         5168 => (16#2FA8#, 16#0020#, 16#0002#),
         5169 => (16#2FA9#, 16#0020#, 16#0002#),
         5170 => (16#2FAA#, 16#0020#, 16#0002#),
         5171 => (16#2FAB#, 16#0020#, 16#0002#),
         5172 => (16#2FAC#, 16#0020#, 16#0002#),
         5173 => (16#2FAD#, 16#0020#, 16#0002#),
         5174 => (16#2FAE#, 16#0020#, 16#0002#),
         5175 => (16#2FAF#, 16#0020#, 16#0002#),
         5176 => (16#2FB0#, 16#0020#, 16#0002#),
         5177 => (16#2FB1#, 16#0020#, 16#0002#),
         5178 => (16#2FB2#, 16#0020#, 16#0002#),
         5179 => (16#2FB3#, 16#0020#, 16#0002#),
         5180 => (16#2FB4#, 16#0020#, 16#0002#),
         5181 => (16#2FB5#, 16#0020#, 16#0002#),
         5182 => (16#2FB6#, 16#0020#, 16#0002#),
         5183 => (16#2FB7#, 16#0020#, 16#0002#),
         5184 => (16#2FB8#, 16#0020#, 16#0002#),
         5185 => (16#2FB9#, 16#0020#, 16#0002#),
         5186 => (16#2FBA#, 16#0020#, 16#0002#),
         5187 => (16#2FBB#, 16#0020#, 16#0002#),
         5188 => (16#2FBC#, 16#0020#, 16#0002#),
         5189 => (16#2FBD#, 16#0020#, 16#0002#),
         5190 => (16#2FBE#, 16#0020#, 16#0002#),
         5191 => (16#2FBF#, 16#0020#, 16#0002#),
         5192 => (16#2FC0#, 16#0020#, 16#0002#),
         5193 => (16#2FC1#, 16#0020#, 16#0002#),
         5194 => (16#2FC2#, 16#0020#, 16#0002#),
         5195 => (16#2FC3#, 16#0020#, 16#0002#),
         5196 => (16#2FC4#, 16#0020#, 16#0002#),
         5197 => (16#2FC5#, 16#0020#, 16#0002#),
         5198 => (16#2FC6#, 16#0020#, 16#0002#),
         5199 => (16#2FC7#, 16#0020#, 16#0002#),
         5200 => (16#2FC8#, 16#0020#, 16#0002#),
         5201 => (16#2FC9#, 16#0020#, 16#0002#),
         5202 => (16#2FCA#, 16#0020#, 16#0002#),
         5203 => (16#2FCB#, 16#0020#, 16#0002#),
         5204 => (16#2FCC#, 16#0020#, 16#0002#),
         5205 => (16#2FCD#, 16#0020#, 16#0002#),
         5206 => (16#2FCE#, 16#0020#, 16#0002#),
         5207 => (16#2FCF#, 16#0020#, 16#0002#),
         5208 => (16#2FD0#, 16#0020#, 16#0002#),
         5209 => (16#2FD1#, 16#0020#, 16#0002#),
         5210 => (16#2FD2#, 16#0020#, 16#0002#),
         5211 => (16#2FD3#, 16#0020#, 16#0002#),
         5212 => (16#2FD4#, 16#0020#, 16#0002#),
         5213 => (16#2FD5#, 16#0020#, 16#0002#),
         5214 => (16#2FD6#, 16#0020#, 16#0002#),
         5215 => (16#2FD7#, 16#0020#, 16#0002#),
         5216 => (16#2FD8#, 16#0020#, 16#0002#),
         5217 => (16#2FD9#, 16#0020#, 16#0002#),
         5218 => (16#2FDA#, 16#0020#, 16#0002#),
         5219 => (16#2FDB#, 16#0020#, 16#0002#),
         5220 => (16#2FDC#, 16#0020#, 16#0002#),
         5221 => (16#2FDD#, 16#0020#, 16#0002#),
         5222 => (16#2FDE#, 16#0020#, 16#0002#),
         5223 => (16#2FDF#, 16#0020#, 16#0002#),
         5224 => (16#2FE0#, 16#0020#, 16#0002#),
         5225 => (16#2FE1#, 16#0020#, 16#0002#),
         5226 => (16#2FE2#, 16#0020#, 16#0002#),
         5227 => (16#2FE3#, 16#0020#, 16#0002#),
         5228 => (16#2FE4#, 16#0020#, 16#0002#),
         5229 => (16#2FE5#, 16#0020#, 16#0002#),
         5230 => (16#2FE6#, 16#0020#, 16#0002#),
         5231 => (16#2FE7#, 16#0020#, 16#0002#),
         5232 => (16#2FE8#, 16#0020#, 16#0002#),
         5233 => (16#2FE9#, 16#0020#, 16#0002#),
         5234 => (16#2FEA#, 16#0020#, 16#0002#),
         5235 => (16#2FEB#, 16#0020#, 16#0002#),
         5236 => (16#2FEC#, 16#0020#, 16#0002#),
         5237 => (16#2FED#, 16#0020#, 16#0002#),
         5238 => (16#2FEE#, 16#0020#, 16#0002#),
         5239 => (16#2FEF#, 16#0020#, 16#0002#),
         5240 => (16#2FF0#, 16#0020#, 16#0002#),
         5241 => (16#2FF1#, 16#0020#, 16#0002#),
         5242 => (16#2FF2#, 16#0020#, 16#0002#),
         5243 => (16#2FF3#, 16#0020#, 16#0002#),
         5244 => (16#2FF4#, 16#0020#, 16#0002#),
         5245 => (16#2FF5#, 16#0020#, 16#0002#),
         5246 => (16#2FF6#, 16#0020#, 16#0002#),
         5247 => (16#2FF7#, 16#0020#, 16#0002#),
         5248 => (16#2FF8#, 16#0020#, 16#0002#),
         5249 => (16#2FF9#, 16#0020#, 16#0002#),
         5250 => (16#2FFA#, 16#0020#, 16#0002#),
         5251 => (16#2FFB#, 16#0020#, 16#0002#),
         5252 => (16#2FFC#, 16#0020#, 16#0002#),
         5253 => (16#2FFD#, 16#0020#, 16#0002#),
         5254 => (16#2FFE#, 16#0020#, 16#0002#),
         5255 => (16#2FFF#, 16#0020#, 16#0002#),
         5256 => (16#3000#, 16#0020#, 16#0002#),
         5257 => (16#3001#, 16#0020#, 16#0002#),
         5258 => (16#3002#, 16#0020#, 16#0002#),
         5259 => (16#3003#, 16#0020#, 16#0002#),
         5260 => (16#3004#, 16#0020#, 16#0002#),
         5261 => (16#3005#, 16#0020#, 16#0002#),
         5262 => (16#3006#, 16#0020#, 16#0002#),
         5263 => (16#3007#, 16#0020#, 16#0002#),
         5264 => (16#3008#, 16#0020#, 16#0002#),
         5265 => (16#3009#, 16#0020#, 16#0002#),
         5266 => (16#300A#, 16#0020#, 16#0002#),
         5267 => (16#300B#, 16#0020#, 16#0002#),
         5268 => (16#300C#, 16#0020#, 16#0002#),
         5269 => (16#300D#, 16#0020#, 16#0002#),
         5270 => (16#300E#, 16#0020#, 16#0002#),
         5271 => (16#300F#, 16#0020#, 16#0002#),
         5272 => (16#3010#, 16#0020#, 16#0002#),
         5273 => (16#3011#, 16#0020#, 16#0002#),
         5274 => (16#3012#, 16#0020#, 16#0002#),
         5275 => (16#3013#, 16#0020#, 16#0002#),
         5276 => (16#3014#, 16#0020#, 16#0002#),
         5277 => (16#3015#, 16#0020#, 16#0002#),
         5278 => (16#3016#, 16#0020#, 16#0002#),
         5279 => (16#3017#, 16#0020#, 16#0002#),
         5280 => (16#3018#, 16#0020#, 16#0002#),
         5281 => (16#3019#, 16#0020#, 16#0002#),
         5282 => (16#301A#, 16#0020#, 16#0002#),
         5283 => (16#301B#, 16#0020#, 16#0002#),
         5284 => (16#301C#, 16#0020#, 16#0002#),
         5285 => (16#301D#, 16#0020#, 16#0002#),
         5286 => (16#301E#, 16#0020#, 16#0002#),
         5287 => (16#301F#, 16#0020#, 16#0002#),
         5288 => (16#3020#, 16#0020#, 16#0002#),
         5289 => (16#3021#, 16#0020#, 16#0002#),
         5290 => (16#3022#, 16#0020#, 16#0002#),
         5291 => (16#3023#, 16#0020#, 16#0002#),
         5292 => (16#3024#, 16#0020#, 16#0002#),
         5293 => (16#3025#, 16#0020#, 16#0002#),
         5294 => (16#3026#, 16#0020#, 16#0002#),
         5295 => (16#3027#, 16#0020#, 16#0002#),
         5296 => (16#3028#, 16#0020#, 16#0002#),
         5297 => (16#3029#, 16#0020#, 16#0002#),
         5298 => (16#302A#, 16#0020#, 16#0002#),
         5299 => (16#302B#, 16#0020#, 16#0002#),
         5300 => (16#302C#, 16#0020#, 16#0002#),
         5301 => (16#302D#, 16#0020#, 16#0002#),
         5302 => (16#302E#, 16#0020#, 16#0002#),
         5303 => (16#302F#, 16#0020#, 16#0002#),
         5304 => (16#3030#, 16#0020#, 16#0002#),
         5305 => (16#3031#, 16#0020#, 16#0002#),
         5306 => (16#3032#, 16#0020#, 16#0002#),
         5307 => (16#3033#, 16#0020#, 16#0002#),
         5308 => (16#3034#, 16#0020#, 16#0002#),
         5309 => (16#3035#, 16#0020#, 16#0002#),
         5310 => (16#3036#, 16#0020#, 16#0002#),
         5311 => (16#3037#, 16#0020#, 16#0002#),
         5312 => (16#3038#, 16#0020#, 16#0002#),
         5313 => (16#3039#, 16#0020#, 16#0002#),
         5314 => (16#303A#, 16#0020#, 16#0002#),
         5315 => (16#303B#, 16#0020#, 16#0002#),
         5316 => (16#303C#, 16#0020#, 16#0002#),
         5317 => (16#303D#, 16#0020#, 16#0002#),
         5318 => (16#303E#, 16#0020#, 16#0002#),
         5319 => (16#303F#, 16#0020#, 16#0002#),
         5320 => (16#3040#, 16#0020#, 16#0002#),
         5321 => (16#3041#, 16#0020#, 16#0002#),
         5322 => (16#3042#, 16#0020#, 16#0002#),
         5323 => (16#3043#, 16#0020#, 16#0002#),
         5324 => (16#3044#, 16#0020#, 16#0002#),
         5325 => (16#3045#, 16#0020#, 16#0002#),
         5326 => (16#3046#, 16#0020#, 16#0002#),
         5327 => (16#3047#, 16#0020#, 16#0002#),
         5328 => (16#3048#, 16#0020#, 16#0002#),
         5329 => (16#3049#, 16#0020#, 16#0002#),
         5330 => (16#304A#, 16#0020#, 16#0002#),
         5331 => (16#304B#, 16#0020#, 16#0002#),
         5332 => (16#304C#, 16#0020#, 16#0002#),
         5333 => (16#304D#, 16#0020#, 16#0002#),
         5334 => (16#304E#, 16#0020#, 16#0002#),
         5335 => (16#304F#, 16#0020#, 16#0002#),
         5336 => (16#3050#, 16#0020#, 16#0002#),
         5337 => (16#3051#, 16#0020#, 16#0002#),
         5338 => (16#3052#, 16#0020#, 16#0002#),
         5339 => (16#3053#, 16#0020#, 16#0002#),
         5340 => (16#3054#, 16#0020#, 16#0002#),
         5341 => (16#3055#, 16#0020#, 16#0002#),
         5342 => (16#3056#, 16#0020#, 16#0002#),
         5343 => (16#3057#, 16#0020#, 16#0002#),
         5344 => (16#3058#, 16#0020#, 16#0002#),
         5345 => (16#3059#, 16#0020#, 16#0002#),
         5346 => (16#305A#, 16#0020#, 16#0002#),
         5347 => (16#305B#, 16#0020#, 16#0002#),
         5348 => (16#305C#, 16#0020#, 16#0002#),
         5349 => (16#305D#, 16#0020#, 16#0002#),
         5350 => (16#305E#, 16#0020#, 16#0002#),
         5351 => (16#305F#, 16#0020#, 16#0002#),
         5352 => (16#3060#, 16#0020#, 16#0002#),
         5353 => (16#3061#, 16#0020#, 16#0002#),
         5354 => (16#3062#, 16#0020#, 16#0002#),
         5355 => (16#3063#, 16#0020#, 16#0002#),
         5356 => (16#3064#, 16#0020#, 16#0002#),
         5357 => (16#3065#, 16#0020#, 16#0002#),
         5358 => (16#3066#, 16#0020#, 16#0002#),
         5359 => (16#3067#, 16#0020#, 16#0002#),
         5360 => (16#3068#, 16#0020#, 16#0002#),
         5361 => (16#3069#, 16#0020#, 16#0002#),
         5362 => (16#306A#, 16#0020#, 16#0002#),
         5363 => (16#306B#, 16#0020#, 16#0002#),
         5364 => (16#306C#, 16#0020#, 16#0002#),
         5365 => (16#306D#, 16#0020#, 16#0002#),
         5366 => (16#306E#, 16#0020#, 16#0002#),
         5367 => (16#306F#, 16#0020#, 16#0002#),
         5368 => (16#3070#, 16#0020#, 16#0002#),
         5369 => (16#3071#, 16#0020#, 16#0002#),
         5370 => (16#3072#, 16#0020#, 16#0002#),
         5371 => (16#3073#, 16#0020#, 16#0002#),
         5372 => (16#3074#, 16#0020#, 16#0002#),
         5373 => (16#3075#, 16#0020#, 16#0002#),
         5374 => (16#3076#, 16#0020#, 16#0002#),
         5375 => (16#3077#, 16#0020#, 16#0002#),
         5376 => (16#3078#, 16#0020#, 16#0002#),
         5377 => (16#3079#, 16#0020#, 16#0002#),
         5378 => (16#307A#, 16#0020#, 16#0002#),
         5379 => (16#307B#, 16#0020#, 16#0002#),
         5380 => (16#307C#, 16#0020#, 16#0002#),
         5381 => (16#307D#, 16#0020#, 16#0002#),
         5382 => (16#307E#, 16#0020#, 16#0002#),
         5383 => (16#307F#, 16#0020#, 16#0002#),
         5384 => (16#3080#, 16#0020#, 16#0002#),
         5385 => (16#3081#, 16#0020#, 16#0002#),
         5386 => (16#3082#, 16#0020#, 16#0002#),
         5387 => (16#3083#, 16#0020#, 16#0002#),
         5388 => (16#3084#, 16#0020#, 16#0002#),
         5389 => (16#3085#, 16#0020#, 16#0002#),
         5390 => (16#3086#, 16#0020#, 16#0002#),
         5391 => (16#3087#, 16#0020#, 16#0002#),
         5392 => (16#3088#, 16#0020#, 16#0002#),
         5393 => (16#3089#, 16#0020#, 16#0002#),
         5394 => (16#308A#, 16#0020#, 16#0002#),
         5395 => (16#308B#, 16#0020#, 16#0002#),
         5396 => (16#308C#, 16#0020#, 16#0002#),
         5397 => (16#308D#, 16#0020#, 16#0002#),
         5398 => (16#308E#, 16#0020#, 16#0002#),
         5399 => (16#308F#, 16#0020#, 16#0002#),
         5400 => (16#3090#, 16#0020#, 16#0002#),
         5401 => (16#3091#, 16#0020#, 16#0002#),
         5402 => (16#3092#, 16#0020#, 16#0002#),
         5403 => (16#3093#, 16#0020#, 16#0002#),
         5404 => (16#3094#, 16#0020#, 16#0002#),
         5405 => (16#3095#, 16#0020#, 16#0002#),
         5406 => (16#3096#, 16#0020#, 16#0002#),
         5407 => (16#3097#, 16#0020#, 16#0002#),
         5408 => (16#3098#, 16#0020#, 16#0002#),
         5409 => (16#3099#, 16#0020#, 16#0002#),
         5410 => (16#309A#, 16#0020#, 16#0002#),
         5411 => (16#309B#, 16#0020#, 16#0002#),
         5412 => (16#309C#, 16#0020#, 16#0002#),
         5413 => (16#309D#, 16#0020#, 16#0002#),
         5414 => (16#309E#, 16#0020#, 16#0002#),
         5415 => (16#309F#, 16#0020#, 16#0002#),
         5416 => (16#30A0#, 16#0020#, 16#0002#),
         5417 => (16#30A1#, 16#0020#, 16#0002#),
         5418 => (16#30A2#, 16#0020#, 16#0002#),
         5419 => (16#30A3#, 16#0020#, 16#0002#),
         5420 => (16#30A4#, 16#0020#, 16#0002#),
         5421 => (16#30A5#, 16#0020#, 16#0002#),
         5422 => (16#30A6#, 16#0020#, 16#0002#),
         5423 => (16#30A7#, 16#0020#, 16#0002#),
         5424 => (16#30A8#, 16#0020#, 16#0002#),
         5425 => (16#30A9#, 16#0020#, 16#0002#),
         5426 => (16#30AA#, 16#0020#, 16#0002#),
         5427 => (16#30AB#, 16#0020#, 16#0002#),
         5428 => (16#30AC#, 16#0020#, 16#0002#),
         5429 => (16#30AD#, 16#0020#, 16#0002#),
         5430 => (16#30AE#, 16#0020#, 16#0002#),
         5431 => (16#30AF#, 16#0020#, 16#0002#),
         5432 => (16#30B0#, 16#0020#, 16#0002#),
         5433 => (16#30B1#, 16#0020#, 16#0002#),
         5434 => (16#30B2#, 16#0020#, 16#0002#),
         5435 => (16#30B3#, 16#0020#, 16#0002#),
         5436 => (16#30B4#, 16#0020#, 16#0002#),
         5437 => (16#30B5#, 16#0020#, 16#0002#),
         5438 => (16#30B6#, 16#0020#, 16#0002#),
         5439 => (16#30B7#, 16#0020#, 16#0002#),
         5440 => (16#30B8#, 16#0020#, 16#0002#),
         5441 => (16#30B9#, 16#0020#, 16#0002#),
         5442 => (16#30BA#, 16#0020#, 16#0002#),
         5443 => (16#30BB#, 16#0020#, 16#0002#),
         5444 => (16#30BC#, 16#0020#, 16#0002#),
         5445 => (16#30BD#, 16#0020#, 16#0002#),
         5446 => (16#30BE#, 16#0020#, 16#0002#),
         5447 => (16#30BF#, 16#0020#, 16#0002#),
         5448 => (16#30C0#, 16#0020#, 16#0002#),
         5449 => (16#30C1#, 16#0020#, 16#0002#),
         5450 => (16#30C2#, 16#0020#, 16#0002#),
         5451 => (16#30C3#, 16#0020#, 16#0002#),
         5452 => (16#30C4#, 16#0020#, 16#0002#),
         5453 => (16#30C5#, 16#0020#, 16#0002#),
         5454 => (16#30C6#, 16#0020#, 16#0002#),
         5455 => (16#30C7#, 16#0020#, 16#0002#),
         5456 => (16#30C8#, 16#0020#, 16#0002#),
         5457 => (16#30C9#, 16#0020#, 16#0002#),
         5458 => (16#30CA#, 16#0020#, 16#0002#),
         5459 => (16#30CB#, 16#0020#, 16#0002#),
         5460 => (16#30CC#, 16#0020#, 16#0002#),
         5461 => (16#30CD#, 16#0020#, 16#0002#),
         5462 => (16#30CE#, 16#0020#, 16#0002#),
         5463 => (16#30CF#, 16#0020#, 16#0002#),
         5464 => (16#30D0#, 16#0020#, 16#0002#),
         5465 => (16#30D1#, 16#0020#, 16#0002#),
         5466 => (16#30D2#, 16#0020#, 16#0002#),
         5467 => (16#30D3#, 16#0020#, 16#0002#),
         5468 => (16#30D4#, 16#0020#, 16#0002#),
         5469 => (16#30D5#, 16#0020#, 16#0002#),
         5470 => (16#30D6#, 16#0020#, 16#0002#),
         5471 => (16#30D7#, 16#0020#, 16#0002#),
         5472 => (16#30D8#, 16#0020#, 16#0002#),
         5473 => (16#30D9#, 16#0020#, 16#0002#),
         5474 => (16#30DA#, 16#0020#, 16#0002#),
         5475 => (16#30DB#, 16#0020#, 16#0002#),
         5476 => (16#30DC#, 16#0020#, 16#0002#),
         5477 => (16#30DD#, 16#0020#, 16#0002#),
         5478 => (16#30DE#, 16#0020#, 16#0002#),
         5479 => (16#30DF#, 16#0020#, 16#0002#),
         5480 => (16#30E0#, 16#0020#, 16#0002#),
         5481 => (16#30E1#, 16#0020#, 16#0002#),
         5482 => (16#30E2#, 16#0020#, 16#0002#),
         5483 => (16#30E3#, 16#0020#, 16#0002#),
         5484 => (16#30E4#, 16#0020#, 16#0002#),
         5485 => (16#30E5#, 16#0020#, 16#0002#),
         5486 => (16#30E6#, 16#0020#, 16#0002#),
         5487 => (16#30E7#, 16#0020#, 16#0002#),
         5488 => (16#30E8#, 16#0020#, 16#0002#),
         5489 => (16#30E9#, 16#0020#, 16#0002#),
         5490 => (16#30EA#, 16#0020#, 16#0002#),
         5491 => (16#30EB#, 16#0020#, 16#0002#),
         5492 => (16#30EC#, 16#0020#, 16#0002#),
         5493 => (16#311F#, 16#0020#, 16#0002#),
         5494 => (16#30ED#, 16#0020#, 16#0002#),
         5495 => (16#30EF#, 16#0020#, 16#0002#),
         5496 => (16#30F0#, 16#0020#, 16#0002#),
         5497 => (16#30F1#, 16#0020#, 16#0002#),
         5498 => (16#30F2#, 16#0020#, 16#0002#),
         5499 => (16#30F3#, 16#0020#, 16#0002#),
         5500 => (16#30F4#, 16#0020#, 16#0002#),
         5501 => (16#30F5#, 16#0020#, 16#0002#),
         5502 => (16#30F6#, 16#0020#, 16#0002#),
         5503 => (16#30F7#, 16#0020#, 16#0002#),
         5504 => (16#30F8#, 16#0020#, 16#0002#),
         5505 => (16#30F9#, 16#0020#, 16#0002#),
         5506 => (16#30FA#, 16#0020#, 16#0002#),
         5507 => (16#30FB#, 16#0020#, 16#0002#),
         5508 => (16#30FC#, 16#0020#, 16#0002#),
         5509 => (16#30FD#, 16#0020#, 16#0002#),
         5510 => (16#30FE#, 16#0020#, 16#0002#),
         5511 => (16#3100#, 16#0020#, 16#0002#),
         5512 => (16#3101#, 16#0020#, 16#0002#),
         5513 => (16#3102#, 16#0020#, 16#0002#),
         5514 => (16#3103#, 16#0020#, 16#0002#),
         5515 => (16#3104#, 16#0020#, 16#0002#),
         5516 => (16#3105#, 16#0020#, 16#0002#),
         5517 => (16#3106#, 16#0020#, 16#0002#),
         5518 => (16#3107#, 16#0020#, 16#0002#),
         5519 => (16#310E#, 16#0020#, 16#0002#),
         5520 => (16#310F#, 16#0020#, 16#0002#),
         5521 => (16#3110#, 16#0020#, 16#0002#),
         5522 => (16#3111#, 16#0020#, 16#0002#),
         5523 => (16#3112#, 16#0020#, 16#0002#),
         5524 => (16#3113#, 16#0020#, 16#0002#),
         5525 => (16#3114#, 16#0020#, 16#0002#),
         5526 => (16#3115#, 16#0020#, 16#0002#),
         5527 => (16#3116#, 16#0020#, 16#0002#),
         5528 => (16#3117#, 16#0020#, 16#0002#),
         5529 => (16#3118#, 16#0020#, 16#0002#),
         5530 => (16#3119#, 16#0020#, 16#0002#),
         5531 => (16#311A#, 16#0020#, 16#0002#),
         5532 => (16#311B#, 16#0020#, 16#0002#),
         5533 => (16#311C#, 16#0020#, 16#0002#),
         5534 => (16#311D#, 16#0020#, 16#0002#),
         5535 => (16#311E#, 16#0020#, 16#0002#),
         5536 => (16#3120#, 16#0020#, 16#0002#),
         5537 => (16#3121#, 16#0020#, 16#0002#),
         5538 => (16#3122#, 16#0020#, 16#0002#),
         5539 => (16#3123#, 16#0020#, 16#0002#),
         5540 => (16#3124#, 16#0020#, 16#0002#),
         5541 => (16#3125#, 16#0020#, 16#0002#),
         5542 => (16#3126#, 16#0020#, 16#0002#),
         5543 => (16#3127#, 16#0020#, 16#0002#),
         5544 => (16#3128#, 16#0020#, 16#0002#),
         5545 => (16#3129#, 16#0020#, 16#0002#),
         5546 => (16#312A#, 16#0020#, 16#0002#),
         5547 => (16#312B#, 16#0020#, 16#0002#),
         5548 => (16#312C#, 16#0020#, 16#0002#),
         5549 => (16#312D#, 16#0020#, 16#0002#),
         5550 => (16#312E#, 16#0020#, 16#0002#),
         5551 => (16#312F#, 16#0020#, 16#0002#),
         5552 => (16#3130#, 16#0020#, 16#0002#),
         5553 => (16#3131#, 16#0020#, 16#0002#),
         5554 => (16#3132#, 16#0020#, 16#0002#),
         5555 => (16#3133#, 16#0020#, 16#0002#),
         5556 => (16#3134#, 16#0020#, 16#0002#),
         5557 => (16#3135#, 16#0020#, 16#0002#),
         5558 => (16#3136#, 16#0020#, 16#0002#),
         5559 => (16#3137#, 16#0020#, 16#0002#),
         5560 => (16#3138#, 16#0020#, 16#0002#),
         5561 => (16#3139#, 16#0020#, 16#0002#),
         5562 => (16#313A#, 16#0020#, 16#0002#),
         5563 => (16#313B#, 16#0020#, 16#0002#),
         5564 => (16#313C#, 16#0020#, 16#0002#),
         5565 => (16#313D#, 16#0020#, 16#0002#),
         5566 => (16#313E#, 16#0020#, 16#0002#),
         5567 => (16#313F#, 16#0020#, 16#0002#),
         5568 => (16#3140#, 16#0020#, 16#0002#),
         5569 => (16#3141#, 16#0020#, 16#0002#),
         5570 => (16#3142#, 16#0020#, 16#0002#),
         5571 => (16#3143#, 16#0020#, 16#0002#),
         5572 => (16#3144#, 16#0020#, 16#0002#),
         5573 => (16#3145#, 16#0020#, 16#0002#),
         5574 => (16#3146#, 16#0020#, 16#0002#),
         5575 => (16#3147#, 16#0020#, 16#0002#),
         5576 => (16#3148#, 16#0020#, 16#0002#),
         5577 => (16#3149#, 16#0020#, 16#0002#),
         5578 => (16#314A#, 16#0020#, 16#0002#),
         5579 => (16#314B#, 16#0020#, 16#0002#),
         5580 => (16#314C#, 16#0020#, 16#0002#),
         5581 => (16#314D#, 16#0020#, 16#0002#),
         5582 => (16#314E#, 16#0020#, 16#0002#),
         5583 => (16#314F#, 16#0020#, 16#0002#),
         5584 => (16#3150#, 16#0020#, 16#0002#),
         5585 => (16#3151#, 16#0020#, 16#0002#),
         5586 => (16#3152#, 16#0020#, 16#0002#),
         5587 => (16#3153#, 16#0020#, 16#0002#),
         5588 => (16#3154#, 16#0020#, 16#0002#),
         5589 => (16#3155#, 16#0020#, 16#0002#),
         5590 => (16#3156#, 16#0020#, 16#0002#),
         5591 => (16#3157#, 16#0020#, 16#0002#),
         5592 => (16#3158#, 16#0020#, 16#0002#),
         5593 => (16#3159#, 16#0020#, 16#0002#),
         5594 => (16#315A#, 16#0020#, 16#0002#),
         5595 => (16#315B#, 16#0020#, 16#0002#),
         5596 => (16#315C#, 16#0020#, 16#0002#),
         5597 => (16#315D#, 16#0020#, 16#0002#),
         5598 => (16#315E#, 16#0020#, 16#0002#),
         5599 => (16#315F#, 16#0020#, 16#0002#),
         5600 => (16#3160#, 16#0020#, 16#0002#),
         5601 => (16#3161#, 16#0020#, 16#0002#),
         5602 => (16#3162#, 16#0020#, 16#0002#),
         5603 => (16#3163#, 16#0020#, 16#0002#),
         5604 => (16#3164#, 16#0020#, 16#0002#),
         5605 => (16#3165#, 16#0020#, 16#0002#),
         5606 => (16#3166#, 16#0020#, 16#0002#),
         5607 => (16#3167#, 16#0020#, 16#0002#),
         5608 => (16#3168#, 16#0020#, 16#0002#),
         5609 => (16#3169#, 16#0020#, 16#0002#),
         5610 => (16#316A#, 16#0020#, 16#0002#),
         5611 => (16#316B#, 16#0020#, 16#0002#),
         5612 => (16#316C#, 16#0020#, 16#0002#),
         5613 => (16#316D#, 16#0020#, 16#0002#),
         5614 => (16#316E#, 16#0020#, 16#0002#),
         5615 => (16#316F#, 16#0020#, 16#0002#),
         5616 => (16#3170#, 16#0020#, 16#0002#),
         5617 => (16#3171#, 16#0020#, 16#0002#),
         5618 => (16#3172#, 16#0020#, 16#0002#),
         5619 => (16#3173#, 16#0020#, 16#0002#),
         5620 => (16#3174#, 16#0020#, 16#0002#),
         5621 => (16#3175#, 16#0020#, 16#0002#),
         5622 => (16#3176#, 16#0020#, 16#0002#),
         5623 => (16#3177#, 16#0020#, 16#0002#),
         5624 => (16#3178#, 16#0020#, 16#0002#),
         5625 => (16#3179#, 16#0020#, 16#0002#),
         5626 => (16#317A#, 16#0020#, 16#0002#),
         5627 => (16#317B#, 16#0020#, 16#0002#),
         5628 => (16#317C#, 16#0020#, 16#0002#),
         5629 => (16#317D#, 16#0020#, 16#0002#),
         5630 => (16#317E#, 16#0020#, 16#0002#),
         5631 => (16#317F#, 16#0020#, 16#0002#),
         5632 => (16#3180#, 16#0020#, 16#0002#),
         5633 => (16#3181#, 16#0020#, 16#0002#),
         5634 => (16#3182#, 16#0020#, 16#0002#),
         5635 => (16#3183#, 16#0020#, 16#0002#),
         5636 => (16#3184#, 16#0020#, 16#0002#),
         5637 => (16#3185#, 16#0020#, 16#0002#),
         5638 => (16#3186#, 16#0020#, 16#0002#),
         5639 => (16#3187#, 16#0020#, 16#0002#),
         5640 => (16#3188#, 16#0020#, 16#0002#),
         5641 => (16#3189#, 16#0020#, 16#0002#),
         5642 => (16#318A#, 16#0020#, 16#0002#),
         5643 => (16#318B#, 16#0020#, 16#0002#),
         5644 => (16#318C#, 16#0020#, 16#0002#),
         5645 => (16#318D#, 16#0020#, 16#0002#),
         5646 => (16#318E#, 16#0020#, 16#0002#),
         5647 => (16#318F#, 16#0020#, 16#0002#),
         5648 => (16#3190#, 16#0020#, 16#0002#),
         5649 => (16#3191#, 16#0020#, 16#0002#),
         5650 => (16#3192#, 16#0020#, 16#0002#),
         5651 => (16#3193#, 16#0020#, 16#0002#),
         5652 => (16#3194#, 16#0020#, 16#0002#),
         5653 => (16#3195#, 16#0020#, 16#0002#),
         5654 => (16#3196#, 16#0020#, 16#0002#),
         5655 => (16#3197#, 16#0020#, 16#0002#),
         5656 => (16#3198#, 16#0020#, 16#0002#),
         5657 => (16#3199#, 16#0020#, 16#0002#),
         5658 => (16#319A#, 16#0020#, 16#0002#),
         5659 => (16#319B#, 16#0020#, 16#0002#),
         5660 => (16#319C#, 16#0020#, 16#0002#),
         5661 => (16#319D#, 16#0020#, 16#0002#),
         5662 => (16#319E#, 16#0020#, 16#0002#),
         5663 => (16#319F#, 16#0020#, 16#0002#),
         5664 => (16#31A0#, 16#0020#, 16#0002#),
         5665 => (16#31A1#, 16#0020#, 16#0002#),
         5666 => (16#31A2#, 16#0020#, 16#0002#),
         5667 => (16#31A3#, 16#0020#, 16#0002#),
         5668 => (16#31A4#, 16#0020#, 16#0002#),
         5669 => (16#31A5#, 16#0020#, 16#0002#),
         5670 => (16#31A6#, 16#0020#, 16#0002#),
         5671 => (16#31A7#, 16#0020#, 16#0002#),
         5672 => (16#31A8#, 16#0020#, 16#0002#),
         5673 => (16#31A9#, 16#0020#, 16#0002#),
         5674 => (16#31AA#, 16#0020#, 16#0002#),
         5675 => (16#31AB#, 16#0020#, 16#0002#),
         5676 => (16#31AC#, 16#0020#, 16#0002#),
         5677 => (16#31AD#, 16#0020#, 16#0002#),
         5678 => (16#31AE#, 16#0020#, 16#0002#),
         5679 => (16#31AF#, 16#0020#, 16#0002#),
         5680 => (16#31B0#, 16#0020#, 16#0002#),
         5681 => (16#31B1#, 16#0020#, 16#0002#),
         5682 => (16#31B2#, 16#0020#, 16#0002#),
         5683 => (16#31B3#, 16#0020#, 16#0002#),
         5684 => (16#31B4#, 16#0020#, 16#0002#),
         5685 => (16#31B5#, 16#0020#, 16#0002#),
         5686 => (16#31B6#, 16#0020#, 16#0002#),
         5687 => (16#31B7#, 16#0020#, 16#0002#),
         5688 => (16#31B8#, 16#0020#, 16#0002#),
         5689 => (16#31B9#, 16#0020#, 16#0002#),
         5690 => (16#31BA#, 16#0020#, 16#0002#),
         5691 => (16#31BB#, 16#0020#, 16#0002#),
         5692 => (16#31BC#, 16#0020#, 16#0002#),
         5693 => (16#31BD#, 16#0020#, 16#0002#),
         5694 => (16#31BE#, 16#0020#, 16#0002#),
         5695 => (16#31BF#, 16#0020#, 16#0002#),
         5696 => (16#31C0#, 16#0020#, 16#0002#),
         5697 => (16#31C1#, 16#0020#, 16#0002#),
         5698 => (16#31C2#, 16#0020#, 16#0002#),
         5699 => (16#31C3#, 16#0020#, 16#0002#),
         5700 => (16#31C4#, 16#0020#, 16#0002#),
         5701 => (16#31C5#, 16#0020#, 16#0002#),
         5702 => (16#31C6#, 16#0020#, 16#0002#),
         5703 => (16#31C7#, 16#0020#, 16#0002#),
         5704 => (16#31C8#, 16#0020#, 16#0002#),
         5705 => (16#31C9#, 16#0020#, 16#0002#),
         5706 => (16#31CA#, 16#0020#, 16#0002#),
         5707 => (16#31CB#, 16#0020#, 16#0002#),
         5708 => (16#31CC#, 16#0020#, 16#0002#),
         5709 => (16#31CD#, 16#0020#, 16#0002#),
         5710 => (16#31CE#, 16#0020#, 16#0002#),
         5711 => (16#31CF#, 16#0020#, 16#0002#),
         5712 => (16#31D0#, 16#0020#, 16#0002#),
         5713 => (16#31D1#, 16#0020#, 16#0002#),
         5714 => (16#31D2#, 16#0020#, 16#0002#),
         5715 => (16#31D3#, 16#0020#, 16#0002#),
         5716 => (16#31D4#, 16#0020#, 16#0002#),
         5717 => (16#31D5#, 16#0020#, 16#0002#),
         5718 => (16#31D6#, 16#0020#, 16#0002#),
         5719 => (16#31D7#, 16#0020#, 16#0002#),
         5720 => (16#31D8#, 16#0020#, 16#0002#),
         5721 => (16#31D9#, 16#0020#, 16#0002#),
         5722 => (16#31DA#, 16#0020#, 16#0002#),
         5723 => (16#31DB#, 16#0020#, 16#0002#),
         5724 => (16#31DC#, 16#0020#, 16#0002#),
         5725 => (16#31DD#, 16#0020#, 16#0002#),
         5726 => (16#31DE#, 16#0020#, 16#0002#),
         5727 => (16#31DF#, 16#0020#, 16#0002#),
         5728 => (16#31E0#, 16#0020#, 16#0002#),
         5729 => (16#31E1#, 16#0020#, 16#0002#),
         5730 => (16#31E2#, 16#0020#, 16#0002#),
         5731 => (16#31E3#, 16#0020#, 16#0002#),
         5732 => (16#31E4#, 16#0020#, 16#0002#),
         5733 => (16#31E5#, 16#0020#, 16#0002#),
         5734 => (16#02FF#, 16#0020#, 16#0002#),
         5735 => (16#017B#, 16#0020#, 16#0002#),
         5736 => (16#30EE#, 16#0020#, 16#0002#),
         5737 => (16#30FF#, 16#0020#, 16#0002#),
         5738 => (16#3108#, 16#0020#, 16#0002#),
         5739 => (16#3109#, 16#0020#, 16#0002#),
         5740 => (16#310A#, 16#0020#, 16#0002#),
         5741 => (16#310B#, 16#0020#, 16#0002#),
         5742 => (16#310C#, 16#0020#, 16#0002#),
         5743 => (16#310D#, 16#0020#, 16#0002#),
         5744 => (16#31E6#, 16#0020#, 16#0002#),
         5745 => (16#31E7#, 16#0020#, 16#0002#),
         5746 => (16#31E8#, 16#0020#, 16#0002#),
         5747 => (16#31E9#, 16#0020#, 16#0002#),
         5748 => (16#31EA#, 16#0020#, 16#0002#),
         5749 => (16#31EB#, 16#0020#, 16#0002#),
         5750 => (16#31EC#, 16#0020#, 16#0002#),
         5751 => (16#31ED#, 16#0020#, 16#0002#),
         5752 => (16#31EE#, 16#0020#, 16#0002#),
         5753 => (16#0108#, 16#0020#, 16#0004#),
         5754 => (16#3235#, 16#0020#, 16#0002#),
         5755 => (16#3236#, 16#0020#, 16#0002#),
         5756 => (16#3237#, 16#0020#, 16#0002#),
         5757 => (16#3238#, 16#0020#, 16#0002#),
         5758 => (16#3239#, 16#0020#, 16#0002#),
         5759 => (16#323A#, 16#0020#, 16#0002#),
         5760 => (16#323B#, 16#0020#, 16#0002#),
         5761 => (16#323C#, 16#0020#, 16#0002#),
         5762 => (16#323D#, 16#0020#, 16#0002#),
         5763 => (16#323E#, 16#0020#, 16#0002#),
         5764 => (16#323F#, 16#0020#, 16#0002#),
         5765 => (16#3240#, 16#0020#, 16#0002#),
         5766 => (16#3241#, 16#0020#, 16#0002#),
         5767 => (16#3242#, 16#0020#, 16#0002#),
         5768 => (16#3243#, 16#0020#, 16#0002#),
         5769 => (16#3244#, 16#0020#, 16#0002#),
         5770 => (16#3245#, 16#0020#, 16#0002#),
         5771 => (16#3246#, 16#0020#, 16#0002#),
         5772 => (16#3247#, 16#0020#, 16#0002#),
         5773 => (16#3248#, 16#0020#, 16#0002#),
         5774 => (16#3249#, 16#0020#, 16#0002#),
         5775 => (16#324A#, 16#0020#, 16#0002#),
         5776 => (16#324B#, 16#0020#, 16#0002#),
         5777 => (16#324C#, 16#0020#, 16#0002#),
         5778 => (16#324D#, 16#0020#, 16#0002#),
         5779 => (16#324E#, 16#0020#, 16#0002#),
         5780 => (16#0213#, 16#0020#, 16#0002#),
         5781 => (16#0214#, 16#0020#, 16#0002#),
         5782 => (16#324F#, 16#0020#, 16#0002#),
         5783 => (16#324F#, 16#0020#, 16#0004#),
         5784 => (16#0000#, 16#0108#, 16#0004#),
         5785 => (16#3250#, 16#0020#, 16#0002#),
         5786 => (16#3274#, 16#0020#, 16#0002#),
         5787 => (16#3250#, 16#0020#, 16#0004#),
         5788 => (16#0000#, 16#0108#, 16#0004#),
         5789 => (16#3250#, 16#0020#, 16#0004#),
         5790 => (16#0000#, 16#0109#, 16#0004#),
         5791 => (16#3251#, 16#0020#, 16#0002#),
         5792 => (16#3251#, 16#0020#, 16#0004#),
         5793 => (16#0000#, 16#0108#, 16#0004#),
         5794 => (16#3252#, 16#0020#, 16#0002#),
         5795 => (16#3252#, 16#0020#, 16#0004#),
         5796 => (16#0000#, 16#0108#, 16#0004#),
         5797 => (16#3270#, 16#0020#, 16#0002#),
         5798 => (16#3272#, 16#0020#, 16#0002#),
         5799 => (16#3252#, 16#0020#, 16#0004#),
         5800 => (16#0000#, 16#0109#, 16#0004#),
         5801 => (16#3252#, 16#0020#, 16#0004#),
         5802 => (16#0000#, 16#010A#, 16#0004#),
         5803 => (16#3252#, 16#0020#, 16#0004#),
         5804 => (16#0000#, 16#010B#, 16#0004#),
         5805 => (16#3254#, 16#0020#, 16#0002#),
         5806 => (16#3255#, 16#0020#, 16#0002#),
         5807 => (16#3256#, 16#0020#, 16#0002#),
         5808 => (16#3257#, 16#0020#, 16#0002#),
         5809 => (16#3257#, 16#0020#, 16#0004#),
         5810 => (16#0000#, 16#0108#, 16#0004#),
         5811 => (16#3257#, 16#0020#, 16#0004#),
         5812 => (16#0000#, 16#0109#, 16#0004#),
         5813 => (16#3257#, 16#0020#, 16#0004#),
         5814 => (16#0000#, 16#010A#, 16#0004#),
         5815 => (16#3257#, 16#0020#, 16#0004#),
         5816 => (16#0000#, 16#010B#, 16#0004#),
         5817 => (16#3259#, 16#0020#, 16#0002#),
         5818 => (16#3277#, 16#0020#, 16#0002#),
         5819 => (16#325A#, 16#0020#, 16#0002#),
         5820 => (16#325B#, 16#0020#, 16#0002#),
         5821 => (16#325B#, 16#0020#, 16#0004#),
         5822 => (16#0000#, 16#0108#, 16#0004#),
         5823 => (16#325B#, 16#0020#, 16#0004#),
         5824 => (16#0000#, 16#0109#, 16#0004#),
         5825 => (16#325B#, 16#0020#, 16#0004#),
         5826 => (16#0000#, 16#010A#, 16#0004#),
         5827 => (16#325C#, 16#0020#, 16#0002#),
         5828 => (16#325C#, 16#0020#, 16#0004#),
         5829 => (16#0000#, 16#0108#, 16#0004#),
         5830 => (16#325C#, 16#0020#, 16#0004#),
         5831 => (16#0000#, 16#0109#, 16#0004#),
         5832 => (16#325D#, 16#0020#, 16#0002#),
         5833 => (16#325D#, 16#0020#, 16#0004#),
         5834 => (16#0000#, 16#0108#, 16#0004#),
         5835 => (16#325F#, 16#0020#, 16#0002#),
         5836 => (16#325F#, 16#0020#, 16#0004#),
         5837 => (16#0000#, 16#0108#, 16#0004#),
         5838 => (16#3260#, 16#0020#, 16#0002#),
         5839 => (16#3260#, 16#0020#, 16#0004#),
         5840 => (16#0000#, 16#0108#, 16#0004#),
         5841 => (16#3261#, 16#0020#, 16#0002#),
         5842 => (16#3262#, 16#0020#, 16#0002#),
         5843 => (16#3263#, 16#0020#, 16#0002#),
         5844 => (16#3264#, 16#0020#, 16#0002#),
         5845 => (16#3264#, 16#0020#, 16#0004#),
         5846 => (16#0000#, 16#0108#, 16#0004#),
         5847 => (16#3264#, 16#0020#, 16#0004#),
         5848 => (16#0000#, 16#010A#, 16#0004#),
         5849 => (16#3264#, 16#0020#, 16#0004#),
         5850 => (16#0000#, 16#010B#, 16#0004#),
         5851 => (16#3264#, 16#0020#, 16#0004#),
         5852 => (16#0000#, 16#010C#, 16#0004#),
         5853 => (16#3266#, 16#0020#, 16#0002#),
         5854 => (16#3266#, 16#0020#, 16#0004#),
         5855 => (16#0000#, 16#0108#, 16#0004#),
         5856 => (16#3266#, 16#0020#, 16#0004#),
         5857 => (16#0000#, 16#0109#, 16#0004#),
         5858 => (16#3267#, 16#0020#, 16#0002#),
         5859 => (16#3267#, 16#0020#, 16#0004#),
         5860 => (16#0000#, 16#0108#, 16#0004#),
         5861 => (16#3267#, 16#0020#, 16#0004#),
         5862 => (16#0000#, 16#0109#, 16#0004#),
         5863 => (16#3262#, 16#0020#, 16#0004#),
         5864 => (16#0000#, 16#0108#, 16#0004#),
         5865 => (16#3268#, 16#0020#, 16#0002#),
         5866 => (16#326A#, 16#0020#, 16#0002#),
         5867 => (16#326A#, 16#0020#, 16#0004#),
         5868 => (16#0000#, 16#0108#, 16#0004#),
         5869 => (16#326A#, 16#0020#, 16#0004#),
         5870 => (16#0000#, 16#0109#, 16#0004#),
         5871 => (16#326B#, 16#0020#, 16#0002#),
         5872 => (16#326B#, 16#0020#, 16#0004#),
         5873 => (16#0000#, 16#0108#, 16#0004#),
         5874 => (16#326C#, 16#0020#, 16#0002#),
         5875 => (16#326C#, 16#0020#, 16#0004#),
         5876 => (16#0000#, 16#0108#, 16#0004#),
         5877 => (16#326D#, 16#0020#, 16#0002#),
         5878 => (16#326E#, 16#0020#, 16#0002#),
         5879 => (16#3275#, 16#0020#, 16#0002#),
         5880 => (16#3279#, 16#0020#, 16#0002#),
         5881 => (16#327A#, 16#0020#, 16#0002#),
         5882 => (16#3276#, 16#0020#, 16#0002#),
         5883 => (16#3278#, 16#0020#, 16#0002#),
         5884 => (16#327B#, 16#0020#, 16#0002#),
         5885 => (16#327C#, 16#0020#, 16#0002#),
         5886 => (16#327C#, 16#0020#, 16#0004#),
         5887 => (16#0000#, 16#0108#, 16#0004#),
         5888 => (16#327C#, 16#0020#, 16#0004#),
         5889 => (16#0000#, 16#0109#, 16#0004#),
         5890 => (16#325A#, 16#0020#, 16#0004#),
         5891 => (16#0000#, 16#0108#, 16#0004#),
         5892 => (16#3264#, 16#0020#, 16#0004#),
         5893 => (16#0000#, 16#0109#, 16#0004#),
         5894 => (16#015A#, 16#0020#, 16#0002#),
         5895 => (16#015B#, 16#0020#, 16#0002#),
         5896 => (16#015C#, 16#0020#, 16#0002#),
         5897 => (16#3260#, 16#0020#, 16#0004#),
         5898 => (16#326B#, 16#0020#, 16#0004#),
         5899 => (16#326A#, 16#0020#, 16#0004#),
         5900 => (16#0000#, 16#0108#, 16#0004#),
         5901 => (16#326A#, 16#0020#, 16#0004#),
         5902 => (16#0000#, 16#0108#, 16#0004#),
         5903 => (16#3251#, 16#0020#, 16#0004#),
         5904 => (16#3251#, 16#0020#, 16#0004#),
         5905 => (16#3258#, 16#0020#, 16#0002#),
         5906 => (16#3265#, 16#0020#, 16#0002#),
         5907 => (16#326F#, 16#0020#, 16#0002#),
         5908 => (16#3253#, 16#0020#, 16#0002#),
         5909 => (16#325E#, 16#0020#, 16#0002#),
         5910 => (16#3269#, 16#0020#, 16#0002#),
         5911 => (16#3271#, 16#0020#, 16#0002#),
         5912 => (16#3273#, 16#0020#, 16#0002#),
         5913 => (16#2B04#, 16#0020#, 16#0002#),
         5914 => (16#2B05#, 16#0020#, 16#0002#),
         5915 => (16#2B06#, 16#0020#, 16#0002#),
         5916 => (16#2B07#, 16#0020#, 16#0002#),
         5917 => (16#2B08#, 16#0020#, 16#0002#),
         5918 => (16#2B09#, 16#0020#, 16#0002#),
         5919 => (16#2B0A#, 16#0020#, 16#0002#),
         5920 => (16#2B0B#, 16#0020#, 16#0002#),
         5921 => (16#2B0C#, 16#0020#, 16#0002#),
         5922 => (16#2B0D#, 16#0020#, 16#0002#),
         5923 => (16#2B0E#, 16#0020#, 16#0002#),
         5924 => (16#2B0F#, 16#0020#, 16#0002#),
         5925 => (16#2B10#, 16#0020#, 16#0002#),
         5926 => (16#2B11#, 16#0020#, 16#0002#),
         5927 => (16#2B12#, 16#0020#, 16#0002#),
         5928 => (16#2B13#, 16#0020#, 16#0002#),
         5929 => (16#2B14#, 16#0020#, 16#0002#),
         5930 => (16#2B15#, 16#0020#, 16#0002#),
         5931 => (16#2B16#, 16#0020#, 16#0002#),
         5932 => (16#2B17#, 16#0020#, 16#0002#),
         5933 => (16#2B18#, 16#0020#, 16#0002#),
         5934 => (16#2B19#, 16#0020#, 16#0002#),
         5935 => (16#2B1A#, 16#0020#, 16#0002#),
         5936 => (16#2B1B#, 16#0020#, 16#0002#),
         5937 => (16#2B1C#, 16#0020#, 16#0002#),
         5938 => (16#2B1D#, 16#0020#, 16#0002#),
         5939 => (16#2B1E#, 16#0020#, 16#0002#),
         5940 => (16#2B1F#, 16#0020#, 16#0002#),
         5941 => (16#2B20#, 16#0020#, 16#0002#),
         5942 => (16#2B21#, 16#0020#, 16#0002#),
         5943 => (16#2B22#, 16#0020#, 16#0002#),
         5944 => (16#2B23#, 16#0020#, 16#0002#),
         5945 => (16#2B24#, 16#0020#, 16#0002#),
         5946 => (16#2B25#, 16#0020#, 16#0002#),
         5947 => (16#2B26#, 16#0020#, 16#0002#),
         5948 => (16#2B27#, 16#0020#, 16#0002#),
         5949 => (16#2B28#, 16#0020#, 16#0002#),
         5950 => (16#2B29#, 16#0020#, 16#0002#),
         5951 => (16#2B2A#, 16#0020#, 16#0002#),
         5952 => (16#2B2B#, 16#0020#, 16#0002#),
         5953 => (16#2B2C#, 16#0020#, 16#0002#),
         5954 => (16#0192#, 16#0020#, 16#0002#),
         5955 => (16#0193#, 16#0020#, 16#0002#),
         5956 => (16#2B2D#, 16#0020#, 16#0002#),
         5957 => (16#2B2E#, 16#0020#, 16#0002#),
         5958 => (16#2B2F#, 16#0020#, 16#0002#),
         5959 => (16#2B30#, 16#0020#, 16#0002#),
         5960 => (16#2B31#, 16#0020#, 16#0002#),
         5961 => (16#2B32#, 16#0020#, 16#0002#),
         5962 => (16#2B33#, 16#0020#, 16#0002#),
         5963 => (16#2B34#, 16#0020#, 16#0002#),
         5964 => (16#2B35#, 16#0020#, 16#0002#),
         5965 => (16#2B36#, 16#0020#, 16#0002#),
         5966 => (16#2B37#, 16#0020#, 16#0002#),
         5967 => (16#2B38#, 16#0020#, 16#0002#),
         5968 => (16#2B39#, 16#0020#, 16#0002#),
         5969 => (16#2B3A#, 16#0020#, 16#0002#),
         5970 => (16#2B3B#, 16#0020#, 16#0002#),
         5971 => (16#2B3C#, 16#0020#, 16#0002#),
         5972 => (16#2B3D#, 16#0020#, 16#0002#),
         5973 => (16#2B3E#, 16#0020#, 16#0002#),
         5974 => (16#2B3F#, 16#0020#, 16#0002#),
         5975 => (16#2B40#, 16#0020#, 16#0002#),
         5976 => (16#2B41#, 16#0020#, 16#0002#),
         5977 => (16#2B42#, 16#0020#, 16#0002#),
         5978 => (16#2B43#, 16#0020#, 16#0002#),
         5979 => (16#2B44#, 16#0020#, 16#0002#),
         5980 => (16#2B45#, 16#0020#, 16#0002#),
         5981 => (16#2B46#, 16#0020#, 16#0002#),
         5982 => (16#2B47#, 16#0020#, 16#0002#),
         5983 => (16#2B48#, 16#0020#, 16#0002#),
         5984 => (16#2B49#, 16#0020#, 16#0002#),
         5985 => (16#2B4A#, 16#0020#, 16#0002#),
         5986 => (16#2B4B#, 16#0020#, 16#0002#),
         5987 => (16#2B4C#, 16#0020#, 16#0002#),
         5988 => (16#2B4D#, 16#0020#, 16#0002#),
         5989 => (16#2B4E#, 16#0020#, 16#0002#),
         5990 => (16#2B4F#, 16#0020#, 16#0002#),
         5991 => (16#2B50#, 16#0020#, 16#0002#),
         5992 => (16#2B51#, 16#0020#, 16#0002#),
         5993 => (16#2B52#, 16#0020#, 16#0002#),
         5994 => (16#2CB4#, 16#0020#, 16#0002#),
         5995 => (16#2CB5#, 16#0020#, 16#0002#),
         5996 => (16#2CB6#, 16#0020#, 16#0002#),
         5997 => (16#2CB7#, 16#0020#, 16#0002#),
         5998 => (16#2CB8#, 16#0020#, 16#0002#),
         5999 => (16#2CB9#, 16#0020#, 16#0002#),
         6000 => (16#2CBA#, 16#0020#, 16#0002#),
         6001 => (16#2CBB#, 16#0020#, 16#0002#),
         6002 => (16#2CBC#, 16#0020#, 16#0002#),
         6003 => (16#2CBD#, 16#0020#, 16#0002#),
         6004 => (16#2CBE#, 16#0020#, 16#0002#),
         6005 => (16#2CBF#, 16#0020#, 16#0002#),
         6006 => (16#2CC0#, 16#0020#, 16#0002#),
         6007 => (16#2CC1#, 16#0020#, 16#0002#),
         6008 => (16#2CC2#, 16#0020#, 16#0002#),
         6009 => (16#2CC3#, 16#0020#, 16#0002#),
         6010 => (16#2CC4#, 16#0020#, 16#0002#),
         6011 => (16#2CC5#, 16#0020#, 16#0002#),
         6012 => (16#2CC6#, 16#0020#, 16#0002#),
         6013 => (16#2CC7#, 16#0020#, 16#0002#),
         6014 => (16#2CC8#, 16#0020#, 16#0002#),
         6015 => (16#2CC9#, 16#0020#, 16#0002#),
         6016 => (16#2CCA#, 16#0020#, 16#0002#),
         6017 => (16#2CCB#, 16#0020#, 16#0002#),
         6018 => (16#2CCC#, 16#0020#, 16#0002#),
         6019 => (16#2CCD#, 16#0020#, 16#0002#),
         6020 => (16#2CCE#, 16#0020#, 16#0002#),
         6021 => (16#2CCF#, 16#0020#, 16#0002#),
         6022 => (16#2CD0#, 16#0020#, 16#0002#),
         6023 => (16#2CD1#, 16#0020#, 16#0002#),
         6024 => (16#2CD2#, 16#0020#, 16#0002#),
         6025 => (16#2CD3#, 16#0020#, 16#0002#),
         6026 => (16#2CD4#, 16#0020#, 16#0002#),
         6027 => (16#2CD5#, 16#0020#, 16#0002#),
         6028 => (16#2CD6#, 16#0020#, 16#0002#),
         6029 => (16#2CD8#, 16#0020#, 16#0002#),
         6030 => (16#2CD9#, 16#0020#, 16#0002#),
         6031 => (16#2CDA#, 16#0020#, 16#0002#),
         6032 => (16#2CDB#, 16#0020#, 16#0002#),
         6033 => (16#2CDC#, 16#0020#, 16#0002#),
         6034 => (16#2CDD#, 16#0020#, 16#0002#),
         6035 => (16#2CDE#, 16#0020#, 16#0002#),
         6036 => (16#2CDF#, 16#0020#, 16#0002#),
         6037 => (16#2CE0#, 16#0020#, 16#0002#),
         6038 => (16#2CE1#, 16#0020#, 16#0002#),
         6039 => (16#2CE2#, 16#0020#, 16#0002#),
         6040 => (16#2CE3#, 16#0020#, 16#0002#),
         6041 => (16#2CE4#, 16#0020#, 16#0002#),
         6042 => (16#2CE5#, 16#0020#, 16#0002#),
         6043 => (16#2CE6#, 16#0020#, 16#0002#),
         6044 => (16#2CE7#, 16#0020#, 16#0002#),
         6045 => (16#2CE8#, 16#0020#, 16#0002#),
         6046 => (16#2CE9#, 16#0020#, 16#0002#),
         6047 => (16#2CEA#, 16#0020#, 16#0002#),
         6048 => (16#2CEB#, 16#0020#, 16#0002#),
         6049 => (16#2CEC#, 16#0020#, 16#0002#),
         6050 => (16#2CED#, 16#0020#, 16#0002#),
         6051 => (16#2CEE#, 16#0020#, 16#0002#),
         6052 => (16#2CEF#, 16#0020#, 16#0002#),
         6053 => (16#2CF0#, 16#0020#, 16#0002#),
         6054 => (16#2CF1#, 16#0020#, 16#0002#),
         6055 => (16#2CF2#, 16#0020#, 16#0002#),
         6056 => (16#2CF3#, 16#0020#, 16#0002#),
         6057 => (16#2CF4#, 16#0020#, 16#0002#),
         6058 => (16#2CF5#, 16#0020#, 16#0002#),
         6059 => (16#2CF6#, 16#0020#, 16#0002#),
         6060 => (16#2CF7#, 16#0020#, 16#0002#),
         6061 => (16#2CF8#, 16#0020#, 16#0002#),
         6062 => (16#0000#, 16#00DE#, 16#0002#),
         6063 => (16#0000#, 16#00DF#, 16#0002#),
         6064 => (16#0000#, 16#00E0#, 16#0002#),
         6065 => (16#2CF9#, 16#0020#, 16#0002#),
         6066 => (16#0197#, 16#0020#, 16#0002#),
         6067 => (16#0198#, 16#0020#, 16#0002#),
         6068 => (16#0157#, 16#0020#, 16#0002#),
         6069 => (16#16B6#, 16#0020#, 16#0002#),
         6070 => (16#02F3#, 16#0020#, 16#0002#),
         6071 => (16#02F4#, 16#0020#, 16#0002#),
         6072 => (16#02F5#, 16#0020#, 16#0002#),
         6073 => (16#16D6#, 16#0020#, 16#0002#),
         6074 => (16#2CD7#, 16#0020#, 16#0002#),
         6075 => (16#02CA#, 16#0020#, 16#0002#),
         6076 => (16#0174#, 16#0020#, 16#0002#),
         6077 => (16#012A#, 16#0020#, 16#0002#),
         6078 => (16#0179#, 16#0020#, 16#0002#),
         6079 => (16#0154#, 16#0020#, 16#0002#),
         6080 => (16#0155#, 16#0020#, 16#0002#),
         6081 => (16#0110#, 16#0020#, 16#0002#),
         6082 => (16#0111#, 16#0020#, 16#0002#),
         6083 => (16#012B#, 16#0020#, 16#0002#),
         6084 => (16#017A#, 16#0020#, 16#0002#),
         6085 => (16#2E7E#, 16#0020#, 16#0002#),
         6086 => (16#2E80#, 16#0020#, 16#0002#),
         6087 => (16#2E83#, 16#0020#, 16#0002#),
         6088 => (16#2E89#, 16#0020#, 16#0002#),
         6089 => (16#2E8B#, 16#0020#, 16#0002#),
         6090 => (16#2E8E#, 16#0020#, 16#0002#),
         6091 => (16#2E90#, 16#0020#, 16#0002#),
         6092 => (16#2E93#, 16#0020#, 16#0002#),
         6093 => (16#2E94#, 16#0020#, 16#0002#),
         6094 => (16#2E95#, 16#0020#, 16#0002#),
         6095 => (16#2E9A#, 16#0020#, 16#0002#),
         6096 => (16#2E9C#, 16#0020#, 16#0002#),
         6097 => (16#2E9F#, 16#0020#, 16#0002#),
         6098 => (16#2EA1#, 16#0020#, 16#0002#),
         6099 => (16#2EA6#, 16#0020#, 16#0002#),
         6100 => (16#2EA8#, 16#0020#, 16#0002#),
         6101 => (16#2EA9#, 16#0020#, 16#0002#),
         6102 => (16#2EAA#, 16#0020#, 16#0002#),
         6103 => (16#2EB1#, 16#0020#, 16#0002#),
         6104 => (16#2EB4#, 16#0020#, 16#0002#),
         6105 => (16#2EB7#, 16#0020#, 16#0002#),
         6106 => (16#2EBC#, 16#0020#, 16#0002#),
         6107 => (16#2EC0#, 16#0020#, 16#0002#),
         6108 => (16#2EC3#, 16#0020#, 16#0002#),
         6109 => (16#2EC5#, 16#0020#, 16#0002#),
         6110 => (16#2EC7#, 16#0020#, 16#0002#),
         6111 => (16#2ECA#, 16#0020#, 16#0002#),
         6112 => (16#2ECF#, 16#0020#, 16#0002#),
         6113 => (16#2ED0#, 16#0020#, 16#0002#),
         6114 => (16#2ED3#, 16#0020#, 16#0002#),
         6115 => (16#2ED7#, 16#0020#, 16#0002#),
         6116 => (16#2EDA#, 16#0020#, 16#0002#),
         6117 => (16#2EDB#, 16#0020#, 16#0002#),
         6118 => (16#2EDC#, 16#0020#, 16#0002#),
         6119 => (16#2EDD#, 16#0020#, 16#0002#),
         6120 => (16#2E7D#, 16#0020#, 16#0002#),
         6121 => (16#2E81#, 16#0020#, 16#0002#),
         6122 => (16#2E84#, 16#0020#, 16#0002#),
         6123 => (16#2E8A#, 16#0020#, 16#0002#),
         6124 => (16#2E8C#, 16#0020#, 16#0002#),
         6125 => (16#2E8F#, 16#0020#, 16#0002#),
         6126 => (16#2E91#, 16#0020#, 16#0002#),
         6127 => (16#2E96#, 16#0020#, 16#0002#),
         6128 => (16#2E9B#, 16#0020#, 16#0002#),
         6129 => (16#2E9D#, 16#0020#, 16#0002#),
         6130 => (16#2EA0#, 16#0020#, 16#0002#),
         6131 => (16#2EA2#, 16#0020#, 16#0002#),
         6132 => (16#2EA7#, 16#0020#, 16#0002#),
         6133 => (16#2EB2#, 16#0020#, 16#0002#),
         6134 => (16#2EB5#, 16#0020#, 16#0002#),
         6135 => (16#2EB8#, 16#0020#, 16#0002#),
         6136 => (16#2EBD#, 16#0020#, 16#0002#),
         6137 => (16#2ED1#, 16#0020#, 16#0002#),
         6138 => (16#2EC1#, 16#0020#, 16#0002#),
         6139 => (16#2EC6#, 16#0020#, 16#0002#),
         6140 => (16#2ECB#, 16#0020#, 16#0002#),
         6141 => (16#2ED5#, 16#0020#, 16#0002#),
         6142 => (16#2ED8#, 16#0020#, 16#0002#),
         6143 => (16#2EDE#, 16#0020#, 16#0002#),
         6144 => (16#2EDF#, 16#0020#, 16#0002#),
         6145 => (16#2EBA#, 16#0020#, 16#0002#),
         6146 => (16#2E82#, 16#0020#, 16#0002#),
         6147 => (16#2E85#, 16#0020#, 16#0002#),
         6148 => (16#2E88#, 16#0020#, 16#0002#),
         6149 => (16#2E92#, 16#0020#, 16#0002#),
         6150 => (16#2E8D#, 16#0020#, 16#0002#),
         6151 => (16#2E97#, 16#0020#, 16#0002#),
         6152 => (16#2ECC#, 16#0020#, 16#0002#),
         6153 => (16#2EA3#, 16#0020#, 16#0002#),
         6154 => (16#2EA5#, 16#0020#, 16#0002#),
         6155 => (16#2E9E#, 16#0020#, 16#0002#),
         6156 => (16#2EAB#, 16#0020#, 16#0002#),
         6157 => (16#2EB3#, 16#0020#, 16#0002#),
         6158 => (16#2EB6#, 16#0020#, 16#0002#),
         6159 => (16#2EBE#, 16#0020#, 16#0002#),
         6160 => (16#2EC8#, 16#0020#, 16#0002#),
         6161 => (16#2ED6#, 16#0020#, 16#0002#),
         6162 => (16#2ED9#, 16#0020#, 16#0002#),
         6163 => (16#2ED2#, 16#0020#, 16#0002#),
         6164 => (16#2ED4#, 16#0020#, 16#0002#),
         6165 => (16#2EE0#, 16#0020#, 16#0002#),
         6166 => (16#2EB9#, 16#0020#, 16#0002#),
         6167 => (16#2EC2#, 16#0020#, 16#0002#),
         6168 => (16#2E86#, 16#0020#, 16#0002#),
         6169 => (16#2ECD#, 16#0020#, 16#0002#),
         6170 => (16#2EC4#, 16#0020#, 16#0002#),
         6171 => (16#2EC9#, 16#0020#, 16#0002#),
         6172 => (16#2EBF#, 16#0020#, 16#0002#),
         6173 => (16#2E76#, 16#0020#, 16#0002#),
         6174 => (16#2E77#, 16#0020#, 16#0002#),
         6175 => (16#2E78#, 16#0020#, 16#0002#),
         6176 => (16#2E79#, 16#0020#, 16#0002#),
         6177 => (16#2E7A#, 16#0020#, 16#0002#),
         6178 => (16#2E7B#, 16#0020#, 16#0002#),
         6179 => (16#2E7C#, 16#0020#, 16#0002#),
         6180 => (16#2E7F#, 16#0020#, 16#0002#),
         6181 => (16#2E87#, 16#0020#, 16#0002#),
         6182 => (16#2ECE#, 16#0020#, 16#0002#),
         6183 => (16#2E98#, 16#0020#, 16#0002#),
         6184 => (16#2EBB#, 16#0020#, 16#0002#),
         6185 => (16#2EE1#, 16#0020#, 16#0002#),
         6186 => (16#2EE3#, 16#0020#, 16#0002#),
         6187 => (16#2EE4#, 16#0020#, 16#0002#),
         6188 => (16#2EE6#, 16#0020#, 16#0002#),
         6189 => (16#2EE7#, 16#0020#, 16#0002#),
         6190 => (16#2EEA#, 16#0020#, 16#0002#),
         6191 => (16#2EEC#, 16#0020#, 16#0002#),
         6192 => (16#2EED#, 16#0020#, 16#0002#),
         6193 => (16#2EEF#, 16#0020#, 16#0002#),
         6194 => (16#2EF1#, 16#0020#, 16#0002#),
         6195 => (16#2EF3#, 16#0020#, 16#0002#),
         6196 => (16#2EF4#, 16#0020#, 16#0002#),
         6197 => (16#2EE8#, 16#0020#, 16#0002#),
         6198 => (16#2EF2#, 16#0020#, 16#0002#),
         6199 => (16#2EA4#, 16#0020#, 16#0002#),
         6200 => (16#2E99#, 16#0020#, 16#0002#),
         6201 => (16#2EAC#, 16#0020#, 16#0002#),
         6202 => (16#2EAD#, 16#0020#, 16#0002#),
         6203 => (16#2EE2#, 16#0020#, 16#0002#),
         6204 => (16#2EE5#, 16#0020#, 16#0002#),
         6205 => (16#2EE9#, 16#0020#, 16#0002#),
         6206 => (16#2EEB#, 16#0020#, 16#0002#),
         6207 => (16#2EAE#, 16#0020#, 16#0002#),
         6208 => (16#2EF0#, 16#0020#, 16#0002#),
         6209 => (16#2EAF#, 16#0020#, 16#0002#),
         6210 => (16#2EB0#, 16#0020#, 16#0002#),
         6211 => (16#2EF5#, 16#0020#, 16#0002#),
         6212 => (16#2EF6#, 16#0020#, 16#0002#),
         6213 => (16#2EEE#, 16#0020#, 16#0002#),
         6214 => (16#2EF8#, 16#0020#, 16#0002#),
         6215 => (16#2EF7#, 16#0020#, 16#0002#),
         6216 => (16#31EF#, 16#0020#, 16#0002#),
         6217 => (16#31F0#, 16#0020#, 16#0002#),
         6218 => (16#31F1#, 16#0020#, 16#0002#),
         6219 => (16#31F2#, 16#0020#, 16#0002#),
         6220 => (16#31F3#, 16#0020#, 16#0002#),
         6221 => (16#31F4#, 16#0020#, 16#0002#),
         6222 => (16#31F5#, 16#0020#, 16#0002#),
         6223 => (16#31F6#, 16#0020#, 16#0002#),
         6224 => (16#31F7#, 16#0020#, 16#0002#),
         6225 => (16#31F8#, 16#0020#, 16#0002#),
         6226 => (16#31F9#, 16#0020#, 16#0002#),
         6227 => (16#31FA#, 16#0020#, 16#0002#),
         6228 => (16#31FB#, 16#0020#, 16#0002#),
         6229 => (16#31FC#, 16#0020#, 16#0002#),
         6230 => (16#31FD#, 16#0020#, 16#0002#),
         6231 => (16#31FE#, 16#0020#, 16#0002#),
         6232 => (16#31FF#, 16#0020#, 16#0002#),
         6233 => (16#3200#, 16#0020#, 16#0002#),
         6234 => (16#3201#, 16#0020#, 16#0002#),
         6235 => (16#3202#, 16#0020#, 16#0002#),
         6236 => (16#3203#, 16#0020#, 16#0002#),
         6237 => (16#3204#, 16#0020#, 16#0002#),
         6238 => (16#3205#, 16#0020#, 16#0002#),
         6239 => (16#3206#, 16#0020#, 16#0002#),
         6240 => (16#3207#, 16#0020#, 16#0002#),
         6241 => (16#3208#, 16#0020#, 16#0002#),
         6242 => (16#3209#, 16#0020#, 16#0002#),
         6243 => (16#320A#, 16#0020#, 16#0002#),
         6244 => (16#320B#, 16#0020#, 16#0002#),
         6245 => (16#320C#, 16#0020#, 16#0002#),
         6246 => (16#320D#, 16#0020#, 16#0002#),
         6247 => (16#320E#, 16#0020#, 16#0002#),
         6248 => (16#320F#, 16#0020#, 16#0002#),
         6249 => (16#3210#, 16#0020#, 16#0002#),
         6250 => (16#3211#, 16#0020#, 16#0002#),
         6251 => (16#3212#, 16#0020#, 16#0002#),
         6252 => (16#3213#, 16#0020#, 16#0002#),
         6253 => (16#3214#, 16#0020#, 16#0002#),
         6254 => (16#3215#, 16#0020#, 16#0002#),
         6255 => (16#3216#, 16#0020#, 16#0002#),
         6256 => (16#3217#, 16#0020#, 16#0002#),
         6257 => (16#3218#, 16#0020#, 16#0002#),
         6258 => (16#3219#, 16#0020#, 16#0002#),
         6259 => (16#321A#, 16#0020#, 16#0002#),
         6260 => (16#321B#, 16#0020#, 16#0002#),
         6261 => (16#321C#, 16#0020#, 16#0002#),
         6262 => (16#321D#, 16#0020#, 16#0002#),
         6263 => (16#321E#, 16#0020#, 16#0002#),
         6264 => (16#321F#, 16#0020#, 16#0002#),
         6265 => (16#3220#, 16#0020#, 16#0002#),
         6266 => (16#3221#, 16#0020#, 16#0002#),
         6267 => (16#3222#, 16#0020#, 16#0002#),
         6268 => (16#3223#, 16#0020#, 16#0002#),
         6269 => (16#3224#, 16#0020#, 16#0002#),
         6270 => (16#3225#, 16#0020#, 16#0002#),
         6271 => (16#3226#, 16#0020#, 16#0002#),
         6272 => (16#3227#, 16#0020#, 16#0002#),
         6273 => (16#3228#, 16#0020#, 16#0002#),
         6274 => (16#3229#, 16#0020#, 16#0002#),
         6275 => (16#322A#, 16#0020#, 16#0002#),
         6276 => (16#322B#, 16#0020#, 16#0002#),
         6277 => (16#322C#, 16#0020#, 16#0002#),
         6278 => (16#322D#, 16#0020#, 16#0002#),
         6279 => (16#322E#, 16#0020#, 16#0002#),
         6280 => (16#322F#, 16#0020#, 16#0002#),
         6281 => (16#3230#, 16#0020#, 16#0002#),
         6282 => (16#3231#, 16#0020#, 16#0002#),
         6283 => (16#3232#, 16#0020#, 16#0002#),
         6284 => (16#3233#, 16#0020#, 16#0002#),
         6285 => (16#3234#, 16#0020#, 16#0002#),
         6286 => (16#2AD2#, 16#0020#, 16#0002#),
         6287 => (16#2AD3#, 16#0020#, 16#0002#),
         6288 => (16#2AD4#, 16#0020#, 16#0002#),
         6289 => (16#2AD5#, 16#0020#, 16#0002#),
         6290 => (16#2AD6#, 16#0020#, 16#0002#),
         6291 => (16#2AD7#, 16#0020#, 16#0002#),
         6292 => (16#2AD8#, 16#0020#, 16#0002#),
         6293 => (16#2AD9#, 16#0020#, 16#0002#),
         6294 => (16#2ADA#, 16#0020#, 16#0002#),
         6295 => (16#2ADB#, 16#0020#, 16#0002#),
         6296 => (16#2ADC#, 16#0020#, 16#0002#),
         6297 => (16#2ADD#, 16#0020#, 16#0002#),
         6298 => (16#2ADE#, 16#0020#, 16#0002#),
         6299 => (16#2ADF#, 16#0020#, 16#0002#),
         6300 => (16#2AE0#, 16#0020#, 16#0002#),
         6301 => (16#2AE1#, 16#0020#, 16#0002#),
         6302 => (16#2AE2#, 16#0020#, 16#0002#),
         6303 => (16#2AE3#, 16#0020#, 16#0002#),
         6304 => (16#2AE4#, 16#0020#, 16#0002#),
         6305 => (16#2AE5#, 16#0020#, 16#0002#),
         6306 => (16#2AE6#, 16#0020#, 16#0002#),
         6307 => (16#2AE7#, 16#0020#, 16#0002#),
         6308 => (16#2AE8#, 16#0020#, 16#0002#),
         6309 => (16#2AE9#, 16#0020#, 16#0002#),
         6310 => (16#2AEA#, 16#0020#, 16#0002#),
         6311 => (16#2AEB#, 16#0020#, 16#0002#),
         6312 => (16#2AEC#, 16#0020#, 16#0002#),
         6313 => (16#2AED#, 16#0020#, 16#0002#),
         6314 => (16#2AEE#, 16#0020#, 16#0002#),
         6315 => (16#2ADA#, 16#0020#, 16#0004#),
         6316 => (16#2AF8#, 16#0020#, 16#0004#),
         6317 => (16#2ADD#, 16#0020#, 16#0004#),
         6318 => (16#2AF9#, 16#0020#, 16#0004#),
         6319 => (16#2AEF#, 16#0020#, 16#0002#),
         6320 => (16#2AF0#, 16#0020#, 16#0002#),
         6321 => (16#2AF1#, 16#0020#, 16#0002#),
         6322 => (16#2AF2#, 16#0020#, 16#0002#),
         6323 => (16#2AF3#, 16#0020#, 16#0002#),
         6324 => (16#2AF4#, 16#0020#, 16#0002#),
         6325 => (16#2AF5#, 16#0020#, 16#0002#),
         6326 => (16#2AF6#, 16#0020#, 16#0002#),
         6327 => (16#2AF7#, 16#0020#, 16#0002#),
         6328 => (16#2AF8#, 16#0020#, 16#0002#),
         6329 => (16#2AF9#, 16#0020#, 16#0002#),
         6330 => (16#2AFA#, 16#0020#, 16#0002#),
         6331 => (16#2AFB#, 16#0020#, 16#0002#),
         6332 => (16#2AFC#, 16#0020#, 16#0002#),
         6333 => (16#2AFD#, 16#0020#, 16#0002#),
         6334 => (16#2AFE#, 16#0020#, 16#0002#),
         6335 => (16#2AFF#, 16#0020#, 16#0002#),
         6336 => (16#2B00#, 16#0020#, 16#0002#),
         6337 => (16#2B01#, 16#0020#, 16#0002#),
         6338 => (16#2B02#, 16#0020#, 16#0002#),
         6339 => (16#2B03#, 16#0020#, 16#0002#),
         6340 => (16#0000#, 16#00E9#, 16#0002#),
         6341 => (16#0000#, 16#00EA#, 16#0002#),
         6342 => (16#0000#, 16#00EB#, 16#0002#),
         6343 => (16#040D#, 16#0020#, 16#0002#),
         6344 => (16#0162#, 16#0020#, 16#0002#),
         6345 => (16#016A#, 16#0020#, 16#0002#),
         6346 => (16#2CFA#, 16#0020#, 16#0002#),
         6347 => (16#2CFB#, 16#0020#, 16#0002#),
         6348 => (16#2CFC#, 16#0020#, 16#0002#),
         6349 => (16#2CFD#, 16#0020#, 16#0002#),
         6350 => (16#2CFE#, 16#0020#, 16#0002#),
         6351 => (16#2CFF#, 16#0020#, 16#0002#),
         6352 => (16#2D00#, 16#0020#, 16#0002#),
         6353 => (16#2D01#, 16#0020#, 16#0002#),
         6354 => (16#2D02#, 16#0020#, 16#0002#),
         6355 => (16#2D03#, 16#0020#, 16#0002#),
         6356 => (16#2D04#, 16#0020#, 16#0002#),
         6357 => (16#2D05#, 16#0020#, 16#0002#),
         6358 => (16#2D06#, 16#0020#, 16#0002#),
         6359 => (16#2D07#, 16#0020#, 16#0002#),
         6360 => (16#2D08#, 16#0020#, 16#0002#),
         6361 => (16#2D09#, 16#0020#, 16#0002#),
         6362 => (16#2D0A#, 16#0020#, 16#0002#),
         6363 => (16#2D0B#, 16#0020#, 16#0002#),
         6364 => (16#2D0C#, 16#0020#, 16#0002#),
         6365 => (16#2D0D#, 16#0020#, 16#0002#),
         6366 => (16#2D0E#, 16#0020#, 16#0002#),
         6367 => (16#2D0F#, 16#0020#, 16#0002#),
         6368 => (16#2D10#, 16#0020#, 16#0002#),
         6369 => (16#2D11#, 16#0020#, 16#0002#),
         6370 => (16#2D12#, 16#0020#, 16#0002#),
         6371 => (16#2D13#, 16#0020#, 16#0002#),
         6372 => (16#2D14#, 16#0020#, 16#0002#),
         6373 => (16#2D15#, 16#0020#, 16#0002#),
         6374 => (16#2D16#, 16#0020#, 16#0002#),
         6375 => (16#2D17#, 16#0020#, 16#0002#),
         6376 => (16#2D18#, 16#0020#, 16#0002#),
         6377 => (16#2D19#, 16#0020#, 16#0002#),
         6378 => (16#2D1A#, 16#0020#, 16#0002#),
         6379 => (16#2D1B#, 16#0020#, 16#0002#),
         6380 => (16#2D1C#, 16#0020#, 16#0002#),
         6381 => (16#2D1D#, 16#0020#, 16#0002#),
         6382 => (16#2D1E#, 16#0020#, 16#0002#),
         6383 => (16#2D1F#, 16#0020#, 16#0002#),
         6384 => (16#2D20#, 16#0020#, 16#0002#),
         6385 => (16#2D21#, 16#0020#, 16#0002#),
         6386 => (16#2D22#, 16#0020#, 16#0002#),
         6387 => (16#2D23#, 16#0020#, 16#0002#),
         6388 => (16#2D24#, 16#0020#, 16#0002#),
         6389 => (16#2D25#, 16#0020#, 16#0002#),
         6390 => (16#2D26#, 16#0020#, 16#0002#),
         6391 => (16#2D27#, 16#0020#, 16#0002#),
         6392 => (16#2D28#, 16#0020#, 16#0002#),
         6393 => (16#2D29#, 16#0020#, 16#0002#),
         6394 => (16#2D2A#, 16#0020#, 16#0002#),
         6395 => (16#2D2B#, 16#0020#, 16#0002#),
         6396 => (16#2D2C#, 16#0020#, 16#0002#),
         6397 => (16#2D2D#, 16#0020#, 16#0002#),
         6398 => (16#2D2E#, 16#0020#, 16#0002#),
         6399 => (16#2D2F#, 16#0020#, 16#0002#),
         6400 => (16#2D30#, 16#0020#, 16#0002#),
         6401 => (16#2D31#, 16#0020#, 16#0002#),
         6402 => (16#2D32#, 16#0020#, 16#0002#),
         6403 => (16#2D33#, 16#0020#, 16#0002#),
         6404 => (16#2D34#, 16#0020#, 16#0002#),
         6405 => (16#2D35#, 16#0020#, 16#0002#),
         6406 => (16#2D36#, 16#0020#, 16#0002#),
         6407 => (16#2D37#, 16#0020#, 16#0002#),
         6408 => (16#2D38#, 16#0020#, 16#0002#),
         6409 => (16#2D39#, 16#0020#, 16#0002#),
         6410 => (16#2D3A#, 16#0020#, 16#0002#),
         6411 => (16#2D3B#, 16#0020#, 16#0002#),
         6412 => (16#2D3C#, 16#0020#, 16#0002#),
         6413 => (16#2D3D#, 16#0020#, 16#0002#),
         6414 => (16#2D3E#, 16#0020#, 16#0002#),
         6415 => (16#2D3F#, 16#0020#, 16#0002#),
         6416 => (16#2D40#, 16#0020#, 16#0002#),
         6417 => (16#2D41#, 16#0020#, 16#0002#),
         6418 => (16#2D42#, 16#0020#, 16#0002#),
         6419 => (16#2D43#, 16#0020#, 16#0002#),
         6420 => (16#2D44#, 16#0020#, 16#0002#),
         6421 => (16#2D45#, 16#0020#, 16#0002#),
         6422 => (16#2D46#, 16#0020#, 16#0002#),
         6423 => (16#2D47#, 16#0020#, 16#0002#),
         6424 => (16#2D48#, 16#0020#, 16#0002#),
         6425 => (16#2D49#, 16#0020#, 16#0002#),
         6426 => (16#2D4A#, 16#0020#, 16#0002#),
         6427 => (16#2D4B#, 16#0020#, 16#0002#),
         6428 => (16#2D4C#, 16#0020#, 16#0002#),
         6429 => (16#2D4D#, 16#0020#, 16#0002#),
         6430 => (16#2D4E#, 16#0020#, 16#0002#),
         6431 => (16#2D4F#, 16#0020#, 16#0002#),
         6432 => (16#2D50#, 16#0020#, 16#0002#),
         6433 => (16#2D51#, 16#0020#, 16#0002#),
         6434 => (16#2D52#, 16#0020#, 16#0002#),
         6435 => (16#2D53#, 16#0020#, 16#0002#),
         6436 => (16#2D54#, 16#0020#, 16#0002#),
         6437 => (16#2D55#, 16#0020#, 16#0002#),
         6438 => (16#2D56#, 16#0020#, 16#0002#),
         6439 => (16#2D57#, 16#0020#, 16#0002#),
         6440 => (16#2D58#, 16#0020#, 16#0002#),
         6441 => (16#2D59#, 16#0020#, 16#0002#),
         6442 => (16#2D5A#, 16#0020#, 16#0002#),
         6443 => (16#2D5B#, 16#0020#, 16#0002#),
         6444 => (16#2D5C#, 16#0020#, 16#0002#),
         6445 => (16#2D5D#, 16#0020#, 16#0002#),
         6446 => (16#2D5E#, 16#0020#, 16#0002#),
         6447 => (16#2D5F#, 16#0020#, 16#0002#),
         6448 => (16#2D60#, 16#0020#, 16#0002#),
         6449 => (16#2D61#, 16#0020#, 16#0002#),
         6450 => (16#2D62#, 16#0020#, 16#0002#),
         6451 => (16#2D39#, 16#0020#, 16#0004#),
         6452 => (16#2D4F#, 16#0020#, 16#0004#),
         6453 => (16#2D39#, 16#0020#, 16#0004#),
         6454 => (16#2D4F#, 16#0020#, 16#0004#),
         6455 => (16#2D5A#, 16#0020#, 16#0004#),
         6456 => (16#0413#, 16#0020#, 16#0002#),
         6457 => (16#0414#, 16#0020#, 16#0002#),
         6458 => (16#0415#, 16#0020#, 16#0002#),
         6459 => (16#0416#, 16#0020#, 16#0002#),
         6460 => (16#0417#, 16#0020#, 16#0002#),
         6461 => (16#0418#, 16#0020#, 16#0002#),
         6462 => (16#0419#, 16#0020#, 16#0002#),
         6463 => (16#041A#, 16#0020#, 16#0002#),
         6464 => (16#041B#, 16#0020#, 16#0002#),
         6465 => (16#041C#, 16#0020#, 16#0002#),
         6466 => (16#041D#, 16#0020#, 16#0002#),
         6467 => (16#041E#, 16#0020#, 16#0002#),
         6468 => (16#041F#, 16#0020#, 16#0002#),
         6469 => (16#0420#, 16#0020#, 16#0002#),
         6470 => (16#0421#, 16#0020#, 16#0002#),
         6471 => (16#0422#, 16#0020#, 16#0002#),
         6472 => (16#0423#, 16#0020#, 16#0002#),
         6473 => (16#0424#, 16#0020#, 16#0002#),
         6474 => (16#0425#, 16#0020#, 16#0002#),
         6475 => (16#0426#, 16#0020#, 16#0002#),
         6476 => (16#0427#, 16#0020#, 16#0002#),
         6477 => (16#0428#, 16#0020#, 16#0002#),
         6478 => (16#0429#, 16#0020#, 16#0002#),
         6479 => (16#042A#, 16#0020#, 16#0002#),
         6480 => (16#042B#, 16#0020#, 16#0002#),
         6481 => (16#042C#, 16#0020#, 16#0002#),
         6482 => (16#042D#, 16#0020#, 16#0002#),
         6483 => (16#042E#, 16#0020#, 16#0002#),
         6484 => (16#042F#, 16#0020#, 16#0002#),
         6485 => (16#0430#, 16#0020#, 16#0002#),
         6486 => (16#0431#, 16#0020#, 16#0002#),
         6487 => (16#0432#, 16#0020#, 16#0002#),
         6488 => (16#2B53#, 16#0020#, 16#0002#),
         6489 => (16#2B54#, 16#0020#, 16#0002#),
         6490 => (16#2B55#, 16#0020#, 16#0002#),
         6491 => (16#2B56#, 16#0020#, 16#0002#),
         6492 => (16#2B57#, 16#0020#, 16#0002#),
         6493 => (16#2B58#, 16#0020#, 16#0002#),
         6494 => (16#2B59#, 16#0020#, 16#0002#),
         6495 => (16#2B5A#, 16#0020#, 16#0002#),
         6496 => (16#2B5B#, 16#0020#, 16#0002#),
         6497 => (16#2B5C#, 16#0020#, 16#0002#),
         6498 => (16#2B5D#, 16#0020#, 16#0002#),
         6499 => (16#2B5E#, 16#0020#, 16#0002#),
         6500 => (16#2B5F#, 16#0020#, 16#0002#),
         6501 => (16#2B60#, 16#0020#, 16#0002#),
         6502 => (16#2B61#, 16#0020#, 16#0002#),
         6503 => (16#2B62#, 16#0020#, 16#0002#),
         6504 => (16#2B63#, 16#0020#, 16#0002#),
         6505 => (16#2B64#, 16#0020#, 16#0002#),
         6506 => (16#2B65#, 16#0020#, 16#0002#),
         6507 => (16#2B66#, 16#0020#, 16#0002#),
         6508 => (16#2B67#, 16#0020#, 16#0002#),
         6509 => (16#2B68#, 16#0020#, 16#0002#),
         6510 => (16#2B69#, 16#0020#, 16#0002#),
         6511 => (16#2B6A#, 16#0020#, 16#0002#),
         6512 => (16#2B6B#, 16#0020#, 16#0002#),
         6513 => (16#2B6C#, 16#0020#, 16#0002#),
         6514 => (16#2B6D#, 16#0020#, 16#0002#),
         6515 => (16#2B6E#, 16#0020#, 16#0002#),
         6516 => (16#01BF#, 16#0020#, 16#0002#),
         6517 => (16#01C0#, 16#0020#, 16#0002#),
         6518 => (16#2D63#, 16#0020#, 16#0002#),
         6519 => (16#2D64#, 16#0020#, 16#0002#),
         6520 => (16#2D65#, 16#0020#, 16#0002#),
         6521 => (16#2D66#, 16#0020#, 16#0002#),
         6522 => (16#2D67#, 16#0020#, 16#0002#),
         6523 => (16#2D68#, 16#0020#, 16#0002#),
         6524 => (16#2D69#, 16#0020#, 16#0002#),
         6525 => (16#2D6A#, 16#0020#, 16#0002#),
         6526 => (16#2D6B#, 16#0020#, 16#0002#),
         6527 => (16#2D6C#, 16#0020#, 16#0002#),
         6528 => (16#2D6D#, 16#0020#, 16#0002#),
         6529 => (16#2D6E#, 16#0020#, 16#0002#),
         6530 => (16#2D6F#, 16#0020#, 16#0002#),
         6531 => (16#2D70#, 16#0020#, 16#0002#),
         6532 => (16#2D71#, 16#0020#, 16#0002#),
         6533 => (16#2D72#, 16#0020#, 16#0002#),
         6534 => (16#2D73#, 16#0020#, 16#0002#),
         6535 => (16#2D74#, 16#0020#, 16#0002#),
         6536 => (16#2D75#, 16#0020#, 16#0002#),
         6537 => (16#2D76#, 16#0020#, 16#0002#),
         6538 => (16#2D77#, 16#0020#, 16#0002#),
         6539 => (16#2D78#, 16#0020#, 16#0002#),
         6540 => (16#2D79#, 16#0020#, 16#0002#),
         6541 => (16#2D7A#, 16#0020#, 16#0002#),
         6542 => (16#2D7B#, 16#0020#, 16#0002#),
         6543 => (16#2D7C#, 16#0020#, 16#0002#),
         6544 => (16#2D7D#, 16#0020#, 16#0002#),
         6545 => (16#2D7E#, 16#0020#, 16#0002#),
         6546 => (16#2D7F#, 16#0020#, 16#0002#),
         6547 => (16#2D80#, 16#0020#, 16#0002#),
         6548 => (16#2D81#, 16#0020#, 16#0002#),
         6549 => (16#2D82#, 16#0020#, 16#0002#),
         6550 => (16#2D83#, 16#0020#, 16#0002#),
         6551 => (16#2D84#, 16#0020#, 16#0002#),
         6552 => (16#2D85#, 16#0020#, 16#0002#),
         6553 => (16#2D86#, 16#0020#, 16#0002#),
         6554 => (16#2D87#, 16#0020#, 16#0002#),
         6555 => (16#2D88#, 16#0020#, 16#0002#),
         6556 => (16#2D89#, 16#0020#, 16#0002#),
         6557 => (16#2D8A#, 16#0020#, 16#0002#),
         6558 => (16#2D8B#, 16#0020#, 16#0002#),
         6559 => (16#2D8C#, 16#0020#, 16#0002#),
         6560 => (16#2D8D#, 16#0020#, 16#0002#),
         6561 => (16#2D8E#, 16#0020#, 16#0002#),
         6562 => (16#2D8F#, 16#0020#, 16#0002#),
         6563 => (16#2D98#, 16#0020#, 16#0002#),
         6564 => (16#2D99#, 16#0020#, 16#0002#),
         6565 => (16#2D9A#, 16#0020#, 16#0002#),
         6566 => (16#2D9B#, 16#0020#, 16#0002#),
         6567 => (16#2D9C#, 16#0020#, 16#0002#),
         6568 => (16#2D9D#, 16#0020#, 16#0002#),
         6569 => (16#2D90#, 16#0020#, 16#0002#),
         6570 => (16#2D89#, 16#0020#, 16#0004#),
         6571 => (16#2DAF#, 16#0020#, 16#0004#),
         6572 => (16#2D89#, 16#0020#, 16#0004#),
         6573 => (16#2D92#, 16#0020#, 16#0002#),
         6574 => (16#2D93#, 16#0020#, 16#0002#),
         6575 => (16#2D94#, 16#0020#, 16#0002#),
         6576 => (16#2D69#, 16#0020#, 16#0004#),
         6577 => (16#2D7E#, 16#0020#, 16#0004#),
         6578 => (16#2D95#, 16#0020#, 16#0002#),
         6579 => (16#2D96#, 16#0020#, 16#0002#),
         6580 => (16#2D97#, 16#0020#, 16#0002#),
         6581 => (16#2DAF#, 16#0020#, 16#0002#),
         6582 => (16#2D9E#, 16#0020#, 16#0002#),
         6583 => (16#2DA0#, 16#0020#, 16#0002#),
         6584 => (16#2DA1#, 16#0020#, 16#0002#),
         6585 => (16#2DA1#, 16#0020#, 16#0004#),
         6586 => (16#2DA2#, 16#0020#, 16#0002#),
         6587 => (16#2DA3#, 16#0020#, 16#0002#),
         6588 => (16#2DA4#, 16#0020#, 16#0002#),
         6589 => (16#2DA5#, 16#0020#, 16#0002#),
         6590 => (16#2DA6#, 16#0020#, 16#0002#),
         6591 => (16#2DA7#, 16#0020#, 16#0002#),
         6592 => (16#2D91#, 16#0020#, 16#0002#),
         6593 => (16#2D9F#, 16#0020#, 16#0002#),
         6594 => (16#2DAE#, 16#0020#, 16#0002#),
         6595 => (16#2DA8#, 16#0020#, 16#0002#),
         6596 => (16#2DA9#, 16#0020#, 16#0002#),
         6597 => (16#2DAB#, 16#0020#, 16#0002#),
         6598 => (16#2DAC#, 16#0020#, 16#0002#),
         6599 => (16#2DAD#, 16#0020#, 16#0002#),
         6600 => (16#2DAA#, 16#0020#, 16#0002#),
         6601 => (16#0000#, 16#00E1#, 16#0002#),
         6602 => (16#0000#, 16#00E2#, 16#0002#),
         6603 => (16#0000#, 16#00E3#, 16#0002#),
         6604 => (16#0000#, 16#00E4#, 16#0002#),
         6605 => (16#0000#, 16#00E5#, 16#0002#),
         6606 => (16#0000#, 16#00E6#, 16#0002#),
         6607 => (16#0000#, 16#00E7#, 16#0002#),
         6608 => (16#0000#, 16#00E8#, 16#0002#),
         6609 => (16#02F6#, 16#0020#, 16#0002#),
         6610 => (16#02F7#, 16#0020#, 16#0002#),
         6611 => (16#02F8#, 16#0020#, 16#0002#),
         6612 => (16#02F9#, 16#0020#, 16#0002#),
         6613 => (16#02FA#, 16#0020#, 16#0002#),
         6614 => (16#02FB#, 16#0020#, 16#0002#),
         6615 => (16#02FC#, 16#0020#, 16#0002#),
         6616 => (16#16B7#, 16#0020#, 16#0002#),
         6617 => (16#0199#, 16#0020#, 16#0002#),
         6618 => (16#019A#, 16#0020#, 16#0002#),
         6619 => (16#019B#, 16#0020#, 16#0002#),
         6620 => (16#019C#, 16#0020#, 16#0002#),
         6621 => (16#02FD#, 16#0020#, 16#0002#),
         6622 => (16#02FE#, 16#0020#, 16#0002#),
         6623 => (16#0000#, 16#0036#, 16#0002#),
         6624 => (16#0000#, 16#00C2#, 16#0002#),
         6625 => (16#2DF5#, 16#0020#, 16#0002#),
         6626 => (16#2DF6#, 16#0020#, 16#0002#),
         6627 => (16#2DF7#, 16#0020#, 16#0002#),
         6628 => (16#2DF8#, 16#0020#, 16#0002#),
         6629 => (16#2DF9#, 16#0020#, 16#0002#),
         6630 => (16#2DFA#, 16#0020#, 16#0002#),
         6631 => (16#2DFB#, 16#0020#, 16#0002#),
         6632 => (16#2DFC#, 16#0020#, 16#0002#),
         6633 => (16#2DFD#, 16#0020#, 16#0002#),
         6634 => (16#2DFE#, 16#0020#, 16#0002#),
         6635 => (16#2DFF#, 16#0020#, 16#0002#),
         6636 => (16#2E00#, 16#0020#, 16#0002#),
         6637 => (16#2E01#, 16#0020#, 16#0002#),
         6638 => (16#2E02#, 16#0020#, 16#0002#),
         6639 => (16#2E03#, 16#0020#, 16#0002#),
         6640 => (16#2E06#, 16#0020#, 16#0002#),
         6641 => (16#2E07#, 16#0020#, 16#0002#),
         6642 => (16#2E08#, 16#0020#, 16#0002#),
         6643 => (16#2E09#, 16#0020#, 16#0002#),
         6644 => (16#2E0A#, 16#0020#, 16#0002#),
         6645 => (16#2E0B#, 16#0020#, 16#0002#),
         6646 => (16#2E0C#, 16#0020#, 16#0002#),
         6647 => (16#2E0D#, 16#0020#, 16#0002#),
         6648 => (16#2E0E#, 16#0020#, 16#0002#),
         6649 => (16#2E0F#, 16#0020#, 16#0002#),
         6650 => (16#2E10#, 16#0020#, 16#0002#),
         6651 => (16#2E11#, 16#0020#, 16#0002#),
         6652 => (16#2E12#, 16#0020#, 16#0002#),
         6653 => (16#2E13#, 16#0020#, 16#0002#),
         6654 => (16#2E14#, 16#0020#, 16#0002#),
         6655 => (16#2E16#, 16#0020#, 16#0002#),
         6656 => (16#2E17#, 16#0020#, 16#0002#),
         6657 => (16#2E18#, 16#0020#, 16#0002#),
         6658 => (16#2E19#, 16#0020#, 16#0002#),
         6659 => (16#2E1A#, 16#0020#, 16#0002#),
         6660 => (16#2E1C#, 16#0020#, 16#0002#),
         6661 => (16#2E1D#, 16#0020#, 16#0002#),
         6662 => (16#2E1E#, 16#0020#, 16#0002#),
         6663 => (16#2E1F#, 16#0020#, 16#0002#),
         6664 => (16#2E20#, 16#0020#, 16#0002#),
         6665 => (16#2E21#, 16#0020#, 16#0002#),
         6666 => (16#2E22#, 16#0020#, 16#0002#),
         6667 => (16#2E23#, 16#0020#, 16#0002#),
         6668 => (16#2E25#, 16#0020#, 16#0002#),
         6669 => (16#2E26#, 16#0020#, 16#0002#),
         6670 => (16#2E27#, 16#0020#, 16#0002#),
         6671 => (16#2E2A#, 16#0020#, 16#0002#),
         6672 => (16#2E2B#, 16#0020#, 16#0002#),
         6673 => (16#2E2C#, 16#0020#, 16#0002#),
         6674 => (16#2E2D#, 16#0020#, 16#0002#),
         6675 => (16#2E2E#, 16#0020#, 16#0002#),
         6676 => (16#2E2F#, 16#0020#, 16#0002#),
         6677 => (16#2E30#, 16#0020#, 16#0002#),
         6678 => (16#2E31#, 16#0020#, 16#0002#),
         6679 => (16#2E32#, 16#0020#, 16#0002#),
         6680 => (16#2E33#, 16#0020#, 16#0002#),
         6681 => (16#2E34#, 16#0020#, 16#0002#),
         6682 => (16#2E36#, 16#0020#, 16#0002#),
         6683 => (16#2E35#, 16#0020#, 16#0002#),
         6684 => (16#2E37#, 16#0020#, 16#0002#),
         6685 => (16#2E38#, 16#0020#, 16#0002#),
         6686 => (16#2E39#, 16#0020#, 16#0002#),
         6687 => (16#2E3A#, 16#0020#, 16#0002#),
         6688 => (16#2E04#, 16#0020#, 16#0002#),
         6689 => (16#2E05#, 16#0020#, 16#0002#),
         6690 => (16#2E15#, 16#0020#, 16#0002#),
         6691 => (16#2E1B#, 16#0020#, 16#0002#),
         6692 => (16#2E24#, 16#0020#, 16#0002#),
         6693 => (16#2E28#, 16#0020#, 16#0002#),
         6694 => (16#2E29#, 16#0020#, 16#0002#),
         6695 => (16#01C1#, 16#0020#, 16#0002#),
         6696 => (16#01C2#, 16#0020#, 16#0002#),
         6697 => (16#017C#, 16#0020#, 16#0002#),
         6698 => (16#0158#, 16#0020#, 16#0002#),
         6699 => (16#019D#, 16#0020#, 16#0002#),
         6700 => (16#019E#, 16#0020#, 16#0002#),
         6701 => (16#010F#, 16#0020#, 16#0002#),
         6702 => (16#0433#, 16#0020#, 16#0002#),
         6703 => (16#0434#, 16#0020#, 16#0002#),
         6704 => (16#0435#, 16#0020#, 16#0002#),
         6705 => (16#0436#, 16#0020#, 16#0002#),
         6706 => (16#0437#, 16#0020#, 16#0002#),
         6707 => (16#0438#, 16#0020#, 16#0002#),
         6708 => (16#0439#, 16#0020#, 16#0002#),
         6709 => (16#043A#, 16#0020#, 16#0002#),
         6710 => (16#043B#, 16#0020#, 16#0002#),
         6711 => (16#043C#, 16#0020#, 16#0002#),
         6712 => (16#043D#, 16#0020#, 16#0002#),
         6713 => (16#043E#, 16#0020#, 16#0002#),
         6714 => (16#043F#, 16#0020#, 16#0002#),
         6715 => (16#0440#, 16#0020#, 16#0002#),
         6716 => (16#0441#, 16#0020#, 16#0002#),
         6717 => (16#0442#, 16#0020#, 16#0002#),
         6718 => (16#0443#, 16#0020#, 16#0002#),
         6719 => (16#0444#, 16#0020#, 16#0002#),
         6720 => (16#0445#, 16#0020#, 16#0002#),
         6721 => (16#0000#, 16#00C4#, 16#0002#),
         6722 => (16#28B2#, 16#0020#, 16#0002#),
         6723 => (16#28B3#, 16#0020#, 16#0002#),
         6724 => (16#28B4#, 16#0020#, 16#0002#),
         6725 => (16#28B5#, 16#0020#, 16#0002#),
         6726 => (16#28B6#, 16#0020#, 16#0002#),
         6727 => (16#28B7#, 16#0020#, 16#0002#),
         6728 => (16#28B8#, 16#0020#, 16#0002#),
         6729 => (16#28B9#, 16#0020#, 16#0002#),
         6730 => (16#28BB#, 16#0020#, 16#0002#),
         6731 => (16#28BC#, 16#0020#, 16#0002#),
         6732 => (16#28BD#, 16#0020#, 16#0002#),
         6733 => (16#28BE#, 16#0020#, 16#0002#),
         6734 => (16#28BF#, 16#0020#, 16#0002#),
         6735 => (16#28C0#, 16#0020#, 16#0002#),
         6736 => (16#28C1#, 16#0020#, 16#0002#),
         6737 => (16#28C2#, 16#0020#, 16#0002#),
         6738 => (16#28C3#, 16#0020#, 16#0002#),
         6739 => (16#28C4#, 16#0020#, 16#0002#),
         6740 => (16#28C5#, 16#0020#, 16#0002#),
         6741 => (16#28C6#, 16#0020#, 16#0002#),
         6742 => (16#28C7#, 16#0020#, 16#0002#),
         6743 => (16#28C8#, 16#0020#, 16#0002#),
         6744 => (16#28CA#, 16#0020#, 16#0002#),
         6745 => (16#28CC#, 16#0020#, 16#0002#),
         6746 => (16#28CE#, 16#0020#, 16#0002#),
         6747 => (16#28D1#, 16#0020#, 16#0002#),
         6748 => (16#28D4#, 16#0020#, 16#0002#),
         6749 => (16#28D6#, 16#0020#, 16#0002#),
         6750 => (16#28D7#, 16#0020#, 16#0002#),
         6751 => (16#28D9#, 16#0020#, 16#0002#),
         6752 => (16#28CD#, 16#0020#, 16#0002#),
         6753 => (16#28CF#, 16#0020#, 16#0002#),
         6754 => (16#28D2#, 16#0020#, 16#0002#),
         6755 => (16#28DA#, 16#0020#, 16#0002#),
         6756 => (16#28DB#, 16#0020#, 16#0002#),
         6757 => (16#28DC#, 16#0020#, 16#0002#),
         6758 => (16#28DD#, 16#0020#, 16#0002#),
         6759 => (16#28DE#, 16#0020#, 16#0002#),
         6760 => (16#28DF#, 16#0020#, 16#0002#),
         6761 => (16#28E0#, 16#0020#, 16#0002#),
         6762 => (16#28E1#, 16#0020#, 16#0002#),
         6763 => (16#28CB#, 16#0020#, 16#0002#),
         6764 => (16#28D5#, 16#0020#, 16#0002#),
         6765 => (16#28BA#, 16#0020#, 16#0002#),
         6766 => (16#28D8#, 16#0020#, 16#0002#),
         6767 => (16#28B2#, 16#0020#, 16#0004#),
         6768 => (16#28D0#, 16#0020#, 16#0002#),
         6769 => (16#28D3#, 16#0020#, 16#0002#),
         6770 => (16#28C9#, 16#0020#, 16#0002#),
         6771 => (16#28B9#, 16#0020#, 16#0019#),
         6772 => (16#28CA#, 16#0020#, 16#0019#),
         6773 => (16#2B6F#, 16#0020#, 16#0002#),
         6774 => (16#2B6F#, 16#0020#, 16#0004#),
         6775 => (16#2B70#, 16#0020#, 16#0002#),
         6776 => (16#2B70#, 16#0020#, 16#0004#),
         6777 => (16#2B71#, 16#0020#, 16#0002#),
         6778 => (16#2B71#, 16#0020#, 16#0004#),
         6779 => (16#2B72#, 16#0020#, 16#0002#),
         6780 => (16#2B72#, 16#0020#, 16#0004#),
         6781 => (16#2B73#, 16#0020#, 16#0002#),
         6782 => (16#2B73#, 16#0020#, 16#0004#),
         6783 => (16#2B74#, 16#0020#, 16#0002#),
         6784 => (16#2B74#, 16#0020#, 16#0004#),
         6785 => (16#2B75#, 16#0020#, 16#0002#),
         6786 => (16#2B75#, 16#0020#, 16#0004#),
         6787 => (16#2B76#, 16#0020#, 16#0002#),
         6788 => (16#2B77#, 16#0020#, 16#0002#),
         6789 => (16#2B78#, 16#0020#, 16#0002#),
         6790 => (16#2B78#, 16#0020#, 16#0004#),
         6791 => (16#2B79#, 16#0020#, 16#0002#),
         6792 => (16#2B79#, 16#0020#, 16#0004#),
         6793 => (16#2B7A#, 16#0020#, 16#0002#),
         6794 => (16#2B7A#, 16#0020#, 16#0004#),
         6795 => (16#2B7B#, 16#0020#, 16#0002#),
         6796 => (16#2B7B#, 16#0020#, 16#0004#),
         6797 => (16#2B7C#, 16#0020#, 16#0002#),
         6798 => (16#2B7C#, 16#0020#, 16#0004#),
         6799 => (16#2B7D#, 16#0020#, 16#0002#),
         6800 => (16#2B7E#, 16#0020#, 16#0002#),
         6801 => (16#2B7E#, 16#0020#, 16#0004#),
         6802 => (16#2B7F#, 16#0020#, 16#0002#),
         6803 => (16#2B80#, 16#0020#, 16#0002#),
         6804 => (16#2B81#, 16#0020#, 16#0002#),
         6805 => (16#2B82#, 16#0020#, 16#0002#),
         6806 => (16#2B83#, 16#0020#, 16#0002#),
         6807 => (16#2B84#, 16#0020#, 16#0002#),
         6808 => (16#2B85#, 16#0020#, 16#0002#),
         6809 => (16#2B85#, 16#0020#, 16#0004#),
         6810 => (16#2B86#, 16#0020#, 16#0002#),
         6811 => (16#2B87#, 16#0020#, 16#0002#),
         6812 => (16#2B87#, 16#0020#, 16#0004#),
         6813 => (16#2B88#, 16#0020#, 16#0002#),
         6814 => (16#2B88#, 16#0020#, 16#0004#),
         6815 => (16#2B89#, 16#0020#, 16#0002#),
         6816 => (16#2B89#, 16#0020#, 16#0004#),
         6817 => (16#2B8A#, 16#0020#, 16#0002#),
         6818 => (16#2B8B#, 16#0020#, 16#0002#),
         6819 => (16#2B8C#, 16#0020#, 16#0002#),
         6820 => (16#2B8D#, 16#0020#, 16#0002#),
         6821 => (16#030B#, 16#0020#, 16#0002#),
         6822 => (16#030C#, 16#0020#, 16#0002#),
         6823 => (16#030D#, 16#0020#, 16#0002#),
         6824 => (16#030E#, 16#0020#, 16#0002#),
         6825 => (16#2A64#, 16#0020#, 16#0002#),
         6826 => (16#2A65#, 16#0020#, 16#0002#),
         6827 => (16#2A66#, 16#0020#, 16#0002#),
         6828 => (16#2A67#, 16#0020#, 16#0002#),
         6829 => (16#2A68#, 16#0020#, 16#0002#),
         6830 => (16#2A69#, 16#0020#, 16#0002#),
         6831 => (16#2A6A#, 16#0020#, 16#0002#),
         6832 => (16#2A6B#, 16#0020#, 16#0002#),
         6833 => (16#2A6C#, 16#0020#, 16#0002#),
         6834 => (16#2A6D#, 16#0020#, 16#0002#),
         6835 => (16#2A71#, 16#0020#, 16#0002#),
         6836 => (16#2A72#, 16#0020#, 16#0002#),
         6837 => (16#2A73#, 16#0020#, 16#0002#),
         6838 => (16#2A74#, 16#0020#, 16#0002#),
         6839 => (16#2A75#, 16#0020#, 16#0002#),
         6840 => (16#2A76#, 16#0020#, 16#0002#),
         6841 => (16#2A77#, 16#0020#, 16#0002#),
         6842 => (16#2A78#, 16#0020#, 16#0002#),
         6843 => (16#2A79#, 16#0020#, 16#0002#),
         6844 => (16#2A7A#, 16#0020#, 16#0002#),
         6845 => (16#2A7B#, 16#0020#, 16#0002#),
         6846 => (16#2A7C#, 16#0020#, 16#0002#),
         6847 => (16#2A7D#, 16#0020#, 16#0002#),
         6848 => (16#2A7E#, 16#0020#, 16#0002#),
         6849 => (16#2A7F#, 16#0020#, 16#0002#),
         6850 => (16#2A80#, 16#0020#, 16#0002#),
         6851 => (16#2A81#, 16#0020#, 16#0002#),
         6852 => (16#2A83#, 16#0020#, 16#0002#),
         6853 => (16#2A85#, 16#0020#, 16#0002#),
         6854 => (16#2A86#, 16#0020#, 16#0002#),
         6855 => (16#2A87#, 16#0020#, 16#0002#),
         6856 => (16#2A88#, 16#0020#, 16#0002#),
         6857 => (16#2A89#, 16#0020#, 16#0002#),
         6858 => (16#2A8A#, 16#0020#, 16#0002#),
         6859 => (16#2A8B#, 16#0020#, 16#0002#),
         6860 => (16#2A8C#, 16#0020#, 16#0002#),
         6861 => (16#2A82#, 16#0020#, 16#0002#),
         6862 => (16#2A84#, 16#0020#, 16#0002#),
         6863 => (16#2A8E#, 16#0020#, 16#0002#),
         6864 => (16#2A8F#, 16#0020#, 16#0002#),
         6865 => (16#2A90#, 16#0020#, 16#0002#),
         6866 => (16#2A91#, 16#0020#, 16#0002#),
         6867 => (16#2A92#, 16#0020#, 16#0002#),
         6868 => (16#2A93#, 16#0020#, 16#0002#),
         6869 => (16#2A94#, 16#0020#, 16#0002#),
         6870 => (16#2A95#, 16#0020#, 16#0002#),
         6871 => (16#2A96#, 16#0020#, 16#0002#),
         6872 => (16#2A97#, 16#0020#, 16#0002#),
         6873 => (16#2A98#, 16#0020#, 16#0002#),
         6874 => (16#2A99#, 16#0020#, 16#0002#),
         6875 => (16#2A9A#, 16#0020#, 16#0002#),
         6876 => (16#2A9B#, 16#0020#, 16#0002#),
         6877 => (16#2A9C#, 16#0020#, 16#0002#),
         6878 => (16#2A9D#, 16#0020#, 16#0002#),
         6879 => (16#2A8D#, 16#0020#, 16#0002#),
         6880 => (16#018E#, 16#0020#, 16#0002#),
         6881 => (16#018F#, 16#0020#, 16#0002#),
         6882 => (16#02EC#, 16#0020#, 16#0002#),
         6883 => (16#02ED#, 16#0020#, 16#0002#),
         6884 => (16#02EE#, 16#0020#, 16#0002#),
         6885 => (16#2A6E#, 16#0020#, 16#0002#),
         6886 => (16#2A6F#, 16#0020#, 16#0002#),
         6887 => (16#2A70#, 16#0020#, 16#0002#),
         6888 => (16#2EF9#, 16#0020#, 16#0002#),
         6889 => (16#2EFA#, 16#0020#, 16#0002#),
         6890 => (16#2EFB#, 16#0020#, 16#0002#),
         6891 => (16#2EFC#, 16#0020#, 16#0002#),
         6892 => (16#2EFD#, 16#0020#, 16#0002#),
         6893 => (16#2EFE#, 16#0020#, 16#0002#),
         6894 => (16#2EFF#, 16#0020#, 16#0002#),
         6895 => (16#2F00#, 16#0020#, 16#0002#),
         6896 => (16#2F01#, 16#0020#, 16#0002#),
         6897 => (16#2F02#, 16#0020#, 16#0002#),
         6898 => (16#2F03#, 16#0020#, 16#0002#),
         6899 => (16#2F04#, 16#0020#, 16#0002#),
         6900 => (16#2F05#, 16#0020#, 16#0002#),
         6901 => (16#2F06#, 16#0020#, 16#0002#),
         6902 => (16#2F07#, 16#0020#, 16#0002#),
         6903 => (16#2F08#, 16#0020#, 16#0002#),
         6904 => (16#2F09#, 16#0020#, 16#0002#),
         6905 => (16#2F0A#, 16#0020#, 16#0002#),
         6906 => (16#2F0B#, 16#0020#, 16#0002#),
         6907 => (16#2F0C#, 16#0020#, 16#0002#),
         6908 => (16#2F0D#, 16#0020#, 16#0002#),
         6909 => (16#2F0E#, 16#0020#, 16#0002#),
         6910 => (16#2F0F#, 16#0020#, 16#0002#),
         6911 => (16#2F10#, 16#0020#, 16#0002#),
         6912 => (16#2F11#, 16#0020#, 16#0002#),
         6913 => (16#2F12#, 16#0020#, 16#0002#),
         6914 => (16#2F13#, 16#0020#, 16#0002#),
         6915 => (16#2F14#, 16#0020#, 16#0002#),
         6916 => (16#2F15#, 16#0020#, 16#0002#),
         6917 => (16#2F16#, 16#0020#, 16#0002#),
         6918 => (16#2F17#, 16#0020#, 16#0002#),
         6919 => (16#2F18#, 16#0020#, 16#0002#),
         6920 => (16#2F19#, 16#0020#, 16#0002#),
         6921 => (16#2F1A#, 16#0020#, 16#0002#),
         6922 => (16#2F1B#, 16#0020#, 16#0002#),
         6923 => (16#2F1C#, 16#0020#, 16#0002#),
         6924 => (16#01B8#, 16#0020#, 16#0002#),
         6925 => (16#01B9#, 16#0020#, 16#0002#),
         6926 => (16#0300#, 16#0020#, 16#0002#),
         6927 => (16#0301#, 16#0020#, 16#0002#),
         6928 => (16#0302#, 16#0020#, 16#0002#),
         6929 => (16#0303#, 16#0020#, 16#0002#),
         6930 => (16#0304#, 16#0020#, 16#0002#),
         6931 => (16#0305#, 16#0020#, 16#0002#),
         6932 => (16#0306#, 16#0020#, 16#0002#),
         6933 => (16#0307#, 16#0020#, 16#0002#),
         6934 => (16#2354#, 16#0020#, 16#0002#),
         6935 => (16#2354#, 16#0020#, 16#0004#),
         6936 => (16#2355#, 16#0020#, 16#0002#),
         6937 => (16#2356#, 16#0020#, 16#0002#),
         6938 => (16#1910#, 16#0020#, 16#0002#),
         6939 => (16#1913#, 16#0020#, 16#0002#),
         6940 => (16#1914#, 16#0020#, 16#0002#),
         6941 => (16#1932#, 16#0020#, 16#0002#),
         6942 => (16#1942#, 16#0020#, 16#0002#),
         6943 => (16#1957#, 16#0020#, 16#0002#),
         6944 => (16#1958#, 16#0020#, 16#0002#),
         6945 => (16#1972#, 16#0020#, 16#0002#),
         6946 => (16#1998#, 16#0020#, 16#0002#),
         6947 => (16#1A04#, 16#0020#, 16#0002#),
         6948 => (16#1A18#, 16#0020#, 16#0002#),
         6949 => (16#1A2D#, 16#0020#, 16#0002#),
         6950 => (16#1A44#, 16#0020#, 16#0002#),
         6951 => (16#1A72#, 16#0020#, 16#0002#),
         6952 => (16#1A86#, 16#0020#, 16#0002#),
         6953 => (16#1AA5#, 16#0020#, 16#0002#),
         6954 => (16#1AB8#, 16#0020#, 16#0002#),
         6955 => (16#1AA6#, 16#0020#, 16#0002#),
         6956 => (16#1AB9#, 16#0020#, 16#0002#),
         6957 => (16#1AB2#, 16#0020#, 16#0002#),
         6958 => (16#1AAC#, 16#0020#, 16#0002#),
         6959 => (16#1ACD#, 16#0020#, 16#0002#),
         6960 => (16#1ABD#, 16#0020#, 16#0002#),
         6961 => (16#1ABE#, 16#0020#, 16#0002#),
         6962 => (16#1AD2#, 16#0020#, 16#0002#),
         6963 => (16#1B00#, 16#0020#, 16#0002#),
         6964 => (16#1B0A#, 16#0020#, 16#0002#),
         6965 => (16#1B5B#, 16#0020#, 16#0002#),
         6966 => (16#1B7B#, 16#0020#, 16#0002#),
         6967 => (16#1B7D#, 16#0020#, 16#0002#),
         6968 => (16#1B7E#, 16#0020#, 16#0002#),
         6969 => (16#1B9B#, 16#0020#, 16#0002#),
         6970 => (16#1BA9#, 16#0020#, 16#0002#),
         6971 => (16#1BBB#, 16#0020#, 16#0002#),
         6972 => (16#1BE7#, 16#0020#, 16#0002#),
         6973 => (16#1C04#, 16#0020#, 16#0002#),
         6974 => (16#1C48#, 16#0020#, 16#0002#),
         6975 => (16#1C49#, 16#0020#, 16#0002#),
         6976 => (16#1C7A#, 16#0020#, 16#0002#),
         6977 => (16#1C88#, 16#0020#, 16#0002#),
         6978 => (16#1C8E#, 16#0020#, 16#0002#),
         6979 => (16#1C93#, 16#0020#, 16#0002#),
         6980 => (16#1C9E#, 16#0020#, 16#0002#),
         6981 => (16#1D72#, 16#0020#, 16#0002#),
         6982 => (16#190C#, 16#0020#, 16#001D#),
         6983 => (16#190C#, 16#0020#, 16#0014#),
         6984 => (16#0000#, 16#0108#, 16#0014#),
         6985 => (16#196E#, 16#0020#, 16#0014#),
         6986 => (16#1925#, 16#0020#, 16#001D#),
         6987 => (16#1931#, 16#0020#, 16#0002#),
         6988 => (16#1953#, 16#0020#, 16#001D#),
         6989 => (16#196E#, 16#0020#, 16#001D#),
         6990 => (16#197C#, 16#0020#, 16#001D#),
         6991 => (16#19B8#, 16#0020#, 16#001D#),
         6992 => (16#19DC#, 16#0020#, 16#001D#),
         6993 => (16#19F6#, 16#0020#, 16#001D#),
         6994 => (16#1A10#, 16#0020#, 16#001D#),
         6995 => (16#1A29#, 16#0020#, 16#001D#),
         6996 => (16#1A3B#, 16#0020#, 16#001D#),
         6997 => (16#1A6E#, 16#0020#, 16#001D#),
         6998 => (16#1A7D#, 16#0020#, 16#001D#),
         6999 => (16#1A85#, 16#0020#, 16#0002#),
         7000 => (16#1AA1#, 16#0020#, 16#001D#),
         7001 => (16#1AC9#, 16#0020#, 16#001D#),
         7002 => (16#1ACE#, 16#0020#, 16#001D#),
         7003 => (16#1AF5#, 16#0020#, 16#001D#),
         7004 => (16#1B57#, 16#0020#, 16#001D#),
         7005 => (16#1B77#, 16#0020#, 16#001D#),
         7006 => (16#1BB7#, 16#0020#, 16#001D#),
         7007 => (16#1916#, 16#0020#, 16#0014#),
         7008 => (16#191A#, 16#0020#, 16#0014#),
         7009 => (16#1914#, 16#0020#, 16#0014#),
         7010 => (16#1925#, 16#0020#, 16#0014#),
         7011 => (16#1953#, 16#0020#, 16#0014#),
         7012 => (16#1981#, 16#0020#, 16#0014#),
         7013 => (16#1986#, 16#0020#, 16#0014#),
         7014 => (16#1998#, 16#0020#, 16#0014#),
         7015 => (16#19B8#, 16#0020#, 16#0014#),
         7016 => (16#1A04#, 16#0020#, 16#0014#),
         7017 => (16#1A29#, 16#0020#, 16#0014#),
         7018 => (16#1A6E#, 16#0020#, 16#0014#),
         7019 => (16#1A9C#, 16#0020#, 16#0014#),
         7020 => (16#1AB4#, 16#0020#, 16#0014#),
         7021 => (16#1ABD#, 16#0020#, 16#0014#),
         7022 => (16#1ABE#, 16#0020#, 16#0014#),
         7023 => (16#1ACE#, 16#0020#, 16#0014#),
         7024 => (16#1B57#, 16#0020#, 16#0014#),
         7025 => (16#1B77#, 16#0020#, 16#0014#),
         7026 => (16#1B7D#, 16#0020#, 16#0014#),
         7027 => (16#1B96#, 16#0020#, 16#0014#),
         7028 => (16#1BA5#, 16#0020#, 16#0014#),
         7029 => (16#1C49#, 16#0020#, 16#0014#),
         7030 => (16#1C78#, 16#0020#, 16#0014#),
         7031 => (16#1C79#, 16#0020#, 16#0014#),
         7032 => (16#1C7B#, 16#0020#, 16#0014#),
         7033 => (16#1C9B#, 16#0020#, 16#0014#),
         7034 => (16#1C9C#, 16#0020#, 16#0014#),
         7035 => (16#19F6#, 16#0020#, 16#0015#),
         7036 => (16#1AF5#, 16#0020#, 16#0015#),
         7037 => (16#1B77#, 16#0020#, 16#0015#),
         7038 => (16#1BA5#, 16#0020#, 16#0015#),
         7039 => (16#1C78#, 16#0020#, 16#0015#),
         7040 => (16#1C79#, 16#0020#, 16#0015#),
         7041 => (16#1C92#, 16#0020#, 16#0015#),
         7042 => (16#1C9B#, 16#0020#, 16#0015#),
         7043 => (16#1C9C#, 16#0020#, 16#0015#),
         7044 => (16#1B7F#, 16#0020#, 16#0002#),
         7045 => (16#1933#, 16#0020#, 16#0002#),
         7046 => (16#1959#, 16#0020#, 16#0002#),
         7047 => (16#19B0#, 16#0020#, 16#0002#),
         7048 => (16#1A73#, 16#0020#, 16#0002#),
         7049 => (16#1A87#, 16#0020#, 16#0002#),
         7050 => (16#1AD5#, 16#0020#, 16#0002#),
         7051 => (16#1B05#, 16#0020#, 16#0002#),
         7052 => (16#1B22#, 16#0020#, 16#0002#),
         7053 => (16#1B38#, 16#0020#, 16#0002#),
         7054 => (16#1B61#, 16#0020#, 16#0002#),
         7055 => (16#1BEC#, 16#0020#, 16#0002#),
         7056 => (16#19D2#, 16#0020#, 16#0002#),
         7057 => (16#1D8A#, 16#0020#, 16#0014#),
         7058 => (16#19B8#, 16#0020#, 16#0004#),
         7059 => (16#0000#, 16#0109#, 16#0004#),
         7060 => (16#1B57#, 16#0020#, 16#0004#),
         7061 => (16#0000#, 16#0108#, 16#0004#),
         7062 => (16#19DC#, 16#0020#, 16#0004#),
         7063 => (16#1A09#, 16#0020#, 16#0002#),
         7064 => (16#1A0F#, 16#0020#, 16#0002#),
         7065 => (16#1AD3#, 16#0020#, 16#0002#),
         7066 => (16#1B87#, 16#0020#, 16#0002#),
         7067 => (16#1BA4#, 16#0020#, 16#0002#),
         7068 => (16#1935#, 16#0020#, 16#0002#),
         7069 => (16#195A#, 16#0020#, 16#0002#),
         7070 => (16#19B1#, 16#0020#, 16#0002#),
         7071 => (16#19C9#, 16#0020#, 16#0002#),
         7072 => (16#1A2E#, 16#0020#, 16#0002#),
         7073 => (16#1A56#, 16#0020#, 16#0002#),
         7074 => (16#1A74#, 16#0020#, 16#0002#),
         7075 => (16#1A91#, 16#0020#, 16#0002#),
         7076 => (16#1AD6#, 16#0020#, 16#0002#),
         7077 => (16#1B0F#, 16#0020#, 16#0002#),
         7078 => (16#1B39#, 16#0020#, 16#0002#),
         7079 => (16#1B49#, 16#0020#, 16#0002#),
         7080 => (16#1BAB#, 16#0020#, 16#0002#),
         7081 => (16#1BC5#, 16#0020#, 16#0002#),
         7082 => (16#1BED#, 16#0020#, 16#0002#),
         7083 => (16#1912#, 16#0020#, 16#0002#),
         7084 => (16#191F#, 16#0020#, 16#0002#),
         7085 => (16#1963#, 16#0020#, 16#0002#),
         7086 => (16#1979#, 16#0020#, 16#0002#),
         7087 => (16#198A#, 16#0020#, 16#0002#),
         7088 => (16#1997#, 16#0020#, 16#0002#),
         7089 => (16#1985#, 16#0020#, 16#0002#),
         7090 => (16#1A0A#, 16#0020#, 16#0002#),
         7091 => (16#1ABB#, 16#0020#, 16#0002#),
         7092 => (16#1B52#, 16#0020#, 16#0002#),
         7093 => (16#1B88#, 16#0020#, 16#0002#),
         7094 => (16#1C09#, 16#0020#, 16#0002#),
         7095 => (16#1920#, 16#0020#, 16#0014#),
         7096 => (16#193E#, 16#0020#, 16#0014#),
         7097 => (16#194D#, 16#0020#, 16#0014#),
         7098 => (16#1953#, 16#0020#, 16#0014#),
         7099 => (16#0000#, 16#0108#, 16#0014#),
         7100 => (16#1993#, 16#0020#, 16#0014#),
         7101 => (16#19A9#, 16#0020#, 16#0014#),
         7102 => (16#1A21#, 16#0020#, 16#0014#),
         7103 => (16#19BC#, 16#0020#, 16#0014#),
         7104 => (16#1B8A#, 16#0020#, 16#0014#),
         7105 => (16#1A05#, 16#0020#, 16#0014#),
         7106 => (16#1A0B#, 16#0020#, 16#0014#),
         7107 => (16#19FE#, 16#0020#, 16#0014#),
         7108 => (16#1A09#, 16#0020#, 16#0014#),
         7109 => (16#1A1D#, 16#0020#, 16#0014#),
         7110 => (16#1A57#, 16#0020#, 16#0014#),
         7111 => (16#1A56#, 16#0020#, 16#0014#),
         7112 => (16#1A3F#, 16#0020#, 16#0014#),
         7113 => (16#1A75#, 16#0020#, 16#0014#),
         7114 => (16#1B9C#, 16#0020#, 16#0014#),
         7115 => (16#1A88#, 16#0020#, 16#0014#),
         7116 => (16#1A92#, 16#0020#, 16#0014#),
         7117 => (16#1A81#, 16#0020#, 16#0014#),
         7118 => (16#1AC0#, 16#0020#, 16#0014#),
         7119 => (16#1ADE#, 16#0020#, 16#0014#),
         7120 => (16#1B3A#, 16#0020#, 16#0014#),
         7121 => (16#1B44#, 16#0020#, 16#0014#),
         7122 => (16#1B62#, 16#0020#, 16#0014#),
         7123 => (16#1B82#, 16#0020#, 16#0014#),
         7124 => (16#1BA0#, 16#0020#, 16#0014#),
         7125 => (16#1B7B#, 16#0020#, 16#0014#),
         7126 => (16#1BAC#, 16#0020#, 16#0014#),
         7127 => (16#1BB3#, 16#0020#, 16#0014#),
         7128 => (16#1BE3#, 16#0020#, 16#0014#),
         7129 => (16#1BF2#, 16#0020#, 16#0014#),
         7130 => (16#1BF6#, 16#0020#, 16#0014#),
         7131 => (16#1C00#, 16#0020#, 16#0014#),
         7132 => (16#1C83#, 16#0020#, 16#0014#),
         7133 => (16#1C1F#, 16#0020#, 16#0004#),
         7134 => (16#190C#, 16#0020#, 16#0004#),
         7135 => (16#1AA1#, 16#0020#, 16#0004#),
         7136 => (16#190C#, 16#0020#, 16#0004#),
         7137 => (16#1BA5#, 16#0020#, 16#0004#),
         7138 => (16#193E#, 16#0020#, 16#0004#),
         7139 => (16#0000#, 16#0030#, 16#0004#),
         7140 => (16#1953#, 16#0020#, 16#0004#),
         7141 => (16#0000#, 16#0109#, 16#0004#),
         7142 => (16#19C1#, 16#0020#, 16#0004#),
         7143 => (16#1A29#, 16#0020#, 16#0004#),
         7144 => (16#1A3F#, 16#0020#, 16#0004#),
         7145 => (16#1A72#, 16#0020#, 16#0004#),
         7146 => (16#1A81#, 16#0020#, 16#0004#),
         7147 => (16#1AFA#, 16#0020#, 16#0004#),
         7148 => (16#1AFF#, 16#0020#, 16#0004#),
         7149 => (16#191A#, 16#0020#, 16#0004#),
         7150 => (16#1981#, 16#0020#, 16#0004#),
         7151 => (16#1A4F#, 16#0020#, 16#0004#),
         7152 => (16#1AA1#, 16#0020#, 16#0004#),
         7153 => (16#0000#, 16#0034#, 16#0004#),
         7154 => (16#1B77#, 16#0020#, 16#0004#),
         7155 => (16#0000#, 16#0034#, 16#0004#),
         7156 => (16#190C#, 16#0020#, 16#0004#),
         7157 => (16#0000#, 16#002B#, 16#0004#),
         7158 => (16#1AA1#, 16#0020#, 16#0004#),
         7159 => (16#0000#, 16#002B#, 16#0004#),
         7160 => (16#1B77#, 16#0020#, 16#0004#),
         7161 => (16#0000#, 16#002B#, 16#0004#),
         7162 => (16#190C#, 16#0020#, 16#0008#),
         7163 => (16#0000#, 16#0044#, 16#0002#),
         7164 => (16#190C#, 16#0020#, 16#0002#),
         7165 => (16#0000#, 16#0044#, 16#0002#),
         7166 => (16#1925#, 16#0020#, 16#0008#),
         7167 => (16#0000#, 16#002E#, 16#0002#),
         7168 => (16#1925#, 16#0020#, 16#0002#),
         7169 => (16#0000#, 16#002E#, 16#0002#),
         7170 => (16#1925#, 16#0020#, 16#0008#),
         7171 => (16#0000#, 16#0042#, 16#0002#),
         7172 => (16#1925#, 16#0020#, 16#0002#),
         7173 => (16#0000#, 16#0042#, 16#0002#),
         7174 => (16#1925#, 16#0020#, 16#0008#),
         7175 => (16#0000#, 16#0049#, 16#0002#),
         7176 => (16#1925#, 16#0020#, 16#0002#),
         7177 => (16#0000#, 16#0049#, 16#0002#),
         7178 => (16#193E#, 16#0020#, 16#0008#),
         7179 => (16#0000#, 16#0030#, 16#0002#),
         7180 => (16#0000#, 16#0024#, 16#0002#),
         7181 => (16#193E#, 16#0020#, 16#0002#),
         7182 => (16#0000#, 16#0030#, 16#0002#),
         7183 => (16#0000#, 16#0024#, 16#0002#),
         7184 => (16#1953#, 16#0020#, 16#0008#),
         7185 => (16#0000#, 16#002E#, 16#0002#),
         7186 => (16#1953#, 16#0020#, 16#0002#),
         7187 => (16#0000#, 16#002E#, 16#0002#),
         7188 => (16#1953#, 16#0020#, 16#0008#),
         7189 => (16#0000#, 16#0042#, 16#0002#),
         7190 => (16#1953#, 16#0020#, 16#0002#),
         7191 => (16#0000#, 16#0042#, 16#0002#),
         7192 => (16#1953#, 16#0020#, 16#0008#),
         7193 => (16#0000#, 16#0049#, 16#0002#),
         7194 => (16#1953#, 16#0020#, 16#0002#),
         7195 => (16#0000#, 16#0049#, 16#0002#),
         7196 => (16#1953#, 16#0020#, 16#0008#),
         7197 => (16#0000#, 16#0030#, 16#0002#),
         7198 => (16#1953#, 16#0020#, 16#0002#),
         7199 => (16#0000#, 16#0030#, 16#0002#),
         7200 => (16#1953#, 16#0020#, 16#0008#),
         7201 => (16#0000#, 16#0046#, 16#0002#),
         7202 => (16#1953#, 16#0020#, 16#0002#),
         7203 => (16#0000#, 16#0046#, 16#0002#),
         7204 => (16#196E#, 16#0020#, 16#0008#),
         7205 => (16#0000#, 16#0032#, 16#0002#),
         7206 => (16#0000#, 16#0025#, 16#0002#),
         7207 => (16#196E#, 16#0020#, 16#0002#),
         7208 => (16#0000#, 16#0032#, 16#0002#),
         7209 => (16#0000#, 16#0025#, 16#0002#),
         7210 => (16#196E#, 16#0020#, 16#0008#),
         7211 => (16#0000#, 16#0032#, 16#0002#),
         7212 => (16#0000#, 16#0024#, 16#0002#),
         7213 => (16#196E#, 16#0020#, 16#0002#),
         7214 => (16#0000#, 16#0032#, 16#0002#),
         7215 => (16#0000#, 16#0024#, 16#0002#),
         7216 => (16#196E#, 16#0020#, 16#0008#),
         7217 => (16#0000#, 16#0046#, 16#0002#),
         7218 => (16#196E#, 16#0020#, 16#0002#),
         7219 => (16#0000#, 16#0046#, 16#0002#),
         7220 => (16#196E#, 16#0020#, 16#0008#),
         7221 => (16#0000#, 16#0048#, 16#0002#),
         7222 => (16#196E#, 16#0020#, 16#0002#),
         7223 => (16#0000#, 16#0048#, 16#0002#),
         7224 => (16#196E#, 16#0020#, 16#0008#),
         7225 => (16#0000#, 16#0030#, 16#0002#),
         7226 => (16#0000#, 16#0026#, 16#0002#),
         7227 => (16#196E#, 16#0020#, 16#0002#),
         7228 => (16#0000#, 16#0030#, 16#0002#),
         7229 => (16#0000#, 16#0026#, 16#0002#),
         7230 => (16#19A9#, 16#0020#, 16#0008#),
         7231 => (16#0000#, 16#002E#, 16#0002#),
         7232 => (16#19A9#, 16#0020#, 16#0002#),
         7233 => (16#0000#, 16#002E#, 16#0002#),
         7234 => (16#19B8#, 16#0020#, 16#0008#),
         7235 => (16#0000#, 16#0032#, 16#0002#),
         7236 => (16#19B8#, 16#0020#, 16#0002#),
         7237 => (16#0000#, 16#0032#, 16#0002#),
         7238 => (16#19DC#, 16#0020#, 16#0008#),
         7239 => (16#0000#, 16#002E#, 16#0002#),
         7240 => (16#19DC#, 16#0020#, 16#0002#),
         7241 => (16#0000#, 16#002E#, 16#0002#),
         7242 => (16#19DC#, 16#0020#, 16#0008#),
         7243 => (16#0000#, 16#0042#, 16#0002#),
         7244 => (16#19DC#, 16#0020#, 16#0002#),
         7245 => (16#0000#, 16#0042#, 16#0002#),
         7246 => (16#19DC#, 16#0020#, 16#0008#),
         7247 => (16#0000#, 16#002B#, 16#0002#),
         7248 => (16#19DC#, 16#0020#, 16#0002#),
         7249 => (16#0000#, 16#002B#, 16#0002#),
         7250 => (16#19DC#, 16#0020#, 16#0008#),
         7251 => (16#0000#, 16#0030#, 16#0002#),
         7252 => (16#19DC#, 16#0020#, 16#0002#),
         7253 => (16#0000#, 16#0030#, 16#0002#),
         7254 => (16#19DC#, 16#0020#, 16#0008#),
         7255 => (16#0000#, 16#0047#, 16#0002#),
         7256 => (16#19DC#, 16#0020#, 16#0002#),
         7257 => (16#0000#, 16#0047#, 16#0002#),
         7258 => (16#19F6#, 16#0020#, 16#0008#),
         7259 => (16#0000#, 16#0048#, 16#0002#),
         7260 => (16#19F6#, 16#0020#, 16#0002#),
         7261 => (16#0000#, 16#0048#, 16#0002#),
         7262 => (16#19F6#, 16#0020#, 16#0008#),
         7263 => (16#0000#, 16#002B#, 16#0002#),
         7264 => (16#0000#, 16#0024#, 16#0002#),
         7265 => (16#19F6#, 16#0020#, 16#0002#),
         7266 => (16#0000#, 16#002B#, 16#0002#),
         7267 => (16#0000#, 16#0024#, 16#0002#),
         7268 => (16#1A29#, 16#0020#, 16#0008#),
         7269 => (16#0000#, 16#0024#, 16#0002#),
         7270 => (16#1A29#, 16#0020#, 16#0002#),
         7271 => (16#0000#, 16#0024#, 16#0002#),
         7272 => (16#1A29#, 16#0020#, 16#0008#),
         7273 => (16#0000#, 16#0042#, 16#0002#),
         7274 => (16#1A29#, 16#0020#, 16#0002#),
         7275 => (16#0000#, 16#0042#, 16#0002#),
         7276 => (16#1A29#, 16#0020#, 16#0008#),
         7277 => (16#0000#, 16#0049#, 16#0002#),
         7278 => (16#1A29#, 16#0020#, 16#0002#),
         7279 => (16#0000#, 16#0049#, 16#0002#),
         7280 => (16#1A3B#, 16#0020#, 16#0008#),
         7281 => (16#0000#, 16#0042#, 16#0002#),
         7282 => (16#1A3B#, 16#0020#, 16#0002#),
         7283 => (16#0000#, 16#0042#, 16#0002#),
         7284 => (16#1A3B#, 16#0020#, 16#0008#),
         7285 => (16#0000#, 16#0042#, 16#0002#),
         7286 => (16#0000#, 16#0032#, 16#0002#),
         7287 => (16#1A3B#, 16#0020#, 16#0002#),
         7288 => (16#0000#, 16#0042#, 16#0002#),
         7289 => (16#0000#, 16#0032#, 16#0002#),
         7290 => (16#1A3B#, 16#0020#, 16#0008#),
         7291 => (16#0000#, 16#0049#, 16#0002#),
         7292 => (16#1A3B#, 16#0020#, 16#0002#),
         7293 => (16#0000#, 16#0049#, 16#0002#),
         7294 => (16#1A3B#, 16#0020#, 16#0008#),
         7295 => (16#0000#, 16#0046#, 16#0002#),
         7296 => (16#1A3B#, 16#0020#, 16#0002#),
         7297 => (16#0000#, 16#0046#, 16#0002#),
         7298 => (16#1A6E#, 16#0020#, 16#0008#),
         7299 => (16#0000#, 16#0024#, 16#0002#),
         7300 => (16#1A6E#, 16#0020#, 16#0002#),
         7301 => (16#0000#, 16#0024#, 16#0002#),
         7302 => (16#1A6E#, 16#0020#, 16#0008#),
         7303 => (16#0000#, 16#002E#, 16#0002#),
         7304 => (16#1A6E#, 16#0020#, 16#0002#),
         7305 => (16#0000#, 16#002E#, 16#0002#),
         7306 => (16#1A6E#, 16#0020#, 16#0008#),
         7307 => (16#0000#, 16#0042#, 16#0002#),
         7308 => (16#1A6E#, 16#0020#, 16#0002#),
         7309 => (16#0000#, 16#0042#, 16#0002#),
         7310 => (16#1A7D#, 16#0020#, 16#0008#),
         7311 => (16#0000#, 16#002E#, 16#0002#),
         7312 => (16#1A7D#, 16#0020#, 16#0002#),
         7313 => (16#0000#, 16#002E#, 16#0002#),
         7314 => (16#1A7D#, 16#0020#, 16#0008#),
         7315 => (16#0000#, 16#0042#, 16#0002#),
         7316 => (16#1A7D#, 16#0020#, 16#0002#),
         7317 => (16#0000#, 16#0042#, 16#0002#),
         7318 => (16#1A7D#, 16#0020#, 16#0008#),
         7319 => (16#0000#, 16#0049#, 16#0002#),
         7320 => (16#1A7D#, 16#0020#, 16#0002#),
         7321 => (16#0000#, 16#0049#, 16#0002#),
         7322 => (16#1A7D#, 16#0020#, 16#0008#),
         7323 => (16#0000#, 16#0046#, 16#0002#),
         7324 => (16#1A7D#, 16#0020#, 16#0002#),
         7325 => (16#0000#, 16#0046#, 16#0002#),
         7326 => (16#1AA1#, 16#0020#, 16#0008#),
         7327 => (16#0000#, 16#002D#, 16#0002#),
         7328 => (16#0000#, 16#0024#, 16#0002#),
         7329 => (16#1AA1#, 16#0020#, 16#0002#),
         7330 => (16#0000#, 16#002D#, 16#0002#),
         7331 => (16#0000#, 16#0024#, 16#0002#),
         7332 => (16#1AA1#, 16#0020#, 16#0008#),
         7333 => (16#0000#, 16#002D#, 16#0002#),
         7334 => (16#0000#, 16#002B#, 16#0002#),
         7335 => (16#1AA1#, 16#0020#, 16#0002#),
         7336 => (16#0000#, 16#002D#, 16#0002#),
         7337 => (16#0000#, 16#002B#, 16#0002#),
         7338 => (16#1AA1#, 16#0020#, 16#0008#),
         7339 => (16#0000#, 16#0032#, 16#0002#),
         7340 => (16#0000#, 16#0025#, 16#0002#),
         7341 => (16#1AA1#, 16#0020#, 16#0002#),
         7342 => (16#0000#, 16#0032#, 16#0002#),
         7343 => (16#0000#, 16#0025#, 16#0002#),
         7344 => (16#1AA1#, 16#0020#, 16#0008#),
         7345 => (16#0000#, 16#0032#, 16#0002#),
         7346 => (16#0000#, 16#0024#, 16#0002#),
         7347 => (16#1AA1#, 16#0020#, 16#0002#),
         7348 => (16#0000#, 16#0032#, 16#0002#),
         7349 => (16#0000#, 16#0024#, 16#0002#),
         7350 => (16#1ACE#, 16#0020#, 16#0008#),
         7351 => (16#0000#, 16#0024#, 16#0002#),
         7352 => (16#1ACE#, 16#0020#, 16#0002#),
         7353 => (16#0000#, 16#0024#, 16#0002#),
         7354 => (16#1ACE#, 16#0020#, 16#0008#),
         7355 => (16#0000#, 16#002E#, 16#0002#),
         7356 => (16#1ACE#, 16#0020#, 16#0002#),
         7357 => (16#0000#, 16#002E#, 16#0002#),
         7358 => (16#1AF5#, 16#0020#, 16#0008#),
         7359 => (16#0000#, 16#002E#, 16#0002#),
         7360 => (16#1AF5#, 16#0020#, 16#0002#),
         7361 => (16#0000#, 16#002E#, 16#0002#),
         7362 => (16#1AF5#, 16#0020#, 16#0008#),
         7363 => (16#0000#, 16#0042#, 16#0002#),
         7364 => (16#1AF5#, 16#0020#, 16#0002#),
         7365 => (16#0000#, 16#0042#, 16#0002#),
         7366 => (16#1AF5#, 16#0020#, 16#0008#),
         7367 => (16#0000#, 16#0042#, 16#0002#),
         7368 => (16#0000#, 16#0032#, 16#0002#),
         7369 => (16#1AF5#, 16#0020#, 16#0002#),
         7370 => (16#0000#, 16#0042#, 16#0002#),
         7371 => (16#0000#, 16#0032#, 16#0002#),
         7372 => (16#1AF5#, 16#0020#, 16#0008#),
         7373 => (16#0000#, 16#0049#, 16#0002#),
         7374 => (16#1AF5#, 16#0020#, 16#0002#),
         7375 => (16#0000#, 16#0049#, 16#0002#),
         7376 => (16#1B33#, 16#0020#, 16#0008#),
         7377 => (16#0000#, 16#002E#, 16#0002#),
         7378 => (16#1B33#, 16#0020#, 16#0002#),
         7379 => (16#0000#, 16#002E#, 16#0002#),
         7380 => (16#1B33#, 16#0020#, 16#0008#),
         7381 => (16#0000#, 16#0042#, 16#0002#),
         7382 => (16#1B33#, 16#0020#, 16#0002#),
         7383 => (16#0000#, 16#0042#, 16#0002#),
         7384 => (16#1B33#, 16#0020#, 16#0008#),
         7385 => (16#0000#, 16#0024#, 16#0002#),
         7386 => (16#0000#, 16#002E#, 16#0002#),
         7387 => (16#1B33#, 16#0020#, 16#0002#),
         7388 => (16#0000#, 16#0024#, 16#0002#),
         7389 => (16#0000#, 16#002E#, 16#0002#),
         7390 => (16#1B33#, 16#0020#, 16#0008#),
         7391 => (16#0000#, 16#0028#, 16#0002#),
         7392 => (16#0000#, 16#002E#, 16#0002#),
         7393 => (16#1B33#, 16#0020#, 16#0002#),
         7394 => (16#0000#, 16#0028#, 16#0002#),
         7395 => (16#0000#, 16#002E#, 16#0002#),
         7396 => (16#1B33#, 16#0020#, 16#0008#),
         7397 => (16#0000#, 16#0042#, 16#0002#),
         7398 => (16#0000#, 16#002E#, 16#0002#),
         7399 => (16#1B33#, 16#0020#, 16#0002#),
         7400 => (16#0000#, 16#0042#, 16#0002#),
         7401 => (16#0000#, 16#002E#, 16#0002#),
         7402 => (16#1B57#, 16#0020#, 16#0008#),
         7403 => (16#0000#, 16#002E#, 16#0002#),
         7404 => (16#1B57#, 16#0020#, 16#0002#),
         7405 => (16#0000#, 16#002E#, 16#0002#),
         7406 => (16#1B57#, 16#0020#, 16#0008#),
         7407 => (16#0000#, 16#0042#, 16#0002#),
         7408 => (16#1B57#, 16#0020#, 16#0002#),
         7409 => (16#0000#, 16#0042#, 16#0002#),
         7410 => (16#1B57#, 16#0020#, 16#0008#),
         7411 => (16#0000#, 16#0049#, 16#0002#),
         7412 => (16#1B57#, 16#0020#, 16#0002#),
         7413 => (16#0000#, 16#0049#, 16#0002#),
         7414 => (16#1B57#, 16#0020#, 16#0008#),
         7415 => (16#0000#, 16#0046#, 16#0002#),
         7416 => (16#1B57#, 16#0020#, 16#0002#),
         7417 => (16#0000#, 16#0046#, 16#0002#),
         7418 => (16#1B77#, 16#0020#, 16#0008#),
         7419 => (16#0000#, 16#0043#, 16#0002#),
         7420 => (16#1B77#, 16#0020#, 16#0002#),
         7421 => (16#0000#, 16#0043#, 16#0002#),
         7422 => (16#1B77#, 16#0020#, 16#0008#),
         7423 => (16#0000#, 16#0048#, 16#0002#),
         7424 => (16#1B77#, 16#0020#, 16#0002#),
         7425 => (16#0000#, 16#0048#, 16#0002#),
         7426 => (16#1B77#, 16#0020#, 16#0008#),
         7427 => (16#0000#, 16#0046#, 16#0002#),
         7428 => (16#1B77#, 16#0020#, 16#0002#),
         7429 => (16#0000#, 16#0046#, 16#0002#),
         7430 => (16#1B77#, 16#0020#, 16#0008#),
         7431 => (16#0000#, 16#002D#, 16#0002#),
         7432 => (16#0000#, 16#0024#, 16#0002#),
         7433 => (16#1B77#, 16#0020#, 16#0002#),
         7434 => (16#0000#, 16#002D#, 16#0002#),
         7435 => (16#0000#, 16#0024#, 16#0002#),
         7436 => (16#1B77#, 16#0020#, 16#0008#),
         7437 => (16#0000#, 16#0032#, 16#0002#),
         7438 => (16#0000#, 16#002B#, 16#0002#),
         7439 => (16#1B77#, 16#0020#, 16#0002#),
         7440 => (16#0000#, 16#0032#, 16#0002#),
         7441 => (16#0000#, 16#002B#, 16#0002#),
         7442 => (16#1BA5#, 16#0020#, 16#0008#),
         7443 => (16#0000#, 16#002D#, 16#0002#),
         7444 => (16#1BA5#, 16#0020#, 16#0002#),
         7445 => (16#0000#, 16#002D#, 16#0002#),
         7446 => (16#1BA5#, 16#0020#, 16#0008#),
         7447 => (16#0000#, 16#0042#, 16#0002#),
         7448 => (16#1BA5#, 16#0020#, 16#0002#),
         7449 => (16#0000#, 16#0042#, 16#0002#),
         7450 => (16#1BB7#, 16#0020#, 16#0008#),
         7451 => (16#0000#, 16#0025#, 16#0002#),
         7452 => (16#1BB7#, 16#0020#, 16#0002#),
         7453 => (16#0000#, 16#0025#, 16#0002#),
         7454 => (16#1BB7#, 16#0020#, 16#0008#),
         7455 => (16#0000#, 16#0024#, 16#0002#),
         7456 => (16#1BB7#, 16#0020#, 16#0002#),
         7457 => (16#0000#, 16#0024#, 16#0002#),
         7458 => (16#1BB7#, 16#0020#, 16#0008#),
         7459 => (16#0000#, 16#002B#, 16#0002#),
         7460 => (16#1BB7#, 16#0020#, 16#0002#),
         7461 => (16#0000#, 16#002B#, 16#0002#),
         7462 => (16#1BB7#, 16#0020#, 16#0008#),
         7463 => (16#0000#, 16#002E#, 16#0002#),
         7464 => (16#1BB7#, 16#0020#, 16#0002#),
         7465 => (16#0000#, 16#002E#, 16#0002#),
         7466 => (16#1BB7#, 16#0020#, 16#0008#),
         7467 => (16#0000#, 16#0042#, 16#0002#),
         7468 => (16#1BB7#, 16#0020#, 16#0002#),
         7469 => (16#0000#, 16#0042#, 16#0002#),
         7470 => (16#1BC1#, 16#0020#, 16#0008#),
         7471 => (16#0000#, 16#002E#, 16#0002#),
         7472 => (16#1BC1#, 16#0020#, 16#0002#),
         7473 => (16#0000#, 16#002E#, 16#0002#),
         7474 => (16#1BC1#, 16#0020#, 16#0008#),
         7475 => (16#0000#, 16#002B#, 16#0002#),
         7476 => (16#1BC1#, 16#0020#, 16#0002#),
         7477 => (16#0000#, 16#002B#, 16#0002#),
         7478 => (16#1BCD#, 16#0020#, 16#0008#),
         7479 => (16#0000#, 16#002E#, 16#0002#),
         7480 => (16#1BCD#, 16#0020#, 16#0002#),
         7481 => (16#0000#, 16#002E#, 16#0002#),
         7482 => (16#1BE3#, 16#0020#, 16#0008#),
         7483 => (16#0000#, 16#0027#, 16#0002#),
         7484 => (16#1BE3#, 16#0020#, 16#0002#),
         7485 => (16#0000#, 16#0027#, 16#0002#),
         7486 => (16#1BE3#, 16#0020#, 16#0008#),
         7487 => (16#0000#, 16#0042#, 16#0002#),
         7488 => (16#1BE3#, 16#0020#, 16#0002#),
         7489 => (16#0000#, 16#0042#, 16#0002#),
         7490 => (16#1BE3#, 16#0020#, 16#0008#),
         7491 => (16#0000#, 16#0049#, 16#0002#),
         7492 => (16#1BE3#, 16#0020#, 16#0002#),
         7493 => (16#0000#, 16#0049#, 16#0002#),
         7494 => (16#19DC#, 16#0020#, 16#0002#),
         7495 => (16#0000#, 16#0049#, 16#0002#),
         7496 => (16#1B57#, 16#0020#, 16#0002#),
         7497 => (16#0000#, 16#002B#, 16#0002#),
         7498 => (16#1BB7#, 16#0020#, 16#0002#),
         7499 => (16#0000#, 16#0029#, 16#0002#),
         7500 => (16#1BCD#, 16#0020#, 16#0002#),
         7501 => (16#0000#, 16#0029#, 16#0002#),
         7502 => (16#190C#, 16#0020#, 16#0004#),
         7503 => (16#1C3F#, 16#0020#, 16#0004#),
         7504 => (16#1B33#, 16#0020#, 16#0004#),
         7505 => (16#0000#, 16#0109#, 16#0004#),
         7506 => (16#0000#, 16#002E#, 16#0002#),
         7507 => (16#1B42#, 16#0020#, 16#0002#),
         7508 => (16#1B43#, 16#0020#, 16#0002#),
         7509 => (16#1B33#, 16#0020#, 16#000A#),
         7510 => (16#0000#, 16#0108#, 16#0004#),
         7511 => (16#1B33#, 16#0020#, 16#000A#),
         7512 => (16#196D#, 16#0020#, 16#0002#),
         7513 => (16#190C#, 16#0020#, 16#0008#),
         7514 => (16#0000#, 16#0042#, 16#0002#),
         7515 => (16#190C#, 16#0020#, 16#0002#),
         7516 => (16#0000#, 16#0042#, 16#0002#),
         7517 => (16#190C#, 16#0020#, 16#0008#),
         7518 => (16#0000#, 16#003B#, 16#0002#),
         7519 => (16#190C#, 16#0020#, 16#0002#),
         7520 => (16#0000#, 16#003B#, 16#0002#),
         7521 => (16#190C#, 16#0020#, 16#0008#),
         7522 => (16#0000#, 16#0027#, 16#0002#),
         7523 => (16#0000#, 16#0024#, 16#0002#),
         7524 => (16#190C#, 16#0020#, 16#0002#),
         7525 => (16#0000#, 16#0027#, 16#0002#),
         7526 => (16#0000#, 16#0024#, 16#0002#),
         7527 => (16#190C#, 16#0020#, 16#0008#),
         7528 => (16#0000#, 16#0027#, 16#0002#),
         7529 => (16#0000#, 16#0025#, 16#0002#),
         7530 => (16#190C#, 16#0020#, 16#0002#),
         7531 => (16#0000#, 16#0027#, 16#0002#),
         7532 => (16#0000#, 16#0025#, 16#0002#),
         7533 => (16#190C#, 16#0020#, 16#0008#),
         7534 => (16#0000#, 16#0027#, 16#0002#),
         7535 => (16#0000#, 16#003B#, 16#0002#),
         7536 => (16#190C#, 16#0020#, 16#0002#),
         7537 => (16#0000#, 16#0027#, 16#0002#),
         7538 => (16#0000#, 16#003B#, 16#0002#),
         7539 => (16#190C#, 16#0020#, 16#0008#),
         7540 => (16#0000#, 16#0027#, 16#0002#),
         7541 => (16#0000#, 16#002D#, 16#0002#),
         7542 => (16#190C#, 16#0020#, 16#0002#),
         7543 => (16#0000#, 16#0027#, 16#0002#),
         7544 => (16#0000#, 16#002D#, 16#0002#),
         7545 => (16#190C#, 16#0020#, 16#0008#),
         7546 => (16#0000#, 16#0042#, 16#0002#),
         7547 => (16#0000#, 16#0027#, 16#0002#),
         7548 => (16#190C#, 16#0020#, 16#0002#),
         7549 => (16#0000#, 16#0042#, 16#0002#),
         7550 => (16#0000#, 16#0027#, 16#0002#),
         7551 => (16#190C#, 16#0020#, 16#0008#),
         7552 => (16#0000#, 16#0026#, 16#0002#),
         7553 => (16#0000#, 16#0024#, 16#0002#),
         7554 => (16#190C#, 16#0020#, 16#0002#),
         7555 => (16#0000#, 16#0026#, 16#0002#),
         7556 => (16#0000#, 16#0024#, 16#0002#),
         7557 => (16#190C#, 16#0020#, 16#0008#),
         7558 => (16#0000#, 16#0026#, 16#0002#),
         7559 => (16#0000#, 16#0025#, 16#0002#),
         7560 => (16#190C#, 16#0020#, 16#0002#),
         7561 => (16#0000#, 16#0026#, 16#0002#),
         7562 => (16#0000#, 16#0025#, 16#0002#),
         7563 => (16#190C#, 16#0020#, 16#0008#),
         7564 => (16#0000#, 16#0026#, 16#0002#),
         7565 => (16#0000#, 16#003B#, 16#0002#),
         7566 => (16#190C#, 16#0020#, 16#0002#),
         7567 => (16#0000#, 16#0026#, 16#0002#),
         7568 => (16#0000#, 16#003B#, 16#0002#),
         7569 => (16#190C#, 16#0020#, 16#0008#),
         7570 => (16#0000#, 16#0026#, 16#0002#),
         7571 => (16#0000#, 16#002D#, 16#0002#),
         7572 => (16#190C#, 16#0020#, 16#0002#),
         7573 => (16#0000#, 16#0026#, 16#0002#),
         7574 => (16#0000#, 16#002D#, 16#0002#),
         7575 => (16#190C#, 16#0020#, 16#0008#),
         7576 => (16#0000#, 16#0042#, 16#0002#),
         7577 => (16#0000#, 16#0026#, 16#0002#),
         7578 => (16#190C#, 16#0020#, 16#0002#),
         7579 => (16#0000#, 16#0042#, 16#0002#),
         7580 => (16#0000#, 16#0026#, 16#0002#),
         7581 => (16#196E#, 16#0020#, 16#0008#),
         7582 => (16#0000#, 16#0042#, 16#0002#),
         7583 => (16#196E#, 16#0020#, 16#0002#),
         7584 => (16#0000#, 16#0042#, 16#0002#),
         7585 => (16#196E#, 16#0020#, 16#0008#),
         7586 => (16#0000#, 16#003B#, 16#0002#),
         7587 => (16#196E#, 16#0020#, 16#0002#),
         7588 => (16#0000#, 16#003B#, 16#0002#),
         7589 => (16#196E#, 16#0020#, 16#0008#),
         7590 => (16#0000#, 16#002D#, 16#0002#),
         7591 => (16#196E#, 16#0020#, 16#0002#),
         7592 => (16#0000#, 16#002D#, 16#0002#),
         7593 => (16#196E#, 16#0020#, 16#0008#),
         7594 => (16#0000#, 16#0027#, 16#0002#),
         7595 => (16#0000#, 16#0024#, 16#0002#),
         7596 => (16#196E#, 16#0020#, 16#0002#),
         7597 => (16#0000#, 16#0027#, 16#0002#),
         7598 => (16#0000#, 16#0024#, 16#0002#),
         7599 => (16#196E#, 16#0020#, 16#0008#),
         7600 => (16#0000#, 16#0027#, 16#0002#),
         7601 => (16#0000#, 16#0025#, 16#0002#),
         7602 => (16#196E#, 16#0020#, 16#0002#),
         7603 => (16#0000#, 16#0027#, 16#0002#),
         7604 => (16#0000#, 16#0025#, 16#0002#),
         7605 => (16#196E#, 16#0020#, 16#0008#),
         7606 => (16#0000#, 16#0027#, 16#0002#),
         7607 => (16#0000#, 16#003B#, 16#0002#),
         7608 => (16#196E#, 16#0020#, 16#0002#),
         7609 => (16#0000#, 16#0027#, 16#0002#),
         7610 => (16#0000#, 16#003B#, 16#0002#),
         7611 => (16#196E#, 16#0020#, 16#0008#),
         7612 => (16#0000#, 16#0027#, 16#0002#),
         7613 => (16#0000#, 16#002D#, 16#0002#),
         7614 => (16#196E#, 16#0020#, 16#0002#),
         7615 => (16#0000#, 16#0027#, 16#0002#),
         7616 => (16#0000#, 16#002D#, 16#0002#),
         7617 => (16#196E#, 16#0020#, 16#0008#),
         7618 => (16#0000#, 16#0042#, 16#0002#),
         7619 => (16#0000#, 16#0027#, 16#0002#),
         7620 => (16#196E#, 16#0020#, 16#0002#),
         7621 => (16#0000#, 16#0042#, 16#0002#),
         7622 => (16#0000#, 16#0027#, 16#0002#),
         7623 => (16#19F6#, 16#0020#, 16#0008#),
         7624 => (16#0000#, 16#003B#, 16#0002#),
         7625 => (16#19F6#, 16#0020#, 16#0002#),
         7626 => (16#0000#, 16#003B#, 16#0002#),
         7627 => (16#19F6#, 16#0020#, 16#0008#),
         7628 => (16#0000#, 16#0042#, 16#0002#),
         7629 => (16#19F6#, 16#0020#, 16#0002#),
         7630 => (16#0000#, 16#0042#, 16#0002#),
         7631 => (16#1AA1#, 16#0020#, 16#0008#),
         7632 => (16#0000#, 16#0042#, 16#0002#),
         7633 => (16#1AA1#, 16#0020#, 16#0002#),
         7634 => (16#0000#, 16#0042#, 16#0002#),
         7635 => (16#1AA1#, 16#0020#, 16#0008#),
         7636 => (16#0000#, 16#003B#, 16#0002#),
         7637 => (16#1AA1#, 16#0020#, 16#0002#),
         7638 => (16#0000#, 16#003B#, 16#0002#),
         7639 => (16#1AA1#, 16#0020#, 16#0008#),
         7640 => (16#0000#, 16#0027#, 16#0002#),
         7641 => (16#0000#, 16#0024#, 16#0002#),
         7642 => (16#1AA1#, 16#0020#, 16#0002#),
         7643 => (16#0000#, 16#0027#, 16#0002#),
         7644 => (16#0000#, 16#0024#, 16#0002#),
         7645 => (16#1AA1#, 16#0020#, 16#0008#),
         7646 => (16#0000#, 16#0027#, 16#0002#),
         7647 => (16#0000#, 16#0025#, 16#0002#),
         7648 => (16#1AA1#, 16#0020#, 16#0002#),
         7649 => (16#0000#, 16#0027#, 16#0002#),
         7650 => (16#0000#, 16#0025#, 16#0002#),
         7651 => (16#1AA1#, 16#0020#, 16#0008#),
         7652 => (16#0000#, 16#0027#, 16#0002#),
         7653 => (16#0000#, 16#003B#, 16#0002#),
         7654 => (16#1AA1#, 16#0020#, 16#0002#),
         7655 => (16#0000#, 16#0027#, 16#0002#),
         7656 => (16#0000#, 16#003B#, 16#0002#),
         7657 => (16#1AA1#, 16#0020#, 16#0008#),
         7658 => (16#0000#, 16#0027#, 16#0002#),
         7659 => (16#0000#, 16#002D#, 16#0002#),
         7660 => (16#1AA1#, 16#0020#, 16#0002#),
         7661 => (16#0000#, 16#0027#, 16#0002#),
         7662 => (16#0000#, 16#002D#, 16#0002#),
         7663 => (16#1AA1#, 16#0020#, 16#0008#),
         7664 => (16#0000#, 16#0042#, 16#0002#),
         7665 => (16#0000#, 16#0027#, 16#0002#),
         7666 => (16#1AA1#, 16#0020#, 16#0002#),
         7667 => (16#0000#, 16#0042#, 16#0002#),
         7668 => (16#0000#, 16#0027#, 16#0002#),
         7669 => (16#1AA1#, 16#0020#, 16#0008#),
         7670 => (16#0000#, 16#003F#, 16#0002#),
         7671 => (16#0000#, 16#0024#, 16#0002#),
         7672 => (16#1AA1#, 16#0020#, 16#0002#),
         7673 => (16#0000#, 16#003F#, 16#0002#),
         7674 => (16#0000#, 16#0024#, 16#0002#),
         7675 => (16#1AA1#, 16#0020#, 16#0008#),
         7676 => (16#0000#, 16#003F#, 16#0002#),
         7677 => (16#0000#, 16#0025#, 16#0002#),
         7678 => (16#1AA1#, 16#0020#, 16#0002#),
         7679 => (16#0000#, 16#003F#, 16#0002#),
         7680 => (16#0000#, 16#0025#, 16#0002#),
         7681 => (16#1AA1#, 16#0020#, 16#0008#),
         7682 => (16#0000#, 16#003F#, 16#0002#),
         7683 => (16#0000#, 16#003B#, 16#0002#),
         7684 => (16#1AA1#, 16#0020#, 16#0002#),
         7685 => (16#0000#, 16#003F#, 16#0002#),
         7686 => (16#0000#, 16#003B#, 16#0002#),
         7687 => (16#1AA1#, 16#0020#, 16#0008#),
         7688 => (16#0000#, 16#003F#, 16#0002#),
         7689 => (16#0000#, 16#002D#, 16#0002#),
         7690 => (16#1AA1#, 16#0020#, 16#0002#),
         7691 => (16#0000#, 16#003F#, 16#0002#),
         7692 => (16#0000#, 16#002D#, 16#0002#),
         7693 => (16#1AA1#, 16#0020#, 16#0008#),
         7694 => (16#0000#, 16#003F#, 16#0002#),
         7695 => (16#0000#, 16#0042#, 16#0002#),
         7696 => (16#1AA1#, 16#0020#, 16#0002#),
         7697 => (16#0000#, 16#003F#, 16#0002#),
         7698 => (16#0000#, 16#0042#, 16#0002#),
         7699 => (16#1B77#, 16#0020#, 16#0008#),
         7700 => (16#0000#, 16#0042#, 16#0002#),
         7701 => (16#1B77#, 16#0020#, 16#0002#),
         7702 => (16#0000#, 16#0042#, 16#0002#),
         7703 => (16#1B77#, 16#0020#, 16#0008#),
         7704 => (16#0000#, 16#003B#, 16#0002#),
         7705 => (16#1B77#, 16#0020#, 16#0002#),
         7706 => (16#0000#, 16#003B#, 16#0002#),
         7707 => (16#1B77#, 16#0020#, 16#0008#),
         7708 => (16#0000#, 16#003F#, 16#0002#),
         7709 => (16#0000#, 16#0024#, 16#0002#),
         7710 => (16#1B77#, 16#0020#, 16#0002#),
         7711 => (16#0000#, 16#003F#, 16#0002#),
         7712 => (16#0000#, 16#0024#, 16#0002#),
         7713 => (16#1B77#, 16#0020#, 16#0008#),
         7714 => (16#0000#, 16#003F#, 16#0002#),
         7715 => (16#0000#, 16#0025#, 16#0002#),
         7716 => (16#1B77#, 16#0020#, 16#0002#),
         7717 => (16#0000#, 16#003F#, 16#0002#),
         7718 => (16#0000#, 16#0025#, 16#0002#),
         7719 => (16#1B77#, 16#0020#, 16#0008#),
         7720 => (16#0000#, 16#003F#, 16#0002#),
         7721 => (16#0000#, 16#003B#, 16#0002#),
         7722 => (16#1B77#, 16#0020#, 16#0002#),
         7723 => (16#0000#, 16#003F#, 16#0002#),
         7724 => (16#0000#, 16#003B#, 16#0002#),
         7725 => (16#1B77#, 16#0020#, 16#0008#),
         7726 => (16#0000#, 16#003F#, 16#0002#),
         7727 => (16#0000#, 16#002D#, 16#0002#),
         7728 => (16#1B77#, 16#0020#, 16#0002#),
         7729 => (16#0000#, 16#003F#, 16#0002#),
         7730 => (16#0000#, 16#002D#, 16#0002#),
         7731 => (16#1B77#, 16#0020#, 16#0008#),
         7732 => (16#0000#, 16#003F#, 16#0002#),
         7733 => (16#0000#, 16#0042#, 16#0002#),
         7734 => (16#1B77#, 16#0020#, 16#0002#),
         7735 => (16#0000#, 16#003F#, 16#0002#),
         7736 => (16#0000#, 16#0042#, 16#0002#),
         7737 => (16#1BCD#, 16#0020#, 16#0008#),
         7738 => (16#0000#, 16#0025#, 16#0002#),
         7739 => (16#1BCD#, 16#0020#, 16#0002#),
         7740 => (16#0000#, 16#0025#, 16#0002#),
         7741 => (16#1BCD#, 16#0020#, 16#0008#),
         7742 => (16#0000#, 16#0042#, 16#0002#),
         7743 => (16#1BCD#, 16#0020#, 16#0002#),
         7744 => (16#0000#, 16#0042#, 16#0002#),
         7745 => (16#1BCD#, 16#0020#, 16#0008#),
         7746 => (16#0000#, 16#003B#, 16#0002#),
         7747 => (16#1BCD#, 16#0020#, 16#0002#),
         7748 => (16#0000#, 16#003B#, 16#0002#),
         7749 => (16#1BCD#, 16#0020#, 16#0008#),
         7750 => (16#0000#, 16#002D#, 16#0002#),
         7751 => (16#1BCD#, 16#0020#, 16#0002#),
         7752 => (16#0000#, 16#002D#, 16#0002#),
         7753 => (16#1A3B#, 16#0020#, 16#000A#),
         7754 => (16#1A3B#, 16#0020#, 16#000A#),
         7755 => (16#1A3B#, 16#0020#, 16#0004#),
         7756 => (16#1A3B#, 16#0020#, 16#0004#),
         7757 => (16#1BB2#, 16#0020#, 16#0008#),
         7758 => (16#1BB2#, 16#0020#, 16#0002#),
         7759 => (16#1BDD#, 16#0020#, 16#0008#),
         7760 => (16#1BDD#, 16#0020#, 16#0002#),
         7761 => (16#1C77#, 16#0020#, 16#0002#),
         7762 => (16#0000#, 16#0022#, 16#0002#),
         7763 => (16#1C77#, 16#0020#, 16#0002#),
         7764 => (16#0000#, 16#0023#, 16#0002#),
         7765 => (16#1C77#, 16#0020#, 16#0002#),
         7766 => (16#0000#, 16#0022#, 16#0002#),
         7767 => (16#0000#, 16#0025#, 16#0002#),
         7768 => (16#1C77#, 16#0020#, 16#0002#),
         7769 => (16#0000#, 16#0023#, 16#0002#),
         7770 => (16#0000#, 16#0025#, 16#0002#),
         7771 => (16#1C77#, 16#0020#, 16#0002#),
         7772 => (16#0000#, 16#0022#, 16#0002#),
         7773 => (16#0000#, 16#0024#, 16#0002#),
         7774 => (16#1C77#, 16#0020#, 16#0002#),
         7775 => (16#0000#, 16#0023#, 16#0002#),
         7776 => (16#0000#, 16#0024#, 16#0002#),
         7777 => (16#1C77#, 16#0020#, 16#0002#),
         7778 => (16#0000#, 16#0022#, 16#0002#),
         7779 => (16#0000#, 16#002A#, 16#0002#),
         7780 => (16#1C77#, 16#0020#, 16#0002#),
         7781 => (16#0000#, 16#0023#, 16#0002#),
         7782 => (16#0000#, 16#002A#, 16#0002#),
         7783 => (16#1C77#, 16#0020#, 16#0008#),
         7784 => (16#0000#, 16#0022#, 16#0002#),
         7785 => (16#1C77#, 16#0020#, 16#0008#),
         7786 => (16#0000#, 16#0023#, 16#0002#),
         7787 => (16#1C77#, 16#0020#, 16#0008#),
         7788 => (16#0000#, 16#0022#, 16#0002#),
         7789 => (16#0000#, 16#0025#, 16#0002#),
         7790 => (16#1C77#, 16#0020#, 16#0008#),
         7791 => (16#0000#, 16#0023#, 16#0002#),
         7792 => (16#0000#, 16#0025#, 16#0002#),
         7793 => (16#1C77#, 16#0020#, 16#0008#),
         7794 => (16#0000#, 16#0022#, 16#0002#),
         7795 => (16#0000#, 16#0024#, 16#0002#),
         7796 => (16#1C77#, 16#0020#, 16#0008#),
         7797 => (16#0000#, 16#0023#, 16#0002#),
         7798 => (16#0000#, 16#0024#, 16#0002#),
         7799 => (16#1C77#, 16#0020#, 16#0008#),
         7800 => (16#0000#, 16#0022#, 16#0002#),
         7801 => (16#0000#, 16#002A#, 16#0002#),
         7802 => (16#1C77#, 16#0020#, 16#0008#),
         7803 => (16#0000#, 16#0023#, 16#0002#),
         7804 => (16#0000#, 16#002A#, 16#0002#),
         7805 => (16#1C7C#, 16#0020#, 16#0002#),
         7806 => (16#0000#, 16#0022#, 16#0002#),
         7807 => (16#1C7C#, 16#0020#, 16#0002#),
         7808 => (16#0000#, 16#0023#, 16#0002#),
         7809 => (16#1C7C#, 16#0020#, 16#0002#),
         7810 => (16#0000#, 16#0022#, 16#0002#),
         7811 => (16#0000#, 16#0025#, 16#0002#),
         7812 => (16#1C7C#, 16#0020#, 16#0002#),
         7813 => (16#0000#, 16#0023#, 16#0002#),
         7814 => (16#0000#, 16#0025#, 16#0002#),
         7815 => (16#1C7C#, 16#0020#, 16#0002#),
         7816 => (16#0000#, 16#0022#, 16#0002#),
         7817 => (16#0000#, 16#0024#, 16#0002#),
         7818 => (16#1C7C#, 16#0020#, 16#0002#),
         7819 => (16#0000#, 16#0023#, 16#0002#),
         7820 => (16#0000#, 16#0024#, 16#0002#),
         7821 => (16#1C7C#, 16#0020#, 16#0008#),
         7822 => (16#0000#, 16#0022#, 16#0002#),
         7823 => (16#1C7C#, 16#0020#, 16#0008#),
         7824 => (16#0000#, 16#0023#, 16#0002#),
         7825 => (16#1C7C#, 16#0020#, 16#0008#),
         7826 => (16#0000#, 16#0022#, 16#0002#),
         7827 => (16#0000#, 16#0025#, 16#0002#),
         7828 => (16#1C7C#, 16#0020#, 16#0008#),
         7829 => (16#0000#, 16#0023#, 16#0002#),
         7830 => (16#0000#, 16#0025#, 16#0002#),
         7831 => (16#1C7C#, 16#0020#, 16#0008#),
         7832 => (16#0000#, 16#0022#, 16#0002#),
         7833 => (16#0000#, 16#0024#, 16#0002#),
         7834 => (16#1C7C#, 16#0020#, 16#0008#),
         7835 => (16#0000#, 16#0023#, 16#0002#),
         7836 => (16#0000#, 16#0024#, 16#0002#),
         7837 => (16#1C82#, 16#0020#, 16#0002#),
         7838 => (16#0000#, 16#0022#, 16#0002#),
         7839 => (16#1C82#, 16#0020#, 16#0002#),
         7840 => (16#0000#, 16#0023#, 16#0002#),
         7841 => (16#1C82#, 16#0020#, 16#0002#),
         7842 => (16#0000#, 16#0022#, 16#0002#),
         7843 => (16#0000#, 16#0025#, 16#0002#),
         7844 => (16#1C82#, 16#0020#, 16#0002#),
         7845 => (16#0000#, 16#0023#, 16#0002#),
         7846 => (16#0000#, 16#0025#, 16#0002#),
         7847 => (16#1C82#, 16#0020#, 16#0002#),
         7848 => (16#0000#, 16#0022#, 16#0002#),
         7849 => (16#0000#, 16#0024#, 16#0002#),
         7850 => (16#1C82#, 16#0020#, 16#0002#),
         7851 => (16#0000#, 16#0023#, 16#0002#),
         7852 => (16#0000#, 16#0024#, 16#0002#),
         7853 => (16#1C82#, 16#0020#, 16#0002#),
         7854 => (16#0000#, 16#0022#, 16#0002#),
         7855 => (16#0000#, 16#002A#, 16#0002#),
         7856 => (16#1C82#, 16#0020#, 16#0002#),
         7857 => (16#0000#, 16#0023#, 16#0002#),
         7858 => (16#0000#, 16#002A#, 16#0002#),
         7859 => (16#1C82#, 16#0020#, 16#0008#),
         7860 => (16#0000#, 16#0022#, 16#0002#),
         7861 => (16#1C82#, 16#0020#, 16#0008#),
         7862 => (16#0000#, 16#0023#, 16#0002#),
         7863 => (16#1C82#, 16#0020#, 16#0008#),
         7864 => (16#0000#, 16#0022#, 16#0002#),
         7865 => (16#0000#, 16#0025#, 16#0002#),
         7866 => (16#1C82#, 16#0020#, 16#0008#),
         7867 => (16#0000#, 16#0023#, 16#0002#),
         7868 => (16#0000#, 16#0025#, 16#0002#),
         7869 => (16#1C82#, 16#0020#, 16#0008#),
         7870 => (16#0000#, 16#0022#, 16#0002#),
         7871 => (16#0000#, 16#0024#, 16#0002#),
         7872 => (16#1C82#, 16#0020#, 16#0008#),
         7873 => (16#0000#, 16#0023#, 16#0002#),
         7874 => (16#0000#, 16#0024#, 16#0002#),
         7875 => (16#1C82#, 16#0020#, 16#0008#),
         7876 => (16#0000#, 16#0022#, 16#0002#),
         7877 => (16#0000#, 16#002A#, 16#0002#),
         7878 => (16#1C82#, 16#0020#, 16#0008#),
         7879 => (16#0000#, 16#0023#, 16#0002#),
         7880 => (16#0000#, 16#002A#, 16#0002#),
         7881 => (16#1C84#, 16#0020#, 16#0002#),
         7882 => (16#0000#, 16#0022#, 16#0002#),
         7883 => (16#1C84#, 16#0020#, 16#0002#),
         7884 => (16#0000#, 16#0023#, 16#0002#),
         7885 => (16#1C84#, 16#0020#, 16#0002#),
         7886 => (16#0000#, 16#0022#, 16#0002#),
         7887 => (16#0000#, 16#0025#, 16#0002#),
         7888 => (16#1C84#, 16#0020#, 16#0002#),
         7889 => (16#0000#, 16#0023#, 16#0002#),
         7890 => (16#0000#, 16#0025#, 16#0002#),
         7891 => (16#1C84#, 16#0020#, 16#0002#),
         7892 => (16#0000#, 16#0022#, 16#0002#),
         7893 => (16#0000#, 16#0024#, 16#0002#),
         7894 => (16#1C84#, 16#0020#, 16#0002#),
         7895 => (16#0000#, 16#0023#, 16#0002#),
         7896 => (16#0000#, 16#0024#, 16#0002#),
         7897 => (16#1C84#, 16#0020#, 16#0002#),
         7898 => (16#0000#, 16#0022#, 16#0002#),
         7899 => (16#0000#, 16#002A#, 16#0002#),
         7900 => (16#1C84#, 16#0020#, 16#0002#),
         7901 => (16#0000#, 16#0023#, 16#0002#),
         7902 => (16#0000#, 16#002A#, 16#0002#),
         7903 => (16#1C84#, 16#0020#, 16#0008#),
         7904 => (16#0000#, 16#0022#, 16#0002#),
         7905 => (16#1C84#, 16#0020#, 16#0008#),
         7906 => (16#0000#, 16#0023#, 16#0002#),
         7907 => (16#1C84#, 16#0020#, 16#0008#),
         7908 => (16#0000#, 16#0022#, 16#0002#),
         7909 => (16#0000#, 16#0025#, 16#0002#),
         7910 => (16#1C84#, 16#0020#, 16#0008#),
         7911 => (16#0000#, 16#0023#, 16#0002#),
         7912 => (16#0000#, 16#0025#, 16#0002#),
         7913 => (16#1C84#, 16#0020#, 16#0008#),
         7914 => (16#0000#, 16#0022#, 16#0002#),
         7915 => (16#0000#, 16#0024#, 16#0002#),
         7916 => (16#1C84#, 16#0020#, 16#0008#),
         7917 => (16#0000#, 16#0023#, 16#0002#),
         7918 => (16#0000#, 16#0024#, 16#0002#),
         7919 => (16#1C84#, 16#0020#, 16#0008#),
         7920 => (16#0000#, 16#0022#, 16#0002#),
         7921 => (16#0000#, 16#002A#, 16#0002#),
         7922 => (16#1C84#, 16#0020#, 16#0008#),
         7923 => (16#0000#, 16#0023#, 16#0002#),
         7924 => (16#0000#, 16#002A#, 16#0002#),
         7925 => (16#1C8C#, 16#0020#, 16#0002#),
         7926 => (16#0000#, 16#0022#, 16#0002#),
         7927 => (16#1C8C#, 16#0020#, 16#0002#),
         7928 => (16#0000#, 16#0023#, 16#0002#),
         7929 => (16#1C8C#, 16#0020#, 16#0002#),
         7930 => (16#0000#, 16#0022#, 16#0002#),
         7931 => (16#0000#, 16#0025#, 16#0002#),
         7932 => (16#1C8C#, 16#0020#, 16#0002#),
         7933 => (16#0000#, 16#0023#, 16#0002#),
         7934 => (16#0000#, 16#0025#, 16#0002#),
         7935 => (16#1C8C#, 16#0020#, 16#0002#),
         7936 => (16#0000#, 16#0022#, 16#0002#),
         7937 => (16#0000#, 16#0024#, 16#0002#),
         7938 => (16#1C8C#, 16#0020#, 16#0002#),
         7939 => (16#0000#, 16#0023#, 16#0002#),
         7940 => (16#0000#, 16#0024#, 16#0002#),
         7941 => (16#1C8C#, 16#0020#, 16#0008#),
         7942 => (16#0000#, 16#0022#, 16#0002#),
         7943 => (16#1C8C#, 16#0020#, 16#0008#),
         7944 => (16#0000#, 16#0023#, 16#0002#),
         7945 => (16#1C8C#, 16#0020#, 16#0008#),
         7946 => (16#0000#, 16#0022#, 16#0002#),
         7947 => (16#0000#, 16#0025#, 16#0002#),
         7948 => (16#1C8C#, 16#0020#, 16#0008#),
         7949 => (16#0000#, 16#0023#, 16#0002#),
         7950 => (16#0000#, 16#0025#, 16#0002#),
         7951 => (16#1C8C#, 16#0020#, 16#0008#),
         7952 => (16#0000#, 16#0022#, 16#0002#),
         7953 => (16#0000#, 16#0024#, 16#0002#),
         7954 => (16#1C8C#, 16#0020#, 16#0008#),
         7955 => (16#0000#, 16#0023#, 16#0002#),
         7956 => (16#0000#, 16#0024#, 16#0002#),
         7957 => (16#1C9A#, 16#0020#, 16#0002#),
         7958 => (16#0000#, 16#0022#, 16#0002#),
         7959 => (16#1C9A#, 16#0020#, 16#0002#),
         7960 => (16#0000#, 16#0023#, 16#0002#),
         7961 => (16#1C9A#, 16#0020#, 16#0002#),
         7962 => (16#0000#, 16#0022#, 16#0002#),
         7963 => (16#0000#, 16#0025#, 16#0002#),
         7964 => (16#1C9A#, 16#0020#, 16#0002#),
         7965 => (16#0000#, 16#0023#, 16#0002#),
         7966 => (16#0000#, 16#0025#, 16#0002#),
         7967 => (16#1C9A#, 16#0020#, 16#0002#),
         7968 => (16#0000#, 16#0022#, 16#0002#),
         7969 => (16#0000#, 16#0024#, 16#0002#),
         7970 => (16#1C9A#, 16#0020#, 16#0002#),
         7971 => (16#0000#, 16#0023#, 16#0002#),
         7972 => (16#0000#, 16#0024#, 16#0002#),
         7973 => (16#1C9A#, 16#0020#, 16#0002#),
         7974 => (16#0000#, 16#0022#, 16#0002#),
         7975 => (16#0000#, 16#002A#, 16#0002#),
         7976 => (16#1C9A#, 16#0020#, 16#0002#),
         7977 => (16#0000#, 16#0023#, 16#0002#),
         7978 => (16#0000#, 16#002A#, 16#0002#),
         7979 => (16#1C9A#, 16#0020#, 16#0008#),
         7980 => (16#0000#, 16#0023#, 16#0002#),
         7981 => (16#1C9A#, 16#0020#, 16#0008#),
         7982 => (16#0000#, 16#0023#, 16#0002#),
         7983 => (16#0000#, 16#0025#, 16#0002#),
         7984 => (16#1C9A#, 16#0020#, 16#0008#),
         7985 => (16#0000#, 16#0023#, 16#0002#),
         7986 => (16#0000#, 16#0024#, 16#0002#),
         7987 => (16#1C9A#, 16#0020#, 16#0008#),
         7988 => (16#0000#, 16#0023#, 16#0002#),
         7989 => (16#0000#, 16#002A#, 16#0002#),
         7990 => (16#1C9F#, 16#0020#, 16#0002#),
         7991 => (16#0000#, 16#0022#, 16#0002#),
         7992 => (16#1C9F#, 16#0020#, 16#0002#),
         7993 => (16#0000#, 16#0023#, 16#0002#),
         7994 => (16#1C9F#, 16#0020#, 16#0002#),
         7995 => (16#0000#, 16#0022#, 16#0002#),
         7996 => (16#0000#, 16#0025#, 16#0002#),
         7997 => (16#1C9F#, 16#0020#, 16#0002#),
         7998 => (16#0000#, 16#0023#, 16#0002#),
         7999 => (16#0000#, 16#0025#, 16#0002#),
         8000 => (16#1C9F#, 16#0020#, 16#0002#),
         8001 => (16#0000#, 16#0022#, 16#0002#),
         8002 => (16#0000#, 16#0024#, 16#0002#),
         8003 => (16#1C9F#, 16#0020#, 16#0002#),
         8004 => (16#0000#, 16#0023#, 16#0002#),
         8005 => (16#0000#, 16#0024#, 16#0002#),
         8006 => (16#1C9F#, 16#0020#, 16#0002#),
         8007 => (16#0000#, 16#0022#, 16#0002#),
         8008 => (16#0000#, 16#002A#, 16#0002#),
         8009 => (16#1C9F#, 16#0020#, 16#0002#),
         8010 => (16#0000#, 16#0023#, 16#0002#),
         8011 => (16#0000#, 16#002A#, 16#0002#),
         8012 => (16#1C9F#, 16#0020#, 16#0008#),
         8013 => (16#0000#, 16#0022#, 16#0002#),
         8014 => (16#1C9F#, 16#0020#, 16#0008#),
         8015 => (16#0000#, 16#0023#, 16#0002#),
         8016 => (16#1C9F#, 16#0020#, 16#0008#),
         8017 => (16#0000#, 16#0022#, 16#0002#),
         8018 => (16#0000#, 16#0025#, 16#0002#),
         8019 => (16#1C9F#, 16#0020#, 16#0008#),
         8020 => (16#0000#, 16#0023#, 16#0002#),
         8021 => (16#0000#, 16#0025#, 16#0002#),
         8022 => (16#1C9F#, 16#0020#, 16#0008#),
         8023 => (16#0000#, 16#0022#, 16#0002#),
         8024 => (16#0000#, 16#0024#, 16#0002#),
         8025 => (16#1C9F#, 16#0020#, 16#0008#),
         8026 => (16#0000#, 16#0023#, 16#0002#),
         8027 => (16#0000#, 16#0024#, 16#0002#),
         8028 => (16#1C9F#, 16#0020#, 16#0008#),
         8029 => (16#0000#, 16#0022#, 16#0002#),
         8030 => (16#0000#, 16#002A#, 16#0002#),
         8031 => (16#1C9F#, 16#0020#, 16#0008#),
         8032 => (16#0000#, 16#0023#, 16#0002#),
         8033 => (16#0000#, 16#002A#, 16#0002#),
         8034 => (16#1C77#, 16#0020#, 16#0002#),
         8035 => (16#0000#, 16#0025#, 16#0002#),
         8036 => (16#1C7C#, 16#0020#, 16#0002#),
         8037 => (16#0000#, 16#0025#, 16#0002#),
         8038 => (16#1C82#, 16#0020#, 16#0002#),
         8039 => (16#0000#, 16#0025#, 16#0002#),
         8040 => (16#1C84#, 16#0020#, 16#0002#),
         8041 => (16#0000#, 16#0025#, 16#0002#),
         8042 => (16#1C8C#, 16#0020#, 16#0002#),
         8043 => (16#0000#, 16#0025#, 16#0002#),
         8044 => (16#1C9A#, 16#0020#, 16#0002#),
         8045 => (16#0000#, 16#0025#, 16#0002#),
         8046 => (16#1C9F#, 16#0020#, 16#0002#),
         8047 => (16#0000#, 16#0025#, 16#0002#),
         8048 => (16#1C77#, 16#0020#, 16#0002#),
         8049 => (16#0000#, 16#0022#, 16#0002#),
         8050 => (16#0000#, 16#004C#, 16#0002#),
         8051 => (16#1C77#, 16#0020#, 16#0002#),
         8052 => (16#0000#, 16#0023#, 16#0002#),
         8053 => (16#0000#, 16#004C#, 16#0002#),
         8054 => (16#1C77#, 16#0020#, 16#0002#),
         8055 => (16#0000#, 16#0022#, 16#0002#),
         8056 => (16#0000#, 16#0025#, 16#0002#),
         8057 => (16#0000#, 16#004C#, 16#0002#),
         8058 => (16#1C77#, 16#0020#, 16#0002#),
         8059 => (16#0000#, 16#0023#, 16#0002#),
         8060 => (16#0000#, 16#0025#, 16#0002#),
         8061 => (16#0000#, 16#004C#, 16#0002#),
         8062 => (16#1C77#, 16#0020#, 16#0002#),
         8063 => (16#0000#, 16#0022#, 16#0002#),
         8064 => (16#0000#, 16#0024#, 16#0002#),
         8065 => (16#0000#, 16#004C#, 16#0002#),
         8066 => (16#1C77#, 16#0020#, 16#0002#),
         8067 => (16#0000#, 16#0023#, 16#0002#),
         8068 => (16#0000#, 16#0024#, 16#0002#),
         8069 => (16#0000#, 16#004C#, 16#0002#),
         8070 => (16#1C77#, 16#0020#, 16#0002#),
         8071 => (16#0000#, 16#0022#, 16#0002#),
         8072 => (16#0000#, 16#002A#, 16#0002#),
         8073 => (16#0000#, 16#004C#, 16#0002#),
         8074 => (16#1C77#, 16#0020#, 16#0002#),
         8075 => (16#0000#, 16#0023#, 16#0002#),
         8076 => (16#0000#, 16#002A#, 16#0002#),
         8077 => (16#0000#, 16#004C#, 16#0002#),
         8078 => (16#1C77#, 16#0020#, 16#0008#),
         8079 => (16#0000#, 16#0022#, 16#0002#),
         8080 => (16#0000#, 16#004C#, 16#0002#),
         8081 => (16#1C77#, 16#0020#, 16#0008#),
         8082 => (16#0000#, 16#0023#, 16#0002#),
         8083 => (16#0000#, 16#004C#, 16#0002#),
         8084 => (16#1C77#, 16#0020#, 16#0008#),
         8085 => (16#0000#, 16#0022#, 16#0002#),
         8086 => (16#0000#, 16#0025#, 16#0002#),
         8087 => (16#0000#, 16#004C#, 16#0002#),
         8088 => (16#1C77#, 16#0020#, 16#0008#),
         8089 => (16#0000#, 16#0023#, 16#0002#),
         8090 => (16#0000#, 16#0025#, 16#0002#),
         8091 => (16#0000#, 16#004C#, 16#0002#),
         8092 => (16#1C77#, 16#0020#, 16#0008#),
         8093 => (16#0000#, 16#0022#, 16#0002#),
         8094 => (16#0000#, 16#0024#, 16#0002#),
         8095 => (16#0000#, 16#004C#, 16#0002#),
         8096 => (16#1C77#, 16#0020#, 16#0008#),
         8097 => (16#0000#, 16#0023#, 16#0002#),
         8098 => (16#0000#, 16#0024#, 16#0002#),
         8099 => (16#0000#, 16#004C#, 16#0002#),
         8100 => (16#1C77#, 16#0020#, 16#0008#),
         8101 => (16#0000#, 16#0022#, 16#0002#),
         8102 => (16#0000#, 16#002A#, 16#0002#),
         8103 => (16#0000#, 16#004C#, 16#0002#),
         8104 => (16#1C77#, 16#0020#, 16#0008#),
         8105 => (16#0000#, 16#0023#, 16#0002#),
         8106 => (16#0000#, 16#002A#, 16#0002#),
         8107 => (16#0000#, 16#004C#, 16#0002#),
         8108 => (16#1C82#, 16#0020#, 16#0002#),
         8109 => (16#0000#, 16#0022#, 16#0002#),
         8110 => (16#0000#, 16#004C#, 16#0002#),
         8111 => (16#1C82#, 16#0020#, 16#0002#),
         8112 => (16#0000#, 16#0023#, 16#0002#),
         8113 => (16#0000#, 16#004C#, 16#0002#),
         8114 => (16#1C82#, 16#0020#, 16#0002#),
         8115 => (16#0000#, 16#0022#, 16#0002#),
         8116 => (16#0000#, 16#0025#, 16#0002#),
         8117 => (16#0000#, 16#004C#, 16#0002#),
         8118 => (16#1C82#, 16#0020#, 16#0002#),
         8119 => (16#0000#, 16#0023#, 16#0002#),
         8120 => (16#0000#, 16#0025#, 16#0002#),
         8121 => (16#0000#, 16#004C#, 16#0002#),
         8122 => (16#1C82#, 16#0020#, 16#0002#),
         8123 => (16#0000#, 16#0022#, 16#0002#),
         8124 => (16#0000#, 16#0024#, 16#0002#),
         8125 => (16#0000#, 16#004C#, 16#0002#),
         8126 => (16#1C82#, 16#0020#, 16#0002#),
         8127 => (16#0000#, 16#0023#, 16#0002#),
         8128 => (16#0000#, 16#0024#, 16#0002#),
         8129 => (16#0000#, 16#004C#, 16#0002#),
         8130 => (16#1C82#, 16#0020#, 16#0002#),
         8131 => (16#0000#, 16#0022#, 16#0002#),
         8132 => (16#0000#, 16#002A#, 16#0002#),
         8133 => (16#0000#, 16#004C#, 16#0002#),
         8134 => (16#1C82#, 16#0020#, 16#0002#),
         8135 => (16#0000#, 16#0023#, 16#0002#),
         8136 => (16#0000#, 16#002A#, 16#0002#),
         8137 => (16#0000#, 16#004C#, 16#0002#),
         8138 => (16#1C82#, 16#0020#, 16#0008#),
         8139 => (16#0000#, 16#0022#, 16#0002#),
         8140 => (16#0000#, 16#004C#, 16#0002#),
         8141 => (16#1C82#, 16#0020#, 16#0008#),
         8142 => (16#0000#, 16#0023#, 16#0002#),
         8143 => (16#0000#, 16#004C#, 16#0002#),
         8144 => (16#1C82#, 16#0020#, 16#0008#),
         8145 => (16#0000#, 16#0022#, 16#0002#),
         8146 => (16#0000#, 16#0025#, 16#0002#),
         8147 => (16#0000#, 16#004C#, 16#0002#),
         8148 => (16#1C82#, 16#0020#, 16#0008#),
         8149 => (16#0000#, 16#0023#, 16#0002#),
         8150 => (16#0000#, 16#0025#, 16#0002#),
         8151 => (16#0000#, 16#004C#, 16#0002#),
         8152 => (16#1C82#, 16#0020#, 16#0008#),
         8153 => (16#0000#, 16#0022#, 16#0002#),
         8154 => (16#0000#, 16#0024#, 16#0002#),
         8155 => (16#0000#, 16#004C#, 16#0002#),
         8156 => (16#1C82#, 16#0020#, 16#0008#),
         8157 => (16#0000#, 16#0023#, 16#0002#),
         8158 => (16#0000#, 16#0024#, 16#0002#),
         8159 => (16#0000#, 16#004C#, 16#0002#),
         8160 => (16#1C82#, 16#0020#, 16#0008#),
         8161 => (16#0000#, 16#0022#, 16#0002#),
         8162 => (16#0000#, 16#002A#, 16#0002#),
         8163 => (16#0000#, 16#004C#, 16#0002#),
         8164 => (16#1C82#, 16#0020#, 16#0008#),
         8165 => (16#0000#, 16#0023#, 16#0002#),
         8166 => (16#0000#, 16#002A#, 16#0002#),
         8167 => (16#0000#, 16#004C#, 16#0002#),
         8168 => (16#1C9F#, 16#0020#, 16#0002#),
         8169 => (16#0000#, 16#0022#, 16#0002#),
         8170 => (16#0000#, 16#004C#, 16#0002#),
         8171 => (16#1C9F#, 16#0020#, 16#0002#),
         8172 => (16#0000#, 16#0023#, 16#0002#),
         8173 => (16#0000#, 16#004C#, 16#0002#),
         8174 => (16#1C9F#, 16#0020#, 16#0002#),
         8175 => (16#0000#, 16#0022#, 16#0002#),
         8176 => (16#0000#, 16#0025#, 16#0002#),
         8177 => (16#0000#, 16#004C#, 16#0002#),
         8178 => (16#1C9F#, 16#0020#, 16#0002#),
         8179 => (16#0000#, 16#0023#, 16#0002#),
         8180 => (16#0000#, 16#0025#, 16#0002#),
         8181 => (16#0000#, 16#004C#, 16#0002#),
         8182 => (16#1C9F#, 16#0020#, 16#0002#),
         8183 => (16#0000#, 16#0022#, 16#0002#),
         8184 => (16#0000#, 16#0024#, 16#0002#),
         8185 => (16#0000#, 16#004C#, 16#0002#),
         8186 => (16#1C9F#, 16#0020#, 16#0002#),
         8187 => (16#0000#, 16#0023#, 16#0002#),
         8188 => (16#0000#, 16#0024#, 16#0002#),
         8189 => (16#0000#, 16#004C#, 16#0002#),
         8190 => (16#1C9F#, 16#0020#, 16#0002#),
         8191 => (16#0000#, 16#0022#, 16#0002#),
         8192 => (16#0000#, 16#002A#, 16#0002#),
         8193 => (16#0000#, 16#004C#, 16#0002#),
         8194 => (16#1C9F#, 16#0020#, 16#0002#),
         8195 => (16#0000#, 16#0023#, 16#0002#),
         8196 => (16#0000#, 16#002A#, 16#0002#),
         8197 => (16#0000#, 16#004C#, 16#0002#),
         8198 => (16#1C9F#, 16#0020#, 16#0008#),
         8199 => (16#0000#, 16#0022#, 16#0002#),
         8200 => (16#0000#, 16#004C#, 16#0002#),
         8201 => (16#1C9F#, 16#0020#, 16#0008#),
         8202 => (16#0000#, 16#0023#, 16#0002#),
         8203 => (16#0000#, 16#004C#, 16#0002#),
         8204 => (16#1C9F#, 16#0020#, 16#0008#),
         8205 => (16#0000#, 16#0022#, 16#0002#),
         8206 => (16#0000#, 16#0025#, 16#0002#),
         8207 => (16#0000#, 16#004C#, 16#0002#),
         8208 => (16#1C9F#, 16#0020#, 16#0008#),
         8209 => (16#0000#, 16#0023#, 16#0002#),
         8210 => (16#0000#, 16#0025#, 16#0002#),
         8211 => (16#0000#, 16#004C#, 16#0002#),
         8212 => (16#1C9F#, 16#0020#, 16#0008#),
         8213 => (16#0000#, 16#0022#, 16#0002#),
         8214 => (16#0000#, 16#0024#, 16#0002#),
         8215 => (16#0000#, 16#004C#, 16#0002#),
         8216 => (16#1C9F#, 16#0020#, 16#0008#),
         8217 => (16#0000#, 16#0023#, 16#0002#),
         8218 => (16#0000#, 16#0024#, 16#0002#),
         8219 => (16#0000#, 16#004C#, 16#0002#),
         8220 => (16#1C9F#, 16#0020#, 16#0008#),
         8221 => (16#0000#, 16#0022#, 16#0002#),
         8222 => (16#0000#, 16#002A#, 16#0002#),
         8223 => (16#0000#, 16#004C#, 16#0002#),
         8224 => (16#1C9F#, 16#0020#, 16#0008#),
         8225 => (16#0000#, 16#0023#, 16#0002#),
         8226 => (16#0000#, 16#002A#, 16#0002#),
         8227 => (16#0000#, 16#004C#, 16#0002#),
         8228 => (16#1C77#, 16#0020#, 16#0002#),
         8229 => (16#0000#, 16#0026#, 16#0002#),
         8230 => (16#1C77#, 16#0020#, 16#0002#),
         8231 => (16#0000#, 16#0032#, 16#0002#),
         8232 => (16#1C77#, 16#0020#, 16#0002#),
         8233 => (16#0000#, 16#0025#, 16#0002#),
         8234 => (16#0000#, 16#004C#, 16#0002#),
         8235 => (16#1C77#, 16#0020#, 16#0002#),
         8236 => (16#0000#, 16#004C#, 16#0002#),
         8237 => (16#1C77#, 16#0020#, 16#0002#),
         8238 => (16#0000#, 16#0024#, 16#0002#),
         8239 => (16#0000#, 16#004C#, 16#0002#),
         8240 => (16#1C77#, 16#0020#, 16#0002#),
         8241 => (16#0000#, 16#002A#, 16#0002#),
         8242 => (16#1C77#, 16#0020#, 16#0002#),
         8243 => (16#0000#, 16#002A#, 16#0002#),
         8244 => (16#0000#, 16#004C#, 16#0002#),
         8245 => (16#1C77#, 16#0020#, 16#0008#),
         8246 => (16#0000#, 16#0026#, 16#0002#),
         8247 => (16#1C77#, 16#0020#, 16#0008#),
         8248 => (16#0000#, 16#0032#, 16#0002#),
         8249 => (16#1C77#, 16#0020#, 16#0008#),
         8250 => (16#0000#, 16#0025#, 16#0002#),
         8251 => (16#1C77#, 16#0020#, 16#0008#),
         8252 => (16#0000#, 16#004C#, 16#0002#),
         8253 => (16#0352#, 16#0020#, 16#0002#),
         8254 => (16#0354#, 16#0020#, 16#0002#),
         8255 => (16#034D#, 16#0020#, 16#0002#),
         8256 => (16#0000#, 16#002A#, 16#0002#),
         8257 => (16#1C82#, 16#0020#, 16#0002#),
         8258 => (16#0000#, 16#0025#, 16#0002#),
         8259 => (16#0000#, 16#004C#, 16#0002#),
         8260 => (16#1C82#, 16#0020#, 16#0002#),
         8261 => (16#0000#, 16#004C#, 16#0002#),
         8262 => (16#1C82#, 16#0020#, 16#0002#),
         8263 => (16#0000#, 16#0024#, 16#0002#),
         8264 => (16#0000#, 16#004C#, 16#0002#),
         8265 => (16#1C82#, 16#0020#, 16#0002#),
         8266 => (16#0000#, 16#002A#, 16#0002#),
         8267 => (16#1C82#, 16#0020#, 16#0002#),
         8268 => (16#0000#, 16#002A#, 16#0002#),
         8269 => (16#0000#, 16#004C#, 16#0002#),
         8270 => (16#1C7C#, 16#0020#, 16#0008#),
         8271 => (16#0000#, 16#0025#, 16#0002#),
         8272 => (16#1C82#, 16#0020#, 16#0008#),
         8273 => (16#0000#, 16#0025#, 16#0002#),
         8274 => (16#1C82#, 16#0020#, 16#0008#),
         8275 => (16#0000#, 16#004C#, 16#0002#),
         8276 => (16#0352#, 16#0020#, 16#0002#),
         8277 => (16#0000#, 16#0025#, 16#0002#),
         8278 => (16#0352#, 16#0020#, 16#0002#),
         8279 => (16#0000#, 16#0024#, 16#0002#),
         8280 => (16#0352#, 16#0020#, 16#0002#),
         8281 => (16#0000#, 16#002A#, 16#0002#),
         8282 => (16#1C84#, 16#0020#, 16#0002#),
         8283 => (16#0000#, 16#0026#, 16#0002#),
         8284 => (16#1C84#, 16#0020#, 16#0002#),
         8285 => (16#0000#, 16#0032#, 16#0002#),
         8286 => (16#1C84#, 16#0020#, 16#0002#),
         8287 => (16#0000#, 16#002B#, 16#0002#),
         8288 => (16#0000#, 16#0025#, 16#0002#),
         8289 => (16#1C84#, 16#0020#, 16#0002#),
         8290 => (16#0000#, 16#002A#, 16#0002#),
         8291 => (16#1C84#, 16#0020#, 16#0002#),
         8292 => (16#0000#, 16#002B#, 16#0002#),
         8293 => (16#0000#, 16#002A#, 16#0002#),
         8294 => (16#1C84#, 16#0020#, 16#0008#),
         8295 => (16#0000#, 16#0026#, 16#0002#),
         8296 => (16#1C84#, 16#0020#, 16#0008#),
         8297 => (16#0000#, 16#0032#, 16#0002#),
         8298 => (16#1C84#, 16#0020#, 16#0008#),
         8299 => (16#0000#, 16#0025#, 16#0002#),
         8300 => (16#0353#, 16#0020#, 16#0002#),
         8301 => (16#0000#, 16#0025#, 16#0002#),
         8302 => (16#0353#, 16#0020#, 16#0002#),
         8303 => (16#0000#, 16#0024#, 16#0002#),
         8304 => (16#0353#, 16#0020#, 16#0002#),
         8305 => (16#0000#, 16#002A#, 16#0002#),
         8306 => (16#1C9A#, 16#0020#, 16#0002#),
         8307 => (16#0000#, 16#0026#, 16#0002#),
         8308 => (16#1C9A#, 16#0020#, 16#0002#),
         8309 => (16#0000#, 16#0032#, 16#0002#),
         8310 => (16#1C9A#, 16#0020#, 16#0002#),
         8311 => (16#0000#, 16#002B#, 16#0002#),
         8312 => (16#0000#, 16#0025#, 16#0002#),
         8313 => (16#1C92#, 16#0020#, 16#0002#),
         8314 => (16#0000#, 16#0022#, 16#0002#),
         8315 => (16#1C92#, 16#0020#, 16#0002#),
         8316 => (16#0000#, 16#0023#, 16#0002#),
         8317 => (16#1C9A#, 16#0020#, 16#0002#),
         8318 => (16#0000#, 16#002A#, 16#0002#),
         8319 => (16#1C9A#, 16#0020#, 16#0002#),
         8320 => (16#0000#, 16#002B#, 16#0002#),
         8321 => (16#0000#, 16#002A#, 16#0002#),
         8322 => (16#1C9A#, 16#0020#, 16#0008#),
         8323 => (16#0000#, 16#0026#, 16#0002#),
         8324 => (16#1C9A#, 16#0020#, 16#0008#),
         8325 => (16#0000#, 16#0032#, 16#0002#),
         8326 => (16#1C9A#, 16#0020#, 16#0008#),
         8327 => (16#0000#, 16#0025#, 16#0002#),
         8328 => (16#1C92#, 16#0020#, 16#0008#),
         8329 => (16#0000#, 16#0023#, 16#0002#),
         8330 => (16#034D#, 16#0020#, 16#0002#),
         8331 => (16#0000#, 16#0025#, 16#0002#),
         8332 => (16#1C9F#, 16#0020#, 16#0002#),
         8333 => (16#0000#, 16#0025#, 16#0002#),
         8334 => (16#0000#, 16#004C#, 16#0002#),
         8335 => (16#1C9F#, 16#0020#, 16#0002#),
         8336 => (16#0000#, 16#004C#, 16#0002#),
         8337 => (16#1C9F#, 16#0020#, 16#0002#),
         8338 => (16#0000#, 16#0024#, 16#0002#),
         8339 => (16#0000#, 16#004C#, 16#0002#),
         8340 => (16#1C9F#, 16#0020#, 16#0002#),
         8341 => (16#0000#, 16#002A#, 16#0002#),
         8342 => (16#1C9F#, 16#0020#, 16#0002#),
         8343 => (16#0000#, 16#002A#, 16#0002#),
         8344 => (16#0000#, 16#004C#, 16#0002#),
         8345 => (16#1C8C#, 16#0020#, 16#0008#),
         8346 => (16#0000#, 16#0025#, 16#0002#),
         8347 => (16#1C9F#, 16#0020#, 16#0008#),
         8348 => (16#0000#, 16#0025#, 16#0002#),
         8349 => (16#1C9F#, 16#0020#, 16#0008#),
         8350 => (16#0000#, 16#004C#, 16#0002#),
         8351 => (16#0112#, 16#0020#, 16#0002#),
         8352 => (16#0112#, 16#0020#, 16#001B#),
         8353 => (16#0113#, 16#0020#, 16#0002#),
         8354 => (16#0114#, 16#0020#, 16#0002#),
         8355 => (16#0115#, 16#0020#, 16#0002#),
         8356 => (16#0116#, 16#0020#, 16#0002#),
         8357 => (16#0275#, 16#0020#, 16#0002#),
         8358 => (16#010B#, 16#0020#, 16#0002#),
         8359 => (16#01F8#, 16#0020#, 16#0002#),
         8360 => (16#01F9#, 16#0020#, 16#0002#),
         8361 => (16#01FA#, 16#0020#, 16#0002#),
         8362 => (16#01FB#, 16#0020#, 16#0002#),
         8363 => (16#01FF#, 16#0020#, 16#0002#),
         8364 => (16#0200#, 16#0020#, 16#0002#),
         8365 => (16#0201#, 16#0020#, 16#0002#),
         8366 => (16#0202#, 16#0020#, 16#0002#),
         8367 => (16#0291#, 16#0020#, 16#0002#),
         8368 => (16#0292#, 16#0020#, 16#0002#),
         8369 => (16#0296#, 16#0020#, 16#0002#),
         8370 => (16#0297#, 16#0020#, 16#0002#),
         8371 => (16#0173#, 16#0020#, 16#0004#),
         8372 => (16#0173#, 16#0020#, 16#0004#),
         8373 => (16#0173#, 16#0020#, 16#0004#),
         8374 => (16#0298#, 16#0020#, 16#0002#),
         8375 => (16#0106#, 16#0020#, 16#0002#),
         8376 => (16#0107#, 16#0020#, 16#0002#),
         8377 => (16#028D#, 16#0020#, 16#0002#),
         8378 => (16#028F#, 16#0020#, 16#0002#),
         8379 => (16#029C#, 16#0020#, 16#0002#),
         8380 => (16#029C#, 16#0020#, 16#0004#),
         8381 => (16#029C#, 16#0020#, 16#0004#),
         8382 => (16#029C#, 16#0020#, 16#0004#),
         8383 => (16#029C#, 16#0020#, 16#0004#),
         8384 => (16#029C#, 16#0020#, 16#0004#),
         8385 => (16#029D#, 16#0020#, 16#0002#),
         8386 => (16#029D#, 16#0020#, 16#0004#),
         8387 => (16#029D#, 16#0020#, 16#0004#),
         8388 => (16#029D#, 16#0020#, 16#0004#),
         8389 => (16#029D#, 16#0020#, 16#0004#),
         8390 => (16#029D#, 16#0020#, 16#0004#),
         8391 => (16#02A0#, 16#0020#, 16#0002#),
         8392 => (16#01FC#, 16#0020#, 16#0002#),
         8393 => (16#01FD#, 16#0020#, 16#0002#),
         8394 => (16#02A1#, 16#0020#, 16#0002#),
         8395 => (16#015E#, 16#0020#, 16#0004#),
         8396 => (16#015E#, 16#0020#, 16#0004#),
         8397 => (16#0171#, 16#0020#, 16#0002#),
         8398 => (16#0109#, 16#0020#, 16#0002#),
         8399 => (16#02A2#, 16#0020#, 16#0002#),
         8400 => (16#02A4#, 16#0020#, 16#0002#),
         8401 => (16#02A6#, 16#0020#, 16#0002#),
         8402 => (16#02A7#, 16#0020#, 16#0002#),
         8403 => (16#0299#, 16#0020#, 16#0002#),
         8404 => (16#04E6#, 16#0020#, 16#0002#),
         8405 => (16#0215#, 16#0020#, 16#0002#),
         8406 => (16#0216#, 16#0020#, 16#0002#),
         8407 => (16#0163#, 16#0020#, 16#0004#),
         8408 => (16#0163#, 16#0020#, 16#0004#),
         8409 => (16#0163#, 16#0020#, 16#0004#),
         8410 => (16#015E#, 16#0020#, 16#0004#),
         8411 => (16#015E#, 16#0020#, 16#0004#),
         8412 => (16#0163#, 16#0020#, 16#0004#),
         8413 => (16#0289#, 16#0020#, 16#0002#),
         8414 => (16#027E#, 16#0020#, 16#0002#),
         8415 => (16#029A#, 16#0020#, 16#0002#),
         8416 => (16#029B#, 16#0020#, 16#0002#),
         8417 => (16#0282#, 16#0020#, 16#0002#),
         8418 => (16#0134#, 16#0020#, 16#0002#),
         8419 => (16#02A5#, 16#0020#, 16#0002#),
         8420 => (16#0283#, 16#0020#, 16#0002#),
         8421 => (16#04E2#, 16#0020#, 16#0002#),
         8422 => (16#0119#, 16#0020#, 16#0002#),
         8423 => (16#02A3#, 16#0020#, 16#0002#),
         8424 => (16#01DA#, 16#0020#, 16#0002#),
         8425 => (16#01DB#, 16#0020#, 16#0002#),
         8426 => (16#01DC#, 16#0020#, 16#0002#),
         8427 => (16#01DD#, 16#0020#, 16#0002#),
         8428 => (16#01DE#, 16#0020#, 16#0002#),
         8429 => (16#01DF#, 16#0020#, 16#0002#),
         8430 => (16#01E0#, 16#0020#, 16#0002#),
         8431 => (16#01E1#, 16#0020#, 16#0002#),
         8432 => (16#01E2#, 16#0020#, 16#0002#),
         8433 => (16#1803#, 16#0020#, 16#0014#),
         8434 => (16#19F6#, 16#0020#, 16#0014#),
         8435 => (16#1807#, 16#0020#, 16#0014#),
         8436 => (16#1808#, 16#0020#, 16#0014#),
         8437 => (16#1809#, 16#0020#, 16#0014#),
         8438 => (16#180A#, 16#0020#, 16#0014#),
         8439 => (16#180B#, 16#0020#, 16#0014#),
         8440 => (16#180C#, 16#0020#, 16#0014#),
         8441 => (16#04D6#, 16#0020#, 16#0014#),
         8442 => (16#04E1#, 16#0020#, 16#0014#),
         8443 => (16#04DB#, 16#0020#, 16#0014#),
         8444 => (16#0209#, 16#0020#, 16#0014#),
         8445 => (16#020A#, 16#0020#, 16#0014#),
         8446 => (16#1A7D#, 16#0020#, 16#0014#),
         8447 => (16#1803#, 16#0020#, 16#0015#),
         8448 => (16#1804#, 16#0020#, 16#0015#),
         8449 => (16#1805#, 16#0020#, 16#0015#),
         8450 => (16#1806#, 16#0020#, 16#0015#),
         8451 => (16#1807#, 16#0020#, 16#0015#),
         8452 => (16#1808#, 16#0020#, 16#0015#),
         8453 => (16#1809#, 16#0020#, 16#0015#),
         8454 => (16#180A#, 16#0020#, 16#0015#),
         8455 => (16#180B#, 16#0020#, 16#0015#),
         8456 => (16#180C#, 16#0020#, 16#0015#),
         8457 => (16#04D6#, 16#0020#, 16#0015#),
         8458 => (16#04E1#, 16#0020#, 16#0015#),
         8459 => (16#04DB#, 16#0020#, 16#0015#),
         8460 => (16#0209#, 16#0020#, 16#0015#),
         8461 => (16#020A#, 16#0020#, 16#0015#),
         8462 => (16#190C#, 16#0020#, 16#0015#),
         8463 => (16#196E#, 16#0020#, 16#0015#),
         8464 => (16#1AA1#, 16#0020#, 16#0015#),
         8465 => (16#1BC1#, 16#0020#, 16#0015#),
         8466 => (16#1981#, 16#0020#, 16#0015#),
         8467 => (16#19DC#, 16#0020#, 16#0015#),
         8468 => (16#1A29#, 16#0020#, 16#0015#),
         8469 => (16#1A3B#, 16#0020#, 16#0015#),
         8470 => (16#1A6E#, 16#0020#, 16#0015#),
         8471 => (16#1A7D#, 16#0020#, 16#0015#),
         8472 => (16#1ACE#, 16#0020#, 16#0015#),
         8473 => (16#1B33#, 16#0020#, 16#0015#),
         8474 => (16#1B57#, 16#0020#, 16#0015#),
         8475 => (16#16D7#, 16#0020#, 16#0002#),
         8476 => (16#16D8#, 16#0020#, 16#0002#),
         8477 => (16#16D9#, 16#0020#, 16#0002#),
         8478 => (16#16DA#, 16#0020#, 16#0002#),
         8479 => (16#16DB#, 16#0020#, 16#0002#),
         8480 => (16#16DC#, 16#0020#, 16#0002#),
         8481 => (16#16DD#, 16#0020#, 16#0002#),
         8482 => (16#16DE#, 16#0020#, 16#0002#),
         8483 => (16#16F4#, 16#0020#, 16#0002#),
         8484 => (16#16DF#, 16#0020#, 16#0002#),
         8485 => (16#16E0#, 16#0020#, 16#0002#),
         8486 => (16#16E1#, 16#0020#, 16#0002#),
         8487 => (16#16E2#, 16#0020#, 16#0002#),
         8488 => (16#16E3#, 16#0020#, 16#0002#),
         8489 => (16#16E4#, 16#0020#, 16#0002#),
         8490 => (16#16E5#, 16#0020#, 16#0002#),
         8491 => (16#16E6#, 16#0020#, 16#0002#),
         8492 => (16#16E7#, 16#0020#, 16#0002#),
         8493 => (16#16E8#, 16#0020#, 16#0002#),
         8494 => (16#16E9#, 16#0020#, 16#0002#),
         8495 => (16#16EA#, 16#0020#, 16#0002#),
         8496 => (16#16EB#, 16#0020#, 16#0002#),
         8497 => (16#16EC#, 16#0020#, 16#0002#),
         8498 => (16#16ED#, 16#0020#, 16#0002#),
         8499 => (16#16EE#, 16#0020#, 16#0002#),
         8500 => (16#16EF#, 16#0020#, 16#0002#),
         8501 => (16#16F0#, 16#0020#, 16#0002#),
         8502 => (16#16F1#, 16#0020#, 16#0002#),
         8503 => (16#16F2#, 16#0020#, 16#0002#),
         8504 => (16#16F3#, 16#0020#, 16#0002#),
         8505 => (16#0000#, 16#00F9#, 16#0002#),
         8506 => (16#0000#, 16#00FA#, 16#0002#),
         8507 => (16#0000#, 16#00FB#, 16#0002#),
         8508 => (16#0000#, 16#00FC#, 16#0002#),
         8509 => (16#0000#, 16#00FD#, 16#0002#),
         8510 => (16#0000#, 16#00FE#, 16#0002#),
         8511 => (16#0000#, 16#00FF#, 16#0002#),
         8512 => (16#0000#, 16#0100#, 16#0002#),
         8513 => (16#0000#, 16#0101#, 16#0002#),
         8514 => (16#0000#, 16#0102#, 16#0002#),
         8515 => (16#0000#, 16#0103#, 16#0002#),
         8516 => (16#0000#, 16#0104#, 16#0002#),
         8517 => (16#0000#, 16#0105#, 16#0002#),
         8518 => (16#0000#, 16#0106#, 16#0002#),
         8519 => (16#190C#, 16#0020#, 16#0004#),
         8520 => (16#0286#, 16#0020#, 16#0004#),
         8521 => (16#193E#, 16#0020#, 16#0004#),
         8522 => (16#190C#, 16#0020#, 16#0004#),
         8523 => (16#0286#, 16#0020#, 16#0004#),
         8524 => (16#1B33#, 16#0020#, 16#0004#),
         8525 => (16#193E#, 16#0020#, 16#000B#),
         8526 => (16#03BA#, 16#0020#, 16#0004#),
         8527 => (16#193E#, 16#0020#, 16#000A#),
         8528 => (16#0448#, 16#0020#, 16#0002#),
         8529 => (16#193E#, 16#0020#, 16#0004#),
         8530 => (16#0286#, 16#0020#, 16#0004#),
         8531 => (16#1AA1#, 16#0020#, 16#0004#),
         8532 => (16#193E#, 16#0020#, 16#0004#),
         8533 => (16#0286#, 16#0020#, 16#0004#),
         8534 => (16#1B77#, 16#0020#, 16#0004#),
         8535 => (16#1986#, 16#0020#, 16#000A#),
         8536 => (16#0449#, 16#0020#, 16#0002#),
         8537 => (16#03BA#, 16#0020#, 16#0004#),
         8538 => (16#19A9#, 16#0020#, 16#000A#),
         8539 => (16#19B8#, 16#0020#, 16#0005#),
         8540 => (16#19DC#, 16#0020#, 16#000B#),
         8541 => (16#19DC#, 16#0020#, 16#0005#),
         8542 => (16#19F6#, 16#0020#, 16#000B#),
         8543 => (16#1A3B#, 16#0020#, 16#000B#),
         8544 => (16#1A3B#, 16#0020#, 16#0005#),
         8545 => (16#044A#, 16#0020#, 16#0002#),
         8546 => (16#1A7D#, 16#0020#, 16#000B#),
         8547 => (16#1A7D#, 16#0020#, 16#000A#),
         8548 => (16#1AA1#, 16#0020#, 16#0004#),
         8549 => (16#044B#, 16#0020#, 16#0002#),
         8550 => (16#044C#, 16#0020#, 16#0002#),
         8551 => (16#1ACE#, 16#0020#, 16#000B#),
         8552 => (16#1AE3#, 16#0020#, 16#000B#),
         8553 => (16#1AF5#, 16#0020#, 16#000B#),
         8554 => (16#044D#, 16#0020#, 16#0002#),
         8555 => (16#044E#, 16#0020#, 16#0002#),
         8556 => (16#1B33#, 16#0020#, 16#0014#),
         8557 => (16#1A6E#, 16#0020#, 16#0014#),
         8558 => (16#1B57#, 16#0020#, 16#000A#),
         8559 => (16#196E#, 16#0020#, 16#000A#),
         8560 => (16#1A3B#, 16#0020#, 16#000A#),
         8561 => (16#1B57#, 16#0020#, 16#0014#),
         8562 => (16#1A6E#, 16#0020#, 16#0014#),
         8563 => (16#044F#, 16#0020#, 16#0002#),
         8564 => (16#1BE3#, 16#0020#, 16#000B#),
         8565 => (16#0450#, 16#0020#, 16#0002#),
         8566 => (16#0451#, 16#0020#, 16#0002#),
         8567 => (16#0452#, 16#0020#, 16#0002#),
         8568 => (16#1925#, 16#0020#, 16#000B#),
         8569 => (16#0453#, 16#0020#, 16#0002#),
         8570 => (16#196E#, 16#0020#, 16#0005#),
         8571 => (16#196E#, 16#0020#, 16#000B#),
         8572 => (16#19A9#, 16#0020#, 16#000B#),
         8573 => (16#19B6#, 16#0020#, 16#0008#),
         8574 => (16#1A6E#, 16#0020#, 16#000B#),
         8575 => (16#1AA1#, 16#0020#, 16#0005#),
         8576 => (16#1F75#, 16#0020#, 16#0004#),
         8577 => (16#1F76#, 16#0020#, 16#0004#),
         8578 => (16#1F77#, 16#0020#, 16#0004#),
         8579 => (16#1F78#, 16#0020#, 16#0004#),
         8580 => (16#19F6#, 16#0020#, 16#0005#),
         8581 => (16#0454#, 16#0020#, 16#0002#),
         8582 => (16#19A9#, 16#0020#, 16#000A#),
         8583 => (16#190C#, 16#0020#, 16#000A#),
         8584 => (16#1BC1#, 16#0020#, 16#000A#),
         8585 => (16#1C8D#, 16#0020#, 16#0005#),
         8586 => (16#1C79#, 16#0020#, 16#0005#),
         8587 => (16#1C79#, 16#0020#, 16#000B#),
         8588 => (16#1C8D#, 16#0020#, 16#000B#),
         8589 => (16#04D5#, 16#0020#, 16#0005#),
         8590 => (16#0455#, 16#0020#, 16#0002#),
         8591 => (16#0456#, 16#0020#, 16#0002#),
         8592 => (16#0457#, 16#0020#, 16#0002#),
         8593 => (16#0458#, 16#0020#, 16#0002#),
         8594 => (16#1953#, 16#0020#, 16#000B#),
         8595 => (16#1953#, 16#0020#, 16#0005#),
         8596 => (16#1A10#, 16#0020#, 16#0005#),
         8597 => (16#0459#, 16#0020#, 16#0002#),
         8598 => (16#0571#, 16#0020#, 16#0002#),
         8599 => (16#045A#, 16#0020#, 16#0002#),
         8600 => (16#190C#, 16#0020#, 16#000A#),
         8601 => (16#0286#, 16#0020#, 16#0004#),
         8602 => (16#1B33#, 16#0020#, 16#000A#),
         8603 => (16#19B6#, 16#0020#, 16#0002#),
         8604 => (16#045B#, 16#0020#, 16#0002#),
         8605 => (16#1804#, 16#0020#, 16#001E#),
         8606 => (16#04E6#, 16#0020#, 16#001E#),
         8607 => (16#180A#, 16#0020#, 16#001E#),
         8608 => (16#1804#, 16#0020#, 16#001E#),
         8609 => (16#04E6#, 16#0020#, 16#001E#),
         8610 => (16#180C#, 16#0020#, 16#001E#),
         8611 => (16#1804#, 16#0020#, 16#001E#),
         8612 => (16#04E6#, 16#0020#, 16#001E#),
         8613 => (16#1804#, 16#0020#, 16#001E#),
         8614 => (16#1803#, 16#0020#, 16#001E#),
         8615 => (16#1804#, 16#0020#, 16#001E#),
         8616 => (16#04E6#, 16#0020#, 16#001E#),
         8617 => (16#1806#, 16#0020#, 16#001E#),
         8618 => (16#1805#, 16#0020#, 16#001E#),
         8619 => (16#04E6#, 16#0020#, 16#001E#),
         8620 => (16#1806#, 16#0020#, 16#001E#),
         8621 => (16#1804#, 16#0020#, 16#001E#),
         8622 => (16#04E6#, 16#0020#, 16#001E#),
         8623 => (16#1808#, 16#0020#, 16#001E#),
         8624 => (16#1805#, 16#0020#, 16#001E#),
         8625 => (16#04E6#, 16#0020#, 16#001E#),
         8626 => (16#1808#, 16#0020#, 16#001E#),
         8627 => (16#1806#, 16#0020#, 16#001E#),
         8628 => (16#04E6#, 16#0020#, 16#001E#),
         8629 => (16#1808#, 16#0020#, 16#001E#),
         8630 => (16#1807#, 16#0020#, 16#001E#),
         8631 => (16#04E6#, 16#0020#, 16#001E#),
         8632 => (16#1808#, 16#0020#, 16#001E#),
         8633 => (16#1804#, 16#0020#, 16#001E#),
         8634 => (16#04E6#, 16#0020#, 16#001E#),
         8635 => (16#1809#, 16#0020#, 16#001E#),
         8636 => (16#1808#, 16#0020#, 16#001E#),
         8637 => (16#04E6#, 16#0020#, 16#001E#),
         8638 => (16#1809#, 16#0020#, 16#001E#),
         8639 => (16#1804#, 16#0020#, 16#001E#),
         8640 => (16#04E6#, 16#0020#, 16#001E#),
         8641 => (16#180B#, 16#0020#, 16#001E#),
         8642 => (16#1806#, 16#0020#, 16#001E#),
         8643 => (16#04E6#, 16#0020#, 16#001E#),
         8644 => (16#180B#, 16#0020#, 16#001E#),
         8645 => (16#1808#, 16#0020#, 16#001E#),
         8646 => (16#04E6#, 16#0020#, 16#001E#),
         8647 => (16#180B#, 16#0020#, 16#001E#),
         8648 => (16#180A#, 16#0020#, 16#001E#),
         8649 => (16#04E6#, 16#0020#, 16#001E#),
         8650 => (16#180B#, 16#0020#, 16#001E#),
         8651 => (16#19F6#, 16#0020#, 16#000A#),
         8652 => (16#19F6#, 16#0020#, 16#000A#),
         8653 => (16#19F6#, 16#0020#, 16#000A#),
         8654 => (16#19F6#, 16#0020#, 16#000A#),
         8655 => (16#19F6#, 16#0020#, 16#000A#),
         8656 => (16#19F6#, 16#0020#, 16#000A#),
         8657 => (16#1BA5#, 16#0020#, 16#000A#),
         8658 => (16#1BA5#, 16#0020#, 16#000A#),
         8659 => (16#19F6#, 16#0020#, 16#000A#),
         8660 => (16#1BA5#, 16#0020#, 16#000A#),
         8661 => (16#19F6#, 16#0020#, 16#000A#),
         8662 => (16#19F6#, 16#0020#, 16#000A#),
         8663 => (16#1BA5#, 16#0020#, 16#000A#),
         8664 => (16#19F6#, 16#0020#, 16#000A#),
         8665 => (16#19F6#, 16#0020#, 16#000A#),
         8666 => (16#19F6#, 16#0020#, 16#000A#),
         8667 => (16#19F6#, 16#0020#, 16#000A#),
         8668 => (16#1BC1#, 16#0020#, 16#000A#),
         8669 => (16#1BC1#, 16#0020#, 16#000A#),
         8670 => (16#19F6#, 16#0020#, 16#000A#),
         8671 => (16#1BC1#, 16#0020#, 16#000A#),
         8672 => (16#19F6#, 16#0020#, 16#000A#),
         8673 => (16#19F6#, 16#0020#, 16#000A#),
         8674 => (16#1A6E#, 16#0020#, 16#000A#),
         8675 => (16#19F6#, 16#0020#, 16#0004#),
         8676 => (16#19F6#, 16#0020#, 16#0004#),
         8677 => (16#19F6#, 16#0020#, 16#0004#),
         8678 => (16#19F6#, 16#0020#, 16#0004#),
         8679 => (16#19F6#, 16#0020#, 16#0004#),
         8680 => (16#19F6#, 16#0020#, 16#0004#),
         8681 => (16#1BA5#, 16#0020#, 16#0004#),
         8682 => (16#1BA5#, 16#0020#, 16#0004#),
         8683 => (16#19F6#, 16#0020#, 16#0004#),
         8684 => (16#1BA5#, 16#0020#, 16#0004#),
         8685 => (16#19F6#, 16#0020#, 16#0004#),
         8686 => (16#19F6#, 16#0020#, 16#0004#),
         8687 => (16#1BA5#, 16#0020#, 16#0004#),
         8688 => (16#19F6#, 16#0020#, 16#0004#),
         8689 => (16#19F6#, 16#0020#, 16#0004#),
         8690 => (16#19F6#, 16#0020#, 16#0004#),
         8691 => (16#19F6#, 16#0020#, 16#0004#),
         8692 => (16#1BC1#, 16#0020#, 16#0004#),
         8693 => (16#1BC1#, 16#0020#, 16#0004#),
         8694 => (16#19F6#, 16#0020#, 16#0004#),
         8695 => (16#1BC1#, 16#0020#, 16#0004#),
         8696 => (16#19F6#, 16#0020#, 16#0004#),
         8697 => (16#19F6#, 16#0020#, 16#0004#),
         8698 => (16#171C#, 16#0020#, 16#0002#),
         8699 => (16#171D#, 16#0020#, 16#0002#),
         8700 => (16#171E#, 16#0020#, 16#0002#),
         8701 => (16#1951#, 16#0020#, 16#0008#),
         8702 => (16#1951#, 16#0020#, 16#0002#),
         8703 => (16#171F#, 16#0020#, 16#0002#),
         8704 => (16#1720#, 16#0020#, 16#0002#),
         8705 => (16#1721#, 16#0020#, 16#0002#),
         8706 => (16#1803#, 16#0020#, 16#001E#),
         8707 => (16#04E6#, 16#0020#, 16#001E#),
         8708 => (16#1806#, 16#0020#, 16#001E#),
         8709 => (16#045C#, 16#0020#, 16#0002#),
         8710 => (16#045E#, 16#0020#, 16#0002#),
         8711 => (16#045D#, 16#0020#, 16#0002#),
         8712 => (16#045F#, 16#0020#, 16#0002#),
         8713 => (16#0460#, 16#0020#, 16#0002#),
         8714 => (16#0461#, 16#0020#, 16#0002#),
         8715 => (16#0462#, 16#0020#, 16#0002#),
         8716 => (16#0463#, 16#0020#, 16#0002#),
         8717 => (16#0464#, 16#0020#, 16#0002#),
         8718 => (16#0465#, 16#0020#, 16#0002#),
         8719 => (16#045C#, 16#0020#, 16#0002#),
         8720 => (16#0000#, 16#002F#, 16#0002#),
         8721 => (16#045D#, 16#0020#, 16#0002#),
         8722 => (16#0000#, 16#002F#, 16#0002#),
         8723 => (16#0466#, 16#0020#, 16#0002#),
         8724 => (16#0467#, 16#0020#, 16#0002#),
         8725 => (16#0468#, 16#0020#, 16#0002#),
         8726 => (16#0469#, 16#0020#, 16#0002#),
         8727 => (16#046A#, 16#0020#, 16#0002#),
         8728 => (16#046B#, 16#0020#, 16#0002#),
         8729 => (16#046C#, 16#0020#, 16#0002#),
         8730 => (16#046D#, 16#0020#, 16#0002#),
         8731 => (16#046E#, 16#0020#, 16#0002#),
         8732 => (16#046F#, 16#0020#, 16#0002#),
         8733 => (16#0470#, 16#0020#, 16#0002#),
         8734 => (16#0471#, 16#0020#, 16#0002#),
         8735 => (16#0472#, 16#0020#, 16#0002#),
         8736 => (16#0473#, 16#0020#, 16#0002#),
         8737 => (16#0474#, 16#0020#, 16#0002#),
         8738 => (16#0475#, 16#0020#, 16#0002#),
         8739 => (16#0476#, 16#0020#, 16#0002#),
         8740 => (16#0477#, 16#0020#, 16#0002#),
         8741 => (16#0460#, 16#0020#, 16#0002#),
         8742 => (16#0000#, 16#002F#, 16#0002#),
         8743 => (16#0478#, 16#0020#, 16#0002#),
         8744 => (16#0479#, 16#0020#, 16#0002#),
         8745 => (16#047A#, 16#0020#, 16#0002#),
         8746 => (16#047B#, 16#0020#, 16#0002#),
         8747 => (16#047C#, 16#0020#, 16#0002#),
         8748 => (16#047D#, 16#0020#, 16#0002#),
         8749 => (16#047E#, 16#0020#, 16#0002#),
         8750 => (16#047F#, 16#0020#, 16#0002#),
         8751 => (16#0480#, 16#0020#, 16#0002#),
         8752 => (16#0481#, 16#0020#, 16#0002#),
         8753 => (16#0482#, 16#0020#, 16#0002#),
         8754 => (16#0483#, 16#0020#, 16#0002#),
         8755 => (16#0484#, 16#0020#, 16#0002#),
         8756 => (16#0485#, 16#0020#, 16#0002#),
         8757 => (16#0486#, 16#0020#, 16#0002#),
         8758 => (16#0487#, 16#0020#, 16#0002#),
         8759 => (16#0488#, 16#0020#, 16#0002#),
         8760 => (16#0489#, 16#0020#, 16#0002#),
         8761 => (16#048A#, 16#0020#, 16#0002#),
         8762 => (16#048B#, 16#0020#, 16#0002#),
         8763 => (16#048C#, 16#0020#, 16#0002#),
         8764 => (16#048D#, 16#0020#, 16#0002#),
         8765 => (16#048E#, 16#0020#, 16#0002#),
         8766 => (16#048F#, 16#0020#, 16#0002#),
         8767 => (16#0490#, 16#0020#, 16#0002#),
         8768 => (16#0491#, 16#0020#, 16#0002#),
         8769 => (16#0492#, 16#0020#, 16#0002#),
         8770 => (16#0493#, 16#0020#, 16#0002#),
         8771 => (16#0494#, 16#0020#, 16#0002#),
         8772 => (16#0495#, 16#0020#, 16#0002#),
         8773 => (16#0496#, 16#0020#, 16#0002#),
         8774 => (16#0000#, 16#002F#, 16#0002#),
         8775 => (16#049A#, 16#0020#, 16#0002#),
         8776 => (16#0000#, 16#002F#, 16#0002#),
         8777 => (16#0498#, 16#0020#, 16#0002#),
         8778 => (16#0000#, 16#002F#, 16#0002#),
         8779 => (16#0497#, 16#0020#, 16#0002#),
         8780 => (16#0499#, 16#0020#, 16#0002#),
         8781 => (16#049B#, 16#0020#, 16#0002#),
         8782 => (16#049C#, 16#0020#, 16#0002#),
         8783 => (16#049D#, 16#0020#, 16#0002#),
         8784 => (16#049E#, 16#0020#, 16#0002#),
         8785 => (16#049F#, 16#0020#, 16#0002#),
         8786 => (16#04A0#, 16#0020#, 16#0002#),
         8787 => (16#04A1#, 16#0020#, 16#0002#),
         8788 => (16#04A2#, 16#0020#, 16#0002#),
         8789 => (16#04A3#, 16#0020#, 16#0002#),
         8790 => (16#04A4#, 16#0020#, 16#0002#),
         8791 => (16#04A5#, 16#0020#, 16#0002#),
         8792 => (16#04A6#, 16#0020#, 16#0002#),
         8793 => (16#04A7#, 16#0020#, 16#0002#),
         8794 => (16#04A8#, 16#0020#, 16#0002#),
         8795 => (16#04A9#, 16#0020#, 16#0002#),
         8796 => (16#04AA#, 16#0020#, 16#0002#),
         8797 => (16#04AB#, 16#0020#, 16#0002#),
         8798 => (16#04AC#, 16#0020#, 16#0002#),
         8799 => (16#04AD#, 16#0020#, 16#0002#),
         8800 => (16#04AE#, 16#0020#, 16#0002#),
         8801 => (16#04AF#, 16#0020#, 16#0002#),
         8802 => (16#04B0#, 16#0020#, 16#0002#),
         8803 => (16#04B1#, 16#0020#, 16#0002#),
         8804 => (16#04B2#, 16#0020#, 16#0002#),
         8805 => (16#04B3#, 16#0020#, 16#0002#),
         8806 => (16#04B4#, 16#0020#, 16#0002#),
         8807 => (16#04B5#, 16#0020#, 16#0002#),
         8808 => (16#04B6#, 16#0020#, 16#0002#),
         8809 => (16#04B7#, 16#0020#, 16#0002#),
         8810 => (16#04B8#, 16#0020#, 16#0002#),
         8811 => (16#04B9#, 16#0020#, 16#0002#),
         8812 => (16#04BA#, 16#0020#, 16#0002#),
         8813 => (16#04BB#, 16#0020#, 16#0002#),
         8814 => (16#04BC#, 16#0020#, 16#0002#),
         8815 => (16#04BD#, 16#0020#, 16#0002#),
         8816 => (16#04BE#, 16#0020#, 16#0002#),
         8817 => (16#04BF#, 16#0020#, 16#0002#),
         8818 => (16#04C0#, 16#0020#, 16#0002#),
         8819 => (16#04C1#, 16#0020#, 16#0002#),
         8820 => (16#04C2#, 16#0020#, 16#0002#),
         8821 => (16#04C3#, 16#0020#, 16#0002#),
         8822 => (16#04C4#, 16#0020#, 16#0002#),
         8823 => (16#04C5#, 16#0020#, 16#0002#),
         8824 => (16#04C6#, 16#0020#, 16#0002#),
         8825 => (16#04C7#, 16#0020#, 16#0002#),
         8826 => (16#04C8#, 16#0020#, 16#0002#),
         8827 => (16#04C9#, 16#0020#, 16#0002#),
         8828 => (16#04C9#, 16#0020#, 16#0002#),
         8829 => (16#0000#, 16#002F#, 16#0002#),
         8830 => (16#04CA#, 16#0020#, 16#0002#),
         8831 => (16#04CB#, 16#0020#, 16#0002#),
         8832 => (16#04CC#, 16#0020#, 16#0002#),
         8833 => (16#04CD#, 16#0020#, 16#0002#),
         8834 => (16#04CD#, 16#0020#, 16#0002#),
         8835 => (16#0000#, 16#002F#, 16#0002#),
         8836 => (16#04CE#, 16#0020#, 16#0002#),
         8837 => (16#04CF#, 16#0020#, 16#0002#),
         8838 => (16#04CF#, 16#0020#, 16#0002#),
         8839 => (16#0000#, 16#002F#, 16#0002#),
         8840 => (16#04D0#, 16#0020#, 16#0002#),
         8841 => (16#04D2#, 16#0020#, 16#0002#),
         8842 => (16#04D3#, 16#0020#, 16#0002#),
         8843 => (16#04D4#, 16#0020#, 16#0002#),
         8844 => (16#04D5#, 16#0020#, 16#0002#),
         8845 => (16#04E1#, 16#0020#, 16#0002#),
         8846 => (16#04E3#, 16#0020#, 16#0002#),
         8847 => (16#04E4#, 16#0020#, 16#0002#),
         8848 => (16#04E5#, 16#0020#, 16#0002#),
         8849 => (16#04E7#, 16#0020#, 16#0002#),
         8850 => (16#04E8#, 16#0020#, 16#0002#),
         8851 => (16#04E9#, 16#0020#, 16#0002#),
         8852 => (16#04EA#, 16#0020#, 16#0002#),
         8853 => (16#04EB#, 16#0020#, 16#0002#),
         8854 => (16#04EC#, 16#0020#, 16#0002#),
         8855 => (16#04EE#, 16#0020#, 16#0002#),
         8856 => (16#04F0#, 16#0020#, 16#0002#),
         8857 => (16#04F1#, 16#0020#, 16#0002#),
         8858 => (16#04F2#, 16#0020#, 16#0002#),
         8859 => (16#04F3#, 16#0020#, 16#0002#),
         8860 => (16#04F4#, 16#0020#, 16#0002#),
         8861 => (16#04F5#, 16#0020#, 16#0002#),
         8862 => (16#04F6#, 16#0020#, 16#0002#),
         8863 => (16#04F6#, 16#0020#, 16#0002#),
         8864 => (16#0000#, 16#002F#, 16#0002#),
         8865 => (16#04F7#, 16#0020#, 16#0002#),
         8866 => (16#04F7#, 16#0020#, 16#0002#),
         8867 => (16#0000#, 16#002F#, 16#0002#),
         8868 => (16#04F8#, 16#0020#, 16#0002#),
         8869 => (16#04F9#, 16#0020#, 16#0002#),
         8870 => (16#04FA#, 16#0020#, 16#0002#),
         8871 => (16#04FB#, 16#0020#, 16#0002#),
         8872 => (16#04FC#, 16#0020#, 16#0002#),
         8873 => (16#04FC#, 16#0020#, 16#0004#),
         8874 => (16#04FC#, 16#0020#, 16#0004#),
         8875 => (16#04FC#, 16#0020#, 16#0004#),
         8876 => (16#04FC#, 16#0020#, 16#0004#),
         8877 => (16#04FC#, 16#0020#, 16#0004#),
         8878 => (16#04FD#, 16#0020#, 16#0002#),
         8879 => (16#04FD#, 16#0020#, 16#0004#),
         8880 => (16#04FD#, 16#0020#, 16#0004#),
         8881 => (16#04FD#, 16#0020#, 16#0004#),
         8882 => (16#04FD#, 16#0020#, 16#0004#),
         8883 => (16#04FD#, 16#0020#, 16#0004#),
         8884 => (16#04FE#, 16#0020#, 16#0002#),
         8885 => (16#04FF#, 16#0020#, 16#0002#),
         8886 => (16#0500#, 16#0020#, 16#0002#),
         8887 => (16#0501#, 16#0020#, 16#0002#),
         8888 => (16#0502#, 16#0020#, 16#0002#),
         8889 => (16#0503#, 16#0020#, 16#0002#),
         8890 => (16#0504#, 16#0020#, 16#0002#),
         8891 => (16#0505#, 16#0020#, 16#0002#),
         8892 => (16#0506#, 16#0020#, 16#0002#),
         8893 => (16#0507#, 16#0020#, 16#0002#),
         8894 => (16#0508#, 16#0020#, 16#0002#),
         8895 => (16#0509#, 16#0020#, 16#0002#),
         8896 => (16#050A#, 16#0020#, 16#0002#),
         8897 => (16#050B#, 16#0020#, 16#0002#),
         8898 => (16#050C#, 16#0020#, 16#0002#),
         8899 => (16#050D#, 16#0020#, 16#0002#),
         8900 => (16#0509#, 16#0020#, 16#0002#),
         8901 => (16#0000#, 16#002F#, 16#0002#),
         8902 => (16#050E#, 16#0020#, 16#0002#),
         8903 => (16#050F#, 16#0020#, 16#0002#),
         8904 => (16#050F#, 16#0020#, 16#0002#),
         8905 => (16#0000#, 16#002F#, 16#0002#),
         8906 => (16#0510#, 16#0020#, 16#0002#),
         8907 => (16#0511#, 16#0020#, 16#0002#),
         8908 => (16#0510#, 16#0020#, 16#0002#),
         8909 => (16#0000#, 16#002F#, 16#0002#),
         8910 => (16#0512#, 16#0020#, 16#0002#),
         8911 => (16#0512#, 16#0020#, 16#0002#),
         8912 => (16#0000#, 16#002F#, 16#0002#),
         8913 => (16#0513#, 16#0020#, 16#0002#),
         8914 => (16#0514#, 16#0020#, 16#0002#),
         8915 => (16#0515#, 16#0020#, 16#0002#),
         8916 => (16#0516#, 16#0020#, 16#0002#),
         8917 => (16#0517#, 16#0020#, 16#0002#),
         8918 => (16#0518#, 16#0020#, 16#0002#),
         8919 => (16#0519#, 16#0020#, 16#0002#),
         8920 => (16#051A#, 16#0020#, 16#0002#),
         8921 => (16#051B#, 16#0020#, 16#0002#),
         8922 => (16#051C#, 16#0020#, 16#0002#),
         8923 => (16#051D#, 16#0020#, 16#0002#),
         8924 => (16#051E#, 16#0020#, 16#0002#),
         8925 => (16#051F#, 16#0020#, 16#0002#),
         8926 => (16#0520#, 16#0020#, 16#0002#),
         8927 => (16#0521#, 16#0020#, 16#0002#),
         8928 => (16#0522#, 16#0020#, 16#0002#),
         8929 => (16#0523#, 16#0020#, 16#0002#),
         8930 => (16#0524#, 16#0020#, 16#0002#),
         8931 => (16#0525#, 16#0020#, 16#0002#),
         8932 => (16#0526#, 16#0020#, 16#0002#),
         8933 => (16#0527#, 16#0020#, 16#0002#),
         8934 => (16#0528#, 16#0020#, 16#0002#),
         8935 => (16#04DB#, 16#0020#, 16#0002#),
         8936 => (16#0000#, 16#002F#, 16#0002#),
         8937 => (16#0529#, 16#0020#, 16#0002#),
         8938 => (16#0529#, 16#0020#, 16#0002#),
         8939 => (16#0000#, 16#002F#, 16#0002#),
         8940 => (16#052A#, 16#0020#, 16#0002#),
         8941 => (16#052B#, 16#0020#, 16#0002#),
         8942 => (16#052C#, 16#0020#, 16#0002#),
         8943 => (16#052D#, 16#0020#, 16#0002#),
         8944 => (16#052E#, 16#0020#, 16#0002#),
         8945 => (16#052F#, 16#0020#, 16#0002#),
         8946 => (16#0530#, 16#0020#, 16#0002#),
         8947 => (16#0531#, 16#0020#, 16#0002#),
         8948 => (16#0532#, 16#0020#, 16#0002#),
         8949 => (16#0533#, 16#0020#, 16#0002#),
         8950 => (16#0516#, 16#0020#, 16#0002#),
         8951 => (16#0000#, 16#002F#, 16#0002#),
         8952 => (16#04DA#, 16#0020#, 16#0002#),
         8953 => (16#0000#, 16#002F#, 16#0002#),
         8954 => (16#04DC#, 16#0020#, 16#0002#),
         8955 => (16#0000#, 16#002F#, 16#0002#),
         8956 => (16#052B#, 16#0020#, 16#0002#),
         8957 => (16#0000#, 16#002F#, 16#0002#),
         8958 => (16#052C#, 16#0020#, 16#0002#),
         8959 => (16#0000#, 16#002F#, 16#0002#),
         8960 => (16#0534#, 16#0020#, 16#0002#),
         8961 => (16#0535#, 16#0020#, 16#0002#),
         8962 => (16#0534#, 16#0020#, 16#0002#),
         8963 => (16#0000#, 16#002F#, 16#0002#),
         8964 => (16#0535#, 16#0020#, 16#0002#),
         8965 => (16#0000#, 16#002F#, 16#0002#),
         8966 => (16#0536#, 16#0020#, 16#0002#),
         8967 => (16#0537#, 16#0020#, 16#0002#),
         8968 => (16#0536#, 16#0020#, 16#0002#),
         8969 => (16#0000#, 16#002F#, 16#0002#),
         8970 => (16#0537#, 16#0020#, 16#0002#),
         8971 => (16#0000#, 16#002F#, 16#0002#),
         8972 => (16#0538#, 16#0020#, 16#0002#),
         8973 => (16#0539#, 16#0020#, 16#0002#),
         8974 => (16#053A#, 16#0020#, 16#0002#),
         8975 => (16#053B#, 16#0020#, 16#0002#),
         8976 => (16#053C#, 16#0020#, 16#0002#),
         8977 => (16#053D#, 16#0020#, 16#0002#),
         8978 => (16#0538#, 16#0020#, 16#0002#),
         8979 => (16#0000#, 16#002F#, 16#0002#),
         8980 => (16#0539#, 16#0020#, 16#0002#),
         8981 => (16#0000#, 16#002F#, 16#0002#),
         8982 => (16#053E#, 16#0020#, 16#0002#),
         8983 => (16#053F#, 16#0020#, 16#0002#),
         8984 => (16#053E#, 16#0020#, 16#0002#),
         8985 => (16#0000#, 16#002F#, 16#0002#),
         8986 => (16#053F#, 16#0020#, 16#0002#),
         8987 => (16#0000#, 16#002F#, 16#0002#),
         8988 => (16#0540#, 16#0020#, 16#0002#),
         8989 => (16#0541#, 16#0020#, 16#0002#),
         8990 => (16#0540#, 16#0020#, 16#0002#),
         8991 => (16#0000#, 16#002F#, 16#0002#),
         8992 => (16#0541#, 16#0020#, 16#0002#),
         8993 => (16#0000#, 16#002F#, 16#0002#),
         8994 => (16#0542#, 16#0020#, 16#0002#),
         8995 => (16#0543#, 16#0020#, 16#0002#),
         8996 => (16#0544#, 16#0020#, 16#0002#),
         8997 => (16#0545#, 16#0020#, 16#0002#),
         8998 => (16#0546#, 16#0020#, 16#0002#),
         8999 => (16#0547#, 16#0020#, 16#0002#),
         9000 => (16#0548#, 16#0020#, 16#0002#),
         9001 => (16#0549#, 16#0020#, 16#0002#),
         9002 => (16#054A#, 16#0020#, 16#0002#),
         9003 => (16#054B#, 16#0020#, 16#0002#),
         9004 => (16#054C#, 16#0020#, 16#0002#),
         9005 => (16#054D#, 16#0020#, 16#0002#),
         9006 => (16#054E#, 16#0020#, 16#0002#),
         9007 => (16#054F#, 16#0020#, 16#0002#),
         9008 => (16#0550#, 16#0020#, 16#0002#),
         9009 => (16#0551#, 16#0020#, 16#0002#),
         9010 => (16#0552#, 16#0020#, 16#0002#),
         9011 => (16#0553#, 16#0020#, 16#0002#),
         9012 => (16#0554#, 16#0020#, 16#0002#),
         9013 => (16#0555#, 16#0020#, 16#0002#),
         9014 => (16#0556#, 16#0020#, 16#0002#),
         9015 => (16#0557#, 16#0020#, 16#0002#),
         9016 => (16#0558#, 16#0020#, 16#0002#),
         9017 => (16#0559#, 16#0020#, 16#0002#),
         9018 => (16#055A#, 16#0020#, 16#0002#),
         9019 => (16#055B#, 16#0020#, 16#0002#),
         9020 => (16#055C#, 16#0020#, 16#0002#),
         9021 => (16#055D#, 16#0020#, 16#0002#),
         9022 => (16#055E#, 16#0020#, 16#0002#),
         9023 => (16#055F#, 16#0020#, 16#0002#),
         9024 => (16#0560#, 16#0020#, 16#0002#),
         9025 => (16#0561#, 16#0020#, 16#0002#),
         9026 => (16#0562#, 16#0020#, 16#0002#),
         9027 => (16#0563#, 16#0020#, 16#0002#),
         9028 => (16#055A#, 16#0020#, 16#0002#),
         9029 => (16#0000#, 16#002F#, 16#0002#),
         9030 => (16#0560#, 16#0020#, 16#0002#),
         9031 => (16#0000#, 16#002F#, 16#0002#),
         9032 => (16#0561#, 16#0020#, 16#0002#),
         9033 => (16#0000#, 16#002F#, 16#0002#),
         9034 => (16#0563#, 16#0020#, 16#0002#),
         9035 => (16#0000#, 16#002F#, 16#0002#),
         9036 => (16#0564#, 16#0020#, 16#0002#),
         9037 => (16#0565#, 16#0020#, 16#0002#),
         9038 => (16#0566#, 16#0020#, 16#0002#),
         9039 => (16#0567#, 16#0020#, 16#0002#),
         9040 => (16#0568#, 16#0020#, 16#0002#),
         9041 => (16#0569#, 16#0020#, 16#0002#),
         9042 => (16#056A#, 16#0020#, 16#0002#),
         9043 => (16#056B#, 16#0020#, 16#0002#),
         9044 => (16#056C#, 16#0020#, 16#0002#),
         9045 => (16#056D#, 16#0020#, 16#0002#),
         9046 => (16#056E#, 16#0020#, 16#0002#),
         9047 => (16#056F#, 16#0020#, 16#0002#),
         9048 => (16#0570#, 16#0020#, 16#0002#),
         9049 => (16#0572#, 16#0020#, 16#0002#),
         9050 => (16#0573#, 16#0020#, 16#0002#),
         9051 => (16#0574#, 16#0020#, 16#0002#),
         9052 => (16#0575#, 16#0020#, 16#0002#),
         9053 => (16#0576#, 16#0020#, 16#0002#),
         9054 => (16#0577#, 16#0020#, 16#0002#),
         9055 => (16#0578#, 16#0020#, 16#0002#),
         9056 => (16#0579#, 16#0020#, 16#0002#),
         9057 => (16#057A#, 16#0020#, 16#0002#),
         9058 => (16#057B#, 16#0020#, 16#0002#),
         9059 => (16#057C#, 16#0020#, 16#0002#),
         9060 => (16#057D#, 16#0020#, 16#0002#),
         9061 => (16#057E#, 16#0020#, 16#0002#),
         9062 => (16#057F#, 16#0020#, 16#0002#),
         9063 => (16#0580#, 16#0020#, 16#0002#),
         9064 => (16#0581#, 16#0020#, 16#0002#),
         9065 => (16#0582#, 16#0020#, 16#0002#),
         9066 => (16#0583#, 16#0020#, 16#0002#),
         9067 => (16#0584#, 16#0020#, 16#0002#),
         9068 => (16#0585#, 16#0020#, 16#0002#),
         9069 => (16#0586#, 16#0020#, 16#0002#),
         9070 => (16#0587#, 16#0020#, 16#0002#),
         9071 => (16#0588#, 16#0020#, 16#0002#),
         9072 => (16#0589#, 16#0020#, 16#0002#),
         9073 => (16#058A#, 16#0020#, 16#0002#),
         9074 => (16#058B#, 16#0020#, 16#0002#),
         9075 => (16#058C#, 16#0020#, 16#0002#),
         9076 => (16#058D#, 16#0020#, 16#0002#),
         9077 => (16#058E#, 16#0020#, 16#0002#),
         9078 => (16#058F#, 16#0020#, 16#0002#),
         9079 => (16#0590#, 16#0020#, 16#0002#),
         9080 => (16#0591#, 16#0020#, 16#0002#),
         9081 => (16#0592#, 16#0020#, 16#0002#),
         9082 => (16#0593#, 16#0020#, 16#0002#),
         9083 => (16#0594#, 16#0020#, 16#0002#),
         9084 => (16#053A#, 16#0020#, 16#0002#),
         9085 => (16#0000#, 16#002F#, 16#0002#),
         9086 => (16#053B#, 16#0020#, 16#0002#),
         9087 => (16#0000#, 16#002F#, 16#0002#),
         9088 => (16#0549#, 16#0020#, 16#0002#),
         9089 => (16#0000#, 16#002F#, 16#0002#),
         9090 => (16#054A#, 16#0020#, 16#0002#),
         9091 => (16#0000#, 16#002F#, 16#0002#),
         9092 => (16#0595#, 16#0020#, 16#0002#),
         9093 => (16#0596#, 16#0020#, 16#0002#),
         9094 => (16#0597#, 16#0020#, 16#0002#),
         9095 => (16#0598#, 16#0020#, 16#0002#),
         9096 => (16#0599#, 16#0020#, 16#0002#),
         9097 => (16#059A#, 16#0020#, 16#0002#),
         9098 => (16#0566#, 16#0020#, 16#0002#),
         9099 => (16#0000#, 16#002F#, 16#0002#),
         9100 => (16#0567#, 16#0020#, 16#0002#),
         9101 => (16#0000#, 16#002F#, 16#0002#),
         9102 => (16#0568#, 16#0020#, 16#0002#),
         9103 => (16#0000#, 16#002F#, 16#0002#),
         9104 => (16#0569#, 16#0020#, 16#0002#),
         9105 => (16#0000#, 16#002F#, 16#0002#),
         9106 => (16#059B#, 16#0020#, 16#0002#),
         9107 => (16#059C#, 16#0020#, 16#0002#),
         9108 => (16#059D#, 16#0020#, 16#0002#),
         9109 => (16#059E#, 16#0020#, 16#0002#),
         9110 => (16#059F#, 16#0020#, 16#0002#),
         9111 => (16#05A0#, 16#0020#, 16#0002#),
         9112 => (16#05A1#, 16#0020#, 16#0002#),
         9113 => (16#05A2#, 16#0020#, 16#0002#),
         9114 => (16#05A3#, 16#0020#, 16#0002#),
         9115 => (16#05A4#, 16#0020#, 16#0002#),
         9116 => (16#05A5#, 16#0020#, 16#0002#),
         9117 => (16#05A6#, 16#0020#, 16#0002#),
         9118 => (16#05A7#, 16#0020#, 16#0002#),
         9119 => (16#05A8#, 16#0020#, 16#0002#),
         9120 => (16#05A9#, 16#0020#, 16#0002#),
         9121 => (16#05AA#, 16#0020#, 16#0002#),
         9122 => (16#05AB#, 16#0020#, 16#0002#),
         9123 => (16#05AC#, 16#0020#, 16#0002#),
         9124 => (16#05AD#, 16#0020#, 16#0002#),
         9125 => (16#05AE#, 16#0020#, 16#0002#),
         9126 => (16#05AF#, 16#0020#, 16#0002#),
         9127 => (16#05B0#, 16#0020#, 16#0002#),
         9128 => (16#05B1#, 16#0020#, 16#0002#),
         9129 => (16#05B2#, 16#0020#, 16#0002#),
         9130 => (16#05B3#, 16#0020#, 16#0002#),
         9131 => (16#05B4#, 16#0020#, 16#0002#),
         9132 => (16#0217#, 16#0020#, 16#0002#),
         9133 => (16#0218#, 16#0020#, 16#0002#),
         9134 => (16#0219#, 16#0020#, 16#0002#),
         9135 => (16#021A#, 16#0020#, 16#0002#),
         9136 => (16#05B5#, 16#0020#, 16#0002#),
         9137 => (16#05B6#, 16#0020#, 16#0002#),
         9138 => (16#05B7#, 16#0020#, 16#0002#),
         9139 => (16#05B8#, 16#0020#, 16#0002#),
         9140 => (16#05B9#, 16#0020#, 16#0002#),
         9141 => (16#05BA#, 16#0020#, 16#0002#),
         9142 => (16#05BB#, 16#0020#, 16#0002#),
         9143 => (16#05BC#, 16#0020#, 16#0002#),
         9144 => (16#05BD#, 16#0020#, 16#0002#),
         9145 => (16#05BE#, 16#0020#, 16#0002#),
         9146 => (16#05BF#, 16#0020#, 16#0002#),
         9147 => (16#05C0#, 16#0020#, 16#0002#),
         9148 => (16#05C1#, 16#0020#, 16#0002#),
         9149 => (16#05C2#, 16#0020#, 16#0002#),
         9150 => (16#05C3#, 16#0020#, 16#0002#),
         9151 => (16#05C4#, 16#0020#, 16#0002#),
         9152 => (16#05C5#, 16#0020#, 16#0002#),
         9153 => (16#05C6#, 16#0020#, 16#0002#),
         9154 => (16#05C7#, 16#0020#, 16#0002#),
         9155 => (16#05C8#, 16#0020#, 16#0002#),
         9156 => (16#05C9#, 16#0020#, 16#0002#),
         9157 => (16#05CA#, 16#0020#, 16#0002#),
         9158 => (16#05CB#, 16#0020#, 16#0002#),
         9159 => (16#05CC#, 16#0020#, 16#0002#),
         9160 => (16#05CD#, 16#0020#, 16#0002#),
         9161 => (16#05CE#, 16#0020#, 16#0002#),
         9162 => (16#05CF#, 16#0020#, 16#0002#),
         9163 => (16#05D0#, 16#0020#, 16#0002#),
         9164 => (16#05D1#, 16#0020#, 16#0002#),
         9165 => (16#0261#, 16#0020#, 16#0002#),
         9166 => (16#0262#, 16#0020#, 16#0002#),
         9167 => (16#05D2#, 16#0020#, 16#0002#),
         9168 => (16#05D3#, 16#0020#, 16#0002#),
         9169 => (16#05D4#, 16#0020#, 16#0002#),
         9170 => (16#05D5#, 16#0020#, 16#0002#),
         9171 => (16#05D6#, 16#0020#, 16#0002#),
         9172 => (16#05D7#, 16#0020#, 16#0002#),
         9173 => (16#05D8#, 16#0020#, 16#0002#),
         9174 => (16#05D9#, 16#0020#, 16#0002#),
         9175 => (16#05DA#, 16#0020#, 16#0002#),
         9176 => (16#05DB#, 16#0020#, 16#0002#),
         9177 => (16#05DC#, 16#0020#, 16#0002#),
         9178 => (16#05DD#, 16#0020#, 16#0002#),
         9179 => (16#05DE#, 16#0020#, 16#0002#),
         9180 => (16#05DF#, 16#0020#, 16#0002#),
         9181 => (16#05E0#, 16#0020#, 16#0002#),
         9182 => (16#05E1#, 16#0020#, 16#0002#),
         9183 => (16#05E2#, 16#0020#, 16#0002#),
         9184 => (16#05E3#, 16#0020#, 16#0002#),
         9185 => (16#05E4#, 16#0020#, 16#0002#),
         9186 => (16#05E5#, 16#0020#, 16#0002#),
         9187 => (16#05E6#, 16#0020#, 16#0002#),
         9188 => (16#05E7#, 16#0020#, 16#0002#),
         9189 => (16#05E8#, 16#0020#, 16#0002#),
         9190 => (16#05E9#, 16#0020#, 16#0002#),
         9191 => (16#05EA#, 16#0020#, 16#0002#),
         9192 => (16#05EB#, 16#0020#, 16#0002#),
         9193 => (16#05EC#, 16#0020#, 16#0002#),
         9194 => (16#05ED#, 16#0020#, 16#0002#),
         9195 => (16#05EE#, 16#0020#, 16#0002#),
         9196 => (16#05EF#, 16#0020#, 16#0002#),
         9197 => (16#05F0#, 16#0020#, 16#0002#),
         9198 => (16#05F1#, 16#0020#, 16#0002#),
         9199 => (16#05F2#, 16#0020#, 16#0002#),
         9200 => (16#05F3#, 16#0020#, 16#0002#),
         9201 => (16#05F4#, 16#0020#, 16#0002#),
         9202 => (16#05F5#, 16#0020#, 16#0002#),
         9203 => (16#05F6#, 16#0020#, 16#0002#),
         9204 => (16#05F7#, 16#0020#, 16#0002#),
         9205 => (16#05F8#, 16#0020#, 16#0002#),
         9206 => (16#05F9#, 16#0020#, 16#0002#),
         9207 => (16#05FA#, 16#0020#, 16#0002#),
         9208 => (16#05FB#, 16#0020#, 16#0002#),
         9209 => (16#05FC#, 16#0020#, 16#0002#),
         9210 => (16#05FD#, 16#0020#, 16#0002#),
         9211 => (16#05FE#, 16#0020#, 16#0002#),
         9212 => (16#05FF#, 16#0020#, 16#0002#),
         9213 => (16#0600#, 16#0020#, 16#0002#),
         9214 => (16#0601#, 16#0020#, 16#0002#),
         9215 => (16#0602#, 16#0020#, 16#0002#),
         9216 => (16#0603#, 16#0020#, 16#0002#),
         9217 => (16#0604#, 16#0020#, 16#0002#),
         9218 => (16#0605#, 16#0020#, 16#0002#),
         9219 => (16#0606#, 16#0020#, 16#0002#),
         9220 => (16#0607#, 16#0020#, 16#0002#),
         9221 => (16#0608#, 16#0020#, 16#0002#),
         9222 => (16#0609#, 16#0020#, 16#0002#),
         9223 => (16#060A#, 16#0020#, 16#0002#),
         9224 => (16#060B#, 16#0020#, 16#0002#),
         9225 => (16#060C#, 16#0020#, 16#0002#),
         9226 => (16#060D#, 16#0020#, 16#0002#),
         9227 => (16#060E#, 16#0020#, 16#0002#),
         9228 => (16#060F#, 16#0020#, 16#0002#),
         9229 => (16#0610#, 16#0020#, 16#0002#),
         9230 => (16#0611#, 16#0020#, 16#0002#),
         9231 => (16#0612#, 16#0020#, 16#0002#),
         9232 => (16#0613#, 16#0020#, 16#0002#),
         9233 => (16#0614#, 16#0020#, 16#0002#),
         9234 => (16#0615#, 16#0020#, 16#0002#),
         9235 => (16#0616#, 16#0020#, 16#0002#),
         9236 => (16#0617#, 16#0020#, 16#0002#),
         9237 => (16#0618#, 16#0020#, 16#0002#),
         9238 => (16#0619#, 16#0020#, 16#0002#),
         9239 => (16#061A#, 16#0020#, 16#0002#),
         9240 => (16#061B#, 16#0020#, 16#0002#),
         9241 => (16#061C#, 16#0020#, 16#0002#),
         9242 => (16#061D#, 16#0020#, 16#0002#),
         9243 => (16#061E#, 16#0020#, 16#0002#),
         9244 => (16#061F#, 16#0020#, 16#0002#),
         9245 => (16#0620#, 16#0020#, 16#0002#),
         9246 => (16#0621#, 16#0020#, 16#0002#),
         9247 => (16#0622#, 16#0020#, 16#0002#),
         9248 => (16#0623#, 16#0020#, 16#0002#),
         9249 => (16#0624#, 16#0020#, 16#0002#),
         9250 => (16#0625#, 16#0020#, 16#0002#),
         9251 => (16#0626#, 16#0020#, 16#0002#),
         9252 => (16#0627#, 16#0020#, 16#0002#),
         9253 => (16#0628#, 16#0020#, 16#0002#),
         9254 => (16#0629#, 16#0020#, 16#0002#),
         9255 => (16#062A#, 16#0020#, 16#0002#),
         9256 => (16#062B#, 16#0020#, 16#0002#),
         9257 => (16#062C#, 16#0020#, 16#0002#),
         9258 => (16#062D#, 16#0020#, 16#0002#),
         9259 => (16#062E#, 16#0020#, 16#0002#),
         9260 => (16#062F#, 16#0020#, 16#0002#),
         9261 => (16#0630#, 16#0020#, 16#0002#),
         9262 => (16#0631#, 16#0020#, 16#0002#),
         9263 => (16#0632#, 16#0020#, 16#0002#),
         9264 => (16#0633#, 16#0020#, 16#0002#),
         9265 => (16#0634#, 16#0020#, 16#0002#),
         9266 => (16#0635#, 16#0020#, 16#0002#),
         9267 => (16#0636#, 16#0020#, 16#0002#),
         9268 => (16#0637#, 16#0020#, 16#0002#),
         9269 => (16#0638#, 16#0020#, 16#0002#),
         9270 => (16#0639#, 16#0020#, 16#0002#),
         9271 => (16#063A#, 16#0020#, 16#0002#),
         9272 => (16#063B#, 16#0020#, 16#0002#),
         9273 => (16#063C#, 16#0020#, 16#0002#),
         9274 => (16#063D#, 16#0020#, 16#0002#),
         9275 => (16#063E#, 16#0020#, 16#0002#),
         9276 => (16#063F#, 16#0020#, 16#0002#),
         9277 => (16#0640#, 16#0020#, 16#0002#),
         9278 => (16#0641#, 16#0020#, 16#0002#),
         9279 => (16#0642#, 16#0020#, 16#0002#),
         9280 => (16#0643#, 16#0020#, 16#0002#),
         9281 => (16#0644#, 16#0020#, 16#0002#),
         9282 => (16#0645#, 16#0020#, 16#0002#),
         9283 => (16#0646#, 16#0020#, 16#0002#),
         9284 => (16#0647#, 16#0020#, 16#0002#),
         9285 => (16#0648#, 16#0020#, 16#0002#),
         9286 => (16#0649#, 16#0020#, 16#0002#),
         9287 => (16#064A#, 16#0020#, 16#0002#),
         9288 => (16#064B#, 16#0020#, 16#0002#),
         9289 => (16#064C#, 16#0020#, 16#0002#),
         9290 => (16#064D#, 16#0020#, 16#0002#),
         9291 => (16#064E#, 16#0020#, 16#0002#),
         9292 => (16#064F#, 16#0020#, 16#0002#),
         9293 => (16#0650#, 16#0020#, 16#0002#),
         9294 => (16#0651#, 16#0020#, 16#0002#),
         9295 => (16#0652#, 16#0020#, 16#0002#),
         9296 => (16#0653#, 16#0020#, 16#0002#),
         9297 => (16#0654#, 16#0020#, 16#0002#),
         9298 => (16#0655#, 16#0020#, 16#0002#),
         9299 => (16#0656#, 16#0020#, 16#0002#),
         9300 => (16#0657#, 16#0020#, 16#0002#),
         9301 => (16#0658#, 16#0020#, 16#0002#),
         9302 => (16#0659#, 16#0020#, 16#0002#),
         9303 => (16#065A#, 16#0020#, 16#0002#),
         9304 => (16#065B#, 16#0020#, 16#0002#),
         9305 => (16#065C#, 16#0020#, 16#0002#),
         9306 => (16#065D#, 16#0020#, 16#0002#),
         9307 => (16#065E#, 16#0020#, 16#0002#),
         9308 => (16#065F#, 16#0020#, 16#0002#),
         9309 => (16#0660#, 16#0020#, 16#0002#),
         9310 => (16#0661#, 16#0020#, 16#0002#),
         9311 => (16#0662#, 16#0020#, 16#0002#),
         9312 => (16#0663#, 16#0020#, 16#0002#),
         9313 => (16#0664#, 16#0020#, 16#0002#),
         9314 => (16#0665#, 16#0020#, 16#0002#),
         9315 => (16#0666#, 16#0020#, 16#0002#),
         9316 => (16#0667#, 16#0020#, 16#0002#),
         9317 => (16#0668#, 16#0020#, 16#0002#),
         9318 => (16#0669#, 16#0020#, 16#0002#),
         9319 => (16#066A#, 16#0020#, 16#0002#),
         9320 => (16#066B#, 16#0020#, 16#0002#),
         9321 => (16#066C#, 16#0020#, 16#0002#),
         9322 => (16#066D#, 16#0020#, 16#0002#),
         9323 => (16#066E#, 16#0020#, 16#0002#),
         9324 => (16#066F#, 16#0020#, 16#0002#),
         9325 => (16#0670#, 16#0020#, 16#0002#),
         9326 => (16#0671#, 16#0020#, 16#0002#),
         9327 => (16#0672#, 16#0020#, 16#0002#),
         9328 => (16#0673#, 16#0020#, 16#0002#),
         9329 => (16#0674#, 16#0020#, 16#0002#),
         9330 => (16#0675#, 16#0020#, 16#0002#),
         9331 => (16#0676#, 16#0020#, 16#0002#),
         9332 => (16#0677#, 16#0020#, 16#0002#),
         9333 => (16#0678#, 16#0020#, 16#0002#),
         9334 => (16#0679#, 16#0020#, 16#0002#),
         9335 => (16#067A#, 16#0020#, 16#0002#),
         9336 => (16#067B#, 16#0020#, 16#0002#),
         9337 => (16#067C#, 16#0020#, 16#0002#),
         9338 => (16#067D#, 16#0020#, 16#0002#),
         9339 => (16#067E#, 16#0020#, 16#0002#),
         9340 => (16#067F#, 16#0020#, 16#0002#),
         9341 => (16#0680#, 16#0020#, 16#0002#),
         9342 => (16#0681#, 16#0020#, 16#0002#),
         9343 => (16#0682#, 16#0020#, 16#0002#),
         9344 => (16#0683#, 16#0020#, 16#0002#),
         9345 => (16#0684#, 16#0020#, 16#0002#),
         9346 => (16#0685#, 16#0020#, 16#0002#),
         9347 => (16#0686#, 16#0020#, 16#0002#),
         9348 => (16#0687#, 16#0020#, 16#0002#),
         9349 => (16#0688#, 16#0020#, 16#0002#),
         9350 => (16#0689#, 16#0020#, 16#0002#),
         9351 => (16#068A#, 16#0020#, 16#0002#),
         9352 => (16#068B#, 16#0020#, 16#0002#),
         9353 => (16#068C#, 16#0020#, 16#0002#),
         9354 => (16#068D#, 16#0020#, 16#0002#),
         9355 => (16#068E#, 16#0020#, 16#0002#),
         9356 => (16#068F#, 16#0020#, 16#0002#),
         9357 => (16#0690#, 16#0020#, 16#0002#),
         9358 => (16#0691#, 16#0020#, 16#0002#),
         9359 => (16#0692#, 16#0020#, 16#0002#),
         9360 => (16#0693#, 16#0020#, 16#0002#),
         9361 => (16#0694#, 16#0020#, 16#0002#),
         9362 => (16#0695#, 16#0020#, 16#0002#),
         9363 => (16#0696#, 16#0020#, 16#0002#),
         9364 => (16#0697#, 16#0020#, 16#0002#),
         9365 => (16#0698#, 16#0020#, 16#0002#),
         9366 => (16#0699#, 16#0020#, 16#0002#),
         9367 => (16#069A#, 16#0020#, 16#0002#),
         9368 => (16#069B#, 16#0020#, 16#0002#),
         9369 => (16#069C#, 16#0020#, 16#0002#),
         9370 => (16#069D#, 16#0020#, 16#0002#),
         9371 => (16#069E#, 16#0020#, 16#0002#),
         9372 => (16#069F#, 16#0020#, 16#0002#),
         9373 => (16#06A0#, 16#0020#, 16#0002#),
         9374 => (16#06A1#, 16#0020#, 16#0002#),
         9375 => (16#06A2#, 16#0020#, 16#0002#),
         9376 => (16#06A3#, 16#0020#, 16#0002#),
         9377 => (16#06A4#, 16#0020#, 16#0002#),
         9378 => (16#06A5#, 16#0020#, 16#0002#),
         9379 => (16#06A6#, 16#0020#, 16#0002#),
         9380 => (16#06A7#, 16#0020#, 16#0002#),
         9381 => (16#06A8#, 16#0020#, 16#0002#),
         9382 => (16#06A9#, 16#0020#, 16#0002#),
         9383 => (16#06AA#, 16#0020#, 16#0002#),
         9384 => (16#06AB#, 16#0020#, 16#0002#),
         9385 => (16#06AC#, 16#0020#, 16#0002#),
         9386 => (16#06AD#, 16#0020#, 16#0002#),
         9387 => (16#06AE#, 16#0020#, 16#0002#),
         9388 => (16#06AF#, 16#0020#, 16#0002#),
         9389 => (16#06B0#, 16#0020#, 16#0002#),
         9390 => (16#06B1#, 16#0020#, 16#0002#),
         9391 => (16#06B2#, 16#0020#, 16#0002#),
         9392 => (16#06B3#, 16#0020#, 16#0002#),
         9393 => (16#06B4#, 16#0020#, 16#0002#),
         9394 => (16#06B5#, 16#0020#, 16#0002#),
         9395 => (16#06B6#, 16#0020#, 16#0002#),
         9396 => (16#06B7#, 16#0020#, 16#0002#),
         9397 => (16#06B8#, 16#0020#, 16#0002#),
         9398 => (16#06B9#, 16#0020#, 16#0002#),
         9399 => (16#06BA#, 16#0020#, 16#0002#),
         9400 => (16#06BB#, 16#0020#, 16#0002#),
         9401 => (16#06BC#, 16#0020#, 16#0002#),
         9402 => (16#06BD#, 16#0020#, 16#0002#),
         9403 => (16#06BE#, 16#0020#, 16#0002#),
         9404 => (16#06BF#, 16#0020#, 16#0002#),
         9405 => (16#06C0#, 16#0020#, 16#0002#),
         9406 => (16#06C1#, 16#0020#, 16#0002#),
         9407 => (16#06C2#, 16#0020#, 16#0002#),
         9408 => (16#06C3#, 16#0020#, 16#0002#),
         9409 => (16#06C4#, 16#0020#, 16#0002#),
         9410 => (16#06C5#, 16#0020#, 16#0002#),
         9411 => (16#06C6#, 16#0020#, 16#0002#),
         9412 => (16#06C7#, 16#0020#, 16#0002#),
         9413 => (16#06C8#, 16#0020#, 16#0002#),
         9414 => (16#06C9#, 16#0020#, 16#0002#),
         9415 => (16#06CA#, 16#0020#, 16#0002#),
         9416 => (16#06CB#, 16#0020#, 16#0002#),
         9417 => (16#06CC#, 16#0020#, 16#0002#),
         9418 => (16#06CD#, 16#0020#, 16#0002#),
         9419 => (16#06CE#, 16#0020#, 16#0002#),
         9420 => (16#06CF#, 16#0020#, 16#0002#),
         9421 => (16#06D0#, 16#0020#, 16#0002#),
         9422 => (16#06D1#, 16#0020#, 16#0002#),
         9423 => (16#06D2#, 16#0020#, 16#0002#),
         9424 => (16#06D3#, 16#0020#, 16#0002#),
         9425 => (16#1804#, 16#0020#, 16#0006#),
         9426 => (16#1805#, 16#0020#, 16#0006#),
         9427 => (16#1806#, 16#0020#, 16#0006#),
         9428 => (16#1807#, 16#0020#, 16#0006#),
         9429 => (16#1808#, 16#0020#, 16#0006#),
         9430 => (16#1809#, 16#0020#, 16#0006#),
         9431 => (16#180A#, 16#0020#, 16#0006#),
         9432 => (16#180B#, 16#0020#, 16#0006#),
         9433 => (16#180C#, 16#0020#, 16#0006#),
         9434 => (16#1804#, 16#0020#, 16#0006#),
         9435 => (16#1803#, 16#0020#, 16#0006#),
         9436 => (16#1804#, 16#0020#, 16#0006#),
         9437 => (16#1804#, 16#0020#, 16#0006#),
         9438 => (16#1804#, 16#0020#, 16#0006#),
         9439 => (16#1806#, 16#0020#, 16#0006#),
         9440 => (16#1804#, 16#0020#, 16#0006#),
         9441 => (16#1807#, 16#0020#, 16#0006#),
         9442 => (16#1804#, 16#0020#, 16#0006#),
         9443 => (16#1808#, 16#0020#, 16#0006#),
         9444 => (16#1804#, 16#0020#, 16#0006#),
         9445 => (16#1809#, 16#0020#, 16#0006#),
         9446 => (16#1804#, 16#0020#, 16#0006#),
         9447 => (16#180A#, 16#0020#, 16#0006#),
         9448 => (16#1804#, 16#0020#, 16#0006#),
         9449 => (16#180B#, 16#0020#, 16#0006#),
         9450 => (16#1804#, 16#0020#, 16#0006#),
         9451 => (16#180C#, 16#0020#, 16#0006#),
         9452 => (16#1805#, 16#0020#, 16#0006#),
         9453 => (16#1803#, 16#0020#, 16#0006#),
         9454 => (16#0209#, 16#0020#, 16#0004#),
         9455 => (16#1804#, 16#0020#, 16#0004#),
         9456 => (16#020A#, 16#0020#, 16#0004#),
         9457 => (16#0209#, 16#0020#, 16#0004#),
         9458 => (16#1805#, 16#0020#, 16#0004#),
         9459 => (16#020A#, 16#0020#, 16#0004#),
         9460 => (16#0209#, 16#0020#, 16#0004#),
         9461 => (16#1806#, 16#0020#, 16#0004#),
         9462 => (16#020A#, 16#0020#, 16#0004#),
         9463 => (16#0209#, 16#0020#, 16#0004#),
         9464 => (16#1807#, 16#0020#, 16#0004#),
         9465 => (16#020A#, 16#0020#, 16#0004#),
         9466 => (16#0209#, 16#0020#, 16#0004#),
         9467 => (16#1808#, 16#0020#, 16#0004#),
         9468 => (16#020A#, 16#0020#, 16#0004#),
         9469 => (16#0209#, 16#0020#, 16#0004#),
         9470 => (16#1809#, 16#0020#, 16#0004#),
         9471 => (16#020A#, 16#0020#, 16#0004#),
         9472 => (16#0209#, 16#0020#, 16#0004#),
         9473 => (16#180A#, 16#0020#, 16#0004#),
         9474 => (16#020A#, 16#0020#, 16#0004#),
         9475 => (16#0209#, 16#0020#, 16#0004#),
         9476 => (16#180B#, 16#0020#, 16#0004#),
         9477 => (16#020A#, 16#0020#, 16#0004#),
         9478 => (16#0209#, 16#0020#, 16#0004#),
         9479 => (16#180C#, 16#0020#, 16#0004#),
         9480 => (16#020A#, 16#0020#, 16#0004#),
         9481 => (16#0209#, 16#0020#, 16#0004#),
         9482 => (16#1804#, 16#0020#, 16#0004#),
         9483 => (16#1803#, 16#0020#, 16#0004#),
         9484 => (16#020A#, 16#0020#, 16#0004#),
         9485 => (16#0209#, 16#0020#, 16#0004#),
         9486 => (16#1804#, 16#0020#, 16#0004#),
         9487 => (16#1804#, 16#0020#, 16#0004#),
         9488 => (16#020A#, 16#0020#, 16#0004#),
         9489 => (16#0209#, 16#0020#, 16#0004#),
         9490 => (16#1804#, 16#0020#, 16#0004#),
         9491 => (16#1805#, 16#0020#, 16#0004#),
         9492 => (16#020A#, 16#0020#, 16#0004#),
         9493 => (16#0209#, 16#0020#, 16#0004#),
         9494 => (16#1804#, 16#0020#, 16#0004#),
         9495 => (16#1806#, 16#0020#, 16#0004#),
         9496 => (16#020A#, 16#0020#, 16#0004#),
         9497 => (16#0209#, 16#0020#, 16#0004#),
         9498 => (16#1804#, 16#0020#, 16#0004#),
         9499 => (16#1807#, 16#0020#, 16#0004#),
         9500 => (16#020A#, 16#0020#, 16#0004#),
         9501 => (16#0209#, 16#0020#, 16#0004#),
         9502 => (16#1804#, 16#0020#, 16#0004#),
         9503 => (16#1808#, 16#0020#, 16#0004#),
         9504 => (16#020A#, 16#0020#, 16#0004#),
         9505 => (16#0209#, 16#0020#, 16#0004#),
         9506 => (16#1804#, 16#0020#, 16#0004#),
         9507 => (16#1809#, 16#0020#, 16#0004#),
         9508 => (16#020A#, 16#0020#, 16#0004#),
         9509 => (16#0209#, 16#0020#, 16#0004#),
         9510 => (16#1804#, 16#0020#, 16#0004#),
         9511 => (16#180A#, 16#0020#, 16#0004#),
         9512 => (16#020A#, 16#0020#, 16#0004#),
         9513 => (16#0209#, 16#0020#, 16#0004#),
         9514 => (16#1804#, 16#0020#, 16#0004#),
         9515 => (16#180B#, 16#0020#, 16#0004#),
         9516 => (16#020A#, 16#0020#, 16#0004#),
         9517 => (16#0209#, 16#0020#, 16#0004#),
         9518 => (16#1804#, 16#0020#, 16#0004#),
         9519 => (16#180C#, 16#0020#, 16#0004#),
         9520 => (16#020A#, 16#0020#, 16#0004#),
         9521 => (16#0209#, 16#0020#, 16#0004#),
         9522 => (16#1805#, 16#0020#, 16#0004#),
         9523 => (16#1803#, 16#0020#, 16#0004#),
         9524 => (16#020A#, 16#0020#, 16#0004#),
         9525 => (16#1804#, 16#0020#, 16#0004#),
         9526 => (16#0173#, 16#0020#, 16#0004#),
         9527 => (16#1805#, 16#0020#, 16#0004#),
         9528 => (16#0173#, 16#0020#, 16#0004#),
         9529 => (16#1806#, 16#0020#, 16#0004#),
         9530 => (16#0173#, 16#0020#, 16#0004#),
         9531 => (16#1807#, 16#0020#, 16#0004#),
         9532 => (16#0173#, 16#0020#, 16#0004#),
         9533 => (16#1808#, 16#0020#, 16#0004#),
         9534 => (16#0173#, 16#0020#, 16#0004#),
         9535 => (16#1809#, 16#0020#, 16#0004#),
         9536 => (16#0173#, 16#0020#, 16#0004#),
         9537 => (16#180A#, 16#0020#, 16#0004#),
         9538 => (16#0173#, 16#0020#, 16#0004#),
         9539 => (16#180B#, 16#0020#, 16#0004#),
         9540 => (16#0173#, 16#0020#, 16#0004#),
         9541 => (16#180C#, 16#0020#, 16#0004#),
         9542 => (16#0173#, 16#0020#, 16#0004#),
         9543 => (16#1804#, 16#0020#, 16#0004#),
         9544 => (16#1803#, 16#0020#, 16#0004#),
         9545 => (16#0173#, 16#0020#, 16#0004#),
         9546 => (16#1804#, 16#0020#, 16#0004#),
         9547 => (16#1804#, 16#0020#, 16#0004#),
         9548 => (16#0173#, 16#0020#, 16#0004#),
         9549 => (16#1804#, 16#0020#, 16#0004#),
         9550 => (16#1805#, 16#0020#, 16#0004#),
         9551 => (16#0173#, 16#0020#, 16#0004#),
         9552 => (16#1804#, 16#0020#, 16#0004#),
         9553 => (16#1806#, 16#0020#, 16#0004#),
         9554 => (16#0173#, 16#0020#, 16#0004#),
         9555 => (16#1804#, 16#0020#, 16#0004#),
         9556 => (16#1807#, 16#0020#, 16#0004#),
         9557 => (16#0173#, 16#0020#, 16#0004#),
         9558 => (16#1804#, 16#0020#, 16#0004#),
         9559 => (16#1808#, 16#0020#, 16#0004#),
         9560 => (16#0173#, 16#0020#, 16#0004#),
         9561 => (16#1804#, 16#0020#, 16#0004#),
         9562 => (16#1809#, 16#0020#, 16#0004#),
         9563 => (16#0173#, 16#0020#, 16#0004#),
         9564 => (16#1804#, 16#0020#, 16#0004#),
         9565 => (16#180A#, 16#0020#, 16#0004#),
         9566 => (16#0173#, 16#0020#, 16#0004#),
         9567 => (16#1804#, 16#0020#, 16#0004#),
         9568 => (16#180B#, 16#0020#, 16#0004#),
         9569 => (16#0173#, 16#0020#, 16#0004#),
         9570 => (16#1804#, 16#0020#, 16#0004#),
         9571 => (16#180C#, 16#0020#, 16#0004#),
         9572 => (16#0173#, 16#0020#, 16#0004#),
         9573 => (16#1805#, 16#0020#, 16#0004#),
         9574 => (16#1803#, 16#0020#, 16#0004#),
         9575 => (16#0173#, 16#0020#, 16#0004#),
         9576 => (16#0209#, 16#0020#, 16#0004#),
         9577 => (16#190C#, 16#0020#, 16#0004#),
         9578 => (16#020A#, 16#0020#, 16#0004#),
         9579 => (16#0209#, 16#0020#, 16#0004#),
         9580 => (16#1925#, 16#0020#, 16#0004#),
         9581 => (16#020A#, 16#0020#, 16#0004#),
         9582 => (16#0209#, 16#0020#, 16#0004#),
         9583 => (16#193E#, 16#0020#, 16#0004#),
         9584 => (16#020A#, 16#0020#, 16#0004#),
         9585 => (16#0209#, 16#0020#, 16#0004#),
         9586 => (16#1953#, 16#0020#, 16#0004#),
         9587 => (16#020A#, 16#0020#, 16#0004#),
         9588 => (16#0209#, 16#0020#, 16#0004#),
         9589 => (16#196E#, 16#0020#, 16#0004#),
         9590 => (16#020A#, 16#0020#, 16#0004#),
         9591 => (16#0209#, 16#0020#, 16#0004#),
         9592 => (16#19A9#, 16#0020#, 16#0004#),
         9593 => (16#020A#, 16#0020#, 16#0004#),
         9594 => (16#0209#, 16#0020#, 16#0004#),
         9595 => (16#19B8#, 16#0020#, 16#0004#),
         9596 => (16#020A#, 16#0020#, 16#0004#),
         9597 => (16#0209#, 16#0020#, 16#0004#),
         9598 => (16#19DC#, 16#0020#, 16#0004#),
         9599 => (16#020A#, 16#0020#, 16#0004#),
         9600 => (16#0209#, 16#0020#, 16#0004#),
         9601 => (16#19F6#, 16#0020#, 16#0004#),
         9602 => (16#020A#, 16#0020#, 16#0004#),
         9603 => (16#0209#, 16#0020#, 16#0004#),
         9604 => (16#1A10#, 16#0020#, 16#0004#),
         9605 => (16#020A#, 16#0020#, 16#0004#),
         9606 => (16#0209#, 16#0020#, 16#0004#),
         9607 => (16#1A29#, 16#0020#, 16#0004#),
         9608 => (16#020A#, 16#0020#, 16#0004#),
         9609 => (16#0209#, 16#0020#, 16#0004#),
         9610 => (16#1A3B#, 16#0020#, 16#0004#),
         9611 => (16#020A#, 16#0020#, 16#0004#),
         9612 => (16#0209#, 16#0020#, 16#0004#),
         9613 => (16#1A6E#, 16#0020#, 16#0004#),
         9614 => (16#020A#, 16#0020#, 16#0004#),
         9615 => (16#0209#, 16#0020#, 16#0004#),
         9616 => (16#1A7D#, 16#0020#, 16#0004#),
         9617 => (16#020A#, 16#0020#, 16#0004#),
         9618 => (16#0209#, 16#0020#, 16#0004#),
         9619 => (16#1AA1#, 16#0020#, 16#0004#),
         9620 => (16#020A#, 16#0020#, 16#0004#),
         9621 => (16#0209#, 16#0020#, 16#0004#),
         9622 => (16#1ACE#, 16#0020#, 16#0004#),
         9623 => (16#020A#, 16#0020#, 16#0004#),
         9624 => (16#0209#, 16#0020#, 16#0004#),
         9625 => (16#1AE3#, 16#0020#, 16#0004#),
         9626 => (16#020A#, 16#0020#, 16#0004#),
         9627 => (16#0209#, 16#0020#, 16#0004#),
         9628 => (16#1AF5#, 16#0020#, 16#0004#),
         9629 => (16#020A#, 16#0020#, 16#0004#),
         9630 => (16#0209#, 16#0020#, 16#0004#),
         9631 => (16#1B33#, 16#0020#, 16#0004#),
         9632 => (16#020A#, 16#0020#, 16#0004#),
         9633 => (16#0209#, 16#0020#, 16#0004#),
         9634 => (16#1B57#, 16#0020#, 16#0004#),
         9635 => (16#020A#, 16#0020#, 16#0004#),
         9636 => (16#0209#, 16#0020#, 16#0004#),
         9637 => (16#1B77#, 16#0020#, 16#0004#),
         9638 => (16#020A#, 16#0020#, 16#0004#),
         9639 => (16#0209#, 16#0020#, 16#0004#),
         9640 => (16#1BA5#, 16#0020#, 16#0004#),
         9641 => (16#020A#, 16#0020#, 16#0004#),
         9642 => (16#0209#, 16#0020#, 16#0004#),
         9643 => (16#1BB7#, 16#0020#, 16#0004#),
         9644 => (16#020A#, 16#0020#, 16#0004#),
         9645 => (16#0209#, 16#0020#, 16#0004#),
         9646 => (16#1BC1#, 16#0020#, 16#0004#),
         9647 => (16#020A#, 16#0020#, 16#0004#),
         9648 => (16#0209#, 16#0020#, 16#0004#),
         9649 => (16#1BCD#, 16#0020#, 16#0004#),
         9650 => (16#020A#, 16#0020#, 16#0004#),
         9651 => (16#0209#, 16#0020#, 16#0004#),
         9652 => (16#1BE3#, 16#0020#, 16#0004#),
         9653 => (16#020A#, 16#0020#, 16#0004#),
         9654 => (16#190C#, 16#0020#, 16#000C#),
         9655 => (16#1925#, 16#0020#, 16#000C#),
         9656 => (16#193E#, 16#0020#, 16#000C#),
         9657 => (16#1953#, 16#0020#, 16#000C#),
         9658 => (16#196E#, 16#0020#, 16#000C#),
         9659 => (16#19A9#, 16#0020#, 16#000C#),
         9660 => (16#19B8#, 16#0020#, 16#000C#),
         9661 => (16#19DC#, 16#0020#, 16#000C#),
         9662 => (16#19F6#, 16#0020#, 16#000C#),
         9663 => (16#1A10#, 16#0020#, 16#000C#),
         9664 => (16#1A29#, 16#0020#, 16#000C#),
         9665 => (16#1A3B#, 16#0020#, 16#000C#),
         9666 => (16#1A6E#, 16#0020#, 16#000C#),
         9667 => (16#1A7D#, 16#0020#, 16#000C#),
         9668 => (16#1AA1#, 16#0020#, 16#000C#),
         9669 => (16#1ACE#, 16#0020#, 16#000C#),
         9670 => (16#1AE3#, 16#0020#, 16#000C#),
         9671 => (16#1AF5#, 16#0020#, 16#000C#),
         9672 => (16#1B33#, 16#0020#, 16#000C#),
         9673 => (16#1B57#, 16#0020#, 16#000C#),
         9674 => (16#1B77#, 16#0020#, 16#000C#),
         9675 => (16#1BA5#, 16#0020#, 16#000C#),
         9676 => (16#1BB7#, 16#0020#, 16#000C#),
         9677 => (16#1BC1#, 16#0020#, 16#000C#),
         9678 => (16#1BCD#, 16#0020#, 16#000C#),
         9679 => (16#1BE3#, 16#0020#, 16#000C#),
         9680 => (16#190C#, 16#0020#, 16#0006#),
         9681 => (16#1925#, 16#0020#, 16#0006#),
         9682 => (16#193E#, 16#0020#, 16#0006#),
         9683 => (16#1953#, 16#0020#, 16#0006#),
         9684 => (16#196E#, 16#0020#, 16#0006#),
         9685 => (16#19A9#, 16#0020#, 16#0006#),
         9686 => (16#19B8#, 16#0020#, 16#0006#),
         9687 => (16#19DC#, 16#0020#, 16#0006#),
         9688 => (16#19F6#, 16#0020#, 16#0006#),
         9689 => (16#1A10#, 16#0020#, 16#0006#),
         9690 => (16#1A29#, 16#0020#, 16#0006#),
         9691 => (16#1A3B#, 16#0020#, 16#0006#),
         9692 => (16#1A6E#, 16#0020#, 16#0006#),
         9693 => (16#1A7D#, 16#0020#, 16#0006#),
         9694 => (16#1AA1#, 16#0020#, 16#0006#),
         9695 => (16#1ACE#, 16#0020#, 16#0006#),
         9696 => (16#1AE3#, 16#0020#, 16#0006#),
         9697 => (16#1AF5#, 16#0020#, 16#0006#),
         9698 => (16#1B33#, 16#0020#, 16#0006#),
         9699 => (16#1B57#, 16#0020#, 16#0006#),
         9700 => (16#1B77#, 16#0020#, 16#0006#),
         9701 => (16#1BA5#, 16#0020#, 16#0006#),
         9702 => (16#1BB7#, 16#0020#, 16#0006#),
         9703 => (16#1BC1#, 16#0020#, 16#0006#),
         9704 => (16#1BCD#, 16#0020#, 16#0006#),
         9705 => (16#1BE3#, 16#0020#, 16#0006#),
         9706 => (16#06D4#, 16#0020#, 16#0002#),
         9707 => (16#06D5#, 16#0020#, 16#0002#),
         9708 => (16#06D6#, 16#0020#, 16#0002#),
         9709 => (16#06D7#, 16#0020#, 16#0002#),
         9710 => (16#06D8#, 16#0020#, 16#0002#),
         9711 => (16#06D9#, 16#0020#, 16#0002#),
         9712 => (16#06DA#, 16#0020#, 16#0002#),
         9713 => (16#06DB#, 16#0020#, 16#0002#),
         9714 => (16#06DC#, 16#0020#, 16#0002#),
         9715 => (16#06DD#, 16#0020#, 16#0002#),
         9716 => (16#06DE#, 16#0020#, 16#0002#),
         9717 => (16#06DF#, 16#0020#, 16#0002#),
         9718 => (16#06E0#, 16#0020#, 16#0002#),
         9719 => (16#06E1#, 16#0020#, 16#0002#),
         9720 => (16#06E2#, 16#0020#, 16#0002#),
         9721 => (16#06E3#, 16#0020#, 16#0002#),
         9722 => (16#06E4#, 16#0020#, 16#0002#),
         9723 => (16#06E5#, 16#0020#, 16#0002#),
         9724 => (16#06E6#, 16#0020#, 16#0002#),
         9725 => (16#06E7#, 16#0020#, 16#0002#),
         9726 => (16#06E8#, 16#0020#, 16#0002#),
         9727 => (16#06E9#, 16#0020#, 16#0002#),
         9728 => (16#06EA#, 16#0020#, 16#0002#),
         9729 => (16#06EB#, 16#0020#, 16#0002#),
         9730 => (16#06EC#, 16#0020#, 16#0002#),
         9731 => (16#06ED#, 16#0020#, 16#0002#),
         9732 => (16#06EE#, 16#0020#, 16#0002#),
         9733 => (16#06EF#, 16#0020#, 16#0002#),
         9734 => (16#06F0#, 16#0020#, 16#0002#),
         9735 => (16#06F1#, 16#0020#, 16#0002#),
         9736 => (16#06F2#, 16#0020#, 16#0002#),
         9737 => (16#06F3#, 16#0020#, 16#0002#),
         9738 => (16#06F4#, 16#0020#, 16#0002#),
         9739 => (16#06F5#, 16#0020#, 16#0002#),
         9740 => (16#06F6#, 16#0020#, 16#0002#),
         9741 => (16#06F7#, 16#0020#, 16#0002#),
         9742 => (16#06F8#, 16#0020#, 16#0002#),
         9743 => (16#06F9#, 16#0020#, 16#0002#),
         9744 => (16#06FA#, 16#0020#, 16#0002#),
         9745 => (16#06FB#, 16#0020#, 16#0002#),
         9746 => (16#06FC#, 16#0020#, 16#0002#),
         9747 => (16#06FD#, 16#0020#, 16#0002#),
         9748 => (16#06FE#, 16#0020#, 16#0002#),
         9749 => (16#06FF#, 16#0020#, 16#0002#),
         9750 => (16#0700#, 16#0020#, 16#0002#),
         9751 => (16#0701#, 16#0020#, 16#0002#),
         9752 => (16#0702#, 16#0020#, 16#0002#),
         9753 => (16#0703#, 16#0020#, 16#0002#),
         9754 => (16#0704#, 16#0020#, 16#0002#),
         9755 => (16#0705#, 16#0020#, 16#0002#),
         9756 => (16#0706#, 16#0020#, 16#0002#),
         9757 => (16#0707#, 16#0020#, 16#0002#),
         9758 => (16#0708#, 16#0020#, 16#0002#),
         9759 => (16#0709#, 16#0020#, 16#0002#),
         9760 => (16#070A#, 16#0020#, 16#0002#),
         9761 => (16#070B#, 16#0020#, 16#0002#),
         9762 => (16#070C#, 16#0020#, 16#0002#),
         9763 => (16#070D#, 16#0020#, 16#0002#),
         9764 => (16#070E#, 16#0020#, 16#0002#),
         9765 => (16#070F#, 16#0020#, 16#0002#),
         9766 => (16#0710#, 16#0020#, 16#0002#),
         9767 => (16#0711#, 16#0020#, 16#0002#),
         9768 => (16#0712#, 16#0020#, 16#0002#),
         9769 => (16#0713#, 16#0020#, 16#0002#),
         9770 => (16#0714#, 16#0020#, 16#0002#),
         9771 => (16#0715#, 16#0020#, 16#0002#),
         9772 => (16#0716#, 16#0020#, 16#0002#),
         9773 => (16#0717#, 16#0020#, 16#0002#),
         9774 => (16#0718#, 16#0020#, 16#0002#),
         9775 => (16#0719#, 16#0020#, 16#0002#),
         9776 => (16#071A#, 16#0020#, 16#0002#),
         9777 => (16#071B#, 16#0020#, 16#0002#),
         9778 => (16#071C#, 16#0020#, 16#0002#),
         9779 => (16#071D#, 16#0020#, 16#0002#),
         9780 => (16#071E#, 16#0020#, 16#0002#),
         9781 => (16#071F#, 16#0020#, 16#0002#),
         9782 => (16#0720#, 16#0020#, 16#0002#),
         9783 => (16#0721#, 16#0020#, 16#0002#),
         9784 => (16#0722#, 16#0020#, 16#0002#),
         9785 => (16#0723#, 16#0020#, 16#0002#),
         9786 => (16#0724#, 16#0020#, 16#0002#),
         9787 => (16#0725#, 16#0020#, 16#0002#),
         9788 => (16#0726#, 16#0020#, 16#0002#),
         9789 => (16#0727#, 16#0020#, 16#0002#),
         9790 => (16#0728#, 16#0020#, 16#0002#),
         9791 => (16#0729#, 16#0020#, 16#0002#),
         9792 => (16#072A#, 16#0020#, 16#0002#),
         9793 => (16#072B#, 16#0020#, 16#0002#),
         9794 => (16#072C#, 16#0020#, 16#0002#),
         9795 => (16#072D#, 16#0020#, 16#0002#),
         9796 => (16#072E#, 16#0020#, 16#0002#),
         9797 => (16#072F#, 16#0020#, 16#0002#),
         9798 => (16#0730#, 16#0020#, 16#0002#),
         9799 => (16#0731#, 16#0020#, 16#0002#),
         9800 => (16#0732#, 16#0020#, 16#0002#),
         9801 => (16#0733#, 16#0020#, 16#0002#),
         9802 => (16#0734#, 16#0020#, 16#0002#),
         9803 => (16#0735#, 16#0020#, 16#0002#),
         9804 => (16#0736#, 16#0020#, 16#0002#),
         9805 => (16#0737#, 16#0020#, 16#0002#),
         9806 => (16#0738#, 16#0020#, 16#0002#),
         9807 => (16#0739#, 16#0020#, 16#0002#),
         9808 => (16#073A#, 16#0020#, 16#0002#),
         9809 => (16#073B#, 16#0020#, 16#0002#),
         9810 => (16#073C#, 16#0020#, 16#0002#),
         9811 => (16#073D#, 16#0020#, 16#0002#),
         9812 => (16#073E#, 16#0020#, 16#0002#),
         9813 => (16#073F#, 16#0020#, 16#0002#),
         9814 => (16#0740#, 16#0020#, 16#0002#),
         9815 => (16#0741#, 16#0020#, 16#0002#),
         9816 => (16#0742#, 16#0020#, 16#0002#),
         9817 => (16#0743#, 16#0020#, 16#0002#),
         9818 => (16#0744#, 16#0020#, 16#0002#),
         9819 => (16#0745#, 16#0020#, 16#0002#),
         9820 => (16#0746#, 16#0020#, 16#0002#),
         9821 => (16#0747#, 16#0020#, 16#0002#),
         9822 => (16#0748#, 16#0020#, 16#0002#),
         9823 => (16#0749#, 16#0020#, 16#0002#),
         9824 => (16#074A#, 16#0020#, 16#0002#),
         9825 => (16#074B#, 16#0020#, 16#0002#),
         9826 => (16#074C#, 16#0020#, 16#0002#),
         9827 => (16#074D#, 16#0020#, 16#0002#),
         9828 => (16#074E#, 16#0020#, 16#0002#),
         9829 => (16#074F#, 16#0020#, 16#0002#),
         9830 => (16#0750#, 16#0020#, 16#0002#),
         9831 => (16#0751#, 16#0020#, 16#0002#),
         9832 => (16#0752#, 16#0020#, 16#0002#),
         9833 => (16#0753#, 16#0020#, 16#0002#),
         9834 => (16#0754#, 16#0020#, 16#0002#),
         9835 => (16#0755#, 16#0020#, 16#0002#),
         9836 => (16#0756#, 16#0020#, 16#0002#),
         9837 => (16#0757#, 16#0020#, 16#0002#),
         9838 => (16#0758#, 16#0020#, 16#0002#),
         9839 => (16#0759#, 16#0020#, 16#0002#),
         9840 => (16#075A#, 16#0020#, 16#0002#),
         9841 => (16#075B#, 16#0020#, 16#0002#),
         9842 => (16#075C#, 16#0020#, 16#0002#),
         9843 => (16#075D#, 16#0020#, 16#0002#),
         9844 => (16#075E#, 16#0020#, 16#0002#),
         9845 => (16#075F#, 16#0020#, 16#0002#),
         9846 => (16#0760#, 16#0020#, 16#0002#),
         9847 => (16#0761#, 16#0020#, 16#0002#),
         9848 => (16#0762#, 16#0020#, 16#0002#),
         9849 => (16#0763#, 16#0020#, 16#0002#),
         9850 => (16#0764#, 16#0020#, 16#0002#),
         9851 => (16#0765#, 16#0020#, 16#0002#),
         9852 => (16#0766#, 16#0020#, 16#0002#),
         9853 => (16#0767#, 16#0020#, 16#0002#),
         9854 => (16#0768#, 16#0020#, 16#0002#),
         9855 => (16#0769#, 16#0020#, 16#0002#),
         9856 => (16#076A#, 16#0020#, 16#0002#),
         9857 => (16#076B#, 16#0020#, 16#0002#),
         9858 => (16#076C#, 16#0020#, 16#0002#),
         9859 => (16#076D#, 16#0020#, 16#0002#),
         9860 => (16#076E#, 16#0020#, 16#0002#),
         9861 => (16#076F#, 16#0020#, 16#0002#),
         9862 => (16#0770#, 16#0020#, 16#0002#),
         9863 => (16#0771#, 16#0020#, 16#0002#),
         9864 => (16#0772#, 16#0020#, 16#0002#),
         9865 => (16#0773#, 16#0020#, 16#0002#),
         9866 => (16#0774#, 16#0020#, 16#0002#),
         9867 => (16#0775#, 16#0020#, 16#0002#),
         9868 => (16#0776#, 16#0020#, 16#0002#),
         9869 => (16#0777#, 16#0020#, 16#0002#),
         9870 => (16#0778#, 16#0020#, 16#0002#),
         9871 => (16#0779#, 16#0020#, 16#0002#),
         9872 => (16#077A#, 16#0020#, 16#0002#),
         9873 => (16#077B#, 16#0020#, 16#0002#),
         9874 => (16#077C#, 16#0020#, 16#0002#),
         9875 => (16#077D#, 16#0020#, 16#0002#),
         9876 => (16#077E#, 16#0020#, 16#0002#),
         9877 => (16#077F#, 16#0020#, 16#0002#),
         9878 => (16#0780#, 16#0020#, 16#0002#),
         9879 => (16#0781#, 16#0020#, 16#0002#),
         9880 => (16#0782#, 16#0020#, 16#0002#),
         9881 => (16#0783#, 16#0020#, 16#0002#),
         9882 => (16#0784#, 16#0020#, 16#0002#),
         9883 => (16#0785#, 16#0020#, 16#0002#),
         9884 => (16#0786#, 16#0020#, 16#0002#),
         9885 => (16#0787#, 16#0020#, 16#0002#),
         9886 => (16#0788#, 16#0020#, 16#0002#),
         9887 => (16#0789#, 16#0020#, 16#0002#),
         9888 => (16#078A#, 16#0020#, 16#0002#),
         9889 => (16#078B#, 16#0020#, 16#0002#),
         9890 => (16#078C#, 16#0020#, 16#0002#),
         9891 => (16#078D#, 16#0020#, 16#0002#),
         9892 => (16#078E#, 16#0020#, 16#0002#),
         9893 => (16#078F#, 16#0020#, 16#0002#),
         9894 => (16#0790#, 16#0020#, 16#0002#),
         9895 => (16#0791#, 16#0020#, 16#0002#),
         9896 => (16#0792#, 16#0020#, 16#0002#),
         9897 => (16#0793#, 16#0020#, 16#0002#),
         9898 => (16#0794#, 16#0020#, 16#0002#),
         9899 => (16#0795#, 16#0020#, 16#0002#),
         9900 => (16#0796#, 16#0020#, 16#0002#),
         9901 => (16#0797#, 16#0020#, 16#0002#),
         9902 => (16#0798#, 16#0020#, 16#0002#),
         9903 => (16#0799#, 16#0020#, 16#0002#),
         9904 => (16#079A#, 16#0020#, 16#0002#),
         9905 => (16#079B#, 16#0020#, 16#0002#),
         9906 => (16#079C#, 16#0020#, 16#0002#),
         9907 => (16#079D#, 16#0020#, 16#0002#),
         9908 => (16#079E#, 16#0020#, 16#0002#),
         9909 => (16#079F#, 16#0020#, 16#0002#),
         9910 => (16#07A0#, 16#0020#, 16#0002#),
         9911 => (16#07A1#, 16#0020#, 16#0002#),
         9912 => (16#07A2#, 16#0020#, 16#0002#),
         9913 => (16#07A3#, 16#0020#, 16#0002#),
         9914 => (16#07A4#, 16#0020#, 16#0002#),
         9915 => (16#07A5#, 16#0020#, 16#0002#),
         9916 => (16#07A6#, 16#0020#, 16#0002#),
         9917 => (16#07A7#, 16#0020#, 16#0002#),
         9918 => (16#07A8#, 16#0020#, 16#0002#),
         9919 => (16#07A9#, 16#0020#, 16#0002#),
         9920 => (16#07AA#, 16#0020#, 16#0002#),
         9921 => (16#07AB#, 16#0020#, 16#0002#),
         9922 => (16#07AC#, 16#0020#, 16#0002#),
         9923 => (16#07AD#, 16#0020#, 16#0002#),
         9924 => (16#07AE#, 16#0020#, 16#0002#),
         9925 => (16#07AF#, 16#0020#, 16#0002#),
         9926 => (16#07B0#, 16#0020#, 16#0002#),
         9927 => (16#07B1#, 16#0020#, 16#0002#),
         9928 => (16#07B2#, 16#0020#, 16#0002#),
         9929 => (16#07B3#, 16#0020#, 16#0002#),
         9930 => (16#07B4#, 16#0020#, 16#0002#),
         9931 => (16#07B5#, 16#0020#, 16#0002#),
         9932 => (16#07B6#, 16#0020#, 16#0002#),
         9933 => (16#07B7#, 16#0020#, 16#0002#),
         9934 => (16#07B8#, 16#0020#, 16#0002#),
         9935 => (16#07B9#, 16#0020#, 16#0002#),
         9936 => (16#07BA#, 16#0020#, 16#0002#),
         9937 => (16#07BB#, 16#0020#, 16#0002#),
         9938 => (16#07BC#, 16#0020#, 16#0002#),
         9939 => (16#07BD#, 16#0020#, 16#0002#),
         9940 => (16#07BE#, 16#0020#, 16#0002#),
         9941 => (16#07BF#, 16#0020#, 16#0002#),
         9942 => (16#07C0#, 16#0020#, 16#0002#),
         9943 => (16#07C1#, 16#0020#, 16#0002#),
         9944 => (16#07C2#, 16#0020#, 16#0002#),
         9945 => (16#07C3#, 16#0020#, 16#0002#),
         9946 => (16#07C4#, 16#0020#, 16#0002#),
         9947 => (16#07C5#, 16#0020#, 16#0002#),
         9948 => (16#07C6#, 16#0020#, 16#0002#),
         9949 => (16#07C7#, 16#0020#, 16#0002#),
         9950 => (16#07C8#, 16#0020#, 16#0002#),
         9951 => (16#07C9#, 16#0020#, 16#0002#),
         9952 => (16#07CA#, 16#0020#, 16#0002#),
         9953 => (16#07CB#, 16#0020#, 16#0002#),
         9954 => (16#07CC#, 16#0020#, 16#0002#),
         9955 => (16#07CD#, 16#0020#, 16#0002#),
         9956 => (16#07CE#, 16#0020#, 16#0002#),
         9957 => (16#07CF#, 16#0020#, 16#0002#),
         9958 => (16#07D0#, 16#0020#, 16#0002#),
         9959 => (16#07D1#, 16#0020#, 16#0002#),
         9960 => (16#07D2#, 16#0020#, 16#0002#),
         9961 => (16#07D3#, 16#0020#, 16#0002#),
         9962 => (16#07D4#, 16#0020#, 16#0002#),
         9963 => (16#07D5#, 16#0020#, 16#0002#),
         9964 => (16#07D6#, 16#0020#, 16#0002#),
         9965 => (16#07D7#, 16#0020#, 16#0002#),
         9966 => (16#07D8#, 16#0020#, 16#0002#),
         9967 => (16#07D9#, 16#0020#, 16#0002#),
         9968 => (16#07DA#, 16#0020#, 16#0002#),
         9969 => (16#07DB#, 16#0020#, 16#0002#),
         9970 => (16#07DC#, 16#0020#, 16#0002#),
         9971 => (16#07DD#, 16#0020#, 16#0002#),
         9972 => (16#07DE#, 16#0020#, 16#0002#),
         9973 => (16#07DF#, 16#0020#, 16#0002#),
         9974 => (16#07E0#, 16#0020#, 16#0002#),
         9975 => (16#07E1#, 16#0020#, 16#0002#),
         9976 => (16#07E2#, 16#0020#, 16#0002#),
         9977 => (16#07E3#, 16#0020#, 16#0002#),
         9978 => (16#07E4#, 16#0020#, 16#0002#),
         9979 => (16#07E5#, 16#0020#, 16#0002#),
         9980 => (16#07E6#, 16#0020#, 16#0002#),
         9981 => (16#07E7#, 16#0020#, 16#0002#),
         9982 => (16#07E8#, 16#0020#, 16#0002#),
         9983 => (16#07E9#, 16#0020#, 16#0002#),
         9984 => (16#07EA#, 16#0020#, 16#0002#),
         9985 => (16#07EB#, 16#0020#, 16#0002#),
         9986 => (16#07EC#, 16#0020#, 16#0002#),
         9987 => (16#07ED#, 16#0020#, 16#0002#),
         9988 => (16#07EE#, 16#0020#, 16#0002#),
         9989 => (16#07EF#, 16#0020#, 16#0002#),
         9990 => (16#07F0#, 16#0020#, 16#0002#),
         9991 => (16#07F1#, 16#0020#, 16#0002#),
         9992 => (16#07F2#, 16#0020#, 16#0002#),
         9993 => (16#07F3#, 16#0020#, 16#0002#),
         9994 => (16#07F4#, 16#0020#, 16#0002#),
         9995 => (16#07F5#, 16#0020#, 16#0002#),
         9996 => (16#07F6#, 16#0020#, 16#0002#),
         9997 => (16#07F7#, 16#0020#, 16#0002#),
         9998 => (16#07F8#, 16#0020#, 16#0002#),
         9999 => (16#07F9#, 16#0020#, 16#0002#),
         10000 => (16#07FA#, 16#0020#, 16#0002#),
         10001 => (16#07FB#, 16#0020#, 16#0002#),
         10002 => (16#07FC#, 16#0020#, 16#0002#),
         10003 => (16#07FD#, 16#0020#, 16#0002#),
         10004 => (16#07FE#, 16#0020#, 16#0002#),
         10005 => (16#07FF#, 16#0020#, 16#0002#),
         10006 => (16#0800#, 16#0020#, 16#0002#),
         10007 => (16#0801#, 16#0020#, 16#0002#),
         10008 => (16#0802#, 16#0020#, 16#0002#),
         10009 => (16#0803#, 16#0020#, 16#0002#),
         10010 => (16#0D5A#, 16#0020#, 16#0002#),
         10011 => (16#0D5B#, 16#0020#, 16#0002#),
         10012 => (16#0D5C#, 16#0020#, 16#0002#),
         10013 => (16#0D5D#, 16#0020#, 16#0002#),
         10014 => (16#0D5E#, 16#0020#, 16#0002#),
         10015 => (16#0D5F#, 16#0020#, 16#0002#),
         10016 => (16#0D60#, 16#0020#, 16#0002#),
         10017 => (16#0D61#, 16#0020#, 16#0002#),
         10018 => (16#0804#, 16#0020#, 16#0002#),
         10019 => (16#0805#, 16#0020#, 16#0002#),
         10020 => (16#0806#, 16#0020#, 16#0002#),
         10021 => (16#0807#, 16#0020#, 16#0002#),
         10022 => (16#0808#, 16#0020#, 16#0002#),
         10023 => (16#0809#, 16#0020#, 16#0002#),
         10024 => (16#080A#, 16#0020#, 16#0002#),
         10025 => (16#080B#, 16#0020#, 16#0002#),
         10026 => (16#080C#, 16#0020#, 16#0002#),
         10027 => (16#080D#, 16#0020#, 16#0002#),
         10028 => (16#080E#, 16#0020#, 16#0002#),
         10029 => (16#080F#, 16#0020#, 16#0002#),
         10030 => (16#0810#, 16#0020#, 16#0002#),
         10031 => (16#0811#, 16#0020#, 16#0002#),
         10032 => (16#0812#, 16#0020#, 16#0002#),
         10033 => (16#0813#, 16#0020#, 16#0002#),
         10034 => (16#0814#, 16#0020#, 16#0002#),
         10035 => (16#0815#, 16#0020#, 16#0002#),
         10036 => (16#0816#, 16#0020#, 16#0002#),
         10037 => (16#0817#, 16#0020#, 16#0002#),
         10038 => (16#0818#, 16#0020#, 16#0002#),
         10039 => (16#0819#, 16#0020#, 16#0002#),
         10040 => (16#081A#, 16#0020#, 16#0002#),
         10041 => (16#081B#, 16#0020#, 16#0002#),
         10042 => (16#081C#, 16#0020#, 16#0002#),
         10043 => (16#081D#, 16#0020#, 16#0002#),
         10044 => (16#081E#, 16#0020#, 16#0002#),
         10045 => (16#081F#, 16#0020#, 16#0002#),
         10046 => (16#0820#, 16#0020#, 16#0002#),
         10047 => (16#0821#, 16#0020#, 16#0002#),
         10048 => (16#0822#, 16#0020#, 16#0002#),
         10049 => (16#0823#, 16#0020#, 16#0002#),
         10050 => (16#0824#, 16#0020#, 16#0002#),
         10051 => (16#0825#, 16#0020#, 16#0002#),
         10052 => (16#0826#, 16#0020#, 16#0002#),
         10053 => (16#0827#, 16#0020#, 16#0002#),
         10054 => (16#0828#, 16#0020#, 16#0002#),
         10055 => (16#0829#, 16#0020#, 16#0002#),
         10056 => (16#082A#, 16#0020#, 16#0002#),
         10057 => (16#082B#, 16#0020#, 16#0002#),
         10058 => (16#082C#, 16#0020#, 16#0002#),
         10059 => (16#082D#, 16#0020#, 16#0002#),
         10060 => (16#082E#, 16#0020#, 16#0002#),
         10061 => (16#082F#, 16#0020#, 16#0002#),
         10062 => (16#0830#, 16#0020#, 16#0002#),
         10063 => (16#0831#, 16#0020#, 16#0002#),
         10064 => (16#0832#, 16#0020#, 16#0002#),
         10065 => (16#0833#, 16#0020#, 16#0002#),
         10066 => (16#0834#, 16#0020#, 16#0002#),
         10067 => (16#0835#, 16#0020#, 16#0002#),
         10068 => (16#0836#, 16#0020#, 16#0002#),
         10069 => (16#0837#, 16#0020#, 16#0002#),
         10070 => (16#0838#, 16#0020#, 16#0002#),
         10071 => (16#0FA9#, 16#0020#, 16#0002#),
         10072 => (16#0FAA#, 16#0020#, 16#0002#),
         10073 => (16#0FAB#, 16#0020#, 16#0002#),
         10074 => (16#0839#, 16#0020#, 16#0002#),
         10075 => (16#083A#, 16#0020#, 16#0002#),
         10076 => (16#083B#, 16#0020#, 16#0002#),
         10077 => (16#083C#, 16#0020#, 16#0002#),
         10078 => (16#083D#, 16#0020#, 16#0002#),
         10079 => (16#083E#, 16#0020#, 16#0002#),
         10080 => (16#083F#, 16#0020#, 16#0002#),
         10081 => (16#0840#, 16#0020#, 16#0002#),
         10082 => (16#0841#, 16#0020#, 16#0002#),
         10083 => (16#0842#, 16#0020#, 16#0002#),
         10084 => (16#0843#, 16#0020#, 16#0002#),
         10085 => (16#0844#, 16#0020#, 16#0002#),
         10086 => (16#0845#, 16#0020#, 16#0002#),
         10087 => (16#0846#, 16#0020#, 16#0002#),
         10088 => (16#0847#, 16#0020#, 16#0002#),
         10089 => (16#0848#, 16#0020#, 16#0002#),
         10090 => (16#0849#, 16#0020#, 16#0002#),
         10091 => (16#084A#, 16#0020#, 16#0002#),
         10092 => (16#084B#, 16#0020#, 16#0002#),
         10093 => (16#084C#, 16#0020#, 16#0002#),
         10094 => (16#084D#, 16#0020#, 16#0002#),
         10095 => (16#084E#, 16#0020#, 16#0002#),
         10096 => (16#084F#, 16#0020#, 16#0002#),
         10097 => (16#0850#, 16#0020#, 16#0002#),
         10098 => (16#0851#, 16#0020#, 16#0002#),
         10099 => (16#0852#, 16#0020#, 16#0002#),
         10100 => (16#0D54#, 16#0020#, 16#0002#),
         10101 => (16#0D55#, 16#0020#, 16#0002#),
         10102 => (16#0D56#, 16#0020#, 16#0002#),
         10103 => (16#0D57#, 16#0020#, 16#0002#),
         10104 => (16#0D58#, 16#0020#, 16#0002#),
         10105 => (16#0D59#, 16#0020#, 16#0002#),
         10106 => (16#0853#, 16#0020#, 16#0002#),
         10107 => (16#0854#, 16#0020#, 16#0002#),
         10108 => (16#0855#, 16#0020#, 16#0002#),
         10109 => (16#0856#, 16#0020#, 16#0002#),
         10110 => (16#0857#, 16#0020#, 16#0002#),
         10111 => (16#0858#, 16#0020#, 16#0002#),
         10112 => (16#0859#, 16#0020#, 16#0002#),
         10113 => (16#085A#, 16#0020#, 16#0002#),
         10114 => (16#085B#, 16#0020#, 16#0002#),
         10115 => (16#085C#, 16#0020#, 16#0002#),
         10116 => (16#085D#, 16#0020#, 16#0002#),
         10117 => (16#085E#, 16#0020#, 16#0002#),
         10118 => (16#085F#, 16#0020#, 16#0002#),
         10119 => (16#0860#, 16#0020#, 16#0002#),
         10120 => (16#0861#, 16#0020#, 16#0002#),
         10121 => (16#0862#, 16#0020#, 16#0002#),
         10122 => (16#0863#, 16#0020#, 16#0002#),
         10123 => (16#0864#, 16#0020#, 16#0002#),
         10124 => (16#0865#, 16#0020#, 16#0002#),
         10125 => (16#0866#, 16#0020#, 16#0002#),
         10126 => (16#0867#, 16#0020#, 16#0002#),
         10127 => (16#0868#, 16#0020#, 16#0002#),
         10128 => (16#0869#, 16#0020#, 16#0002#),
         10129 => (16#086A#, 16#0020#, 16#0002#),
         10130 => (16#086B#, 16#0020#, 16#0002#),
         10131 => (16#086C#, 16#0020#, 16#0002#),
         10132 => (16#086D#, 16#0020#, 16#0002#),
         10133 => (16#086E#, 16#0020#, 16#0002#),
         10134 => (16#086F#, 16#0020#, 16#0002#),
         10135 => (16#0870#, 16#0020#, 16#0002#),
         10136 => (16#0871#, 16#0020#, 16#0002#),
         10137 => (16#0872#, 16#0020#, 16#0002#),
         10138 => (16#0873#, 16#0020#, 16#0002#),
         10139 => (16#0874#, 16#0020#, 16#0002#),
         10140 => (16#0875#, 16#0020#, 16#0002#),
         10141 => (16#0876#, 16#0020#, 16#0002#),
         10142 => (16#0877#, 16#0020#, 16#0002#),
         10143 => (16#0878#, 16#0020#, 16#0002#),
         10144 => (16#0879#, 16#0020#, 16#0002#),
         10145 => (16#087A#, 16#0020#, 16#0002#),
         10146 => (16#087B#, 16#0020#, 16#0002#),
         10147 => (16#087C#, 16#0020#, 16#0002#),
         10148 => (16#087D#, 16#0020#, 16#0002#),
         10149 => (16#087E#, 16#0020#, 16#0002#),
         10150 => (16#087F#, 16#0020#, 16#0002#),
         10151 => (16#0880#, 16#0020#, 16#0002#),
         10152 => (16#0881#, 16#0020#, 16#0002#),
         10153 => (16#0882#, 16#0020#, 16#0002#),
         10154 => (16#0883#, 16#0020#, 16#0002#),
         10155 => (16#0884#, 16#0020#, 16#0002#),
         10156 => (16#0885#, 16#0020#, 16#0002#),
         10157 => (16#0886#, 16#0020#, 16#0002#),
         10158 => (16#0887#, 16#0020#, 16#0002#),
         10159 => (16#0888#, 16#0020#, 16#0002#),
         10160 => (16#0889#, 16#0020#, 16#0002#),
         10161 => (16#088A#, 16#0020#, 16#0002#),
         10162 => (16#088B#, 16#0020#, 16#0002#),
         10163 => (16#088C#, 16#0020#, 16#0002#),
         10164 => (16#088D#, 16#0020#, 16#0002#),
         10165 => (16#088E#, 16#0020#, 16#0002#),
         10166 => (16#088F#, 16#0020#, 16#0002#),
         10167 => (16#0890#, 16#0020#, 16#0002#),
         10168 => (16#0891#, 16#0020#, 16#0002#),
         10169 => (16#0892#, 16#0020#, 16#0002#),
         10170 => (16#0893#, 16#0020#, 16#0002#),
         10171 => (16#0894#, 16#0020#, 16#0002#),
         10172 => (16#0895#, 16#0020#, 16#0002#),
         10173 => (16#0896#, 16#0020#, 16#0002#),
         10174 => (16#0897#, 16#0020#, 16#0002#),
         10175 => (16#0898#, 16#0020#, 16#0002#),
         10176 => (16#0899#, 16#0020#, 16#0002#),
         10177 => (16#089A#, 16#0020#, 16#0002#),
         10178 => (16#089B#, 16#0020#, 16#0002#),
         10179 => (16#089C#, 16#0020#, 16#0002#),
         10180 => (16#089D#, 16#0020#, 16#0002#),
         10181 => (16#089E#, 16#0020#, 16#0002#),
         10182 => (16#089F#, 16#0020#, 16#0002#),
         10183 => (16#08A0#, 16#0020#, 16#0002#),
         10184 => (16#08A1#, 16#0020#, 16#0002#),
         10185 => (16#08A2#, 16#0020#, 16#0002#),
         10186 => (16#08A3#, 16#0020#, 16#0002#),
         10187 => (16#08A4#, 16#0020#, 16#0002#),
         10188 => (16#08A5#, 16#0020#, 16#0002#),
         10189 => (16#08A6#, 16#0020#, 16#0002#),
         10190 => (16#08A7#, 16#0020#, 16#0002#),
         10191 => (16#08A8#, 16#0020#, 16#0002#),
         10192 => (16#08A9#, 16#0020#, 16#0002#),
         10193 => (16#08AA#, 16#0020#, 16#0002#),
         10194 => (16#08AB#, 16#0020#, 16#0002#),
         10195 => (16#08AC#, 16#0020#, 16#0002#),
         10196 => (16#08AD#, 16#0020#, 16#0002#),
         10197 => (16#08AE#, 16#0020#, 16#0002#),
         10198 => (16#08AF#, 16#0020#, 16#0002#),
         10199 => (16#08B0#, 16#0020#, 16#0002#),
         10200 => (16#08B1#, 16#0020#, 16#0002#),
         10201 => (16#08B2#, 16#0020#, 16#0002#),
         10202 => (16#08B3#, 16#0020#, 16#0002#),
         10203 => (16#08B4#, 16#0020#, 16#0002#),
         10204 => (16#08B5#, 16#0020#, 16#0002#),
         10205 => (16#08B6#, 16#0020#, 16#0002#),
         10206 => (16#08B7#, 16#0020#, 16#0002#),
         10207 => (16#08B8#, 16#0020#, 16#0002#),
         10208 => (16#08B9#, 16#0020#, 16#0002#),
         10209 => (16#08BA#, 16#0020#, 16#0002#),
         10210 => (16#08BB#, 16#0020#, 16#0002#),
         10211 => (16#08BC#, 16#0020#, 16#0002#),
         10212 => (16#08BD#, 16#0020#, 16#0002#),
         10213 => (16#08BE#, 16#0020#, 16#0002#),
         10214 => (16#08BF#, 16#0020#, 16#0002#),
         10215 => (16#08C0#, 16#0020#, 16#0002#),
         10216 => (16#08C1#, 16#0020#, 16#0002#),
         10217 => (16#08C2#, 16#0020#, 16#0002#),
         10218 => (16#08DD#, 16#0020#, 16#0002#),
         10219 => (16#08DE#, 16#0020#, 16#0002#),
         10220 => (16#08DF#, 16#0020#, 16#0002#),
         10221 => (16#08E0#, 16#0020#, 16#0002#),
         10222 => (16#08E1#, 16#0020#, 16#0002#),
         10223 => (16#08E2#, 16#0020#, 16#0002#),
         10224 => (16#08E3#, 16#0020#, 16#0002#),
         10225 => (16#08E4#, 16#0020#, 16#0002#),
         10226 => (16#08E5#, 16#0020#, 16#0002#),
         10227 => (16#08E6#, 16#0020#, 16#0002#),
         10228 => (16#08E7#, 16#0020#, 16#0002#),
         10229 => (16#08E8#, 16#0020#, 16#0002#),
         10230 => (16#08E9#, 16#0020#, 16#0002#),
         10231 => (16#08EA#, 16#0020#, 16#0002#),
         10232 => (16#08EB#, 16#0020#, 16#0002#),
         10233 => (16#08EC#, 16#0020#, 16#0002#),
         10234 => (16#08ED#, 16#0020#, 16#0002#),
         10235 => (16#08EE#, 16#0020#, 16#0002#),
         10236 => (16#08EF#, 16#0020#, 16#0002#),
         10237 => (16#08F0#, 16#0020#, 16#0002#),
         10238 => (16#08F1#, 16#0020#, 16#0002#),
         10239 => (16#08F2#, 16#0020#, 16#0002#),
         10240 => (16#08F3#, 16#0020#, 16#0002#),
         10241 => (16#08F4#, 16#0020#, 16#0002#),
         10242 => (16#08F5#, 16#0020#, 16#0002#),
         10243 => (16#08F6#, 16#0020#, 16#0002#),
         10244 => (16#08F7#, 16#0020#, 16#0002#),
         10245 => (16#08F8#, 16#0020#, 16#0002#),
         10246 => (16#08F9#, 16#0020#, 16#0002#),
         10247 => (16#08FA#, 16#0020#, 16#0002#),
         10248 => (16#08FB#, 16#0020#, 16#0002#),
         10249 => (16#08FC#, 16#0020#, 16#0002#),
         10250 => (16#08FD#, 16#0020#, 16#0002#),
         10251 => (16#08FE#, 16#0020#, 16#0002#),
         10252 => (16#08FF#, 16#0020#, 16#0002#),
         10253 => (16#0900#, 16#0020#, 16#0002#),
         10254 => (16#0901#, 16#0020#, 16#0002#),
         10255 => (16#0902#, 16#0020#, 16#0002#),
         10256 => (16#0903#, 16#0020#, 16#0002#),
         10257 => (16#0904#, 16#0020#, 16#0002#),
         10258 => (16#0905#, 16#0020#, 16#0002#),
         10259 => (16#0906#, 16#0020#, 16#0002#),
         10260 => (16#0907#, 16#0020#, 16#0002#),
         10261 => (16#0908#, 16#0020#, 16#0002#),
         10262 => (16#0909#, 16#0020#, 16#0002#),
         10263 => (16#090A#, 16#0020#, 16#0002#),
         10264 => (16#090B#, 16#0020#, 16#0002#),
         10265 => (16#090C#, 16#0020#, 16#0002#),
         10266 => (16#090D#, 16#0020#, 16#0002#),
         10267 => (16#090E#, 16#0020#, 16#0002#),
         10268 => (16#090F#, 16#0020#, 16#0002#),
         10269 => (16#0910#, 16#0020#, 16#0002#),
         10270 => (16#0911#, 16#0020#, 16#0002#),
         10271 => (16#0912#, 16#0020#, 16#0002#),
         10272 => (16#0913#, 16#0020#, 16#0002#),
         10273 => (16#0914#, 16#0020#, 16#0002#),
         10274 => (16#0915#, 16#0020#, 16#0002#),
         10275 => (16#0916#, 16#0020#, 16#0002#),
         10276 => (16#0917#, 16#0020#, 16#0002#),
         10277 => (16#0918#, 16#0020#, 16#0002#),
         10278 => (16#0919#, 16#0020#, 16#0002#),
         10279 => (16#091A#, 16#0020#, 16#0002#),
         10280 => (16#091B#, 16#0020#, 16#0002#),
         10281 => (16#091C#, 16#0020#, 16#0002#),
         10282 => (16#091D#, 16#0020#, 16#0002#),
         10283 => (16#091E#, 16#0020#, 16#0002#),
         10284 => (16#091F#, 16#0020#, 16#0002#),
         10285 => (16#0920#, 16#0020#, 16#0002#),
         10286 => (16#0921#, 16#0020#, 16#0002#),
         10287 => (16#0922#, 16#0020#, 16#0002#),
         10288 => (16#0923#, 16#0020#, 16#0002#),
         10289 => (16#0924#, 16#0020#, 16#0002#),
         10290 => (16#0925#, 16#0020#, 16#0002#),
         10291 => (16#0926#, 16#0020#, 16#0002#),
         10292 => (16#0927#, 16#0020#, 16#0002#),
         10293 => (16#0928#, 16#0020#, 16#0002#),
         10294 => (16#0929#, 16#0020#, 16#0002#),
         10295 => (16#092A#, 16#0020#, 16#0002#),
         10296 => (16#092B#, 16#0020#, 16#0002#),
         10297 => (16#092C#, 16#0020#, 16#0002#),
         10298 => (16#092D#, 16#0020#, 16#0002#),
         10299 => (16#092E#, 16#0020#, 16#0002#),
         10300 => (16#092F#, 16#0020#, 16#0002#),
         10301 => (16#0930#, 16#0020#, 16#0002#),
         10302 => (16#0931#, 16#0020#, 16#0002#),
         10303 => (16#0932#, 16#0020#, 16#0002#),
         10304 => (16#0933#, 16#0020#, 16#0002#),
         10305 => (16#0934#, 16#0020#, 16#0002#),
         10306 => (16#0935#, 16#0020#, 16#0002#),
         10307 => (16#0936#, 16#0020#, 16#0002#),
         10308 => (16#0937#, 16#0020#, 16#0002#),
         10309 => (16#0938#, 16#0020#, 16#0002#),
         10310 => (16#0939#, 16#0020#, 16#0002#),
         10311 => (16#093A#, 16#0020#, 16#0002#),
         10312 => (16#093B#, 16#0020#, 16#0002#),
         10313 => (16#093C#, 16#0020#, 16#0002#),
         10314 => (16#093D#, 16#0020#, 16#0002#),
         10315 => (16#093E#, 16#0020#, 16#0002#),
         10316 => (16#093F#, 16#0020#, 16#0002#),
         10317 => (16#0940#, 16#0020#, 16#0002#),
         10318 => (16#0941#, 16#0020#, 16#0002#),
         10319 => (16#0942#, 16#0020#, 16#0002#),
         10320 => (16#0943#, 16#0020#, 16#0002#),
         10321 => (16#0944#, 16#0020#, 16#0002#),
         10322 => (16#023F#, 16#0020#, 16#0002#),
         10323 => (16#0240#, 16#0020#, 16#0002#),
         10324 => (16#0241#, 16#0020#, 16#0002#),
         10325 => (16#0242#, 16#0020#, 16#0002#),
         10326 => (16#0243#, 16#0020#, 16#0002#),
         10327 => (16#0244#, 16#0020#, 16#0002#),
         10328 => (16#0245#, 16#0020#, 16#0002#),
         10329 => (16#0246#, 16#0020#, 16#0002#),
         10330 => (16#0247#, 16#0020#, 16#0002#),
         10331 => (16#0248#, 16#0020#, 16#0002#),
         10332 => (16#0249#, 16#0020#, 16#0002#),
         10333 => (16#024A#, 16#0020#, 16#0002#),
         10334 => (16#024B#, 16#0020#, 16#0002#),
         10335 => (16#024C#, 16#0020#, 16#0002#),
         10336 => (16#0945#, 16#0020#, 16#0002#),
         10337 => (16#0946#, 16#0020#, 16#0002#),
         10338 => (16#0947#, 16#0020#, 16#0002#),
         10339 => (16#0948#, 16#0020#, 16#0002#),
         10340 => (16#0949#, 16#0020#, 16#0002#),
         10341 => (16#094A#, 16#0020#, 16#0002#),
         10342 => (16#094B#, 16#0020#, 16#0002#),
         10343 => (16#094C#, 16#0020#, 16#0002#),
         10344 => (16#094D#, 16#0020#, 16#0002#),
         10345 => (16#094E#, 16#0020#, 16#0002#),
         10346 => (16#094F#, 16#0020#, 16#0002#),
         10347 => (16#0950#, 16#0020#, 16#0002#),
         10348 => (16#0951#, 16#0020#, 16#0002#),
         10349 => (16#0952#, 16#0020#, 16#0002#),
         10350 => (16#0953#, 16#0020#, 16#0002#),
         10351 => (16#0954#, 16#0020#, 16#0002#),
         10352 => (16#0955#, 16#0020#, 16#0002#),
         10353 => (16#0956#, 16#0020#, 16#0002#),
         10354 => (16#0957#, 16#0020#, 16#0002#),
         10355 => (16#0958#, 16#0020#, 16#0002#),
         10356 => (16#0959#, 16#0020#, 16#0002#),
         10357 => (16#095A#, 16#0020#, 16#0002#),
         10358 => (16#095B#, 16#0020#, 16#0002#),
         10359 => (16#095C#, 16#0020#, 16#0002#),
         10360 => (16#095D#, 16#0020#, 16#0002#),
         10361 => (16#095E#, 16#0020#, 16#0002#),
         10362 => (16#095F#, 16#0020#, 16#0002#),
         10363 => (16#0960#, 16#0020#, 16#0002#),
         10364 => (16#0961#, 16#0020#, 16#0002#),
         10365 => (16#0962#, 16#0020#, 16#0002#),
         10366 => (16#0963#, 16#0020#, 16#0002#),
         10367 => (16#0964#, 16#0020#, 16#0002#),
         10368 => (16#0965#, 16#0020#, 16#0002#),
         10369 => (16#0966#, 16#0020#, 16#0002#),
         10370 => (16#0967#, 16#0020#, 16#0002#),
         10371 => (16#0968#, 16#0020#, 16#0002#),
         10372 => (16#0969#, 16#0020#, 16#0002#),
         10373 => (16#096A#, 16#0020#, 16#0002#),
         10374 => (16#096B#, 16#0020#, 16#0002#),
         10375 => (16#096C#, 16#0020#, 16#0002#),
         10376 => (16#096D#, 16#0020#, 16#0002#),
         10377 => (16#096E#, 16#0020#, 16#0002#),
         10378 => (16#096F#, 16#0020#, 16#0002#),
         10379 => (16#0970#, 16#0020#, 16#0002#),
         10380 => (16#0971#, 16#0020#, 16#0002#),
         10381 => (16#0972#, 16#0020#, 16#0002#),
         10382 => (16#0973#, 16#0020#, 16#0002#),
         10383 => (16#0974#, 16#0020#, 16#0002#),
         10384 => (16#0975#, 16#0020#, 16#0002#),
         10385 => (16#0233#, 16#0020#, 16#0002#),
         10386 => (16#0234#, 16#0020#, 16#0002#),
         10387 => (16#0976#, 16#0020#, 16#0002#),
         10388 => (16#0977#, 16#0020#, 16#0002#),
         10389 => (16#0978#, 16#0020#, 16#0002#),
         10390 => (16#0979#, 16#0020#, 16#0002#),
         10391 => (16#097A#, 16#0020#, 16#0002#),
         10392 => (16#097B#, 16#0020#, 16#0002#),
         10393 => (16#097C#, 16#0020#, 16#0002#),
         10394 => (16#097D#, 16#0020#, 16#0002#),
         10395 => (16#097E#, 16#0020#, 16#0002#),
         10396 => (16#097F#, 16#0020#, 16#0002#),
         10397 => (16#0980#, 16#0020#, 16#0002#),
         10398 => (16#0981#, 16#0020#, 16#0002#),
         10399 => (16#0982#, 16#0020#, 16#0002#),
         10400 => (16#0983#, 16#0020#, 16#0002#),
         10401 => (16#0984#, 16#0020#, 16#0002#),
         10402 => (16#0985#, 16#0020#, 16#0002#),
         10403 => (16#0986#, 16#0020#, 16#0002#),
         10404 => (16#0987#, 16#0020#, 16#0002#),
         10405 => (16#0988#, 16#0020#, 16#0002#),
         10406 => (16#0989#, 16#0020#, 16#0002#),
         10407 => (16#098A#, 16#0020#, 16#0002#),
         10408 => (16#098B#, 16#0020#, 16#0002#),
         10409 => (16#098C#, 16#0020#, 16#0002#),
         10410 => (16#098D#, 16#0020#, 16#0002#),
         10411 => (16#098E#, 16#0020#, 16#0002#),
         10412 => (16#098F#, 16#0020#, 16#0002#),
         10413 => (16#0990#, 16#0020#, 16#0002#),
         10414 => (16#0991#, 16#0020#, 16#0002#),
         10415 => (16#0992#, 16#0020#, 16#0002#),
         10416 => (16#0993#, 16#0020#, 16#0002#),
         10417 => (16#0994#, 16#0020#, 16#0002#),
         10418 => (16#0235#, 16#0020#, 16#0002#),
         10419 => (16#0236#, 16#0020#, 16#0002#),
         10420 => (16#0237#, 16#0020#, 16#0002#),
         10421 => (16#0238#, 16#0020#, 16#0002#),
         10422 => (16#0239#, 16#0020#, 16#0002#),
         10423 => (16#023A#, 16#0020#, 16#0002#),
         10424 => (16#023B#, 16#0020#, 16#0002#),
         10425 => (16#023C#, 16#0020#, 16#0002#),
         10426 => (16#023D#, 16#0020#, 16#0002#),
         10427 => (16#023E#, 16#0020#, 16#0002#),
         10428 => (16#0995#, 16#0020#, 16#0002#),
         10429 => (16#0996#, 16#0020#, 16#0002#),
         10430 => (16#0997#, 16#0020#, 16#0002#),
         10431 => (16#0998#, 16#0020#, 16#0002#),
         10432 => (16#0999#, 16#0020#, 16#0002#),
         10433 => (16#099A#, 16#0020#, 16#0002#),
         10434 => (16#099B#, 16#0020#, 16#0002#),
         10435 => (16#099C#, 16#0020#, 16#0002#),
         10436 => (16#099D#, 16#0020#, 16#0002#),
         10437 => (16#099E#, 16#0020#, 16#0002#),
         10438 => (16#099F#, 16#0020#, 16#0002#),
         10439 => (16#09A0#, 16#0020#, 16#0002#),
         10440 => (16#09A1#, 16#0020#, 16#0002#),
         10441 => (16#09A2#, 16#0020#, 16#0002#),
         10442 => (16#09A3#, 16#0020#, 16#0002#),
         10443 => (16#09A4#, 16#0020#, 16#0002#),
         10444 => (16#0C54#, 16#0020#, 16#0002#),
         10445 => (16#0C55#, 16#0020#, 16#0002#),
         10446 => (16#0C56#, 16#0020#, 16#0002#),
         10447 => (16#0C57#, 16#0020#, 16#0002#),
         10448 => (16#0C58#, 16#0020#, 16#0002#),
         10449 => (16#0C59#, 16#0020#, 16#0002#),
         10450 => (16#0C5A#, 16#0020#, 16#0002#),
         10451 => (16#0C5B#, 16#0020#, 16#0002#),
         10452 => (16#0C5C#, 16#0020#, 16#0002#),
         10453 => (16#0C5D#, 16#0020#, 16#0002#),
         10454 => (16#0C5E#, 16#0020#, 16#0002#),
         10455 => (16#0C5F#, 16#0020#, 16#0002#),
         10456 => (16#0C60#, 16#0020#, 16#0002#),
         10457 => (16#0C61#, 16#0020#, 16#0002#),
         10458 => (16#0C62#, 16#0020#, 16#0002#),
         10459 => (16#0C63#, 16#0020#, 16#0002#),
         10460 => (16#0C64#, 16#0020#, 16#0002#),
         10461 => (16#0C65#, 16#0020#, 16#0002#),
         10462 => (16#0C66#, 16#0020#, 16#0002#),
         10463 => (16#0C67#, 16#0020#, 16#0002#),
         10464 => (16#0C68#, 16#0020#, 16#0002#),
         10465 => (16#0C69#, 16#0020#, 16#0002#),
         10466 => (16#0C6A#, 16#0020#, 16#0002#),
         10467 => (16#0C6B#, 16#0020#, 16#0002#),
         10468 => (16#0C6C#, 16#0020#, 16#0002#),
         10469 => (16#0C6D#, 16#0020#, 16#0002#),
         10470 => (16#0C6E#, 16#0020#, 16#0002#),
         10471 => (16#0C6F#, 16#0020#, 16#0002#),
         10472 => (16#0C70#, 16#0020#, 16#0002#),
         10473 => (16#0C71#, 16#0020#, 16#0002#),
         10474 => (16#0C72#, 16#0020#, 16#0002#),
         10475 => (16#0C73#, 16#0020#, 16#0002#),
         10476 => (16#0C74#, 16#0020#, 16#0002#),
         10477 => (16#0C75#, 16#0020#, 16#0002#),
         10478 => (16#0C76#, 16#0020#, 16#0002#),
         10479 => (16#0C77#, 16#0020#, 16#0002#),
         10480 => (16#0C78#, 16#0020#, 16#0002#),
         10481 => (16#0C79#, 16#0020#, 16#0002#),
         10482 => (16#0C7A#, 16#0020#, 16#0002#),
         10483 => (16#0C7B#, 16#0020#, 16#0002#),
         10484 => (16#0C7C#, 16#0020#, 16#0002#),
         10485 => (16#0C7D#, 16#0020#, 16#0002#),
         10486 => (16#0C7E#, 16#0020#, 16#0002#),
         10487 => (16#0C7F#, 16#0020#, 16#0002#),
         10488 => (16#0C80#, 16#0020#, 16#0002#),
         10489 => (16#0C81#, 16#0020#, 16#0002#),
         10490 => (16#0C82#, 16#0020#, 16#0002#),
         10491 => (16#0C83#, 16#0020#, 16#0002#),
         10492 => (16#0C84#, 16#0020#, 16#0002#),
         10493 => (16#0C85#, 16#0020#, 16#0002#),
         10494 => (16#0C86#, 16#0020#, 16#0002#),
         10495 => (16#0C87#, 16#0020#, 16#0002#),
         10496 => (16#0C88#, 16#0020#, 16#0002#),
         10497 => (16#0C89#, 16#0020#, 16#0002#),
         10498 => (16#0C8A#, 16#0020#, 16#0002#),
         10499 => (16#0C8B#, 16#0020#, 16#0002#),
         10500 => (16#0C8C#, 16#0020#, 16#0002#),
         10501 => (16#0C8D#, 16#0020#, 16#0002#),
         10502 => (16#0C8E#, 16#0020#, 16#0002#),
         10503 => (16#0C8F#, 16#0020#, 16#0002#),
         10504 => (16#0C90#, 16#0020#, 16#0002#),
         10505 => (16#0C91#, 16#0020#, 16#0002#),
         10506 => (16#0C92#, 16#0020#, 16#0002#),
         10507 => (16#0C93#, 16#0020#, 16#0002#),
         10508 => (16#0C94#, 16#0020#, 16#0002#),
         10509 => (16#0C95#, 16#0020#, 16#0002#),
         10510 => (16#0C96#, 16#0020#, 16#0002#),
         10511 => (16#0C97#, 16#0020#, 16#0002#),
         10512 => (16#0C98#, 16#0020#, 16#0002#),
         10513 => (16#0C99#, 16#0020#, 16#0002#),
         10514 => (16#0C9A#, 16#0020#, 16#0002#),
         10515 => (16#0C9B#, 16#0020#, 16#0002#),
         10516 => (16#0C9C#, 16#0020#, 16#0002#),
         10517 => (16#0C9D#, 16#0020#, 16#0002#),
         10518 => (16#0C9E#, 16#0020#, 16#0002#),
         10519 => (16#0C9F#, 16#0020#, 16#0002#),
         10520 => (16#0CA0#, 16#0020#, 16#0002#),
         10521 => (16#0CA1#, 16#0020#, 16#0002#),
         10522 => (16#0CA2#, 16#0020#, 16#0002#),
         10523 => (16#0CA3#, 16#0020#, 16#0002#),
         10524 => (16#0CA4#, 16#0020#, 16#0002#),
         10525 => (16#0CA5#, 16#0020#, 16#0002#),
         10526 => (16#0CA6#, 16#0020#, 16#0002#),
         10527 => (16#0CA7#, 16#0020#, 16#0002#),
         10528 => (16#0CA8#, 16#0020#, 16#0002#),
         10529 => (16#0CA9#, 16#0020#, 16#0002#),
         10530 => (16#0CAA#, 16#0020#, 16#0002#),
         10531 => (16#0CAB#, 16#0020#, 16#0002#),
         10532 => (16#0CAC#, 16#0020#, 16#0002#),
         10533 => (16#0CAD#, 16#0020#, 16#0002#),
         10534 => (16#0CAE#, 16#0020#, 16#0002#),
         10535 => (16#0CAF#, 16#0020#, 16#0002#),
         10536 => (16#0CB0#, 16#0020#, 16#0002#),
         10537 => (16#0CB1#, 16#0020#, 16#0002#),
         10538 => (16#0CB2#, 16#0020#, 16#0002#),
         10539 => (16#0CB3#, 16#0020#, 16#0002#),
         10540 => (16#0CB4#, 16#0020#, 16#0002#),
         10541 => (16#0CB5#, 16#0020#, 16#0002#),
         10542 => (16#0CB6#, 16#0020#, 16#0002#),
         10543 => (16#0CB7#, 16#0020#, 16#0002#),
         10544 => (16#0CB8#, 16#0020#, 16#0002#),
         10545 => (16#0CB9#, 16#0020#, 16#0002#),
         10546 => (16#0CBA#, 16#0020#, 16#0002#),
         10547 => (16#0CBB#, 16#0020#, 16#0002#),
         10548 => (16#0CBC#, 16#0020#, 16#0002#),
         10549 => (16#0CBD#, 16#0020#, 16#0002#),
         10550 => (16#0CBE#, 16#0020#, 16#0002#),
         10551 => (16#0CBF#, 16#0020#, 16#0002#),
         10552 => (16#0CC0#, 16#0020#, 16#0002#),
         10553 => (16#0CC1#, 16#0020#, 16#0002#),
         10554 => (16#0CC2#, 16#0020#, 16#0002#),
         10555 => (16#0CC3#, 16#0020#, 16#0002#),
         10556 => (16#0CC4#, 16#0020#, 16#0002#),
         10557 => (16#0CC5#, 16#0020#, 16#0002#),
         10558 => (16#0CC6#, 16#0020#, 16#0002#),
         10559 => (16#0CC7#, 16#0020#, 16#0002#),
         10560 => (16#0CC8#, 16#0020#, 16#0002#),
         10561 => (16#0CC9#, 16#0020#, 16#0002#),
         10562 => (16#0CCA#, 16#0020#, 16#0002#),
         10563 => (16#0CCB#, 16#0020#, 16#0002#),
         10564 => (16#0CCC#, 16#0020#, 16#0002#),
         10565 => (16#0CCD#, 16#0020#, 16#0002#),
         10566 => (16#0CCE#, 16#0020#, 16#0002#),
         10567 => (16#0CCF#, 16#0020#, 16#0002#),
         10568 => (16#0CD0#, 16#0020#, 16#0002#),
         10569 => (16#0CD1#, 16#0020#, 16#0002#),
         10570 => (16#0CD2#, 16#0020#, 16#0002#),
         10571 => (16#0CD3#, 16#0020#, 16#0002#),
         10572 => (16#0CD4#, 16#0020#, 16#0002#),
         10573 => (16#0CD5#, 16#0020#, 16#0002#),
         10574 => (16#0CD6#, 16#0020#, 16#0002#),
         10575 => (16#0CD7#, 16#0020#, 16#0002#),
         10576 => (16#0CD8#, 16#0020#, 16#0002#),
         10577 => (16#0CD9#, 16#0020#, 16#0002#),
         10578 => (16#0CDA#, 16#0020#, 16#0002#),
         10579 => (16#0CDB#, 16#0020#, 16#0002#),
         10580 => (16#0CDC#, 16#0020#, 16#0002#),
         10581 => (16#0CDD#, 16#0020#, 16#0002#),
         10582 => (16#0CDE#, 16#0020#, 16#0002#),
         10583 => (16#0CDF#, 16#0020#, 16#0002#),
         10584 => (16#0CE0#, 16#0020#, 16#0002#),
         10585 => (16#0CE1#, 16#0020#, 16#0002#),
         10586 => (16#0CE2#, 16#0020#, 16#0002#),
         10587 => (16#0CE3#, 16#0020#, 16#0002#),
         10588 => (16#0CE4#, 16#0020#, 16#0002#),
         10589 => (16#0CE5#, 16#0020#, 16#0002#),
         10590 => (16#0CE6#, 16#0020#, 16#0002#),
         10591 => (16#0CE7#, 16#0020#, 16#0002#),
         10592 => (16#0CE8#, 16#0020#, 16#0002#),
         10593 => (16#0CE9#, 16#0020#, 16#0002#),
         10594 => (16#0CEA#, 16#0020#, 16#0002#),
         10595 => (16#0CEB#, 16#0020#, 16#0002#),
         10596 => (16#0CEC#, 16#0020#, 16#0002#),
         10597 => (16#0CED#, 16#0020#, 16#0002#),
         10598 => (16#0CEE#, 16#0020#, 16#0002#),
         10599 => (16#0CEF#, 16#0020#, 16#0002#),
         10600 => (16#0CF0#, 16#0020#, 16#0002#),
         10601 => (16#0CF1#, 16#0020#, 16#0002#),
         10602 => (16#0CF2#, 16#0020#, 16#0002#),
         10603 => (16#0CF3#, 16#0020#, 16#0002#),
         10604 => (16#0CF4#, 16#0020#, 16#0002#),
         10605 => (16#0CF5#, 16#0020#, 16#0002#),
         10606 => (16#0CF6#, 16#0020#, 16#0002#),
         10607 => (16#0CF7#, 16#0020#, 16#0002#),
         10608 => (16#0CF8#, 16#0020#, 16#0002#),
         10609 => (16#0CF9#, 16#0020#, 16#0002#),
         10610 => (16#0CFA#, 16#0020#, 16#0002#),
         10611 => (16#0CFB#, 16#0020#, 16#0002#),
         10612 => (16#0CFC#, 16#0020#, 16#0002#),
         10613 => (16#0CFD#, 16#0020#, 16#0002#),
         10614 => (16#0CFE#, 16#0020#, 16#0002#),
         10615 => (16#0CFF#, 16#0020#, 16#0002#),
         10616 => (16#0D00#, 16#0020#, 16#0002#),
         10617 => (16#0D01#, 16#0020#, 16#0002#),
         10618 => (16#0D02#, 16#0020#, 16#0002#),
         10619 => (16#0D03#, 16#0020#, 16#0002#),
         10620 => (16#0D04#, 16#0020#, 16#0002#),
         10621 => (16#0D05#, 16#0020#, 16#0002#),
         10622 => (16#0D06#, 16#0020#, 16#0002#),
         10623 => (16#0D07#, 16#0020#, 16#0002#),
         10624 => (16#0D08#, 16#0020#, 16#0002#),
         10625 => (16#0D09#, 16#0020#, 16#0002#),
         10626 => (16#0D0A#, 16#0020#, 16#0002#),
         10627 => (16#0D0B#, 16#0020#, 16#0002#),
         10628 => (16#0D0C#, 16#0020#, 16#0002#),
         10629 => (16#0D0D#, 16#0020#, 16#0002#),
         10630 => (16#0D0E#, 16#0020#, 16#0002#),
         10631 => (16#0D0F#, 16#0020#, 16#0002#),
         10632 => (16#0D10#, 16#0020#, 16#0002#),
         10633 => (16#0D11#, 16#0020#, 16#0002#),
         10634 => (16#0D12#, 16#0020#, 16#0002#),
         10635 => (16#0D13#, 16#0020#, 16#0002#),
         10636 => (16#0D14#, 16#0020#, 16#0002#),
         10637 => (16#0D15#, 16#0020#, 16#0002#),
         10638 => (16#0D16#, 16#0020#, 16#0002#),
         10639 => (16#0D17#, 16#0020#, 16#0002#),
         10640 => (16#0D18#, 16#0020#, 16#0002#),
         10641 => (16#0D19#, 16#0020#, 16#0002#),
         10642 => (16#0D1A#, 16#0020#, 16#0002#),
         10643 => (16#0D1B#, 16#0020#, 16#0002#),
         10644 => (16#0D1C#, 16#0020#, 16#0002#),
         10645 => (16#0D1D#, 16#0020#, 16#0002#),
         10646 => (16#0D1E#, 16#0020#, 16#0002#),
         10647 => (16#0D1F#, 16#0020#, 16#0002#),
         10648 => (16#0D20#, 16#0020#, 16#0002#),
         10649 => (16#0D21#, 16#0020#, 16#0002#),
         10650 => (16#0D22#, 16#0020#, 16#0002#),
         10651 => (16#0D23#, 16#0020#, 16#0002#),
         10652 => (16#0D24#, 16#0020#, 16#0002#),
         10653 => (16#0D25#, 16#0020#, 16#0002#),
         10654 => (16#0D26#, 16#0020#, 16#0002#),
         10655 => (16#0D27#, 16#0020#, 16#0002#),
         10656 => (16#0D28#, 16#0020#, 16#0002#),
         10657 => (16#0D29#, 16#0020#, 16#0002#),
         10658 => (16#0D2A#, 16#0020#, 16#0002#),
         10659 => (16#0D2B#, 16#0020#, 16#0002#),
         10660 => (16#0D2C#, 16#0020#, 16#0002#),
         10661 => (16#0D2D#, 16#0020#, 16#0002#),
         10662 => (16#0D2E#, 16#0020#, 16#0002#),
         10663 => (16#0D2F#, 16#0020#, 16#0002#),
         10664 => (16#0D30#, 16#0020#, 16#0002#),
         10665 => (16#0D31#, 16#0020#, 16#0002#),
         10666 => (16#0D32#, 16#0020#, 16#0002#),
         10667 => (16#0D33#, 16#0020#, 16#0002#),
         10668 => (16#0D34#, 16#0020#, 16#0002#),
         10669 => (16#0D35#, 16#0020#, 16#0002#),
         10670 => (16#0D36#, 16#0020#, 16#0002#),
         10671 => (16#0D37#, 16#0020#, 16#0002#),
         10672 => (16#0D38#, 16#0020#, 16#0002#),
         10673 => (16#0D39#, 16#0020#, 16#0002#),
         10674 => (16#0D3A#, 16#0020#, 16#0002#),
         10675 => (16#0D3B#, 16#0020#, 16#0002#),
         10676 => (16#0D3C#, 16#0020#, 16#0002#),
         10677 => (16#0D3D#, 16#0020#, 16#0002#),
         10678 => (16#0D3E#, 16#0020#, 16#0002#),
         10679 => (16#0D3F#, 16#0020#, 16#0002#),
         10680 => (16#0D40#, 16#0020#, 16#0002#),
         10681 => (16#0D41#, 16#0020#, 16#0002#),
         10682 => (16#0D42#, 16#0020#, 16#0002#),
         10683 => (16#0D43#, 16#0020#, 16#0002#),
         10684 => (16#0D44#, 16#0020#, 16#0002#),
         10685 => (16#0D45#, 16#0020#, 16#0002#),
         10686 => (16#0D46#, 16#0020#, 16#0002#),
         10687 => (16#0D47#, 16#0020#, 16#0002#),
         10688 => (16#0D48#, 16#0020#, 16#0002#),
         10689 => (16#0D49#, 16#0020#, 16#0002#),
         10690 => (16#0D4A#, 16#0020#, 16#0002#),
         10691 => (16#0D4B#, 16#0020#, 16#0002#),
         10692 => (16#0D4C#, 16#0020#, 16#0002#),
         10693 => (16#0D4D#, 16#0020#, 16#0002#),
         10694 => (16#0D4E#, 16#0020#, 16#0002#),
         10695 => (16#0D4F#, 16#0020#, 16#0002#),
         10696 => (16#0D50#, 16#0020#, 16#0002#),
         10697 => (16#0D51#, 16#0020#, 16#0002#),
         10698 => (16#0D52#, 16#0020#, 16#0002#),
         10699 => (16#0D53#, 16#0020#, 16#0002#),
         10700 => (16#09A5#, 16#0020#, 16#0002#),
         10701 => (16#09A6#, 16#0020#, 16#0002#),
         10702 => (16#09A7#, 16#0020#, 16#0002#),
         10703 => (16#09A8#, 16#0020#, 16#0002#),
         10704 => (16#09A9#, 16#0020#, 16#0002#),
         10705 => (16#09AA#, 16#0020#, 16#0002#),
         10706 => (16#09AB#, 16#0020#, 16#0002#),
         10707 => (16#09AC#, 16#0020#, 16#0002#),
         10708 => (16#09AD#, 16#0020#, 16#0002#),
         10709 => (16#09AE#, 16#0020#, 16#0002#),
         10710 => (16#09AF#, 16#0020#, 16#0002#),
         10711 => (16#09B0#, 16#0020#, 16#0002#),
         10712 => (16#09B1#, 16#0020#, 16#0002#),
         10713 => (16#09B2#, 16#0020#, 16#0002#),
         10714 => (16#09B3#, 16#0020#, 16#0002#),
         10715 => (16#09B4#, 16#0020#, 16#0002#),
         10716 => (16#09B5#, 16#0020#, 16#0002#),
         10717 => (16#09B6#, 16#0020#, 16#0002#),
         10718 => (16#09B7#, 16#0020#, 16#0002#),
         10719 => (16#09B8#, 16#0020#, 16#0002#),
         10720 => (16#09B9#, 16#0020#, 16#0002#),
         10721 => (16#09BA#, 16#0020#, 16#0002#),
         10722 => (16#09BB#, 16#0020#, 16#0002#),
         10723 => (16#09BC#, 16#0020#, 16#0002#),
         10724 => (16#09BD#, 16#0020#, 16#0002#),
         10725 => (16#09BE#, 16#0020#, 16#0002#),
         10726 => (16#09BF#, 16#0020#, 16#0002#),
         10727 => (16#09C0#, 16#0020#, 16#0002#),
         10728 => (16#09C1#, 16#0020#, 16#0002#),
         10729 => (16#09C2#, 16#0020#, 16#0002#),
         10730 => (16#09C3#, 16#0020#, 16#0002#),
         10731 => (16#09C4#, 16#0020#, 16#0002#),
         10732 => (16#09C5#, 16#0020#, 16#0002#),
         10733 => (16#09C6#, 16#0020#, 16#0002#),
         10734 => (16#09C7#, 16#0020#, 16#0002#),
         10735 => (16#09C8#, 16#0020#, 16#0002#),
         10736 => (16#09C9#, 16#0020#, 16#0002#),
         10737 => (16#09CA#, 16#0020#, 16#0002#),
         10738 => (16#09CB#, 16#0020#, 16#0002#),
         10739 => (16#09CC#, 16#0020#, 16#0002#),
         10740 => (16#09CD#, 16#0020#, 16#0002#),
         10741 => (16#09CE#, 16#0020#, 16#0002#),
         10742 => (16#09CF#, 16#0020#, 16#0002#),
         10743 => (16#09D0#, 16#0020#, 16#0002#),
         10744 => (16#09D1#, 16#0020#, 16#0002#),
         10745 => (16#09D2#, 16#0020#, 16#0002#),
         10746 => (16#09D3#, 16#0020#, 16#0002#),
         10747 => (16#09D4#, 16#0020#, 16#0002#),
         10748 => (16#09D5#, 16#0020#, 16#0002#),
         10749 => (16#09D6#, 16#0020#, 16#0002#),
         10750 => (16#09D7#, 16#0020#, 16#0002#),
         10751 => (16#09D8#, 16#0020#, 16#0002#),
         10752 => (16#09D9#, 16#0020#, 16#0002#),
         10753 => (16#09DA#, 16#0020#, 16#0002#),
         10754 => (16#09DB#, 16#0020#, 16#0002#),
         10755 => (16#09DC#, 16#0020#, 16#0002#),
         10756 => (16#09DD#, 16#0020#, 16#0002#),
         10757 => (16#09DE#, 16#0020#, 16#0002#),
         10758 => (16#09DF#, 16#0020#, 16#0002#),
         10759 => (16#09E0#, 16#0020#, 16#0002#),
         10760 => (16#09E1#, 16#0020#, 16#0002#),
         10761 => (16#09E2#, 16#0020#, 16#0002#),
         10762 => (16#09E3#, 16#0020#, 16#0002#),
         10763 => (16#09E4#, 16#0020#, 16#0002#),
         10764 => (16#09E5#, 16#0020#, 16#0002#),
         10765 => (16#09E6#, 16#0020#, 16#0002#),
         10766 => (16#09E7#, 16#0020#, 16#0002#),
         10767 => (16#09E8#, 16#0020#, 16#0002#),
         10768 => (16#09E9#, 16#0020#, 16#0002#),
         10769 => (16#09EA#, 16#0020#, 16#0002#),
         10770 => (16#09EB#, 16#0020#, 16#0002#),
         10771 => (16#09EC#, 16#0020#, 16#0002#),
         10772 => (16#09ED#, 16#0020#, 16#0002#),
         10773 => (16#09EE#, 16#0020#, 16#0002#),
         10774 => (16#09EF#, 16#0020#, 16#0002#),
         10775 => (16#09F0#, 16#0020#, 16#0002#),
         10776 => (16#09F1#, 16#0020#, 16#0002#),
         10777 => (16#09F2#, 16#0020#, 16#0002#),
         10778 => (16#09F3#, 16#0020#, 16#0002#),
         10779 => (16#09F4#, 16#0020#, 16#0002#),
         10780 => (16#09F5#, 16#0020#, 16#0002#),
         10781 => (16#09F6#, 16#0020#, 16#0002#),
         10782 => (16#09F7#, 16#0020#, 16#0002#),
         10783 => (16#09F8#, 16#0020#, 16#0002#),
         10784 => (16#09F9#, 16#0020#, 16#0002#),
         10785 => (16#09FA#, 16#0020#, 16#0002#),
         10786 => (16#09FB#, 16#0020#, 16#0002#),
         10787 => (16#09FC#, 16#0020#, 16#0002#),
         10788 => (16#09FD#, 16#0020#, 16#0002#),
         10789 => (16#09FE#, 16#0020#, 16#0002#),
         10790 => (16#09FF#, 16#0020#, 16#0002#),
         10791 => (16#0A00#, 16#0020#, 16#0002#),
         10792 => (16#0A01#, 16#0020#, 16#0002#),
         10793 => (16#0A02#, 16#0020#, 16#0002#),
         10794 => (16#0A03#, 16#0020#, 16#0002#),
         10795 => (16#0A04#, 16#0020#, 16#0002#),
         10796 => (16#0A05#, 16#0020#, 16#0002#),
         10797 => (16#0A06#, 16#0020#, 16#0002#),
         10798 => (16#0A07#, 16#0020#, 16#0002#),
         10799 => (16#0A08#, 16#0020#, 16#0002#),
         10800 => (16#0A09#, 16#0020#, 16#0002#),
         10801 => (16#0A0A#, 16#0020#, 16#0002#),
         10802 => (16#0A0B#, 16#0020#, 16#0002#),
         10803 => (16#0A0C#, 16#0020#, 16#0002#),
         10804 => (16#0A0D#, 16#0020#, 16#0002#),
         10805 => (16#0A0E#, 16#0020#, 16#0002#),
         10806 => (16#0A0F#, 16#0020#, 16#0002#),
         10807 => (16#0A10#, 16#0020#, 16#0002#),
         10808 => (16#0A11#, 16#0020#, 16#0002#),
         10809 => (16#0A12#, 16#0020#, 16#0002#),
         10810 => (16#0A13#, 16#0020#, 16#0002#),
         10811 => (16#0A14#, 16#0020#, 16#0002#),
         10812 => (16#0A15#, 16#0020#, 16#0002#),
         10813 => (16#0A16#, 16#0020#, 16#0002#),
         10814 => (16#0A17#, 16#0020#, 16#0002#),
         10815 => (16#0A18#, 16#0020#, 16#0002#),
         10816 => (16#0A19#, 16#0020#, 16#0002#),
         10817 => (16#0A1A#, 16#0020#, 16#0002#),
         10818 => (16#0A1B#, 16#0020#, 16#0002#),
         10819 => (16#0A1C#, 16#0020#, 16#0002#),
         10820 => (16#0A1D#, 16#0020#, 16#0002#),
         10821 => (16#0A1E#, 16#0020#, 16#0002#),
         10822 => (16#0A1F#, 16#0020#, 16#0002#),
         10823 => (16#0A20#, 16#0020#, 16#0002#),
         10824 => (16#0A21#, 16#0020#, 16#0002#),
         10825 => (16#0A22#, 16#0020#, 16#0002#),
         10826 => (16#0A23#, 16#0020#, 16#0002#),
         10827 => (16#0A24#, 16#0020#, 16#0002#),
         10828 => (16#0A25#, 16#0020#, 16#0002#),
         10829 => (16#0A26#, 16#0020#, 16#0002#),
         10830 => (16#0A27#, 16#0020#, 16#0002#),
         10831 => (16#021D#, 16#0020#, 16#0002#),
         10832 => (16#021E#, 16#0020#, 16#0002#),
         10833 => (16#021F#, 16#0020#, 16#0002#),
         10834 => (16#0220#, 16#0020#, 16#0002#),
         10835 => (16#0221#, 16#0020#, 16#0002#),
         10836 => (16#0222#, 16#0020#, 16#0002#),
         10837 => (16#0223#, 16#0020#, 16#0002#),
         10838 => (16#0224#, 16#0020#, 16#0002#),
         10839 => (16#0225#, 16#0020#, 16#0002#),
         10840 => (16#0226#, 16#0020#, 16#0002#),
         10841 => (16#0227#, 16#0020#, 16#0002#),
         10842 => (16#0228#, 16#0020#, 16#0002#),
         10843 => (16#0229#, 16#0020#, 16#0002#),
         10844 => (16#022A#, 16#0020#, 16#0002#),
         10845 => (16#022B#, 16#0020#, 16#0002#),
         10846 => (16#022C#, 16#0020#, 16#0002#),
         10847 => (16#022D#, 16#0020#, 16#0002#),
         10848 => (16#022E#, 16#0020#, 16#0002#),
         10849 => (16#022F#, 16#0020#, 16#0002#),
         10850 => (16#0230#, 16#0020#, 16#0002#),
         10851 => (16#0231#, 16#0020#, 16#0002#),
         10852 => (16#0232#, 16#0020#, 16#0002#),
         10853 => (16#0A28#, 16#0020#, 16#0002#),
         10854 => (16#0A29#, 16#0020#, 16#0002#),
         10855 => (16#0A2A#, 16#0020#, 16#0002#),
         10856 => (16#0A2B#, 16#0020#, 16#0002#),
         10857 => (16#0A2C#, 16#0020#, 16#0002#),
         10858 => (16#0A2D#, 16#0020#, 16#0002#),
         10859 => (16#0A2E#, 16#0020#, 16#0002#),
         10860 => (16#0A2F#, 16#0020#, 16#0002#),
         10861 => (16#0A30#, 16#0020#, 16#0002#),
         10862 => (16#0A31#, 16#0020#, 16#0002#),
         10863 => (16#0A32#, 16#0020#, 16#0002#),
         10864 => (16#0A33#, 16#0020#, 16#0002#),
         10865 => (16#0A34#, 16#0020#, 16#0002#),
         10866 => (16#0A35#, 16#0020#, 16#0002#),
         10867 => (16#0A36#, 16#0020#, 16#0002#),
         10868 => (16#0A37#, 16#0020#, 16#0002#),
         10869 => (16#0A38#, 16#0020#, 16#0002#),
         10870 => (16#0A39#, 16#0020#, 16#0002#),
         10871 => (16#0A3A#, 16#0020#, 16#0002#),
         10872 => (16#0A3B#, 16#0020#, 16#0002#),
         10873 => (16#0A3C#, 16#0020#, 16#0002#),
         10874 => (16#0A3D#, 16#0020#, 16#0002#),
         10875 => (16#0A3E#, 16#0020#, 16#0002#),
         10876 => (16#0A3F#, 16#0020#, 16#0002#),
         10877 => (16#0A40#, 16#0020#, 16#0002#),
         10878 => (16#0A41#, 16#0020#, 16#0002#),
         10879 => (16#0A42#, 16#0020#, 16#0002#),
         10880 => (16#0A43#, 16#0020#, 16#0002#),
         10881 => (16#0A44#, 16#0020#, 16#0002#),
         10882 => (16#0A45#, 16#0020#, 16#0002#),
         10883 => (16#0A46#, 16#0020#, 16#0002#),
         10884 => (16#0A47#, 16#0020#, 16#0002#),
         10885 => (16#0A48#, 16#0020#, 16#0002#),
         10886 => (16#0A49#, 16#0020#, 16#0002#),
         10887 => (16#0A4A#, 16#0020#, 16#0002#),
         10888 => (16#0A4B#, 16#0020#, 16#0002#),
         10889 => (16#0A4C#, 16#0020#, 16#0002#),
         10890 => (16#0A4D#, 16#0020#, 16#0002#),
         10891 => (16#0A4E#, 16#0020#, 16#0002#),
         10892 => (16#0A4F#, 16#0020#, 16#0002#),
         10893 => (16#0A50#, 16#0020#, 16#0002#),
         10894 => (16#0A51#, 16#0020#, 16#0002#),
         10895 => (16#0A52#, 16#0020#, 16#0002#),
         10896 => (16#0A53#, 16#0020#, 16#0002#),
         10897 => (16#0A54#, 16#0020#, 16#0002#),
         10898 => (16#0A55#, 16#0020#, 16#0002#),
         10899 => (16#0A56#, 16#0020#, 16#0002#),
         10900 => (16#0A57#, 16#0020#, 16#0002#),
         10901 => (16#0A58#, 16#0020#, 16#0002#),
         10902 => (16#0A59#, 16#0020#, 16#0002#),
         10903 => (16#0A5A#, 16#0020#, 16#0002#),
         10904 => (16#0A5B#, 16#0020#, 16#0002#),
         10905 => (16#0A5C#, 16#0020#, 16#0002#),
         10906 => (16#0A5D#, 16#0020#, 16#0002#),
         10907 => (16#0A5E#, 16#0020#, 16#0002#),
         10908 => (16#0A5F#, 16#0020#, 16#0002#),
         10909 => (16#0A60#, 16#0020#, 16#0002#),
         10910 => (16#0A61#, 16#0020#, 16#0002#),
         10911 => (16#0A62#, 16#0020#, 16#0002#),
         10912 => (16#0A63#, 16#0020#, 16#0002#),
         10913 => (16#0A64#, 16#0020#, 16#0002#),
         10914 => (16#0A65#, 16#0020#, 16#0002#),
         10915 => (16#0A66#, 16#0020#, 16#0002#),
         10916 => (16#0277#, 16#0020#, 16#0002#),
         10917 => (16#0278#, 16#0020#, 16#0002#),
         10918 => (16#0279#, 16#0020#, 16#0002#),
         10919 => (16#027A#, 16#0020#, 16#0002#),
         10920 => (16#0A67#, 16#0020#, 16#0002#),
         10921 => (16#0A68#, 16#0020#, 16#0002#),
         10922 => (16#0A69#, 16#0020#, 16#0002#),
         10923 => (16#0A6A#, 16#0020#, 16#0002#),
         10924 => (16#0A6B#, 16#0020#, 16#0002#),
         10925 => (16#0A6C#, 16#0020#, 16#0002#),
         10926 => (16#0A6D#, 16#0020#, 16#0002#),
         10927 => (16#0A6E#, 16#0020#, 16#0002#),
         10928 => (16#0A6F#, 16#0020#, 16#0002#),
         10929 => (16#0A70#, 16#0020#, 16#0002#),
         10930 => (16#0A71#, 16#0020#, 16#0002#),
         10931 => (16#0A72#, 16#0020#, 16#0002#),
         10932 => (16#0A73#, 16#0020#, 16#0002#),
         10933 => (16#0A74#, 16#0020#, 16#0002#),
         10934 => (16#0A75#, 16#0020#, 16#0002#),
         10935 => (16#0A76#, 16#0020#, 16#0002#),
         10936 => (16#0A77#, 16#0020#, 16#0002#),
         10937 => (16#0A78#, 16#0020#, 16#0002#),
         10938 => (16#0A79#, 16#0020#, 16#0002#),
         10939 => (16#0A7A#, 16#0020#, 16#0002#),
         10940 => (16#0A7B#, 16#0020#, 16#0002#),
         10941 => (16#0A7C#, 16#0020#, 16#0002#),
         10942 => (16#0A7D#, 16#0020#, 16#0002#),
         10943 => (16#0A7E#, 16#0020#, 16#0002#),
         10944 => (16#0A7F#, 16#0020#, 16#0002#),
         10945 => (16#0A80#, 16#0020#, 16#0002#),
         10946 => (16#0A81#, 16#0020#, 16#0002#),
         10947 => (16#0A82#, 16#0020#, 16#0002#),
         10948 => (16#0A83#, 16#0020#, 16#0002#),
         10949 => (16#0A84#, 16#0020#, 16#0002#),
         10950 => (16#0A85#, 16#0020#, 16#0002#),
         10951 => (16#0A86#, 16#0020#, 16#0002#),
         10952 => (16#021B#, 16#0020#, 16#0002#),
         10953 => (16#021C#, 16#0020#, 16#0002#),
         10954 => (16#0A87#, 16#0020#, 16#0002#),
         10955 => (16#0A88#, 16#0020#, 16#0002#),
         10956 => (16#0A89#, 16#0020#, 16#0002#),
         10957 => (16#0A8A#, 16#0020#, 16#0002#),
         10958 => (16#0A8B#, 16#0020#, 16#0002#),
         10959 => (16#0A8C#, 16#0020#, 16#0002#),
         10960 => (16#0A8D#, 16#0020#, 16#0002#),
         10961 => (16#0A8E#, 16#0020#, 16#0002#),
         10962 => (16#0A8F#, 16#0020#, 16#0002#),
         10963 => (16#0A90#, 16#0020#, 16#0002#),
         10964 => (16#0A91#, 16#0020#, 16#0002#),
         10965 => (16#0A92#, 16#0020#, 16#0002#),
         10966 => (16#0A93#, 16#0020#, 16#0002#),
         10967 => (16#0A94#, 16#0020#, 16#0002#),
         10968 => (16#0A95#, 16#0020#, 16#0002#),
         10969 => (16#0A96#, 16#0020#, 16#0002#),
         10970 => (16#0A97#, 16#0020#, 16#0002#),
         10971 => (16#0A98#, 16#0020#, 16#0002#),
         10972 => (16#0A99#, 16#0020#, 16#0002#),
         10973 => (16#0A9A#, 16#0020#, 16#0002#),
         10974 => (16#0A9B#, 16#0020#, 16#0002#),
         10975 => (16#0A9C#, 16#0020#, 16#0002#),
         10976 => (16#0A9D#, 16#0020#, 16#0002#),
         10977 => (16#0A9E#, 16#0020#, 16#0002#),
         10978 => (16#0A9F#, 16#0020#, 16#0002#),
         10979 => (16#0AA0#, 16#0020#, 16#0002#),
         10980 => (16#0AA1#, 16#0020#, 16#0002#),
         10981 => (16#0AA2#, 16#0020#, 16#0002#),
         10982 => (16#0AA3#, 16#0020#, 16#0002#),
         10983 => (16#0AA4#, 16#0020#, 16#0002#),
         10984 => (16#0AA5#, 16#0020#, 16#0002#),
         10985 => (16#0AA6#, 16#0020#, 16#0002#),
         10986 => (16#0AA7#, 16#0020#, 16#0002#),
         10987 => (16#0AA8#, 16#0020#, 16#0002#),
         10988 => (16#0AA9#, 16#0020#, 16#0002#),
         10989 => (16#0AAA#, 16#0020#, 16#0002#),
         10990 => (16#0AAB#, 16#0020#, 16#0002#),
         10991 => (16#0AAC#, 16#0020#, 16#0002#),
         10992 => (16#0AAD#, 16#0020#, 16#0002#),
         10993 => (16#0AAE#, 16#0020#, 16#0002#),
         10994 => (16#0AAF#, 16#0020#, 16#0002#),
         10995 => (16#0AB0#, 16#0020#, 16#0002#),
         10996 => (16#0AB1#, 16#0020#, 16#0002#),
         10997 => (16#0AB2#, 16#0020#, 16#0002#),
         10998 => (16#0AB3#, 16#0020#, 16#0002#),
         10999 => (16#0AB4#, 16#0020#, 16#0002#),
         11000 => (16#0AB5#, 16#0020#, 16#0002#),
         11001 => (16#0AB6#, 16#0020#, 16#0002#),
         11002 => (16#0AB7#, 16#0020#, 16#0002#),
         11003 => (16#0AB8#, 16#0020#, 16#0002#),
         11004 => (16#0AB9#, 16#0020#, 16#0002#),
         11005 => (16#0ABA#, 16#0020#, 16#0002#),
         11006 => (16#0ABB#, 16#0020#, 16#0002#),
         11007 => (16#0ABC#, 16#0020#, 16#0002#),
         11008 => (16#0ABD#, 16#0020#, 16#0002#),
         11009 => (16#0ABE#, 16#0020#, 16#0002#),
         11010 => (16#0ABF#, 16#0020#, 16#0002#),
         11011 => (16#0AC0#, 16#0020#, 16#0002#),
         11012 => (16#0AC1#, 16#0020#, 16#0002#),
         11013 => (16#0AC2#, 16#0020#, 16#0002#),
         11014 => (16#0AC3#, 16#0020#, 16#0002#),
         11015 => (16#0AC4#, 16#0020#, 16#0002#),
         11016 => (16#0AC5#, 16#0020#, 16#0002#),
         11017 => (16#0AC6#, 16#0020#, 16#0002#),
         11018 => (16#0AC7#, 16#0020#, 16#0002#),
         11019 => (16#0AC8#, 16#0020#, 16#0002#),
         11020 => (16#0AC9#, 16#0020#, 16#0002#),
         11021 => (16#0ACA#, 16#0020#, 16#0002#),
         11022 => (16#0ACB#, 16#0020#, 16#0002#),
         11023 => (16#0ACC#, 16#0020#, 16#0002#),
         11024 => (16#0ACD#, 16#0020#, 16#0002#),
         11025 => (16#0ACE#, 16#0020#, 16#0002#),
         11026 => (16#0ACF#, 16#0020#, 16#0002#),
         11027 => (16#0AD0#, 16#0020#, 16#0002#),
         11028 => (16#0AD1#, 16#0020#, 16#0002#),
         11029 => (16#0AD2#, 16#0020#, 16#0002#),
         11030 => (16#0AD3#, 16#0020#, 16#0002#),
         11031 => (16#0AD4#, 16#0020#, 16#0002#),
         11032 => (16#0AD5#, 16#0020#, 16#0002#),
         11033 => (16#0AD6#, 16#0020#, 16#0002#),
         11034 => (16#0AD7#, 16#0020#, 16#0002#),
         11035 => (16#0AD8#, 16#0020#, 16#0002#),
         11036 => (16#0AD9#, 16#0020#, 16#0002#),
         11037 => (16#0ADA#, 16#0020#, 16#0002#),
         11038 => (16#0ADB#, 16#0020#, 16#0002#),
         11039 => (16#0ADC#, 16#0020#, 16#0002#),
         11040 => (16#0ADD#, 16#0020#, 16#0002#),
         11041 => (16#0ADE#, 16#0020#, 16#0002#),
         11042 => (16#0ADF#, 16#0020#, 16#0002#),
         11043 => (16#0AE0#, 16#0020#, 16#0002#),
         11044 => (16#0AE1#, 16#0020#, 16#0002#),
         11045 => (16#0AE2#, 16#0020#, 16#0002#),
         11046 => (16#0AE3#, 16#0020#, 16#0002#),
         11047 => (16#0AE4#, 16#0020#, 16#0002#),
         11048 => (16#0AE5#, 16#0020#, 16#0002#),
         11049 => (16#0AE6#, 16#0020#, 16#0002#),
         11050 => (16#0AE7#, 16#0020#, 16#0002#),
         11051 => (16#0AE8#, 16#0020#, 16#0002#),
         11052 => (16#0AE9#, 16#0020#, 16#0002#),
         11053 => (16#0AEA#, 16#0020#, 16#0002#),
         11054 => (16#0AEB#, 16#0020#, 16#0002#),
         11055 => (16#0AEC#, 16#0020#, 16#0002#),
         11056 => (16#0AED#, 16#0020#, 16#0002#),
         11057 => (16#0AEE#, 16#0020#, 16#0002#),
         11058 => (16#0AEF#, 16#0020#, 16#0002#),
         11059 => (16#0AF0#, 16#0020#, 16#0002#),
         11060 => (16#0AF1#, 16#0020#, 16#0002#),
         11061 => (16#0AF2#, 16#0020#, 16#0002#),
         11062 => (16#0AF3#, 16#0020#, 16#0002#),
         11063 => (16#0AF4#, 16#0020#, 16#0002#),
         11064 => (16#0AF5#, 16#0020#, 16#0002#),
         11065 => (16#0AF6#, 16#0020#, 16#0002#),
         11066 => (16#0AF7#, 16#0020#, 16#0002#),
         11067 => (16#0AF8#, 16#0020#, 16#0002#),
         11068 => (16#0AF9#, 16#0020#, 16#0002#),
         11069 => (16#0AFA#, 16#0020#, 16#0002#),
         11070 => (16#0AFB#, 16#0020#, 16#0002#),
         11071 => (16#0137#, 16#0020#, 16#0004#),
         11072 => (16#0137#, 16#0020#, 16#0004#),
         11073 => (16#04DB#, 16#0020#, 16#0004#),
         11074 => (16#04DB#, 16#0020#, 16#0004#),
         11075 => (16#04DB#, 16#0020#, 16#0004#),
         11076 => (16#0AFC#, 16#0020#, 16#0002#),
         11077 => (16#0AFD#, 16#0020#, 16#0002#),
         11078 => (16#0AFE#, 16#0020#, 16#0002#),
         11079 => (16#0AFF#, 16#0020#, 16#0002#),
         11080 => (16#0B00#, 16#0020#, 16#0002#),
         11081 => (16#0B01#, 16#0020#, 16#0002#),
         11082 => (16#0B02#, 16#0020#, 16#0002#),
         11083 => (16#0B03#, 16#0020#, 16#0002#),
         11084 => (16#0B04#, 16#0020#, 16#0002#),
         11085 => (16#0B05#, 16#0020#, 16#0002#),
         11086 => (16#0B06#, 16#0020#, 16#0002#),
         11087 => (16#0B07#, 16#0020#, 16#0002#),
         11088 => (16#0B08#, 16#0020#, 16#0002#),
         11089 => (16#0B09#, 16#0020#, 16#0002#),
         11090 => (16#0B0A#, 16#0020#, 16#0002#),
         11091 => (16#0B0B#, 16#0020#, 16#0002#),
         11092 => (16#0B0C#, 16#0020#, 16#0002#),
         11093 => (16#0B0D#, 16#0020#, 16#0002#),
         11094 => (16#0B0E#, 16#0020#, 16#0002#),
         11095 => (16#0B0F#, 16#0020#, 16#0002#),
         11096 => (16#0B10#, 16#0020#, 16#0002#),
         11097 => (16#0B11#, 16#0020#, 16#0002#),
         11098 => (16#0B12#, 16#0020#, 16#0002#),
         11099 => (16#0B13#, 16#0020#, 16#0002#),
         11100 => (16#0B14#, 16#0020#, 16#0002#),
         11101 => (16#0B15#, 16#0020#, 16#0002#),
         11102 => (16#0B16#, 16#0020#, 16#0002#),
         11103 => (16#0B17#, 16#0020#, 16#0002#),
         11104 => (16#0B18#, 16#0020#, 16#0002#),
         11105 => (16#0B19#, 16#0020#, 16#0002#),
         11106 => (16#0B1A#, 16#0020#, 16#0002#),
         11107 => (16#0B1B#, 16#0020#, 16#0002#),
         11108 => (16#0B1C#, 16#0020#, 16#0002#),
         11109 => (16#0B1D#, 16#0020#, 16#0002#),
         11110 => (16#0B1E#, 16#0020#, 16#0002#),
         11111 => (16#0B1F#, 16#0020#, 16#0002#),
         11112 => (16#0B20#, 16#0020#, 16#0002#),
         11113 => (16#0B21#, 16#0020#, 16#0002#),
         11114 => (16#0B22#, 16#0020#, 16#0002#),
         11115 => (16#0B23#, 16#0020#, 16#0002#),
         11116 => (16#0B24#, 16#0020#, 16#0002#),
         11117 => (16#0B25#, 16#0020#, 16#0002#),
         11118 => (16#0B26#, 16#0020#, 16#0002#),
         11119 => (16#0B27#, 16#0020#, 16#0002#),
         11120 => (16#0B28#, 16#0020#, 16#0002#),
         11121 => (16#0B29#, 16#0020#, 16#0002#),
         11122 => (16#0B2A#, 16#0020#, 16#0002#),
         11123 => (16#0B2B#, 16#0020#, 16#0002#),
         11124 => (16#0B2C#, 16#0020#, 16#0002#),
         11125 => (16#0B2D#, 16#0020#, 16#0002#),
         11126 => (16#0B2E#, 16#0020#, 16#0002#),
         11127 => (16#0B2F#, 16#0020#, 16#0002#),
         11128 => (16#0B30#, 16#0020#, 16#0002#),
         11129 => (16#0B31#, 16#0020#, 16#0002#),
         11130 => (16#0B32#, 16#0020#, 16#0002#),
         11131 => (16#0B33#, 16#0020#, 16#0002#),
         11132 => (16#0B34#, 16#0020#, 16#0002#),
         11133 => (16#0B35#, 16#0020#, 16#0002#),
         11134 => (16#0B36#, 16#0020#, 16#0002#),
         11135 => (16#0B37#, 16#0020#, 16#0002#),
         11136 => (16#0B38#, 16#0020#, 16#0002#),
         11137 => (16#0B39#, 16#0020#, 16#0002#),
         11138 => (16#0B3A#, 16#0020#, 16#0002#),
         11139 => (16#0B3B#, 16#0020#, 16#0002#),
         11140 => (16#0B3C#, 16#0020#, 16#0002#),
         11141 => (16#0B3D#, 16#0020#, 16#0002#),
         11142 => (16#0B3E#, 16#0020#, 16#0002#),
         11143 => (16#0B3F#, 16#0020#, 16#0002#),
         11144 => (16#0B40#, 16#0020#, 16#0002#),
         11145 => (16#0B41#, 16#0020#, 16#0002#),
         11146 => (16#0B42#, 16#0020#, 16#0002#),
         11147 => (16#0B43#, 16#0020#, 16#0002#),
         11148 => (16#0B44#, 16#0020#, 16#0002#),
         11149 => (16#0B45#, 16#0020#, 16#0002#),
         11150 => (16#0B46#, 16#0020#, 16#0002#),
         11151 => (16#0B47#, 16#0020#, 16#0002#),
         11152 => (16#0B48#, 16#0020#, 16#0002#),
         11153 => (16#0B49#, 16#0020#, 16#0002#),
         11154 => (16#0B4A#, 16#0020#, 16#0002#),
         11155 => (16#0B4B#, 16#0020#, 16#0002#),
         11156 => (16#0B4C#, 16#0020#, 16#0002#),
         11157 => (16#0B4D#, 16#0020#, 16#0002#),
         11158 => (16#0B4E#, 16#0020#, 16#0002#),
         11159 => (16#0B4F#, 16#0020#, 16#0002#),
         11160 => (16#0B50#, 16#0020#, 16#0002#),
         11161 => (16#0B51#, 16#0020#, 16#0002#),
         11162 => (16#0B52#, 16#0020#, 16#0002#),
         11163 => (16#0B53#, 16#0020#, 16#0002#),
         11164 => (16#0B54#, 16#0020#, 16#0002#),
         11165 => (16#0B55#, 16#0020#, 16#0002#),
         11166 => (16#0B56#, 16#0020#, 16#0002#),
         11167 => (16#0B57#, 16#0020#, 16#0002#),
         11168 => (16#0B58#, 16#0020#, 16#0002#),
         11169 => (16#0B59#, 16#0020#, 16#0002#),
         11170 => (16#0B5A#, 16#0020#, 16#0002#),
         11171 => (16#0B5B#, 16#0020#, 16#0002#),
         11172 => (16#0B5C#, 16#0020#, 16#0002#),
         11173 => (16#0B5D#, 16#0020#, 16#0002#),
         11174 => (16#0B5E#, 16#0020#, 16#0002#),
         11175 => (16#0B5F#, 16#0020#, 16#0002#),
         11176 => (16#0B60#, 16#0020#, 16#0002#),
         11177 => (16#0B61#, 16#0020#, 16#0002#),
         11178 => (16#0000#, 16#002F#, 16#0002#),
         11179 => (16#0B62#, 16#0020#, 16#0002#),
         11180 => (16#0B63#, 16#0020#, 16#0002#),
         11181 => (16#0B64#, 16#0020#, 16#0002#),
         11182 => (16#0B65#, 16#0020#, 16#0002#),
         11183 => (16#0B66#, 16#0020#, 16#0002#),
         11184 => (16#0B67#, 16#0020#, 16#0002#),
         11185 => (16#0B68#, 16#0020#, 16#0002#),
         11186 => (16#0B69#, 16#0020#, 16#0002#),
         11187 => (16#0B6A#, 16#0020#, 16#0002#),
         11188 => (16#0B6B#, 16#0020#, 16#0002#),
         11189 => (16#0B6C#, 16#0020#, 16#0002#),
         11190 => (16#0B6D#, 16#0020#, 16#0002#),
         11191 => (16#0B6E#, 16#0020#, 16#0002#),
         11192 => (16#0B6F#, 16#0020#, 16#0002#),
         11193 => (16#0B70#, 16#0020#, 16#0002#),
         11194 => (16#0B71#, 16#0020#, 16#0002#),
         11195 => (16#0B72#, 16#0020#, 16#0002#),
         11196 => (16#0B73#, 16#0020#, 16#0002#),
         11197 => (16#0B74#, 16#0020#, 16#0002#),
         11198 => (16#0B75#, 16#0020#, 16#0002#),
         11199 => (16#0B76#, 16#0020#, 16#0002#),
         11200 => (16#0B77#, 16#0020#, 16#0002#),
         11201 => (16#0B78#, 16#0020#, 16#0002#),
         11202 => (16#0B79#, 16#0020#, 16#0002#),
         11203 => (16#0B7A#, 16#0020#, 16#0002#),
         11204 => (16#0B7B#, 16#0020#, 16#0002#),
         11205 => (16#0B7C#, 16#0020#, 16#0002#),
         11206 => (16#0B7D#, 16#0020#, 16#0002#),
         11207 => (16#0B7E#, 16#0020#, 16#0002#),
         11208 => (16#0B7F#, 16#0020#, 16#0002#),
         11209 => (16#0B80#, 16#0020#, 16#0002#),
         11210 => (16#0B81#, 16#0020#, 16#0002#),
         11211 => (16#0B82#, 16#0020#, 16#0002#),
         11212 => (16#0B83#, 16#0020#, 16#0002#),
         11213 => (16#0B84#, 16#0020#, 16#0002#),
         11214 => (16#0B85#, 16#0020#, 16#0002#),
         11215 => (16#0B86#, 16#0020#, 16#0002#),
         11216 => (16#0B87#, 16#0020#, 16#0002#),
         11217 => (16#0B88#, 16#0020#, 16#0002#),
         11218 => (16#0B89#, 16#0020#, 16#0002#),
         11219 => (16#0B8A#, 16#0020#, 16#0002#),
         11220 => (16#0B8B#, 16#0020#, 16#0002#),
         11221 => (16#0B8C#, 16#0020#, 16#0002#),
         11222 => (16#0B8D#, 16#0020#, 16#0002#),
         11223 => (16#0B8E#, 16#0020#, 16#0002#),
         11224 => (16#0B8F#, 16#0020#, 16#0002#),
         11225 => (16#0B90#, 16#0020#, 16#0002#),
         11226 => (16#0B91#, 16#0020#, 16#0002#),
         11227 => (16#0B92#, 16#0020#, 16#0002#),
         11228 => (16#0B93#, 16#0020#, 16#0002#),
         11229 => (16#0B94#, 16#0020#, 16#0002#),
         11230 => (16#0B95#, 16#0020#, 16#0002#),
         11231 => (16#0B96#, 16#0020#, 16#0002#),
         11232 => (16#0B97#, 16#0020#, 16#0002#),
         11233 => (16#0B98#, 16#0020#, 16#0002#),
         11234 => (16#0B99#, 16#0020#, 16#0002#),
         11235 => (16#0B9A#, 16#0020#, 16#0002#),
         11236 => (16#0B9B#, 16#0020#, 16#0002#),
         11237 => (16#0B9C#, 16#0020#, 16#0002#),
         11238 => (16#0B9D#, 16#0020#, 16#0002#),
         11239 => (16#0B9E#, 16#0020#, 16#0002#),
         11240 => (16#0B9F#, 16#0020#, 16#0002#),
         11241 => (16#0BA0#, 16#0020#, 16#0002#),
         11242 => (16#0BA1#, 16#0020#, 16#0002#),
         11243 => (16#0BA2#, 16#0020#, 16#0002#),
         11244 => (16#0BA3#, 16#0020#, 16#0002#),
         11245 => (16#0BA4#, 16#0020#, 16#0002#),
         11246 => (16#0BA5#, 16#0020#, 16#0002#),
         11247 => (16#0BA6#, 16#0020#, 16#0002#),
         11248 => (16#0BA7#, 16#0020#, 16#0002#),
         11249 => (16#0BA8#, 16#0020#, 16#0002#),
         11250 => (16#0BA9#, 16#0020#, 16#0002#),
         11251 => (16#0BAA#, 16#0020#, 16#0002#),
         11252 => (16#0BAB#, 16#0020#, 16#0002#),
         11253 => (16#0BAC#, 16#0020#, 16#0002#),
         11254 => (16#0BAD#, 16#0020#, 16#0002#),
         11255 => (16#0BAE#, 16#0020#, 16#0002#),
         11256 => (16#0BAF#, 16#0020#, 16#0002#),
         11257 => (16#0BB0#, 16#0020#, 16#0002#),
         11258 => (16#0BB1#, 16#0020#, 16#0002#),
         11259 => (16#0BB2#, 16#0020#, 16#0002#),
         11260 => (16#0BB3#, 16#0020#, 16#0002#),
         11261 => (16#0BB4#, 16#0020#, 16#0002#),
         11262 => (16#0BB5#, 16#0020#, 16#0002#),
         11263 => (16#0BB6#, 16#0020#, 16#0002#),
         11264 => (16#0BB7#, 16#0020#, 16#0002#),
         11265 => (16#0BB8#, 16#0020#, 16#0002#),
         11266 => (16#0BB9#, 16#0020#, 16#0002#),
         11267 => (16#0BBA#, 16#0020#, 16#0002#),
         11268 => (16#0BBB#, 16#0020#, 16#0002#),
         11269 => (16#0BBC#, 16#0020#, 16#0002#),
         11270 => (16#0BBD#, 16#0020#, 16#0002#),
         11271 => (16#0BBE#, 16#0020#, 16#0002#),
         11272 => (16#0BBF#, 16#0020#, 16#0002#),
         11273 => (16#0BC0#, 16#0020#, 16#0002#),
         11274 => (16#0BC1#, 16#0020#, 16#0002#),
         11275 => (16#0BC2#, 16#0020#, 16#0002#),
         11276 => (16#0BC3#, 16#0020#, 16#0002#),
         11277 => (16#0BC4#, 16#0020#, 16#0002#),
         11278 => (16#0BC5#, 16#0020#, 16#0002#),
         11279 => (16#0BC6#, 16#0020#, 16#0002#),
         11280 => (16#0BC7#, 16#0020#, 16#0002#),
         11281 => (16#0BC8#, 16#0020#, 16#0002#),
         11282 => (16#0BC9#, 16#0020#, 16#0002#),
         11283 => (16#0BCA#, 16#0020#, 16#0002#),
         11284 => (16#0BCB#, 16#0020#, 16#0002#),
         11285 => (16#0BCC#, 16#0020#, 16#0002#),
         11286 => (16#0BCD#, 16#0020#, 16#0002#),
         11287 => (16#0BCE#, 16#0020#, 16#0002#),
         11288 => (16#0BCF#, 16#0020#, 16#0002#),
         11289 => (16#0BD0#, 16#0020#, 16#0002#),
         11290 => (16#0BD1#, 16#0020#, 16#0002#),
         11291 => (16#0BD2#, 16#0020#, 16#0002#),
         11292 => (16#0BD3#, 16#0020#, 16#0002#),
         11293 => (16#0BD4#, 16#0020#, 16#0002#),
         11294 => (16#0BD5#, 16#0020#, 16#0002#),
         11295 => (16#0BD6#, 16#0020#, 16#0002#),
         11296 => (16#0BD7#, 16#0020#, 16#0002#),
         11297 => (16#0BD8#, 16#0020#, 16#0002#),
         11298 => (16#0BD9#, 16#0020#, 16#0002#),
         11299 => (16#0BDA#, 16#0020#, 16#0002#),
         11300 => (16#0BDB#, 16#0020#, 16#0002#),
         11301 => (16#0BDC#, 16#0020#, 16#0002#),
         11302 => (16#0BDD#, 16#0020#, 16#0002#),
         11303 => (16#0BDE#, 16#0020#, 16#0002#),
         11304 => (16#0BDF#, 16#0020#, 16#0002#),
         11305 => (16#0BE0#, 16#0020#, 16#0002#),
         11306 => (16#0BE1#, 16#0020#, 16#0002#),
         11307 => (16#0BE2#, 16#0020#, 16#0002#),
         11308 => (16#0BE3#, 16#0020#, 16#0002#),
         11309 => (16#0BE4#, 16#0020#, 16#0002#),
         11310 => (16#0BE5#, 16#0020#, 16#0002#),
         11311 => (16#0BE6#, 16#0020#, 16#0002#),
         11312 => (16#0BE7#, 16#0020#, 16#0002#),
         11313 => (16#0BE8#, 16#0020#, 16#0002#),
         11314 => (16#0BE9#, 16#0020#, 16#0002#),
         11315 => (16#0BEA#, 16#0020#, 16#0002#),
         11316 => (16#0BEB#, 16#0020#, 16#0002#),
         11317 => (16#0BEC#, 16#0020#, 16#0002#),
         11318 => (16#0BED#, 16#0020#, 16#0002#),
         11319 => (16#0BEE#, 16#0020#, 16#0002#),
         11320 => (16#0BEF#, 16#0020#, 16#0002#),
         11321 => (16#0BF0#, 16#0020#, 16#0002#),
         11322 => (16#0BF1#, 16#0020#, 16#0002#),
         11323 => (16#0BF2#, 16#0020#, 16#0002#),
         11324 => (16#0BF3#, 16#0020#, 16#0002#),
         11325 => (16#0BF4#, 16#0020#, 16#0002#),
         11326 => (16#0BF5#, 16#0020#, 16#0002#),
         11327 => (16#0BF6#, 16#0020#, 16#0002#),
         11328 => (16#0BF7#, 16#0020#, 16#0002#),
         11329 => (16#0BF8#, 16#0020#, 16#0002#),
         11330 => (16#0BF9#, 16#0020#, 16#0002#),
         11331 => (16#0BFA#, 16#0020#, 16#0002#),
         11332 => (16#0BFB#, 16#0020#, 16#0002#),
         11333 => (16#0BFC#, 16#0020#, 16#0002#),
         11334 => (16#0BFD#, 16#0020#, 16#0002#),
         11335 => (16#0BFE#, 16#0020#, 16#0002#),
         11336 => (16#0BFF#, 16#0020#, 16#0002#),
         11337 => (16#0C00#, 16#0020#, 16#0002#),
         11338 => (16#0C01#, 16#0020#, 16#0002#),
         11339 => (16#0C02#, 16#0020#, 16#0002#),
         11340 => (16#0C03#, 16#0020#, 16#0002#),
         11341 => (16#0C04#, 16#0020#, 16#0002#),
         11342 => (16#0C05#, 16#0020#, 16#0002#),
         11343 => (16#0C06#, 16#0020#, 16#0002#),
         11344 => (16#0C07#, 16#0020#, 16#0002#),
         11345 => (16#0C08#, 16#0020#, 16#0002#),
         11346 => (16#0C09#, 16#0020#, 16#0002#),
         11347 => (16#0C0A#, 16#0020#, 16#0002#),
         11348 => (16#0C0B#, 16#0020#, 16#0002#),
         11349 => (16#0C0C#, 16#0020#, 16#0002#),
         11350 => (16#0C0D#, 16#0020#, 16#0002#),
         11351 => (16#0C0E#, 16#0020#, 16#0002#),
         11352 => (16#0C0F#, 16#0020#, 16#0002#),
         11353 => (16#0C10#, 16#0020#, 16#0002#),
         11354 => (16#0C11#, 16#0020#, 16#0002#),
         11355 => (16#0C12#, 16#0020#, 16#0002#),
         11356 => (16#0C13#, 16#0020#, 16#0002#),
         11357 => (16#0C14#, 16#0020#, 16#0002#),
         11358 => (16#0C15#, 16#0020#, 16#0002#),
         11359 => (16#0C16#, 16#0020#, 16#0002#),
         11360 => (16#0C17#, 16#0020#, 16#0002#),
         11361 => (16#0C18#, 16#0020#, 16#0002#),
         11362 => (16#0C19#, 16#0020#, 16#0002#),
         11363 => (16#0C1A#, 16#0020#, 16#0002#),
         11364 => (16#0C1B#, 16#0020#, 16#0002#),
         11365 => (16#0C1C#, 16#0020#, 16#0002#),
         11366 => (16#0C1D#, 16#0020#, 16#0002#),
         11367 => (16#0C1E#, 16#0020#, 16#0002#),
         11368 => (16#0C1F#, 16#0020#, 16#0002#),
         11369 => (16#0C20#, 16#0020#, 16#0002#),
         11370 => (16#0C21#, 16#0020#, 16#0002#),
         11371 => (16#0C22#, 16#0020#, 16#0002#),
         11372 => (16#0C23#, 16#0020#, 16#0002#),
         11373 => (16#0C24#, 16#0020#, 16#0002#),
         11374 => (16#0C25#, 16#0020#, 16#0002#),
         11375 => (16#0C26#, 16#0020#, 16#0002#),
         11376 => (16#0C27#, 16#0020#, 16#0002#),
         11377 => (16#0C28#, 16#0020#, 16#0002#),
         11378 => (16#0C29#, 16#0020#, 16#0002#),
         11379 => (16#0C2A#, 16#0020#, 16#0002#),
         11380 => (16#0C2B#, 16#0020#, 16#0002#),
         11381 => (16#0C2C#, 16#0020#, 16#0002#),
         11382 => (16#0C2D#, 16#0020#, 16#0002#),
         11383 => (16#0C2E#, 16#0020#, 16#0002#),
         11384 => (16#0C2F#, 16#0020#, 16#0002#),
         11385 => (16#0C30#, 16#0020#, 16#0002#),
         11386 => (16#0C31#, 16#0020#, 16#0002#),
         11387 => (16#0C32#, 16#0020#, 16#0002#),
         11388 => (16#0C33#, 16#0020#, 16#0002#),
         11389 => (16#0C34#, 16#0020#, 16#0002#),
         11390 => (16#0C35#, 16#0020#, 16#0002#),
         11391 => (16#0C36#, 16#0020#, 16#0002#),
         11392 => (16#0C37#, 16#0020#, 16#0002#),
         11393 => (16#0C38#, 16#0020#, 16#0002#),
         11394 => (16#0C39#, 16#0020#, 16#0002#),
         11395 => (16#0C3A#, 16#0020#, 16#0002#),
         11396 => (16#0C3B#, 16#0020#, 16#0002#),
         11397 => (16#0C3C#, 16#0020#, 16#0002#),
         11398 => (16#0C3D#, 16#0020#, 16#0002#),
         11399 => (16#0C3E#, 16#0020#, 16#0002#),
         11400 => (16#0C3F#, 16#0020#, 16#0002#),
         11401 => (16#0C40#, 16#0020#, 16#0002#),
         11402 => (16#0C41#, 16#0020#, 16#0002#),
         11403 => (16#0C42#, 16#0020#, 16#0002#),
         11404 => (16#0C43#, 16#0020#, 16#0002#),
         11405 => (16#0C44#, 16#0020#, 16#0002#),
         11406 => (16#0C45#, 16#0020#, 16#0002#),
         11407 => (16#0C46#, 16#0020#, 16#0002#),
         11408 => (16#0C47#, 16#0020#, 16#0002#),
         11409 => (16#0C48#, 16#0020#, 16#0002#),
         11410 => (16#0C49#, 16#0020#, 16#0002#),
         11411 => (16#0C4A#, 16#0020#, 16#0002#),
         11412 => (16#0C4B#, 16#0020#, 16#0002#),
         11413 => (16#0C4C#, 16#0020#, 16#0002#),
         11414 => (16#0C4D#, 16#0020#, 16#0002#),
         11415 => (16#1EA3#, 16#0020#, 16#0008#),
         11416 => (16#1EA4#, 16#0020#, 16#0008#),
         11417 => (16#1EA5#, 16#0020#, 16#0008#),
         11418 => (16#1EA6#, 16#0020#, 16#0008#),
         11419 => (16#1EA7#, 16#0020#, 16#0008#),
         11420 => (16#1EA8#, 16#0020#, 16#0008#),
         11421 => (16#1EA9#, 16#0020#, 16#0008#),
         11422 => (16#1EAA#, 16#0020#, 16#0008#),
         11423 => (16#1EAB#, 16#0020#, 16#0008#),
         11424 => (16#1EAC#, 16#0020#, 16#0008#),
         11425 => (16#1EAD#, 16#0020#, 16#0008#),
         11426 => (16#1EAE#, 16#0020#, 16#0008#),
         11427 => (16#1EAF#, 16#0020#, 16#0008#),
         11428 => (16#1EB0#, 16#0020#, 16#0008#),
         11429 => (16#1EB1#, 16#0020#, 16#0008#),
         11430 => (16#1EB2#, 16#0020#, 16#0008#),
         11431 => (16#1EB3#, 16#0020#, 16#0008#),
         11432 => (16#1EB4#, 16#0020#, 16#0008#),
         11433 => (16#1EB5#, 16#0020#, 16#0008#),
         11434 => (16#1EB6#, 16#0020#, 16#0008#),
         11435 => (16#1EB7#, 16#0020#, 16#0008#),
         11436 => (16#1EB8#, 16#0020#, 16#0008#),
         11437 => (16#1EB9#, 16#0020#, 16#0008#),
         11438 => (16#1EBA#, 16#0020#, 16#0008#),
         11439 => (16#1EBB#, 16#0020#, 16#0008#),
         11440 => (16#1EBC#, 16#0020#, 16#0008#),
         11441 => (16#1EBD#, 16#0020#, 16#0008#),
         11442 => (16#1EBE#, 16#0020#, 16#0008#),
         11443 => (16#1EBF#, 16#0020#, 16#0008#),
         11444 => (16#1EC0#, 16#0020#, 16#0008#),
         11445 => (16#1EC1#, 16#0020#, 16#0008#),
         11446 => (16#1EC2#, 16#0020#, 16#0008#),
         11447 => (16#1EC3#, 16#0020#, 16#0008#),
         11448 => (16#1EC4#, 16#0020#, 16#0008#),
         11449 => (16#1EC5#, 16#0020#, 16#0008#),
         11450 => (16#1EC6#, 16#0020#, 16#0008#),
         11451 => (16#1EC7#, 16#0020#, 16#0008#),
         11452 => (16#1EC8#, 16#0020#, 16#0008#),
         11453 => (16#1EC9#, 16#0020#, 16#0008#),
         11454 => (16#1ECA#, 16#0020#, 16#0008#),
         11455 => (16#1ECB#, 16#0020#, 16#0008#),
         11456 => (16#1ECC#, 16#0020#, 16#0008#),
         11457 => (16#1ECD#, 16#0020#, 16#0008#),
         11458 => (16#1ECE#, 16#0020#, 16#0008#),
         11459 => (16#1ECF#, 16#0020#, 16#0008#),
         11460 => (16#1ED0#, 16#0020#, 16#0008#),
         11461 => (16#1ED1#, 16#0020#, 16#0008#),
         11462 => (16#1EA3#, 16#0020#, 16#0002#),
         11463 => (16#1EA4#, 16#0020#, 16#0002#),
         11464 => (16#1EA5#, 16#0020#, 16#0002#),
         11465 => (16#1EA6#, 16#0020#, 16#0002#),
         11466 => (16#1EA7#, 16#0020#, 16#0002#),
         11467 => (16#1EA8#, 16#0020#, 16#0002#),
         11468 => (16#1EA9#, 16#0020#, 16#0002#),
         11469 => (16#1EAA#, 16#0020#, 16#0002#),
         11470 => (16#1EAB#, 16#0020#, 16#0002#),
         11471 => (16#1EAC#, 16#0020#, 16#0002#),
         11472 => (16#1EAD#, 16#0020#, 16#0002#),
         11473 => (16#1EAE#, 16#0020#, 16#0002#),
         11474 => (16#1EAF#, 16#0020#, 16#0002#),
         11475 => (16#1EB0#, 16#0020#, 16#0002#),
         11476 => (16#1EB1#, 16#0020#, 16#0002#),
         11477 => (16#1EB2#, 16#0020#, 16#0002#),
         11478 => (16#1EB3#, 16#0020#, 16#0002#),
         11479 => (16#1EB4#, 16#0020#, 16#0002#),
         11480 => (16#1EB5#, 16#0020#, 16#0002#),
         11481 => (16#1EB6#, 16#0020#, 16#0002#),
         11482 => (16#1EB7#, 16#0020#, 16#0002#),
         11483 => (16#1EB8#, 16#0020#, 16#0002#),
         11484 => (16#1EB9#, 16#0020#, 16#0002#),
         11485 => (16#1EBA#, 16#0020#, 16#0002#),
         11486 => (16#1EBB#, 16#0020#, 16#0002#),
         11487 => (16#1EBC#, 16#0020#, 16#0002#),
         11488 => (16#1EBD#, 16#0020#, 16#0002#),
         11489 => (16#1EBE#, 16#0020#, 16#0002#),
         11490 => (16#1EBF#, 16#0020#, 16#0002#),
         11491 => (16#1EC0#, 16#0020#, 16#0002#),
         11492 => (16#1EC1#, 16#0020#, 16#0002#),
         11493 => (16#1EC2#, 16#0020#, 16#0002#),
         11494 => (16#1EC3#, 16#0020#, 16#0002#),
         11495 => (16#1EC4#, 16#0020#, 16#0002#),
         11496 => (16#1EC5#, 16#0020#, 16#0002#),
         11497 => (16#1EC6#, 16#0020#, 16#0002#),
         11498 => (16#1EC7#, 16#0020#, 16#0002#),
         11499 => (16#1EC8#, 16#0020#, 16#0002#),
         11500 => (16#1EC9#, 16#0020#, 16#0002#),
         11501 => (16#1ECA#, 16#0020#, 16#0002#),
         11502 => (16#1ECB#, 16#0020#, 16#0002#),
         11503 => (16#1ECC#, 16#0020#, 16#0002#),
         11504 => (16#1ECD#, 16#0020#, 16#0002#),
         11505 => (16#1ECE#, 16#0020#, 16#0002#),
         11506 => (16#1ECF#, 16#0020#, 16#0002#),
         11507 => (16#1ED0#, 16#0020#, 16#0002#),
         11508 => (16#1ED1#, 16#0020#, 16#0002#),
         11509 => (16#1A4A#, 16#0020#, 16#0008#),
         11510 => (16#1A4A#, 16#0020#, 16#0002#),
         11511 => (16#1A4B#, 16#0020#, 16#0008#),
         11512 => (16#1AD3#, 16#0020#, 16#0008#),
         11513 => (16#1B19#, 16#0020#, 16#0008#),
         11514 => (16#1911#, 16#0020#, 16#0002#),
         11515 => (16#1B60#, 16#0020#, 16#0002#),
         11516 => (16#19ED#, 16#0020#, 16#0008#),
         11517 => (16#19ED#, 16#0020#, 16#0002#),
         11518 => (16#1A33#, 16#0020#, 16#0008#),
         11519 => (16#1A33#, 16#0020#, 16#0002#),
         11520 => (16#1BFE#, 16#0020#, 16#0008#),
         11521 => (16#1BFE#, 16#0020#, 16#0002#),
         11522 => (16#191A#, 16#0020#, 16#0008#),
         11523 => (16#1A75#, 16#0020#, 16#0008#),
         11524 => (16#1916#, 16#0020#, 16#0008#),
         11525 => (16#1920#, 16#0020#, 16#0008#),
         11526 => (16#1BB0#, 16#0020#, 16#0002#),
         11527 => (16#1BBC#, 16#0020#, 16#0008#),
         11528 => (16#1BBC#, 16#0020#, 16#0002#),
         11529 => (16#1BB1#, 16#0020#, 16#0002#),
         11530 => (16#19EE#, 16#0020#, 16#0008#),
         11531 => (16#19EE#, 16#0020#, 16#0002#),
         11532 => (16#1AE2#, 16#0020#, 16#0002#),
         11533 => (16#197B#, 16#0020#, 16#0002#),
         11534 => (16#1B14#, 16#0020#, 16#0002#),
         11535 => (16#1ABF#, 16#0020#, 16#0002#),
         11536 => (16#1980#, 16#0020#, 16#0002#),
         11537 => (16#1A10#, 16#0020#, 16#0015#),
         11538 => (16#1BA5#, 16#0020#, 16#001D#),
         11539 => (16#1B3E#, 16#0020#, 16#0008#),
         11540 => (16#1BFA#, 16#0020#, 16#0008#),
         11541 => (16#1CA4#, 16#0020#, 16#0008#),
         11542 => (16#1CA4#, 16#0020#, 16#0002#),
         11543 => (16#1CA5#, 16#0020#, 16#0008#),
         11544 => (16#1CA5#, 16#0020#, 16#0002#),
         11545 => (16#1CA6#, 16#0020#, 16#0008#),
         11546 => (16#1CA6#, 16#0020#, 16#0002#),
         11547 => (16#1CA7#, 16#0020#, 16#0008#),
         11548 => (16#1CA7#, 16#0020#, 16#0002#),
         11549 => (16#1CA8#, 16#0020#, 16#0008#),
         11550 => (16#1CA8#, 16#0020#, 16#0002#),
         11551 => (16#1CAA#, 16#0020#, 16#0008#),
         11552 => (16#1CAA#, 16#0020#, 16#0002#),
         11553 => (16#1CAB#, 16#0020#, 16#0008#),
         11554 => (16#1CAB#, 16#0020#, 16#0002#),
         11555 => (16#1CAC#, 16#0020#, 16#0008#),
         11556 => (16#1CAC#, 16#0020#, 16#0002#),
         11557 => (16#1CAD#, 16#0020#, 16#0008#),
         11558 => (16#1CAD#, 16#0020#, 16#0002#),
         11559 => (16#1CAE#, 16#0020#, 16#0008#),
         11560 => (16#1CAE#, 16#0020#, 16#0002#),
         11561 => (16#1CAF#, 16#0020#, 16#0008#),
         11562 => (16#1CAF#, 16#0020#, 16#0002#),
         11563 => (16#1CB1#, 16#0020#, 16#0008#),
         11564 => (16#1CB1#, 16#0020#, 16#0002#),
         11565 => (16#1CB2#, 16#0020#, 16#0008#),
         11566 => (16#1CB2#, 16#0020#, 16#0002#),
         11567 => (16#1CB3#, 16#0020#, 16#0008#),
         11568 => (16#1CB3#, 16#0020#, 16#0002#),
         11569 => (16#1CB6#, 16#0020#, 16#0008#),
         11570 => (16#1CB6#, 16#0020#, 16#0002#),
         11571 => (16#1CB7#, 16#0020#, 16#0008#),
         11572 => (16#1CB7#, 16#0020#, 16#0002#),
         11573 => (16#1CB8#, 16#0020#, 16#0008#),
         11574 => (16#1CB8#, 16#0020#, 16#0002#),
         11575 => (16#1CB9#, 16#0020#, 16#0008#),
         11576 => (16#1CB9#, 16#0020#, 16#0002#),
         11577 => (16#1CBA#, 16#0020#, 16#0008#),
         11578 => (16#1CBA#, 16#0020#, 16#0002#),
         11579 => (16#1CBB#, 16#0020#, 16#0008#),
         11580 => (16#1CBB#, 16#0020#, 16#0002#),
         11581 => (16#1CBC#, 16#0020#, 16#0008#),
         11582 => (16#1CBC#, 16#0020#, 16#0002#),
         11583 => (16#1CBD#, 16#0020#, 16#0008#),
         11584 => (16#1CBD#, 16#0020#, 16#0002#),
         11585 => (16#1CBE#, 16#0020#, 16#0008#),
         11586 => (16#1CBE#, 16#0020#, 16#0002#),
         11587 => (16#1CBF#, 16#0020#, 16#0008#),
         11588 => (16#1CBF#, 16#0020#, 16#0002#),
         11589 => (16#1CC0#, 16#0020#, 16#0008#),
         11590 => (16#1CC0#, 16#0020#, 16#0002#),
         11591 => (16#1CDB#, 16#0020#, 16#0008#),
         11592 => (16#1CDB#, 16#0020#, 16#0002#),
         11593 => (16#1CDC#, 16#0020#, 16#0008#),
         11594 => (16#1CDC#, 16#0020#, 16#0002#),
         11595 => (16#1CA9#, 16#0020#, 16#0008#),
         11596 => (16#1CA9#, 16#0020#, 16#0002#),
         11597 => (16#1CB0#, 16#0020#, 16#0008#),
         11598 => (16#1CB0#, 16#0020#, 16#0002#),
         11599 => (16#1CB4#, 16#0020#, 16#0008#),
         11600 => (16#1CB4#, 16#0020#, 16#0002#),
         11601 => (16#1CB5#, 16#0020#, 16#0008#),
         11602 => (16#1CB5#, 16#0020#, 16#0002#),
         11603 => (16#1CC1#, 16#0020#, 16#0008#),
         11604 => (16#1CC1#, 16#0020#, 16#0002#),
         11605 => (16#1CC2#, 16#0020#, 16#0008#),
         11606 => (16#1CC2#, 16#0020#, 16#0002#),
         11607 => (16#1CC5#, 16#0020#, 16#0008#),
         11608 => (16#1CC5#, 16#0020#, 16#0002#),
         11609 => (16#1CC6#, 16#0020#, 16#0008#),
         11610 => (16#1CC6#, 16#0020#, 16#0002#),
         11611 => (16#1CC7#, 16#0020#, 16#0008#),
         11612 => (16#1CC7#, 16#0020#, 16#0002#),
         11613 => (16#1CCB#, 16#0020#, 16#0008#),
         11614 => (16#1CCB#, 16#0020#, 16#0002#),
         11615 => (16#1CCD#, 16#0020#, 16#0008#),
         11616 => (16#1CCD#, 16#0020#, 16#0002#),
         11617 => (16#1CCE#, 16#0020#, 16#0008#),
         11618 => (16#1CCE#, 16#0020#, 16#0002#),
         11619 => (16#1CCF#, 16#0020#, 16#0008#),
         11620 => (16#1CCF#, 16#0020#, 16#0002#),
         11621 => (16#1CD0#, 16#0020#, 16#0008#),
         11622 => (16#1CD0#, 16#0020#, 16#0002#),
         11623 => (16#1CD1#, 16#0020#, 16#0008#),
         11624 => (16#1CD1#, 16#0020#, 16#0002#),
         11625 => (16#1CD2#, 16#0020#, 16#0008#),
         11626 => (16#1CD2#, 16#0020#, 16#0002#),
         11627 => (16#1CD5#, 16#0020#, 16#0008#),
         11628 => (16#1CD5#, 16#0020#, 16#0002#),
         11629 => (16#1CD7#, 16#0020#, 16#0008#),
         11630 => (16#1CD7#, 16#0020#, 16#0002#),
         11631 => (16#1CD8#, 16#0020#, 16#0008#),
         11632 => (16#1CD8#, 16#0020#, 16#0002#),
         11633 => (16#1CD9#, 16#0020#, 16#0008#),
         11634 => (16#1CD9#, 16#0020#, 16#0002#),
         11635 => (16#1CDD#, 16#0020#, 16#0008#),
         11636 => (16#1CDD#, 16#0020#, 16#0002#),
         11637 => (16#1CDE#, 16#0020#, 16#0008#),
         11638 => (16#1CDE#, 16#0020#, 16#0002#),
         11639 => (16#1CDF#, 16#0020#, 16#0008#),
         11640 => (16#1CDF#, 16#0020#, 16#0002#),
         11641 => (16#1CAF#, 16#0020#, 16#0004#),
         11642 => (16#1CA4#, 16#0020#, 16#0004#),
         11643 => (16#1CAE#, 16#0020#, 16#0004#),
         11644 => (16#0C4E#, 16#0020#, 16#0002#),
         11645 => (16#0C4F#, 16#0020#, 16#0002#),
         11646 => (16#0C50#, 16#0020#, 16#0002#),
         11647 => (16#0C51#, 16#0020#, 16#0002#),
         11648 => (16#0C52#, 16#0020#, 16#0002#),
         11649 => (16#0C53#, 16#0020#, 16#0002#),
         11650 => (16#1CC4#, 16#0020#, 16#0008#),
         11651 => (16#1CC4#, 16#0020#, 16#0002#),
         11652 => (16#1CD4#, 16#0020#, 16#0008#),
         11653 => (16#1CD4#, 16#0020#, 16#0002#),
         11654 => (16#1CCA#, 16#0020#, 16#0008#),
         11655 => (16#1CCA#, 16#0020#, 16#0002#),
         11656 => (16#017D#, 16#0020#, 16#0002#),
         11657 => (16#016B#, 16#0020#, 16#0002#),
         11658 => (16#016C#, 16#0020#, 16#0002#),
         11659 => (16#01E8#, 16#0020#, 16#0002#),
         11660 => (16#1738#, 16#0020#, 16#0002#),
         11661 => (16#017E#, 16#0020#, 16#0002#),
         11662 => (16#01E9#, 16#0020#, 16#0002#),
         11663 => (16#1EF9#, 16#0020#, 16#0002#),
         11664 => (16#1EFB#, 16#0020#, 16#0002#),
         11665 => (16#1EFD#, 16#0020#, 16#0002#),
         11666 => (16#1EFF#, 16#0020#, 16#0002#),
         11667 => (16#1F01#, 16#0020#, 16#0002#),
         11668 => (16#1F03#, 16#0020#, 16#0002#),
         11669 => (16#1F05#, 16#0020#, 16#0002#),
         11670 => (16#1F09#, 16#0020#, 16#0002#),
         11671 => (16#1F0B#, 16#0020#, 16#0002#),
         11672 => (16#1F0D#, 16#0020#, 16#0002#),
         11673 => (16#1F0F#, 16#0020#, 16#0002#),
         11674 => (16#1F11#, 16#0020#, 16#0002#),
         11675 => (16#1F13#, 16#0020#, 16#0002#),
         11676 => (16#1F17#, 16#0020#, 16#0002#),
         11677 => (16#1F19#, 16#0020#, 16#0002#),
         11678 => (16#1F1B#, 16#0020#, 16#0002#),
         11679 => (16#1F1D#, 16#0020#, 16#0002#),
         11680 => (16#1F1F#, 16#0020#, 16#0002#),
         11681 => (16#1F21#, 16#0020#, 16#0002#),
         11682 => (16#1F25#, 16#0020#, 16#0002#),
         11683 => (16#1F27#, 16#0020#, 16#0002#),
         11684 => (16#1F29#, 16#0020#, 16#0002#),
         11685 => (16#1F2B#, 16#0020#, 16#0002#),
         11686 => (16#1F2D#, 16#0020#, 16#0002#),
         11687 => (16#1F2F#, 16#0020#, 16#0002#),
         11688 => (16#1F31#, 16#0020#, 16#0002#),
         11689 => (16#1F33#, 16#0020#, 16#0002#),
         11690 => (16#1F35#, 16#0020#, 16#0002#),
         11691 => (16#1F37#, 16#0020#, 16#0002#),
         11692 => (16#1F39#, 16#0020#, 16#0002#),
         11693 => (16#1F3B#, 16#0020#, 16#0002#),
         11694 => (16#1F3F#, 16#0020#, 16#0002#),
         11695 => (16#1F41#, 16#0020#, 16#0002#),
         11696 => (16#1F07#, 16#0020#, 16#0002#),
         11697 => (16#1F15#, 16#0020#, 16#0002#),
         11698 => (16#1F23#, 16#0020#, 16#0002#),
         11699 => (16#1F3D#, 16#0020#, 16#0002#),
         11700 => (16#1F43#, 16#0020#, 16#0002#),
         11701 => (16#1F46#, 16#0020#, 16#0002#),
         11702 => (16#1F4B#, 16#0020#, 16#0002#),
         11703 => (16#2111#, 16#0020#, 16#0002#),
         11704 => (16#2112#, 16#0020#, 16#0002#),
         11705 => (16#2113#, 16#0020#, 16#0002#),
         11706 => (16#2114#, 16#0020#, 16#0002#),
         11707 => (16#2115#, 16#0020#, 16#0002#),
         11708 => (16#2116#, 16#0020#, 16#0002#),
         11709 => (16#2117#, 16#0020#, 16#0002#),
         11710 => (16#2118#, 16#0020#, 16#0002#),
         11711 => (16#2119#, 16#0020#, 16#0002#),
         11712 => (16#211A#, 16#0020#, 16#0002#),
         11713 => (16#211B#, 16#0020#, 16#0002#),
         11714 => (16#211C#, 16#0020#, 16#0002#),
         11715 => (16#211E#, 16#0020#, 16#0002#),
         11716 => (16#211F#, 16#0020#, 16#0002#),
         11717 => (16#2120#, 16#0020#, 16#0002#),
         11718 => (16#2121#, 16#0020#, 16#0002#),
         11719 => (16#2122#, 16#0020#, 16#0002#),
         11720 => (16#2123#, 16#0020#, 16#0002#),
         11721 => (16#2124#, 16#0020#, 16#0002#),
         11722 => (16#2125#, 16#0020#, 16#0002#),
         11723 => (16#2126#, 16#0020#, 16#0002#),
         11724 => (16#2127#, 16#0020#, 16#0002#),
         11725 => (16#2128#, 16#0020#, 16#0002#),
         11726 => (16#2129#, 16#0020#, 16#0002#),
         11727 => (16#212A#, 16#0020#, 16#0002#),
         11728 => (16#212B#, 16#0020#, 16#0002#),
         11729 => (16#212C#, 16#0020#, 16#0002#),
         11730 => (16#212D#, 16#0020#, 16#0002#),
         11731 => (16#212E#, 16#0020#, 16#0002#),
         11732 => (16#212F#, 16#0020#, 16#0002#),
         11733 => (16#2130#, 16#0020#, 16#0002#),
         11734 => (16#2131#, 16#0020#, 16#0002#),
         11735 => (16#2132#, 16#0020#, 16#0002#),
         11736 => (16#2133#, 16#0020#, 16#0002#),
         11737 => (16#2134#, 16#0020#, 16#0002#),
         11738 => (16#2135#, 16#0020#, 16#0002#),
         11739 => (16#2137#, 16#0020#, 16#0002#),
         11740 => (16#2138#, 16#0020#, 16#0002#),
         11741 => (16#2139#, 16#0020#, 16#0002#),
         11742 => (16#213A#, 16#0020#, 16#0002#),
         11743 => (16#213B#, 16#0020#, 16#0002#),
         11744 => (16#213C#, 16#0020#, 16#0002#),
         11745 => (16#213D#, 16#0020#, 16#0002#),
         11746 => (16#213E#, 16#0020#, 16#0002#),
         11747 => (16#213F#, 16#0020#, 16#0002#),
         11748 => (16#2140#, 16#0020#, 16#0002#),
         11749 => (16#2141#, 16#0020#, 16#0002#),
         11750 => (16#2142#, 16#0020#, 16#0002#),
         11751 => (16#2143#, 16#0020#, 16#0002#),
         11752 => (16#2144#, 16#0020#, 16#0002#),
         11753 => (16#2145#, 16#0020#, 16#0002#),
         11754 => (16#2146#, 16#0020#, 16#0002#),
         11755 => (16#2147#, 16#0020#, 16#0002#),
         11756 => (16#2148#, 16#0020#, 16#0002#),
         11757 => (16#211D#, 16#0020#, 16#0002#),
         11758 => (16#2136#, 16#0020#, 16#0002#),
         11759 => (16#2149#, 16#0020#, 16#0002#),
         11760 => (16#0308#, 16#0020#, 16#0002#),
         11761 => (16#215A#, 16#0020#, 16#0002#),
         11762 => (16#216F#, 16#0020#, 16#0002#),
         11763 => (16#2180#, 16#0020#, 16#0002#),
         11764 => (16#2189#, 16#0020#, 16#0002#),
         11765 => (16#2198#, 16#0020#, 16#0002#),
         11766 => (16#21BE#, 16#0020#, 16#0002#),
         11767 => (16#21CF#, 16#0020#, 16#0002#),
         11768 => (16#21D8#, 16#0020#, 16#0002#),
         11769 => (16#21EE#, 16#0020#, 16#0002#),
         11770 => (16#21F7#, 16#0020#, 16#0002#),
         11771 => (16#2200#, 16#0020#, 16#0002#),
         11772 => (16#2231#, 16#0020#, 16#0002#),
         11773 => (16#2250#, 16#0020#, 16#0002#),
         11774 => (16#225F#, 16#0020#, 16#0002#),
         11775 => (16#2268#, 16#0020#, 16#0002#),
         11776 => (16#228A#, 16#0020#, 16#0002#),
         11777 => (16#2293#, 16#0020#, 16#0002#),
         11778 => (16#22A3#, 16#0020#, 16#0002#),
         11779 => (16#22D3#, 16#0020#, 16#0002#),
         11780 => (16#227E#, 16#0020#, 16#0002#),
         11781 => (16#227F#, 16#0020#, 16#0002#),
         11782 => (16#2280#, 16#0020#, 16#0002#),
         11783 => (16#2281#, 16#0020#, 16#0002#),
         11784 => (16#22D7#, 16#0020#, 16#0002#),
         11785 => (16#22D8#, 16#0020#, 16#0002#),
         11786 => (16#22D9#, 16#0020#, 16#0002#),
         11787 => (16#22DA#, 16#0020#, 16#0002#),
         11788 => (16#22DB#, 16#0020#, 16#0002#),
         11789 => (16#22DC#, 16#0020#, 16#0002#),
         11790 => (16#22DD#, 16#0020#, 16#0002#),
         11791 => (16#22DE#, 16#0020#, 16#0002#),
         11792 => (16#22DF#, 16#0020#, 16#0002#),
         11793 => (16#22E0#, 16#0020#, 16#0002#),
         11794 => (16#22E1#, 16#0020#, 16#0002#),
         11795 => (16#22E2#, 16#0020#, 16#0002#),
         11796 => (16#22E3#, 16#0020#, 16#0002#),
         11797 => (16#22E4#, 16#0020#, 16#0002#),
         11798 => (16#22E5#, 16#0020#, 16#0002#),
         11799 => (16#22E6#, 16#0020#, 16#0002#),
         11800 => (16#22E7#, 16#0020#, 16#0002#),
         11801 => (16#22E8#, 16#0020#, 16#0002#),
         11802 => (16#22E9#, 16#0020#, 16#0002#),
         11803 => (16#22EA#, 16#0020#, 16#0002#),
         11804 => (16#22EB#, 16#0020#, 16#0002#),
         11805 => (16#22EC#, 16#0020#, 16#0002#),
         11806 => (16#22ED#, 16#0020#, 16#0002#),
         11807 => (16#22EE#, 16#0020#, 16#0002#),
         11808 => (16#22EF#, 16#0020#, 16#0002#),
         11809 => (16#22F0#, 16#0020#, 16#0002#),
         11810 => (16#22F1#, 16#0020#, 16#0002#),
         11811 => (16#22F2#, 16#0020#, 16#0002#),
         11812 => (16#22F3#, 16#0020#, 16#0002#),
         11813 => (16#22F4#, 16#0020#, 16#0002#),
         11814 => (16#22F5#, 16#0020#, 16#0002#),
         11815 => (16#22F6#, 16#0020#, 16#0002#),
         11816 => (16#22F7#, 16#0020#, 16#0002#),
         11817 => (16#22F8#, 16#0020#, 16#0002#),
         11818 => (16#22F9#, 16#0020#, 16#0002#),
         11819 => (16#22FA#, 16#0020#, 16#0002#),
         11820 => (16#22FB#, 16#0020#, 16#0002#),
         11821 => (16#22FC#, 16#0020#, 16#0002#),
         11822 => (16#22FD#, 16#0020#, 16#0002#),
         11823 => (16#22FE#, 16#0020#, 16#0002#),
         11824 => (16#22FF#, 16#0020#, 16#0002#),
         11825 => (16#2300#, 16#0020#, 16#0002#),
         11826 => (16#2301#, 16#0020#, 16#0002#),
         11827 => (16#2302#, 16#0020#, 16#0002#),
         11828 => (16#2303#, 16#0020#, 16#0002#),
         11829 => (16#2304#, 16#0020#, 16#0002#),
         11830 => (16#2305#, 16#0020#, 16#0002#),
         11831 => (16#2306#, 16#0020#, 16#0002#),
         11832 => (16#2307#, 16#0020#, 16#0002#),
         11833 => (16#2308#, 16#0020#, 16#0002#),
         11834 => (16#2309#, 16#0020#, 16#0002#),
         11835 => (16#230A#, 16#0020#, 16#0002#),
         11836 => (16#230B#, 16#0020#, 16#0002#),
         11837 => (16#230C#, 16#0020#, 16#0002#),
         11838 => (16#230D#, 16#0020#, 16#0002#),
         11839 => (16#230E#, 16#0020#, 16#0002#),
         11840 => (16#1CEC#, 16#0020#, 16#0004#),
         11841 => (16#1CF0#, 16#0020#, 16#0004#),
         11842 => (16#1D08#, 16#0020#, 16#0004#),
         11843 => (16#1D20#, 16#0020#, 16#0004#),
         11844 => (16#1D2A#, 16#0020#, 16#0004#),
         11845 => (16#1D54#, 16#0020#, 16#0004#),
         11846 => (16#1D6E#, 16#0020#, 16#0004#),
         11847 => (16#1D81#, 16#0020#, 16#0004#),
         11848 => (16#1D8A#, 16#0020#, 16#0004#),
         11849 => (16#1DA5#, 16#0020#, 16#0004#),
         11850 => (16#1DAD#, 16#0020#, 16#0004#),
         11851 => (16#1DBA#, 16#0020#, 16#0004#),
         11852 => (16#1DC3#, 16#0020#, 16#0004#),
         11853 => (16#1DCC#, 16#0020#, 16#0004#),
         11854 => (16#1DF0#, 16#0020#, 16#0004#),
         11855 => (16#1E17#, 16#0020#, 16#0004#),
         11856 => (16#1E22#, 16#0020#, 16#0004#),
         11857 => (16#1E41#, 16#0020#, 16#0004#),
         11858 => (16#1E46#, 16#0020#, 16#0004#),
         11859 => (16#1E91#, 16#0020#, 16#0004#),
         11860 => (16#1CE0#, 16#0020#, 16#0004#),
         11861 => (16#1D18#, 16#0020#, 16#0004#),
         11862 => (16#1D53#, 16#0020#, 16#0004#),
         11863 => (16#1DE7#, 16#0020#, 16#0004#),
         11864 => (16#1E5E#, 16#0020#, 16#0004#),
         11865 => (16#1E67#, 16#0020#, 16#0004#),
         11866 => (16#1E6C#, 16#0020#, 16#0004#),
         11867 => (16#1E76#, 16#0020#, 16#0004#),
         11868 => (16#1E7B#, 16#0020#, 16#0004#),
         11869 => (16#1E85#, 16#0020#, 16#0004#),
         11870 => (16#02A8#, 16#0020#, 16#0002#),
         11871 => (16#02A9#, 16#0020#, 16#0002#),
         11872 => (16#024D#, 16#0020#, 16#0002#),
         11873 => (16#024E#, 16#0020#, 16#0002#),
         11874 => (16#024F#, 16#0020#, 16#0002#),
         11875 => (16#0250#, 16#0020#, 16#0002#),
         11876 => (16#02AA#, 16#0020#, 16#0002#),
         11877 => (16#02AB#, 16#0020#, 16#0002#),
         11878 => (16#02AC#, 16#0020#, 16#0002#),
         11879 => (16#0251#, 16#0020#, 16#0002#),
         11880 => (16#0252#, 16#0020#, 16#0002#),
         11881 => (16#02AD#, 16#0020#, 16#0002#),
         11882 => (16#0253#, 16#0020#, 16#0002#),
         11883 => (16#0254#, 16#0020#, 16#0002#),
         11884 => (16#02AE#, 16#0020#, 16#0002#),
         11885 => (16#02AF#, 16#0020#, 16#0002#),
         11886 => (16#02B0#, 16#0020#, 16#0002#),
         11887 => (16#02B1#, 16#0020#, 16#0002#),
         11888 => (16#02B2#, 16#0020#, 16#0002#),
         11889 => (16#02B3#, 16#0020#, 16#0002#),
         11890 => (16#02B4#, 16#0020#, 16#0002#),
         11891 => (16#02B5#, 16#0020#, 16#0002#),
         11892 => (16#02B6#, 16#0020#, 16#0002#),
         11893 => (16#011A#, 16#0020#, 16#0002#),
         11894 => (16#0172#, 16#0020#, 16#0002#),
         11895 => (16#01EA#, 16#0020#, 16#0002#),
         11896 => (16#02B7#, 16#0020#, 16#0002#),
         11897 => (16#02B8#, 16#0020#, 16#0002#),
         11898 => (16#0255#, 16#0020#, 16#0002#),
         11899 => (16#0256#, 16#0020#, 16#0002#),
         11900 => (16#02B9#, 16#0020#, 16#0002#),
         11901 => (16#02BA#, 16#0020#, 16#0002#),
         11902 => (16#0257#, 16#0020#, 16#0002#),
         11903 => (16#0258#, 16#0020#, 16#0002#),
         11904 => (16#0259#, 16#0020#, 16#0002#),
         11905 => (16#025A#, 16#0020#, 16#0002#),
         11906 => (16#025B#, 16#0020#, 16#0002#),
         11907 => (16#025C#, 16#0020#, 16#0002#),
         11908 => (16#025D#, 16#0020#, 16#0002#),
         11909 => (16#025E#, 16#0020#, 16#0002#),
         11910 => (16#025F#, 16#0020#, 16#0002#),
         11911 => (16#0260#, 16#0020#, 16#0002#),
         11912 => (16#01E3#, 16#0020#, 16#0002#),
         11913 => (16#01E4#, 16#0020#, 16#0002#),
         11914 => (16#01E5#, 16#0020#, 16#0002#),
         11915 => (16#01E6#, 16#0020#, 16#0002#),
         11916 => (16#0165#, 16#0020#, 16#0002#),
         11917 => (16#1E4B#, 16#0020#, 16#0002#),
         11918 => (16#017F#, 16#0020#, 16#0002#),
         11919 => (16#0188#, 16#0020#, 16#0002#),
         11920 => (16#0122#, 16#0020#, 16#0002#),
         11921 => (16#0189#, 16#0020#, 16#0002#),
         11922 => (16#0121#, 16#0020#, 16#0002#),
         11923 => (16#0135#, 16#0020#, 16#0002#),
         11924 => (16#0293#, 16#0020#, 16#0002#),
         11925 => (16#0294#, 16#0020#, 16#0002#),
         11926 => (16#0295#, 16#0020#, 16#0002#),
         11927 => (16#027C#, 16#0020#, 16#0002#),
         11928 => (16#0117#, 16#0020#, 16#0002#),
         11929 => (16#0118#, 16#0020#, 16#0002#),
         11930 => (16#0180#, 16#0020#, 16#0002#),
         11931 => (16#01E7#, 16#0020#, 16#0002#),
         11932 => (16#0276#, 16#0020#, 16#0002#),
         11933 => (16#027F#, 16#0020#, 16#0002#),
         11934 => (16#011B#, 16#0020#, 16#0002#),
         11935 => (16#0123#, 16#0020#, 16#0002#),
         11936 => (16#0203#, 16#0020#, 16#0002#),
         11937 => (16#FB40#, 16#0020#, 16#0004#),
         11938 => (16#CE36#, 16#0000#, 16#0000#),
         11939 => (16#0000#, 16#0108#, 16#0004#),
         11940 => (16#FB40#, 16#0020#, 16#0004#),
         11941 => (16#D382#, 16#0000#, 16#0000#),
         11942 => (16#0000#, 16#0108#, 16#0004#),
         11943 => (16#FB40#, 16#0020#, 16#0004#),
         11944 => (16#CE5B#, 16#0000#, 16#0000#),
         11945 => (16#FB40#, 16#0020#, 16#0004#),
         11946 => (16#CE5A#, 16#0000#, 16#0000#),
         11947 => (16#FB40#, 16#0020#, 16#0004#),
         11948 => (16#CE59#, 16#0000#, 16#0000#),
         11949 => (16#0000#, 16#0108#, 16#0004#),
         11950 => (16#FB40#, 16#0020#, 16#0004#),
         11951 => (16#CEBB#, 16#0000#, 16#0000#),
         11952 => (16#FB40#, 16#0020#, 16#0004#),
         11953 => (16#D182#, 16#0000#, 16#0000#),
         11954 => (16#0000#, 16#0108#, 16#0004#),
         11955 => (16#FB40#, 16#0020#, 16#0004#),
         11956 => (16#D1E0#, 16#0000#, 16#0000#),
         11957 => (16#0000#, 16#0108#, 16#0004#),
         11958 => (16#FB40#, 16#0020#, 16#0004#),
         11959 => (16#D200#, 16#0000#, 16#0000#),
         11960 => (16#0000#, 16#0108#, 16#0004#),
         11961 => (16#FB40#, 16#0020#, 16#0004#),
         11962 => (16#D202#, 16#0000#, 16#0000#),
         11963 => (16#FB40#, 16#0020#, 16#0004#),
         11964 => (16#D35C#, 16#0000#, 16#0000#),
         11965 => (16#0000#, 16#0108#, 16#0004#),
         11966 => (16#FB40#, 16#0020#, 16#0004#),
         11967 => (16#D369#, 16#0000#, 16#0000#),
         11968 => (16#0000#, 16#0108#, 16#0004#),
         11969 => (16#FB40#, 16#0020#, 16#0004#),
         11970 => (16#DC0F#, 16#0000#, 16#0000#),
         11971 => (16#0000#, 16#0108#, 16#0004#),
         11972 => (16#FB40#, 16#0020#, 16#0004#),
         11973 => (16#DC0F#, 16#0000#, 16#0000#),
         11974 => (16#0000#, 16#0109#, 16#0004#),
         11975 => (16#FB40#, 16#0020#, 16#0004#),
         11976 => (16#DC22#, 16#0000#, 16#0000#),
         11977 => (16#0000#, 16#0108#, 16#0004#),
         11978 => (16#FB40#, 16#0020#, 16#0004#),
         11979 => (16#DC23#, 16#0000#, 16#0000#),
         11980 => (16#FB40#, 16#0020#, 16#0004#),
         11981 => (16#DC23#, 16#0000#, 16#0000#),
         11982 => (16#0000#, 16#0108#, 16#0004#),
         11983 => (16#FB40#, 16#0020#, 16#0004#),
         11984 => (16#DDF3#, 16#0000#, 16#0000#),
         11985 => (16#FB40#, 16#0020#, 16#0004#),
         11986 => (16#DE7A#, 16#0000#, 16#0000#),
         11987 => (16#FB40#, 16#0020#, 16#0004#),
         11988 => (16#DF51#, 16#0000#, 16#0000#),
         11989 => (16#FB40#, 16#0020#, 16#0004#),
         11990 => (16#DF50#, 16#0000#, 16#0000#),
         11991 => (16#0000#, 16#0108#, 16#0004#),
         11992 => (16#FB40#, 16#0020#, 16#0004#),
         11993 => (16#DFC4#, 16#0000#, 16#0000#),
         11994 => (16#FB40#, 16#0020#, 16#0004#),
         11995 => (16#DFC3#, 16#0000#, 16#0000#),
         11996 => (16#0000#, 16#0108#, 16#0004#),
         11997 => (16#FB40#, 16#0020#, 16#0004#),
         11998 => (16#E24C#, 16#0000#, 16#0000#),
         11999 => (16#FB40#, 16#0020#, 16#0004#),
         12000 => (16#E535#, 16#0000#, 16#0000#),
         12001 => (16#FB40#, 16#0020#, 16#0004#),
         12002 => (16#E5E1#, 16#0000#, 16#0000#),
         12003 => (16#FB40#, 16#0020#, 16#0004#),
         12004 => (16#E5E5#, 16#0000#, 16#0000#),
         12005 => (16#0000#, 16#0108#, 16#0004#),
         12006 => (16#FB40#, 16#0020#, 16#0004#),
         12007 => (16#E708#, 16#0000#, 16#0000#),
         12008 => (16#0000#, 16#0108#, 16#0004#),
         12009 => (16#FB40#, 16#0020#, 16#0004#),
         12010 => (16#EB7A#, 16#0000#, 16#0000#),
         12011 => (16#0000#, 16#0108#, 16#0004#),
         12012 => (16#FB40#, 16#0020#, 16#0004#),
         12013 => (16#EBCD#, 16#0000#, 16#0000#),
         12014 => (16#FB40#, 16#0020#, 16#0004#),
         12015 => (16#EC11#, 16#0000#, 16#0000#),
         12016 => (16#FB40#, 16#0020#, 16#0004#),
         12017 => (16#EC35#, 16#0000#, 16#0000#),
         12018 => (16#FB40#, 16#0020#, 16#0004#),
         12019 => (16#EC3A#, 16#0000#, 16#0000#),
         12020 => (16#FB40#, 16#0020#, 16#0004#),
         12021 => (16#F06C#, 16#0000#, 16#0000#),
         12022 => (16#FB40#, 16#0020#, 16#0004#),
         12023 => (16#F22B#, 16#0000#, 16#0000#),
         12024 => (16#FB40#, 16#0020#, 16#0004#),
         12025 => (16#F22B#, 16#0000#, 16#0000#),
         12026 => (16#0000#, 16#0108#, 16#0004#),
         12027 => (16#FB40#, 16#0020#, 16#0004#),
         12028 => (16#CE2C#, 16#0000#, 16#0000#),
         12029 => (16#FB40#, 16#0020#, 16#0004#),
         12030 => (16#F25B#, 16#0000#, 16#0000#),
         12031 => (16#0000#, 16#0108#, 16#0004#),
         12032 => (16#FB40#, 16#0020#, 16#0004#),
         12033 => (16#F2AD#, 16#0000#, 16#0000#),
         12034 => (16#FB40#, 16#0020#, 16#0004#),
         12035 => (16#F38B#, 16#0000#, 16#0000#),
         12036 => (16#0000#, 16#0108#, 16#0004#),
         12037 => (16#FB40#, 16#0020#, 16#0004#),
         12038 => (16#F58B#, 16#0000#, 16#0000#),
         12039 => (16#0000#, 16#0108#, 16#0004#),
         12040 => (16#FB40#, 16#0020#, 16#0004#),
         12041 => (16#F6EE#, 16#0000#, 16#0000#),
         12042 => (16#0000#, 16#0108#, 16#0004#),
         12043 => (16#FB40#, 16#0020#, 16#0004#),
         12044 => (16#F93A#, 16#0000#, 16#0000#),
         12045 => (16#0000#, 16#0108#, 16#0004#),
         12046 => (16#FB40#, 16#0020#, 16#0004#),
         12047 => (16#F93B#, 16#0000#, 16#0000#),
         12048 => (16#FB40#, 16#0020#, 16#0004#),
         12049 => (16#FAF9#, 16#0000#, 16#0000#),
         12050 => (16#0000#, 16#0108#, 16#0004#),
         12051 => (16#FB40#, 16#0020#, 16#0004#),
         12052 => (16#FCF9#, 16#0000#, 16#0000#),
         12053 => (16#FB40#, 16#0020#, 16#0004#),
         12054 => (16#FE9F#, 16#0000#, 16#0000#),
         12055 => (16#FB40#, 16#0020#, 16#0004#),
         12056 => (16#FF53#, 16#0000#, 16#0000#),
         12057 => (16#FB40#, 16#0020#, 16#0004#),
         12058 => (16#FF52#, 16#0000#, 16#0000#),
         12059 => (16#FB40#, 16#0020#, 16#0004#),
         12060 => (16#FF53#, 16#0000#, 16#0000#),
         12061 => (16#0000#, 16#0108#, 16#0004#),
         12062 => (16#FB40#, 16#0020#, 16#0004#),
         12063 => (16#FF53#, 16#0000#, 16#0000#),
         12064 => (16#0000#, 16#0109#, 16#0004#),
         12065 => (16#FB40#, 16#0020#, 16#0004#),
         12066 => (16#FF52#, 16#0000#, 16#0000#),
         12067 => (16#0000#, 16#0108#, 16#0004#),
         12068 => (16#FB40#, 16#0020#, 16#0004#),
         12069 => (16#FF8A#, 16#0000#, 16#0000#),
         12070 => (16#0000#, 16#0108#, 16#0004#),
         12071 => (16#FB40#, 16#0020#, 16#0004#),
         12072 => (16#FF8A#, 16#0000#, 16#0000#),
         12073 => (16#0000#, 16#0109#, 16#0004#),
         12074 => (16#FB40#, 16#0020#, 16#0004#),
         12075 => (16#FF8B#, 16#0000#, 16#0000#),
         12076 => (16#FB41#, 16#0020#, 16#0004#),
         12077 => (16#8002#, 16#0000#, 16#0000#),
         12078 => (16#FB41#, 16#0020#, 16#0004#),
         12079 => (16#8080#, 16#0000#, 16#0000#),
         12080 => (16#FB41#, 16#0020#, 16#0004#),
         12081 => (16#807F#, 16#0000#, 16#0000#),
         12082 => (16#0000#, 16#0108#, 16#0004#),
         12083 => (16#FB41#, 16#0020#, 16#0004#),
         12084 => (16#8089#, 16#0000#, 16#0000#),
         12085 => (16#0000#, 16#0108#, 16#0004#),
         12086 => (16#FB41#, 16#0020#, 16#0004#),
         12087 => (16#81FC#, 16#0000#, 16#0000#),
         12088 => (16#0000#, 16#0108#, 16#0004#),
         12089 => (16#FB41#, 16#0020#, 16#0004#),
         12090 => (16#8279#, 16#0000#, 16#0000#),
         12091 => (16#FB41#, 16#0020#, 16#0004#),
         12092 => (16#8279#, 16#0000#, 16#0000#),
         12093 => (16#0000#, 16#0108#, 16#0004#),
         12094 => (16#FB41#, 16#0020#, 16#0004#),
         12095 => (16#8279#, 16#0000#, 16#0000#),
         12096 => (16#0000#, 16#0109#, 16#0004#),
         12097 => (16#FB41#, 16#0020#, 16#0004#),
         12098 => (16#864E#, 16#0000#, 16#0000#),
         12099 => (16#FB41#, 16#0020#, 16#0004#),
         12100 => (16#8864#, 16#0000#, 16#0000#),
         12101 => (16#FB41#, 16#0020#, 16#0004#),
         12102 => (16#8980#, 16#0000#, 16#0000#),
         12103 => (16#FB41#, 16#0020#, 16#0004#),
         12104 => (16#897F#, 16#0000#, 16#0000#),
         12105 => (16#FB41#, 16#0020#, 16#0004#),
         12106 => (16#89C1#, 16#0000#, 16#0000#),
         12107 => (16#FB41#, 16#0020#, 16#0004#),
         12108 => (16#89D2#, 16#0000#, 16#0000#),
         12109 => (16#FB41#, 16#0020#, 16#0004#),
         12110 => (16#89D2#, 16#0000#, 16#0000#),
         12111 => (16#0000#, 16#0108#, 16#0004#),
         12112 => (16#FB41#, 16#0020#, 16#0004#),
         12113 => (16#8BA0#, 16#0000#, 16#0000#),
         12114 => (16#FB41#, 16#0020#, 16#0004#),
         12115 => (16#8D1D#, 16#0000#, 16#0000#),
         12116 => (16#FB41#, 16#0020#, 16#0004#),
         12117 => (16#8DB3#, 16#0000#, 16#0000#),
         12118 => (16#0000#, 16#0108#, 16#0004#),
         12119 => (16#FB41#, 16#0020#, 16#0004#),
         12120 => (16#8F66#, 16#0000#, 16#0000#),
         12121 => (16#FB41#, 16#0020#, 16#0004#),
         12122 => (16#8FB6#, 16#0000#, 16#0000#),
         12123 => (16#FB41#, 16#0020#, 16#0004#),
         12124 => (16#8FB6#, 16#0000#, 16#0000#),
         12125 => (16#0000#, 16#0108#, 16#0004#),
         12126 => (16#FB41#, 16#0020#, 16#0004#),
         12127 => (16#8FB6#, 16#0000#, 16#0000#),
         12128 => (16#0000#, 16#0109#, 16#0004#),
         12129 => (16#FB41#, 16#0020#, 16#0004#),
         12130 => (16#9091#, 16#0000#, 16#0000#),
         12131 => (16#0000#, 16#0108#, 16#0004#),
         12132 => (16#FB41#, 16#0020#, 16#0004#),
         12133 => (16#9485#, 16#0000#, 16#0000#),
         12134 => (16#FB41#, 16#0020#, 16#0004#),
         12135 => (16#9577#, 16#0000#, 16#0000#),
         12136 => (16#FB41#, 16#0020#, 16#0004#),
         12137 => (16#9578#, 16#0000#, 16#0000#),
         12138 => (16#FB41#, 16#0020#, 16#0004#),
         12139 => (16#957F#, 16#0000#, 16#0000#),
         12140 => (16#FB41#, 16#0020#, 16#0004#),
         12141 => (16#95E8#, 16#0000#, 16#0000#),
         12142 => (16#FB41#, 16#0020#, 16#0004#),
         12143 => (16#961C#, 16#0000#, 16#0000#),
         12144 => (16#0000#, 16#0108#, 16#0004#),
         12145 => (16#FB41#, 16#0020#, 16#0004#),
         12146 => (16#961D#, 16#0000#, 16#0000#),
         12147 => (16#FB41#, 16#0020#, 16#0004#),
         12148 => (16#96E8#, 16#0000#, 16#0000#),
         12149 => (16#0000#, 16#0108#, 16#0004#),
         12150 => (16#FB41#, 16#0020#, 16#0004#),
         12151 => (16#9752#, 16#0000#, 16#0000#),
         12152 => (16#FB41#, 16#0020#, 16#0004#),
         12153 => (16#97E6#, 16#0000#, 16#0000#),
         12154 => (16#FB41#, 16#0020#, 16#0004#),
         12155 => (16#9875#, 16#0000#, 16#0000#),
         12156 => (16#FB41#, 16#0020#, 16#0004#),
         12157 => (16#98CE#, 16#0000#, 16#0000#),
         12158 => (16#FB41#, 16#0020#, 16#0004#),
         12159 => (16#98DE#, 16#0000#, 16#0000#),
         12160 => (16#FB41#, 16#0020#, 16#0004#),
         12161 => (16#98DF#, 16#0000#, 16#0000#),
         12162 => (16#FB41#, 16#0020#, 16#0004#),
         12163 => (16#98E0#, 16#0000#, 16#0000#),
         12164 => (16#0000#, 16#0108#, 16#0004#),
         12165 => (16#FB41#, 16#0020#, 16#0004#),
         12166 => (16#9963#, 16#0000#, 16#0000#),
         12167 => (16#FB41#, 16#0020#, 16#0004#),
         12168 => (16#9996#, 16#0000#, 16#0000#),
         12169 => (16#0000#, 16#0108#, 16#0004#),
         12170 => (16#FB41#, 16#0020#, 16#0004#),
         12171 => (16#9A6C#, 16#0000#, 16#0000#),
         12172 => (16#FB41#, 16#0020#, 16#0004#),
         12173 => (16#9AA8#, 16#0000#, 16#0000#),
         12174 => (16#0000#, 16#0108#, 16#0004#),
         12175 => (16#FB41#, 16#0020#, 16#0004#),
         12176 => (16#9B3C#, 16#0000#, 16#0000#),
         12177 => (16#0000#, 16#0108#, 16#0004#),
         12178 => (16#FB41#, 16#0020#, 16#0004#),
         12179 => (16#9C7C#, 16#0000#, 16#0000#),
         12180 => (16#FB41#, 16#0020#, 16#0004#),
         12181 => (16#9E1F#, 16#0000#, 16#0000#),
         12182 => (16#FB41#, 16#0020#, 16#0004#),
         12183 => (16#9E75#, 16#0000#, 16#0000#),
         12184 => (16#0000#, 16#0108#, 16#0004#),
         12185 => (16#FB41#, 16#0020#, 16#0004#),
         12186 => (16#9EA6#, 16#0000#, 16#0000#),
         12187 => (16#FB41#, 16#0020#, 16#0004#),
         12188 => (16#9EC4#, 16#0000#, 16#0000#),
         12189 => (16#FB41#, 16#0020#, 16#0004#),
         12190 => (16#9EFE#, 16#0000#, 16#0000#),
         12191 => (16#FB41#, 16#0020#, 16#0004#),
         12192 => (16#9F4A#, 16#0000#, 16#0000#),
         12193 => (16#0000#, 16#0108#, 16#0004#),
         12194 => (16#FB41#, 16#0020#, 16#0004#),
         12195 => (16#9F50#, 16#0000#, 16#0000#),
         12196 => (16#FB41#, 16#0020#, 16#0004#),
         12197 => (16#9F52#, 16#0000#, 16#0000#),
         12198 => (16#0000#, 16#0108#, 16#0004#),
         12199 => (16#FB41#, 16#0020#, 16#0004#),
         12200 => (16#9F7F#, 16#0000#, 16#0000#),
         12201 => (16#FB41#, 16#0020#, 16#0004#),
         12202 => (16#9F8D#, 16#0000#, 16#0000#),
         12203 => (16#0000#, 16#0108#, 16#0004#),
         12204 => (16#FB41#, 16#0020#, 16#0004#),
         12205 => (16#9F99#, 16#0000#, 16#0000#),
         12206 => (16#FB41#, 16#0020#, 16#0004#),
         12207 => (16#9F9C#, 16#0000#, 16#0000#),
         12208 => (16#0000#, 16#0108#, 16#0004#),
         12209 => (16#FB41#, 16#0020#, 16#0004#),
         12210 => (16#9F9C#, 16#0000#, 16#0000#),
         12211 => (16#0000#, 16#0109#, 16#0004#),
         12212 => (16#FB41#, 16#0020#, 16#0004#),
         12213 => (16#9F9F#, 16#0000#, 16#0000#),
         12214 => (16#FB40#, 16#0020#, 16#0004#),
         12215 => (16#CE00#, 16#0000#, 16#0000#),
         12216 => (16#FB40#, 16#0020#, 16#0004#),
         12217 => (16#CE28#, 16#0000#, 16#0000#),
         12218 => (16#FB40#, 16#0020#, 16#0004#),
         12219 => (16#CE3F#, 16#0000#, 16#0000#),
         12220 => (16#FB40#, 16#0020#, 16#0004#),
         12221 => (16#CE85#, 16#0000#, 16#0000#),
         12222 => (16#FB40#, 16#0020#, 16#0004#),
         12223 => (16#CE8C#, 16#0000#, 16#0000#),
         12224 => (16#FB40#, 16#0020#, 16#0004#),
         12225 => (16#CEA0#, 16#0000#, 16#0000#),
         12226 => (16#FB40#, 16#0020#, 16#0004#),
         12227 => (16#CEBA#, 16#0000#, 16#0000#),
         12228 => (16#FB40#, 16#0020#, 16#0004#),
         12229 => (16#D13F#, 16#0000#, 16#0000#),
         12230 => (16#FB40#, 16#0020#, 16#0004#),
         12231 => (16#D165#, 16#0000#, 16#0000#),
         12232 => (16#FB40#, 16#0020#, 16#0004#),
         12233 => (16#D16B#, 16#0000#, 16#0000#),
         12234 => (16#FB40#, 16#0020#, 16#0004#),
         12235 => (16#D196#, 16#0000#, 16#0000#),
         12236 => (16#FB40#, 16#0020#, 16#0004#),
         12237 => (16#D1AB#, 16#0000#, 16#0000#),
         12238 => (16#FB40#, 16#0020#, 16#0004#),
         12239 => (16#D1F5#, 16#0000#, 16#0000#),
         12240 => (16#FB40#, 16#0020#, 16#0004#),
         12241 => (16#D29B#, 16#0000#, 16#0000#),
         12242 => (16#FB40#, 16#0020#, 16#0004#),
         12243 => (16#D2F9#, 16#0000#, 16#0000#),
         12244 => (16#FB40#, 16#0020#, 16#0004#),
         12245 => (16#D315#, 16#0000#, 16#0000#),
         12246 => (16#FB40#, 16#0020#, 16#0004#),
         12247 => (16#D31A#, 16#0000#, 16#0000#),
         12248 => (16#FB40#, 16#0020#, 16#0004#),
         12249 => (16#D338#, 16#0000#, 16#0000#),
         12250 => (16#FB40#, 16#0020#, 16#0004#),
         12251 => (16#D341#, 16#0000#, 16#0000#),
         12252 => (16#FB40#, 16#0020#, 16#0004#),
         12253 => (16#D3B6#, 16#0000#, 16#0000#),
         12254 => (16#FB40#, 16#0020#, 16#0004#),
         12255 => (16#D3C8#, 16#0000#, 16#0000#),
         12256 => (16#FB40#, 16#0020#, 16#0004#),
         12257 => (16#D3E3#, 16#0000#, 16#0000#),
         12258 => (16#FB40#, 16#0020#, 16#0004#),
         12259 => (16#D6D7#, 16#0000#, 16#0000#),
         12260 => (16#FB40#, 16#0020#, 16#0004#),
         12261 => (16#D71F#, 16#0000#, 16#0000#),
         12262 => (16#FB40#, 16#0020#, 16#0004#),
         12263 => (16#D8EB#, 16#0000#, 16#0000#),
         12264 => (16#FB40#, 16#0020#, 16#0004#),
         12265 => (16#D902#, 16#0000#, 16#0000#),
         12266 => (16#FB40#, 16#0020#, 16#0004#),
         12267 => (16#D90A#, 16#0000#, 16#0000#),
         12268 => (16#FB40#, 16#0020#, 16#0004#),
         12269 => (16#D915#, 16#0000#, 16#0000#),
         12270 => (16#FB40#, 16#0020#, 16#0004#),
         12271 => (16#D927#, 16#0000#, 16#0000#),
         12272 => (16#FB40#, 16#0020#, 16#0004#),
         12273 => (16#D973#, 16#0000#, 16#0000#),
         12274 => (16#FB40#, 16#0020#, 16#0004#),
         12275 => (16#DB50#, 16#0000#, 16#0000#),
         12276 => (16#FB40#, 16#0020#, 16#0004#),
         12277 => (16#DB80#, 16#0000#, 16#0000#),
         12278 => (16#FB40#, 16#0020#, 16#0004#),
         12279 => (16#DBF8#, 16#0000#, 16#0000#),
         12280 => (16#FB40#, 16#0020#, 16#0004#),
         12281 => (16#DC38#, 16#0000#, 16#0000#),
         12282 => (16#FB40#, 16#0020#, 16#0004#),
         12283 => (16#DC6E#, 16#0000#, 16#0000#),
         12284 => (16#FB40#, 16#0020#, 16#0004#),
         12285 => (16#DC71#, 16#0000#, 16#0000#),
         12286 => (16#FB40#, 16#0020#, 16#0004#),
         12287 => (16#DDDB#, 16#0000#, 16#0000#),
         12288 => (16#FB40#, 16#0020#, 16#0004#),
         12289 => (16#DDE5#, 16#0000#, 16#0000#),
         12290 => (16#FB40#, 16#0020#, 16#0004#),
         12291 => (16#DDF1#, 16#0000#, 16#0000#),
         12292 => (16#FB40#, 16#0020#, 16#0004#),
         12293 => (16#DDFE#, 16#0000#, 16#0000#),
         12294 => (16#FB40#, 16#0020#, 16#0004#),
         12295 => (16#DE72#, 16#0000#, 16#0000#),
         12296 => (16#FB40#, 16#0020#, 16#0004#),
         12297 => (16#DE7F#, 16#0000#, 16#0000#),
         12298 => (16#FB40#, 16#0020#, 16#0004#),
         12299 => (16#DEF4#, 16#0000#, 16#0000#),
         12300 => (16#FB40#, 16#0020#, 16#0004#),
         12301 => (16#DEFE#, 16#0000#, 16#0000#),
         12302 => (16#FB40#, 16#0020#, 16#0004#),
         12303 => (16#DF0B#, 16#0000#, 16#0000#),
         12304 => (16#FB40#, 16#0020#, 16#0004#),
         12305 => (16#DF13#, 16#0000#, 16#0000#),
         12306 => (16#FB40#, 16#0020#, 16#0004#),
         12307 => (16#DF61#, 16#0000#, 16#0000#),
         12308 => (16#FB40#, 16#0020#, 16#0004#),
         12309 => (16#DF73#, 16#0000#, 16#0000#),
         12310 => (16#FB40#, 16#0020#, 16#0004#),
         12311 => (16#E208#, 16#0000#, 16#0000#),
         12312 => (16#FB40#, 16#0020#, 16#0004#),
         12313 => (16#E236#, 16#0000#, 16#0000#),
         12314 => (16#FB40#, 16#0020#, 16#0004#),
         12315 => (16#E24B#, 16#0000#, 16#0000#),
         12316 => (16#FB40#, 16#0020#, 16#0004#),
         12317 => (16#E52F#, 16#0000#, 16#0000#),
         12318 => (16#FB40#, 16#0020#, 16#0004#),
         12319 => (16#E534#, 16#0000#, 16#0000#),
         12320 => (16#FB40#, 16#0020#, 16#0004#),
         12321 => (16#E587#, 16#0000#, 16#0000#),
         12322 => (16#FB40#, 16#0020#, 16#0004#),
         12323 => (16#E597#, 16#0000#, 16#0000#),
         12324 => (16#FB40#, 16#0020#, 16#0004#),
         12325 => (16#E5A4#, 16#0000#, 16#0000#),
         12326 => (16#FB40#, 16#0020#, 16#0004#),
         12327 => (16#E5B9#, 16#0000#, 16#0000#),
         12328 => (16#FB40#, 16#0020#, 16#0004#),
         12329 => (16#E5E0#, 16#0000#, 16#0000#),
         12330 => (16#FB40#, 16#0020#, 16#0004#),
         12331 => (16#E6F0#, 16#0000#, 16#0000#),
         12332 => (16#FB40#, 16#0020#, 16#0004#),
         12333 => (16#E728#, 16#0000#, 16#0000#),
         12334 => (16#FB40#, 16#0020#, 16#0004#),
         12335 => (16#EB20#, 16#0000#, 16#0000#),
         12336 => (16#FB40#, 16#0020#, 16#0004#),
         12337 => (16#EB62#, 16#0000#, 16#0000#),
         12338 => (16#FB40#, 16#0020#, 16#0004#),
         12339 => (16#EB79#, 16#0000#, 16#0000#),
         12340 => (16#FB40#, 16#0020#, 16#0004#),
         12341 => (16#EBB3#, 16#0000#, 16#0000#),
         12342 => (16#FB40#, 16#0020#, 16#0004#),
         12343 => (16#EBCB#, 16#0000#, 16#0000#),
         12344 => (16#FB40#, 16#0020#, 16#0004#),
         12345 => (16#EBD4#, 16#0000#, 16#0000#),
         12346 => (16#FB40#, 16#0020#, 16#0004#),
         12347 => (16#EBDB#, 16#0000#, 16#0000#),
         12348 => (16#FB40#, 16#0020#, 16#0004#),
         12349 => (16#EC0F#, 16#0000#, 16#0000#),
         12350 => (16#FB40#, 16#0020#, 16#0004#),
         12351 => (16#EC14#, 16#0000#, 16#0000#),
         12352 => (16#FB40#, 16#0020#, 16#0004#),
         12353 => (16#EC34#, 16#0000#, 16#0000#),
         12354 => (16#FB40#, 16#0020#, 16#0004#),
         12355 => (16#F06B#, 16#0000#, 16#0000#),
         12356 => (16#FB40#, 16#0020#, 16#0004#),
         12357 => (16#F22A#, 16#0000#, 16#0000#),
         12358 => (16#FB40#, 16#0020#, 16#0004#),
         12359 => (16#F236#, 16#0000#, 16#0000#),
         12360 => (16#FB40#, 16#0020#, 16#0004#),
         12361 => (16#F23B#, 16#0000#, 16#0000#),
         12362 => (16#FB40#, 16#0020#, 16#0004#),
         12363 => (16#F23F#, 16#0000#, 16#0000#),
         12364 => (16#FB40#, 16#0020#, 16#0004#),
         12365 => (16#F247#, 16#0000#, 16#0000#),
         12366 => (16#FB40#, 16#0020#, 16#0004#),
         12367 => (16#F259#, 16#0000#, 16#0000#),
         12368 => (16#FB40#, 16#0020#, 16#0004#),
         12369 => (16#F2AC#, 16#0000#, 16#0000#),
         12370 => (16#FB40#, 16#0020#, 16#0004#),
         12371 => (16#F384#, 16#0000#, 16#0000#),
         12372 => (16#FB40#, 16#0020#, 16#0004#),
         12373 => (16#F389#, 16#0000#, 16#0000#),
         12374 => (16#FB40#, 16#0020#, 16#0004#),
         12375 => (16#F4DC#, 16#0000#, 16#0000#),
         12376 => (16#FB40#, 16#0020#, 16#0004#),
         12377 => (16#F4E6#, 16#0000#, 16#0000#),
         12378 => (16#FB40#, 16#0020#, 16#0004#),
         12379 => (16#F518#, 16#0000#, 16#0000#),
         12380 => (16#FB40#, 16#0020#, 16#0004#),
         12381 => (16#F51F#, 16#0000#, 16#0000#),
         12382 => (16#FB40#, 16#0020#, 16#0004#),
         12383 => (16#F528#, 16#0000#, 16#0000#),
         12384 => (16#FB40#, 16#0020#, 16#0004#),
         12385 => (16#F530#, 16#0000#, 16#0000#),
         12386 => (16#FB40#, 16#0020#, 16#0004#),
         12387 => (16#F592#, 16#0000#, 16#0000#),
         12388 => (16#FB40#, 16#0020#, 16#0004#),
         12389 => (16#F676#, 16#0000#, 16#0000#),
         12390 => (16#FB40#, 16#0020#, 16#0004#),
         12391 => (16#F67D#, 16#0000#, 16#0000#),
         12392 => (16#FB40#, 16#0020#, 16#0004#),
         12393 => (16#F6AE#, 16#0000#, 16#0000#),
         12394 => (16#FB40#, 16#0020#, 16#0004#),
         12395 => (16#F6BF#, 16#0000#, 16#0000#),
         12396 => (16#FB40#, 16#0020#, 16#0004#),
         12397 => (16#F7DB#, 16#0000#, 16#0000#),
         12398 => (16#FB40#, 16#0020#, 16#0004#),
         12399 => (16#F7E2#, 16#0000#, 16#0000#),
         12400 => (16#FB40#, 16#0020#, 16#0004#),
         12401 => (16#F7F3#, 16#0000#, 16#0000#),
         12402 => (16#FB40#, 16#0020#, 16#0004#),
         12403 => (16#F9B8#, 16#0000#, 16#0000#),
         12404 => (16#FB40#, 16#0020#, 16#0004#),
         12405 => (16#F9BE#, 16#0000#, 16#0000#),
         12406 => (16#FB40#, 16#0020#, 16#0004#),
         12407 => (16#FA74#, 16#0000#, 16#0000#),
         12408 => (16#FB40#, 16#0020#, 16#0004#),
         12409 => (16#FACB#, 16#0000#, 16#0000#),
         12410 => (16#FB40#, 16#0020#, 16#0004#),
         12411 => (16#FC73#, 16#0000#, 16#0000#),
         12412 => (16#FB40#, 16#0020#, 16#0004#),
         12413 => (16#FCF8#, 16#0000#, 16#0000#),
         12414 => (16#FB40#, 16#0020#, 16#0004#),
         12415 => (16#FF36#, 16#0000#, 16#0000#),
         12416 => (16#FB40#, 16#0020#, 16#0004#),
         12417 => (16#FF51#, 16#0000#, 16#0000#),
         12418 => (16#FB40#, 16#0020#, 16#0004#),
         12419 => (16#FFBD#, 16#0000#, 16#0000#),
         12420 => (16#FB41#, 16#0020#, 16#0004#),
         12421 => (16#8001#, 16#0000#, 16#0000#),
         12422 => (16#FB41#, 16#0020#, 16#0004#),
         12423 => (16#800C#, 16#0000#, 16#0000#),
         12424 => (16#FB41#, 16#0020#, 16#0004#),
         12425 => (16#8012#, 16#0000#, 16#0000#),
         12426 => (16#FB41#, 16#0020#, 16#0004#),
         12427 => (16#8033#, 16#0000#, 16#0000#),
         12428 => (16#FB41#, 16#0020#, 16#0004#),
         12429 => (16#81E3#, 16#0000#, 16#0000#),
         12430 => (16#FB41#, 16#0020#, 16#0004#),
         12431 => (16#81EA#, 16#0000#, 16#0000#),
         12432 => (16#FB41#, 16#0020#, 16#0004#),
         12433 => (16#81F3#, 16#0000#, 16#0000#),
         12434 => (16#FB41#, 16#0020#, 16#0004#),
         12435 => (16#820C#, 16#0000#, 16#0000#),
         12436 => (16#FB41#, 16#0020#, 16#0004#),
         12437 => (16#821B#, 16#0000#, 16#0000#),
         12438 => (16#FB41#, 16#0020#, 16#0004#),
         12439 => (16#821F#, 16#0000#, 16#0000#),
         12440 => (16#FB41#, 16#0020#, 16#0004#),
         12441 => (16#826E#, 16#0000#, 16#0000#),
         12442 => (16#FB41#, 16#0020#, 16#0004#),
         12443 => (16#8272#, 16#0000#, 16#0000#),
         12444 => (16#FB41#, 16#0020#, 16#0004#),
         12445 => (16#8278#, 16#0000#, 16#0000#),
         12446 => (16#FB41#, 16#0020#, 16#0004#),
         12447 => (16#864D#, 16#0000#, 16#0000#),
         12448 => (16#FB41#, 16#0020#, 16#0004#),
         12449 => (16#866B#, 16#0000#, 16#0000#),
         12450 => (16#FB41#, 16#0020#, 16#0004#),
         12451 => (16#8840#, 16#0000#, 16#0000#),
         12452 => (16#FB41#, 16#0020#, 16#0004#),
         12453 => (16#884C#, 16#0000#, 16#0000#),
         12454 => (16#FB41#, 16#0020#, 16#0004#),
         12455 => (16#8863#, 16#0000#, 16#0000#),
         12456 => (16#FB41#, 16#0020#, 16#0004#),
         12457 => (16#897E#, 16#0000#, 16#0000#),
         12458 => (16#FB41#, 16#0020#, 16#0004#),
         12459 => (16#898B#, 16#0000#, 16#0000#),
         12460 => (16#FB41#, 16#0020#, 16#0004#),
         12461 => (16#8A00#, 16#0000#, 16#0000#),
         12462 => (16#FB41#, 16#0020#, 16#0004#),
         12463 => (16#8C37#, 16#0000#, 16#0000#),
         12464 => (16#FB41#, 16#0020#, 16#0004#),
         12465 => (16#8C46#, 16#0000#, 16#0000#),
         12466 => (16#FB41#, 16#0020#, 16#0004#),
         12467 => (16#8C55#, 16#0000#, 16#0000#),
         12468 => (16#FB41#, 16#0020#, 16#0004#),
         12469 => (16#8C78#, 16#0000#, 16#0000#),
         12470 => (16#FB41#, 16#0020#, 16#0004#),
         12471 => (16#8C9D#, 16#0000#, 16#0000#),
         12472 => (16#FB41#, 16#0020#, 16#0004#),
         12473 => (16#8D64#, 16#0000#, 16#0000#),
         12474 => (16#FB41#, 16#0020#, 16#0004#),
         12475 => (16#8D70#, 16#0000#, 16#0000#),
         12476 => (16#FB41#, 16#0020#, 16#0004#),
         12477 => (16#8EAB#, 16#0000#, 16#0000#),
         12478 => (16#FB41#, 16#0020#, 16#0004#),
         12479 => (16#8ECA#, 16#0000#, 16#0000#),
         12480 => (16#FB41#, 16#0020#, 16#0004#),
         12481 => (16#8F9B#, 16#0000#, 16#0000#),
         12482 => (16#FB41#, 16#0020#, 16#0004#),
         12483 => (16#8FB0#, 16#0000#, 16#0000#),
         12484 => (16#FB41#, 16#0020#, 16#0004#),
         12485 => (16#8FB5#, 16#0000#, 16#0000#),
         12486 => (16#FB41#, 16#0020#, 16#0004#),
         12487 => (16#9149#, 16#0000#, 16#0000#),
         12488 => (16#FB41#, 16#0020#, 16#0004#),
         12489 => (16#91C6#, 16#0000#, 16#0000#),
         12490 => (16#FB41#, 16#0020#, 16#0004#),
         12491 => (16#91CC#, 16#0000#, 16#0000#),
         12492 => (16#FB41#, 16#0020#, 16#0004#),
         12493 => (16#91D1#, 16#0000#, 16#0000#),
         12494 => (16#FB41#, 16#0020#, 16#0004#),
         12495 => (16#9580#, 16#0000#, 16#0000#),
         12496 => (16#FB41#, 16#0020#, 16#0004#),
         12497 => (16#96B6#, 16#0000#, 16#0000#),
         12498 => (16#FB41#, 16#0020#, 16#0004#),
         12499 => (16#96B9#, 16#0000#, 16#0000#),
         12500 => (16#FB41#, 16#0020#, 16#0004#),
         12501 => (16#9751#, 16#0000#, 16#0000#),
         12502 => (16#FB41#, 16#0020#, 16#0004#),
         12503 => (16#975E#, 16#0000#, 16#0000#),
         12504 => (16#FB41#, 16#0020#, 16#0004#),
         12505 => (16#9762#, 16#0000#, 16#0000#),
         12506 => (16#FB41#, 16#0020#, 16#0004#),
         12507 => (16#9769#, 16#0000#, 16#0000#),
         12508 => (16#FB41#, 16#0020#, 16#0004#),
         12509 => (16#97CB#, 16#0000#, 16#0000#),
         12510 => (16#FB41#, 16#0020#, 16#0004#),
         12511 => (16#97ED#, 16#0000#, 16#0000#),
         12512 => (16#FB41#, 16#0020#, 16#0004#),
         12513 => (16#97F3#, 16#0000#, 16#0000#),
         12514 => (16#FB41#, 16#0020#, 16#0004#),
         12515 => (16#9801#, 16#0000#, 16#0000#),
         12516 => (16#FB41#, 16#0020#, 16#0004#),
         12517 => (16#98A8#, 16#0000#, 16#0000#),
         12518 => (16#FB41#, 16#0020#, 16#0004#),
         12519 => (16#98DB#, 16#0000#, 16#0000#),
         12520 => (16#FB41#, 16#0020#, 16#0004#),
         12521 => (16#9999#, 16#0000#, 16#0000#),
         12522 => (16#FB41#, 16#0020#, 16#0004#),
         12523 => (16#99AC#, 16#0000#, 16#0000#),
         12524 => (16#FB41#, 16#0020#, 16#0004#),
         12525 => (16#9AD8#, 16#0000#, 16#0000#),
         12526 => (16#FB41#, 16#0020#, 16#0004#),
         12527 => (16#9ADF#, 16#0000#, 16#0000#),
         12528 => (16#FB41#, 16#0020#, 16#0004#),
         12529 => (16#9B25#, 16#0000#, 16#0000#),
         12530 => (16#FB41#, 16#0020#, 16#0004#),
         12531 => (16#9B2F#, 16#0000#, 16#0000#),
         12532 => (16#FB41#, 16#0020#, 16#0004#),
         12533 => (16#9B32#, 16#0000#, 16#0000#),
         12534 => (16#FB41#, 16#0020#, 16#0004#),
         12535 => (16#9B5A#, 16#0000#, 16#0000#),
         12536 => (16#FB41#, 16#0020#, 16#0004#),
         12537 => (16#9CE5#, 16#0000#, 16#0000#),
         12538 => (16#FB41#, 16#0020#, 16#0004#),
         12539 => (16#9E7F#, 16#0000#, 16#0000#),
         12540 => (16#FB41#, 16#0020#, 16#0004#),
         12541 => (16#9EA5#, 16#0000#, 16#0000#),
         12542 => (16#FB41#, 16#0020#, 16#0004#),
         12543 => (16#9EBB#, 16#0000#, 16#0000#),
         12544 => (16#FB41#, 16#0020#, 16#0004#),
         12545 => (16#9EC3#, 16#0000#, 16#0000#),
         12546 => (16#FB41#, 16#0020#, 16#0004#),
         12547 => (16#9ECD#, 16#0000#, 16#0000#),
         12548 => (16#FB41#, 16#0020#, 16#0004#),
         12549 => (16#9ED1#, 16#0000#, 16#0000#),
         12550 => (16#FB41#, 16#0020#, 16#0004#),
         12551 => (16#9EF9#, 16#0000#, 16#0000#),
         12552 => (16#FB41#, 16#0020#, 16#0004#),
         12553 => (16#9EFD#, 16#0000#, 16#0000#),
         12554 => (16#FB41#, 16#0020#, 16#0004#),
         12555 => (16#9F0E#, 16#0000#, 16#0000#),
         12556 => (16#FB41#, 16#0020#, 16#0004#),
         12557 => (16#9F13#, 16#0000#, 16#0000#),
         12558 => (16#FB41#, 16#0020#, 16#0004#),
         12559 => (16#9F20#, 16#0000#, 16#0000#),
         12560 => (16#FB41#, 16#0020#, 16#0004#),
         12561 => (16#9F3B#, 16#0000#, 16#0000#),
         12562 => (16#FB41#, 16#0020#, 16#0004#),
         12563 => (16#9FA0#, 16#0000#, 16#0000#),
         12564 => (16#1676#, 16#0020#, 16#0002#),
         12565 => (16#1677#, 16#0020#, 16#0002#),
         12566 => (16#1678#, 16#0020#, 16#0002#),
         12567 => (16#1679#, 16#0020#, 16#0002#),
         12568 => (16#167A#, 16#0020#, 16#0002#),
         12569 => (16#167B#, 16#0020#, 16#0002#),
         12570 => (16#167C#, 16#0020#, 16#0002#),
         12571 => (16#167D#, 16#0020#, 16#0002#),
         12572 => (16#167E#, 16#0020#, 16#0002#),
         12573 => (16#167F#, 16#0020#, 16#0002#),
         12574 => (16#1680#, 16#0020#, 16#0002#),
         12575 => (16#1681#, 16#0020#, 16#0002#),
         12576 => (16#0108#, 16#0020#, 16#0003#),
         12577 => (16#012F#, 16#0020#, 16#0002#),
         12578 => (16#0186#, 16#0020#, 16#0002#),
         12579 => (16#029E#, 16#0020#, 16#0002#),
         12580 => (16#16A6#, 16#0020#, 16#0002#),
         12581 => (16#16C0#, 16#0020#, 16#0002#),
         12582 => (16#3894#, 16#0020#, 16#0004#),
         12583 => (16#38AA#, 16#0020#, 16#0004#),
         12584 => (16#0263#, 16#0020#, 16#0002#),
         12585 => (16#0264#, 16#0020#, 16#0002#),
         12586 => (16#0265#, 16#0020#, 16#0002#),
         12587 => (16#0266#, 16#0020#, 16#0002#),
         12588 => (16#0267#, 16#0020#, 16#0002#),
         12589 => (16#0268#, 16#0020#, 16#0002#),
         12590 => (16#0269#, 16#0020#, 16#0002#),
         12591 => (16#026A#, 16#0020#, 16#0002#),
         12592 => (16#16A7#, 16#0020#, 16#0002#),
         12593 => (16#16A8#, 16#0020#, 16#0002#),
         12594 => (16#026B#, 16#0020#, 16#0002#),
         12595 => (16#026C#, 16#0020#, 16#0002#),
         12596 => (16#026D#, 16#0020#, 16#0002#),
         12597 => (16#026E#, 16#0020#, 16#0002#),
         12598 => (16#026F#, 16#0020#, 16#0002#),
         12599 => (16#0270#, 16#0020#, 16#0002#),
         12600 => (16#0271#, 16#0020#, 16#0002#),
         12601 => (16#0272#, 16#0020#, 16#0002#),
         12602 => (16#011C#, 16#0020#, 16#0002#),
         12603 => (16#0204#, 16#0020#, 16#0002#),
         12604 => (16#0205#, 16#0020#, 16#0002#),
         12605 => (16#0206#, 16#0020#, 16#0002#),
         12606 => (16#16A9#, 16#0020#, 16#0002#),
         12607 => (16#0000#, 16#00F3#, 16#0002#),
         12608 => (16#0000#, 16#00F4#, 16#0002#),
         12609 => (16#0000#, 16#00F5#, 16#0002#),
         12610 => (16#0000#, 16#00F6#, 16#0002#),
         12611 => (16#0000#, 16#00F7#, 16#0002#),
         12612 => (16#0000#, 16#00F8#, 16#0002#),
         12613 => (16#011D#, 16#0020#, 16#0002#),
         12614 => (16#16C2#, 16#0020#, 16#0002#),
         12615 => (16#16C2#, 16#0020#, 16#0002#),
         12616 => (16#0000#, 16#0037#, 16#0002#),
         12617 => (16#16C3#, 16#0020#, 16#0002#),
         12618 => (16#16C3#, 16#0020#, 16#0002#),
         12619 => (16#0000#, 16#0037#, 16#0002#),
         12620 => (16#16C4#, 16#0020#, 16#0002#),
         12621 => (16#16A7#, 16#0020#, 16#0004#),
         12622 => (16#16AA#, 16#0020#, 16#0002#),
         12623 => (16#FB40#, 16#0020#, 16#0004#),
         12624 => (16#D344#, 16#0000#, 16#0000#),
         12625 => (16#FB40#, 16#0020#, 16#0004#),
         12626 => (16#D345#, 16#0000#, 16#0000#),
         12627 => (16#16C1#, 16#0020#, 16#0002#),
         12628 => (16#38A7#, 16#0020#, 16#0004#),
         12629 => (16#3895#, 16#0020#, 16#0004#),
         12630 => (16#029F#, 16#0020#, 16#0002#),
         12631 => (16#16AB#, 16#0020#, 16#0002#),
         12632 => (16#16AC#, 16#0020#, 16#0002#),
         12633 => (16#3888#, 16#0020#, 16#000D#),
         12634 => (16#3888#, 16#0020#, 16#000E#),
         12635 => (16#3889#, 16#0020#, 16#000D#),
         12636 => (16#3889#, 16#0020#, 16#000E#),
         12637 => (16#388A#, 16#0020#, 16#000D#),
         12638 => (16#388A#, 16#0020#, 16#000E#),
         12639 => (16#388C#, 16#0020#, 16#000D#),
         12640 => (16#388C#, 16#0020#, 16#000E#),
         12641 => (16#388D#, 16#0020#, 16#000D#),
         12642 => (16#388D#, 16#0020#, 16#000E#),
         12643 => (16#388E#, 16#0020#, 16#000E#),
         12644 => (16#388E#, 16#0020#, 16#000E#),
         12645 => (16#0000#, 16#0037#, 16#0002#),
         12646 => (16#388F#, 16#0020#, 16#000E#),
         12647 => (16#388F#, 16#0020#, 16#000E#),
         12648 => (16#0000#, 16#0037#, 16#0002#),
         12649 => (16#3890#, 16#0020#, 16#000E#),
         12650 => (16#3890#, 16#0020#, 16#000E#),
         12651 => (16#0000#, 16#0037#, 16#0002#),
         12652 => (16#3891#, 16#0020#, 16#000E#),
         12653 => (16#3891#, 16#0020#, 16#000E#),
         12654 => (16#0000#, 16#0037#, 16#0002#),
         12655 => (16#3892#, 16#0020#, 16#000E#),
         12656 => (16#3892#, 16#0020#, 16#000E#),
         12657 => (16#0000#, 16#0037#, 16#0002#),
         12658 => (16#3893#, 16#0020#, 16#000E#),
         12659 => (16#3893#, 16#0020#, 16#000E#),
         12660 => (16#0000#, 16#0037#, 16#0002#),
         12661 => (16#3894#, 16#0020#, 16#000E#),
         12662 => (16#3894#, 16#0020#, 16#000E#),
         12663 => (16#0000#, 16#0037#, 16#0002#),
         12664 => (16#3895#, 16#0020#, 16#000E#),
         12665 => (16#3895#, 16#0020#, 16#000E#),
         12666 => (16#0000#, 16#0037#, 16#0002#),
         12667 => (16#3896#, 16#0020#, 16#000E#),
         12668 => (16#3896#, 16#0020#, 16#000E#),
         12669 => (16#0000#, 16#0037#, 16#0002#),
         12670 => (16#3897#, 16#0020#, 16#000E#),
         12671 => (16#3897#, 16#0020#, 16#000E#),
         12672 => (16#0000#, 16#0037#, 16#0002#),
         12673 => (16#3898#, 16#0020#, 16#000E#),
         12674 => (16#3898#, 16#0020#, 16#000E#),
         12675 => (16#0000#, 16#0037#, 16#0002#),
         12676 => (16#3899#, 16#0020#, 16#000E#),
         12677 => (16#3899#, 16#0020#, 16#000E#),
         12678 => (16#0000#, 16#0037#, 16#0002#),
         12679 => (16#389A#, 16#0020#, 16#000D#),
         12680 => (16#389A#, 16#0020#, 16#000E#),
         12681 => (16#389A#, 16#0020#, 16#000E#),
         12682 => (16#0000#, 16#0037#, 16#0002#),
         12683 => (16#389B#, 16#0020#, 16#000E#),
         12684 => (16#389B#, 16#0020#, 16#000E#),
         12685 => (16#0000#, 16#0037#, 16#0002#),
         12686 => (16#389C#, 16#0020#, 16#000E#),
         12687 => (16#389C#, 16#0020#, 16#000E#),
         12688 => (16#0000#, 16#0037#, 16#0002#),
         12689 => (16#389D#, 16#0020#, 16#000E#),
         12690 => (16#389E#, 16#0020#, 16#000E#),
         12691 => (16#389F#, 16#0020#, 16#000E#),
         12692 => (16#38A0#, 16#0020#, 16#000E#),
         12693 => (16#38A1#, 16#0020#, 16#000E#),
         12694 => (16#38A2#, 16#0020#, 16#000E#),
         12695 => (16#38A2#, 16#0020#, 16#000E#),
         12696 => (16#0000#, 16#0037#, 16#0002#),
         12697 => (16#38A2#, 16#0020#, 16#000E#),
         12698 => (16#0000#, 16#0038#, 16#0002#),
         12699 => (16#38A3#, 16#0020#, 16#000E#),
         12700 => (16#38A3#, 16#0020#, 16#000E#),
         12701 => (16#0000#, 16#0037#, 16#0002#),
         12702 => (16#38A3#, 16#0020#, 16#000E#),
         12703 => (16#0000#, 16#0038#, 16#0002#),
         12704 => (16#38A4#, 16#0020#, 16#000E#),
         12705 => (16#38A4#, 16#0020#, 16#000E#),
         12706 => (16#0000#, 16#0037#, 16#0002#),
         12707 => (16#38A4#, 16#0020#, 16#000E#),
         12708 => (16#0000#, 16#0038#, 16#0002#),
         12709 => (16#38A5#, 16#0020#, 16#000E#),
         12710 => (16#38A5#, 16#0020#, 16#000E#),
         12711 => (16#0000#, 16#0037#, 16#0002#),
         12712 => (16#38A5#, 16#0020#, 16#000E#),
         12713 => (16#0000#, 16#0038#, 16#0002#),
         12714 => (16#38A6#, 16#0020#, 16#000E#),
         12715 => (16#38A6#, 16#0020#, 16#000E#),
         12716 => (16#0000#, 16#0037#, 16#0002#),
         12717 => (16#38A6#, 16#0020#, 16#000E#),
         12718 => (16#0000#, 16#0038#, 16#0002#),
         12719 => (16#38A7#, 16#0020#, 16#000E#),
         12720 => (16#38A8#, 16#0020#, 16#000E#),
         12721 => (16#38A9#, 16#0020#, 16#000E#),
         12722 => (16#38AA#, 16#0020#, 16#000E#),
         12723 => (16#38AB#, 16#0020#, 16#000E#),
         12724 => (16#38AC#, 16#0020#, 16#000D#),
         12725 => (16#38AC#, 16#0020#, 16#000E#),
         12726 => (16#38AD#, 16#0020#, 16#000D#),
         12727 => (16#38AD#, 16#0020#, 16#000E#),
         12728 => (16#38AF#, 16#0020#, 16#000D#),
         12729 => (16#38AF#, 16#0020#, 16#000E#),
         12730 => (16#38B0#, 16#0020#, 16#000E#),
         12731 => (16#38B1#, 16#0020#, 16#000E#),
         12732 => (16#38B2#, 16#0020#, 16#000E#),
         12733 => (16#38B3#, 16#0020#, 16#000E#),
         12734 => (16#38B4#, 16#0020#, 16#000E#),
         12735 => (16#38B5#, 16#0020#, 16#000D#),
         12736 => (16#38B5#, 16#0020#, 16#000E#),
         12737 => (16#38B6#, 16#0020#, 16#000E#),
         12738 => (16#38B7#, 16#0020#, 16#000E#),
         12739 => (16#38B8#, 16#0020#, 16#000E#),
         12740 => (16#38B9#, 16#0020#, 16#000E#),
         12741 => (16#388A#, 16#0020#, 16#000E#),
         12742 => (16#0000#, 16#0037#, 16#0002#),
         12743 => (16#388E#, 16#0020#, 16#000D#),
         12744 => (16#3891#, 16#0020#, 16#000D#),
         12745 => (16#0355#, 16#0020#, 16#0002#),
         12746 => (16#0356#, 16#0020#, 16#0002#),
         12747 => (16#16C5#, 16#0020#, 16#0002#),
         12748 => (16#16C5#, 16#0020#, 16#0002#),
         12749 => (16#0000#, 16#0037#, 16#0002#),
         12750 => (16#38AF#, 16#0020#, 16#0016#),
         12751 => (16#38B1#, 16#0020#, 16#0016#),
         12752 => (16#011E#, 16#0020#, 16#0002#),
         12753 => (16#3888#, 16#0020#, 16#000F#),
         12754 => (16#3888#, 16#0020#, 16#0011#),
         12755 => (16#3889#, 16#0020#, 16#000F#),
         12756 => (16#3889#, 16#0020#, 16#0011#),
         12757 => (16#388A#, 16#0020#, 16#000F#),
         12758 => (16#388A#, 16#0020#, 16#0011#),
         12759 => (16#388C#, 16#0020#, 16#000F#),
         12760 => (16#388C#, 16#0020#, 16#0011#),
         12761 => (16#388D#, 16#0020#, 16#000F#),
         12762 => (16#388D#, 16#0020#, 16#0011#),
         12763 => (16#388E#, 16#0020#, 16#0011#),
         12764 => (16#388E#, 16#0020#, 16#0011#),
         12765 => (16#0000#, 16#0037#, 16#0002#),
         12766 => (16#388F#, 16#0020#, 16#0011#),
         12767 => (16#388F#, 16#0020#, 16#0011#),
         12768 => (16#0000#, 16#0037#, 16#0002#),
         12769 => (16#3890#, 16#0020#, 16#0011#),
         12770 => (16#3890#, 16#0020#, 16#0011#),
         12771 => (16#0000#, 16#0037#, 16#0002#),
         12772 => (16#3891#, 16#0020#, 16#0011#),
         12773 => (16#3891#, 16#0020#, 16#0011#),
         12774 => (16#0000#, 16#0037#, 16#0002#),
         12775 => (16#3892#, 16#0020#, 16#0011#),
         12776 => (16#3892#, 16#0020#, 16#0011#),
         12777 => (16#0000#, 16#0037#, 16#0002#),
         12778 => (16#3893#, 16#0020#, 16#0011#),
         12779 => (16#3893#, 16#0020#, 16#0011#),
         12780 => (16#0000#, 16#0037#, 16#0002#),
         12781 => (16#3894#, 16#0020#, 16#0011#),
         12782 => (16#3894#, 16#0020#, 16#0011#),
         12783 => (16#0000#, 16#0037#, 16#0002#),
         12784 => (16#3895#, 16#0020#, 16#0011#),
         12785 => (16#3895#, 16#0020#, 16#0011#),
         12786 => (16#0000#, 16#0037#, 16#0002#),
         12787 => (16#3896#, 16#0020#, 16#0011#),
         12788 => (16#3896#, 16#0020#, 16#0011#),
         12789 => (16#0000#, 16#0037#, 16#0002#),
         12790 => (16#3897#, 16#0020#, 16#0011#),
         12791 => (16#3897#, 16#0020#, 16#0011#),
         12792 => (16#0000#, 16#0037#, 16#0002#),
         12793 => (16#3898#, 16#0020#, 16#0011#),
         12794 => (16#3898#, 16#0020#, 16#0011#),
         12795 => (16#0000#, 16#0037#, 16#0002#),
         12796 => (16#3899#, 16#0020#, 16#0011#),
         12797 => (16#3899#, 16#0020#, 16#0011#),
         12798 => (16#0000#, 16#0037#, 16#0002#),
         12799 => (16#389A#, 16#0020#, 16#000F#),
         12800 => (16#389A#, 16#0020#, 16#0011#),
         12801 => (16#389A#, 16#0020#, 16#0011#),
         12802 => (16#0000#, 16#0037#, 16#0002#),
         12803 => (16#389B#, 16#0020#, 16#0011#),
         12804 => (16#389B#, 16#0020#, 16#0011#),
         12805 => (16#0000#, 16#0037#, 16#0002#),
         12806 => (16#389C#, 16#0020#, 16#0011#),
         12807 => (16#389C#, 16#0020#, 16#0011#),
         12808 => (16#0000#, 16#0037#, 16#0002#),
         12809 => (16#389D#, 16#0020#, 16#0011#),
         12810 => (16#389E#, 16#0020#, 16#0011#),
         12811 => (16#389F#, 16#0020#, 16#0011#),
         12812 => (16#38A0#, 16#0020#, 16#0011#),
         12813 => (16#38A1#, 16#0020#, 16#0011#),
         12814 => (16#38A2#, 16#0020#, 16#0011#),
         12815 => (16#38A2#, 16#0020#, 16#0011#),
         12816 => (16#0000#, 16#0037#, 16#0002#),
         12817 => (16#38A2#, 16#0020#, 16#0011#),
         12818 => (16#0000#, 16#0038#, 16#0002#),
         12819 => (16#38A3#, 16#0020#, 16#0011#),
         12820 => (16#38A3#, 16#0020#, 16#0011#),
         12821 => (16#0000#, 16#0037#, 16#0002#),
         12822 => (16#38A3#, 16#0020#, 16#0011#),
         12823 => (16#0000#, 16#0038#, 16#0002#),
         12824 => (16#38A4#, 16#0020#, 16#0011#),
         12825 => (16#38A4#, 16#0020#, 16#0011#),
         12826 => (16#0000#, 16#0037#, 16#0002#),
         12827 => (16#38A4#, 16#0020#, 16#0011#),
         12828 => (16#0000#, 16#0038#, 16#0002#),
         12829 => (16#38A5#, 16#0020#, 16#0011#),
         12830 => (16#38A5#, 16#0020#, 16#0011#),
         12831 => (16#0000#, 16#0037#, 16#0002#),
         12832 => (16#38A5#, 16#0020#, 16#0011#),
         12833 => (16#0000#, 16#0038#, 16#0002#),
         12834 => (16#38A6#, 16#0020#, 16#0011#),
         12835 => (16#38A6#, 16#0020#, 16#0011#),
         12836 => (16#0000#, 16#0037#, 16#0002#),
         12837 => (16#38A6#, 16#0020#, 16#0011#),
         12838 => (16#0000#, 16#0038#, 16#0002#),
         12839 => (16#38A7#, 16#0020#, 16#0011#),
         12840 => (16#38A8#, 16#0020#, 16#0011#),
         12841 => (16#38A9#, 16#0020#, 16#0011#),
         12842 => (16#38AA#, 16#0020#, 16#0011#),
         12843 => (16#38AB#, 16#0020#, 16#0011#),
         12844 => (16#38AC#, 16#0020#, 16#000F#),
         12845 => (16#38AC#, 16#0020#, 16#0011#),
         12846 => (16#38AD#, 16#0020#, 16#000F#),
         12847 => (16#38AD#, 16#0020#, 16#0011#),
         12848 => (16#38AF#, 16#0020#, 16#000F#),
         12849 => (16#38AF#, 16#0020#, 16#0011#),
         12850 => (16#38B0#, 16#0020#, 16#0011#),
         12851 => (16#38B1#, 16#0020#, 16#0011#),
         12852 => (16#38B2#, 16#0020#, 16#0011#),
         12853 => (16#38B3#, 16#0020#, 16#0011#),
         12854 => (16#38B4#, 16#0020#, 16#0011#),
         12855 => (16#38B5#, 16#0020#, 16#000F#),
         12856 => (16#38B5#, 16#0020#, 16#0011#),
         12857 => (16#38B6#, 16#0020#, 16#0011#),
         12858 => (16#38B7#, 16#0020#, 16#0011#),
         12859 => (16#38B8#, 16#0020#, 16#0011#),
         12860 => (16#38B9#, 16#0020#, 16#0011#),
         12861 => (16#388A#, 16#0020#, 16#0011#),
         12862 => (16#0000#, 16#0037#, 16#0002#),
         12863 => (16#388E#, 16#0020#, 16#000F#),
         12864 => (16#3891#, 16#0020#, 16#000F#),
         12865 => (16#38B5#, 16#0020#, 16#0011#),
         12866 => (16#0000#, 16#0037#, 16#0002#),
         12867 => (16#38B6#, 16#0020#, 16#0011#),
         12868 => (16#0000#, 16#0037#, 16#0002#),
         12869 => (16#38B7#, 16#0020#, 16#0011#),
         12870 => (16#0000#, 16#0037#, 16#0002#),
         12871 => (16#38B8#, 16#0020#, 16#0011#),
         12872 => (16#0000#, 16#0037#, 16#0002#),
         12873 => (16#011F#, 16#0020#, 16#0002#),
         12874 => (16#16C6#, 16#0020#, 16#0002#),
         12875 => (16#16C7#, 16#0020#, 16#0002#),
         12876 => (16#16C7#, 16#0020#, 16#0002#),
         12877 => (16#0000#, 16#0037#, 16#0002#),
         12878 => (16#3892#, 16#0020#, 16#0016#),
         12879 => (16#389C#, 16#0020#, 16#0016#),
         12880 => (16#38BA#, 16#0020#, 16#0002#),
         12881 => (16#38BB#, 16#0020#, 16#0002#),
         12882 => (16#38BC#, 16#0020#, 16#0002#),
         12883 => (16#38BD#, 16#0020#, 16#0002#),
         12884 => (16#38BF#, 16#0020#, 16#0002#),
         12885 => (16#38C0#, 16#0020#, 16#0002#),
         12886 => (16#38C1#, 16#0020#, 16#0002#),
         12887 => (16#38C2#, 16#0020#, 16#0002#),
         12888 => (16#38C3#, 16#0020#, 16#0002#),
         12889 => (16#38C4#, 16#0020#, 16#0002#),
         12890 => (16#38C7#, 16#0020#, 16#0002#),
         12891 => (16#38C8#, 16#0020#, 16#0002#),
         12892 => (16#38C9#, 16#0020#, 16#0002#),
         12893 => (16#38CA#, 16#0020#, 16#0002#),
         12894 => (16#38CC#, 16#0020#, 16#0002#),
         12895 => (16#38CD#, 16#0020#, 16#0002#),
         12896 => (16#38CE#, 16#0020#, 16#0002#),
         12897 => (16#38CF#, 16#0020#, 16#0002#),
         12898 => (16#38D0#, 16#0020#, 16#0002#),
         12899 => (16#38D1#, 16#0020#, 16#0002#),
         12900 => (16#38D2#, 16#0020#, 16#0002#),
         12901 => (16#38D6#, 16#0020#, 16#0002#),
         12902 => (16#38D7#, 16#0020#, 16#0002#),
         12903 => (16#38D9#, 16#0020#, 16#0002#),
         12904 => (16#38DA#, 16#0020#, 16#0002#),
         12905 => (16#38DC#, 16#0020#, 16#0002#),
         12906 => (16#38DD#, 16#0020#, 16#0002#),
         12907 => (16#38DE#, 16#0020#, 16#0002#),
         12908 => (16#38DF#, 16#0020#, 16#0002#),
         12909 => (16#38E0#, 16#0020#, 16#0002#),
         12910 => (16#38E1#, 16#0020#, 16#0002#),
         12911 => (16#38E2#, 16#0020#, 16#0002#),
         12912 => (16#38E4#, 16#0020#, 16#0002#),
         12913 => (16#38E8#, 16#0020#, 16#0002#),
         12914 => (16#38E9#, 16#0020#, 16#0002#),
         12915 => (16#38EA#, 16#0020#, 16#0002#),
         12916 => (16#38EB#, 16#0020#, 16#0002#),
         12917 => (16#38BE#, 16#0020#, 16#0002#),
         12918 => (16#38C5#, 16#0020#, 16#0002#),
         12919 => (16#38CB#, 16#0020#, 16#0002#),
         12920 => (16#38EC#, 16#0020#, 16#0002#),
         12921 => (16#3723#, 16#0020#, 16#0004#),
         12922 => (16#3724#, 16#0020#, 16#0004#),
         12923 => (16#3801#, 16#0020#, 16#0004#),
         12924 => (16#3725#, 16#0020#, 16#0004#),
         12925 => (16#3803#, 16#0020#, 16#0004#),
         12926 => (16#3804#, 16#0020#, 16#0004#),
         12927 => (16#3726#, 16#0020#, 16#0004#),
         12928 => (16#3727#, 16#0020#, 16#0004#),
         12929 => (16#3728#, 16#0020#, 16#0004#),
         12930 => (16#3807#, 16#0020#, 16#0004#),
         12931 => (16#3808#, 16#0020#, 16#0004#),
         12932 => (16#3809#, 16#0020#, 16#0004#),
         12933 => (16#380A#, 16#0020#, 16#0004#),
         12934 => (16#380B#, 16#0020#, 16#0004#),
         12935 => (16#380C#, 16#0020#, 16#0004#),
         12936 => (16#373D#, 16#0020#, 16#0004#),
         12937 => (16#3729#, 16#0020#, 16#0004#),
         12938 => (16#372A#, 16#0020#, 16#0004#),
         12939 => (16#372B#, 16#0020#, 16#0004#),
         12940 => (16#3744#, 16#0020#, 16#0004#),
         12941 => (16#372C#, 16#0020#, 16#0004#),
         12942 => (16#372D#, 16#0020#, 16#0004#),
         12943 => (16#372E#, 16#0020#, 16#0004#),
         12944 => (16#372F#, 16#0020#, 16#0004#),
         12945 => (16#3730#, 16#0020#, 16#0004#),
         12946 => (16#3731#, 16#0020#, 16#0004#),
         12947 => (16#3732#, 16#0020#, 16#0004#),
         12948 => (16#3733#, 16#0020#, 16#0004#),
         12949 => (16#3734#, 16#0020#, 16#0004#),
         12950 => (16#3735#, 16#0020#, 16#0004#),
         12951 => (16#37A1#, 16#0020#, 16#0004#),
         12952 => (16#37A2#, 16#0020#, 16#0004#),
         12953 => (16#37A3#, 16#0020#, 16#0004#),
         12954 => (16#37A4#, 16#0020#, 16#0004#),
         12955 => (16#37A5#, 16#0020#, 16#0004#),
         12956 => (16#37A6#, 16#0020#, 16#0004#),
         12957 => (16#37A7#, 16#0020#, 16#0004#),
         12958 => (16#37A8#, 16#0020#, 16#0004#),
         12959 => (16#37A9#, 16#0020#, 16#0004#),
         12960 => (16#37AA#, 16#0020#, 16#0004#),
         12961 => (16#37AB#, 16#0020#, 16#0004#),
         12962 => (16#37AC#, 16#0020#, 16#0004#),
         12963 => (16#37AD#, 16#0020#, 16#0004#),
         12964 => (16#37AE#, 16#0020#, 16#0004#),
         12965 => (16#37AF#, 16#0020#, 16#0004#),
         12966 => (16#37B0#, 16#0020#, 16#0004#),
         12967 => (16#37B1#, 16#0020#, 16#0004#),
         12968 => (16#37B2#, 16#0020#, 16#0004#),
         12969 => (16#37B3#, 16#0020#, 16#0004#),
         12970 => (16#37B4#, 16#0020#, 16#0004#),
         12971 => (16#37B5#, 16#0020#, 16#0004#),
         12972 => (16#37A0#, 16#0020#, 16#0004#),
         12973 => (16#3737#, 16#0020#, 16#0004#),
         12974 => (16#3738#, 16#0020#, 16#0004#),
         12975 => (16#381E#, 16#0020#, 16#0004#),
         12976 => (16#381F#, 16#0020#, 16#0004#),
         12977 => (16#3823#, 16#0020#, 16#0004#),
         12978 => (16#3825#, 16#0020#, 16#0004#),
         12979 => (16#382A#, 16#0020#, 16#0004#),
         12980 => (16#382E#, 16#0020#, 16#0004#),
         12981 => (16#3830#, 16#0020#, 16#0004#),
         12982 => (16#373F#, 16#0020#, 16#0004#),
         12983 => (16#3834#, 16#0020#, 16#0004#),
         12984 => (16#3836#, 16#0020#, 16#0004#),
         12985 => (16#3740#, 16#0020#, 16#0004#),
         12986 => (16#3741#, 16#0020#, 16#0004#),
         12987 => (16#3743#, 16#0020#, 16#0004#),
         12988 => (16#3745#, 16#0020#, 16#0004#),
         12989 => (16#3746#, 16#0020#, 16#0004#),
         12990 => (16#374A#, 16#0020#, 16#0004#),
         12991 => (16#374C#, 16#0020#, 16#0004#),
         12992 => (16#374E#, 16#0020#, 16#0004#),
         12993 => (16#374F#, 16#0020#, 16#0004#),
         12994 => (16#3750#, 16#0020#, 16#0004#),
         12995 => (16#3751#, 16#0020#, 16#0004#),
         12996 => (16#3752#, 16#0020#, 16#0004#),
         12997 => (16#3755#, 16#0020#, 16#0004#),
         12998 => (16#3759#, 16#0020#, 16#0004#),
         12999 => (16#3763#, 16#0020#, 16#0004#),
         13000 => (16#376A#, 16#0020#, 16#0004#),
         13001 => (16#376F#, 16#0020#, 16#0004#),
         13002 => (16#3848#, 16#0020#, 16#0004#),
         13003 => (16#3849#, 16#0020#, 16#0004#),
         13004 => (16#377A#, 16#0020#, 16#0004#),
         13005 => (16#377B#, 16#0020#, 16#0004#),
         13006 => (16#377C#, 16#0020#, 16#0004#),
         13007 => (16#37C4#, 16#0020#, 16#0004#),
         13008 => (16#37C5#, 16#0020#, 16#0004#),
         13009 => (16#37C8#, 16#0020#, 16#0004#),
         13010 => (16#37D1#, 16#0020#, 16#0004#),
         13011 => (16#37D2#, 16#0020#, 16#0004#),
         13012 => (16#37D4#, 16#0020#, 16#0004#),
         13013 => (16#37DE#, 16#0020#, 16#0004#),
         13014 => (16#37E1#, 16#0020#, 16#0004#),
         13015 => (16#16AD#, 16#0020#, 16#0002#),
         13016 => (16#16AE#, 16#0020#, 16#0002#),
         13017 => (16#FB40#, 16#0020#, 16#0014#),
         13018 => (16#CE00#, 16#0000#, 16#0000#),
         13019 => (16#FB40#, 16#0020#, 16#0014#),
         13020 => (16#CE8C#, 16#0000#, 16#0000#),
         13021 => (16#FB40#, 16#0020#, 16#0014#),
         13022 => (16#CE09#, 16#0000#, 16#0000#),
         13023 => (16#FB40#, 16#0020#, 16#0014#),
         13024 => (16#D6DB#, 16#0000#, 16#0000#),
         13025 => (16#FB40#, 16#0020#, 16#0014#),
         13026 => (16#CE0A#, 16#0000#, 16#0000#),
         13027 => (16#FB40#, 16#0020#, 16#0014#),
         13028 => (16#CE2D#, 16#0000#, 16#0000#),
         13029 => (16#FB40#, 16#0020#, 16#0014#),
         13030 => (16#CE0B#, 16#0000#, 16#0000#),
         13031 => (16#FB40#, 16#0020#, 16#0014#),
         13032 => (16#F532#, 16#0000#, 16#0000#),
         13033 => (16#FB40#, 16#0020#, 16#0014#),
         13034 => (16#CE59#, 16#0000#, 16#0000#),
         13035 => (16#FB40#, 16#0020#, 16#0014#),
         13036 => (16#CE19#, 16#0000#, 16#0000#),
         13037 => (16#FB40#, 16#0020#, 16#0014#),
         13038 => (16#CE01#, 16#0000#, 16#0000#),
         13039 => (16#FB40#, 16#0020#, 16#0014#),
         13040 => (16#D929#, 16#0000#, 16#0000#),
         13041 => (16#FB40#, 16#0020#, 16#0014#),
         13042 => (16#D730#, 16#0000#, 16#0000#),
         13043 => (16#FB40#, 16#0020#, 16#0014#),
         13044 => (16#CEBA#, 16#0000#, 16#0000#),
         13045 => (16#38BA#, 16#0020#, 16#0004#),
         13046 => (16#0000#, 16#0109#, 16#0004#),
         13047 => (16#38D0#, 16#0020#, 16#0004#),
         13048 => (16#0000#, 16#0109#, 16#0004#),
         13049 => (16#38C8#, 16#0020#, 16#0004#),
         13050 => (16#0000#, 16#0109#, 16#0004#),
         13051 => (16#38C3#, 16#0020#, 16#0004#),
         13052 => (16#0000#, 16#0109#, 16#0004#),
         13053 => (16#38DB#, 16#0020#, 16#0002#),
         13054 => (16#38DB#, 16#0020#, 16#0004#),
         13055 => (16#0000#, 16#0109#, 16#0004#),
         13056 => (16#38D8#, 16#0020#, 16#0002#),
         13057 => (16#38D7#, 16#0020#, 16#0004#),
         13058 => (16#0000#, 16#0109#, 16#0004#),
         13059 => (16#38EA#, 16#0020#, 16#0004#),
         13060 => (16#0000#, 16#010A#, 16#0004#),
         13061 => (16#38D6#, 16#0020#, 16#0004#),
         13062 => (16#0000#, 16#0109#, 16#0004#),
         13063 => (16#38E9#, 16#0020#, 16#0004#),
         13064 => (16#0000#, 16#0109#, 16#0004#),
         13065 => (16#38EA#, 16#0020#, 16#0004#),
         13066 => (16#0000#, 16#0109#, 16#0004#),
         13067 => (16#38E7#, 16#0020#, 16#0002#),
         13068 => (16#38C6#, 16#0020#, 16#0002#),
         13069 => (16#38DC#, 16#0020#, 16#0004#),
         13070 => (16#0000#, 16#0109#, 16#0004#),
         13071 => (16#38DE#, 16#0020#, 16#0004#),
         13072 => (16#0000#, 16#0109#, 16#0004#),
         13073 => (16#38E5#, 16#0020#, 16#0002#),
         13074 => (16#38E6#, 16#0020#, 16#0002#),
         13075 => (16#38E3#, 16#0020#, 16#0002#),
         13076 => (16#38E9#, 16#0020#, 16#0016#),
         13077 => (16#0000#, 16#0109#, 16#0016#),
         13078 => (16#38BB#, 16#0020#, 16#0019#),
         13079 => (16#38C0#, 16#0020#, 16#0019#),
         13080 => (16#38C4#, 16#0020#, 16#0019#),
         13081 => (16#38C7#, 16#0020#, 16#0019#),
         13082 => (16#38D3#, 16#0020#, 16#0002#),
         13083 => (16#38D4#, 16#0020#, 16#0002#),
         13084 => (16#38D5#, 16#0020#, 16#0002#),
         13085 => (16#1682#, 16#0020#, 16#0002#),
         13086 => (16#1683#, 16#0020#, 16#0002#),
         13087 => (16#1684#, 16#0020#, 16#0002#),
         13088 => (16#1685#, 16#0020#, 16#0002#),
         13089 => (16#1686#, 16#0020#, 16#0002#),
         13090 => (16#1687#, 16#0020#, 16#0002#),
         13091 => (16#1688#, 16#0020#, 16#0002#),
         13092 => (16#1689#, 16#0020#, 16#0002#),
         13093 => (16#168A#, 16#0020#, 16#0002#),
         13094 => (16#168B#, 16#0020#, 16#0002#),
         13095 => (16#168C#, 16#0020#, 16#0002#),
         13096 => (16#168D#, 16#0020#, 16#0002#),
         13097 => (16#168E#, 16#0020#, 16#0002#),
         13098 => (16#168F#, 16#0020#, 16#0002#),
         13099 => (16#1690#, 16#0020#, 16#0002#),
         13100 => (16#1691#, 16#0020#, 16#0002#),
         13101 => (16#1692#, 16#0020#, 16#0002#),
         13102 => (16#1693#, 16#0020#, 16#0002#),
         13103 => (16#1694#, 16#0020#, 16#0002#),
         13104 => (16#1695#, 16#0020#, 16#0002#),
         13105 => (16#1696#, 16#0020#, 16#0002#),
         13106 => (16#1697#, 16#0020#, 16#0002#),
         13107 => (16#1698#, 16#0020#, 16#0002#),
         13108 => (16#1699#, 16#0020#, 16#0002#),
         13109 => (16#169A#, 16#0020#, 16#0002#),
         13110 => (16#169B#, 16#0020#, 16#0002#),
         13111 => (16#169C#, 16#0020#, 16#0002#),
         13112 => (16#169D#, 16#0020#, 16#0002#),
         13113 => (16#169E#, 16#0020#, 16#0002#),
         13114 => (16#169F#, 16#0020#, 16#0002#),
         13115 => (16#16A0#, 16#0020#, 16#0002#),
         13116 => (16#16A1#, 16#0020#, 16#0002#),
         13117 => (16#16A2#, 16#0020#, 16#0002#),
         13118 => (16#16A3#, 16#0020#, 16#0002#),
         13119 => (16#16A4#, 16#0020#, 16#0002#),
         13120 => (16#16A5#, 16#0020#, 16#0002#),
         13121 => (16#3890#, 16#0020#, 16#000F#),
         13122 => (16#3894#, 16#0020#, 16#000F#),
         13123 => (16#3895#, 16#0020#, 16#000F#),
         13124 => (16#389C#, 16#0020#, 16#000F#),
         13125 => (16#389F#, 16#0020#, 16#000F#),
         13126 => (16#38A2#, 16#0020#, 16#000F#),
         13127 => (16#38A3#, 16#0020#, 16#000F#),
         13128 => (16#38A4#, 16#0020#, 16#000F#),
         13129 => (16#38A5#, 16#0020#, 16#000F#),
         13130 => (16#38A6#, 16#0020#, 16#000F#),
         13131 => (16#38A9#, 16#0020#, 16#000F#),
         13132 => (16#38B0#, 16#0020#, 16#000F#),
         13133 => (16#38B1#, 16#0020#, 16#000F#),
         13134 => (16#38B2#, 16#0020#, 16#000F#),
         13135 => (16#38B3#, 16#0020#, 16#000F#),
         13136 => (16#38B4#, 16#0020#, 16#000F#),
         13137 => (16#0209#, 16#0020#, 16#0004#),
         13138 => (16#3723#, 16#0020#, 16#0004#),
         13139 => (16#020A#, 16#0020#, 16#0004#),
         13140 => (16#0209#, 16#0020#, 16#0004#),
         13141 => (16#3725#, 16#0020#, 16#0004#),
         13142 => (16#020A#, 16#0020#, 16#0004#),
         13143 => (16#0209#, 16#0020#, 16#0004#),
         13144 => (16#3726#, 16#0020#, 16#0004#),
         13145 => (16#020A#, 16#0020#, 16#0004#),
         13146 => (16#0209#, 16#0020#, 16#0004#),
         13147 => (16#3728#, 16#0020#, 16#0004#),
         13148 => (16#020A#, 16#0020#, 16#0004#),
         13149 => (16#0209#, 16#0020#, 16#0004#),
         13150 => (16#3729#, 16#0020#, 16#0004#),
         13151 => (16#020A#, 16#0020#, 16#0004#),
         13152 => (16#0209#, 16#0020#, 16#0004#),
         13153 => (16#372A#, 16#0020#, 16#0004#),
         13154 => (16#020A#, 16#0020#, 16#0004#),
         13155 => (16#0209#, 16#0020#, 16#0004#),
         13156 => (16#372C#, 16#0020#, 16#0004#),
         13157 => (16#020A#, 16#0020#, 16#0004#),
         13158 => (16#0209#, 16#0020#, 16#0004#),
         13159 => (16#372E#, 16#0020#, 16#0004#),
         13160 => (16#020A#, 16#0020#, 16#0004#),
         13161 => (16#0209#, 16#0020#, 16#0004#),
         13162 => (16#372F#, 16#0020#, 16#0004#),
         13163 => (16#020A#, 16#0020#, 16#0004#),
         13164 => (16#0209#, 16#0020#, 16#0004#),
         13165 => (16#3731#, 16#0020#, 16#0004#),
         13166 => (16#020A#, 16#0020#, 16#0004#),
         13167 => (16#0209#, 16#0020#, 16#0004#),
         13168 => (16#3732#, 16#0020#, 16#0004#),
         13169 => (16#020A#, 16#0020#, 16#0004#),
         13170 => (16#0209#, 16#0020#, 16#0004#),
         13171 => (16#3733#, 16#0020#, 16#0004#),
         13172 => (16#020A#, 16#0020#, 16#0004#),
         13173 => (16#0209#, 16#0020#, 16#0004#),
         13174 => (16#3734#, 16#0020#, 16#0004#),
         13175 => (16#020A#, 16#0020#, 16#0004#),
         13176 => (16#0209#, 16#0020#, 16#0004#),
         13177 => (16#3735#, 16#0020#, 16#0004#),
         13178 => (16#020A#, 16#0020#, 16#0004#),
         13179 => (16#0209#, 16#0020#, 16#0004#),
         13180 => (16#3723#, 16#0020#, 16#0004#),
         13181 => (16#37A1#, 16#0020#, 16#0004#),
         13182 => (16#020A#, 16#0020#, 16#0004#),
         13183 => (16#0209#, 16#0020#, 16#0004#),
         13184 => (16#3725#, 16#0020#, 16#0004#),
         13185 => (16#37A1#, 16#0020#, 16#0004#),
         13186 => (16#020A#, 16#0020#, 16#0004#),
         13187 => (16#0209#, 16#0020#, 16#0004#),
         13188 => (16#3726#, 16#0020#, 16#0004#),
         13189 => (16#37A1#, 16#0020#, 16#0004#),
         13190 => (16#020A#, 16#0020#, 16#0004#),
         13191 => (16#0209#, 16#0020#, 16#0004#),
         13192 => (16#3728#, 16#0020#, 16#0004#),
         13193 => (16#37A1#, 16#0020#, 16#0004#),
         13194 => (16#020A#, 16#0020#, 16#0004#),
         13195 => (16#0209#, 16#0020#, 16#0004#),
         13196 => (16#3729#, 16#0020#, 16#0004#),
         13197 => (16#37A1#, 16#0020#, 16#0004#),
         13198 => (16#020A#, 16#0020#, 16#0004#),
         13199 => (16#0209#, 16#0020#, 16#0004#),
         13200 => (16#372A#, 16#0020#, 16#0004#),
         13201 => (16#37A1#, 16#0020#, 16#0004#),
         13202 => (16#020A#, 16#0020#, 16#0004#),
         13203 => (16#0209#, 16#0020#, 16#0004#),
         13204 => (16#372C#, 16#0020#, 16#0004#),
         13205 => (16#37A1#, 16#0020#, 16#0004#),
         13206 => (16#020A#, 16#0020#, 16#0004#),
         13207 => (16#0209#, 16#0020#, 16#0004#),
         13208 => (16#372E#, 16#0020#, 16#0004#),
         13209 => (16#37A1#, 16#0020#, 16#0004#),
         13210 => (16#020A#, 16#0020#, 16#0004#),
         13211 => (16#0209#, 16#0020#, 16#0004#),
         13212 => (16#372F#, 16#0020#, 16#0004#),
         13213 => (16#37A1#, 16#0020#, 16#0004#),
         13214 => (16#020A#, 16#0020#, 16#0004#),
         13215 => (16#0209#, 16#0020#, 16#0004#),
         13216 => (16#3731#, 16#0020#, 16#0004#),
         13217 => (16#37A1#, 16#0020#, 16#0004#),
         13218 => (16#020A#, 16#0020#, 16#0004#),
         13219 => (16#0209#, 16#0020#, 16#0004#),
         13220 => (16#3732#, 16#0020#, 16#0004#),
         13221 => (16#37A1#, 16#0020#, 16#0004#),
         13222 => (16#020A#, 16#0020#, 16#0004#),
         13223 => (16#0209#, 16#0020#, 16#0004#),
         13224 => (16#3733#, 16#0020#, 16#0004#),
         13225 => (16#37A1#, 16#0020#, 16#0004#),
         13226 => (16#020A#, 16#0020#, 16#0004#),
         13227 => (16#0209#, 16#0020#, 16#0004#),
         13228 => (16#3734#, 16#0020#, 16#0004#),
         13229 => (16#37A1#, 16#0020#, 16#0004#),
         13230 => (16#020A#, 16#0020#, 16#0004#),
         13231 => (16#0209#, 16#0020#, 16#0004#),
         13232 => (16#3735#, 16#0020#, 16#0004#),
         13233 => (16#37A1#, 16#0020#, 16#0004#),
         13234 => (16#020A#, 16#0020#, 16#0004#),
         13235 => (16#0209#, 16#0020#, 16#0004#),
         13236 => (16#372F#, 16#0020#, 16#0004#),
         13237 => (16#37AE#, 16#0020#, 16#0004#),
         13238 => (16#020A#, 16#0020#, 16#0004#),
         13239 => (16#0209#, 16#0020#, 16#0004#),
         13240 => (16#372E#, 16#0020#, 16#0004#),
         13241 => (16#37A9#, 16#0020#, 16#0004#),
         13242 => (16#372F#, 16#0020#, 16#0004#),
         13243 => (16#37A5#, 16#0020#, 16#0004#),
         13244 => (16#3802#, 16#0020#, 16#0004#),
         13245 => (16#020A#, 16#0020#, 16#0004#),
         13246 => (16#0209#, 16#0020#, 16#0004#),
         13247 => (16#372E#, 16#0020#, 16#0004#),
         13248 => (16#37A9#, 16#0020#, 16#0004#),
         13249 => (16#3735#, 16#0020#, 16#0004#),
         13250 => (16#37AE#, 16#0020#, 16#0004#),
         13251 => (16#020A#, 16#0020#, 16#0004#),
         13252 => (16#0209#, 16#0020#, 16#0004#),
         13253 => (16#FB40#, 16#0020#, 16#0004#),
         13254 => (16#CE00#, 16#0000#, 16#0000#),
         13255 => (16#020A#, 16#0020#, 16#0004#),
         13256 => (16#0209#, 16#0020#, 16#0004#),
         13257 => (16#FB40#, 16#0020#, 16#0004#),
         13258 => (16#CE8C#, 16#0000#, 16#0000#),
         13259 => (16#020A#, 16#0020#, 16#0004#),
         13260 => (16#0209#, 16#0020#, 16#0004#),
         13261 => (16#FB40#, 16#0020#, 16#0004#),
         13262 => (16#CE09#, 16#0000#, 16#0000#),
         13263 => (16#020A#, 16#0020#, 16#0004#),
         13264 => (16#0209#, 16#0020#, 16#0004#),
         13265 => (16#FB40#, 16#0020#, 16#0004#),
         13266 => (16#D6DB#, 16#0000#, 16#0000#),
         13267 => (16#020A#, 16#0020#, 16#0004#),
         13268 => (16#0209#, 16#0020#, 16#0004#),
         13269 => (16#FB40#, 16#0020#, 16#0004#),
         13270 => (16#CE94#, 16#0000#, 16#0000#),
         13271 => (16#020A#, 16#0020#, 16#0004#),
         13272 => (16#0209#, 16#0020#, 16#0004#),
         13273 => (16#FB40#, 16#0020#, 16#0004#),
         13274 => (16#D16D#, 16#0000#, 16#0000#),
         13275 => (16#020A#, 16#0020#, 16#0004#),
         13276 => (16#0209#, 16#0020#, 16#0004#),
         13277 => (16#FB40#, 16#0020#, 16#0004#),
         13278 => (16#CE03#, 16#0000#, 16#0000#),
         13279 => (16#020A#, 16#0020#, 16#0004#),
         13280 => (16#0209#, 16#0020#, 16#0004#),
         13281 => (16#FB40#, 16#0020#, 16#0004#),
         13282 => (16#D16B#, 16#0000#, 16#0000#),
         13283 => (16#020A#, 16#0020#, 16#0004#),
         13284 => (16#0209#, 16#0020#, 16#0004#),
         13285 => (16#FB40#, 16#0020#, 16#0004#),
         13286 => (16#CE5D#, 16#0000#, 16#0000#),
         13287 => (16#020A#, 16#0020#, 16#0004#),
         13288 => (16#0209#, 16#0020#, 16#0004#),
         13289 => (16#FB40#, 16#0020#, 16#0004#),
         13290 => (16#D341#, 16#0000#, 16#0000#),
         13291 => (16#020A#, 16#0020#, 16#0004#),
         13292 => (16#0209#, 16#0020#, 16#0004#),
         13293 => (16#FB40#, 16#0020#, 16#0004#),
         13294 => (16#E708#, 16#0000#, 16#0000#),
         13295 => (16#020A#, 16#0020#, 16#0004#),
         13296 => (16#0209#, 16#0020#, 16#0004#),
         13297 => (16#FB40#, 16#0020#, 16#0004#),
         13298 => (16#F06B#, 16#0000#, 16#0000#),
         13299 => (16#020A#, 16#0020#, 16#0004#),
         13300 => (16#0209#, 16#0020#, 16#0004#),
         13301 => (16#FB40#, 16#0020#, 16#0004#),
         13302 => (16#EC34#, 16#0000#, 16#0000#),
         13303 => (16#020A#, 16#0020#, 16#0004#),
         13304 => (16#0209#, 16#0020#, 16#0004#),
         13305 => (16#FB40#, 16#0020#, 16#0004#),
         13306 => (16#E728#, 16#0000#, 16#0000#),
         13307 => (16#020A#, 16#0020#, 16#0004#),
         13308 => (16#0209#, 16#0020#, 16#0004#),
         13309 => (16#FB41#, 16#0020#, 16#0004#),
         13310 => (16#91D1#, 16#0000#, 16#0000#),
         13311 => (16#020A#, 16#0020#, 16#0004#),
         13312 => (16#0209#, 16#0020#, 16#0004#),
         13313 => (16#FB40#, 16#0020#, 16#0004#),
         13314 => (16#D71F#, 16#0000#, 16#0000#),
         13315 => (16#020A#, 16#0020#, 16#0004#),
         13316 => (16#0209#, 16#0020#, 16#0004#),
         13317 => (16#FB40#, 16#0020#, 16#0004#),
         13318 => (16#E5E5#, 16#0000#, 16#0000#),
         13319 => (16#020A#, 16#0020#, 16#0004#),
         13320 => (16#0209#, 16#0020#, 16#0004#),
         13321 => (16#FB40#, 16#0020#, 16#0004#),
         13322 => (16#E82A#, 16#0000#, 16#0000#),
         13323 => (16#020A#, 16#0020#, 16#0004#),
         13324 => (16#0209#, 16#0020#, 16#0004#),
         13325 => (16#FB40#, 16#0020#, 16#0004#),
         13326 => (16#E709#, 16#0000#, 16#0000#),
         13327 => (16#020A#, 16#0020#, 16#0004#),
         13328 => (16#0209#, 16#0020#, 16#0004#),
         13329 => (16#FB40#, 16#0020#, 16#0004#),
         13330 => (16#F93E#, 16#0000#, 16#0000#),
         13331 => (16#020A#, 16#0020#, 16#0004#),
         13332 => (16#0209#, 16#0020#, 16#0004#),
         13333 => (16#FB40#, 16#0020#, 16#0004#),
         13334 => (16#D40D#, 16#0000#, 16#0000#),
         13335 => (16#020A#, 16#0020#, 16#0004#),
         13336 => (16#0209#, 16#0020#, 16#0004#),
         13337 => (16#FB40#, 16#0020#, 16#0004#),
         13338 => (16#F279#, 16#0000#, 16#0000#),
         13339 => (16#020A#, 16#0020#, 16#0004#),
         13340 => (16#0209#, 16#0020#, 16#0004#),
         13341 => (16#FB41#, 16#0020#, 16#0004#),
         13342 => (16#8CA1#, 16#0000#, 16#0000#),
         13343 => (16#020A#, 16#0020#, 16#0004#),
         13344 => (16#0209#, 16#0020#, 16#0004#),
         13345 => (16#FB40#, 16#0020#, 16#0004#),
         13346 => (16#F95D#, 16#0000#, 16#0000#),
         13347 => (16#020A#, 16#0020#, 16#0004#),
         13348 => (16#0209#, 16#0020#, 16#0004#),
         13349 => (16#FB40#, 16#0020#, 16#0004#),
         13350 => (16#D2B4#, 16#0000#, 16#0000#),
         13351 => (16#020A#, 16#0020#, 16#0004#),
         13352 => (16#0209#, 16#0020#, 16#0004#),
         13353 => (16#FB40#, 16#0020#, 16#0004#),
         13354 => (16#CEE3#, 16#0000#, 16#0000#),
         13355 => (16#020A#, 16#0020#, 16#0004#),
         13356 => (16#0209#, 16#0020#, 16#0004#),
         13357 => (16#FB40#, 16#0020#, 16#0004#),
         13358 => (16#D47C#, 16#0000#, 16#0000#),
         13359 => (16#020A#, 16#0020#, 16#0004#),
         13360 => (16#0209#, 16#0020#, 16#0004#),
         13361 => (16#FB40#, 16#0020#, 16#0004#),
         13362 => (16#DB66#, 16#0000#, 16#0000#),
         13363 => (16#020A#, 16#0020#, 16#0004#),
         13364 => (16#0209#, 16#0020#, 16#0004#),
         13365 => (16#FB40#, 16#0020#, 16#0004#),
         13366 => (16#F6E3#, 16#0000#, 16#0000#),
         13367 => (16#020A#, 16#0020#, 16#0004#),
         13368 => (16#0209#, 16#0020#, 16#0004#),
         13369 => (16#FB40#, 16#0020#, 16#0004#),
         13370 => (16#CF01#, 16#0000#, 16#0000#),
         13371 => (16#020A#, 16#0020#, 16#0004#),
         13372 => (16#0209#, 16#0020#, 16#0004#),
         13373 => (16#FB41#, 16#0020#, 16#0004#),
         13374 => (16#8CC7#, 16#0000#, 16#0000#),
         13375 => (16#020A#, 16#0020#, 16#0004#),
         13376 => (16#0209#, 16#0020#, 16#0004#),
         13377 => (16#FB40#, 16#0020#, 16#0004#),
         13378 => (16#D354#, 16#0000#, 16#0000#),
         13379 => (16#020A#, 16#0020#, 16#0004#),
         13380 => (16#0209#, 16#0020#, 16#0004#),
         13381 => (16#FB40#, 16#0020#, 16#0004#),
         13382 => (16#F96D#, 16#0000#, 16#0000#),
         13383 => (16#020A#, 16#0020#, 16#0004#),
         13384 => (16#0209#, 16#0020#, 16#0004#),
         13385 => (16#FB40#, 16#0020#, 16#0004#),
         13386 => (16#CF11#, 16#0000#, 16#0000#),
         13387 => (16#020A#, 16#0020#, 16#0004#),
         13388 => (16#0209#, 16#0020#, 16#0004#),
         13389 => (16#FB41#, 16#0020#, 16#0004#),
         13390 => (16#81EA#, 16#0000#, 16#0000#),
         13391 => (16#020A#, 16#0020#, 16#0004#),
         13392 => (16#0209#, 16#0020#, 16#0004#),
         13393 => (16#FB41#, 16#0020#, 16#0004#),
         13394 => (16#81F3#, 16#0000#, 16#0000#),
         13395 => (16#020A#, 16#0020#, 16#0004#),
         13396 => (16#FB40#, 16#0020#, 16#0006#),
         13397 => (16#D54F#, 16#0000#, 16#0000#),
         13398 => (16#FB40#, 16#0020#, 16#0006#),
         13399 => (16#DE7C#, 16#0000#, 16#0000#),
         13400 => (16#FB40#, 16#0020#, 16#0006#),
         13401 => (16#E587#, 16#0000#, 16#0000#),
         13402 => (16#FB40#, 16#0020#, 16#0006#),
         13403 => (16#FB8F#, 16#0000#, 16#0000#),
         13404 => (16#1806#, 16#0020#, 16#0006#),
         13405 => (16#1803#, 16#0020#, 16#0006#),
         13406 => (16#1807#, 16#0020#, 16#0006#),
         13407 => (16#1803#, 16#0020#, 16#0006#),
         13408 => (16#1808#, 16#0020#, 16#0006#),
         13409 => (16#1803#, 16#0020#, 16#0006#),
         13410 => (16#1809#, 16#0020#, 16#0006#),
         13411 => (16#1803#, 16#0020#, 16#0006#),
         13412 => (16#180A#, 16#0020#, 16#0006#),
         13413 => (16#1803#, 16#0020#, 16#0006#),
         13414 => (16#180B#, 16#0020#, 16#0006#),
         13415 => (16#1803#, 16#0020#, 16#0006#),
         13416 => (16#1ACE#, 16#0020#, 16#001D#),
         13417 => (16#1B57#, 16#0020#, 16#001D#),
         13418 => (16#196E#, 16#0020#, 16#001D#),
         13419 => (16#1805#, 16#0020#, 16#0006#),
         13420 => (16#1804#, 16#0020#, 16#0006#),
         13421 => (16#1805#, 16#0020#, 16#0006#),
         13422 => (16#1805#, 16#0020#, 16#0006#),
         13423 => (16#1805#, 16#0020#, 16#0006#),
         13424 => (16#1807#, 16#0020#, 16#0006#),
         13425 => (16#1805#, 16#0020#, 16#0006#),
         13426 => (16#1808#, 16#0020#, 16#0006#),
         13427 => (16#1805#, 16#0020#, 16#0006#),
         13428 => (16#1809#, 16#0020#, 16#0006#),
         13429 => (16#1805#, 16#0020#, 16#0006#),
         13430 => (16#180A#, 16#0020#, 16#0006#),
         13431 => (16#1805#, 16#0020#, 16#0006#),
         13432 => (16#180B#, 16#0020#, 16#0006#),
         13433 => (16#1805#, 16#0020#, 16#0006#),
         13434 => (16#180C#, 16#0020#, 16#0006#),
         13435 => (16#1806#, 16#0020#, 16#0006#),
         13436 => (16#1805#, 16#0020#, 16#0006#),
         13437 => (16#1806#, 16#0020#, 16#0006#),
         13438 => (16#1806#, 16#0020#, 16#0006#),
         13439 => (16#1806#, 16#0020#, 16#0006#),
         13440 => (16#1808#, 16#0020#, 16#0006#),
         13441 => (16#3723#, 16#0020#, 16#0006#),
         13442 => (16#3725#, 16#0020#, 16#0006#),
         13443 => (16#3726#, 16#0020#, 16#0006#),
         13444 => (16#3728#, 16#0020#, 16#0006#),
         13445 => (16#3729#, 16#0020#, 16#0006#),
         13446 => (16#372A#, 16#0020#, 16#0006#),
         13447 => (16#372C#, 16#0020#, 16#0006#),
         13448 => (16#372E#, 16#0020#, 16#0006#),
         13449 => (16#372F#, 16#0020#, 16#0006#),
         13450 => (16#3731#, 16#0020#, 16#0006#),
         13451 => (16#3732#, 16#0020#, 16#0006#),
         13452 => (16#3733#, 16#0020#, 16#0006#),
         13453 => (16#3734#, 16#0020#, 16#0006#),
         13454 => (16#3735#, 16#0020#, 16#0006#),
         13455 => (16#3723#, 16#0020#, 16#0006#),
         13456 => (16#37A1#, 16#0020#, 16#0006#),
         13457 => (16#3725#, 16#0020#, 16#0006#),
         13458 => (16#37A1#, 16#0020#, 16#0006#),
         13459 => (16#3726#, 16#0020#, 16#0006#),
         13460 => (16#37A1#, 16#0020#, 16#0006#),
         13461 => (16#3728#, 16#0020#, 16#0006#),
         13462 => (16#37A1#, 16#0020#, 16#0006#),
         13463 => (16#3729#, 16#0020#, 16#0006#),
         13464 => (16#37A1#, 16#0020#, 16#0006#),
         13465 => (16#372A#, 16#0020#, 16#0006#),
         13466 => (16#37A1#, 16#0020#, 16#0006#),
         13467 => (16#372C#, 16#0020#, 16#0006#),
         13468 => (16#37A1#, 16#0020#, 16#0006#),
         13469 => (16#372E#, 16#0020#, 16#0006#),
         13470 => (16#37A1#, 16#0020#, 16#0006#),
         13471 => (16#372F#, 16#0020#, 16#0006#),
         13472 => (16#37A1#, 16#0020#, 16#0006#),
         13473 => (16#3731#, 16#0020#, 16#0006#),
         13474 => (16#37A1#, 16#0020#, 16#0006#),
         13475 => (16#3732#, 16#0020#, 16#0006#),
         13476 => (16#37A1#, 16#0020#, 16#0006#),
         13477 => (16#3733#, 16#0020#, 16#0006#),
         13478 => (16#37A1#, 16#0020#, 16#0006#),
         13479 => (16#3734#, 16#0020#, 16#0006#),
         13480 => (16#37A1#, 16#0020#, 16#0006#),
         13481 => (16#3735#, 16#0020#, 16#0006#),
         13482 => (16#37A1#, 16#0020#, 16#0006#),
         13483 => (16#3731#, 16#0020#, 16#0006#),
         13484 => (16#37A1#, 16#0020#, 16#0006#),
         13485 => (16#380E#, 16#0020#, 16#0006#),
         13486 => (16#3723#, 16#0020#, 16#0006#),
         13487 => (16#37A9#, 16#0020#, 16#0006#),
         13488 => (16#372F#, 16#0020#, 16#0006#),
         13489 => (16#37AE#, 16#0020#, 16#0006#),
         13490 => (16#372E#, 16#0020#, 16#0006#),
         13491 => (16#37B4#, 16#0020#, 16#0006#),
         13492 => (16#372E#, 16#0020#, 16#0006#),
         13493 => (16#37AE#, 16#0020#, 16#0006#),
         13494 => (16#16AF#, 16#0020#, 16#0002#),
         13495 => (16#FB40#, 16#0020#, 16#0006#),
         13496 => (16#CE00#, 16#0000#, 16#0000#),
         13497 => (16#FB40#, 16#0020#, 16#0006#),
         13498 => (16#CE8C#, 16#0000#, 16#0000#),
         13499 => (16#FB40#, 16#0020#, 16#0006#),
         13500 => (16#CE09#, 16#0000#, 16#0000#),
         13501 => (16#FB40#, 16#0020#, 16#0006#),
         13502 => (16#D6DB#, 16#0000#, 16#0000#),
         13503 => (16#FB40#, 16#0020#, 16#0006#),
         13504 => (16#CE94#, 16#0000#, 16#0000#),
         13505 => (16#FB40#, 16#0020#, 16#0006#),
         13506 => (16#D16D#, 16#0000#, 16#0000#),
         13507 => (16#FB40#, 16#0020#, 16#0006#),
         13508 => (16#CE03#, 16#0000#, 16#0000#),
         13509 => (16#FB40#, 16#0020#, 16#0006#),
         13510 => (16#D16B#, 16#0000#, 16#0000#),
         13511 => (16#FB40#, 16#0020#, 16#0006#),
         13512 => (16#CE5D#, 16#0000#, 16#0000#),
         13513 => (16#FB40#, 16#0020#, 16#0006#),
         13514 => (16#D341#, 16#0000#, 16#0000#),
         13515 => (16#FB40#, 16#0020#, 16#0006#),
         13516 => (16#E708#, 16#0000#, 16#0000#),
         13517 => (16#FB40#, 16#0020#, 16#0006#),
         13518 => (16#F06B#, 16#0000#, 16#0000#),
         13519 => (16#FB40#, 16#0020#, 16#0006#),
         13520 => (16#EC34#, 16#0000#, 16#0000#),
         13521 => (16#FB40#, 16#0020#, 16#0006#),
         13522 => (16#E728#, 16#0000#, 16#0000#),
         13523 => (16#FB41#, 16#0020#, 16#0006#),
         13524 => (16#91D1#, 16#0000#, 16#0000#),
         13525 => (16#FB40#, 16#0020#, 16#0006#),
         13526 => (16#D71F#, 16#0000#, 16#0000#),
         13527 => (16#FB40#, 16#0020#, 16#0006#),
         13528 => (16#E5E5#, 16#0000#, 16#0000#),
         13529 => (16#FB40#, 16#0020#, 16#0006#),
         13530 => (16#E82A#, 16#0000#, 16#0000#),
         13531 => (16#FB40#, 16#0020#, 16#0006#),
         13532 => (16#E709#, 16#0000#, 16#0000#),
         13533 => (16#FB40#, 16#0020#, 16#0006#),
         13534 => (16#F93E#, 16#0000#, 16#0000#),
         13535 => (16#FB40#, 16#0020#, 16#0006#),
         13536 => (16#D40D#, 16#0000#, 16#0000#),
         13537 => (16#FB40#, 16#0020#, 16#0006#),
         13538 => (16#F279#, 16#0000#, 16#0000#),
         13539 => (16#FB41#, 16#0020#, 16#0006#),
         13540 => (16#8CA1#, 16#0000#, 16#0000#),
         13541 => (16#FB40#, 16#0020#, 16#0006#),
         13542 => (16#F95D#, 16#0000#, 16#0000#),
         13543 => (16#FB40#, 16#0020#, 16#0006#),
         13544 => (16#D2B4#, 16#0000#, 16#0000#),
         13545 => (16#FB40#, 16#0020#, 16#0006#),
         13546 => (16#F9D8#, 16#0000#, 16#0000#),
         13547 => (16#FB40#, 16#0020#, 16#0006#),
         13548 => (16#F537#, 16#0000#, 16#0000#),
         13549 => (16#FB40#, 16#0020#, 16#0006#),
         13550 => (16#D973#, 16#0000#, 16#0000#),
         13551 => (16#FB41#, 16#0020#, 16#0006#),
         13552 => (16#9069#, 16#0000#, 16#0000#),
         13553 => (16#FB40#, 16#0020#, 16#0006#),
         13554 => (16#D12A#, 16#0000#, 16#0000#),
         13555 => (16#FB40#, 16#0020#, 16#0006#),
         13556 => (16#D370#, 16#0000#, 16#0000#),
         13557 => (16#FB40#, 16#0020#, 16#0006#),
         13558 => (16#ECE8#, 16#0000#, 16#0000#),
         13559 => (16#FB41#, 16#0020#, 16#0006#),
         13560 => (16#9805#, 16#0000#, 16#0000#),
         13561 => (16#FB40#, 16#0020#, 16#0006#),
         13562 => (16#CF11#, 16#0000#, 16#0000#),
         13563 => (16#FB40#, 16#0020#, 16#0006#),
         13564 => (16#D199#, 16#0000#, 16#0000#),
         13565 => (16#FB40#, 16#0020#, 16#0006#),
         13566 => (16#EB63#, 16#0000#, 16#0000#),
         13567 => (16#FB40#, 16#0020#, 16#0006#),
         13568 => (16#CE0A#, 16#0000#, 16#0000#),
         13569 => (16#FB40#, 16#0020#, 16#0006#),
         13570 => (16#CE2D#, 16#0000#, 16#0000#),
         13571 => (16#FB40#, 16#0020#, 16#0006#),
         13572 => (16#CE0B#, 16#0000#, 16#0000#),
         13573 => (16#FB40#, 16#0020#, 16#0006#),
         13574 => (16#DDE6#, 16#0000#, 16#0000#),
         13575 => (16#FB40#, 16#0020#, 16#0006#),
         13576 => (16#D3F3#, 16#0000#, 16#0000#),
         13577 => (16#FB40#, 16#0020#, 16#0006#),
         13578 => (16#D33B#, 16#0000#, 16#0000#),
         13579 => (16#FB40#, 16#0020#, 16#0006#),
         13580 => (16#DB97#, 16#0000#, 16#0000#),
         13581 => (16#FB40#, 16#0020#, 16#0006#),
         13582 => (16#DB66#, 16#0000#, 16#0000#),
         13583 => (16#FB40#, 16#0020#, 16#0006#),
         13584 => (16#F6E3#, 16#0000#, 16#0000#),
         13585 => (16#FB40#, 16#0020#, 16#0006#),
         13586 => (16#CF01#, 16#0000#, 16#0000#),
         13587 => (16#FB41#, 16#0020#, 16#0006#),
         13588 => (16#8CC7#, 16#0000#, 16#0000#),
         13589 => (16#FB40#, 16#0020#, 16#0006#),
         13590 => (16#D354#, 16#0000#, 16#0000#),
         13591 => (16#FB40#, 16#0020#, 16#0006#),
         13592 => (16#D91C#, 16#0000#, 16#0000#),
         13593 => (16#1806#, 16#0020#, 16#0006#),
         13594 => (16#1809#, 16#0020#, 16#0006#),
         13595 => (16#1806#, 16#0020#, 16#0006#),
         13596 => (16#180A#, 16#0020#, 16#0006#),
         13597 => (16#1806#, 16#0020#, 16#0006#),
         13598 => (16#180B#, 16#0020#, 16#0006#),
         13599 => (16#1806#, 16#0020#, 16#0006#),
         13600 => (16#180C#, 16#0020#, 16#0006#),
         13601 => (16#1807#, 16#0020#, 16#0006#),
         13602 => (16#1806#, 16#0020#, 16#0006#),
         13603 => (16#1807#, 16#0020#, 16#0006#),
         13604 => (16#1807#, 16#0020#, 16#0006#),
         13605 => (16#1807#, 16#0020#, 16#0006#),
         13606 => (16#1809#, 16#0020#, 16#0006#),
         13607 => (16#1807#, 16#0020#, 16#0006#),
         13608 => (16#180A#, 16#0020#, 16#0006#),
         13609 => (16#1807#, 16#0020#, 16#0006#),
         13610 => (16#180B#, 16#0020#, 16#0006#),
         13611 => (16#1807#, 16#0020#, 16#0006#),
         13612 => (16#180C#, 16#0020#, 16#0006#),
         13613 => (16#1804#, 16#0020#, 16#0004#),
         13614 => (16#FB40#, 16#0020#, 16#0004#),
         13615 => (16#E708#, 16#0000#, 16#0000#),
         13616 => (16#1805#, 16#0020#, 16#0004#),
         13617 => (16#FB40#, 16#0020#, 16#0004#),
         13618 => (16#E708#, 16#0000#, 16#0000#),
         13619 => (16#1806#, 16#0020#, 16#0004#),
         13620 => (16#FB40#, 16#0020#, 16#0004#),
         13621 => (16#E708#, 16#0000#, 16#0000#),
         13622 => (16#1807#, 16#0020#, 16#0004#),
         13623 => (16#FB40#, 16#0020#, 16#0004#),
         13624 => (16#E708#, 16#0000#, 16#0000#),
         13625 => (16#1808#, 16#0020#, 16#0004#),
         13626 => (16#FB40#, 16#0020#, 16#0004#),
         13627 => (16#E708#, 16#0000#, 16#0000#),
         13628 => (16#1809#, 16#0020#, 16#0004#),
         13629 => (16#FB40#, 16#0020#, 16#0004#),
         13630 => (16#E708#, 16#0000#, 16#0000#),
         13631 => (16#180A#, 16#0020#, 16#0004#),
         13632 => (16#FB40#, 16#0020#, 16#0004#),
         13633 => (16#E708#, 16#0000#, 16#0000#),
         13634 => (16#180B#, 16#0020#, 16#0004#),
         13635 => (16#FB40#, 16#0020#, 16#0004#),
         13636 => (16#E708#, 16#0000#, 16#0000#),
         13637 => (16#180C#, 16#0020#, 16#0004#),
         13638 => (16#FB40#, 16#0020#, 16#0004#),
         13639 => (16#E708#, 16#0000#, 16#0000#),
         13640 => (16#1804#, 16#0020#, 16#0004#),
         13641 => (16#1803#, 16#0020#, 16#0004#),
         13642 => (16#FB40#, 16#0020#, 16#0004#),
         13643 => (16#E708#, 16#0000#, 16#0000#),
         13644 => (16#1804#, 16#0020#, 16#0004#),
         13645 => (16#1804#, 16#0020#, 16#0004#),
         13646 => (16#FB40#, 16#0020#, 16#0004#),
         13647 => (16#E708#, 16#0000#, 16#0000#),
         13648 => (16#1804#, 16#0020#, 16#0004#),
         13649 => (16#1805#, 16#0020#, 16#0004#),
         13650 => (16#FB40#, 16#0020#, 16#0004#),
         13651 => (16#E708#, 16#0000#, 16#0000#),
         13652 => (16#19DC#, 16#0020#, 16#001D#),
         13653 => (16#19B8#, 16#0020#, 16#001C#),
         13654 => (16#196E#, 16#0020#, 16#001C#),
         13655 => (16#1AF5#, 16#0020#, 16#001C#),
         13656 => (16#19B8#, 16#0020#, 16#001C#),
         13657 => (16#196E#, 16#0020#, 16#001C#),
         13658 => (16#1BA5#, 16#0020#, 16#001D#),
         13659 => (16#1A3B#, 16#0020#, 16#001D#),
         13660 => (16#1B57#, 16#0020#, 16#001D#),
         13661 => (16#1953#, 16#0020#, 16#001D#),
         13662 => (16#3888#, 16#0020#, 16#0013#),
         13663 => (16#3889#, 16#0020#, 16#0013#),
         13664 => (16#388A#, 16#0020#, 16#0013#),
         13665 => (16#388C#, 16#0020#, 16#0013#),
         13666 => (16#388D#, 16#0020#, 16#0013#),
         13667 => (16#388E#, 16#0020#, 16#0013#),
         13668 => (16#388F#, 16#0020#, 16#0013#),
         13669 => (16#3890#, 16#0020#, 16#0013#),
         13670 => (16#3891#, 16#0020#, 16#0013#),
         13671 => (16#3892#, 16#0020#, 16#0013#),
         13672 => (16#3893#, 16#0020#, 16#0013#),
         13673 => (16#3894#, 16#0020#, 16#0013#),
         13674 => (16#3895#, 16#0020#, 16#0013#),
         13675 => (16#3896#, 16#0020#, 16#0013#),
         13676 => (16#3897#, 16#0020#, 16#0013#),
         13677 => (16#3898#, 16#0020#, 16#0013#),
         13678 => (16#3899#, 16#0020#, 16#0013#),
         13679 => (16#389A#, 16#0020#, 16#0013#),
         13680 => (16#389B#, 16#0020#, 16#0013#),
         13681 => (16#389C#, 16#0020#, 16#0013#),
         13682 => (16#389D#, 16#0020#, 16#0013#),
         13683 => (16#389E#, 16#0020#, 16#0013#),
         13684 => (16#389F#, 16#0020#, 16#0013#),
         13685 => (16#38A0#, 16#0020#, 16#0013#),
         13686 => (16#38A1#, 16#0020#, 16#0013#),
         13687 => (16#38A2#, 16#0020#, 16#0013#),
         13688 => (16#38A3#, 16#0020#, 16#0013#),
         13689 => (16#38A4#, 16#0020#, 16#0013#),
         13690 => (16#38A5#, 16#0020#, 16#0013#),
         13691 => (16#38A6#, 16#0020#, 16#0013#),
         13692 => (16#38A7#, 16#0020#, 16#0013#),
         13693 => (16#38A8#, 16#0020#, 16#0013#),
         13694 => (16#38A9#, 16#0020#, 16#0013#),
         13695 => (16#38AA#, 16#0020#, 16#0013#),
         13696 => (16#38AB#, 16#0020#, 16#0013#),
         13697 => (16#38AC#, 16#0020#, 16#0013#),
         13698 => (16#38AD#, 16#0020#, 16#0013#),
         13699 => (16#38AF#, 16#0020#, 16#0013#),
         13700 => (16#38B0#, 16#0020#, 16#0013#),
         13701 => (16#38B1#, 16#0020#, 16#0013#),
         13702 => (16#38B2#, 16#0020#, 16#0013#),
         13703 => (16#38B3#, 16#0020#, 16#0013#),
         13704 => (16#38B4#, 16#0020#, 16#0013#),
         13705 => (16#38B5#, 16#0020#, 16#0013#),
         13706 => (16#38B6#, 16#0020#, 16#0013#),
         13707 => (16#38B7#, 16#0020#, 16#0013#),
         13708 => (16#38B8#, 16#0020#, 16#0013#),
         13709 => (16#3888#, 16#0020#, 16#001C#),
         13710 => (16#38A2#, 16#0020#, 16#001C#),
         13711 => (16#0000#, 16#0038#, 16#001C#),
         13712 => (16#16C6#, 16#0020#, 16#001C#),
         13713 => (16#389C#, 16#0020#, 16#001C#),
         13714 => (16#3888#, 16#0020#, 16#001C#),
         13715 => (16#38B2#, 16#0020#, 16#001C#),
         13716 => (16#38A4#, 16#0020#, 16#001C#),
         13717 => (16#3888#, 16#0020#, 16#001C#),
         13718 => (16#3888#, 16#0020#, 16#001C#),
         13719 => (16#38B9#, 16#0020#, 16#001C#),
         13720 => (16#38A5#, 16#0020#, 16#001C#),
         13721 => (16#0000#, 16#0038#, 16#001C#),
         13722 => (16#3888#, 16#0020#, 16#001C#),
         13723 => (16#3888#, 16#0020#, 16#001C#),
         13724 => (16#16C6#, 16#0020#, 16#001C#),
         13725 => (16#38B2#, 16#0020#, 16#001C#),
         13726 => (16#3889#, 16#0020#, 16#001C#),
         13727 => (16#389E#, 16#0020#, 16#001C#),
         13728 => (16#38B9#, 16#0020#, 16#001C#),
         13729 => (16#3890#, 16#0020#, 16#001C#),
         13730 => (16#0000#, 16#0037#, 16#001C#),
         13731 => (16#3889#, 16#0020#, 16#001C#),
         13732 => (16#38B9#, 16#0020#, 16#001C#),
         13733 => (16#3899#, 16#0020#, 16#001C#),
         13734 => (16#388A#, 16#0020#, 16#001C#),
         13735 => (16#388D#, 16#0020#, 16#001C#),
         13736 => (16#38B9#, 16#0020#, 16#001C#),
         13737 => (16#388C#, 16#0020#, 16#001C#),
         13738 => (16#3895#, 16#0020#, 16#001C#),
         13739 => (16#3890#, 16#0020#, 16#001C#),
         13740 => (16#16C6#, 16#0020#, 16#001C#),
         13741 => (16#389C#, 16#0020#, 16#001C#),
         13742 => (16#0000#, 16#0037#, 16#001C#),
         13743 => (16#388C#, 16#0020#, 16#001C#),
         13744 => (16#16C6#, 16#0020#, 16#001C#),
         13745 => (16#388E#, 16#0020#, 16#001C#),
         13746 => (16#16C6#, 16#0020#, 16#001C#),
         13747 => (16#388D#, 16#0020#, 16#001C#),
         13748 => (16#38B9#, 16#0020#, 16#001C#),
         13749 => (16#3895#, 16#0020#, 16#001C#),
         13750 => (16#388D#, 16#0020#, 16#001C#),
         13751 => (16#16C6#, 16#0020#, 16#001C#),
         13752 => (16#38A9#, 16#0020#, 16#001C#),
         13753 => (16#388E#, 16#0020#, 16#001C#),
         13754 => (16#3889#, 16#0020#, 16#001C#),
         13755 => (16#38B1#, 16#0020#, 16#001C#),
         13756 => (16#388E#, 16#0020#, 16#001C#),
         13757 => (16#38B0#, 16#0020#, 16#001C#),
         13758 => (16#389A#, 16#0020#, 16#001C#),
         13759 => (16#389C#, 16#0020#, 16#001C#),
         13760 => (16#388E#, 16#0020#, 16#001C#),
         13761 => (16#38B4#, 16#0020#, 16#001C#),
         13762 => (16#38B1#, 16#0020#, 16#001C#),
         13763 => (16#16C6#, 16#0020#, 16#001C#),
         13764 => (16#388E#, 16#0020#, 16#001C#),
         13765 => (16#0000#, 16#0037#, 16#001C#),
         13766 => (16#38B4#, 16#0020#, 16#001C#),
         13767 => (16#38B9#, 16#0020#, 16#001C#),
         13768 => (16#388E#, 16#0020#, 16#001C#),
         13769 => (16#0000#, 16#0037#, 16#001C#),
         13770 => (16#38B9#, 16#0020#, 16#001C#),
         13771 => (16#38A7#, 16#0020#, 16#001C#),
         13772 => (16#388F#, 16#0020#, 16#001C#),
         13773 => (16#0000#, 16#0037#, 16#001C#),
         13774 => (16#388E#, 16#0020#, 16#001C#),
         13775 => (16#0000#, 16#0037#, 16#001C#),
         13776 => (16#388F#, 16#0020#, 16#001C#),
         13777 => (16#0000#, 16#0037#, 16#001C#),
         13778 => (16#389E#, 16#0020#, 16#001C#),
         13779 => (16#16C6#, 16#0020#, 16#001C#),
         13780 => (16#388F#, 16#0020#, 16#001C#),
         13781 => (16#38AD#, 16#0020#, 16#001C#),
         13782 => (16#38B1#, 16#0020#, 16#001C#),
         13783 => (16#16C6#, 16#0020#, 16#001C#),
         13784 => (16#388F#, 16#0020#, 16#001C#),
         13785 => (16#0000#, 16#0037#, 16#001C#),
         13786 => (16#38B2#, 16#0020#, 16#001C#),
         13787 => (16#3898#, 16#0020#, 16#001C#),
         13788 => (16#0000#, 16#0037#, 16#001C#),
         13789 => (16#16C6#, 16#0020#, 16#001C#),
         13790 => (16#388F#, 16#0020#, 16#001C#),
         13791 => (16#38B4#, 16#0020#, 16#001C#),
         13792 => (16#388F#, 16#0020#, 16#001C#),
         13793 => (16#38B4#, 16#0020#, 16#001C#),
         13794 => (16#3890#, 16#0020#, 16#001C#),
         13795 => (16#0000#, 16#0037#, 16#001C#),
         13796 => (16#38B0#, 16#0020#, 16#001C#),
         13797 => (16#38A9#, 16#0020#, 16#001C#),
         13798 => (16#388F#, 16#0020#, 16#001C#),
         13799 => (16#38B4#, 16#0020#, 16#001C#),
         13800 => (16#38AA#, 16#0020#, 16#001C#),
         13801 => (16#16C6#, 16#0020#, 16#001C#),
         13802 => (16#389C#, 16#0020#, 16#001C#),
         13803 => (16#38B2#, 16#0020#, 16#001C#),
         13804 => (16#388F#, 16#0020#, 16#001C#),
         13805 => (16#38B4#, 16#0020#, 16#001C#),
         13806 => (16#38B5#, 16#0020#, 16#001C#),
         13807 => (16#389A#, 16#0020#, 16#001C#),
         13808 => (16#389C#, 16#0020#, 16#001C#),
         13809 => (16#3890#, 16#0020#, 16#001C#),
         13810 => (16#0000#, 16#0037#, 16#001C#),
         13811 => (16#38B0#, 16#0020#, 16#001C#),
         13812 => (16#38A9#, 16#0020#, 16#001C#),
         13813 => (16#389C#, 16#0020#, 16#001C#),
         13814 => (16#38B9#, 16#0020#, 16#001C#),
         13815 => (16#3890#, 16#0020#, 16#001C#),
         13816 => (16#38B2#, 16#0020#, 16#001C#),
         13817 => (16#3896#, 16#0020#, 16#001C#),
         13818 => (16#0000#, 16#0037#, 16#001C#),
         13819 => (16#3889#, 16#0020#, 16#001C#),
         13820 => (16#38B4#, 16#0020#, 16#001C#),
         13821 => (16#3890#, 16#0020#, 16#001C#),
         13822 => (16#38B4#, 16#0020#, 16#001C#),
         13823 => (16#16C6#, 16#0020#, 16#001C#),
         13824 => (16#38A0#, 16#0020#, 16#001C#),
         13825 => (16#3891#, 16#0020#, 16#001C#),
         13826 => (16#16C6#, 16#0020#, 16#001C#),
         13827 => (16#3895#, 16#0020#, 16#001C#),
         13828 => (16#3892#, 16#0020#, 16#001C#),
         13829 => (16#38B2#, 16#0020#, 16#001C#),
         13830 => (16#389D#, 16#0020#, 16#001C#),
         13831 => (16#3892#, 16#0020#, 16#001C#),
         13832 => (16#16C6#, 16#0020#, 16#001C#),
         13833 => (16#38A6#, 16#0020#, 16#001C#),
         13834 => (16#0000#, 16#0038#, 16#001C#),
         13835 => (16#3893#, 16#0020#, 16#001C#),
         13836 => (16#3889#, 16#0020#, 16#001C#),
         13837 => (16#3890#, 16#0020#, 16#001C#),
         13838 => (16#38B2#, 16#0020#, 16#001C#),
         13839 => (16#3893#, 16#0020#, 16#001C#),
         13840 => (16#38B9#, 16#0020#, 16#001C#),
         13841 => (16#3899#, 16#0020#, 16#001C#),
         13842 => (16#16C6#, 16#0020#, 16#001C#),
         13843 => (16#38A9#, 16#0020#, 16#001C#),
         13844 => (16#3894#, 16#0020#, 16#001C#),
         13845 => (16#38B1#, 16#0020#, 16#001C#),
         13846 => (16#38B9#, 16#0020#, 16#001C#),
         13847 => (16#3890#, 16#0020#, 16#001C#),
         13848 => (16#0000#, 16#0037#, 16#001C#),
         13849 => (16#3896#, 16#0020#, 16#001C#),
         13850 => (16#38B9#, 16#0020#, 16#001C#),
         13851 => (16#3899#, 16#0020#, 16#001C#),
         13852 => (16#3896#, 16#0020#, 16#001C#),
         13853 => (16#38B9#, 16#0020#, 16#001C#),
         13854 => (16#389C#, 16#0020#, 16#001C#),
         13855 => (16#3898#, 16#0020#, 16#001C#),
         13856 => (16#0000#, 16#0037#, 16#001C#),
         13857 => (16#16C6#, 16#0020#, 16#001C#),
         13858 => (16#3895#, 16#0020#, 16#001C#),
         13859 => (16#389B#, 16#0020#, 16#001C#),
         13860 => (16#0000#, 16#0037#, 16#001C#),
         13861 => (16#3894#, 16#0020#, 16#001C#),
         13862 => (16#389C#, 16#0020#, 16#001C#),
         13863 => (16#0000#, 16#0037#, 16#001C#),
         13864 => (16#38B2#, 16#0020#, 16#001C#),
         13865 => (16#389D#, 16#0020#, 16#001C#),
         13866 => (16#38A1#, 16#0020#, 16#001C#),
         13867 => (16#38A1#, 16#0020#, 16#001C#),
         13868 => (16#389A#, 16#0020#, 16#001C#),
         13869 => (16#389C#, 16#0020#, 16#001C#),
         13870 => (16#38A2#, 16#0020#, 16#001C#),
         13871 => (16#3889#, 16#0020#, 16#001C#),
         13872 => (16#389A#, 16#0020#, 16#001C#),
         13873 => (16#38A2#, 16#0020#, 16#001C#),
         13874 => (16#0000#, 16#0038#, 16#001C#),
         13875 => (16#16C6#, 16#0020#, 16#001C#),
         13876 => (16#3896#, 16#0020#, 16#001C#),
         13877 => (16#38B9#, 16#0020#, 16#001C#),
         13878 => (16#389C#, 16#0020#, 16#001C#),
         13879 => (16#38A2#, 16#0020#, 16#001C#),
         13880 => (16#0000#, 16#0038#, 16#001C#),
         13881 => (16#16C6#, 16#0020#, 16#001C#),
         13882 => (16#389A#, 16#0020#, 16#001C#),
         13883 => (16#38A2#, 16#0020#, 16#001C#),
         13884 => (16#0000#, 16#0037#, 16#001C#),
         13885 => (16#16C6#, 16#0020#, 16#001C#),
         13886 => (16#38B3#, 16#0020#, 16#001C#),
         13887 => (16#38B2#, 16#0020#, 16#001C#),
         13888 => (16#38A3#, 16#0020#, 16#001C#),
         13889 => (16#0000#, 16#0038#, 16#001C#),
         13890 => (16#3888#, 16#0020#, 16#001C#),
         13891 => (16#3895#, 16#0020#, 16#001C#),
         13892 => (16#389C#, 16#0020#, 16#001C#),
         13893 => (16#38B2#, 16#0020#, 16#001C#),
         13894 => (16#38A3#, 16#0020#, 16#001C#),
         13895 => (16#0000#, 16#0038#, 16#001C#),
         13896 => (16#3890#, 16#0020#, 16#001C#),
         13897 => (16#38B2#, 16#0020#, 16#001C#),
         13898 => (16#38A3#, 16#0020#, 16#001C#),
         13899 => (16#0000#, 16#0038#, 16#001C#),
         13900 => (16#3892#, 16#0020#, 16#001C#),
         13901 => (16#38A3#, 16#0020#, 16#001C#),
         13902 => (16#0000#, 16#0037#, 16#001C#),
         13903 => (16#38B2#, 16#0020#, 16#001C#),
         13904 => (16#38A4#, 16#0020#, 16#001C#),
         13905 => (16#3888#, 16#0020#, 16#001C#),
         13906 => (16#38B0#, 16#0020#, 16#001C#),
         13907 => (16#389A#, 16#0020#, 16#001C#),
         13908 => (16#389C#, 16#0020#, 16#001C#),
         13909 => (16#0000#, 16#0037#, 16#001C#),
         13910 => (16#38A4#, 16#0020#, 16#001C#),
         13911 => (16#3889#, 16#0020#, 16#001C#),
         13912 => (16#16C6#, 16#0020#, 16#001C#),
         13913 => (16#389C#, 16#0020#, 16#001C#),
         13914 => (16#38A4#, 16#0020#, 16#001C#),
         13915 => (16#0000#, 16#0037#, 16#001C#),
         13916 => (16#389A#, 16#0020#, 16#001C#),
         13917 => (16#3894#, 16#0020#, 16#001C#),
         13918 => (16#388C#, 16#0020#, 16#001C#),
         13919 => (16#38B2#, 16#0020#, 16#001C#),
         13920 => (16#38A4#, 16#0020#, 16#001C#),
         13921 => (16#38B0#, 16#0020#, 16#001C#),
         13922 => (16#38B9#, 16#0020#, 16#001C#),
         13923 => (16#38A5#, 16#0020#, 16#001C#),
         13924 => (16#3890#, 16#0020#, 16#001C#),
         13925 => (16#3898#, 16#0020#, 16#001C#),
         13926 => (16#16C6#, 16#0020#, 16#001C#),
         13927 => (16#38B2#, 16#0020#, 16#001C#),
         13928 => (16#38A5#, 16#0020#, 16#001C#),
         13929 => (16#0000#, 16#0038#, 16#001C#),
         13930 => (16#3897#, 16#0020#, 16#001C#),
         13931 => (16#38A5#, 16#0020#, 16#001C#),
         13932 => (16#0000#, 16#0038#, 16#001C#),
         13933 => (16#389E#, 16#0020#, 16#001C#),
         13934 => (16#38A3#, 16#0020#, 16#001C#),
         13935 => (16#38A5#, 16#0020#, 16#001C#),
         13936 => (16#38B2#, 16#0020#, 16#001C#),
         13937 => (16#389A#, 16#0020#, 16#001C#),
         13938 => (16#38A5#, 16#0020#, 16#001C#),
         13939 => (16#0000#, 16#0038#, 16#001C#),
         13940 => (16#38B9#, 16#0020#, 16#001C#),
         13941 => (16#3895#, 16#0020#, 16#001C#),
         13942 => (16#38A5#, 16#0020#, 16#001C#),
         13943 => (16#0000#, 16#0038#, 16#001C#),
         13944 => (16#16C6#, 16#0020#, 16#001C#),
         13945 => (16#3894#, 16#0020#, 16#001C#),
         13946 => (16#0000#, 16#0037#, 16#001C#),
         13947 => (16#38A5#, 16#0020#, 16#001C#),
         13948 => (16#0000#, 16#0037#, 16#001C#),
         13949 => (16#16C6#, 16#0020#, 16#001C#),
         13950 => (16#3898#, 16#0020#, 16#001C#),
         13951 => (16#38A6#, 16#0020#, 16#001C#),
         13952 => (16#0000#, 16#0038#, 16#001C#),
         13953 => (16#3889#, 16#0020#, 16#001C#),
         13954 => (16#38B9#, 16#0020#, 16#001C#),
         13955 => (16#389C#, 16#0020#, 16#001C#),
         13956 => (16#38A6#, 16#0020#, 16#001C#),
         13957 => (16#0000#, 16#0037#, 16#001C#),
         13958 => (16#38B2#, 16#0020#, 16#001C#),
         13959 => (16#389C#, 16#0020#, 16#001C#),
         13960 => (16#38A6#, 16#0020#, 16#001C#),
         13961 => (16#38B9#, 16#0020#, 16#001C#),
         13962 => (16#38A6#, 16#0020#, 16#001C#),
         13963 => (16#0000#, 16#0038#, 16#001C#),
         13964 => (16#38B9#, 16#0020#, 16#001C#),
         13965 => (16#389C#, 16#0020#, 16#001C#),
         13966 => (16#0000#, 16#0037#, 16#001C#),
         13967 => (16#38A6#, 16#0020#, 16#001C#),
         13968 => (16#16C6#, 16#0020#, 16#001C#),
         13969 => (16#38B2#, 16#0020#, 16#001C#),
         13970 => (16#38A6#, 16#0020#, 16#001C#),
         13971 => (16#16C6#, 16#0020#, 16#001C#),
         13972 => (16#38B9#, 16#0020#, 16#001C#),
         13973 => (16#38A7#, 16#0020#, 16#001C#),
         13974 => (16#3889#, 16#0020#, 16#001C#),
         13975 => (16#3890#, 16#0020#, 16#001C#),
         13976 => (16#38B4#, 16#0020#, 16#001C#),
         13977 => (16#38A7#, 16#0020#, 16#001C#),
         13978 => (16#3889#, 16#0020#, 16#001C#),
         13979 => (16#38B2#, 16#0020#, 16#001C#),
         13980 => (16#38A7#, 16#0020#, 16#001C#),
         13981 => (16#389A#, 16#0020#, 16#001C#),
         13982 => (16#38A2#, 16#0020#, 16#001C#),
         13983 => (16#38A7#, 16#0020#, 16#001C#),
         13984 => (16#38B2#, 16#0020#, 16#001C#),
         13985 => (16#3890#, 16#0020#, 16#001C#),
         13986 => (16#38A7#, 16#0020#, 16#001C#),
         13987 => (16#38B9#, 16#0020#, 16#001C#),
         13988 => (16#3894#, 16#0020#, 16#001C#),
         13989 => (16#38AF#, 16#0020#, 16#001C#),
         13990 => (16#38B9#, 16#0020#, 16#001C#),
         13991 => (16#38A8#, 16#0020#, 16#001C#),
         13992 => (16#3890#, 16#0020#, 16#001C#),
         13993 => (16#38B4#, 16#0020#, 16#001C#),
         13994 => (16#38B9#, 16#0020#, 16#001C#),
         13995 => (16#38A8#, 16#0020#, 16#001C#),
         13996 => (16#38B1#, 16#0020#, 16#001C#),
         13997 => (16#38A8#, 16#0020#, 16#001C#),
         13998 => (16#38B1#, 16#0020#, 16#001C#),
         13999 => (16#38A2#, 16#0020#, 16#001C#),
         14000 => (16#0000#, 16#0037#, 16#001C#),
         14001 => (16#16C6#, 16#0020#, 16#001C#),
         14002 => (16#38B2#, 16#0020#, 16#001C#),
         14003 => (16#38AA#, 16#0020#, 16#001C#),
         14004 => (16#388E#, 16#0020#, 16#001C#),
         14005 => (16#0000#, 16#0037#, 16#001C#),
         14006 => (16#38AA#, 16#0020#, 16#001C#),
         14007 => (16#388E#, 16#0020#, 16#001C#),
         14008 => (16#0000#, 16#0037#, 16#001C#),
         14009 => (16#389C#, 16#0020#, 16#001C#),
         14010 => (16#38B9#, 16#0020#, 16#001C#),
         14011 => (16#38AC#, 16#0020#, 16#001C#),
         14012 => (16#16C6#, 16#0020#, 16#001C#),
         14013 => (16#389C#, 16#0020#, 16#001C#),
         14014 => (16#0000#, 16#0037#, 16#001C#),
         14015 => (16#38AC#, 16#0020#, 16#001C#),
         14016 => (16#16C6#, 16#0020#, 16#001C#),
         14017 => (16#38B2#, 16#0020#, 16#001C#),
         14018 => (16#38AD#, 16#0020#, 16#001C#),
         14019 => (16#3888#, 16#0020#, 16#001C#),
         14020 => (16#38B9#, 16#0020#, 16#001C#),
         14021 => (16#38B1#, 16#0020#, 16#001C#),
         14022 => (16#389A#, 16#0020#, 16#001C#),
         14023 => (16#389C#, 16#0020#, 16#001C#),
         14024 => (16#38B2#, 16#0020#, 16#001C#),
         14025 => (16#38B1#, 16#0020#, 16#001C#),
         14026 => (16#38B0#, 16#0020#, 16#001C#),
         14027 => (16#38B2#, 16#0020#, 16#001C#),
         14028 => (16#38A3#, 16#0020#, 16#001C#),
         14029 => (16#0000#, 16#0038#, 16#001C#),
         14030 => (16#16C6#, 16#0020#, 16#001C#),
         14031 => (16#38B2#, 16#0020#, 16#001C#),
         14032 => (16#16C6#, 16#0020#, 16#001C#),
         14033 => (16#38A4#, 16#0020#, 16#001C#),
         14034 => (16#0000#, 16#0037#, 16#001C#),
         14035 => (16#38B2#, 16#0020#, 16#001C#),
         14036 => (16#38B3#, 16#0020#, 16#001C#),
         14037 => (16#38A9#, 16#0020#, 16#001C#),
         14038 => (16#38B3#, 16#0020#, 16#001C#),
         14039 => (16#38B9#, 16#0020#, 16#001C#),
         14040 => (16#389C#, 16#0020#, 16#001C#),
         14041 => (16#3891#, 16#0020#, 16#001C#),
         14042 => (16#0000#, 16#0037#, 16#001C#),
         14043 => (16#38B9#, 16#0020#, 16#001C#),
         14044 => (16#1803#, 16#0020#, 16#0004#),
         14045 => (16#FB40#, 16#0020#, 16#0004#),
         14046 => (16#F0B9#, 16#0000#, 16#0000#),
         14047 => (16#1804#, 16#0020#, 16#0004#),
         14048 => (16#FB40#, 16#0020#, 16#0004#),
         14049 => (16#F0B9#, 16#0000#, 16#0000#),
         14050 => (16#1805#, 16#0020#, 16#0004#),
         14051 => (16#FB40#, 16#0020#, 16#0004#),
         14052 => (16#F0B9#, 16#0000#, 16#0000#),
         14053 => (16#1806#, 16#0020#, 16#0004#),
         14054 => (16#FB40#, 16#0020#, 16#0004#),
         14055 => (16#F0B9#, 16#0000#, 16#0000#),
         14056 => (16#1807#, 16#0020#, 16#0004#),
         14057 => (16#FB40#, 16#0020#, 16#0004#),
         14058 => (16#F0B9#, 16#0000#, 16#0000#),
         14059 => (16#1808#, 16#0020#, 16#0004#),
         14060 => (16#FB40#, 16#0020#, 16#0004#),
         14061 => (16#F0B9#, 16#0000#, 16#0000#),
         14062 => (16#1809#, 16#0020#, 16#0004#),
         14063 => (16#FB40#, 16#0020#, 16#0004#),
         14064 => (16#F0B9#, 16#0000#, 16#0000#),
         14065 => (16#180A#, 16#0020#, 16#0004#),
         14066 => (16#FB40#, 16#0020#, 16#0004#),
         14067 => (16#F0B9#, 16#0000#, 16#0000#),
         14068 => (16#180B#, 16#0020#, 16#0004#),
         14069 => (16#FB40#, 16#0020#, 16#0004#),
         14070 => (16#F0B9#, 16#0000#, 16#0000#),
         14071 => (16#180C#, 16#0020#, 16#0004#),
         14072 => (16#FB40#, 16#0020#, 16#0004#),
         14073 => (16#F0B9#, 16#0000#, 16#0000#),
         14074 => (16#1804#, 16#0020#, 16#0004#),
         14075 => (16#1803#, 16#0020#, 16#0004#),
         14076 => (16#FB40#, 16#0020#, 16#0004#),
         14077 => (16#F0B9#, 16#0000#, 16#0000#),
         14078 => (16#1804#, 16#0020#, 16#0004#),
         14079 => (16#1804#, 16#0020#, 16#0004#),
         14080 => (16#FB40#, 16#0020#, 16#0004#),
         14081 => (16#F0B9#, 16#0000#, 16#0000#),
         14082 => (16#1804#, 16#0020#, 16#0004#),
         14083 => (16#1805#, 16#0020#, 16#0004#),
         14084 => (16#FB40#, 16#0020#, 16#0004#),
         14085 => (16#F0B9#, 16#0000#, 16#0000#),
         14086 => (16#1804#, 16#0020#, 16#0004#),
         14087 => (16#1806#, 16#0020#, 16#0004#),
         14088 => (16#FB40#, 16#0020#, 16#0004#),
         14089 => (16#F0B9#, 16#0000#, 16#0000#),
         14090 => (16#1804#, 16#0020#, 16#0004#),
         14091 => (16#1807#, 16#0020#, 16#0004#),
         14092 => (16#FB40#, 16#0020#, 16#0004#),
         14093 => (16#F0B9#, 16#0000#, 16#0000#),
         14094 => (16#1804#, 16#0020#, 16#0004#),
         14095 => (16#1808#, 16#0020#, 16#0004#),
         14096 => (16#FB40#, 16#0020#, 16#0004#),
         14097 => (16#F0B9#, 16#0000#, 16#0000#),
         14098 => (16#1804#, 16#0020#, 16#0004#),
         14099 => (16#1809#, 16#0020#, 16#0004#),
         14100 => (16#FB40#, 16#0020#, 16#0004#),
         14101 => (16#F0B9#, 16#0000#, 16#0000#),
         14102 => (16#1804#, 16#0020#, 16#0004#),
         14103 => (16#180A#, 16#0020#, 16#0004#),
         14104 => (16#FB40#, 16#0020#, 16#0004#),
         14105 => (16#F0B9#, 16#0000#, 16#0000#),
         14106 => (16#1804#, 16#0020#, 16#0004#),
         14107 => (16#180B#, 16#0020#, 16#0004#),
         14108 => (16#FB40#, 16#0020#, 16#0004#),
         14109 => (16#F0B9#, 16#0000#, 16#0000#),
         14110 => (16#1804#, 16#0020#, 16#0004#),
         14111 => (16#180C#, 16#0020#, 16#0004#),
         14112 => (16#FB40#, 16#0020#, 16#0004#),
         14113 => (16#F0B9#, 16#0000#, 16#0000#),
         14114 => (16#1805#, 16#0020#, 16#0004#),
         14115 => (16#1803#, 16#0020#, 16#0004#),
         14116 => (16#FB40#, 16#0020#, 16#0004#),
         14117 => (16#F0B9#, 16#0000#, 16#0000#),
         14118 => (16#1805#, 16#0020#, 16#0004#),
         14119 => (16#1804#, 16#0020#, 16#0004#),
         14120 => (16#FB40#, 16#0020#, 16#0004#),
         14121 => (16#F0B9#, 16#0000#, 16#0000#),
         14122 => (16#1805#, 16#0020#, 16#0004#),
         14123 => (16#1805#, 16#0020#, 16#0004#),
         14124 => (16#FB40#, 16#0020#, 16#0004#),
         14125 => (16#F0B9#, 16#0000#, 16#0000#),
         14126 => (16#1805#, 16#0020#, 16#0004#),
         14127 => (16#1806#, 16#0020#, 16#0004#),
         14128 => (16#FB40#, 16#0020#, 16#0004#),
         14129 => (16#F0B9#, 16#0000#, 16#0000#),
         14130 => (16#1805#, 16#0020#, 16#0004#),
         14131 => (16#1807#, 16#0020#, 16#0004#),
         14132 => (16#FB40#, 16#0020#, 16#0004#),
         14133 => (16#F0B9#, 16#0000#, 16#0000#),
         14134 => (16#19DC#, 16#0020#, 16#001C#),
         14135 => (16#1ACE#, 16#0020#, 16#001D#),
         14136 => (16#190C#, 16#0020#, 16#001C#),
         14137 => (16#1953#, 16#0020#, 16#001C#),
         14138 => (16#190C#, 16#0020#, 16#001C#),
         14139 => (16#190C#, 16#0020#, 16#001D#),
         14140 => (16#1B77#, 16#0020#, 16#001D#),
         14141 => (16#1925#, 16#0020#, 16#001C#),
         14142 => (16#190C#, 16#0020#, 16#001C#),
         14143 => (16#1AF5#, 16#0020#, 16#001C#),
         14144 => (16#1AA1#, 16#0020#, 16#001C#),
         14145 => (16#1BA5#, 16#0020#, 16#001D#),
         14146 => (16#1ACE#, 16#0020#, 16#001C#),
         14147 => (16#193E#, 16#0020#, 16#001C#),
         14148 => (16#1953#, 16#0020#, 16#001C#),
         14149 => (16#1A6E#, 16#0020#, 16#001C#),
         14150 => (16#1953#, 16#0020#, 16#001C#),
         14151 => (16#1A6E#, 16#0020#, 16#001C#),
         14152 => (16#1805#, 16#0020#, 16#001C#),
         14153 => (16#1953#, 16#0020#, 16#001C#),
         14154 => (16#1A6E#, 16#0020#, 16#001C#),
         14155 => (16#1806#, 16#0020#, 16#001C#),
         14156 => (16#19F6#, 16#0020#, 16#001D#),
         14157 => (16#1B77#, 16#0020#, 16#001D#),
         14158 => (16#FB40#, 16#0020#, 16#001C#),
         14159 => (16#DE73#, 16#0000#, 16#0000#),
         14160 => (16#FB40#, 16#0020#, 16#001C#),
         14161 => (16#E210#, 16#0000#, 16#0000#),
         14162 => (16#FB40#, 16#0020#, 16#001C#),
         14163 => (16#E62D#, 16#0000#, 16#0000#),
         14164 => (16#FB40#, 16#0020#, 16#001C#),
         14165 => (16#D48C#, 16#0000#, 16#0000#),
         14166 => (16#FB40#, 16#0020#, 16#001C#),
         14167 => (16#D927#, 16#0000#, 16#0000#),
         14168 => (16#FB40#, 16#0020#, 16#001C#),
         14169 => (16#EB63#, 16#0000#, 16#0000#),
         14170 => (16#FB40#, 16#0020#, 16#001C#),
         14171 => (16#E60E#, 16#0000#, 16#0000#),
         14172 => (16#FB40#, 16#0020#, 16#001C#),
         14173 => (16#ECBB#, 16#0000#, 16#0000#),
         14174 => (16#FB40#, 16#0020#, 16#001C#),
         14175 => (16#E82A#, 16#0000#, 16#0000#),
         14176 => (16#FB40#, 16#0020#, 16#001C#),
         14177 => (16#DF0F#, 16#0000#, 16#0000#),
         14178 => (16#FB40#, 16#0020#, 16#001C#),
         14179 => (16#CF1A#, 16#0000#, 16#0000#),
         14180 => (16#FB40#, 16#0020#, 16#001C#),
         14181 => (16#F93E#, 16#0000#, 16#0000#),
         14182 => (16#1ACE#, 16#0020#, 16#001C#),
         14183 => (16#190C#, 16#0020#, 16#001D#),
         14184 => (16#1A7D#, 16#0020#, 16#001C#),
         14185 => (16#190C#, 16#0020#, 16#001D#),
         14186 => (16#1C89#, 16#0020#, 16#001C#),
         14187 => (16#190C#, 16#0020#, 16#001D#),
         14188 => (16#1A6E#, 16#0020#, 16#001C#),
         14189 => (16#190C#, 16#0020#, 16#001D#),
         14190 => (16#1A29#, 16#0020#, 16#001C#),
         14191 => (16#190C#, 16#0020#, 16#001D#),
         14192 => (16#1A29#, 16#0020#, 16#001D#),
         14193 => (16#1925#, 16#0020#, 16#001D#),
         14194 => (16#1A6E#, 16#0020#, 16#001D#),
         14195 => (16#1925#, 16#0020#, 16#001D#),
         14196 => (16#19B8#, 16#0020#, 16#001D#),
         14197 => (16#1925#, 16#0020#, 16#001D#),
         14198 => (16#193E#, 16#0020#, 16#001C#),
         14199 => (16#190C#, 16#0020#, 16#001C#),
         14200 => (16#1A3B#, 16#0020#, 16#001C#),
         14201 => (16#1A29#, 16#0020#, 16#001C#),
         14202 => (16#193E#, 16#0020#, 16#001C#),
         14203 => (16#190C#, 16#0020#, 16#001C#),
         14204 => (16#1A3B#, 16#0020#, 16#001C#),
         14205 => (16#1ACE#, 16#0020#, 16#001C#),
         14206 => (16#19A9#, 16#0020#, 16#001D#),
         14207 => (16#1A7D#, 16#0020#, 16#001C#),
         14208 => (16#19A9#, 16#0020#, 16#001D#),
         14209 => (16#1C89#, 16#0020#, 16#001C#),
         14210 => (16#19A9#, 16#0020#, 16#001D#),
         14211 => (16#1C89#, 16#0020#, 16#001C#),
         14212 => (16#19B8#, 16#0020#, 16#001C#),
         14213 => (16#1A6E#, 16#0020#, 16#001C#),
         14214 => (16#19B8#, 16#0020#, 16#001C#),
         14215 => (16#1A29#, 16#0020#, 16#001C#),
         14216 => (16#19B8#, 16#0020#, 16#001C#),
         14217 => (16#19DC#, 16#0020#, 16#001D#),
         14218 => (16#1BE3#, 16#0020#, 16#001C#),
         14219 => (16#1A29#, 16#0020#, 16#001C#),
         14220 => (16#19DC#, 16#0020#, 16#001D#),
         14221 => (16#1BE3#, 16#0020#, 16#001C#),
         14222 => (16#1A6E#, 16#0020#, 16#001D#),
         14223 => (16#19DC#, 16#0020#, 16#001D#),
         14224 => (16#1BE3#, 16#0020#, 16#001C#),
         14225 => (16#19B8#, 16#0020#, 16#001D#),
         14226 => (16#19DC#, 16#0020#, 16#001D#),
         14227 => (16#1BE3#, 16#0020#, 16#001C#),
         14228 => (16#1B57#, 16#0020#, 16#001D#),
         14229 => (16#19DC#, 16#0020#, 16#001D#),
         14230 => (16#1BE3#, 16#0020#, 16#001C#),
         14231 => (16#1C89#, 16#0020#, 16#001C#),
         14232 => (16#1A3B#, 16#0020#, 16#001C#),
         14233 => (16#1A6E#, 16#0020#, 16#001C#),
         14234 => (16#1A3B#, 16#0020#, 16#001C#),
         14235 => (16#1953#, 16#0020#, 16#001C#),
         14236 => (16#1A3B#, 16#0020#, 16#001C#),
         14237 => (16#1A29#, 16#0020#, 16#001C#),
         14238 => (16#1A3B#, 16#0020#, 16#001C#),
         14239 => (16#19A9#, 16#0020#, 16#001C#),
         14240 => (16#1A6E#, 16#0020#, 16#001C#),
         14241 => (16#1A7D#, 16#0020#, 16#001C#),
         14242 => (16#1A6E#, 16#0020#, 16#001C#),
         14243 => (16#1C89#, 16#0020#, 16#001C#),
         14244 => (16#1A6E#, 16#0020#, 16#001C#),
         14245 => (16#1A6E#, 16#0020#, 16#001C#),
         14246 => (16#1A6E#, 16#0020#, 16#001C#),
         14247 => (16#193E#, 16#0020#, 16#001C#),
         14248 => (16#1A6E#, 16#0020#, 16#001C#),
         14249 => (16#1A29#, 16#0020#, 16#001C#),
         14250 => (16#1A6E#, 16#0020#, 16#001C#),
         14251 => (16#1A6E#, 16#0020#, 16#001C#),
         14252 => (16#1A6E#, 16#0020#, 16#001C#),
         14253 => (16#1805#, 16#0020#, 16#001C#),
         14254 => (16#193E#, 16#0020#, 16#001C#),
         14255 => (16#1A6E#, 16#0020#, 16#001C#),
         14256 => (16#1805#, 16#0020#, 16#001C#),
         14257 => (16#1A29#, 16#0020#, 16#001C#),
         14258 => (16#1A6E#, 16#0020#, 16#001C#),
         14259 => (16#1805#, 16#0020#, 16#001C#),
         14260 => (16#1A6E#, 16#0020#, 16#001C#),
         14261 => (16#1A6E#, 16#0020#, 16#001C#),
         14262 => (16#1806#, 16#0020#, 16#001C#),
         14263 => (16#193E#, 16#0020#, 16#001C#),
         14264 => (16#1A6E#, 16#0020#, 16#001C#),
         14265 => (16#1806#, 16#0020#, 16#001C#),
         14266 => (16#1A29#, 16#0020#, 16#001C#),
         14267 => (16#1A6E#, 16#0020#, 16#001C#),
         14268 => (16#1806#, 16#0020#, 16#001C#),
         14269 => (16#1A6E#, 16#0020#, 16#001C#),
         14270 => (16#04E5#, 16#0020#, 16#001C#),
         14271 => (16#1B33#, 16#0020#, 16#001C#),
         14272 => (16#1A6E#, 16#0020#, 16#001C#),
         14273 => (16#04E5#, 16#0020#, 16#001C#),
         14274 => (16#1B33#, 16#0020#, 16#001C#),
         14275 => (16#1805#, 16#0020#, 16#001C#),
         14276 => (16#1A29#, 16#0020#, 16#001C#),
         14277 => (16#1ACE#, 16#0020#, 16#001D#),
         14278 => (16#190C#, 16#0020#, 16#001C#),
         14279 => (16#1A6E#, 16#0020#, 16#001D#),
         14280 => (16#1ACE#, 16#0020#, 16#001D#),
         14281 => (16#190C#, 16#0020#, 16#001C#),
         14282 => (16#19B8#, 16#0020#, 16#001D#),
         14283 => (16#1ACE#, 16#0020#, 16#001D#),
         14284 => (16#190C#, 16#0020#, 16#001C#),
         14285 => (16#1AF5#, 16#0020#, 16#001C#),
         14286 => (16#190C#, 16#0020#, 16#001C#),
         14287 => (16#1953#, 16#0020#, 16#001C#),
         14288 => (16#1AF5#, 16#0020#, 16#001C#),
         14289 => (16#190C#, 16#0020#, 16#001C#),
         14290 => (16#1953#, 16#0020#, 16#001C#),
         14291 => (16#04E5#, 16#0020#, 16#001C#),
         14292 => (16#1B33#, 16#0020#, 16#001C#),
         14293 => (16#1AF5#, 16#0020#, 16#001C#),
         14294 => (16#190C#, 16#0020#, 16#001C#),
         14295 => (16#1953#, 16#0020#, 16#001C#),
         14296 => (16#04E5#, 16#0020#, 16#001C#),
         14297 => (16#1B33#, 16#0020#, 16#001C#),
         14298 => (16#1805#, 16#0020#, 16#001C#),
         14299 => (16#1ACE#, 16#0020#, 16#001C#),
         14300 => (16#1B33#, 16#0020#, 16#001C#),
         14301 => (16#1A7D#, 16#0020#, 16#001C#),
         14302 => (16#1B33#, 16#0020#, 16#001C#),
         14303 => (16#1C89#, 16#0020#, 16#001C#),
         14304 => (16#1B33#, 16#0020#, 16#001C#),
         14305 => (16#1A6E#, 16#0020#, 16#001C#),
         14306 => (16#1B33#, 16#0020#, 16#001C#),
         14307 => (16#1ACE#, 16#0020#, 16#001C#),
         14308 => (16#1BA5#, 16#0020#, 16#001D#),
         14309 => (16#1A7D#, 16#0020#, 16#001C#),
         14310 => (16#1BA5#, 16#0020#, 16#001D#),
         14311 => (16#1C89#, 16#0020#, 16#001C#),
         14312 => (16#1BA5#, 16#0020#, 16#001D#),
         14313 => (16#1A6E#, 16#0020#, 16#001C#),
         14314 => (16#1BA5#, 16#0020#, 16#001D#),
         14315 => (16#1A29#, 16#0020#, 16#001C#),
         14316 => (16#1BA5#, 16#0020#, 16#001D#),
         14317 => (16#1A6E#, 16#0020#, 16#001D#),
         14318 => (16#1BA5#, 16#0020#, 16#001D#),
         14319 => (16#1ACE#, 16#0020#, 16#001C#),
         14320 => (16#1BB7#, 16#0020#, 16#001D#),
         14321 => (16#1A7D#, 16#0020#, 16#001C#),
         14322 => (16#1BB7#, 16#0020#, 16#001D#),
         14323 => (16#1C89#, 16#0020#, 16#001C#),
         14324 => (16#1BB7#, 16#0020#, 16#001D#),
         14325 => (16#1A6E#, 16#0020#, 16#001C#),
         14326 => (16#1BB7#, 16#0020#, 16#001D#),
         14327 => (16#1A29#, 16#0020#, 16#001C#),
         14328 => (16#1BB7#, 16#0020#, 16#001D#),
         14329 => (16#1A6E#, 16#0020#, 16#001D#),
         14330 => (16#1BB7#, 16#0020#, 16#001D#),
         14331 => (16#1A29#, 16#0020#, 16#001C#),
         14332 => (16#1C9F#, 16#0020#, 16#001D#),
         14333 => (16#1A6E#, 16#0020#, 16#001D#),
         14334 => (16#1C9F#, 16#0020#, 16#001D#),
         14335 => (16#190C#, 16#0020#, 16#001C#),
         14336 => (16#0173#, 16#0020#, 16#001C#),
         14337 => (16#1A6E#, 16#0020#, 16#001C#),
         14338 => (16#0173#, 16#0020#, 16#001C#),
         14339 => (16#1925#, 16#0020#, 16#001D#),
         14340 => (16#1AE3#, 16#0020#, 16#001C#),
         14341 => (16#193E#, 16#0020#, 16#001C#),
         14342 => (16#193E#, 16#0020#, 16#001C#),
         14343 => (16#193E#, 16#0020#, 16#001D#),
         14344 => (16#04E5#, 16#0020#, 16#001C#),
         14345 => (16#1A29#, 16#0020#, 16#001C#),
         14346 => (16#19B8#, 16#0020#, 16#001C#),
         14347 => (16#193E#, 16#0020#, 16#001D#),
         14348 => (16#1AA1#, 16#0020#, 16#001C#),
         14349 => (16#0173#, 16#0020#, 16#001C#),
         14350 => (16#1953#, 16#0020#, 16#001C#),
         14351 => (16#1925#, 16#0020#, 16#001D#),
         14352 => (16#19B8#, 16#0020#, 16#001D#),
         14353 => (16#1BCD#, 16#0020#, 16#001C#),
         14354 => (16#19DC#, 16#0020#, 16#001C#),
         14355 => (16#190C#, 16#0020#, 16#001C#),
         14356 => (16#19DC#, 16#0020#, 16#001D#),
         14357 => (16#1ACE#, 16#0020#, 16#001D#),
         14358 => (16#19F6#, 16#0020#, 16#001C#),
         14359 => (16#1A7D#, 16#0020#, 16#001C#),
         14360 => (16#1A29#, 16#0020#, 16#001D#),
         14361 => (16#1A29#, 16#0020#, 16#001D#),
         14362 => (16#1A29#, 16#0020#, 16#001D#),
         14363 => (16#1A6E#, 16#0020#, 16#001D#),
         14364 => (16#1A29#, 16#0020#, 16#001C#),
         14365 => (16#1B57#, 16#0020#, 16#001C#),
         14366 => (16#1A3B#, 16#0020#, 16#001C#),
         14367 => (16#1A7D#, 16#0020#, 16#001C#),
         14368 => (16#1A3B#, 16#0020#, 16#001C#),
         14369 => (16#1AA1#, 16#0020#, 16#001C#),
         14370 => (16#19B8#, 16#0020#, 16#001C#),
         14371 => (16#1A3B#, 16#0020#, 16#001C#),
         14372 => (16#1BC1#, 16#0020#, 16#001C#),
         14373 => (16#1A6E#, 16#0020#, 16#001C#),
         14374 => (16#1925#, 16#0020#, 16#001C#),
         14375 => (16#1A6E#, 16#0020#, 16#001C#),
         14376 => (16#19F6#, 16#0020#, 16#001C#),
         14377 => (16#1A3B#, 16#0020#, 16#001C#),
         14378 => (16#1A6E#, 16#0020#, 16#001C#),
         14379 => (16#1AA1#, 16#0020#, 16#001C#),
         14380 => (16#1A3B#, 16#0020#, 16#001C#),
         14381 => (16#1ACE#, 16#0020#, 16#001D#),
         14382 => (16#19DC#, 16#0020#, 16#001D#),
         14383 => (16#1ACE#, 16#0020#, 16#001C#),
         14384 => (16#0173#, 16#0020#, 16#001C#),
         14385 => (16#1A6E#, 16#0020#, 16#001C#),
         14386 => (16#0173#, 16#0020#, 16#001C#),
         14387 => (16#1ACE#, 16#0020#, 16#001D#),
         14388 => (16#1ACE#, 16#0020#, 16#001D#),
         14389 => (16#1A6E#, 16#0020#, 16#001D#),
         14390 => (16#1B33#, 16#0020#, 16#001D#),
         14391 => (16#1BA5#, 16#0020#, 16#001C#),
         14392 => (16#1BB7#, 16#0020#, 16#001D#),
         14393 => (16#1925#, 16#0020#, 16#001C#),
         14394 => (16#1BA5#, 16#0020#, 16#001D#),
         14395 => (16#04E5#, 16#0020#, 16#001C#),
         14396 => (16#1A6E#, 16#0020#, 16#001C#),
         14397 => (16#190C#, 16#0020#, 16#001D#),
         14398 => (16#04E5#, 16#0020#, 16#001C#),
         14399 => (16#1A6E#, 16#0020#, 16#001C#),
         14400 => (16#1804#, 16#0020#, 16#0004#),
         14401 => (16#FB40#, 16#0020#, 16#0004#),
         14402 => (16#E5E5#, 16#0000#, 16#0000#),
         14403 => (16#1805#, 16#0020#, 16#0004#),
         14404 => (16#FB40#, 16#0020#, 16#0004#),
         14405 => (16#E5E5#, 16#0000#, 16#0000#),
         14406 => (16#1806#, 16#0020#, 16#0004#),
         14407 => (16#FB40#, 16#0020#, 16#0004#),
         14408 => (16#E5E5#, 16#0000#, 16#0000#),
         14409 => (16#1807#, 16#0020#, 16#0004#),
         14410 => (16#FB40#, 16#0020#, 16#0004#),
         14411 => (16#E5E5#, 16#0000#, 16#0000#),
         14412 => (16#1808#, 16#0020#, 16#0004#),
         14413 => (16#FB40#, 16#0020#, 16#0004#),
         14414 => (16#E5E5#, 16#0000#, 16#0000#),
         14415 => (16#1809#, 16#0020#, 16#0004#),
         14416 => (16#FB40#, 16#0020#, 16#0004#),
         14417 => (16#E5E5#, 16#0000#, 16#0000#),
         14418 => (16#180A#, 16#0020#, 16#0004#),
         14419 => (16#FB40#, 16#0020#, 16#0004#),
         14420 => (16#E5E5#, 16#0000#, 16#0000#),
         14421 => (16#180B#, 16#0020#, 16#0004#),
         14422 => (16#FB40#, 16#0020#, 16#0004#),
         14423 => (16#E5E5#, 16#0000#, 16#0000#),
         14424 => (16#180C#, 16#0020#, 16#0004#),
         14425 => (16#FB40#, 16#0020#, 16#0004#),
         14426 => (16#E5E5#, 16#0000#, 16#0000#),
         14427 => (16#1804#, 16#0020#, 16#0004#),
         14428 => (16#1803#, 16#0020#, 16#0004#),
         14429 => (16#FB40#, 16#0020#, 16#0004#),
         14430 => (16#E5E5#, 16#0000#, 16#0000#),
         14431 => (16#1804#, 16#0020#, 16#0004#),
         14432 => (16#1804#, 16#0020#, 16#0004#),
         14433 => (16#FB40#, 16#0020#, 16#0004#),
         14434 => (16#E5E5#, 16#0000#, 16#0000#),
         14435 => (16#1804#, 16#0020#, 16#0004#),
         14436 => (16#1805#, 16#0020#, 16#0004#),
         14437 => (16#FB40#, 16#0020#, 16#0004#),
         14438 => (16#E5E5#, 16#0000#, 16#0000#),
         14439 => (16#1804#, 16#0020#, 16#0004#),
         14440 => (16#1806#, 16#0020#, 16#0004#),
         14441 => (16#FB40#, 16#0020#, 16#0004#),
         14442 => (16#E5E5#, 16#0000#, 16#0000#),
         14443 => (16#1804#, 16#0020#, 16#0004#),
         14444 => (16#1807#, 16#0020#, 16#0004#),
         14445 => (16#FB40#, 16#0020#, 16#0004#),
         14446 => (16#E5E5#, 16#0000#, 16#0000#),
         14447 => (16#1804#, 16#0020#, 16#0004#),
         14448 => (16#1808#, 16#0020#, 16#0004#),
         14449 => (16#FB40#, 16#0020#, 16#0004#),
         14450 => (16#E5E5#, 16#0000#, 16#0000#),
         14451 => (16#1804#, 16#0020#, 16#0004#),
         14452 => (16#1809#, 16#0020#, 16#0004#),
         14453 => (16#FB40#, 16#0020#, 16#0004#),
         14454 => (16#E5E5#, 16#0000#, 16#0000#),
         14455 => (16#1804#, 16#0020#, 16#0004#),
         14456 => (16#180A#, 16#0020#, 16#0004#),
         14457 => (16#FB40#, 16#0020#, 16#0004#),
         14458 => (16#E5E5#, 16#0000#, 16#0000#),
         14459 => (16#1804#, 16#0020#, 16#0004#),
         14460 => (16#180B#, 16#0020#, 16#0004#),
         14461 => (16#FB40#, 16#0020#, 16#0004#),
         14462 => (16#E5E5#, 16#0000#, 16#0000#),
         14463 => (16#1804#, 16#0020#, 16#0004#),
         14464 => (16#180C#, 16#0020#, 16#0004#),
         14465 => (16#FB40#, 16#0020#, 16#0004#),
         14466 => (16#E5E5#, 16#0000#, 16#0000#),
         14467 => (16#1805#, 16#0020#, 16#0004#),
         14468 => (16#1803#, 16#0020#, 16#0004#),
         14469 => (16#FB40#, 16#0020#, 16#0004#),
         14470 => (16#E5E5#, 16#0000#, 16#0000#),
         14471 => (16#1805#, 16#0020#, 16#0004#),
         14472 => (16#1804#, 16#0020#, 16#0004#),
         14473 => (16#FB40#, 16#0020#, 16#0004#),
         14474 => (16#E5E5#, 16#0000#, 16#0000#),
         14475 => (16#1805#, 16#0020#, 16#0004#),
         14476 => (16#1805#, 16#0020#, 16#0004#),
         14477 => (16#FB40#, 16#0020#, 16#0004#),
         14478 => (16#E5E5#, 16#0000#, 16#0000#),
         14479 => (16#1805#, 16#0020#, 16#0004#),
         14480 => (16#1806#, 16#0020#, 16#0004#),
         14481 => (16#FB40#, 16#0020#, 16#0004#),
         14482 => (16#E5E5#, 16#0000#, 16#0000#),
         14483 => (16#1805#, 16#0020#, 16#0004#),
         14484 => (16#1807#, 16#0020#, 16#0004#),
         14485 => (16#FB40#, 16#0020#, 16#0004#),
         14486 => (16#E5E5#, 16#0000#, 16#0000#),
         14487 => (16#1805#, 16#0020#, 16#0004#),
         14488 => (16#1808#, 16#0020#, 16#0004#),
         14489 => (16#FB40#, 16#0020#, 16#0004#),
         14490 => (16#E5E5#, 16#0000#, 16#0000#),
         14491 => (16#1805#, 16#0020#, 16#0004#),
         14492 => (16#1809#, 16#0020#, 16#0004#),
         14493 => (16#FB40#, 16#0020#, 16#0004#),
         14494 => (16#E5E5#, 16#0000#, 16#0000#),
         14495 => (16#1805#, 16#0020#, 16#0004#),
         14496 => (16#180A#, 16#0020#, 16#0004#),
         14497 => (16#FB40#, 16#0020#, 16#0004#),
         14498 => (16#E5E5#, 16#0000#, 16#0000#),
         14499 => (16#1805#, 16#0020#, 16#0004#),
         14500 => (16#180B#, 16#0020#, 16#0004#),
         14501 => (16#FB40#, 16#0020#, 16#0004#),
         14502 => (16#E5E5#, 16#0000#, 16#0000#),
         14503 => (16#1805#, 16#0020#, 16#0004#),
         14504 => (16#180C#, 16#0020#, 16#0004#),
         14505 => (16#FB40#, 16#0020#, 16#0004#),
         14506 => (16#E5E5#, 16#0000#, 16#0000#),
         14507 => (16#1806#, 16#0020#, 16#0004#),
         14508 => (16#1803#, 16#0020#, 16#0004#),
         14509 => (16#FB40#, 16#0020#, 16#0004#),
         14510 => (16#E5E5#, 16#0000#, 16#0000#),
         14511 => (16#1806#, 16#0020#, 16#0004#),
         14512 => (16#1804#, 16#0020#, 16#0004#),
         14513 => (16#FB40#, 16#0020#, 16#0004#),
         14514 => (16#E5E5#, 16#0000#, 16#0000#),
         14515 => (16#19B8#, 16#0020#, 16#001C#),
         14516 => (16#190C#, 16#0020#, 16#001C#),
         14517 => (16#1A3B#, 16#0020#, 16#001C#),
         14518 => (16#0D62#, 16#0020#, 16#0002#),
         14519 => (16#0D63#, 16#0020#, 16#0002#),
         14520 => (16#0D64#, 16#0020#, 16#0002#),
         14521 => (16#0D65#, 16#0020#, 16#0002#),
         14522 => (16#0D66#, 16#0020#, 16#0002#),
         14523 => (16#0D67#, 16#0020#, 16#0002#),
         14524 => (16#0D68#, 16#0020#, 16#0002#),
         14525 => (16#0D69#, 16#0020#, 16#0002#),
         14526 => (16#0D6A#, 16#0020#, 16#0002#),
         14527 => (16#0D6B#, 16#0020#, 16#0002#),
         14528 => (16#0D6C#, 16#0020#, 16#0002#),
         14529 => (16#0D6D#, 16#0020#, 16#0002#),
         14530 => (16#0D6E#, 16#0020#, 16#0002#),
         14531 => (16#0D6F#, 16#0020#, 16#0002#),
         14532 => (16#0D70#, 16#0020#, 16#0002#),
         14533 => (16#0D71#, 16#0020#, 16#0002#),
         14534 => (16#0D72#, 16#0020#, 16#0002#),
         14535 => (16#0D73#, 16#0020#, 16#0002#),
         14536 => (16#0D74#, 16#0020#, 16#0002#),
         14537 => (16#0D75#, 16#0020#, 16#0002#),
         14538 => (16#0D76#, 16#0020#, 16#0002#),
         14539 => (16#0D77#, 16#0020#, 16#0002#),
         14540 => (16#0D78#, 16#0020#, 16#0002#),
         14541 => (16#0D79#, 16#0020#, 16#0002#),
         14542 => (16#0D7A#, 16#0020#, 16#0002#),
         14543 => (16#0D7B#, 16#0020#, 16#0002#),
         14544 => (16#0D7C#, 16#0020#, 16#0002#),
         14545 => (16#0D7D#, 16#0020#, 16#0002#),
         14546 => (16#0D7E#, 16#0020#, 16#0002#),
         14547 => (16#0D7F#, 16#0020#, 16#0002#),
         14548 => (16#0D80#, 16#0020#, 16#0002#),
         14549 => (16#0D81#, 16#0020#, 16#0002#),
         14550 => (16#0D82#, 16#0020#, 16#0002#),
         14551 => (16#0D83#, 16#0020#, 16#0002#),
         14552 => (16#0D84#, 16#0020#, 16#0002#),
         14553 => (16#0D85#, 16#0020#, 16#0002#),
         14554 => (16#0D86#, 16#0020#, 16#0002#),
         14555 => (16#0D87#, 16#0020#, 16#0002#),
         14556 => (16#0D88#, 16#0020#, 16#0002#),
         14557 => (16#0D89#, 16#0020#, 16#0002#),
         14558 => (16#0D8A#, 16#0020#, 16#0002#),
         14559 => (16#0D8B#, 16#0020#, 16#0002#),
         14560 => (16#0D8C#, 16#0020#, 16#0002#),
         14561 => (16#0D8D#, 16#0020#, 16#0002#),
         14562 => (16#0D8E#, 16#0020#, 16#0002#),
         14563 => (16#0D8F#, 16#0020#, 16#0002#),
         14564 => (16#0D90#, 16#0020#, 16#0002#),
         14565 => (16#0D91#, 16#0020#, 16#0002#),
         14566 => (16#0D92#, 16#0020#, 16#0002#),
         14567 => (16#0D93#, 16#0020#, 16#0002#),
         14568 => (16#0D94#, 16#0020#, 16#0002#),
         14569 => (16#0D95#, 16#0020#, 16#0002#),
         14570 => (16#0D96#, 16#0020#, 16#0002#),
         14571 => (16#0D97#, 16#0020#, 16#0002#),
         14572 => (16#0D98#, 16#0020#, 16#0002#),
         14573 => (16#0D99#, 16#0020#, 16#0002#),
         14574 => (16#0D9A#, 16#0020#, 16#0002#),
         14575 => (16#0D9B#, 16#0020#, 16#0002#),
         14576 => (16#0D9C#, 16#0020#, 16#0002#),
         14577 => (16#0D9D#, 16#0020#, 16#0002#),
         14578 => (16#0D9E#, 16#0020#, 16#0002#),
         14579 => (16#0D9F#, 16#0020#, 16#0002#),
         14580 => (16#0DA0#, 16#0020#, 16#0002#),
         14581 => (16#0DA1#, 16#0020#, 16#0002#),
         14582 => (16#38ED#, 16#0020#, 16#0002#),
         14583 => (16#38EE#, 16#0020#, 16#0002#),
         14584 => (16#38EF#, 16#0020#, 16#0002#),
         14585 => (16#38F0#, 16#0020#, 16#0002#),
         14586 => (16#38F1#, 16#0020#, 16#0002#),
         14587 => (16#38F2#, 16#0020#, 16#0002#),
         14588 => (16#38F3#, 16#0020#, 16#0002#),
         14589 => (16#38F4#, 16#0020#, 16#0002#),
         14590 => (16#38F5#, 16#0020#, 16#0002#),
         14591 => (16#38F6#, 16#0020#, 16#0002#),
         14592 => (16#38F7#, 16#0020#, 16#0002#),
         14593 => (16#38F8#, 16#0020#, 16#0002#),
         14594 => (16#38F9#, 16#0020#, 16#0002#),
         14595 => (16#38FA#, 16#0020#, 16#0002#),
         14596 => (16#38FB#, 16#0020#, 16#0002#),
         14597 => (16#38FC#, 16#0020#, 16#0002#),
         14598 => (16#38FD#, 16#0020#, 16#0002#),
         14599 => (16#38FE#, 16#0020#, 16#0002#),
         14600 => (16#38FF#, 16#0020#, 16#0002#),
         14601 => (16#3900#, 16#0020#, 16#0002#),
         14602 => (16#3901#, 16#0020#, 16#0002#),
         14603 => (16#3902#, 16#0020#, 16#0002#),
         14604 => (16#3903#, 16#0020#, 16#0002#),
         14605 => (16#3904#, 16#0020#, 16#0002#),
         14606 => (16#3905#, 16#0020#, 16#0002#),
         14607 => (16#3906#, 16#0020#, 16#0002#),
         14608 => (16#3907#, 16#0020#, 16#0002#),
         14609 => (16#3908#, 16#0020#, 16#0002#),
         14610 => (16#3909#, 16#0020#, 16#0002#),
         14611 => (16#390A#, 16#0020#, 16#0002#),
         14612 => (16#390B#, 16#0020#, 16#0002#),
         14613 => (16#390C#, 16#0020#, 16#0002#),
         14614 => (16#390D#, 16#0020#, 16#0002#),
         14615 => (16#390E#, 16#0020#, 16#0002#),
         14616 => (16#390F#, 16#0020#, 16#0002#),
         14617 => (16#3910#, 16#0020#, 16#0002#),
         14618 => (16#3911#, 16#0020#, 16#0002#),
         14619 => (16#3912#, 16#0020#, 16#0002#),
         14620 => (16#3913#, 16#0020#, 16#0002#),
         14621 => (16#3914#, 16#0020#, 16#0002#),
         14622 => (16#3915#, 16#0020#, 16#0002#),
         14623 => (16#3916#, 16#0020#, 16#0002#),
         14624 => (16#3917#, 16#0020#, 16#0002#),
         14625 => (16#3918#, 16#0020#, 16#0002#),
         14626 => (16#3919#, 16#0020#, 16#0002#),
         14627 => (16#391A#, 16#0020#, 16#0002#),
         14628 => (16#391B#, 16#0020#, 16#0002#),
         14629 => (16#391C#, 16#0020#, 16#0002#),
         14630 => (16#391D#, 16#0020#, 16#0002#),
         14631 => (16#391E#, 16#0020#, 16#0002#),
         14632 => (16#391F#, 16#0020#, 16#0002#),
         14633 => (16#3920#, 16#0020#, 16#0002#),
         14634 => (16#3921#, 16#0020#, 16#0002#),
         14635 => (16#3922#, 16#0020#, 16#0002#),
         14636 => (16#3923#, 16#0020#, 16#0002#),
         14637 => (16#3924#, 16#0020#, 16#0002#),
         14638 => (16#3925#, 16#0020#, 16#0002#),
         14639 => (16#3926#, 16#0020#, 16#0002#),
         14640 => (16#3927#, 16#0020#, 16#0002#),
         14641 => (16#3928#, 16#0020#, 16#0002#),
         14642 => (16#3929#, 16#0020#, 16#0002#),
         14643 => (16#392A#, 16#0020#, 16#0002#),
         14644 => (16#392B#, 16#0020#, 16#0002#),
         14645 => (16#392C#, 16#0020#, 16#0002#),
         14646 => (16#392D#, 16#0020#, 16#0002#),
         14647 => (16#392E#, 16#0020#, 16#0002#),
         14648 => (16#392F#, 16#0020#, 16#0002#),
         14649 => (16#3930#, 16#0020#, 16#0002#),
         14650 => (16#3931#, 16#0020#, 16#0002#),
         14651 => (16#3932#, 16#0020#, 16#0002#),
         14652 => (16#3933#, 16#0020#, 16#0002#),
         14653 => (16#3934#, 16#0020#, 16#0002#),
         14654 => (16#3935#, 16#0020#, 16#0002#),
         14655 => (16#3936#, 16#0020#, 16#0002#),
         14656 => (16#3937#, 16#0020#, 16#0002#),
         14657 => (16#3938#, 16#0020#, 16#0002#),
         14658 => (16#3939#, 16#0020#, 16#0002#),
         14659 => (16#393A#, 16#0020#, 16#0002#),
         14660 => (16#393B#, 16#0020#, 16#0002#),
         14661 => (16#393C#, 16#0020#, 16#0002#),
         14662 => (16#393D#, 16#0020#, 16#0002#),
         14663 => (16#393E#, 16#0020#, 16#0002#),
         14664 => (16#393F#, 16#0020#, 16#0002#),
         14665 => (16#3940#, 16#0020#, 16#0002#),
         14666 => (16#3941#, 16#0020#, 16#0002#),
         14667 => (16#3942#, 16#0020#, 16#0002#),
         14668 => (16#3943#, 16#0020#, 16#0002#),
         14669 => (16#3944#, 16#0020#, 16#0002#),
         14670 => (16#3945#, 16#0020#, 16#0002#),
         14671 => (16#3946#, 16#0020#, 16#0002#),
         14672 => (16#3947#, 16#0020#, 16#0002#),
         14673 => (16#3948#, 16#0020#, 16#0002#),
         14674 => (16#3949#, 16#0020#, 16#0002#),
         14675 => (16#394A#, 16#0020#, 16#0002#),
         14676 => (16#394B#, 16#0020#, 16#0002#),
         14677 => (16#394C#, 16#0020#, 16#0002#),
         14678 => (16#394D#, 16#0020#, 16#0002#),
         14679 => (16#394E#, 16#0020#, 16#0002#),
         14680 => (16#394F#, 16#0020#, 16#0002#),
         14681 => (16#3950#, 16#0020#, 16#0002#),
         14682 => (16#3951#, 16#0020#, 16#0002#),
         14683 => (16#3952#, 16#0020#, 16#0002#),
         14684 => (16#3953#, 16#0020#, 16#0002#),
         14685 => (16#3954#, 16#0020#, 16#0002#),
         14686 => (16#3955#, 16#0020#, 16#0002#),
         14687 => (16#3956#, 16#0020#, 16#0002#),
         14688 => (16#3957#, 16#0020#, 16#0002#),
         14689 => (16#3958#, 16#0020#, 16#0002#),
         14690 => (16#3959#, 16#0020#, 16#0002#),
         14691 => (16#395A#, 16#0020#, 16#0002#),
         14692 => (16#395B#, 16#0020#, 16#0002#),
         14693 => (16#395C#, 16#0020#, 16#0002#),
         14694 => (16#395D#, 16#0020#, 16#0002#),
         14695 => (16#395E#, 16#0020#, 16#0002#),
         14696 => (16#395F#, 16#0020#, 16#0002#),
         14697 => (16#3960#, 16#0020#, 16#0002#),
         14698 => (16#3961#, 16#0020#, 16#0002#),
         14699 => (16#3962#, 16#0020#, 16#0002#),
         14700 => (16#3963#, 16#0020#, 16#0002#),
         14701 => (16#3964#, 16#0020#, 16#0002#),
         14702 => (16#3965#, 16#0020#, 16#0002#),
         14703 => (16#3966#, 16#0020#, 16#0002#),
         14704 => (16#3967#, 16#0020#, 16#0002#),
         14705 => (16#3968#, 16#0020#, 16#0002#),
         14706 => (16#3969#, 16#0020#, 16#0002#),
         14707 => (16#396A#, 16#0020#, 16#0002#),
         14708 => (16#396B#, 16#0020#, 16#0002#),
         14709 => (16#396C#, 16#0020#, 16#0002#),
         14710 => (16#396D#, 16#0020#, 16#0002#),
         14711 => (16#396E#, 16#0020#, 16#0002#),
         14712 => (16#396F#, 16#0020#, 16#0002#),
         14713 => (16#3970#, 16#0020#, 16#0002#),
         14714 => (16#3971#, 16#0020#, 16#0002#),
         14715 => (16#3972#, 16#0020#, 16#0002#),
         14716 => (16#3973#, 16#0020#, 16#0002#),
         14717 => (16#3974#, 16#0020#, 16#0002#),
         14718 => (16#3975#, 16#0020#, 16#0002#),
         14719 => (16#3976#, 16#0020#, 16#0002#),
         14720 => (16#3977#, 16#0020#, 16#0002#),
         14721 => (16#3978#, 16#0020#, 16#0002#),
         14722 => (16#3979#, 16#0020#, 16#0002#),
         14723 => (16#397A#, 16#0020#, 16#0002#),
         14724 => (16#397B#, 16#0020#, 16#0002#),
         14725 => (16#397C#, 16#0020#, 16#0002#),
         14726 => (16#397D#, 16#0020#, 16#0002#),
         14727 => (16#397E#, 16#0020#, 16#0002#),
         14728 => (16#397F#, 16#0020#, 16#0002#),
         14729 => (16#3980#, 16#0020#, 16#0002#),
         14730 => (16#3981#, 16#0020#, 16#0002#),
         14731 => (16#3982#, 16#0020#, 16#0002#),
         14732 => (16#3983#, 16#0020#, 16#0002#),
         14733 => (16#3984#, 16#0020#, 16#0002#),
         14734 => (16#3985#, 16#0020#, 16#0002#),
         14735 => (16#3986#, 16#0020#, 16#0002#),
         14736 => (16#3987#, 16#0020#, 16#0002#),
         14737 => (16#3988#, 16#0020#, 16#0002#),
         14738 => (16#3989#, 16#0020#, 16#0002#),
         14739 => (16#398A#, 16#0020#, 16#0002#),
         14740 => (16#398B#, 16#0020#, 16#0002#),
         14741 => (16#398C#, 16#0020#, 16#0002#),
         14742 => (16#398D#, 16#0020#, 16#0002#),
         14743 => (16#398E#, 16#0020#, 16#0002#),
         14744 => (16#398F#, 16#0020#, 16#0002#),
         14745 => (16#3990#, 16#0020#, 16#0002#),
         14746 => (16#3991#, 16#0020#, 16#0002#),
         14747 => (16#3992#, 16#0020#, 16#0002#),
         14748 => (16#3993#, 16#0020#, 16#0002#),
         14749 => (16#3994#, 16#0020#, 16#0002#),
         14750 => (16#3995#, 16#0020#, 16#0002#),
         14751 => (16#3996#, 16#0020#, 16#0002#),
         14752 => (16#3997#, 16#0020#, 16#0002#),
         14753 => (16#3998#, 16#0020#, 16#0002#),
         14754 => (16#3999#, 16#0020#, 16#0002#),
         14755 => (16#399A#, 16#0020#, 16#0002#),
         14756 => (16#399B#, 16#0020#, 16#0002#),
         14757 => (16#399C#, 16#0020#, 16#0002#),
         14758 => (16#399D#, 16#0020#, 16#0002#),
         14759 => (16#399E#, 16#0020#, 16#0002#),
         14760 => (16#399F#, 16#0020#, 16#0002#),
         14761 => (16#39A0#, 16#0020#, 16#0002#),
         14762 => (16#39A1#, 16#0020#, 16#0002#),
         14763 => (16#39A2#, 16#0020#, 16#0002#),
         14764 => (16#39A3#, 16#0020#, 16#0002#),
         14765 => (16#39A4#, 16#0020#, 16#0002#),
         14766 => (16#39A5#, 16#0020#, 16#0002#),
         14767 => (16#39A6#, 16#0020#, 16#0002#),
         14768 => (16#39A7#, 16#0020#, 16#0002#),
         14769 => (16#39A8#, 16#0020#, 16#0002#),
         14770 => (16#39A9#, 16#0020#, 16#0002#),
         14771 => (16#39AA#, 16#0020#, 16#0002#),
         14772 => (16#39AB#, 16#0020#, 16#0002#),
         14773 => (16#39AC#, 16#0020#, 16#0002#),
         14774 => (16#39AD#, 16#0020#, 16#0002#),
         14775 => (16#39AE#, 16#0020#, 16#0002#),
         14776 => (16#39AF#, 16#0020#, 16#0002#),
         14777 => (16#39B0#, 16#0020#, 16#0002#),
         14778 => (16#39B1#, 16#0020#, 16#0002#),
         14779 => (16#39B2#, 16#0020#, 16#0002#),
         14780 => (16#39B3#, 16#0020#, 16#0002#),
         14781 => (16#39B4#, 16#0020#, 16#0002#),
         14782 => (16#39B5#, 16#0020#, 16#0002#),
         14783 => (16#39B6#, 16#0020#, 16#0002#),
         14784 => (16#39B7#, 16#0020#, 16#0002#),
         14785 => (16#39B8#, 16#0020#, 16#0002#),
         14786 => (16#39B9#, 16#0020#, 16#0002#),
         14787 => (16#39BA#, 16#0020#, 16#0002#),
         14788 => (16#39BB#, 16#0020#, 16#0002#),
         14789 => (16#39BC#, 16#0020#, 16#0002#),
         14790 => (16#39BD#, 16#0020#, 16#0002#),
         14791 => (16#39BE#, 16#0020#, 16#0002#),
         14792 => (16#39BF#, 16#0020#, 16#0002#),
         14793 => (16#39C0#, 16#0020#, 16#0002#),
         14794 => (16#39C1#, 16#0020#, 16#0002#),
         14795 => (16#39C2#, 16#0020#, 16#0002#),
         14796 => (16#39C3#, 16#0020#, 16#0002#),
         14797 => (16#39C4#, 16#0020#, 16#0002#),
         14798 => (16#39C5#, 16#0020#, 16#0002#),
         14799 => (16#39C6#, 16#0020#, 16#0002#),
         14800 => (16#39C7#, 16#0020#, 16#0002#),
         14801 => (16#39C8#, 16#0020#, 16#0002#),
         14802 => (16#39C9#, 16#0020#, 16#0002#),
         14803 => (16#39CA#, 16#0020#, 16#0002#),
         14804 => (16#39CB#, 16#0020#, 16#0002#),
         14805 => (16#39CC#, 16#0020#, 16#0002#),
         14806 => (16#39CD#, 16#0020#, 16#0002#),
         14807 => (16#39CE#, 16#0020#, 16#0002#),
         14808 => (16#39CF#, 16#0020#, 16#0002#),
         14809 => (16#39D0#, 16#0020#, 16#0002#),
         14810 => (16#39D1#, 16#0020#, 16#0002#),
         14811 => (16#39D2#, 16#0020#, 16#0002#),
         14812 => (16#39D3#, 16#0020#, 16#0002#),
         14813 => (16#39D4#, 16#0020#, 16#0002#),
         14814 => (16#39D5#, 16#0020#, 16#0002#),
         14815 => (16#39D6#, 16#0020#, 16#0002#),
         14816 => (16#39D7#, 16#0020#, 16#0002#),
         14817 => (16#39D8#, 16#0020#, 16#0002#),
         14818 => (16#39D9#, 16#0020#, 16#0002#),
         14819 => (16#39DA#, 16#0020#, 16#0002#),
         14820 => (16#39DB#, 16#0020#, 16#0002#),
         14821 => (16#39DC#, 16#0020#, 16#0002#),
         14822 => (16#39DD#, 16#0020#, 16#0002#),
         14823 => (16#39DE#, 16#0020#, 16#0002#),
         14824 => (16#39DF#, 16#0020#, 16#0002#),
         14825 => (16#39E0#, 16#0020#, 16#0002#),
         14826 => (16#39E1#, 16#0020#, 16#0002#),
         14827 => (16#39E2#, 16#0020#, 16#0002#),
         14828 => (16#39E3#, 16#0020#, 16#0002#),
         14829 => (16#39E4#, 16#0020#, 16#0002#),
         14830 => (16#39E5#, 16#0020#, 16#0002#),
         14831 => (16#39E6#, 16#0020#, 16#0002#),
         14832 => (16#39E7#, 16#0020#, 16#0002#),
         14833 => (16#39E8#, 16#0020#, 16#0002#),
         14834 => (16#39E9#, 16#0020#, 16#0002#),
         14835 => (16#39EA#, 16#0020#, 16#0002#),
         14836 => (16#39EB#, 16#0020#, 16#0002#),
         14837 => (16#39EC#, 16#0020#, 16#0002#),
         14838 => (16#39ED#, 16#0020#, 16#0002#),
         14839 => (16#39EE#, 16#0020#, 16#0002#),
         14840 => (16#39EF#, 16#0020#, 16#0002#),
         14841 => (16#39F0#, 16#0020#, 16#0002#),
         14842 => (16#39F1#, 16#0020#, 16#0002#),
         14843 => (16#39F2#, 16#0020#, 16#0002#),
         14844 => (16#39F3#, 16#0020#, 16#0002#),
         14845 => (16#39F4#, 16#0020#, 16#0002#),
         14846 => (16#39F5#, 16#0020#, 16#0002#),
         14847 => (16#39F6#, 16#0020#, 16#0002#),
         14848 => (16#39F7#, 16#0020#, 16#0002#),
         14849 => (16#39F8#, 16#0020#, 16#0002#),
         14850 => (16#39F9#, 16#0020#, 16#0002#),
         14851 => (16#39FA#, 16#0020#, 16#0002#),
         14852 => (16#39FB#, 16#0020#, 16#0002#),
         14853 => (16#39FC#, 16#0020#, 16#0002#),
         14854 => (16#39FD#, 16#0020#, 16#0002#),
         14855 => (16#39FE#, 16#0020#, 16#0002#),
         14856 => (16#39FF#, 16#0020#, 16#0002#),
         14857 => (16#3A00#, 16#0020#, 16#0002#),
         14858 => (16#3A01#, 16#0020#, 16#0002#),
         14859 => (16#3A02#, 16#0020#, 16#0002#),
         14860 => (16#3A03#, 16#0020#, 16#0002#),
         14861 => (16#3A04#, 16#0020#, 16#0002#),
         14862 => (16#3A05#, 16#0020#, 16#0002#),
         14863 => (16#3A06#, 16#0020#, 16#0002#),
         14864 => (16#3A07#, 16#0020#, 16#0002#),
         14865 => (16#3A08#, 16#0020#, 16#0002#),
         14866 => (16#3A09#, 16#0020#, 16#0002#),
         14867 => (16#3A0A#, 16#0020#, 16#0002#),
         14868 => (16#3A0B#, 16#0020#, 16#0002#),
         14869 => (16#3A0C#, 16#0020#, 16#0002#),
         14870 => (16#3A0D#, 16#0020#, 16#0002#),
         14871 => (16#3A0E#, 16#0020#, 16#0002#),
         14872 => (16#3A0F#, 16#0020#, 16#0002#),
         14873 => (16#3A10#, 16#0020#, 16#0002#),
         14874 => (16#3A11#, 16#0020#, 16#0002#),
         14875 => (16#3A12#, 16#0020#, 16#0002#),
         14876 => (16#3A13#, 16#0020#, 16#0002#),
         14877 => (16#3A14#, 16#0020#, 16#0002#),
         14878 => (16#3A15#, 16#0020#, 16#0002#),
         14879 => (16#3A16#, 16#0020#, 16#0002#),
         14880 => (16#3A17#, 16#0020#, 16#0002#),
         14881 => (16#3A18#, 16#0020#, 16#0002#),
         14882 => (16#3A19#, 16#0020#, 16#0002#),
         14883 => (16#3A1A#, 16#0020#, 16#0002#),
         14884 => (16#3A1B#, 16#0020#, 16#0002#),
         14885 => (16#3A1C#, 16#0020#, 16#0002#),
         14886 => (16#3A1D#, 16#0020#, 16#0002#),
         14887 => (16#3A1E#, 16#0020#, 16#0002#),
         14888 => (16#3A1F#, 16#0020#, 16#0002#),
         14889 => (16#3A20#, 16#0020#, 16#0002#),
         14890 => (16#3A21#, 16#0020#, 16#0002#),
         14891 => (16#3A22#, 16#0020#, 16#0002#),
         14892 => (16#3A23#, 16#0020#, 16#0002#),
         14893 => (16#3A24#, 16#0020#, 16#0002#),
         14894 => (16#3A25#, 16#0020#, 16#0002#),
         14895 => (16#3A26#, 16#0020#, 16#0002#),
         14896 => (16#3A27#, 16#0020#, 16#0002#),
         14897 => (16#3A28#, 16#0020#, 16#0002#),
         14898 => (16#3A29#, 16#0020#, 16#0002#),
         14899 => (16#3A2A#, 16#0020#, 16#0002#),
         14900 => (16#3A2B#, 16#0020#, 16#0002#),
         14901 => (16#3A2C#, 16#0020#, 16#0002#),
         14902 => (16#3A2D#, 16#0020#, 16#0002#),
         14903 => (16#3A2E#, 16#0020#, 16#0002#),
         14904 => (16#3A2F#, 16#0020#, 16#0002#),
         14905 => (16#3A30#, 16#0020#, 16#0002#),
         14906 => (16#3A31#, 16#0020#, 16#0002#),
         14907 => (16#3A32#, 16#0020#, 16#0002#),
         14908 => (16#3A33#, 16#0020#, 16#0002#),
         14909 => (16#3A34#, 16#0020#, 16#0002#),
         14910 => (16#3A35#, 16#0020#, 16#0002#),
         14911 => (16#3A36#, 16#0020#, 16#0002#),
         14912 => (16#3A37#, 16#0020#, 16#0002#),
         14913 => (16#3A38#, 16#0020#, 16#0002#),
         14914 => (16#3A39#, 16#0020#, 16#0002#),
         14915 => (16#3A3A#, 16#0020#, 16#0002#),
         14916 => (16#3A3B#, 16#0020#, 16#0002#),
         14917 => (16#3A3C#, 16#0020#, 16#0002#),
         14918 => (16#3A3D#, 16#0020#, 16#0002#),
         14919 => (16#3A3E#, 16#0020#, 16#0002#),
         14920 => (16#3A3F#, 16#0020#, 16#0002#),
         14921 => (16#3A40#, 16#0020#, 16#0002#),
         14922 => (16#3A41#, 16#0020#, 16#0002#),
         14923 => (16#3A42#, 16#0020#, 16#0002#),
         14924 => (16#3A43#, 16#0020#, 16#0002#),
         14925 => (16#3A44#, 16#0020#, 16#0002#),
         14926 => (16#3A45#, 16#0020#, 16#0002#),
         14927 => (16#3A46#, 16#0020#, 16#0002#),
         14928 => (16#3A47#, 16#0020#, 16#0002#),
         14929 => (16#3A48#, 16#0020#, 16#0002#),
         14930 => (16#3A49#, 16#0020#, 16#0002#),
         14931 => (16#3A4A#, 16#0020#, 16#0002#),
         14932 => (16#3A4B#, 16#0020#, 16#0002#),
         14933 => (16#3A4C#, 16#0020#, 16#0002#),
         14934 => (16#3A4D#, 16#0020#, 16#0002#),
         14935 => (16#3A4E#, 16#0020#, 16#0002#),
         14936 => (16#3A4F#, 16#0020#, 16#0002#),
         14937 => (16#3A50#, 16#0020#, 16#0002#),
         14938 => (16#3A51#, 16#0020#, 16#0002#),
         14939 => (16#3A52#, 16#0020#, 16#0002#),
         14940 => (16#3A53#, 16#0020#, 16#0002#),
         14941 => (16#3A54#, 16#0020#, 16#0002#),
         14942 => (16#3A55#, 16#0020#, 16#0002#),
         14943 => (16#3A56#, 16#0020#, 16#0002#),
         14944 => (16#3A57#, 16#0020#, 16#0002#),
         14945 => (16#3A58#, 16#0020#, 16#0002#),
         14946 => (16#3A59#, 16#0020#, 16#0002#),
         14947 => (16#3A5A#, 16#0020#, 16#0002#),
         14948 => (16#3A5B#, 16#0020#, 16#0002#),
         14949 => (16#3A5C#, 16#0020#, 16#0002#),
         14950 => (16#3A5D#, 16#0020#, 16#0002#),
         14951 => (16#3A5E#, 16#0020#, 16#0002#),
         14952 => (16#3A5F#, 16#0020#, 16#0002#),
         14953 => (16#3A60#, 16#0020#, 16#0002#),
         14954 => (16#3A61#, 16#0020#, 16#0002#),
         14955 => (16#3A62#, 16#0020#, 16#0002#),
         14956 => (16#3A63#, 16#0020#, 16#0002#),
         14957 => (16#3A64#, 16#0020#, 16#0002#),
         14958 => (16#3A65#, 16#0020#, 16#0002#),
         14959 => (16#3A66#, 16#0020#, 16#0002#),
         14960 => (16#3A67#, 16#0020#, 16#0002#),
         14961 => (16#3A68#, 16#0020#, 16#0002#),
         14962 => (16#3A69#, 16#0020#, 16#0002#),
         14963 => (16#3A6A#, 16#0020#, 16#0002#),
         14964 => (16#3A6B#, 16#0020#, 16#0002#),
         14965 => (16#3A6C#, 16#0020#, 16#0002#),
         14966 => (16#3A6D#, 16#0020#, 16#0002#),
         14967 => (16#3A6E#, 16#0020#, 16#0002#),
         14968 => (16#3A6F#, 16#0020#, 16#0002#),
         14969 => (16#3A70#, 16#0020#, 16#0002#),
         14970 => (16#3A71#, 16#0020#, 16#0002#),
         14971 => (16#3A72#, 16#0020#, 16#0002#),
         14972 => (16#3A73#, 16#0020#, 16#0002#),
         14973 => (16#3A74#, 16#0020#, 16#0002#),
         14974 => (16#3A75#, 16#0020#, 16#0002#),
         14975 => (16#3A76#, 16#0020#, 16#0002#),
         14976 => (16#3A77#, 16#0020#, 16#0002#),
         14977 => (16#3A78#, 16#0020#, 16#0002#),
         14978 => (16#3A79#, 16#0020#, 16#0002#),
         14979 => (16#3A7A#, 16#0020#, 16#0002#),
         14980 => (16#3A7B#, 16#0020#, 16#0002#),
         14981 => (16#3A7C#, 16#0020#, 16#0002#),
         14982 => (16#3A7D#, 16#0020#, 16#0002#),
         14983 => (16#3A7E#, 16#0020#, 16#0002#),
         14984 => (16#3A7F#, 16#0020#, 16#0002#),
         14985 => (16#3A80#, 16#0020#, 16#0002#),
         14986 => (16#3A81#, 16#0020#, 16#0002#),
         14987 => (16#3A82#, 16#0020#, 16#0002#),
         14988 => (16#3A83#, 16#0020#, 16#0002#),
         14989 => (16#3A84#, 16#0020#, 16#0002#),
         14990 => (16#3A85#, 16#0020#, 16#0002#),
         14991 => (16#3A86#, 16#0020#, 16#0002#),
         14992 => (16#3A87#, 16#0020#, 16#0002#),
         14993 => (16#3A88#, 16#0020#, 16#0002#),
         14994 => (16#3A89#, 16#0020#, 16#0002#),
         14995 => (16#3A8A#, 16#0020#, 16#0002#),
         14996 => (16#3A8B#, 16#0020#, 16#0002#),
         14997 => (16#3A8C#, 16#0020#, 16#0002#),
         14998 => (16#3A8D#, 16#0020#, 16#0002#),
         14999 => (16#3A8E#, 16#0020#, 16#0002#),
         15000 => (16#3A8F#, 16#0020#, 16#0002#),
         15001 => (16#3A90#, 16#0020#, 16#0002#),
         15002 => (16#3A91#, 16#0020#, 16#0002#),
         15003 => (16#3A92#, 16#0020#, 16#0002#),
         15004 => (16#3A93#, 16#0020#, 16#0002#),
         15005 => (16#3A94#, 16#0020#, 16#0002#),
         15006 => (16#3A95#, 16#0020#, 16#0002#),
         15007 => (16#3A96#, 16#0020#, 16#0002#),
         15008 => (16#3A97#, 16#0020#, 16#0002#),
         15009 => (16#3A98#, 16#0020#, 16#0002#),
         15010 => (16#3A99#, 16#0020#, 16#0002#),
         15011 => (16#3A9A#, 16#0020#, 16#0002#),
         15012 => (16#3A9B#, 16#0020#, 16#0002#),
         15013 => (16#3A9C#, 16#0020#, 16#0002#),
         15014 => (16#3A9D#, 16#0020#, 16#0002#),
         15015 => (16#3A9E#, 16#0020#, 16#0002#),
         15016 => (16#3A9F#, 16#0020#, 16#0002#),
         15017 => (16#3AA0#, 16#0020#, 16#0002#),
         15018 => (16#3AA1#, 16#0020#, 16#0002#),
         15019 => (16#3AA2#, 16#0020#, 16#0002#),
         15020 => (16#3AA3#, 16#0020#, 16#0002#),
         15021 => (16#3AA4#, 16#0020#, 16#0002#),
         15022 => (16#3AA5#, 16#0020#, 16#0002#),
         15023 => (16#3AA6#, 16#0020#, 16#0002#),
         15024 => (16#3AA7#, 16#0020#, 16#0002#),
         15025 => (16#3AA8#, 16#0020#, 16#0002#),
         15026 => (16#3AA9#, 16#0020#, 16#0002#),
         15027 => (16#3AAA#, 16#0020#, 16#0002#),
         15028 => (16#3AAB#, 16#0020#, 16#0002#),
         15029 => (16#3AAC#, 16#0020#, 16#0002#),
         15030 => (16#3AAD#, 16#0020#, 16#0002#),
         15031 => (16#3AAE#, 16#0020#, 16#0002#),
         15032 => (16#3AAF#, 16#0020#, 16#0002#),
         15033 => (16#3AB0#, 16#0020#, 16#0002#),
         15034 => (16#3AB1#, 16#0020#, 16#0002#),
         15035 => (16#3AB2#, 16#0020#, 16#0002#),
         15036 => (16#3AB3#, 16#0020#, 16#0002#),
         15037 => (16#3AB4#, 16#0020#, 16#0002#),
         15038 => (16#3AB5#, 16#0020#, 16#0002#),
         15039 => (16#3AB6#, 16#0020#, 16#0002#),
         15040 => (16#3AB7#, 16#0020#, 16#0002#),
         15041 => (16#3AB8#, 16#0020#, 16#0002#),
         15042 => (16#3AB9#, 16#0020#, 16#0002#),
         15043 => (16#3ABA#, 16#0020#, 16#0002#),
         15044 => (16#3ABB#, 16#0020#, 16#0002#),
         15045 => (16#3ABC#, 16#0020#, 16#0002#),
         15046 => (16#3ABD#, 16#0020#, 16#0002#),
         15047 => (16#3ABE#, 16#0020#, 16#0002#),
         15048 => (16#3ABF#, 16#0020#, 16#0002#),
         15049 => (16#3AC0#, 16#0020#, 16#0002#),
         15050 => (16#3AC1#, 16#0020#, 16#0002#),
         15051 => (16#3AC2#, 16#0020#, 16#0002#),
         15052 => (16#3AC3#, 16#0020#, 16#0002#),
         15053 => (16#3AC4#, 16#0020#, 16#0002#),
         15054 => (16#3AC5#, 16#0020#, 16#0002#),
         15055 => (16#3AC6#, 16#0020#, 16#0002#),
         15056 => (16#3AC7#, 16#0020#, 16#0002#),
         15057 => (16#3AC8#, 16#0020#, 16#0002#),
         15058 => (16#3AC9#, 16#0020#, 16#0002#),
         15059 => (16#3ACA#, 16#0020#, 16#0002#),
         15060 => (16#3ACB#, 16#0020#, 16#0002#),
         15061 => (16#3ACC#, 16#0020#, 16#0002#),
         15062 => (16#3ACD#, 16#0020#, 16#0002#),
         15063 => (16#3ACE#, 16#0020#, 16#0002#),
         15064 => (16#3ACF#, 16#0020#, 16#0002#),
         15065 => (16#3AD0#, 16#0020#, 16#0002#),
         15066 => (16#3AD1#, 16#0020#, 16#0002#),
         15067 => (16#3AD2#, 16#0020#, 16#0002#),
         15068 => (16#3AD3#, 16#0020#, 16#0002#),
         15069 => (16#3AD4#, 16#0020#, 16#0002#),
         15070 => (16#3AD5#, 16#0020#, 16#0002#),
         15071 => (16#3AD6#, 16#0020#, 16#0002#),
         15072 => (16#3AD7#, 16#0020#, 16#0002#),
         15073 => (16#3AD8#, 16#0020#, 16#0002#),
         15074 => (16#3AD9#, 16#0020#, 16#0002#),
         15075 => (16#3ADA#, 16#0020#, 16#0002#),
         15076 => (16#3ADB#, 16#0020#, 16#0002#),
         15077 => (16#3ADC#, 16#0020#, 16#0002#),
         15078 => (16#3ADD#, 16#0020#, 16#0002#),
         15079 => (16#3ADE#, 16#0020#, 16#0002#),
         15080 => (16#3ADF#, 16#0020#, 16#0002#),
         15081 => (16#3AE0#, 16#0020#, 16#0002#),
         15082 => (16#3AE1#, 16#0020#, 16#0002#),
         15083 => (16#3AE2#, 16#0020#, 16#0002#),
         15084 => (16#3AE3#, 16#0020#, 16#0002#),
         15085 => (16#3AE4#, 16#0020#, 16#0002#),
         15086 => (16#3AE5#, 16#0020#, 16#0002#),
         15087 => (16#3AE6#, 16#0020#, 16#0002#),
         15088 => (16#3AE7#, 16#0020#, 16#0002#),
         15089 => (16#3AE8#, 16#0020#, 16#0002#),
         15090 => (16#3AE9#, 16#0020#, 16#0002#),
         15091 => (16#3AEA#, 16#0020#, 16#0002#),
         15092 => (16#3AEB#, 16#0020#, 16#0002#),
         15093 => (16#3AEC#, 16#0020#, 16#0002#),
         15094 => (16#3AED#, 16#0020#, 16#0002#),
         15095 => (16#3AEE#, 16#0020#, 16#0002#),
         15096 => (16#3AEF#, 16#0020#, 16#0002#),
         15097 => (16#3AF0#, 16#0020#, 16#0002#),
         15098 => (16#3AF1#, 16#0020#, 16#0002#),
         15099 => (16#3AF2#, 16#0020#, 16#0002#),
         15100 => (16#3AF3#, 16#0020#, 16#0002#),
         15101 => (16#3AF4#, 16#0020#, 16#0002#),
         15102 => (16#3AF5#, 16#0020#, 16#0002#),
         15103 => (16#3AF6#, 16#0020#, 16#0002#),
         15104 => (16#3AF7#, 16#0020#, 16#0002#),
         15105 => (16#3AF8#, 16#0020#, 16#0002#),
         15106 => (16#3AF9#, 16#0020#, 16#0002#),
         15107 => (16#3AFA#, 16#0020#, 16#0002#),
         15108 => (16#3AFB#, 16#0020#, 16#0002#),
         15109 => (16#3AFC#, 16#0020#, 16#0002#),
         15110 => (16#3AFD#, 16#0020#, 16#0002#),
         15111 => (16#3AFE#, 16#0020#, 16#0002#),
         15112 => (16#3AFF#, 16#0020#, 16#0002#),
         15113 => (16#3B00#, 16#0020#, 16#0002#),
         15114 => (16#3B01#, 16#0020#, 16#0002#),
         15115 => (16#3B02#, 16#0020#, 16#0002#),
         15116 => (16#3B03#, 16#0020#, 16#0002#),
         15117 => (16#3B04#, 16#0020#, 16#0002#),
         15118 => (16#3B05#, 16#0020#, 16#0002#),
         15119 => (16#3B06#, 16#0020#, 16#0002#),
         15120 => (16#3B07#, 16#0020#, 16#0002#),
         15121 => (16#3B08#, 16#0020#, 16#0002#),
         15122 => (16#3B09#, 16#0020#, 16#0002#),
         15123 => (16#3B0A#, 16#0020#, 16#0002#),
         15124 => (16#3B0B#, 16#0020#, 16#0002#),
         15125 => (16#3B0C#, 16#0020#, 16#0002#),
         15126 => (16#3B0D#, 16#0020#, 16#0002#),
         15127 => (16#3B0E#, 16#0020#, 16#0002#),
         15128 => (16#3B0F#, 16#0020#, 16#0002#),
         15129 => (16#3B10#, 16#0020#, 16#0002#),
         15130 => (16#3B11#, 16#0020#, 16#0002#),
         15131 => (16#3B12#, 16#0020#, 16#0002#),
         15132 => (16#3B13#, 16#0020#, 16#0002#),
         15133 => (16#3B14#, 16#0020#, 16#0002#),
         15134 => (16#3B15#, 16#0020#, 16#0002#),
         15135 => (16#3B16#, 16#0020#, 16#0002#),
         15136 => (16#3B17#, 16#0020#, 16#0002#),
         15137 => (16#3B18#, 16#0020#, 16#0002#),
         15138 => (16#3B19#, 16#0020#, 16#0002#),
         15139 => (16#3B1A#, 16#0020#, 16#0002#),
         15140 => (16#3B1B#, 16#0020#, 16#0002#),
         15141 => (16#3B1C#, 16#0020#, 16#0002#),
         15142 => (16#3B1D#, 16#0020#, 16#0002#),
         15143 => (16#3B1E#, 16#0020#, 16#0002#),
         15144 => (16#3B1F#, 16#0020#, 16#0002#),
         15145 => (16#3B20#, 16#0020#, 16#0002#),
         15146 => (16#3B21#, 16#0020#, 16#0002#),
         15147 => (16#3B22#, 16#0020#, 16#0002#),
         15148 => (16#3B23#, 16#0020#, 16#0002#),
         15149 => (16#3B24#, 16#0020#, 16#0002#),
         15150 => (16#3B25#, 16#0020#, 16#0002#),
         15151 => (16#3B26#, 16#0020#, 16#0002#),
         15152 => (16#3B27#, 16#0020#, 16#0002#),
         15153 => (16#3B28#, 16#0020#, 16#0002#),
         15154 => (16#3B29#, 16#0020#, 16#0002#),
         15155 => (16#3B2A#, 16#0020#, 16#0002#),
         15156 => (16#3B2B#, 16#0020#, 16#0002#),
         15157 => (16#3B2C#, 16#0020#, 16#0002#),
         15158 => (16#3B2D#, 16#0020#, 16#0002#),
         15159 => (16#3B2E#, 16#0020#, 16#0002#),
         15160 => (16#3B2F#, 16#0020#, 16#0002#),
         15161 => (16#3B30#, 16#0020#, 16#0002#),
         15162 => (16#3B31#, 16#0020#, 16#0002#),
         15163 => (16#3B32#, 16#0020#, 16#0002#),
         15164 => (16#3B33#, 16#0020#, 16#0002#),
         15165 => (16#3B34#, 16#0020#, 16#0002#),
         15166 => (16#3B35#, 16#0020#, 16#0002#),
         15167 => (16#3B36#, 16#0020#, 16#0002#),
         15168 => (16#3B37#, 16#0020#, 16#0002#),
         15169 => (16#3B38#, 16#0020#, 16#0002#),
         15170 => (16#3B39#, 16#0020#, 16#0002#),
         15171 => (16#3B3A#, 16#0020#, 16#0002#),
         15172 => (16#3B3B#, 16#0020#, 16#0002#),
         15173 => (16#3B3C#, 16#0020#, 16#0002#),
         15174 => (16#3B3D#, 16#0020#, 16#0002#),
         15175 => (16#3B3E#, 16#0020#, 16#0002#),
         15176 => (16#3B3F#, 16#0020#, 16#0002#),
         15177 => (16#3B40#, 16#0020#, 16#0002#),
         15178 => (16#3B41#, 16#0020#, 16#0002#),
         15179 => (16#3B42#, 16#0020#, 16#0002#),
         15180 => (16#3B43#, 16#0020#, 16#0002#),
         15181 => (16#3B44#, 16#0020#, 16#0002#),
         15182 => (16#3B45#, 16#0020#, 16#0002#),
         15183 => (16#3B46#, 16#0020#, 16#0002#),
         15184 => (16#3B47#, 16#0020#, 16#0002#),
         15185 => (16#3B48#, 16#0020#, 16#0002#),
         15186 => (16#3B49#, 16#0020#, 16#0002#),
         15187 => (16#3B4A#, 16#0020#, 16#0002#),
         15188 => (16#3B4B#, 16#0020#, 16#0002#),
         15189 => (16#3B4C#, 16#0020#, 16#0002#),
         15190 => (16#3B4D#, 16#0020#, 16#0002#),
         15191 => (16#3B4E#, 16#0020#, 16#0002#),
         15192 => (16#3B4F#, 16#0020#, 16#0002#),
         15193 => (16#3B50#, 16#0020#, 16#0002#),
         15194 => (16#3B51#, 16#0020#, 16#0002#),
         15195 => (16#3B52#, 16#0020#, 16#0002#),
         15196 => (16#3B53#, 16#0020#, 16#0002#),
         15197 => (16#3B54#, 16#0020#, 16#0002#),
         15198 => (16#3B55#, 16#0020#, 16#0002#),
         15199 => (16#3B56#, 16#0020#, 16#0002#),
         15200 => (16#3B57#, 16#0020#, 16#0002#),
         15201 => (16#3B58#, 16#0020#, 16#0002#),
         15202 => (16#3B59#, 16#0020#, 16#0002#),
         15203 => (16#3B5A#, 16#0020#, 16#0002#),
         15204 => (16#3B5B#, 16#0020#, 16#0002#),
         15205 => (16#3B5C#, 16#0020#, 16#0002#),
         15206 => (16#3B5D#, 16#0020#, 16#0002#),
         15207 => (16#3B5E#, 16#0020#, 16#0002#),
         15208 => (16#3B5F#, 16#0020#, 16#0002#),
         15209 => (16#3B60#, 16#0020#, 16#0002#),
         15210 => (16#3B61#, 16#0020#, 16#0002#),
         15211 => (16#3B62#, 16#0020#, 16#0002#),
         15212 => (16#3B63#, 16#0020#, 16#0002#),
         15213 => (16#3B64#, 16#0020#, 16#0002#),
         15214 => (16#3B65#, 16#0020#, 16#0002#),
         15215 => (16#3B66#, 16#0020#, 16#0002#),
         15216 => (16#3B67#, 16#0020#, 16#0002#),
         15217 => (16#3B68#, 16#0020#, 16#0002#),
         15218 => (16#3B69#, 16#0020#, 16#0002#),
         15219 => (16#3B6A#, 16#0020#, 16#0002#),
         15220 => (16#3B6B#, 16#0020#, 16#0002#),
         15221 => (16#3B6C#, 16#0020#, 16#0002#),
         15222 => (16#3B6D#, 16#0020#, 16#0002#),
         15223 => (16#3B6E#, 16#0020#, 16#0002#),
         15224 => (16#3B6F#, 16#0020#, 16#0002#),
         15225 => (16#3B70#, 16#0020#, 16#0002#),
         15226 => (16#3B71#, 16#0020#, 16#0002#),
         15227 => (16#3B72#, 16#0020#, 16#0002#),
         15228 => (16#3B73#, 16#0020#, 16#0002#),
         15229 => (16#3B74#, 16#0020#, 16#0002#),
         15230 => (16#3B75#, 16#0020#, 16#0002#),
         15231 => (16#3B76#, 16#0020#, 16#0002#),
         15232 => (16#3B77#, 16#0020#, 16#0002#),
         15233 => (16#3B78#, 16#0020#, 16#0002#),
         15234 => (16#3B79#, 16#0020#, 16#0002#),
         15235 => (16#3B7A#, 16#0020#, 16#0002#),
         15236 => (16#3B7B#, 16#0020#, 16#0002#),
         15237 => (16#3B7C#, 16#0020#, 16#0002#),
         15238 => (16#3B7D#, 16#0020#, 16#0002#),
         15239 => (16#3B7E#, 16#0020#, 16#0002#),
         15240 => (16#3B7F#, 16#0020#, 16#0002#),
         15241 => (16#3B80#, 16#0020#, 16#0002#),
         15242 => (16#3B81#, 16#0020#, 16#0002#),
         15243 => (16#3B82#, 16#0020#, 16#0002#),
         15244 => (16#3B83#, 16#0020#, 16#0002#),
         15245 => (16#3B84#, 16#0020#, 16#0002#),
         15246 => (16#3B85#, 16#0020#, 16#0002#),
         15247 => (16#3B86#, 16#0020#, 16#0002#),
         15248 => (16#3B87#, 16#0020#, 16#0002#),
         15249 => (16#3B88#, 16#0020#, 16#0002#),
         15250 => (16#3B89#, 16#0020#, 16#0002#),
         15251 => (16#3B8A#, 16#0020#, 16#0002#),
         15252 => (16#3B8B#, 16#0020#, 16#0002#),
         15253 => (16#3B8C#, 16#0020#, 16#0002#),
         15254 => (16#3B8D#, 16#0020#, 16#0002#),
         15255 => (16#3B8E#, 16#0020#, 16#0002#),
         15256 => (16#3B8F#, 16#0020#, 16#0002#),
         15257 => (16#3B90#, 16#0020#, 16#0002#),
         15258 => (16#3B91#, 16#0020#, 16#0002#),
         15259 => (16#3B92#, 16#0020#, 16#0002#),
         15260 => (16#3B93#, 16#0020#, 16#0002#),
         15261 => (16#3B94#, 16#0020#, 16#0002#),
         15262 => (16#3B95#, 16#0020#, 16#0002#),
         15263 => (16#3B96#, 16#0020#, 16#0002#),
         15264 => (16#3B97#, 16#0020#, 16#0002#),
         15265 => (16#3B98#, 16#0020#, 16#0002#),
         15266 => (16#3B99#, 16#0020#, 16#0002#),
         15267 => (16#3B9A#, 16#0020#, 16#0002#),
         15268 => (16#3B9B#, 16#0020#, 16#0002#),
         15269 => (16#3B9C#, 16#0020#, 16#0002#),
         15270 => (16#3B9D#, 16#0020#, 16#0002#),
         15271 => (16#3B9E#, 16#0020#, 16#0002#),
         15272 => (16#3B9F#, 16#0020#, 16#0002#),
         15273 => (16#3BA0#, 16#0020#, 16#0002#),
         15274 => (16#3BA1#, 16#0020#, 16#0002#),
         15275 => (16#3BA2#, 16#0020#, 16#0002#),
         15276 => (16#3BA3#, 16#0020#, 16#0002#),
         15277 => (16#3BA4#, 16#0020#, 16#0002#),
         15278 => (16#3BA5#, 16#0020#, 16#0002#),
         15279 => (16#3BA6#, 16#0020#, 16#0002#),
         15280 => (16#3BA7#, 16#0020#, 16#0002#),
         15281 => (16#3BA8#, 16#0020#, 16#0002#),
         15282 => (16#3BA9#, 16#0020#, 16#0002#),
         15283 => (16#3BAA#, 16#0020#, 16#0002#),
         15284 => (16#3BAB#, 16#0020#, 16#0002#),
         15285 => (16#3BAC#, 16#0020#, 16#0002#),
         15286 => (16#3BAD#, 16#0020#, 16#0002#),
         15287 => (16#3BAE#, 16#0020#, 16#0002#),
         15288 => (16#3BAF#, 16#0020#, 16#0002#),
         15289 => (16#3BB0#, 16#0020#, 16#0002#),
         15290 => (16#3BB1#, 16#0020#, 16#0002#),
         15291 => (16#3BB2#, 16#0020#, 16#0002#),
         15292 => (16#3BB3#, 16#0020#, 16#0002#),
         15293 => (16#3BB4#, 16#0020#, 16#0002#),
         15294 => (16#3BB5#, 16#0020#, 16#0002#),
         15295 => (16#3BB6#, 16#0020#, 16#0002#),
         15296 => (16#3BB7#, 16#0020#, 16#0002#),
         15297 => (16#3BB8#, 16#0020#, 16#0002#),
         15298 => (16#3BB9#, 16#0020#, 16#0002#),
         15299 => (16#3BBA#, 16#0020#, 16#0002#),
         15300 => (16#3BBB#, 16#0020#, 16#0002#),
         15301 => (16#3BBC#, 16#0020#, 16#0002#),
         15302 => (16#3BBD#, 16#0020#, 16#0002#),
         15303 => (16#3BBE#, 16#0020#, 16#0002#),
         15304 => (16#3BBF#, 16#0020#, 16#0002#),
         15305 => (16#3BC0#, 16#0020#, 16#0002#),
         15306 => (16#3BC1#, 16#0020#, 16#0002#),
         15307 => (16#3BC2#, 16#0020#, 16#0002#),
         15308 => (16#3BC3#, 16#0020#, 16#0002#),
         15309 => (16#3BC4#, 16#0020#, 16#0002#),
         15310 => (16#3BC5#, 16#0020#, 16#0002#),
         15311 => (16#3BC6#, 16#0020#, 16#0002#),
         15312 => (16#3BC7#, 16#0020#, 16#0002#),
         15313 => (16#3BC8#, 16#0020#, 16#0002#),
         15314 => (16#3BC9#, 16#0020#, 16#0002#),
         15315 => (16#3BCA#, 16#0020#, 16#0002#),
         15316 => (16#3BCB#, 16#0020#, 16#0002#),
         15317 => (16#3BCC#, 16#0020#, 16#0002#),
         15318 => (16#3BCD#, 16#0020#, 16#0002#),
         15319 => (16#3BCE#, 16#0020#, 16#0002#),
         15320 => (16#3BCF#, 16#0020#, 16#0002#),
         15321 => (16#3BD0#, 16#0020#, 16#0002#),
         15322 => (16#3BD1#, 16#0020#, 16#0002#),
         15323 => (16#3BD2#, 16#0020#, 16#0002#),
         15324 => (16#3BD3#, 16#0020#, 16#0002#),
         15325 => (16#3BD4#, 16#0020#, 16#0002#),
         15326 => (16#3BD5#, 16#0020#, 16#0002#),
         15327 => (16#3BD6#, 16#0020#, 16#0002#),
         15328 => (16#3BD7#, 16#0020#, 16#0002#),
         15329 => (16#3BD8#, 16#0020#, 16#0002#),
         15330 => (16#3BD9#, 16#0020#, 16#0002#),
         15331 => (16#3BDA#, 16#0020#, 16#0002#),
         15332 => (16#3BDB#, 16#0020#, 16#0002#),
         15333 => (16#3BDC#, 16#0020#, 16#0002#),
         15334 => (16#3BDD#, 16#0020#, 16#0002#),
         15335 => (16#3BDE#, 16#0020#, 16#0002#),
         15336 => (16#3BDF#, 16#0020#, 16#0002#),
         15337 => (16#3BE0#, 16#0020#, 16#0002#),
         15338 => (16#3BE1#, 16#0020#, 16#0002#),
         15339 => (16#3BE2#, 16#0020#, 16#0002#),
         15340 => (16#3BE3#, 16#0020#, 16#0002#),
         15341 => (16#3BE4#, 16#0020#, 16#0002#),
         15342 => (16#3BE5#, 16#0020#, 16#0002#),
         15343 => (16#3BE6#, 16#0020#, 16#0002#),
         15344 => (16#3BE7#, 16#0020#, 16#0002#),
         15345 => (16#3BE8#, 16#0020#, 16#0002#),
         15346 => (16#3BE9#, 16#0020#, 16#0002#),
         15347 => (16#3BEA#, 16#0020#, 16#0002#),
         15348 => (16#3BEB#, 16#0020#, 16#0002#),
         15349 => (16#3BEC#, 16#0020#, 16#0002#),
         15350 => (16#3BED#, 16#0020#, 16#0002#),
         15351 => (16#3BEE#, 16#0020#, 16#0002#),
         15352 => (16#3BEF#, 16#0020#, 16#0002#),
         15353 => (16#3BF0#, 16#0020#, 16#0002#),
         15354 => (16#3BF1#, 16#0020#, 16#0002#),
         15355 => (16#3BF2#, 16#0020#, 16#0002#),
         15356 => (16#3BF3#, 16#0020#, 16#0002#),
         15357 => (16#3BF4#, 16#0020#, 16#0002#),
         15358 => (16#3BF5#, 16#0020#, 16#0002#),
         15359 => (16#3BF6#, 16#0020#, 16#0002#),
         15360 => (16#3BF7#, 16#0020#, 16#0002#),
         15361 => (16#3BF8#, 16#0020#, 16#0002#),
         15362 => (16#3BF9#, 16#0020#, 16#0002#),
         15363 => (16#3BFA#, 16#0020#, 16#0002#),
         15364 => (16#3BFB#, 16#0020#, 16#0002#),
         15365 => (16#3BFC#, 16#0020#, 16#0002#),
         15366 => (16#3BFD#, 16#0020#, 16#0002#),
         15367 => (16#3BFE#, 16#0020#, 16#0002#),
         15368 => (16#3BFF#, 16#0020#, 16#0002#),
         15369 => (16#3C00#, 16#0020#, 16#0002#),
         15370 => (16#3C01#, 16#0020#, 16#0002#),
         15371 => (16#3C02#, 16#0020#, 16#0002#),
         15372 => (16#3C03#, 16#0020#, 16#0002#),
         15373 => (16#3C04#, 16#0020#, 16#0002#),
         15374 => (16#3C05#, 16#0020#, 16#0002#),
         15375 => (16#3C06#, 16#0020#, 16#0002#),
         15376 => (16#3C07#, 16#0020#, 16#0002#),
         15377 => (16#3C08#, 16#0020#, 16#0002#),
         15378 => (16#3C09#, 16#0020#, 16#0002#),
         15379 => (16#3C0A#, 16#0020#, 16#0002#),
         15380 => (16#3C0B#, 16#0020#, 16#0002#),
         15381 => (16#3C0C#, 16#0020#, 16#0002#),
         15382 => (16#3C0D#, 16#0020#, 16#0002#),
         15383 => (16#3C0E#, 16#0020#, 16#0002#),
         15384 => (16#3C0F#, 16#0020#, 16#0002#),
         15385 => (16#3C10#, 16#0020#, 16#0002#),
         15386 => (16#3C11#, 16#0020#, 16#0002#),
         15387 => (16#3C12#, 16#0020#, 16#0002#),
         15388 => (16#3C13#, 16#0020#, 16#0002#),
         15389 => (16#3C14#, 16#0020#, 16#0002#),
         15390 => (16#3C15#, 16#0020#, 16#0002#),
         15391 => (16#3C16#, 16#0020#, 16#0002#),
         15392 => (16#3C17#, 16#0020#, 16#0002#),
         15393 => (16#3C18#, 16#0020#, 16#0002#),
         15394 => (16#3C19#, 16#0020#, 16#0002#),
         15395 => (16#3C1A#, 16#0020#, 16#0002#),
         15396 => (16#3C1B#, 16#0020#, 16#0002#),
         15397 => (16#3C1C#, 16#0020#, 16#0002#),
         15398 => (16#3C1D#, 16#0020#, 16#0002#),
         15399 => (16#3C1E#, 16#0020#, 16#0002#),
         15400 => (16#3C1F#, 16#0020#, 16#0002#),
         15401 => (16#3C20#, 16#0020#, 16#0002#),
         15402 => (16#3C21#, 16#0020#, 16#0002#),
         15403 => (16#3C22#, 16#0020#, 16#0002#),
         15404 => (16#3C23#, 16#0020#, 16#0002#),
         15405 => (16#3C24#, 16#0020#, 16#0002#),
         15406 => (16#3C25#, 16#0020#, 16#0002#),
         15407 => (16#3C26#, 16#0020#, 16#0002#),
         15408 => (16#3C27#, 16#0020#, 16#0002#),
         15409 => (16#3C28#, 16#0020#, 16#0002#),
         15410 => (16#3C29#, 16#0020#, 16#0002#),
         15411 => (16#3C2A#, 16#0020#, 16#0002#),
         15412 => (16#3C2B#, 16#0020#, 16#0002#),
         15413 => (16#3C2C#, 16#0020#, 16#0002#),
         15414 => (16#3C2D#, 16#0020#, 16#0002#),
         15415 => (16#3C2E#, 16#0020#, 16#0002#),
         15416 => (16#3C2F#, 16#0020#, 16#0002#),
         15417 => (16#3C30#, 16#0020#, 16#0002#),
         15418 => (16#3C31#, 16#0020#, 16#0002#),
         15419 => (16#3C32#, 16#0020#, 16#0002#),
         15420 => (16#3C33#, 16#0020#, 16#0002#),
         15421 => (16#3C34#, 16#0020#, 16#0002#),
         15422 => (16#3C35#, 16#0020#, 16#0002#),
         15423 => (16#3C36#, 16#0020#, 16#0002#),
         15424 => (16#3C37#, 16#0020#, 16#0002#),
         15425 => (16#3C38#, 16#0020#, 16#0002#),
         15426 => (16#3C39#, 16#0020#, 16#0002#),
         15427 => (16#3C3A#, 16#0020#, 16#0002#),
         15428 => (16#3C3B#, 16#0020#, 16#0002#),
         15429 => (16#3C3C#, 16#0020#, 16#0002#),
         15430 => (16#3C3D#, 16#0020#, 16#0002#),
         15431 => (16#3C3E#, 16#0020#, 16#0002#),
         15432 => (16#3C3F#, 16#0020#, 16#0002#),
         15433 => (16#3C40#, 16#0020#, 16#0002#),
         15434 => (16#3C41#, 16#0020#, 16#0002#),
         15435 => (16#3C42#, 16#0020#, 16#0002#),
         15436 => (16#3C43#, 16#0020#, 16#0002#),
         15437 => (16#3C44#, 16#0020#, 16#0002#),
         15438 => (16#3C45#, 16#0020#, 16#0002#),
         15439 => (16#3C46#, 16#0020#, 16#0002#),
         15440 => (16#3C47#, 16#0020#, 16#0002#),
         15441 => (16#3C48#, 16#0020#, 16#0002#),
         15442 => (16#3C49#, 16#0020#, 16#0002#),
         15443 => (16#3C4A#, 16#0020#, 16#0002#),
         15444 => (16#3C4B#, 16#0020#, 16#0002#),
         15445 => (16#3C4C#, 16#0020#, 16#0002#),
         15446 => (16#3C4D#, 16#0020#, 16#0002#),
         15447 => (16#3C4E#, 16#0020#, 16#0002#),
         15448 => (16#3C4F#, 16#0020#, 16#0002#),
         15449 => (16#3C50#, 16#0020#, 16#0002#),
         15450 => (16#3C51#, 16#0020#, 16#0002#),
         15451 => (16#3C52#, 16#0020#, 16#0002#),
         15452 => (16#3C53#, 16#0020#, 16#0002#),
         15453 => (16#3C54#, 16#0020#, 16#0002#),
         15454 => (16#3C55#, 16#0020#, 16#0002#),
         15455 => (16#3C56#, 16#0020#, 16#0002#),
         15456 => (16#3C57#, 16#0020#, 16#0002#),
         15457 => (16#3C58#, 16#0020#, 16#0002#),
         15458 => (16#3C59#, 16#0020#, 16#0002#),
         15459 => (16#3C5A#, 16#0020#, 16#0002#),
         15460 => (16#3C5B#, 16#0020#, 16#0002#),
         15461 => (16#3C5C#, 16#0020#, 16#0002#),
         15462 => (16#3C5D#, 16#0020#, 16#0002#),
         15463 => (16#3C5E#, 16#0020#, 16#0002#),
         15464 => (16#3C5F#, 16#0020#, 16#0002#),
         15465 => (16#3C60#, 16#0020#, 16#0002#),
         15466 => (16#3C61#, 16#0020#, 16#0002#),
         15467 => (16#3C62#, 16#0020#, 16#0002#),
         15468 => (16#3C63#, 16#0020#, 16#0002#),
         15469 => (16#3C64#, 16#0020#, 16#0002#),
         15470 => (16#3C65#, 16#0020#, 16#0002#),
         15471 => (16#3C66#, 16#0020#, 16#0002#),
         15472 => (16#3C67#, 16#0020#, 16#0002#),
         15473 => (16#3C68#, 16#0020#, 16#0002#),
         15474 => (16#3C69#, 16#0020#, 16#0002#),
         15475 => (16#3C6A#, 16#0020#, 16#0002#),
         15476 => (16#3C6B#, 16#0020#, 16#0002#),
         15477 => (16#3C6C#, 16#0020#, 16#0002#),
         15478 => (16#3C6D#, 16#0020#, 16#0002#),
         15479 => (16#3C6E#, 16#0020#, 16#0002#),
         15480 => (16#3C6F#, 16#0020#, 16#0002#),
         15481 => (16#3C70#, 16#0020#, 16#0002#),
         15482 => (16#3C71#, 16#0020#, 16#0002#),
         15483 => (16#3C72#, 16#0020#, 16#0002#),
         15484 => (16#3C73#, 16#0020#, 16#0002#),
         15485 => (16#3C74#, 16#0020#, 16#0002#),
         15486 => (16#3C75#, 16#0020#, 16#0002#),
         15487 => (16#3C76#, 16#0020#, 16#0002#),
         15488 => (16#3C77#, 16#0020#, 16#0002#),
         15489 => (16#3C78#, 16#0020#, 16#0002#),
         15490 => (16#3C79#, 16#0020#, 16#0002#),
         15491 => (16#3C7A#, 16#0020#, 16#0002#),
         15492 => (16#3C7B#, 16#0020#, 16#0002#),
         15493 => (16#3C7C#, 16#0020#, 16#0002#),
         15494 => (16#3C7D#, 16#0020#, 16#0002#),
         15495 => (16#3C7E#, 16#0020#, 16#0002#),
         15496 => (16#3C7F#, 16#0020#, 16#0002#),
         15497 => (16#3C80#, 16#0020#, 16#0002#),
         15498 => (16#3C81#, 16#0020#, 16#0002#),
         15499 => (16#3C82#, 16#0020#, 16#0002#),
         15500 => (16#3C83#, 16#0020#, 16#0002#),
         15501 => (16#3C84#, 16#0020#, 16#0002#),
         15502 => (16#3C85#, 16#0020#, 16#0002#),
         15503 => (16#3C86#, 16#0020#, 16#0002#),
         15504 => (16#3C87#, 16#0020#, 16#0002#),
         15505 => (16#3C88#, 16#0020#, 16#0002#),
         15506 => (16#3C89#, 16#0020#, 16#0002#),
         15507 => (16#3C8A#, 16#0020#, 16#0002#),
         15508 => (16#3C8B#, 16#0020#, 16#0002#),
         15509 => (16#3C8C#, 16#0020#, 16#0002#),
         15510 => (16#3C8D#, 16#0020#, 16#0002#),
         15511 => (16#3C8E#, 16#0020#, 16#0002#),
         15512 => (16#3C8F#, 16#0020#, 16#0002#),
         15513 => (16#3C90#, 16#0020#, 16#0002#),
         15514 => (16#3C91#, 16#0020#, 16#0002#),
         15515 => (16#3C92#, 16#0020#, 16#0002#),
         15516 => (16#3C93#, 16#0020#, 16#0002#),
         15517 => (16#3C94#, 16#0020#, 16#0002#),
         15518 => (16#3C95#, 16#0020#, 16#0002#),
         15519 => (16#3C96#, 16#0020#, 16#0002#),
         15520 => (16#3C97#, 16#0020#, 16#0002#),
         15521 => (16#3C98#, 16#0020#, 16#0002#),
         15522 => (16#3C99#, 16#0020#, 16#0002#),
         15523 => (16#3C9A#, 16#0020#, 16#0002#),
         15524 => (16#3C9B#, 16#0020#, 16#0002#),
         15525 => (16#3C9C#, 16#0020#, 16#0002#),
         15526 => (16#3C9D#, 16#0020#, 16#0002#),
         15527 => (16#3C9E#, 16#0020#, 16#0002#),
         15528 => (16#3C9F#, 16#0020#, 16#0002#),
         15529 => (16#3CA0#, 16#0020#, 16#0002#),
         15530 => (16#3CA1#, 16#0020#, 16#0002#),
         15531 => (16#3CA2#, 16#0020#, 16#0002#),
         15532 => (16#3CA3#, 16#0020#, 16#0002#),
         15533 => (16#3CA4#, 16#0020#, 16#0002#),
         15534 => (16#3CA5#, 16#0020#, 16#0002#),
         15535 => (16#3CA6#, 16#0020#, 16#0002#),
         15536 => (16#3CA7#, 16#0020#, 16#0002#),
         15537 => (16#3CA8#, 16#0020#, 16#0002#),
         15538 => (16#3CA9#, 16#0020#, 16#0002#),
         15539 => (16#3CAA#, 16#0020#, 16#0002#),
         15540 => (16#3CAB#, 16#0020#, 16#0002#),
         15541 => (16#3CAC#, 16#0020#, 16#0002#),
         15542 => (16#3CAD#, 16#0020#, 16#0002#),
         15543 => (16#3CAE#, 16#0020#, 16#0002#),
         15544 => (16#3CAF#, 16#0020#, 16#0002#),
         15545 => (16#3CB0#, 16#0020#, 16#0002#),
         15546 => (16#3CB1#, 16#0020#, 16#0002#),
         15547 => (16#3CB2#, 16#0020#, 16#0002#),
         15548 => (16#3CB3#, 16#0020#, 16#0002#),
         15549 => (16#3CB4#, 16#0020#, 16#0002#),
         15550 => (16#3CB5#, 16#0020#, 16#0002#),
         15551 => (16#3CB6#, 16#0020#, 16#0002#),
         15552 => (16#3CB7#, 16#0020#, 16#0002#),
         15553 => (16#3CB8#, 16#0020#, 16#0002#),
         15554 => (16#3CB9#, 16#0020#, 16#0002#),
         15555 => (16#3CBA#, 16#0020#, 16#0002#),
         15556 => (16#3CBB#, 16#0020#, 16#0002#),
         15557 => (16#3CBC#, 16#0020#, 16#0002#),
         15558 => (16#3CBD#, 16#0020#, 16#0002#),
         15559 => (16#3CBE#, 16#0020#, 16#0002#),
         15560 => (16#3CBF#, 16#0020#, 16#0002#),
         15561 => (16#3CC0#, 16#0020#, 16#0002#),
         15562 => (16#3CC1#, 16#0020#, 16#0002#),
         15563 => (16#3CC2#, 16#0020#, 16#0002#),
         15564 => (16#3CC3#, 16#0020#, 16#0002#),
         15565 => (16#3CC4#, 16#0020#, 16#0002#),
         15566 => (16#3CC5#, 16#0020#, 16#0002#),
         15567 => (16#3CC6#, 16#0020#, 16#0002#),
         15568 => (16#3CC7#, 16#0020#, 16#0002#),
         15569 => (16#3CC8#, 16#0020#, 16#0002#),
         15570 => (16#3CC9#, 16#0020#, 16#0002#),
         15571 => (16#3CCA#, 16#0020#, 16#0002#),
         15572 => (16#3CCB#, 16#0020#, 16#0002#),
         15573 => (16#3CCC#, 16#0020#, 16#0002#),
         15574 => (16#3CCD#, 16#0020#, 16#0002#),
         15575 => (16#3CCE#, 16#0020#, 16#0002#),
         15576 => (16#3CCF#, 16#0020#, 16#0002#),
         15577 => (16#3CD0#, 16#0020#, 16#0002#),
         15578 => (16#3CD1#, 16#0020#, 16#0002#),
         15579 => (16#3CD2#, 16#0020#, 16#0002#),
         15580 => (16#3CD3#, 16#0020#, 16#0002#),
         15581 => (16#3CD4#, 16#0020#, 16#0002#),
         15582 => (16#3CD5#, 16#0020#, 16#0002#),
         15583 => (16#3CD6#, 16#0020#, 16#0002#),
         15584 => (16#3CD7#, 16#0020#, 16#0002#),
         15585 => (16#3CD8#, 16#0020#, 16#0002#),
         15586 => (16#3CD9#, 16#0020#, 16#0002#),
         15587 => (16#3CDA#, 16#0020#, 16#0002#),
         15588 => (16#3CDB#, 16#0020#, 16#0002#),
         15589 => (16#3CDC#, 16#0020#, 16#0002#),
         15590 => (16#3CDD#, 16#0020#, 16#0002#),
         15591 => (16#3CDE#, 16#0020#, 16#0002#),
         15592 => (16#3CDF#, 16#0020#, 16#0002#),
         15593 => (16#3CE0#, 16#0020#, 16#0002#),
         15594 => (16#3CE1#, 16#0020#, 16#0002#),
         15595 => (16#3CE2#, 16#0020#, 16#0002#),
         15596 => (16#3CE3#, 16#0020#, 16#0002#),
         15597 => (16#3CE4#, 16#0020#, 16#0002#),
         15598 => (16#3CE5#, 16#0020#, 16#0002#),
         15599 => (16#3CE6#, 16#0020#, 16#0002#),
         15600 => (16#3CE7#, 16#0020#, 16#0002#),
         15601 => (16#3CE8#, 16#0020#, 16#0002#),
         15602 => (16#3CE9#, 16#0020#, 16#0002#),
         15603 => (16#3CEA#, 16#0020#, 16#0002#),
         15604 => (16#3CEB#, 16#0020#, 16#0002#),
         15605 => (16#3CEC#, 16#0020#, 16#0002#),
         15606 => (16#3CED#, 16#0020#, 16#0002#),
         15607 => (16#3CEE#, 16#0020#, 16#0002#),
         15608 => (16#3CEF#, 16#0020#, 16#0002#),
         15609 => (16#3CF0#, 16#0020#, 16#0002#),
         15610 => (16#3CF1#, 16#0020#, 16#0002#),
         15611 => (16#3CF2#, 16#0020#, 16#0002#),
         15612 => (16#3CF3#, 16#0020#, 16#0002#),
         15613 => (16#3CF4#, 16#0020#, 16#0002#),
         15614 => (16#3CF5#, 16#0020#, 16#0002#),
         15615 => (16#3CF6#, 16#0020#, 16#0002#),
         15616 => (16#3CF7#, 16#0020#, 16#0002#),
         15617 => (16#3CF8#, 16#0020#, 16#0002#),
         15618 => (16#3CF9#, 16#0020#, 16#0002#),
         15619 => (16#3CFA#, 16#0020#, 16#0002#),
         15620 => (16#3CFB#, 16#0020#, 16#0002#),
         15621 => (16#3CFC#, 16#0020#, 16#0002#),
         15622 => (16#3CFD#, 16#0020#, 16#0002#),
         15623 => (16#3CFE#, 16#0020#, 16#0002#),
         15624 => (16#3CFF#, 16#0020#, 16#0002#),
         15625 => (16#3D00#, 16#0020#, 16#0002#),
         15626 => (16#3D01#, 16#0020#, 16#0002#),
         15627 => (16#3D02#, 16#0020#, 16#0002#),
         15628 => (16#3D03#, 16#0020#, 16#0002#),
         15629 => (16#3D04#, 16#0020#, 16#0002#),
         15630 => (16#3D05#, 16#0020#, 16#0002#),
         15631 => (16#3D06#, 16#0020#, 16#0002#),
         15632 => (16#3D07#, 16#0020#, 16#0002#),
         15633 => (16#3D08#, 16#0020#, 16#0002#),
         15634 => (16#3D09#, 16#0020#, 16#0002#),
         15635 => (16#3D0A#, 16#0020#, 16#0002#),
         15636 => (16#3D0B#, 16#0020#, 16#0002#),
         15637 => (16#3D0C#, 16#0020#, 16#0002#),
         15638 => (16#3D0D#, 16#0020#, 16#0002#),
         15639 => (16#3D0E#, 16#0020#, 16#0002#),
         15640 => (16#3D0F#, 16#0020#, 16#0002#),
         15641 => (16#3D10#, 16#0020#, 16#0002#),
         15642 => (16#3D11#, 16#0020#, 16#0002#),
         15643 => (16#3D12#, 16#0020#, 16#0002#),
         15644 => (16#3D13#, 16#0020#, 16#0002#),
         15645 => (16#3D14#, 16#0020#, 16#0002#),
         15646 => (16#3D15#, 16#0020#, 16#0002#),
         15647 => (16#3D16#, 16#0020#, 16#0002#),
         15648 => (16#3D17#, 16#0020#, 16#0002#),
         15649 => (16#3D18#, 16#0020#, 16#0002#),
         15650 => (16#3D19#, 16#0020#, 16#0002#),
         15651 => (16#3D1A#, 16#0020#, 16#0002#),
         15652 => (16#3D1B#, 16#0020#, 16#0002#),
         15653 => (16#3D1C#, 16#0020#, 16#0002#),
         15654 => (16#3D1D#, 16#0020#, 16#0002#),
         15655 => (16#3D1E#, 16#0020#, 16#0002#),
         15656 => (16#3D1F#, 16#0020#, 16#0002#),
         15657 => (16#3D20#, 16#0020#, 16#0002#),
         15658 => (16#3D21#, 16#0020#, 16#0002#),
         15659 => (16#3D22#, 16#0020#, 16#0002#),
         15660 => (16#3D23#, 16#0020#, 16#0002#),
         15661 => (16#3D24#, 16#0020#, 16#0002#),
         15662 => (16#3D25#, 16#0020#, 16#0002#),
         15663 => (16#3D26#, 16#0020#, 16#0002#),
         15664 => (16#3D27#, 16#0020#, 16#0002#),
         15665 => (16#3D28#, 16#0020#, 16#0002#),
         15666 => (16#3D29#, 16#0020#, 16#0002#),
         15667 => (16#3D2A#, 16#0020#, 16#0002#),
         15668 => (16#3D2B#, 16#0020#, 16#0002#),
         15669 => (16#3D2C#, 16#0020#, 16#0002#),
         15670 => (16#3D2D#, 16#0020#, 16#0002#),
         15671 => (16#3D2E#, 16#0020#, 16#0002#),
         15672 => (16#3D2F#, 16#0020#, 16#0002#),
         15673 => (16#3D30#, 16#0020#, 16#0002#),
         15674 => (16#3D31#, 16#0020#, 16#0002#),
         15675 => (16#3D32#, 16#0020#, 16#0002#),
         15676 => (16#3D33#, 16#0020#, 16#0002#),
         15677 => (16#3D34#, 16#0020#, 16#0002#),
         15678 => (16#3D35#, 16#0020#, 16#0002#),
         15679 => (16#3D36#, 16#0020#, 16#0002#),
         15680 => (16#3D37#, 16#0020#, 16#0002#),
         15681 => (16#3D38#, 16#0020#, 16#0002#),
         15682 => (16#3D39#, 16#0020#, 16#0002#),
         15683 => (16#3D3A#, 16#0020#, 16#0002#),
         15684 => (16#3D3B#, 16#0020#, 16#0002#),
         15685 => (16#3D3C#, 16#0020#, 16#0002#),
         15686 => (16#3D3D#, 16#0020#, 16#0002#),
         15687 => (16#3D3E#, 16#0020#, 16#0002#),
         15688 => (16#3D3F#, 16#0020#, 16#0002#),
         15689 => (16#3D40#, 16#0020#, 16#0002#),
         15690 => (16#3D41#, 16#0020#, 16#0002#),
         15691 => (16#3D42#, 16#0020#, 16#0002#),
         15692 => (16#3D43#, 16#0020#, 16#0002#),
         15693 => (16#3D44#, 16#0020#, 16#0002#),
         15694 => (16#3D45#, 16#0020#, 16#0002#),
         15695 => (16#3D46#, 16#0020#, 16#0002#),
         15696 => (16#3D47#, 16#0020#, 16#0002#),
         15697 => (16#3D48#, 16#0020#, 16#0002#),
         15698 => (16#3D49#, 16#0020#, 16#0002#),
         15699 => (16#3D4A#, 16#0020#, 16#0002#),
         15700 => (16#3D4B#, 16#0020#, 16#0002#),
         15701 => (16#3D4C#, 16#0020#, 16#0002#),
         15702 => (16#3D4D#, 16#0020#, 16#0002#),
         15703 => (16#3D4E#, 16#0020#, 16#0002#),
         15704 => (16#3D4F#, 16#0020#, 16#0002#),
         15705 => (16#3D50#, 16#0020#, 16#0002#),
         15706 => (16#3D51#, 16#0020#, 16#0002#),
         15707 => (16#3D52#, 16#0020#, 16#0002#),
         15708 => (16#3D53#, 16#0020#, 16#0002#),
         15709 => (16#3D54#, 16#0020#, 16#0002#),
         15710 => (16#3D55#, 16#0020#, 16#0002#),
         15711 => (16#3D56#, 16#0020#, 16#0002#),
         15712 => (16#3D57#, 16#0020#, 16#0002#),
         15713 => (16#3D58#, 16#0020#, 16#0002#),
         15714 => (16#3D59#, 16#0020#, 16#0002#),
         15715 => (16#3D5A#, 16#0020#, 16#0002#),
         15716 => (16#3D5B#, 16#0020#, 16#0002#),
         15717 => (16#3D5C#, 16#0020#, 16#0002#),
         15718 => (16#3D5D#, 16#0020#, 16#0002#),
         15719 => (16#3D5E#, 16#0020#, 16#0002#),
         15720 => (16#3D5F#, 16#0020#, 16#0002#),
         15721 => (16#3D60#, 16#0020#, 16#0002#),
         15722 => (16#3D61#, 16#0020#, 16#0002#),
         15723 => (16#3D62#, 16#0020#, 16#0002#),
         15724 => (16#3D63#, 16#0020#, 16#0002#),
         15725 => (16#3D64#, 16#0020#, 16#0002#),
         15726 => (16#3D65#, 16#0020#, 16#0002#),
         15727 => (16#3D66#, 16#0020#, 16#0002#),
         15728 => (16#3D67#, 16#0020#, 16#0002#),
         15729 => (16#3D68#, 16#0020#, 16#0002#),
         15730 => (16#3D69#, 16#0020#, 16#0002#),
         15731 => (16#3D6A#, 16#0020#, 16#0002#),
         15732 => (16#3D6B#, 16#0020#, 16#0002#),
         15733 => (16#3D6C#, 16#0020#, 16#0002#),
         15734 => (16#3D6D#, 16#0020#, 16#0002#),
         15735 => (16#3D6E#, 16#0020#, 16#0002#),
         15736 => (16#3D6F#, 16#0020#, 16#0002#),
         15737 => (16#3D70#, 16#0020#, 16#0002#),
         15738 => (16#3D71#, 16#0020#, 16#0002#),
         15739 => (16#3D72#, 16#0020#, 16#0002#),
         15740 => (16#3D73#, 16#0020#, 16#0002#),
         15741 => (16#3D74#, 16#0020#, 16#0002#),
         15742 => (16#3D75#, 16#0020#, 16#0002#),
         15743 => (16#3D76#, 16#0020#, 16#0002#),
         15744 => (16#3D77#, 16#0020#, 16#0002#),
         15745 => (16#3D78#, 16#0020#, 16#0002#),
         15746 => (16#3D79#, 16#0020#, 16#0002#),
         15747 => (16#0DF9#, 16#0020#, 16#0002#),
         15748 => (16#0DFA#, 16#0020#, 16#0002#),
         15749 => (16#0DFB#, 16#0020#, 16#0002#),
         15750 => (16#0DFC#, 16#0020#, 16#0002#),
         15751 => (16#0DFD#, 16#0020#, 16#0002#),
         15752 => (16#0DFE#, 16#0020#, 16#0002#),
         15753 => (16#0DFF#, 16#0020#, 16#0002#),
         15754 => (16#0E00#, 16#0020#, 16#0002#),
         15755 => (16#0E01#, 16#0020#, 16#0002#),
         15756 => (16#0E02#, 16#0020#, 16#0002#),
         15757 => (16#0E03#, 16#0020#, 16#0002#),
         15758 => (16#0E04#, 16#0020#, 16#0002#),
         15759 => (16#0E05#, 16#0020#, 16#0002#),
         15760 => (16#0E06#, 16#0020#, 16#0002#),
         15761 => (16#0E07#, 16#0020#, 16#0002#),
         15762 => (16#0E08#, 16#0020#, 16#0002#),
         15763 => (16#0E09#, 16#0020#, 16#0002#),
         15764 => (16#0E0A#, 16#0020#, 16#0002#),
         15765 => (16#0E0B#, 16#0020#, 16#0002#),
         15766 => (16#0E0C#, 16#0020#, 16#0002#),
         15767 => (16#0E0D#, 16#0020#, 16#0002#),
         15768 => (16#0E0E#, 16#0020#, 16#0002#),
         15769 => (16#0E0F#, 16#0020#, 16#0002#),
         15770 => (16#0E10#, 16#0020#, 16#0002#),
         15771 => (16#0E11#, 16#0020#, 16#0002#),
         15772 => (16#0E12#, 16#0020#, 16#0002#),
         15773 => (16#0E13#, 16#0020#, 16#0002#),
         15774 => (16#0E14#, 16#0020#, 16#0002#),
         15775 => (16#0E15#, 16#0020#, 16#0002#),
         15776 => (16#0E16#, 16#0020#, 16#0002#),
         15777 => (16#0E17#, 16#0020#, 16#0002#),
         15778 => (16#0E18#, 16#0020#, 16#0002#),
         15779 => (16#0E19#, 16#0020#, 16#0002#),
         15780 => (16#0E1A#, 16#0020#, 16#0002#),
         15781 => (16#0E1B#, 16#0020#, 16#0002#),
         15782 => (16#0E1C#, 16#0020#, 16#0002#),
         15783 => (16#0E1D#, 16#0020#, 16#0002#),
         15784 => (16#0E1E#, 16#0020#, 16#0002#),
         15785 => (16#0E1F#, 16#0020#, 16#0002#),
         15786 => (16#0E20#, 16#0020#, 16#0002#),
         15787 => (16#0E21#, 16#0020#, 16#0002#),
         15788 => (16#0E22#, 16#0020#, 16#0002#),
         15789 => (16#0E23#, 16#0020#, 16#0002#),
         15790 => (16#0E24#, 16#0020#, 16#0002#),
         15791 => (16#0E25#, 16#0020#, 16#0002#),
         15792 => (16#0E26#, 16#0020#, 16#0002#),
         15793 => (16#0E27#, 16#0020#, 16#0002#),
         15794 => (16#0E28#, 16#0020#, 16#0002#),
         15795 => (16#0E29#, 16#0020#, 16#0002#),
         15796 => (16#0E2A#, 16#0020#, 16#0002#),
         15797 => (16#0E2B#, 16#0020#, 16#0002#),
         15798 => (16#0E2C#, 16#0020#, 16#0002#),
         15799 => (16#0E2D#, 16#0020#, 16#0002#),
         15800 => (16#0E2E#, 16#0020#, 16#0002#),
         15801 => (16#0E2F#, 16#0020#, 16#0002#),
         15802 => (16#3D80#, 16#0020#, 16#0002#),
         15803 => (16#3D81#, 16#0020#, 16#0002#),
         15804 => (16#3D82#, 16#0020#, 16#0002#),
         15805 => (16#3D83#, 16#0020#, 16#0002#),
         15806 => (16#3D84#, 16#0020#, 16#0002#),
         15807 => (16#3D85#, 16#0020#, 16#0002#),
         15808 => (16#3D86#, 16#0020#, 16#0002#),
         15809 => (16#3D87#, 16#0020#, 16#0002#),
         15810 => (16#3D88#, 16#0020#, 16#0002#),
         15811 => (16#3D89#, 16#0020#, 16#0002#),
         15812 => (16#3D8A#, 16#0020#, 16#0002#),
         15813 => (16#3D8B#, 16#0020#, 16#0002#),
         15814 => (16#3D8C#, 16#0020#, 16#0002#),
         15815 => (16#3D8D#, 16#0020#, 16#0002#),
         15816 => (16#3D8E#, 16#0020#, 16#0002#),
         15817 => (16#3D8F#, 16#0020#, 16#0002#),
         15818 => (16#3D90#, 16#0020#, 16#0002#),
         15819 => (16#3D91#, 16#0020#, 16#0002#),
         15820 => (16#3D92#, 16#0020#, 16#0002#),
         15821 => (16#3D93#, 16#0020#, 16#0002#),
         15822 => (16#3D94#, 16#0020#, 16#0002#),
         15823 => (16#3D95#, 16#0020#, 16#0002#),
         15824 => (16#3D96#, 16#0020#, 16#0002#),
         15825 => (16#3D97#, 16#0020#, 16#0002#),
         15826 => (16#3D98#, 16#0020#, 16#0002#),
         15827 => (16#3D99#, 16#0020#, 16#0002#),
         15828 => (16#3D9C#, 16#0020#, 16#0002#),
         15829 => (16#3D9A#, 16#0020#, 16#0002#),
         15830 => (16#3D9D#, 16#0020#, 16#0002#),
         15831 => (16#3D9B#, 16#0020#, 16#0002#),
         15832 => (16#3D9E#, 16#0020#, 16#0002#),
         15833 => (16#3D9F#, 16#0020#, 16#0002#),
         15834 => (16#3DA0#, 16#0020#, 16#0002#),
         15835 => (16#3DA1#, 16#0020#, 16#0002#),
         15836 => (16#3DA2#, 16#0020#, 16#0002#),
         15837 => (16#3DA3#, 16#0020#, 16#0002#),
         15838 => (16#3DA4#, 16#0020#, 16#0002#),
         15839 => (16#3DA5#, 16#0020#, 16#0002#),
         15840 => (16#3DA6#, 16#0020#, 16#0002#),
         15841 => (16#3DA7#, 16#0020#, 16#0002#),
         15842 => (16#3D7A#, 16#0020#, 16#0002#),
         15843 => (16#3D7B#, 16#0020#, 16#0002#),
         15844 => (16#3D7C#, 16#0020#, 16#0002#),
         15845 => (16#3D7D#, 16#0020#, 16#0002#),
         15846 => (16#3D7F#, 16#0020#, 16#0002#),
         15847 => (16#3D7E#, 16#0020#, 16#0002#),
         15848 => (16#012C#, 16#0020#, 16#0002#),
         15849 => (16#0181#, 16#0020#, 16#0002#),
         15850 => (16#32AA#, 16#0020#, 16#0002#),
         15851 => (16#32AB#, 16#0020#, 16#0002#),
         15852 => (16#32AC#, 16#0020#, 16#0002#),
         15853 => (16#32AD#, 16#0020#, 16#0002#),
         15854 => (16#32AE#, 16#0020#, 16#0002#),
         15855 => (16#32AF#, 16#0020#, 16#0002#),
         15856 => (16#32B0#, 16#0020#, 16#0002#),
         15857 => (16#32B1#, 16#0020#, 16#0002#),
         15858 => (16#32B2#, 16#0020#, 16#0002#),
         15859 => (16#32B3#, 16#0020#, 16#0002#),
         15860 => (16#32B4#, 16#0020#, 16#0002#),
         15861 => (16#32B5#, 16#0020#, 16#0002#),
         15862 => (16#32B6#, 16#0020#, 16#0002#),
         15863 => (16#32B7#, 16#0020#, 16#0002#),
         15864 => (16#32B8#, 16#0020#, 16#0002#),
         15865 => (16#32B9#, 16#0020#, 16#0002#),
         15866 => (16#32BA#, 16#0020#, 16#0002#),
         15867 => (16#32BB#, 16#0020#, 16#0002#),
         15868 => (16#32BC#, 16#0020#, 16#0002#),
         15869 => (16#32BD#, 16#0020#, 16#0002#),
         15870 => (16#32BE#, 16#0020#, 16#0002#),
         15871 => (16#32BF#, 16#0020#, 16#0002#),
         15872 => (16#32C0#, 16#0020#, 16#0002#),
         15873 => (16#32C1#, 16#0020#, 16#0002#),
         15874 => (16#32C2#, 16#0020#, 16#0002#),
         15875 => (16#32C3#, 16#0020#, 16#0002#),
         15876 => (16#32C4#, 16#0020#, 16#0002#),
         15877 => (16#32C5#, 16#0020#, 16#0002#),
         15878 => (16#32C6#, 16#0020#, 16#0002#),
         15879 => (16#32C7#, 16#0020#, 16#0002#),
         15880 => (16#32C8#, 16#0020#, 16#0002#),
         15881 => (16#32C9#, 16#0020#, 16#0002#),
         15882 => (16#32CA#, 16#0020#, 16#0002#),
         15883 => (16#32CB#, 16#0020#, 16#0002#),
         15884 => (16#32CC#, 16#0020#, 16#0002#),
         15885 => (16#32CD#, 16#0020#, 16#0002#),
         15886 => (16#32CE#, 16#0020#, 16#0002#),
         15887 => (16#32CF#, 16#0020#, 16#0002#),
         15888 => (16#32D0#, 16#0020#, 16#0002#),
         15889 => (16#32D1#, 16#0020#, 16#0002#),
         15890 => (16#32D2#, 16#0020#, 16#0002#),
         15891 => (16#32D3#, 16#0020#, 16#0002#),
         15892 => (16#32D4#, 16#0020#, 16#0002#),
         15893 => (16#32D5#, 16#0020#, 16#0002#),
         15894 => (16#32D6#, 16#0020#, 16#0002#),
         15895 => (16#32D7#, 16#0020#, 16#0002#),
         15896 => (16#32D8#, 16#0020#, 16#0002#),
         15897 => (16#32D9#, 16#0020#, 16#0002#),
         15898 => (16#32DA#, 16#0020#, 16#0002#),
         15899 => (16#32DB#, 16#0020#, 16#0002#),
         15900 => (16#32DC#, 16#0020#, 16#0002#),
         15901 => (16#32DD#, 16#0020#, 16#0002#),
         15902 => (16#32DE#, 16#0020#, 16#0002#),
         15903 => (16#32DF#, 16#0020#, 16#0002#),
         15904 => (16#32E0#, 16#0020#, 16#0002#),
         15905 => (16#32E1#, 16#0020#, 16#0002#),
         15906 => (16#32E2#, 16#0020#, 16#0002#),
         15907 => (16#32E3#, 16#0020#, 16#0002#),
         15908 => (16#32E4#, 16#0020#, 16#0002#),
         15909 => (16#32E5#, 16#0020#, 16#0002#),
         15910 => (16#32E6#, 16#0020#, 16#0002#),
         15911 => (16#32E7#, 16#0020#, 16#0002#),
         15912 => (16#32E8#, 16#0020#, 16#0002#),
         15913 => (16#32E9#, 16#0020#, 16#0002#),
         15914 => (16#32EA#, 16#0020#, 16#0002#),
         15915 => (16#32EB#, 16#0020#, 16#0002#),
         15916 => (16#32EC#, 16#0020#, 16#0002#),
         15917 => (16#32ED#, 16#0020#, 16#0002#),
         15918 => (16#32EE#, 16#0020#, 16#0002#),
         15919 => (16#32EF#, 16#0020#, 16#0002#),
         15920 => (16#32F0#, 16#0020#, 16#0002#),
         15921 => (16#32F1#, 16#0020#, 16#0002#),
         15922 => (16#32F2#, 16#0020#, 16#0002#),
         15923 => (16#32F3#, 16#0020#, 16#0002#),
         15924 => (16#32F4#, 16#0020#, 16#0002#),
         15925 => (16#32F5#, 16#0020#, 16#0002#),
         15926 => (16#32F6#, 16#0020#, 16#0002#),
         15927 => (16#32F7#, 16#0020#, 16#0002#),
         15928 => (16#32F8#, 16#0020#, 16#0002#),
         15929 => (16#32F9#, 16#0020#, 16#0002#),
         15930 => (16#32FA#, 16#0020#, 16#0002#),
         15931 => (16#32FB#, 16#0020#, 16#0002#),
         15932 => (16#32FC#, 16#0020#, 16#0002#),
         15933 => (16#32FD#, 16#0020#, 16#0002#),
         15934 => (16#32FE#, 16#0020#, 16#0002#),
         15935 => (16#32FF#, 16#0020#, 16#0002#),
         15936 => (16#3300#, 16#0020#, 16#0002#),
         15937 => (16#3301#, 16#0020#, 16#0002#),
         15938 => (16#3302#, 16#0020#, 16#0002#),
         15939 => (16#3303#, 16#0020#, 16#0002#),
         15940 => (16#3304#, 16#0020#, 16#0002#),
         15941 => (16#3305#, 16#0020#, 16#0002#),
         15942 => (16#3306#, 16#0020#, 16#0002#),
         15943 => (16#3307#, 16#0020#, 16#0002#),
         15944 => (16#3308#, 16#0020#, 16#0002#),
         15945 => (16#3309#, 16#0020#, 16#0002#),
         15946 => (16#330A#, 16#0020#, 16#0002#),
         15947 => (16#330B#, 16#0020#, 16#0002#),
         15948 => (16#330C#, 16#0020#, 16#0002#),
         15949 => (16#330D#, 16#0020#, 16#0002#),
         15950 => (16#330E#, 16#0020#, 16#0002#),
         15951 => (16#330F#, 16#0020#, 16#0002#),
         15952 => (16#3310#, 16#0020#, 16#0002#),
         15953 => (16#3311#, 16#0020#, 16#0002#),
         15954 => (16#3312#, 16#0020#, 16#0002#),
         15955 => (16#3313#, 16#0020#, 16#0002#),
         15956 => (16#3314#, 16#0020#, 16#0002#),
         15957 => (16#3315#, 16#0020#, 16#0002#),
         15958 => (16#3316#, 16#0020#, 16#0002#),
         15959 => (16#3317#, 16#0020#, 16#0002#),
         15960 => (16#3318#, 16#0020#, 16#0002#),
         15961 => (16#3319#, 16#0020#, 16#0002#),
         15962 => (16#331A#, 16#0020#, 16#0002#),
         15963 => (16#331B#, 16#0020#, 16#0002#),
         15964 => (16#331C#, 16#0020#, 16#0002#),
         15965 => (16#331D#, 16#0020#, 16#0002#),
         15966 => (16#331E#, 16#0020#, 16#0002#),
         15967 => (16#331F#, 16#0020#, 16#0002#),
         15968 => (16#3320#, 16#0020#, 16#0002#),
         15969 => (16#3321#, 16#0020#, 16#0002#),
         15970 => (16#3322#, 16#0020#, 16#0002#),
         15971 => (16#3323#, 16#0020#, 16#0002#),
         15972 => (16#3324#, 16#0020#, 16#0002#),
         15973 => (16#3325#, 16#0020#, 16#0002#),
         15974 => (16#3326#, 16#0020#, 16#0002#),
         15975 => (16#3327#, 16#0020#, 16#0002#),
         15976 => (16#3328#, 16#0020#, 16#0002#),
         15977 => (16#3329#, 16#0020#, 16#0002#),
         15978 => (16#332A#, 16#0020#, 16#0002#),
         15979 => (16#332B#, 16#0020#, 16#0002#),
         15980 => (16#332C#, 16#0020#, 16#0002#),
         15981 => (16#332D#, 16#0020#, 16#0002#),
         15982 => (16#332E#, 16#0020#, 16#0002#),
         15983 => (16#332F#, 16#0020#, 16#0002#),
         15984 => (16#3330#, 16#0020#, 16#0002#),
         15985 => (16#3331#, 16#0020#, 16#0002#),
         15986 => (16#3332#, 16#0020#, 16#0002#),
         15987 => (16#3333#, 16#0020#, 16#0002#),
         15988 => (16#3334#, 16#0020#, 16#0002#),
         15989 => (16#3335#, 16#0020#, 16#0002#),
         15990 => (16#3336#, 16#0020#, 16#0002#),
         15991 => (16#3337#, 16#0020#, 16#0002#),
         15992 => (16#3338#, 16#0020#, 16#0002#),
         15993 => (16#3339#, 16#0020#, 16#0002#),
         15994 => (16#333A#, 16#0020#, 16#0002#),
         15995 => (16#333B#, 16#0020#, 16#0002#),
         15996 => (16#333C#, 16#0020#, 16#0002#),
         15997 => (16#333D#, 16#0020#, 16#0002#),
         15998 => (16#333E#, 16#0020#, 16#0002#),
         15999 => (16#333F#, 16#0020#, 16#0002#),
         16000 => (16#3340#, 16#0020#, 16#0002#),
         16001 => (16#3341#, 16#0020#, 16#0002#),
         16002 => (16#3342#, 16#0020#, 16#0002#),
         16003 => (16#3343#, 16#0020#, 16#0002#),
         16004 => (16#3344#, 16#0020#, 16#0002#),
         16005 => (16#3345#, 16#0020#, 16#0002#),
         16006 => (16#3346#, 16#0020#, 16#0002#),
         16007 => (16#3347#, 16#0020#, 16#0002#),
         16008 => (16#3348#, 16#0020#, 16#0002#),
         16009 => (16#3349#, 16#0020#, 16#0002#),
         16010 => (16#334A#, 16#0020#, 16#0002#),
         16011 => (16#334B#, 16#0020#, 16#0002#),
         16012 => (16#334C#, 16#0020#, 16#0002#),
         16013 => (16#334D#, 16#0020#, 16#0002#),
         16014 => (16#334E#, 16#0020#, 16#0002#),
         16015 => (16#334F#, 16#0020#, 16#0002#),
         16016 => (16#3350#, 16#0020#, 16#0002#),
         16017 => (16#3351#, 16#0020#, 16#0002#),
         16018 => (16#3352#, 16#0020#, 16#0002#),
         16019 => (16#3353#, 16#0020#, 16#0002#),
         16020 => (16#3354#, 16#0020#, 16#0002#),
         16021 => (16#3355#, 16#0020#, 16#0002#),
         16022 => (16#3356#, 16#0020#, 16#0002#),
         16023 => (16#3357#, 16#0020#, 16#0002#),
         16024 => (16#3358#, 16#0020#, 16#0002#),
         16025 => (16#3359#, 16#0020#, 16#0002#),
         16026 => (16#335A#, 16#0020#, 16#0002#),
         16027 => (16#335B#, 16#0020#, 16#0002#),
         16028 => (16#335C#, 16#0020#, 16#0002#),
         16029 => (16#335D#, 16#0020#, 16#0002#),
         16030 => (16#335E#, 16#0020#, 16#0002#),
         16031 => (16#335F#, 16#0020#, 16#0002#),
         16032 => (16#3360#, 16#0020#, 16#0002#),
         16033 => (16#3361#, 16#0020#, 16#0002#),
         16034 => (16#3362#, 16#0020#, 16#0002#),
         16035 => (16#3363#, 16#0020#, 16#0002#),
         16036 => (16#3364#, 16#0020#, 16#0002#),
         16037 => (16#3365#, 16#0020#, 16#0002#),
         16038 => (16#3366#, 16#0020#, 16#0002#),
         16039 => (16#3367#, 16#0020#, 16#0002#),
         16040 => (16#3368#, 16#0020#, 16#0002#),
         16041 => (16#3369#, 16#0020#, 16#0002#),
         16042 => (16#336A#, 16#0020#, 16#0002#),
         16043 => (16#336B#, 16#0020#, 16#0002#),
         16044 => (16#336C#, 16#0020#, 16#0002#),
         16045 => (16#336D#, 16#0020#, 16#0002#),
         16046 => (16#336E#, 16#0020#, 16#0002#),
         16047 => (16#336F#, 16#0020#, 16#0002#),
         16048 => (16#3370#, 16#0020#, 16#0002#),
         16049 => (16#3371#, 16#0020#, 16#0002#),
         16050 => (16#3372#, 16#0020#, 16#0002#),
         16051 => (16#3373#, 16#0020#, 16#0002#),
         16052 => (16#3374#, 16#0020#, 16#0002#),
         16053 => (16#3375#, 16#0020#, 16#0002#),
         16054 => (16#3376#, 16#0020#, 16#0002#),
         16055 => (16#3377#, 16#0020#, 16#0002#),
         16056 => (16#3378#, 16#0020#, 16#0002#),
         16057 => (16#3379#, 16#0020#, 16#0002#),
         16058 => (16#337A#, 16#0020#, 16#0002#),
         16059 => (16#337B#, 16#0020#, 16#0002#),
         16060 => (16#337C#, 16#0020#, 16#0002#),
         16061 => (16#337D#, 16#0020#, 16#0002#),
         16062 => (16#337E#, 16#0020#, 16#0002#),
         16063 => (16#337F#, 16#0020#, 16#0002#),
         16064 => (16#3380#, 16#0020#, 16#0002#),
         16065 => (16#3381#, 16#0020#, 16#0002#),
         16066 => (16#3382#, 16#0020#, 16#0002#),
         16067 => (16#3383#, 16#0020#, 16#0002#),
         16068 => (16#3384#, 16#0020#, 16#0002#),
         16069 => (16#3385#, 16#0020#, 16#0002#),
         16070 => (16#3386#, 16#0020#, 16#0002#),
         16071 => (16#3387#, 16#0020#, 16#0002#),
         16072 => (16#3388#, 16#0020#, 16#0002#),
         16073 => (16#3389#, 16#0020#, 16#0002#),
         16074 => (16#338A#, 16#0020#, 16#0002#),
         16075 => (16#338B#, 16#0020#, 16#0002#),
         16076 => (16#338C#, 16#0020#, 16#0002#),
         16077 => (16#338D#, 16#0020#, 16#0002#),
         16078 => (16#338E#, 16#0020#, 16#0002#),
         16079 => (16#338F#, 16#0020#, 16#0002#),
         16080 => (16#3390#, 16#0020#, 16#0002#),
         16081 => (16#3391#, 16#0020#, 16#0002#),
         16082 => (16#3392#, 16#0020#, 16#0002#),
         16083 => (16#3393#, 16#0020#, 16#0002#),
         16084 => (16#3394#, 16#0020#, 16#0002#),
         16085 => (16#3395#, 16#0020#, 16#0002#),
         16086 => (16#3396#, 16#0020#, 16#0002#),
         16087 => (16#3397#, 16#0020#, 16#0002#),
         16088 => (16#3398#, 16#0020#, 16#0002#),
         16089 => (16#3399#, 16#0020#, 16#0002#),
         16090 => (16#339A#, 16#0020#, 16#0002#),
         16091 => (16#339B#, 16#0020#, 16#0002#),
         16092 => (16#339C#, 16#0020#, 16#0002#),
         16093 => (16#339D#, 16#0020#, 16#0002#),
         16094 => (16#339E#, 16#0020#, 16#0002#),
         16095 => (16#339F#, 16#0020#, 16#0002#),
         16096 => (16#33A0#, 16#0020#, 16#0002#),
         16097 => (16#33A1#, 16#0020#, 16#0002#),
         16098 => (16#33A2#, 16#0020#, 16#0002#),
         16099 => (16#33A3#, 16#0020#, 16#0002#),
         16100 => (16#33A4#, 16#0020#, 16#0002#),
         16101 => (16#33A5#, 16#0020#, 16#0002#),
         16102 => (16#33A6#, 16#0020#, 16#0002#),
         16103 => (16#33A7#, 16#0020#, 16#0002#),
         16104 => (16#33A8#, 16#0020#, 16#0002#),
         16105 => (16#33A9#, 16#0020#, 16#0002#),
         16106 => (16#33AA#, 16#0020#, 16#0002#),
         16107 => (16#33AB#, 16#0020#, 16#0002#),
         16108 => (16#33AC#, 16#0020#, 16#0002#),
         16109 => (16#33AD#, 16#0020#, 16#0002#),
         16110 => (16#33AE#, 16#0020#, 16#0002#),
         16111 => (16#33AF#, 16#0020#, 16#0002#),
         16112 => (16#33B0#, 16#0020#, 16#0002#),
         16113 => (16#33B1#, 16#0020#, 16#0002#),
         16114 => (16#33B2#, 16#0020#, 16#0002#),
         16115 => (16#33B3#, 16#0020#, 16#0002#),
         16116 => (16#33B4#, 16#0020#, 16#0002#),
         16117 => (16#33B5#, 16#0020#, 16#0002#),
         16118 => (16#33B6#, 16#0020#, 16#0002#),
         16119 => (16#012D#, 16#0020#, 16#0002#),
         16120 => (16#0182#, 16#0020#, 16#0002#),
         16121 => (16#016D#, 16#0020#, 16#0002#),
         16122 => (16#3302#, 16#0020#, 16#0004#),
         16123 => (16#3314#, 16#0020#, 16#0004#),
         16124 => (16#3331#, 16#0020#, 16#0004#),
         16125 => (16#32B6#, 16#0020#, 16#0004#),
         16126 => (16#33B5#, 16#0020#, 16#0004#),
         16127 => (16#32C8#, 16#0020#, 16#0004#),
         16128 => (16#33B5#, 16#0020#, 16#0004#),
         16129 => (16#32DD#, 16#0020#, 16#0004#),
         16130 => (16#33B5#, 16#0020#, 16#0004#),
         16131 => (16#32F1#, 16#0020#, 16#0004#),
         16132 => (16#33B6#, 16#0020#, 16#0004#),
         16133 => (16#32FC#, 16#0020#, 16#0004#),
         16134 => (16#33B5#, 16#0020#, 16#0004#),
         16135 => (16#3302#, 16#0020#, 16#0004#),
         16136 => (16#33B6#, 16#0020#, 16#0004#),
         16137 => (16#3304#, 16#0020#, 16#0004#),
         16138 => (16#33B6#, 16#0020#, 16#0004#),
         16139 => (16#330A#, 16#0020#, 16#0004#),
         16140 => (16#33B5#, 16#0020#, 16#0004#),
         16141 => (16#332F#, 16#0020#, 16#0004#),
         16142 => (16#33B5#, 16#0020#, 16#0004#),
         16143 => (16#335E#, 16#0020#, 16#0004#),
         16144 => (16#33B5#, 16#0020#, 16#0004#),
         16145 => (16#3375#, 16#0020#, 16#0004#),
         16146 => (16#33B5#, 16#0020#, 16#0004#),
         16147 => (16#337B#, 16#0020#, 16#0004#),
         16148 => (16#33B6#, 16#0020#, 16#0004#),
         16149 => (16#3382#, 16#0020#, 16#0004#),
         16150 => (16#33B5#, 16#0020#, 16#0004#),
         16151 => (16#3318#, 16#0020#, 16#0004#),
         16152 => (16#1D2E#, 16#0020#, 16#0008#),
         16153 => (16#1D2E#, 16#0020#, 16#0002#),
         16154 => (16#1D31#, 16#0020#, 16#0008#),
         16155 => (16#1D31#, 16#0020#, 16#0002#),
         16156 => (16#1D36#, 16#0020#, 16#0008#),
         16157 => (16#1D36#, 16#0020#, 16#0002#),
         16158 => (16#1D4A#, 16#0020#, 16#0008#),
         16159 => (16#1D4A#, 16#0020#, 16#0002#),
         16160 => (16#1D53#, 16#0020#, 16#0008#),
         16161 => (16#1D53#, 16#0020#, 16#0002#),
         16162 => (16#1DE7#, 16#0020#, 16#0008#),
         16163 => (16#1DE7#, 16#0020#, 16#0002#),
         16164 => (16#1E0E#, 16#0020#, 16#0008#),
         16165 => (16#1E0E#, 16#0020#, 16#0002#),
         16166 => (16#1E4A#, 16#0020#, 16#0008#),
         16167 => (16#1E4A#, 16#0020#, 16#0002#),
         16168 => (16#1E51#, 16#0020#, 16#0008#),
         16169 => (16#1E51#, 16#0020#, 16#0002#),
         16170 => (16#1E62#, 16#0020#, 16#0008#),
         16171 => (16#1E62#, 16#0020#, 16#0002#),
         16172 => (16#1E6B#, 16#0020#, 16#0008#),
         16173 => (16#1E6B#, 16#0020#, 16#0002#),
         16174 => (16#1E6C#, 16#0020#, 16#0008#),
         16175 => (16#1E6C#, 16#0020#, 16#0002#),
         16176 => (16#1E7A#, 16#0020#, 16#0008#),
         16177 => (16#1E7A#, 16#0020#, 16#0002#),
         16178 => (16#1E7F#, 16#0020#, 16#0008#),
         16179 => (16#1E7F#, 16#0020#, 16#0002#),
         16180 => (16#1E84#, 16#0020#, 16#0008#),
         16181 => (16#1E84#, 16#0020#, 16#0002#),
         16182 => (16#1E99#, 16#0020#, 16#0008#),
         16183 => (16#1E99#, 16#0020#, 16#0002#),
         16184 => (16#1E1B#, 16#0020#, 16#0008#),
         16185 => (16#1E1B#, 16#0020#, 16#0002#),
         16186 => (16#1D12#, 16#0020#, 16#0008#),
         16187 => (16#1D12#, 16#0020#, 16#0002#),
         16188 => (16#1D7E#, 16#0020#, 16#0008#),
         16189 => (16#1D7E#, 16#0020#, 16#0002#),
         16190 => (16#1D89#, 16#0020#, 16#0008#),
         16191 => (16#1D89#, 16#0020#, 16#0002#),
         16192 => (16#1DA5#, 16#0020#, 16#000A#),
         16193 => (16#0000#, 16#0051#, 16#0002#),
         16194 => (16#0285#, 16#0020#, 16#0002#),
         16195 => (16#1D1C#, 16#0020#, 16#0004#),
         16196 => (16#1D3E#, 16#0020#, 16#0004#),
         16197 => (16#1D46#, 16#0020#, 16#0004#),
         16198 => (16#0000#, 16#002B#, 16#0004#),
         16199 => (16#1DDB#, 16#0020#, 16#0004#),
         16200 => (16#1E4D#, 16#0020#, 16#0004#),
         16201 => (16#1E52#, 16#0020#, 16#0004#),
         16202 => (16#1E56#, 16#0020#, 16#0004#),
         16203 => (16#1E06#, 16#0020#, 16#0004#),
         16204 => (16#02BB#, 16#0020#, 16#0002#),
         16205 => (16#1E4C#, 16#0020#, 16#0002#),
         16206 => (16#1D0D#, 16#0020#, 16#0008#),
         16207 => (16#1D0D#, 16#0020#, 16#0002#),
         16208 => (16#1D3D#, 16#0020#, 16#0008#),
         16209 => (16#1D3D#, 16#0020#, 16#0002#),
         16210 => (16#1D25#, 16#0020#, 16#0008#),
         16211 => (16#1D25#, 16#0020#, 16#0002#),
         16212 => (16#1E34#, 16#0020#, 16#0008#),
         16213 => (16#1E34#, 16#0020#, 16#0002#),
         16214 => (16#1D3B#, 16#0020#, 16#0008#),
         16215 => (16#1D3B#, 16#0020#, 16#0002#),
         16216 => (16#1DD6#, 16#0020#, 16#0008#),
         16217 => (16#1DD6#, 16#0020#, 16#0002#),
         16218 => (16#1DD0#, 16#0020#, 16#0008#),
         16219 => (16#1DD0#, 16#0020#, 16#0002#),
         16220 => (16#1E1C#, 16#0020#, 16#0008#),
         16221 => (16#1E1C#, 16#0020#, 16#0002#),
         16222 => (16#1E21#, 16#0020#, 16#0008#),
         16223 => (16#1E21#, 16#0020#, 16#0002#),
         16224 => (16#1E27#, 16#0020#, 16#0008#),
         16225 => (16#1E27#, 16#0020#, 16#0002#),
         16226 => (16#1E05#, 16#0020#, 16#0008#),
         16227 => (16#1E05#, 16#0020#, 16#0002#),
         16228 => (16#1E45#, 16#0020#, 16#0008#),
         16229 => (16#1E45#, 16#0020#, 16#0002#),
         16230 => (16#1E4D#, 16#0020#, 16#0014#),
         16231 => (16#1E56#, 16#0020#, 16#0014#),
         16232 => (16#1E72#, 16#0020#, 16#0004#),
         16233 => (16#33B7#, 16#0020#, 16#0002#),
         16234 => (16#33B8#, 16#0020#, 16#0002#),
         16235 => (16#33B9#, 16#0020#, 16#0002#),
         16236 => (16#33BA#, 16#0020#, 16#0002#),
         16237 => (16#33BB#, 16#0020#, 16#0002#),
         16238 => (16#33BC#, 16#0020#, 16#0002#),
         16239 => (16#33BD#, 16#0020#, 16#0002#),
         16240 => (16#33BE#, 16#0020#, 16#0002#),
         16241 => (16#33BF#, 16#0020#, 16#0002#),
         16242 => (16#33C0#, 16#0020#, 16#0002#),
         16243 => (16#33C1#, 16#0020#, 16#0002#),
         16244 => (16#33C2#, 16#0020#, 16#0002#),
         16245 => (16#33C3#, 16#0020#, 16#0002#),
         16246 => (16#33C4#, 16#0020#, 16#0002#),
         16247 => (16#33C5#, 16#0020#, 16#0002#),
         16248 => (16#33C6#, 16#0020#, 16#0002#),
         16249 => (16#33C7#, 16#0020#, 16#0002#),
         16250 => (16#33C8#, 16#0020#, 16#0002#),
         16251 => (16#33C9#, 16#0020#, 16#0002#),
         16252 => (16#33CA#, 16#0020#, 16#0002#),
         16253 => (16#33CB#, 16#0020#, 16#0002#),
         16254 => (16#33CC#, 16#0020#, 16#0002#),
         16255 => (16#33CD#, 16#0020#, 16#0002#),
         16256 => (16#33CE#, 16#0020#, 16#0002#),
         16257 => (16#33CF#, 16#0020#, 16#0002#),
         16258 => (16#33D0#, 16#0020#, 16#0002#),
         16259 => (16#33D1#, 16#0020#, 16#0002#),
         16260 => (16#33D2#, 16#0020#, 16#0002#),
         16261 => (16#33D3#, 16#0020#, 16#0002#),
         16262 => (16#33D4#, 16#0020#, 16#0002#),
         16263 => (16#33D5#, 16#0020#, 16#0002#),
         16264 => (16#33D6#, 16#0020#, 16#0002#),
         16265 => (16#33D7#, 16#0020#, 16#0002#),
         16266 => (16#33D8#, 16#0020#, 16#0002#),
         16267 => (16#33D9#, 16#0020#, 16#0002#),
         16268 => (16#33DA#, 16#0020#, 16#0002#),
         16269 => (16#33DB#, 16#0020#, 16#0002#),
         16270 => (16#33DC#, 16#0020#, 16#0002#),
         16271 => (16#33DD#, 16#0020#, 16#0002#),
         16272 => (16#33DE#, 16#0020#, 16#0002#),
         16273 => (16#33DF#, 16#0020#, 16#0002#),
         16274 => (16#33E0#, 16#0020#, 16#0002#),
         16275 => (16#33E1#, 16#0020#, 16#0002#),
         16276 => (16#33E2#, 16#0020#, 16#0002#),
         16277 => (16#33E3#, 16#0020#, 16#0002#),
         16278 => (16#33E4#, 16#0020#, 16#0002#),
         16279 => (16#33E5#, 16#0020#, 16#0002#),
         16280 => (16#33E6#, 16#0020#, 16#0002#),
         16281 => (16#33E7#, 16#0020#, 16#0002#),
         16282 => (16#33E8#, 16#0020#, 16#0002#),
         16283 => (16#33E9#, 16#0020#, 16#0002#),
         16284 => (16#33EA#, 16#0020#, 16#0002#),
         16285 => (16#33EB#, 16#0020#, 16#0002#),
         16286 => (16#33EC#, 16#0020#, 16#0002#),
         16287 => (16#33ED#, 16#0020#, 16#0002#),
         16288 => (16#33EE#, 16#0020#, 16#0002#),
         16289 => (16#33EF#, 16#0020#, 16#0002#),
         16290 => (16#33F0#, 16#0020#, 16#0002#),
         16291 => (16#33F1#, 16#0020#, 16#0002#),
         16292 => (16#33F2#, 16#0020#, 16#0002#),
         16293 => (16#33F3#, 16#0020#, 16#0002#),
         16294 => (16#33F4#, 16#0020#, 16#0002#),
         16295 => (16#33F5#, 16#0020#, 16#0002#),
         16296 => (16#33F6#, 16#0020#, 16#0002#),
         16297 => (16#33F7#, 16#0020#, 16#0002#),
         16298 => (16#33F8#, 16#0020#, 16#0002#),
         16299 => (16#33F9#, 16#0020#, 16#0002#),
         16300 => (16#33FA#, 16#0020#, 16#0002#),
         16301 => (16#33FB#, 16#0020#, 16#0002#),
         16302 => (16#33FC#, 16#0020#, 16#0002#),
         16303 => (16#33FD#, 16#0020#, 16#0002#),
         16304 => (16#33FE#, 16#0020#, 16#0002#),
         16305 => (16#33FF#, 16#0020#, 16#0002#),
         16306 => (16#3400#, 16#0020#, 16#0002#),
         16307 => (16#3401#, 16#0020#, 16#0002#),
         16308 => (16#3402#, 16#0020#, 16#0002#),
         16309 => (16#3403#, 16#0020#, 16#0002#),
         16310 => (16#3404#, 16#0020#, 16#0002#),
         16311 => (16#3405#, 16#0020#, 16#0002#),
         16312 => (16#3406#, 16#0020#, 16#0002#),
         16313 => (16#0000#, 16#00B5#, 16#0002#),
         16314 => (16#0000#, 16#00B6#, 16#0002#),
         16315 => (16#01CD#, 16#0020#, 16#0002#),
         16316 => (16#0183#, 16#0020#, 16#0002#),
         16317 => (16#015D#, 16#0020#, 16#0002#),
         16318 => (16#012E#, 16#0020#, 16#0002#),
         16319 => (16#0136#, 16#0020#, 16#0002#),
         16320 => (16#016E#, 16#0020#, 16#0002#),
         16321 => (16#0394#, 16#0020#, 16#0002#),
         16322 => (16#0395#, 16#0020#, 16#0002#),
         16323 => (16#0396#, 16#0020#, 16#0002#),
         16324 => (16#0397#, 16#0020#, 16#0002#),
         16325 => (16#0398#, 16#0020#, 16#0002#),
         16326 => (16#0399#, 16#0020#, 16#0002#),
         16327 => (16#039A#, 16#0020#, 16#0002#),
         16328 => (16#039B#, 16#0020#, 16#0002#),
         16329 => (16#039C#, 16#0020#, 16#0002#),
         16330 => (16#039D#, 16#0020#, 16#0002#),
         16331 => (16#039E#, 16#0020#, 16#0002#),
         16332 => (16#039F#, 16#0020#, 16#0002#),
         16333 => (16#03A0#, 16#0020#, 16#0002#),
         16334 => (16#03A1#, 16#0020#, 16#0002#),
         16335 => (16#03A2#, 16#0020#, 16#0002#),
         16336 => (16#03A3#, 16#0020#, 16#0002#),
         16337 => (16#03A4#, 16#0020#, 16#0002#),
         16338 => (16#03A5#, 16#0020#, 16#0002#),
         16339 => (16#03A6#, 16#0020#, 16#0002#),
         16340 => (16#03A7#, 16#0020#, 16#0002#),
         16341 => (16#03A8#, 16#0020#, 16#0002#),
         16342 => (16#03A9#, 16#0020#, 16#0002#),
         16343 => (16#03AA#, 16#0020#, 16#0002#),
         16344 => (16#03AB#, 16#0020#, 16#0002#),
         16345 => (16#03AC#, 16#0020#, 16#0002#),
         16346 => (16#03AD#, 16#0020#, 16#0002#),
         16347 => (16#03AE#, 16#0020#, 16#0002#),
         16348 => (16#03AF#, 16#0020#, 16#0002#),
         16349 => (16#03B0#, 16#0020#, 16#0002#),
         16350 => (16#03B1#, 16#0020#, 16#0002#),
         16351 => (16#03B2#, 16#0020#, 16#0002#),
         16352 => (16#03B3#, 16#0020#, 16#0002#),
         16353 => (16#03B4#, 16#0020#, 16#0002#),
         16354 => (16#03B5#, 16#0020#, 16#0002#),
         16355 => (16#1C40#, 16#0020#, 16#0008#),
         16356 => (16#1C40#, 16#0020#, 16#0002#),
         16357 => (16#1C4A#, 16#0020#, 16#0008#),
         16358 => (16#1C4A#, 16#0020#, 16#0002#),
         16359 => (16#19EF#, 16#0020#, 16#0008#),
         16360 => (16#19EF#, 16#0020#, 16#0002#),
         16361 => (16#1B57#, 16#0020#, 16#000A#),
         16362 => (16#1BE3#, 16#0020#, 16#0004#),
         16363 => (16#1B57#, 16#0020#, 16#0004#),
         16364 => (16#1BE3#, 16#0020#, 16#0004#),
         16365 => (16#1C25#, 16#0020#, 16#0008#),
         16366 => (16#1C25#, 16#0020#, 16#0002#),
         16367 => (16#1C26#, 16#0020#, 16#0008#),
         16368 => (16#1C26#, 16#0020#, 16#0002#),
         16369 => (16#1C27#, 16#0020#, 16#0008#),
         16370 => (16#1C27#, 16#0020#, 16#0002#),
         16371 => (16#19AD#, 16#0020#, 16#0002#),
         16372 => (16#1B37#, 16#0020#, 16#0002#),
         16373 => (16#190C#, 16#0020#, 16#000A#),
         16374 => (16#190C#, 16#0020#, 16#000A#),
         16375 => (16#190C#, 16#0020#, 16#0004#),
         16376 => (16#190C#, 16#0020#, 16#0004#),
         16377 => (16#190C#, 16#0020#, 16#000A#),
         16378 => (16#1AA1#, 16#0020#, 16#000A#),
         16379 => (16#190C#, 16#0020#, 16#000A#),
         16380 => (16#1B77#, 16#0020#, 16#000A#),
         16381 => (16#190C#, 16#0020#, 16#0004#),
         16382 => (16#1B77#, 16#0020#, 16#0004#),
         16383 => (16#190C#, 16#0020#, 16#000A#),
         16384 => (16#1BA5#, 16#0020#, 16#000A#),
         16385 => (16#190C#, 16#0020#, 16#000A#),
         16386 => (16#0000#, 16#0108#, 16#0004#),
         16387 => (16#1BA5#, 16#0020#, 16#000A#),
         16388 => (16#190C#, 16#0020#, 16#0004#),
         16389 => (16#0000#, 16#0108#, 16#0004#),
         16390 => (16#1BA5#, 16#0020#, 16#0004#),
         16391 => (16#190C#, 16#0020#, 16#000A#),
         16392 => (16#1BCD#, 16#0020#, 16#000A#),
         16393 => (16#190C#, 16#0020#, 16#0004#),
         16394 => (16#1BCD#, 16#0020#, 16#0004#),
         16395 => (16#1952#, 16#0020#, 16#0008#),
         16396 => (16#1952#, 16#0020#, 16#0002#),
         16397 => (16#1A34#, 16#0020#, 16#0008#),
         16398 => (16#1A34#, 16#0020#, 16#0002#),
         16399 => (16#1A35#, 16#0020#, 16#0008#),
         16400 => (16#1A35#, 16#0020#, 16#0002#),
         16401 => (16#1A36#, 16#0020#, 16#0008#),
         16402 => (16#1A36#, 16#0020#, 16#0002#),
         16403 => (16#1A43#, 16#0020#, 16#0008#),
         16404 => (16#1A43#, 16#0020#, 16#0002#),
         16405 => (16#1A45#, 16#0020#, 16#0008#),
         16406 => (16#1A45#, 16#0020#, 16#0002#),
         16407 => (16#1AC4#, 16#0020#, 16#0008#),
         16408 => (16#1AC4#, 16#0020#, 16#0002#),
         16409 => (16#1ABC#, 16#0020#, 16#0008#),
         16410 => (16#1ABC#, 16#0020#, 16#0002#),
         16411 => (16#1AA1#, 16#0020#, 16#000A#),
         16412 => (16#1AA1#, 16#0020#, 16#000A#),
         16413 => (16#1AA1#, 16#0020#, 16#0004#),
         16414 => (16#1AA1#, 16#0020#, 16#0004#),
         16415 => (16#1AD4#, 16#0020#, 16#0008#),
         16416 => (16#1AD4#, 16#0020#, 16#0002#),
         16417 => (16#1ADB#, 16#0020#, 16#0008#),
         16418 => (16#1ADB#, 16#0020#, 16#0002#),
         16419 => (16#1ADC#, 16#0020#, 16#0008#),
         16420 => (16#1ADC#, 16#0020#, 16#0002#),
         16421 => (16#1AE7#, 16#0020#, 16#0008#),
         16422 => (16#1AE7#, 16#0020#, 16#0002#),
         16423 => (16#1AE8#, 16#0020#, 16#0008#),
         16424 => (16#1AE8#, 16#0020#, 16#0002#),
         16425 => (16#1AFF#, 16#0020#, 16#0008#),
         16426 => (16#1AFF#, 16#0020#, 16#0002#),
         16427 => (16#1B32#, 16#0020#, 16#0008#),
         16428 => (16#1B32#, 16#0020#, 16#0002#),
         16429 => (16#1BAA#, 16#0020#, 16#0008#),
         16430 => (16#1BAA#, 16#0020#, 16#0002#),
         16431 => (16#1BA5#, 16#0020#, 16#000A#),
         16432 => (16#1BCD#, 16#0020#, 16#000A#),
         16433 => (16#1BA5#, 16#0020#, 16#0004#),
         16434 => (16#1BCD#, 16#0020#, 16#0004#),
         16435 => (16#1BFF#, 16#0020#, 16#0008#),
         16436 => (16#1BFF#, 16#0020#, 16#0002#),
         16437 => (16#1C16#, 16#0020#, 16#0008#),
         16438 => (16#1C16#, 16#0020#, 16#0002#),
         16439 => (16#1C17#, 16#0020#, 16#0008#),
         16440 => (16#1C17#, 16#0020#, 16#0002#),
         16441 => (16#1C1C#, 16#0020#, 16#0008#),
         16442 => (16#1C1C#, 16#0020#, 16#0002#),
         16443 => (16#1C1D#, 16#0020#, 16#0008#),
         16444 => (16#1C1D#, 16#0020#, 16#0002#),
         16445 => (16#1C1E#, 16#0020#, 16#0008#),
         16446 => (16#1C1E#, 16#0020#, 16#0002#),
         16447 => (16#1C1F#, 16#0020#, 16#0008#),
         16448 => (16#1C1F#, 16#0020#, 16#0002#),
         16449 => (16#1C1F#, 16#0020#, 16#0014#),
         16450 => (16#196C#, 16#0020#, 16#0002#),
         16451 => (16#1A60#, 16#0020#, 16#0002#),
         16452 => (16#1A7C#, 16#0020#, 16#0002#),
         16453 => (16#1A9B#, 16#0020#, 16#0002#),
         16454 => (16#1B30#, 16#0020#, 16#0002#),
         16455 => (16#1B31#, 16#0020#, 16#0002#),
         16456 => (16#1B72#, 16#0020#, 16#0002#),
         16457 => (16#1C20#, 16#0020#, 16#0002#),
         16458 => (16#1953#, 16#0020#, 16#000A#),
         16459 => (16#0000#, 16#0109#, 16#0004#),
         16460 => (16#19A9#, 16#0020#, 16#000A#),
         16461 => (16#0000#, 16#0109#, 16#0004#),
         16462 => (16#19A9#, 16#0020#, 16#0004#),
         16463 => (16#0000#, 16#0109#, 16#0004#),
         16464 => (16#19B8#, 16#0020#, 16#000A#),
         16465 => (16#0000#, 16#0109#, 16#0004#),
         16466 => (16#19D3#, 16#0020#, 16#0008#),
         16467 => (16#19D3#, 16#0020#, 16#0002#),
         16468 => (16#1A65#, 16#0020#, 16#0008#),
         16469 => (16#1A65#, 16#0020#, 16#0002#),
         16470 => (16#1AF5#, 16#0020#, 16#000A#),
         16471 => (16#0000#, 16#0109#, 16#0004#),
         16472 => (16#1AF5#, 16#0020#, 16#0004#),
         16473 => (16#0000#, 16#0109#, 16#0004#),
         16474 => (16#1B33#, 16#0020#, 16#000A#),
         16475 => (16#0000#, 16#0109#, 16#0004#),
         16476 => (16#1B57#, 16#0020#, 16#000A#),
         16477 => (16#0000#, 16#0109#, 16#0004#),
         16478 => (16#1B57#, 16#0020#, 16#0004#),
         16479 => (16#0000#, 16#0109#, 16#0004#),
         16480 => (16#03B6#, 16#0020#, 16#0002#),
         16481 => (16#03B7#, 16#0020#, 16#0002#),
         16482 => (16#03B8#, 16#0020#, 16#0002#),
         16483 => (16#1C41#, 16#0020#, 16#0008#),
         16484 => (16#1C41#, 16#0020#, 16#0002#),
         16485 => (16#1B8A#, 16#0020#, 16#0008#),
         16486 => (16#1A5B#, 16#0020#, 16#0002#),
         16487 => (16#1A90#, 16#0020#, 16#0008#),
         16488 => (16#1A90#, 16#0020#, 16#0002#),
         16489 => (16#1947#, 16#0020#, 16#0008#),
         16490 => (16#1947#, 16#0020#, 16#0002#),
         16491 => (16#1948#, 16#0020#, 16#0002#),
         16492 => (16#19E8#, 16#0020#, 16#0002#),
         16493 => (16#1934#, 16#0020#, 16#0008#),
         16494 => (16#1934#, 16#0020#, 16#0002#),
         16495 => (16#19AF#, 16#0020#, 16#0008#),
         16496 => (16#19AF#, 16#0020#, 16#0002#),
         16497 => (16#190C#, 16#0020#, 16#000A#),
         16498 => (16#0000#, 16#002B#, 16#0004#),
         16499 => (16#1AA1#, 16#0020#, 16#000A#),
         16500 => (16#0000#, 16#002B#, 16#0004#),
         16501 => (16#1B77#, 16#0020#, 16#000A#),
         16502 => (16#0000#, 16#002B#, 16#0004#),
         16503 => (16#19B8#, 16#0020#, 16#000A#),
         16504 => (16#0000#, 16#0035#, 16#0004#),
         16505 => (16#19B8#, 16#0020#, 16#0004#),
         16506 => (16#0000#, 16#0035#, 16#0004#),
         16507 => (16#1A29#, 16#0020#, 16#000A#),
         16508 => (16#0000#, 16#0035#, 16#0004#),
         16509 => (16#1A29#, 16#0020#, 16#0004#),
         16510 => (16#0000#, 16#0035#, 16#0004#),
         16511 => (16#1A7D#, 16#0020#, 16#000A#),
         16512 => (16#0000#, 16#0035#, 16#0004#),
         16513 => (16#1A7D#, 16#0020#, 16#0004#),
         16514 => (16#0000#, 16#0035#, 16#0004#),
         16515 => (16#1AF5#, 16#0020#, 16#000A#),
         16516 => (16#0000#, 16#0035#, 16#0004#),
         16517 => (16#1AF5#, 16#0020#, 16#0004#),
         16518 => (16#0000#, 16#0035#, 16#0004#),
         16519 => (16#1B33#, 16#0020#, 16#000A#),
         16520 => (16#0000#, 16#0035#, 16#0004#),
         16521 => (16#1B33#, 16#0020#, 16#0004#),
         16522 => (16#0000#, 16#0035#, 16#0004#),
         16523 => (16#19E9#, 16#0020#, 16#0008#),
         16524 => (16#1993#, 16#0020#, 16#0008#),
         16525 => (16#19BC#, 16#0020#, 16#0008#),
         16526 => (16#1A51#, 16#0020#, 16#0008#),
         16527 => (16#1A37#, 16#0020#, 16#0008#),
         16528 => (16#1B73#, 16#0020#, 16#0008#),
         16529 => (16#1A03#, 16#0020#, 16#0002#),
         16530 => (16#19DC#, 16#0020#, 16#0014#),
         16531 => (16#0000#, 16#0039#, 16#0014#),
         16532 => (16#1AA1#, 16#0020#, 16#0014#),
         16533 => (16#0000#, 16#0108#, 16#0014#),
         16534 => (16#196E#, 16#0020#, 16#0014#),
         16535 => (16#1B9A#, 16#0020#, 16#0002#),
         16536 => (16#19B7#, 16#0020#, 16#0002#),
         16537 => (16#1ADD#, 16#0020#, 16#0002#),
         16538 => (16#1A7A#, 16#0020#, 16#0002#),
         16539 => (16#1A02#, 16#0020#, 16#0002#),
         16540 => (16#1A7B#, 16#0020#, 16#0002#),
         16541 => (16#260B#, 16#0020#, 16#0002#),
         16542 => (16#260C#, 16#0020#, 16#0002#),
         16543 => (16#260D#, 16#0020#, 16#0002#),
         16544 => (16#260E#, 16#0020#, 16#0002#),
         16545 => (16#260F#, 16#0020#, 16#0002#),
         16546 => (16#2610#, 16#0020#, 16#0002#),
         16547 => (16#2611#, 16#0020#, 16#0002#),
         16548 => (16#2612#, 16#0020#, 16#0002#),
         16549 => (16#2613#, 16#0020#, 16#0002#),
         16550 => (16#2614#, 16#0020#, 16#0002#),
         16551 => (16#2615#, 16#0020#, 16#0002#),
         16552 => (16#2616#, 16#0020#, 16#0002#),
         16553 => (16#2617#, 16#0020#, 16#0002#),
         16554 => (16#2618#, 16#0020#, 16#0002#),
         16555 => (16#2619#, 16#0020#, 16#0002#),
         16556 => (16#261A#, 16#0020#, 16#0002#),
         16557 => (16#261B#, 16#0020#, 16#0002#),
         16558 => (16#261C#, 16#0020#, 16#0002#),
         16559 => (16#261D#, 16#0020#, 16#0002#),
         16560 => (16#261E#, 16#0020#, 16#0002#),
         16561 => (16#261F#, 16#0020#, 16#0002#),
         16562 => (16#2620#, 16#0020#, 16#0002#),
         16563 => (16#2621#, 16#0020#, 16#0002#),
         16564 => (16#2622#, 16#0020#, 16#0002#),
         16565 => (16#2623#, 16#0020#, 16#0002#),
         16566 => (16#2624#, 16#0020#, 16#0002#),
         16567 => (16#2625#, 16#0020#, 16#0002#),
         16568 => (16#2626#, 16#0020#, 16#0002#),
         16569 => (16#2627#, 16#0020#, 16#0002#),
         16570 => (16#2628#, 16#0020#, 16#0002#),
         16571 => (16#2629#, 16#0020#, 16#0002#),
         16572 => (16#262A#, 16#0020#, 16#0002#),
         16573 => (16#262B#, 16#0020#, 16#0002#),
         16574 => (16#262C#, 16#0020#, 16#0002#),
         16575 => (16#262D#, 16#0020#, 16#0002#),
         16576 => (16#262E#, 16#0020#, 16#0002#),
         16577 => (16#262F#, 16#0020#, 16#0002#),
         16578 => (16#2630#, 16#0020#, 16#0002#),
         16579 => (16#2631#, 16#0020#, 16#0002#),
         16580 => (16#03E2#, 16#0020#, 16#0002#),
         16581 => (16#03E3#, 16#0020#, 16#0002#),
         16582 => (16#03E4#, 16#0020#, 16#0002#),
         16583 => (16#03E5#, 16#0020#, 16#0002#),
         16584 => (16#1702#, 16#0020#, 16#0002#),
         16585 => (16#1703#, 16#0020#, 16#0002#),
         16586 => (16#1704#, 16#0020#, 16#0002#),
         16587 => (16#1705#, 16#0020#, 16#0002#),
         16588 => (16#1706#, 16#0020#, 16#0002#),
         16589 => (16#1707#, 16#0020#, 16#0002#),
         16590 => (16#03E6#, 16#0020#, 16#0002#),
         16591 => (16#03E7#, 16#0020#, 16#0002#),
         16592 => (16#16D3#, 16#0020#, 16#0002#),
         16593 => (16#03E8#, 16#0020#, 16#0002#),
         16594 => (16#2A9E#, 16#0020#, 16#0002#),
         16595 => (16#2A9F#, 16#0020#, 16#0002#),
         16596 => (16#2AA0#, 16#0020#, 16#0002#),
         16597 => (16#2AA1#, 16#0020#, 16#0002#),
         16598 => (16#2AA2#, 16#0020#, 16#0002#),
         16599 => (16#2AA3#, 16#0020#, 16#0002#),
         16600 => (16#2AA4#, 16#0020#, 16#0002#),
         16601 => (16#2AA5#, 16#0020#, 16#0002#),
         16602 => (16#2AAA#, 16#0020#, 16#0002#),
         16603 => (16#2AAB#, 16#0020#, 16#0002#),
         16604 => (16#2AAC#, 16#0020#, 16#0002#),
         16605 => (16#2AAD#, 16#0020#, 16#0002#),
         16606 => (16#2AAE#, 16#0020#, 16#0002#),
         16607 => (16#2AAF#, 16#0020#, 16#0002#),
         16608 => (16#2AB0#, 16#0020#, 16#0002#),
         16609 => (16#2AB1#, 16#0020#, 16#0002#),
         16610 => (16#2AB2#, 16#0020#, 16#0002#),
         16611 => (16#2AB3#, 16#0020#, 16#0002#),
         16612 => (16#2AB4#, 16#0020#, 16#0002#),
         16613 => (16#2AB5#, 16#0020#, 16#0002#),
         16614 => (16#2AB7#, 16#0020#, 16#0002#),
         16615 => (16#2AB8#, 16#0020#, 16#0002#),
         16616 => (16#2AB9#, 16#0020#, 16#0002#),
         16617 => (16#2ABA#, 16#0020#, 16#0002#),
         16618 => (16#2ABD#, 16#0020#, 16#0002#),
         16619 => (16#2AC0#, 16#0020#, 16#0002#),
         16620 => (16#2AC1#, 16#0020#, 16#0002#),
         16621 => (16#2AC3#, 16#0020#, 16#0002#),
         16622 => (16#2AC4#, 16#0020#, 16#0002#),
         16623 => (16#2AC7#, 16#0020#, 16#0002#),
         16624 => (16#2ACC#, 16#0020#, 16#0002#),
         16625 => (16#2ACD#, 16#0020#, 16#0002#),
         16626 => (16#2ACE#, 16#0020#, 16#0002#),
         16627 => (16#2ACF#, 16#0020#, 16#0002#),
         16628 => (16#2AC8#, 16#0020#, 16#0002#),
         16629 => (16#2AC9#, 16#0020#, 16#0002#),
         16630 => (16#2ACA#, 16#0020#, 16#0002#),
         16631 => (16#2ACB#, 16#0020#, 16#0002#),
         16632 => (16#2AD0#, 16#0020#, 16#0002#),
         16633 => (16#2AB6#, 16#0020#, 16#0002#),
         16634 => (16#2ABB#, 16#0020#, 16#0002#),
         16635 => (16#2AA6#, 16#0020#, 16#0002#),
         16636 => (16#2AA7#, 16#0020#, 16#0002#),
         16637 => (16#2AA8#, 16#0020#, 16#0002#),
         16638 => (16#2AA9#, 16#0020#, 16#0002#),
         16639 => (16#2ABC#, 16#0020#, 16#0002#),
         16640 => (16#2AC2#, 16#0020#, 16#0002#),
         16641 => (16#2AC5#, 16#0020#, 16#0002#),
         16642 => (16#2AC6#, 16#0020#, 16#0002#),
         16643 => (16#2ABE#, 16#0020#, 16#0002#),
         16644 => (16#2ABF#, 16#0020#, 16#0002#),
         16645 => (16#2AD1#, 16#0020#, 16#0002#),
         16646 => (16#0309#, 16#0020#, 16#0002#),
         16647 => (16#030A#, 16#0020#, 16#0002#),
         16648 => (16#0190#, 16#0020#, 16#0002#),
         16649 => (16#0191#, 16#0020#, 16#0002#),
         16650 => (16#2632#, 16#0020#, 16#0002#),
         16651 => (16#2633#, 16#0020#, 16#0002#),
         16652 => (16#2634#, 16#0020#, 16#0002#),
         16653 => (16#2635#, 16#0020#, 16#0002#),
         16654 => (16#2636#, 16#0020#, 16#0002#),
         16655 => (16#2637#, 16#0020#, 16#0002#),
         16656 => (16#2638#, 16#0020#, 16#0002#),
         16657 => (16#2639#, 16#0020#, 16#0002#),
         16658 => (16#263A#, 16#0020#, 16#0002#),
         16659 => (16#263B#, 16#0020#, 16#0002#),
         16660 => (16#263C#, 16#0020#, 16#0002#),
         16661 => (16#263D#, 16#0020#, 16#0002#),
         16662 => (16#263E#, 16#0020#, 16#0002#),
         16663 => (16#263F#, 16#0020#, 16#0002#),
         16664 => (16#2640#, 16#0020#, 16#0002#),
         16665 => (16#2641#, 16#0020#, 16#0002#),
         16666 => (16#2642#, 16#0020#, 16#0002#),
         16667 => (16#2643#, 16#0020#, 16#0002#),
         16668 => (16#2644#, 16#0020#, 16#0002#),
         16669 => (16#2645#, 16#0020#, 16#0002#),
         16670 => (16#2646#, 16#0020#, 16#0002#),
         16671 => (16#2647#, 16#0020#, 16#0002#),
         16672 => (16#2648#, 16#0020#, 16#0002#),
         16673 => (16#2649#, 16#0020#, 16#0002#),
         16674 => (16#264A#, 16#0020#, 16#0002#),
         16675 => (16#264B#, 16#0020#, 16#0002#),
         16676 => (16#264C#, 16#0020#, 16#0002#),
         16677 => (16#264D#, 16#0020#, 16#0002#),
         16678 => (16#264E#, 16#0020#, 16#0002#),
         16679 => (16#264F#, 16#0020#, 16#0002#),
         16680 => (16#2650#, 16#0020#, 16#0002#),
         16681 => (16#2651#, 16#0020#, 16#0002#),
         16682 => (16#2652#, 16#0020#, 16#0002#),
         16683 => (16#2653#, 16#0020#, 16#0002#),
         16684 => (16#2654#, 16#0020#, 16#0002#),
         16685 => (16#2655#, 16#0020#, 16#0002#),
         16686 => (16#2656#, 16#0020#, 16#0002#),
         16687 => (16#2657#, 16#0020#, 16#0002#),
         16688 => (16#2658#, 16#0020#, 16#0002#),
         16689 => (16#2659#, 16#0020#, 16#0002#),
         16690 => (16#265A#, 16#0020#, 16#0002#),
         16691 => (16#265B#, 16#0020#, 16#0002#),
         16692 => (16#265C#, 16#0020#, 16#0002#),
         16693 => (16#265D#, 16#0020#, 16#0002#),
         16694 => (16#265E#, 16#0020#, 16#0002#),
         16695 => (16#265F#, 16#0020#, 16#0002#),
         16696 => (16#2660#, 16#0020#, 16#0002#),
         16697 => (16#2661#, 16#0020#, 16#0002#),
         16698 => (16#2662#, 16#0020#, 16#0002#),
         16699 => (16#2663#, 16#0020#, 16#0002#),
         16700 => (16#2664#, 16#0020#, 16#0002#),
         16701 => (16#2665#, 16#0020#, 16#0002#),
         16702 => (16#2666#, 16#0020#, 16#0002#),
         16703 => (16#2667#, 16#0020#, 16#0002#),
         16704 => (16#2668#, 16#0020#, 16#0002#),
         16705 => (16#2669#, 16#0020#, 16#0002#),
         16706 => (16#266A#, 16#0020#, 16#0002#),
         16707 => (16#266B#, 16#0020#, 16#0002#),
         16708 => (16#266C#, 16#0020#, 16#0002#),
         16709 => (16#266D#, 16#0020#, 16#0002#),
         16710 => (16#266E#, 16#0020#, 16#0002#),
         16711 => (16#266F#, 16#0020#, 16#0002#),
         16712 => (16#2670#, 16#0020#, 16#0002#),
         16713 => (16#2671#, 16#0020#, 16#0002#),
         16714 => (16#2672#, 16#0020#, 16#0002#),
         16715 => (16#2673#, 16#0020#, 16#0002#),
         16716 => (16#2674#, 16#0020#, 16#0002#),
         16717 => (16#018C#, 16#0020#, 16#0002#),
         16718 => (16#018D#, 16#0020#, 16#0002#),
         16719 => (16#2357#, 16#0020#, 16#0002#),
         16720 => (16#2357#, 16#0020#, 16#0004#),
         16721 => (16#02CC#, 16#0020#, 16#0002#),
         16722 => (16#02CD#, 16#0020#, 16#0002#),
         16723 => (16#02CE#, 16#0020#, 16#0002#),
         16724 => (16#2358#, 16#0020#, 16#0002#),
         16725 => (16#2BB2#, 16#0020#, 16#0002#),
         16726 => (16#2BB3#, 16#0020#, 16#0002#),
         16727 => (16#2BB4#, 16#0020#, 16#0002#),
         16728 => (16#2BB5#, 16#0020#, 16#0002#),
         16729 => (16#2BB6#, 16#0020#, 16#0002#),
         16730 => (16#2BB7#, 16#0020#, 16#0002#),
         16731 => (16#2BB8#, 16#0020#, 16#0002#),
         16732 => (16#2BB9#, 16#0020#, 16#0002#),
         16733 => (16#2BBA#, 16#0020#, 16#0002#),
         16734 => (16#2BBB#, 16#0020#, 16#0002#),
         16735 => (16#2BBC#, 16#0020#, 16#0002#),
         16736 => (16#2BBD#, 16#0020#, 16#0002#),
         16737 => (16#2BBE#, 16#0020#, 16#0002#),
         16738 => (16#2BBF#, 16#0020#, 16#0002#),
         16739 => (16#2BC0#, 16#0020#, 16#0002#),
         16740 => (16#2BC1#, 16#0020#, 16#0002#),
         16741 => (16#2BC2#, 16#0020#, 16#0002#),
         16742 => (16#2BC3#, 16#0020#, 16#0002#),
         16743 => (16#2BC4#, 16#0020#, 16#0002#),
         16744 => (16#2BC5#, 16#0020#, 16#0002#),
         16745 => (16#2BC6#, 16#0020#, 16#0002#),
         16746 => (16#2BC7#, 16#0020#, 16#0002#),
         16747 => (16#2BC8#, 16#0020#, 16#0002#),
         16748 => (16#2BC9#, 16#0020#, 16#0002#),
         16749 => (16#2BCA#, 16#0020#, 16#0002#),
         16750 => (16#2BCB#, 16#0020#, 16#0002#),
         16751 => (16#2BCC#, 16#0020#, 16#0002#),
         16752 => (16#2BCD#, 16#0020#, 16#0002#),
         16753 => (16#2BCE#, 16#0020#, 16#0002#),
         16754 => (16#2BCF#, 16#0020#, 16#0002#),
         16755 => (16#2BD0#, 16#0020#, 16#0002#),
         16756 => (16#2BD1#, 16#0020#, 16#0002#),
         16757 => (16#2BD2#, 16#0020#, 16#0002#),
         16758 => (16#0000#, 16#00DA#, 16#0002#),
         16759 => (16#0000#, 16#00DB#, 16#0002#),
         16760 => (16#0000#, 16#00DC#, 16#0002#),
         16761 => (16#030F#, 16#0020#, 16#0002#),
         16762 => (16#0194#, 16#0020#, 16#0002#),
         16763 => (16#2B8E#, 16#0020#, 16#0002#),
         16764 => (16#2B8F#, 16#0020#, 16#0002#),
         16765 => (16#2B90#, 16#0020#, 16#0002#),
         16766 => (16#2B91#, 16#0020#, 16#0002#),
         16767 => (16#2B92#, 16#0020#, 16#0002#),
         16768 => (16#2B93#, 16#0020#, 16#0002#),
         16769 => (16#2B94#, 16#0020#, 16#0002#),
         16770 => (16#2B95#, 16#0020#, 16#0002#),
         16771 => (16#2B96#, 16#0020#, 16#0002#),
         16772 => (16#2B97#, 16#0020#, 16#0002#),
         16773 => (16#2B98#, 16#0020#, 16#0002#),
         16774 => (16#2B99#, 16#0020#, 16#0002#),
         16775 => (16#2B9A#, 16#0020#, 16#0002#),
         16776 => (16#2B9B#, 16#0020#, 16#0002#),
         16777 => (16#2B9C#, 16#0020#, 16#0002#),
         16778 => (16#2B9D#, 16#0020#, 16#0002#),
         16779 => (16#2B9E#, 16#0020#, 16#0002#),
         16780 => (16#2B9F#, 16#0020#, 16#0002#),
         16781 => (16#2BA0#, 16#0020#, 16#0002#),
         16782 => (16#2BA1#, 16#0020#, 16#0002#),
         16783 => (16#2BA2#, 16#0020#, 16#0002#),
         16784 => (16#2BA3#, 16#0020#, 16#0002#),
         16785 => (16#2BA4#, 16#0020#, 16#0002#),
         16786 => (16#2BA5#, 16#0020#, 16#0002#),
         16787 => (16#2BA6#, 16#0020#, 16#0002#),
         16788 => (16#2BA7#, 16#0020#, 16#0002#),
         16789 => (16#2BA8#, 16#0020#, 16#0002#),
         16790 => (16#2BA9#, 16#0020#, 16#0002#),
         16791 => (16#2BAA#, 16#0020#, 16#0002#),
         16792 => (16#2BAB#, 16#0020#, 16#0002#),
         16793 => (16#2BAC#, 16#0020#, 16#0002#),
         16794 => (16#2BAD#, 16#0020#, 16#0002#),
         16795 => (16#2BAE#, 16#0020#, 16#0002#),
         16796 => (16#2BAF#, 16#0020#, 16#0002#),
         16797 => (16#2BB0#, 16#0020#, 16#0002#),
         16798 => (16#2BB1#, 16#0020#, 16#0002#),
         16799 => (16#01CE#, 16#0020#, 16#0002#),
         16800 => (16#3782#, 16#0020#, 16#0002#),
         16801 => (16#3783#, 16#0020#, 16#0002#),
         16802 => (16#3784#, 16#0020#, 16#0002#),
         16803 => (16#3785#, 16#0020#, 16#0002#),
         16804 => (16#3786#, 16#0020#, 16#0002#),
         16805 => (16#3787#, 16#0020#, 16#0002#),
         16806 => (16#3788#, 16#0020#, 16#0002#),
         16807 => (16#3789#, 16#0020#, 16#0002#),
         16808 => (16#378A#, 16#0020#, 16#0002#),
         16809 => (16#378B#, 16#0020#, 16#0002#),
         16810 => (16#378C#, 16#0020#, 16#0002#),
         16811 => (16#378D#, 16#0020#, 16#0002#),
         16812 => (16#378E#, 16#0020#, 16#0002#),
         16813 => (16#378F#, 16#0020#, 16#0002#),
         16814 => (16#3790#, 16#0020#, 16#0002#),
         16815 => (16#3791#, 16#0020#, 16#0002#),
         16816 => (16#3792#, 16#0020#, 16#0002#),
         16817 => (16#3793#, 16#0020#, 16#0002#),
         16818 => (16#3794#, 16#0020#, 16#0002#),
         16819 => (16#3795#, 16#0020#, 16#0002#),
         16820 => (16#3796#, 16#0020#, 16#0002#),
         16821 => (16#3797#, 16#0020#, 16#0002#),
         16822 => (16#3798#, 16#0020#, 16#0002#),
         16823 => (16#3799#, 16#0020#, 16#0002#),
         16824 => (16#379A#, 16#0020#, 16#0002#),
         16825 => (16#379B#, 16#0020#, 16#0002#),
         16826 => (16#379C#, 16#0020#, 16#0002#),
         16827 => (16#379D#, 16#0020#, 16#0002#),
         16828 => (16#379E#, 16#0020#, 16#0002#),
         16829 => (16#0000#, 16#00C3#, 16#0002#),
         16830 => (16#2E3B#, 16#0020#, 16#0002#),
         16831 => (16#2E3C#, 16#0020#, 16#0002#),
         16832 => (16#2E3D#, 16#0020#, 16#0002#),
         16833 => (16#2E3E#, 16#0020#, 16#0002#),
         16834 => (16#2E3F#, 16#0020#, 16#0002#),
         16835 => (16#2E40#, 16#0020#, 16#0002#),
         16836 => (16#2E41#, 16#0020#, 16#0002#),
         16837 => (16#2E42#, 16#0020#, 16#0002#),
         16838 => (16#2E43#, 16#0020#, 16#0002#),
         16839 => (16#2E44#, 16#0020#, 16#0002#),
         16840 => (16#2E45#, 16#0020#, 16#0002#),
         16841 => (16#2E46#, 16#0020#, 16#0002#),
         16842 => (16#2E47#, 16#0020#, 16#0002#),
         16843 => (16#2E48#, 16#0020#, 16#0002#),
         16844 => (16#2E49#, 16#0020#, 16#0002#),
         16845 => (16#2E4A#, 16#0020#, 16#0002#),
         16846 => (16#2E4B#, 16#0020#, 16#0002#),
         16847 => (16#2E4C#, 16#0020#, 16#0002#),
         16848 => (16#2E4D#, 16#0020#, 16#0002#),
         16849 => (16#2E4E#, 16#0020#, 16#0002#),
         16850 => (16#2E4F#, 16#0020#, 16#0002#),
         16851 => (16#2E50#, 16#0020#, 16#0002#),
         16852 => (16#2E51#, 16#0020#, 16#0002#),
         16853 => (16#2E52#, 16#0020#, 16#0002#),
         16854 => (16#2E53#, 16#0020#, 16#0002#),
         16855 => (16#2E54#, 16#0020#, 16#0002#),
         16856 => (16#2E55#, 16#0020#, 16#0002#),
         16857 => (16#2E56#, 16#0020#, 16#0002#),
         16858 => (16#2E57#, 16#0020#, 16#0002#),
         16859 => (16#2E58#, 16#0020#, 16#0002#),
         16860 => (16#2E59#, 16#0020#, 16#0002#),
         16861 => (16#2E5A#, 16#0020#, 16#0002#),
         16862 => (16#2E5B#, 16#0020#, 16#0002#),
         16863 => (16#2E5C#, 16#0020#, 16#0002#),
         16864 => (16#2E5D#, 16#0020#, 16#0002#),
         16865 => (16#2E5E#, 16#0020#, 16#0002#),
         16866 => (16#2E5F#, 16#0020#, 16#0002#),
         16867 => (16#2E60#, 16#0020#, 16#0002#),
         16868 => (16#2E61#, 16#0020#, 16#0002#),
         16869 => (16#2E63#, 16#0020#, 16#0002#),
         16870 => (16#2E63#, 16#0020#, 16#0004#),
         16871 => (16#2E65#, 16#0020#, 16#0002#),
         16872 => (16#2E66#, 16#0020#, 16#0002#),
         16873 => (16#2E67#, 16#0020#, 16#0002#),
         16874 => (16#2E68#, 16#0020#, 16#0002#),
         16875 => (16#2E69#, 16#0020#, 16#0002#),
         16876 => (16#2E6A#, 16#0020#, 16#0002#),
         16877 => (16#2E6B#, 16#0020#, 16#0002#),
         16878 => (16#2E74#, 16#0020#, 16#0002#),
         16879 => (16#2E6D#, 16#0020#, 16#0002#),
         16880 => (16#2E6E#, 16#0020#, 16#0002#),
         16881 => (16#2E6F#, 16#0020#, 16#0002#),
         16882 => (16#2E70#, 16#0020#, 16#0002#),
         16883 => (16#2E72#, 16#0020#, 16#0002#),
         16884 => (16#2E73#, 16#0020#, 16#0002#),
         16885 => (16#2E6C#, 16#0020#, 16#0002#),
         16886 => (16#2E71#, 16#0020#, 16#0002#),
         16887 => (16#2E62#, 16#0020#, 16#0002#),
         16888 => (16#2E64#, 16#0020#, 16#0002#),
         16889 => (16#2E75#, 16#0020#, 16#0002#),
         16890 => (16#01C3#, 16#0020#, 16#0002#),
         16891 => (16#01C4#, 16#0020#, 16#0002#),
         16892 => (16#01C5#, 16#0020#, 16#0002#),
         16893 => (16#01C6#, 16#0020#, 16#0002#),
         16894 => (16#01C7#, 16#0020#, 16#0002#),
         16895 => (16#01C8#, 16#0020#, 16#0002#),
         16896 => (16#0159#, 16#0020#, 16#0002#),
         16897 => (16#019F#, 16#0020#, 16#0002#),
         16898 => (16#01A0#, 16#0020#, 16#0002#),
         16899 => (16#01C9#, 16#0020#, 16#0002#),
         16900 => (16#01CA#, 16#0020#, 16#0002#),
         16901 => (16#01CB#, 16#0020#, 16#0002#),
         16902 => (16#01CC#, 16#0020#, 16#0002#),
         16903 => (16#16B8#, 16#0020#, 16#0002#),
         16904 => (16#0310#, 16#0020#, 16#0002#),
         16905 => (16#0311#, 16#0020#, 16#0002#),
         16906 => (16#2BDC#, 16#0020#, 16#0002#),
         16907 => (16#2BE4#, 16#0020#, 16#0002#),
         16908 => (16#2BEE#, 16#0020#, 16#0002#),
         16909 => (16#2C04#, 16#0020#, 16#0002#),
         16910 => (16#2C1D#, 16#0020#, 16#0002#),
         16911 => (16#2C67#, 16#0020#, 16#0002#),
         16912 => (16#16B9#, 16#0020#, 16#0002#),
         16913 => (16#2BF6#, 16#0020#, 16#0002#),
         16914 => (16#2C18#, 16#0020#, 16#0002#),
         16915 => (16#2BDA#, 16#0020#, 16#0002#),
         16916 => (16#2BDD#, 16#0020#, 16#0002#),
         16917 => (16#2BE9#, 16#0020#, 16#0002#),
         16918 => (16#2BF0#, 16#0020#, 16#0002#),
         16919 => (16#2BFE#, 16#0020#, 16#0002#),
         16920 => (16#2C01#, 16#0020#, 16#0002#),
         16921 => (16#2C05#, 16#0020#, 16#0002#),
         16922 => (16#2C39#, 16#0020#, 16#0002#),
         16923 => (16#2C0A#, 16#0020#, 16#0002#),
         16924 => (16#2C0D#, 16#0020#, 16#0002#),
         16925 => (16#2C1B#, 16#0020#, 16#0002#),
         16926 => (16#2C1E#, 16#0020#, 16#0002#),
         16927 => (16#2DB0#, 16#0020#, 16#0002#),
         16928 => (16#2DB1#, 16#0020#, 16#0002#),
         16929 => (16#2DB2#, 16#0020#, 16#0002#),
         16930 => (16#2DB3#, 16#0020#, 16#0002#),
         16931 => (16#2DB4#, 16#0020#, 16#0002#),
         16932 => (16#2DB5#, 16#0020#, 16#0002#),
         16933 => (16#2DB6#, 16#0020#, 16#0002#),
         16934 => (16#2DB7#, 16#0020#, 16#0002#),
         16935 => (16#2DB8#, 16#0020#, 16#0002#),
         16936 => (16#2DB9#, 16#0020#, 16#0002#),
         16937 => (16#2DBA#, 16#0020#, 16#0002#),
         16938 => (16#2DBB#, 16#0020#, 16#0002#),
         16939 => (16#2DBC#, 16#0020#, 16#0002#),
         16940 => (16#2DBD#, 16#0020#, 16#0002#),
         16941 => (16#2DBE#, 16#0020#, 16#0002#),
         16942 => (16#2DBF#, 16#0020#, 16#0002#),
         16943 => (16#2DC0#, 16#0020#, 16#0002#),
         16944 => (16#2DC1#, 16#0020#, 16#0002#),
         16945 => (16#2DC2#, 16#0020#, 16#0002#),
         16946 => (16#2DC3#, 16#0020#, 16#0002#),
         16947 => (16#2DC4#, 16#0020#, 16#0002#),
         16948 => (16#2DC5#, 16#0020#, 16#0002#),
         16949 => (16#2DC6#, 16#0020#, 16#0002#),
         16950 => (16#2DC7#, 16#0020#, 16#0002#),
         16951 => (16#2DC8#, 16#0020#, 16#0002#),
         16952 => (16#2DC9#, 16#0020#, 16#0002#),
         16953 => (16#2DCA#, 16#0020#, 16#0002#),
         16954 => (16#2DCB#, 16#0020#, 16#0002#),
         16955 => (16#2DCC#, 16#0020#, 16#0002#),
         16956 => (16#2DCD#, 16#0020#, 16#0002#),
         16957 => (16#2DCE#, 16#0020#, 16#0002#),
         16958 => (16#2DCF#, 16#0020#, 16#0002#),
         16959 => (16#2DD0#, 16#0020#, 16#0002#),
         16960 => (16#2DD1#, 16#0020#, 16#0002#),
         16961 => (16#2DD2#, 16#0020#, 16#0002#),
         16962 => (16#2DD3#, 16#0020#, 16#0002#),
         16963 => (16#2DD4#, 16#0020#, 16#0002#),
         16964 => (16#2DD5#, 16#0020#, 16#0002#),
         16965 => (16#2DD6#, 16#0020#, 16#0002#),
         16966 => (16#2DD7#, 16#0020#, 16#0002#),
         16967 => (16#2DD8#, 16#0020#, 16#0002#),
         16968 => (16#2DDD#, 16#0020#, 16#0002#),
         16969 => (16#2DDE#, 16#0020#, 16#0002#),
         16970 => (16#2DDF#, 16#0020#, 16#0002#),
         16971 => (16#2DE0#, 16#0020#, 16#0002#),
         16972 => (16#2DE1#, 16#0020#, 16#0002#),
         16973 => (16#2DE2#, 16#0020#, 16#0002#),
         16974 => (16#2DE3#, 16#0020#, 16#0002#),
         16975 => (16#2DE4#, 16#0020#, 16#0002#),
         16976 => (16#2DE5#, 16#0020#, 16#0002#),
         16977 => (16#2DE6#, 16#0020#, 16#0002#),
         16978 => (16#2DD9#, 16#0020#, 16#0002#),
         16979 => (16#2DDA#, 16#0020#, 16#0002#),
         16980 => (16#2DDB#, 16#0020#, 16#0002#),
         16981 => (16#2DDC#, 16#0020#, 16#0002#),
         16982 => (16#2DE7#, 16#0020#, 16#0002#),
         16983 => (16#2DE8#, 16#0020#, 16#0002#),
         16984 => (16#2DE9#, 16#0020#, 16#0002#),
         16985 => (16#2DEA#, 16#0020#, 16#0002#),
         16986 => (16#2DEB#, 16#0020#, 16#0002#),
         16987 => (16#2DEC#, 16#0020#, 16#0002#),
         16988 => (16#2DED#, 16#0020#, 16#0002#),
         16989 => (16#2DEE#, 16#0020#, 16#0002#),
         16990 => (16#2DEF#, 16#0020#, 16#0002#),
         16991 => (16#2DF0#, 16#0020#, 16#0002#),
         16992 => (16#2DF1#, 16#0020#, 16#0002#),
         16993 => (16#2DF2#, 16#0020#, 16#0002#),
         16994 => (16#2DF3#, 16#0020#, 16#0002#),
         16995 => (16#2DF4#, 16#0020#, 16#0002#),
         16996 => (16#0312#, 16#0020#, 16#0002#),
         16997 => (16#01A1#, 16#0020#, 16#0002#),
         16998 => (16#01A2#, 16#0020#, 16#0002#),
         16999 => (16#01A3#, 16#0020#, 16#0002#),
         17000 => (16#2BD9#, 16#0020#, 16#0002#),
         17001 => (16#2BE2#, 16#0020#, 16#0002#),
         17002 => (16#2BE5#, 16#0020#, 16#0002#),
         17003 => (16#2BE8#, 16#0020#, 16#0002#),
         17004 => (16#2BEF#, 16#0020#, 16#0002#),
         17005 => (16#2BF5#, 16#0020#, 16#0002#),
         17006 => (16#2BF9#, 16#0020#, 16#0002#),
         17007 => (16#2BFB#, 16#0020#, 16#0002#),
         17008 => (16#2BFD#, 16#0020#, 16#0002#),
         17009 => (16#2C00#, 16#0020#, 16#0002#),
         17010 => (16#2C0C#, 16#0020#, 16#0002#),
         17011 => (16#2C10#, 16#0020#, 16#0002#),
         17012 => (16#2C31#, 16#0020#, 16#0002#),
         17013 => (16#2C34#, 16#0020#, 16#0002#),
         17014 => (16#2C36#, 16#0020#, 16#0002#),
         17015 => (16#2C16#, 16#0020#, 16#0002#),
         17016 => (16#16BA#, 16#0020#, 16#0002#),
         17017 => (16#2C37#, 16#0020#, 16#0002#),
         17018 => (16#2BEB#, 16#0020#, 16#0002#),
         17019 => (16#2C24#, 16#0020#, 16#0002#),
         17020 => (16#2C7F#, 16#0020#, 16#0002#),
         17021 => (16#2C80#, 16#0020#, 16#0002#),
         17022 => (16#2C81#, 16#0020#, 16#0002#),
         17023 => (16#0410#, 16#0020#, 16#0002#),
         17024 => (16#0411#, 16#0020#, 16#0002#),
         17025 => (16#0412#, 16#0020#, 16#0002#),
         17026 => (16#2C25#, 16#0020#, 16#0002#),
         17027 => (16#2C7C#, 16#0020#, 16#0002#),
         17028 => (16#2C7D#, 16#0020#, 16#0002#),
         17029 => (16#2C7E#, 16#0020#, 16#0002#),
         17030 => (16#2BE6#, 16#0020#, 16#0002#),
         17031 => (16#2BF2#, 16#0020#, 16#0002#),
         17032 => (16#29C1#, 16#0020#, 16#0002#),
         17033 => (16#29C2#, 16#0020#, 16#0002#),
         17034 => (16#29C3#, 16#0020#, 16#0002#),
         17035 => (16#29C4#, 16#0020#, 16#0002#),
         17036 => (16#29C5#, 16#0020#, 16#0002#),
         17037 => (16#29C6#, 16#0020#, 16#0002#),
         17038 => (16#29C7#, 16#0020#, 16#0002#),
         17039 => (16#29C8#, 16#0020#, 16#0002#),
         17040 => (16#29C9#, 16#0020#, 16#0002#),
         17041 => (16#29CA#, 16#0020#, 16#0002#),
         17042 => (16#29CB#, 16#0020#, 16#0002#),
         17043 => (16#29CC#, 16#0020#, 16#0002#),
         17044 => (16#29CD#, 16#0020#, 16#0002#),
         17045 => (16#29CE#, 16#0020#, 16#0002#),
         17046 => (16#29CF#, 16#0020#, 16#0002#),
         17047 => (16#29D0#, 16#0020#, 16#0002#),
         17048 => (16#29D1#, 16#0020#, 16#0002#),
         17049 => (16#29D2#, 16#0020#, 16#0002#),
         17050 => (16#29D3#, 16#0020#, 16#0002#),
         17051 => (16#29D4#, 16#0020#, 16#0002#),
         17052 => (16#29D5#, 16#0020#, 16#0002#),
         17053 => (16#29D6#, 16#0020#, 16#0002#),
         17054 => (16#29D7#, 16#0020#, 16#0002#),
         17055 => (16#29D8#, 16#0020#, 16#0002#),
         17056 => (16#29D9#, 16#0020#, 16#0002#),
         17057 => (16#29DA#, 16#0020#, 16#0002#),
         17058 => (16#29DB#, 16#0020#, 16#0002#),
         17059 => (16#29DC#, 16#0020#, 16#0002#),
         17060 => (16#29DD#, 16#0020#, 16#0002#),
         17061 => (16#29DE#, 16#0020#, 16#0002#),
         17062 => (16#29DF#, 16#0020#, 16#0002#),
         17063 => (16#29E0#, 16#0020#, 16#0002#),
         17064 => (16#29E1#, 16#0020#, 16#0002#),
         17065 => (16#29E2#, 16#0020#, 16#0002#),
         17066 => (16#29E3#, 16#0020#, 16#0002#),
         17067 => (16#29E4#, 16#0020#, 16#0002#),
         17068 => (16#29E5#, 16#0020#, 16#0002#),
         17069 => (16#29E6#, 16#0020#, 16#0002#),
         17070 => (16#29E7#, 16#0020#, 16#0002#),
         17071 => (16#29E8#, 16#0020#, 16#0002#),
         17072 => (16#29E9#, 16#0020#, 16#0002#),
         17073 => (16#29EA#, 16#0020#, 16#0002#),
         17074 => (16#29EB#, 16#0020#, 16#0002#),
         17075 => (16#29EC#, 16#0020#, 16#0002#),
         17076 => (16#29ED#, 16#0020#, 16#0002#),
         17077 => (16#29EE#, 16#0020#, 16#0002#),
         17078 => (16#29EF#, 16#0020#, 16#0002#),
         17079 => (16#29F0#, 16#0020#, 16#0002#),
         17080 => (16#29F1#, 16#0020#, 16#0002#),
         17081 => (16#29F2#, 16#0020#, 16#0002#),
         17082 => (16#29F3#, 16#0020#, 16#0002#),
         17083 => (16#29F4#, 16#0020#, 16#0002#),
         17084 => (16#29F5#, 16#0020#, 16#0002#),
         17085 => (16#29F6#, 16#0020#, 16#0002#),
         17086 => (16#29C1#, 16#0020#, 16#0002#),
         17087 => (16#29F6#, 16#0020#, 16#0002#),
         17088 => (16#29C2#, 16#0020#, 16#0002#),
         17089 => (16#29F6#, 16#0020#, 16#0002#),
         17090 => (16#29C3#, 16#0020#, 16#0002#),
         17091 => (16#29F6#, 16#0020#, 16#0002#),
         17092 => (16#29C4#, 16#0020#, 16#0002#),
         17093 => (16#29F6#, 16#0020#, 16#0002#),
         17094 => (16#29C5#, 16#0020#, 16#0002#),
         17095 => (16#29F6#, 16#0020#, 16#0002#),
         17096 => (16#29C6#, 16#0020#, 16#0002#),
         17097 => (16#29F6#, 16#0020#, 16#0002#),
         17098 => (16#29C7#, 16#0020#, 16#0002#),
         17099 => (16#29F6#, 16#0020#, 16#0002#),
         17100 => (16#29C8#, 16#0020#, 16#0002#),
         17101 => (16#29F6#, 16#0020#, 16#0002#),
         17102 => (16#29C9#, 16#0020#, 16#0002#),
         17103 => (16#29F6#, 16#0020#, 16#0002#),
         17104 => (16#29CA#, 16#0020#, 16#0002#),
         17105 => (16#29F6#, 16#0020#, 16#0002#),
         17106 => (16#29CB#, 16#0020#, 16#0002#),
         17107 => (16#29F6#, 16#0020#, 16#0002#),
         17108 => (16#29CC#, 16#0020#, 16#0002#),
         17109 => (16#29F6#, 16#0020#, 16#0002#),
         17110 => (16#29CD#, 16#0020#, 16#0002#),
         17111 => (16#29F6#, 16#0020#, 16#0002#),
         17112 => (16#29CE#, 16#0020#, 16#0002#),
         17113 => (16#29F6#, 16#0020#, 16#0002#),
         17114 => (16#29CF#, 16#0020#, 16#0002#),
         17115 => (16#29F6#, 16#0020#, 16#0002#),
         17116 => (16#29D0#, 16#0020#, 16#0002#),
         17117 => (16#29F6#, 16#0020#, 16#0002#),
         17118 => (16#29D1#, 16#0020#, 16#0002#),
         17119 => (16#29F6#, 16#0020#, 16#0002#),
         17120 => (16#29D2#, 16#0020#, 16#0002#),
         17121 => (16#29F6#, 16#0020#, 16#0002#),
         17122 => (16#29D3#, 16#0020#, 16#0002#),
         17123 => (16#29F6#, 16#0020#, 16#0002#),
         17124 => (16#29D4#, 16#0020#, 16#0002#),
         17125 => (16#29F6#, 16#0020#, 16#0002#),
         17126 => (16#29D5#, 16#0020#, 16#0002#),
         17127 => (16#29F6#, 16#0020#, 16#0002#),
         17128 => (16#29D6#, 16#0020#, 16#0002#),
         17129 => (16#29F6#, 16#0020#, 16#0002#),
         17130 => (16#29D7#, 16#0020#, 16#0002#),
         17131 => (16#29F6#, 16#0020#, 16#0002#),
         17132 => (16#29D8#, 16#0020#, 16#0002#),
         17133 => (16#29F6#, 16#0020#, 16#0002#),
         17134 => (16#29D9#, 16#0020#, 16#0002#),
         17135 => (16#29F6#, 16#0020#, 16#0002#),
         17136 => (16#29DA#, 16#0020#, 16#0002#),
         17137 => (16#29F6#, 16#0020#, 16#0002#),
         17138 => (16#29DB#, 16#0020#, 16#0002#),
         17139 => (16#29F6#, 16#0020#, 16#0002#),
         17140 => (16#29DC#, 16#0020#, 16#0002#),
         17141 => (16#29F6#, 16#0020#, 16#0002#),
         17142 => (16#29DD#, 16#0020#, 16#0002#),
         17143 => (16#29F6#, 16#0020#, 16#0002#),
         17144 => (16#29DE#, 16#0020#, 16#0002#),
         17145 => (16#29F6#, 16#0020#, 16#0002#),
         17146 => (16#29DF#, 16#0020#, 16#0002#),
         17147 => (16#29F6#, 16#0020#, 16#0002#),
         17148 => (16#29E0#, 16#0020#, 16#0002#),
         17149 => (16#29F6#, 16#0020#, 16#0002#),
         17150 => (16#29E1#, 16#0020#, 16#0002#),
         17151 => (16#29F6#, 16#0020#, 16#0002#),
         17152 => (16#29E2#, 16#0020#, 16#0002#),
         17153 => (16#29F6#, 16#0020#, 16#0002#),
         17154 => (16#29E3#, 16#0020#, 16#0002#),
         17155 => (16#29F6#, 16#0020#, 16#0002#),
         17156 => (16#29E4#, 16#0020#, 16#0002#),
         17157 => (16#29F6#, 16#0020#, 16#0002#),
         17158 => (16#29E5#, 16#0020#, 16#0002#),
         17159 => (16#29F6#, 16#0020#, 16#0002#),
         17160 => (16#29E6#, 16#0020#, 16#0002#),
         17161 => (16#29F6#, 16#0020#, 16#0002#),
         17162 => (16#29E7#, 16#0020#, 16#0002#),
         17163 => (16#29F6#, 16#0020#, 16#0002#),
         17164 => (16#29E8#, 16#0020#, 16#0002#),
         17165 => (16#29F6#, 16#0020#, 16#0002#),
         17166 => (16#29E9#, 16#0020#, 16#0002#),
         17167 => (16#29F6#, 16#0020#, 16#0002#),
         17168 => (16#29EA#, 16#0020#, 16#0002#),
         17169 => (16#29F6#, 16#0020#, 16#0002#),
         17170 => (16#29EB#, 16#0020#, 16#0002#),
         17171 => (16#29F6#, 16#0020#, 16#0002#),
         17172 => (16#29EC#, 16#0020#, 16#0002#),
         17173 => (16#29F6#, 16#0020#, 16#0002#),
         17174 => (16#29ED#, 16#0020#, 16#0002#),
         17175 => (16#29F6#, 16#0020#, 16#0002#),
         17176 => (16#29EE#, 16#0020#, 16#0002#),
         17177 => (16#29F6#, 16#0020#, 16#0002#),
         17178 => (16#29EF#, 16#0020#, 16#0002#),
         17179 => (16#29F6#, 16#0020#, 16#0002#),
         17180 => (16#29F0#, 16#0020#, 16#0002#),
         17181 => (16#29F6#, 16#0020#, 16#0002#),
         17182 => (16#29F7#, 16#0020#, 16#0002#),
         17183 => (16#29C1#, 16#0020#, 16#0002#),
         17184 => (16#29F7#, 16#0020#, 16#0002#),
         17185 => (16#29C2#, 16#0020#, 16#0002#),
         17186 => (16#29F7#, 16#0020#, 16#0002#),
         17187 => (16#29C3#, 16#0020#, 16#0002#),
         17188 => (16#29F7#, 16#0020#, 16#0002#),
         17189 => (16#29C4#, 16#0020#, 16#0002#),
         17190 => (16#29F7#, 16#0020#, 16#0002#),
         17191 => (16#29C5#, 16#0020#, 16#0002#),
         17192 => (16#29F7#, 16#0020#, 16#0002#),
         17193 => (16#29C6#, 16#0020#, 16#0002#),
         17194 => (16#29F7#, 16#0020#, 16#0002#),
         17195 => (16#29C7#, 16#0020#, 16#0002#),
         17196 => (16#29F7#, 16#0020#, 16#0002#),
         17197 => (16#29C8#, 16#0020#, 16#0002#),
         17198 => (16#29F7#, 16#0020#, 16#0002#),
         17199 => (16#29C9#, 16#0020#, 16#0002#),
         17200 => (16#29F7#, 16#0020#, 16#0002#),
         17201 => (16#29CA#, 16#0020#, 16#0002#),
         17202 => (16#29F7#, 16#0020#, 16#0002#),
         17203 => (16#29CB#, 16#0020#, 16#0002#),
         17204 => (16#29F7#, 16#0020#, 16#0002#),
         17205 => (16#29CC#, 16#0020#, 16#0002#),
         17206 => (16#29F7#, 16#0020#, 16#0002#),
         17207 => (16#29CD#, 16#0020#, 16#0002#),
         17208 => (16#29F7#, 16#0020#, 16#0002#),
         17209 => (16#29CE#, 16#0020#, 16#0002#),
         17210 => (16#29F7#, 16#0020#, 16#0002#),
         17211 => (16#29CF#, 16#0020#, 16#0002#),
         17212 => (16#29F7#, 16#0020#, 16#0002#),
         17213 => (16#29D0#, 16#0020#, 16#0002#),
         17214 => (16#29F7#, 16#0020#, 16#0002#),
         17215 => (16#29D1#, 16#0020#, 16#0002#),
         17216 => (16#29F7#, 16#0020#, 16#0002#),
         17217 => (16#29D2#, 16#0020#, 16#0002#),
         17218 => (16#29F7#, 16#0020#, 16#0002#),
         17219 => (16#29D3#, 16#0020#, 16#0002#),
         17220 => (16#29F7#, 16#0020#, 16#0002#),
         17221 => (16#29D4#, 16#0020#, 16#0002#),
         17222 => (16#29F7#, 16#0020#, 16#0002#),
         17223 => (16#29D5#, 16#0020#, 16#0002#),
         17224 => (16#29F7#, 16#0020#, 16#0002#),
         17225 => (16#29D6#, 16#0020#, 16#0002#),
         17226 => (16#29F7#, 16#0020#, 16#0002#),
         17227 => (16#29D7#, 16#0020#, 16#0002#),
         17228 => (16#29F7#, 16#0020#, 16#0002#),
         17229 => (16#29D8#, 16#0020#, 16#0002#),
         17230 => (16#29F7#, 16#0020#, 16#0002#),
         17231 => (16#29D9#, 16#0020#, 16#0002#),
         17232 => (16#29F7#, 16#0020#, 16#0002#),
         17233 => (16#29DA#, 16#0020#, 16#0002#),
         17234 => (16#29F7#, 16#0020#, 16#0002#),
         17235 => (16#29DB#, 16#0020#, 16#0002#),
         17236 => (16#29F7#, 16#0020#, 16#0002#),
         17237 => (16#29DC#, 16#0020#, 16#0002#),
         17238 => (16#29F7#, 16#0020#, 16#0002#),
         17239 => (16#29DD#, 16#0020#, 16#0002#),
         17240 => (16#29F7#, 16#0020#, 16#0002#),
         17241 => (16#29DE#, 16#0020#, 16#0002#),
         17242 => (16#29F7#, 16#0020#, 16#0002#),
         17243 => (16#29DF#, 16#0020#, 16#0002#),
         17244 => (16#29F7#, 16#0020#, 16#0002#),
         17245 => (16#29E0#, 16#0020#, 16#0002#),
         17246 => (16#29F7#, 16#0020#, 16#0002#),
         17247 => (16#29E1#, 16#0020#, 16#0002#),
         17248 => (16#29F7#, 16#0020#, 16#0002#),
         17249 => (16#29E2#, 16#0020#, 16#0002#),
         17250 => (16#29F7#, 16#0020#, 16#0002#),
         17251 => (16#29E3#, 16#0020#, 16#0002#),
         17252 => (16#29F7#, 16#0020#, 16#0002#),
         17253 => (16#29E4#, 16#0020#, 16#0002#),
         17254 => (16#29F7#, 16#0020#, 16#0002#),
         17255 => (16#29E5#, 16#0020#, 16#0002#),
         17256 => (16#29F7#, 16#0020#, 16#0002#),
         17257 => (16#29E6#, 16#0020#, 16#0002#),
         17258 => (16#29F7#, 16#0020#, 16#0002#),
         17259 => (16#29E7#, 16#0020#, 16#0002#),
         17260 => (16#29F7#, 16#0020#, 16#0002#),
         17261 => (16#29E8#, 16#0020#, 16#0002#),
         17262 => (16#29F7#, 16#0020#, 16#0002#),
         17263 => (16#29E9#, 16#0020#, 16#0002#),
         17264 => (16#29F7#, 16#0020#, 16#0002#),
         17265 => (16#29EA#, 16#0020#, 16#0002#),
         17266 => (16#29F7#, 16#0020#, 16#0002#),
         17267 => (16#29EB#, 16#0020#, 16#0002#),
         17268 => (16#29F7#, 16#0020#, 16#0002#),
         17269 => (16#29EC#, 16#0020#, 16#0002#),
         17270 => (16#29F7#, 16#0020#, 16#0002#),
         17271 => (16#29ED#, 16#0020#, 16#0002#),
         17272 => (16#29F7#, 16#0020#, 16#0002#),
         17273 => (16#29EE#, 16#0020#, 16#0002#),
         17274 => (16#29F7#, 16#0020#, 16#0002#),
         17275 => (16#29EF#, 16#0020#, 16#0002#),
         17276 => (16#29F7#, 16#0020#, 16#0002#),
         17277 => (16#29F0#, 16#0020#, 16#0002#),
         17278 => (16#29F7#, 16#0020#, 16#0002#),
         17279 => (16#29F8#, 16#0020#, 16#0002#),
         17280 => (16#29F9#, 16#0020#, 16#0002#),
         17281 => (16#29FA#, 16#0020#, 16#0002#),
         17282 => (16#29C1#, 16#0020#, 16#0002#),
         17283 => (16#29FA#, 16#0020#, 16#0002#),
         17284 => (16#29C2#, 16#0020#, 16#0002#),
         17285 => (16#29FA#, 16#0020#, 16#0002#),
         17286 => (16#29C3#, 16#0020#, 16#0002#),
         17287 => (16#29FA#, 16#0020#, 16#0002#),
         17288 => (16#29C4#, 16#0020#, 16#0002#),
         17289 => (16#29FA#, 16#0020#, 16#0002#),
         17290 => (16#29C5#, 16#0020#, 16#0002#),
         17291 => (16#29FA#, 16#0020#, 16#0002#),
         17292 => (16#29C6#, 16#0020#, 16#0002#),
         17293 => (16#29FA#, 16#0020#, 16#0002#),
         17294 => (16#29C7#, 16#0020#, 16#0002#),
         17295 => (16#29FA#, 16#0020#, 16#0002#),
         17296 => (16#29C8#, 16#0020#, 16#0002#),
         17297 => (16#29FA#, 16#0020#, 16#0002#),
         17298 => (16#29C9#, 16#0020#, 16#0002#),
         17299 => (16#29FA#, 16#0020#, 16#0002#),
         17300 => (16#29CA#, 16#0020#, 16#0002#),
         17301 => (16#29FA#, 16#0020#, 16#0002#),
         17302 => (16#29CB#, 16#0020#, 16#0002#),
         17303 => (16#29FA#, 16#0020#, 16#0002#),
         17304 => (16#29CC#, 16#0020#, 16#0002#),
         17305 => (16#29FA#, 16#0020#, 16#0002#),
         17306 => (16#29CD#, 16#0020#, 16#0002#),
         17307 => (16#29FA#, 16#0020#, 16#0002#),
         17308 => (16#29CE#, 16#0020#, 16#0002#),
         17309 => (16#29FA#, 16#0020#, 16#0002#),
         17310 => (16#29CF#, 16#0020#, 16#0002#),
         17311 => (16#29FA#, 16#0020#, 16#0002#),
         17312 => (16#29D0#, 16#0020#, 16#0002#),
         17313 => (16#29FA#, 16#0020#, 16#0002#),
         17314 => (16#29D1#, 16#0020#, 16#0002#),
         17315 => (16#29FA#, 16#0020#, 16#0002#),
         17316 => (16#29D2#, 16#0020#, 16#0002#),
         17317 => (16#29FA#, 16#0020#, 16#0002#),
         17318 => (16#29D3#, 16#0020#, 16#0002#),
         17319 => (16#29FA#, 16#0020#, 16#0002#),
         17320 => (16#29D4#, 16#0020#, 16#0002#),
         17321 => (16#29FA#, 16#0020#, 16#0002#),
         17322 => (16#29D5#, 16#0020#, 16#0002#),
         17323 => (16#29FA#, 16#0020#, 16#0002#),
         17324 => (16#29D6#, 16#0020#, 16#0002#),
         17325 => (16#29FA#, 16#0020#, 16#0002#),
         17326 => (16#29D7#, 16#0020#, 16#0002#),
         17327 => (16#29FA#, 16#0020#, 16#0002#),
         17328 => (16#29D8#, 16#0020#, 16#0002#),
         17329 => (16#29FA#, 16#0020#, 16#0002#),
         17330 => (16#29D9#, 16#0020#, 16#0002#),
         17331 => (16#29FA#, 16#0020#, 16#0002#),
         17332 => (16#29DA#, 16#0020#, 16#0002#),
         17333 => (16#29FA#, 16#0020#, 16#0002#),
         17334 => (16#29DB#, 16#0020#, 16#0002#),
         17335 => (16#29FA#, 16#0020#, 16#0002#),
         17336 => (16#29DC#, 16#0020#, 16#0002#),
         17337 => (16#29FA#, 16#0020#, 16#0002#),
         17338 => (16#29DD#, 16#0020#, 16#0002#),
         17339 => (16#29FA#, 16#0020#, 16#0002#),
         17340 => (16#29DE#, 16#0020#, 16#0002#),
         17341 => (16#29FA#, 16#0020#, 16#0002#),
         17342 => (16#29DF#, 16#0020#, 16#0002#),
         17343 => (16#29FA#, 16#0020#, 16#0002#),
         17344 => (16#29E0#, 16#0020#, 16#0002#),
         17345 => (16#29FA#, 16#0020#, 16#0002#),
         17346 => (16#29E1#, 16#0020#, 16#0002#),
         17347 => (16#29FA#, 16#0020#, 16#0002#),
         17348 => (16#29E2#, 16#0020#, 16#0002#),
         17349 => (16#29FA#, 16#0020#, 16#0002#),
         17350 => (16#29E3#, 16#0020#, 16#0002#),
         17351 => (16#29FA#, 16#0020#, 16#0002#),
         17352 => (16#29E4#, 16#0020#, 16#0002#),
         17353 => (16#29FA#, 16#0020#, 16#0002#),
         17354 => (16#29E5#, 16#0020#, 16#0002#),
         17355 => (16#29FA#, 16#0020#, 16#0002#),
         17356 => (16#29E6#, 16#0020#, 16#0002#),
         17357 => (16#29FA#, 16#0020#, 16#0002#),
         17358 => (16#29E7#, 16#0020#, 16#0002#),
         17359 => (16#29FA#, 16#0020#, 16#0002#),
         17360 => (16#29E8#, 16#0020#, 16#0002#),
         17361 => (16#29FA#, 16#0020#, 16#0002#),
         17362 => (16#29E9#, 16#0020#, 16#0002#),
         17363 => (16#29FA#, 16#0020#, 16#0002#),
         17364 => (16#29EA#, 16#0020#, 16#0002#),
         17365 => (16#29FA#, 16#0020#, 16#0002#),
         17366 => (16#29EB#, 16#0020#, 16#0002#),
         17367 => (16#29FA#, 16#0020#, 16#0002#),
         17368 => (16#29EC#, 16#0020#, 16#0002#),
         17369 => (16#29FA#, 16#0020#, 16#0002#),
         17370 => (16#29ED#, 16#0020#, 16#0002#),
         17371 => (16#29FA#, 16#0020#, 16#0002#),
         17372 => (16#29EE#, 16#0020#, 16#0002#),
         17373 => (16#29FA#, 16#0020#, 16#0002#),
         17374 => (16#29EF#, 16#0020#, 16#0002#),
         17375 => (16#29FA#, 16#0020#, 16#0002#),
         17376 => (16#29F0#, 16#0020#, 16#0002#),
         17377 => (16#29FA#, 16#0020#, 16#0002#),
         17378 => (16#29FB#, 16#0020#, 16#0002#),
         17379 => (16#29FC#, 16#0020#, 16#0002#),
         17380 => (16#29C1#, 16#0020#, 16#0002#),
         17381 => (16#29FC#, 16#0020#, 16#0002#),
         17382 => (16#29C2#, 16#0020#, 16#0002#),
         17383 => (16#29FC#, 16#0020#, 16#0002#),
         17384 => (16#29C3#, 16#0020#, 16#0002#),
         17385 => (16#29FC#, 16#0020#, 16#0002#),
         17386 => (16#29C4#, 16#0020#, 16#0002#),
         17387 => (16#29FC#, 16#0020#, 16#0002#),
         17388 => (16#29C5#, 16#0020#, 16#0002#),
         17389 => (16#29FC#, 16#0020#, 16#0002#),
         17390 => (16#29C6#, 16#0020#, 16#0002#),
         17391 => (16#29FC#, 16#0020#, 16#0002#),
         17392 => (16#29C7#, 16#0020#, 16#0002#),
         17393 => (16#29FC#, 16#0020#, 16#0002#),
         17394 => (16#29C8#, 16#0020#, 16#0002#),
         17395 => (16#29FC#, 16#0020#, 16#0002#),
         17396 => (16#29C9#, 16#0020#, 16#0002#),
         17397 => (16#29FC#, 16#0020#, 16#0002#),
         17398 => (16#29CA#, 16#0020#, 16#0002#),
         17399 => (16#29FC#, 16#0020#, 16#0002#),
         17400 => (16#29CB#, 16#0020#, 16#0002#),
         17401 => (16#29FC#, 16#0020#, 16#0002#),
         17402 => (16#29CC#, 16#0020#, 16#0002#),
         17403 => (16#29FC#, 16#0020#, 16#0002#),
         17404 => (16#29CD#, 16#0020#, 16#0002#),
         17405 => (16#29FC#, 16#0020#, 16#0002#),
         17406 => (16#29CE#, 16#0020#, 16#0002#),
         17407 => (16#29FC#, 16#0020#, 16#0002#),
         17408 => (16#29CF#, 16#0020#, 16#0002#),
         17409 => (16#29FC#, 16#0020#, 16#0002#),
         17410 => (16#29D0#, 16#0020#, 16#0002#),
         17411 => (16#29FC#, 16#0020#, 16#0002#),
         17412 => (16#29D1#, 16#0020#, 16#0002#),
         17413 => (16#29FC#, 16#0020#, 16#0002#),
         17414 => (16#29D2#, 16#0020#, 16#0002#),
         17415 => (16#29FC#, 16#0020#, 16#0002#),
         17416 => (16#29D3#, 16#0020#, 16#0002#),
         17417 => (16#29FC#, 16#0020#, 16#0002#),
         17418 => (16#29D4#, 16#0020#, 16#0002#),
         17419 => (16#29FC#, 16#0020#, 16#0002#),
         17420 => (16#29D5#, 16#0020#, 16#0002#),
         17421 => (16#29FC#, 16#0020#, 16#0002#),
         17422 => (16#29D6#, 16#0020#, 16#0002#),
         17423 => (16#29FC#, 16#0020#, 16#0002#),
         17424 => (16#29D7#, 16#0020#, 16#0002#),
         17425 => (16#29FC#, 16#0020#, 16#0002#),
         17426 => (16#29D8#, 16#0020#, 16#0002#),
         17427 => (16#29FC#, 16#0020#, 16#0002#),
         17428 => (16#29D9#, 16#0020#, 16#0002#),
         17429 => (16#29FC#, 16#0020#, 16#0002#),
         17430 => (16#29DA#, 16#0020#, 16#0002#),
         17431 => (16#29FC#, 16#0020#, 16#0002#),
         17432 => (16#29DB#, 16#0020#, 16#0002#),
         17433 => (16#29FC#, 16#0020#, 16#0002#),
         17434 => (16#29DC#, 16#0020#, 16#0002#),
         17435 => (16#29FC#, 16#0020#, 16#0002#),
         17436 => (16#29DD#, 16#0020#, 16#0002#),
         17437 => (16#29FC#, 16#0020#, 16#0002#),
         17438 => (16#29DE#, 16#0020#, 16#0002#),
         17439 => (16#29FC#, 16#0020#, 16#0002#),
         17440 => (16#29DF#, 16#0020#, 16#0002#),
         17441 => (16#29FC#, 16#0020#, 16#0002#),
         17442 => (16#29E0#, 16#0020#, 16#0002#),
         17443 => (16#29FC#, 16#0020#, 16#0002#),
         17444 => (16#29E1#, 16#0020#, 16#0002#),
         17445 => (16#29FC#, 16#0020#, 16#0002#),
         17446 => (16#29E2#, 16#0020#, 16#0002#),
         17447 => (16#29FC#, 16#0020#, 16#0002#),
         17448 => (16#29E3#, 16#0020#, 16#0002#),
         17449 => (16#29FC#, 16#0020#, 16#0002#),
         17450 => (16#29E4#, 16#0020#, 16#0002#),
         17451 => (16#29FC#, 16#0020#, 16#0002#),
         17452 => (16#29E5#, 16#0020#, 16#0002#),
         17453 => (16#29FC#, 16#0020#, 16#0002#),
         17454 => (16#29E6#, 16#0020#, 16#0002#),
         17455 => (16#29FC#, 16#0020#, 16#0002#),
         17456 => (16#29E7#, 16#0020#, 16#0002#),
         17457 => (16#29FC#, 16#0020#, 16#0002#),
         17458 => (16#29E8#, 16#0020#, 16#0002#),
         17459 => (16#29FC#, 16#0020#, 16#0002#),
         17460 => (16#29E9#, 16#0020#, 16#0002#),
         17461 => (16#29FC#, 16#0020#, 16#0002#),
         17462 => (16#29EA#, 16#0020#, 16#0002#),
         17463 => (16#29FC#, 16#0020#, 16#0002#),
         17464 => (16#29EB#, 16#0020#, 16#0002#),
         17465 => (16#29FC#, 16#0020#, 16#0002#),
         17466 => (16#29EC#, 16#0020#, 16#0002#),
         17467 => (16#29FC#, 16#0020#, 16#0002#),
         17468 => (16#29ED#, 16#0020#, 16#0002#),
         17469 => (16#29FC#, 16#0020#, 16#0002#),
         17470 => (16#29EE#, 16#0020#, 16#0002#),
         17471 => (16#29FC#, 16#0020#, 16#0002#),
         17472 => (16#29EF#, 16#0020#, 16#0002#),
         17473 => (16#29FC#, 16#0020#, 16#0002#),
         17474 => (16#29F0#, 16#0020#, 16#0002#),
         17475 => (16#29FC#, 16#0020#, 16#0002#),
         17476 => (16#29FD#, 16#0020#, 16#0002#),
         17477 => (16#29C1#, 16#0020#, 16#0002#),
         17478 => (16#29FD#, 16#0020#, 16#0002#),
         17479 => (16#29C2#, 16#0020#, 16#0002#),
         17480 => (16#29FD#, 16#0020#, 16#0002#),
         17481 => (16#29C3#, 16#0020#, 16#0002#),
         17482 => (16#29FD#, 16#0020#, 16#0002#),
         17483 => (16#29C4#, 16#0020#, 16#0002#),
         17484 => (16#29FD#, 16#0020#, 16#0002#),
         17485 => (16#29C5#, 16#0020#, 16#0002#),
         17486 => (16#29FD#, 16#0020#, 16#0002#),
         17487 => (16#29C6#, 16#0020#, 16#0002#),
         17488 => (16#29FD#, 16#0020#, 16#0002#),
         17489 => (16#29C7#, 16#0020#, 16#0002#),
         17490 => (16#29FD#, 16#0020#, 16#0002#),
         17491 => (16#29C8#, 16#0020#, 16#0002#),
         17492 => (16#29FD#, 16#0020#, 16#0002#),
         17493 => (16#29C9#, 16#0020#, 16#0002#),
         17494 => (16#29FD#, 16#0020#, 16#0002#),
         17495 => (16#29CA#, 16#0020#, 16#0002#),
         17496 => (16#29FD#, 16#0020#, 16#0002#),
         17497 => (16#29CB#, 16#0020#, 16#0002#),
         17498 => (16#29FD#, 16#0020#, 16#0002#),
         17499 => (16#29CC#, 16#0020#, 16#0002#),
         17500 => (16#29FD#, 16#0020#, 16#0002#),
         17501 => (16#29CD#, 16#0020#, 16#0002#),
         17502 => (16#29FD#, 16#0020#, 16#0002#),
         17503 => (16#29CE#, 16#0020#, 16#0002#),
         17504 => (16#29FD#, 16#0020#, 16#0002#),
         17505 => (16#29CF#, 16#0020#, 16#0002#),
         17506 => (16#29FD#, 16#0020#, 16#0002#),
         17507 => (16#29D0#, 16#0020#, 16#0002#),
         17508 => (16#29FD#, 16#0020#, 16#0002#),
         17509 => (16#29D1#, 16#0020#, 16#0002#),
         17510 => (16#29FD#, 16#0020#, 16#0002#),
         17511 => (16#29D2#, 16#0020#, 16#0002#),
         17512 => (16#29FD#, 16#0020#, 16#0002#),
         17513 => (16#29D3#, 16#0020#, 16#0002#),
         17514 => (16#29FD#, 16#0020#, 16#0002#),
         17515 => (16#29D4#, 16#0020#, 16#0002#),
         17516 => (16#29FD#, 16#0020#, 16#0002#),
         17517 => (16#29D5#, 16#0020#, 16#0002#),
         17518 => (16#29FD#, 16#0020#, 16#0002#),
         17519 => (16#29D6#, 16#0020#, 16#0002#),
         17520 => (16#29FD#, 16#0020#, 16#0002#),
         17521 => (16#29D7#, 16#0020#, 16#0002#),
         17522 => (16#29FD#, 16#0020#, 16#0002#),
         17523 => (16#29D8#, 16#0020#, 16#0002#),
         17524 => (16#29FD#, 16#0020#, 16#0002#),
         17525 => (16#29D9#, 16#0020#, 16#0002#),
         17526 => (16#29FD#, 16#0020#, 16#0002#),
         17527 => (16#29DA#, 16#0020#, 16#0002#),
         17528 => (16#29FD#, 16#0020#, 16#0002#),
         17529 => (16#29DB#, 16#0020#, 16#0002#),
         17530 => (16#29FD#, 16#0020#, 16#0002#),
         17531 => (16#29DC#, 16#0020#, 16#0002#),
         17532 => (16#29FD#, 16#0020#, 16#0002#),
         17533 => (16#29DD#, 16#0020#, 16#0002#),
         17534 => (16#29FD#, 16#0020#, 16#0002#),
         17535 => (16#29DE#, 16#0020#, 16#0002#),
         17536 => (16#29FD#, 16#0020#, 16#0002#),
         17537 => (16#29DF#, 16#0020#, 16#0002#),
         17538 => (16#29FD#, 16#0020#, 16#0002#),
         17539 => (16#29E0#, 16#0020#, 16#0002#),
         17540 => (16#29FD#, 16#0020#, 16#0002#),
         17541 => (16#29E1#, 16#0020#, 16#0002#),
         17542 => (16#29FD#, 16#0020#, 16#0002#),
         17543 => (16#29E2#, 16#0020#, 16#0002#),
         17544 => (16#29FD#, 16#0020#, 16#0002#),
         17545 => (16#29E3#, 16#0020#, 16#0002#),
         17546 => (16#29FD#, 16#0020#, 16#0002#),
         17547 => (16#29E4#, 16#0020#, 16#0002#),
         17548 => (16#29FD#, 16#0020#, 16#0002#),
         17549 => (16#29E5#, 16#0020#, 16#0002#),
         17550 => (16#29FD#, 16#0020#, 16#0002#),
         17551 => (16#29E6#, 16#0020#, 16#0002#),
         17552 => (16#29FD#, 16#0020#, 16#0002#),
         17553 => (16#29E7#, 16#0020#, 16#0002#),
         17554 => (16#29FD#, 16#0020#, 16#0002#),
         17555 => (16#29E8#, 16#0020#, 16#0002#),
         17556 => (16#29FD#, 16#0020#, 16#0002#),
         17557 => (16#29E9#, 16#0020#, 16#0002#),
         17558 => (16#29FD#, 16#0020#, 16#0002#),
         17559 => (16#29EA#, 16#0020#, 16#0002#),
         17560 => (16#29FD#, 16#0020#, 16#0002#),
         17561 => (16#29EB#, 16#0020#, 16#0002#),
         17562 => (16#29FD#, 16#0020#, 16#0002#),
         17563 => (16#29EC#, 16#0020#, 16#0002#),
         17564 => (16#29FD#, 16#0020#, 16#0002#),
         17565 => (16#29ED#, 16#0020#, 16#0002#),
         17566 => (16#29FD#, 16#0020#, 16#0002#),
         17567 => (16#29EE#, 16#0020#, 16#0002#),
         17568 => (16#29FD#, 16#0020#, 16#0002#),
         17569 => (16#29EF#, 16#0020#, 16#0002#),
         17570 => (16#29FD#, 16#0020#, 16#0002#),
         17571 => (16#29F0#, 16#0020#, 16#0002#),
         17572 => (16#29FD#, 16#0020#, 16#0002#),
         17573 => (16#29FE#, 16#0020#, 16#0002#),
         17574 => (16#29FF#, 16#0020#, 16#0002#),
         17575 => (16#0000#, 16#00D7#, 16#0002#),
         17576 => (16#2A00#, 16#0020#, 16#0002#),
         17577 => (16#0000#, 16#00D8#, 16#0002#),
         17578 => (16#2A01#, 16#0020#, 16#0002#),
         17579 => (16#2A02#, 16#0020#, 16#0002#),
         17580 => (16#2A03#, 16#0020#, 16#0002#),
         17581 => (16#16BB#, 16#0020#, 16#0002#),
         17582 => (16#02D4#, 16#0020#, 16#0002#),
         17583 => (16#02D5#, 16#0020#, 16#0002#),
         17584 => (16#25E8#, 16#0020#, 16#0002#),
         17585 => (16#25E9#, 16#0020#, 16#0002#),
         17586 => (16#25EA#, 16#0020#, 16#0002#),
         17587 => (16#25EB#, 16#0020#, 16#0002#),
         17588 => (16#25EC#, 16#0020#, 16#0002#),
         17589 => (16#25ED#, 16#0020#, 16#0002#),
         17590 => (16#25EE#, 16#0020#, 16#0002#),
         17591 => (16#25EF#, 16#0020#, 16#0002#),
         17592 => (16#25F0#, 16#0020#, 16#0002#),
         17593 => (16#25F1#, 16#0020#, 16#0002#),
         17594 => (16#25F2#, 16#0020#, 16#0002#),
         17595 => (16#25FB#, 16#0020#, 16#0002#),
         17596 => (16#25FC#, 16#0020#, 16#0002#),
         17597 => (16#25FD#, 16#0020#, 16#0002#),
         17598 => (16#25FE#, 16#0020#, 16#0002#),
         17599 => (16#25FF#, 16#0020#, 16#0002#),
         17600 => (16#01A4#, 16#0020#, 16#0002#),
         17601 => (16#016F#, 16#0020#, 16#0002#),
         17602 => (16#25CC#, 16#0020#, 16#0002#),
         17603 => (16#16BC#, 16#0020#, 16#0002#),
         17604 => (16#16BD#, 16#0020#, 16#0002#),
         17605 => (16#2600#, 16#0020#, 16#0002#),
         17606 => (16#260A#, 16#0020#, 16#0002#),
         17607 => (16#218A#, 16#0020#, 16#0002#),
         17608 => (16#218B#, 16#0020#, 16#0002#),
         17609 => (16#218C#, 16#0020#, 16#0002#),
         17610 => (16#218D#, 16#0020#, 16#0002#),
         17611 => (16#218E#, 16#0020#, 16#0002#),
         17612 => (16#218F#, 16#0020#, 16#0002#),
         17613 => (16#2251#, 16#0020#, 16#0002#),
         17614 => (16#2252#, 16#0020#, 16#0002#),
         17615 => (16#2253#, 16#0020#, 16#0002#),
         17616 => (16#2254#, 16#0020#, 16#0002#),
         17617 => (16#2255#, 16#0020#, 16#0002#),
         17618 => (16#2256#, 16#0020#, 16#0002#),
         17619 => (16#2232#, 16#0020#, 16#0002#),
         17620 => (16#2233#, 16#0020#, 16#0002#),
         17621 => (16#2234#, 16#0020#, 16#0002#),
         17622 => (16#2235#, 16#0020#, 16#0002#),
         17623 => (16#2236#, 16#0020#, 16#0002#),
         17624 => (16#2237#, 16#0020#, 16#0002#),
         17625 => (16#2294#, 16#0020#, 16#0002#),
         17626 => (16#2295#, 16#0020#, 16#0002#),
         17627 => (16#2296#, 16#0020#, 16#0002#),
         17628 => (16#2297#, 16#0020#, 16#0002#),
         17629 => (16#2298#, 16#0020#, 16#0002#),
         17630 => (16#2299#, 16#0020#, 16#0002#),
         17631 => (16#229A#, 16#0020#, 16#0002#),
         17632 => (16#22AC#, 16#0020#, 16#0002#),
         17633 => (16#22AD#, 16#0020#, 16#0002#),
         17634 => (16#22AE#, 16#0020#, 16#0002#),
         17635 => (16#22AF#, 16#0020#, 16#0002#),
         17636 => (16#22B0#, 16#0020#, 16#0002#),
         17637 => (16#22B1#, 16#0020#, 16#0002#),
         17638 => (16#22B2#, 16#0020#, 16#0002#),
         17639 => (16#191E#, 16#0020#, 16#0002#),
         17640 => (16#1915#, 16#0020#, 16#0002#),
         17641 => (16#1973#, 16#0020#, 16#0002#),
         17642 => (16#1974#, 16#0020#, 16#0002#),
         17643 => (16#197A#, 16#0020#, 16#0002#),
         17644 => (16#19AE#, 16#0020#, 16#0002#),
         17645 => (16#19C0#, 16#0020#, 16#0002#),
         17646 => (16#1A55#, 16#0020#, 16#0002#),
         17647 => (16#1A4F#, 16#0020#, 16#0002#),
         17648 => (16#1A50#, 16#0020#, 16#0002#),
         17649 => (16#1A79#, 16#0020#, 16#0002#),
         17650 => (16#1A9A#, 16#0020#, 16#0002#),
         17651 => (16#1AA0#, 16#0020#, 16#0002#),
         17652 => (16#1AA7#, 16#0020#, 16#0002#),
         17653 => (16#1AB3#, 16#0020#, 16#0002#),
         17654 => (16#1ABA#, 16#0020#, 16#0002#),
         17655 => (16#1AAF#, 16#0020#, 16#0002#),
         17656 => (16#1AAD#, 16#0020#, 16#0002#),
         17657 => (16#1AAE#, 16#0020#, 16#0002#),
         17658 => (16#1AB0#, 16#0020#, 16#0002#),
         17659 => (16#1AB1#, 16#0020#, 16#0002#),
         17660 => (16#1AF9#, 16#0020#, 16#0002#),
         17661 => (16#1AFE#, 16#0020#, 16#0002#),
         17662 => (16#1B27#, 16#0020#, 16#0002#),
         17663 => (16#1B28#, 16#0020#, 16#0002#),
         17664 => (16#1B1D#, 16#0020#, 16#0002#),
         17665 => (16#1B29#, 16#0020#, 16#0002#),
         17666 => (16#1B2A#, 16#0020#, 16#0002#),
         17667 => (16#1B2B#, 16#0020#, 16#0002#),
         17668 => (16#1B48#, 16#0020#, 16#0002#),
         17669 => (16#1B7C#, 16#0020#, 16#0002#),
         17670 => (16#1B86#, 16#0020#, 16#0002#),
         17671 => (16#1B80#, 16#0020#, 16#0002#),
         17672 => (16#1B81#, 16#0020#, 16#0002#),
         17673 => (16#1B89#, 16#0020#, 16#0002#),
         17674 => (16#1BCA#, 16#0020#, 16#0002#),
         17675 => (16#1BCB#, 16#0020#, 16#0002#),
         17676 => (16#1BCC#, 16#0020#, 16#0002#),
         17677 => (16#1BC6#, 16#0020#, 16#0002#),
         17678 => (16#1BC7#, 16#0020#, 16#0002#),
         17679 => (16#1BC8#, 16#0020#, 16#0002#),
         17680 => (16#1BC9#, 16#0020#, 16#0002#),
         17681 => (16#1BDE#, 16#0020#, 16#0002#),
         17682 => (16#03B9#, 16#0020#, 16#0002#),
         17683 => (16#19EF#, 16#0020#, 16#0014#),
         17684 => (16#1A55#, 16#0020#, 16#0014#),
         17685 => (16#1A4B#, 16#0020#, 16#0014#),
         17686 => (16#1B89#, 16#0020#, 16#0014#),
         17687 => (16#1924#, 16#0020#, 16#0002#),
         17688 => (16#1CA0#, 16#0020#, 16#0002#),
         17689 => (16#25CD#, 16#0020#, 16#0002#),
         17690 => (16#25CE#, 16#0020#, 16#0002#),
         17691 => (16#25CF#, 16#0020#, 16#0002#),
         17692 => (16#25D0#, 16#0020#, 16#0002#),
         17693 => (16#25D1#, 16#0020#, 16#0002#),
         17694 => (16#25D2#, 16#0020#, 16#0002#),
         17695 => (16#25D3#, 16#0020#, 16#0002#),
         17696 => (16#25D4#, 16#0020#, 16#0002#),
         17697 => (16#25D5#, 16#0020#, 16#0002#),
         17698 => (16#25D6#, 16#0020#, 16#0002#),
         17699 => (16#25D7#, 16#0020#, 16#0002#),
         17700 => (16#25D8#, 16#0020#, 16#0002#),
         17701 => (16#25D9#, 16#0020#, 16#0002#),
         17702 => (16#25DA#, 16#0020#, 16#0002#),
         17703 => (16#25DB#, 16#0020#, 16#0002#),
         17704 => (16#25DC#, 16#0020#, 16#0002#),
         17705 => (16#25DD#, 16#0020#, 16#0002#),
         17706 => (16#25DE#, 16#0020#, 16#0002#),
         17707 => (16#25DF#, 16#0020#, 16#0002#),
         17708 => (16#25E0#, 16#0020#, 16#0002#),
         17709 => (16#25E1#, 16#0020#, 16#0002#),
         17710 => (16#25E2#, 16#0020#, 16#0002#),
         17711 => (16#25E3#, 16#0020#, 16#0002#),
         17712 => (16#25E4#, 16#0020#, 16#0002#),
         17713 => (16#25E5#, 16#0020#, 16#0002#),
         17714 => (16#25E6#, 16#0020#, 16#0002#),
         17715 => (16#25E7#, 16#0020#, 16#0002#),
         17716 => (16#2601#, 16#0020#, 16#0002#),
         17717 => (16#2602#, 16#0020#, 16#0002#),
         17718 => (16#2603#, 16#0020#, 16#0002#),
         17719 => (16#2604#, 16#0020#, 16#0002#),
         17720 => (16#2605#, 16#0020#, 16#0002#),
         17721 => (16#2606#, 16#0020#, 16#0002#),
         17722 => (16#2607#, 16#0020#, 16#0002#),
         17723 => (16#2608#, 16#0020#, 16#0002#),
         17724 => (16#25F3#, 16#0020#, 16#0002#),
         17725 => (16#25F4#, 16#0020#, 16#0002#),
         17726 => (16#25F5#, 16#0020#, 16#0002#),
         17727 => (16#25F6#, 16#0020#, 16#0002#),
         17728 => (16#25F7#, 16#0020#, 16#0002#),
         17729 => (16#25F8#, 16#0020#, 16#0002#),
         17730 => (16#25F9#, 16#0020#, 16#0002#),
         17731 => (16#25FA#, 16#0020#, 16#0002#),
         17732 => (16#01A5#, 16#0020#, 16#0002#),
         17733 => (16#0000#, 16#00C5#, 16#0002#),
         17734 => (16#2609#, 16#0020#, 16#0002#),
         17735 => (16#37E8#, 16#0020#, 16#0002#),
         17736 => (16#37E9#, 16#0020#, 16#0002#),
         17737 => (16#37EA#, 16#0020#, 16#0002#),
         17738 => (16#37EB#, 16#0020#, 16#0002#),
         17739 => (16#37EC#, 16#0020#, 16#0002#),
         17740 => (16#37ED#, 16#0020#, 16#0002#),
         17741 => (16#37EE#, 16#0020#, 16#0002#),
         17742 => (16#37EF#, 16#0020#, 16#0002#),
         17743 => (16#37F0#, 16#0020#, 16#0002#),
         17744 => (16#37F1#, 16#0020#, 16#0002#),
         17745 => (16#37F2#, 16#0020#, 16#0002#),
         17746 => (16#37F3#, 16#0020#, 16#0002#),
         17747 => (16#37F4#, 16#0020#, 16#0002#),
         17748 => (16#37F5#, 16#0020#, 16#0002#),
         17749 => (16#37F6#, 16#0020#, 16#0002#),
         17750 => (16#37F7#, 16#0020#, 16#0002#),
         17751 => (16#37F8#, 16#0020#, 16#0002#),
         17752 => (16#37F9#, 16#0020#, 16#0002#),
         17753 => (16#37FA#, 16#0020#, 16#0002#),
         17754 => (16#37FB#, 16#0020#, 16#0002#),
         17755 => (16#37FC#, 16#0020#, 16#0002#),
         17756 => (16#37FD#, 16#0020#, 16#0002#),
         17757 => (16#37FE#, 16#0020#, 16#0002#),
         17758 => (16#3857#, 16#0020#, 16#0002#),
         17759 => (16#3858#, 16#0020#, 16#0002#),
         17760 => (16#3859#, 16#0020#, 16#0002#),
         17761 => (16#385A#, 16#0020#, 16#0002#),
         17762 => (16#385B#, 16#0020#, 16#0002#),
         17763 => (16#385C#, 16#0020#, 16#0002#),
         17764 => (16#385D#, 16#0020#, 16#0002#),
         17765 => (16#385E#, 16#0020#, 16#0002#),
         17766 => (16#385F#, 16#0020#, 16#0002#),
         17767 => (16#3860#, 16#0020#, 16#0002#),
         17768 => (16#3861#, 16#0020#, 16#0002#),
         17769 => (16#3862#, 16#0020#, 16#0002#),
         17770 => (16#3863#, 16#0020#, 16#0002#),
         17771 => (16#3864#, 16#0020#, 16#0002#),
         17772 => (16#3865#, 16#0020#, 16#0002#),
         17773 => (16#3866#, 16#0020#, 16#0002#),
         17774 => (16#3867#, 16#0020#, 16#0002#),
         17775 => (16#3868#, 16#0020#, 16#0002#),
         17776 => (16#3869#, 16#0020#, 16#0002#),
         17777 => (16#386A#, 16#0020#, 16#0002#),
         17778 => (16#386B#, 16#0020#, 16#0002#),
         17779 => (16#386C#, 16#0020#, 16#0002#),
         17780 => (16#386D#, 16#0020#, 16#0002#),
         17781 => (16#386E#, 16#0020#, 16#0002#),
         17782 => (16#386F#, 16#0020#, 16#0002#),
         17783 => (16#3870#, 16#0020#, 16#0002#),
         17784 => (16#3871#, 16#0020#, 16#0002#),
         17785 => (16#3872#, 16#0020#, 16#0002#),
         17786 => (16#3873#, 16#0020#, 16#0002#),
         17787 => (16#3874#, 16#0020#, 16#0002#),
         17788 => (16#3875#, 16#0020#, 16#0002#),
         17789 => (16#3876#, 16#0020#, 16#0002#),
         17790 => (16#3877#, 16#0020#, 16#0002#),
         17791 => (16#3878#, 16#0020#, 16#0002#),
         17792 => (16#3879#, 16#0020#, 16#0002#),
         17793 => (16#387A#, 16#0020#, 16#0002#),
         17794 => (16#387B#, 16#0020#, 16#0002#),
         17795 => (16#387C#, 16#0020#, 16#0002#),
         17796 => (16#387D#, 16#0020#, 16#0002#),
         17797 => (16#387E#, 16#0020#, 16#0002#),
         17798 => (16#387F#, 16#0020#, 16#0002#),
         17799 => (16#3880#, 16#0020#, 16#0002#),
         17800 => (16#3881#, 16#0020#, 16#0002#),
         17801 => (16#3882#, 16#0020#, 16#0002#),
         17802 => (16#3883#, 16#0020#, 16#0002#),
         17803 => (16#3884#, 16#0020#, 16#0002#),
         17804 => (16#3885#, 16#0020#, 16#0002#),
         17805 => (16#3886#, 16#0020#, 16#0002#),
         17806 => (16#3887#, 16#0020#, 16#0002#),
         17807 => (16#FB41#, 16#0020#, 16#0002#),
         17808 => (16#8C48#, 16#0000#, 16#0000#),
         17809 => (16#FB40#, 16#0020#, 16#0002#),
         17810 => (16#E6F4#, 16#0000#, 16#0000#),
         17811 => (16#FB41#, 16#0020#, 16#0002#),
         17812 => (16#8ECA#, 16#0000#, 16#0000#),
         17813 => (16#FB41#, 16#0020#, 16#0002#),
         17814 => (16#8CC8#, 16#0000#, 16#0000#),
         17815 => (16#FB40#, 16#0020#, 16#0002#),
         17816 => (16#EED1#, 16#0000#, 16#0000#),
         17817 => (16#FB40#, 16#0020#, 16#0002#),
         17818 => (16#CE32#, 16#0000#, 16#0000#),
         17819 => (16#FB40#, 16#0020#, 16#0002#),
         17820 => (16#D3E5#, 16#0000#, 16#0000#),
         17821 => (16#FB41#, 16#0020#, 16#0002#),
         17822 => (16#9F9C#, 16#0000#, 16#0000#),
         17823 => (16#FB40#, 16#0020#, 16#0002#),
         17824 => (16#D951#, 16#0000#, 16#0000#),
         17825 => (16#FB41#, 16#0020#, 16#0002#),
         17826 => (16#91D1#, 16#0000#, 16#0000#),
         17827 => (16#FB40#, 16#0020#, 16#0002#),
         17828 => (16#D587#, 16#0000#, 16#0000#),
         17829 => (16#FB40#, 16#0020#, 16#0002#),
         17830 => (16#D948#, 16#0000#, 16#0000#),
         17831 => (16#FB40#, 16#0020#, 16#0002#),
         17832 => (16#E1F6#, 16#0000#, 16#0000#),
         17833 => (16#FB40#, 16#0020#, 16#0002#),
         17834 => (16#F669#, 16#0000#, 16#0000#),
         17835 => (16#FB40#, 16#0020#, 16#0002#),
         17836 => (16#FF85#, 16#0000#, 16#0000#),
         17837 => (16#FB41#, 16#0020#, 16#0002#),
         17838 => (16#863F#, 16#0000#, 16#0000#),
         17839 => (16#FB41#, 16#0020#, 16#0002#),
         17840 => (16#87BA#, 16#0000#, 16#0000#),
         17841 => (16#FB41#, 16#0020#, 16#0002#),
         17842 => (16#88F8#, 16#0000#, 16#0000#),
         17843 => (16#FB41#, 16#0020#, 16#0002#),
         17844 => (16#908F#, 16#0000#, 16#0000#),
         17845 => (16#FB40#, 16#0020#, 16#0002#),
         17846 => (16#EA02#, 16#0000#, 16#0000#),
         17847 => (16#FB40#, 16#0020#, 16#0002#),
         17848 => (16#ED1B#, 16#0000#, 16#0000#),
         17849 => (16#FB40#, 16#0020#, 16#0002#),
         17850 => (16#F0D9#, 16#0000#, 16#0000#),
         17851 => (16#FB40#, 16#0020#, 16#0002#),
         17852 => (16#F3DE#, 16#0000#, 16#0000#),
         17853 => (16#FB41#, 16#0020#, 16#0002#),
         17854 => (16#843D#, 16#0000#, 16#0000#),
         17855 => (16#FB41#, 16#0020#, 16#0002#),
         17856 => (16#916A#, 16#0000#, 16#0000#),
         17857 => (16#FB41#, 16#0020#, 16#0002#),
         17858 => (16#99F1#, 16#0000#, 16#0000#),
         17859 => (16#FB40#, 16#0020#, 16#0002#),
         17860 => (16#CE82#, 16#0000#, 16#0000#),
         17861 => (16#FB40#, 16#0020#, 16#0002#),
         17862 => (16#D375#, 16#0000#, 16#0000#),
         17863 => (16#FB40#, 16#0020#, 16#0002#),
         17864 => (16#EB04#, 16#0000#, 16#0000#),
         17865 => (16#FB40#, 16#0020#, 16#0002#),
         17866 => (16#F21B#, 16#0000#, 16#0000#),
         17867 => (16#FB41#, 16#0020#, 16#0002#),
         17868 => (16#862D#, 16#0000#, 16#0000#),
         17869 => (16#FB41#, 16#0020#, 16#0002#),
         17870 => (16#9E1E#, 16#0000#, 16#0000#),
         17871 => (16#FB40#, 16#0020#, 16#0002#),
         17872 => (16#DD50#, 16#0000#, 16#0000#),
         17873 => (16#FB40#, 16#0020#, 16#0002#),
         17874 => (16#EFEB#, 16#0000#, 16#0000#),
         17875 => (16#FB41#, 16#0020#, 16#0002#),
         17876 => (16#85CD#, 16#0000#, 16#0000#),
         17877 => (16#FB41#, 16#0020#, 16#0002#),
         17878 => (16#8964#, 16#0000#, 16#0000#),
         17879 => (16#FB40#, 16#0020#, 16#0002#),
         17880 => (16#E2C9#, 16#0000#, 16#0000#),
         17881 => (16#FB41#, 16#0020#, 16#0002#),
         17882 => (16#81D8#, 16#0000#, 16#0000#),
         17883 => (16#FB41#, 16#0020#, 16#0002#),
         17884 => (16#881F#, 16#0000#, 16#0000#),
         17885 => (16#FB40#, 16#0020#, 16#0002#),
         17886 => (16#DECA#, 16#0000#, 16#0000#),
         17887 => (16#FB40#, 16#0020#, 16#0002#),
         17888 => (16#E717#, 16#0000#, 16#0000#),
         17889 => (16#FB40#, 16#0020#, 16#0002#),
         17890 => (16#ED6A#, 16#0000#, 16#0000#),
         17891 => (16#FB40#, 16#0020#, 16#0002#),
         17892 => (16#F2FC#, 16#0000#, 16#0000#),
         17893 => (16#FB41#, 16#0020#, 16#0002#),
         17894 => (16#90CE#, 16#0000#, 16#0000#),
         17895 => (16#FB40#, 16#0020#, 16#0002#),
         17896 => (16#CF86#, 16#0000#, 16#0000#),
         17897 => (16#FB40#, 16#0020#, 16#0002#),
         17898 => (16#D1B7#, 16#0000#, 16#0000#),
         17899 => (16#FB40#, 16#0020#, 16#0002#),
         17900 => (16#D2DE#, 16#0000#, 16#0000#),
         17901 => (16#FB40#, 16#0020#, 16#0002#),
         17902 => (16#E4C4#, 16#0000#, 16#0000#),
         17903 => (16#FB40#, 16#0020#, 16#0002#),
         17904 => (16#EAD3#, 16#0000#, 16#0000#),
         17905 => (16#FB40#, 16#0020#, 16#0002#),
         17906 => (16#F210#, 16#0000#, 16#0000#),
         17907 => (16#FB40#, 16#0020#, 16#0002#),
         17908 => (16#F6E7#, 16#0000#, 16#0000#),
         17909 => (16#FB41#, 16#0020#, 16#0002#),
         17910 => (16#8001#, 16#0000#, 16#0000#),
         17911 => (16#FB41#, 16#0020#, 16#0002#),
         17912 => (16#8606#, 16#0000#, 16#0000#),
         17913 => (16#FB41#, 16#0020#, 16#0002#),
         17914 => (16#865C#, 16#0000#, 16#0000#),
         17915 => (16#FB41#, 16#0020#, 16#0002#),
         17916 => (16#8DEF#, 16#0000#, 16#0000#),
         17917 => (16#FB41#, 16#0020#, 16#0002#),
         17918 => (16#9732#, 16#0000#, 16#0000#),
         17919 => (16#FB41#, 16#0020#, 16#0002#),
         17920 => (16#9B6F#, 16#0000#, 16#0000#),
         17921 => (16#FB41#, 16#0020#, 16#0002#),
         17922 => (16#9DFA#, 16#0000#, 16#0000#),
         17923 => (16#FB40#, 16#0020#, 16#0002#),
         17924 => (16#F88C#, 16#0000#, 16#0000#),
         17925 => (16#FB40#, 16#0020#, 16#0002#),
         17926 => (16#F97F#, 16#0000#, 16#0000#),
         17927 => (16#FB40#, 16#0020#, 16#0002#),
         17928 => (16#FDA0#, 16#0000#, 16#0000#),
         17929 => (16#FB41#, 16#0020#, 16#0002#),
         17930 => (16#83C9#, 16#0000#, 16#0000#),
         17931 => (16#FB41#, 16#0020#, 16#0002#),
         17932 => (16#9304#, 16#0000#, 16#0000#),
         17933 => (16#FB41#, 16#0020#, 16#0002#),
         17934 => (16#9E7F#, 16#0000#, 16#0000#),
         17935 => (16#FB41#, 16#0020#, 16#0002#),
         17936 => (16#8AD6#, 16#0000#, 16#0000#),
         17937 => (16#FB40#, 16#0020#, 16#0002#),
         17938 => (16#D8DF#, 16#0000#, 16#0000#),
         17939 => (16#FB40#, 16#0020#, 16#0002#),
         17940 => (16#DF04#, 16#0000#, 16#0000#),
         17941 => (16#FB40#, 16#0020#, 16#0002#),
         17942 => (16#FC60#, 16#0000#, 16#0000#),
         17943 => (16#FB41#, 16#0020#, 16#0002#),
         17944 => (16#807E#, 16#0000#, 16#0000#),
         17945 => (16#FB40#, 16#0020#, 16#0002#),
         17946 => (16#F262#, 16#0000#, 16#0000#),
         17947 => (16#FB40#, 16#0020#, 16#0002#),
         17948 => (16#F8CA#, 16#0000#, 16#0000#),
         17949 => (16#FB41#, 16#0020#, 16#0002#),
         17950 => (16#8CC2#, 16#0000#, 16#0000#),
         17951 => (16#FB41#, 16#0020#, 16#0002#),
         17952 => (16#96F7#, 16#0000#, 16#0000#),
         17953 => (16#FB40#, 16#0020#, 16#0002#),
         17954 => (16#D8D8#, 16#0000#, 16#0000#),
         17955 => (16#FB40#, 16#0020#, 16#0002#),
         17956 => (16#DC62#, 16#0000#, 16#0000#),
         17957 => (16#FB40#, 16#0020#, 16#0002#),
         17958 => (16#EA13#, 16#0000#, 16#0000#),
         17959 => (16#FB40#, 16#0020#, 16#0002#),
         17960 => (16#EDDA#, 16#0000#, 16#0000#),
         17961 => (16#FB40#, 16#0020#, 16#0002#),
         17962 => (16#EF0F#, 16#0000#, 16#0000#),
         17963 => (16#FB40#, 16#0020#, 16#0002#),
         17964 => (16#FD2F#, 16#0000#, 16#0000#),
         17965 => (16#FB40#, 16#0020#, 16#0002#),
         17966 => (16#FE37#, 16#0000#, 16#0000#),
         17967 => (16#FB41#, 16#0020#, 16#0002#),
         17968 => (16#964B#, 16#0000#, 16#0000#),
         17969 => (16#FB40#, 16#0020#, 16#0002#),
         17970 => (16#D2D2#, 16#0000#, 16#0000#),
         17971 => (16#FB41#, 16#0020#, 16#0002#),
         17972 => (16#808B#, 16#0000#, 16#0000#),
         17973 => (16#FB40#, 16#0020#, 16#0002#),
         17974 => (16#D1DC#, 16#0000#, 16#0000#),
         17975 => (16#FB40#, 16#0020#, 16#0002#),
         17976 => (16#D1CC#, 16#0000#, 16#0000#),
         17977 => (16#FB40#, 16#0020#, 16#0002#),
         17978 => (16#FA1C#, 16#0000#, 16#0000#),
         17979 => (16#FB40#, 16#0020#, 16#0002#),
         17980 => (16#FDBE#, 16#0000#, 16#0000#),
         17981 => (16#FB41#, 16#0020#, 16#0002#),
         17982 => (16#83F1#, 16#0000#, 16#0000#),
         17983 => (16#FB41#, 16#0020#, 16#0002#),
         17984 => (16#9675#, 16#0000#, 16#0000#),
         17985 => (16#FB41#, 16#0020#, 16#0002#),
         17986 => (16#8B80#, 16#0000#, 16#0000#),
         17987 => (16#FB40#, 16#0020#, 16#0002#),
         17988 => (16#E2CF#, 16#0000#, 16#0000#),
         17989 => (16#FB41#, 16#0020#, 16#0002#),
         17990 => (16#8AFE#, 16#0000#, 16#0000#),
         17991 => (16#FB40#, 16#0020#, 16#0002#),
         17992 => (16#CE39#, 16#0000#, 16#0000#),
         17993 => (16#FB40#, 16#0020#, 16#0002#),
         17994 => (16#DBE7#, 16#0000#, 16#0000#),
         17995 => (16#FB40#, 16#0020#, 16#0002#),
         17996 => (16#E012#, 16#0000#, 16#0000#),
         17997 => (16#FB40#, 16#0020#, 16#0002#),
         17998 => (16#F387#, 16#0000#, 16#0000#),
         17999 => (16#FB40#, 16#0020#, 16#0002#),
         18000 => (16#F570#, 16#0000#, 16#0000#),
         18001 => (16#FB40#, 16#0020#, 16#0002#),
         18002 => (16#D317#, 16#0000#, 16#0000#),
         18003 => (16#FB40#, 16#0020#, 16#0002#),
         18004 => (16#F8FB#, 16#0000#, 16#0000#),
         18005 => (16#FB40#, 16#0020#, 16#0002#),
         18006 => (16#CFBF#, 16#0000#, 16#0000#),
         18007 => (16#FB40#, 16#0020#, 16#0002#),
         18008 => (16#DFA9#, 16#0000#, 16#0000#),
         18009 => (16#FB40#, 16#0020#, 16#0002#),
         18010 => (16#CE0D#, 16#0000#, 16#0000#),
         18011 => (16#FB40#, 16#0020#, 16#0002#),
         18012 => (16#ECCC#, 16#0000#, 16#0000#),
         18013 => (16#FB40#, 16#0020#, 16#0002#),
         18014 => (16#E578#, 16#0000#, 16#0000#),
         18015 => (16#FB40#, 16#0020#, 16#0002#),
         18016 => (16#FD22#, 16#0000#, 16#0000#),
         18017 => (16#FB40#, 16#0020#, 16#0002#),
         18018 => (16#D3C3#, 16#0000#, 16#0000#),
         18019 => (16#FB40#, 16#0020#, 16#0002#),
         18020 => (16#D85E#, 16#0000#, 16#0000#),
         18021 => (16#FB40#, 16#0020#, 16#0002#),
         18022 => (16#F701#, 16#0000#, 16#0000#),
         18023 => (16#FB41#, 16#0020#, 16#0002#),
         18024 => (16#8449#, 16#0000#, 16#0000#),
         18025 => (16#FB41#, 16#0020#, 16#0002#),
         18026 => (16#8AAA#, 16#0000#, 16#0000#),
         18027 => (16#FB40#, 16#0020#, 16#0002#),
         18028 => (16#EBBA#, 16#0000#, 16#0000#),
         18029 => (16#FB41#, 16#0020#, 16#0002#),
         18030 => (16#8FB0#, 16#0000#, 16#0000#),
         18031 => (16#FB40#, 16#0020#, 16#0002#),
         18032 => (16#EC88#, 16#0000#, 16#0000#),
         18033 => (16#FB40#, 16#0020#, 16#0002#),
         18034 => (16#E2FE#, 16#0000#, 16#0000#),
         18035 => (16#FB41#, 16#0020#, 16#0002#),
         18036 => (16#82E5#, 16#0000#, 16#0000#),
         18037 => (16#FB40#, 16#0020#, 16#0002#),
         18038 => (16#E3A0#, 16#0000#, 16#0000#),
         18039 => (16#FB40#, 16#0020#, 16#0002#),
         18040 => (16#F565#, 16#0000#, 16#0000#),
         18041 => (16#FB40#, 16#0020#, 16#0002#),
         18042 => (16#CEAE#, 16#0000#, 16#0000#),
         18043 => (16#FB40#, 16#0020#, 16#0002#),
         18044 => (16#D169#, 16#0000#, 16#0000#),
         18045 => (16#FB40#, 16#0020#, 16#0002#),
         18046 => (16#D1C9#, 16#0000#, 16#0000#),
         18047 => (16#FB40#, 16#0020#, 16#0002#),
         18048 => (16#E881#, 16#0000#, 16#0000#),
         18049 => (16#FB40#, 16#0020#, 16#0002#),
         18050 => (16#FCE7#, 16#0000#, 16#0000#),
         18051 => (16#FB41#, 16#0020#, 16#0002#),
         18052 => (16#826F#, 16#0000#, 16#0000#),
         18053 => (16#FB41#, 16#0020#, 16#0002#),
         18054 => (16#8AD2#, 16#0000#, 16#0000#),
         18055 => (16#FB41#, 16#0020#, 16#0002#),
         18056 => (16#91CF#, 16#0000#, 16#0000#),
         18057 => (16#FB40#, 16#0020#, 16#0002#),
         18058 => (16#D2F5#, 16#0000#, 16#0000#),
         18059 => (16#FB40#, 16#0020#, 16#0002#),
         18060 => (16#D442#, 16#0000#, 16#0000#),
         18061 => (16#FB40#, 16#0020#, 16#0002#),
         18062 => (16#D973#, 16#0000#, 16#0000#),
         18063 => (16#FB40#, 16#0020#, 16#0002#),
         18064 => (16#DEEC#, 16#0000#, 16#0000#),
         18065 => (16#FB40#, 16#0020#, 16#0002#),
         18066 => (16#E5C5#, 16#0000#, 16#0000#),
         18067 => (16#FB40#, 16#0020#, 16#0002#),
         18068 => (16#EFFE#, 16#0000#, 16#0000#),
         18069 => (16#FB40#, 16#0020#, 16#0002#),
         18070 => (16#F92A#, 16#0000#, 16#0000#),
         18071 => (16#FB41#, 16#0020#, 16#0002#),
         18072 => (16#95AD#, 16#0000#, 16#0000#),
         18073 => (16#FB41#, 16#0020#, 16#0002#),
         18074 => (16#9A6A#, 16#0000#, 16#0000#),
         18075 => (16#FB41#, 16#0020#, 16#0002#),
         18076 => (16#9E97#, 16#0000#, 16#0000#),
         18077 => (16#FB41#, 16#0020#, 16#0002#),
         18078 => (16#9ECE#, 16#0000#, 16#0000#),
         18079 => (16#FB40#, 16#0020#, 16#0002#),
         18080 => (16#D29B#, 16#0000#, 16#0000#),
         18081 => (16#FB40#, 16#0020#, 16#0002#),
         18082 => (16#E6C6#, 16#0000#, 16#0000#),
         18083 => (16#FB40#, 16#0020#, 16#0002#),
         18084 => (16#EB77#, 16#0000#, 16#0000#),
         18085 => (16#FB41#, 16#0020#, 16#0002#),
         18086 => (16#8F62#, 16#0000#, 16#0000#),
         18087 => (16#FB40#, 16#0020#, 16#0002#),
         18088 => (16#DE74#, 16#0000#, 16#0000#),
         18089 => (16#FB40#, 16#0020#, 16#0002#),
         18090 => (16#E190#, 16#0000#, 16#0000#),
         18091 => (16#FB40#, 16#0020#, 16#0002#),
         18092 => (16#E200#, 16#0000#, 16#0000#),
         18093 => (16#FB40#, 16#0020#, 16#0002#),
         18094 => (16#E49A#, 16#0000#, 16#0000#),
         18095 => (16#FB40#, 16#0020#, 16#0002#),
         18096 => (16#EF23#, 16#0000#, 16#0000#),
         18097 => (16#FB40#, 16#0020#, 16#0002#),
         18098 => (16#F149#, 16#0000#, 16#0000#),
         18099 => (16#FB40#, 16#0020#, 16#0002#),
         18100 => (16#F489#, 16#0000#, 16#0000#),
         18101 => (16#FB40#, 16#0020#, 16#0002#),
         18102 => (16#F9CA#, 16#0000#, 16#0000#),
         18103 => (16#FB40#, 16#0020#, 16#0002#),
         18104 => (16#FDF4#, 16#0000#, 16#0000#),
         18105 => (16#FB41#, 16#0020#, 16#0002#),
         18106 => (16#806F#, 16#0000#, 16#0000#),
         18107 => (16#FB41#, 16#0020#, 16#0002#),
         18108 => (16#8F26#, 16#0000#, 16#0000#),
         18109 => (16#FB41#, 16#0020#, 16#0002#),
         18110 => (16#84EE#, 16#0000#, 16#0000#),
         18111 => (16#FB41#, 16#0020#, 16#0002#),
         18112 => (16#9023#, 16#0000#, 16#0000#),
         18113 => (16#FB41#, 16#0020#, 16#0002#),
         18114 => (16#934A#, 16#0000#, 16#0000#),
         18115 => (16#FB40#, 16#0020#, 16#0002#),
         18116 => (16#D217#, 16#0000#, 16#0000#),
         18117 => (16#FB40#, 16#0020#, 16#0002#),
         18118 => (16#D2A3#, 16#0000#, 16#0000#),
         18119 => (16#FB40#, 16#0020#, 16#0002#),
         18120 => (16#D4BD#, 16#0000#, 16#0000#),
         18121 => (16#FB40#, 16#0020#, 16#0002#),
         18122 => (16#F0C8#, 16#0000#, 16#0000#),
         18123 => (16#FB41#, 16#0020#, 16#0002#),
         18124 => (16#88C2#, 16#0000#, 16#0000#),
         18125 => (16#FB40#, 16#0020#, 16#0002#),
         18126 => (16#DEC9#, 16#0000#, 16#0000#),
         18127 => (16#FB40#, 16#0020#, 16#0002#),
         18128 => (16#DFF5#, 16#0000#, 16#0000#),
         18129 => (16#FB40#, 16#0020#, 16#0002#),
         18130 => (16#E37B#, 16#0000#, 16#0000#),
         18131 => (16#FB40#, 16#0020#, 16#0002#),
         18132 => (16#EBAE#, 16#0000#, 16#0000#),
         18133 => (16#FB40#, 16#0020#, 16#0002#),
         18134 => (16#FC3E#, 16#0000#, 16#0000#),
         18135 => (16#FB40#, 16#0020#, 16#0002#),
         18136 => (16#F375#, 16#0000#, 16#0000#),
         18137 => (16#FB40#, 16#0020#, 16#0002#),
         18138 => (16#CEE4#, 16#0000#, 16#0000#),
         18139 => (16#FB40#, 16#0020#, 16#0002#),
         18140 => (16#D6F9#, 16#0000#, 16#0000#),
         18141 => (16#FB40#, 16#0020#, 16#0002#),
         18142 => (16#DDBA#, 16#0000#, 16#0000#),
         18143 => (16#FB40#, 16#0020#, 16#0002#),
         18144 => (16#E01C#, 16#0000#, 16#0000#),
         18145 => (16#FB40#, 16#0020#, 16#0002#),
         18146 => (16#F3B2#, 16#0000#, 16#0000#),
         18147 => (16#FB40#, 16#0020#, 16#0002#),
         18148 => (16#F469#, 16#0000#, 16#0000#),
         18149 => (16#FB40#, 16#0020#, 16#0002#),
         18150 => (16#FF9A#, 16#0000#, 16#0000#),
         18151 => (16#FB41#, 16#0020#, 16#0002#),
         18152 => (16#8046#, 16#0000#, 16#0000#),
         18153 => (16#FB41#, 16#0020#, 16#0002#),
         18154 => (16#9234#, 16#0000#, 16#0000#),
         18155 => (16#FB41#, 16#0020#, 16#0002#),
         18156 => (16#96F6#, 16#0000#, 16#0000#),
         18157 => (16#FB41#, 16#0020#, 16#0002#),
         18158 => (16#9748#, 16#0000#, 16#0000#),
         18159 => (16#FB41#, 16#0020#, 16#0002#),
         18160 => (16#9818#, 16#0000#, 16#0000#),
         18161 => (16#FB40#, 16#0020#, 16#0002#),
         18162 => (16#CF8B#, 16#0000#, 16#0000#),
         18163 => (16#FB40#, 16#0020#, 16#0002#),
         18164 => (16#F9AE#, 16#0000#, 16#0000#),
         18165 => (16#FB41#, 16#0020#, 16#0002#),
         18166 => (16#91B4#, 16#0000#, 16#0000#),
         18167 => (16#FB41#, 16#0020#, 16#0002#),
         18168 => (16#96B8#, 16#0000#, 16#0000#),
         18169 => (16#FB40#, 16#0020#, 16#0002#),
         18170 => (16#E0E1#, 16#0000#, 16#0000#),
         18171 => (16#FB40#, 16#0020#, 16#0002#),
         18172 => (16#CE86#, 16#0000#, 16#0000#),
         18173 => (16#FB40#, 16#0020#, 16#0002#),
         18174 => (16#D0DA#, 16#0000#, 16#0000#),
         18175 => (16#FB40#, 16#0020#, 16#0002#),
         18176 => (16#DBEE#, 16#0000#, 16#0000#),
         18177 => (16#FB40#, 16#0020#, 16#0002#),
         18178 => (16#DC3F#, 16#0000#, 16#0000#),
         18179 => (16#FB40#, 16#0020#, 16#0002#),
         18180 => (16#E599#, 16#0000#, 16#0000#),
         18181 => (16#FB40#, 16#0020#, 16#0002#),
         18182 => (16#F1CE#, 16#0000#, 16#0000#),
         18183 => (16#FB40#, 16#0020#, 16#0002#),
         18184 => (16#F642#, 16#0000#, 16#0000#),
         18185 => (16#FB41#, 16#0020#, 16#0002#),
         18186 => (16#84FC#, 16#0000#, 16#0000#),
         18187 => (16#FB41#, 16#0020#, 16#0002#),
         18188 => (16#907C#, 16#0000#, 16#0000#),
         18189 => (16#FB41#, 16#0020#, 16#0002#),
         18190 => (16#9F8D#, 16#0000#, 16#0000#),
         18191 => (16#FB40#, 16#0020#, 16#0002#),
         18192 => (16#E688#, 16#0000#, 16#0000#),
         18193 => (16#FB41#, 16#0020#, 16#0002#),
         18194 => (16#962E#, 16#0000#, 16#0000#),
         18195 => (16#FB40#, 16#0020#, 16#0002#),
         18196 => (16#D289#, 16#0000#, 16#0000#),
         18197 => (16#FB40#, 16#0020#, 16#0002#),
         18198 => (16#E77B#, 16#0000#, 16#0000#),
         18199 => (16#FB40#, 16#0020#, 16#0002#),
         18200 => (16#E7F3#, 16#0000#, 16#0000#),
         18201 => (16#FB40#, 16#0020#, 16#0002#),
         18202 => (16#ED41#, 16#0000#, 16#0000#),
         18203 => (16#FB40#, 16#0020#, 16#0002#),
         18204 => (16#EE9C#, 16#0000#, 16#0000#),
         18205 => (16#FB40#, 16#0020#, 16#0002#),
         18206 => (16#F409#, 16#0000#, 16#0000#),
         18207 => (16#FB40#, 16#0020#, 16#0002#),
         18208 => (16#F559#, 16#0000#, 16#0000#),
         18209 => (16#FB40#, 16#0020#, 16#0002#),
         18210 => (16#F86B#, 16#0000#, 16#0000#),
         18211 => (16#FB40#, 16#0020#, 16#0002#),
         18212 => (16#FD10#, 16#0000#, 16#0000#),
         18213 => (16#FB41#, 16#0020#, 16#0002#),
         18214 => (16#985E#, 16#0000#, 16#0000#),
         18215 => (16#FB40#, 16#0020#, 16#0002#),
         18216 => (16#D16D#, 16#0000#, 16#0000#),
         18217 => (16#FB40#, 16#0020#, 16#0002#),
         18218 => (16#E22E#, 16#0000#, 16#0000#),
         18219 => (16#FB41#, 16#0020#, 16#0002#),
         18220 => (16#9678#, 16#0000#, 16#0000#),
         18221 => (16#FB40#, 16#0020#, 16#0002#),
         18222 => (16#D02B#, 16#0000#, 16#0000#),
         18223 => (16#FB40#, 16#0020#, 16#0002#),
         18224 => (16#DD19#, 16#0000#, 16#0000#),
         18225 => (16#FB40#, 16#0020#, 16#0002#),
         18226 => (16#EDEA#, 16#0000#, 16#0000#),
         18227 => (16#FB41#, 16#0020#, 16#0002#),
         18228 => (16#8F2A#, 16#0000#, 16#0000#),
         18229 => (16#FB40#, 16#0020#, 16#0002#),
         18230 => (16#DF8B#, 16#0000#, 16#0000#),
         18231 => (16#FB40#, 16#0020#, 16#0002#),
         18232 => (16#E144#, 16#0000#, 16#0000#),
         18233 => (16#FB40#, 16#0020#, 16#0002#),
         18234 => (16#E817#, 16#0000#, 16#0000#),
         18235 => (16#FB41#, 16#0020#, 16#0002#),
         18236 => (16#9686#, 16#0000#, 16#0000#),
         18237 => (16#FB40#, 16#0020#, 16#0002#),
         18238 => (16#D229#, 16#0000#, 16#0000#),
         18239 => (16#FB40#, 16#0020#, 16#0002#),
         18240 => (16#D40F#, 16#0000#, 16#0000#),
         18241 => (16#FB40#, 16#0020#, 16#0002#),
         18242 => (16#DC65#, 16#0000#, 16#0000#),
         18243 => (16#FB40#, 16#0020#, 16#0002#),
         18244 => (16#E613#, 16#0000#, 16#0000#),
         18245 => (16#FB40#, 16#0020#, 16#0002#),
         18246 => (16#E74E#, 16#0000#, 16#0000#),
         18247 => (16#FB40#, 16#0020#, 16#0002#),
         18248 => (16#E8A8#, 16#0000#, 16#0000#),
         18249 => (16#FB40#, 16#0020#, 16#0002#),
         18250 => (16#ECE5#, 16#0000#, 16#0000#),
         18251 => (16#FB40#, 16#0020#, 16#0002#),
         18252 => (16#F406#, 16#0000#, 16#0000#),
         18253 => (16#FB40#, 16#0020#, 16#0002#),
         18254 => (16#F5E2#, 16#0000#, 16#0000#),
         18255 => (16#FB40#, 16#0020#, 16#0002#),
         18256 => (16#FF79#, 16#0000#, 16#0000#),
         18257 => (16#FB41#, 16#0020#, 16#0002#),
         18258 => (16#88CF#, 16#0000#, 16#0000#),
         18259 => (16#FB41#, 16#0020#, 16#0002#),
         18260 => (16#88E1#, 16#0000#, 16#0000#),
         18261 => (16#FB41#, 16#0020#, 16#0002#),
         18262 => (16#91CC#, 16#0000#, 16#0000#),
         18263 => (16#FB41#, 16#0020#, 16#0002#),
         18264 => (16#96E2#, 16#0000#, 16#0000#),
         18265 => (16#FB40#, 16#0020#, 16#0002#),
         18266 => (16#D33F#, 16#0000#, 16#0000#),
         18267 => (16#FB40#, 16#0020#, 16#0002#),
         18268 => (16#EEBA#, 16#0000#, 16#0000#),
         18269 => (16#FB40#, 16#0020#, 16#0002#),
         18270 => (16#D41D#, 16#0000#, 16#0000#),
         18271 => (16#FB40#, 16#0020#, 16#0002#),
         18272 => (16#F1D0#, 16#0000#, 16#0000#),
         18273 => (16#FB40#, 16#0020#, 16#0002#),
         18274 => (16#F498#, 16#0000#, 16#0000#),
         18275 => (16#FB41#, 16#0020#, 16#0002#),
         18276 => (16#85FA#, 16#0000#, 16#0000#),
         18277 => (16#FB41#, 16#0020#, 16#0002#),
         18278 => (16#96A3#, 16#0000#, 16#0000#),
         18279 => (16#FB41#, 16#0020#, 16#0002#),
         18280 => (16#9C57#, 16#0000#, 16#0000#),
         18281 => (16#FB41#, 16#0020#, 16#0002#),
         18282 => (16#9E9F#, 16#0000#, 16#0000#),
         18283 => (16#FB40#, 16#0020#, 16#0002#),
         18284 => (16#E797#, 16#0000#, 16#0000#),
         18285 => (16#FB40#, 16#0020#, 16#0002#),
         18286 => (16#EDCB#, 16#0000#, 16#0000#),
         18287 => (16#FB41#, 16#0020#, 16#0002#),
         18288 => (16#81E8#, 16#0000#, 16#0000#),
         18289 => (16#FB40#, 16#0020#, 16#0002#),
         18290 => (16#FACB#, 16#0000#, 16#0000#),
         18291 => (16#FB40#, 16#0020#, 16#0002#),
         18292 => (16#FB20#, 16#0000#, 16#0000#),
         18293 => (16#FB40#, 16#0020#, 16#0002#),
         18294 => (16#FC92#, 16#0000#, 16#0000#),
         18295 => (16#FB40#, 16#0020#, 16#0002#),
         18296 => (16#F2C0#, 16#0000#, 16#0000#),
         18297 => (16#FB40#, 16#0020#, 16#0002#),
         18298 => (16#F099#, 16#0000#, 16#0000#),
         18299 => (16#FB41#, 16#0020#, 16#0002#),
         18300 => (16#8B58#, 16#0000#, 16#0000#),
         18301 => (16#FB40#, 16#0020#, 16#0002#),
         18302 => (16#CEC0#, 16#0000#, 16#0000#),
         18303 => (16#FB41#, 16#0020#, 16#0002#),
         18304 => (16#8336#, 16#0000#, 16#0000#),
         18305 => (16#FB40#, 16#0020#, 16#0002#),
         18306 => (16#D23A#, 16#0000#, 16#0000#),
         18307 => (16#FB40#, 16#0020#, 16#0002#),
         18308 => (16#D207#, 16#0000#, 16#0000#),
         18309 => (16#FB40#, 16#0020#, 16#0002#),
         18310 => (16#DEA6#, 16#0000#, 16#0000#),
         18311 => (16#FB40#, 16#0020#, 16#0002#),
         18312 => (16#E2D3#, 16#0000#, 16#0000#),
         18313 => (16#FB40#, 16#0020#, 16#0002#),
         18314 => (16#FCD6#, 16#0000#, 16#0000#),
         18315 => (16#FB40#, 16#0020#, 16#0002#),
         18316 => (16#DB85#, 16#0000#, 16#0000#),
         18317 => (16#FB40#, 16#0020#, 16#0002#),
         18318 => (16#ED1E#, 16#0000#, 16#0000#),
         18319 => (16#FB40#, 16#0020#, 16#0002#),
         18320 => (16#E6B4#, 16#0000#, 16#0000#),
         18321 => (16#FB41#, 16#0020#, 16#0002#),
         18322 => (16#8F3B#, 16#0000#, 16#0000#),
         18323 => (16#FB41#, 16#0020#, 16#0002#),
         18324 => (16#884C#, 16#0000#, 16#0000#),
         18325 => (16#FB41#, 16#0020#, 16#0002#),
         18326 => (16#964D#, 16#0000#, 16#0000#),
         18327 => (16#FB41#, 16#0020#, 16#0002#),
         18328 => (16#898B#, 16#0000#, 16#0000#),
         18329 => (16#FB40#, 16#0020#, 16#0002#),
         18330 => (16#DED3#, 16#0000#, 16#0000#),
         18331 => (16#FB40#, 16#0020#, 16#0002#),
         18332 => (16#D140#, 16#0000#, 16#0000#),
         18333 => (16#FB40#, 16#0020#, 16#0002#),
         18334 => (16#D5C0#, 16#0000#, 16#0000#),
         18335 => (16#FB41#, 16#0020#, 16#0002#),
         18336 => (16#FA0E#, 16#0000#, 16#0000#),
         18337 => (16#FB41#, 16#0020#, 16#0002#),
         18338 => (16#FA0F#, 16#0000#, 16#0000#),
         18339 => (16#FB40#, 16#0020#, 16#0002#),
         18340 => (16#D85A#, 16#0000#, 16#0000#),
         18341 => (16#FB41#, 16#0020#, 16#0002#),
         18342 => (16#FA11#, 16#0000#, 16#0000#),
         18343 => (16#FB40#, 16#0020#, 16#0002#),
         18344 => (16#E674#, 16#0000#, 16#0000#),
         18345 => (16#FB41#, 16#0020#, 16#0002#),
         18346 => (16#FA13#, 16#0000#, 16#0000#),
         18347 => (16#FB41#, 16#0020#, 16#0002#),
         18348 => (16#FA14#, 16#0000#, 16#0000#),
         18349 => (16#FB40#, 16#0020#, 16#0002#),
         18350 => (16#D1DE#, 16#0000#, 16#0000#),
         18351 => (16#FB40#, 16#0020#, 16#0002#),
         18352 => (16#F32A#, 16#0000#, 16#0000#),
         18353 => (16#FB40#, 16#0020#, 16#0002#),
         18354 => (16#F6CA#, 16#0000#, 16#0000#),
         18355 => (16#FB40#, 16#0020#, 16#0002#),
         18356 => (16#F93C#, 16#0000#, 16#0000#),
         18357 => (16#FB40#, 16#0020#, 16#0002#),
         18358 => (16#F95E#, 16#0000#, 16#0000#),
         18359 => (16#FB40#, 16#0020#, 16#0002#),
         18360 => (16#F965#, 16#0000#, 16#0000#),
         18361 => (16#FB40#, 16#0020#, 16#0002#),
         18362 => (16#F98F#, 16#0000#, 16#0000#),
         18363 => (16#FB41#, 16#0020#, 16#0002#),
         18364 => (16#9756#, 16#0000#, 16#0000#),
         18365 => (16#FB40#, 16#0020#, 16#0002#),
         18366 => (16#FCBE#, 16#0000#, 16#0000#),
         18367 => (16#FB40#, 16#0020#, 16#0002#),
         18368 => (16#FFBD#, 16#0000#, 16#0000#),
         18369 => (16#FB41#, 16#0020#, 16#0002#),
         18370 => (16#FA1F#, 16#0000#, 16#0000#),
         18371 => (16#FB41#, 16#0020#, 16#0002#),
         18372 => (16#8612#, 16#0000#, 16#0000#),
         18373 => (16#FB41#, 16#0020#, 16#0002#),
         18374 => (16#FA21#, 16#0000#, 16#0000#),
         18375 => (16#FB41#, 16#0020#, 16#0002#),
         18376 => (16#8AF8#, 16#0000#, 16#0000#),
         18377 => (16#FB41#, 16#0020#, 16#0002#),
         18378 => (16#FA23#, 16#0000#, 16#0000#),
         18379 => (16#FB41#, 16#0020#, 16#0002#),
         18380 => (16#FA24#, 16#0000#, 16#0000#),
         18381 => (16#FB41#, 16#0020#, 16#0002#),
         18382 => (16#9038#, 16#0000#, 16#0000#),
         18383 => (16#FB41#, 16#0020#, 16#0002#),
         18384 => (16#90FD#, 16#0000#, 16#0000#),
         18385 => (16#FB41#, 16#0020#, 16#0002#),
         18386 => (16#FA27#, 16#0000#, 16#0000#),
         18387 => (16#FB41#, 16#0020#, 16#0002#),
         18388 => (16#FA28#, 16#0000#, 16#0000#),
         18389 => (16#FB41#, 16#0020#, 16#0002#),
         18390 => (16#FA29#, 16#0000#, 16#0000#),
         18391 => (16#FB41#, 16#0020#, 16#0002#),
         18392 => (16#98EF#, 16#0000#, 16#0000#),
         18393 => (16#FB41#, 16#0020#, 16#0002#),
         18394 => (16#98FC#, 16#0000#, 16#0000#),
         18395 => (16#FB41#, 16#0020#, 16#0002#),
         18396 => (16#9928#, 16#0000#, 16#0000#),
         18397 => (16#FB41#, 16#0020#, 16#0002#),
         18398 => (16#9DB4#, 16#0000#, 16#0000#),
         18399 => (16#FB41#, 16#0020#, 16#0002#),
         18400 => (16#90DE#, 16#0000#, 16#0000#),
         18401 => (16#FB41#, 16#0020#, 16#0002#),
         18402 => (16#96B7#, 16#0000#, 16#0000#),
         18403 => (16#FB40#, 16#0020#, 16#0002#),
         18404 => (16#CFAE#, 16#0000#, 16#0000#),
         18405 => (16#FB40#, 16#0020#, 16#0002#),
         18406 => (16#D0E7#, 16#0000#, 16#0000#),
         18407 => (16#FB40#, 16#0020#, 16#0002#),
         18408 => (16#D14D#, 16#0000#, 16#0000#),
         18409 => (16#FB40#, 16#0020#, 16#0002#),
         18410 => (16#D2C9#, 16#0000#, 16#0000#),
         18411 => (16#FB40#, 16#0020#, 16#0002#),
         18412 => (16#D2E4#, 16#0000#, 16#0000#),
         18413 => (16#FB40#, 16#0020#, 16#0002#),
         18414 => (16#D351#, 16#0000#, 16#0000#),
         18415 => (16#FB40#, 16#0020#, 16#0002#),
         18416 => (16#D59D#, 16#0000#, 16#0000#),
         18417 => (16#FB40#, 16#0020#, 16#0002#),
         18418 => (16#D606#, 16#0000#, 16#0000#),
         18419 => (16#FB40#, 16#0020#, 16#0002#),
         18420 => (16#D668#, 16#0000#, 16#0000#),
         18421 => (16#FB40#, 16#0020#, 16#0002#),
         18422 => (16#D840#, 16#0000#, 16#0000#),
         18423 => (16#FB40#, 16#0020#, 16#0002#),
         18424 => (16#D8A8#, 16#0000#, 16#0000#),
         18425 => (16#FB40#, 16#0020#, 16#0002#),
         18426 => (16#DC64#, 16#0000#, 16#0000#),
         18427 => (16#FB40#, 16#0020#, 16#0002#),
         18428 => (16#DC6E#, 16#0000#, 16#0000#),
         18429 => (16#FB40#, 16#0020#, 16#0002#),
         18430 => (16#E094#, 16#0000#, 16#0000#),
         18431 => (16#FB40#, 16#0020#, 16#0002#),
         18432 => (16#E168#, 16#0000#, 16#0000#),
         18433 => (16#FB40#, 16#0020#, 16#0002#),
         18434 => (16#E18E#, 16#0000#, 16#0000#),
         18435 => (16#FB40#, 16#0020#, 16#0002#),
         18436 => (16#E1F2#, 16#0000#, 16#0000#),
         18437 => (16#FB40#, 16#0020#, 16#0002#),
         18438 => (16#E54F#, 16#0000#, 16#0000#),
         18439 => (16#FB40#, 16#0020#, 16#0002#),
         18440 => (16#E5E2#, 16#0000#, 16#0000#),
         18441 => (16#FB40#, 16#0020#, 16#0002#),
         18442 => (16#E691#, 16#0000#, 16#0000#),
         18443 => (16#FB40#, 16#0020#, 16#0002#),
         18444 => (16#E885#, 16#0000#, 16#0000#),
         18445 => (16#FB40#, 16#0020#, 16#0002#),
         18446 => (16#ED77#, 16#0000#, 16#0000#),
         18447 => (16#FB40#, 16#0020#, 16#0002#),
         18448 => (16#EE1A#, 16#0000#, 16#0000#),
         18449 => (16#FB40#, 16#0020#, 16#0002#),
         18450 => (16#EF22#, 16#0000#, 16#0000#),
         18451 => (16#FB40#, 16#0020#, 16#0002#),
         18452 => (16#F16E#, 16#0000#, 16#0000#),
         18453 => (16#FB40#, 16#0020#, 16#0002#),
         18454 => (16#F22B#, 16#0000#, 16#0000#),
         18455 => (16#FB40#, 16#0020#, 16#0002#),
         18456 => (16#F422#, 16#0000#, 16#0000#),
         18457 => (16#FB40#, 16#0020#, 16#0002#),
         18458 => (16#F891#, 16#0000#, 16#0000#),
         18459 => (16#FB40#, 16#0020#, 16#0002#),
         18460 => (16#F93E#, 16#0000#, 16#0000#),
         18461 => (16#FB40#, 16#0020#, 16#0002#),
         18462 => (16#F949#, 16#0000#, 16#0000#),
         18463 => (16#FB40#, 16#0020#, 16#0002#),
         18464 => (16#F948#, 16#0000#, 16#0000#),
         18465 => (16#FB40#, 16#0020#, 16#0002#),
         18466 => (16#F950#, 16#0000#, 16#0000#),
         18467 => (16#FB40#, 16#0020#, 16#0002#),
         18468 => (16#F956#, 16#0000#, 16#0000#),
         18469 => (16#FB40#, 16#0020#, 16#0002#),
         18470 => (16#F95D#, 16#0000#, 16#0000#),
         18471 => (16#FB40#, 16#0020#, 16#0002#),
         18472 => (16#F98D#, 16#0000#, 16#0000#),
         18473 => (16#FB40#, 16#0020#, 16#0002#),
         18474 => (16#F98E#, 16#0000#, 16#0000#),
         18475 => (16#FB40#, 16#0020#, 16#0002#),
         18476 => (16#FA40#, 16#0000#, 16#0000#),
         18477 => (16#FB40#, 16#0020#, 16#0002#),
         18478 => (16#FA81#, 16#0000#, 16#0000#),
         18479 => (16#FB40#, 16#0020#, 16#0002#),
         18480 => (16#FBC0#, 16#0000#, 16#0000#),
         18481 => (16#FB40#, 16#0020#, 16#0002#),
         18482 => (16#FE09#, 16#0000#, 16#0000#),
         18483 => (16#FB40#, 16#0020#, 16#0002#),
         18484 => (16#FE41#, 16#0000#, 16#0000#),
         18485 => (16#FB40#, 16#0020#, 16#0002#),
         18486 => (16#FF72#, 16#0000#, 16#0000#),
         18487 => (16#FB41#, 16#0020#, 16#0002#),
         18488 => (16#8005#, 16#0000#, 16#0000#),
         18489 => (16#FB41#, 16#0020#, 16#0002#),
         18490 => (16#81ED#, 16#0000#, 16#0000#),
         18491 => (16#FB41#, 16#0020#, 16#0002#),
         18492 => (16#8279#, 16#0000#, 16#0000#),
         18493 => (16#FB41#, 16#0020#, 16#0002#),
         18494 => (16#8457#, 16#0000#, 16#0000#),
         18495 => (16#FB41#, 16#0020#, 16#0002#),
         18496 => (16#8910#, 16#0000#, 16#0000#),
         18497 => (16#FB41#, 16#0020#, 16#0002#),
         18498 => (16#8996#, 16#0000#, 16#0000#),
         18499 => (16#FB41#, 16#0020#, 16#0002#),
         18500 => (16#8B01#, 16#0000#, 16#0000#),
         18501 => (16#FB41#, 16#0020#, 16#0002#),
         18502 => (16#8B39#, 16#0000#, 16#0000#),
         18503 => (16#FB41#, 16#0020#, 16#0002#),
         18504 => (16#8CD3#, 16#0000#, 16#0000#),
         18505 => (16#FB41#, 16#0020#, 16#0002#),
         18506 => (16#8D08#, 16#0000#, 16#0000#),
         18507 => (16#FB41#, 16#0020#, 16#0002#),
         18508 => (16#8FB6#, 16#0000#, 16#0000#),
         18509 => (16#FB41#, 16#0020#, 16#0002#),
         18510 => (16#96E3#, 16#0000#, 16#0000#),
         18511 => (16#FB41#, 16#0020#, 16#0002#),
         18512 => (16#97FF#, 16#0000#, 16#0000#),
         18513 => (16#FB41#, 16#0020#, 16#0002#),
         18514 => (16#983B#, 16#0000#, 16#0000#),
         18515 => (16#FB40#, 16#0020#, 16#0002#),
         18516 => (16#E075#, 16#0000#, 16#0000#),
         18517 => (16#FB84#, 16#0020#, 16#0002#),
         18518 => (16#C2EE#, 16#0000#, 16#0000#),
         18519 => (16#FB41#, 16#0020#, 16#0002#),
         18520 => (16#8218#, 16#0000#, 16#0000#),
         18521 => (16#FB40#, 16#0020#, 16#0002#),
         18522 => (16#CE26#, 16#0000#, 16#0000#),
         18523 => (16#FB40#, 16#0020#, 16#0002#),
         18524 => (16#D1B5#, 16#0000#, 16#0000#),
         18525 => (16#FB40#, 16#0020#, 16#0002#),
         18526 => (16#D168#, 16#0000#, 16#0000#),
         18527 => (16#FB40#, 16#0020#, 16#0002#),
         18528 => (16#CF80#, 16#0000#, 16#0000#),
         18529 => (16#FB40#, 16#0020#, 16#0002#),
         18530 => (16#D145#, 16#0000#, 16#0000#),
         18531 => (16#FB40#, 16#0020#, 16#0002#),
         18532 => (16#D180#, 16#0000#, 16#0000#),
         18533 => (16#FB40#, 16#0020#, 16#0002#),
         18534 => (16#D2C7#, 16#0000#, 16#0000#),
         18535 => (16#FB40#, 16#0020#, 16#0002#),
         18536 => (16#D2FA#, 16#0000#, 16#0000#),
         18537 => (16#FB40#, 16#0020#, 16#0002#),
         18538 => (16#D555#, 16#0000#, 16#0000#),
         18539 => (16#FB40#, 16#0020#, 16#0002#),
         18540 => (16#D599#, 16#0000#, 16#0000#),
         18541 => (16#FB40#, 16#0020#, 16#0002#),
         18542 => (16#D5E2#, 16#0000#, 16#0000#),
         18543 => (16#FB40#, 16#0020#, 16#0002#),
         18544 => (16#D8B3#, 16#0000#, 16#0000#),
         18545 => (16#FB40#, 16#0020#, 16#0002#),
         18546 => (16#D944#, 16#0000#, 16#0000#),
         18547 => (16#FB40#, 16#0020#, 16#0002#),
         18548 => (16#D954#, 16#0000#, 16#0000#),
         18549 => (16#FB40#, 16#0020#, 16#0002#),
         18550 => (16#DA62#, 16#0000#, 16#0000#),
         18551 => (16#FB40#, 16#0020#, 16#0002#),
         18552 => (16#DB28#, 16#0000#, 16#0000#),
         18553 => (16#FB40#, 16#0020#, 16#0002#),
         18554 => (16#DED2#, 16#0000#, 16#0000#),
         18555 => (16#FB40#, 16#0020#, 16#0002#),
         18556 => (16#DED9#, 16#0000#, 16#0000#),
         18557 => (16#FB40#, 16#0020#, 16#0002#),
         18558 => (16#DF69#, 16#0000#, 16#0000#),
         18559 => (16#FB40#, 16#0020#, 16#0002#),
         18560 => (16#DFAD#, 16#0000#, 16#0000#),
         18561 => (16#FB40#, 16#0020#, 16#0002#),
         18562 => (16#E0D8#, 16#0000#, 16#0000#),
         18563 => (16#FB40#, 16#0020#, 16#0002#),
         18564 => (16#E14E#, 16#0000#, 16#0000#),
         18565 => (16#FB40#, 16#0020#, 16#0002#),
         18566 => (16#E108#, 16#0000#, 16#0000#),
         18567 => (16#FB40#, 16#0020#, 16#0002#),
         18568 => (16#E160#, 16#0000#, 16#0000#),
         18569 => (16#FB40#, 16#0020#, 16#0002#),
         18570 => (16#E234#, 16#0000#, 16#0000#),
         18571 => (16#FB40#, 16#0020#, 16#0002#),
         18572 => (16#E3C4#, 16#0000#, 16#0000#),
         18573 => (16#FB40#, 16#0020#, 16#0002#),
         18574 => (16#E41C#, 16#0000#, 16#0000#),
         18575 => (16#FB40#, 16#0020#, 16#0002#),
         18576 => (16#E452#, 16#0000#, 16#0000#),
         18577 => (16#FB40#, 16#0020#, 16#0002#),
         18578 => (16#E556#, 16#0000#, 16#0000#),
         18579 => (16#FB40#, 16#0020#, 16#0002#),
         18580 => (16#E71B#, 16#0000#, 16#0000#),
         18581 => (16#FB40#, 16#0020#, 16#0002#),
         18582 => (16#E756#, 16#0000#, 16#0000#),
         18583 => (16#FB40#, 16#0020#, 16#0002#),
         18584 => (16#EB79#, 16#0000#, 16#0000#),
         18585 => (16#FB40#, 16#0020#, 16#0002#),
         18586 => (16#EEDB#, 16#0000#, 16#0000#),
         18587 => (16#FB40#, 16#0020#, 16#0002#),
         18588 => (16#EECB#, 16#0000#, 16#0000#),
         18589 => (16#FB40#, 16#0020#, 16#0002#),
         18590 => (16#F01E#, 16#0000#, 16#0000#),
         18591 => (16#FB40#, 16#0020#, 16#0002#),
         18592 => (16#F7A7#, 16#0000#, 16#0000#),
         18593 => (16#FB40#, 16#0020#, 16#0002#),
         18594 => (16#F235#, 16#0000#, 16#0000#),
         18595 => (16#FB40#, 16#0020#, 16#0002#),
         18596 => (16#F2AF#, 16#0000#, 16#0000#),
         18597 => (16#FB40#, 16#0020#, 16#0002#),
         18598 => (16#F471#, 16#0000#, 16#0000#),
         18599 => (16#FB40#, 16#0020#, 16#0002#),
         18600 => (16#F506#, 16#0000#, 16#0000#),
         18601 => (16#FB40#, 16#0020#, 16#0002#),
         18602 => (16#F53B#, 16#0000#, 16#0000#),
         18603 => (16#FB40#, 16#0020#, 16#0002#),
         18604 => (16#F61D#, 16#0000#, 16#0000#),
         18605 => (16#FB40#, 16#0020#, 16#0002#),
         18606 => (16#F61F#, 16#0000#, 16#0000#),
         18607 => (16#FB40#, 16#0020#, 16#0002#),
         18608 => (16#F6DB#, 16#0000#, 16#0000#),
         18609 => (16#FB40#, 16#0020#, 16#0002#),
         18610 => (16#F6F4#, 16#0000#, 16#0000#),
         18611 => (16#FB40#, 16#0020#, 16#0002#),
         18612 => (16#F74A#, 16#0000#, 16#0000#),
         18613 => (16#FB40#, 16#0020#, 16#0002#),
         18614 => (16#F740#, 16#0000#, 16#0000#),
         18615 => (16#FB40#, 16#0020#, 16#0002#),
         18616 => (16#F8CC#, 16#0000#, 16#0000#),
         18617 => (16#FB40#, 16#0020#, 16#0002#),
         18618 => (16#FAB1#, 16#0000#, 16#0000#),
         18619 => (16#FB40#, 16#0020#, 16#0002#),
         18620 => (16#FC7B#, 16#0000#, 16#0000#),
         18621 => (16#FB40#, 16#0020#, 16#0002#),
         18622 => (16#FD5B#, 16#0000#, 16#0000#),
         18623 => (16#FB40#, 16#0020#, 16#0002#),
         18624 => (16#FF3E#, 16#0000#, 16#0000#),
         18625 => (16#FB41#, 16#0020#, 16#0002#),
         18626 => (16#8352#, 16#0000#, 16#0000#),
         18627 => (16#FB41#, 16#0020#, 16#0002#),
         18628 => (16#83EF#, 16#0000#, 16#0000#),
         18629 => (16#FB41#, 16#0020#, 16#0002#),
         18630 => (16#8779#, 16#0000#, 16#0000#),
         18631 => (16#FB41#, 16#0020#, 16#0002#),
         18632 => (16#8941#, 16#0000#, 16#0000#),
         18633 => (16#FB41#, 16#0020#, 16#0002#),
         18634 => (16#8986#, 16#0000#, 16#0000#),
         18635 => (16#FB41#, 16#0020#, 16#0002#),
         18636 => (16#8ABF#, 16#0000#, 16#0000#),
         18637 => (16#FB41#, 16#0020#, 16#0002#),
         18638 => (16#8ACB#, 16#0000#, 16#0000#),
         18639 => (16#FB41#, 16#0020#, 16#0002#),
         18640 => (16#8AED#, 16#0000#, 16#0000#),
         18641 => (16#FB41#, 16#0020#, 16#0002#),
         18642 => (16#8B8A#, 16#0000#, 16#0000#),
         18643 => (16#FB41#, 16#0020#, 16#0002#),
         18644 => (16#8F38#, 16#0000#, 16#0000#),
         18645 => (16#FB41#, 16#0020#, 16#0002#),
         18646 => (16#9072#, 16#0000#, 16#0000#),
         18647 => (16#FB41#, 16#0020#, 16#0002#),
         18648 => (16#9199#, 16#0000#, 16#0000#),
         18649 => (16#FB41#, 16#0020#, 16#0002#),
         18650 => (16#9276#, 16#0000#, 16#0000#),
         18651 => (16#FB41#, 16#0020#, 16#0002#),
         18652 => (16#967C#, 16#0000#, 16#0000#),
         18653 => (16#FB41#, 16#0020#, 16#0002#),
         18654 => (16#97DB#, 16#0000#, 16#0000#),
         18655 => (16#FB41#, 16#0020#, 16#0002#),
         18656 => (16#980B#, 16#0000#, 16#0000#),
         18657 => (16#FB41#, 16#0020#, 16#0002#),
         18658 => (16#9B12#, 16#0000#, 16#0000#),
         18659 => (16#FB84#, 16#0020#, 16#0002#),
         18660 => (16#A84A#, 16#0000#, 16#0000#),
         18661 => (16#FB84#, 16#0020#, 16#0002#),
         18662 => (16#A844#, 16#0000#, 16#0000#),
         18663 => (16#FB84#, 16#0020#, 16#0002#),
         18664 => (16#B3D5#, 16#0000#, 16#0000#),
         18665 => (16#FB80#, 16#0020#, 16#0002#),
         18666 => (16#BB9D#, 16#0000#, 16#0000#),
         18667 => (16#FB80#, 16#0020#, 16#0002#),
         18668 => (16#C018#, 16#0000#, 16#0000#),
         18669 => (16#FB80#, 16#0020#, 16#0002#),
         18670 => (16#C039#, 16#0000#, 16#0000#),
         18671 => (16#FB84#, 16#0020#, 16#0002#),
         18672 => (16#D249#, 16#0000#, 16#0000#),
         18673 => (16#FB84#, 16#0020#, 16#0002#),
         18674 => (16#DCD0#, 16#0000#, 16#0000#),
         18675 => (16#FB84#, 16#0020#, 16#0002#),
         18676 => (16#FED3#, 16#0000#, 16#0000#),
         18677 => (16#FB41#, 16#0020#, 16#0002#),
         18678 => (16#9F43#, 16#0000#, 16#0000#),
         18679 => (16#FB41#, 16#0020#, 16#0002#),
         18680 => (16#9F8E#, 16#0000#, 16#0000#),
         18681 => (16#19A9#, 16#0020#, 16#0004#),
         18682 => (16#19A9#, 16#0020#, 16#0004#),
         18683 => (16#19A9#, 16#0020#, 16#0004#),
         18684 => (16#19F6#, 16#0020#, 16#0004#),
         18685 => (16#19A9#, 16#0020#, 16#0004#),
         18686 => (16#1A3B#, 16#0020#, 16#0004#),
         18687 => (16#19A9#, 16#0020#, 16#0004#),
         18688 => (16#19A9#, 16#0020#, 16#0004#),
         18689 => (16#1A3B#, 16#0020#, 16#0004#),
         18690 => (16#1B33#, 16#0020#, 16#0004#),
         18691 => (16#0000#, 16#0109#, 16#0004#),
         18692 => (16#1B57#, 16#0020#, 16#0004#),
         18693 => (16#1B33#, 16#0020#, 16#0004#),
         18694 => (16#1B57#, 16#0020#, 16#0004#),
         18695 => (16#1F61#, 16#0020#, 16#0004#),
         18696 => (16#1F63#, 16#0020#, 16#0004#),
         18697 => (16#1F61#, 16#0020#, 16#0004#),
         18698 => (16#1F52#, 16#0020#, 16#0004#),
         18699 => (16#1F61#, 16#0020#, 16#0004#),
         18700 => (16#1F58#, 16#0020#, 16#0004#),
         18701 => (16#1F6B#, 16#0020#, 16#0004#),
         18702 => (16#1F63#, 16#0020#, 16#0004#),
         18703 => (16#1F61#, 16#0020#, 16#0004#),
         18704 => (16#1F5A#, 16#0020#, 16#0004#),
         18705 => (16#1F7E#, 16#0020#, 16#0002#),
         18706 => (16#0000#, 16#0056#, 16#0002#),
         18707 => (16#0000#, 16#0061#, 16#0002#),
         18708 => (16#1F7E#, 16#0020#, 16#0004#),
         18709 => (16#1F7E#, 16#0020#, 16#0004#),
         18710 => (16#0000#, 16#0059#, 16#0002#),
         18711 => (16#1F84#, 16#0020#, 16#0005#),
         18712 => (16#1F75#, 16#0020#, 16#0005#),
         18713 => (16#1F78#, 16#0020#, 16#0005#),
         18714 => (16#1F79#, 16#0020#, 16#0005#),
         18715 => (16#1F7F#, 16#0020#, 16#0005#),
         18716 => (16#1F80#, 16#0020#, 16#0005#),
         18717 => (16#1F81#, 16#0020#, 16#0005#),
         18718 => (16#1F88#, 16#0020#, 16#0005#),
         18719 => (16#1F8A#, 16#0020#, 16#0005#),
         18720 => (16#04D6#, 16#0020#, 16#0005#),
         18721 => (16#1F89#, 16#0020#, 16#0002#),
         18722 => (16#0000#, 16#005E#, 16#0002#),
         18723 => (16#1F89#, 16#0020#, 16#0002#),
         18724 => (16#0000#, 16#005D#, 16#0002#),
         18725 => (16#1F89#, 16#0020#, 16#0002#),
         18726 => (16#0000#, 16#005F#, 16#0002#),
         18727 => (16#0000#, 16#005E#, 16#0002#),
         18728 => (16#1F89#, 16#0020#, 16#0002#),
         18729 => (16#0000#, 16#005F#, 16#0002#),
         18730 => (16#0000#, 16#005D#, 16#0002#),
         18731 => (16#1F75#, 16#0020#, 16#0002#),
         18732 => (16#0000#, 16#0059#, 16#0002#),
         18733 => (16#1F75#, 16#0020#, 16#0002#),
         18734 => (16#0000#, 16#005A#, 16#0002#),
         18735 => (16#1F75#, 16#0020#, 16#0002#),
         18736 => (16#0000#, 16#005F#, 16#0002#),
         18737 => (16#1F76#, 16#0020#, 16#0002#),
         18738 => (16#0000#, 16#005F#, 16#0002#),
         18739 => (16#1F77#, 16#0020#, 16#0002#),
         18740 => (16#0000#, 16#005F#, 16#0002#),
         18741 => (16#1F78#, 16#0020#, 16#0002#),
         18742 => (16#0000#, 16#005F#, 16#0002#),
         18743 => (16#1F79#, 16#0020#, 16#0002#),
         18744 => (16#0000#, 16#005F#, 16#0002#),
         18745 => (16#1F7A#, 16#0020#, 16#0002#),
         18746 => (16#0000#, 16#005F#, 16#0002#),
         18747 => (16#1F7B#, 16#0020#, 16#0002#),
         18748 => (16#0000#, 16#005F#, 16#0002#),
         18749 => (16#1F7D#, 16#0020#, 16#0002#),
         18750 => (16#0000#, 16#005F#, 16#0002#),
         18751 => (16#1F7E#, 16#0020#, 16#0002#),
         18752 => (16#0000#, 16#005F#, 16#0002#),
         18753 => (16#1F7F#, 16#0020#, 16#0019#),
         18754 => (16#0000#, 16#005F#, 16#0002#),
         18755 => (16#1F7F#, 16#0020#, 16#0002#),
         18756 => (16#0000#, 16#005F#, 16#0002#),
         18757 => (16#1F80#, 16#0020#, 16#0002#),
         18758 => (16#0000#, 16#005F#, 16#0002#),
         18759 => (16#1F81#, 16#0020#, 16#0002#),
         18760 => (16#0000#, 16#005F#, 16#0002#),
         18761 => (16#1F82#, 16#0020#, 16#0002#),
         18762 => (16#0000#, 16#005F#, 16#0002#),
         18763 => (16#1F83#, 16#0020#, 16#0002#),
         18764 => (16#0000#, 16#005F#, 16#0002#),
         18765 => (16#1F85#, 16#0020#, 16#0019#),
         18766 => (16#0000#, 16#005F#, 16#0002#),
         18767 => (16#1F85#, 16#0020#, 16#0002#),
         18768 => (16#0000#, 16#005F#, 16#0002#),
         18769 => (16#1F86#, 16#0020#, 16#0002#),
         18770 => (16#0000#, 16#005F#, 16#0002#),
         18771 => (16#1F87#, 16#0020#, 16#0002#),
         18772 => (16#0000#, 16#005F#, 16#0002#),
         18773 => (16#1F88#, 16#0020#, 16#0002#),
         18774 => (16#0000#, 16#005F#, 16#0002#),
         18775 => (16#1F8A#, 16#0020#, 16#0002#),
         18776 => (16#0000#, 16#005F#, 16#0002#),
         18777 => (16#1F7A#, 16#0020#, 16#0002#),
         18778 => (16#0000#, 16#005B#, 16#0002#),
         18779 => (16#1F76#, 16#0020#, 16#0002#),
         18780 => (16#0000#, 16#0060#, 16#0002#),
         18781 => (16#1F7F#, 16#0020#, 16#0002#),
         18782 => (16#0000#, 16#0060#, 16#0002#),
         18783 => (16#1F85#, 16#0020#, 16#0002#),
         18784 => (16#0000#, 16#0060#, 16#0002#),
         18785 => (16#1F75#, 16#0020#, 16#0004#),
         18786 => (16#1F80#, 16#0020#, 16#0004#),
         18787 => (16#1FBF#, 16#0020#, 16#001A#),
         18788 => (16#1FBF#, 16#0020#, 16#0019#),
         18789 => (16#1FCC#, 16#0020#, 16#001A#),
         18790 => (16#1FCC#, 16#0020#, 16#0019#),
         18791 => (16#1FCC#, 16#0020#, 16#0017#),
         18792 => (16#1FCC#, 16#0020#, 16#0018#),
         18793 => (16#1FCD#, 16#0020#, 16#001A#),
         18794 => (16#1FCD#, 16#0020#, 16#0019#),
         18795 => (16#1FCD#, 16#0020#, 16#0017#),
         18796 => (16#1FCD#, 16#0020#, 16#0018#),
         18797 => (16#1FCE#, 16#0020#, 16#001A#),
         18798 => (16#1FCE#, 16#0020#, 16#0019#),
         18799 => (16#1FCE#, 16#0020#, 16#0017#),
         18800 => (16#1FCE#, 16#0020#, 16#0018#),
         18801 => (16#1FDC#, 16#0020#, 16#001A#),
         18802 => (16#1FDC#, 16#0020#, 16#0019#),
         18803 => (16#1FDC#, 16#0020#, 16#0017#),
         18804 => (16#1FDC#, 16#0020#, 16#0018#),
         18805 => (16#1FDF#, 16#0020#, 16#001A#),
         18806 => (16#1FDF#, 16#0020#, 16#0019#),
         18807 => (16#1FDF#, 16#0020#, 16#0017#),
         18808 => (16#1FDF#, 16#0020#, 16#0018#),
         18809 => (16#1FDB#, 16#0020#, 16#001A#),
         18810 => (16#1FDB#, 16#0020#, 16#0019#),
         18811 => (16#1FDB#, 16#0020#, 16#0017#),
         18812 => (16#1FDB#, 16#0020#, 16#0018#),
         18813 => (16#2033#, 16#0020#, 16#001A#),
         18814 => (16#2033#, 16#0020#, 16#0019#),
         18815 => (16#2033#, 16#0020#, 16#0017#),
         18816 => (16#2033#, 16#0020#, 16#0018#),
         18817 => (16#2036#, 16#0020#, 16#001A#),
         18818 => (16#2036#, 16#0020#, 16#0019#),
         18819 => (16#2036#, 16#0020#, 16#0017#),
         18820 => (16#2036#, 16#0020#, 16#0018#),
         18821 => (16#1FE2#, 16#0020#, 16#001A#),
         18822 => (16#1FE2#, 16#0020#, 16#0019#),
         18823 => (16#1FE2#, 16#0020#, 16#0017#),
         18824 => (16#1FE2#, 16#0020#, 16#0018#),
         18825 => (16#1FE1#, 16#0020#, 16#001A#),
         18826 => (16#1FE1#, 16#0020#, 16#0019#),
         18827 => (16#1FE1#, 16#0020#, 16#0017#),
         18828 => (16#1FE1#, 16#0020#, 16#0018#),
         18829 => (16#1FE3#, 16#0020#, 16#001A#),
         18830 => (16#1FE3#, 16#0020#, 16#0019#),
         18831 => (16#1FE3#, 16#0020#, 16#0017#),
         18832 => (16#1FE3#, 16#0020#, 16#0018#),
         18833 => (16#1FE5#, 16#0020#, 16#001A#),
         18834 => (16#1FE5#, 16#0020#, 16#0019#),
         18835 => (16#1FE5#, 16#0020#, 16#0017#),
         18836 => (16#1FE5#, 16#0020#, 16#0018#),
         18837 => (16#1FF9#, 16#0020#, 16#001A#),
         18838 => (16#1FF9#, 16#0020#, 16#0019#),
         18839 => (16#1FF8#, 16#0020#, 16#001A#),
         18840 => (16#1FF8#, 16#0020#, 16#0019#),
         18841 => (16#1FFB#, 16#0020#, 16#001A#),
         18842 => (16#1FFB#, 16#0020#, 16#0019#),
         18843 => (16#1FF4#, 16#0020#, 16#001A#),
         18844 => (16#1FF4#, 16#0020#, 16#0019#),
         18845 => (16#200A#, 16#0020#, 16#001A#),
         18846 => (16#200A#, 16#0020#, 16#0019#),
         18847 => (16#2003#, 16#0020#, 16#001A#),
         18848 => (16#2003#, 16#0020#, 16#0019#),
         18849 => (16#203F#, 16#0020#, 16#001A#),
         18850 => (16#203F#, 16#0020#, 16#0019#),
         18851 => (16#203F#, 16#0020#, 16#0017#),
         18852 => (16#203F#, 16#0020#, 16#0018#),
         18853 => (16#2046#, 16#0020#, 16#001A#),
         18854 => (16#2046#, 16#0020#, 16#0019#),
         18855 => (16#2046#, 16#0020#, 16#0017#),
         18856 => (16#2046#, 16#0020#, 16#0018#),
         18857 => (16#204B#, 16#0020#, 16#001A#),
         18858 => (16#204B#, 16#0020#, 16#0019#),
         18859 => (16#204B#, 16#0020#, 16#0017#),
         18860 => (16#204B#, 16#0020#, 16#0018#),
         18861 => (16#2049#, 16#0020#, 16#001A#),
         18862 => (16#2049#, 16#0020#, 16#0019#),
         18863 => (16#2049#, 16#0020#, 16#0017#),
         18864 => (16#2049#, 16#0020#, 16#0018#),
         18865 => (16#205E#, 16#0020#, 16#001A#),
         18866 => (16#205E#, 16#0020#, 16#0019#),
         18867 => (16#205F#, 16#0020#, 16#001A#),
         18868 => (16#205F#, 16#0020#, 16#0019#),
         18869 => (16#205F#, 16#0020#, 16#0017#),
         18870 => (16#205F#, 16#0020#, 16#0018#),
         18871 => (16#206B#, 16#0020#, 16#001A#),
         18872 => (16#0000#, 16#0083#, 16#001A#),
         18873 => (16#206B#, 16#0020#, 16#0019#),
         18874 => (16#0000#, 16#0083#, 16#0019#),
         18875 => (16#2068#, 16#0020#, 16#001A#),
         18876 => (16#2068#, 16#0020#, 16#0019#),
         18877 => (16#2068#, 16#0020#, 16#0017#),
         18878 => (16#2068#, 16#0020#, 16#0018#),
         18879 => (16#2067#, 16#0020#, 16#001A#),
         18880 => (16#2067#, 16#0020#, 16#0019#),
         18881 => (16#2067#, 16#0020#, 16#0017#),
         18882 => (16#2067#, 16#0020#, 16#0018#),
         18883 => (16#2088#, 16#0020#, 16#001A#),
         18884 => (16#2088#, 16#0020#, 16#0019#),
         18885 => (16#2088#, 16#0020#, 16#001A#),
         18886 => (16#0000#, 16#0083#, 16#001A#),
         18887 => (16#2088#, 16#0020#, 16#0019#),
         18888 => (16#0000#, 16#0083#, 16#0019#),
         18889 => (16#03C6#, 16#0020#, 16#0002#),
         18890 => (16#03C7#, 16#0020#, 16#0002#),
         18891 => (16#03C8#, 16#0020#, 16#0002#),
         18892 => (16#03C9#, 16#0020#, 16#0002#),
         18893 => (16#03CA#, 16#0020#, 16#0002#),
         18894 => (16#03CB#, 16#0020#, 16#0002#),
         18895 => (16#03CC#, 16#0020#, 16#0002#),
         18896 => (16#03CD#, 16#0020#, 16#0002#),
         18897 => (16#03CE#, 16#0020#, 16#0002#),
         18898 => (16#03CF#, 16#0020#, 16#0002#),
         18899 => (16#03D0#, 16#0020#, 16#0002#),
         18900 => (16#03D1#, 16#0020#, 16#0002#),
         18901 => (16#03D2#, 16#0020#, 16#0002#),
         18902 => (16#03D3#, 16#0020#, 16#0002#),
         18903 => (16#03D4#, 16#0020#, 16#0002#),
         18904 => (16#03D5#, 16#0020#, 16#0002#),
         18905 => (16#2044#, 16#0020#, 16#001A#),
         18906 => (16#2044#, 16#0020#, 16#0019#),
         18907 => (16#2044#, 16#0020#, 16#0017#),
         18908 => (16#2044#, 16#0020#, 16#0018#),
         18909 => (16#2070#, 16#0020#, 16#001A#),
         18910 => (16#2070#, 16#0020#, 16#0019#),
         18911 => (16#206F#, 16#0020#, 16#001A#),
         18912 => (16#206F#, 16#0020#, 16#0019#),
         18913 => (16#2071#, 16#0020#, 16#001A#),
         18914 => (16#2071#, 16#0020#, 16#0019#),
         18915 => (16#2070#, 16#0020#, 16#001A#),
         18916 => (16#1FBB#, 16#0020#, 16#001A#),
         18917 => (16#2074#, 16#0020#, 16#001A#),
         18918 => (16#2074#, 16#0020#, 16#0019#),
         18919 => (16#206E#, 16#0020#, 16#001A#),
         18920 => (16#206E#, 16#0020#, 16#0019#),
         18921 => (16#2072#, 16#0020#, 16#001A#),
         18922 => (16#2072#, 16#0020#, 16#0019#),
         18923 => (16#207F#, 16#0020#, 16#001A#),
         18924 => (16#207F#, 16#0020#, 16#0019#),
         18925 => (16#207F#, 16#0020#, 16#0017#),
         18926 => (16#207F#, 16#0020#, 16#0018#),
         18927 => (16#207A#, 16#0020#, 16#0017#),
         18928 => (16#207A#, 16#0020#, 16#0018#),
         18929 => (16#1FC5#, 16#0020#, 16#001A#),
         18930 => (16#1FC9#, 16#0020#, 16#001A#),
         18931 => (16#1FC5#, 16#0020#, 16#0019#),
         18932 => (16#1FC9#, 16#0020#, 16#0019#),
         18933 => (16#1FC5#, 16#0020#, 16#001A#),
         18934 => (16#206B#, 16#0020#, 16#001A#),
         18935 => (16#1FC5#, 16#0020#, 16#0019#),
         18936 => (16#206B#, 16#0020#, 16#0019#),
         18937 => (16#1FC5#, 16#0020#, 16#001A#),
         18938 => (16#206C#, 16#0020#, 16#001A#),
         18939 => (16#1FC5#, 16#0020#, 16#0019#),
         18940 => (16#206C#, 16#0020#, 16#0019#),
         18941 => (16#1FC5#, 16#0020#, 16#001A#),
         18942 => (16#2070#, 16#0020#, 16#001A#),
         18943 => (16#1FC5#, 16#0020#, 16#0019#),
         18944 => (16#2070#, 16#0020#, 16#0019#),
         18945 => (16#1FC5#, 16#0020#, 16#001A#),
         18946 => (16#206F#, 16#0020#, 16#001A#),
         18947 => (16#1FC5#, 16#0020#, 16#0019#),
         18948 => (16#206F#, 16#0020#, 16#0019#),
         18949 => (16#1FC5#, 16#0020#, 16#001A#),
         18950 => (16#2071#, 16#0020#, 16#001A#),
         18951 => (16#1FC5#, 16#0020#, 16#0019#),
         18952 => (16#2071#, 16#0020#, 16#0019#),
         18953 => (16#1FC5#, 16#0020#, 16#001A#),
         18954 => (16#207F#, 16#0020#, 16#001A#),
         18955 => (16#1FC5#, 16#0020#, 16#0019#),
         18956 => (16#207F#, 16#0020#, 16#0019#),
         18957 => (16#1FC5#, 16#0020#, 16#0017#),
         18958 => (16#207F#, 16#0020#, 16#0017#),
         18959 => (16#1FC5#, 16#0020#, 16#001A#),
         18960 => (16#207A#, 16#0020#, 16#001A#),
         18961 => (16#1FC5#, 16#0020#, 16#0019#),
         18962 => (16#207A#, 16#0020#, 16#0019#),
         18963 => (16#1FC5#, 16#0020#, 16#0017#),
         18964 => (16#207A#, 16#0020#, 16#0017#),
         18965 => (16#207C#, 16#0020#, 16#001A#),
         18966 => (16#207C#, 16#0020#, 16#0019#),
         18967 => (16#207C#, 16#0020#, 16#0017#),
         18968 => (16#207C#, 16#0020#, 16#0018#),
         18969 => (16#1FC5#, 16#0020#, 16#001A#),
         18970 => (16#1FE0#, 16#0020#, 16#001A#),
         18971 => (16#1FC5#, 16#0020#, 16#001A#),
         18972 => (16#1FE7#, 16#0020#, 16#001A#),
         18973 => (16#1FC5#, 16#0020#, 16#001A#),
         18974 => (16#2059#, 16#0020#, 16#001A#),
         18975 => (16#1FC5#, 16#0020#, 16#001A#),
         18976 => (16#207B#, 16#0020#, 16#001A#),
         18977 => (16#1FCB#, 16#0020#, 16#001A#),
         18978 => (16#1FE0#, 16#0020#, 16#001A#),
         18979 => (16#1FCB#, 16#0020#, 16#001A#),
         18980 => (16#1FE7#, 16#0020#, 16#001A#),
         18981 => (16#1FCB#, 16#0020#, 16#001A#),
         18982 => (16#1FE8#, 16#0020#, 16#001A#),
         18983 => (16#1FCB#, 16#0020#, 16#001A#),
         18984 => (16#2059#, 16#0020#, 16#001A#),
         18985 => (16#1FCB#, 16#0020#, 16#001A#),
         18986 => (16#207A#, 16#0020#, 16#001A#),
         18987 => (16#1FCB#, 16#0020#, 16#001A#),
         18988 => (16#207B#, 16#0020#, 16#001A#),
         18989 => (16#1FD9#, 16#0020#, 16#001A#),
         18990 => (16#1FE0#, 16#0020#, 16#001A#),
         18991 => (16#1FD9#, 16#0020#, 16#001A#),
         18992 => (16#1FE7#, 16#0020#, 16#001A#),
         18993 => (16#1FD9#, 16#0020#, 16#001A#),
         18994 => (16#1FE8#, 16#0020#, 16#001A#),
         18995 => (16#1FD9#, 16#0020#, 16#001A#),
         18996 => (16#2059#, 16#0020#, 16#001A#),
         18997 => (16#1FD9#, 16#0020#, 16#001A#),
         18998 => (16#207A#, 16#0020#, 16#001A#),
         18999 => (16#1FD9#, 16#0020#, 16#001A#),
         19000 => (16#207B#, 16#0020#, 16#001A#),
         19001 => (16#1FDA#, 16#0020#, 16#001A#),
         19002 => (16#1FE0#, 16#0020#, 16#001A#),
         19003 => (16#1FDA#, 16#0020#, 16#001A#),
         19004 => (16#2059#, 16#0020#, 16#001A#),
         19005 => (16#1FDA#, 16#0020#, 16#001A#),
         19006 => (16#207A#, 16#0020#, 16#001A#),
         19007 => (16#1FDA#, 16#0020#, 16#001A#),
         19008 => (16#207B#, 16#0020#, 16#001A#),
         19009 => (16#1FE0#, 16#0020#, 16#001A#),
         19010 => (16#1FE7#, 16#0020#, 16#001A#),
         19011 => (16#1FE0#, 16#0020#, 16#001A#),
         19012 => (16#2059#, 16#0020#, 16#001A#),
         19013 => (16#1FE7#, 16#0020#, 16#001A#),
         19014 => (16#2059#, 16#0020#, 16#001A#),
         19015 => (16#1FE8#, 16#0020#, 16#001A#),
         19016 => (16#1FE0#, 16#0020#, 16#001A#),
         19017 => (16#1FE8#, 16#0020#, 16#001A#),
         19018 => (16#1FE7#, 16#0020#, 16#001A#),
         19019 => (16#1FE8#, 16#0020#, 16#001A#),
         19020 => (16#2059#, 16#0020#, 16#001A#),
         19021 => (16#2013#, 16#0020#, 16#001A#),
         19022 => (16#1FE0#, 16#0020#, 16#001A#),
         19023 => (16#2013#, 16#0020#, 16#001A#),
         19024 => (16#1FE7#, 16#0020#, 16#001A#),
         19025 => (16#2013#, 16#0020#, 16#001A#),
         19026 => (16#1FE8#, 16#0020#, 16#001A#),
         19027 => (16#2013#, 16#0020#, 16#001A#),
         19028 => (16#2059#, 16#0020#, 16#001A#),
         19029 => (16#201E#, 16#0020#, 16#001A#),
         19030 => (16#1FE7#, 16#0020#, 16#001A#),
         19031 => (16#201E#, 16#0020#, 16#001A#),
         19032 => (16#2059#, 16#0020#, 16#001A#),
         19033 => (16#201F#, 16#0020#, 16#001A#),
         19034 => (16#1FE0#, 16#0020#, 16#001A#),
         19035 => (16#201F#, 16#0020#, 16#001A#),
         19036 => (16#1FE7#, 16#0020#, 16#001A#),
         19037 => (16#201F#, 16#0020#, 16#001A#),
         19038 => (16#1FE8#, 16#0020#, 16#001A#),
         19039 => (16#201F#, 16#0020#, 16#001A#),
         19040 => (16#2059#, 16#0020#, 16#001A#),
         19041 => (16#2024#, 16#0020#, 16#001A#),
         19042 => (16#1FE7#, 16#0020#, 16#001A#),
         19043 => (16#2024#, 16#0020#, 16#001A#),
         19044 => (16#2059#, 16#0020#, 16#001A#),
         19045 => (16#2025#, 16#0020#, 16#001A#),
         19046 => (16#2059#, 16#0020#, 16#001A#),
         19047 => (16#2028#, 16#0020#, 16#001A#),
         19048 => (16#1FE0#, 16#0020#, 16#001A#),
         19049 => (16#2028#, 16#0020#, 16#001A#),
         19050 => (16#2059#, 16#0020#, 16#001A#),
         19051 => (16#2029#, 16#0020#, 16#001A#),
         19052 => (16#1FE0#, 16#0020#, 16#001A#),
         19053 => (16#2029#, 16#0020#, 16#001A#),
         19054 => (16#2059#, 16#0020#, 16#001A#),
         19055 => (16#202F#, 16#0020#, 16#001A#),
         19056 => (16#1FE0#, 16#0020#, 16#001A#),
         19057 => (16#202F#, 16#0020#, 16#001A#),
         19058 => (16#1FE7#, 16#0020#, 16#001A#),
         19059 => (16#202F#, 16#0020#, 16#001A#),
         19060 => (16#1FE8#, 16#0020#, 16#001A#),
         19061 => (16#202F#, 16#0020#, 16#001A#),
         19062 => (16#2059#, 16#0020#, 16#001A#),
         19063 => (16#202F#, 16#0020#, 16#001A#),
         19064 => (16#207A#, 16#0020#, 16#001A#),
         19065 => (16#202F#, 16#0020#, 16#001A#),
         19066 => (16#207B#, 16#0020#, 16#001A#),
         19067 => (16#203A#, 16#0020#, 16#001A#),
         19068 => (16#1FE7#, 16#0020#, 16#001A#),
         19069 => (16#203A#, 16#0020#, 16#001A#),
         19070 => (16#2059#, 16#0020#, 16#001A#),
         19071 => (16#203A#, 16#0020#, 16#001A#),
         19072 => (16#207A#, 16#0020#, 16#001A#),
         19073 => (16#203A#, 16#0020#, 16#001A#),
         19074 => (16#207B#, 16#0020#, 16#001A#),
         19075 => (16#203E#, 16#0020#, 16#001A#),
         19076 => (16#1FC9#, 16#0020#, 16#001A#),
         19077 => (16#203E#, 16#0020#, 16#001A#),
         19078 => (16#1FE0#, 16#0020#, 16#001A#),
         19079 => (16#203E#, 16#0020#, 16#001A#),
         19080 => (16#1FE7#, 16#0020#, 16#001A#),
         19081 => (16#203E#, 16#0020#, 16#001A#),
         19082 => (16#1FE8#, 16#0020#, 16#001A#),
         19083 => (16#203E#, 16#0020#, 16#001A#),
         19084 => (16#2052#, 16#0020#, 16#001A#),
         19085 => (16#203E#, 16#0020#, 16#001A#),
         19086 => (16#2059#, 16#0020#, 16#001A#),
         19087 => (16#203E#, 16#0020#, 16#001A#),
         19088 => (16#207A#, 16#0020#, 16#001A#),
         19089 => (16#203E#, 16#0020#, 16#001A#),
         19090 => (16#207B#, 16#0020#, 16#001A#),
         19091 => (16#2052#, 16#0020#, 16#001A#),
         19092 => (16#1FE0#, 16#0020#, 16#001A#),
         19093 => (16#2052#, 16#0020#, 16#001A#),
         19094 => (16#1FE7#, 16#0020#, 16#001A#),
         19095 => (16#2052#, 16#0020#, 16#001A#),
         19096 => (16#1FE8#, 16#0020#, 16#001A#),
         19097 => (16#2052#, 16#0020#, 16#001A#),
         19098 => (16#2059#, 16#0020#, 16#001A#),
         19099 => (16#2052#, 16#0020#, 16#001A#),
         19100 => (16#207A#, 16#0020#, 16#001A#),
         19101 => (16#2052#, 16#0020#, 16#001A#),
         19102 => (16#207B#, 16#0020#, 16#001A#),
         19103 => (16#2059#, 16#0020#, 16#001A#),
         19104 => (16#1FE0#, 16#0020#, 16#001A#),
         19105 => (16#2059#, 16#0020#, 16#001A#),
         19106 => (16#2059#, 16#0020#, 16#001A#),
         19107 => (16#2059#, 16#0020#, 16#001A#),
         19108 => (16#207A#, 16#0020#, 16#001A#),
         19109 => (16#2059#, 16#0020#, 16#001A#),
         19110 => (16#207B#, 16#0020#, 16#001A#),
         19111 => (16#205D#, 16#0020#, 16#001A#),
         19112 => (16#1FE0#, 16#0020#, 16#001A#),
         19113 => (16#205D#, 16#0020#, 16#001A#),
         19114 => (16#1FE7#, 16#0020#, 16#001A#),
         19115 => (16#205D#, 16#0020#, 16#001A#),
         19116 => (16#1FE8#, 16#0020#, 16#001A#),
         19117 => (16#205D#, 16#0020#, 16#001A#),
         19118 => (16#2059#, 16#0020#, 16#001A#),
         19119 => (16#205D#, 16#0020#, 16#001A#),
         19120 => (16#207A#, 16#0020#, 16#001A#),
         19121 => (16#205D#, 16#0020#, 16#001A#),
         19122 => (16#207B#, 16#0020#, 16#001A#),
         19123 => (16#2066#, 16#0020#, 16#001A#),
         19124 => (16#1FE0#, 16#0020#, 16#001A#),
         19125 => (16#2066#, 16#0020#, 16#001A#),
         19126 => (16#2059#, 16#0020#, 16#001A#),
         19127 => (16#2066#, 16#0020#, 16#001A#),
         19128 => (16#207A#, 16#0020#, 16#001A#),
         19129 => (16#2066#, 16#0020#, 16#001A#),
         19130 => (16#207B#, 16#0020#, 16#001A#),
         19131 => (16#207B#, 16#0020#, 16#001A#),
         19132 => (16#1FE7#, 16#0020#, 16#001A#),
         19133 => (16#207B#, 16#0020#, 16#001A#),
         19134 => (16#1FE8#, 16#0020#, 16#001A#),
         19135 => (16#207B#, 16#0020#, 16#001A#),
         19136 => (16#207A#, 16#0020#, 16#001A#),
         19137 => (16#1FF3#, 16#0020#, 16#001A#),
         19138 => (16#0000#, 16#0097#, 16#001A#),
         19139 => (16#2001#, 16#0020#, 16#001A#),
         19140 => (16#0000#, 16#0097#, 16#001A#),
         19141 => (16#207A#, 16#0020#, 16#001A#),
         19142 => (16#0000#, 16#0097#, 16#001A#),
         19143 => (16#0000#, 16#0070#, 16#001A#),
         19144 => (16#0000#, 16#0080#, 16#001A#),
         19145 => (16#0000#, 16#0073#, 16#001A#),
         19146 => (16#0000#, 16#0080#, 16#001A#),
         19147 => (16#0000#, 16#0076#, 16#001A#),
         19148 => (16#0000#, 16#0080#, 16#001A#),
         19149 => (16#0000#, 16#007A#, 16#001A#),
         19150 => (16#0000#, 16#0080#, 16#001A#),
         19151 => (16#0000#, 16#007D#, 16#001A#),
         19152 => (16#0000#, 16#0080#, 16#001A#),
         19153 => (16#0000#, 16#0080#, 16#001A#),
         19154 => (16#0000#, 16#0097#, 16#001A#),
         19155 => (16#1FC5#, 16#0020#, 16#0019#),
         19156 => (16#2001#, 16#0020#, 16#0019#),
         19157 => (16#1FC5#, 16#0020#, 16#0019#),
         19158 => (16#2002#, 16#0020#, 16#0019#),
         19159 => (16#1FC5#, 16#0020#, 16#0019#),
         19160 => (16#2059#, 16#0020#, 16#0019#),
         19161 => (16#1FC5#, 16#0020#, 16#0019#),
         19162 => (16#205D#, 16#0020#, 16#0019#),
         19163 => (16#1FC5#, 16#0020#, 16#0019#),
         19164 => (16#207B#, 16#0020#, 16#0019#),
         19165 => (16#1FCB#, 16#0020#, 16#0019#),
         19166 => (16#2001#, 16#0020#, 16#0019#),
         19167 => (16#1FCB#, 16#0020#, 16#0019#),
         19168 => (16#2002#, 16#0020#, 16#0019#),
         19169 => (16#1FCB#, 16#0020#, 16#0019#),
         19170 => (16#2059#, 16#0020#, 16#0019#),
         19171 => (16#1FCB#, 16#0020#, 16#0019#),
         19172 => (16#205D#, 16#0020#, 16#0019#),
         19173 => (16#1FCB#, 16#0020#, 16#0019#),
         19174 => (16#207A#, 16#0020#, 16#0019#),
         19175 => (16#1FCB#, 16#0020#, 16#0019#),
         19176 => (16#207B#, 16#0020#, 16#0019#),
         19177 => (16#1FD9#, 16#0020#, 16#0019#),
         19178 => (16#2001#, 16#0020#, 16#0019#),
         19179 => (16#1FD9#, 16#0020#, 16#0019#),
         19180 => (16#2002#, 16#0020#, 16#0019#),
         19181 => (16#1FD9#, 16#0020#, 16#0019#),
         19182 => (16#2059#, 16#0020#, 16#0019#),
         19183 => (16#1FD9#, 16#0020#, 16#0019#),
         19184 => (16#205D#, 16#0020#, 16#0019#),
         19185 => (16#1FD9#, 16#0020#, 16#0019#),
         19186 => (16#207A#, 16#0020#, 16#0019#),
         19187 => (16#1FD9#, 16#0020#, 16#0019#),
         19188 => (16#207B#, 16#0020#, 16#0019#),
         19189 => (16#1FDA#, 16#0020#, 16#0019#),
         19190 => (16#2001#, 16#0020#, 16#0019#),
         19191 => (16#1FDA#, 16#0020#, 16#0019#),
         19192 => (16#2002#, 16#0020#, 16#0019#),
         19193 => (16#1FDA#, 16#0020#, 16#0019#),
         19194 => (16#2059#, 16#0020#, 16#0019#),
         19195 => (16#1FDA#, 16#0020#, 16#0019#),
         19196 => (16#205D#, 16#0020#, 16#0019#),
         19197 => (16#1FDA#, 16#0020#, 16#0019#),
         19198 => (16#207A#, 16#0020#, 16#0019#),
         19199 => (16#1FDA#, 16#0020#, 16#0019#),
         19200 => (16#207B#, 16#0020#, 16#0019#),
         19201 => (16#202F#, 16#0020#, 16#0019#),
         19202 => (16#207A#, 16#0020#, 16#0019#),
         19203 => (16#202F#, 16#0020#, 16#0019#),
         19204 => (16#207B#, 16#0020#, 16#0019#),
         19205 => (16#203A#, 16#0020#, 16#0019#),
         19206 => (16#207A#, 16#0020#, 16#0019#),
         19207 => (16#203A#, 16#0020#, 16#0019#),
         19208 => (16#207B#, 16#0020#, 16#0019#),
         19209 => (16#203E#, 16#0020#, 16#0019#),
         19210 => (16#1FC9#, 16#0020#, 16#0019#),
         19211 => (16#203E#, 16#0020#, 16#0019#),
         19212 => (16#2052#, 16#0020#, 16#0019#),
         19213 => (16#203E#, 16#0020#, 16#0019#),
         19214 => (16#2059#, 16#0020#, 16#0019#),
         19215 => (16#203E#, 16#0020#, 16#0019#),
         19216 => (16#207A#, 16#0020#, 16#0019#),
         19217 => (16#203E#, 16#0020#, 16#0019#),
         19218 => (16#207B#, 16#0020#, 16#0019#),
         19219 => (16#2052#, 16#0020#, 16#0019#),
         19220 => (16#2059#, 16#0020#, 16#0019#),
         19221 => (16#2052#, 16#0020#, 16#0019#),
         19222 => (16#207A#, 16#0020#, 16#0019#),
         19223 => (16#2052#, 16#0020#, 16#0019#),
         19224 => (16#207B#, 16#0020#, 16#0019#),
         19225 => (16#2059#, 16#0020#, 16#0019#),
         19226 => (16#1FC9#, 16#0020#, 16#0019#),
         19227 => (16#2059#, 16#0020#, 16#0019#),
         19228 => (16#2059#, 16#0020#, 16#0019#),
         19229 => (16#205D#, 16#0020#, 16#0019#),
         19230 => (16#2001#, 16#0020#, 16#0019#),
         19231 => (16#205D#, 16#0020#, 16#0019#),
         19232 => (16#2002#, 16#0020#, 16#0019#),
         19233 => (16#205D#, 16#0020#, 16#0019#),
         19234 => (16#2059#, 16#0020#, 16#0019#),
         19235 => (16#205D#, 16#0020#, 16#0019#),
         19236 => (16#205D#, 16#0020#, 16#0019#),
         19237 => (16#205D#, 16#0020#, 16#0019#),
         19238 => (16#207A#, 16#0020#, 16#0019#),
         19239 => (16#205D#, 16#0020#, 16#0019#),
         19240 => (16#207B#, 16#0020#, 16#0019#),
         19241 => (16#207A#, 16#0020#, 16#0019#),
         19242 => (16#0000#, 16#0097#, 16#0019#),
         19243 => (16#207B#, 16#0020#, 16#0019#),
         19244 => (16#2001#, 16#0020#, 16#0019#),
         19245 => (16#207B#, 16#0020#, 16#0019#),
         19246 => (16#2002#, 16#0020#, 16#0019#),
         19247 => (16#207B#, 16#0020#, 16#0019#),
         19248 => (16#205D#, 16#0020#, 16#0019#),
         19249 => (16#207B#, 16#0020#, 16#0019#),
         19250 => (16#207B#, 16#0020#, 16#0019#),
         19251 => (16#1FC5#, 16#0020#, 16#0017#),
         19252 => (16#1FE0#, 16#0020#, 16#0017#),
         19253 => (16#1FC5#, 16#0020#, 16#0017#),
         19254 => (16#1FE7#, 16#0020#, 16#0017#),
         19255 => (16#1FC5#, 16#0020#, 16#0017#),
         19256 => (16#1FE8#, 16#0020#, 16#0017#),
         19257 => (16#1FC5#, 16#0020#, 16#0017#),
         19258 => (16#2059#, 16#0020#, 16#0017#),
         19259 => (16#1FC5#, 16#0020#, 16#0017#),
         19260 => (16#2066#, 16#0020#, 16#0017#),
         19261 => (16#1FCB#, 16#0020#, 16#0017#),
         19262 => (16#1FE0#, 16#0020#, 16#0017#),
         19263 => (16#1FCB#, 16#0020#, 16#0017#),
         19264 => (16#1FE7#, 16#0020#, 16#0017#),
         19265 => (16#1FCB#, 16#0020#, 16#0017#),
         19266 => (16#1FE8#, 16#0020#, 16#0017#),
         19267 => (16#1FCB#, 16#0020#, 16#0017#),
         19268 => (16#2059#, 16#0020#, 16#0017#),
         19269 => (16#1FCB#, 16#0020#, 16#0017#),
         19270 => (16#2066#, 16#0020#, 16#0017#),
         19271 => (16#1FD9#, 16#0020#, 16#0017#),
         19272 => (16#1FE0#, 16#0020#, 16#0017#),
         19273 => (16#1FD9#, 16#0020#, 16#0017#),
         19274 => (16#1FE7#, 16#0020#, 16#0017#),
         19275 => (16#1FD9#, 16#0020#, 16#0017#),
         19276 => (16#1FE8#, 16#0020#, 16#0017#),
         19277 => (16#1FD9#, 16#0020#, 16#0017#),
         19278 => (16#2059#, 16#0020#, 16#0017#),
         19279 => (16#1FD9#, 16#0020#, 16#0017#),
         19280 => (16#2066#, 16#0020#, 16#0017#),
         19281 => (16#1FDA#, 16#0020#, 16#0017#),
         19282 => (16#2059#, 16#0020#, 16#0017#),
         19283 => (16#1FE0#, 16#0020#, 16#0017#),
         19284 => (16#1FE7#, 16#0020#, 16#0017#),
         19285 => (16#1FE0#, 16#0020#, 16#0017#),
         19286 => (16#2059#, 16#0020#, 16#0017#),
         19287 => (16#1FE7#, 16#0020#, 16#0017#),
         19288 => (16#2059#, 16#0020#, 16#0017#),
         19289 => (16#1FE8#, 16#0020#, 16#0017#),
         19290 => (16#1FE0#, 16#0020#, 16#0017#),
         19291 => (16#1FE8#, 16#0020#, 16#0017#),
         19292 => (16#2059#, 16#0020#, 16#0017#),
         19293 => (16#2013#, 16#0020#, 16#0017#),
         19294 => (16#1FE0#, 16#0020#, 16#0017#),
         19295 => (16#2013#, 16#0020#, 16#0017#),
         19296 => (16#1FE7#, 16#0020#, 16#0017#),
         19297 => (16#2013#, 16#0020#, 16#0017#),
         19298 => (16#1FE8#, 16#0020#, 16#0017#),
         19299 => (16#2013#, 16#0020#, 16#0017#),
         19300 => (16#2059#, 16#0020#, 16#0017#),
         19301 => (16#201E#, 16#0020#, 16#0017#),
         19302 => (16#1FE7#, 16#0020#, 16#0017#),
         19303 => (16#201E#, 16#0020#, 16#0017#),
         19304 => (16#1FE8#, 16#0020#, 16#0017#),
         19305 => (16#201E#, 16#0020#, 16#0017#),
         19306 => (16#2059#, 16#0020#, 16#0017#),
         19307 => (16#201F#, 16#0020#, 16#0017#),
         19308 => (16#1FE0#, 16#0020#, 16#0017#),
         19309 => (16#201F#, 16#0020#, 16#0017#),
         19310 => (16#1FE7#, 16#0020#, 16#0017#),
         19311 => (16#201F#, 16#0020#, 16#0017#),
         19312 => (16#1FE8#, 16#0020#, 16#0017#),
         19313 => (16#201F#, 16#0020#, 16#0017#),
         19314 => (16#2059#, 16#0020#, 16#0017#),
         19315 => (16#2024#, 16#0020#, 16#0017#),
         19316 => (16#1FE7#, 16#0020#, 16#0017#),
         19317 => (16#2025#, 16#0020#, 16#0017#),
         19318 => (16#2059#, 16#0020#, 16#0017#),
         19319 => (16#2028#, 16#0020#, 16#0017#),
         19320 => (16#1FE0#, 16#0020#, 16#0017#),
         19321 => (16#2028#, 16#0020#, 16#0017#),
         19322 => (16#2059#, 16#0020#, 16#0017#),
         19323 => (16#2029#, 16#0020#, 16#0017#),
         19324 => (16#1FE0#, 16#0020#, 16#0017#),
         19325 => (16#2029#, 16#0020#, 16#0017#),
         19326 => (16#2059#, 16#0020#, 16#0017#),
         19327 => (16#202F#, 16#0020#, 16#0017#),
         19328 => (16#1FE0#, 16#0020#, 16#0017#),
         19329 => (16#202F#, 16#0020#, 16#0017#),
         19330 => (16#1FE7#, 16#0020#, 16#0017#),
         19331 => (16#202F#, 16#0020#, 16#0017#),
         19332 => (16#1FE8#, 16#0020#, 16#0017#),
         19333 => (16#202F#, 16#0020#, 16#0017#),
         19334 => (16#2059#, 16#0020#, 16#0017#),
         19335 => (16#203A#, 16#0020#, 16#0017#),
         19336 => (16#1FE7#, 16#0020#, 16#0017#),
         19337 => (16#203A#, 16#0020#, 16#0017#),
         19338 => (16#2059#, 16#0020#, 16#0017#),
         19339 => (16#203E#, 16#0020#, 16#0017#),
         19340 => (16#1FE0#, 16#0020#, 16#0017#),
         19341 => (16#203E#, 16#0020#, 16#0017#),
         19342 => (16#1FE7#, 16#0020#, 16#0017#),
         19343 => (16#203E#, 16#0020#, 16#0017#),
         19344 => (16#1FE8#, 16#0020#, 16#0017#),
         19345 => (16#203E#, 16#0020#, 16#0017#),
         19346 => (16#2052#, 16#0020#, 16#0017#),
         19347 => (16#203E#, 16#0020#, 16#0017#),
         19348 => (16#2059#, 16#0020#, 16#0017#),
         19349 => (16#2052#, 16#0020#, 16#0017#),
         19350 => (16#1FE0#, 16#0020#, 16#0017#),
         19351 => (16#2052#, 16#0020#, 16#0017#),
         19352 => (16#1FE7#, 16#0020#, 16#0017#),
         19353 => (16#2052#, 16#0020#, 16#0017#),
         19354 => (16#1FE8#, 16#0020#, 16#0017#),
         19355 => (16#2052#, 16#0020#, 16#0017#),
         19356 => (16#2059#, 16#0020#, 16#0017#),
         19357 => (16#2052#, 16#0020#, 16#0017#),
         19358 => (16#2066#, 16#0020#, 16#0017#),
         19359 => (16#2059#, 16#0020#, 16#0017#),
         19360 => (16#2059#, 16#0020#, 16#0017#),
         19361 => (16#205D#, 16#0020#, 16#0017#),
         19362 => (16#1FE0#, 16#0020#, 16#0017#),
         19363 => (16#205D#, 16#0020#, 16#0017#),
         19364 => (16#1FE7#, 16#0020#, 16#0017#),
         19365 => (16#205D#, 16#0020#, 16#0017#),
         19366 => (16#1FE8#, 16#0020#, 16#0017#),
         19367 => (16#205D#, 16#0020#, 16#0017#),
         19368 => (16#2059#, 16#0020#, 16#0017#),
         19369 => (16#205D#, 16#0020#, 16#0017#),
         19370 => (16#2066#, 16#0020#, 16#0017#),
         19371 => (16#2066#, 16#0020#, 16#0017#),
         19372 => (16#1FE0#, 16#0020#, 16#0017#),
         19373 => (16#2066#, 16#0020#, 16#0017#),
         19374 => (16#0000#, 16#0097#, 16#0017#),
         19375 => (16#207B#, 16#0020#, 16#0017#),
         19376 => (16#1FE0#, 16#0020#, 16#0017#),
         19377 => (16#207B#, 16#0020#, 16#0017#),
         19378 => (16#1FE7#, 16#0020#, 16#0017#),
         19379 => (16#207B#, 16#0020#, 16#0017#),
         19380 => (16#1FE8#, 16#0020#, 16#0017#),
         19381 => (16#207B#, 16#0020#, 16#0017#),
         19382 => (16#2059#, 16#0020#, 16#0017#),
         19383 => (16#207B#, 16#0020#, 16#0017#),
         19384 => (16#2066#, 16#0020#, 16#0017#),
         19385 => (16#1FC5#, 16#0020#, 16#0018#),
         19386 => (16#2059#, 16#0020#, 16#0018#),
         19387 => (16#1FC5#, 16#0020#, 16#0018#),
         19388 => (16#2066#, 16#0020#, 16#0018#),
         19389 => (16#1FCB#, 16#0020#, 16#0018#),
         19390 => (16#2059#, 16#0020#, 16#0018#),
         19391 => (16#1FCB#, 16#0020#, 16#0018#),
         19392 => (16#2066#, 16#0020#, 16#0018#),
         19393 => (16#1FD9#, 16#0020#, 16#0018#),
         19394 => (16#2059#, 16#0020#, 16#0018#),
         19395 => (16#1FD9#, 16#0020#, 16#0018#),
         19396 => (16#2066#, 16#0020#, 16#0018#),
         19397 => (16#1FDA#, 16#0020#, 16#0018#),
         19398 => (16#2059#, 16#0020#, 16#0018#),
         19399 => (16#1FDA#, 16#0020#, 16#0018#),
         19400 => (16#2066#, 16#0020#, 16#0018#),
         19401 => (16#2013#, 16#0020#, 16#0018#),
         19402 => (16#2059#, 16#0020#, 16#0018#),
         19403 => (16#2013#, 16#0020#, 16#0018#),
         19404 => (16#2066#, 16#0020#, 16#0018#),
         19405 => (16#2014#, 16#0020#, 16#0018#),
         19406 => (16#2059#, 16#0020#, 16#0018#),
         19407 => (16#2014#, 16#0020#, 16#0018#),
         19408 => (16#2066#, 16#0020#, 16#0018#),
         19409 => (16#203E#, 16#0020#, 16#0018#),
         19410 => (16#2052#, 16#0020#, 16#0018#),
         19411 => (16#203E#, 16#0020#, 16#0018#),
         19412 => (16#2059#, 16#0020#, 16#0018#),
         19413 => (16#2052#, 16#0020#, 16#0018#),
         19414 => (16#2059#, 16#0020#, 16#0018#),
         19415 => (16#205D#, 16#0020#, 16#0018#),
         19416 => (16#2059#, 16#0020#, 16#0018#),
         19417 => (16#205D#, 16#0020#, 16#0018#),
         19418 => (16#2066#, 16#0020#, 16#0018#),
         19419 => (16#207B#, 16#0020#, 16#0018#),
         19420 => (16#2059#, 16#0020#, 16#0018#),
         19421 => (16#207B#, 16#0020#, 16#0018#),
         19422 => (16#2066#, 16#0020#, 16#0018#),
         19423 => (16#0000#, 16#0076#, 16#0018#),
         19424 => (16#0000#, 16#0080#, 16#0018#),
         19425 => (16#0000#, 16#007A#, 16#0018#),
         19426 => (16#0000#, 16#0080#, 16#0018#),
         19427 => (16#0000#, 16#007D#, 16#0018#),
         19428 => (16#0000#, 16#0080#, 16#0018#),
         19429 => (16#2024#, 16#0020#, 16#001A#),
         19430 => (16#207A#, 16#0020#, 16#001A#),
         19431 => (16#2024#, 16#0020#, 16#001A#),
         19432 => (16#207B#, 16#0020#, 16#001A#),
         19433 => (16#2028#, 16#0020#, 16#001A#),
         19434 => (16#207A#, 16#0020#, 16#001A#),
         19435 => (16#2028#, 16#0020#, 16#001A#),
         19436 => (16#207B#, 16#0020#, 16#001A#),
         19437 => (16#2029#, 16#0020#, 16#001A#),
         19438 => (16#207A#, 16#0020#, 16#001A#),
         19439 => (16#2029#, 16#0020#, 16#001A#),
         19440 => (16#207B#, 16#0020#, 16#001A#),
         19441 => (16#2013#, 16#0020#, 16#001A#),
         19442 => (16#207A#, 16#0020#, 16#001A#),
         19443 => (16#2013#, 16#0020#, 16#001A#),
         19444 => (16#207B#, 16#0020#, 16#001A#),
         19445 => (16#2014#, 16#0020#, 16#001A#),
         19446 => (16#207A#, 16#0020#, 16#001A#),
         19447 => (16#2014#, 16#0020#, 16#001A#),
         19448 => (16#207B#, 16#0020#, 16#001A#),
         19449 => (16#1FE7#, 16#0020#, 16#001A#),
         19450 => (16#207A#, 16#0020#, 16#001A#),
         19451 => (16#1FE0#, 16#0020#, 16#001A#),
         19452 => (16#207A#, 16#0020#, 16#001A#),
         19453 => (16#1FE0#, 16#0020#, 16#001A#),
         19454 => (16#207B#, 16#0020#, 16#001A#),
         19455 => (16#1FE8#, 16#0020#, 16#001A#),
         19456 => (16#207A#, 16#0020#, 16#001A#),
         19457 => (16#201E#, 16#0020#, 16#001A#),
         19458 => (16#207A#, 16#0020#, 16#001A#),
         19459 => (16#201E#, 16#0020#, 16#001A#),
         19460 => (16#207B#, 16#0020#, 16#001A#),
         19461 => (16#201F#, 16#0020#, 16#001A#),
         19462 => (16#207A#, 16#0020#, 16#001A#),
         19463 => (16#201F#, 16#0020#, 16#001A#),
         19464 => (16#207B#, 16#0020#, 16#001A#),
         19465 => (16#2014#, 16#0020#, 16#001A#),
         19466 => (16#1FE0#, 16#0020#, 16#001A#),
         19467 => (16#2014#, 16#0020#, 16#001A#),
         19468 => (16#1FE7#, 16#0020#, 16#001A#),
         19469 => (16#2014#, 16#0020#, 16#001A#),
         19470 => (16#1FE8#, 16#0020#, 16#001A#),
         19471 => (16#2014#, 16#0020#, 16#001A#),
         19472 => (16#2059#, 16#0020#, 16#001A#),
         19473 => (16#2014#, 16#0020#, 16#001A#),
         19474 => (16#2001#, 16#0020#, 16#001A#),
         19475 => (16#2013#, 16#0020#, 16#001A#),
         19476 => (16#2001#, 16#0020#, 16#001A#),
         19477 => (16#201E#, 16#0020#, 16#001A#),
         19478 => (16#2001#, 16#0020#, 16#001A#),
         19479 => (16#201F#, 16#0020#, 16#001A#),
         19480 => (16#2001#, 16#0020#, 16#001A#),
         19481 => (16#2024#, 16#0020#, 16#0019#),
         19482 => (16#207A#, 16#0020#, 16#0019#),
         19483 => (16#2024#, 16#0020#, 16#0019#),
         19484 => (16#207B#, 16#0020#, 16#0019#),
         19485 => (16#2028#, 16#0020#, 16#0019#),
         19486 => (16#207A#, 16#0020#, 16#0019#),
         19487 => (16#2028#, 16#0020#, 16#0019#),
         19488 => (16#207B#, 16#0020#, 16#0019#),
         19489 => (16#2029#, 16#0020#, 16#0019#),
         19490 => (16#207A#, 16#0020#, 16#0019#),
         19491 => (16#2029#, 16#0020#, 16#0019#),
         19492 => (16#207B#, 16#0020#, 16#0019#),
         19493 => (16#2013#, 16#0020#, 16#0019#),
         19494 => (16#207A#, 16#0020#, 16#0019#),
         19495 => (16#2013#, 16#0020#, 16#0019#),
         19496 => (16#207B#, 16#0020#, 16#0019#),
         19497 => (16#2014#, 16#0020#, 16#0019#),
         19498 => (16#207A#, 16#0020#, 16#0019#),
         19499 => (16#2014#, 16#0020#, 16#0019#),
         19500 => (16#207B#, 16#0020#, 16#0019#),
         19501 => (16#1FE7#, 16#0020#, 16#0019#),
         19502 => (16#207A#, 16#0020#, 16#0019#),
         19503 => (16#1FE7#, 16#0020#, 16#0019#),
         19504 => (16#207B#, 16#0020#, 16#0019#),
         19505 => (16#1FE0#, 16#0020#, 16#0019#),
         19506 => (16#207A#, 16#0020#, 16#0019#),
         19507 => (16#1FE0#, 16#0020#, 16#0019#),
         19508 => (16#207B#, 16#0020#, 16#0019#),
         19509 => (16#1FE8#, 16#0020#, 16#0019#),
         19510 => (16#207A#, 16#0020#, 16#0019#),
         19511 => (16#1FE8#, 16#0020#, 16#0019#),
         19512 => (16#207B#, 16#0020#, 16#0019#),
         19513 => (16#201E#, 16#0020#, 16#0019#),
         19514 => (16#207A#, 16#0020#, 16#0019#),
         19515 => (16#201E#, 16#0020#, 16#0019#),
         19516 => (16#207B#, 16#0020#, 16#0019#),
         19517 => (16#201F#, 16#0020#, 16#0019#),
         19518 => (16#207A#, 16#0020#, 16#0019#),
         19519 => (16#201F#, 16#0020#, 16#0019#),
         19520 => (16#207B#, 16#0020#, 16#0019#),
         19521 => (16#2014#, 16#0020#, 16#0019#),
         19522 => (16#1FE0#, 16#0020#, 16#0019#),
         19523 => (16#2014#, 16#0020#, 16#0019#),
         19524 => (16#1FE7#, 16#0020#, 16#0019#),
         19525 => (16#2014#, 16#0020#, 16#0019#),
         19526 => (16#1FE8#, 16#0020#, 16#0019#),
         19527 => (16#2014#, 16#0020#, 16#0019#),
         19528 => (16#2059#, 16#0020#, 16#0019#),
         19529 => (16#2014#, 16#0020#, 16#0019#),
         19530 => (16#2001#, 16#0020#, 16#0019#),
         19531 => (16#2013#, 16#0020#, 16#0019#),
         19532 => (16#2001#, 16#0020#, 16#0019#),
         19533 => (16#201E#, 16#0020#, 16#0019#),
         19534 => (16#2001#, 16#0020#, 16#0019#),
         19535 => (16#201F#, 16#0020#, 16#0019#),
         19536 => (16#2001#, 16#0020#, 16#0019#),
         19537 => (16#2014#, 16#0020#, 16#0017#),
         19538 => (16#1FE0#, 16#0020#, 16#0017#),
         19539 => (16#2014#, 16#0020#, 16#0017#),
         19540 => (16#1FE7#, 16#0020#, 16#0017#),
         19541 => (16#2014#, 16#0020#, 16#0017#),
         19542 => (16#1FE8#, 16#0020#, 16#0017#),
         19543 => (16#2014#, 16#0020#, 16#0017#),
         19544 => (16#2059#, 16#0020#, 16#0017#),
         19545 => (16#2013#, 16#0020#, 16#0017#),
         19546 => (16#2066#, 16#0020#, 16#0017#),
         19547 => (16#2014#, 16#0020#, 16#0017#),
         19548 => (16#2066#, 16#0020#, 16#0017#),
         19549 => (16#2024#, 16#0020#, 16#0017#),
         19550 => (16#2059#, 16#0020#, 16#0017#),
         19551 => (16#2013#, 16#0020#, 16#0018#),
         19552 => (16#1FE0#, 16#0020#, 16#0018#),
         19553 => (16#2013#, 16#0020#, 16#0018#),
         19554 => (16#1FE7#, 16#0020#, 16#0018#),
         19555 => (16#2013#, 16#0020#, 16#0018#),
         19556 => (16#1FE8#, 16#0020#, 16#0018#),
         19557 => (16#2014#, 16#0020#, 16#0018#),
         19558 => (16#1FE0#, 16#0020#, 16#0018#),
         19559 => (16#2014#, 16#0020#, 16#0018#),
         19560 => (16#1FE7#, 16#0020#, 16#0018#),
         19561 => (16#2014#, 16#0020#, 16#0018#),
         19562 => (16#1FE8#, 16#0020#, 16#0018#),
         19563 => (16#2024#, 16#0020#, 16#0018#),
         19564 => (16#2059#, 16#0020#, 16#0018#),
         19565 => (16#2025#, 16#0020#, 16#0018#),
         19566 => (16#2059#, 16#0020#, 16#0018#),
         19567 => (16#1FC9#, 16#0020#, 16#0019#),
         19568 => (16#0000#, 16#006D#, 16#0019#),
         19569 => (16#1FC9#, 16#0020#, 16#001A#),
         19570 => (16#0000#, 16#006D#, 16#001A#),
         19571 => (16#0273#, 16#0020#, 16#0002#),
         19572 => (16#0274#, 16#0020#, 16#0002#),
         19573 => (16#1FD9#, 16#0020#, 16#0017#),
         19574 => (16#1FE0#, 16#0020#, 16#0017#),
         19575 => (16#2059#, 16#0020#, 16#0017#),
         19576 => (16#1FD9#, 16#0020#, 16#0019#),
         19577 => (16#1FE7#, 16#0020#, 16#0019#),
         19578 => (16#1FE0#, 16#0020#, 16#0019#),
         19579 => (16#1FD9#, 16#0020#, 16#0017#),
         19580 => (16#1FE7#, 16#0020#, 16#0017#),
         19581 => (16#1FE0#, 16#0020#, 16#0017#),
         19582 => (16#1FD9#, 16#0020#, 16#0017#),
         19583 => (16#1FE7#, 16#0020#, 16#0017#),
         19584 => (16#2059#, 16#0020#, 16#0017#),
         19585 => (16#1FD9#, 16#0020#, 16#0017#),
         19586 => (16#1FE8#, 16#0020#, 16#0017#),
         19587 => (16#2059#, 16#0020#, 16#0017#),
         19588 => (16#1FD9#, 16#0020#, 16#0017#),
         19589 => (16#2059#, 16#0020#, 16#0017#),
         19590 => (16#1FE0#, 16#0020#, 16#0017#),
         19591 => (16#1FD9#, 16#0020#, 16#0017#),
         19592 => (16#2059#, 16#0020#, 16#0017#),
         19593 => (16#1FE7#, 16#0020#, 16#0017#),
         19594 => (16#1FD9#, 16#0020#, 16#0017#),
         19595 => (16#2059#, 16#0020#, 16#0017#),
         19596 => (16#1FE8#, 16#0020#, 16#0017#),
         19597 => (16#1FE0#, 16#0020#, 16#0019#),
         19598 => (16#2059#, 16#0020#, 16#0019#),
         19599 => (16#1FE7#, 16#0020#, 16#0019#),
         19600 => (16#1FE7#, 16#0020#, 16#0019#),
         19601 => (16#2059#, 16#0020#, 16#0019#),
         19602 => (16#207B#, 16#0020#, 16#0019#),
         19603 => (16#1FE7#, 16#0020#, 16#0019#),
         19604 => (16#2059#, 16#0020#, 16#0019#),
         19605 => (16#207A#, 16#0020#, 16#0019#),
         19606 => (16#2013#, 16#0020#, 16#0017#),
         19607 => (16#1FE7#, 16#0020#, 16#0017#),
         19608 => (16#1FE0#, 16#0020#, 16#0017#),
         19609 => (16#2013#, 16#0020#, 16#0017#),
         19610 => (16#1FE0#, 16#0020#, 16#0017#),
         19611 => (16#1FE7#, 16#0020#, 16#0017#),
         19612 => (16#2013#, 16#0020#, 16#0019#),
         19613 => (16#1FE0#, 16#0020#, 16#0019#),
         19614 => (16#207A#, 16#0020#, 16#0019#),
         19615 => (16#2013#, 16#0020#, 16#0019#),
         19616 => (16#2059#, 16#0020#, 16#0019#),
         19617 => (16#1FE7#, 16#0020#, 16#0019#),
         19618 => (16#2013#, 16#0020#, 16#0017#),
         19619 => (16#2059#, 16#0020#, 16#0017#),
         19620 => (16#1FE7#, 16#0020#, 16#0017#),
         19621 => (16#2013#, 16#0020#, 16#0017#),
         19622 => (16#2059#, 16#0020#, 16#0017#),
         19623 => (16#1FE0#, 16#0020#, 16#0017#),
         19624 => (16#2013#, 16#0020#, 16#0019#),
         19625 => (16#2059#, 16#0020#, 16#0019#),
         19626 => (16#2059#, 16#0020#, 16#0019#),
         19627 => (16#2013#, 16#0020#, 16#0017#),
         19628 => (16#2059#, 16#0020#, 16#0017#),
         19629 => (16#2059#, 16#0020#, 16#0017#),
         19630 => (16#201E#, 16#0020#, 16#0019#),
         19631 => (16#1FE7#, 16#0020#, 16#0019#),
         19632 => (16#1FE7#, 16#0020#, 16#0019#),
         19633 => (16#201E#, 16#0020#, 16#0017#),
         19634 => (16#1FE7#, 16#0020#, 16#0017#),
         19635 => (16#1FE7#, 16#0020#, 16#0017#),
         19636 => (16#201E#, 16#0020#, 16#0019#),
         19637 => (16#2059#, 16#0020#, 16#0019#),
         19638 => (16#2059#, 16#0020#, 16#0019#),
         19639 => (16#2014#, 16#0020#, 16#0019#),
         19640 => (16#1FE7#, 16#0020#, 16#0019#),
         19641 => (16#2059#, 16#0020#, 16#0019#),
         19642 => (16#2014#, 16#0020#, 16#0017#),
         19643 => (16#1FE7#, 16#0020#, 16#0017#),
         19644 => (16#2059#, 16#0020#, 16#0017#),
         19645 => (16#2014#, 16#0020#, 16#0019#),
         19646 => (16#1FE0#, 16#0020#, 16#0019#),
         19647 => (16#207B#, 16#0020#, 16#0019#),
         19648 => (16#2014#, 16#0020#, 16#0019#),
         19649 => (16#2059#, 16#0020#, 16#0019#),
         19650 => (16#1FE8#, 16#0020#, 16#0019#),
         19651 => (16#2014#, 16#0020#, 16#0017#),
         19652 => (16#2059#, 16#0020#, 16#0017#),
         19653 => (16#1FE8#, 16#0020#, 16#0017#),
         19654 => (16#2014#, 16#0020#, 16#0019#),
         19655 => (16#2059#, 16#0020#, 16#0019#),
         19656 => (16#2059#, 16#0020#, 16#0019#),
         19657 => (16#2014#, 16#0020#, 16#0017#),
         19658 => (16#2059#, 16#0020#, 16#0017#),
         19659 => (16#2059#, 16#0020#, 16#0017#),
         19660 => (16#201F#, 16#0020#, 16#0019#),
         19661 => (16#1FE7#, 16#0020#, 16#0019#),
         19662 => (16#207A#, 16#0020#, 16#0019#),
         19663 => (16#201F#, 16#0020#, 16#0019#),
         19664 => (16#1FE8#, 16#0020#, 16#0019#),
         19665 => (16#2059#, 16#0020#, 16#0019#),
         19666 => (16#201F#, 16#0020#, 16#0017#),
         19667 => (16#1FE8#, 16#0020#, 16#0017#),
         19668 => (16#2059#, 16#0020#, 16#0017#),
         19669 => (16#2024#, 16#0020#, 16#0019#),
         19670 => (16#2059#, 16#0020#, 16#0019#),
         19671 => (16#1FE7#, 16#0020#, 16#0019#),
         19672 => (16#2024#, 16#0020#, 16#0017#),
         19673 => (16#2059#, 16#0020#, 16#0017#),
         19674 => (16#1FE7#, 16#0020#, 16#0017#),
         19675 => (16#2024#, 16#0020#, 16#0017#),
         19676 => (16#2059#, 16#0020#, 16#0017#),
         19677 => (16#2059#, 16#0020#, 16#0017#),
         19678 => (16#2024#, 16#0020#, 16#0019#),
         19679 => (16#2059#, 16#0020#, 16#0019#),
         19680 => (16#207B#, 16#0020#, 16#0019#),
         19681 => (16#2028#, 16#0020#, 16#0019#),
         19682 => (16#1FE0#, 16#0020#, 16#0019#),
         19683 => (16#2059#, 16#0020#, 16#0019#),
         19684 => (16#2028#, 16#0020#, 16#0019#),
         19685 => (16#2059#, 16#0020#, 16#0019#),
         19686 => (16#2059#, 16#0020#, 16#0019#),
         19687 => (16#2028#, 16#0020#, 16#0017#),
         19688 => (16#2059#, 16#0020#, 16#0017#),
         19689 => (16#2059#, 16#0020#, 16#0017#),
         19690 => (16#2028#, 16#0020#, 16#0019#),
         19691 => (16#2059#, 16#0020#, 16#0019#),
         19692 => (16#207A#, 16#0020#, 16#0019#),
         19693 => (16#2029#, 16#0020#, 16#0019#),
         19694 => (16#2059#, 16#0020#, 16#0019#),
         19695 => (16#2059#, 16#0020#, 16#0019#),
         19696 => (16#2029#, 16#0020#, 16#0019#),
         19697 => (16#2059#, 16#0020#, 16#0019#),
         19698 => (16#207B#, 16#0020#, 16#0019#),
         19699 => (16#2029#, 16#0020#, 16#0019#),
         19700 => (16#2059#, 16#0020#, 16#0019#),
         19701 => (16#207A#, 16#0020#, 16#0019#),
         19702 => (16#202F#, 16#0020#, 16#0019#),
         19703 => (16#1FE8#, 16#0020#, 16#0019#),
         19704 => (16#2059#, 16#0020#, 16#0019#),
         19705 => (16#202F#, 16#0020#, 16#0017#),
         19706 => (16#1FE8#, 16#0020#, 16#0017#),
         19707 => (16#2059#, 16#0020#, 16#0017#),
         19708 => (16#203A#, 16#0020#, 16#0019#),
         19709 => (16#2059#, 16#0020#, 16#0019#),
         19710 => (16#1FE7#, 16#0020#, 16#0019#),
         19711 => (16#203A#, 16#0020#, 16#0019#),
         19712 => (16#2059#, 16#0020#, 16#0019#),
         19713 => (16#2059#, 16#0020#, 16#0019#),
         19714 => (16#2052#, 16#0020#, 16#0019#),
         19715 => (16#1FE7#, 16#0020#, 16#0019#),
         19716 => (16#2059#, 16#0020#, 16#0019#),
         19717 => (16#2052#, 16#0020#, 16#0019#),
         19718 => (16#1FE7#, 16#0020#, 16#0019#),
         19719 => (16#207B#, 16#0020#, 16#0019#),
         19720 => (16#2052#, 16#0020#, 16#0019#),
         19721 => (16#1FE7#, 16#0020#, 16#0019#),
         19722 => (16#207A#, 16#0020#, 16#0019#),
         19723 => (16#2052#, 16#0020#, 16#0017#),
         19724 => (16#1FE0#, 16#0020#, 16#0017#),
         19725 => (16#1FE0#, 16#0020#, 16#0017#),
         19726 => (16#2052#, 16#0020#, 16#0019#),
         19727 => (16#1FE0#, 16#0020#, 16#0019#),
         19728 => (16#1FE0#, 16#0020#, 16#0019#),
         19729 => (16#2052#, 16#0020#, 16#0019#),
         19730 => (16#1FE8#, 16#0020#, 16#0019#),
         19731 => (16#2059#, 16#0020#, 16#0019#),
         19732 => (16#2052#, 16#0020#, 16#0017#),
         19733 => (16#1FE8#, 16#0020#, 16#0017#),
         19734 => (16#2059#, 16#0020#, 16#0017#),
         19735 => (16#2052#, 16#0020#, 16#0019#),
         19736 => (16#2059#, 16#0020#, 16#0019#),
         19737 => (16#1FE7#, 16#0020#, 16#0019#),
         19738 => (16#2052#, 16#0020#, 16#0017#),
         19739 => (16#2059#, 16#0020#, 16#0017#),
         19740 => (16#1FE7#, 16#0020#, 16#0017#),
         19741 => (16#2059#, 16#0020#, 16#0017#),
         19742 => (16#1FE7#, 16#0020#, 16#0017#),
         19743 => (16#1FE0#, 16#0020#, 16#0017#),
         19744 => (16#2059#, 16#0020#, 16#0019#),
         19745 => (16#1FE7#, 16#0020#, 16#0019#),
         19746 => (16#207B#, 16#0020#, 16#0019#),
         19747 => (16#2059#, 16#0020#, 16#0017#),
         19748 => (16#1FE0#, 16#0020#, 16#0017#),
         19749 => (16#2059#, 16#0020#, 16#0017#),
         19750 => (16#2059#, 16#0020#, 16#0017#),
         19751 => (16#1FE8#, 16#0020#, 16#0017#),
         19752 => (16#2059#, 16#0020#, 16#0017#),
         19753 => (16#2059#, 16#0020#, 16#0017#),
         19754 => (16#1FE0#, 16#0020#, 16#0017#),
         19755 => (16#1FE8#, 16#0020#, 16#0017#),
         19756 => (16#2066#, 16#0020#, 16#0017#),
         19757 => (16#2059#, 16#0020#, 16#0017#),
         19758 => (16#1FE0#, 16#0020#, 16#0017#),
         19759 => (16#205D#, 16#0020#, 16#0017#),
         19760 => (16#1FE7#, 16#0020#, 16#0017#),
         19761 => (16#2059#, 16#0020#, 16#0017#),
         19762 => (16#205D#, 16#0020#, 16#0019#),
         19763 => (16#1FE7#, 16#0020#, 16#0019#),
         19764 => (16#207A#, 16#0020#, 16#0019#),
         19765 => (16#205D#, 16#0020#, 16#0019#),
         19766 => (16#1FE0#, 16#0020#, 16#0019#),
         19767 => (16#2059#, 16#0020#, 16#0019#),
         19768 => (16#205D#, 16#0020#, 16#0017#),
         19769 => (16#1FE0#, 16#0020#, 16#0017#),
         19770 => (16#2059#, 16#0020#, 16#0017#),
         19771 => (16#205D#, 16#0020#, 16#0019#),
         19772 => (16#1FE0#, 16#0020#, 16#0019#),
         19773 => (16#207A#, 16#0020#, 16#0019#),
         19774 => (16#205D#, 16#0020#, 16#0019#),
         19775 => (16#2059#, 16#0020#, 16#0019#),
         19776 => (16#207B#, 16#0020#, 16#0019#),
         19777 => (16#205D#, 16#0020#, 16#0019#),
         19778 => (16#2059#, 16#0020#, 16#0019#),
         19779 => (16#207A#, 16#0020#, 16#0019#),
         19780 => (16#207B#, 16#0020#, 16#0019#),
         19781 => (16#2059#, 16#0020#, 16#0019#),
         19782 => (16#2059#, 16#0020#, 16#0019#),
         19783 => (16#207B#, 16#0020#, 16#0017#),
         19784 => (16#2059#, 16#0020#, 16#0017#),
         19785 => (16#2059#, 16#0020#, 16#0017#),
         19786 => (16#1FCB#, 16#0020#, 16#0019#),
         19787 => (16#1FE8#, 16#0020#, 16#0019#),
         19788 => (16#207B#, 16#0020#, 16#0019#),
         19789 => (16#1FD9#, 16#0020#, 16#0019#),
         19790 => (16#1FE0#, 16#0020#, 16#0019#),
         19791 => (16#207B#, 16#0020#, 16#0019#),
         19792 => (16#1FD9#, 16#0020#, 16#0019#),
         19793 => (16#1FE0#, 16#0020#, 16#0019#),
         19794 => (16#207A#, 16#0020#, 16#0019#),
         19795 => (16#1FD9#, 16#0020#, 16#0019#),
         19796 => (16#1FE8#, 16#0020#, 16#0019#),
         19797 => (16#207B#, 16#0020#, 16#0019#),
         19798 => (16#1FD9#, 16#0020#, 16#0019#),
         19799 => (16#1FE8#, 16#0020#, 16#0019#),
         19800 => (16#207A#, 16#0020#, 16#0019#),
         19801 => (16#1FD9#, 16#0020#, 16#0019#),
         19802 => (16#2059#, 16#0020#, 16#0019#),
         19803 => (16#207B#, 16#0020#, 16#0019#),
         19804 => (16#1FD9#, 16#0020#, 16#0019#),
         19805 => (16#2059#, 16#0020#, 16#0019#),
         19806 => (16#207A#, 16#0020#, 16#0019#),
         19807 => (16#1FE0#, 16#0020#, 16#0019#),
         19808 => (16#2059#, 16#0020#, 16#0019#),
         19809 => (16#207B#, 16#0020#, 16#0019#),
         19810 => (16#1FE0#, 16#0020#, 16#0019#),
         19811 => (16#1FE7#, 16#0020#, 16#0019#),
         19812 => (16#207A#, 16#0020#, 16#0019#),
         19813 => (16#1FE0#, 16#0020#, 16#0019#),
         19814 => (16#2059#, 16#0020#, 16#0019#),
         19815 => (16#207A#, 16#0020#, 16#0019#),
         19816 => (16#2013#, 16#0020#, 16#0019#),
         19817 => (16#1FE8#, 16#0020#, 16#0019#),
         19818 => (16#207A#, 16#0020#, 16#0019#),
         19819 => (16#201E#, 16#0020#, 16#0019#),
         19820 => (16#1FE7#, 16#0020#, 16#0019#),
         19821 => (16#207B#, 16#0020#, 16#0019#),
         19822 => (16#2014#, 16#0020#, 16#0019#),
         19823 => (16#1FE7#, 16#0020#, 16#0019#),
         19824 => (16#207B#, 16#0020#, 16#0019#),
         19825 => (16#201F#, 16#0020#, 16#0019#),
         19826 => (16#1FE7#, 16#0020#, 16#0019#),
         19827 => (16#207B#, 16#0020#, 16#0019#),
         19828 => (16#2052#, 16#0020#, 16#0019#),
         19829 => (16#1FE0#, 16#0020#, 16#0019#),
         19830 => (16#207B#, 16#0020#, 16#0019#),
         19831 => (16#2052#, 16#0020#, 16#0019#),
         19832 => (16#2059#, 16#0020#, 16#0019#),
         19833 => (16#207B#, 16#0020#, 16#0019#),
         19834 => (16#207B#, 16#0020#, 16#0019#),
         19835 => (16#1FE7#, 16#0020#, 16#0019#),
         19836 => (16#207B#, 16#0020#, 16#0019#),
         19837 => (16#207B#, 16#0020#, 16#0019#),
         19838 => (16#1FE0#, 16#0020#, 16#0019#),
         19839 => (16#207B#, 16#0020#, 16#0019#),
         19840 => (16#207B#, 16#0020#, 16#0019#),
         19841 => (16#2059#, 16#0020#, 16#0019#),
         19842 => (16#207B#, 16#0020#, 16#0019#),
         19843 => (16#2059#, 16#0020#, 16#0019#),
         19844 => (16#2059#, 16#0020#, 16#0019#),
         19845 => (16#207B#, 16#0020#, 16#0019#),
         19846 => (16#203A#, 16#0020#, 16#0019#),
         19847 => (16#2059#, 16#0020#, 16#0019#),
         19848 => (16#207B#, 16#0020#, 16#0019#),
         19849 => (16#205D#, 16#0020#, 16#0019#),
         19850 => (16#1FE7#, 16#0020#, 16#0019#),
         19851 => (16#207B#, 16#0020#, 16#0019#),
         19852 => (16#203A#, 16#0020#, 16#0017#),
         19853 => (16#2059#, 16#0020#, 16#0017#),
         19854 => (16#1FE7#, 16#0020#, 16#0017#),
         19855 => (16#2052#, 16#0020#, 16#0017#),
         19856 => (16#1FE7#, 16#0020#, 16#0017#),
         19857 => (16#2059#, 16#0020#, 16#0017#),
         19858 => (16#2028#, 16#0020#, 16#0019#),
         19859 => (16#2059#, 16#0020#, 16#0019#),
         19860 => (16#207B#, 16#0020#, 16#0019#),
         19861 => (16#203E#, 16#0020#, 16#0019#),
         19862 => (16#2059#, 16#0020#, 16#0019#),
         19863 => (16#207B#, 16#0020#, 16#0019#),
         19864 => (16#205D#, 16#0020#, 16#0017#),
         19865 => (16#1FE0#, 16#0020#, 16#0017#),
         19866 => (16#1FE7#, 16#0020#, 16#0017#),
         19867 => (16#2059#, 16#0020#, 16#0019#),
         19868 => (16#1FE8#, 16#0020#, 16#0019#),
         19869 => (16#207B#, 16#0020#, 16#0019#),
         19870 => (16#2052#, 16#0020#, 16#0017#),
         19871 => (16#1FE0#, 16#0020#, 16#0017#),
         19872 => (16#2059#, 16#0020#, 16#0017#),
         19873 => (16#203E#, 16#0020#, 16#0019#),
         19874 => (16#2059#, 16#0020#, 16#0019#),
         19875 => (16#2059#, 16#0020#, 16#0019#),
         19876 => (16#2052#, 16#0020#, 16#0019#),
         19877 => (16#1FE0#, 16#0020#, 16#0019#),
         19878 => (16#2059#, 16#0020#, 16#0019#),
         19879 => (16#205D#, 16#0020#, 16#0019#),
         19880 => (16#1FE0#, 16#0020#, 16#0019#),
         19881 => (16#1FE7#, 16#0020#, 16#0019#),
         19882 => (16#1FE0#, 16#0020#, 16#0019#),
         19883 => (16#1FE7#, 16#0020#, 16#0019#),
         19884 => (16#207B#, 16#0020#, 16#0019#),
         19885 => (16#1FE7#, 16#0020#, 16#0019#),
         19886 => (16#1FE0#, 16#0020#, 16#0019#),
         19887 => (16#207B#, 16#0020#, 16#0019#),
         19888 => (16#2059#, 16#0020#, 16#0019#),
         19889 => (16#1FE0#, 16#0020#, 16#0019#),
         19890 => (16#207B#, 16#0020#, 16#0019#),
         19891 => (16#202F#, 16#0020#, 16#0019#),
         19892 => (16#2059#, 16#0020#, 16#0019#),
         19893 => (16#207B#, 16#0020#, 16#0019#),
         19894 => (16#1FCB#, 16#0020#, 16#0019#),
         19895 => (16#1FE7#, 16#0020#, 16#0019#),
         19896 => (16#207B#, 16#0020#, 16#0019#),
         19897 => (16#203E#, 16#0020#, 16#0017#),
         19898 => (16#2059#, 16#0020#, 16#0017#),
         19899 => (16#2059#, 16#0020#, 16#0017#),
         19900 => (16#2028#, 16#0020#, 16#0017#),
         19901 => (16#1FE0#, 16#0020#, 16#0017#),
         19902 => (16#2059#, 16#0020#, 16#0017#),
         19903 => (16#201E#, 16#0020#, 16#0017#),
         19904 => (16#2059#, 16#0020#, 16#0017#),
         19905 => (16#2059#, 16#0020#, 16#0017#),
         19906 => (16#2013#, 16#0020#, 16#0019#),
         19907 => (16#1FE8#, 16#0020#, 16#0019#),
         19908 => (16#207B#, 16#0020#, 16#0019#),
         19909 => (16#205D#, 16#0020#, 16#0019#),
         19910 => (16#1FE0#, 16#0020#, 16#0019#),
         19911 => (16#207B#, 16#0020#, 16#0019#),
         19912 => (16#201E#, 16#0020#, 16#001A#),
         19913 => (16#2052#, 16#0020#, 16#001A#),
         19914 => (16#2088#, 16#0020#, 16#001A#),
         19915 => (16#203A#, 16#0020#, 16#001A#),
         19916 => (16#2052#, 16#0020#, 16#001A#),
         19917 => (16#2088#, 16#0020#, 16#001A#),
         19918 => (16#1FC9#, 16#0020#, 16#001A#),
         19919 => (16#2052#, 16#0020#, 16#001A#),
         19920 => (16#2052#, 16#0020#, 16#001A#),
         19921 => (16#2066#, 16#0020#, 16#001A#),
         19922 => (16#1FC9#, 16#0020#, 16#001A#),
         19923 => (16#203E#, 16#0020#, 16#001A#),
         19924 => (16#1FCB#, 16#0020#, 16#001A#),
         19925 => (16#2001#, 16#0020#, 16#001A#),
         19926 => (16#2059#, 16#0020#, 16#001A#),
         19927 => (16#1FE7#, 16#0020#, 16#001A#),
         19928 => (16#2059#, 16#0020#, 16#001A#),
         19929 => (16#1FF2#, 16#0020#, 16#001A#),
         19930 => (16#201E#, 16#0020#, 16#001A#),
         19931 => (16#2052#, 16#0020#, 16#001A#),
         19932 => (16#2028#, 16#0020#, 16#001A#),
         19933 => (16#2059#, 16#0020#, 16#001A#),
         19934 => (16#2001#, 16#0020#, 16#001A#),
         19935 => (16#2013#, 16#0020#, 16#001A#),
         19936 => (16#206C#, 16#0020#, 16#001A#),
         19937 => (16#2052#, 16#0020#, 16#001A#),
         19938 => (16#2028#, 16#0020#, 16#001A#),
         19939 => (16#2052#, 16#0020#, 16#001A#),
         19940 => (16#207B#, 16#0020#, 16#001A#),
         19941 => (16#2066#, 16#0020#, 16#001A#),
         19942 => (16#206C#, 16#0020#, 16#001A#),
         19943 => (16#2013#, 16#0020#, 16#001A#),
         19944 => (16#2052#, 16#0020#, 16#001A#),
         19945 => (16#2059#, 16#0020#, 16#001A#),
         19946 => (16#201E#, 16#0020#, 16#001A#),
         19947 => (16#2052#, 16#0020#, 16#001A#),
         19948 => (16#207A#, 16#0020#, 16#001A#),
         19949 => (16#201E#, 16#0020#, 16#001A#),
         19950 => (16#2052#, 16#0020#, 16#001A#),
         19951 => (16#207A#, 16#0020#, 16#001A#),
         19952 => (16#0108#, 16#0020#, 16#001A#),
         19953 => (16#1FC9#, 16#0020#, 16#001A#),
         19954 => (16#2052#, 16#0020#, 16#001A#),
         19955 => (16#2052#, 16#0020#, 16#001A#),
         19956 => (16#2066#, 16#0020#, 16#001A#),
         19957 => (16#0108#, 16#0020#, 16#001A#),
         19958 => (16#2028#, 16#0020#, 16#001A#),
         19959 => (16#2052#, 16#0020#, 16#001A#),
         19960 => (16#207B#, 16#0020#, 16#001A#),
         19961 => (16#2066#, 16#0020#, 16#001A#),
         19962 => (16#0108#, 16#0020#, 16#001A#),
         19963 => (16#206C#, 16#0020#, 16#001A#),
         19964 => (16#2013#, 16#0020#, 16#001A#),
         19965 => (16#2052#, 16#0020#, 16#001A#),
         19966 => (16#2059#, 16#0020#, 16#001A#),
         19967 => (16#1FE0#, 16#0020#, 16#001A#),
         19968 => (16#2052#, 16#0020#, 16#001A#),
         19969 => (16#0108#, 16#0020#, 16#001A#),
         19970 => (16#1FE0#, 16#0020#, 16#001A#),
         19971 => (16#2052#, 16#0020#, 16#001A#),
         19972 => (16#1FC9#, 16#0020#, 16#001A#),
         19973 => (16#2052#, 16#0020#, 16#001A#),
         19974 => (16#2066#, 16#0020#, 16#001A#),
         19975 => (16#16F5#, 16#0020#, 16#0002#),
         19976 => (16#03C5#, 16#0020#, 16#0002#),
         19977 => (16#0120#, 16#0020#, 16#0016#),
         19978 => (16#012F#, 16#0020#, 16#0016#),
         19979 => (16#0186#, 16#0020#, 16#0016#),
         19980 => (16#0137#, 16#0020#, 16#0016#),
         19981 => (16#0132#, 16#0020#, 16#0016#),
         19982 => (16#015E#, 16#0020#, 16#0016#),
         19983 => (16#0163#, 16#0020#, 16#0016#),
         19984 => (16#026D#, 16#0020#, 16#0016#),
         19985 => (16#026E#, 16#0020#, 16#0016#),
         19986 => (16#0173#, 16#0020#, 16#0016#),
         19987 => (16#0173#, 16#0020#, 16#0016#),
         19988 => (16#0173#, 16#0020#, 16#0016#),
         19989 => (16#0115#, 16#0020#, 16#0016#),
         19990 => (16#0114#, 16#0020#, 16#0016#),
         19991 => (16#010A#, 16#0020#, 16#0016#),
         19992 => (16#0209#, 16#0020#, 16#0016#),
         19993 => (16#020A#, 16#0020#, 16#0016#),
         19994 => (16#020D#, 16#0020#, 16#0016#),
         19995 => (16#020E#, 16#0020#, 16#0016#),
         19996 => (16#026B#, 16#0020#, 16#0016#),
         19997 => (16#026C#, 16#0020#, 16#0016#),
         19998 => (16#0269#, 16#0020#, 16#0016#),
         19999 => (16#026A#, 16#0020#, 16#0016#),
         20000 => (16#0263#, 16#0020#, 16#0016#),
         20001 => (16#0264#, 16#0020#, 16#0016#),
         20002 => (16#0261#, 16#0020#, 16#0016#),
         20003 => (16#0262#, 16#0020#, 16#0016#),
         20004 => (16#0265#, 16#0020#, 16#0016#),
         20005 => (16#0266#, 16#0020#, 16#0016#),
         20006 => (16#0267#, 16#0020#, 16#0016#),
         20007 => (16#0268#, 16#0020#, 16#0016#),
         20008 => (16#0130#, 16#0020#, 16#0002#),
         20009 => (16#0131#, 16#0020#, 16#0002#),
         20010 => (16#020B#, 16#0020#, 16#0016#),
         20011 => (16#020C#, 16#0020#, 16#0016#),
         20012 => (16#0109#, 16#0020#, 16#0004#),
         20013 => (16#010A#, 16#0020#, 16#0004#),
         20014 => (16#0120#, 16#0020#, 16#000F#),
         20015 => (16#012F#, 16#0020#, 16#000F#),
         20016 => (16#0173#, 16#0020#, 16#000F#),
         20017 => (16#0132#, 16#0020#, 16#000F#),
         20018 => (16#0137#, 16#0020#, 16#000F#),
         20019 => (16#0163#, 16#0020#, 16#000F#),
         20020 => (16#015E#, 16#0020#, 16#000F#),
         20021 => (16#0115#, 16#0020#, 16#000F#),
         20022 => (16#0209#, 16#0020#, 16#000F#),
         20023 => (16#020A#, 16#0020#, 16#000F#),
         20024 => (16#020D#, 16#0020#, 16#000F#),
         20025 => (16#020E#, 16#0020#, 16#000F#),
         20026 => (16#026B#, 16#0020#, 16#000F#),
         20027 => (16#026C#, 16#0020#, 16#000F#),
         20028 => (16#028A#, 16#0020#, 16#000F#),
         20029 => (16#0288#, 16#0020#, 16#000F#),
         20030 => (16#0281#, 16#0020#, 16#000F#),
         20031 => (16#04D6#, 16#0020#, 16#000F#),
         20032 => (16#010C#, 16#0020#, 16#000F#),
         20033 => (16#04DA#, 16#0020#, 16#000F#),
         20034 => (16#04DC#, 16#0020#, 16#000F#),
         20035 => (16#04DB#, 16#0020#, 16#000F#),
         20036 => (16#0287#, 16#0020#, 16#000F#),
         20037 => (16#16CA#, 16#0020#, 16#000F#),
         20038 => (16#028B#, 16#0020#, 16#000F#),
         20039 => (16#0280#, 16#0020#, 16#000F#),
         20040 => (16#0000#, 16#006D#, 16#0018#),
         20041 => (16#0000#, 16#0081#, 16#001A#),
         20042 => (16#0000#, 16#0081#, 16#0018#),
         20043 => (16#1FBC#, 16#0020#, 16#001A#),
         20044 => (16#1FBC#, 16#0020#, 16#0019#),
         20045 => (16#1FBD#, 16#0020#, 16#001A#),
         20046 => (16#1FBD#, 16#0020#, 16#0019#),
         20047 => (16#1FC0#, 16#0020#, 16#001A#),
         20048 => (16#1FC0#, 16#0020#, 16#0019#),
         20049 => (16#1FC1#, 16#0020#, 16#001A#),
         20050 => (16#1FC1#, 16#0020#, 16#0019#),
         20051 => (16#1FD8#, 16#0020#, 16#001A#),
         20052 => (16#1FD8#, 16#0020#, 16#0019#),
         20053 => (16#1FF2#, 16#0020#, 16#0019#),
         20054 => (16#1FF3#, 16#0020#, 16#0019#),
         20055 => (16#2002#, 16#0020#, 16#001A#),
         20056 => (16#201E#, 16#0020#, 16#0018#),
         20057 => (16#201F#, 16#0020#, 16#0018#),
         20058 => (16#2025#, 16#0020#, 16#0019#),
         20059 => (16#2028#, 16#0020#, 16#0018#),
         20060 => (16#2029#, 16#0020#, 16#0018#),
         20061 => (16#202F#, 16#0020#, 16#0018#),
         20062 => (16#203A#, 16#0020#, 16#0018#),
         20063 => (16#2066#, 16#0020#, 16#0019#),
         20064 => (16#2052#, 16#0020#, 16#001A#),
         20065 => (16#1FBC#, 16#0020#, 16#001A#),
         20066 => (16#2052#, 16#0020#, 16#0019#),
         20067 => (16#1FBC#, 16#0020#, 16#0019#),
         20068 => (16#2052#, 16#0020#, 16#001A#),
         20069 => (16#1FBD#, 16#0020#, 16#001A#),
         20070 => (16#2052#, 16#0020#, 16#0019#),
         20071 => (16#1FBD#, 16#0020#, 16#0019#),
         20072 => (16#2052#, 16#0020#, 16#001A#),
         20073 => (16#1FC1#, 16#0020#, 16#001A#),
         20074 => (16#2052#, 16#0020#, 16#0019#),
         20075 => (16#1FC1#, 16#0020#, 16#0019#),
         20076 => (16#2052#, 16#0020#, 16#0019#),
         20077 => (16#1FC9#, 16#0020#, 16#0019#),
         20078 => (16#015E#, 16#0020#, 16#0003#),
         20079 => (16#01FE#, 16#0020#, 16#0003#),
         20080 => (16#028A#, 16#0020#, 16#0003#),
         20081 => (16#16CA#, 16#0020#, 16#0003#),
         20082 => (16#028B#, 16#0020#, 16#0003#),
         20083 => (16#0288#, 16#0020#, 16#0003#),
         20084 => (16#01F7#, 16#0020#, 16#0003#),
         20085 => (16#0209#, 16#0020#, 16#0003#),
         20086 => (16#020A#, 16#0020#, 16#0003#),
         20087 => (16#0281#, 16#0020#, 16#0003#),
         20088 => (16#04D6#, 16#0020#, 16#0003#),
         20089 => (16#0120#, 16#0020#, 16#0003#),
         20090 => (16#010C#, 16#0020#, 16#0003#),
         20091 => (16#0173#, 16#0020#, 16#0003#),
         20092 => (16#0286#, 16#0020#, 16#0003#),
         20093 => (16#1803#, 16#0020#, 16#0003#),
         20094 => (16#1804#, 16#0020#, 16#0003#),
         20095 => (16#1805#, 16#0020#, 16#0003#),
         20096 => (16#1806#, 16#0020#, 16#0003#),
         20097 => (16#1807#, 16#0020#, 16#0003#),
         20098 => (16#1808#, 16#0020#, 16#0003#),
         20099 => (16#1809#, 16#0020#, 16#0003#),
         20100 => (16#180A#, 16#0020#, 16#0003#),
         20101 => (16#180B#, 16#0020#, 16#0003#),
         20102 => (16#180C#, 16#0020#, 16#0003#),
         20103 => (16#0137#, 16#0020#, 16#0003#),
         20104 => (16#0132#, 16#0020#, 16#0003#),
         20105 => (16#04DA#, 16#0020#, 16#0003#),
         20106 => (16#04DB#, 16#0020#, 16#0003#),
         20107 => (16#04DC#, 16#0020#, 16#0003#),
         20108 => (16#0163#, 16#0020#, 16#0003#),
         20109 => (16#0280#, 16#0020#, 16#0003#),
         20110 => (16#190C#, 16#0020#, 16#0009#),
         20111 => (16#1925#, 16#0020#, 16#0009#),
         20112 => (16#193E#, 16#0020#, 16#0009#),
         20113 => (16#1953#, 16#0020#, 16#0009#),
         20114 => (16#196E#, 16#0020#, 16#0009#),
         20115 => (16#19A9#, 16#0020#, 16#0009#),
         20116 => (16#19B8#, 16#0020#, 16#0009#),
         20117 => (16#19DC#, 16#0020#, 16#0009#),
         20118 => (16#19F6#, 16#0020#, 16#0009#),
         20119 => (16#1A10#, 16#0020#, 16#0009#),
         20120 => (16#1A29#, 16#0020#, 16#0009#),
         20121 => (16#1A3B#, 16#0020#, 16#0009#),
         20122 => (16#1A6E#, 16#0020#, 16#0009#),
         20123 => (16#1A7D#, 16#0020#, 16#0009#),
         20124 => (16#1AA1#, 16#0020#, 16#0009#),
         20125 => (16#1ACE#, 16#0020#, 16#0009#),
         20126 => (16#1AE3#, 16#0020#, 16#0009#),
         20127 => (16#1AF5#, 16#0020#, 16#0009#),
         20128 => (16#1B33#, 16#0020#, 16#0009#),
         20129 => (16#1B57#, 16#0020#, 16#0009#),
         20130 => (16#1B77#, 16#0020#, 16#0009#),
         20131 => (16#1BA5#, 16#0020#, 16#0009#),
         20132 => (16#1BB7#, 16#0020#, 16#0009#),
         20133 => (16#1BC1#, 16#0020#, 16#0009#),
         20134 => (16#1BCD#, 16#0020#, 16#0009#),
         20135 => (16#1BE3#, 16#0020#, 16#0009#),
         20136 => (16#020B#, 16#0020#, 16#0003#),
         20137 => (16#0287#, 16#0020#, 16#0003#),
         20138 => (16#020C#, 16#0020#, 16#0003#),
         20139 => (16#0349#, 16#0020#, 16#0003#),
         20140 => (16#010A#, 16#0020#, 16#0003#),
         20141 => (16#0346#, 16#0020#, 16#0003#),
         20142 => (16#190C#, 16#0020#, 16#0003#),
         20143 => (16#1925#, 16#0020#, 16#0003#),
         20144 => (16#193E#, 16#0020#, 16#0003#),
         20145 => (16#1953#, 16#0020#, 16#0003#),
         20146 => (16#196E#, 16#0020#, 16#0003#),
         20147 => (16#19A9#, 16#0020#, 16#0003#),
         20148 => (16#19B8#, 16#0020#, 16#0003#),
         20149 => (16#19DC#, 16#0020#, 16#0003#),
         20150 => (16#19F6#, 16#0020#, 16#0003#),
         20151 => (16#1A10#, 16#0020#, 16#0003#),
         20152 => (16#1A29#, 16#0020#, 16#0003#),
         20153 => (16#1A3B#, 16#0020#, 16#0003#),
         20154 => (16#1A6E#, 16#0020#, 16#0003#),
         20155 => (16#1A7D#, 16#0020#, 16#0003#),
         20156 => (16#1AA1#, 16#0020#, 16#0003#),
         20157 => (16#1ACE#, 16#0020#, 16#0003#),
         20158 => (16#1AE3#, 16#0020#, 16#0003#),
         20159 => (16#1AF5#, 16#0020#, 16#0003#),
         20160 => (16#1B33#, 16#0020#, 16#0003#),
         20161 => (16#1B57#, 16#0020#, 16#0003#),
         20162 => (16#1B77#, 16#0020#, 16#0003#),
         20163 => (16#1BA5#, 16#0020#, 16#0003#),
         20164 => (16#1BB7#, 16#0020#, 16#0003#),
         20165 => (16#1BC1#, 16#0020#, 16#0003#),
         20166 => (16#1BCD#, 16#0020#, 16#0003#),
         20167 => (16#1BE3#, 16#0020#, 16#0003#),
         20168 => (16#020D#, 16#0020#, 16#0003#),
         20169 => (16#04DE#, 16#0020#, 16#0003#),
         20170 => (16#020E#, 16#0020#, 16#0003#),
         20171 => (16#04E0#, 16#0020#, 16#0003#),
         20172 => (16#021F#, 16#0020#, 16#0003#),
         20173 => (16#0220#, 16#0020#, 16#0003#),
         20174 => (16#0186#, 16#0020#, 16#0012#),
         20175 => (16#0265#, 16#0020#, 16#0012#),
         20176 => (16#0266#, 16#0020#, 16#0012#),
         20177 => (16#012F#, 16#0020#, 16#0012#),
         20178 => (16#011F#, 16#0020#, 16#0012#),
         20179 => (16#38B8#, 16#0020#, 16#0012#),
         20180 => (16#3888#, 16#0020#, 16#0010#),
         20181 => (16#3889#, 16#0020#, 16#0010#),
         20182 => (16#388A#, 16#0020#, 16#0010#),
         20183 => (16#388C#, 16#0020#, 16#0010#),
         20184 => (16#388D#, 16#0020#, 16#0010#),
         20185 => (16#38AC#, 16#0020#, 16#0010#),
         20186 => (16#38AD#, 16#0020#, 16#0010#),
         20187 => (16#38AF#, 16#0020#, 16#0010#),
         20188 => (16#389A#, 16#0020#, 16#0010#),
         20189 => (16#16C6#, 16#0020#, 16#0012#),
         20190 => (16#3888#, 16#0020#, 16#0012#),
         20191 => (16#3889#, 16#0020#, 16#0012#),
         20192 => (16#388A#, 16#0020#, 16#0012#),
         20193 => (16#388C#, 16#0020#, 16#0012#),
         20194 => (16#388D#, 16#0020#, 16#0012#),
         20195 => (16#388E#, 16#0020#, 16#0012#),
         20196 => (16#388F#, 16#0020#, 16#0012#),
         20197 => (16#3890#, 16#0020#, 16#0012#),
         20198 => (16#3891#, 16#0020#, 16#0012#),
         20199 => (16#3892#, 16#0020#, 16#0012#),
         20200 => (16#3893#, 16#0020#, 16#0012#),
         20201 => (16#3894#, 16#0020#, 16#0012#),
         20202 => (16#3895#, 16#0020#, 16#0012#),
         20203 => (16#3896#, 16#0020#, 16#0012#),
         20204 => (16#3897#, 16#0020#, 16#0012#),
         20205 => (16#3898#, 16#0020#, 16#0012#),
         20206 => (16#3899#, 16#0020#, 16#0012#),
         20207 => (16#389A#, 16#0020#, 16#0012#),
         20208 => (16#389B#, 16#0020#, 16#0012#),
         20209 => (16#389C#, 16#0020#, 16#0012#),
         20210 => (16#389D#, 16#0020#, 16#0012#),
         20211 => (16#389E#, 16#0020#, 16#0012#),
         20212 => (16#389F#, 16#0020#, 16#0012#),
         20213 => (16#38A0#, 16#0020#, 16#0012#),
         20214 => (16#38A1#, 16#0020#, 16#0012#),
         20215 => (16#38A2#, 16#0020#, 16#0012#),
         20216 => (16#38A3#, 16#0020#, 16#0012#),
         20217 => (16#38A4#, 16#0020#, 16#0012#),
         20218 => (16#38A5#, 16#0020#, 16#0012#),
         20219 => (16#38A6#, 16#0020#, 16#0012#),
         20220 => (16#38A7#, 16#0020#, 16#0012#),
         20221 => (16#38A8#, 16#0020#, 16#0012#),
         20222 => (16#38A9#, 16#0020#, 16#0012#),
         20223 => (16#38AA#, 16#0020#, 16#0012#),
         20224 => (16#38AB#, 16#0020#, 16#0012#),
         20225 => (16#38AC#, 16#0020#, 16#0012#),
         20226 => (16#38AD#, 16#0020#, 16#0012#),
         20227 => (16#38AF#, 16#0020#, 16#0012#),
         20228 => (16#38B0#, 16#0020#, 16#0012#),
         20229 => (16#38B1#, 16#0020#, 16#0012#),
         20230 => (16#38B2#, 16#0020#, 16#0012#),
         20231 => (16#38B3#, 16#0020#, 16#0012#),
         20232 => (16#38B4#, 16#0020#, 16#0012#),
         20233 => (16#38B5#, 16#0020#, 16#0012#),
         20234 => (16#38B9#, 16#0020#, 16#0012#),
         20235 => (16#0000#, 16#0037#, 16#0012#),
         20236 => (16#0000#, 16#0038#, 16#0012#),
         20237 => (16#37A0#, 16#0020#, 16#0012#),
         20238 => (16#3723#, 16#0020#, 16#0012#),
         20239 => (16#3724#, 16#0020#, 16#0012#),
         20240 => (16#3801#, 16#0020#, 16#0012#),
         20241 => (16#3725#, 16#0020#, 16#0012#),
         20242 => (16#3803#, 16#0020#, 16#0012#),
         20243 => (16#3804#, 16#0020#, 16#0012#),
         20244 => (16#3726#, 16#0020#, 16#0012#),
         20245 => (16#3727#, 16#0020#, 16#0012#),
         20246 => (16#3728#, 16#0020#, 16#0012#),
         20247 => (16#3807#, 16#0020#, 16#0012#),
         20248 => (16#3808#, 16#0020#, 16#0012#),
         20249 => (16#3809#, 16#0020#, 16#0012#),
         20250 => (16#380A#, 16#0020#, 16#0012#),
         20251 => (16#380B#, 16#0020#, 16#0012#),
         20252 => (16#380C#, 16#0020#, 16#0012#),
         20253 => (16#373D#, 16#0020#, 16#0012#),
         20254 => (16#3729#, 16#0020#, 16#0012#),
         20255 => (16#372A#, 16#0020#, 16#0012#),
         20256 => (16#372B#, 16#0020#, 16#0012#),
         20257 => (16#3744#, 16#0020#, 16#0012#),
         20258 => (16#372C#, 16#0020#, 16#0012#),
         20259 => (16#372D#, 16#0020#, 16#0012#),
         20260 => (16#372E#, 16#0020#, 16#0012#),
         20261 => (16#372F#, 16#0020#, 16#0012#),
         20262 => (16#3730#, 16#0020#, 16#0012#),
         20263 => (16#3731#, 16#0020#, 16#0012#),
         20264 => (16#3732#, 16#0020#, 16#0012#),
         20265 => (16#3733#, 16#0020#, 16#0012#),
         20266 => (16#3734#, 16#0020#, 16#0012#),
         20267 => (16#3735#, 16#0020#, 16#0012#),
         20268 => (16#37A1#, 16#0020#, 16#0012#),
         20269 => (16#37A2#, 16#0020#, 16#0012#),
         20270 => (16#37A3#, 16#0020#, 16#0012#),
         20271 => (16#37A4#, 16#0020#, 16#0012#),
         20272 => (16#37A5#, 16#0020#, 16#0012#),
         20273 => (16#37A6#, 16#0020#, 16#0012#),
         20274 => (16#37A7#, 16#0020#, 16#0012#),
         20275 => (16#37A8#, 16#0020#, 16#0012#),
         20276 => (16#37A9#, 16#0020#, 16#0012#),
         20277 => (16#37AA#, 16#0020#, 16#0012#),
         20278 => (16#37AB#, 16#0020#, 16#0012#),
         20279 => (16#37AC#, 16#0020#, 16#0012#),
         20280 => (16#37AD#, 16#0020#, 16#0012#),
         20281 => (16#37AE#, 16#0020#, 16#0012#),
         20282 => (16#37AF#, 16#0020#, 16#0012#),
         20283 => (16#37B0#, 16#0020#, 16#0012#),
         20284 => (16#37B1#, 16#0020#, 16#0012#),
         20285 => (16#37B2#, 16#0020#, 16#0012#),
         20286 => (16#37B3#, 16#0020#, 16#0012#),
         20287 => (16#37B4#, 16#0020#, 16#0012#),
         20288 => (16#37B5#, 16#0020#, 16#0012#),
         20289 => (16#16C9#, 16#0020#, 16#0003#),
         20290 => (16#16CB#, 16#0020#, 16#0003#),
         20291 => (16#04DD#, 16#0020#, 16#0003#),
         20292 => (16#034A#, 16#0020#, 16#0003#),
         20293 => (16#04DF#, 16#0020#, 16#0003#),
         20294 => (16#16CC#, 16#0020#, 16#0003#),
         20295 => (16#16DF#, 16#0020#, 16#0003#),
         20296 => (16#06D6#, 16#0020#, 16#0012#),
         20297 => (16#045C#, 16#0020#, 16#0012#),
         20298 => (16#045E#, 16#0020#, 16#0012#),
         20299 => (16#045D#, 16#0020#, 16#0012#),
         20300 => (16#045F#, 16#0020#, 16#0012#),
         20301 => (16#0774#, 16#0020#, 16#0012#),
         20302 => (16#079F#, 16#0020#, 16#0012#),
         20303 => (16#16B0#, 16#0020#, 16#0002#),
         20304 => (16#FFFD#, 16#0020#, 16#0002#),
         20305 => (16#0001#, 16#0020#, 16#0002#),
         20306 => (16#FFFE#, 16#0020#, 16#0002#),
         20307 => (16#4115#, 16#0020#, 16#0002#),
         20308 => (16#4116#, 16#0020#, 16#0002#),
         20309 => (16#4117#, 16#0020#, 16#0002#),
         20310 => (16#4118#, 16#0020#, 16#0002#),
         20311 => (16#4119#, 16#0020#, 16#0002#),
         20312 => (16#411A#, 16#0020#, 16#0002#),
         20313 => (16#411B#, 16#0020#, 16#0002#),
         20314 => (16#411C#, 16#0020#, 16#0002#),
         20315 => (16#411D#, 16#0020#, 16#0002#),
         20316 => (16#411E#, 16#0020#, 16#0002#),
         20317 => (16#411F#, 16#0020#, 16#0002#),
         20318 => (16#4120#, 16#0020#, 16#0002#),
         20319 => (16#4121#, 16#0020#, 16#0002#),
         20320 => (16#4122#, 16#0020#, 16#0002#),
         20321 => (16#4123#, 16#0020#, 16#0002#),
         20322 => (16#4124#, 16#0020#, 16#0002#),
         20323 => (16#4125#, 16#0020#, 16#0002#),
         20324 => (16#4126#, 16#0020#, 16#0002#),
         20325 => (16#4127#, 16#0020#, 16#0002#),
         20326 => (16#4128#, 16#0020#, 16#0002#),
         20327 => (16#4129#, 16#0020#, 16#0002#),
         20328 => (16#412A#, 16#0020#, 16#0002#),
         20329 => (16#412B#, 16#0020#, 16#0002#),
         20330 => (16#412C#, 16#0020#, 16#0002#),
         20331 => (16#412D#, 16#0020#, 16#0002#),
         20332 => (16#412E#, 16#0020#, 16#0002#),
         20333 => (16#412F#, 16#0020#, 16#0002#),
         20334 => (16#4130#, 16#0020#, 16#0002#),
         20335 => (16#4131#, 16#0020#, 16#0002#),
         20336 => (16#4132#, 16#0020#, 16#0002#),
         20337 => (16#4133#, 16#0020#, 16#0002#),
         20338 => (16#4134#, 16#0020#, 16#0002#),
         20339 => (16#4135#, 16#0020#, 16#0002#),
         20340 => (16#4136#, 16#0020#, 16#0002#),
         20341 => (16#4137#, 16#0020#, 16#0002#),
         20342 => (16#4138#, 16#0020#, 16#0002#),
         20343 => (16#4139#, 16#0020#, 16#0002#),
         20344 => (16#413A#, 16#0020#, 16#0002#),
         20345 => (16#413B#, 16#0020#, 16#0002#),
         20346 => (16#413C#, 16#0020#, 16#0002#),
         20347 => (16#413D#, 16#0020#, 16#0002#),
         20348 => (16#413E#, 16#0020#, 16#0002#),
         20349 => (16#413F#, 16#0020#, 16#0002#),
         20350 => (16#4140#, 16#0020#, 16#0002#),
         20351 => (16#4141#, 16#0020#, 16#0002#),
         20352 => (16#4142#, 16#0020#, 16#0002#),
         20353 => (16#4143#, 16#0020#, 16#0002#),
         20354 => (16#4144#, 16#0020#, 16#0002#),
         20355 => (16#4145#, 16#0020#, 16#0002#),
         20356 => (16#4146#, 16#0020#, 16#0002#),
         20357 => (16#4147#, 16#0020#, 16#0002#),
         20358 => (16#4148#, 16#0020#, 16#0002#),
         20359 => (16#4149#, 16#0020#, 16#0002#),
         20360 => (16#414A#, 16#0020#, 16#0002#),
         20361 => (16#414B#, 16#0020#, 16#0002#),
         20362 => (16#414C#, 16#0020#, 16#0002#),
         20363 => (16#414D#, 16#0020#, 16#0002#),
         20364 => (16#414E#, 16#0020#, 16#0002#),
         20365 => (16#414F#, 16#0020#, 16#0002#),
         20366 => (16#4150#, 16#0020#, 16#0002#),
         20367 => (16#4151#, 16#0020#, 16#0002#),
         20368 => (16#4152#, 16#0020#, 16#0002#),
         20369 => (16#4153#, 16#0020#, 16#0002#),
         20370 => (16#4154#, 16#0020#, 16#0002#),
         20371 => (16#4155#, 16#0020#, 16#0002#),
         20372 => (16#4156#, 16#0020#, 16#0002#),
         20373 => (16#4157#, 16#0020#, 16#0002#),
         20374 => (16#4158#, 16#0020#, 16#0002#),
         20375 => (16#4159#, 16#0020#, 16#0002#),
         20376 => (16#415A#, 16#0020#, 16#0002#),
         20377 => (16#415B#, 16#0020#, 16#0002#),
         20378 => (16#415C#, 16#0020#, 16#0002#),
         20379 => (16#415D#, 16#0020#, 16#0002#),
         20380 => (16#415E#, 16#0020#, 16#0002#),
         20381 => (16#415F#, 16#0020#, 16#0002#),
         20382 => (16#4160#, 16#0020#, 16#0002#),
         20383 => (16#4161#, 16#0020#, 16#0002#),
         20384 => (16#4162#, 16#0020#, 16#0002#),
         20385 => (16#4163#, 16#0020#, 16#0002#),
         20386 => (16#4164#, 16#0020#, 16#0002#),
         20387 => (16#4165#, 16#0020#, 16#0002#),
         20388 => (16#4166#, 16#0020#, 16#0002#),
         20389 => (16#4167#, 16#0020#, 16#0002#),
         20390 => (16#4168#, 16#0020#, 16#0002#),
         20391 => (16#4169#, 16#0020#, 16#0002#),
         20392 => (16#416A#, 16#0020#, 16#0002#),
         20393 => (16#416B#, 16#0020#, 16#0002#),
         20394 => (16#416C#, 16#0020#, 16#0002#),
         20395 => (16#416D#, 16#0020#, 16#0002#),
         20396 => (16#416E#, 16#0020#, 16#0002#),
         20397 => (16#416F#, 16#0020#, 16#0002#),
         20398 => (16#4170#, 16#0020#, 16#0002#),
         20399 => (16#4171#, 16#0020#, 16#0002#),
         20400 => (16#4172#, 16#0020#, 16#0002#),
         20401 => (16#4173#, 16#0020#, 16#0002#),
         20402 => (16#4174#, 16#0020#, 16#0002#),
         20403 => (16#4175#, 16#0020#, 16#0002#),
         20404 => (16#4176#, 16#0020#, 16#0002#),
         20405 => (16#4177#, 16#0020#, 16#0002#),
         20406 => (16#4178#, 16#0020#, 16#0002#),
         20407 => (16#4179#, 16#0020#, 16#0002#),
         20408 => (16#417A#, 16#0020#, 16#0002#),
         20409 => (16#417B#, 16#0020#, 16#0002#),
         20410 => (16#417C#, 16#0020#, 16#0002#),
         20411 => (16#417D#, 16#0020#, 16#0002#),
         20412 => (16#417E#, 16#0020#, 16#0002#),
         20413 => (16#417F#, 16#0020#, 16#0002#),
         20414 => (16#4180#, 16#0020#, 16#0002#),
         20415 => (16#4181#, 16#0020#, 16#0002#),
         20416 => (16#4182#, 16#0020#, 16#0002#),
         20417 => (16#4183#, 16#0020#, 16#0002#),
         20418 => (16#4184#, 16#0020#, 16#0002#),
         20419 => (16#4185#, 16#0020#, 16#0002#),
         20420 => (16#4186#, 16#0020#, 16#0002#),
         20421 => (16#4187#, 16#0020#, 16#0002#),
         20422 => (16#4188#, 16#0020#, 16#0002#),
         20423 => (16#4189#, 16#0020#, 16#0002#),
         20424 => (16#418A#, 16#0020#, 16#0002#),
         20425 => (16#418B#, 16#0020#, 16#0002#),
         20426 => (16#418C#, 16#0020#, 16#0002#),
         20427 => (16#418D#, 16#0020#, 16#0002#),
         20428 => (16#418E#, 16#0020#, 16#0002#),
         20429 => (16#418F#, 16#0020#, 16#0002#),
         20430 => (16#4190#, 16#0020#, 16#0002#),
         20431 => (16#4191#, 16#0020#, 16#0002#),
         20432 => (16#4192#, 16#0020#, 16#0002#),
         20433 => (16#4193#, 16#0020#, 16#0002#),
         20434 => (16#4194#, 16#0020#, 16#0002#),
         20435 => (16#4195#, 16#0020#, 16#0002#),
         20436 => (16#4196#, 16#0020#, 16#0002#),
         20437 => (16#4197#, 16#0020#, 16#0002#),
         20438 => (16#4198#, 16#0020#, 16#0002#),
         20439 => (16#4199#, 16#0020#, 16#0002#),
         20440 => (16#419A#, 16#0020#, 16#0002#),
         20441 => (16#419B#, 16#0020#, 16#0002#),
         20442 => (16#419C#, 16#0020#, 16#0002#),
         20443 => (16#419D#, 16#0020#, 16#0002#),
         20444 => (16#419E#, 16#0020#, 16#0002#),
         20445 => (16#419F#, 16#0020#, 16#0002#),
         20446 => (16#41A0#, 16#0020#, 16#0002#),
         20447 => (16#41A1#, 16#0020#, 16#0002#),
         20448 => (16#41A2#, 16#0020#, 16#0002#),
         20449 => (16#41A3#, 16#0020#, 16#0002#),
         20450 => (16#41A4#, 16#0020#, 16#0002#),
         20451 => (16#41A5#, 16#0020#, 16#0002#),
         20452 => (16#41A6#, 16#0020#, 16#0002#),
         20453 => (16#41A7#, 16#0020#, 16#0002#),
         20454 => (16#41A8#, 16#0020#, 16#0002#),
         20455 => (16#41A9#, 16#0020#, 16#0002#),
         20456 => (16#41AA#, 16#0020#, 16#0002#),
         20457 => (16#41AB#, 16#0020#, 16#0002#),
         20458 => (16#41AC#, 16#0020#, 16#0002#),
         20459 => (16#41AD#, 16#0020#, 16#0002#),
         20460 => (16#41AE#, 16#0020#, 16#0002#),
         20461 => (16#41AF#, 16#0020#, 16#0002#),
         20462 => (16#41B0#, 16#0020#, 16#0002#),
         20463 => (16#41B1#, 16#0020#, 16#0002#),
         20464 => (16#41B2#, 16#0020#, 16#0002#),
         20465 => (16#41B3#, 16#0020#, 16#0002#),
         20466 => (16#41B4#, 16#0020#, 16#0002#),
         20467 => (16#41B5#, 16#0020#, 16#0002#),
         20468 => (16#41B6#, 16#0020#, 16#0002#),
         20469 => (16#41B7#, 16#0020#, 16#0002#),
         20470 => (16#41B8#, 16#0020#, 16#0002#),
         20471 => (16#41B9#, 16#0020#, 16#0002#),
         20472 => (16#41BA#, 16#0020#, 16#0002#),
         20473 => (16#41BB#, 16#0020#, 16#0002#),
         20474 => (16#41BC#, 16#0020#, 16#0002#),
         20475 => (16#41BD#, 16#0020#, 16#0002#),
         20476 => (16#41BE#, 16#0020#, 16#0002#),
         20477 => (16#41BF#, 16#0020#, 16#0002#),
         20478 => (16#41C0#, 16#0020#, 16#0002#),
         20479 => (16#41C1#, 16#0020#, 16#0002#),
         20480 => (16#41C2#, 16#0020#, 16#0002#),
         20481 => (16#41C3#, 16#0020#, 16#0002#),
         20482 => (16#41C4#, 16#0020#, 16#0002#),
         20483 => (16#41C5#, 16#0020#, 16#0002#),
         20484 => (16#41C6#, 16#0020#, 16#0002#),
         20485 => (16#41C7#, 16#0020#, 16#0002#),
         20486 => (16#41C8#, 16#0020#, 16#0002#),
         20487 => (16#41C9#, 16#0020#, 16#0002#),
         20488 => (16#41CA#, 16#0020#, 16#0002#),
         20489 => (16#41CB#, 16#0020#, 16#0002#),
         20490 => (16#41CC#, 16#0020#, 16#0002#),
         20491 => (16#41CD#, 16#0020#, 16#0002#),
         20492 => (16#41CE#, 16#0020#, 16#0002#),
         20493 => (16#41CF#, 16#0020#, 16#0002#),
         20494 => (16#41D0#, 16#0020#, 16#0002#),
         20495 => (16#41D1#, 16#0020#, 16#0002#),
         20496 => (16#41D2#, 16#0020#, 16#0002#),
         20497 => (16#41D3#, 16#0020#, 16#0002#),
         20498 => (16#41D4#, 16#0020#, 16#0002#),
         20499 => (16#41D5#, 16#0020#, 16#0002#),
         20500 => (16#41D6#, 16#0020#, 16#0002#),
         20501 => (16#41D7#, 16#0020#, 16#0002#),
         20502 => (16#41D8#, 16#0020#, 16#0002#),
         20503 => (16#41D9#, 16#0020#, 16#0002#),
         20504 => (16#41DA#, 16#0020#, 16#0002#),
         20505 => (16#41DB#, 16#0020#, 16#0002#),
         20506 => (16#41DC#, 16#0020#, 16#0002#),
         20507 => (16#41DD#, 16#0020#, 16#0002#),
         20508 => (16#41DE#, 16#0020#, 16#0002#),
         20509 => (16#41DF#, 16#0020#, 16#0002#),
         20510 => (16#41E0#, 16#0020#, 16#0002#),
         20511 => (16#41E1#, 16#0020#, 16#0002#),
         20512 => (16#41E2#, 16#0020#, 16#0002#),
         20513 => (16#41E3#, 16#0020#, 16#0002#),
         20514 => (16#41E4#, 16#0020#, 16#0002#),
         20515 => (16#41E5#, 16#0020#, 16#0002#),
         20516 => (16#41E6#, 16#0020#, 16#0002#),
         20517 => (16#41E7#, 16#0020#, 16#0002#),
         20518 => (16#01EC#, 16#0020#, 16#0002#),
         20519 => (16#01ED#, 16#0020#, 16#0002#),
         20520 => (16#01EE#, 16#0020#, 16#0002#),
         20521 => (16#173B#, 16#0020#, 16#0002#),
         20522 => (16#173C#, 16#0020#, 16#0002#),
         20523 => (16#173D#, 16#0020#, 16#0002#),
         20524 => (16#173E#, 16#0020#, 16#0002#),
         20525 => (16#173F#, 16#0020#, 16#0002#),
         20526 => (16#1740#, 16#0020#, 16#0002#),
         20527 => (16#1741#, 16#0020#, 16#0002#),
         20528 => (16#1742#, 16#0020#, 16#0002#),
         20529 => (16#1743#, 16#0020#, 16#0002#),
         20530 => (16#1744#, 16#0020#, 16#0002#),
         20531 => (16#1745#, 16#0020#, 16#0002#),
         20532 => (16#1746#, 16#0020#, 16#0002#),
         20533 => (16#1747#, 16#0020#, 16#0002#),
         20534 => (16#1748#, 16#0020#, 16#0002#),
         20535 => (16#1749#, 16#0020#, 16#0002#),
         20536 => (16#174A#, 16#0020#, 16#0002#),
         20537 => (16#174B#, 16#0020#, 16#0002#),
         20538 => (16#174C#, 16#0020#, 16#0002#),
         20539 => (16#174D#, 16#0020#, 16#0002#),
         20540 => (16#174E#, 16#0020#, 16#0002#),
         20541 => (16#174F#, 16#0020#, 16#0002#),
         20542 => (16#1750#, 16#0020#, 16#0002#),
         20543 => (16#1751#, 16#0020#, 16#0002#),
         20544 => (16#1752#, 16#0020#, 16#0002#),
         20545 => (16#1753#, 16#0020#, 16#0002#),
         20546 => (16#1754#, 16#0020#, 16#0002#),
         20547 => (16#1755#, 16#0020#, 16#0002#),
         20548 => (16#1756#, 16#0020#, 16#0002#),
         20549 => (16#1757#, 16#0020#, 16#0002#),
         20550 => (16#1758#, 16#0020#, 16#0002#),
         20551 => (16#1759#, 16#0020#, 16#0002#),
         20552 => (16#175A#, 16#0020#, 16#0002#),
         20553 => (16#175B#, 16#0020#, 16#0002#),
         20554 => (16#175C#, 16#0020#, 16#0002#),
         20555 => (16#175D#, 16#0020#, 16#0002#),
         20556 => (16#175E#, 16#0020#, 16#0002#),
         20557 => (16#0E30#, 16#0020#, 16#0002#),
         20558 => (16#0E31#, 16#0020#, 16#0002#),
         20559 => (16#0E32#, 16#0020#, 16#0002#),
         20560 => (16#0E33#, 16#0020#, 16#0002#),
         20561 => (16#0E34#, 16#0020#, 16#0002#),
         20562 => (16#0E35#, 16#0020#, 16#0002#),
         20563 => (16#0E36#, 16#0020#, 16#0002#),
         20564 => (16#0E37#, 16#0020#, 16#0002#),
         20565 => (16#0E38#, 16#0020#, 16#0002#),
         20566 => (16#175F#, 16#0020#, 16#0002#),
         20567 => (16#1760#, 16#0020#, 16#0002#),
         20568 => (16#1761#, 16#0020#, 16#0002#),
         20569 => (16#1762#, 16#0020#, 16#0002#),
         20570 => (16#1763#, 16#0020#, 16#0002#),
         20571 => (16#1764#, 16#0020#, 16#0002#),
         20572 => (16#1765#, 16#0020#, 16#0002#),
         20573 => (16#1766#, 16#0020#, 16#0002#),
         20574 => (16#1767#, 16#0020#, 16#0002#),
         20575 => (16#1768#, 16#0020#, 16#0002#),
         20576 => (16#1769#, 16#0020#, 16#0002#),
         20577 => (16#176A#, 16#0020#, 16#0002#),
         20578 => (16#176B#, 16#0020#, 16#0002#),
         20579 => (16#176C#, 16#0020#, 16#0002#),
         20580 => (16#176D#, 16#0020#, 16#0002#),
         20581 => (16#176E#, 16#0020#, 16#0002#),
         20582 => (16#176F#, 16#0020#, 16#0002#),
         20583 => (16#1770#, 16#0020#, 16#0002#),
         20584 => (16#1771#, 16#0020#, 16#0002#),
         20585 => (16#1772#, 16#0020#, 16#0002#),
         20586 => (16#1773#, 16#0020#, 16#0002#),
         20587 => (16#1774#, 16#0020#, 16#0002#),
         20588 => (16#1775#, 16#0020#, 16#0002#),
         20589 => (16#1776#, 16#0020#, 16#0002#),
         20590 => (16#1777#, 16#0020#, 16#0002#),
         20591 => (16#1778#, 16#0020#, 16#0002#),
         20592 => (16#1779#, 16#0020#, 16#0002#),
         20593 => (16#177A#, 16#0020#, 16#0002#),
         20594 => (16#177B#, 16#0020#, 16#0002#),
         20595 => (16#177C#, 16#0020#, 16#0002#),
         20596 => (16#177D#, 16#0020#, 16#0002#),
         20597 => (16#177E#, 16#0020#, 16#0002#),
         20598 => (16#177F#, 16#0020#, 16#0002#),
         20599 => (16#1780#, 16#0020#, 16#0002#),
         20600 => (16#1781#, 16#0020#, 16#0002#),
         20601 => (16#1782#, 16#0020#, 16#0002#),
         20602 => (16#1783#, 16#0020#, 16#0002#),
         20603 => (16#1784#, 16#0020#, 16#0002#),
         20604 => (16#1785#, 16#0020#, 16#0002#),
         20605 => (16#1786#, 16#0020#, 16#0002#),
         20606 => (16#1787#, 16#0020#, 16#0002#),
         20607 => (16#1788#, 16#0020#, 16#0002#),
         20608 => (16#1789#, 16#0020#, 16#0002#),
         20609 => (16#178A#, 16#0020#, 16#0002#),
         20610 => (16#0E39#, 16#0020#, 16#0002#),
         20611 => (16#0E3A#, 16#0020#, 16#0002#),
         20612 => (16#0E3B#, 16#0020#, 16#0002#),
         20613 => (16#0E3C#, 16#0020#, 16#0002#),
         20614 => (16#0E3D#, 16#0020#, 16#0002#),
         20615 => (16#0E3E#, 16#0020#, 16#0002#),
         20616 => (16#0E3F#, 16#0020#, 16#0002#),
         20617 => (16#0E40#, 16#0020#, 16#0002#),
         20618 => (16#0E41#, 16#0020#, 16#0002#),
         20619 => (16#0E42#, 16#0020#, 16#0002#),
         20620 => (16#0E43#, 16#0020#, 16#0002#),
         20621 => (16#0E44#, 16#0020#, 16#0002#),
         20622 => (16#0E45#, 16#0020#, 16#0002#),
         20623 => (16#0E46#, 16#0020#, 16#0002#),
         20624 => (16#0E47#, 16#0020#, 16#0002#),
         20625 => (16#0E48#, 16#0020#, 16#0002#),
         20626 => (16#0E49#, 16#0020#, 16#0002#),
         20627 => (16#178B#, 16#0020#, 16#0002#),
         20628 => (16#0E4A#, 16#0020#, 16#0002#),
         20629 => (16#0E4B#, 16#0020#, 16#0002#),
         20630 => (16#0E4C#, 16#0020#, 16#0002#),
         20631 => (16#0E4D#, 16#0020#, 16#0002#),
         20632 => (16#0E4E#, 16#0020#, 16#0002#),
         20633 => (16#0E4F#, 16#0020#, 16#0002#),
         20634 => (16#0E50#, 16#0020#, 16#0002#),
         20635 => (16#0E51#, 16#0020#, 16#0002#),
         20636 => (16#0E52#, 16#0020#, 16#0002#),
         20637 => (16#0E53#, 16#0020#, 16#0002#),
         20638 => (16#0E54#, 16#0020#, 16#0002#),
         20639 => (16#0E55#, 16#0020#, 16#0002#),
         20640 => (16#0E56#, 16#0020#, 16#0002#),
         20641 => (16#0E57#, 16#0020#, 16#0002#),
         20642 => (16#0E58#, 16#0020#, 16#0002#),
         20643 => (16#0E59#, 16#0020#, 16#0002#),
         20644 => (16#0E5A#, 16#0020#, 16#0002#),
         20645 => (16#0E5B#, 16#0020#, 16#0002#),
         20646 => (16#0E5C#, 16#0020#, 16#0002#),
         20647 => (16#0E5D#, 16#0020#, 16#0002#),
         20648 => (16#0E5E#, 16#0020#, 16#0002#),
         20649 => (16#0E5F#, 16#0020#, 16#0002#),
         20650 => (16#0E60#, 16#0020#, 16#0002#),
         20651 => (16#0E61#, 16#0020#, 16#0002#),
         20652 => (16#0E62#, 16#0020#, 16#0002#),
         20653 => (16#0E63#, 16#0020#, 16#0002#),
         20654 => (16#0E64#, 16#0020#, 16#0002#),
         20655 => (16#0E65#, 16#0020#, 16#0002#),
         20656 => (16#0E66#, 16#0020#, 16#0002#),
         20657 => (16#0E67#, 16#0020#, 16#0002#),
         20658 => (16#0E68#, 16#0020#, 16#0002#),
         20659 => (16#0E69#, 16#0020#, 16#0002#),
         20660 => (16#0E6A#, 16#0020#, 16#0002#),
         20661 => (16#0E6B#, 16#0020#, 16#0002#),
         20662 => (16#0E6C#, 16#0020#, 16#0002#),
         20663 => (16#0E6D#, 16#0020#, 16#0002#),
         20664 => (16#0E6E#, 16#0020#, 16#0002#),
         20665 => (16#0E6F#, 16#0020#, 16#0002#),
         20666 => (16#0E70#, 16#0020#, 16#0002#),
         20667 => (16#0E71#, 16#0020#, 16#0002#),
         20668 => (16#0E72#, 16#0020#, 16#0002#),
         20669 => (16#0E73#, 16#0020#, 16#0002#),
         20670 => (16#0E74#, 16#0020#, 16#0002#),
         20671 => (16#0E75#, 16#0020#, 16#0002#),
         20672 => (16#0E76#, 16#0020#, 16#0002#),
         20673 => (16#0E77#, 16#0020#, 16#0002#),
         20674 => (16#0E78#, 16#0020#, 16#0002#),
         20675 => (16#0E79#, 16#0020#, 16#0002#),
         20676 => (16#0E7A#, 16#0020#, 16#0002#),
         20677 => (16#0E7B#, 16#0020#, 16#0002#),
         20678 => (16#0E7C#, 16#0020#, 16#0002#),
         20679 => (16#0E7D#, 16#0020#, 16#0002#),
         20680 => (16#0E7E#, 16#0020#, 16#0002#),
         20681 => (16#0E7F#, 16#0020#, 16#0002#),
         20682 => (16#0E80#, 16#0020#, 16#0002#),
         20683 => (16#0E81#, 16#0020#, 16#0002#),
         20684 => (16#0E82#, 16#0020#, 16#0002#),
         20685 => (16#0E83#, 16#0020#, 16#0002#),
         20686 => (16#0E84#, 16#0020#, 16#0002#),
         20687 => (16#0000#, 16#0107#, 16#0002#),
         20688 => (16#3EDD#, 16#0020#, 16#0002#),
         20689 => (16#3EDE#, 16#0020#, 16#0002#),
         20690 => (16#3EDF#, 16#0020#, 16#0002#),
         20691 => (16#3EE0#, 16#0020#, 16#0002#),
         20692 => (16#3EE1#, 16#0020#, 16#0002#),
         20693 => (16#3EE2#, 16#0020#, 16#0002#),
         20694 => (16#3EE3#, 16#0020#, 16#0002#),
         20695 => (16#3EE4#, 16#0020#, 16#0002#),
         20696 => (16#3EE5#, 16#0020#, 16#0002#),
         20697 => (16#3EE6#, 16#0020#, 16#0002#),
         20698 => (16#3EE7#, 16#0020#, 16#0002#),
         20699 => (16#3EE8#, 16#0020#, 16#0002#),
         20700 => (16#3EE9#, 16#0020#, 16#0002#),
         20701 => (16#3EEA#, 16#0020#, 16#0002#),
         20702 => (16#3EEB#, 16#0020#, 16#0002#),
         20703 => (16#3EEC#, 16#0020#, 16#0002#),
         20704 => (16#3EED#, 16#0020#, 16#0002#),
         20705 => (16#3EEE#, 16#0020#, 16#0002#),
         20706 => (16#3EEF#, 16#0020#, 16#0002#),
         20707 => (16#3EF0#, 16#0020#, 16#0002#),
         20708 => (16#3EF1#, 16#0020#, 16#0002#),
         20709 => (16#3EF2#, 16#0020#, 16#0002#),
         20710 => (16#3EF3#, 16#0020#, 16#0002#),
         20711 => (16#3EF4#, 16#0020#, 16#0002#),
         20712 => (16#3EF5#, 16#0020#, 16#0002#),
         20713 => (16#3EF6#, 16#0020#, 16#0002#),
         20714 => (16#3EF7#, 16#0020#, 16#0002#),
         20715 => (16#3EF8#, 16#0020#, 16#0002#),
         20716 => (16#3EF9#, 16#0020#, 16#0002#),
         20717 => (16#3EFA#, 16#0020#, 16#0002#),
         20718 => (16#3EFB#, 16#0020#, 16#0002#),
         20719 => (16#3EFC#, 16#0020#, 16#0002#),
         20720 => (16#3EFD#, 16#0020#, 16#0002#),
         20721 => (16#3EFE#, 16#0020#, 16#0002#),
         20722 => (16#3EFF#, 16#0020#, 16#0002#),
         20723 => (16#3F00#, 16#0020#, 16#0002#),
         20724 => (16#3F01#, 16#0020#, 16#0002#),
         20725 => (16#3F02#, 16#0020#, 16#0002#),
         20726 => (16#3F03#, 16#0020#, 16#0002#),
         20727 => (16#3F04#, 16#0020#, 16#0002#),
         20728 => (16#3F05#, 16#0020#, 16#0002#),
         20729 => (16#3F06#, 16#0020#, 16#0002#),
         20730 => (16#3F07#, 16#0020#, 16#0002#),
         20731 => (16#3F08#, 16#0020#, 16#0002#),
         20732 => (16#3F09#, 16#0020#, 16#0002#),
         20733 => (16#3F0A#, 16#0020#, 16#0002#),
         20734 => (16#3F0B#, 16#0020#, 16#0002#),
         20735 => (16#3F0C#, 16#0020#, 16#0002#),
         20736 => (16#3F0D#, 16#0020#, 16#0002#),
         20737 => (16#3F0E#, 16#0020#, 16#0002#),
         20738 => (16#3F0F#, 16#0020#, 16#0002#),
         20739 => (16#3F10#, 16#0020#, 16#0002#),
         20740 => (16#3F11#, 16#0020#, 16#0002#),
         20741 => (16#3F12#, 16#0020#, 16#0002#),
         20742 => (16#3F13#, 16#0020#, 16#0002#),
         20743 => (16#3F14#, 16#0020#, 16#0002#),
         20744 => (16#3F15#, 16#0020#, 16#0002#),
         20745 => (16#3F16#, 16#0020#, 16#0002#),
         20746 => (16#3F17#, 16#0020#, 16#0002#),
         20747 => (16#3F18#, 16#0020#, 16#0002#),
         20748 => (16#3F19#, 16#0020#, 16#0002#),
         20749 => (16#3F1A#, 16#0020#, 16#0002#),
         20750 => (16#3F1B#, 16#0020#, 16#0002#),
         20751 => (16#3F1C#, 16#0020#, 16#0002#),
         20752 => (16#3F1D#, 16#0020#, 16#0002#),
         20753 => (16#3F1E#, 16#0020#, 16#0002#),
         20754 => (16#3F1F#, 16#0020#, 16#0002#),
         20755 => (16#3F20#, 16#0020#, 16#0002#),
         20756 => (16#3F21#, 16#0020#, 16#0002#),
         20757 => (16#3F22#, 16#0020#, 16#0002#),
         20758 => (16#3F23#, 16#0020#, 16#0002#),
         20759 => (16#3F24#, 16#0020#, 16#0002#),
         20760 => (16#3F25#, 16#0020#, 16#0002#),
         20761 => (16#3F26#, 16#0020#, 16#0002#),
         20762 => (16#3F27#, 16#0020#, 16#0002#),
         20763 => (16#3F28#, 16#0020#, 16#0002#),
         20764 => (16#3F29#, 16#0020#, 16#0002#),
         20765 => (16#3F2A#, 16#0020#, 16#0002#),
         20766 => (16#178C#, 16#0020#, 16#0002#),
         20767 => (16#178D#, 16#0020#, 16#0002#),
         20768 => (16#178E#, 16#0020#, 16#0002#),
         20769 => (16#178F#, 16#0020#, 16#0002#),
         20770 => (16#1790#, 16#0020#, 16#0002#),
         20771 => (16#1791#, 16#0020#, 16#0002#),
         20772 => (16#1792#, 16#0020#, 16#0002#),
         20773 => (16#1793#, 16#0020#, 16#0002#),
         20774 => (16#1794#, 16#0020#, 16#0002#),
         20775 => (16#1795#, 16#0020#, 16#0002#),
         20776 => (16#1796#, 16#0020#, 16#0002#),
         20777 => (16#1797#, 16#0020#, 16#0002#),
         20778 => (16#1798#, 16#0020#, 16#0002#),
         20779 => (16#1799#, 16#0020#, 16#0002#),
         20780 => (16#179A#, 16#0020#, 16#0002#),
         20781 => (16#179B#, 16#0020#, 16#0002#),
         20782 => (16#179C#, 16#0020#, 16#0002#),
         20783 => (16#179D#, 16#0020#, 16#0002#),
         20784 => (16#3F45#, 16#0020#, 16#0002#),
         20785 => (16#3F46#, 16#0020#, 16#0002#),
         20786 => (16#3F47#, 16#0020#, 16#0002#),
         20787 => (16#3F48#, 16#0020#, 16#0002#),
         20788 => (16#3F49#, 16#0020#, 16#0002#),
         20789 => (16#3F4A#, 16#0020#, 16#0002#),
         20790 => (16#3F4B#, 16#0020#, 16#0002#),
         20791 => (16#3F4C#, 16#0020#, 16#0002#),
         20792 => (16#3F4D#, 16#0020#, 16#0002#),
         20793 => (16#3F4E#, 16#0020#, 16#0002#),
         20794 => (16#3F4F#, 16#0020#, 16#0002#),
         20795 => (16#3F50#, 16#0020#, 16#0002#),
         20796 => (16#3F51#, 16#0020#, 16#0002#),
         20797 => (16#3F52#, 16#0020#, 16#0002#),
         20798 => (16#3F53#, 16#0020#, 16#0002#),
         20799 => (16#3F55#, 16#0020#, 16#0002#),
         20800 => (16#3F56#, 16#0020#, 16#0002#),
         20801 => (16#3F57#, 16#0020#, 16#0002#),
         20802 => (16#3F58#, 16#0020#, 16#0002#),
         20803 => (16#3F59#, 16#0020#, 16#0002#),
         20804 => (16#3F5A#, 16#0020#, 16#0002#),
         20805 => (16#3F5B#, 16#0020#, 16#0002#),
         20806 => (16#3F5C#, 16#0020#, 16#0002#),
         20807 => (16#3F5D#, 16#0020#, 16#0002#),
         20808 => (16#3F5E#, 16#0020#, 16#0002#),
         20809 => (16#3F5F#, 16#0020#, 16#0002#),
         20810 => (16#3F60#, 16#0020#, 16#0002#),
         20811 => (16#3F61#, 16#0020#, 16#0002#),
         20812 => (16#3F62#, 16#0020#, 16#0002#),
         20813 => (16#3F63#, 16#0020#, 16#0002#),
         20814 => (16#3F64#, 16#0020#, 16#0002#),
         20815 => (16#3F54#, 16#0020#, 16#0002#),
         20816 => (16#1739#, 16#0020#, 16#0002#),
         20817 => (16#173A#, 16#0020#, 16#0002#),
         20818 => (16#3F65#, 16#0020#, 16#0002#),
         20819 => (16#3F66#, 16#0020#, 16#0002#),
         20820 => (16#3F67#, 16#0020#, 16#0002#),
         20821 => (16#3F68#, 16#0020#, 16#0002#),
         20822 => (16#3F69#, 16#0020#, 16#0002#),
         20823 => (16#3F6A#, 16#0020#, 16#0002#),
         20824 => (16#3F6B#, 16#0020#, 16#0002#),
         20825 => (16#3F6C#, 16#0020#, 16#0002#),
         20826 => (16#3F6D#, 16#0020#, 16#0002#),
         20827 => (16#3F6E#, 16#0020#, 16#0002#),
         20828 => (16#3F6F#, 16#0020#, 16#0002#),
         20829 => (16#3F70#, 16#0020#, 16#0002#),
         20830 => (16#3F71#, 16#0020#, 16#0002#),
         20831 => (16#3F72#, 16#0020#, 16#0002#),
         20832 => (16#3F73#, 16#0020#, 16#0002#),
         20833 => (16#3F74#, 16#0020#, 16#0002#),
         20834 => (16#3F75#, 16#0020#, 16#0002#),
         20835 => (16#3F76#, 16#0020#, 16#0002#),
         20836 => (16#3F77#, 16#0020#, 16#0002#),
         20837 => (16#3F78#, 16#0020#, 16#0002#),
         20838 => (16#3F79#, 16#0020#, 16#0002#),
         20839 => (16#3F7A#, 16#0020#, 16#0002#),
         20840 => (16#3F7B#, 16#0020#, 16#0002#),
         20841 => (16#3F7C#, 16#0020#, 16#0002#),
         20842 => (16#3F7D#, 16#0020#, 16#0002#),
         20843 => (16#3F7E#, 16#0020#, 16#0002#),
         20844 => (16#3F7F#, 16#0020#, 16#0002#),
         20845 => (16#1ED2#, 16#0020#, 16#0002#),
         20846 => (16#1ED3#, 16#0020#, 16#0002#),
         20847 => (16#1ED4#, 16#0020#, 16#0002#),
         20848 => (16#1ED5#, 16#0020#, 16#0002#),
         20849 => (16#1ED6#, 16#0020#, 16#0002#),
         20850 => (16#1ED7#, 16#0020#, 16#0002#),
         20851 => (16#1ED8#, 16#0020#, 16#0002#),
         20852 => (16#1ED9#, 16#0020#, 16#0002#),
         20853 => (16#1EDA#, 16#0020#, 16#0002#),
         20854 => (16#1EDB#, 16#0020#, 16#0002#),
         20855 => (16#1EDC#, 16#0020#, 16#0002#),
         20856 => (16#1EDD#, 16#0020#, 16#0002#),
         20857 => (16#1EDE#, 16#0020#, 16#0002#),
         20858 => (16#1EDF#, 16#0020#, 16#0002#),
         20859 => (16#1EE0#, 16#0020#, 16#0002#),
         20860 => (16#1EE1#, 16#0020#, 16#0002#),
         20861 => (16#1EE2#, 16#0020#, 16#0002#),
         20862 => (16#1EE3#, 16#0020#, 16#0002#),
         20863 => (16#1EE4#, 16#0020#, 16#0002#),
         20864 => (16#1EE5#, 16#0020#, 16#0002#),
         20865 => (16#1EE6#, 16#0020#, 16#0002#),
         20866 => (16#1EE7#, 16#0020#, 16#0002#),
         20867 => (16#1EE8#, 16#0020#, 16#0002#),
         20868 => (16#1EE9#, 16#0020#, 16#0002#),
         20869 => (16#1EEA#, 16#0020#, 16#0002#),
         20870 => (16#1EEB#, 16#0020#, 16#0002#),
         20871 => (16#1EEC#, 16#0020#, 16#0002#),
         20872 => (16#1EED#, 16#0020#, 16#0002#),
         20873 => (16#1EEE#, 16#0020#, 16#0002#),
         20874 => (16#1EEF#, 16#0020#, 16#0002#),
         20875 => (16#1EF0#, 16#0020#, 16#0002#),
         20876 => (16#1EF1#, 16#0020#, 16#0002#),
         20877 => (16#1EF2#, 16#0020#, 16#0002#),
         20878 => (16#1EF3#, 16#0020#, 16#0002#),
         20879 => (16#1EF4#, 16#0020#, 16#0002#),
         20880 => (16#1EF5#, 16#0020#, 16#0002#),
         20881 => (16#1EF6#, 16#0020#, 16#0002#),
         20882 => (16#1EF7#, 16#0020#, 16#0002#),
         20883 => (16#1ED2#, 16#0020#, 16#0004#),
         20884 => (16#1ED5#, 16#0020#, 16#0004#),
         20885 => (16#1ED9#, 16#0020#, 16#0004#),
         20886 => (16#1EDF#, 16#0020#, 16#0004#),
         20887 => (16#1EE3#, 16#0020#, 16#0004#),
         20888 => (16#4484#, 16#0020#, 16#0002#),
         20889 => (16#4485#, 16#0020#, 16#0002#),
         20890 => (16#4486#, 16#0020#, 16#0002#),
         20891 => (16#4487#, 16#0020#, 16#0002#),
         20892 => (16#4488#, 16#0020#, 16#0002#),
         20893 => (16#4489#, 16#0020#, 16#0002#),
         20894 => (16#448A#, 16#0020#, 16#0002#),
         20895 => (16#448B#, 16#0020#, 16#0002#),
         20896 => (16#448C#, 16#0020#, 16#0002#),
         20897 => (16#448D#, 16#0020#, 16#0002#),
         20898 => (16#448E#, 16#0020#, 16#0002#),
         20899 => (16#448F#, 16#0020#, 16#0002#),
         20900 => (16#4490#, 16#0020#, 16#0002#),
         20901 => (16#4491#, 16#0020#, 16#0002#),
         20902 => (16#4492#, 16#0020#, 16#0002#),
         20903 => (16#4493#, 16#0020#, 16#0002#),
         20904 => (16#4494#, 16#0020#, 16#0002#),
         20905 => (16#4495#, 16#0020#, 16#0002#),
         20906 => (16#4496#, 16#0020#, 16#0002#),
         20907 => (16#4497#, 16#0020#, 16#0002#),
         20908 => (16#4498#, 16#0020#, 16#0002#),
         20909 => (16#4499#, 16#0020#, 16#0002#),
         20910 => (16#449A#, 16#0020#, 16#0002#),
         20911 => (16#449B#, 16#0020#, 16#0002#),
         20912 => (16#449C#, 16#0020#, 16#0002#),
         20913 => (16#449D#, 16#0020#, 16#0002#),
         20914 => (16#449E#, 16#0020#, 16#0002#),
         20915 => (16#449F#, 16#0020#, 16#0002#),
         20916 => (16#44A0#, 16#0020#, 16#0002#),
         20917 => (16#44A1#, 16#0020#, 16#0002#),
         20918 => (16#01EF#, 16#0020#, 16#0002#),
         20919 => (16#44A2#, 16#0020#, 16#0002#),
         20920 => (16#44A3#, 16#0020#, 16#0002#),
         20921 => (16#44A4#, 16#0020#, 16#0002#),
         20922 => (16#44A5#, 16#0020#, 16#0002#),
         20923 => (16#44A6#, 16#0020#, 16#0002#),
         20924 => (16#44A7#, 16#0020#, 16#0002#),
         20925 => (16#44A8#, 16#0020#, 16#0002#),
         20926 => (16#44A9#, 16#0020#, 16#0002#),
         20927 => (16#44AA#, 16#0020#, 16#0002#),
         20928 => (16#44AB#, 16#0020#, 16#0002#),
         20929 => (16#44AC#, 16#0020#, 16#0002#),
         20930 => (16#44AD#, 16#0020#, 16#0002#),
         20931 => (16#44AE#, 16#0020#, 16#0002#),
         20932 => (16#44AF#, 16#0020#, 16#0002#),
         20933 => (16#44B0#, 16#0020#, 16#0002#),
         20934 => (16#44B1#, 16#0020#, 16#0002#),
         20935 => (16#44B2#, 16#0020#, 16#0002#),
         20936 => (16#44B3#, 16#0020#, 16#0002#),
         20937 => (16#44B4#, 16#0020#, 16#0002#),
         20938 => (16#44B5#, 16#0020#, 16#0002#),
         20939 => (16#44B6#, 16#0020#, 16#0002#),
         20940 => (16#44B7#, 16#0020#, 16#0002#),
         20941 => (16#44B8#, 16#0020#, 16#0002#),
         20942 => (16#44B9#, 16#0020#, 16#0002#),
         20943 => (16#44BA#, 16#0020#, 16#0002#),
         20944 => (16#44BB#, 16#0020#, 16#0002#),
         20945 => (16#44BC#, 16#0020#, 16#0002#),
         20946 => (16#44BD#, 16#0020#, 16#0002#),
         20947 => (16#44BE#, 16#0020#, 16#0002#),
         20948 => (16#44BF#, 16#0020#, 16#0002#),
         20949 => (16#44C0#, 16#0020#, 16#0002#),
         20950 => (16#44C1#, 16#0020#, 16#0002#),
         20951 => (16#44C2#, 16#0020#, 16#0002#),
         20952 => (16#44C3#, 16#0020#, 16#0002#),
         20953 => (16#44C4#, 16#0020#, 16#0002#),
         20954 => (16#44C5#, 16#0020#, 16#0002#),
         20955 => (16#44C6#, 16#0020#, 16#0002#),
         20956 => (16#44C7#, 16#0020#, 16#0002#),
         20957 => (16#44C8#, 16#0020#, 16#0002#),
         20958 => (16#44C9#, 16#0020#, 16#0002#),
         20959 => (16#44CA#, 16#0020#, 16#0002#),
         20960 => (16#44CB#, 16#0020#, 16#0002#),
         20961 => (16#44CC#, 16#0020#, 16#0002#),
         20962 => (16#44CD#, 16#0020#, 16#0002#),
         20963 => (16#01F0#, 16#0020#, 16#0002#),
         20964 => (16#179E#, 16#0020#, 16#0002#),
         20965 => (16#179F#, 16#0020#, 16#0002#),
         20966 => (16#17A0#, 16#0020#, 16#0002#),
         20967 => (16#3F80#, 16#0020#, 16#0008#),
         20968 => (16#3F81#, 16#0020#, 16#0008#),
         20969 => (16#3F82#, 16#0020#, 16#0008#),
         20970 => (16#3F83#, 16#0020#, 16#0008#),
         20971 => (16#3F84#, 16#0020#, 16#0008#),
         20972 => (16#3F85#, 16#0020#, 16#0008#),
         20973 => (16#3F86#, 16#0020#, 16#0008#),
         20974 => (16#3F87#, 16#0020#, 16#0008#),
         20975 => (16#3F88#, 16#0020#, 16#0008#),
         20976 => (16#3F89#, 16#0020#, 16#0008#),
         20977 => (16#3F8A#, 16#0020#, 16#0008#),
         20978 => (16#3F8B#, 16#0020#, 16#0008#),
         20979 => (16#3F8C#, 16#0020#, 16#0008#),
         20980 => (16#3F8D#, 16#0020#, 16#0008#),
         20981 => (16#3F8E#, 16#0020#, 16#0008#),
         20982 => (16#3F8F#, 16#0020#, 16#0008#),
         20983 => (16#3F90#, 16#0020#, 16#0008#),
         20984 => (16#3F91#, 16#0020#, 16#0008#),
         20985 => (16#3F92#, 16#0020#, 16#0008#),
         20986 => (16#3F93#, 16#0020#, 16#0008#),
         20987 => (16#3F94#, 16#0020#, 16#0008#),
         20988 => (16#3F95#, 16#0020#, 16#0008#),
         20989 => (16#3F96#, 16#0020#, 16#0008#),
         20990 => (16#3F97#, 16#0020#, 16#0008#),
         20991 => (16#3F98#, 16#0020#, 16#0008#),
         20992 => (16#3F99#, 16#0020#, 16#0008#),
         20993 => (16#3F9A#, 16#0020#, 16#0008#),
         20994 => (16#3F9B#, 16#0020#, 16#0008#),
         20995 => (16#3F9C#, 16#0020#, 16#0008#),
         20996 => (16#3F9D#, 16#0020#, 16#0008#),
         20997 => (16#3F9E#, 16#0020#, 16#0008#),
         20998 => (16#3F9F#, 16#0020#, 16#0008#),
         20999 => (16#3FA0#, 16#0020#, 16#0008#),
         21000 => (16#3FA1#, 16#0020#, 16#0008#),
         21001 => (16#3FA2#, 16#0020#, 16#0008#),
         21002 => (16#3FA3#, 16#0020#, 16#0008#),
         21003 => (16#3FA4#, 16#0020#, 16#0008#),
         21004 => (16#3FA5#, 16#0020#, 16#0008#),
         21005 => (16#3FA6#, 16#0020#, 16#0008#),
         21006 => (16#3FA7#, 16#0020#, 16#0008#),
         21007 => (16#3F80#, 16#0020#, 16#0002#),
         21008 => (16#3F81#, 16#0020#, 16#0002#),
         21009 => (16#3F82#, 16#0020#, 16#0002#),
         21010 => (16#3F83#, 16#0020#, 16#0002#),
         21011 => (16#3F84#, 16#0020#, 16#0002#),
         21012 => (16#3F85#, 16#0020#, 16#0002#),
         21013 => (16#3F86#, 16#0020#, 16#0002#),
         21014 => (16#3F87#, 16#0020#, 16#0002#),
         21015 => (16#3F88#, 16#0020#, 16#0002#),
         21016 => (16#3F89#, 16#0020#, 16#0002#),
         21017 => (16#3F8A#, 16#0020#, 16#0002#),
         21018 => (16#3F8B#, 16#0020#, 16#0002#),
         21019 => (16#3F8C#, 16#0020#, 16#0002#),
         21020 => (16#3F8D#, 16#0020#, 16#0002#),
         21021 => (16#3F8E#, 16#0020#, 16#0002#),
         21022 => (16#3F8F#, 16#0020#, 16#0002#),
         21023 => (16#3F90#, 16#0020#, 16#0002#),
         21024 => (16#3F91#, 16#0020#, 16#0002#),
         21025 => (16#3F92#, 16#0020#, 16#0002#),
         21026 => (16#3F93#, 16#0020#, 16#0002#),
         21027 => (16#3F94#, 16#0020#, 16#0002#),
         21028 => (16#3F95#, 16#0020#, 16#0002#),
         21029 => (16#3F96#, 16#0020#, 16#0002#),
         21030 => (16#3F97#, 16#0020#, 16#0002#),
         21031 => (16#3F98#, 16#0020#, 16#0002#),
         21032 => (16#3F99#, 16#0020#, 16#0002#),
         21033 => (16#3F9A#, 16#0020#, 16#0002#),
         21034 => (16#3F9B#, 16#0020#, 16#0002#),
         21035 => (16#3F9C#, 16#0020#, 16#0002#),
         21036 => (16#3F9D#, 16#0020#, 16#0002#),
         21037 => (16#3F9E#, 16#0020#, 16#0002#),
         21038 => (16#3F9F#, 16#0020#, 16#0002#),
         21039 => (16#3FA0#, 16#0020#, 16#0002#),
         21040 => (16#3FA1#, 16#0020#, 16#0002#),
         21041 => (16#3FA2#, 16#0020#, 16#0002#),
         21042 => (16#3FA3#, 16#0020#, 16#0002#),
         21043 => (16#3FA4#, 16#0020#, 16#0002#),
         21044 => (16#3FA5#, 16#0020#, 16#0002#),
         21045 => (16#3FA6#, 16#0020#, 16#0002#),
         21046 => (16#3FA7#, 16#0020#, 16#0002#),
         21047 => (16#3FA8#, 16#0020#, 16#0002#),
         21048 => (16#3FA9#, 16#0020#, 16#0002#),
         21049 => (16#3FAA#, 16#0020#, 16#0002#),
         21050 => (16#3FAB#, 16#0020#, 16#0002#),
         21051 => (16#3FAC#, 16#0020#, 16#0002#),
         21052 => (16#3FAD#, 16#0020#, 16#0002#),
         21053 => (16#3FAE#, 16#0020#, 16#0002#),
         21054 => (16#3FAF#, 16#0020#, 16#0002#),
         21055 => (16#3FB0#, 16#0020#, 16#0002#),
         21056 => (16#3FB1#, 16#0020#, 16#0002#),
         21057 => (16#3FB2#, 16#0020#, 16#0002#),
         21058 => (16#3FB3#, 16#0020#, 16#0002#),
         21059 => (16#3FB4#, 16#0020#, 16#0002#),
         21060 => (16#3FB5#, 16#0020#, 16#0002#),
         21061 => (16#3FB6#, 16#0020#, 16#0002#),
         21062 => (16#3FB7#, 16#0020#, 16#0002#),
         21063 => (16#3FB8#, 16#0020#, 16#0002#),
         21064 => (16#3FB9#, 16#0020#, 16#0002#),
         21065 => (16#3FBA#, 16#0020#, 16#0002#),
         21066 => (16#3FBB#, 16#0020#, 16#0002#),
         21067 => (16#3FBC#, 16#0020#, 16#0002#),
         21068 => (16#3FBD#, 16#0020#, 16#0002#),
         21069 => (16#3FBE#, 16#0020#, 16#0002#),
         21070 => (16#3FBF#, 16#0020#, 16#0002#),
         21071 => (16#3FC0#, 16#0020#, 16#0002#),
         21072 => (16#3FC1#, 16#0020#, 16#0002#),
         21073 => (16#3FC2#, 16#0020#, 16#0002#),
         21074 => (16#3FC3#, 16#0020#, 16#0002#),
         21075 => (16#3FC4#, 16#0020#, 16#0002#),
         21076 => (16#3FC5#, 16#0020#, 16#0002#),
         21077 => (16#3FC6#, 16#0020#, 16#0002#),
         21078 => (16#3FC7#, 16#0020#, 16#0002#),
         21079 => (16#3FC8#, 16#0020#, 16#0002#),
         21080 => (16#3FC9#, 16#0020#, 16#0002#),
         21081 => (16#3FCA#, 16#0020#, 16#0002#),
         21082 => (16#3FCB#, 16#0020#, 16#0002#),
         21083 => (16#3FCC#, 16#0020#, 16#0002#),
         21084 => (16#3FCD#, 16#0020#, 16#0002#),
         21085 => (16#3FCE#, 16#0020#, 16#0002#),
         21086 => (16#3FCF#, 16#0020#, 16#0002#),
         21087 => (16#3FD0#, 16#0020#, 16#0002#),
         21088 => (16#3FD1#, 16#0020#, 16#0002#),
         21089 => (16#3FD2#, 16#0020#, 16#0002#),
         21090 => (16#3FD3#, 16#0020#, 16#0002#),
         21091 => (16#3FD4#, 16#0020#, 16#0002#),
         21092 => (16#3FD5#, 16#0020#, 16#0002#),
         21093 => (16#3FD6#, 16#0020#, 16#0002#),
         21094 => (16#3FD7#, 16#0020#, 16#0002#),
         21095 => (16#4063#, 16#0020#, 16#0002#),
         21096 => (16#4064#, 16#0020#, 16#0002#),
         21097 => (16#4065#, 16#0020#, 16#0002#),
         21098 => (16#4066#, 16#0020#, 16#0002#),
         21099 => (16#4067#, 16#0020#, 16#0002#),
         21100 => (16#4068#, 16#0020#, 16#0002#),
         21101 => (16#4069#, 16#0020#, 16#0002#),
         21102 => (16#406A#, 16#0020#, 16#0002#),
         21103 => (16#406B#, 16#0020#, 16#0002#),
         21104 => (16#406C#, 16#0020#, 16#0002#),
         21105 => (16#406D#, 16#0020#, 16#0002#),
         21106 => (16#406E#, 16#0020#, 16#0002#),
         21107 => (16#406F#, 16#0020#, 16#0002#),
         21108 => (16#4070#, 16#0020#, 16#0002#),
         21109 => (16#4071#, 16#0020#, 16#0002#),
         21110 => (16#4072#, 16#0020#, 16#0002#),
         21111 => (16#4073#, 16#0020#, 16#0002#),
         21112 => (16#4074#, 16#0020#, 16#0002#),
         21113 => (16#4075#, 16#0020#, 16#0002#),
         21114 => (16#4076#, 16#0020#, 16#0002#),
         21115 => (16#4077#, 16#0020#, 16#0002#),
         21116 => (16#4078#, 16#0020#, 16#0002#),
         21117 => (16#4079#, 16#0020#, 16#0002#),
         21118 => (16#407A#, 16#0020#, 16#0002#),
         21119 => (16#407B#, 16#0020#, 16#0002#),
         21120 => (16#407C#, 16#0020#, 16#0002#),
         21121 => (16#407D#, 16#0020#, 16#0002#),
         21122 => (16#407E#, 16#0020#, 16#0002#),
         21123 => (16#407F#, 16#0020#, 16#0002#),
         21124 => (16#4080#, 16#0020#, 16#0002#),
         21125 => (16#4081#, 16#0020#, 16#0002#),
         21126 => (16#4082#, 16#0020#, 16#0002#),
         21127 => (16#4083#, 16#0020#, 16#0002#),
         21128 => (16#4084#, 16#0020#, 16#0002#),
         21129 => (16#4085#, 16#0020#, 16#0002#),
         21130 => (16#4086#, 16#0020#, 16#0002#),
         21131 => (16#4087#, 16#0020#, 16#0002#),
         21132 => (16#4088#, 16#0020#, 16#0002#),
         21133 => (16#4089#, 16#0020#, 16#0002#),
         21134 => (16#408A#, 16#0020#, 16#0002#),
         21135 => (16#408B#, 16#0020#, 16#0002#),
         21136 => (16#408C#, 16#0020#, 16#0002#),
         21137 => (16#408D#, 16#0020#, 16#0002#),
         21138 => (16#408E#, 16#0020#, 16#0002#),
         21139 => (16#408F#, 16#0020#, 16#0002#),
         21140 => (16#4090#, 16#0020#, 16#0002#),
         21141 => (16#4091#, 16#0020#, 16#0002#),
         21142 => (16#4092#, 16#0020#, 16#0002#),
         21143 => (16#4093#, 16#0020#, 16#0002#),
         21144 => (16#4094#, 16#0020#, 16#0002#),
         21145 => (16#4095#, 16#0020#, 16#0002#),
         21146 => (16#4096#, 16#0020#, 16#0002#),
         21147 => (16#4097#, 16#0020#, 16#0002#),
         21148 => (16#4098#, 16#0020#, 16#0002#),
         21149 => (16#4099#, 16#0020#, 16#0002#),
         21150 => (16#409A#, 16#0020#, 16#0002#),
         21151 => (16#409B#, 16#0020#, 16#0002#),
         21152 => (16#409C#, 16#0020#, 16#0002#),
         21153 => (16#409D#, 16#0020#, 16#0002#),
         21154 => (16#409E#, 16#0020#, 16#0002#),
         21155 => (16#409F#, 16#0020#, 16#0002#),
         21156 => (16#40A0#, 16#0020#, 16#0002#),
         21157 => (16#40A1#, 16#0020#, 16#0002#),
         21158 => (16#40A2#, 16#0020#, 16#0002#),
         21159 => (16#40A3#, 16#0020#, 16#0002#),
         21160 => (16#40A4#, 16#0020#, 16#0002#),
         21161 => (16#40A5#, 16#0020#, 16#0002#),
         21162 => (16#40A6#, 16#0020#, 16#0002#),
         21163 => (16#40A7#, 16#0020#, 16#0002#),
         21164 => (16#40A8#, 16#0020#, 16#0002#),
         21165 => (16#40A9#, 16#0020#, 16#0002#),
         21166 => (16#40AA#, 16#0020#, 16#0002#),
         21167 => (16#40AB#, 16#0020#, 16#0002#),
         21168 => (16#40AC#, 16#0020#, 16#0002#),
         21169 => (16#40AD#, 16#0020#, 16#0002#),
         21170 => (16#40AE#, 16#0020#, 16#0002#),
         21171 => (16#40AF#, 16#0020#, 16#0002#),
         21172 => (16#40B0#, 16#0020#, 16#0002#),
         21173 => (16#40B1#, 16#0020#, 16#0002#),
         21174 => (16#40B2#, 16#0020#, 16#0002#),
         21175 => (16#40B3#, 16#0020#, 16#0002#),
         21176 => (16#40B4#, 16#0020#, 16#0002#),
         21177 => (16#40B5#, 16#0020#, 16#0002#),
         21178 => (16#40B6#, 16#0020#, 16#0002#),
         21179 => (16#40B7#, 16#0020#, 16#0002#),
         21180 => (16#40B8#, 16#0020#, 16#0002#),
         21181 => (16#40B9#, 16#0020#, 16#0002#),
         21182 => (16#40BA#, 16#0020#, 16#0002#),
         21183 => (16#40BB#, 16#0020#, 16#0002#),
         21184 => (16#40BC#, 16#0020#, 16#0002#),
         21185 => (16#40BD#, 16#0020#, 16#0002#),
         21186 => (16#40BE#, 16#0020#, 16#0002#),
         21187 => (16#40BF#, 16#0020#, 16#0002#),
         21188 => (16#40C0#, 16#0020#, 16#0002#),
         21189 => (16#40C1#, 16#0020#, 16#0002#),
         21190 => (16#40C2#, 16#0020#, 16#0002#),
         21191 => (16#40C3#, 16#0020#, 16#0002#),
         21192 => (16#40C4#, 16#0020#, 16#0002#),
         21193 => (16#40C5#, 16#0020#, 16#0002#),
         21194 => (16#40C6#, 16#0020#, 16#0002#),
         21195 => (16#40C7#, 16#0020#, 16#0002#),
         21196 => (16#40C8#, 16#0020#, 16#0002#),
         21197 => (16#40C9#, 16#0020#, 16#0002#),
         21198 => (16#40CA#, 16#0020#, 16#0002#),
         21199 => (16#40CB#, 16#0020#, 16#0002#),
         21200 => (16#40CC#, 16#0020#, 16#0002#),
         21201 => (16#40CD#, 16#0020#, 16#0002#),
         21202 => (16#40CE#, 16#0020#, 16#0002#),
         21203 => (16#40CF#, 16#0020#, 16#0002#),
         21204 => (16#40D0#, 16#0020#, 16#0002#),
         21205 => (16#40D1#, 16#0020#, 16#0002#),
         21206 => (16#40D2#, 16#0020#, 16#0002#),
         21207 => (16#40D3#, 16#0020#, 16#0002#),
         21208 => (16#40D4#, 16#0020#, 16#0002#),
         21209 => (16#40D5#, 16#0020#, 16#0002#),
         21210 => (16#40D6#, 16#0020#, 16#0002#),
         21211 => (16#40D7#, 16#0020#, 16#0002#),
         21212 => (16#40D8#, 16#0020#, 16#0002#),
         21213 => (16#40D9#, 16#0020#, 16#0002#),
         21214 => (16#40DA#, 16#0020#, 16#0002#),
         21215 => (16#40DB#, 16#0020#, 16#0002#),
         21216 => (16#40DC#, 16#0020#, 16#0002#),
         21217 => (16#0313#, 16#0020#, 16#0002#),
         21218 => (16#41E8#, 16#0020#, 16#0002#),
         21219 => (16#41E9#, 16#0020#, 16#0002#),
         21220 => (16#41EA#, 16#0020#, 16#0002#),
         21221 => (16#41EB#, 16#0020#, 16#0002#),
         21222 => (16#41EC#, 16#0020#, 16#0002#),
         21223 => (16#41ED#, 16#0020#, 16#0002#),
         21224 => (16#41EE#, 16#0020#, 16#0002#),
         21225 => (16#41EF#, 16#0020#, 16#0002#),
         21226 => (16#41F0#, 16#0020#, 16#0002#),
         21227 => (16#41F1#, 16#0020#, 16#0002#),
         21228 => (16#41F2#, 16#0020#, 16#0002#),
         21229 => (16#41F3#, 16#0020#, 16#0002#),
         21230 => (16#41F4#, 16#0020#, 16#0002#),
         21231 => (16#41F5#, 16#0020#, 16#0002#),
         21232 => (16#41F6#, 16#0020#, 16#0002#),
         21233 => (16#41F7#, 16#0020#, 16#0002#),
         21234 => (16#41F8#, 16#0020#, 16#0002#),
         21235 => (16#41F9#, 16#0020#, 16#0002#),
         21236 => (16#41FA#, 16#0020#, 16#0002#),
         21237 => (16#41FB#, 16#0020#, 16#0002#),
         21238 => (16#41FC#, 16#0020#, 16#0002#),
         21239 => (16#41FD#, 16#0020#, 16#0002#),
         21240 => (16#41FE#, 16#0020#, 16#0002#),
         21241 => (16#41FF#, 16#0020#, 16#0002#),
         21242 => (16#4200#, 16#0020#, 16#0002#),
         21243 => (16#4201#, 16#0020#, 16#0002#),
         21244 => (16#4202#, 16#0020#, 16#0002#),
         21245 => (16#4203#, 16#0020#, 16#0002#),
         21246 => (16#4204#, 16#0020#, 16#0002#),
         21247 => (16#4205#, 16#0020#, 16#0002#),
         21248 => (16#4206#, 16#0020#, 16#0002#),
         21249 => (16#4207#, 16#0020#, 16#0002#),
         21250 => (16#4208#, 16#0020#, 16#0002#),
         21251 => (16#4209#, 16#0020#, 16#0002#),
         21252 => (16#420A#, 16#0020#, 16#0002#),
         21253 => (16#420B#, 16#0020#, 16#0002#),
         21254 => (16#420C#, 16#0020#, 16#0002#),
         21255 => (16#420D#, 16#0020#, 16#0002#),
         21256 => (16#420E#, 16#0020#, 16#0002#),
         21257 => (16#420F#, 16#0020#, 16#0002#),
         21258 => (16#4210#, 16#0020#, 16#0002#),
         21259 => (16#4211#, 16#0020#, 16#0002#),
         21260 => (16#4212#, 16#0020#, 16#0002#),
         21261 => (16#4213#, 16#0020#, 16#0002#),
         21262 => (16#4214#, 16#0020#, 16#0002#),
         21263 => (16#4215#, 16#0020#, 16#0002#),
         21264 => (16#4216#, 16#0020#, 16#0002#),
         21265 => (16#4217#, 16#0020#, 16#0002#),
         21266 => (16#4218#, 16#0020#, 16#0002#),
         21267 => (16#4219#, 16#0020#, 16#0002#),
         21268 => (16#421A#, 16#0020#, 16#0002#),
         21269 => (16#421B#, 16#0020#, 16#0002#),
         21270 => (16#421C#, 16#0020#, 16#0002#),
         21271 => (16#421D#, 16#0020#, 16#0002#),
         21272 => (16#421E#, 16#0020#, 16#0002#),
         21273 => (16#421F#, 16#0020#, 16#0002#),
         21274 => (16#4220#, 16#0020#, 16#0002#),
         21275 => (16#4221#, 16#0020#, 16#0002#),
         21276 => (16#4222#, 16#0020#, 16#0002#),
         21277 => (16#4223#, 16#0020#, 16#0002#),
         21278 => (16#4224#, 16#0020#, 16#0002#),
         21279 => (16#4225#, 16#0020#, 16#0002#),
         21280 => (16#4226#, 16#0020#, 16#0002#),
         21281 => (16#4227#, 16#0020#, 16#0002#),
         21282 => (16#4228#, 16#0020#, 16#0002#),
         21283 => (16#4229#, 16#0020#, 16#0002#),
         21284 => (16#422A#, 16#0020#, 16#0002#),
         21285 => (16#422B#, 16#0020#, 16#0002#),
         21286 => (16#422C#, 16#0020#, 16#0002#),
         21287 => (16#422D#, 16#0020#, 16#0002#),
         21288 => (16#422E#, 16#0020#, 16#0002#),
         21289 => (16#422F#, 16#0020#, 16#0002#),
         21290 => (16#4230#, 16#0020#, 16#0002#),
         21291 => (16#4231#, 16#0020#, 16#0002#),
         21292 => (16#4232#, 16#0020#, 16#0002#),
         21293 => (16#4233#, 16#0020#, 16#0002#),
         21294 => (16#4234#, 16#0020#, 16#0002#),
         21295 => (16#4235#, 16#0020#, 16#0002#),
         21296 => (16#4236#, 16#0020#, 16#0002#),
         21297 => (16#4237#, 16#0020#, 16#0002#),
         21298 => (16#4238#, 16#0020#, 16#0002#),
         21299 => (16#4239#, 16#0020#, 16#0002#),
         21300 => (16#423A#, 16#0020#, 16#0002#),
         21301 => (16#423B#, 16#0020#, 16#0002#),
         21302 => (16#423C#, 16#0020#, 16#0002#),
         21303 => (16#423D#, 16#0020#, 16#0002#),
         21304 => (16#423E#, 16#0020#, 16#0002#),
         21305 => (16#423F#, 16#0020#, 16#0002#),
         21306 => (16#4240#, 16#0020#, 16#0002#),
         21307 => (16#4241#, 16#0020#, 16#0002#),
         21308 => (16#4242#, 16#0020#, 16#0002#),
         21309 => (16#4243#, 16#0020#, 16#0002#),
         21310 => (16#4244#, 16#0020#, 16#0002#),
         21311 => (16#4245#, 16#0020#, 16#0002#),
         21312 => (16#4246#, 16#0020#, 16#0002#),
         21313 => (16#4247#, 16#0020#, 16#0002#),
         21314 => (16#4248#, 16#0020#, 16#0002#),
         21315 => (16#4249#, 16#0020#, 16#0002#),
         21316 => (16#424A#, 16#0020#, 16#0002#),
         21317 => (16#424B#, 16#0020#, 16#0002#),
         21318 => (16#424C#, 16#0020#, 16#0002#),
         21319 => (16#424D#, 16#0020#, 16#0002#),
         21320 => (16#424E#, 16#0020#, 16#0002#),
         21321 => (16#424F#, 16#0020#, 16#0002#),
         21322 => (16#4250#, 16#0020#, 16#0002#),
         21323 => (16#4251#, 16#0020#, 16#0002#),
         21324 => (16#4252#, 16#0020#, 16#0002#),
         21325 => (16#4253#, 16#0020#, 16#0002#),
         21326 => (16#4254#, 16#0020#, 16#0002#),
         21327 => (16#4255#, 16#0020#, 16#0002#),
         21328 => (16#4256#, 16#0020#, 16#0002#),
         21329 => (16#4257#, 16#0020#, 16#0002#),
         21330 => (16#4258#, 16#0020#, 16#0002#),
         21331 => (16#4259#, 16#0020#, 16#0002#),
         21332 => (16#425A#, 16#0020#, 16#0002#),
         21333 => (16#425B#, 16#0020#, 16#0002#),
         21334 => (16#425C#, 16#0020#, 16#0002#),
         21335 => (16#425D#, 16#0020#, 16#0002#),
         21336 => (16#425E#, 16#0020#, 16#0002#),
         21337 => (16#425F#, 16#0020#, 16#0002#),
         21338 => (16#4260#, 16#0020#, 16#0002#),
         21339 => (16#4261#, 16#0020#, 16#0002#),
         21340 => (16#4262#, 16#0020#, 16#0002#),
         21341 => (16#4263#, 16#0020#, 16#0002#),
         21342 => (16#4264#, 16#0020#, 16#0002#),
         21343 => (16#4265#, 16#0020#, 16#0002#),
         21344 => (16#4266#, 16#0020#, 16#0002#),
         21345 => (16#4267#, 16#0020#, 16#0002#),
         21346 => (16#4268#, 16#0020#, 16#0002#),
         21347 => (16#4269#, 16#0020#, 16#0002#),
         21348 => (16#426A#, 16#0020#, 16#0002#),
         21349 => (16#426B#, 16#0020#, 16#0002#),
         21350 => (16#426C#, 16#0020#, 16#0002#),
         21351 => (16#426D#, 16#0020#, 16#0002#),
         21352 => (16#426E#, 16#0020#, 16#0002#),
         21353 => (16#426F#, 16#0020#, 16#0002#),
         21354 => (16#4270#, 16#0020#, 16#0002#),
         21355 => (16#4271#, 16#0020#, 16#0002#),
         21356 => (16#4272#, 16#0020#, 16#0002#),
         21357 => (16#4273#, 16#0020#, 16#0002#),
         21358 => (16#4274#, 16#0020#, 16#0002#),
         21359 => (16#4275#, 16#0020#, 16#0002#),
         21360 => (16#4276#, 16#0020#, 16#0002#),
         21361 => (16#4277#, 16#0020#, 16#0002#),
         21362 => (16#4278#, 16#0020#, 16#0002#),
         21363 => (16#4279#, 16#0020#, 16#0002#),
         21364 => (16#427A#, 16#0020#, 16#0002#),
         21365 => (16#427B#, 16#0020#, 16#0002#),
         21366 => (16#427C#, 16#0020#, 16#0002#),
         21367 => (16#427D#, 16#0020#, 16#0002#),
         21368 => (16#427E#, 16#0020#, 16#0002#),
         21369 => (16#427F#, 16#0020#, 16#0002#),
         21370 => (16#4280#, 16#0020#, 16#0002#),
         21371 => (16#4281#, 16#0020#, 16#0002#),
         21372 => (16#4282#, 16#0020#, 16#0002#),
         21373 => (16#4283#, 16#0020#, 16#0002#),
         21374 => (16#4284#, 16#0020#, 16#0002#),
         21375 => (16#4285#, 16#0020#, 16#0002#),
         21376 => (16#4286#, 16#0020#, 16#0002#),
         21377 => (16#4287#, 16#0020#, 16#0002#),
         21378 => (16#4288#, 16#0020#, 16#0002#),
         21379 => (16#4289#, 16#0020#, 16#0002#),
         21380 => (16#428A#, 16#0020#, 16#0002#),
         21381 => (16#428B#, 16#0020#, 16#0002#),
         21382 => (16#428C#, 16#0020#, 16#0002#),
         21383 => (16#428D#, 16#0020#, 16#0002#),
         21384 => (16#428E#, 16#0020#, 16#0002#),
         21385 => (16#428F#, 16#0020#, 16#0002#),
         21386 => (16#4290#, 16#0020#, 16#0002#),
         21387 => (16#4291#, 16#0020#, 16#0002#),
         21388 => (16#4292#, 16#0020#, 16#0002#),
         21389 => (16#4293#, 16#0020#, 16#0002#),
         21390 => (16#4294#, 16#0020#, 16#0002#),
         21391 => (16#4295#, 16#0020#, 16#0002#),
         21392 => (16#4296#, 16#0020#, 16#0002#),
         21393 => (16#4297#, 16#0020#, 16#0002#),
         21394 => (16#4298#, 16#0020#, 16#0002#),
         21395 => (16#4299#, 16#0020#, 16#0002#),
         21396 => (16#429A#, 16#0020#, 16#0002#),
         21397 => (16#429B#, 16#0020#, 16#0002#),
         21398 => (16#429C#, 16#0020#, 16#0002#),
         21399 => (16#429D#, 16#0020#, 16#0002#),
         21400 => (16#429E#, 16#0020#, 16#0002#),
         21401 => (16#429F#, 16#0020#, 16#0002#),
         21402 => (16#42A0#, 16#0020#, 16#0002#),
         21403 => (16#42A1#, 16#0020#, 16#0002#),
         21404 => (16#42A2#, 16#0020#, 16#0002#),
         21405 => (16#42A3#, 16#0020#, 16#0002#),
         21406 => (16#42A4#, 16#0020#, 16#0002#),
         21407 => (16#42A5#, 16#0020#, 16#0002#),
         21408 => (16#42A6#, 16#0020#, 16#0002#),
         21409 => (16#42A7#, 16#0020#, 16#0002#),
         21410 => (16#42A8#, 16#0020#, 16#0002#),
         21411 => (16#42A9#, 16#0020#, 16#0002#),
         21412 => (16#42AA#, 16#0020#, 16#0002#),
         21413 => (16#42AB#, 16#0020#, 16#0002#),
         21414 => (16#42AC#, 16#0020#, 16#0002#),
         21415 => (16#42AD#, 16#0020#, 16#0002#),
         21416 => (16#42AE#, 16#0020#, 16#0002#),
         21417 => (16#42AF#, 16#0020#, 16#0002#),
         21418 => (16#42B0#, 16#0020#, 16#0002#),
         21419 => (16#42B1#, 16#0020#, 16#0002#),
         21420 => (16#42B2#, 16#0020#, 16#0002#),
         21421 => (16#42B3#, 16#0020#, 16#0002#),
         21422 => (16#42B4#, 16#0020#, 16#0002#),
         21423 => (16#42B5#, 16#0020#, 16#0002#),
         21424 => (16#42B6#, 16#0020#, 16#0002#),
         21425 => (16#42B7#, 16#0020#, 16#0002#),
         21426 => (16#42B8#, 16#0020#, 16#0002#),
         21427 => (16#42B9#, 16#0020#, 16#0002#),
         21428 => (16#42BA#, 16#0020#, 16#0002#),
         21429 => (16#42BB#, 16#0020#, 16#0002#),
         21430 => (16#42BC#, 16#0020#, 16#0002#),
         21431 => (16#42BD#, 16#0020#, 16#0002#),
         21432 => (16#42BE#, 16#0020#, 16#0002#),
         21433 => (16#42BF#, 16#0020#, 16#0002#),
         21434 => (16#42C0#, 16#0020#, 16#0002#),
         21435 => (16#42C1#, 16#0020#, 16#0002#),
         21436 => (16#42C2#, 16#0020#, 16#0002#),
         21437 => (16#42C3#, 16#0020#, 16#0002#),
         21438 => (16#42C4#, 16#0020#, 16#0002#),
         21439 => (16#42C5#, 16#0020#, 16#0002#),
         21440 => (16#42C6#, 16#0020#, 16#0002#),
         21441 => (16#42C7#, 16#0020#, 16#0002#),
         21442 => (16#42C8#, 16#0020#, 16#0002#),
         21443 => (16#42C9#, 16#0020#, 16#0002#),
         21444 => (16#42CA#, 16#0020#, 16#0002#),
         21445 => (16#42CB#, 16#0020#, 16#0002#),
         21446 => (16#42CC#, 16#0020#, 16#0002#),
         21447 => (16#42CD#, 16#0020#, 16#0002#),
         21448 => (16#42CE#, 16#0020#, 16#0002#),
         21449 => (16#42CF#, 16#0020#, 16#0002#),
         21450 => (16#42D0#, 16#0020#, 16#0002#),
         21451 => (16#42D1#, 16#0020#, 16#0002#),
         21452 => (16#42D2#, 16#0020#, 16#0002#),
         21453 => (16#42D3#, 16#0020#, 16#0002#),
         21454 => (16#42D4#, 16#0020#, 16#0002#),
         21455 => (16#42D5#, 16#0020#, 16#0002#),
         21456 => (16#42D6#, 16#0020#, 16#0002#),
         21457 => (16#42D7#, 16#0020#, 16#0002#),
         21458 => (16#42D8#, 16#0020#, 16#0002#),
         21459 => (16#42D9#, 16#0020#, 16#0002#),
         21460 => (16#42DA#, 16#0020#, 16#0002#),
         21461 => (16#42DB#, 16#0020#, 16#0002#),
         21462 => (16#42DC#, 16#0020#, 16#0002#),
         21463 => (16#42DD#, 16#0020#, 16#0002#),
         21464 => (16#42DE#, 16#0020#, 16#0002#),
         21465 => (16#42DF#, 16#0020#, 16#0002#),
         21466 => (16#42E0#, 16#0020#, 16#0002#),
         21467 => (16#42E1#, 16#0020#, 16#0002#),
         21468 => (16#42E2#, 16#0020#, 16#0002#),
         21469 => (16#42E3#, 16#0020#, 16#0002#),
         21470 => (16#42E4#, 16#0020#, 16#0002#),
         21471 => (16#42E5#, 16#0020#, 16#0002#),
         21472 => (16#42E6#, 16#0020#, 16#0002#),
         21473 => (16#42E7#, 16#0020#, 16#0002#),
         21474 => (16#42E8#, 16#0020#, 16#0002#),
         21475 => (16#42E9#, 16#0020#, 16#0002#),
         21476 => (16#42EA#, 16#0020#, 16#0002#),
         21477 => (16#42EB#, 16#0020#, 16#0002#),
         21478 => (16#42EC#, 16#0020#, 16#0002#),
         21479 => (16#42ED#, 16#0020#, 16#0002#),
         21480 => (16#42EE#, 16#0020#, 16#0002#),
         21481 => (16#42EF#, 16#0020#, 16#0002#),
         21482 => (16#42F0#, 16#0020#, 16#0002#),
         21483 => (16#42F1#, 16#0020#, 16#0002#),
         21484 => (16#42F2#, 16#0020#, 16#0002#),
         21485 => (16#42F3#, 16#0020#, 16#0002#),
         21486 => (16#42F4#, 16#0020#, 16#0002#),
         21487 => (16#42F5#, 16#0020#, 16#0002#),
         21488 => (16#42F6#, 16#0020#, 16#0002#),
         21489 => (16#42F7#, 16#0020#, 16#0002#),
         21490 => (16#42F8#, 16#0020#, 16#0002#),
         21491 => (16#42F9#, 16#0020#, 16#0002#),
         21492 => (16#42FA#, 16#0020#, 16#0002#),
         21493 => (16#42FB#, 16#0020#, 16#0002#),
         21494 => (16#42FC#, 16#0020#, 16#0002#),
         21495 => (16#42FD#, 16#0020#, 16#0002#),
         21496 => (16#42FE#, 16#0020#, 16#0002#),
         21497 => (16#42FF#, 16#0020#, 16#0002#),
         21498 => (16#4300#, 16#0020#, 16#0002#),
         21499 => (16#4301#, 16#0020#, 16#0002#),
         21500 => (16#4302#, 16#0020#, 16#0002#),
         21501 => (16#4303#, 16#0020#, 16#0002#),
         21502 => (16#4304#, 16#0020#, 16#0002#),
         21503 => (16#4305#, 16#0020#, 16#0002#),
         21504 => (16#4306#, 16#0020#, 16#0002#),
         21505 => (16#4307#, 16#0020#, 16#0002#),
         21506 => (16#4308#, 16#0020#, 16#0002#),
         21507 => (16#4309#, 16#0020#, 16#0002#),
         21508 => (16#430A#, 16#0020#, 16#0002#),
         21509 => (16#430B#, 16#0020#, 16#0002#),
         21510 => (16#430C#, 16#0020#, 16#0002#),
         21511 => (16#430D#, 16#0020#, 16#0002#),
         21512 => (16#430E#, 16#0020#, 16#0002#),
         21513 => (16#430F#, 16#0020#, 16#0002#),
         21514 => (16#4310#, 16#0020#, 16#0002#),
         21515 => (16#4311#, 16#0020#, 16#0002#),
         21516 => (16#4312#, 16#0020#, 16#0002#),
         21517 => (16#4313#, 16#0020#, 16#0002#),
         21518 => (16#4314#, 16#0020#, 16#0002#),
         21519 => (16#4315#, 16#0020#, 16#0002#),
         21520 => (16#4316#, 16#0020#, 16#0002#),
         21521 => (16#4317#, 16#0020#, 16#0002#),
         21522 => (16#4318#, 16#0020#, 16#0002#),
         21523 => (16#4319#, 16#0020#, 16#0002#),
         21524 => (16#431A#, 16#0020#, 16#0002#),
         21525 => (16#431B#, 16#0020#, 16#0002#),
         21526 => (16#431C#, 16#0020#, 16#0002#),
         21527 => (16#431D#, 16#0020#, 16#0002#),
         21528 => (16#431E#, 16#0020#, 16#0002#),
         21529 => (16#431F#, 16#0020#, 16#0002#),
         21530 => (16#4320#, 16#0020#, 16#0002#),
         21531 => (16#4321#, 16#0020#, 16#0002#),
         21532 => (16#4322#, 16#0020#, 16#0002#),
         21533 => (16#4323#, 16#0020#, 16#0002#),
         21534 => (16#4324#, 16#0020#, 16#0002#),
         21535 => (16#4325#, 16#0020#, 16#0002#),
         21536 => (16#4326#, 16#0020#, 16#0002#),
         21537 => (16#4327#, 16#0020#, 16#0002#),
         21538 => (16#4328#, 16#0020#, 16#0002#),
         21539 => (16#4329#, 16#0020#, 16#0002#),
         21540 => (16#432A#, 16#0020#, 16#0002#),
         21541 => (16#432B#, 16#0020#, 16#0002#),
         21542 => (16#432C#, 16#0020#, 16#0002#),
         21543 => (16#432D#, 16#0020#, 16#0002#),
         21544 => (16#432E#, 16#0020#, 16#0002#),
         21545 => (16#432F#, 16#0020#, 16#0002#),
         21546 => (16#4330#, 16#0020#, 16#0002#),
         21547 => (16#4331#, 16#0020#, 16#0002#),
         21548 => (16#4332#, 16#0020#, 16#0002#),
         21549 => (16#4333#, 16#0020#, 16#0002#),
         21550 => (16#4334#, 16#0020#, 16#0002#),
         21551 => (16#4335#, 16#0020#, 16#0002#),
         21552 => (16#4336#, 16#0020#, 16#0002#),
         21553 => (16#4337#, 16#0020#, 16#0002#),
         21554 => (16#4338#, 16#0020#, 16#0002#),
         21555 => (16#4339#, 16#0020#, 16#0002#),
         21556 => (16#433A#, 16#0020#, 16#0002#),
         21557 => (16#433B#, 16#0020#, 16#0002#),
         21558 => (16#433C#, 16#0020#, 16#0002#),
         21559 => (16#433D#, 16#0020#, 16#0002#),
         21560 => (16#433E#, 16#0020#, 16#0002#),
         21561 => (16#433F#, 16#0020#, 16#0002#),
         21562 => (16#4340#, 16#0020#, 16#0002#),
         21563 => (16#4341#, 16#0020#, 16#0002#),
         21564 => (16#4342#, 16#0020#, 16#0002#),
         21565 => (16#4343#, 16#0020#, 16#0002#),
         21566 => (16#4344#, 16#0020#, 16#0002#),
         21567 => (16#4345#, 16#0020#, 16#0002#),
         21568 => (16#4346#, 16#0020#, 16#0002#),
         21569 => (16#4347#, 16#0020#, 16#0002#),
         21570 => (16#4348#, 16#0020#, 16#0002#),
         21571 => (16#4349#, 16#0020#, 16#0002#),
         21572 => (16#434A#, 16#0020#, 16#0002#),
         21573 => (16#434B#, 16#0020#, 16#0002#),
         21574 => (16#434C#, 16#0020#, 16#0002#),
         21575 => (16#434D#, 16#0020#, 16#0002#),
         21576 => (16#434E#, 16#0020#, 16#0002#),
         21577 => (16#434F#, 16#0020#, 16#0002#),
         21578 => (16#4350#, 16#0020#, 16#0002#),
         21579 => (16#4351#, 16#0020#, 16#0002#),
         21580 => (16#4352#, 16#0020#, 16#0002#),
         21581 => (16#4353#, 16#0020#, 16#0002#),
         21582 => (16#4354#, 16#0020#, 16#0002#),
         21583 => (16#4355#, 16#0020#, 16#0002#),
         21584 => (16#4356#, 16#0020#, 16#0002#),
         21585 => (16#4357#, 16#0020#, 16#0002#),
         21586 => (16#4358#, 16#0020#, 16#0002#),
         21587 => (16#4359#, 16#0020#, 16#0002#),
         21588 => (16#435A#, 16#0020#, 16#0002#),
         21589 => (16#435B#, 16#0020#, 16#0002#),
         21590 => (16#435C#, 16#0020#, 16#0002#),
         21591 => (16#435D#, 16#0020#, 16#0002#),
         21592 => (16#435E#, 16#0020#, 16#0002#),
         21593 => (16#435F#, 16#0020#, 16#0002#),
         21594 => (16#4360#, 16#0020#, 16#0002#),
         21595 => (16#4361#, 16#0020#, 16#0002#),
         21596 => (16#4362#, 16#0020#, 16#0002#),
         21597 => (16#4363#, 16#0020#, 16#0002#),
         21598 => (16#4364#, 16#0020#, 16#0002#),
         21599 => (16#4365#, 16#0020#, 16#0002#),
         21600 => (16#4366#, 16#0020#, 16#0002#),
         21601 => (16#4367#, 16#0020#, 16#0002#),
         21602 => (16#4368#, 16#0020#, 16#0002#),
         21603 => (16#4369#, 16#0020#, 16#0002#),
         21604 => (16#436A#, 16#0020#, 16#0002#),
         21605 => (16#436B#, 16#0020#, 16#0002#),
         21606 => (16#436C#, 16#0020#, 16#0002#),
         21607 => (16#436D#, 16#0020#, 16#0002#),
         21608 => (16#436E#, 16#0020#, 16#0002#),
         21609 => (16#436F#, 16#0020#, 16#0002#),
         21610 => (16#4370#, 16#0020#, 16#0002#),
         21611 => (16#4371#, 16#0020#, 16#0002#),
         21612 => (16#4372#, 16#0020#, 16#0002#),
         21613 => (16#4373#, 16#0020#, 16#0002#),
         21614 => (16#440F#, 16#0020#, 16#0002#),
         21615 => (16#4410#, 16#0020#, 16#0002#),
         21616 => (16#4411#, 16#0020#, 16#0002#),
         21617 => (16#4412#, 16#0020#, 16#0002#),
         21618 => (16#4413#, 16#0020#, 16#0002#),
         21619 => (16#4414#, 16#0020#, 16#0002#),
         21620 => (16#4415#, 16#0020#, 16#0002#),
         21621 => (16#4416#, 16#0020#, 16#0002#),
         21622 => (16#4417#, 16#0020#, 16#0002#),
         21623 => (16#4418#, 16#0020#, 16#0002#),
         21624 => (16#4419#, 16#0020#, 16#0002#),
         21625 => (16#441A#, 16#0020#, 16#0002#),
         21626 => (16#441B#, 16#0020#, 16#0002#),
         21627 => (16#441C#, 16#0020#, 16#0002#),
         21628 => (16#441D#, 16#0020#, 16#0002#),
         21629 => (16#441E#, 16#0020#, 16#0002#),
         21630 => (16#441F#, 16#0020#, 16#0002#),
         21631 => (16#4420#, 16#0020#, 16#0002#),
         21632 => (16#4421#, 16#0020#, 16#0002#),
         21633 => (16#4422#, 16#0020#, 16#0002#),
         21634 => (16#4423#, 16#0020#, 16#0002#),
         21635 => (16#4424#, 16#0020#, 16#0002#),
         21636 => (16#01CF#, 16#0020#, 16#0002#),
         21637 => (16#17AC#, 16#0020#, 16#0002#),
         21638 => (16#17AD#, 16#0020#, 16#0002#),
         21639 => (16#17AE#, 16#0020#, 16#0002#),
         21640 => (16#17AF#, 16#0020#, 16#0002#),
         21641 => (16#17B0#, 16#0020#, 16#0002#),
         21642 => (16#43E3#, 16#0020#, 16#0002#),
         21643 => (16#43E4#, 16#0020#, 16#0002#),
         21644 => (16#43E5#, 16#0020#, 16#0002#),
         21645 => (16#43E6#, 16#0020#, 16#0002#),
         21646 => (16#43E7#, 16#0020#, 16#0002#),
         21647 => (16#43E8#, 16#0020#, 16#0002#),
         21648 => (16#43E9#, 16#0020#, 16#0002#),
         21649 => (16#43EA#, 16#0020#, 16#0002#),
         21650 => (16#43EB#, 16#0020#, 16#0002#),
         21651 => (16#43EC#, 16#0020#, 16#0002#),
         21652 => (16#43ED#, 16#0020#, 16#0002#),
         21653 => (16#43EE#, 16#0020#, 16#0002#),
         21654 => (16#43EF#, 16#0020#, 16#0002#),
         21655 => (16#43F0#, 16#0020#, 16#0019#),
         21656 => (16#43F0#, 16#0020#, 16#0002#),
         21657 => (16#43F1#, 16#0020#, 16#0002#),
         21658 => (16#43F2#, 16#0020#, 16#0002#),
         21659 => (16#43F3#, 16#0020#, 16#0002#),
         21660 => (16#43F4#, 16#0020#, 16#0002#),
         21661 => (16#43F5#, 16#0020#, 16#0002#),
         21662 => (16#43F6#, 16#0020#, 16#0002#),
         21663 => (16#43F7#, 16#0020#, 16#0002#),
         21664 => (16#43F8#, 16#0020#, 16#0002#),
         21665 => (16#0E85#, 16#0020#, 16#0002#),
         21666 => (16#0E86#, 16#0020#, 16#0002#),
         21667 => (16#17A1#, 16#0020#, 16#0002#),
         21668 => (16#17A2#, 16#0020#, 16#0002#),
         21669 => (16#43F9#, 16#0020#, 16#0019#),
         21670 => (16#43F9#, 16#0020#, 16#0002#),
         21671 => (16#43FA#, 16#0020#, 16#0019#),
         21672 => (16#43FA#, 16#0020#, 16#0002#),
         21673 => (16#43FB#, 16#0020#, 16#0002#),
         21674 => (16#43FC#, 16#0020#, 16#0002#),
         21675 => (16#43FD#, 16#0020#, 16#0019#),
         21676 => (16#43FD#, 16#0020#, 16#0002#),
         21677 => (16#43FE#, 16#0020#, 16#0002#),
         21678 => (16#43FF#, 16#0020#, 16#0002#),
         21679 => (16#4400#, 16#0020#, 16#0002#),
         21680 => (16#4401#, 16#0020#, 16#0002#),
         21681 => (16#4402#, 16#0020#, 16#0019#),
         21682 => (16#4402#, 16#0020#, 16#0002#),
         21683 => (16#4403#, 16#0020#, 16#0019#),
         21684 => (16#4403#, 16#0020#, 16#0002#),
         21685 => (16#4404#, 16#0020#, 16#0019#),
         21686 => (16#4404#, 16#0020#, 16#0002#),
         21687 => (16#4405#, 16#0020#, 16#0019#),
         21688 => (16#4405#, 16#0020#, 16#0002#),
         21689 => (16#4406#, 16#0020#, 16#0019#),
         21690 => (16#4406#, 16#0020#, 16#0002#),
         21691 => (16#4407#, 16#0020#, 16#0002#),
         21692 => (16#4408#, 16#0020#, 16#0002#),
         21693 => (16#4409#, 16#0020#, 16#0002#),
         21694 => (16#440A#, 16#0020#, 16#0002#),
         21695 => (16#440B#, 16#0020#, 16#0002#),
         21696 => (16#440C#, 16#0020#, 16#0002#),
         21697 => (16#440D#, 16#0020#, 16#0019#),
         21698 => (16#440D#, 16#0020#, 16#0002#),
         21699 => (16#440E#, 16#0020#, 16#0002#),
         21700 => (16#17A3#, 16#0020#, 16#0002#),
         21701 => (16#17A4#, 16#0020#, 16#0002#),
         21702 => (16#17A5#, 16#0020#, 16#0002#),
         21703 => (16#1F8B#, 16#0020#, 16#0002#),
         21704 => (16#1F8C#, 16#0020#, 16#0002#),
         21705 => (16#1F8D#, 16#0020#, 16#0002#),
         21706 => (16#1F8E#, 16#0020#, 16#0002#),
         21707 => (16#1F8F#, 16#0020#, 16#0002#),
         21708 => (16#1F90#, 16#0020#, 16#0002#),
         21709 => (16#1F91#, 16#0020#, 16#0002#),
         21710 => (16#1F92#, 16#0020#, 16#0002#),
         21711 => (16#1F93#, 16#0020#, 16#0002#),
         21712 => (16#1F94#, 16#0020#, 16#0002#),
         21713 => (16#1F95#, 16#0020#, 16#0002#),
         21714 => (16#1F96#, 16#0020#, 16#0002#),
         21715 => (16#1F97#, 16#0020#, 16#0002#),
         21716 => (16#1F98#, 16#0020#, 16#0002#),
         21717 => (16#1F99#, 16#0020#, 16#0002#),
         21718 => (16#1F9A#, 16#0020#, 16#0002#),
         21719 => (16#1F9B#, 16#0020#, 16#0002#),
         21720 => (16#1F9C#, 16#0020#, 16#0002#),
         21721 => (16#1F9D#, 16#0020#, 16#0002#),
         21722 => (16#1F9E#, 16#0020#, 16#0002#),
         21723 => (16#1F9F#, 16#0020#, 16#0002#),
         21724 => (16#1FA0#, 16#0020#, 16#0002#),
         21725 => (16#17A9#, 16#0020#, 16#0002#),
         21726 => (16#17AA#, 16#0020#, 16#0002#),
         21727 => (16#17AB#, 16#0020#, 16#0002#),
         21728 => (16#01F1#, 16#0020#, 16#0002#),
         21729 => (16#3F2B#, 16#0020#, 16#0002#),
         21730 => (16#3F2C#, 16#0020#, 16#0002#),
         21731 => (16#3F2D#, 16#0020#, 16#0002#),
         21732 => (16#3F2E#, 16#0020#, 16#0002#),
         21733 => (16#3F2F#, 16#0020#, 16#0002#),
         21734 => (16#3F30#, 16#0020#, 16#0002#),
         21735 => (16#3F31#, 16#0020#, 16#0002#),
         21736 => (16#3F32#, 16#0020#, 16#0002#),
         21737 => (16#3F33#, 16#0020#, 16#0002#),
         21738 => (16#3F34#, 16#0020#, 16#0002#),
         21739 => (16#3F35#, 16#0020#, 16#0002#),
         21740 => (16#3F36#, 16#0020#, 16#0002#),
         21741 => (16#3F37#, 16#0020#, 16#0002#),
         21742 => (16#3F38#, 16#0020#, 16#0002#),
         21743 => (16#3F39#, 16#0020#, 16#0002#),
         21744 => (16#3F3A#, 16#0020#, 16#0002#),
         21745 => (16#3F3B#, 16#0020#, 16#0002#),
         21746 => (16#3F3C#, 16#0020#, 16#0002#),
         21747 => (16#3F3D#, 16#0020#, 16#0002#),
         21748 => (16#3F3E#, 16#0020#, 16#0002#),
         21749 => (16#3F3F#, 16#0020#, 16#0002#),
         21750 => (16#3F40#, 16#0020#, 16#0002#),
         21751 => (16#3F41#, 16#0020#, 16#0002#),
         21752 => (16#3F42#, 16#0020#, 16#0002#),
         21753 => (16#3F43#, 16#0020#, 16#0002#),
         21754 => (16#3F44#, 16#0020#, 16#0002#),
         21755 => (16#01EB#, 16#0020#, 16#0002#),
         21756 => (16#4C96#, 16#0020#, 16#0004#),
         21757 => (16#0000#, 16#0108#, 16#0004#),
         21758 => (16#4C97#, 16#0020#, 16#0004#),
         21759 => (16#0000#, 16#0108#, 16#0004#),
         21760 => (16#4C98#, 16#0020#, 16#0004#),
         21761 => (16#0000#, 16#0108#, 16#0004#),
         21762 => (16#4C99#, 16#0020#, 16#0004#),
         21763 => (16#0000#, 16#0108#, 16#0004#),
         21764 => (16#4C9A#, 16#0020#, 16#0004#),
         21765 => (16#0000#, 16#0108#, 16#0004#),
         21766 => (16#4C9B#, 16#0020#, 16#0004#),
         21767 => (16#0000#, 16#0108#, 16#0004#),
         21768 => (16#4C9C#, 16#0020#, 16#0004#),
         21769 => (16#0000#, 16#0108#, 16#0004#),
         21770 => (16#4C9C#, 16#0020#, 16#0004#),
         21771 => (16#0000#, 16#0109#, 16#0004#),
         21772 => (16#4C9D#, 16#0020#, 16#0004#),
         21773 => (16#0000#, 16#0108#, 16#0004#),
         21774 => (16#4C9E#, 16#0020#, 16#0004#),
         21775 => (16#0000#, 16#0108#, 16#0004#),
         21776 => (16#4C9F#, 16#0020#, 16#0004#),
         21777 => (16#0000#, 16#0108#, 16#0004#),
         21778 => (16#4C9F#, 16#0020#, 16#0004#),
         21779 => (16#0000#, 16#0109#, 16#0004#),
         21780 => (16#4CA0#, 16#0020#, 16#0004#),
         21781 => (16#0000#, 16#0108#, 16#0004#),
         21782 => (16#4CA0#, 16#0020#, 16#0004#),
         21783 => (16#0000#, 16#0109#, 16#0004#),
         21784 => (16#4CA1#, 16#0020#, 16#0004#),
         21785 => (16#0000#, 16#0108#, 16#0004#),
         21786 => (16#4CA1#, 16#0020#, 16#0004#),
         21787 => (16#0000#, 16#0109#, 16#0004#),
         21788 => (16#4CA2#, 16#0020#, 16#0004#),
         21789 => (16#0000#, 16#0108#, 16#0004#),
         21790 => (16#4CA3#, 16#0020#, 16#0004#),
         21791 => (16#0000#, 16#0108#, 16#0004#),
         21792 => (16#4CA4#, 16#0020#, 16#0004#),
         21793 => (16#0000#, 16#0108#, 16#0004#),
         21794 => (16#4CA5#, 16#0020#, 16#0004#),
         21795 => (16#0000#, 16#0109#, 16#0004#),
         21796 => (16#4CA5#, 16#0020#, 16#0004#),
         21797 => (16#0000#, 16#010A#, 16#0004#),
         21798 => (16#4CA6#, 16#0020#, 16#0004#),
         21799 => (16#0000#, 16#0108#, 16#0004#),
         21800 => (16#4CA7#, 16#0020#, 16#0004#),
         21801 => (16#0000#, 16#0108#, 16#0004#),
         21802 => (16#4CA8#, 16#0020#, 16#0004#),
         21803 => (16#0000#, 16#0108#, 16#0004#),
         21804 => (16#4CA9#, 16#0020#, 16#0004#),
         21805 => (16#0000#, 16#0108#, 16#0004#),
         21806 => (16#4CA9#, 16#0020#, 16#0004#),
         21807 => (16#0000#, 16#0109#, 16#0004#),
         21808 => (16#4CAA#, 16#0020#, 16#0004#),
         21809 => (16#0000#, 16#0108#, 16#0004#),
         21810 => (16#4CAA#, 16#0020#, 16#0004#),
         21811 => (16#0000#, 16#0109#, 16#0004#),
         21812 => (16#4CAB#, 16#0020#, 16#0004#),
         21813 => (16#0000#, 16#0108#, 16#0004#),
         21814 => (16#4CAC#, 16#0020#, 16#0004#),
         21815 => (16#0000#, 16#0108#, 16#0004#),
         21816 => (16#4CAF#, 16#0020#, 16#0002#),
         21817 => (16#4CB0#, 16#0020#, 16#0002#),
         21818 => (16#4C96#, 16#0020#, 16#0002#),
         21819 => (16#4C97#, 16#0020#, 16#0002#),
         21820 => (16#4C98#, 16#0020#, 16#0002#),
         21821 => (16#4C99#, 16#0020#, 16#0002#),
         21822 => (16#4C9A#, 16#0020#, 16#0002#),
         21823 => (16#4C9B#, 16#0020#, 16#0002#),
         21824 => (16#4C9C#, 16#0020#, 16#0002#),
         21825 => (16#4C9D#, 16#0020#, 16#0002#),
         21826 => (16#4C9E#, 16#0020#, 16#0002#),
         21827 => (16#4C9F#, 16#0020#, 16#0002#),
         21828 => (16#4CA0#, 16#0020#, 16#0002#),
         21829 => (16#4CA1#, 16#0020#, 16#0002#),
         21830 => (16#4CA2#, 16#0020#, 16#0002#),
         21831 => (16#4CA3#, 16#0020#, 16#0002#),
         21832 => (16#4CA4#, 16#0020#, 16#0002#),
         21833 => (16#4CA5#, 16#0020#, 16#0002#),
         21834 => (16#4CA5#, 16#0020#, 16#0004#),
         21835 => (16#0000#, 16#0108#, 16#0004#),
         21836 => (16#4CA6#, 16#0020#, 16#0002#),
         21837 => (16#4CA7#, 16#0020#, 16#0002#),
         21838 => (16#4CA8#, 16#0020#, 16#0002#),
         21839 => (16#4CA9#, 16#0020#, 16#0002#),
         21840 => (16#4CAA#, 16#0020#, 16#0002#),
         21841 => (16#4CAB#, 16#0020#, 16#0002#),
         21842 => (16#4CAC#, 16#0020#, 16#0002#),
         21843 => (16#4CAD#, 16#0020#, 16#0002#),
         21844 => (16#4CAE#, 16#0020#, 16#0002#),
         21845 => (16#2927#, 16#0020#, 16#0002#),
         21846 => (16#2928#, 16#0020#, 16#0002#),
         21847 => (16#2929#, 16#0020#, 16#0002#),
         21848 => (16#292A#, 16#0020#, 16#0002#),
         21849 => (16#292B#, 16#0020#, 16#0002#),
         21850 => (16#292C#, 16#0020#, 16#0002#),
         21851 => (16#292D#, 16#0020#, 16#0002#),
         21852 => (16#292E#, 16#0020#, 16#0002#),
         21853 => (16#292F#, 16#0020#, 16#0002#),
         21854 => (16#2930#, 16#0020#, 16#0002#),
         21855 => (16#2931#, 16#0020#, 16#0002#),
         21856 => (16#2932#, 16#0020#, 16#0002#),
         21857 => (16#2933#, 16#0020#, 16#0002#),
         21858 => (16#2934#, 16#0020#, 16#0002#),
         21859 => (16#2935#, 16#0020#, 16#0002#),
         21860 => (16#2936#, 16#0020#, 16#0002#),
         21861 => (16#2937#, 16#0020#, 16#0002#),
         21862 => (16#2938#, 16#0020#, 16#0002#),
         21863 => (16#2939#, 16#0020#, 16#0002#),
         21864 => (16#293A#, 16#0020#, 16#0002#),
         21865 => (16#293B#, 16#0020#, 16#0002#),
         21866 => (16#293C#, 16#0020#, 16#0002#),
         21867 => (16#293D#, 16#0020#, 16#0002#),
         21868 => (16#293E#, 16#0020#, 16#0002#),
         21869 => (16#293F#, 16#0020#, 16#0002#),
         21870 => (16#2940#, 16#0020#, 16#0002#),
         21871 => (16#2941#, 16#0020#, 16#0002#),
         21872 => (16#2942#, 16#0020#, 16#0002#),
         21873 => (16#2943#, 16#0020#, 16#0002#),
         21874 => (16#2944#, 16#0020#, 16#0002#),
         21875 => (16#2945#, 16#0020#, 16#0002#),
         21876 => (16#2946#, 16#0020#, 16#0002#),
         21877 => (16#2947#, 16#0020#, 16#0002#),
         21878 => (16#2948#, 16#0020#, 16#0002#),
         21879 => (16#2949#, 16#0020#, 16#0002#),
         21880 => (16#294A#, 16#0020#, 16#0002#),
         21881 => (16#294B#, 16#0020#, 16#0002#),
         21882 => (16#294C#, 16#0020#, 16#0002#),
         21883 => (16#294D#, 16#0020#, 16#0002#),
         21884 => (16#294E#, 16#0020#, 16#0002#),
         21885 => (16#294F#, 16#0020#, 16#0002#),
         21886 => (16#0000#, 16#00C6#, 16#0002#),
         21887 => (16#0000#, 16#00C7#, 16#0002#),
         21888 => (16#0000#, 16#00C8#, 16#0002#),
         21889 => (16#2950#, 16#0020#, 16#0002#),
         21890 => (16#17CA#, 16#0020#, 16#0002#),
         21891 => (16#17CB#, 16#0020#, 16#0002#),
         21892 => (16#17CC#, 16#0020#, 16#0002#),
         21893 => (16#17CD#, 16#0020#, 16#0002#),
         21894 => (16#0319#, 16#0020#, 16#0002#),
         21895 => (16#031A#, 16#0020#, 16#0002#),
         21896 => (16#031B#, 16#0020#, 16#0002#),
         21897 => (16#031C#, 16#0020#, 16#0002#),
         21898 => (16#031D#, 16#0020#, 16#0002#),
         21899 => (16#031E#, 16#0020#, 16#0002#),
         21900 => (16#01A6#, 16#0020#, 16#0002#),
         21901 => (16#01A7#, 16#0020#, 16#0002#),
         21902 => (16#031F#, 16#0020#, 16#0002#),
         21903 => (16#4374#, 16#0020#, 16#0002#),
         21904 => (16#4375#, 16#0020#, 16#0002#),
         21905 => (16#4376#, 16#0020#, 16#0002#),
         21906 => (16#4377#, 16#0020#, 16#0002#),
         21907 => (16#4378#, 16#0020#, 16#0002#),
         21908 => (16#4379#, 16#0020#, 16#0002#),
         21909 => (16#437A#, 16#0020#, 16#0002#),
         21910 => (16#437B#, 16#0020#, 16#0002#),
         21911 => (16#437C#, 16#0020#, 16#0002#),
         21912 => (16#437D#, 16#0020#, 16#0002#),
         21913 => (16#437E#, 16#0020#, 16#0002#),
         21914 => (16#437F#, 16#0020#, 16#0002#),
         21915 => (16#4380#, 16#0020#, 16#0002#),
         21916 => (16#4381#, 16#0020#, 16#0002#),
         21917 => (16#4382#, 16#0020#, 16#0002#),
         21918 => (16#4383#, 16#0020#, 16#0002#),
         21919 => (16#4384#, 16#0020#, 16#0002#),
         21920 => (16#4385#, 16#0020#, 16#0002#),
         21921 => (16#4386#, 16#0020#, 16#0002#),
         21922 => (16#4387#, 16#0020#, 16#0002#),
         21923 => (16#4388#, 16#0020#, 16#0002#),
         21924 => (16#4389#, 16#0020#, 16#0002#),
         21925 => (16#438A#, 16#0020#, 16#0002#),
         21926 => (16#438B#, 16#0020#, 16#0002#),
         21927 => (16#438C#, 16#0020#, 16#0002#),
         21928 => (16#438D#, 16#0020#, 16#0002#),
         21929 => (16#438E#, 16#0020#, 16#0002#),
         21930 => (16#438F#, 16#0020#, 16#0002#),
         21931 => (16#4390#, 16#0020#, 16#0002#),
         21932 => (16#17A6#, 16#0020#, 16#0002#),
         21933 => (16#0345#, 16#0020#, 16#0002#),
         21934 => (16#4391#, 16#0020#, 16#0002#),
         21935 => (16#4392#, 16#0020#, 16#0002#),
         21936 => (16#4393#, 16#0020#, 16#0002#),
         21937 => (16#4394#, 16#0020#, 16#0002#),
         21938 => (16#4395#, 16#0020#, 16#0002#),
         21939 => (16#4396#, 16#0020#, 16#0002#),
         21940 => (16#4397#, 16#0020#, 16#0002#),
         21941 => (16#4398#, 16#0020#, 16#0002#),
         21942 => (16#4399#, 16#0020#, 16#0002#),
         21943 => (16#439A#, 16#0020#, 16#0002#),
         21944 => (16#439B#, 16#0020#, 16#0002#),
         21945 => (16#439C#, 16#0020#, 16#0002#),
         21946 => (16#439D#, 16#0020#, 16#0002#),
         21947 => (16#439E#, 16#0020#, 16#0002#),
         21948 => (16#439F#, 16#0020#, 16#0002#),
         21949 => (16#43A0#, 16#0020#, 16#0002#),
         21950 => (16#43A1#, 16#0020#, 16#0002#),
         21951 => (16#43A2#, 16#0020#, 16#0002#),
         21952 => (16#43A3#, 16#0020#, 16#0002#),
         21953 => (16#43A4#, 16#0020#, 16#0002#),
         21954 => (16#43A5#, 16#0020#, 16#0002#),
         21955 => (16#43A6#, 16#0020#, 16#0002#),
         21956 => (16#43A7#, 16#0020#, 16#0002#),
         21957 => (16#43A8#, 16#0020#, 16#0002#),
         21958 => (16#43A9#, 16#0020#, 16#0002#),
         21959 => (16#43AA#, 16#0020#, 16#0002#),
         21960 => (16#43AB#, 16#0020#, 16#0002#),
         21961 => (16#43AC#, 16#0020#, 16#0002#),
         21962 => (16#43AD#, 16#0020#, 16#0002#),
         21963 => (16#17A7#, 16#0020#, 16#0002#),
         21964 => (16#17A8#, 16#0020#, 16#0002#),
         21965 => (16#4460#, 16#0020#, 16#0002#),
         21966 => (16#4461#, 16#0020#, 16#0002#),
         21967 => (16#4462#, 16#0020#, 16#0002#),
         21968 => (16#4463#, 16#0020#, 16#0002#),
         21969 => (16#4464#, 16#0020#, 16#0002#),
         21970 => (16#4465#, 16#0020#, 16#0002#),
         21971 => (16#4466#, 16#0020#, 16#0002#),
         21972 => (16#4467#, 16#0020#, 16#0002#),
         21973 => (16#4467#, 16#0020#, 16#0004#),
         21974 => (16#0000#, 16#0109#, 16#0004#),
         21975 => (16#4468#, 16#0020#, 16#0002#),
         21976 => (16#4469#, 16#0020#, 16#0002#),
         21977 => (16#446A#, 16#0020#, 16#0002#),
         21978 => (16#446B#, 16#0020#, 16#0002#),
         21979 => (16#446C#, 16#0020#, 16#0002#),
         21980 => (16#446D#, 16#0020#, 16#0002#),
         21981 => (16#446E#, 16#0020#, 16#0002#),
         21982 => (16#446F#, 16#0020#, 16#0002#),
         21983 => (16#4470#, 16#0020#, 16#0002#),
         21984 => (16#4471#, 16#0020#, 16#0002#),
         21985 => (16#4472#, 16#0020#, 16#0002#),
         21986 => (16#4473#, 16#0020#, 16#0002#),
         21987 => (16#4474#, 16#0020#, 16#0002#),
         21988 => (16#4475#, 16#0020#, 16#0002#),
         21989 => (16#4476#, 16#0020#, 16#0002#),
         21990 => (16#4477#, 16#0020#, 16#0002#),
         21991 => (16#4478#, 16#0020#, 16#0002#),
         21992 => (16#4479#, 16#0020#, 16#0002#),
         21993 => (16#447A#, 16#0020#, 16#0002#),
         21994 => (16#447B#, 16#0020#, 16#0002#),
         21995 => (16#447C#, 16#0020#, 16#0002#),
         21996 => (16#447D#, 16#0020#, 16#0002#),
         21997 => (16#447E#, 16#0020#, 16#0002#),
         21998 => (16#447F#, 16#0020#, 16#0002#),
         21999 => (16#4480#, 16#0020#, 16#0002#),
         22000 => (16#4481#, 16#0020#, 16#0002#),
         22001 => (16#4482#, 16#0020#, 16#0002#),
         22002 => (16#4483#, 16#0020#, 16#0002#),
         22003 => (16#17B1#, 16#0020#, 16#0002#),
         22004 => (16#17B2#, 16#0020#, 16#0002#),
         22005 => (16#17B3#, 16#0020#, 16#0002#),
         22006 => (16#0321#, 16#0020#, 16#0002#),
         22007 => (16#0322#, 16#0020#, 16#0002#),
         22008 => (16#0323#, 16#0020#, 16#0002#),
         22009 => (16#0324#, 16#0020#, 16#0002#),
         22010 => (16#0325#, 16#0020#, 16#0002#),
         22011 => (16#0326#, 16#0020#, 16#0002#),
         22012 => (16#0327#, 16#0020#, 16#0002#),
         22013 => (16#43AE#, 16#0020#, 16#0002#),
         22014 => (16#43AF#, 16#0020#, 16#0002#),
         22015 => (16#43B0#, 16#0020#, 16#0002#),
         22016 => (16#43B1#, 16#0020#, 16#0002#),
         22017 => (16#43B2#, 16#0020#, 16#0002#),
         22018 => (16#43B3#, 16#0020#, 16#0002#),
         22019 => (16#43B4#, 16#0020#, 16#0002#),
         22020 => (16#43B5#, 16#0020#, 16#0002#),
         22021 => (16#43B6#, 16#0020#, 16#0002#),
         22022 => (16#43B7#, 16#0020#, 16#0002#),
         22023 => (16#43B8#, 16#0020#, 16#0002#),
         22024 => (16#43B9#, 16#0020#, 16#0002#),
         22025 => (16#43BA#, 16#0020#, 16#0002#),
         22026 => (16#43BB#, 16#0020#, 16#0002#),
         22027 => (16#43BC#, 16#0020#, 16#0002#),
         22028 => (16#43BD#, 16#0020#, 16#0002#),
         22029 => (16#43BE#, 16#0020#, 16#0002#),
         22030 => (16#43BF#, 16#0020#, 16#0002#),
         22031 => (16#43C0#, 16#0020#, 16#0002#),
         22032 => (16#43C1#, 16#0020#, 16#0002#),
         22033 => (16#43C2#, 16#0020#, 16#0002#),
         22034 => (16#43C3#, 16#0020#, 16#0002#),
         22035 => (16#43C4#, 16#0020#, 16#0002#),
         22036 => (16#43C5#, 16#0020#, 16#0002#),
         22037 => (16#43C6#, 16#0020#, 16#0002#),
         22038 => (16#43C7#, 16#0020#, 16#0002#),
         22039 => (16#43C8#, 16#0020#, 16#0002#),
         22040 => (16#43C9#, 16#0020#, 16#0002#),
         22041 => (16#43CA#, 16#0020#, 16#0002#),
         22042 => (16#43CB#, 16#0020#, 16#0002#),
         22043 => (16#43CC#, 16#0020#, 16#0002#),
         22044 => (16#43CD#, 16#0020#, 16#0002#),
         22045 => (16#43CE#, 16#0020#, 16#0002#),
         22046 => (16#43CF#, 16#0020#, 16#0002#),
         22047 => (16#43D0#, 16#0020#, 16#0002#),
         22048 => (16#43D1#, 16#0020#, 16#0002#),
         22049 => (16#43D2#, 16#0020#, 16#0002#),
         22050 => (16#43D3#, 16#0020#, 16#0002#),
         22051 => (16#43D4#, 16#0020#, 16#0002#),
         22052 => (16#43D5#, 16#0020#, 16#0002#),
         22053 => (16#43D6#, 16#0020#, 16#0002#),
         22054 => (16#43D7#, 16#0020#, 16#0002#),
         22055 => (16#43D8#, 16#0020#, 16#0002#),
         22056 => (16#43D9#, 16#0020#, 16#0002#),
         22057 => (16#43DA#, 16#0020#, 16#0002#),
         22058 => (16#43DB#, 16#0020#, 16#0002#),
         22059 => (16#43DB#, 16#0020#, 16#0004#),
         22060 => (16#0000#, 16#0108#, 16#0004#),
         22061 => (16#43DC#, 16#0020#, 16#0002#),
         22062 => (16#43DD#, 16#0020#, 16#0002#),
         22063 => (16#43DE#, 16#0020#, 16#0002#),
         22064 => (16#43DF#, 16#0020#, 16#0002#),
         22065 => (16#43E0#, 16#0020#, 16#0002#),
         22066 => (16#43E1#, 16#0020#, 16#0002#),
         22067 => (16#43E2#, 16#0020#, 16#0002#),
         22068 => (16#0320#, 16#0020#, 16#0002#),
         22069 => (16#01D0#, 16#0020#, 16#0002#),
         22070 => (16#01D1#, 16#0020#, 16#0002#),
         22071 => (16#01D2#, 16#0020#, 16#0002#),
         22072 => (16#01D3#, 16#0020#, 16#0002#),
         22073 => (16#01D4#, 16#0020#, 16#0002#),
         22074 => (16#01D5#, 16#0020#, 16#0002#),
         22075 => (16#4425#, 16#0020#, 16#0002#),
         22076 => (16#4426#, 16#0020#, 16#0002#),
         22077 => (16#4427#, 16#0020#, 16#0002#),
         22078 => (16#4428#, 16#0020#, 16#0002#),
         22079 => (16#4429#, 16#0020#, 16#0002#),
         22080 => (16#442A#, 16#0020#, 16#0002#),
         22081 => (16#442B#, 16#0020#, 16#0002#),
         22082 => (16#442C#, 16#0020#, 16#0002#),
         22083 => (16#442D#, 16#0020#, 16#0002#),
         22084 => (16#442E#, 16#0020#, 16#0002#),
         22085 => (16#442F#, 16#0020#, 16#0002#),
         22086 => (16#4430#, 16#0020#, 16#0002#),
         22087 => (16#4431#, 16#0020#, 16#0002#),
         22088 => (16#4432#, 16#0020#, 16#0002#),
         22089 => (16#4433#, 16#0020#, 16#0002#),
         22090 => (16#4434#, 16#0020#, 16#0002#),
         22091 => (16#4435#, 16#0020#, 16#0002#),
         22092 => (16#4436#, 16#0020#, 16#0002#),
         22093 => (16#4437#, 16#0020#, 16#0002#),
         22094 => (16#4438#, 16#0020#, 16#0002#),
         22095 => (16#4439#, 16#0020#, 16#0002#),
         22096 => (16#443A#, 16#0020#, 16#0002#),
         22097 => (16#17B4#, 16#0020#, 16#0002#),
         22098 => (16#17B5#, 16#0020#, 16#0002#),
         22099 => (16#17B6#, 16#0020#, 16#0002#),
         22100 => (16#17B7#, 16#0020#, 16#0002#),
         22101 => (16#443B#, 16#0020#, 16#0002#),
         22102 => (16#443C#, 16#0020#, 16#0002#),
         22103 => (16#443D#, 16#0020#, 16#0002#),
         22104 => (16#443E#, 16#0020#, 16#0002#),
         22105 => (16#443F#, 16#0020#, 16#0002#),
         22106 => (16#4440#, 16#0020#, 16#0002#),
         22107 => (16#4441#, 16#0020#, 16#0002#),
         22108 => (16#4442#, 16#0020#, 16#0002#),
         22109 => (16#4443#, 16#0020#, 16#0002#),
         22110 => (16#4444#, 16#0020#, 16#0002#),
         22111 => (16#4445#, 16#0020#, 16#0002#),
         22112 => (16#4446#, 16#0020#, 16#0002#),
         22113 => (16#4447#, 16#0020#, 16#0002#),
         22114 => (16#4448#, 16#0020#, 16#0002#),
         22115 => (16#4449#, 16#0020#, 16#0002#),
         22116 => (16#444A#, 16#0020#, 16#0002#),
         22117 => (16#444B#, 16#0020#, 16#0002#),
         22118 => (16#444C#, 16#0020#, 16#0002#),
         22119 => (16#444D#, 16#0020#, 16#0002#),
         22120 => (16#17B8#, 16#0020#, 16#0002#),
         22121 => (16#17B9#, 16#0020#, 16#0002#),
         22122 => (16#17BA#, 16#0020#, 16#0002#),
         22123 => (16#17BB#, 16#0020#, 16#0002#),
         22124 => (16#444E#, 16#0020#, 16#0002#),
         22125 => (16#444F#, 16#0020#, 16#0002#),
         22126 => (16#4450#, 16#0020#, 16#0002#),
         22127 => (16#4451#, 16#0020#, 16#0002#),
         22128 => (16#4452#, 16#0020#, 16#0002#),
         22129 => (16#4453#, 16#0020#, 16#0002#),
         22130 => (16#4454#, 16#0020#, 16#0002#),
         22131 => (16#4455#, 16#0020#, 16#0002#),
         22132 => (16#4456#, 16#0020#, 16#0002#),
         22133 => (16#4457#, 16#0020#, 16#0002#),
         22134 => (16#4458#, 16#0020#, 16#0002#),
         22135 => (16#4459#, 16#0020#, 16#0002#),
         22136 => (16#445A#, 16#0020#, 16#0002#),
         22137 => (16#445B#, 16#0020#, 16#0002#),
         22138 => (16#445C#, 16#0020#, 16#0002#),
         22139 => (16#445D#, 16#0020#, 16#0002#),
         22140 => (16#445E#, 16#0020#, 16#0002#),
         22141 => (16#445F#, 16#0020#, 16#0002#),
         22142 => (16#0328#, 16#0020#, 16#0002#),
         22143 => (16#0329#, 16#0020#, 16#0002#),
         22144 => (16#032A#, 16#0020#, 16#0002#),
         22145 => (16#032B#, 16#0020#, 16#0002#),
         22146 => (16#17BC#, 16#0020#, 16#0002#),
         22147 => (16#17BD#, 16#0020#, 16#0002#),
         22148 => (16#17BE#, 16#0020#, 16#0002#),
         22149 => (16#327D#, 16#0020#, 16#0002#),
         22150 => (16#327D#, 16#0020#, 16#0004#),
         22151 => (16#0000#, 16#0108#, 16#0004#),
         22152 => (16#327E#, 16#0020#, 16#0002#),
         22153 => (16#327F#, 16#0020#, 16#0002#),
         22154 => (16#327F#, 16#0020#, 16#0004#),
         22155 => (16#0000#, 16#0108#, 16#0004#),
         22156 => (16#3280#, 16#0020#, 16#0002#),
         22157 => (16#3281#, 16#0020#, 16#0002#),
         22158 => (16#3282#, 16#0020#, 16#0002#),
         22159 => (16#3282#, 16#0020#, 16#0004#),
         22160 => (16#0000#, 16#0108#, 16#0004#),
         22161 => (16#3283#, 16#0020#, 16#0002#),
         22162 => (16#3283#, 16#0020#, 16#0004#),
         22163 => (16#0000#, 16#0108#, 16#0004#),
         22164 => (16#3284#, 16#0020#, 16#0002#),
         22165 => (16#3284#, 16#0020#, 16#0004#),
         22166 => (16#0000#, 16#0108#, 16#0004#),
         22167 => (16#3285#, 16#0020#, 16#0002#),
         22168 => (16#3285#, 16#0020#, 16#0004#),
         22169 => (16#0000#, 16#0108#, 16#0004#),
         22170 => (16#3286#, 16#0020#, 16#0002#),
         22171 => (16#3286#, 16#0020#, 16#0004#),
         22172 => (16#0000#, 16#0108#, 16#0004#),
         22173 => (16#3287#, 16#0020#, 16#0002#),
         22174 => (16#3287#, 16#0020#, 16#0004#),
         22175 => (16#0000#, 16#0108#, 16#0004#),
         22176 => (16#3288#, 16#0020#, 16#0002#),
         22177 => (16#3289#, 16#0020#, 16#0002#),
         22178 => (16#3289#, 16#0020#, 16#0004#),
         22179 => (16#0000#, 16#0108#, 16#0004#),
         22180 => (16#328A#, 16#0020#, 16#0002#),
         22181 => (16#328A#, 16#0020#, 16#0004#),
         22182 => (16#0000#, 16#0108#, 16#0004#),
         22183 => (16#328B#, 16#0020#, 16#0002#),
         22184 => (16#328B#, 16#0020#, 16#0004#),
         22185 => (16#0000#, 16#0108#, 16#0004#),
         22186 => (16#328C#, 16#0020#, 16#0002#),
         22187 => (16#328C#, 16#0020#, 16#0004#),
         22188 => (16#0000#, 16#0108#, 16#0004#),
         22189 => (16#328D#, 16#0020#, 16#0002#),
         22190 => (16#328D#, 16#0020#, 16#0004#),
         22191 => (16#0000#, 16#0108#, 16#0004#),
         22192 => (16#328E#, 16#0020#, 16#0002#),
         22193 => (16#328E#, 16#0020#, 16#0004#),
         22194 => (16#0000#, 16#0108#, 16#0004#),
         22195 => (16#328F#, 16#0020#, 16#0002#),
         22196 => (16#3290#, 16#0020#, 16#0002#),
         22197 => (16#3291#, 16#0020#, 16#0002#),
         22198 => (16#3292#, 16#0020#, 16#0002#),
         22199 => (16#3293#, 16#0020#, 16#0002#),
         22200 => (16#3293#, 16#0020#, 16#0004#),
         22201 => (16#0000#, 16#0108#, 16#0004#),
         22202 => (16#3294#, 16#0020#, 16#0002#),
         22203 => (16#3294#, 16#0020#, 16#0004#),
         22204 => (16#0000#, 16#0108#, 16#0004#),
         22205 => (16#3295#, 16#0020#, 16#0002#),
         22206 => (16#3295#, 16#0020#, 16#0004#),
         22207 => (16#0000#, 16#0108#, 16#0004#),
         22208 => (16#3296#, 16#0020#, 16#0002#),
         22209 => (16#3296#, 16#0020#, 16#0004#),
         22210 => (16#0000#, 16#0108#, 16#0004#),
         22211 => (16#3297#, 16#0020#, 16#0002#),
         22212 => (16#3298#, 16#0020#, 16#0002#),
         22213 => (16#3298#, 16#0020#, 16#0004#),
         22214 => (16#0000#, 16#0108#, 16#0004#),
         22215 => (16#3299#, 16#0020#, 16#0002#),
         22216 => (16#329A#, 16#0020#, 16#0002#),
         22217 => (16#329B#, 16#0020#, 16#0002#),
         22218 => (16#329C#, 16#0020#, 16#0002#),
         22219 => (16#329C#, 16#0020#, 16#0004#),
         22220 => (16#0000#, 16#0108#, 16#0004#),
         22221 => (16#329D#, 16#0020#, 16#0002#),
         22222 => (16#329D#, 16#0020#, 16#0004#),
         22223 => (16#0000#, 16#0108#, 16#0004#),
         22224 => (16#329E#, 16#0020#, 16#0002#),
         22225 => (16#329E#, 16#0020#, 16#0004#),
         22226 => (16#0000#, 16#0108#, 16#0004#),
         22227 => (16#329F#, 16#0020#, 16#0002#),
         22228 => (16#329F#, 16#0020#, 16#0004#),
         22229 => (16#0000#, 16#0108#, 16#0004#),
         22230 => (16#32A0#, 16#0020#, 16#0002#),
         22231 => (16#32A0#, 16#0020#, 16#0004#),
         22232 => (16#0000#, 16#0108#, 16#0004#),
         22233 => (16#32A1#, 16#0020#, 16#0002#),
         22234 => (16#32A2#, 16#0020#, 16#0002#),
         22235 => (16#32A3#, 16#0020#, 16#0002#),
         22236 => (16#32A4#, 16#0020#, 16#0002#),
         22237 => (16#32A4#, 16#0020#, 16#0004#),
         22238 => (16#0000#, 16#0108#, 16#0004#),
         22239 => (16#32A5#, 16#0020#, 16#0002#),
         22240 => (16#32A5#, 16#0020#, 16#0004#),
         22241 => (16#0000#, 16#0108#, 16#0004#),
         22242 => (16#32A6#, 16#0020#, 16#0002#),
         22243 => (16#32A6#, 16#0020#, 16#0004#),
         22244 => (16#0000#, 16#0108#, 16#0004#),
         22245 => (16#32A7#, 16#0020#, 16#0002#),
         22246 => (16#32A7#, 16#0020#, 16#0004#),
         22247 => (16#0000#, 16#0108#, 16#0004#),
         22248 => (16#32A8#, 16#0020#, 16#0002#),
         22249 => (16#32A9#, 16#0020#, 16#0002#),
         22250 => (16#1722#, 16#0020#, 16#0002#),
         22251 => (16#1723#, 16#0020#, 16#0002#),
         22252 => (16#1724#, 16#0020#, 16#0002#),
         22253 => (16#1725#, 16#0020#, 16#0002#),
         22254 => (16#1726#, 16#0020#, 16#0002#),
         22255 => (16#1727#, 16#0020#, 16#0002#),
         22256 => (16#1728#, 16#0020#, 16#0002#),
         22257 => (16#1729#, 16#0020#, 16#0002#),
         22258 => (16#172A#, 16#0020#, 16#0002#),
         22259 => (16#172B#, 16#0020#, 16#0002#),
         22260 => (16#172C#, 16#0020#, 16#0002#),
         22261 => (16#172D#, 16#0020#, 16#0002#),
         22262 => (16#172E#, 16#0020#, 16#0002#),
         22263 => (16#172F#, 16#0020#, 16#0002#),
         22264 => (16#1730#, 16#0020#, 16#0002#),
         22265 => (16#1731#, 16#0020#, 16#0002#),
         22266 => (16#1732#, 16#0020#, 16#0002#),
         22267 => (16#1733#, 16#0020#, 16#0002#),
         22268 => (16#1734#, 16#0020#, 16#0002#),
         22269 => (16#1735#, 16#0020#, 16#0002#),
         22270 => (16#1736#, 16#0020#, 16#0002#),
         22271 => (16#1737#, 16#0020#, 16#0002#),
         22272 => (16#2911#, 16#0020#, 16#0002#),
         22273 => (16#2912#, 16#0020#, 16#0002#),
         22274 => (16#28E2#, 16#0020#, 16#0002#),
         22275 => (16#28E3#, 16#0020#, 16#0002#),
         22276 => (16#28E4#, 16#0020#, 16#0002#),
         22277 => (16#28E5#, 16#0020#, 16#0002#),
         22278 => (16#28E6#, 16#0020#, 16#0002#),
         22279 => (16#28E7#, 16#0020#, 16#0002#),
         22280 => (16#28E8#, 16#0020#, 16#0002#),
         22281 => (16#28E9#, 16#0020#, 16#0002#),
         22282 => (16#28EA#, 16#0020#, 16#0002#),
         22283 => (16#28EB#, 16#0020#, 16#0002#),
         22284 => (16#28EC#, 16#0020#, 16#0002#),
         22285 => (16#28ED#, 16#0020#, 16#0002#),
         22286 => (16#28EE#, 16#0020#, 16#0002#),
         22287 => (16#28EF#, 16#0020#, 16#0002#),
         22288 => (16#28F0#, 16#0020#, 16#0002#),
         22289 => (16#28F1#, 16#0020#, 16#0002#),
         22290 => (16#28F2#, 16#0020#, 16#0002#),
         22291 => (16#28F3#, 16#0020#, 16#0002#),
         22292 => (16#28F4#, 16#0020#, 16#0002#),
         22293 => (16#28F5#, 16#0020#, 16#0002#),
         22294 => (16#28F6#, 16#0020#, 16#0002#),
         22295 => (16#28F7#, 16#0020#, 16#0002#),
         22296 => (16#28F8#, 16#0020#, 16#0002#),
         22297 => (16#28F9#, 16#0020#, 16#0002#),
         22298 => (16#28FA#, 16#0020#, 16#0002#),
         22299 => (16#28FB#, 16#0020#, 16#0002#),
         22300 => (16#28FC#, 16#0020#, 16#0002#),
         22301 => (16#28FD#, 16#0020#, 16#0002#),
         22302 => (16#28FE#, 16#0020#, 16#0002#),
         22303 => (16#28FF#, 16#0020#, 16#0002#),
         22304 => (16#2900#, 16#0020#, 16#0002#),
         22305 => (16#2901#, 16#0020#, 16#0002#),
         22306 => (16#2902#, 16#0020#, 16#0002#),
         22307 => (16#2903#, 16#0020#, 16#0002#),
         22308 => (16#2904#, 16#0020#, 16#0002#),
         22309 => (16#2905#, 16#0020#, 16#0002#),
         22310 => (16#2906#, 16#0020#, 16#0002#),
         22311 => (16#2907#, 16#0020#, 16#0002#),
         22312 => (16#2908#, 16#0020#, 16#0002#),
         22313 => (16#2909#, 16#0020#, 16#0002#),
         22314 => (16#290A#, 16#0020#, 16#0002#),
         22315 => (16#290B#, 16#0020#, 16#0002#),
         22316 => (16#290C#, 16#0020#, 16#0002#),
         22317 => (16#290D#, 16#0020#, 16#0002#),
         22318 => (16#290E#, 16#0020#, 16#0002#),
         22319 => (16#290F#, 16#0020#, 16#0002#),
         22320 => (16#2910#, 16#0020#, 16#0002#),
         22321 => (16#2913#, 16#0020#, 16#0002#),
         22322 => (16#2914#, 16#0020#, 16#0002#),
         22323 => (16#2915#, 16#0020#, 16#0002#),
         22324 => (16#2916#, 16#0020#, 16#0002#),
         22325 => (16#2917#, 16#0020#, 16#0002#),
         22326 => (16#2918#, 16#0020#, 16#0002#),
         22327 => (16#2919#, 16#0020#, 16#0002#),
         22328 => (16#291A#, 16#0020#, 16#0002#),
         22329 => (16#291B#, 16#0020#, 16#0002#),
         22330 => (16#291C#, 16#0020#, 16#0002#),
         22331 => (16#291D#, 16#0020#, 16#0002#),
         22332 => (16#291E#, 16#0020#, 16#0002#),
         22333 => (16#291F#, 16#0020#, 16#0002#),
         22334 => (16#2920#, 16#0020#, 16#0002#),
         22335 => (16#2921#, 16#0020#, 16#0002#),
         22336 => (16#2922#, 16#0020#, 16#0002#),
         22337 => (16#2923#, 16#0020#, 16#0002#),
         22338 => (16#2924#, 16#0020#, 16#0002#),
         22339 => (16#2925#, 16#0020#, 16#0002#),
         22340 => (16#01A8#, 16#0020#, 16#0002#),
         22341 => (16#01A9#, 16#0020#, 16#0002#),
         22342 => (16#0314#, 16#0020#, 16#0002#),
         22343 => (16#0315#, 16#0020#, 16#0002#),
         22344 => (16#0316#, 16#0020#, 16#0002#),
         22345 => (16#0317#, 16#0020#, 16#0002#),
         22346 => (16#0318#, 16#0020#, 16#0002#),
         22347 => (16#17BF#, 16#0020#, 16#0002#),
         22348 => (16#17C0#, 16#0020#, 16#0002#),
         22349 => (16#17C1#, 16#0020#, 16#0002#),
         22350 => (16#17C2#, 16#0020#, 16#0002#),
         22351 => (16#17C3#, 16#0020#, 16#0002#),
         22352 => (16#17C4#, 16#0020#, 16#0002#),
         22353 => (16#17C5#, 16#0020#, 16#0002#),
         22354 => (16#17C6#, 16#0020#, 16#0002#),
         22355 => (16#17C7#, 16#0020#, 16#0002#),
         22356 => (16#17C8#, 16#0020#, 16#0002#),
         22357 => (16#17C9#, 16#0020#, 16#0002#),
         22358 => (16#2926#, 16#0020#, 16#0002#),
         22359 => (16#2675#, 16#0020#, 16#0002#),
         22360 => (16#2676#, 16#0020#, 16#0002#),
         22361 => (16#2677#, 16#0020#, 16#0002#),
         22362 => (16#2678#, 16#0020#, 16#0002#),
         22363 => (16#2679#, 16#0020#, 16#0002#),
         22364 => (16#267A#, 16#0020#, 16#0002#),
         22365 => (16#267B#, 16#0020#, 16#0002#),
         22366 => (16#267C#, 16#0020#, 16#0002#),
         22367 => (16#267D#, 16#0020#, 16#0002#),
         22368 => (16#267E#, 16#0020#, 16#0002#),
         22369 => (16#267F#, 16#0020#, 16#0002#),
         22370 => (16#2680#, 16#0020#, 16#0002#),
         22371 => (16#2681#, 16#0020#, 16#0002#),
         22372 => (16#2682#, 16#0020#, 16#0002#),
         22373 => (16#2683#, 16#0020#, 16#0002#),
         22374 => (16#2684#, 16#0020#, 16#0002#),
         22375 => (16#2685#, 16#0020#, 16#0002#),
         22376 => (16#2686#, 16#0020#, 16#0002#),
         22377 => (16#2687#, 16#0020#, 16#0002#),
         22378 => (16#2688#, 16#0020#, 16#0002#),
         22379 => (16#2689#, 16#0020#, 16#0002#),
         22380 => (16#268A#, 16#0020#, 16#0002#),
         22381 => (16#268B#, 16#0020#, 16#0002#),
         22382 => (16#268B#, 16#0020#, 16#0002#),
         22383 => (16#0000#, 16#00BC#, 16#0002#),
         22384 => (16#268C#, 16#0020#, 16#0002#),
         22385 => (16#268C#, 16#0020#, 16#0002#),
         22386 => (16#0000#, 16#00BC#, 16#0002#),
         22387 => (16#268D#, 16#0020#, 16#0002#),
         22388 => (16#268E#, 16#0020#, 16#0002#),
         22389 => (16#268F#, 16#0020#, 16#0002#),
         22390 => (16#2690#, 16#0020#, 16#0002#),
         22391 => (16#2691#, 16#0020#, 16#0002#),
         22392 => (16#2692#, 16#0020#, 16#0002#),
         22393 => (16#2693#, 16#0020#, 16#0002#),
         22394 => (16#2694#, 16#0020#, 16#0002#),
         22395 => (16#2695#, 16#0020#, 16#0002#),
         22396 => (16#2696#, 16#0020#, 16#0002#),
         22397 => (16#2697#, 16#0020#, 16#0002#),
         22398 => (16#2698#, 16#0020#, 16#0002#),
         22399 => (16#2699#, 16#0020#, 16#0002#),
         22400 => (16#269A#, 16#0020#, 16#0002#),
         22401 => (16#2695#, 16#0020#, 16#0002#),
         22402 => (16#0000#, 16#00BC#, 16#0002#),
         22403 => (16#269B#, 16#0020#, 16#0002#),
         22404 => (16#269C#, 16#0020#, 16#0002#),
         22405 => (16#269D#, 16#0020#, 16#0002#),
         22406 => (16#269E#, 16#0020#, 16#0002#),
         22407 => (16#269F#, 16#0020#, 16#0002#),
         22408 => (16#26A0#, 16#0020#, 16#0002#),
         22409 => (16#26A1#, 16#0020#, 16#0002#),
         22410 => (16#26A2#, 16#0020#, 16#0002#),
         22411 => (16#26A3#, 16#0020#, 16#0002#),
         22412 => (16#26A4#, 16#0020#, 16#0002#),
         22413 => (16#26A5#, 16#0020#, 16#0002#),
         22414 => (16#26A6#, 16#0020#, 16#0002#),
         22415 => (16#26A7#, 16#0020#, 16#0002#),
         22416 => (16#26A8#, 16#0020#, 16#0002#),
         22417 => (16#032C#, 16#0020#, 16#0002#),
         22418 => (16#032D#, 16#0020#, 16#0002#),
         22419 => (16#01D6#, 16#0020#, 16#0002#),
         22420 => (16#01D7#, 16#0020#, 16#0002#),
         22421 => (16#01AA#, 16#0020#, 16#0002#),
         22422 => (16#01AB#, 16#0020#, 16#0002#),
         22423 => (16#40DD#, 16#0020#, 16#0002#),
         22424 => (16#40DE#, 16#0020#, 16#0002#),
         22425 => (16#40DF#, 16#0020#, 16#0002#),
         22426 => (16#40E0#, 16#0020#, 16#0002#),
         22427 => (16#40E1#, 16#0020#, 16#0002#),
         22428 => (16#40E2#, 16#0020#, 16#0002#),
         22429 => (16#40E3#, 16#0020#, 16#0002#),
         22430 => (16#40E4#, 16#0020#, 16#0002#),
         22431 => (16#40E5#, 16#0020#, 16#0002#),
         22432 => (16#40E6#, 16#0020#, 16#0002#),
         22433 => (16#40E7#, 16#0020#, 16#0002#),
         22434 => (16#40E8#, 16#0020#, 16#0002#),
         22435 => (16#40E9#, 16#0020#, 16#0002#),
         22436 => (16#40EA#, 16#0020#, 16#0002#),
         22437 => (16#40EB#, 16#0020#, 16#0002#),
         22438 => (16#40EC#, 16#0020#, 16#0002#),
         22439 => (16#40ED#, 16#0020#, 16#0002#),
         22440 => (16#40EE#, 16#0020#, 16#0002#),
         22441 => (16#40EF#, 16#0020#, 16#0002#),
         22442 => (16#40F0#, 16#0020#, 16#0002#),
         22443 => (16#40F1#, 16#0020#, 16#0002#),
         22444 => (16#40F2#, 16#0020#, 16#0002#),
         22445 => (16#40F3#, 16#0020#, 16#0002#),
         22446 => (16#40F4#, 16#0020#, 16#0002#),
         22447 => (16#40F5#, 16#0020#, 16#0002#),
         22448 => (16#2C82#, 16#0020#, 16#0002#),
         22449 => (16#2C83#, 16#0020#, 16#0002#),
         22450 => (16#2C84#, 16#0020#, 16#0002#),
         22451 => (16#2C85#, 16#0020#, 16#0002#),
         22452 => (16#2C86#, 16#0020#, 16#0002#),
         22453 => (16#2C87#, 16#0020#, 16#0002#),
         22454 => (16#2C88#, 16#0020#, 16#0002#),
         22455 => (16#2C89#, 16#0020#, 16#0002#),
         22456 => (16#2C8A#, 16#0020#, 16#0002#),
         22457 => (16#2C8B#, 16#0020#, 16#0002#),
         22458 => (16#2C8C#, 16#0020#, 16#0002#),
         22459 => (16#2C8D#, 16#0020#, 16#0002#),
         22460 => (16#2C8E#, 16#0020#, 16#0002#),
         22461 => (16#2C8F#, 16#0020#, 16#0002#),
         22462 => (16#2C90#, 16#0020#, 16#0002#),
         22463 => (16#2C91#, 16#0020#, 16#0002#),
         22464 => (16#2C92#, 16#0020#, 16#0002#),
         22465 => (16#2C93#, 16#0020#, 16#0002#),
         22466 => (16#2C94#, 16#0020#, 16#0002#),
         22467 => (16#2C95#, 16#0020#, 16#0002#),
         22468 => (16#2C96#, 16#0020#, 16#0002#),
         22469 => (16#2C97#, 16#0020#, 16#0002#),
         22470 => (16#2C98#, 16#0020#, 16#0002#),
         22471 => (16#2C99#, 16#0020#, 16#0002#),
         22472 => (16#2C9A#, 16#0020#, 16#0002#),
         22473 => (16#2C9B#, 16#0020#, 16#0002#),
         22474 => (16#2C9C#, 16#0020#, 16#0002#),
         22475 => (16#2C9D#, 16#0020#, 16#0002#),
         22476 => (16#2C9E#, 16#0020#, 16#0002#),
         22477 => (16#2C9F#, 16#0020#, 16#0002#),
         22478 => (16#2CA0#, 16#0020#, 16#0002#),
         22479 => (16#2CA1#, 16#0020#, 16#0002#),
         22480 => (16#2CA2#, 16#0020#, 16#0002#),
         22481 => (16#2CA3#, 16#0020#, 16#0002#),
         22482 => (16#2CA4#, 16#0020#, 16#0002#),
         22483 => (16#2CA5#, 16#0020#, 16#0002#),
         22484 => (16#2CA6#, 16#0020#, 16#0002#),
         22485 => (16#2CA7#, 16#0020#, 16#0002#),
         22486 => (16#2CA8#, 16#0020#, 16#0002#),
         22487 => (16#2CA9#, 16#0020#, 16#0002#),
         22488 => (16#2CAA#, 16#0020#, 16#0002#),
         22489 => (16#2CAB#, 16#0020#, 16#0002#),
         22490 => (16#2CAC#, 16#0020#, 16#0002#),
         22491 => (16#2CAD#, 16#0020#, 16#0002#),
         22492 => (16#2CAE#, 16#0020#, 16#0002#),
         22493 => (16#2CAF#, 16#0020#, 16#0002#),
         22494 => (16#2CB0#, 16#0020#, 16#0002#),
         22495 => (16#2CB1#, 16#0020#, 16#0002#),
         22496 => (16#2CB2#, 16#0020#, 16#0002#),
         22497 => (16#2CB3#, 16#0020#, 16#0002#),
         22498 => (16#01D8#, 16#0020#, 16#0002#),
         22499 => (16#01AC#, 16#0020#, 16#0002#),
         22500 => (16#01AD#, 16#0020#, 16#0002#),
         22501 => (16#0170#, 16#0020#, 16#0002#),
         22502 => (16#26A9#, 16#0020#, 16#0002#),
         22503 => (16#26AA#, 16#0020#, 16#0002#),
         22504 => (16#26AB#, 16#0020#, 16#0002#),
         22505 => (16#26AC#, 16#0020#, 16#0002#),
         22506 => (16#26AD#, 16#0020#, 16#0002#),
         22507 => (16#26AE#, 16#0020#, 16#0002#),
         22508 => (16#26AF#, 16#0020#, 16#0002#),
         22509 => (16#26B0#, 16#0020#, 16#0002#),
         22510 => (16#26B1#, 16#0020#, 16#0002#),
         22511 => (16#26B2#, 16#0020#, 16#0002#),
         22512 => (16#26B3#, 16#0020#, 16#0002#),
         22513 => (16#26B4#, 16#0020#, 16#0002#),
         22514 => (16#26B5#, 16#0020#, 16#0002#),
         22515 => (16#26B6#, 16#0020#, 16#0002#),
         22516 => (16#26B7#, 16#0020#, 16#0002#),
         22517 => (16#26B8#, 16#0020#, 16#0002#),
         22518 => (16#26B9#, 16#0020#, 16#0002#),
         22519 => (16#26BA#, 16#0020#, 16#0002#),
         22520 => (16#26BB#, 16#0020#, 16#0002#),
         22521 => (16#26BC#, 16#0020#, 16#0002#),
         22522 => (16#26BD#, 16#0020#, 16#0002#),
         22523 => (16#26BE#, 16#0020#, 16#0002#),
         22524 => (16#26BF#, 16#0020#, 16#0002#),
         22525 => (16#26C0#, 16#0020#, 16#0002#),
         22526 => (16#26C1#, 16#0020#, 16#0002#),
         22527 => (16#26C2#, 16#0020#, 16#0002#),
         22528 => (16#26C3#, 16#0020#, 16#0002#),
         22529 => (16#26C4#, 16#0020#, 16#0002#),
         22530 => (16#26C5#, 16#0020#, 16#0002#),
         22531 => (16#26C6#, 16#0020#, 16#0002#),
         22532 => (16#26C7#, 16#0020#, 16#0002#),
         22533 => (16#26C8#, 16#0020#, 16#0002#),
         22534 => (16#26CA#, 16#0020#, 16#0002#),
         22535 => (16#26CB#, 16#0020#, 16#0002#),
         22536 => (16#26CC#, 16#0020#, 16#0002#),
         22537 => (16#032E#, 16#0020#, 16#0002#),
         22538 => (16#032F#, 16#0020#, 16#0002#),
         22539 => (16#26C9#, 16#0020#, 16#0002#),
         22540 => (16#26CF#, 16#0020#, 16#0002#),
         22541 => (16#26D0#, 16#0020#, 16#0002#),
         22542 => (16#26D1#, 16#0020#, 16#0002#),
         22543 => (16#26D2#, 16#0020#, 16#0002#),
         22544 => (16#26D3#, 16#0020#, 16#0002#),
         22545 => (16#26D4#, 16#0020#, 16#0002#),
         22546 => (16#26D5#, 16#0020#, 16#0002#),
         22547 => (16#26D6#, 16#0020#, 16#0002#),
         22548 => (16#26D7#, 16#0020#, 16#0002#),
         22549 => (16#26D8#, 16#0020#, 16#0002#),
         22550 => (16#26D9#, 16#0020#, 16#0002#),
         22551 => (16#26DA#, 16#0020#, 16#0002#),
         22552 => (16#26DB#, 16#0020#, 16#0002#),
         22553 => (16#26DC#, 16#0020#, 16#0002#),
         22554 => (16#26DD#, 16#0020#, 16#0002#),
         22555 => (16#26DE#, 16#0020#, 16#0002#),
         22556 => (16#26DF#, 16#0020#, 16#0002#),
         22557 => (16#26E0#, 16#0020#, 16#0002#),
         22558 => (16#26E1#, 16#0020#, 16#0002#),
         22559 => (16#26E2#, 16#0020#, 16#0002#),
         22560 => (16#26E3#, 16#0020#, 16#0002#),
         22561 => (16#26E4#, 16#0020#, 16#0002#),
         22562 => (16#26E5#, 16#0020#, 16#0002#),
         22563 => (16#26E6#, 16#0020#, 16#0002#),
         22564 => (16#26E7#, 16#0020#, 16#0002#),
         22565 => (16#26E8#, 16#0020#, 16#0002#),
         22566 => (16#26E9#, 16#0020#, 16#0002#),
         22567 => (16#26EA#, 16#0020#, 16#0002#),
         22568 => (16#26EB#, 16#0020#, 16#0002#),
         22569 => (16#26EC#, 16#0020#, 16#0002#),
         22570 => (16#26ED#, 16#0020#, 16#0002#),
         22571 => (16#26EE#, 16#0020#, 16#0002#),
         22572 => (16#26EF#, 16#0020#, 16#0002#),
         22573 => (16#26F0#, 16#0020#, 16#0002#),
         22574 => (16#26F1#, 16#0020#, 16#0002#),
         22575 => (16#26F2#, 16#0020#, 16#0002#),
         22576 => (16#26F3#, 16#0020#, 16#0002#),
         22577 => (16#26F4#, 16#0020#, 16#0002#),
         22578 => (16#26F5#, 16#0020#, 16#0002#),
         22579 => (16#26F6#, 16#0020#, 16#0002#),
         22580 => (16#26F7#, 16#0020#, 16#0002#),
         22581 => (16#26F8#, 16#0020#, 16#0002#),
         22582 => (16#26F9#, 16#0020#, 16#0002#),
         22583 => (16#26FA#, 16#0020#, 16#0002#),
         22584 => (16#26FB#, 16#0020#, 16#0002#),
         22585 => (16#26FC#, 16#0020#, 16#0002#),
         22586 => (16#26FD#, 16#0020#, 16#0002#),
         22587 => (16#26FE#, 16#0020#, 16#0002#),
         22588 => (16#2702#, 16#0020#, 16#0002#),
         22589 => (16#2703#, 16#0020#, 16#0002#),
         22590 => (16#2704#, 16#0020#, 16#0002#),
         22591 => (16#2705#, 16#0020#, 16#0002#),
         22592 => (16#2706#, 16#0020#, 16#0002#),
         22593 => (16#2707#, 16#0020#, 16#0002#),
         22594 => (16#2708#, 16#0020#, 16#0002#),
         22595 => (16#2709#, 16#0020#, 16#0002#),
         22596 => (16#270A#, 16#0020#, 16#0002#),
         22597 => (16#270B#, 16#0020#, 16#0002#),
         22598 => (16#270C#, 16#0020#, 16#0002#),
         22599 => (16#270D#, 16#0020#, 16#0002#),
         22600 => (16#270E#, 16#0020#, 16#0002#),
         22601 => (16#270F#, 16#0020#, 16#0002#),
         22602 => (16#26FF#, 16#0020#, 16#0002#),
         22603 => (16#2700#, 16#0020#, 16#0002#),
         22604 => (16#2701#, 16#0020#, 16#0002#),
         22605 => (16#26CD#, 16#0020#, 16#0002#),
         22606 => (16#01AE#, 16#0020#, 16#0002#),
         22607 => (16#01AF#, 16#0020#, 16#0002#),
         22608 => (16#0331#, 16#0020#, 16#0002#),
         22609 => (16#01D9#, 16#0020#, 16#0002#),
         22610 => (16#0330#, 16#0020#, 16#0002#),
         22611 => (16#26CE#, 16#0020#, 16#0002#),
         22612 => (16#17CE#, 16#0020#, 16#0002#),
         22613 => (16#17CF#, 16#0020#, 16#0002#),
         22614 => (16#17D0#, 16#0020#, 16#0002#),
         22615 => (16#17D1#, 16#0020#, 16#0002#),
         22616 => (16#17D2#, 16#0020#, 16#0002#),
         22617 => (16#17D3#, 16#0020#, 16#0002#),
         22618 => (16#17D4#, 16#0020#, 16#0002#),
         22619 => (16#17D5#, 16#0020#, 16#0002#),
         22620 => (16#17D6#, 16#0020#, 16#0002#),
         22621 => (16#17D7#, 16#0020#, 16#0002#),
         22622 => (16#17D8#, 16#0020#, 16#0002#),
         22623 => (16#2710#, 16#0020#, 16#0002#),
         22624 => (16#2711#, 16#0020#, 16#0002#),
         22625 => (16#2712#, 16#0020#, 16#0002#),
         22626 => (16#2713#, 16#0020#, 16#0002#),
         22627 => (16#2714#, 16#0020#, 16#0002#),
         22628 => (16#2715#, 16#0020#, 16#0002#),
         22629 => (16#2716#, 16#0020#, 16#0002#),
         22630 => (16#2717#, 16#0020#, 16#0002#),
         22631 => (16#2718#, 16#0020#, 16#0002#),
         22632 => (16#2719#, 16#0020#, 16#0002#),
         22633 => (16#271A#, 16#0020#, 16#0002#),
         22634 => (16#271B#, 16#0020#, 16#0002#),
         22635 => (16#271C#, 16#0020#, 16#0002#),
         22636 => (16#271D#, 16#0020#, 16#0002#),
         22637 => (16#271E#, 16#0020#, 16#0002#),
         22638 => (16#271F#, 16#0020#, 16#0002#),
         22639 => (16#2720#, 16#0020#, 16#0002#),
         22640 => (16#2721#, 16#0020#, 16#0002#),
         22641 => (16#2722#, 16#0020#, 16#0002#),
         22642 => (16#2723#, 16#0020#, 16#0002#),
         22643 => (16#2724#, 16#0020#, 16#0002#),
         22644 => (16#2725#, 16#0020#, 16#0002#),
         22645 => (16#2726#, 16#0020#, 16#0002#),
         22646 => (16#2727#, 16#0020#, 16#0002#),
         22647 => (16#2728#, 16#0020#, 16#0002#),
         22648 => (16#2729#, 16#0020#, 16#0002#),
         22649 => (16#272A#, 16#0020#, 16#0002#),
         22650 => (16#272B#, 16#0020#, 16#0002#),
         22651 => (16#272C#, 16#0020#, 16#0002#),
         22652 => (16#272D#, 16#0020#, 16#0002#),
         22653 => (16#272E#, 16#0020#, 16#0002#),
         22654 => (16#272F#, 16#0020#, 16#0002#),
         22655 => (16#2730#, 16#0020#, 16#0002#),
         22656 => (16#2731#, 16#0020#, 16#0002#),
         22657 => (16#2732#, 16#0020#, 16#0002#),
         22658 => (16#2733#, 16#0020#, 16#0002#),
         22659 => (16#2734#, 16#0020#, 16#0002#),
         22660 => (16#2735#, 16#0020#, 16#0002#),
         22661 => (16#2736#, 16#0020#, 16#0002#),
         22662 => (16#2737#, 16#0020#, 16#0002#),
         22663 => (16#2738#, 16#0020#, 16#0002#),
         22664 => (16#2739#, 16#0020#, 16#0002#),
         22665 => (16#273A#, 16#0020#, 16#0002#),
         22666 => (16#273B#, 16#0020#, 16#0002#),
         22667 => (16#273C#, 16#0020#, 16#0002#),
         22668 => (16#273D#, 16#0020#, 16#0002#),
         22669 => (16#273E#, 16#0020#, 16#0002#),
         22670 => (16#273F#, 16#0020#, 16#0002#),
         22671 => (16#2740#, 16#0020#, 16#0002#),
         22672 => (16#2741#, 16#0020#, 16#0002#),
         22673 => (16#2742#, 16#0020#, 16#0002#),
         22674 => (16#2743#, 16#0020#, 16#0002#),
         22675 => (16#01B0#, 16#0020#, 16#0002#),
         22676 => (16#01B1#, 16#0020#, 16#0002#),
         22677 => (16#0332#, 16#0020#, 16#0002#),
         22678 => (16#0333#, 16#0020#, 16#0002#),
         22679 => (16#0334#, 16#0020#, 16#0002#),
         22680 => (16#0335#, 16#0020#, 16#0002#),
         22681 => (16#2744#, 16#0020#, 16#0002#),
         22682 => (16#2745#, 16#0020#, 16#0002#),
         22683 => (16#2746#, 16#0020#, 16#0002#),
         22684 => (16#2747#, 16#0020#, 16#0002#),
         22685 => (16#2748#, 16#0020#, 16#0002#),
         22686 => (16#2749#, 16#0020#, 16#0002#),
         22687 => (16#274A#, 16#0020#, 16#0002#),
         22688 => (16#274B#, 16#0020#, 16#0002#),
         22689 => (16#274C#, 16#0020#, 16#0002#),
         22690 => (16#274D#, 16#0020#, 16#0002#),
         22691 => (16#274E#, 16#0020#, 16#0002#),
         22692 => (16#274F#, 16#0020#, 16#0002#),
         22693 => (16#2750#, 16#0020#, 16#0002#),
         22694 => (16#2751#, 16#0020#, 16#0002#),
         22695 => (16#2752#, 16#0020#, 16#0002#),
         22696 => (16#2753#, 16#0020#, 16#0002#),
         22697 => (16#2754#, 16#0020#, 16#0002#),
         22698 => (16#2755#, 16#0020#, 16#0002#),
         22699 => (16#2756#, 16#0020#, 16#0002#),
         22700 => (16#2757#, 16#0020#, 16#0002#),
         22701 => (16#2758#, 16#0020#, 16#0002#),
         22702 => (16#2759#, 16#0020#, 16#0002#),
         22703 => (16#275A#, 16#0020#, 16#0002#),
         22704 => (16#275B#, 16#0020#, 16#0002#),
         22705 => (16#275C#, 16#0020#, 16#0002#),
         22706 => (16#275D#, 16#0020#, 16#0002#),
         22707 => (16#275E#, 16#0020#, 16#0002#),
         22708 => (16#275F#, 16#0020#, 16#0002#),
         22709 => (16#2760#, 16#0020#, 16#0002#),
         22710 => (16#2761#, 16#0020#, 16#0002#),
         22711 => (16#2762#, 16#0020#, 16#0002#),
         22712 => (16#2763#, 16#0020#, 16#0002#),
         22713 => (16#2764#, 16#0020#, 16#0002#),
         22714 => (16#2765#, 16#0020#, 16#0002#),
         22715 => (16#2766#, 16#0020#, 16#0002#),
         22716 => (16#2767#, 16#0020#, 16#0002#),
         22717 => (16#2768#, 16#0020#, 16#0002#),
         22718 => (16#2769#, 16#0020#, 16#0002#),
         22719 => (16#276A#, 16#0020#, 16#0002#),
         22720 => (16#276B#, 16#0020#, 16#0002#),
         22721 => (16#276C#, 16#0020#, 16#0002#),
         22722 => (16#276D#, 16#0020#, 16#0002#),
         22723 => (16#276E#, 16#0020#, 16#0002#),
         22724 => (16#276F#, 16#0020#, 16#0002#),
         22725 => (16#2770#, 16#0020#, 16#0002#),
         22726 => (16#2771#, 16#0020#, 16#0002#),
         22727 => (16#2772#, 16#0020#, 16#0002#),
         22728 => (16#2773#, 16#0020#, 16#0002#),
         22729 => (16#2774#, 16#0020#, 16#0002#),
         22730 => (16#2775#, 16#0020#, 16#0002#),
         22731 => (16#2776#, 16#0020#, 16#0002#),
         22732 => (16#2777#, 16#0020#, 16#0002#),
         22733 => (16#2778#, 16#0020#, 16#0002#),
         22734 => (16#2779#, 16#0020#, 16#0002#),
         22735 => (16#277A#, 16#0020#, 16#0002#),
         22736 => (16#277B#, 16#0020#, 16#0002#),
         22737 => (16#277C#, 16#0020#, 16#0002#),
         22738 => (16#277D#, 16#0020#, 16#0002#),
         22739 => (16#277E#, 16#0020#, 16#0002#),
         22740 => (16#277F#, 16#0020#, 16#0002#),
         22741 => (16#2780#, 16#0020#, 16#0002#),
         22742 => (16#2781#, 16#0020#, 16#0002#),
         22743 => (16#2782#, 16#0020#, 16#0002#),
         22744 => (16#2783#, 16#0020#, 16#0002#),
         22745 => (16#2785#, 16#0020#, 16#0002#),
         22746 => (16#2787#, 16#0020#, 16#0002#),
         22747 => (16#2788#, 16#0020#, 16#0002#),
         22748 => (16#2789#, 16#0020#, 16#0002#),
         22749 => (16#278A#, 16#0020#, 16#0002#),
         22750 => (16#278B#, 16#0020#, 16#0002#),
         22751 => (16#278C#, 16#0020#, 16#0002#),
         22752 => (16#278D#, 16#0020#, 16#0002#),
         22753 => (16#278E#, 16#0020#, 16#0002#),
         22754 => (16#278F#, 16#0020#, 16#0002#),
         22755 => (16#2790#, 16#0020#, 16#0002#),
         22756 => (16#2791#, 16#0020#, 16#0002#),
         22757 => (16#2792#, 16#0020#, 16#0002#),
         22758 => (16#2793#, 16#0020#, 16#0002#),
         22759 => (16#2794#, 16#0020#, 16#0002#),
         22760 => (16#2795#, 16#0020#, 16#0002#),
         22761 => (16#2796#, 16#0020#, 16#0002#),
         22762 => (16#2797#, 16#0020#, 16#0002#),
         22763 => (16#2798#, 16#0020#, 16#0002#),
         22764 => (16#2799#, 16#0020#, 16#0002#),
         22765 => (16#279A#, 16#0020#, 16#0002#),
         22766 => (16#279B#, 16#0020#, 16#0002#),
         22767 => (16#279C#, 16#0020#, 16#0002#),
         22768 => (16#279D#, 16#0020#, 16#0002#),
         22769 => (16#279E#, 16#0020#, 16#0002#),
         22770 => (16#279F#, 16#0020#, 16#0002#),
         22771 => (16#27A0#, 16#0020#, 16#0002#),
         22772 => (16#27A1#, 16#0020#, 16#0002#),
         22773 => (16#27A2#, 16#0020#, 16#0002#),
         22774 => (16#27A3#, 16#0020#, 16#0002#),
         22775 => (16#27A4#, 16#0020#, 16#0002#),
         22776 => (16#27A5#, 16#0020#, 16#0002#),
         22777 => (16#27A6#, 16#0020#, 16#0002#),
         22778 => (16#27A7#, 16#0020#, 16#0002#),
         22779 => (16#27A8#, 16#0020#, 16#0002#),
         22780 => (16#27A9#, 16#0020#, 16#0002#),
         22781 => (16#27AA#, 16#0020#, 16#0002#),
         22782 => (16#27AB#, 16#0020#, 16#0002#),
         22783 => (16#27AC#, 16#0020#, 16#0002#),
         22784 => (16#27AD#, 16#0020#, 16#0002#),
         22785 => (16#27B0#, 16#0020#, 16#0002#),
         22786 => (16#27B1#, 16#0020#, 16#0002#),
         22787 => (16#27B2#, 16#0020#, 16#0002#),
         22788 => (16#27B3#, 16#0020#, 16#0002#),
         22789 => (16#27B4#, 16#0020#, 16#0002#),
         22790 => (16#27B5#, 16#0020#, 16#0002#),
         22791 => (16#27B6#, 16#0020#, 16#0002#),
         22792 => (16#27B9#, 16#0020#, 16#0002#),
         22793 => (16#27BB#, 16#0020#, 16#0002#),
         22794 => (16#27BC#, 16#0020#, 16#0002#),
         22795 => (16#27BA#, 16#0020#, 16#0002#),
         22796 => (16#27BD#, 16#0020#, 16#0002#),
         22797 => (16#27BE#, 16#0020#, 16#0002#),
         22798 => (16#27BF#, 16#0020#, 16#0002#),
         22799 => (16#27AE#, 16#0020#, 16#0002#),
         22800 => (16#27AF#, 16#0020#, 16#0002#),
         22801 => (16#2784#, 16#0020#, 16#0002#),
         22802 => (16#2786#, 16#0020#, 16#0002#),
         22803 => (16#27B7#, 16#0020#, 16#0002#),
         22804 => (16#27B8#, 16#0020#, 16#0002#),
         22805 => (16#27C1#, 16#0020#, 16#0002#),
         22806 => (16#27C2#, 16#0020#, 16#0002#),
         22807 => (16#27C3#, 16#0020#, 16#0002#),
         22808 => (16#27C4#, 16#0020#, 16#0002#),
         22809 => (16#27C5#, 16#0020#, 16#0002#),
         22810 => (16#27C6#, 16#0020#, 16#0002#),
         22811 => (16#27C7#, 16#0020#, 16#0002#),
         22812 => (16#27C8#, 16#0020#, 16#0002#),
         22813 => (16#27C9#, 16#0020#, 16#0002#),
         22814 => (16#27CA#, 16#0020#, 16#0002#),
         22815 => (16#27CB#, 16#0020#, 16#0002#),
         22816 => (16#27CC#, 16#0020#, 16#0002#),
         22817 => (16#27CD#, 16#0020#, 16#0002#),
         22818 => (16#27CE#, 16#0020#, 16#0002#),
         22819 => (16#27CF#, 16#0020#, 16#0002#),
         22820 => (16#27D0#, 16#0020#, 16#0002#),
         22821 => (16#27D1#, 16#0020#, 16#0002#),
         22822 => (16#27D2#, 16#0020#, 16#0002#),
         22823 => (16#27D3#, 16#0020#, 16#0002#),
         22824 => (16#27D4#, 16#0020#, 16#0002#),
         22825 => (16#27D5#, 16#0020#, 16#0002#),
         22826 => (16#27D6#, 16#0020#, 16#0002#),
         22827 => (16#27D7#, 16#0020#, 16#0002#),
         22828 => (16#27D8#, 16#0020#, 16#0002#),
         22829 => (16#27D9#, 16#0020#, 16#0002#),
         22830 => (16#27DA#, 16#0020#, 16#0002#),
         22831 => (16#27DB#, 16#0020#, 16#0002#),
         22832 => (16#27DC#, 16#0020#, 16#0002#),
         22833 => (16#27DD#, 16#0020#, 16#0002#),
         22834 => (16#27DE#, 16#0020#, 16#0002#),
         22835 => (16#27DF#, 16#0020#, 16#0002#),
         22836 => (16#27E0#, 16#0020#, 16#0002#),
         22837 => (16#27E1#, 16#0020#, 16#0002#),
         22838 => (16#27E2#, 16#0020#, 16#0002#),
         22839 => (16#27E3#, 16#0020#, 16#0002#),
         22840 => (16#27E4#, 16#0020#, 16#0002#),
         22841 => (16#27E5#, 16#0020#, 16#0002#),
         22842 => (16#27E6#, 16#0020#, 16#0002#),
         22843 => (16#27E7#, 16#0020#, 16#0002#),
         22844 => (16#27E8#, 16#0020#, 16#0002#),
         22845 => (16#27E9#, 16#0020#, 16#0002#),
         22846 => (16#27EA#, 16#0020#, 16#0002#),
         22847 => (16#27EB#, 16#0020#, 16#0002#),
         22848 => (16#27EC#, 16#0020#, 16#0002#),
         22849 => (16#27ED#, 16#0020#, 16#0002#),
         22850 => (16#27EE#, 16#0020#, 16#0002#),
         22851 => (16#27EF#, 16#0020#, 16#0002#),
         22852 => (16#27F0#, 16#0020#, 16#0002#),
         22853 => (16#27F3#, 16#0020#, 16#0002#),
         22854 => (16#27F4#, 16#0020#, 16#0002#),
         22855 => (16#27F5#, 16#0020#, 16#0002#),
         22856 => (16#27F6#, 16#0020#, 16#0002#),
         22857 => (16#27F7#, 16#0020#, 16#0002#),
         22858 => (16#27F8#, 16#0020#, 16#0002#),
         22859 => (16#27F9#, 16#0020#, 16#0002#),
         22860 => (16#27FA#, 16#0020#, 16#0002#),
         22861 => (16#27FB#, 16#0020#, 16#0002#),
         22862 => (16#27FC#, 16#0020#, 16#0002#),
         22863 => (16#27FE#, 16#0020#, 16#0002#),
         22864 => (16#27FF#, 16#0020#, 16#0002#),
         22865 => (16#2801#, 16#0020#, 16#0002#),
         22866 => (16#27FD#, 16#0020#, 16#0002#),
         22867 => (16#2800#, 16#0020#, 16#0002#),
         22868 => (16#2802#, 16#0020#, 16#0002#),
         22869 => (16#27F1#, 16#0020#, 16#0002#),
         22870 => (16#27F2#, 16#0020#, 16#0002#),
         22871 => (16#0336#, 16#0020#, 16#0002#),
         22872 => (16#27C0#, 16#0020#, 16#0002#),
         22873 => (16#2803#, 16#0020#, 16#0002#),
         22874 => (16#2804#, 16#0020#, 16#0002#),
         22875 => (16#2805#, 16#0020#, 16#0002#),
         22876 => (16#2806#, 16#0020#, 16#0002#),
         22877 => (16#2807#, 16#0020#, 16#0002#),
         22878 => (16#2808#, 16#0020#, 16#0002#),
         22879 => (16#2809#, 16#0020#, 16#0002#),
         22880 => (16#280A#, 16#0020#, 16#0002#),
         22881 => (16#280B#, 16#0020#, 16#0002#),
         22882 => (16#280C#, 16#0020#, 16#0002#),
         22883 => (16#280D#, 16#0020#, 16#0002#),
         22884 => (16#280E#, 16#0020#, 16#0002#),
         22885 => (16#280F#, 16#0020#, 16#0002#),
         22886 => (16#2810#, 16#0020#, 16#0002#),
         22887 => (16#2811#, 16#0020#, 16#0002#),
         22888 => (16#2812#, 16#0020#, 16#0002#),
         22889 => (16#2813#, 16#0020#, 16#0002#),
         22890 => (16#2814#, 16#0020#, 16#0002#),
         22891 => (16#2815#, 16#0020#, 16#0002#),
         22892 => (16#2816#, 16#0020#, 16#0002#),
         22893 => (16#2817#, 16#0020#, 16#0002#),
         22894 => (16#2818#, 16#0020#, 16#0002#),
         22895 => (16#2819#, 16#0020#, 16#0002#),
         22896 => (16#281A#, 16#0020#, 16#0002#),
         22897 => (16#281B#, 16#0020#, 16#0002#),
         22898 => (16#281C#, 16#0020#, 16#0002#),
         22899 => (16#281D#, 16#0020#, 16#0002#),
         22900 => (16#281E#, 16#0020#, 16#0002#),
         22901 => (16#281F#, 16#0020#, 16#0002#),
         22902 => (16#2820#, 16#0020#, 16#0002#),
         22903 => (16#2821#, 16#0020#, 16#0002#),
         22904 => (16#2822#, 16#0020#, 16#0002#),
         22905 => (16#2823#, 16#0020#, 16#0002#),
         22906 => (16#2824#, 16#0020#, 16#0002#),
         22907 => (16#2825#, 16#0020#, 16#0002#),
         22908 => (16#2826#, 16#0020#, 16#0002#),
         22909 => (16#2827#, 16#0020#, 16#0002#),
         22910 => (16#2828#, 16#0020#, 16#0002#),
         22911 => (16#2829#, 16#0020#, 16#0002#),
         22912 => (16#282A#, 16#0020#, 16#0002#),
         22913 => (16#282B#, 16#0020#, 16#0002#),
         22914 => (16#282C#, 16#0020#, 16#0002#),
         22915 => (16#282D#, 16#0020#, 16#0002#),
         22916 => (16#282E#, 16#0020#, 16#0002#),
         22917 => (16#282F#, 16#0020#, 16#0002#),
         22918 => (16#2830#, 16#0020#, 16#0002#),
         22919 => (16#2831#, 16#0020#, 16#0002#),
         22920 => (16#2832#, 16#0020#, 16#0002#),
         22921 => (16#2833#, 16#0020#, 16#0002#),
         22922 => (16#2834#, 16#0020#, 16#0002#),
         22923 => (16#2835#, 16#0020#, 16#0002#),
         22924 => (16#2836#, 16#0020#, 16#0002#),
         22925 => (16#2837#, 16#0020#, 16#0002#),
         22926 => (16#2838#, 16#0020#, 16#0002#),
         22927 => (16#2839#, 16#0020#, 16#0002#),
         22928 => (16#283B#, 16#0020#, 16#0002#),
         22929 => (16#283A#, 16#0020#, 16#0002#),
         22930 => (16#283C#, 16#0020#, 16#0002#),
         22931 => (16#283D#, 16#0020#, 16#0002#),
         22932 => (16#0337#, 16#0020#, 16#0002#),
         22933 => (16#01B2#, 16#0020#, 16#0002#),
         22934 => (16#01B3#, 16#0020#, 16#0002#),
         22935 => (16#0338#, 16#0020#, 16#0002#),
         22936 => (16#0339#, 16#0020#, 16#0002#),
         22937 => (16#033A#, 16#0020#, 16#0002#),
         22938 => (16#033B#, 16#0020#, 16#0002#),
         22939 => (16#033C#, 16#0020#, 16#0002#),
         22940 => (16#033D#, 16#0020#, 16#0002#),
         22941 => (16#283E#, 16#0020#, 16#0002#),
         22942 => (16#283F#, 16#0020#, 16#0002#),
         22943 => (16#2840#, 16#0020#, 16#0002#),
         22944 => (16#2841#, 16#0020#, 16#0002#),
         22945 => (16#2842#, 16#0020#, 16#0002#),
         22946 => (16#2843#, 16#0020#, 16#0002#),
         22947 => (16#2844#, 16#0020#, 16#0002#),
         22948 => (16#2845#, 16#0020#, 16#0002#),
         22949 => (16#2846#, 16#0020#, 16#0002#),
         22950 => (16#2847#, 16#0020#, 16#0002#),
         22951 => (16#2848#, 16#0020#, 16#0002#),
         22952 => (16#2849#, 16#0020#, 16#0002#),
         22953 => (16#284A#, 16#0020#, 16#0002#),
         22954 => (16#284B#, 16#0020#, 16#0002#),
         22955 => (16#284C#, 16#0020#, 16#0002#),
         22956 => (16#284D#, 16#0020#, 16#0002#),
         22957 => (16#284E#, 16#0020#, 16#0002#),
         22958 => (16#284F#, 16#0020#, 16#0002#),
         22959 => (16#2850#, 16#0020#, 16#0002#),
         22960 => (16#2851#, 16#0020#, 16#0002#),
         22961 => (16#2852#, 16#0020#, 16#0002#),
         22962 => (16#2853#, 16#0020#, 16#0002#),
         22963 => (16#2854#, 16#0020#, 16#0002#),
         22964 => (16#2855#, 16#0020#, 16#0002#),
         22965 => (16#2856#, 16#0020#, 16#0002#),
         22966 => (16#2857#, 16#0020#, 16#0002#),
         22967 => (16#2858#, 16#0020#, 16#0002#),
         22968 => (16#2859#, 16#0020#, 16#0002#),
         22969 => (16#285A#, 16#0020#, 16#0002#),
         22970 => (16#285B#, 16#0020#, 16#0002#),
         22971 => (16#285C#, 16#0020#, 16#0002#),
         22972 => (16#285D#, 16#0020#, 16#0002#),
         22973 => (16#285E#, 16#0020#, 16#0002#),
         22974 => (16#285F#, 16#0020#, 16#0002#),
         22975 => (16#2860#, 16#0020#, 16#0002#),
         22976 => (16#2861#, 16#0020#, 16#0002#),
         22977 => (16#2862#, 16#0020#, 16#0002#),
         22978 => (16#2863#, 16#0020#, 16#0002#),
         22979 => (16#2864#, 16#0020#, 16#0002#),
         22980 => (16#2865#, 16#0020#, 16#0002#),
         22981 => (16#2866#, 16#0020#, 16#0002#),
         22982 => (16#2867#, 16#0020#, 16#0002#),
         22983 => (16#2868#, 16#0020#, 16#0002#),
         22984 => (16#2869#, 16#0020#, 16#0002#),
         22985 => (16#286A#, 16#0020#, 16#0002#),
         22986 => (16#286B#, 16#0020#, 16#0002#),
         22987 => (16#286C#, 16#0020#, 16#0002#),
         22988 => (16#286D#, 16#0020#, 16#0002#),
         22989 => (16#286E#, 16#0020#, 16#0002#),
         22990 => (16#286F#, 16#0020#, 16#0002#),
         22991 => (16#2870#, 16#0020#, 16#0002#),
         22992 => (16#2871#, 16#0020#, 16#0002#),
         22993 => (16#2872#, 16#0020#, 16#0002#),
         22994 => (16#2873#, 16#0020#, 16#0002#),
         22995 => (16#2874#, 16#0020#, 16#0002#),
         22996 => (16#2875#, 16#0020#, 16#0002#),
         22997 => (16#2876#, 16#0020#, 16#0002#),
         22998 => (16#2877#, 16#0020#, 16#0002#),
         22999 => (16#2878#, 16#0020#, 16#0002#),
         23000 => (16#2879#, 16#0020#, 16#0002#),
         23001 => (16#287A#, 16#0020#, 16#0002#),
         23002 => (16#287B#, 16#0020#, 16#0002#),
         23003 => (16#01B4#, 16#0020#, 16#0002#),
         23004 => (16#01B5#, 16#0020#, 16#0002#),
         23005 => (16#033E#, 16#0020#, 16#0002#),
         23006 => (16#287C#, 16#0020#, 16#0002#),
         23007 => (16#287D#, 16#0020#, 16#0002#),
         23008 => (16#287E#, 16#0020#, 16#0002#),
         23009 => (16#287F#, 16#0020#, 16#0002#),
         23010 => (16#2880#, 16#0020#, 16#0002#),
         23011 => (16#2881#, 16#0020#, 16#0002#),
         23012 => (16#2882#, 16#0020#, 16#0002#),
         23013 => (16#2883#, 16#0020#, 16#0002#),
         23014 => (16#2884#, 16#0020#, 16#0002#),
         23015 => (16#2885#, 16#0020#, 16#0002#),
         23016 => (16#2886#, 16#0020#, 16#0002#),
         23017 => (16#288A#, 16#0020#, 16#0002#),
         23018 => (16#288B#, 16#0020#, 16#0002#),
         23019 => (16#288C#, 16#0020#, 16#0002#),
         23020 => (16#288D#, 16#0020#, 16#0002#),
         23021 => (16#288E#, 16#0020#, 16#0002#),
         23022 => (16#288F#, 16#0020#, 16#0002#),
         23023 => (16#2890#, 16#0020#, 16#0002#),
         23024 => (16#2891#, 16#0020#, 16#0002#),
         23025 => (16#2892#, 16#0020#, 16#0002#),
         23026 => (16#2893#, 16#0020#, 16#0002#),
         23027 => (16#2894#, 16#0020#, 16#0002#),
         23028 => (16#2895#, 16#0020#, 16#0002#),
         23029 => (16#2896#, 16#0020#, 16#0002#),
         23030 => (16#2897#, 16#0020#, 16#0002#),
         23031 => (16#2898#, 16#0020#, 16#0002#),
         23032 => (16#2899#, 16#0020#, 16#0002#),
         23033 => (16#289A#, 16#0020#, 16#0002#),
         23034 => (16#289B#, 16#0020#, 16#0002#),
         23035 => (16#289C#, 16#0020#, 16#0002#),
         23036 => (16#289D#, 16#0020#, 16#0002#),
         23037 => (16#289E#, 16#0020#, 16#0002#),
         23038 => (16#289F#, 16#0020#, 16#0002#),
         23039 => (16#28A0#, 16#0020#, 16#0002#),
         23040 => (16#28A1#, 16#0020#, 16#0002#),
         23041 => (16#28A2#, 16#0020#, 16#0002#),
         23042 => (16#28A3#, 16#0020#, 16#0002#),
         23043 => (16#28A4#, 16#0020#, 16#0002#),
         23044 => (16#28A5#, 16#0020#, 16#0002#),
         23045 => (16#28A6#, 16#0020#, 16#0002#),
         23046 => (16#2888#, 16#0020#, 16#0002#),
         23047 => (16#2887#, 16#0020#, 16#0002#),
         23048 => (16#2889#, 16#0020#, 16#0002#),
         23049 => (16#28A7#, 16#0020#, 16#0002#),
         23050 => (16#28A8#, 16#0020#, 16#0002#),
         23051 => (16#28A9#, 16#0020#, 16#0002#),
         23052 => (16#28AA#, 16#0020#, 16#0002#),
         23053 => (16#28AB#, 16#0020#, 16#0002#),
         23054 => (16#28AC#, 16#0020#, 16#0002#),
         23055 => (16#28AD#, 16#0020#, 16#0002#),
         23056 => (16#28AE#, 16#0020#, 16#0002#),
         23057 => (16#28AF#, 16#0020#, 16#0002#),
         23058 => (16#28B0#, 16#0020#, 16#0002#),
         23059 => (16#28B1#, 16#0020#, 16#0002#),
         23060 => (16#3E2A#, 16#0020#, 16#0008#),
         23061 => (16#3E2B#, 16#0020#, 16#0008#),
         23062 => (16#3E2C#, 16#0020#, 16#0008#),
         23063 => (16#3E2D#, 16#0020#, 16#0008#),
         23064 => (16#3E2E#, 16#0020#, 16#0008#),
         23065 => (16#3E2F#, 16#0020#, 16#0008#),
         23066 => (16#3E30#, 16#0020#, 16#0008#),
         23067 => (16#3E31#, 16#0020#, 16#0008#),
         23068 => (16#3E32#, 16#0020#, 16#0008#),
         23069 => (16#3E33#, 16#0020#, 16#0008#),
         23070 => (16#3E34#, 16#0020#, 16#0008#),
         23071 => (16#3E35#, 16#0020#, 16#0008#),
         23072 => (16#3E36#, 16#0020#, 16#0008#),
         23073 => (16#3E37#, 16#0020#, 16#0008#),
         23074 => (16#3E38#, 16#0020#, 16#0008#),
         23075 => (16#3E39#, 16#0020#, 16#0008#),
         23076 => (16#3E3A#, 16#0020#, 16#0008#),
         23077 => (16#3E3B#, 16#0020#, 16#0008#),
         23078 => (16#3E3C#, 16#0020#, 16#0008#),
         23079 => (16#3E3D#, 16#0020#, 16#0008#),
         23080 => (16#3E3E#, 16#0020#, 16#0008#),
         23081 => (16#3E3F#, 16#0020#, 16#0008#),
         23082 => (16#3E40#, 16#0020#, 16#0008#),
         23083 => (16#3E41#, 16#0020#, 16#0008#),
         23084 => (16#3E42#, 16#0020#, 16#0008#),
         23085 => (16#3E43#, 16#0020#, 16#0008#),
         23086 => (16#3E44#, 16#0020#, 16#0008#),
         23087 => (16#3E45#, 16#0020#, 16#0008#),
         23088 => (16#3E46#, 16#0020#, 16#0008#),
         23089 => (16#3E47#, 16#0020#, 16#0008#),
         23090 => (16#3E48#, 16#0020#, 16#0008#),
         23091 => (16#3E49#, 16#0020#, 16#0008#),
         23092 => (16#3E2A#, 16#0020#, 16#0002#),
         23093 => (16#3E2B#, 16#0020#, 16#0002#),
         23094 => (16#3E2C#, 16#0020#, 16#0002#),
         23095 => (16#3E2D#, 16#0020#, 16#0002#),
         23096 => (16#3E2E#, 16#0020#, 16#0002#),
         23097 => (16#3E2F#, 16#0020#, 16#0002#),
         23098 => (16#3E30#, 16#0020#, 16#0002#),
         23099 => (16#3E31#, 16#0020#, 16#0002#),
         23100 => (16#3E32#, 16#0020#, 16#0002#),
         23101 => (16#3E33#, 16#0020#, 16#0002#),
         23102 => (16#3E34#, 16#0020#, 16#0002#),
         23103 => (16#3E35#, 16#0020#, 16#0002#),
         23104 => (16#3E36#, 16#0020#, 16#0002#),
         23105 => (16#3E37#, 16#0020#, 16#0002#),
         23106 => (16#3E38#, 16#0020#, 16#0002#),
         23107 => (16#3E39#, 16#0020#, 16#0002#),
         23108 => (16#3E3A#, 16#0020#, 16#0002#),
         23109 => (16#3E3B#, 16#0020#, 16#0002#),
         23110 => (16#3E3C#, 16#0020#, 16#0002#),
         23111 => (16#3E3D#, 16#0020#, 16#0002#),
         23112 => (16#3E3E#, 16#0020#, 16#0002#),
         23113 => (16#3E3F#, 16#0020#, 16#0002#),
         23114 => (16#3E40#, 16#0020#, 16#0002#),
         23115 => (16#3E41#, 16#0020#, 16#0002#),
         23116 => (16#3E42#, 16#0020#, 16#0002#),
         23117 => (16#3E43#, 16#0020#, 16#0002#),
         23118 => (16#3E44#, 16#0020#, 16#0002#),
         23119 => (16#3E45#, 16#0020#, 16#0002#),
         23120 => (16#3E46#, 16#0020#, 16#0002#),
         23121 => (16#3E47#, 16#0020#, 16#0002#),
         23122 => (16#3E48#, 16#0020#, 16#0002#),
         23123 => (16#3E49#, 16#0020#, 16#0002#),
         23124 => (16#17D9#, 16#0020#, 16#0002#),
         23125 => (16#17DA#, 16#0020#, 16#0002#),
         23126 => (16#17DB#, 16#0020#, 16#0002#),
         23127 => (16#17DC#, 16#0020#, 16#0002#),
         23128 => (16#17DD#, 16#0020#, 16#0002#),
         23129 => (16#17DE#, 16#0020#, 16#0002#),
         23130 => (16#17DF#, 16#0020#, 16#0002#),
         23131 => (16#17E0#, 16#0020#, 16#0002#),
         23132 => (16#17E1#, 16#0020#, 16#0002#),
         23133 => (16#3E29#, 16#0020#, 16#0002#),
         23134 => (16#3E51#, 16#0020#, 16#0002#),
         23135 => (16#3E52#, 16#0020#, 16#0002#),
         23136 => (16#3E53#, 16#0020#, 16#0002#),
         23137 => (16#3E54#, 16#0020#, 16#0002#),
         23138 => (16#3E55#, 16#0020#, 16#0002#),
         23139 => (16#3E56#, 16#0020#, 16#0002#),
         23140 => (16#3E57#, 16#0020#, 16#0002#),
         23141 => (16#3E58#, 16#0020#, 16#0002#),
         23142 => (16#3E59#, 16#0020#, 16#0002#),
         23143 => (16#3E5A#, 16#0020#, 16#0002#),
         23144 => (16#3E5B#, 16#0020#, 16#0002#),
         23145 => (16#3E5C#, 16#0020#, 16#0002#),
         23146 => (16#3E5D#, 16#0020#, 16#0002#),
         23147 => (16#3E5E#, 16#0020#, 16#0002#),
         23148 => (16#3E5F#, 16#0020#, 16#0002#),
         23149 => (16#3E60#, 16#0020#, 16#0002#),
         23150 => (16#3E61#, 16#0020#, 16#0002#),
         23151 => (16#3E62#, 16#0020#, 16#0002#),
         23152 => (16#3E63#, 16#0020#, 16#0002#),
         23153 => (16#3E64#, 16#0020#, 16#0002#),
         23154 => (16#3E65#, 16#0020#, 16#0002#),
         23155 => (16#3E4A#, 16#0020#, 16#0002#),
         23156 => (16#3E4B#, 16#0020#, 16#0002#),
         23157 => (16#3E4C#, 16#0020#, 16#0002#),
         23158 => (16#3E4D#, 16#0020#, 16#0002#),
         23159 => (16#3E4E#, 16#0020#, 16#0002#),
         23160 => (16#3E4F#, 16#0020#, 16#0002#),
         23161 => (16#3E50#, 16#0020#, 16#0002#),
         23162 => (16#3E66#, 16#0020#, 16#0002#),
         23163 => (16#3E67#, 16#0020#, 16#0002#),
         23164 => (16#3E6D#, 16#0020#, 16#0002#),
         23165 => (16#3E68#, 16#0020#, 16#0002#),
         23166 => (16#3E69#, 16#0020#, 16#0002#),
         23167 => (16#3E6A#, 16#0020#, 16#0002#),
         23168 => (16#3E6B#, 16#0020#, 16#0002#),
         23169 => (16#3E6C#, 16#0020#, 16#0002#),
         23170 => (16#3E6E#, 16#0020#, 16#0002#),
         23171 => (16#3E74#, 16#0020#, 16#0002#),
         23172 => (16#3E72#, 16#0020#, 16#0002#),
         23173 => (16#3E80#, 16#0020#, 16#0002#),
         23174 => (16#3E75#, 16#0020#, 16#0002#),
         23175 => (16#3E73#, 16#0020#, 16#0002#),
         23176 => (16#3E81#, 16#0020#, 16#0002#),
         23177 => (16#3E7C#, 16#0020#, 16#0002#),
         23178 => (16#3E7A#, 16#0020#, 16#0002#),
         23179 => (16#3E7D#, 16#0020#, 16#0002#),
         23180 => (16#3E7B#, 16#0020#, 16#0002#),
         23181 => (16#3E6F#, 16#0020#, 16#0002#),
         23182 => (16#3E82#, 16#0020#, 16#0002#),
         23183 => (16#3E71#, 16#0020#, 16#0002#),
         23184 => (16#3E70#, 16#0020#, 16#0002#),
         23185 => (16#3E78#, 16#0020#, 16#0002#),
         23186 => (16#3E76#, 16#0020#, 16#0002#),
         23187 => (16#3E7E#, 16#0020#, 16#0002#),
         23188 => (16#3E79#, 16#0020#, 16#0002#),
         23189 => (16#3E77#, 16#0020#, 16#0002#),
         23190 => (16#3E7F#, 16#0020#, 16#0002#),
         23191 => (16#44CE#, 16#0020#, 16#0002#),
         23192 => (16#44CF#, 16#0020#, 16#0002#),
         23193 => (16#44D0#, 16#0020#, 16#0002#),
         23194 => (16#44D1#, 16#0020#, 16#0002#),
         23195 => (16#44D2#, 16#0020#, 16#0002#),
         23196 => (16#44D3#, 16#0020#, 16#0002#),
         23197 => (16#44D4#, 16#0020#, 16#0002#),
         23198 => (16#44D5#, 16#0020#, 16#0002#),
         23199 => (16#44D6#, 16#0020#, 16#0002#),
         23200 => (16#44D7#, 16#0020#, 16#0002#),
         23201 => (16#44D8#, 16#0020#, 16#0002#),
         23202 => (16#44D9#, 16#0020#, 16#0002#),
         23203 => (16#44DA#, 16#0020#, 16#0002#),
         23204 => (16#44DB#, 16#0020#, 16#0002#),
         23205 => (16#44DC#, 16#0020#, 16#0002#),
         23206 => (16#44DD#, 16#0020#, 16#0002#),
         23207 => (16#44DE#, 16#0020#, 16#0002#),
         23208 => (16#44DF#, 16#0020#, 16#0002#),
         23209 => (16#44E0#, 16#0020#, 16#0002#),
         23210 => (16#44E1#, 16#0020#, 16#0002#),
         23211 => (16#44E2#, 16#0020#, 16#0002#),
         23212 => (16#44E3#, 16#0020#, 16#0002#),
         23213 => (16#44E4#, 16#0020#, 16#0002#),
         23214 => (16#44E5#, 16#0020#, 16#0002#),
         23215 => (16#44E6#, 16#0020#, 16#0002#),
         23216 => (16#44E7#, 16#0020#, 16#0002#),
         23217 => (16#44E8#, 16#0020#, 16#0002#),
         23218 => (16#44E9#, 16#0020#, 16#0002#),
         23219 => (16#44EA#, 16#0020#, 16#0002#),
         23220 => (16#44EB#, 16#0020#, 16#0002#),
         23221 => (16#44EC#, 16#0020#, 16#0002#),
         23222 => (16#44ED#, 16#0020#, 16#0002#),
         23223 => (16#44EE#, 16#0020#, 16#0002#),
         23224 => (16#44EF#, 16#0020#, 16#0002#),
         23225 => (16#44F0#, 16#0020#, 16#0002#),
         23226 => (16#44F1#, 16#0020#, 16#0002#),
         23227 => (16#44F2#, 16#0020#, 16#0002#),
         23228 => (16#44F3#, 16#0020#, 16#0002#),
         23229 => (16#44F4#, 16#0020#, 16#0002#),
         23230 => (16#44F5#, 16#0020#, 16#0002#),
         23231 => (16#44F6#, 16#0020#, 16#0002#),
         23232 => (16#44F7#, 16#0020#, 16#0002#),
         23233 => (16#44F8#, 16#0020#, 16#0002#),
         23234 => (16#44F9#, 16#0020#, 16#0002#),
         23235 => (16#44FA#, 16#0020#, 16#0002#),
         23236 => (16#44FB#, 16#0020#, 16#0002#),
         23237 => (16#44FC#, 16#0020#, 16#0002#),
         23238 => (16#44FD#, 16#0020#, 16#0002#),
         23239 => (16#44FE#, 16#0020#, 16#0002#),
         23240 => (16#44FF#, 16#0020#, 16#0002#),
         23241 => (16#4500#, 16#0020#, 16#0002#),
         23242 => (16#4501#, 16#0020#, 16#0002#),
         23243 => (16#4502#, 16#0020#, 16#0002#),
         23244 => (16#4503#, 16#0020#, 16#0002#),
         23245 => (16#4504#, 16#0020#, 16#0002#),
         23246 => (16#4505#, 16#0020#, 16#0002#),
         23247 => (16#4506#, 16#0020#, 16#0002#),
         23248 => (16#4507#, 16#0020#, 16#0002#),
         23249 => (16#4508#, 16#0020#, 16#0002#),
         23250 => (16#4509#, 16#0020#, 16#0002#),
         23251 => (16#450A#, 16#0020#, 16#0002#),
         23252 => (16#450B#, 16#0020#, 16#0002#),
         23253 => (16#450C#, 16#0020#, 16#0002#),
         23254 => (16#450D#, 16#0020#, 16#0002#),
         23255 => (16#450E#, 16#0020#, 16#0002#),
         23256 => (16#450F#, 16#0020#, 16#0002#),
         23257 => (16#4510#, 16#0020#, 16#0002#),
         23258 => (16#4511#, 16#0020#, 16#0002#),
         23259 => (16#4512#, 16#0020#, 16#0002#),
         23260 => (16#4513#, 16#0020#, 16#0002#),
         23261 => (16#4514#, 16#0020#, 16#0002#),
         23262 => (16#4515#, 16#0020#, 16#0002#),
         23263 => (16#4516#, 16#0020#, 16#0002#),
         23264 => (16#4517#, 16#0020#, 16#0002#),
         23265 => (16#4518#, 16#0020#, 16#0002#),
         23266 => (16#4519#, 16#0020#, 16#0002#),
         23267 => (16#451A#, 16#0020#, 16#0002#),
         23268 => (16#451B#, 16#0020#, 16#0002#),
         23269 => (16#451C#, 16#0020#, 16#0002#),
         23270 => (16#451D#, 16#0020#, 16#0002#),
         23271 => (16#451E#, 16#0020#, 16#0002#),
         23272 => (16#451F#, 16#0020#, 16#0002#),
         23273 => (16#4520#, 16#0020#, 16#0002#),
         23274 => (16#4521#, 16#0020#, 16#0002#),
         23275 => (16#4522#, 16#0020#, 16#0002#),
         23276 => (16#4523#, 16#0020#, 16#0002#),
         23277 => (16#4524#, 16#0020#, 16#0002#),
         23278 => (16#4525#, 16#0020#, 16#0002#),
         23279 => (16#4526#, 16#0020#, 16#0002#),
         23280 => (16#4527#, 16#0020#, 16#0002#),
         23281 => (16#4528#, 16#0020#, 16#0002#),
         23282 => (16#4529#, 16#0020#, 16#0002#),
         23283 => (16#452A#, 16#0020#, 16#0002#),
         23284 => (16#452B#, 16#0020#, 16#0002#),
         23285 => (16#452C#, 16#0020#, 16#0002#),
         23286 => (16#452D#, 16#0020#, 16#0002#),
         23287 => (16#452E#, 16#0020#, 16#0002#),
         23288 => (16#452F#, 16#0020#, 16#0002#),
         23289 => (16#4530#, 16#0020#, 16#0002#),
         23290 => (16#4531#, 16#0020#, 16#0002#),
         23291 => (16#4532#, 16#0020#, 16#0002#),
         23292 => (16#4533#, 16#0020#, 16#0002#),
         23293 => (16#4534#, 16#0020#, 16#0002#),
         23294 => (16#4535#, 16#0020#, 16#0002#),
         23295 => (16#4536#, 16#0020#, 16#0002#),
         23296 => (16#4537#, 16#0020#, 16#0002#),
         23297 => (16#4538#, 16#0020#, 16#0002#),
         23298 => (16#4539#, 16#0020#, 16#0002#),
         23299 => (16#453A#, 16#0020#, 16#0002#),
         23300 => (16#453B#, 16#0020#, 16#0002#),
         23301 => (16#453C#, 16#0020#, 16#0002#),
         23302 => (16#453D#, 16#0020#, 16#0002#),
         23303 => (16#453E#, 16#0020#, 16#0002#),
         23304 => (16#453F#, 16#0020#, 16#0002#),
         23305 => (16#4540#, 16#0020#, 16#0002#),
         23306 => (16#4541#, 16#0020#, 16#0002#),
         23307 => (16#4542#, 16#0020#, 16#0002#),
         23308 => (16#4543#, 16#0020#, 16#0002#),
         23309 => (16#4544#, 16#0020#, 16#0002#),
         23310 => (16#4545#, 16#0020#, 16#0002#),
         23311 => (16#4546#, 16#0020#, 16#0002#),
         23312 => (16#4547#, 16#0020#, 16#0002#),
         23313 => (16#4548#, 16#0020#, 16#0002#),
         23314 => (16#4549#, 16#0020#, 16#0002#),
         23315 => (16#454A#, 16#0020#, 16#0002#),
         23316 => (16#454B#, 16#0020#, 16#0002#),
         23317 => (16#454C#, 16#0020#, 16#0002#),
         23318 => (16#454D#, 16#0020#, 16#0002#),
         23319 => (16#454E#, 16#0020#, 16#0002#),
         23320 => (16#454F#, 16#0020#, 16#0002#),
         23321 => (16#4550#, 16#0020#, 16#0002#),
         23322 => (16#4551#, 16#0020#, 16#0002#),
         23323 => (16#4552#, 16#0020#, 16#0002#),
         23324 => (16#4553#, 16#0020#, 16#0002#),
         23325 => (16#4554#, 16#0020#, 16#0002#),
         23326 => (16#4555#, 16#0020#, 16#0002#),
         23327 => (16#4556#, 16#0020#, 16#0002#),
         23328 => (16#4557#, 16#0020#, 16#0002#),
         23329 => (16#4558#, 16#0020#, 16#0002#),
         23330 => (16#4559#, 16#0020#, 16#0002#),
         23331 => (16#455A#, 16#0020#, 16#0002#),
         23332 => (16#455B#, 16#0020#, 16#0002#),
         23333 => (16#455C#, 16#0020#, 16#0002#),
         23334 => (16#455D#, 16#0020#, 16#0002#),
         23335 => (16#455E#, 16#0020#, 16#0002#),
         23336 => (16#455F#, 16#0020#, 16#0002#),
         23337 => (16#4560#, 16#0020#, 16#0002#),
         23338 => (16#4561#, 16#0020#, 16#0002#),
         23339 => (16#4562#, 16#0020#, 16#0002#),
         23340 => (16#4563#, 16#0020#, 16#0002#),
         23341 => (16#4564#, 16#0020#, 16#0002#),
         23342 => (16#4565#, 16#0020#, 16#0002#),
         23343 => (16#4566#, 16#0020#, 16#0002#),
         23344 => (16#4567#, 16#0020#, 16#0002#),
         23345 => (16#4568#, 16#0020#, 16#0002#),
         23346 => (16#4569#, 16#0020#, 16#0002#),
         23347 => (16#456A#, 16#0020#, 16#0002#),
         23348 => (16#456B#, 16#0020#, 16#0002#),
         23349 => (16#456C#, 16#0020#, 16#0002#),
         23350 => (16#456D#, 16#0020#, 16#0002#),
         23351 => (16#456E#, 16#0020#, 16#0002#),
         23352 => (16#456F#, 16#0020#, 16#0002#),
         23353 => (16#4570#, 16#0020#, 16#0002#),
         23354 => (16#4571#, 16#0020#, 16#0002#),
         23355 => (16#4572#, 16#0020#, 16#0002#),
         23356 => (16#4573#, 16#0020#, 16#0002#),
         23357 => (16#4574#, 16#0020#, 16#0002#),
         23358 => (16#4575#, 16#0020#, 16#0002#),
         23359 => (16#4576#, 16#0020#, 16#0002#),
         23360 => (16#4577#, 16#0020#, 16#0002#),
         23361 => (16#4578#, 16#0020#, 16#0002#),
         23362 => (16#4579#, 16#0020#, 16#0002#),
         23363 => (16#457A#, 16#0020#, 16#0002#),
         23364 => (16#457B#, 16#0020#, 16#0002#),
         23365 => (16#457C#, 16#0020#, 16#0002#),
         23366 => (16#457D#, 16#0020#, 16#0002#),
         23367 => (16#457E#, 16#0020#, 16#0002#),
         23368 => (16#457F#, 16#0020#, 16#0002#),
         23369 => (16#4580#, 16#0020#, 16#0002#),
         23370 => (16#4581#, 16#0020#, 16#0002#),
         23371 => (16#4582#, 16#0020#, 16#0002#),
         23372 => (16#4583#, 16#0020#, 16#0002#),
         23373 => (16#4584#, 16#0020#, 16#0002#),
         23374 => (16#4585#, 16#0020#, 16#0002#),
         23375 => (16#4586#, 16#0020#, 16#0002#),
         23376 => (16#4587#, 16#0020#, 16#0002#),
         23377 => (16#4588#, 16#0020#, 16#0002#),
         23378 => (16#4589#, 16#0020#, 16#0002#),
         23379 => (16#458A#, 16#0020#, 16#0002#),
         23380 => (16#458B#, 16#0020#, 16#0002#),
         23381 => (16#458C#, 16#0020#, 16#0002#),
         23382 => (16#458D#, 16#0020#, 16#0002#),
         23383 => (16#458E#, 16#0020#, 16#0002#),
         23384 => (16#458F#, 16#0020#, 16#0002#),
         23385 => (16#4590#, 16#0020#, 16#0002#),
         23386 => (16#4591#, 16#0020#, 16#0002#),
         23387 => (16#4592#, 16#0020#, 16#0002#),
         23388 => (16#4593#, 16#0020#, 16#0002#),
         23389 => (16#4594#, 16#0020#, 16#0002#),
         23390 => (16#4595#, 16#0020#, 16#0002#),
         23391 => (16#4596#, 16#0020#, 16#0002#),
         23392 => (16#4597#, 16#0020#, 16#0002#),
         23393 => (16#4598#, 16#0020#, 16#0002#),
         23394 => (16#4599#, 16#0020#, 16#0002#),
         23395 => (16#459A#, 16#0020#, 16#0002#),
         23396 => (16#459B#, 16#0020#, 16#0002#),
         23397 => (16#459C#, 16#0020#, 16#0002#),
         23398 => (16#459D#, 16#0020#, 16#0002#),
         23399 => (16#459E#, 16#0020#, 16#0002#),
         23400 => (16#459F#, 16#0020#, 16#0002#),
         23401 => (16#45A0#, 16#0020#, 16#0002#),
         23402 => (16#45A1#, 16#0020#, 16#0002#),
         23403 => (16#45A2#, 16#0020#, 16#0002#),
         23404 => (16#45A3#, 16#0020#, 16#0002#),
         23405 => (16#45A4#, 16#0020#, 16#0002#),
         23406 => (16#45A5#, 16#0020#, 16#0002#),
         23407 => (16#45A6#, 16#0020#, 16#0002#),
         23408 => (16#45A7#, 16#0020#, 16#0002#),
         23409 => (16#45A8#, 16#0020#, 16#0002#),
         23410 => (16#45A9#, 16#0020#, 16#0002#),
         23411 => (16#45AA#, 16#0020#, 16#0002#),
         23412 => (16#45AB#, 16#0020#, 16#0002#),
         23413 => (16#45AC#, 16#0020#, 16#0002#),
         23414 => (16#45AD#, 16#0020#, 16#0002#),
         23415 => (16#45AE#, 16#0020#, 16#0002#),
         23416 => (16#45AF#, 16#0020#, 16#0002#),
         23417 => (16#45B0#, 16#0020#, 16#0002#),
         23418 => (16#45B1#, 16#0020#, 16#0002#),
         23419 => (16#45B2#, 16#0020#, 16#0002#),
         23420 => (16#45B3#, 16#0020#, 16#0002#),
         23421 => (16#45B4#, 16#0020#, 16#0002#),
         23422 => (16#45B5#, 16#0020#, 16#0002#),
         23423 => (16#45B6#, 16#0020#, 16#0002#),
         23424 => (16#45B7#, 16#0020#, 16#0002#),
         23425 => (16#45B8#, 16#0020#, 16#0002#),
         23426 => (16#45B9#, 16#0020#, 16#0002#),
         23427 => (16#45BA#, 16#0020#, 16#0002#),
         23428 => (16#45BB#, 16#0020#, 16#0002#),
         23429 => (16#45BC#, 16#0020#, 16#0002#),
         23430 => (16#45BD#, 16#0020#, 16#0002#),
         23431 => (16#45BE#, 16#0020#, 16#0002#),
         23432 => (16#45BF#, 16#0020#, 16#0002#),
         23433 => (16#45C0#, 16#0020#, 16#0002#),
         23434 => (16#45C1#, 16#0020#, 16#0002#),
         23435 => (16#45C2#, 16#0020#, 16#0002#),
         23436 => (16#45C3#, 16#0020#, 16#0002#),
         23437 => (16#45C4#, 16#0020#, 16#0002#),
         23438 => (16#45C5#, 16#0020#, 16#0002#),
         23439 => (16#45C6#, 16#0020#, 16#0002#),
         23440 => (16#45C7#, 16#0020#, 16#0002#),
         23441 => (16#45C8#, 16#0020#, 16#0002#),
         23442 => (16#45C9#, 16#0020#, 16#0002#),
         23443 => (16#45CA#, 16#0020#, 16#0002#),
         23444 => (16#45CB#, 16#0020#, 16#0002#),
         23445 => (16#45CC#, 16#0020#, 16#0002#),
         23446 => (16#45CD#, 16#0020#, 16#0002#),
         23447 => (16#45CE#, 16#0020#, 16#0002#),
         23448 => (16#45CF#, 16#0020#, 16#0002#),
         23449 => (16#45D0#, 16#0020#, 16#0002#),
         23450 => (16#45D1#, 16#0020#, 16#0002#),
         23451 => (16#45D2#, 16#0020#, 16#0002#),
         23452 => (16#45D3#, 16#0020#, 16#0002#),
         23453 => (16#45D4#, 16#0020#, 16#0002#),
         23454 => (16#45D5#, 16#0020#, 16#0002#),
         23455 => (16#45D6#, 16#0020#, 16#0002#),
         23456 => (16#45D7#, 16#0020#, 16#0002#),
         23457 => (16#45D8#, 16#0020#, 16#0002#),
         23458 => (16#45D9#, 16#0020#, 16#0002#),
         23459 => (16#45DA#, 16#0020#, 16#0002#),
         23460 => (16#45DB#, 16#0020#, 16#0002#),
         23461 => (16#45DC#, 16#0020#, 16#0002#),
         23462 => (16#45DD#, 16#0020#, 16#0002#),
         23463 => (16#45DE#, 16#0020#, 16#0002#),
         23464 => (16#45DF#, 16#0020#, 16#0002#),
         23465 => (16#45E0#, 16#0020#, 16#0002#),
         23466 => (16#45E1#, 16#0020#, 16#0002#),
         23467 => (16#45E2#, 16#0020#, 16#0002#),
         23468 => (16#45E3#, 16#0020#, 16#0002#),
         23469 => (16#45E4#, 16#0020#, 16#0002#),
         23470 => (16#45E5#, 16#0020#, 16#0002#),
         23471 => (16#45E6#, 16#0020#, 16#0002#),
         23472 => (16#45E7#, 16#0020#, 16#0002#),
         23473 => (16#45E8#, 16#0020#, 16#0002#),
         23474 => (16#45E9#, 16#0020#, 16#0002#),
         23475 => (16#45EA#, 16#0020#, 16#0002#),
         23476 => (16#45EB#, 16#0020#, 16#0002#),
         23477 => (16#45EC#, 16#0020#, 16#0002#),
         23478 => (16#45ED#, 16#0020#, 16#0002#),
         23479 => (16#45EE#, 16#0020#, 16#0002#),
         23480 => (16#45EF#, 16#0020#, 16#0002#),
         23481 => (16#45F0#, 16#0020#, 16#0002#),
         23482 => (16#45F1#, 16#0020#, 16#0002#),
         23483 => (16#45F2#, 16#0020#, 16#0002#),
         23484 => (16#45F3#, 16#0020#, 16#0002#),
         23485 => (16#45F4#, 16#0020#, 16#0002#),
         23486 => (16#45F5#, 16#0020#, 16#0002#),
         23487 => (16#45F6#, 16#0020#, 16#0002#),
         23488 => (16#45F7#, 16#0020#, 16#0002#),
         23489 => (16#45F8#, 16#0020#, 16#0002#),
         23490 => (16#45F9#, 16#0020#, 16#0002#),
         23491 => (16#45FA#, 16#0020#, 16#0002#),
         23492 => (16#45FB#, 16#0020#, 16#0002#),
         23493 => (16#45FC#, 16#0020#, 16#0002#),
         23494 => (16#45FD#, 16#0020#, 16#0002#),
         23495 => (16#45FE#, 16#0020#, 16#0002#),
         23496 => (16#45FF#, 16#0020#, 16#0002#),
         23497 => (16#4600#, 16#0020#, 16#0002#),
         23498 => (16#4601#, 16#0020#, 16#0002#),
         23499 => (16#4602#, 16#0020#, 16#0002#),
         23500 => (16#4603#, 16#0020#, 16#0002#),
         23501 => (16#4604#, 16#0020#, 16#0002#),
         23502 => (16#4605#, 16#0020#, 16#0002#),
         23503 => (16#4606#, 16#0020#, 16#0002#),
         23504 => (16#4607#, 16#0020#, 16#0002#),
         23505 => (16#4608#, 16#0020#, 16#0002#),
         23506 => (16#4609#, 16#0020#, 16#0002#),
         23507 => (16#460A#, 16#0020#, 16#0002#),
         23508 => (16#460B#, 16#0020#, 16#0002#),
         23509 => (16#460C#, 16#0020#, 16#0002#),
         23510 => (16#460D#, 16#0020#, 16#0002#),
         23511 => (16#460E#, 16#0020#, 16#0002#),
         23512 => (16#460F#, 16#0020#, 16#0002#),
         23513 => (16#4610#, 16#0020#, 16#0002#),
         23514 => (16#4611#, 16#0020#, 16#0002#),
         23515 => (16#4612#, 16#0020#, 16#0002#),
         23516 => (16#4613#, 16#0020#, 16#0002#),
         23517 => (16#4614#, 16#0020#, 16#0002#),
         23518 => (16#4615#, 16#0020#, 16#0002#),
         23519 => (16#4616#, 16#0020#, 16#0002#),
         23520 => (16#4617#, 16#0020#, 16#0002#),
         23521 => (16#4618#, 16#0020#, 16#0002#),
         23522 => (16#4619#, 16#0020#, 16#0002#),
         23523 => (16#461A#, 16#0020#, 16#0002#),
         23524 => (16#461B#, 16#0020#, 16#0002#),
         23525 => (16#461C#, 16#0020#, 16#0002#),
         23526 => (16#461D#, 16#0020#, 16#0002#),
         23527 => (16#461E#, 16#0020#, 16#0002#),
         23528 => (16#461F#, 16#0020#, 16#0002#),
         23529 => (16#4620#, 16#0020#, 16#0002#),
         23530 => (16#4621#, 16#0020#, 16#0002#),
         23531 => (16#4622#, 16#0020#, 16#0002#),
         23532 => (16#4623#, 16#0020#, 16#0002#),
         23533 => (16#4624#, 16#0020#, 16#0002#),
         23534 => (16#4625#, 16#0020#, 16#0002#),
         23535 => (16#4626#, 16#0020#, 16#0002#),
         23536 => (16#4627#, 16#0020#, 16#0002#),
         23537 => (16#4628#, 16#0020#, 16#0002#),
         23538 => (16#4629#, 16#0020#, 16#0002#),
         23539 => (16#462A#, 16#0020#, 16#0002#),
         23540 => (16#462B#, 16#0020#, 16#0002#),
         23541 => (16#462C#, 16#0020#, 16#0002#),
         23542 => (16#462D#, 16#0020#, 16#0002#),
         23543 => (16#462E#, 16#0020#, 16#0002#),
         23544 => (16#462F#, 16#0020#, 16#0002#),
         23545 => (16#4630#, 16#0020#, 16#0002#),
         23546 => (16#4631#, 16#0020#, 16#0002#),
         23547 => (16#4632#, 16#0020#, 16#0002#),
         23548 => (16#4633#, 16#0020#, 16#0002#),
         23549 => (16#4634#, 16#0020#, 16#0002#),
         23550 => (16#4635#, 16#0020#, 16#0002#),
         23551 => (16#4636#, 16#0020#, 16#0002#),
         23552 => (16#4637#, 16#0020#, 16#0002#),
         23553 => (16#4638#, 16#0020#, 16#0002#),
         23554 => (16#4639#, 16#0020#, 16#0002#),
         23555 => (16#463A#, 16#0020#, 16#0002#),
         23556 => (16#463B#, 16#0020#, 16#0002#),
         23557 => (16#463C#, 16#0020#, 16#0002#),
         23558 => (16#463D#, 16#0020#, 16#0002#),
         23559 => (16#463E#, 16#0020#, 16#0002#),
         23560 => (16#463F#, 16#0020#, 16#0002#),
         23561 => (16#4640#, 16#0020#, 16#0002#),
         23562 => (16#4641#, 16#0020#, 16#0002#),
         23563 => (16#4642#, 16#0020#, 16#0002#),
         23564 => (16#4643#, 16#0020#, 16#0002#),
         23565 => (16#4644#, 16#0020#, 16#0002#),
         23566 => (16#4645#, 16#0020#, 16#0002#),
         23567 => (16#4646#, 16#0020#, 16#0002#),
         23568 => (16#4647#, 16#0020#, 16#0002#),
         23569 => (16#4648#, 16#0020#, 16#0002#),
         23570 => (16#4649#, 16#0020#, 16#0002#),
         23571 => (16#464A#, 16#0020#, 16#0002#),
         23572 => (16#464B#, 16#0020#, 16#0002#),
         23573 => (16#464C#, 16#0020#, 16#0002#),
         23574 => (16#464D#, 16#0020#, 16#0002#),
         23575 => (16#464E#, 16#0020#, 16#0002#),
         23576 => (16#464F#, 16#0020#, 16#0002#),
         23577 => (16#4650#, 16#0020#, 16#0002#),
         23578 => (16#4651#, 16#0020#, 16#0002#),
         23579 => (16#4652#, 16#0020#, 16#0002#),
         23580 => (16#4653#, 16#0020#, 16#0002#),
         23581 => (16#4654#, 16#0020#, 16#0002#),
         23582 => (16#4655#, 16#0020#, 16#0002#),
         23583 => (16#4656#, 16#0020#, 16#0002#),
         23584 => (16#4657#, 16#0020#, 16#0002#),
         23585 => (16#4658#, 16#0020#, 16#0002#),
         23586 => (16#4659#, 16#0020#, 16#0002#),
         23587 => (16#465A#, 16#0020#, 16#0002#),
         23588 => (16#465B#, 16#0020#, 16#0002#),
         23589 => (16#465C#, 16#0020#, 16#0002#),
         23590 => (16#465D#, 16#0020#, 16#0002#),
         23591 => (16#465E#, 16#0020#, 16#0002#),
         23592 => (16#465F#, 16#0020#, 16#0002#),
         23593 => (16#4660#, 16#0020#, 16#0002#),
         23594 => (16#4661#, 16#0020#, 16#0002#),
         23595 => (16#4662#, 16#0020#, 16#0002#),
         23596 => (16#4663#, 16#0020#, 16#0002#),
         23597 => (16#4664#, 16#0020#, 16#0002#),
         23598 => (16#4665#, 16#0020#, 16#0002#),
         23599 => (16#4666#, 16#0020#, 16#0002#),
         23600 => (16#4667#, 16#0020#, 16#0002#),
         23601 => (16#4668#, 16#0020#, 16#0002#),
         23602 => (16#4669#, 16#0020#, 16#0002#),
         23603 => (16#466A#, 16#0020#, 16#0002#),
         23604 => (16#466B#, 16#0020#, 16#0002#),
         23605 => (16#466C#, 16#0020#, 16#0002#),
         23606 => (16#466D#, 16#0020#, 16#0002#),
         23607 => (16#466E#, 16#0020#, 16#0002#),
         23608 => (16#466F#, 16#0020#, 16#0002#),
         23609 => (16#4670#, 16#0020#, 16#0002#),
         23610 => (16#4671#, 16#0020#, 16#0002#),
         23611 => (16#4672#, 16#0020#, 16#0002#),
         23612 => (16#4673#, 16#0020#, 16#0002#),
         23613 => (16#4674#, 16#0020#, 16#0002#),
         23614 => (16#4675#, 16#0020#, 16#0002#),
         23615 => (16#4676#, 16#0020#, 16#0002#),
         23616 => (16#4677#, 16#0020#, 16#0002#),
         23617 => (16#4678#, 16#0020#, 16#0002#),
         23618 => (16#4679#, 16#0020#, 16#0002#),
         23619 => (16#467A#, 16#0020#, 16#0002#),
         23620 => (16#467B#, 16#0020#, 16#0002#),
         23621 => (16#467C#, 16#0020#, 16#0002#),
         23622 => (16#467D#, 16#0020#, 16#0002#),
         23623 => (16#467E#, 16#0020#, 16#0002#),
         23624 => (16#467F#, 16#0020#, 16#0002#),
         23625 => (16#4680#, 16#0020#, 16#0002#),
         23626 => (16#4681#, 16#0020#, 16#0002#),
         23627 => (16#4682#, 16#0020#, 16#0002#),
         23628 => (16#4683#, 16#0020#, 16#0002#),
         23629 => (16#4684#, 16#0020#, 16#0002#),
         23630 => (16#4685#, 16#0020#, 16#0002#),
         23631 => (16#4686#, 16#0020#, 16#0002#),
         23632 => (16#4687#, 16#0020#, 16#0002#),
         23633 => (16#4688#, 16#0020#, 16#0002#),
         23634 => (16#4689#, 16#0020#, 16#0002#),
         23635 => (16#468A#, 16#0020#, 16#0002#),
         23636 => (16#468B#, 16#0020#, 16#0002#),
         23637 => (16#468C#, 16#0020#, 16#0002#),
         23638 => (16#468D#, 16#0020#, 16#0002#),
         23639 => (16#468E#, 16#0020#, 16#0002#),
         23640 => (16#468F#, 16#0020#, 16#0002#),
         23641 => (16#4690#, 16#0020#, 16#0002#),
         23642 => (16#4691#, 16#0020#, 16#0002#),
         23643 => (16#4692#, 16#0020#, 16#0002#),
         23644 => (16#4693#, 16#0020#, 16#0002#),
         23645 => (16#4694#, 16#0020#, 16#0002#),
         23646 => (16#4695#, 16#0020#, 16#0002#),
         23647 => (16#4696#, 16#0020#, 16#0002#),
         23648 => (16#4697#, 16#0020#, 16#0002#),
         23649 => (16#4698#, 16#0020#, 16#0002#),
         23650 => (16#4699#, 16#0020#, 16#0002#),
         23651 => (16#469A#, 16#0020#, 16#0002#),
         23652 => (16#469B#, 16#0020#, 16#0002#),
         23653 => (16#469C#, 16#0020#, 16#0002#),
         23654 => (16#469D#, 16#0020#, 16#0002#),
         23655 => (16#469E#, 16#0020#, 16#0002#),
         23656 => (16#469F#, 16#0020#, 16#0002#),
         23657 => (16#46A0#, 16#0020#, 16#0002#),
         23658 => (16#46A1#, 16#0020#, 16#0002#),
         23659 => (16#46A2#, 16#0020#, 16#0002#),
         23660 => (16#46A3#, 16#0020#, 16#0002#),
         23661 => (16#46A4#, 16#0020#, 16#0002#),
         23662 => (16#46A5#, 16#0020#, 16#0002#),
         23663 => (16#46A6#, 16#0020#, 16#0002#),
         23664 => (16#46A7#, 16#0020#, 16#0002#),
         23665 => (16#46A8#, 16#0020#, 16#0002#),
         23666 => (16#46A9#, 16#0020#, 16#0002#),
         23667 => (16#46AA#, 16#0020#, 16#0002#),
         23668 => (16#46AB#, 16#0020#, 16#0002#),
         23669 => (16#46AC#, 16#0020#, 16#0002#),
         23670 => (16#46AD#, 16#0020#, 16#0002#),
         23671 => (16#46AE#, 16#0020#, 16#0002#),
         23672 => (16#46AF#, 16#0020#, 16#0002#),
         23673 => (16#46B0#, 16#0020#, 16#0002#),
         23674 => (16#46B1#, 16#0020#, 16#0002#),
         23675 => (16#46B2#, 16#0020#, 16#0002#),
         23676 => (16#46B3#, 16#0020#, 16#0002#),
         23677 => (16#46B4#, 16#0020#, 16#0002#),
         23678 => (16#46B5#, 16#0020#, 16#0002#),
         23679 => (16#46B6#, 16#0020#, 16#0002#),
         23680 => (16#46B7#, 16#0020#, 16#0002#),
         23681 => (16#46B8#, 16#0020#, 16#0002#),
         23682 => (16#46B9#, 16#0020#, 16#0002#),
         23683 => (16#46BA#, 16#0020#, 16#0002#),
         23684 => (16#46BB#, 16#0020#, 16#0002#),
         23685 => (16#46BC#, 16#0020#, 16#0002#),
         23686 => (16#46BD#, 16#0020#, 16#0002#),
         23687 => (16#46BE#, 16#0020#, 16#0002#),
         23688 => (16#46BF#, 16#0020#, 16#0002#),
         23689 => (16#46C0#, 16#0020#, 16#0002#),
         23690 => (16#46C1#, 16#0020#, 16#0002#),
         23691 => (16#46C2#, 16#0020#, 16#0002#),
         23692 => (16#46C3#, 16#0020#, 16#0002#),
         23693 => (16#46C4#, 16#0020#, 16#0002#),
         23694 => (16#46C5#, 16#0020#, 16#0002#),
         23695 => (16#46C6#, 16#0020#, 16#0002#),
         23696 => (16#46C7#, 16#0020#, 16#0002#),
         23697 => (16#46C8#, 16#0020#, 16#0002#),
         23698 => (16#46C9#, 16#0020#, 16#0002#),
         23699 => (16#46CA#, 16#0020#, 16#0002#),
         23700 => (16#46CB#, 16#0020#, 16#0002#),
         23701 => (16#46CC#, 16#0020#, 16#0002#),
         23702 => (16#46CD#, 16#0020#, 16#0002#),
         23703 => (16#46CE#, 16#0020#, 16#0002#),
         23704 => (16#46CF#, 16#0020#, 16#0002#),
         23705 => (16#46D0#, 16#0020#, 16#0002#),
         23706 => (16#46D1#, 16#0020#, 16#0002#),
         23707 => (16#46D2#, 16#0020#, 16#0002#),
         23708 => (16#46D3#, 16#0020#, 16#0002#),
         23709 => (16#46D4#, 16#0020#, 16#0002#),
         23710 => (16#46D5#, 16#0020#, 16#0002#),
         23711 => (16#46D6#, 16#0020#, 16#0002#),
         23712 => (16#46D7#, 16#0020#, 16#0002#),
         23713 => (16#46D8#, 16#0020#, 16#0002#),
         23714 => (16#46D9#, 16#0020#, 16#0002#),
         23715 => (16#46DA#, 16#0020#, 16#0002#),
         23716 => (16#46DB#, 16#0020#, 16#0002#),
         23717 => (16#46DC#, 16#0020#, 16#0002#),
         23718 => (16#46DD#, 16#0020#, 16#0002#),
         23719 => (16#46DE#, 16#0020#, 16#0002#),
         23720 => (16#46DF#, 16#0020#, 16#0002#),
         23721 => (16#46E0#, 16#0020#, 16#0002#),
         23722 => (16#46E1#, 16#0020#, 16#0002#),
         23723 => (16#46E2#, 16#0020#, 16#0002#),
         23724 => (16#46E3#, 16#0020#, 16#0002#),
         23725 => (16#46E4#, 16#0020#, 16#0002#),
         23726 => (16#46E5#, 16#0020#, 16#0002#),
         23727 => (16#46E6#, 16#0020#, 16#0002#),
         23728 => (16#46E7#, 16#0020#, 16#0002#),
         23729 => (16#46E8#, 16#0020#, 16#0002#),
         23730 => (16#46E9#, 16#0020#, 16#0002#),
         23731 => (16#46EA#, 16#0020#, 16#0002#),
         23732 => (16#46EB#, 16#0020#, 16#0002#),
         23733 => (16#46EC#, 16#0020#, 16#0002#),
         23734 => (16#46ED#, 16#0020#, 16#0002#),
         23735 => (16#46EE#, 16#0020#, 16#0002#),
         23736 => (16#46EF#, 16#0020#, 16#0002#),
         23737 => (16#46F0#, 16#0020#, 16#0002#),
         23738 => (16#46F1#, 16#0020#, 16#0002#),
         23739 => (16#46F2#, 16#0020#, 16#0002#),
         23740 => (16#46F3#, 16#0020#, 16#0002#),
         23741 => (16#46F4#, 16#0020#, 16#0002#),
         23742 => (16#46F5#, 16#0020#, 16#0002#),
         23743 => (16#46F6#, 16#0020#, 16#0002#),
         23744 => (16#46F7#, 16#0020#, 16#0002#),
         23745 => (16#46F8#, 16#0020#, 16#0002#),
         23746 => (16#46F9#, 16#0020#, 16#0002#),
         23747 => (16#46FA#, 16#0020#, 16#0002#),
         23748 => (16#46FB#, 16#0020#, 16#0002#),
         23749 => (16#46FC#, 16#0020#, 16#0002#),
         23750 => (16#46FD#, 16#0020#, 16#0002#),
         23751 => (16#46FE#, 16#0020#, 16#0002#),
         23752 => (16#46FF#, 16#0020#, 16#0002#),
         23753 => (16#4700#, 16#0020#, 16#0002#),
         23754 => (16#4701#, 16#0020#, 16#0002#),
         23755 => (16#4702#, 16#0020#, 16#0002#),
         23756 => (16#4703#, 16#0020#, 16#0002#),
         23757 => (16#4704#, 16#0020#, 16#0002#),
         23758 => (16#4705#, 16#0020#, 16#0002#),
         23759 => (16#4706#, 16#0020#, 16#0002#),
         23760 => (16#4707#, 16#0020#, 16#0002#),
         23761 => (16#4708#, 16#0020#, 16#0002#),
         23762 => (16#4709#, 16#0020#, 16#0002#),
         23763 => (16#470A#, 16#0020#, 16#0002#),
         23764 => (16#470B#, 16#0020#, 16#0002#),
         23765 => (16#470C#, 16#0020#, 16#0002#),
         23766 => (16#470D#, 16#0020#, 16#0002#),
         23767 => (16#470E#, 16#0020#, 16#0002#),
         23768 => (16#470F#, 16#0020#, 16#0002#),
         23769 => (16#4710#, 16#0020#, 16#0002#),
         23770 => (16#4711#, 16#0020#, 16#0002#),
         23771 => (16#4712#, 16#0020#, 16#0002#),
         23772 => (16#4713#, 16#0020#, 16#0002#),
         23773 => (16#4714#, 16#0020#, 16#0002#),
         23774 => (16#4715#, 16#0020#, 16#0002#),
         23775 => (16#4716#, 16#0020#, 16#0002#),
         23776 => (16#4717#, 16#0020#, 16#0002#),
         23777 => (16#4718#, 16#0020#, 16#0002#),
         23778 => (16#4719#, 16#0020#, 16#0002#),
         23779 => (16#471A#, 16#0020#, 16#0002#),
         23780 => (16#471B#, 16#0020#, 16#0002#),
         23781 => (16#471C#, 16#0020#, 16#0002#),
         23782 => (16#471D#, 16#0020#, 16#0002#),
         23783 => (16#471E#, 16#0020#, 16#0002#),
         23784 => (16#471F#, 16#0020#, 16#0002#),
         23785 => (16#4720#, 16#0020#, 16#0002#),
         23786 => (16#4721#, 16#0020#, 16#0002#),
         23787 => (16#4722#, 16#0020#, 16#0002#),
         23788 => (16#4723#, 16#0020#, 16#0002#),
         23789 => (16#4724#, 16#0020#, 16#0002#),
         23790 => (16#4725#, 16#0020#, 16#0002#),
         23791 => (16#4726#, 16#0020#, 16#0002#),
         23792 => (16#4727#, 16#0020#, 16#0002#),
         23793 => (16#4728#, 16#0020#, 16#0002#),
         23794 => (16#4729#, 16#0020#, 16#0002#),
         23795 => (16#472A#, 16#0020#, 16#0002#),
         23796 => (16#472B#, 16#0020#, 16#0002#),
         23797 => (16#472C#, 16#0020#, 16#0002#),
         23798 => (16#472D#, 16#0020#, 16#0002#),
         23799 => (16#472E#, 16#0020#, 16#0002#),
         23800 => (16#472F#, 16#0020#, 16#0002#),
         23801 => (16#4730#, 16#0020#, 16#0002#),
         23802 => (16#4733#, 16#0020#, 16#0002#),
         23803 => (16#4734#, 16#0020#, 16#0002#),
         23804 => (16#4735#, 16#0020#, 16#0002#),
         23805 => (16#4736#, 16#0020#, 16#0002#),
         23806 => (16#4737#, 16#0020#, 16#0002#),
         23807 => (16#4738#, 16#0020#, 16#0002#),
         23808 => (16#4739#, 16#0020#, 16#0002#),
         23809 => (16#473A#, 16#0020#, 16#0002#),
         23810 => (16#473B#, 16#0020#, 16#0002#),
         23811 => (16#473C#, 16#0020#, 16#0002#),
         23812 => (16#473D#, 16#0020#, 16#0002#),
         23813 => (16#473E#, 16#0020#, 16#0002#),
         23814 => (16#473F#, 16#0020#, 16#0002#),
         23815 => (16#4740#, 16#0020#, 16#0002#),
         23816 => (16#4741#, 16#0020#, 16#0002#),
         23817 => (16#4742#, 16#0020#, 16#0002#),
         23818 => (16#4743#, 16#0020#, 16#0002#),
         23819 => (16#4744#, 16#0020#, 16#0002#),
         23820 => (16#4745#, 16#0020#, 16#0002#),
         23821 => (16#4746#, 16#0020#, 16#0002#),
         23822 => (16#4747#, 16#0020#, 16#0002#),
         23823 => (16#4748#, 16#0020#, 16#0002#),
         23824 => (16#4749#, 16#0020#, 16#0002#),
         23825 => (16#474A#, 16#0020#, 16#0002#),
         23826 => (16#474B#, 16#0020#, 16#0002#),
         23827 => (16#474C#, 16#0020#, 16#0002#),
         23828 => (16#474D#, 16#0020#, 16#0002#),
         23829 => (16#474E#, 16#0020#, 16#0002#),
         23830 => (16#474F#, 16#0020#, 16#0002#),
         23831 => (16#4750#, 16#0020#, 16#0002#),
         23832 => (16#4751#, 16#0020#, 16#0002#),
         23833 => (16#4752#, 16#0020#, 16#0002#),
         23834 => (16#4753#, 16#0020#, 16#0002#),
         23835 => (16#4754#, 16#0020#, 16#0002#),
         23836 => (16#4755#, 16#0020#, 16#0002#),
         23837 => (16#4756#, 16#0020#, 16#0002#),
         23838 => (16#4757#, 16#0020#, 16#0002#),
         23839 => (16#4758#, 16#0020#, 16#0002#),
         23840 => (16#4759#, 16#0020#, 16#0002#),
         23841 => (16#475A#, 16#0020#, 16#0002#),
         23842 => (16#475B#, 16#0020#, 16#0002#),
         23843 => (16#475C#, 16#0020#, 16#0002#),
         23844 => (16#475D#, 16#0020#, 16#0002#),
         23845 => (16#475E#, 16#0020#, 16#0002#),
         23846 => (16#475F#, 16#0020#, 16#0002#),
         23847 => (16#4760#, 16#0020#, 16#0002#),
         23848 => (16#4761#, 16#0020#, 16#0002#),
         23849 => (16#4762#, 16#0020#, 16#0002#),
         23850 => (16#4763#, 16#0020#, 16#0002#),
         23851 => (16#4764#, 16#0020#, 16#0002#),
         23852 => (16#4765#, 16#0020#, 16#0002#),
         23853 => (16#4766#, 16#0020#, 16#0002#),
         23854 => (16#4767#, 16#0020#, 16#0002#),
         23855 => (16#4768#, 16#0020#, 16#0002#),
         23856 => (16#4769#, 16#0020#, 16#0002#),
         23857 => (16#476A#, 16#0020#, 16#0002#),
         23858 => (16#476B#, 16#0020#, 16#0002#),
         23859 => (16#476C#, 16#0020#, 16#0002#),
         23860 => (16#476D#, 16#0020#, 16#0002#),
         23861 => (16#476E#, 16#0020#, 16#0002#),
         23862 => (16#476F#, 16#0020#, 16#0002#),
         23863 => (16#4770#, 16#0020#, 16#0002#),
         23864 => (16#4771#, 16#0020#, 16#0002#),
         23865 => (16#4772#, 16#0020#, 16#0002#),
         23866 => (16#4773#, 16#0020#, 16#0002#),
         23867 => (16#4774#, 16#0020#, 16#0002#),
         23868 => (16#4775#, 16#0020#, 16#0002#),
         23869 => (16#4776#, 16#0020#, 16#0002#),
         23870 => (16#4777#, 16#0020#, 16#0002#),
         23871 => (16#4778#, 16#0020#, 16#0002#),
         23872 => (16#4779#, 16#0020#, 16#0002#),
         23873 => (16#477A#, 16#0020#, 16#0002#),
         23874 => (16#477B#, 16#0020#, 16#0002#),
         23875 => (16#477C#, 16#0020#, 16#0002#),
         23876 => (16#477D#, 16#0020#, 16#0002#),
         23877 => (16#477E#, 16#0020#, 16#0002#),
         23878 => (16#477F#, 16#0020#, 16#0002#),
         23879 => (16#4780#, 16#0020#, 16#0002#),
         23880 => (16#4781#, 16#0020#, 16#0002#),
         23881 => (16#4782#, 16#0020#, 16#0002#),
         23882 => (16#4783#, 16#0020#, 16#0002#),
         23883 => (16#4784#, 16#0020#, 16#0002#),
         23884 => (16#4785#, 16#0020#, 16#0002#),
         23885 => (16#4786#, 16#0020#, 16#0002#),
         23886 => (16#4787#, 16#0020#, 16#0002#),
         23887 => (16#4788#, 16#0020#, 16#0002#),
         23888 => (16#4789#, 16#0020#, 16#0002#),
         23889 => (16#478A#, 16#0020#, 16#0002#),
         23890 => (16#478B#, 16#0020#, 16#0002#),
         23891 => (16#478C#, 16#0020#, 16#0002#),
         23892 => (16#478D#, 16#0020#, 16#0002#),
         23893 => (16#478E#, 16#0020#, 16#0002#),
         23894 => (16#478F#, 16#0020#, 16#0002#),
         23895 => (16#4790#, 16#0020#, 16#0002#),
         23896 => (16#4791#, 16#0020#, 16#0002#),
         23897 => (16#4792#, 16#0020#, 16#0002#),
         23898 => (16#4793#, 16#0020#, 16#0002#),
         23899 => (16#4794#, 16#0020#, 16#0002#),
         23900 => (16#4795#, 16#0020#, 16#0002#),
         23901 => (16#4796#, 16#0020#, 16#0002#),
         23902 => (16#4797#, 16#0020#, 16#0002#),
         23903 => (16#4798#, 16#0020#, 16#0002#),
         23904 => (16#4799#, 16#0020#, 16#0002#),
         23905 => (16#479A#, 16#0020#, 16#0002#),
         23906 => (16#479B#, 16#0020#, 16#0002#),
         23907 => (16#479C#, 16#0020#, 16#0002#),
         23908 => (16#479D#, 16#0020#, 16#0002#),
         23909 => (16#479E#, 16#0020#, 16#0002#),
         23910 => (16#479F#, 16#0020#, 16#0002#),
         23911 => (16#47A0#, 16#0020#, 16#0002#),
         23912 => (16#47A1#, 16#0020#, 16#0002#),
         23913 => (16#47A2#, 16#0020#, 16#0002#),
         23914 => (16#47A3#, 16#0020#, 16#0002#),
         23915 => (16#4731#, 16#0020#, 16#0002#),
         23916 => (16#4732#, 16#0020#, 16#0002#),
         23917 => (16#47A4#, 16#0020#, 16#0002#),
         23918 => (16#47A5#, 16#0020#, 16#0002#),
         23919 => (16#47A6#, 16#0020#, 16#0002#),
         23920 => (16#47A7#, 16#0020#, 16#0002#),
         23921 => (16#47A8#, 16#0020#, 16#0002#),
         23922 => (16#47A9#, 16#0020#, 16#0002#),
         23923 => (16#47AA#, 16#0020#, 16#0002#),
         23924 => (16#47AB#, 16#0020#, 16#0002#),
         23925 => (16#47AC#, 16#0020#, 16#0002#),
         23926 => (16#47AD#, 16#0020#, 16#0002#),
         23927 => (16#47AE#, 16#0020#, 16#0002#),
         23928 => (16#47AF#, 16#0020#, 16#0002#),
         23929 => (16#47B0#, 16#0020#, 16#0002#),
         23930 => (16#47B1#, 16#0020#, 16#0002#),
         23931 => (16#47B2#, 16#0020#, 16#0002#),
         23932 => (16#47B3#, 16#0020#, 16#0002#),
         23933 => (16#47B4#, 16#0020#, 16#0002#),
         23934 => (16#47B5#, 16#0020#, 16#0002#),
         23935 => (16#47B6#, 16#0020#, 16#0002#),
         23936 => (16#47B7#, 16#0020#, 16#0002#),
         23937 => (16#47B8#, 16#0020#, 16#0002#),
         23938 => (16#47B9#, 16#0020#, 16#0002#),
         23939 => (16#47BA#, 16#0020#, 16#0002#),
         23940 => (16#47BB#, 16#0020#, 16#0002#),
         23941 => (16#47BC#, 16#0020#, 16#0002#),
         23942 => (16#47BD#, 16#0020#, 16#0002#),
         23943 => (16#47BE#, 16#0020#, 16#0002#),
         23944 => (16#47BF#, 16#0020#, 16#0002#),
         23945 => (16#47C0#, 16#0020#, 16#0002#),
         23946 => (16#47C1#, 16#0020#, 16#0002#),
         23947 => (16#47C2#, 16#0020#, 16#0002#),
         23948 => (16#47C3#, 16#0020#, 16#0002#),
         23949 => (16#47C4#, 16#0020#, 16#0002#),
         23950 => (16#47C5#, 16#0020#, 16#0002#),
         23951 => (16#47C6#, 16#0020#, 16#0002#),
         23952 => (16#47C7#, 16#0020#, 16#0002#),
         23953 => (16#47C8#, 16#0020#, 16#0002#),
         23954 => (16#47C9#, 16#0020#, 16#0002#),
         23955 => (16#47CA#, 16#0020#, 16#0002#),
         23956 => (16#47CB#, 16#0020#, 16#0002#),
         23957 => (16#47CC#, 16#0020#, 16#0002#),
         23958 => (16#47CD#, 16#0020#, 16#0002#),
         23959 => (16#47CE#, 16#0020#, 16#0002#),
         23960 => (16#47CF#, 16#0020#, 16#0002#),
         23961 => (16#47D0#, 16#0020#, 16#0002#),
         23962 => (16#47D1#, 16#0020#, 16#0002#),
         23963 => (16#47D2#, 16#0020#, 16#0002#),
         23964 => (16#47D3#, 16#0020#, 16#0002#),
         23965 => (16#47D4#, 16#0020#, 16#0002#),
         23966 => (16#47D5#, 16#0020#, 16#0002#),
         23967 => (16#47D6#, 16#0020#, 16#0002#),
         23968 => (16#47D7#, 16#0020#, 16#0002#),
         23969 => (16#47D8#, 16#0020#, 16#0002#),
         23970 => (16#47D9#, 16#0020#, 16#0002#),
         23971 => (16#47DA#, 16#0020#, 16#0002#),
         23972 => (16#47DB#, 16#0020#, 16#0002#),
         23973 => (16#47DC#, 16#0020#, 16#0002#),
         23974 => (16#47DD#, 16#0020#, 16#0002#),
         23975 => (16#47DE#, 16#0020#, 16#0002#),
         23976 => (16#47DF#, 16#0020#, 16#0002#),
         23977 => (16#47E0#, 16#0020#, 16#0002#),
         23978 => (16#47E1#, 16#0020#, 16#0002#),
         23979 => (16#47E2#, 16#0020#, 16#0002#),
         23980 => (16#47E3#, 16#0020#, 16#0002#),
         23981 => (16#47E4#, 16#0020#, 16#0002#),
         23982 => (16#47E5#, 16#0020#, 16#0002#),
         23983 => (16#47E6#, 16#0020#, 16#0002#),
         23984 => (16#47E7#, 16#0020#, 16#0002#),
         23985 => (16#47E8#, 16#0020#, 16#0002#),
         23986 => (16#47E9#, 16#0020#, 16#0002#),
         23987 => (16#47EA#, 16#0020#, 16#0002#),
         23988 => (16#47EB#, 16#0020#, 16#0002#),
         23989 => (16#47EC#, 16#0020#, 16#0002#),
         23990 => (16#47ED#, 16#0020#, 16#0002#),
         23991 => (16#47EE#, 16#0020#, 16#0002#),
         23992 => (16#47EF#, 16#0020#, 16#0002#),
         23993 => (16#47F0#, 16#0020#, 16#0002#),
         23994 => (16#47F1#, 16#0020#, 16#0002#),
         23995 => (16#47F2#, 16#0020#, 16#0002#),
         23996 => (16#47F3#, 16#0020#, 16#0002#),
         23997 => (16#47F4#, 16#0020#, 16#0002#),
         23998 => (16#47F5#, 16#0020#, 16#0002#),
         23999 => (16#47F6#, 16#0020#, 16#0002#),
         24000 => (16#47F7#, 16#0020#, 16#0002#),
         24001 => (16#47F8#, 16#0020#, 16#0002#),
         24002 => (16#47F9#, 16#0020#, 16#0002#),
         24003 => (16#47FA#, 16#0020#, 16#0002#),
         24004 => (16#47FB#, 16#0020#, 16#0002#),
         24005 => (16#47FC#, 16#0020#, 16#0002#),
         24006 => (16#47FD#, 16#0020#, 16#0002#),
         24007 => (16#47FE#, 16#0020#, 16#0002#),
         24008 => (16#47FF#, 16#0020#, 16#0002#),
         24009 => (16#4800#, 16#0020#, 16#0002#),
         24010 => (16#4801#, 16#0020#, 16#0002#),
         24011 => (16#4802#, 16#0020#, 16#0002#),
         24012 => (16#4803#, 16#0020#, 16#0002#),
         24013 => (16#4804#, 16#0020#, 16#0002#),
         24014 => (16#4805#, 16#0020#, 16#0002#),
         24015 => (16#4806#, 16#0020#, 16#0002#),
         24016 => (16#4807#, 16#0020#, 16#0002#),
         24017 => (16#4808#, 16#0020#, 16#0002#),
         24018 => (16#4809#, 16#0020#, 16#0002#),
         24019 => (16#480A#, 16#0020#, 16#0002#),
         24020 => (16#480B#, 16#0020#, 16#0002#),
         24021 => (16#480C#, 16#0020#, 16#0002#),
         24022 => (16#480D#, 16#0020#, 16#0002#),
         24023 => (16#480E#, 16#0020#, 16#0002#),
         24024 => (16#480F#, 16#0020#, 16#0002#),
         24025 => (16#4810#, 16#0020#, 16#0002#),
         24026 => (16#4811#, 16#0020#, 16#0002#),
         24027 => (16#4812#, 16#0020#, 16#0002#),
         24028 => (16#4813#, 16#0020#, 16#0002#),
         24029 => (16#4814#, 16#0020#, 16#0002#),
         24030 => (16#4815#, 16#0020#, 16#0002#),
         24031 => (16#4816#, 16#0020#, 16#0002#),
         24032 => (16#4817#, 16#0020#, 16#0002#),
         24033 => (16#4818#, 16#0020#, 16#0002#),
         24034 => (16#4819#, 16#0020#, 16#0002#),
         24035 => (16#481A#, 16#0020#, 16#0002#),
         24036 => (16#481B#, 16#0020#, 16#0002#),
         24037 => (16#481C#, 16#0020#, 16#0002#),
         24038 => (16#481D#, 16#0020#, 16#0002#),
         24039 => (16#481E#, 16#0020#, 16#0002#),
         24040 => (16#481F#, 16#0020#, 16#0002#),
         24041 => (16#4820#, 16#0020#, 16#0002#),
         24042 => (16#4821#, 16#0020#, 16#0002#),
         24043 => (16#4822#, 16#0020#, 16#0002#),
         24044 => (16#4823#, 16#0020#, 16#0002#),
         24045 => (16#4824#, 16#0020#, 16#0002#),
         24046 => (16#4825#, 16#0020#, 16#0002#),
         24047 => (16#4826#, 16#0020#, 16#0002#),
         24048 => (16#4827#, 16#0020#, 16#0002#),
         24049 => (16#4828#, 16#0020#, 16#0002#),
         24050 => (16#4829#, 16#0020#, 16#0002#),
         24051 => (16#482A#, 16#0020#, 16#0002#),
         24052 => (16#482B#, 16#0020#, 16#0002#),
         24053 => (16#482C#, 16#0020#, 16#0002#),
         24054 => (16#482D#, 16#0020#, 16#0002#),
         24055 => (16#482E#, 16#0020#, 16#0002#),
         24056 => (16#482F#, 16#0020#, 16#0002#),
         24057 => (16#4830#, 16#0020#, 16#0002#),
         24058 => (16#4831#, 16#0020#, 16#0002#),
         24059 => (16#4832#, 16#0020#, 16#0002#),
         24060 => (16#4833#, 16#0020#, 16#0002#),
         24061 => (16#4834#, 16#0020#, 16#0002#),
         24062 => (16#4835#, 16#0020#, 16#0002#),
         24063 => (16#4836#, 16#0020#, 16#0002#),
         24064 => (16#4837#, 16#0020#, 16#0002#),
         24065 => (16#4838#, 16#0020#, 16#0002#),
         24066 => (16#4839#, 16#0020#, 16#0002#),
         24067 => (16#483A#, 16#0020#, 16#0002#),
         24068 => (16#483B#, 16#0020#, 16#0002#),
         24069 => (16#483C#, 16#0020#, 16#0002#),
         24070 => (16#483D#, 16#0020#, 16#0002#),
         24071 => (16#483E#, 16#0020#, 16#0002#),
         24072 => (16#483F#, 16#0020#, 16#0002#),
         24073 => (16#4840#, 16#0020#, 16#0002#),
         24074 => (16#4841#, 16#0020#, 16#0002#),
         24075 => (16#4842#, 16#0020#, 16#0002#),
         24076 => (16#4843#, 16#0020#, 16#0002#),
         24077 => (16#4844#, 16#0020#, 16#0002#),
         24078 => (16#4845#, 16#0020#, 16#0002#),
         24079 => (16#4846#, 16#0020#, 16#0002#),
         24080 => (16#4847#, 16#0020#, 16#0002#),
         24081 => (16#4848#, 16#0020#, 16#0002#),
         24082 => (16#4849#, 16#0020#, 16#0002#),
         24083 => (16#484A#, 16#0020#, 16#0002#),
         24084 => (16#484B#, 16#0020#, 16#0002#),
         24085 => (16#484C#, 16#0020#, 16#0002#),
         24086 => (16#484D#, 16#0020#, 16#0002#),
         24087 => (16#484E#, 16#0020#, 16#0002#),
         24088 => (16#484F#, 16#0020#, 16#0002#),
         24089 => (16#4850#, 16#0020#, 16#0002#),
         24090 => (16#4851#, 16#0020#, 16#0002#),
         24091 => (16#4852#, 16#0020#, 16#0002#),
         24092 => (16#4853#, 16#0020#, 16#0002#),
         24093 => (16#4854#, 16#0020#, 16#0002#),
         24094 => (16#4855#, 16#0020#, 16#0002#),
         24095 => (16#4856#, 16#0020#, 16#0002#),
         24096 => (16#4857#, 16#0020#, 16#0002#),
         24097 => (16#4858#, 16#0020#, 16#0002#),
         24098 => (16#4859#, 16#0020#, 16#0002#),
         24099 => (16#485A#, 16#0020#, 16#0002#),
         24100 => (16#485B#, 16#0020#, 16#0002#),
         24101 => (16#485C#, 16#0020#, 16#0002#),
         24102 => (16#485D#, 16#0020#, 16#0002#),
         24103 => (16#485E#, 16#0020#, 16#0002#),
         24104 => (16#485F#, 16#0020#, 16#0002#),
         24105 => (16#4860#, 16#0020#, 16#0002#),
         24106 => (16#4861#, 16#0020#, 16#0002#),
         24107 => (16#4862#, 16#0020#, 16#0002#),
         24108 => (16#4863#, 16#0020#, 16#0002#),
         24109 => (16#4864#, 16#0020#, 16#0002#),
         24110 => (16#4865#, 16#0020#, 16#0002#),
         24111 => (16#4866#, 16#0020#, 16#0002#),
         24112 => (16#17E9#, 16#0020#, 16#0002#),
         24113 => (16#17EA#, 16#0020#, 16#0002#),
         24114 => (16#17EB#, 16#0020#, 16#0002#),
         24115 => (16#17EC#, 16#0020#, 16#0002#),
         24116 => (16#17ED#, 16#0020#, 16#0002#),
         24117 => (16#17EE#, 16#0020#, 16#0002#),
         24118 => (16#17EF#, 16#0020#, 16#0002#),
         24119 => (16#17F0#, 16#0020#, 16#0002#),
         24120 => (16#17F1#, 16#0020#, 16#0002#),
         24121 => (16#17F2#, 16#0020#, 16#0002#),
         24122 => (16#17F3#, 16#0020#, 16#0002#),
         24123 => (16#17F4#, 16#0020#, 16#0002#),
         24124 => (16#17F5#, 16#0020#, 16#0002#),
         24125 => (16#17F6#, 16#0020#, 16#0002#),
         24126 => (16#17F7#, 16#0020#, 16#0002#),
         24127 => (16#17F8#, 16#0020#, 16#0002#),
         24128 => (16#17F9#, 16#0020#, 16#0002#),
         24129 => (16#01F2#, 16#0020#, 16#0002#),
         24130 => (16#01F3#, 16#0020#, 16#0002#),
         24131 => (16#01F4#, 16#0020#, 16#0002#),
         24132 => (16#01F5#, 16#0020#, 16#0002#),
         24133 => (16#01F6#, 16#0020#, 16#0002#),
         24134 => (16#4867#, 16#0020#, 16#0002#),
         24135 => (16#4868#, 16#0020#, 16#0002#),
         24136 => (16#4869#, 16#0020#, 16#0002#),
         24137 => (16#486A#, 16#0020#, 16#0002#),
         24138 => (16#486B#, 16#0020#, 16#0002#),
         24139 => (16#486C#, 16#0020#, 16#0002#),
         24140 => (16#486D#, 16#0020#, 16#0002#),
         24141 => (16#486E#, 16#0020#, 16#0002#),
         24142 => (16#486F#, 16#0020#, 16#0002#),
         24143 => (16#4870#, 16#0020#, 16#0002#),
         24144 => (16#4871#, 16#0020#, 16#0002#),
         24145 => (16#4872#, 16#0020#, 16#0002#),
         24146 => (16#4873#, 16#0020#, 16#0002#),
         24147 => (16#4874#, 16#0020#, 16#0002#),
         24148 => (16#4875#, 16#0020#, 16#0002#),
         24149 => (16#4876#, 16#0020#, 16#0002#),
         24150 => (16#4877#, 16#0020#, 16#0002#),
         24151 => (16#4878#, 16#0020#, 16#0002#),
         24152 => (16#4879#, 16#0020#, 16#0002#),
         24153 => (16#487A#, 16#0020#, 16#0002#),
         24154 => (16#487B#, 16#0020#, 16#0002#),
         24155 => (16#487C#, 16#0020#, 16#0002#),
         24156 => (16#487D#, 16#0020#, 16#0002#),
         24157 => (16#487E#, 16#0020#, 16#0002#),
         24158 => (16#487F#, 16#0020#, 16#0002#),
         24159 => (16#4880#, 16#0020#, 16#0002#),
         24160 => (16#4881#, 16#0020#, 16#0002#),
         24161 => (16#4882#, 16#0020#, 16#0002#),
         24162 => (16#4883#, 16#0020#, 16#0002#),
         24163 => (16#4884#, 16#0020#, 16#0002#),
         24164 => (16#4885#, 16#0020#, 16#0002#),
         24165 => (16#4886#, 16#0020#, 16#0002#),
         24166 => (16#4887#, 16#0020#, 16#0002#),
         24167 => (16#4888#, 16#0020#, 16#0002#),
         24168 => (16#4889#, 16#0020#, 16#0002#),
         24169 => (16#488A#, 16#0020#, 16#0002#),
         24170 => (16#488B#, 16#0020#, 16#0002#),
         24171 => (16#488C#, 16#0020#, 16#0002#),
         24172 => (16#488D#, 16#0020#, 16#0002#),
         24173 => (16#488E#, 16#0020#, 16#0002#),
         24174 => (16#488F#, 16#0020#, 16#0002#),
         24175 => (16#4890#, 16#0020#, 16#0002#),
         24176 => (16#4891#, 16#0020#, 16#0002#),
         24177 => (16#4892#, 16#0020#, 16#0002#),
         24178 => (16#4893#, 16#0020#, 16#0002#),
         24179 => (16#4894#, 16#0020#, 16#0002#),
         24180 => (16#4895#, 16#0020#, 16#0002#),
         24181 => (16#4896#, 16#0020#, 16#0002#),
         24182 => (16#4897#, 16#0020#, 16#0002#),
         24183 => (16#4898#, 16#0020#, 16#0002#),
         24184 => (16#4899#, 16#0020#, 16#0002#),
         24185 => (16#489A#, 16#0020#, 16#0002#),
         24186 => (16#489B#, 16#0020#, 16#0002#),
         24187 => (16#489C#, 16#0020#, 16#0002#),
         24188 => (16#489D#, 16#0020#, 16#0002#),
         24189 => (16#489E#, 16#0020#, 16#0002#),
         24190 => (16#489F#, 16#0020#, 16#0002#),
         24191 => (16#48A0#, 16#0020#, 16#0002#),
         24192 => (16#48A1#, 16#0020#, 16#0002#),
         24193 => (16#48A2#, 16#0020#, 16#0002#),
         24194 => (16#48A3#, 16#0020#, 16#0002#),
         24195 => (16#48A4#, 16#0020#, 16#0002#),
         24196 => (16#48A5#, 16#0020#, 16#0002#),
         24197 => (16#48A6#, 16#0020#, 16#0002#),
         24198 => (16#48A7#, 16#0020#, 16#0002#),
         24199 => (16#48A8#, 16#0020#, 16#0002#),
         24200 => (16#48A9#, 16#0020#, 16#0002#),
         24201 => (16#48AA#, 16#0020#, 16#0002#),
         24202 => (16#48AB#, 16#0020#, 16#0002#),
         24203 => (16#48AC#, 16#0020#, 16#0002#),
         24204 => (16#48AD#, 16#0020#, 16#0002#),
         24205 => (16#48AE#, 16#0020#, 16#0002#),
         24206 => (16#48AF#, 16#0020#, 16#0002#),
         24207 => (16#48B0#, 16#0020#, 16#0002#),
         24208 => (16#48B1#, 16#0020#, 16#0002#),
         24209 => (16#48B2#, 16#0020#, 16#0002#),
         24210 => (16#48B3#, 16#0020#, 16#0002#),
         24211 => (16#48B4#, 16#0020#, 16#0002#),
         24212 => (16#48B5#, 16#0020#, 16#0002#),
         24213 => (16#48B6#, 16#0020#, 16#0002#),
         24214 => (16#48B7#, 16#0020#, 16#0002#),
         24215 => (16#48B8#, 16#0020#, 16#0002#),
         24216 => (16#48B9#, 16#0020#, 16#0002#),
         24217 => (16#48BA#, 16#0020#, 16#0002#),
         24218 => (16#48BB#, 16#0020#, 16#0002#),
         24219 => (16#48BC#, 16#0020#, 16#0002#),
         24220 => (16#48BD#, 16#0020#, 16#0002#),
         24221 => (16#48BE#, 16#0020#, 16#0002#),
         24222 => (16#48BF#, 16#0020#, 16#0002#),
         24223 => (16#48C0#, 16#0020#, 16#0002#),
         24224 => (16#48C1#, 16#0020#, 16#0002#),
         24225 => (16#48C2#, 16#0020#, 16#0002#),
         24226 => (16#48C3#, 16#0020#, 16#0002#),
         24227 => (16#48C4#, 16#0020#, 16#0002#),
         24228 => (16#48C5#, 16#0020#, 16#0002#),
         24229 => (16#48C6#, 16#0020#, 16#0002#),
         24230 => (16#48C7#, 16#0020#, 16#0002#),
         24231 => (16#48C8#, 16#0020#, 16#0002#),
         24232 => (16#48C9#, 16#0020#, 16#0002#),
         24233 => (16#48CA#, 16#0020#, 16#0002#),
         24234 => (16#48CB#, 16#0020#, 16#0002#),
         24235 => (16#48CC#, 16#0020#, 16#0002#),
         24236 => (16#48CD#, 16#0020#, 16#0002#),
         24237 => (16#48CE#, 16#0020#, 16#0002#),
         24238 => (16#48CF#, 16#0020#, 16#0002#),
         24239 => (16#48D0#, 16#0020#, 16#0002#),
         24240 => (16#48D1#, 16#0020#, 16#0002#),
         24241 => (16#48D2#, 16#0020#, 16#0002#),
         24242 => (16#48D3#, 16#0020#, 16#0002#),
         24243 => (16#48D4#, 16#0020#, 16#0002#),
         24244 => (16#48D5#, 16#0020#, 16#0002#),
         24245 => (16#48D6#, 16#0020#, 16#0002#),
         24246 => (16#48D7#, 16#0020#, 16#0002#),
         24247 => (16#48D8#, 16#0020#, 16#0002#),
         24248 => (16#48D9#, 16#0020#, 16#0002#),
         24249 => (16#48DA#, 16#0020#, 16#0002#),
         24250 => (16#48DB#, 16#0020#, 16#0002#),
         24251 => (16#48DC#, 16#0020#, 16#0002#),
         24252 => (16#48DD#, 16#0020#, 16#0002#),
         24253 => (16#48DE#, 16#0020#, 16#0002#),
         24254 => (16#48DF#, 16#0020#, 16#0002#),
         24255 => (16#48E0#, 16#0020#, 16#0002#),
         24256 => (16#48E1#, 16#0020#, 16#0002#),
         24257 => (16#48E2#, 16#0020#, 16#0002#),
         24258 => (16#48E3#, 16#0020#, 16#0002#),
         24259 => (16#48E4#, 16#0020#, 16#0002#),
         24260 => (16#48E5#, 16#0020#, 16#0002#),
         24261 => (16#48E6#, 16#0020#, 16#0002#),
         24262 => (16#48E7#, 16#0020#, 16#0002#),
         24263 => (16#48E8#, 16#0020#, 16#0002#),
         24264 => (16#48E9#, 16#0020#, 16#0002#),
         24265 => (16#48EA#, 16#0020#, 16#0002#),
         24266 => (16#48EB#, 16#0020#, 16#0002#),
         24267 => (16#48EC#, 16#0020#, 16#0002#),
         24268 => (16#48ED#, 16#0020#, 16#0002#),
         24269 => (16#48EE#, 16#0020#, 16#0002#),
         24270 => (16#48EF#, 16#0020#, 16#0002#),
         24271 => (16#48F0#, 16#0020#, 16#0002#),
         24272 => (16#48F1#, 16#0020#, 16#0002#),
         24273 => (16#48F2#, 16#0020#, 16#0002#),
         24274 => (16#48F3#, 16#0020#, 16#0002#),
         24275 => (16#48F4#, 16#0020#, 16#0002#),
         24276 => (16#48F5#, 16#0020#, 16#0002#),
         24277 => (16#48F6#, 16#0020#, 16#0002#),
         24278 => (16#48F7#, 16#0020#, 16#0002#),
         24279 => (16#48F8#, 16#0020#, 16#0002#),
         24280 => (16#48F9#, 16#0020#, 16#0002#),
         24281 => (16#48FA#, 16#0020#, 16#0002#),
         24282 => (16#48FB#, 16#0020#, 16#0002#),
         24283 => (16#48FC#, 16#0020#, 16#0002#),
         24284 => (16#48FD#, 16#0020#, 16#0002#),
         24285 => (16#48FE#, 16#0020#, 16#0002#),
         24286 => (16#48FF#, 16#0020#, 16#0002#),
         24287 => (16#4900#, 16#0020#, 16#0002#),
         24288 => (16#4901#, 16#0020#, 16#0002#),
         24289 => (16#4902#, 16#0020#, 16#0002#),
         24290 => (16#4903#, 16#0020#, 16#0002#),
         24291 => (16#4904#, 16#0020#, 16#0002#),
         24292 => (16#4905#, 16#0020#, 16#0002#),
         24293 => (16#4906#, 16#0020#, 16#0002#),
         24294 => (16#4907#, 16#0020#, 16#0002#),
         24295 => (16#4908#, 16#0020#, 16#0002#),
         24296 => (16#4909#, 16#0020#, 16#0002#),
         24297 => (16#490A#, 16#0020#, 16#0002#),
         24298 => (16#490B#, 16#0020#, 16#0002#),
         24299 => (16#490C#, 16#0020#, 16#0002#),
         24300 => (16#490D#, 16#0020#, 16#0002#),
         24301 => (16#490E#, 16#0020#, 16#0002#),
         24302 => (16#490F#, 16#0020#, 16#0002#),
         24303 => (16#4910#, 16#0020#, 16#0002#),
         24304 => (16#4911#, 16#0020#, 16#0002#),
         24305 => (16#4912#, 16#0020#, 16#0002#),
         24306 => (16#4913#, 16#0020#, 16#0002#),
         24307 => (16#4914#, 16#0020#, 16#0002#),
         24308 => (16#4915#, 16#0020#, 16#0002#),
         24309 => (16#4916#, 16#0020#, 16#0002#),
         24310 => (16#4917#, 16#0020#, 16#0002#),
         24311 => (16#4918#, 16#0020#, 16#0002#),
         24312 => (16#4919#, 16#0020#, 16#0002#),
         24313 => (16#491A#, 16#0020#, 16#0002#),
         24314 => (16#491B#, 16#0020#, 16#0002#),
         24315 => (16#491C#, 16#0020#, 16#0002#),
         24316 => (16#491D#, 16#0020#, 16#0002#),
         24317 => (16#491E#, 16#0020#, 16#0002#),
         24318 => (16#491F#, 16#0020#, 16#0002#),
         24319 => (16#4920#, 16#0020#, 16#0002#),
         24320 => (16#4921#, 16#0020#, 16#0002#),
         24321 => (16#4922#, 16#0020#, 16#0002#),
         24322 => (16#4923#, 16#0020#, 16#0002#),
         24323 => (16#4924#, 16#0020#, 16#0002#),
         24324 => (16#4925#, 16#0020#, 16#0002#),
         24325 => (16#4926#, 16#0020#, 16#0002#),
         24326 => (16#4927#, 16#0020#, 16#0002#),
         24327 => (16#4928#, 16#0020#, 16#0002#),
         24328 => (16#4929#, 16#0020#, 16#0002#),
         24329 => (16#492A#, 16#0020#, 16#0002#),
         24330 => (16#492B#, 16#0020#, 16#0002#),
         24331 => (16#492C#, 16#0020#, 16#0002#),
         24332 => (16#492D#, 16#0020#, 16#0002#),
         24333 => (16#492E#, 16#0020#, 16#0002#),
         24334 => (16#492F#, 16#0020#, 16#0002#),
         24335 => (16#4930#, 16#0020#, 16#0002#),
         24336 => (16#4931#, 16#0020#, 16#0002#),
         24337 => (16#4932#, 16#0020#, 16#0002#),
         24338 => (16#4933#, 16#0020#, 16#0002#),
         24339 => (16#4934#, 16#0020#, 16#0002#),
         24340 => (16#4935#, 16#0020#, 16#0002#),
         24341 => (16#4936#, 16#0020#, 16#0002#),
         24342 => (16#4937#, 16#0020#, 16#0002#),
         24343 => (16#4938#, 16#0020#, 16#0002#),
         24344 => (16#4939#, 16#0020#, 16#0002#),
         24345 => (16#493A#, 16#0020#, 16#0002#),
         24346 => (16#493B#, 16#0020#, 16#0002#),
         24347 => (16#493C#, 16#0020#, 16#0002#),
         24348 => (16#493D#, 16#0020#, 16#0002#),
         24349 => (16#493E#, 16#0020#, 16#0002#),
         24350 => (16#493F#, 16#0020#, 16#0002#),
         24351 => (16#4940#, 16#0020#, 16#0002#),
         24352 => (16#4941#, 16#0020#, 16#0002#),
         24353 => (16#4942#, 16#0020#, 16#0002#),
         24354 => (16#4943#, 16#0020#, 16#0002#),
         24355 => (16#4944#, 16#0020#, 16#0002#),
         24356 => (16#4945#, 16#0020#, 16#0002#),
         24357 => (16#4946#, 16#0020#, 16#0002#),
         24358 => (16#4947#, 16#0020#, 16#0002#),
         24359 => (16#4948#, 16#0020#, 16#0002#),
         24360 => (16#4949#, 16#0020#, 16#0002#),
         24361 => (16#494A#, 16#0020#, 16#0002#),
         24362 => (16#494B#, 16#0020#, 16#0002#),
         24363 => (16#494C#, 16#0020#, 16#0002#),
         24364 => (16#494D#, 16#0020#, 16#0002#),
         24365 => (16#494E#, 16#0020#, 16#0002#),
         24366 => (16#494F#, 16#0020#, 16#0002#),
         24367 => (16#4950#, 16#0020#, 16#0002#),
         24368 => (16#4951#, 16#0020#, 16#0002#),
         24369 => (16#4952#, 16#0020#, 16#0002#),
         24370 => (16#4953#, 16#0020#, 16#0002#),
         24371 => (16#4954#, 16#0020#, 16#0002#),
         24372 => (16#4955#, 16#0020#, 16#0002#),
         24373 => (16#4956#, 16#0020#, 16#0002#),
         24374 => (16#4957#, 16#0020#, 16#0002#),
         24375 => (16#4958#, 16#0020#, 16#0002#),
         24376 => (16#4959#, 16#0020#, 16#0002#),
         24377 => (16#495A#, 16#0020#, 16#0002#),
         24378 => (16#495B#, 16#0020#, 16#0002#),
         24379 => (16#495C#, 16#0020#, 16#0002#),
         24380 => (16#495D#, 16#0020#, 16#0002#),
         24381 => (16#495E#, 16#0020#, 16#0002#),
         24382 => (16#495F#, 16#0020#, 16#0002#),
         24383 => (16#4960#, 16#0020#, 16#0002#),
         24384 => (16#4961#, 16#0020#, 16#0002#),
         24385 => (16#4962#, 16#0020#, 16#0002#),
         24386 => (16#4963#, 16#0020#, 16#0002#),
         24387 => (16#4964#, 16#0020#, 16#0002#),
         24388 => (16#4965#, 16#0020#, 16#0002#),
         24389 => (16#4966#, 16#0020#, 16#0002#),
         24390 => (16#4967#, 16#0020#, 16#0002#),
         24391 => (16#4968#, 16#0020#, 16#0002#),
         24392 => (16#4969#, 16#0020#, 16#0002#),
         24393 => (16#496A#, 16#0020#, 16#0002#),
         24394 => (16#496B#, 16#0020#, 16#0002#),
         24395 => (16#496C#, 16#0020#, 16#0002#),
         24396 => (16#496D#, 16#0020#, 16#0002#),
         24397 => (16#496E#, 16#0020#, 16#0002#),
         24398 => (16#496F#, 16#0020#, 16#0002#),
         24399 => (16#4970#, 16#0020#, 16#0002#),
         24400 => (16#4971#, 16#0020#, 16#0002#),
         24401 => (16#4972#, 16#0020#, 16#0002#),
         24402 => (16#4973#, 16#0020#, 16#0002#),
         24403 => (16#4974#, 16#0020#, 16#0002#),
         24404 => (16#4975#, 16#0020#, 16#0002#),
         24405 => (16#4976#, 16#0020#, 16#0002#),
         24406 => (16#4977#, 16#0020#, 16#0002#),
         24407 => (16#4978#, 16#0020#, 16#0002#),
         24408 => (16#4979#, 16#0020#, 16#0002#),
         24409 => (16#497A#, 16#0020#, 16#0002#),
         24410 => (16#497B#, 16#0020#, 16#0002#),
         24411 => (16#497C#, 16#0020#, 16#0002#),
         24412 => (16#497D#, 16#0020#, 16#0002#),
         24413 => (16#497E#, 16#0020#, 16#0002#),
         24414 => (16#497F#, 16#0020#, 16#0002#),
         24415 => (16#4980#, 16#0020#, 16#0002#),
         24416 => (16#4981#, 16#0020#, 16#0002#),
         24417 => (16#4982#, 16#0020#, 16#0002#),
         24418 => (16#4983#, 16#0020#, 16#0002#),
         24419 => (16#4984#, 16#0020#, 16#0002#),
         24420 => (16#4985#, 16#0020#, 16#0002#),
         24421 => (16#4986#, 16#0020#, 16#0002#),
         24422 => (16#4987#, 16#0020#, 16#0002#),
         24423 => (16#4988#, 16#0020#, 16#0002#),
         24424 => (16#4989#, 16#0020#, 16#0002#),
         24425 => (16#498A#, 16#0020#, 16#0002#),
         24426 => (16#498B#, 16#0020#, 16#0002#),
         24427 => (16#498C#, 16#0020#, 16#0002#),
         24428 => (16#498D#, 16#0020#, 16#0002#),
         24429 => (16#498E#, 16#0020#, 16#0002#),
         24430 => (16#498F#, 16#0020#, 16#0002#),
         24431 => (16#4990#, 16#0020#, 16#0002#),
         24432 => (16#4991#, 16#0020#, 16#0002#),
         24433 => (16#4992#, 16#0020#, 16#0002#),
         24434 => (16#4993#, 16#0020#, 16#0002#),
         24435 => (16#4994#, 16#0020#, 16#0002#),
         24436 => (16#4995#, 16#0020#, 16#0002#),
         24437 => (16#4996#, 16#0020#, 16#0002#),
         24438 => (16#4997#, 16#0020#, 16#0002#),
         24439 => (16#4998#, 16#0020#, 16#0002#),
         24440 => (16#4999#, 16#0020#, 16#0002#),
         24441 => (16#499A#, 16#0020#, 16#0002#),
         24442 => (16#499B#, 16#0020#, 16#0002#),
         24443 => (16#499C#, 16#0020#, 16#0002#),
         24444 => (16#499D#, 16#0020#, 16#0002#),
         24445 => (16#499E#, 16#0020#, 16#0002#),
         24446 => (16#499F#, 16#0020#, 16#0002#),
         24447 => (16#49A0#, 16#0020#, 16#0002#),
         24448 => (16#49A1#, 16#0020#, 16#0002#),
         24449 => (16#49A2#, 16#0020#, 16#0002#),
         24450 => (16#49A3#, 16#0020#, 16#0002#),
         24451 => (16#49A4#, 16#0020#, 16#0002#),
         24452 => (16#49A5#, 16#0020#, 16#0002#),
         24453 => (16#49A6#, 16#0020#, 16#0002#),
         24454 => (16#49A7#, 16#0020#, 16#0002#),
         24455 => (16#49A8#, 16#0020#, 16#0002#),
         24456 => (16#49A9#, 16#0020#, 16#0002#),
         24457 => (16#49AA#, 16#0020#, 16#0002#),
         24458 => (16#49AB#, 16#0020#, 16#0002#),
         24459 => (16#49AC#, 16#0020#, 16#0002#),
         24460 => (16#49AD#, 16#0020#, 16#0002#),
         24461 => (16#49AE#, 16#0020#, 16#0002#),
         24462 => (16#49AF#, 16#0020#, 16#0002#),
         24463 => (16#49B0#, 16#0020#, 16#0002#),
         24464 => (16#49B1#, 16#0020#, 16#0002#),
         24465 => (16#49B2#, 16#0020#, 16#0002#),
         24466 => (16#49B3#, 16#0020#, 16#0002#),
         24467 => (16#49B4#, 16#0020#, 16#0002#),
         24468 => (16#49B5#, 16#0020#, 16#0002#),
         24469 => (16#49B6#, 16#0020#, 16#0002#),
         24470 => (16#49B7#, 16#0020#, 16#0002#),
         24471 => (16#49B8#, 16#0020#, 16#0002#),
         24472 => (16#49B9#, 16#0020#, 16#0002#),
         24473 => (16#49BA#, 16#0020#, 16#0002#),
         24474 => (16#49BB#, 16#0020#, 16#0002#),
         24475 => (16#49BC#, 16#0020#, 16#0002#),
         24476 => (16#49BD#, 16#0020#, 16#0002#),
         24477 => (16#49BE#, 16#0020#, 16#0002#),
         24478 => (16#49BF#, 16#0020#, 16#0002#),
         24479 => (16#49C0#, 16#0020#, 16#0002#),
         24480 => (16#49C1#, 16#0020#, 16#0002#),
         24481 => (16#49C2#, 16#0020#, 16#0002#),
         24482 => (16#49C3#, 16#0020#, 16#0002#),
         24483 => (16#49C4#, 16#0020#, 16#0002#),
         24484 => (16#49C5#, 16#0020#, 16#0002#),
         24485 => (16#49C6#, 16#0020#, 16#0002#),
         24486 => (16#49C7#, 16#0020#, 16#0002#),
         24487 => (16#49C8#, 16#0020#, 16#0002#),
         24488 => (16#49C9#, 16#0020#, 16#0002#),
         24489 => (16#49CA#, 16#0020#, 16#0002#),
         24490 => (16#49CB#, 16#0020#, 16#0002#),
         24491 => (16#49CC#, 16#0020#, 16#0002#),
         24492 => (16#49CD#, 16#0020#, 16#0002#),
         24493 => (16#49CE#, 16#0020#, 16#0002#),
         24494 => (16#49CF#, 16#0020#, 16#0002#),
         24495 => (16#49D0#, 16#0020#, 16#0002#),
         24496 => (16#49D1#, 16#0020#, 16#0002#),
         24497 => (16#49D2#, 16#0020#, 16#0002#),
         24498 => (16#49D3#, 16#0020#, 16#0002#),
         24499 => (16#49D4#, 16#0020#, 16#0002#),
         24500 => (16#49D5#, 16#0020#, 16#0002#),
         24501 => (16#49D6#, 16#0020#, 16#0002#),
         24502 => (16#49D7#, 16#0020#, 16#0002#),
         24503 => (16#49D8#, 16#0020#, 16#0002#),
         24504 => (16#49D9#, 16#0020#, 16#0002#),
         24505 => (16#49DA#, 16#0020#, 16#0002#),
         24506 => (16#49DB#, 16#0020#, 16#0002#),
         24507 => (16#49DC#, 16#0020#, 16#0002#),
         24508 => (16#49DD#, 16#0020#, 16#0002#),
         24509 => (16#49DE#, 16#0020#, 16#0002#),
         24510 => (16#49DF#, 16#0020#, 16#0002#),
         24511 => (16#49E0#, 16#0020#, 16#0002#),
         24512 => (16#49E1#, 16#0020#, 16#0002#),
         24513 => (16#49E2#, 16#0020#, 16#0002#),
         24514 => (16#49E3#, 16#0020#, 16#0002#),
         24515 => (16#49E4#, 16#0020#, 16#0002#),
         24516 => (16#49E5#, 16#0020#, 16#0002#),
         24517 => (16#49E6#, 16#0020#, 16#0002#),
         24518 => (16#49E7#, 16#0020#, 16#0002#),
         24519 => (16#49E8#, 16#0020#, 16#0002#),
         24520 => (16#49E9#, 16#0020#, 16#0002#),
         24521 => (16#49EA#, 16#0020#, 16#0002#),
         24522 => (16#49EB#, 16#0020#, 16#0002#),
         24523 => (16#49EC#, 16#0020#, 16#0002#),
         24524 => (16#49ED#, 16#0020#, 16#0002#),
         24525 => (16#49EE#, 16#0020#, 16#0002#),
         24526 => (16#49EF#, 16#0020#, 16#0002#),
         24527 => (16#49F0#, 16#0020#, 16#0002#),
         24528 => (16#49F1#, 16#0020#, 16#0002#),
         24529 => (16#49F2#, 16#0020#, 16#0002#),
         24530 => (16#49F3#, 16#0020#, 16#0002#),
         24531 => (16#49F4#, 16#0020#, 16#0002#),
         24532 => (16#49F5#, 16#0020#, 16#0002#),
         24533 => (16#49F6#, 16#0020#, 16#0002#),
         24534 => (16#49F7#, 16#0020#, 16#0002#),
         24535 => (16#49F8#, 16#0020#, 16#0002#),
         24536 => (16#49F9#, 16#0020#, 16#0002#),
         24537 => (16#49FA#, 16#0020#, 16#0002#),
         24538 => (16#49FB#, 16#0020#, 16#0002#),
         24539 => (16#49FC#, 16#0020#, 16#0002#),
         24540 => (16#49FD#, 16#0020#, 16#0002#),
         24541 => (16#49FE#, 16#0020#, 16#0002#),
         24542 => (16#49FF#, 16#0020#, 16#0002#),
         24543 => (16#4A00#, 16#0020#, 16#0002#),
         24544 => (16#4A01#, 16#0020#, 16#0002#),
         24545 => (16#4A02#, 16#0020#, 16#0002#),
         24546 => (16#4A03#, 16#0020#, 16#0002#),
         24547 => (16#4A04#, 16#0020#, 16#0002#),
         24548 => (16#4A05#, 16#0020#, 16#0002#),
         24549 => (16#4A06#, 16#0020#, 16#0002#),
         24550 => (16#4A07#, 16#0020#, 16#0002#),
         24551 => (16#4A08#, 16#0020#, 16#0002#),
         24552 => (16#4A09#, 16#0020#, 16#0002#),
         24553 => (16#4A0A#, 16#0020#, 16#0002#),
         24554 => (16#4A0B#, 16#0020#, 16#0002#),
         24555 => (16#4A0C#, 16#0020#, 16#0002#),
         24556 => (16#4A0D#, 16#0020#, 16#0002#),
         24557 => (16#4A0E#, 16#0020#, 16#0002#),
         24558 => (16#4A0F#, 16#0020#, 16#0002#),
         24559 => (16#4A10#, 16#0020#, 16#0002#),
         24560 => (16#4A11#, 16#0020#, 16#0002#),
         24561 => (16#4A12#, 16#0020#, 16#0002#),
         24562 => (16#4A13#, 16#0020#, 16#0002#),
         24563 => (16#4A14#, 16#0020#, 16#0002#),
         24564 => (16#4A15#, 16#0020#, 16#0002#),
         24565 => (16#4A16#, 16#0020#, 16#0002#),
         24566 => (16#4A17#, 16#0020#, 16#0002#),
         24567 => (16#4A18#, 16#0020#, 16#0002#),
         24568 => (16#4A19#, 16#0020#, 16#0002#),
         24569 => (16#4A1A#, 16#0020#, 16#0002#),
         24570 => (16#4A1B#, 16#0020#, 16#0002#),
         24571 => (16#4A1C#, 16#0020#, 16#0002#),
         24572 => (16#4A1D#, 16#0020#, 16#0002#),
         24573 => (16#4A1E#, 16#0020#, 16#0002#),
         24574 => (16#4A1F#, 16#0020#, 16#0002#),
         24575 => (16#4A20#, 16#0020#, 16#0002#),
         24576 => (16#4A21#, 16#0020#, 16#0002#),
         24577 => (16#4A22#, 16#0020#, 16#0002#),
         24578 => (16#4A23#, 16#0020#, 16#0002#),
         24579 => (16#4A24#, 16#0020#, 16#0002#),
         24580 => (16#4A25#, 16#0020#, 16#0002#),
         24581 => (16#4A26#, 16#0020#, 16#0002#),
         24582 => (16#4A27#, 16#0020#, 16#0002#),
         24583 => (16#4A28#, 16#0020#, 16#0002#),
         24584 => (16#4A29#, 16#0020#, 16#0002#),
         24585 => (16#4A2A#, 16#0020#, 16#0002#),
         24586 => (16#4A2B#, 16#0020#, 16#0002#),
         24587 => (16#4A2C#, 16#0020#, 16#0002#),
         24588 => (16#4A2D#, 16#0020#, 16#0002#),
         24589 => (16#4A2E#, 16#0020#, 16#0002#),
         24590 => (16#4A2F#, 16#0020#, 16#0002#),
         24591 => (16#4A30#, 16#0020#, 16#0002#),
         24592 => (16#4A31#, 16#0020#, 16#0002#),
         24593 => (16#4A32#, 16#0020#, 16#0002#),
         24594 => (16#4A33#, 16#0020#, 16#0002#),
         24595 => (16#4A34#, 16#0020#, 16#0002#),
         24596 => (16#4A35#, 16#0020#, 16#0002#),
         24597 => (16#4A36#, 16#0020#, 16#0002#),
         24598 => (16#4A37#, 16#0020#, 16#0002#),
         24599 => (16#4A38#, 16#0020#, 16#0002#),
         24600 => (16#4A39#, 16#0020#, 16#0002#),
         24601 => (16#4A3A#, 16#0020#, 16#0002#),
         24602 => (16#4A3B#, 16#0020#, 16#0002#),
         24603 => (16#4A3C#, 16#0020#, 16#0002#),
         24604 => (16#4A3D#, 16#0020#, 16#0002#),
         24605 => (16#4A3E#, 16#0020#, 16#0002#),
         24606 => (16#4A3F#, 16#0020#, 16#0002#),
         24607 => (16#4A40#, 16#0020#, 16#0002#),
         24608 => (16#4A41#, 16#0020#, 16#0002#),
         24609 => (16#4A42#, 16#0020#, 16#0002#),
         24610 => (16#4A43#, 16#0020#, 16#0002#),
         24611 => (16#4A44#, 16#0020#, 16#0002#),
         24612 => (16#4A45#, 16#0020#, 16#0002#),
         24613 => (16#4A46#, 16#0020#, 16#0002#),
         24614 => (16#4A47#, 16#0020#, 16#0002#),
         24615 => (16#4A48#, 16#0020#, 16#0002#),
         24616 => (16#4A49#, 16#0020#, 16#0002#),
         24617 => (16#4A4A#, 16#0020#, 16#0002#),
         24618 => (16#4A4B#, 16#0020#, 16#0002#),
         24619 => (16#4A4C#, 16#0020#, 16#0002#),
         24620 => (16#4A4D#, 16#0020#, 16#0002#),
         24621 => (16#4A4E#, 16#0020#, 16#0002#),
         24622 => (16#4A4F#, 16#0020#, 16#0002#),
         24623 => (16#4A50#, 16#0020#, 16#0002#),
         24624 => (16#4A51#, 16#0020#, 16#0002#),
         24625 => (16#4A52#, 16#0020#, 16#0002#),
         24626 => (16#4A53#, 16#0020#, 16#0002#),
         24627 => (16#4A54#, 16#0020#, 16#0002#),
         24628 => (16#4A55#, 16#0020#, 16#0002#),
         24629 => (16#4A56#, 16#0020#, 16#0002#),
         24630 => (16#4A57#, 16#0020#, 16#0002#),
         24631 => (16#4A58#, 16#0020#, 16#0002#),
         24632 => (16#4A59#, 16#0020#, 16#0002#),
         24633 => (16#4A5A#, 16#0020#, 16#0002#),
         24634 => (16#4A5B#, 16#0020#, 16#0002#),
         24635 => (16#4A5C#, 16#0020#, 16#0002#),
         24636 => (16#4A5D#, 16#0020#, 16#0002#),
         24637 => (16#4A5E#, 16#0020#, 16#0002#),
         24638 => (16#4A5F#, 16#0020#, 16#0002#),
         24639 => (16#4A60#, 16#0020#, 16#0002#),
         24640 => (16#4A61#, 16#0020#, 16#0002#),
         24641 => (16#4A62#, 16#0020#, 16#0002#),
         24642 => (16#4A63#, 16#0020#, 16#0002#),
         24643 => (16#4A64#, 16#0020#, 16#0002#),
         24644 => (16#4A65#, 16#0020#, 16#0002#),
         24645 => (16#4A66#, 16#0020#, 16#0002#),
         24646 => (16#4A67#, 16#0020#, 16#0002#),
         24647 => (16#4A68#, 16#0020#, 16#0002#),
         24648 => (16#4A69#, 16#0020#, 16#0002#),
         24649 => (16#4A6A#, 16#0020#, 16#0002#),
         24650 => (16#4A6B#, 16#0020#, 16#0002#),
         24651 => (16#4A6C#, 16#0020#, 16#0002#),
         24652 => (16#4A6D#, 16#0020#, 16#0002#),
         24653 => (16#4A6E#, 16#0020#, 16#0002#),
         24654 => (16#4A6F#, 16#0020#, 16#0002#),
         24655 => (16#4A70#, 16#0020#, 16#0002#),
         24656 => (16#4A71#, 16#0020#, 16#0002#),
         24657 => (16#4A72#, 16#0020#, 16#0002#),
         24658 => (16#4A73#, 16#0020#, 16#0002#),
         24659 => (16#4A74#, 16#0020#, 16#0002#),
         24660 => (16#4A75#, 16#0020#, 16#0002#),
         24661 => (16#4A76#, 16#0020#, 16#0002#),
         24662 => (16#4A77#, 16#0020#, 16#0002#),
         24663 => (16#4A78#, 16#0020#, 16#0002#),
         24664 => (16#4A79#, 16#0020#, 16#0002#),
         24665 => (16#4A7A#, 16#0020#, 16#0002#),
         24666 => (16#4A7B#, 16#0020#, 16#0002#),
         24667 => (16#4A7C#, 16#0020#, 16#0002#),
         24668 => (16#4A7D#, 16#0020#, 16#0002#),
         24669 => (16#4A7E#, 16#0020#, 16#0002#),
         24670 => (16#4A7F#, 16#0020#, 16#0002#),
         24671 => (16#4A80#, 16#0020#, 16#0002#),
         24672 => (16#4A81#, 16#0020#, 16#0002#),
         24673 => (16#4A82#, 16#0020#, 16#0002#),
         24674 => (16#4A83#, 16#0020#, 16#0002#),
         24675 => (16#4A84#, 16#0020#, 16#0002#),
         24676 => (16#4A85#, 16#0020#, 16#0002#),
         24677 => (16#4A86#, 16#0020#, 16#0002#),
         24678 => (16#4A87#, 16#0020#, 16#0002#),
         24679 => (16#4A88#, 16#0020#, 16#0002#),
         24680 => (16#4A89#, 16#0020#, 16#0002#),
         24681 => (16#4A8A#, 16#0020#, 16#0002#),
         24682 => (16#4A8B#, 16#0020#, 16#0002#),
         24683 => (16#4A8C#, 16#0020#, 16#0002#),
         24684 => (16#4A8D#, 16#0020#, 16#0002#),
         24685 => (16#4A8E#, 16#0020#, 16#0002#),
         24686 => (16#4A8F#, 16#0020#, 16#0002#),
         24687 => (16#4A90#, 16#0020#, 16#0002#),
         24688 => (16#4A91#, 16#0020#, 16#0002#),
         24689 => (16#4A92#, 16#0020#, 16#0002#),
         24690 => (16#4A93#, 16#0020#, 16#0002#),
         24691 => (16#4A94#, 16#0020#, 16#0002#),
         24692 => (16#4A95#, 16#0020#, 16#0002#),
         24693 => (16#4A96#, 16#0020#, 16#0002#),
         24694 => (16#4A97#, 16#0020#, 16#0002#),
         24695 => (16#4A98#, 16#0020#, 16#0002#),
         24696 => (16#4A99#, 16#0020#, 16#0002#),
         24697 => (16#4A9A#, 16#0020#, 16#0002#),
         24698 => (16#4A9B#, 16#0020#, 16#0002#),
         24699 => (16#4A9C#, 16#0020#, 16#0002#),
         24700 => (16#4A9D#, 16#0020#, 16#0002#),
         24701 => (16#4A9E#, 16#0020#, 16#0002#),
         24702 => (16#4A9F#, 16#0020#, 16#0002#),
         24703 => (16#4AA0#, 16#0020#, 16#0002#),
         24704 => (16#4AA1#, 16#0020#, 16#0002#),
         24705 => (16#4AA2#, 16#0020#, 16#0002#),
         24706 => (16#4AA3#, 16#0020#, 16#0002#),
         24707 => (16#4AA4#, 16#0020#, 16#0002#),
         24708 => (16#4AA5#, 16#0020#, 16#0002#),
         24709 => (16#4AA6#, 16#0020#, 16#0002#),
         24710 => (16#4AA7#, 16#0020#, 16#0002#),
         24711 => (16#4AA8#, 16#0020#, 16#0002#),
         24712 => (16#4AA9#, 16#0020#, 16#0002#),
         24713 => (16#4AAA#, 16#0020#, 16#0002#),
         24714 => (16#4AAB#, 16#0020#, 16#0002#),
         24715 => (16#4AAC#, 16#0020#, 16#0002#),
         24716 => (16#4AAD#, 16#0020#, 16#0002#),
         24717 => (16#4AAE#, 16#0020#, 16#0002#),
         24718 => (16#4AAF#, 16#0020#, 16#0002#),
         24719 => (16#4AB0#, 16#0020#, 16#0002#),
         24720 => (16#4AB1#, 16#0020#, 16#0002#),
         24721 => (16#4AB2#, 16#0020#, 16#0002#),
         24722 => (16#4AB3#, 16#0020#, 16#0002#),
         24723 => (16#4AB4#, 16#0020#, 16#0002#),
         24724 => (16#4AB5#, 16#0020#, 16#0002#),
         24725 => (16#4AB6#, 16#0020#, 16#0002#),
         24726 => (16#4AB7#, 16#0020#, 16#0002#),
         24727 => (16#4AB8#, 16#0020#, 16#0002#),
         24728 => (16#4AB9#, 16#0020#, 16#0002#),
         24729 => (16#4ABA#, 16#0020#, 16#0002#),
         24730 => (16#4ABB#, 16#0020#, 16#0002#),
         24731 => (16#4ABC#, 16#0020#, 16#0002#),
         24732 => (16#4ABD#, 16#0020#, 16#0002#),
         24733 => (16#4ABE#, 16#0020#, 16#0002#),
         24734 => (16#4ABF#, 16#0020#, 16#0002#),
         24735 => (16#4AC0#, 16#0020#, 16#0002#),
         24736 => (16#4AC1#, 16#0020#, 16#0002#),
         24737 => (16#4AC2#, 16#0020#, 16#0002#),
         24738 => (16#4AC3#, 16#0020#, 16#0002#),
         24739 => (16#4AC4#, 16#0020#, 16#0002#),
         24740 => (16#4AC5#, 16#0020#, 16#0002#),
         24741 => (16#4AC6#, 16#0020#, 16#0002#),
         24742 => (16#4AC7#, 16#0020#, 16#0002#),
         24743 => (16#4AC8#, 16#0020#, 16#0002#),
         24744 => (16#4AC9#, 16#0020#, 16#0002#),
         24745 => (16#4ACA#, 16#0020#, 16#0002#),
         24746 => (16#4ACB#, 16#0020#, 16#0002#),
         24747 => (16#4ACC#, 16#0020#, 16#0002#),
         24748 => (16#4ACD#, 16#0020#, 16#0002#),
         24749 => (16#4ACE#, 16#0020#, 16#0002#),
         24750 => (16#4ACF#, 16#0020#, 16#0002#),
         24751 => (16#4AD0#, 16#0020#, 16#0002#),
         24752 => (16#4AD1#, 16#0020#, 16#0002#),
         24753 => (16#4AD2#, 16#0020#, 16#0002#),
         24754 => (16#4AD3#, 16#0020#, 16#0002#),
         24755 => (16#4AD4#, 16#0020#, 16#0002#),
         24756 => (16#4AD5#, 16#0020#, 16#0002#),
         24757 => (16#4AD6#, 16#0020#, 16#0002#),
         24758 => (16#4AD7#, 16#0020#, 16#0002#),
         24759 => (16#4AD8#, 16#0020#, 16#0002#),
         24760 => (16#4AD9#, 16#0020#, 16#0002#),
         24761 => (16#4ADA#, 16#0020#, 16#0002#),
         24762 => (16#4ADB#, 16#0020#, 16#0002#),
         24763 => (16#4ADC#, 16#0020#, 16#0002#),
         24764 => (16#4ADD#, 16#0020#, 16#0002#),
         24765 => (16#4ADE#, 16#0020#, 16#0002#),
         24766 => (16#4ADF#, 16#0020#, 16#0002#),
         24767 => (16#4AE0#, 16#0020#, 16#0002#),
         24768 => (16#4AE1#, 16#0020#, 16#0002#),
         24769 => (16#4AE2#, 16#0020#, 16#0002#),
         24770 => (16#4AE3#, 16#0020#, 16#0002#),
         24771 => (16#4AE4#, 16#0020#, 16#0002#),
         24772 => (16#4AE5#, 16#0020#, 16#0002#),
         24773 => (16#4AE6#, 16#0020#, 16#0002#),
         24774 => (16#4AE7#, 16#0020#, 16#0002#),
         24775 => (16#4AE8#, 16#0020#, 16#0002#),
         24776 => (16#4AE9#, 16#0020#, 16#0002#),
         24777 => (16#4AEA#, 16#0020#, 16#0002#),
         24778 => (16#4AEB#, 16#0020#, 16#0002#),
         24779 => (16#4AEC#, 16#0020#, 16#0002#),
         24780 => (16#4AED#, 16#0020#, 16#0002#),
         24781 => (16#4AEE#, 16#0020#, 16#0002#),
         24782 => (16#4AEF#, 16#0020#, 16#0002#),
         24783 => (16#4AF0#, 16#0020#, 16#0002#),
         24784 => (16#4AF1#, 16#0020#, 16#0002#),
         24785 => (16#4AF2#, 16#0020#, 16#0002#),
         24786 => (16#4AF3#, 16#0020#, 16#0002#),
         24787 => (16#4AF4#, 16#0020#, 16#0002#),
         24788 => (16#4AF5#, 16#0020#, 16#0002#),
         24789 => (16#4AF6#, 16#0020#, 16#0002#),
         24790 => (16#4AF7#, 16#0020#, 16#0002#),
         24791 => (16#4AF8#, 16#0020#, 16#0002#),
         24792 => (16#4AF9#, 16#0020#, 16#0002#),
         24793 => (16#4AFA#, 16#0020#, 16#0002#),
         24794 => (16#4AFB#, 16#0020#, 16#0002#),
         24795 => (16#4AFC#, 16#0020#, 16#0002#),
         24796 => (16#4AFD#, 16#0020#, 16#0002#),
         24797 => (16#4AFE#, 16#0020#, 16#0002#),
         24798 => (16#4AFF#, 16#0020#, 16#0002#),
         24799 => (16#4B00#, 16#0020#, 16#0002#),
         24800 => (16#4B01#, 16#0020#, 16#0002#),
         24801 => (16#4B02#, 16#0020#, 16#0002#),
         24802 => (16#4B03#, 16#0020#, 16#0002#),
         24803 => (16#4B04#, 16#0020#, 16#0002#),
         24804 => (16#4B05#, 16#0020#, 16#0002#),
         24805 => (16#4B06#, 16#0020#, 16#0002#),
         24806 => (16#4B07#, 16#0020#, 16#0002#),
         24807 => (16#4B08#, 16#0020#, 16#0002#),
         24808 => (16#4B09#, 16#0020#, 16#0002#),
         24809 => (16#4B0A#, 16#0020#, 16#0002#),
         24810 => (16#4B0B#, 16#0020#, 16#0002#),
         24811 => (16#4B0C#, 16#0020#, 16#0002#),
         24812 => (16#4B0D#, 16#0020#, 16#0002#),
         24813 => (16#4B0E#, 16#0020#, 16#0002#),
         24814 => (16#4B0F#, 16#0020#, 16#0002#),
         24815 => (16#4B10#, 16#0020#, 16#0002#),
         24816 => (16#4B11#, 16#0020#, 16#0002#),
         24817 => (16#4B12#, 16#0020#, 16#0002#),
         24818 => (16#4B13#, 16#0020#, 16#0002#),
         24819 => (16#4B14#, 16#0020#, 16#0002#),
         24820 => (16#4B15#, 16#0020#, 16#0002#),
         24821 => (16#4B16#, 16#0020#, 16#0002#),
         24822 => (16#4B17#, 16#0020#, 16#0002#),
         24823 => (16#4B18#, 16#0020#, 16#0002#),
         24824 => (16#4B19#, 16#0020#, 16#0002#),
         24825 => (16#4B1A#, 16#0020#, 16#0002#),
         24826 => (16#4B1B#, 16#0020#, 16#0002#),
         24827 => (16#4B1C#, 16#0020#, 16#0002#),
         24828 => (16#4B1D#, 16#0020#, 16#0002#),
         24829 => (16#4B1E#, 16#0020#, 16#0002#),
         24830 => (16#4B1F#, 16#0020#, 16#0002#),
         24831 => (16#4B20#, 16#0020#, 16#0002#),
         24832 => (16#4B21#, 16#0020#, 16#0002#),
         24833 => (16#4B22#, 16#0020#, 16#0002#),
         24834 => (16#4B23#, 16#0020#, 16#0002#),
         24835 => (16#4B24#, 16#0020#, 16#0002#),
         24836 => (16#4B25#, 16#0020#, 16#0002#),
         24837 => (16#4B26#, 16#0020#, 16#0002#),
         24838 => (16#4B27#, 16#0020#, 16#0002#),
         24839 => (16#4B28#, 16#0020#, 16#0002#),
         24840 => (16#4B29#, 16#0020#, 16#0002#),
         24841 => (16#4B2A#, 16#0020#, 16#0002#),
         24842 => (16#4B2B#, 16#0020#, 16#0002#),
         24843 => (16#4B2C#, 16#0020#, 16#0002#),
         24844 => (16#4B2D#, 16#0020#, 16#0002#),
         24845 => (16#4B2E#, 16#0020#, 16#0002#),
         24846 => (16#4B2F#, 16#0020#, 16#0002#),
         24847 => (16#4B30#, 16#0020#, 16#0002#),
         24848 => (16#4B31#, 16#0020#, 16#0002#),
         24849 => (16#4B32#, 16#0020#, 16#0002#),
         24850 => (16#4B33#, 16#0020#, 16#0002#),
         24851 => (16#4B34#, 16#0020#, 16#0002#),
         24852 => (16#4B35#, 16#0020#, 16#0002#),
         24853 => (16#4B36#, 16#0020#, 16#0002#),
         24854 => (16#4B37#, 16#0020#, 16#0002#),
         24855 => (16#4B38#, 16#0020#, 16#0002#),
         24856 => (16#4B39#, 16#0020#, 16#0002#),
         24857 => (16#4B3A#, 16#0020#, 16#0002#),
         24858 => (16#4B3B#, 16#0020#, 16#0002#),
         24859 => (16#4B3C#, 16#0020#, 16#0002#),
         24860 => (16#4B3D#, 16#0020#, 16#0002#),
         24861 => (16#4B3E#, 16#0020#, 16#0002#),
         24862 => (16#4B3F#, 16#0020#, 16#0002#),
         24863 => (16#4B40#, 16#0020#, 16#0002#),
         24864 => (16#4B41#, 16#0020#, 16#0002#),
         24865 => (16#4B42#, 16#0020#, 16#0002#),
         24866 => (16#4B43#, 16#0020#, 16#0002#),
         24867 => (16#4B44#, 16#0020#, 16#0002#),
         24868 => (16#4B45#, 16#0020#, 16#0002#),
         24869 => (16#4B46#, 16#0020#, 16#0002#),
         24870 => (16#4B47#, 16#0020#, 16#0002#),
         24871 => (16#4B48#, 16#0020#, 16#0002#),
         24872 => (16#4B49#, 16#0020#, 16#0002#),
         24873 => (16#4B4A#, 16#0020#, 16#0002#),
         24874 => (16#4B4B#, 16#0020#, 16#0002#),
         24875 => (16#4B4C#, 16#0020#, 16#0002#),
         24876 => (16#4B4D#, 16#0020#, 16#0002#),
         24877 => (16#4B4E#, 16#0020#, 16#0002#),
         24878 => (16#4B4F#, 16#0020#, 16#0002#),
         24879 => (16#4B50#, 16#0020#, 16#0002#),
         24880 => (16#4B51#, 16#0020#, 16#0002#),
         24881 => (16#4B52#, 16#0020#, 16#0002#),
         24882 => (16#4B53#, 16#0020#, 16#0002#),
         24883 => (16#4B54#, 16#0020#, 16#0002#),
         24884 => (16#4B55#, 16#0020#, 16#0002#),
         24885 => (16#4B56#, 16#0020#, 16#0002#),
         24886 => (16#4B57#, 16#0020#, 16#0002#),
         24887 => (16#4B58#, 16#0020#, 16#0002#),
         24888 => (16#4B59#, 16#0020#, 16#0002#),
         24889 => (16#4B5A#, 16#0020#, 16#0002#),
         24890 => (16#4B5B#, 16#0020#, 16#0002#),
         24891 => (16#4B5C#, 16#0020#, 16#0002#),
         24892 => (16#4B5D#, 16#0020#, 16#0002#),
         24893 => (16#4B5E#, 16#0020#, 16#0002#),
         24894 => (16#4B5F#, 16#0020#, 16#0002#),
         24895 => (16#4B60#, 16#0020#, 16#0002#),
         24896 => (16#4B61#, 16#0020#, 16#0002#),
         24897 => (16#4B62#, 16#0020#, 16#0002#),
         24898 => (16#4B63#, 16#0020#, 16#0002#),
         24899 => (16#4B64#, 16#0020#, 16#0002#),
         24900 => (16#4B65#, 16#0020#, 16#0002#),
         24901 => (16#4B66#, 16#0020#, 16#0002#),
         24902 => (16#4B67#, 16#0020#, 16#0002#),
         24903 => (16#4B68#, 16#0020#, 16#0002#),
         24904 => (16#4B69#, 16#0020#, 16#0002#),
         24905 => (16#4B6A#, 16#0020#, 16#0002#),
         24906 => (16#4B6B#, 16#0020#, 16#0002#),
         24907 => (16#4B6C#, 16#0020#, 16#0002#),
         24908 => (16#4B6D#, 16#0020#, 16#0002#),
         24909 => (16#4B6E#, 16#0020#, 16#0002#),
         24910 => (16#4B6F#, 16#0020#, 16#0002#),
         24911 => (16#4B70#, 16#0020#, 16#0002#),
         24912 => (16#4B71#, 16#0020#, 16#0002#),
         24913 => (16#4B72#, 16#0020#, 16#0002#),
         24914 => (16#4B73#, 16#0020#, 16#0002#),
         24915 => (16#4B74#, 16#0020#, 16#0002#),
         24916 => (16#4B75#, 16#0020#, 16#0002#),
         24917 => (16#4B76#, 16#0020#, 16#0002#),
         24918 => (16#4B77#, 16#0020#, 16#0002#),
         24919 => (16#4B78#, 16#0020#, 16#0002#),
         24920 => (16#4B79#, 16#0020#, 16#0002#),
         24921 => (16#4B7A#, 16#0020#, 16#0002#),
         24922 => (16#4B7B#, 16#0020#, 16#0002#),
         24923 => (16#4B7C#, 16#0020#, 16#0002#),
         24924 => (16#4B7D#, 16#0020#, 16#0002#),
         24925 => (16#4B7E#, 16#0020#, 16#0002#),
         24926 => (16#4B7F#, 16#0020#, 16#0002#),
         24927 => (16#4B80#, 16#0020#, 16#0002#),
         24928 => (16#4B81#, 16#0020#, 16#0002#),
         24929 => (16#4B82#, 16#0020#, 16#0002#),
         24930 => (16#4B83#, 16#0020#, 16#0002#),
         24931 => (16#4B84#, 16#0020#, 16#0002#),
         24932 => (16#4B85#, 16#0020#, 16#0002#),
         24933 => (16#4B86#, 16#0020#, 16#0002#),
         24934 => (16#4B87#, 16#0020#, 16#0002#),
         24935 => (16#4B88#, 16#0020#, 16#0002#),
         24936 => (16#4B89#, 16#0020#, 16#0002#),
         24937 => (16#4B8A#, 16#0020#, 16#0002#),
         24938 => (16#4B8B#, 16#0020#, 16#0002#),
         24939 => (16#4B8C#, 16#0020#, 16#0002#),
         24940 => (16#4B8D#, 16#0020#, 16#0002#),
         24941 => (16#4B8E#, 16#0020#, 16#0002#),
         24942 => (16#4B8F#, 16#0020#, 16#0002#),
         24943 => (16#4B90#, 16#0020#, 16#0002#),
         24944 => (16#4B91#, 16#0020#, 16#0002#),
         24945 => (16#4B92#, 16#0020#, 16#0002#),
         24946 => (16#4B93#, 16#0020#, 16#0002#),
         24947 => (16#4B94#, 16#0020#, 16#0002#),
         24948 => (16#4B95#, 16#0020#, 16#0002#),
         24949 => (16#4B96#, 16#0020#, 16#0002#),
         24950 => (16#4B97#, 16#0020#, 16#0002#),
         24951 => (16#4B98#, 16#0020#, 16#0002#),
         24952 => (16#4B99#, 16#0020#, 16#0002#),
         24953 => (16#4B9A#, 16#0020#, 16#0002#),
         24954 => (16#4B9B#, 16#0020#, 16#0002#),
         24955 => (16#4B9C#, 16#0020#, 16#0002#),
         24956 => (16#4B9D#, 16#0020#, 16#0002#),
         24957 => (16#4B9E#, 16#0020#, 16#0002#),
         24958 => (16#4B9F#, 16#0020#, 16#0002#),
         24959 => (16#4BA0#, 16#0020#, 16#0002#),
         24960 => (16#4BA1#, 16#0020#, 16#0002#),
         24961 => (16#4BA2#, 16#0020#, 16#0002#),
         24962 => (16#4BA3#, 16#0020#, 16#0002#),
         24963 => (16#4BA4#, 16#0020#, 16#0002#),
         24964 => (16#4BA5#, 16#0020#, 16#0002#),
         24965 => (16#4BA6#, 16#0020#, 16#0002#),
         24966 => (16#4BA7#, 16#0020#, 16#0002#),
         24967 => (16#4BA8#, 16#0020#, 16#0002#),
         24968 => (16#4BA9#, 16#0020#, 16#0002#),
         24969 => (16#4BAA#, 16#0020#, 16#0002#),
         24970 => (16#4BAB#, 16#0020#, 16#0002#),
         24971 => (16#4BAC#, 16#0020#, 16#0002#),
         24972 => (16#4BAD#, 16#0020#, 16#0002#),
         24973 => (16#4BAE#, 16#0020#, 16#0002#),
         24974 => (16#4BAF#, 16#0020#, 16#0002#),
         24975 => (16#4BB0#, 16#0020#, 16#0002#),
         24976 => (16#4BB1#, 16#0020#, 16#0002#),
         24977 => (16#4BB2#, 16#0020#, 16#0002#),
         24978 => (16#4BB3#, 16#0020#, 16#0002#),
         24979 => (16#4BB4#, 16#0020#, 16#0002#),
         24980 => (16#4BB5#, 16#0020#, 16#0002#),
         24981 => (16#4BB6#, 16#0020#, 16#0002#),
         24982 => (16#4BB7#, 16#0020#, 16#0002#),
         24983 => (16#4BB8#, 16#0020#, 16#0002#),
         24984 => (16#4BB9#, 16#0020#, 16#0002#),
         24985 => (16#4BBA#, 16#0020#, 16#0002#),
         24986 => (16#4BBB#, 16#0020#, 16#0002#),
         24987 => (16#4BBC#, 16#0020#, 16#0002#),
         24988 => (16#4BBD#, 16#0020#, 16#0002#),
         24989 => (16#4BBE#, 16#0020#, 16#0002#),
         24990 => (16#4BBF#, 16#0020#, 16#0002#),
         24991 => (16#4BC0#, 16#0020#, 16#0002#),
         24992 => (16#4BC1#, 16#0020#, 16#0002#),
         24993 => (16#4BC2#, 16#0020#, 16#0002#),
         24994 => (16#4BC3#, 16#0020#, 16#0002#),
         24995 => (16#4BC4#, 16#0020#, 16#0002#),
         24996 => (16#4BC5#, 16#0020#, 16#0002#),
         24997 => (16#4BC6#, 16#0020#, 16#0002#),
         24998 => (16#4BC7#, 16#0020#, 16#0002#),
         24999 => (16#4BC8#, 16#0020#, 16#0002#),
         25000 => (16#4BC9#, 16#0020#, 16#0002#),
         25001 => (16#4BCA#, 16#0020#, 16#0002#),
         25002 => (16#4BCB#, 16#0020#, 16#0002#),
         25003 => (16#4BCC#, 16#0020#, 16#0002#),
         25004 => (16#4BCD#, 16#0020#, 16#0002#),
         25005 => (16#4BCE#, 16#0020#, 16#0002#),
         25006 => (16#4BCF#, 16#0020#, 16#0002#),
         25007 => (16#4BD0#, 16#0020#, 16#0002#),
         25008 => (16#4BD1#, 16#0020#, 16#0002#),
         25009 => (16#4BD2#, 16#0020#, 16#0002#),
         25010 => (16#4BD3#, 16#0020#, 16#0002#),
         25011 => (16#4BD4#, 16#0020#, 16#0002#),
         25012 => (16#4BD5#, 16#0020#, 16#0002#),
         25013 => (16#4BD6#, 16#0020#, 16#0002#),
         25014 => (16#4BD7#, 16#0020#, 16#0002#),
         25015 => (16#4BD8#, 16#0020#, 16#0002#),
         25016 => (16#4BD9#, 16#0020#, 16#0002#),
         25017 => (16#4BDA#, 16#0020#, 16#0002#),
         25018 => (16#4BDB#, 16#0020#, 16#0002#),
         25019 => (16#4BDC#, 16#0020#, 16#0002#),
         25020 => (16#4BDD#, 16#0020#, 16#0002#),
         25021 => (16#4BDE#, 16#0020#, 16#0002#),
         25022 => (16#4BDF#, 16#0020#, 16#0002#),
         25023 => (16#4BE0#, 16#0020#, 16#0002#),
         25024 => (16#4BE1#, 16#0020#, 16#0002#),
         25025 => (16#4BE2#, 16#0020#, 16#0002#),
         25026 => (16#4BE3#, 16#0020#, 16#0002#),
         25027 => (16#4BE4#, 16#0020#, 16#0002#),
         25028 => (16#4BE5#, 16#0020#, 16#0002#),
         25029 => (16#4BE6#, 16#0020#, 16#0002#),
         25030 => (16#4BE7#, 16#0020#, 16#0002#),
         25031 => (16#4BE8#, 16#0020#, 16#0002#),
         25032 => (16#4BE9#, 16#0020#, 16#0002#),
         25033 => (16#4BEA#, 16#0020#, 16#0002#),
         25034 => (16#4BEB#, 16#0020#, 16#0002#),
         25035 => (16#4BEC#, 16#0020#, 16#0002#),
         25036 => (16#4BED#, 16#0020#, 16#0002#),
         25037 => (16#4BEE#, 16#0020#, 16#0002#),
         25038 => (16#4BEF#, 16#0020#, 16#0002#),
         25039 => (16#4BF0#, 16#0020#, 16#0002#),
         25040 => (16#4BF1#, 16#0020#, 16#0002#),
         25041 => (16#4BF2#, 16#0020#, 16#0002#),
         25042 => (16#4BF3#, 16#0020#, 16#0002#),
         25043 => (16#4BF4#, 16#0020#, 16#0002#),
         25044 => (16#4BF5#, 16#0020#, 16#0002#),
         25045 => (16#4BF6#, 16#0020#, 16#0002#),
         25046 => (16#4BF7#, 16#0020#, 16#0002#),
         25047 => (16#4BF8#, 16#0020#, 16#0002#),
         25048 => (16#4BF9#, 16#0020#, 16#0002#),
         25049 => (16#4BFA#, 16#0020#, 16#0002#),
         25050 => (16#4BFB#, 16#0020#, 16#0002#),
         25051 => (16#4BFC#, 16#0020#, 16#0002#),
         25052 => (16#4BFD#, 16#0020#, 16#0002#),
         25053 => (16#4BFE#, 16#0020#, 16#0002#),
         25054 => (16#4BFF#, 16#0020#, 16#0002#),
         25055 => (16#4C00#, 16#0020#, 16#0002#),
         25056 => (16#4C01#, 16#0020#, 16#0002#),
         25057 => (16#4C02#, 16#0020#, 16#0002#),
         25058 => (16#4C03#, 16#0020#, 16#0002#),
         25059 => (16#4C04#, 16#0020#, 16#0002#),
         25060 => (16#4C05#, 16#0020#, 16#0002#),
         25061 => (16#4C06#, 16#0020#, 16#0002#),
         25062 => (16#4C07#, 16#0020#, 16#0002#),
         25063 => (16#4C08#, 16#0020#, 16#0002#),
         25064 => (16#4C09#, 16#0020#, 16#0002#),
         25065 => (16#4C0A#, 16#0020#, 16#0002#),
         25066 => (16#4C0B#, 16#0020#, 16#0002#),
         25067 => (16#4C0C#, 16#0020#, 16#0002#),
         25068 => (16#4C0D#, 16#0020#, 16#0002#),
         25069 => (16#4C0E#, 16#0020#, 16#0002#),
         25070 => (16#4C0F#, 16#0020#, 16#0002#),
         25071 => (16#4C10#, 16#0020#, 16#0002#),
         25072 => (16#4C11#, 16#0020#, 16#0002#),
         25073 => (16#4C12#, 16#0020#, 16#0002#),
         25074 => (16#4C13#, 16#0020#, 16#0002#),
         25075 => (16#4C14#, 16#0020#, 16#0002#),
         25076 => (16#4C15#, 16#0020#, 16#0002#),
         25077 => (16#4C16#, 16#0020#, 16#0002#),
         25078 => (16#4C17#, 16#0020#, 16#0002#),
         25079 => (16#4C18#, 16#0020#, 16#0002#),
         25080 => (16#4C19#, 16#0020#, 16#0002#),
         25081 => (16#4C1A#, 16#0020#, 16#0002#),
         25082 => (16#4C1B#, 16#0020#, 16#0002#),
         25083 => (16#4C1C#, 16#0020#, 16#0002#),
         25084 => (16#4C1D#, 16#0020#, 16#0002#),
         25085 => (16#4C1E#, 16#0020#, 16#0002#),
         25086 => (16#4C1F#, 16#0020#, 16#0002#),
         25087 => (16#4C20#, 16#0020#, 16#0002#),
         25088 => (16#4C21#, 16#0020#, 16#0002#),
         25089 => (16#4C22#, 16#0020#, 16#0002#),
         25090 => (16#4C23#, 16#0020#, 16#0002#),
         25091 => (16#4C24#, 16#0020#, 16#0002#),
         25092 => (16#4C25#, 16#0020#, 16#0002#),
         25093 => (16#4C26#, 16#0020#, 16#0002#),
         25094 => (16#4C27#, 16#0020#, 16#0002#),
         25095 => (16#4C28#, 16#0020#, 16#0002#),
         25096 => (16#4C29#, 16#0020#, 16#0002#),
         25097 => (16#4C2A#, 16#0020#, 16#0002#),
         25098 => (16#4C2B#, 16#0020#, 16#0002#),
         25099 => (16#4C2C#, 16#0020#, 16#0002#),
         25100 => (16#4C2D#, 16#0020#, 16#0002#),
         25101 => (16#4C2E#, 16#0020#, 16#0002#),
         25102 => (16#4C2F#, 16#0020#, 16#0002#),
         25103 => (16#4C30#, 16#0020#, 16#0002#),
         25104 => (16#4C31#, 16#0020#, 16#0002#),
         25105 => (16#4C32#, 16#0020#, 16#0002#),
         25106 => (16#4C33#, 16#0020#, 16#0002#),
         25107 => (16#4C34#, 16#0020#, 16#0002#),
         25108 => (16#4C35#, 16#0020#, 16#0002#),
         25109 => (16#4C36#, 16#0020#, 16#0002#),
         25110 => (16#4C37#, 16#0020#, 16#0002#),
         25111 => (16#4C38#, 16#0020#, 16#0002#),
         25112 => (16#4C39#, 16#0020#, 16#0002#),
         25113 => (16#4C3A#, 16#0020#, 16#0002#),
         25114 => (16#4C3B#, 16#0020#, 16#0002#),
         25115 => (16#4C3C#, 16#0020#, 16#0002#),
         25116 => (16#4C3D#, 16#0020#, 16#0002#),
         25117 => (16#4C3E#, 16#0020#, 16#0002#),
         25118 => (16#4C3F#, 16#0020#, 16#0002#),
         25119 => (16#4C40#, 16#0020#, 16#0002#),
         25120 => (16#4C41#, 16#0020#, 16#0002#),
         25121 => (16#4C42#, 16#0020#, 16#0002#),
         25122 => (16#4C43#, 16#0020#, 16#0002#),
         25123 => (16#4C44#, 16#0020#, 16#0002#),
         25124 => (16#4C45#, 16#0020#, 16#0002#),
         25125 => (16#4C46#, 16#0020#, 16#0002#),
         25126 => (16#4C47#, 16#0020#, 16#0002#),
         25127 => (16#4C48#, 16#0020#, 16#0002#),
         25128 => (16#4C49#, 16#0020#, 16#0002#),
         25129 => (16#4C4A#, 16#0020#, 16#0002#),
         25130 => (16#4C4B#, 16#0020#, 16#0002#),
         25131 => (16#4C4C#, 16#0020#, 16#0002#),
         25132 => (16#4C4D#, 16#0020#, 16#0002#),
         25133 => (16#4C4E#, 16#0020#, 16#0002#),
         25134 => (16#4C4F#, 16#0020#, 16#0002#),
         25135 => (16#4C50#, 16#0020#, 16#0002#),
         25136 => (16#4C51#, 16#0020#, 16#0002#),
         25137 => (16#4C52#, 16#0020#, 16#0002#),
         25138 => (16#4C53#, 16#0020#, 16#0002#),
         25139 => (16#4C54#, 16#0020#, 16#0002#),
         25140 => (16#4C55#, 16#0020#, 16#0002#),
         25141 => (16#4C56#, 16#0020#, 16#0002#),
         25142 => (16#4C57#, 16#0020#, 16#0002#),
         25143 => (16#4C58#, 16#0020#, 16#0002#),
         25144 => (16#4C59#, 16#0020#, 16#0002#),
         25145 => (16#4C5A#, 16#0020#, 16#0002#),
         25146 => (16#4C5B#, 16#0020#, 16#0002#),
         25147 => (16#4C5C#, 16#0020#, 16#0002#),
         25148 => (16#4C5D#, 16#0020#, 16#0002#),
         25149 => (16#4C5E#, 16#0020#, 16#0002#),
         25150 => (16#4C5F#, 16#0020#, 16#0002#),
         25151 => (16#4C60#, 16#0020#, 16#0002#),
         25152 => (16#4C61#, 16#0020#, 16#0002#),
         25153 => (16#4C62#, 16#0020#, 16#0002#),
         25154 => (16#4C63#, 16#0020#, 16#0002#),
         25155 => (16#4C64#, 16#0020#, 16#0002#),
         25156 => (16#4C65#, 16#0020#, 16#0002#),
         25157 => (16#4C66#, 16#0020#, 16#0002#),
         25158 => (16#4C67#, 16#0020#, 16#0002#),
         25159 => (16#4C68#, 16#0020#, 16#0002#),
         25160 => (16#4C69#, 16#0020#, 16#0002#),
         25161 => (16#4C6A#, 16#0020#, 16#0002#),
         25162 => (16#4C6B#, 16#0020#, 16#0002#),
         25163 => (16#4C6C#, 16#0020#, 16#0002#),
         25164 => (16#4C6D#, 16#0020#, 16#0002#),
         25165 => (16#4C6E#, 16#0020#, 16#0002#),
         25166 => (16#4C6F#, 16#0020#, 16#0002#),
         25167 => (16#4C70#, 16#0020#, 16#0002#),
         25168 => (16#4C71#, 16#0020#, 16#0002#),
         25169 => (16#4C72#, 16#0020#, 16#0002#),
         25170 => (16#4C73#, 16#0020#, 16#0002#),
         25171 => (16#4C74#, 16#0020#, 16#0002#),
         25172 => (16#4C75#, 16#0020#, 16#0002#),
         25173 => (16#4C76#, 16#0020#, 16#0002#),
         25174 => (16#4C77#, 16#0020#, 16#0002#),
         25175 => (16#4C78#, 16#0020#, 16#0002#),
         25176 => (16#4C79#, 16#0020#, 16#0002#),
         25177 => (16#4C7A#, 16#0020#, 16#0002#),
         25178 => (16#4C7B#, 16#0020#, 16#0002#),
         25179 => (16#4C7C#, 16#0020#, 16#0002#),
         25180 => (16#4C7D#, 16#0020#, 16#0002#),
         25181 => (16#4C7E#, 16#0020#, 16#0002#),
         25182 => (16#4C7F#, 16#0020#, 16#0002#),
         25183 => (16#4C80#, 16#0020#, 16#0002#),
         25184 => (16#4C81#, 16#0020#, 16#0002#),
         25185 => (16#4C82#, 16#0020#, 16#0002#),
         25186 => (16#4C83#, 16#0020#, 16#0002#),
         25187 => (16#4C84#, 16#0020#, 16#0002#),
         25188 => (16#4C85#, 16#0020#, 16#0002#),
         25189 => (16#4C86#, 16#0020#, 16#0002#),
         25190 => (16#4C87#, 16#0020#, 16#0002#),
         25191 => (16#4C88#, 16#0020#, 16#0002#),
         25192 => (16#4C89#, 16#0020#, 16#0002#),
         25193 => (16#4C8A#, 16#0020#, 16#0002#),
         25194 => (16#4C8B#, 16#0020#, 16#0002#),
         25195 => (16#4C8C#, 16#0020#, 16#0002#),
         25196 => (16#4C8D#, 16#0020#, 16#0002#),
         25197 => (16#4C8E#, 16#0020#, 16#0002#),
         25198 => (16#4C8F#, 16#0020#, 16#0002#),
         25199 => (16#4C90#, 16#0020#, 16#0002#),
         25200 => (16#4C91#, 16#0020#, 16#0002#),
         25201 => (16#4C92#, 16#0020#, 16#0002#),
         25202 => (16#4C93#, 16#0020#, 16#0002#),
         25203 => (16#4C94#, 16#0020#, 16#0002#),
         25204 => (16#4C95#, 16#0020#, 16#0002#),
         25205 => (16#3407#, 16#0020#, 16#0002#),
         25206 => (16#3408#, 16#0020#, 16#0002#),
         25207 => (16#3409#, 16#0020#, 16#0002#),
         25208 => (16#340A#, 16#0020#, 16#0002#),
         25209 => (16#340B#, 16#0020#, 16#0002#),
         25210 => (16#340C#, 16#0020#, 16#0002#),
         25211 => (16#340D#, 16#0020#, 16#0002#),
         25212 => (16#340E#, 16#0020#, 16#0002#),
         25213 => (16#340F#, 16#0020#, 16#0002#),
         25214 => (16#3410#, 16#0020#, 16#0002#),
         25215 => (16#3411#, 16#0020#, 16#0002#),
         25216 => (16#3412#, 16#0020#, 16#0002#),
         25217 => (16#3413#, 16#0020#, 16#0002#),
         25218 => (16#3414#, 16#0020#, 16#0002#),
         25219 => (16#3415#, 16#0020#, 16#0002#),
         25220 => (16#3416#, 16#0020#, 16#0002#),
         25221 => (16#3417#, 16#0020#, 16#0002#),
         25222 => (16#3418#, 16#0020#, 16#0002#),
         25223 => (16#3419#, 16#0020#, 16#0002#),
         25224 => (16#341A#, 16#0020#, 16#0002#),
         25225 => (16#341B#, 16#0020#, 16#0002#),
         25226 => (16#341C#, 16#0020#, 16#0002#),
         25227 => (16#341D#, 16#0020#, 16#0002#),
         25228 => (16#341E#, 16#0020#, 16#0002#),
         25229 => (16#341F#, 16#0020#, 16#0002#),
         25230 => (16#3420#, 16#0020#, 16#0002#),
         25231 => (16#3421#, 16#0020#, 16#0002#),
         25232 => (16#3422#, 16#0020#, 16#0002#),
         25233 => (16#3423#, 16#0020#, 16#0002#),
         25234 => (16#3424#, 16#0020#, 16#0002#),
         25235 => (16#3425#, 16#0020#, 16#0002#),
         25236 => (16#3426#, 16#0020#, 16#0002#),
         25237 => (16#3427#, 16#0020#, 16#0002#),
         25238 => (16#3428#, 16#0020#, 16#0002#),
         25239 => (16#3429#, 16#0020#, 16#0002#),
         25240 => (16#342A#, 16#0020#, 16#0002#),
         25241 => (16#342B#, 16#0020#, 16#0002#),
         25242 => (16#342C#, 16#0020#, 16#0002#),
         25243 => (16#342D#, 16#0020#, 16#0002#),
         25244 => (16#342E#, 16#0020#, 16#0002#),
         25245 => (16#342F#, 16#0020#, 16#0002#),
         25246 => (16#3430#, 16#0020#, 16#0002#),
         25247 => (16#3431#, 16#0020#, 16#0002#),
         25248 => (16#3432#, 16#0020#, 16#0002#),
         25249 => (16#3433#, 16#0020#, 16#0002#),
         25250 => (16#3434#, 16#0020#, 16#0002#),
         25251 => (16#3435#, 16#0020#, 16#0002#),
         25252 => (16#3436#, 16#0020#, 16#0002#),
         25253 => (16#3437#, 16#0020#, 16#0002#),
         25254 => (16#3438#, 16#0020#, 16#0002#),
         25255 => (16#3439#, 16#0020#, 16#0002#),
         25256 => (16#343A#, 16#0020#, 16#0002#),
         25257 => (16#343B#, 16#0020#, 16#0002#),
         25258 => (16#343C#, 16#0020#, 16#0002#),
         25259 => (16#343D#, 16#0020#, 16#0002#),
         25260 => (16#343E#, 16#0020#, 16#0002#),
         25261 => (16#343F#, 16#0020#, 16#0002#),
         25262 => (16#3440#, 16#0020#, 16#0002#),
         25263 => (16#3441#, 16#0020#, 16#0002#),
         25264 => (16#3442#, 16#0020#, 16#0002#),
         25265 => (16#3443#, 16#0020#, 16#0002#),
         25266 => (16#3444#, 16#0020#, 16#0002#),
         25267 => (16#3445#, 16#0020#, 16#0002#),
         25268 => (16#3446#, 16#0020#, 16#0002#),
         25269 => (16#3447#, 16#0020#, 16#0002#),
         25270 => (16#3448#, 16#0020#, 16#0002#),
         25271 => (16#3449#, 16#0020#, 16#0002#),
         25272 => (16#344A#, 16#0020#, 16#0002#),
         25273 => (16#344B#, 16#0020#, 16#0002#),
         25274 => (16#344C#, 16#0020#, 16#0002#),
         25275 => (16#344D#, 16#0020#, 16#0002#),
         25276 => (16#344E#, 16#0020#, 16#0002#),
         25277 => (16#344F#, 16#0020#, 16#0002#),
         25278 => (16#3450#, 16#0020#, 16#0002#),
         25279 => (16#3451#, 16#0020#, 16#0002#),
         25280 => (16#3452#, 16#0020#, 16#0002#),
         25281 => (16#3453#, 16#0020#, 16#0002#),
         25282 => (16#3454#, 16#0020#, 16#0002#),
         25283 => (16#3455#, 16#0020#, 16#0002#),
         25284 => (16#3456#, 16#0020#, 16#0002#),
         25285 => (16#3457#, 16#0020#, 16#0002#),
         25286 => (16#3458#, 16#0020#, 16#0002#),
         25287 => (16#3459#, 16#0020#, 16#0002#),
         25288 => (16#345A#, 16#0020#, 16#0002#),
         25289 => (16#345B#, 16#0020#, 16#0002#),
         25290 => (16#345C#, 16#0020#, 16#0002#),
         25291 => (16#345D#, 16#0020#, 16#0002#),
         25292 => (16#345E#, 16#0020#, 16#0002#),
         25293 => (16#345F#, 16#0020#, 16#0002#),
         25294 => (16#3460#, 16#0020#, 16#0002#),
         25295 => (16#3461#, 16#0020#, 16#0002#),
         25296 => (16#3462#, 16#0020#, 16#0002#),
         25297 => (16#3463#, 16#0020#, 16#0002#),
         25298 => (16#3464#, 16#0020#, 16#0002#),
         25299 => (16#3465#, 16#0020#, 16#0002#),
         25300 => (16#3466#, 16#0020#, 16#0002#),
         25301 => (16#3467#, 16#0020#, 16#0002#),
         25302 => (16#3468#, 16#0020#, 16#0002#),
         25303 => (16#3469#, 16#0020#, 16#0002#),
         25304 => (16#346A#, 16#0020#, 16#0002#),
         25305 => (16#346B#, 16#0020#, 16#0002#),
         25306 => (16#346C#, 16#0020#, 16#0002#),
         25307 => (16#346D#, 16#0020#, 16#0002#),
         25308 => (16#346E#, 16#0020#, 16#0002#),
         25309 => (16#346F#, 16#0020#, 16#0002#),
         25310 => (16#3470#, 16#0020#, 16#0002#),
         25311 => (16#3471#, 16#0020#, 16#0002#),
         25312 => (16#3472#, 16#0020#, 16#0002#),
         25313 => (16#3473#, 16#0020#, 16#0002#),
         25314 => (16#3474#, 16#0020#, 16#0002#),
         25315 => (16#3475#, 16#0020#, 16#0002#),
         25316 => (16#3476#, 16#0020#, 16#0002#),
         25317 => (16#3477#, 16#0020#, 16#0002#),
         25318 => (16#3478#, 16#0020#, 16#0002#),
         25319 => (16#3479#, 16#0020#, 16#0002#),
         25320 => (16#347A#, 16#0020#, 16#0002#),
         25321 => (16#347B#, 16#0020#, 16#0002#),
         25322 => (16#347C#, 16#0020#, 16#0002#),
         25323 => (16#347D#, 16#0020#, 16#0002#),
         25324 => (16#347E#, 16#0020#, 16#0002#),
         25325 => (16#347F#, 16#0020#, 16#0002#),
         25326 => (16#3480#, 16#0020#, 16#0002#),
         25327 => (16#3481#, 16#0020#, 16#0002#),
         25328 => (16#3482#, 16#0020#, 16#0002#),
         25329 => (16#3483#, 16#0020#, 16#0002#),
         25330 => (16#3484#, 16#0020#, 16#0002#),
         25331 => (16#3485#, 16#0020#, 16#0002#),
         25332 => (16#3486#, 16#0020#, 16#0002#),
         25333 => (16#3487#, 16#0020#, 16#0002#),
         25334 => (16#3488#, 16#0020#, 16#0002#),
         25335 => (16#3489#, 16#0020#, 16#0002#),
         25336 => (16#348A#, 16#0020#, 16#0002#),
         25337 => (16#348B#, 16#0020#, 16#0002#),
         25338 => (16#348C#, 16#0020#, 16#0002#),
         25339 => (16#348D#, 16#0020#, 16#0002#),
         25340 => (16#348E#, 16#0020#, 16#0002#),
         25341 => (16#348F#, 16#0020#, 16#0002#),
         25342 => (16#3490#, 16#0020#, 16#0002#),
         25343 => (16#3491#, 16#0020#, 16#0002#),
         25344 => (16#3492#, 16#0020#, 16#0002#),
         25345 => (16#3493#, 16#0020#, 16#0002#),
         25346 => (16#3494#, 16#0020#, 16#0002#),
         25347 => (16#3495#, 16#0020#, 16#0002#),
         25348 => (16#3496#, 16#0020#, 16#0002#),
         25349 => (16#3497#, 16#0020#, 16#0002#),
         25350 => (16#3498#, 16#0020#, 16#0002#),
         25351 => (16#3499#, 16#0020#, 16#0002#),
         25352 => (16#349A#, 16#0020#, 16#0002#),
         25353 => (16#349B#, 16#0020#, 16#0002#),
         25354 => (16#349C#, 16#0020#, 16#0002#),
         25355 => (16#349D#, 16#0020#, 16#0002#),
         25356 => (16#349E#, 16#0020#, 16#0002#),
         25357 => (16#349F#, 16#0020#, 16#0002#),
         25358 => (16#34A0#, 16#0020#, 16#0002#),
         25359 => (16#34A1#, 16#0020#, 16#0002#),
         25360 => (16#34A2#, 16#0020#, 16#0002#),
         25361 => (16#34A3#, 16#0020#, 16#0002#),
         25362 => (16#34A4#, 16#0020#, 16#0002#),
         25363 => (16#34A5#, 16#0020#, 16#0002#),
         25364 => (16#34A6#, 16#0020#, 16#0002#),
         25365 => (16#34A7#, 16#0020#, 16#0002#),
         25366 => (16#34A8#, 16#0020#, 16#0002#),
         25367 => (16#34A9#, 16#0020#, 16#0002#),
         25368 => (16#34AA#, 16#0020#, 16#0002#),
         25369 => (16#34AB#, 16#0020#, 16#0002#),
         25370 => (16#34AC#, 16#0020#, 16#0002#),
         25371 => (16#34AD#, 16#0020#, 16#0002#),
         25372 => (16#34AE#, 16#0020#, 16#0002#),
         25373 => (16#34AF#, 16#0020#, 16#0002#),
         25374 => (16#34B0#, 16#0020#, 16#0002#),
         25375 => (16#34B1#, 16#0020#, 16#0002#),
         25376 => (16#34B2#, 16#0020#, 16#0002#),
         25377 => (16#34B3#, 16#0020#, 16#0002#),
         25378 => (16#34B4#, 16#0020#, 16#0002#),
         25379 => (16#34B5#, 16#0020#, 16#0002#),
         25380 => (16#34B6#, 16#0020#, 16#0002#),
         25381 => (16#34B7#, 16#0020#, 16#0002#),
         25382 => (16#34B8#, 16#0020#, 16#0002#),
         25383 => (16#34B9#, 16#0020#, 16#0002#),
         25384 => (16#34BA#, 16#0020#, 16#0002#),
         25385 => (16#34BB#, 16#0020#, 16#0002#),
         25386 => (16#34BC#, 16#0020#, 16#0002#),
         25387 => (16#34BD#, 16#0020#, 16#0002#),
         25388 => (16#34BE#, 16#0020#, 16#0002#),
         25389 => (16#34BF#, 16#0020#, 16#0002#),
         25390 => (16#34C0#, 16#0020#, 16#0002#),
         25391 => (16#34C1#, 16#0020#, 16#0002#),
         25392 => (16#34C2#, 16#0020#, 16#0002#),
         25393 => (16#34C3#, 16#0020#, 16#0002#),
         25394 => (16#34C4#, 16#0020#, 16#0002#),
         25395 => (16#34C5#, 16#0020#, 16#0002#),
         25396 => (16#34C6#, 16#0020#, 16#0002#),
         25397 => (16#34C7#, 16#0020#, 16#0002#),
         25398 => (16#34C8#, 16#0020#, 16#0002#),
         25399 => (16#34C9#, 16#0020#, 16#0002#),
         25400 => (16#34CA#, 16#0020#, 16#0002#),
         25401 => (16#34CB#, 16#0020#, 16#0002#),
         25402 => (16#34CC#, 16#0020#, 16#0002#),
         25403 => (16#34CD#, 16#0020#, 16#0002#),
         25404 => (16#34CE#, 16#0020#, 16#0002#),
         25405 => (16#34CF#, 16#0020#, 16#0002#),
         25406 => (16#34D0#, 16#0020#, 16#0002#),
         25407 => (16#34D1#, 16#0020#, 16#0002#),
         25408 => (16#34D2#, 16#0020#, 16#0002#),
         25409 => (16#34D3#, 16#0020#, 16#0002#),
         25410 => (16#34D4#, 16#0020#, 16#0002#),
         25411 => (16#34D5#, 16#0020#, 16#0002#),
         25412 => (16#34D6#, 16#0020#, 16#0002#),
         25413 => (16#34D7#, 16#0020#, 16#0002#),
         25414 => (16#34D8#, 16#0020#, 16#0002#),
         25415 => (16#34D9#, 16#0020#, 16#0002#),
         25416 => (16#34DA#, 16#0020#, 16#0002#),
         25417 => (16#34DB#, 16#0020#, 16#0002#),
         25418 => (16#34DC#, 16#0020#, 16#0002#),
         25419 => (16#34DD#, 16#0020#, 16#0002#),
         25420 => (16#34DE#, 16#0020#, 16#0002#),
         25421 => (16#34DF#, 16#0020#, 16#0002#),
         25422 => (16#34E0#, 16#0020#, 16#0002#),
         25423 => (16#34E1#, 16#0020#, 16#0002#),
         25424 => (16#34E2#, 16#0020#, 16#0002#),
         25425 => (16#34E3#, 16#0020#, 16#0002#),
         25426 => (16#34E4#, 16#0020#, 16#0002#),
         25427 => (16#34E5#, 16#0020#, 16#0002#),
         25428 => (16#34E6#, 16#0020#, 16#0002#),
         25429 => (16#34E7#, 16#0020#, 16#0002#),
         25430 => (16#34E8#, 16#0020#, 16#0002#),
         25431 => (16#34E9#, 16#0020#, 16#0002#),
         25432 => (16#34EA#, 16#0020#, 16#0002#),
         25433 => (16#34EB#, 16#0020#, 16#0002#),
         25434 => (16#34EC#, 16#0020#, 16#0002#),
         25435 => (16#34ED#, 16#0020#, 16#0002#),
         25436 => (16#34EE#, 16#0020#, 16#0002#),
         25437 => (16#34EF#, 16#0020#, 16#0002#),
         25438 => (16#34F0#, 16#0020#, 16#0002#),
         25439 => (16#34F1#, 16#0020#, 16#0002#),
         25440 => (16#34F2#, 16#0020#, 16#0002#),
         25441 => (16#34F3#, 16#0020#, 16#0002#),
         25442 => (16#34F4#, 16#0020#, 16#0002#),
         25443 => (16#34F5#, 16#0020#, 16#0002#),
         25444 => (16#34F6#, 16#0020#, 16#0002#),
         25445 => (16#34F7#, 16#0020#, 16#0002#),
         25446 => (16#34F8#, 16#0020#, 16#0002#),
         25447 => (16#34F9#, 16#0020#, 16#0002#),
         25448 => (16#34FA#, 16#0020#, 16#0002#),
         25449 => (16#34FB#, 16#0020#, 16#0002#),
         25450 => (16#34FC#, 16#0020#, 16#0002#),
         25451 => (16#34FD#, 16#0020#, 16#0002#),
         25452 => (16#34FE#, 16#0020#, 16#0002#),
         25453 => (16#34FF#, 16#0020#, 16#0002#),
         25454 => (16#3500#, 16#0020#, 16#0002#),
         25455 => (16#3501#, 16#0020#, 16#0002#),
         25456 => (16#3502#, 16#0020#, 16#0002#),
         25457 => (16#3503#, 16#0020#, 16#0002#),
         25458 => (16#3504#, 16#0020#, 16#0002#),
         25459 => (16#3505#, 16#0020#, 16#0002#),
         25460 => (16#3506#, 16#0020#, 16#0002#),
         25461 => (16#3507#, 16#0020#, 16#0002#),
         25462 => (16#3508#, 16#0020#, 16#0002#),
         25463 => (16#3509#, 16#0020#, 16#0002#),
         25464 => (16#350A#, 16#0020#, 16#0002#),
         25465 => (16#350B#, 16#0020#, 16#0002#),
         25466 => (16#350C#, 16#0020#, 16#0002#),
         25467 => (16#350D#, 16#0020#, 16#0002#),
         25468 => (16#350E#, 16#0020#, 16#0002#),
         25469 => (16#350F#, 16#0020#, 16#0002#),
         25470 => (16#3510#, 16#0020#, 16#0002#),
         25471 => (16#3511#, 16#0020#, 16#0002#),
         25472 => (16#3512#, 16#0020#, 16#0002#),
         25473 => (16#3513#, 16#0020#, 16#0002#),
         25474 => (16#3514#, 16#0020#, 16#0002#),
         25475 => (16#3515#, 16#0020#, 16#0002#),
         25476 => (16#3516#, 16#0020#, 16#0002#),
         25477 => (16#3517#, 16#0020#, 16#0002#),
         25478 => (16#3518#, 16#0020#, 16#0002#),
         25479 => (16#3519#, 16#0020#, 16#0002#),
         25480 => (16#351A#, 16#0020#, 16#0002#),
         25481 => (16#351B#, 16#0020#, 16#0002#),
         25482 => (16#351C#, 16#0020#, 16#0002#),
         25483 => (16#351D#, 16#0020#, 16#0002#),
         25484 => (16#351E#, 16#0020#, 16#0002#),
         25485 => (16#351F#, 16#0020#, 16#0002#),
         25486 => (16#3520#, 16#0020#, 16#0002#),
         25487 => (16#3521#, 16#0020#, 16#0002#),
         25488 => (16#3522#, 16#0020#, 16#0002#),
         25489 => (16#3523#, 16#0020#, 16#0002#),
         25490 => (16#3524#, 16#0020#, 16#0002#),
         25491 => (16#3525#, 16#0020#, 16#0002#),
         25492 => (16#3526#, 16#0020#, 16#0002#),
         25493 => (16#3527#, 16#0020#, 16#0002#),
         25494 => (16#3528#, 16#0020#, 16#0002#),
         25495 => (16#3529#, 16#0020#, 16#0002#),
         25496 => (16#352A#, 16#0020#, 16#0002#),
         25497 => (16#352B#, 16#0020#, 16#0002#),
         25498 => (16#352C#, 16#0020#, 16#0002#),
         25499 => (16#352D#, 16#0020#, 16#0002#),
         25500 => (16#352E#, 16#0020#, 16#0002#),
         25501 => (16#352F#, 16#0020#, 16#0002#),
         25502 => (16#3530#, 16#0020#, 16#0002#),
         25503 => (16#3531#, 16#0020#, 16#0002#),
         25504 => (16#3532#, 16#0020#, 16#0002#),
         25505 => (16#3533#, 16#0020#, 16#0002#),
         25506 => (16#3534#, 16#0020#, 16#0002#),
         25507 => (16#3535#, 16#0020#, 16#0002#),
         25508 => (16#3536#, 16#0020#, 16#0002#),
         25509 => (16#3537#, 16#0020#, 16#0002#),
         25510 => (16#3538#, 16#0020#, 16#0002#),
         25511 => (16#3539#, 16#0020#, 16#0002#),
         25512 => (16#353A#, 16#0020#, 16#0002#),
         25513 => (16#353B#, 16#0020#, 16#0002#),
         25514 => (16#353C#, 16#0020#, 16#0002#),
         25515 => (16#353D#, 16#0020#, 16#0002#),
         25516 => (16#353E#, 16#0020#, 16#0002#),
         25517 => (16#353F#, 16#0020#, 16#0002#),
         25518 => (16#3540#, 16#0020#, 16#0002#),
         25519 => (16#3541#, 16#0020#, 16#0002#),
         25520 => (16#3542#, 16#0020#, 16#0002#),
         25521 => (16#3543#, 16#0020#, 16#0002#),
         25522 => (16#3544#, 16#0020#, 16#0002#),
         25523 => (16#3545#, 16#0020#, 16#0002#),
         25524 => (16#3546#, 16#0020#, 16#0002#),
         25525 => (16#3547#, 16#0020#, 16#0002#),
         25526 => (16#3548#, 16#0020#, 16#0002#),
         25527 => (16#3549#, 16#0020#, 16#0002#),
         25528 => (16#354A#, 16#0020#, 16#0002#),
         25529 => (16#354B#, 16#0020#, 16#0002#),
         25530 => (16#354C#, 16#0020#, 16#0002#),
         25531 => (16#354D#, 16#0020#, 16#0002#),
         25532 => (16#354E#, 16#0020#, 16#0002#),
         25533 => (16#354F#, 16#0020#, 16#0002#),
         25534 => (16#3550#, 16#0020#, 16#0002#),
         25535 => (16#3551#, 16#0020#, 16#0002#),
         25536 => (16#3552#, 16#0020#, 16#0002#),
         25537 => (16#3553#, 16#0020#, 16#0002#),
         25538 => (16#3554#, 16#0020#, 16#0002#),
         25539 => (16#3555#, 16#0020#, 16#0002#),
         25540 => (16#3556#, 16#0020#, 16#0002#),
         25541 => (16#3557#, 16#0020#, 16#0002#),
         25542 => (16#3558#, 16#0020#, 16#0002#),
         25543 => (16#3559#, 16#0020#, 16#0002#),
         25544 => (16#355A#, 16#0020#, 16#0002#),
         25545 => (16#355B#, 16#0020#, 16#0002#),
         25546 => (16#355C#, 16#0020#, 16#0002#),
         25547 => (16#355D#, 16#0020#, 16#0002#),
         25548 => (16#355E#, 16#0020#, 16#0002#),
         25549 => (16#355F#, 16#0020#, 16#0002#),
         25550 => (16#3560#, 16#0020#, 16#0002#),
         25551 => (16#3561#, 16#0020#, 16#0002#),
         25552 => (16#3562#, 16#0020#, 16#0002#),
         25553 => (16#3563#, 16#0020#, 16#0002#),
         25554 => (16#3564#, 16#0020#, 16#0002#),
         25555 => (16#3565#, 16#0020#, 16#0002#),
         25556 => (16#3566#, 16#0020#, 16#0002#),
         25557 => (16#3567#, 16#0020#, 16#0002#),
         25558 => (16#3568#, 16#0020#, 16#0002#),
         25559 => (16#3569#, 16#0020#, 16#0002#),
         25560 => (16#356A#, 16#0020#, 16#0002#),
         25561 => (16#356B#, 16#0020#, 16#0002#),
         25562 => (16#356C#, 16#0020#, 16#0002#),
         25563 => (16#356D#, 16#0020#, 16#0002#),
         25564 => (16#356E#, 16#0020#, 16#0002#),
         25565 => (16#356F#, 16#0020#, 16#0002#),
         25566 => (16#3570#, 16#0020#, 16#0002#),
         25567 => (16#3571#, 16#0020#, 16#0002#),
         25568 => (16#3572#, 16#0020#, 16#0002#),
         25569 => (16#3573#, 16#0020#, 16#0002#),
         25570 => (16#3574#, 16#0020#, 16#0002#),
         25571 => (16#3575#, 16#0020#, 16#0002#),
         25572 => (16#3576#, 16#0020#, 16#0002#),
         25573 => (16#3577#, 16#0020#, 16#0002#),
         25574 => (16#3578#, 16#0020#, 16#0002#),
         25575 => (16#3579#, 16#0020#, 16#0002#),
         25576 => (16#357A#, 16#0020#, 16#0002#),
         25577 => (16#357B#, 16#0020#, 16#0002#),
         25578 => (16#357C#, 16#0020#, 16#0002#),
         25579 => (16#357D#, 16#0020#, 16#0002#),
         25580 => (16#357E#, 16#0020#, 16#0002#),
         25581 => (16#357F#, 16#0020#, 16#0002#),
         25582 => (16#3580#, 16#0020#, 16#0002#),
         25583 => (16#3581#, 16#0020#, 16#0002#),
         25584 => (16#3582#, 16#0020#, 16#0002#),
         25585 => (16#3583#, 16#0020#, 16#0002#),
         25586 => (16#3584#, 16#0020#, 16#0002#),
         25587 => (16#3585#, 16#0020#, 16#0002#),
         25588 => (16#3586#, 16#0020#, 16#0002#),
         25589 => (16#3587#, 16#0020#, 16#0002#),
         25590 => (16#3588#, 16#0020#, 16#0002#),
         25591 => (16#3589#, 16#0020#, 16#0002#),
         25592 => (16#358A#, 16#0020#, 16#0002#),
         25593 => (16#358B#, 16#0020#, 16#0002#),
         25594 => (16#358C#, 16#0020#, 16#0002#),
         25595 => (16#358D#, 16#0020#, 16#0002#),
         25596 => (16#358E#, 16#0020#, 16#0002#),
         25597 => (16#358F#, 16#0020#, 16#0002#),
         25598 => (16#3590#, 16#0020#, 16#0002#),
         25599 => (16#3591#, 16#0020#, 16#0002#),
         25600 => (16#3592#, 16#0020#, 16#0002#),
         25601 => (16#3593#, 16#0020#, 16#0002#),
         25602 => (16#3594#, 16#0020#, 16#0002#),
         25603 => (16#3595#, 16#0020#, 16#0002#),
         25604 => (16#3596#, 16#0020#, 16#0002#),
         25605 => (16#3597#, 16#0020#, 16#0002#),
         25606 => (16#3598#, 16#0020#, 16#0002#),
         25607 => (16#3599#, 16#0020#, 16#0002#),
         25608 => (16#359A#, 16#0020#, 16#0002#),
         25609 => (16#359B#, 16#0020#, 16#0002#),
         25610 => (16#359C#, 16#0020#, 16#0002#),
         25611 => (16#359D#, 16#0020#, 16#0002#),
         25612 => (16#359E#, 16#0020#, 16#0002#),
         25613 => (16#359F#, 16#0020#, 16#0002#),
         25614 => (16#35A0#, 16#0020#, 16#0002#),
         25615 => (16#35A1#, 16#0020#, 16#0002#),
         25616 => (16#35A2#, 16#0020#, 16#0002#),
         25617 => (16#35A3#, 16#0020#, 16#0002#),
         25618 => (16#35A4#, 16#0020#, 16#0002#),
         25619 => (16#35A5#, 16#0020#, 16#0002#),
         25620 => (16#35A6#, 16#0020#, 16#0002#),
         25621 => (16#35A7#, 16#0020#, 16#0002#),
         25622 => (16#35A8#, 16#0020#, 16#0002#),
         25623 => (16#35A9#, 16#0020#, 16#0002#),
         25624 => (16#35AA#, 16#0020#, 16#0002#),
         25625 => (16#35AB#, 16#0020#, 16#0002#),
         25626 => (16#35AC#, 16#0020#, 16#0002#),
         25627 => (16#35AD#, 16#0020#, 16#0002#),
         25628 => (16#35AE#, 16#0020#, 16#0002#),
         25629 => (16#35AF#, 16#0020#, 16#0002#),
         25630 => (16#35B0#, 16#0020#, 16#0002#),
         25631 => (16#35B1#, 16#0020#, 16#0002#),
         25632 => (16#35B2#, 16#0020#, 16#0002#),
         25633 => (16#35B3#, 16#0020#, 16#0002#),
         25634 => (16#35B4#, 16#0020#, 16#0002#),
         25635 => (16#35B5#, 16#0020#, 16#0002#),
         25636 => (16#35B6#, 16#0020#, 16#0002#),
         25637 => (16#35B7#, 16#0020#, 16#0002#),
         25638 => (16#35B8#, 16#0020#, 16#0002#),
         25639 => (16#35B9#, 16#0020#, 16#0002#),
         25640 => (16#35BA#, 16#0020#, 16#0002#),
         25641 => (16#35BB#, 16#0020#, 16#0002#),
         25642 => (16#35BC#, 16#0020#, 16#0002#),
         25643 => (16#35BD#, 16#0020#, 16#0002#),
         25644 => (16#35BE#, 16#0020#, 16#0002#),
         25645 => (16#35BF#, 16#0020#, 16#0002#),
         25646 => (16#35C0#, 16#0020#, 16#0002#),
         25647 => (16#35C1#, 16#0020#, 16#0002#),
         25648 => (16#35C2#, 16#0020#, 16#0002#),
         25649 => (16#35C3#, 16#0020#, 16#0002#),
         25650 => (16#35C4#, 16#0020#, 16#0002#),
         25651 => (16#35C5#, 16#0020#, 16#0002#),
         25652 => (16#35C6#, 16#0020#, 16#0002#),
         25653 => (16#35C7#, 16#0020#, 16#0002#),
         25654 => (16#35C8#, 16#0020#, 16#0002#),
         25655 => (16#35C9#, 16#0020#, 16#0002#),
         25656 => (16#35CA#, 16#0020#, 16#0002#),
         25657 => (16#35CB#, 16#0020#, 16#0002#),
         25658 => (16#35CC#, 16#0020#, 16#0002#),
         25659 => (16#35CD#, 16#0020#, 16#0002#),
         25660 => (16#35CE#, 16#0020#, 16#0002#),
         25661 => (16#35CF#, 16#0020#, 16#0002#),
         25662 => (16#35D0#, 16#0020#, 16#0002#),
         25663 => (16#35D1#, 16#0020#, 16#0002#),
         25664 => (16#35D2#, 16#0020#, 16#0002#),
         25665 => (16#35D3#, 16#0020#, 16#0002#),
         25666 => (16#35D4#, 16#0020#, 16#0002#),
         25667 => (16#35D5#, 16#0020#, 16#0002#),
         25668 => (16#35D6#, 16#0020#, 16#0002#),
         25669 => (16#35D7#, 16#0020#, 16#0002#),
         25670 => (16#35D8#, 16#0020#, 16#0002#),
         25671 => (16#35D9#, 16#0020#, 16#0002#),
         25672 => (16#35DA#, 16#0020#, 16#0002#),
         25673 => (16#35DB#, 16#0020#, 16#0002#),
         25674 => (16#35DC#, 16#0020#, 16#0002#),
         25675 => (16#35DD#, 16#0020#, 16#0002#),
         25676 => (16#35DE#, 16#0020#, 16#0002#),
         25677 => (16#35DF#, 16#0020#, 16#0002#),
         25678 => (16#35E0#, 16#0020#, 16#0002#),
         25679 => (16#35E1#, 16#0020#, 16#0002#),
         25680 => (16#35E2#, 16#0020#, 16#0002#),
         25681 => (16#35E3#, 16#0020#, 16#0002#),
         25682 => (16#35E4#, 16#0020#, 16#0002#),
         25683 => (16#35E5#, 16#0020#, 16#0002#),
         25684 => (16#35E6#, 16#0020#, 16#0002#),
         25685 => (16#35E7#, 16#0020#, 16#0002#),
         25686 => (16#35E8#, 16#0020#, 16#0002#),
         25687 => (16#35E9#, 16#0020#, 16#0002#),
         25688 => (16#35EA#, 16#0020#, 16#0002#),
         25689 => (16#35EB#, 16#0020#, 16#0002#),
         25690 => (16#35EC#, 16#0020#, 16#0002#),
         25691 => (16#35ED#, 16#0020#, 16#0002#),
         25692 => (16#35EE#, 16#0020#, 16#0002#),
         25693 => (16#35EF#, 16#0020#, 16#0002#),
         25694 => (16#35F0#, 16#0020#, 16#0002#),
         25695 => (16#35F1#, 16#0020#, 16#0002#),
         25696 => (16#35F2#, 16#0020#, 16#0002#),
         25697 => (16#35F3#, 16#0020#, 16#0002#),
         25698 => (16#35F4#, 16#0020#, 16#0002#),
         25699 => (16#35F5#, 16#0020#, 16#0002#),
         25700 => (16#35F6#, 16#0020#, 16#0002#),
         25701 => (16#35F7#, 16#0020#, 16#0002#),
         25702 => (16#35F8#, 16#0020#, 16#0002#),
         25703 => (16#35F9#, 16#0020#, 16#0002#),
         25704 => (16#35FA#, 16#0020#, 16#0002#),
         25705 => (16#35FB#, 16#0020#, 16#0002#),
         25706 => (16#35FC#, 16#0020#, 16#0002#),
         25707 => (16#35FD#, 16#0020#, 16#0002#),
         25708 => (16#35FE#, 16#0020#, 16#0002#),
         25709 => (16#35FF#, 16#0020#, 16#0002#),
         25710 => (16#3600#, 16#0020#, 16#0002#),
         25711 => (16#3601#, 16#0020#, 16#0002#),
         25712 => (16#3602#, 16#0020#, 16#0002#),
         25713 => (16#3603#, 16#0020#, 16#0002#),
         25714 => (16#3604#, 16#0020#, 16#0002#),
         25715 => (16#3605#, 16#0020#, 16#0002#),
         25716 => (16#3606#, 16#0020#, 16#0002#),
         25717 => (16#3607#, 16#0020#, 16#0002#),
         25718 => (16#3608#, 16#0020#, 16#0002#),
         25719 => (16#3609#, 16#0020#, 16#0002#),
         25720 => (16#360A#, 16#0020#, 16#0002#),
         25721 => (16#360B#, 16#0020#, 16#0002#),
         25722 => (16#360C#, 16#0020#, 16#0002#),
         25723 => (16#360D#, 16#0020#, 16#0002#),
         25724 => (16#360E#, 16#0020#, 16#0002#),
         25725 => (16#360F#, 16#0020#, 16#0002#),
         25726 => (16#3610#, 16#0020#, 16#0002#),
         25727 => (16#3611#, 16#0020#, 16#0002#),
         25728 => (16#3612#, 16#0020#, 16#0002#),
         25729 => (16#3613#, 16#0020#, 16#0002#),
         25730 => (16#3614#, 16#0020#, 16#0002#),
         25731 => (16#3615#, 16#0020#, 16#0002#),
         25732 => (16#3616#, 16#0020#, 16#0002#),
         25733 => (16#3617#, 16#0020#, 16#0002#),
         25734 => (16#3618#, 16#0020#, 16#0002#),
         25735 => (16#3619#, 16#0020#, 16#0002#),
         25736 => (16#361A#, 16#0020#, 16#0002#),
         25737 => (16#361B#, 16#0020#, 16#0002#),
         25738 => (16#361C#, 16#0020#, 16#0002#),
         25739 => (16#361D#, 16#0020#, 16#0002#),
         25740 => (16#361E#, 16#0020#, 16#0002#),
         25741 => (16#361F#, 16#0020#, 16#0002#),
         25742 => (16#3620#, 16#0020#, 16#0002#),
         25743 => (16#3621#, 16#0020#, 16#0002#),
         25744 => (16#3622#, 16#0020#, 16#0002#),
         25745 => (16#3623#, 16#0020#, 16#0002#),
         25746 => (16#3624#, 16#0020#, 16#0002#),
         25747 => (16#3625#, 16#0020#, 16#0002#),
         25748 => (16#3626#, 16#0020#, 16#0002#),
         25749 => (16#3627#, 16#0020#, 16#0002#),
         25750 => (16#3628#, 16#0020#, 16#0002#),
         25751 => (16#3629#, 16#0020#, 16#0002#),
         25752 => (16#362A#, 16#0020#, 16#0002#),
         25753 => (16#362B#, 16#0020#, 16#0002#),
         25754 => (16#362C#, 16#0020#, 16#0002#),
         25755 => (16#362D#, 16#0020#, 16#0002#),
         25756 => (16#362E#, 16#0020#, 16#0002#),
         25757 => (16#362F#, 16#0020#, 16#0002#),
         25758 => (16#3630#, 16#0020#, 16#0002#),
         25759 => (16#3631#, 16#0020#, 16#0002#),
         25760 => (16#3632#, 16#0020#, 16#0002#),
         25761 => (16#3633#, 16#0020#, 16#0002#),
         25762 => (16#3634#, 16#0020#, 16#0002#),
         25763 => (16#3635#, 16#0020#, 16#0002#),
         25764 => (16#3636#, 16#0020#, 16#0002#),
         25765 => (16#3637#, 16#0020#, 16#0002#),
         25766 => (16#3638#, 16#0020#, 16#0002#),
         25767 => (16#3639#, 16#0020#, 16#0002#),
         25768 => (16#363A#, 16#0020#, 16#0002#),
         25769 => (16#363B#, 16#0020#, 16#0002#),
         25770 => (16#363C#, 16#0020#, 16#0002#),
         25771 => (16#363D#, 16#0020#, 16#0002#),
         25772 => (16#363E#, 16#0020#, 16#0002#),
         25773 => (16#363F#, 16#0020#, 16#0002#),
         25774 => (16#40F6#, 16#0020#, 16#0002#),
         25775 => (16#40F7#, 16#0020#, 16#0002#),
         25776 => (16#40F8#, 16#0020#, 16#0002#),
         25777 => (16#40F9#, 16#0020#, 16#0002#),
         25778 => (16#40FA#, 16#0020#, 16#0002#),
         25779 => (16#40FB#, 16#0020#, 16#0002#),
         25780 => (16#40FC#, 16#0020#, 16#0002#),
         25781 => (16#40FD#, 16#0020#, 16#0002#),
         25782 => (16#40FE#, 16#0020#, 16#0002#),
         25783 => (16#40FF#, 16#0020#, 16#0002#),
         25784 => (16#4100#, 16#0020#, 16#0002#),
         25785 => (16#4101#, 16#0020#, 16#0002#),
         25786 => (16#4102#, 16#0020#, 16#0002#),
         25787 => (16#4103#, 16#0020#, 16#0002#),
         25788 => (16#4104#, 16#0020#, 16#0002#),
         25789 => (16#4105#, 16#0020#, 16#0002#),
         25790 => (16#4106#, 16#0020#, 16#0002#),
         25791 => (16#4107#, 16#0020#, 16#0002#),
         25792 => (16#4108#, 16#0020#, 16#0002#),
         25793 => (16#4109#, 16#0020#, 16#0002#),
         25794 => (16#410A#, 16#0020#, 16#0002#),
         25795 => (16#410B#, 16#0020#, 16#0002#),
         25796 => (16#410C#, 16#0020#, 16#0002#),
         25797 => (16#410D#, 16#0020#, 16#0002#),
         25798 => (16#410E#, 16#0020#, 16#0002#),
         25799 => (16#410F#, 16#0020#, 16#0002#),
         25800 => (16#4110#, 16#0020#, 16#0002#),
         25801 => (16#4111#, 16#0020#, 16#0002#),
         25802 => (16#4112#, 16#0020#, 16#0002#),
         25803 => (16#4113#, 16#0020#, 16#0002#),
         25804 => (16#4114#, 16#0020#, 16#0002#),
         25805 => (16#01B6#, 16#0020#, 16#0002#),
         25806 => (16#01B7#, 16#0020#, 16#0002#),
         25807 => (16#3640#, 16#0020#, 16#0002#),
         25808 => (16#3641#, 16#0020#, 16#0002#),
         25809 => (16#3642#, 16#0020#, 16#0002#),
         25810 => (16#3643#, 16#0020#, 16#0002#),
         25811 => (16#3644#, 16#0020#, 16#0002#),
         25812 => (16#3645#, 16#0020#, 16#0002#),
         25813 => (16#3646#, 16#0020#, 16#0002#),
         25814 => (16#3647#, 16#0020#, 16#0002#),
         25815 => (16#3648#, 16#0020#, 16#0002#),
         25816 => (16#3649#, 16#0020#, 16#0002#),
         25817 => (16#364A#, 16#0020#, 16#0002#),
         25818 => (16#364B#, 16#0020#, 16#0002#),
         25819 => (16#364C#, 16#0020#, 16#0002#),
         25820 => (16#364D#, 16#0020#, 16#0002#),
         25821 => (16#364E#, 16#0020#, 16#0002#),
         25822 => (16#364F#, 16#0020#, 16#0002#),
         25823 => (16#3650#, 16#0020#, 16#0002#),
         25824 => (16#3651#, 16#0020#, 16#0002#),
         25825 => (16#3652#, 16#0020#, 16#0002#),
         25826 => (16#3653#, 16#0020#, 16#0002#),
         25827 => (16#3654#, 16#0020#, 16#0002#),
         25828 => (16#3655#, 16#0020#, 16#0002#),
         25829 => (16#3656#, 16#0020#, 16#0002#),
         25830 => (16#3657#, 16#0020#, 16#0002#),
         25831 => (16#3658#, 16#0020#, 16#0002#),
         25832 => (16#3659#, 16#0020#, 16#0002#),
         25833 => (16#365A#, 16#0020#, 16#0002#),
         25834 => (16#365B#, 16#0020#, 16#0002#),
         25835 => (16#365C#, 16#0020#, 16#0002#),
         25836 => (16#365D#, 16#0020#, 16#0002#),
         25837 => (16#0000#, 16#00B7#, 16#0002#),
         25838 => (16#0000#, 16#00B8#, 16#0002#),
         25839 => (16#0000#, 16#00B9#, 16#0002#),
         25840 => (16#0000#, 16#00BA#, 16#0002#),
         25841 => (16#0000#, 16#00BB#, 16#0002#),
         25842 => (16#0184#, 16#0020#, 16#0002#),
         25843 => (16#3E83#, 16#0020#, 16#0002#),
         25844 => (16#3E84#, 16#0020#, 16#0002#),
         25845 => (16#3E85#, 16#0020#, 16#0002#),
         25846 => (16#3E86#, 16#0020#, 16#0002#),
         25847 => (16#3E87#, 16#0020#, 16#0002#),
         25848 => (16#3E88#, 16#0020#, 16#0002#),
         25849 => (16#3E89#, 16#0020#, 16#0002#),
         25850 => (16#3E8A#, 16#0020#, 16#0002#),
         25851 => (16#3E8B#, 16#0020#, 16#0002#),
         25852 => (16#3E8C#, 16#0020#, 16#0002#),
         25853 => (16#3E8D#, 16#0020#, 16#0002#),
         25854 => (16#3E8E#, 16#0020#, 16#0002#),
         25855 => (16#3E8F#, 16#0020#, 16#0002#),
         25856 => (16#3E90#, 16#0020#, 16#0002#),
         25857 => (16#3E91#, 16#0020#, 16#0002#),
         25858 => (16#3E92#, 16#0020#, 16#0002#),
         25859 => (16#3E93#, 16#0020#, 16#0002#),
         25860 => (16#3E94#, 16#0020#, 16#0002#),
         25861 => (16#3E95#, 16#0020#, 16#0002#),
         25862 => (16#3E96#, 16#0020#, 16#0002#),
         25863 => (16#3E97#, 16#0020#, 16#0002#),
         25864 => (16#3E98#, 16#0020#, 16#0002#),
         25865 => (16#3E99#, 16#0020#, 16#0002#),
         25866 => (16#3E9A#, 16#0020#, 16#0002#),
         25867 => (16#3E9B#, 16#0020#, 16#0002#),
         25868 => (16#3E9C#, 16#0020#, 16#0002#),
         25869 => (16#3E9D#, 16#0020#, 16#0002#),
         25870 => (16#3E9E#, 16#0020#, 16#0002#),
         25871 => (16#3E9F#, 16#0020#, 16#0002#),
         25872 => (16#3EA0#, 16#0020#, 16#0002#),
         25873 => (16#3EA1#, 16#0020#, 16#0002#),
         25874 => (16#3EA2#, 16#0020#, 16#0002#),
         25875 => (16#3EA3#, 16#0020#, 16#0002#),
         25876 => (16#3EA4#, 16#0020#, 16#0002#),
         25877 => (16#3EA5#, 16#0020#, 16#0002#),
         25878 => (16#3EA6#, 16#0020#, 16#0002#),
         25879 => (16#3EA7#, 16#0020#, 16#0002#),
         25880 => (16#3EA8#, 16#0020#, 16#0002#),
         25881 => (16#3EA9#, 16#0020#, 16#0002#),
         25882 => (16#3EAA#, 16#0020#, 16#0002#),
         25883 => (16#3EAB#, 16#0020#, 16#0002#),
         25884 => (16#3EAC#, 16#0020#, 16#0002#),
         25885 => (16#3EAD#, 16#0020#, 16#0002#),
         25886 => (16#3EAE#, 16#0020#, 16#0002#),
         25887 => (16#3EAF#, 16#0020#, 16#0002#),
         25888 => (16#3EB0#, 16#0020#, 16#0002#),
         25889 => (16#3EB1#, 16#0020#, 16#0002#),
         25890 => (16#3EB2#, 16#0020#, 16#0002#),
         25891 => (16#0000#, 16#00EC#, 16#0002#),
         25892 => (16#0000#, 16#00ED#, 16#0002#),
         25893 => (16#0000#, 16#00EE#, 16#0002#),
         25894 => (16#0000#, 16#00EF#, 16#0002#),
         25895 => (16#0000#, 16#00F0#, 16#0002#),
         25896 => (16#0000#, 16#00F1#, 16#0002#),
         25897 => (16#0000#, 16#00F2#, 16#0002#),
         25898 => (16#033F#, 16#0020#, 16#0002#),
         25899 => (16#0340#, 16#0020#, 16#0002#),
         25900 => (16#0341#, 16#0020#, 16#0002#),
         25901 => (16#0342#, 16#0020#, 16#0002#),
         25902 => (16#0343#, 16#0020#, 16#0002#),
         25903 => (16#0E87#, 16#0020#, 16#0002#),
         25904 => (16#0E88#, 16#0020#, 16#0002#),
         25905 => (16#0E89#, 16#0020#, 16#0002#),
         25906 => (16#0E8A#, 16#0020#, 16#0002#),
         25907 => (16#3EB3#, 16#0020#, 16#0002#),
         25908 => (16#3EB4#, 16#0020#, 16#0002#),
         25909 => (16#16BE#, 16#0020#, 16#0002#),
         25910 => (16#16BF#, 16#0020#, 16#0002#),
         25911 => (16#0344#, 16#0020#, 16#0002#),
         25912 => (16#0E8B#, 16#0020#, 16#0002#),
         25913 => (16#17E2#, 16#0020#, 16#0002#),
         25914 => (16#17E3#, 16#0020#, 16#0002#),
         25915 => (16#17E4#, 16#0020#, 16#0002#),
         25916 => (16#17E5#, 16#0020#, 16#0002#),
         25917 => (16#17E6#, 16#0020#, 16#0002#),
         25918 => (16#17E7#, 16#0020#, 16#0002#),
         25919 => (16#17E8#, 16#0020#, 16#0002#),
         25920 => (16#3EB5#, 16#0020#, 16#0002#),
         25921 => (16#3EB6#, 16#0020#, 16#0002#),
         25922 => (16#3EB7#, 16#0020#, 16#0002#),
         25923 => (16#3EB8#, 16#0020#, 16#0002#),
         25924 => (16#3EB9#, 16#0020#, 16#0002#),
         25925 => (16#3EBA#, 16#0020#, 16#0002#),
         25926 => (16#3EBB#, 16#0020#, 16#0002#),
         25927 => (16#3EBC#, 16#0020#, 16#0002#),
         25928 => (16#3EBD#, 16#0020#, 16#0002#),
         25929 => (16#3EBE#, 16#0020#, 16#0002#),
         25930 => (16#3EBF#, 16#0020#, 16#0002#),
         25931 => (16#3EC0#, 16#0020#, 16#0002#),
         25932 => (16#3EC1#, 16#0020#, 16#0002#),
         25933 => (16#3EC2#, 16#0020#, 16#0002#),
         25934 => (16#3EC3#, 16#0020#, 16#0002#),
         25935 => (16#3EC4#, 16#0020#, 16#0002#),
         25936 => (16#3EC5#, 16#0020#, 16#0002#),
         25937 => (16#3EC6#, 16#0020#, 16#0002#),
         25938 => (16#3EC7#, 16#0020#, 16#0002#),
         25939 => (16#3EC8#, 16#0020#, 16#0002#),
         25940 => (16#3EC9#, 16#0020#, 16#0002#),
         25941 => (16#3ECA#, 16#0020#, 16#0002#),
         25942 => (16#3ECB#, 16#0020#, 16#0002#),
         25943 => (16#3ECC#, 16#0020#, 16#0002#),
         25944 => (16#3ECD#, 16#0020#, 16#0002#),
         25945 => (16#3ECE#, 16#0020#, 16#0002#),
         25946 => (16#3ECF#, 16#0020#, 16#0002#),
         25947 => (16#3ED0#, 16#0020#, 16#0002#),
         25948 => (16#3ED1#, 16#0020#, 16#0002#),
         25949 => (16#3ED2#, 16#0020#, 16#0002#),
         25950 => (16#3ED3#, 16#0020#, 16#0002#),
         25951 => (16#3ED4#, 16#0020#, 16#0002#),
         25952 => (16#3ED5#, 16#0020#, 16#0002#),
         25953 => (16#3ED6#, 16#0020#, 16#0002#),
         25954 => (16#3ED7#, 16#0020#, 16#0002#),
         25955 => (16#3ED8#, 16#0020#, 16#0002#),
         25956 => (16#3ED9#, 16#0020#, 16#0002#),
         25957 => (16#3EDA#, 16#0020#, 16#0002#),
         25958 => (16#3EDB#, 16#0020#, 16#0002#),
         25959 => (16#3EDC#, 16#0020#, 16#0002#),
         25960 => (16#3DA8#, 16#0020#, 16#0002#),
         25961 => (16#3DA9#, 16#0020#, 16#0002#),
         25962 => (16#3DAA#, 16#0020#, 16#0002#),
         25963 => (16#3DAB#, 16#0020#, 16#0002#),
         25964 => (16#3DAC#, 16#0020#, 16#0002#),
         25965 => (16#3DAD#, 16#0020#, 16#0002#),
         25966 => (16#3DAC#, 16#0020#, 16#0004#),
         25967 => (16#3DAE#, 16#0020#, 16#0002#),
         25968 => (16#3DAF#, 16#0020#, 16#0002#),
         25969 => (16#3DB0#, 16#0020#, 16#0002#),
         25970 => (16#3DB1#, 16#0020#, 16#0002#),
         25971 => (16#3DB2#, 16#0020#, 16#0002#),
         25972 => (16#3DB3#, 16#0020#, 16#0002#),
         25973 => (16#3DB4#, 16#0020#, 16#0002#),
         25974 => (16#3DB5#, 16#0020#, 16#0002#),
         25975 => (16#3DB6#, 16#0020#, 16#0002#),
         25976 => (16#3DB7#, 16#0020#, 16#0002#),
         25977 => (16#3DB8#, 16#0020#, 16#0002#),
         25978 => (16#3DB9#, 16#0020#, 16#0002#),
         25979 => (16#3DB7#, 16#0020#, 16#0004#),
         25980 => (16#3DBA#, 16#0020#, 16#0002#),
         25981 => (16#3DBB#, 16#0020#, 16#0002#),
         25982 => (16#3DBC#, 16#0020#, 16#0002#),
         25983 => (16#3DBD#, 16#0020#, 16#0002#),
         25984 => (16#3DBE#, 16#0020#, 16#0002#),
         25985 => (16#3DBF#, 16#0020#, 16#0002#),
         25986 => (16#3DC0#, 16#0020#, 16#0002#),
         25987 => (16#3DC1#, 16#0020#, 16#0002#),
         25988 => (16#3DC2#, 16#0020#, 16#0002#),
         25989 => (16#3DC3#, 16#0020#, 16#0002#),
         25990 => (16#3DC4#, 16#0020#, 16#0002#),
         25991 => (16#3DC5#, 16#0020#, 16#0002#),
         25992 => (16#3DC6#, 16#0020#, 16#0002#),
         25993 => (16#3DC7#, 16#0020#, 16#0002#),
         25994 => (16#3DC8#, 16#0020#, 16#0002#),
         25995 => (16#3DC9#, 16#0020#, 16#0002#),
         25996 => (16#3DCA#, 16#0020#, 16#0002#),
         25997 => (16#3DC9#, 16#0020#, 16#0004#),
         25998 => (16#3DCB#, 16#0020#, 16#0002#),
         25999 => (16#3DCC#, 16#0020#, 16#0002#),
         26000 => (16#3DCD#, 16#0020#, 16#0002#),
         26001 => (16#3DCE#, 16#0020#, 16#0002#),
         26002 => (16#3DCF#, 16#0020#, 16#0002#),
         26003 => (16#3DD0#, 16#0020#, 16#0002#),
         26004 => (16#3DD1#, 16#0020#, 16#0002#),
         26005 => (16#3DD2#, 16#0020#, 16#0002#),
         26006 => (16#3DD3#, 16#0020#, 16#0002#),
         26007 => (16#3DD4#, 16#0020#, 16#0002#),
         26008 => (16#3DD5#, 16#0020#, 16#0002#),
         26009 => (16#3DD6#, 16#0020#, 16#0002#),
         26010 => (16#3DD7#, 16#0020#, 16#0002#),
         26011 => (16#3DD8#, 16#0020#, 16#0002#),
         26012 => (16#3DD9#, 16#0020#, 16#0002#),
         26013 => (16#3DDA#, 16#0020#, 16#0002#),
         26014 => (16#3DDB#, 16#0020#, 16#0002#),
         26015 => (16#3DDC#, 16#0020#, 16#0002#),
         26016 => (16#3DDD#, 16#0020#, 16#0002#),
         26017 => (16#3DDE#, 16#0020#, 16#0002#),
         26018 => (16#3DDF#, 16#0020#, 16#0002#),
         26019 => (16#3DE0#, 16#0020#, 16#0002#),
         26020 => (16#3DE1#, 16#0020#, 16#0002#),
         26021 => (16#3DE2#, 16#0020#, 16#0002#),
         26022 => (16#3DE3#, 16#0020#, 16#0002#),
         26023 => (16#3DE2#, 16#0020#, 16#0004#),
         26024 => (16#3DE4#, 16#0020#, 16#0002#),
         26025 => (16#3DE5#, 16#0020#, 16#0002#),
         26026 => (16#3DE6#, 16#0020#, 16#0002#),
         26027 => (16#3DE7#, 16#0020#, 16#0002#),
         26028 => (16#3DE8#, 16#0020#, 16#0002#),
         26029 => (16#3DE9#, 16#0020#, 16#0002#),
         26030 => (16#3DEA#, 16#0020#, 16#0002#),
         26031 => (16#3DEB#, 16#0020#, 16#0002#),
         26032 => (16#3DEC#, 16#0020#, 16#0002#),
         26033 => (16#3DED#, 16#0020#, 16#0002#),
         26034 => (16#3DEE#, 16#0020#, 16#0002#),
         26035 => (16#3DEF#, 16#0020#, 16#0002#),
         26036 => (16#3DF0#, 16#0020#, 16#0002#),
         26037 => (16#3DF1#, 16#0020#, 16#0002#),
         26038 => (16#3DF2#, 16#0020#, 16#0002#),
         26039 => (16#3DF3#, 16#0020#, 16#0002#),
         26040 => (16#3DF4#, 16#0020#, 16#0002#),
         26041 => (16#3DF5#, 16#0020#, 16#0002#),
         26042 => (16#3DF6#, 16#0020#, 16#0002#),
         26043 => (16#3DF7#, 16#0020#, 16#0002#),
         26044 => (16#3DF8#, 16#0020#, 16#0002#),
         26045 => (16#3DF9#, 16#0020#, 16#0002#),
         26046 => (16#3DFA#, 16#0020#, 16#0002#),
         26047 => (16#3DFB#, 16#0020#, 16#0002#),
         26048 => (16#3DFC#, 16#0020#, 16#0002#),
         26049 => (16#3DFD#, 16#0020#, 16#0002#),
         26050 => (16#3DFE#, 16#0020#, 16#0002#),
         26051 => (16#3DFF#, 16#0020#, 16#0002#),
         26052 => (16#3E00#, 16#0020#, 16#0002#),
         26053 => (16#3E01#, 16#0020#, 16#0002#),
         26054 => (16#3E02#, 16#0020#, 16#0002#),
         26055 => (16#3E03#, 16#0020#, 16#0002#),
         26056 => (16#3E04#, 16#0020#, 16#0002#),
         26057 => (16#3E05#, 16#0020#, 16#0002#),
         26058 => (16#3E06#, 16#0020#, 16#0002#),
         26059 => (16#3E07#, 16#0020#, 16#0002#),
         26060 => (16#3E08#, 16#0020#, 16#0002#),
         26061 => (16#3E09#, 16#0020#, 16#0002#),
         26062 => (16#3E0A#, 16#0020#, 16#0002#),
         26063 => (16#3E0B#, 16#0020#, 16#0002#),
         26064 => (16#3E0C#, 16#0020#, 16#0002#),
         26065 => (16#3E0D#, 16#0020#, 16#0002#),
         26066 => (16#3E0E#, 16#0020#, 16#0002#),
         26067 => (16#3E0F#, 16#0020#, 16#0002#),
         26068 => (16#3E10#, 16#0020#, 16#0002#),
         26069 => (16#3E11#, 16#0020#, 16#0002#),
         26070 => (16#3E12#, 16#0020#, 16#0002#),
         26071 => (16#3E13#, 16#0020#, 16#0002#),
         26072 => (16#3E14#, 16#0020#, 16#0002#),
         26073 => (16#3E15#, 16#0020#, 16#0002#),
         26074 => (16#3E16#, 16#0020#, 16#0002#),
         26075 => (16#3E17#, 16#0020#, 16#0002#),
         26076 => (16#3E18#, 16#0020#, 16#0002#),
         26077 => (16#3E19#, 16#0020#, 16#0002#),
         26078 => (16#3E1A#, 16#0020#, 16#0002#),
         26079 => (16#3E1B#, 16#0020#, 16#0002#),
         26080 => (16#3E1C#, 16#0020#, 16#0002#),
         26081 => (16#3E1D#, 16#0020#, 16#0002#),
         26082 => (16#3E1E#, 16#0020#, 16#0002#),
         26083 => (16#3E1F#, 16#0020#, 16#0002#),
         26084 => (16#3E20#, 16#0020#, 16#0002#),
         26085 => (16#3E21#, 16#0020#, 16#0002#),
         26086 => (16#3E22#, 16#0020#, 16#0002#),
         26087 => (16#3E23#, 16#0020#, 16#0002#),
         26088 => (16#3E24#, 16#0020#, 16#0002#),
         26089 => (16#3E25#, 16#0020#, 16#0002#),
         26090 => (16#3E26#, 16#0020#, 16#0002#),
         26091 => (16#3E27#, 16#0020#, 16#0002#),
         26092 => (16#3E28#, 16#0020#, 16#0002#),
         26093 => (16#388B#, 16#0020#, 16#0011#),
         26094 => (16#38AE#, 16#0020#, 16#000E#),
         26095 => (16#3FD8#, 16#0020#, 16#0002#),
         26096 => (16#3FD9#, 16#0020#, 16#0002#),
         26097 => (16#3FDA#, 16#0020#, 16#0002#),
         26098 => (16#3FDB#, 16#0020#, 16#0002#),
         26099 => (16#3FDC#, 16#0020#, 16#0002#),
         26100 => (16#3FDD#, 16#0020#, 16#0002#),
         26101 => (16#3FDE#, 16#0020#, 16#0002#),
         26102 => (16#3FDF#, 16#0020#, 16#0002#),
         26103 => (16#3FE0#, 16#0020#, 16#0002#),
         26104 => (16#3FE1#, 16#0020#, 16#0002#),
         26105 => (16#3FE2#, 16#0020#, 16#0002#),
         26106 => (16#3FE3#, 16#0020#, 16#0002#),
         26107 => (16#3FE4#, 16#0020#, 16#0002#),
         26108 => (16#3FE5#, 16#0020#, 16#0002#),
         26109 => (16#3FE6#, 16#0020#, 16#0002#),
         26110 => (16#3FE7#, 16#0020#, 16#0002#),
         26111 => (16#3FE8#, 16#0020#, 16#0002#),
         26112 => (16#3FE9#, 16#0020#, 16#0002#),
         26113 => (16#3FEA#, 16#0020#, 16#0002#),
         26114 => (16#3FEB#, 16#0020#, 16#0002#),
         26115 => (16#3FEC#, 16#0020#, 16#0002#),
         26116 => (16#3FED#, 16#0020#, 16#0002#),
         26117 => (16#3FEE#, 16#0020#, 16#0002#),
         26118 => (16#3FEF#, 16#0020#, 16#0002#),
         26119 => (16#3FF0#, 16#0020#, 16#0002#),
         26120 => (16#3FF1#, 16#0020#, 16#0002#),
         26121 => (16#3FF2#, 16#0020#, 16#0002#),
         26122 => (16#3FF3#, 16#0020#, 16#0002#),
         26123 => (16#3FF4#, 16#0020#, 16#0002#),
         26124 => (16#3FF5#, 16#0020#, 16#0002#),
         26125 => (16#3FF6#, 16#0020#, 16#0002#),
         26126 => (16#3FF7#, 16#0020#, 16#0002#),
         26127 => (16#3FF8#, 16#0020#, 16#0002#),
         26128 => (16#3FF9#, 16#0020#, 16#0002#),
         26129 => (16#3FFA#, 16#0020#, 16#0002#),
         26130 => (16#3FFB#, 16#0020#, 16#0002#),
         26131 => (16#3FFC#, 16#0020#, 16#0002#),
         26132 => (16#3FFD#, 16#0020#, 16#0002#),
         26133 => (16#3FFE#, 16#0020#, 16#0002#),
         26134 => (16#3FFF#, 16#0020#, 16#0002#),
         26135 => (16#4000#, 16#0020#, 16#0002#),
         26136 => (16#4001#, 16#0020#, 16#0002#),
         26137 => (16#4002#, 16#0020#, 16#0002#),
         26138 => (16#4003#, 16#0020#, 16#0002#),
         26139 => (16#4004#, 16#0020#, 16#0002#),
         26140 => (16#4005#, 16#0020#, 16#0002#),
         26141 => (16#4006#, 16#0020#, 16#0002#),
         26142 => (16#4007#, 16#0020#, 16#0002#),
         26143 => (16#4008#, 16#0020#, 16#0002#),
         26144 => (16#4009#, 16#0020#, 16#0002#),
         26145 => (16#400A#, 16#0020#, 16#0002#),
         26146 => (16#400B#, 16#0020#, 16#0002#),
         26147 => (16#400C#, 16#0020#, 16#0002#),
         26148 => (16#400D#, 16#0020#, 16#0002#),
         26149 => (16#400E#, 16#0020#, 16#0002#),
         26150 => (16#400F#, 16#0020#, 16#0002#),
         26151 => (16#4010#, 16#0020#, 16#0002#),
         26152 => (16#4011#, 16#0020#, 16#0002#),
         26153 => (16#4012#, 16#0020#, 16#0002#),
         26154 => (16#4013#, 16#0020#, 16#0002#),
         26155 => (16#4014#, 16#0020#, 16#0002#),
         26156 => (16#4015#, 16#0020#, 16#0002#),
         26157 => (16#4016#, 16#0020#, 16#0002#),
         26158 => (16#4017#, 16#0020#, 16#0002#),
         26159 => (16#4018#, 16#0020#, 16#0002#),
         26160 => (16#4019#, 16#0020#, 16#0002#),
         26161 => (16#401A#, 16#0020#, 16#0002#),
         26162 => (16#401B#, 16#0020#, 16#0002#),
         26163 => (16#401C#, 16#0020#, 16#0002#),
         26164 => (16#401D#, 16#0020#, 16#0002#),
         26165 => (16#401E#, 16#0020#, 16#0002#),
         26166 => (16#401F#, 16#0020#, 16#0002#),
         26167 => (16#4020#, 16#0020#, 16#0002#),
         26168 => (16#4021#, 16#0020#, 16#0002#),
         26169 => (16#4022#, 16#0020#, 16#0002#),
         26170 => (16#4023#, 16#0020#, 16#0002#),
         26171 => (16#4024#, 16#0020#, 16#0002#),
         26172 => (16#4025#, 16#0020#, 16#0002#),
         26173 => (16#4026#, 16#0020#, 16#0002#),
         26174 => (16#4027#, 16#0020#, 16#0002#),
         26175 => (16#4028#, 16#0020#, 16#0002#),
         26176 => (16#4029#, 16#0020#, 16#0002#),
         26177 => (16#402A#, 16#0020#, 16#0002#),
         26178 => (16#402B#, 16#0020#, 16#0002#),
         26179 => (16#402C#, 16#0020#, 16#0002#),
         26180 => (16#402D#, 16#0020#, 16#0002#),
         26181 => (16#402E#, 16#0020#, 16#0002#),
         26182 => (16#402F#, 16#0020#, 16#0002#),
         26183 => (16#4030#, 16#0020#, 16#0002#),
         26184 => (16#4031#, 16#0020#, 16#0002#),
         26185 => (16#4032#, 16#0020#, 16#0002#),
         26186 => (16#4033#, 16#0020#, 16#0002#),
         26187 => (16#4034#, 16#0020#, 16#0002#),
         26188 => (16#4035#, 16#0020#, 16#0002#),
         26189 => (16#4036#, 16#0020#, 16#0002#),
         26190 => (16#4037#, 16#0020#, 16#0002#),
         26191 => (16#4038#, 16#0020#, 16#0002#),
         26192 => (16#4039#, 16#0020#, 16#0002#),
         26193 => (16#403A#, 16#0020#, 16#0002#),
         26194 => (16#403B#, 16#0020#, 16#0002#),
         26195 => (16#403C#, 16#0020#, 16#0002#),
         26196 => (16#403D#, 16#0020#, 16#0002#),
         26197 => (16#403E#, 16#0020#, 16#0002#),
         26198 => (16#403F#, 16#0020#, 16#0002#),
         26199 => (16#4040#, 16#0020#, 16#0002#),
         26200 => (16#4041#, 16#0020#, 16#0002#),
         26201 => (16#4042#, 16#0020#, 16#0002#),
         26202 => (16#4043#, 16#0020#, 16#0002#),
         26203 => (16#4044#, 16#0020#, 16#0002#),
         26204 => (16#4045#, 16#0020#, 16#0002#),
         26205 => (16#4046#, 16#0020#, 16#0002#),
         26206 => (16#4047#, 16#0020#, 16#0002#),
         26207 => (16#4048#, 16#0020#, 16#0002#),
         26208 => (16#4049#, 16#0020#, 16#0002#),
         26209 => (16#404A#, 16#0020#, 16#0002#),
         26210 => (16#404B#, 16#0020#, 16#0002#),
         26211 => (16#404C#, 16#0020#, 16#0002#),
         26212 => (16#404D#, 16#0020#, 16#0002#),
         26213 => (16#404E#, 16#0020#, 16#0002#),
         26214 => (16#404F#, 16#0020#, 16#0002#),
         26215 => (16#4050#, 16#0020#, 16#0002#),
         26216 => (16#4051#, 16#0020#, 16#0002#),
         26217 => (16#4052#, 16#0020#, 16#0002#),
         26218 => (16#4053#, 16#0020#, 16#0002#),
         26219 => (16#4054#, 16#0020#, 16#0002#),
         26220 => (16#4055#, 16#0020#, 16#0002#),
         26221 => (16#4056#, 16#0020#, 16#0002#),
         26222 => (16#4057#, 16#0020#, 16#0002#),
         26223 => (16#4058#, 16#0020#, 16#0002#),
         26224 => (16#4059#, 16#0020#, 16#0002#),
         26225 => (16#405A#, 16#0020#, 16#0002#),
         26226 => (16#405B#, 16#0020#, 16#0002#),
         26227 => (16#405C#, 16#0020#, 16#0002#),
         26228 => (16#405D#, 16#0020#, 16#0002#),
         26229 => (16#405E#, 16#0020#, 16#0002#),
         26230 => (16#405F#, 16#0020#, 16#0002#),
         26231 => (16#4060#, 16#0020#, 16#0002#),
         26232 => (16#4061#, 16#0020#, 16#0002#),
         26233 => (16#4062#, 16#0020#, 16#0002#),
         26234 => (16#1071#, 16#0020#, 16#0002#),
         26235 => (16#0185#, 16#0020#, 16#0002#),
         26236 => (16#0E8C#, 16#0020#, 16#0002#),
         26237 => (16#0E8D#, 16#0020#, 16#0002#),
         26238 => (16#0E8E#, 16#0020#, 16#0002#),
         26239 => (16#0E8F#, 16#0020#, 16#0002#),
         26240 => (16#0E90#, 16#0020#, 16#0002#),
         26241 => (16#0E91#, 16#0020#, 16#0002#),
         26242 => (16#0E92#, 16#0020#, 16#0002#),
         26243 => (16#0E93#, 16#0020#, 16#0002#),
         26244 => (16#0E94#, 16#0020#, 16#0002#),
         26245 => (16#0E95#, 16#0020#, 16#0002#),
         26246 => (16#0E96#, 16#0020#, 16#0002#),
         26247 => (16#0E97#, 16#0020#, 16#0002#),
         26248 => (16#0E98#, 16#0020#, 16#0002#),
         26249 => (16#0E99#, 16#0020#, 16#0002#),
         26250 => (16#0E9A#, 16#0020#, 16#0002#),
         26251 => (16#0E9B#, 16#0020#, 16#0002#),
         26252 => (16#0E9C#, 16#0020#, 16#0002#),
         26253 => (16#0E9D#, 16#0020#, 16#0002#),
         26254 => (16#0E9E#, 16#0020#, 16#0002#),
         26255 => (16#0E9F#, 16#0020#, 16#0002#),
         26256 => (16#0EA0#, 16#0020#, 16#0002#),
         26257 => (16#0EA1#, 16#0020#, 16#0002#),
         26258 => (16#0EA2#, 16#0020#, 16#0002#),
         26259 => (16#0EA3#, 16#0020#, 16#0002#),
         26260 => (16#0EA4#, 16#0020#, 16#0002#),
         26261 => (16#0EA5#, 16#0020#, 16#0002#),
         26262 => (16#0EA6#, 16#0020#, 16#0002#),
         26263 => (16#0EA7#, 16#0020#, 16#0002#),
         26264 => (16#0EA8#, 16#0020#, 16#0002#),
         26265 => (16#0EA9#, 16#0020#, 16#0002#),
         26266 => (16#0EAA#, 16#0020#, 16#0002#),
         26267 => (16#0EAB#, 16#0020#, 16#0002#),
         26268 => (16#0EAC#, 16#0020#, 16#0002#),
         26269 => (16#0EAD#, 16#0020#, 16#0002#),
         26270 => (16#0EAE#, 16#0020#, 16#0002#),
         26271 => (16#0EAF#, 16#0020#, 16#0002#),
         26272 => (16#0EB0#, 16#0020#, 16#0002#),
         26273 => (16#0EB1#, 16#0020#, 16#0002#),
         26274 => (16#0EB2#, 16#0020#, 16#0002#),
         26275 => (16#0EB3#, 16#0020#, 16#0002#),
         26276 => (16#0EB4#, 16#0020#, 16#0002#),
         26277 => (16#0EB5#, 16#0020#, 16#0002#),
         26278 => (16#0EB6#, 16#0020#, 16#0002#),
         26279 => (16#0EB7#, 16#0020#, 16#0002#),
         26280 => (16#0EB8#, 16#0020#, 16#0002#),
         26281 => (16#0EB9#, 16#0020#, 16#0002#),
         26282 => (16#0EBA#, 16#0020#, 16#0002#),
         26283 => (16#0EBB#, 16#0020#, 16#0002#),
         26284 => (16#0EBC#, 16#0020#, 16#0002#),
         26285 => (16#0EBD#, 16#0020#, 16#0002#),
         26286 => (16#0EBE#, 16#0020#, 16#0002#),
         26287 => (16#0EBF#, 16#0020#, 16#0002#),
         26288 => (16#0EC0#, 16#0020#, 16#0002#),
         26289 => (16#0EC1#, 16#0020#, 16#0002#),
         26290 => (16#0EC2#, 16#0020#, 16#0002#),
         26291 => (16#0EC3#, 16#0020#, 16#0002#),
         26292 => (16#0EC4#, 16#0020#, 16#0002#),
         26293 => (16#0EC5#, 16#0020#, 16#0002#),
         26294 => (16#0EC6#, 16#0020#, 16#0002#),
         26295 => (16#0EC7#, 16#0020#, 16#0002#),
         26296 => (16#0EC8#, 16#0020#, 16#0002#),
         26297 => (16#0EC9#, 16#0020#, 16#0002#),
         26298 => (16#0ECA#, 16#0020#, 16#0002#),
         26299 => (16#0ECB#, 16#0020#, 16#0002#),
         26300 => (16#0ECC#, 16#0020#, 16#0002#),
         26301 => (16#0ECD#, 16#0020#, 16#0002#),
         26302 => (16#0ECE#, 16#0020#, 16#0002#),
         26303 => (16#0ECF#, 16#0020#, 16#0002#),
         26304 => (16#0ED0#, 16#0020#, 16#0002#),
         26305 => (16#0ED1#, 16#0020#, 16#0002#),
         26306 => (16#0ED2#, 16#0020#, 16#0002#),
         26307 => (16#0ED3#, 16#0020#, 16#0002#),
         26308 => (16#0ED4#, 16#0020#, 16#0002#),
         26309 => (16#0ED5#, 16#0020#, 16#0002#),
         26310 => (16#0ED6#, 16#0020#, 16#0002#),
         26311 => (16#0ED7#, 16#0020#, 16#0002#),
         26312 => (16#0ED8#, 16#0020#, 16#0002#),
         26313 => (16#0ED9#, 16#0020#, 16#0002#),
         26314 => (16#0EDA#, 16#0020#, 16#0002#),
         26315 => (16#0EDB#, 16#0020#, 16#0002#),
         26316 => (16#0EDC#, 16#0020#, 16#0002#),
         26317 => (16#0EDD#, 16#0020#, 16#0002#),
         26318 => (16#0EDE#, 16#0020#, 16#0002#),
         26319 => (16#0EDF#, 16#0020#, 16#0002#),
         26320 => (16#0EE0#, 16#0020#, 16#0002#),
         26321 => (16#0EE1#, 16#0020#, 16#0002#),
         26322 => (16#0EE2#, 16#0020#, 16#0002#),
         26323 => (16#0EE3#, 16#0020#, 16#0002#),
         26324 => (16#0EE4#, 16#0020#, 16#0002#),
         26325 => (16#0EE5#, 16#0020#, 16#0002#),
         26326 => (16#0EE6#, 16#0020#, 16#0002#),
         26327 => (16#0EE7#, 16#0020#, 16#0002#),
         26328 => (16#0EE8#, 16#0020#, 16#0002#),
         26329 => (16#0EE9#, 16#0020#, 16#0002#),
         26330 => (16#0EEA#, 16#0020#, 16#0002#),
         26331 => (16#0EEB#, 16#0020#, 16#0002#),
         26332 => (16#0EEC#, 16#0020#, 16#0002#),
         26333 => (16#0EED#, 16#0020#, 16#0002#),
         26334 => (16#0EEE#, 16#0020#, 16#0002#),
         26335 => (16#0EEF#, 16#0020#, 16#0002#),
         26336 => (16#0EF0#, 16#0020#, 16#0002#),
         26337 => (16#0EF1#, 16#0020#, 16#0002#),
         26338 => (16#0EF2#, 16#0020#, 16#0002#),
         26339 => (16#0EF3#, 16#0020#, 16#0002#),
         26340 => (16#0EF4#, 16#0020#, 16#0002#),
         26341 => (16#0EF5#, 16#0020#, 16#0002#),
         26342 => (16#0EF6#, 16#0020#, 16#0002#),
         26343 => (16#0EF7#, 16#0020#, 16#0002#),
         26344 => (16#0EF8#, 16#0020#, 16#0002#),
         26345 => (16#0EF9#, 16#0020#, 16#0002#),
         26346 => (16#0EFA#, 16#0020#, 16#0002#),
         26347 => (16#0EFB#, 16#0020#, 16#0002#),
         26348 => (16#0EFC#, 16#0020#, 16#0002#),
         26349 => (16#0EFD#, 16#0020#, 16#0002#),
         26350 => (16#0EFE#, 16#0020#, 16#0002#),
         26351 => (16#0EFF#, 16#0020#, 16#0002#),
         26352 => (16#0F00#, 16#0020#, 16#0002#),
         26353 => (16#0F01#, 16#0020#, 16#0002#),
         26354 => (16#0F02#, 16#0020#, 16#0002#),
         26355 => (16#0F03#, 16#0020#, 16#0002#),
         26356 => (16#0F04#, 16#0020#, 16#0002#),
         26357 => (16#0F05#, 16#0020#, 16#0002#),
         26358 => (16#0F06#, 16#0020#, 16#0002#),
         26359 => (16#0F07#, 16#0020#, 16#0002#),
         26360 => (16#0F08#, 16#0020#, 16#0002#),
         26361 => (16#0F09#, 16#0020#, 16#0002#),
         26362 => (16#0F0A#, 16#0020#, 16#0002#),
         26363 => (16#0F0B#, 16#0020#, 16#0002#),
         26364 => (16#0F0C#, 16#0020#, 16#0002#),
         26365 => (16#0F0D#, 16#0020#, 16#0002#),
         26366 => (16#0F0E#, 16#0020#, 16#0002#),
         26367 => (16#0F0F#, 16#0020#, 16#0002#),
         26368 => (16#0F10#, 16#0020#, 16#0002#),
         26369 => (16#0F11#, 16#0020#, 16#0002#),
         26370 => (16#0F12#, 16#0020#, 16#0002#),
         26371 => (16#0F13#, 16#0020#, 16#0002#),
         26372 => (16#0F14#, 16#0020#, 16#0002#),
         26373 => (16#0F15#, 16#0020#, 16#0002#),
         26374 => (16#0F16#, 16#0020#, 16#0002#),
         26375 => (16#0F17#, 16#0020#, 16#0002#),
         26376 => (16#0F18#, 16#0020#, 16#0002#),
         26377 => (16#0F19#, 16#0020#, 16#0002#),
         26378 => (16#0F1A#, 16#0020#, 16#0002#),
         26379 => (16#0F1B#, 16#0020#, 16#0002#),
         26380 => (16#0F1C#, 16#0020#, 16#0002#),
         26381 => (16#0F1D#, 16#0020#, 16#0002#),
         26382 => (16#0F1E#, 16#0020#, 16#0002#),
         26383 => (16#0F1F#, 16#0020#, 16#0002#),
         26384 => (16#0F20#, 16#0020#, 16#0002#),
         26385 => (16#0F21#, 16#0020#, 16#0002#),
         26386 => (16#0F22#, 16#0020#, 16#0002#),
         26387 => (16#0F23#, 16#0020#, 16#0002#),
         26388 => (16#0F24#, 16#0020#, 16#0002#),
         26389 => (16#0F25#, 16#0020#, 16#0002#),
         26390 => (16#0F26#, 16#0020#, 16#0002#),
         26391 => (16#0F27#, 16#0020#, 16#0002#),
         26392 => (16#0F28#, 16#0020#, 16#0002#),
         26393 => (16#0F29#, 16#0020#, 16#0002#),
         26394 => (16#0F2A#, 16#0020#, 16#0002#),
         26395 => (16#0F2B#, 16#0020#, 16#0002#),
         26396 => (16#0F2C#, 16#0020#, 16#0002#),
         26397 => (16#0F2D#, 16#0020#, 16#0002#),
         26398 => (16#0F2E#, 16#0020#, 16#0002#),
         26399 => (16#0F2F#, 16#0020#, 16#0002#),
         26400 => (16#0F30#, 16#0020#, 16#0002#),
         26401 => (16#0F31#, 16#0020#, 16#0002#),
         26402 => (16#0F32#, 16#0020#, 16#0002#),
         26403 => (16#0F33#, 16#0020#, 16#0002#),
         26404 => (16#0F34#, 16#0020#, 16#0002#),
         26405 => (16#0F35#, 16#0020#, 16#0002#),
         26406 => (16#0F36#, 16#0020#, 16#0002#),
         26407 => (16#0F37#, 16#0020#, 16#0002#),
         26408 => (16#0F38#, 16#0020#, 16#0002#),
         26409 => (16#0F39#, 16#0020#, 16#0002#),
         26410 => (16#0F3A#, 16#0020#, 16#0002#),
         26411 => (16#0F3B#, 16#0020#, 16#0002#),
         26412 => (16#0F3C#, 16#0020#, 16#0002#),
         26413 => (16#0F3D#, 16#0020#, 16#0002#),
         26414 => (16#0F3E#, 16#0020#, 16#0002#),
         26415 => (16#0F3F#, 16#0020#, 16#0002#),
         26416 => (16#0F40#, 16#0020#, 16#0002#),
         26417 => (16#0F41#, 16#0020#, 16#0002#),
         26418 => (16#0F42#, 16#0020#, 16#0002#),
         26419 => (16#0F43#, 16#0020#, 16#0002#),
         26420 => (16#0F44#, 16#0020#, 16#0002#),
         26421 => (16#0F45#, 16#0020#, 16#0002#),
         26422 => (16#0F46#, 16#0020#, 16#0002#),
         26423 => (16#0F47#, 16#0020#, 16#0002#),
         26424 => (16#0F48#, 16#0020#, 16#0002#),
         26425 => (16#0F49#, 16#0020#, 16#0002#),
         26426 => (16#0F4A#, 16#0020#, 16#0002#),
         26427 => (16#0F4B#, 16#0020#, 16#0002#),
         26428 => (16#0F4C#, 16#0020#, 16#0002#),
         26429 => (16#0F4D#, 16#0020#, 16#0002#),
         26430 => (16#0F4E#, 16#0020#, 16#0002#),
         26431 => (16#0F4F#, 16#0020#, 16#0002#),
         26432 => (16#0F50#, 16#0020#, 16#0002#),
         26433 => (16#0F51#, 16#0020#, 16#0002#),
         26434 => (16#0F52#, 16#0020#, 16#0002#),
         26435 => (16#0F53#, 16#0020#, 16#0002#),
         26436 => (16#0F54#, 16#0020#, 16#0002#),
         26437 => (16#0F55#, 16#0020#, 16#0002#),
         26438 => (16#0F56#, 16#0020#, 16#0002#),
         26439 => (16#0F57#, 16#0020#, 16#0002#),
         26440 => (16#0F58#, 16#0020#, 16#0002#),
         26441 => (16#0F59#, 16#0020#, 16#0002#),
         26442 => (16#0F5A#, 16#0020#, 16#0002#),
         26443 => (16#0F5B#, 16#0020#, 16#0002#),
         26444 => (16#0F5C#, 16#0020#, 16#0002#),
         26445 => (16#0F5D#, 16#0020#, 16#0002#),
         26446 => (16#0F5E#, 16#0020#, 16#0002#),
         26447 => (16#0F5F#, 16#0020#, 16#0002#),
         26448 => (16#0F60#, 16#0020#, 16#0002#),
         26449 => (16#0F61#, 16#0020#, 16#0002#),
         26450 => (16#0F62#, 16#0020#, 16#0002#),
         26451 => (16#0F63#, 16#0020#, 16#0002#),
         26452 => (16#0F64#, 16#0020#, 16#0002#),
         26453 => (16#0F65#, 16#0020#, 16#0002#),
         26454 => (16#0F66#, 16#0020#, 16#0002#),
         26455 => (16#0F67#, 16#0020#, 16#0002#),
         26456 => (16#0F68#, 16#0020#, 16#0002#),
         26457 => (16#0F69#, 16#0020#, 16#0002#),
         26458 => (16#0F6A#, 16#0020#, 16#0002#),
         26459 => (16#0F6B#, 16#0020#, 16#0002#),
         26460 => (16#0F6C#, 16#0020#, 16#0002#),
         26461 => (16#0F6D#, 16#0020#, 16#0002#),
         26462 => (16#0F6E#, 16#0020#, 16#0002#),
         26463 => (16#0F6F#, 16#0020#, 16#0002#),
         26464 => (16#0F70#, 16#0020#, 16#0002#),
         26465 => (16#0F71#, 16#0020#, 16#0002#),
         26466 => (16#0F72#, 16#0020#, 16#0002#),
         26467 => (16#0F73#, 16#0020#, 16#0002#),
         26468 => (16#0F74#, 16#0020#, 16#0002#),
         26469 => (16#0F75#, 16#0020#, 16#0002#),
         26470 => (16#0F76#, 16#0020#, 16#0002#),
         26471 => (16#0F77#, 16#0020#, 16#0002#),
         26472 => (16#0F78#, 16#0020#, 16#0002#),
         26473 => (16#0F79#, 16#0020#, 16#0002#),
         26474 => (16#0F7A#, 16#0020#, 16#0002#),
         26475 => (16#0F7B#, 16#0020#, 16#0002#),
         26476 => (16#0F7C#, 16#0020#, 16#0002#),
         26477 => (16#0F7D#, 16#0020#, 16#0002#),
         26478 => (16#0F7E#, 16#0020#, 16#0002#),
         26479 => (16#0F7F#, 16#0020#, 16#0002#),
         26480 => (16#0F80#, 16#0020#, 16#0002#),
         26481 => (16#0F81#, 16#0020#, 16#0002#),
         26482 => (16#0F82#, 16#0020#, 16#0002#),
         26483 => (16#0F83#, 16#0020#, 16#0002#),
         26484 => (16#0F84#, 16#0020#, 16#0002#),
         26485 => (16#0F85#, 16#0020#, 16#0002#),
         26486 => (16#0F86#, 16#0020#, 16#0002#),
         26487 => (16#0F87#, 16#0020#, 16#0002#),
         26488 => (16#0F88#, 16#0020#, 16#0002#),
         26489 => (16#0F89#, 16#0020#, 16#0002#),
         26490 => (16#0F8A#, 16#0020#, 16#0002#),
         26491 => (16#0F8B#, 16#0020#, 16#0002#),
         26492 => (16#0F8C#, 16#0020#, 16#0002#),
         26493 => (16#0F8D#, 16#0020#, 16#0002#),
         26494 => (16#0F8E#, 16#0020#, 16#0002#),
         26495 => (16#0F8F#, 16#0020#, 16#0002#),
         26496 => (16#0F90#, 16#0020#, 16#0002#),
         26497 => (16#0F91#, 16#0020#, 16#0002#),
         26498 => (16#0F92#, 16#0020#, 16#0002#),
         26499 => (16#0F93#, 16#0020#, 16#0002#),
         26500 => (16#0F94#, 16#0020#, 16#0002#),
         26501 => (16#0F95#, 16#0020#, 16#0002#),
         26502 => (16#0F96#, 16#0020#, 16#0002#),
         26503 => (16#0F97#, 16#0020#, 16#0002#),
         26504 => (16#0F98#, 16#0020#, 16#0002#),
         26505 => (16#0F99#, 16#0020#, 16#0002#),
         26506 => (16#0F9A#, 16#0020#, 16#0002#),
         26507 => (16#0F9B#, 16#0020#, 16#0002#),
         26508 => (16#0F9C#, 16#0020#, 16#0002#),
         26509 => (16#0F9D#, 16#0020#, 16#0002#),
         26510 => (16#0F9E#, 16#0020#, 16#0002#),
         26511 => (16#0F9F#, 16#0020#, 16#0002#),
         26512 => (16#0FA0#, 16#0020#, 16#0002#),
         26513 => (16#0FA1#, 16#0020#, 16#0002#),
         26514 => (16#0FA2#, 16#0020#, 16#0002#),
         26515 => (16#0FA3#, 16#0020#, 16#0002#),
         26516 => (16#0FA4#, 16#0020#, 16#0002#),
         26517 => (16#0FA5#, 16#0020#, 16#0002#),
         26518 => (16#0FA6#, 16#0020#, 16#0002#),
         26519 => (16#0FA7#, 16#0020#, 16#0002#),
         26520 => (16#0FA8#, 16#0020#, 16#0002#),
         26521 => (16#0FBC#, 16#0020#, 16#0002#),
         26522 => (16#0FAC#, 16#0020#, 16#0002#),
         26523 => (16#0FAD#, 16#0020#, 16#0002#),
         26524 => (16#0FAE#, 16#0020#, 16#0002#),
         26525 => (16#0FAF#, 16#0020#, 16#0002#),
         26526 => (16#0FB0#, 16#0020#, 16#0002#),
         26527 => (16#0FB1#, 16#0020#, 16#0002#),
         26528 => (16#0FB2#, 16#0020#, 16#0002#),
         26529 => (16#0FB3#, 16#0020#, 16#0002#),
         26530 => (16#0FB4#, 16#0020#, 16#0002#),
         26531 => (16#0FB5#, 16#0020#, 16#0002#),
         26532 => (16#0FB6#, 16#0020#, 16#0002#),
         26533 => (16#0FB7#, 16#0020#, 16#0002#),
         26534 => (16#0FB8#, 16#0020#, 16#0002#),
         26535 => (16#0FB9#, 16#0020#, 16#0002#),
         26536 => (16#0FBA#, 16#0020#, 16#0002#),
         26537 => (16#0FBB#, 16#0020#, 16#0002#),
         26538 => (16#0FBD#, 16#0020#, 16#0002#),
         26539 => (16#0FBE#, 16#0020#, 16#0002#),
         26540 => (16#0FBF#, 16#0020#, 16#0002#),
         26541 => (16#0FC0#, 16#0020#, 16#0002#),
         26542 => (16#0FC1#, 16#0020#, 16#0002#),
         26543 => (16#0FC2#, 16#0020#, 16#0002#),
         26544 => (16#0FC3#, 16#0020#, 16#0002#),
         26545 => (16#0FC4#, 16#0020#, 16#0002#),
         26546 => (16#0FC5#, 16#0020#, 16#0002#),
         26547 => (16#0FC6#, 16#0020#, 16#0002#),
         26548 => (16#0FC7#, 16#0020#, 16#0002#),
         26549 => (16#0FC8#, 16#0020#, 16#0002#),
         26550 => (16#0FC9#, 16#0020#, 16#0002#),
         26551 => (16#0FCA#, 16#0020#, 16#0002#),
         26552 => (16#0FCB#, 16#0020#, 16#0002#),
         26553 => (16#0FCC#, 16#0020#, 16#0002#),
         26554 => (16#0FCD#, 16#0020#, 16#0002#),
         26555 => (16#0FCE#, 16#0020#, 16#0002#),
         26556 => (16#0FCF#, 16#0020#, 16#0002#),
         26557 => (16#0FD0#, 16#0020#, 16#0002#),
         26558 => (16#0FD1#, 16#0020#, 16#0002#),
         26559 => (16#0FD2#, 16#0020#, 16#0002#),
         26560 => (16#0FD3#, 16#0020#, 16#0002#),
         26561 => (16#0FD4#, 16#0020#, 16#0002#),
         26562 => (16#0FD5#, 16#0020#, 16#0002#),
         26563 => (16#0FD6#, 16#0020#, 16#0002#),
         26564 => (16#0FD7#, 16#0020#, 16#0002#),
         26565 => (16#0FD8#, 16#0020#, 16#0002#),
         26566 => (16#0FD9#, 16#0020#, 16#0002#),
         26567 => (16#0FDA#, 16#0020#, 16#0002#),
         26568 => (16#0FDB#, 16#0020#, 16#0002#),
         26569 => (16#0FDC#, 16#0020#, 16#0002#),
         26570 => (16#0FDD#, 16#0020#, 16#0002#),
         26571 => (16#0FDE#, 16#0020#, 16#0002#),
         26572 => (16#0FDF#, 16#0020#, 16#0002#),
         26573 => (16#0FE0#, 16#0020#, 16#0002#),
         26574 => (16#0FE1#, 16#0020#, 16#0002#),
         26575 => (16#0FE2#, 16#0020#, 16#0002#),
         26576 => (16#0FE3#, 16#0020#, 16#0002#),
         26577 => (16#0FE4#, 16#0020#, 16#0002#),
         26578 => (16#0FE5#, 16#0020#, 16#0002#),
         26579 => (16#0FE6#, 16#0020#, 16#0002#),
         26580 => (16#0FE7#, 16#0020#, 16#0002#),
         26581 => (16#0FE8#, 16#0020#, 16#0002#),
         26582 => (16#0FE9#, 16#0020#, 16#0002#),
         26583 => (16#0FEA#, 16#0020#, 16#0002#),
         26584 => (16#0FEB#, 16#0020#, 16#0002#),
         26585 => (16#0FEC#, 16#0020#, 16#0002#),
         26586 => (16#0FED#, 16#0020#, 16#0002#),
         26587 => (16#0FEE#, 16#0020#, 16#0002#),
         26588 => (16#0FEF#, 16#0020#, 16#0002#),
         26589 => (16#0FF0#, 16#0020#, 16#0002#),
         26590 => (16#0FF1#, 16#0020#, 16#0002#),
         26591 => (16#0FF2#, 16#0020#, 16#0002#),
         26592 => (16#0FF3#, 16#0020#, 16#0002#),
         26593 => (16#0FF4#, 16#0020#, 16#0002#),
         26594 => (16#0FF5#, 16#0020#, 16#0002#),
         26595 => (16#0FF6#, 16#0020#, 16#0002#),
         26596 => (16#0FF7#, 16#0020#, 16#0002#),
         26597 => (16#0FF8#, 16#0020#, 16#0002#),
         26598 => (16#0FF9#, 16#0020#, 16#0002#),
         26599 => (16#0FFA#, 16#0020#, 16#0002#),
         26600 => (16#0FFB#, 16#0020#, 16#0002#),
         26601 => (16#0FFC#, 16#0020#, 16#0002#),
         26602 => (16#0FFD#, 16#0020#, 16#0002#),
         26603 => (16#0FFE#, 16#0020#, 16#0002#),
         26604 => (16#0FFF#, 16#0020#, 16#0002#),
         26605 => (16#1000#, 16#0020#, 16#0002#),
         26606 => (16#1001#, 16#0020#, 16#0002#),
         26607 => (16#1002#, 16#0020#, 16#0002#),
         26608 => (16#1003#, 16#0020#, 16#0002#),
         26609 => (16#1004#, 16#0020#, 16#0002#),
         26610 => (16#1005#, 16#0020#, 16#0002#),
         26611 => (16#1006#, 16#0020#, 16#0002#),
         26612 => (16#1007#, 16#0020#, 16#0002#),
         26613 => (16#1008#, 16#0020#, 16#0002#),
         26614 => (16#1009#, 16#0020#, 16#0002#),
         26615 => (16#100A#, 16#0020#, 16#0002#),
         26616 => (16#100B#, 16#0020#, 16#0002#),
         26617 => (16#100C#, 16#0020#, 16#0002#),
         26618 => (16#100D#, 16#0020#, 16#0002#),
         26619 => (16#100E#, 16#0020#, 16#0002#),
         26620 => (16#100F#, 16#0020#, 16#0002#),
         26621 => (16#1010#, 16#0020#, 16#0002#),
         26622 => (16#1011#, 16#0020#, 16#0002#),
         26623 => (16#1012#, 16#0020#, 16#0002#),
         26624 => (16#1013#, 16#0020#, 16#0002#),
         26625 => (16#1014#, 16#0020#, 16#0002#),
         26626 => (16#1015#, 16#0020#, 16#0002#),
         26627 => (16#1016#, 16#0020#, 16#0002#),
         26628 => (16#1017#, 16#0020#, 16#0002#),
         26629 => (16#1018#, 16#0020#, 16#0002#),
         26630 => (16#1019#, 16#0020#, 16#0002#),
         26631 => (16#101A#, 16#0020#, 16#0002#),
         26632 => (16#101B#, 16#0020#, 16#0002#),
         26633 => (16#101C#, 16#0020#, 16#0002#),
         26634 => (16#101D#, 16#0020#, 16#0002#),
         26635 => (16#101E#, 16#0020#, 16#0002#),
         26636 => (16#101F#, 16#0020#, 16#0002#),
         26637 => (16#1020#, 16#0020#, 16#0002#),
         26638 => (16#1021#, 16#0020#, 16#0002#),
         26639 => (16#1022#, 16#0020#, 16#0002#),
         26640 => (16#1023#, 16#0020#, 16#0002#),
         26641 => (16#1024#, 16#0020#, 16#0002#),
         26642 => (16#1025#, 16#0020#, 16#0002#),
         26643 => (16#1026#, 16#0020#, 16#0002#),
         26644 => (16#1027#, 16#0020#, 16#0002#),
         26645 => (16#1028#, 16#0020#, 16#0002#),
         26646 => (16#1029#, 16#0020#, 16#0002#),
         26647 => (16#102A#, 16#0020#, 16#0002#),
         26648 => (16#102B#, 16#0020#, 16#0002#),
         26649 => (16#102C#, 16#0020#, 16#0002#),
         26650 => (16#102D#, 16#0020#, 16#0002#),
         26651 => (16#102E#, 16#0020#, 16#0002#),
         26652 => (16#102F#, 16#0020#, 16#0002#),
         26653 => (16#1030#, 16#0020#, 16#0002#),
         26654 => (16#1031#, 16#0020#, 16#0002#),
         26655 => (16#1032#, 16#0020#, 16#0002#),
         26656 => (16#1033#, 16#0020#, 16#0002#),
         26657 => (16#1034#, 16#0020#, 16#0002#),
         26658 => (16#1035#, 16#0020#, 16#0002#),
         26659 => (16#1036#, 16#0020#, 16#0002#),
         26660 => (16#1037#, 16#0020#, 16#0002#),
         26661 => (16#1038#, 16#0020#, 16#0002#),
         26662 => (16#1039#, 16#0020#, 16#0002#),
         26663 => (16#103A#, 16#0020#, 16#0002#),
         26664 => (16#103B#, 16#0020#, 16#0002#),
         26665 => (16#103C#, 16#0020#, 16#0002#),
         26666 => (16#103D#, 16#0020#, 16#0002#),
         26667 => (16#103E#, 16#0020#, 16#0002#),
         26668 => (16#103F#, 16#0020#, 16#0002#),
         26669 => (16#1040#, 16#0020#, 16#0002#),
         26670 => (16#1041#, 16#0020#, 16#0002#),
         26671 => (16#1042#, 16#0020#, 16#0002#),
         26672 => (16#1043#, 16#0020#, 16#0002#),
         26673 => (16#1044#, 16#0020#, 16#0002#),
         26674 => (16#1045#, 16#0020#, 16#0002#),
         26675 => (16#1046#, 16#0020#, 16#0002#),
         26676 => (16#1047#, 16#0020#, 16#0002#),
         26677 => (16#1048#, 16#0020#, 16#0002#),
         26678 => (16#1049#, 16#0020#, 16#0002#),
         26679 => (16#104A#, 16#0020#, 16#0002#),
         26680 => (16#104B#, 16#0020#, 16#0002#),
         26681 => (16#104C#, 16#0020#, 16#0002#),
         26682 => (16#104D#, 16#0020#, 16#0002#),
         26683 => (16#104E#, 16#0020#, 16#0002#),
         26684 => (16#104F#, 16#0020#, 16#0002#),
         26685 => (16#1050#, 16#0020#, 16#0002#),
         26686 => (16#1051#, 16#0020#, 16#0002#),
         26687 => (16#1052#, 16#0020#, 16#0002#),
         26688 => (16#1053#, 16#0020#, 16#0002#),
         26689 => (16#1054#, 16#0020#, 16#0002#),
         26690 => (16#1055#, 16#0020#, 16#0002#),
         26691 => (16#1056#, 16#0020#, 16#0002#),
         26692 => (16#1057#, 16#0020#, 16#0002#),
         26693 => (16#1058#, 16#0020#, 16#0002#),
         26694 => (16#1059#, 16#0020#, 16#0002#),
         26695 => (16#105A#, 16#0020#, 16#0002#),
         26696 => (16#105B#, 16#0020#, 16#0002#),
         26697 => (16#105C#, 16#0020#, 16#0002#),
         26698 => (16#105D#, 16#0020#, 16#0002#),
         26699 => (16#105E#, 16#0020#, 16#0002#),
         26700 => (16#105F#, 16#0020#, 16#0002#),
         26701 => (16#1060#, 16#0020#, 16#0002#),
         26702 => (16#1061#, 16#0020#, 16#0002#),
         26703 => (16#1062#, 16#0020#, 16#0002#),
         26704 => (16#1063#, 16#0020#, 16#0002#),
         26705 => (16#1064#, 16#0020#, 16#0002#),
         26706 => (16#1065#, 16#0020#, 16#0002#),
         26707 => (16#1066#, 16#0020#, 16#0002#),
         26708 => (16#1067#, 16#0020#, 16#0002#),
         26709 => (16#1068#, 16#0020#, 16#0002#),
         26710 => (16#1069#, 16#0020#, 16#0002#),
         26711 => (16#106A#, 16#0020#, 16#0002#),
         26712 => (16#106B#, 16#0020#, 16#0002#),
         26713 => (16#106C#, 16#0020#, 16#0002#),
         26714 => (16#106D#, 16#0020#, 16#0002#),
         26715 => (16#106E#, 16#0020#, 16#0002#),
         26716 => (16#106F#, 16#0020#, 16#0002#),
         26717 => (16#1070#, 16#0020#, 16#0002#),
         26718 => (16#0DA2#, 16#0020#, 16#0002#),
         26719 => (16#0DA3#, 16#0020#, 16#0002#),
         26720 => (16#0DA4#, 16#0020#, 16#0002#),
         26721 => (16#0DA5#, 16#0020#, 16#0002#),
         26722 => (16#0DA6#, 16#0020#, 16#0002#),
         26723 => (16#0DA7#, 16#0020#, 16#0002#),
         26724 => (16#0DA8#, 16#0020#, 16#0002#),
         26725 => (16#0DA9#, 16#0020#, 16#0002#),
         26726 => (16#0DAA#, 16#0020#, 16#0002#),
         26727 => (16#0DAB#, 16#0020#, 16#0002#),
         26728 => (16#0DAC#, 16#0020#, 16#0002#),
         26729 => (16#0DAD#, 16#0020#, 16#0002#),
         26730 => (16#0DAE#, 16#0020#, 16#0002#),
         26731 => (16#0DAF#, 16#0020#, 16#0002#),
         26732 => (16#0DB0#, 16#0020#, 16#0002#),
         26733 => (16#0DB1#, 16#0020#, 16#0002#),
         26734 => (16#0DB2#, 16#0020#, 16#0002#),
         26735 => (16#0DB3#, 16#0020#, 16#0002#),
         26736 => (16#0DB4#, 16#0020#, 16#0002#),
         26737 => (16#0DB5#, 16#0020#, 16#0002#),
         26738 => (16#0DB6#, 16#0020#, 16#0002#),
         26739 => (16#0DB7#, 16#0020#, 16#0002#),
         26740 => (16#0DB8#, 16#0020#, 16#0002#),
         26741 => (16#0DB9#, 16#0020#, 16#0002#),
         26742 => (16#0DBA#, 16#0020#, 16#0002#),
         26743 => (16#0DBB#, 16#0020#, 16#0002#),
         26744 => (16#0DBC#, 16#0020#, 16#0002#),
         26745 => (16#0DBD#, 16#0020#, 16#0002#),
         26746 => (16#0DBE#, 16#0020#, 16#0002#),
         26747 => (16#0DBF#, 16#0020#, 16#0002#),
         26748 => (16#0DC0#, 16#0020#, 16#0002#),
         26749 => (16#0DC1#, 16#0020#, 16#0002#),
         26750 => (16#0DC2#, 16#0020#, 16#0002#),
         26751 => (16#0DC3#, 16#0020#, 16#0002#),
         26752 => (16#0DC4#, 16#0020#, 16#0002#),
         26753 => (16#0DC5#, 16#0020#, 16#0002#),
         26754 => (16#0DC6#, 16#0020#, 16#0002#),
         26755 => (16#0DC7#, 16#0020#, 16#0002#),
         26756 => (16#0DC8#, 16#0020#, 16#0002#),
         26757 => (16#0DC9#, 16#0020#, 16#0002#),
         26758 => (16#0DCA#, 16#0020#, 16#0002#),
         26759 => (16#0DCB#, 16#0020#, 16#0002#),
         26760 => (16#0DCC#, 16#0020#, 16#0002#),
         26761 => (16#0DCD#, 16#0020#, 16#0002#),
         26762 => (16#0DCE#, 16#0020#, 16#0002#),
         26763 => (16#0DCF#, 16#0020#, 16#0002#),
         26764 => (16#0DD0#, 16#0020#, 16#0002#),
         26765 => (16#0DD1#, 16#0020#, 16#0002#),
         26766 => (16#0DD2#, 16#0020#, 16#0002#),
         26767 => (16#0DD3#, 16#0020#, 16#0002#),
         26768 => (16#0DD4#, 16#0020#, 16#0002#),
         26769 => (16#0DD5#, 16#0020#, 16#0002#),
         26770 => (16#0DD6#, 16#0020#, 16#0002#),
         26771 => (16#0DD7#, 16#0020#, 16#0002#),
         26772 => (16#0DD8#, 16#0020#, 16#0002#),
         26773 => (16#0DD9#, 16#0020#, 16#0002#),
         26774 => (16#0DDA#, 16#0020#, 16#0002#),
         26775 => (16#0DDB#, 16#0020#, 16#0002#),
         26776 => (16#0DDC#, 16#0020#, 16#0002#),
         26777 => (16#0DDD#, 16#0020#, 16#0002#),
         26778 => (16#0DDE#, 16#0020#, 16#0002#),
         26779 => (16#0DDF#, 16#0020#, 16#0002#),
         26780 => (16#0DE0#, 16#0020#, 16#0002#),
         26781 => (16#0DE1#, 16#0020#, 16#0002#),
         26782 => (16#0DE2#, 16#0020#, 16#0002#),
         26783 => (16#0DE3#, 16#0020#, 16#0002#),
         26784 => (16#0DE4#, 16#0020#, 16#0002#),
         26785 => (16#0DE5#, 16#0020#, 16#0002#),
         26786 => (16#0DE6#, 16#0020#, 16#0002#),
         26787 => (16#0DE7#, 16#0020#, 16#0002#),
         26788 => (16#0DE8#, 16#0020#, 16#0002#),
         26789 => (16#0DE9#, 16#0020#, 16#0002#),
         26790 => (16#0DEA#, 16#0020#, 16#0002#),
         26791 => (16#0DEB#, 16#0020#, 16#0002#),
         26792 => (16#0DEC#, 16#0020#, 16#0002#),
         26793 => (16#0DED#, 16#0020#, 16#0002#),
         26794 => (16#0DEE#, 16#0020#, 16#0002#),
         26795 => (16#0DEF#, 16#0020#, 16#0002#),
         26796 => (16#0DF0#, 16#0020#, 16#0002#),
         26797 => (16#0DF1#, 16#0020#, 16#0002#),
         26798 => (16#0DF2#, 16#0020#, 16#0002#),
         26799 => (16#0DF3#, 16#0020#, 16#0002#),
         26800 => (16#0DF4#, 16#0020#, 16#0002#),
         26801 => (16#0DF5#, 16#0020#, 16#0002#),
         26802 => (16#0DF6#, 16#0020#, 16#0002#),
         26803 => (16#0DF7#, 16#0020#, 16#0002#),
         26804 => (16#0DF8#, 16#0020#, 16#0002#),
         26805 => (16#17FA#, 16#0020#, 16#0002#),
         26806 => (16#17FB#, 16#0020#, 16#0002#),
         26807 => (16#17FC#, 16#0020#, 16#0002#),
         26808 => (16#17FD#, 16#0020#, 16#0002#),
         26809 => (16#17FE#, 16#0020#, 16#0002#),
         26810 => (16#17FF#, 16#0020#, 16#0002#),
         26811 => (16#1800#, 16#0020#, 16#0002#),
         26812 => (16#1801#, 16#0020#, 16#0002#),
         26813 => (16#1802#, 16#0020#, 16#0002#),
         26814 => (16#190C#, 16#0020#, 16#000B#),
         26815 => (16#19B8#, 16#0020#, 16#000B#),
         26816 => (16#1A10#, 16#0020#, 16#000B#),
         26817 => (16#1A29#, 16#0020#, 16#000B#),
         26818 => (16#1AA1#, 16#0020#, 16#000B#),
         26819 => (16#1B33#, 16#0020#, 16#000B#),
         26820 => (16#1B57#, 16#0020#, 16#000B#),
         26821 => (16#1B77#, 16#0020#, 16#000B#),
         26822 => (16#1BA5#, 16#0020#, 16#000B#),
         26823 => (16#1BB7#, 16#0020#, 16#000B#),
         26824 => (16#1BC1#, 16#0020#, 16#000B#),
         26825 => (16#1BCD#, 16#0020#, 16#000B#),
         26826 => (16#190C#, 16#0020#, 16#0005#),
         26827 => (16#1925#, 16#0020#, 16#0005#),
         26828 => (16#193E#, 16#0020#, 16#0005#),
         26829 => (16#19A9#, 16#0020#, 16#0005#),
         26830 => (16#1A29#, 16#0020#, 16#0005#),
         26831 => (16#1A6E#, 16#0020#, 16#0005#),
         26832 => (16#1A7D#, 16#0020#, 16#0005#),
         26833 => (16#1ACE#, 16#0020#, 16#0005#),
         26834 => (16#1AE3#, 16#0020#, 16#0005#),
         26835 => (16#1AF5#, 16#0020#, 16#0005#),
         26836 => (16#1B33#, 16#0020#, 16#0005#),
         26837 => (16#1B57#, 16#0020#, 16#0005#),
         26838 => (16#1B77#, 16#0020#, 16#0005#),
         26839 => (16#1BA5#, 16#0020#, 16#0005#),
         26840 => (16#1BB7#, 16#0020#, 16#0005#),
         26841 => (16#1BC1#, 16#0020#, 16#0005#),
         26842 => (16#1BCD#, 16#0020#, 16#0005#),
         26843 => (16#1BE3#, 16#0020#, 16#0005#),
         26844 => (16#19FA#, 16#0020#, 16#0005#),
         26845 => (16#1A14#, 16#0020#, 16#0005#),
         26846 => (16#1C77#, 16#0020#, 16#000B#),
         26847 => (16#1C78#, 16#0020#, 16#000B#),
         26848 => (16#1C7B#, 16#0020#, 16#000B#),
         26849 => (16#1C7C#, 16#0020#, 16#000B#),
         26850 => (16#1C80#, 16#0020#, 16#000B#),
         26851 => (16#1C82#, 16#0020#, 16#000B#),
         26852 => (16#1C83#, 16#0020#, 16#000B#),
         26853 => (16#1C84#, 16#0020#, 16#000B#),
         26854 => (16#1C86#, 16#0020#, 16#000B#),
         26855 => (16#1C87#, 16#0020#, 16#000B#),
         26856 => (16#1C89#, 16#0020#, 16#000B#),
         26857 => (16#1C8A#, 16#0020#, 16#000B#),
         26858 => (16#1C8B#, 16#0020#, 16#000B#),
         26859 => (16#1C8C#, 16#0020#, 16#000B#),
         26860 => (16#1C92#, 16#0020#, 16#000B#),
         26861 => (16#1C95#, 16#0020#, 16#000B#),
         26862 => (16#1C99#, 16#0020#, 16#000B#),
         26863 => (16#1C9A#, 16#0020#, 16#000B#),
         26864 => (16#1C9B#, 16#0020#, 16#000B#),
         26865 => (16#1C9C#, 16#0020#, 16#000B#),
         26866 => (16#1C9D#, 16#0020#, 16#000B#),
         26867 => (16#1C9F#, 16#0020#, 16#000B#),
         26868 => (16#04CC#, 16#0020#, 16#0005#),
         26869 => (16#1C77#, 16#0020#, 16#0005#),
         26870 => (16#1C78#, 16#0020#, 16#0005#),
         26871 => (16#1C7B#, 16#0020#, 16#0005#),
         26872 => (16#1C7C#, 16#0020#, 16#0005#),
         26873 => (16#1C80#, 16#0020#, 16#0005#),
         26874 => (16#1C82#, 16#0020#, 16#0005#),
         26875 => (16#1C83#, 16#0020#, 16#0005#),
         26876 => (16#1C84#, 16#0020#, 16#0005#),
         26877 => (16#1C86#, 16#0020#, 16#0005#),
         26878 => (16#1C87#, 16#0020#, 16#0005#),
         26879 => (16#1C89#, 16#0020#, 16#0005#),
         26880 => (16#1C8A#, 16#0020#, 16#0005#),
         26881 => (16#1C8B#, 16#0020#, 16#0005#),
         26882 => (16#1C8C#, 16#0020#, 16#0005#),
         26883 => (16#1C92#, 16#0020#, 16#0005#),
         26884 => (16#1C95#, 16#0020#, 16#0005#),
         26885 => (16#1C99#, 16#0020#, 16#0005#),
         26886 => (16#1C9A#, 16#0020#, 16#0005#),
         26887 => (16#1C9B#, 16#0020#, 16#0005#),
         26888 => (16#1C9C#, 16#0020#, 16#0005#),
         26889 => (16#1C9D#, 16#0020#, 16#0005#),
         26890 => (16#1C9F#, 16#0020#, 16#0005#),
         26891 => (16#04C8#, 16#0020#, 16#0005#),
         26892 => (16#1C7D#, 16#0020#, 16#000B#),
         26893 => (16#1C7D#, 16#0020#, 16#0005#),
         26894 => (16#1803#, 16#0020#, 16#0005#),
         26895 => (16#1804#, 16#0020#, 16#0005#),
         26896 => (16#1805#, 16#0020#, 16#0005#),
         26897 => (16#1806#, 16#0020#, 16#0005#),
         26898 => (16#1807#, 16#0020#, 16#0005#),
         26899 => (16#1808#, 16#0020#, 16#0005#),
         26900 => (16#1809#, 16#0020#, 16#0005#),
         26901 => (16#180A#, 16#0020#, 16#0005#),
         26902 => (16#180B#, 16#0020#, 16#0005#),
         26903 => (16#180C#, 16#0020#, 16#0005#),
         26904 => (16#365E#, 16#0020#, 16#0002#),
         26905 => (16#365F#, 16#0020#, 16#0002#),
         26906 => (16#3660#, 16#0020#, 16#0002#),
         26907 => (16#3661#, 16#0020#, 16#0002#),
         26908 => (16#3662#, 16#0020#, 16#0002#),
         26909 => (16#3663#, 16#0020#, 16#0002#),
         26910 => (16#3664#, 16#0020#, 16#0002#),
         26911 => (16#3665#, 16#0020#, 16#0002#),
         26912 => (16#3666#, 16#0020#, 16#0002#),
         26913 => (16#3667#, 16#0020#, 16#0002#),
         26914 => (16#3668#, 16#0020#, 16#0002#),
         26915 => (16#3669#, 16#0020#, 16#0002#),
         26916 => (16#366A#, 16#0020#, 16#0002#),
         26917 => (16#366B#, 16#0020#, 16#0002#),
         26918 => (16#366C#, 16#0020#, 16#0002#),
         26919 => (16#366D#, 16#0020#, 16#0002#),
         26920 => (16#366E#, 16#0020#, 16#0002#),
         26921 => (16#366F#, 16#0020#, 16#0002#),
         26922 => (16#3670#, 16#0020#, 16#0002#),
         26923 => (16#3671#, 16#0020#, 16#0002#),
         26924 => (16#3672#, 16#0020#, 16#0002#),
         26925 => (16#3673#, 16#0020#, 16#0002#),
         26926 => (16#3674#, 16#0020#, 16#0002#),
         26927 => (16#3675#, 16#0020#, 16#0002#),
         26928 => (16#3676#, 16#0020#, 16#0002#),
         26929 => (16#3677#, 16#0020#, 16#0002#),
         26930 => (16#3678#, 16#0020#, 16#0002#),
         26931 => (16#3679#, 16#0020#, 16#0002#),
         26932 => (16#367A#, 16#0020#, 16#0002#),
         26933 => (16#367B#, 16#0020#, 16#0002#),
         26934 => (16#367C#, 16#0020#, 16#0002#),
         26935 => (16#367D#, 16#0020#, 16#0002#),
         26936 => (16#367E#, 16#0020#, 16#0002#),
         26937 => (16#367F#, 16#0020#, 16#0002#),
         26938 => (16#3680#, 16#0020#, 16#0002#),
         26939 => (16#3681#, 16#0020#, 16#0002#),
         26940 => (16#3682#, 16#0020#, 16#0002#),
         26941 => (16#3683#, 16#0020#, 16#0002#),
         26942 => (16#3684#, 16#0020#, 16#0002#),
         26943 => (16#3685#, 16#0020#, 16#0002#),
         26944 => (16#3686#, 16#0020#, 16#0002#),
         26945 => (16#3687#, 16#0020#, 16#0002#),
         26946 => (16#3688#, 16#0020#, 16#0002#),
         26947 => (16#3689#, 16#0020#, 16#0002#),
         26948 => (16#368A#, 16#0020#, 16#0002#),
         26949 => (16#368B#, 16#0020#, 16#0002#),
         26950 => (16#368C#, 16#0020#, 16#0002#),
         26951 => (16#368D#, 16#0020#, 16#0002#),
         26952 => (16#368E#, 16#0020#, 16#0002#),
         26953 => (16#368F#, 16#0020#, 16#0002#),
         26954 => (16#3690#, 16#0020#, 16#0002#),
         26955 => (16#3691#, 16#0020#, 16#0002#),
         26956 => (16#3692#, 16#0020#, 16#0002#),
         26957 => (16#3693#, 16#0020#, 16#0002#),
         26958 => (16#3694#, 16#0020#, 16#0002#),
         26959 => (16#3695#, 16#0020#, 16#0002#),
         26960 => (16#3696#, 16#0020#, 16#0002#),
         26961 => (16#3697#, 16#0020#, 16#0002#),
         26962 => (16#3698#, 16#0020#, 16#0002#),
         26963 => (16#3699#, 16#0020#, 16#0002#),
         26964 => (16#369A#, 16#0020#, 16#0002#),
         26965 => (16#369B#, 16#0020#, 16#0002#),
         26966 => (16#369C#, 16#0020#, 16#0002#),
         26967 => (16#369D#, 16#0020#, 16#0002#),
         26968 => (16#369E#, 16#0020#, 16#0002#),
         26969 => (16#369F#, 16#0020#, 16#0002#),
         26970 => (16#36A0#, 16#0020#, 16#0002#),
         26971 => (16#36A1#, 16#0020#, 16#0002#),
         26972 => (16#36A2#, 16#0020#, 16#0002#),
         26973 => (16#36A3#, 16#0020#, 16#0002#),
         26974 => (16#36A4#, 16#0020#, 16#0002#),
         26975 => (16#36A5#, 16#0020#, 16#0002#),
         26976 => (16#36A6#, 16#0020#, 16#0002#),
         26977 => (16#36A7#, 16#0020#, 16#0002#),
         26978 => (16#36A8#, 16#0020#, 16#0002#),
         26979 => (16#36A9#, 16#0020#, 16#0002#),
         26980 => (16#36AA#, 16#0020#, 16#0002#),
         26981 => (16#36AB#, 16#0020#, 16#0002#),
         26982 => (16#36AC#, 16#0020#, 16#0002#),
         26983 => (16#36AD#, 16#0020#, 16#0002#),
         26984 => (16#36AE#, 16#0020#, 16#0002#),
         26985 => (16#36AF#, 16#0020#, 16#0002#),
         26986 => (16#36B0#, 16#0020#, 16#0002#),
         26987 => (16#36B1#, 16#0020#, 16#0002#),
         26988 => (16#36B2#, 16#0020#, 16#0002#),
         26989 => (16#36B3#, 16#0020#, 16#0002#),
         26990 => (16#36B4#, 16#0020#, 16#0002#),
         26991 => (16#36B5#, 16#0020#, 16#0002#),
         26992 => (16#36B6#, 16#0020#, 16#0002#),
         26993 => (16#36B7#, 16#0020#, 16#0002#),
         26994 => (16#36B8#, 16#0020#, 16#0002#),
         26995 => (16#36B9#, 16#0020#, 16#0002#),
         26996 => (16#36BA#, 16#0020#, 16#0002#),
         26997 => (16#36BB#, 16#0020#, 16#0002#),
         26998 => (16#36BC#, 16#0020#, 16#0002#),
         26999 => (16#36BD#, 16#0020#, 16#0002#),
         27000 => (16#36BE#, 16#0020#, 16#0002#),
         27001 => (16#36BF#, 16#0020#, 16#0002#),
         27002 => (16#36C0#, 16#0020#, 16#0002#),
         27003 => (16#36C1#, 16#0020#, 16#0002#),
         27004 => (16#36C2#, 16#0020#, 16#0002#),
         27005 => (16#36C3#, 16#0020#, 16#0002#),
         27006 => (16#36C4#, 16#0020#, 16#0002#),
         27007 => (16#36C5#, 16#0020#, 16#0002#),
         27008 => (16#36C6#, 16#0020#, 16#0002#),
         27009 => (16#36C7#, 16#0020#, 16#0002#),
         27010 => (16#36C8#, 16#0020#, 16#0002#),
         27011 => (16#36C9#, 16#0020#, 16#0002#),
         27012 => (16#36CA#, 16#0020#, 16#0002#),
         27013 => (16#36CB#, 16#0020#, 16#0002#),
         27014 => (16#36CC#, 16#0020#, 16#0002#),
         27015 => (16#36CD#, 16#0020#, 16#0002#),
         27016 => (16#36CE#, 16#0020#, 16#0002#),
         27017 => (16#36CF#, 16#0020#, 16#0002#),
         27018 => (16#36D0#, 16#0020#, 16#0002#),
         27019 => (16#36D1#, 16#0020#, 16#0002#),
         27020 => (16#36D2#, 16#0020#, 16#0002#),
         27021 => (16#36D3#, 16#0020#, 16#0002#),
         27022 => (16#36D4#, 16#0020#, 16#0002#),
         27023 => (16#36D5#, 16#0020#, 16#0002#),
         27024 => (16#36D6#, 16#0020#, 16#0002#),
         27025 => (16#36D7#, 16#0020#, 16#0002#),
         27026 => (16#36D8#, 16#0020#, 16#0002#),
         27027 => (16#36D9#, 16#0020#, 16#0002#),
         27028 => (16#36DA#, 16#0020#, 16#0002#),
         27029 => (16#36DB#, 16#0020#, 16#0002#),
         27030 => (16#36DC#, 16#0020#, 16#0002#),
         27031 => (16#36DD#, 16#0020#, 16#0002#),
         27032 => (16#36DE#, 16#0020#, 16#0002#),
         27033 => (16#36DF#, 16#0020#, 16#0002#),
         27034 => (16#36E0#, 16#0020#, 16#0002#),
         27035 => (16#36E1#, 16#0020#, 16#0002#),
         27036 => (16#36E2#, 16#0020#, 16#0002#),
         27037 => (16#36E3#, 16#0020#, 16#0002#),
         27038 => (16#36E4#, 16#0020#, 16#0002#),
         27039 => (16#36E5#, 16#0020#, 16#0002#),
         27040 => (16#36E6#, 16#0020#, 16#0002#),
         27041 => (16#36E7#, 16#0020#, 16#0002#),
         27042 => (16#36E8#, 16#0020#, 16#0002#),
         27043 => (16#36E9#, 16#0020#, 16#0002#),
         27044 => (16#36EA#, 16#0020#, 16#0002#),
         27045 => (16#36EB#, 16#0020#, 16#0002#),
         27046 => (16#36EC#, 16#0020#, 16#0002#),
         27047 => (16#36ED#, 16#0020#, 16#0002#),
         27048 => (16#36EE#, 16#0020#, 16#0002#),
         27049 => (16#36EF#, 16#0020#, 16#0002#),
         27050 => (16#36F0#, 16#0020#, 16#0002#),
         27051 => (16#36F1#, 16#0020#, 16#0002#),
         27052 => (16#36F2#, 16#0020#, 16#0002#),
         27053 => (16#36F3#, 16#0020#, 16#0002#),
         27054 => (16#36F4#, 16#0020#, 16#0002#),
         27055 => (16#36F5#, 16#0020#, 16#0002#),
         27056 => (16#36F6#, 16#0020#, 16#0002#),
         27057 => (16#36F7#, 16#0020#, 16#0002#),
         27058 => (16#36F8#, 16#0020#, 16#0002#),
         27059 => (16#36F9#, 16#0020#, 16#0002#),
         27060 => (16#36FA#, 16#0020#, 16#0002#),
         27061 => (16#36FB#, 16#0020#, 16#0002#),
         27062 => (16#36FC#, 16#0020#, 16#0002#),
         27063 => (16#36FD#, 16#0020#, 16#0002#),
         27064 => (16#36FE#, 16#0020#, 16#0002#),
         27065 => (16#36FF#, 16#0020#, 16#0002#),
         27066 => (16#3700#, 16#0020#, 16#0002#),
         27067 => (16#3701#, 16#0020#, 16#0002#),
         27068 => (16#3702#, 16#0020#, 16#0002#),
         27069 => (16#3703#, 16#0020#, 16#0002#),
         27070 => (16#3704#, 16#0020#, 16#0002#),
         27071 => (16#3705#, 16#0020#, 16#0002#),
         27072 => (16#3706#, 16#0020#, 16#0002#),
         27073 => (16#3707#, 16#0020#, 16#0002#),
         27074 => (16#3708#, 16#0020#, 16#0002#),
         27075 => (16#3709#, 16#0020#, 16#0002#),
         27076 => (16#370A#, 16#0020#, 16#0002#),
         27077 => (16#370B#, 16#0020#, 16#0002#),
         27078 => (16#370C#, 16#0020#, 16#0002#),
         27079 => (16#370D#, 16#0020#, 16#0002#),
         27080 => (16#370E#, 16#0020#, 16#0002#),
         27081 => (16#370F#, 16#0020#, 16#0002#),
         27082 => (16#3710#, 16#0020#, 16#0002#),
         27083 => (16#3711#, 16#0020#, 16#0002#),
         27084 => (16#3712#, 16#0020#, 16#0002#),
         27085 => (16#3713#, 16#0020#, 16#0002#),
         27086 => (16#3714#, 16#0020#, 16#0002#),
         27087 => (16#3715#, 16#0020#, 16#0002#),
         27088 => (16#3716#, 16#0020#, 16#0002#),
         27089 => (16#3717#, 16#0020#, 16#0002#),
         27090 => (16#3718#, 16#0020#, 16#0002#),
         27091 => (16#3719#, 16#0020#, 16#0002#),
         27092 => (16#371A#, 16#0020#, 16#0002#),
         27093 => (16#371B#, 16#0020#, 16#0002#),
         27094 => (16#371C#, 16#0020#, 16#0002#),
         27095 => (16#371D#, 16#0020#, 16#0002#),
         27096 => (16#371E#, 16#0020#, 16#0002#),
         27097 => (16#371F#, 16#0020#, 16#0002#),
         27098 => (16#3720#, 16#0020#, 16#0002#),
         27099 => (16#3721#, 16#0020#, 16#0002#),
         27100 => (16#3722#, 16#0020#, 16#0002#),
         27101 => (16#1FC9#, 16#0020#, 16#0005#),
         27102 => (16#1FCB#, 16#0020#, 16#0005#),
         27103 => (16#1FE0#, 16#0020#, 16#0005#),
         27104 => (16#1FF2#, 16#0020#, 16#0005#),
         27105 => (16#206C#, 16#0020#, 16#0005#),
         27106 => (16#2002#, 16#0020#, 16#0005#),
         27107 => (16#1FE7#, 16#0020#, 16#0005#),
         27108 => (16#2024#, 16#0020#, 16#0005#),
         27109 => (16#207B#, 16#0020#, 16#0005#),
         27110 => (16#203E#, 16#0020#, 16#0005#),
         27111 => (16#2052#, 16#0020#, 16#0005#),
         27112 => (16#2059#, 16#0020#, 16#0005#),
         27113 => (16#205D#, 16#0020#, 16#0005#),
         27114 => (16#2013#, 16#0020#, 16#0005#),
         27115 => (16#2028#, 16#0020#, 16#0005#),
         27116 => (16#202F#, 16#0020#, 16#0005#),
         27117 => (16#201E#, 16#0020#, 16#0005#),
         27118 => (16#203A#, 16#0020#, 16#0005#),
         27119 => (16#2001#, 16#0020#, 16#0005#),
         27120 => (16#2014#, 16#0020#, 16#0005#),
         27121 => (16#1FD9#, 16#0020#, 16#0005#),
         27122 => (16#1FDA#, 16#0020#, 16#0005#),
         27123 => (16#1FE8#, 16#0020#, 16#0005#),
         27124 => (16#1FF3#, 16#0020#, 16#0005#),
         27125 => (16#201F#, 16#0020#, 16#0005#),
         27126 => (16#2025#, 16#0020#, 16#0005#),
         27127 => (16#2029#, 16#0020#, 16#0005#),
         27128 => (16#1FCA#, 16#0020#, 16#0005#),
         27129 => (16#205E#, 16#0020#, 16#0005#),
         27130 => (16#2030#, 16#0020#, 16#0005#),
         27131 => (16#2039#, 16#0020#, 16#0005#),
         27132 => (16#2066#, 16#0020#, 16#0005#),
         27133 => (16#03BF#, 16#0020#, 16#0002#),
         27134 => (16#03C0#, 16#0020#, 16#0002#),
         27135 => (16#1072#, 16#0020#, 16#0002#),
         27136 => (16#1073#, 16#0020#, 16#0002#),
         27137 => (16#1074#, 16#0020#, 16#0002#),
         27138 => (16#1075#, 16#0020#, 16#0002#),
         27139 => (16#1076#, 16#0020#, 16#0002#),
         27140 => (16#1077#, 16#0020#, 16#0002#),
         27141 => (16#1078#, 16#0020#, 16#0002#),
         27142 => (16#1079#, 16#0020#, 16#0002#),
         27143 => (16#107A#, 16#0020#, 16#0002#),
         27144 => (16#107B#, 16#0020#, 16#0002#),
         27145 => (16#107C#, 16#0020#, 16#0002#),
         27146 => (16#107D#, 16#0020#, 16#0002#),
         27147 => (16#107E#, 16#0020#, 16#0002#),
         27148 => (16#107F#, 16#0020#, 16#0002#),
         27149 => (16#1080#, 16#0020#, 16#0002#),
         27150 => (16#1081#, 16#0020#, 16#0002#),
         27151 => (16#1082#, 16#0020#, 16#0002#),
         27152 => (16#1083#, 16#0020#, 16#0002#),
         27153 => (16#1084#, 16#0020#, 16#0002#),
         27154 => (16#1085#, 16#0020#, 16#0002#),
         27155 => (16#1086#, 16#0020#, 16#0002#),
         27156 => (16#1087#, 16#0020#, 16#0002#),
         27157 => (16#1088#, 16#0020#, 16#0002#),
         27158 => (16#1089#, 16#0020#, 16#0002#),
         27159 => (16#108A#, 16#0020#, 16#0002#),
         27160 => (16#108B#, 16#0020#, 16#0002#),
         27161 => (16#108C#, 16#0020#, 16#0002#),
         27162 => (16#108D#, 16#0020#, 16#0002#),
         27163 => (16#108E#, 16#0020#, 16#0002#),
         27164 => (16#108F#, 16#0020#, 16#0002#),
         27165 => (16#1090#, 16#0020#, 16#0002#),
         27166 => (16#1091#, 16#0020#, 16#0002#),
         27167 => (16#1092#, 16#0020#, 16#0002#),
         27168 => (16#1093#, 16#0020#, 16#0002#),
         27169 => (16#1094#, 16#0020#, 16#0002#),
         27170 => (16#1095#, 16#0020#, 16#0002#),
         27171 => (16#1096#, 16#0020#, 16#0002#),
         27172 => (16#1097#, 16#0020#, 16#0002#),
         27173 => (16#1098#, 16#0020#, 16#0002#),
         27174 => (16#1099#, 16#0020#, 16#0002#),
         27175 => (16#109A#, 16#0020#, 16#0002#),
         27176 => (16#109B#, 16#0020#, 16#0002#),
         27177 => (16#109C#, 16#0020#, 16#0002#),
         27178 => (16#109D#, 16#0020#, 16#0002#),
         27179 => (16#109E#, 16#0020#, 16#0002#),
         27180 => (16#109F#, 16#0020#, 16#0002#),
         27181 => (16#10A0#, 16#0020#, 16#0002#),
         27182 => (16#10A1#, 16#0020#, 16#0002#),
         27183 => (16#10A2#, 16#0020#, 16#0002#),
         27184 => (16#10A3#, 16#0020#, 16#0002#),
         27185 => (16#10A4#, 16#0020#, 16#0002#),
         27186 => (16#10A5#, 16#0020#, 16#0002#),
         27187 => (16#10A6#, 16#0020#, 16#0002#),
         27188 => (16#10A7#, 16#0020#, 16#0002#),
         27189 => (16#10A8#, 16#0020#, 16#0002#),
         27190 => (16#10A9#, 16#0020#, 16#0002#),
         27191 => (16#10AA#, 16#0020#, 16#0002#),
         27192 => (16#10AB#, 16#0020#, 16#0002#),
         27193 => (16#10AC#, 16#0020#, 16#0002#),
         27194 => (16#10AD#, 16#0020#, 16#0002#),
         27195 => (16#10AE#, 16#0020#, 16#0002#),
         27196 => (16#10AF#, 16#0020#, 16#0002#),
         27197 => (16#10B0#, 16#0020#, 16#0002#),
         27198 => (16#10B1#, 16#0020#, 16#0002#),
         27199 => (16#10B2#, 16#0020#, 16#0002#),
         27200 => (16#10B3#, 16#0020#, 16#0002#),
         27201 => (16#10B4#, 16#0020#, 16#0002#),
         27202 => (16#10B5#, 16#0020#, 16#0002#),
         27203 => (16#10B6#, 16#0020#, 16#0002#),
         27204 => (16#10B7#, 16#0020#, 16#0002#),
         27205 => (16#10B8#, 16#0020#, 16#0002#),
         27206 => (16#10B9#, 16#0020#, 16#0002#),
         27207 => (16#10BA#, 16#0020#, 16#0002#),
         27208 => (16#10BB#, 16#0020#, 16#0002#),
         27209 => (16#10BC#, 16#0020#, 16#0002#),
         27210 => (16#10BD#, 16#0020#, 16#0002#),
         27211 => (16#10BE#, 16#0020#, 16#0002#),
         27212 => (16#10BF#, 16#0020#, 16#0002#),
         27213 => (16#10C0#, 16#0020#, 16#0002#),
         27214 => (16#10C1#, 16#0020#, 16#0002#),
         27215 => (16#10C2#, 16#0020#, 16#0002#),
         27216 => (16#10C3#, 16#0020#, 16#0002#),
         27217 => (16#10C4#, 16#0020#, 16#0002#),
         27218 => (16#10C5#, 16#0020#, 16#0002#),
         27219 => (16#10C6#, 16#0020#, 16#0002#),
         27220 => (16#10C7#, 16#0020#, 16#0002#),
         27221 => (16#10C8#, 16#0020#, 16#0002#),
         27222 => (16#10C9#, 16#0020#, 16#0002#),
         27223 => (16#10CA#, 16#0020#, 16#0002#),
         27224 => (16#10CB#, 16#0020#, 16#0002#),
         27225 => (16#10CC#, 16#0020#, 16#0002#),
         27226 => (16#10CD#, 16#0020#, 16#0002#),
         27227 => (16#10CE#, 16#0020#, 16#0002#),
         27228 => (16#10CF#, 16#0020#, 16#0002#),
         27229 => (16#10D0#, 16#0020#, 16#0002#),
         27230 => (16#10D1#, 16#0020#, 16#0002#),
         27231 => (16#10D2#, 16#0020#, 16#0002#),
         27232 => (16#10D3#, 16#0020#, 16#0002#),
         27233 => (16#10D4#, 16#0020#, 16#0002#),
         27234 => (16#10D5#, 16#0020#, 16#0002#),
         27235 => (16#10D6#, 16#0020#, 16#0002#),
         27236 => (16#10D7#, 16#0020#, 16#0002#),
         27237 => (16#10D8#, 16#0020#, 16#0002#),
         27238 => (16#10D9#, 16#0020#, 16#0002#),
         27239 => (16#10DA#, 16#0020#, 16#0002#),
         27240 => (16#10DB#, 16#0020#, 16#0002#),
         27241 => (16#10DC#, 16#0020#, 16#0002#),
         27242 => (16#10DD#, 16#0020#, 16#0002#),
         27243 => (16#10DE#, 16#0020#, 16#0002#),
         27244 => (16#10DF#, 16#0020#, 16#0002#),
         27245 => (16#10E0#, 16#0020#, 16#0002#),
         27246 => (16#10E1#, 16#0020#, 16#0002#),
         27247 => (16#10E2#, 16#0020#, 16#0002#),
         27248 => (16#10E3#, 16#0020#, 16#0002#),
         27249 => (16#10E4#, 16#0020#, 16#0002#),
         27250 => (16#10E5#, 16#0020#, 16#0002#),
         27251 => (16#10E6#, 16#0020#, 16#0002#),
         27252 => (16#10E7#, 16#0020#, 16#0002#),
         27253 => (16#10E8#, 16#0020#, 16#0002#),
         27254 => (16#10E9#, 16#0020#, 16#0002#),
         27255 => (16#10EA#, 16#0020#, 16#0002#),
         27256 => (16#10EB#, 16#0020#, 16#0002#),
         27257 => (16#10EC#, 16#0020#, 16#0002#),
         27258 => (16#10ED#, 16#0020#, 16#0002#),
         27259 => (16#10EE#, 16#0020#, 16#0002#),
         27260 => (16#10EF#, 16#0020#, 16#0002#),
         27261 => (16#10F0#, 16#0020#, 16#0002#),
         27262 => (16#10F1#, 16#0020#, 16#0002#),
         27263 => (16#10F2#, 16#0020#, 16#0002#),
         27264 => (16#10F3#, 16#0020#, 16#0002#),
         27265 => (16#10F4#, 16#0020#, 16#0002#),
         27266 => (16#10F5#, 16#0020#, 16#0002#),
         27267 => (16#10F6#, 16#0020#, 16#0002#),
         27268 => (16#10F7#, 16#0020#, 16#0002#),
         27269 => (16#10F8#, 16#0020#, 16#0002#),
         27270 => (16#10F9#, 16#0020#, 16#0002#),
         27271 => (16#10FA#, 16#0020#, 16#0002#),
         27272 => (16#10FB#, 16#0020#, 16#0002#),
         27273 => (16#10FC#, 16#0020#, 16#0002#),
         27274 => (16#10FD#, 16#0020#, 16#0002#),
         27275 => (16#10FE#, 16#0020#, 16#0002#),
         27276 => (16#10FF#, 16#0020#, 16#0002#),
         27277 => (16#1100#, 16#0020#, 16#0002#),
         27278 => (16#1101#, 16#0020#, 16#0002#),
         27279 => (16#1102#, 16#0020#, 16#0002#),
         27280 => (16#1103#, 16#0020#, 16#0002#),
         27281 => (16#1104#, 16#0020#, 16#0002#),
         27282 => (16#1105#, 16#0020#, 16#0002#),
         27283 => (16#1106#, 16#0020#, 16#0002#),
         27284 => (16#1107#, 16#0020#, 16#0002#),
         27285 => (16#1108#, 16#0020#, 16#0002#),
         27286 => (16#1109#, 16#0020#, 16#0002#),
         27287 => (16#110A#, 16#0020#, 16#0002#),
         27288 => (16#110B#, 16#0020#, 16#0002#),
         27289 => (16#110C#, 16#0020#, 16#0002#),
         27290 => (16#110D#, 16#0020#, 16#0002#),
         27291 => (16#110E#, 16#0020#, 16#0002#),
         27292 => (16#110F#, 16#0020#, 16#0002#),
         27293 => (16#1110#, 16#0020#, 16#0002#),
         27294 => (16#1111#, 16#0020#, 16#0002#),
         27295 => (16#1112#, 16#0020#, 16#0002#),
         27296 => (16#1113#, 16#0020#, 16#0002#),
         27297 => (16#1114#, 16#0020#, 16#0002#),
         27298 => (16#1115#, 16#0020#, 16#0002#),
         27299 => (16#1116#, 16#0020#, 16#0002#),
         27300 => (16#1117#, 16#0020#, 16#0002#),
         27301 => (16#1118#, 16#0020#, 16#0002#),
         27302 => (16#1119#, 16#0020#, 16#0002#),
         27303 => (16#111A#, 16#0020#, 16#0002#),
         27304 => (16#111B#, 16#0020#, 16#0002#),
         27305 => (16#111C#, 16#0020#, 16#0002#),
         27306 => (16#111D#, 16#0020#, 16#0002#),
         27307 => (16#111E#, 16#0020#, 16#0002#),
         27308 => (16#111F#, 16#0020#, 16#0002#),
         27309 => (16#1120#, 16#0020#, 16#0002#),
         27310 => (16#1121#, 16#0020#, 16#0002#),
         27311 => (16#1122#, 16#0020#, 16#0002#),
         27312 => (16#1123#, 16#0020#, 16#0002#),
         27313 => (16#1124#, 16#0020#, 16#0002#),
         27314 => (16#1125#, 16#0020#, 16#0002#),
         27315 => (16#1126#, 16#0020#, 16#0002#),
         27316 => (16#1127#, 16#0020#, 16#0002#),
         27317 => (16#1128#, 16#0020#, 16#0002#),
         27318 => (16#1129#, 16#0020#, 16#0002#),
         27319 => (16#112A#, 16#0020#, 16#0002#),
         27320 => (16#112B#, 16#0020#, 16#0002#),
         27321 => (16#112C#, 16#0020#, 16#0002#),
         27322 => (16#112D#, 16#0020#, 16#0002#),
         27323 => (16#112E#, 16#0020#, 16#0002#),
         27324 => (16#112F#, 16#0020#, 16#0002#),
         27325 => (16#1130#, 16#0020#, 16#0002#),
         27326 => (16#1131#, 16#0020#, 16#0002#),
         27327 => (16#1132#, 16#0020#, 16#0002#),
         27328 => (16#1133#, 16#0020#, 16#0002#),
         27329 => (16#1134#, 16#0020#, 16#0002#),
         27330 => (16#1135#, 16#0020#, 16#0002#),
         27331 => (16#1136#, 16#0020#, 16#0002#),
         27332 => (16#1137#, 16#0020#, 16#0002#),
         27333 => (16#1138#, 16#0020#, 16#0002#),
         27334 => (16#1139#, 16#0020#, 16#0002#),
         27335 => (16#113A#, 16#0020#, 16#0002#),
         27336 => (16#113B#, 16#0020#, 16#0002#),
         27337 => (16#113C#, 16#0020#, 16#0002#),
         27338 => (16#113D#, 16#0020#, 16#0002#),
         27339 => (16#113E#, 16#0020#, 16#0002#),
         27340 => (16#113F#, 16#0020#, 16#0002#),
         27341 => (16#1140#, 16#0020#, 16#0002#),
         27342 => (16#1141#, 16#0020#, 16#0002#),
         27343 => (16#1142#, 16#0020#, 16#0002#),
         27344 => (16#1143#, 16#0020#, 16#0002#),
         27345 => (16#1144#, 16#0020#, 16#0002#),
         27346 => (16#1145#, 16#0020#, 16#0002#),
         27347 => (16#1146#, 16#0020#, 16#0002#),
         27348 => (16#1147#, 16#0020#, 16#0002#),
         27349 => (16#1148#, 16#0020#, 16#0002#),
         27350 => (16#1149#, 16#0020#, 16#0002#),
         27351 => (16#114A#, 16#0020#, 16#0002#),
         27352 => (16#114B#, 16#0020#, 16#0002#),
         27353 => (16#114C#, 16#0020#, 16#0002#),
         27354 => (16#114D#, 16#0020#, 16#0002#),
         27355 => (16#114E#, 16#0020#, 16#0002#),
         27356 => (16#114F#, 16#0020#, 16#0002#),
         27357 => (16#1150#, 16#0020#, 16#0002#),
         27358 => (16#1151#, 16#0020#, 16#0002#),
         27359 => (16#1152#, 16#0020#, 16#0002#),
         27360 => (16#1153#, 16#0020#, 16#0002#),
         27361 => (16#1803#, 16#0020#, 16#0004#),
         27362 => (16#0120#, 16#0020#, 16#0004#),
         27363 => (16#1804#, 16#0020#, 16#0004#),
         27364 => (16#0120#, 16#0020#, 16#0004#),
         27365 => (16#1805#, 16#0020#, 16#0004#),
         27366 => (16#0120#, 16#0020#, 16#0004#),
         27367 => (16#1806#, 16#0020#, 16#0004#),
         27368 => (16#0120#, 16#0020#, 16#0004#),
         27369 => (16#1807#, 16#0020#, 16#0004#),
         27370 => (16#0120#, 16#0020#, 16#0004#),
         27371 => (16#1808#, 16#0020#, 16#0004#),
         27372 => (16#0120#, 16#0020#, 16#0004#),
         27373 => (16#1809#, 16#0020#, 16#0004#),
         27374 => (16#0120#, 16#0020#, 16#0004#),
         27375 => (16#180A#, 16#0020#, 16#0004#),
         27376 => (16#0120#, 16#0020#, 16#0004#),
         27377 => (16#180B#, 16#0020#, 16#0004#),
         27378 => (16#0120#, 16#0020#, 16#0004#),
         27379 => (16#180C#, 16#0020#, 16#0004#),
         27380 => (16#0120#, 16#0020#, 16#0004#),
         27381 => (16#0209#, 16#0020#, 16#0004#),
         27382 => (16#190C#, 16#0020#, 16#000A#),
         27383 => (16#020A#, 16#0020#, 16#0004#),
         27384 => (16#0209#, 16#0020#, 16#0004#),
         27385 => (16#1925#, 16#0020#, 16#000A#),
         27386 => (16#020A#, 16#0020#, 16#0004#),
         27387 => (16#0209#, 16#0020#, 16#0004#),
         27388 => (16#193E#, 16#0020#, 16#000A#),
         27389 => (16#020A#, 16#0020#, 16#0004#),
         27390 => (16#0209#, 16#0020#, 16#0004#),
         27391 => (16#1953#, 16#0020#, 16#000A#),
         27392 => (16#020A#, 16#0020#, 16#0004#),
         27393 => (16#0209#, 16#0020#, 16#0004#),
         27394 => (16#196E#, 16#0020#, 16#000A#),
         27395 => (16#020A#, 16#0020#, 16#0004#),
         27396 => (16#0209#, 16#0020#, 16#0004#),
         27397 => (16#19A9#, 16#0020#, 16#000A#),
         27398 => (16#020A#, 16#0020#, 16#0004#),
         27399 => (16#0209#, 16#0020#, 16#0004#),
         27400 => (16#19B8#, 16#0020#, 16#000A#),
         27401 => (16#020A#, 16#0020#, 16#0004#),
         27402 => (16#0209#, 16#0020#, 16#0004#),
         27403 => (16#19DC#, 16#0020#, 16#000A#),
         27404 => (16#020A#, 16#0020#, 16#0004#),
         27405 => (16#0209#, 16#0020#, 16#0004#),
         27406 => (16#19F6#, 16#0020#, 16#000A#),
         27407 => (16#020A#, 16#0020#, 16#0004#),
         27408 => (16#0209#, 16#0020#, 16#0004#),
         27409 => (16#1A10#, 16#0020#, 16#000A#),
         27410 => (16#020A#, 16#0020#, 16#0004#),
         27411 => (16#0209#, 16#0020#, 16#0004#),
         27412 => (16#1A29#, 16#0020#, 16#000A#),
         27413 => (16#020A#, 16#0020#, 16#0004#),
         27414 => (16#0209#, 16#0020#, 16#0004#),
         27415 => (16#1A3B#, 16#0020#, 16#000A#),
         27416 => (16#020A#, 16#0020#, 16#0004#),
         27417 => (16#0209#, 16#0020#, 16#0004#),
         27418 => (16#1A6E#, 16#0020#, 16#000A#),
         27419 => (16#020A#, 16#0020#, 16#0004#),
         27420 => (16#0209#, 16#0020#, 16#0004#),
         27421 => (16#1A7D#, 16#0020#, 16#000A#),
         27422 => (16#020A#, 16#0020#, 16#0004#),
         27423 => (16#0209#, 16#0020#, 16#0004#),
         27424 => (16#1AA1#, 16#0020#, 16#000A#),
         27425 => (16#020A#, 16#0020#, 16#0004#),
         27426 => (16#0209#, 16#0020#, 16#0004#),
         27427 => (16#1ACE#, 16#0020#, 16#000A#),
         27428 => (16#020A#, 16#0020#, 16#0004#),
         27429 => (16#0209#, 16#0020#, 16#0004#),
         27430 => (16#1AE3#, 16#0020#, 16#000A#),
         27431 => (16#020A#, 16#0020#, 16#0004#),
         27432 => (16#0209#, 16#0020#, 16#0004#),
         27433 => (16#1AF5#, 16#0020#, 16#000A#),
         27434 => (16#020A#, 16#0020#, 16#0004#),
         27435 => (16#0209#, 16#0020#, 16#0004#),
         27436 => (16#1B33#, 16#0020#, 16#000A#),
         27437 => (16#020A#, 16#0020#, 16#0004#),
         27438 => (16#0209#, 16#0020#, 16#0004#),
         27439 => (16#1B57#, 16#0020#, 16#000A#),
         27440 => (16#020A#, 16#0020#, 16#0004#),
         27441 => (16#0209#, 16#0020#, 16#0004#),
         27442 => (16#1B77#, 16#0020#, 16#000A#),
         27443 => (16#020A#, 16#0020#, 16#0004#),
         27444 => (16#0209#, 16#0020#, 16#0004#),
         27445 => (16#1BA5#, 16#0020#, 16#000A#),
         27446 => (16#020A#, 16#0020#, 16#0004#),
         27447 => (16#0209#, 16#0020#, 16#0004#),
         27448 => (16#1BB7#, 16#0020#, 16#000A#),
         27449 => (16#020A#, 16#0020#, 16#0004#),
         27450 => (16#0209#, 16#0020#, 16#0004#),
         27451 => (16#1BC1#, 16#0020#, 16#000A#),
         27452 => (16#020A#, 16#0020#, 16#0004#),
         27453 => (16#0209#, 16#0020#, 16#0004#),
         27454 => (16#1BCD#, 16#0020#, 16#000A#),
         27455 => (16#020A#, 16#0020#, 16#0004#),
         27456 => (16#0209#, 16#0020#, 16#0004#),
         27457 => (16#1BE3#, 16#0020#, 16#000A#),
         27458 => (16#020A#, 16#0020#, 16#0004#),
         27459 => (16#026B#, 16#0020#, 16#0004#),
         27460 => (16#1B33#, 16#0020#, 16#000A#),
         27461 => (16#026C#, 16#0020#, 16#0004#),
         27462 => (16#1BB7#, 16#0020#, 16#000C#),
         27463 => (16#1BE3#, 16#0020#, 16#000C#),
         27464 => (16#1AE3#, 16#0020#, 16#001D#),
         27465 => (16#1BC1#, 16#0020#, 16#001D#),
         27466 => (16#1BCD#, 16#0020#, 16#001D#),
         27467 => (16#1BE3#, 16#0020#, 16#001D#),
         27468 => (16#19DC#, 16#0020#, 16#001D#),
         27469 => (16#1BA5#, 16#0020#, 16#001D#),
         27470 => (16#1B33#, 16#0020#, 16#001D#),
         27471 => (16#1953#, 16#0020#, 16#001D#),
         27472 => (16#1B33#, 16#0020#, 16#001D#),
         27473 => (16#1B33#, 16#0020#, 16#001D#),
         27474 => (16#1ACE#, 16#0020#, 16#001D#),
         27475 => (16#1ACE#, 16#0020#, 16#001D#),
         27476 => (16#1BA5#, 16#0020#, 16#001D#),
         27477 => (16#1BB7#, 16#0020#, 16#001D#),
         27478 => (16#193E#, 16#0020#, 16#001D#),
         27479 => (16#1A6E#, 16#0020#, 16#0014#),
         27480 => (16#193E#, 16#0020#, 16#0014#),
         27481 => (16#1A6E#, 16#0020#, 16#0014#),
         27482 => (16#1953#, 16#0020#, 16#0014#),
         27483 => (16#19F6#, 16#0020#, 16#001D#),
         27484 => (16#193E#, 16#0020#, 16#001D#),
         27485 => (16#1ACE#, 16#0020#, 16#001D#),
         27486 => (16#190C#, 16#0020#, 16#001D#),
         27487 => (16#1B33#, 16#0020#, 16#001D#),
         27488 => (16#190C#, 16#0020#, 16#001D#),
         27489 => (16#190C#, 16#0020#, 16#001D#),
         27490 => (16#1925#, 16#0020#, 16#001D#),
         27491 => (16#1953#, 16#0020#, 16#001D#),
         27492 => (16#1A10#, 16#0020#, 16#001D#),
         27493 => (16#193E#, 16#0020#, 16#001D#),
         27494 => (16#1A3B#, 16#0020#, 16#001D#),
         27495 => (16#193E#, 16#0020#, 16#001D#),
         27496 => (16#1AA1#, 16#0020#, 16#001D#),
         27497 => (16#1AA1#, 16#0020#, 16#001D#),
         27498 => (16#1A3B#, 16#0020#, 16#001D#),
         27499 => (16#19A9#, 16#0020#, 16#001D#),
         27500 => (16#1AF5#, 16#0020#, 16#001D#),
         27501 => (16#196E#, 16#0020#, 16#001D#),
         27502 => (16#196E#, 16#0020#, 16#001D#),
         27503 => (16#19F6#, 16#0020#, 16#001D#),
         27504 => (16#1953#, 16#0020#, 16#001D#),
         27505 => (16#1A7D#, 16#0020#, 16#001D#),
         27506 => (16#196E#, 16#0020#, 16#001D#),
         27507 => (16#1BB7#, 16#0020#, 16#001D#),
         27508 => (16#1A7D#, 16#0020#, 16#001D#),
         27509 => (16#19B8#, 16#0020#, 16#001D#),
         27510 => (16#1AA1#, 16#0020#, 16#001D#),
         27511 => (16#1A29#, 16#0020#, 16#001D#),
         27512 => (16#1B33#, 16#0020#, 16#001D#),
         27513 => (16#1AA1#, 16#0020#, 16#001D#),
         27514 => (16#1B33#, 16#0020#, 16#001D#),
         27515 => (16#1B77#, 16#0020#, 16#001D#),
         27516 => (16#1ACE#, 16#0020#, 16#001D#),
         27517 => (16#015E#, 16#0020#, 16#001C#),
         27518 => (16#08C3#, 16#0020#, 16#0002#),
         27519 => (16#08C4#, 16#0020#, 16#0002#),
         27520 => (16#08C5#, 16#0020#, 16#0002#),
         27521 => (16#08C6#, 16#0020#, 16#0002#),
         27522 => (16#08C7#, 16#0020#, 16#0002#),
         27523 => (16#08C8#, 16#0020#, 16#0002#),
         27524 => (16#08C9#, 16#0020#, 16#0002#),
         27525 => (16#08CA#, 16#0020#, 16#0002#),
         27526 => (16#08CB#, 16#0020#, 16#0002#),
         27527 => (16#08CC#, 16#0020#, 16#0002#),
         27528 => (16#08CD#, 16#0020#, 16#0002#),
         27529 => (16#08CE#, 16#0020#, 16#0002#),
         27530 => (16#08CF#, 16#0020#, 16#0002#),
         27531 => (16#08D0#, 16#0020#, 16#0002#),
         27532 => (16#08D1#, 16#0020#, 16#0002#),
         27533 => (16#08D2#, 16#0020#, 16#0002#),
         27534 => (16#08D3#, 16#0020#, 16#0002#),
         27535 => (16#08D4#, 16#0020#, 16#0002#),
         27536 => (16#08D5#, 16#0020#, 16#0002#),
         27537 => (16#08D6#, 16#0020#, 16#0002#),
         27538 => (16#08D7#, 16#0020#, 16#0002#),
         27539 => (16#08D8#, 16#0020#, 16#0002#),
         27540 => (16#08D9#, 16#0020#, 16#0002#),
         27541 => (16#08DA#, 16#0020#, 16#0002#),
         27542 => (16#08DB#, 16#0020#, 16#0002#),
         27543 => (16#08DC#, 16#0020#, 16#0002#),
         27544 => (16#38A6#, 16#0020#, 16#001C#),
         27545 => (16#388E#, 16#0020#, 16#001C#),
         27546 => (16#3892#, 16#0020#, 16#001C#),
         27547 => (16#3892#, 16#0020#, 16#001C#),
         27548 => (16#FB40#, 16#0020#, 16#001C#),
         27549 => (16#E24B#, 16#0000#, 16#0000#),
         27550 => (16#FB40#, 16#0020#, 16#001C#),
         27551 => (16#DB57#, 16#0000#, 16#0000#),
         27552 => (16#FB40#, 16#0020#, 16#001C#),
         27553 => (16#D3CC#, 16#0000#, 16#0000#),
         27554 => (16#FB40#, 16#0020#, 16#001C#),
         27555 => (16#CE8C#, 16#0000#, 16#0000#),
         27556 => (16#FB40#, 16#0020#, 16#001C#),
         27557 => (16#D91A#, 16#0000#, 16#0000#),
         27558 => (16#FB41#, 16#0020#, 16#001C#),
         27559 => (16#89E3#, 16#0000#, 16#0000#),
         27560 => (16#FB40#, 16#0020#, 16#001C#),
         27561 => (16#D929#, 16#0000#, 16#0000#),
         27562 => (16#FB40#, 16#0020#, 16#001C#),
         27563 => (16#CEA4#, 16#0000#, 16#0000#),
         27564 => (16#FB40#, 16#0020#, 16#001C#),
         27565 => (16#E620#, 16#0000#, 16#0000#),
         27566 => (16#FB40#, 16#0020#, 16#001C#),
         27567 => (16#F121#, 16#0000#, 16#0000#),
         27568 => (16#FB40#, 16#0020#, 16#001C#),
         27569 => (16#E599#, 16#0000#, 16#0000#),
         27570 => (16#FB40#, 16#0020#, 16#001C#),
         27571 => (16#D24D#, 16#0000#, 16#0000#),
         27572 => (16#FB40#, 16#0020#, 16#001C#),
         27573 => (16#DF8C#, 16#0000#, 16#0000#),
         27574 => (16#FB40#, 16#0020#, 16#001C#),
         27575 => (16#D18D#, 16#0000#, 16#0000#),
         27576 => (16#FB40#, 16#0020#, 16#001C#),
         27577 => (16#E5B0#, 16#0000#, 16#0000#),
         27578 => (16#FB40#, 16#0020#, 16#001C#),
         27579 => (16#D21D#, 16#0000#, 16#0000#),
         27580 => (16#FB40#, 16#0020#, 16#001C#),
         27581 => (16#FD42#, 16#0000#, 16#0000#),
         27582 => (16#FB40#, 16#0020#, 16#001C#),
         27583 => (16#F51F#, 16#0000#, 16#0000#),
         27584 => (16#FB41#, 16#0020#, 16#001C#),
         27585 => (16#8CA9#, 16#0000#, 16#0000#),
         27586 => (16#FB40#, 16#0020#, 16#001C#),
         27587 => (16#D8F0#, 16#0000#, 16#0000#),
         27588 => (16#FB40#, 16#0020#, 16#001C#),
         27589 => (16#D439#, 16#0000#, 16#0000#),
         27590 => (16#FB40#, 16#0020#, 16#001C#),
         27591 => (16#EF14#, 16#0000#, 16#0000#),
         27592 => (16#FB40#, 16#0020#, 16#001C#),
         27593 => (16#E295#, 16#0000#, 16#0000#),
         27594 => (16#FB40#, 16#0020#, 16#001C#),
         27595 => (16#E355#, 16#0000#, 16#0000#),
         27596 => (16#FB40#, 16#0020#, 16#001C#),
         27597 => (16#CE00#, 16#0000#, 16#0000#),
         27598 => (16#FB40#, 16#0020#, 16#001C#),
         27599 => (16#CE09#, 16#0000#, 16#0000#),
         27600 => (16#FB41#, 16#0020#, 16#001C#),
         27601 => (16#904A#, 16#0000#, 16#0000#),
         27602 => (16#FB40#, 16#0020#, 16#001C#),
         27603 => (16#DDE6#, 16#0000#, 16#0000#),
         27604 => (16#FB40#, 16#0020#, 16#001C#),
         27605 => (16#CE2D#, 16#0000#, 16#0000#),
         27606 => (16#FB40#, 16#0020#, 16#001C#),
         27607 => (16#D3F3#, 16#0000#, 16#0000#),
         27608 => (16#FB40#, 16#0020#, 16#001C#),
         27609 => (16#E307#, 16#0000#, 16#0000#),
         27610 => (16#FB41#, 16#0020#, 16#001C#),
         27611 => (16#8D70#, 16#0000#, 16#0000#),
         27612 => (16#FB40#, 16#0020#, 16#001C#),
         27613 => (16#E253#, 16#0000#, 16#0000#),
         27614 => (16#FB40#, 16#0020#, 16#001C#),
         27615 => (16#F981#, 16#0000#, 16#0000#),
         27616 => (16#FB40#, 16#0020#, 16#001C#),
         27617 => (16#FA7A#, 16#0000#, 16#0000#),
         27618 => (16#FB40#, 16#0020#, 16#001C#),
         27619 => (16#D408#, 16#0000#, 16#0000#),
         27620 => (16#FB40#, 16#0020#, 16#001C#),
         27621 => (16#EE80#, 16#0000#, 16#0000#),
         27622 => (16#FB40#, 16#0020#, 16#001C#),
         27623 => (16#E709#, 16#0000#, 16#0000#),
         27624 => (16#FB40#, 16#0020#, 16#001C#),
         27625 => (16#E708#, 16#0000#, 16#0000#),
         27626 => (16#FB40#, 16#0020#, 16#001C#),
         27627 => (16#F533#, 16#0000#, 16#0000#),
         27628 => (16#FB40#, 16#0020#, 16#001C#),
         27629 => (16#D272#, 16#0000#, 16#0000#),
         27630 => (16#FB40#, 16#0020#, 16#001C#),
         27631 => (16#D5B6#, 16#0000#, 16#0000#),
         27632 => (16#026B#, 16#0020#, 16#0004#),
         27633 => (16#FB40#, 16#0020#, 16#0004#),
         27634 => (16#E72C#, 16#0000#, 16#0000#),
         27635 => (16#026C#, 16#0020#, 16#0004#),
         27636 => (16#026B#, 16#0020#, 16#0004#),
         27637 => (16#FB40#, 16#0020#, 16#0004#),
         27638 => (16#CE09#, 16#0000#, 16#0000#),
         27639 => (16#026C#, 16#0020#, 16#0004#),
         27640 => (16#026B#, 16#0020#, 16#0004#),
         27641 => (16#FB40#, 16#0020#, 16#0004#),
         27642 => (16#CE8C#, 16#0000#, 16#0000#),
         27643 => (16#026C#, 16#0020#, 16#0004#),
         27644 => (16#026B#, 16#0020#, 16#0004#),
         27645 => (16#FB40#, 16#0020#, 16#0004#),
         27646 => (16#DB89#, 16#0000#, 16#0000#),
         27647 => (16#026C#, 16#0020#, 16#0004#),
         27648 => (16#026B#, 16#0020#, 16#0004#),
         27649 => (16#FB40#, 16#0020#, 16#0004#),
         27650 => (16#F0B9#, 16#0000#, 16#0000#),
         27651 => (16#026C#, 16#0020#, 16#0004#),
         27652 => (16#026B#, 16#0020#, 16#0004#),
         27653 => (16#FB40#, 16#0020#, 16#0004#),
         27654 => (16#E253#, 16#0000#, 16#0000#),
         27655 => (16#026C#, 16#0020#, 16#0004#),
         27656 => (16#026B#, 16#0020#, 16#0004#),
         27657 => (16#FB40#, 16#0020#, 16#0004#),
         27658 => (16#F6D7#, 16#0000#, 16#0000#),
         27659 => (16#026C#, 16#0020#, 16#0004#),
         27660 => (16#026B#, 16#0020#, 16#0004#),
         27661 => (16#FB40#, 16#0020#, 16#0004#),
         27662 => (16#D2DD#, 16#0000#, 16#0000#),
         27663 => (16#026C#, 16#0020#, 16#0004#),
         27664 => (16#026B#, 16#0020#, 16#0004#),
         27665 => (16#FB40#, 16#0020#, 16#0004#),
         27666 => (16#E557#, 16#0000#, 16#0000#),
         27667 => (16#026C#, 16#0020#, 16#0004#),
         27668 => (16#FB40#, 16#0020#, 16#0006#),
         27669 => (16#DF97#, 16#0000#, 16#0000#),
         27670 => (16#FB40#, 16#0020#, 16#0006#),
         27671 => (16#D3EF#, 16#0000#, 16#0000#),
         27672 => (16#1154#, 16#0020#, 16#0002#),
         27673 => (16#1155#, 16#0020#, 16#0002#),
         27674 => (16#1156#, 16#0020#, 16#0002#),
         27675 => (16#1157#, 16#0020#, 16#0002#),
         27676 => (16#1158#, 16#0020#, 16#0002#),
         27677 => (16#1159#, 16#0020#, 16#0002#),
         27678 => (16#115A#, 16#0020#, 16#0002#),
         27679 => (16#115B#, 16#0020#, 16#0002#),
         27680 => (16#115C#, 16#0020#, 16#0002#),
         27681 => (16#115D#, 16#0020#, 16#0002#),
         27682 => (16#115E#, 16#0020#, 16#0002#),
         27683 => (16#115F#, 16#0020#, 16#0002#),
         27684 => (16#1160#, 16#0020#, 16#0002#),
         27685 => (16#1161#, 16#0020#, 16#0002#),
         27686 => (16#1162#, 16#0020#, 16#0002#),
         27687 => (16#1163#, 16#0020#, 16#0002#),
         27688 => (16#1164#, 16#0020#, 16#0002#),
         27689 => (16#1165#, 16#0020#, 16#0002#),
         27690 => (16#1166#, 16#0020#, 16#0002#),
         27691 => (16#1167#, 16#0020#, 16#0002#),
         27692 => (16#1168#, 16#0020#, 16#0002#),
         27693 => (16#1169#, 16#0020#, 16#0002#),
         27694 => (16#116A#, 16#0020#, 16#0002#),
         27695 => (16#116B#, 16#0020#, 16#0002#),
         27696 => (16#116C#, 16#0020#, 16#0002#),
         27697 => (16#116D#, 16#0020#, 16#0002#),
         27698 => (16#116E#, 16#0020#, 16#0002#),
         27699 => (16#116F#, 16#0020#, 16#0002#),
         27700 => (16#1170#, 16#0020#, 16#0002#),
         27701 => (16#1171#, 16#0020#, 16#0002#),
         27702 => (16#1172#, 16#0020#, 16#0002#),
         27703 => (16#1173#, 16#0020#, 16#0002#),
         27704 => (16#1174#, 16#0020#, 16#0002#),
         27705 => (16#1175#, 16#0020#, 16#0002#),
         27706 => (16#1176#, 16#0020#, 16#0002#),
         27707 => (16#1177#, 16#0020#, 16#0002#),
         27708 => (16#1178#, 16#0020#, 16#0002#),
         27709 => (16#1179#, 16#0020#, 16#0002#),
         27710 => (16#117A#, 16#0020#, 16#0002#),
         27711 => (16#117B#, 16#0020#, 16#0002#),
         27712 => (16#117C#, 16#0020#, 16#0002#),
         27713 => (16#117D#, 16#0020#, 16#0002#),
         27714 => (16#117E#, 16#0020#, 16#0002#),
         27715 => (16#117F#, 16#0020#, 16#0002#),
         27716 => (16#1180#, 16#0020#, 16#0002#),
         27717 => (16#1181#, 16#0020#, 16#0002#),
         27718 => (16#1182#, 16#0020#, 16#0002#),
         27719 => (16#1183#, 16#0020#, 16#0002#),
         27720 => (16#1184#, 16#0020#, 16#0002#),
         27721 => (16#1185#, 16#0020#, 16#0002#),
         27722 => (16#1186#, 16#0020#, 16#0002#),
         27723 => (16#1187#, 16#0020#, 16#0002#),
         27724 => (16#1188#, 16#0020#, 16#0002#),
         27725 => (16#1189#, 16#0020#, 16#0002#),
         27726 => (16#118A#, 16#0020#, 16#0002#),
         27727 => (16#118B#, 16#0020#, 16#0002#),
         27728 => (16#118C#, 16#0020#, 16#0002#),
         27729 => (16#118D#, 16#0020#, 16#0002#),
         27730 => (16#118E#, 16#0020#, 16#0002#),
         27731 => (16#118F#, 16#0020#, 16#0002#),
         27732 => (16#1190#, 16#0020#, 16#0002#),
         27733 => (16#1191#, 16#0020#, 16#0002#),
         27734 => (16#1192#, 16#0020#, 16#0002#),
         27735 => (16#1193#, 16#0020#, 16#0002#),
         27736 => (16#1194#, 16#0020#, 16#0002#),
         27737 => (16#1195#, 16#0020#, 16#0002#),
         27738 => (16#1196#, 16#0020#, 16#0002#),
         27739 => (16#1197#, 16#0020#, 16#0002#),
         27740 => (16#1198#, 16#0020#, 16#0002#),
         27741 => (16#1199#, 16#0020#, 16#0002#),
         27742 => (16#119A#, 16#0020#, 16#0002#),
         27743 => (16#119B#, 16#0020#, 16#0002#),
         27744 => (16#119C#, 16#0020#, 16#0002#),
         27745 => (16#119D#, 16#0020#, 16#0002#),
         27746 => (16#119E#, 16#0020#, 16#0002#),
         27747 => (16#119F#, 16#0020#, 16#0002#),
         27748 => (16#11A0#, 16#0020#, 16#0002#),
         27749 => (16#11A1#, 16#0020#, 16#0002#),
         27750 => (16#11A2#, 16#0020#, 16#0002#),
         27751 => (16#11A3#, 16#0020#, 16#0002#),
         27752 => (16#11A4#, 16#0020#, 16#0002#),
         27753 => (16#11A5#, 16#0020#, 16#0002#),
         27754 => (16#11A6#, 16#0020#, 16#0002#),
         27755 => (16#11A7#, 16#0020#, 16#0002#),
         27756 => (16#11A8#, 16#0020#, 16#0002#),
         27757 => (16#11A9#, 16#0020#, 16#0002#),
         27758 => (16#11AA#, 16#0020#, 16#0002#),
         27759 => (16#11AB#, 16#0020#, 16#0002#),
         27760 => (16#11AC#, 16#0020#, 16#0002#),
         27761 => (16#11AD#, 16#0020#, 16#0002#),
         27762 => (16#11AE#, 16#0020#, 16#0002#),
         27763 => (16#11AF#, 16#0020#, 16#0002#),
         27764 => (16#11B0#, 16#0020#, 16#0002#),
         27765 => (16#11B1#, 16#0020#, 16#0002#),
         27766 => (16#11B2#, 16#0020#, 16#0002#),
         27767 => (16#11B3#, 16#0020#, 16#0002#),
         27768 => (16#11B4#, 16#0020#, 16#0002#),
         27769 => (16#11B5#, 16#0020#, 16#0002#),
         27770 => (16#11B6#, 16#0020#, 16#0002#),
         27771 => (16#11B7#, 16#0020#, 16#0002#),
         27772 => (16#11B8#, 16#0020#, 16#0002#),
         27773 => (16#11B9#, 16#0020#, 16#0002#),
         27774 => (16#11BA#, 16#0020#, 16#0002#),
         27775 => (16#11BB#, 16#0020#, 16#0002#),
         27776 => (16#11BC#, 16#0020#, 16#0002#),
         27777 => (16#11BD#, 16#0020#, 16#0002#),
         27778 => (16#11BE#, 16#0020#, 16#0002#),
         27779 => (16#11BF#, 16#0020#, 16#0002#),
         27780 => (16#11C0#, 16#0020#, 16#0002#),
         27781 => (16#11C1#, 16#0020#, 16#0002#),
         27782 => (16#11C2#, 16#0020#, 16#0002#),
         27783 => (16#11C3#, 16#0020#, 16#0002#),
         27784 => (16#11C4#, 16#0020#, 16#0002#),
         27785 => (16#11C5#, 16#0020#, 16#0002#),
         27786 => (16#11C6#, 16#0020#, 16#0002#),
         27787 => (16#11C7#, 16#0020#, 16#0002#),
         27788 => (16#11C8#, 16#0020#, 16#0002#),
         27789 => (16#11C9#, 16#0020#, 16#0002#),
         27790 => (16#11CA#, 16#0020#, 16#0002#),
         27791 => (16#11CB#, 16#0020#, 16#0002#),
         27792 => (16#11CC#, 16#0020#, 16#0002#),
         27793 => (16#11CD#, 16#0020#, 16#0002#),
         27794 => (16#11CE#, 16#0020#, 16#0002#),
         27795 => (16#11CF#, 16#0020#, 16#0002#),
         27796 => (16#11D0#, 16#0020#, 16#0002#),
         27797 => (16#11D1#, 16#0020#, 16#0002#),
         27798 => (16#11D2#, 16#0020#, 16#0002#),
         27799 => (16#11D3#, 16#0020#, 16#0002#),
         27800 => (16#11D4#, 16#0020#, 16#0002#),
         27801 => (16#11D5#, 16#0020#, 16#0002#),
         27802 => (16#11D6#, 16#0020#, 16#0002#),
         27803 => (16#11D7#, 16#0020#, 16#0002#),
         27804 => (16#11D8#, 16#0020#, 16#0002#),
         27805 => (16#11D9#, 16#0020#, 16#0002#),
         27806 => (16#11DA#, 16#0020#, 16#0002#),
         27807 => (16#11DB#, 16#0020#, 16#0002#),
         27808 => (16#11DC#, 16#0020#, 16#0002#),
         27809 => (16#11DD#, 16#0020#, 16#0002#),
         27810 => (16#11DE#, 16#0020#, 16#0002#),
         27811 => (16#11DF#, 16#0020#, 16#0002#),
         27812 => (16#11E0#, 16#0020#, 16#0002#),
         27813 => (16#11E1#, 16#0020#, 16#0002#),
         27814 => (16#11E2#, 16#0020#, 16#0002#),
         27815 => (16#11E3#, 16#0020#, 16#0002#),
         27816 => (16#11E4#, 16#0020#, 16#0002#),
         27817 => (16#11E5#, 16#0020#, 16#0002#),
         27818 => (16#11E6#, 16#0020#, 16#0002#),
         27819 => (16#11E7#, 16#0020#, 16#0002#),
         27820 => (16#11E8#, 16#0020#, 16#0002#),
         27821 => (16#11E9#, 16#0020#, 16#0002#),
         27822 => (16#11EA#, 16#0020#, 16#0002#),
         27823 => (16#11EB#, 16#0020#, 16#0002#),
         27824 => (16#11EC#, 16#0020#, 16#0002#),
         27825 => (16#11ED#, 16#0020#, 16#0002#),
         27826 => (16#11EE#, 16#0020#, 16#0002#),
         27827 => (16#11EF#, 16#0020#, 16#0002#),
         27828 => (16#11F0#, 16#0020#, 16#0002#),
         27829 => (16#11F1#, 16#0020#, 16#0002#),
         27830 => (16#11F2#, 16#0020#, 16#0002#),
         27831 => (16#11F3#, 16#0020#, 16#0002#),
         27832 => (16#11F4#, 16#0020#, 16#0002#),
         27833 => (16#11F5#, 16#0020#, 16#0002#),
         27834 => (16#11F6#, 16#0020#, 16#0002#),
         27835 => (16#11F7#, 16#0020#, 16#0002#),
         27836 => (16#11F8#, 16#0020#, 16#0002#),
         27837 => (16#11F9#, 16#0020#, 16#0002#),
         27838 => (16#11FA#, 16#0020#, 16#0002#),
         27839 => (16#11FB#, 16#0020#, 16#0002#),
         27840 => (16#11FC#, 16#0020#, 16#0002#),
         27841 => (16#11FD#, 16#0020#, 16#0002#),
         27842 => (16#11FE#, 16#0020#, 16#0002#),
         27843 => (16#11FF#, 16#0020#, 16#0002#),
         27844 => (16#1200#, 16#0020#, 16#0002#),
         27845 => (16#1201#, 16#0020#, 16#0002#),
         27846 => (16#1202#, 16#0020#, 16#0002#),
         27847 => (16#1203#, 16#0020#, 16#0002#),
         27848 => (16#1204#, 16#0020#, 16#0002#),
         27849 => (16#1205#, 16#0020#, 16#0002#),
         27850 => (16#1206#, 16#0020#, 16#0002#),
         27851 => (16#1207#, 16#0020#, 16#0002#),
         27852 => (16#1208#, 16#0020#, 16#0002#),
         27853 => (16#1209#, 16#0020#, 16#0002#),
         27854 => (16#120A#, 16#0020#, 16#0002#),
         27855 => (16#120B#, 16#0020#, 16#0002#),
         27856 => (16#120C#, 16#0020#, 16#0002#),
         27857 => (16#120D#, 16#0020#, 16#0002#),
         27858 => (16#120E#, 16#0020#, 16#0002#),
         27859 => (16#120F#, 16#0020#, 16#0002#),
         27860 => (16#1210#, 16#0020#, 16#0002#),
         27861 => (16#1211#, 16#0020#, 16#0002#),
         27862 => (16#1212#, 16#0020#, 16#0002#),
         27863 => (16#1213#, 16#0020#, 16#0002#),
         27864 => (16#1214#, 16#0020#, 16#0002#),
         27865 => (16#1215#, 16#0020#, 16#0002#),
         27866 => (16#1216#, 16#0020#, 16#0002#),
         27867 => (16#1217#, 16#0020#, 16#0002#),
         27868 => (16#1218#, 16#0020#, 16#0002#),
         27869 => (16#1219#, 16#0020#, 16#0002#),
         27870 => (16#121A#, 16#0020#, 16#0002#),
         27871 => (16#121B#, 16#0020#, 16#0002#),
         27872 => (16#121C#, 16#0020#, 16#0002#),
         27873 => (16#121D#, 16#0020#, 16#0002#),
         27874 => (16#121E#, 16#0020#, 16#0002#),
         27875 => (16#121F#, 16#0020#, 16#0002#),
         27876 => (16#1220#, 16#0020#, 16#0002#),
         27877 => (16#1221#, 16#0020#, 16#0002#),
         27878 => (16#1222#, 16#0020#, 16#0002#),
         27879 => (16#1223#, 16#0020#, 16#0002#),
         27880 => (16#1224#, 16#0020#, 16#0002#),
         27881 => (16#1225#, 16#0020#, 16#0002#),
         27882 => (16#1226#, 16#0020#, 16#0002#),
         27883 => (16#1227#, 16#0020#, 16#0002#),
         27884 => (16#1228#, 16#0020#, 16#0002#),
         27885 => (16#1229#, 16#0020#, 16#0002#),
         27886 => (16#122A#, 16#0020#, 16#0002#),
         27887 => (16#122B#, 16#0020#, 16#0002#),
         27888 => (16#122C#, 16#0020#, 16#0002#),
         27889 => (16#122D#, 16#0020#, 16#0002#),
         27890 => (16#122E#, 16#0020#, 16#0002#),
         27891 => (16#122F#, 16#0020#, 16#0002#),
         27892 => (16#1230#, 16#0020#, 16#0002#),
         27893 => (16#1231#, 16#0020#, 16#0002#),
         27894 => (16#1232#, 16#0020#, 16#0002#),
         27895 => (16#1233#, 16#0020#, 16#0002#),
         27896 => (16#1234#, 16#0020#, 16#0002#),
         27897 => (16#1235#, 16#0020#, 16#0002#),
         27898 => (16#1236#, 16#0020#, 16#0002#),
         27899 => (16#1237#, 16#0020#, 16#0002#),
         27900 => (16#1238#, 16#0020#, 16#0002#),
         27901 => (16#1239#, 16#0020#, 16#0002#),
         27902 => (16#123A#, 16#0020#, 16#0002#),
         27903 => (16#123B#, 16#0020#, 16#0002#),
         27904 => (16#123C#, 16#0020#, 16#0002#),
         27905 => (16#123D#, 16#0020#, 16#0002#),
         27906 => (16#123E#, 16#0020#, 16#0002#),
         27907 => (16#123F#, 16#0020#, 16#0002#),
         27908 => (16#1240#, 16#0020#, 16#0002#),
         27909 => (16#1241#, 16#0020#, 16#0002#),
         27910 => (16#1242#, 16#0020#, 16#0002#),
         27911 => (16#1243#, 16#0020#, 16#0002#),
         27912 => (16#1244#, 16#0020#, 16#0002#),
         27913 => (16#1245#, 16#0020#, 16#0002#),
         27914 => (16#1246#, 16#0020#, 16#0002#),
         27915 => (16#1247#, 16#0020#, 16#0002#),
         27916 => (16#1248#, 16#0020#, 16#0002#),
         27917 => (16#1249#, 16#0020#, 16#0002#),
         27918 => (16#124A#, 16#0020#, 16#0002#),
         27919 => (16#124B#, 16#0020#, 16#0002#),
         27920 => (16#124C#, 16#0020#, 16#0002#),
         27921 => (16#124D#, 16#0020#, 16#0002#),
         27922 => (16#124E#, 16#0020#, 16#0002#),
         27923 => (16#124F#, 16#0020#, 16#0002#),
         27924 => (16#1250#, 16#0020#, 16#0002#),
         27925 => (16#1251#, 16#0020#, 16#0002#),
         27926 => (16#1252#, 16#0020#, 16#0002#),
         27927 => (16#1253#, 16#0020#, 16#0002#),
         27928 => (16#1254#, 16#0020#, 16#0002#),
         27929 => (16#1255#, 16#0020#, 16#0002#),
         27930 => (16#1256#, 16#0020#, 16#0002#),
         27931 => (16#1257#, 16#0020#, 16#0002#),
         27932 => (16#1258#, 16#0020#, 16#0002#),
         27933 => (16#1259#, 16#0020#, 16#0002#),
         27934 => (16#125A#, 16#0020#, 16#0002#),
         27935 => (16#125B#, 16#0020#, 16#0002#),
         27936 => (16#125C#, 16#0020#, 16#0002#),
         27937 => (16#125D#, 16#0020#, 16#0002#),
         27938 => (16#125E#, 16#0020#, 16#0002#),
         27939 => (16#125F#, 16#0020#, 16#0002#),
         27940 => (16#1260#, 16#0020#, 16#0002#),
         27941 => (16#1261#, 16#0020#, 16#0002#),
         27942 => (16#1262#, 16#0020#, 16#0002#),
         27943 => (16#1263#, 16#0020#, 16#0002#),
         27944 => (16#1264#, 16#0020#, 16#0002#),
         27945 => (16#1265#, 16#0020#, 16#0002#),
         27946 => (16#1266#, 16#0020#, 16#0002#),
         27947 => (16#1267#, 16#0020#, 16#0002#),
         27948 => (16#1268#, 16#0020#, 16#0002#),
         27949 => (16#1269#, 16#0020#, 16#0002#),
         27950 => (16#126A#, 16#0020#, 16#0002#),
         27951 => (16#126B#, 16#0020#, 16#0002#),
         27952 => (16#126C#, 16#0020#, 16#0002#),
         27953 => (16#126D#, 16#0020#, 16#0002#),
         27954 => (16#126E#, 16#0020#, 16#0002#),
         27955 => (16#126F#, 16#0020#, 16#0002#),
         27956 => (16#1270#, 16#0020#, 16#0002#),
         27957 => (16#1271#, 16#0020#, 16#0002#),
         27958 => (16#1272#, 16#0020#, 16#0002#),
         27959 => (16#1273#, 16#0020#, 16#0002#),
         27960 => (16#1274#, 16#0020#, 16#0002#),
         27961 => (16#1275#, 16#0020#, 16#0002#),
         27962 => (16#1276#, 16#0020#, 16#0002#),
         27963 => (16#1277#, 16#0020#, 16#0002#),
         27964 => (16#1278#, 16#0020#, 16#0002#),
         27965 => (16#1279#, 16#0020#, 16#0002#),
         27966 => (16#127A#, 16#0020#, 16#0002#),
         27967 => (16#127B#, 16#0020#, 16#0002#),
         27968 => (16#127C#, 16#0020#, 16#0002#),
         27969 => (16#127D#, 16#0020#, 16#0002#),
         27970 => (16#127E#, 16#0020#, 16#0002#),
         27971 => (16#127F#, 16#0020#, 16#0002#),
         27972 => (16#1280#, 16#0020#, 16#0002#),
         27973 => (16#1281#, 16#0020#, 16#0002#),
         27974 => (16#1282#, 16#0020#, 16#0002#),
         27975 => (16#1283#, 16#0020#, 16#0002#),
         27976 => (16#1284#, 16#0020#, 16#0002#),
         27977 => (16#1285#, 16#0020#, 16#0002#),
         27978 => (16#1286#, 16#0020#, 16#0002#),
         27979 => (16#1287#, 16#0020#, 16#0002#),
         27980 => (16#1288#, 16#0020#, 16#0002#),
         27981 => (16#1289#, 16#0020#, 16#0002#),
         27982 => (16#128A#, 16#0020#, 16#0002#),
         27983 => (16#128B#, 16#0020#, 16#0002#),
         27984 => (16#128C#, 16#0020#, 16#0002#),
         27985 => (16#128D#, 16#0020#, 16#0002#),
         27986 => (16#128E#, 16#0020#, 16#0002#),
         27987 => (16#128F#, 16#0020#, 16#0002#),
         27988 => (16#1290#, 16#0020#, 16#0002#),
         27989 => (16#1291#, 16#0020#, 16#0002#),
         27990 => (16#1292#, 16#0020#, 16#0002#),
         27991 => (16#1293#, 16#0020#, 16#0002#),
         27992 => (16#1294#, 16#0020#, 16#0002#),
         27993 => (16#1295#, 16#0020#, 16#0002#),
         27994 => (16#1296#, 16#0020#, 16#0002#),
         27995 => (16#1297#, 16#0020#, 16#0002#),
         27996 => (16#1298#, 16#0020#, 16#0002#),
         27997 => (16#1299#, 16#0020#, 16#0002#),
         27998 => (16#129A#, 16#0020#, 16#0002#),
         27999 => (16#129B#, 16#0020#, 16#0002#),
         28000 => (16#129C#, 16#0020#, 16#0002#),
         28001 => (16#129D#, 16#0020#, 16#0002#),
         28002 => (16#129E#, 16#0020#, 16#0002#),
         28003 => (16#129F#, 16#0020#, 16#0002#),
         28004 => (16#12A0#, 16#0020#, 16#0002#),
         28005 => (16#12A1#, 16#0020#, 16#0002#),
         28006 => (16#12A2#, 16#0020#, 16#0002#),
         28007 => (16#12A3#, 16#0020#, 16#0002#),
         28008 => (16#12A4#, 16#0020#, 16#0002#),
         28009 => (16#12A5#, 16#0020#, 16#0002#),
         28010 => (16#12A6#, 16#0020#, 16#0002#),
         28011 => (16#12A7#, 16#0020#, 16#0002#),
         28012 => (16#12A8#, 16#0020#, 16#0002#),
         28013 => (16#12A9#, 16#0020#, 16#0002#),
         28014 => (16#12AA#, 16#0020#, 16#0002#),
         28015 => (16#12AB#, 16#0020#, 16#0002#),
         28016 => (16#12AC#, 16#0020#, 16#0002#),
         28017 => (16#12AD#, 16#0020#, 16#0002#),
         28018 => (16#12AE#, 16#0020#, 16#0002#),
         28019 => (16#12AF#, 16#0020#, 16#0002#),
         28020 => (16#12B0#, 16#0020#, 16#0002#),
         28021 => (16#12B1#, 16#0020#, 16#0002#),
         28022 => (16#12B2#, 16#0020#, 16#0002#),
         28023 => (16#12B3#, 16#0020#, 16#0002#),
         28024 => (16#12B4#, 16#0020#, 16#0002#),
         28025 => (16#12B5#, 16#0020#, 16#0002#),
         28026 => (16#12B6#, 16#0020#, 16#0002#),
         28027 => (16#12B7#, 16#0020#, 16#0002#),
         28028 => (16#12B8#, 16#0020#, 16#0002#),
         28029 => (16#12B9#, 16#0020#, 16#0002#),
         28030 => (16#12BA#, 16#0020#, 16#0002#),
         28031 => (16#12BB#, 16#0020#, 16#0002#),
         28032 => (16#12BC#, 16#0020#, 16#0002#),
         28033 => (16#12BD#, 16#0020#, 16#0002#),
         28034 => (16#12BE#, 16#0020#, 16#0002#),
         28035 => (16#12BF#, 16#0020#, 16#0002#),
         28036 => (16#12C0#, 16#0020#, 16#0002#),
         28037 => (16#12C1#, 16#0020#, 16#0002#),
         28038 => (16#12C2#, 16#0020#, 16#0002#),
         28039 => (16#12C3#, 16#0020#, 16#0002#),
         28040 => (16#12C4#, 16#0020#, 16#0002#),
         28041 => (16#12C5#, 16#0020#, 16#0002#),
         28042 => (16#12C6#, 16#0020#, 16#0002#),
         28043 => (16#12C7#, 16#0020#, 16#0002#),
         28044 => (16#12C8#, 16#0020#, 16#0002#),
         28045 => (16#12C9#, 16#0020#, 16#0002#),
         28046 => (16#12CA#, 16#0020#, 16#0002#),
         28047 => (16#12CB#, 16#0020#, 16#0002#),
         28048 => (16#12CC#, 16#0020#, 16#0002#),
         28049 => (16#12CD#, 16#0020#, 16#0002#),
         28050 => (16#12CE#, 16#0020#, 16#0002#),
         28051 => (16#12CF#, 16#0020#, 16#0002#),
         28052 => (16#12D0#, 16#0020#, 16#0002#),
         28053 => (16#12D1#, 16#0020#, 16#0002#),
         28054 => (16#12D2#, 16#0020#, 16#0002#),
         28055 => (16#12D3#, 16#0020#, 16#0002#),
         28056 => (16#12D4#, 16#0020#, 16#0002#),
         28057 => (16#12D5#, 16#0020#, 16#0002#),
         28058 => (16#12D6#, 16#0020#, 16#0002#),
         28059 => (16#12D7#, 16#0020#, 16#0002#),
         28060 => (16#12D8#, 16#0020#, 16#0002#),
         28061 => (16#12D9#, 16#0020#, 16#0002#),
         28062 => (16#12DA#, 16#0020#, 16#0002#),
         28063 => (16#12DB#, 16#0020#, 16#0002#),
         28064 => (16#12DC#, 16#0020#, 16#0002#),
         28065 => (16#12DD#, 16#0020#, 16#0002#),
         28066 => (16#12DE#, 16#0020#, 16#0002#),
         28067 => (16#12DF#, 16#0020#, 16#0002#),
         28068 => (16#12E0#, 16#0020#, 16#0002#),
         28069 => (16#12E1#, 16#0020#, 16#0002#),
         28070 => (16#12E2#, 16#0020#, 16#0002#),
         28071 => (16#12E3#, 16#0020#, 16#0002#),
         28072 => (16#12E4#, 16#0020#, 16#0002#),
         28073 => (16#12E5#, 16#0020#, 16#0002#),
         28074 => (16#12E6#, 16#0020#, 16#0002#),
         28075 => (16#12E7#, 16#0020#, 16#0002#),
         28076 => (16#12E8#, 16#0020#, 16#0002#),
         28077 => (16#12E9#, 16#0020#, 16#0002#),
         28078 => (16#12EA#, 16#0020#, 16#0002#),
         28079 => (16#12EB#, 16#0020#, 16#0002#),
         28080 => (16#12EC#, 16#0020#, 16#0002#),
         28081 => (16#12ED#, 16#0020#, 16#0002#),
         28082 => (16#12EE#, 16#0020#, 16#0002#),
         28083 => (16#12EF#, 16#0020#, 16#0002#),
         28084 => (16#12F0#, 16#0020#, 16#0002#),
         28085 => (16#12F1#, 16#0020#, 16#0002#),
         28086 => (16#12F2#, 16#0020#, 16#0002#),
         28087 => (16#12F3#, 16#0020#, 16#0002#),
         28088 => (16#12F4#, 16#0020#, 16#0002#),
         28089 => (16#12F5#, 16#0020#, 16#0002#),
         28090 => (16#12F6#, 16#0020#, 16#0002#),
         28091 => (16#12F7#, 16#0020#, 16#0002#),
         28092 => (16#12F8#, 16#0020#, 16#0002#),
         28093 => (16#12F9#, 16#0020#, 16#0002#),
         28094 => (16#12FA#, 16#0020#, 16#0002#),
         28095 => (16#12FB#, 16#0020#, 16#0002#),
         28096 => (16#12FC#, 16#0020#, 16#0002#),
         28097 => (16#12FD#, 16#0020#, 16#0002#),
         28098 => (16#12FE#, 16#0020#, 16#0002#),
         28099 => (16#12FF#, 16#0020#, 16#0002#),
         28100 => (16#1300#, 16#0020#, 16#0002#),
         28101 => (16#1301#, 16#0020#, 16#0002#),
         28102 => (16#1302#, 16#0020#, 16#0002#),
         28103 => (16#1303#, 16#0020#, 16#0002#),
         28104 => (16#1304#, 16#0020#, 16#0002#),
         28105 => (16#1305#, 16#0020#, 16#0002#),
         28106 => (16#1306#, 16#0020#, 16#0002#),
         28107 => (16#1307#, 16#0020#, 16#0002#),
         28108 => (16#1308#, 16#0020#, 16#0002#),
         28109 => (16#1309#, 16#0020#, 16#0002#),
         28110 => (16#130A#, 16#0020#, 16#0002#),
         28111 => (16#130B#, 16#0020#, 16#0002#),
         28112 => (16#130C#, 16#0020#, 16#0002#),
         28113 => (16#130D#, 16#0020#, 16#0002#),
         28114 => (16#130E#, 16#0020#, 16#0002#),
         28115 => (16#130F#, 16#0020#, 16#0002#),
         28116 => (16#1310#, 16#0020#, 16#0002#),
         28117 => (16#1311#, 16#0020#, 16#0002#),
         28118 => (16#1312#, 16#0020#, 16#0002#),
         28119 => (16#1313#, 16#0020#, 16#0002#),
         28120 => (16#1314#, 16#0020#, 16#0002#),
         28121 => (16#1315#, 16#0020#, 16#0002#),
         28122 => (16#1316#, 16#0020#, 16#0002#),
         28123 => (16#1317#, 16#0020#, 16#0002#),
         28124 => (16#1318#, 16#0020#, 16#0002#),
         28125 => (16#1319#, 16#0020#, 16#0002#),
         28126 => (16#131A#, 16#0020#, 16#0002#),
         28127 => (16#131B#, 16#0020#, 16#0002#),
         28128 => (16#131C#, 16#0020#, 16#0002#),
         28129 => (16#131D#, 16#0020#, 16#0002#),
         28130 => (16#131E#, 16#0020#, 16#0002#),
         28131 => (16#131F#, 16#0020#, 16#0002#),
         28132 => (16#1320#, 16#0020#, 16#0002#),
         28133 => (16#1321#, 16#0020#, 16#0002#),
         28134 => (16#1322#, 16#0020#, 16#0002#),
         28135 => (16#1323#, 16#0020#, 16#0002#),
         28136 => (16#1324#, 16#0020#, 16#0002#),
         28137 => (16#1325#, 16#0020#, 16#0002#),
         28138 => (16#1326#, 16#0020#, 16#0002#),
         28139 => (16#1327#, 16#0020#, 16#0002#),
         28140 => (16#1328#, 16#0020#, 16#0002#),
         28141 => (16#1329#, 16#0020#, 16#0002#),
         28142 => (16#132A#, 16#0020#, 16#0002#),
         28143 => (16#132B#, 16#0020#, 16#0002#),
         28144 => (16#132C#, 16#0020#, 16#0002#),
         28145 => (16#132D#, 16#0020#, 16#0002#),
         28146 => (16#132E#, 16#0020#, 16#0002#),
         28147 => (16#132F#, 16#0020#, 16#0002#),
         28148 => (16#1330#, 16#0020#, 16#0002#),
         28149 => (16#1331#, 16#0020#, 16#0002#),
         28150 => (16#1332#, 16#0020#, 16#0002#),
         28151 => (16#1333#, 16#0020#, 16#0002#),
         28152 => (16#1334#, 16#0020#, 16#0002#),
         28153 => (16#1335#, 16#0020#, 16#0002#),
         28154 => (16#1336#, 16#0020#, 16#0002#),
         28155 => (16#1337#, 16#0020#, 16#0002#),
         28156 => (16#1338#, 16#0020#, 16#0002#),
         28157 => (16#1339#, 16#0020#, 16#0002#),
         28158 => (16#133A#, 16#0020#, 16#0002#),
         28159 => (16#133B#, 16#0020#, 16#0002#),
         28160 => (16#133C#, 16#0020#, 16#0002#),
         28161 => (16#133D#, 16#0020#, 16#0002#),
         28162 => (16#133E#, 16#0020#, 16#0002#),
         28163 => (16#133F#, 16#0020#, 16#0002#),
         28164 => (16#1340#, 16#0020#, 16#0002#),
         28165 => (16#1341#, 16#0020#, 16#0002#),
         28166 => (16#1342#, 16#0020#, 16#0002#),
         28167 => (16#1343#, 16#0020#, 16#0002#),
         28168 => (16#1344#, 16#0020#, 16#0002#),
         28169 => (16#1345#, 16#0020#, 16#0002#),
         28170 => (16#1346#, 16#0020#, 16#0002#),
         28171 => (16#1347#, 16#0020#, 16#0002#),
         28172 => (16#1348#, 16#0020#, 16#0002#),
         28173 => (16#1349#, 16#0020#, 16#0002#),
         28174 => (16#134A#, 16#0020#, 16#0002#),
         28175 => (16#134B#, 16#0020#, 16#0002#),
         28176 => (16#134C#, 16#0020#, 16#0002#),
         28177 => (16#134D#, 16#0020#, 16#0002#),
         28178 => (16#134E#, 16#0020#, 16#0002#),
         28179 => (16#134F#, 16#0020#, 16#0002#),
         28180 => (16#1350#, 16#0020#, 16#0002#),
         28181 => (16#1351#, 16#0020#, 16#0002#),
         28182 => (16#1352#, 16#0020#, 16#0002#),
         28183 => (16#1353#, 16#0020#, 16#0002#),
         28184 => (16#1354#, 16#0020#, 16#0002#),
         28185 => (16#1355#, 16#0020#, 16#0002#),
         28186 => (16#1356#, 16#0020#, 16#0002#),
         28187 => (16#1357#, 16#0020#, 16#0002#),
         28188 => (16#1358#, 16#0020#, 16#0002#),
         28189 => (16#1359#, 16#0020#, 16#0002#),
         28190 => (16#135A#, 16#0020#, 16#0002#),
         28191 => (16#135B#, 16#0020#, 16#0002#),
         28192 => (16#135C#, 16#0020#, 16#0002#),
         28193 => (16#135D#, 16#0020#, 16#0002#),
         28194 => (16#135E#, 16#0020#, 16#0002#),
         28195 => (16#135F#, 16#0020#, 16#0002#),
         28196 => (16#1360#, 16#0020#, 16#0002#),
         28197 => (16#1361#, 16#0020#, 16#0002#),
         28198 => (16#1362#, 16#0020#, 16#0002#),
         28199 => (16#1363#, 16#0020#, 16#0002#),
         28200 => (16#1364#, 16#0020#, 16#0002#),
         28201 => (16#1365#, 16#0020#, 16#0002#),
         28202 => (16#1366#, 16#0020#, 16#0002#),
         28203 => (16#1367#, 16#0020#, 16#0002#),
         28204 => (16#1368#, 16#0020#, 16#0002#),
         28205 => (16#1369#, 16#0020#, 16#0002#),
         28206 => (16#136A#, 16#0020#, 16#0002#),
         28207 => (16#136B#, 16#0020#, 16#0002#),
         28208 => (16#136C#, 16#0020#, 16#0002#),
         28209 => (16#136D#, 16#0020#, 16#0002#),
         28210 => (16#136E#, 16#0020#, 16#0002#),
         28211 => (16#136F#, 16#0020#, 16#0002#),
         28212 => (16#1370#, 16#0020#, 16#0002#),
         28213 => (16#1371#, 16#0020#, 16#0002#),
         28214 => (16#1372#, 16#0020#, 16#0002#),
         28215 => (16#1373#, 16#0020#, 16#0002#),
         28216 => (16#1374#, 16#0020#, 16#0002#),
         28217 => (16#1375#, 16#0020#, 16#0002#),
         28218 => (16#1376#, 16#0020#, 16#0002#),
         28219 => (16#1377#, 16#0020#, 16#0002#),
         28220 => (16#1378#, 16#0020#, 16#0002#),
         28221 => (16#1379#, 16#0020#, 16#0002#),
         28222 => (16#137A#, 16#0020#, 16#0002#),
         28223 => (16#137B#, 16#0020#, 16#0002#),
         28224 => (16#137C#, 16#0020#, 16#0002#),
         28225 => (16#137D#, 16#0020#, 16#0002#),
         28226 => (16#137E#, 16#0020#, 16#0002#),
         28227 => (16#137F#, 16#0020#, 16#0002#),
         28228 => (16#1380#, 16#0020#, 16#0002#),
         28229 => (16#1381#, 16#0020#, 16#0002#),
         28230 => (16#1382#, 16#0020#, 16#0002#),
         28231 => (16#1383#, 16#0020#, 16#0002#),
         28232 => (16#1384#, 16#0020#, 16#0002#),
         28233 => (16#1385#, 16#0020#, 16#0002#),
         28234 => (16#1386#, 16#0020#, 16#0002#),
         28235 => (16#1387#, 16#0020#, 16#0002#),
         28236 => (16#1388#, 16#0020#, 16#0002#),
         28237 => (16#1389#, 16#0020#, 16#0002#),
         28238 => (16#138A#, 16#0020#, 16#0002#),
         28239 => (16#138B#, 16#0020#, 16#0002#),
         28240 => (16#138C#, 16#0020#, 16#0002#),
         28241 => (16#138D#, 16#0020#, 16#0002#),
         28242 => (16#138E#, 16#0020#, 16#0002#),
         28243 => (16#138F#, 16#0020#, 16#0002#),
         28244 => (16#1390#, 16#0020#, 16#0002#),
         28245 => (16#1391#, 16#0020#, 16#0002#),
         28246 => (16#1392#, 16#0020#, 16#0002#),
         28247 => (16#1393#, 16#0020#, 16#0002#),
         28248 => (16#1394#, 16#0020#, 16#0002#),
         28249 => (16#1395#, 16#0020#, 16#0002#),
         28250 => (16#1396#, 16#0020#, 16#0002#),
         28251 => (16#1397#, 16#0020#, 16#0002#),
         28252 => (16#1398#, 16#0020#, 16#0002#),
         28253 => (16#1399#, 16#0020#, 16#0002#),
         28254 => (16#139A#, 16#0020#, 16#0002#),
         28255 => (16#139B#, 16#0020#, 16#0002#),
         28256 => (16#139C#, 16#0020#, 16#0002#),
         28257 => (16#139D#, 16#0020#, 16#0002#),
         28258 => (16#139E#, 16#0020#, 16#0002#),
         28259 => (16#139F#, 16#0020#, 16#0002#),
         28260 => (16#13A0#, 16#0020#, 16#0002#),
         28261 => (16#13A1#, 16#0020#, 16#0002#),
         28262 => (16#13A2#, 16#0020#, 16#0002#),
         28263 => (16#13A3#, 16#0020#, 16#0002#),
         28264 => (16#13A4#, 16#0020#, 16#0002#),
         28265 => (16#13A5#, 16#0020#, 16#0002#),
         28266 => (16#13A6#, 16#0020#, 16#0002#),
         28267 => (16#13A7#, 16#0020#, 16#0002#),
         28268 => (16#13A8#, 16#0020#, 16#0002#),
         28269 => (16#13A9#, 16#0020#, 16#0002#),
         28270 => (16#13AA#, 16#0020#, 16#0002#),
         28271 => (16#13AB#, 16#0020#, 16#0002#),
         28272 => (16#13AC#, 16#0020#, 16#0002#),
         28273 => (16#13AD#, 16#0020#, 16#0002#),
         28274 => (16#13AE#, 16#0020#, 16#0002#),
         28275 => (16#13AF#, 16#0020#, 16#0002#),
         28276 => (16#13B0#, 16#0020#, 16#0002#),
         28277 => (16#13B1#, 16#0020#, 16#0002#),
         28278 => (16#13B2#, 16#0020#, 16#0002#),
         28279 => (16#13B3#, 16#0020#, 16#0002#),
         28280 => (16#13B4#, 16#0020#, 16#0002#),
         28281 => (16#13B5#, 16#0020#, 16#0002#),
         28282 => (16#13B6#, 16#0020#, 16#0002#),
         28283 => (16#13B7#, 16#0020#, 16#0002#),
         28284 => (16#13B8#, 16#0020#, 16#0002#),
         28285 => (16#13B9#, 16#0020#, 16#0002#),
         28286 => (16#13BA#, 16#0020#, 16#0002#),
         28287 => (16#13BB#, 16#0020#, 16#0002#),
         28288 => (16#13BC#, 16#0020#, 16#0002#),
         28289 => (16#13BD#, 16#0020#, 16#0002#),
         28290 => (16#13BE#, 16#0020#, 16#0002#),
         28291 => (16#13BF#, 16#0020#, 16#0002#),
         28292 => (16#13C0#, 16#0020#, 16#0002#),
         28293 => (16#13C1#, 16#0020#, 16#0002#),
         28294 => (16#13C2#, 16#0020#, 16#0002#),
         28295 => (16#13C3#, 16#0020#, 16#0002#),
         28296 => (16#13C4#, 16#0020#, 16#0002#),
         28297 => (16#13C5#, 16#0020#, 16#0002#),
         28298 => (16#13C6#, 16#0020#, 16#0002#),
         28299 => (16#13C7#, 16#0020#, 16#0002#),
         28300 => (16#13C8#, 16#0020#, 16#0002#),
         28301 => (16#13C9#, 16#0020#, 16#0002#),
         28302 => (16#13CA#, 16#0020#, 16#0002#),
         28303 => (16#13CB#, 16#0020#, 16#0002#),
         28304 => (16#13CC#, 16#0020#, 16#0002#),
         28305 => (16#13CD#, 16#0020#, 16#0002#),
         28306 => (16#13CE#, 16#0020#, 16#0002#),
         28307 => (16#13CF#, 16#0020#, 16#0002#),
         28308 => (16#13D0#, 16#0020#, 16#0002#),
         28309 => (16#13D1#, 16#0020#, 16#0002#),
         28310 => (16#13D2#, 16#0020#, 16#0002#),
         28311 => (16#13D3#, 16#0020#, 16#0002#),
         28312 => (16#13D4#, 16#0020#, 16#0002#),
         28313 => (16#13D5#, 16#0020#, 16#0002#),
         28314 => (16#13D6#, 16#0020#, 16#0002#),
         28315 => (16#13D7#, 16#0020#, 16#0002#),
         28316 => (16#13D8#, 16#0020#, 16#0002#),
         28317 => (16#13D9#, 16#0020#, 16#0002#),
         28318 => (16#13DA#, 16#0020#, 16#0002#),
         28319 => (16#13DB#, 16#0020#, 16#0002#),
         28320 => (16#13DC#, 16#0020#, 16#0002#),
         28321 => (16#13DD#, 16#0020#, 16#0002#),
         28322 => (16#13DE#, 16#0020#, 16#0002#),
         28323 => (16#13DF#, 16#0020#, 16#0002#),
         28324 => (16#13E0#, 16#0020#, 16#0002#),
         28325 => (16#13E1#, 16#0020#, 16#0002#),
         28326 => (16#13E2#, 16#0020#, 16#0002#),
         28327 => (16#13E3#, 16#0020#, 16#0002#),
         28328 => (16#13E4#, 16#0020#, 16#0002#),
         28329 => (16#13E5#, 16#0020#, 16#0002#),
         28330 => (16#13E6#, 16#0020#, 16#0002#),
         28331 => (16#13E7#, 16#0020#, 16#0002#),
         28332 => (16#13E8#, 16#0020#, 16#0002#),
         28333 => (16#13E9#, 16#0020#, 16#0002#),
         28334 => (16#13EA#, 16#0020#, 16#0002#),
         28335 => (16#13EB#, 16#0020#, 16#0002#),
         28336 => (16#13EC#, 16#0020#, 16#0002#),
         28337 => (16#13ED#, 16#0020#, 16#0002#),
         28338 => (16#13EE#, 16#0020#, 16#0002#),
         28339 => (16#13EF#, 16#0020#, 16#0002#),
         28340 => (16#13F0#, 16#0020#, 16#0002#),
         28341 => (16#13F1#, 16#0020#, 16#0002#),
         28342 => (16#13F2#, 16#0020#, 16#0002#),
         28343 => (16#13F3#, 16#0020#, 16#0002#),
         28344 => (16#13F4#, 16#0020#, 16#0002#),
         28345 => (16#13F5#, 16#0020#, 16#0002#),
         28346 => (16#13F6#, 16#0020#, 16#0002#),
         28347 => (16#13F7#, 16#0020#, 16#0002#),
         28348 => (16#13F8#, 16#0020#, 16#0002#),
         28349 => (16#13F9#, 16#0020#, 16#0002#),
         28350 => (16#13FA#, 16#0020#, 16#0002#),
         28351 => (16#13FB#, 16#0020#, 16#0002#),
         28352 => (16#13FC#, 16#0020#, 16#0002#),
         28353 => (16#13FD#, 16#0020#, 16#0002#),
         28354 => (16#13FE#, 16#0020#, 16#0002#),
         28355 => (16#13FF#, 16#0020#, 16#0002#),
         28356 => (16#1400#, 16#0020#, 16#0002#),
         28357 => (16#1401#, 16#0020#, 16#0002#),
         28358 => (16#1402#, 16#0020#, 16#0002#),
         28359 => (16#1403#, 16#0020#, 16#0002#),
         28360 => (16#1404#, 16#0020#, 16#0002#),
         28361 => (16#1405#, 16#0020#, 16#0002#),
         28362 => (16#1406#, 16#0020#, 16#0002#),
         28363 => (16#1407#, 16#0020#, 16#0002#),
         28364 => (16#1408#, 16#0020#, 16#0002#),
         28365 => (16#1409#, 16#0020#, 16#0002#),
         28366 => (16#140A#, 16#0020#, 16#0002#),
         28367 => (16#140B#, 16#0020#, 16#0002#),
         28368 => (16#140C#, 16#0020#, 16#0002#),
         28369 => (16#140D#, 16#0020#, 16#0002#),
         28370 => (16#140E#, 16#0020#, 16#0002#),
         28371 => (16#140F#, 16#0020#, 16#0002#),
         28372 => (16#1410#, 16#0020#, 16#0002#),
         28373 => (16#1411#, 16#0020#, 16#0002#),
         28374 => (16#1412#, 16#0020#, 16#0002#),
         28375 => (16#1413#, 16#0020#, 16#0002#),
         28376 => (16#1414#, 16#0020#, 16#0002#),
         28377 => (16#1415#, 16#0020#, 16#0002#),
         28378 => (16#1416#, 16#0020#, 16#0002#),
         28379 => (16#1417#, 16#0020#, 16#0002#),
         28380 => (16#1418#, 16#0020#, 16#0002#),
         28381 => (16#1419#, 16#0020#, 16#0002#),
         28382 => (16#141A#, 16#0020#, 16#0002#),
         28383 => (16#141B#, 16#0020#, 16#0002#),
         28384 => (16#141C#, 16#0020#, 16#0002#),
         28385 => (16#141D#, 16#0020#, 16#0002#),
         28386 => (16#141E#, 16#0020#, 16#0002#),
         28387 => (16#141F#, 16#0020#, 16#0002#),
         28388 => (16#1420#, 16#0020#, 16#0002#),
         28389 => (16#1421#, 16#0020#, 16#0002#),
         28390 => (16#1422#, 16#0020#, 16#0002#),
         28391 => (16#1423#, 16#0020#, 16#0002#),
         28392 => (16#1424#, 16#0020#, 16#0002#),
         28393 => (16#1425#, 16#0020#, 16#0002#),
         28394 => (16#1426#, 16#0020#, 16#0002#),
         28395 => (16#1427#, 16#0020#, 16#0002#),
         28396 => (16#1428#, 16#0020#, 16#0002#),
         28397 => (16#1429#, 16#0020#, 16#0002#),
         28398 => (16#142A#, 16#0020#, 16#0002#),
         28399 => (16#142B#, 16#0020#, 16#0002#),
         28400 => (16#142C#, 16#0020#, 16#0002#),
         28401 => (16#142D#, 16#0020#, 16#0002#),
         28402 => (16#142E#, 16#0020#, 16#0002#),
         28403 => (16#142F#, 16#0020#, 16#0002#),
         28404 => (16#1430#, 16#0020#, 16#0002#),
         28405 => (16#1431#, 16#0020#, 16#0002#),
         28406 => (16#1432#, 16#0020#, 16#0002#),
         28407 => (16#1433#, 16#0020#, 16#0002#),
         28408 => (16#1434#, 16#0020#, 16#0002#),
         28409 => (16#1435#, 16#0020#, 16#0002#),
         28410 => (16#1436#, 16#0020#, 16#0002#),
         28411 => (16#1437#, 16#0020#, 16#0002#),
         28412 => (16#1438#, 16#0020#, 16#0002#),
         28413 => (16#1439#, 16#0020#, 16#0002#),
         28414 => (16#143A#, 16#0020#, 16#0002#),
         28415 => (16#143B#, 16#0020#, 16#0002#),
         28416 => (16#143C#, 16#0020#, 16#0002#),
         28417 => (16#143D#, 16#0020#, 16#0002#),
         28418 => (16#143E#, 16#0020#, 16#0002#),
         28419 => (16#143F#, 16#0020#, 16#0002#),
         28420 => (16#1440#, 16#0020#, 16#0002#),
         28421 => (16#1441#, 16#0020#, 16#0002#),
         28422 => (16#1442#, 16#0020#, 16#0002#),
         28423 => (16#1443#, 16#0020#, 16#0002#),
         28424 => (16#1444#, 16#0020#, 16#0002#),
         28425 => (16#1445#, 16#0020#, 16#0002#),
         28426 => (16#1446#, 16#0020#, 16#0002#),
         28427 => (16#1447#, 16#0020#, 16#0002#),
         28428 => (16#1448#, 16#0020#, 16#0002#),
         28429 => (16#1449#, 16#0020#, 16#0002#),
         28430 => (16#144A#, 16#0020#, 16#0002#),
         28431 => (16#144B#, 16#0020#, 16#0002#),
         28432 => (16#144C#, 16#0020#, 16#0002#),
         28433 => (16#144D#, 16#0020#, 16#0002#),
         28434 => (16#144E#, 16#0020#, 16#0002#),
         28435 => (16#144F#, 16#0020#, 16#0002#),
         28436 => (16#1450#, 16#0020#, 16#0002#),
         28437 => (16#1451#, 16#0020#, 16#0002#),
         28438 => (16#1452#, 16#0020#, 16#0002#),
         28439 => (16#1453#, 16#0020#, 16#0002#),
         28440 => (16#1454#, 16#0020#, 16#0002#),
         28441 => (16#1455#, 16#0020#, 16#0002#),
         28442 => (16#1456#, 16#0020#, 16#0002#),
         28443 => (16#1457#, 16#0020#, 16#0002#),
         28444 => (16#1458#, 16#0020#, 16#0002#),
         28445 => (16#1459#, 16#0020#, 16#0002#),
         28446 => (16#145A#, 16#0020#, 16#0002#),
         28447 => (16#145B#, 16#0020#, 16#0002#),
         28448 => (16#145C#, 16#0020#, 16#0002#),
         28449 => (16#145D#, 16#0020#, 16#0002#),
         28450 => (16#145E#, 16#0020#, 16#0002#),
         28451 => (16#145F#, 16#0020#, 16#0002#),
         28452 => (16#1460#, 16#0020#, 16#0002#),
         28453 => (16#1461#, 16#0020#, 16#0002#),
         28454 => (16#1462#, 16#0020#, 16#0002#),
         28455 => (16#1463#, 16#0020#, 16#0002#),
         28456 => (16#1464#, 16#0020#, 16#0002#),
         28457 => (16#1465#, 16#0020#, 16#0002#),
         28458 => (16#1466#, 16#0020#, 16#0002#),
         28459 => (16#1467#, 16#0020#, 16#0002#),
         28460 => (16#1468#, 16#0020#, 16#0002#),
         28461 => (16#1469#, 16#0020#, 16#0002#),
         28462 => (16#146A#, 16#0020#, 16#0002#),
         28463 => (16#146B#, 16#0020#, 16#0002#),
         28464 => (16#146C#, 16#0020#, 16#0002#),
         28465 => (16#146D#, 16#0020#, 16#0002#),
         28466 => (16#146E#, 16#0020#, 16#0002#),
         28467 => (16#146F#, 16#0020#, 16#0002#),
         28468 => (16#1470#, 16#0020#, 16#0002#),
         28469 => (16#1471#, 16#0020#, 16#0002#),
         28470 => (16#1472#, 16#0020#, 16#0002#),
         28471 => (16#1473#, 16#0020#, 16#0002#),
         28472 => (16#1474#, 16#0020#, 16#0002#),
         28473 => (16#1475#, 16#0020#, 16#0002#),
         28474 => (16#1476#, 16#0020#, 16#0002#),
         28475 => (16#1477#, 16#0020#, 16#0002#),
         28476 => (16#1478#, 16#0020#, 16#0002#),
         28477 => (16#1479#, 16#0020#, 16#0002#),
         28478 => (16#147A#, 16#0020#, 16#0002#),
         28479 => (16#147B#, 16#0020#, 16#0002#),
         28480 => (16#147C#, 16#0020#, 16#0002#),
         28481 => (16#147D#, 16#0020#, 16#0002#),
         28482 => (16#147E#, 16#0020#, 16#0002#),
         28483 => (16#147F#, 16#0020#, 16#0002#),
         28484 => (16#1480#, 16#0020#, 16#0002#),
         28485 => (16#1481#, 16#0020#, 16#0002#),
         28486 => (16#1482#, 16#0020#, 16#0002#),
         28487 => (16#1483#, 16#0020#, 16#0002#),
         28488 => (16#1484#, 16#0020#, 16#0002#),
         28489 => (16#1485#, 16#0020#, 16#0002#),
         28490 => (16#1486#, 16#0020#, 16#0002#),
         28491 => (16#1487#, 16#0020#, 16#0002#),
         28492 => (16#1488#, 16#0020#, 16#0002#),
         28493 => (16#1489#, 16#0020#, 16#0002#),
         28494 => (16#148A#, 16#0020#, 16#0002#),
         28495 => (16#148B#, 16#0020#, 16#0002#),
         28496 => (16#148C#, 16#0020#, 16#0002#),
         28497 => (16#148D#, 16#0020#, 16#0002#),
         28498 => (16#148E#, 16#0020#, 16#0002#),
         28499 => (16#148F#, 16#0020#, 16#0002#),
         28500 => (16#1490#, 16#0020#, 16#0002#),
         28501 => (16#1491#, 16#0020#, 16#0002#),
         28502 => (16#1492#, 16#0020#, 16#0002#),
         28503 => (16#1493#, 16#0020#, 16#0002#),
         28504 => (16#1494#, 16#0020#, 16#0002#),
         28505 => (16#1495#, 16#0020#, 16#0002#),
         28506 => (16#1496#, 16#0020#, 16#0002#),
         28507 => (16#1497#, 16#0020#, 16#0002#),
         28508 => (16#1498#, 16#0020#, 16#0002#),
         28509 => (16#1499#, 16#0020#, 16#0002#),
         28510 => (16#149A#, 16#0020#, 16#0002#),
         28511 => (16#149B#, 16#0020#, 16#0002#),
         28512 => (16#149C#, 16#0020#, 16#0002#),
         28513 => (16#149D#, 16#0020#, 16#0002#),
         28514 => (16#149E#, 16#0020#, 16#0002#),
         28515 => (16#149F#, 16#0020#, 16#0002#),
         28516 => (16#14A0#, 16#0020#, 16#0002#),
         28517 => (16#14A1#, 16#0020#, 16#0002#),
         28518 => (16#14A2#, 16#0020#, 16#0002#),
         28519 => (16#14A3#, 16#0020#, 16#0002#),
         28520 => (16#14A4#, 16#0020#, 16#0002#),
         28521 => (16#14A5#, 16#0020#, 16#0002#),
         28522 => (16#14A6#, 16#0020#, 16#0002#),
         28523 => (16#14A7#, 16#0020#, 16#0002#),
         28524 => (16#14A8#, 16#0020#, 16#0002#),
         28525 => (16#14A9#, 16#0020#, 16#0002#),
         28526 => (16#14AA#, 16#0020#, 16#0002#),
         28527 => (16#14AB#, 16#0020#, 16#0002#),
         28528 => (16#14AC#, 16#0020#, 16#0002#),
         28529 => (16#14AD#, 16#0020#, 16#0002#),
         28530 => (16#14AE#, 16#0020#, 16#0002#),
         28531 => (16#14AF#, 16#0020#, 16#0002#),
         28532 => (16#14B0#, 16#0020#, 16#0002#),
         28533 => (16#14B1#, 16#0020#, 16#0002#),
         28534 => (16#14B2#, 16#0020#, 16#0002#),
         28535 => (16#14B3#, 16#0020#, 16#0002#),
         28536 => (16#14B4#, 16#0020#, 16#0002#),
         28537 => (16#14B5#, 16#0020#, 16#0002#),
         28538 => (16#14B6#, 16#0020#, 16#0002#),
         28539 => (16#14B7#, 16#0020#, 16#0002#),
         28540 => (16#14B8#, 16#0020#, 16#0002#),
         28541 => (16#14B9#, 16#0020#, 16#0002#),
         28542 => (16#14BA#, 16#0020#, 16#0002#),
         28543 => (16#14BB#, 16#0020#, 16#0002#),
         28544 => (16#14BC#, 16#0020#, 16#0002#),
         28545 => (16#14BD#, 16#0020#, 16#0002#),
         28546 => (16#14BE#, 16#0020#, 16#0002#),
         28547 => (16#14BF#, 16#0020#, 16#0002#),
         28548 => (16#14C0#, 16#0020#, 16#0002#),
         28549 => (16#14C1#, 16#0020#, 16#0002#),
         28550 => (16#14C2#, 16#0020#, 16#0002#),
         28551 => (16#14C3#, 16#0020#, 16#0002#),
         28552 => (16#14C4#, 16#0020#, 16#0002#),
         28553 => (16#14C5#, 16#0020#, 16#0002#),
         28554 => (16#14C6#, 16#0020#, 16#0002#),
         28555 => (16#14C7#, 16#0020#, 16#0002#),
         28556 => (16#14C8#, 16#0020#, 16#0002#),
         28557 => (16#14C9#, 16#0020#, 16#0002#),
         28558 => (16#14CA#, 16#0020#, 16#0002#),
         28559 => (16#14CB#, 16#0020#, 16#0002#),
         28560 => (16#14CC#, 16#0020#, 16#0002#),
         28561 => (16#14CD#, 16#0020#, 16#0002#),
         28562 => (16#14CE#, 16#0020#, 16#0002#),
         28563 => (16#14CF#, 16#0020#, 16#0002#),
         28564 => (16#14D0#, 16#0020#, 16#0002#),
         28565 => (16#14D1#, 16#0020#, 16#0002#),
         28566 => (16#14D2#, 16#0020#, 16#0002#),
         28567 => (16#14D3#, 16#0020#, 16#0002#),
         28568 => (16#14D4#, 16#0020#, 16#0002#),
         28569 => (16#14D5#, 16#0020#, 16#0002#),
         28570 => (16#14D6#, 16#0020#, 16#0002#),
         28571 => (16#14D7#, 16#0020#, 16#0002#),
         28572 => (16#14D8#, 16#0020#, 16#0002#),
         28573 => (16#14D9#, 16#0020#, 16#0002#),
         28574 => (16#14DA#, 16#0020#, 16#0002#),
         28575 => (16#14DB#, 16#0020#, 16#0002#),
         28576 => (16#14DC#, 16#0020#, 16#0002#),
         28577 => (16#14DD#, 16#0020#, 16#0002#),
         28578 => (16#14DE#, 16#0020#, 16#0002#),
         28579 => (16#14DF#, 16#0020#, 16#0002#),
         28580 => (16#14E0#, 16#0020#, 16#0002#),
         28581 => (16#14E1#, 16#0020#, 16#0002#),
         28582 => (16#14E2#, 16#0020#, 16#0002#),
         28583 => (16#14E3#, 16#0020#, 16#0002#),
         28584 => (16#14E4#, 16#0020#, 16#0002#),
         28585 => (16#14E5#, 16#0020#, 16#0002#),
         28586 => (16#14E6#, 16#0020#, 16#0002#),
         28587 => (16#14E7#, 16#0020#, 16#0002#),
         28588 => (16#14E8#, 16#0020#, 16#0002#),
         28589 => (16#14E9#, 16#0020#, 16#0002#),
         28590 => (16#14EA#, 16#0020#, 16#0002#),
         28591 => (16#14EB#, 16#0020#, 16#0002#),
         28592 => (16#14EC#, 16#0020#, 16#0002#),
         28593 => (16#14ED#, 16#0020#, 16#0002#),
         28594 => (16#14EE#, 16#0020#, 16#0002#),
         28595 => (16#14EF#, 16#0020#, 16#0002#),
         28596 => (16#14F0#, 16#0020#, 16#0002#),
         28597 => (16#14F1#, 16#0020#, 16#0002#),
         28598 => (16#14F2#, 16#0020#, 16#0002#),
         28599 => (16#14F3#, 16#0020#, 16#0002#),
         28600 => (16#14F4#, 16#0020#, 16#0002#),
         28601 => (16#14F5#, 16#0020#, 16#0002#),
         28602 => (16#14F6#, 16#0020#, 16#0002#),
         28603 => (16#14F7#, 16#0020#, 16#0002#),
         28604 => (16#14F8#, 16#0020#, 16#0002#),
         28605 => (16#14F9#, 16#0020#, 16#0002#),
         28606 => (16#14FA#, 16#0020#, 16#0002#),
         28607 => (16#14FB#, 16#0020#, 16#0002#),
         28608 => (16#14FC#, 16#0020#, 16#0002#),
         28609 => (16#14FD#, 16#0020#, 16#0002#),
         28610 => (16#14FE#, 16#0020#, 16#0002#),
         28611 => (16#14FF#, 16#0020#, 16#0002#),
         28612 => (16#1500#, 16#0020#, 16#0002#),
         28613 => (16#1501#, 16#0020#, 16#0002#),
         28614 => (16#1502#, 16#0020#, 16#0002#),
         28615 => (16#1503#, 16#0020#, 16#0002#),
         28616 => (16#1504#, 16#0020#, 16#0002#),
         28617 => (16#1505#, 16#0020#, 16#0002#),
         28618 => (16#1506#, 16#0020#, 16#0002#),
         28619 => (16#1507#, 16#0020#, 16#0002#),
         28620 => (16#1508#, 16#0020#, 16#0002#),
         28621 => (16#1509#, 16#0020#, 16#0002#),
         28622 => (16#150A#, 16#0020#, 16#0002#),
         28623 => (16#150B#, 16#0020#, 16#0002#),
         28624 => (16#150C#, 16#0020#, 16#0002#),
         28625 => (16#150D#, 16#0020#, 16#0002#),
         28626 => (16#150E#, 16#0020#, 16#0002#),
         28627 => (16#150F#, 16#0020#, 16#0002#),
         28628 => (16#1510#, 16#0020#, 16#0002#),
         28629 => (16#1511#, 16#0020#, 16#0002#),
         28630 => (16#1512#, 16#0020#, 16#0002#),
         28631 => (16#1513#, 16#0020#, 16#0002#),
         28632 => (16#1514#, 16#0020#, 16#0002#),
         28633 => (16#1515#, 16#0020#, 16#0002#),
         28634 => (16#1516#, 16#0020#, 16#0002#),
         28635 => (16#1517#, 16#0020#, 16#0002#),
         28636 => (16#1518#, 16#0020#, 16#0002#),
         28637 => (16#1519#, 16#0020#, 16#0002#),
         28638 => (16#151A#, 16#0020#, 16#0002#),
         28639 => (16#151B#, 16#0020#, 16#0002#),
         28640 => (16#151C#, 16#0020#, 16#0002#),
         28641 => (16#151D#, 16#0020#, 16#0002#),
         28642 => (16#151E#, 16#0020#, 16#0002#),
         28643 => (16#151F#, 16#0020#, 16#0002#),
         28644 => (16#1520#, 16#0020#, 16#0002#),
         28645 => (16#1521#, 16#0020#, 16#0002#),
         28646 => (16#1522#, 16#0020#, 16#0002#),
         28647 => (16#1523#, 16#0020#, 16#0002#),
         28648 => (16#1524#, 16#0020#, 16#0002#),
         28649 => (16#1525#, 16#0020#, 16#0002#),
         28650 => (16#1526#, 16#0020#, 16#0002#),
         28651 => (16#1527#, 16#0020#, 16#0002#),
         28652 => (16#1528#, 16#0020#, 16#0002#),
         28653 => (16#1529#, 16#0020#, 16#0002#),
         28654 => (16#152A#, 16#0020#, 16#0002#),
         28655 => (16#152B#, 16#0020#, 16#0002#),
         28656 => (16#152C#, 16#0020#, 16#0002#),
         28657 => (16#152D#, 16#0020#, 16#0002#),
         28658 => (16#152E#, 16#0020#, 16#0002#),
         28659 => (16#152F#, 16#0020#, 16#0002#),
         28660 => (16#1530#, 16#0020#, 16#0002#),
         28661 => (16#1531#, 16#0020#, 16#0002#),
         28662 => (16#1532#, 16#0020#, 16#0002#),
         28663 => (16#1533#, 16#0020#, 16#0002#),
         28664 => (16#1534#, 16#0020#, 16#0002#),
         28665 => (16#1535#, 16#0020#, 16#0002#),
         28666 => (16#1536#, 16#0020#, 16#0002#),
         28667 => (16#1537#, 16#0020#, 16#0002#),
         28668 => (16#1538#, 16#0020#, 16#0002#),
         28669 => (16#1539#, 16#0020#, 16#0002#),
         28670 => (16#153A#, 16#0020#, 16#0002#),
         28671 => (16#153B#, 16#0020#, 16#0002#),
         28672 => (16#153C#, 16#0020#, 16#0002#),
         28673 => (16#153D#, 16#0020#, 16#0002#),
         28674 => (16#153E#, 16#0020#, 16#0002#),
         28675 => (16#153F#, 16#0020#, 16#0002#),
         28676 => (16#1540#, 16#0020#, 16#0002#),
         28677 => (16#1541#, 16#0020#, 16#0002#),
         28678 => (16#1542#, 16#0020#, 16#0002#),
         28679 => (16#1543#, 16#0020#, 16#0002#),
         28680 => (16#1544#, 16#0020#, 16#0002#),
         28681 => (16#1545#, 16#0020#, 16#0002#),
         28682 => (16#1546#, 16#0020#, 16#0002#),
         28683 => (16#1547#, 16#0020#, 16#0002#),
         28684 => (16#1548#, 16#0020#, 16#0002#),
         28685 => (16#1549#, 16#0020#, 16#0002#),
         28686 => (16#154A#, 16#0020#, 16#0002#),
         28687 => (16#154B#, 16#0020#, 16#0002#),
         28688 => (16#154C#, 16#0020#, 16#0002#),
         28689 => (16#154D#, 16#0020#, 16#0002#),
         28690 => (16#154E#, 16#0020#, 16#0002#),
         28691 => (16#154F#, 16#0020#, 16#0002#),
         28692 => (16#1550#, 16#0020#, 16#0002#),
         28693 => (16#1551#, 16#0020#, 16#0002#),
         28694 => (16#1552#, 16#0020#, 16#0002#),
         28695 => (16#1553#, 16#0020#, 16#0002#),
         28696 => (16#1554#, 16#0020#, 16#0002#),
         28697 => (16#1555#, 16#0020#, 16#0002#),
         28698 => (16#1556#, 16#0020#, 16#0002#),
         28699 => (16#1557#, 16#0020#, 16#0002#),
         28700 => (16#1558#, 16#0020#, 16#0002#),
         28701 => (16#1559#, 16#0020#, 16#0002#),
         28702 => (16#155A#, 16#0020#, 16#0002#),
         28703 => (16#155B#, 16#0020#, 16#0002#),
         28704 => (16#155C#, 16#0020#, 16#0002#),
         28705 => (16#155D#, 16#0020#, 16#0002#),
         28706 => (16#155E#, 16#0020#, 16#0002#),
         28707 => (16#155F#, 16#0020#, 16#0002#),
         28708 => (16#1560#, 16#0020#, 16#0002#),
         28709 => (16#1561#, 16#0020#, 16#0002#),
         28710 => (16#1562#, 16#0020#, 16#0002#),
         28711 => (16#1563#, 16#0020#, 16#0002#),
         28712 => (16#1564#, 16#0020#, 16#0002#),
         28713 => (16#1565#, 16#0020#, 16#0002#),
         28714 => (16#1566#, 16#0020#, 16#0002#),
         28715 => (16#1567#, 16#0020#, 16#0002#),
         28716 => (16#1568#, 16#0020#, 16#0002#),
         28717 => (16#1569#, 16#0020#, 16#0002#),
         28718 => (16#156A#, 16#0020#, 16#0002#),
         28719 => (16#156B#, 16#0020#, 16#0002#),
         28720 => (16#156C#, 16#0020#, 16#0002#),
         28721 => (16#156D#, 16#0020#, 16#0002#),
         28722 => (16#156E#, 16#0020#, 16#0002#),
         28723 => (16#156F#, 16#0020#, 16#0002#),
         28724 => (16#1570#, 16#0020#, 16#0002#),
         28725 => (16#1571#, 16#0020#, 16#0002#),
         28726 => (16#1572#, 16#0020#, 16#0002#),
         28727 => (16#1573#, 16#0020#, 16#0002#),
         28728 => (16#1574#, 16#0020#, 16#0002#),
         28729 => (16#1575#, 16#0020#, 16#0002#),
         28730 => (16#1576#, 16#0020#, 16#0002#),
         28731 => (16#1577#, 16#0020#, 16#0002#),
         28732 => (16#1578#, 16#0020#, 16#0002#),
         28733 => (16#1579#, 16#0020#, 16#0002#),
         28734 => (16#157A#, 16#0020#, 16#0002#),
         28735 => (16#157B#, 16#0020#, 16#0002#),
         28736 => (16#157C#, 16#0020#, 16#0002#),
         28737 => (16#157D#, 16#0020#, 16#0002#),
         28738 => (16#157E#, 16#0020#, 16#0002#),
         28739 => (16#157F#, 16#0020#, 16#0002#),
         28740 => (16#1580#, 16#0020#, 16#0002#),
         28741 => (16#1581#, 16#0020#, 16#0002#),
         28742 => (16#1582#, 16#0020#, 16#0002#),
         28743 => (16#1583#, 16#0020#, 16#0002#),
         28744 => (16#1584#, 16#0020#, 16#0002#),
         28745 => (16#1585#, 16#0020#, 16#0002#),
         28746 => (16#1586#, 16#0020#, 16#0002#),
         28747 => (16#1587#, 16#0020#, 16#0002#),
         28748 => (16#1588#, 16#0020#, 16#0002#),
         28749 => (16#1589#, 16#0020#, 16#0002#),
         28750 => (16#158A#, 16#0020#, 16#0002#),
         28751 => (16#158B#, 16#0020#, 16#0002#),
         28752 => (16#158C#, 16#0020#, 16#0002#),
         28753 => (16#158D#, 16#0020#, 16#0002#),
         28754 => (16#158E#, 16#0020#, 16#0002#),
         28755 => (16#158F#, 16#0020#, 16#0002#),
         28756 => (16#1590#, 16#0020#, 16#0002#),
         28757 => (16#1591#, 16#0020#, 16#0002#),
         28758 => (16#1592#, 16#0020#, 16#0002#),
         28759 => (16#1593#, 16#0020#, 16#0002#),
         28760 => (16#1594#, 16#0020#, 16#0002#),
         28761 => (16#1595#, 16#0020#, 16#0002#),
         28762 => (16#1596#, 16#0020#, 16#0002#),
         28763 => (16#1597#, 16#0020#, 16#0002#),
         28764 => (16#1598#, 16#0020#, 16#0002#),
         28765 => (16#1599#, 16#0020#, 16#0002#),
         28766 => (16#159A#, 16#0020#, 16#0002#),
         28767 => (16#159B#, 16#0020#, 16#0002#),
         28768 => (16#159C#, 16#0020#, 16#0002#),
         28769 => (16#159D#, 16#0020#, 16#0002#),
         28770 => (16#159E#, 16#0020#, 16#0002#),
         28771 => (16#159F#, 16#0020#, 16#0002#),
         28772 => (16#15A0#, 16#0020#, 16#0002#),
         28773 => (16#15A1#, 16#0020#, 16#0002#),
         28774 => (16#15A2#, 16#0020#, 16#0002#),
         28775 => (16#15A3#, 16#0020#, 16#0002#),
         28776 => (16#15A4#, 16#0020#, 16#0002#),
         28777 => (16#15A5#, 16#0020#, 16#0002#),
         28778 => (16#15A6#, 16#0020#, 16#0002#),
         28779 => (16#15A7#, 16#0020#, 16#0002#),
         28780 => (16#15A8#, 16#0020#, 16#0002#),
         28781 => (16#15A9#, 16#0020#, 16#0002#),
         28782 => (16#15AA#, 16#0020#, 16#0002#),
         28783 => (16#15AB#, 16#0020#, 16#0002#),
         28784 => (16#15AC#, 16#0020#, 16#0002#),
         28785 => (16#15AD#, 16#0020#, 16#0002#),
         28786 => (16#15AE#, 16#0020#, 16#0002#),
         28787 => (16#15AF#, 16#0020#, 16#0002#),
         28788 => (16#15B0#, 16#0020#, 16#0002#),
         28789 => (16#15B1#, 16#0020#, 16#0002#),
         28790 => (16#15B2#, 16#0020#, 16#0002#),
         28791 => (16#15B3#, 16#0020#, 16#0002#),
         28792 => (16#15B4#, 16#0020#, 16#0002#),
         28793 => (16#15B5#, 16#0020#, 16#0002#),
         28794 => (16#15B6#, 16#0020#, 16#0002#),
         28795 => (16#15B7#, 16#0020#, 16#0002#),
         28796 => (16#15B8#, 16#0020#, 16#0002#),
         28797 => (16#15B9#, 16#0020#, 16#0002#),
         28798 => (16#15BA#, 16#0020#, 16#0002#),
         28799 => (16#15BB#, 16#0020#, 16#0002#),
         28800 => (16#15BC#, 16#0020#, 16#0002#),
         28801 => (16#15BD#, 16#0020#, 16#0002#),
         28802 => (16#15BE#, 16#0020#, 16#0002#),
         28803 => (16#15BF#, 16#0020#, 16#0002#),
         28804 => (16#15C0#, 16#0020#, 16#0002#),
         28805 => (16#15C1#, 16#0020#, 16#0002#),
         28806 => (16#15C2#, 16#0020#, 16#0002#),
         28807 => (16#15C3#, 16#0020#, 16#0002#),
         28808 => (16#15C4#, 16#0020#, 16#0002#),
         28809 => (16#15C5#, 16#0020#, 16#0002#),
         28810 => (16#15C6#, 16#0020#, 16#0002#),
         28811 => (16#15C7#, 16#0020#, 16#0002#),
         28812 => (16#15C8#, 16#0020#, 16#0002#),
         28813 => (16#15C9#, 16#0020#, 16#0002#),
         28814 => (16#15CA#, 16#0020#, 16#0002#),
         28815 => (16#15CB#, 16#0020#, 16#0002#),
         28816 => (16#15CC#, 16#0020#, 16#0002#),
         28817 => (16#15CD#, 16#0020#, 16#0002#),
         28818 => (16#15CE#, 16#0020#, 16#0002#),
         28819 => (16#15CF#, 16#0020#, 16#0002#),
         28820 => (16#15D0#, 16#0020#, 16#0002#),
         28821 => (16#15D1#, 16#0020#, 16#0002#),
         28822 => (16#15D2#, 16#0020#, 16#0002#),
         28823 => (16#15D3#, 16#0020#, 16#0002#),
         28824 => (16#15D4#, 16#0020#, 16#0002#),
         28825 => (16#15D5#, 16#0020#, 16#0002#),
         28826 => (16#15D6#, 16#0020#, 16#0002#),
         28827 => (16#15D7#, 16#0020#, 16#0002#),
         28828 => (16#15D8#, 16#0020#, 16#0002#),
         28829 => (16#15D9#, 16#0020#, 16#0002#),
         28830 => (16#15DA#, 16#0020#, 16#0002#),
         28831 => (16#15DB#, 16#0020#, 16#0002#),
         28832 => (16#15DC#, 16#0020#, 16#0002#),
         28833 => (16#15DD#, 16#0020#, 16#0002#),
         28834 => (16#15DE#, 16#0020#, 16#0002#),
         28835 => (16#15DF#, 16#0020#, 16#0002#),
         28836 => (16#15E0#, 16#0020#, 16#0002#),
         28837 => (16#15E1#, 16#0020#, 16#0002#),
         28838 => (16#15E2#, 16#0020#, 16#0002#),
         28839 => (16#15E3#, 16#0020#, 16#0002#),
         28840 => (16#15E4#, 16#0020#, 16#0002#),
         28841 => (16#15E5#, 16#0020#, 16#0002#),
         28842 => (16#15E6#, 16#0020#, 16#0002#),
         28843 => (16#15E7#, 16#0020#, 16#0002#),
         28844 => (16#15E8#, 16#0020#, 16#0002#),
         28845 => (16#15E9#, 16#0020#, 16#0002#),
         28846 => (16#15EA#, 16#0020#, 16#0002#),
         28847 => (16#15EB#, 16#0020#, 16#0002#),
         28848 => (16#15EC#, 16#0020#, 16#0002#),
         28849 => (16#15ED#, 16#0020#, 16#0002#),
         28850 => (16#15EE#, 16#0020#, 16#0002#),
         28851 => (16#15EF#, 16#0020#, 16#0002#),
         28852 => (16#15F0#, 16#0020#, 16#0002#),
         28853 => (16#15F1#, 16#0020#, 16#0002#),
         28854 => (16#15F2#, 16#0020#, 16#0002#),
         28855 => (16#15F3#, 16#0020#, 16#0002#),
         28856 => (16#15F4#, 16#0020#, 16#0002#),
         28857 => (16#15F5#, 16#0020#, 16#0002#),
         28858 => (16#15F6#, 16#0020#, 16#0002#),
         28859 => (16#15F7#, 16#0020#, 16#0002#),
         28860 => (16#15F8#, 16#0020#, 16#0002#),
         28861 => (16#15F9#, 16#0020#, 16#0002#),
         28862 => (16#15FA#, 16#0020#, 16#0002#),
         28863 => (16#15FB#, 16#0020#, 16#0002#),
         28864 => (16#15FC#, 16#0020#, 16#0002#),
         28865 => (16#15FD#, 16#0020#, 16#0002#),
         28866 => (16#15FE#, 16#0020#, 16#0002#),
         28867 => (16#15FF#, 16#0020#, 16#0002#),
         28868 => (16#1600#, 16#0020#, 16#0002#),
         28869 => (16#1601#, 16#0020#, 16#0002#),
         28870 => (16#1602#, 16#0020#, 16#0002#),
         28871 => (16#1603#, 16#0020#, 16#0002#),
         28872 => (16#1604#, 16#0020#, 16#0002#),
         28873 => (16#1605#, 16#0020#, 16#0002#),
         28874 => (16#1606#, 16#0020#, 16#0002#),
         28875 => (16#1607#, 16#0020#, 16#0002#),
         28876 => (16#1608#, 16#0020#, 16#0002#),
         28877 => (16#1609#, 16#0020#, 16#0002#),
         28878 => (16#160A#, 16#0020#, 16#0002#),
         28879 => (16#160B#, 16#0020#, 16#0002#),
         28880 => (16#160C#, 16#0020#, 16#0002#),
         28881 => (16#160D#, 16#0020#, 16#0002#),
         28882 => (16#160E#, 16#0020#, 16#0002#),
         28883 => (16#160F#, 16#0020#, 16#0002#),
         28884 => (16#1610#, 16#0020#, 16#0002#),
         28885 => (16#1611#, 16#0020#, 16#0002#),
         28886 => (16#1612#, 16#0020#, 16#0002#),
         28887 => (16#1613#, 16#0020#, 16#0002#),
         28888 => (16#1614#, 16#0020#, 16#0002#),
         28889 => (16#1615#, 16#0020#, 16#0002#),
         28890 => (16#1616#, 16#0020#, 16#0002#),
         28891 => (16#1617#, 16#0020#, 16#0002#),
         28892 => (16#1618#, 16#0020#, 16#0002#),
         28893 => (16#1619#, 16#0020#, 16#0002#),
         28894 => (16#161A#, 16#0020#, 16#0002#),
         28895 => (16#161B#, 16#0020#, 16#0002#),
         28896 => (16#161C#, 16#0020#, 16#0002#),
         28897 => (16#161D#, 16#0020#, 16#0002#),
         28898 => (16#161E#, 16#0020#, 16#0002#),
         28899 => (16#161F#, 16#0020#, 16#0002#),
         28900 => (16#1620#, 16#0020#, 16#0002#),
         28901 => (16#1621#, 16#0020#, 16#0002#),
         28902 => (16#1622#, 16#0020#, 16#0002#),
         28903 => (16#1623#, 16#0020#, 16#0002#),
         28904 => (16#1624#, 16#0020#, 16#0002#),
         28905 => (16#1625#, 16#0020#, 16#0002#),
         28906 => (16#1626#, 16#0020#, 16#0002#),
         28907 => (16#1627#, 16#0020#, 16#0002#),
         28908 => (16#1628#, 16#0020#, 16#0002#),
         28909 => (16#1629#, 16#0020#, 16#0002#),
         28910 => (16#162A#, 16#0020#, 16#0002#),
         28911 => (16#162B#, 16#0020#, 16#0002#),
         28912 => (16#162C#, 16#0020#, 16#0002#),
         28913 => (16#162D#, 16#0020#, 16#0002#),
         28914 => (16#162E#, 16#0020#, 16#0002#),
         28915 => (16#162F#, 16#0020#, 16#0002#),
         28916 => (16#1630#, 16#0020#, 16#0002#),
         28917 => (16#1631#, 16#0020#, 16#0002#),
         28918 => (16#1632#, 16#0020#, 16#0002#),
         28919 => (16#1633#, 16#0020#, 16#0002#),
         28920 => (16#1634#, 16#0020#, 16#0002#),
         28921 => (16#1635#, 16#0020#, 16#0002#),
         28922 => (16#1636#, 16#0020#, 16#0002#),
         28923 => (16#1637#, 16#0020#, 16#0002#),
         28924 => (16#1638#, 16#0020#, 16#0002#),
         28925 => (16#1639#, 16#0020#, 16#0002#),
         28926 => (16#163A#, 16#0020#, 16#0002#),
         28927 => (16#163B#, 16#0020#, 16#0002#),
         28928 => (16#163C#, 16#0020#, 16#0002#),
         28929 => (16#163D#, 16#0020#, 16#0002#),
         28930 => (16#163E#, 16#0020#, 16#0002#),
         28931 => (16#163F#, 16#0020#, 16#0002#),
         28932 => (16#1640#, 16#0020#, 16#0002#),
         28933 => (16#1641#, 16#0020#, 16#0002#),
         28934 => (16#1642#, 16#0020#, 16#0002#),
         28935 => (16#1643#, 16#0020#, 16#0002#),
         28936 => (16#1644#, 16#0020#, 16#0002#),
         28937 => (16#1645#, 16#0020#, 16#0002#),
         28938 => (16#1646#, 16#0020#, 16#0002#),
         28939 => (16#1647#, 16#0020#, 16#0002#),
         28940 => (16#1648#, 16#0020#, 16#0002#),
         28941 => (16#1649#, 16#0020#, 16#0002#),
         28942 => (16#164A#, 16#0020#, 16#0002#),
         28943 => (16#164B#, 16#0020#, 16#0002#),
         28944 => (16#164C#, 16#0020#, 16#0002#),
         28945 => (16#164D#, 16#0020#, 16#0002#),
         28946 => (16#164E#, 16#0020#, 16#0002#),
         28947 => (16#164F#, 16#0020#, 16#0002#),
         28948 => (16#1650#, 16#0020#, 16#0002#),
         28949 => (16#1651#, 16#0020#, 16#0002#),
         28950 => (16#1652#, 16#0020#, 16#0002#),
         28951 => (16#1653#, 16#0020#, 16#0002#),
         28952 => (16#1654#, 16#0020#, 16#0002#),
         28953 => (16#1655#, 16#0020#, 16#0002#),
         28954 => (16#1656#, 16#0020#, 16#0002#),
         28955 => (16#1657#, 16#0020#, 16#0002#),
         28956 => (16#1658#, 16#0020#, 16#0002#),
         28957 => (16#1659#, 16#0020#, 16#0002#),
         28958 => (16#165A#, 16#0020#, 16#0002#),
         28959 => (16#165B#, 16#0020#, 16#0002#),
         28960 => (16#165C#, 16#0020#, 16#0002#),
         28961 => (16#165D#, 16#0020#, 16#0002#),
         28962 => (16#165E#, 16#0020#, 16#0002#),
         28963 => (16#165F#, 16#0020#, 16#0002#),
         28964 => (16#1660#, 16#0020#, 16#0002#),
         28965 => (16#1661#, 16#0020#, 16#0002#),
         28966 => (16#1662#, 16#0020#, 16#0002#),
         28967 => (16#1663#, 16#0020#, 16#0002#),
         28968 => (16#1664#, 16#0020#, 16#0002#),
         28969 => (16#1665#, 16#0020#, 16#0002#),
         28970 => (16#1666#, 16#0020#, 16#0002#),
         28971 => (16#1667#, 16#0020#, 16#0002#),
         28972 => (16#1668#, 16#0020#, 16#0002#),
         28973 => (16#1669#, 16#0020#, 16#0002#),
         28974 => (16#166A#, 16#0020#, 16#0002#),
         28975 => (16#166B#, 16#0020#, 16#0002#),
         28976 => (16#166C#, 16#0020#, 16#0002#),
         28977 => (16#166D#, 16#0020#, 16#0002#),
         28978 => (16#166E#, 16#0020#, 16#0002#),
         28979 => (16#166F#, 16#0020#, 16#0002#),
         28980 => (16#1670#, 16#0020#, 16#0002#),
         28981 => (16#1671#, 16#0020#, 16#0002#),
         28982 => (16#1672#, 16#0020#, 16#0002#),
         28983 => (16#1673#, 16#0020#, 16#0002#),
         28984 => (16#1674#, 16#0020#, 16#0002#),
         28985 => (16#1675#, 16#0020#, 16#0002#),
         28986 => (16#FB40#, 16#0020#, 16#0002#),
         28987 => (16#CE3D#, 16#0000#, 16#0000#),
         28988 => (16#FB40#, 16#0020#, 16#0002#),
         28989 => (16#CE38#, 16#0000#, 16#0000#),
         28990 => (16#FB40#, 16#0020#, 16#0002#),
         28991 => (16#CE41#, 16#0000#, 16#0000#),
         28992 => (16#FB84#, 16#0020#, 16#0002#),
         28993 => (16#8122#, 16#0000#, 16#0000#),
         28994 => (16#FB40#, 16#0020#, 16#0002#),
         28995 => (16#CF60#, 16#0000#, 16#0000#),
         28996 => (16#FB40#, 16#0020#, 16#0002#),
         28997 => (16#CFBB#, 16#0000#, 16#0000#),
         28998 => (16#FB40#, 16#0020#, 16#0002#),
         28999 => (16#D002#, 16#0000#, 16#0000#),
         29000 => (16#FB40#, 16#0020#, 16#0002#),
         29001 => (16#D07A#, 16#0000#, 16#0000#),
         29002 => (16#FB40#, 16#0020#, 16#0002#),
         29003 => (16#D099#, 16#0000#, 16#0000#),
         29004 => (16#FB40#, 16#0020#, 16#0002#),
         29005 => (16#D0CF#, 16#0000#, 16#0000#),
         29006 => (16#FB80#, 16#0020#, 16#0002#),
         29007 => (16#B49E#, 16#0000#, 16#0000#),
         29008 => (16#FB84#, 16#0020#, 16#0002#),
         29009 => (16#863A#, 16#0000#, 16#0000#),
         29010 => (16#FB40#, 16#0020#, 16#0002#),
         29011 => (16#D154#, 16#0000#, 16#0000#),
         29012 => (16#FB40#, 16#0020#, 16#0002#),
         29013 => (16#D164#, 16#0000#, 16#0000#),
         29014 => (16#FB40#, 16#0020#, 16#0002#),
         29015 => (16#D177#, 16#0000#, 16#0000#),
         29016 => (16#FB84#, 16#0020#, 16#0002#),
         29017 => (16#851C#, 16#0000#, 16#0000#),
         29018 => (16#FB80#, 16#0020#, 16#0002#),
         29019 => (16#B4B9#, 16#0000#, 16#0000#),
         29020 => (16#FB40#, 16#0020#, 16#0002#),
         29021 => (16#D167#, 16#0000#, 16#0000#),
         29022 => (16#FB40#, 16#0020#, 16#0002#),
         29023 => (16#D18D#, 16#0000#, 16#0000#),
         29024 => (16#FB84#, 16#0020#, 16#0002#),
         29025 => (16#854B#, 16#0000#, 16#0000#),
         29026 => (16#FB40#, 16#0020#, 16#0002#),
         29027 => (16#D197#, 16#0000#, 16#0000#),
         29028 => (16#FB40#, 16#0020#, 16#0002#),
         29029 => (16#D1A4#, 16#0000#, 16#0000#),
         29030 => (16#FB40#, 16#0020#, 16#0002#),
         29031 => (16#CECC#, 16#0000#, 16#0000#),
         29032 => (16#FB40#, 16#0020#, 16#0002#),
         29033 => (16#D1AC#, 16#0000#, 16#0000#),
         29034 => (16#FB85#, 16#0020#, 16#0002#),
         29035 => (16#91DF#, 16#0000#, 16#0000#),
         29036 => (16#FB40#, 16#0020#, 16#0002#),
         29037 => (16#D1F5#, 16#0000#, 16#0000#),
         29038 => (16#FB40#, 16#0020#, 16#0002#),
         29039 => (16#D203#, 16#0000#, 16#0000#),
         29040 => (16#FB80#, 16#0020#, 16#0002#),
         29041 => (16#B4DF#, 16#0000#, 16#0000#),
         29042 => (16#FB40#, 16#0020#, 16#0002#),
         29043 => (16#D23B#, 16#0000#, 16#0000#),
         29044 => (16#FB40#, 16#0020#, 16#0002#),
         29045 => (16#D246#, 16#0000#, 16#0000#),
         29046 => (16#FB40#, 16#0020#, 16#0002#),
         29047 => (16#D272#, 16#0000#, 16#0000#),
         29048 => (16#FB40#, 16#0020#, 16#0002#),
         29049 => (16#D277#, 16#0000#, 16#0000#),
         29050 => (16#FB80#, 16#0020#, 16#0002#),
         29051 => (16#B515#, 16#0000#, 16#0000#),
         29052 => (16#FB40#, 16#0020#, 16#0002#),
         29053 => (16#D305#, 16#0000#, 16#0000#),
         29054 => (16#FB40#, 16#0020#, 16#0002#),
         29055 => (16#D306#, 16#0000#, 16#0000#),
         29056 => (16#FB40#, 16#0020#, 16#0002#),
         29057 => (16#D349#, 16#0000#, 16#0000#),
         29058 => (16#FB40#, 16#0020#, 16#0002#),
         29059 => (16#D35A#, 16#0000#, 16#0000#),
         29060 => (16#FB40#, 16#0020#, 16#0002#),
         29061 => (16#D373#, 16#0000#, 16#0000#),
         29062 => (16#FB40#, 16#0020#, 16#0002#),
         29063 => (16#D37D#, 16#0000#, 16#0000#),
         29064 => (16#FB40#, 16#0020#, 16#0002#),
         29065 => (16#D37F#, 16#0000#, 16#0000#),
         29066 => (16#FB84#, 16#0020#, 16#0002#),
         29067 => (16#8A2C#, 16#0000#, 16#0000#),
         29068 => (16#FB40#, 16#0020#, 16#0002#),
         29069 => (16#F070#, 16#0000#, 16#0000#),
         29070 => (16#FB40#, 16#0020#, 16#0002#),
         29071 => (16#D3CA#, 16#0000#, 16#0000#),
         29072 => (16#FB40#, 16#0020#, 16#0002#),
         29073 => (16#D3DF#, 16#0000#, 16#0000#),
         29074 => (16#FB84#, 16#0020#, 16#0002#),
         29075 => (16#8B63#, 16#0000#, 16#0000#),
         29076 => (16#FB40#, 16#0020#, 16#0002#),
         29077 => (16#D3EB#, 16#0000#, 16#0000#),
         29078 => (16#FB40#, 16#0020#, 16#0002#),
         29079 => (16#D3F1#, 16#0000#, 16#0000#),
         29080 => (16#FB40#, 16#0020#, 16#0002#),
         29081 => (16#D406#, 16#0000#, 16#0000#),
         29082 => (16#FB40#, 16#0020#, 16#0002#),
         29083 => (16#D49E#, 16#0000#, 16#0000#),
         29084 => (16#FB40#, 16#0020#, 16#0002#),
         29085 => (16#D438#, 16#0000#, 16#0000#),
         29086 => (16#FB40#, 16#0020#, 16#0002#),
         29087 => (16#D448#, 16#0000#, 16#0000#),
         29088 => (16#FB40#, 16#0020#, 16#0002#),
         29089 => (16#D468#, 16#0000#, 16#0000#),
         29090 => (16#FB40#, 16#0020#, 16#0002#),
         29091 => (16#D4A2#, 16#0000#, 16#0000#),
         29092 => (16#FB40#, 16#0020#, 16#0002#),
         29093 => (16#D4F6#, 16#0000#, 16#0000#),
         29094 => (16#FB40#, 16#0020#, 16#0002#),
         29095 => (16#D510#, 16#0000#, 16#0000#),
         29096 => (16#FB40#, 16#0020#, 16#0002#),
         29097 => (16#D553#, 16#0000#, 16#0000#),
         29098 => (16#FB40#, 16#0020#, 16#0002#),
         29099 => (16#D563#, 16#0000#, 16#0000#),
         29100 => (16#FB40#, 16#0020#, 16#0002#),
         29101 => (16#D584#, 16#0000#, 16#0000#),
         29102 => (16#FB40#, 16#0020#, 16#0002#),
         29103 => (16#D5AB#, 16#0000#, 16#0000#),
         29104 => (16#FB40#, 16#0020#, 16#0002#),
         29105 => (16#D5B3#, 16#0000#, 16#0000#),
         29106 => (16#FB40#, 16#0020#, 16#0002#),
         29107 => (16#D5C2#, 16#0000#, 16#0000#),
         29108 => (16#FB40#, 16#0020#, 16#0002#),
         29109 => (16#D716#, 16#0000#, 16#0000#),
         29110 => (16#FB40#, 16#0020#, 16#0002#),
         29111 => (16#D717#, 16#0000#, 16#0000#),
         29112 => (16#FB40#, 16#0020#, 16#0002#),
         29113 => (16#D651#, 16#0000#, 16#0000#),
         29114 => (16#FB40#, 16#0020#, 16#0002#),
         29115 => (16#D674#, 16#0000#, 16#0000#),
         29116 => (16#FB40#, 16#0020#, 16#0002#),
         29117 => (16#D8EE#, 16#0000#, 16#0000#),
         29118 => (16#FB40#, 16#0020#, 16#0002#),
         29119 => (16#D7CE#, 16#0000#, 16#0000#),
         29120 => (16#FB40#, 16#0020#, 16#0002#),
         29121 => (16#D7F4#, 16#0000#, 16#0000#),
         29122 => (16#FB40#, 16#0020#, 16#0002#),
         29123 => (16#D80D#, 16#0000#, 16#0000#),
         29124 => (16#FB40#, 16#0020#, 16#0002#),
         29125 => (16#D78B#, 16#0000#, 16#0000#),
         29126 => (16#FB40#, 16#0020#, 16#0002#),
         29127 => (16#D832#, 16#0000#, 16#0000#),
         29128 => (16#FB40#, 16#0020#, 16#0002#),
         29129 => (16#D831#, 16#0000#, 16#0000#),
         29130 => (16#FB40#, 16#0020#, 16#0002#),
         29131 => (16#D8AC#, 16#0000#, 16#0000#),
         29132 => (16#FB84#, 16#0020#, 16#0002#),
         29133 => (16#94E4#, 16#0000#, 16#0000#),
         29134 => (16#FB40#, 16#0020#, 16#0002#),
         29135 => (16#D8F2#, 16#0000#, 16#0000#),
         29136 => (16#FB40#, 16#0020#, 16#0002#),
         29137 => (16#D8F7#, 16#0000#, 16#0000#),
         29138 => (16#FB40#, 16#0020#, 16#0002#),
         29139 => (16#D906#, 16#0000#, 16#0000#),
         29140 => (16#FB40#, 16#0020#, 16#0002#),
         29141 => (16#D91A#, 16#0000#, 16#0000#),
         29142 => (16#FB40#, 16#0020#, 16#0002#),
         29143 => (16#D922#, 16#0000#, 16#0000#),
         29144 => (16#FB40#, 16#0020#, 16#0002#),
         29145 => (16#D962#, 16#0000#, 16#0000#),
         29146 => (16#FB84#, 16#0020#, 16#0002#),
         29147 => (16#96A8#, 16#0000#, 16#0000#),
         29148 => (16#FB84#, 16#0020#, 16#0002#),
         29149 => (16#96EA#, 16#0000#, 16#0000#),
         29150 => (16#FB40#, 16#0020#, 16#0002#),
         29151 => (16#D9EC#, 16#0000#, 16#0000#),
         29152 => (16#FB40#, 16#0020#, 16#0002#),
         29153 => (16#DA1B#, 16#0000#, 16#0000#),
         29154 => (16#FB40#, 16#0020#, 16#0002#),
         29155 => (16#DA27#, 16#0000#, 16#0000#),
         29156 => (16#FB40#, 16#0020#, 16#0002#),
         29157 => (16#D9D8#, 16#0000#, 16#0000#),
         29158 => (16#FB40#, 16#0020#, 16#0002#),
         29159 => (16#DA66#, 16#0000#, 16#0000#),
         29160 => (16#FB80#, 16#0020#, 16#0002#),
         29161 => (16#B6EE#, 16#0000#, 16#0000#),
         29162 => (16#FB80#, 16#0020#, 16#0002#),
         29163 => (16#B6FC#, 16#0000#, 16#0000#),
         29164 => (16#FB40#, 16#0020#, 16#0002#),
         29165 => (16#DB08#, 16#0000#, 16#0000#),
         29166 => (16#FB40#, 16#0020#, 16#0002#),
         29167 => (16#DB3E#, 16#0000#, 16#0000#),
         29168 => (16#FB84#, 16#0020#, 16#0002#),
         29169 => (16#99C8#, 16#0000#, 16#0000#),
         29170 => (16#FB40#, 16#0020#, 16#0002#),
         29171 => (16#DBC3#, 16#0000#, 16#0000#),
         29172 => (16#FB40#, 16#0020#, 16#0002#),
         29173 => (16#DBD8#, 16#0000#, 16#0000#),
         29174 => (16#FB40#, 16#0020#, 16#0002#),
         29175 => (16#DBF3#, 16#0000#, 16#0000#),
         29176 => (16#FB84#, 16#0020#, 16#0002#),
         29177 => (16#9B18#, 16#0000#, 16#0000#),
         29178 => (16#FB40#, 16#0020#, 16#0002#),
         29179 => (16#DBFF#, 16#0000#, 16#0000#),
         29180 => (16#FB40#, 16#0020#, 16#0002#),
         29181 => (16#DC06#, 16#0000#, 16#0000#),
         29182 => (16#FB40#, 16#0020#, 16#0002#),
         29183 => (16#DF53#, 16#0000#, 16#0000#),
         29184 => (16#FB40#, 16#0020#, 16#0002#),
         29185 => (16#DC22#, 16#0000#, 16#0000#),
         29186 => (16#FB80#, 16#0020#, 16#0002#),
         29187 => (16#B781#, 16#0000#, 16#0000#),
         29188 => (16#FB40#, 16#0020#, 16#0002#),
         29189 => (16#DC60#, 16#0000#, 16#0000#),
         29190 => (16#FB40#, 16#0020#, 16#0002#),
         29191 => (16#DCC0#, 16#0000#, 16#0000#),
         29192 => (16#FB40#, 16#0020#, 16#0002#),
         29193 => (16#DC8D#, 16#0000#, 16#0000#),
         29194 => (16#FB84#, 16#0020#, 16#0002#),
         29195 => (16#9DE4#, 16#0000#, 16#0000#),
         29196 => (16#FB40#, 16#0020#, 16#0002#),
         29197 => (16#DD43#, 16#0000#, 16#0000#),
         29198 => (16#FB84#, 16#0020#, 16#0002#),
         29199 => (16#9DE6#, 16#0000#, 16#0000#),
         29200 => (16#FB40#, 16#0020#, 16#0002#),
         29201 => (16#DD6E#, 16#0000#, 16#0000#),
         29202 => (16#FB40#, 16#0020#, 16#0002#),
         29203 => (16#DD6B#, 16#0000#, 16#0000#),
         29204 => (16#FB40#, 16#0020#, 16#0002#),
         29205 => (16#DD7C#, 16#0000#, 16#0000#),
         29206 => (16#FB40#, 16#0020#, 16#0002#),
         29207 => (16#DDE1#, 16#0000#, 16#0000#),
         29208 => (16#FB40#, 16#0020#, 16#0002#),
         29209 => (16#DDE2#, 16#0000#, 16#0000#),
         29210 => (16#FB80#, 16#0020#, 16#0002#),
         29211 => (16#B82F#, 16#0000#, 16#0000#),
         29212 => (16#FB40#, 16#0020#, 16#0002#),
         29213 => (16#DDFD#, 16#0000#, 16#0000#),
         29214 => (16#FB40#, 16#0020#, 16#0002#),
         29215 => (16#DE28#, 16#0000#, 16#0000#),
         29216 => (16#FB40#, 16#0020#, 16#0002#),
         29217 => (16#DE3D#, 16#0000#, 16#0000#),
         29218 => (16#FB40#, 16#0020#, 16#0002#),
         29219 => (16#DE69#, 16#0000#, 16#0000#),
         29220 => (16#FB80#, 16#0020#, 16#0002#),
         29221 => (16#B862#, 16#0000#, 16#0000#),
         29222 => (16#FB84#, 16#0020#, 16#0002#),
         29223 => (16#A183#, 16#0000#, 16#0000#),
         29224 => (16#FB80#, 16#0020#, 16#0002#),
         29225 => (16#B87C#, 16#0000#, 16#0000#),
         29226 => (16#FB40#, 16#0020#, 16#0002#),
         29227 => (16#DEB0#, 16#0000#, 16#0000#),
         29228 => (16#FB40#, 16#0020#, 16#0002#),
         29229 => (16#DEB3#, 16#0000#, 16#0000#),
         29230 => (16#FB40#, 16#0020#, 16#0002#),
         29231 => (16#DEB6#, 16#0000#, 16#0000#),
         29232 => (16#FB85#, 16#0020#, 16#0002#),
         29233 => (16#A392#, 16#0000#, 16#0000#),
         29234 => (16#FB40#, 16#0020#, 16#0002#),
         29235 => (16#DEFE#, 16#0000#, 16#0000#),
         29236 => (16#FB84#, 16#0020#, 16#0002#),
         29237 => (16#A331#, 16#0000#, 16#0000#),
         29238 => (16#FB41#, 16#0020#, 16#0002#),
         29239 => (16#8201#, 16#0000#, 16#0000#),
         29240 => (16#FB40#, 16#0020#, 16#0002#),
         29241 => (16#DF22#, 16#0000#, 16#0000#),
         29242 => (16#FB80#, 16#0020#, 16#0002#),
         29243 => (16#B8C7#, 16#0000#, 16#0000#),
         29244 => (16#FB84#, 16#0020#, 16#0002#),
         29245 => (16#B2B8#, 16#0000#, 16#0000#),
         29246 => (16#FB84#, 16#0020#, 16#0002#),
         29247 => (16#E1DA#, 16#0000#, 16#0000#),
         29248 => (16#FB40#, 16#0020#, 16#0002#),
         29249 => (16#DF62#, 16#0000#, 16#0000#),
         29250 => (16#FB40#, 16#0020#, 16#0002#),
         29251 => (16#DF6B#, 16#0000#, 16#0000#),
         29252 => (16#FB80#, 16#0020#, 16#0002#),
         29253 => (16#B8E3#, 16#0000#, 16#0000#),
         29254 => (16#FB40#, 16#0020#, 16#0002#),
         29255 => (16#DF9A#, 16#0000#, 16#0000#),
         29256 => (16#FB40#, 16#0020#, 16#0002#),
         29257 => (16#DFCD#, 16#0000#, 16#0000#),
         29258 => (16#FB40#, 16#0020#, 16#0002#),
         29259 => (16#DFD7#, 16#0000#, 16#0000#),
         29260 => (16#FB40#, 16#0020#, 16#0002#),
         29261 => (16#DFF9#, 16#0000#, 16#0000#),
         29262 => (16#FB40#, 16#0020#, 16#0002#),
         29263 => (16#E081#, 16#0000#, 16#0000#),
         29264 => (16#FB80#, 16#0020#, 16#0002#),
         29265 => (16#B93A#, 16#0000#, 16#0000#),
         29266 => (16#FB80#, 16#0020#, 16#0002#),
         29267 => (16#B91C#, 16#0000#, 16#0000#),
         29268 => (16#FB84#, 16#0020#, 16#0002#),
         29269 => (16#A6D4#, 16#0000#, 16#0000#),
         29270 => (16#FB40#, 16#0020#, 16#0002#),
         29271 => (16#E0C7#, 16#0000#, 16#0000#),
         29272 => (16#FB40#, 16#0020#, 16#0002#),
         29273 => (16#E148#, 16#0000#, 16#0000#),
         29274 => (16#FB40#, 16#0020#, 16#0002#),
         29275 => (16#E14C#, 16#0000#, 16#0000#),
         29276 => (16#FB40#, 16#0020#, 16#0002#),
         29277 => (16#E17A#, 16#0000#, 16#0000#),
         29278 => (16#FB40#, 16#0020#, 16#0002#),
         29279 => (16#E1B2#, 16#0000#, 16#0000#),
         29280 => (16#FB40#, 16#0020#, 16#0002#),
         29281 => (16#E1A4#, 16#0000#, 16#0000#),
         29282 => (16#FB40#, 16#0020#, 16#0002#),
         29283 => (16#E1AF#, 16#0000#, 16#0000#),
         29284 => (16#FB40#, 16#0020#, 16#0002#),
         29285 => (16#E1DE#, 16#0000#, 16#0000#),
         29286 => (16#FB40#, 16#0020#, 16#0002#),
         29287 => (16#E210#, 16#0000#, 16#0000#),
         29288 => (16#FB40#, 16#0020#, 16#0002#),
         29289 => (16#E21B#, 16#0000#, 16#0000#),
         29290 => (16#FB40#, 16#0020#, 16#0002#),
         29291 => (16#E25D#, 16#0000#, 16#0000#),
         29292 => (16#FB40#, 16#0020#, 16#0002#),
         29293 => (16#E2B1#, 16#0000#, 16#0000#),
         29294 => (16#FB40#, 16#0020#, 16#0002#),
         29295 => (16#E2D4#, 16#0000#, 16#0000#),
         29296 => (16#FB40#, 16#0020#, 16#0002#),
         29297 => (16#E350#, 16#0000#, 16#0000#),
         29298 => (16#FB84#, 16#0020#, 16#0002#),
         29299 => (16#AB0C#, 16#0000#, 16#0000#),
         29300 => (16#FB40#, 16#0020#, 16#0002#),
         29301 => (16#E33D#, 16#0000#, 16#0000#),
         29302 => (16#FB40#, 16#0020#, 16#0002#),
         29303 => (16#E2FC#, 16#0000#, 16#0000#),
         29304 => (16#FB40#, 16#0020#, 16#0002#),
         29305 => (16#E368#, 16#0000#, 16#0000#),
         29306 => (16#FB40#, 16#0020#, 16#0002#),
         29307 => (16#E383#, 16#0000#, 16#0000#),
         29308 => (16#FB40#, 16#0020#, 16#0002#),
         29309 => (16#E3E4#, 16#0000#, 16#0000#),
         29310 => (16#FB84#, 16#0020#, 16#0002#),
         29311 => (16#ABF1#, 16#0000#, 16#0000#),
         29312 => (16#FB40#, 16#0020#, 16#0002#),
         29313 => (16#E422#, 16#0000#, 16#0000#),
         29314 => (16#FB40#, 16#0020#, 16#0002#),
         29315 => (16#E3C5#, 16#0000#, 16#0000#),
         29316 => (16#FB40#, 16#0020#, 16#0002#),
         29317 => (16#E3A9#, 16#0000#, 16#0000#),
         29318 => (16#FB80#, 16#0020#, 16#0002#),
         29319 => (16#BA2E#, 16#0000#, 16#0000#),
         29320 => (16#FB40#, 16#0020#, 16#0002#),
         29321 => (16#E469#, 16#0000#, 16#0000#),
         29322 => (16#FB40#, 16#0020#, 16#0002#),
         29323 => (16#E47E#, 16#0000#, 16#0000#),
         29324 => (16#FB40#, 16#0020#, 16#0002#),
         29325 => (16#E49D#, 16#0000#, 16#0000#),
         29326 => (16#FB40#, 16#0020#, 16#0002#),
         29327 => (16#E477#, 16#0000#, 16#0000#),
         29328 => (16#FB80#, 16#0020#, 16#0002#),
         29329 => (16#BA6C#, 16#0000#, 16#0000#),
         29330 => (16#FB40#, 16#0020#, 16#0002#),
         29331 => (16#E56C#, 16#0000#, 16#0000#),
         29332 => (16#FB84#, 16#0020#, 16#0002#),
         29333 => (16#B00A#, 16#0000#, 16#0000#),
         29334 => (16#FB40#, 16#0020#, 16#0002#),
         29335 => (16#E5E3#, 16#0000#, 16#0000#),
         29336 => (16#FB40#, 16#0020#, 16#0002#),
         29337 => (16#E6F8#, 16#0000#, 16#0000#),
         29338 => (16#FB40#, 16#0020#, 16#0002#),
         29339 => (16#E649#, 16#0000#, 16#0000#),
         29340 => (16#FB80#, 16#0020#, 16#0002#),
         29341 => (16#BB19#, 16#0000#, 16#0000#),
         29342 => (16#FB80#, 16#0020#, 16#0002#),
         29343 => (16#BB08#, 16#0000#, 16#0000#),
         29344 => (16#FB80#, 16#0020#, 16#0002#),
         29345 => (16#BAE4#, 16#0000#, 16#0000#),
         29346 => (16#FB40#, 16#0020#, 16#0002#),
         29347 => (16#D192#, 16#0000#, 16#0000#),
         29348 => (16#FB40#, 16#0020#, 16#0002#),
         29349 => (16#D195#, 16#0000#, 16#0000#),
         29350 => (16#FB40#, 16#0020#, 16#0002#),
         29351 => (16#E700#, 16#0000#, 16#0000#),
         29352 => (16#FB40#, 16#0020#, 16#0002#),
         29353 => (16#E69C#, 16#0000#, 16#0000#),
         29354 => (16#FB41#, 16#0020#, 16#0002#),
         29355 => (16#80AD#, 16#0000#, 16#0000#),
         29356 => (16#FB80#, 16#0020#, 16#0002#),
         29357 => (16#C3D9#, 16#0000#, 16#0000#),
         29358 => (16#FB40#, 16#0020#, 16#0002#),
         29359 => (16#E721#, 16#0000#, 16#0000#),
         29360 => (16#FB40#, 16#0020#, 16#0002#),
         29361 => (16#E75E#, 16#0000#, 16#0000#),
         29362 => (16#FB40#, 16#0020#, 16#0002#),
         29363 => (16#E753#, 16#0000#, 16#0000#),
         29364 => (16#FB84#, 16#0020#, 16#0002#),
         29365 => (16#B3C3#, 16#0000#, 16#0000#),
         29366 => (16#FB80#, 16#0020#, 16#0002#),
         29367 => (16#BB49#, 16#0000#, 16#0000#),
         29368 => (16#FB40#, 16#0020#, 16#0002#),
         29369 => (16#E7FA#, 16#0000#, 16#0000#),
         29370 => (16#FB40#, 16#0020#, 16#0002#),
         29371 => (16#E785#, 16#0000#, 16#0000#),
         29372 => (16#FB40#, 16#0020#, 16#0002#),
         29373 => (16#E852#, 16#0000#, 16#0000#),
         29374 => (16#FB84#, 16#0020#, 16#0002#),
         29375 => (16#B46D#, 16#0000#, 16#0000#),
         29376 => (16#FB40#, 16#0020#, 16#0002#),
         29377 => (16#E88E#, 16#0000#, 16#0000#),
         29378 => (16#FB40#, 16#0020#, 16#0002#),
         29379 => (16#E81F#, 16#0000#, 16#0000#),
         29380 => (16#FB40#, 16#0020#, 16#0002#),
         29381 => (16#E914#, 16#0000#, 16#0000#),
         29382 => (16#FB40#, 16#0020#, 16#0002#),
         29383 => (16#E942#, 16#0000#, 16#0000#),
         29384 => (16#FB40#, 16#0020#, 16#0002#),
         29385 => (16#E9A3#, 16#0000#, 16#0000#),
         29386 => (16#FB40#, 16#0020#, 16#0002#),
         29387 => (16#E9EA#, 16#0000#, 16#0000#),
         29388 => (16#FB40#, 16#0020#, 16#0002#),
         29389 => (16#EAA8#, 16#0000#, 16#0000#),
         29390 => (16#FB84#, 16#0020#, 16#0002#),
         29391 => (16#B6A3#, 16#0000#, 16#0000#),
         29392 => (16#FB40#, 16#0020#, 16#0002#),
         29393 => (16#EADB#, 16#0000#, 16#0000#),
         29394 => (16#FB80#, 16#0020#, 16#0002#),
         29395 => (16#BC18#, 16#0000#, 16#0000#),
         29396 => (16#FB40#, 16#0020#, 16#0002#),
         29397 => (16#EB21#, 16#0000#, 16#0000#),
         29398 => (16#FB84#, 16#0020#, 16#0002#),
         29399 => (16#B8A7#, 16#0000#, 16#0000#),
         29400 => (16#FB40#, 16#0020#, 16#0002#),
         29401 => (16#EB54#, 16#0000#, 16#0000#),
         29402 => (16#FB80#, 16#0020#, 16#0002#),
         29403 => (16#BC4E#, 16#0000#, 16#0000#),
         29404 => (16#FB40#, 16#0020#, 16#0002#),
         29405 => (16#EB72#, 16#0000#, 16#0000#),
         29406 => (16#FB40#, 16#0020#, 16#0002#),
         29407 => (16#EB9F#, 16#0000#, 16#0000#),
         29408 => (16#FB40#, 16#0020#, 16#0002#),
         29409 => (16#EBBB#, 16#0000#, 16#0000#),
         29410 => (16#FB84#, 16#0020#, 16#0002#),
         29411 => (16#BA8D#, 16#0000#, 16#0000#),
         29412 => (16#FB84#, 16#0020#, 16#0002#),
         29413 => (16#9D0B#, 16#0000#, 16#0000#),
         29414 => (16#FB84#, 16#0020#, 16#0002#),
         29415 => (16#BAFA#, 16#0000#, 16#0000#),
         29416 => (16#FB40#, 16#0020#, 16#0002#),
         29417 => (16#EC4E#, 16#0000#, 16#0000#),
         29418 => (16#FB84#, 16#0020#, 16#0002#),
         29419 => (16#BCBC#, 16#0000#, 16#0000#),
         29420 => (16#FB40#, 16#0020#, 16#0002#),
         29421 => (16#ECBF#, 16#0000#, 16#0000#),
         29422 => (16#FB40#, 16#0020#, 16#0002#),
         29423 => (16#ECCD#, 16#0000#, 16#0000#),
         29424 => (16#FB40#, 16#0020#, 16#0002#),
         29425 => (16#EC67#, 16#0000#, 16#0000#),
         29426 => (16#FB40#, 16#0020#, 16#0002#),
         29427 => (16#ED16#, 16#0000#, 16#0000#),
         29428 => (16#FB40#, 16#0020#, 16#0002#),
         29429 => (16#ED3E#, 16#0000#, 16#0000#),
         29430 => (16#FB40#, 16#0020#, 16#0002#),
         29431 => (16#ED69#, 16#0000#, 16#0000#),
         29432 => (16#FB40#, 16#0020#, 16#0002#),
         29433 => (16#ED78#, 16#0000#, 16#0000#),
         29434 => (16#FB40#, 16#0020#, 16#0002#),
         29435 => (16#ED85#, 16#0000#, 16#0000#),
         29436 => (16#FB84#, 16#0020#, 16#0002#),
         29437 => (16#BD1E#, 16#0000#, 16#0000#),
         29438 => (16#FB40#, 16#0020#, 16#0002#),
         29439 => (16#ED34#, 16#0000#, 16#0000#),
         29440 => (16#FB40#, 16#0020#, 16#0002#),
         29441 => (16#EE2F#, 16#0000#, 16#0000#),
         29442 => (16#FB40#, 16#0020#, 16#0002#),
         29443 => (16#EE6E#, 16#0000#, 16#0000#),
         29444 => (16#FB80#, 16#0020#, 16#0002#),
         29445 => (16#BD33#, 16#0000#, 16#0000#),
         29446 => (16#FB40#, 16#0020#, 16#0002#),
         29447 => (16#EEC7#, 16#0000#, 16#0000#),
         29448 => (16#FB84#, 16#0020#, 16#0002#),
         29449 => (16#BED1#, 16#0000#, 16#0000#),
         29450 => (16#FB40#, 16#0020#, 16#0002#),
         29451 => (16#EDF9#, 16#0000#, 16#0000#),
         29452 => (16#FB40#, 16#0020#, 16#0002#),
         29453 => (16#EF6E#, 16#0000#, 16#0000#),
         29454 => (16#FB84#, 16#0020#, 16#0002#),
         29455 => (16#BF5E#, 16#0000#, 16#0000#),
         29456 => (16#FB84#, 16#0020#, 16#0002#),
         29457 => (16#BF8E#, 16#0000#, 16#0000#),
         29458 => (16#FB40#, 16#0020#, 16#0002#),
         29459 => (16#EFC6#, 16#0000#, 16#0000#),
         29460 => (16#FB40#, 16#0020#, 16#0002#),
         29461 => (16#F039#, 16#0000#, 16#0000#),
         29462 => (16#FB40#, 16#0020#, 16#0002#),
         29463 => (16#F01B#, 16#0000#, 16#0000#),
         29464 => (16#FB80#, 16#0020#, 16#0002#),
         29465 => (16#BD96#, 16#0000#, 16#0000#),
         29466 => (16#FB40#, 16#0020#, 16#0002#),
         29467 => (16#F04A#, 16#0000#, 16#0000#),
         29468 => (16#FB40#, 16#0020#, 16#0002#),
         29469 => (16#F07D#, 16#0000#, 16#0000#),
         29470 => (16#FB40#, 16#0020#, 16#0002#),
         29471 => (16#F077#, 16#0000#, 16#0000#),
         29472 => (16#FB40#, 16#0020#, 16#0002#),
         29473 => (16#F0AD#, 16#0000#, 16#0000#),
         29474 => (16#FB84#, 16#0020#, 16#0002#),
         29475 => (16#8525#, 16#0000#, 16#0000#),
         29476 => (16#FB40#, 16#0020#, 16#0002#),
         29477 => (16#F145#, 16#0000#, 16#0000#),
         29478 => (16#FB84#, 16#0020#, 16#0002#),
         29479 => (16#C263#, 16#0000#, 16#0000#),
         29480 => (16#FB40#, 16#0020#, 16#0002#),
         29481 => (16#F19C#, 16#0000#, 16#0000#),
         29482 => (16#FB84#, 16#0020#, 16#0002#),
         29483 => (16#C3AB#, 16#0000#, 16#0000#),
         29484 => (16#FB40#, 16#0020#, 16#0002#),
         29485 => (16#F228#, 16#0000#, 16#0000#),
         29486 => (16#FB40#, 16#0020#, 16#0002#),
         29487 => (16#F250#, 16#0000#, 16#0000#),
         29488 => (16#FB84#, 16#0020#, 16#0002#),
         29489 => (16#C608#, 16#0000#, 16#0000#),
         29490 => (16#FB40#, 16#0020#, 16#0002#),
         29491 => (16#F280#, 16#0000#, 16#0000#),
         29492 => (16#FB40#, 16#0020#, 16#0002#),
         29493 => (16#F295#, 16#0000#, 16#0000#),
         29494 => (16#FB84#, 16#0020#, 16#0002#),
         29495 => (16#C735#, 16#0000#, 16#0000#),
         29496 => (16#FB84#, 16#0020#, 16#0002#),
         29497 => (16#C814#, 16#0000#, 16#0000#),
         29498 => (16#FB40#, 16#0020#, 16#0002#),
         29499 => (16#F37A#, 16#0000#, 16#0000#),
         29500 => (16#FB40#, 16#0020#, 16#0002#),
         29501 => (16#F38B#, 16#0000#, 16#0000#),
         29502 => (16#FB80#, 16#0020#, 16#0002#),
         29503 => (16#BEAC#, 16#0000#, 16#0000#),
         29504 => (16#FB40#, 16#0020#, 16#0002#),
         29505 => (16#F3A5#, 16#0000#, 16#0000#),
         29506 => (16#FB80#, 16#0020#, 16#0002#),
         29507 => (16#BEB8#, 16#0000#, 16#0000#),
         29508 => (16#FB40#, 16#0020#, 16#0002#),
         29509 => (16#F447#, 16#0000#, 16#0000#),
         29510 => (16#FB40#, 16#0020#, 16#0002#),
         29511 => (16#F45C#, 16#0000#, 16#0000#),
         29512 => (16#FB40#, 16#0020#, 16#0002#),
         29513 => (16#F485#, 16#0000#, 16#0000#),
         29514 => (16#FB40#, 16#0020#, 16#0002#),
         29515 => (16#F4CA#, 16#0000#, 16#0000#),
         29516 => (16#FB80#, 16#0020#, 16#0002#),
         29517 => (16#BF1B#, 16#0000#, 16#0000#),
         29518 => (16#FB40#, 16#0020#, 16#0002#),
         29519 => (16#F524#, 16#0000#, 16#0000#),
         29520 => (16#FB84#, 16#0020#, 16#0002#),
         29521 => (16#CC36#, 16#0000#, 16#0000#),
         29522 => (16#FB40#, 16#0020#, 16#0002#),
         29523 => (16#F53E#, 16#0000#, 16#0000#),
         29524 => (16#FB84#, 16#0020#, 16#0002#),
         29525 => (16#CC92#, 16#0000#, 16#0000#),
         29526 => (16#FB84#, 16#0020#, 16#0002#),
         29527 => (16#A19F#, 16#0000#, 16#0000#),
         29528 => (16#FB40#, 16#0020#, 16#0002#),
         29529 => (16#F610#, 16#0000#, 16#0000#),
         29530 => (16#FB84#, 16#0020#, 16#0002#),
         29531 => (16#CFA1#, 16#0000#, 16#0000#),
         29532 => (16#FB84#, 16#0020#, 16#0002#),
         29533 => (16#CFB8#, 16#0000#, 16#0000#),
         29534 => (16#FB84#, 16#0020#, 16#0002#),
         29535 => (16#D044#, 16#0000#, 16#0000#),
         29536 => (16#FB80#, 16#0020#, 16#0002#),
         29537 => (16#BFFC#, 16#0000#, 16#0000#),
         29538 => (16#FB80#, 16#0020#, 16#0002#),
         29539 => (16#C008#, 16#0000#, 16#0000#),
         29540 => (16#FB84#, 16#0020#, 16#0002#),
         29541 => (16#D0F3#, 16#0000#, 16#0000#),
         29542 => (16#FB84#, 16#0020#, 16#0002#),
         29543 => (16#D0F2#, 16#0000#, 16#0000#),
         29544 => (16#FB84#, 16#0020#, 16#0002#),
         29545 => (16#D119#, 16#0000#, 16#0000#),
         29546 => (16#FB84#, 16#0020#, 16#0002#),
         29547 => (16#D133#, 16#0000#, 16#0000#),
         29548 => (16#FB40#, 16#0020#, 16#0002#),
         29549 => (16#F71E#, 16#0000#, 16#0000#),
         29550 => (16#FB40#, 16#0020#, 16#0002#),
         29551 => (16#F71F#, 16#0000#, 16#0000#),
         29552 => (16#FB40#, 16#0020#, 16#0002#),
         29553 => (16#F78B#, 16#0000#, 16#0000#),
         29554 => (16#FB80#, 16#0020#, 16#0002#),
         29555 => (16#C046#, 16#0000#, 16#0000#),
         29556 => (16#FB80#, 16#0020#, 16#0002#),
         29557 => (16#C096#, 16#0000#, 16#0000#),
         29558 => (16#FB84#, 16#0020#, 16#0002#),
         29559 => (16#D41D#, 16#0000#, 16#0000#),
         29560 => (16#FB40#, 16#0020#, 16#0002#),
         29561 => (16#F84E#, 16#0000#, 16#0000#),
         29562 => (16#FB80#, 16#0020#, 16#0002#),
         29563 => (16#C0E3#, 16#0000#, 16#0000#),
         29564 => (16#FB84#, 16#0020#, 16#0002#),
         29565 => (16#D626#, 16#0000#, 16#0000#),
         29566 => (16#FB84#, 16#0020#, 16#0002#),
         29567 => (16#D69A#, 16#0000#, 16#0000#),
         29568 => (16#FB84#, 16#0020#, 16#0002#),
         29569 => (16#D6C5#, 16#0000#, 16#0000#),
         29570 => (16#FB40#, 16#0020#, 16#0002#),
         29571 => (16#F9EB#, 16#0000#, 16#0000#),
         29572 => (16#FB80#, 16#0020#, 16#0002#),
         29573 => (16#C12F#, 16#0000#, 16#0000#),
         29574 => (16#FB40#, 16#0020#, 16#0002#),
         29575 => (16#FA4A#, 16#0000#, 16#0000#),
         29576 => (16#FB40#, 16#0020#, 16#0002#),
         29577 => (16#FA4F#, 16#0000#, 16#0000#),
         29578 => (16#FB84#, 16#0020#, 16#0002#),
         29579 => (16#D97C#, 16#0000#, 16#0000#),
         29580 => (16#FB84#, 16#0020#, 16#0002#),
         29581 => (16#DAA7#, 16#0000#, 16#0000#),
         29582 => (16#FB40#, 16#0020#, 16#0002#),
         29583 => (16#FAEE#, 16#0000#, 16#0000#),
         29584 => (16#FB80#, 16#0020#, 16#0002#),
         29585 => (16#C202#, 16#0000#, 16#0000#),
         29586 => (16#FB84#, 16#0020#, 16#0002#),
         29587 => (16#DBAB#, 16#0000#, 16#0000#),
         29588 => (16#FB40#, 16#0020#, 16#0002#),
         29589 => (16#FBC6#, 16#0000#, 16#0000#),
         29590 => (16#FB40#, 16#0020#, 16#0002#),
         29591 => (16#FBC9#, 16#0000#, 16#0000#),
         29592 => (16#FB80#, 16#0020#, 16#0002#),
         29593 => (16#C227#, 16#0000#, 16#0000#),
         29594 => (16#FB84#, 16#0020#, 16#0002#),
         29595 => (16#DC80#, 16#0000#, 16#0000#),
         29596 => (16#FB40#, 16#0020#, 16#0002#),
         29597 => (16#FCD2#, 16#0000#, 16#0000#),
         29598 => (16#FB80#, 16#0020#, 16#0002#),
         29599 => (16#C2A0#, 16#0000#, 16#0000#),
         29600 => (16#FB40#, 16#0020#, 16#0002#),
         29601 => (16#FCE8#, 16#0000#, 16#0000#),
         29602 => (16#FB40#, 16#0020#, 16#0002#),
         29603 => (16#FCE3#, 16#0000#, 16#0000#),
         29604 => (16#FB40#, 16#0020#, 16#0002#),
         29605 => (16#FD00#, 16#0000#, 16#0000#),
         29606 => (16#FB84#, 16#0020#, 16#0002#),
         29607 => (16#DF86#, 16#0000#, 16#0000#),
         29608 => (16#FB40#, 16#0020#, 16#0002#),
         29609 => (16#FD63#, 16#0000#, 16#0000#),
         29610 => (16#FB80#, 16#0020#, 16#0002#),
         29611 => (16#C301#, 16#0000#, 16#0000#),
         29612 => (16#FB40#, 16#0020#, 16#0002#),
         29613 => (16#FDC7#, 16#0000#, 16#0000#),
         29614 => (16#FB40#, 16#0020#, 16#0002#),
         29615 => (16#FE02#, 16#0000#, 16#0000#),
         29616 => (16#FB40#, 16#0020#, 16#0002#),
         29617 => (16#FE45#, 16#0000#, 16#0000#),
         29618 => (16#FB80#, 16#0020#, 16#0002#),
         29619 => (16#C334#, 16#0000#, 16#0000#),
         29620 => (16#FB84#, 16#0020#, 16#0002#),
         29621 => (16#E228#, 16#0000#, 16#0000#),
         29622 => (16#FB84#, 16#0020#, 16#0002#),
         29623 => (16#E247#, 16#0000#, 16#0000#),
         29624 => (16#FB80#, 16#0020#, 16#0002#),
         29625 => (16#C359#, 16#0000#, 16#0000#),
         29626 => (16#FB84#, 16#0020#, 16#0002#),
         29627 => (16#E2D9#, 16#0000#, 16#0000#),
         29628 => (16#FB40#, 16#0020#, 16#0002#),
         29629 => (16#FF7A#, 16#0000#, 16#0000#),
         29630 => (16#FB84#, 16#0020#, 16#0002#),
         29631 => (16#E33E#, 16#0000#, 16#0000#),
         29632 => (16#FB40#, 16#0020#, 16#0002#),
         29633 => (16#FF95#, 16#0000#, 16#0000#),
         29634 => (16#FB40#, 16#0020#, 16#0002#),
         29635 => (16#FFFA#, 16#0000#, 16#0000#),
         29636 => (16#FB84#, 16#0020#, 16#0002#),
         29637 => (16#E4DA#, 16#0000#, 16#0000#),
         29638 => (16#FB84#, 16#0020#, 16#0002#),
         29639 => (16#E523#, 16#0000#, 16#0000#),
         29640 => (16#FB41#, 16#0020#, 16#0002#),
         29641 => (16#8060#, 16#0000#, 16#0000#),
         29642 => (16#FB84#, 16#0020#, 16#0002#),
         29643 => (16#E5A8#, 16#0000#, 16#0000#),
         29644 => (16#FB41#, 16#0020#, 16#0002#),
         29645 => (16#8070#, 16#0000#, 16#0000#),
         29646 => (16#FB84#, 16#0020#, 16#0002#),
         29647 => (16#B35F#, 16#0000#, 16#0000#),
         29648 => (16#FB80#, 16#0020#, 16#0002#),
         29649 => (16#C3D5#, 16#0000#, 16#0000#),
         29650 => (16#FB41#, 16#0020#, 16#0002#),
         29651 => (16#80B2#, 16#0000#, 16#0000#),
         29652 => (16#FB41#, 16#0020#, 16#0002#),
         29653 => (16#8103#, 16#0000#, 16#0000#),
         29654 => (16#FB80#, 16#0020#, 16#0002#),
         29655 => (16#C40B#, 16#0000#, 16#0000#),
         29656 => (16#FB41#, 16#0020#, 16#0002#),
         29657 => (16#813E#, 16#0000#, 16#0000#),
         29658 => (16#FB40#, 16#0020#, 16#0002#),
         29659 => (16#DAB5#, 16#0000#, 16#0000#),
         29660 => (16#FB84#, 16#0020#, 16#0002#),
         29661 => (16#E7A7#, 16#0000#, 16#0000#),
         29662 => (16#FB84#, 16#0020#, 16#0002#),
         29663 => (16#E7B5#, 16#0000#, 16#0000#),
         29664 => (16#FB84#, 16#0020#, 16#0002#),
         29665 => (16#B393#, 16#0000#, 16#0000#),
         29666 => (16#FB84#, 16#0020#, 16#0002#),
         29667 => (16#B39C#, 16#0000#, 16#0000#),
         29668 => (16#FB41#, 16#0020#, 16#0002#),
         29669 => (16#8204#, 16#0000#, 16#0000#),
         29670 => (16#FB41#, 16#0020#, 16#0002#),
         29671 => (16#8F9E#, 16#0000#, 16#0000#),
         29672 => (16#FB80#, 16#0020#, 16#0002#),
         29673 => (16#C46B#, 16#0000#, 16#0000#),
         29674 => (16#FB41#, 16#0020#, 16#0002#),
         29675 => (16#8291#, 16#0000#, 16#0000#),
         29676 => (16#FB41#, 16#0020#, 16#0002#),
         29677 => (16#828B#, 16#0000#, 16#0000#),
         29678 => (16#FB41#, 16#0020#, 16#0002#),
         29679 => (16#829D#, 16#0000#, 16#0000#),
         29680 => (16#FB40#, 16#0020#, 16#0002#),
         29681 => (16#D2B3#, 16#0000#, 16#0000#),
         29682 => (16#FB41#, 16#0020#, 16#0002#),
         29683 => (16#82B1#, 16#0000#, 16#0000#),
         29684 => (16#FB41#, 16#0020#, 16#0002#),
         29685 => (16#82B3#, 16#0000#, 16#0000#),
         29686 => (16#FB41#, 16#0020#, 16#0002#),
         29687 => (16#82BD#, 16#0000#, 16#0000#),
         29688 => (16#FB41#, 16#0020#, 16#0002#),
         29689 => (16#82E6#, 16#0000#, 16#0000#),
         29690 => (16#FB84#, 16#0020#, 16#0002#),
         29691 => (16#EB3C#, 16#0000#, 16#0000#),
         29692 => (16#FB41#, 16#0020#, 16#0002#),
         29693 => (16#831D#, 16#0000#, 16#0000#),
         29694 => (16#FB41#, 16#0020#, 16#0002#),
         29695 => (16#8363#, 16#0000#, 16#0000#),
         29696 => (16#FB41#, 16#0020#, 16#0002#),
         29697 => (16#83AD#, 16#0000#, 16#0000#),
         29698 => (16#FB41#, 16#0020#, 16#0002#),
         29699 => (16#8323#, 16#0000#, 16#0000#),
         29700 => (16#FB41#, 16#0020#, 16#0002#),
         29701 => (16#83BD#, 16#0000#, 16#0000#),
         29702 => (16#FB41#, 16#0020#, 16#0002#),
         29703 => (16#83E7#, 16#0000#, 16#0000#),
         29704 => (16#FB41#, 16#0020#, 16#0002#),
         29705 => (16#8353#, 16#0000#, 16#0000#),
         29706 => (16#FB41#, 16#0020#, 16#0002#),
         29707 => (16#83CA#, 16#0000#, 16#0000#),
         29708 => (16#FB41#, 16#0020#, 16#0002#),
         29709 => (16#83CC#, 16#0000#, 16#0000#),
         29710 => (16#FB41#, 16#0020#, 16#0002#),
         29711 => (16#83DC#, 16#0000#, 16#0000#),
         29712 => (16#FB84#, 16#0020#, 16#0002#),
         29713 => (16#EC36#, 16#0000#, 16#0000#),
         29714 => (16#FB84#, 16#0020#, 16#0002#),
         29715 => (16#ED6B#, 16#0000#, 16#0000#),
         29716 => (16#FB84#, 16#0020#, 16#0002#),
         29717 => (16#ECD5#, 16#0000#, 16#0000#),
         29718 => (16#FB80#, 16#0020#, 16#0002#),
         29719 => (16#C52B#, 16#0000#, 16#0000#),
         29720 => (16#FB41#, 16#0020#, 16#0002#),
         29721 => (16#84F1#, 16#0000#, 16#0000#),
         29722 => (16#FB41#, 16#0020#, 16#0002#),
         29723 => (16#84F3#, 16#0000#, 16#0000#),
         29724 => (16#FB41#, 16#0020#, 16#0002#),
         29725 => (16#8516#, 16#0000#, 16#0000#),
         29726 => (16#FB84#, 16#0020#, 16#0002#),
         29727 => (16#F3CA#, 16#0000#, 16#0000#),
         29728 => (16#FB41#, 16#0020#, 16#0002#),
         29729 => (16#8564#, 16#0000#, 16#0000#),
         29730 => (16#FB84#, 16#0020#, 16#0002#),
         29731 => (16#EF2C#, 16#0000#, 16#0000#),
         29732 => (16#FB80#, 16#0020#, 16#0002#),
         29733 => (16#C55D#, 16#0000#, 16#0000#),
         29734 => (16#FB80#, 16#0020#, 16#0002#),
         29735 => (16#C561#, 16#0000#, 16#0000#),
         29736 => (16#FB84#, 16#0020#, 16#0002#),
         29737 => (16#EFB1#, 16#0000#, 16#0000#),
         29738 => (16#FB84#, 16#0020#, 16#0002#),
         29739 => (16#F0D2#, 16#0000#, 16#0000#),
         29740 => (16#FB80#, 16#0020#, 16#0002#),
         29741 => (16#C56B#, 16#0000#, 16#0000#),
         29742 => (16#FB41#, 16#0020#, 16#0002#),
         29743 => (16#8650#, 16#0000#, 16#0000#),
         29744 => (16#FB41#, 16#0020#, 16#0002#),
         29745 => (16#8667#, 16#0000#, 16#0000#),
         29746 => (16#FB41#, 16#0020#, 16#0002#),
         29747 => (16#8669#, 16#0000#, 16#0000#),
         29748 => (16#FB41#, 16#0020#, 16#0002#),
         29749 => (16#86A9#, 16#0000#, 16#0000#),
         29750 => (16#FB41#, 16#0020#, 16#0002#),
         29751 => (16#8688#, 16#0000#, 16#0000#),
         29752 => (16#FB41#, 16#0020#, 16#0002#),
         29753 => (16#870E#, 16#0000#, 16#0000#),
         29754 => (16#FB41#, 16#0020#, 16#0002#),
         29755 => (16#86E2#, 16#0000#, 16#0000#),
         29756 => (16#FB41#, 16#0020#, 16#0002#),
         29757 => (16#8728#, 16#0000#, 16#0000#),
         29758 => (16#FB41#, 16#0020#, 16#0002#),
         29759 => (16#876B#, 16#0000#, 16#0000#),
         29760 => (16#FB41#, 16#0020#, 16#0002#),
         29761 => (16#8786#, 16#0000#, 16#0000#),
         29762 => (16#FB80#, 16#0020#, 16#0002#),
         29763 => (16#C5D7#, 16#0000#, 16#0000#),
         29764 => (16#FB41#, 16#0020#, 16#0002#),
         29765 => (16#87E1#, 16#0000#, 16#0000#),
         29766 => (16#FB41#, 16#0020#, 16#0002#),
         29767 => (16#8801#, 16#0000#, 16#0000#),
         29768 => (16#FB80#, 16#0020#, 16#0002#),
         29769 => (16#C5F9#, 16#0000#, 16#0000#),
         29770 => (16#FB41#, 16#0020#, 16#0002#),
         29771 => (16#8860#, 16#0000#, 16#0000#),
         29772 => (16#FB41#, 16#0020#, 16#0002#),
         29773 => (16#8863#, 16#0000#, 16#0000#),
         29774 => (16#FB84#, 16#0020#, 16#0002#),
         29775 => (16#F667#, 16#0000#, 16#0000#),
         29776 => (16#FB41#, 16#0020#, 16#0002#),
         29777 => (16#88D7#, 16#0000#, 16#0000#),
         29778 => (16#FB41#, 16#0020#, 16#0002#),
         29779 => (16#88DE#, 16#0000#, 16#0000#),
         29780 => (16#FB80#, 16#0020#, 16#0002#),
         29781 => (16#C635#, 16#0000#, 16#0000#),
         29782 => (16#FB41#, 16#0020#, 16#0002#),
         29783 => (16#88FA#, 16#0000#, 16#0000#),
         29784 => (16#FB80#, 16#0020#, 16#0002#),
         29785 => (16#B4BB#, 16#0000#, 16#0000#),
         29786 => (16#FB84#, 16#0020#, 16#0002#),
         29787 => (16#F8AE#, 16#0000#, 16#0000#),
         29788 => (16#FB84#, 16#0020#, 16#0002#),
         29789 => (16#F966#, 16#0000#, 16#0000#),
         29790 => (16#FB80#, 16#0020#, 16#0002#),
         29791 => (16#C6BE#, 16#0000#, 16#0000#),
         29792 => (16#FB80#, 16#0020#, 16#0002#),
         29793 => (16#C6C7#, 16#0000#, 16#0000#),
         29794 => (16#FB41#, 16#0020#, 16#0002#),
         29795 => (16#8AA0#, 16#0000#, 16#0000#),
         29796 => (16#FB41#, 16#0020#, 16#0002#),
         29797 => (16#8C55#, 16#0000#, 16#0000#),
         29798 => (16#FB84#, 16#0020#, 16#0002#),
         29799 => (16#FCA8#, 16#0000#, 16#0000#),
         29800 => (16#FB41#, 16#0020#, 16#0002#),
         29801 => (16#8CAB#, 16#0000#, 16#0000#),
         29802 => (16#FB41#, 16#0020#, 16#0002#),
         29803 => (16#8CC1#, 16#0000#, 16#0000#),
         29804 => (16#FB41#, 16#0020#, 16#0002#),
         29805 => (16#8D1B#, 16#0000#, 16#0000#),
         29806 => (16#FB41#, 16#0020#, 16#0002#),
         29807 => (16#8D77#, 16#0000#, 16#0000#),
         29808 => (16#FB84#, 16#0020#, 16#0002#),
         29809 => (16#FF2F#, 16#0000#, 16#0000#),
         29810 => (16#FB84#, 16#0020#, 16#0002#),
         29811 => (16#8804#, 16#0000#, 16#0000#),
         29812 => (16#FB41#, 16#0020#, 16#0002#),
         29813 => (16#8DCB#, 16#0000#, 16#0000#),
         29814 => (16#FB41#, 16#0020#, 16#0002#),
         29815 => (16#8DBC#, 16#0000#, 16#0000#),
         29816 => (16#FB41#, 16#0020#, 16#0002#),
         29817 => (16#8DF0#, 16#0000#, 16#0000#),
         29818 => (16#FB84#, 16#0020#, 16#0002#),
         29819 => (16#88DE#, 16#0000#, 16#0000#),
         29820 => (16#FB41#, 16#0020#, 16#0002#),
         29821 => (16#8ED4#, 16#0000#, 16#0000#),
         29822 => (16#FB85#, 16#0020#, 16#0002#),
         29823 => (16#85D2#, 16#0000#, 16#0000#),
         29824 => (16#FB85#, 16#0020#, 16#0002#),
         29825 => (16#85ED#, 16#0000#, 16#0000#),
         29826 => (16#FB41#, 16#0020#, 16#0002#),
         29827 => (16#9094#, 16#0000#, 16#0000#),
         29828 => (16#FB41#, 16#0020#, 16#0002#),
         29829 => (16#90F1#, 16#0000#, 16#0000#),
         29830 => (16#FB41#, 16#0020#, 16#0002#),
         29831 => (16#9111#, 16#0000#, 16#0000#),
         29832 => (16#FB85#, 16#0020#, 16#0002#),
         29833 => (16#872E#, 16#0000#, 16#0000#),
         29834 => (16#FB41#, 16#0020#, 16#0002#),
         29835 => (16#911B#, 16#0000#, 16#0000#),
         29836 => (16#FB41#, 16#0020#, 16#0002#),
         29837 => (16#9238#, 16#0000#, 16#0000#),
         29838 => (16#FB41#, 16#0020#, 16#0002#),
         29839 => (16#92D7#, 16#0000#, 16#0000#),
         29840 => (16#FB41#, 16#0020#, 16#0002#),
         29841 => (16#92D8#, 16#0000#, 16#0000#),
         29842 => (16#FB41#, 16#0020#, 16#0002#),
         29843 => (16#927C#, 16#0000#, 16#0000#),
         29844 => (16#FB41#, 16#0020#, 16#0002#),
         29845 => (16#93F9#, 16#0000#, 16#0000#),
         29846 => (16#FB41#, 16#0020#, 16#0002#),
         29847 => (16#9415#, 16#0000#, 16#0000#),
         29848 => (16#FB85#, 16#0020#, 16#0002#),
         29849 => (16#8BFA#, 16#0000#, 16#0000#),
         29850 => (16#FB41#, 16#0020#, 16#0002#),
         29851 => (16#958B#, 16#0000#, 16#0000#),
         29852 => (16#FB80#, 16#0020#, 16#0002#),
         29853 => (16#C995#, 16#0000#, 16#0000#),
         29854 => (16#FB41#, 16#0020#, 16#0002#),
         29855 => (16#95B7#, 16#0000#, 16#0000#),
         29856 => (16#FB85#, 16#0020#, 16#0002#),
         29857 => (16#8D77#, 16#0000#, 16#0000#),
         29858 => (16#FB80#, 16#0020#, 16#0002#),
         29859 => (16#C9E6#, 16#0000#, 16#0000#),
         29860 => (16#FB41#, 16#0020#, 16#0002#),
         29861 => (16#96C3#, 16#0000#, 16#0000#),
         29862 => (16#FB40#, 16#0020#, 16#0002#),
         29863 => (16#DDB2#, 16#0000#, 16#0000#),
         29864 => (16#FB41#, 16#0020#, 16#0002#),
         29865 => (16#9723#, 16#0000#, 16#0000#),
         29866 => (16#FB85#, 16#0020#, 16#0002#),
         29867 => (16#9145#, 16#0000#, 16#0000#),
         29868 => (16#FB85#, 16#0020#, 16#0002#),
         29869 => (16#921A#, 16#0000#, 16#0000#),
         29870 => (16#FB80#, 16#0020#, 16#0002#),
         29871 => (16#CA6E#, 16#0000#, 16#0000#),
         29872 => (16#FB80#, 16#0020#, 16#0002#),
         29873 => (16#CA76#, 16#0000#, 16#0000#),
         29874 => (16#FB41#, 16#0020#, 16#0002#),
         29875 => (16#97E0#, 16#0000#, 16#0000#),
         29876 => (16#FB85#, 16#0020#, 16#0002#),
         29877 => (16#940A#, 16#0000#, 16#0000#),
         29878 => (16#FB80#, 16#0020#, 16#0002#),
         29879 => (16#CAB2#, 16#0000#, 16#0000#),
         29880 => (16#FB85#, 16#0020#, 16#0002#),
         29881 => (16#9496#, 16#0000#, 16#0000#),
         29882 => (16#FB41#, 16#0020#, 16#0002#),
         29883 => (16#9829#, 16#0000#, 16#0000#),
         29884 => (16#FB85#, 16#0020#, 16#0002#),
         29885 => (16#95B6#, 16#0000#, 16#0000#),
         29886 => (16#FB41#, 16#0020#, 16#0002#),
         29887 => (16#98E2#, 16#0000#, 16#0000#),
         29888 => (16#FB80#, 16#0020#, 16#0002#),
         29889 => (16#CB33#, 16#0000#, 16#0000#),
         29890 => (16#FB41#, 16#0020#, 16#0002#),
         29891 => (16#9929#, 16#0000#, 16#0000#),
         29892 => (16#FB41#, 16#0020#, 16#0002#),
         29893 => (16#99A7#, 16#0000#, 16#0000#),
         29894 => (16#FB41#, 16#0020#, 16#0002#),
         29895 => (16#99C2#, 16#0000#, 16#0000#),
         29896 => (16#FB41#, 16#0020#, 16#0002#),
         29897 => (16#99FE#, 16#0000#, 16#0000#),
         29898 => (16#FB80#, 16#0020#, 16#0002#),
         29899 => (16#CBCE#, 16#0000#, 16#0000#),
         29900 => (16#FB85#, 16#0020#, 16#0002#),
         29901 => (16#9B30#, 16#0000#, 16#0000#),
         29902 => (16#FB41#, 16#0020#, 16#0002#),
         29903 => (16#9C40#, 16#0000#, 16#0000#),
         29904 => (16#FB41#, 16#0020#, 16#0002#),
         29905 => (16#9CFD#, 16#0000#, 16#0000#),
         29906 => (16#FB80#, 16#0020#, 16#0002#),
         29907 => (16#CCCE#, 16#0000#, 16#0000#),
         29908 => (16#FB80#, 16#0020#, 16#0002#),
         29909 => (16#CCED#, 16#0000#, 16#0000#),
         29910 => (16#FB41#, 16#0020#, 16#0002#),
         29911 => (16#9D67#, 16#0000#, 16#0000#),
         29912 => (16#FB85#, 16#0020#, 16#0002#),
         29913 => (16#A0CE#, 16#0000#, 16#0000#),
         29914 => (16#FB80#, 16#0020#, 16#0002#),
         29915 => (16#CCF8#, 16#0000#, 16#0000#),
         29916 => (16#FB85#, 16#0020#, 16#0002#),
         29917 => (16#A105#, 16#0000#, 16#0000#),
         29918 => (16#FB85#, 16#0020#, 16#0002#),
         29919 => (16#A20E#, 16#0000#, 16#0000#),
         29920 => (16#FB85#, 16#0020#, 16#0002#),
         29921 => (16#A291#, 16#0000#, 16#0000#),
         29922 => (16#FB41#, 16#0020#, 16#0002#),
         29923 => (16#9EBB#, 16#0000#, 16#0000#),
         29924 => (16#FB80#, 16#0020#, 16#0002#),
         29925 => (16#CD56#, 16#0000#, 16#0000#),
         29926 => (16#FB41#, 16#0020#, 16#0002#),
         29927 => (16#9EF9#, 16#0000#, 16#0000#),
         29928 => (16#FB41#, 16#0020#, 16#0002#),
         29929 => (16#9EFE#, 16#0000#, 16#0000#),
         29930 => (16#FB41#, 16#0020#, 16#0002#),
         29931 => (16#9F05#, 16#0000#, 16#0000#),
         29932 => (16#FB41#, 16#0020#, 16#0002#),
         29933 => (16#9F0F#, 16#0000#, 16#0000#),
         29934 => (16#FB41#, 16#0020#, 16#0002#),
         29935 => (16#9F16#, 16#0000#, 16#0000#),
         29936 => (16#FB41#, 16#0020#, 16#0002#),
         29937 => (16#9F3B#, 16#0000#, 16#0000#),
         29938 => (16#FB85#, 16#0020#, 16#0002#),
         29939 => (16#A600#, 16#0000#, 16#0000#));

   Contraction_Data : aliased constant Contractor_Array
     := (1 => (16#0000B7#, 0, 0, 52, 53),
         2 => (16#000387#, 0, 0, 52, 53),
         3 => (16#0000B7#, 0, 0, 86, 87),
         4 => (16#000387#, 0, 0, 86, 87),
         5 => (16#000306#, 0, 0, 1243, 1243),
         6 => (16#000306#, 0, 0, 1273, 1273),
         7 => (16#000653#, 0, 0, 1718, 1718),
         8 => (16#000654#, 0, 0, 1719, 1719),
         9 => (16#000655#, 0, 0, 1721, 1721),
         10 => (16#000654#, 0, 0, 1720, 1720),
         11 => (16#000654#, 0, 0, 1722, 1722),
         12 => (16#0009BE#, 0, 0, 2419, 2419),
         13 => (16#0009D7#, 0, 0, 2420, 2420),
         14 => (16#000B56#, 0, 0, 2643, 2643),
         15 => (16#000B3E#, 0, 0, 2644, 2644),
         16 => (16#000B57#, 0, 0, 2645, 2645),
         17 => (16#000BD7#, 0, 0, 2677, 2677),
         18 => (16#000BBE#, 0, 0, 2708, 2708),
         19 => (16#000BD7#, 0, 0, 2709, 2709),
         20 => (16#000BBE#, 0, 0, 2711, 2711),
         21 => (16#000C56#, 0, 0, 2786, 2786),
         22 => (16#000CD5#, 0, 0, 2853, 2853),
         23 => (16#000CD5#, 0, 0, 2859, 2859),
         24 => (16#000CD6#, 0, 0, 2860, 2860),
         25 => (16#000CC2#, 26, 26, 2861, 2861),
         26 => (16#000CD5#, 0, 0, 2862, 2862),
         27 => (16#000CD5#, 0, 0, 2862, 2862),
         28 => (16#000D3E#, 0, 0, 2935, 2935),
         29 => (16#000D57#, 0, 0, 2936, 2936),
         30 => (16#000D3E#, 0, 0, 2938, 2938),
         31 => (16#000DCA#, 0, 0, 3034, 3034),
         32 => (16#000DCF#, 34, 34, 3035, 3035),
         33 => (16#000DDF#, 0, 0, 3036, 3036),
         34 => (16#000DCA#, 0, 0, 3037, 3037),
         35 => (16#000DCA#, 0, 0, 3037, 3037),
         36 => (16#000E01#, 0, 0, 3103, 3104),
         37 => (16#000E02#, 0, 0, 3105, 3106),
         38 => (16#000E03#, 0, 0, 3107, 3108),
         39 => (16#000E04#, 0, 0, 3109, 3110),
         40 => (16#000E05#, 0, 0, 3111, 3112),
         41 => (16#000E06#, 0, 0, 3113, 3114),
         42 => (16#000E07#, 0, 0, 3115, 3116),
         43 => (16#000E08#, 0, 0, 3117, 3118),
         44 => (16#000E09#, 0, 0, 3119, 3120),
         45 => (16#000E0A#, 0, 0, 3121, 3122),
         46 => (16#000E0B#, 0, 0, 3123, 3124),
         47 => (16#000E0C#, 0, 0, 3125, 3126),
         48 => (16#000E0D#, 0, 0, 3127, 3128),
         49 => (16#000E0E#, 0, 0, 3129, 3130),
         50 => (16#000E0F#, 0, 0, 3131, 3132),
         51 => (16#000E10#, 0, 0, 3133, 3134),
         52 => (16#000E11#, 0, 0, 3135, 3136),
         53 => (16#000E12#, 0, 0, 3137, 3138),
         54 => (16#000E13#, 0, 0, 3139, 3140),
         55 => (16#000E14#, 0, 0, 3141, 3142),
         56 => (16#000E15#, 0, 0, 3143, 3144),
         57 => (16#000E16#, 0, 0, 3145, 3146),
         58 => (16#000E17#, 0, 0, 3147, 3148),
         59 => (16#000E18#, 0, 0, 3149, 3150),
         60 => (16#000E19#, 0, 0, 3151, 3152),
         61 => (16#000E1A#, 0, 0, 3153, 3154),
         62 => (16#000E1B#, 0, 0, 3155, 3156),
         63 => (16#000E1C#, 0, 0, 3157, 3158),
         64 => (16#000E1D#, 0, 0, 3159, 3160),
         65 => (16#000E1E#, 0, 0, 3161, 3162),
         66 => (16#000E1F#, 0, 0, 3163, 3164),
         67 => (16#000E20#, 0, 0, 3165, 3166),
         68 => (16#000E21#, 0, 0, 3167, 3168),
         69 => (16#000E22#, 0, 0, 3169, 3170),
         70 => (16#000E23#, 0, 0, 3171, 3172),
         71 => (16#000E24#, 0, 0, 3173, 3174),
         72 => (16#000E25#, 0, 0, 3175, 3176),
         73 => (16#000E26#, 0, 0, 3177, 3178),
         74 => (16#000E27#, 0, 0, 3179, 3180),
         75 => (16#000E28#, 0, 0, 3181, 3182),
         76 => (16#000E29#, 0, 0, 3183, 3184),
         77 => (16#000E2A#, 0, 0, 3185, 3186),
         78 => (16#000E2B#, 0, 0, 3187, 3188),
         79 => (16#000E2C#, 0, 0, 3189, 3190),
         80 => (16#000E2D#, 0, 0, 3191, 3192),
         81 => (16#000E2E#, 0, 0, 3193, 3194),
         82 => (16#000E01#, 0, 0, 3196, 3197),
         83 => (16#000E02#, 0, 0, 3198, 3199),
         84 => (16#000E03#, 0, 0, 3200, 3201),
         85 => (16#000E04#, 0, 0, 3202, 3203),
         86 => (16#000E05#, 0, 0, 3204, 3205),
         87 => (16#000E06#, 0, 0, 3206, 3207),
         88 => (16#000E07#, 0, 0, 3208, 3209),
         89 => (16#000E08#, 0, 0, 3210, 3211),
         90 => (16#000E09#, 0, 0, 3212, 3213),
         91 => (16#000E0A#, 0, 0, 3214, 3215),
         92 => (16#000E0B#, 0, 0, 3216, 3217),
         93 => (16#000E0C#, 0, 0, 3218, 3219),
         94 => (16#000E0D#, 0, 0, 3220, 3221),
         95 => (16#000E0E#, 0, 0, 3222, 3223),
         96 => (16#000E0F#, 0, 0, 3224, 3225),
         97 => (16#000E10#, 0, 0, 3226, 3227),
         98 => (16#000E11#, 0, 0, 3228, 3229),
         99 => (16#000E12#, 0, 0, 3230, 3231),
         100 => (16#000E13#, 0, 0, 3232, 3233),
         101 => (16#000E14#, 0, 0, 3234, 3235),
         102 => (16#000E15#, 0, 0, 3236, 3237),
         103 => (16#000E16#, 0, 0, 3238, 3239),
         104 => (16#000E17#, 0, 0, 3240, 3241),
         105 => (16#000E18#, 0, 0, 3242, 3243),
         106 => (16#000E19#, 0, 0, 3244, 3245),
         107 => (16#000E1A#, 0, 0, 3246, 3247),
         108 => (16#000E1B#, 0, 0, 3248, 3249),
         109 => (16#000E1C#, 0, 0, 3250, 3251),
         110 => (16#000E1D#, 0, 0, 3252, 3253),
         111 => (16#000E1E#, 0, 0, 3254, 3255),
         112 => (16#000E1F#, 0, 0, 3256, 3257),
         113 => (16#000E20#, 0, 0, 3258, 3259),
         114 => (16#000E21#, 0, 0, 3260, 3261),
         115 => (16#000E22#, 0, 0, 3262, 3263),
         116 => (16#000E23#, 0, 0, 3264, 3265),
         117 => (16#000E24#, 0, 0, 3266, 3267),
         118 => (16#000E25#, 0, 0, 3268, 3269),
         119 => (16#000E26#, 0, 0, 3270, 3271),
         120 => (16#000E27#, 0, 0, 3272, 3273),
         121 => (16#000E28#, 0, 0, 3274, 3275),
         122 => (16#000E29#, 0, 0, 3276, 3277),
         123 => (16#000E2A#, 0, 0, 3278, 3279),
         124 => (16#000E2B#, 0, 0, 3280, 3281),
         125 => (16#000E2C#, 0, 0, 3282, 3283),
         126 => (16#000E2D#, 0, 0, 3284, 3285),
         127 => (16#000E2E#, 0, 0, 3286, 3287),
         128 => (16#000E01#, 0, 0, 3289, 3290),
         129 => (16#000E02#, 0, 0, 3291, 3292),
         130 => (16#000E03#, 0, 0, 3293, 3294),
         131 => (16#000E04#, 0, 0, 3295, 3296),
         132 => (16#000E05#, 0, 0, 3297, 3298),
         133 => (16#000E06#, 0, 0, 3299, 3300),
         134 => (16#000E07#, 0, 0, 3301, 3302),
         135 => (16#000E08#, 0, 0, 3303, 3304),
         136 => (16#000E09#, 0, 0, 3305, 3306),
         137 => (16#000E0A#, 0, 0, 3307, 3308),
         138 => (16#000E0B#, 0, 0, 3309, 3310),
         139 => (16#000E0C#, 0, 0, 3311, 3312),
         140 => (16#000E0D#, 0, 0, 3313, 3314),
         141 => (16#000E0E#, 0, 0, 3315, 3316),
         142 => (16#000E0F#, 0, 0, 3317, 3318),
         143 => (16#000E10#, 0, 0, 3319, 3320),
         144 => (16#000E11#, 0, 0, 3321, 3322),
         145 => (16#000E12#, 0, 0, 3323, 3324),
         146 => (16#000E13#, 0, 0, 3325, 3326),
         147 => (16#000E14#, 0, 0, 3327, 3328),
         148 => (16#000E15#, 0, 0, 3329, 3330),
         149 => (16#000E16#, 0, 0, 3331, 3332),
         150 => (16#000E17#, 0, 0, 3333, 3334),
         151 => (16#000E18#, 0, 0, 3335, 3336),
         152 => (16#000E19#, 0, 0, 3337, 3338),
         153 => (16#000E1A#, 0, 0, 3339, 3340),
         154 => (16#000E1B#, 0, 0, 3341, 3342),
         155 => (16#000E1C#, 0, 0, 3343, 3344),
         156 => (16#000E1D#, 0, 0, 3345, 3346),
         157 => (16#000E1E#, 0, 0, 3347, 3348),
         158 => (16#000E1F#, 0, 0, 3349, 3350),
         159 => (16#000E20#, 0, 0, 3351, 3352),
         160 => (16#000E21#, 0, 0, 3353, 3354),
         161 => (16#000E22#, 0, 0, 3355, 3356),
         162 => (16#000E23#, 0, 0, 3357, 3358),
         163 => (16#000E24#, 0, 0, 3359, 3360),
         164 => (16#000E25#, 0, 0, 3361, 3362),
         165 => (16#000E26#, 0, 0, 3363, 3364),
         166 => (16#000E27#, 0, 0, 3365, 3366),
         167 => (16#000E28#, 0, 0, 3367, 3368),
         168 => (16#000E29#, 0, 0, 3369, 3370),
         169 => (16#000E2A#, 0, 0, 3371, 3372),
         170 => (16#000E2B#, 0, 0, 3373, 3374),
         171 => (16#000E2C#, 0, 0, 3375, 3376),
         172 => (16#000E2D#, 0, 0, 3377, 3378),
         173 => (16#000E2E#, 0, 0, 3379, 3380),
         174 => (16#000E01#, 0, 0, 3382, 3383),
         175 => (16#000E02#, 0, 0, 3384, 3385),
         176 => (16#000E03#, 0, 0, 3386, 3387),
         177 => (16#000E04#, 0, 0, 3388, 3389),
         178 => (16#000E05#, 0, 0, 3390, 3391),
         179 => (16#000E06#, 0, 0, 3392, 3393),
         180 => (16#000E07#, 0, 0, 3394, 3395),
         181 => (16#000E08#, 0, 0, 3396, 3397),
         182 => (16#000E09#, 0, 0, 3398, 3399),
         183 => (16#000E0A#, 0, 0, 3400, 3401),
         184 => (16#000E0B#, 0, 0, 3402, 3403),
         185 => (16#000E0C#, 0, 0, 3404, 3405),
         186 => (16#000E0D#, 0, 0, 3406, 3407),
         187 => (16#000E0E#, 0, 0, 3408, 3409),
         188 => (16#000E0F#, 0, 0, 3410, 3411),
         189 => (16#000E10#, 0, 0, 3412, 3413),
         190 => (16#000E11#, 0, 0, 3414, 3415),
         191 => (16#000E12#, 0, 0, 3416, 3417),
         192 => (16#000E13#, 0, 0, 3418, 3419),
         193 => (16#000E14#, 0, 0, 3420, 3421),
         194 => (16#000E15#, 0, 0, 3422, 3423),
         195 => (16#000E16#, 0, 0, 3424, 3425),
         196 => (16#000E17#, 0, 0, 3426, 3427),
         197 => (16#000E18#, 0, 0, 3428, 3429),
         198 => (16#000E19#, 0, 0, 3430, 3431),
         199 => (16#000E1A#, 0, 0, 3432, 3433),
         200 => (16#000E1B#, 0, 0, 3434, 3435),
         201 => (16#000E1C#, 0, 0, 3436, 3437),
         202 => (16#000E1D#, 0, 0, 3438, 3439),
         203 => (16#000E1E#, 0, 0, 3440, 3441),
         204 => (16#000E1F#, 0, 0, 3442, 3443),
         205 => (16#000E20#, 0, 0, 3444, 3445),
         206 => (16#000E21#, 0, 0, 3446, 3447),
         207 => (16#000E22#, 0, 0, 3448, 3449),
         208 => (16#000E23#, 0, 0, 3450, 3451),
         209 => (16#000E24#, 0, 0, 3452, 3453),
         210 => (16#000E25#, 0, 0, 3454, 3455),
         211 => (16#000E26#, 0, 0, 3456, 3457),
         212 => (16#000E27#, 0, 0, 3458, 3459),
         213 => (16#000E28#, 0, 0, 3460, 3461),
         214 => (16#000E29#, 0, 0, 3462, 3463),
         215 => (16#000E2A#, 0, 0, 3464, 3465),
         216 => (16#000E2B#, 0, 0, 3466, 3467),
         217 => (16#000E2C#, 0, 0, 3468, 3469),
         218 => (16#000E2D#, 0, 0, 3470, 3471),
         219 => (16#000E2E#, 0, 0, 3472, 3473),
         220 => (16#000E01#, 0, 0, 3475, 3476),
         221 => (16#000E02#, 0, 0, 3477, 3478),
         222 => (16#000E03#, 0, 0, 3479, 3480),
         223 => (16#000E04#, 0, 0, 3481, 3482),
         224 => (16#000E05#, 0, 0, 3483, 3484),
         225 => (16#000E06#, 0, 0, 3485, 3486),
         226 => (16#000E07#, 0, 0, 3487, 3488),
         227 => (16#000E08#, 0, 0, 3489, 3490),
         228 => (16#000E09#, 0, 0, 3491, 3492),
         229 => (16#000E0A#, 0, 0, 3493, 3494),
         230 => (16#000E0B#, 0, 0, 3495, 3496),
         231 => (16#000E0C#, 0, 0, 3497, 3498),
         232 => (16#000E0D#, 0, 0, 3499, 3500),
         233 => (16#000E0E#, 0, 0, 3501, 3502),
         234 => (16#000E0F#, 0, 0, 3503, 3504),
         235 => (16#000E10#, 0, 0, 3505, 3506),
         236 => (16#000E11#, 0, 0, 3507, 3508),
         237 => (16#000E12#, 0, 0, 3509, 3510),
         238 => (16#000E13#, 0, 0, 3511, 3512),
         239 => (16#000E14#, 0, 0, 3513, 3514),
         240 => (16#000E15#, 0, 0, 3515, 3516),
         241 => (16#000E16#, 0, 0, 3517, 3518),
         242 => (16#000E17#, 0, 0, 3519, 3520),
         243 => (16#000E18#, 0, 0, 3521, 3522),
         244 => (16#000E19#, 0, 0, 3523, 3524),
         245 => (16#000E1A#, 0, 0, 3525, 3526),
         246 => (16#000E1B#, 0, 0, 3527, 3528),
         247 => (16#000E1C#, 0, 0, 3529, 3530),
         248 => (16#000E1D#, 0, 0, 3531, 3532),
         249 => (16#000E1E#, 0, 0, 3533, 3534),
         250 => (16#000E1F#, 0, 0, 3535, 3536),
         251 => (16#000E20#, 0, 0, 3537, 3538),
         252 => (16#000E21#, 0, 0, 3539, 3540),
         253 => (16#000E22#, 0, 0, 3541, 3542),
         254 => (16#000E23#, 0, 0, 3543, 3544),
         255 => (16#000E24#, 0, 0, 3545, 3546),
         256 => (16#000E25#, 0, 0, 3547, 3548),
         257 => (16#000E26#, 0, 0, 3549, 3550),
         258 => (16#000E27#, 0, 0, 3551, 3552),
         259 => (16#000E28#, 0, 0, 3553, 3554),
         260 => (16#000E29#, 0, 0, 3555, 3556),
         261 => (16#000E2A#, 0, 0, 3557, 3558),
         262 => (16#000E2B#, 0, 0, 3559, 3560),
         263 => (16#000E2C#, 0, 0, 3561, 3562),
         264 => (16#000E2D#, 0, 0, 3563, 3564),
         265 => (16#000E2E#, 0, 0, 3565, 3566),
         266 => (16#000E32#, 0, 0, 3093, 3093),
         267 => (16#000EDE#, 0, 0, 3622, 3623),
         268 => (16#000E81#, 0, 0, 3624, 3625),
         269 => (16#000E82#, 0, 0, 3626, 3627),
         270 => (16#000E84#, 0, 0, 3628, 3629),
         271 => (16#000E87#, 0, 0, 3630, 3631),
         272 => (16#000E88#, 0, 0, 3632, 3633),
         273 => (16#000EAA#, 0, 0, 3634, 3635),
         274 => (16#000E8A#, 0, 0, 3636, 3637),
         275 => (16#000EDF#, 0, 0, 3638, 3639),
         276 => (16#000E8D#, 0, 0, 3640, 3641),
         277 => (16#000E94#, 0, 0, 3642, 3643),
         278 => (16#000E95#, 0, 0, 3644, 3645),
         279 => (16#000E96#, 0, 0, 3646, 3647),
         280 => (16#000E97#, 0, 0, 3648, 3649),
         281 => (16#000E99#, 0, 0, 3650, 3651),
         282 => (16#000E9A#, 0, 0, 3652, 3653),
         283 => (16#000E9B#, 0, 0, 3654, 3655),
         284 => (16#000E9C#, 0, 0, 3656, 3657),
         285 => (16#000E9D#, 0, 0, 3658, 3659),
         286 => (16#000E9E#, 0, 0, 3660, 3661),
         287 => (16#000E9F#, 0, 0, 3662, 3663),
         288 => (16#000EA1#, 0, 0, 3664, 3665),
         289 => (16#000EA2#, 0, 0, 3666, 3667),
         290 => (16#000EA3#, 0, 0, 3668, 3669),
         291 => (16#000EA5#, 0, 0, 3670, 3671),
         292 => (16#000EA7#, 0, 0, 3672, 3673),
         293 => (16#000EDC#, 0, 0, 3674, 3676),
         294 => (16#000EDD#, 0, 0, 3677, 3679),
         295 => (16#000EAB#, 0, 0, 3680, 3681),
         296 => (16#000EAD#, 0, 0, 3682, 3683),
         297 => (16#000EAE#, 0, 0, 3684, 3685),
         298 => (16#000EDE#, 0, 0, 3687, 3688),
         299 => (16#000E81#, 0, 0, 3689, 3690),
         300 => (16#000E82#, 0, 0, 3691, 3692),
         301 => (16#000E84#, 0, 0, 3693, 3694),
         302 => (16#000E87#, 0, 0, 3695, 3696),
         303 => (16#000E88#, 0, 0, 3697, 3698),
         304 => (16#000EAA#, 0, 0, 3699, 3700),
         305 => (16#000E8A#, 0, 0, 3701, 3702),
         306 => (16#000EDF#, 0, 0, 3703, 3704),
         307 => (16#000E8D#, 0, 0, 3705, 3706),
         308 => (16#000E94#, 0, 0, 3707, 3708),
         309 => (16#000E95#, 0, 0, 3709, 3710),
         310 => (16#000E96#, 0, 0, 3711, 3712),
         311 => (16#000E97#, 0, 0, 3713, 3714),
         312 => (16#000E99#, 0, 0, 3715, 3716),
         313 => (16#000E9A#, 0, 0, 3717, 3718),
         314 => (16#000E9B#, 0, 0, 3719, 3720),
         315 => (16#000E9C#, 0, 0, 3721, 3722),
         316 => (16#000E9D#, 0, 0, 3723, 3724),
         317 => (16#000E9E#, 0, 0, 3725, 3726),
         318 => (16#000E9F#, 0, 0, 3727, 3728),
         319 => (16#000EA1#, 0, 0, 3729, 3730),
         320 => (16#000EA2#, 0, 0, 3731, 3732),
         321 => (16#000EA3#, 0, 0, 3733, 3734),
         322 => (16#000EA5#, 0, 0, 3735, 3736),
         323 => (16#000EA7#, 0, 0, 3737, 3738),
         324 => (16#000EDC#, 0, 0, 3739, 3741),
         325 => (16#000EDD#, 0, 0, 3742, 3744),
         326 => (16#000EAB#, 0, 0, 3745, 3746),
         327 => (16#000EAD#, 0, 0, 3747, 3748),
         328 => (16#000EAE#, 0, 0, 3749, 3750),
         329 => (16#000EDE#, 0, 0, 3752, 3753),
         330 => (16#000E81#, 0, 0, 3754, 3755),
         331 => (16#000E82#, 0, 0, 3756, 3757),
         332 => (16#000E84#, 0, 0, 3758, 3759),
         333 => (16#000E87#, 0, 0, 3760, 3761),
         334 => (16#000E88#, 0, 0, 3762, 3763),
         335 => (16#000EAA#, 0, 0, 3764, 3765),
         336 => (16#000E8A#, 0, 0, 3766, 3767),
         337 => (16#000EDF#, 0, 0, 3768, 3769),
         338 => (16#000E8D#, 0, 0, 3770, 3771),
         339 => (16#000E94#, 0, 0, 3772, 3773),
         340 => (16#000E95#, 0, 0, 3774, 3775),
         341 => (16#000E96#, 0, 0, 3776, 3777),
         342 => (16#000E97#, 0, 0, 3778, 3779),
         343 => (16#000E99#, 0, 0, 3780, 3781),
         344 => (16#000E9A#, 0, 0, 3782, 3783),
         345 => (16#000E9B#, 0, 0, 3784, 3785),
         346 => (16#000E9C#, 0, 0, 3786, 3787),
         347 => (16#000E9D#, 0, 0, 3788, 3789),
         348 => (16#000E9E#, 0, 0, 3790, 3791),
         349 => (16#000E9F#, 0, 0, 3792, 3793),
         350 => (16#000EA1#, 0, 0, 3794, 3795),
         351 => (16#000EA2#, 0, 0, 3796, 3797),
         352 => (16#000EA3#, 0, 0, 3798, 3799),
         353 => (16#000EA5#, 0, 0, 3800, 3801),
         354 => (16#000EA7#, 0, 0, 3802, 3803),
         355 => (16#000EDC#, 0, 0, 3804, 3806),
         356 => (16#000EDD#, 0, 0, 3807, 3809),
         357 => (16#000EAB#, 0, 0, 3810, 3811),
         358 => (16#000EAD#, 0, 0, 3812, 3813),
         359 => (16#000EAE#, 0, 0, 3814, 3815),
         360 => (16#000EDE#, 0, 0, 3817, 3818),
         361 => (16#000E81#, 0, 0, 3819, 3820),
         362 => (16#000E82#, 0, 0, 3821, 3822),
         363 => (16#000E84#, 0, 0, 3823, 3824),
         364 => (16#000E87#, 0, 0, 3825, 3826),
         365 => (16#000E88#, 0, 0, 3827, 3828),
         366 => (16#000EAA#, 0, 0, 3829, 3830),
         367 => (16#000E8A#, 0, 0, 3831, 3832),
         368 => (16#000EDF#, 0, 0, 3833, 3834),
         369 => (16#000E8D#, 0, 0, 3835, 3836),
         370 => (16#000E94#, 0, 0, 3837, 3838),
         371 => (16#000E95#, 0, 0, 3839, 3840),
         372 => (16#000E96#, 0, 0, 3841, 3842),
         373 => (16#000E97#, 0, 0, 3843, 3844),
         374 => (16#000E99#, 0, 0, 3845, 3846),
         375 => (16#000E9A#, 0, 0, 3847, 3848),
         376 => (16#000E9B#, 0, 0, 3849, 3850),
         377 => (16#000E9C#, 0, 0, 3851, 3852),
         378 => (16#000E9D#, 0, 0, 3853, 3854),
         379 => (16#000E9E#, 0, 0, 3855, 3856),
         380 => (16#000E9F#, 0, 0, 3857, 3858),
         381 => (16#000EA1#, 0, 0, 3859, 3860),
         382 => (16#000EA2#, 0, 0, 3861, 3862),
         383 => (16#000EA3#, 0, 0, 3863, 3864),
         384 => (16#000EA5#, 0, 0, 3865, 3866),
         385 => (16#000EA7#, 0, 0, 3867, 3868),
         386 => (16#000EDC#, 0, 0, 3869, 3871),
         387 => (16#000EDD#, 0, 0, 3872, 3874),
         388 => (16#000EAB#, 0, 0, 3875, 3876),
         389 => (16#000EAD#, 0, 0, 3877, 3878),
         390 => (16#000EAE#, 0, 0, 3879, 3880),
         391 => (16#000EDE#, 0, 0, 3882, 3883),
         392 => (16#000E81#, 0, 0, 3884, 3885),
         393 => (16#000E82#, 0, 0, 3886, 3887),
         394 => (16#000E84#, 0, 0, 3888, 3889),
         395 => (16#000E87#, 0, 0, 3890, 3891),
         396 => (16#000E88#, 0, 0, 3892, 3893),
         397 => (16#000EAA#, 0, 0, 3894, 3895),
         398 => (16#000E8A#, 0, 0, 3896, 3897),
         399 => (16#000EDF#, 0, 0, 3898, 3899),
         400 => (16#000E8D#, 0, 0, 3900, 3901),
         401 => (16#000E94#, 0, 0, 3902, 3903),
         402 => (16#000E95#, 0, 0, 3904, 3905),
         403 => (16#000E96#, 0, 0, 3906, 3907),
         404 => (16#000E97#, 0, 0, 3908, 3909),
         405 => (16#000E99#, 0, 0, 3910, 3911),
         406 => (16#000E9A#, 0, 0, 3912, 3913),
         407 => (16#000E9B#, 0, 0, 3914, 3915),
         408 => (16#000E9C#, 0, 0, 3916, 3917),
         409 => (16#000E9D#, 0, 0, 3918, 3919),
         410 => (16#000E9E#, 0, 0, 3920, 3921),
         411 => (16#000E9F#, 0, 0, 3922, 3923),
         412 => (16#000EA1#, 0, 0, 3924, 3925),
         413 => (16#000EA2#, 0, 0, 3926, 3927),
         414 => (16#000EA3#, 0, 0, 3928, 3929),
         415 => (16#000EA5#, 0, 0, 3930, 3931),
         416 => (16#000EA7#, 0, 0, 3932, 3933),
         417 => (16#000EDC#, 0, 0, 3934, 3936),
         418 => (16#000EDD#, 0, 0, 3937, 3939),
         419 => (16#000EAB#, 0, 0, 3940, 3941),
         420 => (16#000EAD#, 0, 0, 3942, 3943),
         421 => (16#000EAE#, 0, 0, 3944, 3945),
         422 => (16#000EB2#, 0, 0, 3611, 3611),
         423 => (16#000F72#, 0, 0, 4055, 4055),
         424 => (16#000F80#, 0, 0, 4056, 4056),
         425 => (16#000F74#, 0, 0, 4057, 4057),
         426 => (16#000F71#, 431, 433, 4118, 4119),
         427 => (16#000F73#, 0, 0, 4120, 4121),
         428 => (16#000F75#, 0, 0, 4122, 4123),
         429 => (16#000F80#, 0, 0, 4060, 4060),
         430 => (16#000F81#, 0, 0, 4061, 4061),
         431 => (16#000F72#, 0, 0, 4120, 4121),
         432 => (16#000F74#, 0, 0, 4122, 4123),
         433 => (16#000F80#, 0, 0, 4061, 4061),
         434 => (16#000F71#, 439, 441, 4125, 4126),
         435 => (16#000F73#, 0, 0, 4127, 4128),
         436 => (16#000F75#, 0, 0, 4129, 4130),
         437 => (16#000F80#, 0, 0, 4062, 4062),
         438 => (16#000F81#, 0, 0, 4063, 4063),
         439 => (16#000F72#, 0, 0, 4127, 4128),
         440 => (16#000F74#, 0, 0, 4129, 4130),
         441 => (16#000F80#, 0, 0, 4063, 4063),
         442 => (16#00102E#, 0, 0, 4207, 4207),
         443 => (16#001B35#, 0, 0, 6626, 6626),
         444 => (16#001B35#, 0, 0, 6628, 6628),
         445 => (16#001B35#, 0, 0, 6630, 6630),
         446 => (16#001B35#, 0, 0, 6632, 6632),
         447 => (16#001B35#, 0, 0, 6634, 6634),
         448 => (16#001B35#, 0, 0, 6638, 6638),
         449 => (16#001B35#, 0, 0, 6678, 6678),
         450 => (16#001B35#, 0, 0, 6680, 6680),
         451 => (16#001B35#, 0, 0, 6682, 6682),
         452 => (16#001B35#, 0, 0, 6684, 6684),
         453 => (16#001B35#, 0, 0, 6686, 6686),
         454 => (16#00AA80#, 0, 0, 17086, 17087),
         455 => (16#00AA81#, 0, 0, 17088, 17089),
         456 => (16#00AA82#, 0, 0, 17090, 17091),
         457 => (16#00AA83#, 0, 0, 17092, 17093),
         458 => (16#00AA84#, 0, 0, 17094, 17095),
         459 => (16#00AA85#, 0, 0, 17096, 17097),
         460 => (16#00AA86#, 0, 0, 17098, 17099),
         461 => (16#00AA87#, 0, 0, 17100, 17101),
         462 => (16#00AA88#, 0, 0, 17102, 17103),
         463 => (16#00AA89#, 0, 0, 17104, 17105),
         464 => (16#00AA8A#, 0, 0, 17106, 17107),
         465 => (16#00AA8B#, 0, 0, 17108, 17109),
         466 => (16#00AA8C#, 0, 0, 17110, 17111),
         467 => (16#00AA8D#, 0, 0, 17112, 17113),
         468 => (16#00AA8E#, 0, 0, 17114, 17115),
         469 => (16#00AA8F#, 0, 0, 17116, 17117),
         470 => (16#00AA90#, 0, 0, 17118, 17119),
         471 => (16#00AA91#, 0, 0, 17120, 17121),
         472 => (16#00AA92#, 0, 0, 17122, 17123),
         473 => (16#00AA93#, 0, 0, 17124, 17125),
         474 => (16#00AA94#, 0, 0, 17126, 17127),
         475 => (16#00AA95#, 0, 0, 17128, 17129),
         476 => (16#00AA96#, 0, 0, 17130, 17131),
         477 => (16#00AA97#, 0, 0, 17132, 17133),
         478 => (16#00AA98#, 0, 0, 17134, 17135),
         479 => (16#00AA99#, 0, 0, 17136, 17137),
         480 => (16#00AA9A#, 0, 0, 17138, 17139),
         481 => (16#00AA9B#, 0, 0, 17140, 17141),
         482 => (16#00AA9C#, 0, 0, 17142, 17143),
         483 => (16#00AA9D#, 0, 0, 17144, 17145),
         484 => (16#00AA9E#, 0, 0, 17146, 17147),
         485 => (16#00AA9F#, 0, 0, 17148, 17149),
         486 => (16#00AAA0#, 0, 0, 17150, 17151),
         487 => (16#00AAA1#, 0, 0, 17152, 17153),
         488 => (16#00AAA2#, 0, 0, 17154, 17155),
         489 => (16#00AAA3#, 0, 0, 17156, 17157),
         490 => (16#00AAA4#, 0, 0, 17158, 17159),
         491 => (16#00AAA5#, 0, 0, 17160, 17161),
         492 => (16#00AAA6#, 0, 0, 17162, 17163),
         493 => (16#00AAA7#, 0, 0, 17164, 17165),
         494 => (16#00AAA8#, 0, 0, 17166, 17167),
         495 => (16#00AAA9#, 0, 0, 17168, 17169),
         496 => (16#00AAAA#, 0, 0, 17170, 17171),
         497 => (16#00AAAB#, 0, 0, 17172, 17173),
         498 => (16#00AAAC#, 0, 0, 17174, 17175),
         499 => (16#00AAAD#, 0, 0, 17176, 17177),
         500 => (16#00AAAE#, 0, 0, 17178, 17179),
         501 => (16#00AAAF#, 0, 0, 17180, 17181),
         502 => (16#00AA80#, 0, 0, 17183, 17184),
         503 => (16#00AA81#, 0, 0, 17185, 17186),
         504 => (16#00AA82#, 0, 0, 17187, 17188),
         505 => (16#00AA83#, 0, 0, 17189, 17190),
         506 => (16#00AA84#, 0, 0, 17191, 17192),
         507 => (16#00AA85#, 0, 0, 17193, 17194),
         508 => (16#00AA86#, 0, 0, 17195, 17196),
         509 => (16#00AA87#, 0, 0, 17197, 17198),
         510 => (16#00AA88#, 0, 0, 17199, 17200),
         511 => (16#00AA89#, 0, 0, 17201, 17202),
         512 => (16#00AA8A#, 0, 0, 17203, 17204),
         513 => (16#00AA8B#, 0, 0, 17205, 17206),
         514 => (16#00AA8C#, 0, 0, 17207, 17208),
         515 => (16#00AA8D#, 0, 0, 17209, 17210),
         516 => (16#00AA8E#, 0, 0, 17211, 17212),
         517 => (16#00AA8F#, 0, 0, 17213, 17214),
         518 => (16#00AA90#, 0, 0, 17215, 17216),
         519 => (16#00AA91#, 0, 0, 17217, 17218),
         520 => (16#00AA92#, 0, 0, 17219, 17220),
         521 => (16#00AA93#, 0, 0, 17221, 17222),
         522 => (16#00AA94#, 0, 0, 17223, 17224),
         523 => (16#00AA95#, 0, 0, 17225, 17226),
         524 => (16#00AA96#, 0, 0, 17227, 17228),
         525 => (16#00AA97#, 0, 0, 17229, 17230),
         526 => (16#00AA98#, 0, 0, 17231, 17232),
         527 => (16#00AA99#, 0, 0, 17233, 17234),
         528 => (16#00AA9A#, 0, 0, 17235, 17236),
         529 => (16#00AA9B#, 0, 0, 17237, 17238),
         530 => (16#00AA9C#, 0, 0, 17239, 17240),
         531 => (16#00AA9D#, 0, 0, 17241, 17242),
         532 => (16#00AA9E#, 0, 0, 17243, 17244),
         533 => (16#00AA9F#, 0, 0, 17245, 17246),
         534 => (16#00AAA0#, 0, 0, 17247, 17248),
         535 => (16#00AAA1#, 0, 0, 17249, 17250),
         536 => (16#00AAA2#, 0, 0, 17251, 17252),
         537 => (16#00AAA3#, 0, 0, 17253, 17254),
         538 => (16#00AAA4#, 0, 0, 17255, 17256),
         539 => (16#00AAA5#, 0, 0, 17257, 17258),
         540 => (16#00AAA6#, 0, 0, 17259, 17260),
         541 => (16#00AAA7#, 0, 0, 17261, 17262),
         542 => (16#00AAA8#, 0, 0, 17263, 17264),
         543 => (16#00AAA9#, 0, 0, 17265, 17266),
         544 => (16#00AAAA#, 0, 0, 17267, 17268),
         545 => (16#00AAAB#, 0, 0, 17269, 17270),
         546 => (16#00AAAC#, 0, 0, 17271, 17272),
         547 => (16#00AAAD#, 0, 0, 17273, 17274),
         548 => (16#00AAAE#, 0, 0, 17275, 17276),
         549 => (16#00AAAF#, 0, 0, 17277, 17278),
         550 => (16#00AA80#, 0, 0, 17282, 17283),
         551 => (16#00AA81#, 0, 0, 17284, 17285),
         552 => (16#00AA82#, 0, 0, 17286, 17287),
         553 => (16#00AA83#, 0, 0, 17288, 17289),
         554 => (16#00AA84#, 0, 0, 17290, 17291),
         555 => (16#00AA85#, 0, 0, 17292, 17293),
         556 => (16#00AA86#, 0, 0, 17294, 17295),
         557 => (16#00AA87#, 0, 0, 17296, 17297),
         558 => (16#00AA88#, 0, 0, 17298, 17299),
         559 => (16#00AA89#, 0, 0, 17300, 17301),
         560 => (16#00AA8A#, 0, 0, 17302, 17303),
         561 => (16#00AA8B#, 0, 0, 17304, 17305),
         562 => (16#00AA8C#, 0, 0, 17306, 17307),
         563 => (16#00AA8D#, 0, 0, 17308, 17309),
         564 => (16#00AA8E#, 0, 0, 17310, 17311),
         565 => (16#00AA8F#, 0, 0, 17312, 17313),
         566 => (16#00AA90#, 0, 0, 17314, 17315),
         567 => (16#00AA91#, 0, 0, 17316, 17317),
         568 => (16#00AA92#, 0, 0, 17318, 17319),
         569 => (16#00AA93#, 0, 0, 17320, 17321),
         570 => (16#00AA94#, 0, 0, 17322, 17323),
         571 => (16#00AA95#, 0, 0, 17324, 17325),
         572 => (16#00AA96#, 0, 0, 17326, 17327),
         573 => (16#00AA97#, 0, 0, 17328, 17329),
         574 => (16#00AA98#, 0, 0, 17330, 17331),
         575 => (16#00AA99#, 0, 0, 17332, 17333),
         576 => (16#00AA9A#, 0, 0, 17334, 17335),
         577 => (16#00AA9B#, 0, 0, 17336, 17337),
         578 => (16#00AA9C#, 0, 0, 17338, 17339),
         579 => (16#00AA9D#, 0, 0, 17340, 17341),
         580 => (16#00AA9E#, 0, 0, 17342, 17343),
         581 => (16#00AA9F#, 0, 0, 17344, 17345),
         582 => (16#00AAA0#, 0, 0, 17346, 17347),
         583 => (16#00AAA1#, 0, 0, 17348, 17349),
         584 => (16#00AAA2#, 0, 0, 17350, 17351),
         585 => (16#00AAA3#, 0, 0, 17352, 17353),
         586 => (16#00AAA4#, 0, 0, 17354, 17355),
         587 => (16#00AAA5#, 0, 0, 17356, 17357),
         588 => (16#00AAA6#, 0, 0, 17358, 17359),
         589 => (16#00AAA7#, 0, 0, 17360, 17361),
         590 => (16#00AAA8#, 0, 0, 17362, 17363),
         591 => (16#00AAA9#, 0, 0, 17364, 17365),
         592 => (16#00AAAA#, 0, 0, 17366, 17367),
         593 => (16#00AAAB#, 0, 0, 17368, 17369),
         594 => (16#00AAAC#, 0, 0, 17370, 17371),
         595 => (16#00AAAD#, 0, 0, 17372, 17373),
         596 => (16#00AAAE#, 0, 0, 17374, 17375),
         597 => (16#00AAAF#, 0, 0, 17376, 17377),
         598 => (16#00AA80#, 0, 0, 17380, 17381),
         599 => (16#00AA81#, 0, 0, 17382, 17383),
         600 => (16#00AA82#, 0, 0, 17384, 17385),
         601 => (16#00AA83#, 0, 0, 17386, 17387),
         602 => (16#00AA84#, 0, 0, 17388, 17389),
         603 => (16#00AA85#, 0, 0, 17390, 17391),
         604 => (16#00AA86#, 0, 0, 17392, 17393),
         605 => (16#00AA87#, 0, 0, 17394, 17395),
         606 => (16#00AA88#, 0, 0, 17396, 17397),
         607 => (16#00AA89#, 0, 0, 17398, 17399),
         608 => (16#00AA8A#, 0, 0, 17400, 17401),
         609 => (16#00AA8B#, 0, 0, 17402, 17403),
         610 => (16#00AA8C#, 0, 0, 17404, 17405),
         611 => (16#00AA8D#, 0, 0, 17406, 17407),
         612 => (16#00AA8E#, 0, 0, 17408, 17409),
         613 => (16#00AA8F#, 0, 0, 17410, 17411),
         614 => (16#00AA90#, 0, 0, 17412, 17413),
         615 => (16#00AA91#, 0, 0, 17414, 17415),
         616 => (16#00AA92#, 0, 0, 17416, 17417),
         617 => (16#00AA93#, 0, 0, 17418, 17419),
         618 => (16#00AA94#, 0, 0, 17420, 17421),
         619 => (16#00AA95#, 0, 0, 17422, 17423),
         620 => (16#00AA96#, 0, 0, 17424, 17425),
         621 => (16#00AA97#, 0, 0, 17426, 17427),
         622 => (16#00AA98#, 0, 0, 17428, 17429),
         623 => (16#00AA99#, 0, 0, 17430, 17431),
         624 => (16#00AA9A#, 0, 0, 17432, 17433),
         625 => (16#00AA9B#, 0, 0, 17434, 17435),
         626 => (16#00AA9C#, 0, 0, 17436, 17437),
         627 => (16#00AA9D#, 0, 0, 17438, 17439),
         628 => (16#00AA9E#, 0, 0, 17440, 17441),
         629 => (16#00AA9F#, 0, 0, 17442, 17443),
         630 => (16#00AAA0#, 0, 0, 17444, 17445),
         631 => (16#00AAA1#, 0, 0, 17446, 17447),
         632 => (16#00AAA2#, 0, 0, 17448, 17449),
         633 => (16#00AAA3#, 0, 0, 17450, 17451),
         634 => (16#00AAA4#, 0, 0, 17452, 17453),
         635 => (16#00AAA5#, 0, 0, 17454, 17455),
         636 => (16#00AAA6#, 0, 0, 17456, 17457),
         637 => (16#00AAA7#, 0, 0, 17458, 17459),
         638 => (16#00AAA8#, 0, 0, 17460, 17461),
         639 => (16#00AAA9#, 0, 0, 17462, 17463),
         640 => (16#00AAAA#, 0, 0, 17464, 17465),
         641 => (16#00AAAB#, 0, 0, 17466, 17467),
         642 => (16#00AAAC#, 0, 0, 17468, 17469),
         643 => (16#00AAAD#, 0, 0, 17470, 17471),
         644 => (16#00AAAE#, 0, 0, 17472, 17473),
         645 => (16#00AAAF#, 0, 0, 17474, 17475),
         646 => (16#00AA80#, 0, 0, 17477, 17478),
         647 => (16#00AA81#, 0, 0, 17479, 17480),
         648 => (16#00AA82#, 0, 0, 17481, 17482),
         649 => (16#00AA83#, 0, 0, 17483, 17484),
         650 => (16#00AA84#, 0, 0, 17485, 17486),
         651 => (16#00AA85#, 0, 0, 17487, 17488),
         652 => (16#00AA86#, 0, 0, 17489, 17490),
         653 => (16#00AA87#, 0, 0, 17491, 17492),
         654 => (16#00AA88#, 0, 0, 17493, 17494),
         655 => (16#00AA89#, 0, 0, 17495, 17496),
         656 => (16#00AA8A#, 0, 0, 17497, 17498),
         657 => (16#00AA8B#, 0, 0, 17499, 17500),
         658 => (16#00AA8C#, 0, 0, 17501, 17502),
         659 => (16#00AA8D#, 0, 0, 17503, 17504),
         660 => (16#00AA8E#, 0, 0, 17505, 17506),
         661 => (16#00AA8F#, 0, 0, 17507, 17508),
         662 => (16#00AA90#, 0, 0, 17509, 17510),
         663 => (16#00AA91#, 0, 0, 17511, 17512),
         664 => (16#00AA92#, 0, 0, 17513, 17514),
         665 => (16#00AA93#, 0, 0, 17515, 17516),
         666 => (16#00AA94#, 0, 0, 17517, 17518),
         667 => (16#00AA95#, 0, 0, 17519, 17520),
         668 => (16#00AA96#, 0, 0, 17521, 17522),
         669 => (16#00AA97#, 0, 0, 17523, 17524),
         670 => (16#00AA98#, 0, 0, 17525, 17526),
         671 => (16#00AA99#, 0, 0, 17527, 17528),
         672 => (16#00AA9A#, 0, 0, 17529, 17530),
         673 => (16#00AA9B#, 0, 0, 17531, 17532),
         674 => (16#00AA9C#, 0, 0, 17533, 17534),
         675 => (16#00AA9D#, 0, 0, 17535, 17536),
         676 => (16#00AA9E#, 0, 0, 17537, 17538),
         677 => (16#00AA9F#, 0, 0, 17539, 17540),
         678 => (16#00AAA0#, 0, 0, 17541, 17542),
         679 => (16#00AAA1#, 0, 0, 17543, 17544),
         680 => (16#00AAA2#, 0, 0, 17545, 17546),
         681 => (16#00AAA3#, 0, 0, 17547, 17548),
         682 => (16#00AAA4#, 0, 0, 17549, 17550),
         683 => (16#00AAA5#, 0, 0, 17551, 17552),
         684 => (16#00AAA6#, 0, 0, 17553, 17554),
         685 => (16#00AAA7#, 0, 0, 17555, 17556),
         686 => (16#00AAA8#, 0, 0, 17557, 17558),
         687 => (16#00AAA9#, 0, 0, 17559, 17560),
         688 => (16#00AAAA#, 0, 0, 17561, 17562),
         689 => (16#00AAAB#, 0, 0, 17563, 17564),
         690 => (16#00AAAC#, 0, 0, 17565, 17566),
         691 => (16#00AAAD#, 0, 0, 17567, 17568),
         692 => (16#00AAAE#, 0, 0, 17569, 17570),
         693 => (16#00AAAF#, 0, 0, 17571, 17572),
         694 => (16#011127#, 0, 0, 22491, 22491),
         695 => (16#011127#, 0, 0, 22492, 22492),
         696 => (16#01133E#, 0, 0, 22793, 22793),
         697 => (16#011357#, 0, 0, 22794, 22794),
         698 => (16#0114BA#, 0, 0, 22863, 22863),
         699 => (16#0114B0#, 0, 0, 22864, 22864),
         700 => (16#0114BD#, 0, 0, 22865, 22865),
         701 => (16#0115AF#, 0, 0, 22928, 22928),
         702 => (16#0115AF#, 0, 0, 22930, 22930));

   Group_0000 : aliased constant Collation_Second_Stage
     := (16#09#           =>  --  0009
          (0, 0, 2, 2),
         16#0A#           =>  --  000A
          (0, 0, 3, 3),
         16#0B#           =>  --  000B
          (0, 0, 4, 4),
         16#0C#           =>  --  000C
          (0, 0, 5, 5),
         16#0D#           =>  --  000D
          (0, 0, 6, 6),
         16#20#           =>  --  0020
          (0, 0, 7, 7),
         16#21#           =>  --  0021
          (0, 0, 8, 8),
         16#22#           =>  --  0022
          (0, 0, 9, 9),
         16#23#           =>  --  0023
          (0, 0, 10, 10),
         16#24#           =>  --  0024
          (0, 0, 11, 11),
         16#25#           =>  --  0025
          (0, 0, 12, 12),
         16#26#           =>  --  0026
          (0, 0, 13, 13),
         16#27#           =>  --  0027
          (0, 0, 14, 14),
         16#28#           =>  --  0028
          (0, 0, 15, 15),
         16#29#           =>  --  0029
          (0, 0, 16, 16),
         16#2A#           =>  --  002A
          (0, 0, 17, 17),
         16#2B#           =>  --  002B
          (0, 0, 18, 18),
         16#2C#           =>  --  002C
          (0, 0, 19, 19),
         16#2D#           =>  --  002D
          (0, 0, 20, 20),
         16#2E#           =>  --  002E
          (0, 0, 21, 21),
         16#2F#           =>  --  002F
          (0, 0, 22, 22),
         16#30#           =>  --  0030
          (0, 0, 23, 23),
         16#31#           =>  --  0031
          (0, 0, 24, 24),
         16#32#           =>  --  0032
          (0, 0, 25, 25),
         16#33#           =>  --  0033
          (0, 0, 26, 26),
         16#34#           =>  --  0034
          (0, 0, 27, 27),
         16#35#           =>  --  0035
          (0, 0, 28, 28),
         16#36#           =>  --  0036
          (0, 0, 29, 29),
         16#37#           =>  --  0037
          (0, 0, 30, 30),
         16#38#           =>  --  0038
          (0, 0, 31, 31),
         16#39#           =>  --  0039
          (0, 0, 32, 32),
         16#3A#           =>  --  003A
          (0, 0, 33, 33),
         16#3B#           =>  --  003B
          (0, 0, 34, 34),
         16#3C#           =>  --  003C
          (0, 0, 35, 35),
         16#3D#           =>  --  003D
          (0, 0, 36, 36),
         16#3E#           =>  --  003E
          (0, 0, 37, 37),
         16#3F#           =>  --  003F
          (0, 0, 38, 38),
         16#40#           =>  --  0040
          (0, 0, 39, 39),
         16#41#           =>  --  0041
          (0, 0, 40, 40),
         16#42#           =>  --  0042
          (0, 0, 41, 41),
         16#43#           =>  --  0043
          (0, 0, 42, 42),
         16#44#           =>  --  0044
          (0, 0, 43, 43),
         16#45#           =>  --  0045
          (0, 0, 44, 44),
         16#46#           =>  --  0046
          (0, 0, 45, 45),
         16#47#           =>  --  0047
          (0, 0, 46, 46),
         16#48#           =>  --  0048
          (0, 0, 47, 47),
         16#49#           =>  --  0049
          (0, 0, 48, 48),
         16#4A#           =>  --  004A
          (0, 0, 49, 49),
         16#4B#           =>  --  004B
          (0, 0, 50, 50),
         16#4C#           =>  --  004C
          (1, 2, 51, 51),
         16#4D#           =>  --  004D
          (0, 0, 54, 54),
         16#4E#           =>  --  004E
          (0, 0, 55, 55),
         16#4F#           =>  --  004F
          (0, 0, 56, 56),
         16#50#           =>  --  0050
          (0, 0, 57, 57),
         16#51#           =>  --  0051
          (0, 0, 58, 58),
         16#52#           =>  --  0052
          (0, 0, 59, 59),
         16#53#           =>  --  0053
          (0, 0, 60, 60),
         16#54#           =>  --  0054
          (0, 0, 61, 61),
         16#55#           =>  --  0055
          (0, 0, 62, 62),
         16#56#           =>  --  0056
          (0, 0, 63, 63),
         16#57#           =>  --  0057
          (0, 0, 64, 64),
         16#58#           =>  --  0058
          (0, 0, 65, 65),
         16#59#           =>  --  0059
          (0, 0, 66, 66),
         16#5A#           =>  --  005A
          (0, 0, 67, 67),
         16#5B#           =>  --  005B
          (0, 0, 68, 68),
         16#5C#           =>  --  005C
          (0, 0, 69, 69),
         16#5D#           =>  --  005D
          (0, 0, 70, 70),
         16#5E#           =>  --  005E
          (0, 0, 71, 71),
         16#5F#           =>  --  005F
          (0, 0, 72, 72),
         16#60#           =>  --  0060
          (0, 0, 73, 73),
         16#61#           =>  --  0061
          (0, 0, 74, 74),
         16#62#           =>  --  0062
          (0, 0, 75, 75),
         16#63#           =>  --  0063
          (0, 0, 76, 76),
         16#64#           =>  --  0064
          (0, 0, 77, 77),
         16#65#           =>  --  0065
          (0, 0, 78, 78),
         16#66#           =>  --  0066
          (0, 0, 79, 79),
         16#67#           =>  --  0067
          (0, 0, 80, 80),
         16#68#           =>  --  0068
          (0, 0, 81, 81),
         16#69#           =>  --  0069
          (0, 0, 82, 82),
         16#6A#           =>  --  006A
          (0, 0, 83, 83),
         16#6B#           =>  --  006B
          (0, 0, 84, 84),
         16#6C#           =>  --  006C
          (3, 4, 85, 85),
         16#6D#           =>  --  006D
          (0, 0, 88, 88),
         16#6E#           =>  --  006E
          (0, 0, 89, 89),
         16#6F#           =>  --  006F
          (0, 0, 90, 90),
         16#70#           =>  --  0070
          (0, 0, 91, 91),
         16#71#           =>  --  0071
          (0, 0, 92, 92),
         16#72#           =>  --  0072
          (0, 0, 93, 93),
         16#73#           =>  --  0073
          (0, 0, 94, 94),
         16#74#           =>  --  0074
          (0, 0, 95, 95),
         16#75#           =>  --  0075
          (0, 0, 96, 96),
         16#76#           =>  --  0076
          (0, 0, 97, 97),
         16#77#           =>  --  0077
          (0, 0, 98, 98),
         16#78#           =>  --  0078
          (0, 0, 99, 99),
         16#79#           =>  --  0079
          (0, 0, 100, 100),
         16#7A#           =>  --  007A
          (0, 0, 101, 101),
         16#7B#           =>  --  007B
          (0, 0, 102, 102),
         16#7C#           =>  --  007C
          (0, 0, 103, 103),
         16#7D#           =>  --  007D
          (0, 0, 104, 104),
         16#7E#           =>  --  007E
          (0, 0, 105, 105),
         16#85#           =>  --  0085
          (0, 0, 106, 106),
         16#A0#           =>  --  00A0
          (0, 0, 107, 107),
         16#A1#           =>  --  00A1
          (0, 0, 108, 108),
         16#A2#           =>  --  00A2
          (0, 0, 109, 109),
         16#A3#           =>  --  00A3
          (0, 0, 110, 110),
         16#A4#           =>  --  00A4
          (0, 0, 111, 111),
         16#A5#           =>  --  00A5
          (0, 0, 112, 112),
         16#A6#           =>  --  00A6
          (0, 0, 113, 113),
         16#A7#           =>  --  00A7
          (0, 0, 114, 114),
         16#A8#           =>  --  00A8
          (0, 0, 115, 115),
         16#A9#           =>  --  00A9
          (0, 0, 116, 116),
         16#AA#           =>  --  00AA
          (0, 0, 117, 117),
         16#AB#           =>  --  00AB
          (0, 0, 118, 118),
         16#AC#           =>  --  00AC
          (0, 0, 119, 119),
         16#AE#           =>  --  00AE
          (0, 0, 120, 120),
         16#AF#           =>  --  00AF
          (0, 0, 121, 121),
         16#B0#           =>  --  00B0
          (0, 0, 122, 122),
         16#B1#           =>  --  00B1
          (0, 0, 123, 123),
         16#B2#           =>  --  00B2
          (0, 0, 124, 124),
         16#B3#           =>  --  00B3
          (0, 0, 125, 125),
         16#B4#           =>  --  00B4
          (0, 0, 126, 126),
         16#B5#           =>  --  00B5
          (0, 0, 127, 127),
         16#B6#           =>  --  00B6
          (0, 0, 128, 128),
         16#B7#           =>  --  00B7
          (0, 0, 129, 129),
         16#B8#           =>  --  00B8
          (0, 0, 130, 130),
         16#B9#           =>  --  00B9
          (0, 0, 131, 131),
         16#BA#           =>  --  00BA
          (0, 0, 132, 132),
         16#BB#           =>  --  00BB
          (0, 0, 133, 133),
         16#BC#           =>  --  00BC
          (0, 0, 134, 136),
         16#BD#           =>  --  00BD
          (0, 0, 137, 139),
         16#BE#           =>  --  00BE
          (0, 0, 140, 142),
         16#BF#           =>  --  00BF
          (0, 0, 143, 143),
         16#C0#           =>  --  00C0
          (0, 0, 144, 145),
         16#C1#           =>  --  00C1
          (0, 0, 146, 147),
         16#C2#           =>  --  00C2
          (0, 0, 148, 149),
         16#C3#           =>  --  00C3
          (0, 0, 150, 151),
         16#C4#           =>  --  00C4
          (0, 0, 152, 153),
         16#C5#           =>  --  00C5
          (0, 0, 154, 155),
         16#C6#           =>  --  00C6
          (0, 0, 156, 158),
         16#C7#           =>  --  00C7
          (0, 0, 159, 160),
         16#C8#           =>  --  00C8
          (0, 0, 161, 162),
         16#C9#           =>  --  00C9
          (0, 0, 163, 164),
         16#CA#           =>  --  00CA
          (0, 0, 165, 166),
         16#CB#           =>  --  00CB
          (0, 0, 167, 168),
         16#CC#           =>  --  00CC
          (0, 0, 169, 170),
         16#CD#           =>  --  00CD
          (0, 0, 171, 172),
         16#CE#           =>  --  00CE
          (0, 0, 173, 174),
         16#CF#           =>  --  00CF
          (0, 0, 175, 176),
         16#D0#           =>  --  00D0
          (0, 0, 177, 178),
         16#D1#           =>  --  00D1
          (0, 0, 179, 180),
         16#D2#           =>  --  00D2
          (0, 0, 181, 182),
         16#D3#           =>  --  00D3
          (0, 0, 183, 184),
         16#D4#           =>  --  00D4
          (0, 0, 185, 186),
         16#D5#           =>  --  00D5
          (0, 0, 187, 188),
         16#D6#           =>  --  00D6
          (0, 0, 189, 190),
         16#D7#           =>  --  00D7
          (0, 0, 191, 191),
         16#D8#           =>  --  00D8
          (0, 0, 192, 193),
         16#D9#           =>  --  00D9
          (0, 0, 194, 195),
         16#DA#           =>  --  00DA
          (0, 0, 196, 197),
         16#DB#           =>  --  00DB
          (0, 0, 198, 199),
         16#DC#           =>  --  00DC
          (0, 0, 200, 201),
         16#DD#           =>  --  00DD
          (0, 0, 202, 203),
         16#DE#           =>  --  00DE
          (0, 0, 204, 204),
         16#DF#           =>  --  00DF
          (0, 0, 205, 207),
         16#E0#           =>  --  00E0
          (0, 0, 208, 209),
         16#E1#           =>  --  00E1
          (0, 0, 210, 211),
         16#E2#           =>  --  00E2
          (0, 0, 212, 213),
         16#E3#           =>  --  00E3
          (0, 0, 214, 215),
         16#E4#           =>  --  00E4
          (0, 0, 216, 217),
         16#E5#           =>  --  00E5
          (0, 0, 218, 219),
         16#E6#           =>  --  00E6
          (0, 0, 220, 222),
         16#E7#           =>  --  00E7
          (0, 0, 223, 224),
         16#E8#           =>  --  00E8
          (0, 0, 225, 226),
         16#E9#           =>  --  00E9
          (0, 0, 227, 228),
         16#EA#           =>  --  00EA
          (0, 0, 229, 230),
         16#EB#           =>  --  00EB
          (0, 0, 231, 232),
         16#EC#           =>  --  00EC
          (0, 0, 233, 234),
         16#ED#           =>  --  00ED
          (0, 0, 235, 236),
         16#EE#           =>  --  00EE
          (0, 0, 237, 238),
         16#EF#           =>  --  00EF
          (0, 0, 239, 240),
         16#F0#           =>  --  00F0
          (0, 0, 241, 242),
         16#F1#           =>  --  00F1
          (0, 0, 243, 244),
         16#F2#           =>  --  00F2
          (0, 0, 245, 246),
         16#F3#           =>  --  00F3
          (0, 0, 247, 248),
         16#F4#           =>  --  00F4
          (0, 0, 249, 250),
         16#F5#           =>  --  00F5
          (0, 0, 251, 252),
         16#F6#           =>  --  00F6
          (0, 0, 253, 254),
         16#F7#           =>  --  00F7
          (0, 0, 255, 255),
         16#F8#           =>  --  00F8
          (0, 0, 256, 257),
         16#F9#           =>  --  00F9
          (0, 0, 258, 259),
         16#FA#           =>  --  00FA
          (0, 0, 260, 261),
         16#FB#           =>  --  00FB
          (0, 0, 262, 263),
         16#FC#           =>  --  00FC
          (0, 0, 264, 265),
         16#FD#           =>  --  00FD
          (0, 0, 266, 267),
         16#FE#           =>  --  00FE
          (0, 0, 268, 268),
         16#FF#           =>  --  00FF
          (0, 0, 269, 270),
         others           =>
          (0, 0, 1, 1));

   Group_0001 : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  0100
          (0, 0, 271, 272),
         16#01#           =>  --  0101
          (0, 0, 273, 274),
         16#02#           =>  --  0102
          (0, 0, 275, 276),
         16#03#           =>  --  0103
          (0, 0, 277, 278),
         16#04#           =>  --  0104
          (0, 0, 279, 280),
         16#05#           =>  --  0105
          (0, 0, 281, 282),
         16#06#           =>  --  0106
          (0, 0, 283, 284),
         16#07#           =>  --  0107
          (0, 0, 285, 286),
         16#08#           =>  --  0108
          (0, 0, 287, 288),
         16#09#           =>  --  0109
          (0, 0, 289, 290),
         16#0A#           =>  --  010A
          (0, 0, 291, 292),
         16#0B#           =>  --  010B
          (0, 0, 293, 294),
         16#0C#           =>  --  010C
          (0, 0, 295, 296),
         16#0D#           =>  --  010D
          (0, 0, 297, 298),
         16#0E#           =>  --  010E
          (0, 0, 299, 300),
         16#0F#           =>  --  010F
          (0, 0, 301, 302),
         16#10#           =>  --  0110
          (0, 0, 303, 304),
         16#11#           =>  --  0111
          (0, 0, 305, 306),
         16#12#           =>  --  0112
          (0, 0, 307, 308),
         16#13#           =>  --  0113
          (0, 0, 309, 310),
         16#14#           =>  --  0114
          (0, 0, 311, 312),
         16#15#           =>  --  0115
          (0, 0, 313, 314),
         16#16#           =>  --  0116
          (0, 0, 315, 316),
         16#17#           =>  --  0117
          (0, 0, 317, 318),
         16#18#           =>  --  0118
          (0, 0, 319, 320),
         16#19#           =>  --  0119
          (0, 0, 321, 322),
         16#1A#           =>  --  011A
          (0, 0, 323, 324),
         16#1B#           =>  --  011B
          (0, 0, 325, 326),
         16#1C#           =>  --  011C
          (0, 0, 327, 328),
         16#1D#           =>  --  011D
          (0, 0, 329, 330),
         16#1E#           =>  --  011E
          (0, 0, 331, 332),
         16#1F#           =>  --  011F
          (0, 0, 333, 334),
         16#20#           =>  --  0120
          (0, 0, 335, 336),
         16#21#           =>  --  0121
          (0, 0, 337, 338),
         16#22#           =>  --  0122
          (0, 0, 339, 340),
         16#23#           =>  --  0123
          (0, 0, 341, 342),
         16#24#           =>  --  0124
          (0, 0, 343, 344),
         16#25#           =>  --  0125
          (0, 0, 345, 346),
         16#26#           =>  --  0126
          (0, 0, 347, 348),
         16#27#           =>  --  0127
          (0, 0, 349, 350),
         16#28#           =>  --  0128
          (0, 0, 351, 352),
         16#29#           =>  --  0129
          (0, 0, 353, 354),
         16#2A#           =>  --  012A
          (0, 0, 355, 356),
         16#2B#           =>  --  012B
          (0, 0, 357, 358),
         16#2C#           =>  --  012C
          (0, 0, 359, 360),
         16#2D#           =>  --  012D
          (0, 0, 361, 362),
         16#2E#           =>  --  012E
          (0, 0, 363, 364),
         16#2F#           =>  --  012F
          (0, 0, 365, 366),
         16#30#           =>  --  0130
          (0, 0, 367, 368),
         16#31#           =>  --  0131
          (0, 0, 369, 369),
         16#32#           =>  --  0132
          (0, 0, 370, 371),
         16#33#           =>  --  0133
          (0, 0, 372, 373),
         16#34#           =>  --  0134
          (0, 0, 374, 375),
         16#35#           =>  --  0135
          (0, 0, 376, 377),
         16#36#           =>  --  0136
          (0, 0, 378, 379),
         16#37#           =>  --  0137
          (0, 0, 380, 381),
         16#38#           =>  --  0138
          (0, 0, 382, 382),
         16#39#           =>  --  0139
          (0, 0, 383, 384),
         16#3A#           =>  --  013A
          (0, 0, 385, 386),
         16#3B#           =>  --  013B
          (0, 0, 387, 388),
         16#3C#           =>  --  013C
          (0, 0, 389, 390),
         16#3D#           =>  --  013D
          (0, 0, 391, 392),
         16#3E#           =>  --  013E
          (0, 0, 393, 394),
         16#3F#           =>  --  013F
          (0, 0, 52, 53),
         16#40#           =>  --  0140
          (0, 0, 86, 87),
         16#41#           =>  --  0141
          (0, 0, 395, 396),
         16#42#           =>  --  0142
          (0, 0, 397, 398),
         16#43#           =>  --  0143
          (0, 0, 399, 400),
         16#44#           =>  --  0144
          (0, 0, 401, 402),
         16#45#           =>  --  0145
          (0, 0, 403, 404),
         16#46#           =>  --  0146
          (0, 0, 405, 406),
         16#47#           =>  --  0147
          (0, 0, 407, 408),
         16#48#           =>  --  0148
          (0, 0, 409, 410),
         16#49#           =>  --  0149
          (0, 0, 411, 412),
         16#4A#           =>  --  014A
          (0, 0, 413, 413),
         16#4B#           =>  --  014B
          (0, 0, 414, 414),
         16#4C#           =>  --  014C
          (0, 0, 415, 416),
         16#4D#           =>  --  014D
          (0, 0, 417, 418),
         16#4E#           =>  --  014E
          (0, 0, 419, 420),
         16#4F#           =>  --  014F
          (0, 0, 421, 422),
         16#50#           =>  --  0150
          (0, 0, 423, 424),
         16#51#           =>  --  0151
          (0, 0, 425, 426),
         16#52#           =>  --  0152
          (0, 0, 427, 429),
         16#53#           =>  --  0153
          (0, 0, 430, 432),
         16#54#           =>  --  0154
          (0, 0, 433, 434),
         16#55#           =>  --  0155
          (0, 0, 435, 436),
         16#56#           =>  --  0156
          (0, 0, 437, 438),
         16#57#           =>  --  0157
          (0, 0, 439, 440),
         16#58#           =>  --  0158
          (0, 0, 441, 442),
         16#59#           =>  --  0159
          (0, 0, 443, 444),
         16#5A#           =>  --  015A
          (0, 0, 445, 446),
         16#5B#           =>  --  015B
          (0, 0, 447, 448),
         16#5C#           =>  --  015C
          (0, 0, 449, 450),
         16#5D#           =>  --  015D
          (0, 0, 451, 452),
         16#5E#           =>  --  015E
          (0, 0, 453, 454),
         16#5F#           =>  --  015F
          (0, 0, 455, 456),
         16#60#           =>  --  0160
          (0, 0, 457, 458),
         16#61#           =>  --  0161
          (0, 0, 459, 460),
         16#62#           =>  --  0162
          (0, 0, 461, 462),
         16#63#           =>  --  0163
          (0, 0, 463, 464),
         16#64#           =>  --  0164
          (0, 0, 465, 466),
         16#65#           =>  --  0165
          (0, 0, 467, 468),
         16#66#           =>  --  0166
          (0, 0, 469, 469),
         16#67#           =>  --  0167
          (0, 0, 470, 470),
         16#68#           =>  --  0168
          (0, 0, 471, 472),
         16#69#           =>  --  0169
          (0, 0, 473, 474),
         16#6A#           =>  --  016A
          (0, 0, 475, 476),
         16#6B#           =>  --  016B
          (0, 0, 477, 478),
         16#6C#           =>  --  016C
          (0, 0, 479, 480),
         16#6D#           =>  --  016D
          (0, 0, 481, 482),
         16#6E#           =>  --  016E
          (0, 0, 483, 484),
         16#6F#           =>  --  016F
          (0, 0, 485, 486),
         16#70#           =>  --  0170
          (0, 0, 487, 488),
         16#71#           =>  --  0171
          (0, 0, 489, 490),
         16#72#           =>  --  0172
          (0, 0, 491, 492),
         16#73#           =>  --  0173
          (0, 0, 493, 494),
         16#74#           =>  --  0174
          (0, 0, 495, 496),
         16#75#           =>  --  0175
          (0, 0, 497, 498),
         16#76#           =>  --  0176
          (0, 0, 499, 500),
         16#77#           =>  --  0177
          (0, 0, 501, 502),
         16#78#           =>  --  0178
          (0, 0, 503, 504),
         16#79#           =>  --  0179
          (0, 0, 505, 506),
         16#7A#           =>  --  017A
          (0, 0, 507, 508),
         16#7B#           =>  --  017B
          (0, 0, 509, 510),
         16#7C#           =>  --  017C
          (0, 0, 511, 512),
         16#7D#           =>  --  017D
          (0, 0, 513, 514),
         16#7E#           =>  --  017E
          (0, 0, 515, 516),
         16#7F#           =>  --  017F
          (0, 0, 517, 518),
         16#80#           =>  --  0180
          (0, 0, 519, 519),
         16#81#           =>  --  0181
          (0, 0, 520, 520),
         16#82#           =>  --  0182
          (0, 0, 521, 521),
         16#83#           =>  --  0183
          (0, 0, 522, 522),
         16#84#           =>  --  0184
          (0, 0, 523, 523),
         16#85#           =>  --  0185
          (0, 0, 524, 524),
         16#86#           =>  --  0186
          (0, 0, 525, 525),
         16#87#           =>  --  0187
          (0, 0, 526, 526),
         16#88#           =>  --  0188
          (0, 0, 527, 527),
         16#89#           =>  --  0189
          (0, 0, 528, 528),
         16#8A#           =>  --  018A
          (0, 0, 529, 529),
         16#8B#           =>  --  018B
          (0, 0, 530, 530),
         16#8C#           =>  --  018C
          (0, 0, 531, 531),
         16#8D#           =>  --  018D
          (0, 0, 532, 533),
         16#8E#           =>  --  018E
          (0, 0, 534, 534),
         16#8F#           =>  --  018F
          (0, 0, 535, 535),
         16#90#           =>  --  0190
          (0, 0, 536, 536),
         16#91#           =>  --  0191
          (0, 0, 537, 537),
         16#92#           =>  --  0192
          (0, 0, 538, 538),
         16#93#           =>  --  0193
          (0, 0, 539, 539),
         16#94#           =>  --  0194
          (0, 0, 540, 540),
         16#95#           =>  --  0195
          (0, 0, 541, 541),
         16#96#           =>  --  0196
          (0, 0, 542, 542),
         16#97#           =>  --  0197
          (0, 0, 543, 543),
         16#98#           =>  --  0198
          (0, 0, 544, 544),
         16#99#           =>  --  0199
          (0, 0, 545, 545),
         16#9A#           =>  --  019A
          (0, 0, 546, 546),
         16#9B#           =>  --  019B
          (0, 0, 547, 547),
         16#9C#           =>  --  019C
          (0, 0, 548, 548),
         16#9D#           =>  --  019D
          (0, 0, 549, 549),
         16#9E#           =>  --  019E
          (0, 0, 550, 550),
         16#9F#           =>  --  019F
          (0, 0, 551, 551),
         16#A0#           =>  --  01A0
          (0, 0, 552, 553),
         16#A1#           =>  --  01A1
          (0, 0, 554, 555),
         16#A2#           =>  --  01A2
          (0, 0, 556, 556),
         16#A3#           =>  --  01A3
          (0, 0, 557, 557),
         16#A4#           =>  --  01A4
          (0, 0, 558, 558),
         16#A5#           =>  --  01A5
          (0, 0, 559, 559),
         16#A6#           =>  --  01A6
          (0, 0, 560, 560),
         16#A7#           =>  --  01A7
          (0, 0, 561, 561),
         16#A8#           =>  --  01A8
          (0, 0, 562, 562),
         16#A9#           =>  --  01A9
          (0, 0, 563, 563),
         16#AA#           =>  --  01AA
          (0, 0, 564, 564),
         16#AB#           =>  --  01AB
          (0, 0, 565, 565),
         16#AC#           =>  --  01AC
          (0, 0, 566, 566),
         16#AD#           =>  --  01AD
          (0, 0, 567, 567),
         16#AE#           =>  --  01AE
          (0, 0, 568, 568),
         16#AF#           =>  --  01AF
          (0, 0, 569, 570),
         16#B0#           =>  --  01B0
          (0, 0, 571, 572),
         16#B1#           =>  --  01B1
          (0, 0, 573, 573),
         16#B2#           =>  --  01B2
          (0, 0, 574, 574),
         16#B3#           =>  --  01B3
          (0, 0, 575, 575),
         16#B4#           =>  --  01B4
          (0, 0, 576, 576),
         16#B5#           =>  --  01B5
          (0, 0, 577, 577),
         16#B6#           =>  --  01B6
          (0, 0, 578, 578),
         16#B7#           =>  --  01B7
          (0, 0, 579, 579),
         16#B8#           =>  --  01B8
          (0, 0, 580, 580),
         16#B9#           =>  --  01B9
          (0, 0, 581, 581),
         16#BA#           =>  --  01BA
          (0, 0, 582, 582),
         16#BB#           =>  --  01BB
          (0, 0, 583, 583),
         16#BC#           =>  --  01BC
          (0, 0, 584, 584),
         16#BD#           =>  --  01BD
          (0, 0, 585, 585),
         16#BE#           =>  --  01BE
          (0, 0, 586, 587),
         16#BF#           =>  --  01BF
          (0, 0, 588, 588),
         16#C0#           =>  --  01C0
          (0, 0, 589, 589),
         16#C1#           =>  --  01C1
          (0, 0, 590, 590),
         16#C2#           =>  --  01C2
          (0, 0, 591, 591),
         16#C3#           =>  --  01C3
          (0, 0, 592, 592),
         16#C4#           =>  --  01C4
          (0, 0, 593, 595),
         16#C5#           =>  --  01C5
          (0, 0, 596, 598),
         16#C6#           =>  --  01C6
          (0, 0, 599, 601),
         16#C7#           =>  --  01C7
          (0, 0, 602, 603),
         16#C8#           =>  --  01C8
          (0, 0, 604, 605),
         16#C9#           =>  --  01C9
          (0, 0, 606, 607),
         16#CA#           =>  --  01CA
          (0, 0, 608, 609),
         16#CB#           =>  --  01CB
          (0, 0, 610, 611),
         16#CC#           =>  --  01CC
          (0, 0, 612, 613),
         16#CD#           =>  --  01CD
          (0, 0, 614, 615),
         16#CE#           =>  --  01CE
          (0, 0, 616, 617),
         16#CF#           =>  --  01CF
          (0, 0, 618, 619),
         16#D0#           =>  --  01D0
          (0, 0, 620, 621),
         16#D1#           =>  --  01D1
          (0, 0, 622, 623),
         16#D2#           =>  --  01D2
          (0, 0, 624, 625),
         16#D3#           =>  --  01D3
          (0, 0, 626, 627),
         16#D4#           =>  --  01D4
          (0, 0, 628, 629),
         16#D5#           =>  --  01D5
          (0, 0, 630, 632),
         16#D6#           =>  --  01D6
          (0, 0, 633, 635),
         16#D7#           =>  --  01D7
          (0, 0, 636, 638),
         16#D8#           =>  --  01D8
          (0, 0, 639, 641),
         16#D9#           =>  --  01D9
          (0, 0, 642, 644),
         16#DA#           =>  --  01DA
          (0, 0, 645, 647),
         16#DB#           =>  --  01DB
          (0, 0, 648, 650),
         16#DC#           =>  --  01DC
          (0, 0, 651, 653),
         16#DD#           =>  --  01DD
          (0, 0, 654, 654),
         16#DE#           =>  --  01DE
          (0, 0, 655, 657),
         16#DF#           =>  --  01DF
          (0, 0, 658, 660),
         16#E0#           =>  --  01E0
          (0, 0, 661, 663),
         16#E1#           =>  --  01E1
          (0, 0, 664, 666),
         16#E2#           =>  --  01E2
          (0, 0, 667, 670),
         16#E3#           =>  --  01E3
          (0, 0, 671, 674),
         16#E4#           =>  --  01E4
          (0, 0, 675, 675),
         16#E5#           =>  --  01E5
          (0, 0, 676, 676),
         16#E6#           =>  --  01E6
          (0, 0, 677, 678),
         16#E7#           =>  --  01E7
          (0, 0, 679, 680),
         16#E8#           =>  --  01E8
          (0, 0, 681, 682),
         16#E9#           =>  --  01E9
          (0, 0, 683, 684),
         16#EA#           =>  --  01EA
          (0, 0, 685, 686),
         16#EB#           =>  --  01EB
          (0, 0, 687, 688),
         16#EC#           =>  --  01EC
          (0, 0, 689, 691),
         16#ED#           =>  --  01ED
          (0, 0, 692, 694),
         16#EE#           =>  --  01EE
          (0, 0, 695, 696),
         16#EF#           =>  --  01EF
          (0, 0, 697, 698),
         16#F0#           =>  --  01F0
          (0, 0, 699, 700),
         16#F1#           =>  --  01F1
          (0, 0, 593, 594),
         16#F2#           =>  --  01F2
          (0, 0, 596, 597),
         16#F3#           =>  --  01F3
          (0, 0, 599, 600),
         16#F4#           =>  --  01F4
          (0, 0, 701, 702),
         16#F5#           =>  --  01F5
          (0, 0, 703, 704),
         16#F6#           =>  --  01F6
          (0, 0, 705, 705),
         16#F7#           =>  --  01F7
          (0, 0, 706, 706),
         16#F8#           =>  --  01F8
          (0, 0, 707, 708),
         16#F9#           =>  --  01F9
          (0, 0, 709, 710),
         16#FA#           =>  --  01FA
          (0, 0, 711, 713),
         16#FB#           =>  --  01FB
          (0, 0, 714, 716),
         16#FC#           =>  --  01FC
          (0, 0, 717, 720),
         16#FD#           =>  --  01FD
          (0, 0, 721, 724),
         16#FE#           =>  --  01FE
          (0, 0, 725, 727),
         16#FF#           =>  --  01FF
          (0, 0, 728, 730),
         others           =>
          (0, 0, 1, 1));

   Group_0002 : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  0200
          (0, 0, 731, 732),
         16#01#           =>  --  0201
          (0, 0, 733, 734),
         16#02#           =>  --  0202
          (0, 0, 735, 736),
         16#03#           =>  --  0203
          (0, 0, 737, 738),
         16#04#           =>  --  0204
          (0, 0, 739, 740),
         16#05#           =>  --  0205
          (0, 0, 741, 742),
         16#06#           =>  --  0206
          (0, 0, 743, 744),
         16#07#           =>  --  0207
          (0, 0, 745, 746),
         16#08#           =>  --  0208
          (0, 0, 747, 748),
         16#09#           =>  --  0209
          (0, 0, 749, 750),
         16#0A#           =>  --  020A
          (0, 0, 751, 752),
         16#0B#           =>  --  020B
          (0, 0, 753, 754),
         16#0C#           =>  --  020C
          (0, 0, 755, 756),
         16#0D#           =>  --  020D
          (0, 0, 757, 758),
         16#0E#           =>  --  020E
          (0, 0, 759, 760),
         16#0F#           =>  --  020F
          (0, 0, 761, 762),
         16#10#           =>  --  0210
          (0, 0, 763, 764),
         16#11#           =>  --  0211
          (0, 0, 765, 766),
         16#12#           =>  --  0212
          (0, 0, 767, 768),
         16#13#           =>  --  0213
          (0, 0, 769, 770),
         16#14#           =>  --  0214
          (0, 0, 771, 772),
         16#15#           =>  --  0215
          (0, 0, 773, 774),
         16#16#           =>  --  0216
          (0, 0, 775, 776),
         16#17#           =>  --  0217
          (0, 0, 777, 778),
         16#18#           =>  --  0218
          (0, 0, 779, 780),
         16#19#           =>  --  0219
          (0, 0, 781, 782),
         16#1A#           =>  --  021A
          (0, 0, 783, 784),
         16#1B#           =>  --  021B
          (0, 0, 785, 786),
         16#1C#           =>  --  021C
          (0, 0, 787, 787),
         16#1D#           =>  --  021D
          (0, 0, 788, 788),
         16#1E#           =>  --  021E
          (0, 0, 789, 790),
         16#1F#           =>  --  021F
          (0, 0, 791, 792),
         16#20#           =>  --  0220
          (0, 0, 793, 793),
         16#21#           =>  --  0221
          (0, 0, 794, 794),
         16#22#           =>  --  0222
          (0, 0, 795, 795),
         16#23#           =>  --  0223
          (0, 0, 796, 796),
         16#24#           =>  --  0224
          (0, 0, 797, 797),
         16#25#           =>  --  0225
          (0, 0, 798, 798),
         16#26#           =>  --  0226
          (0, 0, 661, 662),
         16#27#           =>  --  0227
          (0, 0, 664, 665),
         16#28#           =>  --  0228
          (0, 0, 799, 800),
         16#29#           =>  --  0229
          (0, 0, 801, 802),
         16#2A#           =>  --  022A
          (0, 0, 803, 805),
         16#2B#           =>  --  022B
          (0, 0, 806, 808),
         16#2C#           =>  --  022C
          (0, 0, 809, 811),
         16#2D#           =>  --  022D
          (0, 0, 812, 814),
         16#2E#           =>  --  022E
          (0, 0, 815, 816),
         16#2F#           =>  --  022F
          (0, 0, 817, 818),
         16#30#           =>  --  0230
          (0, 0, 819, 821),
         16#31#           =>  --  0231
          (0, 0, 822, 824),
         16#32#           =>  --  0232
          (0, 0, 825, 826),
         16#33#           =>  --  0233
          (0, 0, 827, 828),
         16#34#           =>  --  0234
          (0, 0, 829, 829),
         16#35#           =>  --  0235
          (0, 0, 830, 830),
         16#36#           =>  --  0236
          (0, 0, 831, 831),
         16#37#           =>  --  0237
          (0, 0, 832, 832),
         16#38#           =>  --  0238
          (0, 0, 833, 834),
         16#39#           =>  --  0239
          (0, 0, 835, 836),
         16#3A#           =>  --  023A
          (0, 0, 837, 837),
         16#3B#           =>  --  023B
          (0, 0, 838, 838),
         16#3C#           =>  --  023C
          (0, 0, 839, 839),
         16#3D#           =>  --  023D
          (0, 0, 840, 840),
         16#3E#           =>  --  023E
          (0, 0, 841, 841),
         16#3F#           =>  --  023F
          (0, 0, 842, 842),
         16#40#           =>  --  0240
          (0, 0, 843, 843),
         16#41#           =>  --  0241
          (0, 0, 844, 844),
         16#42#           =>  --  0242
          (0, 0, 845, 845),
         16#43#           =>  --  0243
          (0, 0, 846, 846),
         16#44#           =>  --  0244
          (0, 0, 847, 847),
         16#45#           =>  --  0245
          (0, 0, 848, 848),
         16#46#           =>  --  0246
          (0, 0, 849, 849),
         16#47#           =>  --  0247
          (0, 0, 850, 850),
         16#48#           =>  --  0248
          (0, 0, 851, 851),
         16#49#           =>  --  0249
          (0, 0, 852, 852),
         16#4A#           =>  --  024A
          (0, 0, 853, 853),
         16#4B#           =>  --  024B
          (0, 0, 854, 854),
         16#4C#           =>  --  024C
          (0, 0, 855, 855),
         16#4D#           =>  --  024D
          (0, 0, 856, 856),
         16#4E#           =>  --  024E
          (0, 0, 857, 857),
         16#4F#           =>  --  024F
          (0, 0, 858, 858),
         16#50#           =>  --  0250
          (0, 0, 859, 859),
         16#51#           =>  --  0251
          (0, 0, 860, 860),
         16#52#           =>  --  0252
          (0, 0, 861, 861),
         16#53#           =>  --  0253
          (0, 0, 862, 862),
         16#54#           =>  --  0254
          (0, 0, 863, 863),
         16#55#           =>  --  0255
          (0, 0, 864, 864),
         16#56#           =>  --  0256
          (0, 0, 865, 865),
         16#57#           =>  --  0257
          (0, 0, 866, 866),
         16#58#           =>  --  0258
          (0, 0, 867, 867),
         16#59#           =>  --  0259
          (0, 0, 868, 868),
         16#5A#           =>  --  025A
          (0, 0, 869, 869),
         16#5B#           =>  --  025B
          (0, 0, 870, 870),
         16#5C#           =>  --  025C
          (0, 0, 871, 871),
         16#5D#           =>  --  025D
          (0, 0, 872, 872),
         16#5E#           =>  --  025E
          (0, 0, 873, 873),
         16#5F#           =>  --  025F
          (0, 0, 874, 874),
         16#60#           =>  --  0260
          (0, 0, 875, 875),
         16#61#           =>  --  0261
          (0, 0, 876, 876),
         16#62#           =>  --  0262
          (0, 0, 877, 877),
         16#63#           =>  --  0263
          (0, 0, 878, 878),
         16#64#           =>  --  0264
          (0, 0, 879, 879),
         16#65#           =>  --  0265
          (0, 0, 880, 880),
         16#66#           =>  --  0266
          (0, 0, 881, 881),
         16#67#           =>  --  0267
          (0, 0, 882, 882),
         16#68#           =>  --  0268
          (0, 0, 883, 883),
         16#69#           =>  --  0269
          (0, 0, 884, 884),
         16#6A#           =>  --  026A
          (0, 0, 885, 885),
         16#6B#           =>  --  026B
          (0, 0, 886, 886),
         16#6C#           =>  --  026C
          (0, 0, 887, 887),
         16#6D#           =>  --  026D
          (0, 0, 888, 888),
         16#6E#           =>  --  026E
          (0, 0, 889, 889),
         16#6F#           =>  --  026F
          (0, 0, 890, 890),
         16#70#           =>  --  0270
          (0, 0, 891, 891),
         16#71#           =>  --  0271
          (0, 0, 892, 892),
         16#72#           =>  --  0272
          (0, 0, 893, 893),
         16#73#           =>  --  0273
          (0, 0, 894, 894),
         16#74#           =>  --  0274
          (0, 0, 895, 895),
         16#75#           =>  --  0275
          (0, 0, 896, 896),
         16#76#           =>  --  0276
          (0, 0, 897, 897),
         16#77#           =>  --  0277
          (0, 0, 898, 898),
         16#78#           =>  --  0278
          (0, 0, 899, 899),
         16#79#           =>  --  0279
          (0, 0, 900, 900),
         16#7A#           =>  --  027A
          (0, 0, 901, 901),
         16#7B#           =>  --  027B
          (0, 0, 902, 902),
         16#7C#           =>  --  027C
          (0, 0, 903, 903),
         16#7D#           =>  --  027D
          (0, 0, 904, 904),
         16#7E#           =>  --  027E
          (0, 0, 905, 905),
         16#7F#           =>  --  027F
          (0, 0, 906, 906),
         16#80#           =>  --  0280
          (0, 0, 907, 907),
         16#81#           =>  --  0281
          (0, 0, 908, 908),
         16#82#           =>  --  0282
          (0, 0, 909, 909),
         16#83#           =>  --  0283
          (0, 0, 910, 910),
         16#84#           =>  --  0284
          (0, 0, 911, 911),
         16#85#           =>  --  0285
          (0, 0, 912, 912),
         16#86#           =>  --  0286
          (0, 0, 913, 913),
         16#87#           =>  --  0287
          (0, 0, 914, 914),
         16#88#           =>  --  0288
          (0, 0, 915, 915),
         16#89#           =>  --  0289
          (0, 0, 916, 916),
         16#8A#           =>  --  028A
          (0, 0, 917, 917),
         16#8B#           =>  --  028B
          (0, 0, 918, 918),
         16#8C#           =>  --  028C
          (0, 0, 919, 919),
         16#8D#           =>  --  028D
          (0, 0, 920, 920),
         16#8E#           =>  --  028E
          (0, 0, 921, 921),
         16#8F#           =>  --  028F
          (0, 0, 922, 922),
         16#90#           =>  --  0290
          (0, 0, 923, 923),
         16#91#           =>  --  0291
          (0, 0, 924, 924),
         16#92#           =>  --  0292
          (0, 0, 697, 697),
         16#93#           =>  --  0293
          (0, 0, 925, 925),
         16#94#           =>  --  0294
          (0, 0, 926, 926),
         16#95#           =>  --  0295
          (0, 0, 927, 927),
         16#96#           =>  --  0296
          (0, 0, 928, 928),
         16#97#           =>  --  0297
          (0, 0, 929, 929),
         16#98#           =>  --  0298
          (0, 0, 930, 930),
         16#99#           =>  --  0299
          (0, 0, 931, 931),
         16#9A#           =>  --  029A
          (0, 0, 932, 932),
         16#9B#           =>  --  029B
          (0, 0, 933, 933),
         16#9C#           =>  --  029C
          (0, 0, 934, 934),
         16#9D#           =>  --  029D
          (0, 0, 935, 935),
         16#9E#           =>  --  029E
          (0, 0, 936, 936),
         16#9F#           =>  --  029F
          (0, 0, 937, 937),
         16#A0#           =>  --  02A0
          (0, 0, 938, 938),
         16#A1#           =>  --  02A1
          (0, 0, 939, 939),
         16#A2#           =>  --  02A2
          (0, 0, 940, 940),
         16#A3#           =>  --  02A3
          (0, 0, 599, 600),
         16#A4#           =>  --  02A4
          (0, 0, 941, 942),
         16#A5#           =>  --  02A5
          (0, 0, 943, 944),
         16#A6#           =>  --  02A6
          (0, 0, 586, 587),
         16#A7#           =>  --  02A7
          (0, 0, 945, 946),
         16#A8#           =>  --  02A8
          (0, 0, 947, 948),
         16#A9#           =>  --  02A9
          (0, 0, 949, 950),
         16#AA#           =>  --  02AA
          (0, 0, 951, 952),
         16#AB#           =>  --  02AB
          (0, 0, 953, 954),
         16#AC#           =>  --  02AC
          (0, 0, 955, 955),
         16#AD#           =>  --  02AD
          (0, 0, 956, 956),
         16#AE#           =>  --  02AE
          (0, 0, 957, 957),
         16#AF#           =>  --  02AF
          (0, 0, 958, 958),
         16#B0#           =>  --  02B0
          (0, 0, 959, 959),
         16#B1#           =>  --  02B1
          (0, 0, 960, 960),
         16#B2#           =>  --  02B2
          (0, 0, 961, 961),
         16#B3#           =>  --  02B3
          (0, 0, 962, 962),
         16#B4#           =>  --  02B4
          (0, 0, 963, 963),
         16#B5#           =>  --  02B5
          (0, 0, 964, 964),
         16#B6#           =>  --  02B6
          (0, 0, 965, 965),
         16#B7#           =>  --  02B7
          (0, 0, 966, 966),
         16#B8#           =>  --  02B8
          (0, 0, 967, 967),
         16#B9#           =>  --  02B9
          (0, 0, 968, 968),
         16#BA#           =>  --  02BA
          (0, 0, 969, 969),
         16#BB#           =>  --  02BB
          (0, 0, 970, 970),
         16#BC#           =>  --  02BC
          (0, 0, 971, 971),
         16#BD#           =>  --  02BD
          (0, 0, 972, 972),
         16#BE#           =>  --  02BE
          (0, 0, 973, 973),
         16#BF#           =>  --  02BF
          (0, 0, 974, 974),
         16#C0#           =>  --  02C0
          (0, 0, 975, 975),
         16#C1#           =>  --  02C1
          (0, 0, 976, 976),
         16#C2#           =>  --  02C2
          (0, 0, 977, 977),
         16#C3#           =>  --  02C3
          (0, 0, 978, 978),
         16#C4#           =>  --  02C4
          (0, 0, 979, 979),
         16#C5#           =>  --  02C5
          (0, 0, 980, 980),
         16#C6#           =>  --  02C6
          (0, 0, 981, 981),
         16#C7#           =>  --  02C7
          (0, 0, 982, 982),
         16#C8#           =>  --  02C8
          (0, 0, 983, 983),
         16#C9#           =>  --  02C9
          (0, 0, 984, 984),
         16#CA#           =>  --  02CA
          (0, 0, 985, 985),
         16#CB#           =>  --  02CB
          (0, 0, 986, 986),
         16#CC#           =>  --  02CC
          (0, 0, 987, 987),
         16#CD#           =>  --  02CD
          (0, 0, 988, 988),
         16#CE#           =>  --  02CE
          (0, 0, 989, 989),
         16#CF#           =>  --  02CF
          (0, 0, 990, 990),
         16#D0#           =>  --  02D0
          (0, 0, 991, 991),
         16#D1#           =>  --  02D1
          (0, 0, 992, 992),
         16#D2#           =>  --  02D2
          (0, 0, 993, 993),
         16#D3#           =>  --  02D3
          (0, 0, 994, 994),
         16#D4#           =>  --  02D4
          (0, 0, 995, 995),
         16#D5#           =>  --  02D5
          (0, 0, 996, 996),
         16#D6#           =>  --  02D6
          (0, 0, 997, 997),
         16#D7#           =>  --  02D7
          (0, 0, 998, 998),
         16#D8#           =>  --  02D8
          (0, 0, 999, 999),
         16#D9#           =>  --  02D9
          (0, 0, 1000, 1000),
         16#DA#           =>  --  02DA
          (0, 0, 1001, 1001),
         16#DB#           =>  --  02DB
          (0, 0, 1002, 1002),
         16#DC#           =>  --  02DC
          (0, 0, 1003, 1003),
         16#DD#           =>  --  02DD
          (0, 0, 1004, 1004),
         16#DE#           =>  --  02DE
          (0, 0, 1005, 1005),
         16#DF#           =>  --  02DF
          (0, 0, 1006, 1006),
         16#E0#           =>  --  02E0
          (0, 0, 1007, 1007),
         16#E1#           =>  --  02E1
          (0, 0, 1008, 1008),
         16#E2#           =>  --  02E2
          (0, 0, 1009, 1009),
         16#E3#           =>  --  02E3
          (0, 0, 1010, 1010),
         16#E4#           =>  --  02E4
          (0, 0, 1011, 1011),
         16#E5#           =>  --  02E5
          (0, 0, 1012, 1012),
         16#E6#           =>  --  02E6
          (0, 0, 1013, 1013),
         16#E7#           =>  --  02E7
          (0, 0, 1014, 1014),
         16#E8#           =>  --  02E8
          (0, 0, 1015, 1015),
         16#E9#           =>  --  02E9
          (0, 0, 1016, 1016),
         16#EA#           =>  --  02EA
          (0, 0, 1017, 1017),
         16#EB#           =>  --  02EB
          (0, 0, 1018, 1018),
         16#EC#           =>  --  02EC
          (0, 0, 1019, 1019),
         16#ED#           =>  --  02ED
          (0, 0, 1020, 1020),
         16#EE#           =>  --  02EE
          (0, 0, 1021, 1021),
         16#EF#           =>  --  02EF
          (0, 0, 1022, 1022),
         16#F0#           =>  --  02F0
          (0, 0, 1023, 1023),
         16#F1#           =>  --  02F1
          (0, 0, 1024, 1024),
         16#F2#           =>  --  02F2
          (0, 0, 1025, 1025),
         16#F3#           =>  --  02F3
          (0, 0, 1026, 1026),
         16#F4#           =>  --  02F4
          (0, 0, 1027, 1027),
         16#F5#           =>  --  02F5
          (0, 0, 1028, 1028),
         16#F6#           =>  --  02F6
          (0, 0, 1029, 1029),
         16#F7#           =>  --  02F7
          (0, 0, 1030, 1030),
         16#F8#           =>  --  02F8
          (0, 0, 1031, 1031),
         16#F9#           =>  --  02F9
          (0, 0, 1032, 1032),
         16#FA#           =>  --  02FA
          (0, 0, 1033, 1033),
         16#FB#           =>  --  02FB
          (0, 0, 1034, 1034),
         16#FC#           =>  --  02FC
          (0, 0, 1035, 1035),
         16#FD#           =>  --  02FD
          (0, 0, 1036, 1036),
         16#FE#           =>  --  02FE
          (0, 0, 1037, 1037),
         16#FF#           =>  --  02FF
          (0, 0, 1038, 1038),
         others           =>
          (0, 0, 1, 1));

   Group_0003 : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  0300
          (0, 0, 145, 145),
         16#01#           =>  --  0301
          (0, 0, 147, 147),
         16#02#           =>  --  0302
          (0, 0, 149, 149),
         16#03#           =>  --  0303
          (0, 0, 151, 151),
         16#04#           =>  --  0304
          (0, 0, 272, 272),
         16#05#           =>  --  0305
          (0, 0, 1039, 1039),
         16#06#           =>  --  0306
          (0, 0, 276, 276),
         16#07#           =>  --  0307
          (0, 0, 292, 292),
         16#08#           =>  --  0308
          (0, 0, 153, 153),
         16#09#           =>  --  0309
          (0, 0, 1040, 1040),
         16#0A#           =>  --  030A
          (0, 0, 155, 155),
         16#0B#           =>  --  030B
          (0, 0, 424, 424),
         16#0C#           =>  --  030C
          (0, 0, 296, 296),
         16#0D# .. 16#0E# =>  --  030D .. 030E
          (0, 0, 1041, 1041),
         16#0F#           =>  --  030F
          (0, 0, 732, 732),
         16#10#           =>  --  0310
          (0, 0, 1042, 1042),
         16#11#           =>  --  0311
          (0, 0, 736, 736),
         16#12#           =>  --  0312
          (0, 0, 1041, 1041),
         16#13#           =>  --  0313
          (0, 0, 1043, 1043),
         16#14#           =>  --  0314
          (0, 0, 1044, 1044),
         16#15#           =>  --  0315
          (0, 0, 1041, 1041),
         16#1A#           =>  --  031A
          (0, 0, 1041, 1041),
         16#1B#           =>  --  031B
          (0, 0, 553, 553),
         16#21#           =>  --  0321
          (0, 0, 1046, 1046),
         16#22#           =>  --  0322
          (0, 0, 1047, 1047),
         16#23#           =>  --  0323
          (0, 0, 1048, 1048),
         16#24#           =>  --  0324
          (0, 0, 1049, 1049),
         16#25#           =>  --  0325
          (0, 0, 1050, 1050),
         16#26#           =>  --  0326
          (0, 0, 780, 780),
         16#27#           =>  --  0327
          (0, 0, 160, 160),
         16#28#           =>  --  0328
          (0, 0, 280, 280),
         16#2D#           =>  --  032D
          (0, 0, 1051, 1051),
         16#2E#           =>  --  032E
          (0, 0, 1052, 1052),
         16#30#           =>  --  0330
          (0, 0, 1053, 1053),
         16#31#           =>  --  0331
          (0, 0, 1054, 1054),
         16#32#           =>  --  0332
          (0, 0, 1055, 1055),
         16#34#           =>  --  0334
          (0, 0, 1056, 1056),
         16#35#           =>  --  0335
          (0, 0, 304, 304),
         16#36# .. 16#37# =>  --  0336 .. 0337
          (0, 0, 1057, 1057),
         16#38#           =>  --  0338
          (0, 0, 193, 193),
         16#39#           =>  --  0339
          (0, 0, 1058, 1058),
         16#3D# .. 16#3F# =>  --  033D .. 033F
          (0, 0, 1041, 1041),
         16#40#           =>  --  0340
          (0, 0, 145, 145),
         16#41#           =>  --  0341
          (0, 0, 147, 147),
         16#42#           =>  --  0342
          (0, 0, 1059, 1059),
         16#43#           =>  --  0343
          (0, 0, 1043, 1043),
         16#44#           =>  --  0344
          (0, 0, 637, 638),
         16#45#           =>  --  0345
          (0, 0, 1060, 1060),
         16#46#           =>  --  0346
          (0, 0, 1041, 1041),
         16#4A# .. 16#4C# =>  --  034A .. 034C
          (0, 0, 1041, 1041),
         16#4F#           =>  --  034F
          (0, 0, 1, 1),
         16#50# .. 16#52# =>  --  0350 .. 0352
          (0, 0, 1041, 1041),
         16#57#           =>  --  0357
          (0, 0, 1041, 1041),
         16#58#           =>  --  0358
          (0, 0, 1061, 1061),
         16#5B#           =>  --  035B
          (0, 0, 1041, 1041),
         16#5D# .. 16#5E# =>  --  035D .. 035E
          (0, 0, 1041, 1041),
         16#60#           =>  --  0360
          (0, 0, 1062, 1062),
         16#61#           =>  --  0361
          (0, 0, 1063, 1063),
         16#63#           =>  --  0363
          (0, 0, 220, 220),
         16#64#           =>  --  0364
          (0, 0, 222, 222),
         16#65#           =>  --  0365
          (0, 0, 372, 372),
         16#66#           =>  --  0366
          (0, 0, 430, 430),
         16#67#           =>  --  0367
          (0, 0, 1064, 1064),
         16#68#           =>  --  0368
          (0, 0, 1065, 1065),
         16#69#           =>  --  0369
          (0, 0, 241, 241),
         16#6A#           =>  --  036A
          (0, 0, 1066, 1066),
         16#6B#           =>  --  036B
          (0, 0, 1067, 1067),
         16#6C#           =>  --  036C
          (0, 0, 1068, 1068),
         16#6D#           =>  --  036D
          (0, 0, 586, 586),
         16#6E#           =>  --  036E
          (0, 0, 1069, 1069),
         16#6F#           =>  --  036F
          (0, 0, 1070, 1070),
         16#70#           =>  --  0370
          (0, 0, 1071, 1071),
         16#71#           =>  --  0371
          (0, 0, 1072, 1072),
         16#72#           =>  --  0372
          (0, 0, 1073, 1073),
         16#73#           =>  --  0373
          (0, 0, 1074, 1074),
         16#74#           =>  --  0374
          (0, 0, 968, 968),
         16#75#           =>  --  0375
          (0, 0, 1075, 1075),
         16#76#           =>  --  0376
          (0, 0, 1076, 1076),
         16#77#           =>  --  0377
          (0, 0, 1077, 1077),
         16#78# .. 16#79# =>  --  0378 .. 0379
          (0, 0, 0, 0),
         16#7A#           =>  --  037A
          (0, 0, 1078, 1078),
         16#7B#           =>  --  037B
          (0, 0, 1079, 1079),
         16#7C#           =>  --  037C
          (0, 0, 1080, 1080),
         16#7D#           =>  --  037D
          (0, 0, 1081, 1081),
         16#7E#           =>  --  037E
          (0, 0, 34, 34),
         16#7F#           =>  --  037F
          (0, 0, 1082, 1082),
         16#80# .. 16#83# =>  --  0380 .. 0383
          (0, 0, 0, 0),
         16#84#           =>  --  0384
          (0, 0, 126, 126),
         16#85#           =>  --  0385
          (0, 0, 1083, 1084),
         16#86#           =>  --  0386
          (0, 0, 1085, 1086),
         16#87#           =>  --  0387
          (0, 0, 129, 129),
         16#88#           =>  --  0388
          (0, 0, 1087, 1088),
         16#89#           =>  --  0389
          (0, 0, 1089, 1090),
         16#8A#           =>  --  038A
          (0, 0, 1091, 1092),
         16#8B#           =>  --  038B
          (0, 0, 0, 0),
         16#8C#           =>  --  038C
          (0, 0, 1093, 1094),
         16#8D#           =>  --  038D
          (0, 0, 0, 0),
         16#8E#           =>  --  038E
          (0, 0, 1095, 1096),
         16#8F#           =>  --  038F
          (0, 0, 1097, 1098),
         16#90#           =>  --  0390
          (0, 0, 1099, 1101),
         16#91#           =>  --  0391
          (0, 0, 1085, 1085),
         16#92#           =>  --  0392
          (0, 0, 1102, 1102),
         16#93#           =>  --  0393
          (0, 0, 1103, 1103),
         16#94#           =>  --  0394
          (0, 0, 1104, 1104),
         16#95#           =>  --  0395
          (0, 0, 1087, 1087),
         16#96#           =>  --  0396
          (0, 0, 1105, 1105),
         16#97#           =>  --  0397
          (0, 0, 1089, 1089),
         16#98#           =>  --  0398
          (0, 0, 1106, 1106),
         16#99#           =>  --  0399
          (0, 0, 1091, 1091),
         16#9A#           =>  --  039A
          (0, 0, 1107, 1107),
         16#9B#           =>  --  039B
          (0, 0, 1108, 1108),
         16#9C#           =>  --  039C
          (0, 0, 1109, 1109),
         16#9D#           =>  --  039D
          (0, 0, 1110, 1110),
         16#9E#           =>  --  039E
          (0, 0, 1111, 1111),
         16#9F#           =>  --  039F
          (0, 0, 1093, 1093),
         16#A0#           =>  --  03A0
          (0, 0, 1112, 1112),
         16#A1#           =>  --  03A1
          (0, 0, 1113, 1113),
         16#A2#           =>  --  03A2
          (0, 0, 0, 0),
         16#A3#           =>  --  03A3
          (0, 0, 1114, 1114),
         16#A4#           =>  --  03A4
          (0, 0, 1115, 1115),
         16#A5#           =>  --  03A5
          (0, 0, 1095, 1095),
         16#A6#           =>  --  03A6
          (0, 0, 1116, 1116),
         16#A7#           =>  --  03A7
          (0, 0, 1117, 1117),
         16#A8#           =>  --  03A8
          (0, 0, 1118, 1118),
         16#A9#           =>  --  03A9
          (0, 0, 1097, 1097),
         16#AA#           =>  --  03AA
          (0, 0, 1119, 1120),
         16#AB#           =>  --  03AB
          (0, 0, 1121, 1122),
         16#AC#           =>  --  03AC
          (0, 0, 1123, 1124),
         16#AD#           =>  --  03AD
          (0, 0, 1125, 1126),
         16#AE#           =>  --  03AE
          (0, 0, 1127, 1128),
         16#AF#           =>  --  03AF
          (0, 0, 1129, 1130),
         16#B0#           =>  --  03B0
          (0, 0, 1131, 1133),
         16#B1#           =>  --  03B1
          (0, 0, 1123, 1123),
         16#B2#           =>  --  03B2
          (0, 0, 1134, 1134),
         16#B3#           =>  --  03B3
          (0, 0, 1135, 1135),
         16#B4#           =>  --  03B4
          (0, 0, 1136, 1136),
         16#B5#           =>  --  03B5
          (0, 0, 1125, 1125),
         16#B6#           =>  --  03B6
          (0, 0, 1137, 1137),
         16#B7#           =>  --  03B7
          (0, 0, 1127, 1127),
         16#B8#           =>  --  03B8
          (0, 0, 1138, 1138),
         16#B9#           =>  --  03B9
          (0, 0, 1099, 1099),
         16#BA#           =>  --  03BA
          (0, 0, 1139, 1139),
         16#BB#           =>  --  03BB
          (0, 0, 1140, 1140),
         16#BC#           =>  --  03BC
          (0, 0, 1141, 1141),
         16#BD#           =>  --  03BD
          (0, 0, 1142, 1142),
         16#BE#           =>  --  03BE
          (0, 0, 1143, 1143),
         16#BF#           =>  --  03BF
          (0, 0, 1144, 1144),
         16#C0#           =>  --  03C0
          (0, 0, 1145, 1145),
         16#C1#           =>  --  03C1
          (0, 0, 1146, 1146),
         16#C2#           =>  --  03C2
          (0, 0, 1147, 1147),
         16#C3#           =>  --  03C3
          (0, 0, 1148, 1148),
         16#C4#           =>  --  03C4
          (0, 0, 1149, 1149),
         16#C5#           =>  --  03C5
          (0, 0, 1131, 1131),
         16#C6#           =>  --  03C6
          (0, 0, 1150, 1150),
         16#C7#           =>  --  03C7
          (0, 0, 1151, 1151),
         16#C8#           =>  --  03C8
          (0, 0, 1152, 1152),
         16#C9#           =>  --  03C9
          (0, 0, 1153, 1153),
         16#CA#           =>  --  03CA
          (0, 0, 1099, 1100),
         16#CB#           =>  --  03CB
          (0, 0, 1131, 1132),
         16#CC#           =>  --  03CC
          (0, 0, 1154, 1155),
         16#CD#           =>  --  03CD
          (0, 0, 1156, 1157),
         16#CE#           =>  --  03CE
          (0, 0, 1158, 1159),
         16#CF#           =>  --  03CF
          (0, 0, 1160, 1162),
         16#D0#           =>  --  03D0
          (0, 0, 1163, 1163),
         16#D1#           =>  --  03D1
          (0, 0, 1164, 1164),
         16#D2#           =>  --  03D2
          (0, 0, 1165, 1165),
         16#D3#           =>  --  03D3
          (0, 0, 1166, 1167),
         16#D4#           =>  --  03D4
          (0, 0, 1168, 1169),
         16#D5#           =>  --  03D5
          (0, 0, 1170, 1170),
         16#D6#           =>  --  03D6
          (0, 0, 1171, 1171),
         16#D7#           =>  --  03D7
          (0, 0, 1172, 1174),
         16#D8#           =>  --  03D8
          (0, 0, 1175, 1175),
         16#D9#           =>  --  03D9
          (0, 0, 1176, 1176),
         16#DA#           =>  --  03DA
          (0, 0, 1177, 1177),
         16#DB#           =>  --  03DB
          (0, 0, 1178, 1178),
         16#DC#           =>  --  03DC
          (0, 0, 1179, 1179),
         16#DD#           =>  --  03DD
          (0, 0, 1180, 1180),
         16#DE#           =>  --  03DE
          (0, 0, 1181, 1181),
         16#DF#           =>  --  03DF
          (0, 0, 1182, 1182),
         16#E0#           =>  --  03E0
          (0, 0, 1183, 1183),
         16#E1#           =>  --  03E1
          (0, 0, 1184, 1184),
         16#E2#           =>  --  03E2
          (0, 0, 1185, 1185),
         16#E3#           =>  --  03E3
          (0, 0, 1186, 1186),
         16#E4#           =>  --  03E4
          (0, 0, 1187, 1187),
         16#E5#           =>  --  03E5
          (0, 0, 1188, 1188),
         16#E6#           =>  --  03E6
          (0, 0, 1189, 1189),
         16#E7#           =>  --  03E7
          (0, 0, 1190, 1190),
         16#E8#           =>  --  03E8
          (0, 0, 1191, 1191),
         16#E9#           =>  --  03E9
          (0, 0, 1192, 1192),
         16#EA#           =>  --  03EA
          (0, 0, 1193, 1193),
         16#EB#           =>  --  03EB
          (0, 0, 1194, 1194),
         16#EC#           =>  --  03EC
          (0, 0, 1195, 1195),
         16#ED#           =>  --  03ED
          (0, 0, 1196, 1196),
         16#EE#           =>  --  03EE
          (0, 0, 1197, 1197),
         16#EF#           =>  --  03EF
          (0, 0, 1198, 1198),
         16#F0#           =>  --  03F0
          (0, 0, 1172, 1172),
         16#F1#           =>  --  03F1
          (0, 0, 1199, 1199),
         16#F2#           =>  --  03F2
          (0, 0, 1200, 1200),
         16#F3#           =>  --  03F3
          (0, 0, 1201, 1201),
         16#F4#           =>  --  03F4
          (0, 0, 1202, 1202),
         16#F5#           =>  --  03F5
          (0, 0, 1203, 1203),
         16#F6#           =>  --  03F6
          (0, 0, 1204, 1204),
         16#F7#           =>  --  03F7
          (0, 0, 1205, 1205),
         16#F8#           =>  --  03F8
          (0, 0, 1206, 1206),
         16#F9#           =>  --  03F9
          (0, 0, 1207, 1207),
         16#FA#           =>  --  03FA
          (0, 0, 1208, 1208),
         16#FB#           =>  --  03FB
          (0, 0, 1209, 1209),
         16#FC#           =>  --  03FC
          (0, 0, 1210, 1210),
         16#FD#           =>  --  03FD
          (0, 0, 1211, 1211),
         16#FE#           =>  --  03FE
          (0, 0, 1212, 1212),
         16#FF#           =>  --  03FF
          (0, 0, 1213, 1213),
         others           =>
          (0, 0, 1045, 1045));

   Group_0004 : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  0400
          (0, 0, 1214, 1215),
         16#01#           =>  --  0401
          (0, 0, 1216, 1217),
         16#02#           =>  --  0402
          (0, 0, 1218, 1218),
         16#03#           =>  --  0403
          (0, 0, 1219, 1220),
         16#04#           =>  --  0404
          (0, 0, 1221, 1221),
         16#05#           =>  --  0405
          (0, 0, 1222, 1222),
         16#06#           =>  --  0406
          (0, 0, 1223, 1223),
         16#07#           =>  --  0407
          (0, 0, 1224, 1225),
         16#08#           =>  --  0408
          (0, 0, 1226, 1226),
         16#09#           =>  --  0409
          (0, 0, 1227, 1227),
         16#0A#           =>  --  040A
          (0, 0, 1228, 1228),
         16#0B#           =>  --  040B
          (0, 0, 1229, 1229),
         16#0C#           =>  --  040C
          (0, 0, 1230, 1231),
         16#0D#           =>  --  040D
          (0, 0, 1232, 1233),
         16#0E#           =>  --  040E
          (0, 0, 1234, 1235),
         16#0F#           =>  --  040F
          (0, 0, 1236, 1236),
         16#10#           =>  --  0410
          (0, 0, 1237, 1237),
         16#11#           =>  --  0411
          (0, 0, 1238, 1238),
         16#12#           =>  --  0412
          (0, 0, 1239, 1239),
         16#13#           =>  --  0413
          (0, 0, 1219, 1219),
         16#14#           =>  --  0414
          (0, 0, 1240, 1240),
         16#15#           =>  --  0415
          (0, 0, 1214, 1214),
         16#16#           =>  --  0416
          (0, 0, 1241, 1241),
         16#17#           =>  --  0417
          (0, 0, 1242, 1242),
         16#18#           =>  --  0418
          (5, 5, 1232, 1232),
         16#19#           =>  --  0419
          (0, 0, 1243, 1243),
         16#1A#           =>  --  041A
          (0, 0, 1230, 1230),
         16#1B#           =>  --  041B
          (0, 0, 1244, 1244),
         16#1C#           =>  --  041C
          (0, 0, 1245, 1245),
         16#1D#           =>  --  041D
          (0, 0, 1246, 1246),
         16#1E#           =>  --  041E
          (0, 0, 1247, 1247),
         16#1F#           =>  --  041F
          (0, 0, 1248, 1248),
         16#20#           =>  --  0420
          (0, 0, 1249, 1249),
         16#21#           =>  --  0421
          (0, 0, 1250, 1250),
         16#22#           =>  --  0422
          (0, 0, 1251, 1251),
         16#23#           =>  --  0423
          (0, 0, 1234, 1234),
         16#24#           =>  --  0424
          (0, 0, 1252, 1252),
         16#25#           =>  --  0425
          (0, 0, 1253, 1253),
         16#26#           =>  --  0426
          (0, 0, 1254, 1254),
         16#27#           =>  --  0427
          (0, 0, 1255, 1255),
         16#28#           =>  --  0428
          (0, 0, 1256, 1256),
         16#29#           =>  --  0429
          (0, 0, 1257, 1257),
         16#2A#           =>  --  042A
          (0, 0, 1258, 1258),
         16#2B#           =>  --  042B
          (0, 0, 1259, 1259),
         16#2C#           =>  --  042C
          (0, 0, 1260, 1260),
         16#2D#           =>  --  042D
          (0, 0, 1261, 1261),
         16#2E#           =>  --  042E
          (0, 0, 1262, 1262),
         16#2F#           =>  --  042F
          (0, 0, 1263, 1263),
         16#30#           =>  --  0430
          (0, 0, 1264, 1264),
         16#31#           =>  --  0431
          (0, 0, 1265, 1265),
         16#32#           =>  --  0432
          (0, 0, 1266, 1266),
         16#33#           =>  --  0433
          (0, 0, 1267, 1267),
         16#34#           =>  --  0434
          (0, 0, 1268, 1268),
         16#35#           =>  --  0435
          (0, 0, 1269, 1269),
         16#36#           =>  --  0436
          (0, 0, 1270, 1270),
         16#37#           =>  --  0437
          (0, 0, 1271, 1271),
         16#38#           =>  --  0438
          (6, 6, 1272, 1272),
         16#39#           =>  --  0439
          (0, 0, 1273, 1273),
         16#3A#           =>  --  043A
          (0, 0, 1274, 1274),
         16#3B#           =>  --  043B
          (0, 0, 1275, 1275),
         16#3C#           =>  --  043C
          (0, 0, 1276, 1276),
         16#3D#           =>  --  043D
          (0, 0, 1277, 1277),
         16#3E#           =>  --  043E
          (0, 0, 1278, 1278),
         16#3F#           =>  --  043F
          (0, 0, 1279, 1279),
         16#40#           =>  --  0440
          (0, 0, 1280, 1280),
         16#41#           =>  --  0441
          (0, 0, 1281, 1281),
         16#42#           =>  --  0442
          (0, 0, 1282, 1282),
         16#43#           =>  --  0443
          (0, 0, 1283, 1283),
         16#44#           =>  --  0444
          (0, 0, 1284, 1284),
         16#45#           =>  --  0445
          (0, 0, 1285, 1285),
         16#46#           =>  --  0446
          (0, 0, 1286, 1286),
         16#47#           =>  --  0447
          (0, 0, 1287, 1287),
         16#48#           =>  --  0448
          (0, 0, 1288, 1288),
         16#49#           =>  --  0449
          (0, 0, 1289, 1289),
         16#4A#           =>  --  044A
          (0, 0, 1290, 1290),
         16#4B#           =>  --  044B
          (0, 0, 1291, 1291),
         16#4C#           =>  --  044C
          (0, 0, 1292, 1292),
         16#4D#           =>  --  044D
          (0, 0, 1293, 1293),
         16#4E#           =>  --  044E
          (0, 0, 1294, 1294),
         16#4F#           =>  --  044F
          (0, 0, 1295, 1295),
         16#50#           =>  --  0450
          (0, 0, 1296, 1297),
         16#51#           =>  --  0451
          (0, 0, 1298, 1299),
         16#52#           =>  --  0452
          (0, 0, 1300, 1300),
         16#53#           =>  --  0453
          (0, 0, 1301, 1302),
         16#54#           =>  --  0454
          (0, 0, 1303, 1303),
         16#55#           =>  --  0455
          (0, 0, 1304, 1304),
         16#56#           =>  --  0456
          (0, 0, 1305, 1305),
         16#57#           =>  --  0457
          (0, 0, 1306, 1307),
         16#58#           =>  --  0458
          (0, 0, 1308, 1308),
         16#59#           =>  --  0459
          (0, 0, 1309, 1309),
         16#5A#           =>  --  045A
          (0, 0, 1310, 1310),
         16#5B#           =>  --  045B
          (0, 0, 1311, 1311),
         16#5C#           =>  --  045C
          (0, 0, 1312, 1313),
         16#5D#           =>  --  045D
          (0, 0, 1314, 1315),
         16#5E#           =>  --  045E
          (0, 0, 1316, 1317),
         16#5F#           =>  --  045F
          (0, 0, 1318, 1318),
         16#60#           =>  --  0460
          (0, 0, 1319, 1319),
         16#61#           =>  --  0461
          (0, 0, 1320, 1320),
         16#62#           =>  --  0462
          (0, 0, 1321, 1321),
         16#63#           =>  --  0463
          (0, 0, 1322, 1322),
         16#64#           =>  --  0464
          (0, 0, 1323, 1323),
         16#65#           =>  --  0465
          (0, 0, 1324, 1324),
         16#66#           =>  --  0466
          (0, 0, 1325, 1325),
         16#67#           =>  --  0467
          (0, 0, 1326, 1326),
         16#68#           =>  --  0468
          (0, 0, 1327, 1327),
         16#69#           =>  --  0469
          (0, 0, 1328, 1328),
         16#6A#           =>  --  046A
          (0, 0, 1329, 1329),
         16#6B#           =>  --  046B
          (0, 0, 1330, 1330),
         16#6C#           =>  --  046C
          (0, 0, 1331, 1331),
         16#6D#           =>  --  046D
          (0, 0, 1332, 1332),
         16#6E#           =>  --  046E
          (0, 0, 1333, 1333),
         16#6F#           =>  --  046F
          (0, 0, 1334, 1334),
         16#70#           =>  --  0470
          (0, 0, 1335, 1335),
         16#71#           =>  --  0471
          (0, 0, 1336, 1336),
         16#72#           =>  --  0472
          (0, 0, 1337, 1337),
         16#73#           =>  --  0473
          (0, 0, 1338, 1338),
         16#74#           =>  --  0474
          (0, 0, 1339, 1339),
         16#75#           =>  --  0475
          (0, 0, 1340, 1340),
         16#76#           =>  --  0476
          (0, 0, 1341, 1342),
         16#77#           =>  --  0477
          (0, 0, 1343, 1344),
         16#78#           =>  --  0478
          (0, 0, 1345, 1345),
         16#79#           =>  --  0479
          (0, 0, 1346, 1346),
         16#7A#           =>  --  047A
          (0, 0, 1347, 1347),
         16#7B#           =>  --  047B
          (0, 0, 1348, 1348),
         16#7C#           =>  --  047C
          (0, 0, 1349, 1349),
         16#7D#           =>  --  047D
          (0, 0, 1350, 1350),
         16#7E#           =>  --  047E
          (0, 0, 1351, 1351),
         16#7F#           =>  --  047F
          (0, 0, 1352, 1352),
         16#80#           =>  --  0480
          (0, 0, 1353, 1353),
         16#81#           =>  --  0481
          (0, 0, 1354, 1354),
         16#82#           =>  --  0482
          (0, 0, 1355, 1355),
         16#83#           =>  --  0483
          (0, 0, 1356, 1356),
         16#85#           =>  --  0485
          (0, 0, 1044, 1044),
         16#86#           =>  --  0486
          (0, 0, 1043, 1043),
         16#88# .. 16#89# =>  --  0488 .. 0489
          (0, 0, 1, 1),
         16#8A#           =>  --  048A
          (0, 0, 1357, 1357),
         16#8B#           =>  --  048B
          (0, 0, 1358, 1358),
         16#8C#           =>  --  048C
          (0, 0, 1359, 1359),
         16#8D#           =>  --  048D
          (0, 0, 1360, 1360),
         16#8E#           =>  --  048E
          (0, 0, 1361, 1361),
         16#8F#           =>  --  048F
          (0, 0, 1362, 1362),
         16#90#           =>  --  0490
          (0, 0, 1363, 1364),
         16#91#           =>  --  0491
          (0, 0, 1365, 1366),
         16#92#           =>  --  0492
          (0, 0, 1367, 1367),
         16#93#           =>  --  0493
          (0, 0, 1368, 1368),
         16#94#           =>  --  0494
          (0, 0, 1369, 1369),
         16#95#           =>  --  0495
          (0, 0, 1370, 1370),
         16#96#           =>  --  0496
          (0, 0, 1371, 1371),
         16#97#           =>  --  0497
          (0, 0, 1372, 1372),
         16#98#           =>  --  0498
          (0, 0, 1373, 1373),
         16#99#           =>  --  0499
          (0, 0, 1374, 1374),
         16#9A#           =>  --  049A
          (0, 0, 1375, 1375),
         16#9B#           =>  --  049B
          (0, 0, 1376, 1376),
         16#9C#           =>  --  049C
          (0, 0, 1377, 1377),
         16#9D#           =>  --  049D
          (0, 0, 1378, 1378),
         16#9E#           =>  --  049E
          (0, 0, 1379, 1379),
         16#9F#           =>  --  049F
          (0, 0, 1380, 1380),
         16#A0#           =>  --  04A0
          (0, 0, 1381, 1381),
         16#A1#           =>  --  04A1
          (0, 0, 1382, 1382),
         16#A2#           =>  --  04A2
          (0, 0, 1383, 1383),
         16#A3#           =>  --  04A3
          (0, 0, 1384, 1384),
         16#A4#           =>  --  04A4
          (0, 0, 1385, 1385),
         16#A5#           =>  --  04A5
          (0, 0, 1386, 1386),
         16#A6#           =>  --  04A6
          (0, 0, 1387, 1387),
         16#A7#           =>  --  04A7
          (0, 0, 1388, 1388),
         16#A8#           =>  --  04A8
          (0, 0, 1389, 1389),
         16#A9#           =>  --  04A9
          (0, 0, 1390, 1390),
         16#AA#           =>  --  04AA
          (0, 0, 1391, 1391),
         16#AB#           =>  --  04AB
          (0, 0, 1392, 1392),
         16#AC#           =>  --  04AC
          (0, 0, 1393, 1393),
         16#AD#           =>  --  04AD
          (0, 0, 1394, 1394),
         16#AE#           =>  --  04AE
          (0, 0, 1395, 1395),
         16#AF#           =>  --  04AF
          (0, 0, 1396, 1396),
         16#B0#           =>  --  04B0
          (0, 0, 1397, 1397),
         16#B1#           =>  --  04B1
          (0, 0, 1398, 1398),
         16#B2#           =>  --  04B2
          (0, 0, 1399, 1399),
         16#B3#           =>  --  04B3
          (0, 0, 1400, 1400),
         16#B4#           =>  --  04B4
          (0, 0, 1401, 1401),
         16#B5#           =>  --  04B5
          (0, 0, 1402, 1402),
         16#B6#           =>  --  04B6
          (0, 0, 1403, 1403),
         16#B7#           =>  --  04B7
          (0, 0, 1404, 1404),
         16#B8#           =>  --  04B8
          (0, 0, 1405, 1405),
         16#B9#           =>  --  04B9
          (0, 0, 1406, 1406),
         16#BA#           =>  --  04BA
          (0, 0, 1407, 1407),
         16#BB#           =>  --  04BB
          (0, 0, 1408, 1408),
         16#BC#           =>  --  04BC
          (0, 0, 1409, 1409),
         16#BD#           =>  --  04BD
          (0, 0, 1410, 1410),
         16#BE#           =>  --  04BE
          (0, 0, 1411, 1411),
         16#BF#           =>  --  04BF
          (0, 0, 1412, 1412),
         16#C0#           =>  --  04C0
          (0, 0, 1413, 1413),
         16#C1#           =>  --  04C1
          (0, 0, 1414, 1415),
         16#C2#           =>  --  04C2
          (0, 0, 1416, 1417),
         16#C3#           =>  --  04C3
          (0, 0, 1418, 1418),
         16#C4#           =>  --  04C4
          (0, 0, 1419, 1419),
         16#C5#           =>  --  04C5
          (0, 0, 1420, 1420),
         16#C6#           =>  --  04C6
          (0, 0, 1421, 1421),
         16#C7#           =>  --  04C7
          (0, 0, 1422, 1422),
         16#C8#           =>  --  04C8
          (0, 0, 1423, 1423),
         16#C9#           =>  --  04C9
          (0, 0, 1424, 1424),
         16#CA#           =>  --  04CA
          (0, 0, 1425, 1425),
         16#CB#           =>  --  04CB
          (0, 0, 1426, 1426),
         16#CC#           =>  --  04CC
          (0, 0, 1427, 1427),
         16#CD#           =>  --  04CD
          (0, 0, 1428, 1428),
         16#CE#           =>  --  04CE
          (0, 0, 1429, 1429),
         16#CF#           =>  --  04CF
          (0, 0, 1430, 1430),
         16#D0#           =>  --  04D0
          (0, 0, 1431, 1432),
         16#D1#           =>  --  04D1
          (0, 0, 1433, 1434),
         16#D2#           =>  --  04D2
          (0, 0, 1435, 1436),
         16#D3#           =>  --  04D3
          (0, 0, 1437, 1438),
         16#D4#           =>  --  04D4
          (0, 0, 1439, 1439),
         16#D5#           =>  --  04D5
          (0, 0, 1440, 1440),
         16#D6#           =>  --  04D6
          (0, 0, 1441, 1442),
         16#D7#           =>  --  04D7
          (0, 0, 1443, 1444),
         16#D8#           =>  --  04D8
          (0, 0, 1445, 1445),
         16#D9#           =>  --  04D9
          (0, 0, 1446, 1446),
         16#DA#           =>  --  04DA
          (0, 0, 1447, 1448),
         16#DB#           =>  --  04DB
          (0, 0, 1449, 1450),
         16#DC#           =>  --  04DC
          (0, 0, 1451, 1452),
         16#DD#           =>  --  04DD
          (0, 0, 1453, 1454),
         16#DE#           =>  --  04DE
          (0, 0, 1455, 1456),
         16#DF#           =>  --  04DF
          (0, 0, 1457, 1458),
         16#E0#           =>  --  04E0
          (0, 0, 1459, 1459),
         16#E1#           =>  --  04E1
          (0, 0, 1460, 1460),
         16#E2#           =>  --  04E2
          (0, 0, 1461, 1462),
         16#E3#           =>  --  04E3
          (0, 0, 1463, 1464),
         16#E4#           =>  --  04E4
          (0, 0, 1465, 1466),
         16#E5#           =>  --  04E5
          (0, 0, 1467, 1468),
         16#E6#           =>  --  04E6
          (0, 0, 1469, 1470),
         16#E7#           =>  --  04E7
          (0, 0, 1471, 1472),
         16#E8#           =>  --  04E8
          (0, 0, 1473, 1473),
         16#E9#           =>  --  04E9
          (0, 0, 1474, 1474),
         16#EA#           =>  --  04EA
          (0, 0, 1475, 1476),
         16#EB#           =>  --  04EB
          (0, 0, 1477, 1478),
         16#EC#           =>  --  04EC
          (0, 0, 1479, 1480),
         16#ED#           =>  --  04ED
          (0, 0, 1481, 1482),
         16#EE#           =>  --  04EE
          (0, 0, 1483, 1484),
         16#EF#           =>  --  04EF
          (0, 0, 1485, 1486),
         16#F0#           =>  --  04F0
          (0, 0, 1487, 1488),
         16#F1#           =>  --  04F1
          (0, 0, 1489, 1490),
         16#F2#           =>  --  04F2
          (0, 0, 1491, 1492),
         16#F3#           =>  --  04F3
          (0, 0, 1493, 1494),
         16#F4#           =>  --  04F4
          (0, 0, 1495, 1496),
         16#F5#           =>  --  04F5
          (0, 0, 1497, 1498),
         16#F6#           =>  --  04F6
          (0, 0, 1499, 1499),
         16#F7#           =>  --  04F7
          (0, 0, 1500, 1500),
         16#F8#           =>  --  04F8
          (0, 0, 1501, 1502),
         16#F9#           =>  --  04F9
          (0, 0, 1503, 1504),
         16#FA#           =>  --  04FA
          (0, 0, 1505, 1505),
         16#FB#           =>  --  04FB
          (0, 0, 1506, 1506),
         16#FC#           =>  --  04FC
          (0, 0, 1507, 1507),
         16#FD#           =>  --  04FD
          (0, 0, 1508, 1508),
         16#FE#           =>  --  04FE
          (0, 0, 1509, 1509),
         16#FF#           =>  --  04FF
          (0, 0, 1510, 1510),
         others           =>
          (0, 0, 1041, 1041));

   Group_0005 : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  0500
          (0, 0, 1511, 1511),
         16#01#           =>  --  0501
          (0, 0, 1512, 1512),
         16#02#           =>  --  0502
          (0, 0, 1513, 1513),
         16#03#           =>  --  0503
          (0, 0, 1514, 1514),
         16#04#           =>  --  0504
          (0, 0, 1515, 1515),
         16#05#           =>  --  0505
          (0, 0, 1516, 1516),
         16#06#           =>  --  0506
          (0, 0, 1517, 1517),
         16#07#           =>  --  0507
          (0, 0, 1518, 1518),
         16#08#           =>  --  0508
          (0, 0, 1519, 1519),
         16#09#           =>  --  0509
          (0, 0, 1520, 1520),
         16#0A#           =>  --  050A
          (0, 0, 1521, 1521),
         16#0B#           =>  --  050B
          (0, 0, 1522, 1522),
         16#0C#           =>  --  050C
          (0, 0, 1523, 1523),
         16#0D#           =>  --  050D
          (0, 0, 1524, 1524),
         16#0E#           =>  --  050E
          (0, 0, 1525, 1525),
         16#0F#           =>  --  050F
          (0, 0, 1526, 1526),
         16#10#           =>  --  0510
          (0, 0, 1527, 1527),
         16#11#           =>  --  0511
          (0, 0, 1528, 1528),
         16#12#           =>  --  0512
          (0, 0, 1529, 1529),
         16#13#           =>  --  0513
          (0, 0, 1530, 1530),
         16#14#           =>  --  0514
          (0, 0, 1531, 1531),
         16#15#           =>  --  0515
          (0, 0, 1532, 1532),
         16#16#           =>  --  0516
          (0, 0, 1533, 1533),
         16#17#           =>  --  0517
          (0, 0, 1534, 1534),
         16#18#           =>  --  0518
          (0, 0, 1535, 1535),
         16#19#           =>  --  0519
          (0, 0, 1536, 1536),
         16#1A#           =>  --  051A
          (0, 0, 1537, 1537),
         16#1B#           =>  --  051B
          (0, 0, 1538, 1538),
         16#1C#           =>  --  051C
          (0, 0, 1539, 1539),
         16#1D#           =>  --  051D
          (0, 0, 1540, 1540),
         16#1E#           =>  --  051E
          (0, 0, 1541, 1541),
         16#1F#           =>  --  051F
          (0, 0, 1542, 1542),
         16#20#           =>  --  0520
          (0, 0, 1543, 1543),
         16#21#           =>  --  0521
          (0, 0, 1544, 1544),
         16#22#           =>  --  0522
          (0, 0, 1545, 1545),
         16#23#           =>  --  0523
          (0, 0, 1546, 1546),
         16#24#           =>  --  0524
          (0, 0, 1547, 1547),
         16#25#           =>  --  0525
          (0, 0, 1548, 1548),
         16#26#           =>  --  0526
          (0, 0, 1549, 1549),
         16#27#           =>  --  0527
          (0, 0, 1550, 1550),
         16#28#           =>  --  0528
          (0, 0, 1551, 1551),
         16#29#           =>  --  0529
          (0, 0, 1552, 1552),
         16#2A#           =>  --  052A
          (0, 0, 1553, 1553),
         16#2B#           =>  --  052B
          (0, 0, 1554, 1554),
         16#2C#           =>  --  052C
          (0, 0, 1555, 1555),
         16#2D#           =>  --  052D
          (0, 0, 1556, 1556),
         16#2E#           =>  --  052E
          (0, 0, 1557, 1557),
         16#2F#           =>  --  052F
          (0, 0, 1558, 1558),
         16#30#           =>  --  0530
          (0, 0, 0, 0),
         16#31#           =>  --  0531
          (0, 0, 1559, 1559),
         16#32#           =>  --  0532
          (0, 0, 1560, 1560),
         16#33#           =>  --  0533
          (0, 0, 1561, 1561),
         16#34#           =>  --  0534
          (0, 0, 1562, 1562),
         16#35#           =>  --  0535
          (0, 0, 1563, 1563),
         16#36#           =>  --  0536
          (0, 0, 1564, 1564),
         16#37#           =>  --  0537
          (0, 0, 1565, 1565),
         16#38#           =>  --  0538
          (0, 0, 1566, 1566),
         16#39#           =>  --  0539
          (0, 0, 1567, 1567),
         16#3A#           =>  --  053A
          (0, 0, 1568, 1568),
         16#3B#           =>  --  053B
          (0, 0, 1569, 1569),
         16#3C#           =>  --  053C
          (0, 0, 1570, 1570),
         16#3D#           =>  --  053D
          (0, 0, 1571, 1571),
         16#3E#           =>  --  053E
          (0, 0, 1572, 1572),
         16#3F#           =>  --  053F
          (0, 0, 1573, 1573),
         16#40#           =>  --  0540
          (0, 0, 1574, 1574),
         16#41#           =>  --  0541
          (0, 0, 1575, 1575),
         16#42#           =>  --  0542
          (0, 0, 1576, 1576),
         16#43#           =>  --  0543
          (0, 0, 1577, 1577),
         16#44#           =>  --  0544
          (0, 0, 1578, 1578),
         16#45#           =>  --  0545
          (0, 0, 1579, 1579),
         16#46#           =>  --  0546
          (0, 0, 1580, 1580),
         16#47#           =>  --  0547
          (0, 0, 1581, 1581),
         16#48#           =>  --  0548
          (0, 0, 1582, 1582),
         16#49#           =>  --  0549
          (0, 0, 1583, 1583),
         16#4A#           =>  --  054A
          (0, 0, 1584, 1584),
         16#4B#           =>  --  054B
          (0, 0, 1585, 1585),
         16#4C#           =>  --  054C
          (0, 0, 1586, 1586),
         16#4D#           =>  --  054D
          (0, 0, 1587, 1587),
         16#4E#           =>  --  054E
          (0, 0, 1588, 1588),
         16#4F#           =>  --  054F
          (0, 0, 1589, 1589),
         16#50#           =>  --  0550
          (0, 0, 1590, 1590),
         16#51#           =>  --  0551
          (0, 0, 1591, 1591),
         16#52#           =>  --  0552
          (0, 0, 1592, 1592),
         16#53#           =>  --  0553
          (0, 0, 1593, 1593),
         16#54#           =>  --  0554
          (0, 0, 1594, 1594),
         16#55#           =>  --  0555
          (0, 0, 1595, 1595),
         16#56#           =>  --  0556
          (0, 0, 1596, 1596),
         16#57# .. 16#58# =>  --  0557 .. 0558
          (0, 0, 0, 0),
         16#59#           =>  --  0559
          (0, 0, 1597, 1597),
         16#5A#           =>  --  055A
          (0, 0, 1598, 1598),
         16#5B#           =>  --  055B
          (0, 0, 1599, 1599),
         16#5C#           =>  --  055C
          (0, 0, 1600, 1600),
         16#5D#           =>  --  055D
          (0, 0, 1601, 1601),
         16#5E#           =>  --  055E
          (0, 0, 1602, 1602),
         16#5F#           =>  --  055F
          (0, 0, 1603, 1603),
         16#60#           =>  --  0560
          (0, 0, 0, 0),
         16#61#           =>  --  0561
          (0, 0, 1604, 1604),
         16#62#           =>  --  0562
          (0, 0, 1605, 1605),
         16#63#           =>  --  0563
          (0, 0, 1606, 1606),
         16#64#           =>  --  0564
          (0, 0, 1607, 1607),
         16#65#           =>  --  0565
          (0, 0, 1608, 1608),
         16#66#           =>  --  0566
          (0, 0, 1609, 1609),
         16#67#           =>  --  0567
          (0, 0, 1610, 1610),
         16#68#           =>  --  0568
          (0, 0, 1611, 1611),
         16#69#           =>  --  0569
          (0, 0, 1612, 1612),
         16#6A#           =>  --  056A
          (0, 0, 1613, 1613),
         16#6B#           =>  --  056B
          (0, 0, 1614, 1614),
         16#6C#           =>  --  056C
          (0, 0, 1615, 1615),
         16#6D#           =>  --  056D
          (0, 0, 1616, 1616),
         16#6E#           =>  --  056E
          (0, 0, 1617, 1617),
         16#6F#           =>  --  056F
          (0, 0, 1618, 1618),
         16#70#           =>  --  0570
          (0, 0, 1619, 1619),
         16#71#           =>  --  0571
          (0, 0, 1620, 1620),
         16#72#           =>  --  0572
          (0, 0, 1621, 1621),
         16#73#           =>  --  0573
          (0, 0, 1622, 1622),
         16#74#           =>  --  0574
          (0, 0, 1623, 1623),
         16#75#           =>  --  0575
          (0, 0, 1624, 1624),
         16#76#           =>  --  0576
          (0, 0, 1625, 1625),
         16#77#           =>  --  0577
          (0, 0, 1626, 1626),
         16#78#           =>  --  0578
          (0, 0, 1627, 1627),
         16#79#           =>  --  0579
          (0, 0, 1628, 1628),
         16#7A#           =>  --  057A
          (0, 0, 1629, 1629),
         16#7B#           =>  --  057B
          (0, 0, 1630, 1630),
         16#7C#           =>  --  057C
          (0, 0, 1631, 1631),
         16#7D#           =>  --  057D
          (0, 0, 1632, 1632),
         16#7E#           =>  --  057E
          (0, 0, 1633, 1633),
         16#7F#           =>  --  057F
          (0, 0, 1634, 1634),
         16#80#           =>  --  0580
          (0, 0, 1635, 1635),
         16#81#           =>  --  0581
          (0, 0, 1636, 1636),
         16#82#           =>  --  0582
          (0, 0, 1637, 1637),
         16#83#           =>  --  0583
          (0, 0, 1638, 1638),
         16#84#           =>  --  0584
          (0, 0, 1639, 1639),
         16#85#           =>  --  0585
          (0, 0, 1640, 1640),
         16#86#           =>  --  0586
          (0, 0, 1641, 1641),
         16#87#           =>  --  0587
          (0, 0, 1642, 1643),
         16#88#           =>  --  0588
          (0, 0, 0, 0),
         16#89#           =>  --  0589
          (0, 0, 1644, 1644),
         16#8A#           =>  --  058A
          (0, 0, 1645, 1645),
         16#8B# .. 16#8C# =>  --  058B .. 058C
          (0, 0, 0, 0),
         16#8D#           =>  --  058D
          (0, 0, 1646, 1646),
         16#8E#           =>  --  058E
          (0, 0, 1647, 1647),
         16#8F#           =>  --  058F
          (0, 0, 1648, 1648),
         16#90#           =>  --  0590
          (0, 0, 0, 0),
         16#B0#           =>  --  05B0
          (0, 0, 1649, 1649),
         16#B1#           =>  --  05B1
          (0, 0, 1650, 1650),
         16#B2#           =>  --  05B2
          (0, 0, 1651, 1651),
         16#B3#           =>  --  05B3
          (0, 0, 1652, 1652),
         16#B4#           =>  --  05B4
          (0, 0, 1653, 1653),
         16#B5#           =>  --  05B5
          (0, 0, 1654, 1654),
         16#B6#           =>  --  05B6
          (0, 0, 1655, 1655),
         16#B7#           =>  --  05B7
          (0, 0, 1656, 1656),
         16#B8#           =>  --  05B8
          (0, 0, 1657, 1657),
         16#B9# .. 16#BA# =>  --  05B9 .. 05BA
          (0, 0, 1658, 1658),
         16#BB#           =>  --  05BB
          (0, 0, 1659, 1659),
         16#BC#           =>  --  05BC
          (0, 0, 1660, 1660),
         16#BE#           =>  --  05BE
          (0, 0, 1661, 1661),
         16#BF#           =>  --  05BF
          (0, 0, 1662, 1662),
         16#C0#           =>  --  05C0
          (0, 0, 1663, 1663),
         16#C1#           =>  --  05C1
          (0, 0, 1664, 1664),
         16#C2#           =>  --  05C2
          (0, 0, 1665, 1665),
         16#C3#           =>  --  05C3
          (0, 0, 1666, 1666),
         16#C6#           =>  --  05C6
          (0, 0, 1667, 1667),
         16#C7#           =>  --  05C7
          (0, 0, 1657, 1657),
         16#C8# .. 16#CF# =>  --  05C8 .. 05CF
          (0, 0, 0, 0),
         16#D0#           =>  --  05D0
          (0, 0, 1668, 1668),
         16#D1#           =>  --  05D1
          (0, 0, 1669, 1669),
         16#D2#           =>  --  05D2
          (0, 0, 1670, 1670),
         16#D3#           =>  --  05D3
          (0, 0, 1671, 1671),
         16#D4#           =>  --  05D4
          (0, 0, 1672, 1672),
         16#D5#           =>  --  05D5
          (0, 0, 1673, 1673),
         16#D6#           =>  --  05D6
          (0, 0, 1674, 1674),
         16#D7#           =>  --  05D7
          (0, 0, 1675, 1675),
         16#D8#           =>  --  05D8
          (0, 0, 1676, 1676),
         16#D9#           =>  --  05D9
          (0, 0, 1677, 1677),
         16#DA#           =>  --  05DA
          (0, 0, 1678, 1678),
         16#DB#           =>  --  05DB
          (0, 0, 1679, 1679),
         16#DC#           =>  --  05DC
          (0, 0, 1680, 1680),
         16#DD#           =>  --  05DD
          (0, 0, 1681, 1681),
         16#DE#           =>  --  05DE
          (0, 0, 1682, 1682),
         16#DF#           =>  --  05DF
          (0, 0, 1683, 1683),
         16#E0#           =>  --  05E0
          (0, 0, 1684, 1684),
         16#E1#           =>  --  05E1
          (0, 0, 1685, 1685),
         16#E2#           =>  --  05E2
          (0, 0, 1686, 1686),
         16#E3#           =>  --  05E3
          (0, 0, 1687, 1687),
         16#E4#           =>  --  05E4
          (0, 0, 1688, 1688),
         16#E5#           =>  --  05E5
          (0, 0, 1689, 1689),
         16#E6#           =>  --  05E6
          (0, 0, 1690, 1690),
         16#E7#           =>  --  05E7
          (0, 0, 1691, 1691),
         16#E8#           =>  --  05E8
          (0, 0, 1692, 1692),
         16#E9#           =>  --  05E9
          (0, 0, 1693, 1693),
         16#EA#           =>  --  05EA
          (0, 0, 1694, 1694),
         16#EB# .. 16#EF# =>  --  05EB .. 05EF
          (0, 0, 0, 0),
         16#F0#           =>  --  05F0
          (0, 0, 1695, 1696),
         16#F1#           =>  --  05F1
          (0, 0, 1697, 1698),
         16#F2#           =>  --  05F2
          (0, 0, 1699, 1700),
         16#F3#           =>  --  05F3
          (0, 0, 1701, 1701),
         16#F4#           =>  --  05F4
          (0, 0, 1702, 1702),
         16#F5# .. 16#FF# =>  --  05F5 .. 05FF
          (0, 0, 0, 0),
         others           =>
          (0, 0, 1, 1));

   Group_0006 : aliased constant Collation_Second_Stage
     := (16#06#           =>  --  0606
          (0, 0, 1703, 1703),
         16#07#           =>  --  0607
          (0, 0, 1704, 1704),
         16#08#           =>  --  0608
          (0, 0, 1705, 1705),
         16#09#           =>  --  0609
          (0, 0, 1706, 1706),
         16#0A#           =>  --  060A
          (0, 0, 1707, 1707),
         16#0B#           =>  --  060B
          (0, 0, 1708, 1708),
         16#0C#           =>  --  060C
          (0, 0, 1709, 1709),
         16#0D#           =>  --  060D
          (0, 0, 1710, 1710),
         16#0E#           =>  --  060E
          (0, 0, 1711, 1711),
         16#0F#           =>  --  060F
          (0, 0, 1712, 1712),
         16#1B#           =>  --  061B
          (0, 0, 1713, 1713),
         16#1D#           =>  --  061D
          (0, 0, 0, 0),
         16#1E#           =>  --  061E
          (0, 0, 1714, 1714),
         16#1F#           =>  --  061F
          (0, 0, 1715, 1715),
         16#20#           =>  --  0620
          (0, 0, 1716, 1716),
         16#21#           =>  --  0621
          (0, 0, 1717, 1717),
         16#22#           =>  --  0622
          (0, 0, 1718, 1718),
         16#23#           =>  --  0623
          (0, 0, 1719, 1719),
         16#24#           =>  --  0624
          (0, 0, 1720, 1720),
         16#25#           =>  --  0625
          (0, 0, 1721, 1721),
         16#26#           =>  --  0626
          (0, 0, 1722, 1722),
         16#27#           =>  --  0627
          (7, 9, 1723, 1723),
         16#28#           =>  --  0628
          (0, 0, 1724, 1724),
         16#29#           =>  --  0629
          (0, 0, 1725, 1725),
         16#2A#           =>  --  062A
          (0, 0, 1726, 1726),
         16#2B#           =>  --  062B
          (0, 0, 1727, 1727),
         16#2C#           =>  --  062C
          (0, 0, 1728, 1728),
         16#2D#           =>  --  062D
          (0, 0, 1729, 1729),
         16#2E#           =>  --  062E
          (0, 0, 1730, 1730),
         16#2F#           =>  --  062F
          (0, 0, 1731, 1731),
         16#30#           =>  --  0630
          (0, 0, 1732, 1732),
         16#31#           =>  --  0631
          (0, 0, 1733, 1733),
         16#32#           =>  --  0632
          (0, 0, 1734, 1734),
         16#33#           =>  --  0633
          (0, 0, 1735, 1735),
         16#34#           =>  --  0634
          (0, 0, 1736, 1736),
         16#35#           =>  --  0635
          (0, 0, 1737, 1737),
         16#36#           =>  --  0636
          (0, 0, 1738, 1738),
         16#37#           =>  --  0637
          (0, 0, 1739, 1739),
         16#38#           =>  --  0638
          (0, 0, 1740, 1740),
         16#39#           =>  --  0639
          (0, 0, 1741, 1741),
         16#3A#           =>  --  063A
          (0, 0, 1742, 1742),
         16#3B#           =>  --  063B
          (0, 0, 1743, 1743),
         16#3C#           =>  --  063C
          (0, 0, 1744, 1744),
         16#3D#           =>  --  063D
          (0, 0, 1745, 1745),
         16#3E#           =>  --  063E
          (0, 0, 1746, 1746),
         16#3F#           =>  --  063F
          (0, 0, 1747, 1747),
         16#41#           =>  --  0641
          (0, 0, 1748, 1748),
         16#42#           =>  --  0642
          (0, 0, 1749, 1749),
         16#43#           =>  --  0643
          (0, 0, 1750, 1750),
         16#44#           =>  --  0644
          (0, 0, 1751, 1751),
         16#45#           =>  --  0645
          (0, 0, 1752, 1752),
         16#46#           =>  --  0646
          (0, 0, 1753, 1753),
         16#47#           =>  --  0647
          (0, 0, 1754, 1754),
         16#48#           =>  --  0648
          (10, 10, 1755, 1755),
         16#49#           =>  --  0649
          (0, 0, 1756, 1756),
         16#4A#           =>  --  064A
          (11, 11, 1757, 1757),
         16#4B#           =>  --  064B
          (0, 0, 1758, 1758),
         16#4C#           =>  --  064C
          (0, 0, 1759, 1759),
         16#4D#           =>  --  064D
          (0, 0, 1760, 1760),
         16#4E#           =>  --  064E
          (0, 0, 1761, 1761),
         16#4F#           =>  --  064F
          (0, 0, 1762, 1762),
         16#50#           =>  --  0650
          (0, 0, 1763, 1763),
         16#51#           =>  --  0651
          (0, 0, 1764, 1764),
         16#52#           =>  --  0652
          (0, 0, 1765, 1765),
         16#53#           =>  --  0653
          (0, 0, 1766, 1766),
         16#54#           =>  --  0654
          (0, 0, 1767, 1767),
         16#55#           =>  --  0655
          (0, 0, 1768, 1768),
         16#56#           =>  --  0656
          (0, 0, 1769, 1769),
         16#57#           =>  --  0657
          (0, 0, 1770, 1770),
         16#58#           =>  --  0658
          (0, 0, 1771, 1771),
         16#59#           =>  --  0659
          (0, 0, 1772, 1772),
         16#5A#           =>  --  065A
          (0, 0, 1773, 1773),
         16#5B#           =>  --  065B
          (0, 0, 1774, 1774),
         16#5C#           =>  --  065C
          (0, 0, 1775, 1775),
         16#5D#           =>  --  065D
          (0, 0, 1776, 1776),
         16#5E#           =>  --  065E
          (0, 0, 1777, 1777),
         16#5F#           =>  --  065F
          (0, 0, 1778, 1778),
         16#60#           =>  --  0660
          (0, 0, 23, 23),
         16#61#           =>  --  0661
          (0, 0, 24, 24),
         16#62#           =>  --  0662
          (0, 0, 25, 25),
         16#63#           =>  --  0663
          (0, 0, 26, 26),
         16#64#           =>  --  0664
          (0, 0, 27, 27),
         16#65#           =>  --  0665
          (0, 0, 28, 28),
         16#66#           =>  --  0666
          (0, 0, 29, 29),
         16#67#           =>  --  0667
          (0, 0, 30, 30),
         16#68#           =>  --  0668
          (0, 0, 31, 31),
         16#69#           =>  --  0669
          (0, 0, 32, 32),
         16#6A#           =>  --  066A
          (0, 0, 1779, 1779),
         16#6B#           =>  --  066B
          (0, 0, 1780, 1780),
         16#6C#           =>  --  066C
          (0, 0, 1781, 1781),
         16#6D#           =>  --  066D
          (0, 0, 1782, 1782),
         16#6E#           =>  --  066E
          (0, 0, 1783, 1783),
         16#6F#           =>  --  066F
          (0, 0, 1784, 1784),
         16#70#           =>  --  0670
          (0, 0, 1785, 1785),
         16#71#           =>  --  0671
          (0, 0, 1786, 1786),
         16#72#           =>  --  0672
          (0, 0, 1787, 1787),
         16#73#           =>  --  0673
          (0, 0, 1788, 1788),
         16#74#           =>  --  0674
          (0, 0, 1789, 1789),
         16#75#           =>  --  0675
          (0, 0, 1790, 1791),
         16#76#           =>  --  0676
          (0, 0, 1792, 1793),
         16#77#           =>  --  0677
          (0, 0, 1794, 1795),
         16#78#           =>  --  0678
          (0, 0, 1796, 1797),
         16#79#           =>  --  0679
          (0, 0, 1798, 1798),
         16#7A#           =>  --  067A
          (0, 0, 1799, 1799),
         16#7B#           =>  --  067B
          (0, 0, 1800, 1800),
         16#7C#           =>  --  067C
          (0, 0, 1801, 1801),
         16#7D#           =>  --  067D
          (0, 0, 1802, 1802),
         16#7E#           =>  --  067E
          (0, 0, 1803, 1803),
         16#7F#           =>  --  067F
          (0, 0, 1804, 1804),
         16#80#           =>  --  0680
          (0, 0, 1805, 1805),
         16#81#           =>  --  0681
          (0, 0, 1806, 1806),
         16#82#           =>  --  0682
          (0, 0, 1807, 1807),
         16#83#           =>  --  0683
          (0, 0, 1808, 1808),
         16#84#           =>  --  0684
          (0, 0, 1809, 1809),
         16#85#           =>  --  0685
          (0, 0, 1810, 1810),
         16#86#           =>  --  0686
          (0, 0, 1811, 1811),
         16#87#           =>  --  0687
          (0, 0, 1812, 1812),
         16#88#           =>  --  0688
          (0, 0, 1813, 1813),
         16#89#           =>  --  0689
          (0, 0, 1814, 1814),
         16#8A#           =>  --  068A
          (0, 0, 1815, 1815),
         16#8B#           =>  --  068B
          (0, 0, 1816, 1816),
         16#8C#           =>  --  068C
          (0, 0, 1817, 1817),
         16#8D#           =>  --  068D
          (0, 0, 1818, 1818),
         16#8E#           =>  --  068E
          (0, 0, 1819, 1819),
         16#8F#           =>  --  068F
          (0, 0, 1820, 1820),
         16#90#           =>  --  0690
          (0, 0, 1821, 1821),
         16#91#           =>  --  0691
          (0, 0, 1822, 1822),
         16#92#           =>  --  0692
          (0, 0, 1823, 1823),
         16#93#           =>  --  0693
          (0, 0, 1824, 1824),
         16#94#           =>  --  0694
          (0, 0, 1825, 1825),
         16#95#           =>  --  0695
          (0, 0, 1826, 1826),
         16#96#           =>  --  0696
          (0, 0, 1827, 1827),
         16#97#           =>  --  0697
          (0, 0, 1828, 1828),
         16#98#           =>  --  0698
          (0, 0, 1829, 1829),
         16#99#           =>  --  0699
          (0, 0, 1830, 1830),
         16#9A#           =>  --  069A
          (0, 0, 1831, 1831),
         16#9B#           =>  --  069B
          (0, 0, 1832, 1832),
         16#9C#           =>  --  069C
          (0, 0, 1833, 1833),
         16#9D#           =>  --  069D
          (0, 0, 1834, 1834),
         16#9E#           =>  --  069E
          (0, 0, 1835, 1835),
         16#9F#           =>  --  069F
          (0, 0, 1836, 1836),
         16#A0#           =>  --  06A0
          (0, 0, 1837, 1837),
         16#A1#           =>  --  06A1
          (0, 0, 1838, 1838),
         16#A2#           =>  --  06A2
          (0, 0, 1839, 1839),
         16#A3#           =>  --  06A3
          (0, 0, 1840, 1840),
         16#A4#           =>  --  06A4
          (0, 0, 1841, 1841),
         16#A5#           =>  --  06A5
          (0, 0, 1842, 1842),
         16#A6#           =>  --  06A6
          (0, 0, 1843, 1843),
         16#A7#           =>  --  06A7
          (0, 0, 1844, 1844),
         16#A8#           =>  --  06A8
          (0, 0, 1845, 1845),
         16#A9#           =>  --  06A9
          (0, 0, 1846, 1846),
         16#AA#           =>  --  06AA
          (0, 0, 1847, 1847),
         16#AB#           =>  --  06AB
          (0, 0, 1848, 1848),
         16#AC#           =>  --  06AC
          (0, 0, 1849, 1849),
         16#AD#           =>  --  06AD
          (0, 0, 1850, 1850),
         16#AE#           =>  --  06AE
          (0, 0, 1851, 1851),
         16#AF#           =>  --  06AF
          (0, 0, 1852, 1852),
         16#B0#           =>  --  06B0
          (0, 0, 1853, 1853),
         16#B1#           =>  --  06B1
          (0, 0, 1854, 1854),
         16#B2#           =>  --  06B2
          (0, 0, 1855, 1855),
         16#B3#           =>  --  06B3
          (0, 0, 1856, 1856),
         16#B4#           =>  --  06B4
          (0, 0, 1857, 1857),
         16#B5#           =>  --  06B5
          (0, 0, 1858, 1858),
         16#B6#           =>  --  06B6
          (0, 0, 1859, 1859),
         16#B7#           =>  --  06B7
          (0, 0, 1860, 1860),
         16#B8#           =>  --  06B8
          (0, 0, 1861, 1861),
         16#B9#           =>  --  06B9
          (0, 0, 1862, 1862),
         16#BA#           =>  --  06BA
          (0, 0, 1863, 1863),
         16#BB#           =>  --  06BB
          (0, 0, 1864, 1864),
         16#BC#           =>  --  06BC
          (0, 0, 1865, 1865),
         16#BD#           =>  --  06BD
          (0, 0, 1866, 1866),
         16#BE#           =>  --  06BE
          (0, 0, 1867, 1867),
         16#BF#           =>  --  06BF
          (0, 0, 1868, 1868),
         16#C0#           =>  --  06C0
          (0, 0, 1869, 1870),
         16#C1#           =>  --  06C1
          (0, 0, 1871, 1871),
         16#C2#           =>  --  06C2
          (0, 0, 1872, 1873),
         16#C3#           =>  --  06C3
          (0, 0, 1874, 1874),
         16#C4#           =>  --  06C4
          (0, 0, 1875, 1875),
         16#C5#           =>  --  06C5
          (0, 0, 1876, 1876),
         16#C6#           =>  --  06C6
          (0, 0, 1877, 1877),
         16#C7#           =>  --  06C7
          (0, 0, 1878, 1878),
         16#C8#           =>  --  06C8
          (0, 0, 1879, 1879),
         16#C9#           =>  --  06C9
          (0, 0, 1880, 1880),
         16#CA#           =>  --  06CA
          (0, 0, 1881, 1881),
         16#CB#           =>  --  06CB
          (0, 0, 1882, 1882),
         16#CC#           =>  --  06CC
          (0, 0, 1883, 1883),
         16#CD#           =>  --  06CD
          (0, 0, 1884, 1884),
         16#CE#           =>  --  06CE
          (0, 0, 1885, 1885),
         16#CF#           =>  --  06CF
          (0, 0, 1886, 1886),
         16#D0#           =>  --  06D0
          (0, 0, 1887, 1887),
         16#D1#           =>  --  06D1
          (0, 0, 1888, 1888),
         16#D2#           =>  --  06D2
          (0, 0, 1889, 1889),
         16#D3#           =>  --  06D3
          (0, 0, 1890, 1891),
         16#D4#           =>  --  06D4
          (0, 0, 1892, 1892),
         16#D5#           =>  --  06D5
          (0, 0, 1869, 1869),
         16#DE#           =>  --  06DE
          (0, 0, 1893, 1893),
         16#E5#           =>  --  06E5
          (0, 0, 1792, 1792),
         16#E6#           =>  --  06E6
          (0, 0, 1796, 1796),
         16#E9#           =>  --  06E9
          (0, 0, 1894, 1894),
         16#EE#           =>  --  06EE
          (0, 0, 1895, 1895),
         16#EF#           =>  --  06EF
          (0, 0, 1896, 1896),
         16#F0#           =>  --  06F0
          (0, 0, 23, 23),
         16#F1#           =>  --  06F1
          (0, 0, 24, 24),
         16#F2#           =>  --  06F2
          (0, 0, 25, 25),
         16#F3#           =>  --  06F3
          (0, 0, 26, 26),
         16#F4#           =>  --  06F4
          (0, 0, 27, 27),
         16#F5#           =>  --  06F5
          (0, 0, 28, 28),
         16#F6#           =>  --  06F6
          (0, 0, 29, 29),
         16#F7#           =>  --  06F7
          (0, 0, 30, 30),
         16#F8#           =>  --  06F8
          (0, 0, 31, 31),
         16#F9#           =>  --  06F9
          (0, 0, 32, 32),
         16#FA#           =>  --  06FA
          (0, 0, 1897, 1897),
         16#FB#           =>  --  06FB
          (0, 0, 1898, 1898),
         16#FC#           =>  --  06FC
          (0, 0, 1899, 1899),
         16#FD#           =>  --  06FD
          (0, 0, 1900, 1901),
         16#FE#           =>  --  06FE
          (0, 0, 1902, 1903),
         16#FF#           =>  --  06FF
          (0, 0, 1904, 1904),
         others           =>
          (0, 0, 1, 1));

   Group_0007 : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  0700
          (0, 0, 1905, 1905),
         16#01#           =>  --  0701
          (0, 0, 1906, 1906),
         16#02#           =>  --  0702
          (0, 0, 1907, 1907),
         16#03#           =>  --  0703
          (0, 0, 1908, 1908),
         16#04#           =>  --  0704
          (0, 0, 1909, 1909),
         16#05#           =>  --  0705
          (0, 0, 1910, 1910),
         16#06#           =>  --  0706
          (0, 0, 1911, 1911),
         16#07#           =>  --  0707
          (0, 0, 1912, 1912),
         16#08#           =>  --  0708
          (0, 0, 1913, 1913),
         16#09#           =>  --  0709
          (0, 0, 1914, 1914),
         16#0A#           =>  --  070A
          (0, 0, 1915, 1915),
         16#0B#           =>  --  070B
          (0, 0, 1916, 1916),
         16#0C#           =>  --  070C
          (0, 0, 1917, 1917),
         16#0D#           =>  --  070D
          (0, 0, 1918, 1918),
         16#0F#           =>  --  070F
          (0, 0, 1, 1),
         16#10#           =>  --  0710
          (0, 0, 1919, 1919),
         16#11#           =>  --  0711
          (0, 0, 1920, 1920),
         16#12#           =>  --  0712
          (0, 0, 1921, 1921),
         16#13#           =>  --  0713
          (0, 0, 1922, 1922),
         16#14#           =>  --  0714
          (0, 0, 1923, 1924),
         16#15#           =>  --  0715
          (0, 0, 1925, 1925),
         16#16#           =>  --  0716
          (0, 0, 1926, 1926),
         16#17#           =>  --  0717
          (0, 0, 1927, 1927),
         16#18#           =>  --  0718
          (0, 0, 1928, 1928),
         16#19#           =>  --  0719
          (0, 0, 1929, 1929),
         16#1A#           =>  --  071A
          (0, 0, 1930, 1930),
         16#1B#           =>  --  071B
          (0, 0, 1931, 1931),
         16#1C#           =>  --  071C
          (0, 0, 1932, 1933),
         16#1D#           =>  --  071D
          (0, 0, 1934, 1934),
         16#1E#           =>  --  071E
          (0, 0, 1935, 1935),
         16#1F#           =>  --  071F
          (0, 0, 1936, 1936),
         16#20#           =>  --  0720
          (0, 0, 1937, 1937),
         16#21#           =>  --  0721
          (0, 0, 1938, 1938),
         16#22#           =>  --  0722
          (0, 0, 1939, 1939),
         16#23#           =>  --  0723
          (0, 0, 1940, 1940),
         16#24#           =>  --  0724
          (0, 0, 1941, 1941),
         16#25#           =>  --  0725
          (0, 0, 1942, 1942),
         16#26#           =>  --  0726
          (0, 0, 1943, 1943),
         16#27#           =>  --  0727
          (0, 0, 1944, 1945),
         16#28#           =>  --  0728
          (0, 0, 1946, 1946),
         16#29#           =>  --  0729
          (0, 0, 1947, 1947),
         16#2A#           =>  --  072A
          (0, 0, 1948, 1948),
         16#2B#           =>  --  072B
          (0, 0, 1949, 1949),
         16#2C#           =>  --  072C
          (0, 0, 1950, 1950),
         16#2D#           =>  --  072D
          (0, 0, 1951, 1952),
         16#2E#           =>  --  072E
          (0, 0, 1953, 1954),
         16#2F#           =>  --  072F
          (0, 0, 1955, 1956),
         16#30#           =>  --  0730
          (0, 0, 1957, 1957),
         16#31#           =>  --  0731
          (0, 0, 1958, 1958),
         16#32#           =>  --  0732
          (0, 0, 1959, 1959),
         16#33#           =>  --  0733
          (0, 0, 1960, 1960),
         16#34#           =>  --  0734
          (0, 0, 1961, 1961),
         16#35#           =>  --  0735
          (0, 0, 1962, 1962),
         16#36#           =>  --  0736
          (0, 0, 1963, 1963),
         16#37#           =>  --  0737
          (0, 0, 1964, 1964),
         16#38#           =>  --  0738
          (0, 0, 1965, 1965),
         16#39#           =>  --  0739
          (0, 0, 1966, 1966),
         16#3A#           =>  --  073A
          (0, 0, 1967, 1967),
         16#3B#           =>  --  073B
          (0, 0, 1968, 1968),
         16#3C#           =>  --  073C
          (0, 0, 1969, 1969),
         16#3D#           =>  --  073D
          (0, 0, 1970, 1970),
         16#3E#           =>  --  073E
          (0, 0, 1971, 1971),
         16#3F#           =>  --  073F
          (0, 0, 1972, 1972),
         16#40#           =>  --  0740
          (0, 0, 1, 1),
         16#41#           =>  --  0741
          (0, 0, 1041, 1041),
         16#42#           =>  --  0742
          (0, 0, 1045, 1045),
         16#43# .. 16#44# =>  --  0743 .. 0744
          (0, 0, 1, 1),
         16#45#           =>  --  0745
          (0, 0, 1041, 1041),
         16#46#           =>  --  0746
          (0, 0, 1045, 1045),
         16#47# .. 16#4A# =>  --  0747 .. 074A
          (0, 0, 1, 1),
         16#4D#           =>  --  074D
          (0, 0, 1973, 1973),
         16#4E#           =>  --  074E
          (0, 0, 1974, 1974),
         16#4F#           =>  --  074F
          (0, 0, 1975, 1975),
         16#50#           =>  --  0750
          (0, 0, 1976, 1976),
         16#51#           =>  --  0751
          (0, 0, 1977, 1977),
         16#52#           =>  --  0752
          (0, 0, 1978, 1978),
         16#53#           =>  --  0753
          (0, 0, 1979, 1979),
         16#54#           =>  --  0754
          (0, 0, 1980, 1980),
         16#55#           =>  --  0755
          (0, 0, 1981, 1981),
         16#56#           =>  --  0756
          (0, 0, 1982, 1982),
         16#57#           =>  --  0757
          (0, 0, 1983, 1983),
         16#58#           =>  --  0758
          (0, 0, 1984, 1984),
         16#59#           =>  --  0759
          (0, 0, 1985, 1985),
         16#5A#           =>  --  075A
          (0, 0, 1986, 1986),
         16#5B#           =>  --  075B
          (0, 0, 1987, 1987),
         16#5C#           =>  --  075C
          (0, 0, 1988, 1988),
         16#5D#           =>  --  075D
          (0, 0, 1989, 1989),
         16#5E#           =>  --  075E
          (0, 0, 1990, 1990),
         16#5F#           =>  --  075F
          (0, 0, 1991, 1991),
         16#60#           =>  --  0760
          (0, 0, 1992, 1992),
         16#61#           =>  --  0761
          (0, 0, 1993, 1993),
         16#62#           =>  --  0762
          (0, 0, 1994, 1994),
         16#63#           =>  --  0763
          (0, 0, 1995, 1995),
         16#64#           =>  --  0764
          (0, 0, 1996, 1996),
         16#65#           =>  --  0765
          (0, 0, 1997, 1997),
         16#66#           =>  --  0766
          (0, 0, 1998, 1998),
         16#67#           =>  --  0767
          (0, 0, 1999, 1999),
         16#68#           =>  --  0768
          (0, 0, 2000, 2000),
         16#69#           =>  --  0769
          (0, 0, 2001, 2001),
         16#6A#           =>  --  076A
          (0, 0, 2002, 2002),
         16#6B#           =>  --  076B
          (0, 0, 2003, 2003),
         16#6C#           =>  --  076C
          (0, 0, 2004, 2004),
         16#6D#           =>  --  076D
          (0, 0, 2005, 2005),
         16#6E#           =>  --  076E
          (0, 0, 2006, 2006),
         16#6F#           =>  --  076F
          (0, 0, 2007, 2007),
         16#70#           =>  --  0770
          (0, 0, 2008, 2008),
         16#71#           =>  --  0771
          (0, 0, 2009, 2009),
         16#72#           =>  --  0772
          (0, 0, 2010, 2010),
         16#73#           =>  --  0773
          (0, 0, 2011, 2011),
         16#74#           =>  --  0774
          (0, 0, 2012, 2012),
         16#75#           =>  --  0775
          (0, 0, 2013, 2013),
         16#76#           =>  --  0776
          (0, 0, 2014, 2014),
         16#77#           =>  --  0777
          (0, 0, 2015, 2015),
         16#78#           =>  --  0778
          (0, 0, 2016, 2016),
         16#79#           =>  --  0779
          (0, 0, 2017, 2017),
         16#7A#           =>  --  077A
          (0, 0, 2018, 2018),
         16#7B#           =>  --  077B
          (0, 0, 2019, 2019),
         16#7C#           =>  --  077C
          (0, 0, 2020, 2020),
         16#7D#           =>  --  077D
          (0, 0, 2021, 2021),
         16#7E#           =>  --  077E
          (0, 0, 2022, 2022),
         16#7F#           =>  --  077F
          (0, 0, 2023, 2023),
         16#80#           =>  --  0780
          (0, 0, 2024, 2024),
         16#81#           =>  --  0781
          (0, 0, 2025, 2025),
         16#82#           =>  --  0782
          (0, 0, 2026, 2026),
         16#83#           =>  --  0783
          (0, 0, 2027, 2027),
         16#84#           =>  --  0784
          (0, 0, 2028, 2028),
         16#85#           =>  --  0785
          (0, 0, 2029, 2029),
         16#86#           =>  --  0786
          (0, 0, 2030, 2030),
         16#87#           =>  --  0787
          (0, 0, 2031, 2031),
         16#88#           =>  --  0788
          (0, 0, 2032, 2032),
         16#89#           =>  --  0789
          (0, 0, 2033, 2033),
         16#8A#           =>  --  078A
          (0, 0, 2034, 2034),
         16#8B#           =>  --  078B
          (0, 0, 2035, 2035),
         16#8C#           =>  --  078C
          (0, 0, 2036, 2036),
         16#8D#           =>  --  078D
          (0, 0, 2037, 2037),
         16#8E#           =>  --  078E
          (0, 0, 2038, 2038),
         16#8F#           =>  --  078F
          (0, 0, 2039, 2039),
         16#90#           =>  --  0790
          (0, 0, 2040, 2040),
         16#91#           =>  --  0791
          (0, 0, 2041, 2041),
         16#92#           =>  --  0792
          (0, 0, 2042, 2042),
         16#93#           =>  --  0793
          (0, 0, 2043, 2043),
         16#94#           =>  --  0794
          (0, 0, 2044, 2044),
         16#95#           =>  --  0795
          (0, 0, 2045, 2045),
         16#96#           =>  --  0796
          (0, 0, 2046, 2046),
         16#97#           =>  --  0797
          (0, 0, 2047, 2047),
         16#98#           =>  --  0798
          (0, 0, 2048, 2048),
         16#99#           =>  --  0799
          (0, 0, 2049, 2049),
         16#9A#           =>  --  079A
          (0, 0, 2050, 2050),
         16#9B#           =>  --  079B
          (0, 0, 2051, 2051),
         16#9C#           =>  --  079C
          (0, 0, 2052, 2052),
         16#9D#           =>  --  079D
          (0, 0, 2053, 2053),
         16#9E#           =>  --  079E
          (0, 0, 2054, 2054),
         16#9F#           =>  --  079F
          (0, 0, 2055, 2055),
         16#A0#           =>  --  07A0
          (0, 0, 2056, 2056),
         16#A1#           =>  --  07A1
          (0, 0, 2057, 2057),
         16#A2#           =>  --  07A2
          (0, 0, 2058, 2058),
         16#A3#           =>  --  07A3
          (0, 0, 2059, 2059),
         16#A4#           =>  --  07A4
          (0, 0, 2060, 2060),
         16#A5#           =>  --  07A5
          (0, 0, 2061, 2061),
         16#A6#           =>  --  07A6
          (0, 0, 2062, 2062),
         16#A7#           =>  --  07A7
          (0, 0, 2063, 2063),
         16#A8#           =>  --  07A8
          (0, 0, 2064, 2064),
         16#A9#           =>  --  07A9
          (0, 0, 2065, 2065),
         16#AA#           =>  --  07AA
          (0, 0, 2066, 2066),
         16#AB#           =>  --  07AB
          (0, 0, 2067, 2067),
         16#AC#           =>  --  07AC
          (0, 0, 2068, 2068),
         16#AD#           =>  --  07AD
          (0, 0, 2069, 2069),
         16#AE#           =>  --  07AE
          (0, 0, 2070, 2070),
         16#AF#           =>  --  07AF
          (0, 0, 2071, 2071),
         16#B0#           =>  --  07B0
          (0, 0, 2072, 2072),
         16#B1#           =>  --  07B1
          (0, 0, 2073, 2073),
         16#C0#           =>  --  07C0
          (0, 0, 23, 23),
         16#C1#           =>  --  07C1
          (0, 0, 24, 24),
         16#C2#           =>  --  07C2
          (0, 0, 25, 25),
         16#C3#           =>  --  07C3
          (0, 0, 26, 26),
         16#C4#           =>  --  07C4
          (0, 0, 27, 27),
         16#C5#           =>  --  07C5
          (0, 0, 28, 28),
         16#C6#           =>  --  07C6
          (0, 0, 29, 29),
         16#C7#           =>  --  07C7
          (0, 0, 30, 30),
         16#C8#           =>  --  07C8
          (0, 0, 31, 31),
         16#C9#           =>  --  07C9
          (0, 0, 32, 32),
         16#CA#           =>  --  07CA
          (0, 0, 2074, 2074),
         16#CB#           =>  --  07CB
          (0, 0, 2075, 2075),
         16#CC#           =>  --  07CC
          (0, 0, 2076, 2076),
         16#CD#           =>  --  07CD
          (0, 0, 2077, 2077),
         16#CE#           =>  --  07CE
          (0, 0, 2078, 2078),
         16#CF#           =>  --  07CF
          (0, 0, 2079, 2079),
         16#D0#           =>  --  07D0
          (0, 0, 2080, 2080),
         16#D1#           =>  --  07D1
          (0, 0, 2081, 2081),
         16#D2#           =>  --  07D2
          (0, 0, 2082, 2082),
         16#D3#           =>  --  07D3
          (0, 0, 2083, 2083),
         16#D4#           =>  --  07D4
          (0, 0, 2084, 2084),
         16#D5#           =>  --  07D5
          (0, 0, 2085, 2085),
         16#D6#           =>  --  07D6
          (0, 0, 2086, 2086),
         16#D7#           =>  --  07D7
          (0, 0, 2087, 2087),
         16#D8#           =>  --  07D8
          (0, 0, 2088, 2088),
         16#D9#           =>  --  07D9
          (0, 0, 2089, 2089),
         16#DA#           =>  --  07DA
          (0, 0, 2090, 2090),
         16#DB#           =>  --  07DB
          (0, 0, 2091, 2091),
         16#DC#           =>  --  07DC
          (0, 0, 2092, 2092),
         16#DD#           =>  --  07DD
          (0, 0, 2093, 2093),
         16#DE#           =>  --  07DE
          (0, 0, 2094, 2094),
         16#DF#           =>  --  07DF
          (0, 0, 2095, 2095),
         16#E0#           =>  --  07E0
          (0, 0, 2096, 2096),
         16#E1#           =>  --  07E1
          (0, 0, 2097, 2097),
         16#E2#           =>  --  07E2
          (0, 0, 2098, 2098),
         16#E3#           =>  --  07E3
          (0, 0, 2099, 2099),
         16#E4#           =>  --  07E4
          (0, 0, 2100, 2100),
         16#E5#           =>  --  07E5
          (0, 0, 2101, 2101),
         16#E6#           =>  --  07E6
          (0, 0, 2102, 2102),
         16#E7#           =>  --  07E7
          (0, 0, 2103, 2103),
         16#E8#           =>  --  07E8
          (0, 0, 2104, 2105),
         16#E9#           =>  --  07E9
          (0, 0, 2106, 2107),
         16#EA#           =>  --  07EA
          (0, 0, 2108, 2109),
         16#EB#           =>  --  07EB
          (0, 0, 2110, 2110),
         16#EC#           =>  --  07EC
          (0, 0, 2111, 2111),
         16#ED#           =>  --  07ED
          (0, 0, 2112, 2112),
         16#EE#           =>  --  07EE
          (0, 0, 2113, 2113),
         16#EF#           =>  --  07EF
          (0, 0, 2114, 2114),
         16#F0#           =>  --  07F0
          (0, 0, 2115, 2115),
         16#F1#           =>  --  07F1
          (0, 0, 2116, 2116),
         16#F2#           =>  --  07F2
          (0, 0, 2117, 2117),
         16#F3#           =>  --  07F3
          (0, 0, 2118, 2118),
         16#F4#           =>  --  07F4
          (0, 0, 2119, 2119),
         16#F5#           =>  --  07F5
          (0, 0, 2120, 2120),
         16#F6#           =>  --  07F6
          (0, 0, 2121, 2121),
         16#F7#           =>  --  07F7
          (0, 0, 2122, 2122),
         16#F8#           =>  --  07F8
          (0, 0, 2123, 2123),
         16#F9#           =>  --  07F9
          (0, 0, 2124, 2124),
         16#FA#           =>  --  07FA
          (0, 0, 1, 1),
         others           =>
          (0, 0, 0, 0));

   Group_0008 : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  0800
          (0, 0, 2125, 2125),
         16#01#           =>  --  0801
          (0, 0, 2126, 2126),
         16#02#           =>  --  0802
          (0, 0, 2127, 2127),
         16#03#           =>  --  0803
          (0, 0, 2128, 2128),
         16#04#           =>  --  0804
          (0, 0, 2129, 2129),
         16#05#           =>  --  0805
          (0, 0, 2130, 2130),
         16#06#           =>  --  0806
          (0, 0, 2131, 2131),
         16#07#           =>  --  0807
          (0, 0, 2132, 2132),
         16#08#           =>  --  0808
          (0, 0, 2133, 2133),
         16#09#           =>  --  0809
          (0, 0, 2134, 2134),
         16#0A#           =>  --  080A
          (0, 0, 2135, 2135),
         16#0B#           =>  --  080B
          (0, 0, 2136, 2136),
         16#0C#           =>  --  080C
          (0, 0, 2137, 2137),
         16#0D#           =>  --  080D
          (0, 0, 2138, 2138),
         16#0E#           =>  --  080E
          (0, 0, 2139, 2139),
         16#0F#           =>  --  080F
          (0, 0, 2140, 2140),
         16#10#           =>  --  0810
          (0, 0, 2141, 2141),
         16#11#           =>  --  0811
          (0, 0, 2142, 2142),
         16#12#           =>  --  0812
          (0, 0, 2143, 2143),
         16#13#           =>  --  0813
          (0, 0, 2144, 2144),
         16#14#           =>  --  0814
          (0, 0, 2145, 2145),
         16#15#           =>  --  0815
          (0, 0, 2146, 2146),
         16#16#           =>  --  0816
          (0, 0, 2147, 2147),
         16#17#           =>  --  0817
          (0, 0, 2148, 2148),
         16#18#           =>  --  0818
          (0, 0, 2149, 2149),
         16#19#           =>  --  0819
          (0, 0, 2150, 2150),
         16#1A#           =>  --  081A
          (0, 0, 2151, 2151),
         16#1B#           =>  --  081B
          (0, 0, 2152, 2152),
         16#1C# .. 16#1D# =>  --  081C .. 081D
          (0, 0, 2153, 2153),
         16#1E# .. 16#20# =>  --  081E .. 0820
          (0, 0, 2154, 2154),
         16#21# .. 16#23# =>  --  0821 .. 0823
          (0, 0, 2155, 2155),
         16#24# .. 16#25# =>  --  0824 .. 0825
          (0, 0, 2156, 2156),
         16#26# .. 16#27# =>  --  0826 .. 0827
          (0, 0, 2157, 2157),
         16#28# .. 16#2A# =>  --  0828 .. 082A
          (0, 0, 2158, 2158),
         16#2B#           =>  --  082B
          (0, 0, 2159, 2159),
         16#2C#           =>  --  082C
          (0, 0, 2160, 2160),
         16#2D#           =>  --  082D
          (0, 0, 2161, 2161),
         16#30#           =>  --  0830
          (0, 0, 2162, 2162),
         16#31#           =>  --  0831
          (0, 0, 2163, 2163),
         16#32#           =>  --  0832
          (0, 0, 2164, 2164),
         16#33#           =>  --  0833
          (0, 0, 2165, 2165),
         16#34#           =>  --  0834
          (0, 0, 2166, 2166),
         16#35#           =>  --  0835
          (0, 0, 2167, 2167),
         16#36#           =>  --  0836
          (0, 0, 2168, 2168),
         16#37#           =>  --  0837
          (0, 0, 2169, 2169),
         16#38#           =>  --  0838
          (0, 0, 2170, 2170),
         16#39#           =>  --  0839
          (0, 0, 2171, 2171),
         16#3A#           =>  --  083A
          (0, 0, 2172, 2172),
         16#3B#           =>  --  083B
          (0, 0, 2173, 2173),
         16#3C#           =>  --  083C
          (0, 0, 2174, 2174),
         16#3D#           =>  --  083D
          (0, 0, 2175, 2175),
         16#3E#           =>  --  083E
          (0, 0, 2176, 2176),
         16#40#           =>  --  0840
          (0, 0, 2177, 2177),
         16#41#           =>  --  0841
          (0, 0, 2178, 2178),
         16#42#           =>  --  0842
          (0, 0, 2179, 2179),
         16#43#           =>  --  0843
          (0, 0, 2180, 2180),
         16#44#           =>  --  0844
          (0, 0, 2181, 2181),
         16#45#           =>  --  0845
          (0, 0, 2182, 2182),
         16#46#           =>  --  0846
          (0, 0, 2183, 2183),
         16#47#           =>  --  0847
          (0, 0, 2184, 2184),
         16#48#           =>  --  0848
          (0, 0, 2185, 2185),
         16#49#           =>  --  0849
          (0, 0, 2186, 2186),
         16#4A#           =>  --  084A
          (0, 0, 2187, 2187),
         16#4B#           =>  --  084B
          (0, 0, 2188, 2188),
         16#4C#           =>  --  084C
          (0, 0, 2189, 2189),
         16#4D#           =>  --  084D
          (0, 0, 2190, 2190),
         16#4E#           =>  --  084E
          (0, 0, 2191, 2191),
         16#4F#           =>  --  084F
          (0, 0, 2192, 2192),
         16#50#           =>  --  0850
          (0, 0, 2193, 2193),
         16#51#           =>  --  0851
          (0, 0, 2194, 2194),
         16#52#           =>  --  0852
          (0, 0, 2195, 2195),
         16#53#           =>  --  0853
          (0, 0, 2196, 2196),
         16#54#           =>  --  0854
          (0, 0, 2197, 2197),
         16#55#           =>  --  0855
          (0, 0, 2198, 2198),
         16#56#           =>  --  0856
          (0, 0, 2199, 2199),
         16#57#           =>  --  0857
          (0, 0, 2200, 2200),
         16#58#           =>  --  0858
          (0, 0, 2201, 2201),
         16#59# .. 16#5B# =>  --  0859 .. 085B
          (0, 0, 1045, 1045),
         16#5E#           =>  --  085E
          (0, 0, 2202, 2202),
         16#A0#           =>  --  08A0
          (0, 0, 2203, 2203),
         16#A1#           =>  --  08A1
          (0, 0, 2204, 2204),
         16#A2#           =>  --  08A2
          (0, 0, 2205, 2205),
         16#A3#           =>  --  08A3
          (0, 0, 2206, 2206),
         16#A4#           =>  --  08A4
          (0, 0, 2207, 2207),
         16#A5#           =>  --  08A5
          (0, 0, 2208, 2208),
         16#A6#           =>  --  08A6
          (0, 0, 2209, 2209),
         16#A7#           =>  --  08A7
          (0, 0, 2210, 2210),
         16#A8#           =>  --  08A8
          (0, 0, 2211, 2211),
         16#A9#           =>  --  08A9
          (0, 0, 2212, 2212),
         16#AA#           =>  --  08AA
          (0, 0, 2213, 2213),
         16#AB#           =>  --  08AB
          (0, 0, 2214, 2214),
         16#AC#           =>  --  08AC
          (0, 0, 2215, 2215),
         16#AD#           =>  --  08AD
          (0, 0, 1790, 1790),
         16#AE#           =>  --  08AE
          (0, 0, 2216, 2216),
         16#AF#           =>  --  08AF
          (0, 0, 2217, 2217),
         16#B0#           =>  --  08B0
          (0, 0, 2218, 2218),
         16#B1#           =>  --  08B1
          (0, 0, 2219, 2219),
         16#B2#           =>  --  08B2
          (0, 0, 2220, 2220),
         16#E4#           =>  --  08E4
          (0, 0, 2221, 2221),
         16#E5#           =>  --  08E5
          (0, 0, 2222, 2222),
         16#E6#           =>  --  08E6
          (0, 0, 2223, 2223),
         16#E7#           =>  --  08E7
          (0, 0, 2224, 2224),
         16#E8#           =>  --  08E8
          (0, 0, 2225, 2225),
         16#E9#           =>  --  08E9
          (0, 0, 2226, 2226),
         16#EA# .. 16#EF# =>  --  08EA .. 08EF
          (0, 0, 1, 1),
         16#F0#           =>  --  08F0
          (0, 0, 2227, 2227),
         16#F1#           =>  --  08F1
          (0, 0, 2228, 2228),
         16#F2#           =>  --  08F2
          (0, 0, 2229, 2229),
         16#F3#           =>  --  08F3
          (0, 0, 1, 1),
         16#F4#           =>  --  08F4
          (0, 0, 2230, 2230),
         16#F5#           =>  --  08F5
          (0, 0, 2231, 2231),
         16#F6#           =>  --  08F6
          (0, 0, 2232, 2232),
         16#F7#           =>  --  08F7
          (0, 0, 2233, 2233),
         16#F8#           =>  --  08F8
          (0, 0, 2234, 2234),
         16#F9#           =>  --  08F9
          (0, 0, 2235, 2235),
         16#FA#           =>  --  08FA
          (0, 0, 2236, 2236),
         16#FB#           =>  --  08FB
          (0, 0, 2237, 2237),
         16#FC#           =>  --  08FC
          (0, 0, 2238, 2238),
         16#FD#           =>  --  08FD
          (0, 0, 2239, 2239),
         16#FE#           =>  --  08FE
          (0, 0, 2240, 2240),
         16#FF#           =>  --  08FF
          (0, 0, 2241, 2241),
         others           =>
          (0, 0, 0, 0));

   Group_0009 : aliased constant Collation_Second_Stage
     := (16#00# .. 16#01# =>  --  0900 .. 0901
          (0, 0, 2242, 2242),
         16#02#           =>  --  0902
          (0, 0, 2243, 2243),
         16#03#           =>  --  0903
          (0, 0, 2244, 2244),
         16#04#           =>  --  0904
          (0, 0, 2245, 2245),
         16#05#           =>  --  0905
          (0, 0, 2246, 2246),
         16#06#           =>  --  0906
          (0, 0, 2247, 2247),
         16#07#           =>  --  0907
          (0, 0, 2248, 2248),
         16#08#           =>  --  0908
          (0, 0, 2249, 2249),
         16#09#           =>  --  0909
          (0, 0, 2250, 2250),
         16#0A#           =>  --  090A
          (0, 0, 2251, 2251),
         16#0B#           =>  --  090B
          (0, 0, 2252, 2252),
         16#0C#           =>  --  090C
          (0, 0, 2253, 2253),
         16#0D#           =>  --  090D
          (0, 0, 2254, 2254),
         16#0E#           =>  --  090E
          (0, 0, 2255, 2255),
         16#0F#           =>  --  090F
          (0, 0, 2256, 2256),
         16#10#           =>  --  0910
          (0, 0, 2257, 2257),
         16#11#           =>  --  0911
          (0, 0, 2258, 2258),
         16#12#           =>  --  0912
          (0, 0, 2259, 2259),
         16#13#           =>  --  0913
          (0, 0, 2260, 2260),
         16#14#           =>  --  0914
          (0, 0, 2261, 2261),
         16#15#           =>  --  0915
          (0, 0, 2262, 2262),
         16#16#           =>  --  0916
          (0, 0, 2263, 2263),
         16#17#           =>  --  0917
          (0, 0, 2264, 2264),
         16#18#           =>  --  0918
          (0, 0, 2265, 2265),
         16#19#           =>  --  0919
          (0, 0, 2266, 2266),
         16#1A#           =>  --  091A
          (0, 0, 2267, 2267),
         16#1B#           =>  --  091B
          (0, 0, 2268, 2268),
         16#1C#           =>  --  091C
          (0, 0, 2269, 2269),
         16#1D#           =>  --  091D
          (0, 0, 2270, 2270),
         16#1E#           =>  --  091E
          (0, 0, 2271, 2271),
         16#1F#           =>  --  091F
          (0, 0, 2272, 2272),
         16#20#           =>  --  0920
          (0, 0, 2273, 2273),
         16#21#           =>  --  0921
          (0, 0, 2274, 2274),
         16#22#           =>  --  0922
          (0, 0, 2275, 2275),
         16#23#           =>  --  0923
          (0, 0, 2276, 2276),
         16#24#           =>  --  0924
          (0, 0, 2277, 2277),
         16#25#           =>  --  0925
          (0, 0, 2278, 2278),
         16#26#           =>  --  0926
          (0, 0, 2279, 2279),
         16#27#           =>  --  0927
          (0, 0, 2280, 2280),
         16#28#           =>  --  0928
          (0, 0, 2281, 2281),
         16#29#           =>  --  0929
          (0, 0, 2282, 2283),
         16#2A#           =>  --  092A
          (0, 0, 2284, 2284),
         16#2B#           =>  --  092B
          (0, 0, 2285, 2285),
         16#2C#           =>  --  092C
          (0, 0, 2286, 2286),
         16#2D#           =>  --  092D
          (0, 0, 2287, 2287),
         16#2E#           =>  --  092E
          (0, 0, 2288, 2288),
         16#2F#           =>  --  092F
          (0, 0, 2289, 2289),
         16#30#           =>  --  0930
          (0, 0, 2290, 2290),
         16#31#           =>  --  0931
          (0, 0, 2291, 2292),
         16#32#           =>  --  0932
          (0, 0, 2293, 2293),
         16#33#           =>  --  0933
          (0, 0, 2294, 2294),
         16#34#           =>  --  0934
          (0, 0, 2295, 2296),
         16#35#           =>  --  0935
          (0, 0, 2297, 2297),
         16#36#           =>  --  0936
          (0, 0, 2298, 2298),
         16#37#           =>  --  0937
          (0, 0, 2299, 2299),
         16#38#           =>  --  0938
          (0, 0, 2300, 2300),
         16#39#           =>  --  0939
          (0, 0, 2301, 2301),
         16#3A#           =>  --  093A
          (0, 0, 2302, 2302),
         16#3B#           =>  --  093B
          (0, 0, 2303, 2303),
         16#3C#           =>  --  093C
          (0, 0, 2283, 2283),
         16#3D#           =>  --  093D
          (0, 0, 2304, 2304),
         16#3E#           =>  --  093E
          (0, 0, 2305, 2305),
         16#3F#           =>  --  093F
          (0, 0, 2306, 2306),
         16#40#           =>  --  0940
          (0, 0, 2307, 2307),
         16#41#           =>  --  0941
          (0, 0, 2308, 2308),
         16#42#           =>  --  0942
          (0, 0, 2309, 2309),
         16#43#           =>  --  0943
          (0, 0, 2310, 2310),
         16#44#           =>  --  0944
          (0, 0, 2311, 2311),
         16#45#           =>  --  0945
          (0, 0, 2312, 2312),
         16#46#           =>  --  0946
          (0, 0, 2313, 2313),
         16#47#           =>  --  0947
          (0, 0, 2314, 2314),
         16#48#           =>  --  0948
          (0, 0, 2315, 2315),
         16#49#           =>  --  0949
          (0, 0, 2316, 2316),
         16#4A#           =>  --  094A
          (0, 0, 2317, 2317),
         16#4B#           =>  --  094B
          (0, 0, 2318, 2318),
         16#4C#           =>  --  094C
          (0, 0, 2319, 2319),
         16#4D#           =>  --  094D
          (0, 0, 2320, 2320),
         16#4E#           =>  --  094E
          (0, 0, 2321, 2321),
         16#4F#           =>  --  094F
          (0, 0, 2322, 2322),
         16#50#           =>  --  0950
          (0, 0, 2323, 2323),
         16#51# .. 16#52# =>  --  0951 .. 0952
          (0, 0, 1, 1),
         16#53#           =>  --  0953
          (0, 0, 145, 145),
         16#54#           =>  --  0954
          (0, 0, 147, 147),
         16#55#           =>  --  0955
          (0, 0, 2324, 2324),
         16#56#           =>  --  0956
          (0, 0, 2325, 2325),
         16#57#           =>  --  0957
          (0, 0, 2326, 2326),
         16#58#           =>  --  0958
          (0, 0, 2327, 2328),
         16#59#           =>  --  0959
          (0, 0, 2329, 2330),
         16#5A#           =>  --  095A
          (0, 0, 2331, 2332),
         16#5B#           =>  --  095B
          (0, 0, 2333, 2334),
         16#5C#           =>  --  095C
          (0, 0, 2335, 2336),
         16#5D#           =>  --  095D
          (0, 0, 2337, 2338),
         16#5E#           =>  --  095E
          (0, 0, 2339, 2340),
         16#5F#           =>  --  095F
          (0, 0, 2341, 2342),
         16#60#           =>  --  0960
          (0, 0, 2343, 2343),
         16#61#           =>  --  0961
          (0, 0, 2344, 2344),
         16#62#           =>  --  0962
          (0, 0, 2345, 2345),
         16#63#           =>  --  0963
          (0, 0, 2346, 2346),
         16#64#           =>  --  0964
          (0, 0, 2347, 2347),
         16#65#           =>  --  0965
          (0, 0, 2348, 2348),
         16#66#           =>  --  0966
          (0, 0, 23, 23),
         16#67#           =>  --  0967
          (0, 0, 24, 24),
         16#68#           =>  --  0968
          (0, 0, 25, 25),
         16#69#           =>  --  0969
          (0, 0, 26, 26),
         16#6A#           =>  --  096A
          (0, 0, 27, 27),
         16#6B#           =>  --  096B
          (0, 0, 28, 28),
         16#6C#           =>  --  096C
          (0, 0, 29, 29),
         16#6D#           =>  --  096D
          (0, 0, 30, 30),
         16#6E#           =>  --  096E
          (0, 0, 31, 31),
         16#6F#           =>  --  096F
          (0, 0, 32, 32),
         16#70#           =>  --  0970
          (0, 0, 2349, 2349),
         16#71#           =>  --  0971
          (0, 0, 2350, 2350),
         16#72#           =>  --  0972
          (0, 0, 2351, 2351),
         16#73#           =>  --  0973
          (0, 0, 2352, 2352),
         16#74#           =>  --  0974
          (0, 0, 2353, 2353),
         16#75#           =>  --  0975
          (0, 0, 2354, 2354),
         16#76#           =>  --  0976
          (0, 0, 2355, 2355),
         16#77#           =>  --  0977
          (0, 0, 2356, 2356),
         16#78#           =>  --  0978
          (0, 0, 2357, 2357),
         16#79#           =>  --  0979
          (0, 0, 2358, 2358),
         16#7A#           =>  --  097A
          (0, 0, 2359, 2359),
         16#7B#           =>  --  097B
          (0, 0, 2360, 2360),
         16#7C#           =>  --  097C
          (0, 0, 2361, 2361),
         16#7D#           =>  --  097D
          (0, 0, 2362, 2362),
         16#7E#           =>  --  097E
          (0, 0, 2363, 2363),
         16#7F#           =>  --  097F
          (0, 0, 2364, 2364),
         16#80#           =>  --  0980
          (0, 0, 2365, 2365),
         16#81#           =>  --  0981
          (0, 0, 2242, 2242),
         16#82#           =>  --  0982
          (0, 0, 2243, 2243),
         16#83#           =>  --  0983
          (0, 0, 2244, 2244),
         16#85#           =>  --  0985
          (0, 0, 2366, 2366),
         16#86#           =>  --  0986
          (0, 0, 2367, 2367),
         16#87#           =>  --  0987
          (0, 0, 2368, 2368),
         16#88#           =>  --  0988
          (0, 0, 2369, 2369),
         16#89#           =>  --  0989
          (0, 0, 2370, 2370),
         16#8A#           =>  --  098A
          (0, 0, 2371, 2371),
         16#8B#           =>  --  098B
          (0, 0, 2372, 2372),
         16#8C#           =>  --  098C
          (0, 0, 2373, 2373),
         16#8F#           =>  --  098F
          (0, 0, 2374, 2374),
         16#90#           =>  --  0990
          (0, 0, 2375, 2375),
         16#93#           =>  --  0993
          (0, 0, 2376, 2376),
         16#94#           =>  --  0994
          (0, 0, 2377, 2377),
         16#95#           =>  --  0995
          (0, 0, 2378, 2378),
         16#96#           =>  --  0996
          (0, 0, 2379, 2379),
         16#97#           =>  --  0997
          (0, 0, 2380, 2380),
         16#98#           =>  --  0998
          (0, 0, 2381, 2381),
         16#99#           =>  --  0999
          (0, 0, 2382, 2382),
         16#9A#           =>  --  099A
          (0, 0, 2383, 2383),
         16#9B#           =>  --  099B
          (0, 0, 2384, 2384),
         16#9C#           =>  --  099C
          (0, 0, 2385, 2385),
         16#9D#           =>  --  099D
          (0, 0, 2386, 2386),
         16#9E#           =>  --  099E
          (0, 0, 2387, 2387),
         16#9F#           =>  --  099F
          (0, 0, 2388, 2388),
         16#A0#           =>  --  09A0
          (0, 0, 2389, 2389),
         16#A1#           =>  --  09A1
          (0, 0, 2390, 2390),
         16#A2#           =>  --  09A2
          (0, 0, 2391, 2391),
         16#A3#           =>  --  09A3
          (0, 0, 2392, 2392),
         16#A4#           =>  --  09A4
          (0, 0, 2393, 2393),
         16#A5#           =>  --  09A5
          (0, 0, 2394, 2394),
         16#A6#           =>  --  09A6
          (0, 0, 2395, 2395),
         16#A7#           =>  --  09A7
          (0, 0, 2396, 2396),
         16#A8#           =>  --  09A8
          (0, 0, 2397, 2397),
         16#AA#           =>  --  09AA
          (0, 0, 2398, 2398),
         16#AB#           =>  --  09AB
          (0, 0, 2399, 2399),
         16#AC#           =>  --  09AC
          (0, 0, 2400, 2400),
         16#AD#           =>  --  09AD
          (0, 0, 2401, 2401),
         16#AE#           =>  --  09AE
          (0, 0, 2402, 2402),
         16#AF#           =>  --  09AF
          (0, 0, 2403, 2403),
         16#B0#           =>  --  09B0
          (0, 0, 2404, 2404),
         16#B2#           =>  --  09B2
          (0, 0, 2405, 2405),
         16#B6#           =>  --  09B6
          (0, 0, 2406, 2406),
         16#B7#           =>  --  09B7
          (0, 0, 2407, 2407),
         16#B8#           =>  --  09B8
          (0, 0, 2408, 2408),
         16#B9#           =>  --  09B9
          (0, 0, 2409, 2409),
         16#BC#           =>  --  09BC
          (0, 0, 2283, 2283),
         16#BD#           =>  --  09BD
          (0, 0, 2410, 2410),
         16#BE#           =>  --  09BE
          (0, 0, 2411, 2411),
         16#BF#           =>  --  09BF
          (0, 0, 2412, 2412),
         16#C0#           =>  --  09C0
          (0, 0, 2413, 2413),
         16#C1#           =>  --  09C1
          (0, 0, 2414, 2414),
         16#C2#           =>  --  09C2
          (0, 0, 2415, 2415),
         16#C3#           =>  --  09C3
          (0, 0, 2416, 2416),
         16#C4#           =>  --  09C4
          (0, 0, 2417, 2417),
         16#C7#           =>  --  09C7
          (12, 13, 2418, 2418),
         16#C8#           =>  --  09C8
          (0, 0, 2421, 2421),
         16#CB#           =>  --  09CB
          (0, 0, 2419, 2419),
         16#CC#           =>  --  09CC
          (0, 0, 2420, 2420),
         16#CD#           =>  --  09CD
          (0, 0, 2422, 2422),
         16#CE#           =>  --  09CE
          (0, 0, 2423, 2424),
         16#D7#           =>  --  09D7
          (0, 0, 2425, 2425),
         16#DC#           =>  --  09DC
          (0, 0, 2426, 2427),
         16#DD#           =>  --  09DD
          (0, 0, 2428, 2429),
         16#DF#           =>  --  09DF
          (0, 0, 2430, 2431),
         16#E0#           =>  --  09E0
          (0, 0, 2432, 2432),
         16#E1#           =>  --  09E1
          (0, 0, 2433, 2433),
         16#E2#           =>  --  09E2
          (0, 0, 2434, 2434),
         16#E3#           =>  --  09E3
          (0, 0, 2435, 2435),
         16#E6#           =>  --  09E6
          (0, 0, 23, 23),
         16#E7#           =>  --  09E7
          (0, 0, 24, 24),
         16#E8#           =>  --  09E8
          (0, 0, 25, 25),
         16#E9#           =>  --  09E9
          (0, 0, 26, 26),
         16#EA#           =>  --  09EA
          (0, 0, 27, 27),
         16#EB#           =>  --  09EB
          (0, 0, 28, 28),
         16#EC#           =>  --  09EC
          (0, 0, 29, 29),
         16#ED#           =>  --  09ED
          (0, 0, 30, 30),
         16#EE#           =>  --  09EE
          (0, 0, 31, 31),
         16#EF#           =>  --  09EF
          (0, 0, 32, 32),
         16#F0#           =>  --  09F0
          (0, 0, 2436, 2436),
         16#F1#           =>  --  09F1
          (0, 0, 2437, 2437),
         16#F2#           =>  --  09F2
          (0, 0, 2438, 2438),
         16#F3#           =>  --  09F3
          (0, 0, 2439, 2439),
         16#F4#           =>  --  09F4
          (0, 0, 2440, 2440),
         16#F5#           =>  --  09F5
          (0, 0, 2441, 2441),
         16#F6#           =>  --  09F6
          (0, 0, 2442, 2442),
         16#F7#           =>  --  09F7
          (0, 0, 2443, 2443),
         16#F8#           =>  --  09F8
          (0, 0, 2444, 2444),
         16#F9#           =>  --  09F9
          (0, 0, 2445, 2445),
         16#FA#           =>  --  09FA
          (0, 0, 2446, 2446),
         16#FB#           =>  --  09FB
          (0, 0, 2447, 2447),
         others           =>
          (0, 0, 0, 0));

   Group_000A : aliased constant Collation_Second_Stage
     := (16#01#           =>  --  0A01
          (0, 0, 2242, 2242),
         16#02#           =>  --  0A02
          (0, 0, 2243, 2243),
         16#03#           =>  --  0A03
          (0, 0, 2244, 2244),
         16#05#           =>  --  0A05
          (0, 0, 2448, 2448),
         16#06#           =>  --  0A06
          (0, 0, 2449, 2449),
         16#07#           =>  --  0A07
          (0, 0, 2450, 2450),
         16#08#           =>  --  0A08
          (0, 0, 2451, 2451),
         16#09#           =>  --  0A09
          (0, 0, 2452, 2452),
         16#0A#           =>  --  0A0A
          (0, 0, 2453, 2453),
         16#0F#           =>  --  0A0F
          (0, 0, 2454, 2454),
         16#10#           =>  --  0A10
          (0, 0, 2455, 2455),
         16#13#           =>  --  0A13
          (0, 0, 2456, 2456),
         16#14#           =>  --  0A14
          (0, 0, 2457, 2457),
         16#15#           =>  --  0A15
          (0, 0, 2458, 2458),
         16#16#           =>  --  0A16
          (0, 0, 2459, 2459),
         16#17#           =>  --  0A17
          (0, 0, 2460, 2460),
         16#18#           =>  --  0A18
          (0, 0, 2461, 2461),
         16#19#           =>  --  0A19
          (0, 0, 2462, 2462),
         16#1A#           =>  --  0A1A
          (0, 0, 2463, 2463),
         16#1B#           =>  --  0A1B
          (0, 0, 2464, 2464),
         16#1C#           =>  --  0A1C
          (0, 0, 2465, 2465),
         16#1D#           =>  --  0A1D
          (0, 0, 2466, 2466),
         16#1E#           =>  --  0A1E
          (0, 0, 2467, 2467),
         16#1F#           =>  --  0A1F
          (0, 0, 2468, 2468),
         16#20#           =>  --  0A20
          (0, 0, 2469, 2469),
         16#21#           =>  --  0A21
          (0, 0, 2470, 2470),
         16#22#           =>  --  0A22
          (0, 0, 2471, 2471),
         16#23#           =>  --  0A23
          (0, 0, 2472, 2472),
         16#24#           =>  --  0A24
          (0, 0, 2473, 2473),
         16#25#           =>  --  0A25
          (0, 0, 2474, 2474),
         16#26#           =>  --  0A26
          (0, 0, 2475, 2475),
         16#27#           =>  --  0A27
          (0, 0, 2476, 2476),
         16#28#           =>  --  0A28
          (0, 0, 2477, 2477),
         16#2A#           =>  --  0A2A
          (0, 0, 2478, 2478),
         16#2B#           =>  --  0A2B
          (0, 0, 2479, 2479),
         16#2C#           =>  --  0A2C
          (0, 0, 2480, 2480),
         16#2D#           =>  --  0A2D
          (0, 0, 2481, 2481),
         16#2E#           =>  --  0A2E
          (0, 0, 2482, 2482),
         16#2F#           =>  --  0A2F
          (0, 0, 2483, 2483),
         16#30#           =>  --  0A30
          (0, 0, 2484, 2484),
         16#32#           =>  --  0A32
          (0, 0, 2485, 2485),
         16#33#           =>  --  0A33
          (0, 0, 2486, 2487),
         16#35#           =>  --  0A35
          (0, 0, 2488, 2488),
         16#36#           =>  --  0A36
          (0, 0, 2489, 2490),
         16#38#           =>  --  0A38
          (0, 0, 2489, 2489),
         16#39#           =>  --  0A39
          (0, 0, 2491, 2491),
         16#3C#           =>  --  0A3C
          (0, 0, 2283, 2283),
         16#3E#           =>  --  0A3E
          (0, 0, 2492, 2492),
         16#3F#           =>  --  0A3F
          (0, 0, 2493, 2493),
         16#40#           =>  --  0A40
          (0, 0, 2494, 2494),
         16#41#           =>  --  0A41
          (0, 0, 2495, 2495),
         16#42#           =>  --  0A42
          (0, 0, 2496, 2496),
         16#47#           =>  --  0A47
          (0, 0, 2497, 2497),
         16#48#           =>  --  0A48
          (0, 0, 2498, 2498),
         16#4B#           =>  --  0A4B
          (0, 0, 2499, 2499),
         16#4C#           =>  --  0A4C
          (0, 0, 2500, 2500),
         16#4D#           =>  --  0A4D
          (0, 0, 2501, 2501),
         16#51#           =>  --  0A51
          (0, 0, 2502, 2502),
         16#59#           =>  --  0A59
          (0, 0, 2503, 2504),
         16#5A#           =>  --  0A5A
          (0, 0, 2505, 2506),
         16#5B#           =>  --  0A5B
          (0, 0, 2507, 2508),
         16#5C#           =>  --  0A5C
          (0, 0, 2509, 2509),
         16#5E#           =>  --  0A5E
          (0, 0, 2510, 2511),
         16#66#           =>  --  0A66
          (0, 0, 23, 23),
         16#67#           =>  --  0A67
          (0, 0, 24, 24),
         16#68#           =>  --  0A68
          (0, 0, 25, 25),
         16#69#           =>  --  0A69
          (0, 0, 26, 26),
         16#6A#           =>  --  0A6A
          (0, 0, 27, 27),
         16#6B#           =>  --  0A6B
          (0, 0, 28, 28),
         16#6C#           =>  --  0A6C
          (0, 0, 29, 29),
         16#6D#           =>  --  0A6D
          (0, 0, 30, 30),
         16#6E#           =>  --  0A6E
          (0, 0, 31, 31),
         16#6F#           =>  --  0A6F
          (0, 0, 32, 32),
         16#70#           =>  --  0A70
          (0, 0, 2512, 2512),
         16#71#           =>  --  0A71
          (0, 0, 2513, 2513),
         16#72#           =>  --  0A72
          (0, 0, 2514, 2514),
         16#73#           =>  --  0A73
          (0, 0, 2515, 2515),
         16#74#           =>  --  0A74
          (0, 0, 2516, 2516),
         16#75#           =>  --  0A75
          (0, 0, 2517, 2517),
         16#81#           =>  --  0A81
          (0, 0, 2242, 2242),
         16#82#           =>  --  0A82
          (0, 0, 2243, 2243),
         16#83#           =>  --  0A83
          (0, 0, 2244, 2244),
         16#85#           =>  --  0A85
          (0, 0, 2518, 2518),
         16#86#           =>  --  0A86
          (0, 0, 2519, 2519),
         16#87#           =>  --  0A87
          (0, 0, 2520, 2520),
         16#88#           =>  --  0A88
          (0, 0, 2521, 2521),
         16#89#           =>  --  0A89
          (0, 0, 2522, 2522),
         16#8A#           =>  --  0A8A
          (0, 0, 2523, 2523),
         16#8B#           =>  --  0A8B
          (0, 0, 2524, 2524),
         16#8C#           =>  --  0A8C
          (0, 0, 2525, 2525),
         16#8D#           =>  --  0A8D
          (0, 0, 2526, 2526),
         16#8F#           =>  --  0A8F
          (0, 0, 2527, 2527),
         16#90#           =>  --  0A90
          (0, 0, 2528, 2528),
         16#91#           =>  --  0A91
          (0, 0, 2529, 2529),
         16#93#           =>  --  0A93
          (0, 0, 2530, 2530),
         16#94#           =>  --  0A94
          (0, 0, 2531, 2531),
         16#95#           =>  --  0A95
          (0, 0, 2532, 2532),
         16#96#           =>  --  0A96
          (0, 0, 2533, 2533),
         16#97#           =>  --  0A97
          (0, 0, 2534, 2534),
         16#98#           =>  --  0A98
          (0, 0, 2535, 2535),
         16#99#           =>  --  0A99
          (0, 0, 2536, 2536),
         16#9A#           =>  --  0A9A
          (0, 0, 2537, 2537),
         16#9B#           =>  --  0A9B
          (0, 0, 2538, 2538),
         16#9C#           =>  --  0A9C
          (0, 0, 2539, 2539),
         16#9D#           =>  --  0A9D
          (0, 0, 2540, 2540),
         16#9E#           =>  --  0A9E
          (0, 0, 2541, 2541),
         16#9F#           =>  --  0A9F
          (0, 0, 2542, 2542),
         16#A0#           =>  --  0AA0
          (0, 0, 2543, 2543),
         16#A1#           =>  --  0AA1
          (0, 0, 2544, 2544),
         16#A2#           =>  --  0AA2
          (0, 0, 2545, 2545),
         16#A3#           =>  --  0AA3
          (0, 0, 2546, 2546),
         16#A4#           =>  --  0AA4
          (0, 0, 2547, 2547),
         16#A5#           =>  --  0AA5
          (0, 0, 2548, 2548),
         16#A6#           =>  --  0AA6
          (0, 0, 2549, 2549),
         16#A7#           =>  --  0AA7
          (0, 0, 2550, 2550),
         16#A8#           =>  --  0AA8
          (0, 0, 2551, 2551),
         16#AA#           =>  --  0AAA
          (0, 0, 2552, 2552),
         16#AB#           =>  --  0AAB
          (0, 0, 2553, 2553),
         16#AC#           =>  --  0AAC
          (0, 0, 2554, 2554),
         16#AD#           =>  --  0AAD
          (0, 0, 2555, 2555),
         16#AE#           =>  --  0AAE
          (0, 0, 2556, 2556),
         16#AF#           =>  --  0AAF
          (0, 0, 2557, 2557),
         16#B0#           =>  --  0AB0
          (0, 0, 2558, 2558),
         16#B2#           =>  --  0AB2
          (0, 0, 2559, 2559),
         16#B3#           =>  --  0AB3
          (0, 0, 2560, 2560),
         16#B5#           =>  --  0AB5
          (0, 0, 2561, 2561),
         16#B6#           =>  --  0AB6
          (0, 0, 2562, 2562),
         16#B7#           =>  --  0AB7
          (0, 0, 2563, 2563),
         16#B8#           =>  --  0AB8
          (0, 0, 2564, 2564),
         16#B9#           =>  --  0AB9
          (0, 0, 2565, 2565),
         16#BC#           =>  --  0ABC
          (0, 0, 2283, 2283),
         16#BD#           =>  --  0ABD
          (0, 0, 2566, 2566),
         16#BE#           =>  --  0ABE
          (0, 0, 2567, 2567),
         16#BF#           =>  --  0ABF
          (0, 0, 2568, 2568),
         16#C0#           =>  --  0AC0
          (0, 0, 2569, 2569),
         16#C1#           =>  --  0AC1
          (0, 0, 2570, 2570),
         16#C2#           =>  --  0AC2
          (0, 0, 2571, 2571),
         16#C3#           =>  --  0AC3
          (0, 0, 2572, 2572),
         16#C4#           =>  --  0AC4
          (0, 0, 2573, 2573),
         16#C5#           =>  --  0AC5
          (0, 0, 2574, 2574),
         16#C7#           =>  --  0AC7
          (0, 0, 2575, 2575),
         16#C8#           =>  --  0AC8
          (0, 0, 2576, 2576),
         16#C9#           =>  --  0AC9
          (0, 0, 2577, 2577),
         16#CB#           =>  --  0ACB
          (0, 0, 2578, 2578),
         16#CC#           =>  --  0ACC
          (0, 0, 2579, 2579),
         16#CD#           =>  --  0ACD
          (0, 0, 2580, 2580),
         16#D0#           =>  --  0AD0
          (0, 0, 2581, 2581),
         16#E0#           =>  --  0AE0
          (0, 0, 2582, 2582),
         16#E1#           =>  --  0AE1
          (0, 0, 2583, 2583),
         16#E2#           =>  --  0AE2
          (0, 0, 2584, 2584),
         16#E3#           =>  --  0AE3
          (0, 0, 2585, 2585),
         16#E6#           =>  --  0AE6
          (0, 0, 23, 23),
         16#E7#           =>  --  0AE7
          (0, 0, 24, 24),
         16#E8#           =>  --  0AE8
          (0, 0, 25, 25),
         16#E9#           =>  --  0AE9
          (0, 0, 26, 26),
         16#EA#           =>  --  0AEA
          (0, 0, 27, 27),
         16#EB#           =>  --  0AEB
          (0, 0, 28, 28),
         16#EC#           =>  --  0AEC
          (0, 0, 29, 29),
         16#ED#           =>  --  0AED
          (0, 0, 30, 30),
         16#EE#           =>  --  0AEE
          (0, 0, 31, 31),
         16#EF#           =>  --  0AEF
          (0, 0, 32, 32),
         16#F0#           =>  --  0AF0
          (0, 0, 2586, 2586),
         16#F1#           =>  --  0AF1
          (0, 0, 2587, 2587),
         others           =>
          (0, 0, 0, 0));

   Group_000B : aliased constant Collation_Second_Stage
     := (16#01#           =>  --  0B01
          (0, 0, 2242, 2242),
         16#02#           =>  --  0B02
          (0, 0, 2243, 2243),
         16#03#           =>  --  0B03
          (0, 0, 2244, 2244),
         16#05#           =>  --  0B05
          (0, 0, 2588, 2588),
         16#06#           =>  --  0B06
          (0, 0, 2589, 2589),
         16#07#           =>  --  0B07
          (0, 0, 2590, 2590),
         16#08#           =>  --  0B08
          (0, 0, 2591, 2591),
         16#09#           =>  --  0B09
          (0, 0, 2592, 2592),
         16#0A#           =>  --  0B0A
          (0, 0, 2593, 2593),
         16#0B#           =>  --  0B0B
          (0, 0, 2594, 2594),
         16#0C#           =>  --  0B0C
          (0, 0, 2595, 2595),
         16#0F#           =>  --  0B0F
          (0, 0, 2596, 2596),
         16#10#           =>  --  0B10
          (0, 0, 2597, 2597),
         16#13#           =>  --  0B13
          (0, 0, 2598, 2598),
         16#14#           =>  --  0B14
          (0, 0, 2599, 2599),
         16#15#           =>  --  0B15
          (0, 0, 2600, 2600),
         16#16#           =>  --  0B16
          (0, 0, 2601, 2601),
         16#17#           =>  --  0B17
          (0, 0, 2602, 2602),
         16#18#           =>  --  0B18
          (0, 0, 2603, 2603),
         16#19#           =>  --  0B19
          (0, 0, 2604, 2604),
         16#1A#           =>  --  0B1A
          (0, 0, 2605, 2605),
         16#1B#           =>  --  0B1B
          (0, 0, 2606, 2606),
         16#1C#           =>  --  0B1C
          (0, 0, 2607, 2607),
         16#1D#           =>  --  0B1D
          (0, 0, 2608, 2608),
         16#1E#           =>  --  0B1E
          (0, 0, 2609, 2609),
         16#1F#           =>  --  0B1F
          (0, 0, 2610, 2610),
         16#20#           =>  --  0B20
          (0, 0, 2611, 2611),
         16#21#           =>  --  0B21
          (0, 0, 2612, 2612),
         16#22#           =>  --  0B22
          (0, 0, 2613, 2613),
         16#23#           =>  --  0B23
          (0, 0, 2614, 2614),
         16#24#           =>  --  0B24
          (0, 0, 2615, 2615),
         16#25#           =>  --  0B25
          (0, 0, 2616, 2616),
         16#26#           =>  --  0B26
          (0, 0, 2617, 2617),
         16#27#           =>  --  0B27
          (0, 0, 2618, 2618),
         16#28#           =>  --  0B28
          (0, 0, 2619, 2619),
         16#2A#           =>  --  0B2A
          (0, 0, 2620, 2620),
         16#2B#           =>  --  0B2B
          (0, 0, 2621, 2621),
         16#2C#           =>  --  0B2C
          (0, 0, 2622, 2622),
         16#2D#           =>  --  0B2D
          (0, 0, 2623, 2623),
         16#2E#           =>  --  0B2E
          (0, 0, 2624, 2624),
         16#2F#           =>  --  0B2F
          (0, 0, 2625, 2625),
         16#30#           =>  --  0B30
          (0, 0, 2626, 2626),
         16#32#           =>  --  0B32
          (0, 0, 2627, 2627),
         16#33#           =>  --  0B33
          (0, 0, 2628, 2628),
         16#35#           =>  --  0B35
          (0, 0, 2629, 2629),
         16#36#           =>  --  0B36
          (0, 0, 2630, 2630),
         16#37#           =>  --  0B37
          (0, 0, 2631, 2631),
         16#38#           =>  --  0B38
          (0, 0, 2632, 2632),
         16#39#           =>  --  0B39
          (0, 0, 2633, 2633),
         16#3C#           =>  --  0B3C
          (0, 0, 2283, 2283),
         16#3D#           =>  --  0B3D
          (0, 0, 2634, 2634),
         16#3E#           =>  --  0B3E
          (0, 0, 2635, 2635),
         16#3F#           =>  --  0B3F
          (0, 0, 2636, 2636),
         16#40#           =>  --  0B40
          (0, 0, 2637, 2637),
         16#41#           =>  --  0B41
          (0, 0, 2638, 2638),
         16#42#           =>  --  0B42
          (0, 0, 2639, 2639),
         16#43#           =>  --  0B43
          (0, 0, 2640, 2640),
         16#44#           =>  --  0B44
          (0, 0, 2641, 2641),
         16#47#           =>  --  0B47
          (14, 16, 2642, 2642),
         16#48#           =>  --  0B48
          (0, 0, 2643, 2643),
         16#4B#           =>  --  0B4B
          (0, 0, 2644, 2644),
         16#4C#           =>  --  0B4C
          (0, 0, 2645, 2645),
         16#4D#           =>  --  0B4D
          (0, 0, 2646, 2646),
         16#56#           =>  --  0B56
          (0, 0, 2647, 2647),
         16#57#           =>  --  0B57
          (0, 0, 2648, 2648),
         16#5C#           =>  --  0B5C
          (0, 0, 2649, 2650),
         16#5D#           =>  --  0B5D
          (0, 0, 2651, 2652),
         16#5F#           =>  --  0B5F
          (0, 0, 2653, 2653),
         16#60#           =>  --  0B60
          (0, 0, 2654, 2654),
         16#61#           =>  --  0B61
          (0, 0, 2655, 2655),
         16#62#           =>  --  0B62
          (0, 0, 2656, 2656),
         16#63#           =>  --  0B63
          (0, 0, 2657, 2657),
         16#66#           =>  --  0B66
          (0, 0, 23, 23),
         16#67#           =>  --  0B67
          (0, 0, 24, 24),
         16#68#           =>  --  0B68
          (0, 0, 25, 25),
         16#69#           =>  --  0B69
          (0, 0, 26, 26),
         16#6A#           =>  --  0B6A
          (0, 0, 27, 27),
         16#6B#           =>  --  0B6B
          (0, 0, 28, 28),
         16#6C#           =>  --  0B6C
          (0, 0, 29, 29),
         16#6D#           =>  --  0B6D
          (0, 0, 30, 30),
         16#6E#           =>  --  0B6E
          (0, 0, 31, 31),
         16#6F#           =>  --  0B6F
          (0, 0, 32, 32),
         16#70#           =>  --  0B70
          (0, 0, 2658, 2658),
         16#71#           =>  --  0B71
          (0, 0, 2659, 2659),
         16#72#           =>  --  0B72
          (0, 0, 2660, 2660),
         16#73#           =>  --  0B73
          (0, 0, 2661, 2661),
         16#74#           =>  --  0B74
          (0, 0, 2662, 2662),
         16#75#           =>  --  0B75
          (0, 0, 2663, 2663),
         16#76#           =>  --  0B76
          (0, 0, 2664, 2664),
         16#77#           =>  --  0B77
          (0, 0, 2665, 2665),
         16#82#           =>  --  0B82
          (0, 0, 2243, 2243),
         16#83#           =>  --  0B83
          (0, 0, 2666, 2666),
         16#85#           =>  --  0B85
          (0, 0, 2667, 2667),
         16#86#           =>  --  0B86
          (0, 0, 2668, 2668),
         16#87#           =>  --  0B87
          (0, 0, 2669, 2669),
         16#88#           =>  --  0B88
          (0, 0, 2670, 2670),
         16#89#           =>  --  0B89
          (0, 0, 2671, 2671),
         16#8A#           =>  --  0B8A
          (0, 0, 2672, 2672),
         16#8E#           =>  --  0B8E
          (0, 0, 2673, 2673),
         16#8F#           =>  --  0B8F
          (0, 0, 2674, 2674),
         16#90#           =>  --  0B90
          (0, 0, 2675, 2675),
         16#92#           =>  --  0B92
          (17, 17, 2676, 2676),
         16#93#           =>  --  0B93
          (0, 0, 2678, 2678),
         16#94#           =>  --  0B94
          (0, 0, 2677, 2677),
         16#95#           =>  --  0B95
          (0, 0, 2679, 2679),
         16#99#           =>  --  0B99
          (0, 0, 2680, 2680),
         16#9A#           =>  --  0B9A
          (0, 0, 2681, 2681),
         16#9C#           =>  --  0B9C
          (0, 0, 2682, 2682),
         16#9E#           =>  --  0B9E
          (0, 0, 2683, 2683),
         16#9F#           =>  --  0B9F
          (0, 0, 2684, 2684),
         16#A3#           =>  --  0BA3
          (0, 0, 2685, 2685),
         16#A4#           =>  --  0BA4
          (0, 0, 2686, 2686),
         16#A8#           =>  --  0BA8
          (0, 0, 2687, 2687),
         16#A9#           =>  --  0BA9
          (0, 0, 2688, 2688),
         16#AA#           =>  --  0BAA
          (0, 0, 2689, 2689),
         16#AE#           =>  --  0BAE
          (0, 0, 2690, 2690),
         16#AF#           =>  --  0BAF
          (0, 0, 2691, 2691),
         16#B0#           =>  --  0BB0
          (0, 0, 2692, 2692),
         16#B1#           =>  --  0BB1
          (0, 0, 2693, 2693),
         16#B2#           =>  --  0BB2
          (0, 0, 2694, 2694),
         16#B3#           =>  --  0BB3
          (0, 0, 2695, 2695),
         16#B4#           =>  --  0BB4
          (0, 0, 2696, 2696),
         16#B5#           =>  --  0BB5
          (0, 0, 2697, 2697),
         16#B6#           =>  --  0BB6
          (0, 0, 2698, 2698),
         16#B7#           =>  --  0BB7
          (0, 0, 2699, 2699),
         16#B8#           =>  --  0BB8
          (0, 0, 2700, 2700),
         16#B9#           =>  --  0BB9
          (0, 0, 2701, 2701),
         16#BE#           =>  --  0BBE
          (0, 0, 2702, 2702),
         16#BF#           =>  --  0BBF
          (0, 0, 2703, 2703),
         16#C0#           =>  --  0BC0
          (0, 0, 2704, 2704),
         16#C1#           =>  --  0BC1
          (0, 0, 2705, 2705),
         16#C2#           =>  --  0BC2
          (0, 0, 2706, 2706),
         16#C6#           =>  --  0BC6
          (18, 19, 2707, 2707),
         16#C7#           =>  --  0BC7
          (20, 20, 2710, 2710),
         16#C8#           =>  --  0BC8
          (0, 0, 2712, 2712),
         16#CA#           =>  --  0BCA
          (0, 0, 2708, 2708),
         16#CB#           =>  --  0BCB
          (0, 0, 2711, 2711),
         16#CC#           =>  --  0BCC
          (0, 0, 2709, 2709),
         16#CD#           =>  --  0BCD
          (0, 0, 2713, 2713),
         16#D0#           =>  --  0BD0
          (0, 0, 2714, 2714),
         16#D7#           =>  --  0BD7
          (0, 0, 2715, 2715),
         16#E6#           =>  --  0BE6
          (0, 0, 23, 23),
         16#E7#           =>  --  0BE7
          (0, 0, 24, 24),
         16#E8#           =>  --  0BE8
          (0, 0, 25, 25),
         16#E9#           =>  --  0BE9
          (0, 0, 26, 26),
         16#EA#           =>  --  0BEA
          (0, 0, 27, 27),
         16#EB#           =>  --  0BEB
          (0, 0, 28, 28),
         16#EC#           =>  --  0BEC
          (0, 0, 29, 29),
         16#ED#           =>  --  0BED
          (0, 0, 30, 30),
         16#EE#           =>  --  0BEE
          (0, 0, 31, 31),
         16#EF#           =>  --  0BEF
          (0, 0, 32, 32),
         16#F0#           =>  --  0BF0
          (0, 0, 2716, 2716),
         16#F1#           =>  --  0BF1
          (0, 0, 2717, 2717),
         16#F2#           =>  --  0BF2
          (0, 0, 2718, 2718),
         16#F3#           =>  --  0BF3
          (0, 0, 2719, 2719),
         16#F4#           =>  --  0BF4
          (0, 0, 2720, 2720),
         16#F5#           =>  --  0BF5
          (0, 0, 2721, 2721),
         16#F6#           =>  --  0BF6
          (0, 0, 2722, 2722),
         16#F7#           =>  --  0BF7
          (0, 0, 2723, 2723),
         16#F8#           =>  --  0BF8
          (0, 0, 2724, 2724),
         16#F9#           =>  --  0BF9
          (0, 0, 2725, 2725),
         16#FA#           =>  --  0BFA
          (0, 0, 2726, 2726),
         others           =>
          (0, 0, 0, 0));

   Group_000C : aliased constant Collation_Second_Stage
     := (16#00# .. 16#01# =>  --  0C00 .. 0C01
          (0, 0, 2242, 2242),
         16#02#           =>  --  0C02
          (0, 0, 2243, 2243),
         16#03#           =>  --  0C03
          (0, 0, 2244, 2244),
         16#05#           =>  --  0C05
          (0, 0, 2727, 2727),
         16#06#           =>  --  0C06
          (0, 0, 2728, 2728),
         16#07#           =>  --  0C07
          (0, 0, 2729, 2729),
         16#08#           =>  --  0C08
          (0, 0, 2730, 2730),
         16#09#           =>  --  0C09
          (0, 0, 2731, 2731),
         16#0A#           =>  --  0C0A
          (0, 0, 2732, 2732),
         16#0B#           =>  --  0C0B
          (0, 0, 2733, 2733),
         16#0C#           =>  --  0C0C
          (0, 0, 2734, 2734),
         16#0E#           =>  --  0C0E
          (0, 0, 2735, 2735),
         16#0F#           =>  --  0C0F
          (0, 0, 2736, 2736),
         16#10#           =>  --  0C10
          (0, 0, 2737, 2737),
         16#12#           =>  --  0C12
          (0, 0, 2738, 2738),
         16#13#           =>  --  0C13
          (0, 0, 2739, 2739),
         16#14#           =>  --  0C14
          (0, 0, 2740, 2740),
         16#15#           =>  --  0C15
          (0, 0, 2741, 2741),
         16#16#           =>  --  0C16
          (0, 0, 2742, 2742),
         16#17#           =>  --  0C17
          (0, 0, 2743, 2743),
         16#18#           =>  --  0C18
          (0, 0, 2744, 2744),
         16#19#           =>  --  0C19
          (0, 0, 2745, 2745),
         16#1A#           =>  --  0C1A
          (0, 0, 2746, 2746),
         16#1B#           =>  --  0C1B
          (0, 0, 2747, 2747),
         16#1C#           =>  --  0C1C
          (0, 0, 2748, 2748),
         16#1D#           =>  --  0C1D
          (0, 0, 2749, 2749),
         16#1E#           =>  --  0C1E
          (0, 0, 2750, 2750),
         16#1F#           =>  --  0C1F
          (0, 0, 2751, 2751),
         16#20#           =>  --  0C20
          (0, 0, 2752, 2752),
         16#21#           =>  --  0C21
          (0, 0, 2753, 2753),
         16#22#           =>  --  0C22
          (0, 0, 2754, 2754),
         16#23#           =>  --  0C23
          (0, 0, 2755, 2755),
         16#24#           =>  --  0C24
          (0, 0, 2756, 2756),
         16#25#           =>  --  0C25
          (0, 0, 2757, 2757),
         16#26#           =>  --  0C26
          (0, 0, 2758, 2758),
         16#27#           =>  --  0C27
          (0, 0, 2759, 2759),
         16#28#           =>  --  0C28
          (0, 0, 2760, 2760),
         16#2A#           =>  --  0C2A
          (0, 0, 2761, 2761),
         16#2B#           =>  --  0C2B
          (0, 0, 2762, 2762),
         16#2C#           =>  --  0C2C
          (0, 0, 2763, 2763),
         16#2D#           =>  --  0C2D
          (0, 0, 2764, 2764),
         16#2E#           =>  --  0C2E
          (0, 0, 2765, 2765),
         16#2F#           =>  --  0C2F
          (0, 0, 2766, 2766),
         16#30#           =>  --  0C30
          (0, 0, 2767, 2767),
         16#31#           =>  --  0C31
          (0, 0, 2768, 2768),
         16#32#           =>  --  0C32
          (0, 0, 2769, 2769),
         16#33#           =>  --  0C33
          (0, 0, 2770, 2770),
         16#34#           =>  --  0C34
          (0, 0, 2771, 2771),
         16#35#           =>  --  0C35
          (0, 0, 2772, 2772),
         16#36#           =>  --  0C36
          (0, 0, 2773, 2773),
         16#37#           =>  --  0C37
          (0, 0, 2774, 2774),
         16#38#           =>  --  0C38
          (0, 0, 2775, 2775),
         16#39#           =>  --  0C39
          (0, 0, 2776, 2776),
         16#3D#           =>  --  0C3D
          (0, 0, 2777, 2777),
         16#3E#           =>  --  0C3E
          (0, 0, 2778, 2778),
         16#3F#           =>  --  0C3F
          (0, 0, 2779, 2779),
         16#40#           =>  --  0C40
          (0, 0, 2780, 2780),
         16#41#           =>  --  0C41
          (0, 0, 2781, 2781),
         16#42#           =>  --  0C42
          (0, 0, 2782, 2782),
         16#43#           =>  --  0C43
          (0, 0, 2783, 2783),
         16#44#           =>  --  0C44
          (0, 0, 2784, 2784),
         16#46#           =>  --  0C46
          (21, 21, 2785, 2785),
         16#47#           =>  --  0C47
          (0, 0, 2787, 2787),
         16#48#           =>  --  0C48
          (0, 0, 2786, 2786),
         16#4A#           =>  --  0C4A
          (0, 0, 2788, 2788),
         16#4B#           =>  --  0C4B
          (0, 0, 2789, 2789),
         16#4C#           =>  --  0C4C
          (0, 0, 2790, 2790),
         16#4D#           =>  --  0C4D
          (0, 0, 2791, 2791),
         16#55#           =>  --  0C55
          (0, 0, 2792, 2792),
         16#56#           =>  --  0C56
          (0, 0, 2793, 2793),
         16#58#           =>  --  0C58
          (0, 0, 2794, 2794),
         16#59#           =>  --  0C59
          (0, 0, 2795, 2795),
         16#60#           =>  --  0C60
          (0, 0, 2796, 2796),
         16#61#           =>  --  0C61
          (0, 0, 2797, 2797),
         16#62#           =>  --  0C62
          (0, 0, 2798, 2798),
         16#63#           =>  --  0C63
          (0, 0, 2799, 2799),
         16#66#           =>  --  0C66
          (0, 0, 23, 23),
         16#67#           =>  --  0C67
          (0, 0, 24, 24),
         16#68#           =>  --  0C68
          (0, 0, 25, 25),
         16#69#           =>  --  0C69
          (0, 0, 26, 26),
         16#6A#           =>  --  0C6A
          (0, 0, 27, 27),
         16#6B#           =>  --  0C6B
          (0, 0, 28, 28),
         16#6C#           =>  --  0C6C
          (0, 0, 29, 29),
         16#6D#           =>  --  0C6D
          (0, 0, 30, 30),
         16#6E#           =>  --  0C6E
          (0, 0, 31, 31),
         16#6F#           =>  --  0C6F
          (0, 0, 32, 32),
         16#78#           =>  --  0C78
          (0, 0, 23, 23),
         16#79#           =>  --  0C79
          (0, 0, 24, 24),
         16#7A#           =>  --  0C7A
          (0, 0, 25, 25),
         16#7B#           =>  --  0C7B
          (0, 0, 26, 26),
         16#7C#           =>  --  0C7C
          (0, 0, 24, 24),
         16#7D#           =>  --  0C7D
          (0, 0, 25, 25),
         16#7E#           =>  --  0C7E
          (0, 0, 26, 26),
         16#7F#           =>  --  0C7F
          (0, 0, 2800, 2800),
         16#81#           =>  --  0C81
          (0, 0, 2242, 2242),
         16#82#           =>  --  0C82
          (0, 0, 2243, 2243),
         16#83#           =>  --  0C83
          (0, 0, 2244, 2244),
         16#85#           =>  --  0C85
          (0, 0, 2801, 2801),
         16#86#           =>  --  0C86
          (0, 0, 2802, 2802),
         16#87#           =>  --  0C87
          (0, 0, 2803, 2803),
         16#88#           =>  --  0C88
          (0, 0, 2804, 2804),
         16#89#           =>  --  0C89
          (0, 0, 2805, 2805),
         16#8A#           =>  --  0C8A
          (0, 0, 2806, 2806),
         16#8B#           =>  --  0C8B
          (0, 0, 2807, 2807),
         16#8C#           =>  --  0C8C
          (0, 0, 2808, 2808),
         16#8E#           =>  --  0C8E
          (0, 0, 2809, 2809),
         16#8F#           =>  --  0C8F
          (0, 0, 2810, 2810),
         16#90#           =>  --  0C90
          (0, 0, 2811, 2811),
         16#92#           =>  --  0C92
          (0, 0, 2812, 2812),
         16#93#           =>  --  0C93
          (0, 0, 2813, 2813),
         16#94#           =>  --  0C94
          (0, 0, 2814, 2814),
         16#95#           =>  --  0C95
          (0, 0, 2815, 2815),
         16#96#           =>  --  0C96
          (0, 0, 2816, 2816),
         16#97#           =>  --  0C97
          (0, 0, 2817, 2817),
         16#98#           =>  --  0C98
          (0, 0, 2818, 2818),
         16#99#           =>  --  0C99
          (0, 0, 2819, 2819),
         16#9A#           =>  --  0C9A
          (0, 0, 2820, 2820),
         16#9B#           =>  --  0C9B
          (0, 0, 2821, 2821),
         16#9C#           =>  --  0C9C
          (0, 0, 2822, 2822),
         16#9D#           =>  --  0C9D
          (0, 0, 2823, 2823),
         16#9E#           =>  --  0C9E
          (0, 0, 2824, 2824),
         16#9F#           =>  --  0C9F
          (0, 0, 2825, 2825),
         16#A0#           =>  --  0CA0
          (0, 0, 2826, 2826),
         16#A1#           =>  --  0CA1
          (0, 0, 2827, 2827),
         16#A2#           =>  --  0CA2
          (0, 0, 2828, 2828),
         16#A3#           =>  --  0CA3
          (0, 0, 2829, 2829),
         16#A4#           =>  --  0CA4
          (0, 0, 2830, 2830),
         16#A5#           =>  --  0CA5
          (0, 0, 2831, 2831),
         16#A6#           =>  --  0CA6
          (0, 0, 2832, 2832),
         16#A7#           =>  --  0CA7
          (0, 0, 2833, 2833),
         16#A8#           =>  --  0CA8
          (0, 0, 2834, 2834),
         16#AA#           =>  --  0CAA
          (0, 0, 2835, 2835),
         16#AB#           =>  --  0CAB
          (0, 0, 2836, 2836),
         16#AC#           =>  --  0CAC
          (0, 0, 2837, 2837),
         16#AD#           =>  --  0CAD
          (0, 0, 2838, 2838),
         16#AE#           =>  --  0CAE
          (0, 0, 2839, 2839),
         16#AF#           =>  --  0CAF
          (0, 0, 2840, 2840),
         16#B0#           =>  --  0CB0
          (0, 0, 2841, 2841),
         16#B1#           =>  --  0CB1
          (0, 0, 2842, 2842),
         16#B2#           =>  --  0CB2
          (0, 0, 2843, 2843),
         16#B3#           =>  --  0CB3
          (0, 0, 2844, 2844),
         16#B5#           =>  --  0CB5
          (0, 0, 2845, 2845),
         16#B6#           =>  --  0CB6
          (0, 0, 2846, 2846),
         16#B7#           =>  --  0CB7
          (0, 0, 2847, 2847),
         16#B8#           =>  --  0CB8
          (0, 0, 2848, 2848),
         16#B9#           =>  --  0CB9
          (0, 0, 2849, 2849),
         16#BC#           =>  --  0CBC
          (0, 0, 2283, 2283),
         16#BD#           =>  --  0CBD
          (0, 0, 2850, 2850),
         16#BE#           =>  --  0CBE
          (0, 0, 2851, 2851),
         16#BF#           =>  --  0CBF
          (22, 22, 2852, 2852),
         16#C0#           =>  --  0CC0
          (0, 0, 2853, 2853),
         16#C1#           =>  --  0CC1
          (0, 0, 2854, 2854),
         16#C2#           =>  --  0CC2
          (0, 0, 2855, 2855),
         16#C3#           =>  --  0CC3
          (0, 0, 2856, 2856),
         16#C4#           =>  --  0CC4
          (0, 0, 2857, 2857),
         16#C6#           =>  --  0CC6
          (23, 25, 2858, 2858),
         16#C7#           =>  --  0CC7
          (0, 0, 2859, 2859),
         16#C8#           =>  --  0CC8
          (0, 0, 2860, 2860),
         16#CA#           =>  --  0CCA
          (27, 27, 2861, 2861),
         16#CB#           =>  --  0CCB
          (0, 0, 2862, 2862),
         16#CC#           =>  --  0CCC
          (0, 0, 2863, 2863),
         16#CD#           =>  --  0CCD
          (0, 0, 2864, 2864),
         16#D5#           =>  --  0CD5
          (0, 0, 2865, 2865),
         16#D6#           =>  --  0CD6
          (0, 0, 2866, 2866),
         16#DE#           =>  --  0CDE
          (0, 0, 2867, 2867),
         16#E0#           =>  --  0CE0
          (0, 0, 2868, 2868),
         16#E1#           =>  --  0CE1
          (0, 0, 2869, 2869),
         16#E2#           =>  --  0CE2
          (0, 0, 2870, 2870),
         16#E3#           =>  --  0CE3
          (0, 0, 2871, 2871),
         16#E6#           =>  --  0CE6
          (0, 0, 23, 23),
         16#E7#           =>  --  0CE7
          (0, 0, 24, 24),
         16#E8#           =>  --  0CE8
          (0, 0, 25, 25),
         16#E9#           =>  --  0CE9
          (0, 0, 26, 26),
         16#EA#           =>  --  0CEA
          (0, 0, 27, 27),
         16#EB#           =>  --  0CEB
          (0, 0, 28, 28),
         16#EC#           =>  --  0CEC
          (0, 0, 29, 29),
         16#ED#           =>  --  0CED
          (0, 0, 30, 30),
         16#EE#           =>  --  0CEE
          (0, 0, 31, 31),
         16#EF#           =>  --  0CEF
          (0, 0, 32, 32),
         16#F1#           =>  --  0CF1
          (0, 0, 2872, 2872),
         16#F2#           =>  --  0CF2
          (0, 0, 2873, 2873),
         others           =>
          (0, 0, 0, 0));

   Group_000D : aliased constant Collation_Second_Stage
     := (16#01#           =>  --  0D01
          (0, 0, 2242, 2242),
         16#02#           =>  --  0D02
          (0, 0, 2243, 2243),
         16#03#           =>  --  0D03
          (0, 0, 2244, 2244),
         16#05#           =>  --  0D05
          (0, 0, 2874, 2874),
         16#06#           =>  --  0D06
          (0, 0, 2875, 2875),
         16#07#           =>  --  0D07
          (0, 0, 2876, 2876),
         16#08#           =>  --  0D08
          (0, 0, 2877, 2877),
         16#09#           =>  --  0D09
          (0, 0, 2878, 2878),
         16#0A#           =>  --  0D0A
          (0, 0, 2879, 2879),
         16#0B#           =>  --  0D0B
          (0, 0, 2880, 2880),
         16#0C#           =>  --  0D0C
          (0, 0, 2881, 2881),
         16#0E#           =>  --  0D0E
          (0, 0, 2882, 2882),
         16#0F#           =>  --  0D0F
          (0, 0, 2883, 2883),
         16#10#           =>  --  0D10
          (0, 0, 2884, 2884),
         16#12#           =>  --  0D12
          (0, 0, 2885, 2885),
         16#13#           =>  --  0D13
          (0, 0, 2886, 2886),
         16#14#           =>  --  0D14
          (0, 0, 2887, 2887),
         16#15#           =>  --  0D15
          (0, 0, 2888, 2888),
         16#16#           =>  --  0D16
          (0, 0, 2889, 2889),
         16#17#           =>  --  0D17
          (0, 0, 2890, 2890),
         16#18#           =>  --  0D18
          (0, 0, 2891, 2891),
         16#19#           =>  --  0D19
          (0, 0, 2892, 2892),
         16#1A#           =>  --  0D1A
          (0, 0, 2893, 2893),
         16#1B#           =>  --  0D1B
          (0, 0, 2894, 2894),
         16#1C#           =>  --  0D1C
          (0, 0, 2895, 2895),
         16#1D#           =>  --  0D1D
          (0, 0, 2896, 2896),
         16#1E#           =>  --  0D1E
          (0, 0, 2897, 2897),
         16#1F#           =>  --  0D1F
          (0, 0, 2898, 2898),
         16#20#           =>  --  0D20
          (0, 0, 2899, 2899),
         16#21#           =>  --  0D21
          (0, 0, 2900, 2900),
         16#22#           =>  --  0D22
          (0, 0, 2901, 2901),
         16#23#           =>  --  0D23
          (0, 0, 2902, 2902),
         16#24#           =>  --  0D24
          (0, 0, 2903, 2903),
         16#25#           =>  --  0D25
          (0, 0, 2904, 2904),
         16#26#           =>  --  0D26
          (0, 0, 2905, 2905),
         16#27#           =>  --  0D27
          (0, 0, 2906, 2906),
         16#28#           =>  --  0D28
          (0, 0, 2907, 2907),
         16#29#           =>  --  0D29
          (0, 0, 2908, 2908),
         16#2A#           =>  --  0D2A
          (0, 0, 2909, 2909),
         16#2B#           =>  --  0D2B
          (0, 0, 2910, 2910),
         16#2C#           =>  --  0D2C
          (0, 0, 2911, 2911),
         16#2D#           =>  --  0D2D
          (0, 0, 2912, 2912),
         16#2E#           =>  --  0D2E
          (0, 0, 2913, 2913),
         16#2F#           =>  --  0D2F
          (0, 0, 2914, 2914),
         16#30#           =>  --  0D30
          (0, 0, 2915, 2915),
         16#31#           =>  --  0D31
          (0, 0, 2916, 2916),
         16#32#           =>  --  0D32
          (0, 0, 2917, 2917),
         16#33#           =>  --  0D33
          (0, 0, 2918, 2918),
         16#34#           =>  --  0D34
          (0, 0, 2919, 2919),
         16#35#           =>  --  0D35
          (0, 0, 2920, 2920),
         16#36#           =>  --  0D36
          (0, 0, 2921, 2921),
         16#37#           =>  --  0D37
          (0, 0, 2922, 2922),
         16#38#           =>  --  0D38
          (0, 0, 2923, 2923),
         16#39#           =>  --  0D39
          (0, 0, 2924, 2924),
         16#3A#           =>  --  0D3A
          (0, 0, 2925, 2925),
         16#3D#           =>  --  0D3D
          (0, 0, 2926, 2926),
         16#3E#           =>  --  0D3E
          (0, 0, 2927, 2927),
         16#3F#           =>  --  0D3F
          (0, 0, 2928, 2928),
         16#40#           =>  --  0D40
          (0, 0, 2929, 2929),
         16#41#           =>  --  0D41
          (0, 0, 2930, 2930),
         16#42#           =>  --  0D42
          (0, 0, 2931, 2931),
         16#43#           =>  --  0D43
          (0, 0, 2932, 2932),
         16#44#           =>  --  0D44
          (0, 0, 2933, 2933),
         16#46#           =>  --  0D46
          (28, 29, 2934, 2934),
         16#47#           =>  --  0D47
          (30, 30, 2937, 2937),
         16#48#           =>  --  0D48
          (0, 0, 2939, 2939),
         16#4A#           =>  --  0D4A
          (0, 0, 2935, 2935),
         16#4B#           =>  --  0D4B
          (0, 0, 2938, 2938),
         16#4C#           =>  --  0D4C
          (0, 0, 2936, 2936),
         16#4D#           =>  --  0D4D
          (0, 0, 2940, 2940),
         16#4E#           =>  --  0D4E
          (0, 0, 2941, 2942),
         16#57#           =>  --  0D57
          (0, 0, 2943, 2943),
         16#60#           =>  --  0D60
          (0, 0, 2944, 2944),
         16#61#           =>  --  0D61
          (0, 0, 2945, 2945),
         16#62#           =>  --  0D62
          (0, 0, 2946, 2946),
         16#63#           =>  --  0D63
          (0, 0, 2947, 2947),
         16#66#           =>  --  0D66
          (0, 0, 23, 23),
         16#67#           =>  --  0D67
          (0, 0, 24, 24),
         16#68#           =>  --  0D68
          (0, 0, 25, 25),
         16#69#           =>  --  0D69
          (0, 0, 26, 26),
         16#6A#           =>  --  0D6A
          (0, 0, 27, 27),
         16#6B#           =>  --  0D6B
          (0, 0, 28, 28),
         16#6C#           =>  --  0D6C
          (0, 0, 29, 29),
         16#6D#           =>  --  0D6D
          (0, 0, 30, 30),
         16#6E#           =>  --  0D6E
          (0, 0, 31, 31),
         16#6F#           =>  --  0D6F
          (0, 0, 32, 32),
         16#70#           =>  --  0D70
          (0, 0, 2948, 2948),
         16#71#           =>  --  0D71
          (0, 0, 2949, 2949),
         16#72#           =>  --  0D72
          (0, 0, 2950, 2950),
         16#73#           =>  --  0D73
          (0, 0, 2951, 2951),
         16#74#           =>  --  0D74
          (0, 0, 2952, 2952),
         16#75#           =>  --  0D75
          (0, 0, 2953, 2953),
         16#79#           =>  --  0D79
          (0, 0, 2954, 2954),
         16#7A#           =>  --  0D7A
          (0, 0, 2955, 2956),
         16#7B#           =>  --  0D7B
          (0, 0, 2957, 2958),
         16#7C#           =>  --  0D7C
          (0, 0, 2941, 2942),
         16#7D#           =>  --  0D7D
          (0, 0, 2959, 2960),
         16#7E#           =>  --  0D7E
          (0, 0, 2961, 2962),
         16#7F#           =>  --  0D7F
          (0, 0, 2963, 2964),
         16#82#           =>  --  0D82
          (0, 0, 2243, 2243),
         16#83#           =>  --  0D83
          (0, 0, 2244, 2244),
         16#85#           =>  --  0D85
          (0, 0, 2965, 2965),
         16#86#           =>  --  0D86
          (0, 0, 2966, 2966),
         16#87#           =>  --  0D87
          (0, 0, 2967, 2967),
         16#88#           =>  --  0D88
          (0, 0, 2968, 2968),
         16#89#           =>  --  0D89
          (0, 0, 2969, 2969),
         16#8A#           =>  --  0D8A
          (0, 0, 2970, 2970),
         16#8B#           =>  --  0D8B
          (0, 0, 2971, 2971),
         16#8C#           =>  --  0D8C
          (0, 0, 2972, 2972),
         16#8D#           =>  --  0D8D
          (0, 0, 2973, 2973),
         16#8E#           =>  --  0D8E
          (0, 0, 2974, 2974),
         16#8F#           =>  --  0D8F
          (0, 0, 2975, 2975),
         16#90#           =>  --  0D90
          (0, 0, 2976, 2976),
         16#91#           =>  --  0D91
          (0, 0, 2977, 2977),
         16#92#           =>  --  0D92
          (0, 0, 2978, 2978),
         16#93#           =>  --  0D93
          (0, 0, 2979, 2979),
         16#94#           =>  --  0D94
          (0, 0, 2980, 2980),
         16#95#           =>  --  0D95
          (0, 0, 2981, 2981),
         16#96#           =>  --  0D96
          (0, 0, 2982, 2982),
         16#9A#           =>  --  0D9A
          (0, 0, 2983, 2983),
         16#9B#           =>  --  0D9B
          (0, 0, 2984, 2984),
         16#9C#           =>  --  0D9C
          (0, 0, 2985, 2985),
         16#9D#           =>  --  0D9D
          (0, 0, 2986, 2986),
         16#9E#           =>  --  0D9E
          (0, 0, 2987, 2987),
         16#9F#           =>  --  0D9F
          (0, 0, 2988, 2988),
         16#A0#           =>  --  0DA0
          (0, 0, 2989, 2989),
         16#A1#           =>  --  0DA1
          (0, 0, 2990, 2990),
         16#A2#           =>  --  0DA2
          (0, 0, 2991, 2991),
         16#A3#           =>  --  0DA3
          (0, 0, 2992, 2992),
         16#A4#           =>  --  0DA4
          (0, 0, 2993, 2993),
         16#A5#           =>  --  0DA5
          (0, 0, 2994, 2994),
         16#A6#           =>  --  0DA6
          (0, 0, 2995, 2995),
         16#A7#           =>  --  0DA7
          (0, 0, 2996, 2996),
         16#A8#           =>  --  0DA8
          (0, 0, 2997, 2997),
         16#A9#           =>  --  0DA9
          (0, 0, 2998, 2998),
         16#AA#           =>  --  0DAA
          (0, 0, 2999, 2999),
         16#AB#           =>  --  0DAB
          (0, 0, 3000, 3000),
         16#AC#           =>  --  0DAC
          (0, 0, 3001, 3001),
         16#AD#           =>  --  0DAD
          (0, 0, 3002, 3002),
         16#AE#           =>  --  0DAE
          (0, 0, 3003, 3003),
         16#AF#           =>  --  0DAF
          (0, 0, 3004, 3004),
         16#B0#           =>  --  0DB0
          (0, 0, 3005, 3005),
         16#B1#           =>  --  0DB1
          (0, 0, 3006, 3006),
         16#B3#           =>  --  0DB3
          (0, 0, 3007, 3007),
         16#B4#           =>  --  0DB4
          (0, 0, 3008, 3008),
         16#B5#           =>  --  0DB5
          (0, 0, 3009, 3009),
         16#B6#           =>  --  0DB6
          (0, 0, 3010, 3010),
         16#B7#           =>  --  0DB7
          (0, 0, 3011, 3011),
         16#B8#           =>  --  0DB8
          (0, 0, 3012, 3012),
         16#B9#           =>  --  0DB9
          (0, 0, 3013, 3013),
         16#BA#           =>  --  0DBA
          (0, 0, 3014, 3014),
         16#BB#           =>  --  0DBB
          (0, 0, 3015, 3015),
         16#BD#           =>  --  0DBD
          (0, 0, 3016, 3016),
         16#C0#           =>  --  0DC0
          (0, 0, 3017, 3017),
         16#C1#           =>  --  0DC1
          (0, 0, 3018, 3018),
         16#C2#           =>  --  0DC2
          (0, 0, 3019, 3019),
         16#C3#           =>  --  0DC3
          (0, 0, 3020, 3020),
         16#C4#           =>  --  0DC4
          (0, 0, 3021, 3021),
         16#C5#           =>  --  0DC5
          (0, 0, 3022, 3022),
         16#C6#           =>  --  0DC6
          (0, 0, 3023, 3023),
         16#CA#           =>  --  0DCA
          (0, 0, 3024, 3024),
         16#CF#           =>  --  0DCF
          (0, 0, 3025, 3025),
         16#D0#           =>  --  0DD0
          (0, 0, 3026, 3026),
         16#D1#           =>  --  0DD1
          (0, 0, 3027, 3027),
         16#D2#           =>  --  0DD2
          (0, 0, 3028, 3028),
         16#D3#           =>  --  0DD3
          (0, 0, 3029, 3029),
         16#D4#           =>  --  0DD4
          (0, 0, 3030, 3030),
         16#D6#           =>  --  0DD6
          (0, 0, 3031, 3031),
         16#D8#           =>  --  0DD8
          (0, 0, 3032, 3032),
         16#D9#           =>  --  0DD9
          (31, 33, 3033, 3033),
         16#DA#           =>  --  0DDA
          (0, 0, 3034, 3034),
         16#DB#           =>  --  0DDB
          (0, 0, 3038, 3038),
         16#DC#           =>  --  0DDC
          (35, 35, 3035, 3035),
         16#DD#           =>  --  0DDD
          (0, 0, 3037, 3037),
         16#DE#           =>  --  0DDE
          (0, 0, 3036, 3036),
         16#DF#           =>  --  0DDF
          (0, 0, 3039, 3039),
         16#E6#           =>  --  0DE6
          (0, 0, 23, 23),
         16#E7#           =>  --  0DE7
          (0, 0, 24, 24),
         16#E8#           =>  --  0DE8
          (0, 0, 25, 25),
         16#E9#           =>  --  0DE9
          (0, 0, 26, 26),
         16#EA#           =>  --  0DEA
          (0, 0, 27, 27),
         16#EB#           =>  --  0DEB
          (0, 0, 28, 28),
         16#EC#           =>  --  0DEC
          (0, 0, 29, 29),
         16#ED#           =>  --  0DED
          (0, 0, 30, 30),
         16#EE#           =>  --  0DEE
          (0, 0, 31, 31),
         16#EF#           =>  --  0DEF
          (0, 0, 32, 32),
         16#F2#           =>  --  0DF2
          (0, 0, 3040, 3040),
         16#F3#           =>  --  0DF3
          (0, 0, 3041, 3041),
         16#F4#           =>  --  0DF4
          (0, 0, 3042, 3042),
         others           =>
          (0, 0, 0, 0));

   Group_000E : aliased constant Collation_Second_Stage
     := (16#01#           =>  --  0E01
          (0, 0, 3043, 3043),
         16#02#           =>  --  0E02
          (0, 0, 3044, 3044),
         16#03#           =>  --  0E03
          (0, 0, 3045, 3045),
         16#04#           =>  --  0E04
          (0, 0, 3046, 3046),
         16#05#           =>  --  0E05
          (0, 0, 3047, 3047),
         16#06#           =>  --  0E06
          (0, 0, 3048, 3048),
         16#07#           =>  --  0E07
          (0, 0, 3049, 3049),
         16#08#           =>  --  0E08
          (0, 0, 3050, 3050),
         16#09#           =>  --  0E09
          (0, 0, 3051, 3051),
         16#0A#           =>  --  0E0A
          (0, 0, 3052, 3052),
         16#0B#           =>  --  0E0B
          (0, 0, 3053, 3053),
         16#0C#           =>  --  0E0C
          (0, 0, 3054, 3054),
         16#0D#           =>  --  0E0D
          (0, 0, 3055, 3055),
         16#0E#           =>  --  0E0E
          (0, 0, 3056, 3056),
         16#0F#           =>  --  0E0F
          (0, 0, 3057, 3057),
         16#10#           =>  --  0E10
          (0, 0, 3058, 3058),
         16#11#           =>  --  0E11
          (0, 0, 3059, 3059),
         16#12#           =>  --  0E12
          (0, 0, 3060, 3060),
         16#13#           =>  --  0E13
          (0, 0, 3061, 3061),
         16#14#           =>  --  0E14
          (0, 0, 3062, 3062),
         16#15#           =>  --  0E15
          (0, 0, 3063, 3063),
         16#16#           =>  --  0E16
          (0, 0, 3064, 3064),
         16#17#           =>  --  0E17
          (0, 0, 3065, 3065),
         16#18#           =>  --  0E18
          (0, 0, 3066, 3066),
         16#19#           =>  --  0E19
          (0, 0, 3067, 3067),
         16#1A#           =>  --  0E1A
          (0, 0, 3068, 3068),
         16#1B#           =>  --  0E1B
          (0, 0, 3069, 3069),
         16#1C#           =>  --  0E1C
          (0, 0, 3070, 3070),
         16#1D#           =>  --  0E1D
          (0, 0, 3071, 3071),
         16#1E#           =>  --  0E1E
          (0, 0, 3072, 3072),
         16#1F#           =>  --  0E1F
          (0, 0, 3073, 3073),
         16#20#           =>  --  0E20
          (0, 0, 3074, 3074),
         16#21#           =>  --  0E21
          (0, 0, 3075, 3075),
         16#22#           =>  --  0E22
          (0, 0, 3076, 3076),
         16#23#           =>  --  0E23
          (0, 0, 3077, 3077),
         16#24#           =>  --  0E24
          (0, 0, 3078, 3078),
         16#25#           =>  --  0E25
          (0, 0, 3079, 3079),
         16#26#           =>  --  0E26
          (0, 0, 3080, 3080),
         16#27#           =>  --  0E27
          (0, 0, 3081, 3081),
         16#28#           =>  --  0E28
          (0, 0, 3082, 3082),
         16#29#           =>  --  0E29
          (0, 0, 3083, 3083),
         16#2A#           =>  --  0E2A
          (0, 0, 3084, 3084),
         16#2B#           =>  --  0E2B
          (0, 0, 3085, 3085),
         16#2C#           =>  --  0E2C
          (0, 0, 3086, 3086),
         16#2D#           =>  --  0E2D
          (0, 0, 3087, 3087),
         16#2E#           =>  --  0E2E
          (0, 0, 3088, 3088),
         16#2F#           =>  --  0E2F
          (0, 0, 3089, 3089),
         16#30#           =>  --  0E30
          (0, 0, 3090, 3090),
         16#31#           =>  --  0E31
          (0, 0, 3091, 3091),
         16#32#           =>  --  0E32
          (0, 0, 3092, 3092),
         16#33#           =>  --  0E33
          (0, 0, 3093, 3093),
         16#34#           =>  --  0E34
          (0, 0, 3094, 3094),
         16#35#           =>  --  0E35
          (0, 0, 3095, 3095),
         16#36#           =>  --  0E36
          (0, 0, 3096, 3096),
         16#37#           =>  --  0E37
          (0, 0, 3097, 3097),
         16#38#           =>  --  0E38
          (0, 0, 3098, 3098),
         16#39#           =>  --  0E39
          (0, 0, 3099, 3099),
         16#3A#           =>  --  0E3A
          (0, 0, 3100, 3100),
         16#3F#           =>  --  0E3F
          (0, 0, 3101, 3101),
         16#40#           =>  --  0E40
          (36, 81, 3102, 3102),
         16#41#           =>  --  0E41
          (82, 127, 3195, 3195),
         16#42#           =>  --  0E42
          (128, 173, 3288, 3288),
         16#43#           =>  --  0E43
          (174, 219, 3381, 3381),
         16#44#           =>  --  0E44
          (220, 265, 3474, 3474),
         16#45#           =>  --  0E45
          (0, 0, 3567, 3567),
         16#46#           =>  --  0E46
          (0, 0, 3568, 3568),
         16#47#           =>  --  0E47
          (0, 0, 3569, 3569),
         16#48#           =>  --  0E48
          (0, 0, 3570, 3570),
         16#49#           =>  --  0E49
          (0, 0, 3571, 3571),
         16#4A#           =>  --  0E4A
          (0, 0, 3572, 3572),
         16#4B#           =>  --  0E4B
          (0, 0, 3573, 3573),
         16#4C#           =>  --  0E4C
          (0, 0, 3574, 3574),
         16#4D#           =>  --  0E4D
          (266, 266, 3575, 3575),
         16#4E#           =>  --  0E4E
          (0, 0, 3576, 3576),
         16#4F#           =>  --  0E4F
          (0, 0, 3577, 3577),
         16#50#           =>  --  0E50
          (0, 0, 23, 23),
         16#51#           =>  --  0E51
          (0, 0, 24, 24),
         16#52#           =>  --  0E52
          (0, 0, 25, 25),
         16#53#           =>  --  0E53
          (0, 0, 26, 26),
         16#54#           =>  --  0E54
          (0, 0, 27, 27),
         16#55#           =>  --  0E55
          (0, 0, 28, 28),
         16#56#           =>  --  0E56
          (0, 0, 29, 29),
         16#57#           =>  --  0E57
          (0, 0, 30, 30),
         16#58#           =>  --  0E58
          (0, 0, 31, 31),
         16#59#           =>  --  0E59
          (0, 0, 32, 32),
         16#5A#           =>  --  0E5A
          (0, 0, 3578, 3578),
         16#5B#           =>  --  0E5B
          (0, 0, 3579, 3579),
         16#81#           =>  --  0E81
          (0, 0, 3580, 3580),
         16#82#           =>  --  0E82
          (0, 0, 3581, 3581),
         16#84#           =>  --  0E84
          (0, 0, 3582, 3582),
         16#87#           =>  --  0E87
          (0, 0, 3583, 3583),
         16#88#           =>  --  0E88
          (0, 0, 3584, 3584),
         16#8A#           =>  --  0E8A
          (0, 0, 3585, 3585),
         16#8D#           =>  --  0E8D
          (0, 0, 3586, 3586),
         16#94#           =>  --  0E94
          (0, 0, 3587, 3587),
         16#95#           =>  --  0E95
          (0, 0, 3588, 3588),
         16#96#           =>  --  0E96
          (0, 0, 3589, 3589),
         16#97#           =>  --  0E97
          (0, 0, 3590, 3590),
         16#99#           =>  --  0E99
          (0, 0, 3591, 3591),
         16#9A#           =>  --  0E9A
          (0, 0, 3592, 3592),
         16#9B#           =>  --  0E9B
          (0, 0, 3593, 3593),
         16#9C#           =>  --  0E9C
          (0, 0, 3594, 3594),
         16#9D#           =>  --  0E9D
          (0, 0, 3595, 3595),
         16#9E#           =>  --  0E9E
          (0, 0, 3596, 3596),
         16#9F#           =>  --  0E9F
          (0, 0, 3597, 3597),
         16#A1#           =>  --  0EA1
          (0, 0, 3598, 3598),
         16#A2#           =>  --  0EA2
          (0, 0, 3599, 3599),
         16#A3#           =>  --  0EA3
          (0, 0, 3600, 3600),
         16#A5#           =>  --  0EA5
          (0, 0, 3601, 3601),
         16#A7#           =>  --  0EA7
          (0, 0, 3602, 3602),
         16#AA#           =>  --  0EAA
          (0, 0, 3603, 3603),
         16#AB#           =>  --  0EAB
          (0, 0, 3604, 3604),
         16#AD#           =>  --  0EAD
          (0, 0, 3605, 3605),
         16#AE#           =>  --  0EAE
          (0, 0, 3606, 3606),
         16#AF#           =>  --  0EAF
          (0, 0, 3607, 3607),
         16#B0#           =>  --  0EB0
          (0, 0, 3608, 3608),
         16#B1#           =>  --  0EB1
          (0, 0, 3609, 3609),
         16#B2#           =>  --  0EB2
          (0, 0, 3610, 3610),
         16#B3#           =>  --  0EB3
          (0, 0, 3611, 3611),
         16#B4#           =>  --  0EB4
          (0, 0, 3612, 3612),
         16#B5#           =>  --  0EB5
          (0, 0, 3613, 3613),
         16#B6#           =>  --  0EB6
          (0, 0, 3614, 3614),
         16#B7#           =>  --  0EB7
          (0, 0, 3615, 3615),
         16#B8#           =>  --  0EB8
          (0, 0, 3616, 3616),
         16#B9#           =>  --  0EB9
          (0, 0, 3617, 3617),
         16#BB#           =>  --  0EBB
          (0, 0, 3618, 3618),
         16#BC#           =>  --  0EBC
          (0, 0, 3619, 3619),
         16#BD#           =>  --  0EBD
          (0, 0, 3620, 3620),
         16#C0#           =>  --  0EC0
          (267, 297, 3621, 3621),
         16#C1#           =>  --  0EC1
          (298, 328, 3686, 3686),
         16#C2#           =>  --  0EC2
          (329, 359, 3751, 3751),
         16#C3#           =>  --  0EC3
          (360, 390, 3816, 3816),
         16#C4#           =>  --  0EC4
          (391, 421, 3881, 3881),
         16#C6#           =>  --  0EC6
          (0, 0, 3946, 3946),
         16#C8#           =>  --  0EC8
          (0, 0, 3947, 3947),
         16#C9#           =>  --  0EC9
          (0, 0, 3948, 3948),
         16#CA#           =>  --  0ECA
          (0, 0, 3949, 3949),
         16#CB#           =>  --  0ECB
          (0, 0, 3950, 3950),
         16#CC#           =>  --  0ECC
          (0, 0, 3951, 3951),
         16#CD#           =>  --  0ECD
          (422, 422, 3952, 3952),
         16#D0#           =>  --  0ED0
          (0, 0, 23, 23),
         16#D1#           =>  --  0ED1
          (0, 0, 24, 24),
         16#D2#           =>  --  0ED2
          (0, 0, 25, 25),
         16#D3#           =>  --  0ED3
          (0, 0, 26, 26),
         16#D4#           =>  --  0ED4
          (0, 0, 27, 27),
         16#D5#           =>  --  0ED5
          (0, 0, 28, 28),
         16#D6#           =>  --  0ED6
          (0, 0, 29, 29),
         16#D7#           =>  --  0ED7
          (0, 0, 30, 30),
         16#D8#           =>  --  0ED8
          (0, 0, 31, 31),
         16#D9#           =>  --  0ED9
          (0, 0, 32, 32),
         16#DC#           =>  --  0EDC
          (0, 0, 3674, 3675),
         16#DD#           =>  --  0EDD
          (0, 0, 3677, 3678),
         16#DE#           =>  --  0EDE
          (0, 0, 3622, 3622),
         16#DF#           =>  --  0EDF
          (0, 0, 3638, 3638),
         others           =>
          (0, 0, 0, 0));

   Group_000F : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  0F00
          (0, 0, 3953, 3955),
         16#01#           =>  --  0F01
          (0, 0, 3956, 3956),
         16#02#           =>  --  0F02
          (0, 0, 3957, 3957),
         16#03#           =>  --  0F03
          (0, 0, 3958, 3958),
         16#04#           =>  --  0F04
          (0, 0, 3959, 3959),
         16#05#           =>  --  0F05
          (0, 0, 3960, 3960),
         16#06#           =>  --  0F06
          (0, 0, 3961, 3961),
         16#07#           =>  --  0F07
          (0, 0, 3962, 3962),
         16#08#           =>  --  0F08
          (0, 0, 3963, 3963),
         16#09#           =>  --  0F09
          (0, 0, 3964, 3964),
         16#0A#           =>  --  0F0A
          (0, 0, 3965, 3965),
         16#0B#           =>  --  0F0B
          (0, 0, 3966, 3966),
         16#0C#           =>  --  0F0C
          (0, 0, 3967, 3967),
         16#0D#           =>  --  0F0D
          (0, 0, 3968, 3968),
         16#0E#           =>  --  0F0E
          (0, 0, 3969, 3969),
         16#0F#           =>  --  0F0F
          (0, 0, 3970, 3970),
         16#10#           =>  --  0F10
          (0, 0, 3971, 3971),
         16#11#           =>  --  0F11
          (0, 0, 3972, 3972),
         16#12#           =>  --  0F12
          (0, 0, 3973, 3973),
         16#13#           =>  --  0F13
          (0, 0, 3974, 3974),
         16#14#           =>  --  0F14
          (0, 0, 3975, 3975),
         16#15#           =>  --  0F15
          (0, 0, 3976, 3976),
         16#16#           =>  --  0F16
          (0, 0, 3977, 3977),
         16#17#           =>  --  0F17
          (0, 0, 3978, 3978),
         16#18# .. 16#19# =>  --  0F18 .. 0F19
          (0, 0, 1, 1),
         16#1A#           =>  --  0F1A
          (0, 0, 3979, 3979),
         16#1B#           =>  --  0F1B
          (0, 0, 3980, 3980),
         16#1C#           =>  --  0F1C
          (0, 0, 3981, 3981),
         16#1D#           =>  --  0F1D
          (0, 0, 3982, 3982),
         16#1E#           =>  --  0F1E
          (0, 0, 3983, 3983),
         16#1F#           =>  --  0F1F
          (0, 0, 3984, 3984),
         16#20#           =>  --  0F20
          (0, 0, 23, 23),
         16#21#           =>  --  0F21
          (0, 0, 24, 24),
         16#22#           =>  --  0F22
          (0, 0, 25, 25),
         16#23#           =>  --  0F23
          (0, 0, 26, 26),
         16#24#           =>  --  0F24
          (0, 0, 27, 27),
         16#25#           =>  --  0F25
          (0, 0, 28, 28),
         16#26#           =>  --  0F26
          (0, 0, 29, 29),
         16#27#           =>  --  0F27
          (0, 0, 30, 30),
         16#28#           =>  --  0F28
          (0, 0, 31, 31),
         16#29#           =>  --  0F29
          (0, 0, 32, 32),
         16#2A#           =>  --  0F2A
          (0, 0, 3985, 3985),
         16#2B#           =>  --  0F2B
          (0, 0, 3986, 3986),
         16#2C#           =>  --  0F2C
          (0, 0, 3987, 3987),
         16#2D#           =>  --  0F2D
          (0, 0, 3988, 3988),
         16#2E#           =>  --  0F2E
          (0, 0, 3989, 3989),
         16#2F#           =>  --  0F2F
          (0, 0, 3990, 3990),
         16#30#           =>  --  0F30
          (0, 0, 3991, 3991),
         16#31#           =>  --  0F31
          (0, 0, 3992, 3992),
         16#32#           =>  --  0F32
          (0, 0, 3993, 3993),
         16#33#           =>  --  0F33
          (0, 0, 3994, 3994),
         16#34#           =>  --  0F34
          (0, 0, 3995, 3995),
         16#35#           =>  --  0F35
          (0, 0, 1, 1),
         16#36#           =>  --  0F36
          (0, 0, 3996, 3996),
         16#37#           =>  --  0F37
          (0, 0, 1, 1),
         16#38#           =>  --  0F38
          (0, 0, 3997, 3997),
         16#39#           =>  --  0F39
          (0, 0, 3998, 3998),
         16#3A#           =>  --  0F3A
          (0, 0, 3999, 3999),
         16#3B#           =>  --  0F3B
          (0, 0, 4000, 4000),
         16#3C#           =>  --  0F3C
          (0, 0, 4001, 4001),
         16#3D#           =>  --  0F3D
          (0, 0, 4002, 4002),
         16#3E# .. 16#3F# =>  --  0F3E .. 0F3F
          (0, 0, 1, 1),
         16#40#           =>  --  0F40
          (0, 0, 4003, 4003),
         16#41#           =>  --  0F41
          (0, 0, 4004, 4004),
         16#42#           =>  --  0F42
          (0, 0, 4005, 4005),
         16#43#           =>  --  0F43
          (0, 0, 4006, 4007),
         16#44#           =>  --  0F44
          (0, 0, 4008, 4008),
         16#45#           =>  --  0F45
          (0, 0, 4009, 4009),
         16#46#           =>  --  0F46
          (0, 0, 4010, 4010),
         16#47#           =>  --  0F47
          (0, 0, 4011, 4011),
         16#49#           =>  --  0F49
          (0, 0, 4012, 4012),
         16#4A#           =>  --  0F4A
          (0, 0, 4013, 4013),
         16#4B#           =>  --  0F4B
          (0, 0, 4014, 4014),
         16#4C#           =>  --  0F4C
          (0, 0, 4015, 4015),
         16#4D#           =>  --  0F4D
          (0, 0, 4016, 4017),
         16#4E#           =>  --  0F4E
          (0, 0, 4018, 4018),
         16#4F#           =>  --  0F4F
          (0, 0, 4019, 4019),
         16#50#           =>  --  0F50
          (0, 0, 4020, 4020),
         16#51#           =>  --  0F51
          (0, 0, 4021, 4021),
         16#52#           =>  --  0F52
          (0, 0, 4022, 4023),
         16#53#           =>  --  0F53
          (0, 0, 4024, 4024),
         16#54#           =>  --  0F54
          (0, 0, 4025, 4025),
         16#55#           =>  --  0F55
          (0, 0, 4026, 4026),
         16#56#           =>  --  0F56
          (0, 0, 4027, 4027),
         16#57#           =>  --  0F57
          (0, 0, 4028, 4029),
         16#58#           =>  --  0F58
          (0, 0, 4030, 4030),
         16#59#           =>  --  0F59
          (0, 0, 4031, 4031),
         16#5A#           =>  --  0F5A
          (0, 0, 4032, 4032),
         16#5B#           =>  --  0F5B
          (0, 0, 4033, 4033),
         16#5C#           =>  --  0F5C
          (0, 0, 4034, 4035),
         16#5D#           =>  --  0F5D
          (0, 0, 4036, 4036),
         16#5E#           =>  --  0F5E
          (0, 0, 4037, 4037),
         16#5F#           =>  --  0F5F
          (0, 0, 4038, 4038),
         16#60#           =>  --  0F60
          (0, 0, 4039, 4039),
         16#61#           =>  --  0F61
          (0, 0, 4040, 4040),
         16#62#           =>  --  0F62
          (0, 0, 4041, 4041),
         16#63#           =>  --  0F63
          (0, 0, 4042, 4042),
         16#64#           =>  --  0F64
          (0, 0, 4043, 4043),
         16#65#           =>  --  0F65
          (0, 0, 4044, 4044),
         16#66#           =>  --  0F66
          (0, 0, 4045, 4045),
         16#67#           =>  --  0F67
          (0, 0, 4046, 4046),
         16#68#           =>  --  0F68
          (0, 0, 4047, 4047),
         16#69#           =>  --  0F69
          (0, 0, 4048, 4049),
         16#6A#           =>  --  0F6A
          (0, 0, 4050, 4051),
         16#6B#           =>  --  0F6B
          (0, 0, 4052, 4052),
         16#6C#           =>  --  0F6C
          (0, 0, 4053, 4053),
         16#71#           =>  --  0F71
          (423, 425, 4054, 4054),
         16#72#           =>  --  0F72
          (0, 0, 4058, 4058),
         16#73#           =>  --  0F73
          (0, 0, 4055, 4055),
         16#74#           =>  --  0F74
          (0, 0, 4059, 4059),
         16#75#           =>  --  0F75
          (0, 0, 4057, 4057),
         16#76#           =>  --  0F76
          (0, 0, 4060, 4060),
         16#77#           =>  --  0F77
          (0, 0, 4061, 4061),
         16#78#           =>  --  0F78
          (0, 0, 4062, 4062),
         16#79#           =>  --  0F79
          (0, 0, 4063, 4063),
         16#7A#           =>  --  0F7A
          (0, 0, 4064, 4064),
         16#7B#           =>  --  0F7B
          (0, 0, 4065, 4065),
         16#7C#           =>  --  0F7C
          (0, 0, 4066, 4066),
         16#7D#           =>  --  0F7D
          (0, 0, 4067, 4067),
         16#7E#           =>  --  0F7E
          (0, 0, 2243, 2243),
         16#7F#           =>  --  0F7F
          (0, 0, 2244, 2244),
         16#80#           =>  --  0F80
          (0, 0, 4068, 4068),
         16#81#           =>  --  0F81
          (0, 0, 4056, 4056),
         16#82# .. 16#83# =>  --  0F82 .. 0F83
          (0, 0, 1, 1),
         16#84#           =>  --  0F84
          (0, 0, 4069, 4069),
         16#85#           =>  --  0F85
          (0, 0, 4070, 4070),
         16#86# .. 16#87# =>  --  0F86 .. 0F87
          (0, 0, 1, 1),
         16#88#           =>  --  0F88
          (0, 0, 4071, 4071),
         16#89#           =>  --  0F89
          (0, 0, 4072, 4072),
         16#8A#           =>  --  0F8A
          (0, 0, 4073, 4073),
         16#8B#           =>  --  0F8B
          (0, 0, 4074, 4074),
         16#8C#           =>  --  0F8C
          (0, 0, 4075, 4075),
         16#8D#           =>  --  0F8D
          (0, 0, 4076, 4076),
         16#8E#           =>  --  0F8E
          (0, 0, 4077, 4077),
         16#8F#           =>  --  0F8F
          (0, 0, 4078, 4078),
         16#90#           =>  --  0F90
          (0, 0, 4079, 4079),
         16#91#           =>  --  0F91
          (0, 0, 4080, 4080),
         16#92#           =>  --  0F92
          (0, 0, 4081, 4081),
         16#93#           =>  --  0F93
          (0, 0, 4082, 4083),
         16#94#           =>  --  0F94
          (0, 0, 4084, 4084),
         16#95#           =>  --  0F95
          (0, 0, 4085, 4085),
         16#96#           =>  --  0F96
          (0, 0, 4086, 4086),
         16#97#           =>  --  0F97
          (0, 0, 4087, 4087),
         16#99#           =>  --  0F99
          (0, 0, 4088, 4088),
         16#9A#           =>  --  0F9A
          (0, 0, 4089, 4089),
         16#9B#           =>  --  0F9B
          (0, 0, 4090, 4090),
         16#9C#           =>  --  0F9C
          (0, 0, 4091, 4091),
         16#9D#           =>  --  0F9D
          (0, 0, 4092, 4093),
         16#9E#           =>  --  0F9E
          (0, 0, 4094, 4094),
         16#9F#           =>  --  0F9F
          (0, 0, 4095, 4095),
         16#A0#           =>  --  0FA0
          (0, 0, 4096, 4096),
         16#A1#           =>  --  0FA1
          (0, 0, 4097, 4097),
         16#A2#           =>  --  0FA2
          (0, 0, 4098, 4099),
         16#A3#           =>  --  0FA3
          (0, 0, 4100, 4100),
         16#A4#           =>  --  0FA4
          (0, 0, 4101, 4101),
         16#A5#           =>  --  0FA5
          (0, 0, 4102, 4102),
         16#A6#           =>  --  0FA6
          (0, 0, 4103, 4103),
         16#A7#           =>  --  0FA7
          (0, 0, 4104, 4105),
         16#A8#           =>  --  0FA8
          (0, 0, 4106, 4106),
         16#A9#           =>  --  0FA9
          (0, 0, 4107, 4107),
         16#AA#           =>  --  0FAA
          (0, 0, 4108, 4108),
         16#AB#           =>  --  0FAB
          (0, 0, 4109, 4109),
         16#AC#           =>  --  0FAC
          (0, 0, 4110, 4111),
         16#AD#           =>  --  0FAD
          (0, 0, 4112, 4112),
         16#AE#           =>  --  0FAE
          (0, 0, 4113, 4113),
         16#AF#           =>  --  0FAF
          (0, 0, 4114, 4114),
         16#B0#           =>  --  0FB0
          (0, 0, 4115, 4115),
         16#B1#           =>  --  0FB1
          (0, 0, 4116, 4116),
         16#B2#           =>  --  0FB2
          (426, 430, 4117, 4117),
         16#B3#           =>  --  0FB3
          (434, 438, 4124, 4124),
         16#B4#           =>  --  0FB4
          (0, 0, 4131, 4131),
         16#B5#           =>  --  0FB5
          (0, 0, 4049, 4049),
         16#B6#           =>  --  0FB6
          (0, 0, 4132, 4132),
         16#B7#           =>  --  0FB7
          (0, 0, 4007, 4007),
         16#B8#           =>  --  0FB8
          (0, 0, 4133, 4133),
         16#B9#           =>  --  0FB9
          (0, 0, 4134, 4135),
         16#BA#           =>  --  0FBA
          (0, 0, 4136, 4137),
         16#BB#           =>  --  0FBB
          (0, 0, 4138, 4139),
         16#BC#           =>  --  0FBC
          (0, 0, 4140, 4141),
         16#BE#           =>  --  0FBE
          (0, 0, 4142, 4142),
         16#BF#           =>  --  0FBF
          (0, 0, 4143, 4143),
         16#C0#           =>  --  0FC0
          (0, 0, 4144, 4144),
         16#C1#           =>  --  0FC1
          (0, 0, 4145, 4145),
         16#C2#           =>  --  0FC2
          (0, 0, 4146, 4146),
         16#C3#           =>  --  0FC3
          (0, 0, 4147, 4147),
         16#C4#           =>  --  0FC4
          (0, 0, 4148, 4148),
         16#C5#           =>  --  0FC5
          (0, 0, 4149, 4149),
         16#C6#           =>  --  0FC6
          (0, 0, 1, 1),
         16#C7#           =>  --  0FC7
          (0, 0, 4150, 4150),
         16#C8#           =>  --  0FC8
          (0, 0, 4151, 4151),
         16#C9#           =>  --  0FC9
          (0, 0, 4152, 4152),
         16#CA#           =>  --  0FCA
          (0, 0, 4153, 4153),
         16#CB#           =>  --  0FCB
          (0, 0, 4154, 4154),
         16#CC#           =>  --  0FCC
          (0, 0, 4155, 4155),
         16#CE#           =>  --  0FCE
          (0, 0, 4156, 4156),
         16#CF#           =>  --  0FCF
          (0, 0, 4157, 4157),
         16#D0#           =>  --  0FD0
          (0, 0, 4158, 4158),
         16#D1#           =>  --  0FD1
          (0, 0, 4159, 4159),
         16#D2#           =>  --  0FD2
          (0, 0, 4160, 4160),
         16#D3#           =>  --  0FD3
          (0, 0, 4161, 4161),
         16#D4#           =>  --  0FD4
          (0, 0, 4162, 4162),
         16#D5#           =>  --  0FD5
          (0, 0, 4163, 4163),
         16#D6#           =>  --  0FD6
          (0, 0, 4164, 4164),
         16#D7#           =>  --  0FD7
          (0, 0, 4165, 4165),
         16#D8#           =>  --  0FD8
          (0, 0, 4166, 4166),
         16#D9#           =>  --  0FD9
          (0, 0, 4167, 4167),
         16#DA#           =>  --  0FDA
          (0, 0, 4168, 4168),
         others           =>
          (0, 0, 0, 0));

   Group_0010 : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  1000
          (0, 0, 4169, 4169),
         16#01#           =>  --  1001
          (0, 0, 4170, 4170),
         16#02#           =>  --  1002
          (0, 0, 4171, 4171),
         16#03#           =>  --  1003
          (0, 0, 4172, 4172),
         16#04#           =>  --  1004
          (0, 0, 4173, 4173),
         16#05#           =>  --  1005
          (0, 0, 4174, 4174),
         16#06#           =>  --  1006
          (0, 0, 4175, 4175),
         16#07#           =>  --  1007
          (0, 0, 4176, 4176),
         16#08#           =>  --  1008
          (0, 0, 4177, 4177),
         16#09#           =>  --  1009
          (0, 0, 4178, 4178),
         16#0A#           =>  --  100A
          (0, 0, 4179, 4179),
         16#0B#           =>  --  100B
          (0, 0, 4180, 4180),
         16#0C#           =>  --  100C
          (0, 0, 4181, 4181),
         16#0D#           =>  --  100D
          (0, 0, 4182, 4182),
         16#0E#           =>  --  100E
          (0, 0, 4183, 4183),
         16#0F#           =>  --  100F
          (0, 0, 4184, 4184),
         16#10#           =>  --  1010
          (0, 0, 4185, 4185),
         16#11#           =>  --  1011
          (0, 0, 4186, 4186),
         16#12#           =>  --  1012
          (0, 0, 4187, 4187),
         16#13#           =>  --  1013
          (0, 0, 4188, 4188),
         16#14#           =>  --  1014
          (0, 0, 4189, 4189),
         16#15#           =>  --  1015
          (0, 0, 4190, 4190),
         16#16#           =>  --  1016
          (0, 0, 4191, 4191),
         16#17#           =>  --  1017
          (0, 0, 4192, 4192),
         16#18#           =>  --  1018
          (0, 0, 4193, 4193),
         16#19#           =>  --  1019
          (0, 0, 4194, 4194),
         16#1A#           =>  --  101A
          (0, 0, 4195, 4195),
         16#1B#           =>  --  101B
          (0, 0, 4196, 4196),
         16#1C#           =>  --  101C
          (0, 0, 4197, 4197),
         16#1D#           =>  --  101D
          (0, 0, 4198, 4198),
         16#1E#           =>  --  101E
          (0, 0, 4199, 4199),
         16#1F#           =>  --  101F
          (0, 0, 4200, 4200),
         16#20#           =>  --  1020
          (0, 0, 4201, 4201),
         16#21#           =>  --  1021
          (0, 0, 4202, 4202),
         16#22#           =>  --  1022
          (0, 0, 4203, 4203),
         16#23#           =>  --  1023
          (0, 0, 4204, 4204),
         16#24#           =>  --  1024
          (0, 0, 4205, 4205),
         16#25#           =>  --  1025
          (442, 442, 4206, 4206),
         16#26#           =>  --  1026
          (0, 0, 4207, 4207),
         16#27#           =>  --  1027
          (0, 0, 4208, 4208),
         16#28#           =>  --  1028
          (0, 0, 4209, 4209),
         16#29#           =>  --  1029
          (0, 0, 4210, 4210),
         16#2A#           =>  --  102A
          (0, 0, 4211, 4211),
         16#2B#           =>  --  102B
          (0, 0, 4212, 4212),
         16#2C#           =>  --  102C
          (0, 0, 4213, 4213),
         16#2D#           =>  --  102D
          (0, 0, 4214, 4214),
         16#2E#           =>  --  102E
          (0, 0, 4215, 4215),
         16#2F#           =>  --  102F
          (0, 0, 4216, 4216),
         16#30#           =>  --  1030
          (0, 0, 4217, 4217),
         16#31#           =>  --  1031
          (0, 0, 4218, 4218),
         16#32#           =>  --  1032
          (0, 0, 4219, 4219),
         16#33#           =>  --  1033
          (0, 0, 4220, 4220),
         16#34#           =>  --  1034
          (0, 0, 4221, 4221),
         16#35#           =>  --  1035
          (0, 0, 4222, 4222),
         16#36#           =>  --  1036
          (0, 0, 2243, 2243),
         16#37#           =>  --  1037
          (0, 0, 4223, 4223),
         16#38#           =>  --  1038
          (0, 0, 2244, 2244),
         16#39#           =>  --  1039
          (0, 0, 4224, 4224),
         16#3A#           =>  --  103A
          (0, 0, 4225, 4225),
         16#3B#           =>  --  103B
          (0, 0, 4226, 4226),
         16#3C#           =>  --  103C
          (0, 0, 4227, 4227),
         16#3D#           =>  --  103D
          (0, 0, 4228, 4228),
         16#3E#           =>  --  103E
          (0, 0, 4229, 4229),
         16#3F#           =>  --  103F
          (0, 0, 4230, 4232),
         16#40#           =>  --  1040
          (0, 0, 23, 23),
         16#41#           =>  --  1041
          (0, 0, 24, 24),
         16#42#           =>  --  1042
          (0, 0, 25, 25),
         16#43#           =>  --  1043
          (0, 0, 26, 26),
         16#44#           =>  --  1044
          (0, 0, 27, 27),
         16#45#           =>  --  1045
          (0, 0, 28, 28),
         16#46#           =>  --  1046
          (0, 0, 29, 29),
         16#47#           =>  --  1047
          (0, 0, 30, 30),
         16#48#           =>  --  1048
          (0, 0, 31, 31),
         16#49#           =>  --  1049
          (0, 0, 32, 32),
         16#4A#           =>  --  104A
          (0, 0, 4233, 4233),
         16#4B#           =>  --  104B
          (0, 0, 4234, 4234),
         16#4C#           =>  --  104C
          (0, 0, 4235, 4235),
         16#4D#           =>  --  104D
          (0, 0, 4236, 4236),
         16#4E#           =>  --  104E
          (0, 0, 4237, 4237),
         16#4F#           =>  --  104F
          (0, 0, 4238, 4238),
         16#50#           =>  --  1050
          (0, 0, 4239, 4239),
         16#51#           =>  --  1051
          (0, 0, 4240, 4240),
         16#52#           =>  --  1052
          (0, 0, 4241, 4241),
         16#53#           =>  --  1053
          (0, 0, 4242, 4242),
         16#54#           =>  --  1054
          (0, 0, 4243, 4243),
         16#55#           =>  --  1055
          (0, 0, 4244, 4244),
         16#56#           =>  --  1056
          (0, 0, 4245, 4245),
         16#57#           =>  --  1057
          (0, 0, 4246, 4246),
         16#58#           =>  --  1058
          (0, 0, 4247, 4247),
         16#59#           =>  --  1059
          (0, 0, 4248, 4248),
         16#5A#           =>  --  105A
          (0, 0, 4249, 4249),
         16#5B#           =>  --  105B
          (0, 0, 4250, 4250),
         16#5C#           =>  --  105C
          (0, 0, 4251, 4251),
         16#5D#           =>  --  105D
          (0, 0, 4252, 4252),
         16#5E#           =>  --  105E
          (0, 0, 4253, 4253),
         16#5F#           =>  --  105F
          (0, 0, 4254, 4254),
         16#60#           =>  --  1060
          (0, 0, 4255, 4255),
         16#61#           =>  --  1061
          (0, 0, 4256, 4256),
         16#62#           =>  --  1062
          (0, 0, 4257, 4257),
         16#63#           =>  --  1063
          (0, 0, 4258, 4258),
         16#64#           =>  --  1064
          (0, 0, 4259, 4259),
         16#65#           =>  --  1065
          (0, 0, 4260, 4260),
         16#66#           =>  --  1066
          (0, 0, 4261, 4261),
         16#67#           =>  --  1067
          (0, 0, 4262, 4262),
         16#68#           =>  --  1068
          (0, 0, 4263, 4263),
         16#69#           =>  --  1069
          (0, 0, 4264, 4264),
         16#6A#           =>  --  106A
          (0, 0, 4265, 4265),
         16#6B#           =>  --  106B
          (0, 0, 4266, 4266),
         16#6C#           =>  --  106C
          (0, 0, 4267, 4267),
         16#6D#           =>  --  106D
          (0, 0, 4268, 4268),
         16#6E#           =>  --  106E
          (0, 0, 4269, 4269),
         16#6F#           =>  --  106F
          (0, 0, 4270, 4270),
         16#70#           =>  --  1070
          (0, 0, 4271, 4271),
         16#71#           =>  --  1071
          (0, 0, 4272, 4272),
         16#72#           =>  --  1072
          (0, 0, 4273, 4273),
         16#73#           =>  --  1073
          (0, 0, 4274, 4274),
         16#74#           =>  --  1074
          (0, 0, 4275, 4275),
         16#75#           =>  --  1075
          (0, 0, 4276, 4276),
         16#76#           =>  --  1076
          (0, 0, 4277, 4277),
         16#77#           =>  --  1077
          (0, 0, 4278, 4278),
         16#78#           =>  --  1078
          (0, 0, 4279, 4279),
         16#79#           =>  --  1079
          (0, 0, 4280, 4280),
         16#7A#           =>  --  107A
          (0, 0, 4281, 4281),
         16#7B#           =>  --  107B
          (0, 0, 4282, 4282),
         16#7C#           =>  --  107C
          (0, 0, 4283, 4283),
         16#7D#           =>  --  107D
          (0, 0, 4284, 4284),
         16#7E#           =>  --  107E
          (0, 0, 4285, 4285),
         16#7F#           =>  --  107F
          (0, 0, 4286, 4286),
         16#80#           =>  --  1080
          (0, 0, 4287, 4287),
         16#81#           =>  --  1081
          (0, 0, 4288, 4288),
         16#82#           =>  --  1082
          (0, 0, 4289, 4289),
         16#83#           =>  --  1083
          (0, 0, 4290, 4290),
         16#84#           =>  --  1084
          (0, 0, 4291, 4291),
         16#85#           =>  --  1085
          (0, 0, 4292, 4292),
         16#86#           =>  --  1086
          (0, 0, 4293, 4293),
         16#87#           =>  --  1087
          (0, 0, 4294, 4294),
         16#88#           =>  --  1088
          (0, 0, 4295, 4295),
         16#89#           =>  --  1089
          (0, 0, 4296, 4296),
         16#8A#           =>  --  108A
          (0, 0, 4297, 4297),
         16#8B#           =>  --  108B
          (0, 0, 4298, 4298),
         16#8C#           =>  --  108C
          (0, 0, 4299, 4299),
         16#8D#           =>  --  108D
          (0, 0, 4300, 4300),
         16#8E#           =>  --  108E
          (0, 0, 4301, 4301),
         16#8F#           =>  --  108F
          (0, 0, 4302, 4302),
         16#90#           =>  --  1090
          (0, 0, 23, 23),
         16#91#           =>  --  1091
          (0, 0, 24, 24),
         16#92#           =>  --  1092
          (0, 0, 25, 25),
         16#93#           =>  --  1093
          (0, 0, 26, 26),
         16#94#           =>  --  1094
          (0, 0, 27, 27),
         16#95#           =>  --  1095
          (0, 0, 28, 28),
         16#96#           =>  --  1096
          (0, 0, 29, 29),
         16#97#           =>  --  1097
          (0, 0, 30, 30),
         16#98#           =>  --  1098
          (0, 0, 31, 31),
         16#99#           =>  --  1099
          (0, 0, 32, 32),
         16#9A#           =>  --  109A
          (0, 0, 4303, 4303),
         16#9B#           =>  --  109B
          (0, 0, 4304, 4304),
         16#9C#           =>  --  109C
          (0, 0, 4305, 4305),
         16#9D#           =>  --  109D
          (0, 0, 4306, 4306),
         16#9E#           =>  --  109E
          (0, 0, 4307, 4307),
         16#9F#           =>  --  109F
          (0, 0, 4308, 4308),
         16#A0#           =>  --  10A0
          (0, 0, 4309, 4309),
         16#A1#           =>  --  10A1
          (0, 0, 4310, 4310),
         16#A2#           =>  --  10A2
          (0, 0, 4311, 4311),
         16#A3#           =>  --  10A3
          (0, 0, 4312, 4312),
         16#A4#           =>  --  10A4
          (0, 0, 4313, 4313),
         16#A5#           =>  --  10A5
          (0, 0, 4314, 4314),
         16#A6#           =>  --  10A6
          (0, 0, 4315, 4315),
         16#A7#           =>  --  10A7
          (0, 0, 4316, 4316),
         16#A8#           =>  --  10A8
          (0, 0, 4317, 4317),
         16#A9#           =>  --  10A9
          (0, 0, 4318, 4318),
         16#AA#           =>  --  10AA
          (0, 0, 4319, 4319),
         16#AB#           =>  --  10AB
          (0, 0, 4320, 4320),
         16#AC#           =>  --  10AC
          (0, 0, 4321, 4321),
         16#AD#           =>  --  10AD
          (0, 0, 4322, 4322),
         16#AE#           =>  --  10AE
          (0, 0, 4323, 4323),
         16#AF#           =>  --  10AF
          (0, 0, 4324, 4324),
         16#B0#           =>  --  10B0
          (0, 0, 4325, 4325),
         16#B1#           =>  --  10B1
          (0, 0, 4326, 4326),
         16#B2#           =>  --  10B2
          (0, 0, 4327, 4327),
         16#B3#           =>  --  10B3
          (0, 0, 4328, 4328),
         16#B4#           =>  --  10B4
          (0, 0, 4329, 4329),
         16#B5#           =>  --  10B5
          (0, 0, 4330, 4330),
         16#B6#           =>  --  10B6
          (0, 0, 4331, 4331),
         16#B7#           =>  --  10B7
          (0, 0, 4332, 4332),
         16#B8#           =>  --  10B8
          (0, 0, 4333, 4333),
         16#B9#           =>  --  10B9
          (0, 0, 4334, 4334),
         16#BA#           =>  --  10BA
          (0, 0, 4335, 4335),
         16#BB#           =>  --  10BB
          (0, 0, 4336, 4336),
         16#BC#           =>  --  10BC
          (0, 0, 4337, 4337),
         16#BD#           =>  --  10BD
          (0, 0, 4338, 4338),
         16#BE#           =>  --  10BE
          (0, 0, 4339, 4339),
         16#BF#           =>  --  10BF
          (0, 0, 4340, 4340),
         16#C0#           =>  --  10C0
          (0, 0, 4341, 4341),
         16#C1#           =>  --  10C1
          (0, 0, 4342, 4342),
         16#C2#           =>  --  10C2
          (0, 0, 4343, 4343),
         16#C3#           =>  --  10C3
          (0, 0, 4344, 4344),
         16#C4#           =>  --  10C4
          (0, 0, 4345, 4345),
         16#C5#           =>  --  10C5
          (0, 0, 4346, 4346),
         16#C7#           =>  --  10C7
          (0, 0, 4347, 4347),
         16#CD#           =>  --  10CD
          (0, 0, 4348, 4348),
         16#D0#           =>  --  10D0
          (0, 0, 4349, 4349),
         16#D1#           =>  --  10D1
          (0, 0, 4350, 4350),
         16#D2#           =>  --  10D2
          (0, 0, 4351, 4351),
         16#D3#           =>  --  10D3
          (0, 0, 4352, 4352),
         16#D4#           =>  --  10D4
          (0, 0, 4353, 4353),
         16#D5#           =>  --  10D5
          (0, 0, 4354, 4354),
         16#D6#           =>  --  10D6
          (0, 0, 4355, 4355),
         16#D7#           =>  --  10D7
          (0, 0, 4356, 4356),
         16#D8#           =>  --  10D8
          (0, 0, 4357, 4357),
         16#D9#           =>  --  10D9
          (0, 0, 4358, 4358),
         16#DA#           =>  --  10DA
          (0, 0, 4359, 4359),
         16#DB#           =>  --  10DB
          (0, 0, 4360, 4360),
         16#DC#           =>  --  10DC
          (0, 0, 4361, 4361),
         16#DD#           =>  --  10DD
          (0, 0, 4362, 4362),
         16#DE#           =>  --  10DE
          (0, 0, 4363, 4363),
         16#DF#           =>  --  10DF
          (0, 0, 4364, 4364),
         16#E0#           =>  --  10E0
          (0, 0, 4365, 4365),
         16#E1#           =>  --  10E1
          (0, 0, 4366, 4366),
         16#E2#           =>  --  10E2
          (0, 0, 4367, 4367),
         16#E3#           =>  --  10E3
          (0, 0, 4368, 4368),
         16#E4#           =>  --  10E4
          (0, 0, 4369, 4369),
         16#E5#           =>  --  10E5
          (0, 0, 4370, 4370),
         16#E6#           =>  --  10E6
          (0, 0, 4371, 4371),
         16#E7#           =>  --  10E7
          (0, 0, 4372, 4372),
         16#E8#           =>  --  10E8
          (0, 0, 4373, 4373),
         16#E9#           =>  --  10E9
          (0, 0, 4374, 4374),
         16#EA#           =>  --  10EA
          (0, 0, 4375, 4375),
         16#EB#           =>  --  10EB
          (0, 0, 4376, 4376),
         16#EC#           =>  --  10EC
          (0, 0, 4377, 4377),
         16#ED#           =>  --  10ED
          (0, 0, 4378, 4378),
         16#EE#           =>  --  10EE
          (0, 0, 4379, 4379),
         16#EF#           =>  --  10EF
          (0, 0, 4380, 4380),
         16#F0#           =>  --  10F0
          (0, 0, 4381, 4381),
         16#F1#           =>  --  10F1
          (0, 0, 4382, 4382),
         16#F2#           =>  --  10F2
          (0, 0, 4383, 4383),
         16#F3#           =>  --  10F3
          (0, 0, 4384, 4384),
         16#F4#           =>  --  10F4
          (0, 0, 4385, 4385),
         16#F5#           =>  --  10F5
          (0, 0, 4386, 4386),
         16#F6#           =>  --  10F6
          (0, 0, 4387, 4387),
         16#F7#           =>  --  10F7
          (0, 0, 4388, 4388),
         16#F8#           =>  --  10F8
          (0, 0, 4389, 4389),
         16#F9#           =>  --  10F9
          (0, 0, 4390, 4390),
         16#FA#           =>  --  10FA
          (0, 0, 4391, 4391),
         16#FB#           =>  --  10FB
          (0, 0, 4392, 4392),
         16#FC#           =>  --  10FC
          (0, 0, 4393, 4393),
         16#FD#           =>  --  10FD
          (0, 0, 4394, 4394),
         16#FE#           =>  --  10FE
          (0, 0, 4395, 4395),
         16#FF#           =>  --  10FF
          (0, 0, 4396, 4396),
         others           =>
          (0, 0, 0, 0));

   Group_0011 : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  1100
          (0, 0, 4397, 4397),
         16#01#           =>  --  1101
          (0, 0, 4398, 4398),
         16#02#           =>  --  1102
          (0, 0, 4399, 4399),
         16#03#           =>  --  1103
          (0, 0, 4400, 4400),
         16#04#           =>  --  1104
          (0, 0, 4401, 4401),
         16#05#           =>  --  1105
          (0, 0, 4402, 4402),
         16#06#           =>  --  1106
          (0, 0, 4403, 4403),
         16#07#           =>  --  1107
          (0, 0, 4404, 4404),
         16#08#           =>  --  1108
          (0, 0, 4405, 4405),
         16#09#           =>  --  1109
          (0, 0, 4406, 4406),
         16#0A#           =>  --  110A
          (0, 0, 4407, 4407),
         16#0B#           =>  --  110B
          (0, 0, 4408, 4408),
         16#0C#           =>  --  110C
          (0, 0, 4409, 4409),
         16#0D#           =>  --  110D
          (0, 0, 4410, 4410),
         16#0E#           =>  --  110E
          (0, 0, 4411, 4411),
         16#0F#           =>  --  110F
          (0, 0, 4412, 4412),
         16#10#           =>  --  1110
          (0, 0, 4413, 4413),
         16#11#           =>  --  1111
          (0, 0, 4414, 4414),
         16#12#           =>  --  1112
          (0, 0, 4415, 4415),
         16#13#           =>  --  1113
          (0, 0, 4416, 4416),
         16#14#           =>  --  1114
          (0, 0, 4417, 4417),
         16#15#           =>  --  1115
          (0, 0, 4418, 4418),
         16#16#           =>  --  1116
          (0, 0, 4419, 4419),
         16#17#           =>  --  1117
          (0, 0, 4420, 4420),
         16#18#           =>  --  1118
          (0, 0, 4421, 4421),
         16#19#           =>  --  1119
          (0, 0, 4422, 4422),
         16#1A#           =>  --  111A
          (0, 0, 4423, 4423),
         16#1B#           =>  --  111B
          (0, 0, 4424, 4424),
         16#1C#           =>  --  111C
          (0, 0, 4425, 4425),
         16#1D#           =>  --  111D
          (0, 0, 4426, 4426),
         16#1E#           =>  --  111E
          (0, 0, 4427, 4427),
         16#1F#           =>  --  111F
          (0, 0, 4428, 4428),
         16#20#           =>  --  1120
          (0, 0, 4429, 4429),
         16#21#           =>  --  1121
          (0, 0, 4430, 4430),
         16#22#           =>  --  1122
          (0, 0, 4431, 4431),
         16#23#           =>  --  1123
          (0, 0, 4432, 4432),
         16#24#           =>  --  1124
          (0, 0, 4433, 4433),
         16#25#           =>  --  1125
          (0, 0, 4434, 4434),
         16#26#           =>  --  1126
          (0, 0, 4435, 4435),
         16#27#           =>  --  1127
          (0, 0, 4436, 4436),
         16#28#           =>  --  1128
          (0, 0, 4437, 4437),
         16#29#           =>  --  1129
          (0, 0, 4438, 4438),
         16#2A#           =>  --  112A
          (0, 0, 4439, 4439),
         16#2B#           =>  --  112B
          (0, 0, 4440, 4440),
         16#2C#           =>  --  112C
          (0, 0, 4441, 4441),
         16#2D#           =>  --  112D
          (0, 0, 4442, 4442),
         16#2E#           =>  --  112E
          (0, 0, 4443, 4443),
         16#2F#           =>  --  112F
          (0, 0, 4444, 4444),
         16#30#           =>  --  1130
          (0, 0, 4445, 4445),
         16#31#           =>  --  1131
          (0, 0, 4446, 4446),
         16#32#           =>  --  1132
          (0, 0, 4447, 4447),
         16#33#           =>  --  1133
          (0, 0, 4448, 4448),
         16#34#           =>  --  1134
          (0, 0, 4449, 4449),
         16#35#           =>  --  1135
          (0, 0, 4450, 4450),
         16#36#           =>  --  1136
          (0, 0, 4451, 4451),
         16#37#           =>  --  1137
          (0, 0, 4452, 4452),
         16#38#           =>  --  1138
          (0, 0, 4453, 4453),
         16#39#           =>  --  1139
          (0, 0, 4454, 4454),
         16#3A#           =>  --  113A
          (0, 0, 4455, 4455),
         16#3B#           =>  --  113B
          (0, 0, 4456, 4456),
         16#3C#           =>  --  113C
          (0, 0, 4457, 4457),
         16#3D#           =>  --  113D
          (0, 0, 4458, 4458),
         16#3E#           =>  --  113E
          (0, 0, 4459, 4459),
         16#3F#           =>  --  113F
          (0, 0, 4460, 4460),
         16#40#           =>  --  1140
          (0, 0, 4461, 4461),
         16#41#           =>  --  1141
          (0, 0, 4462, 4462),
         16#42#           =>  --  1142
          (0, 0, 4463, 4463),
         16#43#           =>  --  1143
          (0, 0, 4464, 4464),
         16#44#           =>  --  1144
          (0, 0, 4465, 4465),
         16#45#           =>  --  1145
          (0, 0, 4466, 4466),
         16#46#           =>  --  1146
          (0, 0, 4467, 4467),
         16#47#           =>  --  1147
          (0, 0, 4468, 4468),
         16#48#           =>  --  1148
          (0, 0, 4469, 4469),
         16#49#           =>  --  1149
          (0, 0, 4470, 4470),
         16#4A#           =>  --  114A
          (0, 0, 4471, 4471),
         16#4B#           =>  --  114B
          (0, 0, 4472, 4472),
         16#4C#           =>  --  114C
          (0, 0, 4473, 4473),
         16#4D#           =>  --  114D
          (0, 0, 4474, 4474),
         16#4E#           =>  --  114E
          (0, 0, 4475, 4475),
         16#4F#           =>  --  114F
          (0, 0, 4476, 4476),
         16#50#           =>  --  1150
          (0, 0, 4477, 4477),
         16#51#           =>  --  1151
          (0, 0, 4478, 4478),
         16#52#           =>  --  1152
          (0, 0, 4479, 4479),
         16#53#           =>  --  1153
          (0, 0, 4480, 4480),
         16#54#           =>  --  1154
          (0, 0, 4481, 4481),
         16#55#           =>  --  1155
          (0, 0, 4482, 4482),
         16#56#           =>  --  1156
          (0, 0, 4483, 4483),
         16#57#           =>  --  1157
          (0, 0, 4484, 4484),
         16#58#           =>  --  1158
          (0, 0, 4485, 4485),
         16#59#           =>  --  1159
          (0, 0, 4486, 4486),
         16#5A#           =>  --  115A
          (0, 0, 4487, 4487),
         16#5B#           =>  --  115B
          (0, 0, 4488, 4488),
         16#5C#           =>  --  115C
          (0, 0, 4489, 4489),
         16#5D#           =>  --  115D
          (0, 0, 4490, 4490),
         16#5E#           =>  --  115E
          (0, 0, 4491, 4491),
         16#5F#           =>  --  115F
          (0, 0, 4492, 4492),
         16#60#           =>  --  1160
          (0, 0, 4493, 4493),
         16#61#           =>  --  1161
          (0, 0, 4494, 4494),
         16#62#           =>  --  1162
          (0, 0, 4495, 4495),
         16#63#           =>  --  1163
          (0, 0, 4496, 4496),
         16#64#           =>  --  1164
          (0, 0, 4497, 4497),
         16#65#           =>  --  1165
          (0, 0, 4498, 4498),
         16#66#           =>  --  1166
          (0, 0, 4499, 4499),
         16#67#           =>  --  1167
          (0, 0, 4500, 4500),
         16#68#           =>  --  1168
          (0, 0, 4501, 4501),
         16#69#           =>  --  1169
          (0, 0, 4502, 4502),
         16#6A#           =>  --  116A
          (0, 0, 4503, 4503),
         16#6B#           =>  --  116B
          (0, 0, 4504, 4504),
         16#6C#           =>  --  116C
          (0, 0, 4505, 4505),
         16#6D#           =>  --  116D
          (0, 0, 4506, 4506),
         16#6E#           =>  --  116E
          (0, 0, 4507, 4507),
         16#6F#           =>  --  116F
          (0, 0, 4508, 4508),
         16#70#           =>  --  1170
          (0, 0, 4509, 4509),
         16#71#           =>  --  1171
          (0, 0, 4510, 4510),
         16#72#           =>  --  1172
          (0, 0, 4511, 4511),
         16#73#           =>  --  1173
          (0, 0, 4512, 4512),
         16#74#           =>  --  1174
          (0, 0, 4513, 4513),
         16#75#           =>  --  1175
          (0, 0, 4514, 4514),
         16#76#           =>  --  1176
          (0, 0, 4515, 4515),
         16#77#           =>  --  1177
          (0, 0, 4516, 4516),
         16#78#           =>  --  1178
          (0, 0, 4517, 4517),
         16#79#           =>  --  1179
          (0, 0, 4518, 4518),
         16#7A#           =>  --  117A
          (0, 0, 4519, 4519),
         16#7B#           =>  --  117B
          (0, 0, 4520, 4520),
         16#7C#           =>  --  117C
          (0, 0, 4521, 4521),
         16#7D#           =>  --  117D
          (0, 0, 4522, 4522),
         16#7E#           =>  --  117E
          (0, 0, 4523, 4523),
         16#7F#           =>  --  117F
          (0, 0, 4524, 4524),
         16#80#           =>  --  1180
          (0, 0, 4525, 4525),
         16#81#           =>  --  1181
          (0, 0, 4526, 4526),
         16#82#           =>  --  1182
          (0, 0, 4527, 4527),
         16#83#           =>  --  1183
          (0, 0, 4528, 4528),
         16#84#           =>  --  1184
          (0, 0, 4529, 4529),
         16#85#           =>  --  1185
          (0, 0, 4530, 4530),
         16#86#           =>  --  1186
          (0, 0, 4531, 4531),
         16#87#           =>  --  1187
          (0, 0, 4532, 4532),
         16#88#           =>  --  1188
          (0, 0, 4533, 4533),
         16#89#           =>  --  1189
          (0, 0, 4534, 4534),
         16#8A#           =>  --  118A
          (0, 0, 4535, 4535),
         16#8B#           =>  --  118B
          (0, 0, 4536, 4536),
         16#8C#           =>  --  118C
          (0, 0, 4537, 4537),
         16#8D#           =>  --  118D
          (0, 0, 4538, 4538),
         16#8E#           =>  --  118E
          (0, 0, 4539, 4539),
         16#8F#           =>  --  118F
          (0, 0, 4540, 4540),
         16#90#           =>  --  1190
          (0, 0, 4541, 4541),
         16#91#           =>  --  1191
          (0, 0, 4542, 4542),
         16#92#           =>  --  1192
          (0, 0, 4543, 4543),
         16#93#           =>  --  1193
          (0, 0, 4544, 4544),
         16#94#           =>  --  1194
          (0, 0, 4545, 4545),
         16#95#           =>  --  1195
          (0, 0, 4546, 4546),
         16#96#           =>  --  1196
          (0, 0, 4547, 4547),
         16#97#           =>  --  1197
          (0, 0, 4548, 4548),
         16#98#           =>  --  1198
          (0, 0, 4549, 4549),
         16#99#           =>  --  1199
          (0, 0, 4550, 4550),
         16#9A#           =>  --  119A
          (0, 0, 4551, 4551),
         16#9B#           =>  --  119B
          (0, 0, 4552, 4552),
         16#9C#           =>  --  119C
          (0, 0, 4553, 4553),
         16#9D#           =>  --  119D
          (0, 0, 4554, 4554),
         16#9E#           =>  --  119E
          (0, 0, 4555, 4555),
         16#9F#           =>  --  119F
          (0, 0, 4556, 4556),
         16#A0#           =>  --  11A0
          (0, 0, 4557, 4557),
         16#A1#           =>  --  11A1
          (0, 0, 4558, 4558),
         16#A2#           =>  --  11A2
          (0, 0, 4559, 4559),
         16#A3#           =>  --  11A3
          (0, 0, 4560, 4560),
         16#A4#           =>  --  11A4
          (0, 0, 4561, 4561),
         16#A5#           =>  --  11A5
          (0, 0, 4562, 4562),
         16#A6#           =>  --  11A6
          (0, 0, 4563, 4563),
         16#A7#           =>  --  11A7
          (0, 0, 4564, 4564),
         16#A8#           =>  --  11A8
          (0, 0, 4565, 4565),
         16#A9#           =>  --  11A9
          (0, 0, 4566, 4566),
         16#AA#           =>  --  11AA
          (0, 0, 4567, 4567),
         16#AB#           =>  --  11AB
          (0, 0, 4568, 4568),
         16#AC#           =>  --  11AC
          (0, 0, 4569, 4569),
         16#AD#           =>  --  11AD
          (0, 0, 4570, 4570),
         16#AE#           =>  --  11AE
          (0, 0, 4571, 4571),
         16#AF#           =>  --  11AF
          (0, 0, 4572, 4572),
         16#B0#           =>  --  11B0
          (0, 0, 4573, 4573),
         16#B1#           =>  --  11B1
          (0, 0, 4574, 4574),
         16#B2#           =>  --  11B2
          (0, 0, 4575, 4575),
         16#B3#           =>  --  11B3
          (0, 0, 4576, 4576),
         16#B4#           =>  --  11B4
          (0, 0, 4577, 4577),
         16#B5#           =>  --  11B5
          (0, 0, 4578, 4578),
         16#B6#           =>  --  11B6
          (0, 0, 4579, 4579),
         16#B7#           =>  --  11B7
          (0, 0, 4580, 4580),
         16#B8#           =>  --  11B8
          (0, 0, 4581, 4581),
         16#B9#           =>  --  11B9
          (0, 0, 4582, 4582),
         16#BA#           =>  --  11BA
          (0, 0, 4583, 4583),
         16#BB#           =>  --  11BB
          (0, 0, 4584, 4584),
         16#BC#           =>  --  11BC
          (0, 0, 4585, 4585),
         16#BD#           =>  --  11BD
          (0, 0, 4586, 4586),
         16#BE#           =>  --  11BE
          (0, 0, 4587, 4587),
         16#BF#           =>  --  11BF
          (0, 0, 4588, 4588),
         16#C0#           =>  --  11C0
          (0, 0, 4589, 4589),
         16#C1#           =>  --  11C1
          (0, 0, 4590, 4590),
         16#C2#           =>  --  11C2
          (0, 0, 4591, 4591),
         16#C3#           =>  --  11C3
          (0, 0, 4592, 4592),
         16#C4#           =>  --  11C4
          (0, 0, 4593, 4593),
         16#C5#           =>  --  11C5
          (0, 0, 4594, 4594),
         16#C6#           =>  --  11C6
          (0, 0, 4595, 4595),
         16#C7#           =>  --  11C7
          (0, 0, 4596, 4596),
         16#C8#           =>  --  11C8
          (0, 0, 4597, 4597),
         16#C9#           =>  --  11C9
          (0, 0, 4598, 4598),
         16#CA#           =>  --  11CA
          (0, 0, 4599, 4599),
         16#CB#           =>  --  11CB
          (0, 0, 4600, 4600),
         16#CC#           =>  --  11CC
          (0, 0, 4601, 4601),
         16#CD#           =>  --  11CD
          (0, 0, 4602, 4602),
         16#CE#           =>  --  11CE
          (0, 0, 4603, 4603),
         16#CF#           =>  --  11CF
          (0, 0, 4604, 4604),
         16#D0#           =>  --  11D0
          (0, 0, 4605, 4605),
         16#D1#           =>  --  11D1
          (0, 0, 4606, 4606),
         16#D2#           =>  --  11D2
          (0, 0, 4607, 4607),
         16#D3#           =>  --  11D3
          (0, 0, 4608, 4608),
         16#D4#           =>  --  11D4
          (0, 0, 4609, 4609),
         16#D5#           =>  --  11D5
          (0, 0, 4610, 4610),
         16#D6#           =>  --  11D6
          (0, 0, 4611, 4611),
         16#D7#           =>  --  11D7
          (0, 0, 4612, 4612),
         16#D8#           =>  --  11D8
          (0, 0, 4613, 4613),
         16#D9#           =>  --  11D9
          (0, 0, 4614, 4614),
         16#DA#           =>  --  11DA
          (0, 0, 4615, 4615),
         16#DB#           =>  --  11DB
          (0, 0, 4616, 4616),
         16#DC#           =>  --  11DC
          (0, 0, 4617, 4617),
         16#DD#           =>  --  11DD
          (0, 0, 4618, 4618),
         16#DE#           =>  --  11DE
          (0, 0, 4619, 4619),
         16#DF#           =>  --  11DF
          (0, 0, 4620, 4620),
         16#E0#           =>  --  11E0
          (0, 0, 4621, 4621),
         16#E1#           =>  --  11E1
          (0, 0, 4622, 4622),
         16#E2#           =>  --  11E2
          (0, 0, 4623, 4623),
         16#E3#           =>  --  11E3
          (0, 0, 4624, 4624),
         16#E4#           =>  --  11E4
          (0, 0, 4625, 4625),
         16#E5#           =>  --  11E5
          (0, 0, 4626, 4626),
         16#E6#           =>  --  11E6
          (0, 0, 4627, 4627),
         16#E7#           =>  --  11E7
          (0, 0, 4628, 4628),
         16#E8#           =>  --  11E8
          (0, 0, 4629, 4629),
         16#E9#           =>  --  11E9
          (0, 0, 4630, 4630),
         16#EA#           =>  --  11EA
          (0, 0, 4631, 4631),
         16#EB#           =>  --  11EB
          (0, 0, 4632, 4632),
         16#EC#           =>  --  11EC
          (0, 0, 4633, 4633),
         16#ED#           =>  --  11ED
          (0, 0, 4634, 4634),
         16#EE#           =>  --  11EE
          (0, 0, 4635, 4635),
         16#EF#           =>  --  11EF
          (0, 0, 4636, 4636),
         16#F0#           =>  --  11F0
          (0, 0, 4637, 4637),
         16#F1#           =>  --  11F1
          (0, 0, 4638, 4638),
         16#F2#           =>  --  11F2
          (0, 0, 4639, 4639),
         16#F3#           =>  --  11F3
          (0, 0, 4640, 4640),
         16#F4#           =>  --  11F4
          (0, 0, 4641, 4641),
         16#F5#           =>  --  11F5
          (0, 0, 4642, 4642),
         16#F6#           =>  --  11F6
          (0, 0, 4643, 4643),
         16#F7#           =>  --  11F7
          (0, 0, 4644, 4644),
         16#F8#           =>  --  11F8
          (0, 0, 4645, 4645),
         16#F9#           =>  --  11F9
          (0, 0, 4646, 4646),
         16#FA#           =>  --  11FA
          (0, 0, 4647, 4647),
         16#FB#           =>  --  11FB
          (0, 0, 4648, 4648),
         16#FC#           =>  --  11FC
          (0, 0, 4649, 4649),
         16#FD#           =>  --  11FD
          (0, 0, 4650, 4650),
         16#FE#           =>  --  11FE
          (0, 0, 4651, 4651),
         16#FF#           =>  --  11FF
          (0, 0, 4652, 4652),
         others           =>
          (0, 0, 0, 0));

   Group_0012 : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  1200
          (0, 0, 4653, 4653),
         16#01#           =>  --  1201
          (0, 0, 4654, 4654),
         16#02#           =>  --  1202
          (0, 0, 4655, 4655),
         16#03#           =>  --  1203
          (0, 0, 4656, 4656),
         16#04#           =>  --  1204
          (0, 0, 4657, 4657),
         16#05#           =>  --  1205
          (0, 0, 4658, 4658),
         16#06#           =>  --  1206
          (0, 0, 4659, 4659),
         16#07#           =>  --  1207
          (0, 0, 4660, 4660),
         16#08#           =>  --  1208
          (0, 0, 4661, 4661),
         16#09#           =>  --  1209
          (0, 0, 4662, 4662),
         16#0A#           =>  --  120A
          (0, 0, 4663, 4663),
         16#0B#           =>  --  120B
          (0, 0, 4664, 4664),
         16#0C#           =>  --  120C
          (0, 0, 4665, 4665),
         16#0D#           =>  --  120D
          (0, 0, 4666, 4666),
         16#0E#           =>  --  120E
          (0, 0, 4667, 4667),
         16#0F#           =>  --  120F
          (0, 0, 4668, 4668),
         16#10#           =>  --  1210
          (0, 0, 4669, 4669),
         16#11#           =>  --  1211
          (0, 0, 4670, 4670),
         16#12#           =>  --  1212
          (0, 0, 4671, 4671),
         16#13#           =>  --  1213
          (0, 0, 4672, 4672),
         16#14#           =>  --  1214
          (0, 0, 4673, 4673),
         16#15#           =>  --  1215
          (0, 0, 4674, 4674),
         16#16#           =>  --  1216
          (0, 0, 4675, 4675),
         16#17#           =>  --  1217
          (0, 0, 4676, 4676),
         16#18#           =>  --  1218
          (0, 0, 4677, 4677),
         16#19#           =>  --  1219
          (0, 0, 4678, 4678),
         16#1A#           =>  --  121A
          (0, 0, 4679, 4679),
         16#1B#           =>  --  121B
          (0, 0, 4680, 4680),
         16#1C#           =>  --  121C
          (0, 0, 4681, 4681),
         16#1D#           =>  --  121D
          (0, 0, 4682, 4682),
         16#1E#           =>  --  121E
          (0, 0, 4683, 4683),
         16#1F#           =>  --  121F
          (0, 0, 4684, 4684),
         16#20#           =>  --  1220
          (0, 0, 4685, 4685),
         16#21#           =>  --  1221
          (0, 0, 4686, 4686),
         16#22#           =>  --  1222
          (0, 0, 4687, 4687),
         16#23#           =>  --  1223
          (0, 0, 4688, 4688),
         16#24#           =>  --  1224
          (0, 0, 4689, 4689),
         16#25#           =>  --  1225
          (0, 0, 4690, 4690),
         16#26#           =>  --  1226
          (0, 0, 4691, 4691),
         16#27#           =>  --  1227
          (0, 0, 4692, 4692),
         16#28#           =>  --  1228
          (0, 0, 4693, 4693),
         16#29#           =>  --  1229
          (0, 0, 4694, 4694),
         16#2A#           =>  --  122A
          (0, 0, 4695, 4695),
         16#2B#           =>  --  122B
          (0, 0, 4696, 4696),
         16#2C#           =>  --  122C
          (0, 0, 4697, 4697),
         16#2D#           =>  --  122D
          (0, 0, 4698, 4698),
         16#2E#           =>  --  122E
          (0, 0, 4699, 4699),
         16#2F#           =>  --  122F
          (0, 0, 4700, 4700),
         16#30#           =>  --  1230
          (0, 0, 4701, 4701),
         16#31#           =>  --  1231
          (0, 0, 4702, 4702),
         16#32#           =>  --  1232
          (0, 0, 4703, 4703),
         16#33#           =>  --  1233
          (0, 0, 4704, 4704),
         16#34#           =>  --  1234
          (0, 0, 4705, 4705),
         16#35#           =>  --  1235
          (0, 0, 4706, 4706),
         16#36#           =>  --  1236
          (0, 0, 4707, 4707),
         16#37#           =>  --  1237
          (0, 0, 4708, 4708),
         16#38#           =>  --  1238
          (0, 0, 4709, 4709),
         16#39#           =>  --  1239
          (0, 0, 4710, 4710),
         16#3A#           =>  --  123A
          (0, 0, 4711, 4711),
         16#3B#           =>  --  123B
          (0, 0, 4712, 4712),
         16#3C#           =>  --  123C
          (0, 0, 4713, 4713),
         16#3D#           =>  --  123D
          (0, 0, 4714, 4714),
         16#3E#           =>  --  123E
          (0, 0, 4715, 4715),
         16#3F#           =>  --  123F
          (0, 0, 4716, 4716),
         16#40#           =>  --  1240
          (0, 0, 4717, 4717),
         16#41#           =>  --  1241
          (0, 0, 4718, 4718),
         16#42#           =>  --  1242
          (0, 0, 4719, 4719),
         16#43#           =>  --  1243
          (0, 0, 4720, 4720),
         16#44#           =>  --  1244
          (0, 0, 4721, 4721),
         16#45#           =>  --  1245
          (0, 0, 4722, 4722),
         16#46#           =>  --  1246
          (0, 0, 4723, 4723),
         16#47#           =>  --  1247
          (0, 0, 4724, 4724),
         16#48#           =>  --  1248
          (0, 0, 4725, 4725),
         16#4A#           =>  --  124A
          (0, 0, 4726, 4726),
         16#4B#           =>  --  124B
          (0, 0, 4727, 4727),
         16#4C#           =>  --  124C
          (0, 0, 4728, 4728),
         16#4D#           =>  --  124D
          (0, 0, 4729, 4729),
         16#50#           =>  --  1250
          (0, 0, 4730, 4730),
         16#51#           =>  --  1251
          (0, 0, 4731, 4731),
         16#52#           =>  --  1252
          (0, 0, 4732, 4732),
         16#53#           =>  --  1253
          (0, 0, 4733, 4733),
         16#54#           =>  --  1254
          (0, 0, 4734, 4734),
         16#55#           =>  --  1255
          (0, 0, 4735, 4735),
         16#56#           =>  --  1256
          (0, 0, 4736, 4736),
         16#58#           =>  --  1258
          (0, 0, 4737, 4737),
         16#5A#           =>  --  125A
          (0, 0, 4738, 4738),
         16#5B#           =>  --  125B
          (0, 0, 4739, 4739),
         16#5C#           =>  --  125C
          (0, 0, 4740, 4740),
         16#5D#           =>  --  125D
          (0, 0, 4741, 4741),
         16#60#           =>  --  1260
          (0, 0, 4742, 4742),
         16#61#           =>  --  1261
          (0, 0, 4743, 4743),
         16#62#           =>  --  1262
          (0, 0, 4744, 4744),
         16#63#           =>  --  1263
          (0, 0, 4745, 4745),
         16#64#           =>  --  1264
          (0, 0, 4746, 4746),
         16#65#           =>  --  1265
          (0, 0, 4747, 4747),
         16#66#           =>  --  1266
          (0, 0, 4748, 4748),
         16#67#           =>  --  1267
          (0, 0, 4749, 4749),
         16#68#           =>  --  1268
          (0, 0, 4750, 4750),
         16#69#           =>  --  1269
          (0, 0, 4751, 4751),
         16#6A#           =>  --  126A
          (0, 0, 4752, 4752),
         16#6B#           =>  --  126B
          (0, 0, 4753, 4753),
         16#6C#           =>  --  126C
          (0, 0, 4754, 4754),
         16#6D#           =>  --  126D
          (0, 0, 4755, 4755),
         16#6E#           =>  --  126E
          (0, 0, 4756, 4756),
         16#6F#           =>  --  126F
          (0, 0, 4757, 4757),
         16#70#           =>  --  1270
          (0, 0, 4758, 4758),
         16#71#           =>  --  1271
          (0, 0, 4759, 4759),
         16#72#           =>  --  1272
          (0, 0, 4760, 4760),
         16#73#           =>  --  1273
          (0, 0, 4761, 4761),
         16#74#           =>  --  1274
          (0, 0, 4762, 4762),
         16#75#           =>  --  1275
          (0, 0, 4763, 4763),
         16#76#           =>  --  1276
          (0, 0, 4764, 4764),
         16#77#           =>  --  1277
          (0, 0, 4765, 4765),
         16#78#           =>  --  1278
          (0, 0, 4766, 4766),
         16#79#           =>  --  1279
          (0, 0, 4767, 4767),
         16#7A#           =>  --  127A
          (0, 0, 4768, 4768),
         16#7B#           =>  --  127B
          (0, 0, 4769, 4769),
         16#7C#           =>  --  127C
          (0, 0, 4770, 4770),
         16#7D#           =>  --  127D
          (0, 0, 4771, 4771),
         16#7E#           =>  --  127E
          (0, 0, 4772, 4772),
         16#7F#           =>  --  127F
          (0, 0, 4773, 4773),
         16#80#           =>  --  1280
          (0, 0, 4774, 4774),
         16#81#           =>  --  1281
          (0, 0, 4775, 4775),
         16#82#           =>  --  1282
          (0, 0, 4776, 4776),
         16#83#           =>  --  1283
          (0, 0, 4777, 4777),
         16#84#           =>  --  1284
          (0, 0, 4778, 4778),
         16#85#           =>  --  1285
          (0, 0, 4779, 4779),
         16#86#           =>  --  1286
          (0, 0, 4780, 4780),
         16#87#           =>  --  1287
          (0, 0, 4781, 4781),
         16#88#           =>  --  1288
          (0, 0, 4782, 4782),
         16#8A#           =>  --  128A
          (0, 0, 4783, 4783),
         16#8B#           =>  --  128B
          (0, 0, 4784, 4784),
         16#8C#           =>  --  128C
          (0, 0, 4785, 4785),
         16#8D#           =>  --  128D
          (0, 0, 4786, 4786),
         16#90#           =>  --  1290
          (0, 0, 4787, 4787),
         16#91#           =>  --  1291
          (0, 0, 4788, 4788),
         16#92#           =>  --  1292
          (0, 0, 4789, 4789),
         16#93#           =>  --  1293
          (0, 0, 4790, 4790),
         16#94#           =>  --  1294
          (0, 0, 4791, 4791),
         16#95#           =>  --  1295
          (0, 0, 4792, 4792),
         16#96#           =>  --  1296
          (0, 0, 4793, 4793),
         16#97#           =>  --  1297
          (0, 0, 4794, 4794),
         16#98#           =>  --  1298
          (0, 0, 4795, 4795),
         16#99#           =>  --  1299
          (0, 0, 4796, 4796),
         16#9A#           =>  --  129A
          (0, 0, 4797, 4797),
         16#9B#           =>  --  129B
          (0, 0, 4798, 4798),
         16#9C#           =>  --  129C
          (0, 0, 4799, 4799),
         16#9D#           =>  --  129D
          (0, 0, 4800, 4800),
         16#9E#           =>  --  129E
          (0, 0, 4801, 4801),
         16#9F#           =>  --  129F
          (0, 0, 4802, 4802),
         16#A0#           =>  --  12A0
          (0, 0, 4803, 4803),
         16#A1#           =>  --  12A1
          (0, 0, 4804, 4804),
         16#A2#           =>  --  12A2
          (0, 0, 4805, 4805),
         16#A3#           =>  --  12A3
          (0, 0, 4806, 4806),
         16#A4#           =>  --  12A4
          (0, 0, 4807, 4807),
         16#A5#           =>  --  12A5
          (0, 0, 4808, 4808),
         16#A6#           =>  --  12A6
          (0, 0, 4809, 4809),
         16#A7#           =>  --  12A7
          (0, 0, 4810, 4810),
         16#A8#           =>  --  12A8
          (0, 0, 4811, 4811),
         16#A9#           =>  --  12A9
          (0, 0, 4812, 4812),
         16#AA#           =>  --  12AA
          (0, 0, 4813, 4813),
         16#AB#           =>  --  12AB
          (0, 0, 4814, 4814),
         16#AC#           =>  --  12AC
          (0, 0, 4815, 4815),
         16#AD#           =>  --  12AD
          (0, 0, 4816, 4816),
         16#AE#           =>  --  12AE
          (0, 0, 4817, 4817),
         16#AF#           =>  --  12AF
          (0, 0, 4818, 4818),
         16#B0#           =>  --  12B0
          (0, 0, 4819, 4819),
         16#B2#           =>  --  12B2
          (0, 0, 4820, 4820),
         16#B3#           =>  --  12B3
          (0, 0, 4821, 4821),
         16#B4#           =>  --  12B4
          (0, 0, 4822, 4822),
         16#B5#           =>  --  12B5
          (0, 0, 4823, 4823),
         16#B8#           =>  --  12B8
          (0, 0, 4824, 4824),
         16#B9#           =>  --  12B9
          (0, 0, 4825, 4825),
         16#BA#           =>  --  12BA
          (0, 0, 4826, 4826),
         16#BB#           =>  --  12BB
          (0, 0, 4827, 4827),
         16#BC#           =>  --  12BC
          (0, 0, 4828, 4828),
         16#BD#           =>  --  12BD
          (0, 0, 4829, 4829),
         16#BE#           =>  --  12BE
          (0, 0, 4830, 4830),
         16#C0#           =>  --  12C0
          (0, 0, 4831, 4831),
         16#C2#           =>  --  12C2
          (0, 0, 4832, 4832),
         16#C3#           =>  --  12C3
          (0, 0, 4833, 4833),
         16#C4#           =>  --  12C4
          (0, 0, 4834, 4834),
         16#C5#           =>  --  12C5
          (0, 0, 4835, 4835),
         16#C8#           =>  --  12C8
          (0, 0, 4836, 4836),
         16#C9#           =>  --  12C9
          (0, 0, 4837, 4837),
         16#CA#           =>  --  12CA
          (0, 0, 4838, 4838),
         16#CB#           =>  --  12CB
          (0, 0, 4839, 4839),
         16#CC#           =>  --  12CC
          (0, 0, 4840, 4840),
         16#CD#           =>  --  12CD
          (0, 0, 4841, 4841),
         16#CE#           =>  --  12CE
          (0, 0, 4842, 4842),
         16#CF#           =>  --  12CF
          (0, 0, 4843, 4843),
         16#D0#           =>  --  12D0
          (0, 0, 4844, 4844),
         16#D1#           =>  --  12D1
          (0, 0, 4845, 4845),
         16#D2#           =>  --  12D2
          (0, 0, 4846, 4846),
         16#D3#           =>  --  12D3
          (0, 0, 4847, 4847),
         16#D4#           =>  --  12D4
          (0, 0, 4848, 4848),
         16#D5#           =>  --  12D5
          (0, 0, 4849, 4849),
         16#D6#           =>  --  12D6
          (0, 0, 4850, 4850),
         16#D8#           =>  --  12D8
          (0, 0, 4851, 4851),
         16#D9#           =>  --  12D9
          (0, 0, 4852, 4852),
         16#DA#           =>  --  12DA
          (0, 0, 4853, 4853),
         16#DB#           =>  --  12DB
          (0, 0, 4854, 4854),
         16#DC#           =>  --  12DC
          (0, 0, 4855, 4855),
         16#DD#           =>  --  12DD
          (0, 0, 4856, 4856),
         16#DE#           =>  --  12DE
          (0, 0, 4857, 4857),
         16#DF#           =>  --  12DF
          (0, 0, 4858, 4858),
         16#E0#           =>  --  12E0
          (0, 0, 4859, 4859),
         16#E1#           =>  --  12E1
          (0, 0, 4860, 4860),
         16#E2#           =>  --  12E2
          (0, 0, 4861, 4861),
         16#E3#           =>  --  12E3
          (0, 0, 4862, 4862),
         16#E4#           =>  --  12E4
          (0, 0, 4863, 4863),
         16#E5#           =>  --  12E5
          (0, 0, 4864, 4864),
         16#E6#           =>  --  12E6
          (0, 0, 4865, 4865),
         16#E7#           =>  --  12E7
          (0, 0, 4866, 4866),
         16#E8#           =>  --  12E8
          (0, 0, 4867, 4867),
         16#E9#           =>  --  12E9
          (0, 0, 4868, 4868),
         16#EA#           =>  --  12EA
          (0, 0, 4869, 4869),
         16#EB#           =>  --  12EB
          (0, 0, 4870, 4870),
         16#EC#           =>  --  12EC
          (0, 0, 4871, 4871),
         16#ED#           =>  --  12ED
          (0, 0, 4872, 4872),
         16#EE#           =>  --  12EE
          (0, 0, 4873, 4873),
         16#EF#           =>  --  12EF
          (0, 0, 4874, 4874),
         16#F0#           =>  --  12F0
          (0, 0, 4875, 4875),
         16#F1#           =>  --  12F1
          (0, 0, 4876, 4876),
         16#F2#           =>  --  12F2
          (0, 0, 4877, 4877),
         16#F3#           =>  --  12F3
          (0, 0, 4878, 4878),
         16#F4#           =>  --  12F4
          (0, 0, 4879, 4879),
         16#F5#           =>  --  12F5
          (0, 0, 4880, 4880),
         16#F6#           =>  --  12F6
          (0, 0, 4881, 4881),
         16#F7#           =>  --  12F7
          (0, 0, 4882, 4882),
         16#F8#           =>  --  12F8
          (0, 0, 4883, 4883),
         16#F9#           =>  --  12F9
          (0, 0, 4884, 4884),
         16#FA#           =>  --  12FA
          (0, 0, 4885, 4885),
         16#FB#           =>  --  12FB
          (0, 0, 4886, 4886),
         16#FC#           =>  --  12FC
          (0, 0, 4887, 4887),
         16#FD#           =>  --  12FD
          (0, 0, 4888, 4888),
         16#FE#           =>  --  12FE
          (0, 0, 4889, 4889),
         16#FF#           =>  --  12FF
          (0, 0, 4890, 4890),
         others           =>
          (0, 0, 0, 0));

   Group_0013 : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  1300
          (0, 0, 4891, 4891),
         16#01#           =>  --  1301
          (0, 0, 4892, 4892),
         16#02#           =>  --  1302
          (0, 0, 4893, 4893),
         16#03#           =>  --  1303
          (0, 0, 4894, 4894),
         16#04#           =>  --  1304
          (0, 0, 4895, 4895),
         16#05#           =>  --  1305
          (0, 0, 4896, 4896),
         16#06#           =>  --  1306
          (0, 0, 4897, 4897),
         16#07#           =>  --  1307
          (0, 0, 4898, 4898),
         16#08#           =>  --  1308
          (0, 0, 4899, 4899),
         16#09#           =>  --  1309
          (0, 0, 4900, 4900),
         16#0A#           =>  --  130A
          (0, 0, 4901, 4901),
         16#0B#           =>  --  130B
          (0, 0, 4902, 4902),
         16#0C#           =>  --  130C
          (0, 0, 4903, 4903),
         16#0D#           =>  --  130D
          (0, 0, 4904, 4904),
         16#0E#           =>  --  130E
          (0, 0, 4905, 4905),
         16#0F#           =>  --  130F
          (0, 0, 4906, 4906),
         16#10#           =>  --  1310
          (0, 0, 4907, 4907),
         16#12#           =>  --  1312
          (0, 0, 4908, 4908),
         16#13#           =>  --  1313
          (0, 0, 4909, 4909),
         16#14#           =>  --  1314
          (0, 0, 4910, 4910),
         16#15#           =>  --  1315
          (0, 0, 4911, 4911),
         16#18#           =>  --  1318
          (0, 0, 4912, 4912),
         16#19#           =>  --  1319
          (0, 0, 4913, 4913),
         16#1A#           =>  --  131A
          (0, 0, 4914, 4914),
         16#1B#           =>  --  131B
          (0, 0, 4915, 4915),
         16#1C#           =>  --  131C
          (0, 0, 4916, 4916),
         16#1D#           =>  --  131D
          (0, 0, 4917, 4917),
         16#1E#           =>  --  131E
          (0, 0, 4918, 4918),
         16#1F#           =>  --  131F
          (0, 0, 4919, 4919),
         16#20#           =>  --  1320
          (0, 0, 4920, 4920),
         16#21#           =>  --  1321
          (0, 0, 4921, 4921),
         16#22#           =>  --  1322
          (0, 0, 4922, 4922),
         16#23#           =>  --  1323
          (0, 0, 4923, 4923),
         16#24#           =>  --  1324
          (0, 0, 4924, 4924),
         16#25#           =>  --  1325
          (0, 0, 4925, 4925),
         16#26#           =>  --  1326
          (0, 0, 4926, 4926),
         16#27#           =>  --  1327
          (0, 0, 4927, 4927),
         16#28#           =>  --  1328
          (0, 0, 4928, 4928),
         16#29#           =>  --  1329
          (0, 0, 4929, 4929),
         16#2A#           =>  --  132A
          (0, 0, 4930, 4930),
         16#2B#           =>  --  132B
          (0, 0, 4931, 4931),
         16#2C#           =>  --  132C
          (0, 0, 4932, 4932),
         16#2D#           =>  --  132D
          (0, 0, 4933, 4933),
         16#2E#           =>  --  132E
          (0, 0, 4934, 4934),
         16#2F#           =>  --  132F
          (0, 0, 4935, 4935),
         16#30#           =>  --  1330
          (0, 0, 4936, 4936),
         16#31#           =>  --  1331
          (0, 0, 4937, 4937),
         16#32#           =>  --  1332
          (0, 0, 4938, 4938),
         16#33#           =>  --  1333
          (0, 0, 4939, 4939),
         16#34#           =>  --  1334
          (0, 0, 4940, 4940),
         16#35#           =>  --  1335
          (0, 0, 4941, 4941),
         16#36#           =>  --  1336
          (0, 0, 4942, 4942),
         16#37#           =>  --  1337
          (0, 0, 4943, 4943),
         16#38#           =>  --  1338
          (0, 0, 4944, 4944),
         16#39#           =>  --  1339
          (0, 0, 4945, 4945),
         16#3A#           =>  --  133A
          (0, 0, 4946, 4946),
         16#3B#           =>  --  133B
          (0, 0, 4947, 4947),
         16#3C#           =>  --  133C
          (0, 0, 4948, 4948),
         16#3D#           =>  --  133D
          (0, 0, 4949, 4949),
         16#3E#           =>  --  133E
          (0, 0, 4950, 4950),
         16#3F#           =>  --  133F
          (0, 0, 4951, 4951),
         16#40#           =>  --  1340
          (0, 0, 4952, 4952),
         16#41#           =>  --  1341
          (0, 0, 4953, 4953),
         16#42#           =>  --  1342
          (0, 0, 4954, 4954),
         16#43#           =>  --  1343
          (0, 0, 4955, 4955),
         16#44#           =>  --  1344
          (0, 0, 4956, 4956),
         16#45#           =>  --  1345
          (0, 0, 4957, 4957),
         16#46#           =>  --  1346
          (0, 0, 4958, 4958),
         16#47#           =>  --  1347
          (0, 0, 4959, 4959),
         16#48#           =>  --  1348
          (0, 0, 4960, 4960),
         16#49#           =>  --  1349
          (0, 0, 4961, 4961),
         16#4A#           =>  --  134A
          (0, 0, 4962, 4962),
         16#4B#           =>  --  134B
          (0, 0, 4963, 4963),
         16#4C#           =>  --  134C
          (0, 0, 4964, 4964),
         16#4D#           =>  --  134D
          (0, 0, 4965, 4965),
         16#4E#           =>  --  134E
          (0, 0, 4966, 4966),
         16#4F#           =>  --  134F
          (0, 0, 4967, 4967),
         16#50#           =>  --  1350
          (0, 0, 4968, 4968),
         16#51#           =>  --  1351
          (0, 0, 4969, 4969),
         16#52#           =>  --  1352
          (0, 0, 4970, 4970),
         16#53#           =>  --  1353
          (0, 0, 4971, 4971),
         16#54#           =>  --  1354
          (0, 0, 4972, 4972),
         16#55#           =>  --  1355
          (0, 0, 4973, 4973),
         16#56#           =>  --  1356
          (0, 0, 4974, 4974),
         16#57#           =>  --  1357
          (0, 0, 4975, 4975),
         16#58#           =>  --  1358
          (0, 0, 4976, 4976),
         16#59#           =>  --  1359
          (0, 0, 4977, 4977),
         16#5A#           =>  --  135A
          (0, 0, 4978, 4978),
         16#5D#           =>  --  135D
          (0, 0, 4979, 4979),
         16#5E#           =>  --  135E
          (0, 0, 4980, 4980),
         16#5F#           =>  --  135F
          (0, 0, 4981, 4981),
         16#60#           =>  --  1360
          (0, 0, 4982, 4982),
         16#61#           =>  --  1361
          (0, 0, 4983, 4983),
         16#62#           =>  --  1362
          (0, 0, 4984, 4984),
         16#63#           =>  --  1363
          (0, 0, 4985, 4985),
         16#64#           =>  --  1364
          (0, 0, 4986, 4986),
         16#65#           =>  --  1365
          (0, 0, 4987, 4987),
         16#66#           =>  --  1366
          (0, 0, 4988, 4988),
         16#67#           =>  --  1367
          (0, 0, 4989, 4989),
         16#68#           =>  --  1368
          (0, 0, 4990, 4990),
         16#69#           =>  --  1369
          (0, 0, 24, 24),
         16#6A#           =>  --  136A
          (0, 0, 25, 25),
         16#6B#           =>  --  136B
          (0, 0, 26, 26),
         16#6C#           =>  --  136C
          (0, 0, 27, 27),
         16#6D#           =>  --  136D
          (0, 0, 28, 28),
         16#6E#           =>  --  136E
          (0, 0, 29, 29),
         16#6F#           =>  --  136F
          (0, 0, 30, 30),
         16#70#           =>  --  1370
          (0, 0, 31, 31),
         16#71#           =>  --  1371
          (0, 0, 32, 32),
         16#72#           =>  --  1372
          (0, 0, 4991, 4991),
         16#73#           =>  --  1373
          (0, 0, 4992, 4992),
         16#74#           =>  --  1374
          (0, 0, 4993, 4993),
         16#75#           =>  --  1375
          (0, 0, 4994, 4994),
         16#76#           =>  --  1376
          (0, 0, 4995, 4995),
         16#77#           =>  --  1377
          (0, 0, 4996, 4996),
         16#78#           =>  --  1378
          (0, 0, 4997, 4997),
         16#79#           =>  --  1379
          (0, 0, 4998, 4998),
         16#7A#           =>  --  137A
          (0, 0, 4999, 4999),
         16#7B#           =>  --  137B
          (0, 0, 5000, 5000),
         16#7C#           =>  --  137C
          (0, 0, 5001, 5001),
         16#80#           =>  --  1380
          (0, 0, 5002, 5002),
         16#81#           =>  --  1381
          (0, 0, 5003, 5003),
         16#82#           =>  --  1382
          (0, 0, 5004, 5004),
         16#83#           =>  --  1383
          (0, 0, 5005, 5005),
         16#84#           =>  --  1384
          (0, 0, 5006, 5006),
         16#85#           =>  --  1385
          (0, 0, 5007, 5007),
         16#86#           =>  --  1386
          (0, 0, 5008, 5008),
         16#87#           =>  --  1387
          (0, 0, 5009, 5009),
         16#88#           =>  --  1388
          (0, 0, 5010, 5010),
         16#89#           =>  --  1389
          (0, 0, 5011, 5011),
         16#8A#           =>  --  138A
          (0, 0, 5012, 5012),
         16#8B#           =>  --  138B
          (0, 0, 5013, 5013),
         16#8C#           =>  --  138C
          (0, 0, 5014, 5014),
         16#8D#           =>  --  138D
          (0, 0, 5015, 5015),
         16#8E#           =>  --  138E
          (0, 0, 5016, 5016),
         16#8F#           =>  --  138F
          (0, 0, 5017, 5017),
         16#90#           =>  --  1390
          (0, 0, 5018, 5018),
         16#91#           =>  --  1391
          (0, 0, 5019, 5019),
         16#92#           =>  --  1392
          (0, 0, 5020, 5020),
         16#93#           =>  --  1393
          (0, 0, 5021, 5021),
         16#94#           =>  --  1394
          (0, 0, 5022, 5022),
         16#95#           =>  --  1395
          (0, 0, 5023, 5023),
         16#96#           =>  --  1396
          (0, 0, 5024, 5024),
         16#97#           =>  --  1397
          (0, 0, 5025, 5025),
         16#98#           =>  --  1398
          (0, 0, 5026, 5026),
         16#99#           =>  --  1399
          (0, 0, 5027, 5027),
         16#A0#           =>  --  13A0
          (0, 0, 5028, 5028),
         16#A1#           =>  --  13A1
          (0, 0, 5029, 5029),
         16#A2#           =>  --  13A2
          (0, 0, 5030, 5030),
         16#A3#           =>  --  13A3
          (0, 0, 5031, 5031),
         16#A4#           =>  --  13A4
          (0, 0, 5032, 5032),
         16#A5#           =>  --  13A5
          (0, 0, 5033, 5033),
         16#A6#           =>  --  13A6
          (0, 0, 5034, 5034),
         16#A7#           =>  --  13A7
          (0, 0, 5035, 5035),
         16#A8#           =>  --  13A8
          (0, 0, 5036, 5036),
         16#A9#           =>  --  13A9
          (0, 0, 5037, 5037),
         16#AA#           =>  --  13AA
          (0, 0, 5038, 5038),
         16#AB#           =>  --  13AB
          (0, 0, 5039, 5039),
         16#AC#           =>  --  13AC
          (0, 0, 5040, 5040),
         16#AD#           =>  --  13AD
          (0, 0, 5041, 5041),
         16#AE#           =>  --  13AE
          (0, 0, 5042, 5042),
         16#AF#           =>  --  13AF
          (0, 0, 5043, 5043),
         16#B0#           =>  --  13B0
          (0, 0, 5044, 5044),
         16#B1#           =>  --  13B1
          (0, 0, 5045, 5045),
         16#B2#           =>  --  13B2
          (0, 0, 5046, 5046),
         16#B3#           =>  --  13B3
          (0, 0, 5047, 5047),
         16#B4#           =>  --  13B4
          (0, 0, 5048, 5048),
         16#B5#           =>  --  13B5
          (0, 0, 5049, 5049),
         16#B6#           =>  --  13B6
          (0, 0, 5050, 5050),
         16#B7#           =>  --  13B7
          (0, 0, 5051, 5051),
         16#B8#           =>  --  13B8
          (0, 0, 5052, 5052),
         16#B9#           =>  --  13B9
          (0, 0, 5053, 5053),
         16#BA#           =>  --  13BA
          (0, 0, 5054, 5054),
         16#BB#           =>  --  13BB
          (0, 0, 5055, 5055),
         16#BC#           =>  --  13BC
          (0, 0, 5056, 5056),
         16#BD#           =>  --  13BD
          (0, 0, 5057, 5057),
         16#BE#           =>  --  13BE
          (0, 0, 5058, 5058),
         16#BF#           =>  --  13BF
          (0, 0, 5059, 5059),
         16#C0#           =>  --  13C0
          (0, 0, 5060, 5060),
         16#C1#           =>  --  13C1
          (0, 0, 5061, 5061),
         16#C2#           =>  --  13C2
          (0, 0, 5062, 5062),
         16#C3#           =>  --  13C3
          (0, 0, 5063, 5063),
         16#C4#           =>  --  13C4
          (0, 0, 5064, 5064),
         16#C5#           =>  --  13C5
          (0, 0, 5065, 5065),
         16#C6#           =>  --  13C6
          (0, 0, 5066, 5066),
         16#C7#           =>  --  13C7
          (0, 0, 5067, 5067),
         16#C8#           =>  --  13C8
          (0, 0, 5068, 5068),
         16#C9#           =>  --  13C9
          (0, 0, 5069, 5069),
         16#CA#           =>  --  13CA
          (0, 0, 5070, 5070),
         16#CB#           =>  --  13CB
          (0, 0, 5071, 5071),
         16#CC#           =>  --  13CC
          (0, 0, 5072, 5072),
         16#CD#           =>  --  13CD
          (0, 0, 5073, 5073),
         16#CE#           =>  --  13CE
          (0, 0, 5074, 5074),
         16#CF#           =>  --  13CF
          (0, 0, 5075, 5075),
         16#D0#           =>  --  13D0
          (0, 0, 5076, 5076),
         16#D1#           =>  --  13D1
          (0, 0, 5077, 5077),
         16#D2#           =>  --  13D2
          (0, 0, 5078, 5078),
         16#D3#           =>  --  13D3
          (0, 0, 5079, 5079),
         16#D4#           =>  --  13D4
          (0, 0, 5080, 5080),
         16#D5#           =>  --  13D5
          (0, 0, 5081, 5081),
         16#D6#           =>  --  13D6
          (0, 0, 5082, 5082),
         16#D7#           =>  --  13D7
          (0, 0, 5083, 5083),
         16#D8#           =>  --  13D8
          (0, 0, 5084, 5084),
         16#D9#           =>  --  13D9
          (0, 0, 5085, 5085),
         16#DA#           =>  --  13DA
          (0, 0, 5086, 5086),
         16#DB#           =>  --  13DB
          (0, 0, 5087, 5087),
         16#DC#           =>  --  13DC
          (0, 0, 5088, 5088),
         16#DD#           =>  --  13DD
          (0, 0, 5089, 5089),
         16#DE#           =>  --  13DE
          (0, 0, 5090, 5090),
         16#DF#           =>  --  13DF
          (0, 0, 5091, 5091),
         16#E0#           =>  --  13E0
          (0, 0, 5092, 5092),
         16#E1#           =>  --  13E1
          (0, 0, 5093, 5093),
         16#E2#           =>  --  13E2
          (0, 0, 5094, 5094),
         16#E3#           =>  --  13E3
          (0, 0, 5095, 5095),
         16#E4#           =>  --  13E4
          (0, 0, 5096, 5096),
         16#E5#           =>  --  13E5
          (0, 0, 5097, 5097),
         16#E6#           =>  --  13E6
          (0, 0, 5098, 5098),
         16#E7#           =>  --  13E7
          (0, 0, 5099, 5099),
         16#E8#           =>  --  13E8
          (0, 0, 5100, 5100),
         16#E9#           =>  --  13E9
          (0, 0, 5101, 5101),
         16#EA#           =>  --  13EA
          (0, 0, 5102, 5102),
         16#EB#           =>  --  13EB
          (0, 0, 5103, 5103),
         16#EC#           =>  --  13EC
          (0, 0, 5104, 5104),
         16#ED#           =>  --  13ED
          (0, 0, 5105, 5105),
         16#EE#           =>  --  13EE
          (0, 0, 5106, 5106),
         16#EF#           =>  --  13EF
          (0, 0, 5107, 5107),
         16#F0#           =>  --  13F0
          (0, 0, 5108, 5108),
         16#F1#           =>  --  13F1
          (0, 0, 5109, 5109),
         16#F2#           =>  --  13F2
          (0, 0, 5110, 5110),
         16#F3#           =>  --  13F3
          (0, 0, 5111, 5111),
         16#F4#           =>  --  13F4
          (0, 0, 5112, 5112),
         others           =>
          (0, 0, 0, 0));

   Group_0014 : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  1400
          (0, 0, 5113, 5113),
         16#01#           =>  --  1401
          (0, 0, 5114, 5114),
         16#02#           =>  --  1402
          (0, 0, 5115, 5115),
         16#03#           =>  --  1403
          (0, 0, 5116, 5116),
         16#04#           =>  --  1404
          (0, 0, 5117, 5117),
         16#05#           =>  --  1405
          (0, 0, 5118, 5118),
         16#06#           =>  --  1406
          (0, 0, 5119, 5119),
         16#07#           =>  --  1407
          (0, 0, 5120, 5120),
         16#08#           =>  --  1408
          (0, 0, 5121, 5121),
         16#09#           =>  --  1409
          (0, 0, 5122, 5122),
         16#0A#           =>  --  140A
          (0, 0, 5123, 5123),
         16#0B#           =>  --  140B
          (0, 0, 5124, 5124),
         16#0C#           =>  --  140C
          (0, 0, 5125, 5125),
         16#0D#           =>  --  140D
          (0, 0, 5126, 5126),
         16#0E#           =>  --  140E
          (0, 0, 5127, 5127),
         16#0F#           =>  --  140F
          (0, 0, 5128, 5128),
         16#10#           =>  --  1410
          (0, 0, 5129, 5129),
         16#11#           =>  --  1411
          (0, 0, 5130, 5130),
         16#12#           =>  --  1412
          (0, 0, 5131, 5131),
         16#13#           =>  --  1413
          (0, 0, 5132, 5132),
         16#14#           =>  --  1414
          (0, 0, 5133, 5133),
         16#15#           =>  --  1415
          (0, 0, 5134, 5134),
         16#16#           =>  --  1416
          (0, 0, 5135, 5135),
         16#17#           =>  --  1417
          (0, 0, 5136, 5136),
         16#18#           =>  --  1418
          (0, 0, 5137, 5137),
         16#19#           =>  --  1419
          (0, 0, 5138, 5138),
         16#1A#           =>  --  141A
          (0, 0, 5139, 5139),
         16#1B#           =>  --  141B
          (0, 0, 5140, 5140),
         16#1C#           =>  --  141C
          (0, 0, 5141, 5141),
         16#1D#           =>  --  141D
          (0, 0, 5142, 5142),
         16#1E#           =>  --  141E
          (0, 0, 5143, 5143),
         16#1F#           =>  --  141F
          (0, 0, 5144, 5144),
         16#20#           =>  --  1420
          (0, 0, 5145, 5145),
         16#21#           =>  --  1421
          (0, 0, 5146, 5146),
         16#22#           =>  --  1422
          (0, 0, 5147, 5147),
         16#23#           =>  --  1423
          (0, 0, 5148, 5148),
         16#24#           =>  --  1424
          (0, 0, 5149, 5149),
         16#25#           =>  --  1425
          (0, 0, 5150, 5150),
         16#26#           =>  --  1426
          (0, 0, 5151, 5151),
         16#27#           =>  --  1427
          (0, 0, 5152, 5152),
         16#28#           =>  --  1428
          (0, 0, 5153, 5153),
         16#29#           =>  --  1429
          (0, 0, 5154, 5154),
         16#2A#           =>  --  142A
          (0, 0, 5155, 5155),
         16#2B#           =>  --  142B
          (0, 0, 5156, 5156),
         16#2C#           =>  --  142C
          (0, 0, 5157, 5157),
         16#2D#           =>  --  142D
          (0, 0, 5158, 5158),
         16#2E#           =>  --  142E
          (0, 0, 5159, 5159),
         16#2F#           =>  --  142F
          (0, 0, 5160, 5160),
         16#30#           =>  --  1430
          (0, 0, 5161, 5161),
         16#31#           =>  --  1431
          (0, 0, 5162, 5162),
         16#32#           =>  --  1432
          (0, 0, 5163, 5163),
         16#33#           =>  --  1433
          (0, 0, 5164, 5164),
         16#34#           =>  --  1434
          (0, 0, 5165, 5165),
         16#35#           =>  --  1435
          (0, 0, 5166, 5166),
         16#36#           =>  --  1436
          (0, 0, 5167, 5167),
         16#37#           =>  --  1437
          (0, 0, 5168, 5168),
         16#38#           =>  --  1438
          (0, 0, 5169, 5169),
         16#39#           =>  --  1439
          (0, 0, 5170, 5170),
         16#3A#           =>  --  143A
          (0, 0, 5171, 5171),
         16#3B#           =>  --  143B
          (0, 0, 5172, 5172),
         16#3C#           =>  --  143C
          (0, 0, 5173, 5173),
         16#3D#           =>  --  143D
          (0, 0, 5174, 5174),
         16#3E#           =>  --  143E
          (0, 0, 5175, 5175),
         16#3F#           =>  --  143F
          (0, 0, 5176, 5176),
         16#40#           =>  --  1440
          (0, 0, 5177, 5177),
         16#41#           =>  --  1441
          (0, 0, 5178, 5178),
         16#42#           =>  --  1442
          (0, 0, 5179, 5179),
         16#43#           =>  --  1443
          (0, 0, 5180, 5180),
         16#44#           =>  --  1444
          (0, 0, 5181, 5181),
         16#45#           =>  --  1445
          (0, 0, 5182, 5182),
         16#46#           =>  --  1446
          (0, 0, 5183, 5183),
         16#47#           =>  --  1447
          (0, 0, 5184, 5184),
         16#48#           =>  --  1448
          (0, 0, 5185, 5185),
         16#49#           =>  --  1449
          (0, 0, 5186, 5186),
         16#4A#           =>  --  144A
          (0, 0, 5187, 5187),
         16#4B#           =>  --  144B
          (0, 0, 5188, 5188),
         16#4C#           =>  --  144C
          (0, 0, 5189, 5189),
         16#4D#           =>  --  144D
          (0, 0, 5190, 5190),
         16#4E#           =>  --  144E
          (0, 0, 5191, 5191),
         16#4F#           =>  --  144F
          (0, 0, 5192, 5192),
         16#50#           =>  --  1450
          (0, 0, 5193, 5193),
         16#51#           =>  --  1451
          (0, 0, 5194, 5194),
         16#52#           =>  --  1452
          (0, 0, 5195, 5195),
         16#53#           =>  --  1453
          (0, 0, 5196, 5196),
         16#54#           =>  --  1454
          (0, 0, 5197, 5197),
         16#55#           =>  --  1455
          (0, 0, 5198, 5198),
         16#56#           =>  --  1456
          (0, 0, 5199, 5199),
         16#57#           =>  --  1457
          (0, 0, 5200, 5200),
         16#58#           =>  --  1458
          (0, 0, 5201, 5201),
         16#59#           =>  --  1459
          (0, 0, 5202, 5202),
         16#5A#           =>  --  145A
          (0, 0, 5203, 5203),
         16#5B#           =>  --  145B
          (0, 0, 5204, 5204),
         16#5C#           =>  --  145C
          (0, 0, 5205, 5205),
         16#5D#           =>  --  145D
          (0, 0, 5206, 5206),
         16#5E#           =>  --  145E
          (0, 0, 5207, 5207),
         16#5F#           =>  --  145F
          (0, 0, 5208, 5208),
         16#60#           =>  --  1460
          (0, 0, 5209, 5209),
         16#61#           =>  --  1461
          (0, 0, 5210, 5210),
         16#62#           =>  --  1462
          (0, 0, 5211, 5211),
         16#63#           =>  --  1463
          (0, 0, 5212, 5212),
         16#64#           =>  --  1464
          (0, 0, 5213, 5213),
         16#65#           =>  --  1465
          (0, 0, 5214, 5214),
         16#66#           =>  --  1466
          (0, 0, 5215, 5215),
         16#67#           =>  --  1467
          (0, 0, 5216, 5216),
         16#68#           =>  --  1468
          (0, 0, 5217, 5217),
         16#69#           =>  --  1469
          (0, 0, 5218, 5218),
         16#6A#           =>  --  146A
          (0, 0, 5219, 5219),
         16#6B#           =>  --  146B
          (0, 0, 5220, 5220),
         16#6C#           =>  --  146C
          (0, 0, 5221, 5221),
         16#6D#           =>  --  146D
          (0, 0, 5222, 5222),
         16#6E#           =>  --  146E
          (0, 0, 5223, 5223),
         16#6F#           =>  --  146F
          (0, 0, 5224, 5224),
         16#70#           =>  --  1470
          (0, 0, 5225, 5225),
         16#71#           =>  --  1471
          (0, 0, 5226, 5226),
         16#72#           =>  --  1472
          (0, 0, 5227, 5227),
         16#73#           =>  --  1473
          (0, 0, 5228, 5228),
         16#74#           =>  --  1474
          (0, 0, 5229, 5229),
         16#75#           =>  --  1475
          (0, 0, 5230, 5230),
         16#76#           =>  --  1476
          (0, 0, 5231, 5231),
         16#77#           =>  --  1477
          (0, 0, 5232, 5232),
         16#78#           =>  --  1478
          (0, 0, 5233, 5233),
         16#79#           =>  --  1479
          (0, 0, 5234, 5234),
         16#7A#           =>  --  147A
          (0, 0, 5235, 5235),
         16#7B#           =>  --  147B
          (0, 0, 5236, 5236),
         16#7C#           =>  --  147C
          (0, 0, 5237, 5237),
         16#7D#           =>  --  147D
          (0, 0, 5238, 5238),
         16#7E#           =>  --  147E
          (0, 0, 5239, 5239),
         16#7F#           =>  --  147F
          (0, 0, 5240, 5240),
         16#80#           =>  --  1480
          (0, 0, 5241, 5241),
         16#81#           =>  --  1481
          (0, 0, 5242, 5242),
         16#82#           =>  --  1482
          (0, 0, 5243, 5243),
         16#83#           =>  --  1483
          (0, 0, 5244, 5244),
         16#84#           =>  --  1484
          (0, 0, 5245, 5245),
         16#85#           =>  --  1485
          (0, 0, 5246, 5246),
         16#86#           =>  --  1486
          (0, 0, 5247, 5247),
         16#87#           =>  --  1487
          (0, 0, 5248, 5248),
         16#88#           =>  --  1488
          (0, 0, 5249, 5249),
         16#89#           =>  --  1489
          (0, 0, 5250, 5250),
         16#8A#           =>  --  148A
          (0, 0, 5251, 5251),
         16#8B#           =>  --  148B
          (0, 0, 5252, 5252),
         16#8C#           =>  --  148C
          (0, 0, 5253, 5253),
         16#8D#           =>  --  148D
          (0, 0, 5254, 5254),
         16#8E#           =>  --  148E
          (0, 0, 5255, 5255),
         16#8F#           =>  --  148F
          (0, 0, 5256, 5256),
         16#90#           =>  --  1490
          (0, 0, 5257, 5257),
         16#91#           =>  --  1491
          (0, 0, 5258, 5258),
         16#92#           =>  --  1492
          (0, 0, 5259, 5259),
         16#93#           =>  --  1493
          (0, 0, 5260, 5260),
         16#94#           =>  --  1494
          (0, 0, 5261, 5261),
         16#95#           =>  --  1495
          (0, 0, 5262, 5262),
         16#96#           =>  --  1496
          (0, 0, 5263, 5263),
         16#97#           =>  --  1497
          (0, 0, 5264, 5264),
         16#98#           =>  --  1498
          (0, 0, 5265, 5265),
         16#99#           =>  --  1499
          (0, 0, 5266, 5266),
         16#9A#           =>  --  149A
          (0, 0, 5267, 5267),
         16#9B#           =>  --  149B
          (0, 0, 5268, 5268),
         16#9C#           =>  --  149C
          (0, 0, 5269, 5269),
         16#9D#           =>  --  149D
          (0, 0, 5270, 5270),
         16#9E#           =>  --  149E
          (0, 0, 5271, 5271),
         16#9F#           =>  --  149F
          (0, 0, 5272, 5272),
         16#A0#           =>  --  14A0
          (0, 0, 5273, 5273),
         16#A1#           =>  --  14A1
          (0, 0, 5274, 5274),
         16#A2#           =>  --  14A2
          (0, 0, 5275, 5275),
         16#A3#           =>  --  14A3
          (0, 0, 5276, 5276),
         16#A4#           =>  --  14A4
          (0, 0, 5277, 5277),
         16#A5#           =>  --  14A5
          (0, 0, 5278, 5278),
         16#A6#           =>  --  14A6
          (0, 0, 5279, 5279),
         16#A7#           =>  --  14A7
          (0, 0, 5280, 5280),
         16#A8#           =>  --  14A8
          (0, 0, 5281, 5281),
         16#A9#           =>  --  14A9
          (0, 0, 5282, 5282),
         16#AA#           =>  --  14AA
          (0, 0, 5283, 5283),
         16#AB#           =>  --  14AB
          (0, 0, 5284, 5284),
         16#AC#           =>  --  14AC
          (0, 0, 5285, 5285),
         16#AD#           =>  --  14AD
          (0, 0, 5286, 5286),
         16#AE#           =>  --  14AE
          (0, 0, 5287, 5287),
         16#AF#           =>  --  14AF
          (0, 0, 5288, 5288),
         16#B0#           =>  --  14B0
          (0, 0, 5289, 5289),
         16#B1#           =>  --  14B1
          (0, 0, 5290, 5290),
         16#B2#           =>  --  14B2
          (0, 0, 5291, 5291),
         16#B3#           =>  --  14B3
          (0, 0, 5292, 5292),
         16#B4#           =>  --  14B4
          (0, 0, 5293, 5293),
         16#B5#           =>  --  14B5
          (0, 0, 5294, 5294),
         16#B6#           =>  --  14B6
          (0, 0, 5295, 5295),
         16#B7#           =>  --  14B7
          (0, 0, 5296, 5296),
         16#B8#           =>  --  14B8
          (0, 0, 5297, 5297),
         16#B9#           =>  --  14B9
          (0, 0, 5298, 5298),
         16#BA#           =>  --  14BA
          (0, 0, 5299, 5299),
         16#BB#           =>  --  14BB
          (0, 0, 5300, 5300),
         16#BC#           =>  --  14BC
          (0, 0, 5301, 5301),
         16#BD#           =>  --  14BD
          (0, 0, 5302, 5302),
         16#BE#           =>  --  14BE
          (0, 0, 5303, 5303),
         16#BF#           =>  --  14BF
          (0, 0, 5304, 5304),
         16#C0#           =>  --  14C0
          (0, 0, 5305, 5305),
         16#C1#           =>  --  14C1
          (0, 0, 5306, 5306),
         16#C2#           =>  --  14C2
          (0, 0, 5307, 5307),
         16#C3#           =>  --  14C3
          (0, 0, 5308, 5308),
         16#C4#           =>  --  14C4
          (0, 0, 5309, 5309),
         16#C5#           =>  --  14C5
          (0, 0, 5310, 5310),
         16#C6#           =>  --  14C6
          (0, 0, 5311, 5311),
         16#C7#           =>  --  14C7
          (0, 0, 5312, 5312),
         16#C8#           =>  --  14C8
          (0, 0, 5313, 5313),
         16#C9#           =>  --  14C9
          (0, 0, 5314, 5314),
         16#CA#           =>  --  14CA
          (0, 0, 5315, 5315),
         16#CB#           =>  --  14CB
          (0, 0, 5316, 5316),
         16#CC#           =>  --  14CC
          (0, 0, 5317, 5317),
         16#CD#           =>  --  14CD
          (0, 0, 5318, 5318),
         16#CE#           =>  --  14CE
          (0, 0, 5319, 5319),
         16#CF#           =>  --  14CF
          (0, 0, 5320, 5320),
         16#D0#           =>  --  14D0
          (0, 0, 5321, 5321),
         16#D1#           =>  --  14D1
          (0, 0, 5322, 5322),
         16#D2#           =>  --  14D2
          (0, 0, 5323, 5323),
         16#D3#           =>  --  14D3
          (0, 0, 5324, 5324),
         16#D4#           =>  --  14D4
          (0, 0, 5325, 5325),
         16#D5#           =>  --  14D5
          (0, 0, 5326, 5326),
         16#D6#           =>  --  14D6
          (0, 0, 5327, 5327),
         16#D7#           =>  --  14D7
          (0, 0, 5328, 5328),
         16#D8#           =>  --  14D8
          (0, 0, 5329, 5329),
         16#D9#           =>  --  14D9
          (0, 0, 5330, 5330),
         16#DA#           =>  --  14DA
          (0, 0, 5331, 5331),
         16#DB#           =>  --  14DB
          (0, 0, 5332, 5332),
         16#DC#           =>  --  14DC
          (0, 0, 5333, 5333),
         16#DD#           =>  --  14DD
          (0, 0, 5334, 5334),
         16#DE#           =>  --  14DE
          (0, 0, 5335, 5335),
         16#DF#           =>  --  14DF
          (0, 0, 5336, 5336),
         16#E0#           =>  --  14E0
          (0, 0, 5337, 5337),
         16#E1#           =>  --  14E1
          (0, 0, 5338, 5338),
         16#E2#           =>  --  14E2
          (0, 0, 5339, 5339),
         16#E3#           =>  --  14E3
          (0, 0, 5340, 5340),
         16#E4#           =>  --  14E4
          (0, 0, 5341, 5341),
         16#E5#           =>  --  14E5
          (0, 0, 5342, 5342),
         16#E6#           =>  --  14E6
          (0, 0, 5343, 5343),
         16#E7#           =>  --  14E7
          (0, 0, 5344, 5344),
         16#E8#           =>  --  14E8
          (0, 0, 5345, 5345),
         16#E9#           =>  --  14E9
          (0, 0, 5346, 5346),
         16#EA#           =>  --  14EA
          (0, 0, 5347, 5347),
         16#EB#           =>  --  14EB
          (0, 0, 5348, 5348),
         16#EC#           =>  --  14EC
          (0, 0, 5349, 5349),
         16#ED#           =>  --  14ED
          (0, 0, 5350, 5350),
         16#EE#           =>  --  14EE
          (0, 0, 5351, 5351),
         16#EF#           =>  --  14EF
          (0, 0, 5352, 5352),
         16#F0#           =>  --  14F0
          (0, 0, 5353, 5353),
         16#F1#           =>  --  14F1
          (0, 0, 5354, 5354),
         16#F2#           =>  --  14F2
          (0, 0, 5355, 5355),
         16#F3#           =>  --  14F3
          (0, 0, 5356, 5356),
         16#F4#           =>  --  14F4
          (0, 0, 5357, 5357),
         16#F5#           =>  --  14F5
          (0, 0, 5358, 5358),
         16#F6#           =>  --  14F6
          (0, 0, 5359, 5359),
         16#F7#           =>  --  14F7
          (0, 0, 5360, 5360),
         16#F8#           =>  --  14F8
          (0, 0, 5361, 5361),
         16#F9#           =>  --  14F9
          (0, 0, 5362, 5362),
         16#FA#           =>  --  14FA
          (0, 0, 5363, 5363),
         16#FB#           =>  --  14FB
          (0, 0, 5364, 5364),
         16#FC#           =>  --  14FC
          (0, 0, 5365, 5365),
         16#FD#           =>  --  14FD
          (0, 0, 5366, 5366),
         16#FE#           =>  --  14FE
          (0, 0, 5367, 5367),
         16#FF#           =>  --  14FF
          (0, 0, 5368, 5368),
         others           =>
          (0, 0, 0, 0));

   Group_0015 : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  1500
          (0, 0, 5369, 5369),
         16#01#           =>  --  1501
          (0, 0, 5370, 5370),
         16#02#           =>  --  1502
          (0, 0, 5371, 5371),
         16#03#           =>  --  1503
          (0, 0, 5372, 5372),
         16#04#           =>  --  1504
          (0, 0, 5373, 5373),
         16#05#           =>  --  1505
          (0, 0, 5374, 5374),
         16#06#           =>  --  1506
          (0, 0, 5375, 5375),
         16#07#           =>  --  1507
          (0, 0, 5376, 5376),
         16#08#           =>  --  1508
          (0, 0, 5377, 5377),
         16#09#           =>  --  1509
          (0, 0, 5378, 5378),
         16#0A#           =>  --  150A
          (0, 0, 5379, 5379),
         16#0B#           =>  --  150B
          (0, 0, 5380, 5380),
         16#0C#           =>  --  150C
          (0, 0, 5381, 5381),
         16#0D#           =>  --  150D
          (0, 0, 5382, 5382),
         16#0E#           =>  --  150E
          (0, 0, 5383, 5383),
         16#0F#           =>  --  150F
          (0, 0, 5384, 5384),
         16#10#           =>  --  1510
          (0, 0, 5385, 5385),
         16#11#           =>  --  1511
          (0, 0, 5386, 5386),
         16#12#           =>  --  1512
          (0, 0, 5387, 5387),
         16#13#           =>  --  1513
          (0, 0, 5388, 5388),
         16#14#           =>  --  1514
          (0, 0, 5389, 5389),
         16#15#           =>  --  1515
          (0, 0, 5390, 5390),
         16#16#           =>  --  1516
          (0, 0, 5391, 5391),
         16#17#           =>  --  1517
          (0, 0, 5392, 5392),
         16#18#           =>  --  1518
          (0, 0, 5393, 5393),
         16#19#           =>  --  1519
          (0, 0, 5394, 5394),
         16#1A#           =>  --  151A
          (0, 0, 5395, 5395),
         16#1B#           =>  --  151B
          (0, 0, 5396, 5396),
         16#1C#           =>  --  151C
          (0, 0, 5397, 5397),
         16#1D#           =>  --  151D
          (0, 0, 5398, 5398),
         16#1E#           =>  --  151E
          (0, 0, 5399, 5399),
         16#1F#           =>  --  151F
          (0, 0, 5400, 5400),
         16#20#           =>  --  1520
          (0, 0, 5401, 5401),
         16#21#           =>  --  1521
          (0, 0, 5402, 5402),
         16#22#           =>  --  1522
          (0, 0, 5403, 5403),
         16#23#           =>  --  1523
          (0, 0, 5404, 5404),
         16#24#           =>  --  1524
          (0, 0, 5405, 5405),
         16#25#           =>  --  1525
          (0, 0, 5406, 5406),
         16#26#           =>  --  1526
          (0, 0, 5407, 5407),
         16#27#           =>  --  1527
          (0, 0, 5408, 5408),
         16#28#           =>  --  1528
          (0, 0, 5409, 5409),
         16#29#           =>  --  1529
          (0, 0, 5410, 5410),
         16#2A#           =>  --  152A
          (0, 0, 5411, 5411),
         16#2B#           =>  --  152B
          (0, 0, 5412, 5412),
         16#2C#           =>  --  152C
          (0, 0, 5413, 5413),
         16#2D#           =>  --  152D
          (0, 0, 5414, 5414),
         16#2E#           =>  --  152E
          (0, 0, 5415, 5415),
         16#2F#           =>  --  152F
          (0, 0, 5416, 5416),
         16#30#           =>  --  1530
          (0, 0, 5417, 5417),
         16#31#           =>  --  1531
          (0, 0, 5418, 5418),
         16#32#           =>  --  1532
          (0, 0, 5419, 5419),
         16#33#           =>  --  1533
          (0, 0, 5420, 5420),
         16#34#           =>  --  1534
          (0, 0, 5421, 5421),
         16#35#           =>  --  1535
          (0, 0, 5422, 5422),
         16#36#           =>  --  1536
          (0, 0, 5423, 5423),
         16#37#           =>  --  1537
          (0, 0, 5424, 5424),
         16#38#           =>  --  1538
          (0, 0, 5425, 5425),
         16#39#           =>  --  1539
          (0, 0, 5426, 5426),
         16#3A#           =>  --  153A
          (0, 0, 5427, 5427),
         16#3B#           =>  --  153B
          (0, 0, 5428, 5428),
         16#3C#           =>  --  153C
          (0, 0, 5429, 5429),
         16#3D#           =>  --  153D
          (0, 0, 5430, 5430),
         16#3E#           =>  --  153E
          (0, 0, 5431, 5431),
         16#3F#           =>  --  153F
          (0, 0, 5432, 5432),
         16#40#           =>  --  1540
          (0, 0, 5433, 5433),
         16#41#           =>  --  1541
          (0, 0, 5434, 5434),
         16#42#           =>  --  1542
          (0, 0, 5435, 5435),
         16#43#           =>  --  1543
          (0, 0, 5436, 5436),
         16#44#           =>  --  1544
          (0, 0, 5437, 5437),
         16#45#           =>  --  1545
          (0, 0, 5438, 5438),
         16#46#           =>  --  1546
          (0, 0, 5439, 5439),
         16#47#           =>  --  1547
          (0, 0, 5440, 5440),
         16#48#           =>  --  1548
          (0, 0, 5441, 5441),
         16#49#           =>  --  1549
          (0, 0, 5442, 5442),
         16#4A#           =>  --  154A
          (0, 0, 5443, 5443),
         16#4B#           =>  --  154B
          (0, 0, 5444, 5444),
         16#4C#           =>  --  154C
          (0, 0, 5445, 5445),
         16#4D#           =>  --  154D
          (0, 0, 5446, 5446),
         16#4E#           =>  --  154E
          (0, 0, 5447, 5447),
         16#4F#           =>  --  154F
          (0, 0, 5448, 5448),
         16#50#           =>  --  1550
          (0, 0, 5449, 5449),
         16#51#           =>  --  1551
          (0, 0, 5450, 5450),
         16#52#           =>  --  1552
          (0, 0, 5451, 5451),
         16#53#           =>  --  1553
          (0, 0, 5452, 5452),
         16#54#           =>  --  1554
          (0, 0, 5453, 5453),
         16#55#           =>  --  1555
          (0, 0, 5454, 5454),
         16#56#           =>  --  1556
          (0, 0, 5455, 5455),
         16#57#           =>  --  1557
          (0, 0, 5456, 5456),
         16#58#           =>  --  1558
          (0, 0, 5457, 5457),
         16#59#           =>  --  1559
          (0, 0, 5458, 5458),
         16#5A#           =>  --  155A
          (0, 0, 5459, 5459),
         16#5B#           =>  --  155B
          (0, 0, 5460, 5460),
         16#5C#           =>  --  155C
          (0, 0, 5461, 5461),
         16#5D#           =>  --  155D
          (0, 0, 5462, 5462),
         16#5E#           =>  --  155E
          (0, 0, 5463, 5463),
         16#5F#           =>  --  155F
          (0, 0, 5464, 5464),
         16#60#           =>  --  1560
          (0, 0, 5465, 5465),
         16#61#           =>  --  1561
          (0, 0, 5466, 5466),
         16#62#           =>  --  1562
          (0, 0, 5467, 5467),
         16#63#           =>  --  1563
          (0, 0, 5468, 5468),
         16#64#           =>  --  1564
          (0, 0, 5469, 5469),
         16#65#           =>  --  1565
          (0, 0, 5470, 5470),
         16#66#           =>  --  1566
          (0, 0, 5471, 5471),
         16#67#           =>  --  1567
          (0, 0, 5472, 5472),
         16#68#           =>  --  1568
          (0, 0, 5473, 5473),
         16#69#           =>  --  1569
          (0, 0, 5474, 5474),
         16#6A#           =>  --  156A
          (0, 0, 5475, 5475),
         16#6B#           =>  --  156B
          (0, 0, 5476, 5476),
         16#6C#           =>  --  156C
          (0, 0, 5477, 5477),
         16#6D#           =>  --  156D
          (0, 0, 5478, 5478),
         16#6E#           =>  --  156E
          (0, 0, 5479, 5479),
         16#6F#           =>  --  156F
          (0, 0, 5480, 5480),
         16#70#           =>  --  1570
          (0, 0, 5481, 5481),
         16#71#           =>  --  1571
          (0, 0, 5482, 5482),
         16#72#           =>  --  1572
          (0, 0, 5483, 5483),
         16#73#           =>  --  1573
          (0, 0, 5484, 5484),
         16#74#           =>  --  1574
          (0, 0, 5485, 5485),
         16#75#           =>  --  1575
          (0, 0, 5486, 5486),
         16#76#           =>  --  1576
          (0, 0, 5487, 5487),
         16#77#           =>  --  1577
          (0, 0, 5488, 5488),
         16#78#           =>  --  1578
          (0, 0, 5489, 5489),
         16#79#           =>  --  1579
          (0, 0, 5490, 5490),
         16#7A#           =>  --  157A
          (0, 0, 5491, 5491),
         16#7B#           =>  --  157B
          (0, 0, 5492, 5492),
         16#7C#           =>  --  157C
          (0, 0, 5493, 5493),
         16#7D#           =>  --  157D
          (0, 0, 5494, 5494),
         16#7E#           =>  --  157E
          (0, 0, 5495, 5495),
         16#7F#           =>  --  157F
          (0, 0, 5496, 5496),
         16#80#           =>  --  1580
          (0, 0, 5497, 5497),
         16#81#           =>  --  1581
          (0, 0, 5498, 5498),
         16#82#           =>  --  1582
          (0, 0, 5499, 5499),
         16#83#           =>  --  1583
          (0, 0, 5500, 5500),
         16#84#           =>  --  1584
          (0, 0, 5501, 5501),
         16#85#           =>  --  1585
          (0, 0, 5502, 5502),
         16#86#           =>  --  1586
          (0, 0, 5503, 5503),
         16#87#           =>  --  1587
          (0, 0, 5504, 5504),
         16#88#           =>  --  1588
          (0, 0, 5505, 5505),
         16#89#           =>  --  1589
          (0, 0, 5506, 5506),
         16#8A#           =>  --  158A
          (0, 0, 5507, 5507),
         16#8B#           =>  --  158B
          (0, 0, 5508, 5508),
         16#8C#           =>  --  158C
          (0, 0, 5509, 5509),
         16#8D#           =>  --  158D
          (0, 0, 5510, 5510),
         16#8E#           =>  --  158E
          (0, 0, 5511, 5511),
         16#8F#           =>  --  158F
          (0, 0, 5512, 5512),
         16#90#           =>  --  1590
          (0, 0, 5513, 5513),
         16#91#           =>  --  1591
          (0, 0, 5514, 5514),
         16#92#           =>  --  1592
          (0, 0, 5515, 5515),
         16#93#           =>  --  1593
          (0, 0, 5516, 5516),
         16#94#           =>  --  1594
          (0, 0, 5517, 5517),
         16#95#           =>  --  1595
          (0, 0, 5518, 5518),
         16#96#           =>  --  1596
          (0, 0, 5519, 5519),
         16#97#           =>  --  1597
          (0, 0, 5520, 5520),
         16#98#           =>  --  1598
          (0, 0, 5521, 5521),
         16#99#           =>  --  1599
          (0, 0, 5522, 5522),
         16#9A#           =>  --  159A
          (0, 0, 5523, 5523),
         16#9B#           =>  --  159B
          (0, 0, 5524, 5524),
         16#9C#           =>  --  159C
          (0, 0, 5525, 5525),
         16#9D#           =>  --  159D
          (0, 0, 5526, 5526),
         16#9E#           =>  --  159E
          (0, 0, 5527, 5527),
         16#9F#           =>  --  159F
          (0, 0, 5528, 5528),
         16#A0#           =>  --  15A0
          (0, 0, 5529, 5529),
         16#A1#           =>  --  15A1
          (0, 0, 5530, 5530),
         16#A2#           =>  --  15A2
          (0, 0, 5531, 5531),
         16#A3#           =>  --  15A3
          (0, 0, 5532, 5532),
         16#A4#           =>  --  15A4
          (0, 0, 5533, 5533),
         16#A5#           =>  --  15A5
          (0, 0, 5534, 5534),
         16#A6#           =>  --  15A6
          (0, 0, 5535, 5535),
         16#A7#           =>  --  15A7
          (0, 0, 5536, 5536),
         16#A8#           =>  --  15A8
          (0, 0, 5537, 5537),
         16#A9#           =>  --  15A9
          (0, 0, 5538, 5538),
         16#AA#           =>  --  15AA
          (0, 0, 5539, 5539),
         16#AB#           =>  --  15AB
          (0, 0, 5540, 5540),
         16#AC#           =>  --  15AC
          (0, 0, 5541, 5541),
         16#AD#           =>  --  15AD
          (0, 0, 5542, 5542),
         16#AE#           =>  --  15AE
          (0, 0, 5543, 5543),
         16#AF#           =>  --  15AF
          (0, 0, 5544, 5544),
         16#B0#           =>  --  15B0
          (0, 0, 5545, 5545),
         16#B1#           =>  --  15B1
          (0, 0, 5546, 5546),
         16#B2#           =>  --  15B2
          (0, 0, 5547, 5547),
         16#B3#           =>  --  15B3
          (0, 0, 5548, 5548),
         16#B4#           =>  --  15B4
          (0, 0, 5549, 5549),
         16#B5#           =>  --  15B5
          (0, 0, 5550, 5550),
         16#B6#           =>  --  15B6
          (0, 0, 5551, 5551),
         16#B7#           =>  --  15B7
          (0, 0, 5552, 5552),
         16#B8#           =>  --  15B8
          (0, 0, 5553, 5553),
         16#B9#           =>  --  15B9
          (0, 0, 5554, 5554),
         16#BA#           =>  --  15BA
          (0, 0, 5555, 5555),
         16#BB#           =>  --  15BB
          (0, 0, 5556, 5556),
         16#BC#           =>  --  15BC
          (0, 0, 5557, 5557),
         16#BD#           =>  --  15BD
          (0, 0, 5558, 5558),
         16#BE#           =>  --  15BE
          (0, 0, 5559, 5559),
         16#BF#           =>  --  15BF
          (0, 0, 5560, 5560),
         16#C0#           =>  --  15C0
          (0, 0, 5561, 5561),
         16#C1#           =>  --  15C1
          (0, 0, 5562, 5562),
         16#C2#           =>  --  15C2
          (0, 0, 5563, 5563),
         16#C3#           =>  --  15C3
          (0, 0, 5564, 5564),
         16#C4#           =>  --  15C4
          (0, 0, 5565, 5565),
         16#C5#           =>  --  15C5
          (0, 0, 5566, 5566),
         16#C6#           =>  --  15C6
          (0, 0, 5567, 5567),
         16#C7#           =>  --  15C7
          (0, 0, 5568, 5568),
         16#C8#           =>  --  15C8
          (0, 0, 5569, 5569),
         16#C9#           =>  --  15C9
          (0, 0, 5570, 5570),
         16#CA#           =>  --  15CA
          (0, 0, 5571, 5571),
         16#CB#           =>  --  15CB
          (0, 0, 5572, 5572),
         16#CC#           =>  --  15CC
          (0, 0, 5573, 5573),
         16#CD#           =>  --  15CD
          (0, 0, 5574, 5574),
         16#CE#           =>  --  15CE
          (0, 0, 5575, 5575),
         16#CF#           =>  --  15CF
          (0, 0, 5576, 5576),
         16#D0#           =>  --  15D0
          (0, 0, 5577, 5577),
         16#D1#           =>  --  15D1
          (0, 0, 5578, 5578),
         16#D2#           =>  --  15D2
          (0, 0, 5579, 5579),
         16#D3#           =>  --  15D3
          (0, 0, 5580, 5580),
         16#D4#           =>  --  15D4
          (0, 0, 5581, 5581),
         16#D5#           =>  --  15D5
          (0, 0, 5582, 5582),
         16#D6#           =>  --  15D6
          (0, 0, 5583, 5583),
         16#D7#           =>  --  15D7
          (0, 0, 5584, 5584),
         16#D8#           =>  --  15D8
          (0, 0, 5585, 5585),
         16#D9#           =>  --  15D9
          (0, 0, 5586, 5586),
         16#DA#           =>  --  15DA
          (0, 0, 5587, 5587),
         16#DB#           =>  --  15DB
          (0, 0, 5588, 5588),
         16#DC#           =>  --  15DC
          (0, 0, 5589, 5589),
         16#DD#           =>  --  15DD
          (0, 0, 5590, 5590),
         16#DE#           =>  --  15DE
          (0, 0, 5591, 5591),
         16#DF#           =>  --  15DF
          (0, 0, 5592, 5592),
         16#E0#           =>  --  15E0
          (0, 0, 5593, 5593),
         16#E1#           =>  --  15E1
          (0, 0, 5594, 5594),
         16#E2#           =>  --  15E2
          (0, 0, 5595, 5595),
         16#E3#           =>  --  15E3
          (0, 0, 5596, 5596),
         16#E4#           =>  --  15E4
          (0, 0, 5597, 5597),
         16#E5#           =>  --  15E5
          (0, 0, 5598, 5598),
         16#E6#           =>  --  15E6
          (0, 0, 5599, 5599),
         16#E7#           =>  --  15E7
          (0, 0, 5600, 5600),
         16#E8#           =>  --  15E8
          (0, 0, 5601, 5601),
         16#E9#           =>  --  15E9
          (0, 0, 5602, 5602),
         16#EA#           =>  --  15EA
          (0, 0, 5603, 5603),
         16#EB#           =>  --  15EB
          (0, 0, 5604, 5604),
         16#EC#           =>  --  15EC
          (0, 0, 5605, 5605),
         16#ED#           =>  --  15ED
          (0, 0, 5606, 5606),
         16#EE#           =>  --  15EE
          (0, 0, 5607, 5607),
         16#EF#           =>  --  15EF
          (0, 0, 5608, 5608),
         16#F0#           =>  --  15F0
          (0, 0, 5609, 5609),
         16#F1#           =>  --  15F1
          (0, 0, 5610, 5610),
         16#F2#           =>  --  15F2
          (0, 0, 5611, 5611),
         16#F3#           =>  --  15F3
          (0, 0, 5612, 5612),
         16#F4#           =>  --  15F4
          (0, 0, 5613, 5613),
         16#F5#           =>  --  15F5
          (0, 0, 5614, 5614),
         16#F6#           =>  --  15F6
          (0, 0, 5615, 5615),
         16#F7#           =>  --  15F7
          (0, 0, 5616, 5616),
         16#F8#           =>  --  15F8
          (0, 0, 5617, 5617),
         16#F9#           =>  --  15F9
          (0, 0, 5618, 5618),
         16#FA#           =>  --  15FA
          (0, 0, 5619, 5619),
         16#FB#           =>  --  15FB
          (0, 0, 5620, 5620),
         16#FC#           =>  --  15FC
          (0, 0, 5621, 5621),
         16#FD#           =>  --  15FD
          (0, 0, 5622, 5622),
         16#FE#           =>  --  15FE
          (0, 0, 5623, 5623),
         16#FF#           =>  --  15FF
          (0, 0, 5624, 5624),
         others           =>
          (0, 0, 0, 0));

   Group_0016 : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  1600
          (0, 0, 5625, 5625),
         16#01#           =>  --  1601
          (0, 0, 5626, 5626),
         16#02#           =>  --  1602
          (0, 0, 5627, 5627),
         16#03#           =>  --  1603
          (0, 0, 5628, 5628),
         16#04#           =>  --  1604
          (0, 0, 5629, 5629),
         16#05#           =>  --  1605
          (0, 0, 5630, 5630),
         16#06#           =>  --  1606
          (0, 0, 5631, 5631),
         16#07#           =>  --  1607
          (0, 0, 5632, 5632),
         16#08#           =>  --  1608
          (0, 0, 5633, 5633),
         16#09#           =>  --  1609
          (0, 0, 5634, 5634),
         16#0A#           =>  --  160A
          (0, 0, 5635, 5635),
         16#0B#           =>  --  160B
          (0, 0, 5636, 5636),
         16#0C#           =>  --  160C
          (0, 0, 5637, 5637),
         16#0D#           =>  --  160D
          (0, 0, 5638, 5638),
         16#0E#           =>  --  160E
          (0, 0, 5639, 5639),
         16#0F#           =>  --  160F
          (0, 0, 5640, 5640),
         16#10#           =>  --  1610
          (0, 0, 5641, 5641),
         16#11#           =>  --  1611
          (0, 0, 5642, 5642),
         16#12#           =>  --  1612
          (0, 0, 5643, 5643),
         16#13#           =>  --  1613
          (0, 0, 5644, 5644),
         16#14#           =>  --  1614
          (0, 0, 5645, 5645),
         16#15#           =>  --  1615
          (0, 0, 5646, 5646),
         16#16#           =>  --  1616
          (0, 0, 5647, 5647),
         16#17#           =>  --  1617
          (0, 0, 5648, 5648),
         16#18#           =>  --  1618
          (0, 0, 5649, 5649),
         16#19#           =>  --  1619
          (0, 0, 5650, 5650),
         16#1A#           =>  --  161A
          (0, 0, 5651, 5651),
         16#1B#           =>  --  161B
          (0, 0, 5652, 5652),
         16#1C#           =>  --  161C
          (0, 0, 5653, 5653),
         16#1D#           =>  --  161D
          (0, 0, 5654, 5654),
         16#1E#           =>  --  161E
          (0, 0, 5655, 5655),
         16#1F#           =>  --  161F
          (0, 0, 5656, 5656),
         16#20#           =>  --  1620
          (0, 0, 5657, 5657),
         16#21#           =>  --  1621
          (0, 0, 5658, 5658),
         16#22#           =>  --  1622
          (0, 0, 5659, 5659),
         16#23#           =>  --  1623
          (0, 0, 5660, 5660),
         16#24#           =>  --  1624
          (0, 0, 5661, 5661),
         16#25#           =>  --  1625
          (0, 0, 5662, 5662),
         16#26#           =>  --  1626
          (0, 0, 5663, 5663),
         16#27#           =>  --  1627
          (0, 0, 5664, 5664),
         16#28#           =>  --  1628
          (0, 0, 5665, 5665),
         16#29#           =>  --  1629
          (0, 0, 5666, 5666),
         16#2A#           =>  --  162A
          (0, 0, 5667, 5667),
         16#2B#           =>  --  162B
          (0, 0, 5668, 5668),
         16#2C#           =>  --  162C
          (0, 0, 5669, 5669),
         16#2D#           =>  --  162D
          (0, 0, 5670, 5670),
         16#2E#           =>  --  162E
          (0, 0, 5671, 5671),
         16#2F#           =>  --  162F
          (0, 0, 5672, 5672),
         16#30#           =>  --  1630
          (0, 0, 5673, 5673),
         16#31#           =>  --  1631
          (0, 0, 5674, 5674),
         16#32#           =>  --  1632
          (0, 0, 5675, 5675),
         16#33#           =>  --  1633
          (0, 0, 5676, 5676),
         16#34#           =>  --  1634
          (0, 0, 5677, 5677),
         16#35#           =>  --  1635
          (0, 0, 5678, 5678),
         16#36#           =>  --  1636
          (0, 0, 5679, 5679),
         16#37#           =>  --  1637
          (0, 0, 5680, 5680),
         16#38#           =>  --  1638
          (0, 0, 5681, 5681),
         16#39#           =>  --  1639
          (0, 0, 5682, 5682),
         16#3A#           =>  --  163A
          (0, 0, 5683, 5683),
         16#3B#           =>  --  163B
          (0, 0, 5684, 5684),
         16#3C#           =>  --  163C
          (0, 0, 5685, 5685),
         16#3D#           =>  --  163D
          (0, 0, 5686, 5686),
         16#3E#           =>  --  163E
          (0, 0, 5687, 5687),
         16#3F#           =>  --  163F
          (0, 0, 5688, 5688),
         16#40#           =>  --  1640
          (0, 0, 5689, 5689),
         16#41#           =>  --  1641
          (0, 0, 5690, 5690),
         16#42#           =>  --  1642
          (0, 0, 5691, 5691),
         16#43#           =>  --  1643
          (0, 0, 5692, 5692),
         16#44#           =>  --  1644
          (0, 0, 5693, 5693),
         16#45#           =>  --  1645
          (0, 0, 5694, 5694),
         16#46#           =>  --  1646
          (0, 0, 5695, 5695),
         16#47#           =>  --  1647
          (0, 0, 5696, 5696),
         16#48#           =>  --  1648
          (0, 0, 5697, 5697),
         16#49#           =>  --  1649
          (0, 0, 5698, 5698),
         16#4A#           =>  --  164A
          (0, 0, 5699, 5699),
         16#4B#           =>  --  164B
          (0, 0, 5700, 5700),
         16#4C#           =>  --  164C
          (0, 0, 5701, 5701),
         16#4D#           =>  --  164D
          (0, 0, 5702, 5702),
         16#4E#           =>  --  164E
          (0, 0, 5703, 5703),
         16#4F#           =>  --  164F
          (0, 0, 5704, 5704),
         16#50#           =>  --  1650
          (0, 0, 5705, 5705),
         16#51#           =>  --  1651
          (0, 0, 5706, 5706),
         16#52#           =>  --  1652
          (0, 0, 5707, 5707),
         16#53#           =>  --  1653
          (0, 0, 5708, 5708),
         16#54#           =>  --  1654
          (0, 0, 5709, 5709),
         16#55#           =>  --  1655
          (0, 0, 5710, 5710),
         16#56#           =>  --  1656
          (0, 0, 5711, 5711),
         16#57#           =>  --  1657
          (0, 0, 5712, 5712),
         16#58#           =>  --  1658
          (0, 0, 5713, 5713),
         16#59#           =>  --  1659
          (0, 0, 5714, 5714),
         16#5A#           =>  --  165A
          (0, 0, 5715, 5715),
         16#5B#           =>  --  165B
          (0, 0, 5716, 5716),
         16#5C#           =>  --  165C
          (0, 0, 5717, 5717),
         16#5D#           =>  --  165D
          (0, 0, 5718, 5718),
         16#5E#           =>  --  165E
          (0, 0, 5719, 5719),
         16#5F#           =>  --  165F
          (0, 0, 5720, 5720),
         16#60#           =>  --  1660
          (0, 0, 5721, 5721),
         16#61#           =>  --  1661
          (0, 0, 5722, 5722),
         16#62#           =>  --  1662
          (0, 0, 5723, 5723),
         16#63#           =>  --  1663
          (0, 0, 5724, 5724),
         16#64#           =>  --  1664
          (0, 0, 5725, 5725),
         16#65#           =>  --  1665
          (0, 0, 5726, 5726),
         16#66#           =>  --  1666
          (0, 0, 5727, 5727),
         16#67#           =>  --  1667
          (0, 0, 5728, 5728),
         16#68#           =>  --  1668
          (0, 0, 5729, 5729),
         16#69#           =>  --  1669
          (0, 0, 5730, 5730),
         16#6A#           =>  --  166A
          (0, 0, 5731, 5731),
         16#6B#           =>  --  166B
          (0, 0, 5732, 5732),
         16#6C#           =>  --  166C
          (0, 0, 5733, 5733),
         16#6D#           =>  --  166D
          (0, 0, 5734, 5734),
         16#6E#           =>  --  166E
          (0, 0, 5735, 5735),
         16#6F#           =>  --  166F
          (0, 0, 5736, 5736),
         16#70#           =>  --  1670
          (0, 0, 5737, 5737),
         16#71#           =>  --  1671
          (0, 0, 5738, 5738),
         16#72#           =>  --  1672
          (0, 0, 5739, 5739),
         16#73#           =>  --  1673
          (0, 0, 5740, 5740),
         16#74#           =>  --  1674
          (0, 0, 5741, 5741),
         16#75#           =>  --  1675
          (0, 0, 5742, 5742),
         16#76#           =>  --  1676
          (0, 0, 5743, 5743),
         16#77#           =>  --  1677
          (0, 0, 5744, 5744),
         16#78#           =>  --  1678
          (0, 0, 5745, 5745),
         16#79#           =>  --  1679
          (0, 0, 5746, 5746),
         16#7A#           =>  --  167A
          (0, 0, 5747, 5747),
         16#7B#           =>  --  167B
          (0, 0, 5748, 5748),
         16#7C#           =>  --  167C
          (0, 0, 5749, 5749),
         16#7D#           =>  --  167D
          (0, 0, 5750, 5750),
         16#7E#           =>  --  167E
          (0, 0, 5751, 5751),
         16#7F#           =>  --  167F
          (0, 0, 5752, 5752),
         16#80#           =>  --  1680
          (0, 0, 5753, 5753),
         16#81#           =>  --  1681
          (0, 0, 5754, 5754),
         16#82#           =>  --  1682
          (0, 0, 5755, 5755),
         16#83#           =>  --  1683
          (0, 0, 5756, 5756),
         16#84#           =>  --  1684
          (0, 0, 5757, 5757),
         16#85#           =>  --  1685
          (0, 0, 5758, 5758),
         16#86#           =>  --  1686
          (0, 0, 5759, 5759),
         16#87#           =>  --  1687
          (0, 0, 5760, 5760),
         16#88#           =>  --  1688
          (0, 0, 5761, 5761),
         16#89#           =>  --  1689
          (0, 0, 5762, 5762),
         16#8A#           =>  --  168A
          (0, 0, 5763, 5763),
         16#8B#           =>  --  168B
          (0, 0, 5764, 5764),
         16#8C#           =>  --  168C
          (0, 0, 5765, 5765),
         16#8D#           =>  --  168D
          (0, 0, 5766, 5766),
         16#8E#           =>  --  168E
          (0, 0, 5767, 5767),
         16#8F#           =>  --  168F
          (0, 0, 5768, 5768),
         16#90#           =>  --  1690
          (0, 0, 5769, 5769),
         16#91#           =>  --  1691
          (0, 0, 5770, 5770),
         16#92#           =>  --  1692
          (0, 0, 5771, 5771),
         16#93#           =>  --  1693
          (0, 0, 5772, 5772),
         16#94#           =>  --  1694
          (0, 0, 5773, 5773),
         16#95#           =>  --  1695
          (0, 0, 5774, 5774),
         16#96#           =>  --  1696
          (0, 0, 5775, 5775),
         16#97#           =>  --  1697
          (0, 0, 5776, 5776),
         16#98#           =>  --  1698
          (0, 0, 5777, 5777),
         16#99#           =>  --  1699
          (0, 0, 5778, 5778),
         16#9A#           =>  --  169A
          (0, 0, 5779, 5779),
         16#9B#           =>  --  169B
          (0, 0, 5780, 5780),
         16#9C#           =>  --  169C
          (0, 0, 5781, 5781),
         16#A0#           =>  --  16A0
          (0, 0, 5782, 5782),
         16#A1#           =>  --  16A1
          (0, 0, 5783, 5784),
         16#A2#           =>  --  16A2
          (0, 0, 5785, 5785),
         16#A3#           =>  --  16A3
          (0, 0, 5786, 5786),
         16#A4#           =>  --  16A4
          (0, 0, 5787, 5788),
         16#A5#           =>  --  16A5
          (0, 0, 5789, 5790),
         16#A6#           =>  --  16A6
          (0, 0, 5791, 5791),
         16#A7#           =>  --  16A7
          (0, 0, 5792, 5793),
         16#A8#           =>  --  16A8
          (0, 0, 5794, 5794),
         16#A9#           =>  --  16A9
          (0, 0, 5795, 5796),
         16#AA#           =>  --  16AA
          (0, 0, 5797, 5797),
         16#AB#           =>  --  16AB
          (0, 0, 5798, 5798),
         16#AC#           =>  --  16AC
          (0, 0, 5799, 5800),
         16#AD#           =>  --  16AD
          (0, 0, 5801, 5802),
         16#AE#           =>  --  16AE
          (0, 0, 5803, 5804),
         16#AF#           =>  --  16AF
          (0, 0, 5805, 5805),
         16#B0#           =>  --  16B0
          (0, 0, 5806, 5806),
         16#B1#           =>  --  16B1
          (0, 0, 5807, 5807),
         16#B2#           =>  --  16B2
          (0, 0, 5808, 5808),
         16#B3#           =>  --  16B3
          (0, 0, 5809, 5810),
         16#B4#           =>  --  16B4
          (0, 0, 5811, 5812),
         16#B5#           =>  --  16B5
          (0, 0, 5813, 5814),
         16#B6#           =>  --  16B6
          (0, 0, 5815, 5816),
         16#B7#           =>  --  16B7
          (0, 0, 5817, 5817),
         16#B8#           =>  --  16B8
          (0, 0, 5818, 5818),
         16#B9#           =>  --  16B9
          (0, 0, 5819, 5819),
         16#BA#           =>  --  16BA
          (0, 0, 5820, 5820),
         16#BB#           =>  --  16BB
          (0, 0, 5821, 5822),
         16#BC#           =>  --  16BC
          (0, 0, 5823, 5824),
         16#BD#           =>  --  16BD
          (0, 0, 5825, 5826),
         16#BE#           =>  --  16BE
          (0, 0, 5827, 5827),
         16#BF#           =>  --  16BF
          (0, 0, 5828, 5829),
         16#C0#           =>  --  16C0
          (0, 0, 5830, 5831),
         16#C1#           =>  --  16C1
          (0, 0, 5832, 5832),
         16#C2#           =>  --  16C2
          (0, 0, 5833, 5834),
         16#C3#           =>  --  16C3
          (0, 0, 5835, 5835),
         16#C4#           =>  --  16C4
          (0, 0, 5836, 5837),
         16#C5#           =>  --  16C5
          (0, 0, 5838, 5838),
         16#C6#           =>  --  16C6
          (0, 0, 5839, 5840),
         16#C7#           =>  --  16C7
          (0, 0, 5841, 5841),
         16#C8#           =>  --  16C8
          (0, 0, 5842, 5842),
         16#C9#           =>  --  16C9
          (0, 0, 5843, 5843),
         16#CA#           =>  --  16CA
          (0, 0, 5844, 5844),
         16#CB#           =>  --  16CB
          (0, 0, 5845, 5846),
         16#CC#           =>  --  16CC
          (0, 0, 5847, 5848),
         16#CD#           =>  --  16CD
          (0, 0, 5849, 5850),
         16#CE#           =>  --  16CE
          (0, 0, 5851, 5852),
         16#CF#           =>  --  16CF
          (0, 0, 5853, 5853),
         16#D0#           =>  --  16D0
          (0, 0, 5854, 5855),
         16#D1#           =>  --  16D1
          (0, 0, 5856, 5857),
         16#D2#           =>  --  16D2
          (0, 0, 5858, 5858),
         16#D3#           =>  --  16D3
          (0, 0, 5859, 5860),
         16#D4#           =>  --  16D4
          (0, 0, 5861, 5862),
         16#D5#           =>  --  16D5
          (0, 0, 5863, 5864),
         16#D6#           =>  --  16D6
          (0, 0, 5865, 5865),
         16#D7#           =>  --  16D7
          (0, 0, 5866, 5866),
         16#D8#           =>  --  16D8
          (0, 0, 5867, 5868),
         16#D9#           =>  --  16D9
          (0, 0, 5869, 5870),
         16#DA#           =>  --  16DA
          (0, 0, 5871, 5871),
         16#DB#           =>  --  16DB
          (0, 0, 5872, 5873),
         16#DC#           =>  --  16DC
          (0, 0, 5874, 5874),
         16#DD#           =>  --  16DD
          (0, 0, 5875, 5876),
         16#DE#           =>  --  16DE
          (0, 0, 5877, 5877),
         16#DF#           =>  --  16DF
          (0, 0, 5878, 5878),
         16#E0#           =>  --  16E0
          (0, 0, 5879, 5879),
         16#E1#           =>  --  16E1
          (0, 0, 5880, 5880),
         16#E2#           =>  --  16E2
          (0, 0, 5881, 5881),
         16#E3#           =>  --  16E3
          (0, 0, 5882, 5882),
         16#E4#           =>  --  16E4
          (0, 0, 5883, 5883),
         16#E5#           =>  --  16E5
          (0, 0, 5884, 5884),
         16#E6#           =>  --  16E6
          (0, 0, 5885, 5885),
         16#E7#           =>  --  16E7
          (0, 0, 5886, 5887),
         16#E8#           =>  --  16E8
          (0, 0, 5888, 5889),
         16#E9#           =>  --  16E9
          (0, 0, 5890, 5891),
         16#EA#           =>  --  16EA
          (0, 0, 5892, 5893),
         16#EB#           =>  --  16EB
          (0, 0, 5894, 5894),
         16#EC#           =>  --  16EC
          (0, 0, 5895, 5895),
         16#ED#           =>  --  16ED
          (0, 0, 5896, 5896),
         16#EE#           =>  --  16EE
          (0, 0, 5897, 5898),
         16#EF#           =>  --  16EF
          (0, 0, 5899, 5902),
         16#F0#           =>  --  16F0
          (0, 0, 5903, 5904),
         16#F1#           =>  --  16F1
          (0, 0, 5905, 5905),
         16#F2#           =>  --  16F2
          (0, 0, 5906, 5906),
         16#F3#           =>  --  16F3
          (0, 0, 5907, 5907),
         16#F4#           =>  --  16F4
          (0, 0, 5908, 5908),
         16#F5#           =>  --  16F5
          (0, 0, 5909, 5909),
         16#F6#           =>  --  16F6
          (0, 0, 5910, 5910),
         16#F7#           =>  --  16F7
          (0, 0, 5911, 5911),
         16#F8#           =>  --  16F8
          (0, 0, 5912, 5912),
         others           =>
          (0, 0, 0, 0));

   Group_0017 : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  1700
          (0, 0, 5913, 5913),
         16#01#           =>  --  1701
          (0, 0, 5914, 5914),
         16#02#           =>  --  1702
          (0, 0, 5915, 5915),
         16#03#           =>  --  1703
          (0, 0, 5916, 5916),
         16#04#           =>  --  1704
          (0, 0, 5917, 5917),
         16#05#           =>  --  1705
          (0, 0, 5918, 5918),
         16#06#           =>  --  1706
          (0, 0, 5919, 5919),
         16#07#           =>  --  1707
          (0, 0, 5920, 5920),
         16#08#           =>  --  1708
          (0, 0, 5921, 5921),
         16#09#           =>  --  1709
          (0, 0, 5922, 5922),
         16#0A#           =>  --  170A
          (0, 0, 5923, 5923),
         16#0B#           =>  --  170B
          (0, 0, 5924, 5924),
         16#0C#           =>  --  170C
          (0, 0, 5925, 5925),
         16#0E#           =>  --  170E
          (0, 0, 5926, 5926),
         16#0F#           =>  --  170F
          (0, 0, 5927, 5927),
         16#10#           =>  --  1710
          (0, 0, 5928, 5928),
         16#11#           =>  --  1711
          (0, 0, 5929, 5929),
         16#12#           =>  --  1712
          (0, 0, 5930, 5930),
         16#13#           =>  --  1713
          (0, 0, 5931, 5931),
         16#14#           =>  --  1714
          (0, 0, 5932, 5932),
         16#20#           =>  --  1720
          (0, 0, 5933, 5933),
         16#21#           =>  --  1721
          (0, 0, 5934, 5934),
         16#22#           =>  --  1722
          (0, 0, 5935, 5935),
         16#23#           =>  --  1723
          (0, 0, 5936, 5936),
         16#24#           =>  --  1724
          (0, 0, 5937, 5937),
         16#25#           =>  --  1725
          (0, 0, 5938, 5938),
         16#26#           =>  --  1726
          (0, 0, 5939, 5939),
         16#27#           =>  --  1727
          (0, 0, 5940, 5940),
         16#28#           =>  --  1728
          (0, 0, 5941, 5941),
         16#29#           =>  --  1729
          (0, 0, 5942, 5942),
         16#2A#           =>  --  172A
          (0, 0, 5943, 5943),
         16#2B#           =>  --  172B
          (0, 0, 5944, 5944),
         16#2C#           =>  --  172C
          (0, 0, 5945, 5945),
         16#2D#           =>  --  172D
          (0, 0, 5946, 5946),
         16#2E#           =>  --  172E
          (0, 0, 5947, 5947),
         16#2F#           =>  --  172F
          (0, 0, 5948, 5948),
         16#30#           =>  --  1730
          (0, 0, 5949, 5949),
         16#31#           =>  --  1731
          (0, 0, 5950, 5950),
         16#32#           =>  --  1732
          (0, 0, 5951, 5951),
         16#33#           =>  --  1733
          (0, 0, 5952, 5952),
         16#34#           =>  --  1734
          (0, 0, 5953, 5953),
         16#35#           =>  --  1735
          (0, 0, 5954, 5954),
         16#36#           =>  --  1736
          (0, 0, 5955, 5955),
         16#40#           =>  --  1740
          (0, 0, 5956, 5956),
         16#41#           =>  --  1741
          (0, 0, 5957, 5957),
         16#42#           =>  --  1742
          (0, 0, 5958, 5958),
         16#43#           =>  --  1743
          (0, 0, 5959, 5959),
         16#44#           =>  --  1744
          (0, 0, 5960, 5960),
         16#45#           =>  --  1745
          (0, 0, 5961, 5961),
         16#46#           =>  --  1746
          (0, 0, 5962, 5962),
         16#47#           =>  --  1747
          (0, 0, 5963, 5963),
         16#48#           =>  --  1748
          (0, 0, 5964, 5964),
         16#49#           =>  --  1749
          (0, 0, 5965, 5965),
         16#4A#           =>  --  174A
          (0, 0, 5966, 5966),
         16#4B#           =>  --  174B
          (0, 0, 5967, 5967),
         16#4C#           =>  --  174C
          (0, 0, 5968, 5968),
         16#4D#           =>  --  174D
          (0, 0, 5969, 5969),
         16#4E#           =>  --  174E
          (0, 0, 5970, 5970),
         16#4F#           =>  --  174F
          (0, 0, 5971, 5971),
         16#50#           =>  --  1750
          (0, 0, 5972, 5972),
         16#51#           =>  --  1751
          (0, 0, 5973, 5973),
         16#52#           =>  --  1752
          (0, 0, 5974, 5974),
         16#53#           =>  --  1753
          (0, 0, 5975, 5975),
         16#60#           =>  --  1760
          (0, 0, 5976, 5976),
         16#61#           =>  --  1761
          (0, 0, 5977, 5977),
         16#62#           =>  --  1762
          (0, 0, 5978, 5978),
         16#63#           =>  --  1763
          (0, 0, 5979, 5979),
         16#64#           =>  --  1764
          (0, 0, 5980, 5980),
         16#65#           =>  --  1765
          (0, 0, 5981, 5981),
         16#66#           =>  --  1766
          (0, 0, 5982, 5982),
         16#67#           =>  --  1767
          (0, 0, 5983, 5983),
         16#68#           =>  --  1768
          (0, 0, 5984, 5984),
         16#69#           =>  --  1769
          (0, 0, 5985, 5985),
         16#6A#           =>  --  176A
          (0, 0, 5986, 5986),
         16#6B#           =>  --  176B
          (0, 0, 5987, 5987),
         16#6C#           =>  --  176C
          (0, 0, 5988, 5988),
         16#6E#           =>  --  176E
          (0, 0, 5989, 5989),
         16#6F#           =>  --  176F
          (0, 0, 5990, 5990),
         16#70#           =>  --  1770
          (0, 0, 5991, 5991),
         16#72#           =>  --  1772
          (0, 0, 5992, 5992),
         16#73#           =>  --  1773
          (0, 0, 5993, 5993),
         16#80#           =>  --  1780
          (0, 0, 5994, 5994),
         16#81#           =>  --  1781
          (0, 0, 5995, 5995),
         16#82#           =>  --  1782
          (0, 0, 5996, 5996),
         16#83#           =>  --  1783
          (0, 0, 5997, 5997),
         16#84#           =>  --  1784
          (0, 0, 5998, 5998),
         16#85#           =>  --  1785
          (0, 0, 5999, 5999),
         16#86#           =>  --  1786
          (0, 0, 6000, 6000),
         16#87#           =>  --  1787
          (0, 0, 6001, 6001),
         16#88#           =>  --  1788
          (0, 0, 6002, 6002),
         16#89#           =>  --  1789
          (0, 0, 6003, 6003),
         16#8A#           =>  --  178A
          (0, 0, 6004, 6004),
         16#8B#           =>  --  178B
          (0, 0, 6005, 6005),
         16#8C#           =>  --  178C
          (0, 0, 6006, 6006),
         16#8D#           =>  --  178D
          (0, 0, 6007, 6007),
         16#8E#           =>  --  178E
          (0, 0, 6008, 6008),
         16#8F#           =>  --  178F
          (0, 0, 6009, 6009),
         16#90#           =>  --  1790
          (0, 0, 6010, 6010),
         16#91#           =>  --  1791
          (0, 0, 6011, 6011),
         16#92#           =>  --  1792
          (0, 0, 6012, 6012),
         16#93#           =>  --  1793
          (0, 0, 6013, 6013),
         16#94#           =>  --  1794
          (0, 0, 6014, 6014),
         16#95#           =>  --  1795
          (0, 0, 6015, 6015),
         16#96#           =>  --  1796
          (0, 0, 6016, 6016),
         16#97#           =>  --  1797
          (0, 0, 6017, 6017),
         16#98#           =>  --  1798
          (0, 0, 6018, 6018),
         16#99#           =>  --  1799
          (0, 0, 6019, 6019),
         16#9A#           =>  --  179A
          (0, 0, 6020, 6020),
         16#9B#           =>  --  179B
          (0, 0, 6021, 6021),
         16#9C#           =>  --  179C
          (0, 0, 6022, 6022),
         16#9D#           =>  --  179D
          (0, 0, 6023, 6023),
         16#9E#           =>  --  179E
          (0, 0, 6024, 6024),
         16#9F#           =>  --  179F
          (0, 0, 6025, 6025),
         16#A0#           =>  --  17A0
          (0, 0, 6026, 6026),
         16#A1#           =>  --  17A1
          (0, 0, 6027, 6027),
         16#A2#           =>  --  17A2
          (0, 0, 6028, 6028),
         16#A3#           =>  --  17A3
          (0, 0, 6029, 6029),
         16#A4#           =>  --  17A4
          (0, 0, 6030, 6030),
         16#A5#           =>  --  17A5
          (0, 0, 6031, 6031),
         16#A6#           =>  --  17A6
          (0, 0, 6032, 6032),
         16#A7#           =>  --  17A7
          (0, 0, 6033, 6033),
         16#A8#           =>  --  17A8
          (0, 0, 6034, 6034),
         16#A9#           =>  --  17A9
          (0, 0, 6035, 6035),
         16#AA#           =>  --  17AA
          (0, 0, 6036, 6036),
         16#AB#           =>  --  17AB
          (0, 0, 6037, 6037),
         16#AC#           =>  --  17AC
          (0, 0, 6038, 6038),
         16#AD#           =>  --  17AD
          (0, 0, 6039, 6039),
         16#AE#           =>  --  17AE
          (0, 0, 6040, 6040),
         16#AF#           =>  --  17AF
          (0, 0, 6041, 6041),
         16#B0#           =>  --  17B0
          (0, 0, 6042, 6042),
         16#B1#           =>  --  17B1
          (0, 0, 6043, 6043),
         16#B2#           =>  --  17B2
          (0, 0, 6044, 6044),
         16#B3#           =>  --  17B3
          (0, 0, 6045, 6045),
         16#B4# .. 16#B5# =>  --  17B4 .. 17B5
          (0, 0, 1, 1),
         16#B6#           =>  --  17B6
          (0, 0, 6046, 6046),
         16#B7#           =>  --  17B7
          (0, 0, 6047, 6047),
         16#B8#           =>  --  17B8
          (0, 0, 6048, 6048),
         16#B9#           =>  --  17B9
          (0, 0, 6049, 6049),
         16#BA#           =>  --  17BA
          (0, 0, 6050, 6050),
         16#BB#           =>  --  17BB
          (0, 0, 6051, 6051),
         16#BC#           =>  --  17BC
          (0, 0, 6052, 6052),
         16#BD#           =>  --  17BD
          (0, 0, 6053, 6053),
         16#BE#           =>  --  17BE
          (0, 0, 6054, 6054),
         16#BF#           =>  --  17BF
          (0, 0, 6055, 6055),
         16#C0#           =>  --  17C0
          (0, 0, 6056, 6056),
         16#C1#           =>  --  17C1
          (0, 0, 6057, 6057),
         16#C2#           =>  --  17C2
          (0, 0, 6058, 6058),
         16#C3#           =>  --  17C3
          (0, 0, 6059, 6059),
         16#C4#           =>  --  17C4
          (0, 0, 6060, 6060),
         16#C5#           =>  --  17C5
          (0, 0, 6061, 6061),
         16#C6#           =>  --  17C6
          (0, 0, 2243, 2243),
         16#C7#           =>  --  17C7
          (0, 0, 2244, 2244),
         16#C8#           =>  --  17C8
          (0, 0, 6062, 6062),
         16#C9#           =>  --  17C9
          (0, 0, 6063, 6063),
         16#CA#           =>  --  17CA
          (0, 0, 6064, 6064),
         16#CB# .. 16#D1# =>  --  17CB .. 17D1
          (0, 0, 1041, 1041),
         16#D2#           =>  --  17D2
          (0, 0, 6065, 6065),
         16#D3#           =>  --  17D3
          (0, 0, 1, 1),
         16#D4#           =>  --  17D4
          (0, 0, 6066, 6066),
         16#D5#           =>  --  17D5
          (0, 0, 6067, 6067),
         16#D6#           =>  --  17D6
          (0, 0, 6068, 6068),
         16#D7#           =>  --  17D7
          (0, 0, 6069, 6069),
         16#D8#           =>  --  17D8
          (0, 0, 6070, 6070),
         16#D9#           =>  --  17D9
          (0, 0, 6071, 6071),
         16#DA#           =>  --  17DA
          (0, 0, 6072, 6072),
         16#DB#           =>  --  17DB
          (0, 0, 6073, 6073),
         16#DC#           =>  --  17DC
          (0, 0, 6074, 6074),
         16#DD#           =>  --  17DD
          (0, 0, 1041, 1041),
         16#E0#           =>  --  17E0
          (0, 0, 23, 23),
         16#E1#           =>  --  17E1
          (0, 0, 24, 24),
         16#E2#           =>  --  17E2
          (0, 0, 25, 25),
         16#E3#           =>  --  17E3
          (0, 0, 26, 26),
         16#E4#           =>  --  17E4
          (0, 0, 27, 27),
         16#E5#           =>  --  17E5
          (0, 0, 28, 28),
         16#E6#           =>  --  17E6
          (0, 0, 29, 29),
         16#E7#           =>  --  17E7
          (0, 0, 30, 30),
         16#E8#           =>  --  17E8
          (0, 0, 31, 31),
         16#E9#           =>  --  17E9
          (0, 0, 32, 32),
         16#F0#           =>  --  17F0
          (0, 0, 23, 23),
         16#F1#           =>  --  17F1
          (0, 0, 24, 24),
         16#F2#           =>  --  17F2
          (0, 0, 25, 25),
         16#F3#           =>  --  17F3
          (0, 0, 26, 26),
         16#F4#           =>  --  17F4
          (0, 0, 27, 27),
         16#F5#           =>  --  17F5
          (0, 0, 28, 28),
         16#F6#           =>  --  17F6
          (0, 0, 29, 29),
         16#F7#           =>  --  17F7
          (0, 0, 30, 30),
         16#F8#           =>  --  17F8
          (0, 0, 31, 31),
         16#F9#           =>  --  17F9
          (0, 0, 32, 32),
         others           =>
          (0, 0, 0, 0));

   Group_0018 : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  1800
          (0, 0, 6075, 6075),
         16#01#           =>  --  1801
          (0, 0, 6076, 6076),
         16#02#           =>  --  1802
          (0, 0, 6077, 6077),
         16#03#           =>  --  1803
          (0, 0, 6078, 6078),
         16#04#           =>  --  1804
          (0, 0, 6079, 6079),
         16#05#           =>  --  1805
          (0, 0, 6080, 6080),
         16#06#           =>  --  1806
          (0, 0, 6081, 6081),
         16#07#           =>  --  1807
          (0, 0, 6082, 6082),
         16#08#           =>  --  1808
          (0, 0, 6083, 6083),
         16#09#           =>  --  1809
          (0, 0, 6084, 6084),
         16#0A# .. 16#0E# =>  --  180A .. 180E
          (0, 0, 1, 1),
         16#10#           =>  --  1810
          (0, 0, 23, 23),
         16#11#           =>  --  1811
          (0, 0, 24, 24),
         16#12#           =>  --  1812
          (0, 0, 25, 25),
         16#13#           =>  --  1813
          (0, 0, 26, 26),
         16#14#           =>  --  1814
          (0, 0, 27, 27),
         16#15#           =>  --  1815
          (0, 0, 28, 28),
         16#16#           =>  --  1816
          (0, 0, 29, 29),
         16#17#           =>  --  1817
          (0, 0, 30, 30),
         16#18#           =>  --  1818
          (0, 0, 31, 31),
         16#19#           =>  --  1819
          (0, 0, 32, 32),
         16#20#           =>  --  1820
          (0, 0, 6085, 6085),
         16#21#           =>  --  1821
          (0, 0, 6086, 6086),
         16#22#           =>  --  1822
          (0, 0, 6087, 6087),
         16#23#           =>  --  1823
          (0, 0, 6088, 6088),
         16#24#           =>  --  1824
          (0, 0, 6089, 6089),
         16#25#           =>  --  1825
          (0, 0, 6090, 6090),
         16#26#           =>  --  1826
          (0, 0, 6091, 6091),
         16#27#           =>  --  1827
          (0, 0, 6092, 6092),
         16#28#           =>  --  1828
          (0, 0, 6093, 6093),
         16#29#           =>  --  1829
          (0, 0, 6094, 6094),
         16#2A#           =>  --  182A
          (0, 0, 6095, 6095),
         16#2B#           =>  --  182B
          (0, 0, 6096, 6096),
         16#2C#           =>  --  182C
          (0, 0, 6097, 6097),
         16#2D#           =>  --  182D
          (0, 0, 6098, 6098),
         16#2E#           =>  --  182E
          (0, 0, 6099, 6099),
         16#2F#           =>  --  182F
          (0, 0, 6100, 6100),
         16#30#           =>  --  1830
          (0, 0, 6101, 6101),
         16#31#           =>  --  1831
          (0, 0, 6102, 6102),
         16#32#           =>  --  1832
          (0, 0, 6103, 6103),
         16#33#           =>  --  1833
          (0, 0, 6104, 6104),
         16#34#           =>  --  1834
          (0, 0, 6105, 6105),
         16#35#           =>  --  1835
          (0, 0, 6106, 6106),
         16#36#           =>  --  1836
          (0, 0, 6107, 6107),
         16#37#           =>  --  1837
          (0, 0, 6108, 6108),
         16#38#           =>  --  1838
          (0, 0, 6109, 6109),
         16#39#           =>  --  1839
          (0, 0, 6110, 6110),
         16#3A#           =>  --  183A
          (0, 0, 6111, 6111),
         16#3B#           =>  --  183B
          (0, 0, 6112, 6112),
         16#3C#           =>  --  183C
          (0, 0, 6113, 6113),
         16#3D#           =>  --  183D
          (0, 0, 6114, 6114),
         16#3E#           =>  --  183E
          (0, 0, 6115, 6115),
         16#3F#           =>  --  183F
          (0, 0, 6116, 6116),
         16#40#           =>  --  1840
          (0, 0, 6117, 6117),
         16#41#           =>  --  1841
          (0, 0, 6118, 6118),
         16#42#           =>  --  1842
          (0, 0, 6119, 6119),
         16#43#           =>  --  1843
          (0, 0, 6120, 6120),
         16#44#           =>  --  1844
          (0, 0, 6121, 6121),
         16#45#           =>  --  1845
          (0, 0, 6122, 6122),
         16#46#           =>  --  1846
          (0, 0, 6123, 6123),
         16#47#           =>  --  1847
          (0, 0, 6124, 6124),
         16#48#           =>  --  1848
          (0, 0, 6125, 6125),
         16#49#           =>  --  1849
          (0, 0, 6126, 6126),
         16#4A#           =>  --  184A
          (0, 0, 6127, 6127),
         16#4B#           =>  --  184B
          (0, 0, 6128, 6128),
         16#4C#           =>  --  184C
          (0, 0, 6129, 6129),
         16#4D#           =>  --  184D
          (0, 0, 6130, 6130),
         16#4E#           =>  --  184E
          (0, 0, 6131, 6131),
         16#4F#           =>  --  184F
          (0, 0, 6132, 6132),
         16#50#           =>  --  1850
          (0, 0, 6133, 6133),
         16#51#           =>  --  1851
          (0, 0, 6134, 6134),
         16#52#           =>  --  1852
          (0, 0, 6135, 6135),
         16#53#           =>  --  1853
          (0, 0, 6136, 6136),
         16#54#           =>  --  1854
          (0, 0, 6137, 6137),
         16#55#           =>  --  1855
          (0, 0, 6138, 6138),
         16#56#           =>  --  1856
          (0, 0, 6139, 6139),
         16#57#           =>  --  1857
          (0, 0, 6140, 6140),
         16#58#           =>  --  1858
          (0, 0, 6141, 6141),
         16#59#           =>  --  1859
          (0, 0, 6142, 6142),
         16#5A#           =>  --  185A
          (0, 0, 6143, 6143),
         16#5B#           =>  --  185B
          (0, 0, 6144, 6144),
         16#5C#           =>  --  185C
          (0, 0, 6145, 6145),
         16#5D#           =>  --  185D
          (0, 0, 6146, 6146),
         16#5E#           =>  --  185E
          (0, 0, 6147, 6147),
         16#5F#           =>  --  185F
          (0, 0, 6148, 6148),
         16#60#           =>  --  1860
          (0, 0, 6149, 6149),
         16#61#           =>  --  1861
          (0, 0, 6150, 6150),
         16#62#           =>  --  1862
          (0, 0, 6151, 6151),
         16#63#           =>  --  1863
          (0, 0, 6152, 6152),
         16#64#           =>  --  1864
          (0, 0, 6153, 6153),
         16#65#           =>  --  1865
          (0, 0, 6154, 6154),
         16#66#           =>  --  1866
          (0, 0, 6155, 6155),
         16#67#           =>  --  1867
          (0, 0, 6156, 6156),
         16#68#           =>  --  1868
          (0, 0, 6157, 6157),
         16#69#           =>  --  1869
          (0, 0, 6158, 6158),
         16#6A#           =>  --  186A
          (0, 0, 6159, 6159),
         16#6B#           =>  --  186B
          (0, 0, 6160, 6160),
         16#6C#           =>  --  186C
          (0, 0, 6161, 6161),
         16#6D#           =>  --  186D
          (0, 0, 6162, 6162),
         16#6E#           =>  --  186E
          (0, 0, 6163, 6163),
         16#6F#           =>  --  186F
          (0, 0, 6164, 6164),
         16#70#           =>  --  1870
          (0, 0, 6165, 6165),
         16#71#           =>  --  1871
          (0, 0, 6166, 6166),
         16#72#           =>  --  1872
          (0, 0, 6167, 6167),
         16#73#           =>  --  1873
          (0, 0, 6168, 6168),
         16#74#           =>  --  1874
          (0, 0, 6169, 6169),
         16#75#           =>  --  1875
          (0, 0, 6170, 6170),
         16#76#           =>  --  1876
          (0, 0, 6171, 6171),
         16#77#           =>  --  1877
          (0, 0, 6172, 6172),
         16#80#           =>  --  1880
          (0, 0, 6173, 6173),
         16#81#           =>  --  1881
          (0, 0, 6174, 6174),
         16#82#           =>  --  1882
          (0, 0, 6175, 6175),
         16#83#           =>  --  1883
          (0, 0, 6176, 6176),
         16#84#           =>  --  1884
          (0, 0, 6177, 6177),
         16#85#           =>  --  1885
          (0, 0, 6178, 6178),
         16#86#           =>  --  1886
          (0, 0, 6179, 6179),
         16#87#           =>  --  1887
          (0, 0, 6180, 6180),
         16#88#           =>  --  1888
          (0, 0, 6181, 6181),
         16#89#           =>  --  1889
          (0, 0, 6182, 6182),
         16#8A#           =>  --  188A
          (0, 0, 6183, 6183),
         16#8B#           =>  --  188B
          (0, 0, 6184, 6184),
         16#8C#           =>  --  188C
          (0, 0, 6185, 6185),
         16#8D#           =>  --  188D
          (0, 0, 6186, 6186),
         16#8E#           =>  --  188E
          (0, 0, 6187, 6187),
         16#8F#           =>  --  188F
          (0, 0, 6188, 6188),
         16#90#           =>  --  1890
          (0, 0, 6189, 6189),
         16#91#           =>  --  1891
          (0, 0, 6190, 6190),
         16#92#           =>  --  1892
          (0, 0, 6191, 6191),
         16#93#           =>  --  1893
          (0, 0, 6192, 6192),
         16#94#           =>  --  1894
          (0, 0, 6193, 6193),
         16#95#           =>  --  1895
          (0, 0, 6194, 6194),
         16#96#           =>  --  1896
          (0, 0, 6195, 6195),
         16#97#           =>  --  1897
          (0, 0, 6196, 6196),
         16#98#           =>  --  1898
          (0, 0, 6197, 6197),
         16#99#           =>  --  1899
          (0, 0, 6198, 6198),
         16#9A#           =>  --  189A
          (0, 0, 6199, 6199),
         16#9B#           =>  --  189B
          (0, 0, 6200, 6200),
         16#9C#           =>  --  189C
          (0, 0, 6201, 6201),
         16#9D#           =>  --  189D
          (0, 0, 6202, 6202),
         16#9E#           =>  --  189E
          (0, 0, 6203, 6203),
         16#9F#           =>  --  189F
          (0, 0, 6204, 6204),
         16#A0#           =>  --  18A0
          (0, 0, 6205, 6205),
         16#A1#           =>  --  18A1
          (0, 0, 6206, 6206),
         16#A2#           =>  --  18A2
          (0, 0, 6207, 6207),
         16#A3#           =>  --  18A3
          (0, 0, 6208, 6208),
         16#A4#           =>  --  18A4
          (0, 0, 6209, 6209),
         16#A5#           =>  --  18A5
          (0, 0, 6210, 6210),
         16#A6#           =>  --  18A6
          (0, 0, 6211, 6211),
         16#A7#           =>  --  18A7
          (0, 0, 6212, 6212),
         16#A8#           =>  --  18A8
          (0, 0, 6213, 6213),
         16#A9#           =>  --  18A9
          (0, 0, 6214, 6214),
         16#AA#           =>  --  18AA
          (0, 0, 6215, 6215),
         16#B0#           =>  --  18B0
          (0, 0, 6216, 6216),
         16#B1#           =>  --  18B1
          (0, 0, 6217, 6217),
         16#B2#           =>  --  18B2
          (0, 0, 6218, 6218),
         16#B3#           =>  --  18B3
          (0, 0, 6219, 6219),
         16#B4#           =>  --  18B4
          (0, 0, 6220, 6220),
         16#B5#           =>  --  18B5
          (0, 0, 6221, 6221),
         16#B6#           =>  --  18B6
          (0, 0, 6222, 6222),
         16#B7#           =>  --  18B7
          (0, 0, 6223, 6223),
         16#B8#           =>  --  18B8
          (0, 0, 6224, 6224),
         16#B9#           =>  --  18B9
          (0, 0, 6225, 6225),
         16#BA#           =>  --  18BA
          (0, 0, 6226, 6226),
         16#BB#           =>  --  18BB
          (0, 0, 6227, 6227),
         16#BC#           =>  --  18BC
          (0, 0, 6228, 6228),
         16#BD#           =>  --  18BD
          (0, 0, 6229, 6229),
         16#BE#           =>  --  18BE
          (0, 0, 6230, 6230),
         16#BF#           =>  --  18BF
          (0, 0, 6231, 6231),
         16#C0#           =>  --  18C0
          (0, 0, 6232, 6232),
         16#C1#           =>  --  18C1
          (0, 0, 6233, 6233),
         16#C2#           =>  --  18C2
          (0, 0, 6234, 6234),
         16#C3#           =>  --  18C3
          (0, 0, 6235, 6235),
         16#C4#           =>  --  18C4
          (0, 0, 6236, 6236),
         16#C5#           =>  --  18C5
          (0, 0, 6237, 6237),
         16#C6#           =>  --  18C6
          (0, 0, 6238, 6238),
         16#C7#           =>  --  18C7
          (0, 0, 6239, 6239),
         16#C8#           =>  --  18C8
          (0, 0, 6240, 6240),
         16#C9#           =>  --  18C9
          (0, 0, 6241, 6241),
         16#CA#           =>  --  18CA
          (0, 0, 6242, 6242),
         16#CB#           =>  --  18CB
          (0, 0, 6243, 6243),
         16#CC#           =>  --  18CC
          (0, 0, 6244, 6244),
         16#CD#           =>  --  18CD
          (0, 0, 6245, 6245),
         16#CE#           =>  --  18CE
          (0, 0, 6246, 6246),
         16#CF#           =>  --  18CF
          (0, 0, 6247, 6247),
         16#D0#           =>  --  18D0
          (0, 0, 6248, 6248),
         16#D1#           =>  --  18D1
          (0, 0, 6249, 6249),
         16#D2#           =>  --  18D2
          (0, 0, 6250, 6250),
         16#D3#           =>  --  18D3
          (0, 0, 6251, 6251),
         16#D4#           =>  --  18D4
          (0, 0, 6252, 6252),
         16#D5#           =>  --  18D5
          (0, 0, 6253, 6253),
         16#D6#           =>  --  18D6
          (0, 0, 6254, 6254),
         16#D7#           =>  --  18D7
          (0, 0, 6255, 6255),
         16#D8#           =>  --  18D8
          (0, 0, 6256, 6256),
         16#D9#           =>  --  18D9
          (0, 0, 6257, 6257),
         16#DA#           =>  --  18DA
          (0, 0, 6258, 6258),
         16#DB#           =>  --  18DB
          (0, 0, 6259, 6259),
         16#DC#           =>  --  18DC
          (0, 0, 6260, 6260),
         16#DD#           =>  --  18DD
          (0, 0, 6261, 6261),
         16#DE#           =>  --  18DE
          (0, 0, 6262, 6262),
         16#DF#           =>  --  18DF
          (0, 0, 6263, 6263),
         16#E0#           =>  --  18E0
          (0, 0, 6264, 6264),
         16#E1#           =>  --  18E1
          (0, 0, 6265, 6265),
         16#E2#           =>  --  18E2
          (0, 0, 6266, 6266),
         16#E3#           =>  --  18E3
          (0, 0, 6267, 6267),
         16#E4#           =>  --  18E4
          (0, 0, 6268, 6268),
         16#E5#           =>  --  18E5
          (0, 0, 6269, 6269),
         16#E6#           =>  --  18E6
          (0, 0, 6270, 6270),
         16#E7#           =>  --  18E7
          (0, 0, 6271, 6271),
         16#E8#           =>  --  18E8
          (0, 0, 6272, 6272),
         16#E9#           =>  --  18E9
          (0, 0, 6273, 6273),
         16#EA#           =>  --  18EA
          (0, 0, 6274, 6274),
         16#EB#           =>  --  18EB
          (0, 0, 6275, 6275),
         16#EC#           =>  --  18EC
          (0, 0, 6276, 6276),
         16#ED#           =>  --  18ED
          (0, 0, 6277, 6277),
         16#EE#           =>  --  18EE
          (0, 0, 6278, 6278),
         16#EF#           =>  --  18EF
          (0, 0, 6279, 6279),
         16#F0#           =>  --  18F0
          (0, 0, 6280, 6280),
         16#F1#           =>  --  18F1
          (0, 0, 6281, 6281),
         16#F2#           =>  --  18F2
          (0, 0, 6282, 6282),
         16#F3#           =>  --  18F3
          (0, 0, 6283, 6283),
         16#F4#           =>  --  18F4
          (0, 0, 6284, 6284),
         16#F5#           =>  --  18F5
          (0, 0, 6285, 6285),
         others           =>
          (0, 0, 0, 0));

   Group_0019 : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  1900
          (0, 0, 6286, 6286),
         16#01#           =>  --  1901
          (0, 0, 6287, 6287),
         16#02#           =>  --  1902
          (0, 0, 6288, 6288),
         16#03#           =>  --  1903
          (0, 0, 6289, 6289),
         16#04#           =>  --  1904
          (0, 0, 6290, 6290),
         16#05#           =>  --  1905
          (0, 0, 6291, 6291),
         16#06#           =>  --  1906
          (0, 0, 6292, 6292),
         16#07#           =>  --  1907
          (0, 0, 6293, 6293),
         16#08#           =>  --  1908
          (0, 0, 6294, 6294),
         16#09#           =>  --  1909
          (0, 0, 6295, 6295),
         16#0A#           =>  --  190A
          (0, 0, 6296, 6296),
         16#0B#           =>  --  190B
          (0, 0, 6297, 6297),
         16#0C#           =>  --  190C
          (0, 0, 6298, 6298),
         16#0D#           =>  --  190D
          (0, 0, 6299, 6299),
         16#0E#           =>  --  190E
          (0, 0, 6300, 6300),
         16#0F#           =>  --  190F
          (0, 0, 6301, 6301),
         16#10#           =>  --  1910
          (0, 0, 6302, 6302),
         16#11#           =>  --  1911
          (0, 0, 6303, 6303),
         16#12#           =>  --  1912
          (0, 0, 6304, 6304),
         16#13#           =>  --  1913
          (0, 0, 6305, 6305),
         16#14#           =>  --  1914
          (0, 0, 6306, 6306),
         16#15#           =>  --  1915
          (0, 0, 6307, 6307),
         16#16#           =>  --  1916
          (0, 0, 6308, 6308),
         16#17#           =>  --  1917
          (0, 0, 6309, 6309),
         16#18#           =>  --  1918
          (0, 0, 6310, 6310),
         16#19#           =>  --  1919
          (0, 0, 6311, 6311),
         16#1A#           =>  --  191A
          (0, 0, 6312, 6312),
         16#1B#           =>  --  191B
          (0, 0, 6313, 6313),
         16#1C#           =>  --  191C
          (0, 0, 6314, 6314),
         16#1D#           =>  --  191D
          (0, 0, 6315, 6316),
         16#1E#           =>  --  191E
          (0, 0, 6317, 6318),
         16#20#           =>  --  1920
          (0, 0, 6319, 6319),
         16#21#           =>  --  1921
          (0, 0, 6320, 6320),
         16#22#           =>  --  1922
          (0, 0, 6321, 6321),
         16#23#           =>  --  1923
          (0, 0, 6322, 6322),
         16#24#           =>  --  1924
          (0, 0, 6323, 6323),
         16#25#           =>  --  1925
          (0, 0, 6324, 6324),
         16#26#           =>  --  1926
          (0, 0, 6325, 6325),
         16#27#           =>  --  1927
          (0, 0, 6326, 6326),
         16#28#           =>  --  1928
          (0, 0, 6327, 6327),
         16#29#           =>  --  1929
          (0, 0, 6328, 6328),
         16#2A#           =>  --  192A
          (0, 0, 6329, 6329),
         16#2B#           =>  --  192B
          (0, 0, 6330, 6330),
         16#30#           =>  --  1930
          (0, 0, 6331, 6331),
         16#31#           =>  --  1931
          (0, 0, 6332, 6332),
         16#32#           =>  --  1932
          (0, 0, 6333, 6333),
         16#33#           =>  --  1933
          (0, 0, 6334, 6334),
         16#34#           =>  --  1934
          (0, 0, 6335, 6335),
         16#35#           =>  --  1935
          (0, 0, 6336, 6336),
         16#36#           =>  --  1936
          (0, 0, 6337, 6337),
         16#37#           =>  --  1937
          (0, 0, 6338, 6338),
         16#38#           =>  --  1938
          (0, 0, 6339, 6339),
         16#39#           =>  --  1939
          (0, 0, 6340, 6340),
         16#3A#           =>  --  193A
          (0, 0, 6341, 6341),
         16#3B#           =>  --  193B
          (0, 0, 6342, 6342),
         16#40#           =>  --  1940
          (0, 0, 6343, 6343),
         16#44#           =>  --  1944
          (0, 0, 6344, 6344),
         16#45#           =>  --  1945
          (0, 0, 6345, 6345),
         16#46#           =>  --  1946
          (0, 0, 23, 23),
         16#47#           =>  --  1947
          (0, 0, 24, 24),
         16#48#           =>  --  1948
          (0, 0, 25, 25),
         16#49#           =>  --  1949
          (0, 0, 26, 26),
         16#4A#           =>  --  194A
          (0, 0, 27, 27),
         16#4B#           =>  --  194B
          (0, 0, 28, 28),
         16#4C#           =>  --  194C
          (0, 0, 29, 29),
         16#4D#           =>  --  194D
          (0, 0, 30, 30),
         16#4E#           =>  --  194E
          (0, 0, 31, 31),
         16#4F#           =>  --  194F
          (0, 0, 32, 32),
         16#50#           =>  --  1950
          (0, 0, 6346, 6346),
         16#51#           =>  --  1951
          (0, 0, 6347, 6347),
         16#52#           =>  --  1952
          (0, 0, 6348, 6348),
         16#53#           =>  --  1953
          (0, 0, 6349, 6349),
         16#54#           =>  --  1954
          (0, 0, 6350, 6350),
         16#55#           =>  --  1955
          (0, 0, 6351, 6351),
         16#56#           =>  --  1956
          (0, 0, 6352, 6352),
         16#57#           =>  --  1957
          (0, 0, 6353, 6353),
         16#58#           =>  --  1958
          (0, 0, 6354, 6354),
         16#59#           =>  --  1959
          (0, 0, 6355, 6355),
         16#5A#           =>  --  195A
          (0, 0, 6356, 6356),
         16#5B#           =>  --  195B
          (0, 0, 6357, 6357),
         16#5C#           =>  --  195C
          (0, 0, 6358, 6358),
         16#5D#           =>  --  195D
          (0, 0, 6359, 6359),
         16#5E#           =>  --  195E
          (0, 0, 6360, 6360),
         16#5F#           =>  --  195F
          (0, 0, 6361, 6361),
         16#60#           =>  --  1960
          (0, 0, 6362, 6362),
         16#61#           =>  --  1961
          (0, 0, 6363, 6363),
         16#62#           =>  --  1962
          (0, 0, 6364, 6364),
         16#63#           =>  --  1963
          (0, 0, 6365, 6365),
         16#64#           =>  --  1964
          (0, 0, 6366, 6366),
         16#65#           =>  --  1965
          (0, 0, 6367, 6367),
         16#66#           =>  --  1966
          (0, 0, 6368, 6368),
         16#67#           =>  --  1967
          (0, 0, 6369, 6369),
         16#68#           =>  --  1968
          (0, 0, 6370, 6370),
         16#69#           =>  --  1969
          (0, 0, 6371, 6371),
         16#6A#           =>  --  196A
          (0, 0, 6372, 6372),
         16#6B#           =>  --  196B
          (0, 0, 6373, 6373),
         16#6C#           =>  --  196C
          (0, 0, 6374, 6374),
         16#6D#           =>  --  196D
          (0, 0, 6375, 6375),
         16#70#           =>  --  1970
          (0, 0, 6376, 6376),
         16#71#           =>  --  1971
          (0, 0, 6377, 6377),
         16#72#           =>  --  1972
          (0, 0, 6378, 6378),
         16#73#           =>  --  1973
          (0, 0, 6379, 6379),
         16#74#           =>  --  1974
          (0, 0, 6380, 6380),
         16#80#           =>  --  1980
          (0, 0, 6381, 6381),
         16#81#           =>  --  1981
          (0, 0, 6382, 6382),
         16#82#           =>  --  1982
          (0, 0, 6383, 6383),
         16#83#           =>  --  1983
          (0, 0, 6384, 6384),
         16#84#           =>  --  1984
          (0, 0, 6385, 6385),
         16#85#           =>  --  1985
          (0, 0, 6386, 6386),
         16#86#           =>  --  1986
          (0, 0, 6387, 6387),
         16#87#           =>  --  1987
          (0, 0, 6388, 6388),
         16#88#           =>  --  1988
          (0, 0, 6389, 6389),
         16#89#           =>  --  1989
          (0, 0, 6390, 6390),
         16#8A#           =>  --  198A
          (0, 0, 6391, 6391),
         16#8B#           =>  --  198B
          (0, 0, 6392, 6392),
         16#8C#           =>  --  198C
          (0, 0, 6393, 6393),
         16#8D#           =>  --  198D
          (0, 0, 6394, 6394),
         16#8E#           =>  --  198E
          (0, 0, 6395, 6395),
         16#8F#           =>  --  198F
          (0, 0, 6396, 6396),
         16#90#           =>  --  1990
          (0, 0, 6397, 6397),
         16#91#           =>  --  1991
          (0, 0, 6398, 6398),
         16#92#           =>  --  1992
          (0, 0, 6399, 6399),
         16#93#           =>  --  1993
          (0, 0, 6400, 6400),
         16#94#           =>  --  1994
          (0, 0, 6401, 6401),
         16#95#           =>  --  1995
          (0, 0, 6402, 6402),
         16#96#           =>  --  1996
          (0, 0, 6403, 6403),
         16#97#           =>  --  1997
          (0, 0, 6404, 6404),
         16#98#           =>  --  1998
          (0, 0, 6405, 6405),
         16#99#           =>  --  1999
          (0, 0, 6406, 6406),
         16#9A#           =>  --  199A
          (0, 0, 6407, 6407),
         16#9B#           =>  --  199B
          (0, 0, 6408, 6408),
         16#9C#           =>  --  199C
          (0, 0, 6409, 6409),
         16#9D#           =>  --  199D
          (0, 0, 6410, 6410),
         16#9E#           =>  --  199E
          (0, 0, 6411, 6411),
         16#9F#           =>  --  199F
          (0, 0, 6412, 6412),
         16#A0#           =>  --  19A0
          (0, 0, 6413, 6413),
         16#A1#           =>  --  19A1
          (0, 0, 6414, 6414),
         16#A2#           =>  --  19A2
          (0, 0, 6415, 6415),
         16#A3#           =>  --  19A3
          (0, 0, 6416, 6416),
         16#A4#           =>  --  19A4
          (0, 0, 6417, 6417),
         16#A5#           =>  --  19A5
          (0, 0, 6418, 6418),
         16#A6#           =>  --  19A6
          (0, 0, 6419, 6419),
         16#A7#           =>  --  19A7
          (0, 0, 6420, 6420),
         16#A8#           =>  --  19A8
          (0, 0, 6421, 6421),
         16#A9#           =>  --  19A9
          (0, 0, 6422, 6422),
         16#AA#           =>  --  19AA
          (0, 0, 6423, 6423),
         16#AB#           =>  --  19AB
          (0, 0, 6424, 6424),
         16#B0#           =>  --  19B0
          (0, 0, 6425, 6425),
         16#B1#           =>  --  19B1
          (0, 0, 6426, 6426),
         16#B2#           =>  --  19B2
          (0, 0, 6427, 6427),
         16#B3#           =>  --  19B3
          (0, 0, 6428, 6428),
         16#B4#           =>  --  19B4
          (0, 0, 6429, 6429),
         16#B5#           =>  --  19B5
          (0, 0, 6430, 6430),
         16#B6#           =>  --  19B6
          (0, 0, 6431, 6431),
         16#B7#           =>  --  19B7
          (0, 0, 6432, 6432),
         16#B8#           =>  --  19B8
          (0, 0, 6433, 6433),
         16#B9#           =>  --  19B9
          (0, 0, 6434, 6434),
         16#BA#           =>  --  19BA
          (0, 0, 6435, 6435),
         16#BB#           =>  --  19BB
          (0, 0, 6436, 6436),
         16#BC#           =>  --  19BC
          (0, 0, 6437, 6437),
         16#BD#           =>  --  19BD
          (0, 0, 6438, 6438),
         16#BE#           =>  --  19BE
          (0, 0, 6439, 6439),
         16#BF#           =>  --  19BF
          (0, 0, 6440, 6440),
         16#C0#           =>  --  19C0
          (0, 0, 6441, 6441),
         16#C1#           =>  --  19C1
          (0, 0, 6442, 6442),
         16#C2#           =>  --  19C2
          (0, 0, 6443, 6443),
         16#C3#           =>  --  19C3
          (0, 0, 6444, 6444),
         16#C4#           =>  --  19C4
          (0, 0, 6445, 6445),
         16#C5#           =>  --  19C5
          (0, 0, 6446, 6446),
         16#C6#           =>  --  19C6
          (0, 0, 6447, 6447),
         16#C7#           =>  --  19C7
          (0, 0, 6448, 6448),
         16#C8#           =>  --  19C8
          (0, 0, 6449, 6449),
         16#C9#           =>  --  19C9
          (0, 0, 6450, 6450),
         16#D0#           =>  --  19D0
          (0, 0, 23, 23),
         16#D1#           =>  --  19D1
          (0, 0, 24, 24),
         16#D2#           =>  --  19D2
          (0, 0, 25, 25),
         16#D3#           =>  --  19D3
          (0, 0, 26, 26),
         16#D4#           =>  --  19D4
          (0, 0, 27, 27),
         16#D5#           =>  --  19D5
          (0, 0, 28, 28),
         16#D6#           =>  --  19D6
          (0, 0, 29, 29),
         16#D7#           =>  --  19D7
          (0, 0, 30, 30),
         16#D8#           =>  --  19D8
          (0, 0, 31, 31),
         16#D9#           =>  --  19D9
          (0, 0, 32, 32),
         16#DA#           =>  --  19DA
          (0, 0, 24, 24),
         16#DE#           =>  --  19DE
          (0, 0, 6451, 6452),
         16#DF#           =>  --  19DF
          (0, 0, 6453, 6455),
         16#E0#           =>  --  19E0
          (0, 0, 6456, 6456),
         16#E1#           =>  --  19E1
          (0, 0, 6457, 6457),
         16#E2#           =>  --  19E2
          (0, 0, 6458, 6458),
         16#E3#           =>  --  19E3
          (0, 0, 6459, 6459),
         16#E4#           =>  --  19E4
          (0, 0, 6460, 6460),
         16#E5#           =>  --  19E5
          (0, 0, 6461, 6461),
         16#E6#           =>  --  19E6
          (0, 0, 6462, 6462),
         16#E7#           =>  --  19E7
          (0, 0, 6463, 6463),
         16#E8#           =>  --  19E8
          (0, 0, 6464, 6464),
         16#E9#           =>  --  19E9
          (0, 0, 6465, 6465),
         16#EA#           =>  --  19EA
          (0, 0, 6466, 6466),
         16#EB#           =>  --  19EB
          (0, 0, 6467, 6467),
         16#EC#           =>  --  19EC
          (0, 0, 6468, 6468),
         16#ED#           =>  --  19ED
          (0, 0, 6469, 6469),
         16#EE#           =>  --  19EE
          (0, 0, 6470, 6470),
         16#EF#           =>  --  19EF
          (0, 0, 6471, 6471),
         16#F0#           =>  --  19F0
          (0, 0, 6472, 6472),
         16#F1#           =>  --  19F1
          (0, 0, 6473, 6473),
         16#F2#           =>  --  19F2
          (0, 0, 6474, 6474),
         16#F3#           =>  --  19F3
          (0, 0, 6475, 6475),
         16#F4#           =>  --  19F4
          (0, 0, 6476, 6476),
         16#F5#           =>  --  19F5
          (0, 0, 6477, 6477),
         16#F6#           =>  --  19F6
          (0, 0, 6478, 6478),
         16#F7#           =>  --  19F7
          (0, 0, 6479, 6479),
         16#F8#           =>  --  19F8
          (0, 0, 6480, 6480),
         16#F9#           =>  --  19F9
          (0, 0, 6481, 6481),
         16#FA#           =>  --  19FA
          (0, 0, 6482, 6482),
         16#FB#           =>  --  19FB
          (0, 0, 6483, 6483),
         16#FC#           =>  --  19FC
          (0, 0, 6484, 6484),
         16#FD#           =>  --  19FD
          (0, 0, 6485, 6485),
         16#FE#           =>  --  19FE
          (0, 0, 6486, 6486),
         16#FF#           =>  --  19FF
          (0, 0, 6487, 6487),
         others           =>
          (0, 0, 0, 0));

   Group_001A : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  1A00
          (0, 0, 6488, 6488),
         16#01#           =>  --  1A01
          (0, 0, 6489, 6489),
         16#02#           =>  --  1A02
          (0, 0, 6490, 6490),
         16#03#           =>  --  1A03
          (0, 0, 6491, 6491),
         16#04#           =>  --  1A04
          (0, 0, 6492, 6492),
         16#05#           =>  --  1A05
          (0, 0, 6493, 6493),
         16#06#           =>  --  1A06
          (0, 0, 6494, 6494),
         16#07#           =>  --  1A07
          (0, 0, 6495, 6495),
         16#08#           =>  --  1A08
          (0, 0, 6496, 6496),
         16#09#           =>  --  1A09
          (0, 0, 6497, 6497),
         16#0A#           =>  --  1A0A
          (0, 0, 6498, 6498),
         16#0B#           =>  --  1A0B
          (0, 0, 6499, 6499),
         16#0C#           =>  --  1A0C
          (0, 0, 6500, 6500),
         16#0D#           =>  --  1A0D
          (0, 0, 6501, 6501),
         16#0E#           =>  --  1A0E
          (0, 0, 6502, 6502),
         16#0F#           =>  --  1A0F
          (0, 0, 6503, 6503),
         16#10#           =>  --  1A10
          (0, 0, 6504, 6504),
         16#11#           =>  --  1A11
          (0, 0, 6505, 6505),
         16#12#           =>  --  1A12
          (0, 0, 6506, 6506),
         16#13#           =>  --  1A13
          (0, 0, 6507, 6507),
         16#14#           =>  --  1A14
          (0, 0, 6508, 6508),
         16#15#           =>  --  1A15
          (0, 0, 6509, 6509),
         16#16#           =>  --  1A16
          (0, 0, 6510, 6510),
         16#17#           =>  --  1A17
          (0, 0, 6511, 6511),
         16#18#           =>  --  1A18
          (0, 0, 6512, 6512),
         16#19#           =>  --  1A19
          (0, 0, 6513, 6513),
         16#1A#           =>  --  1A1A
          (0, 0, 6514, 6514),
         16#1B#           =>  --  1A1B
          (0, 0, 6515, 6515),
         16#1E#           =>  --  1A1E
          (0, 0, 6516, 6516),
         16#1F#           =>  --  1A1F
          (0, 0, 6517, 6517),
         16#20#           =>  --  1A20
          (0, 0, 6518, 6518),
         16#21#           =>  --  1A21
          (0, 0, 6519, 6519),
         16#22#           =>  --  1A22
          (0, 0, 6520, 6520),
         16#23#           =>  --  1A23
          (0, 0, 6521, 6521),
         16#24#           =>  --  1A24
          (0, 0, 6522, 6522),
         16#25#           =>  --  1A25
          (0, 0, 6523, 6523),
         16#26#           =>  --  1A26
          (0, 0, 6524, 6524),
         16#27#           =>  --  1A27
          (0, 0, 6525, 6525),
         16#28#           =>  --  1A28
          (0, 0, 6526, 6526),
         16#29#           =>  --  1A29
          (0, 0, 6527, 6527),
         16#2A#           =>  --  1A2A
          (0, 0, 6528, 6528),
         16#2B#           =>  --  1A2B
          (0, 0, 6529, 6529),
         16#2C#           =>  --  1A2C
          (0, 0, 6530, 6530),
         16#2D#           =>  --  1A2D
          (0, 0, 6531, 6531),
         16#2E#           =>  --  1A2E
          (0, 0, 6532, 6532),
         16#2F#           =>  --  1A2F
          (0, 0, 6533, 6533),
         16#30#           =>  --  1A30
          (0, 0, 6534, 6534),
         16#31#           =>  --  1A31
          (0, 0, 6535, 6535),
         16#32#           =>  --  1A32
          (0, 0, 6536, 6536),
         16#33#           =>  --  1A33
          (0, 0, 6537, 6537),
         16#34#           =>  --  1A34
          (0, 0, 6538, 6538),
         16#35#           =>  --  1A35
          (0, 0, 6539, 6539),
         16#36#           =>  --  1A36
          (0, 0, 6540, 6540),
         16#37#           =>  --  1A37
          (0, 0, 6541, 6541),
         16#38#           =>  --  1A38
          (0, 0, 6542, 6542),
         16#39#           =>  --  1A39
          (0, 0, 6543, 6543),
         16#3A#           =>  --  1A3A
          (0, 0, 6544, 6544),
         16#3B#           =>  --  1A3B
          (0, 0, 6545, 6545),
         16#3C#           =>  --  1A3C
          (0, 0, 6546, 6546),
         16#3D#           =>  --  1A3D
          (0, 0, 6547, 6547),
         16#3E#           =>  --  1A3E
          (0, 0, 6548, 6548),
         16#3F#           =>  --  1A3F
          (0, 0, 6549, 6549),
         16#40#           =>  --  1A40
          (0, 0, 6550, 6550),
         16#41#           =>  --  1A41
          (0, 0, 6551, 6551),
         16#42#           =>  --  1A42
          (0, 0, 6552, 6552),
         16#43#           =>  --  1A43
          (0, 0, 6553, 6553),
         16#44#           =>  --  1A44
          (0, 0, 6554, 6554),
         16#45#           =>  --  1A45
          (0, 0, 6555, 6555),
         16#46#           =>  --  1A46
          (0, 0, 6556, 6556),
         16#47#           =>  --  1A47
          (0, 0, 6557, 6557),
         16#48#           =>  --  1A48
          (0, 0, 6558, 6558),
         16#49#           =>  --  1A49
          (0, 0, 6559, 6559),
         16#4A#           =>  --  1A4A
          (0, 0, 6560, 6560),
         16#4B#           =>  --  1A4B
          (0, 0, 6561, 6561),
         16#4C#           =>  --  1A4C
          (0, 0, 6562, 6562),
         16#4D#           =>  --  1A4D
          (0, 0, 6563, 6563),
         16#4E#           =>  --  1A4E
          (0, 0, 6564, 6564),
         16#4F#           =>  --  1A4F
          (0, 0, 6565, 6565),
         16#50#           =>  --  1A50
          (0, 0, 6566, 6566),
         16#51#           =>  --  1A51
          (0, 0, 6567, 6567),
         16#52#           =>  --  1A52
          (0, 0, 6568, 6568),
         16#53#           =>  --  1A53
          (0, 0, 6569, 6569),
         16#54#           =>  --  1A54
          (0, 0, 6570, 6572),
         16#55#           =>  --  1A55
          (0, 0, 6573, 6573),
         16#56#           =>  --  1A56
          (0, 0, 6574, 6574),
         16#57#           =>  --  1A57
          (0, 0, 6575, 6575),
         16#58# .. 16#59# =>  --  1A58 .. 1A59
          (0, 0, 6576, 6576),
         16#5A# .. 16#5B# =>  --  1A5A .. 1A5B
          (0, 0, 6577, 6577),
         16#5C#           =>  --  1A5C
          (0, 0, 6578, 6578),
         16#5D#           =>  --  1A5D
          (0, 0, 6579, 6579),
         16#5E#           =>  --  1A5E
          (0, 0, 6580, 6580),
         16#60#           =>  --  1A60
          (0, 0, 6581, 6581),
         16#61#           =>  --  1A61
          (0, 0, 6582, 6582),
         16#62#           =>  --  1A62
          (0, 0, 6583, 6583),
         16#63#           =>  --  1A63
          (0, 0, 6584, 6584),
         16#64#           =>  --  1A64
          (0, 0, 6585, 6585),
         16#65#           =>  --  1A65
          (0, 0, 6586, 6586),
         16#66#           =>  --  1A66
          (0, 0, 6587, 6587),
         16#67#           =>  --  1A67
          (0, 0, 6588, 6588),
         16#68#           =>  --  1A68
          (0, 0, 6589, 6589),
         16#69#           =>  --  1A69
          (0, 0, 6590, 6590),
         16#6A#           =>  --  1A6A
          (0, 0, 6591, 6591),
         16#6B#           =>  --  1A6B
          (0, 0, 6592, 6592),
         16#6C#           =>  --  1A6C
          (0, 0, 6593, 6593),
         16#6D#           =>  --  1A6D
          (0, 0, 6594, 6594),
         16#6E#           =>  --  1A6E
          (0, 0, 6595, 6595),
         16#6F#           =>  --  1A6F
          (0, 0, 6596, 6596),
         16#70#           =>  --  1A70
          (0, 0, 6597, 6597),
         16#71#           =>  --  1A71
          (0, 0, 6598, 6598),
         16#72#           =>  --  1A72
          (0, 0, 6599, 6599),
         16#73#           =>  --  1A73
          (0, 0, 6600, 6600),
         16#74#           =>  --  1A74
          (0, 0, 2243, 2243),
         16#75#           =>  --  1A75
          (0, 0, 6601, 6601),
         16#76#           =>  --  1A76
          (0, 0, 6602, 6602),
         16#77#           =>  --  1A77
          (0, 0, 6603, 6603),
         16#78#           =>  --  1A78
          (0, 0, 6604, 6604),
         16#79#           =>  --  1A79
          (0, 0, 6605, 6605),
         16#7A#           =>  --  1A7A
          (0, 0, 6606, 6606),
         16#7B#           =>  --  1A7B
          (0, 0, 6607, 6607),
         16#7C#           =>  --  1A7C
          (0, 0, 6608, 6608),
         16#7F#           =>  --  1A7F
          (0, 0, 1, 1),
         16#80#           =>  --  1A80
          (0, 0, 23, 23),
         16#81#           =>  --  1A81
          (0, 0, 24, 24),
         16#82#           =>  --  1A82
          (0, 0, 25, 25),
         16#83#           =>  --  1A83
          (0, 0, 26, 26),
         16#84#           =>  --  1A84
          (0, 0, 27, 27),
         16#85#           =>  --  1A85
          (0, 0, 28, 28),
         16#86#           =>  --  1A86
          (0, 0, 29, 29),
         16#87#           =>  --  1A87
          (0, 0, 30, 30),
         16#88#           =>  --  1A88
          (0, 0, 31, 31),
         16#89#           =>  --  1A89
          (0, 0, 32, 32),
         16#90#           =>  --  1A90
          (0, 0, 23, 23),
         16#91#           =>  --  1A91
          (0, 0, 24, 24),
         16#92#           =>  --  1A92
          (0, 0, 25, 25),
         16#93#           =>  --  1A93
          (0, 0, 26, 26),
         16#94#           =>  --  1A94
          (0, 0, 27, 27),
         16#95#           =>  --  1A95
          (0, 0, 28, 28),
         16#96#           =>  --  1A96
          (0, 0, 29, 29),
         16#97#           =>  --  1A97
          (0, 0, 30, 30),
         16#98#           =>  --  1A98
          (0, 0, 31, 31),
         16#99#           =>  --  1A99
          (0, 0, 32, 32),
         16#A0#           =>  --  1AA0
          (0, 0, 6609, 6609),
         16#A1#           =>  --  1AA1
          (0, 0, 6610, 6610),
         16#A2#           =>  --  1AA2
          (0, 0, 6611, 6611),
         16#A3#           =>  --  1AA3
          (0, 0, 6612, 6612),
         16#A4#           =>  --  1AA4
          (0, 0, 6613, 6613),
         16#A5#           =>  --  1AA5
          (0, 0, 6614, 6614),
         16#A6#           =>  --  1AA6
          (0, 0, 6615, 6615),
         16#A7#           =>  --  1AA7
          (0, 0, 6616, 6616),
         16#A8#           =>  --  1AA8
          (0, 0, 6617, 6617),
         16#A9#           =>  --  1AA9
          (0, 0, 6618, 6618),
         16#AA#           =>  --  1AAA
          (0, 0, 6619, 6619),
         16#AB#           =>  --  1AAB
          (0, 0, 6620, 6620),
         16#AC#           =>  --  1AAC
          (0, 0, 6621, 6621),
         16#AD#           =>  --  1AAD
          (0, 0, 6622, 6622),
         16#B0# .. 16#B4# =>  --  1AB0 .. 1AB4
          (0, 0, 1041, 1041),
         16#B5# .. 16#BA# =>  --  1AB5 .. 1ABA
          (0, 0, 1045, 1045),
         16#BB# .. 16#BC# =>  --  1ABB .. 1ABC
          (0, 0, 1041, 1041),
         16#BD#           =>  --  1ABD
          (0, 0, 1045, 1045),
         16#BE#           =>  --  1ABE
          (0, 0, 6623, 6623),
         others           =>
          (0, 0, 0, 0));

   Group_001B : aliased constant Collation_Second_Stage
     := (16#00# .. 16#01# =>  --  1B00 .. 1B01
          (0, 0, 2242, 2242),
         16#02#           =>  --  1B02
          (0, 0, 2243, 2243),
         16#03#           =>  --  1B03
          (0, 0, 6624, 6624),
         16#04#           =>  --  1B04
          (0, 0, 2244, 2244),
         16#05#           =>  --  1B05
          (443, 443, 6625, 6625),
         16#06#           =>  --  1B06
          (0, 0, 6626, 6626),
         16#07#           =>  --  1B07
          (444, 444, 6627, 6627),
         16#08#           =>  --  1B08
          (0, 0, 6628, 6628),
         16#09#           =>  --  1B09
          (445, 445, 6629, 6629),
         16#0A#           =>  --  1B0A
          (0, 0, 6630, 6630),
         16#0B#           =>  --  1B0B
          (446, 446, 6631, 6631),
         16#0C#           =>  --  1B0C
          (0, 0, 6632, 6632),
         16#0D#           =>  --  1B0D
          (447, 447, 6633, 6633),
         16#0E#           =>  --  1B0E
          (0, 0, 6634, 6634),
         16#0F#           =>  --  1B0F
          (0, 0, 6635, 6635),
         16#10#           =>  --  1B10
          (0, 0, 6636, 6636),
         16#11#           =>  --  1B11
          (448, 448, 6637, 6637),
         16#12#           =>  --  1B12
          (0, 0, 6638, 6638),
         16#13#           =>  --  1B13
          (0, 0, 6639, 6639),
         16#14#           =>  --  1B14
          (0, 0, 6640, 6640),
         16#15#           =>  --  1B15
          (0, 0, 6641, 6641),
         16#16#           =>  --  1B16
          (0, 0, 6642, 6642),
         16#17#           =>  --  1B17
          (0, 0, 6643, 6643),
         16#18#           =>  --  1B18
          (0, 0, 6644, 6644),
         16#19#           =>  --  1B19
          (0, 0, 6645, 6645),
         16#1A#           =>  --  1B1A
          (0, 0, 6646, 6646),
         16#1B#           =>  --  1B1B
          (0, 0, 6647, 6647),
         16#1C#           =>  --  1B1C
          (0, 0, 6648, 6648),
         16#1D#           =>  --  1B1D
          (0, 0, 6649, 6649),
         16#1E#           =>  --  1B1E
          (0, 0, 6650, 6650),
         16#1F#           =>  --  1B1F
          (0, 0, 6651, 6651),
         16#20#           =>  --  1B20
          (0, 0, 6652, 6652),
         16#21#           =>  --  1B21
          (0, 0, 6653, 6653),
         16#22#           =>  --  1B22
          (0, 0, 6654, 6654),
         16#23#           =>  --  1B23
          (0, 0, 6655, 6655),
         16#24#           =>  --  1B24
          (0, 0, 6656, 6656),
         16#25#           =>  --  1B25
          (0, 0, 6657, 6657),
         16#26#           =>  --  1B26
          (0, 0, 6658, 6658),
         16#27#           =>  --  1B27
          (0, 0, 6659, 6659),
         16#28#           =>  --  1B28
          (0, 0, 6660, 6660),
         16#29#           =>  --  1B29
          (0, 0, 6661, 6661),
         16#2A#           =>  --  1B2A
          (0, 0, 6662, 6662),
         16#2B#           =>  --  1B2B
          (0, 0, 6663, 6663),
         16#2C#           =>  --  1B2C
          (0, 0, 6664, 6664),
         16#2D#           =>  --  1B2D
          (0, 0, 6665, 6665),
         16#2E#           =>  --  1B2E
          (0, 0, 6666, 6666),
         16#2F#           =>  --  1B2F
          (0, 0, 6667, 6667),
         16#30#           =>  --  1B30
          (0, 0, 6668, 6668),
         16#31#           =>  --  1B31
          (0, 0, 6669, 6669),
         16#32#           =>  --  1B32
          (0, 0, 6670, 6670),
         16#33#           =>  --  1B33
          (0, 0, 6671, 6671),
         16#34#           =>  --  1B34
          (0, 0, 2283, 2283),
         16#35#           =>  --  1B35
          (0, 0, 6672, 6672),
         16#36#           =>  --  1B36
          (0, 0, 6673, 6673),
         16#37#           =>  --  1B37
          (0, 0, 6674, 6674),
         16#38#           =>  --  1B38
          (0, 0, 6675, 6675),
         16#39#           =>  --  1B39
          (0, 0, 6676, 6676),
         16#3A#           =>  --  1B3A
          (449, 449, 6677, 6677),
         16#3B#           =>  --  1B3B
          (0, 0, 6678, 6678),
         16#3C#           =>  --  1B3C
          (450, 450, 6679, 6679),
         16#3D#           =>  --  1B3D
          (0, 0, 6680, 6680),
         16#3E#           =>  --  1B3E
          (451, 451, 6681, 6681),
         16#3F#           =>  --  1B3F
          (452, 452, 6683, 6683),
         16#40#           =>  --  1B40
          (0, 0, 6682, 6682),
         16#41#           =>  --  1B41
          (0, 0, 6684, 6684),
         16#42#           =>  --  1B42
          (453, 453, 6685, 6685),
         16#43#           =>  --  1B43
          (0, 0, 6686, 6686),
         16#44#           =>  --  1B44
          (0, 0, 6687, 6687),
         16#45#           =>  --  1B45
          (0, 0, 6688, 6688),
         16#46#           =>  --  1B46
          (0, 0, 6689, 6689),
         16#47#           =>  --  1B47
          (0, 0, 6690, 6690),
         16#48#           =>  --  1B48
          (0, 0, 6691, 6691),
         16#49#           =>  --  1B49
          (0, 0, 6692, 6692),
         16#4A#           =>  --  1B4A
          (0, 0, 6693, 6693),
         16#4B#           =>  --  1B4B
          (0, 0, 6694, 6694),
         16#50#           =>  --  1B50
          (0, 0, 23, 23),
         16#51#           =>  --  1B51
          (0, 0, 24, 24),
         16#52#           =>  --  1B52
          (0, 0, 25, 25),
         16#53#           =>  --  1B53
          (0, 0, 26, 26),
         16#54#           =>  --  1B54
          (0, 0, 27, 27),
         16#55#           =>  --  1B55
          (0, 0, 28, 28),
         16#56#           =>  --  1B56
          (0, 0, 29, 29),
         16#57#           =>  --  1B57
          (0, 0, 30, 30),
         16#58#           =>  --  1B58
          (0, 0, 31, 31),
         16#59#           =>  --  1B59
          (0, 0, 32, 32),
         16#5A#           =>  --  1B5A
          (0, 0, 6695, 6695),
         16#5B#           =>  --  1B5B
          (0, 0, 6696, 6696),
         16#5C#           =>  --  1B5C
          (0, 0, 6697, 6697),
         16#5D#           =>  --  1B5D
          (0, 0, 6698, 6698),
         16#5E#           =>  --  1B5E
          (0, 0, 6699, 6699),
         16#5F#           =>  --  1B5F
          (0, 0, 6700, 6700),
         16#60#           =>  --  1B60
          (0, 0, 6701, 6701),
         16#61#           =>  --  1B61
          (0, 0, 6702, 6702),
         16#62#           =>  --  1B62
          (0, 0, 6703, 6703),
         16#63#           =>  --  1B63
          (0, 0, 6704, 6704),
         16#64#           =>  --  1B64
          (0, 0, 6705, 6705),
         16#65#           =>  --  1B65
          (0, 0, 6706, 6706),
         16#66#           =>  --  1B66
          (0, 0, 6707, 6707),
         16#67#           =>  --  1B67
          (0, 0, 6708, 6708),
         16#68#           =>  --  1B68
          (0, 0, 6709, 6709),
         16#69#           =>  --  1B69
          (0, 0, 6710, 6710),
         16#6A#           =>  --  1B6A
          (0, 0, 6711, 6711),
         16#6B# .. 16#73# =>  --  1B6B .. 1B73
          (0, 0, 1, 1),
         16#74#           =>  --  1B74
          (0, 0, 6712, 6712),
         16#75#           =>  --  1B75
          (0, 0, 6713, 6713),
         16#76#           =>  --  1B76
          (0, 0, 6714, 6714),
         16#77#           =>  --  1B77
          (0, 0, 6715, 6715),
         16#78#           =>  --  1B78
          (0, 0, 6716, 6716),
         16#79#           =>  --  1B79
          (0, 0, 6717, 6717),
         16#7A#           =>  --  1B7A
          (0, 0, 6718, 6718),
         16#7B#           =>  --  1B7B
          (0, 0, 6719, 6719),
         16#7C#           =>  --  1B7C
          (0, 0, 6720, 6720),
         16#80#           =>  --  1B80
          (0, 0, 2243, 2243),
         16#81#           =>  --  1B81
          (0, 0, 6721, 6721),
         16#82#           =>  --  1B82
          (0, 0, 2244, 2244),
         16#83#           =>  --  1B83
          (0, 0, 6722, 6722),
         16#84#           =>  --  1B84
          (0, 0, 6723, 6723),
         16#85#           =>  --  1B85
          (0, 0, 6724, 6724),
         16#86#           =>  --  1B86
          (0, 0, 6725, 6725),
         16#87#           =>  --  1B87
          (0, 0, 6726, 6726),
         16#88#           =>  --  1B88
          (0, 0, 6727, 6727),
         16#89#           =>  --  1B89
          (0, 0, 6728, 6728),
         16#8A#           =>  --  1B8A
          (0, 0, 6729, 6729),
         16#8B#           =>  --  1B8B
          (0, 0, 6730, 6730),
         16#8C#           =>  --  1B8C
          (0, 0, 6731, 6731),
         16#8D#           =>  --  1B8D
          (0, 0, 6732, 6732),
         16#8E#           =>  --  1B8E
          (0, 0, 6733, 6733),
         16#8F#           =>  --  1B8F
          (0, 0, 6734, 6734),
         16#90#           =>  --  1B90
          (0, 0, 6735, 6735),
         16#91#           =>  --  1B91
          (0, 0, 6736, 6736),
         16#92#           =>  --  1B92
          (0, 0, 6737, 6737),
         16#93#           =>  --  1B93
          (0, 0, 6738, 6738),
         16#94#           =>  --  1B94
          (0, 0, 6739, 6739),
         16#95#           =>  --  1B95
          (0, 0, 6740, 6740),
         16#96#           =>  --  1B96
          (0, 0, 6741, 6741),
         16#97#           =>  --  1B97
          (0, 0, 6742, 6742),
         16#98#           =>  --  1B98
          (0, 0, 6743, 6743),
         16#99#           =>  --  1B99
          (0, 0, 6744, 6744),
         16#9A#           =>  --  1B9A
          (0, 0, 6745, 6745),
         16#9B#           =>  --  1B9B
          (0, 0, 6746, 6746),
         16#9C#           =>  --  1B9C
          (0, 0, 6747, 6747),
         16#9D#           =>  --  1B9D
          (0, 0, 6748, 6748),
         16#9E#           =>  --  1B9E
          (0, 0, 6749, 6749),
         16#9F#           =>  --  1B9F
          (0, 0, 6750, 6750),
         16#A0#           =>  --  1BA0
          (0, 0, 6751, 6751),
         16#A1#           =>  --  1BA1
          (0, 0, 6752, 6752),
         16#A2#           =>  --  1BA2
          (0, 0, 6753, 6753),
         16#A3#           =>  --  1BA3
          (0, 0, 6754, 6754),
         16#A4#           =>  --  1BA4
          (0, 0, 6755, 6755),
         16#A5#           =>  --  1BA5
          (0, 0, 6756, 6756),
         16#A6#           =>  --  1BA6
          (0, 0, 6757, 6757),
         16#A7#           =>  --  1BA7
          (0, 0, 6758, 6758),
         16#A8#           =>  --  1BA8
          (0, 0, 6759, 6759),
         16#A9#           =>  --  1BA9
          (0, 0, 6760, 6760),
         16#AA#           =>  --  1BAA
          (0, 0, 6761, 6761),
         16#AB#           =>  --  1BAB
          (0, 0, 6762, 6762),
         16#AC#           =>  --  1BAC
          (0, 0, 6763, 6763),
         16#AD#           =>  --  1BAD
          (0, 0, 6764, 6764),
         16#AE#           =>  --  1BAE
          (0, 0, 6765, 6765),
         16#AF#           =>  --  1BAF
          (0, 0, 6766, 6766),
         16#B0#           =>  --  1BB0
          (0, 0, 23, 23),
         16#B1#           =>  --  1BB1
          (0, 0, 24, 24),
         16#B2#           =>  --  1BB2
          (0, 0, 25, 25),
         16#B3#           =>  --  1BB3
          (0, 0, 26, 26),
         16#B4#           =>  --  1BB4
          (0, 0, 27, 27),
         16#B5#           =>  --  1BB5
          (0, 0, 28, 28),
         16#B6#           =>  --  1BB6
          (0, 0, 29, 29),
         16#B7#           =>  --  1BB7
          (0, 0, 30, 30),
         16#B8#           =>  --  1BB8
          (0, 0, 31, 31),
         16#B9#           =>  --  1BB9
          (0, 0, 32, 32),
         16#BA#           =>  --  1BBA
          (0, 0, 6767, 6767),
         16#BB#           =>  --  1BBB
          (0, 0, 6768, 6768),
         16#BC#           =>  --  1BBC
          (0, 0, 6769, 6769),
         16#BD#           =>  --  1BBD
          (0, 0, 6770, 6770),
         16#BE#           =>  --  1BBE
          (0, 0, 6771, 6771),
         16#BF#           =>  --  1BBF
          (0, 0, 6772, 6772),
         16#C0#           =>  --  1BC0
          (0, 0, 6773, 6773),
         16#C1#           =>  --  1BC1
          (0, 0, 6774, 6774),
         16#C2#           =>  --  1BC2
          (0, 0, 6775, 6775),
         16#C3# .. 16#C4# =>  --  1BC3 .. 1BC4
          (0, 0, 6776, 6776),
         16#C5#           =>  --  1BC5
          (0, 0, 6777, 6777),
         16#C6#           =>  --  1BC6
          (0, 0, 6778, 6778),
         16#C7#           =>  --  1BC7
          (0, 0, 6779, 6779),
         16#C8#           =>  --  1BC8
          (0, 0, 6780, 6780),
         16#C9#           =>  --  1BC9
          (0, 0, 6781, 6781),
         16#CA#           =>  --  1BCA
          (0, 0, 6782, 6782),
         16#CB#           =>  --  1BCB
          (0, 0, 6783, 6783),
         16#CC# .. 16#CD# =>  --  1BCC .. 1BCD
          (0, 0, 6784, 6784),
         16#CE#           =>  --  1BCE
          (0, 0, 6785, 6785),
         16#CF#           =>  --  1BCF
          (0, 0, 6786, 6786),
         16#D0#           =>  --  1BD0
          (0, 0, 6787, 6787),
         16#D1#           =>  --  1BD1
          (0, 0, 6788, 6788),
         16#D2#           =>  --  1BD2
          (0, 0, 6789, 6789),
         16#D3#           =>  --  1BD3
          (0, 0, 6790, 6790),
         16#D4#           =>  --  1BD4
          (0, 0, 6791, 6791),
         16#D5#           =>  --  1BD5
          (0, 0, 6792, 6792),
         16#D6#           =>  --  1BD6
          (0, 0, 6793, 6793),
         16#D7#           =>  --  1BD7
          (0, 0, 6794, 6794),
         16#D8#           =>  --  1BD8
          (0, 0, 6795, 6795),
         16#D9# .. 16#DA# =>  --  1BD9 .. 1BDA
          (0, 0, 6796, 6796),
         16#DB#           =>  --  1BDB
          (0, 0, 6797, 6797),
         16#DC#           =>  --  1BDC
          (0, 0, 6798, 6798),
         16#DD#           =>  --  1BDD
          (0, 0, 6799, 6799),
         16#DE#           =>  --  1BDE
          (0, 0, 6800, 6800),
         16#DF#           =>  --  1BDF
          (0, 0, 6801, 6801),
         16#E0#           =>  --  1BE0
          (0, 0, 6802, 6802),
         16#E1#           =>  --  1BE1
          (0, 0, 6803, 6803),
         16#E2#           =>  --  1BE2
          (0, 0, 6804, 6804),
         16#E3#           =>  --  1BE3
          (0, 0, 6805, 6805),
         16#E4#           =>  --  1BE4
          (0, 0, 6806, 6806),
         16#E5#           =>  --  1BE5
          (0, 0, 6807, 6807),
         16#E6#           =>  --  1BE6
          (0, 0, 2283, 2283),
         16#E7#           =>  --  1BE7
          (0, 0, 6808, 6808),
         16#E8#           =>  --  1BE8
          (0, 0, 6809, 6809),
         16#E9#           =>  --  1BE9
          (0, 0, 6810, 6810),
         16#EA#           =>  --  1BEA
          (0, 0, 6811, 6811),
         16#EB#           =>  --  1BEB
          (0, 0, 6812, 6812),
         16#EC#           =>  --  1BEC
          (0, 0, 6813, 6813),
         16#ED#           =>  --  1BED
          (0, 0, 6814, 6814),
         16#EE#           =>  --  1BEE
          (0, 0, 6815, 6815),
         16#EF#           =>  --  1BEF
          (0, 0, 6816, 6816),
         16#F0#           =>  --  1BF0
          (0, 0, 6817, 6817),
         16#F1#           =>  --  1BF1
          (0, 0, 6818, 6818),
         16#F2#           =>  --  1BF2
          (0, 0, 6819, 6819),
         16#F3#           =>  --  1BF3
          (0, 0, 6820, 6820),
         16#FC#           =>  --  1BFC
          (0, 0, 6821, 6821),
         16#FD#           =>  --  1BFD
          (0, 0, 6822, 6822),
         16#FE#           =>  --  1BFE
          (0, 0, 6823, 6823),
         16#FF#           =>  --  1BFF
          (0, 0, 6824, 6824),
         others           =>
          (0, 0, 0, 0));

   Group_001C : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  1C00
          (0, 0, 6825, 6825),
         16#01#           =>  --  1C01
          (0, 0, 6826, 6826),
         16#02#           =>  --  1C02
          (0, 0, 6827, 6827),
         16#03#           =>  --  1C03
          (0, 0, 6828, 6828),
         16#04#           =>  --  1C04
          (0, 0, 6829, 6829),
         16#05#           =>  --  1C05
          (0, 0, 6830, 6830),
         16#06#           =>  --  1C06
          (0, 0, 6831, 6831),
         16#07#           =>  --  1C07
          (0, 0, 6832, 6832),
         16#08#           =>  --  1C08
          (0, 0, 6833, 6833),
         16#09#           =>  --  1C09
          (0, 0, 6834, 6834),
         16#0A#           =>  --  1C0A
          (0, 0, 6835, 6835),
         16#0B#           =>  --  1C0B
          (0, 0, 6836, 6836),
         16#0C#           =>  --  1C0C
          (0, 0, 6837, 6837),
         16#0D#           =>  --  1C0D
          (0, 0, 6838, 6838),
         16#0E#           =>  --  1C0E
          (0, 0, 6839, 6839),
         16#0F#           =>  --  1C0F
          (0, 0, 6840, 6840),
         16#10#           =>  --  1C10
          (0, 0, 6841, 6841),
         16#11#           =>  --  1C11
          (0, 0, 6842, 6842),
         16#12#           =>  --  1C12
          (0, 0, 6843, 6843),
         16#13#           =>  --  1C13
          (0, 0, 6844, 6844),
         16#14#           =>  --  1C14
          (0, 0, 6845, 6845),
         16#15#           =>  --  1C15
          (0, 0, 6846, 6846),
         16#16#           =>  --  1C16
          (0, 0, 6847, 6847),
         16#17#           =>  --  1C17
          (0, 0, 6848, 6848),
         16#18#           =>  --  1C18
          (0, 0, 6849, 6849),
         16#19#           =>  --  1C19
          (0, 0, 6850, 6850),
         16#1A#           =>  --  1C1A
          (0, 0, 6851, 6851),
         16#1B#           =>  --  1C1B
          (0, 0, 6852, 6852),
         16#1C#           =>  --  1C1C
          (0, 0, 6853, 6853),
         16#1D#           =>  --  1C1D
          (0, 0, 6854, 6854),
         16#1E#           =>  --  1C1E
          (0, 0, 6855, 6855),
         16#1F#           =>  --  1C1F
          (0, 0, 6856, 6856),
         16#20#           =>  --  1C20
          (0, 0, 6857, 6857),
         16#21#           =>  --  1C21
          (0, 0, 6858, 6858),
         16#22#           =>  --  1C22
          (0, 0, 6859, 6859),
         16#23#           =>  --  1C23
          (0, 0, 6860, 6860),
         16#24#           =>  --  1C24
          (0, 0, 6861, 6861),
         16#25#           =>  --  1C25
          (0, 0, 6862, 6862),
         16#26#           =>  --  1C26
          (0, 0, 6863, 6863),
         16#27#           =>  --  1C27
          (0, 0, 6864, 6864),
         16#28#           =>  --  1C28
          (0, 0, 6865, 6865),
         16#29#           =>  --  1C29
          (0, 0, 6866, 6866),
         16#2A#           =>  --  1C2A
          (0, 0, 6867, 6867),
         16#2B#           =>  --  1C2B
          (0, 0, 6868, 6868),
         16#2C#           =>  --  1C2C
          (0, 0, 6869, 6869),
         16#2D#           =>  --  1C2D
          (0, 0, 6870, 6870),
         16#2E#           =>  --  1C2E
          (0, 0, 6871, 6871),
         16#2F#           =>  --  1C2F
          (0, 0, 6872, 6872),
         16#30#           =>  --  1C30
          (0, 0, 6873, 6873),
         16#31#           =>  --  1C31
          (0, 0, 6874, 6874),
         16#32#           =>  --  1C32
          (0, 0, 6875, 6875),
         16#33#           =>  --  1C33
          (0, 0, 6876, 6876),
         16#34#           =>  --  1C34
          (0, 0, 6877, 6877),
         16#35#           =>  --  1C35
          (0, 0, 6878, 6878),
         16#36#           =>  --  1C36
          (0, 0, 6879, 6879),
         16#37#           =>  --  1C37
          (0, 0, 2283, 2283),
         16#3B#           =>  --  1C3B
          (0, 0, 6880, 6880),
         16#3C#           =>  --  1C3C
          (0, 0, 6881, 6881),
         16#3D#           =>  --  1C3D
          (0, 0, 6882, 6882),
         16#3E#           =>  --  1C3E
          (0, 0, 6883, 6883),
         16#3F#           =>  --  1C3F
          (0, 0, 6884, 6884),
         16#40#           =>  --  1C40
          (0, 0, 23, 23),
         16#41#           =>  --  1C41
          (0, 0, 24, 24),
         16#42#           =>  --  1C42
          (0, 0, 25, 25),
         16#43#           =>  --  1C43
          (0, 0, 26, 26),
         16#44#           =>  --  1C44
          (0, 0, 27, 27),
         16#45#           =>  --  1C45
          (0, 0, 28, 28),
         16#46#           =>  --  1C46
          (0, 0, 29, 29),
         16#47#           =>  --  1C47
          (0, 0, 30, 30),
         16#48#           =>  --  1C48
          (0, 0, 31, 31),
         16#49#           =>  --  1C49
          (0, 0, 32, 32),
         16#4D#           =>  --  1C4D
          (0, 0, 6885, 6885),
         16#4E#           =>  --  1C4E
          (0, 0, 6886, 6886),
         16#4F#           =>  --  1C4F
          (0, 0, 6887, 6887),
         16#50#           =>  --  1C50
          (0, 0, 23, 23),
         16#51#           =>  --  1C51
          (0, 0, 24, 24),
         16#52#           =>  --  1C52
          (0, 0, 25, 25),
         16#53#           =>  --  1C53
          (0, 0, 26, 26),
         16#54#           =>  --  1C54
          (0, 0, 27, 27),
         16#55#           =>  --  1C55
          (0, 0, 28, 28),
         16#56#           =>  --  1C56
          (0, 0, 29, 29),
         16#57#           =>  --  1C57
          (0, 0, 30, 30),
         16#58#           =>  --  1C58
          (0, 0, 31, 31),
         16#59#           =>  --  1C59
          (0, 0, 32, 32),
         16#5A#           =>  --  1C5A
          (0, 0, 6888, 6888),
         16#5B#           =>  --  1C5B
          (0, 0, 6889, 6889),
         16#5C#           =>  --  1C5C
          (0, 0, 6890, 6890),
         16#5D#           =>  --  1C5D
          (0, 0, 6891, 6891),
         16#5E#           =>  --  1C5E
          (0, 0, 6892, 6892),
         16#5F#           =>  --  1C5F
          (0, 0, 6893, 6893),
         16#60#           =>  --  1C60
          (0, 0, 6894, 6894),
         16#61#           =>  --  1C61
          (0, 0, 6895, 6895),
         16#62#           =>  --  1C62
          (0, 0, 6896, 6896),
         16#63#           =>  --  1C63
          (0, 0, 6897, 6897),
         16#64#           =>  --  1C64
          (0, 0, 6898, 6898),
         16#65#           =>  --  1C65
          (0, 0, 6899, 6899),
         16#66#           =>  --  1C66
          (0, 0, 6900, 6900),
         16#67#           =>  --  1C67
          (0, 0, 6901, 6901),
         16#68#           =>  --  1C68
          (0, 0, 6902, 6902),
         16#69#           =>  --  1C69
          (0, 0, 6903, 6903),
         16#6A#           =>  --  1C6A
          (0, 0, 6904, 6904),
         16#6B#           =>  --  1C6B
          (0, 0, 6905, 6905),
         16#6C#           =>  --  1C6C
          (0, 0, 6906, 6906),
         16#6D#           =>  --  1C6D
          (0, 0, 6907, 6907),
         16#6E#           =>  --  1C6E
          (0, 0, 6908, 6908),
         16#6F#           =>  --  1C6F
          (0, 0, 6909, 6909),
         16#70#           =>  --  1C70
          (0, 0, 6910, 6910),
         16#71#           =>  --  1C71
          (0, 0, 6911, 6911),
         16#72#           =>  --  1C72
          (0, 0, 6912, 6912),
         16#73#           =>  --  1C73
          (0, 0, 6913, 6913),
         16#74#           =>  --  1C74
          (0, 0, 6914, 6914),
         16#75#           =>  --  1C75
          (0, 0, 6915, 6915),
         16#76#           =>  --  1C76
          (0, 0, 6916, 6916),
         16#77#           =>  --  1C77
          (0, 0, 6917, 6917),
         16#78#           =>  --  1C78
          (0, 0, 6918, 6918),
         16#79#           =>  --  1C79
          (0, 0, 6919, 6919),
         16#7A#           =>  --  1C7A
          (0, 0, 6920, 6920),
         16#7B#           =>  --  1C7B
          (0, 0, 6921, 6921),
         16#7C#           =>  --  1C7C
          (0, 0, 6922, 6922),
         16#7D#           =>  --  1C7D
          (0, 0, 6923, 6923),
         16#7E#           =>  --  1C7E
          (0, 0, 6924, 6924),
         16#7F#           =>  --  1C7F
          (0, 0, 6925, 6925),
         16#C0#           =>  --  1CC0
          (0, 0, 6926, 6926),
         16#C1#           =>  --  1CC1
          (0, 0, 6927, 6927),
         16#C2#           =>  --  1CC2
          (0, 0, 6928, 6928),
         16#C3#           =>  --  1CC3
          (0, 0, 6929, 6929),
         16#C4#           =>  --  1CC4
          (0, 0, 6930, 6930),
         16#C5#           =>  --  1CC5
          (0, 0, 6931, 6931),
         16#C6#           =>  --  1CC6
          (0, 0, 6932, 6932),
         16#C7#           =>  --  1CC7
          (0, 0, 6933, 6933),
         16#D0# .. 16#E8# =>  --  1CD0 .. 1CE8
          (0, 0, 1, 1),
         16#E9#           =>  --  1CE9
          (0, 0, 6934, 6934),
         16#EA# .. 16#EC# =>  --  1CEA .. 1CEC
          (0, 0, 6935, 6935),
         16#ED#           =>  --  1CED
          (0, 0, 2243, 2243),
         16#EE# .. 16#F1# =>  --  1CEE .. 1CF1
          (0, 0, 6935, 6935),
         16#F2# .. 16#F3# =>  --  1CF2 .. 1CF3
          (0, 0, 2244, 2244),
         16#F4#           =>  --  1CF4
          (0, 0, 1, 1),
         16#F5#           =>  --  1CF5
          (0, 0, 6936, 6936),
         16#F6#           =>  --  1CF6
          (0, 0, 6937, 6937),
         16#F8# .. 16#F9# =>  --  1CF8 .. 1CF9
          (0, 0, 1, 1),
         others           =>
          (0, 0, 0, 0));

   Group_001D : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  1D00
          (0, 0, 6938, 6938),
         16#01#           =>  --  1D01
          (0, 0, 6939, 6939),
         16#02#           =>  --  1D02
          (0, 0, 6940, 6940),
         16#03#           =>  --  1D03
          (0, 0, 6941, 6941),
         16#04#           =>  --  1D04
          (0, 0, 6942, 6942),
         16#05#           =>  --  1D05
          (0, 0, 6943, 6943),
         16#06#           =>  --  1D06
          (0, 0, 6944, 6944),
         16#07#           =>  --  1D07
          (0, 0, 6945, 6945),
         16#08#           =>  --  1D08
          (0, 0, 6946, 6946),
         16#09#           =>  --  1D09
          (0, 0, 6947, 6947),
         16#0A#           =>  --  1D0A
          (0, 0, 6948, 6948),
         16#0B#           =>  --  1D0B
          (0, 0, 6949, 6949),
         16#0C#           =>  --  1D0C
          (0, 0, 6950, 6950),
         16#0D#           =>  --  1D0D
          (0, 0, 6951, 6951),
         16#0E#           =>  --  1D0E
          (0, 0, 6952, 6952),
         16#0F#           =>  --  1D0F
          (0, 0, 6953, 6953),
         16#10#           =>  --  1D10
          (0, 0, 6954, 6954),
         16#11#           =>  --  1D11
          (0, 0, 6955, 6955),
         16#12#           =>  --  1D12
          (0, 0, 6956, 6956),
         16#13#           =>  --  1D13
          (0, 0, 6957, 6957),
         16#14#           =>  --  1D14
          (0, 0, 6958, 6958),
         16#15#           =>  --  1D15
          (0, 0, 6959, 6959),
         16#16#           =>  --  1D16
          (0, 0, 6960, 6960),
         16#17#           =>  --  1D17
          (0, 0, 6961, 6961),
         16#18#           =>  --  1D18
          (0, 0, 6962, 6962),
         16#19#           =>  --  1D19
          (0, 0, 6963, 6963),
         16#1A#           =>  --  1D1A
          (0, 0, 6964, 6964),
         16#1B#           =>  --  1D1B
          (0, 0, 6965, 6965),
         16#1C#           =>  --  1D1C
          (0, 0, 6966, 6966),
         16#1D#           =>  --  1D1D
          (0, 0, 6967, 6967),
         16#1E#           =>  --  1D1E
          (0, 0, 6968, 6968),
         16#1F#           =>  --  1D1F
          (0, 0, 6969, 6969),
         16#20#           =>  --  1D20
          (0, 0, 6970, 6970),
         16#21#           =>  --  1D21
          (0, 0, 6971, 6971),
         16#22#           =>  --  1D22
          (0, 0, 6972, 6972),
         16#23#           =>  --  1D23
          (0, 0, 6973, 6973),
         16#24#           =>  --  1D24
          (0, 0, 6974, 6974),
         16#25#           =>  --  1D25
          (0, 0, 6975, 6975),
         16#26#           =>  --  1D26
          (0, 0, 6976, 6976),
         16#27#           =>  --  1D27
          (0, 0, 6977, 6977),
         16#28#           =>  --  1D28
          (0, 0, 6978, 6978),
         16#29#           =>  --  1D29
          (0, 0, 6979, 6979),
         16#2A#           =>  --  1D2A
          (0, 0, 6980, 6980),
         16#2B#           =>  --  1D2B
          (0, 0, 6981, 6981),
         16#2C#           =>  --  1D2C
          (0, 0, 6982, 6982),
         16#2D#           =>  --  1D2D
          (0, 0, 6983, 6985),
         16#2E#           =>  --  1D2E
          (0, 0, 6986, 6986),
         16#2F#           =>  --  1D2F
          (0, 0, 6987, 6987),
         16#30#           =>  --  1D30
          (0, 0, 6988, 6988),
         16#31#           =>  --  1D31
          (0, 0, 6989, 6989),
         16#32#           =>  --  1D32
          (0, 0, 6990, 6990),
         16#33#           =>  --  1D33
          (0, 0, 6991, 6991),
         16#34#           =>  --  1D34
          (0, 0, 6992, 6992),
         16#35#           =>  --  1D35
          (0, 0, 6993, 6993),
         16#36#           =>  --  1D36
          (0, 0, 6994, 6994),
         16#37#           =>  --  1D37
          (0, 0, 6995, 6995),
         16#38#           =>  --  1D38
          (0, 0, 6996, 6996),
         16#39#           =>  --  1D39
          (0, 0, 6997, 6997),
         16#3A#           =>  --  1D3A
          (0, 0, 6998, 6998),
         16#3B#           =>  --  1D3B
          (0, 0, 6999, 6999),
         16#3C#           =>  --  1D3C
          (0, 0, 7000, 7000),
         16#3D#           =>  --  1D3D
          (0, 0, 7001, 7001),
         16#3E#           =>  --  1D3E
          (0, 0, 7002, 7002),
         16#3F#           =>  --  1D3F
          (0, 0, 7003, 7003),
         16#40#           =>  --  1D40
          (0, 0, 7004, 7004),
         16#41#           =>  --  1D41
          (0, 0, 7005, 7005),
         16#42#           =>  --  1D42
          (0, 0, 7006, 7006),
         16#43#           =>  --  1D43
          (0, 0, 117, 117),
         16#44#           =>  --  1D44
          (0, 0, 7007, 7007),
         16#45#           =>  --  1D45
          (0, 0, 7008, 7008),
         16#46#           =>  --  1D46
          (0, 0, 7009, 7009),
         16#47#           =>  --  1D47
          (0, 0, 7010, 7010),
         16#48#           =>  --  1D48
          (0, 0, 7011, 7011),
         16#49#           =>  --  1D49
          (0, 0, 6985, 6985),
         16#4A#           =>  --  1D4A
          (0, 0, 7012, 7012),
         16#4B#           =>  --  1D4B
          (0, 0, 7013, 7013),
         16#4C#           =>  --  1D4C
          (0, 0, 7014, 7014),
         16#4D#           =>  --  1D4D
          (0, 0, 7015, 7015),
         16#4E#           =>  --  1D4E
          (0, 0, 7016, 7016),
         16#4F#           =>  --  1D4F
          (0, 0, 7017, 7017),
         16#50#           =>  --  1D50
          (0, 0, 7018, 7018),
         16#51#           =>  --  1D51
          (0, 0, 7019, 7019),
         16#52#           =>  --  1D52
          (0, 0, 132, 132),
         16#53#           =>  --  1D53
          (0, 0, 7020, 7020),
         16#54#           =>  --  1D54
          (0, 0, 7021, 7021),
         16#55#           =>  --  1D55
          (0, 0, 7022, 7022),
         16#56#           =>  --  1D56
          (0, 0, 7023, 7023),
         16#57#           =>  --  1D57
          (0, 0, 7024, 7024),
         16#58#           =>  --  1D58
          (0, 0, 7025, 7025),
         16#59#           =>  --  1D59
          (0, 0, 7026, 7026),
         16#5A#           =>  --  1D5A
          (0, 0, 7027, 7027),
         16#5B#           =>  --  1D5B
          (0, 0, 7028, 7028),
         16#5C#           =>  --  1D5C
          (0, 0, 7029, 7029),
         16#5D#           =>  --  1D5D
          (0, 0, 7030, 7030),
         16#5E#           =>  --  1D5E
          (0, 0, 7031, 7031),
         16#5F#           =>  --  1D5F
          (0, 0, 7032, 7032),
         16#60#           =>  --  1D60
          (0, 0, 7033, 7033),
         16#61#           =>  --  1D61
          (0, 0, 7034, 7034),
         16#62#           =>  --  1D62
          (0, 0, 7035, 7035),
         16#63#           =>  --  1D63
          (0, 0, 7036, 7036),
         16#64#           =>  --  1D64
          (0, 0, 7037, 7037),
         16#65#           =>  --  1D65
          (0, 0, 7038, 7038),
         16#66#           =>  --  1D66
          (0, 0, 7039, 7039),
         16#67#           =>  --  1D67
          (0, 0, 7040, 7040),
         16#68#           =>  --  1D68
          (0, 0, 7041, 7041),
         16#69#           =>  --  1D69
          (0, 0, 7042, 7042),
         16#6A#           =>  --  1D6A
          (0, 0, 7043, 7043),
         16#6B#           =>  --  1D6B
          (0, 0, 7044, 7044),
         16#6C#           =>  --  1D6C
          (0, 0, 7045, 7045),
         16#6D#           =>  --  1D6D
          (0, 0, 7046, 7046),
         16#6E#           =>  --  1D6E
          (0, 0, 7047, 7047),
         16#6F#           =>  --  1D6F
          (0, 0, 7048, 7048),
         16#70#           =>  --  1D70
          (0, 0, 7049, 7049),
         16#71#           =>  --  1D71
          (0, 0, 7050, 7050),
         16#72#           =>  --  1D72
          (0, 0, 7051, 7051),
         16#73#           =>  --  1D73
          (0, 0, 7052, 7052),
         16#74#           =>  --  1D74
          (0, 0, 7053, 7053),
         16#75#           =>  --  1D75
          (0, 0, 7054, 7054),
         16#76#           =>  --  1D76
          (0, 0, 7055, 7055),
         16#77#           =>  --  1D77
          (0, 0, 7056, 7056),
         16#78#           =>  --  1D78
          (0, 0, 7057, 7057),
         16#79#           =>  --  1D79
          (0, 0, 7058, 7059),
         16#7A#           =>  --  1D7A
          (0, 0, 7060, 7062),
         16#7B#           =>  --  1D7B
          (0, 0, 7063, 7063),
         16#7C#           =>  --  1D7C
          (0, 0, 7064, 7064),
         16#7D#           =>  --  1D7D
          (0, 0, 7065, 7065),
         16#7E#           =>  --  1D7E
          (0, 0, 7066, 7066),
         16#7F#           =>  --  1D7F
          (0, 0, 7067, 7067),
         16#80#           =>  --  1D80
          (0, 0, 7068, 7068),
         16#81#           =>  --  1D81
          (0, 0, 7069, 7069),
         16#82#           =>  --  1D82
          (0, 0, 7070, 7070),
         16#83#           =>  --  1D83
          (0, 0, 7071, 7071),
         16#84#           =>  --  1D84
          (0, 0, 7072, 7072),
         16#85#           =>  --  1D85
          (0, 0, 7073, 7073),
         16#86#           =>  --  1D86
          (0, 0, 7074, 7074),
         16#87#           =>  --  1D87
          (0, 0, 7075, 7075),
         16#88#           =>  --  1D88
          (0, 0, 7076, 7076),
         16#89#           =>  --  1D89
          (0, 0, 7077, 7077),
         16#8A#           =>  --  1D8A
          (0, 0, 7078, 7078),
         16#8B#           =>  --  1D8B
          (0, 0, 7079, 7079),
         16#8C#           =>  --  1D8C
          (0, 0, 7080, 7080),
         16#8D#           =>  --  1D8D
          (0, 0, 7081, 7081),
         16#8E#           =>  --  1D8E
          (0, 0, 7082, 7082),
         16#8F#           =>  --  1D8F
          (0, 0, 7083, 7083),
         16#90#           =>  --  1D90
          (0, 0, 7084, 7084),
         16#91#           =>  --  1D91
          (0, 0, 7085, 7085),
         16#92#           =>  --  1D92
          (0, 0, 7086, 7086),
         16#93#           =>  --  1D93
          (0, 0, 7087, 7087),
         16#94#           =>  --  1D94
          (0, 0, 7088, 7088),
         16#95#           =>  --  1D95
          (0, 0, 7089, 7089),
         16#96#           =>  --  1D96
          (0, 0, 7090, 7090),
         16#97#           =>  --  1D97
          (0, 0, 7091, 7091),
         16#98#           =>  --  1D98
          (0, 0, 7092, 7092),
         16#99#           =>  --  1D99
          (0, 0, 7093, 7093),
         16#9A#           =>  --  1D9A
          (0, 0, 7094, 7094),
         16#9B#           =>  --  1D9B
          (0, 0, 7095, 7095),
         16#9C#           =>  --  1D9C
          (0, 0, 7096, 7096),
         16#9D#           =>  --  1D9D
          (0, 0, 7097, 7097),
         16#9E#           =>  --  1D9E
          (0, 0, 7098, 7099),
         16#9F#           =>  --  1D9F
          (0, 0, 7100, 7100),
         16#A0#           =>  --  1DA0
          (0, 0, 7101, 7101),
         16#A1#           =>  --  1DA1
          (0, 0, 7102, 7102),
         16#A2#           =>  --  1DA2
          (0, 0, 7103, 7103),
         16#A3#           =>  --  1DA3
          (0, 0, 7104, 7104),
         16#A4#           =>  --  1DA4
          (0, 0, 7105, 7105),
         16#A5#           =>  --  1DA5
          (0, 0, 7106, 7106),
         16#A6#           =>  --  1DA6
          (0, 0, 7107, 7107),
         16#A7#           =>  --  1DA7
          (0, 0, 7108, 7108),
         16#A8#           =>  --  1DA8
          (0, 0, 7109, 7109),
         16#A9#           =>  --  1DA9
          (0, 0, 7110, 7110),
         16#AA#           =>  --  1DAA
          (0, 0, 7111, 7111),
         16#AB#           =>  --  1DAB
          (0, 0, 7112, 7112),
         16#AC#           =>  --  1DAC
          (0, 0, 7113, 7113),
         16#AD#           =>  --  1DAD
          (0, 0, 7114, 7114),
         16#AE#           =>  --  1DAE
          (0, 0, 7115, 7115),
         16#AF#           =>  --  1DAF
          (0, 0, 7116, 7116),
         16#B0#           =>  --  1DB0
          (0, 0, 7117, 7117),
         16#B1#           =>  --  1DB1
          (0, 0, 7118, 7118),
         16#B2#           =>  --  1DB2
          (0, 0, 7119, 7119),
         16#B3#           =>  --  1DB3
          (0, 0, 7120, 7120),
         16#B4#           =>  --  1DB4
          (0, 0, 7121, 7121),
         16#B5#           =>  --  1DB5
          (0, 0, 7122, 7122),
         16#B6#           =>  --  1DB6
          (0, 0, 7123, 7123),
         16#B7#           =>  --  1DB7
          (0, 0, 7124, 7124),
         16#B8#           =>  --  1DB8
          (0, 0, 7125, 7125),
         16#B9#           =>  --  1DB9
          (0, 0, 7126, 7126),
         16#BA#           =>  --  1DBA
          (0, 0, 7127, 7127),
         16#BB#           =>  --  1DBB
          (0, 0, 7128, 7128),
         16#BC#           =>  --  1DBC
          (0, 0, 7129, 7129),
         16#BD#           =>  --  1DBD
          (0, 0, 7130, 7130),
         16#BE#           =>  --  1DBE
          (0, 0, 7131, 7131),
         16#BF#           =>  --  1DBF
          (0, 0, 7132, 7132),
         16#C2#           =>  --  1DC2
          (0, 0, 1045, 1045),
         16#CA#           =>  --  1DCA
          (0, 0, 1068, 1068),
         16#CF# .. 16#D0# =>  --  1DCF .. 1DD0
          (0, 0, 1045, 1045),
         16#D2#           =>  --  1DD2
          (0, 0, 7133, 7133),
         16#D3#           =>  --  1DD3
          (0, 0, 220, 221),
         16#D4#           =>  --  1DD4
          (0, 0, 220, 222),
         16#D5#           =>  --  1DD5
          (0, 0, 7134, 7135),
         16#D6#           =>  --  1DD6
          (0, 0, 7136, 7137),
         16#D7#           =>  --  1DD7
          (0, 0, 7138, 7139),
         16#D8#           =>  --  1DD8
          (0, 0, 7140, 7141),
         16#D9#           =>  --  1DD9
          (0, 0, 241, 242),
         16#DA#           =>  --  1DDA
          (0, 0, 7058, 7058),
         16#DB#           =>  --  1DDB
          (0, 0, 7142, 7142),
         16#DC#           =>  --  1DDC
          (0, 0, 7143, 7143),
         16#DD#           =>  --  1DDD
          (0, 0, 606, 606),
         16#DE#           =>  --  1DDE
          (0, 0, 7144, 7144),
         16#DF#           =>  --  1DDF
          (0, 0, 7145, 7145),
         16#E0#           =>  --  1DE0
          (0, 0, 412, 412),
         16#E1#           =>  --  1DE1
          (0, 0, 7146, 7146),
         16#E2#           =>  --  1DE2
          (0, 0, 7147, 7147),
         16#E3#           =>  --  1DE3
          (0, 0, 7148, 7148),
         16#E4#           =>  --  1DE4
          (0, 0, 205, 205),
         16#E5#           =>  --  1DE5
          (0, 0, 517, 518),
         16#E6#           =>  --  1DE6
          (0, 0, 532, 532),
         16#E7#           =>  --  1DE7
          (0, 0, 7149, 7149),
         16#E8#           =>  --  1DE8
          (0, 0, 834, 834),
         16#E9#           =>  --  1DE9
          (0, 0, 1163, 1163),
         16#EA#           =>  --  1DEA
          (0, 0, 7150, 7150),
         16#EB#           =>  --  1DEB
          (0, 0, 949, 949),
         16#EC#           =>  --  1DEC
          (0, 0, 7151, 7151),
         16#ED#           =>  --  1DED
          (0, 0, 7152, 7153),
         16#EE#           =>  --  1DEE
          (0, 0, 836, 836),
         16#EF#           =>  --  1DEF
          (0, 0, 946, 946),
         16#F0#           =>  --  1DF0
          (0, 0, 7154, 7155),
         16#F1#           =>  --  1DF1
          (0, 0, 533, 533),
         16#F2#           =>  --  1DF2
          (0, 0, 7156, 7157),
         16#F3#           =>  --  1DF3
          (0, 0, 7158, 7159),
         16#F4#           =>  --  1DF4
          (0, 0, 7160, 7161),
         16#F6# .. 16#FB# =>  --  1DF6 .. 1DFB
          (0, 0, 0, 0),
         16#FC# .. 16#FD# =>  --  1DFC .. 1DFD
          (0, 0, 1045, 1045),
         16#FF#           =>  --  1DFF
          (0, 0, 1045, 1045),
         others           =>
          (0, 0, 1041, 1041));

   Group_001E : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  1E00
          (0, 0, 7162, 7163),
         16#01#           =>  --  1E01
          (0, 0, 7164, 7165),
         16#02#           =>  --  1E02
          (0, 0, 7166, 7167),
         16#03#           =>  --  1E03
          (0, 0, 7168, 7169),
         16#04#           =>  --  1E04
          (0, 0, 7170, 7171),
         16#05#           =>  --  1E05
          (0, 0, 7172, 7173),
         16#06#           =>  --  1E06
          (0, 0, 7174, 7175),
         16#07#           =>  --  1E07
          (0, 0, 7176, 7177),
         16#08#           =>  --  1E08
          (0, 0, 7178, 7180),
         16#09#           =>  --  1E09
          (0, 0, 7181, 7183),
         16#0A#           =>  --  1E0A
          (0, 0, 7184, 7185),
         16#0B#           =>  --  1E0B
          (0, 0, 7186, 7187),
         16#0C#           =>  --  1E0C
          (0, 0, 7188, 7189),
         16#0D#           =>  --  1E0D
          (0, 0, 7190, 7191),
         16#0E#           =>  --  1E0E
          (0, 0, 7192, 7193),
         16#0F#           =>  --  1E0F
          (0, 0, 7194, 7195),
         16#10#           =>  --  1E10
          (0, 0, 7196, 7197),
         16#11#           =>  --  1E11
          (0, 0, 7198, 7199),
         16#12#           =>  --  1E12
          (0, 0, 7200, 7201),
         16#13#           =>  --  1E13
          (0, 0, 7202, 7203),
         16#14#           =>  --  1E14
          (0, 0, 7204, 7206),
         16#15#           =>  --  1E15
          (0, 0, 7207, 7209),
         16#16#           =>  --  1E16
          (0, 0, 7210, 7212),
         16#17#           =>  --  1E17
          (0, 0, 7213, 7215),
         16#18#           =>  --  1E18
          (0, 0, 7216, 7217),
         16#19#           =>  --  1E19
          (0, 0, 7218, 7219),
         16#1A#           =>  --  1E1A
          (0, 0, 7220, 7221),
         16#1B#           =>  --  1E1B
          (0, 0, 7222, 7223),
         16#1C#           =>  --  1E1C
          (0, 0, 7224, 7226),
         16#1D#           =>  --  1E1D
          (0, 0, 7227, 7229),
         16#1E#           =>  --  1E1E
          (0, 0, 7230, 7231),
         16#1F#           =>  --  1E1F
          (0, 0, 7232, 7233),
         16#20#           =>  --  1E20
          (0, 0, 7234, 7235),
         16#21#           =>  --  1E21
          (0, 0, 7236, 7237),
         16#22#           =>  --  1E22
          (0, 0, 7238, 7239),
         16#23#           =>  --  1E23
          (0, 0, 7240, 7241),
         16#24#           =>  --  1E24
          (0, 0, 7242, 7243),
         16#25#           =>  --  1E25
          (0, 0, 7244, 7245),
         16#26#           =>  --  1E26
          (0, 0, 7246, 7247),
         16#27#           =>  --  1E27
          (0, 0, 7248, 7249),
         16#28#           =>  --  1E28
          (0, 0, 7250, 7251),
         16#29#           =>  --  1E29
          (0, 0, 7252, 7253),
         16#2A#           =>  --  1E2A
          (0, 0, 7254, 7255),
         16#2B#           =>  --  1E2B
          (0, 0, 7256, 7257),
         16#2C#           =>  --  1E2C
          (0, 0, 7258, 7259),
         16#2D#           =>  --  1E2D
          (0, 0, 7260, 7261),
         16#2E#           =>  --  1E2E
          (0, 0, 7262, 7264),
         16#2F#           =>  --  1E2F
          (0, 0, 7265, 7267),
         16#30#           =>  --  1E30
          (0, 0, 7268, 7269),
         16#31#           =>  --  1E31
          (0, 0, 7270, 7271),
         16#32#           =>  --  1E32
          (0, 0, 7272, 7273),
         16#33#           =>  --  1E33
          (0, 0, 7274, 7275),
         16#34#           =>  --  1E34
          (0, 0, 7276, 7277),
         16#35#           =>  --  1E35
          (0, 0, 7278, 7279),
         16#36#           =>  --  1E36
          (0, 0, 7280, 7281),
         16#37#           =>  --  1E37
          (0, 0, 7282, 7283),
         16#38#           =>  --  1E38
          (0, 0, 7284, 7286),
         16#39#           =>  --  1E39
          (0, 0, 7287, 7289),
         16#3A#           =>  --  1E3A
          (0, 0, 7290, 7291),
         16#3B#           =>  --  1E3B
          (0, 0, 7292, 7293),
         16#3C#           =>  --  1E3C
          (0, 0, 7294, 7295),
         16#3D#           =>  --  1E3D
          (0, 0, 7296, 7297),
         16#3E#           =>  --  1E3E
          (0, 0, 7298, 7299),
         16#3F#           =>  --  1E3F
          (0, 0, 7300, 7301),
         16#40#           =>  --  1E40
          (0, 0, 7302, 7303),
         16#41#           =>  --  1E41
          (0, 0, 7304, 7305),
         16#42#           =>  --  1E42
          (0, 0, 7306, 7307),
         16#43#           =>  --  1E43
          (0, 0, 7308, 7309),
         16#44#           =>  --  1E44
          (0, 0, 7310, 7311),
         16#45#           =>  --  1E45
          (0, 0, 7312, 7313),
         16#46#           =>  --  1E46
          (0, 0, 7314, 7315),
         16#47#           =>  --  1E47
          (0, 0, 7316, 7317),
         16#48#           =>  --  1E48
          (0, 0, 7318, 7319),
         16#49#           =>  --  1E49
          (0, 0, 7320, 7321),
         16#4A#           =>  --  1E4A
          (0, 0, 7322, 7323),
         16#4B#           =>  --  1E4B
          (0, 0, 7324, 7325),
         16#4C#           =>  --  1E4C
          (0, 0, 7326, 7328),
         16#4D#           =>  --  1E4D
          (0, 0, 7329, 7331),
         16#4E#           =>  --  1E4E
          (0, 0, 7332, 7334),
         16#4F#           =>  --  1E4F
          (0, 0, 7335, 7337),
         16#50#           =>  --  1E50
          (0, 0, 7338, 7340),
         16#51#           =>  --  1E51
          (0, 0, 7341, 7343),
         16#52#           =>  --  1E52
          (0, 0, 7344, 7346),
         16#53#           =>  --  1E53
          (0, 0, 7347, 7349),
         16#54#           =>  --  1E54
          (0, 0, 7350, 7351),
         16#55#           =>  --  1E55
          (0, 0, 7352, 7353),
         16#56#           =>  --  1E56
          (0, 0, 7354, 7355),
         16#57#           =>  --  1E57
          (0, 0, 7356, 7357),
         16#58#           =>  --  1E58
          (0, 0, 7358, 7359),
         16#59#           =>  --  1E59
          (0, 0, 7360, 7361),
         16#5A#           =>  --  1E5A
          (0, 0, 7362, 7363),
         16#5B#           =>  --  1E5B
          (0, 0, 7364, 7365),
         16#5C#           =>  --  1E5C
          (0, 0, 7366, 7368),
         16#5D#           =>  --  1E5D
          (0, 0, 7369, 7371),
         16#5E#           =>  --  1E5E
          (0, 0, 7372, 7373),
         16#5F#           =>  --  1E5F
          (0, 0, 7374, 7375),
         16#60#           =>  --  1E60
          (0, 0, 7376, 7377),
         16#61#           =>  --  1E61
          (0, 0, 7378, 7379),
         16#62#           =>  --  1E62
          (0, 0, 7380, 7381),
         16#63#           =>  --  1E63
          (0, 0, 7382, 7383),
         16#64#           =>  --  1E64
          (0, 0, 7384, 7386),
         16#65#           =>  --  1E65
          (0, 0, 7387, 7389),
         16#66#           =>  --  1E66
          (0, 0, 7390, 7392),
         16#67#           =>  --  1E67
          (0, 0, 7393, 7395),
         16#68#           =>  --  1E68
          (0, 0, 7396, 7398),
         16#69#           =>  --  1E69
          (0, 0, 7399, 7401),
         16#6A#           =>  --  1E6A
          (0, 0, 7402, 7403),
         16#6B#           =>  --  1E6B
          (0, 0, 7404, 7405),
         16#6C#           =>  --  1E6C
          (0, 0, 7406, 7407),
         16#6D#           =>  --  1E6D
          (0, 0, 7408, 7409),
         16#6E#           =>  --  1E6E
          (0, 0, 7410, 7411),
         16#6F#           =>  --  1E6F
          (0, 0, 7412, 7413),
         16#70#           =>  --  1E70
          (0, 0, 7414, 7415),
         16#71#           =>  --  1E71
          (0, 0, 7416, 7417),
         16#72#           =>  --  1E72
          (0, 0, 7418, 7419),
         16#73#           =>  --  1E73
          (0, 0, 7420, 7421),
         16#74#           =>  --  1E74
          (0, 0, 7422, 7423),
         16#75#           =>  --  1E75
          (0, 0, 7424, 7425),
         16#76#           =>  --  1E76
          (0, 0, 7426, 7427),
         16#77#           =>  --  1E77
          (0, 0, 7428, 7429),
         16#78#           =>  --  1E78
          (0, 0, 7430, 7432),
         16#79#           =>  --  1E79
          (0, 0, 7433, 7435),
         16#7A#           =>  --  1E7A
          (0, 0, 7436, 7438),
         16#7B#           =>  --  1E7B
          (0, 0, 7439, 7441),
         16#7C#           =>  --  1E7C
          (0, 0, 7442, 7443),
         16#7D#           =>  --  1E7D
          (0, 0, 7444, 7445),
         16#7E#           =>  --  1E7E
          (0, 0, 7446, 7447),
         16#7F#           =>  --  1E7F
          (0, 0, 7448, 7449),
         16#80#           =>  --  1E80
          (0, 0, 7450, 7451),
         16#81#           =>  --  1E81
          (0, 0, 7452, 7453),
         16#82#           =>  --  1E82
          (0, 0, 7454, 7455),
         16#83#           =>  --  1E83
          (0, 0, 7456, 7457),
         16#84#           =>  --  1E84
          (0, 0, 7458, 7459),
         16#85#           =>  --  1E85
          (0, 0, 7460, 7461),
         16#86#           =>  --  1E86
          (0, 0, 7462, 7463),
         16#87#           =>  --  1E87
          (0, 0, 7464, 7465),
         16#88#           =>  --  1E88
          (0, 0, 7466, 7467),
         16#89#           =>  --  1E89
          (0, 0, 7468, 7469),
         16#8A#           =>  --  1E8A
          (0, 0, 7470, 7471),
         16#8B#           =>  --  1E8B
          (0, 0, 7472, 7473),
         16#8C#           =>  --  1E8C
          (0, 0, 7474, 7475),
         16#8D#           =>  --  1E8D
          (0, 0, 7476, 7477),
         16#8E#           =>  --  1E8E
          (0, 0, 7478, 7479),
         16#8F#           =>  --  1E8F
          (0, 0, 7480, 7481),
         16#90#           =>  --  1E90
          (0, 0, 7482, 7483),
         16#91#           =>  --  1E91
          (0, 0, 7484, 7485),
         16#92#           =>  --  1E92
          (0, 0, 7486, 7487),
         16#93#           =>  --  1E93
          (0, 0, 7488, 7489),
         16#94#           =>  --  1E94
          (0, 0, 7490, 7491),
         16#95#           =>  --  1E95
          (0, 0, 7492, 7493),
         16#96#           =>  --  1E96
          (0, 0, 7494, 7495),
         16#97#           =>  --  1E97
          (0, 0, 7496, 7497),
         16#98#           =>  --  1E98
          (0, 0, 7498, 7499),
         16#99#           =>  --  1E99
          (0, 0, 7500, 7501),
         16#9A#           =>  --  1E9A
          (0, 0, 7502, 7503),
         16#9B#           =>  --  1E9B
          (0, 0, 7504, 7506),
         16#9C#           =>  --  1E9C
          (0, 0, 7507, 7507),
         16#9D#           =>  --  1E9D
          (0, 0, 7508, 7508),
         16#9E#           =>  --  1E9E
          (0, 0, 7509, 7511),
         16#9F#           =>  --  1E9F
          (0, 0, 7512, 7512),
         16#A0#           =>  --  1EA0
          (0, 0, 7513, 7514),
         16#A1#           =>  --  1EA1
          (0, 0, 7515, 7516),
         16#A2#           =>  --  1EA2
          (0, 0, 7517, 7518),
         16#A3#           =>  --  1EA3
          (0, 0, 7519, 7520),
         16#A4#           =>  --  1EA4
          (0, 0, 7521, 7523),
         16#A5#           =>  --  1EA5
          (0, 0, 7524, 7526),
         16#A6#           =>  --  1EA6
          (0, 0, 7527, 7529),
         16#A7#           =>  --  1EA7
          (0, 0, 7530, 7532),
         16#A8#           =>  --  1EA8
          (0, 0, 7533, 7535),
         16#A9#           =>  --  1EA9
          (0, 0, 7536, 7538),
         16#AA#           =>  --  1EAA
          (0, 0, 7539, 7541),
         16#AB#           =>  --  1EAB
          (0, 0, 7542, 7544),
         16#AC#           =>  --  1EAC
          (0, 0, 7545, 7547),
         16#AD#           =>  --  1EAD
          (0, 0, 7548, 7550),
         16#AE#           =>  --  1EAE
          (0, 0, 7551, 7553),
         16#AF#           =>  --  1EAF
          (0, 0, 7554, 7556),
         16#B0#           =>  --  1EB0
          (0, 0, 7557, 7559),
         16#B1#           =>  --  1EB1
          (0, 0, 7560, 7562),
         16#B2#           =>  --  1EB2
          (0, 0, 7563, 7565),
         16#B3#           =>  --  1EB3
          (0, 0, 7566, 7568),
         16#B4#           =>  --  1EB4
          (0, 0, 7569, 7571),
         16#B5#           =>  --  1EB5
          (0, 0, 7572, 7574),
         16#B6#           =>  --  1EB6
          (0, 0, 7575, 7577),
         16#B7#           =>  --  1EB7
          (0, 0, 7578, 7580),
         16#B8#           =>  --  1EB8
          (0, 0, 7581, 7582),
         16#B9#           =>  --  1EB9
          (0, 0, 7583, 7584),
         16#BA#           =>  --  1EBA
          (0, 0, 7585, 7586),
         16#BB#           =>  --  1EBB
          (0, 0, 7587, 7588),
         16#BC#           =>  --  1EBC
          (0, 0, 7589, 7590),
         16#BD#           =>  --  1EBD
          (0, 0, 7591, 7592),
         16#BE#           =>  --  1EBE
          (0, 0, 7593, 7595),
         16#BF#           =>  --  1EBF
          (0, 0, 7596, 7598),
         16#C0#           =>  --  1EC0
          (0, 0, 7599, 7601),
         16#C1#           =>  --  1EC1
          (0, 0, 7602, 7604),
         16#C2#           =>  --  1EC2
          (0, 0, 7605, 7607),
         16#C3#           =>  --  1EC3
          (0, 0, 7608, 7610),
         16#C4#           =>  --  1EC4
          (0, 0, 7611, 7613),
         16#C5#           =>  --  1EC5
          (0, 0, 7614, 7616),
         16#C6#           =>  --  1EC6
          (0, 0, 7617, 7619),
         16#C7#           =>  --  1EC7
          (0, 0, 7620, 7622),
         16#C8#           =>  --  1EC8
          (0, 0, 7623, 7624),
         16#C9#           =>  --  1EC9
          (0, 0, 7625, 7626),
         16#CA#           =>  --  1ECA
          (0, 0, 7627, 7628),
         16#CB#           =>  --  1ECB
          (0, 0, 7629, 7630),
         16#CC#           =>  --  1ECC
          (0, 0, 7631, 7632),
         16#CD#           =>  --  1ECD
          (0, 0, 7633, 7634),
         16#CE#           =>  --  1ECE
          (0, 0, 7635, 7636),
         16#CF#           =>  --  1ECF
          (0, 0, 7637, 7638),
         16#D0#           =>  --  1ED0
          (0, 0, 7639, 7641),
         16#D1#           =>  --  1ED1
          (0, 0, 7642, 7644),
         16#D2#           =>  --  1ED2
          (0, 0, 7645, 7647),
         16#D3#           =>  --  1ED3
          (0, 0, 7648, 7650),
         16#D4#           =>  --  1ED4
          (0, 0, 7651, 7653),
         16#D5#           =>  --  1ED5
          (0, 0, 7654, 7656),
         16#D6#           =>  --  1ED6
          (0, 0, 7657, 7659),
         16#D7#           =>  --  1ED7
          (0, 0, 7660, 7662),
         16#D8#           =>  --  1ED8
          (0, 0, 7663, 7665),
         16#D9#           =>  --  1ED9
          (0, 0, 7666, 7668),
         16#DA#           =>  --  1EDA
          (0, 0, 7669, 7671),
         16#DB#           =>  --  1EDB
          (0, 0, 7672, 7674),
         16#DC#           =>  --  1EDC
          (0, 0, 7675, 7677),
         16#DD#           =>  --  1EDD
          (0, 0, 7678, 7680),
         16#DE#           =>  --  1EDE
          (0, 0, 7681, 7683),
         16#DF#           =>  --  1EDF
          (0, 0, 7684, 7686),
         16#E0#           =>  --  1EE0
          (0, 0, 7687, 7689),
         16#E1#           =>  --  1EE1
          (0, 0, 7690, 7692),
         16#E2#           =>  --  1EE2
          (0, 0, 7693, 7695),
         16#E3#           =>  --  1EE3
          (0, 0, 7696, 7698),
         16#E4#           =>  --  1EE4
          (0, 0, 7699, 7700),
         16#E5#           =>  --  1EE5
          (0, 0, 7701, 7702),
         16#E6#           =>  --  1EE6
          (0, 0, 7703, 7704),
         16#E7#           =>  --  1EE7
          (0, 0, 7705, 7706),
         16#E8#           =>  --  1EE8
          (0, 0, 7707, 7709),
         16#E9#           =>  --  1EE9
          (0, 0, 7710, 7712),
         16#EA#           =>  --  1EEA
          (0, 0, 7713, 7715),
         16#EB#           =>  --  1EEB
          (0, 0, 7716, 7718),
         16#EC#           =>  --  1EEC
          (0, 0, 7719, 7721),
         16#ED#           =>  --  1EED
          (0, 0, 7722, 7724),
         16#EE#           =>  --  1EEE
          (0, 0, 7725, 7727),
         16#EF#           =>  --  1EEF
          (0, 0, 7728, 7730),
         16#F0#           =>  --  1EF0
          (0, 0, 7731, 7733),
         16#F1#           =>  --  1EF1
          (0, 0, 7734, 7736),
         16#F2#           =>  --  1EF2
          (0, 0, 7737, 7738),
         16#F3#           =>  --  1EF3
          (0, 0, 7739, 7740),
         16#F4#           =>  --  1EF4
          (0, 0, 7741, 7742),
         16#F5#           =>  --  1EF5
          (0, 0, 7743, 7744),
         16#F6#           =>  --  1EF6
          (0, 0, 7745, 7746),
         16#F7#           =>  --  1EF7
          (0, 0, 7747, 7748),
         16#F8#           =>  --  1EF8
          (0, 0, 7749, 7750),
         16#F9#           =>  --  1EF9
          (0, 0, 7751, 7752),
         16#FA#           =>  --  1EFA
          (0, 0, 7753, 7754),
         16#FB#           =>  --  1EFB
          (0, 0, 7755, 7756),
         16#FC#           =>  --  1EFC
          (0, 0, 7757, 7757),
         16#FD#           =>  --  1EFD
          (0, 0, 7758, 7758),
         16#FE#           =>  --  1EFE
          (0, 0, 7759, 7759),
         16#FF#           =>  --  1EFF
          (0, 0, 7760, 7760),
         others           =>
          (0, 0, 1041, 1041));

   Group_001F : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  1F00
          (0, 0, 7761, 7762),
         16#01#           =>  --  1F01
          (0, 0, 7763, 7764),
         16#02#           =>  --  1F02
          (0, 0, 7765, 7767),
         16#03#           =>  --  1F03
          (0, 0, 7768, 7770),
         16#04#           =>  --  1F04
          (0, 0, 7771, 7773),
         16#05#           =>  --  1F05
          (0, 0, 7774, 7776),
         16#06#           =>  --  1F06
          (0, 0, 7777, 7779),
         16#07#           =>  --  1F07
          (0, 0, 7780, 7782),
         16#08#           =>  --  1F08
          (0, 0, 7783, 7784),
         16#09#           =>  --  1F09
          (0, 0, 7785, 7786),
         16#0A#           =>  --  1F0A
          (0, 0, 7787, 7789),
         16#0B#           =>  --  1F0B
          (0, 0, 7790, 7792),
         16#0C#           =>  --  1F0C
          (0, 0, 7793, 7795),
         16#0D#           =>  --  1F0D
          (0, 0, 7796, 7798),
         16#0E#           =>  --  1F0E
          (0, 0, 7799, 7801),
         16#0F#           =>  --  1F0F
          (0, 0, 7802, 7804),
         16#10#           =>  --  1F10
          (0, 0, 7805, 7806),
         16#11#           =>  --  1F11
          (0, 0, 7807, 7808),
         16#12#           =>  --  1F12
          (0, 0, 7809, 7811),
         16#13#           =>  --  1F13
          (0, 0, 7812, 7814),
         16#14#           =>  --  1F14
          (0, 0, 7815, 7817),
         16#15#           =>  --  1F15
          (0, 0, 7818, 7820),
         16#18#           =>  --  1F18
          (0, 0, 7821, 7822),
         16#19#           =>  --  1F19
          (0, 0, 7823, 7824),
         16#1A#           =>  --  1F1A
          (0, 0, 7825, 7827),
         16#1B#           =>  --  1F1B
          (0, 0, 7828, 7830),
         16#1C#           =>  --  1F1C
          (0, 0, 7831, 7833),
         16#1D#           =>  --  1F1D
          (0, 0, 7834, 7836),
         16#20#           =>  --  1F20
          (0, 0, 7837, 7838),
         16#21#           =>  --  1F21
          (0, 0, 7839, 7840),
         16#22#           =>  --  1F22
          (0, 0, 7841, 7843),
         16#23#           =>  --  1F23
          (0, 0, 7844, 7846),
         16#24#           =>  --  1F24
          (0, 0, 7847, 7849),
         16#25#           =>  --  1F25
          (0, 0, 7850, 7852),
         16#26#           =>  --  1F26
          (0, 0, 7853, 7855),
         16#27#           =>  --  1F27
          (0, 0, 7856, 7858),
         16#28#           =>  --  1F28
          (0, 0, 7859, 7860),
         16#29#           =>  --  1F29
          (0, 0, 7861, 7862),
         16#2A#           =>  --  1F2A
          (0, 0, 7863, 7865),
         16#2B#           =>  --  1F2B
          (0, 0, 7866, 7868),
         16#2C#           =>  --  1F2C
          (0, 0, 7869, 7871),
         16#2D#           =>  --  1F2D
          (0, 0, 7872, 7874),
         16#2E#           =>  --  1F2E
          (0, 0, 7875, 7877),
         16#2F#           =>  --  1F2F
          (0, 0, 7878, 7880),
         16#30#           =>  --  1F30
          (0, 0, 7881, 7882),
         16#31#           =>  --  1F31
          (0, 0, 7883, 7884),
         16#32#           =>  --  1F32
          (0, 0, 7885, 7887),
         16#33#           =>  --  1F33
          (0, 0, 7888, 7890),
         16#34#           =>  --  1F34
          (0, 0, 7891, 7893),
         16#35#           =>  --  1F35
          (0, 0, 7894, 7896),
         16#36#           =>  --  1F36
          (0, 0, 7897, 7899),
         16#37#           =>  --  1F37
          (0, 0, 7900, 7902),
         16#38#           =>  --  1F38
          (0, 0, 7903, 7904),
         16#39#           =>  --  1F39
          (0, 0, 7905, 7906),
         16#3A#           =>  --  1F3A
          (0, 0, 7907, 7909),
         16#3B#           =>  --  1F3B
          (0, 0, 7910, 7912),
         16#3C#           =>  --  1F3C
          (0, 0, 7913, 7915),
         16#3D#           =>  --  1F3D
          (0, 0, 7916, 7918),
         16#3E#           =>  --  1F3E
          (0, 0, 7919, 7921),
         16#3F#           =>  --  1F3F
          (0, 0, 7922, 7924),
         16#40#           =>  --  1F40
          (0, 0, 7925, 7926),
         16#41#           =>  --  1F41
          (0, 0, 7927, 7928),
         16#42#           =>  --  1F42
          (0, 0, 7929, 7931),
         16#43#           =>  --  1F43
          (0, 0, 7932, 7934),
         16#44#           =>  --  1F44
          (0, 0, 7935, 7937),
         16#45#           =>  --  1F45
          (0, 0, 7938, 7940),
         16#48#           =>  --  1F48
          (0, 0, 7941, 7942),
         16#49#           =>  --  1F49
          (0, 0, 7943, 7944),
         16#4A#           =>  --  1F4A
          (0, 0, 7945, 7947),
         16#4B#           =>  --  1F4B
          (0, 0, 7948, 7950),
         16#4C#           =>  --  1F4C
          (0, 0, 7951, 7953),
         16#4D#           =>  --  1F4D
          (0, 0, 7954, 7956),
         16#50#           =>  --  1F50
          (0, 0, 7957, 7958),
         16#51#           =>  --  1F51
          (0, 0, 7959, 7960),
         16#52#           =>  --  1F52
          (0, 0, 7961, 7963),
         16#53#           =>  --  1F53
          (0, 0, 7964, 7966),
         16#54#           =>  --  1F54
          (0, 0, 7967, 7969),
         16#55#           =>  --  1F55
          (0, 0, 7970, 7972),
         16#56#           =>  --  1F56
          (0, 0, 7973, 7975),
         16#57#           =>  --  1F57
          (0, 0, 7976, 7978),
         16#59#           =>  --  1F59
          (0, 0, 7979, 7980),
         16#5B#           =>  --  1F5B
          (0, 0, 7981, 7983),
         16#5D#           =>  --  1F5D
          (0, 0, 7984, 7986),
         16#5F#           =>  --  1F5F
          (0, 0, 7987, 7989),
         16#60#           =>  --  1F60
          (0, 0, 7990, 7991),
         16#61#           =>  --  1F61
          (0, 0, 7992, 7993),
         16#62#           =>  --  1F62
          (0, 0, 7994, 7996),
         16#63#           =>  --  1F63
          (0, 0, 7997, 7999),
         16#64#           =>  --  1F64
          (0, 0, 8000, 8002),
         16#65#           =>  --  1F65
          (0, 0, 8003, 8005),
         16#66#           =>  --  1F66
          (0, 0, 8006, 8008),
         16#67#           =>  --  1F67
          (0, 0, 8009, 8011),
         16#68#           =>  --  1F68
          (0, 0, 8012, 8013),
         16#69#           =>  --  1F69
          (0, 0, 8014, 8015),
         16#6A#           =>  --  1F6A
          (0, 0, 8016, 8018),
         16#6B#           =>  --  1F6B
          (0, 0, 8019, 8021),
         16#6C#           =>  --  1F6C
          (0, 0, 8022, 8024),
         16#6D#           =>  --  1F6D
          (0, 0, 8025, 8027),
         16#6E#           =>  --  1F6E
          (0, 0, 8028, 8030),
         16#6F#           =>  --  1F6F
          (0, 0, 8031, 8033),
         16#70#           =>  --  1F70
          (0, 0, 8034, 8035),
         16#71#           =>  --  1F71
          (0, 0, 1123, 1124),
         16#72#           =>  --  1F72
          (0, 0, 8036, 8037),
         16#73#           =>  --  1F73
          (0, 0, 1125, 1126),
         16#74#           =>  --  1F74
          (0, 0, 8038, 8039),
         16#75#           =>  --  1F75
          (0, 0, 1127, 1128),
         16#76#           =>  --  1F76
          (0, 0, 8040, 8041),
         16#77#           =>  --  1F77
          (0, 0, 1129, 1130),
         16#78#           =>  --  1F78
          (0, 0, 8042, 8043),
         16#79#           =>  --  1F79
          (0, 0, 1154, 1155),
         16#7A#           =>  --  1F7A
          (0, 0, 8044, 8045),
         16#7B#           =>  --  1F7B
          (0, 0, 1156, 1157),
         16#7C#           =>  --  1F7C
          (0, 0, 8046, 8047),
         16#7D#           =>  --  1F7D
          (0, 0, 1158, 1159),
         16#80#           =>  --  1F80
          (0, 0, 8048, 8050),
         16#81#           =>  --  1F81
          (0, 0, 8051, 8053),
         16#82#           =>  --  1F82
          (0, 0, 8054, 8057),
         16#83#           =>  --  1F83
          (0, 0, 8058, 8061),
         16#84#           =>  --  1F84
          (0, 0, 8062, 8065),
         16#85#           =>  --  1F85
          (0, 0, 8066, 8069),
         16#86#           =>  --  1F86
          (0, 0, 8070, 8073),
         16#87#           =>  --  1F87
          (0, 0, 8074, 8077),
         16#88#           =>  --  1F88
          (0, 0, 8078, 8080),
         16#89#           =>  --  1F89
          (0, 0, 8081, 8083),
         16#8A#           =>  --  1F8A
          (0, 0, 8084, 8087),
         16#8B#           =>  --  1F8B
          (0, 0, 8088, 8091),
         16#8C#           =>  --  1F8C
          (0, 0, 8092, 8095),
         16#8D#           =>  --  1F8D
          (0, 0, 8096, 8099),
         16#8E#           =>  --  1F8E
          (0, 0, 8100, 8103),
         16#8F#           =>  --  1F8F
          (0, 0, 8104, 8107),
         16#90#           =>  --  1F90
          (0, 0, 8108, 8110),
         16#91#           =>  --  1F91
          (0, 0, 8111, 8113),
         16#92#           =>  --  1F92
          (0, 0, 8114, 8117),
         16#93#           =>  --  1F93
          (0, 0, 8118, 8121),
         16#94#           =>  --  1F94
          (0, 0, 8122, 8125),
         16#95#           =>  --  1F95
          (0, 0, 8126, 8129),
         16#96#           =>  --  1F96
          (0, 0, 8130, 8133),
         16#97#           =>  --  1F97
          (0, 0, 8134, 8137),
         16#98#           =>  --  1F98
          (0, 0, 8138, 8140),
         16#99#           =>  --  1F99
          (0, 0, 8141, 8143),
         16#9A#           =>  --  1F9A
          (0, 0, 8144, 8147),
         16#9B#           =>  --  1F9B
          (0, 0, 8148, 8151),
         16#9C#           =>  --  1F9C
          (0, 0, 8152, 8155),
         16#9D#           =>  --  1F9D
          (0, 0, 8156, 8159),
         16#9E#           =>  --  1F9E
          (0, 0, 8160, 8163),
         16#9F#           =>  --  1F9F
          (0, 0, 8164, 8167),
         16#A0#           =>  --  1FA0
          (0, 0, 8168, 8170),
         16#A1#           =>  --  1FA1
          (0, 0, 8171, 8173),
         16#A2#           =>  --  1FA2
          (0, 0, 8174, 8177),
         16#A3#           =>  --  1FA3
          (0, 0, 8178, 8181),
         16#A4#           =>  --  1FA4
          (0, 0, 8182, 8185),
         16#A5#           =>  --  1FA5
          (0, 0, 8186, 8189),
         16#A6#           =>  --  1FA6
          (0, 0, 8190, 8193),
         16#A7#           =>  --  1FA7
          (0, 0, 8194, 8197),
         16#A8#           =>  --  1FA8
          (0, 0, 8198, 8200),
         16#A9#           =>  --  1FA9
          (0, 0, 8201, 8203),
         16#AA#           =>  --  1FAA
          (0, 0, 8204, 8207),
         16#AB#           =>  --  1FAB
          (0, 0, 8208, 8211),
         16#AC#           =>  --  1FAC
          (0, 0, 8212, 8215),
         16#AD#           =>  --  1FAD
          (0, 0, 8216, 8219),
         16#AE#           =>  --  1FAE
          (0, 0, 8220, 8223),
         16#AF#           =>  --  1FAF
          (0, 0, 8224, 8227),
         16#B0#           =>  --  1FB0
          (0, 0, 8228, 8229),
         16#B1#           =>  --  1FB1
          (0, 0, 8230, 8231),
         16#B2#           =>  --  1FB2
          (0, 0, 8232, 8234),
         16#B3#           =>  --  1FB3
          (0, 0, 8235, 8236),
         16#B4#           =>  --  1FB4
          (0, 0, 8237, 8239),
         16#B6#           =>  --  1FB6
          (0, 0, 8240, 8241),
         16#B7#           =>  --  1FB7
          (0, 0, 8242, 8244),
         16#B8#           =>  --  1FB8
          (0, 0, 8245, 8246),
         16#B9#           =>  --  1FB9
          (0, 0, 8247, 8248),
         16#BA#           =>  --  1FBA
          (0, 0, 8249, 8250),
         16#BB#           =>  --  1FBB
          (0, 0, 1085, 1086),
         16#BC#           =>  --  1FBC
          (0, 0, 8251, 8252),
         16#BD#           =>  --  1FBD
          (0, 0, 8253, 8253),
         16#BE#           =>  --  1FBE
          (0, 0, 1099, 1099),
         16#BF#           =>  --  1FBF
          (0, 0, 8253, 8253),
         16#C0#           =>  --  1FC0
          (0, 0, 8254, 8254),
         16#C1#           =>  --  1FC1
          (0, 0, 8255, 8256),
         16#C2#           =>  --  1FC2
          (0, 0, 8257, 8259),
         16#C3#           =>  --  1FC3
          (0, 0, 8260, 8261),
         16#C4#           =>  --  1FC4
          (0, 0, 8262, 8264),
         16#C6#           =>  --  1FC6
          (0, 0, 8265, 8266),
         16#C7#           =>  --  1FC7
          (0, 0, 8267, 8269),
         16#C8#           =>  --  1FC8
          (0, 0, 8270, 8271),
         16#C9#           =>  --  1FC9
          (0, 0, 1087, 1088),
         16#CA#           =>  --  1FCA
          (0, 0, 8272, 8273),
         16#CB#           =>  --  1FCB
          (0, 0, 1089, 1090),
         16#CC#           =>  --  1FCC
          (0, 0, 8274, 8275),
         16#CD#           =>  --  1FCD
          (0, 0, 8276, 8277),
         16#CE#           =>  --  1FCE
          (0, 0, 8278, 8279),
         16#CF#           =>  --  1FCF
          (0, 0, 8280, 8281),
         16#D0#           =>  --  1FD0
          (0, 0, 8282, 8283),
         16#D1#           =>  --  1FD1
          (0, 0, 8284, 8285),
         16#D2#           =>  --  1FD2
          (0, 0, 8286, 8288),
         16#D3#           =>  --  1FD3
          (0, 0, 1099, 1101),
         16#D6#           =>  --  1FD6
          (0, 0, 8289, 8290),
         16#D7#           =>  --  1FD7
          (0, 0, 8291, 8293),
         16#D8#           =>  --  1FD8
          (0, 0, 8294, 8295),
         16#D9#           =>  --  1FD9
          (0, 0, 8296, 8297),
         16#DA#           =>  --  1FDA
          (0, 0, 8298, 8299),
         16#DB#           =>  --  1FDB
          (0, 0, 1091, 1092),
         16#DD#           =>  --  1FDD
          (0, 0, 8300, 8301),
         16#DE#           =>  --  1FDE
          (0, 0, 8302, 8303),
         16#DF#           =>  --  1FDF
          (0, 0, 8304, 8305),
         16#E0#           =>  --  1FE0
          (0, 0, 8306, 8307),
         16#E1#           =>  --  1FE1
          (0, 0, 8308, 8309),
         16#E2#           =>  --  1FE2
          (0, 0, 8310, 8312),
         16#E3#           =>  --  1FE3
          (0, 0, 1131, 1133),
         16#E4#           =>  --  1FE4
          (0, 0, 8313, 8314),
         16#E5#           =>  --  1FE5
          (0, 0, 8315, 8316),
         16#E6#           =>  --  1FE6
          (0, 0, 8317, 8318),
         16#E7#           =>  --  1FE7
          (0, 0, 8319, 8321),
         16#E8#           =>  --  1FE8
          (0, 0, 8322, 8323),
         16#E9#           =>  --  1FE9
          (0, 0, 8324, 8325),
         16#EA#           =>  --  1FEA
          (0, 0, 8326, 8327),
         16#EB#           =>  --  1FEB
          (0, 0, 1095, 1096),
         16#EC#           =>  --  1FEC
          (0, 0, 8328, 8329),
         16#ED#           =>  --  1FED
          (0, 0, 8330, 8331),
         16#EE#           =>  --  1FEE
          (0, 0, 1083, 1084),
         16#EF#           =>  --  1FEF
          (0, 0, 73, 73),
         16#F2#           =>  --  1FF2
          (0, 0, 8332, 8334),
         16#F3#           =>  --  1FF3
          (0, 0, 8335, 8336),
         16#F4#           =>  --  1FF4
          (0, 0, 8337, 8339),
         16#F6#           =>  --  1FF6
          (0, 0, 8340, 8341),
         16#F7#           =>  --  1FF7
          (0, 0, 8342, 8344),
         16#F8#           =>  --  1FF8
          (0, 0, 8345, 8346),
         16#F9#           =>  --  1FF9
          (0, 0, 1093, 1094),
         16#FA#           =>  --  1FFA
          (0, 0, 8347, 8348),
         16#FB#           =>  --  1FFB
          (0, 0, 1097, 1098),
         16#FC#           =>  --  1FFC
          (0, 0, 8349, 8350),
         16#FD#           =>  --  1FFD
          (0, 0, 126, 126),
         16#FE#           =>  --  1FFE
          (0, 0, 8300, 8300),
         others           =>
          (0, 0, 0, 0));

   Group_0020 : aliased constant Collation_Second_Stage
     := (16#00# .. 16#06# =>  --  2000 .. 2006
          (0, 0, 5753, 5753),
         16#07#           =>  --  2007
          (0, 0, 107, 107),
         16#08# .. 16#0A# =>  --  2008 .. 200A
          (0, 0, 5753, 5753),
         16#0B# .. 16#0F# =>  --  200B .. 200F
          (0, 0, 1, 1),
         16#10#           =>  --  2010
          (0, 0, 8351, 8351),
         16#11#           =>  --  2011
          (0, 0, 8352, 8352),
         16#12#           =>  --  2012
          (0, 0, 8353, 8353),
         16#13#           =>  --  2013
          (0, 0, 8354, 8354),
         16#14#           =>  --  2014
          (0, 0, 8355, 8355),
         16#15#           =>  --  2015
          (0, 0, 8356, 8356),
         16#16#           =>  --  2016
          (0, 0, 8357, 8357),
         16#17#           =>  --  2017
          (0, 0, 8358, 8358),
         16#18#           =>  --  2018
          (0, 0, 8359, 8359),
         16#19#           =>  --  2019
          (0, 0, 8360, 8360),
         16#1A#           =>  --  201A
          (0, 0, 8361, 8361),
         16#1B#           =>  --  201B
          (0, 0, 8362, 8362),
         16#1C#           =>  --  201C
          (0, 0, 8363, 8363),
         16#1D#           =>  --  201D
          (0, 0, 8364, 8364),
         16#1E#           =>  --  201E
          (0, 0, 8365, 8365),
         16#1F#           =>  --  201F
          (0, 0, 8366, 8366),
         16#20#           =>  --  2020
          (0, 0, 8367, 8367),
         16#21#           =>  --  2021
          (0, 0, 8368, 8368),
         16#22#           =>  --  2022
          (0, 0, 8369, 8369),
         16#23#           =>  --  2023
          (0, 0, 8370, 8370),
         16#24#           =>  --  2024
          (0, 0, 8371, 8371),
         16#25#           =>  --  2025
          (0, 0, 8372, 8373),
         16#26#           =>  --  2026
          (0, 0, 8371, 8373),
         16#27#           =>  --  2027
          (0, 0, 8374, 8374),
         16#28#           =>  --  2028
          (0, 0, 8375, 8375),
         16#29#           =>  --  2029
          (0, 0, 8376, 8376),
         16#2A# .. 16#2E# =>  --  202A .. 202E
          (0, 0, 1, 1),
         16#2F#           =>  --  202F
          (0, 0, 107, 107),
         16#30#           =>  --  2030
          (0, 0, 8377, 8377),
         16#31#           =>  --  2031
          (0, 0, 8378, 8378),
         16#32#           =>  --  2032
          (0, 0, 8379, 8379),
         16#33#           =>  --  2033
          (0, 0, 8380, 8381),
         16#34#           =>  --  2034
          (0, 0, 8382, 8384),
         16#35#           =>  --  2035
          (0, 0, 8385, 8385),
         16#36#           =>  --  2036
          (0, 0, 8386, 8387),
         16#37#           =>  --  2037
          (0, 0, 8388, 8390),
         16#38#           =>  --  2038
          (0, 0, 8391, 8391),
         16#39#           =>  --  2039
          (0, 0, 8392, 8392),
         16#3A#           =>  --  203A
          (0, 0, 8393, 8393),
         16#3B#           =>  --  203B
          (0, 0, 8394, 8394),
         16#3C#           =>  --  203C
          (0, 0, 8395, 8396),
         16#3D#           =>  --  203D
          (0, 0, 8397, 8397),
         16#3E#           =>  --  203E
          (0, 0, 8398, 8398),
         16#3F#           =>  --  203F
          (0, 0, 8399, 8399),
         16#40#           =>  --  2040
          (0, 0, 8400, 8400),
         16#41#           =>  --  2041
          (0, 0, 8401, 8401),
         16#42#           =>  --  2042
          (0, 0, 8402, 8402),
         16#43#           =>  --  2043
          (0, 0, 8403, 8403),
         16#44#           =>  --  2044
          (0, 0, 8404, 8404),
         16#45#           =>  --  2045
          (0, 0, 8405, 8405),
         16#46#           =>  --  2046
          (0, 0, 8406, 8406),
         16#47#           =>  --  2047
          (0, 0, 8407, 8408),
         16#48#           =>  --  2048
          (0, 0, 8409, 8410),
         16#49#           =>  --  2049
          (0, 0, 8411, 8412),
         16#4A#           =>  --  204A
          (0, 0, 8413, 8413),
         16#4B#           =>  --  204B
          (0, 0, 8414, 8414),
         16#4C#           =>  --  204C
          (0, 0, 8415, 8415),
         16#4D#           =>  --  204D
          (0, 0, 8416, 8416),
         16#4E#           =>  --  204E
          (0, 0, 8417, 8417),
         16#4F#           =>  --  204F
          (0, 0, 8418, 8418),
         16#50#           =>  --  2050
          (0, 0, 8419, 8419),
         16#51#           =>  --  2051
          (0, 0, 8420, 8420),
         16#52#           =>  --  2052
          (0, 0, 8421, 8421),
         16#53#           =>  --  2053
          (0, 0, 8422, 8422),
         16#54#           =>  --  2054
          (0, 0, 8423, 8423),
         16#55#           =>  --  2055
          (0, 0, 8424, 8424),
         16#56#           =>  --  2056
          (0, 0, 8425, 8425),
         16#57#           =>  --  2057
          (0, 0, 8380, 8383),
         16#58#           =>  --  2058
          (0, 0, 8426, 8426),
         16#59#           =>  --  2059
          (0, 0, 8427, 8427),
         16#5A#           =>  --  205A
          (0, 0, 8428, 8428),
         16#5B#           =>  --  205B
          (0, 0, 8429, 8429),
         16#5C#           =>  --  205C
          (0, 0, 8430, 8430),
         16#5D#           =>  --  205D
          (0, 0, 8431, 8431),
         16#5E#           =>  --  205E
          (0, 0, 8432, 8432),
         16#5F#           =>  --  205F
          (0, 0, 5753, 5753),
         16#60# .. 16#64# =>  --  2060 .. 2064
          (0, 0, 1, 1),
         16#66# .. 16#6F# =>  --  2066 .. 206F
          (0, 0, 1, 1),
         16#70#           =>  --  2070
          (0, 0, 8433, 8433),
         16#71#           =>  --  2071
          (0, 0, 8434, 8434),
         16#74#           =>  --  2074
          (0, 0, 8435, 8435),
         16#75#           =>  --  2075
          (0, 0, 8436, 8436),
         16#76#           =>  --  2076
          (0, 0, 8437, 8437),
         16#77#           =>  --  2077
          (0, 0, 8438, 8438),
         16#78#           =>  --  2078
          (0, 0, 8439, 8439),
         16#79#           =>  --  2079
          (0, 0, 8440, 8440),
         16#7A#           =>  --  207A
          (0, 0, 8441, 8441),
         16#7B#           =>  --  207B
          (0, 0, 8442, 8442),
         16#7C#           =>  --  207C
          (0, 0, 8443, 8443),
         16#7D#           =>  --  207D
          (0, 0, 8444, 8444),
         16#7E#           =>  --  207E
          (0, 0, 8445, 8445),
         16#7F#           =>  --  207F
          (0, 0, 8446, 8446),
         16#80#           =>  --  2080
          (0, 0, 8447, 8447),
         16#81#           =>  --  2081
          (0, 0, 8448, 8448),
         16#82#           =>  --  2082
          (0, 0, 8449, 8449),
         16#83#           =>  --  2083
          (0, 0, 8450, 8450),
         16#84#           =>  --  2084
          (0, 0, 8451, 8451),
         16#85#           =>  --  2085
          (0, 0, 8452, 8452),
         16#86#           =>  --  2086
          (0, 0, 8453, 8453),
         16#87#           =>  --  2087
          (0, 0, 8454, 8454),
         16#88#           =>  --  2088
          (0, 0, 8455, 8455),
         16#89#           =>  --  2089
          (0, 0, 8456, 8456),
         16#8A#           =>  --  208A
          (0, 0, 8457, 8457),
         16#8B#           =>  --  208B
          (0, 0, 8458, 8458),
         16#8C#           =>  --  208C
          (0, 0, 8459, 8459),
         16#8D#           =>  --  208D
          (0, 0, 8460, 8460),
         16#8E#           =>  --  208E
          (0, 0, 8461, 8461),
         16#90#           =>  --  2090
          (0, 0, 8462, 8462),
         16#91#           =>  --  2091
          (0, 0, 8463, 8463),
         16#92#           =>  --  2092
          (0, 0, 8464, 8464),
         16#93#           =>  --  2093
          (0, 0, 8465, 8465),
         16#94#           =>  --  2094
          (0, 0, 8466, 8466),
         16#95#           =>  --  2095
          (0, 0, 8467, 8467),
         16#96#           =>  --  2096
          (0, 0, 8468, 8468),
         16#97#           =>  --  2097
          (0, 0, 8469, 8469),
         16#98#           =>  --  2098
          (0, 0, 8470, 8470),
         16#99#           =>  --  2099
          (0, 0, 8471, 8471),
         16#9A#           =>  --  209A
          (0, 0, 8472, 8472),
         16#9B#           =>  --  209B
          (0, 0, 8473, 8473),
         16#9C#           =>  --  209C
          (0, 0, 8474, 8474),
         16#A0#           =>  --  20A0
          (0, 0, 8475, 8475),
         16#A1#           =>  --  20A1
          (0, 0, 8476, 8476),
         16#A2#           =>  --  20A2
          (0, 0, 8477, 8477),
         16#A3#           =>  --  20A3
          (0, 0, 8478, 8478),
         16#A4#           =>  --  20A4
          (0, 0, 8479, 8479),
         16#A5#           =>  --  20A5
          (0, 0, 8480, 8480),
         16#A6#           =>  --  20A6
          (0, 0, 8481, 8481),
         16#A7#           =>  --  20A7
          (0, 0, 8482, 8482),
         16#A8#           =>  --  20A8
          (0, 0, 8483, 8483),
         16#A9#           =>  --  20A9
          (0, 0, 8484, 8484),
         16#AA#           =>  --  20AA
          (0, 0, 8485, 8485),
         16#AB#           =>  --  20AB
          (0, 0, 8486, 8486),
         16#AC#           =>  --  20AC
          (0, 0, 8487, 8487),
         16#AD#           =>  --  20AD
          (0, 0, 8488, 8488),
         16#AE#           =>  --  20AE
          (0, 0, 8489, 8489),
         16#AF#           =>  --  20AF
          (0, 0, 8490, 8490),
         16#B0#           =>  --  20B0
          (0, 0, 8491, 8491),
         16#B1#           =>  --  20B1
          (0, 0, 8492, 8492),
         16#B2#           =>  --  20B2
          (0, 0, 8493, 8493),
         16#B3#           =>  --  20B3
          (0, 0, 8494, 8494),
         16#B4#           =>  --  20B4
          (0, 0, 8495, 8495),
         16#B5#           =>  --  20B5
          (0, 0, 8496, 8496),
         16#B6#           =>  --  20B6
          (0, 0, 8497, 8497),
         16#B7#           =>  --  20B7
          (0, 0, 8498, 8498),
         16#B8#           =>  --  20B8
          (0, 0, 8499, 8499),
         16#B9#           =>  --  20B9
          (0, 0, 8500, 8500),
         16#BA#           =>  --  20BA
          (0, 0, 8501, 8501),
         16#BB#           =>  --  20BB
          (0, 0, 8502, 8502),
         16#BC#           =>  --  20BC
          (0, 0, 8503, 8503),
         16#BD#           =>  --  20BD
          (0, 0, 8504, 8504),
         16#D0#           =>  --  20D0
          (0, 0, 8505, 8505),
         16#D1#           =>  --  20D1
          (0, 0, 8506, 8506),
         16#D2# .. 16#D3# =>  --  20D2 .. 20D3
          (0, 0, 8507, 8507),
         16#D4#           =>  --  20D4
          (0, 0, 8508, 8508),
         16#D5#           =>  --  20D5
          (0, 0, 8509, 8509),
         16#D6#           =>  --  20D6
          (0, 0, 8510, 8510),
         16#D7#           =>  --  20D7
          (0, 0, 8511, 8511),
         16#D8# .. 16#DA# =>  --  20D8 .. 20DA
          (0, 0, 1057, 1057),
         16#DB#           =>  --  20DB
          (0, 0, 8512, 8512),
         16#DC#           =>  --  20DC
          (0, 0, 8513, 8513),
         16#DD# .. 16#E0# =>  --  20DD .. 20E0
          (0, 0, 6623, 6623),
         16#E1#           =>  --  20E1
          (0, 0, 8514, 8514),
         16#E2# .. 16#E4# =>  --  20E2 .. 20E4
          (0, 0, 6623, 6623),
         16#E5#           =>  --  20E5
          (0, 0, 1057, 1057),
         16#E6#           =>  --  20E6
          (0, 0, 8515, 8515),
         16#E7#           =>  --  20E7
          (0, 0, 8516, 8516),
         16#E8#           =>  --  20E8
          (0, 0, 8517, 8517),
         16#E9#           =>  --  20E9
          (0, 0, 8518, 8518),
         16#EA# .. 16#EB# =>  --  20EA .. 20EB
          (0, 0, 1057, 1057),
         16#EC# .. 16#EF# =>  --  20EC .. 20EF
          (0, 0, 1045, 1045),
         16#F0#           =>  --  20F0
          (0, 0, 1041, 1041),
         others           =>
          (0, 0, 0, 0));

   Group_0021 : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  2100
          (0, 0, 8519, 8521),
         16#01#           =>  --  2101
          (0, 0, 8522, 8524),
         16#02#           =>  --  2102
          (0, 0, 8525, 8525),
         16#03#           =>  --  2103
          (0, 0, 8526, 8527),
         16#04#           =>  --  2104
          (0, 0, 8528, 8528),
         16#05#           =>  --  2105
          (0, 0, 8529, 8531),
         16#06#           =>  --  2106
          (0, 0, 8532, 8534),
         16#07#           =>  --  2107
          (0, 0, 8535, 8535),
         16#08#           =>  --  2108
          (0, 0, 8536, 8536),
         16#09#           =>  --  2109
          (0, 0, 8537, 8538),
         16#0A#           =>  --  210A
          (0, 0, 8539, 8539),
         16#0B# .. 16#0D# =>  --  210B .. 210D
          (0, 0, 8540, 8540),
         16#0E#           =>  --  210E
          (0, 0, 8541, 8541),
         16#0F#           =>  --  210F
          (0, 0, 349, 350),
         16#10# .. 16#11# =>  --  2110 .. 2111
          (0, 0, 8542, 8542),
         16#12#           =>  --  2112
          (0, 0, 8543, 8543),
         16#13#           =>  --  2113
          (0, 0, 8544, 8544),
         16#14#           =>  --  2114
          (0, 0, 8545, 8545),
         16#15#           =>  --  2115
          (0, 0, 8546, 8546),
         16#16#           =>  --  2116
          (0, 0, 8547, 8548),
         16#17#           =>  --  2117
          (0, 0, 8549, 8549),
         16#18#           =>  --  2118
          (0, 0, 8550, 8550),
         16#19#           =>  --  2119
          (0, 0, 8551, 8551),
         16#1A#           =>  --  211A
          (0, 0, 8552, 8552),
         16#1B# .. 16#1D# =>  --  211B .. 211D
          (0, 0, 8553, 8553),
         16#1E#           =>  --  211E
          (0, 0, 8554, 8554),
         16#1F#           =>  --  211F
          (0, 0, 8555, 8555),
         16#20#           =>  --  2120
          (0, 0, 8556, 8557),
         16#21#           =>  --  2121
          (0, 0, 8558, 8560),
         16#22#           =>  --  2122
          (0, 0, 8561, 8562),
         16#23#           =>  --  2123
          (0, 0, 8563, 8563),
         16#24#           =>  --  2124
          (0, 0, 8564, 8564),
         16#25#           =>  --  2125
          (0, 0, 8565, 8565),
         16#26#           =>  --  2126
          (0, 0, 1097, 1097),
         16#27#           =>  --  2127
          (0, 0, 8566, 8566),
         16#28#           =>  --  2128
          (0, 0, 8564, 8564),
         16#29#           =>  --  2129
          (0, 0, 8567, 8567),
         16#2A#           =>  --  212A
          (0, 0, 50, 50),
         16#2B#           =>  --  212B
          (0, 0, 154, 155),
         16#2C#           =>  --  212C
          (0, 0, 8568, 8568),
         16#2D#           =>  --  212D
          (0, 0, 8525, 8525),
         16#2E#           =>  --  212E
          (0, 0, 8569, 8569),
         16#2F#           =>  --  212F
          (0, 0, 8570, 8570),
         16#30#           =>  --  2130
          (0, 0, 8571, 8571),
         16#31#           =>  --  2131
          (0, 0, 8572, 8572),
         16#32#           =>  --  2132
          (0, 0, 8573, 8573),
         16#33#           =>  --  2133
          (0, 0, 8574, 8574),
         16#34#           =>  --  2134
          (0, 0, 8575, 8575),
         16#35#           =>  --  2135
          (0, 0, 8576, 8576),
         16#36#           =>  --  2136
          (0, 0, 8577, 8577),
         16#37#           =>  --  2137
          (0, 0, 8578, 8578),
         16#38#           =>  --  2138
          (0, 0, 8579, 8579),
         16#39#           =>  --  2139
          (0, 0, 8580, 8580),
         16#3A#           =>  --  213A
          (0, 0, 8581, 8581),
         16#3B#           =>  --  213B
          (0, 0, 8582, 8584),
         16#3C#           =>  --  213C
          (0, 0, 8585, 8585),
         16#3D#           =>  --  213D
          (0, 0, 8586, 8586),
         16#3E#           =>  --  213E
          (0, 0, 8587, 8587),
         16#3F#           =>  --  213F
          (0, 0, 8588, 8588),
         16#40#           =>  --  2140
          (0, 0, 8589, 8589),
         16#41#           =>  --  2141
          (0, 0, 8590, 8590),
         16#42#           =>  --  2142
          (0, 0, 8591, 8591),
         16#43#           =>  --  2143
          (0, 0, 8592, 8592),
         16#44#           =>  --  2144
          (0, 0, 8593, 8593),
         16#45#           =>  --  2145
          (0, 0, 8594, 8594),
         16#46#           =>  --  2146
          (0, 0, 8595, 8595),
         16#47#           =>  --  2147
          (0, 0, 8570, 8570),
         16#48#           =>  --  2148
          (0, 0, 8580, 8580),
         16#49#           =>  --  2149
          (0, 0, 8596, 8596),
         16#4A#           =>  --  214A
          (0, 0, 8597, 8597),
         16#4B#           =>  --  214B
          (0, 0, 8598, 8598),
         16#4C#           =>  --  214C
          (0, 0, 8599, 8599),
         16#4D#           =>  --  214D
          (0, 0, 8600, 8602),
         16#4E#           =>  --  214E
          (0, 0, 8603, 8603),
         16#4F#           =>  --  214F
          (0, 0, 8604, 8604),
         16#50#           =>  --  2150
          (0, 0, 8605, 8607),
         16#51#           =>  --  2151
          (0, 0, 8608, 8610),
         16#52#           =>  --  2152
          (0, 0, 8611, 8614),
         16#53#           =>  --  2153
          (0, 0, 8615, 8617),
         16#54#           =>  --  2154
          (0, 0, 8618, 8620),
         16#55#           =>  --  2155
          (0, 0, 8621, 8623),
         16#56#           =>  --  2156
          (0, 0, 8624, 8626),
         16#57#           =>  --  2157
          (0, 0, 8627, 8629),
         16#58#           =>  --  2158
          (0, 0, 8630, 8632),
         16#59#           =>  --  2159
          (0, 0, 8633, 8635),
         16#5A#           =>  --  215A
          (0, 0, 8636, 8638),
         16#5B#           =>  --  215B
          (0, 0, 8639, 8641),
         16#5C#           =>  --  215C
          (0, 0, 8642, 8644),
         16#5D#           =>  --  215D
          (0, 0, 8645, 8647),
         16#5E#           =>  --  215E
          (0, 0, 8648, 8650),
         16#5F#           =>  --  215F
          (0, 0, 134, 135),
         16#60#           =>  --  2160
          (0, 0, 370, 370),
         16#61#           =>  --  2161
          (0, 0, 8651, 8652),
         16#62#           =>  --  2162
          (0, 0, 8653, 8655),
         16#63#           =>  --  2163
          (0, 0, 8656, 8657),
         16#64#           =>  --  2164
          (0, 0, 8657, 8657),
         16#65#           =>  --  2165
          (0, 0, 8658, 8659),
         16#66#           =>  --  2166
          (0, 0, 8660, 8662),
         16#67#           =>  --  2167
          (0, 0, 8663, 8666),
         16#68#           =>  --  2168
          (0, 0, 8667, 8668),
         16#69#           =>  --  2169
          (0, 0, 8584, 8584),
         16#6A#           =>  --  216A
          (0, 0, 8669, 8670),
         16#6B#           =>  --  216B
          (0, 0, 8671, 8673),
         16#6C#           =>  --  216C
          (0, 0, 602, 602),
         16#6D#           =>  --  216D
          (0, 0, 8527, 8527),
         16#6E#           =>  --  216E
          (0, 0, 177, 177),
         16#6F#           =>  --  216F
          (0, 0, 8674, 8674),
         16#70#           =>  --  2170
          (0, 0, 372, 372),
         16#71#           =>  --  2171
          (0, 0, 8675, 8676),
         16#72#           =>  --  2172
          (0, 0, 8677, 8679),
         16#73#           =>  --  2173
          (0, 0, 8680, 8681),
         16#74#           =>  --  2174
          (0, 0, 1069, 1069),
         16#75#           =>  --  2175
          (0, 0, 8682, 8683),
         16#76#           =>  --  2176
          (0, 0, 8684, 8686),
         16#77#           =>  --  2177
          (0, 0, 8687, 8690),
         16#78#           =>  --  2178
          (0, 0, 8691, 8692),
         16#79#           =>  --  2179
          (0, 0, 1070, 1070),
         16#7A#           =>  --  217A
          (0, 0, 8693, 8694),
         16#7B#           =>  --  217B
          (0, 0, 8695, 8697),
         16#7C#           =>  --  217C
          (0, 0, 606, 606),
         16#7D#           =>  --  217D
          (0, 0, 1065, 1065),
         16#7E#           =>  --  217E
          (0, 0, 241, 241),
         16#7F#           =>  --  217F
          (0, 0, 1067, 1067),
         16#80#           =>  --  2180
          (0, 0, 8698, 8698),
         16#81#           =>  --  2181
          (0, 0, 8699, 8699),
         16#82#           =>  --  2182
          (0, 0, 8700, 8700),
         16#83#           =>  --  2183
          (0, 0, 8701, 8701),
         16#84#           =>  --  2184
          (0, 0, 8702, 8702),
         16#85#           =>  --  2185
          (0, 0, 29, 29),
         16#86#           =>  --  2186
          (0, 0, 8703, 8703),
         16#87#           =>  --  2187
          (0, 0, 8704, 8704),
         16#88#           =>  --  2188
          (0, 0, 8705, 8705),
         16#89#           =>  --  2189
          (0, 0, 8706, 8708),
         16#90#           =>  --  2190
          (0, 0, 8709, 8709),
         16#91#           =>  --  2191
          (0, 0, 8710, 8710),
         16#92#           =>  --  2192
          (0, 0, 8711, 8711),
         16#93#           =>  --  2193
          (0, 0, 8712, 8712),
         16#94#           =>  --  2194
          (0, 0, 8713, 8713),
         16#95#           =>  --  2195
          (0, 0, 8714, 8714),
         16#96#           =>  --  2196
          (0, 0, 8715, 8715),
         16#97#           =>  --  2197
          (0, 0, 8716, 8716),
         16#98#           =>  --  2198
          (0, 0, 8717, 8717),
         16#99#           =>  --  2199
          (0, 0, 8718, 8718),
         16#9A#           =>  --  219A
          (0, 0, 8719, 8720),
         16#9B#           =>  --  219B
          (0, 0, 8721, 8722),
         16#9C#           =>  --  219C
          (0, 0, 8723, 8723),
         16#9D#           =>  --  219D
          (0, 0, 8724, 8724),
         16#9E#           =>  --  219E
          (0, 0, 8725, 8725),
         16#9F#           =>  --  219F
          (0, 0, 8726, 8726),
         16#A0#           =>  --  21A0
          (0, 0, 8727, 8727),
         16#A1#           =>  --  21A1
          (0, 0, 8728, 8728),
         16#A2#           =>  --  21A2
          (0, 0, 8729, 8729),
         16#A3#           =>  --  21A3
          (0, 0, 8730, 8730),
         16#A4#           =>  --  21A4
          (0, 0, 8731, 8731),
         16#A5#           =>  --  21A5
          (0, 0, 8732, 8732),
         16#A6#           =>  --  21A6
          (0, 0, 8733, 8733),
         16#A7#           =>  --  21A7
          (0, 0, 8734, 8734),
         16#A8#           =>  --  21A8
          (0, 0, 8735, 8735),
         16#A9#           =>  --  21A9
          (0, 0, 8736, 8736),
         16#AA#           =>  --  21AA
          (0, 0, 8737, 8737),
         16#AB#           =>  --  21AB
          (0, 0, 8738, 8738),
         16#AC#           =>  --  21AC
          (0, 0, 8739, 8739),
         16#AD#           =>  --  21AD
          (0, 0, 8740, 8740),
         16#AE#           =>  --  21AE
          (0, 0, 8741, 8742),
         16#AF#           =>  --  21AF
          (0, 0, 8743, 8743),
         16#B0#           =>  --  21B0
          (0, 0, 8744, 8744),
         16#B1#           =>  --  21B1
          (0, 0, 8745, 8745),
         16#B2#           =>  --  21B2
          (0, 0, 8746, 8746),
         16#B3#           =>  --  21B3
          (0, 0, 8747, 8747),
         16#B4#           =>  --  21B4
          (0, 0, 8748, 8748),
         16#B5#           =>  --  21B5
          (0, 0, 8749, 8749),
         16#B6#           =>  --  21B6
          (0, 0, 8750, 8750),
         16#B7#           =>  --  21B7
          (0, 0, 8751, 8751),
         16#B8#           =>  --  21B8
          (0, 0, 8752, 8752),
         16#B9#           =>  --  21B9
          (0, 0, 8753, 8753),
         16#BA#           =>  --  21BA
          (0, 0, 8754, 8754),
         16#BB#           =>  --  21BB
          (0, 0, 8755, 8755),
         16#BC#           =>  --  21BC
          (0, 0, 8756, 8756),
         16#BD#           =>  --  21BD
          (0, 0, 8757, 8757),
         16#BE#           =>  --  21BE
          (0, 0, 8758, 8758),
         16#BF#           =>  --  21BF
          (0, 0, 8759, 8759),
         16#C0#           =>  --  21C0
          (0, 0, 8760, 8760),
         16#C1#           =>  --  21C1
          (0, 0, 8761, 8761),
         16#C2#           =>  --  21C2
          (0, 0, 8762, 8762),
         16#C3#           =>  --  21C3
          (0, 0, 8763, 8763),
         16#C4#           =>  --  21C4
          (0, 0, 8764, 8764),
         16#C5#           =>  --  21C5
          (0, 0, 8765, 8765),
         16#C6#           =>  --  21C6
          (0, 0, 8766, 8766),
         16#C7#           =>  --  21C7
          (0, 0, 8767, 8767),
         16#C8#           =>  --  21C8
          (0, 0, 8768, 8768),
         16#C9#           =>  --  21C9
          (0, 0, 8769, 8769),
         16#CA#           =>  --  21CA
          (0, 0, 8770, 8770),
         16#CB#           =>  --  21CB
          (0, 0, 8771, 8771),
         16#CC#           =>  --  21CC
          (0, 0, 8772, 8772),
         16#CD#           =>  --  21CD
          (0, 0, 8773, 8774),
         16#CE#           =>  --  21CE
          (0, 0, 8775, 8776),
         16#CF#           =>  --  21CF
          (0, 0, 8777, 8778),
         16#D0#           =>  --  21D0
          (0, 0, 8773, 8773),
         16#D1#           =>  --  21D1
          (0, 0, 8779, 8779),
         16#D2#           =>  --  21D2
          (0, 0, 8777, 8777),
         16#D3#           =>  --  21D3
          (0, 0, 8780, 8780),
         16#D4#           =>  --  21D4
          (0, 0, 8775, 8775),
         16#D5#           =>  --  21D5
          (0, 0, 8781, 8781),
         16#D6#           =>  --  21D6
          (0, 0, 8782, 8782),
         16#D7#           =>  --  21D7
          (0, 0, 8783, 8783),
         16#D8#           =>  --  21D8
          (0, 0, 8784, 8784),
         16#D9#           =>  --  21D9
          (0, 0, 8785, 8785),
         16#DA#           =>  --  21DA
          (0, 0, 8786, 8786),
         16#DB#           =>  --  21DB
          (0, 0, 8787, 8787),
         16#DC#           =>  --  21DC
          (0, 0, 8788, 8788),
         16#DD#           =>  --  21DD
          (0, 0, 8789, 8789),
         16#DE#           =>  --  21DE
          (0, 0, 8790, 8790),
         16#DF#           =>  --  21DF
          (0, 0, 8791, 8791),
         16#E0#           =>  --  21E0
          (0, 0, 8792, 8792),
         16#E1#           =>  --  21E1
          (0, 0, 8793, 8793),
         16#E2#           =>  --  21E2
          (0, 0, 8794, 8794),
         16#E3#           =>  --  21E3
          (0, 0, 8795, 8795),
         16#E4#           =>  --  21E4
          (0, 0, 8796, 8796),
         16#E5#           =>  --  21E5
          (0, 0, 8797, 8797),
         16#E6#           =>  --  21E6
          (0, 0, 8798, 8798),
         16#E7#           =>  --  21E7
          (0, 0, 8799, 8799),
         16#E8#           =>  --  21E8
          (0, 0, 8800, 8800),
         16#E9#           =>  --  21E9
          (0, 0, 8801, 8801),
         16#EA#           =>  --  21EA
          (0, 0, 8802, 8802),
         16#EB#           =>  --  21EB
          (0, 0, 8803, 8803),
         16#EC#           =>  --  21EC
          (0, 0, 8804, 8804),
         16#ED#           =>  --  21ED
          (0, 0, 8805, 8805),
         16#EE#           =>  --  21EE
          (0, 0, 8806, 8806),
         16#EF#           =>  --  21EF
          (0, 0, 8807, 8807),
         16#F0#           =>  --  21F0
          (0, 0, 8808, 8808),
         16#F1#           =>  --  21F1
          (0, 0, 8809, 8809),
         16#F2#           =>  --  21F2
          (0, 0, 8810, 8810),
         16#F3#           =>  --  21F3
          (0, 0, 8811, 8811),
         16#F4#           =>  --  21F4
          (0, 0, 8812, 8812),
         16#F5#           =>  --  21F5
          (0, 0, 8813, 8813),
         16#F6#           =>  --  21F6
          (0, 0, 8814, 8814),
         16#F7#           =>  --  21F7
          (0, 0, 8815, 8815),
         16#F8#           =>  --  21F8
          (0, 0, 8816, 8816),
         16#F9#           =>  --  21F9
          (0, 0, 8817, 8817),
         16#FA#           =>  --  21FA
          (0, 0, 8818, 8818),
         16#FB#           =>  --  21FB
          (0, 0, 8819, 8819),
         16#FC#           =>  --  21FC
          (0, 0, 8820, 8820),
         16#FD#           =>  --  21FD
          (0, 0, 8821, 8821),
         16#FE#           =>  --  21FE
          (0, 0, 8822, 8822),
         16#FF#           =>  --  21FF
          (0, 0, 8823, 8823),
         others           =>
          (0, 0, 0, 0));

   Group_0022 : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  2200
          (0, 0, 8824, 8824),
         16#01#           =>  --  2201
          (0, 0, 8825, 8825),
         16#02#           =>  --  2202
          (0, 0, 8826, 8826),
         16#03#           =>  --  2203
          (0, 0, 8827, 8827),
         16#04#           =>  --  2204
          (0, 0, 8828, 8829),
         16#05#           =>  --  2205
          (0, 0, 8830, 8830),
         16#06#           =>  --  2206
          (0, 0, 8831, 8831),
         16#07#           =>  --  2207
          (0, 0, 8832, 8832),
         16#08#           =>  --  2208
          (0, 0, 8833, 8833),
         16#09#           =>  --  2209
          (0, 0, 8834, 8835),
         16#0A#           =>  --  220A
          (0, 0, 8836, 8836),
         16#0B#           =>  --  220B
          (0, 0, 8837, 8837),
         16#0C#           =>  --  220C
          (0, 0, 8838, 8839),
         16#0D#           =>  --  220D
          (0, 0, 8840, 8840),
         16#0E#           =>  --  220E
          (0, 0, 8841, 8841),
         16#0F#           =>  --  220F
          (0, 0, 8842, 8842),
         16#10#           =>  --  2210
          (0, 0, 8843, 8843),
         16#11#           =>  --  2211
          (0, 0, 8844, 8844),
         16#12#           =>  --  2212
          (0, 0, 8845, 8845),
         16#13#           =>  --  2213
          (0, 0, 8846, 8846),
         16#14#           =>  --  2214
          (0, 0, 8847, 8847),
         16#15#           =>  --  2215
          (0, 0, 8848, 8848),
         16#16#           =>  --  2216
          (0, 0, 8849, 8849),
         16#17#           =>  --  2217
          (0, 0, 8850, 8850),
         16#18#           =>  --  2218
          (0, 0, 8851, 8851),
         16#19#           =>  --  2219
          (0, 0, 8852, 8852),
         16#1A#           =>  --  221A
          (0, 0, 8853, 8853),
         16#1B#           =>  --  221B
          (0, 0, 8854, 8854),
         16#1C#           =>  --  221C
          (0, 0, 8855, 8855),
         16#1D#           =>  --  221D
          (0, 0, 8856, 8856),
         16#1E#           =>  --  221E
          (0, 0, 8857, 8857),
         16#1F#           =>  --  221F
          (0, 0, 8858, 8858),
         16#20#           =>  --  2220
          (0, 0, 8859, 8859),
         16#21#           =>  --  2221
          (0, 0, 8860, 8860),
         16#22#           =>  --  2222
          (0, 0, 8861, 8861),
         16#23#           =>  --  2223
          (0, 0, 8862, 8862),
         16#24#           =>  --  2224
          (0, 0, 8863, 8864),
         16#25#           =>  --  2225
          (0, 0, 8865, 8865),
         16#26#           =>  --  2226
          (0, 0, 8866, 8867),
         16#27#           =>  --  2227
          (0, 0, 8868, 8868),
         16#28#           =>  --  2228
          (0, 0, 8869, 8869),
         16#29#           =>  --  2229
          (0, 0, 8870, 8870),
         16#2A#           =>  --  222A
          (0, 0, 8871, 8871),
         16#2B#           =>  --  222B
          (0, 0, 8872, 8872),
         16#2C#           =>  --  222C
          (0, 0, 8873, 8874),
         16#2D#           =>  --  222D
          (0, 0, 8875, 8877),
         16#2E#           =>  --  222E
          (0, 0, 8878, 8878),
         16#2F#           =>  --  222F
          (0, 0, 8879, 8880),
         16#30#           =>  --  2230
          (0, 0, 8881, 8883),
         16#31#           =>  --  2231
          (0, 0, 8884, 8884),
         16#32#           =>  --  2232
          (0, 0, 8885, 8885),
         16#33#           =>  --  2233
          (0, 0, 8886, 8886),
         16#34#           =>  --  2234
          (0, 0, 8887, 8887),
         16#35#           =>  --  2235
          (0, 0, 8888, 8888),
         16#36#           =>  --  2236
          (0, 0, 8889, 8889),
         16#37#           =>  --  2237
          (0, 0, 8890, 8890),
         16#38#           =>  --  2238
          (0, 0, 8891, 8891),
         16#39#           =>  --  2239
          (0, 0, 8892, 8892),
         16#3A#           =>  --  223A
          (0, 0, 8893, 8893),
         16#3B#           =>  --  223B
          (0, 0, 8894, 8894),
         16#3C#           =>  --  223C
          (0, 0, 8895, 8895),
         16#3D#           =>  --  223D
          (0, 0, 8896, 8896),
         16#3E#           =>  --  223E
          (0, 0, 8897, 8897),
         16#3F#           =>  --  223F
          (0, 0, 8898, 8898),
         16#40#           =>  --  2240
          (0, 0, 8899, 8899),
         16#41#           =>  --  2241
          (0, 0, 8900, 8901),
         16#42#           =>  --  2242
          (0, 0, 8902, 8902),
         16#43#           =>  --  2243
          (0, 0, 8903, 8903),
         16#44#           =>  --  2244
          (0, 0, 8904, 8905),
         16#45#           =>  --  2245
          (0, 0, 8906, 8906),
         16#46#           =>  --  2246
          (0, 0, 8907, 8907),
         16#47#           =>  --  2247
          (0, 0, 8908, 8909),
         16#48#           =>  --  2248
          (0, 0, 8910, 8910),
         16#49#           =>  --  2249
          (0, 0, 8911, 8912),
         16#4A#           =>  --  224A
          (0, 0, 8913, 8913),
         16#4B#           =>  --  224B
          (0, 0, 8914, 8914),
         16#4C#           =>  --  224C
          (0, 0, 8915, 8915),
         16#4D#           =>  --  224D
          (0, 0, 8916, 8916),
         16#4E#           =>  --  224E
          (0, 0, 8917, 8917),
         16#4F#           =>  --  224F
          (0, 0, 8918, 8918),
         16#50#           =>  --  2250
          (0, 0, 8919, 8919),
         16#51#           =>  --  2251
          (0, 0, 8920, 8920),
         16#52#           =>  --  2252
          (0, 0, 8921, 8921),
         16#53#           =>  --  2253
          (0, 0, 8922, 8922),
         16#54#           =>  --  2254
          (0, 0, 8923, 8923),
         16#55#           =>  --  2255
          (0, 0, 8924, 8924),
         16#56#           =>  --  2256
          (0, 0, 8925, 8925),
         16#57#           =>  --  2257
          (0, 0, 8926, 8926),
         16#58#           =>  --  2258
          (0, 0, 8927, 8927),
         16#59#           =>  --  2259
          (0, 0, 8928, 8928),
         16#5A#           =>  --  225A
          (0, 0, 8929, 8929),
         16#5B#           =>  --  225B
          (0, 0, 8930, 8930),
         16#5C#           =>  --  225C
          (0, 0, 8931, 8931),
         16#5D#           =>  --  225D
          (0, 0, 8932, 8932),
         16#5E#           =>  --  225E
          (0, 0, 8933, 8933),
         16#5F#           =>  --  225F
          (0, 0, 8934, 8934),
         16#60#           =>  --  2260
          (0, 0, 8935, 8936),
         16#61#           =>  --  2261
          (0, 0, 8937, 8937),
         16#62#           =>  --  2262
          (0, 0, 8938, 8939),
         16#63#           =>  --  2263
          (0, 0, 8940, 8940),
         16#64#           =>  --  2264
          (0, 0, 8941, 8941),
         16#65#           =>  --  2265
          (0, 0, 8942, 8942),
         16#66#           =>  --  2266
          (0, 0, 8943, 8943),
         16#67#           =>  --  2267
          (0, 0, 8944, 8944),
         16#68#           =>  --  2268
          (0, 0, 8945, 8945),
         16#69#           =>  --  2269
          (0, 0, 8946, 8946),
         16#6A#           =>  --  226A
          (0, 0, 8947, 8947),
         16#6B#           =>  --  226B
          (0, 0, 8948, 8948),
         16#6C#           =>  --  226C
          (0, 0, 8949, 8949),
         16#6D#           =>  --  226D
          (0, 0, 8950, 8951),
         16#6E#           =>  --  226E
          (0, 0, 8952, 8953),
         16#6F#           =>  --  226F
          (0, 0, 8954, 8955),
         16#70#           =>  --  2270
          (0, 0, 8956, 8957),
         16#71#           =>  --  2271
          (0, 0, 8958, 8959),
         16#72#           =>  --  2272
          (0, 0, 8960, 8960),
         16#73#           =>  --  2273
          (0, 0, 8961, 8961),
         16#74#           =>  --  2274
          (0, 0, 8962, 8963),
         16#75#           =>  --  2275
          (0, 0, 8964, 8965),
         16#76#           =>  --  2276
          (0, 0, 8966, 8966),
         16#77#           =>  --  2277
          (0, 0, 8967, 8967),
         16#78#           =>  --  2278
          (0, 0, 8968, 8969),
         16#79#           =>  --  2279
          (0, 0, 8970, 8971),
         16#7A#           =>  --  227A
          (0, 0, 8972, 8972),
         16#7B#           =>  --  227B
          (0, 0, 8973, 8973),
         16#7C#           =>  --  227C
          (0, 0, 8974, 8974),
         16#7D#           =>  --  227D
          (0, 0, 8975, 8975),
         16#7E#           =>  --  227E
          (0, 0, 8976, 8976),
         16#7F#           =>  --  227F
          (0, 0, 8977, 8977),
         16#80#           =>  --  2280
          (0, 0, 8978, 8979),
         16#81#           =>  --  2281
          (0, 0, 8980, 8981),
         16#82#           =>  --  2282
          (0, 0, 8982, 8982),
         16#83#           =>  --  2283
          (0, 0, 8983, 8983),
         16#84#           =>  --  2284
          (0, 0, 8984, 8985),
         16#85#           =>  --  2285
          (0, 0, 8986, 8987),
         16#86#           =>  --  2286
          (0, 0, 8988, 8988),
         16#87#           =>  --  2287
          (0, 0, 8989, 8989),
         16#88#           =>  --  2288
          (0, 0, 8990, 8991),
         16#89#           =>  --  2289
          (0, 0, 8992, 8993),
         16#8A#           =>  --  228A
          (0, 0, 8994, 8994),
         16#8B#           =>  --  228B
          (0, 0, 8995, 8995),
         16#8C#           =>  --  228C
          (0, 0, 8996, 8996),
         16#8D#           =>  --  228D
          (0, 0, 8997, 8997),
         16#8E#           =>  --  228E
          (0, 0, 8998, 8998),
         16#8F#           =>  --  228F
          (0, 0, 8999, 8999),
         16#90#           =>  --  2290
          (0, 0, 9000, 9000),
         16#91#           =>  --  2291
          (0, 0, 9001, 9001),
         16#92#           =>  --  2292
          (0, 0, 9002, 9002),
         16#93#           =>  --  2293
          (0, 0, 9003, 9003),
         16#94#           =>  --  2294
          (0, 0, 9004, 9004),
         16#95#           =>  --  2295
          (0, 0, 9005, 9005),
         16#96#           =>  --  2296
          (0, 0, 9006, 9006),
         16#97#           =>  --  2297
          (0, 0, 9007, 9007),
         16#98#           =>  --  2298
          (0, 0, 9008, 9008),
         16#99#           =>  --  2299
          (0, 0, 9009, 9009),
         16#9A#           =>  --  229A
          (0, 0, 9010, 9010),
         16#9B#           =>  --  229B
          (0, 0, 9011, 9011),
         16#9C#           =>  --  229C
          (0, 0, 9012, 9012),
         16#9D#           =>  --  229D
          (0, 0, 9013, 9013),
         16#9E#           =>  --  229E
          (0, 0, 9014, 9014),
         16#9F#           =>  --  229F
          (0, 0, 9015, 9015),
         16#A0#           =>  --  22A0
          (0, 0, 9016, 9016),
         16#A1#           =>  --  22A1
          (0, 0, 9017, 9017),
         16#A2#           =>  --  22A2
          (0, 0, 9018, 9018),
         16#A3#           =>  --  22A3
          (0, 0, 9019, 9019),
         16#A4#           =>  --  22A4
          (0, 0, 9020, 9020),
         16#A5#           =>  --  22A5
          (0, 0, 9021, 9021),
         16#A6#           =>  --  22A6
          (0, 0, 9022, 9022),
         16#A7#           =>  --  22A7
          (0, 0, 9023, 9023),
         16#A8#           =>  --  22A8
          (0, 0, 9024, 9024),
         16#A9#           =>  --  22A9
          (0, 0, 9025, 9025),
         16#AA#           =>  --  22AA
          (0, 0, 9026, 9026),
         16#AB#           =>  --  22AB
          (0, 0, 9027, 9027),
         16#AC#           =>  --  22AC
          (0, 0, 9028, 9029),
         16#AD#           =>  --  22AD
          (0, 0, 9030, 9031),
         16#AE#           =>  --  22AE
          (0, 0, 9032, 9033),
         16#AF#           =>  --  22AF
          (0, 0, 9034, 9035),
         16#B0#           =>  --  22B0
          (0, 0, 9036, 9036),
         16#B1#           =>  --  22B1
          (0, 0, 9037, 9037),
         16#B2#           =>  --  22B2
          (0, 0, 9038, 9038),
         16#B3#           =>  --  22B3
          (0, 0, 9039, 9039),
         16#B4#           =>  --  22B4
          (0, 0, 9040, 9040),
         16#B5#           =>  --  22B5
          (0, 0, 9041, 9041),
         16#B6#           =>  --  22B6
          (0, 0, 9042, 9042),
         16#B7#           =>  --  22B7
          (0, 0, 9043, 9043),
         16#B8#           =>  --  22B8
          (0, 0, 9044, 9044),
         16#B9#           =>  --  22B9
          (0, 0, 9045, 9045),
         16#BA#           =>  --  22BA
          (0, 0, 9046, 9046),
         16#BB#           =>  --  22BB
          (0, 0, 9047, 9047),
         16#BC#           =>  --  22BC
          (0, 0, 9048, 9048),
         16#BD#           =>  --  22BD
          (0, 0, 9049, 9049),
         16#BE#           =>  --  22BE
          (0, 0, 9050, 9050),
         16#BF#           =>  --  22BF
          (0, 0, 9051, 9051),
         16#C0#           =>  --  22C0
          (0, 0, 9052, 9052),
         16#C1#           =>  --  22C1
          (0, 0, 9053, 9053),
         16#C2#           =>  --  22C2
          (0, 0, 9054, 9054),
         16#C3#           =>  --  22C3
          (0, 0, 9055, 9055),
         16#C4#           =>  --  22C4
          (0, 0, 9056, 9056),
         16#C5#           =>  --  22C5
          (0, 0, 9057, 9057),
         16#C6#           =>  --  22C6
          (0, 0, 9058, 9058),
         16#C7#           =>  --  22C7
          (0, 0, 9059, 9059),
         16#C8#           =>  --  22C8
          (0, 0, 9060, 9060),
         16#C9#           =>  --  22C9
          (0, 0, 9061, 9061),
         16#CA#           =>  --  22CA
          (0, 0, 9062, 9062),
         16#CB#           =>  --  22CB
          (0, 0, 9063, 9063),
         16#CC#           =>  --  22CC
          (0, 0, 9064, 9064),
         16#CD#           =>  --  22CD
          (0, 0, 9065, 9065),
         16#CE#           =>  --  22CE
          (0, 0, 9066, 9066),
         16#CF#           =>  --  22CF
          (0, 0, 9067, 9067),
         16#D0#           =>  --  22D0
          (0, 0, 9068, 9068),
         16#D1#           =>  --  22D1
          (0, 0, 9069, 9069),
         16#D2#           =>  --  22D2
          (0, 0, 9070, 9070),
         16#D3#           =>  --  22D3
          (0, 0, 9071, 9071),
         16#D4#           =>  --  22D4
          (0, 0, 9072, 9072),
         16#D5#           =>  --  22D5
          (0, 0, 9073, 9073),
         16#D6#           =>  --  22D6
          (0, 0, 9074, 9074),
         16#D7#           =>  --  22D7
          (0, 0, 9075, 9075),
         16#D8#           =>  --  22D8
          (0, 0, 9076, 9076),
         16#D9#           =>  --  22D9
          (0, 0, 9077, 9077),
         16#DA#           =>  --  22DA
          (0, 0, 9078, 9078),
         16#DB#           =>  --  22DB
          (0, 0, 9079, 9079),
         16#DC#           =>  --  22DC
          (0, 0, 9080, 9080),
         16#DD#           =>  --  22DD
          (0, 0, 9081, 9081),
         16#DE#           =>  --  22DE
          (0, 0, 9082, 9082),
         16#DF#           =>  --  22DF
          (0, 0, 9083, 9083),
         16#E0#           =>  --  22E0
          (0, 0, 9084, 9085),
         16#E1#           =>  --  22E1
          (0, 0, 9086, 9087),
         16#E2#           =>  --  22E2
          (0, 0, 9088, 9089),
         16#E3#           =>  --  22E3
          (0, 0, 9090, 9091),
         16#E4#           =>  --  22E4
          (0, 0, 9092, 9092),
         16#E5#           =>  --  22E5
          (0, 0, 9093, 9093),
         16#E6#           =>  --  22E6
          (0, 0, 9094, 9094),
         16#E7#           =>  --  22E7
          (0, 0, 9095, 9095),
         16#E8#           =>  --  22E8
          (0, 0, 9096, 9096),
         16#E9#           =>  --  22E9
          (0, 0, 9097, 9097),
         16#EA#           =>  --  22EA
          (0, 0, 9098, 9099),
         16#EB#           =>  --  22EB
          (0, 0, 9100, 9101),
         16#EC#           =>  --  22EC
          (0, 0, 9102, 9103),
         16#ED#           =>  --  22ED
          (0, 0, 9104, 9105),
         16#EE#           =>  --  22EE
          (0, 0, 9106, 9106),
         16#EF#           =>  --  22EF
          (0, 0, 9107, 9107),
         16#F0#           =>  --  22F0
          (0, 0, 9108, 9108),
         16#F1#           =>  --  22F1
          (0, 0, 9109, 9109),
         16#F2#           =>  --  22F2
          (0, 0, 9110, 9110),
         16#F3#           =>  --  22F3
          (0, 0, 9111, 9111),
         16#F4#           =>  --  22F4
          (0, 0, 9112, 9112),
         16#F5#           =>  --  22F5
          (0, 0, 9113, 9113),
         16#F6#           =>  --  22F6
          (0, 0, 9114, 9114),
         16#F7#           =>  --  22F7
          (0, 0, 9115, 9115),
         16#F8#           =>  --  22F8
          (0, 0, 9116, 9116),
         16#F9#           =>  --  22F9
          (0, 0, 9117, 9117),
         16#FA#           =>  --  22FA
          (0, 0, 9118, 9118),
         16#FB#           =>  --  22FB
          (0, 0, 9119, 9119),
         16#FC#           =>  --  22FC
          (0, 0, 9120, 9120),
         16#FD#           =>  --  22FD
          (0, 0, 9121, 9121),
         16#FE#           =>  --  22FE
          (0, 0, 9122, 9122),
         16#FF#           =>  --  22FF
          (0, 0, 9123, 9123),
         others           =>
          (0, 0, 0, 0));

   Group_0023 : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  2300
          (0, 0, 9124, 9124),
         16#01#           =>  --  2301
          (0, 0, 9125, 9125),
         16#02#           =>  --  2302
          (0, 0, 9126, 9126),
         16#03#           =>  --  2303
          (0, 0, 9127, 9127),
         16#04#           =>  --  2304
          (0, 0, 9128, 9128),
         16#05#           =>  --  2305
          (0, 0, 9129, 9129),
         16#06#           =>  --  2306
          (0, 0, 9130, 9130),
         16#07#           =>  --  2307
          (0, 0, 9131, 9131),
         16#08#           =>  --  2308
          (0, 0, 9132, 9132),
         16#09#           =>  --  2309
          (0, 0, 9133, 9133),
         16#0A#           =>  --  230A
          (0, 0, 9134, 9134),
         16#0B#           =>  --  230B
          (0, 0, 9135, 9135),
         16#0C#           =>  --  230C
          (0, 0, 9136, 9136),
         16#0D#           =>  --  230D
          (0, 0, 9137, 9137),
         16#0E#           =>  --  230E
          (0, 0, 9138, 9138),
         16#0F#           =>  --  230F
          (0, 0, 9139, 9139),
         16#10#           =>  --  2310
          (0, 0, 9140, 9140),
         16#11#           =>  --  2311
          (0, 0, 9141, 9141),
         16#12#           =>  --  2312
          (0, 0, 9142, 9142),
         16#13#           =>  --  2313
          (0, 0, 9143, 9143),
         16#14#           =>  --  2314
          (0, 0, 9144, 9144),
         16#15#           =>  --  2315
          (0, 0, 9145, 9145),
         16#16#           =>  --  2316
          (0, 0, 9146, 9146),
         16#17#           =>  --  2317
          (0, 0, 9147, 9147),
         16#18#           =>  --  2318
          (0, 0, 9148, 9148),
         16#19#           =>  --  2319
          (0, 0, 9149, 9149),
         16#1A#           =>  --  231A
          (0, 0, 9150, 9150),
         16#1B#           =>  --  231B
          (0, 0, 9151, 9151),
         16#1C#           =>  --  231C
          (0, 0, 9152, 9152),
         16#1D#           =>  --  231D
          (0, 0, 9153, 9153),
         16#1E#           =>  --  231E
          (0, 0, 9154, 9154),
         16#1F#           =>  --  231F
          (0, 0, 9155, 9155),
         16#20#           =>  --  2320
          (0, 0, 9156, 9156),
         16#21#           =>  --  2321
          (0, 0, 9157, 9157),
         16#22#           =>  --  2322
          (0, 0, 9158, 9158),
         16#23#           =>  --  2323
          (0, 0, 9159, 9159),
         16#24#           =>  --  2324
          (0, 0, 9160, 9160),
         16#25#           =>  --  2325
          (0, 0, 9161, 9161),
         16#26#           =>  --  2326
          (0, 0, 9162, 9162),
         16#27#           =>  --  2327
          (0, 0, 9163, 9163),
         16#28#           =>  --  2328
          (0, 0, 9164, 9164),
         16#29#           =>  --  2329
          (0, 0, 9165, 9165),
         16#2A#           =>  --  232A
          (0, 0, 9166, 9166),
         16#2B#           =>  --  232B
          (0, 0, 9167, 9167),
         16#2C#           =>  --  232C
          (0, 0, 9168, 9168),
         16#2D#           =>  --  232D
          (0, 0, 9169, 9169),
         16#2E#           =>  --  232E
          (0, 0, 9170, 9170),
         16#2F#           =>  --  232F
          (0, 0, 9171, 9171),
         16#30#           =>  --  2330
          (0, 0, 9172, 9172),
         16#31#           =>  --  2331
          (0, 0, 9173, 9173),
         16#32#           =>  --  2332
          (0, 0, 9174, 9174),
         16#33#           =>  --  2333
          (0, 0, 9175, 9175),
         16#34#           =>  --  2334
          (0, 0, 9176, 9176),
         16#35#           =>  --  2335
          (0, 0, 9177, 9177),
         16#36#           =>  --  2336
          (0, 0, 9178, 9178),
         16#37#           =>  --  2337
          (0, 0, 9179, 9179),
         16#38#           =>  --  2338
          (0, 0, 9180, 9180),
         16#39#           =>  --  2339
          (0, 0, 9181, 9181),
         16#3A#           =>  --  233A
          (0, 0, 9182, 9182),
         16#3B#           =>  --  233B
          (0, 0, 9183, 9183),
         16#3C#           =>  --  233C
          (0, 0, 9184, 9184),
         16#3D#           =>  --  233D
          (0, 0, 9185, 9185),
         16#3E#           =>  --  233E
          (0, 0, 9186, 9186),
         16#3F#           =>  --  233F
          (0, 0, 9187, 9187),
         16#40#           =>  --  2340
          (0, 0, 9188, 9188),
         16#41#           =>  --  2341
          (0, 0, 9189, 9189),
         16#42#           =>  --  2342
          (0, 0, 9190, 9190),
         16#43#           =>  --  2343
          (0, 0, 9191, 9191),
         16#44#           =>  --  2344
          (0, 0, 9192, 9192),
         16#45#           =>  --  2345
          (0, 0, 9193, 9193),
         16#46#           =>  --  2346
          (0, 0, 9194, 9194),
         16#47#           =>  --  2347
          (0, 0, 9195, 9195),
         16#48#           =>  --  2348
          (0, 0, 9196, 9196),
         16#49#           =>  --  2349
          (0, 0, 9197, 9197),
         16#4A#           =>  --  234A
          (0, 0, 9198, 9198),
         16#4B#           =>  --  234B
          (0, 0, 9199, 9199),
         16#4C#           =>  --  234C
          (0, 0, 9200, 9200),
         16#4D#           =>  --  234D
          (0, 0, 9201, 9201),
         16#4E#           =>  --  234E
          (0, 0, 9202, 9202),
         16#4F#           =>  --  234F
          (0, 0, 9203, 9203),
         16#50#           =>  --  2350
          (0, 0, 9204, 9204),
         16#51#           =>  --  2351
          (0, 0, 9205, 9205),
         16#52#           =>  --  2352
          (0, 0, 9206, 9206),
         16#53#           =>  --  2353
          (0, 0, 9207, 9207),
         16#54#           =>  --  2354
          (0, 0, 9208, 9208),
         16#55#           =>  --  2355
          (0, 0, 9209, 9209),
         16#56#           =>  --  2356
          (0, 0, 9210, 9210),
         16#57#           =>  --  2357
          (0, 0, 9211, 9211),
         16#58#           =>  --  2358
          (0, 0, 9212, 9212),
         16#59#           =>  --  2359
          (0, 0, 9213, 9213),
         16#5A#           =>  --  235A
          (0, 0, 9214, 9214),
         16#5B#           =>  --  235B
          (0, 0, 9215, 9215),
         16#5C#           =>  --  235C
          (0, 0, 9216, 9216),
         16#5D#           =>  --  235D
          (0, 0, 9217, 9217),
         16#5E#           =>  --  235E
          (0, 0, 9218, 9218),
         16#5F#           =>  --  235F
          (0, 0, 9219, 9219),
         16#60#           =>  --  2360
          (0, 0, 9220, 9220),
         16#61#           =>  --  2361
          (0, 0, 9221, 9221),
         16#62#           =>  --  2362
          (0, 0, 9222, 9222),
         16#63#           =>  --  2363
          (0, 0, 9223, 9223),
         16#64#           =>  --  2364
          (0, 0, 9224, 9224),
         16#65#           =>  --  2365
          (0, 0, 9225, 9225),
         16#66#           =>  --  2366
          (0, 0, 9226, 9226),
         16#67#           =>  --  2367
          (0, 0, 9227, 9227),
         16#68#           =>  --  2368
          (0, 0, 9228, 9228),
         16#69#           =>  --  2369
          (0, 0, 9229, 9229),
         16#6A#           =>  --  236A
          (0, 0, 9230, 9230),
         16#6B#           =>  --  236B
          (0, 0, 9231, 9231),
         16#6C#           =>  --  236C
          (0, 0, 9232, 9232),
         16#6D#           =>  --  236D
          (0, 0, 9233, 9233),
         16#6E#           =>  --  236E
          (0, 0, 9234, 9234),
         16#6F#           =>  --  236F
          (0, 0, 9235, 9235),
         16#70#           =>  --  2370
          (0, 0, 9236, 9236),
         16#71#           =>  --  2371
          (0, 0, 9237, 9237),
         16#72#           =>  --  2372
          (0, 0, 9238, 9238),
         16#73#           =>  --  2373
          (0, 0, 9239, 9239),
         16#74#           =>  --  2374
          (0, 0, 9240, 9240),
         16#75#           =>  --  2375
          (0, 0, 9241, 9241),
         16#76#           =>  --  2376
          (0, 0, 9242, 9242),
         16#77#           =>  --  2377
          (0, 0, 9243, 9243),
         16#78#           =>  --  2378
          (0, 0, 9244, 9244),
         16#79#           =>  --  2379
          (0, 0, 9245, 9245),
         16#7A#           =>  --  237A
          (0, 0, 9246, 9246),
         16#7B#           =>  --  237B
          (0, 0, 9247, 9247),
         16#7C#           =>  --  237C
          (0, 0, 9248, 9248),
         16#7D#           =>  --  237D
          (0, 0, 9249, 9249),
         16#7E#           =>  --  237E
          (0, 0, 9250, 9250),
         16#7F#           =>  --  237F
          (0, 0, 9251, 9251),
         16#80#           =>  --  2380
          (0, 0, 9252, 9252),
         16#81#           =>  --  2381
          (0, 0, 9253, 9253),
         16#82#           =>  --  2382
          (0, 0, 9254, 9254),
         16#83#           =>  --  2383
          (0, 0, 9255, 9255),
         16#84#           =>  --  2384
          (0, 0, 9256, 9256),
         16#85#           =>  --  2385
          (0, 0, 9257, 9257),
         16#86#           =>  --  2386
          (0, 0, 9258, 9258),
         16#87#           =>  --  2387
          (0, 0, 9259, 9259),
         16#88#           =>  --  2388
          (0, 0, 9260, 9260),
         16#89#           =>  --  2389
          (0, 0, 9261, 9261),
         16#8A#           =>  --  238A
          (0, 0, 9262, 9262),
         16#8B#           =>  --  238B
          (0, 0, 9263, 9263),
         16#8C#           =>  --  238C
          (0, 0, 9264, 9264),
         16#8D#           =>  --  238D
          (0, 0, 9265, 9265),
         16#8E#           =>  --  238E
          (0, 0, 9266, 9266),
         16#8F#           =>  --  238F
          (0, 0, 9267, 9267),
         16#90#           =>  --  2390
          (0, 0, 9268, 9268),
         16#91#           =>  --  2391
          (0, 0, 9269, 9269),
         16#92#           =>  --  2392
          (0, 0, 9270, 9270),
         16#93#           =>  --  2393
          (0, 0, 9271, 9271),
         16#94#           =>  --  2394
          (0, 0, 9272, 9272),
         16#95#           =>  --  2395
          (0, 0, 9273, 9273),
         16#96#           =>  --  2396
          (0, 0, 9274, 9274),
         16#97#           =>  --  2397
          (0, 0, 9275, 9275),
         16#98#           =>  --  2398
          (0, 0, 9276, 9276),
         16#99#           =>  --  2399
          (0, 0, 9277, 9277),
         16#9A#           =>  --  239A
          (0, 0, 9278, 9278),
         16#9B#           =>  --  239B
          (0, 0, 9279, 9279),
         16#9C#           =>  --  239C
          (0, 0, 9280, 9280),
         16#9D#           =>  --  239D
          (0, 0, 9281, 9281),
         16#9E#           =>  --  239E
          (0, 0, 9282, 9282),
         16#9F#           =>  --  239F
          (0, 0, 9283, 9283),
         16#A0#           =>  --  23A0
          (0, 0, 9284, 9284),
         16#A1#           =>  --  23A1
          (0, 0, 9285, 9285),
         16#A2#           =>  --  23A2
          (0, 0, 9286, 9286),
         16#A3#           =>  --  23A3
          (0, 0, 9287, 9287),
         16#A4#           =>  --  23A4
          (0, 0, 9288, 9288),
         16#A5#           =>  --  23A5
          (0, 0, 9289, 9289),
         16#A6#           =>  --  23A6
          (0, 0, 9290, 9290),
         16#A7#           =>  --  23A7
          (0, 0, 9291, 9291),
         16#A8#           =>  --  23A8
          (0, 0, 9292, 9292),
         16#A9#           =>  --  23A9
          (0, 0, 9293, 9293),
         16#AA#           =>  --  23AA
          (0, 0, 9294, 9294),
         16#AB#           =>  --  23AB
          (0, 0, 9295, 9295),
         16#AC#           =>  --  23AC
          (0, 0, 9296, 9296),
         16#AD#           =>  --  23AD
          (0, 0, 9297, 9297),
         16#AE#           =>  --  23AE
          (0, 0, 9298, 9298),
         16#AF#           =>  --  23AF
          (0, 0, 9299, 9299),
         16#B0#           =>  --  23B0
          (0, 0, 9300, 9300),
         16#B1#           =>  --  23B1
          (0, 0, 9301, 9301),
         16#B2#           =>  --  23B2
          (0, 0, 9302, 9302),
         16#B3#           =>  --  23B3
          (0, 0, 9303, 9303),
         16#B4#           =>  --  23B4
          (0, 0, 9304, 9304),
         16#B5#           =>  --  23B5
          (0, 0, 9305, 9305),
         16#B6#           =>  --  23B6
          (0, 0, 9306, 9306),
         16#B7#           =>  --  23B7
          (0, 0, 9307, 9307),
         16#B8#           =>  --  23B8
          (0, 0, 9308, 9308),
         16#B9#           =>  --  23B9
          (0, 0, 9309, 9309),
         16#BA#           =>  --  23BA
          (0, 0, 9310, 9310),
         16#BB#           =>  --  23BB
          (0, 0, 9311, 9311),
         16#BC#           =>  --  23BC
          (0, 0, 9312, 9312),
         16#BD#           =>  --  23BD
          (0, 0, 9313, 9313),
         16#BE#           =>  --  23BE
          (0, 0, 9314, 9314),
         16#BF#           =>  --  23BF
          (0, 0, 9315, 9315),
         16#C0#           =>  --  23C0
          (0, 0, 9316, 9316),
         16#C1#           =>  --  23C1
          (0, 0, 9317, 9317),
         16#C2#           =>  --  23C2
          (0, 0, 9318, 9318),
         16#C3#           =>  --  23C3
          (0, 0, 9319, 9319),
         16#C4#           =>  --  23C4
          (0, 0, 9320, 9320),
         16#C5#           =>  --  23C5
          (0, 0, 9321, 9321),
         16#C6#           =>  --  23C6
          (0, 0, 9322, 9322),
         16#C7#           =>  --  23C7
          (0, 0, 9323, 9323),
         16#C8#           =>  --  23C8
          (0, 0, 9324, 9324),
         16#C9#           =>  --  23C9
          (0, 0, 9325, 9325),
         16#CA#           =>  --  23CA
          (0, 0, 9326, 9326),
         16#CB#           =>  --  23CB
          (0, 0, 9327, 9327),
         16#CC#           =>  --  23CC
          (0, 0, 9328, 9328),
         16#CD#           =>  --  23CD
          (0, 0, 9329, 9329),
         16#CE#           =>  --  23CE
          (0, 0, 9330, 9330),
         16#CF#           =>  --  23CF
          (0, 0, 9331, 9331),
         16#D0#           =>  --  23D0
          (0, 0, 9332, 9332),
         16#D1#           =>  --  23D1
          (0, 0, 9333, 9333),
         16#D2#           =>  --  23D2
          (0, 0, 9334, 9334),
         16#D3#           =>  --  23D3
          (0, 0, 9335, 9335),
         16#D4#           =>  --  23D4
          (0, 0, 9336, 9336),
         16#D5#           =>  --  23D5
          (0, 0, 9337, 9337),
         16#D6#           =>  --  23D6
          (0, 0, 9338, 9338),
         16#D7#           =>  --  23D7
          (0, 0, 9339, 9339),
         16#D8#           =>  --  23D8
          (0, 0, 9340, 9340),
         16#D9#           =>  --  23D9
          (0, 0, 9341, 9341),
         16#DA#           =>  --  23DA
          (0, 0, 9342, 9342),
         16#DB#           =>  --  23DB
          (0, 0, 9343, 9343),
         16#DC#           =>  --  23DC
          (0, 0, 9344, 9344),
         16#DD#           =>  --  23DD
          (0, 0, 9345, 9345),
         16#DE#           =>  --  23DE
          (0, 0, 9346, 9346),
         16#DF#           =>  --  23DF
          (0, 0, 9347, 9347),
         16#E0#           =>  --  23E0
          (0, 0, 9348, 9348),
         16#E1#           =>  --  23E1
          (0, 0, 9349, 9349),
         16#E2#           =>  --  23E2
          (0, 0, 9350, 9350),
         16#E3#           =>  --  23E3
          (0, 0, 9351, 9351),
         16#E4#           =>  --  23E4
          (0, 0, 9352, 9352),
         16#E5#           =>  --  23E5
          (0, 0, 9353, 9353),
         16#E6#           =>  --  23E6
          (0, 0, 9354, 9354),
         16#E7#           =>  --  23E7
          (0, 0, 9355, 9355),
         16#E8#           =>  --  23E8
          (0, 0, 9356, 9356),
         16#E9#           =>  --  23E9
          (0, 0, 9357, 9357),
         16#EA#           =>  --  23EA
          (0, 0, 9358, 9358),
         16#EB#           =>  --  23EB
          (0, 0, 9359, 9359),
         16#EC#           =>  --  23EC
          (0, 0, 9360, 9360),
         16#ED#           =>  --  23ED
          (0, 0, 9361, 9361),
         16#EE#           =>  --  23EE
          (0, 0, 9362, 9362),
         16#EF#           =>  --  23EF
          (0, 0, 9363, 9363),
         16#F0#           =>  --  23F0
          (0, 0, 9364, 9364),
         16#F1#           =>  --  23F1
          (0, 0, 9365, 9365),
         16#F2#           =>  --  23F2
          (0, 0, 9366, 9366),
         16#F3#           =>  --  23F3
          (0, 0, 9367, 9367),
         16#F4#           =>  --  23F4
          (0, 0, 9368, 9368),
         16#F5#           =>  --  23F5
          (0, 0, 9369, 9369),
         16#F6#           =>  --  23F6
          (0, 0, 9370, 9370),
         16#F7#           =>  --  23F7
          (0, 0, 9371, 9371),
         16#F8#           =>  --  23F8
          (0, 0, 9372, 9372),
         16#F9#           =>  --  23F9
          (0, 0, 9373, 9373),
         16#FA#           =>  --  23FA
          (0, 0, 9374, 9374),
         others           =>
          (0, 0, 0, 0));

   Group_0024 : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  2400
          (0, 0, 9375, 9375),
         16#01#           =>  --  2401
          (0, 0, 9376, 9376),
         16#02#           =>  --  2402
          (0, 0, 9377, 9377),
         16#03#           =>  --  2403
          (0, 0, 9378, 9378),
         16#04#           =>  --  2404
          (0, 0, 9379, 9379),
         16#05#           =>  --  2405
          (0, 0, 9380, 9380),
         16#06#           =>  --  2406
          (0, 0, 9381, 9381),
         16#07#           =>  --  2407
          (0, 0, 9382, 9382),
         16#08#           =>  --  2408
          (0, 0, 9383, 9383),
         16#09#           =>  --  2409
          (0, 0, 9384, 9384),
         16#0A#           =>  --  240A
          (0, 0, 9385, 9385),
         16#0B#           =>  --  240B
          (0, 0, 9386, 9386),
         16#0C#           =>  --  240C
          (0, 0, 9387, 9387),
         16#0D#           =>  --  240D
          (0, 0, 9388, 9388),
         16#0E#           =>  --  240E
          (0, 0, 9389, 9389),
         16#0F#           =>  --  240F
          (0, 0, 9390, 9390),
         16#10#           =>  --  2410
          (0, 0, 9391, 9391),
         16#11#           =>  --  2411
          (0, 0, 9392, 9392),
         16#12#           =>  --  2412
          (0, 0, 9393, 9393),
         16#13#           =>  --  2413
          (0, 0, 9394, 9394),
         16#14#           =>  --  2414
          (0, 0, 9395, 9395),
         16#15#           =>  --  2415
          (0, 0, 9396, 9396),
         16#16#           =>  --  2416
          (0, 0, 9397, 9397),
         16#17#           =>  --  2417
          (0, 0, 9398, 9398),
         16#18#           =>  --  2418
          (0, 0, 9399, 9399),
         16#19#           =>  --  2419
          (0, 0, 9400, 9400),
         16#1A#           =>  --  241A
          (0, 0, 9401, 9401),
         16#1B#           =>  --  241B
          (0, 0, 9402, 9402),
         16#1C#           =>  --  241C
          (0, 0, 9403, 9403),
         16#1D#           =>  --  241D
          (0, 0, 9404, 9404),
         16#1E#           =>  --  241E
          (0, 0, 9405, 9405),
         16#1F#           =>  --  241F
          (0, 0, 9406, 9406),
         16#20#           =>  --  2420
          (0, 0, 9407, 9407),
         16#21#           =>  --  2421
          (0, 0, 9408, 9408),
         16#22#           =>  --  2422
          (0, 0, 9409, 9409),
         16#23#           =>  --  2423
          (0, 0, 9410, 9410),
         16#24#           =>  --  2424
          (0, 0, 9411, 9411),
         16#25#           =>  --  2425
          (0, 0, 9412, 9412),
         16#26#           =>  --  2426
          (0, 0, 9413, 9413),
         16#40#           =>  --  2440
          (0, 0, 9414, 9414),
         16#41#           =>  --  2441
          (0, 0, 9415, 9415),
         16#42#           =>  --  2442
          (0, 0, 9416, 9416),
         16#43#           =>  --  2443
          (0, 0, 9417, 9417),
         16#44#           =>  --  2444
          (0, 0, 9418, 9418),
         16#45#           =>  --  2445
          (0, 0, 9419, 9419),
         16#46#           =>  --  2446
          (0, 0, 9420, 9420),
         16#47#           =>  --  2447
          (0, 0, 9421, 9421),
         16#48#           =>  --  2448
          (0, 0, 9422, 9422),
         16#49#           =>  --  2449
          (0, 0, 9423, 9423),
         16#4A#           =>  --  244A
          (0, 0, 9424, 9424),
         16#60#           =>  --  2460
          (0, 0, 9425, 9425),
         16#61#           =>  --  2461
          (0, 0, 9426, 9426),
         16#62#           =>  --  2462
          (0, 0, 9427, 9427),
         16#63#           =>  --  2463
          (0, 0, 9428, 9428),
         16#64#           =>  --  2464
          (0, 0, 9429, 9429),
         16#65#           =>  --  2465
          (0, 0, 9430, 9430),
         16#66#           =>  --  2466
          (0, 0, 9431, 9431),
         16#67#           =>  --  2467
          (0, 0, 9432, 9432),
         16#68#           =>  --  2468
          (0, 0, 9433, 9433),
         16#69#           =>  --  2469
          (0, 0, 9434, 9435),
         16#6A#           =>  --  246A
          (0, 0, 9436, 9437),
         16#6B#           =>  --  246B
          (0, 0, 9425, 9426),
         16#6C#           =>  --  246C
          (0, 0, 9438, 9439),
         16#6D#           =>  --  246D
          (0, 0, 9440, 9441),
         16#6E#           =>  --  246E
          (0, 0, 9442, 9443),
         16#6F#           =>  --  246F
          (0, 0, 9444, 9445),
         16#70#           =>  --  2470
          (0, 0, 9446, 9447),
         16#71#           =>  --  2471
          (0, 0, 9448, 9449),
         16#72#           =>  --  2472
          (0, 0, 9450, 9451),
         16#73#           =>  --  2473
          (0, 0, 9452, 9453),
         16#74#           =>  --  2474
          (0, 0, 9454, 9456),
         16#75#           =>  --  2475
          (0, 0, 9457, 9459),
         16#76#           =>  --  2476
          (0, 0, 9460, 9462),
         16#77#           =>  --  2477
          (0, 0, 9463, 9465),
         16#78#           =>  --  2478
          (0, 0, 9466, 9468),
         16#79#           =>  --  2479
          (0, 0, 9469, 9471),
         16#7A#           =>  --  247A
          (0, 0, 9472, 9474),
         16#7B#           =>  --  247B
          (0, 0, 9475, 9477),
         16#7C#           =>  --  247C
          (0, 0, 9478, 9480),
         16#7D#           =>  --  247D
          (0, 0, 9481, 9484),
         16#7E#           =>  --  247E
          (0, 0, 9485, 9488),
         16#7F#           =>  --  247F
          (0, 0, 9489, 9492),
         16#80#           =>  --  2480
          (0, 0, 9493, 9496),
         16#81#           =>  --  2481
          (0, 0, 9497, 9500),
         16#82#           =>  --  2482
          (0, 0, 9501, 9504),
         16#83#           =>  --  2483
          (0, 0, 9505, 9508),
         16#84#           =>  --  2484
          (0, 0, 9509, 9512),
         16#85#           =>  --  2485
          (0, 0, 9513, 9516),
         16#86#           =>  --  2486
          (0, 0, 9517, 9520),
         16#87#           =>  --  2487
          (0, 0, 9521, 9524),
         16#88#           =>  --  2488
          (0, 0, 9525, 9526),
         16#89#           =>  --  2489
          (0, 0, 9527, 9528),
         16#8A#           =>  --  248A
          (0, 0, 9529, 9530),
         16#8B#           =>  --  248B
          (0, 0, 9531, 9532),
         16#8C#           =>  --  248C
          (0, 0, 9533, 9534),
         16#8D#           =>  --  248D
          (0, 0, 9535, 9536),
         16#8E#           =>  --  248E
          (0, 0, 9537, 9538),
         16#8F#           =>  --  248F
          (0, 0, 9539, 9540),
         16#90#           =>  --  2490
          (0, 0, 9541, 9542),
         16#91#           =>  --  2491
          (0, 0, 9543, 9545),
         16#92#           =>  --  2492
          (0, 0, 9546, 9548),
         16#93#           =>  --  2493
          (0, 0, 9549, 9551),
         16#94#           =>  --  2494
          (0, 0, 9552, 9554),
         16#95#           =>  --  2495
          (0, 0, 9555, 9557),
         16#96#           =>  --  2496
          (0, 0, 9558, 9560),
         16#97#           =>  --  2497
          (0, 0, 9561, 9563),
         16#98#           =>  --  2498
          (0, 0, 9564, 9566),
         16#99#           =>  --  2499
          (0, 0, 9567, 9569),
         16#9A#           =>  --  249A
          (0, 0, 9570, 9572),
         16#9B#           =>  --  249B
          (0, 0, 9573, 9575),
         16#9C#           =>  --  249C
          (0, 0, 9576, 9578),
         16#9D#           =>  --  249D
          (0, 0, 9579, 9581),
         16#9E#           =>  --  249E
          (0, 0, 9582, 9584),
         16#9F#           =>  --  249F
          (0, 0, 9585, 9587),
         16#A0#           =>  --  24A0
          (0, 0, 9588, 9590),
         16#A1#           =>  --  24A1
          (0, 0, 9591, 9593),
         16#A2#           =>  --  24A2
          (0, 0, 9594, 9596),
         16#A3#           =>  --  24A3
          (0, 0, 9597, 9599),
         16#A4#           =>  --  24A4
          (0, 0, 9600, 9602),
         16#A5#           =>  --  24A5
          (0, 0, 9603, 9605),
         16#A6#           =>  --  24A6
          (0, 0, 9606, 9608),
         16#A7#           =>  --  24A7
          (0, 0, 9609, 9611),
         16#A8#           =>  --  24A8
          (0, 0, 9612, 9614),
         16#A9#           =>  --  24A9
          (0, 0, 9615, 9617),
         16#AA#           =>  --  24AA
          (0, 0, 9618, 9620),
         16#AB#           =>  --  24AB
          (0, 0, 9621, 9623),
         16#AC#           =>  --  24AC
          (0, 0, 9624, 9626),
         16#AD#           =>  --  24AD
          (0, 0, 9627, 9629),
         16#AE#           =>  --  24AE
          (0, 0, 9630, 9632),
         16#AF#           =>  --  24AF
          (0, 0, 9633, 9635),
         16#B0#           =>  --  24B0
          (0, 0, 9636, 9638),
         16#B1#           =>  --  24B1
          (0, 0, 9639, 9641),
         16#B2#           =>  --  24B2
          (0, 0, 9642, 9644),
         16#B3#           =>  --  24B3
          (0, 0, 9645, 9647),
         16#B4#           =>  --  24B4
          (0, 0, 9648, 9650),
         16#B5#           =>  --  24B5
          (0, 0, 9651, 9653),
         16#B6#           =>  --  24B6
          (0, 0, 9654, 9654),
         16#B7#           =>  --  24B7
          (0, 0, 9655, 9655),
         16#B8#           =>  --  24B8
          (0, 0, 9656, 9656),
         16#B9#           =>  --  24B9
          (0, 0, 9657, 9657),
         16#BA#           =>  --  24BA
          (0, 0, 9658, 9658),
         16#BB#           =>  --  24BB
          (0, 0, 9659, 9659),
         16#BC#           =>  --  24BC
          (0, 0, 9660, 9660),
         16#BD#           =>  --  24BD
          (0, 0, 9661, 9661),
         16#BE#           =>  --  24BE
          (0, 0, 9662, 9662),
         16#BF#           =>  --  24BF
          (0, 0, 9663, 9663),
         16#C0#           =>  --  24C0
          (0, 0, 9664, 9664),
         16#C1#           =>  --  24C1
          (0, 0, 9665, 9665),
         16#C2#           =>  --  24C2
          (0, 0, 9666, 9666),
         16#C3#           =>  --  24C3
          (0, 0, 9667, 9667),
         16#C4#           =>  --  24C4
          (0, 0, 9668, 9668),
         16#C5#           =>  --  24C5
          (0, 0, 9669, 9669),
         16#C6#           =>  --  24C6
          (0, 0, 9670, 9670),
         16#C7#           =>  --  24C7
          (0, 0, 9671, 9671),
         16#C8#           =>  --  24C8
          (0, 0, 9672, 9672),
         16#C9#           =>  --  24C9
          (0, 0, 9673, 9673),
         16#CA#           =>  --  24CA
          (0, 0, 9674, 9674),
         16#CB#           =>  --  24CB
          (0, 0, 9675, 9675),
         16#CC#           =>  --  24CC
          (0, 0, 9676, 9676),
         16#CD#           =>  --  24CD
          (0, 0, 9677, 9677),
         16#CE#           =>  --  24CE
          (0, 0, 9678, 9678),
         16#CF#           =>  --  24CF
          (0, 0, 9679, 9679),
         16#D0#           =>  --  24D0
          (0, 0, 9680, 9680),
         16#D1#           =>  --  24D1
          (0, 0, 9681, 9681),
         16#D2#           =>  --  24D2
          (0, 0, 9682, 9682),
         16#D3#           =>  --  24D3
          (0, 0, 9683, 9683),
         16#D4#           =>  --  24D4
          (0, 0, 9684, 9684),
         16#D5#           =>  --  24D5
          (0, 0, 9685, 9685),
         16#D6#           =>  --  24D6
          (0, 0, 9686, 9686),
         16#D7#           =>  --  24D7
          (0, 0, 9687, 9687),
         16#D8#           =>  --  24D8
          (0, 0, 9688, 9688),
         16#D9#           =>  --  24D9
          (0, 0, 9689, 9689),
         16#DA#           =>  --  24DA
          (0, 0, 9690, 9690),
         16#DB#           =>  --  24DB
          (0, 0, 9691, 9691),
         16#DC#           =>  --  24DC
          (0, 0, 9692, 9692),
         16#DD#           =>  --  24DD
          (0, 0, 9693, 9693),
         16#DE#           =>  --  24DE
          (0, 0, 9694, 9694),
         16#DF#           =>  --  24DF
          (0, 0, 9695, 9695),
         16#E0#           =>  --  24E0
          (0, 0, 9696, 9696),
         16#E1#           =>  --  24E1
          (0, 0, 9697, 9697),
         16#E2#           =>  --  24E2
          (0, 0, 9698, 9698),
         16#E3#           =>  --  24E3
          (0, 0, 9699, 9699),
         16#E4#           =>  --  24E4
          (0, 0, 9700, 9700),
         16#E5#           =>  --  24E5
          (0, 0, 9701, 9701),
         16#E6#           =>  --  24E6
          (0, 0, 9702, 9702),
         16#E7#           =>  --  24E7
          (0, 0, 9703, 9703),
         16#E8#           =>  --  24E8
          (0, 0, 9704, 9704),
         16#E9#           =>  --  24E9
          (0, 0, 9705, 9705),
         16#EA#           =>  --  24EA
          (0, 0, 9435, 9435),
         16#EB#           =>  --  24EB
          (0, 0, 9436, 9437),
         16#EC#           =>  --  24EC
          (0, 0, 9425, 9426),
         16#ED#           =>  --  24ED
          (0, 0, 9438, 9439),
         16#EE#           =>  --  24EE
          (0, 0, 9440, 9441),
         16#EF#           =>  --  24EF
          (0, 0, 9442, 9443),
         16#F0#           =>  --  24F0
          (0, 0, 9444, 9445),
         16#F1#           =>  --  24F1
          (0, 0, 9446, 9447),
         16#F2#           =>  --  24F2
          (0, 0, 9448, 9449),
         16#F3#           =>  --  24F3
          (0, 0, 9450, 9451),
         16#F4#           =>  --  24F4
          (0, 0, 9452, 9453),
         16#F5#           =>  --  24F5
          (0, 0, 9425, 9425),
         16#F6#           =>  --  24F6
          (0, 0, 9426, 9426),
         16#F7#           =>  --  24F7
          (0, 0, 9427, 9427),
         16#F8#           =>  --  24F8
          (0, 0, 9428, 9428),
         16#F9#           =>  --  24F9
          (0, 0, 9429, 9429),
         16#FA#           =>  --  24FA
          (0, 0, 9430, 9430),
         16#FB#           =>  --  24FB
          (0, 0, 9431, 9431),
         16#FC#           =>  --  24FC
          (0, 0, 9432, 9432),
         16#FD#           =>  --  24FD
          (0, 0, 9433, 9433),
         16#FE#           =>  --  24FE
          (0, 0, 9434, 9435),
         16#FF#           =>  --  24FF
          (0, 0, 9435, 9435),
         others           =>
          (0, 0, 0, 0));

   Group_0025 : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  2500
          (0, 0, 9706, 9706),
         16#01#           =>  --  2501
          (0, 0, 9707, 9707),
         16#02#           =>  --  2502
          (0, 0, 9708, 9708),
         16#03#           =>  --  2503
          (0, 0, 9709, 9709),
         16#04#           =>  --  2504
          (0, 0, 9710, 9710),
         16#05#           =>  --  2505
          (0, 0, 9711, 9711),
         16#06#           =>  --  2506
          (0, 0, 9712, 9712),
         16#07#           =>  --  2507
          (0, 0, 9713, 9713),
         16#08#           =>  --  2508
          (0, 0, 9714, 9714),
         16#09#           =>  --  2509
          (0, 0, 9715, 9715),
         16#0A#           =>  --  250A
          (0, 0, 9716, 9716),
         16#0B#           =>  --  250B
          (0, 0, 9717, 9717),
         16#0C#           =>  --  250C
          (0, 0, 9718, 9718),
         16#0D#           =>  --  250D
          (0, 0, 9719, 9719),
         16#0E#           =>  --  250E
          (0, 0, 9720, 9720),
         16#0F#           =>  --  250F
          (0, 0, 9721, 9721),
         16#10#           =>  --  2510
          (0, 0, 9722, 9722),
         16#11#           =>  --  2511
          (0, 0, 9723, 9723),
         16#12#           =>  --  2512
          (0, 0, 9724, 9724),
         16#13#           =>  --  2513
          (0, 0, 9725, 9725),
         16#14#           =>  --  2514
          (0, 0, 9726, 9726),
         16#15#           =>  --  2515
          (0, 0, 9727, 9727),
         16#16#           =>  --  2516
          (0, 0, 9728, 9728),
         16#17#           =>  --  2517
          (0, 0, 9729, 9729),
         16#18#           =>  --  2518
          (0, 0, 9730, 9730),
         16#19#           =>  --  2519
          (0, 0, 9731, 9731),
         16#1A#           =>  --  251A
          (0, 0, 9732, 9732),
         16#1B#           =>  --  251B
          (0, 0, 9733, 9733),
         16#1C#           =>  --  251C
          (0, 0, 9734, 9734),
         16#1D#           =>  --  251D
          (0, 0, 9735, 9735),
         16#1E#           =>  --  251E
          (0, 0, 9736, 9736),
         16#1F#           =>  --  251F
          (0, 0, 9737, 9737),
         16#20#           =>  --  2520
          (0, 0, 9738, 9738),
         16#21#           =>  --  2521
          (0, 0, 9739, 9739),
         16#22#           =>  --  2522
          (0, 0, 9740, 9740),
         16#23#           =>  --  2523
          (0, 0, 9741, 9741),
         16#24#           =>  --  2524
          (0, 0, 9742, 9742),
         16#25#           =>  --  2525
          (0, 0, 9743, 9743),
         16#26#           =>  --  2526
          (0, 0, 9744, 9744),
         16#27#           =>  --  2527
          (0, 0, 9745, 9745),
         16#28#           =>  --  2528
          (0, 0, 9746, 9746),
         16#29#           =>  --  2529
          (0, 0, 9747, 9747),
         16#2A#           =>  --  252A
          (0, 0, 9748, 9748),
         16#2B#           =>  --  252B
          (0, 0, 9749, 9749),
         16#2C#           =>  --  252C
          (0, 0, 9750, 9750),
         16#2D#           =>  --  252D
          (0, 0, 9751, 9751),
         16#2E#           =>  --  252E
          (0, 0, 9752, 9752),
         16#2F#           =>  --  252F
          (0, 0, 9753, 9753),
         16#30#           =>  --  2530
          (0, 0, 9754, 9754),
         16#31#           =>  --  2531
          (0, 0, 9755, 9755),
         16#32#           =>  --  2532
          (0, 0, 9756, 9756),
         16#33#           =>  --  2533
          (0, 0, 9757, 9757),
         16#34#           =>  --  2534
          (0, 0, 9758, 9758),
         16#35#           =>  --  2535
          (0, 0, 9759, 9759),
         16#36#           =>  --  2536
          (0, 0, 9760, 9760),
         16#37#           =>  --  2537
          (0, 0, 9761, 9761),
         16#38#           =>  --  2538
          (0, 0, 9762, 9762),
         16#39#           =>  --  2539
          (0, 0, 9763, 9763),
         16#3A#           =>  --  253A
          (0, 0, 9764, 9764),
         16#3B#           =>  --  253B
          (0, 0, 9765, 9765),
         16#3C#           =>  --  253C
          (0, 0, 9766, 9766),
         16#3D#           =>  --  253D
          (0, 0, 9767, 9767),
         16#3E#           =>  --  253E
          (0, 0, 9768, 9768),
         16#3F#           =>  --  253F
          (0, 0, 9769, 9769),
         16#40#           =>  --  2540
          (0, 0, 9770, 9770),
         16#41#           =>  --  2541
          (0, 0, 9771, 9771),
         16#42#           =>  --  2542
          (0, 0, 9772, 9772),
         16#43#           =>  --  2543
          (0, 0, 9773, 9773),
         16#44#           =>  --  2544
          (0, 0, 9774, 9774),
         16#45#           =>  --  2545
          (0, 0, 9775, 9775),
         16#46#           =>  --  2546
          (0, 0, 9776, 9776),
         16#47#           =>  --  2547
          (0, 0, 9777, 9777),
         16#48#           =>  --  2548
          (0, 0, 9778, 9778),
         16#49#           =>  --  2549
          (0, 0, 9779, 9779),
         16#4A#           =>  --  254A
          (0, 0, 9780, 9780),
         16#4B#           =>  --  254B
          (0, 0, 9781, 9781),
         16#4C#           =>  --  254C
          (0, 0, 9782, 9782),
         16#4D#           =>  --  254D
          (0, 0, 9783, 9783),
         16#4E#           =>  --  254E
          (0, 0, 9784, 9784),
         16#4F#           =>  --  254F
          (0, 0, 9785, 9785),
         16#50#           =>  --  2550
          (0, 0, 9786, 9786),
         16#51#           =>  --  2551
          (0, 0, 9787, 9787),
         16#52#           =>  --  2552
          (0, 0, 9788, 9788),
         16#53#           =>  --  2553
          (0, 0, 9789, 9789),
         16#54#           =>  --  2554
          (0, 0, 9790, 9790),
         16#55#           =>  --  2555
          (0, 0, 9791, 9791),
         16#56#           =>  --  2556
          (0, 0, 9792, 9792),
         16#57#           =>  --  2557
          (0, 0, 9793, 9793),
         16#58#           =>  --  2558
          (0, 0, 9794, 9794),
         16#59#           =>  --  2559
          (0, 0, 9795, 9795),
         16#5A#           =>  --  255A
          (0, 0, 9796, 9796),
         16#5B#           =>  --  255B
          (0, 0, 9797, 9797),
         16#5C#           =>  --  255C
          (0, 0, 9798, 9798),
         16#5D#           =>  --  255D
          (0, 0, 9799, 9799),
         16#5E#           =>  --  255E
          (0, 0, 9800, 9800),
         16#5F#           =>  --  255F
          (0, 0, 9801, 9801),
         16#60#           =>  --  2560
          (0, 0, 9802, 9802),
         16#61#           =>  --  2561
          (0, 0, 9803, 9803),
         16#62#           =>  --  2562
          (0, 0, 9804, 9804),
         16#63#           =>  --  2563
          (0, 0, 9805, 9805),
         16#64#           =>  --  2564
          (0, 0, 9806, 9806),
         16#65#           =>  --  2565
          (0, 0, 9807, 9807),
         16#66#           =>  --  2566
          (0, 0, 9808, 9808),
         16#67#           =>  --  2567
          (0, 0, 9809, 9809),
         16#68#           =>  --  2568
          (0, 0, 9810, 9810),
         16#69#           =>  --  2569
          (0, 0, 9811, 9811),
         16#6A#           =>  --  256A
          (0, 0, 9812, 9812),
         16#6B#           =>  --  256B
          (0, 0, 9813, 9813),
         16#6C#           =>  --  256C
          (0, 0, 9814, 9814),
         16#6D#           =>  --  256D
          (0, 0, 9815, 9815),
         16#6E#           =>  --  256E
          (0, 0, 9816, 9816),
         16#6F#           =>  --  256F
          (0, 0, 9817, 9817),
         16#70#           =>  --  2570
          (0, 0, 9818, 9818),
         16#71#           =>  --  2571
          (0, 0, 9819, 9819),
         16#72#           =>  --  2572
          (0, 0, 9820, 9820),
         16#73#           =>  --  2573
          (0, 0, 9821, 9821),
         16#74#           =>  --  2574
          (0, 0, 9822, 9822),
         16#75#           =>  --  2575
          (0, 0, 9823, 9823),
         16#76#           =>  --  2576
          (0, 0, 9824, 9824),
         16#77#           =>  --  2577
          (0, 0, 9825, 9825),
         16#78#           =>  --  2578
          (0, 0, 9826, 9826),
         16#79#           =>  --  2579
          (0, 0, 9827, 9827),
         16#7A#           =>  --  257A
          (0, 0, 9828, 9828),
         16#7B#           =>  --  257B
          (0, 0, 9829, 9829),
         16#7C#           =>  --  257C
          (0, 0, 9830, 9830),
         16#7D#           =>  --  257D
          (0, 0, 9831, 9831),
         16#7E#           =>  --  257E
          (0, 0, 9832, 9832),
         16#7F#           =>  --  257F
          (0, 0, 9833, 9833),
         16#80#           =>  --  2580
          (0, 0, 9834, 9834),
         16#81#           =>  --  2581
          (0, 0, 9835, 9835),
         16#82#           =>  --  2582
          (0, 0, 9836, 9836),
         16#83#           =>  --  2583
          (0, 0, 9837, 9837),
         16#84#           =>  --  2584
          (0, 0, 9838, 9838),
         16#85#           =>  --  2585
          (0, 0, 9839, 9839),
         16#86#           =>  --  2586
          (0, 0, 9840, 9840),
         16#87#           =>  --  2587
          (0, 0, 9841, 9841),
         16#88#           =>  --  2588
          (0, 0, 9842, 9842),
         16#89#           =>  --  2589
          (0, 0, 9843, 9843),
         16#8A#           =>  --  258A
          (0, 0, 9844, 9844),
         16#8B#           =>  --  258B
          (0, 0, 9845, 9845),
         16#8C#           =>  --  258C
          (0, 0, 9846, 9846),
         16#8D#           =>  --  258D
          (0, 0, 9847, 9847),
         16#8E#           =>  --  258E
          (0, 0, 9848, 9848),
         16#8F#           =>  --  258F
          (0, 0, 9849, 9849),
         16#90#           =>  --  2590
          (0, 0, 9850, 9850),
         16#91#           =>  --  2591
          (0, 0, 9851, 9851),
         16#92#           =>  --  2592
          (0, 0, 9852, 9852),
         16#93#           =>  --  2593
          (0, 0, 9853, 9853),
         16#94#           =>  --  2594
          (0, 0, 9854, 9854),
         16#95#           =>  --  2595
          (0, 0, 9855, 9855),
         16#96#           =>  --  2596
          (0, 0, 9856, 9856),
         16#97#           =>  --  2597
          (0, 0, 9857, 9857),
         16#98#           =>  --  2598
          (0, 0, 9858, 9858),
         16#99#           =>  --  2599
          (0, 0, 9859, 9859),
         16#9A#           =>  --  259A
          (0, 0, 9860, 9860),
         16#9B#           =>  --  259B
          (0, 0, 9861, 9861),
         16#9C#           =>  --  259C
          (0, 0, 9862, 9862),
         16#9D#           =>  --  259D
          (0, 0, 9863, 9863),
         16#9E#           =>  --  259E
          (0, 0, 9864, 9864),
         16#9F#           =>  --  259F
          (0, 0, 9865, 9865),
         16#A0#           =>  --  25A0
          (0, 0, 9866, 9866),
         16#A1#           =>  --  25A1
          (0, 0, 9867, 9867),
         16#A2#           =>  --  25A2
          (0, 0, 9868, 9868),
         16#A3#           =>  --  25A3
          (0, 0, 9869, 9869),
         16#A4#           =>  --  25A4
          (0, 0, 9870, 9870),
         16#A5#           =>  --  25A5
          (0, 0, 9871, 9871),
         16#A6#           =>  --  25A6
          (0, 0, 9872, 9872),
         16#A7#           =>  --  25A7
          (0, 0, 9873, 9873),
         16#A8#           =>  --  25A8
          (0, 0, 9874, 9874),
         16#A9#           =>  --  25A9
          (0, 0, 9875, 9875),
         16#AA#           =>  --  25AA
          (0, 0, 9876, 9876),
         16#AB#           =>  --  25AB
          (0, 0, 9877, 9877),
         16#AC#           =>  --  25AC
          (0, 0, 9878, 9878),
         16#AD#           =>  --  25AD
          (0, 0, 9879, 9879),
         16#AE#           =>  --  25AE
          (0, 0, 9880, 9880),
         16#AF#           =>  --  25AF
          (0, 0, 9881, 9881),
         16#B0#           =>  --  25B0
          (0, 0, 9882, 9882),
         16#B1#           =>  --  25B1
          (0, 0, 9883, 9883),
         16#B2#           =>  --  25B2
          (0, 0, 9884, 9884),
         16#B3#           =>  --  25B3
          (0, 0, 9885, 9885),
         16#B4#           =>  --  25B4
          (0, 0, 9886, 9886),
         16#B5#           =>  --  25B5
          (0, 0, 9887, 9887),
         16#B6#           =>  --  25B6
          (0, 0, 9888, 9888),
         16#B7#           =>  --  25B7
          (0, 0, 9889, 9889),
         16#B8#           =>  --  25B8
          (0, 0, 9890, 9890),
         16#B9#           =>  --  25B9
          (0, 0, 9891, 9891),
         16#BA#           =>  --  25BA
          (0, 0, 9892, 9892),
         16#BB#           =>  --  25BB
          (0, 0, 9893, 9893),
         16#BC#           =>  --  25BC
          (0, 0, 9894, 9894),
         16#BD#           =>  --  25BD
          (0, 0, 9895, 9895),
         16#BE#           =>  --  25BE
          (0, 0, 9896, 9896),
         16#BF#           =>  --  25BF
          (0, 0, 9897, 9897),
         16#C0#           =>  --  25C0
          (0, 0, 9898, 9898),
         16#C1#           =>  --  25C1
          (0, 0, 9899, 9899),
         16#C2#           =>  --  25C2
          (0, 0, 9900, 9900),
         16#C3#           =>  --  25C3
          (0, 0, 9901, 9901),
         16#C4#           =>  --  25C4
          (0, 0, 9902, 9902),
         16#C5#           =>  --  25C5
          (0, 0, 9903, 9903),
         16#C6#           =>  --  25C6
          (0, 0, 9904, 9904),
         16#C7#           =>  --  25C7
          (0, 0, 9905, 9905),
         16#C8#           =>  --  25C8
          (0, 0, 9906, 9906),
         16#C9#           =>  --  25C9
          (0, 0, 9907, 9907),
         16#CA#           =>  --  25CA
          (0, 0, 9908, 9908),
         16#CB#           =>  --  25CB
          (0, 0, 9909, 9909),
         16#CC#           =>  --  25CC
          (0, 0, 9910, 9910),
         16#CD#           =>  --  25CD
          (0, 0, 9911, 9911),
         16#CE#           =>  --  25CE
          (0, 0, 9912, 9912),
         16#CF#           =>  --  25CF
          (0, 0, 9913, 9913),
         16#D0#           =>  --  25D0
          (0, 0, 9914, 9914),
         16#D1#           =>  --  25D1
          (0, 0, 9915, 9915),
         16#D2#           =>  --  25D2
          (0, 0, 9916, 9916),
         16#D3#           =>  --  25D3
          (0, 0, 9917, 9917),
         16#D4#           =>  --  25D4
          (0, 0, 9918, 9918),
         16#D5#           =>  --  25D5
          (0, 0, 9919, 9919),
         16#D6#           =>  --  25D6
          (0, 0, 9920, 9920),
         16#D7#           =>  --  25D7
          (0, 0, 9921, 9921),
         16#D8#           =>  --  25D8
          (0, 0, 9922, 9922),
         16#D9#           =>  --  25D9
          (0, 0, 9923, 9923),
         16#DA#           =>  --  25DA
          (0, 0, 9924, 9924),
         16#DB#           =>  --  25DB
          (0, 0, 9925, 9925),
         16#DC#           =>  --  25DC
          (0, 0, 9926, 9926),
         16#DD#           =>  --  25DD
          (0, 0, 9927, 9927),
         16#DE#           =>  --  25DE
          (0, 0, 9928, 9928),
         16#DF#           =>  --  25DF
          (0, 0, 9929, 9929),
         16#E0#           =>  --  25E0
          (0, 0, 9930, 9930),
         16#E1#           =>  --  25E1
          (0, 0, 9931, 9931),
         16#E2#           =>  --  25E2
          (0, 0, 9932, 9932),
         16#E3#           =>  --  25E3
          (0, 0, 9933, 9933),
         16#E4#           =>  --  25E4
          (0, 0, 9934, 9934),
         16#E5#           =>  --  25E5
          (0, 0, 9935, 9935),
         16#E6#           =>  --  25E6
          (0, 0, 9936, 9936),
         16#E7#           =>  --  25E7
          (0, 0, 9937, 9937),
         16#E8#           =>  --  25E8
          (0, 0, 9938, 9938),
         16#E9#           =>  --  25E9
          (0, 0, 9939, 9939),
         16#EA#           =>  --  25EA
          (0, 0, 9940, 9940),
         16#EB#           =>  --  25EB
          (0, 0, 9941, 9941),
         16#EC#           =>  --  25EC
          (0, 0, 9942, 9942),
         16#ED#           =>  --  25ED
          (0, 0, 9943, 9943),
         16#EE#           =>  --  25EE
          (0, 0, 9944, 9944),
         16#EF#           =>  --  25EF
          (0, 0, 9945, 9945),
         16#F0#           =>  --  25F0
          (0, 0, 9946, 9946),
         16#F1#           =>  --  25F1
          (0, 0, 9947, 9947),
         16#F2#           =>  --  25F2
          (0, 0, 9948, 9948),
         16#F3#           =>  --  25F3
          (0, 0, 9949, 9949),
         16#F4#           =>  --  25F4
          (0, 0, 9950, 9950),
         16#F5#           =>  --  25F5
          (0, 0, 9951, 9951),
         16#F6#           =>  --  25F6
          (0, 0, 9952, 9952),
         16#F7#           =>  --  25F7
          (0, 0, 9953, 9953),
         16#F8#           =>  --  25F8
          (0, 0, 9954, 9954),
         16#F9#           =>  --  25F9
          (0, 0, 9955, 9955),
         16#FA#           =>  --  25FA
          (0, 0, 9956, 9956),
         16#FB#           =>  --  25FB
          (0, 0, 9957, 9957),
         16#FC#           =>  --  25FC
          (0, 0, 9958, 9958),
         16#FD#           =>  --  25FD
          (0, 0, 9959, 9959),
         16#FE#           =>  --  25FE
          (0, 0, 9960, 9960),
         16#FF#           =>  --  25FF
          (0, 0, 9961, 9961),
         others           =>
          (0, 0, 0, 0));

   Group_0026 : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  2600
          (0, 0, 9962, 9962),
         16#01#           =>  --  2601
          (0, 0, 9963, 9963),
         16#02#           =>  --  2602
          (0, 0, 9964, 9964),
         16#03#           =>  --  2603
          (0, 0, 9965, 9965),
         16#04#           =>  --  2604
          (0, 0, 9966, 9966),
         16#05#           =>  --  2605
          (0, 0, 9967, 9967),
         16#06#           =>  --  2606
          (0, 0, 9968, 9968),
         16#07#           =>  --  2607
          (0, 0, 9969, 9969),
         16#08#           =>  --  2608
          (0, 0, 9970, 9970),
         16#09#           =>  --  2609
          (0, 0, 9971, 9971),
         16#0A#           =>  --  260A
          (0, 0, 9972, 9972),
         16#0B#           =>  --  260B
          (0, 0, 9973, 9973),
         16#0C#           =>  --  260C
          (0, 0, 9974, 9974),
         16#0D#           =>  --  260D
          (0, 0, 9975, 9975),
         16#0E#           =>  --  260E
          (0, 0, 9976, 9976),
         16#0F#           =>  --  260F
          (0, 0, 9977, 9977),
         16#10#           =>  --  2610
          (0, 0, 9978, 9978),
         16#11#           =>  --  2611
          (0, 0, 9979, 9979),
         16#12#           =>  --  2612
          (0, 0, 9980, 9980),
         16#13#           =>  --  2613
          (0, 0, 9981, 9981),
         16#14#           =>  --  2614
          (0, 0, 9982, 9982),
         16#15#           =>  --  2615
          (0, 0, 9983, 9983),
         16#16#           =>  --  2616
          (0, 0, 9984, 9984),
         16#17#           =>  --  2617
          (0, 0, 9985, 9985),
         16#18#           =>  --  2618
          (0, 0, 9986, 9986),
         16#19#           =>  --  2619
          (0, 0, 9987, 9987),
         16#1A#           =>  --  261A
          (0, 0, 9988, 9988),
         16#1B#           =>  --  261B
          (0, 0, 9989, 9989),
         16#1C#           =>  --  261C
          (0, 0, 9990, 9990),
         16#1D#           =>  --  261D
          (0, 0, 9991, 9991),
         16#1E#           =>  --  261E
          (0, 0, 9992, 9992),
         16#1F#           =>  --  261F
          (0, 0, 9993, 9993),
         16#20#           =>  --  2620
          (0, 0, 9994, 9994),
         16#21#           =>  --  2621
          (0, 0, 9995, 9995),
         16#22#           =>  --  2622
          (0, 0, 9996, 9996),
         16#23#           =>  --  2623
          (0, 0, 9997, 9997),
         16#24#           =>  --  2624
          (0, 0, 9998, 9998),
         16#25#           =>  --  2625
          (0, 0, 9999, 9999),
         16#26#           =>  --  2626
          (0, 0, 10000, 10000),
         16#27#           =>  --  2627
          (0, 0, 10001, 10001),
         16#28#           =>  --  2628
          (0, 0, 10002, 10002),
         16#29#           =>  --  2629
          (0, 0, 10003, 10003),
         16#2A#           =>  --  262A
          (0, 0, 10004, 10004),
         16#2B#           =>  --  262B
          (0, 0, 10005, 10005),
         16#2C#           =>  --  262C
          (0, 0, 10006, 10006),
         16#2D#           =>  --  262D
          (0, 0, 10007, 10007),
         16#2E#           =>  --  262E
          (0, 0, 10008, 10008),
         16#2F#           =>  --  262F
          (0, 0, 10009, 10009),
         16#30#           =>  --  2630
          (0, 0, 10010, 10010),
         16#31#           =>  --  2631
          (0, 0, 10011, 10011),
         16#32#           =>  --  2632
          (0, 0, 10012, 10012),
         16#33#           =>  --  2633
          (0, 0, 10013, 10013),
         16#34#           =>  --  2634
          (0, 0, 10014, 10014),
         16#35#           =>  --  2635
          (0, 0, 10015, 10015),
         16#36#           =>  --  2636
          (0, 0, 10016, 10016),
         16#37#           =>  --  2637
          (0, 0, 10017, 10017),
         16#38#           =>  --  2638
          (0, 0, 10018, 10018),
         16#39#           =>  --  2639
          (0, 0, 10019, 10019),
         16#3A#           =>  --  263A
          (0, 0, 10020, 10020),
         16#3B#           =>  --  263B
          (0, 0, 10021, 10021),
         16#3C#           =>  --  263C
          (0, 0, 10022, 10022),
         16#3D#           =>  --  263D
          (0, 0, 10023, 10023),
         16#3E#           =>  --  263E
          (0, 0, 10024, 10024),
         16#3F#           =>  --  263F
          (0, 0, 10025, 10025),
         16#40#           =>  --  2640
          (0, 0, 10026, 10026),
         16#41#           =>  --  2641
          (0, 0, 10027, 10027),
         16#42#           =>  --  2642
          (0, 0, 10028, 10028),
         16#43#           =>  --  2643
          (0, 0, 10029, 10029),
         16#44#           =>  --  2644
          (0, 0, 10030, 10030),
         16#45#           =>  --  2645
          (0, 0, 10031, 10031),
         16#46#           =>  --  2646
          (0, 0, 10032, 10032),
         16#47#           =>  --  2647
          (0, 0, 10033, 10033),
         16#48#           =>  --  2648
          (0, 0, 10034, 10034),
         16#49#           =>  --  2649
          (0, 0, 10035, 10035),
         16#4A#           =>  --  264A
          (0, 0, 10036, 10036),
         16#4B#           =>  --  264B
          (0, 0, 10037, 10037),
         16#4C#           =>  --  264C
          (0, 0, 10038, 10038),
         16#4D#           =>  --  264D
          (0, 0, 10039, 10039),
         16#4E#           =>  --  264E
          (0, 0, 10040, 10040),
         16#4F#           =>  --  264F
          (0, 0, 10041, 10041),
         16#50#           =>  --  2650
          (0, 0, 10042, 10042),
         16#51#           =>  --  2651
          (0, 0, 10043, 10043),
         16#52#           =>  --  2652
          (0, 0, 10044, 10044),
         16#53#           =>  --  2653
          (0, 0, 10045, 10045),
         16#54#           =>  --  2654
          (0, 0, 10046, 10046),
         16#55#           =>  --  2655
          (0, 0, 10047, 10047),
         16#56#           =>  --  2656
          (0, 0, 10048, 10048),
         16#57#           =>  --  2657
          (0, 0, 10049, 10049),
         16#58#           =>  --  2658
          (0, 0, 10050, 10050),
         16#59#           =>  --  2659
          (0, 0, 10051, 10051),
         16#5A#           =>  --  265A
          (0, 0, 10052, 10052),
         16#5B#           =>  --  265B
          (0, 0, 10053, 10053),
         16#5C#           =>  --  265C
          (0, 0, 10054, 10054),
         16#5D#           =>  --  265D
          (0, 0, 10055, 10055),
         16#5E#           =>  --  265E
          (0, 0, 10056, 10056),
         16#5F#           =>  --  265F
          (0, 0, 10057, 10057),
         16#60#           =>  --  2660
          (0, 0, 10058, 10058),
         16#61#           =>  --  2661
          (0, 0, 10059, 10059),
         16#62#           =>  --  2662
          (0, 0, 10060, 10060),
         16#63#           =>  --  2663
          (0, 0, 10061, 10061),
         16#64#           =>  --  2664
          (0, 0, 10062, 10062),
         16#65#           =>  --  2665
          (0, 0, 10063, 10063),
         16#66#           =>  --  2666
          (0, 0, 10064, 10064),
         16#67#           =>  --  2667
          (0, 0, 10065, 10065),
         16#68#           =>  --  2668
          (0, 0, 10066, 10066),
         16#69#           =>  --  2669
          (0, 0, 10067, 10067),
         16#6A#           =>  --  266A
          (0, 0, 10068, 10068),
         16#6B#           =>  --  266B
          (0, 0, 10069, 10069),
         16#6C#           =>  --  266C
          (0, 0, 10070, 10070),
         16#6D#           =>  --  266D
          (0, 0, 10071, 10071),
         16#6E#           =>  --  266E
          (0, 0, 10072, 10072),
         16#6F#           =>  --  266F
          (0, 0, 10073, 10073),
         16#70#           =>  --  2670
          (0, 0, 10074, 10074),
         16#71#           =>  --  2671
          (0, 0, 10075, 10075),
         16#72#           =>  --  2672
          (0, 0, 10076, 10076),
         16#73#           =>  --  2673
          (0, 0, 10077, 10077),
         16#74#           =>  --  2674
          (0, 0, 10078, 10078),
         16#75#           =>  --  2675
          (0, 0, 10079, 10079),
         16#76#           =>  --  2676
          (0, 0, 10080, 10080),
         16#77#           =>  --  2677
          (0, 0, 10081, 10081),
         16#78#           =>  --  2678
          (0, 0, 10082, 10082),
         16#79#           =>  --  2679
          (0, 0, 10083, 10083),
         16#7A#           =>  --  267A
          (0, 0, 10084, 10084),
         16#7B#           =>  --  267B
          (0, 0, 10085, 10085),
         16#7C#           =>  --  267C
          (0, 0, 10086, 10086),
         16#7D#           =>  --  267D
          (0, 0, 10087, 10087),
         16#7E#           =>  --  267E
          (0, 0, 10088, 10088),
         16#7F#           =>  --  267F
          (0, 0, 10089, 10089),
         16#80#           =>  --  2680
          (0, 0, 10090, 10090),
         16#81#           =>  --  2681
          (0, 0, 10091, 10091),
         16#82#           =>  --  2682
          (0, 0, 10092, 10092),
         16#83#           =>  --  2683
          (0, 0, 10093, 10093),
         16#84#           =>  --  2684
          (0, 0, 10094, 10094),
         16#85#           =>  --  2685
          (0, 0, 10095, 10095),
         16#86#           =>  --  2686
          (0, 0, 10096, 10096),
         16#87#           =>  --  2687
          (0, 0, 10097, 10097),
         16#88#           =>  --  2688
          (0, 0, 10098, 10098),
         16#89#           =>  --  2689
          (0, 0, 10099, 10099),
         16#8A#           =>  --  268A
          (0, 0, 10100, 10100),
         16#8B#           =>  --  268B
          (0, 0, 10101, 10101),
         16#8C#           =>  --  268C
          (0, 0, 10102, 10102),
         16#8D#           =>  --  268D
          (0, 0, 10103, 10103),
         16#8E#           =>  --  268E
          (0, 0, 10104, 10104),
         16#8F#           =>  --  268F
          (0, 0, 10105, 10105),
         16#90#           =>  --  2690
          (0, 0, 10106, 10106),
         16#91#           =>  --  2691
          (0, 0, 10107, 10107),
         16#92#           =>  --  2692
          (0, 0, 10108, 10108),
         16#93#           =>  --  2693
          (0, 0, 10109, 10109),
         16#94#           =>  --  2694
          (0, 0, 10110, 10110),
         16#95#           =>  --  2695
          (0, 0, 10111, 10111),
         16#96#           =>  --  2696
          (0, 0, 10112, 10112),
         16#97#           =>  --  2697
          (0, 0, 10113, 10113),
         16#98#           =>  --  2698
          (0, 0, 10114, 10114),
         16#99#           =>  --  2699
          (0, 0, 10115, 10115),
         16#9A#           =>  --  269A
          (0, 0, 10116, 10116),
         16#9B#           =>  --  269B
          (0, 0, 10117, 10117),
         16#9C#           =>  --  269C
          (0, 0, 10118, 10118),
         16#9D#           =>  --  269D
          (0, 0, 10119, 10119),
         16#9E#           =>  --  269E
          (0, 0, 10120, 10120),
         16#9F#           =>  --  269F
          (0, 0, 10121, 10121),
         16#A0#           =>  --  26A0
          (0, 0, 10122, 10122),
         16#A1#           =>  --  26A1
          (0, 0, 10123, 10123),
         16#A2#           =>  --  26A2
          (0, 0, 10124, 10124),
         16#A3#           =>  --  26A3
          (0, 0, 10125, 10125),
         16#A4#           =>  --  26A4
          (0, 0, 10126, 10126),
         16#A5#           =>  --  26A5
          (0, 0, 10127, 10127),
         16#A6#           =>  --  26A6
          (0, 0, 10128, 10128),
         16#A7#           =>  --  26A7
          (0, 0, 10129, 10129),
         16#A8#           =>  --  26A8
          (0, 0, 10130, 10130),
         16#A9#           =>  --  26A9
          (0, 0, 10131, 10131),
         16#AA#           =>  --  26AA
          (0, 0, 10132, 10132),
         16#AB#           =>  --  26AB
          (0, 0, 10133, 10133),
         16#AC#           =>  --  26AC
          (0, 0, 10134, 10134),
         16#AD#           =>  --  26AD
          (0, 0, 10135, 10135),
         16#AE#           =>  --  26AE
          (0, 0, 10136, 10136),
         16#AF#           =>  --  26AF
          (0, 0, 10137, 10137),
         16#B0#           =>  --  26B0
          (0, 0, 10138, 10138),
         16#B1#           =>  --  26B1
          (0, 0, 10139, 10139),
         16#B2#           =>  --  26B2
          (0, 0, 10140, 10140),
         16#B3#           =>  --  26B3
          (0, 0, 10141, 10141),
         16#B4#           =>  --  26B4
          (0, 0, 10142, 10142),
         16#B5#           =>  --  26B5
          (0, 0, 10143, 10143),
         16#B6#           =>  --  26B6
          (0, 0, 10144, 10144),
         16#B7#           =>  --  26B7
          (0, 0, 10145, 10145),
         16#B8#           =>  --  26B8
          (0, 0, 10146, 10146),
         16#B9#           =>  --  26B9
          (0, 0, 10147, 10147),
         16#BA#           =>  --  26BA
          (0, 0, 10148, 10148),
         16#BB#           =>  --  26BB
          (0, 0, 10149, 10149),
         16#BC#           =>  --  26BC
          (0, 0, 10150, 10150),
         16#BD#           =>  --  26BD
          (0, 0, 10151, 10151),
         16#BE#           =>  --  26BE
          (0, 0, 10152, 10152),
         16#BF#           =>  --  26BF
          (0, 0, 10153, 10153),
         16#C0#           =>  --  26C0
          (0, 0, 10154, 10154),
         16#C1#           =>  --  26C1
          (0, 0, 10155, 10155),
         16#C2#           =>  --  26C2
          (0, 0, 10156, 10156),
         16#C3#           =>  --  26C3
          (0, 0, 10157, 10157),
         16#C4#           =>  --  26C4
          (0, 0, 10158, 10158),
         16#C5#           =>  --  26C5
          (0, 0, 10159, 10159),
         16#C6#           =>  --  26C6
          (0, 0, 10160, 10160),
         16#C7#           =>  --  26C7
          (0, 0, 10161, 10161),
         16#C8#           =>  --  26C8
          (0, 0, 10162, 10162),
         16#C9#           =>  --  26C9
          (0, 0, 10163, 10163),
         16#CA#           =>  --  26CA
          (0, 0, 10164, 10164),
         16#CB#           =>  --  26CB
          (0, 0, 10165, 10165),
         16#CC#           =>  --  26CC
          (0, 0, 10166, 10166),
         16#CD#           =>  --  26CD
          (0, 0, 10167, 10167),
         16#CE#           =>  --  26CE
          (0, 0, 10168, 10168),
         16#CF#           =>  --  26CF
          (0, 0, 10169, 10169),
         16#D0#           =>  --  26D0
          (0, 0, 10170, 10170),
         16#D1#           =>  --  26D1
          (0, 0, 10171, 10171),
         16#D2#           =>  --  26D2
          (0, 0, 10172, 10172),
         16#D3#           =>  --  26D3
          (0, 0, 10173, 10173),
         16#D4#           =>  --  26D4
          (0, 0, 10174, 10174),
         16#D5#           =>  --  26D5
          (0, 0, 10175, 10175),
         16#D6#           =>  --  26D6
          (0, 0, 10176, 10176),
         16#D7#           =>  --  26D7
          (0, 0, 10177, 10177),
         16#D8#           =>  --  26D8
          (0, 0, 10178, 10178),
         16#D9#           =>  --  26D9
          (0, 0, 10179, 10179),
         16#DA#           =>  --  26DA
          (0, 0, 10180, 10180),
         16#DB#           =>  --  26DB
          (0, 0, 10181, 10181),
         16#DC#           =>  --  26DC
          (0, 0, 10182, 10182),
         16#DD#           =>  --  26DD
          (0, 0, 10183, 10183),
         16#DE#           =>  --  26DE
          (0, 0, 10184, 10184),
         16#DF#           =>  --  26DF
          (0, 0, 10185, 10185),
         16#E0#           =>  --  26E0
          (0, 0, 10186, 10186),
         16#E1#           =>  --  26E1
          (0, 0, 10187, 10187),
         16#E2#           =>  --  26E2
          (0, 0, 10188, 10188),
         16#E3#           =>  --  26E3
          (0, 0, 10189, 10189),
         16#E4#           =>  --  26E4
          (0, 0, 10190, 10190),
         16#E5#           =>  --  26E5
          (0, 0, 10191, 10191),
         16#E6#           =>  --  26E6
          (0, 0, 10192, 10192),
         16#E7#           =>  --  26E7
          (0, 0, 10193, 10193),
         16#E8#           =>  --  26E8
          (0, 0, 10194, 10194),
         16#E9#           =>  --  26E9
          (0, 0, 10195, 10195),
         16#EA#           =>  --  26EA
          (0, 0, 10196, 10196),
         16#EB#           =>  --  26EB
          (0, 0, 10197, 10197),
         16#EC#           =>  --  26EC
          (0, 0, 10198, 10198),
         16#ED#           =>  --  26ED
          (0, 0, 10199, 10199),
         16#EE#           =>  --  26EE
          (0, 0, 10200, 10200),
         16#EF#           =>  --  26EF
          (0, 0, 10201, 10201),
         16#F0#           =>  --  26F0
          (0, 0, 10202, 10202),
         16#F1#           =>  --  26F1
          (0, 0, 10203, 10203),
         16#F2#           =>  --  26F2
          (0, 0, 10204, 10204),
         16#F3#           =>  --  26F3
          (0, 0, 10205, 10205),
         16#F4#           =>  --  26F4
          (0, 0, 10206, 10206),
         16#F5#           =>  --  26F5
          (0, 0, 10207, 10207),
         16#F6#           =>  --  26F6
          (0, 0, 10208, 10208),
         16#F7#           =>  --  26F7
          (0, 0, 10209, 10209),
         16#F8#           =>  --  26F8
          (0, 0, 10210, 10210),
         16#F9#           =>  --  26F9
          (0, 0, 10211, 10211),
         16#FA#           =>  --  26FA
          (0, 0, 10212, 10212),
         16#FB#           =>  --  26FB
          (0, 0, 10213, 10213),
         16#FC#           =>  --  26FC
          (0, 0, 10214, 10214),
         16#FD#           =>  --  26FD
          (0, 0, 10215, 10215),
         16#FE#           =>  --  26FE
          (0, 0, 10216, 10216),
         16#FF#           =>  --  26FF
          (0, 0, 10217, 10217),
         others           =>
          (0, 0, 0, 0));

   Group_0027 : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  2700
          (0, 0, 10218, 10218),
         16#01#           =>  --  2701
          (0, 0, 10219, 10219),
         16#02#           =>  --  2702
          (0, 0, 10220, 10220),
         16#03#           =>  --  2703
          (0, 0, 10221, 10221),
         16#04#           =>  --  2704
          (0, 0, 10222, 10222),
         16#05#           =>  --  2705
          (0, 0, 10223, 10223),
         16#06#           =>  --  2706
          (0, 0, 10224, 10224),
         16#07#           =>  --  2707
          (0, 0, 10225, 10225),
         16#08#           =>  --  2708
          (0, 0, 10226, 10226),
         16#09#           =>  --  2709
          (0, 0, 10227, 10227),
         16#0A#           =>  --  270A
          (0, 0, 10228, 10228),
         16#0B#           =>  --  270B
          (0, 0, 10229, 10229),
         16#0C#           =>  --  270C
          (0, 0, 10230, 10230),
         16#0D#           =>  --  270D
          (0, 0, 10231, 10231),
         16#0E#           =>  --  270E
          (0, 0, 10232, 10232),
         16#0F#           =>  --  270F
          (0, 0, 10233, 10233),
         16#10#           =>  --  2710
          (0, 0, 10234, 10234),
         16#11#           =>  --  2711
          (0, 0, 10235, 10235),
         16#12#           =>  --  2712
          (0, 0, 10236, 10236),
         16#13#           =>  --  2713
          (0, 0, 10237, 10237),
         16#14#           =>  --  2714
          (0, 0, 10238, 10238),
         16#15#           =>  --  2715
          (0, 0, 10239, 10239),
         16#16#           =>  --  2716
          (0, 0, 10240, 10240),
         16#17#           =>  --  2717
          (0, 0, 10241, 10241),
         16#18#           =>  --  2718
          (0, 0, 10242, 10242),
         16#19#           =>  --  2719
          (0, 0, 10243, 10243),
         16#1A#           =>  --  271A
          (0, 0, 10244, 10244),
         16#1B#           =>  --  271B
          (0, 0, 10245, 10245),
         16#1C#           =>  --  271C
          (0, 0, 10246, 10246),
         16#1D#           =>  --  271D
          (0, 0, 10247, 10247),
         16#1E#           =>  --  271E
          (0, 0, 10248, 10248),
         16#1F#           =>  --  271F
          (0, 0, 10249, 10249),
         16#20#           =>  --  2720
          (0, 0, 10250, 10250),
         16#21#           =>  --  2721
          (0, 0, 10251, 10251),
         16#22#           =>  --  2722
          (0, 0, 10252, 10252),
         16#23#           =>  --  2723
          (0, 0, 10253, 10253),
         16#24#           =>  --  2724
          (0, 0, 10254, 10254),
         16#25#           =>  --  2725
          (0, 0, 10255, 10255),
         16#26#           =>  --  2726
          (0, 0, 10256, 10256),
         16#27#           =>  --  2727
          (0, 0, 10257, 10257),
         16#28#           =>  --  2728
          (0, 0, 10258, 10258),
         16#29#           =>  --  2729
          (0, 0, 10259, 10259),
         16#2A#           =>  --  272A
          (0, 0, 10260, 10260),
         16#2B#           =>  --  272B
          (0, 0, 10261, 10261),
         16#2C#           =>  --  272C
          (0, 0, 10262, 10262),
         16#2D#           =>  --  272D
          (0, 0, 10263, 10263),
         16#2E#           =>  --  272E
          (0, 0, 10264, 10264),
         16#2F#           =>  --  272F
          (0, 0, 10265, 10265),
         16#30#           =>  --  2730
          (0, 0, 10266, 10266),
         16#31#           =>  --  2731
          (0, 0, 10267, 10267),
         16#32#           =>  --  2732
          (0, 0, 10268, 10268),
         16#33#           =>  --  2733
          (0, 0, 10269, 10269),
         16#34#           =>  --  2734
          (0, 0, 10270, 10270),
         16#35#           =>  --  2735
          (0, 0, 10271, 10271),
         16#36#           =>  --  2736
          (0, 0, 10272, 10272),
         16#37#           =>  --  2737
          (0, 0, 10273, 10273),
         16#38#           =>  --  2738
          (0, 0, 10274, 10274),
         16#39#           =>  --  2739
          (0, 0, 10275, 10275),
         16#3A#           =>  --  273A
          (0, 0, 10276, 10276),
         16#3B#           =>  --  273B
          (0, 0, 10277, 10277),
         16#3C#           =>  --  273C
          (0, 0, 10278, 10278),
         16#3D#           =>  --  273D
          (0, 0, 10279, 10279),
         16#3E#           =>  --  273E
          (0, 0, 10280, 10280),
         16#3F#           =>  --  273F
          (0, 0, 10281, 10281),
         16#40#           =>  --  2740
          (0, 0, 10282, 10282),
         16#41#           =>  --  2741
          (0, 0, 10283, 10283),
         16#42#           =>  --  2742
          (0, 0, 10284, 10284),
         16#43#           =>  --  2743
          (0, 0, 10285, 10285),
         16#44#           =>  --  2744
          (0, 0, 10286, 10286),
         16#45#           =>  --  2745
          (0, 0, 10287, 10287),
         16#46#           =>  --  2746
          (0, 0, 10288, 10288),
         16#47#           =>  --  2747
          (0, 0, 10289, 10289),
         16#48#           =>  --  2748
          (0, 0, 10290, 10290),
         16#49#           =>  --  2749
          (0, 0, 10291, 10291),
         16#4A#           =>  --  274A
          (0, 0, 10292, 10292),
         16#4B#           =>  --  274B
          (0, 0, 10293, 10293),
         16#4C#           =>  --  274C
          (0, 0, 10294, 10294),
         16#4D#           =>  --  274D
          (0, 0, 10295, 10295),
         16#4E#           =>  --  274E
          (0, 0, 10296, 10296),
         16#4F#           =>  --  274F
          (0, 0, 10297, 10297),
         16#50#           =>  --  2750
          (0, 0, 10298, 10298),
         16#51#           =>  --  2751
          (0, 0, 10299, 10299),
         16#52#           =>  --  2752
          (0, 0, 10300, 10300),
         16#53#           =>  --  2753
          (0, 0, 10301, 10301),
         16#54#           =>  --  2754
          (0, 0, 10302, 10302),
         16#55#           =>  --  2755
          (0, 0, 10303, 10303),
         16#56#           =>  --  2756
          (0, 0, 10304, 10304),
         16#57#           =>  --  2757
          (0, 0, 10305, 10305),
         16#58#           =>  --  2758
          (0, 0, 10306, 10306),
         16#59#           =>  --  2759
          (0, 0, 10307, 10307),
         16#5A#           =>  --  275A
          (0, 0, 10308, 10308),
         16#5B#           =>  --  275B
          (0, 0, 10309, 10309),
         16#5C#           =>  --  275C
          (0, 0, 10310, 10310),
         16#5D#           =>  --  275D
          (0, 0, 10311, 10311),
         16#5E#           =>  --  275E
          (0, 0, 10312, 10312),
         16#5F#           =>  --  275F
          (0, 0, 10313, 10313),
         16#60#           =>  --  2760
          (0, 0, 10314, 10314),
         16#61#           =>  --  2761
          (0, 0, 10315, 10315),
         16#62#           =>  --  2762
          (0, 0, 10316, 10316),
         16#63#           =>  --  2763
          (0, 0, 10317, 10317),
         16#64#           =>  --  2764
          (0, 0, 10318, 10318),
         16#65#           =>  --  2765
          (0, 0, 10319, 10319),
         16#66#           =>  --  2766
          (0, 0, 10320, 10320),
         16#67#           =>  --  2767
          (0, 0, 10321, 10321),
         16#68#           =>  --  2768
          (0, 0, 10322, 10322),
         16#69#           =>  --  2769
          (0, 0, 10323, 10323),
         16#6A#           =>  --  276A
          (0, 0, 10324, 10324),
         16#6B#           =>  --  276B
          (0, 0, 10325, 10325),
         16#6C#           =>  --  276C
          (0, 0, 10326, 10326),
         16#6D#           =>  --  276D
          (0, 0, 10327, 10327),
         16#6E#           =>  --  276E
          (0, 0, 10328, 10328),
         16#6F#           =>  --  276F
          (0, 0, 10329, 10329),
         16#70#           =>  --  2770
          (0, 0, 10330, 10330),
         16#71#           =>  --  2771
          (0, 0, 10331, 10331),
         16#72#           =>  --  2772
          (0, 0, 10332, 10332),
         16#73#           =>  --  2773
          (0, 0, 10333, 10333),
         16#74#           =>  --  2774
          (0, 0, 10334, 10334),
         16#75#           =>  --  2775
          (0, 0, 10335, 10335),
         16#77#           =>  --  2777
          (0, 0, 9426, 9426),
         16#78#           =>  --  2778
          (0, 0, 9427, 9427),
         16#79#           =>  --  2779
          (0, 0, 9428, 9428),
         16#7A#           =>  --  277A
          (0, 0, 9429, 9429),
         16#7B#           =>  --  277B
          (0, 0, 9430, 9430),
         16#7C#           =>  --  277C
          (0, 0, 9431, 9431),
         16#7D#           =>  --  277D
          (0, 0, 9432, 9432),
         16#7E#           =>  --  277E
          (0, 0, 9433, 9433),
         16#7F#           =>  --  277F
          (0, 0, 9434, 9435),
         16#81#           =>  --  2781
          (0, 0, 9426, 9426),
         16#82#           =>  --  2782
          (0, 0, 9427, 9427),
         16#83#           =>  --  2783
          (0, 0, 9428, 9428),
         16#84#           =>  --  2784
          (0, 0, 9429, 9429),
         16#85#           =>  --  2785
          (0, 0, 9430, 9430),
         16#86#           =>  --  2786
          (0, 0, 9431, 9431),
         16#87#           =>  --  2787
          (0, 0, 9432, 9432),
         16#88#           =>  --  2788
          (0, 0, 9433, 9433),
         16#89#           =>  --  2789
          (0, 0, 9434, 9435),
         16#8B#           =>  --  278B
          (0, 0, 9426, 9426),
         16#8C#           =>  --  278C
          (0, 0, 9427, 9427),
         16#8D#           =>  --  278D
          (0, 0, 9428, 9428),
         16#8E#           =>  --  278E
          (0, 0, 9429, 9429),
         16#8F#           =>  --  278F
          (0, 0, 9430, 9430),
         16#90#           =>  --  2790
          (0, 0, 9431, 9431),
         16#91#           =>  --  2791
          (0, 0, 9432, 9432),
         16#92#           =>  --  2792
          (0, 0, 9433, 9433),
         16#93#           =>  --  2793
          (0, 0, 9434, 9435),
         16#94#           =>  --  2794
          (0, 0, 10336, 10336),
         16#95#           =>  --  2795
          (0, 0, 10337, 10337),
         16#96#           =>  --  2796
          (0, 0, 10338, 10338),
         16#97#           =>  --  2797
          (0, 0, 10339, 10339),
         16#98#           =>  --  2798
          (0, 0, 10340, 10340),
         16#99#           =>  --  2799
          (0, 0, 10341, 10341),
         16#9A#           =>  --  279A
          (0, 0, 10342, 10342),
         16#9B#           =>  --  279B
          (0, 0, 10343, 10343),
         16#9C#           =>  --  279C
          (0, 0, 10344, 10344),
         16#9D#           =>  --  279D
          (0, 0, 10345, 10345),
         16#9E#           =>  --  279E
          (0, 0, 10346, 10346),
         16#9F#           =>  --  279F
          (0, 0, 10347, 10347),
         16#A0#           =>  --  27A0
          (0, 0, 10348, 10348),
         16#A1#           =>  --  27A1
          (0, 0, 10349, 10349),
         16#A2#           =>  --  27A2
          (0, 0, 10350, 10350),
         16#A3#           =>  --  27A3
          (0, 0, 10351, 10351),
         16#A4#           =>  --  27A4
          (0, 0, 10352, 10352),
         16#A5#           =>  --  27A5
          (0, 0, 10353, 10353),
         16#A6#           =>  --  27A6
          (0, 0, 10354, 10354),
         16#A7#           =>  --  27A7
          (0, 0, 10355, 10355),
         16#A8#           =>  --  27A8
          (0, 0, 10356, 10356),
         16#A9#           =>  --  27A9
          (0, 0, 10357, 10357),
         16#AA#           =>  --  27AA
          (0, 0, 10358, 10358),
         16#AB#           =>  --  27AB
          (0, 0, 10359, 10359),
         16#AC#           =>  --  27AC
          (0, 0, 10360, 10360),
         16#AD#           =>  --  27AD
          (0, 0, 10361, 10361),
         16#AE#           =>  --  27AE
          (0, 0, 10362, 10362),
         16#AF#           =>  --  27AF
          (0, 0, 10363, 10363),
         16#B0#           =>  --  27B0
          (0, 0, 10364, 10364),
         16#B1#           =>  --  27B1
          (0, 0, 10365, 10365),
         16#B2#           =>  --  27B2
          (0, 0, 10366, 10366),
         16#B3#           =>  --  27B3
          (0, 0, 10367, 10367),
         16#B4#           =>  --  27B4
          (0, 0, 10368, 10368),
         16#B5#           =>  --  27B5
          (0, 0, 10369, 10369),
         16#B6#           =>  --  27B6
          (0, 0, 10370, 10370),
         16#B7#           =>  --  27B7
          (0, 0, 10371, 10371),
         16#B8#           =>  --  27B8
          (0, 0, 10372, 10372),
         16#B9#           =>  --  27B9
          (0, 0, 10373, 10373),
         16#BA#           =>  --  27BA
          (0, 0, 10374, 10374),
         16#BB#           =>  --  27BB
          (0, 0, 10375, 10375),
         16#BC#           =>  --  27BC
          (0, 0, 10376, 10376),
         16#BD#           =>  --  27BD
          (0, 0, 10377, 10377),
         16#BE#           =>  --  27BE
          (0, 0, 10378, 10378),
         16#BF#           =>  --  27BF
          (0, 0, 10379, 10379),
         16#C0#           =>  --  27C0
          (0, 0, 10380, 10380),
         16#C1#           =>  --  27C1
          (0, 0, 10381, 10381),
         16#C2#           =>  --  27C2
          (0, 0, 10382, 10382),
         16#C3#           =>  --  27C3
          (0, 0, 10383, 10383),
         16#C4#           =>  --  27C4
          (0, 0, 10384, 10384),
         16#C5#           =>  --  27C5
          (0, 0, 10385, 10385),
         16#C6#           =>  --  27C6
          (0, 0, 10386, 10386),
         16#C7#           =>  --  27C7
          (0, 0, 10387, 10387),
         16#C8#           =>  --  27C8
          (0, 0, 10388, 10388),
         16#C9#           =>  --  27C9
          (0, 0, 10389, 10389),
         16#CA#           =>  --  27CA
          (0, 0, 10390, 10390),
         16#CB#           =>  --  27CB
          (0, 0, 10391, 10391),
         16#CC#           =>  --  27CC
          (0, 0, 10392, 10392),
         16#CD#           =>  --  27CD
          (0, 0, 10393, 10393),
         16#CE#           =>  --  27CE
          (0, 0, 10394, 10394),
         16#CF#           =>  --  27CF
          (0, 0, 10395, 10395),
         16#D0#           =>  --  27D0
          (0, 0, 10396, 10396),
         16#D1#           =>  --  27D1
          (0, 0, 10397, 10397),
         16#D2#           =>  --  27D2
          (0, 0, 10398, 10398),
         16#D3#           =>  --  27D3
          (0, 0, 10399, 10399),
         16#D4#           =>  --  27D4
          (0, 0, 10400, 10400),
         16#D5#           =>  --  27D5
          (0, 0, 10401, 10401),
         16#D6#           =>  --  27D6
          (0, 0, 10402, 10402),
         16#D7#           =>  --  27D7
          (0, 0, 10403, 10403),
         16#D8#           =>  --  27D8
          (0, 0, 10404, 10404),
         16#D9#           =>  --  27D9
          (0, 0, 10405, 10405),
         16#DA#           =>  --  27DA
          (0, 0, 10406, 10406),
         16#DB#           =>  --  27DB
          (0, 0, 10407, 10407),
         16#DC#           =>  --  27DC
          (0, 0, 10408, 10408),
         16#DD#           =>  --  27DD
          (0, 0, 10409, 10409),
         16#DE#           =>  --  27DE
          (0, 0, 10410, 10410),
         16#DF#           =>  --  27DF
          (0, 0, 10411, 10411),
         16#E0#           =>  --  27E0
          (0, 0, 10412, 10412),
         16#E1#           =>  --  27E1
          (0, 0, 10413, 10413),
         16#E2#           =>  --  27E2
          (0, 0, 10414, 10414),
         16#E3#           =>  --  27E3
          (0, 0, 10415, 10415),
         16#E4#           =>  --  27E4
          (0, 0, 10416, 10416),
         16#E5#           =>  --  27E5
          (0, 0, 10417, 10417),
         16#E6#           =>  --  27E6
          (0, 0, 10418, 10418),
         16#E7#           =>  --  27E7
          (0, 0, 10419, 10419),
         16#E8#           =>  --  27E8
          (0, 0, 10420, 10420),
         16#E9#           =>  --  27E9
          (0, 0, 10421, 10421),
         16#EA#           =>  --  27EA
          (0, 0, 10422, 10422),
         16#EB#           =>  --  27EB
          (0, 0, 10423, 10423),
         16#EC#           =>  --  27EC
          (0, 0, 10424, 10424),
         16#ED#           =>  --  27ED
          (0, 0, 10425, 10425),
         16#EE#           =>  --  27EE
          (0, 0, 10426, 10426),
         16#EF#           =>  --  27EF
          (0, 0, 10427, 10427),
         16#F0#           =>  --  27F0
          (0, 0, 10428, 10428),
         16#F1#           =>  --  27F1
          (0, 0, 10429, 10429),
         16#F2#           =>  --  27F2
          (0, 0, 10430, 10430),
         16#F3#           =>  --  27F3
          (0, 0, 10431, 10431),
         16#F4#           =>  --  27F4
          (0, 0, 10432, 10432),
         16#F5#           =>  --  27F5
          (0, 0, 10433, 10433),
         16#F6#           =>  --  27F6
          (0, 0, 10434, 10434),
         16#F7#           =>  --  27F7
          (0, 0, 10435, 10435),
         16#F8#           =>  --  27F8
          (0, 0, 10436, 10436),
         16#F9#           =>  --  27F9
          (0, 0, 10437, 10437),
         16#FA#           =>  --  27FA
          (0, 0, 10438, 10438),
         16#FB#           =>  --  27FB
          (0, 0, 10439, 10439),
         16#FC#           =>  --  27FC
          (0, 0, 10440, 10440),
         16#FD#           =>  --  27FD
          (0, 0, 10441, 10441),
         16#FE#           =>  --  27FE
          (0, 0, 10442, 10442),
         16#FF#           =>  --  27FF
          (0, 0, 10443, 10443),
         others           =>
          (0, 0, 9425, 9425));

   Group_0028 : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  2800
          (0, 0, 10444, 10444),
         16#01#           =>  --  2801
          (0, 0, 10445, 10445),
         16#02#           =>  --  2802
          (0, 0, 10446, 10446),
         16#03#           =>  --  2803
          (0, 0, 10447, 10447),
         16#04#           =>  --  2804
          (0, 0, 10448, 10448),
         16#05#           =>  --  2805
          (0, 0, 10449, 10449),
         16#06#           =>  --  2806
          (0, 0, 10450, 10450),
         16#07#           =>  --  2807
          (0, 0, 10451, 10451),
         16#08#           =>  --  2808
          (0, 0, 10452, 10452),
         16#09#           =>  --  2809
          (0, 0, 10453, 10453),
         16#0A#           =>  --  280A
          (0, 0, 10454, 10454),
         16#0B#           =>  --  280B
          (0, 0, 10455, 10455),
         16#0C#           =>  --  280C
          (0, 0, 10456, 10456),
         16#0D#           =>  --  280D
          (0, 0, 10457, 10457),
         16#0E#           =>  --  280E
          (0, 0, 10458, 10458),
         16#0F#           =>  --  280F
          (0, 0, 10459, 10459),
         16#10#           =>  --  2810
          (0, 0, 10460, 10460),
         16#11#           =>  --  2811
          (0, 0, 10461, 10461),
         16#12#           =>  --  2812
          (0, 0, 10462, 10462),
         16#13#           =>  --  2813
          (0, 0, 10463, 10463),
         16#14#           =>  --  2814
          (0, 0, 10464, 10464),
         16#15#           =>  --  2815
          (0, 0, 10465, 10465),
         16#16#           =>  --  2816
          (0, 0, 10466, 10466),
         16#17#           =>  --  2817
          (0, 0, 10467, 10467),
         16#18#           =>  --  2818
          (0, 0, 10468, 10468),
         16#19#           =>  --  2819
          (0, 0, 10469, 10469),
         16#1A#           =>  --  281A
          (0, 0, 10470, 10470),
         16#1B#           =>  --  281B
          (0, 0, 10471, 10471),
         16#1C#           =>  --  281C
          (0, 0, 10472, 10472),
         16#1D#           =>  --  281D
          (0, 0, 10473, 10473),
         16#1E#           =>  --  281E
          (0, 0, 10474, 10474),
         16#1F#           =>  --  281F
          (0, 0, 10475, 10475),
         16#20#           =>  --  2820
          (0, 0, 10476, 10476),
         16#21#           =>  --  2821
          (0, 0, 10477, 10477),
         16#22#           =>  --  2822
          (0, 0, 10478, 10478),
         16#23#           =>  --  2823
          (0, 0, 10479, 10479),
         16#24#           =>  --  2824
          (0, 0, 10480, 10480),
         16#25#           =>  --  2825
          (0, 0, 10481, 10481),
         16#26#           =>  --  2826
          (0, 0, 10482, 10482),
         16#27#           =>  --  2827
          (0, 0, 10483, 10483),
         16#28#           =>  --  2828
          (0, 0, 10484, 10484),
         16#29#           =>  --  2829
          (0, 0, 10485, 10485),
         16#2A#           =>  --  282A
          (0, 0, 10486, 10486),
         16#2B#           =>  --  282B
          (0, 0, 10487, 10487),
         16#2C#           =>  --  282C
          (0, 0, 10488, 10488),
         16#2D#           =>  --  282D
          (0, 0, 10489, 10489),
         16#2E#           =>  --  282E
          (0, 0, 10490, 10490),
         16#2F#           =>  --  282F
          (0, 0, 10491, 10491),
         16#30#           =>  --  2830
          (0, 0, 10492, 10492),
         16#31#           =>  --  2831
          (0, 0, 10493, 10493),
         16#32#           =>  --  2832
          (0, 0, 10494, 10494),
         16#33#           =>  --  2833
          (0, 0, 10495, 10495),
         16#34#           =>  --  2834
          (0, 0, 10496, 10496),
         16#35#           =>  --  2835
          (0, 0, 10497, 10497),
         16#36#           =>  --  2836
          (0, 0, 10498, 10498),
         16#37#           =>  --  2837
          (0, 0, 10499, 10499),
         16#38#           =>  --  2838
          (0, 0, 10500, 10500),
         16#39#           =>  --  2839
          (0, 0, 10501, 10501),
         16#3A#           =>  --  283A
          (0, 0, 10502, 10502),
         16#3B#           =>  --  283B
          (0, 0, 10503, 10503),
         16#3C#           =>  --  283C
          (0, 0, 10504, 10504),
         16#3D#           =>  --  283D
          (0, 0, 10505, 10505),
         16#3E#           =>  --  283E
          (0, 0, 10506, 10506),
         16#3F#           =>  --  283F
          (0, 0, 10507, 10507),
         16#40#           =>  --  2840
          (0, 0, 10508, 10508),
         16#41#           =>  --  2841
          (0, 0, 10509, 10509),
         16#42#           =>  --  2842
          (0, 0, 10510, 10510),
         16#43#           =>  --  2843
          (0, 0, 10511, 10511),
         16#44#           =>  --  2844
          (0, 0, 10512, 10512),
         16#45#           =>  --  2845
          (0, 0, 10513, 10513),
         16#46#           =>  --  2846
          (0, 0, 10514, 10514),
         16#47#           =>  --  2847
          (0, 0, 10515, 10515),
         16#48#           =>  --  2848
          (0, 0, 10516, 10516),
         16#49#           =>  --  2849
          (0, 0, 10517, 10517),
         16#4A#           =>  --  284A
          (0, 0, 10518, 10518),
         16#4B#           =>  --  284B
          (0, 0, 10519, 10519),
         16#4C#           =>  --  284C
          (0, 0, 10520, 10520),
         16#4D#           =>  --  284D
          (0, 0, 10521, 10521),
         16#4E#           =>  --  284E
          (0, 0, 10522, 10522),
         16#4F#           =>  --  284F
          (0, 0, 10523, 10523),
         16#50#           =>  --  2850
          (0, 0, 10524, 10524),
         16#51#           =>  --  2851
          (0, 0, 10525, 10525),
         16#52#           =>  --  2852
          (0, 0, 10526, 10526),
         16#53#           =>  --  2853
          (0, 0, 10527, 10527),
         16#54#           =>  --  2854
          (0, 0, 10528, 10528),
         16#55#           =>  --  2855
          (0, 0, 10529, 10529),
         16#56#           =>  --  2856
          (0, 0, 10530, 10530),
         16#57#           =>  --  2857
          (0, 0, 10531, 10531),
         16#58#           =>  --  2858
          (0, 0, 10532, 10532),
         16#59#           =>  --  2859
          (0, 0, 10533, 10533),
         16#5A#           =>  --  285A
          (0, 0, 10534, 10534),
         16#5B#           =>  --  285B
          (0, 0, 10535, 10535),
         16#5C#           =>  --  285C
          (0, 0, 10536, 10536),
         16#5D#           =>  --  285D
          (0, 0, 10537, 10537),
         16#5E#           =>  --  285E
          (0, 0, 10538, 10538),
         16#5F#           =>  --  285F
          (0, 0, 10539, 10539),
         16#60#           =>  --  2860
          (0, 0, 10540, 10540),
         16#61#           =>  --  2861
          (0, 0, 10541, 10541),
         16#62#           =>  --  2862
          (0, 0, 10542, 10542),
         16#63#           =>  --  2863
          (0, 0, 10543, 10543),
         16#64#           =>  --  2864
          (0, 0, 10544, 10544),
         16#65#           =>  --  2865
          (0, 0, 10545, 10545),
         16#66#           =>  --  2866
          (0, 0, 10546, 10546),
         16#67#           =>  --  2867
          (0, 0, 10547, 10547),
         16#68#           =>  --  2868
          (0, 0, 10548, 10548),
         16#69#           =>  --  2869
          (0, 0, 10549, 10549),
         16#6A#           =>  --  286A
          (0, 0, 10550, 10550),
         16#6B#           =>  --  286B
          (0, 0, 10551, 10551),
         16#6C#           =>  --  286C
          (0, 0, 10552, 10552),
         16#6D#           =>  --  286D
          (0, 0, 10553, 10553),
         16#6E#           =>  --  286E
          (0, 0, 10554, 10554),
         16#6F#           =>  --  286F
          (0, 0, 10555, 10555),
         16#70#           =>  --  2870
          (0, 0, 10556, 10556),
         16#71#           =>  --  2871
          (0, 0, 10557, 10557),
         16#72#           =>  --  2872
          (0, 0, 10558, 10558),
         16#73#           =>  --  2873
          (0, 0, 10559, 10559),
         16#74#           =>  --  2874
          (0, 0, 10560, 10560),
         16#75#           =>  --  2875
          (0, 0, 10561, 10561),
         16#76#           =>  --  2876
          (0, 0, 10562, 10562),
         16#77#           =>  --  2877
          (0, 0, 10563, 10563),
         16#78#           =>  --  2878
          (0, 0, 10564, 10564),
         16#79#           =>  --  2879
          (0, 0, 10565, 10565),
         16#7A#           =>  --  287A
          (0, 0, 10566, 10566),
         16#7B#           =>  --  287B
          (0, 0, 10567, 10567),
         16#7C#           =>  --  287C
          (0, 0, 10568, 10568),
         16#7D#           =>  --  287D
          (0, 0, 10569, 10569),
         16#7E#           =>  --  287E
          (0, 0, 10570, 10570),
         16#7F#           =>  --  287F
          (0, 0, 10571, 10571),
         16#80#           =>  --  2880
          (0, 0, 10572, 10572),
         16#81#           =>  --  2881
          (0, 0, 10573, 10573),
         16#82#           =>  --  2882
          (0, 0, 10574, 10574),
         16#83#           =>  --  2883
          (0, 0, 10575, 10575),
         16#84#           =>  --  2884
          (0, 0, 10576, 10576),
         16#85#           =>  --  2885
          (0, 0, 10577, 10577),
         16#86#           =>  --  2886
          (0, 0, 10578, 10578),
         16#87#           =>  --  2887
          (0, 0, 10579, 10579),
         16#88#           =>  --  2888
          (0, 0, 10580, 10580),
         16#89#           =>  --  2889
          (0, 0, 10581, 10581),
         16#8A#           =>  --  288A
          (0, 0, 10582, 10582),
         16#8B#           =>  --  288B
          (0, 0, 10583, 10583),
         16#8C#           =>  --  288C
          (0, 0, 10584, 10584),
         16#8D#           =>  --  288D
          (0, 0, 10585, 10585),
         16#8E#           =>  --  288E
          (0, 0, 10586, 10586),
         16#8F#           =>  --  288F
          (0, 0, 10587, 10587),
         16#90#           =>  --  2890
          (0, 0, 10588, 10588),
         16#91#           =>  --  2891
          (0, 0, 10589, 10589),
         16#92#           =>  --  2892
          (0, 0, 10590, 10590),
         16#93#           =>  --  2893
          (0, 0, 10591, 10591),
         16#94#           =>  --  2894
          (0, 0, 10592, 10592),
         16#95#           =>  --  2895
          (0, 0, 10593, 10593),
         16#96#           =>  --  2896
          (0, 0, 10594, 10594),
         16#97#           =>  --  2897
          (0, 0, 10595, 10595),
         16#98#           =>  --  2898
          (0, 0, 10596, 10596),
         16#99#           =>  --  2899
          (0, 0, 10597, 10597),
         16#9A#           =>  --  289A
          (0, 0, 10598, 10598),
         16#9B#           =>  --  289B
          (0, 0, 10599, 10599),
         16#9C#           =>  --  289C
          (0, 0, 10600, 10600),
         16#9D#           =>  --  289D
          (0, 0, 10601, 10601),
         16#9E#           =>  --  289E
          (0, 0, 10602, 10602),
         16#9F#           =>  --  289F
          (0, 0, 10603, 10603),
         16#A0#           =>  --  28A0
          (0, 0, 10604, 10604),
         16#A1#           =>  --  28A1
          (0, 0, 10605, 10605),
         16#A2#           =>  --  28A2
          (0, 0, 10606, 10606),
         16#A3#           =>  --  28A3
          (0, 0, 10607, 10607),
         16#A4#           =>  --  28A4
          (0, 0, 10608, 10608),
         16#A5#           =>  --  28A5
          (0, 0, 10609, 10609),
         16#A6#           =>  --  28A6
          (0, 0, 10610, 10610),
         16#A7#           =>  --  28A7
          (0, 0, 10611, 10611),
         16#A8#           =>  --  28A8
          (0, 0, 10612, 10612),
         16#A9#           =>  --  28A9
          (0, 0, 10613, 10613),
         16#AA#           =>  --  28AA
          (0, 0, 10614, 10614),
         16#AB#           =>  --  28AB
          (0, 0, 10615, 10615),
         16#AC#           =>  --  28AC
          (0, 0, 10616, 10616),
         16#AD#           =>  --  28AD
          (0, 0, 10617, 10617),
         16#AE#           =>  --  28AE
          (0, 0, 10618, 10618),
         16#AF#           =>  --  28AF
          (0, 0, 10619, 10619),
         16#B0#           =>  --  28B0
          (0, 0, 10620, 10620),
         16#B1#           =>  --  28B1
          (0, 0, 10621, 10621),
         16#B2#           =>  --  28B2
          (0, 0, 10622, 10622),
         16#B3#           =>  --  28B3
          (0, 0, 10623, 10623),
         16#B4#           =>  --  28B4
          (0, 0, 10624, 10624),
         16#B5#           =>  --  28B5
          (0, 0, 10625, 10625),
         16#B6#           =>  --  28B6
          (0, 0, 10626, 10626),
         16#B7#           =>  --  28B7
          (0, 0, 10627, 10627),
         16#B8#           =>  --  28B8
          (0, 0, 10628, 10628),
         16#B9#           =>  --  28B9
          (0, 0, 10629, 10629),
         16#BA#           =>  --  28BA
          (0, 0, 10630, 10630),
         16#BB#           =>  --  28BB
          (0, 0, 10631, 10631),
         16#BC#           =>  --  28BC
          (0, 0, 10632, 10632),
         16#BD#           =>  --  28BD
          (0, 0, 10633, 10633),
         16#BE#           =>  --  28BE
          (0, 0, 10634, 10634),
         16#BF#           =>  --  28BF
          (0, 0, 10635, 10635),
         16#C0#           =>  --  28C0
          (0, 0, 10636, 10636),
         16#C1#           =>  --  28C1
          (0, 0, 10637, 10637),
         16#C2#           =>  --  28C2
          (0, 0, 10638, 10638),
         16#C3#           =>  --  28C3
          (0, 0, 10639, 10639),
         16#C4#           =>  --  28C4
          (0, 0, 10640, 10640),
         16#C5#           =>  --  28C5
          (0, 0, 10641, 10641),
         16#C6#           =>  --  28C6
          (0, 0, 10642, 10642),
         16#C7#           =>  --  28C7
          (0, 0, 10643, 10643),
         16#C8#           =>  --  28C8
          (0, 0, 10644, 10644),
         16#C9#           =>  --  28C9
          (0, 0, 10645, 10645),
         16#CA#           =>  --  28CA
          (0, 0, 10646, 10646),
         16#CB#           =>  --  28CB
          (0, 0, 10647, 10647),
         16#CC#           =>  --  28CC
          (0, 0, 10648, 10648),
         16#CD#           =>  --  28CD
          (0, 0, 10649, 10649),
         16#CE#           =>  --  28CE
          (0, 0, 10650, 10650),
         16#CF#           =>  --  28CF
          (0, 0, 10651, 10651),
         16#D0#           =>  --  28D0
          (0, 0, 10652, 10652),
         16#D1#           =>  --  28D1
          (0, 0, 10653, 10653),
         16#D2#           =>  --  28D2
          (0, 0, 10654, 10654),
         16#D3#           =>  --  28D3
          (0, 0, 10655, 10655),
         16#D4#           =>  --  28D4
          (0, 0, 10656, 10656),
         16#D5#           =>  --  28D5
          (0, 0, 10657, 10657),
         16#D6#           =>  --  28D6
          (0, 0, 10658, 10658),
         16#D7#           =>  --  28D7
          (0, 0, 10659, 10659),
         16#D8#           =>  --  28D8
          (0, 0, 10660, 10660),
         16#D9#           =>  --  28D9
          (0, 0, 10661, 10661),
         16#DA#           =>  --  28DA
          (0, 0, 10662, 10662),
         16#DB#           =>  --  28DB
          (0, 0, 10663, 10663),
         16#DC#           =>  --  28DC
          (0, 0, 10664, 10664),
         16#DD#           =>  --  28DD
          (0, 0, 10665, 10665),
         16#DE#           =>  --  28DE
          (0, 0, 10666, 10666),
         16#DF#           =>  --  28DF
          (0, 0, 10667, 10667),
         16#E0#           =>  --  28E0
          (0, 0, 10668, 10668),
         16#E1#           =>  --  28E1
          (0, 0, 10669, 10669),
         16#E2#           =>  --  28E2
          (0, 0, 10670, 10670),
         16#E3#           =>  --  28E3
          (0, 0, 10671, 10671),
         16#E4#           =>  --  28E4
          (0, 0, 10672, 10672),
         16#E5#           =>  --  28E5
          (0, 0, 10673, 10673),
         16#E6#           =>  --  28E6
          (0, 0, 10674, 10674),
         16#E7#           =>  --  28E7
          (0, 0, 10675, 10675),
         16#E8#           =>  --  28E8
          (0, 0, 10676, 10676),
         16#E9#           =>  --  28E9
          (0, 0, 10677, 10677),
         16#EA#           =>  --  28EA
          (0, 0, 10678, 10678),
         16#EB#           =>  --  28EB
          (0, 0, 10679, 10679),
         16#EC#           =>  --  28EC
          (0, 0, 10680, 10680),
         16#ED#           =>  --  28ED
          (0, 0, 10681, 10681),
         16#EE#           =>  --  28EE
          (0, 0, 10682, 10682),
         16#EF#           =>  --  28EF
          (0, 0, 10683, 10683),
         16#F0#           =>  --  28F0
          (0, 0, 10684, 10684),
         16#F1#           =>  --  28F1
          (0, 0, 10685, 10685),
         16#F2#           =>  --  28F2
          (0, 0, 10686, 10686),
         16#F3#           =>  --  28F3
          (0, 0, 10687, 10687),
         16#F4#           =>  --  28F4
          (0, 0, 10688, 10688),
         16#F5#           =>  --  28F5
          (0, 0, 10689, 10689),
         16#F6#           =>  --  28F6
          (0, 0, 10690, 10690),
         16#F7#           =>  --  28F7
          (0, 0, 10691, 10691),
         16#F8#           =>  --  28F8
          (0, 0, 10692, 10692),
         16#F9#           =>  --  28F9
          (0, 0, 10693, 10693),
         16#FA#           =>  --  28FA
          (0, 0, 10694, 10694),
         16#FB#           =>  --  28FB
          (0, 0, 10695, 10695),
         16#FC#           =>  --  28FC
          (0, 0, 10696, 10696),
         16#FD#           =>  --  28FD
          (0, 0, 10697, 10697),
         16#FE#           =>  --  28FE
          (0, 0, 10698, 10698),
         16#FF#           =>  --  28FF
          (0, 0, 10699, 10699),
         others           =>
          (0, 0, 9425, 9425));

   Group_0029 : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  2900
          (0, 0, 10700, 10700),
         16#01#           =>  --  2901
          (0, 0, 10701, 10701),
         16#02#           =>  --  2902
          (0, 0, 10702, 10702),
         16#03#           =>  --  2903
          (0, 0, 10703, 10703),
         16#04#           =>  --  2904
          (0, 0, 10704, 10704),
         16#05#           =>  --  2905
          (0, 0, 10705, 10705),
         16#06#           =>  --  2906
          (0, 0, 10706, 10706),
         16#07#           =>  --  2907
          (0, 0, 10707, 10707),
         16#08#           =>  --  2908
          (0, 0, 10708, 10708),
         16#09#           =>  --  2909
          (0, 0, 10709, 10709),
         16#0A#           =>  --  290A
          (0, 0, 10710, 10710),
         16#0B#           =>  --  290B
          (0, 0, 10711, 10711),
         16#0C#           =>  --  290C
          (0, 0, 10712, 10712),
         16#0D#           =>  --  290D
          (0, 0, 10713, 10713),
         16#0E#           =>  --  290E
          (0, 0, 10714, 10714),
         16#0F#           =>  --  290F
          (0, 0, 10715, 10715),
         16#10#           =>  --  2910
          (0, 0, 10716, 10716),
         16#11#           =>  --  2911
          (0, 0, 10717, 10717),
         16#12#           =>  --  2912
          (0, 0, 10718, 10718),
         16#13#           =>  --  2913
          (0, 0, 10719, 10719),
         16#14#           =>  --  2914
          (0, 0, 10720, 10720),
         16#15#           =>  --  2915
          (0, 0, 10721, 10721),
         16#16#           =>  --  2916
          (0, 0, 10722, 10722),
         16#17#           =>  --  2917
          (0, 0, 10723, 10723),
         16#18#           =>  --  2918
          (0, 0, 10724, 10724),
         16#19#           =>  --  2919
          (0, 0, 10725, 10725),
         16#1A#           =>  --  291A
          (0, 0, 10726, 10726),
         16#1B#           =>  --  291B
          (0, 0, 10727, 10727),
         16#1C#           =>  --  291C
          (0, 0, 10728, 10728),
         16#1D#           =>  --  291D
          (0, 0, 10729, 10729),
         16#1E#           =>  --  291E
          (0, 0, 10730, 10730),
         16#1F#           =>  --  291F
          (0, 0, 10731, 10731),
         16#20#           =>  --  2920
          (0, 0, 10732, 10732),
         16#21#           =>  --  2921
          (0, 0, 10733, 10733),
         16#22#           =>  --  2922
          (0, 0, 10734, 10734),
         16#23#           =>  --  2923
          (0, 0, 10735, 10735),
         16#24#           =>  --  2924
          (0, 0, 10736, 10736),
         16#25#           =>  --  2925
          (0, 0, 10737, 10737),
         16#26#           =>  --  2926
          (0, 0, 10738, 10738),
         16#27#           =>  --  2927
          (0, 0, 10739, 10739),
         16#28#           =>  --  2928
          (0, 0, 10740, 10740),
         16#29#           =>  --  2929
          (0, 0, 10741, 10741),
         16#2A#           =>  --  292A
          (0, 0, 10742, 10742),
         16#2B#           =>  --  292B
          (0, 0, 10743, 10743),
         16#2C#           =>  --  292C
          (0, 0, 10744, 10744),
         16#2D#           =>  --  292D
          (0, 0, 10745, 10745),
         16#2E#           =>  --  292E
          (0, 0, 10746, 10746),
         16#2F#           =>  --  292F
          (0, 0, 10747, 10747),
         16#30#           =>  --  2930
          (0, 0, 10748, 10748),
         16#31#           =>  --  2931
          (0, 0, 10749, 10749),
         16#32#           =>  --  2932
          (0, 0, 10750, 10750),
         16#33#           =>  --  2933
          (0, 0, 10751, 10751),
         16#34#           =>  --  2934
          (0, 0, 10752, 10752),
         16#35#           =>  --  2935
          (0, 0, 10753, 10753),
         16#36#           =>  --  2936
          (0, 0, 10754, 10754),
         16#37#           =>  --  2937
          (0, 0, 10755, 10755),
         16#38#           =>  --  2938
          (0, 0, 10756, 10756),
         16#39#           =>  --  2939
          (0, 0, 10757, 10757),
         16#3A#           =>  --  293A
          (0, 0, 10758, 10758),
         16#3B#           =>  --  293B
          (0, 0, 10759, 10759),
         16#3C#           =>  --  293C
          (0, 0, 10760, 10760),
         16#3D#           =>  --  293D
          (0, 0, 10761, 10761),
         16#3E#           =>  --  293E
          (0, 0, 10762, 10762),
         16#3F#           =>  --  293F
          (0, 0, 10763, 10763),
         16#40#           =>  --  2940
          (0, 0, 10764, 10764),
         16#41#           =>  --  2941
          (0, 0, 10765, 10765),
         16#42#           =>  --  2942
          (0, 0, 10766, 10766),
         16#43#           =>  --  2943
          (0, 0, 10767, 10767),
         16#44#           =>  --  2944
          (0, 0, 10768, 10768),
         16#45#           =>  --  2945
          (0, 0, 10769, 10769),
         16#46#           =>  --  2946
          (0, 0, 10770, 10770),
         16#47#           =>  --  2947
          (0, 0, 10771, 10771),
         16#48#           =>  --  2948
          (0, 0, 10772, 10772),
         16#49#           =>  --  2949
          (0, 0, 10773, 10773),
         16#4A#           =>  --  294A
          (0, 0, 10774, 10774),
         16#4B#           =>  --  294B
          (0, 0, 10775, 10775),
         16#4C#           =>  --  294C
          (0, 0, 10776, 10776),
         16#4D#           =>  --  294D
          (0, 0, 10777, 10777),
         16#4E#           =>  --  294E
          (0, 0, 10778, 10778),
         16#4F#           =>  --  294F
          (0, 0, 10779, 10779),
         16#50#           =>  --  2950
          (0, 0, 10780, 10780),
         16#51#           =>  --  2951
          (0, 0, 10781, 10781),
         16#52#           =>  --  2952
          (0, 0, 10782, 10782),
         16#53#           =>  --  2953
          (0, 0, 10783, 10783),
         16#54#           =>  --  2954
          (0, 0, 10784, 10784),
         16#55#           =>  --  2955
          (0, 0, 10785, 10785),
         16#56#           =>  --  2956
          (0, 0, 10786, 10786),
         16#57#           =>  --  2957
          (0, 0, 10787, 10787),
         16#58#           =>  --  2958
          (0, 0, 10788, 10788),
         16#59#           =>  --  2959
          (0, 0, 10789, 10789),
         16#5A#           =>  --  295A
          (0, 0, 10790, 10790),
         16#5B#           =>  --  295B
          (0, 0, 10791, 10791),
         16#5C#           =>  --  295C
          (0, 0, 10792, 10792),
         16#5D#           =>  --  295D
          (0, 0, 10793, 10793),
         16#5E#           =>  --  295E
          (0, 0, 10794, 10794),
         16#5F#           =>  --  295F
          (0, 0, 10795, 10795),
         16#60#           =>  --  2960
          (0, 0, 10796, 10796),
         16#61#           =>  --  2961
          (0, 0, 10797, 10797),
         16#62#           =>  --  2962
          (0, 0, 10798, 10798),
         16#63#           =>  --  2963
          (0, 0, 10799, 10799),
         16#64#           =>  --  2964
          (0, 0, 10800, 10800),
         16#65#           =>  --  2965
          (0, 0, 10801, 10801),
         16#66#           =>  --  2966
          (0, 0, 10802, 10802),
         16#67#           =>  --  2967
          (0, 0, 10803, 10803),
         16#68#           =>  --  2968
          (0, 0, 10804, 10804),
         16#69#           =>  --  2969
          (0, 0, 10805, 10805),
         16#6A#           =>  --  296A
          (0, 0, 10806, 10806),
         16#6B#           =>  --  296B
          (0, 0, 10807, 10807),
         16#6C#           =>  --  296C
          (0, 0, 10808, 10808),
         16#6D#           =>  --  296D
          (0, 0, 10809, 10809),
         16#6E#           =>  --  296E
          (0, 0, 10810, 10810),
         16#6F#           =>  --  296F
          (0, 0, 10811, 10811),
         16#70#           =>  --  2970
          (0, 0, 10812, 10812),
         16#71#           =>  --  2971
          (0, 0, 10813, 10813),
         16#72#           =>  --  2972
          (0, 0, 10814, 10814),
         16#73#           =>  --  2973
          (0, 0, 10815, 10815),
         16#74#           =>  --  2974
          (0, 0, 10816, 10816),
         16#75#           =>  --  2975
          (0, 0, 10817, 10817),
         16#76#           =>  --  2976
          (0, 0, 10818, 10818),
         16#77#           =>  --  2977
          (0, 0, 10819, 10819),
         16#78#           =>  --  2978
          (0, 0, 10820, 10820),
         16#79#           =>  --  2979
          (0, 0, 10821, 10821),
         16#7A#           =>  --  297A
          (0, 0, 10822, 10822),
         16#7B#           =>  --  297B
          (0, 0, 10823, 10823),
         16#7C#           =>  --  297C
          (0, 0, 10824, 10824),
         16#7D#           =>  --  297D
          (0, 0, 10825, 10825),
         16#7E#           =>  --  297E
          (0, 0, 10826, 10826),
         16#7F#           =>  --  297F
          (0, 0, 10827, 10827),
         16#80#           =>  --  2980
          (0, 0, 10828, 10828),
         16#81#           =>  --  2981
          (0, 0, 10829, 10829),
         16#82#           =>  --  2982
          (0, 0, 10830, 10830),
         16#83#           =>  --  2983
          (0, 0, 10831, 10831),
         16#84#           =>  --  2984
          (0, 0, 10832, 10832),
         16#85#           =>  --  2985
          (0, 0, 10833, 10833),
         16#86#           =>  --  2986
          (0, 0, 10834, 10834),
         16#87#           =>  --  2987
          (0, 0, 10835, 10835),
         16#88#           =>  --  2988
          (0, 0, 10836, 10836),
         16#89#           =>  --  2989
          (0, 0, 10837, 10837),
         16#8A#           =>  --  298A
          (0, 0, 10838, 10838),
         16#8B#           =>  --  298B
          (0, 0, 10839, 10839),
         16#8C#           =>  --  298C
          (0, 0, 10840, 10840),
         16#8D#           =>  --  298D
          (0, 0, 10841, 10841),
         16#8E#           =>  --  298E
          (0, 0, 10842, 10842),
         16#8F#           =>  --  298F
          (0, 0, 10843, 10843),
         16#90#           =>  --  2990
          (0, 0, 10844, 10844),
         16#91#           =>  --  2991
          (0, 0, 10845, 10845),
         16#92#           =>  --  2992
          (0, 0, 10846, 10846),
         16#93#           =>  --  2993
          (0, 0, 10847, 10847),
         16#94#           =>  --  2994
          (0, 0, 10848, 10848),
         16#95#           =>  --  2995
          (0, 0, 10849, 10849),
         16#96#           =>  --  2996
          (0, 0, 10850, 10850),
         16#97#           =>  --  2997
          (0, 0, 10851, 10851),
         16#98#           =>  --  2998
          (0, 0, 10852, 10852),
         16#99#           =>  --  2999
          (0, 0, 10853, 10853),
         16#9A#           =>  --  299A
          (0, 0, 10854, 10854),
         16#9B#           =>  --  299B
          (0, 0, 10855, 10855),
         16#9C#           =>  --  299C
          (0, 0, 10856, 10856),
         16#9D#           =>  --  299D
          (0, 0, 10857, 10857),
         16#9E#           =>  --  299E
          (0, 0, 10858, 10858),
         16#9F#           =>  --  299F
          (0, 0, 10859, 10859),
         16#A0#           =>  --  29A0
          (0, 0, 10860, 10860),
         16#A1#           =>  --  29A1
          (0, 0, 10861, 10861),
         16#A2#           =>  --  29A2
          (0, 0, 10862, 10862),
         16#A3#           =>  --  29A3
          (0, 0, 10863, 10863),
         16#A4#           =>  --  29A4
          (0, 0, 10864, 10864),
         16#A5#           =>  --  29A5
          (0, 0, 10865, 10865),
         16#A6#           =>  --  29A6
          (0, 0, 10866, 10866),
         16#A7#           =>  --  29A7
          (0, 0, 10867, 10867),
         16#A8#           =>  --  29A8
          (0, 0, 10868, 10868),
         16#A9#           =>  --  29A9
          (0, 0, 10869, 10869),
         16#AA#           =>  --  29AA
          (0, 0, 10870, 10870),
         16#AB#           =>  --  29AB
          (0, 0, 10871, 10871),
         16#AC#           =>  --  29AC
          (0, 0, 10872, 10872),
         16#AD#           =>  --  29AD
          (0, 0, 10873, 10873),
         16#AE#           =>  --  29AE
          (0, 0, 10874, 10874),
         16#AF#           =>  --  29AF
          (0, 0, 10875, 10875),
         16#B0#           =>  --  29B0
          (0, 0, 10876, 10876),
         16#B1#           =>  --  29B1
          (0, 0, 10877, 10877),
         16#B2#           =>  --  29B2
          (0, 0, 10878, 10878),
         16#B3#           =>  --  29B3
          (0, 0, 10879, 10879),
         16#B4#           =>  --  29B4
          (0, 0, 10880, 10880),
         16#B5#           =>  --  29B5
          (0, 0, 10881, 10881),
         16#B6#           =>  --  29B6
          (0, 0, 10882, 10882),
         16#B7#           =>  --  29B7
          (0, 0, 10883, 10883),
         16#B8#           =>  --  29B8
          (0, 0, 10884, 10884),
         16#B9#           =>  --  29B9
          (0, 0, 10885, 10885),
         16#BA#           =>  --  29BA
          (0, 0, 10886, 10886),
         16#BB#           =>  --  29BB
          (0, 0, 10887, 10887),
         16#BC#           =>  --  29BC
          (0, 0, 10888, 10888),
         16#BD#           =>  --  29BD
          (0, 0, 10889, 10889),
         16#BE#           =>  --  29BE
          (0, 0, 10890, 10890),
         16#BF#           =>  --  29BF
          (0, 0, 10891, 10891),
         16#C0#           =>  --  29C0
          (0, 0, 10892, 10892),
         16#C1#           =>  --  29C1
          (0, 0, 10893, 10893),
         16#C2#           =>  --  29C2
          (0, 0, 10894, 10894),
         16#C3#           =>  --  29C3
          (0, 0, 10895, 10895),
         16#C4#           =>  --  29C4
          (0, 0, 10896, 10896),
         16#C5#           =>  --  29C5
          (0, 0, 10897, 10897),
         16#C6#           =>  --  29C6
          (0, 0, 10898, 10898),
         16#C7#           =>  --  29C7
          (0, 0, 10899, 10899),
         16#C8#           =>  --  29C8
          (0, 0, 10900, 10900),
         16#C9#           =>  --  29C9
          (0, 0, 10901, 10901),
         16#CA#           =>  --  29CA
          (0, 0, 10902, 10902),
         16#CB#           =>  --  29CB
          (0, 0, 10903, 10903),
         16#CC#           =>  --  29CC
          (0, 0, 10904, 10904),
         16#CD#           =>  --  29CD
          (0, 0, 10905, 10905),
         16#CE#           =>  --  29CE
          (0, 0, 10906, 10906),
         16#CF#           =>  --  29CF
          (0, 0, 10907, 10907),
         16#D0#           =>  --  29D0
          (0, 0, 10908, 10908),
         16#D1#           =>  --  29D1
          (0, 0, 10909, 10909),
         16#D2#           =>  --  29D2
          (0, 0, 10910, 10910),
         16#D3#           =>  --  29D3
          (0, 0, 10911, 10911),
         16#D4#           =>  --  29D4
          (0, 0, 10912, 10912),
         16#D5#           =>  --  29D5
          (0, 0, 10913, 10913),
         16#D6#           =>  --  29D6
          (0, 0, 10914, 10914),
         16#D7#           =>  --  29D7
          (0, 0, 10915, 10915),
         16#D8#           =>  --  29D8
          (0, 0, 10916, 10916),
         16#D9#           =>  --  29D9
          (0, 0, 10917, 10917),
         16#DA#           =>  --  29DA
          (0, 0, 10918, 10918),
         16#DB#           =>  --  29DB
          (0, 0, 10919, 10919),
         16#DC#           =>  --  29DC
          (0, 0, 10920, 10920),
         16#DD#           =>  --  29DD
          (0, 0, 10921, 10921),
         16#DE#           =>  --  29DE
          (0, 0, 10922, 10922),
         16#DF#           =>  --  29DF
          (0, 0, 10923, 10923),
         16#E0#           =>  --  29E0
          (0, 0, 10924, 10924),
         16#E1#           =>  --  29E1
          (0, 0, 10925, 10925),
         16#E2#           =>  --  29E2
          (0, 0, 10926, 10926),
         16#E3#           =>  --  29E3
          (0, 0, 10927, 10927),
         16#E4#           =>  --  29E4
          (0, 0, 10928, 10928),
         16#E5#           =>  --  29E5
          (0, 0, 10929, 10929),
         16#E6#           =>  --  29E6
          (0, 0, 10930, 10930),
         16#E7#           =>  --  29E7
          (0, 0, 10931, 10931),
         16#E8#           =>  --  29E8
          (0, 0, 10932, 10932),
         16#E9#           =>  --  29E9
          (0, 0, 10933, 10933),
         16#EA#           =>  --  29EA
          (0, 0, 10934, 10934),
         16#EB#           =>  --  29EB
          (0, 0, 10935, 10935),
         16#EC#           =>  --  29EC
          (0, 0, 10936, 10936),
         16#ED#           =>  --  29ED
          (0, 0, 10937, 10937),
         16#EE#           =>  --  29EE
          (0, 0, 10938, 10938),
         16#EF#           =>  --  29EF
          (0, 0, 10939, 10939),
         16#F0#           =>  --  29F0
          (0, 0, 10940, 10940),
         16#F1#           =>  --  29F1
          (0, 0, 10941, 10941),
         16#F2#           =>  --  29F2
          (0, 0, 10942, 10942),
         16#F3#           =>  --  29F3
          (0, 0, 10943, 10943),
         16#F4#           =>  --  29F4
          (0, 0, 10944, 10944),
         16#F5#           =>  --  29F5
          (0, 0, 10945, 10945),
         16#F6#           =>  --  29F6
          (0, 0, 10946, 10946),
         16#F7#           =>  --  29F7
          (0, 0, 10947, 10947),
         16#F8#           =>  --  29F8
          (0, 0, 10948, 10948),
         16#F9#           =>  --  29F9
          (0, 0, 10949, 10949),
         16#FA#           =>  --  29FA
          (0, 0, 10950, 10950),
         16#FB#           =>  --  29FB
          (0, 0, 10951, 10951),
         16#FC#           =>  --  29FC
          (0, 0, 10952, 10952),
         16#FD#           =>  --  29FD
          (0, 0, 10953, 10953),
         16#FE#           =>  --  29FE
          (0, 0, 10954, 10954),
         16#FF#           =>  --  29FF
          (0, 0, 10955, 10955),
         others           =>
          (0, 0, 9425, 9425));

   Group_002A : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  2A00
          (0, 0, 10956, 10956),
         16#01#           =>  --  2A01
          (0, 0, 10957, 10957),
         16#02#           =>  --  2A02
          (0, 0, 10958, 10958),
         16#03#           =>  --  2A03
          (0, 0, 10959, 10959),
         16#04#           =>  --  2A04
          (0, 0, 10960, 10960),
         16#05#           =>  --  2A05
          (0, 0, 10961, 10961),
         16#06#           =>  --  2A06
          (0, 0, 10962, 10962),
         16#07#           =>  --  2A07
          (0, 0, 10963, 10963),
         16#08#           =>  --  2A08
          (0, 0, 10964, 10964),
         16#09#           =>  --  2A09
          (0, 0, 10965, 10965),
         16#0A#           =>  --  2A0A
          (0, 0, 10966, 10966),
         16#0B#           =>  --  2A0B
          (0, 0, 10967, 10967),
         16#0C#           =>  --  2A0C
          (0, 0, 8873, 8876),
         16#0D#           =>  --  2A0D
          (0, 0, 10968, 10968),
         16#0E#           =>  --  2A0E
          (0, 0, 10969, 10969),
         16#0F#           =>  --  2A0F
          (0, 0, 10970, 10970),
         16#10#           =>  --  2A10
          (0, 0, 10971, 10971),
         16#11#           =>  --  2A11
          (0, 0, 10972, 10972),
         16#12#           =>  --  2A12
          (0, 0, 10973, 10973),
         16#13#           =>  --  2A13
          (0, 0, 10974, 10974),
         16#14#           =>  --  2A14
          (0, 0, 10975, 10975),
         16#15#           =>  --  2A15
          (0, 0, 10976, 10976),
         16#16#           =>  --  2A16
          (0, 0, 10977, 10977),
         16#17#           =>  --  2A17
          (0, 0, 10978, 10978),
         16#18#           =>  --  2A18
          (0, 0, 10979, 10979),
         16#19#           =>  --  2A19
          (0, 0, 10980, 10980),
         16#1A#           =>  --  2A1A
          (0, 0, 10981, 10981),
         16#1B#           =>  --  2A1B
          (0, 0, 10982, 10982),
         16#1C#           =>  --  2A1C
          (0, 0, 10983, 10983),
         16#1D#           =>  --  2A1D
          (0, 0, 10984, 10984),
         16#1E#           =>  --  2A1E
          (0, 0, 10985, 10985),
         16#1F#           =>  --  2A1F
          (0, 0, 10986, 10986),
         16#20#           =>  --  2A20
          (0, 0, 10987, 10987),
         16#21#           =>  --  2A21
          (0, 0, 10988, 10988),
         16#22#           =>  --  2A22
          (0, 0, 10989, 10989),
         16#23#           =>  --  2A23
          (0, 0, 10990, 10990),
         16#24#           =>  --  2A24
          (0, 0, 10991, 10991),
         16#25#           =>  --  2A25
          (0, 0, 10992, 10992),
         16#26#           =>  --  2A26
          (0, 0, 10993, 10993),
         16#27#           =>  --  2A27
          (0, 0, 10994, 10994),
         16#28#           =>  --  2A28
          (0, 0, 10995, 10995),
         16#29#           =>  --  2A29
          (0, 0, 10996, 10996),
         16#2A#           =>  --  2A2A
          (0, 0, 10997, 10997),
         16#2B#           =>  --  2A2B
          (0, 0, 10998, 10998),
         16#2C#           =>  --  2A2C
          (0, 0, 10999, 10999),
         16#2D#           =>  --  2A2D
          (0, 0, 11000, 11000),
         16#2E#           =>  --  2A2E
          (0, 0, 11001, 11001),
         16#2F#           =>  --  2A2F
          (0, 0, 11002, 11002),
         16#30#           =>  --  2A30
          (0, 0, 11003, 11003),
         16#31#           =>  --  2A31
          (0, 0, 11004, 11004),
         16#32#           =>  --  2A32
          (0, 0, 11005, 11005),
         16#33#           =>  --  2A33
          (0, 0, 11006, 11006),
         16#34#           =>  --  2A34
          (0, 0, 11007, 11007),
         16#35#           =>  --  2A35
          (0, 0, 11008, 11008),
         16#36#           =>  --  2A36
          (0, 0, 11009, 11009),
         16#37#           =>  --  2A37
          (0, 0, 11010, 11010),
         16#38#           =>  --  2A38
          (0, 0, 11011, 11011),
         16#39#           =>  --  2A39
          (0, 0, 11012, 11012),
         16#3A#           =>  --  2A3A
          (0, 0, 11013, 11013),
         16#3B#           =>  --  2A3B
          (0, 0, 11014, 11014),
         16#3C#           =>  --  2A3C
          (0, 0, 11015, 11015),
         16#3D#           =>  --  2A3D
          (0, 0, 11016, 11016),
         16#3E#           =>  --  2A3E
          (0, 0, 11017, 11017),
         16#3F#           =>  --  2A3F
          (0, 0, 11018, 11018),
         16#40#           =>  --  2A40
          (0, 0, 11019, 11019),
         16#41#           =>  --  2A41
          (0, 0, 11020, 11020),
         16#42#           =>  --  2A42
          (0, 0, 11021, 11021),
         16#43#           =>  --  2A43
          (0, 0, 11022, 11022),
         16#44#           =>  --  2A44
          (0, 0, 11023, 11023),
         16#45#           =>  --  2A45
          (0, 0, 11024, 11024),
         16#46#           =>  --  2A46
          (0, 0, 11025, 11025),
         16#47#           =>  --  2A47
          (0, 0, 11026, 11026),
         16#48#           =>  --  2A48
          (0, 0, 11027, 11027),
         16#49#           =>  --  2A49
          (0, 0, 11028, 11028),
         16#4A#           =>  --  2A4A
          (0, 0, 11029, 11029),
         16#4B#           =>  --  2A4B
          (0, 0, 11030, 11030),
         16#4C#           =>  --  2A4C
          (0, 0, 11031, 11031),
         16#4D#           =>  --  2A4D
          (0, 0, 11032, 11032),
         16#4E#           =>  --  2A4E
          (0, 0, 11033, 11033),
         16#4F#           =>  --  2A4F
          (0, 0, 11034, 11034),
         16#50#           =>  --  2A50
          (0, 0, 11035, 11035),
         16#51#           =>  --  2A51
          (0, 0, 11036, 11036),
         16#52#           =>  --  2A52
          (0, 0, 11037, 11037),
         16#53#           =>  --  2A53
          (0, 0, 11038, 11038),
         16#54#           =>  --  2A54
          (0, 0, 11039, 11039),
         16#55#           =>  --  2A55
          (0, 0, 11040, 11040),
         16#56#           =>  --  2A56
          (0, 0, 11041, 11041),
         16#57#           =>  --  2A57
          (0, 0, 11042, 11042),
         16#58#           =>  --  2A58
          (0, 0, 11043, 11043),
         16#59#           =>  --  2A59
          (0, 0, 11044, 11044),
         16#5A#           =>  --  2A5A
          (0, 0, 11045, 11045),
         16#5B#           =>  --  2A5B
          (0, 0, 11046, 11046),
         16#5C#           =>  --  2A5C
          (0, 0, 11047, 11047),
         16#5D#           =>  --  2A5D
          (0, 0, 11048, 11048),
         16#5E#           =>  --  2A5E
          (0, 0, 11049, 11049),
         16#5F#           =>  --  2A5F
          (0, 0, 11050, 11050),
         16#60#           =>  --  2A60
          (0, 0, 11051, 11051),
         16#61#           =>  --  2A61
          (0, 0, 11052, 11052),
         16#62#           =>  --  2A62
          (0, 0, 11053, 11053),
         16#63#           =>  --  2A63
          (0, 0, 11054, 11054),
         16#64#           =>  --  2A64
          (0, 0, 11055, 11055),
         16#65#           =>  --  2A65
          (0, 0, 11056, 11056),
         16#66#           =>  --  2A66
          (0, 0, 11057, 11057),
         16#67#           =>  --  2A67
          (0, 0, 11058, 11058),
         16#68#           =>  --  2A68
          (0, 0, 11059, 11059),
         16#69#           =>  --  2A69
          (0, 0, 11060, 11060),
         16#6A#           =>  --  2A6A
          (0, 0, 11061, 11061),
         16#6B#           =>  --  2A6B
          (0, 0, 11062, 11062),
         16#6C#           =>  --  2A6C
          (0, 0, 11063, 11063),
         16#6D#           =>  --  2A6D
          (0, 0, 11064, 11064),
         16#6E#           =>  --  2A6E
          (0, 0, 11065, 11065),
         16#6F#           =>  --  2A6F
          (0, 0, 11066, 11066),
         16#70#           =>  --  2A70
          (0, 0, 11067, 11067),
         16#71#           =>  --  2A71
          (0, 0, 11068, 11068),
         16#72#           =>  --  2A72
          (0, 0, 11069, 11069),
         16#73#           =>  --  2A73
          (0, 0, 11070, 11070),
         16#74#           =>  --  2A74
          (0, 0, 11071, 11073),
         16#75#           =>  --  2A75
          (0, 0, 11074, 11075),
         16#76#           =>  --  2A76
          (0, 0, 11073, 11075),
         16#77#           =>  --  2A77
          (0, 0, 11076, 11076),
         16#78#           =>  --  2A78
          (0, 0, 11077, 11077),
         16#79#           =>  --  2A79
          (0, 0, 11078, 11078),
         16#7A#           =>  --  2A7A
          (0, 0, 11079, 11079),
         16#7B#           =>  --  2A7B
          (0, 0, 11080, 11080),
         16#7C#           =>  --  2A7C
          (0, 0, 11081, 11081),
         16#7D#           =>  --  2A7D
          (0, 0, 11082, 11082),
         16#7E#           =>  --  2A7E
          (0, 0, 11083, 11083),
         16#7F#           =>  --  2A7F
          (0, 0, 11084, 11084),
         16#80#           =>  --  2A80
          (0, 0, 11085, 11085),
         16#81#           =>  --  2A81
          (0, 0, 11086, 11086),
         16#82#           =>  --  2A82
          (0, 0, 11087, 11087),
         16#83#           =>  --  2A83
          (0, 0, 11088, 11088),
         16#84#           =>  --  2A84
          (0, 0, 11089, 11089),
         16#85#           =>  --  2A85
          (0, 0, 11090, 11090),
         16#86#           =>  --  2A86
          (0, 0, 11091, 11091),
         16#87#           =>  --  2A87
          (0, 0, 11092, 11092),
         16#88#           =>  --  2A88
          (0, 0, 11093, 11093),
         16#89#           =>  --  2A89
          (0, 0, 11094, 11094),
         16#8A#           =>  --  2A8A
          (0, 0, 11095, 11095),
         16#8B#           =>  --  2A8B
          (0, 0, 11096, 11096),
         16#8C#           =>  --  2A8C
          (0, 0, 11097, 11097),
         16#8D#           =>  --  2A8D
          (0, 0, 11098, 11098),
         16#8E#           =>  --  2A8E
          (0, 0, 11099, 11099),
         16#8F#           =>  --  2A8F
          (0, 0, 11100, 11100),
         16#90#           =>  --  2A90
          (0, 0, 11101, 11101),
         16#91#           =>  --  2A91
          (0, 0, 11102, 11102),
         16#92#           =>  --  2A92
          (0, 0, 11103, 11103),
         16#93#           =>  --  2A93
          (0, 0, 11104, 11104),
         16#94#           =>  --  2A94
          (0, 0, 11105, 11105),
         16#95#           =>  --  2A95
          (0, 0, 11106, 11106),
         16#96#           =>  --  2A96
          (0, 0, 11107, 11107),
         16#97#           =>  --  2A97
          (0, 0, 11108, 11108),
         16#98#           =>  --  2A98
          (0, 0, 11109, 11109),
         16#99#           =>  --  2A99
          (0, 0, 11110, 11110),
         16#9A#           =>  --  2A9A
          (0, 0, 11111, 11111),
         16#9B#           =>  --  2A9B
          (0, 0, 11112, 11112),
         16#9C#           =>  --  2A9C
          (0, 0, 11113, 11113),
         16#9D#           =>  --  2A9D
          (0, 0, 11114, 11114),
         16#9E#           =>  --  2A9E
          (0, 0, 11115, 11115),
         16#9F#           =>  --  2A9F
          (0, 0, 11116, 11116),
         16#A0#           =>  --  2AA0
          (0, 0, 11117, 11117),
         16#A1#           =>  --  2AA1
          (0, 0, 11118, 11118),
         16#A2#           =>  --  2AA2
          (0, 0, 11119, 11119),
         16#A3#           =>  --  2AA3
          (0, 0, 11120, 11120),
         16#A4#           =>  --  2AA4
          (0, 0, 11121, 11121),
         16#A5#           =>  --  2AA5
          (0, 0, 11122, 11122),
         16#A6#           =>  --  2AA6
          (0, 0, 11123, 11123),
         16#A7#           =>  --  2AA7
          (0, 0, 11124, 11124),
         16#A8#           =>  --  2AA8
          (0, 0, 11125, 11125),
         16#A9#           =>  --  2AA9
          (0, 0, 11126, 11126),
         16#AA#           =>  --  2AAA
          (0, 0, 11127, 11127),
         16#AB#           =>  --  2AAB
          (0, 0, 11128, 11128),
         16#AC#           =>  --  2AAC
          (0, 0, 11129, 11129),
         16#AD#           =>  --  2AAD
          (0, 0, 11130, 11130),
         16#AE#           =>  --  2AAE
          (0, 0, 11131, 11131),
         16#AF#           =>  --  2AAF
          (0, 0, 11132, 11132),
         16#B0#           =>  --  2AB0
          (0, 0, 11133, 11133),
         16#B1#           =>  --  2AB1
          (0, 0, 11134, 11134),
         16#B2#           =>  --  2AB2
          (0, 0, 11135, 11135),
         16#B3#           =>  --  2AB3
          (0, 0, 11136, 11136),
         16#B4#           =>  --  2AB4
          (0, 0, 11137, 11137),
         16#B5#           =>  --  2AB5
          (0, 0, 11138, 11138),
         16#B6#           =>  --  2AB6
          (0, 0, 11139, 11139),
         16#B7#           =>  --  2AB7
          (0, 0, 11140, 11140),
         16#B8#           =>  --  2AB8
          (0, 0, 11141, 11141),
         16#B9#           =>  --  2AB9
          (0, 0, 11142, 11142),
         16#BA#           =>  --  2ABA
          (0, 0, 11143, 11143),
         16#BB#           =>  --  2ABB
          (0, 0, 11144, 11144),
         16#BC#           =>  --  2ABC
          (0, 0, 11145, 11145),
         16#BD#           =>  --  2ABD
          (0, 0, 11146, 11146),
         16#BE#           =>  --  2ABE
          (0, 0, 11147, 11147),
         16#BF#           =>  --  2ABF
          (0, 0, 11148, 11148),
         16#C0#           =>  --  2AC0
          (0, 0, 11149, 11149),
         16#C1#           =>  --  2AC1
          (0, 0, 11150, 11150),
         16#C2#           =>  --  2AC2
          (0, 0, 11151, 11151),
         16#C3#           =>  --  2AC3
          (0, 0, 11152, 11152),
         16#C4#           =>  --  2AC4
          (0, 0, 11153, 11153),
         16#C5#           =>  --  2AC5
          (0, 0, 11154, 11154),
         16#C6#           =>  --  2AC6
          (0, 0, 11155, 11155),
         16#C7#           =>  --  2AC7
          (0, 0, 11156, 11156),
         16#C8#           =>  --  2AC8
          (0, 0, 11157, 11157),
         16#C9#           =>  --  2AC9
          (0, 0, 11158, 11158),
         16#CA#           =>  --  2ACA
          (0, 0, 11159, 11159),
         16#CB#           =>  --  2ACB
          (0, 0, 11160, 11160),
         16#CC#           =>  --  2ACC
          (0, 0, 11161, 11161),
         16#CD#           =>  --  2ACD
          (0, 0, 11162, 11162),
         16#CE#           =>  --  2ACE
          (0, 0, 11163, 11163),
         16#CF#           =>  --  2ACF
          (0, 0, 11164, 11164),
         16#D0#           =>  --  2AD0
          (0, 0, 11165, 11165),
         16#D1#           =>  --  2AD1
          (0, 0, 11166, 11166),
         16#D2#           =>  --  2AD2
          (0, 0, 11167, 11167),
         16#D3#           =>  --  2AD3
          (0, 0, 11168, 11168),
         16#D4#           =>  --  2AD4
          (0, 0, 11169, 11169),
         16#D5#           =>  --  2AD5
          (0, 0, 11170, 11170),
         16#D6#           =>  --  2AD6
          (0, 0, 11171, 11171),
         16#D7#           =>  --  2AD7
          (0, 0, 11172, 11172),
         16#D8#           =>  --  2AD8
          (0, 0, 11173, 11173),
         16#D9#           =>  --  2AD9
          (0, 0, 11174, 11174),
         16#DA#           =>  --  2ADA
          (0, 0, 11175, 11175),
         16#DB#           =>  --  2ADB
          (0, 0, 11176, 11176),
         16#DC#           =>  --  2ADC
          (0, 0, 11177, 11178),
         16#DD#           =>  --  2ADD
          (0, 0, 11177, 11177),
         16#DE#           =>  --  2ADE
          (0, 0, 11179, 11179),
         16#DF#           =>  --  2ADF
          (0, 0, 11180, 11180),
         16#E0#           =>  --  2AE0
          (0, 0, 11181, 11181),
         16#E1#           =>  --  2AE1
          (0, 0, 11182, 11182),
         16#E2#           =>  --  2AE2
          (0, 0, 11183, 11183),
         16#E3#           =>  --  2AE3
          (0, 0, 11184, 11184),
         16#E4#           =>  --  2AE4
          (0, 0, 11185, 11185),
         16#E5#           =>  --  2AE5
          (0, 0, 11186, 11186),
         16#E6#           =>  --  2AE6
          (0, 0, 11187, 11187),
         16#E7#           =>  --  2AE7
          (0, 0, 11188, 11188),
         16#E8#           =>  --  2AE8
          (0, 0, 11189, 11189),
         16#E9#           =>  --  2AE9
          (0, 0, 11190, 11190),
         16#EA#           =>  --  2AEA
          (0, 0, 11191, 11191),
         16#EB#           =>  --  2AEB
          (0, 0, 11192, 11192),
         16#EC#           =>  --  2AEC
          (0, 0, 11193, 11193),
         16#ED#           =>  --  2AED
          (0, 0, 11194, 11194),
         16#EE#           =>  --  2AEE
          (0, 0, 11195, 11195),
         16#EF#           =>  --  2AEF
          (0, 0, 11196, 11196),
         16#F0#           =>  --  2AF0
          (0, 0, 11197, 11197),
         16#F1#           =>  --  2AF1
          (0, 0, 11198, 11198),
         16#F2#           =>  --  2AF2
          (0, 0, 11199, 11199),
         16#F3#           =>  --  2AF3
          (0, 0, 11200, 11200),
         16#F4#           =>  --  2AF4
          (0, 0, 11201, 11201),
         16#F5#           =>  --  2AF5
          (0, 0, 11202, 11202),
         16#F6#           =>  --  2AF6
          (0, 0, 11203, 11203),
         16#F7#           =>  --  2AF7
          (0, 0, 11204, 11204),
         16#F8#           =>  --  2AF8
          (0, 0, 11205, 11205),
         16#F9#           =>  --  2AF9
          (0, 0, 11206, 11206),
         16#FA#           =>  --  2AFA
          (0, 0, 11207, 11207),
         16#FB#           =>  --  2AFB
          (0, 0, 11208, 11208),
         16#FC#           =>  --  2AFC
          (0, 0, 11209, 11209),
         16#FD#           =>  --  2AFD
          (0, 0, 11210, 11210),
         16#FE#           =>  --  2AFE
          (0, 0, 11211, 11211),
         16#FF#           =>  --  2AFF
          (0, 0, 11212, 11212),
         others           =>
          (0, 0, 9425, 9425));

   Group_002B : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  2B00
          (0, 0, 11213, 11213),
         16#01#           =>  --  2B01
          (0, 0, 11214, 11214),
         16#02#           =>  --  2B02
          (0, 0, 11215, 11215),
         16#03#           =>  --  2B03
          (0, 0, 11216, 11216),
         16#04#           =>  --  2B04
          (0, 0, 11217, 11217),
         16#05#           =>  --  2B05
          (0, 0, 11218, 11218),
         16#06#           =>  --  2B06
          (0, 0, 11219, 11219),
         16#07#           =>  --  2B07
          (0, 0, 11220, 11220),
         16#08#           =>  --  2B08
          (0, 0, 11221, 11221),
         16#09#           =>  --  2B09
          (0, 0, 11222, 11222),
         16#0A#           =>  --  2B0A
          (0, 0, 11223, 11223),
         16#0B#           =>  --  2B0B
          (0, 0, 11224, 11224),
         16#0C#           =>  --  2B0C
          (0, 0, 11225, 11225),
         16#0D#           =>  --  2B0D
          (0, 0, 11226, 11226),
         16#0E#           =>  --  2B0E
          (0, 0, 11227, 11227),
         16#0F#           =>  --  2B0F
          (0, 0, 11228, 11228),
         16#10#           =>  --  2B10
          (0, 0, 11229, 11229),
         16#11#           =>  --  2B11
          (0, 0, 11230, 11230),
         16#12#           =>  --  2B12
          (0, 0, 11231, 11231),
         16#13#           =>  --  2B13
          (0, 0, 11232, 11232),
         16#14#           =>  --  2B14
          (0, 0, 11233, 11233),
         16#15#           =>  --  2B15
          (0, 0, 11234, 11234),
         16#16#           =>  --  2B16
          (0, 0, 11235, 11235),
         16#17#           =>  --  2B17
          (0, 0, 11236, 11236),
         16#18#           =>  --  2B18
          (0, 0, 11237, 11237),
         16#19#           =>  --  2B19
          (0, 0, 11238, 11238),
         16#1A#           =>  --  2B1A
          (0, 0, 11239, 11239),
         16#1B#           =>  --  2B1B
          (0, 0, 11240, 11240),
         16#1C#           =>  --  2B1C
          (0, 0, 11241, 11241),
         16#1D#           =>  --  2B1D
          (0, 0, 11242, 11242),
         16#1E#           =>  --  2B1E
          (0, 0, 11243, 11243),
         16#1F#           =>  --  2B1F
          (0, 0, 11244, 11244),
         16#20#           =>  --  2B20
          (0, 0, 11245, 11245),
         16#21#           =>  --  2B21
          (0, 0, 11246, 11246),
         16#22#           =>  --  2B22
          (0, 0, 11247, 11247),
         16#23#           =>  --  2B23
          (0, 0, 11248, 11248),
         16#24#           =>  --  2B24
          (0, 0, 11249, 11249),
         16#25#           =>  --  2B25
          (0, 0, 11250, 11250),
         16#26#           =>  --  2B26
          (0, 0, 11251, 11251),
         16#27#           =>  --  2B27
          (0, 0, 11252, 11252),
         16#28#           =>  --  2B28
          (0, 0, 11253, 11253),
         16#29#           =>  --  2B29
          (0, 0, 11254, 11254),
         16#2A#           =>  --  2B2A
          (0, 0, 11255, 11255),
         16#2B#           =>  --  2B2B
          (0, 0, 11256, 11256),
         16#2C#           =>  --  2B2C
          (0, 0, 11257, 11257),
         16#2D#           =>  --  2B2D
          (0, 0, 11258, 11258),
         16#2E#           =>  --  2B2E
          (0, 0, 11259, 11259),
         16#2F#           =>  --  2B2F
          (0, 0, 11260, 11260),
         16#30#           =>  --  2B30
          (0, 0, 11261, 11261),
         16#31#           =>  --  2B31
          (0, 0, 11262, 11262),
         16#32#           =>  --  2B32
          (0, 0, 11263, 11263),
         16#33#           =>  --  2B33
          (0, 0, 11264, 11264),
         16#34#           =>  --  2B34
          (0, 0, 11265, 11265),
         16#35#           =>  --  2B35
          (0, 0, 11266, 11266),
         16#36#           =>  --  2B36
          (0, 0, 11267, 11267),
         16#37#           =>  --  2B37
          (0, 0, 11268, 11268),
         16#38#           =>  --  2B38
          (0, 0, 11269, 11269),
         16#39#           =>  --  2B39
          (0, 0, 11270, 11270),
         16#3A#           =>  --  2B3A
          (0, 0, 11271, 11271),
         16#3B#           =>  --  2B3B
          (0, 0, 11272, 11272),
         16#3C#           =>  --  2B3C
          (0, 0, 11273, 11273),
         16#3D#           =>  --  2B3D
          (0, 0, 11274, 11274),
         16#3E#           =>  --  2B3E
          (0, 0, 11275, 11275),
         16#3F#           =>  --  2B3F
          (0, 0, 11276, 11276),
         16#40#           =>  --  2B40
          (0, 0, 11277, 11277),
         16#41#           =>  --  2B41
          (0, 0, 11278, 11278),
         16#42#           =>  --  2B42
          (0, 0, 11279, 11279),
         16#43#           =>  --  2B43
          (0, 0, 11280, 11280),
         16#44#           =>  --  2B44
          (0, 0, 11281, 11281),
         16#45#           =>  --  2B45
          (0, 0, 11282, 11282),
         16#46#           =>  --  2B46
          (0, 0, 11283, 11283),
         16#47#           =>  --  2B47
          (0, 0, 11284, 11284),
         16#48#           =>  --  2B48
          (0, 0, 11285, 11285),
         16#49#           =>  --  2B49
          (0, 0, 11286, 11286),
         16#4A#           =>  --  2B4A
          (0, 0, 11287, 11287),
         16#4B#           =>  --  2B4B
          (0, 0, 11288, 11288),
         16#4C#           =>  --  2B4C
          (0, 0, 11289, 11289),
         16#4D#           =>  --  2B4D
          (0, 0, 11290, 11290),
         16#4E#           =>  --  2B4E
          (0, 0, 11291, 11291),
         16#4F#           =>  --  2B4F
          (0, 0, 11292, 11292),
         16#50#           =>  --  2B50
          (0, 0, 11293, 11293),
         16#51#           =>  --  2B51
          (0, 0, 11294, 11294),
         16#52#           =>  --  2B52
          (0, 0, 11295, 11295),
         16#53#           =>  --  2B53
          (0, 0, 11296, 11296),
         16#54#           =>  --  2B54
          (0, 0, 11297, 11297),
         16#55#           =>  --  2B55
          (0, 0, 11298, 11298),
         16#56#           =>  --  2B56
          (0, 0, 11299, 11299),
         16#57#           =>  --  2B57
          (0, 0, 11300, 11300),
         16#58#           =>  --  2B58
          (0, 0, 11301, 11301),
         16#59#           =>  --  2B59
          (0, 0, 11302, 11302),
         16#5A#           =>  --  2B5A
          (0, 0, 11303, 11303),
         16#5B#           =>  --  2B5B
          (0, 0, 11304, 11304),
         16#5C#           =>  --  2B5C
          (0, 0, 11305, 11305),
         16#5D#           =>  --  2B5D
          (0, 0, 11306, 11306),
         16#5E#           =>  --  2B5E
          (0, 0, 11307, 11307),
         16#5F#           =>  --  2B5F
          (0, 0, 11308, 11308),
         16#60#           =>  --  2B60
          (0, 0, 11309, 11309),
         16#61#           =>  --  2B61
          (0, 0, 11310, 11310),
         16#62#           =>  --  2B62
          (0, 0, 11311, 11311),
         16#63#           =>  --  2B63
          (0, 0, 11312, 11312),
         16#64#           =>  --  2B64
          (0, 0, 11313, 11313),
         16#65#           =>  --  2B65
          (0, 0, 11314, 11314),
         16#66#           =>  --  2B66
          (0, 0, 11315, 11315),
         16#67#           =>  --  2B67
          (0, 0, 11316, 11316),
         16#68#           =>  --  2B68
          (0, 0, 11317, 11317),
         16#69#           =>  --  2B69
          (0, 0, 11318, 11318),
         16#6A#           =>  --  2B6A
          (0, 0, 11319, 11319),
         16#6B#           =>  --  2B6B
          (0, 0, 11320, 11320),
         16#6C#           =>  --  2B6C
          (0, 0, 11321, 11321),
         16#6D#           =>  --  2B6D
          (0, 0, 11322, 11322),
         16#6E#           =>  --  2B6E
          (0, 0, 11323, 11323),
         16#6F#           =>  --  2B6F
          (0, 0, 11324, 11324),
         16#70#           =>  --  2B70
          (0, 0, 11325, 11325),
         16#71#           =>  --  2B71
          (0, 0, 11326, 11326),
         16#72#           =>  --  2B72
          (0, 0, 11327, 11327),
         16#73#           =>  --  2B73
          (0, 0, 11328, 11328),
         16#76#           =>  --  2B76
          (0, 0, 11329, 11329),
         16#77#           =>  --  2B77
          (0, 0, 11330, 11330),
         16#78#           =>  --  2B78
          (0, 0, 11331, 11331),
         16#79#           =>  --  2B79
          (0, 0, 11332, 11332),
         16#7A#           =>  --  2B7A
          (0, 0, 11333, 11333),
         16#7B#           =>  --  2B7B
          (0, 0, 11334, 11334),
         16#7C#           =>  --  2B7C
          (0, 0, 11335, 11335),
         16#7D#           =>  --  2B7D
          (0, 0, 11336, 11336),
         16#7E#           =>  --  2B7E
          (0, 0, 11337, 11337),
         16#7F#           =>  --  2B7F
          (0, 0, 11338, 11338),
         16#80#           =>  --  2B80
          (0, 0, 11339, 11339),
         16#81#           =>  --  2B81
          (0, 0, 11340, 11340),
         16#82#           =>  --  2B82
          (0, 0, 11341, 11341),
         16#83#           =>  --  2B83
          (0, 0, 11342, 11342),
         16#84#           =>  --  2B84
          (0, 0, 11343, 11343),
         16#85#           =>  --  2B85
          (0, 0, 11344, 11344),
         16#86#           =>  --  2B86
          (0, 0, 11345, 11345),
         16#87#           =>  --  2B87
          (0, 0, 11346, 11346),
         16#88#           =>  --  2B88
          (0, 0, 11347, 11347),
         16#89#           =>  --  2B89
          (0, 0, 11348, 11348),
         16#8A#           =>  --  2B8A
          (0, 0, 11349, 11349),
         16#8B#           =>  --  2B8B
          (0, 0, 11350, 11350),
         16#8C#           =>  --  2B8C
          (0, 0, 11351, 11351),
         16#8D#           =>  --  2B8D
          (0, 0, 11352, 11352),
         16#8E#           =>  --  2B8E
          (0, 0, 11353, 11353),
         16#8F#           =>  --  2B8F
          (0, 0, 11354, 11354),
         16#90#           =>  --  2B90
          (0, 0, 11355, 11355),
         16#91#           =>  --  2B91
          (0, 0, 11356, 11356),
         16#92#           =>  --  2B92
          (0, 0, 11357, 11357),
         16#93#           =>  --  2B93
          (0, 0, 11358, 11358),
         16#94#           =>  --  2B94
          (0, 0, 11359, 11359),
         16#95#           =>  --  2B95
          (0, 0, 11360, 11360),
         16#98#           =>  --  2B98
          (0, 0, 11361, 11361),
         16#99#           =>  --  2B99
          (0, 0, 11362, 11362),
         16#9A#           =>  --  2B9A
          (0, 0, 11363, 11363),
         16#9B#           =>  --  2B9B
          (0, 0, 11364, 11364),
         16#9C#           =>  --  2B9C
          (0, 0, 11365, 11365),
         16#9D#           =>  --  2B9D
          (0, 0, 11366, 11366),
         16#9E#           =>  --  2B9E
          (0, 0, 11367, 11367),
         16#9F#           =>  --  2B9F
          (0, 0, 11368, 11368),
         16#A0#           =>  --  2BA0
          (0, 0, 11369, 11369),
         16#A1#           =>  --  2BA1
          (0, 0, 11370, 11370),
         16#A2#           =>  --  2BA2
          (0, 0, 11371, 11371),
         16#A3#           =>  --  2BA3
          (0, 0, 11372, 11372),
         16#A4#           =>  --  2BA4
          (0, 0, 11373, 11373),
         16#A5#           =>  --  2BA5
          (0, 0, 11374, 11374),
         16#A6#           =>  --  2BA6
          (0, 0, 11375, 11375),
         16#A7#           =>  --  2BA7
          (0, 0, 11376, 11376),
         16#A8#           =>  --  2BA8
          (0, 0, 11377, 11377),
         16#A9#           =>  --  2BA9
          (0, 0, 11378, 11378),
         16#AA#           =>  --  2BAA
          (0, 0, 11379, 11379),
         16#AB#           =>  --  2BAB
          (0, 0, 11380, 11380),
         16#AC#           =>  --  2BAC
          (0, 0, 11381, 11381),
         16#AD#           =>  --  2BAD
          (0, 0, 11382, 11382),
         16#AE#           =>  --  2BAE
          (0, 0, 11383, 11383),
         16#AF#           =>  --  2BAF
          (0, 0, 11384, 11384),
         16#B0#           =>  --  2BB0
          (0, 0, 11385, 11385),
         16#B1#           =>  --  2BB1
          (0, 0, 11386, 11386),
         16#B2#           =>  --  2BB2
          (0, 0, 11387, 11387),
         16#B3#           =>  --  2BB3
          (0, 0, 11388, 11388),
         16#B4#           =>  --  2BB4
          (0, 0, 11389, 11389),
         16#B5#           =>  --  2BB5
          (0, 0, 11390, 11390),
         16#B6#           =>  --  2BB6
          (0, 0, 11391, 11391),
         16#B7#           =>  --  2BB7
          (0, 0, 11392, 11392),
         16#B8#           =>  --  2BB8
          (0, 0, 11393, 11393),
         16#B9#           =>  --  2BB9
          (0, 0, 11394, 11394),
         16#BD#           =>  --  2BBD
          (0, 0, 11395, 11395),
         16#BE#           =>  --  2BBE
          (0, 0, 11396, 11396),
         16#BF#           =>  --  2BBF
          (0, 0, 11397, 11397),
         16#C0#           =>  --  2BC0
          (0, 0, 11398, 11398),
         16#C1#           =>  --  2BC1
          (0, 0, 11399, 11399),
         16#C2#           =>  --  2BC2
          (0, 0, 11400, 11400),
         16#C3#           =>  --  2BC3
          (0, 0, 11401, 11401),
         16#C4#           =>  --  2BC4
          (0, 0, 11402, 11402),
         16#C5#           =>  --  2BC5
          (0, 0, 11403, 11403),
         16#C6#           =>  --  2BC6
          (0, 0, 11404, 11404),
         16#C7#           =>  --  2BC7
          (0, 0, 11405, 11405),
         16#C8#           =>  --  2BC8
          (0, 0, 11406, 11406),
         16#CA#           =>  --  2BCA
          (0, 0, 11407, 11407),
         16#CB#           =>  --  2BCB
          (0, 0, 11408, 11408),
         16#CC#           =>  --  2BCC
          (0, 0, 11409, 11409),
         16#CD#           =>  --  2BCD
          (0, 0, 11410, 11410),
         16#CE#           =>  --  2BCE
          (0, 0, 11411, 11411),
         16#CF#           =>  --  2BCF
          (0, 0, 11412, 11412),
         16#D0#           =>  --  2BD0
          (0, 0, 11413, 11413),
         16#D1#           =>  --  2BD1
          (0, 0, 11414, 11414),
         others           =>
          (0, 0, 0, 0));

   Group_002C : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  2C00
          (0, 0, 11415, 11415),
         16#01#           =>  --  2C01
          (0, 0, 11416, 11416),
         16#02#           =>  --  2C02
          (0, 0, 11417, 11417),
         16#03#           =>  --  2C03
          (0, 0, 11418, 11418),
         16#04#           =>  --  2C04
          (0, 0, 11419, 11419),
         16#05#           =>  --  2C05
          (0, 0, 11420, 11420),
         16#06#           =>  --  2C06
          (0, 0, 11421, 11421),
         16#07#           =>  --  2C07
          (0, 0, 11422, 11422),
         16#08#           =>  --  2C08
          (0, 0, 11423, 11423),
         16#09#           =>  --  2C09
          (0, 0, 11424, 11424),
         16#0A#           =>  --  2C0A
          (0, 0, 11425, 11425),
         16#0B#           =>  --  2C0B
          (0, 0, 11426, 11426),
         16#0C#           =>  --  2C0C
          (0, 0, 11427, 11427),
         16#0D#           =>  --  2C0D
          (0, 0, 11428, 11428),
         16#0E#           =>  --  2C0E
          (0, 0, 11429, 11429),
         16#0F#           =>  --  2C0F
          (0, 0, 11430, 11430),
         16#10#           =>  --  2C10
          (0, 0, 11431, 11431),
         16#11#           =>  --  2C11
          (0, 0, 11432, 11432),
         16#12#           =>  --  2C12
          (0, 0, 11433, 11433),
         16#13#           =>  --  2C13
          (0, 0, 11434, 11434),
         16#14#           =>  --  2C14
          (0, 0, 11435, 11435),
         16#15#           =>  --  2C15
          (0, 0, 11436, 11436),
         16#16#           =>  --  2C16
          (0, 0, 11437, 11437),
         16#17#           =>  --  2C17
          (0, 0, 11438, 11438),
         16#18#           =>  --  2C18
          (0, 0, 11439, 11439),
         16#19#           =>  --  2C19
          (0, 0, 11440, 11440),
         16#1A#           =>  --  2C1A
          (0, 0, 11441, 11441),
         16#1B#           =>  --  2C1B
          (0, 0, 11442, 11442),
         16#1C#           =>  --  2C1C
          (0, 0, 11443, 11443),
         16#1D#           =>  --  2C1D
          (0, 0, 11444, 11444),
         16#1E#           =>  --  2C1E
          (0, 0, 11445, 11445),
         16#1F#           =>  --  2C1F
          (0, 0, 11446, 11446),
         16#20#           =>  --  2C20
          (0, 0, 11447, 11447),
         16#21#           =>  --  2C21
          (0, 0, 11448, 11448),
         16#22#           =>  --  2C22
          (0, 0, 11449, 11449),
         16#23#           =>  --  2C23
          (0, 0, 11450, 11450),
         16#24#           =>  --  2C24
          (0, 0, 11451, 11451),
         16#25#           =>  --  2C25
          (0, 0, 11452, 11452),
         16#26#           =>  --  2C26
          (0, 0, 11453, 11453),
         16#27#           =>  --  2C27
          (0, 0, 11454, 11454),
         16#28#           =>  --  2C28
          (0, 0, 11455, 11455),
         16#29#           =>  --  2C29
          (0, 0, 11456, 11456),
         16#2A#           =>  --  2C2A
          (0, 0, 11457, 11457),
         16#2B#           =>  --  2C2B
          (0, 0, 11458, 11458),
         16#2C#           =>  --  2C2C
          (0, 0, 11459, 11459),
         16#2D#           =>  --  2C2D
          (0, 0, 11460, 11460),
         16#2E#           =>  --  2C2E
          (0, 0, 11461, 11461),
         16#30#           =>  --  2C30
          (0, 0, 11462, 11462),
         16#31#           =>  --  2C31
          (0, 0, 11463, 11463),
         16#32#           =>  --  2C32
          (0, 0, 11464, 11464),
         16#33#           =>  --  2C33
          (0, 0, 11465, 11465),
         16#34#           =>  --  2C34
          (0, 0, 11466, 11466),
         16#35#           =>  --  2C35
          (0, 0, 11467, 11467),
         16#36#           =>  --  2C36
          (0, 0, 11468, 11468),
         16#37#           =>  --  2C37
          (0, 0, 11469, 11469),
         16#38#           =>  --  2C38
          (0, 0, 11470, 11470),
         16#39#           =>  --  2C39
          (0, 0, 11471, 11471),
         16#3A#           =>  --  2C3A
          (0, 0, 11472, 11472),
         16#3B#           =>  --  2C3B
          (0, 0, 11473, 11473),
         16#3C#           =>  --  2C3C
          (0, 0, 11474, 11474),
         16#3D#           =>  --  2C3D
          (0, 0, 11475, 11475),
         16#3E#           =>  --  2C3E
          (0, 0, 11476, 11476),
         16#3F#           =>  --  2C3F
          (0, 0, 11477, 11477),
         16#40#           =>  --  2C40
          (0, 0, 11478, 11478),
         16#41#           =>  --  2C41
          (0, 0, 11479, 11479),
         16#42#           =>  --  2C42
          (0, 0, 11480, 11480),
         16#43#           =>  --  2C43
          (0, 0, 11481, 11481),
         16#44#           =>  --  2C44
          (0, 0, 11482, 11482),
         16#45#           =>  --  2C45
          (0, 0, 11483, 11483),
         16#46#           =>  --  2C46
          (0, 0, 11484, 11484),
         16#47#           =>  --  2C47
          (0, 0, 11485, 11485),
         16#48#           =>  --  2C48
          (0, 0, 11486, 11486),
         16#49#           =>  --  2C49
          (0, 0, 11487, 11487),
         16#4A#           =>  --  2C4A
          (0, 0, 11488, 11488),
         16#4B#           =>  --  2C4B
          (0, 0, 11489, 11489),
         16#4C#           =>  --  2C4C
          (0, 0, 11490, 11490),
         16#4D#           =>  --  2C4D
          (0, 0, 11491, 11491),
         16#4E#           =>  --  2C4E
          (0, 0, 11492, 11492),
         16#4F#           =>  --  2C4F
          (0, 0, 11493, 11493),
         16#50#           =>  --  2C50
          (0, 0, 11494, 11494),
         16#51#           =>  --  2C51
          (0, 0, 11495, 11495),
         16#52#           =>  --  2C52
          (0, 0, 11496, 11496),
         16#53#           =>  --  2C53
          (0, 0, 11497, 11497),
         16#54#           =>  --  2C54
          (0, 0, 11498, 11498),
         16#55#           =>  --  2C55
          (0, 0, 11499, 11499),
         16#56#           =>  --  2C56
          (0, 0, 11500, 11500),
         16#57#           =>  --  2C57
          (0, 0, 11501, 11501),
         16#58#           =>  --  2C58
          (0, 0, 11502, 11502),
         16#59#           =>  --  2C59
          (0, 0, 11503, 11503),
         16#5A#           =>  --  2C5A
          (0, 0, 11504, 11504),
         16#5B#           =>  --  2C5B
          (0, 0, 11505, 11505),
         16#5C#           =>  --  2C5C
          (0, 0, 11506, 11506),
         16#5D#           =>  --  2C5D
          (0, 0, 11507, 11507),
         16#5E#           =>  --  2C5E
          (0, 0, 11508, 11508),
         16#60#           =>  --  2C60
          (0, 0, 11509, 11509),
         16#61#           =>  --  2C61
          (0, 0, 11510, 11510),
         16#62#           =>  --  2C62
          (0, 0, 11511, 11511),
         16#63#           =>  --  2C63
          (0, 0, 11512, 11512),
         16#64#           =>  --  2C64
          (0, 0, 11513, 11513),
         16#65#           =>  --  2C65
          (0, 0, 11514, 11514),
         16#66#           =>  --  2C66
          (0, 0, 11515, 11515),
         16#67#           =>  --  2C67
          (0, 0, 11516, 11516),
         16#68#           =>  --  2C68
          (0, 0, 11517, 11517),
         16#69#           =>  --  2C69
          (0, 0, 11518, 11518),
         16#6A#           =>  --  2C6A
          (0, 0, 11519, 11519),
         16#6B#           =>  --  2C6B
          (0, 0, 11520, 11520),
         16#6C#           =>  --  2C6C
          (0, 0, 11521, 11521),
         16#6D#           =>  --  2C6D
          (0, 0, 11522, 11522),
         16#6E#           =>  --  2C6E
          (0, 0, 11523, 11523),
         16#6F#           =>  --  2C6F
          (0, 0, 11524, 11524),
         16#70#           =>  --  2C70
          (0, 0, 11525, 11525),
         16#71#           =>  --  2C71
          (0, 0, 11526, 11526),
         16#72#           =>  --  2C72
          (0, 0, 11527, 11527),
         16#73#           =>  --  2C73
          (0, 0, 11528, 11528),
         16#74#           =>  --  2C74
          (0, 0, 11529, 11529),
         16#75#           =>  --  2C75
          (0, 0, 11530, 11530),
         16#76#           =>  --  2C76
          (0, 0, 11531, 11531),
         16#77#           =>  --  2C77
          (0, 0, 11532, 11532),
         16#78#           =>  --  2C78
          (0, 0, 11533, 11533),
         16#79#           =>  --  2C79
          (0, 0, 11534, 11534),
         16#7A#           =>  --  2C7A
          (0, 0, 11535, 11535),
         16#7B#           =>  --  2C7B
          (0, 0, 11536, 11536),
         16#7C#           =>  --  2C7C
          (0, 0, 11537, 11537),
         16#7D#           =>  --  2C7D
          (0, 0, 11538, 11538),
         16#7E#           =>  --  2C7E
          (0, 0, 11539, 11539),
         16#7F#           =>  --  2C7F
          (0, 0, 11540, 11540),
         16#80#           =>  --  2C80
          (0, 0, 11541, 11541),
         16#81#           =>  --  2C81
          (0, 0, 11542, 11542),
         16#82#           =>  --  2C82
          (0, 0, 11543, 11543),
         16#83#           =>  --  2C83
          (0, 0, 11544, 11544),
         16#84#           =>  --  2C84
          (0, 0, 11545, 11545),
         16#85#           =>  --  2C85
          (0, 0, 11546, 11546),
         16#86#           =>  --  2C86
          (0, 0, 11547, 11547),
         16#87#           =>  --  2C87
          (0, 0, 11548, 11548),
         16#88#           =>  --  2C88
          (0, 0, 11549, 11549),
         16#89#           =>  --  2C89
          (0, 0, 11550, 11550),
         16#8A#           =>  --  2C8A
          (0, 0, 11551, 11551),
         16#8B#           =>  --  2C8B
          (0, 0, 11552, 11552),
         16#8C#           =>  --  2C8C
          (0, 0, 11553, 11553),
         16#8D#           =>  --  2C8D
          (0, 0, 11554, 11554),
         16#8E#           =>  --  2C8E
          (0, 0, 11555, 11555),
         16#8F#           =>  --  2C8F
          (0, 0, 11556, 11556),
         16#90#           =>  --  2C90
          (0, 0, 11557, 11557),
         16#91#           =>  --  2C91
          (0, 0, 11558, 11558),
         16#92#           =>  --  2C92
          (0, 0, 11559, 11559),
         16#93#           =>  --  2C93
          (0, 0, 11560, 11560),
         16#94#           =>  --  2C94
          (0, 0, 11561, 11561),
         16#95#           =>  --  2C95
          (0, 0, 11562, 11562),
         16#96#           =>  --  2C96
          (0, 0, 11563, 11563),
         16#97#           =>  --  2C97
          (0, 0, 11564, 11564),
         16#98#           =>  --  2C98
          (0, 0, 11565, 11565),
         16#99#           =>  --  2C99
          (0, 0, 11566, 11566),
         16#9A#           =>  --  2C9A
          (0, 0, 11567, 11567),
         16#9B#           =>  --  2C9B
          (0, 0, 11568, 11568),
         16#9C#           =>  --  2C9C
          (0, 0, 11569, 11569),
         16#9D#           =>  --  2C9D
          (0, 0, 11570, 11570),
         16#9E#           =>  --  2C9E
          (0, 0, 11571, 11571),
         16#9F#           =>  --  2C9F
          (0, 0, 11572, 11572),
         16#A0#           =>  --  2CA0
          (0, 0, 11573, 11573),
         16#A1#           =>  --  2CA1
          (0, 0, 11574, 11574),
         16#A2#           =>  --  2CA2
          (0, 0, 11575, 11575),
         16#A3#           =>  --  2CA3
          (0, 0, 11576, 11576),
         16#A4#           =>  --  2CA4
          (0, 0, 11577, 11577),
         16#A5#           =>  --  2CA5
          (0, 0, 11578, 11578),
         16#A6#           =>  --  2CA6
          (0, 0, 11579, 11579),
         16#A7#           =>  --  2CA7
          (0, 0, 11580, 11580),
         16#A8#           =>  --  2CA8
          (0, 0, 11581, 11581),
         16#A9#           =>  --  2CA9
          (0, 0, 11582, 11582),
         16#AA#           =>  --  2CAA
          (0, 0, 11583, 11583),
         16#AB#           =>  --  2CAB
          (0, 0, 11584, 11584),
         16#AC#           =>  --  2CAC
          (0, 0, 11585, 11585),
         16#AD#           =>  --  2CAD
          (0, 0, 11586, 11586),
         16#AE#           =>  --  2CAE
          (0, 0, 11587, 11587),
         16#AF#           =>  --  2CAF
          (0, 0, 11588, 11588),
         16#B0#           =>  --  2CB0
          (0, 0, 11589, 11589),
         16#B1#           =>  --  2CB1
          (0, 0, 11590, 11590),
         16#B2#           =>  --  2CB2
          (0, 0, 11591, 11591),
         16#B3#           =>  --  2CB3
          (0, 0, 11592, 11592),
         16#B4#           =>  --  2CB4
          (0, 0, 11593, 11593),
         16#B5#           =>  --  2CB5
          (0, 0, 11594, 11594),
         16#B6#           =>  --  2CB6
          (0, 0, 11595, 11595),
         16#B7#           =>  --  2CB7
          (0, 0, 11596, 11596),
         16#B8#           =>  --  2CB8
          (0, 0, 11597, 11597),
         16#B9#           =>  --  2CB9
          (0, 0, 11598, 11598),
         16#BA#           =>  --  2CBA
          (0, 0, 11599, 11599),
         16#BB#           =>  --  2CBB
          (0, 0, 11600, 11600),
         16#BC#           =>  --  2CBC
          (0, 0, 11601, 11601),
         16#BD#           =>  --  2CBD
          (0, 0, 11602, 11602),
         16#BE#           =>  --  2CBE
          (0, 0, 11603, 11603),
         16#BF#           =>  --  2CBF
          (0, 0, 11604, 11604),
         16#C0#           =>  --  2CC0
          (0, 0, 11605, 11605),
         16#C1#           =>  --  2CC1
          (0, 0, 11606, 11606),
         16#C2#           =>  --  2CC2
          (0, 0, 11607, 11607),
         16#C3#           =>  --  2CC3
          (0, 0, 11608, 11608),
         16#C4#           =>  --  2CC4
          (0, 0, 11609, 11609),
         16#C5#           =>  --  2CC5
          (0, 0, 11610, 11610),
         16#C6#           =>  --  2CC6
          (0, 0, 11611, 11611),
         16#C7#           =>  --  2CC7
          (0, 0, 11612, 11612),
         16#C8#           =>  --  2CC8
          (0, 0, 11613, 11613),
         16#C9#           =>  --  2CC9
          (0, 0, 11614, 11614),
         16#CA#           =>  --  2CCA
          (0, 0, 11615, 11615),
         16#CB#           =>  --  2CCB
          (0, 0, 11616, 11616),
         16#CC#           =>  --  2CCC
          (0, 0, 11617, 11617),
         16#CD#           =>  --  2CCD
          (0, 0, 11618, 11618),
         16#CE#           =>  --  2CCE
          (0, 0, 11619, 11619),
         16#CF#           =>  --  2CCF
          (0, 0, 11620, 11620),
         16#D0#           =>  --  2CD0
          (0, 0, 11621, 11621),
         16#D1#           =>  --  2CD1
          (0, 0, 11622, 11622),
         16#D2#           =>  --  2CD2
          (0, 0, 11623, 11623),
         16#D3#           =>  --  2CD3
          (0, 0, 11624, 11624),
         16#D4#           =>  --  2CD4
          (0, 0, 11625, 11625),
         16#D5#           =>  --  2CD5
          (0, 0, 11626, 11626),
         16#D6#           =>  --  2CD6
          (0, 0, 11627, 11627),
         16#D7#           =>  --  2CD7
          (0, 0, 11628, 11628),
         16#D8#           =>  --  2CD8
          (0, 0, 11629, 11629),
         16#D9#           =>  --  2CD9
          (0, 0, 11630, 11630),
         16#DA#           =>  --  2CDA
          (0, 0, 11631, 11631),
         16#DB#           =>  --  2CDB
          (0, 0, 11632, 11632),
         16#DC#           =>  --  2CDC
          (0, 0, 11633, 11633),
         16#DD#           =>  --  2CDD
          (0, 0, 11634, 11634),
         16#DE#           =>  --  2CDE
          (0, 0, 11635, 11635),
         16#DF#           =>  --  2CDF
          (0, 0, 11636, 11636),
         16#E0#           =>  --  2CE0
          (0, 0, 11637, 11637),
         16#E1#           =>  --  2CE1
          (0, 0, 11638, 11638),
         16#E2#           =>  --  2CE2
          (0, 0, 11639, 11639),
         16#E3#           =>  --  2CE3
          (0, 0, 11640, 11640),
         16#E4#           =>  --  2CE4
          (0, 0, 11641, 11643),
         16#E5#           =>  --  2CE5
          (0, 0, 11644, 11644),
         16#E6#           =>  --  2CE6
          (0, 0, 11645, 11645),
         16#E7#           =>  --  2CE7
          (0, 0, 11646, 11646),
         16#E8#           =>  --  2CE8
          (0, 0, 11647, 11647),
         16#E9#           =>  --  2CE9
          (0, 0, 11648, 11648),
         16#EA#           =>  --  2CEA
          (0, 0, 11649, 11649),
         16#EB#           =>  --  2CEB
          (0, 0, 11650, 11650),
         16#EC#           =>  --  2CEC
          (0, 0, 11651, 11651),
         16#ED#           =>  --  2CED
          (0, 0, 11652, 11652),
         16#EE#           =>  --  2CEE
          (0, 0, 11653, 11653),
         16#EF#           =>  --  2CEF
          (0, 0, 1041, 1041),
         16#F0#           =>  --  2CF0
          (0, 0, 1044, 1044),
         16#F1#           =>  --  2CF1
          (0, 0, 1043, 1043),
         16#F2#           =>  --  2CF2
          (0, 0, 11654, 11654),
         16#F3#           =>  --  2CF3
          (0, 0, 11655, 11655),
         16#F9#           =>  --  2CF9
          (0, 0, 11656, 11656),
         16#FA#           =>  --  2CFA
          (0, 0, 11657, 11657),
         16#FB#           =>  --  2CFB
          (0, 0, 11658, 11658),
         16#FC#           =>  --  2CFC
          (0, 0, 11659, 11659),
         16#FD#           =>  --  2CFD
          (0, 0, 11660, 11660),
         16#FE#           =>  --  2CFE
          (0, 0, 11661, 11661),
         16#FF#           =>  --  2CFF
          (0, 0, 11662, 11662),
         others           =>
          (0, 0, 0, 0));

   Group_002D : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  2D00
          (0, 0, 11663, 11663),
         16#01#           =>  --  2D01
          (0, 0, 11664, 11664),
         16#02#           =>  --  2D02
          (0, 0, 11665, 11665),
         16#03#           =>  --  2D03
          (0, 0, 11666, 11666),
         16#04#           =>  --  2D04
          (0, 0, 11667, 11667),
         16#05#           =>  --  2D05
          (0, 0, 11668, 11668),
         16#06#           =>  --  2D06
          (0, 0, 11669, 11669),
         16#07#           =>  --  2D07
          (0, 0, 11670, 11670),
         16#08#           =>  --  2D08
          (0, 0, 11671, 11671),
         16#09#           =>  --  2D09
          (0, 0, 11672, 11672),
         16#0A#           =>  --  2D0A
          (0, 0, 11673, 11673),
         16#0B#           =>  --  2D0B
          (0, 0, 11674, 11674),
         16#0C#           =>  --  2D0C
          (0, 0, 11675, 11675),
         16#0D#           =>  --  2D0D
          (0, 0, 11676, 11676),
         16#0E#           =>  --  2D0E
          (0, 0, 11677, 11677),
         16#0F#           =>  --  2D0F
          (0, 0, 11678, 11678),
         16#10#           =>  --  2D10
          (0, 0, 11679, 11679),
         16#11#           =>  --  2D11
          (0, 0, 11680, 11680),
         16#12#           =>  --  2D12
          (0, 0, 11681, 11681),
         16#13#           =>  --  2D13
          (0, 0, 11682, 11682),
         16#14#           =>  --  2D14
          (0, 0, 11683, 11683),
         16#15#           =>  --  2D15
          (0, 0, 11684, 11684),
         16#16#           =>  --  2D16
          (0, 0, 11685, 11685),
         16#17#           =>  --  2D17
          (0, 0, 11686, 11686),
         16#18#           =>  --  2D18
          (0, 0, 11687, 11687),
         16#19#           =>  --  2D19
          (0, 0, 11688, 11688),
         16#1A#           =>  --  2D1A
          (0, 0, 11689, 11689),
         16#1B#           =>  --  2D1B
          (0, 0, 11690, 11690),
         16#1C#           =>  --  2D1C
          (0, 0, 11691, 11691),
         16#1D#           =>  --  2D1D
          (0, 0, 11692, 11692),
         16#1E#           =>  --  2D1E
          (0, 0, 11693, 11693),
         16#1F#           =>  --  2D1F
          (0, 0, 11694, 11694),
         16#20#           =>  --  2D20
          (0, 0, 11695, 11695),
         16#21#           =>  --  2D21
          (0, 0, 11696, 11696),
         16#22#           =>  --  2D22
          (0, 0, 11697, 11697),
         16#23#           =>  --  2D23
          (0, 0, 11698, 11698),
         16#24#           =>  --  2D24
          (0, 0, 11699, 11699),
         16#25#           =>  --  2D25
          (0, 0, 11700, 11700),
         16#27#           =>  --  2D27
          (0, 0, 11701, 11701),
         16#2D#           =>  --  2D2D
          (0, 0, 11702, 11702),
         16#30#           =>  --  2D30
          (0, 0, 11703, 11703),
         16#31#           =>  --  2D31
          (0, 0, 11704, 11704),
         16#32#           =>  --  2D32
          (0, 0, 11705, 11705),
         16#33#           =>  --  2D33
          (0, 0, 11706, 11706),
         16#34#           =>  --  2D34
          (0, 0, 11707, 11707),
         16#35#           =>  --  2D35
          (0, 0, 11708, 11708),
         16#36#           =>  --  2D36
          (0, 0, 11709, 11709),
         16#37#           =>  --  2D37
          (0, 0, 11710, 11710),
         16#38#           =>  --  2D38
          (0, 0, 11711, 11711),
         16#39#           =>  --  2D39
          (0, 0, 11712, 11712),
         16#3A#           =>  --  2D3A
          (0, 0, 11713, 11713),
         16#3B#           =>  --  2D3B
          (0, 0, 11714, 11714),
         16#3C#           =>  --  2D3C
          (0, 0, 11715, 11715),
         16#3D#           =>  --  2D3D
          (0, 0, 11716, 11716),
         16#3E#           =>  --  2D3E
          (0, 0, 11717, 11717),
         16#3F#           =>  --  2D3F
          (0, 0, 11718, 11718),
         16#40#           =>  --  2D40
          (0, 0, 11719, 11719),
         16#41#           =>  --  2D41
          (0, 0, 11720, 11720),
         16#42#           =>  --  2D42
          (0, 0, 11721, 11721),
         16#43#           =>  --  2D43
          (0, 0, 11722, 11722),
         16#44#           =>  --  2D44
          (0, 0, 11723, 11723),
         16#45#           =>  --  2D45
          (0, 0, 11724, 11724),
         16#46#           =>  --  2D46
          (0, 0, 11725, 11725),
         16#47#           =>  --  2D47
          (0, 0, 11726, 11726),
         16#48#           =>  --  2D48
          (0, 0, 11727, 11727),
         16#49#           =>  --  2D49
          (0, 0, 11728, 11728),
         16#4A#           =>  --  2D4A
          (0, 0, 11729, 11729),
         16#4B#           =>  --  2D4B
          (0, 0, 11730, 11730),
         16#4C#           =>  --  2D4C
          (0, 0, 11731, 11731),
         16#4D#           =>  --  2D4D
          (0, 0, 11732, 11732),
         16#4E#           =>  --  2D4E
          (0, 0, 11733, 11733),
         16#4F#           =>  --  2D4F
          (0, 0, 11734, 11734),
         16#50#           =>  --  2D50
          (0, 0, 11735, 11735),
         16#51#           =>  --  2D51
          (0, 0, 11736, 11736),
         16#52#           =>  --  2D52
          (0, 0, 11737, 11737),
         16#53#           =>  --  2D53
          (0, 0, 11738, 11738),
         16#54#           =>  --  2D54
          (0, 0, 11739, 11739),
         16#55#           =>  --  2D55
          (0, 0, 11740, 11740),
         16#56#           =>  --  2D56
          (0, 0, 11741, 11741),
         16#57#           =>  --  2D57
          (0, 0, 11742, 11742),
         16#58#           =>  --  2D58
          (0, 0, 11743, 11743),
         16#59#           =>  --  2D59
          (0, 0, 11744, 11744),
         16#5A#           =>  --  2D5A
          (0, 0, 11745, 11745),
         16#5B#           =>  --  2D5B
          (0, 0, 11746, 11746),
         16#5C#           =>  --  2D5C
          (0, 0, 11747, 11747),
         16#5D#           =>  --  2D5D
          (0, 0, 11748, 11748),
         16#5E#           =>  --  2D5E
          (0, 0, 11749, 11749),
         16#5F#           =>  --  2D5F
          (0, 0, 11750, 11750),
         16#60#           =>  --  2D60
          (0, 0, 11751, 11751),
         16#61#           =>  --  2D61
          (0, 0, 11752, 11752),
         16#62#           =>  --  2D62
          (0, 0, 11753, 11753),
         16#63#           =>  --  2D63
          (0, 0, 11754, 11754),
         16#64#           =>  --  2D64
          (0, 0, 11755, 11755),
         16#65#           =>  --  2D65
          (0, 0, 11756, 11756),
         16#66#           =>  --  2D66
          (0, 0, 11757, 11757),
         16#67#           =>  --  2D67
          (0, 0, 11758, 11758),
         16#6F#           =>  --  2D6F
          (0, 0, 11759, 11759),
         16#70#           =>  --  2D70
          (0, 0, 11760, 11760),
         16#7F#           =>  --  2D7F
          (0, 0, 1, 1),
         16#80#           =>  --  2D80
          (0, 0, 11761, 11761),
         16#81#           =>  --  2D81
          (0, 0, 11762, 11762),
         16#82#           =>  --  2D82
          (0, 0, 11763, 11763),
         16#83#           =>  --  2D83
          (0, 0, 11764, 11764),
         16#84#           =>  --  2D84
          (0, 0, 11765, 11765),
         16#85#           =>  --  2D85
          (0, 0, 11766, 11766),
         16#86#           =>  --  2D86
          (0, 0, 11767, 11767),
         16#87#           =>  --  2D87
          (0, 0, 11768, 11768),
         16#88#           =>  --  2D88
          (0, 0, 11769, 11769),
         16#89#           =>  --  2D89
          (0, 0, 11770, 11770),
         16#8A#           =>  --  2D8A
          (0, 0, 11771, 11771),
         16#8B#           =>  --  2D8B
          (0, 0, 11772, 11772),
         16#8C#           =>  --  2D8C
          (0, 0, 11773, 11773),
         16#8D#           =>  --  2D8D
          (0, 0, 11774, 11774),
         16#8E#           =>  --  2D8E
          (0, 0, 11775, 11775),
         16#8F#           =>  --  2D8F
          (0, 0, 11776, 11776),
         16#90#           =>  --  2D90
          (0, 0, 11777, 11777),
         16#91#           =>  --  2D91
          (0, 0, 11778, 11778),
         16#92#           =>  --  2D92
          (0, 0, 11779, 11779),
         16#93#           =>  --  2D93
          (0, 0, 11780, 11780),
         16#94#           =>  --  2D94
          (0, 0, 11781, 11781),
         16#95#           =>  --  2D95
          (0, 0, 11782, 11782),
         16#96#           =>  --  2D96
          (0, 0, 11783, 11783),
         16#A0#           =>  --  2DA0
          (0, 0, 11784, 11784),
         16#A1#           =>  --  2DA1
          (0, 0, 11785, 11785),
         16#A2#           =>  --  2DA2
          (0, 0, 11786, 11786),
         16#A3#           =>  --  2DA3
          (0, 0, 11787, 11787),
         16#A4#           =>  --  2DA4
          (0, 0, 11788, 11788),
         16#A5#           =>  --  2DA5
          (0, 0, 11789, 11789),
         16#A6#           =>  --  2DA6
          (0, 0, 11790, 11790),
         16#A8#           =>  --  2DA8
          (0, 0, 11791, 11791),
         16#A9#           =>  --  2DA9
          (0, 0, 11792, 11792),
         16#AA#           =>  --  2DAA
          (0, 0, 11793, 11793),
         16#AB#           =>  --  2DAB
          (0, 0, 11794, 11794),
         16#AC#           =>  --  2DAC
          (0, 0, 11795, 11795),
         16#AD#           =>  --  2DAD
          (0, 0, 11796, 11796),
         16#AE#           =>  --  2DAE
          (0, 0, 11797, 11797),
         16#B0#           =>  --  2DB0
          (0, 0, 11798, 11798),
         16#B1#           =>  --  2DB1
          (0, 0, 11799, 11799),
         16#B2#           =>  --  2DB2
          (0, 0, 11800, 11800),
         16#B3#           =>  --  2DB3
          (0, 0, 11801, 11801),
         16#B4#           =>  --  2DB4
          (0, 0, 11802, 11802),
         16#B5#           =>  --  2DB5
          (0, 0, 11803, 11803),
         16#B6#           =>  --  2DB6
          (0, 0, 11804, 11804),
         16#B8#           =>  --  2DB8
          (0, 0, 11805, 11805),
         16#B9#           =>  --  2DB9
          (0, 0, 11806, 11806),
         16#BA#           =>  --  2DBA
          (0, 0, 11807, 11807),
         16#BB#           =>  --  2DBB
          (0, 0, 11808, 11808),
         16#BC#           =>  --  2DBC
          (0, 0, 11809, 11809),
         16#BD#           =>  --  2DBD
          (0, 0, 11810, 11810),
         16#BE#           =>  --  2DBE
          (0, 0, 11811, 11811),
         16#C0#           =>  --  2DC0
          (0, 0, 11812, 11812),
         16#C1#           =>  --  2DC1
          (0, 0, 11813, 11813),
         16#C2#           =>  --  2DC2
          (0, 0, 11814, 11814),
         16#C3#           =>  --  2DC3
          (0, 0, 11815, 11815),
         16#C4#           =>  --  2DC4
          (0, 0, 11816, 11816),
         16#C5#           =>  --  2DC5
          (0, 0, 11817, 11817),
         16#C6#           =>  --  2DC6
          (0, 0, 11818, 11818),
         16#C8#           =>  --  2DC8
          (0, 0, 11819, 11819),
         16#C9#           =>  --  2DC9
          (0, 0, 11820, 11820),
         16#CA#           =>  --  2DCA
          (0, 0, 11821, 11821),
         16#CB#           =>  --  2DCB
          (0, 0, 11822, 11822),
         16#CC#           =>  --  2DCC
          (0, 0, 11823, 11823),
         16#CD#           =>  --  2DCD
          (0, 0, 11824, 11824),
         16#CE#           =>  --  2DCE
          (0, 0, 11825, 11825),
         16#D0#           =>  --  2DD0
          (0, 0, 11826, 11826),
         16#D1#           =>  --  2DD1
          (0, 0, 11827, 11827),
         16#D2#           =>  --  2DD2
          (0, 0, 11828, 11828),
         16#D3#           =>  --  2DD3
          (0, 0, 11829, 11829),
         16#D4#           =>  --  2DD4
          (0, 0, 11830, 11830),
         16#D5#           =>  --  2DD5
          (0, 0, 11831, 11831),
         16#D6#           =>  --  2DD6
          (0, 0, 11832, 11832),
         16#D8#           =>  --  2DD8
          (0, 0, 11833, 11833),
         16#D9#           =>  --  2DD9
          (0, 0, 11834, 11834),
         16#DA#           =>  --  2DDA
          (0, 0, 11835, 11835),
         16#DB#           =>  --  2DDB
          (0, 0, 11836, 11836),
         16#DC#           =>  --  2DDC
          (0, 0, 11837, 11837),
         16#DD#           =>  --  2DDD
          (0, 0, 11838, 11838),
         16#DE#           =>  --  2DDE
          (0, 0, 11839, 11839),
         16#E0#           =>  --  2DE0
          (0, 0, 11840, 11840),
         16#E1#           =>  --  2DE1
          (0, 0, 11841, 11841),
         16#E2#           =>  --  2DE2
          (0, 0, 1365, 1365),
         16#E3#           =>  --  2DE3
          (0, 0, 11842, 11842),
         16#E4#           =>  --  2DE4
          (0, 0, 11843, 11843),
         16#E5#           =>  --  2DE5
          (0, 0, 11844, 11844),
         16#E6#           =>  --  2DE6
          (0, 0, 11845, 11845),
         16#E7#           =>  --  2DE7
          (0, 0, 11846, 11846),
         16#E8#           =>  --  2DE8
          (0, 0, 11847, 11847),
         16#E9#           =>  --  2DE9
          (0, 0, 11848, 11848),
         16#EA#           =>  --  2DEA
          (0, 0, 11849, 11849),
         16#EB#           =>  --  2DEB
          (0, 0, 11850, 11850),
         16#EC#           =>  --  2DEC
          (0, 0, 11851, 11851),
         16#ED#           =>  --  2DED
          (0, 0, 11852, 11852),
         16#EE#           =>  --  2DEE
          (0, 0, 11853, 11853),
         16#EF#           =>  --  2DEF
          (0, 0, 11854, 11854),
         16#F0#           =>  --  2DF0
          (0, 0, 11855, 11855),
         16#F1#           =>  --  2DF1
          (0, 0, 11856, 11856),
         16#F2#           =>  --  2DF2
          (0, 0, 11857, 11857),
         16#F3#           =>  --  2DF3
          (0, 0, 11858, 11858),
         16#F4#           =>  --  2DF4
          (0, 0, 11859, 11859),
         16#F5#           =>  --  2DF5
          (0, 0, 11852, 11853),
         16#F6#           =>  --  2DF6
          (0, 0, 11860, 11860),
         16#F7#           =>  --  2DF7
          (0, 0, 11861, 11861),
         16#F8#           =>  --  2DF8
          (0, 0, 11862, 11862),
         16#F9#           =>  --  2DF9
          (0, 0, 11863, 11863),
         16#FA#           =>  --  2DFA
          (0, 0, 11864, 11864),
         16#FB#           =>  --  2DFB
          (0, 0, 11865, 11865),
         16#FC#           =>  --  2DFC
          (0, 0, 11866, 11866),
         16#FD#           =>  --  2DFD
          (0, 0, 11867, 11867),
         16#FE#           =>  --  2DFE
          (0, 0, 11868, 11868),
         16#FF#           =>  --  2DFF
          (0, 0, 11869, 11869),
         others           =>
          (0, 0, 0, 0));

   Group_002E : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  2E00
          (0, 0, 11870, 11870),
         16#01#           =>  --  2E01
          (0, 0, 11871, 11871),
         16#02#           =>  --  2E02
          (0, 0, 11872, 11872),
         16#03#           =>  --  2E03
          (0, 0, 11873, 11873),
         16#04#           =>  --  2E04
          (0, 0, 11874, 11874),
         16#05#           =>  --  2E05
          (0, 0, 11875, 11875),
         16#06#           =>  --  2E06
          (0, 0, 11876, 11876),
         16#07#           =>  --  2E07
          (0, 0, 11877, 11877),
         16#08#           =>  --  2E08
          (0, 0, 11878, 11878),
         16#09#           =>  --  2E09
          (0, 0, 11879, 11879),
         16#0A#           =>  --  2E0A
          (0, 0, 11880, 11880),
         16#0B#           =>  --  2E0B
          (0, 0, 11881, 11881),
         16#0C#           =>  --  2E0C
          (0, 0, 11882, 11882),
         16#0D#           =>  --  2E0D
          (0, 0, 11883, 11883),
         16#0E#           =>  --  2E0E
          (0, 0, 11884, 11884),
         16#0F#           =>  --  2E0F
          (0, 0, 11885, 11885),
         16#10#           =>  --  2E10
          (0, 0, 11886, 11886),
         16#11#           =>  --  2E11
          (0, 0, 11887, 11887),
         16#12#           =>  --  2E12
          (0, 0, 11888, 11888),
         16#13#           =>  --  2E13
          (0, 0, 11889, 11889),
         16#14#           =>  --  2E14
          (0, 0, 11890, 11890),
         16#15#           =>  --  2E15
          (0, 0, 11891, 11891),
         16#16#           =>  --  2E16
          (0, 0, 11892, 11892),
         16#17#           =>  --  2E17
          (0, 0, 11893, 11893),
         16#18#           =>  --  2E18
          (0, 0, 11894, 11894),
         16#19#           =>  --  2E19
          (0, 0, 11895, 11895),
         16#1A#           =>  --  2E1A
          (0, 0, 11896, 11896),
         16#1B#           =>  --  2E1B
          (0, 0, 11897, 11897),
         16#1C#           =>  --  2E1C
          (0, 0, 11898, 11898),
         16#1D#           =>  --  2E1D
          (0, 0, 11899, 11899),
         16#1E#           =>  --  2E1E
          (0, 0, 11900, 11900),
         16#1F#           =>  --  2E1F
          (0, 0, 11901, 11901),
         16#20#           =>  --  2E20
          (0, 0, 11902, 11902),
         16#21#           =>  --  2E21
          (0, 0, 11903, 11903),
         16#22#           =>  --  2E22
          (0, 0, 11904, 11904),
         16#23#           =>  --  2E23
          (0, 0, 11905, 11905),
         16#24#           =>  --  2E24
          (0, 0, 11906, 11906),
         16#25#           =>  --  2E25
          (0, 0, 11907, 11907),
         16#26#           =>  --  2E26
          (0, 0, 11908, 11908),
         16#27#           =>  --  2E27
          (0, 0, 11909, 11909),
         16#28#           =>  --  2E28
          (0, 0, 11910, 11910),
         16#29#           =>  --  2E29
          (0, 0, 11911, 11911),
         16#2A#           =>  --  2E2A
          (0, 0, 11912, 11912),
         16#2B#           =>  --  2E2B
          (0, 0, 11913, 11913),
         16#2C#           =>  --  2E2C
          (0, 0, 11914, 11914),
         16#2D#           =>  --  2E2D
          (0, 0, 11915, 11915),
         16#2E#           =>  --  2E2E
          (0, 0, 11916, 11916),
         16#2F#           =>  --  2E2F
          (0, 0, 11917, 11917),
         16#30#           =>  --  2E30
          (0, 0, 11918, 11918),
         16#31#           =>  --  2E31
          (0, 0, 11919, 11919),
         16#32#           =>  --  2E32
          (0, 0, 11920, 11920),
         16#33#           =>  --  2E33
          (0, 0, 11921, 11921),
         16#34#           =>  --  2E34
          (0, 0, 11922, 11922),
         16#35#           =>  --  2E35
          (0, 0, 11923, 11923),
         16#36#           =>  --  2E36
          (0, 0, 11924, 11924),
         16#37#           =>  --  2E37
          (0, 0, 11925, 11925),
         16#38#           =>  --  2E38
          (0, 0, 11926, 11926),
         16#39#           =>  --  2E39
          (0, 0, 11927, 11927),
         16#3A#           =>  --  2E3A
          (0, 0, 11928, 11928),
         16#3B#           =>  --  2E3B
          (0, 0, 11929, 11929),
         16#3C#           =>  --  2E3C
          (0, 0, 11930, 11930),
         16#3D#           =>  --  2E3D
          (0, 0, 11931, 11931),
         16#3E#           =>  --  2E3E
          (0, 0, 11932, 11932),
         16#3F#           =>  --  2E3F
          (0, 0, 11933, 11933),
         16#40#           =>  --  2E40
          (0, 0, 11934, 11934),
         16#41#           =>  --  2E41
          (0, 0, 11935, 11935),
         16#42#           =>  --  2E42
          (0, 0, 11936, 11936),
         16#80#           =>  --  2E80
          (0, 0, 11937, 11939),
         16#81#           =>  --  2E81
          (0, 0, 11940, 11942),
         16#82#           =>  --  2E82
          (0, 0, 11943, 11944),
         16#83#           =>  --  2E83
          (0, 0, 11945, 11946),
         16#84#           =>  --  2E84
          (0, 0, 11947, 11949),
         16#85#           =>  --  2E85
          (0, 0, 11950, 11951),
         16#86#           =>  --  2E86
          (0, 0, 11952, 11954),
         16#87#           =>  --  2E87
          (0, 0, 11955, 11957),
         16#88#           =>  --  2E88
          (0, 0, 11958, 11960),
         16#89#           =>  --  2E89
          (0, 0, 11961, 11962),
         16#8A#           =>  --  2E8A
          (0, 0, 11963, 11965),
         16#8B#           =>  --  2E8B
          (0, 0, 11966, 11968),
         16#8C#           =>  --  2E8C
          (0, 0, 11969, 11971),
         16#8D#           =>  --  2E8D
          (0, 0, 11972, 11974),
         16#8E#           =>  --  2E8E
          (0, 0, 11975, 11977),
         16#8F#           =>  --  2E8F
          (0, 0, 11978, 11979),
         16#90#           =>  --  2E90
          (0, 0, 11975, 11976),
         16#91#           =>  --  2E91
          (0, 0, 11980, 11982),
         16#92#           =>  --  2E92
          (0, 0, 11983, 11984),
         16#93#           =>  --  2E93
          (0, 0, 11985, 11986),
         16#94#           =>  --  2E94
          (0, 0, 11987, 11988),
         16#95#           =>  --  2E95
          (0, 0, 11989, 11991),
         16#96#           =>  --  2E96
          (0, 0, 11992, 11993),
         16#97#           =>  --  2E97
          (0, 0, 11994, 11996),
         16#98#           =>  --  2E98
          (0, 0, 11997, 11998),
         16#99#           =>  --  2E99
          (0, 0, 11999, 12000),
         16#9B#           =>  --  2E9B
          (0, 0, 12001, 12002),
         16#9C#           =>  --  2E9C
          (0, 0, 12003, 12005),
         16#9D#           =>  --  2E9D
          (0, 0, 12006, 12008),
         16#9E#           =>  --  2E9E
          (0, 0, 12009, 12011),
         16#9F#           =>  --  2E9F
          (0, 0, 12012, 12013),
         16#A0#           =>  --  2EA0
          (0, 0, 12014, 12015),
         16#A1#           =>  --  2EA1
          (0, 0, 12016, 12017),
         16#A2#           =>  --  2EA2
          (0, 0, 12018, 12019),
         16#A3#           =>  --  2EA3
          (0, 0, 12020, 12021),
         16#A4#           =>  --  2EA4
          (0, 0, 12022, 12023),
         16#A5#           =>  --  2EA5
          (0, 0, 12024, 12026),
         16#A6#           =>  --  2EA6
          (0, 0, 12027, 12028),
         16#A7#           =>  --  2EA7
          (0, 0, 12029, 12031),
         16#A8#           =>  --  2EA8
          (0, 0, 12032, 12033),
         16#A9#           =>  --  2EA9
          (0, 0, 12034, 12036),
         16#AA#           =>  --  2EAA
          (0, 0, 12037, 12039),
         16#AB#           =>  --  2EAB
          (0, 0, 12040, 12042),
         16#AC#           =>  --  2EAC
          (0, 0, 12043, 12045),
         16#AD#           =>  --  2EAD
          (0, 0, 12046, 12047),
         16#AE#           =>  --  2EAE
          (0, 0, 12048, 12050),
         16#AF#           =>  --  2EAF
          (0, 0, 12051, 12052),
         16#B0#           =>  --  2EB0
          (0, 0, 12053, 12054),
         16#B1#           =>  --  2EB1
          (0, 0, 12055, 12056),
         16#B2#           =>  --  2EB2
          (0, 0, 12057, 12058),
         16#B3#           =>  --  2EB3
          (0, 0, 12059, 12061),
         16#B4#           =>  --  2EB4
          (0, 0, 12062, 12064),
         16#B5#           =>  --  2EB5
          (0, 0, 12065, 12067),
         16#B6#           =>  --  2EB6
          (0, 0, 12068, 12070),
         16#B7#           =>  --  2EB7
          (0, 0, 12071, 12073),
         16#B8#           =>  --  2EB8
          (0, 0, 12074, 12075),
         16#B9#           =>  --  2EB9
          (0, 0, 12076, 12077),
         16#BA#           =>  --  2EBA
          (0, 0, 12078, 12079),
         16#BB#           =>  --  2EBB
          (0, 0, 12080, 12082),
         16#BC#           =>  --  2EBC
          (0, 0, 12083, 12085),
         16#BD#           =>  --  2EBD
          (0, 0, 12086, 12088),
         16#BE#           =>  --  2EBE
          (0, 0, 12089, 12090),
         16#BF#           =>  --  2EBF
          (0, 0, 12091, 12093),
         16#C0#           =>  --  2EC0
          (0, 0, 12094, 12096),
         16#C1#           =>  --  2EC1
          (0, 0, 12097, 12098),
         16#C2#           =>  --  2EC2
          (0, 0, 12099, 12100),
         16#C3#           =>  --  2EC3
          (0, 0, 12101, 12102),
         16#C4#           =>  --  2EC4
          (0, 0, 12103, 12104),
         16#C5#           =>  --  2EC5
          (0, 0, 12105, 12106),
         16#C6#           =>  --  2EC6
          (0, 0, 12107, 12108),
         16#C7#           =>  --  2EC7
          (0, 0, 12109, 12111),
         16#C8#           =>  --  2EC8
          (0, 0, 12112, 12113),
         16#C9#           =>  --  2EC9
          (0, 0, 12114, 12115),
         16#CA#           =>  --  2ECA
          (0, 0, 12116, 12118),
         16#CB#           =>  --  2ECB
          (0, 0, 12119, 12120),
         16#CC#           =>  --  2ECC
          (0, 0, 12121, 12122),
         16#CD#           =>  --  2ECD
          (0, 0, 12123, 12125),
         16#CE#           =>  --  2ECE
          (0, 0, 12126, 12128),
         16#CF#           =>  --  2ECF
          (0, 0, 12129, 12131),
         16#D0#           =>  --  2ED0
          (0, 0, 12132, 12133),
         16#D1#           =>  --  2ED1
          (0, 0, 12134, 12135),
         16#D2#           =>  --  2ED2
          (0, 0, 12136, 12137),
         16#D3#           =>  --  2ED3
          (0, 0, 12138, 12139),
         16#D4#           =>  --  2ED4
          (0, 0, 12140, 12141),
         16#D5#           =>  --  2ED5
          (0, 0, 12142, 12144),
         16#D6#           =>  --  2ED6
          (0, 0, 12145, 12146),
         16#D7#           =>  --  2ED7
          (0, 0, 12147, 12149),
         16#D8#           =>  --  2ED8
          (0, 0, 12150, 12151),
         16#D9#           =>  --  2ED9
          (0, 0, 12152, 12153),
         16#DA#           =>  --  2EDA
          (0, 0, 12154, 12155),
         16#DB#           =>  --  2EDB
          (0, 0, 12156, 12157),
         16#DC#           =>  --  2EDC
          (0, 0, 12158, 12159),
         16#DD#           =>  --  2EDD
          (0, 0, 12160, 12161),
         16#DE#           =>  --  2EDE
          (0, 0, 12162, 12164),
         16#DF#           =>  --  2EDF
          (0, 0, 12162, 12163),
         16#E0#           =>  --  2EE0
          (0, 0, 12165, 12166),
         16#E1#           =>  --  2EE1
          (0, 0, 12167, 12169),
         16#E2#           =>  --  2EE2
          (0, 0, 12170, 12171),
         16#E3#           =>  --  2EE3
          (0, 0, 12172, 12174),
         16#E4#           =>  --  2EE4
          (0, 0, 12175, 12177),
         16#E5#           =>  --  2EE5
          (0, 0, 12178, 12179),
         16#E6#           =>  --  2EE6
          (0, 0, 12180, 12181),
         16#E7#           =>  --  2EE7
          (0, 0, 12182, 12184),
         16#E8#           =>  --  2EE8
          (0, 0, 12185, 12186),
         16#E9#           =>  --  2EE9
          (0, 0, 12187, 12188),
         16#EA#           =>  --  2EEA
          (0, 0, 12189, 12190),
         16#EB#           =>  --  2EEB
          (0, 0, 12191, 12193),
         16#EC#           =>  --  2EEC
          (0, 0, 12194, 12195),
         16#ED#           =>  --  2EED
          (0, 0, 12196, 12198),
         16#EE#           =>  --  2EEE
          (0, 0, 12199, 12200),
         16#EF#           =>  --  2EEF
          (0, 0, 12201, 12203),
         16#F0#           =>  --  2EF0
          (0, 0, 12204, 12205),
         16#F1#           =>  --  2EF1
          (0, 0, 12206, 12208),
         16#F2#           =>  --  2EF2
          (0, 0, 12209, 12211),
         16#F3#           =>  --  2EF3
          (0, 0, 12212, 12213),
         others           =>
          (0, 0, 0, 0));

   Group_002F : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  2F00
          (0, 0, 12214, 12215),
         16#01#           =>  --  2F01
          (0, 0, 12216, 12217),
         16#02#           =>  --  2F02
          (0, 0, 11937, 11938),
         16#03#           =>  --  2F03
          (0, 0, 12218, 12219),
         16#04#           =>  --  2F04
          (0, 0, 11947, 11948),
         16#05#           =>  --  2F05
          (0, 0, 12220, 12221),
         16#06#           =>  --  2F06
          (0, 0, 12222, 12223),
         16#07#           =>  --  2F07
          (0, 0, 12224, 12225),
         16#08#           =>  --  2F08
          (0, 0, 12226, 12227),
         16#09#           =>  --  2F09
          (0, 0, 12228, 12229),
         16#0A#           =>  --  2F0A
          (0, 0, 12230, 12231),
         16#0B#           =>  --  2F0B
          (0, 0, 12232, 12233),
         16#0C#           =>  --  2F0C
          (0, 0, 11952, 11953),
         16#0D#           =>  --  2F0D
          (0, 0, 12234, 12235),
         16#0E#           =>  --  2F0E
          (0, 0, 12236, 12237),
         16#0F#           =>  --  2F0F
          (0, 0, 11955, 11956),
         16#10#           =>  --  2F10
          (0, 0, 12238, 12239),
         16#11#           =>  --  2F11
          (0, 0, 11958, 11959),
         16#12#           =>  --  2F12
          (0, 0, 12240, 12241),
         16#13#           =>  --  2F13
          (0, 0, 12242, 12243),
         16#14#           =>  --  2F14
          (0, 0, 12244, 12245),
         16#15#           =>  --  2F15
          (0, 0, 12246, 12247),
         16#16#           =>  --  2F16
          (0, 0, 12248, 12249),
         16#17#           =>  --  2F17
          (0, 0, 12250, 12251),
         16#18#           =>  --  2F18
          (0, 0, 11963, 11964),
         16#19#           =>  --  2F19
          (0, 0, 11966, 11967),
         16#1A#           =>  --  2F1A
          (0, 0, 11940, 11941),
         16#1B#           =>  --  2F1B
          (0, 0, 12252, 12253),
         16#1C#           =>  --  2F1C
          (0, 0, 12254, 12255),
         16#1D#           =>  --  2F1D
          (0, 0, 12256, 12257),
         16#1E#           =>  --  2F1E
          (0, 0, 12258, 12259),
         16#1F#           =>  --  2F1F
          (0, 0, 12260, 12261),
         16#20#           =>  --  2F20
          (0, 0, 12262, 12263),
         16#21#           =>  --  2F21
          (0, 0, 12264, 12265),
         16#22#           =>  --  2F22
          (0, 0, 12266, 12267),
         16#23#           =>  --  2F23
          (0, 0, 12268, 12269),
         16#24#           =>  --  2F24
          (0, 0, 12270, 12271),
         16#25#           =>  --  2F25
          (0, 0, 12272, 12273),
         16#26#           =>  --  2F26
          (0, 0, 12274, 12275),
         16#27#           =>  --  2F27
          (0, 0, 12276, 12277),
         16#28#           =>  --  2F28
          (0, 0, 12278, 12279),
         16#29#           =>  --  2F29
          (0, 0, 11969, 11970),
         16#2A#           =>  --  2F2A
          (0, 0, 11975, 11976),
         16#2B#           =>  --  2F2B
          (0, 0, 12280, 12281),
         16#2C#           =>  --  2F2C
          (0, 0, 12282, 12283),
         16#2D#           =>  --  2F2D
          (0, 0, 12284, 12285),
         16#2E#           =>  --  2F2E
          (0, 0, 12286, 12287),
         16#2F#           =>  --  2F2F
          (0, 0, 12288, 12289),
         16#30#           =>  --  2F30
          (0, 0, 12290, 12291),
         16#31#           =>  --  2F31
          (0, 0, 12292, 12293),
         16#32#           =>  --  2F32
          (0, 0, 12294, 12295),
         16#33#           =>  --  2F33
          (0, 0, 11985, 11986),
         16#34#           =>  --  2F34
          (0, 0, 12296, 12297),
         16#35#           =>  --  2F35
          (0, 0, 12298, 12299),
         16#36#           =>  --  2F36
          (0, 0, 12300, 12301),
         16#37#           =>  --  2F37
          (0, 0, 12302, 12303),
         16#38#           =>  --  2F38
          (0, 0, 12304, 12305),
         16#39#           =>  --  2F39
          (0, 0, 11989, 11990),
         16#3A#           =>  --  2F3A
          (0, 0, 12306, 12307),
         16#3B#           =>  --  2F3B
          (0, 0, 12308, 12309),
         16#3C#           =>  --  2F3C
          (0, 0, 11994, 11995),
         16#3D#           =>  --  2F3D
          (0, 0, 12310, 12311),
         16#3E#           =>  --  2F3E
          (0, 0, 12312, 12313),
         16#3F#           =>  --  2F3F
          (0, 0, 12314, 12315),
         16#40#           =>  --  2F40
          (0, 0, 12316, 12317),
         16#41#           =>  --  2F41
          (0, 0, 12318, 12319),
         16#42#           =>  --  2F42
          (0, 0, 12320, 12321),
         16#43#           =>  --  2F43
          (0, 0, 12322, 12323),
         16#44#           =>  --  2F44
          (0, 0, 12324, 12325),
         16#45#           =>  --  2F45
          (0, 0, 12326, 12327),
         16#46#           =>  --  2F46
          (0, 0, 12328, 12329),
         16#47#           =>  --  2F47
          (0, 0, 12003, 12004),
         16#48#           =>  --  2F48
          (0, 0, 12330, 12331),
         16#49#           =>  --  2F49
          (0, 0, 12006, 12007),
         16#4A#           =>  --  2F4A
          (0, 0, 12332, 12333),
         16#4B#           =>  --  2F4B
          (0, 0, 12334, 12335),
         16#4C#           =>  --  2F4C
          (0, 0, 12336, 12337),
         16#4D#           =>  --  2F4D
          (0, 0, 12338, 12339),
         16#4E#           =>  --  2F4E
          (0, 0, 12340, 12341),
         16#4F#           =>  --  2F4F
          (0, 0, 12342, 12343),
         16#50#           =>  --  2F50
          (0, 0, 12344, 12345),
         16#51#           =>  --  2F51
          (0, 0, 12346, 12347),
         16#52#           =>  --  2F52
          (0, 0, 12348, 12349),
         16#53#           =>  --  2F53
          (0, 0, 12350, 12351),
         16#54#           =>  --  2F54
          (0, 0, 12352, 12353),
         16#55#           =>  --  2F55
          (0, 0, 12354, 12355),
         16#56#           =>  --  2F56
          (0, 0, 12356, 12357),
         16#57#           =>  --  2F57
          (0, 0, 12358, 12359),
         16#58#           =>  --  2F58
          (0, 0, 12360, 12361),
         16#59#           =>  --  2F59
          (0, 0, 12362, 12363),
         16#5A#           =>  --  2F5A
          (0, 0, 12364, 12365),
         16#5B#           =>  --  2F5B
          (0, 0, 12366, 12367),
         16#5C#           =>  --  2F5C
          (0, 0, 12029, 12030),
         16#5D#           =>  --  2F5D
          (0, 0, 12368, 12369),
         16#5E#           =>  --  2F5E
          (0, 0, 12370, 12371),
         16#5F#           =>  --  2F5F
          (0, 0, 12372, 12373),
         16#60#           =>  --  2F60
          (0, 0, 12374, 12375),
         16#61#           =>  --  2F61
          (0, 0, 12376, 12377),
         16#62#           =>  --  2F62
          (0, 0, 12378, 12379),
         16#63#           =>  --  2F63
          (0, 0, 12380, 12381),
         16#64#           =>  --  2F64
          (0, 0, 12382, 12383),
         16#65#           =>  --  2F65
          (0, 0, 12384, 12385),
         16#66#           =>  --  2F66
          (0, 0, 12037, 12038),
         16#67#           =>  --  2F67
          (0, 0, 12386, 12387),
         16#68#           =>  --  2F68
          (0, 0, 12388, 12389),
         16#69#           =>  --  2F69
          (0, 0, 12390, 12391),
         16#6A#           =>  --  2F6A
          (0, 0, 12392, 12393),
         16#6B#           =>  --  2F6B
          (0, 0, 12394, 12395),
         16#6C#           =>  --  2F6C
          (0, 0, 12040, 12041),
         16#6D#           =>  --  2F6D
          (0, 0, 12396, 12397),
         16#6E#           =>  --  2F6E
          (0, 0, 12398, 12399),
         16#6F#           =>  --  2F6F
          (0, 0, 12400, 12401),
         16#70#           =>  --  2F70
          (0, 0, 12043, 12044),
         16#71#           =>  --  2F71
          (0, 0, 12402, 12403),
         16#72#           =>  --  2F72
          (0, 0, 12404, 12405),
         16#73#           =>  --  2F73
          (0, 0, 12406, 12407),
         16#74#           =>  --  2F74
          (0, 0, 12408, 12409),
         16#75#           =>  --  2F75
          (0, 0, 12048, 12049),
         16#76#           =>  --  2F76
          (0, 0, 12410, 12411),
         16#77#           =>  --  2F77
          (0, 0, 12412, 12413),
         16#78#           =>  --  2F78
          (0, 0, 12414, 12415),
         16#79#           =>  --  2F79
          (0, 0, 12416, 12417),
         16#7A#           =>  --  2F7A
          (0, 0, 12068, 12069),
         16#7B#           =>  --  2F7B
          (0, 0, 12418, 12419),
         16#7C#           =>  --  2F7C
          (0, 0, 12420, 12421),
         16#7D#           =>  --  2F7D
          (0, 0, 12422, 12423),
         16#7E#           =>  --  2F7E
          (0, 0, 12424, 12425),
         16#7F#           =>  --  2F7F
          (0, 0, 12426, 12427),
         16#80#           =>  --  2F80
          (0, 0, 12080, 12081),
         16#81#           =>  --  2F81
          (0, 0, 12083, 12084),
         16#82#           =>  --  2F82
          (0, 0, 12428, 12429),
         16#83#           =>  --  2F83
          (0, 0, 12430, 12431),
         16#84#           =>  --  2F84
          (0, 0, 12432, 12433),
         16#85#           =>  --  2F85
          (0, 0, 12086, 12087),
         16#86#           =>  --  2F86
          (0, 0, 12434, 12435),
         16#87#           =>  --  2F87
          (0, 0, 12436, 12437),
         16#88#           =>  --  2F88
          (0, 0, 12438, 12439),
         16#89#           =>  --  2F89
          (0, 0, 12440, 12441),
         16#8A#           =>  --  2F8A
          (0, 0, 12442, 12443),
         16#8B#           =>  --  2F8B
          (0, 0, 12444, 12445),
         16#8C#           =>  --  2F8C
          (0, 0, 12446, 12447),
         16#8D#           =>  --  2F8D
          (0, 0, 12448, 12449),
         16#8E#           =>  --  2F8E
          (0, 0, 12450, 12451),
         16#8F#           =>  --  2F8F
          (0, 0, 12452, 12453),
         16#90#           =>  --  2F90
          (0, 0, 12454, 12455),
         16#91#           =>  --  2F91
          (0, 0, 12456, 12457),
         16#92#           =>  --  2F92
          (0, 0, 12458, 12459),
         16#93#           =>  --  2F93
          (0, 0, 12107, 12108),
         16#94#           =>  --  2F94
          (0, 0, 12460, 12461),
         16#95#           =>  --  2F95
          (0, 0, 12462, 12463),
         16#96#           =>  --  2F96
          (0, 0, 12464, 12465),
         16#97#           =>  --  2F97
          (0, 0, 12466, 12467),
         16#98#           =>  --  2F98
          (0, 0, 12468, 12469),
         16#99#           =>  --  2F99
          (0, 0, 12470, 12471),
         16#9A#           =>  --  2F9A
          (0, 0, 12472, 12473),
         16#9B#           =>  --  2F9B
          (0, 0, 12474, 12475),
         16#9C#           =>  --  2F9C
          (0, 0, 12116, 12117),
         16#9D#           =>  --  2F9D
          (0, 0, 12476, 12477),
         16#9E#           =>  --  2F9E
          (0, 0, 12478, 12479),
         16#9F#           =>  --  2F9F
          (0, 0, 12480, 12481),
         16#A0#           =>  --  2FA0
          (0, 0, 12482, 12483),
         16#A1#           =>  --  2FA1
          (0, 0, 12484, 12485),
         16#A2#           =>  --  2FA2
          (0, 0, 12129, 12130),
         16#A3#           =>  --  2FA3
          (0, 0, 12486, 12487),
         16#A4#           =>  --  2FA4
          (0, 0, 12488, 12489),
         16#A5#           =>  --  2FA5
          (0, 0, 12490, 12491),
         16#A6#           =>  --  2FA6
          (0, 0, 12492, 12493),
         16#A7#           =>  --  2FA7
          (0, 0, 12134, 12135),
         16#A8#           =>  --  2FA8
          (0, 0, 12494, 12495),
         16#A9#           =>  --  2FA9
          (0, 0, 12142, 12143),
         16#AA#           =>  --  2FAA
          (0, 0, 12496, 12497),
         16#AB#           =>  --  2FAB
          (0, 0, 12498, 12499),
         16#AC#           =>  --  2FAC
          (0, 0, 12147, 12148),
         16#AD#           =>  --  2FAD
          (0, 0, 12500, 12501),
         16#AE#           =>  --  2FAE
          (0, 0, 12502, 12503),
         16#AF#           =>  --  2FAF
          (0, 0, 12504, 12505),
         16#B0#           =>  --  2FB0
          (0, 0, 12506, 12507),
         16#B1#           =>  --  2FB1
          (0, 0, 12508, 12509),
         16#B2#           =>  --  2FB2
          (0, 0, 12510, 12511),
         16#B3#           =>  --  2FB3
          (0, 0, 12512, 12513),
         16#B4#           =>  --  2FB4
          (0, 0, 12514, 12515),
         16#B5#           =>  --  2FB5
          (0, 0, 12516, 12517),
         16#B6#           =>  --  2FB6
          (0, 0, 12518, 12519),
         16#B7#           =>  --  2FB7
          (0, 0, 12160, 12161),
         16#B8#           =>  --  2FB8
          (0, 0, 12167, 12168),
         16#B9#           =>  --  2FB9
          (0, 0, 12520, 12521),
         16#BA#           =>  --  2FBA
          (0, 0, 12522, 12523),
         16#BB#           =>  --  2FBB
          (0, 0, 12172, 12173),
         16#BC#           =>  --  2FBC
          (0, 0, 12524, 12525),
         16#BD#           =>  --  2FBD
          (0, 0, 12526, 12527),
         16#BE#           =>  --  2FBE
          (0, 0, 12528, 12529),
         16#BF#           =>  --  2FBF
          (0, 0, 12530, 12531),
         16#C0#           =>  --  2FC0
          (0, 0, 12532, 12533),
         16#C1#           =>  --  2FC1
          (0, 0, 12175, 12176),
         16#C2#           =>  --  2FC2
          (0, 0, 12534, 12535),
         16#C3#           =>  --  2FC3
          (0, 0, 12536, 12537),
         16#C4#           =>  --  2FC4
          (0, 0, 12182, 12183),
         16#C5#           =>  --  2FC5
          (0, 0, 12538, 12539),
         16#C6#           =>  --  2FC6
          (0, 0, 12540, 12541),
         16#C7#           =>  --  2FC7
          (0, 0, 12542, 12543),
         16#C8#           =>  --  2FC8
          (0, 0, 12544, 12545),
         16#C9#           =>  --  2FC9
          (0, 0, 12546, 12547),
         16#CA#           =>  --  2FCA
          (0, 0, 12548, 12549),
         16#CB#           =>  --  2FCB
          (0, 0, 12550, 12551),
         16#CC#           =>  --  2FCC
          (0, 0, 12552, 12553),
         16#CD#           =>  --  2FCD
          (0, 0, 12554, 12555),
         16#CE#           =>  --  2FCE
          (0, 0, 12556, 12557),
         16#CF#           =>  --  2FCF
          (0, 0, 12558, 12559),
         16#D0#           =>  --  2FD0
          (0, 0, 12560, 12561),
         16#D1#           =>  --  2FD1
          (0, 0, 12191, 12192),
         16#D2#           =>  --  2FD2
          (0, 0, 12196, 12197),
         16#D3#           =>  --  2FD3
          (0, 0, 12201, 12202),
         16#D4#           =>  --  2FD4
          (0, 0, 12206, 12207),
         16#D5#           =>  --  2FD5
          (0, 0, 12562, 12563),
         16#F0#           =>  --  2FF0
          (0, 0, 12564, 12564),
         16#F1#           =>  --  2FF1
          (0, 0, 12565, 12565),
         16#F2#           =>  --  2FF2
          (0, 0, 12566, 12566),
         16#F3#           =>  --  2FF3
          (0, 0, 12567, 12567),
         16#F4#           =>  --  2FF4
          (0, 0, 12568, 12568),
         16#F5#           =>  --  2FF5
          (0, 0, 12569, 12569),
         16#F6#           =>  --  2FF6
          (0, 0, 12570, 12570),
         16#F7#           =>  --  2FF7
          (0, 0, 12571, 12571),
         16#F8#           =>  --  2FF8
          (0, 0, 12572, 12572),
         16#F9#           =>  --  2FF9
          (0, 0, 12573, 12573),
         16#FA#           =>  --  2FFA
          (0, 0, 12574, 12574),
         16#FB#           =>  --  2FFB
          (0, 0, 12575, 12575),
         others           =>
          (0, 0, 0, 0));

   Group_0030 : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  3000
          (0, 0, 12576, 12576),
         16#01#           =>  --  3001
          (0, 0, 12577, 12577),
         16#02#           =>  --  3002
          (0, 0, 12578, 12578),
         16#03#           =>  --  3003
          (0, 0, 12579, 12579),
         16#04#           =>  --  3004
          (0, 0, 12580, 12580),
         16#05#           =>  --  3005
          (0, 0, 12581, 12581),
         16#06#           =>  --  3006
          (0, 0, 12582, 12583),
         16#07#           =>  --  3007
          (0, 0, 23, 23),
         16#08#           =>  --  3008
          (0, 0, 9165, 9165),
         16#09#           =>  --  3009
          (0, 0, 9166, 9166),
         16#0A#           =>  --  300A
          (0, 0, 12584, 12584),
         16#0B#           =>  --  300B
          (0, 0, 12585, 12585),
         16#0C#           =>  --  300C
          (0, 0, 12586, 12586),
         16#0D#           =>  --  300D
          (0, 0, 12587, 12587),
         16#0E#           =>  --  300E
          (0, 0, 12588, 12588),
         16#0F#           =>  --  300F
          (0, 0, 12589, 12589),
         16#10#           =>  --  3010
          (0, 0, 12590, 12590),
         16#11#           =>  --  3011
          (0, 0, 12591, 12591),
         16#12#           =>  --  3012
          (0, 0, 12592, 12592),
         16#13#           =>  --  3013
          (0, 0, 12593, 12593),
         16#14#           =>  --  3014
          (0, 0, 12594, 12594),
         16#15#           =>  --  3015
          (0, 0, 12595, 12595),
         16#16#           =>  --  3016
          (0, 0, 12596, 12596),
         16#17#           =>  --  3017
          (0, 0, 12597, 12597),
         16#18#           =>  --  3018
          (0, 0, 12598, 12598),
         16#19#           =>  --  3019
          (0, 0, 12599, 12599),
         16#1A#           =>  --  301A
          (0, 0, 12600, 12600),
         16#1B#           =>  --  301B
          (0, 0, 12601, 12601),
         16#1C#           =>  --  301C
          (0, 0, 12602, 12602),
         16#1D#           =>  --  301D
          (0, 0, 12603, 12603),
         16#1E#           =>  --  301E
          (0, 0, 12604, 12604),
         16#1F#           =>  --  301F
          (0, 0, 12605, 12605),
         16#20#           =>  --  3020
          (0, 0, 12606, 12606),
         16#21#           =>  --  3021
          (0, 0, 24, 24),
         16#22#           =>  --  3022
          (0, 0, 25, 25),
         16#23#           =>  --  3023
          (0, 0, 26, 26),
         16#24#           =>  --  3024
          (0, 0, 27, 27),
         16#25#           =>  --  3025
          (0, 0, 28, 28),
         16#26#           =>  --  3026
          (0, 0, 29, 29),
         16#27#           =>  --  3027
          (0, 0, 30, 30),
         16#28#           =>  --  3028
          (0, 0, 31, 31),
         16#29#           =>  --  3029
          (0, 0, 32, 32),
         16#2A#           =>  --  302A
          (0, 0, 12607, 12607),
         16#2B#           =>  --  302B
          (0, 0, 12608, 12608),
         16#2C#           =>  --  302C
          (0, 0, 12609, 12609),
         16#2D#           =>  --  302D
          (0, 0, 12610, 12610),
         16#2E#           =>  --  302E
          (0, 0, 12611, 12611),
         16#2F#           =>  --  302F
          (0, 0, 12612, 12612),
         16#30#           =>  --  3030
          (0, 0, 12613, 12613),
         16#31#           =>  --  3031
          (0, 0, 12614, 12614),
         16#32#           =>  --  3032
          (0, 0, 12615, 12616),
         16#33#           =>  --  3033
          (0, 0, 12617, 12617),
         16#34#           =>  --  3034
          (0, 0, 12618, 12619),
         16#35#           =>  --  3035
          (0, 0, 12620, 12620),
         16#36#           =>  --  3036
          (0, 0, 12621, 12621),
         16#37#           =>  --  3037
          (0, 0, 12622, 12622),
         16#38#           =>  --  3038
          (0, 0, 12250, 12251),
         16#39#           =>  --  3039
          (0, 0, 12623, 12624),
         16#3A#           =>  --  303A
          (0, 0, 12625, 12626),
         16#3B#           =>  --  303B
          (0, 0, 12627, 12627),
         16#3C#           =>  --  303C
          (0, 0, 12628, 12629),
         16#3D#           =>  --  303D
          (0, 0, 12630, 12630),
         16#3E#           =>  --  303E
          (0, 0, 12631, 12631),
         16#3F#           =>  --  303F
          (0, 0, 12632, 12632),
         16#41#           =>  --  3041
          (0, 0, 12633, 12633),
         16#42#           =>  --  3042
          (0, 0, 12634, 12634),
         16#43#           =>  --  3043
          (0, 0, 12635, 12635),
         16#44#           =>  --  3044
          (0, 0, 12636, 12636),
         16#45#           =>  --  3045
          (0, 0, 12637, 12637),
         16#46#           =>  --  3046
          (0, 0, 12638, 12638),
         16#47#           =>  --  3047
          (0, 0, 12639, 12639),
         16#48#           =>  --  3048
          (0, 0, 12640, 12640),
         16#49#           =>  --  3049
          (0, 0, 12641, 12641),
         16#4A#           =>  --  304A
          (0, 0, 12642, 12642),
         16#4B#           =>  --  304B
          (0, 0, 12643, 12643),
         16#4C#           =>  --  304C
          (0, 0, 12644, 12645),
         16#4D#           =>  --  304D
          (0, 0, 12646, 12646),
         16#4E#           =>  --  304E
          (0, 0, 12647, 12648),
         16#4F#           =>  --  304F
          (0, 0, 12649, 12649),
         16#50#           =>  --  3050
          (0, 0, 12650, 12651),
         16#51#           =>  --  3051
          (0, 0, 12652, 12652),
         16#52#           =>  --  3052
          (0, 0, 12653, 12654),
         16#53#           =>  --  3053
          (0, 0, 12655, 12655),
         16#54#           =>  --  3054
          (0, 0, 12656, 12657),
         16#55#           =>  --  3055
          (0, 0, 12658, 12658),
         16#56#           =>  --  3056
          (0, 0, 12659, 12660),
         16#57#           =>  --  3057
          (0, 0, 12661, 12661),
         16#58#           =>  --  3058
          (0, 0, 12662, 12663),
         16#59#           =>  --  3059
          (0, 0, 12664, 12664),
         16#5A#           =>  --  305A
          (0, 0, 12665, 12666),
         16#5B#           =>  --  305B
          (0, 0, 12667, 12667),
         16#5C#           =>  --  305C
          (0, 0, 12668, 12669),
         16#5D#           =>  --  305D
          (0, 0, 12670, 12670),
         16#5E#           =>  --  305E
          (0, 0, 12671, 12672),
         16#5F#           =>  --  305F
          (0, 0, 12673, 12673),
         16#60#           =>  --  3060
          (0, 0, 12674, 12675),
         16#61#           =>  --  3061
          (0, 0, 12676, 12676),
         16#62#           =>  --  3062
          (0, 0, 12677, 12678),
         16#63#           =>  --  3063
          (0, 0, 12679, 12679),
         16#64#           =>  --  3064
          (0, 0, 12680, 12680),
         16#65#           =>  --  3065
          (0, 0, 12681, 12682),
         16#66#           =>  --  3066
          (0, 0, 12683, 12683),
         16#67#           =>  --  3067
          (0, 0, 12684, 12685),
         16#68#           =>  --  3068
          (0, 0, 12686, 12686),
         16#69#           =>  --  3069
          (0, 0, 12687, 12688),
         16#6A#           =>  --  306A
          (0, 0, 12689, 12689),
         16#6B#           =>  --  306B
          (0, 0, 12690, 12690),
         16#6C#           =>  --  306C
          (0, 0, 12691, 12691),
         16#6D#           =>  --  306D
          (0, 0, 12692, 12692),
         16#6E#           =>  --  306E
          (0, 0, 12693, 12693),
         16#6F#           =>  --  306F
          (0, 0, 12694, 12694),
         16#70#           =>  --  3070
          (0, 0, 12695, 12696),
         16#71#           =>  --  3071
          (0, 0, 12697, 12698),
         16#72#           =>  --  3072
          (0, 0, 12699, 12699),
         16#73#           =>  --  3073
          (0, 0, 12700, 12701),
         16#74#           =>  --  3074
          (0, 0, 12702, 12703),
         16#75#           =>  --  3075
          (0, 0, 12704, 12704),
         16#76#           =>  --  3076
          (0, 0, 12705, 12706),
         16#77#           =>  --  3077
          (0, 0, 12707, 12708),
         16#78#           =>  --  3078
          (0, 0, 12709, 12709),
         16#79#           =>  --  3079
          (0, 0, 12710, 12711),
         16#7A#           =>  --  307A
          (0, 0, 12712, 12713),
         16#7B#           =>  --  307B
          (0, 0, 12714, 12714),
         16#7C#           =>  --  307C
          (0, 0, 12715, 12716),
         16#7D#           =>  --  307D
          (0, 0, 12717, 12718),
         16#7E#           =>  --  307E
          (0, 0, 12719, 12719),
         16#7F#           =>  --  307F
          (0, 0, 12720, 12720),
         16#80#           =>  --  3080
          (0, 0, 12721, 12721),
         16#81#           =>  --  3081
          (0, 0, 12722, 12722),
         16#82#           =>  --  3082
          (0, 0, 12723, 12723),
         16#83#           =>  --  3083
          (0, 0, 12724, 12724),
         16#84#           =>  --  3084
          (0, 0, 12725, 12725),
         16#85#           =>  --  3085
          (0, 0, 12726, 12726),
         16#86#           =>  --  3086
          (0, 0, 12727, 12727),
         16#87#           =>  --  3087
          (0, 0, 12728, 12728),
         16#88#           =>  --  3088
          (0, 0, 12729, 12729),
         16#89#           =>  --  3089
          (0, 0, 12730, 12730),
         16#8A#           =>  --  308A
          (0, 0, 12731, 12731),
         16#8B#           =>  --  308B
          (0, 0, 12732, 12732),
         16#8C#           =>  --  308C
          (0, 0, 12733, 12733),
         16#8D#           =>  --  308D
          (0, 0, 12734, 12734),
         16#8E#           =>  --  308E
          (0, 0, 12735, 12735),
         16#8F#           =>  --  308F
          (0, 0, 12736, 12736),
         16#90#           =>  --  3090
          (0, 0, 12737, 12737),
         16#91#           =>  --  3091
          (0, 0, 12738, 12738),
         16#92#           =>  --  3092
          (0, 0, 12739, 12739),
         16#93#           =>  --  3093
          (0, 0, 12740, 12740),
         16#94#           =>  --  3094
          (0, 0, 12741, 12742),
         16#95#           =>  --  3095
          (0, 0, 12743, 12743),
         16#96#           =>  --  3096
          (0, 0, 12744, 12744),
         16#99#           =>  --  3099
          (0, 0, 12616, 12616),
         16#9A#           =>  --  309A
          (0, 0, 12698, 12698),
         16#9B#           =>  --  309B
          (0, 0, 12745, 12745),
         16#9C#           =>  --  309C
          (0, 0, 12746, 12746),
         16#9D#           =>  --  309D
          (0, 0, 12747, 12747),
         16#9E#           =>  --  309E
          (0, 0, 12748, 12749),
         16#9F#           =>  --  309F
          (0, 0, 12750, 12751),
         16#A0#           =>  --  30A0
          (0, 0, 12752, 12752),
         16#A1#           =>  --  30A1
          (0, 0, 12753, 12753),
         16#A2#           =>  --  30A2
          (0, 0, 12754, 12754),
         16#A3#           =>  --  30A3
          (0, 0, 12755, 12755),
         16#A4#           =>  --  30A4
          (0, 0, 12756, 12756),
         16#A5#           =>  --  30A5
          (0, 0, 12757, 12757),
         16#A6#           =>  --  30A6
          (0, 0, 12758, 12758),
         16#A7#           =>  --  30A7
          (0, 0, 12759, 12759),
         16#A8#           =>  --  30A8
          (0, 0, 12760, 12760),
         16#A9#           =>  --  30A9
          (0, 0, 12761, 12761),
         16#AA#           =>  --  30AA
          (0, 0, 12762, 12762),
         16#AB#           =>  --  30AB
          (0, 0, 12763, 12763),
         16#AC#           =>  --  30AC
          (0, 0, 12764, 12765),
         16#AD#           =>  --  30AD
          (0, 0, 12766, 12766),
         16#AE#           =>  --  30AE
          (0, 0, 12767, 12768),
         16#AF#           =>  --  30AF
          (0, 0, 12769, 12769),
         16#B0#           =>  --  30B0
          (0, 0, 12770, 12771),
         16#B1#           =>  --  30B1
          (0, 0, 12772, 12772),
         16#B2#           =>  --  30B2
          (0, 0, 12773, 12774),
         16#B3#           =>  --  30B3
          (0, 0, 12775, 12775),
         16#B4#           =>  --  30B4
          (0, 0, 12776, 12777),
         16#B5#           =>  --  30B5
          (0, 0, 12778, 12778),
         16#B6#           =>  --  30B6
          (0, 0, 12779, 12780),
         16#B7#           =>  --  30B7
          (0, 0, 12781, 12781),
         16#B8#           =>  --  30B8
          (0, 0, 12782, 12783),
         16#B9#           =>  --  30B9
          (0, 0, 12784, 12784),
         16#BA#           =>  --  30BA
          (0, 0, 12785, 12786),
         16#BB#           =>  --  30BB
          (0, 0, 12787, 12787),
         16#BC#           =>  --  30BC
          (0, 0, 12788, 12789),
         16#BD#           =>  --  30BD
          (0, 0, 12790, 12790),
         16#BE#           =>  --  30BE
          (0, 0, 12791, 12792),
         16#BF#           =>  --  30BF
          (0, 0, 12793, 12793),
         16#C0#           =>  --  30C0
          (0, 0, 12794, 12795),
         16#C1#           =>  --  30C1
          (0, 0, 12796, 12796),
         16#C2#           =>  --  30C2
          (0, 0, 12797, 12798),
         16#C3#           =>  --  30C3
          (0, 0, 12799, 12799),
         16#C4#           =>  --  30C4
          (0, 0, 12800, 12800),
         16#C5#           =>  --  30C5
          (0, 0, 12801, 12802),
         16#C6#           =>  --  30C6
          (0, 0, 12803, 12803),
         16#C7#           =>  --  30C7
          (0, 0, 12804, 12805),
         16#C8#           =>  --  30C8
          (0, 0, 12806, 12806),
         16#C9#           =>  --  30C9
          (0, 0, 12807, 12808),
         16#CA#           =>  --  30CA
          (0, 0, 12809, 12809),
         16#CB#           =>  --  30CB
          (0, 0, 12810, 12810),
         16#CC#           =>  --  30CC
          (0, 0, 12811, 12811),
         16#CD#           =>  --  30CD
          (0, 0, 12812, 12812),
         16#CE#           =>  --  30CE
          (0, 0, 12813, 12813),
         16#CF#           =>  --  30CF
          (0, 0, 12814, 12814),
         16#D0#           =>  --  30D0
          (0, 0, 12815, 12816),
         16#D1#           =>  --  30D1
          (0, 0, 12817, 12818),
         16#D2#           =>  --  30D2
          (0, 0, 12819, 12819),
         16#D3#           =>  --  30D3
          (0, 0, 12820, 12821),
         16#D4#           =>  --  30D4
          (0, 0, 12822, 12823),
         16#D5#           =>  --  30D5
          (0, 0, 12824, 12824),
         16#D6#           =>  --  30D6
          (0, 0, 12825, 12826),
         16#D7#           =>  --  30D7
          (0, 0, 12827, 12828),
         16#D8#           =>  --  30D8
          (0, 0, 12829, 12829),
         16#D9#           =>  --  30D9
          (0, 0, 12830, 12831),
         16#DA#           =>  --  30DA
          (0, 0, 12832, 12833),
         16#DB#           =>  --  30DB
          (0, 0, 12834, 12834),
         16#DC#           =>  --  30DC
          (0, 0, 12835, 12836),
         16#DD#           =>  --  30DD
          (0, 0, 12837, 12838),
         16#DE#           =>  --  30DE
          (0, 0, 12839, 12839),
         16#DF#           =>  --  30DF
          (0, 0, 12840, 12840),
         16#E0#           =>  --  30E0
          (0, 0, 12841, 12841),
         16#E1#           =>  --  30E1
          (0, 0, 12842, 12842),
         16#E2#           =>  --  30E2
          (0, 0, 12843, 12843),
         16#E3#           =>  --  30E3
          (0, 0, 12844, 12844),
         16#E4#           =>  --  30E4
          (0, 0, 12845, 12845),
         16#E5#           =>  --  30E5
          (0, 0, 12846, 12846),
         16#E6#           =>  --  30E6
          (0, 0, 12847, 12847),
         16#E7#           =>  --  30E7
          (0, 0, 12848, 12848),
         16#E8#           =>  --  30E8
          (0, 0, 12849, 12849),
         16#E9#           =>  --  30E9
          (0, 0, 12850, 12850),
         16#EA#           =>  --  30EA
          (0, 0, 12851, 12851),
         16#EB#           =>  --  30EB
          (0, 0, 12852, 12852),
         16#EC#           =>  --  30EC
          (0, 0, 12853, 12853),
         16#ED#           =>  --  30ED
          (0, 0, 12854, 12854),
         16#EE#           =>  --  30EE
          (0, 0, 12855, 12855),
         16#EF#           =>  --  30EF
          (0, 0, 12856, 12856),
         16#F0#           =>  --  30F0
          (0, 0, 12857, 12857),
         16#F1#           =>  --  30F1
          (0, 0, 12858, 12858),
         16#F2#           =>  --  30F2
          (0, 0, 12859, 12859),
         16#F3#           =>  --  30F3
          (0, 0, 12860, 12860),
         16#F4#           =>  --  30F4
          (0, 0, 12861, 12862),
         16#F5#           =>  --  30F5
          (0, 0, 12863, 12863),
         16#F6#           =>  --  30F6
          (0, 0, 12864, 12864),
         16#F7#           =>  --  30F7
          (0, 0, 12865, 12866),
         16#F8#           =>  --  30F8
          (0, 0, 12867, 12868),
         16#F9#           =>  --  30F9
          (0, 0, 12869, 12870),
         16#FA#           =>  --  30FA
          (0, 0, 12871, 12872),
         16#FB#           =>  --  30FB
          (0, 0, 12873, 12873),
         16#FC#           =>  --  30FC
          (0, 0, 12874, 12874),
         16#FD#           =>  --  30FD
          (0, 0, 12875, 12875),
         16#FE#           =>  --  30FE
          (0, 0, 12876, 12877),
         16#FF#           =>  --  30FF
          (0, 0, 12878, 12879),
         others           =>
          (0, 0, 0, 0));

   Group_0031 : aliased constant Collation_Second_Stage
     := (16#05#           =>  --  3105
          (0, 0, 12880, 12880),
         16#06#           =>  --  3106
          (0, 0, 12881, 12881),
         16#07#           =>  --  3107
          (0, 0, 12882, 12882),
         16#08#           =>  --  3108
          (0, 0, 12883, 12883),
         16#09#           =>  --  3109
          (0, 0, 12884, 12884),
         16#0A#           =>  --  310A
          (0, 0, 12885, 12885),
         16#0B#           =>  --  310B
          (0, 0, 12886, 12886),
         16#0C#           =>  --  310C
          (0, 0, 12887, 12887),
         16#0D#           =>  --  310D
          (0, 0, 12888, 12888),
         16#0E#           =>  --  310E
          (0, 0, 12889, 12889),
         16#0F#           =>  --  310F
          (0, 0, 12890, 12890),
         16#10#           =>  --  3110
          (0, 0, 12891, 12891),
         16#11#           =>  --  3111
          (0, 0, 12892, 12892),
         16#12#           =>  --  3112
          (0, 0, 12893, 12893),
         16#13#           =>  --  3113
          (0, 0, 12894, 12894),
         16#14#           =>  --  3114
          (0, 0, 12895, 12895),
         16#15#           =>  --  3115
          (0, 0, 12896, 12896),
         16#16#           =>  --  3116
          (0, 0, 12897, 12897),
         16#17#           =>  --  3117
          (0, 0, 12898, 12898),
         16#18#           =>  --  3118
          (0, 0, 12899, 12899),
         16#19#           =>  --  3119
          (0, 0, 12900, 12900),
         16#1A#           =>  --  311A
          (0, 0, 12901, 12901),
         16#1B#           =>  --  311B
          (0, 0, 12902, 12902),
         16#1C#           =>  --  311C
          (0, 0, 12903, 12903),
         16#1D#           =>  --  311D
          (0, 0, 12904, 12904),
         16#1E#           =>  --  311E
          (0, 0, 12905, 12905),
         16#1F#           =>  --  311F
          (0, 0, 12906, 12906),
         16#20#           =>  --  3120
          (0, 0, 12907, 12907),
         16#21#           =>  --  3121
          (0, 0, 12908, 12908),
         16#22#           =>  --  3122
          (0, 0, 12909, 12909),
         16#23#           =>  --  3123
          (0, 0, 12910, 12910),
         16#24#           =>  --  3124
          (0, 0, 12911, 12911),
         16#25#           =>  --  3125
          (0, 0, 12912, 12912),
         16#26#           =>  --  3126
          (0, 0, 12913, 12913),
         16#27#           =>  --  3127
          (0, 0, 12914, 12914),
         16#28#           =>  --  3128
          (0, 0, 12915, 12915),
         16#29#           =>  --  3129
          (0, 0, 12916, 12916),
         16#2A#           =>  --  312A
          (0, 0, 12917, 12917),
         16#2B#           =>  --  312B
          (0, 0, 12918, 12918),
         16#2C#           =>  --  312C
          (0, 0, 12919, 12919),
         16#2D#           =>  --  312D
          (0, 0, 12920, 12920),
         16#31#           =>  --  3131
          (0, 0, 12921, 12921),
         16#32#           =>  --  3132
          (0, 0, 12922, 12922),
         16#33#           =>  --  3133
          (0, 0, 12923, 12923),
         16#34#           =>  --  3134
          (0, 0, 12924, 12924),
         16#35#           =>  --  3135
          (0, 0, 12925, 12925),
         16#36#           =>  --  3136
          (0, 0, 12926, 12926),
         16#37#           =>  --  3137
          (0, 0, 12927, 12927),
         16#38#           =>  --  3138
          (0, 0, 12928, 12928),
         16#39#           =>  --  3139
          (0, 0, 12929, 12929),
         16#3A#           =>  --  313A
          (0, 0, 12930, 12930),
         16#3B#           =>  --  313B
          (0, 0, 12931, 12931),
         16#3C#           =>  --  313C
          (0, 0, 12932, 12932),
         16#3D#           =>  --  313D
          (0, 0, 12933, 12933),
         16#3E#           =>  --  313E
          (0, 0, 12934, 12934),
         16#3F#           =>  --  313F
          (0, 0, 12935, 12935),
         16#40#           =>  --  3140
          (0, 0, 12936, 12936),
         16#41#           =>  --  3141
          (0, 0, 12937, 12937),
         16#42#           =>  --  3142
          (0, 0, 12938, 12938),
         16#43#           =>  --  3143
          (0, 0, 12939, 12939),
         16#44#           =>  --  3144
          (0, 0, 12940, 12940),
         16#45#           =>  --  3145
          (0, 0, 12941, 12941),
         16#46#           =>  --  3146
          (0, 0, 12942, 12942),
         16#47#           =>  --  3147
          (0, 0, 12943, 12943),
         16#48#           =>  --  3148
          (0, 0, 12944, 12944),
         16#49#           =>  --  3149
          (0, 0, 12945, 12945),
         16#4A#           =>  --  314A
          (0, 0, 12946, 12946),
         16#4B#           =>  --  314B
          (0, 0, 12947, 12947),
         16#4C#           =>  --  314C
          (0, 0, 12948, 12948),
         16#4D#           =>  --  314D
          (0, 0, 12949, 12949),
         16#4E#           =>  --  314E
          (0, 0, 12950, 12950),
         16#4F#           =>  --  314F
          (0, 0, 12951, 12951),
         16#50#           =>  --  3150
          (0, 0, 12952, 12952),
         16#51#           =>  --  3151
          (0, 0, 12953, 12953),
         16#52#           =>  --  3152
          (0, 0, 12954, 12954),
         16#53#           =>  --  3153
          (0, 0, 12955, 12955),
         16#54#           =>  --  3154
          (0, 0, 12956, 12956),
         16#55#           =>  --  3155
          (0, 0, 12957, 12957),
         16#56#           =>  --  3156
          (0, 0, 12958, 12958),
         16#57#           =>  --  3157
          (0, 0, 12959, 12959),
         16#58#           =>  --  3158
          (0, 0, 12960, 12960),
         16#59#           =>  --  3159
          (0, 0, 12961, 12961),
         16#5A#           =>  --  315A
          (0, 0, 12962, 12962),
         16#5B#           =>  --  315B
          (0, 0, 12963, 12963),
         16#5C#           =>  --  315C
          (0, 0, 12964, 12964),
         16#5D#           =>  --  315D
          (0, 0, 12965, 12965),
         16#5E#           =>  --  315E
          (0, 0, 12966, 12966),
         16#5F#           =>  --  315F
          (0, 0, 12967, 12967),
         16#60#           =>  --  3160
          (0, 0, 12968, 12968),
         16#61#           =>  --  3161
          (0, 0, 12969, 12969),
         16#62#           =>  --  3162
          (0, 0, 12970, 12970),
         16#63#           =>  --  3163
          (0, 0, 12971, 12971),
         16#64#           =>  --  3164
          (0, 0, 12972, 12972),
         16#65#           =>  --  3165
          (0, 0, 12973, 12973),
         16#66#           =>  --  3166
          (0, 0, 12974, 12974),
         16#67#           =>  --  3167
          (0, 0, 12975, 12975),
         16#68#           =>  --  3168
          (0, 0, 12976, 12976),
         16#69#           =>  --  3169
          (0, 0, 12977, 12977),
         16#6A#           =>  --  316A
          (0, 0, 12978, 12978),
         16#6B#           =>  --  316B
          (0, 0, 12979, 12979),
         16#6C#           =>  --  316C
          (0, 0, 12980, 12980),
         16#6D#           =>  --  316D
          (0, 0, 12981, 12981),
         16#6E#           =>  --  316E
          (0, 0, 12982, 12982),
         16#6F#           =>  --  316F
          (0, 0, 12983, 12983),
         16#70#           =>  --  3170
          (0, 0, 12984, 12984),
         16#71#           =>  --  3171
          (0, 0, 12985, 12985),
         16#72#           =>  --  3172
          (0, 0, 12986, 12986),
         16#73#           =>  --  3173
          (0, 0, 12987, 12987),
         16#74#           =>  --  3174
          (0, 0, 12988, 12988),
         16#75#           =>  --  3175
          (0, 0, 12989, 12989),
         16#76#           =>  --  3176
          (0, 0, 12990, 12990),
         16#77#           =>  --  3177
          (0, 0, 12991, 12991),
         16#78#           =>  --  3178
          (0, 0, 12992, 12992),
         16#79#           =>  --  3179
          (0, 0, 12993, 12993),
         16#7A#           =>  --  317A
          (0, 0, 12994, 12994),
         16#7B#           =>  --  317B
          (0, 0, 12995, 12995),
         16#7C#           =>  --  317C
          (0, 0, 12996, 12996),
         16#7D#           =>  --  317D
          (0, 0, 12997, 12997),
         16#7E#           =>  --  317E
          (0, 0, 12998, 12998),
         16#7F#           =>  --  317F
          (0, 0, 12999, 12999),
         16#80#           =>  --  3180
          (0, 0, 13000, 13000),
         16#81#           =>  --  3181
          (0, 0, 13001, 13001),
         16#82#           =>  --  3182
          (0, 0, 13002, 13002),
         16#83#           =>  --  3183
          (0, 0, 13003, 13003),
         16#84#           =>  --  3184
          (0, 0, 13004, 13004),
         16#85#           =>  --  3185
          (0, 0, 13005, 13005),
         16#86#           =>  --  3186
          (0, 0, 13006, 13006),
         16#87#           =>  --  3187
          (0, 0, 13007, 13007),
         16#88#           =>  --  3188
          (0, 0, 13008, 13008),
         16#89#           =>  --  3189
          (0, 0, 13009, 13009),
         16#8A#           =>  --  318A
          (0, 0, 13010, 13010),
         16#8B#           =>  --  318B
          (0, 0, 13011, 13011),
         16#8C#           =>  --  318C
          (0, 0, 13012, 13012),
         16#8D#           =>  --  318D
          (0, 0, 13013, 13013),
         16#8E#           =>  --  318E
          (0, 0, 13014, 13014),
         16#90#           =>  --  3190
          (0, 0, 13015, 13015),
         16#91#           =>  --  3191
          (0, 0, 13016, 13016),
         16#92#           =>  --  3192
          (0, 0, 13017, 13018),
         16#93#           =>  --  3193
          (0, 0, 13019, 13020),
         16#94#           =>  --  3194
          (0, 0, 13021, 13022),
         16#95#           =>  --  3195
          (0, 0, 13023, 13024),
         16#96#           =>  --  3196
          (0, 0, 13025, 13026),
         16#97#           =>  --  3197
          (0, 0, 13027, 13028),
         16#98#           =>  --  3198
          (0, 0, 13029, 13030),
         16#99#           =>  --  3199
          (0, 0, 13031, 13032),
         16#9A#           =>  --  319A
          (0, 0, 13033, 13034),
         16#9B#           =>  --  319B
          (0, 0, 13035, 13036),
         16#9C#           =>  --  319C
          (0, 0, 13037, 13038),
         16#9D#           =>  --  319D
          (0, 0, 13039, 13040),
         16#9E#           =>  --  319E
          (0, 0, 13041, 13042),
         16#9F#           =>  --  319F
          (0, 0, 13043, 13044),
         16#A0#           =>  --  31A0
          (0, 0, 13045, 13046),
         16#A1#           =>  --  31A1
          (0, 0, 13047, 13048),
         16#A2#           =>  --  31A2
          (0, 0, 13049, 13050),
         16#A3#           =>  --  31A3
          (0, 0, 13051, 13052),
         16#A4#           =>  --  31A4
          (0, 0, 13053, 13053),
         16#A5#           =>  --  31A5
          (0, 0, 13054, 13055),
         16#A6#           =>  --  31A6
          (0, 0, 13056, 13056),
         16#A7#           =>  --  31A7
          (0, 0, 13057, 13058),
         16#A8#           =>  --  31A8
          (0, 0, 13059, 13060),
         16#A9#           =>  --  31A9
          (0, 0, 13061, 13062),
         16#AA#           =>  --  31AA
          (0, 0, 13063, 13064),
         16#AB#           =>  --  31AB
          (0, 0, 13065, 13066),
         16#AC#           =>  --  31AC
          (0, 0, 13067, 13067),
         16#AD#           =>  --  31AD
          (0, 0, 13068, 13068),
         16#AE#           =>  --  31AE
          (0, 0, 13069, 13070),
         16#AF#           =>  --  31AF
          (0, 0, 13071, 13072),
         16#B0#           =>  --  31B0
          (0, 0, 13073, 13073),
         16#B1#           =>  --  31B1
          (0, 0, 13074, 13074),
         16#B2#           =>  --  31B2
          (0, 0, 13075, 13075),
         16#B3#           =>  --  31B3
          (0, 0, 13076, 13077),
         16#B4#           =>  --  31B4
          (0, 0, 13078, 13078),
         16#B5#           =>  --  31B5
          (0, 0, 13079, 13079),
         16#B6#           =>  --  31B6
          (0, 0, 13080, 13080),
         16#B7#           =>  --  31B7
          (0, 0, 13081, 13081),
         16#B8#           =>  --  31B8
          (0, 0, 13082, 13082),
         16#B9#           =>  --  31B9
          (0, 0, 13083, 13083),
         16#BA#           =>  --  31BA
          (0, 0, 13084, 13084),
         16#C0#           =>  --  31C0
          (0, 0, 13085, 13085),
         16#C1#           =>  --  31C1
          (0, 0, 13086, 13086),
         16#C2#           =>  --  31C2
          (0, 0, 13087, 13087),
         16#C3#           =>  --  31C3
          (0, 0, 13088, 13088),
         16#C4#           =>  --  31C4
          (0, 0, 13089, 13089),
         16#C5#           =>  --  31C5
          (0, 0, 13090, 13090),
         16#C6#           =>  --  31C6
          (0, 0, 13091, 13091),
         16#C7#           =>  --  31C7
          (0, 0, 13092, 13092),
         16#C8#           =>  --  31C8
          (0, 0, 13093, 13093),
         16#C9#           =>  --  31C9
          (0, 0, 13094, 13094),
         16#CA#           =>  --  31CA
          (0, 0, 13095, 13095),
         16#CB#           =>  --  31CB
          (0, 0, 13096, 13096),
         16#CC#           =>  --  31CC
          (0, 0, 13097, 13097),
         16#CD#           =>  --  31CD
          (0, 0, 13098, 13098),
         16#CE#           =>  --  31CE
          (0, 0, 13099, 13099),
         16#CF#           =>  --  31CF
          (0, 0, 13100, 13100),
         16#D0#           =>  --  31D0
          (0, 0, 13101, 13101),
         16#D1#           =>  --  31D1
          (0, 0, 13102, 13102),
         16#D2#           =>  --  31D2
          (0, 0, 13103, 13103),
         16#D3#           =>  --  31D3
          (0, 0, 13104, 13104),
         16#D4#           =>  --  31D4
          (0, 0, 13105, 13105),
         16#D5#           =>  --  31D5
          (0, 0, 13106, 13106),
         16#D6#           =>  --  31D6
          (0, 0, 13107, 13107),
         16#D7#           =>  --  31D7
          (0, 0, 13108, 13108),
         16#D8#           =>  --  31D8
          (0, 0, 13109, 13109),
         16#D9#           =>  --  31D9
          (0, 0, 13110, 13110),
         16#DA#           =>  --  31DA
          (0, 0, 13111, 13111),
         16#DB#           =>  --  31DB
          (0, 0, 13112, 13112),
         16#DC#           =>  --  31DC
          (0, 0, 13113, 13113),
         16#DD#           =>  --  31DD
          (0, 0, 13114, 13114),
         16#DE#           =>  --  31DE
          (0, 0, 13115, 13115),
         16#DF#           =>  --  31DF
          (0, 0, 13116, 13116),
         16#E0#           =>  --  31E0
          (0, 0, 13117, 13117),
         16#E1#           =>  --  31E1
          (0, 0, 13118, 13118),
         16#E2#           =>  --  31E2
          (0, 0, 13119, 13119),
         16#E3#           =>  --  31E3
          (0, 0, 13120, 13120),
         16#F0#           =>  --  31F0
          (0, 0, 13121, 13121),
         16#F1#           =>  --  31F1
          (0, 0, 13122, 13122),
         16#F2#           =>  --  31F2
          (0, 0, 13123, 13123),
         16#F3#           =>  --  31F3
          (0, 0, 13124, 13124),
         16#F4#           =>  --  31F4
          (0, 0, 13125, 13125),
         16#F5#           =>  --  31F5
          (0, 0, 13126, 13126),
         16#F6#           =>  --  31F6
          (0, 0, 13127, 13127),
         16#F7#           =>  --  31F7
          (0, 0, 13128, 13128),
         16#F8#           =>  --  31F8
          (0, 0, 13129, 13129),
         16#F9#           =>  --  31F9
          (0, 0, 13130, 13130),
         16#FA#           =>  --  31FA
          (0, 0, 13131, 13131),
         16#FB#           =>  --  31FB
          (0, 0, 13132, 13132),
         16#FC#           =>  --  31FC
          (0, 0, 13133, 13133),
         16#FD#           =>  --  31FD
          (0, 0, 13134, 13134),
         16#FE#           =>  --  31FE
          (0, 0, 13135, 13135),
         16#FF#           =>  --  31FF
          (0, 0, 13136, 13136),
         others           =>
          (0, 0, 0, 0));

   Group_0032 : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  3200
          (0, 0, 13137, 13139),
         16#01#           =>  --  3201
          (0, 0, 13140, 13142),
         16#02#           =>  --  3202
          (0, 0, 13143, 13145),
         16#03#           =>  --  3203
          (0, 0, 13146, 13148),
         16#04#           =>  --  3204
          (0, 0, 13149, 13151),
         16#05#           =>  --  3205
          (0, 0, 13152, 13154),
         16#06#           =>  --  3206
          (0, 0, 13155, 13157),
         16#07#           =>  --  3207
          (0, 0, 13158, 13160),
         16#08#           =>  --  3208
          (0, 0, 13161, 13163),
         16#09#           =>  --  3209
          (0, 0, 13164, 13166),
         16#0A#           =>  --  320A
          (0, 0, 13167, 13169),
         16#0B#           =>  --  320B
          (0, 0, 13170, 13172),
         16#0C#           =>  --  320C
          (0, 0, 13173, 13175),
         16#0D#           =>  --  320D
          (0, 0, 13176, 13178),
         16#0E#           =>  --  320E
          (0, 0, 13179, 13182),
         16#0F#           =>  --  320F
          (0, 0, 13183, 13186),
         16#10#           =>  --  3210
          (0, 0, 13187, 13190),
         16#11#           =>  --  3211
          (0, 0, 13191, 13194),
         16#12#           =>  --  3212
          (0, 0, 13195, 13198),
         16#13#           =>  --  3213
          (0, 0, 13199, 13202),
         16#14#           =>  --  3214
          (0, 0, 13203, 13206),
         16#15#           =>  --  3215
          (0, 0, 13207, 13210),
         16#16#           =>  --  3216
          (0, 0, 13211, 13214),
         16#17#           =>  --  3217
          (0, 0, 13215, 13218),
         16#18#           =>  --  3218
          (0, 0, 13219, 13222),
         16#19#           =>  --  3219
          (0, 0, 13223, 13226),
         16#1A#           =>  --  321A
          (0, 0, 13227, 13230),
         16#1B#           =>  --  321B
          (0, 0, 13231, 13234),
         16#1C#           =>  --  321C
          (0, 0, 13235, 13238),
         16#1D#           =>  --  321D
          (0, 0, 13239, 13245),
         16#1E#           =>  --  321E
          (0, 0, 13246, 13251),
         16#1F#           =>  --  321F
          (0, 0, 0, 0),
         16#20#           =>  --  3220
          (0, 0, 13252, 13255),
         16#21#           =>  --  3221
          (0, 0, 13256, 13259),
         16#22#           =>  --  3222
          (0, 0, 13260, 13263),
         16#23#           =>  --  3223
          (0, 0, 13264, 13267),
         16#24#           =>  --  3224
          (0, 0, 13268, 13271),
         16#25#           =>  --  3225
          (0, 0, 13272, 13275),
         16#26#           =>  --  3226
          (0, 0, 13276, 13279),
         16#27#           =>  --  3227
          (0, 0, 13280, 13283),
         16#28#           =>  --  3228
          (0, 0, 13284, 13287),
         16#29#           =>  --  3229
          (0, 0, 13288, 13291),
         16#2A#           =>  --  322A
          (0, 0, 13292, 13295),
         16#2B#           =>  --  322B
          (0, 0, 13296, 13299),
         16#2C#           =>  --  322C
          (0, 0, 13300, 13303),
         16#2D#           =>  --  322D
          (0, 0, 13304, 13307),
         16#2E#           =>  --  322E
          (0, 0, 13308, 13311),
         16#2F#           =>  --  322F
          (0, 0, 13312, 13315),
         16#30#           =>  --  3230
          (0, 0, 13316, 13319),
         16#31#           =>  --  3231
          (0, 0, 13320, 13323),
         16#32#           =>  --  3232
          (0, 0, 13324, 13327),
         16#33#           =>  --  3233
          (0, 0, 13328, 13331),
         16#34#           =>  --  3234
          (0, 0, 13332, 13335),
         16#35#           =>  --  3235
          (0, 0, 13336, 13339),
         16#36#           =>  --  3236
          (0, 0, 13340, 13343),
         16#37#           =>  --  3237
          (0, 0, 13344, 13347),
         16#38#           =>  --  3238
          (0, 0, 13348, 13351),
         16#39#           =>  --  3239
          (0, 0, 13352, 13355),
         16#3A#           =>  --  323A
          (0, 0, 13356, 13359),
         16#3B#           =>  --  323B
          (0, 0, 13360, 13363),
         16#3C#           =>  --  323C
          (0, 0, 13364, 13367),
         16#3D#           =>  --  323D
          (0, 0, 13368, 13371),
         16#3E#           =>  --  323E
          (0, 0, 13372, 13375),
         16#3F#           =>  --  323F
          (0, 0, 13376, 13379),
         16#40#           =>  --  3240
          (0, 0, 13380, 13383),
         16#41#           =>  --  3241
          (0, 0, 13384, 13387),
         16#42#           =>  --  3242
          (0, 0, 13388, 13391),
         16#43#           =>  --  3243
          (0, 0, 13392, 13395),
         16#44#           =>  --  3244
          (0, 0, 13396, 13397),
         16#45#           =>  --  3245
          (0, 0, 13398, 13399),
         16#46#           =>  --  3246
          (0, 0, 13400, 13401),
         16#47#           =>  --  3247
          (0, 0, 13402, 13403),
         16#48#           =>  --  3248
          (0, 0, 9434, 9435),
         16#49#           =>  --  3249
          (0, 0, 9452, 9453),
         16#4B#           =>  --  324B
          (0, 0, 13406, 13407),
         16#4C#           =>  --  324C
          (0, 0, 13408, 13409),
         16#4D#           =>  --  324D
          (0, 0, 13410, 13411),
         16#4E#           =>  --  324E
          (0, 0, 13412, 13413),
         16#4F#           =>  --  324F
          (0, 0, 13414, 13415),
         16#50#           =>  --  3250
          (0, 0, 13416, 13418),
         16#51#           =>  --  3251
          (0, 0, 13419, 13420),
         16#52#           =>  --  3252
          (0, 0, 13421, 13422),
         16#53#           =>  --  3253
          (0, 0, 9426, 9427),
         16#54#           =>  --  3254
          (0, 0, 13423, 13424),
         16#55#           =>  --  3255
          (0, 0, 13425, 13426),
         16#56#           =>  --  3256
          (0, 0, 13427, 13428),
         16#57#           =>  --  3257
          (0, 0, 13429, 13430),
         16#58#           =>  --  3258
          (0, 0, 13431, 13432),
         16#59#           =>  --  3259
          (0, 0, 13433, 13434),
         16#5B#           =>  --  325B
          (0, 0, 9439, 9440),
         16#5C#           =>  --  325C
          (0, 0, 13435, 13436),
         16#5D#           =>  --  325D
          (0, 0, 13437, 13438),
         16#5E#           =>  --  325E
          (0, 0, 9427, 9428),
         16#5F#           =>  --  325F
          (0, 0, 13439, 13440),
         16#60#           =>  --  3260
          (0, 0, 13441, 13441),
         16#61#           =>  --  3261
          (0, 0, 13442, 13442),
         16#62#           =>  --  3262
          (0, 0, 13443, 13443),
         16#63#           =>  --  3263
          (0, 0, 13444, 13444),
         16#64#           =>  --  3264
          (0, 0, 13445, 13445),
         16#65#           =>  --  3265
          (0, 0, 13446, 13446),
         16#66#           =>  --  3266
          (0, 0, 13447, 13447),
         16#67#           =>  --  3267
          (0, 0, 13448, 13448),
         16#68#           =>  --  3268
          (0, 0, 13449, 13449),
         16#69#           =>  --  3269
          (0, 0, 13450, 13450),
         16#6A#           =>  --  326A
          (0, 0, 13451, 13451),
         16#6B#           =>  --  326B
          (0, 0, 13452, 13452),
         16#6C#           =>  --  326C
          (0, 0, 13453, 13453),
         16#6D#           =>  --  326D
          (0, 0, 13454, 13454),
         16#6E#           =>  --  326E
          (0, 0, 13455, 13456),
         16#6F#           =>  --  326F
          (0, 0, 13457, 13458),
         16#70#           =>  --  3270
          (0, 0, 13459, 13460),
         16#71#           =>  --  3271
          (0, 0, 13461, 13462),
         16#72#           =>  --  3272
          (0, 0, 13463, 13464),
         16#73#           =>  --  3273
          (0, 0, 13465, 13466),
         16#74#           =>  --  3274
          (0, 0, 13467, 13468),
         16#75#           =>  --  3275
          (0, 0, 13469, 13470),
         16#76#           =>  --  3276
          (0, 0, 13471, 13472),
         16#77#           =>  --  3277
          (0, 0, 13473, 13474),
         16#78#           =>  --  3278
          (0, 0, 13475, 13476),
         16#79#           =>  --  3279
          (0, 0, 13477, 13478),
         16#7A#           =>  --  327A
          (0, 0, 13479, 13480),
         16#7B#           =>  --  327B
          (0, 0, 13481, 13482),
         16#7C#           =>  --  327C
          (0, 0, 13483, 13487),
         16#7D#           =>  --  327D
          (0, 0, 13488, 13491),
         16#7E#           =>  --  327E
          (0, 0, 13492, 13493),
         16#7F#           =>  --  327F
          (0, 0, 13494, 13494),
         16#80#           =>  --  3280
          (0, 0, 13495, 13496),
         16#81#           =>  --  3281
          (0, 0, 13497, 13498),
         16#82#           =>  --  3282
          (0, 0, 13499, 13500),
         16#83#           =>  --  3283
          (0, 0, 13501, 13502),
         16#84#           =>  --  3284
          (0, 0, 13503, 13504),
         16#85#           =>  --  3285
          (0, 0, 13505, 13506),
         16#86#           =>  --  3286
          (0, 0, 13507, 13508),
         16#87#           =>  --  3287
          (0, 0, 13509, 13510),
         16#88#           =>  --  3288
          (0, 0, 13511, 13512),
         16#89#           =>  --  3289
          (0, 0, 13513, 13514),
         16#8A#           =>  --  328A
          (0, 0, 13515, 13516),
         16#8B#           =>  --  328B
          (0, 0, 13517, 13518),
         16#8C#           =>  --  328C
          (0, 0, 13519, 13520),
         16#8D#           =>  --  328D
          (0, 0, 13521, 13522),
         16#8E#           =>  --  328E
          (0, 0, 13523, 13524),
         16#8F#           =>  --  328F
          (0, 0, 13525, 13526),
         16#90#           =>  --  3290
          (0, 0, 13527, 13528),
         16#91#           =>  --  3291
          (0, 0, 13529, 13530),
         16#92#           =>  --  3292
          (0, 0, 13531, 13532),
         16#93#           =>  --  3293
          (0, 0, 13533, 13534),
         16#94#           =>  --  3294
          (0, 0, 13535, 13536),
         16#95#           =>  --  3295
          (0, 0, 13537, 13538),
         16#96#           =>  --  3296
          (0, 0, 13539, 13540),
         16#97#           =>  --  3297
          (0, 0, 13541, 13542),
         16#98#           =>  --  3298
          (0, 0, 13543, 13544),
         16#99#           =>  --  3299
          (0, 0, 13545, 13546),
         16#9A#           =>  --  329A
          (0, 0, 13547, 13548),
         16#9B#           =>  --  329B
          (0, 0, 13549, 13550),
         16#9C#           =>  --  329C
          (0, 0, 13551, 13552),
         16#9D#           =>  --  329D
          (0, 0, 13553, 13554),
         16#9E#           =>  --  329E
          (0, 0, 13555, 13556),
         16#9F#           =>  --  329F
          (0, 0, 13557, 13558),
         16#A0#           =>  --  32A0
          (0, 0, 13559, 13560),
         16#A1#           =>  --  32A1
          (0, 0, 13561, 13562),
         16#A2#           =>  --  32A2
          (0, 0, 13563, 13564),
         16#A3#           =>  --  32A3
          (0, 0, 13565, 13566),
         16#A4#           =>  --  32A4
          (0, 0, 13567, 13568),
         16#A5#           =>  --  32A5
          (0, 0, 13569, 13570),
         16#A6#           =>  --  32A6
          (0, 0, 13571, 13572),
         16#A7#           =>  --  32A7
          (0, 0, 13573, 13574),
         16#A8#           =>  --  32A8
          (0, 0, 13575, 13576),
         16#A9#           =>  --  32A9
          (0, 0, 13577, 13578),
         16#AA#           =>  --  32AA
          (0, 0, 13579, 13580),
         16#AB#           =>  --  32AB
          (0, 0, 13581, 13582),
         16#AC#           =>  --  32AC
          (0, 0, 13583, 13584),
         16#AD#           =>  --  32AD
          (0, 0, 13585, 13586),
         16#AE#           =>  --  32AE
          (0, 0, 13587, 13588),
         16#AF#           =>  --  32AF
          (0, 0, 13589, 13590),
         16#B0#           =>  --  32B0
          (0, 0, 13591, 13592),
         16#B1#           =>  --  32B1
          (0, 0, 13593, 13594),
         16#B2#           =>  --  32B2
          (0, 0, 13595, 13596),
         16#B3#           =>  --  32B3
          (0, 0, 13597, 13598),
         16#B4#           =>  --  32B4
          (0, 0, 13599, 13600),
         16#B5#           =>  --  32B5
          (0, 0, 13406, 13407),
         16#B6#           =>  --  32B6
          (0, 0, 9441, 9442),
         16#B7#           =>  --  32B7
          (0, 0, 13424, 13425),
         16#B8#           =>  --  32B8
          (0, 0, 13601, 13602),
         16#B9#           =>  --  32B9
          (0, 0, 13603, 13604),
         16#BA#           =>  --  32BA
          (0, 0, 9428, 9429),
         16#BB#           =>  --  32BB
          (0, 0, 13605, 13606),
         16#BC#           =>  --  32BC
          (0, 0, 13607, 13608),
         16#BD#           =>  --  32BD
          (0, 0, 13609, 13610),
         16#BE#           =>  --  32BE
          (0, 0, 13611, 13612),
         16#BF#           =>  --  32BF
          (0, 0, 13408, 13409),
         16#C0#           =>  --  32C0
          (0, 0, 13613, 13615),
         16#C1#           =>  --  32C1
          (0, 0, 13616, 13618),
         16#C2#           =>  --  32C2
          (0, 0, 13619, 13621),
         16#C3#           =>  --  32C3
          (0, 0, 13622, 13624),
         16#C4#           =>  --  32C4
          (0, 0, 13625, 13627),
         16#C5#           =>  --  32C5
          (0, 0, 13628, 13630),
         16#C6#           =>  --  32C6
          (0, 0, 13631, 13633),
         16#C7#           =>  --  32C7
          (0, 0, 13634, 13636),
         16#C8#           =>  --  32C8
          (0, 0, 13637, 13639),
         16#C9#           =>  --  32C9
          (0, 0, 13640, 13643),
         16#CA#           =>  --  32CA
          (0, 0, 13644, 13647),
         16#CB#           =>  --  32CB
          (0, 0, 13648, 13651),
         16#CC#           =>  --  32CC
          (0, 0, 13652, 13653),
         16#CD#           =>  --  32CD
          (0, 0, 13654, 13656),
         16#CE#           =>  --  32CE
          (0, 0, 13657, 13658),
         16#CF#           =>  --  32CF
          (0, 0, 13659, 13661),
         16#D0#           =>  --  32D0
          (0, 0, 13662, 13662),
         16#D1#           =>  --  32D1
          (0, 0, 13663, 13663),
         16#D2#           =>  --  32D2
          (0, 0, 13664, 13664),
         16#D3#           =>  --  32D3
          (0, 0, 13665, 13665),
         16#D4#           =>  --  32D4
          (0, 0, 13666, 13666),
         16#D5#           =>  --  32D5
          (0, 0, 13667, 13667),
         16#D6#           =>  --  32D6
          (0, 0, 13668, 13668),
         16#D7#           =>  --  32D7
          (0, 0, 13669, 13669),
         16#D8#           =>  --  32D8
          (0, 0, 13670, 13670),
         16#D9#           =>  --  32D9
          (0, 0, 13671, 13671),
         16#DA#           =>  --  32DA
          (0, 0, 13672, 13672),
         16#DB#           =>  --  32DB
          (0, 0, 13673, 13673),
         16#DC#           =>  --  32DC
          (0, 0, 13674, 13674),
         16#DD#           =>  --  32DD
          (0, 0, 13675, 13675),
         16#DE#           =>  --  32DE
          (0, 0, 13676, 13676),
         16#DF#           =>  --  32DF
          (0, 0, 13677, 13677),
         16#E0#           =>  --  32E0
          (0, 0, 13678, 13678),
         16#E1#           =>  --  32E1
          (0, 0, 13679, 13679),
         16#E2#           =>  --  32E2
          (0, 0, 13680, 13680),
         16#E3#           =>  --  32E3
          (0, 0, 13681, 13681),
         16#E4#           =>  --  32E4
          (0, 0, 13682, 13682),
         16#E5#           =>  --  32E5
          (0, 0, 13683, 13683),
         16#E6#           =>  --  32E6
          (0, 0, 13684, 13684),
         16#E7#           =>  --  32E7
          (0, 0, 13685, 13685),
         16#E8#           =>  --  32E8
          (0, 0, 13686, 13686),
         16#E9#           =>  --  32E9
          (0, 0, 13687, 13687),
         16#EA#           =>  --  32EA
          (0, 0, 13688, 13688),
         16#EB#           =>  --  32EB
          (0, 0, 13689, 13689),
         16#EC#           =>  --  32EC
          (0, 0, 13690, 13690),
         16#ED#           =>  --  32ED
          (0, 0, 13691, 13691),
         16#EE#           =>  --  32EE
          (0, 0, 13692, 13692),
         16#EF#           =>  --  32EF
          (0, 0, 13693, 13693),
         16#F0#           =>  --  32F0
          (0, 0, 13694, 13694),
         16#F1#           =>  --  32F1
          (0, 0, 13695, 13695),
         16#F2#           =>  --  32F2
          (0, 0, 13696, 13696),
         16#F3#           =>  --  32F3
          (0, 0, 13697, 13697),
         16#F4#           =>  --  32F4
          (0, 0, 13698, 13698),
         16#F5#           =>  --  32F5
          (0, 0, 13699, 13699),
         16#F6#           =>  --  32F6
          (0, 0, 13700, 13700),
         16#F7#           =>  --  32F7
          (0, 0, 13701, 13701),
         16#F8#           =>  --  32F8
          (0, 0, 13702, 13702),
         16#F9#           =>  --  32F9
          (0, 0, 13703, 13703),
         16#FA#           =>  --  32FA
          (0, 0, 13704, 13704),
         16#FB#           =>  --  32FB
          (0, 0, 13705, 13705),
         16#FC#           =>  --  32FC
          (0, 0, 13706, 13706),
         16#FD#           =>  --  32FD
          (0, 0, 13707, 13707),
         16#FE#           =>  --  32FE
          (0, 0, 13708, 13708),
         16#FF#           =>  --  32FF
          (0, 0, 0, 0),
         others           =>
          (0, 0, 13404, 13405));

   Group_0033 : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  3300
          (0, 0, 13709, 13713),
         16#01#           =>  --  3301
          (0, 0, 13714, 13717),
         16#02#           =>  --  3302
          (0, 0, 13718, 13722),
         16#03#           =>  --  3303
          (0, 0, 13723, 13725),
         16#04#           =>  --  3304
          (0, 0, 13726, 13730),
         16#05#           =>  --  3305
          (0, 0, 13731, 13733),
         16#06#           =>  --  3306
          (0, 0, 13734, 13736),
         16#07#           =>  --  3307
          (0, 0, 13737, 13742),
         16#08#           =>  --  3308
          (0, 0, 13743, 13746),
         16#09#           =>  --  3309
          (0, 0, 13747, 13749),
         16#0A#           =>  --  330A
          (0, 0, 13750, 13752),
         16#0B#           =>  --  330B
          (0, 0, 13753, 13755),
         16#0C#           =>  --  330C
          (0, 0, 13756, 13759),
         16#0D#           =>  --  330D
          (0, 0, 13760, 13763),
         16#0E#           =>  --  330E
          (0, 0, 13764, 13767),
         16#0F#           =>  --  330F
          (0, 0, 13768, 13771),
         16#10#           =>  --  3310
          (0, 0, 13772, 13775),
         16#11#           =>  --  3311
          (0, 0, 13776, 13779),
         16#12#           =>  --  3312
          (0, 0, 13780, 13783),
         16#13#           =>  --  3313
          (0, 0, 13784, 13789),
         16#14#           =>  --  3314
          (0, 0, 13790, 13791),
         16#15#           =>  --  3315
          (0, 0, 13792, 13797),
         16#16#           =>  --  3316
          (0, 0, 13798, 13803),
         16#17#           =>  --  3317
          (0, 0, 13804, 13808),
         16#18#           =>  --  3318
          (0, 0, 13794, 13797),
         16#19#           =>  --  3319
          (0, 0, 13809, 13814),
         16#1A#           =>  --  331A
          (0, 0, 13815, 13820),
         16#1B#           =>  --  331B
          (0, 0, 13821, 13824),
         16#1C#           =>  --  331C
          (0, 0, 13825, 13827),
         16#1D#           =>  --  331D
          (0, 0, 13828, 13830),
         16#1E#           =>  --  331E
          (0, 0, 13831, 13834),
         16#1F#           =>  --  331F
          (0, 0, 13835, 13838),
         16#20#           =>  --  3320
          (0, 0, 13839, 13843),
         16#21#           =>  --  3321
          (0, 0, 13844, 13848),
         16#22#           =>  --  3322
          (0, 0, 13849, 13851),
         16#23#           =>  --  3323
          (0, 0, 13852, 13854),
         16#24#           =>  --  3324
          (0, 0, 13855, 13858),
         16#25#           =>  --  3325
          (0, 0, 13859, 13861),
         16#26#           =>  --  3326
          (0, 0, 13862, 13864),
         16#27#           =>  --  3327
          (0, 0, 13813, 13814),
         16#28#           =>  --  3328
          (0, 0, 13865, 13866),
         16#29#           =>  --  3329
          (0, 0, 13867, 13869),
         16#2A#           =>  --  332A
          (0, 0, 13870, 13872),
         16#2B#           =>  --  332B
          (0, 0, 13873, 13878),
         16#2C#           =>  --  332C
          (0, 0, 13879, 13882),
         16#2D#           =>  --  332D
          (0, 0, 13883, 13887),
         16#2E#           =>  --  332E
          (0, 0, 13888, 13893),
         16#2F#           =>  --  332F
          (0, 0, 13894, 13897),
         16#30#           =>  --  3330
          (0, 0, 13898, 13900),
         16#31#           =>  --  3331
          (0, 0, 13901, 13903),
         16#32#           =>  --  3332
          (0, 0, 13904, 13909),
         16#33#           =>  --  3333
          (0, 0, 13910, 13913),
         16#34#           =>  --  3334
          (0, 0, 13914, 13919),
         16#35#           =>  --  3335
          (0, 0, 13920, 13922),
         16#36#           =>  --  3336
          (0, 0, 13923, 13927),
         16#37#           =>  --  3337
          (0, 0, 13928, 13930),
         16#38#           =>  --  3338
          (0, 0, 13931, 13934),
         16#39#           =>  --  3339
          (0, 0, 13935, 13937),
         16#3A#           =>  --  333A
          (0, 0, 13938, 13941),
         16#3B#           =>  --  333B
          (0, 0, 13942, 13946),
         16#3C#           =>  --  333C
          (0, 0, 13947, 13950),
         16#3D#           =>  --  333D
          (0, 0, 13951, 13955),
         16#3E#           =>  --  333E
          (0, 0, 13956, 13959),
         16#3F#           =>  --  333F
          (0, 0, 13960, 13961),
         16#40#           =>  --  3340
          (0, 0, 13962, 13966),
         16#41#           =>  --  3341
          (0, 0, 13967, 13969),
         16#42#           =>  --  3342
          (0, 0, 13970, 13972),
         16#43#           =>  --  3343
          (0, 0, 13973, 13976),
         16#44#           =>  --  3344
          (0, 0, 13977, 13979),
         16#45#           =>  --  3345
          (0, 0, 13980, 13982),
         16#46#           =>  --  3346
          (0, 0, 13983, 13985),
         16#47#           =>  --  3347
          (0, 0, 13986, 13990),
         16#48#           =>  --  3348
          (0, 0, 13991, 13994),
         16#49#           =>  --  3349
          (0, 0, 13995, 13996),
         16#4A#           =>  --  334A
          (0, 0, 13997, 14002),
         16#4B#           =>  --  334B
          (0, 0, 14003, 14005),
         16#4C#           =>  --  334C
          (0, 0, 14006, 14010),
         16#4D#           =>  --  334D
          (0, 0, 13800, 13803),
         16#4E#           =>  --  334E
          (0, 0, 14011, 14014),
         16#4F#           =>  --  334F
          (0, 0, 14015, 14017),
         16#50#           =>  --  3350
          (0, 0, 14018, 14020),
         16#51#           =>  --  3351
          (0, 0, 14021, 14024),
         16#52#           =>  --  3352
          (0, 0, 14025, 14026),
         16#53#           =>  --  3353
          (0, 0, 14027, 14030),
         16#54#           =>  --  3354
          (0, 0, 14031, 14035),
         16#55#           =>  --  3355
          (0, 0, 14036, 14037),
         16#56#           =>  --  3356
          (0, 0, 14038, 14043),
         16#57#           =>  --  3357
          (0, 0, 13806, 13808),
         16#58#           =>  --  3358
          (0, 0, 14044, 14046),
         16#59#           =>  --  3359
          (0, 0, 14047, 14049),
         16#5A#           =>  --  335A
          (0, 0, 14050, 14052),
         16#5B#           =>  --  335B
          (0, 0, 14053, 14055),
         16#5C#           =>  --  335C
          (0, 0, 14056, 14058),
         16#5D#           =>  --  335D
          (0, 0, 14059, 14061),
         16#5E#           =>  --  335E
          (0, 0, 14062, 14064),
         16#5F#           =>  --  335F
          (0, 0, 14065, 14067),
         16#60#           =>  --  3360
          (0, 0, 14068, 14070),
         16#61#           =>  --  3361
          (0, 0, 14071, 14073),
         16#62#           =>  --  3362
          (0, 0, 14074, 14077),
         16#63#           =>  --  3363
          (0, 0, 14078, 14081),
         16#64#           =>  --  3364
          (0, 0, 14082, 14085),
         16#65#           =>  --  3365
          (0, 0, 14086, 14089),
         16#66#           =>  --  3366
          (0, 0, 14090, 14093),
         16#67#           =>  --  3367
          (0, 0, 14094, 14097),
         16#68#           =>  --  3368
          (0, 0, 14098, 14101),
         16#69#           =>  --  3369
          (0, 0, 14102, 14105),
         16#6A#           =>  --  336A
          (0, 0, 14106, 14109),
         16#6B#           =>  --  336B
          (0, 0, 14110, 14113),
         16#6C#           =>  --  336C
          (0, 0, 14114, 14117),
         16#6D#           =>  --  336D
          (0, 0, 14118, 14121),
         16#6E#           =>  --  336E
          (0, 0, 14122, 14125),
         16#6F#           =>  --  336F
          (0, 0, 14126, 14129),
         16#70#           =>  --  3370
          (0, 0, 14130, 14133),
         16#71#           =>  --  3371
          (0, 0, 14134, 14136),
         16#72#           =>  --  3372
          (0, 0, 14137, 14138),
         16#73#           =>  --  3373
          (0, 0, 14139, 14140),
         16#74#           =>  --  3374
          (0, 0, 14141, 14143),
         16#75#           =>  --  3375
          (0, 0, 14144, 14145),
         16#76#           =>  --  3376
          (0, 0, 14146, 14147),
         16#77#           =>  --  3377
          (0, 0, 14148, 14149),
         16#78#           =>  --  3378
          (0, 0, 14150, 14152),
         16#79#           =>  --  3379
          (0, 0, 14153, 14155),
         16#7A#           =>  --  337A
          (0, 0, 14156, 14157),
         16#7B#           =>  --  337B
          (0, 0, 14158, 14161),
         16#7C#           =>  --  337C
          (0, 0, 14162, 14165),
         16#7D#           =>  --  337D
          (0, 0, 14166, 14169),
         16#7E#           =>  --  337E
          (0, 0, 14170, 14173),
         16#7F#           =>  --  337F
          (0, 0, 14174, 14181),
         16#80#           =>  --  3380
          (0, 0, 14182, 14183),
         16#81#           =>  --  3381
          (0, 0, 14184, 14185),
         16#82#           =>  --  3382
          (0, 0, 14186, 14187),
         16#83#           =>  --  3383
          (0, 0, 14188, 14189),
         16#84#           =>  --  3384
          (0, 0, 14190, 14191),
         16#85#           =>  --  3385
          (0, 0, 14192, 14193),
         16#86#           =>  --  3386
          (0, 0, 14194, 14195),
         16#87#           =>  --  3387
          (0, 0, 14196, 14197),
         16#88#           =>  --  3388
          (0, 0, 14198, 14200),
         16#89#           =>  --  3389
          (0, 0, 14201, 14204),
         16#8A#           =>  --  338A
          (0, 0, 14205, 14206),
         16#8B#           =>  --  338B
          (0, 0, 14207, 14208),
         16#8C#           =>  --  338C
          (0, 0, 14209, 14210),
         16#8D#           =>  --  338D
          (0, 0, 14211, 14212),
         16#8E#           =>  --  338E
          (0, 0, 14213, 14214),
         16#8F#           =>  --  338F
          (0, 0, 14215, 14216),
         16#90#           =>  --  3390
          (0, 0, 14217, 14218),
         16#91#           =>  --  3391
          (0, 0, 14219, 14221),
         16#92#           =>  --  3392
          (0, 0, 14222, 14224),
         16#93#           =>  --  3393
          (0, 0, 14225, 14227),
         16#94#           =>  --  3394
          (0, 0, 14228, 14230),
         16#95#           =>  --  3395
          (0, 0, 14231, 14232),
         16#96#           =>  --  3396
          (0, 0, 14233, 14234),
         16#97#           =>  --  3397
          (0, 0, 14235, 14236),
         16#98#           =>  --  3398
          (0, 0, 14237, 14238),
         16#99#           =>  --  3399
          (0, 0, 14239, 14240),
         16#9A#           =>  --  339A
          (0, 0, 14241, 14242),
         16#9B#           =>  --  339B
          (0, 0, 14243, 14244),
         16#9C#           =>  --  339C
          (0, 0, 14245, 14246),
         16#9D#           =>  --  339D
          (0, 0, 14247, 14248),
         16#9E#           =>  --  339E
          (0, 0, 14249, 14250),
         16#9F#           =>  --  339F
          (0, 0, 14251, 14253),
         16#A0#           =>  --  33A0
          (0, 0, 14254, 14256),
         16#A1#           =>  --  33A1
          (0, 0, 14151, 14152),
         16#A2#           =>  --  33A2
          (0, 0, 14257, 14259),
         16#A3#           =>  --  33A3
          (0, 0, 14260, 14262),
         16#A4#           =>  --  33A4
          (0, 0, 14263, 14265),
         16#A5#           =>  --  33A5
          (0, 0, 14154, 14155),
         16#A6#           =>  --  33A6
          (0, 0, 14266, 14268),
         16#A7#           =>  --  33A7
          (0, 0, 14269, 14271),
         16#A8#           =>  --  33A8
          (0, 0, 14272, 14275),
         16#A9#           =>  --  33A9
          (0, 0, 14135, 14136),
         16#AA#           =>  --  33AA
          (0, 0, 14276, 14278),
         16#AB#           =>  --  33AB
          (0, 0, 14279, 14281),
         16#AC#           =>  --  33AC
          (0, 0, 14282, 14284),
         16#AD#           =>  --  33AD
          (0, 0, 14285, 14287),
         16#AE#           =>  --  33AE
          (0, 0, 14288, 14292),
         16#AF#           =>  --  33AF
          (0, 0, 14293, 14298),
         16#B0#           =>  --  33B0
          (0, 0, 14299, 14300),
         16#B1#           =>  --  33B1
          (0, 0, 14301, 14302),
         16#B2#           =>  --  33B2
          (0, 0, 14303, 14304),
         16#B3#           =>  --  33B3
          (0, 0, 14305, 14306),
         16#B4#           =>  --  33B4
          (0, 0, 14307, 14308),
         16#B5#           =>  --  33B5
          (0, 0, 14309, 14310),
         16#B6#           =>  --  33B6
          (0, 0, 14311, 14312),
         16#B7#           =>  --  33B7
          (0, 0, 14313, 14314),
         16#B8#           =>  --  33B8
          (0, 0, 14315, 14316),
         16#B9#           =>  --  33B9
          (0, 0, 14317, 14318),
         16#BA#           =>  --  33BA
          (0, 0, 14319, 14320),
         16#BB#           =>  --  33BB
          (0, 0, 14321, 14322),
         16#BC#           =>  --  33BC
          (0, 0, 14323, 14324),
         16#BD#           =>  --  33BD
          (0, 0, 14325, 14326),
         16#BE#           =>  --  33BE
          (0, 0, 14327, 14328),
         16#BF#           =>  --  33BF
          (0, 0, 14329, 14330),
         16#C0#           =>  --  33C0
          (0, 0, 14331, 14332),
         16#C1#           =>  --  33C1
          (0, 0, 14333, 14334),
         16#C2#           =>  --  33C2
          (0, 0, 14335, 14338),
         16#C3#           =>  --  33C3
          (0, 0, 14339, 14340),
         16#C4#           =>  --  33C4
          (0, 0, 14341, 14342),
         16#C5#           =>  --  33C5
          (0, 0, 14147, 14148),
         16#C6#           =>  --  33C6
          (0, 0, 14343, 14346),
         16#C7#           =>  --  33C7
          (0, 0, 14347, 14349),
         16#C8#           =>  --  33C8
          (0, 0, 14350, 14351),
         16#C9#           =>  --  33C9
          (0, 0, 14352, 14353),
         16#CA#           =>  --  33CA
          (0, 0, 14354, 14355),
         16#CB#           =>  --  33CB
          (0, 0, 14356, 14357),
         16#CC#           =>  --  33CC
          (0, 0, 14358, 14359),
         16#CD#           =>  --  33CD
          (0, 0, 14360, 14361),
         16#CE#           =>  --  33CE
          (0, 0, 14362, 14363),
         16#CF#           =>  --  33CF
          (0, 0, 14364, 14365),
         16#D0#           =>  --  33D0
          (0, 0, 14232, 14233),
         16#D1#           =>  --  33D1
          (0, 0, 14366, 14367),
         16#D2#           =>  --  33D2
          (0, 0, 14368, 14370),
         16#D3#           =>  --  33D3
          (0, 0, 14371, 14372),
         16#D4#           =>  --  33D4
          (0, 0, 14373, 14374),
         16#D5#           =>  --  33D5
          (0, 0, 14375, 14377),
         16#D6#           =>  --  33D6
          (0, 0, 14378, 14380),
         16#D7#           =>  --  33D7
          (0, 0, 14381, 14382),
         16#D8#           =>  --  33D8
          (0, 0, 14383, 14386),
         16#D9#           =>  --  33D9
          (0, 0, 14387, 14389),
         16#DA#           =>  --  33DA
          (0, 0, 7002, 7003),
         16#DB#           =>  --  33DB
          (0, 0, 14292, 14293),
         16#DC#           =>  --  33DC
          (0, 0, 14390, 14391),
         16#DD#           =>  --  33DD
          (0, 0, 14392, 14393),
         16#DE#           =>  --  33DE
          (0, 0, 14394, 14396),
         16#DF#           =>  --  33DF
          (0, 0, 14397, 14399),
         16#E0#           =>  --  33E0
          (0, 0, 14400, 14402),
         16#E1#           =>  --  33E1
          (0, 0, 14403, 14405),
         16#E2#           =>  --  33E2
          (0, 0, 14406, 14408),
         16#E3#           =>  --  33E3
          (0, 0, 14409, 14411),
         16#E4#           =>  --  33E4
          (0, 0, 14412, 14414),
         16#E5#           =>  --  33E5
          (0, 0, 14415, 14417),
         16#E6#           =>  --  33E6
          (0, 0, 14418, 14420),
         16#E7#           =>  --  33E7
          (0, 0, 14421, 14423),
         16#E8#           =>  --  33E8
          (0, 0, 14424, 14426),
         16#E9#           =>  --  33E9
          (0, 0, 14427, 14430),
         16#EA#           =>  --  33EA
          (0, 0, 14431, 14434),
         16#EB#           =>  --  33EB
          (0, 0, 14435, 14438),
         16#EC#           =>  --  33EC
          (0, 0, 14439, 14442),
         16#ED#           =>  --  33ED
          (0, 0, 14443, 14446),
         16#EE#           =>  --  33EE
          (0, 0, 14447, 14450),
         16#EF#           =>  --  33EF
          (0, 0, 14451, 14454),
         16#F0#           =>  --  33F0
          (0, 0, 14455, 14458),
         16#F1#           =>  --  33F1
          (0, 0, 14459, 14462),
         16#F2#           =>  --  33F2
          (0, 0, 14463, 14466),
         16#F3#           =>  --  33F3
          (0, 0, 14467, 14470),
         16#F4#           =>  --  33F4
          (0, 0, 14471, 14474),
         16#F5#           =>  --  33F5
          (0, 0, 14475, 14478),
         16#F6#           =>  --  33F6
          (0, 0, 14479, 14482),
         16#F7#           =>  --  33F7
          (0, 0, 14483, 14486),
         16#F8#           =>  --  33F8
          (0, 0, 14487, 14490),
         16#F9#           =>  --  33F9
          (0, 0, 14491, 14494),
         16#FA#           =>  --  33FA
          (0, 0, 14495, 14498),
         16#FB#           =>  --  33FB
          (0, 0, 14499, 14502),
         16#FC#           =>  --  33FC
          (0, 0, 14503, 14506),
         16#FD#           =>  --  33FD
          (0, 0, 14507, 14510),
         16#FE#           =>  --  33FE
          (0, 0, 14511, 14514),
         16#FF#           =>  --  33FF
          (0, 0, 14515, 14517),
         others           =>
          (0, 0, 13404, 13405));

   Group_0034 : aliased constant Collation_Second_Stage
     := (others           =>
          (0, 0, 0, 0));

   Group_004D : aliased constant Collation_Second_Stage
     := (16#C0#           =>  --  4DC0
          (0, 0, 14518, 14518),
         16#C1#           =>  --  4DC1
          (0, 0, 14519, 14519),
         16#C2#           =>  --  4DC2
          (0, 0, 14520, 14520),
         16#C3#           =>  --  4DC3
          (0, 0, 14521, 14521),
         16#C4#           =>  --  4DC4
          (0, 0, 14522, 14522),
         16#C5#           =>  --  4DC5
          (0, 0, 14523, 14523),
         16#C6#           =>  --  4DC6
          (0, 0, 14524, 14524),
         16#C7#           =>  --  4DC7
          (0, 0, 14525, 14525),
         16#C8#           =>  --  4DC8
          (0, 0, 14526, 14526),
         16#C9#           =>  --  4DC9
          (0, 0, 14527, 14527),
         16#CA#           =>  --  4DCA
          (0, 0, 14528, 14528),
         16#CB#           =>  --  4DCB
          (0, 0, 14529, 14529),
         16#CC#           =>  --  4DCC
          (0, 0, 14530, 14530),
         16#CD#           =>  --  4DCD
          (0, 0, 14531, 14531),
         16#CE#           =>  --  4DCE
          (0, 0, 14532, 14532),
         16#CF#           =>  --  4DCF
          (0, 0, 14533, 14533),
         16#D0#           =>  --  4DD0
          (0, 0, 14534, 14534),
         16#D1#           =>  --  4DD1
          (0, 0, 14535, 14535),
         16#D2#           =>  --  4DD2
          (0, 0, 14536, 14536),
         16#D3#           =>  --  4DD3
          (0, 0, 14537, 14537),
         16#D4#           =>  --  4DD4
          (0, 0, 14538, 14538),
         16#D5#           =>  --  4DD5
          (0, 0, 14539, 14539),
         16#D6#           =>  --  4DD6
          (0, 0, 14540, 14540),
         16#D7#           =>  --  4DD7
          (0, 0, 14541, 14541),
         16#D8#           =>  --  4DD8
          (0, 0, 14542, 14542),
         16#D9#           =>  --  4DD9
          (0, 0, 14543, 14543),
         16#DA#           =>  --  4DDA
          (0, 0, 14544, 14544),
         16#DB#           =>  --  4DDB
          (0, 0, 14545, 14545),
         16#DC#           =>  --  4DDC
          (0, 0, 14546, 14546),
         16#DD#           =>  --  4DDD
          (0, 0, 14547, 14547),
         16#DE#           =>  --  4DDE
          (0, 0, 14548, 14548),
         16#DF#           =>  --  4DDF
          (0, 0, 14549, 14549),
         16#E0#           =>  --  4DE0
          (0, 0, 14550, 14550),
         16#E1#           =>  --  4DE1
          (0, 0, 14551, 14551),
         16#E2#           =>  --  4DE2
          (0, 0, 14552, 14552),
         16#E3#           =>  --  4DE3
          (0, 0, 14553, 14553),
         16#E4#           =>  --  4DE4
          (0, 0, 14554, 14554),
         16#E5#           =>  --  4DE5
          (0, 0, 14555, 14555),
         16#E6#           =>  --  4DE6
          (0, 0, 14556, 14556),
         16#E7#           =>  --  4DE7
          (0, 0, 14557, 14557),
         16#E8#           =>  --  4DE8
          (0, 0, 14558, 14558),
         16#E9#           =>  --  4DE9
          (0, 0, 14559, 14559),
         16#EA#           =>  --  4DEA
          (0, 0, 14560, 14560),
         16#EB#           =>  --  4DEB
          (0, 0, 14561, 14561),
         16#EC#           =>  --  4DEC
          (0, 0, 14562, 14562),
         16#ED#           =>  --  4DED
          (0, 0, 14563, 14563),
         16#EE#           =>  --  4DEE
          (0, 0, 14564, 14564),
         16#EF#           =>  --  4DEF
          (0, 0, 14565, 14565),
         16#F0#           =>  --  4DF0
          (0, 0, 14566, 14566),
         16#F1#           =>  --  4DF1
          (0, 0, 14567, 14567),
         16#F2#           =>  --  4DF2
          (0, 0, 14568, 14568),
         16#F3#           =>  --  4DF3
          (0, 0, 14569, 14569),
         16#F4#           =>  --  4DF4
          (0, 0, 14570, 14570),
         16#F5#           =>  --  4DF5
          (0, 0, 14571, 14571),
         16#F6#           =>  --  4DF6
          (0, 0, 14572, 14572),
         16#F7#           =>  --  4DF7
          (0, 0, 14573, 14573),
         16#F8#           =>  --  4DF8
          (0, 0, 14574, 14574),
         16#F9#           =>  --  4DF9
          (0, 0, 14575, 14575),
         16#FA#           =>  --  4DFA
          (0, 0, 14576, 14576),
         16#FB#           =>  --  4DFB
          (0, 0, 14577, 14577),
         16#FC#           =>  --  4DFC
          (0, 0, 14578, 14578),
         16#FD#           =>  --  4DFD
          (0, 0, 14579, 14579),
         16#FE#           =>  --  4DFE
          (0, 0, 14580, 14580),
         16#FF#           =>  --  4DFF
          (0, 0, 14581, 14581),
         others           =>
          (0, 0, 0, 0));

   Group_00A0 : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  A000
          (0, 0, 14582, 14582),
         16#01#           =>  --  A001
          (0, 0, 14583, 14583),
         16#02#           =>  --  A002
          (0, 0, 14584, 14584),
         16#03#           =>  --  A003
          (0, 0, 14585, 14585),
         16#04#           =>  --  A004
          (0, 0, 14586, 14586),
         16#05#           =>  --  A005
          (0, 0, 14587, 14587),
         16#06#           =>  --  A006
          (0, 0, 14588, 14588),
         16#07#           =>  --  A007
          (0, 0, 14589, 14589),
         16#08#           =>  --  A008
          (0, 0, 14590, 14590),
         16#09#           =>  --  A009
          (0, 0, 14591, 14591),
         16#0A#           =>  --  A00A
          (0, 0, 14592, 14592),
         16#0B#           =>  --  A00B
          (0, 0, 14593, 14593),
         16#0C#           =>  --  A00C
          (0, 0, 14594, 14594),
         16#0D#           =>  --  A00D
          (0, 0, 14595, 14595),
         16#0E#           =>  --  A00E
          (0, 0, 14596, 14596),
         16#0F#           =>  --  A00F
          (0, 0, 14597, 14597),
         16#10#           =>  --  A010
          (0, 0, 14598, 14598),
         16#11#           =>  --  A011
          (0, 0, 14599, 14599),
         16#12#           =>  --  A012
          (0, 0, 14600, 14600),
         16#13#           =>  --  A013
          (0, 0, 14601, 14601),
         16#14#           =>  --  A014
          (0, 0, 14602, 14602),
         16#15#           =>  --  A015
          (0, 0, 14603, 14603),
         16#16#           =>  --  A016
          (0, 0, 14604, 14604),
         16#17#           =>  --  A017
          (0, 0, 14605, 14605),
         16#18#           =>  --  A018
          (0, 0, 14606, 14606),
         16#19#           =>  --  A019
          (0, 0, 14607, 14607),
         16#1A#           =>  --  A01A
          (0, 0, 14608, 14608),
         16#1B#           =>  --  A01B
          (0, 0, 14609, 14609),
         16#1C#           =>  --  A01C
          (0, 0, 14610, 14610),
         16#1D#           =>  --  A01D
          (0, 0, 14611, 14611),
         16#1E#           =>  --  A01E
          (0, 0, 14612, 14612),
         16#1F#           =>  --  A01F
          (0, 0, 14613, 14613),
         16#20#           =>  --  A020
          (0, 0, 14614, 14614),
         16#21#           =>  --  A021
          (0, 0, 14615, 14615),
         16#22#           =>  --  A022
          (0, 0, 14616, 14616),
         16#23#           =>  --  A023
          (0, 0, 14617, 14617),
         16#24#           =>  --  A024
          (0, 0, 14618, 14618),
         16#25#           =>  --  A025
          (0, 0, 14619, 14619),
         16#26#           =>  --  A026
          (0, 0, 14620, 14620),
         16#27#           =>  --  A027
          (0, 0, 14621, 14621),
         16#28#           =>  --  A028
          (0, 0, 14622, 14622),
         16#29#           =>  --  A029
          (0, 0, 14623, 14623),
         16#2A#           =>  --  A02A
          (0, 0, 14624, 14624),
         16#2B#           =>  --  A02B
          (0, 0, 14625, 14625),
         16#2C#           =>  --  A02C
          (0, 0, 14626, 14626),
         16#2D#           =>  --  A02D
          (0, 0, 14627, 14627),
         16#2E#           =>  --  A02E
          (0, 0, 14628, 14628),
         16#2F#           =>  --  A02F
          (0, 0, 14629, 14629),
         16#30#           =>  --  A030
          (0, 0, 14630, 14630),
         16#31#           =>  --  A031
          (0, 0, 14631, 14631),
         16#32#           =>  --  A032
          (0, 0, 14632, 14632),
         16#33#           =>  --  A033
          (0, 0, 14633, 14633),
         16#34#           =>  --  A034
          (0, 0, 14634, 14634),
         16#35#           =>  --  A035
          (0, 0, 14635, 14635),
         16#36#           =>  --  A036
          (0, 0, 14636, 14636),
         16#37#           =>  --  A037
          (0, 0, 14637, 14637),
         16#38#           =>  --  A038
          (0, 0, 14638, 14638),
         16#39#           =>  --  A039
          (0, 0, 14639, 14639),
         16#3A#           =>  --  A03A
          (0, 0, 14640, 14640),
         16#3B#           =>  --  A03B
          (0, 0, 14641, 14641),
         16#3C#           =>  --  A03C
          (0, 0, 14642, 14642),
         16#3D#           =>  --  A03D
          (0, 0, 14643, 14643),
         16#3E#           =>  --  A03E
          (0, 0, 14644, 14644),
         16#3F#           =>  --  A03F
          (0, 0, 14645, 14645),
         16#40#           =>  --  A040
          (0, 0, 14646, 14646),
         16#41#           =>  --  A041
          (0, 0, 14647, 14647),
         16#42#           =>  --  A042
          (0, 0, 14648, 14648),
         16#43#           =>  --  A043
          (0, 0, 14649, 14649),
         16#44#           =>  --  A044
          (0, 0, 14650, 14650),
         16#45#           =>  --  A045
          (0, 0, 14651, 14651),
         16#46#           =>  --  A046
          (0, 0, 14652, 14652),
         16#47#           =>  --  A047
          (0, 0, 14653, 14653),
         16#48#           =>  --  A048
          (0, 0, 14654, 14654),
         16#49#           =>  --  A049
          (0, 0, 14655, 14655),
         16#4A#           =>  --  A04A
          (0, 0, 14656, 14656),
         16#4B#           =>  --  A04B
          (0, 0, 14657, 14657),
         16#4C#           =>  --  A04C
          (0, 0, 14658, 14658),
         16#4D#           =>  --  A04D
          (0, 0, 14659, 14659),
         16#4E#           =>  --  A04E
          (0, 0, 14660, 14660),
         16#4F#           =>  --  A04F
          (0, 0, 14661, 14661),
         16#50#           =>  --  A050
          (0, 0, 14662, 14662),
         16#51#           =>  --  A051
          (0, 0, 14663, 14663),
         16#52#           =>  --  A052
          (0, 0, 14664, 14664),
         16#53#           =>  --  A053
          (0, 0, 14665, 14665),
         16#54#           =>  --  A054
          (0, 0, 14666, 14666),
         16#55#           =>  --  A055
          (0, 0, 14667, 14667),
         16#56#           =>  --  A056
          (0, 0, 14668, 14668),
         16#57#           =>  --  A057
          (0, 0, 14669, 14669),
         16#58#           =>  --  A058
          (0, 0, 14670, 14670),
         16#59#           =>  --  A059
          (0, 0, 14671, 14671),
         16#5A#           =>  --  A05A
          (0, 0, 14672, 14672),
         16#5B#           =>  --  A05B
          (0, 0, 14673, 14673),
         16#5C#           =>  --  A05C
          (0, 0, 14674, 14674),
         16#5D#           =>  --  A05D
          (0, 0, 14675, 14675),
         16#5E#           =>  --  A05E
          (0, 0, 14676, 14676),
         16#5F#           =>  --  A05F
          (0, 0, 14677, 14677),
         16#60#           =>  --  A060
          (0, 0, 14678, 14678),
         16#61#           =>  --  A061
          (0, 0, 14679, 14679),
         16#62#           =>  --  A062
          (0, 0, 14680, 14680),
         16#63#           =>  --  A063
          (0, 0, 14681, 14681),
         16#64#           =>  --  A064
          (0, 0, 14682, 14682),
         16#65#           =>  --  A065
          (0, 0, 14683, 14683),
         16#66#           =>  --  A066
          (0, 0, 14684, 14684),
         16#67#           =>  --  A067
          (0, 0, 14685, 14685),
         16#68#           =>  --  A068
          (0, 0, 14686, 14686),
         16#69#           =>  --  A069
          (0, 0, 14687, 14687),
         16#6A#           =>  --  A06A
          (0, 0, 14688, 14688),
         16#6B#           =>  --  A06B
          (0, 0, 14689, 14689),
         16#6C#           =>  --  A06C
          (0, 0, 14690, 14690),
         16#6D#           =>  --  A06D
          (0, 0, 14691, 14691),
         16#6E#           =>  --  A06E
          (0, 0, 14692, 14692),
         16#6F#           =>  --  A06F
          (0, 0, 14693, 14693),
         16#70#           =>  --  A070
          (0, 0, 14694, 14694),
         16#71#           =>  --  A071
          (0, 0, 14695, 14695),
         16#72#           =>  --  A072
          (0, 0, 14696, 14696),
         16#73#           =>  --  A073
          (0, 0, 14697, 14697),
         16#74#           =>  --  A074
          (0, 0, 14698, 14698),
         16#75#           =>  --  A075
          (0, 0, 14699, 14699),
         16#76#           =>  --  A076
          (0, 0, 14700, 14700),
         16#77#           =>  --  A077
          (0, 0, 14701, 14701),
         16#78#           =>  --  A078
          (0, 0, 14702, 14702),
         16#79#           =>  --  A079
          (0, 0, 14703, 14703),
         16#7A#           =>  --  A07A
          (0, 0, 14704, 14704),
         16#7B#           =>  --  A07B
          (0, 0, 14705, 14705),
         16#7C#           =>  --  A07C
          (0, 0, 14706, 14706),
         16#7D#           =>  --  A07D
          (0, 0, 14707, 14707),
         16#7E#           =>  --  A07E
          (0, 0, 14708, 14708),
         16#7F#           =>  --  A07F
          (0, 0, 14709, 14709),
         16#80#           =>  --  A080
          (0, 0, 14710, 14710),
         16#81#           =>  --  A081
          (0, 0, 14711, 14711),
         16#82#           =>  --  A082
          (0, 0, 14712, 14712),
         16#83#           =>  --  A083
          (0, 0, 14713, 14713),
         16#84#           =>  --  A084
          (0, 0, 14714, 14714),
         16#85#           =>  --  A085
          (0, 0, 14715, 14715),
         16#86#           =>  --  A086
          (0, 0, 14716, 14716),
         16#87#           =>  --  A087
          (0, 0, 14717, 14717),
         16#88#           =>  --  A088
          (0, 0, 14718, 14718),
         16#89#           =>  --  A089
          (0, 0, 14719, 14719),
         16#8A#           =>  --  A08A
          (0, 0, 14720, 14720),
         16#8B#           =>  --  A08B
          (0, 0, 14721, 14721),
         16#8C#           =>  --  A08C
          (0, 0, 14722, 14722),
         16#8D#           =>  --  A08D
          (0, 0, 14723, 14723),
         16#8E#           =>  --  A08E
          (0, 0, 14724, 14724),
         16#8F#           =>  --  A08F
          (0, 0, 14725, 14725),
         16#90#           =>  --  A090
          (0, 0, 14726, 14726),
         16#91#           =>  --  A091
          (0, 0, 14727, 14727),
         16#92#           =>  --  A092
          (0, 0, 14728, 14728),
         16#93#           =>  --  A093
          (0, 0, 14729, 14729),
         16#94#           =>  --  A094
          (0, 0, 14730, 14730),
         16#95#           =>  --  A095
          (0, 0, 14731, 14731),
         16#96#           =>  --  A096
          (0, 0, 14732, 14732),
         16#97#           =>  --  A097
          (0, 0, 14733, 14733),
         16#98#           =>  --  A098
          (0, 0, 14734, 14734),
         16#99#           =>  --  A099
          (0, 0, 14735, 14735),
         16#9A#           =>  --  A09A
          (0, 0, 14736, 14736),
         16#9B#           =>  --  A09B
          (0, 0, 14737, 14737),
         16#9C#           =>  --  A09C
          (0, 0, 14738, 14738),
         16#9D#           =>  --  A09D
          (0, 0, 14739, 14739),
         16#9E#           =>  --  A09E
          (0, 0, 14740, 14740),
         16#9F#           =>  --  A09F
          (0, 0, 14741, 14741),
         16#A0#           =>  --  A0A0
          (0, 0, 14742, 14742),
         16#A1#           =>  --  A0A1
          (0, 0, 14743, 14743),
         16#A2#           =>  --  A0A2
          (0, 0, 14744, 14744),
         16#A3#           =>  --  A0A3
          (0, 0, 14745, 14745),
         16#A4#           =>  --  A0A4
          (0, 0, 14746, 14746),
         16#A5#           =>  --  A0A5
          (0, 0, 14747, 14747),
         16#A6#           =>  --  A0A6
          (0, 0, 14748, 14748),
         16#A7#           =>  --  A0A7
          (0, 0, 14749, 14749),
         16#A8#           =>  --  A0A8
          (0, 0, 14750, 14750),
         16#A9#           =>  --  A0A9
          (0, 0, 14751, 14751),
         16#AA#           =>  --  A0AA
          (0, 0, 14752, 14752),
         16#AB#           =>  --  A0AB
          (0, 0, 14753, 14753),
         16#AC#           =>  --  A0AC
          (0, 0, 14754, 14754),
         16#AD#           =>  --  A0AD
          (0, 0, 14755, 14755),
         16#AE#           =>  --  A0AE
          (0, 0, 14756, 14756),
         16#AF#           =>  --  A0AF
          (0, 0, 14757, 14757),
         16#B0#           =>  --  A0B0
          (0, 0, 14758, 14758),
         16#B1#           =>  --  A0B1
          (0, 0, 14759, 14759),
         16#B2#           =>  --  A0B2
          (0, 0, 14760, 14760),
         16#B3#           =>  --  A0B3
          (0, 0, 14761, 14761),
         16#B4#           =>  --  A0B4
          (0, 0, 14762, 14762),
         16#B5#           =>  --  A0B5
          (0, 0, 14763, 14763),
         16#B6#           =>  --  A0B6
          (0, 0, 14764, 14764),
         16#B7#           =>  --  A0B7
          (0, 0, 14765, 14765),
         16#B8#           =>  --  A0B8
          (0, 0, 14766, 14766),
         16#B9#           =>  --  A0B9
          (0, 0, 14767, 14767),
         16#BA#           =>  --  A0BA
          (0, 0, 14768, 14768),
         16#BB#           =>  --  A0BB
          (0, 0, 14769, 14769),
         16#BC#           =>  --  A0BC
          (0, 0, 14770, 14770),
         16#BD#           =>  --  A0BD
          (0, 0, 14771, 14771),
         16#BE#           =>  --  A0BE
          (0, 0, 14772, 14772),
         16#BF#           =>  --  A0BF
          (0, 0, 14773, 14773),
         16#C0#           =>  --  A0C0
          (0, 0, 14774, 14774),
         16#C1#           =>  --  A0C1
          (0, 0, 14775, 14775),
         16#C2#           =>  --  A0C2
          (0, 0, 14776, 14776),
         16#C3#           =>  --  A0C3
          (0, 0, 14777, 14777),
         16#C4#           =>  --  A0C4
          (0, 0, 14778, 14778),
         16#C5#           =>  --  A0C5
          (0, 0, 14779, 14779),
         16#C6#           =>  --  A0C6
          (0, 0, 14780, 14780),
         16#C7#           =>  --  A0C7
          (0, 0, 14781, 14781),
         16#C8#           =>  --  A0C8
          (0, 0, 14782, 14782),
         16#C9#           =>  --  A0C9
          (0, 0, 14783, 14783),
         16#CA#           =>  --  A0CA
          (0, 0, 14784, 14784),
         16#CB#           =>  --  A0CB
          (0, 0, 14785, 14785),
         16#CC#           =>  --  A0CC
          (0, 0, 14786, 14786),
         16#CD#           =>  --  A0CD
          (0, 0, 14787, 14787),
         16#CE#           =>  --  A0CE
          (0, 0, 14788, 14788),
         16#CF#           =>  --  A0CF
          (0, 0, 14789, 14789),
         16#D0#           =>  --  A0D0
          (0, 0, 14790, 14790),
         16#D1#           =>  --  A0D1
          (0, 0, 14791, 14791),
         16#D2#           =>  --  A0D2
          (0, 0, 14792, 14792),
         16#D3#           =>  --  A0D3
          (0, 0, 14793, 14793),
         16#D4#           =>  --  A0D4
          (0, 0, 14794, 14794),
         16#D5#           =>  --  A0D5
          (0, 0, 14795, 14795),
         16#D6#           =>  --  A0D6
          (0, 0, 14796, 14796),
         16#D7#           =>  --  A0D7
          (0, 0, 14797, 14797),
         16#D8#           =>  --  A0D8
          (0, 0, 14798, 14798),
         16#D9#           =>  --  A0D9
          (0, 0, 14799, 14799),
         16#DA#           =>  --  A0DA
          (0, 0, 14800, 14800),
         16#DB#           =>  --  A0DB
          (0, 0, 14801, 14801),
         16#DC#           =>  --  A0DC
          (0, 0, 14802, 14802),
         16#DD#           =>  --  A0DD
          (0, 0, 14803, 14803),
         16#DE#           =>  --  A0DE
          (0, 0, 14804, 14804),
         16#DF#           =>  --  A0DF
          (0, 0, 14805, 14805),
         16#E0#           =>  --  A0E0
          (0, 0, 14806, 14806),
         16#E1#           =>  --  A0E1
          (0, 0, 14807, 14807),
         16#E2#           =>  --  A0E2
          (0, 0, 14808, 14808),
         16#E3#           =>  --  A0E3
          (0, 0, 14809, 14809),
         16#E4#           =>  --  A0E4
          (0, 0, 14810, 14810),
         16#E5#           =>  --  A0E5
          (0, 0, 14811, 14811),
         16#E6#           =>  --  A0E6
          (0, 0, 14812, 14812),
         16#E7#           =>  --  A0E7
          (0, 0, 14813, 14813),
         16#E8#           =>  --  A0E8
          (0, 0, 14814, 14814),
         16#E9#           =>  --  A0E9
          (0, 0, 14815, 14815),
         16#EA#           =>  --  A0EA
          (0, 0, 14816, 14816),
         16#EB#           =>  --  A0EB
          (0, 0, 14817, 14817),
         16#EC#           =>  --  A0EC
          (0, 0, 14818, 14818),
         16#ED#           =>  --  A0ED
          (0, 0, 14819, 14819),
         16#EE#           =>  --  A0EE
          (0, 0, 14820, 14820),
         16#EF#           =>  --  A0EF
          (0, 0, 14821, 14821),
         16#F0#           =>  --  A0F0
          (0, 0, 14822, 14822),
         16#F1#           =>  --  A0F1
          (0, 0, 14823, 14823),
         16#F2#           =>  --  A0F2
          (0, 0, 14824, 14824),
         16#F3#           =>  --  A0F3
          (0, 0, 14825, 14825),
         16#F4#           =>  --  A0F4
          (0, 0, 14826, 14826),
         16#F5#           =>  --  A0F5
          (0, 0, 14827, 14827),
         16#F6#           =>  --  A0F6
          (0, 0, 14828, 14828),
         16#F7#           =>  --  A0F7
          (0, 0, 14829, 14829),
         16#F8#           =>  --  A0F8
          (0, 0, 14830, 14830),
         16#F9#           =>  --  A0F9
          (0, 0, 14831, 14831),
         16#FA#           =>  --  A0FA
          (0, 0, 14832, 14832),
         16#FB#           =>  --  A0FB
          (0, 0, 14833, 14833),
         16#FC#           =>  --  A0FC
          (0, 0, 14834, 14834),
         16#FD#           =>  --  A0FD
          (0, 0, 14835, 14835),
         16#FE#           =>  --  A0FE
          (0, 0, 14836, 14836),
         16#FF#           =>  --  A0FF
          (0, 0, 14837, 14837),
         others           =>
          (0, 0, 0, 0));

   Group_00A1 : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  A100
          (0, 0, 14838, 14838),
         16#01#           =>  --  A101
          (0, 0, 14839, 14839),
         16#02#           =>  --  A102
          (0, 0, 14840, 14840),
         16#03#           =>  --  A103
          (0, 0, 14841, 14841),
         16#04#           =>  --  A104
          (0, 0, 14842, 14842),
         16#05#           =>  --  A105
          (0, 0, 14843, 14843),
         16#06#           =>  --  A106
          (0, 0, 14844, 14844),
         16#07#           =>  --  A107
          (0, 0, 14845, 14845),
         16#08#           =>  --  A108
          (0, 0, 14846, 14846),
         16#09#           =>  --  A109
          (0, 0, 14847, 14847),
         16#0A#           =>  --  A10A
          (0, 0, 14848, 14848),
         16#0B#           =>  --  A10B
          (0, 0, 14849, 14849),
         16#0C#           =>  --  A10C
          (0, 0, 14850, 14850),
         16#0D#           =>  --  A10D
          (0, 0, 14851, 14851),
         16#0E#           =>  --  A10E
          (0, 0, 14852, 14852),
         16#0F#           =>  --  A10F
          (0, 0, 14853, 14853),
         16#10#           =>  --  A110
          (0, 0, 14854, 14854),
         16#11#           =>  --  A111
          (0, 0, 14855, 14855),
         16#12#           =>  --  A112
          (0, 0, 14856, 14856),
         16#13#           =>  --  A113
          (0, 0, 14857, 14857),
         16#14#           =>  --  A114
          (0, 0, 14858, 14858),
         16#15#           =>  --  A115
          (0, 0, 14859, 14859),
         16#16#           =>  --  A116
          (0, 0, 14860, 14860),
         16#17#           =>  --  A117
          (0, 0, 14861, 14861),
         16#18#           =>  --  A118
          (0, 0, 14862, 14862),
         16#19#           =>  --  A119
          (0, 0, 14863, 14863),
         16#1A#           =>  --  A11A
          (0, 0, 14864, 14864),
         16#1B#           =>  --  A11B
          (0, 0, 14865, 14865),
         16#1C#           =>  --  A11C
          (0, 0, 14866, 14866),
         16#1D#           =>  --  A11D
          (0, 0, 14867, 14867),
         16#1E#           =>  --  A11E
          (0, 0, 14868, 14868),
         16#1F#           =>  --  A11F
          (0, 0, 14869, 14869),
         16#20#           =>  --  A120
          (0, 0, 14870, 14870),
         16#21#           =>  --  A121
          (0, 0, 14871, 14871),
         16#22#           =>  --  A122
          (0, 0, 14872, 14872),
         16#23#           =>  --  A123
          (0, 0, 14873, 14873),
         16#24#           =>  --  A124
          (0, 0, 14874, 14874),
         16#25#           =>  --  A125
          (0, 0, 14875, 14875),
         16#26#           =>  --  A126
          (0, 0, 14876, 14876),
         16#27#           =>  --  A127
          (0, 0, 14877, 14877),
         16#28#           =>  --  A128
          (0, 0, 14878, 14878),
         16#29#           =>  --  A129
          (0, 0, 14879, 14879),
         16#2A#           =>  --  A12A
          (0, 0, 14880, 14880),
         16#2B#           =>  --  A12B
          (0, 0, 14881, 14881),
         16#2C#           =>  --  A12C
          (0, 0, 14882, 14882),
         16#2D#           =>  --  A12D
          (0, 0, 14883, 14883),
         16#2E#           =>  --  A12E
          (0, 0, 14884, 14884),
         16#2F#           =>  --  A12F
          (0, 0, 14885, 14885),
         16#30#           =>  --  A130
          (0, 0, 14886, 14886),
         16#31#           =>  --  A131
          (0, 0, 14887, 14887),
         16#32#           =>  --  A132
          (0, 0, 14888, 14888),
         16#33#           =>  --  A133
          (0, 0, 14889, 14889),
         16#34#           =>  --  A134
          (0, 0, 14890, 14890),
         16#35#           =>  --  A135
          (0, 0, 14891, 14891),
         16#36#           =>  --  A136
          (0, 0, 14892, 14892),
         16#37#           =>  --  A137
          (0, 0, 14893, 14893),
         16#38#           =>  --  A138
          (0, 0, 14894, 14894),
         16#39#           =>  --  A139
          (0, 0, 14895, 14895),
         16#3A#           =>  --  A13A
          (0, 0, 14896, 14896),
         16#3B#           =>  --  A13B
          (0, 0, 14897, 14897),
         16#3C#           =>  --  A13C
          (0, 0, 14898, 14898),
         16#3D#           =>  --  A13D
          (0, 0, 14899, 14899),
         16#3E#           =>  --  A13E
          (0, 0, 14900, 14900),
         16#3F#           =>  --  A13F
          (0, 0, 14901, 14901),
         16#40#           =>  --  A140
          (0, 0, 14902, 14902),
         16#41#           =>  --  A141
          (0, 0, 14903, 14903),
         16#42#           =>  --  A142
          (0, 0, 14904, 14904),
         16#43#           =>  --  A143
          (0, 0, 14905, 14905),
         16#44#           =>  --  A144
          (0, 0, 14906, 14906),
         16#45#           =>  --  A145
          (0, 0, 14907, 14907),
         16#46#           =>  --  A146
          (0, 0, 14908, 14908),
         16#47#           =>  --  A147
          (0, 0, 14909, 14909),
         16#48#           =>  --  A148
          (0, 0, 14910, 14910),
         16#49#           =>  --  A149
          (0, 0, 14911, 14911),
         16#4A#           =>  --  A14A
          (0, 0, 14912, 14912),
         16#4B#           =>  --  A14B
          (0, 0, 14913, 14913),
         16#4C#           =>  --  A14C
          (0, 0, 14914, 14914),
         16#4D#           =>  --  A14D
          (0, 0, 14915, 14915),
         16#4E#           =>  --  A14E
          (0, 0, 14916, 14916),
         16#4F#           =>  --  A14F
          (0, 0, 14917, 14917),
         16#50#           =>  --  A150
          (0, 0, 14918, 14918),
         16#51#           =>  --  A151
          (0, 0, 14919, 14919),
         16#52#           =>  --  A152
          (0, 0, 14920, 14920),
         16#53#           =>  --  A153
          (0, 0, 14921, 14921),
         16#54#           =>  --  A154
          (0, 0, 14922, 14922),
         16#55#           =>  --  A155
          (0, 0, 14923, 14923),
         16#56#           =>  --  A156
          (0, 0, 14924, 14924),
         16#57#           =>  --  A157
          (0, 0, 14925, 14925),
         16#58#           =>  --  A158
          (0, 0, 14926, 14926),
         16#59#           =>  --  A159
          (0, 0, 14927, 14927),
         16#5A#           =>  --  A15A
          (0, 0, 14928, 14928),
         16#5B#           =>  --  A15B
          (0, 0, 14929, 14929),
         16#5C#           =>  --  A15C
          (0, 0, 14930, 14930),
         16#5D#           =>  --  A15D
          (0, 0, 14931, 14931),
         16#5E#           =>  --  A15E
          (0, 0, 14932, 14932),
         16#5F#           =>  --  A15F
          (0, 0, 14933, 14933),
         16#60#           =>  --  A160
          (0, 0, 14934, 14934),
         16#61#           =>  --  A161
          (0, 0, 14935, 14935),
         16#62#           =>  --  A162
          (0, 0, 14936, 14936),
         16#63#           =>  --  A163
          (0, 0, 14937, 14937),
         16#64#           =>  --  A164
          (0, 0, 14938, 14938),
         16#65#           =>  --  A165
          (0, 0, 14939, 14939),
         16#66#           =>  --  A166
          (0, 0, 14940, 14940),
         16#67#           =>  --  A167
          (0, 0, 14941, 14941),
         16#68#           =>  --  A168
          (0, 0, 14942, 14942),
         16#69#           =>  --  A169
          (0, 0, 14943, 14943),
         16#6A#           =>  --  A16A
          (0, 0, 14944, 14944),
         16#6B#           =>  --  A16B
          (0, 0, 14945, 14945),
         16#6C#           =>  --  A16C
          (0, 0, 14946, 14946),
         16#6D#           =>  --  A16D
          (0, 0, 14947, 14947),
         16#6E#           =>  --  A16E
          (0, 0, 14948, 14948),
         16#6F#           =>  --  A16F
          (0, 0, 14949, 14949),
         16#70#           =>  --  A170
          (0, 0, 14950, 14950),
         16#71#           =>  --  A171
          (0, 0, 14951, 14951),
         16#72#           =>  --  A172
          (0, 0, 14952, 14952),
         16#73#           =>  --  A173
          (0, 0, 14953, 14953),
         16#74#           =>  --  A174
          (0, 0, 14954, 14954),
         16#75#           =>  --  A175
          (0, 0, 14955, 14955),
         16#76#           =>  --  A176
          (0, 0, 14956, 14956),
         16#77#           =>  --  A177
          (0, 0, 14957, 14957),
         16#78#           =>  --  A178
          (0, 0, 14958, 14958),
         16#79#           =>  --  A179
          (0, 0, 14959, 14959),
         16#7A#           =>  --  A17A
          (0, 0, 14960, 14960),
         16#7B#           =>  --  A17B
          (0, 0, 14961, 14961),
         16#7C#           =>  --  A17C
          (0, 0, 14962, 14962),
         16#7D#           =>  --  A17D
          (0, 0, 14963, 14963),
         16#7E#           =>  --  A17E
          (0, 0, 14964, 14964),
         16#7F#           =>  --  A17F
          (0, 0, 14965, 14965),
         16#80#           =>  --  A180
          (0, 0, 14966, 14966),
         16#81#           =>  --  A181
          (0, 0, 14967, 14967),
         16#82#           =>  --  A182
          (0, 0, 14968, 14968),
         16#83#           =>  --  A183
          (0, 0, 14969, 14969),
         16#84#           =>  --  A184
          (0, 0, 14970, 14970),
         16#85#           =>  --  A185
          (0, 0, 14971, 14971),
         16#86#           =>  --  A186
          (0, 0, 14972, 14972),
         16#87#           =>  --  A187
          (0, 0, 14973, 14973),
         16#88#           =>  --  A188
          (0, 0, 14974, 14974),
         16#89#           =>  --  A189
          (0, 0, 14975, 14975),
         16#8A#           =>  --  A18A
          (0, 0, 14976, 14976),
         16#8B#           =>  --  A18B
          (0, 0, 14977, 14977),
         16#8C#           =>  --  A18C
          (0, 0, 14978, 14978),
         16#8D#           =>  --  A18D
          (0, 0, 14979, 14979),
         16#8E#           =>  --  A18E
          (0, 0, 14980, 14980),
         16#8F#           =>  --  A18F
          (0, 0, 14981, 14981),
         16#90#           =>  --  A190
          (0, 0, 14982, 14982),
         16#91#           =>  --  A191
          (0, 0, 14983, 14983),
         16#92#           =>  --  A192
          (0, 0, 14984, 14984),
         16#93#           =>  --  A193
          (0, 0, 14985, 14985),
         16#94#           =>  --  A194
          (0, 0, 14986, 14986),
         16#95#           =>  --  A195
          (0, 0, 14987, 14987),
         16#96#           =>  --  A196
          (0, 0, 14988, 14988),
         16#97#           =>  --  A197
          (0, 0, 14989, 14989),
         16#98#           =>  --  A198
          (0, 0, 14990, 14990),
         16#99#           =>  --  A199
          (0, 0, 14991, 14991),
         16#9A#           =>  --  A19A
          (0, 0, 14992, 14992),
         16#9B#           =>  --  A19B
          (0, 0, 14993, 14993),
         16#9C#           =>  --  A19C
          (0, 0, 14994, 14994),
         16#9D#           =>  --  A19D
          (0, 0, 14995, 14995),
         16#9E#           =>  --  A19E
          (0, 0, 14996, 14996),
         16#9F#           =>  --  A19F
          (0, 0, 14997, 14997),
         16#A0#           =>  --  A1A0
          (0, 0, 14998, 14998),
         16#A1#           =>  --  A1A1
          (0, 0, 14999, 14999),
         16#A2#           =>  --  A1A2
          (0, 0, 15000, 15000),
         16#A3#           =>  --  A1A3
          (0, 0, 15001, 15001),
         16#A4#           =>  --  A1A4
          (0, 0, 15002, 15002),
         16#A5#           =>  --  A1A5
          (0, 0, 15003, 15003),
         16#A6#           =>  --  A1A6
          (0, 0, 15004, 15004),
         16#A7#           =>  --  A1A7
          (0, 0, 15005, 15005),
         16#A8#           =>  --  A1A8
          (0, 0, 15006, 15006),
         16#A9#           =>  --  A1A9
          (0, 0, 15007, 15007),
         16#AA#           =>  --  A1AA
          (0, 0, 15008, 15008),
         16#AB#           =>  --  A1AB
          (0, 0, 15009, 15009),
         16#AC#           =>  --  A1AC
          (0, 0, 15010, 15010),
         16#AD#           =>  --  A1AD
          (0, 0, 15011, 15011),
         16#AE#           =>  --  A1AE
          (0, 0, 15012, 15012),
         16#AF#           =>  --  A1AF
          (0, 0, 15013, 15013),
         16#B0#           =>  --  A1B0
          (0, 0, 15014, 15014),
         16#B1#           =>  --  A1B1
          (0, 0, 15015, 15015),
         16#B2#           =>  --  A1B2
          (0, 0, 15016, 15016),
         16#B3#           =>  --  A1B3
          (0, 0, 15017, 15017),
         16#B4#           =>  --  A1B4
          (0, 0, 15018, 15018),
         16#B5#           =>  --  A1B5
          (0, 0, 15019, 15019),
         16#B6#           =>  --  A1B6
          (0, 0, 15020, 15020),
         16#B7#           =>  --  A1B7
          (0, 0, 15021, 15021),
         16#B8#           =>  --  A1B8
          (0, 0, 15022, 15022),
         16#B9#           =>  --  A1B9
          (0, 0, 15023, 15023),
         16#BA#           =>  --  A1BA
          (0, 0, 15024, 15024),
         16#BB#           =>  --  A1BB
          (0, 0, 15025, 15025),
         16#BC#           =>  --  A1BC
          (0, 0, 15026, 15026),
         16#BD#           =>  --  A1BD
          (0, 0, 15027, 15027),
         16#BE#           =>  --  A1BE
          (0, 0, 15028, 15028),
         16#BF#           =>  --  A1BF
          (0, 0, 15029, 15029),
         16#C0#           =>  --  A1C0
          (0, 0, 15030, 15030),
         16#C1#           =>  --  A1C1
          (0, 0, 15031, 15031),
         16#C2#           =>  --  A1C2
          (0, 0, 15032, 15032),
         16#C3#           =>  --  A1C3
          (0, 0, 15033, 15033),
         16#C4#           =>  --  A1C4
          (0, 0, 15034, 15034),
         16#C5#           =>  --  A1C5
          (0, 0, 15035, 15035),
         16#C6#           =>  --  A1C6
          (0, 0, 15036, 15036),
         16#C7#           =>  --  A1C7
          (0, 0, 15037, 15037),
         16#C8#           =>  --  A1C8
          (0, 0, 15038, 15038),
         16#C9#           =>  --  A1C9
          (0, 0, 15039, 15039),
         16#CA#           =>  --  A1CA
          (0, 0, 15040, 15040),
         16#CB#           =>  --  A1CB
          (0, 0, 15041, 15041),
         16#CC#           =>  --  A1CC
          (0, 0, 15042, 15042),
         16#CD#           =>  --  A1CD
          (0, 0, 15043, 15043),
         16#CE#           =>  --  A1CE
          (0, 0, 15044, 15044),
         16#CF#           =>  --  A1CF
          (0, 0, 15045, 15045),
         16#D0#           =>  --  A1D0
          (0, 0, 15046, 15046),
         16#D1#           =>  --  A1D1
          (0, 0, 15047, 15047),
         16#D2#           =>  --  A1D2
          (0, 0, 15048, 15048),
         16#D3#           =>  --  A1D3
          (0, 0, 15049, 15049),
         16#D4#           =>  --  A1D4
          (0, 0, 15050, 15050),
         16#D5#           =>  --  A1D5
          (0, 0, 15051, 15051),
         16#D6#           =>  --  A1D6
          (0, 0, 15052, 15052),
         16#D7#           =>  --  A1D7
          (0, 0, 15053, 15053),
         16#D8#           =>  --  A1D8
          (0, 0, 15054, 15054),
         16#D9#           =>  --  A1D9
          (0, 0, 15055, 15055),
         16#DA#           =>  --  A1DA
          (0, 0, 15056, 15056),
         16#DB#           =>  --  A1DB
          (0, 0, 15057, 15057),
         16#DC#           =>  --  A1DC
          (0, 0, 15058, 15058),
         16#DD#           =>  --  A1DD
          (0, 0, 15059, 15059),
         16#DE#           =>  --  A1DE
          (0, 0, 15060, 15060),
         16#DF#           =>  --  A1DF
          (0, 0, 15061, 15061),
         16#E0#           =>  --  A1E0
          (0, 0, 15062, 15062),
         16#E1#           =>  --  A1E1
          (0, 0, 15063, 15063),
         16#E2#           =>  --  A1E2
          (0, 0, 15064, 15064),
         16#E3#           =>  --  A1E3
          (0, 0, 15065, 15065),
         16#E4#           =>  --  A1E4
          (0, 0, 15066, 15066),
         16#E5#           =>  --  A1E5
          (0, 0, 15067, 15067),
         16#E6#           =>  --  A1E6
          (0, 0, 15068, 15068),
         16#E7#           =>  --  A1E7
          (0, 0, 15069, 15069),
         16#E8#           =>  --  A1E8
          (0, 0, 15070, 15070),
         16#E9#           =>  --  A1E9
          (0, 0, 15071, 15071),
         16#EA#           =>  --  A1EA
          (0, 0, 15072, 15072),
         16#EB#           =>  --  A1EB
          (0, 0, 15073, 15073),
         16#EC#           =>  --  A1EC
          (0, 0, 15074, 15074),
         16#ED#           =>  --  A1ED
          (0, 0, 15075, 15075),
         16#EE#           =>  --  A1EE
          (0, 0, 15076, 15076),
         16#EF#           =>  --  A1EF
          (0, 0, 15077, 15077),
         16#F0#           =>  --  A1F0
          (0, 0, 15078, 15078),
         16#F1#           =>  --  A1F1
          (0, 0, 15079, 15079),
         16#F2#           =>  --  A1F2
          (0, 0, 15080, 15080),
         16#F3#           =>  --  A1F3
          (0, 0, 15081, 15081),
         16#F4#           =>  --  A1F4
          (0, 0, 15082, 15082),
         16#F5#           =>  --  A1F5
          (0, 0, 15083, 15083),
         16#F6#           =>  --  A1F6
          (0, 0, 15084, 15084),
         16#F7#           =>  --  A1F7
          (0, 0, 15085, 15085),
         16#F8#           =>  --  A1F8
          (0, 0, 15086, 15086),
         16#F9#           =>  --  A1F9
          (0, 0, 15087, 15087),
         16#FA#           =>  --  A1FA
          (0, 0, 15088, 15088),
         16#FB#           =>  --  A1FB
          (0, 0, 15089, 15089),
         16#FC#           =>  --  A1FC
          (0, 0, 15090, 15090),
         16#FD#           =>  --  A1FD
          (0, 0, 15091, 15091),
         16#FE#           =>  --  A1FE
          (0, 0, 15092, 15092),
         16#FF#           =>  --  A1FF
          (0, 0, 15093, 15093),
         others           =>
          (0, 0, 0, 0));

   Group_00A2 : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  A200
          (0, 0, 15094, 15094),
         16#01#           =>  --  A201
          (0, 0, 15095, 15095),
         16#02#           =>  --  A202
          (0, 0, 15096, 15096),
         16#03#           =>  --  A203
          (0, 0, 15097, 15097),
         16#04#           =>  --  A204
          (0, 0, 15098, 15098),
         16#05#           =>  --  A205
          (0, 0, 15099, 15099),
         16#06#           =>  --  A206
          (0, 0, 15100, 15100),
         16#07#           =>  --  A207
          (0, 0, 15101, 15101),
         16#08#           =>  --  A208
          (0, 0, 15102, 15102),
         16#09#           =>  --  A209
          (0, 0, 15103, 15103),
         16#0A#           =>  --  A20A
          (0, 0, 15104, 15104),
         16#0B#           =>  --  A20B
          (0, 0, 15105, 15105),
         16#0C#           =>  --  A20C
          (0, 0, 15106, 15106),
         16#0D#           =>  --  A20D
          (0, 0, 15107, 15107),
         16#0E#           =>  --  A20E
          (0, 0, 15108, 15108),
         16#0F#           =>  --  A20F
          (0, 0, 15109, 15109),
         16#10#           =>  --  A210
          (0, 0, 15110, 15110),
         16#11#           =>  --  A211
          (0, 0, 15111, 15111),
         16#12#           =>  --  A212
          (0, 0, 15112, 15112),
         16#13#           =>  --  A213
          (0, 0, 15113, 15113),
         16#14#           =>  --  A214
          (0, 0, 15114, 15114),
         16#15#           =>  --  A215
          (0, 0, 15115, 15115),
         16#16#           =>  --  A216
          (0, 0, 15116, 15116),
         16#17#           =>  --  A217
          (0, 0, 15117, 15117),
         16#18#           =>  --  A218
          (0, 0, 15118, 15118),
         16#19#           =>  --  A219
          (0, 0, 15119, 15119),
         16#1A#           =>  --  A21A
          (0, 0, 15120, 15120),
         16#1B#           =>  --  A21B
          (0, 0, 15121, 15121),
         16#1C#           =>  --  A21C
          (0, 0, 15122, 15122),
         16#1D#           =>  --  A21D
          (0, 0, 15123, 15123),
         16#1E#           =>  --  A21E
          (0, 0, 15124, 15124),
         16#1F#           =>  --  A21F
          (0, 0, 15125, 15125),
         16#20#           =>  --  A220
          (0, 0, 15126, 15126),
         16#21#           =>  --  A221
          (0, 0, 15127, 15127),
         16#22#           =>  --  A222
          (0, 0, 15128, 15128),
         16#23#           =>  --  A223
          (0, 0, 15129, 15129),
         16#24#           =>  --  A224
          (0, 0, 15130, 15130),
         16#25#           =>  --  A225
          (0, 0, 15131, 15131),
         16#26#           =>  --  A226
          (0, 0, 15132, 15132),
         16#27#           =>  --  A227
          (0, 0, 15133, 15133),
         16#28#           =>  --  A228
          (0, 0, 15134, 15134),
         16#29#           =>  --  A229
          (0, 0, 15135, 15135),
         16#2A#           =>  --  A22A
          (0, 0, 15136, 15136),
         16#2B#           =>  --  A22B
          (0, 0, 15137, 15137),
         16#2C#           =>  --  A22C
          (0, 0, 15138, 15138),
         16#2D#           =>  --  A22D
          (0, 0, 15139, 15139),
         16#2E#           =>  --  A22E
          (0, 0, 15140, 15140),
         16#2F#           =>  --  A22F
          (0, 0, 15141, 15141),
         16#30#           =>  --  A230
          (0, 0, 15142, 15142),
         16#31#           =>  --  A231
          (0, 0, 15143, 15143),
         16#32#           =>  --  A232
          (0, 0, 15144, 15144),
         16#33#           =>  --  A233
          (0, 0, 15145, 15145),
         16#34#           =>  --  A234
          (0, 0, 15146, 15146),
         16#35#           =>  --  A235
          (0, 0, 15147, 15147),
         16#36#           =>  --  A236
          (0, 0, 15148, 15148),
         16#37#           =>  --  A237
          (0, 0, 15149, 15149),
         16#38#           =>  --  A238
          (0, 0, 15150, 15150),
         16#39#           =>  --  A239
          (0, 0, 15151, 15151),
         16#3A#           =>  --  A23A
          (0, 0, 15152, 15152),
         16#3B#           =>  --  A23B
          (0, 0, 15153, 15153),
         16#3C#           =>  --  A23C
          (0, 0, 15154, 15154),
         16#3D#           =>  --  A23D
          (0, 0, 15155, 15155),
         16#3E#           =>  --  A23E
          (0, 0, 15156, 15156),
         16#3F#           =>  --  A23F
          (0, 0, 15157, 15157),
         16#40#           =>  --  A240
          (0, 0, 15158, 15158),
         16#41#           =>  --  A241
          (0, 0, 15159, 15159),
         16#42#           =>  --  A242
          (0, 0, 15160, 15160),
         16#43#           =>  --  A243
          (0, 0, 15161, 15161),
         16#44#           =>  --  A244
          (0, 0, 15162, 15162),
         16#45#           =>  --  A245
          (0, 0, 15163, 15163),
         16#46#           =>  --  A246
          (0, 0, 15164, 15164),
         16#47#           =>  --  A247
          (0, 0, 15165, 15165),
         16#48#           =>  --  A248
          (0, 0, 15166, 15166),
         16#49#           =>  --  A249
          (0, 0, 15167, 15167),
         16#4A#           =>  --  A24A
          (0, 0, 15168, 15168),
         16#4B#           =>  --  A24B
          (0, 0, 15169, 15169),
         16#4C#           =>  --  A24C
          (0, 0, 15170, 15170),
         16#4D#           =>  --  A24D
          (0, 0, 15171, 15171),
         16#4E#           =>  --  A24E
          (0, 0, 15172, 15172),
         16#4F#           =>  --  A24F
          (0, 0, 15173, 15173),
         16#50#           =>  --  A250
          (0, 0, 15174, 15174),
         16#51#           =>  --  A251
          (0, 0, 15175, 15175),
         16#52#           =>  --  A252
          (0, 0, 15176, 15176),
         16#53#           =>  --  A253
          (0, 0, 15177, 15177),
         16#54#           =>  --  A254
          (0, 0, 15178, 15178),
         16#55#           =>  --  A255
          (0, 0, 15179, 15179),
         16#56#           =>  --  A256
          (0, 0, 15180, 15180),
         16#57#           =>  --  A257
          (0, 0, 15181, 15181),
         16#58#           =>  --  A258
          (0, 0, 15182, 15182),
         16#59#           =>  --  A259
          (0, 0, 15183, 15183),
         16#5A#           =>  --  A25A
          (0, 0, 15184, 15184),
         16#5B#           =>  --  A25B
          (0, 0, 15185, 15185),
         16#5C#           =>  --  A25C
          (0, 0, 15186, 15186),
         16#5D#           =>  --  A25D
          (0, 0, 15187, 15187),
         16#5E#           =>  --  A25E
          (0, 0, 15188, 15188),
         16#5F#           =>  --  A25F
          (0, 0, 15189, 15189),
         16#60#           =>  --  A260
          (0, 0, 15190, 15190),
         16#61#           =>  --  A261
          (0, 0, 15191, 15191),
         16#62#           =>  --  A262
          (0, 0, 15192, 15192),
         16#63#           =>  --  A263
          (0, 0, 15193, 15193),
         16#64#           =>  --  A264
          (0, 0, 15194, 15194),
         16#65#           =>  --  A265
          (0, 0, 15195, 15195),
         16#66#           =>  --  A266
          (0, 0, 15196, 15196),
         16#67#           =>  --  A267
          (0, 0, 15197, 15197),
         16#68#           =>  --  A268
          (0, 0, 15198, 15198),
         16#69#           =>  --  A269
          (0, 0, 15199, 15199),
         16#6A#           =>  --  A26A
          (0, 0, 15200, 15200),
         16#6B#           =>  --  A26B
          (0, 0, 15201, 15201),
         16#6C#           =>  --  A26C
          (0, 0, 15202, 15202),
         16#6D#           =>  --  A26D
          (0, 0, 15203, 15203),
         16#6E#           =>  --  A26E
          (0, 0, 15204, 15204),
         16#6F#           =>  --  A26F
          (0, 0, 15205, 15205),
         16#70#           =>  --  A270
          (0, 0, 15206, 15206),
         16#71#           =>  --  A271
          (0, 0, 15207, 15207),
         16#72#           =>  --  A272
          (0, 0, 15208, 15208),
         16#73#           =>  --  A273
          (0, 0, 15209, 15209),
         16#74#           =>  --  A274
          (0, 0, 15210, 15210),
         16#75#           =>  --  A275
          (0, 0, 15211, 15211),
         16#76#           =>  --  A276
          (0, 0, 15212, 15212),
         16#77#           =>  --  A277
          (0, 0, 15213, 15213),
         16#78#           =>  --  A278
          (0, 0, 15214, 15214),
         16#79#           =>  --  A279
          (0, 0, 15215, 15215),
         16#7A#           =>  --  A27A
          (0, 0, 15216, 15216),
         16#7B#           =>  --  A27B
          (0, 0, 15217, 15217),
         16#7C#           =>  --  A27C
          (0, 0, 15218, 15218),
         16#7D#           =>  --  A27D
          (0, 0, 15219, 15219),
         16#7E#           =>  --  A27E
          (0, 0, 15220, 15220),
         16#7F#           =>  --  A27F
          (0, 0, 15221, 15221),
         16#80#           =>  --  A280
          (0, 0, 15222, 15222),
         16#81#           =>  --  A281
          (0, 0, 15223, 15223),
         16#82#           =>  --  A282
          (0, 0, 15224, 15224),
         16#83#           =>  --  A283
          (0, 0, 15225, 15225),
         16#84#           =>  --  A284
          (0, 0, 15226, 15226),
         16#85#           =>  --  A285
          (0, 0, 15227, 15227),
         16#86#           =>  --  A286
          (0, 0, 15228, 15228),
         16#87#           =>  --  A287
          (0, 0, 15229, 15229),
         16#88#           =>  --  A288
          (0, 0, 15230, 15230),
         16#89#           =>  --  A289
          (0, 0, 15231, 15231),
         16#8A#           =>  --  A28A
          (0, 0, 15232, 15232),
         16#8B#           =>  --  A28B
          (0, 0, 15233, 15233),
         16#8C#           =>  --  A28C
          (0, 0, 15234, 15234),
         16#8D#           =>  --  A28D
          (0, 0, 15235, 15235),
         16#8E#           =>  --  A28E
          (0, 0, 15236, 15236),
         16#8F#           =>  --  A28F
          (0, 0, 15237, 15237),
         16#90#           =>  --  A290
          (0, 0, 15238, 15238),
         16#91#           =>  --  A291
          (0, 0, 15239, 15239),
         16#92#           =>  --  A292
          (0, 0, 15240, 15240),
         16#93#           =>  --  A293
          (0, 0, 15241, 15241),
         16#94#           =>  --  A294
          (0, 0, 15242, 15242),
         16#95#           =>  --  A295
          (0, 0, 15243, 15243),
         16#96#           =>  --  A296
          (0, 0, 15244, 15244),
         16#97#           =>  --  A297
          (0, 0, 15245, 15245),
         16#98#           =>  --  A298
          (0, 0, 15246, 15246),
         16#99#           =>  --  A299
          (0, 0, 15247, 15247),
         16#9A#           =>  --  A29A
          (0, 0, 15248, 15248),
         16#9B#           =>  --  A29B
          (0, 0, 15249, 15249),
         16#9C#           =>  --  A29C
          (0, 0, 15250, 15250),
         16#9D#           =>  --  A29D
          (0, 0, 15251, 15251),
         16#9E#           =>  --  A29E
          (0, 0, 15252, 15252),
         16#9F#           =>  --  A29F
          (0, 0, 15253, 15253),
         16#A0#           =>  --  A2A0
          (0, 0, 15254, 15254),
         16#A1#           =>  --  A2A1
          (0, 0, 15255, 15255),
         16#A2#           =>  --  A2A2
          (0, 0, 15256, 15256),
         16#A3#           =>  --  A2A3
          (0, 0, 15257, 15257),
         16#A4#           =>  --  A2A4
          (0, 0, 15258, 15258),
         16#A5#           =>  --  A2A5
          (0, 0, 15259, 15259),
         16#A6#           =>  --  A2A6
          (0, 0, 15260, 15260),
         16#A7#           =>  --  A2A7
          (0, 0, 15261, 15261),
         16#A8#           =>  --  A2A8
          (0, 0, 15262, 15262),
         16#A9#           =>  --  A2A9
          (0, 0, 15263, 15263),
         16#AA#           =>  --  A2AA
          (0, 0, 15264, 15264),
         16#AB#           =>  --  A2AB
          (0, 0, 15265, 15265),
         16#AC#           =>  --  A2AC
          (0, 0, 15266, 15266),
         16#AD#           =>  --  A2AD
          (0, 0, 15267, 15267),
         16#AE#           =>  --  A2AE
          (0, 0, 15268, 15268),
         16#AF#           =>  --  A2AF
          (0, 0, 15269, 15269),
         16#B0#           =>  --  A2B0
          (0, 0, 15270, 15270),
         16#B1#           =>  --  A2B1
          (0, 0, 15271, 15271),
         16#B2#           =>  --  A2B2
          (0, 0, 15272, 15272),
         16#B3#           =>  --  A2B3
          (0, 0, 15273, 15273),
         16#B4#           =>  --  A2B4
          (0, 0, 15274, 15274),
         16#B5#           =>  --  A2B5
          (0, 0, 15275, 15275),
         16#B6#           =>  --  A2B6
          (0, 0, 15276, 15276),
         16#B7#           =>  --  A2B7
          (0, 0, 15277, 15277),
         16#B8#           =>  --  A2B8
          (0, 0, 15278, 15278),
         16#B9#           =>  --  A2B9
          (0, 0, 15279, 15279),
         16#BA#           =>  --  A2BA
          (0, 0, 15280, 15280),
         16#BB#           =>  --  A2BB
          (0, 0, 15281, 15281),
         16#BC#           =>  --  A2BC
          (0, 0, 15282, 15282),
         16#BD#           =>  --  A2BD
          (0, 0, 15283, 15283),
         16#BE#           =>  --  A2BE
          (0, 0, 15284, 15284),
         16#BF#           =>  --  A2BF
          (0, 0, 15285, 15285),
         16#C0#           =>  --  A2C0
          (0, 0, 15286, 15286),
         16#C1#           =>  --  A2C1
          (0, 0, 15287, 15287),
         16#C2#           =>  --  A2C2
          (0, 0, 15288, 15288),
         16#C3#           =>  --  A2C3
          (0, 0, 15289, 15289),
         16#C4#           =>  --  A2C4
          (0, 0, 15290, 15290),
         16#C5#           =>  --  A2C5
          (0, 0, 15291, 15291),
         16#C6#           =>  --  A2C6
          (0, 0, 15292, 15292),
         16#C7#           =>  --  A2C7
          (0, 0, 15293, 15293),
         16#C8#           =>  --  A2C8
          (0, 0, 15294, 15294),
         16#C9#           =>  --  A2C9
          (0, 0, 15295, 15295),
         16#CA#           =>  --  A2CA
          (0, 0, 15296, 15296),
         16#CB#           =>  --  A2CB
          (0, 0, 15297, 15297),
         16#CC#           =>  --  A2CC
          (0, 0, 15298, 15298),
         16#CD#           =>  --  A2CD
          (0, 0, 15299, 15299),
         16#CE#           =>  --  A2CE
          (0, 0, 15300, 15300),
         16#CF#           =>  --  A2CF
          (0, 0, 15301, 15301),
         16#D0#           =>  --  A2D0
          (0, 0, 15302, 15302),
         16#D1#           =>  --  A2D1
          (0, 0, 15303, 15303),
         16#D2#           =>  --  A2D2
          (0, 0, 15304, 15304),
         16#D3#           =>  --  A2D3
          (0, 0, 15305, 15305),
         16#D4#           =>  --  A2D4
          (0, 0, 15306, 15306),
         16#D5#           =>  --  A2D5
          (0, 0, 15307, 15307),
         16#D6#           =>  --  A2D6
          (0, 0, 15308, 15308),
         16#D7#           =>  --  A2D7
          (0, 0, 15309, 15309),
         16#D8#           =>  --  A2D8
          (0, 0, 15310, 15310),
         16#D9#           =>  --  A2D9
          (0, 0, 15311, 15311),
         16#DA#           =>  --  A2DA
          (0, 0, 15312, 15312),
         16#DB#           =>  --  A2DB
          (0, 0, 15313, 15313),
         16#DC#           =>  --  A2DC
          (0, 0, 15314, 15314),
         16#DD#           =>  --  A2DD
          (0, 0, 15315, 15315),
         16#DE#           =>  --  A2DE
          (0, 0, 15316, 15316),
         16#DF#           =>  --  A2DF
          (0, 0, 15317, 15317),
         16#E0#           =>  --  A2E0
          (0, 0, 15318, 15318),
         16#E1#           =>  --  A2E1
          (0, 0, 15319, 15319),
         16#E2#           =>  --  A2E2
          (0, 0, 15320, 15320),
         16#E3#           =>  --  A2E3
          (0, 0, 15321, 15321),
         16#E4#           =>  --  A2E4
          (0, 0, 15322, 15322),
         16#E5#           =>  --  A2E5
          (0, 0, 15323, 15323),
         16#E6#           =>  --  A2E6
          (0, 0, 15324, 15324),
         16#E7#           =>  --  A2E7
          (0, 0, 15325, 15325),
         16#E8#           =>  --  A2E8
          (0, 0, 15326, 15326),
         16#E9#           =>  --  A2E9
          (0, 0, 15327, 15327),
         16#EA#           =>  --  A2EA
          (0, 0, 15328, 15328),
         16#EB#           =>  --  A2EB
          (0, 0, 15329, 15329),
         16#EC#           =>  --  A2EC
          (0, 0, 15330, 15330),
         16#ED#           =>  --  A2ED
          (0, 0, 15331, 15331),
         16#EE#           =>  --  A2EE
          (0, 0, 15332, 15332),
         16#EF#           =>  --  A2EF
          (0, 0, 15333, 15333),
         16#F0#           =>  --  A2F0
          (0, 0, 15334, 15334),
         16#F1#           =>  --  A2F1
          (0, 0, 15335, 15335),
         16#F2#           =>  --  A2F2
          (0, 0, 15336, 15336),
         16#F3#           =>  --  A2F3
          (0, 0, 15337, 15337),
         16#F4#           =>  --  A2F4
          (0, 0, 15338, 15338),
         16#F5#           =>  --  A2F5
          (0, 0, 15339, 15339),
         16#F6#           =>  --  A2F6
          (0, 0, 15340, 15340),
         16#F7#           =>  --  A2F7
          (0, 0, 15341, 15341),
         16#F8#           =>  --  A2F8
          (0, 0, 15342, 15342),
         16#F9#           =>  --  A2F9
          (0, 0, 15343, 15343),
         16#FA#           =>  --  A2FA
          (0, 0, 15344, 15344),
         16#FB#           =>  --  A2FB
          (0, 0, 15345, 15345),
         16#FC#           =>  --  A2FC
          (0, 0, 15346, 15346),
         16#FD#           =>  --  A2FD
          (0, 0, 15347, 15347),
         16#FE#           =>  --  A2FE
          (0, 0, 15348, 15348),
         16#FF#           =>  --  A2FF
          (0, 0, 15349, 15349),
         others           =>
          (0, 0, 0, 0));

   Group_00A3 : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  A300
          (0, 0, 15350, 15350),
         16#01#           =>  --  A301
          (0, 0, 15351, 15351),
         16#02#           =>  --  A302
          (0, 0, 15352, 15352),
         16#03#           =>  --  A303
          (0, 0, 15353, 15353),
         16#04#           =>  --  A304
          (0, 0, 15354, 15354),
         16#05#           =>  --  A305
          (0, 0, 15355, 15355),
         16#06#           =>  --  A306
          (0, 0, 15356, 15356),
         16#07#           =>  --  A307
          (0, 0, 15357, 15357),
         16#08#           =>  --  A308
          (0, 0, 15358, 15358),
         16#09#           =>  --  A309
          (0, 0, 15359, 15359),
         16#0A#           =>  --  A30A
          (0, 0, 15360, 15360),
         16#0B#           =>  --  A30B
          (0, 0, 15361, 15361),
         16#0C#           =>  --  A30C
          (0, 0, 15362, 15362),
         16#0D#           =>  --  A30D
          (0, 0, 15363, 15363),
         16#0E#           =>  --  A30E
          (0, 0, 15364, 15364),
         16#0F#           =>  --  A30F
          (0, 0, 15365, 15365),
         16#10#           =>  --  A310
          (0, 0, 15366, 15366),
         16#11#           =>  --  A311
          (0, 0, 15367, 15367),
         16#12#           =>  --  A312
          (0, 0, 15368, 15368),
         16#13#           =>  --  A313
          (0, 0, 15369, 15369),
         16#14#           =>  --  A314
          (0, 0, 15370, 15370),
         16#15#           =>  --  A315
          (0, 0, 15371, 15371),
         16#16#           =>  --  A316
          (0, 0, 15372, 15372),
         16#17#           =>  --  A317
          (0, 0, 15373, 15373),
         16#18#           =>  --  A318
          (0, 0, 15374, 15374),
         16#19#           =>  --  A319
          (0, 0, 15375, 15375),
         16#1A#           =>  --  A31A
          (0, 0, 15376, 15376),
         16#1B#           =>  --  A31B
          (0, 0, 15377, 15377),
         16#1C#           =>  --  A31C
          (0, 0, 15378, 15378),
         16#1D#           =>  --  A31D
          (0, 0, 15379, 15379),
         16#1E#           =>  --  A31E
          (0, 0, 15380, 15380),
         16#1F#           =>  --  A31F
          (0, 0, 15381, 15381),
         16#20#           =>  --  A320
          (0, 0, 15382, 15382),
         16#21#           =>  --  A321
          (0, 0, 15383, 15383),
         16#22#           =>  --  A322
          (0, 0, 15384, 15384),
         16#23#           =>  --  A323
          (0, 0, 15385, 15385),
         16#24#           =>  --  A324
          (0, 0, 15386, 15386),
         16#25#           =>  --  A325
          (0, 0, 15387, 15387),
         16#26#           =>  --  A326
          (0, 0, 15388, 15388),
         16#27#           =>  --  A327
          (0, 0, 15389, 15389),
         16#28#           =>  --  A328
          (0, 0, 15390, 15390),
         16#29#           =>  --  A329
          (0, 0, 15391, 15391),
         16#2A#           =>  --  A32A
          (0, 0, 15392, 15392),
         16#2B#           =>  --  A32B
          (0, 0, 15393, 15393),
         16#2C#           =>  --  A32C
          (0, 0, 15394, 15394),
         16#2D#           =>  --  A32D
          (0, 0, 15395, 15395),
         16#2E#           =>  --  A32E
          (0, 0, 15396, 15396),
         16#2F#           =>  --  A32F
          (0, 0, 15397, 15397),
         16#30#           =>  --  A330
          (0, 0, 15398, 15398),
         16#31#           =>  --  A331
          (0, 0, 15399, 15399),
         16#32#           =>  --  A332
          (0, 0, 15400, 15400),
         16#33#           =>  --  A333
          (0, 0, 15401, 15401),
         16#34#           =>  --  A334
          (0, 0, 15402, 15402),
         16#35#           =>  --  A335
          (0, 0, 15403, 15403),
         16#36#           =>  --  A336
          (0, 0, 15404, 15404),
         16#37#           =>  --  A337
          (0, 0, 15405, 15405),
         16#38#           =>  --  A338
          (0, 0, 15406, 15406),
         16#39#           =>  --  A339
          (0, 0, 15407, 15407),
         16#3A#           =>  --  A33A
          (0, 0, 15408, 15408),
         16#3B#           =>  --  A33B
          (0, 0, 15409, 15409),
         16#3C#           =>  --  A33C
          (0, 0, 15410, 15410),
         16#3D#           =>  --  A33D
          (0, 0, 15411, 15411),
         16#3E#           =>  --  A33E
          (0, 0, 15412, 15412),
         16#3F#           =>  --  A33F
          (0, 0, 15413, 15413),
         16#40#           =>  --  A340
          (0, 0, 15414, 15414),
         16#41#           =>  --  A341
          (0, 0, 15415, 15415),
         16#42#           =>  --  A342
          (0, 0, 15416, 15416),
         16#43#           =>  --  A343
          (0, 0, 15417, 15417),
         16#44#           =>  --  A344
          (0, 0, 15418, 15418),
         16#45#           =>  --  A345
          (0, 0, 15419, 15419),
         16#46#           =>  --  A346
          (0, 0, 15420, 15420),
         16#47#           =>  --  A347
          (0, 0, 15421, 15421),
         16#48#           =>  --  A348
          (0, 0, 15422, 15422),
         16#49#           =>  --  A349
          (0, 0, 15423, 15423),
         16#4A#           =>  --  A34A
          (0, 0, 15424, 15424),
         16#4B#           =>  --  A34B
          (0, 0, 15425, 15425),
         16#4C#           =>  --  A34C
          (0, 0, 15426, 15426),
         16#4D#           =>  --  A34D
          (0, 0, 15427, 15427),
         16#4E#           =>  --  A34E
          (0, 0, 15428, 15428),
         16#4F#           =>  --  A34F
          (0, 0, 15429, 15429),
         16#50#           =>  --  A350
          (0, 0, 15430, 15430),
         16#51#           =>  --  A351
          (0, 0, 15431, 15431),
         16#52#           =>  --  A352
          (0, 0, 15432, 15432),
         16#53#           =>  --  A353
          (0, 0, 15433, 15433),
         16#54#           =>  --  A354
          (0, 0, 15434, 15434),
         16#55#           =>  --  A355
          (0, 0, 15435, 15435),
         16#56#           =>  --  A356
          (0, 0, 15436, 15436),
         16#57#           =>  --  A357
          (0, 0, 15437, 15437),
         16#58#           =>  --  A358
          (0, 0, 15438, 15438),
         16#59#           =>  --  A359
          (0, 0, 15439, 15439),
         16#5A#           =>  --  A35A
          (0, 0, 15440, 15440),
         16#5B#           =>  --  A35B
          (0, 0, 15441, 15441),
         16#5C#           =>  --  A35C
          (0, 0, 15442, 15442),
         16#5D#           =>  --  A35D
          (0, 0, 15443, 15443),
         16#5E#           =>  --  A35E
          (0, 0, 15444, 15444),
         16#5F#           =>  --  A35F
          (0, 0, 15445, 15445),
         16#60#           =>  --  A360
          (0, 0, 15446, 15446),
         16#61#           =>  --  A361
          (0, 0, 15447, 15447),
         16#62#           =>  --  A362
          (0, 0, 15448, 15448),
         16#63#           =>  --  A363
          (0, 0, 15449, 15449),
         16#64#           =>  --  A364
          (0, 0, 15450, 15450),
         16#65#           =>  --  A365
          (0, 0, 15451, 15451),
         16#66#           =>  --  A366
          (0, 0, 15452, 15452),
         16#67#           =>  --  A367
          (0, 0, 15453, 15453),
         16#68#           =>  --  A368
          (0, 0, 15454, 15454),
         16#69#           =>  --  A369
          (0, 0, 15455, 15455),
         16#6A#           =>  --  A36A
          (0, 0, 15456, 15456),
         16#6B#           =>  --  A36B
          (0, 0, 15457, 15457),
         16#6C#           =>  --  A36C
          (0, 0, 15458, 15458),
         16#6D#           =>  --  A36D
          (0, 0, 15459, 15459),
         16#6E#           =>  --  A36E
          (0, 0, 15460, 15460),
         16#6F#           =>  --  A36F
          (0, 0, 15461, 15461),
         16#70#           =>  --  A370
          (0, 0, 15462, 15462),
         16#71#           =>  --  A371
          (0, 0, 15463, 15463),
         16#72#           =>  --  A372
          (0, 0, 15464, 15464),
         16#73#           =>  --  A373
          (0, 0, 15465, 15465),
         16#74#           =>  --  A374
          (0, 0, 15466, 15466),
         16#75#           =>  --  A375
          (0, 0, 15467, 15467),
         16#76#           =>  --  A376
          (0, 0, 15468, 15468),
         16#77#           =>  --  A377
          (0, 0, 15469, 15469),
         16#78#           =>  --  A378
          (0, 0, 15470, 15470),
         16#79#           =>  --  A379
          (0, 0, 15471, 15471),
         16#7A#           =>  --  A37A
          (0, 0, 15472, 15472),
         16#7B#           =>  --  A37B
          (0, 0, 15473, 15473),
         16#7C#           =>  --  A37C
          (0, 0, 15474, 15474),
         16#7D#           =>  --  A37D
          (0, 0, 15475, 15475),
         16#7E#           =>  --  A37E
          (0, 0, 15476, 15476),
         16#7F#           =>  --  A37F
          (0, 0, 15477, 15477),
         16#80#           =>  --  A380
          (0, 0, 15478, 15478),
         16#81#           =>  --  A381
          (0, 0, 15479, 15479),
         16#82#           =>  --  A382
          (0, 0, 15480, 15480),
         16#83#           =>  --  A383
          (0, 0, 15481, 15481),
         16#84#           =>  --  A384
          (0, 0, 15482, 15482),
         16#85#           =>  --  A385
          (0, 0, 15483, 15483),
         16#86#           =>  --  A386
          (0, 0, 15484, 15484),
         16#87#           =>  --  A387
          (0, 0, 15485, 15485),
         16#88#           =>  --  A388
          (0, 0, 15486, 15486),
         16#89#           =>  --  A389
          (0, 0, 15487, 15487),
         16#8A#           =>  --  A38A
          (0, 0, 15488, 15488),
         16#8B#           =>  --  A38B
          (0, 0, 15489, 15489),
         16#8C#           =>  --  A38C
          (0, 0, 15490, 15490),
         16#8D#           =>  --  A38D
          (0, 0, 15491, 15491),
         16#8E#           =>  --  A38E
          (0, 0, 15492, 15492),
         16#8F#           =>  --  A38F
          (0, 0, 15493, 15493),
         16#90#           =>  --  A390
          (0, 0, 15494, 15494),
         16#91#           =>  --  A391
          (0, 0, 15495, 15495),
         16#92#           =>  --  A392
          (0, 0, 15496, 15496),
         16#93#           =>  --  A393
          (0, 0, 15497, 15497),
         16#94#           =>  --  A394
          (0, 0, 15498, 15498),
         16#95#           =>  --  A395
          (0, 0, 15499, 15499),
         16#96#           =>  --  A396
          (0, 0, 15500, 15500),
         16#97#           =>  --  A397
          (0, 0, 15501, 15501),
         16#98#           =>  --  A398
          (0, 0, 15502, 15502),
         16#99#           =>  --  A399
          (0, 0, 15503, 15503),
         16#9A#           =>  --  A39A
          (0, 0, 15504, 15504),
         16#9B#           =>  --  A39B
          (0, 0, 15505, 15505),
         16#9C#           =>  --  A39C
          (0, 0, 15506, 15506),
         16#9D#           =>  --  A39D
          (0, 0, 15507, 15507),
         16#9E#           =>  --  A39E
          (0, 0, 15508, 15508),
         16#9F#           =>  --  A39F
          (0, 0, 15509, 15509),
         16#A0#           =>  --  A3A0
          (0, 0, 15510, 15510),
         16#A1#           =>  --  A3A1
          (0, 0, 15511, 15511),
         16#A2#           =>  --  A3A2
          (0, 0, 15512, 15512),
         16#A3#           =>  --  A3A3
          (0, 0, 15513, 15513),
         16#A4#           =>  --  A3A4
          (0, 0, 15514, 15514),
         16#A5#           =>  --  A3A5
          (0, 0, 15515, 15515),
         16#A6#           =>  --  A3A6
          (0, 0, 15516, 15516),
         16#A7#           =>  --  A3A7
          (0, 0, 15517, 15517),
         16#A8#           =>  --  A3A8
          (0, 0, 15518, 15518),
         16#A9#           =>  --  A3A9
          (0, 0, 15519, 15519),
         16#AA#           =>  --  A3AA
          (0, 0, 15520, 15520),
         16#AB#           =>  --  A3AB
          (0, 0, 15521, 15521),
         16#AC#           =>  --  A3AC
          (0, 0, 15522, 15522),
         16#AD#           =>  --  A3AD
          (0, 0, 15523, 15523),
         16#AE#           =>  --  A3AE
          (0, 0, 15524, 15524),
         16#AF#           =>  --  A3AF
          (0, 0, 15525, 15525),
         16#B0#           =>  --  A3B0
          (0, 0, 15526, 15526),
         16#B1#           =>  --  A3B1
          (0, 0, 15527, 15527),
         16#B2#           =>  --  A3B2
          (0, 0, 15528, 15528),
         16#B3#           =>  --  A3B3
          (0, 0, 15529, 15529),
         16#B4#           =>  --  A3B4
          (0, 0, 15530, 15530),
         16#B5#           =>  --  A3B5
          (0, 0, 15531, 15531),
         16#B6#           =>  --  A3B6
          (0, 0, 15532, 15532),
         16#B7#           =>  --  A3B7
          (0, 0, 15533, 15533),
         16#B8#           =>  --  A3B8
          (0, 0, 15534, 15534),
         16#B9#           =>  --  A3B9
          (0, 0, 15535, 15535),
         16#BA#           =>  --  A3BA
          (0, 0, 15536, 15536),
         16#BB#           =>  --  A3BB
          (0, 0, 15537, 15537),
         16#BC#           =>  --  A3BC
          (0, 0, 15538, 15538),
         16#BD#           =>  --  A3BD
          (0, 0, 15539, 15539),
         16#BE#           =>  --  A3BE
          (0, 0, 15540, 15540),
         16#BF#           =>  --  A3BF
          (0, 0, 15541, 15541),
         16#C0#           =>  --  A3C0
          (0, 0, 15542, 15542),
         16#C1#           =>  --  A3C1
          (0, 0, 15543, 15543),
         16#C2#           =>  --  A3C2
          (0, 0, 15544, 15544),
         16#C3#           =>  --  A3C3
          (0, 0, 15545, 15545),
         16#C4#           =>  --  A3C4
          (0, 0, 15546, 15546),
         16#C5#           =>  --  A3C5
          (0, 0, 15547, 15547),
         16#C6#           =>  --  A3C6
          (0, 0, 15548, 15548),
         16#C7#           =>  --  A3C7
          (0, 0, 15549, 15549),
         16#C8#           =>  --  A3C8
          (0, 0, 15550, 15550),
         16#C9#           =>  --  A3C9
          (0, 0, 15551, 15551),
         16#CA#           =>  --  A3CA
          (0, 0, 15552, 15552),
         16#CB#           =>  --  A3CB
          (0, 0, 15553, 15553),
         16#CC#           =>  --  A3CC
          (0, 0, 15554, 15554),
         16#CD#           =>  --  A3CD
          (0, 0, 15555, 15555),
         16#CE#           =>  --  A3CE
          (0, 0, 15556, 15556),
         16#CF#           =>  --  A3CF
          (0, 0, 15557, 15557),
         16#D0#           =>  --  A3D0
          (0, 0, 15558, 15558),
         16#D1#           =>  --  A3D1
          (0, 0, 15559, 15559),
         16#D2#           =>  --  A3D2
          (0, 0, 15560, 15560),
         16#D3#           =>  --  A3D3
          (0, 0, 15561, 15561),
         16#D4#           =>  --  A3D4
          (0, 0, 15562, 15562),
         16#D5#           =>  --  A3D5
          (0, 0, 15563, 15563),
         16#D6#           =>  --  A3D6
          (0, 0, 15564, 15564),
         16#D7#           =>  --  A3D7
          (0, 0, 15565, 15565),
         16#D8#           =>  --  A3D8
          (0, 0, 15566, 15566),
         16#D9#           =>  --  A3D9
          (0, 0, 15567, 15567),
         16#DA#           =>  --  A3DA
          (0, 0, 15568, 15568),
         16#DB#           =>  --  A3DB
          (0, 0, 15569, 15569),
         16#DC#           =>  --  A3DC
          (0, 0, 15570, 15570),
         16#DD#           =>  --  A3DD
          (0, 0, 15571, 15571),
         16#DE#           =>  --  A3DE
          (0, 0, 15572, 15572),
         16#DF#           =>  --  A3DF
          (0, 0, 15573, 15573),
         16#E0#           =>  --  A3E0
          (0, 0, 15574, 15574),
         16#E1#           =>  --  A3E1
          (0, 0, 15575, 15575),
         16#E2#           =>  --  A3E2
          (0, 0, 15576, 15576),
         16#E3#           =>  --  A3E3
          (0, 0, 15577, 15577),
         16#E4#           =>  --  A3E4
          (0, 0, 15578, 15578),
         16#E5#           =>  --  A3E5
          (0, 0, 15579, 15579),
         16#E6#           =>  --  A3E6
          (0, 0, 15580, 15580),
         16#E7#           =>  --  A3E7
          (0, 0, 15581, 15581),
         16#E8#           =>  --  A3E8
          (0, 0, 15582, 15582),
         16#E9#           =>  --  A3E9
          (0, 0, 15583, 15583),
         16#EA#           =>  --  A3EA
          (0, 0, 15584, 15584),
         16#EB#           =>  --  A3EB
          (0, 0, 15585, 15585),
         16#EC#           =>  --  A3EC
          (0, 0, 15586, 15586),
         16#ED#           =>  --  A3ED
          (0, 0, 15587, 15587),
         16#EE#           =>  --  A3EE
          (0, 0, 15588, 15588),
         16#EF#           =>  --  A3EF
          (0, 0, 15589, 15589),
         16#F0#           =>  --  A3F0
          (0, 0, 15590, 15590),
         16#F1#           =>  --  A3F1
          (0, 0, 15591, 15591),
         16#F2#           =>  --  A3F2
          (0, 0, 15592, 15592),
         16#F3#           =>  --  A3F3
          (0, 0, 15593, 15593),
         16#F4#           =>  --  A3F4
          (0, 0, 15594, 15594),
         16#F5#           =>  --  A3F5
          (0, 0, 15595, 15595),
         16#F6#           =>  --  A3F6
          (0, 0, 15596, 15596),
         16#F7#           =>  --  A3F7
          (0, 0, 15597, 15597),
         16#F8#           =>  --  A3F8
          (0, 0, 15598, 15598),
         16#F9#           =>  --  A3F9
          (0, 0, 15599, 15599),
         16#FA#           =>  --  A3FA
          (0, 0, 15600, 15600),
         16#FB#           =>  --  A3FB
          (0, 0, 15601, 15601),
         16#FC#           =>  --  A3FC
          (0, 0, 15602, 15602),
         16#FD#           =>  --  A3FD
          (0, 0, 15603, 15603),
         16#FE#           =>  --  A3FE
          (0, 0, 15604, 15604),
         16#FF#           =>  --  A3FF
          (0, 0, 15605, 15605),
         others           =>
          (0, 0, 0, 0));

   Group_00A4 : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  A400
          (0, 0, 15606, 15606),
         16#01#           =>  --  A401
          (0, 0, 15607, 15607),
         16#02#           =>  --  A402
          (0, 0, 15608, 15608),
         16#03#           =>  --  A403
          (0, 0, 15609, 15609),
         16#04#           =>  --  A404
          (0, 0, 15610, 15610),
         16#05#           =>  --  A405
          (0, 0, 15611, 15611),
         16#06#           =>  --  A406
          (0, 0, 15612, 15612),
         16#07#           =>  --  A407
          (0, 0, 15613, 15613),
         16#08#           =>  --  A408
          (0, 0, 15614, 15614),
         16#09#           =>  --  A409
          (0, 0, 15615, 15615),
         16#0A#           =>  --  A40A
          (0, 0, 15616, 15616),
         16#0B#           =>  --  A40B
          (0, 0, 15617, 15617),
         16#0C#           =>  --  A40C
          (0, 0, 15618, 15618),
         16#0D#           =>  --  A40D
          (0, 0, 15619, 15619),
         16#0E#           =>  --  A40E
          (0, 0, 15620, 15620),
         16#0F#           =>  --  A40F
          (0, 0, 15621, 15621),
         16#10#           =>  --  A410
          (0, 0, 15622, 15622),
         16#11#           =>  --  A411
          (0, 0, 15623, 15623),
         16#12#           =>  --  A412
          (0, 0, 15624, 15624),
         16#13#           =>  --  A413
          (0, 0, 15625, 15625),
         16#14#           =>  --  A414
          (0, 0, 15626, 15626),
         16#15#           =>  --  A415
          (0, 0, 15627, 15627),
         16#16#           =>  --  A416
          (0, 0, 15628, 15628),
         16#17#           =>  --  A417
          (0, 0, 15629, 15629),
         16#18#           =>  --  A418
          (0, 0, 15630, 15630),
         16#19#           =>  --  A419
          (0, 0, 15631, 15631),
         16#1A#           =>  --  A41A
          (0, 0, 15632, 15632),
         16#1B#           =>  --  A41B
          (0, 0, 15633, 15633),
         16#1C#           =>  --  A41C
          (0, 0, 15634, 15634),
         16#1D#           =>  --  A41D
          (0, 0, 15635, 15635),
         16#1E#           =>  --  A41E
          (0, 0, 15636, 15636),
         16#1F#           =>  --  A41F
          (0, 0, 15637, 15637),
         16#20#           =>  --  A420
          (0, 0, 15638, 15638),
         16#21#           =>  --  A421
          (0, 0, 15639, 15639),
         16#22#           =>  --  A422
          (0, 0, 15640, 15640),
         16#23#           =>  --  A423
          (0, 0, 15641, 15641),
         16#24#           =>  --  A424
          (0, 0, 15642, 15642),
         16#25#           =>  --  A425
          (0, 0, 15643, 15643),
         16#26#           =>  --  A426
          (0, 0, 15644, 15644),
         16#27#           =>  --  A427
          (0, 0, 15645, 15645),
         16#28#           =>  --  A428
          (0, 0, 15646, 15646),
         16#29#           =>  --  A429
          (0, 0, 15647, 15647),
         16#2A#           =>  --  A42A
          (0, 0, 15648, 15648),
         16#2B#           =>  --  A42B
          (0, 0, 15649, 15649),
         16#2C#           =>  --  A42C
          (0, 0, 15650, 15650),
         16#2D#           =>  --  A42D
          (0, 0, 15651, 15651),
         16#2E#           =>  --  A42E
          (0, 0, 15652, 15652),
         16#2F#           =>  --  A42F
          (0, 0, 15653, 15653),
         16#30#           =>  --  A430
          (0, 0, 15654, 15654),
         16#31#           =>  --  A431
          (0, 0, 15655, 15655),
         16#32#           =>  --  A432
          (0, 0, 15656, 15656),
         16#33#           =>  --  A433
          (0, 0, 15657, 15657),
         16#34#           =>  --  A434
          (0, 0, 15658, 15658),
         16#35#           =>  --  A435
          (0, 0, 15659, 15659),
         16#36#           =>  --  A436
          (0, 0, 15660, 15660),
         16#37#           =>  --  A437
          (0, 0, 15661, 15661),
         16#38#           =>  --  A438
          (0, 0, 15662, 15662),
         16#39#           =>  --  A439
          (0, 0, 15663, 15663),
         16#3A#           =>  --  A43A
          (0, 0, 15664, 15664),
         16#3B#           =>  --  A43B
          (0, 0, 15665, 15665),
         16#3C#           =>  --  A43C
          (0, 0, 15666, 15666),
         16#3D#           =>  --  A43D
          (0, 0, 15667, 15667),
         16#3E#           =>  --  A43E
          (0, 0, 15668, 15668),
         16#3F#           =>  --  A43F
          (0, 0, 15669, 15669),
         16#40#           =>  --  A440
          (0, 0, 15670, 15670),
         16#41#           =>  --  A441
          (0, 0, 15671, 15671),
         16#42#           =>  --  A442
          (0, 0, 15672, 15672),
         16#43#           =>  --  A443
          (0, 0, 15673, 15673),
         16#44#           =>  --  A444
          (0, 0, 15674, 15674),
         16#45#           =>  --  A445
          (0, 0, 15675, 15675),
         16#46#           =>  --  A446
          (0, 0, 15676, 15676),
         16#47#           =>  --  A447
          (0, 0, 15677, 15677),
         16#48#           =>  --  A448
          (0, 0, 15678, 15678),
         16#49#           =>  --  A449
          (0, 0, 15679, 15679),
         16#4A#           =>  --  A44A
          (0, 0, 15680, 15680),
         16#4B#           =>  --  A44B
          (0, 0, 15681, 15681),
         16#4C#           =>  --  A44C
          (0, 0, 15682, 15682),
         16#4D#           =>  --  A44D
          (0, 0, 15683, 15683),
         16#4E#           =>  --  A44E
          (0, 0, 15684, 15684),
         16#4F#           =>  --  A44F
          (0, 0, 15685, 15685),
         16#50#           =>  --  A450
          (0, 0, 15686, 15686),
         16#51#           =>  --  A451
          (0, 0, 15687, 15687),
         16#52#           =>  --  A452
          (0, 0, 15688, 15688),
         16#53#           =>  --  A453
          (0, 0, 15689, 15689),
         16#54#           =>  --  A454
          (0, 0, 15690, 15690),
         16#55#           =>  --  A455
          (0, 0, 15691, 15691),
         16#56#           =>  --  A456
          (0, 0, 15692, 15692),
         16#57#           =>  --  A457
          (0, 0, 15693, 15693),
         16#58#           =>  --  A458
          (0, 0, 15694, 15694),
         16#59#           =>  --  A459
          (0, 0, 15695, 15695),
         16#5A#           =>  --  A45A
          (0, 0, 15696, 15696),
         16#5B#           =>  --  A45B
          (0, 0, 15697, 15697),
         16#5C#           =>  --  A45C
          (0, 0, 15698, 15698),
         16#5D#           =>  --  A45D
          (0, 0, 15699, 15699),
         16#5E#           =>  --  A45E
          (0, 0, 15700, 15700),
         16#5F#           =>  --  A45F
          (0, 0, 15701, 15701),
         16#60#           =>  --  A460
          (0, 0, 15702, 15702),
         16#61#           =>  --  A461
          (0, 0, 15703, 15703),
         16#62#           =>  --  A462
          (0, 0, 15704, 15704),
         16#63#           =>  --  A463
          (0, 0, 15705, 15705),
         16#64#           =>  --  A464
          (0, 0, 15706, 15706),
         16#65#           =>  --  A465
          (0, 0, 15707, 15707),
         16#66#           =>  --  A466
          (0, 0, 15708, 15708),
         16#67#           =>  --  A467
          (0, 0, 15709, 15709),
         16#68#           =>  --  A468
          (0, 0, 15710, 15710),
         16#69#           =>  --  A469
          (0, 0, 15711, 15711),
         16#6A#           =>  --  A46A
          (0, 0, 15712, 15712),
         16#6B#           =>  --  A46B
          (0, 0, 15713, 15713),
         16#6C#           =>  --  A46C
          (0, 0, 15714, 15714),
         16#6D#           =>  --  A46D
          (0, 0, 15715, 15715),
         16#6E#           =>  --  A46E
          (0, 0, 15716, 15716),
         16#6F#           =>  --  A46F
          (0, 0, 15717, 15717),
         16#70#           =>  --  A470
          (0, 0, 15718, 15718),
         16#71#           =>  --  A471
          (0, 0, 15719, 15719),
         16#72#           =>  --  A472
          (0, 0, 15720, 15720),
         16#73#           =>  --  A473
          (0, 0, 15721, 15721),
         16#74#           =>  --  A474
          (0, 0, 15722, 15722),
         16#75#           =>  --  A475
          (0, 0, 15723, 15723),
         16#76#           =>  --  A476
          (0, 0, 15724, 15724),
         16#77#           =>  --  A477
          (0, 0, 15725, 15725),
         16#78#           =>  --  A478
          (0, 0, 15726, 15726),
         16#79#           =>  --  A479
          (0, 0, 15727, 15727),
         16#7A#           =>  --  A47A
          (0, 0, 15728, 15728),
         16#7B#           =>  --  A47B
          (0, 0, 15729, 15729),
         16#7C#           =>  --  A47C
          (0, 0, 15730, 15730),
         16#7D#           =>  --  A47D
          (0, 0, 15731, 15731),
         16#7E#           =>  --  A47E
          (0, 0, 15732, 15732),
         16#7F#           =>  --  A47F
          (0, 0, 15733, 15733),
         16#80#           =>  --  A480
          (0, 0, 15734, 15734),
         16#81#           =>  --  A481
          (0, 0, 15735, 15735),
         16#82#           =>  --  A482
          (0, 0, 15736, 15736),
         16#83#           =>  --  A483
          (0, 0, 15737, 15737),
         16#84#           =>  --  A484
          (0, 0, 15738, 15738),
         16#85#           =>  --  A485
          (0, 0, 15739, 15739),
         16#86#           =>  --  A486
          (0, 0, 15740, 15740),
         16#87#           =>  --  A487
          (0, 0, 15741, 15741),
         16#88#           =>  --  A488
          (0, 0, 15742, 15742),
         16#89#           =>  --  A489
          (0, 0, 15743, 15743),
         16#8A#           =>  --  A48A
          (0, 0, 15744, 15744),
         16#8B#           =>  --  A48B
          (0, 0, 15745, 15745),
         16#8C#           =>  --  A48C
          (0, 0, 15746, 15746),
         16#90#           =>  --  A490
          (0, 0, 15747, 15747),
         16#91#           =>  --  A491
          (0, 0, 15748, 15748),
         16#92#           =>  --  A492
          (0, 0, 15749, 15749),
         16#93#           =>  --  A493
          (0, 0, 15750, 15750),
         16#94#           =>  --  A494
          (0, 0, 15751, 15751),
         16#95#           =>  --  A495
          (0, 0, 15752, 15752),
         16#96#           =>  --  A496
          (0, 0, 15753, 15753),
         16#97#           =>  --  A497
          (0, 0, 15754, 15754),
         16#98#           =>  --  A498
          (0, 0, 15755, 15755),
         16#99#           =>  --  A499
          (0, 0, 15756, 15756),
         16#9A#           =>  --  A49A
          (0, 0, 15757, 15757),
         16#9B#           =>  --  A49B
          (0, 0, 15758, 15758),
         16#9C#           =>  --  A49C
          (0, 0, 15759, 15759),
         16#9D#           =>  --  A49D
          (0, 0, 15760, 15760),
         16#9E#           =>  --  A49E
          (0, 0, 15761, 15761),
         16#9F#           =>  --  A49F
          (0, 0, 15762, 15762),
         16#A0#           =>  --  A4A0
          (0, 0, 15763, 15763),
         16#A1#           =>  --  A4A1
          (0, 0, 15764, 15764),
         16#A2#           =>  --  A4A2
          (0, 0, 15765, 15765),
         16#A3#           =>  --  A4A3
          (0, 0, 15766, 15766),
         16#A4#           =>  --  A4A4
          (0, 0, 15767, 15767),
         16#A5#           =>  --  A4A5
          (0, 0, 15768, 15768),
         16#A6#           =>  --  A4A6
          (0, 0, 15769, 15769),
         16#A7#           =>  --  A4A7
          (0, 0, 15770, 15770),
         16#A8#           =>  --  A4A8
          (0, 0, 15771, 15771),
         16#A9#           =>  --  A4A9
          (0, 0, 15772, 15772),
         16#AA#           =>  --  A4AA
          (0, 0, 15773, 15773),
         16#AB#           =>  --  A4AB
          (0, 0, 15774, 15774),
         16#AC#           =>  --  A4AC
          (0, 0, 15775, 15775),
         16#AD#           =>  --  A4AD
          (0, 0, 15776, 15776),
         16#AE#           =>  --  A4AE
          (0, 0, 15777, 15777),
         16#AF#           =>  --  A4AF
          (0, 0, 15778, 15778),
         16#B0#           =>  --  A4B0
          (0, 0, 15779, 15779),
         16#B1#           =>  --  A4B1
          (0, 0, 15780, 15780),
         16#B2#           =>  --  A4B2
          (0, 0, 15781, 15781),
         16#B3#           =>  --  A4B3
          (0, 0, 15782, 15782),
         16#B4#           =>  --  A4B4
          (0, 0, 15783, 15783),
         16#B5#           =>  --  A4B5
          (0, 0, 15784, 15784),
         16#B6#           =>  --  A4B6
          (0, 0, 15785, 15785),
         16#B7#           =>  --  A4B7
          (0, 0, 15786, 15786),
         16#B8#           =>  --  A4B8
          (0, 0, 15787, 15787),
         16#B9#           =>  --  A4B9
          (0, 0, 15788, 15788),
         16#BA#           =>  --  A4BA
          (0, 0, 15789, 15789),
         16#BB#           =>  --  A4BB
          (0, 0, 15790, 15790),
         16#BC#           =>  --  A4BC
          (0, 0, 15791, 15791),
         16#BD#           =>  --  A4BD
          (0, 0, 15792, 15792),
         16#BE#           =>  --  A4BE
          (0, 0, 15793, 15793),
         16#BF#           =>  --  A4BF
          (0, 0, 15794, 15794),
         16#C0#           =>  --  A4C0
          (0, 0, 15795, 15795),
         16#C1#           =>  --  A4C1
          (0, 0, 15796, 15796),
         16#C2#           =>  --  A4C2
          (0, 0, 15797, 15797),
         16#C3#           =>  --  A4C3
          (0, 0, 15798, 15798),
         16#C4#           =>  --  A4C4
          (0, 0, 15799, 15799),
         16#C5#           =>  --  A4C5
          (0, 0, 15800, 15800),
         16#C6#           =>  --  A4C6
          (0, 0, 15801, 15801),
         16#D0#           =>  --  A4D0
          (0, 0, 15802, 15802),
         16#D1#           =>  --  A4D1
          (0, 0, 15803, 15803),
         16#D2#           =>  --  A4D2
          (0, 0, 15804, 15804),
         16#D3#           =>  --  A4D3
          (0, 0, 15805, 15805),
         16#D4#           =>  --  A4D4
          (0, 0, 15806, 15806),
         16#D5#           =>  --  A4D5
          (0, 0, 15807, 15807),
         16#D6#           =>  --  A4D6
          (0, 0, 15808, 15808),
         16#D7#           =>  --  A4D7
          (0, 0, 15809, 15809),
         16#D8#           =>  --  A4D8
          (0, 0, 15810, 15810),
         16#D9#           =>  --  A4D9
          (0, 0, 15811, 15811),
         16#DA#           =>  --  A4DA
          (0, 0, 15812, 15812),
         16#DB#           =>  --  A4DB
          (0, 0, 15813, 15813),
         16#DC#           =>  --  A4DC
          (0, 0, 15814, 15814),
         16#DD#           =>  --  A4DD
          (0, 0, 15815, 15815),
         16#DE#           =>  --  A4DE
          (0, 0, 15816, 15816),
         16#DF#           =>  --  A4DF
          (0, 0, 15817, 15817),
         16#E0#           =>  --  A4E0
          (0, 0, 15818, 15818),
         16#E1#           =>  --  A4E1
          (0, 0, 15819, 15819),
         16#E2#           =>  --  A4E2
          (0, 0, 15820, 15820),
         16#E3#           =>  --  A4E3
          (0, 0, 15821, 15821),
         16#E4#           =>  --  A4E4
          (0, 0, 15822, 15822),
         16#E5#           =>  --  A4E5
          (0, 0, 15823, 15823),
         16#E6#           =>  --  A4E6
          (0, 0, 15824, 15824),
         16#E7#           =>  --  A4E7
          (0, 0, 15825, 15825),
         16#E8#           =>  --  A4E8
          (0, 0, 15826, 15826),
         16#E9#           =>  --  A4E9
          (0, 0, 15827, 15827),
         16#EA#           =>  --  A4EA
          (0, 0, 15828, 15828),
         16#EB#           =>  --  A4EB
          (0, 0, 15829, 15829),
         16#EC#           =>  --  A4EC
          (0, 0, 15830, 15830),
         16#ED#           =>  --  A4ED
          (0, 0, 15831, 15831),
         16#EE#           =>  --  A4EE
          (0, 0, 15832, 15832),
         16#EF#           =>  --  A4EF
          (0, 0, 15833, 15833),
         16#F0#           =>  --  A4F0
          (0, 0, 15834, 15834),
         16#F1#           =>  --  A4F1
          (0, 0, 15835, 15835),
         16#F2#           =>  --  A4F2
          (0, 0, 15836, 15836),
         16#F3#           =>  --  A4F3
          (0, 0, 15837, 15837),
         16#F4#           =>  --  A4F4
          (0, 0, 15838, 15838),
         16#F5#           =>  --  A4F5
          (0, 0, 15839, 15839),
         16#F6#           =>  --  A4F6
          (0, 0, 15840, 15840),
         16#F7#           =>  --  A4F7
          (0, 0, 15841, 15841),
         16#F8#           =>  --  A4F8
          (0, 0, 15842, 15842),
         16#F9#           =>  --  A4F9
          (0, 0, 15843, 15843),
         16#FA#           =>  --  A4FA
          (0, 0, 15844, 15844),
         16#FB#           =>  --  A4FB
          (0, 0, 15845, 15845),
         16#FC#           =>  --  A4FC
          (0, 0, 15846, 15846),
         16#FD#           =>  --  A4FD
          (0, 0, 15847, 15847),
         16#FE#           =>  --  A4FE
          (0, 0, 15848, 15848),
         16#FF#           =>  --  A4FF
          (0, 0, 15849, 15849),
         others           =>
          (0, 0, 0, 0));

   Group_00A5 : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  A500
          (0, 0, 15850, 15850),
         16#01#           =>  --  A501
          (0, 0, 15851, 15851),
         16#02#           =>  --  A502
          (0, 0, 15852, 15852),
         16#03#           =>  --  A503
          (0, 0, 15853, 15853),
         16#04#           =>  --  A504
          (0, 0, 15854, 15854),
         16#05#           =>  --  A505
          (0, 0, 15855, 15855),
         16#06#           =>  --  A506
          (0, 0, 15856, 15856),
         16#07#           =>  --  A507
          (0, 0, 15857, 15857),
         16#08#           =>  --  A508
          (0, 0, 15858, 15858),
         16#09#           =>  --  A509
          (0, 0, 15859, 15859),
         16#0A#           =>  --  A50A
          (0, 0, 15860, 15860),
         16#0B#           =>  --  A50B
          (0, 0, 15861, 15861),
         16#0C#           =>  --  A50C
          (0, 0, 15862, 15862),
         16#0D#           =>  --  A50D
          (0, 0, 15863, 15863),
         16#0E#           =>  --  A50E
          (0, 0, 15864, 15864),
         16#0F#           =>  --  A50F
          (0, 0, 15865, 15865),
         16#10#           =>  --  A510
          (0, 0, 15866, 15866),
         16#11#           =>  --  A511
          (0, 0, 15867, 15867),
         16#12#           =>  --  A512
          (0, 0, 15868, 15868),
         16#13#           =>  --  A513
          (0, 0, 15869, 15869),
         16#14#           =>  --  A514
          (0, 0, 15870, 15870),
         16#15#           =>  --  A515
          (0, 0, 15871, 15871),
         16#16#           =>  --  A516
          (0, 0, 15872, 15872),
         16#17#           =>  --  A517
          (0, 0, 15873, 15873),
         16#18#           =>  --  A518
          (0, 0, 15874, 15874),
         16#19#           =>  --  A519
          (0, 0, 15875, 15875),
         16#1A#           =>  --  A51A
          (0, 0, 15876, 15876),
         16#1B#           =>  --  A51B
          (0, 0, 15877, 15877),
         16#1C#           =>  --  A51C
          (0, 0, 15878, 15878),
         16#1D#           =>  --  A51D
          (0, 0, 15879, 15879),
         16#1E#           =>  --  A51E
          (0, 0, 15880, 15880),
         16#1F#           =>  --  A51F
          (0, 0, 15881, 15881),
         16#20#           =>  --  A520
          (0, 0, 15882, 15882),
         16#21#           =>  --  A521
          (0, 0, 15883, 15883),
         16#22#           =>  --  A522
          (0, 0, 15884, 15884),
         16#23#           =>  --  A523
          (0, 0, 15885, 15885),
         16#24#           =>  --  A524
          (0, 0, 15886, 15886),
         16#25#           =>  --  A525
          (0, 0, 15887, 15887),
         16#26#           =>  --  A526
          (0, 0, 15888, 15888),
         16#27#           =>  --  A527
          (0, 0, 15889, 15889),
         16#28#           =>  --  A528
          (0, 0, 15890, 15890),
         16#29#           =>  --  A529
          (0, 0, 15891, 15891),
         16#2A#           =>  --  A52A
          (0, 0, 15892, 15892),
         16#2B#           =>  --  A52B
          (0, 0, 15893, 15893),
         16#2C#           =>  --  A52C
          (0, 0, 15894, 15894),
         16#2D#           =>  --  A52D
          (0, 0, 15895, 15895),
         16#2E#           =>  --  A52E
          (0, 0, 15896, 15896),
         16#2F#           =>  --  A52F
          (0, 0, 15897, 15897),
         16#30#           =>  --  A530
          (0, 0, 15898, 15898),
         16#31#           =>  --  A531
          (0, 0, 15899, 15899),
         16#32#           =>  --  A532
          (0, 0, 15900, 15900),
         16#33#           =>  --  A533
          (0, 0, 15901, 15901),
         16#34#           =>  --  A534
          (0, 0, 15902, 15902),
         16#35#           =>  --  A535
          (0, 0, 15903, 15903),
         16#36#           =>  --  A536
          (0, 0, 15904, 15904),
         16#37#           =>  --  A537
          (0, 0, 15905, 15905),
         16#38#           =>  --  A538
          (0, 0, 15906, 15906),
         16#39#           =>  --  A539
          (0, 0, 15907, 15907),
         16#3A#           =>  --  A53A
          (0, 0, 15908, 15908),
         16#3B#           =>  --  A53B
          (0, 0, 15909, 15909),
         16#3C#           =>  --  A53C
          (0, 0, 15910, 15910),
         16#3D#           =>  --  A53D
          (0, 0, 15911, 15911),
         16#3E#           =>  --  A53E
          (0, 0, 15912, 15912),
         16#3F#           =>  --  A53F
          (0, 0, 15913, 15913),
         16#40#           =>  --  A540
          (0, 0, 15914, 15914),
         16#41#           =>  --  A541
          (0, 0, 15915, 15915),
         16#42#           =>  --  A542
          (0, 0, 15916, 15916),
         16#43#           =>  --  A543
          (0, 0, 15917, 15917),
         16#44#           =>  --  A544
          (0, 0, 15918, 15918),
         16#45#           =>  --  A545
          (0, 0, 15919, 15919),
         16#46#           =>  --  A546
          (0, 0, 15920, 15920),
         16#47#           =>  --  A547
          (0, 0, 15921, 15921),
         16#48#           =>  --  A548
          (0, 0, 15922, 15922),
         16#49#           =>  --  A549
          (0, 0, 15923, 15923),
         16#4A#           =>  --  A54A
          (0, 0, 15924, 15924),
         16#4B#           =>  --  A54B
          (0, 0, 15925, 15925),
         16#4C#           =>  --  A54C
          (0, 0, 15926, 15926),
         16#4D#           =>  --  A54D
          (0, 0, 15927, 15927),
         16#4E#           =>  --  A54E
          (0, 0, 15928, 15928),
         16#4F#           =>  --  A54F
          (0, 0, 15929, 15929),
         16#50#           =>  --  A550
          (0, 0, 15930, 15930),
         16#51#           =>  --  A551
          (0, 0, 15931, 15931),
         16#52#           =>  --  A552
          (0, 0, 15932, 15932),
         16#53#           =>  --  A553
          (0, 0, 15933, 15933),
         16#54#           =>  --  A554
          (0, 0, 15934, 15934),
         16#55#           =>  --  A555
          (0, 0, 15935, 15935),
         16#56#           =>  --  A556
          (0, 0, 15936, 15936),
         16#57#           =>  --  A557
          (0, 0, 15937, 15937),
         16#58#           =>  --  A558
          (0, 0, 15938, 15938),
         16#59#           =>  --  A559
          (0, 0, 15939, 15939),
         16#5A#           =>  --  A55A
          (0, 0, 15940, 15940),
         16#5B#           =>  --  A55B
          (0, 0, 15941, 15941),
         16#5C#           =>  --  A55C
          (0, 0, 15942, 15942),
         16#5D#           =>  --  A55D
          (0, 0, 15943, 15943),
         16#5E#           =>  --  A55E
          (0, 0, 15944, 15944),
         16#5F#           =>  --  A55F
          (0, 0, 15945, 15945),
         16#60#           =>  --  A560
          (0, 0, 15946, 15946),
         16#61#           =>  --  A561
          (0, 0, 15947, 15947),
         16#62#           =>  --  A562
          (0, 0, 15948, 15948),
         16#63#           =>  --  A563
          (0, 0, 15949, 15949),
         16#64#           =>  --  A564
          (0, 0, 15950, 15950),
         16#65#           =>  --  A565
          (0, 0, 15951, 15951),
         16#66#           =>  --  A566
          (0, 0, 15952, 15952),
         16#67#           =>  --  A567
          (0, 0, 15953, 15953),
         16#68#           =>  --  A568
          (0, 0, 15954, 15954),
         16#69#           =>  --  A569
          (0, 0, 15955, 15955),
         16#6A#           =>  --  A56A
          (0, 0, 15956, 15956),
         16#6B#           =>  --  A56B
          (0, 0, 15957, 15957),
         16#6C#           =>  --  A56C
          (0, 0, 15958, 15958),
         16#6D#           =>  --  A56D
          (0, 0, 15959, 15959),
         16#6E#           =>  --  A56E
          (0, 0, 15960, 15960),
         16#6F#           =>  --  A56F
          (0, 0, 15961, 15961),
         16#70#           =>  --  A570
          (0, 0, 15962, 15962),
         16#71#           =>  --  A571
          (0, 0, 15963, 15963),
         16#72#           =>  --  A572
          (0, 0, 15964, 15964),
         16#73#           =>  --  A573
          (0, 0, 15965, 15965),
         16#74#           =>  --  A574
          (0, 0, 15966, 15966),
         16#75#           =>  --  A575
          (0, 0, 15967, 15967),
         16#76#           =>  --  A576
          (0, 0, 15968, 15968),
         16#77#           =>  --  A577
          (0, 0, 15969, 15969),
         16#78#           =>  --  A578
          (0, 0, 15970, 15970),
         16#79#           =>  --  A579
          (0, 0, 15971, 15971),
         16#7A#           =>  --  A57A
          (0, 0, 15972, 15972),
         16#7B#           =>  --  A57B
          (0, 0, 15973, 15973),
         16#7C#           =>  --  A57C
          (0, 0, 15974, 15974),
         16#7D#           =>  --  A57D
          (0, 0, 15975, 15975),
         16#7E#           =>  --  A57E
          (0, 0, 15976, 15976),
         16#7F#           =>  --  A57F
          (0, 0, 15977, 15977),
         16#80#           =>  --  A580
          (0, 0, 15978, 15978),
         16#81#           =>  --  A581
          (0, 0, 15979, 15979),
         16#82#           =>  --  A582
          (0, 0, 15980, 15980),
         16#83#           =>  --  A583
          (0, 0, 15981, 15981),
         16#84#           =>  --  A584
          (0, 0, 15982, 15982),
         16#85#           =>  --  A585
          (0, 0, 15983, 15983),
         16#86#           =>  --  A586
          (0, 0, 15984, 15984),
         16#87#           =>  --  A587
          (0, 0, 15985, 15985),
         16#88#           =>  --  A588
          (0, 0, 15986, 15986),
         16#89#           =>  --  A589
          (0, 0, 15987, 15987),
         16#8A#           =>  --  A58A
          (0, 0, 15988, 15988),
         16#8B#           =>  --  A58B
          (0, 0, 15989, 15989),
         16#8C#           =>  --  A58C
          (0, 0, 15990, 15990),
         16#8D#           =>  --  A58D
          (0, 0, 15991, 15991),
         16#8E#           =>  --  A58E
          (0, 0, 15992, 15992),
         16#8F#           =>  --  A58F
          (0, 0, 15993, 15993),
         16#90#           =>  --  A590
          (0, 0, 15994, 15994),
         16#91#           =>  --  A591
          (0, 0, 15995, 15995),
         16#92#           =>  --  A592
          (0, 0, 15996, 15996),
         16#93#           =>  --  A593
          (0, 0, 15997, 15997),
         16#94#           =>  --  A594
          (0, 0, 15998, 15998),
         16#95#           =>  --  A595
          (0, 0, 15999, 15999),
         16#96#           =>  --  A596
          (0, 0, 16000, 16000),
         16#97#           =>  --  A597
          (0, 0, 16001, 16001),
         16#98#           =>  --  A598
          (0, 0, 16002, 16002),
         16#99#           =>  --  A599
          (0, 0, 16003, 16003),
         16#9A#           =>  --  A59A
          (0, 0, 16004, 16004),
         16#9B#           =>  --  A59B
          (0, 0, 16005, 16005),
         16#9C#           =>  --  A59C
          (0, 0, 16006, 16006),
         16#9D#           =>  --  A59D
          (0, 0, 16007, 16007),
         16#9E#           =>  --  A59E
          (0, 0, 16008, 16008),
         16#9F#           =>  --  A59F
          (0, 0, 16009, 16009),
         16#A0#           =>  --  A5A0
          (0, 0, 16010, 16010),
         16#A1#           =>  --  A5A1
          (0, 0, 16011, 16011),
         16#A2#           =>  --  A5A2
          (0, 0, 16012, 16012),
         16#A3#           =>  --  A5A3
          (0, 0, 16013, 16013),
         16#A4#           =>  --  A5A4
          (0, 0, 16014, 16014),
         16#A5#           =>  --  A5A5
          (0, 0, 16015, 16015),
         16#A6#           =>  --  A5A6
          (0, 0, 16016, 16016),
         16#A7#           =>  --  A5A7
          (0, 0, 16017, 16017),
         16#A8#           =>  --  A5A8
          (0, 0, 16018, 16018),
         16#A9#           =>  --  A5A9
          (0, 0, 16019, 16019),
         16#AA#           =>  --  A5AA
          (0, 0, 16020, 16020),
         16#AB#           =>  --  A5AB
          (0, 0, 16021, 16021),
         16#AC#           =>  --  A5AC
          (0, 0, 16022, 16022),
         16#AD#           =>  --  A5AD
          (0, 0, 16023, 16023),
         16#AE#           =>  --  A5AE
          (0, 0, 16024, 16024),
         16#AF#           =>  --  A5AF
          (0, 0, 16025, 16025),
         16#B0#           =>  --  A5B0
          (0, 0, 16026, 16026),
         16#B1#           =>  --  A5B1
          (0, 0, 16027, 16027),
         16#B2#           =>  --  A5B2
          (0, 0, 16028, 16028),
         16#B3#           =>  --  A5B3
          (0, 0, 16029, 16029),
         16#B4#           =>  --  A5B4
          (0, 0, 16030, 16030),
         16#B5#           =>  --  A5B5
          (0, 0, 16031, 16031),
         16#B6#           =>  --  A5B6
          (0, 0, 16032, 16032),
         16#B7#           =>  --  A5B7
          (0, 0, 16033, 16033),
         16#B8#           =>  --  A5B8
          (0, 0, 16034, 16034),
         16#B9#           =>  --  A5B9
          (0, 0, 16035, 16035),
         16#BA#           =>  --  A5BA
          (0, 0, 16036, 16036),
         16#BB#           =>  --  A5BB
          (0, 0, 16037, 16037),
         16#BC#           =>  --  A5BC
          (0, 0, 16038, 16038),
         16#BD#           =>  --  A5BD
          (0, 0, 16039, 16039),
         16#BE#           =>  --  A5BE
          (0, 0, 16040, 16040),
         16#BF#           =>  --  A5BF
          (0, 0, 16041, 16041),
         16#C0#           =>  --  A5C0
          (0, 0, 16042, 16042),
         16#C1#           =>  --  A5C1
          (0, 0, 16043, 16043),
         16#C2#           =>  --  A5C2
          (0, 0, 16044, 16044),
         16#C3#           =>  --  A5C3
          (0, 0, 16045, 16045),
         16#C4#           =>  --  A5C4
          (0, 0, 16046, 16046),
         16#C5#           =>  --  A5C5
          (0, 0, 16047, 16047),
         16#C6#           =>  --  A5C6
          (0, 0, 16048, 16048),
         16#C7#           =>  --  A5C7
          (0, 0, 16049, 16049),
         16#C8#           =>  --  A5C8
          (0, 0, 16050, 16050),
         16#C9#           =>  --  A5C9
          (0, 0, 16051, 16051),
         16#CA#           =>  --  A5CA
          (0, 0, 16052, 16052),
         16#CB#           =>  --  A5CB
          (0, 0, 16053, 16053),
         16#CC#           =>  --  A5CC
          (0, 0, 16054, 16054),
         16#CD#           =>  --  A5CD
          (0, 0, 16055, 16055),
         16#CE#           =>  --  A5CE
          (0, 0, 16056, 16056),
         16#CF#           =>  --  A5CF
          (0, 0, 16057, 16057),
         16#D0#           =>  --  A5D0
          (0, 0, 16058, 16058),
         16#D1#           =>  --  A5D1
          (0, 0, 16059, 16059),
         16#D2#           =>  --  A5D2
          (0, 0, 16060, 16060),
         16#D3#           =>  --  A5D3
          (0, 0, 16061, 16061),
         16#D4#           =>  --  A5D4
          (0, 0, 16062, 16062),
         16#D5#           =>  --  A5D5
          (0, 0, 16063, 16063),
         16#D6#           =>  --  A5D6
          (0, 0, 16064, 16064),
         16#D7#           =>  --  A5D7
          (0, 0, 16065, 16065),
         16#D8#           =>  --  A5D8
          (0, 0, 16066, 16066),
         16#D9#           =>  --  A5D9
          (0, 0, 16067, 16067),
         16#DA#           =>  --  A5DA
          (0, 0, 16068, 16068),
         16#DB#           =>  --  A5DB
          (0, 0, 16069, 16069),
         16#DC#           =>  --  A5DC
          (0, 0, 16070, 16070),
         16#DD#           =>  --  A5DD
          (0, 0, 16071, 16071),
         16#DE#           =>  --  A5DE
          (0, 0, 16072, 16072),
         16#DF#           =>  --  A5DF
          (0, 0, 16073, 16073),
         16#E0#           =>  --  A5E0
          (0, 0, 16074, 16074),
         16#E1#           =>  --  A5E1
          (0, 0, 16075, 16075),
         16#E2#           =>  --  A5E2
          (0, 0, 16076, 16076),
         16#E3#           =>  --  A5E3
          (0, 0, 16077, 16077),
         16#E4#           =>  --  A5E4
          (0, 0, 16078, 16078),
         16#E5#           =>  --  A5E5
          (0, 0, 16079, 16079),
         16#E6#           =>  --  A5E6
          (0, 0, 16080, 16080),
         16#E7#           =>  --  A5E7
          (0, 0, 16081, 16081),
         16#E8#           =>  --  A5E8
          (0, 0, 16082, 16082),
         16#E9#           =>  --  A5E9
          (0, 0, 16083, 16083),
         16#EA#           =>  --  A5EA
          (0, 0, 16084, 16084),
         16#EB#           =>  --  A5EB
          (0, 0, 16085, 16085),
         16#EC#           =>  --  A5EC
          (0, 0, 16086, 16086),
         16#ED#           =>  --  A5ED
          (0, 0, 16087, 16087),
         16#EE#           =>  --  A5EE
          (0, 0, 16088, 16088),
         16#EF#           =>  --  A5EF
          (0, 0, 16089, 16089),
         16#F0#           =>  --  A5F0
          (0, 0, 16090, 16090),
         16#F1#           =>  --  A5F1
          (0, 0, 16091, 16091),
         16#F2#           =>  --  A5F2
          (0, 0, 16092, 16092),
         16#F3#           =>  --  A5F3
          (0, 0, 16093, 16093),
         16#F4#           =>  --  A5F4
          (0, 0, 16094, 16094),
         16#F5#           =>  --  A5F5
          (0, 0, 16095, 16095),
         16#F6#           =>  --  A5F6
          (0, 0, 16096, 16096),
         16#F7#           =>  --  A5F7
          (0, 0, 16097, 16097),
         16#F8#           =>  --  A5F8
          (0, 0, 16098, 16098),
         16#F9#           =>  --  A5F9
          (0, 0, 16099, 16099),
         16#FA#           =>  --  A5FA
          (0, 0, 16100, 16100),
         16#FB#           =>  --  A5FB
          (0, 0, 16101, 16101),
         16#FC#           =>  --  A5FC
          (0, 0, 16102, 16102),
         16#FD#           =>  --  A5FD
          (0, 0, 16103, 16103),
         16#FE#           =>  --  A5FE
          (0, 0, 16104, 16104),
         16#FF#           =>  --  A5FF
          (0, 0, 16105, 16105),
         others           =>
          (0, 0, 0, 0));

   Group_00A6 : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  A600
          (0, 0, 16106, 16106),
         16#01#           =>  --  A601
          (0, 0, 16107, 16107),
         16#02#           =>  --  A602
          (0, 0, 16108, 16108),
         16#03#           =>  --  A603
          (0, 0, 16109, 16109),
         16#04#           =>  --  A604
          (0, 0, 16110, 16110),
         16#05#           =>  --  A605
          (0, 0, 16111, 16111),
         16#06#           =>  --  A606
          (0, 0, 16112, 16112),
         16#07#           =>  --  A607
          (0, 0, 16113, 16113),
         16#08#           =>  --  A608
          (0, 0, 16114, 16114),
         16#09#           =>  --  A609
          (0, 0, 16115, 16115),
         16#0A#           =>  --  A60A
          (0, 0, 16116, 16116),
         16#0B#           =>  --  A60B
          (0, 0, 16117, 16117),
         16#0C#           =>  --  A60C
          (0, 0, 16118, 16118),
         16#0D#           =>  --  A60D
          (0, 0, 16119, 16119),
         16#0E#           =>  --  A60E
          (0, 0, 16120, 16120),
         16#0F#           =>  --  A60F
          (0, 0, 16121, 16121),
         16#10#           =>  --  A610
          (0, 0, 16122, 16122),
         16#11#           =>  --  A611
          (0, 0, 16123, 16123),
         16#12#           =>  --  A612
          (0, 0, 16124, 16124),
         16#13#           =>  --  A613
          (0, 0, 16125, 16126),
         16#14#           =>  --  A614
          (0, 0, 16127, 16128),
         16#15#           =>  --  A615
          (0, 0, 16129, 16130),
         16#16#           =>  --  A616
          (0, 0, 16131, 16132),
         16#17#           =>  --  A617
          (0, 0, 16133, 16134),
         16#18#           =>  --  A618
          (0, 0, 16135, 16136),
         16#19#           =>  --  A619
          (0, 0, 16137, 16138),
         16#1A#           =>  --  A61A
          (0, 0, 16139, 16140),
         16#1B#           =>  --  A61B
          (0, 0, 16141, 16142),
         16#1C#           =>  --  A61C
          (0, 0, 16143, 16144),
         16#1D#           =>  --  A61D
          (0, 0, 16145, 16146),
         16#1E#           =>  --  A61E
          (0, 0, 16147, 16148),
         16#1F#           =>  --  A61F
          (0, 0, 16149, 16150),
         16#20#           =>  --  A620
          (0, 0, 23, 23),
         16#21#           =>  --  A621
          (0, 0, 24, 24),
         16#22#           =>  --  A622
          (0, 0, 25, 25),
         16#23#           =>  --  A623
          (0, 0, 26, 26),
         16#24#           =>  --  A624
          (0, 0, 27, 27),
         16#25#           =>  --  A625
          (0, 0, 28, 28),
         16#26#           =>  --  A626
          (0, 0, 29, 29),
         16#27#           =>  --  A627
          (0, 0, 30, 30),
         16#28#           =>  --  A628
          (0, 0, 31, 31),
         16#29#           =>  --  A629
          (0, 0, 32, 32),
         16#2A#           =>  --  A62A
          (0, 0, 16151, 16151),
         16#2B#           =>  --  A62B
          (0, 0, 16147, 16147),
         16#40#           =>  --  A640
          (0, 0, 16152, 16152),
         16#41#           =>  --  A641
          (0, 0, 16153, 16153),
         16#42#           =>  --  A642
          (0, 0, 16154, 16154),
         16#43#           =>  --  A643
          (0, 0, 16155, 16155),
         16#44#           =>  --  A644
          (0, 0, 16156, 16156),
         16#45#           =>  --  A645
          (0, 0, 16157, 16157),
         16#46#           =>  --  A646
          (0, 0, 16158, 16158),
         16#47#           =>  --  A647
          (0, 0, 16159, 16159),
         16#48#           =>  --  A648
          (0, 0, 16160, 16160),
         16#49#           =>  --  A649
          (0, 0, 16161, 16161),
         16#4A#           =>  --  A64A
          (0, 0, 16162, 16162),
         16#4B#           =>  --  A64B
          (0, 0, 16163, 16163),
         16#4C#           =>  --  A64C
          (0, 0, 16164, 16164),
         16#4D#           =>  --  A64D
          (0, 0, 16165, 16165),
         16#4E#           =>  --  A64E
          (0, 0, 16166, 16166),
         16#4F#           =>  --  A64F
          (0, 0, 16167, 16167),
         16#50#           =>  --  A650
          (0, 0, 16168, 16168),
         16#51#           =>  --  A651
          (0, 0, 16169, 16169),
         16#52#           =>  --  A652
          (0, 0, 16170, 16170),
         16#53#           =>  --  A653
          (0, 0, 16171, 16171),
         16#54#           =>  --  A654
          (0, 0, 16172, 16172),
         16#55#           =>  --  A655
          (0, 0, 16173, 16173),
         16#56#           =>  --  A656
          (0, 0, 16174, 16174),
         16#57#           =>  --  A657
          (0, 0, 16175, 16175),
         16#58#           =>  --  A658
          (0, 0, 16176, 16176),
         16#59#           =>  --  A659
          (0, 0, 16177, 16177),
         16#5A#           =>  --  A65A
          (0, 0, 16178, 16178),
         16#5B#           =>  --  A65B
          (0, 0, 16179, 16179),
         16#5C#           =>  --  A65C
          (0, 0, 16180, 16180),
         16#5D#           =>  --  A65D
          (0, 0, 16181, 16181),
         16#5E#           =>  --  A65E
          (0, 0, 16182, 16182),
         16#5F#           =>  --  A65F
          (0, 0, 16183, 16183),
         16#60#           =>  --  A660
          (0, 0, 16184, 16184),
         16#61#           =>  --  A661
          (0, 0, 16185, 16185),
         16#62#           =>  --  A662
          (0, 0, 16186, 16186),
         16#63#           =>  --  A663
          (0, 0, 16187, 16187),
         16#64#           =>  --  A664
          (0, 0, 16188, 16188),
         16#65#           =>  --  A665
          (0, 0, 16189, 16189),
         16#66#           =>  --  A666
          (0, 0, 16190, 16190),
         16#67#           =>  --  A667
          (0, 0, 16191, 16191),
         16#68#           =>  --  A668
          (0, 0, 16192, 16192),
         16#69#           =>  --  A669
          (0, 0, 11849, 11849),
         16#6A#           =>  --  A66A
          (0, 0, 16192, 16192),
         16#6B#           =>  --  A66B
          (0, 0, 11849, 11849),
         16#6C#           =>  --  A66C
          (0, 0, 16192, 16192),
         16#6D# .. 16#6E# =>  --  A66D .. A66E
          (0, 0, 11849, 11849),
         16#6F#           =>  --  A66F
          (0, 0, 16193, 16193),
         16#70# .. 16#72# =>  --  A670 .. A672
          (0, 0, 1, 1),
         16#73#           =>  --  A673
          (0, 0, 16194, 16194),
         16#74#           =>  --  A674
          (0, 0, 16195, 16195),
         16#75#           =>  --  A675
          (0, 0, 16196, 16196),
         16#76#           =>  --  A676
          (0, 0, 16197, 16198),
         16#77#           =>  --  A677
          (0, 0, 16199, 16199),
         16#78#           =>  --  A678
          (0, 0, 16200, 16200),
         16#79#           =>  --  A679
          (0, 0, 16201, 16201),
         16#7A#           =>  --  A67A
          (0, 0, 16202, 16202),
         16#7B#           =>  --  A67B
          (0, 0, 16203, 16203),
         16#7C# .. 16#7D# =>  --  A67C .. A67D
          (0, 0, 1041, 1041),
         16#7E#           =>  --  A67E
          (0, 0, 16204, 16204),
         16#7F#           =>  --  A67F
          (0, 0, 16205, 16205),
         16#80#           =>  --  A680
          (0, 0, 16206, 16206),
         16#81#           =>  --  A681
          (0, 0, 16207, 16207),
         16#82#           =>  --  A682
          (0, 0, 16208, 16208),
         16#83#           =>  --  A683
          (0, 0, 16209, 16209),
         16#84#           =>  --  A684
          (0, 0, 16210, 16210),
         16#85#           =>  --  A685
          (0, 0, 16211, 16211),
         16#86#           =>  --  A686
          (0, 0, 16212, 16212),
         16#87#           =>  --  A687
          (0, 0, 16213, 16213),
         16#88#           =>  --  A688
          (0, 0, 16214, 16214),
         16#89#           =>  --  A689
          (0, 0, 16215, 16215),
         16#8A#           =>  --  A68A
          (0, 0, 16216, 16216),
         16#8B#           =>  --  A68B
          (0, 0, 16217, 16217),
         16#8C#           =>  --  A68C
          (0, 0, 16218, 16218),
         16#8D#           =>  --  A68D
          (0, 0, 16219, 16219),
         16#8E#           =>  --  A68E
          (0, 0, 16220, 16220),
         16#8F#           =>  --  A68F
          (0, 0, 16221, 16221),
         16#90#           =>  --  A690
          (0, 0, 16222, 16222),
         16#91#           =>  --  A691
          (0, 0, 16223, 16223),
         16#92#           =>  --  A692
          (0, 0, 16224, 16224),
         16#93#           =>  --  A693
          (0, 0, 16225, 16225),
         16#94#           =>  --  A694
          (0, 0, 16226, 16226),
         16#95#           =>  --  A695
          (0, 0, 16227, 16227),
         16#96#           =>  --  A696
          (0, 0, 16228, 16228),
         16#97#           =>  --  A697
          (0, 0, 16229, 16229),
         16#98#           =>  --  A698
          (0, 0, 16192, 16192),
         16#99#           =>  --  A699
          (0, 0, 11849, 11849),
         16#9A#           =>  --  A69A
          (0, 0, 16192, 16192),
         16#9B#           =>  --  A69B
          (0, 0, 11849, 11849),
         16#9C#           =>  --  A69C
          (0, 0, 16230, 16230),
         16#9D#           =>  --  A69D
          (0, 0, 16231, 16231),
         16#9F#           =>  --  A69F
          (0, 0, 16232, 16232),
         16#A0#           =>  --  A6A0
          (0, 0, 16233, 16233),
         16#A1#           =>  --  A6A1
          (0, 0, 16234, 16234),
         16#A2#           =>  --  A6A2
          (0, 0, 16235, 16235),
         16#A3#           =>  --  A6A3
          (0, 0, 16236, 16236),
         16#A4#           =>  --  A6A4
          (0, 0, 16237, 16237),
         16#A5#           =>  --  A6A5
          (0, 0, 16238, 16238),
         16#A6#           =>  --  A6A6
          (0, 0, 16239, 16239),
         16#A7#           =>  --  A6A7
          (0, 0, 16240, 16240),
         16#A8#           =>  --  A6A8
          (0, 0, 16241, 16241),
         16#A9#           =>  --  A6A9
          (0, 0, 16242, 16242),
         16#AA#           =>  --  A6AA
          (0, 0, 16243, 16243),
         16#AB#           =>  --  A6AB
          (0, 0, 16244, 16244),
         16#AC#           =>  --  A6AC
          (0, 0, 16245, 16245),
         16#AD#           =>  --  A6AD
          (0, 0, 16246, 16246),
         16#AE#           =>  --  A6AE
          (0, 0, 16247, 16247),
         16#AF#           =>  --  A6AF
          (0, 0, 16248, 16248),
         16#B0#           =>  --  A6B0
          (0, 0, 16249, 16249),
         16#B1#           =>  --  A6B1
          (0, 0, 16250, 16250),
         16#B2#           =>  --  A6B2
          (0, 0, 16251, 16251),
         16#B3#           =>  --  A6B3
          (0, 0, 16252, 16252),
         16#B4#           =>  --  A6B4
          (0, 0, 16253, 16253),
         16#B5#           =>  --  A6B5
          (0, 0, 16254, 16254),
         16#B6#           =>  --  A6B6
          (0, 0, 16255, 16255),
         16#B7#           =>  --  A6B7
          (0, 0, 16256, 16256),
         16#B8#           =>  --  A6B8
          (0, 0, 16257, 16257),
         16#B9#           =>  --  A6B9
          (0, 0, 16258, 16258),
         16#BA#           =>  --  A6BA
          (0, 0, 16259, 16259),
         16#BB#           =>  --  A6BB
          (0, 0, 16260, 16260),
         16#BC#           =>  --  A6BC
          (0, 0, 16261, 16261),
         16#BD#           =>  --  A6BD
          (0, 0, 16262, 16262),
         16#BE#           =>  --  A6BE
          (0, 0, 16263, 16263),
         16#BF#           =>  --  A6BF
          (0, 0, 16264, 16264),
         16#C0#           =>  --  A6C0
          (0, 0, 16265, 16265),
         16#C1#           =>  --  A6C1
          (0, 0, 16266, 16266),
         16#C2#           =>  --  A6C2
          (0, 0, 16267, 16267),
         16#C3#           =>  --  A6C3
          (0, 0, 16268, 16268),
         16#C4#           =>  --  A6C4
          (0, 0, 16269, 16269),
         16#C5#           =>  --  A6C5
          (0, 0, 16270, 16270),
         16#C6#           =>  --  A6C6
          (0, 0, 16271, 16271),
         16#C7#           =>  --  A6C7
          (0, 0, 16272, 16272),
         16#C8#           =>  --  A6C8
          (0, 0, 16273, 16273),
         16#C9#           =>  --  A6C9
          (0, 0, 16274, 16274),
         16#CA#           =>  --  A6CA
          (0, 0, 16275, 16275),
         16#CB#           =>  --  A6CB
          (0, 0, 16276, 16276),
         16#CC#           =>  --  A6CC
          (0, 0, 16277, 16277),
         16#CD#           =>  --  A6CD
          (0, 0, 16278, 16278),
         16#CE#           =>  --  A6CE
          (0, 0, 16279, 16279),
         16#CF#           =>  --  A6CF
          (0, 0, 16280, 16280),
         16#D0#           =>  --  A6D0
          (0, 0, 16281, 16281),
         16#D1#           =>  --  A6D1
          (0, 0, 16282, 16282),
         16#D2#           =>  --  A6D2
          (0, 0, 16283, 16283),
         16#D3#           =>  --  A6D3
          (0, 0, 16284, 16284),
         16#D4#           =>  --  A6D4
          (0, 0, 16285, 16285),
         16#D5#           =>  --  A6D5
          (0, 0, 16286, 16286),
         16#D6#           =>  --  A6D6
          (0, 0, 16287, 16287),
         16#D7#           =>  --  A6D7
          (0, 0, 16288, 16288),
         16#D8#           =>  --  A6D8
          (0, 0, 16289, 16289),
         16#D9#           =>  --  A6D9
          (0, 0, 16290, 16290),
         16#DA#           =>  --  A6DA
          (0, 0, 16291, 16291),
         16#DB#           =>  --  A6DB
          (0, 0, 16292, 16292),
         16#DC#           =>  --  A6DC
          (0, 0, 16293, 16293),
         16#DD#           =>  --  A6DD
          (0, 0, 16294, 16294),
         16#DE#           =>  --  A6DE
          (0, 0, 16295, 16295),
         16#DF#           =>  --  A6DF
          (0, 0, 16296, 16296),
         16#E0#           =>  --  A6E0
          (0, 0, 16297, 16297),
         16#E1#           =>  --  A6E1
          (0, 0, 16298, 16298),
         16#E2#           =>  --  A6E2
          (0, 0, 16299, 16299),
         16#E3#           =>  --  A6E3
          (0, 0, 16300, 16300),
         16#E4#           =>  --  A6E4
          (0, 0, 16301, 16301),
         16#E5#           =>  --  A6E5
          (0, 0, 16302, 16302),
         16#E6#           =>  --  A6E6
          (0, 0, 16303, 16303),
         16#E7#           =>  --  A6E7
          (0, 0, 16304, 16304),
         16#E8#           =>  --  A6E8
          (0, 0, 16305, 16305),
         16#E9#           =>  --  A6E9
          (0, 0, 16306, 16306),
         16#EA#           =>  --  A6EA
          (0, 0, 16307, 16307),
         16#EB#           =>  --  A6EB
          (0, 0, 16308, 16308),
         16#EC#           =>  --  A6EC
          (0, 0, 16309, 16309),
         16#ED#           =>  --  A6ED
          (0, 0, 16310, 16310),
         16#EE#           =>  --  A6EE
          (0, 0, 16311, 16311),
         16#EF#           =>  --  A6EF
          (0, 0, 16312, 16312),
         16#F0#           =>  --  A6F0
          (0, 0, 16313, 16313),
         16#F1#           =>  --  A6F1
          (0, 0, 16314, 16314),
         16#F2#           =>  --  A6F2
          (0, 0, 16315, 16315),
         16#F3#           =>  --  A6F3
          (0, 0, 16316, 16316),
         16#F4#           =>  --  A6F4
          (0, 0, 16317, 16317),
         16#F5#           =>  --  A6F5
          (0, 0, 16318, 16318),
         16#F6#           =>  --  A6F6
          (0, 0, 16319, 16319),
         16#F7#           =>  --  A6F7
          (0, 0, 16320, 16320),
         others           =>
          (0, 0, 0, 0));

   Group_00A7 : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  A700
          (0, 0, 16321, 16321),
         16#01#           =>  --  A701
          (0, 0, 16322, 16322),
         16#02#           =>  --  A702
          (0, 0, 16323, 16323),
         16#03#           =>  --  A703
          (0, 0, 16324, 16324),
         16#04#           =>  --  A704
          (0, 0, 16325, 16325),
         16#05#           =>  --  A705
          (0, 0, 16326, 16326),
         16#06#           =>  --  A706
          (0, 0, 16327, 16327),
         16#07#           =>  --  A707
          (0, 0, 16328, 16328),
         16#08#           =>  --  A708
          (0, 0, 16329, 16329),
         16#09#           =>  --  A709
          (0, 0, 16330, 16330),
         16#0A#           =>  --  A70A
          (0, 0, 16331, 16331),
         16#0B#           =>  --  A70B
          (0, 0, 16332, 16332),
         16#0C#           =>  --  A70C
          (0, 0, 16333, 16333),
         16#0D#           =>  --  A70D
          (0, 0, 16334, 16334),
         16#0E#           =>  --  A70E
          (0, 0, 16335, 16335),
         16#0F#           =>  --  A70F
          (0, 0, 16336, 16336),
         16#10#           =>  --  A710
          (0, 0, 16337, 16337),
         16#11#           =>  --  A711
          (0, 0, 16338, 16338),
         16#12#           =>  --  A712
          (0, 0, 16339, 16339),
         16#13#           =>  --  A713
          (0, 0, 16340, 16340),
         16#14#           =>  --  A714
          (0, 0, 16341, 16341),
         16#15#           =>  --  A715
          (0, 0, 16342, 16342),
         16#16#           =>  --  A716
          (0, 0, 16343, 16343),
         16#17#           =>  --  A717
          (0, 0, 16344, 16344),
         16#18#           =>  --  A718
          (0, 0, 16345, 16345),
         16#19#           =>  --  A719
          (0, 0, 16346, 16346),
         16#1A#           =>  --  A71A
          (0, 0, 16347, 16347),
         16#1B#           =>  --  A71B
          (0, 0, 16348, 16348),
         16#1C#           =>  --  A71C
          (0, 0, 16349, 16349),
         16#1D#           =>  --  A71D
          (0, 0, 16350, 16350),
         16#1E#           =>  --  A71E
          (0, 0, 16351, 16351),
         16#1F#           =>  --  A71F
          (0, 0, 16352, 16352),
         16#20#           =>  --  A720
          (0, 0, 16353, 16353),
         16#21#           =>  --  A721
          (0, 0, 16354, 16354),
         16#22#           =>  --  A722
          (0, 0, 16355, 16355),
         16#23#           =>  --  A723
          (0, 0, 16356, 16356),
         16#24#           =>  --  A724
          (0, 0, 16357, 16357),
         16#25#           =>  --  A725
          (0, 0, 16358, 16358),
         16#26#           =>  --  A726
          (0, 0, 16359, 16359),
         16#27#           =>  --  A727
          (0, 0, 16360, 16360),
         16#28#           =>  --  A728
          (0, 0, 16361, 16362),
         16#29#           =>  --  A729
          (0, 0, 16363, 16364),
         16#2A#           =>  --  A72A
          (0, 0, 16365, 16365),
         16#2B#           =>  --  A72B
          (0, 0, 16366, 16366),
         16#2C#           =>  --  A72C
          (0, 0, 16367, 16367),
         16#2D#           =>  --  A72D
          (0, 0, 16368, 16368),
         16#2E#           =>  --  A72E
          (0, 0, 16369, 16369),
         16#2F#           =>  --  A72F
          (0, 0, 16370, 16370),
         16#30#           =>  --  A730
          (0, 0, 16371, 16371),
         16#31#           =>  --  A731
          (0, 0, 16372, 16372),
         16#32#           =>  --  A732
          (0, 0, 16373, 16374),
         16#33#           =>  --  A733
          (0, 0, 16375, 16376),
         16#34#           =>  --  A734
          (0, 0, 16377, 16378),
         16#35#           =>  --  A735
          (0, 0, 7134, 7135),
         16#36#           =>  --  A736
          (0, 0, 16379, 16380),
         16#37#           =>  --  A737
          (0, 0, 16381, 16382),
         16#38#           =>  --  A738
          (0, 0, 16383, 16384),
         16#39#           =>  --  A739
          (0, 0, 7136, 7137),
         16#3A#           =>  --  A73A
          (0, 0, 16385, 16387),
         16#3B#           =>  --  A73B
          (0, 0, 16388, 16390),
         16#3C#           =>  --  A73C
          (0, 0, 16391, 16392),
         16#3D#           =>  --  A73D
          (0, 0, 16393, 16394),
         16#3E#           =>  --  A73E
          (0, 0, 16395, 16395),
         16#3F#           =>  --  A73F
          (0, 0, 16396, 16396),
         16#40#           =>  --  A740
          (0, 0, 16397, 16397),
         16#41#           =>  --  A741
          (0, 0, 16398, 16398),
         16#42#           =>  --  A742
          (0, 0, 16399, 16399),
         16#43#           =>  --  A743
          (0, 0, 16400, 16400),
         16#44#           =>  --  A744
          (0, 0, 16401, 16401),
         16#45#           =>  --  A745
          (0, 0, 16402, 16402),
         16#46#           =>  --  A746
          (0, 0, 16403, 16403),
         16#47#           =>  --  A747
          (0, 0, 16404, 16404),
         16#48#           =>  --  A748
          (0, 0, 16405, 16405),
         16#49#           =>  --  A749
          (0, 0, 16406, 16406),
         16#4A#           =>  --  A74A
          (0, 0, 16407, 16407),
         16#4B#           =>  --  A74B
          (0, 0, 16408, 16408),
         16#4C#           =>  --  A74C
          (0, 0, 16409, 16409),
         16#4D#           =>  --  A74D
          (0, 0, 16410, 16410),
         16#4E#           =>  --  A74E
          (0, 0, 16411, 16412),
         16#4F#           =>  --  A74F
          (0, 0, 16413, 16414),
         16#50#           =>  --  A750
          (0, 0, 16415, 16415),
         16#51#           =>  --  A751
          (0, 0, 16416, 16416),
         16#52#           =>  --  A752
          (0, 0, 16417, 16417),
         16#53#           =>  --  A753
          (0, 0, 16418, 16418),
         16#54#           =>  --  A754
          (0, 0, 16419, 16419),
         16#55#           =>  --  A755
          (0, 0, 16420, 16420),
         16#56#           =>  --  A756
          (0, 0, 16421, 16421),
         16#57#           =>  --  A757
          (0, 0, 16422, 16422),
         16#58#           =>  --  A758
          (0, 0, 16423, 16423),
         16#59#           =>  --  A759
          (0, 0, 16424, 16424),
         16#5A#           =>  --  A75A
          (0, 0, 16425, 16425),
         16#5B#           =>  --  A75B
          (0, 0, 16426, 16426),
         16#5C#           =>  --  A75C
          (0, 0, 16427, 16427),
         16#5D#           =>  --  A75D
          (0, 0, 16428, 16428),
         16#5E#           =>  --  A75E
          (0, 0, 16429, 16429),
         16#5F#           =>  --  A75F
          (0, 0, 16430, 16430),
         16#60#           =>  --  A760
          (0, 0, 16431, 16432),
         16#61#           =>  --  A761
          (0, 0, 16433, 16434),
         16#62#           =>  --  A762
          (0, 0, 16435, 16435),
         16#63#           =>  --  A763
          (0, 0, 16436, 16436),
         16#64#           =>  --  A764
          (0, 0, 16437, 16437),
         16#65#           =>  --  A765
          (0, 0, 16438, 16438),
         16#66#           =>  --  A766
          (0, 0, 16439, 16439),
         16#67#           =>  --  A767
          (0, 0, 16440, 16440),
         16#68#           =>  --  A768
          (0, 0, 16441, 16441),
         16#69#           =>  --  A769
          (0, 0, 16442, 16442),
         16#6A#           =>  --  A76A
          (0, 0, 16443, 16443),
         16#6B#           =>  --  A76B
          (0, 0, 16444, 16444),
         16#6C#           =>  --  A76C
          (0, 0, 16445, 16445),
         16#6D#           =>  --  A76D
          (0, 0, 16446, 16446),
         16#6E#           =>  --  A76E
          (0, 0, 16447, 16447),
         16#6F#           =>  --  A76F
          (0, 0, 16448, 16448),
         16#70#           =>  --  A770
          (0, 0, 16449, 16449),
         16#71#           =>  --  A771
          (0, 0, 16450, 16450),
         16#72#           =>  --  A772
          (0, 0, 16451, 16451),
         16#73#           =>  --  A773
          (0, 0, 16452, 16452),
         16#74#           =>  --  A774
          (0, 0, 16453, 16453),
         16#75#           =>  --  A775
          (0, 0, 16454, 16454),
         16#76#           =>  --  A776
          (0, 0, 16455, 16455),
         16#77#           =>  --  A777
          (0, 0, 16456, 16456),
         16#78#           =>  --  A778
          (0, 0, 16457, 16457),
         16#79#           =>  --  A779
          (0, 0, 16458, 16459),
         16#7A#           =>  --  A77A
          (0, 0, 7140, 7141),
         16#7B#           =>  --  A77B
          (0, 0, 16460, 16461),
         16#7C#           =>  --  A77C
          (0, 0, 16462, 16463),
         16#7D#           =>  --  A77D
          (0, 0, 16464, 16465),
         16#7E#           =>  --  A77E
          (0, 0, 16466, 16466),
         16#7F#           =>  --  A77F
          (0, 0, 16467, 16467),
         16#80#           =>  --  A780
          (0, 0, 16468, 16468),
         16#81#           =>  --  A781
          (0, 0, 16469, 16469),
         16#82#           =>  --  A782
          (0, 0, 16470, 16471),
         16#83#           =>  --  A783
          (0, 0, 16472, 16473),
         16#84#           =>  --  A784
          (0, 0, 16474, 16475),
         16#85#           =>  --  A785
          (0, 0, 517, 518),
         16#86#           =>  --  A786
          (0, 0, 16476, 16477),
         16#87#           =>  --  A787
          (0, 0, 16478, 16479),
         16#88#           =>  --  A788
          (0, 0, 16480, 16480),
         16#89#           =>  --  A789
          (0, 0, 16481, 16481),
         16#8A#           =>  --  A78A
          (0, 0, 16482, 16482),
         16#8B#           =>  --  A78B
          (0, 0, 16483, 16483),
         16#8C#           =>  --  A78C
          (0, 0, 16484, 16484),
         16#8D#           =>  --  A78D
          (0, 0, 16485, 16485),
         16#8E#           =>  --  A78E
          (0, 0, 16486, 16486),
         16#90#           =>  --  A790
          (0, 0, 16487, 16487),
         16#91#           =>  --  A791
          (0, 0, 16488, 16488),
         16#92#           =>  --  A792
          (0, 0, 16489, 16489),
         16#93#           =>  --  A793
          (0, 0, 16490, 16490),
         16#94#           =>  --  A794
          (0, 0, 16491, 16491),
         16#95#           =>  --  A795
          (0, 0, 16492, 16492),
         16#96#           =>  --  A796
          (0, 0, 16493, 16493),
         16#97#           =>  --  A797
          (0, 0, 16494, 16494),
         16#98#           =>  --  A798
          (0, 0, 16495, 16495),
         16#99#           =>  --  A799
          (0, 0, 16496, 16496),
         16#9A#           =>  --  A79A
          (0, 0, 16497, 16498),
         16#9B#           =>  --  A79B
          (0, 0, 7156, 7157),
         16#9C#           =>  --  A79C
          (0, 0, 16499, 16500),
         16#9D#           =>  --  A79D
          (0, 0, 7158, 7159),
         16#9E#           =>  --  A79E
          (0, 0, 16501, 16502),
         16#9F#           =>  --  A79F
          (0, 0, 7160, 7161),
         16#A0#           =>  --  A7A0
          (0, 0, 16503, 16504),
         16#A1#           =>  --  A7A1
          (0, 0, 16505, 16506),
         16#A2#           =>  --  A7A2
          (0, 0, 16507, 16508),
         16#A3#           =>  --  A7A3
          (0, 0, 16509, 16510),
         16#A4#           =>  --  A7A4
          (0, 0, 16511, 16512),
         16#A5#           =>  --  A7A5
          (0, 0, 16513, 16514),
         16#A6#           =>  --  A7A6
          (0, 0, 16515, 16516),
         16#A7#           =>  --  A7A7
          (0, 0, 16517, 16518),
         16#A8#           =>  --  A7A8
          (0, 0, 16519, 16520),
         16#A9#           =>  --  A7A9
          (0, 0, 16521, 16522),
         16#AA#           =>  --  A7AA
          (0, 0, 16523, 16523),
         16#AB#           =>  --  A7AB
          (0, 0, 16524, 16524),
         16#AC#           =>  --  A7AC
          (0, 0, 16525, 16525),
         16#AD#           =>  --  A7AD
          (0, 0, 16526, 16526),
         16#B0#           =>  --  A7B0
          (0, 0, 16527, 16527),
         16#B1#           =>  --  A7B1
          (0, 0, 16528, 16528),
         16#F7#           =>  --  A7F7
          (0, 0, 16529, 16529),
         16#F8#           =>  --  A7F8
          (0, 0, 16530, 16531),
         16#F9#           =>  --  A7F9
          (0, 0, 16532, 16534),
         16#FA#           =>  --  A7FA
          (0, 0, 16535, 16535),
         16#FB#           =>  --  A7FB
          (0, 0, 16536, 16536),
         16#FC#           =>  --  A7FC
          (0, 0, 16537, 16537),
         16#FD#           =>  --  A7FD
          (0, 0, 16538, 16538),
         16#FE#           =>  --  A7FE
          (0, 0, 16539, 16539),
         16#FF#           =>  --  A7FF
          (0, 0, 16540, 16540),
         others           =>
          (0, 0, 0, 0));

   Group_00A8 : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  A800
          (0, 0, 16541, 16541),
         16#01#           =>  --  A801
          (0, 0, 16542, 16542),
         16#02#           =>  --  A802
          (0, 0, 16543, 16543),
         16#03#           =>  --  A803
          (0, 0, 16544, 16544),
         16#04#           =>  --  A804
          (0, 0, 16545, 16545),
         16#05#           =>  --  A805
          (0, 0, 16546, 16546),
         16#06#           =>  --  A806
          (0, 0, 16547, 16547),
         16#07#           =>  --  A807
          (0, 0, 16548, 16548),
         16#08#           =>  --  A808
          (0, 0, 16549, 16549),
         16#09#           =>  --  A809
          (0, 0, 16550, 16550),
         16#0A#           =>  --  A80A
          (0, 0, 16551, 16551),
         16#0B#           =>  --  A80B
          (0, 0, 2243, 2243),
         16#0C#           =>  --  A80C
          (0, 0, 16552, 16552),
         16#0D#           =>  --  A80D
          (0, 0, 16553, 16553),
         16#0E#           =>  --  A80E
          (0, 0, 16554, 16554),
         16#0F#           =>  --  A80F
          (0, 0, 16555, 16555),
         16#10#           =>  --  A810
          (0, 0, 16556, 16556),
         16#11#           =>  --  A811
          (0, 0, 16557, 16557),
         16#12#           =>  --  A812
          (0, 0, 16558, 16558),
         16#13#           =>  --  A813
          (0, 0, 16559, 16559),
         16#14#           =>  --  A814
          (0, 0, 16560, 16560),
         16#15#           =>  --  A815
          (0, 0, 16561, 16561),
         16#16#           =>  --  A816
          (0, 0, 16562, 16562),
         16#17#           =>  --  A817
          (0, 0, 16563, 16563),
         16#18#           =>  --  A818
          (0, 0, 16564, 16564),
         16#19#           =>  --  A819
          (0, 0, 16565, 16565),
         16#1A#           =>  --  A81A
          (0, 0, 16566, 16566),
         16#1B#           =>  --  A81B
          (0, 0, 16567, 16567),
         16#1C#           =>  --  A81C
          (0, 0, 16568, 16568),
         16#1D#           =>  --  A81D
          (0, 0, 16569, 16569),
         16#1E#           =>  --  A81E
          (0, 0, 16570, 16570),
         16#1F#           =>  --  A81F
          (0, 0, 16571, 16571),
         16#20#           =>  --  A820
          (0, 0, 16572, 16572),
         16#21#           =>  --  A821
          (0, 0, 16573, 16573),
         16#22#           =>  --  A822
          (0, 0, 16574, 16574),
         16#23#           =>  --  A823
          (0, 0, 16575, 16575),
         16#24#           =>  --  A824
          (0, 0, 16576, 16576),
         16#25#           =>  --  A825
          (0, 0, 16577, 16577),
         16#26#           =>  --  A826
          (0, 0, 16578, 16578),
         16#27#           =>  --  A827
          (0, 0, 16579, 16579),
         16#28#           =>  --  A828
          (0, 0, 16580, 16580),
         16#29#           =>  --  A829
          (0, 0, 16581, 16581),
         16#2A#           =>  --  A82A
          (0, 0, 16582, 16582),
         16#2B#           =>  --  A82B
          (0, 0, 16583, 16583),
         16#30#           =>  --  A830
          (0, 0, 16584, 16584),
         16#31#           =>  --  A831
          (0, 0, 16585, 16585),
         16#32#           =>  --  A832
          (0, 0, 16586, 16586),
         16#33#           =>  --  A833
          (0, 0, 16587, 16587),
         16#34#           =>  --  A834
          (0, 0, 16588, 16588),
         16#35#           =>  --  A835
          (0, 0, 16589, 16589),
         16#36#           =>  --  A836
          (0, 0, 16590, 16590),
         16#37#           =>  --  A837
          (0, 0, 16591, 16591),
         16#38#           =>  --  A838
          (0, 0, 16592, 16592),
         16#39#           =>  --  A839
          (0, 0, 16593, 16593),
         16#40#           =>  --  A840
          (0, 0, 16594, 16594),
         16#41#           =>  --  A841
          (0, 0, 16595, 16595),
         16#42#           =>  --  A842
          (0, 0, 16596, 16596),
         16#43#           =>  --  A843
          (0, 0, 16597, 16597),
         16#44#           =>  --  A844
          (0, 0, 16598, 16598),
         16#45#           =>  --  A845
          (0, 0, 16599, 16599),
         16#46#           =>  --  A846
          (0, 0, 16600, 16600),
         16#47#           =>  --  A847
          (0, 0, 16601, 16601),
         16#48#           =>  --  A848
          (0, 0, 16602, 16602),
         16#49#           =>  --  A849
          (0, 0, 16603, 16603),
         16#4A#           =>  --  A84A
          (0, 0, 16604, 16604),
         16#4B#           =>  --  A84B
          (0, 0, 16605, 16605),
         16#4C#           =>  --  A84C
          (0, 0, 16606, 16606),
         16#4D#           =>  --  A84D
          (0, 0, 16607, 16607),
         16#4E#           =>  --  A84E
          (0, 0, 16608, 16608),
         16#4F#           =>  --  A84F
          (0, 0, 16609, 16609),
         16#50#           =>  --  A850
          (0, 0, 16610, 16610),
         16#51#           =>  --  A851
          (0, 0, 16611, 16611),
         16#52#           =>  --  A852
          (0, 0, 16612, 16612),
         16#53#           =>  --  A853
          (0, 0, 16613, 16613),
         16#54#           =>  --  A854
          (0, 0, 16614, 16614),
         16#55#           =>  --  A855
          (0, 0, 16615, 16615),
         16#56#           =>  --  A856
          (0, 0, 16616, 16616),
         16#57#           =>  --  A857
          (0, 0, 16617, 16617),
         16#58#           =>  --  A858
          (0, 0, 16618, 16618),
         16#59#           =>  --  A859
          (0, 0, 16619, 16619),
         16#5A#           =>  --  A85A
          (0, 0, 16620, 16620),
         16#5B#           =>  --  A85B
          (0, 0, 16621, 16621),
         16#5C#           =>  --  A85C
          (0, 0, 16622, 16622),
         16#5D#           =>  --  A85D
          (0, 0, 16623, 16623),
         16#5E#           =>  --  A85E
          (0, 0, 16624, 16624),
         16#5F#           =>  --  A85F
          (0, 0, 16625, 16625),
         16#60#           =>  --  A860
          (0, 0, 16626, 16626),
         16#61#           =>  --  A861
          (0, 0, 16627, 16627),
         16#62#           =>  --  A862
          (0, 0, 16628, 16628),
         16#63#           =>  --  A863
          (0, 0, 16629, 16629),
         16#64#           =>  --  A864
          (0, 0, 16630, 16630),
         16#65#           =>  --  A865
          (0, 0, 16631, 16631),
         16#66#           =>  --  A866
          (0, 0, 16632, 16632),
         16#67#           =>  --  A867
          (0, 0, 16633, 16633),
         16#68#           =>  --  A868
          (0, 0, 16634, 16634),
         16#69#           =>  --  A869
          (0, 0, 16635, 16635),
         16#6A#           =>  --  A86A
          (0, 0, 16636, 16636),
         16#6B#           =>  --  A86B
          (0, 0, 16637, 16637),
         16#6C#           =>  --  A86C
          (0, 0, 16638, 16638),
         16#6D#           =>  --  A86D
          (0, 0, 16639, 16639),
         16#6E#           =>  --  A86E
          (0, 0, 16640, 16640),
         16#6F#           =>  --  A86F
          (0, 0, 16641, 16641),
         16#70#           =>  --  A870
          (0, 0, 16642, 16642),
         16#71#           =>  --  A871
          (0, 0, 16643, 16643),
         16#72#           =>  --  A872
          (0, 0, 16644, 16644),
         16#73#           =>  --  A873
          (0, 0, 16645, 16645),
         16#74#           =>  --  A874
          (0, 0, 16646, 16646),
         16#75#           =>  --  A875
          (0, 0, 16647, 16647),
         16#76#           =>  --  A876
          (0, 0, 16648, 16648),
         16#77#           =>  --  A877
          (0, 0, 16649, 16649),
         16#80#           =>  --  A880
          (0, 0, 2243, 2243),
         16#81#           =>  --  A881
          (0, 0, 2244, 2244),
         16#82#           =>  --  A882
          (0, 0, 16650, 16650),
         16#83#           =>  --  A883
          (0, 0, 16651, 16651),
         16#84#           =>  --  A884
          (0, 0, 16652, 16652),
         16#85#           =>  --  A885
          (0, 0, 16653, 16653),
         16#86#           =>  --  A886
          (0, 0, 16654, 16654),
         16#87#           =>  --  A887
          (0, 0, 16655, 16655),
         16#88#           =>  --  A888
          (0, 0, 16656, 16656),
         16#89#           =>  --  A889
          (0, 0, 16657, 16657),
         16#8A#           =>  --  A88A
          (0, 0, 16658, 16658),
         16#8B#           =>  --  A88B
          (0, 0, 16659, 16659),
         16#8C#           =>  --  A88C
          (0, 0, 16660, 16660),
         16#8D#           =>  --  A88D
          (0, 0, 16661, 16661),
         16#8E#           =>  --  A88E
          (0, 0, 16662, 16662),
         16#8F#           =>  --  A88F
          (0, 0, 16663, 16663),
         16#90#           =>  --  A890
          (0, 0, 16664, 16664),
         16#91#           =>  --  A891
          (0, 0, 16665, 16665),
         16#92#           =>  --  A892
          (0, 0, 16666, 16666),
         16#93#           =>  --  A893
          (0, 0, 16667, 16667),
         16#94#           =>  --  A894
          (0, 0, 16668, 16668),
         16#95#           =>  --  A895
          (0, 0, 16669, 16669),
         16#96#           =>  --  A896
          (0, 0, 16670, 16670),
         16#97#           =>  --  A897
          (0, 0, 16671, 16671),
         16#98#           =>  --  A898
          (0, 0, 16672, 16672),
         16#99#           =>  --  A899
          (0, 0, 16673, 16673),
         16#9A#           =>  --  A89A
          (0, 0, 16674, 16674),
         16#9B#           =>  --  A89B
          (0, 0, 16675, 16675),
         16#9C#           =>  --  A89C
          (0, 0, 16676, 16676),
         16#9D#           =>  --  A89D
          (0, 0, 16677, 16677),
         16#9E#           =>  --  A89E
          (0, 0, 16678, 16678),
         16#9F#           =>  --  A89F
          (0, 0, 16679, 16679),
         16#A0#           =>  --  A8A0
          (0, 0, 16680, 16680),
         16#A1#           =>  --  A8A1
          (0, 0, 16681, 16681),
         16#A2#           =>  --  A8A2
          (0, 0, 16682, 16682),
         16#A3#           =>  --  A8A3
          (0, 0, 16683, 16683),
         16#A4#           =>  --  A8A4
          (0, 0, 16684, 16684),
         16#A5#           =>  --  A8A5
          (0, 0, 16685, 16685),
         16#A6#           =>  --  A8A6
          (0, 0, 16686, 16686),
         16#A7#           =>  --  A8A7
          (0, 0, 16687, 16687),
         16#A8#           =>  --  A8A8
          (0, 0, 16688, 16688),
         16#A9#           =>  --  A8A9
          (0, 0, 16689, 16689),
         16#AA#           =>  --  A8AA
          (0, 0, 16690, 16690),
         16#AB#           =>  --  A8AB
          (0, 0, 16691, 16691),
         16#AC#           =>  --  A8AC
          (0, 0, 16692, 16692),
         16#AD#           =>  --  A8AD
          (0, 0, 16693, 16693),
         16#AE#           =>  --  A8AE
          (0, 0, 16694, 16694),
         16#AF#           =>  --  A8AF
          (0, 0, 16695, 16695),
         16#B0#           =>  --  A8B0
          (0, 0, 16696, 16696),
         16#B1#           =>  --  A8B1
          (0, 0, 16697, 16697),
         16#B2#           =>  --  A8B2
          (0, 0, 16698, 16698),
         16#B3#           =>  --  A8B3
          (0, 0, 16699, 16699),
         16#B4#           =>  --  A8B4
          (0, 0, 16700, 16700),
         16#B5#           =>  --  A8B5
          (0, 0, 16701, 16701),
         16#B6#           =>  --  A8B6
          (0, 0, 16702, 16702),
         16#B7#           =>  --  A8B7
          (0, 0, 16703, 16703),
         16#B8#           =>  --  A8B8
          (0, 0, 16704, 16704),
         16#B9#           =>  --  A8B9
          (0, 0, 16705, 16705),
         16#BA#           =>  --  A8BA
          (0, 0, 16706, 16706),
         16#BB#           =>  --  A8BB
          (0, 0, 16707, 16707),
         16#BC#           =>  --  A8BC
          (0, 0, 16708, 16708),
         16#BD#           =>  --  A8BD
          (0, 0, 16709, 16709),
         16#BE#           =>  --  A8BE
          (0, 0, 16710, 16710),
         16#BF#           =>  --  A8BF
          (0, 0, 16711, 16711),
         16#C0#           =>  --  A8C0
          (0, 0, 16712, 16712),
         16#C1#           =>  --  A8C1
          (0, 0, 16713, 16713),
         16#C2#           =>  --  A8C2
          (0, 0, 16714, 16714),
         16#C3#           =>  --  A8C3
          (0, 0, 16715, 16715),
         16#C4#           =>  --  A8C4
          (0, 0, 16716, 16716),
         16#CE#           =>  --  A8CE
          (0, 0, 16717, 16717),
         16#CF#           =>  --  A8CF
          (0, 0, 16718, 16718),
         16#D0#           =>  --  A8D0
          (0, 0, 23, 23),
         16#D1#           =>  --  A8D1
          (0, 0, 24, 24),
         16#D2#           =>  --  A8D2
          (0, 0, 25, 25),
         16#D3#           =>  --  A8D3
          (0, 0, 26, 26),
         16#D4#           =>  --  A8D4
          (0, 0, 27, 27),
         16#D5#           =>  --  A8D5
          (0, 0, 28, 28),
         16#D6#           =>  --  A8D6
          (0, 0, 29, 29),
         16#D7#           =>  --  A8D7
          (0, 0, 30, 30),
         16#D8#           =>  --  A8D8
          (0, 0, 31, 31),
         16#D9#           =>  --  A8D9
          (0, 0, 32, 32),
         16#E0# .. 16#F1# =>  --  A8E0 .. A8F1
          (0, 0, 1, 1),
         16#F2#           =>  --  A8F2
          (0, 0, 16719, 16719),
         16#F3# .. 16#F7# =>  --  A8F3 .. A8F7
          (0, 0, 16720, 16720),
         16#F8#           =>  --  A8F8
          (0, 0, 16721, 16721),
         16#F9#           =>  --  A8F9
          (0, 0, 16722, 16722),
         16#FA#           =>  --  A8FA
          (0, 0, 16723, 16723),
         16#FB#           =>  --  A8FB
          (0, 0, 16724, 16724),
         others           =>
          (0, 0, 0, 0));

   Group_00A9 : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  A900
          (0, 0, 23, 23),
         16#01#           =>  --  A901
          (0, 0, 24, 24),
         16#02#           =>  --  A902
          (0, 0, 25, 25),
         16#03#           =>  --  A903
          (0, 0, 26, 26),
         16#04#           =>  --  A904
          (0, 0, 27, 27),
         16#05#           =>  --  A905
          (0, 0, 28, 28),
         16#06#           =>  --  A906
          (0, 0, 29, 29),
         16#07#           =>  --  A907
          (0, 0, 30, 30),
         16#08#           =>  --  A908
          (0, 0, 31, 31),
         16#09#           =>  --  A909
          (0, 0, 32, 32),
         16#0A#           =>  --  A90A
          (0, 0, 16725, 16725),
         16#0B#           =>  --  A90B
          (0, 0, 16726, 16726),
         16#0C#           =>  --  A90C
          (0, 0, 16727, 16727),
         16#0D#           =>  --  A90D
          (0, 0, 16728, 16728),
         16#0E#           =>  --  A90E
          (0, 0, 16729, 16729),
         16#0F#           =>  --  A90F
          (0, 0, 16730, 16730),
         16#10#           =>  --  A910
          (0, 0, 16731, 16731),
         16#11#           =>  --  A911
          (0, 0, 16732, 16732),
         16#12#           =>  --  A912
          (0, 0, 16733, 16733),
         16#13#           =>  --  A913
          (0, 0, 16734, 16734),
         16#14#           =>  --  A914
          (0, 0, 16735, 16735),
         16#15#           =>  --  A915
          (0, 0, 16736, 16736),
         16#16#           =>  --  A916
          (0, 0, 16737, 16737),
         16#17#           =>  --  A917
          (0, 0, 16738, 16738),
         16#18#           =>  --  A918
          (0, 0, 16739, 16739),
         16#19#           =>  --  A919
          (0, 0, 16740, 16740),
         16#1A#           =>  --  A91A
          (0, 0, 16741, 16741),
         16#1B#           =>  --  A91B
          (0, 0, 16742, 16742),
         16#1C#           =>  --  A91C
          (0, 0, 16743, 16743),
         16#1D#           =>  --  A91D
          (0, 0, 16744, 16744),
         16#1E#           =>  --  A91E
          (0, 0, 16745, 16745),
         16#1F#           =>  --  A91F
          (0, 0, 16746, 16746),
         16#20#           =>  --  A920
          (0, 0, 16747, 16747),
         16#21#           =>  --  A921
          (0, 0, 16748, 16748),
         16#22#           =>  --  A922
          (0, 0, 16749, 16749),
         16#23#           =>  --  A923
          (0, 0, 16750, 16750),
         16#24#           =>  --  A924
          (0, 0, 16751, 16751),
         16#25#           =>  --  A925
          (0, 0, 16752, 16752),
         16#26#           =>  --  A926
          (0, 0, 16753, 16753),
         16#27#           =>  --  A927
          (0, 0, 16754, 16754),
         16#28#           =>  --  A928
          (0, 0, 16755, 16755),
         16#29#           =>  --  A929
          (0, 0, 16756, 16756),
         16#2A#           =>  --  A92A
          (0, 0, 16757, 16757),
         16#2B#           =>  --  A92B
          (0, 0, 16758, 16758),
         16#2C#           =>  --  A92C
          (0, 0, 16759, 16759),
         16#2D#           =>  --  A92D
          (0, 0, 16760, 16760),
         16#2E#           =>  --  A92E
          (0, 0, 16761, 16761),
         16#2F#           =>  --  A92F
          (0, 0, 16762, 16762),
         16#30#           =>  --  A930
          (0, 0, 16763, 16763),
         16#31#           =>  --  A931
          (0, 0, 16764, 16764),
         16#32#           =>  --  A932
          (0, 0, 16765, 16765),
         16#33#           =>  --  A933
          (0, 0, 16766, 16766),
         16#34#           =>  --  A934
          (0, 0, 16767, 16767),
         16#35#           =>  --  A935
          (0, 0, 16768, 16768),
         16#36#           =>  --  A936
          (0, 0, 16769, 16769),
         16#37#           =>  --  A937
          (0, 0, 16770, 16770),
         16#38#           =>  --  A938
          (0, 0, 16771, 16771),
         16#39#           =>  --  A939
          (0, 0, 16772, 16772),
         16#3A#           =>  --  A93A
          (0, 0, 16773, 16773),
         16#3B#           =>  --  A93B
          (0, 0, 16774, 16774),
         16#3C#           =>  --  A93C
          (0, 0, 16775, 16775),
         16#3D#           =>  --  A93D
          (0, 0, 16776, 16776),
         16#3E#           =>  --  A93E
          (0, 0, 16777, 16777),
         16#3F#           =>  --  A93F
          (0, 0, 16778, 16778),
         16#40#           =>  --  A940
          (0, 0, 16779, 16779),
         16#41#           =>  --  A941
          (0, 0, 16780, 16780),
         16#42#           =>  --  A942
          (0, 0, 16781, 16781),
         16#43#           =>  --  A943
          (0, 0, 16782, 16782),
         16#44#           =>  --  A944
          (0, 0, 16783, 16783),
         16#45#           =>  --  A945
          (0, 0, 16784, 16784),
         16#46#           =>  --  A946
          (0, 0, 16785, 16785),
         16#47#           =>  --  A947
          (0, 0, 16786, 16786),
         16#48#           =>  --  A948
          (0, 0, 16787, 16787),
         16#49#           =>  --  A949
          (0, 0, 16788, 16788),
         16#4A#           =>  --  A94A
          (0, 0, 16789, 16789),
         16#4B#           =>  --  A94B
          (0, 0, 16790, 16790),
         16#4C#           =>  --  A94C
          (0, 0, 16791, 16791),
         16#4D#           =>  --  A94D
          (0, 0, 16792, 16792),
         16#4E#           =>  --  A94E
          (0, 0, 16793, 16793),
         16#4F#           =>  --  A94F
          (0, 0, 16794, 16794),
         16#50#           =>  --  A950
          (0, 0, 16795, 16795),
         16#51#           =>  --  A951
          (0, 0, 16796, 16796),
         16#52#           =>  --  A952
          (0, 0, 16797, 16797),
         16#53#           =>  --  A953
          (0, 0, 16798, 16798),
         16#5F#           =>  --  A95F
          (0, 0, 16799, 16799),
         16#60#           =>  --  A960
          (0, 0, 16800, 16800),
         16#61#           =>  --  A961
          (0, 0, 16801, 16801),
         16#62#           =>  --  A962
          (0, 0, 16802, 16802),
         16#63#           =>  --  A963
          (0, 0, 16803, 16803),
         16#64#           =>  --  A964
          (0, 0, 16804, 16804),
         16#65#           =>  --  A965
          (0, 0, 16805, 16805),
         16#66#           =>  --  A966
          (0, 0, 16806, 16806),
         16#67#           =>  --  A967
          (0, 0, 16807, 16807),
         16#68#           =>  --  A968
          (0, 0, 16808, 16808),
         16#69#           =>  --  A969
          (0, 0, 16809, 16809),
         16#6A#           =>  --  A96A
          (0, 0, 16810, 16810),
         16#6B#           =>  --  A96B
          (0, 0, 16811, 16811),
         16#6C#           =>  --  A96C
          (0, 0, 16812, 16812),
         16#6D#           =>  --  A96D
          (0, 0, 16813, 16813),
         16#6E#           =>  --  A96E
          (0, 0, 16814, 16814),
         16#6F#           =>  --  A96F
          (0, 0, 16815, 16815),
         16#70#           =>  --  A970
          (0, 0, 16816, 16816),
         16#71#           =>  --  A971
          (0, 0, 16817, 16817),
         16#72#           =>  --  A972
          (0, 0, 16818, 16818),
         16#73#           =>  --  A973
          (0, 0, 16819, 16819),
         16#74#           =>  --  A974
          (0, 0, 16820, 16820),
         16#75#           =>  --  A975
          (0, 0, 16821, 16821),
         16#76#           =>  --  A976
          (0, 0, 16822, 16822),
         16#77#           =>  --  A977
          (0, 0, 16823, 16823),
         16#78#           =>  --  A978
          (0, 0, 16824, 16824),
         16#79#           =>  --  A979
          (0, 0, 16825, 16825),
         16#7A#           =>  --  A97A
          (0, 0, 16826, 16826),
         16#7B#           =>  --  A97B
          (0, 0, 16827, 16827),
         16#7C#           =>  --  A97C
          (0, 0, 16828, 16828),
         16#80#           =>  --  A980
          (0, 0, 2242, 2242),
         16#81#           =>  --  A981
          (0, 0, 2243, 2243),
         16#82#           =>  --  A982
          (0, 0, 16829, 16829),
         16#83#           =>  --  A983
          (0, 0, 2244, 2244),
         16#84#           =>  --  A984
          (0, 0, 16830, 16830),
         16#85#           =>  --  A985
          (0, 0, 16831, 16831),
         16#86#           =>  --  A986
          (0, 0, 16832, 16832),
         16#87#           =>  --  A987
          (0, 0, 16833, 16833),
         16#88#           =>  --  A988
          (0, 0, 16834, 16834),
         16#89#           =>  --  A989
          (0, 0, 16835, 16835),
         16#8A#           =>  --  A98A
          (0, 0, 16836, 16836),
         16#8B#           =>  --  A98B
          (0, 0, 16837, 16837),
         16#8C#           =>  --  A98C
          (0, 0, 16838, 16838),
         16#8D#           =>  --  A98D
          (0, 0, 16839, 16839),
         16#8E#           =>  --  A98E
          (0, 0, 16840, 16840),
         16#8F#           =>  --  A98F
          (0, 0, 16841, 16841),
         16#90#           =>  --  A990
          (0, 0, 16842, 16842),
         16#91#           =>  --  A991
          (0, 0, 16843, 16843),
         16#92#           =>  --  A992
          (0, 0, 16844, 16844),
         16#93#           =>  --  A993
          (0, 0, 16845, 16845),
         16#94#           =>  --  A994
          (0, 0, 16846, 16846),
         16#95#           =>  --  A995
          (0, 0, 16847, 16847),
         16#96#           =>  --  A996
          (0, 0, 16848, 16848),
         16#97#           =>  --  A997
          (0, 0, 16849, 16849),
         16#98#           =>  --  A998
          (0, 0, 16850, 16850),
         16#99#           =>  --  A999
          (0, 0, 16851, 16851),
         16#9A#           =>  --  A99A
          (0, 0, 16852, 16852),
         16#9B#           =>  --  A99B
          (0, 0, 16853, 16853),
         16#9C#           =>  --  A99C
          (0, 0, 16854, 16854),
         16#9D#           =>  --  A99D
          (0, 0, 16855, 16855),
         16#9E#           =>  --  A99E
          (0, 0, 16856, 16856),
         16#9F#           =>  --  A99F
          (0, 0, 16857, 16857),
         16#A0#           =>  --  A9A0
          (0, 0, 16858, 16858),
         16#A1#           =>  --  A9A1
          (0, 0, 16859, 16859),
         16#A2#           =>  --  A9A2
          (0, 0, 16860, 16860),
         16#A3#           =>  --  A9A3
          (0, 0, 16861, 16861),
         16#A4#           =>  --  A9A4
          (0, 0, 16862, 16862),
         16#A5#           =>  --  A9A5
          (0, 0, 16863, 16863),
         16#A6#           =>  --  A9A6
          (0, 0, 16864, 16864),
         16#A7#           =>  --  A9A7
          (0, 0, 16865, 16865),
         16#A8#           =>  --  A9A8
          (0, 0, 16866, 16866),
         16#A9#           =>  --  A9A9
          (0, 0, 16867, 16867),
         16#AA#           =>  --  A9AA
          (0, 0, 16868, 16868),
         16#AB#           =>  --  A9AB
          (0, 0, 16869, 16869),
         16#AC#           =>  --  A9AC
          (0, 0, 16870, 16870),
         16#AD#           =>  --  A9AD
          (0, 0, 16871, 16871),
         16#AE#           =>  --  A9AE
          (0, 0, 16872, 16872),
         16#AF#           =>  --  A9AF
          (0, 0, 16873, 16873),
         16#B0#           =>  --  A9B0
          (0, 0, 16874, 16874),
         16#B1#           =>  --  A9B1
          (0, 0, 16875, 16875),
         16#B2#           =>  --  A9B2
          (0, 0, 16876, 16876),
         16#B3#           =>  --  A9B3
          (0, 0, 2283, 2283),
         16#B4#           =>  --  A9B4
          (0, 0, 16877, 16877),
         16#B5#           =>  --  A9B5
          (0, 0, 16878, 16878),
         16#B6#           =>  --  A9B6
          (0, 0, 16879, 16879),
         16#B7#           =>  --  A9B7
          (0, 0, 16880, 16880),
         16#B8#           =>  --  A9B8
          (0, 0, 16881, 16881),
         16#B9#           =>  --  A9B9
          (0, 0, 16882, 16882),
         16#BA#           =>  --  A9BA
          (0, 0, 16883, 16883),
         16#BB#           =>  --  A9BB
          (0, 0, 16884, 16884),
         16#BC#           =>  --  A9BC
          (0, 0, 16885, 16885),
         16#BD#           =>  --  A9BD
          (0, 0, 16886, 16886),
         16#BE#           =>  --  A9BE
          (0, 0, 16887, 16887),
         16#BF#           =>  --  A9BF
          (0, 0, 16888, 16888),
         16#C0#           =>  --  A9C0
          (0, 0, 16889, 16889),
         16#C1#           =>  --  A9C1
          (0, 0, 16890, 16890),
         16#C2#           =>  --  A9C2
          (0, 0, 16891, 16891),
         16#C3#           =>  --  A9C3
          (0, 0, 16892, 16892),
         16#C4#           =>  --  A9C4
          (0, 0, 16893, 16893),
         16#C5#           =>  --  A9C5
          (0, 0, 16894, 16894),
         16#C6#           =>  --  A9C6
          (0, 0, 16895, 16895),
         16#C7#           =>  --  A9C7
          (0, 0, 16896, 16896),
         16#C8#           =>  --  A9C8
          (0, 0, 16897, 16897),
         16#C9#           =>  --  A9C9
          (0, 0, 16898, 16898),
         16#CA#           =>  --  A9CA
          (0, 0, 16899, 16899),
         16#CB#           =>  --  A9CB
          (0, 0, 16900, 16900),
         16#CC#           =>  --  A9CC
          (0, 0, 16901, 16901),
         16#CD#           =>  --  A9CD
          (0, 0, 16902, 16902),
         16#CF#           =>  --  A9CF
          (0, 0, 16903, 16903),
         16#D0#           =>  --  A9D0
          (0, 0, 23, 23),
         16#D1#           =>  --  A9D1
          (0, 0, 24, 24),
         16#D2#           =>  --  A9D2
          (0, 0, 25, 25),
         16#D3#           =>  --  A9D3
          (0, 0, 26, 26),
         16#D4#           =>  --  A9D4
          (0, 0, 27, 27),
         16#D5#           =>  --  A9D5
          (0, 0, 28, 28),
         16#D6#           =>  --  A9D6
          (0, 0, 29, 29),
         16#D7#           =>  --  A9D7
          (0, 0, 30, 30),
         16#D8#           =>  --  A9D8
          (0, 0, 31, 31),
         16#D9#           =>  --  A9D9
          (0, 0, 32, 32),
         16#DE#           =>  --  A9DE
          (0, 0, 16904, 16904),
         16#DF#           =>  --  A9DF
          (0, 0, 16905, 16905),
         16#E0#           =>  --  A9E0
          (0, 0, 16906, 16906),
         16#E1#           =>  --  A9E1
          (0, 0, 16907, 16907),
         16#E2#           =>  --  A9E2
          (0, 0, 16908, 16908),
         16#E3#           =>  --  A9E3
          (0, 0, 16909, 16909),
         16#E4#           =>  --  A9E4
          (0, 0, 16910, 16910),
         16#E5#           =>  --  A9E5
          (0, 0, 16911, 16911),
         16#E6#           =>  --  A9E6
          (0, 0, 16912, 16912),
         16#E7#           =>  --  A9E7
          (0, 0, 16913, 16913),
         16#E8#           =>  --  A9E8
          (0, 0, 16914, 16914),
         16#E9#           =>  --  A9E9
          (0, 0, 16915, 16915),
         16#EA#           =>  --  A9EA
          (0, 0, 16916, 16916),
         16#EB#           =>  --  A9EB
          (0, 0, 16917, 16917),
         16#EC#           =>  --  A9EC
          (0, 0, 16918, 16918),
         16#ED#           =>  --  A9ED
          (0, 0, 16919, 16919),
         16#EE#           =>  --  A9EE
          (0, 0, 16920, 16920),
         16#EF#           =>  --  A9EF
          (0, 0, 16921, 16921),
         16#F0#           =>  --  A9F0
          (0, 0, 23, 23),
         16#F1#           =>  --  A9F1
          (0, 0, 24, 24),
         16#F2#           =>  --  A9F2
          (0, 0, 25, 25),
         16#F3#           =>  --  A9F3
          (0, 0, 26, 26),
         16#F4#           =>  --  A9F4
          (0, 0, 27, 27),
         16#F5#           =>  --  A9F5
          (0, 0, 28, 28),
         16#F6#           =>  --  A9F6
          (0, 0, 29, 29),
         16#F7#           =>  --  A9F7
          (0, 0, 30, 30),
         16#F8#           =>  --  A9F8
          (0, 0, 31, 31),
         16#F9#           =>  --  A9F9
          (0, 0, 32, 32),
         16#FA#           =>  --  A9FA
          (0, 0, 16922, 16922),
         16#FB#           =>  --  A9FB
          (0, 0, 16923, 16923),
         16#FC#           =>  --  A9FC
          (0, 0, 16924, 16924),
         16#FD#           =>  --  A9FD
          (0, 0, 16925, 16925),
         16#FE#           =>  --  A9FE
          (0, 0, 16926, 16926),
         others           =>
          (0, 0, 0, 0));

   Group_00AA : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  AA00
          (0, 0, 16927, 16927),
         16#01#           =>  --  AA01
          (0, 0, 16928, 16928),
         16#02#           =>  --  AA02
          (0, 0, 16929, 16929),
         16#03#           =>  --  AA03
          (0, 0, 16930, 16930),
         16#04#           =>  --  AA04
          (0, 0, 16931, 16931),
         16#05#           =>  --  AA05
          (0, 0, 16932, 16932),
         16#06#           =>  --  AA06
          (0, 0, 16933, 16933),
         16#07#           =>  --  AA07
          (0, 0, 16934, 16934),
         16#08#           =>  --  AA08
          (0, 0, 16935, 16935),
         16#09#           =>  --  AA09
          (0, 0, 16936, 16936),
         16#0A#           =>  --  AA0A
          (0, 0, 16937, 16937),
         16#0B#           =>  --  AA0B
          (0, 0, 16938, 16938),
         16#0C#           =>  --  AA0C
          (0, 0, 16939, 16939),
         16#0D#           =>  --  AA0D
          (0, 0, 16940, 16940),
         16#0E#           =>  --  AA0E
          (0, 0, 16941, 16941),
         16#0F#           =>  --  AA0F
          (0, 0, 16942, 16942),
         16#10#           =>  --  AA10
          (0, 0, 16943, 16943),
         16#11#           =>  --  AA11
          (0, 0, 16944, 16944),
         16#12#           =>  --  AA12
          (0, 0, 16945, 16945),
         16#13#           =>  --  AA13
          (0, 0, 16946, 16946),
         16#14#           =>  --  AA14
          (0, 0, 16947, 16947),
         16#15#           =>  --  AA15
          (0, 0, 16948, 16948),
         16#16#           =>  --  AA16
          (0, 0, 16949, 16949),
         16#17#           =>  --  AA17
          (0, 0, 16950, 16950),
         16#18#           =>  --  AA18
          (0, 0, 16951, 16951),
         16#19#           =>  --  AA19
          (0, 0, 16952, 16952),
         16#1A#           =>  --  AA1A
          (0, 0, 16953, 16953),
         16#1B#           =>  --  AA1B
          (0, 0, 16954, 16954),
         16#1C#           =>  --  AA1C
          (0, 0, 16955, 16955),
         16#1D#           =>  --  AA1D
          (0, 0, 16956, 16956),
         16#1E#           =>  --  AA1E
          (0, 0, 16957, 16957),
         16#1F#           =>  --  AA1F
          (0, 0, 16958, 16958),
         16#20#           =>  --  AA20
          (0, 0, 16959, 16959),
         16#21#           =>  --  AA21
          (0, 0, 16960, 16960),
         16#22#           =>  --  AA22
          (0, 0, 16961, 16961),
         16#23#           =>  --  AA23
          (0, 0, 16962, 16962),
         16#24#           =>  --  AA24
          (0, 0, 16963, 16963),
         16#25#           =>  --  AA25
          (0, 0, 16964, 16964),
         16#26#           =>  --  AA26
          (0, 0, 16965, 16965),
         16#27#           =>  --  AA27
          (0, 0, 16966, 16966),
         16#28#           =>  --  AA28
          (0, 0, 16967, 16967),
         16#29#           =>  --  AA29
          (0, 0, 16968, 16968),
         16#2A#           =>  --  AA2A
          (0, 0, 16969, 16969),
         16#2B#           =>  --  AA2B
          (0, 0, 16970, 16970),
         16#2C#           =>  --  AA2C
          (0, 0, 16971, 16971),
         16#2D#           =>  --  AA2D
          (0, 0, 16972, 16972),
         16#2E#           =>  --  AA2E
          (0, 0, 16973, 16973),
         16#2F#           =>  --  AA2F
          (0, 0, 16974, 16974),
         16#30#           =>  --  AA30
          (0, 0, 16975, 16975),
         16#31#           =>  --  AA31
          (0, 0, 16976, 16976),
         16#32#           =>  --  AA32
          (0, 0, 16977, 16977),
         16#33#           =>  --  AA33
          (0, 0, 16978, 16978),
         16#34#           =>  --  AA34
          (0, 0, 16979, 16979),
         16#35#           =>  --  AA35
          (0, 0, 16980, 16980),
         16#36#           =>  --  AA36
          (0, 0, 16981, 16981),
         16#40#           =>  --  AA40
          (0, 0, 16982, 16982),
         16#41#           =>  --  AA41
          (0, 0, 16983, 16983),
         16#42#           =>  --  AA42
          (0, 0, 16984, 16984),
         16#43#           =>  --  AA43
          (0, 0, 16985, 16985),
         16#44#           =>  --  AA44
          (0, 0, 16986, 16986),
         16#45#           =>  --  AA45
          (0, 0, 16987, 16987),
         16#46#           =>  --  AA46
          (0, 0, 16988, 16988),
         16#47#           =>  --  AA47
          (0, 0, 16989, 16989),
         16#48#           =>  --  AA48
          (0, 0, 16990, 16990),
         16#49#           =>  --  AA49
          (0, 0, 16991, 16991),
         16#4A#           =>  --  AA4A
          (0, 0, 16992, 16992),
         16#4B#           =>  --  AA4B
          (0, 0, 16993, 16993),
         16#4C#           =>  --  AA4C
          (0, 0, 16994, 16994),
         16#4D#           =>  --  AA4D
          (0, 0, 16995, 16995),
         16#50#           =>  --  AA50
          (0, 0, 23, 23),
         16#51#           =>  --  AA51
          (0, 0, 24, 24),
         16#52#           =>  --  AA52
          (0, 0, 25, 25),
         16#53#           =>  --  AA53
          (0, 0, 26, 26),
         16#54#           =>  --  AA54
          (0, 0, 27, 27),
         16#55#           =>  --  AA55
          (0, 0, 28, 28),
         16#56#           =>  --  AA56
          (0, 0, 29, 29),
         16#57#           =>  --  AA57
          (0, 0, 30, 30),
         16#58#           =>  --  AA58
          (0, 0, 31, 31),
         16#59#           =>  --  AA59
          (0, 0, 32, 32),
         16#5C#           =>  --  AA5C
          (0, 0, 16996, 16996),
         16#5D#           =>  --  AA5D
          (0, 0, 16997, 16997),
         16#5E#           =>  --  AA5E
          (0, 0, 16998, 16998),
         16#5F#           =>  --  AA5F
          (0, 0, 16999, 16999),
         16#60#           =>  --  AA60
          (0, 0, 17000, 17000),
         16#61#           =>  --  AA61
          (0, 0, 17001, 17001),
         16#62#           =>  --  AA62
          (0, 0, 17002, 17002),
         16#63#           =>  --  AA63
          (0, 0, 17003, 17003),
         16#64#           =>  --  AA64
          (0, 0, 17004, 17004),
         16#65#           =>  --  AA65
          (0, 0, 17005, 17005),
         16#66#           =>  --  AA66
          (0, 0, 17006, 17006),
         16#67#           =>  --  AA67
          (0, 0, 17007, 17007),
         16#68#           =>  --  AA68
          (0, 0, 17008, 17008),
         16#69#           =>  --  AA69
          (0, 0, 17009, 17009),
         16#6A#           =>  --  AA6A
          (0, 0, 17010, 17010),
         16#6B#           =>  --  AA6B
          (0, 0, 17011, 17011),
         16#6C#           =>  --  AA6C
          (0, 0, 17012, 17012),
         16#6D#           =>  --  AA6D
          (0, 0, 17013, 17013),
         16#6E#           =>  --  AA6E
          (0, 0, 17014, 17014),
         16#6F#           =>  --  AA6F
          (0, 0, 17015, 17015),
         16#70#           =>  --  AA70
          (0, 0, 17016, 17016),
         16#71#           =>  --  AA71
          (0, 0, 17017, 17017),
         16#72#           =>  --  AA72
          (0, 0, 17018, 17018),
         16#73#           =>  --  AA73
          (0, 0, 17019, 17019),
         16#74#           =>  --  AA74
          (0, 0, 17020, 17020),
         16#75#           =>  --  AA75
          (0, 0, 17021, 17021),
         16#76#           =>  --  AA76
          (0, 0, 17022, 17022),
         16#77#           =>  --  AA77
          (0, 0, 17023, 17023),
         16#78#           =>  --  AA78
          (0, 0, 17024, 17024),
         16#79#           =>  --  AA79
          (0, 0, 17025, 17025),
         16#7A#           =>  --  AA7A
          (0, 0, 17026, 17026),
         16#7B#           =>  --  AA7B
          (0, 0, 17027, 17027),
         16#7C#           =>  --  AA7C
          (0, 0, 17028, 17028),
         16#7D#           =>  --  AA7D
          (0, 0, 17029, 17029),
         16#7E#           =>  --  AA7E
          (0, 0, 17030, 17030),
         16#7F#           =>  --  AA7F
          (0, 0, 17031, 17031),
         16#80#           =>  --  AA80
          (0, 0, 17032, 17032),
         16#81#           =>  --  AA81
          (0, 0, 17033, 17033),
         16#82#           =>  --  AA82
          (0, 0, 17034, 17034),
         16#83#           =>  --  AA83
          (0, 0, 17035, 17035),
         16#84#           =>  --  AA84
          (0, 0, 17036, 17036),
         16#85#           =>  --  AA85
          (0, 0, 17037, 17037),
         16#86#           =>  --  AA86
          (0, 0, 17038, 17038),
         16#87#           =>  --  AA87
          (0, 0, 17039, 17039),
         16#88#           =>  --  AA88
          (0, 0, 17040, 17040),
         16#89#           =>  --  AA89
          (0, 0, 17041, 17041),
         16#8A#           =>  --  AA8A
          (0, 0, 17042, 17042),
         16#8B#           =>  --  AA8B
          (0, 0, 17043, 17043),
         16#8C#           =>  --  AA8C
          (0, 0, 17044, 17044),
         16#8D#           =>  --  AA8D
          (0, 0, 17045, 17045),
         16#8E#           =>  --  AA8E
          (0, 0, 17046, 17046),
         16#8F#           =>  --  AA8F
          (0, 0, 17047, 17047),
         16#90#           =>  --  AA90
          (0, 0, 17048, 17048),
         16#91#           =>  --  AA91
          (0, 0, 17049, 17049),
         16#92#           =>  --  AA92
          (0, 0, 17050, 17050),
         16#93#           =>  --  AA93
          (0, 0, 17051, 17051),
         16#94#           =>  --  AA94
          (0, 0, 17052, 17052),
         16#95#           =>  --  AA95
          (0, 0, 17053, 17053),
         16#96#           =>  --  AA96
          (0, 0, 17054, 17054),
         16#97#           =>  --  AA97
          (0, 0, 17055, 17055),
         16#98#           =>  --  AA98
          (0, 0, 17056, 17056),
         16#99#           =>  --  AA99
          (0, 0, 17057, 17057),
         16#9A#           =>  --  AA9A
          (0, 0, 17058, 17058),
         16#9B#           =>  --  AA9B
          (0, 0, 17059, 17059),
         16#9C#           =>  --  AA9C
          (0, 0, 17060, 17060),
         16#9D#           =>  --  AA9D
          (0, 0, 17061, 17061),
         16#9E#           =>  --  AA9E
          (0, 0, 17062, 17062),
         16#9F#           =>  --  AA9F
          (0, 0, 17063, 17063),
         16#A0#           =>  --  AAA0
          (0, 0, 17064, 17064),
         16#A1#           =>  --  AAA1
          (0, 0, 17065, 17065),
         16#A2#           =>  --  AAA2
          (0, 0, 17066, 17066),
         16#A3#           =>  --  AAA3
          (0, 0, 17067, 17067),
         16#A4#           =>  --  AAA4
          (0, 0, 17068, 17068),
         16#A5#           =>  --  AAA5
          (0, 0, 17069, 17069),
         16#A6#           =>  --  AAA6
          (0, 0, 17070, 17070),
         16#A7#           =>  --  AAA7
          (0, 0, 17071, 17071),
         16#A8#           =>  --  AAA8
          (0, 0, 17072, 17072),
         16#A9#           =>  --  AAA9
          (0, 0, 17073, 17073),
         16#AA#           =>  --  AAAA
          (0, 0, 17074, 17074),
         16#AB#           =>  --  AAAB
          (0, 0, 17075, 17075),
         16#AC#           =>  --  AAAC
          (0, 0, 17076, 17076),
         16#AD#           =>  --  AAAD
          (0, 0, 17077, 17077),
         16#AE#           =>  --  AAAE
          (0, 0, 17078, 17078),
         16#AF#           =>  --  AAAF
          (0, 0, 17079, 17079),
         16#B0#           =>  --  AAB0
          (0, 0, 17080, 17080),
         16#B1#           =>  --  AAB1
          (0, 0, 17081, 17081),
         16#B2#           =>  --  AAB2
          (0, 0, 17082, 17082),
         16#B3#           =>  --  AAB3
          (0, 0, 17083, 17083),
         16#B4#           =>  --  AAB4
          (0, 0, 17084, 17084),
         16#B5#           =>  --  AAB5
          (454, 501, 17085, 17085),
         16#B6#           =>  --  AAB6
          (502, 549, 17182, 17182),
         16#B7#           =>  --  AAB7
          (0, 0, 17279, 17279),
         16#B8#           =>  --  AAB8
          (0, 0, 17280, 17280),
         16#B9#           =>  --  AAB9
          (550, 597, 17281, 17281),
         16#BA#           =>  --  AABA
          (0, 0, 17378, 17378),
         16#BB#           =>  --  AABB
          (598, 645, 17379, 17379),
         16#BC#           =>  --  AABC
          (646, 693, 17476, 17476),
         16#BD#           =>  --  AABD
          (0, 0, 17573, 17573),
         16#BE#           =>  --  AABE
          (0, 0, 17574, 17574),
         16#BF#           =>  --  AABF
          (0, 0, 17575, 17575),
         16#C0#           =>  --  AAC0
          (0, 0, 17576, 17576),
         16#C1#           =>  --  AAC1
          (0, 0, 17577, 17577),
         16#C2#           =>  --  AAC2
          (0, 0, 17578, 17578),
         16#DB#           =>  --  AADB
          (0, 0, 17579, 17579),
         16#DC#           =>  --  AADC
          (0, 0, 17580, 17580),
         16#DD#           =>  --  AADD
          (0, 0, 17581, 17581),
         16#DE#           =>  --  AADE
          (0, 0, 17582, 17582),
         16#DF#           =>  --  AADF
          (0, 0, 17583, 17583),
         16#E0#           =>  --  AAE0
          (0, 0, 17584, 17584),
         16#E1#           =>  --  AAE1
          (0, 0, 17585, 17585),
         16#E2#           =>  --  AAE2
          (0, 0, 17586, 17586),
         16#E3#           =>  --  AAE3
          (0, 0, 17587, 17587),
         16#E4#           =>  --  AAE4
          (0, 0, 17588, 17588),
         16#E5#           =>  --  AAE5
          (0, 0, 17589, 17589),
         16#E6#           =>  --  AAE6
          (0, 0, 17590, 17590),
         16#E7#           =>  --  AAE7
          (0, 0, 17591, 17591),
         16#E8#           =>  --  AAE8
          (0, 0, 17592, 17592),
         16#E9#           =>  --  AAE9
          (0, 0, 17593, 17593),
         16#EA#           =>  --  AAEA
          (0, 0, 17594, 17594),
         16#EB#           =>  --  AAEB
          (0, 0, 17595, 17595),
         16#EC#           =>  --  AAEC
          (0, 0, 17596, 17596),
         16#ED#           =>  --  AAED
          (0, 0, 17597, 17597),
         16#EE#           =>  --  AAEE
          (0, 0, 17598, 17598),
         16#EF#           =>  --  AAEF
          (0, 0, 17599, 17599),
         16#F0#           =>  --  AAF0
          (0, 0, 17600, 17600),
         16#F1#           =>  --  AAF1
          (0, 0, 17601, 17601),
         16#F2#           =>  --  AAF2
          (0, 0, 17602, 17602),
         16#F3#           =>  --  AAF3
          (0, 0, 17603, 17603),
         16#F4#           =>  --  AAF4
          (0, 0, 17604, 17604),
         16#F5#           =>  --  AAF5
          (0, 0, 17605, 17605),
         16#F6#           =>  --  AAF6
          (0, 0, 17606, 17606),
         others           =>
          (0, 0, 0, 0));

   Group_00AB : aliased constant Collation_Second_Stage
     := (16#01#           =>  --  AB01
          (0, 0, 17607, 17607),
         16#02#           =>  --  AB02
          (0, 0, 17608, 17608),
         16#03#           =>  --  AB03
          (0, 0, 17609, 17609),
         16#04#           =>  --  AB04
          (0, 0, 17610, 17610),
         16#05#           =>  --  AB05
          (0, 0, 17611, 17611),
         16#06#           =>  --  AB06
          (0, 0, 17612, 17612),
         16#09#           =>  --  AB09
          (0, 0, 17613, 17613),
         16#0A#           =>  --  AB0A
          (0, 0, 17614, 17614),
         16#0B#           =>  --  AB0B
          (0, 0, 17615, 17615),
         16#0C#           =>  --  AB0C
          (0, 0, 17616, 17616),
         16#0D#           =>  --  AB0D
          (0, 0, 17617, 17617),
         16#0E#           =>  --  AB0E
          (0, 0, 17618, 17618),
         16#11#           =>  --  AB11
          (0, 0, 17619, 17619),
         16#12#           =>  --  AB12
          (0, 0, 17620, 17620),
         16#13#           =>  --  AB13
          (0, 0, 17621, 17621),
         16#14#           =>  --  AB14
          (0, 0, 17622, 17622),
         16#15#           =>  --  AB15
          (0, 0, 17623, 17623),
         16#16#           =>  --  AB16
          (0, 0, 17624, 17624),
         16#20#           =>  --  AB20
          (0, 0, 17625, 17625),
         16#21#           =>  --  AB21
          (0, 0, 17626, 17626),
         16#22#           =>  --  AB22
          (0, 0, 17627, 17627),
         16#23#           =>  --  AB23
          (0, 0, 17628, 17628),
         16#24#           =>  --  AB24
          (0, 0, 17629, 17629),
         16#25#           =>  --  AB25
          (0, 0, 17630, 17630),
         16#26#           =>  --  AB26
          (0, 0, 17631, 17631),
         16#28#           =>  --  AB28
          (0, 0, 17632, 17632),
         16#29#           =>  --  AB29
          (0, 0, 17633, 17633),
         16#2A#           =>  --  AB2A
          (0, 0, 17634, 17634),
         16#2B#           =>  --  AB2B
          (0, 0, 17635, 17635),
         16#2C#           =>  --  AB2C
          (0, 0, 17636, 17636),
         16#2D#           =>  --  AB2D
          (0, 0, 17637, 17637),
         16#2E#           =>  --  AB2E
          (0, 0, 17638, 17638),
         16#30#           =>  --  AB30
          (0, 0, 17639, 17639),
         16#31#           =>  --  AB31
          (0, 0, 17640, 17640),
         16#32#           =>  --  AB32
          (0, 0, 17641, 17641),
         16#33#           =>  --  AB33
          (0, 0, 17642, 17642),
         16#34#           =>  --  AB34
          (0, 0, 17643, 17643),
         16#35#           =>  --  AB35
          (0, 0, 17644, 17644),
         16#36#           =>  --  AB36
          (0, 0, 17645, 17645),
         16#37#           =>  --  AB37
          (0, 0, 17646, 17646),
         16#38#           =>  --  AB38
          (0, 0, 17647, 17647),
         16#39#           =>  --  AB39
          (0, 0, 17648, 17648),
         16#3A#           =>  --  AB3A
          (0, 0, 17649, 17649),
         16#3B#           =>  --  AB3B
          (0, 0, 17650, 17650),
         16#3C#           =>  --  AB3C
          (0, 0, 17651, 17651),
         16#3D#           =>  --  AB3D
          (0, 0, 17652, 17652),
         16#3E#           =>  --  AB3E
          (0, 0, 17653, 17653),
         16#3F#           =>  --  AB3F
          (0, 0, 17654, 17654),
         16#40#           =>  --  AB40
          (0, 0, 17655, 17655),
         16#41#           =>  --  AB41
          (0, 0, 17656, 17656),
         16#42#           =>  --  AB42
          (0, 0, 17657, 17657),
         16#43#           =>  --  AB43
          (0, 0, 17658, 17658),
         16#44#           =>  --  AB44
          (0, 0, 17659, 17659),
         16#45#           =>  --  AB45
          (0, 0, 17660, 17660),
         16#46#           =>  --  AB46
          (0, 0, 17661, 17661),
         16#47#           =>  --  AB47
          (0, 0, 17662, 17662),
         16#48#           =>  --  AB48
          (0, 0, 17663, 17663),
         16#49#           =>  --  AB49
          (0, 0, 17664, 17664),
         16#4A#           =>  --  AB4A
          (0, 0, 17665, 17665),
         16#4B#           =>  --  AB4B
          (0, 0, 17666, 17666),
         16#4C#           =>  --  AB4C
          (0, 0, 17667, 17667),
         16#4D#           =>  --  AB4D
          (0, 0, 17668, 17668),
         16#4E#           =>  --  AB4E
          (0, 0, 17669, 17669),
         16#4F#           =>  --  AB4F
          (0, 0, 17670, 17670),
         16#50#           =>  --  AB50
          (0, 0, 17671, 17671),
         16#51#           =>  --  AB51
          (0, 0, 17672, 17672),
         16#52#           =>  --  AB52
          (0, 0, 17673, 17673),
         16#53#           =>  --  AB53
          (0, 0, 17674, 17674),
         16#54#           =>  --  AB54
          (0, 0, 17675, 17675),
         16#55#           =>  --  AB55
          (0, 0, 17676, 17676),
         16#56#           =>  --  AB56
          (0, 0, 17677, 17677),
         16#57#           =>  --  AB57
          (0, 0, 17678, 17678),
         16#58#           =>  --  AB58
          (0, 0, 17679, 17679),
         16#59#           =>  --  AB59
          (0, 0, 17680, 17680),
         16#5A#           =>  --  AB5A
          (0, 0, 17681, 17681),
         16#5B#           =>  --  AB5B
          (0, 0, 17682, 17682),
         16#5C#           =>  --  AB5C
          (0, 0, 17683, 17683),
         16#5D#           =>  --  AB5D
          (0, 0, 17684, 17684),
         16#5E#           =>  --  AB5E
          (0, 0, 17685, 17685),
         16#5F#           =>  --  AB5F
          (0, 0, 17686, 17686),
         16#64#           =>  --  AB64
          (0, 0, 17687, 17687),
         16#65#           =>  --  AB65
          (0, 0, 17688, 17688),
         16#C0#           =>  --  ABC0
          (0, 0, 17689, 17689),
         16#C1#           =>  --  ABC1
          (0, 0, 17690, 17690),
         16#C2#           =>  --  ABC2
          (0, 0, 17691, 17691),
         16#C3#           =>  --  ABC3
          (0, 0, 17692, 17692),
         16#C4#           =>  --  ABC4
          (0, 0, 17693, 17693),
         16#C5#           =>  --  ABC5
          (0, 0, 17694, 17694),
         16#C6#           =>  --  ABC6
          (0, 0, 17695, 17695),
         16#C7#           =>  --  ABC7
          (0, 0, 17696, 17696),
         16#C8#           =>  --  ABC8
          (0, 0, 17697, 17697),
         16#C9#           =>  --  ABC9
          (0, 0, 17698, 17698),
         16#CA#           =>  --  ABCA
          (0, 0, 17699, 17699),
         16#CB#           =>  --  ABCB
          (0, 0, 17700, 17700),
         16#CC#           =>  --  ABCC
          (0, 0, 17701, 17701),
         16#CD#           =>  --  ABCD
          (0, 0, 17702, 17702),
         16#CE#           =>  --  ABCE
          (0, 0, 17703, 17703),
         16#CF#           =>  --  ABCF
          (0, 0, 17704, 17704),
         16#D0#           =>  --  ABD0
          (0, 0, 17705, 17705),
         16#D1#           =>  --  ABD1
          (0, 0, 17706, 17706),
         16#D2#           =>  --  ABD2
          (0, 0, 17707, 17707),
         16#D3#           =>  --  ABD3
          (0, 0, 17708, 17708),
         16#D4#           =>  --  ABD4
          (0, 0, 17709, 17709),
         16#D5#           =>  --  ABD5
          (0, 0, 17710, 17710),
         16#D6#           =>  --  ABD6
          (0, 0, 17711, 17711),
         16#D7#           =>  --  ABD7
          (0, 0, 17712, 17712),
         16#D8#           =>  --  ABD8
          (0, 0, 17713, 17713),
         16#D9#           =>  --  ABD9
          (0, 0, 17714, 17714),
         16#DA#           =>  --  ABDA
          (0, 0, 17715, 17715),
         16#DB#           =>  --  ABDB
          (0, 0, 17716, 17716),
         16#DC#           =>  --  ABDC
          (0, 0, 17717, 17717),
         16#DD#           =>  --  ABDD
          (0, 0, 17718, 17718),
         16#DE#           =>  --  ABDE
          (0, 0, 17719, 17719),
         16#DF#           =>  --  ABDF
          (0, 0, 17720, 17720),
         16#E0#           =>  --  ABE0
          (0, 0, 17721, 17721),
         16#E1#           =>  --  ABE1
          (0, 0, 17722, 17722),
         16#E2#           =>  --  ABE2
          (0, 0, 17723, 17723),
         16#E3#           =>  --  ABE3
          (0, 0, 17724, 17724),
         16#E4#           =>  --  ABE4
          (0, 0, 17725, 17725),
         16#E5#           =>  --  ABE5
          (0, 0, 17726, 17726),
         16#E6#           =>  --  ABE6
          (0, 0, 17727, 17727),
         16#E7#           =>  --  ABE7
          (0, 0, 17728, 17728),
         16#E8#           =>  --  ABE8
          (0, 0, 17729, 17729),
         16#E9#           =>  --  ABE9
          (0, 0, 17730, 17730),
         16#EA#           =>  --  ABEA
          (0, 0, 17731, 17731),
         16#EB#           =>  --  ABEB
          (0, 0, 17732, 17732),
         16#EC#           =>  --  ABEC
          (0, 0, 17733, 17733),
         16#ED#           =>  --  ABED
          (0, 0, 17734, 17734),
         16#F0#           =>  --  ABF0
          (0, 0, 23, 23),
         16#F1#           =>  --  ABF1
          (0, 0, 24, 24),
         16#F2#           =>  --  ABF2
          (0, 0, 25, 25),
         16#F3#           =>  --  ABF3
          (0, 0, 26, 26),
         16#F4#           =>  --  ABF4
          (0, 0, 27, 27),
         16#F5#           =>  --  ABF5
          (0, 0, 28, 28),
         16#F6#           =>  --  ABF6
          (0, 0, 29, 29),
         16#F7#           =>  --  ABF7
          (0, 0, 30, 30),
         16#F8#           =>  --  ABF8
          (0, 0, 31, 31),
         16#F9#           =>  --  ABF9
          (0, 0, 32, 32),
         others           =>
          (0, 0, 0, 0));

   Group_00D7 : aliased constant Collation_Second_Stage
     := (16#B0#           =>  --  D7B0
          (0, 0, 17735, 17735),
         16#B1#           =>  --  D7B1
          (0, 0, 17736, 17736),
         16#B2#           =>  --  D7B2
          (0, 0, 17737, 17737),
         16#B3#           =>  --  D7B3
          (0, 0, 17738, 17738),
         16#B4#           =>  --  D7B4
          (0, 0, 17739, 17739),
         16#B5#           =>  --  D7B5
          (0, 0, 17740, 17740),
         16#B6#           =>  --  D7B6
          (0, 0, 17741, 17741),
         16#B7#           =>  --  D7B7
          (0, 0, 17742, 17742),
         16#B8#           =>  --  D7B8
          (0, 0, 17743, 17743),
         16#B9#           =>  --  D7B9
          (0, 0, 17744, 17744),
         16#BA#           =>  --  D7BA
          (0, 0, 17745, 17745),
         16#BB#           =>  --  D7BB
          (0, 0, 17746, 17746),
         16#BC#           =>  --  D7BC
          (0, 0, 17747, 17747),
         16#BD#           =>  --  D7BD
          (0, 0, 17748, 17748),
         16#BE#           =>  --  D7BE
          (0, 0, 17749, 17749),
         16#BF#           =>  --  D7BF
          (0, 0, 17750, 17750),
         16#C0#           =>  --  D7C0
          (0, 0, 17751, 17751),
         16#C1#           =>  --  D7C1
          (0, 0, 17752, 17752),
         16#C2#           =>  --  D7C2
          (0, 0, 17753, 17753),
         16#C3#           =>  --  D7C3
          (0, 0, 17754, 17754),
         16#C4#           =>  --  D7C4
          (0, 0, 17755, 17755),
         16#C5#           =>  --  D7C5
          (0, 0, 17756, 17756),
         16#C6#           =>  --  D7C6
          (0, 0, 17757, 17757),
         16#CB#           =>  --  D7CB
          (0, 0, 17758, 17758),
         16#CC#           =>  --  D7CC
          (0, 0, 17759, 17759),
         16#CD#           =>  --  D7CD
          (0, 0, 17760, 17760),
         16#CE#           =>  --  D7CE
          (0, 0, 17761, 17761),
         16#CF#           =>  --  D7CF
          (0, 0, 17762, 17762),
         16#D0#           =>  --  D7D0
          (0, 0, 17763, 17763),
         16#D1#           =>  --  D7D1
          (0, 0, 17764, 17764),
         16#D2#           =>  --  D7D2
          (0, 0, 17765, 17765),
         16#D3#           =>  --  D7D3
          (0, 0, 17766, 17766),
         16#D4#           =>  --  D7D4
          (0, 0, 17767, 17767),
         16#D5#           =>  --  D7D5
          (0, 0, 17768, 17768),
         16#D6#           =>  --  D7D6
          (0, 0, 17769, 17769),
         16#D7#           =>  --  D7D7
          (0, 0, 17770, 17770),
         16#D8#           =>  --  D7D8
          (0, 0, 17771, 17771),
         16#D9#           =>  --  D7D9
          (0, 0, 17772, 17772),
         16#DA#           =>  --  D7DA
          (0, 0, 17773, 17773),
         16#DB#           =>  --  D7DB
          (0, 0, 17774, 17774),
         16#DC#           =>  --  D7DC
          (0, 0, 17775, 17775),
         16#DD#           =>  --  D7DD
          (0, 0, 17776, 17776),
         16#DE#           =>  --  D7DE
          (0, 0, 17777, 17777),
         16#DF#           =>  --  D7DF
          (0, 0, 17778, 17778),
         16#E0#           =>  --  D7E0
          (0, 0, 17779, 17779),
         16#E1#           =>  --  D7E1
          (0, 0, 17780, 17780),
         16#E2#           =>  --  D7E2
          (0, 0, 17781, 17781),
         16#E3#           =>  --  D7E3
          (0, 0, 17782, 17782),
         16#E4#           =>  --  D7E4
          (0, 0, 17783, 17783),
         16#E5#           =>  --  D7E5
          (0, 0, 17784, 17784),
         16#E6#           =>  --  D7E6
          (0, 0, 17785, 17785),
         16#E7#           =>  --  D7E7
          (0, 0, 17786, 17786),
         16#E8#           =>  --  D7E8
          (0, 0, 17787, 17787),
         16#E9#           =>  --  D7E9
          (0, 0, 17788, 17788),
         16#EA#           =>  --  D7EA
          (0, 0, 17789, 17789),
         16#EB#           =>  --  D7EB
          (0, 0, 17790, 17790),
         16#EC#           =>  --  D7EC
          (0, 0, 17791, 17791),
         16#ED#           =>  --  D7ED
          (0, 0, 17792, 17792),
         16#EE#           =>  --  D7EE
          (0, 0, 17793, 17793),
         16#EF#           =>  --  D7EF
          (0, 0, 17794, 17794),
         16#F0#           =>  --  D7F0
          (0, 0, 17795, 17795),
         16#F1#           =>  --  D7F1
          (0, 0, 17796, 17796),
         16#F2#           =>  --  D7F2
          (0, 0, 17797, 17797),
         16#F3#           =>  --  D7F3
          (0, 0, 17798, 17798),
         16#F4#           =>  --  D7F4
          (0, 0, 17799, 17799),
         16#F5#           =>  --  D7F5
          (0, 0, 17800, 17800),
         16#F6#           =>  --  D7F6
          (0, 0, 17801, 17801),
         16#F7#           =>  --  D7F7
          (0, 0, 17802, 17802),
         16#F8#           =>  --  D7F8
          (0, 0, 17803, 17803),
         16#F9#           =>  --  D7F9
          (0, 0, 17804, 17804),
         16#FA#           =>  --  D7FA
          (0, 0, 17805, 17805),
         16#FB#           =>  --  D7FB
          (0, 0, 17806, 17806),
         others           =>
          (0, 0, 0, 0));

   Group_00F9 : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  F900
          (0, 0, 17807, 17808),
         16#01#           =>  --  F901
          (0, 0, 17809, 17810),
         16#02#           =>  --  F902
          (0, 0, 17811, 17812),
         16#03#           =>  --  F903
          (0, 0, 17813, 17814),
         16#04#           =>  --  F904
          (0, 0, 17815, 17816),
         16#05#           =>  --  F905
          (0, 0, 17817, 17818),
         16#06#           =>  --  F906
          (0, 0, 17819, 17820),
         16#07# .. 16#08# =>  --  F907 .. F908
          (0, 0, 17821, 17822),
         16#09#           =>  --  F909
          (0, 0, 17823, 17824),
         16#0A#           =>  --  F90A
          (0, 0, 17825, 17826),
         16#0B#           =>  --  F90B
          (0, 0, 17827, 17828),
         16#0C#           =>  --  F90C
          (0, 0, 17829, 17830),
         16#0D#           =>  --  F90D
          (0, 0, 17831, 17832),
         16#0E#           =>  --  F90E
          (0, 0, 17833, 17834),
         16#0F#           =>  --  F90F
          (0, 0, 17835, 17836),
         16#10#           =>  --  F910
          (0, 0, 17837, 17838),
         16#11#           =>  --  F911
          (0, 0, 17839, 17840),
         16#12#           =>  --  F912
          (0, 0, 17841, 17842),
         16#13#           =>  --  F913
          (0, 0, 17843, 17844),
         16#15#           =>  --  F915
          (0, 0, 17847, 17848),
         16#16#           =>  --  F916
          (0, 0, 17849, 17850),
         16#17#           =>  --  F917
          (0, 0, 17851, 17852),
         16#18#           =>  --  F918
          (0, 0, 17853, 17854),
         16#19#           =>  --  F919
          (0, 0, 17855, 17856),
         16#1A#           =>  --  F91A
          (0, 0, 17857, 17858),
         16#1B#           =>  --  F91B
          (0, 0, 17859, 17860),
         16#1C#           =>  --  F91C
          (0, 0, 17861, 17862),
         16#1D#           =>  --  F91D
          (0, 0, 17863, 17864),
         16#1E#           =>  --  F91E
          (0, 0, 17865, 17866),
         16#1F#           =>  --  F91F
          (0, 0, 17867, 17868),
         16#20#           =>  --  F920
          (0, 0, 17869, 17870),
         16#21#           =>  --  F921
          (0, 0, 17871, 17872),
         16#22#           =>  --  F922
          (0, 0, 17873, 17874),
         16#23#           =>  --  F923
          (0, 0, 17875, 17876),
         16#24#           =>  --  F924
          (0, 0, 17877, 17878),
         16#25#           =>  --  F925
          (0, 0, 17879, 17880),
         16#26#           =>  --  F926
          (0, 0, 17881, 17882),
         16#27#           =>  --  F927
          (0, 0, 17883, 17884),
         16#28#           =>  --  F928
          (0, 0, 17885, 17886),
         16#29#           =>  --  F929
          (0, 0, 17887, 17888),
         16#2A#           =>  --  F92A
          (0, 0, 17889, 17890),
         16#2B#           =>  --  F92B
          (0, 0, 17891, 17892),
         16#2C#           =>  --  F92C
          (0, 0, 17893, 17894),
         16#2D#           =>  --  F92D
          (0, 0, 17895, 17896),
         16#2E#           =>  --  F92E
          (0, 0, 17897, 17898),
         16#2F#           =>  --  F92F
          (0, 0, 17899, 17900),
         16#30#           =>  --  F930
          (0, 0, 17901, 17902),
         16#31#           =>  --  F931
          (0, 0, 17903, 17904),
         16#32#           =>  --  F932
          (0, 0, 17905, 17906),
         16#33#           =>  --  F933
          (0, 0, 17907, 17908),
         16#34#           =>  --  F934
          (0, 0, 17909, 17910),
         16#35#           =>  --  F935
          (0, 0, 17911, 17912),
         16#36#           =>  --  F936
          (0, 0, 17913, 17914),
         16#37#           =>  --  F937
          (0, 0, 17915, 17916),
         16#38#           =>  --  F938
          (0, 0, 17917, 17918),
         16#39#           =>  --  F939
          (0, 0, 17919, 17920),
         16#3A#           =>  --  F93A
          (0, 0, 17921, 17922),
         16#3B#           =>  --  F93B
          (0, 0, 17923, 17924),
         16#3C#           =>  --  F93C
          (0, 0, 17925, 17926),
         16#3D#           =>  --  F93D
          (0, 0, 17927, 17928),
         16#3E#           =>  --  F93E
          (0, 0, 17929, 17930),
         16#3F#           =>  --  F93F
          (0, 0, 17931, 17932),
         16#40#           =>  --  F940
          (0, 0, 17933, 17934),
         16#41#           =>  --  F941
          (0, 0, 17935, 17936),
         16#42#           =>  --  F942
          (0, 0, 17937, 17938),
         16#43#           =>  --  F943
          (0, 0, 17939, 17940),
         16#44#           =>  --  F944
          (0, 0, 17941, 17942),
         16#45#           =>  --  F945
          (0, 0, 17943, 17944),
         16#46#           =>  --  F946
          (0, 0, 17945, 17946),
         16#47#           =>  --  F947
          (0, 0, 17947, 17948),
         16#48#           =>  --  F948
          (0, 0, 17949, 17950),
         16#49#           =>  --  F949
          (0, 0, 17951, 17952),
         16#4A#           =>  --  F94A
          (0, 0, 17953, 17954),
         16#4B#           =>  --  F94B
          (0, 0, 17955, 17956),
         16#4C#           =>  --  F94C
          (0, 0, 17957, 17958),
         16#4D#           =>  --  F94D
          (0, 0, 17959, 17960),
         16#4E#           =>  --  F94E
          (0, 0, 17961, 17962),
         16#4F#           =>  --  F94F
          (0, 0, 17963, 17964),
         16#50#           =>  --  F950
          (0, 0, 17965, 17966),
         16#51#           =>  --  F951
          (0, 0, 17967, 17968),
         16#52#           =>  --  F952
          (0, 0, 17969, 17970),
         16#53#           =>  --  F953
          (0, 0, 17971, 17972),
         16#54#           =>  --  F954
          (0, 0, 17973, 17974),
         16#55#           =>  --  F955
          (0, 0, 17975, 17976),
         16#56#           =>  --  F956
          (0, 0, 17977, 17978),
         16#57#           =>  --  F957
          (0, 0, 17979, 17980),
         16#58#           =>  --  F958
          (0, 0, 17981, 17982),
         16#59#           =>  --  F959
          (0, 0, 17983, 17984),
         16#5A#           =>  --  F95A
          (0, 0, 17985, 17986),
         16#5B#           =>  --  F95B
          (0, 0, 17987, 17988),
         16#5D#           =>  --  F95D
          (0, 0, 17989, 17990),
         16#5E#           =>  --  F95E
          (0, 0, 17991, 17992),
         16#5F#           =>  --  F95F
          (0, 0, 17993, 17994),
         16#60#           =>  --  F960
          (0, 0, 17995, 17996),
         16#61#           =>  --  F961
          (0, 0, 17997, 17998),
         16#62#           =>  --  F962
          (0, 0, 17999, 18000),
         16#63#           =>  --  F963
          (0, 0, 18001, 18002),
         16#64#           =>  --  F964
          (0, 0, 18003, 18004),
         16#65#           =>  --  F965
          (0, 0, 18005, 18006),
         16#66#           =>  --  F966
          (0, 0, 18007, 18008),
         16#67#           =>  --  F967
          (0, 0, 18009, 18010),
         16#68#           =>  --  F968
          (0, 0, 18011, 18012),
         16#69#           =>  --  F969
          (0, 0, 18013, 18014),
         16#6A#           =>  --  F96A
          (0, 0, 18015, 18016),
         16#6B#           =>  --  F96B
          (0, 0, 18017, 18018),
         16#6C#           =>  --  F96C
          (0, 0, 18019, 18020),
         16#6D#           =>  --  F96D
          (0, 0, 18021, 18022),
         16#6E#           =>  --  F96E
          (0, 0, 18023, 18024),
         16#6F#           =>  --  F96F
          (0, 0, 18025, 18026),
         16#70#           =>  --  F970
          (0, 0, 18027, 18028),
         16#71#           =>  --  F971
          (0, 0, 18029, 18030),
         16#72#           =>  --  F972
          (0, 0, 18031, 18032),
         16#73#           =>  --  F973
          (0, 0, 18033, 18034),
         16#74#           =>  --  F974
          (0, 0, 18035, 18036),
         16#75#           =>  --  F975
          (0, 0, 18037, 18038),
         16#76#           =>  --  F976
          (0, 0, 18039, 18040),
         16#77#           =>  --  F977
          (0, 0, 18041, 18042),
         16#78#           =>  --  F978
          (0, 0, 18043, 18044),
         16#79#           =>  --  F979
          (0, 0, 18045, 18046),
         16#7A#           =>  --  F97A
          (0, 0, 18047, 18048),
         16#7B#           =>  --  F97B
          (0, 0, 18049, 18050),
         16#7C#           =>  --  F97C
          (0, 0, 18051, 18052),
         16#7D#           =>  --  F97D
          (0, 0, 18053, 18054),
         16#7E#           =>  --  F97E
          (0, 0, 18055, 18056),
         16#7F#           =>  --  F97F
          (0, 0, 18057, 18058),
         16#80#           =>  --  F980
          (0, 0, 18059, 18060),
         16#81#           =>  --  F981
          (0, 0, 18061, 18062),
         16#82#           =>  --  F982
          (0, 0, 18063, 18064),
         16#83#           =>  --  F983
          (0, 0, 18065, 18066),
         16#84#           =>  --  F984
          (0, 0, 18067, 18068),
         16#85#           =>  --  F985
          (0, 0, 18069, 18070),
         16#86#           =>  --  F986
          (0, 0, 18071, 18072),
         16#87#           =>  --  F987
          (0, 0, 18073, 18074),
         16#88#           =>  --  F988
          (0, 0, 18075, 18076),
         16#89#           =>  --  F989
          (0, 0, 18077, 18078),
         16#8A#           =>  --  F98A
          (0, 0, 18079, 18080),
         16#8B#           =>  --  F98B
          (0, 0, 18081, 18082),
         16#8C#           =>  --  F98C
          (0, 0, 18083, 18084),
         16#8D#           =>  --  F98D
          (0, 0, 18085, 18086),
         16#8E#           =>  --  F98E
          (0, 0, 18087, 18088),
         16#8F#           =>  --  F98F
          (0, 0, 18089, 18090),
         16#90#           =>  --  F990
          (0, 0, 18091, 18092),
         16#91#           =>  --  F991
          (0, 0, 18093, 18094),
         16#92#           =>  --  F992
          (0, 0, 18095, 18096),
         16#93#           =>  --  F993
          (0, 0, 18097, 18098),
         16#94#           =>  --  F994
          (0, 0, 18099, 18100),
         16#95#           =>  --  F995
          (0, 0, 18101, 18102),
         16#96#           =>  --  F996
          (0, 0, 18103, 18104),
         16#97#           =>  --  F997
          (0, 0, 18105, 18106),
         16#98#           =>  --  F998
          (0, 0, 18107, 18108),
         16#99#           =>  --  F999
          (0, 0, 18109, 18110),
         16#9A#           =>  --  F99A
          (0, 0, 18111, 18112),
         16#9B#           =>  --  F99B
          (0, 0, 18113, 18114),
         16#9C#           =>  --  F99C
          (0, 0, 18115, 18116),
         16#9D#           =>  --  F99D
          (0, 0, 18117, 18118),
         16#9E#           =>  --  F99E
          (0, 0, 18119, 18120),
         16#9F#           =>  --  F99F
          (0, 0, 18121, 18122),
         16#A0#           =>  --  F9A0
          (0, 0, 18123, 18124),
         16#A1#           =>  --  F9A1
          (0, 0, 18025, 18026),
         16#A2#           =>  --  F9A2
          (0, 0, 18125, 18126),
         16#A3#           =>  --  F9A3
          (0, 0, 18127, 18128),
         16#A4#           =>  --  F9A4
          (0, 0, 18129, 18130),
         16#A5#           =>  --  F9A5
          (0, 0, 18131, 18132),
         16#A6#           =>  --  F9A6
          (0, 0, 18133, 18134),
         16#A7#           =>  --  F9A7
          (0, 0, 18135, 18136),
         16#A8#           =>  --  F9A8
          (0, 0, 18137, 18138),
         16#A9#           =>  --  F9A9
          (0, 0, 18139, 18140),
         16#AA#           =>  --  F9AA
          (0, 0, 17993, 17994),
         16#AB#           =>  --  F9AB
          (0, 0, 18141, 18142),
         16#AC#           =>  --  F9AC
          (0, 0, 18143, 18144),
         16#AD#           =>  --  F9AD
          (0, 0, 18145, 18146),
         16#AE#           =>  --  F9AE
          (0, 0, 18147, 18148),
         16#AF#           =>  --  F9AF
          (0, 0, 18149, 18150),
         16#B0#           =>  --  F9B0
          (0, 0, 18151, 18152),
         16#B1#           =>  --  F9B1
          (0, 0, 18153, 18154),
         16#B2#           =>  --  F9B2
          (0, 0, 18155, 18156),
         16#B3#           =>  --  F9B3
          (0, 0, 18157, 18158),
         16#B4#           =>  --  F9B4
          (0, 0, 18159, 18160),
         16#B5#           =>  --  F9B5
          (0, 0, 18161, 18162),
         16#B6#           =>  --  F9B6
          (0, 0, 18163, 18164),
         16#B7#           =>  --  F9B7
          (0, 0, 18165, 18166),
         16#B8#           =>  --  F9B8
          (0, 0, 18167, 18168),
         16#B9#           =>  --  F9B9
          (0, 0, 18169, 18170),
         16#BA#           =>  --  F9BA
          (0, 0, 18171, 18172),
         16#BB#           =>  --  F9BB
          (0, 0, 18173, 18174),
         16#BC#           =>  --  F9BC
          (0, 0, 18175, 18176),
         16#BD#           =>  --  F9BD
          (0, 0, 18177, 18178),
         16#BE#           =>  --  F9BE
          (0, 0, 18179, 18180),
         16#C0#           =>  --  F9C0
          (0, 0, 18181, 18182),
         16#C1#           =>  --  F9C1
          (0, 0, 18183, 18184),
         16#C2#           =>  --  F9C2
          (0, 0, 18185, 18186),
         16#C3#           =>  --  F9C3
          (0, 0, 18187, 18188),
         16#C4#           =>  --  F9C4
          (0, 0, 18189, 18190),
         16#C5#           =>  --  F9C5
          (0, 0, 18191, 18192),
         16#C6#           =>  --  F9C6
          (0, 0, 18193, 18194),
         16#C7#           =>  --  F9C7
          (0, 0, 18195, 18196),
         16#C8#           =>  --  F9C8
          (0, 0, 18197, 18198),
         16#C9#           =>  --  F9C9
          (0, 0, 18199, 18200),
         16#CA#           =>  --  F9CA
          (0, 0, 18201, 18202),
         16#CB#           =>  --  F9CB
          (0, 0, 18203, 18204),
         16#CC#           =>  --  F9CC
          (0, 0, 18205, 18206),
         16#CD#           =>  --  F9CD
          (0, 0, 18207, 18208),
         16#CE#           =>  --  F9CE
          (0, 0, 18209, 18210),
         16#CF#           =>  --  F9CF
          (0, 0, 18211, 18212),
         16#D0#           =>  --  F9D0
          (0, 0, 18213, 18214),
         16#D1#           =>  --  F9D1
          (0, 0, 18215, 18216),
         16#D2#           =>  --  F9D2
          (0, 0, 18217, 18218),
         16#D3#           =>  --  F9D3
          (0, 0, 18219, 18220),
         16#D4#           =>  --  F9D4
          (0, 0, 18221, 18222),
         16#D5#           =>  --  F9D5
          (0, 0, 18223, 18224),
         16#D6#           =>  --  F9D6
          (0, 0, 18225, 18226),
         16#D7#           =>  --  F9D7
          (0, 0, 18227, 18228),
         16#D8#           =>  --  F9D8
          (0, 0, 18229, 18230),
         16#D9#           =>  --  F9D9
          (0, 0, 18231, 18232),
         16#DA#           =>  --  F9DA
          (0, 0, 18233, 18234),
         16#DB#           =>  --  F9DB
          (0, 0, 17997, 17998),
         16#DC#           =>  --  F9DC
          (0, 0, 18235, 18236),
         16#DD#           =>  --  F9DD
          (0, 0, 18237, 18238),
         16#DE#           =>  --  F9DE
          (0, 0, 18239, 18240),
         16#DF#           =>  --  F9DF
          (0, 0, 18241, 18242),
         16#E0#           =>  --  F9E0
          (0, 0, 18243, 18244),
         16#E1#           =>  --  F9E1
          (0, 0, 18245, 18246),
         16#E2#           =>  --  F9E2
          (0, 0, 18247, 18248),
         16#E3#           =>  --  F9E3
          (0, 0, 18249, 18250),
         16#E4#           =>  --  F9E4
          (0, 0, 18251, 18252),
         16#E5#           =>  --  F9E5
          (0, 0, 18253, 18254),
         16#E6#           =>  --  F9E6
          (0, 0, 18255, 18256),
         16#E7#           =>  --  F9E7
          (0, 0, 18257, 18258),
         16#E8#           =>  --  F9E8
          (0, 0, 18259, 18260),
         16#E9#           =>  --  F9E9
          (0, 0, 18261, 18262),
         16#EA#           =>  --  F9EA
          (0, 0, 18263, 18264),
         16#EB#           =>  --  F9EB
          (0, 0, 18265, 18266),
         16#EC#           =>  --  F9EC
          (0, 0, 18267, 18268),
         16#ED#           =>  --  F9ED
          (0, 0, 18269, 18270),
         16#EE#           =>  --  F9EE
          (0, 0, 18271, 18272),
         16#EF#           =>  --  F9EF
          (0, 0, 18273, 18274),
         16#F0#           =>  --  F9F0
          (0, 0, 18275, 18276),
         16#F1#           =>  --  F9F1
          (0, 0, 18277, 18278),
         16#F2#           =>  --  F9F2
          (0, 0, 18279, 18280),
         16#F3#           =>  --  F9F3
          (0, 0, 18281, 18282),
         16#F4#           =>  --  F9F4
          (0, 0, 18283, 18284),
         16#F5#           =>  --  F9F5
          (0, 0, 18285, 18286),
         16#F6#           =>  --  F9F6
          (0, 0, 18287, 18288),
         16#F7#           =>  --  F9F7
          (0, 0, 18289, 18290),
         16#F8#           =>  --  F9F8
          (0, 0, 18291, 18292),
         16#F9#           =>  --  F9F9
          (0, 0, 18293, 18294),
         16#FA#           =>  --  F9FA
          (0, 0, 18295, 18296),
         16#FB#           =>  --  F9FB
          (0, 0, 18297, 18298),
         16#FC#           =>  --  F9FC
          (0, 0, 18299, 18300),
         16#FD#           =>  --  F9FD
          (0, 0, 18301, 18302),
         16#FE#           =>  --  F9FE
          (0, 0, 18303, 18304),
         16#FF#           =>  --  F9FF
          (0, 0, 18305, 18306),
         others           =>
          (0, 0, 17845, 17846));

   Group_00FA : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  FA00
          (0, 0, 18307, 18308),
         16#01#           =>  --  FA01
          (0, 0, 18309, 18310),
         16#02#           =>  --  FA02
          (0, 0, 18311, 18312),
         16#03#           =>  --  FA03
          (0, 0, 18313, 18314),
         16#04#           =>  --  FA04
          (0, 0, 18315, 18316),
         16#05#           =>  --  FA05
          (0, 0, 18317, 18318),
         16#06#           =>  --  FA06
          (0, 0, 18319, 18320),
         16#07#           =>  --  FA07
          (0, 0, 18321, 18322),
         16#08#           =>  --  FA08
          (0, 0, 18323, 18324),
         16#09#           =>  --  FA09
          (0, 0, 18325, 18326),
         16#0A#           =>  --  FA0A
          (0, 0, 18327, 18328),
         16#0B#           =>  --  FA0B
          (0, 0, 18329, 18330),
         16#0C#           =>  --  FA0C
          (0, 0, 18331, 18332),
         16#0D#           =>  --  FA0D
          (0, 0, 18333, 18334),
         16#0E#           =>  --  FA0E
          (0, 0, 18335, 18336),
         16#0F#           =>  --  FA0F
          (0, 0, 18337, 18338),
         16#10#           =>  --  FA10
          (0, 0, 18339, 18340),
         16#11#           =>  --  FA11
          (0, 0, 18341, 18342),
         16#12#           =>  --  FA12
          (0, 0, 18343, 18344),
         16#13#           =>  --  FA13
          (0, 0, 18345, 18346),
         16#14#           =>  --  FA14
          (0, 0, 18347, 18348),
         16#15#           =>  --  FA15
          (0, 0, 18349, 18350),
         16#16#           =>  --  FA16
          (0, 0, 18351, 18352),
         16#17#           =>  --  FA17
          (0, 0, 18353, 18354),
         16#18#           =>  --  FA18
          (0, 0, 18355, 18356),
         16#19#           =>  --  FA19
          (0, 0, 18357, 18358),
         16#1A#           =>  --  FA1A
          (0, 0, 18359, 18360),
         16#1B#           =>  --  FA1B
          (0, 0, 18361, 18362),
         16#1C#           =>  --  FA1C
          (0, 0, 18363, 18364),
         16#1D#           =>  --  FA1D
          (0, 0, 18365, 18366),
         16#1E#           =>  --  FA1E
          (0, 0, 18367, 18368),
         16#1F#           =>  --  FA1F
          (0, 0, 18369, 18370),
         16#20#           =>  --  FA20
          (0, 0, 18371, 18372),
         16#21#           =>  --  FA21
          (0, 0, 18373, 18374),
         16#22#           =>  --  FA22
          (0, 0, 18375, 18376),
         16#23#           =>  --  FA23
          (0, 0, 18377, 18378),
         16#24#           =>  --  FA24
          (0, 0, 18379, 18380),
         16#25#           =>  --  FA25
          (0, 0, 18381, 18382),
         16#26#           =>  --  FA26
          (0, 0, 18383, 18384),
         16#27#           =>  --  FA27
          (0, 0, 18385, 18386),
         16#28#           =>  --  FA28
          (0, 0, 18387, 18388),
         16#29#           =>  --  FA29
          (0, 0, 18389, 18390),
         16#2A#           =>  --  FA2A
          (0, 0, 18391, 18392),
         16#2B#           =>  --  FA2B
          (0, 0, 18393, 18394),
         16#2C#           =>  --  FA2C
          (0, 0, 18395, 18396),
         16#2D#           =>  --  FA2D
          (0, 0, 18397, 18398),
         16#2E#           =>  --  FA2E
          (0, 0, 18399, 18400),
         16#2F#           =>  --  FA2F
          (0, 0, 18401, 18402),
         16#30#           =>  --  FA30
          (0, 0, 18403, 18404),
         16#31#           =>  --  FA31
          (0, 0, 18405, 18406),
         16#32#           =>  --  FA32
          (0, 0, 18407, 18408),
         16#33#           =>  --  FA33
          (0, 0, 18409, 18410),
         16#34#           =>  --  FA34
          (0, 0, 18411, 18412),
         16#35#           =>  --  FA35
          (0, 0, 18413, 18414),
         16#36#           =>  --  FA36
          (0, 0, 18415, 18416),
         16#37#           =>  --  FA37
          (0, 0, 18417, 18418),
         16#38#           =>  --  FA38
          (0, 0, 18419, 18420),
         16#39#           =>  --  FA39
          (0, 0, 18421, 18422),
         16#3A#           =>  --  FA3A
          (0, 0, 18423, 18424),
         16#3B#           =>  --  FA3B
          (0, 0, 18425, 18426),
         16#3C#           =>  --  FA3C
          (0, 0, 18427, 18428),
         16#3D#           =>  --  FA3D
          (0, 0, 18429, 18430),
         16#3E#           =>  --  FA3E
          (0, 0, 18431, 18432),
         16#3F#           =>  --  FA3F
          (0, 0, 18433, 18434),
         16#40#           =>  --  FA40
          (0, 0, 18435, 18436),
         16#41#           =>  --  FA41
          (0, 0, 18437, 18438),
         16#42#           =>  --  FA42
          (0, 0, 18439, 18440),
         16#43#           =>  --  FA43
          (0, 0, 18441, 18442),
         16#44#           =>  --  FA44
          (0, 0, 18443, 18444),
         16#45#           =>  --  FA45
          (0, 0, 18445, 18446),
         16#46#           =>  --  FA46
          (0, 0, 18447, 18448),
         16#47#           =>  --  FA47
          (0, 0, 18449, 18450),
         16#48#           =>  --  FA48
          (0, 0, 18451, 18452),
         16#49#           =>  --  FA49
          (0, 0, 18453, 18454),
         16#4A#           =>  --  FA4A
          (0, 0, 18455, 18456),
         16#4B#           =>  --  FA4B
          (0, 0, 18457, 18458),
         16#4C#           =>  --  FA4C
          (0, 0, 18459, 18460),
         16#4D#           =>  --  FA4D
          (0, 0, 18461, 18462),
         16#4E#           =>  --  FA4E
          (0, 0, 18463, 18464),
         16#4F#           =>  --  FA4F
          (0, 0, 18465, 18466),
         16#50#           =>  --  FA50
          (0, 0, 18467, 18468),
         16#51#           =>  --  FA51
          (0, 0, 18469, 18470),
         16#52#           =>  --  FA52
          (0, 0, 18471, 18472),
         16#53#           =>  --  FA53
          (0, 0, 18473, 18474),
         16#54#           =>  --  FA54
          (0, 0, 18475, 18476),
         16#55#           =>  --  FA55
          (0, 0, 18477, 18478),
         16#56#           =>  --  FA56
          (0, 0, 18479, 18480),
         16#57#           =>  --  FA57
          (0, 0, 18103, 18104),
         16#58#           =>  --  FA58
          (0, 0, 18481, 18482),
         16#59#           =>  --  FA59
          (0, 0, 18483, 18484),
         16#5A#           =>  --  FA5A
          (0, 0, 18485, 18486),
         16#5B#           =>  --  FA5B
          (0, 0, 18487, 18488),
         16#5C#           =>  --  FA5C
          (0, 0, 18489, 18490),
         16#5D# .. 16#5E# =>  --  FA5D .. FA5E
          (0, 0, 18491, 18492),
         16#5F#           =>  --  FA5F
          (0, 0, 18493, 18494),
         16#60#           =>  --  FA60
          (0, 0, 18495, 18496),
         16#61#           =>  --  FA61
          (0, 0, 18497, 18498),
         16#62#           =>  --  FA62
          (0, 0, 18499, 18500),
         16#63#           =>  --  FA63
          (0, 0, 18501, 18502),
         16#64#           =>  --  FA64
          (0, 0, 18503, 18504),
         16#65#           =>  --  FA65
          (0, 0, 18505, 18506),
         16#66#           =>  --  FA66
          (0, 0, 18507, 18508),
         16#67#           =>  --  FA67
          (0, 0, 18381, 18382),
         16#68#           =>  --  FA68
          (0, 0, 18509, 18510),
         16#69#           =>  --  FA69
          (0, 0, 18511, 18512),
         16#6A#           =>  --  FA6A
          (0, 0, 18513, 18514),
         16#6B#           =>  --  FA6B
          (0, 0, 18515, 18516),
         16#6C#           =>  --  FA6C
          (0, 0, 18517, 18518),
         16#6D#           =>  --  FA6D
          (0, 0, 18519, 18520),
         16#70#           =>  --  FA70
          (0, 0, 18521, 18522),
         16#71#           =>  --  FA71
          (0, 0, 18523, 18524),
         16#72#           =>  --  FA72
          (0, 0, 18525, 18526),
         16#73#           =>  --  FA73
          (0, 0, 18527, 18528),
         16#74#           =>  --  FA74
          (0, 0, 18529, 18530),
         16#75#           =>  --  FA75
          (0, 0, 18531, 18532),
         16#76#           =>  --  FA76
          (0, 0, 18533, 18534),
         16#77#           =>  --  FA77
          (0, 0, 18535, 18536),
         16#78#           =>  --  FA78
          (0, 0, 18415, 18416),
         16#79#           =>  --  FA79
          (0, 0, 18537, 18538),
         16#7A#           =>  --  FA7A
          (0, 0, 18539, 18540),
         16#7B#           =>  --  FA7B
          (0, 0, 18541, 18542),
         16#7C#           =>  --  FA7C
          (0, 0, 18339, 18340),
         16#7D#           =>  --  FA7D
          (0, 0, 18543, 18544),
         16#7E#           =>  --  FA7E
          (0, 0, 18545, 18546),
         16#7F#           =>  --  FA7F
          (0, 0, 18547, 18548),
         16#80#           =>  --  FA80
          (0, 0, 18549, 18550),
         16#81#           =>  --  FA81
          (0, 0, 18551, 18552),
         16#82#           =>  --  FA82
          (0, 0, 18553, 18554),
         16#83#           =>  --  FA83
          (0, 0, 18555, 18556),
         16#84#           =>  --  FA84
          (0, 0, 18557, 18558),
         16#85#           =>  --  FA85
          (0, 0, 18559, 18560),
         16#86#           =>  --  FA86
          (0, 0, 18561, 18562),
         16#87#           =>  --  FA87
          (0, 0, 18563, 18564),
         16#88#           =>  --  FA88
          (0, 0, 18565, 18566),
         16#89#           =>  --  FA89
          (0, 0, 18433, 18434),
         16#8A#           =>  --  FA8A
          (0, 0, 18567, 18568),
         16#8B#           =>  --  FA8B
          (0, 0, 18435, 18436),
         16#8C#           =>  --  FA8C
          (0, 0, 18569, 18570),
         16#8D#           =>  --  FA8D
          (0, 0, 18571, 18572),
         16#8E#           =>  --  FA8E
          (0, 0, 18573, 18574),
         16#8F#           =>  --  FA8F
          (0, 0, 18575, 18576),
         16#90#           =>  --  FA90
          (0, 0, 18577, 18578),
         16#91#           =>  --  FA91
          (0, 0, 18343, 18344),
         16#92#           =>  --  FA92
          (0, 0, 17887, 17888),
         16#93#           =>  --  FA93
          (0, 0, 18579, 18580),
         16#94#           =>  --  FA94
          (0, 0, 18581, 18582),
         16#95#           =>  --  FA95
          (0, 0, 18583, 18584),
         16#96#           =>  --  FA96
          (0, 0, 18027, 18028),
         16#97#           =>  --  FA97
          (0, 0, 18201, 18202),
         16#98#           =>  --  FA98
          (0, 0, 18585, 18586),
         16#99#           =>  --  FA99
          (0, 0, 18587, 18588),
         16#9A#           =>  --  FA9A
          (0, 0, 18449, 18450),
         16#9B#           =>  --  FA9B
          (0, 0, 18589, 18590),
         16#9C#           =>  --  FA9C
          (0, 0, 18451, 18452),
         16#9D#           =>  --  FA9D
          (0, 0, 18591, 18592),
         16#9E#           =>  --  FA9E
          (0, 0, 18593, 18594),
         16#9F#           =>  --  FA9F
          (0, 0, 18595, 18596),
         16#A0#           =>  --  FAA0
          (0, 0, 18351, 18352),
         16#A1#           =>  --  FAA1
          (0, 0, 18597, 18598),
         16#A2#           =>  --  FAA2
          (0, 0, 18599, 18600),
         16#A3#           =>  --  FAA3
          (0, 0, 18601, 18602),
         16#A4#           =>  --  FAA4
          (0, 0, 18603, 18604),
         16#A5#           =>  --  FAA5
          (0, 0, 18605, 18606),
         16#A6#           =>  --  FAA6
          (0, 0, 18353, 18354),
         16#A7#           =>  --  FAA7
          (0, 0, 18607, 18608),
         16#A8#           =>  --  FAA8
          (0, 0, 18609, 18610),
         16#A9#           =>  --  FAA9
          (0, 0, 18611, 18612),
         16#AA#           =>  --  FAAA
          (0, 0, 18613, 18614),
         16#AB#           =>  --  FAAB
          (0, 0, 18615, 18616),
         16#AC#           =>  --  FAAC
          (0, 0, 18617, 18618),
         16#AD#           =>  --  FAAD
          (0, 0, 18479, 18480),
         16#AE#           =>  --  FAAE
          (0, 0, 18619, 18620),
         16#AF#           =>  --  FAAF
          (0, 0, 18621, 18622),
         16#B0#           =>  --  FAB0
          (0, 0, 18103, 18104),
         16#B1#           =>  --  FAB1
          (0, 0, 18623, 18624),
         16#B2#           =>  --  FAB2
          (0, 0, 18487, 18488),
         16#B3#           =>  --  FAB3
          (0, 0, 18625, 18626),
         16#B4#           =>  --  FAB4
          (0, 0, 18627, 18628),
         16#B5#           =>  --  FAB5
          (0, 0, 18629, 18630),
         16#B6#           =>  --  FAB6
          (0, 0, 18631, 18632),
         16#B7#           =>  --  FAB7
          (0, 0, 18633, 18634),
         16#B8#           =>  --  FAB8
          (0, 0, 18497, 18498),
         16#B9#           =>  --  FAB9
          (0, 0, 18635, 18636),
         16#BA#           =>  --  FABA
          (0, 0, 18375, 18376),
         16#BB#           =>  --  FABB
          (0, 0, 18637, 18638),
         16#BC#           =>  --  FABC
          (0, 0, 18499, 18500),
         16#BD#           =>  --  FABD
          (0, 0, 17989, 17990),
         16#BE#           =>  --  FABE
          (0, 0, 18639, 18640),
         16#BF#           =>  --  FABF
          (0, 0, 18501, 18502),
         16#C0#           =>  --  FAC0
          (0, 0, 18641, 18642),
         16#C1#           =>  --  FAC1
          (0, 0, 18505, 18506),
         16#C2#           =>  --  FAC2
          (0, 0, 18643, 18644),
         16#C3#           =>  --  FAC3
          (0, 0, 18645, 18646),
         16#C4#           =>  --  FAC4
          (0, 0, 18647, 18648),
         16#C5#           =>  --  FAC5
          (0, 0, 18649, 18650),
         16#C6#           =>  --  FAC6
          (0, 0, 18651, 18652),
         16#C7#           =>  --  FAC7
          (0, 0, 18509, 18510),
         16#C8#           =>  --  FAC8
          (0, 0, 18363, 18364),
         16#C9#           =>  --  FAC9
          (0, 0, 18653, 18654),
         16#CA#           =>  --  FACA
          (0, 0, 18511, 18512),
         16#CB#           =>  --  FACB
          (0, 0, 18655, 18656),
         16#CC#           =>  --  FACC
          (0, 0, 18513, 18514),
         16#CD#           =>  --  FACD
          (0, 0, 18657, 18658),
         16#CE#           =>  --  FACE
          (0, 0, 17821, 17822),
         16#CF#           =>  --  FACF
          (0, 0, 18659, 18660),
         16#D0#           =>  --  FAD0
          (0, 0, 18661, 18662),
         16#D1#           =>  --  FAD1
          (0, 0, 18663, 18664),
         16#D2#           =>  --  FAD2
          (0, 0, 18665, 18666),
         16#D3#           =>  --  FAD3
          (0, 0, 18667, 18668),
         16#D4#           =>  --  FAD4
          (0, 0, 18669, 18670),
         16#D5#           =>  --  FAD5
          (0, 0, 18671, 18672),
         16#D6#           =>  --  FAD6
          (0, 0, 18673, 18674),
         16#D7#           =>  --  FAD7
          (0, 0, 18675, 18676),
         16#D8#           =>  --  FAD8
          (0, 0, 18677, 18678),
         16#D9#           =>  --  FAD9
          (0, 0, 18679, 18680),
         others           =>
          (0, 0, 0, 0));

   Group_00FB : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  FB00
          (0, 0, 18681, 18682),
         16#01#           =>  --  FB01
          (0, 0, 18683, 18684),
         16#02#           =>  --  FB02
          (0, 0, 18685, 18686),
         16#03#           =>  --  FB03
          (0, 0, 18682, 18684),
         16#04#           =>  --  FB04
          (0, 0, 18687, 18689),
         16#05#           =>  --  FB05
          (0, 0, 18690, 18692),
         16#06#           =>  --  FB06
          (0, 0, 18693, 18694),
         16#13#           =>  --  FB13
          (0, 0, 18695, 18696),
         16#14#           =>  --  FB14
          (0, 0, 18697, 18698),
         16#15#           =>  --  FB15
          (0, 0, 18699, 18700),
         16#16#           =>  --  FB16
          (0, 0, 18701, 18702),
         16#17#           =>  --  FB17
          (0, 0, 18703, 18704),
         16#1D#           =>  --  FB1D
          (0, 0, 18705, 18706),
         16#1E#           =>  --  FB1E
          (0, 0, 18707, 18707),
         16#1F#           =>  --  FB1F
          (0, 0, 18708, 18710),
         16#20#           =>  --  FB20
          (0, 0, 18711, 18711),
         16#21#           =>  --  FB21
          (0, 0, 18712, 18712),
         16#22#           =>  --  FB22
          (0, 0, 18713, 18713),
         16#23#           =>  --  FB23
          (0, 0, 18714, 18714),
         16#24#           =>  --  FB24
          (0, 0, 18715, 18715),
         16#25#           =>  --  FB25
          (0, 0, 18716, 18716),
         16#26#           =>  --  FB26
          (0, 0, 18717, 18717),
         16#27#           =>  --  FB27
          (0, 0, 18718, 18718),
         16#28#           =>  --  FB28
          (0, 0, 18719, 18719),
         16#29#           =>  --  FB29
          (0, 0, 18720, 18720),
         16#2A#           =>  --  FB2A
          (0, 0, 18721, 18722),
         16#2B#           =>  --  FB2B
          (0, 0, 18723, 18724),
         16#2C#           =>  --  FB2C
          (0, 0, 18725, 18727),
         16#2D#           =>  --  FB2D
          (0, 0, 18728, 18730),
         16#2E#           =>  --  FB2E
          (0, 0, 18731, 18732),
         16#2F#           =>  --  FB2F
          (0, 0, 18733, 18734),
         16#30#           =>  --  FB30
          (0, 0, 18735, 18736),
         16#31#           =>  --  FB31
          (0, 0, 18737, 18738),
         16#32#           =>  --  FB32
          (0, 0, 18739, 18740),
         16#33#           =>  --  FB33
          (0, 0, 18741, 18742),
         16#34#           =>  --  FB34
          (0, 0, 18743, 18744),
         16#35#           =>  --  FB35
          (0, 0, 18745, 18746),
         16#36#           =>  --  FB36
          (0, 0, 18747, 18748),
         16#38#           =>  --  FB38
          (0, 0, 18749, 18750),
         16#39#           =>  --  FB39
          (0, 0, 18751, 18752),
         16#3A#           =>  --  FB3A
          (0, 0, 18753, 18754),
         16#3B#           =>  --  FB3B
          (0, 0, 18755, 18756),
         16#3C#           =>  --  FB3C
          (0, 0, 18757, 18758),
         16#3E#           =>  --  FB3E
          (0, 0, 18759, 18760),
         16#40#           =>  --  FB40
          (0, 0, 18761, 18762),
         16#41#           =>  --  FB41
          (0, 0, 18763, 18764),
         16#43#           =>  --  FB43
          (0, 0, 18765, 18766),
         16#44#           =>  --  FB44
          (0, 0, 18767, 18768),
         16#46#           =>  --  FB46
          (0, 0, 18769, 18770),
         16#47#           =>  --  FB47
          (0, 0, 18771, 18772),
         16#48#           =>  --  FB48
          (0, 0, 18773, 18774),
         16#49#           =>  --  FB49
          (0, 0, 18725, 18726),
         16#4A#           =>  --  FB4A
          (0, 0, 18775, 18776),
         16#4B#           =>  --  FB4B
          (0, 0, 18777, 18778),
         16#4C#           =>  --  FB4C
          (0, 0, 18779, 18780),
         16#4D#           =>  --  FB4D
          (0, 0, 18781, 18782),
         16#4E#           =>  --  FB4E
          (0, 0, 18783, 18784),
         16#4F#           =>  --  FB4F
          (0, 0, 18785, 18786),
         16#50#           =>  --  FB50
          (0, 0, 18787, 18787),
         16#51#           =>  --  FB51
          (0, 0, 18788, 18788),
         16#52#           =>  --  FB52
          (0, 0, 18789, 18789),
         16#53#           =>  --  FB53
          (0, 0, 18790, 18790),
         16#54#           =>  --  FB54
          (0, 0, 18791, 18791),
         16#55#           =>  --  FB55
          (0, 0, 18792, 18792),
         16#56#           =>  --  FB56
          (0, 0, 18793, 18793),
         16#57#           =>  --  FB57
          (0, 0, 18794, 18794),
         16#58#           =>  --  FB58
          (0, 0, 18795, 18795),
         16#59#           =>  --  FB59
          (0, 0, 18796, 18796),
         16#5A#           =>  --  FB5A
          (0, 0, 18797, 18797),
         16#5B#           =>  --  FB5B
          (0, 0, 18798, 18798),
         16#5C#           =>  --  FB5C
          (0, 0, 18799, 18799),
         16#5D#           =>  --  FB5D
          (0, 0, 18800, 18800),
         16#5E#           =>  --  FB5E
          (0, 0, 18801, 18801),
         16#5F#           =>  --  FB5F
          (0, 0, 18802, 18802),
         16#60#           =>  --  FB60
          (0, 0, 18803, 18803),
         16#61#           =>  --  FB61
          (0, 0, 18804, 18804),
         16#62#           =>  --  FB62
          (0, 0, 18805, 18805),
         16#63#           =>  --  FB63
          (0, 0, 18806, 18806),
         16#64#           =>  --  FB64
          (0, 0, 18807, 18807),
         16#65#           =>  --  FB65
          (0, 0, 18808, 18808),
         16#66#           =>  --  FB66
          (0, 0, 18809, 18809),
         16#67#           =>  --  FB67
          (0, 0, 18810, 18810),
         16#68#           =>  --  FB68
          (0, 0, 18811, 18811),
         16#69#           =>  --  FB69
          (0, 0, 18812, 18812),
         16#6A#           =>  --  FB6A
          (0, 0, 18813, 18813),
         16#6B#           =>  --  FB6B
          (0, 0, 18814, 18814),
         16#6C#           =>  --  FB6C
          (0, 0, 18815, 18815),
         16#6D#           =>  --  FB6D
          (0, 0, 18816, 18816),
         16#6E#           =>  --  FB6E
          (0, 0, 18817, 18817),
         16#6F#           =>  --  FB6F
          (0, 0, 18818, 18818),
         16#70#           =>  --  FB70
          (0, 0, 18819, 18819),
         16#71#           =>  --  FB71
          (0, 0, 18820, 18820),
         16#72#           =>  --  FB72
          (0, 0, 18821, 18821),
         16#73#           =>  --  FB73
          (0, 0, 18822, 18822),
         16#74#           =>  --  FB74
          (0, 0, 18823, 18823),
         16#75#           =>  --  FB75
          (0, 0, 18824, 18824),
         16#76#           =>  --  FB76
          (0, 0, 18825, 18825),
         16#77#           =>  --  FB77
          (0, 0, 18826, 18826),
         16#78#           =>  --  FB78
          (0, 0, 18827, 18827),
         16#79#           =>  --  FB79
          (0, 0, 18828, 18828),
         16#7A#           =>  --  FB7A
          (0, 0, 18829, 18829),
         16#7B#           =>  --  FB7B
          (0, 0, 18830, 18830),
         16#7C#           =>  --  FB7C
          (0, 0, 18831, 18831),
         16#7D#           =>  --  FB7D
          (0, 0, 18832, 18832),
         16#7E#           =>  --  FB7E
          (0, 0, 18833, 18833),
         16#7F#           =>  --  FB7F
          (0, 0, 18834, 18834),
         16#80#           =>  --  FB80
          (0, 0, 18835, 18835),
         16#81#           =>  --  FB81
          (0, 0, 18836, 18836),
         16#82#           =>  --  FB82
          (0, 0, 18837, 18837),
         16#83#           =>  --  FB83
          (0, 0, 18838, 18838),
         16#84#           =>  --  FB84
          (0, 0, 18839, 18839),
         16#85#           =>  --  FB85
          (0, 0, 18840, 18840),
         16#86#           =>  --  FB86
          (0, 0, 18841, 18841),
         16#87#           =>  --  FB87
          (0, 0, 18842, 18842),
         16#88#           =>  --  FB88
          (0, 0, 18843, 18843),
         16#89#           =>  --  FB89
          (0, 0, 18844, 18844),
         16#8A#           =>  --  FB8A
          (0, 0, 18845, 18845),
         16#8B#           =>  --  FB8B
          (0, 0, 18846, 18846),
         16#8C#           =>  --  FB8C
          (0, 0, 18847, 18847),
         16#8D#           =>  --  FB8D
          (0, 0, 18848, 18848),
         16#8E#           =>  --  FB8E
          (0, 0, 18849, 18849),
         16#8F#           =>  --  FB8F
          (0, 0, 18850, 18850),
         16#90#           =>  --  FB90
          (0, 0, 18851, 18851),
         16#91#           =>  --  FB91
          (0, 0, 18852, 18852),
         16#92#           =>  --  FB92
          (0, 0, 18853, 18853),
         16#93#           =>  --  FB93
          (0, 0, 18854, 18854),
         16#94#           =>  --  FB94
          (0, 0, 18855, 18855),
         16#95#           =>  --  FB95
          (0, 0, 18856, 18856),
         16#96#           =>  --  FB96
          (0, 0, 18857, 18857),
         16#97#           =>  --  FB97
          (0, 0, 18858, 18858),
         16#98#           =>  --  FB98
          (0, 0, 18859, 18859),
         16#99#           =>  --  FB99
          (0, 0, 18860, 18860),
         16#9A#           =>  --  FB9A
          (0, 0, 18861, 18861),
         16#9B#           =>  --  FB9B
          (0, 0, 18862, 18862),
         16#9C#           =>  --  FB9C
          (0, 0, 18863, 18863),
         16#9D#           =>  --  FB9D
          (0, 0, 18864, 18864),
         16#9E#           =>  --  FB9E
          (0, 0, 18865, 18865),
         16#9F#           =>  --  FB9F
          (0, 0, 18866, 18866),
         16#A0#           =>  --  FBA0
          (0, 0, 18867, 18867),
         16#A1#           =>  --  FBA1
          (0, 0, 18868, 18868),
         16#A2#           =>  --  FBA2
          (0, 0, 18869, 18869),
         16#A3#           =>  --  FBA3
          (0, 0, 18870, 18870),
         16#A4#           =>  --  FBA4
          (0, 0, 18871, 18872),
         16#A5#           =>  --  FBA5
          (0, 0, 18873, 18874),
         16#A6#           =>  --  FBA6
          (0, 0, 18875, 18875),
         16#A7#           =>  --  FBA7
          (0, 0, 18876, 18876),
         16#A8#           =>  --  FBA8
          (0, 0, 18877, 18877),
         16#A9#           =>  --  FBA9
          (0, 0, 18878, 18878),
         16#AA#           =>  --  FBAA
          (0, 0, 18879, 18879),
         16#AB#           =>  --  FBAB
          (0, 0, 18880, 18880),
         16#AC#           =>  --  FBAC
          (0, 0, 18881, 18881),
         16#AD#           =>  --  FBAD
          (0, 0, 18882, 18882),
         16#AE#           =>  --  FBAE
          (0, 0, 18883, 18883),
         16#AF#           =>  --  FBAF
          (0, 0, 18884, 18884),
         16#B0#           =>  --  FBB0
          (0, 0, 18885, 18886),
         16#B1#           =>  --  FBB1
          (0, 0, 18887, 18888),
         16#B2#           =>  --  FBB2
          (0, 0, 18889, 18889),
         16#B3#           =>  --  FBB3
          (0, 0, 18890, 18890),
         16#B4#           =>  --  FBB4
          (0, 0, 18891, 18891),
         16#B5#           =>  --  FBB5
          (0, 0, 18892, 18892),
         16#B6#           =>  --  FBB6
          (0, 0, 18893, 18893),
         16#B7#           =>  --  FBB7
          (0, 0, 18894, 18894),
         16#B8#           =>  --  FBB8
          (0, 0, 18895, 18895),
         16#B9#           =>  --  FBB9
          (0, 0, 18896, 18896),
         16#BA#           =>  --  FBBA
          (0, 0, 18897, 18897),
         16#BB#           =>  --  FBBB
          (0, 0, 18898, 18898),
         16#BC#           =>  --  FBBC
          (0, 0, 18899, 18899),
         16#BD#           =>  --  FBBD
          (0, 0, 18900, 18900),
         16#BE#           =>  --  FBBE
          (0, 0, 18901, 18901),
         16#BF#           =>  --  FBBF
          (0, 0, 18902, 18902),
         16#C0#           =>  --  FBC0
          (0, 0, 18903, 18903),
         16#C1#           =>  --  FBC1
          (0, 0, 18904, 18904),
         16#D3#           =>  --  FBD3
          (0, 0, 18905, 18905),
         16#D4#           =>  --  FBD4
          (0, 0, 18906, 18906),
         16#D5#           =>  --  FBD5
          (0, 0, 18907, 18907),
         16#D6#           =>  --  FBD6
          (0, 0, 18908, 18908),
         16#D7#           =>  --  FBD7
          (0, 0, 18909, 18909),
         16#D8#           =>  --  FBD8
          (0, 0, 18910, 18910),
         16#D9#           =>  --  FBD9
          (0, 0, 18911, 18911),
         16#DA#           =>  --  FBDA
          (0, 0, 18912, 18912),
         16#DB#           =>  --  FBDB
          (0, 0, 18913, 18913),
         16#DC#           =>  --  FBDC
          (0, 0, 18914, 18914),
         16#DD#           =>  --  FBDD
          (0, 0, 18915, 18916),
         16#DE#           =>  --  FBDE
          (0, 0, 18917, 18917),
         16#DF#           =>  --  FBDF
          (0, 0, 18918, 18918),
         16#E0#           =>  --  FBE0
          (0, 0, 18919, 18919),
         16#E1#           =>  --  FBE1
          (0, 0, 18920, 18920),
         16#E2#           =>  --  FBE2
          (0, 0, 18921, 18921),
         16#E3#           =>  --  FBE3
          (0, 0, 18922, 18922),
         16#E4#           =>  --  FBE4
          (0, 0, 18923, 18923),
         16#E5#           =>  --  FBE5
          (0, 0, 18924, 18924),
         16#E6#           =>  --  FBE6
          (0, 0, 18925, 18925),
         16#E7#           =>  --  FBE7
          (0, 0, 18926, 18926),
         16#E8#           =>  --  FBE8
          (0, 0, 18927, 18927),
         16#E9#           =>  --  FBE9
          (0, 0, 18928, 18928),
         16#EA#           =>  --  FBEA
          (0, 0, 18929, 18930),
         16#EB#           =>  --  FBEB
          (0, 0, 18931, 18932),
         16#EC#           =>  --  FBEC
          (0, 0, 18933, 18934),
         16#ED#           =>  --  FBED
          (0, 0, 18935, 18936),
         16#EE#           =>  --  FBEE
          (0, 0, 18937, 18938),
         16#EF#           =>  --  FBEF
          (0, 0, 18939, 18940),
         16#F0#           =>  --  FBF0
          (0, 0, 18941, 18942),
         16#F1#           =>  --  FBF1
          (0, 0, 18943, 18944),
         16#F2#           =>  --  FBF2
          (0, 0, 18945, 18946),
         16#F3#           =>  --  FBF3
          (0, 0, 18947, 18948),
         16#F4#           =>  --  FBF4
          (0, 0, 18949, 18950),
         16#F5#           =>  --  FBF5
          (0, 0, 18951, 18952),
         16#F6#           =>  --  FBF6
          (0, 0, 18953, 18954),
         16#F7#           =>  --  FBF7
          (0, 0, 18955, 18956),
         16#F8#           =>  --  FBF8
          (0, 0, 18957, 18958),
         16#F9#           =>  --  FBF9
          (0, 0, 18959, 18960),
         16#FA#           =>  --  FBFA
          (0, 0, 18961, 18962),
         16#FB#           =>  --  FBFB
          (0, 0, 18963, 18964),
         16#FC#           =>  --  FBFC
          (0, 0, 18965, 18965),
         16#FD#           =>  --  FBFD
          (0, 0, 18966, 18966),
         16#FE#           =>  --  FBFE
          (0, 0, 18967, 18967),
         16#FF#           =>  --  FBFF
          (0, 0, 18968, 18968),
         others           =>
          (0, 0, 0, 0));

   Group_00FC : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  FC00
          (0, 0, 18969, 18970),
         16#01#           =>  --  FC01
          (0, 0, 18971, 18972),
         16#02#           =>  --  FC02
          (0, 0, 18973, 18974),
         16#03#           =>  --  FC03
          (0, 0, 18959, 18960),
         16#04#           =>  --  FC04
          (0, 0, 18975, 18976),
         16#05#           =>  --  FC05
          (0, 0, 18977, 18978),
         16#06#           =>  --  FC06
          (0, 0, 18979, 18980),
         16#07#           =>  --  FC07
          (0, 0, 18981, 18982),
         16#08#           =>  --  FC08
          (0, 0, 18983, 18984),
         16#09#           =>  --  FC09
          (0, 0, 18985, 18986),
         16#0A#           =>  --  FC0A
          (0, 0, 18987, 18988),
         16#0B#           =>  --  FC0B
          (0, 0, 18989, 18990),
         16#0C#           =>  --  FC0C
          (0, 0, 18991, 18992),
         16#0D#           =>  --  FC0D
          (0, 0, 18993, 18994),
         16#0E#           =>  --  FC0E
          (0, 0, 18995, 18996),
         16#0F#           =>  --  FC0F
          (0, 0, 18997, 18998),
         16#10#           =>  --  FC10
          (0, 0, 18999, 19000),
         16#11#           =>  --  FC11
          (0, 0, 19001, 19002),
         16#12#           =>  --  FC12
          (0, 0, 19003, 19004),
         16#13#           =>  --  FC13
          (0, 0, 19005, 19006),
         16#14#           =>  --  FC14
          (0, 0, 19007, 19008),
         16#15#           =>  --  FC15
          (0, 0, 19009, 19010),
         16#16#           =>  --  FC16
          (0, 0, 19011, 19012),
         16#17#           =>  --  FC17
          (0, 0, 19010, 19011),
         16#18#           =>  --  FC18
          (0, 0, 19013, 19014),
         16#19#           =>  --  FC19
          (0, 0, 19015, 19016),
         16#1A#           =>  --  FC1A
          (0, 0, 19017, 19018),
         16#1B#           =>  --  FC1B
          (0, 0, 19019, 19020),
         16#1C#           =>  --  FC1C
          (0, 0, 19021, 19022),
         16#1D#           =>  --  FC1D
          (0, 0, 19023, 19024),
         16#1E#           =>  --  FC1E
          (0, 0, 19025, 19026),
         16#1F#           =>  --  FC1F
          (0, 0, 19027, 19028),
         16#20#           =>  --  FC20
          (0, 0, 19029, 19030),
         16#21#           =>  --  FC21
          (0, 0, 19031, 19032),
         16#22#           =>  --  FC22
          (0, 0, 19033, 19034),
         16#23#           =>  --  FC23
          (0, 0, 19035, 19036),
         16#24#           =>  --  FC24
          (0, 0, 19037, 19038),
         16#25#           =>  --  FC25
          (0, 0, 19039, 19040),
         16#26#           =>  --  FC26
          (0, 0, 19041, 19042),
         16#27#           =>  --  FC27
          (0, 0, 19043, 19044),
         16#28#           =>  --  FC28
          (0, 0, 19045, 19046),
         16#29#           =>  --  FC29
          (0, 0, 19047, 19048),
         16#2A#           =>  --  FC2A
          (0, 0, 19049, 19050),
         16#2B#           =>  --  FC2B
          (0, 0, 19051, 19052),
         16#2C#           =>  --  FC2C
          (0, 0, 19053, 19054),
         16#2D#           =>  --  FC2D
          (0, 0, 19055, 19056),
         16#2E#           =>  --  FC2E
          (0, 0, 19057, 19058),
         16#2F#           =>  --  FC2F
          (0, 0, 19059, 19060),
         16#30#           =>  --  FC30
          (0, 0, 19061, 19062),
         16#31#           =>  --  FC31
          (0, 0, 19063, 19064),
         16#32#           =>  --  FC32
          (0, 0, 19065, 19066),
         16#33#           =>  --  FC33
          (0, 0, 19067, 19068),
         16#34#           =>  --  FC34
          (0, 0, 19069, 19070),
         16#35#           =>  --  FC35
          (0, 0, 19071, 19072),
         16#36#           =>  --  FC36
          (0, 0, 19073, 19074),
         16#37#           =>  --  FC37
          (0, 0, 19075, 19076),
         16#38#           =>  --  FC38
          (0, 0, 19077, 19078),
         16#39#           =>  --  FC39
          (0, 0, 19079, 19080),
         16#3A#           =>  --  FC3A
          (0, 0, 19081, 19082),
         16#3B#           =>  --  FC3B
          (0, 0, 19083, 19084),
         16#3C#           =>  --  FC3C
          (0, 0, 19085, 19086),
         16#3D#           =>  --  FC3D
          (0, 0, 19087, 19088),
         16#3E#           =>  --  FC3E
          (0, 0, 19089, 19090),
         16#3F#           =>  --  FC3F
          (0, 0, 19091, 19092),
         16#40#           =>  --  FC40
          (0, 0, 19093, 19094),
         16#41#           =>  --  FC41
          (0, 0, 19095, 19096),
         16#42#           =>  --  FC42
          (0, 0, 19097, 19098),
         16#43#           =>  --  FC43
          (0, 0, 19099, 19100),
         16#44#           =>  --  FC44
          (0, 0, 19101, 19102),
         16#45#           =>  --  FC45
          (0, 0, 19103, 19104),
         16#46#           =>  --  FC46
          (0, 0, 19012, 19013),
         16#47#           =>  --  FC47
          (0, 0, 19014, 19015),
         16#48#           =>  --  FC48
          (0, 0, 19105, 19106),
         16#49#           =>  --  FC49
          (0, 0, 19107, 19108),
         16#4A#           =>  --  FC4A
          (0, 0, 19109, 19110),
         16#4B#           =>  --  FC4B
          (0, 0, 19111, 19112),
         16#4C#           =>  --  FC4C
          (0, 0, 19113, 19114),
         16#4D#           =>  --  FC4D
          (0, 0, 19115, 19116),
         16#4E#           =>  --  FC4E
          (0, 0, 19117, 19118),
         16#4F#           =>  --  FC4F
          (0, 0, 19119, 19120),
         16#50#           =>  --  FC50
          (0, 0, 19121, 19122),
         16#51#           =>  --  FC51
          (0, 0, 19123, 19124),
         16#52#           =>  --  FC52
          (0, 0, 19125, 19126),
         16#53#           =>  --  FC53
          (0, 0, 19127, 19128),
         16#54#           =>  --  FC54
          (0, 0, 19129, 19130),
         16#55#           =>  --  FC55
          (0, 0, 19008, 19009),
         16#56#           =>  --  FC56
          (0, 0, 19131, 19132),
         16#57#           =>  --  FC57
          (0, 0, 19133, 19134),
         16#58#           =>  --  FC58
          (0, 0, 19102, 19103),
         16#59#           =>  --  FC59
          (0, 0, 19135, 19136),
         16#5A#           =>  --  FC5A
          (0, 0, 19130, 19131),
         16#5B#           =>  --  FC5B
          (0, 0, 19137, 19138),
         16#5C#           =>  --  FC5C
          (0, 0, 19139, 19140),
         16#5D#           =>  --  FC5D
          (0, 0, 19141, 19142),
         16#5E#           =>  --  FC5E
          (0, 0, 19143, 19144),
         16#5F#           =>  --  FC5F
          (0, 0, 19145, 19146),
         16#60#           =>  --  FC60
          (0, 0, 19147, 19148),
         16#61#           =>  --  FC61
          (0, 0, 19149, 19150),
         16#62#           =>  --  FC62
          (0, 0, 19151, 19152),
         16#63#           =>  --  FC63
          (0, 0, 19153, 19154),
         16#64#           =>  --  FC64
          (0, 0, 19155, 19156),
         16#65#           =>  --  FC65
          (0, 0, 19157, 19158),
         16#66#           =>  --  FC66
          (0, 0, 19159, 19160),
         16#67#           =>  --  FC67
          (0, 0, 19161, 19162),
         16#68#           =>  --  FC68
          (0, 0, 18961, 18962),
         16#69#           =>  --  FC69
          (0, 0, 19163, 19164),
         16#6A#           =>  --  FC6A
          (0, 0, 19165, 19166),
         16#6B#           =>  --  FC6B
          (0, 0, 19167, 19168),
         16#6C#           =>  --  FC6C
          (0, 0, 19169, 19170),
         16#6D#           =>  --  FC6D
          (0, 0, 19171, 19172),
         16#6E#           =>  --  FC6E
          (0, 0, 19173, 19174),
         16#6F#           =>  --  FC6F
          (0, 0, 19175, 19176),
         16#70#           =>  --  FC70
          (0, 0, 19177, 19178),
         16#71#           =>  --  FC71
          (0, 0, 19179, 19180),
         16#72#           =>  --  FC72
          (0, 0, 19181, 19182),
         16#73#           =>  --  FC73
          (0, 0, 19183, 19184),
         16#74#           =>  --  FC74
          (0, 0, 19185, 19186),
         16#75#           =>  --  FC75
          (0, 0, 19187, 19188),
         16#76#           =>  --  FC76
          (0, 0, 19189, 19190),
         16#77#           =>  --  FC77
          (0, 0, 19191, 19192),
         16#78#           =>  --  FC78
          (0, 0, 19193, 19194),
         16#79#           =>  --  FC79
          (0, 0, 19195, 19196),
         16#7A#           =>  --  FC7A
          (0, 0, 19197, 19198),
         16#7B#           =>  --  FC7B
          (0, 0, 19199, 19200),
         16#7C#           =>  --  FC7C
          (0, 0, 19201, 19202),
         16#7D#           =>  --  FC7D
          (0, 0, 19203, 19204),
         16#7E#           =>  --  FC7E
          (0, 0, 19205, 19206),
         16#7F#           =>  --  FC7F
          (0, 0, 19207, 19208),
         16#80#           =>  --  FC80
          (0, 0, 19209, 19210),
         16#81#           =>  --  FC81
          (0, 0, 19211, 19212),
         16#82#           =>  --  FC82
          (0, 0, 19213, 19214),
         16#83#           =>  --  FC83
          (0, 0, 19215, 19216),
         16#84#           =>  --  FC84
          (0, 0, 19217, 19218),
         16#85#           =>  --  FC85
          (0, 0, 19219, 19220),
         16#86#           =>  --  FC86
          (0, 0, 19221, 19222),
         16#87#           =>  --  FC87
          (0, 0, 19223, 19224),
         16#88#           =>  --  FC88
          (0, 0, 19225, 19226),
         16#89#           =>  --  FC89
          (0, 0, 19227, 19228),
         16#8A#           =>  --  FC8A
          (0, 0, 19229, 19230),
         16#8B#           =>  --  FC8B
          (0, 0, 19231, 19232),
         16#8C#           =>  --  FC8C
          (0, 0, 19233, 19234),
         16#8D#           =>  --  FC8D
          (0, 0, 19235, 19236),
         16#8E#           =>  --  FC8E
          (0, 0, 19237, 19238),
         16#8F#           =>  --  FC8F
          (0, 0, 19239, 19240),
         16#90#           =>  --  FC90
          (0, 0, 19241, 19242),
         16#91#           =>  --  FC91
          (0, 0, 19243, 19244),
         16#92#           =>  --  FC92
          (0, 0, 19245, 19246),
         16#93#           =>  --  FC93
          (0, 0, 19224, 19225),
         16#94#           =>  --  FC94
          (0, 0, 19247, 19248),
         16#95#           =>  --  FC95
          (0, 0, 19240, 19241),
         16#96#           =>  --  FC96
          (0, 0, 19249, 19250),
         16#97#           =>  --  FC97
          (0, 0, 19251, 19252),
         16#98#           =>  --  FC98
          (0, 0, 19253, 19254),
         16#99#           =>  --  FC99
          (0, 0, 19255, 19256),
         16#9A#           =>  --  FC9A
          (0, 0, 19257, 19258),
         16#9B#           =>  --  FC9B
          (0, 0, 19259, 19260),
         16#9C#           =>  --  FC9C
          (0, 0, 19261, 19262),
         16#9D#           =>  --  FC9D
          (0, 0, 19263, 19264),
         16#9E#           =>  --  FC9E
          (0, 0, 19265, 19266),
         16#9F#           =>  --  FC9F
          (0, 0, 19267, 19268),
         16#A0#           =>  --  FCA0
          (0, 0, 19269, 19270),
         16#A1#           =>  --  FCA1
          (0, 0, 19271, 19272),
         16#A2#           =>  --  FCA2
          (0, 0, 19273, 19274),
         16#A3#           =>  --  FCA3
          (0, 0, 19275, 19276),
         16#A4#           =>  --  FCA4
          (0, 0, 19277, 19278),
         16#A5#           =>  --  FCA5
          (0, 0, 19279, 19280),
         16#A6#           =>  --  FCA6
          (0, 0, 19281, 19282),
         16#A7#           =>  --  FCA7
          (0, 0, 19283, 19284),
         16#A8#           =>  --  FCA8
          (0, 0, 19285, 19286),
         16#A9#           =>  --  FCA9
          (0, 0, 19284, 19285),
         16#AA#           =>  --  FCAA
          (0, 0, 19287, 19288),
         16#AB#           =>  --  FCAB
          (0, 0, 19289, 19290),
         16#AC#           =>  --  FCAC
          (0, 0, 19291, 19292),
         16#AD#           =>  --  FCAD
          (0, 0, 19293, 19294),
         16#AE#           =>  --  FCAE
          (0, 0, 19295, 19296),
         16#AF#           =>  --  FCAF
          (0, 0, 19297, 19298),
         16#B0#           =>  --  FCB0
          (0, 0, 19299, 19300),
         16#B1#           =>  --  FCB1
          (0, 0, 19301, 19302),
         16#B2#           =>  --  FCB2
          (0, 0, 19303, 19304),
         16#B3#           =>  --  FCB3
          (0, 0, 19305, 19306),
         16#B4#           =>  --  FCB4
          (0, 0, 19307, 19308),
         16#B5#           =>  --  FCB5
          (0, 0, 19309, 19310),
         16#B6#           =>  --  FCB6
          (0, 0, 19311, 19312),
         16#B7#           =>  --  FCB7
          (0, 0, 19313, 19314),
         16#B8#           =>  --  FCB8
          (0, 0, 19315, 19316),
         16#B9#           =>  --  FCB9
          (0, 0, 19317, 19318),
         16#BA#           =>  --  FCBA
          (0, 0, 19319, 19320),
         16#BB#           =>  --  FCBB
          (0, 0, 19321, 19322),
         16#BC#           =>  --  FCBC
          (0, 0, 19323, 19324),
         16#BD#           =>  --  FCBD
          (0, 0, 19325, 19326),
         16#BE#           =>  --  FCBE
          (0, 0, 19327, 19328),
         16#BF#           =>  --  FCBF
          (0, 0, 19329, 19330),
         16#C0#           =>  --  FCC0
          (0, 0, 19331, 19332),
         16#C1#           =>  --  FCC1
          (0, 0, 19333, 19334),
         16#C2#           =>  --  FCC2
          (0, 0, 19335, 19336),
         16#C3#           =>  --  FCC3
          (0, 0, 19337, 19338),
         16#C4#           =>  --  FCC4
          (0, 0, 19339, 19340),
         16#C5#           =>  --  FCC5
          (0, 0, 19341, 19342),
         16#C6#           =>  --  FCC6
          (0, 0, 19343, 19344),
         16#C7#           =>  --  FCC7
          (0, 0, 19345, 19346),
         16#C8#           =>  --  FCC8
          (0, 0, 19347, 19348),
         16#C9#           =>  --  FCC9
          (0, 0, 19349, 19350),
         16#CA#           =>  --  FCCA
          (0, 0, 19351, 19352),
         16#CB#           =>  --  FCCB
          (0, 0, 19353, 19354),
         16#CC#           =>  --  FCCC
          (0, 0, 19355, 19356),
         16#CD#           =>  --  FCCD
          (0, 0, 19357, 19358),
         16#CE#           =>  --  FCCE
          (0, 0, 19282, 19283),
         16#CF#           =>  --  FCCF
          (0, 0, 19286, 19287),
         16#D0#           =>  --  FCD0
          (0, 0, 19288, 19289),
         16#D1#           =>  --  FCD1
          (0, 0, 19359, 19360),
         16#D2#           =>  --  FCD2
          (0, 0, 19361, 19362),
         16#D3#           =>  --  FCD3
          (0, 0, 19363, 19364),
         16#D4#           =>  --  FCD4
          (0, 0, 19365, 19366),
         16#D5#           =>  --  FCD5
          (0, 0, 19367, 19368),
         16#D6#           =>  --  FCD6
          (0, 0, 19369, 19370),
         16#D7#           =>  --  FCD7
          (0, 0, 19371, 19372),
         16#D8#           =>  --  FCD8
          (0, 0, 19358, 19359),
         16#D9#           =>  --  FCD9
          (0, 0, 19373, 19374),
         16#DA#           =>  --  FCDA
          (0, 0, 19375, 19376),
         16#DB#           =>  --  FCDB
          (0, 0, 19377, 19378),
         16#DC#           =>  --  FCDC
          (0, 0, 19379, 19380),
         16#DD#           =>  --  FCDD
          (0, 0, 19381, 19382),
         16#DE#           =>  --  FCDE
          (0, 0, 19383, 19384),
         16#DF#           =>  --  FCDF
          (0, 0, 19385, 19386),
         16#E0#           =>  --  FCE0
          (0, 0, 19387, 19388),
         16#E1#           =>  --  FCE1
          (0, 0, 19389, 19390),
         16#E2#           =>  --  FCE2
          (0, 0, 19391, 19392),
         16#E3#           =>  --  FCE3
          (0, 0, 19393, 19394),
         16#E4#           =>  --  FCE4
          (0, 0, 19395, 19396),
         16#E5#           =>  --  FCE5
          (0, 0, 19397, 19398),
         16#E6#           =>  --  FCE6
          (0, 0, 19399, 19400),
         16#E7#           =>  --  FCE7
          (0, 0, 19401, 19402),
         16#E8#           =>  --  FCE8
          (0, 0, 19403, 19404),
         16#E9#           =>  --  FCE9
          (0, 0, 19405, 19406),
         16#EA#           =>  --  FCEA
          (0, 0, 19407, 19408),
         16#EB#           =>  --  FCEB
          (0, 0, 19409, 19410),
         16#EC#           =>  --  FCEC
          (0, 0, 19411, 19412),
         16#ED#           =>  --  FCED
          (0, 0, 19413, 19414),
         16#EE#           =>  --  FCEE
          (0, 0, 19415, 19416),
         16#EF#           =>  --  FCEF
          (0, 0, 19417, 19418),
         16#F0#           =>  --  FCF0
          (0, 0, 19419, 19420),
         16#F1#           =>  --  FCF1
          (0, 0, 19421, 19422),
         16#F2#           =>  --  FCF2
          (0, 0, 19423, 19424),
         16#F3#           =>  --  FCF3
          (0, 0, 19425, 19426),
         16#F4#           =>  --  FCF4
          (0, 0, 19427, 19428),
         16#F5#           =>  --  FCF5
          (0, 0, 19429, 19430),
         16#F6#           =>  --  FCF6
          (0, 0, 19431, 19432),
         16#F7#           =>  --  FCF7
          (0, 0, 19433, 19434),
         16#F8#           =>  --  FCF8
          (0, 0, 19435, 19436),
         16#F9#           =>  --  FCF9
          (0, 0, 19437, 19438),
         16#FA#           =>  --  FCFA
          (0, 0, 19439, 19440),
         16#FB#           =>  --  FCFB
          (0, 0, 19441, 19442),
         16#FC#           =>  --  FCFC
          (0, 0, 19443, 19444),
         16#FD#           =>  --  FCFD
          (0, 0, 19445, 19446),
         16#FE#           =>  --  FCFE
          (0, 0, 19447, 19448),
         16#FF#           =>  --  FCFF
          (0, 0, 19449, 19450),
         others           =>
          (0, 0, 0, 0));

   Group_00FD : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  FD00
          (0, 0, 19132, 19133),
         16#01#           =>  --  FD01
          (0, 0, 19451, 19452),
         16#02#           =>  --  FD02
          (0, 0, 19453, 19454),
         16#03#           =>  --  FD03
          (0, 0, 19455, 19456),
         16#04#           =>  --  FD04
          (0, 0, 19134, 19135),
         16#05#           =>  --  FD05
          (0, 0, 19457, 19458),
         16#06#           =>  --  FD06
          (0, 0, 19459, 19460),
         16#07#           =>  --  FD07
          (0, 0, 19461, 19462),
         16#08#           =>  --  FD08
          (0, 0, 19463, 19464),
         16#09#           =>  --  FD09
          (0, 0, 19465, 19466),
         16#0A#           =>  --  FD0A
          (0, 0, 19467, 19468),
         16#0B#           =>  --  FD0B
          (0, 0, 19469, 19470),
         16#0C#           =>  --  FD0C
          (0, 0, 19471, 19472),
         16#0D#           =>  --  FD0D
          (0, 0, 19473, 19474),
         16#0E#           =>  --  FD0E
          (0, 0, 19475, 19476),
         16#0F#           =>  --  FD0F
          (0, 0, 19477, 19478),
         16#10#           =>  --  FD10
          (0, 0, 19479, 19480),
         16#11#           =>  --  FD11
          (0, 0, 19481, 19482),
         16#12#           =>  --  FD12
          (0, 0, 19483, 19484),
         16#13#           =>  --  FD13
          (0, 0, 19485, 19486),
         16#14#           =>  --  FD14
          (0, 0, 19487, 19488),
         16#15#           =>  --  FD15
          (0, 0, 19489, 19490),
         16#16#           =>  --  FD16
          (0, 0, 19491, 19492),
         16#17#           =>  --  FD17
          (0, 0, 19493, 19494),
         16#18#           =>  --  FD18
          (0, 0, 19495, 19496),
         16#19#           =>  --  FD19
          (0, 0, 19497, 19498),
         16#1A#           =>  --  FD1A
          (0, 0, 19499, 19500),
         16#1B#           =>  --  FD1B
          (0, 0, 19501, 19502),
         16#1C#           =>  --  FD1C
          (0, 0, 19503, 19504),
         16#1D#           =>  --  FD1D
          (0, 0, 19505, 19506),
         16#1E#           =>  --  FD1E
          (0, 0, 19507, 19508),
         16#1F#           =>  --  FD1F
          (0, 0, 19509, 19510),
         16#20#           =>  --  FD20
          (0, 0, 19511, 19512),
         16#21#           =>  --  FD21
          (0, 0, 19513, 19514),
         16#22#           =>  --  FD22
          (0, 0, 19515, 19516),
         16#23#           =>  --  FD23
          (0, 0, 19517, 19518),
         16#24#           =>  --  FD24
          (0, 0, 19519, 19520),
         16#25#           =>  --  FD25
          (0, 0, 19521, 19522),
         16#26#           =>  --  FD26
          (0, 0, 19523, 19524),
         16#27#           =>  --  FD27
          (0, 0, 19525, 19526),
         16#28#           =>  --  FD28
          (0, 0, 19527, 19528),
         16#29#           =>  --  FD29
          (0, 0, 19529, 19530),
         16#2A#           =>  --  FD2A
          (0, 0, 19531, 19532),
         16#2B#           =>  --  FD2B
          (0, 0, 19533, 19534),
         16#2C#           =>  --  FD2C
          (0, 0, 19535, 19536),
         16#2D#           =>  --  FD2D
          (0, 0, 19537, 19538),
         16#2E#           =>  --  FD2E
          (0, 0, 19539, 19540),
         16#2F#           =>  --  FD2F
          (0, 0, 19541, 19542),
         16#30#           =>  --  FD30
          (0, 0, 19543, 19544),
         16#31#           =>  --  FD31
          (0, 0, 19545, 19546),
         16#32#           =>  --  FD32
          (0, 0, 19547, 19548),
         16#33#           =>  --  FD33
          (0, 0, 19549, 19550),
         16#34#           =>  --  FD34
          (0, 0, 19551, 19552),
         16#35#           =>  --  FD35
          (0, 0, 19553, 19554),
         16#36#           =>  --  FD36
          (0, 0, 19555, 19556),
         16#37#           =>  --  FD37
          (0, 0, 19557, 19558),
         16#38#           =>  --  FD38
          (0, 0, 19559, 19560),
         16#39#           =>  --  FD39
          (0, 0, 19561, 19562),
         16#3A#           =>  --  FD3A
          (0, 0, 19563, 19564),
         16#3B#           =>  --  FD3B
          (0, 0, 19565, 19566),
         16#3C#           =>  --  FD3C
          (0, 0, 19567, 19568),
         16#3D#           =>  --  FD3D
          (0, 0, 19569, 19570),
         16#3E#           =>  --  FD3E
          (0, 0, 19571, 19571),
         16#3F#           =>  --  FD3F
          (0, 0, 19572, 19572),
         16#50#           =>  --  FD50
          (0, 0, 19573, 19575),
         16#51#           =>  --  FD51
          (0, 0, 19576, 19578),
         16#52#           =>  --  FD52
          (0, 0, 19579, 19581),
         16#53#           =>  --  FD53
          (0, 0, 19582, 19584),
         16#54#           =>  --  FD54
          (0, 0, 19585, 19587),
         16#55#           =>  --  FD55
          (0, 0, 19588, 19590),
         16#56#           =>  --  FD56
          (0, 0, 19591, 19593),
         16#57#           =>  --  FD57
          (0, 0, 19594, 19596),
         16#58#           =>  --  FD58
          (0, 0, 19597, 19599),
         16#59#           =>  --  FD59
          (0, 0, 19285, 19287),
         16#5A#           =>  --  FD5A
          (0, 0, 19600, 19602),
         16#5B#           =>  --  FD5B
          (0, 0, 19603, 19605),
         16#5C#           =>  --  FD5C
          (0, 0, 19606, 19608),
         16#5D#           =>  --  FD5D
          (0, 0, 19609, 19611),
         16#5E#           =>  --  FD5E
          (0, 0, 19612, 19614),
         16#5F#           =>  --  FD5F
          (0, 0, 19615, 19617),
         16#60#           =>  --  FD60
          (0, 0, 19618, 19620),
         16#61#           =>  --  FD61
          (0, 0, 19621, 19623),
         16#62#           =>  --  FD62
          (0, 0, 19624, 19626),
         16#63#           =>  --  FD63
          (0, 0, 19627, 19629),
         16#64#           =>  --  FD64
          (0, 0, 19630, 19632),
         16#65#           =>  --  FD65
          (0, 0, 19633, 19635),
         16#66#           =>  --  FD66
          (0, 0, 19636, 19638),
         16#67#           =>  --  FD67
          (0, 0, 19639, 19641),
         16#68#           =>  --  FD68
          (0, 0, 19642, 19644),
         16#69#           =>  --  FD69
          (0, 0, 19645, 19647),
         16#6A#           =>  --  FD6A
          (0, 0, 19648, 19650),
         16#6B#           =>  --  FD6B
          (0, 0, 19651, 19653),
         16#6C#           =>  --  FD6C
          (0, 0, 19654, 19656),
         16#6D#           =>  --  FD6D
          (0, 0, 19657, 19659),
         16#6E#           =>  --  FD6E
          (0, 0, 19660, 19662),
         16#6F#           =>  --  FD6F
          (0, 0, 19663, 19665),
         16#70#           =>  --  FD70
          (0, 0, 19666, 19668),
         16#71#           =>  --  FD71
          (0, 0, 19669, 19671),
         16#72#           =>  --  FD72
          (0, 0, 19672, 19674),
         16#73#           =>  --  FD73
          (0, 0, 19675, 19677),
         16#74#           =>  --  FD74
          (0, 0, 19678, 19680),
         16#75#           =>  --  FD75
          (0, 0, 19681, 19683),
         16#76#           =>  --  FD76
          (0, 0, 19684, 19686),
         16#77#           =>  --  FD77
          (0, 0, 19687, 19689),
         16#78#           =>  --  FD78
          (0, 0, 19690, 19692),
         16#79#           =>  --  FD79
          (0, 0, 19693, 19695),
         16#7A#           =>  --  FD7A
          (0, 0, 19696, 19698),
         16#7B#           =>  --  FD7B
          (0, 0, 19699, 19701),
         16#7C#           =>  --  FD7C
          (0, 0, 19702, 19704),
         16#7D#           =>  --  FD7D
          (0, 0, 19705, 19707),
         16#7E#           =>  --  FD7E
          (0, 0, 19708, 19710),
         16#7F#           =>  --  FD7F
          (0, 0, 19711, 19713),
         16#80#           =>  --  FD80
          (0, 0, 19714, 19716),
         16#81#           =>  --  FD81
          (0, 0, 19717, 19719),
         16#82#           =>  --  FD82
          (0, 0, 19720, 19722),
         16#83#           =>  --  FD83
          (0, 0, 19723, 19725),
         16#84#           =>  --  FD84
          (0, 0, 19726, 19728),
         16#85#           =>  --  FD85
          (0, 0, 19729, 19731),
         16#86#           =>  --  FD86
          (0, 0, 19732, 19734),
         16#87#           =>  --  FD87
          (0, 0, 19735, 19737),
         16#88#           =>  --  FD88
          (0, 0, 19738, 19740),
         16#89#           =>  --  FD89
          (0, 0, 19741, 19743),
         16#8A#           =>  --  FD8A
          (0, 0, 19286, 19288),
         16#8B#           =>  --  FD8B
          (0, 0, 19744, 19746),
         16#8C#           =>  --  FD8C
          (0, 0, 19282, 19284),
         16#8D#           =>  --  FD8D
          (0, 0, 19747, 19749),
         16#8E#           =>  --  FD8E
          (0, 0, 19288, 19290),
         16#8F#           =>  --  FD8F
          (0, 0, 19750, 19752),
         16#92#           =>  --  FD92
          (0, 0, 19753, 19755),
         16#93#           =>  --  FD93
          (0, 0, 19756, 19758),
         16#94#           =>  --  FD94
          (0, 0, 19358, 19360),
         16#95#           =>  --  FD95
          (0, 0, 19759, 19761),
         16#96#           =>  --  FD96
          (0, 0, 19762, 19764),
         16#97#           =>  --  FD97
          (0, 0, 19765, 19767),
         16#98#           =>  --  FD98
          (0, 0, 19768, 19770),
         16#99#           =>  --  FD99
          (0, 0, 19771, 19773),
         16#9A#           =>  --  FD9A
          (0, 0, 19774, 19776),
         16#9B#           =>  --  FD9B
          (0, 0, 19777, 19779),
         16#9C#           =>  --  FD9C
          (0, 0, 19780, 19782),
         16#9D#           =>  --  FD9D
          (0, 0, 19783, 19785),
         16#9E#           =>  --  FD9E
          (0, 0, 19786, 19788),
         16#9F#           =>  --  FD9F
          (0, 0, 19789, 19791),
         16#A0#           =>  --  FDA0
          (0, 0, 19792, 19794),
         16#A1#           =>  --  FDA1
          (0, 0, 19795, 19797),
         16#A2#           =>  --  FDA2
          (0, 0, 19798, 19800),
         16#A3#           =>  --  FDA3
          (0, 0, 19801, 19803),
         16#A4#           =>  --  FDA4
          (0, 0, 19804, 19806),
         16#A5#           =>  --  FDA5
          (0, 0, 19807, 19809),
         16#A6#           =>  --  FDA6
          (0, 0, 19810, 19812),
         16#A7#           =>  --  FDA7
          (0, 0, 19813, 19815),
         16#A8#           =>  --  FDA8
          (0, 0, 19816, 19818),
         16#A9#           =>  --  FDA9
          (0, 0, 19819, 19821),
         16#AA#           =>  --  FDAA
          (0, 0, 19822, 19824),
         16#AB#           =>  --  FDAB
          (0, 0, 19825, 19827),
         16#AC#           =>  --  FDAC
          (0, 0, 19828, 19830),
         16#AD#           =>  --  FDAD
          (0, 0, 19831, 19833),
         16#AE#           =>  --  FDAE
          (0, 0, 19834, 19836),
         16#AF#           =>  --  FDAF
          (0, 0, 19837, 19839),
         16#B0#           =>  --  FDB0
          (0, 0, 19840, 19842),
         16#B1#           =>  --  FDB1
          (0, 0, 19843, 19845),
         16#B2#           =>  --  FDB2
          (0, 0, 19846, 19848),
         16#B3#           =>  --  FDB3
          (0, 0, 19849, 19851),
         16#B4#           =>  --  FDB4
          (0, 0, 19852, 19854),
         16#B5#           =>  --  FDB5
          (0, 0, 19855, 19857),
         16#B6#           =>  --  FDB6
          (0, 0, 19858, 19860),
         16#B7#           =>  --  FDB7
          (0, 0, 19861, 19863),
         16#B8#           =>  --  FDB8
          (0, 0, 19864, 19866),
         16#B9#           =>  --  FDB9
          (0, 0, 19867, 19869),
         16#BA#           =>  --  FDBA
          (0, 0, 19870, 19872),
         16#BB#           =>  --  FDBB
          (0, 0, 19873, 19875),
         16#BC#           =>  --  FDBC
          (0, 0, 19876, 19878),
         16#BD#           =>  --  FDBD
          (0, 0, 19879, 19881),
         16#BE#           =>  --  FDBE
          (0, 0, 19882, 19884),
         16#BF#           =>  --  FDBF
          (0, 0, 19885, 19887),
         16#C0#           =>  --  FDC0
          (0, 0, 19888, 19890),
         16#C1#           =>  --  FDC1
          (0, 0, 19891, 19893),
         16#C2#           =>  --  FDC2
          (0, 0, 19894, 19896),
         16#C3#           =>  --  FDC3
          (0, 0, 19897, 19899),
         16#C4#           =>  --  FDC4
          (0, 0, 19900, 19902),
         16#C5#           =>  --  FDC5
          (0, 0, 19903, 19905),
         16#C6#           =>  --  FDC6
          (0, 0, 19906, 19908),
         16#C7#           =>  --  FDC7
          (0, 0, 19909, 19911),
         16#F0#           =>  --  FDF0
          (0, 0, 19912, 19914),
         16#F1#           =>  --  FDF1
          (0, 0, 19915, 19917),
         16#F2#           =>  --  FDF2
          (0, 0, 19918, 19921),
         16#F3#           =>  --  FDF3
          (0, 0, 19922, 19925),
         16#F4#           =>  --  FDF4
          (0, 0, 19926, 19929),
         16#F5#           =>  --  FDF5
          (0, 0, 19930, 19933),
         16#F6#           =>  --  FDF6
          (0, 0, 19934, 19937),
         16#F7#           =>  --  FDF7
          (0, 0, 19938, 19941),
         16#F8#           =>  --  FDF8
          (0, 0, 19942, 19945),
         16#F9#           =>  --  FDF9
          (0, 0, 19946, 19948),
         16#FA#           =>  --  FDFA
          (0, 0, 19949, 19966),
         16#FB#           =>  --  FDFB
          (0, 0, 19967, 19974),
         16#FC#           =>  --  FDFC
          (0, 0, 19975, 19975),
         16#FD#           =>  --  FDFD
          (0, 0, 19976, 19976),
         others           =>
          (0, 0, 0, 0));

   Group_00FE : aliased constant Collation_Second_Stage
     := (16#10#           =>  --  FE10
          (0, 0, 19977, 19977),
         16#11#           =>  --  FE11
          (0, 0, 19978, 19978),
         16#12#           =>  --  FE12
          (0, 0, 19979, 19979),
         16#13#           =>  --  FE13
          (0, 0, 19980, 19980),
         16#14#           =>  --  FE14
          (0, 0, 19981, 19981),
         16#15#           =>  --  FE15
          (0, 0, 19982, 19982),
         16#16#           =>  --  FE16
          (0, 0, 19983, 19983),
         16#17#           =>  --  FE17
          (0, 0, 19984, 19984),
         16#18#           =>  --  FE18
          (0, 0, 19985, 19985),
         16#19#           =>  --  FE19
          (0, 0, 19986, 19988),
         16#1A# .. 16#1F# =>  --  FE1A .. FE1F
          (0, 0, 0, 0),
         16#20#           =>  --  FE20
          (0, 0, 1063, 1063),
         16#22#           =>  --  FE22
          (0, 0, 1062, 1062),
         16#27#           =>  --  FE27
          (0, 0, 1045, 1045),
         16#29#           =>  --  FE29
          (0, 0, 1062, 1062),
         16#2E# .. 16#2F# =>  --  FE2E .. FE2F
          (0, 0, 0, 0),
         16#30#           =>  --  FE30
          (0, 0, 19986, 19987),
         16#31#           =>  --  FE31
          (0, 0, 19989, 19989),
         16#32#           =>  --  FE32
          (0, 0, 19990, 19990),
         16#33# .. 16#34# =>  --  FE33 .. FE34
          (0, 0, 19991, 19991),
         16#35#           =>  --  FE35
          (0, 0, 19992, 19992),
         16#36#           =>  --  FE36
          (0, 0, 19993, 19993),
         16#37#           =>  --  FE37
          (0, 0, 19994, 19994),
         16#38#           =>  --  FE38
          (0, 0, 19995, 19995),
         16#39#           =>  --  FE39
          (0, 0, 19996, 19996),
         16#3A#           =>  --  FE3A
          (0, 0, 19997, 19997),
         16#3B#           =>  --  FE3B
          (0, 0, 19998, 19998),
         16#3C#           =>  --  FE3C
          (0, 0, 19999, 19999),
         16#3D#           =>  --  FE3D
          (0, 0, 20000, 20000),
         16#3E#           =>  --  FE3E
          (0, 0, 20001, 20001),
         16#3F#           =>  --  FE3F
          (0, 0, 20002, 20002),
         16#40#           =>  --  FE40
          (0, 0, 20003, 20003),
         16#41#           =>  --  FE41
          (0, 0, 20004, 20004),
         16#42#           =>  --  FE42
          (0, 0, 20005, 20005),
         16#43#           =>  --  FE43
          (0, 0, 20006, 20006),
         16#44#           =>  --  FE44
          (0, 0, 20007, 20007),
         16#45#           =>  --  FE45
          (0, 0, 20008, 20008),
         16#46#           =>  --  FE46
          (0, 0, 20009, 20009),
         16#47#           =>  --  FE47
          (0, 0, 20010, 20010),
         16#48#           =>  --  FE48
          (0, 0, 20011, 20011),
         16#49# .. 16#4C# =>  --  FE49 .. FE4C
          (0, 0, 20012, 20012),
         16#4D# .. 16#4F# =>  --  FE4D .. FE4F
          (0, 0, 20013, 20013),
         16#50#           =>  --  FE50
          (0, 0, 20014, 20014),
         16#51#           =>  --  FE51
          (0, 0, 20015, 20015),
         16#52#           =>  --  FE52
          (0, 0, 20016, 20016),
         16#53#           =>  --  FE53
          (0, 0, 0, 0),
         16#54#           =>  --  FE54
          (0, 0, 20017, 20017),
         16#55#           =>  --  FE55
          (0, 0, 20018, 20018),
         16#56#           =>  --  FE56
          (0, 0, 20019, 20019),
         16#57#           =>  --  FE57
          (0, 0, 20020, 20020),
         16#58#           =>  --  FE58
          (0, 0, 20021, 20021),
         16#59#           =>  --  FE59
          (0, 0, 20022, 20022),
         16#5A#           =>  --  FE5A
          (0, 0, 20023, 20023),
         16#5B#           =>  --  FE5B
          (0, 0, 20024, 20024),
         16#5C#           =>  --  FE5C
          (0, 0, 20025, 20025),
         16#5D#           =>  --  FE5D
          (0, 0, 20026, 20026),
         16#5E#           =>  --  FE5E
          (0, 0, 20027, 20027),
         16#5F#           =>  --  FE5F
          (0, 0, 20028, 20028),
         16#60#           =>  --  FE60
          (0, 0, 20029, 20029),
         16#61#           =>  --  FE61
          (0, 0, 20030, 20030),
         16#62#           =>  --  FE62
          (0, 0, 20031, 20031),
         16#63#           =>  --  FE63
          (0, 0, 20032, 20032),
         16#64#           =>  --  FE64
          (0, 0, 20033, 20033),
         16#65#           =>  --  FE65
          (0, 0, 20034, 20034),
         16#66#           =>  --  FE66
          (0, 0, 20035, 20035),
         16#67#           =>  --  FE67
          (0, 0, 0, 0),
         16#68#           =>  --  FE68
          (0, 0, 20036, 20036),
         16#69#           =>  --  FE69
          (0, 0, 20037, 20037),
         16#6A#           =>  --  FE6A
          (0, 0, 20038, 20038),
         16#6B#           =>  --  FE6B
          (0, 0, 20039, 20039),
         16#6C# .. 16#6F# =>  --  FE6C .. FE6F
          (0, 0, 0, 0),
         16#70#           =>  --  FE70
          (0, 0, 19570, 19570),
         16#71#           =>  --  FE71
          (0, 0, 20040, 20040),
         16#72#           =>  --  FE72
          (0, 0, 19143, 19143),
         16#74#           =>  --  FE74
          (0, 0, 19145, 19145),
         16#75#           =>  --  FE75
          (0, 0, 0, 0),
         16#76#           =>  --  FE76
          (0, 0, 19147, 19147),
         16#77#           =>  --  FE77
          (0, 0, 19423, 19423),
         16#78#           =>  --  FE78
          (0, 0, 19149, 19149),
         16#79#           =>  --  FE79
          (0, 0, 19425, 19425),
         16#7A#           =>  --  FE7A
          (0, 0, 19151, 19151),
         16#7B#           =>  --  FE7B
          (0, 0, 19427, 19427),
         16#7C#           =>  --  FE7C
          (0, 0, 19144, 19144),
         16#7D#           =>  --  FE7D
          (0, 0, 19424, 19424),
         16#7E#           =>  --  FE7E
          (0, 0, 20041, 20041),
         16#7F#           =>  --  FE7F
          (0, 0, 20042, 20042),
         16#80#           =>  --  FE80
          (0, 0, 18916, 18916),
         16#81#           =>  --  FE81
          (0, 0, 20043, 20043),
         16#82#           =>  --  FE82
          (0, 0, 20044, 20044),
         16#83#           =>  --  FE83
          (0, 0, 20045, 20045),
         16#84#           =>  --  FE84
          (0, 0, 20046, 20046),
         16#85#           =>  --  FE85
          (0, 0, 20047, 20047),
         16#86#           =>  --  FE86
          (0, 0, 20048, 20048),
         16#87#           =>  --  FE87
          (0, 0, 20049, 20049),
         16#88#           =>  --  FE88
          (0, 0, 20050, 20050),
         16#89#           =>  --  FE89
          (0, 0, 18929, 18929),
         16#8A#           =>  --  FE8A
          (0, 0, 18931, 18931),
         16#8B#           =>  --  FE8B
          (0, 0, 18957, 18957),
         16#8C#           =>  --  FE8C
          (0, 0, 19385, 19385),
         16#8D#           =>  --  FE8D
          (0, 0, 18930, 18930),
         16#8E#           =>  --  FE8E
          (0, 0, 18932, 18932),
         16#8F#           =>  --  FE8F
          (0, 0, 18977, 18977),
         16#90#           =>  --  FE90
          (0, 0, 19165, 19165),
         16#91#           =>  --  FE91
          (0, 0, 19261, 19261),
         16#92#           =>  --  FE92
          (0, 0, 19389, 19389),
         16#93#           =>  --  FE93
          (0, 0, 20051, 20051),
         16#94#           =>  --  FE94
          (0, 0, 20052, 20052),
         16#95#           =>  --  FE95
          (0, 0, 18989, 18989),
         16#96#           =>  --  FE96
          (0, 0, 19177, 19177),
         16#97#           =>  --  FE97
          (0, 0, 19271, 19271),
         16#98#           =>  --  FE98
          (0, 0, 19393, 19393),
         16#99#           =>  --  FE99
          (0, 0, 19001, 19001),
         16#9A#           =>  --  FE9A
          (0, 0, 19189, 19189),
         16#9B#           =>  --  FE9B
          (0, 0, 19281, 19281),
         16#9C#           =>  --  FE9C
          (0, 0, 19397, 19397),
         16#9D#           =>  --  FE9D
          (0, 0, 18970, 18970),
         16#9E#           =>  --  FE9E
          (0, 0, 19505, 19505),
         16#9F#           =>  --  FE9F
          (0, 0, 19252, 19252),
         16#A0#           =>  --  FEA0
          (0, 0, 19552, 19552),
         16#A1#           =>  --  FEA1
          (0, 0, 18972, 18972),
         16#A2#           =>  --  FEA2
          (0, 0, 19501, 19501),
         16#A3#           =>  --  FEA3
          (0, 0, 19254, 19254),
         16#A4#           =>  --  FEA4
          (0, 0, 19554, 19554),
         16#A5#           =>  --  FEA5
          (0, 0, 18982, 18982),
         16#A6#           =>  --  FEA6
          (0, 0, 19509, 19509),
         16#A7#           =>  --  FEA7
          (0, 0, 19256, 19256),
         16#A8#           =>  --  FEA8
          (0, 0, 19556, 19556),
         16#A9#           =>  --  FEA9
          (0, 0, 19929, 19929),
         16#AA#           =>  --  FEAA
          (0, 0, 20053, 20053),
         16#AB#           =>  --  FEAB
          (0, 0, 19137, 19137),
         16#AC#           =>  --  FEAC
          (0, 0, 20054, 20054),
         16#AD#           =>  --  FEAD
          (0, 0, 19139, 19139),
         16#AE#           =>  --  FEAE
          (0, 0, 19156, 19156),
         16#AF#           =>  --  FEAF
          (0, 0, 20055, 20055),
         16#B0#           =>  --  FEB0
          (0, 0, 19158, 19158),
         16#B1#           =>  --  FEB1
          (0, 0, 19021, 19021),
         16#B2#           =>  --  FEB2
          (0, 0, 19493, 19493),
         16#B3#           =>  --  FEB3
          (0, 0, 19293, 19293),
         16#B4#           =>  --  FEB4
          (0, 0, 19401, 19401),
         16#B5#           =>  --  FEB5
          (0, 0, 19445, 19445),
         16#B6#           =>  --  FEB6
          (0, 0, 19497, 19497),
         16#B7#           =>  --  FEB7
          (0, 0, 19537, 19537),
         16#B8#           =>  --  FEB8
          (0, 0, 19405, 19405),
         16#B9#           =>  --  FEB9
          (0, 0, 19029, 19029),
         16#BA#           =>  --  FEBA
          (0, 0, 19513, 19513),
         16#BB#           =>  --  FEBB
          (0, 0, 19301, 19301),
         16#BC#           =>  --  FEBC
          (0, 0, 20056, 20056),
         16#BD#           =>  --  FEBD
          (0, 0, 19033, 19033),
         16#BE#           =>  --  FEBE
          (0, 0, 19517, 19517),
         16#BF#           =>  --  FEBF
          (0, 0, 19307, 19307),
         16#C0#           =>  --  FEC0
          (0, 0, 20057, 20057),
         16#C1#           =>  --  FEC1
          (0, 0, 19041, 19041),
         16#C2#           =>  --  FEC2
          (0, 0, 19481, 19481),
         16#C3#           =>  --  FEC3
          (0, 0, 19315, 19315),
         16#C4#           =>  --  FEC4
          (0, 0, 19563, 19563),
         16#C5#           =>  --  FEC5
          (0, 0, 19045, 19045),
         16#C6#           =>  --  FEC6
          (0, 0, 20058, 20058),
         16#C7#           =>  --  FEC7
          (0, 0, 19317, 19317),
         16#C8#           =>  --  FEC8
          (0, 0, 19565, 19565),
         16#C9#           =>  --  FEC9
          (0, 0, 19047, 19047),
         16#CA#           =>  --  FECA
          (0, 0, 19485, 19485),
         16#CB#           =>  --  FECB
          (0, 0, 19319, 19319),
         16#CC#           =>  --  FECC
          (0, 0, 20059, 20059),
         16#CD#           =>  --  FECD
          (0, 0, 19051, 19051),
         16#CE#           =>  --  FECE
          (0, 0, 19489, 19489),
         16#CF#           =>  --  FECF
          (0, 0, 19323, 19323),
         16#D0#           =>  --  FED0
          (0, 0, 20060, 20060),
         16#D1#           =>  --  FED1
          (0, 0, 19055, 19055),
         16#D2#           =>  --  FED2
          (0, 0, 19201, 19201),
         16#D3#           =>  --  FED3
          (0, 0, 19327, 19327),
         16#D4#           =>  --  FED4
          (0, 0, 20061, 20061),
         16#D5#           =>  --  FED5
          (0, 0, 19067, 19067),
         16#D6#           =>  --  FED6
          (0, 0, 19205, 19205),
         16#D7#           =>  --  FED7
          (0, 0, 19335, 19335),
         16#D8#           =>  --  FED8
          (0, 0, 20062, 20062),
         16#D9#           =>  --  FED9
          (0, 0, 19075, 19075),
         16#DA#           =>  --  FEDA
          (0, 0, 19209, 19209),
         16#DB#           =>  --  FEDB
          (0, 0, 19339, 19339),
         16#DC#           =>  --  FEDC
          (0, 0, 19409, 19409),
         16#DD#           =>  --  FEDD
          (0, 0, 19084, 19084),
         16#DE#           =>  --  FEDE
          (0, 0, 19212, 19212),
         16#DF#           =>  --  FEDF
          (0, 0, 19346, 19346),
         16#E0#           =>  --  FEE0
          (0, 0, 19410, 19410),
         16#E1#           =>  --  FEE1
          (0, 0, 18974, 18974),
         16#E2#           =>  --  FEE2
          (0, 0, 19160, 19160),
         16#E3#           =>  --  FEE3
          (0, 0, 19258, 19258),
         16#E4#           =>  --  FEE4
          (0, 0, 19386, 19386),
         16#E5#           =>  --  FEE5
          (0, 0, 19111, 19111),
         16#E6#           =>  --  FEE6
          (0, 0, 19162, 19162),
         16#E7#           =>  --  FEE7
          (0, 0, 19361, 19361),
         16#E8#           =>  --  FEE8
          (0, 0, 19415, 19415),
         16#E9#           =>  --  FEE9
          (0, 0, 19123, 19123),
         16#EA#           =>  --  FEEA
          (0, 0, 20063, 20063),
         16#EB#           =>  --  FEEB
          (0, 0, 19260, 19260),
         16#EC#           =>  --  FEEC
          (0, 0, 19388, 19388),
         16#ED#           =>  --  FEED
          (0, 0, 18938, 18938),
         16#EE#           =>  --  FEEE
          (0, 0, 18940, 18940),
         16#EF#           =>  --  FEEF
          (0, 0, 18960, 18960),
         16#F0#           =>  --  FEF0
          (0, 0, 18962, 18962),
         16#F1#           =>  --  FEF1
          (0, 0, 18976, 18976),
         16#F2#           =>  --  FEF2
          (0, 0, 19164, 19164),
         16#F3#           =>  --  FEF3
          (0, 0, 19375, 19375),
         16#F4#           =>  --  FEF4
          (0, 0, 19419, 19419),
         16#F5#           =>  --  FEF5
          (0, 0, 20064, 20065),
         16#F6#           =>  --  FEF6
          (0, 0, 20066, 20067),
         16#F7#           =>  --  FEF7
          (0, 0, 20068, 20069),
         16#F8#           =>  --  FEF8
          (0, 0, 20070, 20071),
         16#F9#           =>  --  FEF9
          (0, 0, 20072, 20073),
         16#FA#           =>  --  FEFA
          (0, 0, 20074, 20075),
         16#FB#           =>  --  FEFB
          (0, 0, 19971, 19972),
         16#FC#           =>  --  FEFC
          (0, 0, 20076, 20077),
         16#FD# .. 16#FE# =>  --  FEFD .. FEFE
          (0, 0, 0, 0),
         others           =>
          (0, 0, 1, 1));

   Group_00FF : aliased constant Collation_Second_Stage
     := (16#01#           =>  --  FF01
          (0, 0, 20078, 20078),
         16#02#           =>  --  FF02
          (0, 0, 20079, 20079),
         16#03#           =>  --  FF03
          (0, 0, 20080, 20080),
         16#04#           =>  --  FF04
          (0, 0, 20081, 20081),
         16#05#           =>  --  FF05
          (0, 0, 20082, 20082),
         16#06#           =>  --  FF06
          (0, 0, 20083, 20083),
         16#07#           =>  --  FF07
          (0, 0, 20084, 20084),
         16#08#           =>  --  FF08
          (0, 0, 20085, 20085),
         16#09#           =>  --  FF09
          (0, 0, 20086, 20086),
         16#0A#           =>  --  FF0A
          (0, 0, 20087, 20087),
         16#0B#           =>  --  FF0B
          (0, 0, 20088, 20088),
         16#0C#           =>  --  FF0C
          (0, 0, 20089, 20089),
         16#0D#           =>  --  FF0D
          (0, 0, 20090, 20090),
         16#0E#           =>  --  FF0E
          (0, 0, 20091, 20091),
         16#0F#           =>  --  FF0F
          (0, 0, 20092, 20092),
         16#10#           =>  --  FF10
          (0, 0, 20093, 20093),
         16#11#           =>  --  FF11
          (0, 0, 20094, 20094),
         16#12#           =>  --  FF12
          (0, 0, 20095, 20095),
         16#13#           =>  --  FF13
          (0, 0, 20096, 20096),
         16#14#           =>  --  FF14
          (0, 0, 20097, 20097),
         16#15#           =>  --  FF15
          (0, 0, 20098, 20098),
         16#16#           =>  --  FF16
          (0, 0, 20099, 20099),
         16#17#           =>  --  FF17
          (0, 0, 20100, 20100),
         16#18#           =>  --  FF18
          (0, 0, 20101, 20101),
         16#19#           =>  --  FF19
          (0, 0, 20102, 20102),
         16#1A#           =>  --  FF1A
          (0, 0, 20103, 20103),
         16#1B#           =>  --  FF1B
          (0, 0, 20104, 20104),
         16#1C#           =>  --  FF1C
          (0, 0, 20105, 20105),
         16#1D#           =>  --  FF1D
          (0, 0, 20106, 20106),
         16#1E#           =>  --  FF1E
          (0, 0, 20107, 20107),
         16#1F#           =>  --  FF1F
          (0, 0, 20108, 20108),
         16#20#           =>  --  FF20
          (0, 0, 20109, 20109),
         16#21#           =>  --  FF21
          (0, 0, 20110, 20110),
         16#22#           =>  --  FF22
          (0, 0, 20111, 20111),
         16#23#           =>  --  FF23
          (0, 0, 20112, 20112),
         16#24#           =>  --  FF24
          (0, 0, 20113, 20113),
         16#25#           =>  --  FF25
          (0, 0, 20114, 20114),
         16#26#           =>  --  FF26
          (0, 0, 20115, 20115),
         16#27#           =>  --  FF27
          (0, 0, 20116, 20116),
         16#28#           =>  --  FF28
          (0, 0, 20117, 20117),
         16#29#           =>  --  FF29
          (0, 0, 20118, 20118),
         16#2A#           =>  --  FF2A
          (0, 0, 20119, 20119),
         16#2B#           =>  --  FF2B
          (0, 0, 20120, 20120),
         16#2C#           =>  --  FF2C
          (0, 0, 20121, 20121),
         16#2D#           =>  --  FF2D
          (0, 0, 20122, 20122),
         16#2E#           =>  --  FF2E
          (0, 0, 20123, 20123),
         16#2F#           =>  --  FF2F
          (0, 0, 20124, 20124),
         16#30#           =>  --  FF30
          (0, 0, 20125, 20125),
         16#31#           =>  --  FF31
          (0, 0, 20126, 20126),
         16#32#           =>  --  FF32
          (0, 0, 20127, 20127),
         16#33#           =>  --  FF33
          (0, 0, 20128, 20128),
         16#34#           =>  --  FF34
          (0, 0, 20129, 20129),
         16#35#           =>  --  FF35
          (0, 0, 20130, 20130),
         16#36#           =>  --  FF36
          (0, 0, 20131, 20131),
         16#37#           =>  --  FF37
          (0, 0, 20132, 20132),
         16#38#           =>  --  FF38
          (0, 0, 20133, 20133),
         16#39#           =>  --  FF39
          (0, 0, 20134, 20134),
         16#3A#           =>  --  FF3A
          (0, 0, 20135, 20135),
         16#3B#           =>  --  FF3B
          (0, 0, 20136, 20136),
         16#3C#           =>  --  FF3C
          (0, 0, 20137, 20137),
         16#3D#           =>  --  FF3D
          (0, 0, 20138, 20138),
         16#3E#           =>  --  FF3E
          (0, 0, 20139, 20139),
         16#3F#           =>  --  FF3F
          (0, 0, 20140, 20140),
         16#40#           =>  --  FF40
          (0, 0, 20141, 20141),
         16#41#           =>  --  FF41
          (0, 0, 20142, 20142),
         16#42#           =>  --  FF42
          (0, 0, 20143, 20143),
         16#43#           =>  --  FF43
          (0, 0, 20144, 20144),
         16#44#           =>  --  FF44
          (0, 0, 20145, 20145),
         16#45#           =>  --  FF45
          (0, 0, 20146, 20146),
         16#46#           =>  --  FF46
          (0, 0, 20147, 20147),
         16#47#           =>  --  FF47
          (0, 0, 20148, 20148),
         16#48#           =>  --  FF48
          (0, 0, 20149, 20149),
         16#49#           =>  --  FF49
          (0, 0, 20150, 20150),
         16#4A#           =>  --  FF4A
          (0, 0, 20151, 20151),
         16#4B#           =>  --  FF4B
          (0, 0, 20152, 20152),
         16#4C#           =>  --  FF4C
          (0, 0, 20153, 20153),
         16#4D#           =>  --  FF4D
          (0, 0, 20154, 20154),
         16#4E#           =>  --  FF4E
          (0, 0, 20155, 20155),
         16#4F#           =>  --  FF4F
          (0, 0, 20156, 20156),
         16#50#           =>  --  FF50
          (0, 0, 20157, 20157),
         16#51#           =>  --  FF51
          (0, 0, 20158, 20158),
         16#52#           =>  --  FF52
          (0, 0, 20159, 20159),
         16#53#           =>  --  FF53
          (0, 0, 20160, 20160),
         16#54#           =>  --  FF54
          (0, 0, 20161, 20161),
         16#55#           =>  --  FF55
          (0, 0, 20162, 20162),
         16#56#           =>  --  FF56
          (0, 0, 20163, 20163),
         16#57#           =>  --  FF57
          (0, 0, 20164, 20164),
         16#58#           =>  --  FF58
          (0, 0, 20165, 20165),
         16#59#           =>  --  FF59
          (0, 0, 20166, 20166),
         16#5A#           =>  --  FF5A
          (0, 0, 20167, 20167),
         16#5B#           =>  --  FF5B
          (0, 0, 20168, 20168),
         16#5C#           =>  --  FF5C
          (0, 0, 20169, 20169),
         16#5D#           =>  --  FF5D
          (0, 0, 20170, 20170),
         16#5E#           =>  --  FF5E
          (0, 0, 20171, 20171),
         16#5F#           =>  --  FF5F
          (0, 0, 20172, 20172),
         16#60#           =>  --  FF60
          (0, 0, 20173, 20173),
         16#61#           =>  --  FF61
          (0, 0, 20174, 20174),
         16#62#           =>  --  FF62
          (0, 0, 20175, 20175),
         16#63#           =>  --  FF63
          (0, 0, 20176, 20176),
         16#64#           =>  --  FF64
          (0, 0, 20177, 20177),
         16#65#           =>  --  FF65
          (0, 0, 20178, 20178),
         16#66#           =>  --  FF66
          (0, 0, 20179, 20179),
         16#67#           =>  --  FF67
          (0, 0, 20180, 20180),
         16#68#           =>  --  FF68
          (0, 0, 20181, 20181),
         16#69#           =>  --  FF69
          (0, 0, 20182, 20182),
         16#6A#           =>  --  FF6A
          (0, 0, 20183, 20183),
         16#6B#           =>  --  FF6B
          (0, 0, 20184, 20184),
         16#6C#           =>  --  FF6C
          (0, 0, 20185, 20185),
         16#6D#           =>  --  FF6D
          (0, 0, 20186, 20186),
         16#6E#           =>  --  FF6E
          (0, 0, 20187, 20187),
         16#6F#           =>  --  FF6F
          (0, 0, 20188, 20188),
         16#70#           =>  --  FF70
          (0, 0, 20189, 20189),
         16#71#           =>  --  FF71
          (0, 0, 20190, 20190),
         16#72#           =>  --  FF72
          (0, 0, 20191, 20191),
         16#73#           =>  --  FF73
          (0, 0, 20192, 20192),
         16#74#           =>  --  FF74
          (0, 0, 20193, 20193),
         16#75#           =>  --  FF75
          (0, 0, 20194, 20194),
         16#76#           =>  --  FF76
          (0, 0, 20195, 20195),
         16#77#           =>  --  FF77
          (0, 0, 20196, 20196),
         16#78#           =>  --  FF78
          (0, 0, 20197, 20197),
         16#79#           =>  --  FF79
          (0, 0, 20198, 20198),
         16#7A#           =>  --  FF7A
          (0, 0, 20199, 20199),
         16#7B#           =>  --  FF7B
          (0, 0, 20200, 20200),
         16#7C#           =>  --  FF7C
          (0, 0, 20201, 20201),
         16#7D#           =>  --  FF7D
          (0, 0, 20202, 20202),
         16#7E#           =>  --  FF7E
          (0, 0, 20203, 20203),
         16#7F#           =>  --  FF7F
          (0, 0, 20204, 20204),
         16#80#           =>  --  FF80
          (0, 0, 20205, 20205),
         16#81#           =>  --  FF81
          (0, 0, 20206, 20206),
         16#82#           =>  --  FF82
          (0, 0, 20207, 20207),
         16#83#           =>  --  FF83
          (0, 0, 20208, 20208),
         16#84#           =>  --  FF84
          (0, 0, 20209, 20209),
         16#85#           =>  --  FF85
          (0, 0, 20210, 20210),
         16#86#           =>  --  FF86
          (0, 0, 20211, 20211),
         16#87#           =>  --  FF87
          (0, 0, 20212, 20212),
         16#88#           =>  --  FF88
          (0, 0, 20213, 20213),
         16#89#           =>  --  FF89
          (0, 0, 20214, 20214),
         16#8A#           =>  --  FF8A
          (0, 0, 20215, 20215),
         16#8B#           =>  --  FF8B
          (0, 0, 20216, 20216),
         16#8C#           =>  --  FF8C
          (0, 0, 20217, 20217),
         16#8D#           =>  --  FF8D
          (0, 0, 20218, 20218),
         16#8E#           =>  --  FF8E
          (0, 0, 20219, 20219),
         16#8F#           =>  --  FF8F
          (0, 0, 20220, 20220),
         16#90#           =>  --  FF90
          (0, 0, 20221, 20221),
         16#91#           =>  --  FF91
          (0, 0, 20222, 20222),
         16#92#           =>  --  FF92
          (0, 0, 20223, 20223),
         16#93#           =>  --  FF93
          (0, 0, 20224, 20224),
         16#94#           =>  --  FF94
          (0, 0, 20225, 20225),
         16#95#           =>  --  FF95
          (0, 0, 20226, 20226),
         16#96#           =>  --  FF96
          (0, 0, 20227, 20227),
         16#97#           =>  --  FF97
          (0, 0, 20228, 20228),
         16#98#           =>  --  FF98
          (0, 0, 20229, 20229),
         16#99#           =>  --  FF99
          (0, 0, 20230, 20230),
         16#9A#           =>  --  FF9A
          (0, 0, 20231, 20231),
         16#9B#           =>  --  FF9B
          (0, 0, 20232, 20232),
         16#9C#           =>  --  FF9C
          (0, 0, 20233, 20233),
         16#9D#           =>  --  FF9D
          (0, 0, 20234, 20234),
         16#9E#           =>  --  FF9E
          (0, 0, 20235, 20235),
         16#9F#           =>  --  FF9F
          (0, 0, 20236, 20236),
         16#A0#           =>  --  FFA0
          (0, 0, 20237, 20237),
         16#A1#           =>  --  FFA1
          (0, 0, 20238, 20238),
         16#A2#           =>  --  FFA2
          (0, 0, 20239, 20239),
         16#A3#           =>  --  FFA3
          (0, 0, 20240, 20240),
         16#A4#           =>  --  FFA4
          (0, 0, 20241, 20241),
         16#A5#           =>  --  FFA5
          (0, 0, 20242, 20242),
         16#A6#           =>  --  FFA6
          (0, 0, 20243, 20243),
         16#A7#           =>  --  FFA7
          (0, 0, 20244, 20244),
         16#A8#           =>  --  FFA8
          (0, 0, 20245, 20245),
         16#A9#           =>  --  FFA9
          (0, 0, 20246, 20246),
         16#AA#           =>  --  FFAA
          (0, 0, 20247, 20247),
         16#AB#           =>  --  FFAB
          (0, 0, 20248, 20248),
         16#AC#           =>  --  FFAC
          (0, 0, 20249, 20249),
         16#AD#           =>  --  FFAD
          (0, 0, 20250, 20250),
         16#AE#           =>  --  FFAE
          (0, 0, 20251, 20251),
         16#AF#           =>  --  FFAF
          (0, 0, 20252, 20252),
         16#B0#           =>  --  FFB0
          (0, 0, 20253, 20253),
         16#B1#           =>  --  FFB1
          (0, 0, 20254, 20254),
         16#B2#           =>  --  FFB2
          (0, 0, 20255, 20255),
         16#B3#           =>  --  FFB3
          (0, 0, 20256, 20256),
         16#B4#           =>  --  FFB4
          (0, 0, 20257, 20257),
         16#B5#           =>  --  FFB5
          (0, 0, 20258, 20258),
         16#B6#           =>  --  FFB6
          (0, 0, 20259, 20259),
         16#B7#           =>  --  FFB7
          (0, 0, 20260, 20260),
         16#B8#           =>  --  FFB8
          (0, 0, 20261, 20261),
         16#B9#           =>  --  FFB9
          (0, 0, 20262, 20262),
         16#BA#           =>  --  FFBA
          (0, 0, 20263, 20263),
         16#BB#           =>  --  FFBB
          (0, 0, 20264, 20264),
         16#BC#           =>  --  FFBC
          (0, 0, 20265, 20265),
         16#BD#           =>  --  FFBD
          (0, 0, 20266, 20266),
         16#BE#           =>  --  FFBE
          (0, 0, 20267, 20267),
         16#C2#           =>  --  FFC2
          (0, 0, 20268, 20268),
         16#C3#           =>  --  FFC3
          (0, 0, 20269, 20269),
         16#C4#           =>  --  FFC4
          (0, 0, 20270, 20270),
         16#C5#           =>  --  FFC5
          (0, 0, 20271, 20271),
         16#C6#           =>  --  FFC6
          (0, 0, 20272, 20272),
         16#C7#           =>  --  FFC7
          (0, 0, 20273, 20273),
         16#CA#           =>  --  FFCA
          (0, 0, 20274, 20274),
         16#CB#           =>  --  FFCB
          (0, 0, 20275, 20275),
         16#CC#           =>  --  FFCC
          (0, 0, 20276, 20276),
         16#CD#           =>  --  FFCD
          (0, 0, 20277, 20277),
         16#CE#           =>  --  FFCE
          (0, 0, 20278, 20278),
         16#CF#           =>  --  FFCF
          (0, 0, 20279, 20279),
         16#D2#           =>  --  FFD2
          (0, 0, 20280, 20280),
         16#D3#           =>  --  FFD3
          (0, 0, 20281, 20281),
         16#D4#           =>  --  FFD4
          (0, 0, 20282, 20282),
         16#D5#           =>  --  FFD5
          (0, 0, 20283, 20283),
         16#D6#           =>  --  FFD6
          (0, 0, 20284, 20284),
         16#D7#           =>  --  FFD7
          (0, 0, 20285, 20285),
         16#DA#           =>  --  FFDA
          (0, 0, 20286, 20286),
         16#DB#           =>  --  FFDB
          (0, 0, 20287, 20287),
         16#DC#           =>  --  FFDC
          (0, 0, 20288, 20288),
         16#E0#           =>  --  FFE0
          (0, 0, 20289, 20289),
         16#E1#           =>  --  FFE1
          (0, 0, 20290, 20290),
         16#E2#           =>  --  FFE2
          (0, 0, 20291, 20291),
         16#E3#           =>  --  FFE3
          (0, 0, 20292, 20292),
         16#E4#           =>  --  FFE4
          (0, 0, 20293, 20293),
         16#E5#           =>  --  FFE5
          (0, 0, 20294, 20294),
         16#E6#           =>  --  FFE6
          (0, 0, 20295, 20295),
         16#E8#           =>  --  FFE8
          (0, 0, 20296, 20296),
         16#E9#           =>  --  FFE9
          (0, 0, 20297, 20297),
         16#EA#           =>  --  FFEA
          (0, 0, 20298, 20298),
         16#EB#           =>  --  FFEB
          (0, 0, 20299, 20299),
         16#EC#           =>  --  FFEC
          (0, 0, 20300, 20300),
         16#ED#           =>  --  FFED
          (0, 0, 20301, 20301),
         16#EE#           =>  --  FFEE
          (0, 0, 20302, 20302),
         16#F9# .. 16#FB# =>  --  FFF9 .. FFFB
          (0, 0, 1, 1),
         16#FC#           =>  --  FFFC
          (0, 0, 20303, 20303),
         16#FD#           =>  --  FFFD
          (0, 0, 20304, 20304),
         16#FE#           =>  --  FFFE
          (0, 0, 20305, 20305),
         16#FF#           =>  --  FFFF
          (0, 0, 20306, 20306),
         others           =>
          (0, 0, 0, 0));

   Group_0100 : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  010000
          (0, 0, 20307, 20307),
         16#01#           =>  --  010001
          (0, 0, 20308, 20308),
         16#02#           =>  --  010002
          (0, 0, 20309, 20309),
         16#03#           =>  --  010003
          (0, 0, 20310, 20310),
         16#04#           =>  --  010004
          (0, 0, 20311, 20311),
         16#05#           =>  --  010005
          (0, 0, 20312, 20312),
         16#06#           =>  --  010006
          (0, 0, 20313, 20313),
         16#07#           =>  --  010007
          (0, 0, 20314, 20314),
         16#08#           =>  --  010008
          (0, 0, 20315, 20315),
         16#09#           =>  --  010009
          (0, 0, 20316, 20316),
         16#0A#           =>  --  01000A
          (0, 0, 20317, 20317),
         16#0B#           =>  --  01000B
          (0, 0, 20318, 20318),
         16#0D#           =>  --  01000D
          (0, 0, 20319, 20319),
         16#0E#           =>  --  01000E
          (0, 0, 20320, 20320),
         16#0F#           =>  --  01000F
          (0, 0, 20321, 20321),
         16#10#           =>  --  010010
          (0, 0, 20322, 20322),
         16#11#           =>  --  010011
          (0, 0, 20323, 20323),
         16#12#           =>  --  010012
          (0, 0, 20324, 20324),
         16#13#           =>  --  010013
          (0, 0, 20325, 20325),
         16#14#           =>  --  010014
          (0, 0, 20326, 20326),
         16#15#           =>  --  010015
          (0, 0, 20327, 20327),
         16#16#           =>  --  010016
          (0, 0, 20328, 20328),
         16#17#           =>  --  010017
          (0, 0, 20329, 20329),
         16#18#           =>  --  010018
          (0, 0, 20330, 20330),
         16#19#           =>  --  010019
          (0, 0, 20331, 20331),
         16#1A#           =>  --  01001A
          (0, 0, 20332, 20332),
         16#1B#           =>  --  01001B
          (0, 0, 20333, 20333),
         16#1C#           =>  --  01001C
          (0, 0, 20334, 20334),
         16#1D#           =>  --  01001D
          (0, 0, 20335, 20335),
         16#1E#           =>  --  01001E
          (0, 0, 20336, 20336),
         16#1F#           =>  --  01001F
          (0, 0, 20337, 20337),
         16#20#           =>  --  010020
          (0, 0, 20338, 20338),
         16#21#           =>  --  010021
          (0, 0, 20339, 20339),
         16#22#           =>  --  010022
          (0, 0, 20340, 20340),
         16#23#           =>  --  010023
          (0, 0, 20341, 20341),
         16#24#           =>  --  010024
          (0, 0, 20342, 20342),
         16#25#           =>  --  010025
          (0, 0, 20343, 20343),
         16#26#           =>  --  010026
          (0, 0, 20344, 20344),
         16#28#           =>  --  010028
          (0, 0, 20345, 20345),
         16#29#           =>  --  010029
          (0, 0, 20346, 20346),
         16#2A#           =>  --  01002A
          (0, 0, 20347, 20347),
         16#2B#           =>  --  01002B
          (0, 0, 20348, 20348),
         16#2C#           =>  --  01002C
          (0, 0, 20349, 20349),
         16#2D#           =>  --  01002D
          (0, 0, 20350, 20350),
         16#2E#           =>  --  01002E
          (0, 0, 20351, 20351),
         16#2F#           =>  --  01002F
          (0, 0, 20352, 20352),
         16#30#           =>  --  010030
          (0, 0, 20353, 20353),
         16#31#           =>  --  010031
          (0, 0, 20354, 20354),
         16#32#           =>  --  010032
          (0, 0, 20355, 20355),
         16#33#           =>  --  010033
          (0, 0, 20356, 20356),
         16#34#           =>  --  010034
          (0, 0, 20357, 20357),
         16#35#           =>  --  010035
          (0, 0, 20358, 20358),
         16#36#           =>  --  010036
          (0, 0, 20359, 20359),
         16#37#           =>  --  010037
          (0, 0, 20360, 20360),
         16#38#           =>  --  010038
          (0, 0, 20361, 20361),
         16#39#           =>  --  010039
          (0, 0, 20362, 20362),
         16#3A#           =>  --  01003A
          (0, 0, 20363, 20363),
         16#3C#           =>  --  01003C
          (0, 0, 20364, 20364),
         16#3D#           =>  --  01003D
          (0, 0, 20365, 20365),
         16#3F#           =>  --  01003F
          (0, 0, 20366, 20366),
         16#40#           =>  --  010040
          (0, 0, 20367, 20367),
         16#41#           =>  --  010041
          (0, 0, 20368, 20368),
         16#42#           =>  --  010042
          (0, 0, 20369, 20369),
         16#43#           =>  --  010043
          (0, 0, 20370, 20370),
         16#44#           =>  --  010044
          (0, 0, 20371, 20371),
         16#45#           =>  --  010045
          (0, 0, 20372, 20372),
         16#46#           =>  --  010046
          (0, 0, 20373, 20373),
         16#47#           =>  --  010047
          (0, 0, 20374, 20374),
         16#48#           =>  --  010048
          (0, 0, 20375, 20375),
         16#49#           =>  --  010049
          (0, 0, 20376, 20376),
         16#4A#           =>  --  01004A
          (0, 0, 20377, 20377),
         16#4B#           =>  --  01004B
          (0, 0, 20378, 20378),
         16#4C#           =>  --  01004C
          (0, 0, 20379, 20379),
         16#4D#           =>  --  01004D
          (0, 0, 20380, 20380),
         16#50#           =>  --  010050
          (0, 0, 20381, 20381),
         16#51#           =>  --  010051
          (0, 0, 20382, 20382),
         16#52#           =>  --  010052
          (0, 0, 20383, 20383),
         16#53#           =>  --  010053
          (0, 0, 20384, 20384),
         16#54#           =>  --  010054
          (0, 0, 20385, 20385),
         16#55#           =>  --  010055
          (0, 0, 20386, 20386),
         16#56#           =>  --  010056
          (0, 0, 20387, 20387),
         16#57#           =>  --  010057
          (0, 0, 20388, 20388),
         16#58#           =>  --  010058
          (0, 0, 20389, 20389),
         16#59#           =>  --  010059
          (0, 0, 20390, 20390),
         16#5A#           =>  --  01005A
          (0, 0, 20391, 20391),
         16#5B#           =>  --  01005B
          (0, 0, 20392, 20392),
         16#5C#           =>  --  01005C
          (0, 0, 20393, 20393),
         16#5D#           =>  --  01005D
          (0, 0, 20394, 20394),
         16#80#           =>  --  010080
          (0, 0, 20395, 20395),
         16#81#           =>  --  010081
          (0, 0, 20396, 20396),
         16#82#           =>  --  010082
          (0, 0, 20397, 20397),
         16#83#           =>  --  010083
          (0, 0, 20398, 20398),
         16#84#           =>  --  010084
          (0, 0, 20399, 20399),
         16#85#           =>  --  010085
          (0, 0, 20400, 20400),
         16#86#           =>  --  010086
          (0, 0, 20401, 20401),
         16#87#           =>  --  010087
          (0, 0, 20402, 20402),
         16#88#           =>  --  010088
          (0, 0, 20403, 20403),
         16#89#           =>  --  010089
          (0, 0, 20404, 20404),
         16#8A#           =>  --  01008A
          (0, 0, 20405, 20405),
         16#8B#           =>  --  01008B
          (0, 0, 20406, 20406),
         16#8C#           =>  --  01008C
          (0, 0, 20407, 20407),
         16#8D#           =>  --  01008D
          (0, 0, 20408, 20408),
         16#8E#           =>  --  01008E
          (0, 0, 20409, 20409),
         16#8F#           =>  --  01008F
          (0, 0, 20410, 20410),
         16#90#           =>  --  010090
          (0, 0, 20411, 20411),
         16#91#           =>  --  010091
          (0, 0, 20412, 20412),
         16#92#           =>  --  010092
          (0, 0, 20413, 20413),
         16#93#           =>  --  010093
          (0, 0, 20414, 20414),
         16#94#           =>  --  010094
          (0, 0, 20415, 20415),
         16#95#           =>  --  010095
          (0, 0, 20416, 20416),
         16#96#           =>  --  010096
          (0, 0, 20417, 20417),
         16#97#           =>  --  010097
          (0, 0, 20418, 20418),
         16#98#           =>  --  010098
          (0, 0, 20419, 20419),
         16#99#           =>  --  010099
          (0, 0, 20420, 20420),
         16#9A#           =>  --  01009A
          (0, 0, 20421, 20421),
         16#9B#           =>  --  01009B
          (0, 0, 20422, 20422),
         16#9C#           =>  --  01009C
          (0, 0, 20423, 20423),
         16#9D#           =>  --  01009D
          (0, 0, 20424, 20424),
         16#9E#           =>  --  01009E
          (0, 0, 20425, 20425),
         16#9F#           =>  --  01009F
          (0, 0, 20426, 20426),
         16#A0#           =>  --  0100A0
          (0, 0, 20427, 20427),
         16#A1#           =>  --  0100A1
          (0, 0, 20428, 20428),
         16#A2#           =>  --  0100A2
          (0, 0, 20429, 20429),
         16#A3#           =>  --  0100A3
          (0, 0, 20430, 20430),
         16#A4#           =>  --  0100A4
          (0, 0, 20431, 20431),
         16#A5#           =>  --  0100A5
          (0, 0, 20432, 20432),
         16#A6#           =>  --  0100A6
          (0, 0, 20433, 20433),
         16#A7#           =>  --  0100A7
          (0, 0, 20434, 20434),
         16#A8#           =>  --  0100A8
          (0, 0, 20435, 20435),
         16#A9#           =>  --  0100A9
          (0, 0, 20436, 20436),
         16#AA#           =>  --  0100AA
          (0, 0, 20437, 20437),
         16#AB#           =>  --  0100AB
          (0, 0, 20438, 20438),
         16#AC#           =>  --  0100AC
          (0, 0, 20439, 20439),
         16#AD#           =>  --  0100AD
          (0, 0, 20440, 20440),
         16#AE#           =>  --  0100AE
          (0, 0, 20441, 20441),
         16#AF#           =>  --  0100AF
          (0, 0, 20442, 20442),
         16#B0#           =>  --  0100B0
          (0, 0, 20443, 20443),
         16#B1#           =>  --  0100B1
          (0, 0, 20444, 20444),
         16#B2#           =>  --  0100B2
          (0, 0, 20445, 20445),
         16#B3#           =>  --  0100B3
          (0, 0, 20446, 20446),
         16#B4#           =>  --  0100B4
          (0, 0, 20447, 20447),
         16#B5#           =>  --  0100B5
          (0, 0, 20448, 20448),
         16#B6#           =>  --  0100B6
          (0, 0, 20449, 20449),
         16#B7#           =>  --  0100B7
          (0, 0, 20450, 20450),
         16#B8#           =>  --  0100B8
          (0, 0, 20451, 20451),
         16#B9#           =>  --  0100B9
          (0, 0, 20452, 20452),
         16#BA#           =>  --  0100BA
          (0, 0, 20453, 20453),
         16#BB#           =>  --  0100BB
          (0, 0, 20454, 20454),
         16#BC#           =>  --  0100BC
          (0, 0, 20455, 20455),
         16#BD#           =>  --  0100BD
          (0, 0, 20456, 20456),
         16#BE#           =>  --  0100BE
          (0, 0, 20457, 20457),
         16#BF#           =>  --  0100BF
          (0, 0, 20458, 20458),
         16#C0#           =>  --  0100C0
          (0, 0, 20459, 20459),
         16#C1#           =>  --  0100C1
          (0, 0, 20460, 20460),
         16#C2#           =>  --  0100C2
          (0, 0, 20461, 20461),
         16#C3#           =>  --  0100C3
          (0, 0, 20462, 20462),
         16#C4#           =>  --  0100C4
          (0, 0, 20463, 20463),
         16#C5#           =>  --  0100C5
          (0, 0, 20464, 20464),
         16#C6#           =>  --  0100C6
          (0, 0, 20465, 20465),
         16#C7#           =>  --  0100C7
          (0, 0, 20466, 20466),
         16#C8#           =>  --  0100C8
          (0, 0, 20467, 20467),
         16#C9#           =>  --  0100C9
          (0, 0, 20468, 20468),
         16#CA#           =>  --  0100CA
          (0, 0, 20469, 20469),
         16#CB#           =>  --  0100CB
          (0, 0, 20470, 20470),
         16#CC#           =>  --  0100CC
          (0, 0, 20471, 20471),
         16#CD#           =>  --  0100CD
          (0, 0, 20472, 20472),
         16#CE#           =>  --  0100CE
          (0, 0, 20473, 20473),
         16#CF#           =>  --  0100CF
          (0, 0, 20474, 20474),
         16#D0#           =>  --  0100D0
          (0, 0, 20475, 20475),
         16#D1#           =>  --  0100D1
          (0, 0, 20476, 20476),
         16#D2#           =>  --  0100D2
          (0, 0, 20477, 20477),
         16#D3#           =>  --  0100D3
          (0, 0, 20478, 20478),
         16#D4#           =>  --  0100D4
          (0, 0, 20479, 20479),
         16#D5#           =>  --  0100D5
          (0, 0, 20480, 20480),
         16#D6#           =>  --  0100D6
          (0, 0, 20481, 20481),
         16#D7#           =>  --  0100D7
          (0, 0, 20482, 20482),
         16#D8#           =>  --  0100D8
          (0, 0, 20483, 20483),
         16#D9#           =>  --  0100D9
          (0, 0, 20484, 20484),
         16#DA#           =>  --  0100DA
          (0, 0, 20485, 20485),
         16#DB#           =>  --  0100DB
          (0, 0, 20486, 20486),
         16#DC#           =>  --  0100DC
          (0, 0, 20487, 20487),
         16#DD#           =>  --  0100DD
          (0, 0, 20488, 20488),
         16#DE#           =>  --  0100DE
          (0, 0, 20489, 20489),
         16#DF#           =>  --  0100DF
          (0, 0, 20490, 20490),
         16#E0#           =>  --  0100E0
          (0, 0, 20491, 20491),
         16#E1#           =>  --  0100E1
          (0, 0, 20492, 20492),
         16#E2#           =>  --  0100E2
          (0, 0, 20493, 20493),
         16#E3#           =>  --  0100E3
          (0, 0, 20494, 20494),
         16#E4#           =>  --  0100E4
          (0, 0, 20495, 20495),
         16#E5#           =>  --  0100E5
          (0, 0, 20496, 20496),
         16#E6#           =>  --  0100E6
          (0, 0, 20497, 20497),
         16#E7#           =>  --  0100E7
          (0, 0, 20498, 20498),
         16#E8#           =>  --  0100E8
          (0, 0, 20499, 20499),
         16#E9#           =>  --  0100E9
          (0, 0, 20500, 20500),
         16#EA#           =>  --  0100EA
          (0, 0, 20501, 20501),
         16#EB#           =>  --  0100EB
          (0, 0, 20502, 20502),
         16#EC#           =>  --  0100EC
          (0, 0, 20503, 20503),
         16#ED#           =>  --  0100ED
          (0, 0, 20504, 20504),
         16#EE#           =>  --  0100EE
          (0, 0, 20505, 20505),
         16#EF#           =>  --  0100EF
          (0, 0, 20506, 20506),
         16#F0#           =>  --  0100F0
          (0, 0, 20507, 20507),
         16#F1#           =>  --  0100F1
          (0, 0, 20508, 20508),
         16#F2#           =>  --  0100F2
          (0, 0, 20509, 20509),
         16#F3#           =>  --  0100F3
          (0, 0, 20510, 20510),
         16#F4#           =>  --  0100F4
          (0, 0, 20511, 20511),
         16#F5#           =>  --  0100F5
          (0, 0, 20512, 20512),
         16#F6#           =>  --  0100F6
          (0, 0, 20513, 20513),
         16#F7#           =>  --  0100F7
          (0, 0, 20514, 20514),
         16#F8#           =>  --  0100F8
          (0, 0, 20515, 20515),
         16#F9#           =>  --  0100F9
          (0, 0, 20516, 20516),
         16#FA#           =>  --  0100FA
          (0, 0, 20517, 20517),
         others           =>
          (0, 0, 0, 0));

   Group_0101 : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  010100
          (0, 0, 20518, 20518),
         16#01#           =>  --  010101
          (0, 0, 20519, 20519),
         16#02#           =>  --  010102
          (0, 0, 20520, 20520),
         16#07#           =>  --  010107
          (0, 0, 24, 24),
         16#08#           =>  --  010108
          (0, 0, 25, 25),
         16#09#           =>  --  010109
          (0, 0, 26, 26),
         16#0A#           =>  --  01010A
          (0, 0, 27, 27),
         16#0B#           =>  --  01010B
          (0, 0, 28, 28),
         16#0C#           =>  --  01010C
          (0, 0, 29, 29),
         16#0D#           =>  --  01010D
          (0, 0, 30, 30),
         16#0E#           =>  --  01010E
          (0, 0, 31, 31),
         16#0F#           =>  --  01010F
          (0, 0, 32, 32),
         16#10#           =>  --  010110
          (0, 0, 20521, 20521),
         16#11#           =>  --  010111
          (0, 0, 20522, 20522),
         16#12#           =>  --  010112
          (0, 0, 20523, 20523),
         16#13#           =>  --  010113
          (0, 0, 20524, 20524),
         16#14#           =>  --  010114
          (0, 0, 20525, 20525),
         16#15#           =>  --  010115
          (0, 0, 20526, 20526),
         16#16#           =>  --  010116
          (0, 0, 20527, 20527),
         16#17#           =>  --  010117
          (0, 0, 20528, 20528),
         16#18#           =>  --  010118
          (0, 0, 20529, 20529),
         16#19#           =>  --  010119
          (0, 0, 20530, 20530),
         16#1A#           =>  --  01011A
          (0, 0, 20531, 20531),
         16#1B#           =>  --  01011B
          (0, 0, 20532, 20532),
         16#1C#           =>  --  01011C
          (0, 0, 20533, 20533),
         16#1D#           =>  --  01011D
          (0, 0, 20534, 20534),
         16#1E#           =>  --  01011E
          (0, 0, 20535, 20535),
         16#1F#           =>  --  01011F
          (0, 0, 20536, 20536),
         16#20#           =>  --  010120
          (0, 0, 20537, 20537),
         16#21#           =>  --  010121
          (0, 0, 20538, 20538),
         16#22#           =>  --  010122
          (0, 0, 20539, 20539),
         16#23#           =>  --  010123
          (0, 0, 20540, 20540),
         16#24#           =>  --  010124
          (0, 0, 20541, 20541),
         16#25#           =>  --  010125
          (0, 0, 20542, 20542),
         16#26#           =>  --  010126
          (0, 0, 20543, 20543),
         16#27#           =>  --  010127
          (0, 0, 20544, 20544),
         16#28#           =>  --  010128
          (0, 0, 20545, 20545),
         16#29#           =>  --  010129
          (0, 0, 20546, 20546),
         16#2A#           =>  --  01012A
          (0, 0, 20547, 20547),
         16#2B#           =>  --  01012B
          (0, 0, 20548, 20548),
         16#2C#           =>  --  01012C
          (0, 0, 20549, 20549),
         16#2D#           =>  --  01012D
          (0, 0, 20550, 20550),
         16#2E#           =>  --  01012E
          (0, 0, 20551, 20551),
         16#2F#           =>  --  01012F
          (0, 0, 20552, 20552),
         16#30#           =>  --  010130
          (0, 0, 20553, 20553),
         16#31#           =>  --  010131
          (0, 0, 20554, 20554),
         16#32#           =>  --  010132
          (0, 0, 20555, 20555),
         16#33#           =>  --  010133
          (0, 0, 20556, 20556),
         16#37#           =>  --  010137
          (0, 0, 20557, 20557),
         16#38#           =>  --  010138
          (0, 0, 20558, 20558),
         16#39#           =>  --  010139
          (0, 0, 20559, 20559),
         16#3A#           =>  --  01013A
          (0, 0, 20560, 20560),
         16#3B#           =>  --  01013B
          (0, 0, 20561, 20561),
         16#3C#           =>  --  01013C
          (0, 0, 20562, 20562),
         16#3D#           =>  --  01013D
          (0, 0, 20563, 20563),
         16#3E#           =>  --  01013E
          (0, 0, 20564, 20564),
         16#3F#           =>  --  01013F
          (0, 0, 20565, 20565),
         16#40#           =>  --  010140
          (0, 0, 20566, 20566),
         16#41#           =>  --  010141
          (0, 0, 20567, 20567),
         16#42#           =>  --  010142
          (0, 0, 24, 24),
         16#43#           =>  --  010143
          (0, 0, 28, 28),
         16#44#           =>  --  010144
          (0, 0, 20568, 20568),
         16#45#           =>  --  010145
          (0, 0, 20569, 20569),
         16#46#           =>  --  010146
          (0, 0, 20570, 20570),
         16#47#           =>  --  010147
          (0, 0, 20571, 20571),
         16#48#           =>  --  010148
          (0, 0, 28, 28),
         16#49#           =>  --  010149
          (0, 0, 20572, 20572),
         16#4A#           =>  --  01014A
          (0, 0, 20573, 20573),
         16#4B#           =>  --  01014B
          (0, 0, 20574, 20574),
         16#4C#           =>  --  01014C
          (0, 0, 20575, 20575),
         16#4D#           =>  --  01014D
          (0, 0, 20576, 20576),
         16#4E#           =>  --  01014E
          (0, 0, 20577, 20577),
         16#4F#           =>  --  01014F
          (0, 0, 28, 28),
         16#50#           =>  --  010150
          (0, 0, 20578, 20578),
         16#51#           =>  --  010151
          (0, 0, 20579, 20579),
         16#52#           =>  --  010152
          (0, 0, 20580, 20580),
         16#53#           =>  --  010153
          (0, 0, 20581, 20581),
         16#54#           =>  --  010154
          (0, 0, 20582, 20582),
         16#55#           =>  --  010155
          (0, 0, 20583, 20583),
         16#56#           =>  --  010156
          (0, 0, 20584, 20584),
         16#57#           =>  --  010157
          (0, 0, 20585, 20585),
         16#58# .. 16#5A# =>  --  010158 .. 01015A
          (0, 0, 24, 24),
         16#5B# .. 16#5E# =>  --  01015B .. 01015E
          (0, 0, 25, 25),
         16#5F#           =>  --  01015F
          (0, 0, 28, 28),
         16#60#           =>  --  010160
          (0, 0, 20586, 20586),
         16#61#           =>  --  010161
          (0, 0, 20587, 20587),
         16#62#           =>  --  010162
          (0, 0, 20588, 20588),
         16#63#           =>  --  010163
          (0, 0, 20589, 20589),
         16#64#           =>  --  010164
          (0, 0, 20590, 20590),
         16#65#           =>  --  010165
          (0, 0, 20591, 20591),
         16#66#           =>  --  010166
          (0, 0, 20592, 20592),
         16#67#           =>  --  010167
          (0, 0, 20593, 20593),
         16#68#           =>  --  010168
          (0, 0, 20594, 20594),
         16#69#           =>  --  010169
          (0, 0, 20595, 20595),
         16#6A#           =>  --  01016A
          (0, 0, 20596, 20596),
         16#6B#           =>  --  01016B
          (0, 0, 20597, 20597),
         16#6C#           =>  --  01016C
          (0, 0, 20598, 20598),
         16#6D#           =>  --  01016D
          (0, 0, 20599, 20599),
         16#6E#           =>  --  01016E
          (0, 0, 20600, 20600),
         16#6F#           =>  --  01016F
          (0, 0, 20601, 20601),
         16#70#           =>  --  010170
          (0, 0, 20602, 20602),
         16#71#           =>  --  010171
          (0, 0, 20603, 20603),
         16#72#           =>  --  010172
          (0, 0, 20604, 20604),
         16#73#           =>  --  010173
          (0, 0, 28, 28),
         16#74#           =>  --  010174
          (0, 0, 20605, 20605),
         16#75#           =>  --  010175
          (0, 0, 20606, 20606),
         16#76#           =>  --  010176
          (0, 0, 20607, 20607),
         16#77#           =>  --  010177
          (0, 0, 20608, 20608),
         16#78#           =>  --  010178
          (0, 0, 20609, 20609),
         16#79#           =>  --  010179
          (0, 0, 20610, 20610),
         16#7A#           =>  --  01017A
          (0, 0, 20611, 20611),
         16#7B#           =>  --  01017B
          (0, 0, 20612, 20612),
         16#7C#           =>  --  01017C
          (0, 0, 20613, 20613),
         16#7D#           =>  --  01017D
          (0, 0, 20614, 20614),
         16#7E#           =>  --  01017E
          (0, 0, 20615, 20615),
         16#7F#           =>  --  01017F
          (0, 0, 20616, 20616),
         16#80#           =>  --  010180
          (0, 0, 20617, 20617),
         16#81#           =>  --  010181
          (0, 0, 20618, 20618),
         16#82#           =>  --  010182
          (0, 0, 20619, 20619),
         16#83#           =>  --  010183
          (0, 0, 20620, 20620),
         16#84#           =>  --  010184
          (0, 0, 20621, 20621),
         16#85#           =>  --  010185
          (0, 0, 20622, 20622),
         16#86#           =>  --  010186
          (0, 0, 20623, 20623),
         16#87#           =>  --  010187
          (0, 0, 20624, 20624),
         16#88#           =>  --  010188
          (0, 0, 20625, 20625),
         16#89#           =>  --  010189
          (0, 0, 20626, 20626),
         16#8A#           =>  --  01018A
          (0, 0, 23, 23),
         16#8B#           =>  --  01018B
          (0, 0, 20627, 20627),
         16#8C#           =>  --  01018C
          (0, 0, 20628, 20628),
         16#90#           =>  --  010190
          (0, 0, 20629, 20629),
         16#91#           =>  --  010191
          (0, 0, 20630, 20630),
         16#92#           =>  --  010192
          (0, 0, 20631, 20631),
         16#93#           =>  --  010193
          (0, 0, 20632, 20632),
         16#94#           =>  --  010194
          (0, 0, 20633, 20633),
         16#95#           =>  --  010195
          (0, 0, 20634, 20634),
         16#96#           =>  --  010196
          (0, 0, 20635, 20635),
         16#97#           =>  --  010197
          (0, 0, 20636, 20636),
         16#98#           =>  --  010198
          (0, 0, 20637, 20637),
         16#99#           =>  --  010199
          (0, 0, 20638, 20638),
         16#9A#           =>  --  01019A
          (0, 0, 20639, 20639),
         16#9B#           =>  --  01019B
          (0, 0, 20640, 20640),
         16#A0#           =>  --  0101A0
          (0, 0, 20641, 20641),
         16#D0#           =>  --  0101D0
          (0, 0, 20642, 20642),
         16#D1#           =>  --  0101D1
          (0, 0, 20643, 20643),
         16#D2#           =>  --  0101D2
          (0, 0, 20644, 20644),
         16#D3#           =>  --  0101D3
          (0, 0, 20645, 20645),
         16#D4#           =>  --  0101D4
          (0, 0, 20646, 20646),
         16#D5#           =>  --  0101D5
          (0, 0, 20647, 20647),
         16#D6#           =>  --  0101D6
          (0, 0, 20648, 20648),
         16#D7#           =>  --  0101D7
          (0, 0, 20649, 20649),
         16#D8#           =>  --  0101D8
          (0, 0, 20650, 20650),
         16#D9#           =>  --  0101D9
          (0, 0, 20651, 20651),
         16#DA#           =>  --  0101DA
          (0, 0, 20652, 20652),
         16#DB#           =>  --  0101DB
          (0, 0, 20653, 20653),
         16#DC#           =>  --  0101DC
          (0, 0, 20654, 20654),
         16#DD#           =>  --  0101DD
          (0, 0, 20655, 20655),
         16#DE#           =>  --  0101DE
          (0, 0, 20656, 20656),
         16#DF#           =>  --  0101DF
          (0, 0, 20657, 20657),
         16#E0#           =>  --  0101E0
          (0, 0, 20658, 20658),
         16#E1#           =>  --  0101E1
          (0, 0, 20659, 20659),
         16#E2#           =>  --  0101E2
          (0, 0, 20660, 20660),
         16#E3#           =>  --  0101E3
          (0, 0, 20661, 20661),
         16#E4#           =>  --  0101E4
          (0, 0, 20662, 20662),
         16#E5#           =>  --  0101E5
          (0, 0, 20663, 20663),
         16#E6#           =>  --  0101E6
          (0, 0, 20664, 20664),
         16#E7#           =>  --  0101E7
          (0, 0, 20665, 20665),
         16#E8#           =>  --  0101E8
          (0, 0, 20666, 20666),
         16#E9#           =>  --  0101E9
          (0, 0, 20667, 20667),
         16#EA#           =>  --  0101EA
          (0, 0, 20668, 20668),
         16#EB#           =>  --  0101EB
          (0, 0, 20669, 20669),
         16#EC#           =>  --  0101EC
          (0, 0, 20670, 20670),
         16#ED#           =>  --  0101ED
          (0, 0, 20671, 20671),
         16#EE#           =>  --  0101EE
          (0, 0, 20672, 20672),
         16#EF#           =>  --  0101EF
          (0, 0, 20673, 20673),
         16#F0#           =>  --  0101F0
          (0, 0, 20674, 20674),
         16#F1#           =>  --  0101F1
          (0, 0, 20675, 20675),
         16#F2#           =>  --  0101F2
          (0, 0, 20676, 20676),
         16#F3#           =>  --  0101F3
          (0, 0, 20677, 20677),
         16#F4#           =>  --  0101F4
          (0, 0, 20678, 20678),
         16#F5#           =>  --  0101F5
          (0, 0, 20679, 20679),
         16#F6#           =>  --  0101F6
          (0, 0, 20680, 20680),
         16#F7#           =>  --  0101F7
          (0, 0, 20681, 20681),
         16#F8#           =>  --  0101F8
          (0, 0, 20682, 20682),
         16#F9#           =>  --  0101F9
          (0, 0, 20683, 20683),
         16#FA#           =>  --  0101FA
          (0, 0, 20684, 20684),
         16#FB#           =>  --  0101FB
          (0, 0, 20685, 20685),
         16#FC#           =>  --  0101FC
          (0, 0, 20686, 20686),
         16#FD#           =>  --  0101FD
          (0, 0, 20687, 20687),
         others           =>
          (0, 0, 0, 0));

   Group_0102 : aliased constant Collation_Second_Stage
     := (16#80#           =>  --  010280
          (0, 0, 20688, 20688),
         16#81#           =>  --  010281
          (0, 0, 20689, 20689),
         16#82#           =>  --  010282
          (0, 0, 20690, 20690),
         16#83#           =>  --  010283
          (0, 0, 20691, 20691),
         16#84#           =>  --  010284
          (0, 0, 20692, 20692),
         16#85#           =>  --  010285
          (0, 0, 20693, 20693),
         16#86#           =>  --  010286
          (0, 0, 20694, 20694),
         16#87#           =>  --  010287
          (0, 0, 20695, 20695),
         16#88#           =>  --  010288
          (0, 0, 20696, 20696),
         16#89#           =>  --  010289
          (0, 0, 20697, 20697),
         16#8A#           =>  --  01028A
          (0, 0, 20698, 20698),
         16#8B#           =>  --  01028B
          (0, 0, 20699, 20699),
         16#8C#           =>  --  01028C
          (0, 0, 20700, 20700),
         16#8D#           =>  --  01028D
          (0, 0, 20701, 20701),
         16#8E#           =>  --  01028E
          (0, 0, 20702, 20702),
         16#8F#           =>  --  01028F
          (0, 0, 20703, 20703),
         16#90#           =>  --  010290
          (0, 0, 20704, 20704),
         16#91#           =>  --  010291
          (0, 0, 20705, 20705),
         16#92#           =>  --  010292
          (0, 0, 20706, 20706),
         16#93#           =>  --  010293
          (0, 0, 20707, 20707),
         16#94#           =>  --  010294
          (0, 0, 20708, 20708),
         16#95#           =>  --  010295
          (0, 0, 20709, 20709),
         16#96#           =>  --  010296
          (0, 0, 20710, 20710),
         16#97#           =>  --  010297
          (0, 0, 20711, 20711),
         16#98#           =>  --  010298
          (0, 0, 20712, 20712),
         16#99#           =>  --  010299
          (0, 0, 20713, 20713),
         16#9A#           =>  --  01029A
          (0, 0, 20714, 20714),
         16#9B#           =>  --  01029B
          (0, 0, 20715, 20715),
         16#9C#           =>  --  01029C
          (0, 0, 20716, 20716),
         16#A0#           =>  --  0102A0
          (0, 0, 20717, 20717),
         16#A1#           =>  --  0102A1
          (0, 0, 20718, 20718),
         16#A2#           =>  --  0102A2
          (0, 0, 20719, 20719),
         16#A3#           =>  --  0102A3
          (0, 0, 20720, 20720),
         16#A4#           =>  --  0102A4
          (0, 0, 20721, 20721),
         16#A5#           =>  --  0102A5
          (0, 0, 20722, 20722),
         16#A6#           =>  --  0102A6
          (0, 0, 20723, 20723),
         16#A7#           =>  --  0102A7
          (0, 0, 20724, 20724),
         16#A8#           =>  --  0102A8
          (0, 0, 20725, 20725),
         16#A9#           =>  --  0102A9
          (0, 0, 20726, 20726),
         16#AA#           =>  --  0102AA
          (0, 0, 20727, 20727),
         16#AB#           =>  --  0102AB
          (0, 0, 20728, 20728),
         16#AC#           =>  --  0102AC
          (0, 0, 20729, 20729),
         16#AD#           =>  --  0102AD
          (0, 0, 20730, 20730),
         16#AE#           =>  --  0102AE
          (0, 0, 20731, 20731),
         16#AF#           =>  --  0102AF
          (0, 0, 20732, 20732),
         16#B0#           =>  --  0102B0
          (0, 0, 20733, 20733),
         16#B1#           =>  --  0102B1
          (0, 0, 20734, 20734),
         16#B2#           =>  --  0102B2
          (0, 0, 20735, 20735),
         16#B3#           =>  --  0102B3
          (0, 0, 20736, 20736),
         16#B4#           =>  --  0102B4
          (0, 0, 20737, 20737),
         16#B5#           =>  --  0102B5
          (0, 0, 20738, 20738),
         16#B6#           =>  --  0102B6
          (0, 0, 20739, 20739),
         16#B7#           =>  --  0102B7
          (0, 0, 20740, 20740),
         16#B8#           =>  --  0102B8
          (0, 0, 20741, 20741),
         16#B9#           =>  --  0102B9
          (0, 0, 20742, 20742),
         16#BA#           =>  --  0102BA
          (0, 0, 20743, 20743),
         16#BB#           =>  --  0102BB
          (0, 0, 20744, 20744),
         16#BC#           =>  --  0102BC
          (0, 0, 20745, 20745),
         16#BD#           =>  --  0102BD
          (0, 0, 20746, 20746),
         16#BE#           =>  --  0102BE
          (0, 0, 20747, 20747),
         16#BF#           =>  --  0102BF
          (0, 0, 20748, 20748),
         16#C0#           =>  --  0102C0
          (0, 0, 20749, 20749),
         16#C1#           =>  --  0102C1
          (0, 0, 20750, 20750),
         16#C2#           =>  --  0102C2
          (0, 0, 20751, 20751),
         16#C3#           =>  --  0102C3
          (0, 0, 20752, 20752),
         16#C4#           =>  --  0102C4
          (0, 0, 20753, 20753),
         16#C5#           =>  --  0102C5
          (0, 0, 20754, 20754),
         16#C6#           =>  --  0102C6
          (0, 0, 20755, 20755),
         16#C7#           =>  --  0102C7
          (0, 0, 20756, 20756),
         16#C8#           =>  --  0102C8
          (0, 0, 20757, 20757),
         16#C9#           =>  --  0102C9
          (0, 0, 20758, 20758),
         16#CA#           =>  --  0102CA
          (0, 0, 20759, 20759),
         16#CB#           =>  --  0102CB
          (0, 0, 20760, 20760),
         16#CC#           =>  --  0102CC
          (0, 0, 20761, 20761),
         16#CD#           =>  --  0102CD
          (0, 0, 20762, 20762),
         16#CE#           =>  --  0102CE
          (0, 0, 20763, 20763),
         16#CF#           =>  --  0102CF
          (0, 0, 20764, 20764),
         16#D0#           =>  --  0102D0
          (0, 0, 20765, 20765),
         16#E0#           =>  --  0102E0
          (0, 0, 1, 1),
         16#E1#           =>  --  0102E1
          (0, 0, 24, 24),
         16#E2#           =>  --  0102E2
          (0, 0, 25, 25),
         16#E3#           =>  --  0102E3
          (0, 0, 26, 26),
         16#E4#           =>  --  0102E4
          (0, 0, 27, 27),
         16#E5#           =>  --  0102E5
          (0, 0, 28, 28),
         16#E6#           =>  --  0102E6
          (0, 0, 29, 29),
         16#E7#           =>  --  0102E7
          (0, 0, 30, 30),
         16#E8#           =>  --  0102E8
          (0, 0, 31, 31),
         16#E9#           =>  --  0102E9
          (0, 0, 32, 32),
         16#EA#           =>  --  0102EA
          (0, 0, 20766, 20766),
         16#EB#           =>  --  0102EB
          (0, 0, 20767, 20767),
         16#EC#           =>  --  0102EC
          (0, 0, 20768, 20768),
         16#ED#           =>  --  0102ED
          (0, 0, 20769, 20769),
         16#EE#           =>  --  0102EE
          (0, 0, 20770, 20770),
         16#EF#           =>  --  0102EF
          (0, 0, 20771, 20771),
         16#F0#           =>  --  0102F0
          (0, 0, 20772, 20772),
         16#F1#           =>  --  0102F1
          (0, 0, 20773, 20773),
         16#F2#           =>  --  0102F2
          (0, 0, 20774, 20774),
         16#F3#           =>  --  0102F3
          (0, 0, 20775, 20775),
         16#F4#           =>  --  0102F4
          (0, 0, 20776, 20776),
         16#F5#           =>  --  0102F5
          (0, 0, 20777, 20777),
         16#F6#           =>  --  0102F6
          (0, 0, 20778, 20778),
         16#F7#           =>  --  0102F7
          (0, 0, 20779, 20779),
         16#F8#           =>  --  0102F8
          (0, 0, 20780, 20780),
         16#F9#           =>  --  0102F9
          (0, 0, 20781, 20781),
         16#FA#           =>  --  0102FA
          (0, 0, 20782, 20782),
         16#FB#           =>  --  0102FB
          (0, 0, 20783, 20783),
         others           =>
          (0, 0, 0, 0));

   Group_0103 : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  010300
          (0, 0, 20784, 20784),
         16#01#           =>  --  010301
          (0, 0, 20785, 20785),
         16#02#           =>  --  010302
          (0, 0, 20786, 20786),
         16#03#           =>  --  010303
          (0, 0, 20787, 20787),
         16#04#           =>  --  010304
          (0, 0, 20788, 20788),
         16#05#           =>  --  010305
          (0, 0, 20789, 20789),
         16#06#           =>  --  010306
          (0, 0, 20790, 20790),
         16#07#           =>  --  010307
          (0, 0, 20791, 20791),
         16#08#           =>  --  010308
          (0, 0, 20792, 20792),
         16#09#           =>  --  010309
          (0, 0, 20793, 20793),
         16#0A#           =>  --  01030A
          (0, 0, 20794, 20794),
         16#0B#           =>  --  01030B
          (0, 0, 20795, 20795),
         16#0C#           =>  --  01030C
          (0, 0, 20796, 20796),
         16#0D#           =>  --  01030D
          (0, 0, 20797, 20797),
         16#0E#           =>  --  01030E
          (0, 0, 20798, 20798),
         16#0F#           =>  --  01030F
          (0, 0, 20799, 20799),
         16#10#           =>  --  010310
          (0, 0, 20800, 20800),
         16#11#           =>  --  010311
          (0, 0, 20801, 20801),
         16#12#           =>  --  010312
          (0, 0, 20802, 20802),
         16#13#           =>  --  010313
          (0, 0, 20803, 20803),
         16#14#           =>  --  010314
          (0, 0, 20804, 20804),
         16#15#           =>  --  010315
          (0, 0, 20805, 20805),
         16#16#           =>  --  010316
          (0, 0, 20806, 20806),
         16#17#           =>  --  010317
          (0, 0, 20807, 20807),
         16#18#           =>  --  010318
          (0, 0, 20808, 20808),
         16#19#           =>  --  010319
          (0, 0, 20809, 20809),
         16#1A#           =>  --  01031A
          (0, 0, 20810, 20810),
         16#1B#           =>  --  01031B
          (0, 0, 20811, 20811),
         16#1C#           =>  --  01031C
          (0, 0, 20812, 20812),
         16#1D#           =>  --  01031D
          (0, 0, 20813, 20813),
         16#1E#           =>  --  01031E
          (0, 0, 20814, 20814),
         16#1F#           =>  --  01031F
          (0, 0, 20815, 20815),
         16#20#           =>  --  010320
          (0, 0, 24, 24),
         16#21#           =>  --  010321
          (0, 0, 28, 28),
         16#22#           =>  --  010322
          (0, 0, 20816, 20816),
         16#23#           =>  --  010323
          (0, 0, 20817, 20817),
         16#30#           =>  --  010330
          (0, 0, 20818, 20818),
         16#31#           =>  --  010331
          (0, 0, 20819, 20819),
         16#32#           =>  --  010332
          (0, 0, 20820, 20820),
         16#33#           =>  --  010333
          (0, 0, 20821, 20821),
         16#34#           =>  --  010334
          (0, 0, 20822, 20822),
         16#35#           =>  --  010335
          (0, 0, 20823, 20823),
         16#36#           =>  --  010336
          (0, 0, 20824, 20824),
         16#37#           =>  --  010337
          (0, 0, 20825, 20825),
         16#38#           =>  --  010338
          (0, 0, 20826, 20826),
         16#39#           =>  --  010339
          (0, 0, 20827, 20827),
         16#3A#           =>  --  01033A
          (0, 0, 20828, 20828),
         16#3B#           =>  --  01033B
          (0, 0, 20829, 20829),
         16#3C#           =>  --  01033C
          (0, 0, 20830, 20830),
         16#3D#           =>  --  01033D
          (0, 0, 20831, 20831),
         16#3E#           =>  --  01033E
          (0, 0, 20832, 20832),
         16#3F#           =>  --  01033F
          (0, 0, 20833, 20833),
         16#40#           =>  --  010340
          (0, 0, 20834, 20834),
         16#41#           =>  --  010341
          (0, 0, 20835, 20835),
         16#42#           =>  --  010342
          (0, 0, 20836, 20836),
         16#43#           =>  --  010343
          (0, 0, 20837, 20837),
         16#44#           =>  --  010344
          (0, 0, 20838, 20838),
         16#45#           =>  --  010345
          (0, 0, 20839, 20839),
         16#46#           =>  --  010346
          (0, 0, 20840, 20840),
         16#47#           =>  --  010347
          (0, 0, 20841, 20841),
         16#48#           =>  --  010348
          (0, 0, 20842, 20842),
         16#49#           =>  --  010349
          (0, 0, 20843, 20843),
         16#4A#           =>  --  01034A
          (0, 0, 20844, 20844),
         16#50#           =>  --  010350
          (0, 0, 20845, 20845),
         16#51#           =>  --  010351
          (0, 0, 20846, 20846),
         16#52#           =>  --  010352
          (0, 0, 20847, 20847),
         16#53#           =>  --  010353
          (0, 0, 20848, 20848),
         16#54#           =>  --  010354
          (0, 0, 20849, 20849),
         16#55#           =>  --  010355
          (0, 0, 20850, 20850),
         16#56#           =>  --  010356
          (0, 0, 20851, 20851),
         16#57#           =>  --  010357
          (0, 0, 20852, 20852),
         16#58#           =>  --  010358
          (0, 0, 20853, 20853),
         16#59#           =>  --  010359
          (0, 0, 20854, 20854),
         16#5A#           =>  --  01035A
          (0, 0, 20855, 20855),
         16#5B#           =>  --  01035B
          (0, 0, 20856, 20856),
         16#5C#           =>  --  01035C
          (0, 0, 20857, 20857),
         16#5D#           =>  --  01035D
          (0, 0, 20858, 20858),
         16#5E#           =>  --  01035E
          (0, 0, 20859, 20859),
         16#5F#           =>  --  01035F
          (0, 0, 20860, 20860),
         16#60#           =>  --  010360
          (0, 0, 20861, 20861),
         16#61#           =>  --  010361
          (0, 0, 20862, 20862),
         16#62#           =>  --  010362
          (0, 0, 20863, 20863),
         16#63#           =>  --  010363
          (0, 0, 20864, 20864),
         16#64#           =>  --  010364
          (0, 0, 20865, 20865),
         16#65#           =>  --  010365
          (0, 0, 20866, 20866),
         16#66#           =>  --  010366
          (0, 0, 20867, 20867),
         16#67#           =>  --  010367
          (0, 0, 20868, 20868),
         16#68#           =>  --  010368
          (0, 0, 20869, 20869),
         16#69#           =>  --  010369
          (0, 0, 20870, 20870),
         16#6A#           =>  --  01036A
          (0, 0, 20871, 20871),
         16#6B#           =>  --  01036B
          (0, 0, 20872, 20872),
         16#6C#           =>  --  01036C
          (0, 0, 20873, 20873),
         16#6D#           =>  --  01036D
          (0, 0, 20874, 20874),
         16#6E#           =>  --  01036E
          (0, 0, 20875, 20875),
         16#6F#           =>  --  01036F
          (0, 0, 20876, 20876),
         16#70#           =>  --  010370
          (0, 0, 20877, 20877),
         16#71#           =>  --  010371
          (0, 0, 20878, 20878),
         16#72#           =>  --  010372
          (0, 0, 20879, 20879),
         16#73#           =>  --  010373
          (0, 0, 20880, 20880),
         16#74#           =>  --  010374
          (0, 0, 20881, 20881),
         16#75#           =>  --  010375
          (0, 0, 20882, 20882),
         16#76#           =>  --  010376
          (0, 0, 20883, 20883),
         16#77#           =>  --  010377
          (0, 0, 20884, 20884),
         16#78#           =>  --  010378
          (0, 0, 20885, 20885),
         16#79#           =>  --  010379
          (0, 0, 20886, 20886),
         16#7A#           =>  --  01037A
          (0, 0, 20887, 20887),
         16#80#           =>  --  010380
          (0, 0, 20888, 20888),
         16#81#           =>  --  010381
          (0, 0, 20889, 20889),
         16#82#           =>  --  010382
          (0, 0, 20890, 20890),
         16#83#           =>  --  010383
          (0, 0, 20891, 20891),
         16#84#           =>  --  010384
          (0, 0, 20892, 20892),
         16#85#           =>  --  010385
          (0, 0, 20893, 20893),
         16#86#           =>  --  010386
          (0, 0, 20894, 20894),
         16#87#           =>  --  010387
          (0, 0, 20895, 20895),
         16#88#           =>  --  010388
          (0, 0, 20896, 20896),
         16#89#           =>  --  010389
          (0, 0, 20897, 20897),
         16#8A#           =>  --  01038A
          (0, 0, 20898, 20898),
         16#8B#           =>  --  01038B
          (0, 0, 20899, 20899),
         16#8C#           =>  --  01038C
          (0, 0, 20900, 20900),
         16#8D#           =>  --  01038D
          (0, 0, 20901, 20901),
         16#8E#           =>  --  01038E
          (0, 0, 20902, 20902),
         16#8F#           =>  --  01038F
          (0, 0, 20903, 20903),
         16#90#           =>  --  010390
          (0, 0, 20904, 20904),
         16#91#           =>  --  010391
          (0, 0, 20905, 20905),
         16#92#           =>  --  010392
          (0, 0, 20906, 20906),
         16#93#           =>  --  010393
          (0, 0, 20907, 20907),
         16#94#           =>  --  010394
          (0, 0, 20908, 20908),
         16#95#           =>  --  010395
          (0, 0, 20909, 20909),
         16#96#           =>  --  010396
          (0, 0, 20910, 20910),
         16#97#           =>  --  010397
          (0, 0, 20911, 20911),
         16#98#           =>  --  010398
          (0, 0, 20912, 20912),
         16#99#           =>  --  010399
          (0, 0, 20913, 20913),
         16#9A#           =>  --  01039A
          (0, 0, 20914, 20914),
         16#9B#           =>  --  01039B
          (0, 0, 20915, 20915),
         16#9C#           =>  --  01039C
          (0, 0, 20916, 20916),
         16#9D#           =>  --  01039D
          (0, 0, 20917, 20917),
         16#9F#           =>  --  01039F
          (0, 0, 20918, 20918),
         16#A0#           =>  --  0103A0
          (0, 0, 20919, 20919),
         16#A1#           =>  --  0103A1
          (0, 0, 20920, 20920),
         16#A2#           =>  --  0103A2
          (0, 0, 20921, 20921),
         16#A3#           =>  --  0103A3
          (0, 0, 20922, 20922),
         16#A4#           =>  --  0103A4
          (0, 0, 20923, 20923),
         16#A5#           =>  --  0103A5
          (0, 0, 20924, 20924),
         16#A6#           =>  --  0103A6
          (0, 0, 20925, 20925),
         16#A7#           =>  --  0103A7
          (0, 0, 20926, 20926),
         16#A8#           =>  --  0103A8
          (0, 0, 20927, 20927),
         16#A9#           =>  --  0103A9
          (0, 0, 20928, 20928),
         16#AA#           =>  --  0103AA
          (0, 0, 20929, 20929),
         16#AB#           =>  --  0103AB
          (0, 0, 20930, 20930),
         16#AC#           =>  --  0103AC
          (0, 0, 20931, 20931),
         16#AD#           =>  --  0103AD
          (0, 0, 20932, 20932),
         16#AE#           =>  --  0103AE
          (0, 0, 20933, 20933),
         16#AF#           =>  --  0103AF
          (0, 0, 20934, 20934),
         16#B0#           =>  --  0103B0
          (0, 0, 20935, 20935),
         16#B1#           =>  --  0103B1
          (0, 0, 20936, 20936),
         16#B2#           =>  --  0103B2
          (0, 0, 20937, 20937),
         16#B3#           =>  --  0103B3
          (0, 0, 20938, 20938),
         16#B4#           =>  --  0103B4
          (0, 0, 20939, 20939),
         16#B5#           =>  --  0103B5
          (0, 0, 20940, 20940),
         16#B6#           =>  --  0103B6
          (0, 0, 20941, 20941),
         16#B7#           =>  --  0103B7
          (0, 0, 20942, 20942),
         16#B8#           =>  --  0103B8
          (0, 0, 20943, 20943),
         16#B9#           =>  --  0103B9
          (0, 0, 20944, 20944),
         16#BA#           =>  --  0103BA
          (0, 0, 20945, 20945),
         16#BB#           =>  --  0103BB
          (0, 0, 20946, 20946),
         16#BC#           =>  --  0103BC
          (0, 0, 20947, 20947),
         16#BD#           =>  --  0103BD
          (0, 0, 20948, 20948),
         16#BE#           =>  --  0103BE
          (0, 0, 20949, 20949),
         16#BF#           =>  --  0103BF
          (0, 0, 20950, 20950),
         16#C0#           =>  --  0103C0
          (0, 0, 20951, 20951),
         16#C1#           =>  --  0103C1
          (0, 0, 20952, 20952),
         16#C2#           =>  --  0103C2
          (0, 0, 20953, 20953),
         16#C3#           =>  --  0103C3
          (0, 0, 20954, 20954),
         16#C8#           =>  --  0103C8
          (0, 0, 20955, 20955),
         16#C9#           =>  --  0103C9
          (0, 0, 20956, 20956),
         16#CA#           =>  --  0103CA
          (0, 0, 20957, 20957),
         16#CB#           =>  --  0103CB
          (0, 0, 20958, 20958),
         16#CC#           =>  --  0103CC
          (0, 0, 20959, 20959),
         16#CD#           =>  --  0103CD
          (0, 0, 20960, 20960),
         16#CE#           =>  --  0103CE
          (0, 0, 20961, 20961),
         16#CF#           =>  --  0103CF
          (0, 0, 20962, 20962),
         16#D0#           =>  --  0103D0
          (0, 0, 20963, 20963),
         16#D1#           =>  --  0103D1
          (0, 0, 24, 24),
         16#D2#           =>  --  0103D2
          (0, 0, 25, 25),
         16#D3#           =>  --  0103D3
          (0, 0, 20964, 20964),
         16#D4#           =>  --  0103D4
          (0, 0, 20965, 20965),
         16#D5#           =>  --  0103D5
          (0, 0, 20966, 20966),
         others           =>
          (0, 0, 0, 0));

   Group_0104 : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  010400
          (0, 0, 20967, 20967),
         16#01#           =>  --  010401
          (0, 0, 20968, 20968),
         16#02#           =>  --  010402
          (0, 0, 20969, 20969),
         16#03#           =>  --  010403
          (0, 0, 20970, 20970),
         16#04#           =>  --  010404
          (0, 0, 20971, 20971),
         16#05#           =>  --  010405
          (0, 0, 20972, 20972),
         16#06#           =>  --  010406
          (0, 0, 20973, 20973),
         16#07#           =>  --  010407
          (0, 0, 20974, 20974),
         16#08#           =>  --  010408
          (0, 0, 20975, 20975),
         16#09#           =>  --  010409
          (0, 0, 20976, 20976),
         16#0A#           =>  --  01040A
          (0, 0, 20977, 20977),
         16#0B#           =>  --  01040B
          (0, 0, 20978, 20978),
         16#0C#           =>  --  01040C
          (0, 0, 20979, 20979),
         16#0D#           =>  --  01040D
          (0, 0, 20980, 20980),
         16#0E#           =>  --  01040E
          (0, 0, 20981, 20981),
         16#0F#           =>  --  01040F
          (0, 0, 20982, 20982),
         16#10#           =>  --  010410
          (0, 0, 20983, 20983),
         16#11#           =>  --  010411
          (0, 0, 20984, 20984),
         16#12#           =>  --  010412
          (0, 0, 20985, 20985),
         16#13#           =>  --  010413
          (0, 0, 20986, 20986),
         16#14#           =>  --  010414
          (0, 0, 20987, 20987),
         16#15#           =>  --  010415
          (0, 0, 20988, 20988),
         16#16#           =>  --  010416
          (0, 0, 20989, 20989),
         16#17#           =>  --  010417
          (0, 0, 20990, 20990),
         16#18#           =>  --  010418
          (0, 0, 20991, 20991),
         16#19#           =>  --  010419
          (0, 0, 20992, 20992),
         16#1A#           =>  --  01041A
          (0, 0, 20993, 20993),
         16#1B#           =>  --  01041B
          (0, 0, 20994, 20994),
         16#1C#           =>  --  01041C
          (0, 0, 20995, 20995),
         16#1D#           =>  --  01041D
          (0, 0, 20996, 20996),
         16#1E#           =>  --  01041E
          (0, 0, 20997, 20997),
         16#1F#           =>  --  01041F
          (0, 0, 20998, 20998),
         16#20#           =>  --  010420
          (0, 0, 20999, 20999),
         16#21#           =>  --  010421
          (0, 0, 21000, 21000),
         16#22#           =>  --  010422
          (0, 0, 21001, 21001),
         16#23#           =>  --  010423
          (0, 0, 21002, 21002),
         16#24#           =>  --  010424
          (0, 0, 21003, 21003),
         16#25#           =>  --  010425
          (0, 0, 21004, 21004),
         16#26#           =>  --  010426
          (0, 0, 21005, 21005),
         16#27#           =>  --  010427
          (0, 0, 21006, 21006),
         16#28#           =>  --  010428
          (0, 0, 21007, 21007),
         16#29#           =>  --  010429
          (0, 0, 21008, 21008),
         16#2A#           =>  --  01042A
          (0, 0, 21009, 21009),
         16#2B#           =>  --  01042B
          (0, 0, 21010, 21010),
         16#2C#           =>  --  01042C
          (0, 0, 21011, 21011),
         16#2D#           =>  --  01042D
          (0, 0, 21012, 21012),
         16#2E#           =>  --  01042E
          (0, 0, 21013, 21013),
         16#2F#           =>  --  01042F
          (0, 0, 21014, 21014),
         16#30#           =>  --  010430
          (0, 0, 21015, 21015),
         16#31#           =>  --  010431
          (0, 0, 21016, 21016),
         16#32#           =>  --  010432
          (0, 0, 21017, 21017),
         16#33#           =>  --  010433
          (0, 0, 21018, 21018),
         16#34#           =>  --  010434
          (0, 0, 21019, 21019),
         16#35#           =>  --  010435
          (0, 0, 21020, 21020),
         16#36#           =>  --  010436
          (0, 0, 21021, 21021),
         16#37#           =>  --  010437
          (0, 0, 21022, 21022),
         16#38#           =>  --  010438
          (0, 0, 21023, 21023),
         16#39#           =>  --  010439
          (0, 0, 21024, 21024),
         16#3A#           =>  --  01043A
          (0, 0, 21025, 21025),
         16#3B#           =>  --  01043B
          (0, 0, 21026, 21026),
         16#3C#           =>  --  01043C
          (0, 0, 21027, 21027),
         16#3D#           =>  --  01043D
          (0, 0, 21028, 21028),
         16#3E#           =>  --  01043E
          (0, 0, 21029, 21029),
         16#3F#           =>  --  01043F
          (0, 0, 21030, 21030),
         16#40#           =>  --  010440
          (0, 0, 21031, 21031),
         16#41#           =>  --  010441
          (0, 0, 21032, 21032),
         16#42#           =>  --  010442
          (0, 0, 21033, 21033),
         16#43#           =>  --  010443
          (0, 0, 21034, 21034),
         16#44#           =>  --  010444
          (0, 0, 21035, 21035),
         16#45#           =>  --  010445
          (0, 0, 21036, 21036),
         16#46#           =>  --  010446
          (0, 0, 21037, 21037),
         16#47#           =>  --  010447
          (0, 0, 21038, 21038),
         16#48#           =>  --  010448
          (0, 0, 21039, 21039),
         16#49#           =>  --  010449
          (0, 0, 21040, 21040),
         16#4A#           =>  --  01044A
          (0, 0, 21041, 21041),
         16#4B#           =>  --  01044B
          (0, 0, 21042, 21042),
         16#4C#           =>  --  01044C
          (0, 0, 21043, 21043),
         16#4D#           =>  --  01044D
          (0, 0, 21044, 21044),
         16#4E#           =>  --  01044E
          (0, 0, 21045, 21045),
         16#4F#           =>  --  01044F
          (0, 0, 21046, 21046),
         16#50#           =>  --  010450
          (0, 0, 21047, 21047),
         16#51#           =>  --  010451
          (0, 0, 21048, 21048),
         16#52#           =>  --  010452
          (0, 0, 21049, 21049),
         16#53#           =>  --  010453
          (0, 0, 21050, 21050),
         16#54#           =>  --  010454
          (0, 0, 21051, 21051),
         16#55#           =>  --  010455
          (0, 0, 21052, 21052),
         16#56#           =>  --  010456
          (0, 0, 21053, 21053),
         16#57#           =>  --  010457
          (0, 0, 21054, 21054),
         16#58#           =>  --  010458
          (0, 0, 21055, 21055),
         16#59#           =>  --  010459
          (0, 0, 21056, 21056),
         16#5A#           =>  --  01045A
          (0, 0, 21057, 21057),
         16#5B#           =>  --  01045B
          (0, 0, 21058, 21058),
         16#5C#           =>  --  01045C
          (0, 0, 21059, 21059),
         16#5D#           =>  --  01045D
          (0, 0, 21060, 21060),
         16#5E#           =>  --  01045E
          (0, 0, 21061, 21061),
         16#5F#           =>  --  01045F
          (0, 0, 21062, 21062),
         16#60#           =>  --  010460
          (0, 0, 21063, 21063),
         16#61#           =>  --  010461
          (0, 0, 21064, 21064),
         16#62#           =>  --  010462
          (0, 0, 21065, 21065),
         16#63#           =>  --  010463
          (0, 0, 21066, 21066),
         16#64#           =>  --  010464
          (0, 0, 21067, 21067),
         16#65#           =>  --  010465
          (0, 0, 21068, 21068),
         16#66#           =>  --  010466
          (0, 0, 21069, 21069),
         16#67#           =>  --  010467
          (0, 0, 21070, 21070),
         16#68#           =>  --  010468
          (0, 0, 21071, 21071),
         16#69#           =>  --  010469
          (0, 0, 21072, 21072),
         16#6A#           =>  --  01046A
          (0, 0, 21073, 21073),
         16#6B#           =>  --  01046B
          (0, 0, 21074, 21074),
         16#6C#           =>  --  01046C
          (0, 0, 21075, 21075),
         16#6D#           =>  --  01046D
          (0, 0, 21076, 21076),
         16#6E#           =>  --  01046E
          (0, 0, 21077, 21077),
         16#6F#           =>  --  01046F
          (0, 0, 21078, 21078),
         16#70#           =>  --  010470
          (0, 0, 21079, 21079),
         16#71#           =>  --  010471
          (0, 0, 21080, 21080),
         16#72#           =>  --  010472
          (0, 0, 21081, 21081),
         16#73#           =>  --  010473
          (0, 0, 21082, 21082),
         16#74#           =>  --  010474
          (0, 0, 21083, 21083),
         16#75#           =>  --  010475
          (0, 0, 21084, 21084),
         16#76#           =>  --  010476
          (0, 0, 21085, 21085),
         16#77#           =>  --  010477
          (0, 0, 21086, 21086),
         16#78#           =>  --  010478
          (0, 0, 21087, 21087),
         16#79#           =>  --  010479
          (0, 0, 21088, 21088),
         16#7A#           =>  --  01047A
          (0, 0, 21089, 21089),
         16#7B#           =>  --  01047B
          (0, 0, 21090, 21090),
         16#7C#           =>  --  01047C
          (0, 0, 21091, 21091),
         16#7D#           =>  --  01047D
          (0, 0, 21092, 21092),
         16#7E#           =>  --  01047E
          (0, 0, 21093, 21093),
         16#7F#           =>  --  01047F
          (0, 0, 21094, 21094),
         16#80#           =>  --  010480
          (0, 0, 21095, 21095),
         16#81#           =>  --  010481
          (0, 0, 21096, 21096),
         16#82#           =>  --  010482
          (0, 0, 21097, 21097),
         16#83#           =>  --  010483
          (0, 0, 21098, 21098),
         16#84#           =>  --  010484
          (0, 0, 21099, 21099),
         16#85#           =>  --  010485
          (0, 0, 21100, 21100),
         16#86#           =>  --  010486
          (0, 0, 21101, 21101),
         16#87#           =>  --  010487
          (0, 0, 21102, 21102),
         16#88#           =>  --  010488
          (0, 0, 21103, 21103),
         16#89#           =>  --  010489
          (0, 0, 21104, 21104),
         16#8A#           =>  --  01048A
          (0, 0, 21105, 21105),
         16#8B#           =>  --  01048B
          (0, 0, 21106, 21106),
         16#8C#           =>  --  01048C
          (0, 0, 21107, 21107),
         16#8D#           =>  --  01048D
          (0, 0, 21108, 21108),
         16#8E#           =>  --  01048E
          (0, 0, 21109, 21109),
         16#8F#           =>  --  01048F
          (0, 0, 21110, 21110),
         16#90#           =>  --  010490
          (0, 0, 21111, 21111),
         16#91#           =>  --  010491
          (0, 0, 21112, 21112),
         16#92#           =>  --  010492
          (0, 0, 21113, 21113),
         16#93#           =>  --  010493
          (0, 0, 21114, 21114),
         16#94#           =>  --  010494
          (0, 0, 21115, 21115),
         16#95#           =>  --  010495
          (0, 0, 21116, 21116),
         16#96#           =>  --  010496
          (0, 0, 21117, 21117),
         16#97#           =>  --  010497
          (0, 0, 21118, 21118),
         16#98#           =>  --  010498
          (0, 0, 21119, 21119),
         16#99#           =>  --  010499
          (0, 0, 21120, 21120),
         16#9A#           =>  --  01049A
          (0, 0, 21121, 21121),
         16#9B#           =>  --  01049B
          (0, 0, 21122, 21122),
         16#9C#           =>  --  01049C
          (0, 0, 21123, 21123),
         16#9D#           =>  --  01049D
          (0, 0, 21124, 21124),
         16#A0#           =>  --  0104A0
          (0, 0, 23, 23),
         16#A1#           =>  --  0104A1
          (0, 0, 24, 24),
         16#A2#           =>  --  0104A2
          (0, 0, 25, 25),
         16#A3#           =>  --  0104A3
          (0, 0, 26, 26),
         16#A4#           =>  --  0104A4
          (0, 0, 27, 27),
         16#A5#           =>  --  0104A5
          (0, 0, 28, 28),
         16#A6#           =>  --  0104A6
          (0, 0, 29, 29),
         16#A7#           =>  --  0104A7
          (0, 0, 30, 30),
         16#A8#           =>  --  0104A8
          (0, 0, 31, 31),
         16#A9#           =>  --  0104A9
          (0, 0, 32, 32),
         others           =>
          (0, 0, 0, 0));

   Group_0105 : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  010500
          (0, 0, 21125, 21125),
         16#01#           =>  --  010501
          (0, 0, 21126, 21126),
         16#02#           =>  --  010502
          (0, 0, 21127, 21127),
         16#03#           =>  --  010503
          (0, 0, 21128, 21128),
         16#04#           =>  --  010504
          (0, 0, 21129, 21129),
         16#05#           =>  --  010505
          (0, 0, 21130, 21130),
         16#06#           =>  --  010506
          (0, 0, 21131, 21131),
         16#07#           =>  --  010507
          (0, 0, 21132, 21132),
         16#08#           =>  --  010508
          (0, 0, 21133, 21133),
         16#09#           =>  --  010509
          (0, 0, 21134, 21134),
         16#0A#           =>  --  01050A
          (0, 0, 21135, 21135),
         16#0B#           =>  --  01050B
          (0, 0, 21136, 21136),
         16#0C#           =>  --  01050C
          (0, 0, 21137, 21137),
         16#0D#           =>  --  01050D
          (0, 0, 21138, 21138),
         16#0E#           =>  --  01050E
          (0, 0, 21139, 21139),
         16#0F#           =>  --  01050F
          (0, 0, 21140, 21140),
         16#10#           =>  --  010510
          (0, 0, 21141, 21141),
         16#11#           =>  --  010511
          (0, 0, 21142, 21142),
         16#12#           =>  --  010512
          (0, 0, 21143, 21143),
         16#13#           =>  --  010513
          (0, 0, 21144, 21144),
         16#14#           =>  --  010514
          (0, 0, 21145, 21145),
         16#15#           =>  --  010515
          (0, 0, 21146, 21146),
         16#16#           =>  --  010516
          (0, 0, 21147, 21147),
         16#17#           =>  --  010517
          (0, 0, 21148, 21148),
         16#18#           =>  --  010518
          (0, 0, 21149, 21149),
         16#19#           =>  --  010519
          (0, 0, 21150, 21150),
         16#1A#           =>  --  01051A
          (0, 0, 21151, 21151),
         16#1B#           =>  --  01051B
          (0, 0, 21152, 21152),
         16#1C#           =>  --  01051C
          (0, 0, 21153, 21153),
         16#1D#           =>  --  01051D
          (0, 0, 21154, 21154),
         16#1E#           =>  --  01051E
          (0, 0, 21155, 21155),
         16#1F#           =>  --  01051F
          (0, 0, 21156, 21156),
         16#20#           =>  --  010520
          (0, 0, 21157, 21157),
         16#21#           =>  --  010521
          (0, 0, 21158, 21158),
         16#22#           =>  --  010522
          (0, 0, 21159, 21159),
         16#23#           =>  --  010523
          (0, 0, 21160, 21160),
         16#24#           =>  --  010524
          (0, 0, 21161, 21161),
         16#25#           =>  --  010525
          (0, 0, 21162, 21162),
         16#26#           =>  --  010526
          (0, 0, 21163, 21163),
         16#27#           =>  --  010527
          (0, 0, 21164, 21164),
         16#30#           =>  --  010530
          (0, 0, 21165, 21165),
         16#31#           =>  --  010531
          (0, 0, 21166, 21166),
         16#32#           =>  --  010532
          (0, 0, 21167, 21167),
         16#33#           =>  --  010533
          (0, 0, 21168, 21168),
         16#34#           =>  --  010534
          (0, 0, 21169, 21169),
         16#35#           =>  --  010535
          (0, 0, 21170, 21170),
         16#36#           =>  --  010536
          (0, 0, 21171, 21171),
         16#37#           =>  --  010537
          (0, 0, 21172, 21172),
         16#38#           =>  --  010538
          (0, 0, 21173, 21173),
         16#39#           =>  --  010539
          (0, 0, 21174, 21174),
         16#3A#           =>  --  01053A
          (0, 0, 21175, 21175),
         16#3B#           =>  --  01053B
          (0, 0, 21176, 21176),
         16#3C#           =>  --  01053C
          (0, 0, 21177, 21177),
         16#3D#           =>  --  01053D
          (0, 0, 21178, 21178),
         16#3E#           =>  --  01053E
          (0, 0, 21179, 21179),
         16#3F#           =>  --  01053F
          (0, 0, 21180, 21180),
         16#40#           =>  --  010540
          (0, 0, 21181, 21181),
         16#41#           =>  --  010541
          (0, 0, 21182, 21182),
         16#42#           =>  --  010542
          (0, 0, 21183, 21183),
         16#43#           =>  --  010543
          (0, 0, 21184, 21184),
         16#44#           =>  --  010544
          (0, 0, 21185, 21185),
         16#45#           =>  --  010545
          (0, 0, 21186, 21186),
         16#46#           =>  --  010546
          (0, 0, 21187, 21187),
         16#47#           =>  --  010547
          (0, 0, 21188, 21188),
         16#48#           =>  --  010548
          (0, 0, 21189, 21189),
         16#49#           =>  --  010549
          (0, 0, 21190, 21190),
         16#4A#           =>  --  01054A
          (0, 0, 21191, 21191),
         16#4B#           =>  --  01054B
          (0, 0, 21192, 21192),
         16#4C#           =>  --  01054C
          (0, 0, 21193, 21193),
         16#4D#           =>  --  01054D
          (0, 0, 21194, 21194),
         16#4E#           =>  --  01054E
          (0, 0, 21195, 21195),
         16#4F#           =>  --  01054F
          (0, 0, 21196, 21196),
         16#50#           =>  --  010550
          (0, 0, 21197, 21197),
         16#51#           =>  --  010551
          (0, 0, 21198, 21198),
         16#52#           =>  --  010552
          (0, 0, 21199, 21199),
         16#53#           =>  --  010553
          (0, 0, 21200, 21200),
         16#54#           =>  --  010554
          (0, 0, 21201, 21201),
         16#55#           =>  --  010555
          (0, 0, 21202, 21202),
         16#56#           =>  --  010556
          (0, 0, 21203, 21203),
         16#57#           =>  --  010557
          (0, 0, 21204, 21204),
         16#58#           =>  --  010558
          (0, 0, 21205, 21205),
         16#59#           =>  --  010559
          (0, 0, 21206, 21206),
         16#5A#           =>  --  01055A
          (0, 0, 21207, 21207),
         16#5B#           =>  --  01055B
          (0, 0, 21208, 21208),
         16#5C#           =>  --  01055C
          (0, 0, 21209, 21209),
         16#5D#           =>  --  01055D
          (0, 0, 21210, 21210),
         16#5E#           =>  --  01055E
          (0, 0, 21211, 21211),
         16#5F#           =>  --  01055F
          (0, 0, 21212, 21212),
         16#60#           =>  --  010560
          (0, 0, 21213, 21213),
         16#61#           =>  --  010561
          (0, 0, 21214, 21214),
         16#62#           =>  --  010562
          (0, 0, 21215, 21215),
         16#63#           =>  --  010563
          (0, 0, 21216, 21216),
         16#6F#           =>  --  01056F
          (0, 0, 21217, 21217),
         others           =>
          (0, 0, 0, 0));

   Group_0106 : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  010600
          (0, 0, 21218, 21218),
         16#01#           =>  --  010601
          (0, 0, 21219, 21219),
         16#02#           =>  --  010602
          (0, 0, 21220, 21220),
         16#03#           =>  --  010603
          (0, 0, 21221, 21221),
         16#04#           =>  --  010604
          (0, 0, 21222, 21222),
         16#05#           =>  --  010605
          (0, 0, 21223, 21223),
         16#06#           =>  --  010606
          (0, 0, 21224, 21224),
         16#07#           =>  --  010607
          (0, 0, 21225, 21225),
         16#08#           =>  --  010608
          (0, 0, 21226, 21226),
         16#09#           =>  --  010609
          (0, 0, 21227, 21227),
         16#0A#           =>  --  01060A
          (0, 0, 21228, 21228),
         16#0B#           =>  --  01060B
          (0, 0, 21229, 21229),
         16#0C#           =>  --  01060C
          (0, 0, 21230, 21230),
         16#0D#           =>  --  01060D
          (0, 0, 21231, 21231),
         16#0E#           =>  --  01060E
          (0, 0, 21232, 21232),
         16#0F#           =>  --  01060F
          (0, 0, 21233, 21233),
         16#10#           =>  --  010610
          (0, 0, 21234, 21234),
         16#11#           =>  --  010611
          (0, 0, 21235, 21235),
         16#12#           =>  --  010612
          (0, 0, 21236, 21236),
         16#13#           =>  --  010613
          (0, 0, 21237, 21237),
         16#14#           =>  --  010614
          (0, 0, 21238, 21238),
         16#15#           =>  --  010615
          (0, 0, 21239, 21239),
         16#16#           =>  --  010616
          (0, 0, 21240, 21240),
         16#17#           =>  --  010617
          (0, 0, 21241, 21241),
         16#18#           =>  --  010618
          (0, 0, 21242, 21242),
         16#19#           =>  --  010619
          (0, 0, 21243, 21243),
         16#1A#           =>  --  01061A
          (0, 0, 21244, 21244),
         16#1B#           =>  --  01061B
          (0, 0, 21245, 21245),
         16#1C#           =>  --  01061C
          (0, 0, 21246, 21246),
         16#1D#           =>  --  01061D
          (0, 0, 21247, 21247),
         16#1E#           =>  --  01061E
          (0, 0, 21248, 21248),
         16#1F#           =>  --  01061F
          (0, 0, 21249, 21249),
         16#20#           =>  --  010620
          (0, 0, 21250, 21250),
         16#21#           =>  --  010621
          (0, 0, 21251, 21251),
         16#22#           =>  --  010622
          (0, 0, 21252, 21252),
         16#23#           =>  --  010623
          (0, 0, 21253, 21253),
         16#24#           =>  --  010624
          (0, 0, 21254, 21254),
         16#25#           =>  --  010625
          (0, 0, 21255, 21255),
         16#26#           =>  --  010626
          (0, 0, 21256, 21256),
         16#27#           =>  --  010627
          (0, 0, 21257, 21257),
         16#28#           =>  --  010628
          (0, 0, 21258, 21258),
         16#29#           =>  --  010629
          (0, 0, 21259, 21259),
         16#2A#           =>  --  01062A
          (0, 0, 21260, 21260),
         16#2B#           =>  --  01062B
          (0, 0, 21261, 21261),
         16#2C#           =>  --  01062C
          (0, 0, 21262, 21262),
         16#2D#           =>  --  01062D
          (0, 0, 21263, 21263),
         16#2E#           =>  --  01062E
          (0, 0, 21264, 21264),
         16#2F#           =>  --  01062F
          (0, 0, 21265, 21265),
         16#30#           =>  --  010630
          (0, 0, 21266, 21266),
         16#31#           =>  --  010631
          (0, 0, 21267, 21267),
         16#32#           =>  --  010632
          (0, 0, 21268, 21268),
         16#33#           =>  --  010633
          (0, 0, 21269, 21269),
         16#34#           =>  --  010634
          (0, 0, 21270, 21270),
         16#35#           =>  --  010635
          (0, 0, 21271, 21271),
         16#36#           =>  --  010636
          (0, 0, 21272, 21272),
         16#37#           =>  --  010637
          (0, 0, 21273, 21273),
         16#38#           =>  --  010638
          (0, 0, 21274, 21274),
         16#39#           =>  --  010639
          (0, 0, 21275, 21275),
         16#3A#           =>  --  01063A
          (0, 0, 21276, 21276),
         16#3B#           =>  --  01063B
          (0, 0, 21277, 21277),
         16#3C#           =>  --  01063C
          (0, 0, 21278, 21278),
         16#3D#           =>  --  01063D
          (0, 0, 21279, 21279),
         16#3E#           =>  --  01063E
          (0, 0, 21280, 21280),
         16#3F#           =>  --  01063F
          (0, 0, 21281, 21281),
         16#40#           =>  --  010640
          (0, 0, 21282, 21282),
         16#41#           =>  --  010641
          (0, 0, 21283, 21283),
         16#42#           =>  --  010642
          (0, 0, 21284, 21284),
         16#43#           =>  --  010643
          (0, 0, 21285, 21285),
         16#44#           =>  --  010644
          (0, 0, 21286, 21286),
         16#45#           =>  --  010645
          (0, 0, 21287, 21287),
         16#46#           =>  --  010646
          (0, 0, 21288, 21288),
         16#47#           =>  --  010647
          (0, 0, 21289, 21289),
         16#48#           =>  --  010648
          (0, 0, 21290, 21290),
         16#49#           =>  --  010649
          (0, 0, 21291, 21291),
         16#4A#           =>  --  01064A
          (0, 0, 21292, 21292),
         16#4B#           =>  --  01064B
          (0, 0, 21293, 21293),
         16#4C#           =>  --  01064C
          (0, 0, 21294, 21294),
         16#4D#           =>  --  01064D
          (0, 0, 21295, 21295),
         16#4E#           =>  --  01064E
          (0, 0, 21296, 21296),
         16#4F#           =>  --  01064F
          (0, 0, 21297, 21297),
         16#50#           =>  --  010650
          (0, 0, 21298, 21298),
         16#51#           =>  --  010651
          (0, 0, 21299, 21299),
         16#52#           =>  --  010652
          (0, 0, 21300, 21300),
         16#53#           =>  --  010653
          (0, 0, 21301, 21301),
         16#54#           =>  --  010654
          (0, 0, 21302, 21302),
         16#55#           =>  --  010655
          (0, 0, 21303, 21303),
         16#56#           =>  --  010656
          (0, 0, 21304, 21304),
         16#57#           =>  --  010657
          (0, 0, 21305, 21305),
         16#58#           =>  --  010658
          (0, 0, 21306, 21306),
         16#59#           =>  --  010659
          (0, 0, 21307, 21307),
         16#5A#           =>  --  01065A
          (0, 0, 21308, 21308),
         16#5B#           =>  --  01065B
          (0, 0, 21309, 21309),
         16#5C#           =>  --  01065C
          (0, 0, 21310, 21310),
         16#5D#           =>  --  01065D
          (0, 0, 21311, 21311),
         16#5E#           =>  --  01065E
          (0, 0, 21312, 21312),
         16#5F#           =>  --  01065F
          (0, 0, 21313, 21313),
         16#60#           =>  --  010660
          (0, 0, 21314, 21314),
         16#61#           =>  --  010661
          (0, 0, 21315, 21315),
         16#62#           =>  --  010662
          (0, 0, 21316, 21316),
         16#63#           =>  --  010663
          (0, 0, 21317, 21317),
         16#64#           =>  --  010664
          (0, 0, 21318, 21318),
         16#65#           =>  --  010665
          (0, 0, 21319, 21319),
         16#66#           =>  --  010666
          (0, 0, 21320, 21320),
         16#67#           =>  --  010667
          (0, 0, 21321, 21321),
         16#68#           =>  --  010668
          (0, 0, 21322, 21322),
         16#69#           =>  --  010669
          (0, 0, 21323, 21323),
         16#6A#           =>  --  01066A
          (0, 0, 21324, 21324),
         16#6B#           =>  --  01066B
          (0, 0, 21325, 21325),
         16#6C#           =>  --  01066C
          (0, 0, 21326, 21326),
         16#6D#           =>  --  01066D
          (0, 0, 21327, 21327),
         16#6E#           =>  --  01066E
          (0, 0, 21328, 21328),
         16#6F#           =>  --  01066F
          (0, 0, 21329, 21329),
         16#70#           =>  --  010670
          (0, 0, 21330, 21330),
         16#71#           =>  --  010671
          (0, 0, 21331, 21331),
         16#72#           =>  --  010672
          (0, 0, 21332, 21332),
         16#73#           =>  --  010673
          (0, 0, 21333, 21333),
         16#74#           =>  --  010674
          (0, 0, 21334, 21334),
         16#75#           =>  --  010675
          (0, 0, 21335, 21335),
         16#76#           =>  --  010676
          (0, 0, 21336, 21336),
         16#77#           =>  --  010677
          (0, 0, 21337, 21337),
         16#78#           =>  --  010678
          (0, 0, 21338, 21338),
         16#79#           =>  --  010679
          (0, 0, 21339, 21339),
         16#7A#           =>  --  01067A
          (0, 0, 21340, 21340),
         16#7B#           =>  --  01067B
          (0, 0, 21341, 21341),
         16#7C#           =>  --  01067C
          (0, 0, 21342, 21342),
         16#7D#           =>  --  01067D
          (0, 0, 21343, 21343),
         16#7E#           =>  --  01067E
          (0, 0, 21344, 21344),
         16#7F#           =>  --  01067F
          (0, 0, 21345, 21345),
         16#80#           =>  --  010680
          (0, 0, 21346, 21346),
         16#81#           =>  --  010681
          (0, 0, 21347, 21347),
         16#82#           =>  --  010682
          (0, 0, 21348, 21348),
         16#83#           =>  --  010683
          (0, 0, 21349, 21349),
         16#84#           =>  --  010684
          (0, 0, 21350, 21350),
         16#85#           =>  --  010685
          (0, 0, 21351, 21351),
         16#86#           =>  --  010686
          (0, 0, 21352, 21352),
         16#87#           =>  --  010687
          (0, 0, 21353, 21353),
         16#88#           =>  --  010688
          (0, 0, 21354, 21354),
         16#89#           =>  --  010689
          (0, 0, 21355, 21355),
         16#8A#           =>  --  01068A
          (0, 0, 21356, 21356),
         16#8B#           =>  --  01068B
          (0, 0, 21357, 21357),
         16#8C#           =>  --  01068C
          (0, 0, 21358, 21358),
         16#8D#           =>  --  01068D
          (0, 0, 21359, 21359),
         16#8E#           =>  --  01068E
          (0, 0, 21360, 21360),
         16#8F#           =>  --  01068F
          (0, 0, 21361, 21361),
         16#90#           =>  --  010690
          (0, 0, 21362, 21362),
         16#91#           =>  --  010691
          (0, 0, 21363, 21363),
         16#92#           =>  --  010692
          (0, 0, 21364, 21364),
         16#93#           =>  --  010693
          (0, 0, 21365, 21365),
         16#94#           =>  --  010694
          (0, 0, 21366, 21366),
         16#95#           =>  --  010695
          (0, 0, 21367, 21367),
         16#96#           =>  --  010696
          (0, 0, 21368, 21368),
         16#97#           =>  --  010697
          (0, 0, 21369, 21369),
         16#98#           =>  --  010698
          (0, 0, 21370, 21370),
         16#99#           =>  --  010699
          (0, 0, 21371, 21371),
         16#9A#           =>  --  01069A
          (0, 0, 21372, 21372),
         16#9B#           =>  --  01069B
          (0, 0, 21373, 21373),
         16#9C#           =>  --  01069C
          (0, 0, 21374, 21374),
         16#9D#           =>  --  01069D
          (0, 0, 21375, 21375),
         16#9E#           =>  --  01069E
          (0, 0, 21376, 21376),
         16#9F#           =>  --  01069F
          (0, 0, 21377, 21377),
         16#A0#           =>  --  0106A0
          (0, 0, 21378, 21378),
         16#A1#           =>  --  0106A1
          (0, 0, 21379, 21379),
         16#A2#           =>  --  0106A2
          (0, 0, 21380, 21380),
         16#A3#           =>  --  0106A3
          (0, 0, 21381, 21381),
         16#A4#           =>  --  0106A4
          (0, 0, 21382, 21382),
         16#A5#           =>  --  0106A5
          (0, 0, 21383, 21383),
         16#A6#           =>  --  0106A6
          (0, 0, 21384, 21384),
         16#A7#           =>  --  0106A7
          (0, 0, 21385, 21385),
         16#A8#           =>  --  0106A8
          (0, 0, 21386, 21386),
         16#A9#           =>  --  0106A9
          (0, 0, 21387, 21387),
         16#AA#           =>  --  0106AA
          (0, 0, 21388, 21388),
         16#AB#           =>  --  0106AB
          (0, 0, 21389, 21389),
         16#AC#           =>  --  0106AC
          (0, 0, 21390, 21390),
         16#AD#           =>  --  0106AD
          (0, 0, 21391, 21391),
         16#AE#           =>  --  0106AE
          (0, 0, 21392, 21392),
         16#AF#           =>  --  0106AF
          (0, 0, 21393, 21393),
         16#B0#           =>  --  0106B0
          (0, 0, 21394, 21394),
         16#B1#           =>  --  0106B1
          (0, 0, 21395, 21395),
         16#B2#           =>  --  0106B2
          (0, 0, 21396, 21396),
         16#B3#           =>  --  0106B3
          (0, 0, 21397, 21397),
         16#B4#           =>  --  0106B4
          (0, 0, 21398, 21398),
         16#B5#           =>  --  0106B5
          (0, 0, 21399, 21399),
         16#B6#           =>  --  0106B6
          (0, 0, 21400, 21400),
         16#B7#           =>  --  0106B7
          (0, 0, 21401, 21401),
         16#B8#           =>  --  0106B8
          (0, 0, 21402, 21402),
         16#B9#           =>  --  0106B9
          (0, 0, 21403, 21403),
         16#BA#           =>  --  0106BA
          (0, 0, 21404, 21404),
         16#BB#           =>  --  0106BB
          (0, 0, 21405, 21405),
         16#BC#           =>  --  0106BC
          (0, 0, 21406, 21406),
         16#BD#           =>  --  0106BD
          (0, 0, 21407, 21407),
         16#BE#           =>  --  0106BE
          (0, 0, 21408, 21408),
         16#BF#           =>  --  0106BF
          (0, 0, 21409, 21409),
         16#C0#           =>  --  0106C0
          (0, 0, 21410, 21410),
         16#C1#           =>  --  0106C1
          (0, 0, 21411, 21411),
         16#C2#           =>  --  0106C2
          (0, 0, 21412, 21412),
         16#C3#           =>  --  0106C3
          (0, 0, 21413, 21413),
         16#C4#           =>  --  0106C4
          (0, 0, 21414, 21414),
         16#C5#           =>  --  0106C5
          (0, 0, 21415, 21415),
         16#C6#           =>  --  0106C6
          (0, 0, 21416, 21416),
         16#C7#           =>  --  0106C7
          (0, 0, 21417, 21417),
         16#C8#           =>  --  0106C8
          (0, 0, 21418, 21418),
         16#C9#           =>  --  0106C9
          (0, 0, 21419, 21419),
         16#CA#           =>  --  0106CA
          (0, 0, 21420, 21420),
         16#CB#           =>  --  0106CB
          (0, 0, 21421, 21421),
         16#CC#           =>  --  0106CC
          (0, 0, 21422, 21422),
         16#CD#           =>  --  0106CD
          (0, 0, 21423, 21423),
         16#CE#           =>  --  0106CE
          (0, 0, 21424, 21424),
         16#CF#           =>  --  0106CF
          (0, 0, 21425, 21425),
         16#D0#           =>  --  0106D0
          (0, 0, 21426, 21426),
         16#D1#           =>  --  0106D1
          (0, 0, 21427, 21427),
         16#D2#           =>  --  0106D2
          (0, 0, 21428, 21428),
         16#D3#           =>  --  0106D3
          (0, 0, 21429, 21429),
         16#D4#           =>  --  0106D4
          (0, 0, 21430, 21430),
         16#D5#           =>  --  0106D5
          (0, 0, 21431, 21431),
         16#D6#           =>  --  0106D6
          (0, 0, 21432, 21432),
         16#D7#           =>  --  0106D7
          (0, 0, 21433, 21433),
         16#D8#           =>  --  0106D8
          (0, 0, 21434, 21434),
         16#D9#           =>  --  0106D9
          (0, 0, 21435, 21435),
         16#DA#           =>  --  0106DA
          (0, 0, 21436, 21436),
         16#DB#           =>  --  0106DB
          (0, 0, 21437, 21437),
         16#DC#           =>  --  0106DC
          (0, 0, 21438, 21438),
         16#DD#           =>  --  0106DD
          (0, 0, 21439, 21439),
         16#DE#           =>  --  0106DE
          (0, 0, 21440, 21440),
         16#DF#           =>  --  0106DF
          (0, 0, 21441, 21441),
         16#E0#           =>  --  0106E0
          (0, 0, 21442, 21442),
         16#E1#           =>  --  0106E1
          (0, 0, 21443, 21443),
         16#E2#           =>  --  0106E2
          (0, 0, 21444, 21444),
         16#E3#           =>  --  0106E3
          (0, 0, 21445, 21445),
         16#E4#           =>  --  0106E4
          (0, 0, 21446, 21446),
         16#E5#           =>  --  0106E5
          (0, 0, 21447, 21447),
         16#E6#           =>  --  0106E6
          (0, 0, 21448, 21448),
         16#E7#           =>  --  0106E7
          (0, 0, 21449, 21449),
         16#E8#           =>  --  0106E8
          (0, 0, 21450, 21450),
         16#E9#           =>  --  0106E9
          (0, 0, 21451, 21451),
         16#EA#           =>  --  0106EA
          (0, 0, 21452, 21452),
         16#EB#           =>  --  0106EB
          (0, 0, 21453, 21453),
         16#EC#           =>  --  0106EC
          (0, 0, 21454, 21454),
         16#ED#           =>  --  0106ED
          (0, 0, 21455, 21455),
         16#EE#           =>  --  0106EE
          (0, 0, 21456, 21456),
         16#EF#           =>  --  0106EF
          (0, 0, 21457, 21457),
         16#F0#           =>  --  0106F0
          (0, 0, 21458, 21458),
         16#F1#           =>  --  0106F1
          (0, 0, 21459, 21459),
         16#F2#           =>  --  0106F2
          (0, 0, 21460, 21460),
         16#F3#           =>  --  0106F3
          (0, 0, 21461, 21461),
         16#F4#           =>  --  0106F4
          (0, 0, 21462, 21462),
         16#F5#           =>  --  0106F5
          (0, 0, 21463, 21463),
         16#F6#           =>  --  0106F6
          (0, 0, 21464, 21464),
         16#F7#           =>  --  0106F7
          (0, 0, 21465, 21465),
         16#F8#           =>  --  0106F8
          (0, 0, 21466, 21466),
         16#F9#           =>  --  0106F9
          (0, 0, 21467, 21467),
         16#FA#           =>  --  0106FA
          (0, 0, 21468, 21468),
         16#FB#           =>  --  0106FB
          (0, 0, 21469, 21469),
         16#FC#           =>  --  0106FC
          (0, 0, 21470, 21470),
         16#FD#           =>  --  0106FD
          (0, 0, 21471, 21471),
         16#FE#           =>  --  0106FE
          (0, 0, 21472, 21472),
         16#FF#           =>  --  0106FF
          (0, 0, 21473, 21473),
         others           =>
          (0, 0, 0, 0));

   Group_0107 : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  010700
          (0, 0, 21474, 21474),
         16#01#           =>  --  010701
          (0, 0, 21475, 21475),
         16#02#           =>  --  010702
          (0, 0, 21476, 21476),
         16#03#           =>  --  010703
          (0, 0, 21477, 21477),
         16#04#           =>  --  010704
          (0, 0, 21478, 21478),
         16#05#           =>  --  010705
          (0, 0, 21479, 21479),
         16#06#           =>  --  010706
          (0, 0, 21480, 21480),
         16#07#           =>  --  010707
          (0, 0, 21481, 21481),
         16#08#           =>  --  010708
          (0, 0, 21482, 21482),
         16#09#           =>  --  010709
          (0, 0, 21483, 21483),
         16#0A#           =>  --  01070A
          (0, 0, 21484, 21484),
         16#0B#           =>  --  01070B
          (0, 0, 21485, 21485),
         16#0C#           =>  --  01070C
          (0, 0, 21486, 21486),
         16#0D#           =>  --  01070D
          (0, 0, 21487, 21487),
         16#0E#           =>  --  01070E
          (0, 0, 21488, 21488),
         16#0F#           =>  --  01070F
          (0, 0, 21489, 21489),
         16#10#           =>  --  010710
          (0, 0, 21490, 21490),
         16#11#           =>  --  010711
          (0, 0, 21491, 21491),
         16#12#           =>  --  010712
          (0, 0, 21492, 21492),
         16#13#           =>  --  010713
          (0, 0, 21493, 21493),
         16#14#           =>  --  010714
          (0, 0, 21494, 21494),
         16#15#           =>  --  010715
          (0, 0, 21495, 21495),
         16#16#           =>  --  010716
          (0, 0, 21496, 21496),
         16#17#           =>  --  010717
          (0, 0, 21497, 21497),
         16#18#           =>  --  010718
          (0, 0, 21498, 21498),
         16#19#           =>  --  010719
          (0, 0, 21499, 21499),
         16#1A#           =>  --  01071A
          (0, 0, 21500, 21500),
         16#1B#           =>  --  01071B
          (0, 0, 21501, 21501),
         16#1C#           =>  --  01071C
          (0, 0, 21502, 21502),
         16#1D#           =>  --  01071D
          (0, 0, 21503, 21503),
         16#1E#           =>  --  01071E
          (0, 0, 21504, 21504),
         16#1F#           =>  --  01071F
          (0, 0, 21505, 21505),
         16#20#           =>  --  010720
          (0, 0, 21506, 21506),
         16#21#           =>  --  010721
          (0, 0, 21507, 21507),
         16#22#           =>  --  010722
          (0, 0, 21508, 21508),
         16#23#           =>  --  010723
          (0, 0, 21509, 21509),
         16#24#           =>  --  010724
          (0, 0, 21510, 21510),
         16#25#           =>  --  010725
          (0, 0, 21511, 21511),
         16#26#           =>  --  010726
          (0, 0, 21512, 21512),
         16#27#           =>  --  010727
          (0, 0, 21513, 21513),
         16#28#           =>  --  010728
          (0, 0, 21514, 21514),
         16#29#           =>  --  010729
          (0, 0, 21515, 21515),
         16#2A#           =>  --  01072A
          (0, 0, 21516, 21516),
         16#2B#           =>  --  01072B
          (0, 0, 21517, 21517),
         16#2C#           =>  --  01072C
          (0, 0, 21518, 21518),
         16#2D#           =>  --  01072D
          (0, 0, 21519, 21519),
         16#2E#           =>  --  01072E
          (0, 0, 21520, 21520),
         16#2F#           =>  --  01072F
          (0, 0, 21521, 21521),
         16#30#           =>  --  010730
          (0, 0, 21522, 21522),
         16#31#           =>  --  010731
          (0, 0, 21523, 21523),
         16#32#           =>  --  010732
          (0, 0, 21524, 21524),
         16#33#           =>  --  010733
          (0, 0, 21525, 21525),
         16#34#           =>  --  010734
          (0, 0, 21526, 21526),
         16#35#           =>  --  010735
          (0, 0, 21527, 21527),
         16#36#           =>  --  010736
          (0, 0, 21528, 21528),
         16#40#           =>  --  010740
          (0, 0, 21529, 21529),
         16#41#           =>  --  010741
          (0, 0, 21530, 21530),
         16#42#           =>  --  010742
          (0, 0, 21531, 21531),
         16#43#           =>  --  010743
          (0, 0, 21532, 21532),
         16#44#           =>  --  010744
          (0, 0, 21533, 21533),
         16#45#           =>  --  010745
          (0, 0, 21534, 21534),
         16#46#           =>  --  010746
          (0, 0, 21535, 21535),
         16#47#           =>  --  010747
          (0, 0, 21536, 21536),
         16#48#           =>  --  010748
          (0, 0, 21537, 21537),
         16#49#           =>  --  010749
          (0, 0, 21538, 21538),
         16#4A#           =>  --  01074A
          (0, 0, 21539, 21539),
         16#4B#           =>  --  01074B
          (0, 0, 21540, 21540),
         16#4C#           =>  --  01074C
          (0, 0, 21541, 21541),
         16#4D#           =>  --  01074D
          (0, 0, 21542, 21542),
         16#4E#           =>  --  01074E
          (0, 0, 21543, 21543),
         16#4F#           =>  --  01074F
          (0, 0, 21544, 21544),
         16#50#           =>  --  010750
          (0, 0, 21545, 21545),
         16#51#           =>  --  010751
          (0, 0, 21546, 21546),
         16#52#           =>  --  010752
          (0, 0, 21547, 21547),
         16#53#           =>  --  010753
          (0, 0, 21548, 21548),
         16#54#           =>  --  010754
          (0, 0, 21549, 21549),
         16#55#           =>  --  010755
          (0, 0, 21550, 21550),
         16#60#           =>  --  010760
          (0, 0, 21551, 21551),
         16#61#           =>  --  010761
          (0, 0, 21552, 21552),
         16#62#           =>  --  010762
          (0, 0, 21553, 21553),
         16#63#           =>  --  010763
          (0, 0, 21554, 21554),
         16#64#           =>  --  010764
          (0, 0, 21555, 21555),
         16#65#           =>  --  010765
          (0, 0, 21556, 21556),
         16#66#           =>  --  010766
          (0, 0, 21557, 21557),
         16#67#           =>  --  010767
          (0, 0, 21558, 21558),
         others           =>
          (0, 0, 0, 0));

   Group_0108 : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  010800
          (0, 0, 21559, 21559),
         16#01#           =>  --  010801
          (0, 0, 21560, 21560),
         16#02#           =>  --  010802
          (0, 0, 21561, 21561),
         16#03#           =>  --  010803
          (0, 0, 21562, 21562),
         16#04#           =>  --  010804
          (0, 0, 21563, 21563),
         16#05#           =>  --  010805
          (0, 0, 21564, 21564),
         16#08#           =>  --  010808
          (0, 0, 21565, 21565),
         16#0A#           =>  --  01080A
          (0, 0, 21566, 21566),
         16#0B#           =>  --  01080B
          (0, 0, 21567, 21567),
         16#0C#           =>  --  01080C
          (0, 0, 21568, 21568),
         16#0D#           =>  --  01080D
          (0, 0, 21569, 21569),
         16#0E#           =>  --  01080E
          (0, 0, 21570, 21570),
         16#0F#           =>  --  01080F
          (0, 0, 21571, 21571),
         16#10#           =>  --  010810
          (0, 0, 21572, 21572),
         16#11#           =>  --  010811
          (0, 0, 21573, 21573),
         16#12#           =>  --  010812
          (0, 0, 21574, 21574),
         16#13#           =>  --  010813
          (0, 0, 21575, 21575),
         16#14#           =>  --  010814
          (0, 0, 21576, 21576),
         16#15#           =>  --  010815
          (0, 0, 21577, 21577),
         16#16#           =>  --  010816
          (0, 0, 21578, 21578),
         16#17#           =>  --  010817
          (0, 0, 21579, 21579),
         16#18#           =>  --  010818
          (0, 0, 21580, 21580),
         16#19#           =>  --  010819
          (0, 0, 21581, 21581),
         16#1A#           =>  --  01081A
          (0, 0, 21582, 21582),
         16#1B#           =>  --  01081B
          (0, 0, 21583, 21583),
         16#1C#           =>  --  01081C
          (0, 0, 21584, 21584),
         16#1D#           =>  --  01081D
          (0, 0, 21585, 21585),
         16#1E#           =>  --  01081E
          (0, 0, 21586, 21586),
         16#1F#           =>  --  01081F
          (0, 0, 21587, 21587),
         16#20#           =>  --  010820
          (0, 0, 21588, 21588),
         16#21#           =>  --  010821
          (0, 0, 21589, 21589),
         16#22#           =>  --  010822
          (0, 0, 21590, 21590),
         16#23#           =>  --  010823
          (0, 0, 21591, 21591),
         16#24#           =>  --  010824
          (0, 0, 21592, 21592),
         16#25#           =>  --  010825
          (0, 0, 21593, 21593),
         16#26#           =>  --  010826
          (0, 0, 21594, 21594),
         16#27#           =>  --  010827
          (0, 0, 21595, 21595),
         16#28#           =>  --  010828
          (0, 0, 21596, 21596),
         16#29#           =>  --  010829
          (0, 0, 21597, 21597),
         16#2A#           =>  --  01082A
          (0, 0, 21598, 21598),
         16#2B#           =>  --  01082B
          (0, 0, 21599, 21599),
         16#2C#           =>  --  01082C
          (0, 0, 21600, 21600),
         16#2D#           =>  --  01082D
          (0, 0, 21601, 21601),
         16#2E#           =>  --  01082E
          (0, 0, 21602, 21602),
         16#2F#           =>  --  01082F
          (0, 0, 21603, 21603),
         16#30#           =>  --  010830
          (0, 0, 21604, 21604),
         16#31#           =>  --  010831
          (0, 0, 21605, 21605),
         16#32#           =>  --  010832
          (0, 0, 21606, 21606),
         16#33#           =>  --  010833
          (0, 0, 21607, 21607),
         16#34#           =>  --  010834
          (0, 0, 21608, 21608),
         16#35#           =>  --  010835
          (0, 0, 21609, 21609),
         16#37#           =>  --  010837
          (0, 0, 21610, 21610),
         16#38#           =>  --  010838
          (0, 0, 21611, 21611),
         16#3C#           =>  --  01083C
          (0, 0, 21612, 21612),
         16#3F#           =>  --  01083F
          (0, 0, 21613, 21613),
         16#40#           =>  --  010840
          (0, 0, 21614, 21614),
         16#41#           =>  --  010841
          (0, 0, 21615, 21615),
         16#42#           =>  --  010842
          (0, 0, 21616, 21616),
         16#43#           =>  --  010843
          (0, 0, 21617, 21617),
         16#44#           =>  --  010844
          (0, 0, 21618, 21618),
         16#45#           =>  --  010845
          (0, 0, 21619, 21619),
         16#46#           =>  --  010846
          (0, 0, 21620, 21620),
         16#47#           =>  --  010847
          (0, 0, 21621, 21621),
         16#48#           =>  --  010848
          (0, 0, 21622, 21622),
         16#49#           =>  --  010849
          (0, 0, 21623, 21623),
         16#4A#           =>  --  01084A
          (0, 0, 21624, 21624),
         16#4B#           =>  --  01084B
          (0, 0, 21625, 21625),
         16#4C#           =>  --  01084C
          (0, 0, 21626, 21626),
         16#4D#           =>  --  01084D
          (0, 0, 21627, 21627),
         16#4E#           =>  --  01084E
          (0, 0, 21628, 21628),
         16#4F#           =>  --  01084F
          (0, 0, 21629, 21629),
         16#50#           =>  --  010850
          (0, 0, 21630, 21630),
         16#51#           =>  --  010851
          (0, 0, 21631, 21631),
         16#52#           =>  --  010852
          (0, 0, 21632, 21632),
         16#53#           =>  --  010853
          (0, 0, 21633, 21633),
         16#54#           =>  --  010854
          (0, 0, 21634, 21634),
         16#55#           =>  --  010855
          (0, 0, 21635, 21635),
         16#57#           =>  --  010857
          (0, 0, 21636, 21636),
         16#58#           =>  --  010858
          (0, 0, 24, 24),
         16#59#           =>  --  010859
          (0, 0, 25, 25),
         16#5A#           =>  --  01085A
          (0, 0, 26, 26),
         16#5B#           =>  --  01085B
          (0, 0, 21637, 21637),
         16#5C#           =>  --  01085C
          (0, 0, 21638, 21638),
         16#5D#           =>  --  01085D
          (0, 0, 21639, 21639),
         16#5E#           =>  --  01085E
          (0, 0, 21640, 21640),
         16#5F#           =>  --  01085F
          (0, 0, 21641, 21641),
         16#60#           =>  --  010860
          (0, 0, 21642, 21642),
         16#61#           =>  --  010861
          (0, 0, 21643, 21643),
         16#62#           =>  --  010862
          (0, 0, 21644, 21644),
         16#63#           =>  --  010863
          (0, 0, 21645, 21645),
         16#64#           =>  --  010864
          (0, 0, 21646, 21646),
         16#65#           =>  --  010865
          (0, 0, 21647, 21647),
         16#66#           =>  --  010866
          (0, 0, 21648, 21648),
         16#67#           =>  --  010867
          (0, 0, 21649, 21649),
         16#68#           =>  --  010868
          (0, 0, 21650, 21650),
         16#69#           =>  --  010869
          (0, 0, 21651, 21651),
         16#6A#           =>  --  01086A
          (0, 0, 21652, 21652),
         16#6B#           =>  --  01086B
          (0, 0, 21653, 21653),
         16#6C#           =>  --  01086C
          (0, 0, 21654, 21654),
         16#6D#           =>  --  01086D
          (0, 0, 21655, 21655),
         16#6E#           =>  --  01086E
          (0, 0, 21656, 21656),
         16#6F#           =>  --  01086F
          (0, 0, 21657, 21657),
         16#70#           =>  --  010870
          (0, 0, 21658, 21658),
         16#71#           =>  --  010871
          (0, 0, 21659, 21659),
         16#72#           =>  --  010872
          (0, 0, 21660, 21660),
         16#73#           =>  --  010873
          (0, 0, 21661, 21661),
         16#74#           =>  --  010874
          (0, 0, 21662, 21662),
         16#75#           =>  --  010875
          (0, 0, 21663, 21663),
         16#76#           =>  --  010876
          (0, 0, 21664, 21664),
         16#77#           =>  --  010877
          (0, 0, 21665, 21665),
         16#78#           =>  --  010878
          (0, 0, 21666, 21666),
         16#79#           =>  --  010879
          (0, 0, 24, 24),
         16#7A#           =>  --  01087A
          (0, 0, 25, 25),
         16#7B#           =>  --  01087B
          (0, 0, 26, 26),
         16#7C#           =>  --  01087C
          (0, 0, 27, 27),
         16#7D#           =>  --  01087D
          (0, 0, 28, 28),
         16#7E#           =>  --  01087E
          (0, 0, 21667, 21667),
         16#7F#           =>  --  01087F
          (0, 0, 21668, 21668),
         16#80#           =>  --  010880
          (0, 0, 21669, 21669),
         16#81#           =>  --  010881
          (0, 0, 21670, 21670),
         16#82#           =>  --  010882
          (0, 0, 21671, 21671),
         16#83#           =>  --  010883
          (0, 0, 21672, 21672),
         16#84#           =>  --  010884
          (0, 0, 21673, 21673),
         16#85#           =>  --  010885
          (0, 0, 21674, 21674),
         16#86#           =>  --  010886
          (0, 0, 21675, 21675),
         16#87#           =>  --  010887
          (0, 0, 21676, 21676),
         16#88#           =>  --  010888
          (0, 0, 21677, 21677),
         16#89#           =>  --  010889
          (0, 0, 21678, 21678),
         16#8A#           =>  --  01088A
          (0, 0, 21679, 21679),
         16#8B#           =>  --  01088B
          (0, 0, 21680, 21680),
         16#8C#           =>  --  01088C
          (0, 0, 21681, 21681),
         16#8D#           =>  --  01088D
          (0, 0, 21682, 21682),
         16#8E#           =>  --  01088E
          (0, 0, 21683, 21683),
         16#8F#           =>  --  01088F
          (0, 0, 21684, 21684),
         16#90#           =>  --  010890
          (0, 0, 21685, 21685),
         16#91#           =>  --  010891
          (0, 0, 21686, 21686),
         16#92#           =>  --  010892
          (0, 0, 21687, 21687),
         16#93#           =>  --  010893
          (0, 0, 21688, 21688),
         16#94#           =>  --  010894
          (0, 0, 21689, 21689),
         16#95#           =>  --  010895
          (0, 0, 21690, 21690),
         16#96#           =>  --  010896
          (0, 0, 21691, 21691),
         16#97#           =>  --  010897
          (0, 0, 21692, 21692),
         16#98#           =>  --  010898
          (0, 0, 21693, 21693),
         16#99#           =>  --  010899
          (0, 0, 21694, 21694),
         16#9A#           =>  --  01089A
          (0, 0, 21695, 21695),
         16#9B#           =>  --  01089B
          (0, 0, 21696, 21696),
         16#9C#           =>  --  01089C
          (0, 0, 21697, 21697),
         16#9D#           =>  --  01089D
          (0, 0, 21698, 21698),
         16#9E#           =>  --  01089E
          (0, 0, 21699, 21699),
         16#A7#           =>  --  0108A7
          (0, 0, 24, 24),
         16#A8#           =>  --  0108A8
          (0, 0, 25, 25),
         16#A9#           =>  --  0108A9
          (0, 0, 26, 26),
         16#AA# .. 16#AB# =>  --  0108AA .. 0108AB
          (0, 0, 27, 27),
         16#AC#           =>  --  0108AC
          (0, 0, 28, 28),
         16#AD#           =>  --  0108AD
          (0, 0, 21700, 21700),
         16#AE#           =>  --  0108AE
          (0, 0, 21701, 21701),
         16#AF#           =>  --  0108AF
          (0, 0, 21702, 21702),
         others           =>
          (0, 0, 0, 0));

   Group_0109 : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  010900
          (0, 0, 21703, 21703),
         16#01#           =>  --  010901
          (0, 0, 21704, 21704),
         16#02#           =>  --  010902
          (0, 0, 21705, 21705),
         16#03#           =>  --  010903
          (0, 0, 21706, 21706),
         16#04#           =>  --  010904
          (0, 0, 21707, 21707),
         16#05#           =>  --  010905
          (0, 0, 21708, 21708),
         16#06#           =>  --  010906
          (0, 0, 21709, 21709),
         16#07#           =>  --  010907
          (0, 0, 21710, 21710),
         16#08#           =>  --  010908
          (0, 0, 21711, 21711),
         16#09#           =>  --  010909
          (0, 0, 21712, 21712),
         16#0A#           =>  --  01090A
          (0, 0, 21713, 21713),
         16#0B#           =>  --  01090B
          (0, 0, 21714, 21714),
         16#0C#           =>  --  01090C
          (0, 0, 21715, 21715),
         16#0D#           =>  --  01090D
          (0, 0, 21716, 21716),
         16#0E#           =>  --  01090E
          (0, 0, 21717, 21717),
         16#0F#           =>  --  01090F
          (0, 0, 21718, 21718),
         16#10#           =>  --  010910
          (0, 0, 21719, 21719),
         16#11#           =>  --  010911
          (0, 0, 21720, 21720),
         16#12#           =>  --  010912
          (0, 0, 21721, 21721),
         16#13#           =>  --  010913
          (0, 0, 21722, 21722),
         16#14#           =>  --  010914
          (0, 0, 21723, 21723),
         16#15#           =>  --  010915
          (0, 0, 21724, 21724),
         16#16#           =>  --  010916
          (0, 0, 24, 24),
         16#17#           =>  --  010917
          (0, 0, 21725, 21725),
         16#18#           =>  --  010918
          (0, 0, 21726, 21726),
         16#19#           =>  --  010919
          (0, 0, 21727, 21727),
         16#1A#           =>  --  01091A
          (0, 0, 25, 25),
         16#1B#           =>  --  01091B
          (0, 0, 26, 26),
         16#1F#           =>  --  01091F
          (0, 0, 21728, 21728),
         16#20#           =>  --  010920
          (0, 0, 21729, 21729),
         16#21#           =>  --  010921
          (0, 0, 21730, 21730),
         16#22#           =>  --  010922
          (0, 0, 21731, 21731),
         16#23#           =>  --  010923
          (0, 0, 21732, 21732),
         16#24#           =>  --  010924
          (0, 0, 21733, 21733),
         16#25#           =>  --  010925
          (0, 0, 21734, 21734),
         16#26#           =>  --  010926
          (0, 0, 21735, 21735),
         16#27#           =>  --  010927
          (0, 0, 21736, 21736),
         16#28#           =>  --  010928
          (0, 0, 21737, 21737),
         16#29#           =>  --  010929
          (0, 0, 21738, 21738),
         16#2A#           =>  --  01092A
          (0, 0, 21739, 21739),
         16#2B#           =>  --  01092B
          (0, 0, 21740, 21740),
         16#2C#           =>  --  01092C
          (0, 0, 21741, 21741),
         16#2D#           =>  --  01092D
          (0, 0, 21742, 21742),
         16#2E#           =>  --  01092E
          (0, 0, 21743, 21743),
         16#2F#           =>  --  01092F
          (0, 0, 21744, 21744),
         16#30#           =>  --  010930
          (0, 0, 21745, 21745),
         16#31#           =>  --  010931
          (0, 0, 21746, 21746),
         16#32#           =>  --  010932
          (0, 0, 21747, 21747),
         16#33#           =>  --  010933
          (0, 0, 21748, 21748),
         16#34#           =>  --  010934
          (0, 0, 21749, 21749),
         16#35#           =>  --  010935
          (0, 0, 21750, 21750),
         16#36#           =>  --  010936
          (0, 0, 21751, 21751),
         16#37#           =>  --  010937
          (0, 0, 21752, 21752),
         16#38#           =>  --  010938
          (0, 0, 21753, 21753),
         16#39#           =>  --  010939
          (0, 0, 21754, 21754),
         16#3F#           =>  --  01093F
          (0, 0, 21755, 21755),
         16#80#           =>  --  010980
          (0, 0, 21756, 21757),
         16#81#           =>  --  010981
          (0, 0, 21758, 21759),
         16#82#           =>  --  010982
          (0, 0, 21760, 21761),
         16#83#           =>  --  010983
          (0, 0, 21762, 21763),
         16#84#           =>  --  010984
          (0, 0, 21764, 21765),
         16#85#           =>  --  010985
          (0, 0, 21766, 21767),
         16#86#           =>  --  010986
          (0, 0, 21768, 21769),
         16#87#           =>  --  010987
          (0, 0, 21770, 21771),
         16#88#           =>  --  010988
          (0, 0, 21772, 21773),
         16#89#           =>  --  010989
          (0, 0, 21774, 21775),
         16#8A#           =>  --  01098A
          (0, 0, 21776, 21777),
         16#8B#           =>  --  01098B
          (0, 0, 21778, 21779),
         16#8C#           =>  --  01098C
          (0, 0, 21780, 21781),
         16#8D#           =>  --  01098D
          (0, 0, 21782, 21783),
         16#8E#           =>  --  01098E
          (0, 0, 21784, 21785),
         16#8F#           =>  --  01098F
          (0, 0, 21786, 21787),
         16#90#           =>  --  010990
          (0, 0, 21788, 21789),
         16#91#           =>  --  010991
          (0, 0, 21790, 21791),
         16#92#           =>  --  010992
          (0, 0, 21792, 21793),
         16#93#           =>  --  010993
          (0, 0, 21794, 21795),
         16#94#           =>  --  010994
          (0, 0, 21796, 21797),
         16#95#           =>  --  010995
          (0, 0, 21798, 21799),
         16#96#           =>  --  010996
          (0, 0, 21800, 21801),
         16#97#           =>  --  010997
          (0, 0, 21802, 21803),
         16#98#           =>  --  010998
          (0, 0, 21804, 21805),
         16#99#           =>  --  010999
          (0, 0, 21806, 21807),
         16#9A#           =>  --  01099A
          (0, 0, 21808, 21809),
         16#9B#           =>  --  01099B
          (0, 0, 21810, 21811),
         16#9C#           =>  --  01099C
          (0, 0, 21812, 21813),
         16#9D#           =>  --  01099D
          (0, 0, 21814, 21815),
         16#9E#           =>  --  01099E
          (0, 0, 21816, 21816),
         16#9F#           =>  --  01099F
          (0, 0, 21817, 21817),
         16#A0#           =>  --  0109A0
          (0, 0, 21818, 21818),
         16#A1#           =>  --  0109A1
          (0, 0, 21819, 21819),
         16#A2#           =>  --  0109A2
          (0, 0, 21820, 21820),
         16#A3#           =>  --  0109A3
          (0, 0, 21821, 21821),
         16#A4#           =>  --  0109A4
          (0, 0, 21822, 21822),
         16#A5#           =>  --  0109A5
          (0, 0, 21823, 21823),
         16#A6#           =>  --  0109A6
          (0, 0, 21824, 21824),
         16#A7#           =>  --  0109A7
          (0, 0, 21825, 21825),
         16#A8#           =>  --  0109A8
          (0, 0, 21826, 21826),
         16#A9#           =>  --  0109A9
          (0, 0, 21827, 21827),
         16#AA#           =>  --  0109AA
          (0, 0, 21828, 21828),
         16#AB#           =>  --  0109AB
          (0, 0, 21829, 21829),
         16#AC#           =>  --  0109AC
          (0, 0, 21830, 21830),
         16#AD#           =>  --  0109AD
          (0, 0, 21831, 21831),
         16#AE#           =>  --  0109AE
          (0, 0, 21832, 21832),
         16#AF#           =>  --  0109AF
          (0, 0, 21833, 21833),
         16#B0#           =>  --  0109B0
          (0, 0, 21834, 21835),
         16#B1#           =>  --  0109B1
          (0, 0, 21836, 21836),
         16#B2#           =>  --  0109B2
          (0, 0, 21837, 21837),
         16#B3#           =>  --  0109B3
          (0, 0, 21838, 21838),
         16#B4#           =>  --  0109B4
          (0, 0, 21839, 21839),
         16#B5#           =>  --  0109B5
          (0, 0, 21840, 21840),
         16#B6#           =>  --  0109B6
          (0, 0, 21841, 21841),
         16#B7#           =>  --  0109B7
          (0, 0, 21842, 21842),
         16#BE#           =>  --  0109BE
          (0, 0, 21843, 21843),
         16#BF#           =>  --  0109BF
          (0, 0, 21844, 21844),
         others           =>
          (0, 0, 0, 0));

   Group_010A : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  010A00
          (0, 0, 21845, 21845),
         16#01#           =>  --  010A01
          (0, 0, 21846, 21846),
         16#02#           =>  --  010A02
          (0, 0, 21847, 21847),
         16#03#           =>  --  010A03
          (0, 0, 21848, 21848),
         16#05#           =>  --  010A05
          (0, 0, 21849, 21849),
         16#06#           =>  --  010A06
          (0, 0, 21850, 21850),
         16#0C#           =>  --  010A0C
          (0, 0, 21851, 21851),
         16#0D#           =>  --  010A0D
          (0, 0, 1045, 1045),
         16#0E#           =>  --  010A0E
          (0, 0, 2243, 2243),
         16#0F#           =>  --  010A0F
          (0, 0, 2244, 2244),
         16#10#           =>  --  010A10
          (0, 0, 21852, 21852),
         16#11#           =>  --  010A11
          (0, 0, 21853, 21853),
         16#12#           =>  --  010A12
          (0, 0, 21854, 21854),
         16#13#           =>  --  010A13
          (0, 0, 21855, 21855),
         16#15#           =>  --  010A15
          (0, 0, 21856, 21856),
         16#16#           =>  --  010A16
          (0, 0, 21857, 21857),
         16#17#           =>  --  010A17
          (0, 0, 21858, 21858),
         16#19#           =>  --  010A19
          (0, 0, 21859, 21859),
         16#1A#           =>  --  010A1A
          (0, 0, 21860, 21860),
         16#1B#           =>  --  010A1B
          (0, 0, 21861, 21861),
         16#1C#           =>  --  010A1C
          (0, 0, 21862, 21862),
         16#1D#           =>  --  010A1D
          (0, 0, 21863, 21863),
         16#1E#           =>  --  010A1E
          (0, 0, 21864, 21864),
         16#1F#           =>  --  010A1F
          (0, 0, 21865, 21865),
         16#20#           =>  --  010A20
          (0, 0, 21866, 21866),
         16#21#           =>  --  010A21
          (0, 0, 21867, 21867),
         16#22#           =>  --  010A22
          (0, 0, 21868, 21868),
         16#23#           =>  --  010A23
          (0, 0, 21869, 21869),
         16#24#           =>  --  010A24
          (0, 0, 21870, 21870),
         16#25#           =>  --  010A25
          (0, 0, 21871, 21871),
         16#26#           =>  --  010A26
          (0, 0, 21872, 21872),
         16#27#           =>  --  010A27
          (0, 0, 21873, 21873),
         16#28#           =>  --  010A28
          (0, 0, 21874, 21874),
         16#29#           =>  --  010A29
          (0, 0, 21875, 21875),
         16#2A#           =>  --  010A2A
          (0, 0, 21876, 21876),
         16#2B#           =>  --  010A2B
          (0, 0, 21877, 21877),
         16#2C#           =>  --  010A2C
          (0, 0, 21878, 21878),
         16#2D#           =>  --  010A2D
          (0, 0, 21879, 21879),
         16#2E#           =>  --  010A2E
          (0, 0, 21880, 21880),
         16#2F#           =>  --  010A2F
          (0, 0, 21881, 21881),
         16#30#           =>  --  010A30
          (0, 0, 21882, 21882),
         16#31#           =>  --  010A31
          (0, 0, 21883, 21883),
         16#32#           =>  --  010A32
          (0, 0, 21884, 21884),
         16#33#           =>  --  010A33
          (0, 0, 21885, 21885),
         16#38#           =>  --  010A38
          (0, 0, 21886, 21886),
         16#39#           =>  --  010A39
          (0, 0, 21887, 21887),
         16#3A#           =>  --  010A3A
          (0, 0, 21888, 21888),
         16#3F#           =>  --  010A3F
          (0, 0, 21889, 21889),
         16#40#           =>  --  010A40
          (0, 0, 24, 24),
         16#41#           =>  --  010A41
          (0, 0, 25, 25),
         16#42#           =>  --  010A42
          (0, 0, 26, 26),
         16#43#           =>  --  010A43
          (0, 0, 27, 27),
         16#44#           =>  --  010A44
          (0, 0, 21890, 21890),
         16#45#           =>  --  010A45
          (0, 0, 21891, 21891),
         16#46#           =>  --  010A46
          (0, 0, 21892, 21892),
         16#47#           =>  --  010A47
          (0, 0, 21893, 21893),
         16#50#           =>  --  010A50
          (0, 0, 21894, 21894),
         16#51#           =>  --  010A51
          (0, 0, 21895, 21895),
         16#52#           =>  --  010A52
          (0, 0, 21896, 21896),
         16#53#           =>  --  010A53
          (0, 0, 21897, 21897),
         16#54#           =>  --  010A54
          (0, 0, 21898, 21898),
         16#55#           =>  --  010A55
          (0, 0, 21899, 21899),
         16#56#           =>  --  010A56
          (0, 0, 21900, 21900),
         16#57#           =>  --  010A57
          (0, 0, 21901, 21901),
         16#58#           =>  --  010A58
          (0, 0, 21902, 21902),
         16#60#           =>  --  010A60
          (0, 0, 21903, 21903),
         16#61#           =>  --  010A61
          (0, 0, 21904, 21904),
         16#62#           =>  --  010A62
          (0, 0, 21905, 21905),
         16#63#           =>  --  010A63
          (0, 0, 21906, 21906),
         16#64#           =>  --  010A64
          (0, 0, 21907, 21907),
         16#65#           =>  --  010A65
          (0, 0, 21908, 21908),
         16#66#           =>  --  010A66
          (0, 0, 21909, 21909),
         16#67#           =>  --  010A67
          (0, 0, 21910, 21910),
         16#68#           =>  --  010A68
          (0, 0, 21911, 21911),
         16#69#           =>  --  010A69
          (0, 0, 21912, 21912),
         16#6A#           =>  --  010A6A
          (0, 0, 21913, 21913),
         16#6B#           =>  --  010A6B
          (0, 0, 21914, 21914),
         16#6C#           =>  --  010A6C
          (0, 0, 21915, 21915),
         16#6D#           =>  --  010A6D
          (0, 0, 21916, 21916),
         16#6E#           =>  --  010A6E
          (0, 0, 21917, 21917),
         16#6F#           =>  --  010A6F
          (0, 0, 21918, 21918),
         16#70#           =>  --  010A70
          (0, 0, 21919, 21919),
         16#71#           =>  --  010A71
          (0, 0, 21920, 21920),
         16#72#           =>  --  010A72
          (0, 0, 21921, 21921),
         16#73#           =>  --  010A73
          (0, 0, 21922, 21922),
         16#74#           =>  --  010A74
          (0, 0, 21923, 21923),
         16#75#           =>  --  010A75
          (0, 0, 21924, 21924),
         16#76#           =>  --  010A76
          (0, 0, 21925, 21925),
         16#77#           =>  --  010A77
          (0, 0, 21926, 21926),
         16#78#           =>  --  010A78
          (0, 0, 21927, 21927),
         16#79#           =>  --  010A79
          (0, 0, 21928, 21928),
         16#7A#           =>  --  010A7A
          (0, 0, 21929, 21929),
         16#7B#           =>  --  010A7B
          (0, 0, 21930, 21930),
         16#7C#           =>  --  010A7C
          (0, 0, 21931, 21931),
         16#7D#           =>  --  010A7D
          (0, 0, 24, 24),
         16#7E#           =>  --  010A7E
          (0, 0, 21932, 21932),
         16#7F#           =>  --  010A7F
          (0, 0, 21933, 21933),
         16#80#           =>  --  010A80
          (0, 0, 21934, 21934),
         16#81#           =>  --  010A81
          (0, 0, 21935, 21935),
         16#82#           =>  --  010A82
          (0, 0, 21936, 21936),
         16#83#           =>  --  010A83
          (0, 0, 21937, 21937),
         16#84#           =>  --  010A84
          (0, 0, 21938, 21938),
         16#85#           =>  --  010A85
          (0, 0, 21939, 21939),
         16#86#           =>  --  010A86
          (0, 0, 21940, 21940),
         16#87#           =>  --  010A87
          (0, 0, 21941, 21941),
         16#88#           =>  --  010A88
          (0, 0, 21942, 21942),
         16#89#           =>  --  010A89
          (0, 0, 21943, 21943),
         16#8A#           =>  --  010A8A
          (0, 0, 21944, 21944),
         16#8B#           =>  --  010A8B
          (0, 0, 21945, 21945),
         16#8C#           =>  --  010A8C
          (0, 0, 21946, 21946),
         16#8D#           =>  --  010A8D
          (0, 0, 21947, 21947),
         16#8E#           =>  --  010A8E
          (0, 0, 21948, 21948),
         16#8F#           =>  --  010A8F
          (0, 0, 21949, 21949),
         16#90#           =>  --  010A90
          (0, 0, 21950, 21950),
         16#91#           =>  --  010A91
          (0, 0, 21951, 21951),
         16#92#           =>  --  010A92
          (0, 0, 21952, 21952),
         16#93#           =>  --  010A93
          (0, 0, 21953, 21953),
         16#94#           =>  --  010A94
          (0, 0, 21954, 21954),
         16#95#           =>  --  010A95
          (0, 0, 21955, 21955),
         16#96#           =>  --  010A96
          (0, 0, 21956, 21956),
         16#97#           =>  --  010A97
          (0, 0, 21957, 21957),
         16#98#           =>  --  010A98
          (0, 0, 21958, 21958),
         16#99#           =>  --  010A99
          (0, 0, 21959, 21959),
         16#9A#           =>  --  010A9A
          (0, 0, 21960, 21960),
         16#9B#           =>  --  010A9B
          (0, 0, 21961, 21961),
         16#9C#           =>  --  010A9C
          (0, 0, 21962, 21962),
         16#9D#           =>  --  010A9D
          (0, 0, 24, 24),
         16#9E#           =>  --  010A9E
          (0, 0, 21963, 21963),
         16#9F#           =>  --  010A9F
          (0, 0, 21964, 21964),
         16#C0#           =>  --  010AC0
          (0, 0, 21965, 21965),
         16#C1#           =>  --  010AC1
          (0, 0, 21966, 21966),
         16#C2#           =>  --  010AC2
          (0, 0, 21967, 21967),
         16#C3#           =>  --  010AC3
          (0, 0, 21968, 21968),
         16#C4#           =>  --  010AC4
          (0, 0, 21969, 21969),
         16#C5#           =>  --  010AC5
          (0, 0, 21970, 21970),
         16#C6#           =>  --  010AC6
          (0, 0, 21971, 21971),
         16#C7#           =>  --  010AC7
          (0, 0, 21972, 21972),
         16#C8#           =>  --  010AC8
          (0, 0, 21973, 21974),
         16#C9#           =>  --  010AC9
          (0, 0, 21975, 21975),
         16#CA#           =>  --  010ACA
          (0, 0, 21976, 21976),
         16#CB#           =>  --  010ACB
          (0, 0, 21977, 21977),
         16#CC#           =>  --  010ACC
          (0, 0, 21978, 21978),
         16#CD#           =>  --  010ACD
          (0, 0, 21979, 21979),
         16#CE#           =>  --  010ACE
          (0, 0, 21980, 21980),
         16#CF#           =>  --  010ACF
          (0, 0, 21981, 21981),
         16#D0#           =>  --  010AD0
          (0, 0, 21982, 21982),
         16#D1#           =>  --  010AD1
          (0, 0, 21983, 21983),
         16#D2#           =>  --  010AD2
          (0, 0, 21984, 21984),
         16#D3#           =>  --  010AD3
          (0, 0, 21985, 21985),
         16#D4#           =>  --  010AD4
          (0, 0, 21986, 21986),
         16#D5#           =>  --  010AD5
          (0, 0, 21987, 21987),
         16#D6#           =>  --  010AD6
          (0, 0, 21988, 21988),
         16#D7#           =>  --  010AD7
          (0, 0, 21989, 21989),
         16#D8#           =>  --  010AD8
          (0, 0, 21990, 21990),
         16#D9#           =>  --  010AD9
          (0, 0, 21991, 21991),
         16#DA#           =>  --  010ADA
          (0, 0, 21992, 21992),
         16#DB#           =>  --  010ADB
          (0, 0, 21993, 21993),
         16#DC#           =>  --  010ADC
          (0, 0, 21994, 21994),
         16#DD#           =>  --  010ADD
          (0, 0, 21995, 21995),
         16#DE#           =>  --  010ADE
          (0, 0, 21996, 21996),
         16#DF#           =>  --  010ADF
          (0, 0, 21997, 21997),
         16#E0#           =>  --  010AE0
          (0, 0, 21998, 21998),
         16#E1#           =>  --  010AE1
          (0, 0, 21999, 21999),
         16#E2#           =>  --  010AE2
          (0, 0, 22000, 22000),
         16#E3#           =>  --  010AE3
          (0, 0, 22001, 22001),
         16#E4#           =>  --  010AE4
          (0, 0, 22002, 22002),
         16#E5#           =>  --  010AE5
          (0, 0, 1041, 1041),
         16#E6#           =>  --  010AE6
          (0, 0, 1045, 1045),
         16#EB#           =>  --  010AEB
          (0, 0, 24, 24),
         16#EC#           =>  --  010AEC
          (0, 0, 28, 28),
         16#ED#           =>  --  010AED
          (0, 0, 22003, 22003),
         16#EE#           =>  --  010AEE
          (0, 0, 22004, 22004),
         16#EF#           =>  --  010AEF
          (0, 0, 22005, 22005),
         16#F0#           =>  --  010AF0
          (0, 0, 22006, 22006),
         16#F1#           =>  --  010AF1
          (0, 0, 22007, 22007),
         16#F2#           =>  --  010AF2
          (0, 0, 22008, 22008),
         16#F3#           =>  --  010AF3
          (0, 0, 22009, 22009),
         16#F4#           =>  --  010AF4
          (0, 0, 22010, 22010),
         16#F5#           =>  --  010AF5
          (0, 0, 22011, 22011),
         16#F6#           =>  --  010AF6
          (0, 0, 22012, 22012),
         others           =>
          (0, 0, 0, 0));

   Group_010B : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  010B00
          (0, 0, 22013, 22013),
         16#01#           =>  --  010B01
          (0, 0, 22014, 22014),
         16#02#           =>  --  010B02
          (0, 0, 22015, 22015),
         16#03#           =>  --  010B03
          (0, 0, 22016, 22016),
         16#04#           =>  --  010B04
          (0, 0, 22017, 22017),
         16#05#           =>  --  010B05
          (0, 0, 22018, 22018),
         16#06#           =>  --  010B06
          (0, 0, 22019, 22019),
         16#07#           =>  --  010B07
          (0, 0, 22020, 22020),
         16#08#           =>  --  010B08
          (0, 0, 22021, 22021),
         16#09#           =>  --  010B09
          (0, 0, 22022, 22022),
         16#0A#           =>  --  010B0A
          (0, 0, 22023, 22023),
         16#0B#           =>  --  010B0B
          (0, 0, 22024, 22024),
         16#0C#           =>  --  010B0C
          (0, 0, 22025, 22025),
         16#0D#           =>  --  010B0D
          (0, 0, 22026, 22026),
         16#0E#           =>  --  010B0E
          (0, 0, 22027, 22027),
         16#0F#           =>  --  010B0F
          (0, 0, 22028, 22028),
         16#10#           =>  --  010B10
          (0, 0, 22029, 22029),
         16#11#           =>  --  010B11
          (0, 0, 22030, 22030),
         16#12#           =>  --  010B12
          (0, 0, 22031, 22031),
         16#13#           =>  --  010B13
          (0, 0, 22032, 22032),
         16#14#           =>  --  010B14
          (0, 0, 22033, 22033),
         16#15#           =>  --  010B15
          (0, 0, 22034, 22034),
         16#16#           =>  --  010B16
          (0, 0, 22035, 22035),
         16#17#           =>  --  010B17
          (0, 0, 22036, 22036),
         16#18#           =>  --  010B18
          (0, 0, 22037, 22037),
         16#19#           =>  --  010B19
          (0, 0, 22038, 22038),
         16#1A#           =>  --  010B1A
          (0, 0, 22039, 22039),
         16#1B#           =>  --  010B1B
          (0, 0, 22040, 22040),
         16#1C#           =>  --  010B1C
          (0, 0, 22041, 22041),
         16#1D#           =>  --  010B1D
          (0, 0, 22042, 22042),
         16#1E#           =>  --  010B1E
          (0, 0, 22043, 22043),
         16#1F#           =>  --  010B1F
          (0, 0, 22044, 22044),
         16#20#           =>  --  010B20
          (0, 0, 22045, 22045),
         16#21#           =>  --  010B21
          (0, 0, 22046, 22046),
         16#22#           =>  --  010B22
          (0, 0, 22047, 22047),
         16#23#           =>  --  010B23
          (0, 0, 22048, 22048),
         16#24#           =>  --  010B24
          (0, 0, 22049, 22049),
         16#25#           =>  --  010B25
          (0, 0, 22050, 22050),
         16#26#           =>  --  010B26
          (0, 0, 22051, 22051),
         16#27#           =>  --  010B27
          (0, 0, 22052, 22052),
         16#28#           =>  --  010B28
          (0, 0, 22053, 22053),
         16#29#           =>  --  010B29
          (0, 0, 22054, 22054),
         16#2A#           =>  --  010B2A
          (0, 0, 22055, 22055),
         16#2B#           =>  --  010B2B
          (0, 0, 22056, 22056),
         16#2C#           =>  --  010B2C
          (0, 0, 22057, 22057),
         16#2D#           =>  --  010B2D
          (0, 0, 22058, 22058),
         16#2E#           =>  --  010B2E
          (0, 0, 22059, 22060),
         16#2F#           =>  --  010B2F
          (0, 0, 22061, 22061),
         16#30#           =>  --  010B30
          (0, 0, 22062, 22062),
         16#31#           =>  --  010B31
          (0, 0, 22063, 22063),
         16#32#           =>  --  010B32
          (0, 0, 22064, 22064),
         16#33#           =>  --  010B33
          (0, 0, 22065, 22065),
         16#34#           =>  --  010B34
          (0, 0, 22066, 22066),
         16#35#           =>  --  010B35
          (0, 0, 22067, 22067),
         16#39#           =>  --  010B39
          (0, 0, 22068, 22068),
         16#3A#           =>  --  010B3A
          (0, 0, 22069, 22069),
         16#3B#           =>  --  010B3B
          (0, 0, 22070, 22070),
         16#3C#           =>  --  010B3C
          (0, 0, 22071, 22071),
         16#3D#           =>  --  010B3D
          (0, 0, 22072, 22072),
         16#3E#           =>  --  010B3E
          (0, 0, 22073, 22073),
         16#3F#           =>  --  010B3F
          (0, 0, 22074, 22074),
         16#40#           =>  --  010B40
          (0, 0, 22075, 22075),
         16#41#           =>  --  010B41
          (0, 0, 22076, 22076),
         16#42#           =>  --  010B42
          (0, 0, 22077, 22077),
         16#43#           =>  --  010B43
          (0, 0, 22078, 22078),
         16#44#           =>  --  010B44
          (0, 0, 22079, 22079),
         16#45#           =>  --  010B45
          (0, 0, 22080, 22080),
         16#46#           =>  --  010B46
          (0, 0, 22081, 22081),
         16#47#           =>  --  010B47
          (0, 0, 22082, 22082),
         16#48#           =>  --  010B48
          (0, 0, 22083, 22083),
         16#49#           =>  --  010B49
          (0, 0, 22084, 22084),
         16#4A#           =>  --  010B4A
          (0, 0, 22085, 22085),
         16#4B#           =>  --  010B4B
          (0, 0, 22086, 22086),
         16#4C#           =>  --  010B4C
          (0, 0, 22087, 22087),
         16#4D#           =>  --  010B4D
          (0, 0, 22088, 22088),
         16#4E#           =>  --  010B4E
          (0, 0, 22089, 22089),
         16#4F#           =>  --  010B4F
          (0, 0, 22090, 22090),
         16#50#           =>  --  010B50
          (0, 0, 22091, 22091),
         16#51#           =>  --  010B51
          (0, 0, 22092, 22092),
         16#52#           =>  --  010B52
          (0, 0, 22093, 22093),
         16#53#           =>  --  010B53
          (0, 0, 22094, 22094),
         16#54#           =>  --  010B54
          (0, 0, 22095, 22095),
         16#55#           =>  --  010B55
          (0, 0, 22096, 22096),
         16#58#           =>  --  010B58
          (0, 0, 24, 24),
         16#59#           =>  --  010B59
          (0, 0, 25, 25),
         16#5A#           =>  --  010B5A
          (0, 0, 26, 26),
         16#5B#           =>  --  010B5B
          (0, 0, 27, 27),
         16#5C#           =>  --  010B5C
          (0, 0, 22097, 22097),
         16#5D#           =>  --  010B5D
          (0, 0, 22098, 22098),
         16#5E#           =>  --  010B5E
          (0, 0, 22099, 22099),
         16#5F#           =>  --  010B5F
          (0, 0, 22100, 22100),
         16#60#           =>  --  010B60
          (0, 0, 22101, 22101),
         16#61#           =>  --  010B61
          (0, 0, 22102, 22102),
         16#62#           =>  --  010B62
          (0, 0, 22103, 22103),
         16#63#           =>  --  010B63
          (0, 0, 22104, 22104),
         16#64#           =>  --  010B64
          (0, 0, 22105, 22105),
         16#65#           =>  --  010B65
          (0, 0, 22106, 22106),
         16#66#           =>  --  010B66
          (0, 0, 22107, 22107),
         16#67#           =>  --  010B67
          (0, 0, 22108, 22108),
         16#68#           =>  --  010B68
          (0, 0, 22109, 22109),
         16#69#           =>  --  010B69
          (0, 0, 22110, 22110),
         16#6A#           =>  --  010B6A
          (0, 0, 22111, 22111),
         16#6B#           =>  --  010B6B
          (0, 0, 22112, 22112),
         16#6C#           =>  --  010B6C
          (0, 0, 22113, 22113),
         16#6D#           =>  --  010B6D
          (0, 0, 22114, 22114),
         16#6E#           =>  --  010B6E
          (0, 0, 22115, 22115),
         16#6F#           =>  --  010B6F
          (0, 0, 22116, 22116),
         16#70#           =>  --  010B70
          (0, 0, 22117, 22117),
         16#71#           =>  --  010B71
          (0, 0, 22118, 22118),
         16#72#           =>  --  010B72
          (0, 0, 22119, 22119),
         16#78#           =>  --  010B78
          (0, 0, 24, 24),
         16#79#           =>  --  010B79
          (0, 0, 25, 25),
         16#7A#           =>  --  010B7A
          (0, 0, 26, 26),
         16#7B#           =>  --  010B7B
          (0, 0, 27, 27),
         16#7C#           =>  --  010B7C
          (0, 0, 22120, 22120),
         16#7D#           =>  --  010B7D
          (0, 0, 22121, 22121),
         16#7E#           =>  --  010B7E
          (0, 0, 22122, 22122),
         16#7F#           =>  --  010B7F
          (0, 0, 22123, 22123),
         16#80#           =>  --  010B80
          (0, 0, 22124, 22124),
         16#81#           =>  --  010B81
          (0, 0, 22125, 22125),
         16#82#           =>  --  010B82
          (0, 0, 22126, 22126),
         16#83#           =>  --  010B83
          (0, 0, 22127, 22127),
         16#84#           =>  --  010B84
          (0, 0, 22128, 22128),
         16#85#           =>  --  010B85
          (0, 0, 22129, 22129),
         16#86#           =>  --  010B86
          (0, 0, 22130, 22130),
         16#87#           =>  --  010B87
          (0, 0, 22131, 22131),
         16#88#           =>  --  010B88
          (0, 0, 22132, 22132),
         16#89#           =>  --  010B89
          (0, 0, 22133, 22133),
         16#8A#           =>  --  010B8A
          (0, 0, 22134, 22134),
         16#8B#           =>  --  010B8B
          (0, 0, 22135, 22135),
         16#8C#           =>  --  010B8C
          (0, 0, 22136, 22136),
         16#8D#           =>  --  010B8D
          (0, 0, 22137, 22137),
         16#8E#           =>  --  010B8E
          (0, 0, 22138, 22138),
         16#8F#           =>  --  010B8F
          (0, 0, 22139, 22139),
         16#90#           =>  --  010B90
          (0, 0, 22140, 22140),
         16#91#           =>  --  010B91
          (0, 0, 22141, 22141),
         16#99#           =>  --  010B99
          (0, 0, 22142, 22142),
         16#9A#           =>  --  010B9A
          (0, 0, 22143, 22143),
         16#9B#           =>  --  010B9B
          (0, 0, 22144, 22144),
         16#9C#           =>  --  010B9C
          (0, 0, 22145, 22145),
         16#A9#           =>  --  010BA9
          (0, 0, 24, 24),
         16#AA#           =>  --  010BAA
          (0, 0, 25, 25),
         16#AB#           =>  --  010BAB
          (0, 0, 26, 26),
         16#AC#           =>  --  010BAC
          (0, 0, 27, 27),
         16#AD#           =>  --  010BAD
          (0, 0, 22146, 22146),
         16#AE#           =>  --  010BAE
          (0, 0, 22147, 22147),
         16#AF#           =>  --  010BAF
          (0, 0, 22148, 22148),
         others           =>
          (0, 0, 0, 0));

   Group_010C : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  010C00
          (0, 0, 22149, 22149),
         16#01#           =>  --  010C01
          (0, 0, 22150, 22151),
         16#02#           =>  --  010C02
          (0, 0, 22152, 22152),
         16#03#           =>  --  010C03
          (0, 0, 22153, 22153),
         16#04#           =>  --  010C04
          (0, 0, 22154, 22155),
         16#05#           =>  --  010C05
          (0, 0, 22156, 22156),
         16#06#           =>  --  010C06
          (0, 0, 22157, 22157),
         16#07#           =>  --  010C07
          (0, 0, 22158, 22158),
         16#08#           =>  --  010C08
          (0, 0, 22159, 22160),
         16#09#           =>  --  010C09
          (0, 0, 22161, 22161),
         16#0A#           =>  --  010C0A
          (0, 0, 22162, 22163),
         16#0B#           =>  --  010C0B
          (0, 0, 22164, 22164),
         16#0C#           =>  --  010C0C
          (0, 0, 22165, 22166),
         16#0D#           =>  --  010C0D
          (0, 0, 22167, 22167),
         16#0E#           =>  --  010C0E
          (0, 0, 22168, 22169),
         16#0F#           =>  --  010C0F
          (0, 0, 22170, 22170),
         16#10#           =>  --  010C10
          (0, 0, 22171, 22172),
         16#11#           =>  --  010C11
          (0, 0, 22173, 22173),
         16#12#           =>  --  010C12
          (0, 0, 22174, 22175),
         16#13#           =>  --  010C13
          (0, 0, 22176, 22176),
         16#14#           =>  --  010C14
          (0, 0, 22177, 22177),
         16#15#           =>  --  010C15
          (0, 0, 22178, 22179),
         16#16#           =>  --  010C16
          (0, 0, 22180, 22180),
         16#17#           =>  --  010C17
          (0, 0, 22181, 22182),
         16#18#           =>  --  010C18
          (0, 0, 22183, 22183),
         16#19#           =>  --  010C19
          (0, 0, 22184, 22185),
         16#1A#           =>  --  010C1A
          (0, 0, 22186, 22186),
         16#1B#           =>  --  010C1B
          (0, 0, 22187, 22188),
         16#1C#           =>  --  010C1C
          (0, 0, 22189, 22189),
         16#1D#           =>  --  010C1D
          (0, 0, 22190, 22191),
         16#1E#           =>  --  010C1E
          (0, 0, 22192, 22192),
         16#1F#           =>  --  010C1F
          (0, 0, 22193, 22194),
         16#20#           =>  --  010C20
          (0, 0, 22195, 22195),
         16#21#           =>  --  010C21
          (0, 0, 22196, 22196),
         16#22#           =>  --  010C22
          (0, 0, 22197, 22197),
         16#23#           =>  --  010C23
          (0, 0, 22198, 22198),
         16#24#           =>  --  010C24
          (0, 0, 22199, 22199),
         16#25#           =>  --  010C25
          (0, 0, 22200, 22201),
         16#26#           =>  --  010C26
          (0, 0, 22202, 22202),
         16#27#           =>  --  010C27
          (0, 0, 22203, 22204),
         16#28#           =>  --  010C28
          (0, 0, 22205, 22205),
         16#29#           =>  --  010C29
          (0, 0, 22206, 22207),
         16#2A#           =>  --  010C2A
          (0, 0, 22208, 22208),
         16#2B#           =>  --  010C2B
          (0, 0, 22209, 22210),
         16#2C#           =>  --  010C2C
          (0, 0, 22211, 22211),
         16#2D#           =>  --  010C2D
          (0, 0, 22212, 22212),
         16#2E#           =>  --  010C2E
          (0, 0, 22213, 22214),
         16#2F#           =>  --  010C2F
          (0, 0, 22215, 22215),
         16#30#           =>  --  010C30
          (0, 0, 22216, 22216),
         16#31#           =>  --  010C31
          (0, 0, 22217, 22217),
         16#32#           =>  --  010C32
          (0, 0, 22218, 22218),
         16#33#           =>  --  010C33
          (0, 0, 22219, 22220),
         16#34#           =>  --  010C34
          (0, 0, 22221, 22221),
         16#35#           =>  --  010C35
          (0, 0, 22222, 22223),
         16#36#           =>  --  010C36
          (0, 0, 22224, 22224),
         16#37#           =>  --  010C37
          (0, 0, 22225, 22226),
         16#38#           =>  --  010C38
          (0, 0, 22227, 22227),
         16#39#           =>  --  010C39
          (0, 0, 22228, 22229),
         16#3A#           =>  --  010C3A
          (0, 0, 22230, 22230),
         16#3B#           =>  --  010C3B
          (0, 0, 22231, 22232),
         16#3C#           =>  --  010C3C
          (0, 0, 22233, 22233),
         16#3D#           =>  --  010C3D
          (0, 0, 22234, 22234),
         16#3E#           =>  --  010C3E
          (0, 0, 22235, 22235),
         16#3F#           =>  --  010C3F
          (0, 0, 22236, 22236),
         16#40#           =>  --  010C40
          (0, 0, 22237, 22238),
         16#41#           =>  --  010C41
          (0, 0, 22239, 22239),
         16#42#           =>  --  010C42
          (0, 0, 22240, 22241),
         16#43#           =>  --  010C43
          (0, 0, 22242, 22242),
         16#44#           =>  --  010C44
          (0, 0, 22243, 22244),
         16#45#           =>  --  010C45
          (0, 0, 22245, 22245),
         16#46#           =>  --  010C46
          (0, 0, 22246, 22247),
         16#47#           =>  --  010C47
          (0, 0, 22248, 22248),
         16#48#           =>  --  010C48
          (0, 0, 22249, 22249),
         others           =>
          (0, 0, 0, 0));

   Group_010E : aliased constant Collation_Second_Stage
     := (16#60#           =>  --  010E60
          (0, 0, 24, 24),
         16#61#           =>  --  010E61
          (0, 0, 25, 25),
         16#62#           =>  --  010E62
          (0, 0, 26, 26),
         16#63#           =>  --  010E63
          (0, 0, 27, 27),
         16#64#           =>  --  010E64
          (0, 0, 28, 28),
         16#65#           =>  --  010E65
          (0, 0, 29, 29),
         16#66#           =>  --  010E66
          (0, 0, 30, 30),
         16#67#           =>  --  010E67
          (0, 0, 31, 31),
         16#68#           =>  --  010E68
          (0, 0, 32, 32),
         16#69#           =>  --  010E69
          (0, 0, 22250, 22250),
         16#6A#           =>  --  010E6A
          (0, 0, 22251, 22251),
         16#6B#           =>  --  010E6B
          (0, 0, 22252, 22252),
         16#6C#           =>  --  010E6C
          (0, 0, 22253, 22253),
         16#6D#           =>  --  010E6D
          (0, 0, 22254, 22254),
         16#6E#           =>  --  010E6E
          (0, 0, 22255, 22255),
         16#6F#           =>  --  010E6F
          (0, 0, 22256, 22256),
         16#70#           =>  --  010E70
          (0, 0, 22257, 22257),
         16#71#           =>  --  010E71
          (0, 0, 22258, 22258),
         16#72#           =>  --  010E72
          (0, 0, 22259, 22259),
         16#73#           =>  --  010E73
          (0, 0, 22260, 22260),
         16#74#           =>  --  010E74
          (0, 0, 22261, 22261),
         16#75#           =>  --  010E75
          (0, 0, 22262, 22262),
         16#76#           =>  --  010E76
          (0, 0, 22263, 22263),
         16#77#           =>  --  010E77
          (0, 0, 22264, 22264),
         16#78#           =>  --  010E78
          (0, 0, 22265, 22265),
         16#79#           =>  --  010E79
          (0, 0, 22266, 22266),
         16#7A#           =>  --  010E7A
          (0, 0, 22267, 22267),
         16#7B#           =>  --  010E7B
          (0, 0, 22268, 22268),
         16#7C#           =>  --  010E7C
          (0, 0, 22269, 22269),
         16#7D#           =>  --  010E7D
          (0, 0, 22270, 22270),
         16#7E#           =>  --  010E7E
          (0, 0, 22271, 22271),
         others           =>
          (0, 0, 0, 0));

   Group_0110 : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  011000
          (0, 0, 2242, 2242),
         16#01#           =>  --  011001
          (0, 0, 2243, 2243),
         16#02#           =>  --  011002
          (0, 0, 2244, 2244),
         16#03#           =>  --  011003
          (0, 0, 22272, 22272),
         16#04#           =>  --  011004
          (0, 0, 22273, 22273),
         16#05#           =>  --  011005
          (0, 0, 22274, 22274),
         16#06#           =>  --  011006
          (0, 0, 22275, 22275),
         16#07#           =>  --  011007
          (0, 0, 22276, 22276),
         16#08#           =>  --  011008
          (0, 0, 22277, 22277),
         16#09#           =>  --  011009
          (0, 0, 22278, 22278),
         16#0A#           =>  --  01100A
          (0, 0, 22279, 22279),
         16#0B#           =>  --  01100B
          (0, 0, 22280, 22280),
         16#0C#           =>  --  01100C
          (0, 0, 22281, 22281),
         16#0D#           =>  --  01100D
          (0, 0, 22282, 22282),
         16#0E#           =>  --  01100E
          (0, 0, 22283, 22283),
         16#0F#           =>  --  01100F
          (0, 0, 22284, 22284),
         16#10#           =>  --  011010
          (0, 0, 22285, 22285),
         16#11#           =>  --  011011
          (0, 0, 22286, 22286),
         16#12#           =>  --  011012
          (0, 0, 22287, 22287),
         16#13#           =>  --  011013
          (0, 0, 22288, 22288),
         16#14#           =>  --  011014
          (0, 0, 22289, 22289),
         16#15#           =>  --  011015
          (0, 0, 22290, 22290),
         16#16#           =>  --  011016
          (0, 0, 22291, 22291),
         16#17#           =>  --  011017
          (0, 0, 22292, 22292),
         16#18#           =>  --  011018
          (0, 0, 22293, 22293),
         16#19#           =>  --  011019
          (0, 0, 22294, 22294),
         16#1A#           =>  --  01101A
          (0, 0, 22295, 22295),
         16#1B#           =>  --  01101B
          (0, 0, 22296, 22296),
         16#1C#           =>  --  01101C
          (0, 0, 22297, 22297),
         16#1D#           =>  --  01101D
          (0, 0, 22298, 22298),
         16#1E#           =>  --  01101E
          (0, 0, 22299, 22299),
         16#1F#           =>  --  01101F
          (0, 0, 22300, 22300),
         16#20#           =>  --  011020
          (0, 0, 22301, 22301),
         16#21#           =>  --  011021
          (0, 0, 22302, 22302),
         16#22#           =>  --  011022
          (0, 0, 22303, 22303),
         16#23#           =>  --  011023
          (0, 0, 22304, 22304),
         16#24#           =>  --  011024
          (0, 0, 22305, 22305),
         16#25#           =>  --  011025
          (0, 0, 22306, 22306),
         16#26#           =>  --  011026
          (0, 0, 22307, 22307),
         16#27#           =>  --  011027
          (0, 0, 22308, 22308),
         16#28#           =>  --  011028
          (0, 0, 22309, 22309),
         16#29#           =>  --  011029
          (0, 0, 22310, 22310),
         16#2A#           =>  --  01102A
          (0, 0, 22311, 22311),
         16#2B#           =>  --  01102B
          (0, 0, 22312, 22312),
         16#2C#           =>  --  01102C
          (0, 0, 22313, 22313),
         16#2D#           =>  --  01102D
          (0, 0, 22314, 22314),
         16#2E#           =>  --  01102E
          (0, 0, 22315, 22315),
         16#2F#           =>  --  01102F
          (0, 0, 22316, 22316),
         16#30#           =>  --  011030
          (0, 0, 22317, 22317),
         16#31#           =>  --  011031
          (0, 0, 22318, 22318),
         16#32#           =>  --  011032
          (0, 0, 22319, 22319),
         16#33#           =>  --  011033
          (0, 0, 22320, 22320),
         16#34#           =>  --  011034
          (0, 0, 22321, 22321),
         16#35#           =>  --  011035
          (0, 0, 22322, 22322),
         16#36#           =>  --  011036
          (0, 0, 22323, 22323),
         16#37#           =>  --  011037
          (0, 0, 22324, 22324),
         16#38#           =>  --  011038
          (0, 0, 22325, 22325),
         16#39#           =>  --  011039
          (0, 0, 22326, 22326),
         16#3A#           =>  --  01103A
          (0, 0, 22327, 22327),
         16#3B#           =>  --  01103B
          (0, 0, 22328, 22328),
         16#3C#           =>  --  01103C
          (0, 0, 22329, 22329),
         16#3D#           =>  --  01103D
          (0, 0, 22330, 22330),
         16#3E#           =>  --  01103E
          (0, 0, 22331, 22331),
         16#3F#           =>  --  01103F
          (0, 0, 22332, 22332),
         16#40#           =>  --  011040
          (0, 0, 22333, 22333),
         16#41#           =>  --  011041
          (0, 0, 22334, 22334),
         16#42#           =>  --  011042
          (0, 0, 22335, 22335),
         16#43#           =>  --  011043
          (0, 0, 22336, 22336),
         16#44#           =>  --  011044
          (0, 0, 22337, 22337),
         16#45#           =>  --  011045
          (0, 0, 22338, 22338),
         16#46#           =>  --  011046
          (0, 0, 22339, 22339),
         16#47#           =>  --  011047
          (0, 0, 22340, 22340),
         16#48#           =>  --  011048
          (0, 0, 22341, 22341),
         16#49#           =>  --  011049
          (0, 0, 22342, 22342),
         16#4A#           =>  --  01104A
          (0, 0, 22343, 22343),
         16#4B#           =>  --  01104B
          (0, 0, 22344, 22344),
         16#4C#           =>  --  01104C
          (0, 0, 22345, 22345),
         16#4D#           =>  --  01104D
          (0, 0, 22346, 22346),
         16#52#           =>  --  011052
          (0, 0, 24, 24),
         16#53#           =>  --  011053
          (0, 0, 25, 25),
         16#54#           =>  --  011054
          (0, 0, 26, 26),
         16#55#           =>  --  011055
          (0, 0, 27, 27),
         16#56#           =>  --  011056
          (0, 0, 28, 28),
         16#57#           =>  --  011057
          (0, 0, 29, 29),
         16#58#           =>  --  011058
          (0, 0, 30, 30),
         16#59#           =>  --  011059
          (0, 0, 31, 31),
         16#5A#           =>  --  01105A
          (0, 0, 32, 32),
         16#5B#           =>  --  01105B
          (0, 0, 22347, 22347),
         16#5C#           =>  --  01105C
          (0, 0, 22348, 22348),
         16#5D#           =>  --  01105D
          (0, 0, 22349, 22349),
         16#5E#           =>  --  01105E
          (0, 0, 22350, 22350),
         16#5F#           =>  --  01105F
          (0, 0, 22351, 22351),
         16#60#           =>  --  011060
          (0, 0, 22352, 22352),
         16#61#           =>  --  011061
          (0, 0, 22353, 22353),
         16#62#           =>  --  011062
          (0, 0, 22354, 22354),
         16#63#           =>  --  011063
          (0, 0, 22355, 22355),
         16#64#           =>  --  011064
          (0, 0, 22356, 22356),
         16#65#           =>  --  011065
          (0, 0, 22357, 22357),
         16#66#           =>  --  011066
          (0, 0, 23, 23),
         16#67#           =>  --  011067
          (0, 0, 24, 24),
         16#68#           =>  --  011068
          (0, 0, 25, 25),
         16#69#           =>  --  011069
          (0, 0, 26, 26),
         16#6A#           =>  --  01106A
          (0, 0, 27, 27),
         16#6B#           =>  --  01106B
          (0, 0, 28, 28),
         16#6C#           =>  --  01106C
          (0, 0, 29, 29),
         16#6D#           =>  --  01106D
          (0, 0, 30, 30),
         16#6E#           =>  --  01106E
          (0, 0, 31, 31),
         16#6F#           =>  --  01106F
          (0, 0, 32, 32),
         16#7F#           =>  --  01107F
          (0, 0, 22358, 22358),
         16#80#           =>  --  011080
          (0, 0, 2242, 2242),
         16#81#           =>  --  011081
          (0, 0, 2243, 2243),
         16#82#           =>  --  011082
          (0, 0, 2244, 2244),
         16#83#           =>  --  011083
          (0, 0, 22359, 22359),
         16#84#           =>  --  011084
          (0, 0, 22360, 22360),
         16#85#           =>  --  011085
          (0, 0, 22361, 22361),
         16#86#           =>  --  011086
          (0, 0, 22362, 22362),
         16#87#           =>  --  011087
          (0, 0, 22363, 22363),
         16#88#           =>  --  011088
          (0, 0, 22364, 22364),
         16#89#           =>  --  011089
          (0, 0, 22365, 22365),
         16#8A#           =>  --  01108A
          (0, 0, 22366, 22366),
         16#8B#           =>  --  01108B
          (0, 0, 22367, 22367),
         16#8C#           =>  --  01108C
          (0, 0, 22368, 22368),
         16#8D#           =>  --  01108D
          (0, 0, 22369, 22369),
         16#8E#           =>  --  01108E
          (0, 0, 22370, 22370),
         16#8F#           =>  --  01108F
          (0, 0, 22371, 22371),
         16#90#           =>  --  011090
          (0, 0, 22372, 22372),
         16#91#           =>  --  011091
          (0, 0, 22373, 22373),
         16#92#           =>  --  011092
          (0, 0, 22374, 22374),
         16#93#           =>  --  011093
          (0, 0, 22375, 22375),
         16#94#           =>  --  011094
          (0, 0, 22376, 22376),
         16#95#           =>  --  011095
          (0, 0, 22377, 22377),
         16#96#           =>  --  011096
          (0, 0, 22378, 22378),
         16#97#           =>  --  011097
          (0, 0, 22379, 22379),
         16#98#           =>  --  011098
          (0, 0, 22380, 22380),
         16#99#           =>  --  011099
          (0, 0, 22381, 22381),
         16#9A#           =>  --  01109A
          (0, 0, 22382, 22383),
         16#9B#           =>  --  01109B
          (0, 0, 22384, 22384),
         16#9C#           =>  --  01109C
          (0, 0, 22385, 22386),
         16#9D#           =>  --  01109D
          (0, 0, 22387, 22387),
         16#9E#           =>  --  01109E
          (0, 0, 22388, 22388),
         16#9F#           =>  --  01109F
          (0, 0, 22389, 22389),
         16#A0#           =>  --  0110A0
          (0, 0, 22390, 22390),
         16#A1#           =>  --  0110A1
          (0, 0, 22391, 22391),
         16#A2#           =>  --  0110A2
          (0, 0, 22392, 22392),
         16#A3#           =>  --  0110A3
          (0, 0, 22393, 22393),
         16#A4#           =>  --  0110A4
          (0, 0, 22394, 22394),
         16#A5#           =>  --  0110A5
          (0, 0, 22395, 22395),
         16#A6#           =>  --  0110A6
          (0, 0, 22396, 22396),
         16#A7#           =>  --  0110A7
          (0, 0, 22397, 22397),
         16#A8#           =>  --  0110A8
          (0, 0, 22398, 22398),
         16#A9#           =>  --  0110A9
          (0, 0, 22399, 22399),
         16#AA#           =>  --  0110AA
          (0, 0, 22400, 22400),
         16#AB#           =>  --  0110AB
          (0, 0, 22401, 22402),
         16#AC#           =>  --  0110AC
          (0, 0, 22403, 22403),
         16#AD#           =>  --  0110AD
          (0, 0, 22404, 22404),
         16#AE#           =>  --  0110AE
          (0, 0, 22405, 22405),
         16#AF#           =>  --  0110AF
          (0, 0, 22406, 22406),
         16#B0#           =>  --  0110B0
          (0, 0, 22407, 22407),
         16#B1#           =>  --  0110B1
          (0, 0, 22408, 22408),
         16#B2#           =>  --  0110B2
          (0, 0, 22409, 22409),
         16#B3#           =>  --  0110B3
          (0, 0, 22410, 22410),
         16#B4#           =>  --  0110B4
          (0, 0, 22411, 22411),
         16#B5#           =>  --  0110B5
          (0, 0, 22412, 22412),
         16#B6#           =>  --  0110B6
          (0, 0, 22413, 22413),
         16#B7#           =>  --  0110B7
          (0, 0, 22414, 22414),
         16#B8#           =>  --  0110B8
          (0, 0, 22415, 22415),
         16#B9#           =>  --  0110B9
          (0, 0, 22416, 22416),
         16#BA#           =>  --  0110BA
          (0, 0, 2283, 2283),
         16#BB#           =>  --  0110BB
          (0, 0, 22417, 22417),
         16#BC#           =>  --  0110BC
          (0, 0, 22418, 22418),
         16#BD#           =>  --  0110BD
          (0, 0, 1, 1),
         16#BE#           =>  --  0110BE
          (0, 0, 22419, 22419),
         16#BF#           =>  --  0110BF
          (0, 0, 22420, 22420),
         16#C0#           =>  --  0110C0
          (0, 0, 22421, 22421),
         16#C1#           =>  --  0110C1
          (0, 0, 22422, 22422),
         16#D0#           =>  --  0110D0
          (0, 0, 22423, 22423),
         16#D1#           =>  --  0110D1
          (0, 0, 22424, 22424),
         16#D2#           =>  --  0110D2
          (0, 0, 22425, 22425),
         16#D3#           =>  --  0110D3
          (0, 0, 22426, 22426),
         16#D4#           =>  --  0110D4
          (0, 0, 22427, 22427),
         16#D5#           =>  --  0110D5
          (0, 0, 22428, 22428),
         16#D6#           =>  --  0110D6
          (0, 0, 22429, 22429),
         16#D7#           =>  --  0110D7
          (0, 0, 22430, 22430),
         16#D8#           =>  --  0110D8
          (0, 0, 22431, 22431),
         16#D9#           =>  --  0110D9
          (0, 0, 22432, 22432),
         16#DA#           =>  --  0110DA
          (0, 0, 22433, 22433),
         16#DB#           =>  --  0110DB
          (0, 0, 22434, 22434),
         16#DC#           =>  --  0110DC
          (0, 0, 22435, 22435),
         16#DD#           =>  --  0110DD
          (0, 0, 22436, 22436),
         16#DE#           =>  --  0110DE
          (0, 0, 22437, 22437),
         16#DF#           =>  --  0110DF
          (0, 0, 22438, 22438),
         16#E0#           =>  --  0110E0
          (0, 0, 22439, 22439),
         16#E1#           =>  --  0110E1
          (0, 0, 22440, 22440),
         16#E2#           =>  --  0110E2
          (0, 0, 22441, 22441),
         16#E3#           =>  --  0110E3
          (0, 0, 22442, 22442),
         16#E4#           =>  --  0110E4
          (0, 0, 22443, 22443),
         16#E5#           =>  --  0110E5
          (0, 0, 22444, 22444),
         16#E6#           =>  --  0110E6
          (0, 0, 22445, 22445),
         16#E7#           =>  --  0110E7
          (0, 0, 22446, 22446),
         16#E8#           =>  --  0110E8
          (0, 0, 22447, 22447),
         16#F0#           =>  --  0110F0
          (0, 0, 23, 23),
         16#F1#           =>  --  0110F1
          (0, 0, 24, 24),
         16#F2#           =>  --  0110F2
          (0, 0, 25, 25),
         16#F3#           =>  --  0110F3
          (0, 0, 26, 26),
         16#F4#           =>  --  0110F4
          (0, 0, 27, 27),
         16#F5#           =>  --  0110F5
          (0, 0, 28, 28),
         16#F6#           =>  --  0110F6
          (0, 0, 29, 29),
         16#F7#           =>  --  0110F7
          (0, 0, 30, 30),
         16#F8#           =>  --  0110F8
          (0, 0, 31, 31),
         16#F9#           =>  --  0110F9
          (0, 0, 32, 32),
         others           =>
          (0, 0, 0, 0));

   Group_0111 : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  011100
          (0, 0, 2242, 2242),
         16#01#           =>  --  011101
          (0, 0, 2243, 2243),
         16#02#           =>  --  011102
          (0, 0, 2244, 2244),
         16#03#           =>  --  011103
          (0, 0, 22448, 22448),
         16#04#           =>  --  011104
          (0, 0, 22449, 22449),
         16#05#           =>  --  011105
          (0, 0, 22450, 22450),
         16#06#           =>  --  011106
          (0, 0, 22451, 22451),
         16#07#           =>  --  011107
          (0, 0, 22452, 22452),
         16#08#           =>  --  011108
          (0, 0, 22453, 22453),
         16#09#           =>  --  011109
          (0, 0, 22454, 22454),
         16#0A#           =>  --  01110A
          (0, 0, 22455, 22455),
         16#0B#           =>  --  01110B
          (0, 0, 22456, 22456),
         16#0C#           =>  --  01110C
          (0, 0, 22457, 22457),
         16#0D#           =>  --  01110D
          (0, 0, 22458, 22458),
         16#0E#           =>  --  01110E
          (0, 0, 22459, 22459),
         16#0F#           =>  --  01110F
          (0, 0, 22460, 22460),
         16#10#           =>  --  011110
          (0, 0, 22461, 22461),
         16#11#           =>  --  011111
          (0, 0, 22462, 22462),
         16#12#           =>  --  011112
          (0, 0, 22463, 22463),
         16#13#           =>  --  011113
          (0, 0, 22464, 22464),
         16#14#           =>  --  011114
          (0, 0, 22465, 22465),
         16#15#           =>  --  011115
          (0, 0, 22466, 22466),
         16#16#           =>  --  011116
          (0, 0, 22467, 22467),
         16#17#           =>  --  011117
          (0, 0, 22468, 22468),
         16#18#           =>  --  011118
          (0, 0, 22469, 22469),
         16#19#           =>  --  011119
          (0, 0, 22470, 22470),
         16#1A#           =>  --  01111A
          (0, 0, 22471, 22471),
         16#1B#           =>  --  01111B
          (0, 0, 22472, 22472),
         16#1C#           =>  --  01111C
          (0, 0, 22473, 22473),
         16#1D#           =>  --  01111D
          (0, 0, 22474, 22474),
         16#1E#           =>  --  01111E
          (0, 0, 22475, 22475),
         16#1F#           =>  --  01111F
          (0, 0, 22476, 22476),
         16#20#           =>  --  011120
          (0, 0, 22477, 22477),
         16#21#           =>  --  011121
          (0, 0, 22478, 22478),
         16#22#           =>  --  011122
          (0, 0, 22479, 22479),
         16#23#           =>  --  011123
          (0, 0, 22480, 22480),
         16#24#           =>  --  011124
          (0, 0, 22481, 22481),
         16#25#           =>  --  011125
          (0, 0, 22482, 22482),
         16#26#           =>  --  011126
          (0, 0, 22483, 22483),
         16#27#           =>  --  011127
          (0, 0, 22484, 22484),
         16#28#           =>  --  011128
          (0, 0, 22485, 22485),
         16#29#           =>  --  011129
          (0, 0, 22486, 22486),
         16#2A#           =>  --  01112A
          (0, 0, 22487, 22487),
         16#2B#           =>  --  01112B
          (0, 0, 22488, 22488),
         16#2C#           =>  --  01112C
          (0, 0, 22489, 22489),
         16#2D#           =>  --  01112D
          (0, 0, 22490, 22490),
         16#2E#           =>  --  01112E
          (0, 0, 22491, 22491),
         16#2F#           =>  --  01112F
          (0, 0, 22492, 22492),
         16#30#           =>  --  011130
          (0, 0, 22493, 22493),
         16#31#           =>  --  011131
          (694, 694, 22494, 22494),
         16#32#           =>  --  011132
          (695, 695, 22495, 22495),
         16#33#           =>  --  011133
          (0, 0, 22496, 22496),
         16#34#           =>  --  011134
          (0, 0, 22497, 22497),
         16#36#           =>  --  011136
          (0, 0, 23, 23),
         16#37#           =>  --  011137
          (0, 0, 24, 24),
         16#38#           =>  --  011138
          (0, 0, 25, 25),
         16#39#           =>  --  011139
          (0, 0, 26, 26),
         16#3A#           =>  --  01113A
          (0, 0, 27, 27),
         16#3B#           =>  --  01113B
          (0, 0, 28, 28),
         16#3C#           =>  --  01113C
          (0, 0, 29, 29),
         16#3D#           =>  --  01113D
          (0, 0, 30, 30),
         16#3E#           =>  --  01113E
          (0, 0, 31, 31),
         16#3F#           =>  --  01113F
          (0, 0, 32, 32),
         16#40#           =>  --  011140
          (0, 0, 22498, 22498),
         16#41#           =>  --  011141
          (0, 0, 22499, 22499),
         16#42#           =>  --  011142
          (0, 0, 22500, 22500),
         16#43#           =>  --  011143
          (0, 0, 22501, 22501),
         16#50#           =>  --  011150
          (0, 0, 22502, 22502),
         16#51#           =>  --  011151
          (0, 0, 22503, 22503),
         16#52#           =>  --  011152
          (0, 0, 22504, 22504),
         16#53#           =>  --  011153
          (0, 0, 22505, 22505),
         16#54#           =>  --  011154
          (0, 0, 22506, 22506),
         16#55#           =>  --  011155
          (0, 0, 22507, 22507),
         16#56#           =>  --  011156
          (0, 0, 22508, 22508),
         16#57#           =>  --  011157
          (0, 0, 22509, 22509),
         16#58#           =>  --  011158
          (0, 0, 22510, 22510),
         16#59#           =>  --  011159
          (0, 0, 22511, 22511),
         16#5A#           =>  --  01115A
          (0, 0, 22512, 22512),
         16#5B#           =>  --  01115B
          (0, 0, 22513, 22513),
         16#5C#           =>  --  01115C
          (0, 0, 22514, 22514),
         16#5D#           =>  --  01115D
          (0, 0, 22515, 22515),
         16#5E#           =>  --  01115E
          (0, 0, 22516, 22516),
         16#5F#           =>  --  01115F
          (0, 0, 22517, 22517),
         16#60#           =>  --  011160
          (0, 0, 22518, 22518),
         16#61#           =>  --  011161
          (0, 0, 22519, 22519),
         16#62#           =>  --  011162
          (0, 0, 22520, 22520),
         16#63#           =>  --  011163
          (0, 0, 22521, 22521),
         16#64#           =>  --  011164
          (0, 0, 22522, 22522),
         16#65#           =>  --  011165
          (0, 0, 22523, 22523),
         16#66#           =>  --  011166
          (0, 0, 22524, 22524),
         16#67#           =>  --  011167
          (0, 0, 22525, 22525),
         16#68#           =>  --  011168
          (0, 0, 22526, 22526),
         16#69#           =>  --  011169
          (0, 0, 22527, 22527),
         16#6A#           =>  --  01116A
          (0, 0, 22528, 22528),
         16#6B#           =>  --  01116B
          (0, 0, 22529, 22529),
         16#6C#           =>  --  01116C
          (0, 0, 22530, 22530),
         16#6D#           =>  --  01116D
          (0, 0, 22531, 22531),
         16#6E#           =>  --  01116E
          (0, 0, 22532, 22532),
         16#6F#           =>  --  01116F
          (0, 0, 22533, 22533),
         16#70#           =>  --  011170
          (0, 0, 22534, 22534),
         16#71#           =>  --  011171
          (0, 0, 22535, 22535),
         16#72#           =>  --  011172
          (0, 0, 22536, 22536),
         16#73#           =>  --  011173
          (0, 0, 2283, 2283),
         16#74#           =>  --  011174
          (0, 0, 22537, 22537),
         16#75#           =>  --  011175
          (0, 0, 22538, 22538),
         16#76#           =>  --  011176
          (0, 0, 22539, 22539),
         16#80#           =>  --  011180
          (0, 0, 2242, 2242),
         16#81#           =>  --  011181
          (0, 0, 2243, 2243),
         16#82#           =>  --  011182
          (0, 0, 2244, 2244),
         16#83#           =>  --  011183
          (0, 0, 22540, 22540),
         16#84#           =>  --  011184
          (0, 0, 22541, 22541),
         16#85#           =>  --  011185
          (0, 0, 22542, 22542),
         16#86#           =>  --  011186
          (0, 0, 22543, 22543),
         16#87#           =>  --  011187
          (0, 0, 22544, 22544),
         16#88#           =>  --  011188
          (0, 0, 22545, 22545),
         16#89#           =>  --  011189
          (0, 0, 22546, 22546),
         16#8A#           =>  --  01118A
          (0, 0, 22547, 22547),
         16#8B#           =>  --  01118B
          (0, 0, 22548, 22548),
         16#8C#           =>  --  01118C
          (0, 0, 22549, 22549),
         16#8D#           =>  --  01118D
          (0, 0, 22550, 22550),
         16#8E#           =>  --  01118E
          (0, 0, 22551, 22551),
         16#8F#           =>  --  01118F
          (0, 0, 22552, 22552),
         16#90#           =>  --  011190
          (0, 0, 22553, 22553),
         16#91#           =>  --  011191
          (0, 0, 22554, 22554),
         16#92#           =>  --  011192
          (0, 0, 22555, 22555),
         16#93#           =>  --  011193
          (0, 0, 22556, 22556),
         16#94#           =>  --  011194
          (0, 0, 22557, 22557),
         16#95#           =>  --  011195
          (0, 0, 22558, 22558),
         16#96#           =>  --  011196
          (0, 0, 22559, 22559),
         16#97#           =>  --  011197
          (0, 0, 22560, 22560),
         16#98#           =>  --  011198
          (0, 0, 22561, 22561),
         16#99#           =>  --  011199
          (0, 0, 22562, 22562),
         16#9A#           =>  --  01119A
          (0, 0, 22563, 22563),
         16#9B#           =>  --  01119B
          (0, 0, 22564, 22564),
         16#9C#           =>  --  01119C
          (0, 0, 22565, 22565),
         16#9D#           =>  --  01119D
          (0, 0, 22566, 22566),
         16#9E#           =>  --  01119E
          (0, 0, 22567, 22567),
         16#9F#           =>  --  01119F
          (0, 0, 22568, 22568),
         16#A0#           =>  --  0111A0
          (0, 0, 22569, 22569),
         16#A1#           =>  --  0111A1
          (0, 0, 22570, 22570),
         16#A2#           =>  --  0111A2
          (0, 0, 22571, 22571),
         16#A3#           =>  --  0111A3
          (0, 0, 22572, 22572),
         16#A4#           =>  --  0111A4
          (0, 0, 22573, 22573),
         16#A5#           =>  --  0111A5
          (0, 0, 22574, 22574),
         16#A6#           =>  --  0111A6
          (0, 0, 22575, 22575),
         16#A7#           =>  --  0111A7
          (0, 0, 22576, 22576),
         16#A8#           =>  --  0111A8
          (0, 0, 22577, 22577),
         16#A9#           =>  --  0111A9
          (0, 0, 22578, 22578),
         16#AA#           =>  --  0111AA
          (0, 0, 22579, 22579),
         16#AB#           =>  --  0111AB
          (0, 0, 22580, 22580),
         16#AC#           =>  --  0111AC
          (0, 0, 22581, 22581),
         16#AD#           =>  --  0111AD
          (0, 0, 22582, 22582),
         16#AE#           =>  --  0111AE
          (0, 0, 22583, 22583),
         16#AF#           =>  --  0111AF
          (0, 0, 22584, 22584),
         16#B0#           =>  --  0111B0
          (0, 0, 22585, 22585),
         16#B1#           =>  --  0111B1
          (0, 0, 22586, 22586),
         16#B2#           =>  --  0111B2
          (0, 0, 22587, 22587),
         16#B3#           =>  --  0111B3
          (0, 0, 22588, 22588),
         16#B4#           =>  --  0111B4
          (0, 0, 22589, 22589),
         16#B5#           =>  --  0111B5
          (0, 0, 22590, 22590),
         16#B6#           =>  --  0111B6
          (0, 0, 22591, 22591),
         16#B7#           =>  --  0111B7
          (0, 0, 22592, 22592),
         16#B8#           =>  --  0111B8
          (0, 0, 22593, 22593),
         16#B9#           =>  --  0111B9
          (0, 0, 22594, 22594),
         16#BA#           =>  --  0111BA
          (0, 0, 22595, 22595),
         16#BB#           =>  --  0111BB
          (0, 0, 22596, 22596),
         16#BC#           =>  --  0111BC
          (0, 0, 22597, 22597),
         16#BD#           =>  --  0111BD
          (0, 0, 22598, 22598),
         16#BE#           =>  --  0111BE
          (0, 0, 22599, 22599),
         16#BF#           =>  --  0111BF
          (0, 0, 22600, 22600),
         16#C0#           =>  --  0111C0
          (0, 0, 22601, 22601),
         16#C1#           =>  --  0111C1
          (0, 0, 22602, 22602),
         16#C2#           =>  --  0111C2
          (0, 0, 22603, 22603),
         16#C3#           =>  --  0111C3
          (0, 0, 22604, 22604),
         16#C4#           =>  --  0111C4
          (0, 0, 22605, 22605),
         16#C5#           =>  --  0111C5
          (0, 0, 22606, 22606),
         16#C6#           =>  --  0111C6
          (0, 0, 22607, 22607),
         16#C7#           =>  --  0111C7
          (0, 0, 22608, 22608),
         16#C8#           =>  --  0111C8
          (0, 0, 22609, 22609),
         16#CD#           =>  --  0111CD
          (0, 0, 22610, 22610),
         16#D0#           =>  --  0111D0
          (0, 0, 23, 23),
         16#D1#           =>  --  0111D1
          (0, 0, 24, 24),
         16#D2#           =>  --  0111D2
          (0, 0, 25, 25),
         16#D3#           =>  --  0111D3
          (0, 0, 26, 26),
         16#D4#           =>  --  0111D4
          (0, 0, 27, 27),
         16#D5#           =>  --  0111D5
          (0, 0, 28, 28),
         16#D6#           =>  --  0111D6
          (0, 0, 29, 29),
         16#D7#           =>  --  0111D7
          (0, 0, 30, 30),
         16#D8#           =>  --  0111D8
          (0, 0, 31, 31),
         16#D9#           =>  --  0111D9
          (0, 0, 32, 32),
         16#DA#           =>  --  0111DA
          (0, 0, 22611, 22611),
         16#E1#           =>  --  0111E1
          (0, 0, 24, 24),
         16#E2#           =>  --  0111E2
          (0, 0, 25, 25),
         16#E3#           =>  --  0111E3
          (0, 0, 26, 26),
         16#E4#           =>  --  0111E4
          (0, 0, 27, 27),
         16#E5#           =>  --  0111E5
          (0, 0, 28, 28),
         16#E6#           =>  --  0111E6
          (0, 0, 29, 29),
         16#E7#           =>  --  0111E7
          (0, 0, 30, 30),
         16#E8#           =>  --  0111E8
          (0, 0, 31, 31),
         16#E9#           =>  --  0111E9
          (0, 0, 32, 32),
         16#EA#           =>  --  0111EA
          (0, 0, 22612, 22612),
         16#EB#           =>  --  0111EB
          (0, 0, 22613, 22613),
         16#EC#           =>  --  0111EC
          (0, 0, 22614, 22614),
         16#ED#           =>  --  0111ED
          (0, 0, 22615, 22615),
         16#EE#           =>  --  0111EE
          (0, 0, 22616, 22616),
         16#EF#           =>  --  0111EF
          (0, 0, 22617, 22617),
         16#F0#           =>  --  0111F0
          (0, 0, 22618, 22618),
         16#F1#           =>  --  0111F1
          (0, 0, 22619, 22619),
         16#F2#           =>  --  0111F2
          (0, 0, 22620, 22620),
         16#F3#           =>  --  0111F3
          (0, 0, 22621, 22621),
         16#F4#           =>  --  0111F4
          (0, 0, 22622, 22622),
         others           =>
          (0, 0, 0, 0));

   Group_0112 : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  011200
          (0, 0, 22623, 22623),
         16#01#           =>  --  011201
          (0, 0, 22624, 22624),
         16#02#           =>  --  011202
          (0, 0, 22625, 22625),
         16#03#           =>  --  011203
          (0, 0, 22626, 22626),
         16#04#           =>  --  011204
          (0, 0, 22627, 22627),
         16#05#           =>  --  011205
          (0, 0, 22628, 22628),
         16#06#           =>  --  011206
          (0, 0, 22629, 22629),
         16#07#           =>  --  011207
          (0, 0, 22630, 22630),
         16#08#           =>  --  011208
          (0, 0, 22631, 22631),
         16#09#           =>  --  011209
          (0, 0, 22632, 22632),
         16#0A#           =>  --  01120A
          (0, 0, 22633, 22633),
         16#0B#           =>  --  01120B
          (0, 0, 22634, 22634),
         16#0C#           =>  --  01120C
          (0, 0, 22635, 22635),
         16#0D#           =>  --  01120D
          (0, 0, 22636, 22636),
         16#0E#           =>  --  01120E
          (0, 0, 22637, 22637),
         16#0F#           =>  --  01120F
          (0, 0, 22638, 22638),
         16#10#           =>  --  011210
          (0, 0, 22639, 22639),
         16#11#           =>  --  011211
          (0, 0, 22640, 22640),
         16#13#           =>  --  011213
          (0, 0, 22641, 22641),
         16#14#           =>  --  011214
          (0, 0, 22642, 22642),
         16#15#           =>  --  011215
          (0, 0, 22643, 22643),
         16#16#           =>  --  011216
          (0, 0, 22644, 22644),
         16#17#           =>  --  011217
          (0, 0, 22645, 22645),
         16#18#           =>  --  011218
          (0, 0, 22646, 22646),
         16#19#           =>  --  011219
          (0, 0, 22647, 22647),
         16#1A#           =>  --  01121A
          (0, 0, 22648, 22648),
         16#1B#           =>  --  01121B
          (0, 0, 22649, 22649),
         16#1C#           =>  --  01121C
          (0, 0, 22650, 22650),
         16#1D#           =>  --  01121D
          (0, 0, 22651, 22651),
         16#1E#           =>  --  01121E
          (0, 0, 22652, 22652),
         16#1F#           =>  --  01121F
          (0, 0, 22653, 22653),
         16#20#           =>  --  011220
          (0, 0, 22654, 22654),
         16#21#           =>  --  011221
          (0, 0, 22655, 22655),
         16#22#           =>  --  011222
          (0, 0, 22656, 22656),
         16#23#           =>  --  011223
          (0, 0, 22657, 22657),
         16#24#           =>  --  011224
          (0, 0, 22658, 22658),
         16#25#           =>  --  011225
          (0, 0, 22659, 22659),
         16#26#           =>  --  011226
          (0, 0, 22660, 22660),
         16#27#           =>  --  011227
          (0, 0, 22661, 22661),
         16#28#           =>  --  011228
          (0, 0, 22662, 22662),
         16#29#           =>  --  011229
          (0, 0, 22663, 22663),
         16#2A#           =>  --  01122A
          (0, 0, 22664, 22664),
         16#2B#           =>  --  01122B
          (0, 0, 22665, 22665),
         16#2C#           =>  --  01122C
          (0, 0, 22666, 22666),
         16#2D#           =>  --  01122D
          (0, 0, 22667, 22667),
         16#2E#           =>  --  01122E
          (0, 0, 22668, 22668),
         16#2F#           =>  --  01122F
          (0, 0, 22669, 22669),
         16#30#           =>  --  011230
          (0, 0, 22670, 22670),
         16#31#           =>  --  011231
          (0, 0, 22671, 22671),
         16#32#           =>  --  011232
          (0, 0, 22672, 22672),
         16#33#           =>  --  011233
          (0, 0, 22673, 22673),
         16#34#           =>  --  011234
          (0, 0, 2243, 2243),
         16#35#           =>  --  011235
          (0, 0, 22674, 22674),
         16#36#           =>  --  011236
          (0, 0, 2283, 2283),
         16#37#           =>  --  011237
          (0, 0, 1764, 1764),
         16#38#           =>  --  011238
          (0, 0, 22675, 22675),
         16#39#           =>  --  011239
          (0, 0, 22676, 22676),
         16#3A#           =>  --  01123A
          (0, 0, 22677, 22677),
         16#3B#           =>  --  01123B
          (0, 0, 22678, 22678),
         16#3C#           =>  --  01123C
          (0, 0, 22679, 22679),
         16#3D#           =>  --  01123D
          (0, 0, 22680, 22680),
         16#B0#           =>  --  0112B0
          (0, 0, 22681, 22681),
         16#B1#           =>  --  0112B1
          (0, 0, 22682, 22682),
         16#B2#           =>  --  0112B2
          (0, 0, 22683, 22683),
         16#B3#           =>  --  0112B3
          (0, 0, 22684, 22684),
         16#B4#           =>  --  0112B4
          (0, 0, 22685, 22685),
         16#B5#           =>  --  0112B5
          (0, 0, 22686, 22686),
         16#B6#           =>  --  0112B6
          (0, 0, 22687, 22687),
         16#B7#           =>  --  0112B7
          (0, 0, 22688, 22688),
         16#B8#           =>  --  0112B8
          (0, 0, 22689, 22689),
         16#B9#           =>  --  0112B9
          (0, 0, 22690, 22690),
         16#BA#           =>  --  0112BA
          (0, 0, 22691, 22691),
         16#BB#           =>  --  0112BB
          (0, 0, 22692, 22692),
         16#BC#           =>  --  0112BC
          (0, 0, 22693, 22693),
         16#BD#           =>  --  0112BD
          (0, 0, 22694, 22694),
         16#BE#           =>  --  0112BE
          (0, 0, 22695, 22695),
         16#BF#           =>  --  0112BF
          (0, 0, 22696, 22696),
         16#C0#           =>  --  0112C0
          (0, 0, 22697, 22697),
         16#C1#           =>  --  0112C1
          (0, 0, 22698, 22698),
         16#C2#           =>  --  0112C2
          (0, 0, 22699, 22699),
         16#C3#           =>  --  0112C3
          (0, 0, 22700, 22700),
         16#C4#           =>  --  0112C4
          (0, 0, 22701, 22701),
         16#C5#           =>  --  0112C5
          (0, 0, 22702, 22702),
         16#C6#           =>  --  0112C6
          (0, 0, 22703, 22703),
         16#C7#           =>  --  0112C7
          (0, 0, 22704, 22704),
         16#C8#           =>  --  0112C8
          (0, 0, 22705, 22705),
         16#C9#           =>  --  0112C9
          (0, 0, 22706, 22706),
         16#CA#           =>  --  0112CA
          (0, 0, 22707, 22707),
         16#CB#           =>  --  0112CB
          (0, 0, 22708, 22708),
         16#CC#           =>  --  0112CC
          (0, 0, 22709, 22709),
         16#CD#           =>  --  0112CD
          (0, 0, 22710, 22710),
         16#CE#           =>  --  0112CE
          (0, 0, 22711, 22711),
         16#CF#           =>  --  0112CF
          (0, 0, 22712, 22712),
         16#D0#           =>  --  0112D0
          (0, 0, 22713, 22713),
         16#D1#           =>  --  0112D1
          (0, 0, 22714, 22714),
         16#D2#           =>  --  0112D2
          (0, 0, 22715, 22715),
         16#D3#           =>  --  0112D3
          (0, 0, 22716, 22716),
         16#D4#           =>  --  0112D4
          (0, 0, 22717, 22717),
         16#D5#           =>  --  0112D5
          (0, 0, 22718, 22718),
         16#D6#           =>  --  0112D6
          (0, 0, 22719, 22719),
         16#D7#           =>  --  0112D7
          (0, 0, 22720, 22720),
         16#D8#           =>  --  0112D8
          (0, 0, 22721, 22721),
         16#D9#           =>  --  0112D9
          (0, 0, 22722, 22722),
         16#DA#           =>  --  0112DA
          (0, 0, 22723, 22723),
         16#DB#           =>  --  0112DB
          (0, 0, 22724, 22724),
         16#DC#           =>  --  0112DC
          (0, 0, 22725, 22725),
         16#DD#           =>  --  0112DD
          (0, 0, 22726, 22726),
         16#DE#           =>  --  0112DE
          (0, 0, 22727, 22727),
         16#DF#           =>  --  0112DF
          (0, 0, 2243, 2243),
         16#E0#           =>  --  0112E0
          (0, 0, 22728, 22728),
         16#E1#           =>  --  0112E1
          (0, 0, 22729, 22729),
         16#E2#           =>  --  0112E2
          (0, 0, 22730, 22730),
         16#E3#           =>  --  0112E3
          (0, 0, 22731, 22731),
         16#E4#           =>  --  0112E4
          (0, 0, 22732, 22732),
         16#E5#           =>  --  0112E5
          (0, 0, 22733, 22733),
         16#E6#           =>  --  0112E6
          (0, 0, 22734, 22734),
         16#E7#           =>  --  0112E7
          (0, 0, 22735, 22735),
         16#E8#           =>  --  0112E8
          (0, 0, 22736, 22736),
         16#E9#           =>  --  0112E9
          (0, 0, 2283, 2283),
         16#EA#           =>  --  0112EA
          (0, 0, 22737, 22737),
         16#F0#           =>  --  0112F0
          (0, 0, 23, 23),
         16#F1#           =>  --  0112F1
          (0, 0, 24, 24),
         16#F2#           =>  --  0112F2
          (0, 0, 25, 25),
         16#F3#           =>  --  0112F3
          (0, 0, 26, 26),
         16#F4#           =>  --  0112F4
          (0, 0, 27, 27),
         16#F5#           =>  --  0112F5
          (0, 0, 28, 28),
         16#F6#           =>  --  0112F6
          (0, 0, 29, 29),
         16#F7#           =>  --  0112F7
          (0, 0, 30, 30),
         16#F8#           =>  --  0112F8
          (0, 0, 31, 31),
         16#F9#           =>  --  0112F9
          (0, 0, 32, 32),
         others           =>
          (0, 0, 0, 0));

   Group_0113 : aliased constant Collation_Second_Stage
     := (16#01#           =>  --  011301
          (0, 0, 2242, 2242),
         16#02#           =>  --  011302
          (0, 0, 2243, 2243),
         16#03#           =>  --  011303
          (0, 0, 2244, 2244),
         16#05#           =>  --  011305
          (0, 0, 22738, 22738),
         16#06#           =>  --  011306
          (0, 0, 22739, 22739),
         16#07#           =>  --  011307
          (0, 0, 22740, 22740),
         16#08#           =>  --  011308
          (0, 0, 22741, 22741),
         16#09#           =>  --  011309
          (0, 0, 22742, 22742),
         16#0A#           =>  --  01130A
          (0, 0, 22743, 22743),
         16#0B#           =>  --  01130B
          (0, 0, 22744, 22744),
         16#0C#           =>  --  01130C
          (0, 0, 22745, 22745),
         16#0F#           =>  --  01130F
          (0, 0, 22746, 22746),
         16#10#           =>  --  011310
          (0, 0, 22747, 22747),
         16#13#           =>  --  011313
          (0, 0, 22748, 22748),
         16#14#           =>  --  011314
          (0, 0, 22749, 22749),
         16#15#           =>  --  011315
          (0, 0, 22750, 22750),
         16#16#           =>  --  011316
          (0, 0, 22751, 22751),
         16#17#           =>  --  011317
          (0, 0, 22752, 22752),
         16#18#           =>  --  011318
          (0, 0, 22753, 22753),
         16#19#           =>  --  011319
          (0, 0, 22754, 22754),
         16#1A#           =>  --  01131A
          (0, 0, 22755, 22755),
         16#1B#           =>  --  01131B
          (0, 0, 22756, 22756),
         16#1C#           =>  --  01131C
          (0, 0, 22757, 22757),
         16#1D#           =>  --  01131D
          (0, 0, 22758, 22758),
         16#1E#           =>  --  01131E
          (0, 0, 22759, 22759),
         16#1F#           =>  --  01131F
          (0, 0, 22760, 22760),
         16#20#           =>  --  011320
          (0, 0, 22761, 22761),
         16#21#           =>  --  011321
          (0, 0, 22762, 22762),
         16#22#           =>  --  011322
          (0, 0, 22763, 22763),
         16#23#           =>  --  011323
          (0, 0, 22764, 22764),
         16#24#           =>  --  011324
          (0, 0, 22765, 22765),
         16#25#           =>  --  011325
          (0, 0, 22766, 22766),
         16#26#           =>  --  011326
          (0, 0, 22767, 22767),
         16#27#           =>  --  011327
          (0, 0, 22768, 22768),
         16#28#           =>  --  011328
          (0, 0, 22769, 22769),
         16#2A#           =>  --  01132A
          (0, 0, 22770, 22770),
         16#2B#           =>  --  01132B
          (0, 0, 22771, 22771),
         16#2C#           =>  --  01132C
          (0, 0, 22772, 22772),
         16#2D#           =>  --  01132D
          (0, 0, 22773, 22773),
         16#2E#           =>  --  01132E
          (0, 0, 22774, 22774),
         16#2F#           =>  --  01132F
          (0, 0, 22775, 22775),
         16#30#           =>  --  011330
          (0, 0, 22776, 22776),
         16#32#           =>  --  011332
          (0, 0, 22777, 22777),
         16#33#           =>  --  011333
          (0, 0, 22778, 22778),
         16#35#           =>  --  011335
          (0, 0, 22779, 22779),
         16#36#           =>  --  011336
          (0, 0, 22780, 22780),
         16#37#           =>  --  011337
          (0, 0, 22781, 22781),
         16#38#           =>  --  011338
          (0, 0, 22782, 22782),
         16#39#           =>  --  011339
          (0, 0, 22783, 22783),
         16#3C#           =>  --  01133C
          (0, 0, 2283, 2283),
         16#3D#           =>  --  01133D
          (0, 0, 22784, 22784),
         16#3E#           =>  --  01133E
          (0, 0, 22785, 22785),
         16#3F#           =>  --  01133F
          (0, 0, 22786, 22786),
         16#40#           =>  --  011340
          (0, 0, 22787, 22787),
         16#41#           =>  --  011341
          (0, 0, 22788, 22788),
         16#42#           =>  --  011342
          (0, 0, 22789, 22789),
         16#43#           =>  --  011343
          (0, 0, 22790, 22790),
         16#44#           =>  --  011344
          (0, 0, 22791, 22791),
         16#47#           =>  --  011347
          (696, 697, 22792, 22792),
         16#48#           =>  --  011348
          (0, 0, 22795, 22795),
         16#4B#           =>  --  01134B
          (0, 0, 22793, 22793),
         16#4C#           =>  --  01134C
          (0, 0, 22794, 22794),
         16#4D#           =>  --  01134D
          (0, 0, 22796, 22796),
         16#57#           =>  --  011357
          (0, 0, 22797, 22797),
         16#5D#           =>  --  01135D
          (0, 0, 22798, 22798),
         16#5E#           =>  --  01135E
          (0, 0, 22799, 22799),
         16#5F#           =>  --  01135F
          (0, 0, 22800, 22800),
         16#60#           =>  --  011360
          (0, 0, 22801, 22801),
         16#61#           =>  --  011361
          (0, 0, 22802, 22802),
         16#62#           =>  --  011362
          (0, 0, 22803, 22803),
         16#63#           =>  --  011363
          (0, 0, 22804, 22804),
         16#66# .. 16#6C# =>  --  011366 .. 01136C
          (0, 0, 1, 1),
         16#70# .. 16#74# =>  --  011370 .. 011374
          (0, 0, 1, 1),
         others           =>
          (0, 0, 0, 0));

   Group_0114 : aliased constant Collation_Second_Stage
     := (16#80#           =>  --  011480
          (0, 0, 22805, 22805),
         16#81#           =>  --  011481
          (0, 0, 22806, 22806),
         16#82#           =>  --  011482
          (0, 0, 22807, 22807),
         16#83#           =>  --  011483
          (0, 0, 22808, 22808),
         16#84#           =>  --  011484
          (0, 0, 22809, 22809),
         16#85#           =>  --  011485
          (0, 0, 22810, 22810),
         16#86#           =>  --  011486
          (0, 0, 22811, 22811),
         16#87#           =>  --  011487
          (0, 0, 22812, 22812),
         16#88#           =>  --  011488
          (0, 0, 22813, 22813),
         16#89#           =>  --  011489
          (0, 0, 22814, 22814),
         16#8A#           =>  --  01148A
          (0, 0, 22815, 22815),
         16#8B#           =>  --  01148B
          (0, 0, 22816, 22816),
         16#8C#           =>  --  01148C
          (0, 0, 22817, 22817),
         16#8D#           =>  --  01148D
          (0, 0, 22818, 22818),
         16#8E#           =>  --  01148E
          (0, 0, 22819, 22819),
         16#8F#           =>  --  01148F
          (0, 0, 22820, 22820),
         16#90#           =>  --  011490
          (0, 0, 22821, 22821),
         16#91#           =>  --  011491
          (0, 0, 22822, 22822),
         16#92#           =>  --  011492
          (0, 0, 22823, 22823),
         16#93#           =>  --  011493
          (0, 0, 22824, 22824),
         16#94#           =>  --  011494
          (0, 0, 22825, 22825),
         16#95#           =>  --  011495
          (0, 0, 22826, 22826),
         16#96#           =>  --  011496
          (0, 0, 22827, 22827),
         16#97#           =>  --  011497
          (0, 0, 22828, 22828),
         16#98#           =>  --  011498
          (0, 0, 22829, 22829),
         16#99#           =>  --  011499
          (0, 0, 22830, 22830),
         16#9A#           =>  --  01149A
          (0, 0, 22831, 22831),
         16#9B#           =>  --  01149B
          (0, 0, 22832, 22832),
         16#9C#           =>  --  01149C
          (0, 0, 22833, 22833),
         16#9D#           =>  --  01149D
          (0, 0, 22834, 22834),
         16#9E#           =>  --  01149E
          (0, 0, 22835, 22835),
         16#9F#           =>  --  01149F
          (0, 0, 22836, 22836),
         16#A0#           =>  --  0114A0
          (0, 0, 22837, 22837),
         16#A1#           =>  --  0114A1
          (0, 0, 22838, 22838),
         16#A2#           =>  --  0114A2
          (0, 0, 22839, 22839),
         16#A3#           =>  --  0114A3
          (0, 0, 22840, 22840),
         16#A4#           =>  --  0114A4
          (0, 0, 22841, 22841),
         16#A5#           =>  --  0114A5
          (0, 0, 22842, 22842),
         16#A6#           =>  --  0114A6
          (0, 0, 22843, 22843),
         16#A7#           =>  --  0114A7
          (0, 0, 22844, 22844),
         16#A8#           =>  --  0114A8
          (0, 0, 22845, 22845),
         16#A9#           =>  --  0114A9
          (0, 0, 22846, 22846),
         16#AA#           =>  --  0114AA
          (0, 0, 22847, 22847),
         16#AB#           =>  --  0114AB
          (0, 0, 22848, 22848),
         16#AC#           =>  --  0114AC
          (0, 0, 22849, 22849),
         16#AD#           =>  --  0114AD
          (0, 0, 22850, 22850),
         16#AE#           =>  --  0114AE
          (0, 0, 22851, 22851),
         16#AF#           =>  --  0114AF
          (0, 0, 22852, 22852),
         16#B0#           =>  --  0114B0
          (0, 0, 22853, 22853),
         16#B1#           =>  --  0114B1
          (0, 0, 22854, 22854),
         16#B2#           =>  --  0114B2
          (0, 0, 22855, 22855),
         16#B3#           =>  --  0114B3
          (0, 0, 22856, 22856),
         16#B4#           =>  --  0114B4
          (0, 0, 22857, 22857),
         16#B5#           =>  --  0114B5
          (0, 0, 22858, 22858),
         16#B6#           =>  --  0114B6
          (0, 0, 22859, 22859),
         16#B7#           =>  --  0114B7
          (0, 0, 22860, 22860),
         16#B8#           =>  --  0114B8
          (0, 0, 22861, 22861),
         16#B9#           =>  --  0114B9
          (698, 700, 22862, 22862),
         16#BA#           =>  --  0114BA
          (0, 0, 22866, 22866),
         16#BB#           =>  --  0114BB
          (0, 0, 22863, 22863),
         16#BC#           =>  --  0114BC
          (0, 0, 22864, 22864),
         16#BD#           =>  --  0114BD
          (0, 0, 22867, 22867),
         16#BE#           =>  --  0114BE
          (0, 0, 22865, 22865),
         16#BF#           =>  --  0114BF
          (0, 0, 2242, 2242),
         16#C0#           =>  --  0114C0
          (0, 0, 2243, 2243),
         16#C1#           =>  --  0114C1
          (0, 0, 2244, 2244),
         16#C2#           =>  --  0114C2
          (0, 0, 22868, 22868),
         16#C3#           =>  --  0114C3
          (0, 0, 2283, 2283),
         16#C4#           =>  --  0114C4
          (0, 0, 22869, 22869),
         16#C5#           =>  --  0114C5
          (0, 0, 22870, 22870),
         16#C6#           =>  --  0114C6
          (0, 0, 22871, 22871),
         16#C7#           =>  --  0114C7
          (0, 0, 22872, 22872),
         16#D0#           =>  --  0114D0
          (0, 0, 23, 23),
         16#D1#           =>  --  0114D1
          (0, 0, 24, 24),
         16#D2#           =>  --  0114D2
          (0, 0, 25, 25),
         16#D3#           =>  --  0114D3
          (0, 0, 26, 26),
         16#D4#           =>  --  0114D4
          (0, 0, 27, 27),
         16#D5#           =>  --  0114D5
          (0, 0, 28, 28),
         16#D6#           =>  --  0114D6
          (0, 0, 29, 29),
         16#D7#           =>  --  0114D7
          (0, 0, 30, 30),
         16#D8#           =>  --  0114D8
          (0, 0, 31, 31),
         16#D9#           =>  --  0114D9
          (0, 0, 32, 32),
         others           =>
          (0, 0, 0, 0));

   Group_0115 : aliased constant Collation_Second_Stage
     := (16#80#           =>  --  011580
          (0, 0, 22873, 22873),
         16#81#           =>  --  011581
          (0, 0, 22874, 22874),
         16#82#           =>  --  011582
          (0, 0, 22875, 22875),
         16#83#           =>  --  011583
          (0, 0, 22876, 22876),
         16#84#           =>  --  011584
          (0, 0, 22877, 22877),
         16#85#           =>  --  011585
          (0, 0, 22878, 22878),
         16#86#           =>  --  011586
          (0, 0, 22879, 22879),
         16#87#           =>  --  011587
          (0, 0, 22880, 22880),
         16#88#           =>  --  011588
          (0, 0, 22881, 22881),
         16#89#           =>  --  011589
          (0, 0, 22882, 22882),
         16#8A#           =>  --  01158A
          (0, 0, 22883, 22883),
         16#8B#           =>  --  01158B
          (0, 0, 22884, 22884),
         16#8C#           =>  --  01158C
          (0, 0, 22885, 22885),
         16#8D#           =>  --  01158D
          (0, 0, 22886, 22886),
         16#8E#           =>  --  01158E
          (0, 0, 22887, 22887),
         16#8F#           =>  --  01158F
          (0, 0, 22888, 22888),
         16#90#           =>  --  011590
          (0, 0, 22889, 22889),
         16#91#           =>  --  011591
          (0, 0, 22890, 22890),
         16#92#           =>  --  011592
          (0, 0, 22891, 22891),
         16#93#           =>  --  011593
          (0, 0, 22892, 22892),
         16#94#           =>  --  011594
          (0, 0, 22893, 22893),
         16#95#           =>  --  011595
          (0, 0, 22894, 22894),
         16#96#           =>  --  011596
          (0, 0, 22895, 22895),
         16#97#           =>  --  011597
          (0, 0, 22896, 22896),
         16#98#           =>  --  011598
          (0, 0, 22897, 22897),
         16#99#           =>  --  011599
          (0, 0, 22898, 22898),
         16#9A#           =>  --  01159A
          (0, 0, 22899, 22899),
         16#9B#           =>  --  01159B
          (0, 0, 22900, 22900),
         16#9C#           =>  --  01159C
          (0, 0, 22901, 22901),
         16#9D#           =>  --  01159D
          (0, 0, 22902, 22902),
         16#9E#           =>  --  01159E
          (0, 0, 22903, 22903),
         16#9F#           =>  --  01159F
          (0, 0, 22904, 22904),
         16#A0#           =>  --  0115A0
          (0, 0, 22905, 22905),
         16#A1#           =>  --  0115A1
          (0, 0, 22906, 22906),
         16#A2#           =>  --  0115A2
          (0, 0, 22907, 22907),
         16#A3#           =>  --  0115A3
          (0, 0, 22908, 22908),
         16#A4#           =>  --  0115A4
          (0, 0, 22909, 22909),
         16#A5#           =>  --  0115A5
          (0, 0, 22910, 22910),
         16#A6#           =>  --  0115A6
          (0, 0, 22911, 22911),
         16#A7#           =>  --  0115A7
          (0, 0, 22912, 22912),
         16#A8#           =>  --  0115A8
          (0, 0, 22913, 22913),
         16#A9#           =>  --  0115A9
          (0, 0, 22914, 22914),
         16#AA#           =>  --  0115AA
          (0, 0, 22915, 22915),
         16#AB#           =>  --  0115AB
          (0, 0, 22916, 22916),
         16#AC#           =>  --  0115AC
          (0, 0, 22917, 22917),
         16#AD#           =>  --  0115AD
          (0, 0, 22918, 22918),
         16#AE#           =>  --  0115AE
          (0, 0, 22919, 22919),
         16#AF#           =>  --  0115AF
          (0, 0, 22920, 22920),
         16#B0#           =>  --  0115B0
          (0, 0, 22921, 22921),
         16#B1#           =>  --  0115B1
          (0, 0, 22922, 22922),
         16#B2#           =>  --  0115B2
          (0, 0, 22923, 22923),
         16#B3#           =>  --  0115B3
          (0, 0, 22924, 22924),
         16#B4#           =>  --  0115B4
          (0, 0, 22925, 22925),
         16#B5#           =>  --  0115B5
          (0, 0, 22926, 22926),
         16#B8#           =>  --  0115B8
          (701, 701, 22927, 22927),
         16#B9#           =>  --  0115B9
          (702, 702, 22929, 22929),
         16#BA#           =>  --  0115BA
          (0, 0, 22928, 22928),
         16#BB#           =>  --  0115BB
          (0, 0, 22930, 22930),
         16#BC#           =>  --  0115BC
          (0, 0, 2242, 2242),
         16#BD#           =>  --  0115BD
          (0, 0, 2243, 2243),
         16#BE#           =>  --  0115BE
          (0, 0, 2244, 2244),
         16#BF#           =>  --  0115BF
          (0, 0, 22931, 22931),
         16#C0#           =>  --  0115C0
          (0, 0, 2283, 2283),
         16#C1#           =>  --  0115C1
          (0, 0, 22932, 22932),
         16#C2#           =>  --  0115C2
          (0, 0, 22933, 22933),
         16#C3#           =>  --  0115C3
          (0, 0, 22934, 22934),
         16#C4#           =>  --  0115C4
          (0, 0, 22935, 22935),
         16#C5#           =>  --  0115C5
          (0, 0, 22936, 22936),
         16#C6#           =>  --  0115C6
          (0, 0, 22937, 22937),
         16#C7#           =>  --  0115C7
          (0, 0, 22938, 22938),
         16#C8#           =>  --  0115C8
          (0, 0, 22939, 22939),
         16#C9#           =>  --  0115C9
          (0, 0, 22940, 22940),
         others           =>
          (0, 0, 0, 0));

   Group_0116 : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  011600
          (0, 0, 22941, 22941),
         16#01#           =>  --  011601
          (0, 0, 22942, 22942),
         16#02#           =>  --  011602
          (0, 0, 22943, 22943),
         16#03#           =>  --  011603
          (0, 0, 22944, 22944),
         16#04#           =>  --  011604
          (0, 0, 22945, 22945),
         16#05#           =>  --  011605
          (0, 0, 22946, 22946),
         16#06#           =>  --  011606
          (0, 0, 22947, 22947),
         16#07#           =>  --  011607
          (0, 0, 22948, 22948),
         16#08#           =>  --  011608
          (0, 0, 22949, 22949),
         16#09#           =>  --  011609
          (0, 0, 22950, 22950),
         16#0A#           =>  --  01160A
          (0, 0, 22951, 22951),
         16#0B#           =>  --  01160B
          (0, 0, 22952, 22952),
         16#0C#           =>  --  01160C
          (0, 0, 22953, 22953),
         16#0D#           =>  --  01160D
          (0, 0, 22954, 22954),
         16#0E#           =>  --  01160E
          (0, 0, 22955, 22955),
         16#0F#           =>  --  01160F
          (0, 0, 22956, 22956),
         16#10#           =>  --  011610
          (0, 0, 22957, 22957),
         16#11#           =>  --  011611
          (0, 0, 22958, 22958),
         16#12#           =>  --  011612
          (0, 0, 22959, 22959),
         16#13#           =>  --  011613
          (0, 0, 22960, 22960),
         16#14#           =>  --  011614
          (0, 0, 22961, 22961),
         16#15#           =>  --  011615
          (0, 0, 22962, 22962),
         16#16#           =>  --  011616
          (0, 0, 22963, 22963),
         16#17#           =>  --  011617
          (0, 0, 22964, 22964),
         16#18#           =>  --  011618
          (0, 0, 22965, 22965),
         16#19#           =>  --  011619
          (0, 0, 22966, 22966),
         16#1A#           =>  --  01161A
          (0, 0, 22967, 22967),
         16#1B#           =>  --  01161B
          (0, 0, 22968, 22968),
         16#1C#           =>  --  01161C
          (0, 0, 22969, 22969),
         16#1D#           =>  --  01161D
          (0, 0, 22970, 22970),
         16#1E#           =>  --  01161E
          (0, 0, 22971, 22971),
         16#1F#           =>  --  01161F
          (0, 0, 22972, 22972),
         16#20#           =>  --  011620
          (0, 0, 22973, 22973),
         16#21#           =>  --  011621
          (0, 0, 22974, 22974),
         16#22#           =>  --  011622
          (0, 0, 22975, 22975),
         16#23#           =>  --  011623
          (0, 0, 22976, 22976),
         16#24#           =>  --  011624
          (0, 0, 22977, 22977),
         16#25#           =>  --  011625
          (0, 0, 22978, 22978),
         16#26#           =>  --  011626
          (0, 0, 22979, 22979),
         16#27#           =>  --  011627
          (0, 0, 22980, 22980),
         16#28#           =>  --  011628
          (0, 0, 22981, 22981),
         16#29#           =>  --  011629
          (0, 0, 22982, 22982),
         16#2A#           =>  --  01162A
          (0, 0, 22983, 22983),
         16#2B#           =>  --  01162B
          (0, 0, 22984, 22984),
         16#2C#           =>  --  01162C
          (0, 0, 22985, 22985),
         16#2D#           =>  --  01162D
          (0, 0, 22986, 22986),
         16#2E#           =>  --  01162E
          (0, 0, 22987, 22987),
         16#2F#           =>  --  01162F
          (0, 0, 22988, 22988),
         16#30#           =>  --  011630
          (0, 0, 22989, 22989),
         16#31#           =>  --  011631
          (0, 0, 22990, 22990),
         16#32#           =>  --  011632
          (0, 0, 22991, 22991),
         16#33#           =>  --  011633
          (0, 0, 22992, 22992),
         16#34#           =>  --  011634
          (0, 0, 22993, 22993),
         16#35#           =>  --  011635
          (0, 0, 22994, 22994),
         16#36#           =>  --  011636
          (0, 0, 22995, 22995),
         16#37#           =>  --  011637
          (0, 0, 22996, 22996),
         16#38#           =>  --  011638
          (0, 0, 22997, 22997),
         16#39#           =>  --  011639
          (0, 0, 22998, 22998),
         16#3A#           =>  --  01163A
          (0, 0, 22999, 22999),
         16#3B#           =>  --  01163B
          (0, 0, 23000, 23000),
         16#3C#           =>  --  01163C
          (0, 0, 23001, 23001),
         16#3D#           =>  --  01163D
          (0, 0, 2243, 2243),
         16#3E#           =>  --  01163E
          (0, 0, 2244, 2244),
         16#3F#           =>  --  01163F
          (0, 0, 23002, 23002),
         16#40#           =>  --  011640
          (0, 0, 2242, 2242),
         16#41#           =>  --  011641
          (0, 0, 23003, 23003),
         16#42#           =>  --  011642
          (0, 0, 23004, 23004),
         16#43#           =>  --  011643
          (0, 0, 23005, 23005),
         16#44#           =>  --  011644
          (0, 0, 23006, 23006),
         16#50#           =>  --  011650
          (0, 0, 23, 23),
         16#51#           =>  --  011651
          (0, 0, 24, 24),
         16#52#           =>  --  011652
          (0, 0, 25, 25),
         16#53#           =>  --  011653
          (0, 0, 26, 26),
         16#54#           =>  --  011654
          (0, 0, 27, 27),
         16#55#           =>  --  011655
          (0, 0, 28, 28),
         16#56#           =>  --  011656
          (0, 0, 29, 29),
         16#57#           =>  --  011657
          (0, 0, 30, 30),
         16#58#           =>  --  011658
          (0, 0, 31, 31),
         16#59#           =>  --  011659
          (0, 0, 32, 32),
         16#80#           =>  --  011680
          (0, 0, 23007, 23007),
         16#81#           =>  --  011681
          (0, 0, 23008, 23008),
         16#82#           =>  --  011682
          (0, 0, 23009, 23009),
         16#83#           =>  --  011683
          (0, 0, 23010, 23010),
         16#84#           =>  --  011684
          (0, 0, 23011, 23011),
         16#85#           =>  --  011685
          (0, 0, 23012, 23012),
         16#86#           =>  --  011686
          (0, 0, 23013, 23013),
         16#87#           =>  --  011687
          (0, 0, 23014, 23014),
         16#88#           =>  --  011688
          (0, 0, 23015, 23015),
         16#89#           =>  --  011689
          (0, 0, 23016, 23016),
         16#8A#           =>  --  01168A
          (0, 0, 23017, 23017),
         16#8B#           =>  --  01168B
          (0, 0, 23018, 23018),
         16#8C#           =>  --  01168C
          (0, 0, 23019, 23019),
         16#8D#           =>  --  01168D
          (0, 0, 23020, 23020),
         16#8E#           =>  --  01168E
          (0, 0, 23021, 23021),
         16#8F#           =>  --  01168F
          (0, 0, 23022, 23022),
         16#90#           =>  --  011690
          (0, 0, 23023, 23023),
         16#91#           =>  --  011691
          (0, 0, 23024, 23024),
         16#92#           =>  --  011692
          (0, 0, 23025, 23025),
         16#93#           =>  --  011693
          (0, 0, 23026, 23026),
         16#94#           =>  --  011694
          (0, 0, 23027, 23027),
         16#95#           =>  --  011695
          (0, 0, 23028, 23028),
         16#96#           =>  --  011696
          (0, 0, 23029, 23029),
         16#97#           =>  --  011697
          (0, 0, 23030, 23030),
         16#98#           =>  --  011698
          (0, 0, 23031, 23031),
         16#99#           =>  --  011699
          (0, 0, 23032, 23032),
         16#9A#           =>  --  01169A
          (0, 0, 23033, 23033),
         16#9B#           =>  --  01169B
          (0, 0, 23034, 23034),
         16#9C#           =>  --  01169C
          (0, 0, 23035, 23035),
         16#9D#           =>  --  01169D
          (0, 0, 23036, 23036),
         16#9E#           =>  --  01169E
          (0, 0, 23037, 23037),
         16#9F#           =>  --  01169F
          (0, 0, 23038, 23038),
         16#A0#           =>  --  0116A0
          (0, 0, 23039, 23039),
         16#A1#           =>  --  0116A1
          (0, 0, 23040, 23040),
         16#A2#           =>  --  0116A2
          (0, 0, 23041, 23041),
         16#A3#           =>  --  0116A3
          (0, 0, 23042, 23042),
         16#A4#           =>  --  0116A4
          (0, 0, 23043, 23043),
         16#A5#           =>  --  0116A5
          (0, 0, 23044, 23044),
         16#A6#           =>  --  0116A6
          (0, 0, 23045, 23045),
         16#A7#           =>  --  0116A7
          (0, 0, 23046, 23046),
         16#A8#           =>  --  0116A8
          (0, 0, 23047, 23047),
         16#A9#           =>  --  0116A9
          (0, 0, 23048, 23048),
         16#AA#           =>  --  0116AA
          (0, 0, 23049, 23049),
         16#AB#           =>  --  0116AB
          (0, 0, 2243, 2243),
         16#AC#           =>  --  0116AC
          (0, 0, 2244, 2244),
         16#AD#           =>  --  0116AD
          (0, 0, 23050, 23050),
         16#AE#           =>  --  0116AE
          (0, 0, 23051, 23051),
         16#AF#           =>  --  0116AF
          (0, 0, 23052, 23052),
         16#B0#           =>  --  0116B0
          (0, 0, 23053, 23053),
         16#B1#           =>  --  0116B1
          (0, 0, 23054, 23054),
         16#B2#           =>  --  0116B2
          (0, 0, 23055, 23055),
         16#B3#           =>  --  0116B3
          (0, 0, 23056, 23056),
         16#B4#           =>  --  0116B4
          (0, 0, 23057, 23057),
         16#B5#           =>  --  0116B5
          (0, 0, 23058, 23058),
         16#B6#           =>  --  0116B6
          (0, 0, 23059, 23059),
         16#B7#           =>  --  0116B7
          (0, 0, 2283, 2283),
         16#C0#           =>  --  0116C0
          (0, 0, 23, 23),
         16#C1#           =>  --  0116C1
          (0, 0, 24, 24),
         16#C2#           =>  --  0116C2
          (0, 0, 25, 25),
         16#C3#           =>  --  0116C3
          (0, 0, 26, 26),
         16#C4#           =>  --  0116C4
          (0, 0, 27, 27),
         16#C5#           =>  --  0116C5
          (0, 0, 28, 28),
         16#C6#           =>  --  0116C6
          (0, 0, 29, 29),
         16#C7#           =>  --  0116C7
          (0, 0, 30, 30),
         16#C8#           =>  --  0116C8
          (0, 0, 31, 31),
         16#C9#           =>  --  0116C9
          (0, 0, 32, 32),
         others           =>
          (0, 0, 0, 0));

   Group_0118 : aliased constant Collation_Second_Stage
     := (16#A0#           =>  --  0118A0
          (0, 0, 23060, 23060),
         16#A1#           =>  --  0118A1
          (0, 0, 23061, 23061),
         16#A2#           =>  --  0118A2
          (0, 0, 23062, 23062),
         16#A3#           =>  --  0118A3
          (0, 0, 23063, 23063),
         16#A4#           =>  --  0118A4
          (0, 0, 23064, 23064),
         16#A5#           =>  --  0118A5
          (0, 0, 23065, 23065),
         16#A6#           =>  --  0118A6
          (0, 0, 23066, 23066),
         16#A7#           =>  --  0118A7
          (0, 0, 23067, 23067),
         16#A8#           =>  --  0118A8
          (0, 0, 23068, 23068),
         16#A9#           =>  --  0118A9
          (0, 0, 23069, 23069),
         16#AA#           =>  --  0118AA
          (0, 0, 23070, 23070),
         16#AB#           =>  --  0118AB
          (0, 0, 23071, 23071),
         16#AC#           =>  --  0118AC
          (0, 0, 23072, 23072),
         16#AD#           =>  --  0118AD
          (0, 0, 23073, 23073),
         16#AE#           =>  --  0118AE
          (0, 0, 23074, 23074),
         16#AF#           =>  --  0118AF
          (0, 0, 23075, 23075),
         16#B0#           =>  --  0118B0
          (0, 0, 23076, 23076),
         16#B1#           =>  --  0118B1
          (0, 0, 23077, 23077),
         16#B2#           =>  --  0118B2
          (0, 0, 23078, 23078),
         16#B3#           =>  --  0118B3
          (0, 0, 23079, 23079),
         16#B4#           =>  --  0118B4
          (0, 0, 23080, 23080),
         16#B5#           =>  --  0118B5
          (0, 0, 23081, 23081),
         16#B6#           =>  --  0118B6
          (0, 0, 23082, 23082),
         16#B7#           =>  --  0118B7
          (0, 0, 23083, 23083),
         16#B8#           =>  --  0118B8
          (0, 0, 23084, 23084),
         16#B9#           =>  --  0118B9
          (0, 0, 23085, 23085),
         16#BA#           =>  --  0118BA
          (0, 0, 23086, 23086),
         16#BB#           =>  --  0118BB
          (0, 0, 23087, 23087),
         16#BC#           =>  --  0118BC
          (0, 0, 23088, 23088),
         16#BD#           =>  --  0118BD
          (0, 0, 23089, 23089),
         16#BE#           =>  --  0118BE
          (0, 0, 23090, 23090),
         16#BF#           =>  --  0118BF
          (0, 0, 23091, 23091),
         16#C0#           =>  --  0118C0
          (0, 0, 23092, 23092),
         16#C1#           =>  --  0118C1
          (0, 0, 23093, 23093),
         16#C2#           =>  --  0118C2
          (0, 0, 23094, 23094),
         16#C3#           =>  --  0118C3
          (0, 0, 23095, 23095),
         16#C4#           =>  --  0118C4
          (0, 0, 23096, 23096),
         16#C5#           =>  --  0118C5
          (0, 0, 23097, 23097),
         16#C6#           =>  --  0118C6
          (0, 0, 23098, 23098),
         16#C7#           =>  --  0118C7
          (0, 0, 23099, 23099),
         16#C8#           =>  --  0118C8
          (0, 0, 23100, 23100),
         16#C9#           =>  --  0118C9
          (0, 0, 23101, 23101),
         16#CA#           =>  --  0118CA
          (0, 0, 23102, 23102),
         16#CB#           =>  --  0118CB
          (0, 0, 23103, 23103),
         16#CC#           =>  --  0118CC
          (0, 0, 23104, 23104),
         16#CD#           =>  --  0118CD
          (0, 0, 23105, 23105),
         16#CE#           =>  --  0118CE
          (0, 0, 23106, 23106),
         16#CF#           =>  --  0118CF
          (0, 0, 23107, 23107),
         16#D0#           =>  --  0118D0
          (0, 0, 23108, 23108),
         16#D1#           =>  --  0118D1
          (0, 0, 23109, 23109),
         16#D2#           =>  --  0118D2
          (0, 0, 23110, 23110),
         16#D3#           =>  --  0118D3
          (0, 0, 23111, 23111),
         16#D4#           =>  --  0118D4
          (0, 0, 23112, 23112),
         16#D5#           =>  --  0118D5
          (0, 0, 23113, 23113),
         16#D6#           =>  --  0118D6
          (0, 0, 23114, 23114),
         16#D7#           =>  --  0118D7
          (0, 0, 23115, 23115),
         16#D8#           =>  --  0118D8
          (0, 0, 23116, 23116),
         16#D9#           =>  --  0118D9
          (0, 0, 23117, 23117),
         16#DA#           =>  --  0118DA
          (0, 0, 23118, 23118),
         16#DB#           =>  --  0118DB
          (0, 0, 23119, 23119),
         16#DC#           =>  --  0118DC
          (0, 0, 23120, 23120),
         16#DD#           =>  --  0118DD
          (0, 0, 23121, 23121),
         16#DE#           =>  --  0118DE
          (0, 0, 23122, 23122),
         16#DF#           =>  --  0118DF
          (0, 0, 23123, 23123),
         16#E0#           =>  --  0118E0
          (0, 0, 23, 23),
         16#E1#           =>  --  0118E1
          (0, 0, 24, 24),
         16#E2#           =>  --  0118E2
          (0, 0, 25, 25),
         16#E3#           =>  --  0118E3
          (0, 0, 26, 26),
         16#E4#           =>  --  0118E4
          (0, 0, 27, 27),
         16#E5#           =>  --  0118E5
          (0, 0, 28, 28),
         16#E6#           =>  --  0118E6
          (0, 0, 29, 29),
         16#E7#           =>  --  0118E7
          (0, 0, 30, 30),
         16#E8#           =>  --  0118E8
          (0, 0, 31, 31),
         16#E9#           =>  --  0118E9
          (0, 0, 32, 32),
         16#EA#           =>  --  0118EA
          (0, 0, 23124, 23124),
         16#EB#           =>  --  0118EB
          (0, 0, 23125, 23125),
         16#EC#           =>  --  0118EC
          (0, 0, 23126, 23126),
         16#ED#           =>  --  0118ED
          (0, 0, 23127, 23127),
         16#EE#           =>  --  0118EE
          (0, 0, 23128, 23128),
         16#EF#           =>  --  0118EF
          (0, 0, 23129, 23129),
         16#F0#           =>  --  0118F0
          (0, 0, 23130, 23130),
         16#F1#           =>  --  0118F1
          (0, 0, 23131, 23131),
         16#F2#           =>  --  0118F2
          (0, 0, 23132, 23132),
         16#FF#           =>  --  0118FF
          (0, 0, 23133, 23133),
         others           =>
          (0, 0, 0, 0));

   Group_011A : aliased constant Collation_Second_Stage
     := (16#C0#           =>  --  011AC0
          (0, 0, 23134, 23134),
         16#C1#           =>  --  011AC1
          (0, 0, 23135, 23135),
         16#C2#           =>  --  011AC2
          (0, 0, 23136, 23136),
         16#C3#           =>  --  011AC3
          (0, 0, 23137, 23137),
         16#C4#           =>  --  011AC4
          (0, 0, 23138, 23138),
         16#C5#           =>  --  011AC5
          (0, 0, 23139, 23139),
         16#C6#           =>  --  011AC6
          (0, 0, 23140, 23140),
         16#C7#           =>  --  011AC7
          (0, 0, 23141, 23141),
         16#C8#           =>  --  011AC8
          (0, 0, 23142, 23142),
         16#C9#           =>  --  011AC9
          (0, 0, 23143, 23143),
         16#CA#           =>  --  011ACA
          (0, 0, 23144, 23144),
         16#CB#           =>  --  011ACB
          (0, 0, 23145, 23145),
         16#CC#           =>  --  011ACC
          (0, 0, 23146, 23146),
         16#CD#           =>  --  011ACD
          (0, 0, 23147, 23147),
         16#CE#           =>  --  011ACE
          (0, 0, 23148, 23148),
         16#CF#           =>  --  011ACF
          (0, 0, 23149, 23149),
         16#D0#           =>  --  011AD0
          (0, 0, 23150, 23150),
         16#D1#           =>  --  011AD1
          (0, 0, 23151, 23151),
         16#D2#           =>  --  011AD2
          (0, 0, 23152, 23152),
         16#D3#           =>  --  011AD3
          (0, 0, 23153, 23153),
         16#D4#           =>  --  011AD4
          (0, 0, 23154, 23154),
         16#D5#           =>  --  011AD5
          (0, 0, 23155, 23155),
         16#D6#           =>  --  011AD6
          (0, 0, 23156, 23156),
         16#D7#           =>  --  011AD7
          (0, 0, 23157, 23157),
         16#D8#           =>  --  011AD8
          (0, 0, 23158, 23158),
         16#D9#           =>  --  011AD9
          (0, 0, 23159, 23159),
         16#DA#           =>  --  011ADA
          (0, 0, 23160, 23160),
         16#DB#           =>  --  011ADB
          (0, 0, 23161, 23161),
         16#DC#           =>  --  011ADC
          (0, 0, 23162, 23162),
         16#DD#           =>  --  011ADD
          (0, 0, 23163, 23163),
         16#DE#           =>  --  011ADE
          (0, 0, 23164, 23164),
         16#DF#           =>  --  011ADF
          (0, 0, 23165, 23165),
         16#E0#           =>  --  011AE0
          (0, 0, 23166, 23166),
         16#E1#           =>  --  011AE1
          (0, 0, 23167, 23167),
         16#E2#           =>  --  011AE2
          (0, 0, 23168, 23168),
         16#E3#           =>  --  011AE3
          (0, 0, 23169, 23169),
         16#E4#           =>  --  011AE4
          (0, 0, 23170, 23170),
         16#E5#           =>  --  011AE5
          (0, 0, 23171, 23171),
         16#E6#           =>  --  011AE6
          (0, 0, 23172, 23172),
         16#E7#           =>  --  011AE7
          (0, 0, 23173, 23173),
         16#E8#           =>  --  011AE8
          (0, 0, 23174, 23174),
         16#E9#           =>  --  011AE9
          (0, 0, 23175, 23175),
         16#EA#           =>  --  011AEA
          (0, 0, 23176, 23176),
         16#EB#           =>  --  011AEB
          (0, 0, 23177, 23177),
         16#EC#           =>  --  011AEC
          (0, 0, 23178, 23178),
         16#ED#           =>  --  011AED
          (0, 0, 23179, 23179),
         16#EE#           =>  --  011AEE
          (0, 0, 23180, 23180),
         16#EF#           =>  --  011AEF
          (0, 0, 23181, 23181),
         16#F0#           =>  --  011AF0
          (0, 0, 23182, 23182),
         16#F1#           =>  --  011AF1
          (0, 0, 23183, 23183),
         16#F2#           =>  --  011AF2
          (0, 0, 23184, 23184),
         16#F3#           =>  --  011AF3
          (0, 0, 23185, 23185),
         16#F4#           =>  --  011AF4
          (0, 0, 23186, 23186),
         16#F5#           =>  --  011AF5
          (0, 0, 23187, 23187),
         16#F6#           =>  --  011AF6
          (0, 0, 23188, 23188),
         16#F7#           =>  --  011AF7
          (0, 0, 23189, 23189),
         16#F8#           =>  --  011AF8
          (0, 0, 23190, 23190),
         others           =>
          (0, 0, 0, 0));

   Group_0120 : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  012000
          (0, 0, 23191, 23191),
         16#01#           =>  --  012001
          (0, 0, 23192, 23192),
         16#02#           =>  --  012002
          (0, 0, 23193, 23193),
         16#03#           =>  --  012003
          (0, 0, 23194, 23194),
         16#04#           =>  --  012004
          (0, 0, 23195, 23195),
         16#05#           =>  --  012005
          (0, 0, 23196, 23196),
         16#06#           =>  --  012006
          (0, 0, 23197, 23197),
         16#07#           =>  --  012007
          (0, 0, 23198, 23198),
         16#08#           =>  --  012008
          (0, 0, 23199, 23199),
         16#09#           =>  --  012009
          (0, 0, 23200, 23200),
         16#0A#           =>  --  01200A
          (0, 0, 23201, 23201),
         16#0B#           =>  --  01200B
          (0, 0, 23202, 23202),
         16#0C#           =>  --  01200C
          (0, 0, 23203, 23203),
         16#0D#           =>  --  01200D
          (0, 0, 23204, 23204),
         16#0E#           =>  --  01200E
          (0, 0, 23205, 23205),
         16#0F#           =>  --  01200F
          (0, 0, 23206, 23206),
         16#10#           =>  --  012010
          (0, 0, 23207, 23207),
         16#11#           =>  --  012011
          (0, 0, 23208, 23208),
         16#12#           =>  --  012012
          (0, 0, 23209, 23209),
         16#13#           =>  --  012013
          (0, 0, 23210, 23210),
         16#14#           =>  --  012014
          (0, 0, 23211, 23211),
         16#15#           =>  --  012015
          (0, 0, 23212, 23212),
         16#16#           =>  --  012016
          (0, 0, 23213, 23213),
         16#17#           =>  --  012017
          (0, 0, 23214, 23214),
         16#18#           =>  --  012018
          (0, 0, 23215, 23215),
         16#19#           =>  --  012019
          (0, 0, 23216, 23216),
         16#1A#           =>  --  01201A
          (0, 0, 23217, 23217),
         16#1B#           =>  --  01201B
          (0, 0, 23218, 23218),
         16#1C#           =>  --  01201C
          (0, 0, 23219, 23219),
         16#1D#           =>  --  01201D
          (0, 0, 23220, 23220),
         16#1E#           =>  --  01201E
          (0, 0, 23221, 23221),
         16#1F#           =>  --  01201F
          (0, 0, 23222, 23222),
         16#20#           =>  --  012020
          (0, 0, 23223, 23223),
         16#21#           =>  --  012021
          (0, 0, 23224, 23224),
         16#22#           =>  --  012022
          (0, 0, 23225, 23225),
         16#23#           =>  --  012023
          (0, 0, 23226, 23226),
         16#24#           =>  --  012024
          (0, 0, 23227, 23227),
         16#25#           =>  --  012025
          (0, 0, 23228, 23228),
         16#26#           =>  --  012026
          (0, 0, 23229, 23229),
         16#27#           =>  --  012027
          (0, 0, 23230, 23230),
         16#28#           =>  --  012028
          (0, 0, 23231, 23231),
         16#29#           =>  --  012029
          (0, 0, 23232, 23232),
         16#2A#           =>  --  01202A
          (0, 0, 23233, 23233),
         16#2B#           =>  --  01202B
          (0, 0, 23234, 23234),
         16#2C#           =>  --  01202C
          (0, 0, 23235, 23235),
         16#2D#           =>  --  01202D
          (0, 0, 23236, 23236),
         16#2E#           =>  --  01202E
          (0, 0, 23237, 23237),
         16#2F#           =>  --  01202F
          (0, 0, 23238, 23238),
         16#30#           =>  --  012030
          (0, 0, 23239, 23239),
         16#31#           =>  --  012031
          (0, 0, 23240, 23240),
         16#32#           =>  --  012032
          (0, 0, 23241, 23241),
         16#33#           =>  --  012033
          (0, 0, 23242, 23242),
         16#34#           =>  --  012034
          (0, 0, 23243, 23243),
         16#35#           =>  --  012035
          (0, 0, 23244, 23244),
         16#36#           =>  --  012036
          (0, 0, 23245, 23245),
         16#37#           =>  --  012037
          (0, 0, 23246, 23246),
         16#38#           =>  --  012038
          (0, 0, 23247, 23247),
         16#39#           =>  --  012039
          (0, 0, 23248, 23248),
         16#3A#           =>  --  01203A
          (0, 0, 23249, 23249),
         16#3B#           =>  --  01203B
          (0, 0, 23250, 23250),
         16#3C#           =>  --  01203C
          (0, 0, 23251, 23251),
         16#3D#           =>  --  01203D
          (0, 0, 23252, 23252),
         16#3E#           =>  --  01203E
          (0, 0, 23253, 23253),
         16#3F#           =>  --  01203F
          (0, 0, 23254, 23254),
         16#40#           =>  --  012040
          (0, 0, 23255, 23255),
         16#41#           =>  --  012041
          (0, 0, 23256, 23256),
         16#42#           =>  --  012042
          (0, 0, 23257, 23257),
         16#43#           =>  --  012043
          (0, 0, 23258, 23258),
         16#44#           =>  --  012044
          (0, 0, 23259, 23259),
         16#45#           =>  --  012045
          (0, 0, 23260, 23260),
         16#46#           =>  --  012046
          (0, 0, 23261, 23261),
         16#47#           =>  --  012047
          (0, 0, 23262, 23262),
         16#48#           =>  --  012048
          (0, 0, 23263, 23263),
         16#49#           =>  --  012049
          (0, 0, 23264, 23264),
         16#4A#           =>  --  01204A
          (0, 0, 23265, 23265),
         16#4B#           =>  --  01204B
          (0, 0, 23266, 23266),
         16#4C#           =>  --  01204C
          (0, 0, 23267, 23267),
         16#4D#           =>  --  01204D
          (0, 0, 23268, 23268),
         16#4E#           =>  --  01204E
          (0, 0, 23269, 23269),
         16#4F#           =>  --  01204F
          (0, 0, 23270, 23270),
         16#50#           =>  --  012050
          (0, 0, 23271, 23271),
         16#51#           =>  --  012051
          (0, 0, 23272, 23272),
         16#52#           =>  --  012052
          (0, 0, 23273, 23273),
         16#53#           =>  --  012053
          (0, 0, 23274, 23274),
         16#54#           =>  --  012054
          (0, 0, 23275, 23275),
         16#55#           =>  --  012055
          (0, 0, 23276, 23276),
         16#56#           =>  --  012056
          (0, 0, 23277, 23277),
         16#57#           =>  --  012057
          (0, 0, 23278, 23278),
         16#58#           =>  --  012058
          (0, 0, 23279, 23279),
         16#59#           =>  --  012059
          (0, 0, 23280, 23280),
         16#5A#           =>  --  01205A
          (0, 0, 23281, 23281),
         16#5B#           =>  --  01205B
          (0, 0, 23282, 23282),
         16#5C#           =>  --  01205C
          (0, 0, 23283, 23283),
         16#5D#           =>  --  01205D
          (0, 0, 23284, 23284),
         16#5E#           =>  --  01205E
          (0, 0, 23285, 23285),
         16#5F#           =>  --  01205F
          (0, 0, 23286, 23286),
         16#60#           =>  --  012060
          (0, 0, 23287, 23287),
         16#61#           =>  --  012061
          (0, 0, 23288, 23288),
         16#62#           =>  --  012062
          (0, 0, 23289, 23289),
         16#63#           =>  --  012063
          (0, 0, 23290, 23290),
         16#64#           =>  --  012064
          (0, 0, 23291, 23291),
         16#65#           =>  --  012065
          (0, 0, 23292, 23292),
         16#66#           =>  --  012066
          (0, 0, 23293, 23293),
         16#67#           =>  --  012067
          (0, 0, 23294, 23294),
         16#68#           =>  --  012068
          (0, 0, 23295, 23295),
         16#69#           =>  --  012069
          (0, 0, 23296, 23296),
         16#6A#           =>  --  01206A
          (0, 0, 23297, 23297),
         16#6B#           =>  --  01206B
          (0, 0, 23298, 23298),
         16#6C#           =>  --  01206C
          (0, 0, 23299, 23299),
         16#6D#           =>  --  01206D
          (0, 0, 23300, 23300),
         16#6E#           =>  --  01206E
          (0, 0, 23301, 23301),
         16#6F#           =>  --  01206F
          (0, 0, 23302, 23302),
         16#70#           =>  --  012070
          (0, 0, 23303, 23303),
         16#71#           =>  --  012071
          (0, 0, 23304, 23304),
         16#72#           =>  --  012072
          (0, 0, 23305, 23305),
         16#73#           =>  --  012073
          (0, 0, 23306, 23306),
         16#74#           =>  --  012074
          (0, 0, 23307, 23307),
         16#75#           =>  --  012075
          (0, 0, 23308, 23308),
         16#76#           =>  --  012076
          (0, 0, 23309, 23309),
         16#77#           =>  --  012077
          (0, 0, 23310, 23310),
         16#78#           =>  --  012078
          (0, 0, 23311, 23311),
         16#79#           =>  --  012079
          (0, 0, 23312, 23312),
         16#7A#           =>  --  01207A
          (0, 0, 23313, 23313),
         16#7B#           =>  --  01207B
          (0, 0, 23314, 23314),
         16#7C#           =>  --  01207C
          (0, 0, 23315, 23315),
         16#7D#           =>  --  01207D
          (0, 0, 23316, 23316),
         16#7E#           =>  --  01207E
          (0, 0, 23317, 23317),
         16#7F#           =>  --  01207F
          (0, 0, 23318, 23318),
         16#80#           =>  --  012080
          (0, 0, 23319, 23319),
         16#81#           =>  --  012081
          (0, 0, 23320, 23320),
         16#82#           =>  --  012082
          (0, 0, 23321, 23321),
         16#83#           =>  --  012083
          (0, 0, 23322, 23322),
         16#84#           =>  --  012084
          (0, 0, 23323, 23323),
         16#85#           =>  --  012085
          (0, 0, 23324, 23324),
         16#86#           =>  --  012086
          (0, 0, 23325, 23325),
         16#87#           =>  --  012087
          (0, 0, 23326, 23326),
         16#88#           =>  --  012088
          (0, 0, 23327, 23327),
         16#89#           =>  --  012089
          (0, 0, 23328, 23328),
         16#8A#           =>  --  01208A
          (0, 0, 23329, 23329),
         16#8B#           =>  --  01208B
          (0, 0, 23330, 23330),
         16#8C#           =>  --  01208C
          (0, 0, 23331, 23331),
         16#8D#           =>  --  01208D
          (0, 0, 23332, 23332),
         16#8E#           =>  --  01208E
          (0, 0, 23333, 23333),
         16#8F#           =>  --  01208F
          (0, 0, 23334, 23334),
         16#90#           =>  --  012090
          (0, 0, 23335, 23335),
         16#91#           =>  --  012091
          (0, 0, 23336, 23336),
         16#92#           =>  --  012092
          (0, 0, 23337, 23337),
         16#93#           =>  --  012093
          (0, 0, 23338, 23338),
         16#94#           =>  --  012094
          (0, 0, 23339, 23339),
         16#95#           =>  --  012095
          (0, 0, 23340, 23340),
         16#96#           =>  --  012096
          (0, 0, 23341, 23341),
         16#97#           =>  --  012097
          (0, 0, 23342, 23342),
         16#98#           =>  --  012098
          (0, 0, 23343, 23343),
         16#99#           =>  --  012099
          (0, 0, 23344, 23344),
         16#9A#           =>  --  01209A
          (0, 0, 23345, 23345),
         16#9B#           =>  --  01209B
          (0, 0, 23346, 23346),
         16#9C#           =>  --  01209C
          (0, 0, 23347, 23347),
         16#9D#           =>  --  01209D
          (0, 0, 23348, 23348),
         16#9E#           =>  --  01209E
          (0, 0, 23349, 23349),
         16#9F#           =>  --  01209F
          (0, 0, 23350, 23350),
         16#A0#           =>  --  0120A0
          (0, 0, 23351, 23351),
         16#A1#           =>  --  0120A1
          (0, 0, 23352, 23352),
         16#A2#           =>  --  0120A2
          (0, 0, 23353, 23353),
         16#A3#           =>  --  0120A3
          (0, 0, 23354, 23354),
         16#A4#           =>  --  0120A4
          (0, 0, 23355, 23355),
         16#A5#           =>  --  0120A5
          (0, 0, 23356, 23356),
         16#A6#           =>  --  0120A6
          (0, 0, 23357, 23357),
         16#A7#           =>  --  0120A7
          (0, 0, 23358, 23358),
         16#A8#           =>  --  0120A8
          (0, 0, 23359, 23359),
         16#A9#           =>  --  0120A9
          (0, 0, 23360, 23360),
         16#AA#           =>  --  0120AA
          (0, 0, 23361, 23361),
         16#AB#           =>  --  0120AB
          (0, 0, 23362, 23362),
         16#AC#           =>  --  0120AC
          (0, 0, 23363, 23363),
         16#AD#           =>  --  0120AD
          (0, 0, 23364, 23364),
         16#AE#           =>  --  0120AE
          (0, 0, 23365, 23365),
         16#AF#           =>  --  0120AF
          (0, 0, 23366, 23366),
         16#B0#           =>  --  0120B0
          (0, 0, 23367, 23367),
         16#B1#           =>  --  0120B1
          (0, 0, 23368, 23368),
         16#B2#           =>  --  0120B2
          (0, 0, 23369, 23369),
         16#B3#           =>  --  0120B3
          (0, 0, 23370, 23370),
         16#B4#           =>  --  0120B4
          (0, 0, 23371, 23371),
         16#B5#           =>  --  0120B5
          (0, 0, 23372, 23372),
         16#B6#           =>  --  0120B6
          (0, 0, 23373, 23373),
         16#B7#           =>  --  0120B7
          (0, 0, 23374, 23374),
         16#B8#           =>  --  0120B8
          (0, 0, 23375, 23375),
         16#B9#           =>  --  0120B9
          (0, 0, 23376, 23376),
         16#BA#           =>  --  0120BA
          (0, 0, 23377, 23377),
         16#BB#           =>  --  0120BB
          (0, 0, 23378, 23378),
         16#BC#           =>  --  0120BC
          (0, 0, 23379, 23379),
         16#BD#           =>  --  0120BD
          (0, 0, 23380, 23380),
         16#BE#           =>  --  0120BE
          (0, 0, 23381, 23381),
         16#BF#           =>  --  0120BF
          (0, 0, 23382, 23382),
         16#C0#           =>  --  0120C0
          (0, 0, 23383, 23383),
         16#C1#           =>  --  0120C1
          (0, 0, 23384, 23384),
         16#C2#           =>  --  0120C2
          (0, 0, 23385, 23385),
         16#C3#           =>  --  0120C3
          (0, 0, 23386, 23386),
         16#C4#           =>  --  0120C4
          (0, 0, 23387, 23387),
         16#C5#           =>  --  0120C5
          (0, 0, 23388, 23388),
         16#C6#           =>  --  0120C6
          (0, 0, 23389, 23389),
         16#C7#           =>  --  0120C7
          (0, 0, 23390, 23390),
         16#C8#           =>  --  0120C8
          (0, 0, 23391, 23391),
         16#C9#           =>  --  0120C9
          (0, 0, 23392, 23392),
         16#CA#           =>  --  0120CA
          (0, 0, 23393, 23393),
         16#CB#           =>  --  0120CB
          (0, 0, 23394, 23394),
         16#CC#           =>  --  0120CC
          (0, 0, 23395, 23395),
         16#CD#           =>  --  0120CD
          (0, 0, 23396, 23396),
         16#CE#           =>  --  0120CE
          (0, 0, 23397, 23397),
         16#CF#           =>  --  0120CF
          (0, 0, 23398, 23398),
         16#D0#           =>  --  0120D0
          (0, 0, 23399, 23399),
         16#D1#           =>  --  0120D1
          (0, 0, 23400, 23400),
         16#D2#           =>  --  0120D2
          (0, 0, 23401, 23401),
         16#D3#           =>  --  0120D3
          (0, 0, 23402, 23402),
         16#D4#           =>  --  0120D4
          (0, 0, 23403, 23403),
         16#D5#           =>  --  0120D5
          (0, 0, 23404, 23404),
         16#D6#           =>  --  0120D6
          (0, 0, 23405, 23405),
         16#D7#           =>  --  0120D7
          (0, 0, 23406, 23406),
         16#D8#           =>  --  0120D8
          (0, 0, 23407, 23407),
         16#D9#           =>  --  0120D9
          (0, 0, 23408, 23408),
         16#DA#           =>  --  0120DA
          (0, 0, 23409, 23409),
         16#DB#           =>  --  0120DB
          (0, 0, 23410, 23410),
         16#DC#           =>  --  0120DC
          (0, 0, 23411, 23411),
         16#DD#           =>  --  0120DD
          (0, 0, 23412, 23412),
         16#DE#           =>  --  0120DE
          (0, 0, 23413, 23413),
         16#DF#           =>  --  0120DF
          (0, 0, 23414, 23414),
         16#E0#           =>  --  0120E0
          (0, 0, 23415, 23415),
         16#E1#           =>  --  0120E1
          (0, 0, 23416, 23416),
         16#E2#           =>  --  0120E2
          (0, 0, 23417, 23417),
         16#E3#           =>  --  0120E3
          (0, 0, 23418, 23418),
         16#E4#           =>  --  0120E4
          (0, 0, 23419, 23419),
         16#E5#           =>  --  0120E5
          (0, 0, 23420, 23420),
         16#E6#           =>  --  0120E6
          (0, 0, 23421, 23421),
         16#E7#           =>  --  0120E7
          (0, 0, 23422, 23422),
         16#E8#           =>  --  0120E8
          (0, 0, 23423, 23423),
         16#E9#           =>  --  0120E9
          (0, 0, 23424, 23424),
         16#EA#           =>  --  0120EA
          (0, 0, 23425, 23425),
         16#EB#           =>  --  0120EB
          (0, 0, 23426, 23426),
         16#EC#           =>  --  0120EC
          (0, 0, 23427, 23427),
         16#ED#           =>  --  0120ED
          (0, 0, 23428, 23428),
         16#EE#           =>  --  0120EE
          (0, 0, 23429, 23429),
         16#EF#           =>  --  0120EF
          (0, 0, 23430, 23430),
         16#F0#           =>  --  0120F0
          (0, 0, 23431, 23431),
         16#F1#           =>  --  0120F1
          (0, 0, 23432, 23432),
         16#F2#           =>  --  0120F2
          (0, 0, 23433, 23433),
         16#F3#           =>  --  0120F3
          (0, 0, 23434, 23434),
         16#F4#           =>  --  0120F4
          (0, 0, 23435, 23435),
         16#F5#           =>  --  0120F5
          (0, 0, 23436, 23436),
         16#F6#           =>  --  0120F6
          (0, 0, 23437, 23437),
         16#F7#           =>  --  0120F7
          (0, 0, 23438, 23438),
         16#F8#           =>  --  0120F8
          (0, 0, 23439, 23439),
         16#F9#           =>  --  0120F9
          (0, 0, 23440, 23440),
         16#FA#           =>  --  0120FA
          (0, 0, 23441, 23441),
         16#FB#           =>  --  0120FB
          (0, 0, 23442, 23442),
         16#FC#           =>  --  0120FC
          (0, 0, 23443, 23443),
         16#FD#           =>  --  0120FD
          (0, 0, 23444, 23444),
         16#FE#           =>  --  0120FE
          (0, 0, 23445, 23445),
         16#FF#           =>  --  0120FF
          (0, 0, 23446, 23446),
         others           =>
          (0, 0, 0, 0));

   Group_0121 : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  012100
          (0, 0, 23447, 23447),
         16#01#           =>  --  012101
          (0, 0, 23448, 23448),
         16#02#           =>  --  012102
          (0, 0, 23449, 23449),
         16#03#           =>  --  012103
          (0, 0, 23450, 23450),
         16#04#           =>  --  012104
          (0, 0, 23451, 23451),
         16#05#           =>  --  012105
          (0, 0, 23452, 23452),
         16#06#           =>  --  012106
          (0, 0, 23453, 23453),
         16#07#           =>  --  012107
          (0, 0, 23454, 23454),
         16#08#           =>  --  012108
          (0, 0, 23455, 23455),
         16#09#           =>  --  012109
          (0, 0, 23456, 23456),
         16#0A#           =>  --  01210A
          (0, 0, 23457, 23457),
         16#0B#           =>  --  01210B
          (0, 0, 23458, 23458),
         16#0C#           =>  --  01210C
          (0, 0, 23459, 23459),
         16#0D#           =>  --  01210D
          (0, 0, 23460, 23460),
         16#0E#           =>  --  01210E
          (0, 0, 23461, 23461),
         16#0F#           =>  --  01210F
          (0, 0, 23462, 23462),
         16#10#           =>  --  012110
          (0, 0, 23463, 23463),
         16#11#           =>  --  012111
          (0, 0, 23464, 23464),
         16#12#           =>  --  012112
          (0, 0, 23465, 23465),
         16#13#           =>  --  012113
          (0, 0, 23466, 23466),
         16#14#           =>  --  012114
          (0, 0, 23467, 23467),
         16#15#           =>  --  012115
          (0, 0, 23468, 23468),
         16#16#           =>  --  012116
          (0, 0, 23469, 23469),
         16#17#           =>  --  012117
          (0, 0, 23470, 23470),
         16#18#           =>  --  012118
          (0, 0, 23471, 23471),
         16#19#           =>  --  012119
          (0, 0, 23472, 23472),
         16#1A#           =>  --  01211A
          (0, 0, 23473, 23473),
         16#1B#           =>  --  01211B
          (0, 0, 23474, 23474),
         16#1C#           =>  --  01211C
          (0, 0, 23475, 23475),
         16#1D#           =>  --  01211D
          (0, 0, 23476, 23476),
         16#1E#           =>  --  01211E
          (0, 0, 23477, 23477),
         16#1F#           =>  --  01211F
          (0, 0, 23478, 23478),
         16#20#           =>  --  012120
          (0, 0, 23479, 23479),
         16#21#           =>  --  012121
          (0, 0, 23480, 23480),
         16#22#           =>  --  012122
          (0, 0, 23481, 23481),
         16#23#           =>  --  012123
          (0, 0, 23482, 23482),
         16#24#           =>  --  012124
          (0, 0, 23483, 23483),
         16#25#           =>  --  012125
          (0, 0, 23484, 23484),
         16#26#           =>  --  012126
          (0, 0, 23485, 23485),
         16#27#           =>  --  012127
          (0, 0, 23486, 23486),
         16#28#           =>  --  012128
          (0, 0, 23487, 23487),
         16#29#           =>  --  012129
          (0, 0, 23488, 23488),
         16#2A#           =>  --  01212A
          (0, 0, 23489, 23489),
         16#2B#           =>  --  01212B
          (0, 0, 23490, 23490),
         16#2C#           =>  --  01212C
          (0, 0, 23491, 23491),
         16#2D#           =>  --  01212D
          (0, 0, 23492, 23492),
         16#2E#           =>  --  01212E
          (0, 0, 23493, 23493),
         16#2F#           =>  --  01212F
          (0, 0, 23494, 23494),
         16#30#           =>  --  012130
          (0, 0, 23495, 23495),
         16#31#           =>  --  012131
          (0, 0, 23496, 23496),
         16#32#           =>  --  012132
          (0, 0, 23497, 23497),
         16#33#           =>  --  012133
          (0, 0, 23498, 23498),
         16#34#           =>  --  012134
          (0, 0, 23499, 23499),
         16#35#           =>  --  012135
          (0, 0, 23500, 23500),
         16#36#           =>  --  012136
          (0, 0, 23501, 23501),
         16#37#           =>  --  012137
          (0, 0, 23502, 23502),
         16#38#           =>  --  012138
          (0, 0, 23503, 23503),
         16#39#           =>  --  012139
          (0, 0, 23504, 23504),
         16#3A#           =>  --  01213A
          (0, 0, 23505, 23505),
         16#3B#           =>  --  01213B
          (0, 0, 23506, 23506),
         16#3C#           =>  --  01213C
          (0, 0, 23507, 23507),
         16#3D#           =>  --  01213D
          (0, 0, 23508, 23508),
         16#3E#           =>  --  01213E
          (0, 0, 23509, 23509),
         16#3F#           =>  --  01213F
          (0, 0, 23510, 23510),
         16#40#           =>  --  012140
          (0, 0, 23511, 23511),
         16#41#           =>  --  012141
          (0, 0, 23512, 23512),
         16#42#           =>  --  012142
          (0, 0, 23513, 23513),
         16#43#           =>  --  012143
          (0, 0, 23514, 23514),
         16#44#           =>  --  012144
          (0, 0, 23515, 23515),
         16#45#           =>  --  012145
          (0, 0, 23516, 23516),
         16#46#           =>  --  012146
          (0, 0, 23517, 23517),
         16#47#           =>  --  012147
          (0, 0, 23518, 23518),
         16#48#           =>  --  012148
          (0, 0, 23519, 23519),
         16#49#           =>  --  012149
          (0, 0, 23520, 23520),
         16#4A#           =>  --  01214A
          (0, 0, 23521, 23521),
         16#4B#           =>  --  01214B
          (0, 0, 23522, 23522),
         16#4C#           =>  --  01214C
          (0, 0, 23523, 23523),
         16#4D#           =>  --  01214D
          (0, 0, 23524, 23524),
         16#4E#           =>  --  01214E
          (0, 0, 23525, 23525),
         16#4F#           =>  --  01214F
          (0, 0, 23526, 23526),
         16#50#           =>  --  012150
          (0, 0, 23527, 23527),
         16#51#           =>  --  012151
          (0, 0, 23528, 23528),
         16#52#           =>  --  012152
          (0, 0, 23529, 23529),
         16#53#           =>  --  012153
          (0, 0, 23530, 23530),
         16#54#           =>  --  012154
          (0, 0, 23531, 23531),
         16#55#           =>  --  012155
          (0, 0, 23532, 23532),
         16#56#           =>  --  012156
          (0, 0, 23533, 23533),
         16#57#           =>  --  012157
          (0, 0, 23534, 23534),
         16#58#           =>  --  012158
          (0, 0, 23535, 23535),
         16#59#           =>  --  012159
          (0, 0, 23536, 23536),
         16#5A#           =>  --  01215A
          (0, 0, 23537, 23537),
         16#5B#           =>  --  01215B
          (0, 0, 23538, 23538),
         16#5C#           =>  --  01215C
          (0, 0, 23539, 23539),
         16#5D#           =>  --  01215D
          (0, 0, 23540, 23540),
         16#5E#           =>  --  01215E
          (0, 0, 23541, 23541),
         16#5F#           =>  --  01215F
          (0, 0, 23542, 23542),
         16#60#           =>  --  012160
          (0, 0, 23543, 23543),
         16#61#           =>  --  012161
          (0, 0, 23544, 23544),
         16#62#           =>  --  012162
          (0, 0, 23545, 23545),
         16#63#           =>  --  012163
          (0, 0, 23546, 23546),
         16#64#           =>  --  012164
          (0, 0, 23547, 23547),
         16#65#           =>  --  012165
          (0, 0, 23548, 23548),
         16#66#           =>  --  012166
          (0, 0, 23549, 23549),
         16#67#           =>  --  012167
          (0, 0, 23550, 23550),
         16#68#           =>  --  012168
          (0, 0, 23551, 23551),
         16#69#           =>  --  012169
          (0, 0, 23552, 23552),
         16#6A#           =>  --  01216A
          (0, 0, 23553, 23553),
         16#6B#           =>  --  01216B
          (0, 0, 23554, 23554),
         16#6C#           =>  --  01216C
          (0, 0, 23555, 23555),
         16#6D#           =>  --  01216D
          (0, 0, 23556, 23556),
         16#6E#           =>  --  01216E
          (0, 0, 23557, 23557),
         16#6F#           =>  --  01216F
          (0, 0, 23558, 23558),
         16#70#           =>  --  012170
          (0, 0, 23559, 23559),
         16#71#           =>  --  012171
          (0, 0, 23560, 23560),
         16#72#           =>  --  012172
          (0, 0, 23561, 23561),
         16#73#           =>  --  012173
          (0, 0, 23562, 23562),
         16#74#           =>  --  012174
          (0, 0, 23563, 23563),
         16#75#           =>  --  012175
          (0, 0, 23564, 23564),
         16#76#           =>  --  012176
          (0, 0, 23565, 23565),
         16#77#           =>  --  012177
          (0, 0, 23566, 23566),
         16#78#           =>  --  012178
          (0, 0, 23567, 23567),
         16#79#           =>  --  012179
          (0, 0, 23568, 23568),
         16#7A#           =>  --  01217A
          (0, 0, 23569, 23569),
         16#7B#           =>  --  01217B
          (0, 0, 23570, 23570),
         16#7C#           =>  --  01217C
          (0, 0, 23571, 23571),
         16#7D#           =>  --  01217D
          (0, 0, 23572, 23572),
         16#7E#           =>  --  01217E
          (0, 0, 23573, 23573),
         16#7F#           =>  --  01217F
          (0, 0, 23574, 23574),
         16#80#           =>  --  012180
          (0, 0, 23575, 23575),
         16#81#           =>  --  012181
          (0, 0, 23576, 23576),
         16#82#           =>  --  012182
          (0, 0, 23577, 23577),
         16#83#           =>  --  012183
          (0, 0, 23578, 23578),
         16#84#           =>  --  012184
          (0, 0, 23579, 23579),
         16#85#           =>  --  012185
          (0, 0, 23580, 23580),
         16#86#           =>  --  012186
          (0, 0, 23581, 23581),
         16#87#           =>  --  012187
          (0, 0, 23582, 23582),
         16#88#           =>  --  012188
          (0, 0, 23583, 23583),
         16#89#           =>  --  012189
          (0, 0, 23584, 23584),
         16#8A#           =>  --  01218A
          (0, 0, 23585, 23585),
         16#8B#           =>  --  01218B
          (0, 0, 23586, 23586),
         16#8C#           =>  --  01218C
          (0, 0, 23587, 23587),
         16#8D#           =>  --  01218D
          (0, 0, 23588, 23588),
         16#8E#           =>  --  01218E
          (0, 0, 23589, 23589),
         16#8F#           =>  --  01218F
          (0, 0, 23590, 23590),
         16#90#           =>  --  012190
          (0, 0, 23591, 23591),
         16#91#           =>  --  012191
          (0, 0, 23592, 23592),
         16#92#           =>  --  012192
          (0, 0, 23593, 23593),
         16#93#           =>  --  012193
          (0, 0, 23594, 23594),
         16#94#           =>  --  012194
          (0, 0, 23595, 23595),
         16#95#           =>  --  012195
          (0, 0, 23596, 23596),
         16#96#           =>  --  012196
          (0, 0, 23597, 23597),
         16#97#           =>  --  012197
          (0, 0, 23598, 23598),
         16#98#           =>  --  012198
          (0, 0, 23599, 23599),
         16#99#           =>  --  012199
          (0, 0, 23600, 23600),
         16#9A#           =>  --  01219A
          (0, 0, 23601, 23601),
         16#9B#           =>  --  01219B
          (0, 0, 23602, 23602),
         16#9C#           =>  --  01219C
          (0, 0, 23603, 23603),
         16#9D#           =>  --  01219D
          (0, 0, 23604, 23604),
         16#9E#           =>  --  01219E
          (0, 0, 23605, 23605),
         16#9F#           =>  --  01219F
          (0, 0, 23606, 23606),
         16#A0#           =>  --  0121A0
          (0, 0, 23607, 23607),
         16#A1#           =>  --  0121A1
          (0, 0, 23608, 23608),
         16#A2#           =>  --  0121A2
          (0, 0, 23609, 23609),
         16#A3#           =>  --  0121A3
          (0, 0, 23610, 23610),
         16#A4#           =>  --  0121A4
          (0, 0, 23611, 23611),
         16#A5#           =>  --  0121A5
          (0, 0, 23612, 23612),
         16#A6#           =>  --  0121A6
          (0, 0, 23613, 23613),
         16#A7#           =>  --  0121A7
          (0, 0, 23614, 23614),
         16#A8#           =>  --  0121A8
          (0, 0, 23615, 23615),
         16#A9#           =>  --  0121A9
          (0, 0, 23616, 23616),
         16#AA#           =>  --  0121AA
          (0, 0, 23617, 23617),
         16#AB#           =>  --  0121AB
          (0, 0, 23618, 23618),
         16#AC#           =>  --  0121AC
          (0, 0, 23619, 23619),
         16#AD#           =>  --  0121AD
          (0, 0, 23620, 23620),
         16#AE#           =>  --  0121AE
          (0, 0, 23621, 23621),
         16#AF#           =>  --  0121AF
          (0, 0, 23622, 23622),
         16#B0#           =>  --  0121B0
          (0, 0, 23623, 23623),
         16#B1#           =>  --  0121B1
          (0, 0, 23624, 23624),
         16#B2#           =>  --  0121B2
          (0, 0, 23625, 23625),
         16#B3#           =>  --  0121B3
          (0, 0, 23626, 23626),
         16#B4#           =>  --  0121B4
          (0, 0, 23627, 23627),
         16#B5#           =>  --  0121B5
          (0, 0, 23628, 23628),
         16#B6#           =>  --  0121B6
          (0, 0, 23629, 23629),
         16#B7#           =>  --  0121B7
          (0, 0, 23630, 23630),
         16#B8#           =>  --  0121B8
          (0, 0, 23631, 23631),
         16#B9#           =>  --  0121B9
          (0, 0, 23632, 23632),
         16#BA#           =>  --  0121BA
          (0, 0, 23633, 23633),
         16#BB#           =>  --  0121BB
          (0, 0, 23634, 23634),
         16#BC#           =>  --  0121BC
          (0, 0, 23635, 23635),
         16#BD#           =>  --  0121BD
          (0, 0, 23636, 23636),
         16#BE#           =>  --  0121BE
          (0, 0, 23637, 23637),
         16#BF#           =>  --  0121BF
          (0, 0, 23638, 23638),
         16#C0#           =>  --  0121C0
          (0, 0, 23639, 23639),
         16#C1#           =>  --  0121C1
          (0, 0, 23640, 23640),
         16#C2#           =>  --  0121C2
          (0, 0, 23641, 23641),
         16#C3#           =>  --  0121C3
          (0, 0, 23642, 23642),
         16#C4#           =>  --  0121C4
          (0, 0, 23643, 23643),
         16#C5#           =>  --  0121C5
          (0, 0, 23644, 23644),
         16#C6#           =>  --  0121C6
          (0, 0, 23645, 23645),
         16#C7#           =>  --  0121C7
          (0, 0, 23646, 23646),
         16#C8#           =>  --  0121C8
          (0, 0, 23647, 23647),
         16#C9#           =>  --  0121C9
          (0, 0, 23648, 23648),
         16#CA#           =>  --  0121CA
          (0, 0, 23649, 23649),
         16#CB#           =>  --  0121CB
          (0, 0, 23650, 23650),
         16#CC#           =>  --  0121CC
          (0, 0, 23651, 23651),
         16#CD#           =>  --  0121CD
          (0, 0, 23652, 23652),
         16#CE#           =>  --  0121CE
          (0, 0, 23653, 23653),
         16#CF#           =>  --  0121CF
          (0, 0, 23654, 23654),
         16#D0#           =>  --  0121D0
          (0, 0, 23655, 23655),
         16#D1#           =>  --  0121D1
          (0, 0, 23656, 23656),
         16#D2#           =>  --  0121D2
          (0, 0, 23657, 23657),
         16#D3#           =>  --  0121D3
          (0, 0, 23658, 23658),
         16#D4#           =>  --  0121D4
          (0, 0, 23659, 23659),
         16#D5#           =>  --  0121D5
          (0, 0, 23660, 23660),
         16#D6#           =>  --  0121D6
          (0, 0, 23661, 23661),
         16#D7#           =>  --  0121D7
          (0, 0, 23662, 23662),
         16#D8#           =>  --  0121D8
          (0, 0, 23663, 23663),
         16#D9#           =>  --  0121D9
          (0, 0, 23664, 23664),
         16#DA#           =>  --  0121DA
          (0, 0, 23665, 23665),
         16#DB#           =>  --  0121DB
          (0, 0, 23666, 23666),
         16#DC#           =>  --  0121DC
          (0, 0, 23667, 23667),
         16#DD#           =>  --  0121DD
          (0, 0, 23668, 23668),
         16#DE#           =>  --  0121DE
          (0, 0, 23669, 23669),
         16#DF#           =>  --  0121DF
          (0, 0, 23670, 23670),
         16#E0#           =>  --  0121E0
          (0, 0, 23671, 23671),
         16#E1#           =>  --  0121E1
          (0, 0, 23672, 23672),
         16#E2#           =>  --  0121E2
          (0, 0, 23673, 23673),
         16#E3#           =>  --  0121E3
          (0, 0, 23674, 23674),
         16#E4#           =>  --  0121E4
          (0, 0, 23675, 23675),
         16#E5#           =>  --  0121E5
          (0, 0, 23676, 23676),
         16#E6#           =>  --  0121E6
          (0, 0, 23677, 23677),
         16#E7#           =>  --  0121E7
          (0, 0, 23678, 23678),
         16#E8#           =>  --  0121E8
          (0, 0, 23679, 23679),
         16#E9#           =>  --  0121E9
          (0, 0, 23680, 23680),
         16#EA#           =>  --  0121EA
          (0, 0, 23681, 23681),
         16#EB#           =>  --  0121EB
          (0, 0, 23682, 23682),
         16#EC#           =>  --  0121EC
          (0, 0, 23683, 23683),
         16#ED#           =>  --  0121ED
          (0, 0, 23684, 23684),
         16#EE#           =>  --  0121EE
          (0, 0, 23685, 23685),
         16#EF#           =>  --  0121EF
          (0, 0, 23686, 23686),
         16#F0#           =>  --  0121F0
          (0, 0, 23687, 23687),
         16#F1#           =>  --  0121F1
          (0, 0, 23688, 23688),
         16#F2#           =>  --  0121F2
          (0, 0, 23689, 23689),
         16#F3#           =>  --  0121F3
          (0, 0, 23690, 23690),
         16#F4#           =>  --  0121F4
          (0, 0, 23691, 23691),
         16#F5#           =>  --  0121F5
          (0, 0, 23692, 23692),
         16#F6#           =>  --  0121F6
          (0, 0, 23693, 23693),
         16#F7#           =>  --  0121F7
          (0, 0, 23694, 23694),
         16#F8#           =>  --  0121F8
          (0, 0, 23695, 23695),
         16#F9#           =>  --  0121F9
          (0, 0, 23696, 23696),
         16#FA#           =>  --  0121FA
          (0, 0, 23697, 23697),
         16#FB#           =>  --  0121FB
          (0, 0, 23698, 23698),
         16#FC#           =>  --  0121FC
          (0, 0, 23699, 23699),
         16#FD#           =>  --  0121FD
          (0, 0, 23700, 23700),
         16#FE#           =>  --  0121FE
          (0, 0, 23701, 23701),
         16#FF#           =>  --  0121FF
          (0, 0, 23702, 23702),
         others           =>
          (0, 0, 0, 0));

   Group_0122 : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  012200
          (0, 0, 23703, 23703),
         16#01#           =>  --  012201
          (0, 0, 23704, 23704),
         16#02#           =>  --  012202
          (0, 0, 23705, 23705),
         16#03#           =>  --  012203
          (0, 0, 23706, 23706),
         16#04#           =>  --  012204
          (0, 0, 23707, 23707),
         16#05#           =>  --  012205
          (0, 0, 23708, 23708),
         16#06#           =>  --  012206
          (0, 0, 23709, 23709),
         16#07#           =>  --  012207
          (0, 0, 23710, 23710),
         16#08#           =>  --  012208
          (0, 0, 23711, 23711),
         16#09#           =>  --  012209
          (0, 0, 23712, 23712),
         16#0A#           =>  --  01220A
          (0, 0, 23713, 23713),
         16#0B#           =>  --  01220B
          (0, 0, 23714, 23714),
         16#0C#           =>  --  01220C
          (0, 0, 23715, 23715),
         16#0D#           =>  --  01220D
          (0, 0, 23716, 23716),
         16#0E#           =>  --  01220E
          (0, 0, 23717, 23717),
         16#0F#           =>  --  01220F
          (0, 0, 23718, 23718),
         16#10#           =>  --  012210
          (0, 0, 23719, 23719),
         16#11#           =>  --  012211
          (0, 0, 23720, 23720),
         16#12#           =>  --  012212
          (0, 0, 23721, 23721),
         16#13#           =>  --  012213
          (0, 0, 23722, 23722),
         16#14#           =>  --  012214
          (0, 0, 23723, 23723),
         16#15#           =>  --  012215
          (0, 0, 23724, 23724),
         16#16#           =>  --  012216
          (0, 0, 23725, 23725),
         16#17#           =>  --  012217
          (0, 0, 23726, 23726),
         16#18#           =>  --  012218
          (0, 0, 23727, 23727),
         16#19#           =>  --  012219
          (0, 0, 23728, 23728),
         16#1A#           =>  --  01221A
          (0, 0, 23729, 23729),
         16#1B#           =>  --  01221B
          (0, 0, 23730, 23730),
         16#1C#           =>  --  01221C
          (0, 0, 23731, 23731),
         16#1D#           =>  --  01221D
          (0, 0, 23732, 23732),
         16#1E#           =>  --  01221E
          (0, 0, 23733, 23733),
         16#1F#           =>  --  01221F
          (0, 0, 23734, 23734),
         16#20#           =>  --  012220
          (0, 0, 23735, 23735),
         16#21#           =>  --  012221
          (0, 0, 23736, 23736),
         16#22#           =>  --  012222
          (0, 0, 23737, 23737),
         16#23#           =>  --  012223
          (0, 0, 23738, 23738),
         16#24#           =>  --  012224
          (0, 0, 23739, 23739),
         16#25#           =>  --  012225
          (0, 0, 23740, 23740),
         16#26#           =>  --  012226
          (0, 0, 23741, 23741),
         16#27#           =>  --  012227
          (0, 0, 23742, 23742),
         16#28#           =>  --  012228
          (0, 0, 23743, 23743),
         16#29#           =>  --  012229
          (0, 0, 23744, 23744),
         16#2A#           =>  --  01222A
          (0, 0, 23745, 23745),
         16#2B#           =>  --  01222B
          (0, 0, 23746, 23746),
         16#2C#           =>  --  01222C
          (0, 0, 23747, 23747),
         16#2D#           =>  --  01222D
          (0, 0, 23748, 23748),
         16#2E#           =>  --  01222E
          (0, 0, 23749, 23749),
         16#2F#           =>  --  01222F
          (0, 0, 23750, 23750),
         16#30#           =>  --  012230
          (0, 0, 23751, 23751),
         16#31#           =>  --  012231
          (0, 0, 23752, 23752),
         16#32#           =>  --  012232
          (0, 0, 23753, 23753),
         16#33#           =>  --  012233
          (0, 0, 23754, 23754),
         16#34#           =>  --  012234
          (0, 0, 23755, 23755),
         16#35#           =>  --  012235
          (0, 0, 23756, 23756),
         16#36#           =>  --  012236
          (0, 0, 23757, 23757),
         16#37#           =>  --  012237
          (0, 0, 23758, 23758),
         16#38#           =>  --  012238
          (0, 0, 23759, 23759),
         16#39#           =>  --  012239
          (0, 0, 23760, 23760),
         16#3A#           =>  --  01223A
          (0, 0, 23761, 23761),
         16#3B#           =>  --  01223B
          (0, 0, 23762, 23762),
         16#3C#           =>  --  01223C
          (0, 0, 23763, 23763),
         16#3D#           =>  --  01223D
          (0, 0, 23764, 23764),
         16#3E#           =>  --  01223E
          (0, 0, 23765, 23765),
         16#3F#           =>  --  01223F
          (0, 0, 23766, 23766),
         16#40#           =>  --  012240
          (0, 0, 23767, 23767),
         16#41#           =>  --  012241
          (0, 0, 23768, 23768),
         16#42#           =>  --  012242
          (0, 0, 23769, 23769),
         16#43#           =>  --  012243
          (0, 0, 23770, 23770),
         16#44#           =>  --  012244
          (0, 0, 23771, 23771),
         16#45#           =>  --  012245
          (0, 0, 23772, 23772),
         16#46#           =>  --  012246
          (0, 0, 23773, 23773),
         16#47#           =>  --  012247
          (0, 0, 23774, 23774),
         16#48#           =>  --  012248
          (0, 0, 23775, 23775),
         16#49#           =>  --  012249
          (0, 0, 23776, 23776),
         16#4A#           =>  --  01224A
          (0, 0, 23777, 23777),
         16#4B#           =>  --  01224B
          (0, 0, 23778, 23778),
         16#4C#           =>  --  01224C
          (0, 0, 23779, 23779),
         16#4D#           =>  --  01224D
          (0, 0, 23780, 23780),
         16#4E#           =>  --  01224E
          (0, 0, 23781, 23781),
         16#4F#           =>  --  01224F
          (0, 0, 23782, 23782),
         16#50#           =>  --  012250
          (0, 0, 23783, 23783),
         16#51#           =>  --  012251
          (0, 0, 23784, 23784),
         16#52#           =>  --  012252
          (0, 0, 23785, 23785),
         16#53#           =>  --  012253
          (0, 0, 23786, 23786),
         16#54#           =>  --  012254
          (0, 0, 23787, 23787),
         16#55#           =>  --  012255
          (0, 0, 23788, 23788),
         16#56#           =>  --  012256
          (0, 0, 23789, 23789),
         16#57#           =>  --  012257
          (0, 0, 23790, 23790),
         16#58#           =>  --  012258
          (0, 0, 23791, 23791),
         16#59#           =>  --  012259
          (0, 0, 23792, 23792),
         16#5A#           =>  --  01225A
          (0, 0, 23793, 23793),
         16#5B#           =>  --  01225B
          (0, 0, 23794, 23794),
         16#5C#           =>  --  01225C
          (0, 0, 23795, 23795),
         16#5D#           =>  --  01225D
          (0, 0, 23796, 23796),
         16#5E#           =>  --  01225E
          (0, 0, 23797, 23797),
         16#5F#           =>  --  01225F
          (0, 0, 23798, 23798),
         16#60#           =>  --  012260
          (0, 0, 23799, 23799),
         16#61#           =>  --  012261
          (0, 0, 23800, 23800),
         16#62#           =>  --  012262
          (0, 0, 23801, 23801),
         16#63#           =>  --  012263
          (0, 0, 23802, 23802),
         16#64#           =>  --  012264
          (0, 0, 23803, 23803),
         16#65#           =>  --  012265
          (0, 0, 23804, 23804),
         16#66#           =>  --  012266
          (0, 0, 23805, 23805),
         16#67#           =>  --  012267
          (0, 0, 23806, 23806),
         16#68#           =>  --  012268
          (0, 0, 23807, 23807),
         16#69#           =>  --  012269
          (0, 0, 23808, 23808),
         16#6A#           =>  --  01226A
          (0, 0, 23809, 23809),
         16#6B#           =>  --  01226B
          (0, 0, 23810, 23810),
         16#6C#           =>  --  01226C
          (0, 0, 23811, 23811),
         16#6D#           =>  --  01226D
          (0, 0, 23812, 23812),
         16#6E#           =>  --  01226E
          (0, 0, 23813, 23813),
         16#6F#           =>  --  01226F
          (0, 0, 23814, 23814),
         16#70#           =>  --  012270
          (0, 0, 23815, 23815),
         16#71#           =>  --  012271
          (0, 0, 23816, 23816),
         16#72#           =>  --  012272
          (0, 0, 23817, 23817),
         16#73#           =>  --  012273
          (0, 0, 23818, 23818),
         16#74#           =>  --  012274
          (0, 0, 23819, 23819),
         16#75#           =>  --  012275
          (0, 0, 23820, 23820),
         16#76#           =>  --  012276
          (0, 0, 23821, 23821),
         16#77#           =>  --  012277
          (0, 0, 23822, 23822),
         16#78#           =>  --  012278
          (0, 0, 23823, 23823),
         16#79#           =>  --  012279
          (0, 0, 23824, 23824),
         16#7A#           =>  --  01227A
          (0, 0, 23825, 23825),
         16#7B#           =>  --  01227B
          (0, 0, 23826, 23826),
         16#7C#           =>  --  01227C
          (0, 0, 23827, 23827),
         16#7D#           =>  --  01227D
          (0, 0, 23828, 23828),
         16#7E#           =>  --  01227E
          (0, 0, 23829, 23829),
         16#7F#           =>  --  01227F
          (0, 0, 23830, 23830),
         16#80#           =>  --  012280
          (0, 0, 23831, 23831),
         16#81#           =>  --  012281
          (0, 0, 23832, 23832),
         16#82#           =>  --  012282
          (0, 0, 23833, 23833),
         16#83#           =>  --  012283
          (0, 0, 23834, 23834),
         16#84#           =>  --  012284
          (0, 0, 23835, 23835),
         16#85#           =>  --  012285
          (0, 0, 23836, 23836),
         16#86#           =>  --  012286
          (0, 0, 23837, 23837),
         16#87#           =>  --  012287
          (0, 0, 23838, 23838),
         16#88#           =>  --  012288
          (0, 0, 23839, 23839),
         16#89#           =>  --  012289
          (0, 0, 23840, 23840),
         16#8A#           =>  --  01228A
          (0, 0, 23841, 23841),
         16#8B#           =>  --  01228B
          (0, 0, 23842, 23842),
         16#8C#           =>  --  01228C
          (0, 0, 23843, 23843),
         16#8D#           =>  --  01228D
          (0, 0, 23844, 23844),
         16#8E#           =>  --  01228E
          (0, 0, 23845, 23845),
         16#8F#           =>  --  01228F
          (0, 0, 23846, 23846),
         16#90#           =>  --  012290
          (0, 0, 23847, 23847),
         16#91#           =>  --  012291
          (0, 0, 23848, 23848),
         16#92#           =>  --  012292
          (0, 0, 23849, 23849),
         16#93#           =>  --  012293
          (0, 0, 23850, 23850),
         16#94#           =>  --  012294
          (0, 0, 23851, 23851),
         16#95#           =>  --  012295
          (0, 0, 23852, 23852),
         16#96#           =>  --  012296
          (0, 0, 23853, 23853),
         16#97#           =>  --  012297
          (0, 0, 23854, 23854),
         16#98#           =>  --  012298
          (0, 0, 23855, 23855),
         16#99#           =>  --  012299
          (0, 0, 23856, 23856),
         16#9A#           =>  --  01229A
          (0, 0, 23857, 23857),
         16#9B#           =>  --  01229B
          (0, 0, 23858, 23858),
         16#9C#           =>  --  01229C
          (0, 0, 23859, 23859),
         16#9D#           =>  --  01229D
          (0, 0, 23860, 23860),
         16#9E#           =>  --  01229E
          (0, 0, 23861, 23861),
         16#9F#           =>  --  01229F
          (0, 0, 23862, 23862),
         16#A0#           =>  --  0122A0
          (0, 0, 23863, 23863),
         16#A1#           =>  --  0122A1
          (0, 0, 23864, 23864),
         16#A2#           =>  --  0122A2
          (0, 0, 23865, 23865),
         16#A3#           =>  --  0122A3
          (0, 0, 23866, 23866),
         16#A4#           =>  --  0122A4
          (0, 0, 23867, 23867),
         16#A5#           =>  --  0122A5
          (0, 0, 23868, 23868),
         16#A6#           =>  --  0122A6
          (0, 0, 23869, 23869),
         16#A7#           =>  --  0122A7
          (0, 0, 23870, 23870),
         16#A8#           =>  --  0122A8
          (0, 0, 23871, 23871),
         16#A9#           =>  --  0122A9
          (0, 0, 23872, 23872),
         16#AA#           =>  --  0122AA
          (0, 0, 23873, 23873),
         16#AB#           =>  --  0122AB
          (0, 0, 23874, 23874),
         16#AC#           =>  --  0122AC
          (0, 0, 23875, 23875),
         16#AD#           =>  --  0122AD
          (0, 0, 23876, 23876),
         16#AE#           =>  --  0122AE
          (0, 0, 23877, 23877),
         16#AF#           =>  --  0122AF
          (0, 0, 23878, 23878),
         16#B0#           =>  --  0122B0
          (0, 0, 23879, 23879),
         16#B1#           =>  --  0122B1
          (0, 0, 23880, 23880),
         16#B2#           =>  --  0122B2
          (0, 0, 23881, 23881),
         16#B3#           =>  --  0122B3
          (0, 0, 23882, 23882),
         16#B4#           =>  --  0122B4
          (0, 0, 23883, 23883),
         16#B5#           =>  --  0122B5
          (0, 0, 23884, 23884),
         16#B6#           =>  --  0122B6
          (0, 0, 23885, 23885),
         16#B7#           =>  --  0122B7
          (0, 0, 23886, 23886),
         16#B8#           =>  --  0122B8
          (0, 0, 23887, 23887),
         16#B9#           =>  --  0122B9
          (0, 0, 23888, 23888),
         16#BA#           =>  --  0122BA
          (0, 0, 23889, 23889),
         16#BB#           =>  --  0122BB
          (0, 0, 23890, 23890),
         16#BC#           =>  --  0122BC
          (0, 0, 23891, 23891),
         16#BD#           =>  --  0122BD
          (0, 0, 23892, 23892),
         16#BE#           =>  --  0122BE
          (0, 0, 23893, 23893),
         16#BF#           =>  --  0122BF
          (0, 0, 23894, 23894),
         16#C0#           =>  --  0122C0
          (0, 0, 23895, 23895),
         16#C1#           =>  --  0122C1
          (0, 0, 23896, 23896),
         16#C2#           =>  --  0122C2
          (0, 0, 23897, 23897),
         16#C3#           =>  --  0122C3
          (0, 0, 23898, 23898),
         16#C4#           =>  --  0122C4
          (0, 0, 23899, 23899),
         16#C5#           =>  --  0122C5
          (0, 0, 23900, 23900),
         16#C6#           =>  --  0122C6
          (0, 0, 23901, 23901),
         16#C7#           =>  --  0122C7
          (0, 0, 23902, 23902),
         16#C8#           =>  --  0122C8
          (0, 0, 23903, 23903),
         16#C9#           =>  --  0122C9
          (0, 0, 23904, 23904),
         16#CA#           =>  --  0122CA
          (0, 0, 23905, 23905),
         16#CB#           =>  --  0122CB
          (0, 0, 23906, 23906),
         16#CC#           =>  --  0122CC
          (0, 0, 23907, 23907),
         16#CD#           =>  --  0122CD
          (0, 0, 23908, 23908),
         16#CE#           =>  --  0122CE
          (0, 0, 23909, 23909),
         16#CF#           =>  --  0122CF
          (0, 0, 23910, 23910),
         16#D0#           =>  --  0122D0
          (0, 0, 23911, 23911),
         16#D1#           =>  --  0122D1
          (0, 0, 23912, 23912),
         16#D2#           =>  --  0122D2
          (0, 0, 23913, 23913),
         16#D3#           =>  --  0122D3
          (0, 0, 23914, 23914),
         16#D4#           =>  --  0122D4
          (0, 0, 23915, 23915),
         16#D5#           =>  --  0122D5
          (0, 0, 23916, 23916),
         16#D6#           =>  --  0122D6
          (0, 0, 23917, 23917),
         16#D7#           =>  --  0122D7
          (0, 0, 23918, 23918),
         16#D8#           =>  --  0122D8
          (0, 0, 23919, 23919),
         16#D9#           =>  --  0122D9
          (0, 0, 23920, 23920),
         16#DA#           =>  --  0122DA
          (0, 0, 23921, 23921),
         16#DB#           =>  --  0122DB
          (0, 0, 23922, 23922),
         16#DC#           =>  --  0122DC
          (0, 0, 23923, 23923),
         16#DD#           =>  --  0122DD
          (0, 0, 23924, 23924),
         16#DE#           =>  --  0122DE
          (0, 0, 23925, 23925),
         16#DF#           =>  --  0122DF
          (0, 0, 23926, 23926),
         16#E0#           =>  --  0122E0
          (0, 0, 23927, 23927),
         16#E1#           =>  --  0122E1
          (0, 0, 23928, 23928),
         16#E2#           =>  --  0122E2
          (0, 0, 23929, 23929),
         16#E3#           =>  --  0122E3
          (0, 0, 23930, 23930),
         16#E4#           =>  --  0122E4
          (0, 0, 23931, 23931),
         16#E5#           =>  --  0122E5
          (0, 0, 23932, 23932),
         16#E6#           =>  --  0122E6
          (0, 0, 23933, 23933),
         16#E7#           =>  --  0122E7
          (0, 0, 23934, 23934),
         16#E8#           =>  --  0122E8
          (0, 0, 23935, 23935),
         16#E9#           =>  --  0122E9
          (0, 0, 23936, 23936),
         16#EA#           =>  --  0122EA
          (0, 0, 23937, 23937),
         16#EB#           =>  --  0122EB
          (0, 0, 23938, 23938),
         16#EC#           =>  --  0122EC
          (0, 0, 23939, 23939),
         16#ED#           =>  --  0122ED
          (0, 0, 23940, 23940),
         16#EE#           =>  --  0122EE
          (0, 0, 23941, 23941),
         16#EF#           =>  --  0122EF
          (0, 0, 23942, 23942),
         16#F0#           =>  --  0122F0
          (0, 0, 23943, 23943),
         16#F1#           =>  --  0122F1
          (0, 0, 23944, 23944),
         16#F2#           =>  --  0122F2
          (0, 0, 23945, 23945),
         16#F3#           =>  --  0122F3
          (0, 0, 23946, 23946),
         16#F4#           =>  --  0122F4
          (0, 0, 23947, 23947),
         16#F5#           =>  --  0122F5
          (0, 0, 23948, 23948),
         16#F6#           =>  --  0122F6
          (0, 0, 23949, 23949),
         16#F7#           =>  --  0122F7
          (0, 0, 23950, 23950),
         16#F8#           =>  --  0122F8
          (0, 0, 23951, 23951),
         16#F9#           =>  --  0122F9
          (0, 0, 23952, 23952),
         16#FA#           =>  --  0122FA
          (0, 0, 23953, 23953),
         16#FB#           =>  --  0122FB
          (0, 0, 23954, 23954),
         16#FC#           =>  --  0122FC
          (0, 0, 23955, 23955),
         16#FD#           =>  --  0122FD
          (0, 0, 23956, 23956),
         16#FE#           =>  --  0122FE
          (0, 0, 23957, 23957),
         16#FF#           =>  --  0122FF
          (0, 0, 23958, 23958),
         others           =>
          (0, 0, 0, 0));

   Group_0123 : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  012300
          (0, 0, 23959, 23959),
         16#01#           =>  --  012301
          (0, 0, 23960, 23960),
         16#02#           =>  --  012302
          (0, 0, 23961, 23961),
         16#03#           =>  --  012303
          (0, 0, 23962, 23962),
         16#04#           =>  --  012304
          (0, 0, 23963, 23963),
         16#05#           =>  --  012305
          (0, 0, 23964, 23964),
         16#06#           =>  --  012306
          (0, 0, 23965, 23965),
         16#07#           =>  --  012307
          (0, 0, 23966, 23966),
         16#08#           =>  --  012308
          (0, 0, 23967, 23967),
         16#09#           =>  --  012309
          (0, 0, 23968, 23968),
         16#0A#           =>  --  01230A
          (0, 0, 23969, 23969),
         16#0B#           =>  --  01230B
          (0, 0, 23970, 23970),
         16#0C#           =>  --  01230C
          (0, 0, 23971, 23971),
         16#0D#           =>  --  01230D
          (0, 0, 23972, 23972),
         16#0E#           =>  --  01230E
          (0, 0, 23973, 23973),
         16#0F#           =>  --  01230F
          (0, 0, 23974, 23974),
         16#10#           =>  --  012310
          (0, 0, 23975, 23975),
         16#11#           =>  --  012311
          (0, 0, 23976, 23976),
         16#12#           =>  --  012312
          (0, 0, 23977, 23977),
         16#13#           =>  --  012313
          (0, 0, 23978, 23978),
         16#14#           =>  --  012314
          (0, 0, 23979, 23979),
         16#15#           =>  --  012315
          (0, 0, 23980, 23980),
         16#16#           =>  --  012316
          (0, 0, 23981, 23981),
         16#17#           =>  --  012317
          (0, 0, 23982, 23982),
         16#18#           =>  --  012318
          (0, 0, 23983, 23983),
         16#19#           =>  --  012319
          (0, 0, 23984, 23984),
         16#1A#           =>  --  01231A
          (0, 0, 23985, 23985),
         16#1B#           =>  --  01231B
          (0, 0, 23986, 23986),
         16#1C#           =>  --  01231C
          (0, 0, 23987, 23987),
         16#1D#           =>  --  01231D
          (0, 0, 23988, 23988),
         16#1E#           =>  --  01231E
          (0, 0, 23989, 23989),
         16#1F#           =>  --  01231F
          (0, 0, 23990, 23990),
         16#20#           =>  --  012320
          (0, 0, 23991, 23991),
         16#21#           =>  --  012321
          (0, 0, 23992, 23992),
         16#22#           =>  --  012322
          (0, 0, 23993, 23993),
         16#23#           =>  --  012323
          (0, 0, 23994, 23994),
         16#24#           =>  --  012324
          (0, 0, 23995, 23995),
         16#25#           =>  --  012325
          (0, 0, 23996, 23996),
         16#26#           =>  --  012326
          (0, 0, 23997, 23997),
         16#27#           =>  --  012327
          (0, 0, 23998, 23998),
         16#28#           =>  --  012328
          (0, 0, 23999, 23999),
         16#29#           =>  --  012329
          (0, 0, 24000, 24000),
         16#2A#           =>  --  01232A
          (0, 0, 24001, 24001),
         16#2B#           =>  --  01232B
          (0, 0, 24002, 24002),
         16#2C#           =>  --  01232C
          (0, 0, 24003, 24003),
         16#2D#           =>  --  01232D
          (0, 0, 24004, 24004),
         16#2E#           =>  --  01232E
          (0, 0, 24005, 24005),
         16#2F#           =>  --  01232F
          (0, 0, 24006, 24006),
         16#30#           =>  --  012330
          (0, 0, 24007, 24007),
         16#31#           =>  --  012331
          (0, 0, 24008, 24008),
         16#32#           =>  --  012332
          (0, 0, 24009, 24009),
         16#33#           =>  --  012333
          (0, 0, 24010, 24010),
         16#34#           =>  --  012334
          (0, 0, 24011, 24011),
         16#35#           =>  --  012335
          (0, 0, 24012, 24012),
         16#36#           =>  --  012336
          (0, 0, 24013, 24013),
         16#37#           =>  --  012337
          (0, 0, 24014, 24014),
         16#38#           =>  --  012338
          (0, 0, 24015, 24015),
         16#39#           =>  --  012339
          (0, 0, 24016, 24016),
         16#3A#           =>  --  01233A
          (0, 0, 24017, 24017),
         16#3B#           =>  --  01233B
          (0, 0, 24018, 24018),
         16#3C#           =>  --  01233C
          (0, 0, 24019, 24019),
         16#3D#           =>  --  01233D
          (0, 0, 24020, 24020),
         16#3E#           =>  --  01233E
          (0, 0, 24021, 24021),
         16#3F#           =>  --  01233F
          (0, 0, 24022, 24022),
         16#40#           =>  --  012340
          (0, 0, 24023, 24023),
         16#41#           =>  --  012341
          (0, 0, 24024, 24024),
         16#42#           =>  --  012342
          (0, 0, 24025, 24025),
         16#43#           =>  --  012343
          (0, 0, 24026, 24026),
         16#44#           =>  --  012344
          (0, 0, 24027, 24027),
         16#45#           =>  --  012345
          (0, 0, 24028, 24028),
         16#46#           =>  --  012346
          (0, 0, 24029, 24029),
         16#47#           =>  --  012347
          (0, 0, 24030, 24030),
         16#48#           =>  --  012348
          (0, 0, 24031, 24031),
         16#49#           =>  --  012349
          (0, 0, 24032, 24032),
         16#4A#           =>  --  01234A
          (0, 0, 24033, 24033),
         16#4B#           =>  --  01234B
          (0, 0, 24034, 24034),
         16#4C#           =>  --  01234C
          (0, 0, 24035, 24035),
         16#4D#           =>  --  01234D
          (0, 0, 24036, 24036),
         16#4E#           =>  --  01234E
          (0, 0, 24037, 24037),
         16#4F#           =>  --  01234F
          (0, 0, 24038, 24038),
         16#50#           =>  --  012350
          (0, 0, 24039, 24039),
         16#51#           =>  --  012351
          (0, 0, 24040, 24040),
         16#52#           =>  --  012352
          (0, 0, 24041, 24041),
         16#53#           =>  --  012353
          (0, 0, 24042, 24042),
         16#54#           =>  --  012354
          (0, 0, 24043, 24043),
         16#55#           =>  --  012355
          (0, 0, 24044, 24044),
         16#56#           =>  --  012356
          (0, 0, 24045, 24045),
         16#57#           =>  --  012357
          (0, 0, 24046, 24046),
         16#58#           =>  --  012358
          (0, 0, 24047, 24047),
         16#59#           =>  --  012359
          (0, 0, 24048, 24048),
         16#5A#           =>  --  01235A
          (0, 0, 24049, 24049),
         16#5B#           =>  --  01235B
          (0, 0, 24050, 24050),
         16#5C#           =>  --  01235C
          (0, 0, 24051, 24051),
         16#5D#           =>  --  01235D
          (0, 0, 24052, 24052),
         16#5E#           =>  --  01235E
          (0, 0, 24053, 24053),
         16#5F#           =>  --  01235F
          (0, 0, 24054, 24054),
         16#60#           =>  --  012360
          (0, 0, 24055, 24055),
         16#61#           =>  --  012361
          (0, 0, 24056, 24056),
         16#62#           =>  --  012362
          (0, 0, 24057, 24057),
         16#63#           =>  --  012363
          (0, 0, 24058, 24058),
         16#64#           =>  --  012364
          (0, 0, 24059, 24059),
         16#65#           =>  --  012365
          (0, 0, 24060, 24060),
         16#66#           =>  --  012366
          (0, 0, 24061, 24061),
         16#67#           =>  --  012367
          (0, 0, 24062, 24062),
         16#68#           =>  --  012368
          (0, 0, 24063, 24063),
         16#69#           =>  --  012369
          (0, 0, 24064, 24064),
         16#6A#           =>  --  01236A
          (0, 0, 24065, 24065),
         16#6B#           =>  --  01236B
          (0, 0, 24066, 24066),
         16#6C#           =>  --  01236C
          (0, 0, 24067, 24067),
         16#6D#           =>  --  01236D
          (0, 0, 24068, 24068),
         16#6E#           =>  --  01236E
          (0, 0, 24069, 24069),
         16#6F#           =>  --  01236F
          (0, 0, 24070, 24070),
         16#70#           =>  --  012370
          (0, 0, 24071, 24071),
         16#71#           =>  --  012371
          (0, 0, 24072, 24072),
         16#72#           =>  --  012372
          (0, 0, 24073, 24073),
         16#73#           =>  --  012373
          (0, 0, 24074, 24074),
         16#74#           =>  --  012374
          (0, 0, 24075, 24075),
         16#75#           =>  --  012375
          (0, 0, 24076, 24076),
         16#76#           =>  --  012376
          (0, 0, 24077, 24077),
         16#77#           =>  --  012377
          (0, 0, 24078, 24078),
         16#78#           =>  --  012378
          (0, 0, 24079, 24079),
         16#79#           =>  --  012379
          (0, 0, 24080, 24080),
         16#7A#           =>  --  01237A
          (0, 0, 24081, 24081),
         16#7B#           =>  --  01237B
          (0, 0, 24082, 24082),
         16#7C#           =>  --  01237C
          (0, 0, 24083, 24083),
         16#7D#           =>  --  01237D
          (0, 0, 24084, 24084),
         16#7E#           =>  --  01237E
          (0, 0, 24085, 24085),
         16#7F#           =>  --  01237F
          (0, 0, 24086, 24086),
         16#80#           =>  --  012380
          (0, 0, 24087, 24087),
         16#81#           =>  --  012381
          (0, 0, 24088, 24088),
         16#82#           =>  --  012382
          (0, 0, 24089, 24089),
         16#83#           =>  --  012383
          (0, 0, 24090, 24090),
         16#84#           =>  --  012384
          (0, 0, 24091, 24091),
         16#85#           =>  --  012385
          (0, 0, 24092, 24092),
         16#86#           =>  --  012386
          (0, 0, 24093, 24093),
         16#87#           =>  --  012387
          (0, 0, 24094, 24094),
         16#88#           =>  --  012388
          (0, 0, 24095, 24095),
         16#89#           =>  --  012389
          (0, 0, 24096, 24096),
         16#8A#           =>  --  01238A
          (0, 0, 24097, 24097),
         16#8B#           =>  --  01238B
          (0, 0, 24098, 24098),
         16#8C#           =>  --  01238C
          (0, 0, 24099, 24099),
         16#8D#           =>  --  01238D
          (0, 0, 24100, 24100),
         16#8E#           =>  --  01238E
          (0, 0, 24101, 24101),
         16#8F#           =>  --  01238F
          (0, 0, 24102, 24102),
         16#90#           =>  --  012390
          (0, 0, 24103, 24103),
         16#91#           =>  --  012391
          (0, 0, 24104, 24104),
         16#92#           =>  --  012392
          (0, 0, 24105, 24105),
         16#93#           =>  --  012393
          (0, 0, 24106, 24106),
         16#94#           =>  --  012394
          (0, 0, 24107, 24107),
         16#95#           =>  --  012395
          (0, 0, 24108, 24108),
         16#96#           =>  --  012396
          (0, 0, 24109, 24109),
         16#97#           =>  --  012397
          (0, 0, 24110, 24110),
         16#98#           =>  --  012398
          (0, 0, 24111, 24111),
         others           =>
          (0, 0, 0, 0));

   Group_0124 : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  012400
          (0, 0, 25, 25),
         16#01#           =>  --  012401
          (0, 0, 26, 26),
         16#02#           =>  --  012402
          (0, 0, 27, 27),
         16#03#           =>  --  012403
          (0, 0, 28, 28),
         16#04#           =>  --  012404
          (0, 0, 29, 29),
         16#05#           =>  --  012405
          (0, 0, 30, 30),
         16#06#           =>  --  012406
          (0, 0, 31, 31),
         16#07#           =>  --  012407
          (0, 0, 32, 32),
         16#08#           =>  --  012408
          (0, 0, 26, 26),
         16#09#           =>  --  012409
          (0, 0, 27, 27),
         16#0A#           =>  --  01240A
          (0, 0, 28, 28),
         16#0B#           =>  --  01240B
          (0, 0, 29, 29),
         16#0C#           =>  --  01240C
          (0, 0, 30, 30),
         16#0D#           =>  --  01240D
          (0, 0, 31, 31),
         16#0E#           =>  --  01240E
          (0, 0, 32, 32),
         16#0F#           =>  --  01240F
          (0, 0, 27, 27),
         16#10#           =>  --  012410
          (0, 0, 28, 28),
         16#11#           =>  --  012411
          (0, 0, 29, 29),
         16#12#           =>  --  012412
          (0, 0, 30, 30),
         16#13#           =>  --  012413
          (0, 0, 31, 31),
         16#14#           =>  --  012414
          (0, 0, 32, 32),
         16#15#           =>  --  012415
          (0, 0, 24, 24),
         16#16#           =>  --  012416
          (0, 0, 25, 25),
         16#17#           =>  --  012417
          (0, 0, 26, 26),
         16#18#           =>  --  012418
          (0, 0, 27, 27),
         16#19#           =>  --  012419
          (0, 0, 28, 28),
         16#1A#           =>  --  01241A
          (0, 0, 29, 29),
         16#1B#           =>  --  01241B
          (0, 0, 30, 30),
         16#1C#           =>  --  01241C
          (0, 0, 31, 31),
         16#1D#           =>  --  01241D
          (0, 0, 32, 32),
         16#1E#           =>  --  01241E
          (0, 0, 24, 24),
         16#1F#           =>  --  01241F
          (0, 0, 25, 25),
         16#20#           =>  --  012420
          (0, 0, 26, 26),
         16#21#           =>  --  012421
          (0, 0, 27, 27),
         16#22#           =>  --  012422
          (0, 0, 28, 28),
         16#23#           =>  --  012423
          (0, 0, 25, 25),
         16#24# .. 16#25# =>  --  012424 .. 012425
          (0, 0, 26, 26),
         16#26#           =>  --  012426
          (0, 0, 27, 27),
         16#27#           =>  --  012427
          (0, 0, 28, 28),
         16#28#           =>  --  012428
          (0, 0, 29, 29),
         16#29#           =>  --  012429
          (0, 0, 30, 30),
         16#2A#           =>  --  01242A
          (0, 0, 31, 31),
         16#2B#           =>  --  01242B
          (0, 0, 32, 32),
         16#2C#           =>  --  01242C
          (0, 0, 24, 24),
         16#2D#           =>  --  01242D
          (0, 0, 25, 25),
         16#2E# .. 16#2F# =>  --  01242E .. 01242F
          (0, 0, 26, 26),
         16#30#           =>  --  012430
          (0, 0, 27, 27),
         16#31#           =>  --  012431
          (0, 0, 28, 28),
         16#32#           =>  --  012432
          (0, 0, 24112, 24112),
         16#33#           =>  --  012433
          (0, 0, 24113, 24113),
         16#34#           =>  --  012434
          (0, 0, 24, 24),
         16#35#           =>  --  012435
          (0, 0, 25, 25),
         16#36# .. 16#37# =>  --  012436 .. 012437
          (0, 0, 26, 26),
         16#38#           =>  --  012438
          (0, 0, 27, 27),
         16#39#           =>  --  012439
          (0, 0, 28, 28),
         16#3A# .. 16#3B# =>  --  01243A .. 01243B
          (0, 0, 26, 26),
         16#3C# .. 16#3F# =>  --  01243C .. 01243F
          (0, 0, 27, 27),
         16#40#           =>  --  012440
          (0, 0, 29, 29),
         16#41# .. 16#43# =>  --  012441 .. 012443
          (0, 0, 30, 30),
         16#44# .. 16#45# =>  --  012444 .. 012445
          (0, 0, 31, 31),
         16#46# .. 16#49# =>  --  012446 .. 012449
          (0, 0, 32, 32),
         16#4A#           =>  --  01244A
          (0, 0, 25, 25),
         16#4B#           =>  --  01244B
          (0, 0, 26, 26),
         16#4C#           =>  --  01244C
          (0, 0, 27, 27),
         16#4D#           =>  --  01244D
          (0, 0, 28, 28),
         16#4E#           =>  --  01244E
          (0, 0, 29, 29),
         16#4F#           =>  --  01244F
          (0, 0, 24, 24),
         16#50#           =>  --  012450
          (0, 0, 25, 25),
         16#51#           =>  --  012451
          (0, 0, 26, 26),
         16#52# .. 16#53# =>  --  012452 .. 012453
          (0, 0, 27, 27),
         16#54# .. 16#55# =>  --  012454 .. 012455
          (0, 0, 28, 28),
         16#56#           =>  --  012456
          (0, 0, 25, 25),
         16#57#           =>  --  012457
          (0, 0, 26, 26),
         16#58#           =>  --  012458
          (0, 0, 24, 24),
         16#59#           =>  --  012459
          (0, 0, 25, 25),
         16#5A#           =>  --  01245A
          (0, 0, 24114, 24114),
         16#5B#           =>  --  01245B
          (0, 0, 24115, 24115),
         16#5C#           =>  --  01245C
          (0, 0, 24116, 24116),
         16#5D#           =>  --  01245D
          (0, 0, 24117, 24117),
         16#5E#           =>  --  01245E
          (0, 0, 24118, 24118),
         16#5F#           =>  --  01245F
          (0, 0, 24119, 24119),
         16#60#           =>  --  012460
          (0, 0, 24120, 24120),
         16#61#           =>  --  012461
          (0, 0, 24121, 24121),
         16#62#           =>  --  012462
          (0, 0, 24122, 24122),
         16#63#           =>  --  012463
          (0, 0, 24123, 24123),
         16#64#           =>  --  012464
          (0, 0, 24124, 24124),
         16#65#           =>  --  012465
          (0, 0, 24125, 24125),
         16#66#           =>  --  012466
          (0, 0, 24126, 24126),
         16#67#           =>  --  012467
          (0, 0, 24127, 24127),
         16#68#           =>  --  012468
          (0, 0, 24128, 24128),
         16#69#           =>  --  012469
          (0, 0, 27, 27),
         16#6A#           =>  --  01246A
          (0, 0, 28, 28),
         16#6B#           =>  --  01246B
          (0, 0, 29, 29),
         16#6C#           =>  --  01246C
          (0, 0, 30, 30),
         16#6D#           =>  --  01246D
          (0, 0, 31, 31),
         16#6E#           =>  --  01246E
          (0, 0, 32, 32),
         16#70#           =>  --  012470
          (0, 0, 24129, 24129),
         16#71#           =>  --  012471
          (0, 0, 24130, 24130),
         16#72#           =>  --  012472
          (0, 0, 24131, 24131),
         16#73#           =>  --  012473
          (0, 0, 24132, 24132),
         16#74#           =>  --  012474
          (0, 0, 24133, 24133),
         others           =>
          (0, 0, 0, 0));

   Group_0130 : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  013000
          (0, 0, 24134, 24134),
         16#01#           =>  --  013001
          (0, 0, 24135, 24135),
         16#02#           =>  --  013002
          (0, 0, 24136, 24136),
         16#03#           =>  --  013003
          (0, 0, 24137, 24137),
         16#04#           =>  --  013004
          (0, 0, 24138, 24138),
         16#05#           =>  --  013005
          (0, 0, 24139, 24139),
         16#06#           =>  --  013006
          (0, 0, 24140, 24140),
         16#07#           =>  --  013007
          (0, 0, 24141, 24141),
         16#08#           =>  --  013008
          (0, 0, 24142, 24142),
         16#09#           =>  --  013009
          (0, 0, 24143, 24143),
         16#0A#           =>  --  01300A
          (0, 0, 24144, 24144),
         16#0B#           =>  --  01300B
          (0, 0, 24145, 24145),
         16#0C#           =>  --  01300C
          (0, 0, 24146, 24146),
         16#0D#           =>  --  01300D
          (0, 0, 24147, 24147),
         16#0E#           =>  --  01300E
          (0, 0, 24148, 24148),
         16#0F#           =>  --  01300F
          (0, 0, 24149, 24149),
         16#10#           =>  --  013010
          (0, 0, 24150, 24150),
         16#11#           =>  --  013011
          (0, 0, 24151, 24151),
         16#12#           =>  --  013012
          (0, 0, 24152, 24152),
         16#13#           =>  --  013013
          (0, 0, 24153, 24153),
         16#14#           =>  --  013014
          (0, 0, 24154, 24154),
         16#15#           =>  --  013015
          (0, 0, 24155, 24155),
         16#16#           =>  --  013016
          (0, 0, 24156, 24156),
         16#17#           =>  --  013017
          (0, 0, 24157, 24157),
         16#18#           =>  --  013018
          (0, 0, 24158, 24158),
         16#19#           =>  --  013019
          (0, 0, 24159, 24159),
         16#1A#           =>  --  01301A
          (0, 0, 24160, 24160),
         16#1B#           =>  --  01301B
          (0, 0, 24161, 24161),
         16#1C#           =>  --  01301C
          (0, 0, 24162, 24162),
         16#1D#           =>  --  01301D
          (0, 0, 24163, 24163),
         16#1E#           =>  --  01301E
          (0, 0, 24164, 24164),
         16#1F#           =>  --  01301F
          (0, 0, 24165, 24165),
         16#20#           =>  --  013020
          (0, 0, 24166, 24166),
         16#21#           =>  --  013021
          (0, 0, 24167, 24167),
         16#22#           =>  --  013022
          (0, 0, 24168, 24168),
         16#23#           =>  --  013023
          (0, 0, 24169, 24169),
         16#24#           =>  --  013024
          (0, 0, 24170, 24170),
         16#25#           =>  --  013025
          (0, 0, 24171, 24171),
         16#26#           =>  --  013026
          (0, 0, 24172, 24172),
         16#27#           =>  --  013027
          (0, 0, 24173, 24173),
         16#28#           =>  --  013028
          (0, 0, 24174, 24174),
         16#29#           =>  --  013029
          (0, 0, 24175, 24175),
         16#2A#           =>  --  01302A
          (0, 0, 24176, 24176),
         16#2B#           =>  --  01302B
          (0, 0, 24177, 24177),
         16#2C#           =>  --  01302C
          (0, 0, 24178, 24178),
         16#2D#           =>  --  01302D
          (0, 0, 24179, 24179),
         16#2E#           =>  --  01302E
          (0, 0, 24180, 24180),
         16#2F#           =>  --  01302F
          (0, 0, 24181, 24181),
         16#30#           =>  --  013030
          (0, 0, 24182, 24182),
         16#31#           =>  --  013031
          (0, 0, 24183, 24183),
         16#32#           =>  --  013032
          (0, 0, 24184, 24184),
         16#33#           =>  --  013033
          (0, 0, 24185, 24185),
         16#34#           =>  --  013034
          (0, 0, 24186, 24186),
         16#35#           =>  --  013035
          (0, 0, 24187, 24187),
         16#36#           =>  --  013036
          (0, 0, 24188, 24188),
         16#37#           =>  --  013037
          (0, 0, 24189, 24189),
         16#38#           =>  --  013038
          (0, 0, 24190, 24190),
         16#39#           =>  --  013039
          (0, 0, 24191, 24191),
         16#3A#           =>  --  01303A
          (0, 0, 24192, 24192),
         16#3B#           =>  --  01303B
          (0, 0, 24193, 24193),
         16#3C#           =>  --  01303C
          (0, 0, 24194, 24194),
         16#3D#           =>  --  01303D
          (0, 0, 24195, 24195),
         16#3E#           =>  --  01303E
          (0, 0, 24196, 24196),
         16#3F#           =>  --  01303F
          (0, 0, 24197, 24197),
         16#40#           =>  --  013040
          (0, 0, 24198, 24198),
         16#41#           =>  --  013041
          (0, 0, 24199, 24199),
         16#42#           =>  --  013042
          (0, 0, 24200, 24200),
         16#43#           =>  --  013043
          (0, 0, 24201, 24201),
         16#44#           =>  --  013044
          (0, 0, 24202, 24202),
         16#45#           =>  --  013045
          (0, 0, 24203, 24203),
         16#46#           =>  --  013046
          (0, 0, 24204, 24204),
         16#47#           =>  --  013047
          (0, 0, 24205, 24205),
         16#48#           =>  --  013048
          (0, 0, 24206, 24206),
         16#49#           =>  --  013049
          (0, 0, 24207, 24207),
         16#4A#           =>  --  01304A
          (0, 0, 24208, 24208),
         16#4B#           =>  --  01304B
          (0, 0, 24209, 24209),
         16#4C#           =>  --  01304C
          (0, 0, 24210, 24210),
         16#4D#           =>  --  01304D
          (0, 0, 24211, 24211),
         16#4E#           =>  --  01304E
          (0, 0, 24212, 24212),
         16#4F#           =>  --  01304F
          (0, 0, 24213, 24213),
         16#50#           =>  --  013050
          (0, 0, 24214, 24214),
         16#51#           =>  --  013051
          (0, 0, 24215, 24215),
         16#52#           =>  --  013052
          (0, 0, 24216, 24216),
         16#53#           =>  --  013053
          (0, 0, 24217, 24217),
         16#54#           =>  --  013054
          (0, 0, 24218, 24218),
         16#55#           =>  --  013055
          (0, 0, 24219, 24219),
         16#56#           =>  --  013056
          (0, 0, 24220, 24220),
         16#57#           =>  --  013057
          (0, 0, 24221, 24221),
         16#58#           =>  --  013058
          (0, 0, 24222, 24222),
         16#59#           =>  --  013059
          (0, 0, 24223, 24223),
         16#5A#           =>  --  01305A
          (0, 0, 24224, 24224),
         16#5B#           =>  --  01305B
          (0, 0, 24225, 24225),
         16#5C#           =>  --  01305C
          (0, 0, 24226, 24226),
         16#5D#           =>  --  01305D
          (0, 0, 24227, 24227),
         16#5E#           =>  --  01305E
          (0, 0, 24228, 24228),
         16#5F#           =>  --  01305F
          (0, 0, 24229, 24229),
         16#60#           =>  --  013060
          (0, 0, 24230, 24230),
         16#61#           =>  --  013061
          (0, 0, 24231, 24231),
         16#62#           =>  --  013062
          (0, 0, 24232, 24232),
         16#63#           =>  --  013063
          (0, 0, 24233, 24233),
         16#64#           =>  --  013064
          (0, 0, 24234, 24234),
         16#65#           =>  --  013065
          (0, 0, 24235, 24235),
         16#66#           =>  --  013066
          (0, 0, 24236, 24236),
         16#67#           =>  --  013067
          (0, 0, 24237, 24237),
         16#68#           =>  --  013068
          (0, 0, 24238, 24238),
         16#69#           =>  --  013069
          (0, 0, 24239, 24239),
         16#6A#           =>  --  01306A
          (0, 0, 24240, 24240),
         16#6B#           =>  --  01306B
          (0, 0, 24241, 24241),
         16#6C#           =>  --  01306C
          (0, 0, 24242, 24242),
         16#6D#           =>  --  01306D
          (0, 0, 24243, 24243),
         16#6E#           =>  --  01306E
          (0, 0, 24244, 24244),
         16#6F#           =>  --  01306F
          (0, 0, 24245, 24245),
         16#70#           =>  --  013070
          (0, 0, 24246, 24246),
         16#71#           =>  --  013071
          (0, 0, 24247, 24247),
         16#72#           =>  --  013072
          (0, 0, 24248, 24248),
         16#73#           =>  --  013073
          (0, 0, 24249, 24249),
         16#74#           =>  --  013074
          (0, 0, 24250, 24250),
         16#75#           =>  --  013075
          (0, 0, 24251, 24251),
         16#76#           =>  --  013076
          (0, 0, 24252, 24252),
         16#77#           =>  --  013077
          (0, 0, 24253, 24253),
         16#78#           =>  --  013078
          (0, 0, 24254, 24254),
         16#79#           =>  --  013079
          (0, 0, 24255, 24255),
         16#7A#           =>  --  01307A
          (0, 0, 24256, 24256),
         16#7B#           =>  --  01307B
          (0, 0, 24257, 24257),
         16#7C#           =>  --  01307C
          (0, 0, 24258, 24258),
         16#7D#           =>  --  01307D
          (0, 0, 24259, 24259),
         16#7E#           =>  --  01307E
          (0, 0, 24260, 24260),
         16#7F#           =>  --  01307F
          (0, 0, 24261, 24261),
         16#80#           =>  --  013080
          (0, 0, 24262, 24262),
         16#81#           =>  --  013081
          (0, 0, 24263, 24263),
         16#82#           =>  --  013082
          (0, 0, 24264, 24264),
         16#83#           =>  --  013083
          (0, 0, 24265, 24265),
         16#84#           =>  --  013084
          (0, 0, 24266, 24266),
         16#85#           =>  --  013085
          (0, 0, 24267, 24267),
         16#86#           =>  --  013086
          (0, 0, 24268, 24268),
         16#87#           =>  --  013087
          (0, 0, 24269, 24269),
         16#88#           =>  --  013088
          (0, 0, 24270, 24270),
         16#89#           =>  --  013089
          (0, 0, 24271, 24271),
         16#8A#           =>  --  01308A
          (0, 0, 24272, 24272),
         16#8B#           =>  --  01308B
          (0, 0, 24273, 24273),
         16#8C#           =>  --  01308C
          (0, 0, 24274, 24274),
         16#8D#           =>  --  01308D
          (0, 0, 24275, 24275),
         16#8E#           =>  --  01308E
          (0, 0, 24276, 24276),
         16#8F#           =>  --  01308F
          (0, 0, 24277, 24277),
         16#90#           =>  --  013090
          (0, 0, 24278, 24278),
         16#91#           =>  --  013091
          (0, 0, 24279, 24279),
         16#92#           =>  --  013092
          (0, 0, 24280, 24280),
         16#93#           =>  --  013093
          (0, 0, 24281, 24281),
         16#94#           =>  --  013094
          (0, 0, 24282, 24282),
         16#95#           =>  --  013095
          (0, 0, 24283, 24283),
         16#96#           =>  --  013096
          (0, 0, 24284, 24284),
         16#97#           =>  --  013097
          (0, 0, 24285, 24285),
         16#98#           =>  --  013098
          (0, 0, 24286, 24286),
         16#99#           =>  --  013099
          (0, 0, 24287, 24287),
         16#9A#           =>  --  01309A
          (0, 0, 24288, 24288),
         16#9B#           =>  --  01309B
          (0, 0, 24289, 24289),
         16#9C#           =>  --  01309C
          (0, 0, 24290, 24290),
         16#9D#           =>  --  01309D
          (0, 0, 24291, 24291),
         16#9E#           =>  --  01309E
          (0, 0, 24292, 24292),
         16#9F#           =>  --  01309F
          (0, 0, 24293, 24293),
         16#A0#           =>  --  0130A0
          (0, 0, 24294, 24294),
         16#A1#           =>  --  0130A1
          (0, 0, 24295, 24295),
         16#A2#           =>  --  0130A2
          (0, 0, 24296, 24296),
         16#A3#           =>  --  0130A3
          (0, 0, 24297, 24297),
         16#A4#           =>  --  0130A4
          (0, 0, 24298, 24298),
         16#A5#           =>  --  0130A5
          (0, 0, 24299, 24299),
         16#A6#           =>  --  0130A6
          (0, 0, 24300, 24300),
         16#A7#           =>  --  0130A7
          (0, 0, 24301, 24301),
         16#A8#           =>  --  0130A8
          (0, 0, 24302, 24302),
         16#A9#           =>  --  0130A9
          (0, 0, 24303, 24303),
         16#AA#           =>  --  0130AA
          (0, 0, 24304, 24304),
         16#AB#           =>  --  0130AB
          (0, 0, 24305, 24305),
         16#AC#           =>  --  0130AC
          (0, 0, 24306, 24306),
         16#AD#           =>  --  0130AD
          (0, 0, 24307, 24307),
         16#AE#           =>  --  0130AE
          (0, 0, 24308, 24308),
         16#AF#           =>  --  0130AF
          (0, 0, 24309, 24309),
         16#B0#           =>  --  0130B0
          (0, 0, 24310, 24310),
         16#B1#           =>  --  0130B1
          (0, 0, 24311, 24311),
         16#B2#           =>  --  0130B2
          (0, 0, 24312, 24312),
         16#B3#           =>  --  0130B3
          (0, 0, 24313, 24313),
         16#B4#           =>  --  0130B4
          (0, 0, 24314, 24314),
         16#B5#           =>  --  0130B5
          (0, 0, 24315, 24315),
         16#B6#           =>  --  0130B6
          (0, 0, 24316, 24316),
         16#B7#           =>  --  0130B7
          (0, 0, 24317, 24317),
         16#B8#           =>  --  0130B8
          (0, 0, 24318, 24318),
         16#B9#           =>  --  0130B9
          (0, 0, 24319, 24319),
         16#BA#           =>  --  0130BA
          (0, 0, 24320, 24320),
         16#BB#           =>  --  0130BB
          (0, 0, 24321, 24321),
         16#BC#           =>  --  0130BC
          (0, 0, 24322, 24322),
         16#BD#           =>  --  0130BD
          (0, 0, 24323, 24323),
         16#BE#           =>  --  0130BE
          (0, 0, 24324, 24324),
         16#BF#           =>  --  0130BF
          (0, 0, 24325, 24325),
         16#C0#           =>  --  0130C0
          (0, 0, 24326, 24326),
         16#C1#           =>  --  0130C1
          (0, 0, 24327, 24327),
         16#C2#           =>  --  0130C2
          (0, 0, 24328, 24328),
         16#C3#           =>  --  0130C3
          (0, 0, 24329, 24329),
         16#C4#           =>  --  0130C4
          (0, 0, 24330, 24330),
         16#C5#           =>  --  0130C5
          (0, 0, 24331, 24331),
         16#C6#           =>  --  0130C6
          (0, 0, 24332, 24332),
         16#C7#           =>  --  0130C7
          (0, 0, 24333, 24333),
         16#C8#           =>  --  0130C8
          (0, 0, 24334, 24334),
         16#C9#           =>  --  0130C9
          (0, 0, 24335, 24335),
         16#CA#           =>  --  0130CA
          (0, 0, 24336, 24336),
         16#CB#           =>  --  0130CB
          (0, 0, 24337, 24337),
         16#CC#           =>  --  0130CC
          (0, 0, 24338, 24338),
         16#CD#           =>  --  0130CD
          (0, 0, 24339, 24339),
         16#CE#           =>  --  0130CE
          (0, 0, 24340, 24340),
         16#CF#           =>  --  0130CF
          (0, 0, 24341, 24341),
         16#D0#           =>  --  0130D0
          (0, 0, 24342, 24342),
         16#D1#           =>  --  0130D1
          (0, 0, 24343, 24343),
         16#D2#           =>  --  0130D2
          (0, 0, 24344, 24344),
         16#D3#           =>  --  0130D3
          (0, 0, 24345, 24345),
         16#D4#           =>  --  0130D4
          (0, 0, 24346, 24346),
         16#D5#           =>  --  0130D5
          (0, 0, 24347, 24347),
         16#D6#           =>  --  0130D6
          (0, 0, 24348, 24348),
         16#D7#           =>  --  0130D7
          (0, 0, 24349, 24349),
         16#D8#           =>  --  0130D8
          (0, 0, 24350, 24350),
         16#D9#           =>  --  0130D9
          (0, 0, 24351, 24351),
         16#DA#           =>  --  0130DA
          (0, 0, 24352, 24352),
         16#DB#           =>  --  0130DB
          (0, 0, 24353, 24353),
         16#DC#           =>  --  0130DC
          (0, 0, 24354, 24354),
         16#DD#           =>  --  0130DD
          (0, 0, 24355, 24355),
         16#DE#           =>  --  0130DE
          (0, 0, 24356, 24356),
         16#DF#           =>  --  0130DF
          (0, 0, 24357, 24357),
         16#E0#           =>  --  0130E0
          (0, 0, 24358, 24358),
         16#E1#           =>  --  0130E1
          (0, 0, 24359, 24359),
         16#E2#           =>  --  0130E2
          (0, 0, 24360, 24360),
         16#E3#           =>  --  0130E3
          (0, 0, 24361, 24361),
         16#E4#           =>  --  0130E4
          (0, 0, 24362, 24362),
         16#E5#           =>  --  0130E5
          (0, 0, 24363, 24363),
         16#E6#           =>  --  0130E6
          (0, 0, 24364, 24364),
         16#E7#           =>  --  0130E7
          (0, 0, 24365, 24365),
         16#E8#           =>  --  0130E8
          (0, 0, 24366, 24366),
         16#E9#           =>  --  0130E9
          (0, 0, 24367, 24367),
         16#EA#           =>  --  0130EA
          (0, 0, 24368, 24368),
         16#EB#           =>  --  0130EB
          (0, 0, 24369, 24369),
         16#EC#           =>  --  0130EC
          (0, 0, 24370, 24370),
         16#ED#           =>  --  0130ED
          (0, 0, 24371, 24371),
         16#EE#           =>  --  0130EE
          (0, 0, 24372, 24372),
         16#EF#           =>  --  0130EF
          (0, 0, 24373, 24373),
         16#F0#           =>  --  0130F0
          (0, 0, 24374, 24374),
         16#F1#           =>  --  0130F1
          (0, 0, 24375, 24375),
         16#F2#           =>  --  0130F2
          (0, 0, 24376, 24376),
         16#F3#           =>  --  0130F3
          (0, 0, 24377, 24377),
         16#F4#           =>  --  0130F4
          (0, 0, 24378, 24378),
         16#F5#           =>  --  0130F5
          (0, 0, 24379, 24379),
         16#F6#           =>  --  0130F6
          (0, 0, 24380, 24380),
         16#F7#           =>  --  0130F7
          (0, 0, 24381, 24381),
         16#F8#           =>  --  0130F8
          (0, 0, 24382, 24382),
         16#F9#           =>  --  0130F9
          (0, 0, 24383, 24383),
         16#FA#           =>  --  0130FA
          (0, 0, 24384, 24384),
         16#FB#           =>  --  0130FB
          (0, 0, 24385, 24385),
         16#FC#           =>  --  0130FC
          (0, 0, 24386, 24386),
         16#FD#           =>  --  0130FD
          (0, 0, 24387, 24387),
         16#FE#           =>  --  0130FE
          (0, 0, 24388, 24388),
         16#FF#           =>  --  0130FF
          (0, 0, 24389, 24389),
         others           =>
          (0, 0, 0, 0));

   Group_0131 : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  013100
          (0, 0, 24390, 24390),
         16#01#           =>  --  013101
          (0, 0, 24391, 24391),
         16#02#           =>  --  013102
          (0, 0, 24392, 24392),
         16#03#           =>  --  013103
          (0, 0, 24393, 24393),
         16#04#           =>  --  013104
          (0, 0, 24394, 24394),
         16#05#           =>  --  013105
          (0, 0, 24395, 24395),
         16#06#           =>  --  013106
          (0, 0, 24396, 24396),
         16#07#           =>  --  013107
          (0, 0, 24397, 24397),
         16#08#           =>  --  013108
          (0, 0, 24398, 24398),
         16#09#           =>  --  013109
          (0, 0, 24399, 24399),
         16#0A#           =>  --  01310A
          (0, 0, 24400, 24400),
         16#0B#           =>  --  01310B
          (0, 0, 24401, 24401),
         16#0C#           =>  --  01310C
          (0, 0, 24402, 24402),
         16#0D#           =>  --  01310D
          (0, 0, 24403, 24403),
         16#0E#           =>  --  01310E
          (0, 0, 24404, 24404),
         16#0F#           =>  --  01310F
          (0, 0, 24405, 24405),
         16#10#           =>  --  013110
          (0, 0, 24406, 24406),
         16#11#           =>  --  013111
          (0, 0, 24407, 24407),
         16#12#           =>  --  013112
          (0, 0, 24408, 24408),
         16#13#           =>  --  013113
          (0, 0, 24409, 24409),
         16#14#           =>  --  013114
          (0, 0, 24410, 24410),
         16#15#           =>  --  013115
          (0, 0, 24411, 24411),
         16#16#           =>  --  013116
          (0, 0, 24412, 24412),
         16#17#           =>  --  013117
          (0, 0, 24413, 24413),
         16#18#           =>  --  013118
          (0, 0, 24414, 24414),
         16#19#           =>  --  013119
          (0, 0, 24415, 24415),
         16#1A#           =>  --  01311A
          (0, 0, 24416, 24416),
         16#1B#           =>  --  01311B
          (0, 0, 24417, 24417),
         16#1C#           =>  --  01311C
          (0, 0, 24418, 24418),
         16#1D#           =>  --  01311D
          (0, 0, 24419, 24419),
         16#1E#           =>  --  01311E
          (0, 0, 24420, 24420),
         16#1F#           =>  --  01311F
          (0, 0, 24421, 24421),
         16#20#           =>  --  013120
          (0, 0, 24422, 24422),
         16#21#           =>  --  013121
          (0, 0, 24423, 24423),
         16#22#           =>  --  013122
          (0, 0, 24424, 24424),
         16#23#           =>  --  013123
          (0, 0, 24425, 24425),
         16#24#           =>  --  013124
          (0, 0, 24426, 24426),
         16#25#           =>  --  013125
          (0, 0, 24427, 24427),
         16#26#           =>  --  013126
          (0, 0, 24428, 24428),
         16#27#           =>  --  013127
          (0, 0, 24429, 24429),
         16#28#           =>  --  013128
          (0, 0, 24430, 24430),
         16#29#           =>  --  013129
          (0, 0, 24431, 24431),
         16#2A#           =>  --  01312A
          (0, 0, 24432, 24432),
         16#2B#           =>  --  01312B
          (0, 0, 24433, 24433),
         16#2C#           =>  --  01312C
          (0, 0, 24434, 24434),
         16#2D#           =>  --  01312D
          (0, 0, 24435, 24435),
         16#2E#           =>  --  01312E
          (0, 0, 24436, 24436),
         16#2F#           =>  --  01312F
          (0, 0, 24437, 24437),
         16#30#           =>  --  013130
          (0, 0, 24438, 24438),
         16#31#           =>  --  013131
          (0, 0, 24439, 24439),
         16#32#           =>  --  013132
          (0, 0, 24440, 24440),
         16#33#           =>  --  013133
          (0, 0, 24441, 24441),
         16#34#           =>  --  013134
          (0, 0, 24442, 24442),
         16#35#           =>  --  013135
          (0, 0, 24443, 24443),
         16#36#           =>  --  013136
          (0, 0, 24444, 24444),
         16#37#           =>  --  013137
          (0, 0, 24445, 24445),
         16#38#           =>  --  013138
          (0, 0, 24446, 24446),
         16#39#           =>  --  013139
          (0, 0, 24447, 24447),
         16#3A#           =>  --  01313A
          (0, 0, 24448, 24448),
         16#3B#           =>  --  01313B
          (0, 0, 24449, 24449),
         16#3C#           =>  --  01313C
          (0, 0, 24450, 24450),
         16#3D#           =>  --  01313D
          (0, 0, 24451, 24451),
         16#3E#           =>  --  01313E
          (0, 0, 24452, 24452),
         16#3F#           =>  --  01313F
          (0, 0, 24453, 24453),
         16#40#           =>  --  013140
          (0, 0, 24454, 24454),
         16#41#           =>  --  013141
          (0, 0, 24455, 24455),
         16#42#           =>  --  013142
          (0, 0, 24456, 24456),
         16#43#           =>  --  013143
          (0, 0, 24457, 24457),
         16#44#           =>  --  013144
          (0, 0, 24458, 24458),
         16#45#           =>  --  013145
          (0, 0, 24459, 24459),
         16#46#           =>  --  013146
          (0, 0, 24460, 24460),
         16#47#           =>  --  013147
          (0, 0, 24461, 24461),
         16#48#           =>  --  013148
          (0, 0, 24462, 24462),
         16#49#           =>  --  013149
          (0, 0, 24463, 24463),
         16#4A#           =>  --  01314A
          (0, 0, 24464, 24464),
         16#4B#           =>  --  01314B
          (0, 0, 24465, 24465),
         16#4C#           =>  --  01314C
          (0, 0, 24466, 24466),
         16#4D#           =>  --  01314D
          (0, 0, 24467, 24467),
         16#4E#           =>  --  01314E
          (0, 0, 24468, 24468),
         16#4F#           =>  --  01314F
          (0, 0, 24469, 24469),
         16#50#           =>  --  013150
          (0, 0, 24470, 24470),
         16#51#           =>  --  013151
          (0, 0, 24471, 24471),
         16#52#           =>  --  013152
          (0, 0, 24472, 24472),
         16#53#           =>  --  013153
          (0, 0, 24473, 24473),
         16#54#           =>  --  013154
          (0, 0, 24474, 24474),
         16#55#           =>  --  013155
          (0, 0, 24475, 24475),
         16#56#           =>  --  013156
          (0, 0, 24476, 24476),
         16#57#           =>  --  013157
          (0, 0, 24477, 24477),
         16#58#           =>  --  013158
          (0, 0, 24478, 24478),
         16#59#           =>  --  013159
          (0, 0, 24479, 24479),
         16#5A#           =>  --  01315A
          (0, 0, 24480, 24480),
         16#5B#           =>  --  01315B
          (0, 0, 24481, 24481),
         16#5C#           =>  --  01315C
          (0, 0, 24482, 24482),
         16#5D#           =>  --  01315D
          (0, 0, 24483, 24483),
         16#5E#           =>  --  01315E
          (0, 0, 24484, 24484),
         16#5F#           =>  --  01315F
          (0, 0, 24485, 24485),
         16#60#           =>  --  013160
          (0, 0, 24486, 24486),
         16#61#           =>  --  013161
          (0, 0, 24487, 24487),
         16#62#           =>  --  013162
          (0, 0, 24488, 24488),
         16#63#           =>  --  013163
          (0, 0, 24489, 24489),
         16#64#           =>  --  013164
          (0, 0, 24490, 24490),
         16#65#           =>  --  013165
          (0, 0, 24491, 24491),
         16#66#           =>  --  013166
          (0, 0, 24492, 24492),
         16#67#           =>  --  013167
          (0, 0, 24493, 24493),
         16#68#           =>  --  013168
          (0, 0, 24494, 24494),
         16#69#           =>  --  013169
          (0, 0, 24495, 24495),
         16#6A#           =>  --  01316A
          (0, 0, 24496, 24496),
         16#6B#           =>  --  01316B
          (0, 0, 24497, 24497),
         16#6C#           =>  --  01316C
          (0, 0, 24498, 24498),
         16#6D#           =>  --  01316D
          (0, 0, 24499, 24499),
         16#6E#           =>  --  01316E
          (0, 0, 24500, 24500),
         16#6F#           =>  --  01316F
          (0, 0, 24501, 24501),
         16#70#           =>  --  013170
          (0, 0, 24502, 24502),
         16#71#           =>  --  013171
          (0, 0, 24503, 24503),
         16#72#           =>  --  013172
          (0, 0, 24504, 24504),
         16#73#           =>  --  013173
          (0, 0, 24505, 24505),
         16#74#           =>  --  013174
          (0, 0, 24506, 24506),
         16#75#           =>  --  013175
          (0, 0, 24507, 24507),
         16#76#           =>  --  013176
          (0, 0, 24508, 24508),
         16#77#           =>  --  013177
          (0, 0, 24509, 24509),
         16#78#           =>  --  013178
          (0, 0, 24510, 24510),
         16#79#           =>  --  013179
          (0, 0, 24511, 24511),
         16#7A#           =>  --  01317A
          (0, 0, 24512, 24512),
         16#7B#           =>  --  01317B
          (0, 0, 24513, 24513),
         16#7C#           =>  --  01317C
          (0, 0, 24514, 24514),
         16#7D#           =>  --  01317D
          (0, 0, 24515, 24515),
         16#7E#           =>  --  01317E
          (0, 0, 24516, 24516),
         16#7F#           =>  --  01317F
          (0, 0, 24517, 24517),
         16#80#           =>  --  013180
          (0, 0, 24518, 24518),
         16#81#           =>  --  013181
          (0, 0, 24519, 24519),
         16#82#           =>  --  013182
          (0, 0, 24520, 24520),
         16#83#           =>  --  013183
          (0, 0, 24521, 24521),
         16#84#           =>  --  013184
          (0, 0, 24522, 24522),
         16#85#           =>  --  013185
          (0, 0, 24523, 24523),
         16#86#           =>  --  013186
          (0, 0, 24524, 24524),
         16#87#           =>  --  013187
          (0, 0, 24525, 24525),
         16#88#           =>  --  013188
          (0, 0, 24526, 24526),
         16#89#           =>  --  013189
          (0, 0, 24527, 24527),
         16#8A#           =>  --  01318A
          (0, 0, 24528, 24528),
         16#8B#           =>  --  01318B
          (0, 0, 24529, 24529),
         16#8C#           =>  --  01318C
          (0, 0, 24530, 24530),
         16#8D#           =>  --  01318D
          (0, 0, 24531, 24531),
         16#8E#           =>  --  01318E
          (0, 0, 24532, 24532),
         16#8F#           =>  --  01318F
          (0, 0, 24533, 24533),
         16#90#           =>  --  013190
          (0, 0, 24534, 24534),
         16#91#           =>  --  013191
          (0, 0, 24535, 24535),
         16#92#           =>  --  013192
          (0, 0, 24536, 24536),
         16#93#           =>  --  013193
          (0, 0, 24537, 24537),
         16#94#           =>  --  013194
          (0, 0, 24538, 24538),
         16#95#           =>  --  013195
          (0, 0, 24539, 24539),
         16#96#           =>  --  013196
          (0, 0, 24540, 24540),
         16#97#           =>  --  013197
          (0, 0, 24541, 24541),
         16#98#           =>  --  013198
          (0, 0, 24542, 24542),
         16#99#           =>  --  013199
          (0, 0, 24543, 24543),
         16#9A#           =>  --  01319A
          (0, 0, 24544, 24544),
         16#9B#           =>  --  01319B
          (0, 0, 24545, 24545),
         16#9C#           =>  --  01319C
          (0, 0, 24546, 24546),
         16#9D#           =>  --  01319D
          (0, 0, 24547, 24547),
         16#9E#           =>  --  01319E
          (0, 0, 24548, 24548),
         16#9F#           =>  --  01319F
          (0, 0, 24549, 24549),
         16#A0#           =>  --  0131A0
          (0, 0, 24550, 24550),
         16#A1#           =>  --  0131A1
          (0, 0, 24551, 24551),
         16#A2#           =>  --  0131A2
          (0, 0, 24552, 24552),
         16#A3#           =>  --  0131A3
          (0, 0, 24553, 24553),
         16#A4#           =>  --  0131A4
          (0, 0, 24554, 24554),
         16#A5#           =>  --  0131A5
          (0, 0, 24555, 24555),
         16#A6#           =>  --  0131A6
          (0, 0, 24556, 24556),
         16#A7#           =>  --  0131A7
          (0, 0, 24557, 24557),
         16#A8#           =>  --  0131A8
          (0, 0, 24558, 24558),
         16#A9#           =>  --  0131A9
          (0, 0, 24559, 24559),
         16#AA#           =>  --  0131AA
          (0, 0, 24560, 24560),
         16#AB#           =>  --  0131AB
          (0, 0, 24561, 24561),
         16#AC#           =>  --  0131AC
          (0, 0, 24562, 24562),
         16#AD#           =>  --  0131AD
          (0, 0, 24563, 24563),
         16#AE#           =>  --  0131AE
          (0, 0, 24564, 24564),
         16#AF#           =>  --  0131AF
          (0, 0, 24565, 24565),
         16#B0#           =>  --  0131B0
          (0, 0, 24566, 24566),
         16#B1#           =>  --  0131B1
          (0, 0, 24567, 24567),
         16#B2#           =>  --  0131B2
          (0, 0, 24568, 24568),
         16#B3#           =>  --  0131B3
          (0, 0, 24569, 24569),
         16#B4#           =>  --  0131B4
          (0, 0, 24570, 24570),
         16#B5#           =>  --  0131B5
          (0, 0, 24571, 24571),
         16#B6#           =>  --  0131B6
          (0, 0, 24572, 24572),
         16#B7#           =>  --  0131B7
          (0, 0, 24573, 24573),
         16#B8#           =>  --  0131B8
          (0, 0, 24574, 24574),
         16#B9#           =>  --  0131B9
          (0, 0, 24575, 24575),
         16#BA#           =>  --  0131BA
          (0, 0, 24576, 24576),
         16#BB#           =>  --  0131BB
          (0, 0, 24577, 24577),
         16#BC#           =>  --  0131BC
          (0, 0, 24578, 24578),
         16#BD#           =>  --  0131BD
          (0, 0, 24579, 24579),
         16#BE#           =>  --  0131BE
          (0, 0, 24580, 24580),
         16#BF#           =>  --  0131BF
          (0, 0, 24581, 24581),
         16#C0#           =>  --  0131C0
          (0, 0, 24582, 24582),
         16#C1#           =>  --  0131C1
          (0, 0, 24583, 24583),
         16#C2#           =>  --  0131C2
          (0, 0, 24584, 24584),
         16#C3#           =>  --  0131C3
          (0, 0, 24585, 24585),
         16#C4#           =>  --  0131C4
          (0, 0, 24586, 24586),
         16#C5#           =>  --  0131C5
          (0, 0, 24587, 24587),
         16#C6#           =>  --  0131C6
          (0, 0, 24588, 24588),
         16#C7#           =>  --  0131C7
          (0, 0, 24589, 24589),
         16#C8#           =>  --  0131C8
          (0, 0, 24590, 24590),
         16#C9#           =>  --  0131C9
          (0, 0, 24591, 24591),
         16#CA#           =>  --  0131CA
          (0, 0, 24592, 24592),
         16#CB#           =>  --  0131CB
          (0, 0, 24593, 24593),
         16#CC#           =>  --  0131CC
          (0, 0, 24594, 24594),
         16#CD#           =>  --  0131CD
          (0, 0, 24595, 24595),
         16#CE#           =>  --  0131CE
          (0, 0, 24596, 24596),
         16#CF#           =>  --  0131CF
          (0, 0, 24597, 24597),
         16#D0#           =>  --  0131D0
          (0, 0, 24598, 24598),
         16#D1#           =>  --  0131D1
          (0, 0, 24599, 24599),
         16#D2#           =>  --  0131D2
          (0, 0, 24600, 24600),
         16#D3#           =>  --  0131D3
          (0, 0, 24601, 24601),
         16#D4#           =>  --  0131D4
          (0, 0, 24602, 24602),
         16#D5#           =>  --  0131D5
          (0, 0, 24603, 24603),
         16#D6#           =>  --  0131D6
          (0, 0, 24604, 24604),
         16#D7#           =>  --  0131D7
          (0, 0, 24605, 24605),
         16#D8#           =>  --  0131D8
          (0, 0, 24606, 24606),
         16#D9#           =>  --  0131D9
          (0, 0, 24607, 24607),
         16#DA#           =>  --  0131DA
          (0, 0, 24608, 24608),
         16#DB#           =>  --  0131DB
          (0, 0, 24609, 24609),
         16#DC#           =>  --  0131DC
          (0, 0, 24610, 24610),
         16#DD#           =>  --  0131DD
          (0, 0, 24611, 24611),
         16#DE#           =>  --  0131DE
          (0, 0, 24612, 24612),
         16#DF#           =>  --  0131DF
          (0, 0, 24613, 24613),
         16#E0#           =>  --  0131E0
          (0, 0, 24614, 24614),
         16#E1#           =>  --  0131E1
          (0, 0, 24615, 24615),
         16#E2#           =>  --  0131E2
          (0, 0, 24616, 24616),
         16#E3#           =>  --  0131E3
          (0, 0, 24617, 24617),
         16#E4#           =>  --  0131E4
          (0, 0, 24618, 24618),
         16#E5#           =>  --  0131E5
          (0, 0, 24619, 24619),
         16#E6#           =>  --  0131E6
          (0, 0, 24620, 24620),
         16#E7#           =>  --  0131E7
          (0, 0, 24621, 24621),
         16#E8#           =>  --  0131E8
          (0, 0, 24622, 24622),
         16#E9#           =>  --  0131E9
          (0, 0, 24623, 24623),
         16#EA#           =>  --  0131EA
          (0, 0, 24624, 24624),
         16#EB#           =>  --  0131EB
          (0, 0, 24625, 24625),
         16#EC#           =>  --  0131EC
          (0, 0, 24626, 24626),
         16#ED#           =>  --  0131ED
          (0, 0, 24627, 24627),
         16#EE#           =>  --  0131EE
          (0, 0, 24628, 24628),
         16#EF#           =>  --  0131EF
          (0, 0, 24629, 24629),
         16#F0#           =>  --  0131F0
          (0, 0, 24630, 24630),
         16#F1#           =>  --  0131F1
          (0, 0, 24631, 24631),
         16#F2#           =>  --  0131F2
          (0, 0, 24632, 24632),
         16#F3#           =>  --  0131F3
          (0, 0, 24633, 24633),
         16#F4#           =>  --  0131F4
          (0, 0, 24634, 24634),
         16#F5#           =>  --  0131F5
          (0, 0, 24635, 24635),
         16#F6#           =>  --  0131F6
          (0, 0, 24636, 24636),
         16#F7#           =>  --  0131F7
          (0, 0, 24637, 24637),
         16#F8#           =>  --  0131F8
          (0, 0, 24638, 24638),
         16#F9#           =>  --  0131F9
          (0, 0, 24639, 24639),
         16#FA#           =>  --  0131FA
          (0, 0, 24640, 24640),
         16#FB#           =>  --  0131FB
          (0, 0, 24641, 24641),
         16#FC#           =>  --  0131FC
          (0, 0, 24642, 24642),
         16#FD#           =>  --  0131FD
          (0, 0, 24643, 24643),
         16#FE#           =>  --  0131FE
          (0, 0, 24644, 24644),
         16#FF#           =>  --  0131FF
          (0, 0, 24645, 24645),
         others           =>
          (0, 0, 0, 0));

   Group_0132 : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  013200
          (0, 0, 24646, 24646),
         16#01#           =>  --  013201
          (0, 0, 24647, 24647),
         16#02#           =>  --  013202
          (0, 0, 24648, 24648),
         16#03#           =>  --  013203
          (0, 0, 24649, 24649),
         16#04#           =>  --  013204
          (0, 0, 24650, 24650),
         16#05#           =>  --  013205
          (0, 0, 24651, 24651),
         16#06#           =>  --  013206
          (0, 0, 24652, 24652),
         16#07#           =>  --  013207
          (0, 0, 24653, 24653),
         16#08#           =>  --  013208
          (0, 0, 24654, 24654),
         16#09#           =>  --  013209
          (0, 0, 24655, 24655),
         16#0A#           =>  --  01320A
          (0, 0, 24656, 24656),
         16#0B#           =>  --  01320B
          (0, 0, 24657, 24657),
         16#0C#           =>  --  01320C
          (0, 0, 24658, 24658),
         16#0D#           =>  --  01320D
          (0, 0, 24659, 24659),
         16#0E#           =>  --  01320E
          (0, 0, 24660, 24660),
         16#0F#           =>  --  01320F
          (0, 0, 24661, 24661),
         16#10#           =>  --  013210
          (0, 0, 24662, 24662),
         16#11#           =>  --  013211
          (0, 0, 24663, 24663),
         16#12#           =>  --  013212
          (0, 0, 24664, 24664),
         16#13#           =>  --  013213
          (0, 0, 24665, 24665),
         16#14#           =>  --  013214
          (0, 0, 24666, 24666),
         16#15#           =>  --  013215
          (0, 0, 24667, 24667),
         16#16#           =>  --  013216
          (0, 0, 24668, 24668),
         16#17#           =>  --  013217
          (0, 0, 24669, 24669),
         16#18#           =>  --  013218
          (0, 0, 24670, 24670),
         16#19#           =>  --  013219
          (0, 0, 24671, 24671),
         16#1A#           =>  --  01321A
          (0, 0, 24672, 24672),
         16#1B#           =>  --  01321B
          (0, 0, 24673, 24673),
         16#1C#           =>  --  01321C
          (0, 0, 24674, 24674),
         16#1D#           =>  --  01321D
          (0, 0, 24675, 24675),
         16#1E#           =>  --  01321E
          (0, 0, 24676, 24676),
         16#1F#           =>  --  01321F
          (0, 0, 24677, 24677),
         16#20#           =>  --  013220
          (0, 0, 24678, 24678),
         16#21#           =>  --  013221
          (0, 0, 24679, 24679),
         16#22#           =>  --  013222
          (0, 0, 24680, 24680),
         16#23#           =>  --  013223
          (0, 0, 24681, 24681),
         16#24#           =>  --  013224
          (0, 0, 24682, 24682),
         16#25#           =>  --  013225
          (0, 0, 24683, 24683),
         16#26#           =>  --  013226
          (0, 0, 24684, 24684),
         16#27#           =>  --  013227
          (0, 0, 24685, 24685),
         16#28#           =>  --  013228
          (0, 0, 24686, 24686),
         16#29#           =>  --  013229
          (0, 0, 24687, 24687),
         16#2A#           =>  --  01322A
          (0, 0, 24688, 24688),
         16#2B#           =>  --  01322B
          (0, 0, 24689, 24689),
         16#2C#           =>  --  01322C
          (0, 0, 24690, 24690),
         16#2D#           =>  --  01322D
          (0, 0, 24691, 24691),
         16#2E#           =>  --  01322E
          (0, 0, 24692, 24692),
         16#2F#           =>  --  01322F
          (0, 0, 24693, 24693),
         16#30#           =>  --  013230
          (0, 0, 24694, 24694),
         16#31#           =>  --  013231
          (0, 0, 24695, 24695),
         16#32#           =>  --  013232
          (0, 0, 24696, 24696),
         16#33#           =>  --  013233
          (0, 0, 24697, 24697),
         16#34#           =>  --  013234
          (0, 0, 24698, 24698),
         16#35#           =>  --  013235
          (0, 0, 24699, 24699),
         16#36#           =>  --  013236
          (0, 0, 24700, 24700),
         16#37#           =>  --  013237
          (0, 0, 24701, 24701),
         16#38#           =>  --  013238
          (0, 0, 24702, 24702),
         16#39#           =>  --  013239
          (0, 0, 24703, 24703),
         16#3A#           =>  --  01323A
          (0, 0, 24704, 24704),
         16#3B#           =>  --  01323B
          (0, 0, 24705, 24705),
         16#3C#           =>  --  01323C
          (0, 0, 24706, 24706),
         16#3D#           =>  --  01323D
          (0, 0, 24707, 24707),
         16#3E#           =>  --  01323E
          (0, 0, 24708, 24708),
         16#3F#           =>  --  01323F
          (0, 0, 24709, 24709),
         16#40#           =>  --  013240
          (0, 0, 24710, 24710),
         16#41#           =>  --  013241
          (0, 0, 24711, 24711),
         16#42#           =>  --  013242
          (0, 0, 24712, 24712),
         16#43#           =>  --  013243
          (0, 0, 24713, 24713),
         16#44#           =>  --  013244
          (0, 0, 24714, 24714),
         16#45#           =>  --  013245
          (0, 0, 24715, 24715),
         16#46#           =>  --  013246
          (0, 0, 24716, 24716),
         16#47#           =>  --  013247
          (0, 0, 24717, 24717),
         16#48#           =>  --  013248
          (0, 0, 24718, 24718),
         16#49#           =>  --  013249
          (0, 0, 24719, 24719),
         16#4A#           =>  --  01324A
          (0, 0, 24720, 24720),
         16#4B#           =>  --  01324B
          (0, 0, 24721, 24721),
         16#4C#           =>  --  01324C
          (0, 0, 24722, 24722),
         16#4D#           =>  --  01324D
          (0, 0, 24723, 24723),
         16#4E#           =>  --  01324E
          (0, 0, 24724, 24724),
         16#4F#           =>  --  01324F
          (0, 0, 24725, 24725),
         16#50#           =>  --  013250
          (0, 0, 24726, 24726),
         16#51#           =>  --  013251
          (0, 0, 24727, 24727),
         16#52#           =>  --  013252
          (0, 0, 24728, 24728),
         16#53#           =>  --  013253
          (0, 0, 24729, 24729),
         16#54#           =>  --  013254
          (0, 0, 24730, 24730),
         16#55#           =>  --  013255
          (0, 0, 24731, 24731),
         16#56#           =>  --  013256
          (0, 0, 24732, 24732),
         16#57#           =>  --  013257
          (0, 0, 24733, 24733),
         16#58#           =>  --  013258
          (0, 0, 24734, 24734),
         16#59#           =>  --  013259
          (0, 0, 24735, 24735),
         16#5A#           =>  --  01325A
          (0, 0, 24736, 24736),
         16#5B#           =>  --  01325B
          (0, 0, 24737, 24737),
         16#5C#           =>  --  01325C
          (0, 0, 24738, 24738),
         16#5D#           =>  --  01325D
          (0, 0, 24739, 24739),
         16#5E#           =>  --  01325E
          (0, 0, 24740, 24740),
         16#5F#           =>  --  01325F
          (0, 0, 24741, 24741),
         16#60#           =>  --  013260
          (0, 0, 24742, 24742),
         16#61#           =>  --  013261
          (0, 0, 24743, 24743),
         16#62#           =>  --  013262
          (0, 0, 24744, 24744),
         16#63#           =>  --  013263
          (0, 0, 24745, 24745),
         16#64#           =>  --  013264
          (0, 0, 24746, 24746),
         16#65#           =>  --  013265
          (0, 0, 24747, 24747),
         16#66#           =>  --  013266
          (0, 0, 24748, 24748),
         16#67#           =>  --  013267
          (0, 0, 24749, 24749),
         16#68#           =>  --  013268
          (0, 0, 24750, 24750),
         16#69#           =>  --  013269
          (0, 0, 24751, 24751),
         16#6A#           =>  --  01326A
          (0, 0, 24752, 24752),
         16#6B#           =>  --  01326B
          (0, 0, 24753, 24753),
         16#6C#           =>  --  01326C
          (0, 0, 24754, 24754),
         16#6D#           =>  --  01326D
          (0, 0, 24755, 24755),
         16#6E#           =>  --  01326E
          (0, 0, 24756, 24756),
         16#6F#           =>  --  01326F
          (0, 0, 24757, 24757),
         16#70#           =>  --  013270
          (0, 0, 24758, 24758),
         16#71#           =>  --  013271
          (0, 0, 24759, 24759),
         16#72#           =>  --  013272
          (0, 0, 24760, 24760),
         16#73#           =>  --  013273
          (0, 0, 24761, 24761),
         16#74#           =>  --  013274
          (0, 0, 24762, 24762),
         16#75#           =>  --  013275
          (0, 0, 24763, 24763),
         16#76#           =>  --  013276
          (0, 0, 24764, 24764),
         16#77#           =>  --  013277
          (0, 0, 24765, 24765),
         16#78#           =>  --  013278
          (0, 0, 24766, 24766),
         16#79#           =>  --  013279
          (0, 0, 24767, 24767),
         16#7A#           =>  --  01327A
          (0, 0, 24768, 24768),
         16#7B#           =>  --  01327B
          (0, 0, 24769, 24769),
         16#7C#           =>  --  01327C
          (0, 0, 24770, 24770),
         16#7D#           =>  --  01327D
          (0, 0, 24771, 24771),
         16#7E#           =>  --  01327E
          (0, 0, 24772, 24772),
         16#7F#           =>  --  01327F
          (0, 0, 24773, 24773),
         16#80#           =>  --  013280
          (0, 0, 24774, 24774),
         16#81#           =>  --  013281
          (0, 0, 24775, 24775),
         16#82#           =>  --  013282
          (0, 0, 24776, 24776),
         16#83#           =>  --  013283
          (0, 0, 24777, 24777),
         16#84#           =>  --  013284
          (0, 0, 24778, 24778),
         16#85#           =>  --  013285
          (0, 0, 24779, 24779),
         16#86#           =>  --  013286
          (0, 0, 24780, 24780),
         16#87#           =>  --  013287
          (0, 0, 24781, 24781),
         16#88#           =>  --  013288
          (0, 0, 24782, 24782),
         16#89#           =>  --  013289
          (0, 0, 24783, 24783),
         16#8A#           =>  --  01328A
          (0, 0, 24784, 24784),
         16#8B#           =>  --  01328B
          (0, 0, 24785, 24785),
         16#8C#           =>  --  01328C
          (0, 0, 24786, 24786),
         16#8D#           =>  --  01328D
          (0, 0, 24787, 24787),
         16#8E#           =>  --  01328E
          (0, 0, 24788, 24788),
         16#8F#           =>  --  01328F
          (0, 0, 24789, 24789),
         16#90#           =>  --  013290
          (0, 0, 24790, 24790),
         16#91#           =>  --  013291
          (0, 0, 24791, 24791),
         16#92#           =>  --  013292
          (0, 0, 24792, 24792),
         16#93#           =>  --  013293
          (0, 0, 24793, 24793),
         16#94#           =>  --  013294
          (0, 0, 24794, 24794),
         16#95#           =>  --  013295
          (0, 0, 24795, 24795),
         16#96#           =>  --  013296
          (0, 0, 24796, 24796),
         16#97#           =>  --  013297
          (0, 0, 24797, 24797),
         16#98#           =>  --  013298
          (0, 0, 24798, 24798),
         16#99#           =>  --  013299
          (0, 0, 24799, 24799),
         16#9A#           =>  --  01329A
          (0, 0, 24800, 24800),
         16#9B#           =>  --  01329B
          (0, 0, 24801, 24801),
         16#9C#           =>  --  01329C
          (0, 0, 24802, 24802),
         16#9D#           =>  --  01329D
          (0, 0, 24803, 24803),
         16#9E#           =>  --  01329E
          (0, 0, 24804, 24804),
         16#9F#           =>  --  01329F
          (0, 0, 24805, 24805),
         16#A0#           =>  --  0132A0
          (0, 0, 24806, 24806),
         16#A1#           =>  --  0132A1
          (0, 0, 24807, 24807),
         16#A2#           =>  --  0132A2
          (0, 0, 24808, 24808),
         16#A3#           =>  --  0132A3
          (0, 0, 24809, 24809),
         16#A4#           =>  --  0132A4
          (0, 0, 24810, 24810),
         16#A5#           =>  --  0132A5
          (0, 0, 24811, 24811),
         16#A6#           =>  --  0132A6
          (0, 0, 24812, 24812),
         16#A7#           =>  --  0132A7
          (0, 0, 24813, 24813),
         16#A8#           =>  --  0132A8
          (0, 0, 24814, 24814),
         16#A9#           =>  --  0132A9
          (0, 0, 24815, 24815),
         16#AA#           =>  --  0132AA
          (0, 0, 24816, 24816),
         16#AB#           =>  --  0132AB
          (0, 0, 24817, 24817),
         16#AC#           =>  --  0132AC
          (0, 0, 24818, 24818),
         16#AD#           =>  --  0132AD
          (0, 0, 24819, 24819),
         16#AE#           =>  --  0132AE
          (0, 0, 24820, 24820),
         16#AF#           =>  --  0132AF
          (0, 0, 24821, 24821),
         16#B0#           =>  --  0132B0
          (0, 0, 24822, 24822),
         16#B1#           =>  --  0132B1
          (0, 0, 24823, 24823),
         16#B2#           =>  --  0132B2
          (0, 0, 24824, 24824),
         16#B3#           =>  --  0132B3
          (0, 0, 24825, 24825),
         16#B4#           =>  --  0132B4
          (0, 0, 24826, 24826),
         16#B5#           =>  --  0132B5
          (0, 0, 24827, 24827),
         16#B6#           =>  --  0132B6
          (0, 0, 24828, 24828),
         16#B7#           =>  --  0132B7
          (0, 0, 24829, 24829),
         16#B8#           =>  --  0132B8
          (0, 0, 24830, 24830),
         16#B9#           =>  --  0132B9
          (0, 0, 24831, 24831),
         16#BA#           =>  --  0132BA
          (0, 0, 24832, 24832),
         16#BB#           =>  --  0132BB
          (0, 0, 24833, 24833),
         16#BC#           =>  --  0132BC
          (0, 0, 24834, 24834),
         16#BD#           =>  --  0132BD
          (0, 0, 24835, 24835),
         16#BE#           =>  --  0132BE
          (0, 0, 24836, 24836),
         16#BF#           =>  --  0132BF
          (0, 0, 24837, 24837),
         16#C0#           =>  --  0132C0
          (0, 0, 24838, 24838),
         16#C1#           =>  --  0132C1
          (0, 0, 24839, 24839),
         16#C2#           =>  --  0132C2
          (0, 0, 24840, 24840),
         16#C3#           =>  --  0132C3
          (0, 0, 24841, 24841),
         16#C4#           =>  --  0132C4
          (0, 0, 24842, 24842),
         16#C5#           =>  --  0132C5
          (0, 0, 24843, 24843),
         16#C6#           =>  --  0132C6
          (0, 0, 24844, 24844),
         16#C7#           =>  --  0132C7
          (0, 0, 24845, 24845),
         16#C8#           =>  --  0132C8
          (0, 0, 24846, 24846),
         16#C9#           =>  --  0132C9
          (0, 0, 24847, 24847),
         16#CA#           =>  --  0132CA
          (0, 0, 24848, 24848),
         16#CB#           =>  --  0132CB
          (0, 0, 24849, 24849),
         16#CC#           =>  --  0132CC
          (0, 0, 24850, 24850),
         16#CD#           =>  --  0132CD
          (0, 0, 24851, 24851),
         16#CE#           =>  --  0132CE
          (0, 0, 24852, 24852),
         16#CF#           =>  --  0132CF
          (0, 0, 24853, 24853),
         16#D0#           =>  --  0132D0
          (0, 0, 24854, 24854),
         16#D1#           =>  --  0132D1
          (0, 0, 24855, 24855),
         16#D2#           =>  --  0132D2
          (0, 0, 24856, 24856),
         16#D3#           =>  --  0132D3
          (0, 0, 24857, 24857),
         16#D4#           =>  --  0132D4
          (0, 0, 24858, 24858),
         16#D5#           =>  --  0132D5
          (0, 0, 24859, 24859),
         16#D6#           =>  --  0132D6
          (0, 0, 24860, 24860),
         16#D7#           =>  --  0132D7
          (0, 0, 24861, 24861),
         16#D8#           =>  --  0132D8
          (0, 0, 24862, 24862),
         16#D9#           =>  --  0132D9
          (0, 0, 24863, 24863),
         16#DA#           =>  --  0132DA
          (0, 0, 24864, 24864),
         16#DB#           =>  --  0132DB
          (0, 0, 24865, 24865),
         16#DC#           =>  --  0132DC
          (0, 0, 24866, 24866),
         16#DD#           =>  --  0132DD
          (0, 0, 24867, 24867),
         16#DE#           =>  --  0132DE
          (0, 0, 24868, 24868),
         16#DF#           =>  --  0132DF
          (0, 0, 24869, 24869),
         16#E0#           =>  --  0132E0
          (0, 0, 24870, 24870),
         16#E1#           =>  --  0132E1
          (0, 0, 24871, 24871),
         16#E2#           =>  --  0132E2
          (0, 0, 24872, 24872),
         16#E3#           =>  --  0132E3
          (0, 0, 24873, 24873),
         16#E4#           =>  --  0132E4
          (0, 0, 24874, 24874),
         16#E5#           =>  --  0132E5
          (0, 0, 24875, 24875),
         16#E6#           =>  --  0132E6
          (0, 0, 24876, 24876),
         16#E7#           =>  --  0132E7
          (0, 0, 24877, 24877),
         16#E8#           =>  --  0132E8
          (0, 0, 24878, 24878),
         16#E9#           =>  --  0132E9
          (0, 0, 24879, 24879),
         16#EA#           =>  --  0132EA
          (0, 0, 24880, 24880),
         16#EB#           =>  --  0132EB
          (0, 0, 24881, 24881),
         16#EC#           =>  --  0132EC
          (0, 0, 24882, 24882),
         16#ED#           =>  --  0132ED
          (0, 0, 24883, 24883),
         16#EE#           =>  --  0132EE
          (0, 0, 24884, 24884),
         16#EF#           =>  --  0132EF
          (0, 0, 24885, 24885),
         16#F0#           =>  --  0132F0
          (0, 0, 24886, 24886),
         16#F1#           =>  --  0132F1
          (0, 0, 24887, 24887),
         16#F2#           =>  --  0132F2
          (0, 0, 24888, 24888),
         16#F3#           =>  --  0132F3
          (0, 0, 24889, 24889),
         16#F4#           =>  --  0132F4
          (0, 0, 24890, 24890),
         16#F5#           =>  --  0132F5
          (0, 0, 24891, 24891),
         16#F6#           =>  --  0132F6
          (0, 0, 24892, 24892),
         16#F7#           =>  --  0132F7
          (0, 0, 24893, 24893),
         16#F8#           =>  --  0132F8
          (0, 0, 24894, 24894),
         16#F9#           =>  --  0132F9
          (0, 0, 24895, 24895),
         16#FA#           =>  --  0132FA
          (0, 0, 24896, 24896),
         16#FB#           =>  --  0132FB
          (0, 0, 24897, 24897),
         16#FC#           =>  --  0132FC
          (0, 0, 24898, 24898),
         16#FD#           =>  --  0132FD
          (0, 0, 24899, 24899),
         16#FE#           =>  --  0132FE
          (0, 0, 24900, 24900),
         16#FF#           =>  --  0132FF
          (0, 0, 24901, 24901),
         others           =>
          (0, 0, 0, 0));

   Group_0133 : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  013300
          (0, 0, 24902, 24902),
         16#01#           =>  --  013301
          (0, 0, 24903, 24903),
         16#02#           =>  --  013302
          (0, 0, 24904, 24904),
         16#03#           =>  --  013303
          (0, 0, 24905, 24905),
         16#04#           =>  --  013304
          (0, 0, 24906, 24906),
         16#05#           =>  --  013305
          (0, 0, 24907, 24907),
         16#06#           =>  --  013306
          (0, 0, 24908, 24908),
         16#07#           =>  --  013307
          (0, 0, 24909, 24909),
         16#08#           =>  --  013308
          (0, 0, 24910, 24910),
         16#09#           =>  --  013309
          (0, 0, 24911, 24911),
         16#0A#           =>  --  01330A
          (0, 0, 24912, 24912),
         16#0B#           =>  --  01330B
          (0, 0, 24913, 24913),
         16#0C#           =>  --  01330C
          (0, 0, 24914, 24914),
         16#0D#           =>  --  01330D
          (0, 0, 24915, 24915),
         16#0E#           =>  --  01330E
          (0, 0, 24916, 24916),
         16#0F#           =>  --  01330F
          (0, 0, 24917, 24917),
         16#10#           =>  --  013310
          (0, 0, 24918, 24918),
         16#11#           =>  --  013311
          (0, 0, 24919, 24919),
         16#12#           =>  --  013312
          (0, 0, 24920, 24920),
         16#13#           =>  --  013313
          (0, 0, 24921, 24921),
         16#14#           =>  --  013314
          (0, 0, 24922, 24922),
         16#15#           =>  --  013315
          (0, 0, 24923, 24923),
         16#16#           =>  --  013316
          (0, 0, 24924, 24924),
         16#17#           =>  --  013317
          (0, 0, 24925, 24925),
         16#18#           =>  --  013318
          (0, 0, 24926, 24926),
         16#19#           =>  --  013319
          (0, 0, 24927, 24927),
         16#1A#           =>  --  01331A
          (0, 0, 24928, 24928),
         16#1B#           =>  --  01331B
          (0, 0, 24929, 24929),
         16#1C#           =>  --  01331C
          (0, 0, 24930, 24930),
         16#1D#           =>  --  01331D
          (0, 0, 24931, 24931),
         16#1E#           =>  --  01331E
          (0, 0, 24932, 24932),
         16#1F#           =>  --  01331F
          (0, 0, 24933, 24933),
         16#20#           =>  --  013320
          (0, 0, 24934, 24934),
         16#21#           =>  --  013321
          (0, 0, 24935, 24935),
         16#22#           =>  --  013322
          (0, 0, 24936, 24936),
         16#23#           =>  --  013323
          (0, 0, 24937, 24937),
         16#24#           =>  --  013324
          (0, 0, 24938, 24938),
         16#25#           =>  --  013325
          (0, 0, 24939, 24939),
         16#26#           =>  --  013326
          (0, 0, 24940, 24940),
         16#27#           =>  --  013327
          (0, 0, 24941, 24941),
         16#28#           =>  --  013328
          (0, 0, 24942, 24942),
         16#29#           =>  --  013329
          (0, 0, 24943, 24943),
         16#2A#           =>  --  01332A
          (0, 0, 24944, 24944),
         16#2B#           =>  --  01332B
          (0, 0, 24945, 24945),
         16#2C#           =>  --  01332C
          (0, 0, 24946, 24946),
         16#2D#           =>  --  01332D
          (0, 0, 24947, 24947),
         16#2E#           =>  --  01332E
          (0, 0, 24948, 24948),
         16#2F#           =>  --  01332F
          (0, 0, 24949, 24949),
         16#30#           =>  --  013330
          (0, 0, 24950, 24950),
         16#31#           =>  --  013331
          (0, 0, 24951, 24951),
         16#32#           =>  --  013332
          (0, 0, 24952, 24952),
         16#33#           =>  --  013333
          (0, 0, 24953, 24953),
         16#34#           =>  --  013334
          (0, 0, 24954, 24954),
         16#35#           =>  --  013335
          (0, 0, 24955, 24955),
         16#36#           =>  --  013336
          (0, 0, 24956, 24956),
         16#37#           =>  --  013337
          (0, 0, 24957, 24957),
         16#38#           =>  --  013338
          (0, 0, 24958, 24958),
         16#39#           =>  --  013339
          (0, 0, 24959, 24959),
         16#3A#           =>  --  01333A
          (0, 0, 24960, 24960),
         16#3B#           =>  --  01333B
          (0, 0, 24961, 24961),
         16#3C#           =>  --  01333C
          (0, 0, 24962, 24962),
         16#3D#           =>  --  01333D
          (0, 0, 24963, 24963),
         16#3E#           =>  --  01333E
          (0, 0, 24964, 24964),
         16#3F#           =>  --  01333F
          (0, 0, 24965, 24965),
         16#40#           =>  --  013340
          (0, 0, 24966, 24966),
         16#41#           =>  --  013341
          (0, 0, 24967, 24967),
         16#42#           =>  --  013342
          (0, 0, 24968, 24968),
         16#43#           =>  --  013343
          (0, 0, 24969, 24969),
         16#44#           =>  --  013344
          (0, 0, 24970, 24970),
         16#45#           =>  --  013345
          (0, 0, 24971, 24971),
         16#46#           =>  --  013346
          (0, 0, 24972, 24972),
         16#47#           =>  --  013347
          (0, 0, 24973, 24973),
         16#48#           =>  --  013348
          (0, 0, 24974, 24974),
         16#49#           =>  --  013349
          (0, 0, 24975, 24975),
         16#4A#           =>  --  01334A
          (0, 0, 24976, 24976),
         16#4B#           =>  --  01334B
          (0, 0, 24977, 24977),
         16#4C#           =>  --  01334C
          (0, 0, 24978, 24978),
         16#4D#           =>  --  01334D
          (0, 0, 24979, 24979),
         16#4E#           =>  --  01334E
          (0, 0, 24980, 24980),
         16#4F#           =>  --  01334F
          (0, 0, 24981, 24981),
         16#50#           =>  --  013350
          (0, 0, 24982, 24982),
         16#51#           =>  --  013351
          (0, 0, 24983, 24983),
         16#52#           =>  --  013352
          (0, 0, 24984, 24984),
         16#53#           =>  --  013353
          (0, 0, 24985, 24985),
         16#54#           =>  --  013354
          (0, 0, 24986, 24986),
         16#55#           =>  --  013355
          (0, 0, 24987, 24987),
         16#56#           =>  --  013356
          (0, 0, 24988, 24988),
         16#57#           =>  --  013357
          (0, 0, 24989, 24989),
         16#58#           =>  --  013358
          (0, 0, 24990, 24990),
         16#59#           =>  --  013359
          (0, 0, 24991, 24991),
         16#5A#           =>  --  01335A
          (0, 0, 24992, 24992),
         16#5B#           =>  --  01335B
          (0, 0, 24993, 24993),
         16#5C#           =>  --  01335C
          (0, 0, 24994, 24994),
         16#5D#           =>  --  01335D
          (0, 0, 24995, 24995),
         16#5E#           =>  --  01335E
          (0, 0, 24996, 24996),
         16#5F#           =>  --  01335F
          (0, 0, 24997, 24997),
         16#60#           =>  --  013360
          (0, 0, 24998, 24998),
         16#61#           =>  --  013361
          (0, 0, 24999, 24999),
         16#62#           =>  --  013362
          (0, 0, 25000, 25000),
         16#63#           =>  --  013363
          (0, 0, 25001, 25001),
         16#64#           =>  --  013364
          (0, 0, 25002, 25002),
         16#65#           =>  --  013365
          (0, 0, 25003, 25003),
         16#66#           =>  --  013366
          (0, 0, 25004, 25004),
         16#67#           =>  --  013367
          (0, 0, 25005, 25005),
         16#68#           =>  --  013368
          (0, 0, 25006, 25006),
         16#69#           =>  --  013369
          (0, 0, 25007, 25007),
         16#6A#           =>  --  01336A
          (0, 0, 25008, 25008),
         16#6B#           =>  --  01336B
          (0, 0, 25009, 25009),
         16#6C#           =>  --  01336C
          (0, 0, 25010, 25010),
         16#6D#           =>  --  01336D
          (0, 0, 25011, 25011),
         16#6E#           =>  --  01336E
          (0, 0, 25012, 25012),
         16#6F#           =>  --  01336F
          (0, 0, 25013, 25013),
         16#70#           =>  --  013370
          (0, 0, 25014, 25014),
         16#71#           =>  --  013371
          (0, 0, 25015, 25015),
         16#72#           =>  --  013372
          (0, 0, 25016, 25016),
         16#73#           =>  --  013373
          (0, 0, 25017, 25017),
         16#74#           =>  --  013374
          (0, 0, 25018, 25018),
         16#75#           =>  --  013375
          (0, 0, 25019, 25019),
         16#76#           =>  --  013376
          (0, 0, 25020, 25020),
         16#77#           =>  --  013377
          (0, 0, 25021, 25021),
         16#78#           =>  --  013378
          (0, 0, 25022, 25022),
         16#79#           =>  --  013379
          (0, 0, 25023, 25023),
         16#7A#           =>  --  01337A
          (0, 0, 25024, 25024),
         16#7B#           =>  --  01337B
          (0, 0, 25025, 25025),
         16#7C#           =>  --  01337C
          (0, 0, 25026, 25026),
         16#7D#           =>  --  01337D
          (0, 0, 25027, 25027),
         16#7E#           =>  --  01337E
          (0, 0, 25028, 25028),
         16#7F#           =>  --  01337F
          (0, 0, 25029, 25029),
         16#80#           =>  --  013380
          (0, 0, 25030, 25030),
         16#81#           =>  --  013381
          (0, 0, 25031, 25031),
         16#82#           =>  --  013382
          (0, 0, 25032, 25032),
         16#83#           =>  --  013383
          (0, 0, 25033, 25033),
         16#84#           =>  --  013384
          (0, 0, 25034, 25034),
         16#85#           =>  --  013385
          (0, 0, 25035, 25035),
         16#86#           =>  --  013386
          (0, 0, 25036, 25036),
         16#87#           =>  --  013387
          (0, 0, 25037, 25037),
         16#88#           =>  --  013388
          (0, 0, 25038, 25038),
         16#89#           =>  --  013389
          (0, 0, 25039, 25039),
         16#8A#           =>  --  01338A
          (0, 0, 25040, 25040),
         16#8B#           =>  --  01338B
          (0, 0, 25041, 25041),
         16#8C#           =>  --  01338C
          (0, 0, 25042, 25042),
         16#8D#           =>  --  01338D
          (0, 0, 25043, 25043),
         16#8E#           =>  --  01338E
          (0, 0, 25044, 25044),
         16#8F#           =>  --  01338F
          (0, 0, 25045, 25045),
         16#90#           =>  --  013390
          (0, 0, 25046, 25046),
         16#91#           =>  --  013391
          (0, 0, 25047, 25047),
         16#92#           =>  --  013392
          (0, 0, 25048, 25048),
         16#93#           =>  --  013393
          (0, 0, 25049, 25049),
         16#94#           =>  --  013394
          (0, 0, 25050, 25050),
         16#95#           =>  --  013395
          (0, 0, 25051, 25051),
         16#96#           =>  --  013396
          (0, 0, 25052, 25052),
         16#97#           =>  --  013397
          (0, 0, 25053, 25053),
         16#98#           =>  --  013398
          (0, 0, 25054, 25054),
         16#99#           =>  --  013399
          (0, 0, 25055, 25055),
         16#9A#           =>  --  01339A
          (0, 0, 25056, 25056),
         16#9B#           =>  --  01339B
          (0, 0, 25057, 25057),
         16#9C#           =>  --  01339C
          (0, 0, 25058, 25058),
         16#9D#           =>  --  01339D
          (0, 0, 25059, 25059),
         16#9E#           =>  --  01339E
          (0, 0, 25060, 25060),
         16#9F#           =>  --  01339F
          (0, 0, 25061, 25061),
         16#A0#           =>  --  0133A0
          (0, 0, 25062, 25062),
         16#A1#           =>  --  0133A1
          (0, 0, 25063, 25063),
         16#A2#           =>  --  0133A2
          (0, 0, 25064, 25064),
         16#A3#           =>  --  0133A3
          (0, 0, 25065, 25065),
         16#A4#           =>  --  0133A4
          (0, 0, 25066, 25066),
         16#A5#           =>  --  0133A5
          (0, 0, 25067, 25067),
         16#A6#           =>  --  0133A6
          (0, 0, 25068, 25068),
         16#A7#           =>  --  0133A7
          (0, 0, 25069, 25069),
         16#A8#           =>  --  0133A8
          (0, 0, 25070, 25070),
         16#A9#           =>  --  0133A9
          (0, 0, 25071, 25071),
         16#AA#           =>  --  0133AA
          (0, 0, 25072, 25072),
         16#AB#           =>  --  0133AB
          (0, 0, 25073, 25073),
         16#AC#           =>  --  0133AC
          (0, 0, 25074, 25074),
         16#AD#           =>  --  0133AD
          (0, 0, 25075, 25075),
         16#AE#           =>  --  0133AE
          (0, 0, 25076, 25076),
         16#AF#           =>  --  0133AF
          (0, 0, 25077, 25077),
         16#B0#           =>  --  0133B0
          (0, 0, 25078, 25078),
         16#B1#           =>  --  0133B1
          (0, 0, 25079, 25079),
         16#B2#           =>  --  0133B2
          (0, 0, 25080, 25080),
         16#B3#           =>  --  0133B3
          (0, 0, 25081, 25081),
         16#B4#           =>  --  0133B4
          (0, 0, 25082, 25082),
         16#B5#           =>  --  0133B5
          (0, 0, 25083, 25083),
         16#B6#           =>  --  0133B6
          (0, 0, 25084, 25084),
         16#B7#           =>  --  0133B7
          (0, 0, 25085, 25085),
         16#B8#           =>  --  0133B8
          (0, 0, 25086, 25086),
         16#B9#           =>  --  0133B9
          (0, 0, 25087, 25087),
         16#BA#           =>  --  0133BA
          (0, 0, 25088, 25088),
         16#BB#           =>  --  0133BB
          (0, 0, 25089, 25089),
         16#BC#           =>  --  0133BC
          (0, 0, 25090, 25090),
         16#BD#           =>  --  0133BD
          (0, 0, 25091, 25091),
         16#BE#           =>  --  0133BE
          (0, 0, 25092, 25092),
         16#BF#           =>  --  0133BF
          (0, 0, 25093, 25093),
         16#C0#           =>  --  0133C0
          (0, 0, 25094, 25094),
         16#C1#           =>  --  0133C1
          (0, 0, 25095, 25095),
         16#C2#           =>  --  0133C2
          (0, 0, 25096, 25096),
         16#C3#           =>  --  0133C3
          (0, 0, 25097, 25097),
         16#C4#           =>  --  0133C4
          (0, 0, 25098, 25098),
         16#C5#           =>  --  0133C5
          (0, 0, 25099, 25099),
         16#C6#           =>  --  0133C6
          (0, 0, 25100, 25100),
         16#C7#           =>  --  0133C7
          (0, 0, 25101, 25101),
         16#C8#           =>  --  0133C8
          (0, 0, 25102, 25102),
         16#C9#           =>  --  0133C9
          (0, 0, 25103, 25103),
         16#CA#           =>  --  0133CA
          (0, 0, 25104, 25104),
         16#CB#           =>  --  0133CB
          (0, 0, 25105, 25105),
         16#CC#           =>  --  0133CC
          (0, 0, 25106, 25106),
         16#CD#           =>  --  0133CD
          (0, 0, 25107, 25107),
         16#CE#           =>  --  0133CE
          (0, 0, 25108, 25108),
         16#CF#           =>  --  0133CF
          (0, 0, 25109, 25109),
         16#D0#           =>  --  0133D0
          (0, 0, 25110, 25110),
         16#D1#           =>  --  0133D1
          (0, 0, 25111, 25111),
         16#D2#           =>  --  0133D2
          (0, 0, 25112, 25112),
         16#D3#           =>  --  0133D3
          (0, 0, 25113, 25113),
         16#D4#           =>  --  0133D4
          (0, 0, 25114, 25114),
         16#D5#           =>  --  0133D5
          (0, 0, 25115, 25115),
         16#D6#           =>  --  0133D6
          (0, 0, 25116, 25116),
         16#D7#           =>  --  0133D7
          (0, 0, 25117, 25117),
         16#D8#           =>  --  0133D8
          (0, 0, 25118, 25118),
         16#D9#           =>  --  0133D9
          (0, 0, 25119, 25119),
         16#DA#           =>  --  0133DA
          (0, 0, 25120, 25120),
         16#DB#           =>  --  0133DB
          (0, 0, 25121, 25121),
         16#DC#           =>  --  0133DC
          (0, 0, 25122, 25122),
         16#DD#           =>  --  0133DD
          (0, 0, 25123, 25123),
         16#DE#           =>  --  0133DE
          (0, 0, 25124, 25124),
         16#DF#           =>  --  0133DF
          (0, 0, 25125, 25125),
         16#E0#           =>  --  0133E0
          (0, 0, 25126, 25126),
         16#E1#           =>  --  0133E1
          (0, 0, 25127, 25127),
         16#E2#           =>  --  0133E2
          (0, 0, 25128, 25128),
         16#E3#           =>  --  0133E3
          (0, 0, 25129, 25129),
         16#E4#           =>  --  0133E4
          (0, 0, 25130, 25130),
         16#E5#           =>  --  0133E5
          (0, 0, 25131, 25131),
         16#E6#           =>  --  0133E6
          (0, 0, 25132, 25132),
         16#E7#           =>  --  0133E7
          (0, 0, 25133, 25133),
         16#E8#           =>  --  0133E8
          (0, 0, 25134, 25134),
         16#E9#           =>  --  0133E9
          (0, 0, 25135, 25135),
         16#EA#           =>  --  0133EA
          (0, 0, 25136, 25136),
         16#EB#           =>  --  0133EB
          (0, 0, 25137, 25137),
         16#EC#           =>  --  0133EC
          (0, 0, 25138, 25138),
         16#ED#           =>  --  0133ED
          (0, 0, 25139, 25139),
         16#EE#           =>  --  0133EE
          (0, 0, 25140, 25140),
         16#EF#           =>  --  0133EF
          (0, 0, 25141, 25141),
         16#F0#           =>  --  0133F0
          (0, 0, 25142, 25142),
         16#F1#           =>  --  0133F1
          (0, 0, 25143, 25143),
         16#F2#           =>  --  0133F2
          (0, 0, 25144, 25144),
         16#F3#           =>  --  0133F3
          (0, 0, 25145, 25145),
         16#F4#           =>  --  0133F4
          (0, 0, 25146, 25146),
         16#F5#           =>  --  0133F5
          (0, 0, 25147, 25147),
         16#F6#           =>  --  0133F6
          (0, 0, 25148, 25148),
         16#F7#           =>  --  0133F7
          (0, 0, 25149, 25149),
         16#F8#           =>  --  0133F8
          (0, 0, 25150, 25150),
         16#F9#           =>  --  0133F9
          (0, 0, 25151, 25151),
         16#FA#           =>  --  0133FA
          (0, 0, 25152, 25152),
         16#FB#           =>  --  0133FB
          (0, 0, 25153, 25153),
         16#FC#           =>  --  0133FC
          (0, 0, 25154, 25154),
         16#FD#           =>  --  0133FD
          (0, 0, 25155, 25155),
         16#FE#           =>  --  0133FE
          (0, 0, 25156, 25156),
         16#FF#           =>  --  0133FF
          (0, 0, 25157, 25157),
         others           =>
          (0, 0, 0, 0));

   Group_0134 : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  013400
          (0, 0, 25158, 25158),
         16#01#           =>  --  013401
          (0, 0, 25159, 25159),
         16#02#           =>  --  013402
          (0, 0, 25160, 25160),
         16#03#           =>  --  013403
          (0, 0, 25161, 25161),
         16#04#           =>  --  013404
          (0, 0, 25162, 25162),
         16#05#           =>  --  013405
          (0, 0, 25163, 25163),
         16#06#           =>  --  013406
          (0, 0, 25164, 25164),
         16#07#           =>  --  013407
          (0, 0, 25165, 25165),
         16#08#           =>  --  013408
          (0, 0, 25166, 25166),
         16#09#           =>  --  013409
          (0, 0, 25167, 25167),
         16#0A#           =>  --  01340A
          (0, 0, 25168, 25168),
         16#0B#           =>  --  01340B
          (0, 0, 25169, 25169),
         16#0C#           =>  --  01340C
          (0, 0, 25170, 25170),
         16#0D#           =>  --  01340D
          (0, 0, 25171, 25171),
         16#0E#           =>  --  01340E
          (0, 0, 25172, 25172),
         16#0F#           =>  --  01340F
          (0, 0, 25173, 25173),
         16#10#           =>  --  013410
          (0, 0, 25174, 25174),
         16#11#           =>  --  013411
          (0, 0, 25175, 25175),
         16#12#           =>  --  013412
          (0, 0, 25176, 25176),
         16#13#           =>  --  013413
          (0, 0, 25177, 25177),
         16#14#           =>  --  013414
          (0, 0, 25178, 25178),
         16#15#           =>  --  013415
          (0, 0, 25179, 25179),
         16#16#           =>  --  013416
          (0, 0, 25180, 25180),
         16#17#           =>  --  013417
          (0, 0, 25181, 25181),
         16#18#           =>  --  013418
          (0, 0, 25182, 25182),
         16#19#           =>  --  013419
          (0, 0, 25183, 25183),
         16#1A#           =>  --  01341A
          (0, 0, 25184, 25184),
         16#1B#           =>  --  01341B
          (0, 0, 25185, 25185),
         16#1C#           =>  --  01341C
          (0, 0, 25186, 25186),
         16#1D#           =>  --  01341D
          (0, 0, 25187, 25187),
         16#1E#           =>  --  01341E
          (0, 0, 25188, 25188),
         16#1F#           =>  --  01341F
          (0, 0, 25189, 25189),
         16#20#           =>  --  013420
          (0, 0, 25190, 25190),
         16#21#           =>  --  013421
          (0, 0, 25191, 25191),
         16#22#           =>  --  013422
          (0, 0, 25192, 25192),
         16#23#           =>  --  013423
          (0, 0, 25193, 25193),
         16#24#           =>  --  013424
          (0, 0, 25194, 25194),
         16#25#           =>  --  013425
          (0, 0, 25195, 25195),
         16#26#           =>  --  013426
          (0, 0, 25196, 25196),
         16#27#           =>  --  013427
          (0, 0, 25197, 25197),
         16#28#           =>  --  013428
          (0, 0, 25198, 25198),
         16#29#           =>  --  013429
          (0, 0, 25199, 25199),
         16#2A#           =>  --  01342A
          (0, 0, 25200, 25200),
         16#2B#           =>  --  01342B
          (0, 0, 25201, 25201),
         16#2C#           =>  --  01342C
          (0, 0, 25202, 25202),
         16#2D#           =>  --  01342D
          (0, 0, 25203, 25203),
         16#2E#           =>  --  01342E
          (0, 0, 25204, 25204),
         others           =>
          (0, 0, 0, 0));

   Group_0168 : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  016800
          (0, 0, 25205, 25205),
         16#01#           =>  --  016801
          (0, 0, 25206, 25206),
         16#02#           =>  --  016802
          (0, 0, 25207, 25207),
         16#03#           =>  --  016803
          (0, 0, 25208, 25208),
         16#04#           =>  --  016804
          (0, 0, 25209, 25209),
         16#05#           =>  --  016805
          (0, 0, 25210, 25210),
         16#06#           =>  --  016806
          (0, 0, 25211, 25211),
         16#07#           =>  --  016807
          (0, 0, 25212, 25212),
         16#08#           =>  --  016808
          (0, 0, 25213, 25213),
         16#09#           =>  --  016809
          (0, 0, 25214, 25214),
         16#0A#           =>  --  01680A
          (0, 0, 25215, 25215),
         16#0B#           =>  --  01680B
          (0, 0, 25216, 25216),
         16#0C#           =>  --  01680C
          (0, 0, 25217, 25217),
         16#0D#           =>  --  01680D
          (0, 0, 25218, 25218),
         16#0E#           =>  --  01680E
          (0, 0, 25219, 25219),
         16#0F#           =>  --  01680F
          (0, 0, 25220, 25220),
         16#10#           =>  --  016810
          (0, 0, 25221, 25221),
         16#11#           =>  --  016811
          (0, 0, 25222, 25222),
         16#12#           =>  --  016812
          (0, 0, 25223, 25223),
         16#13#           =>  --  016813
          (0, 0, 25224, 25224),
         16#14#           =>  --  016814
          (0, 0, 25225, 25225),
         16#15#           =>  --  016815
          (0, 0, 25226, 25226),
         16#16#           =>  --  016816
          (0, 0, 25227, 25227),
         16#17#           =>  --  016817
          (0, 0, 25228, 25228),
         16#18#           =>  --  016818
          (0, 0, 25229, 25229),
         16#19#           =>  --  016819
          (0, 0, 25230, 25230),
         16#1A#           =>  --  01681A
          (0, 0, 25231, 25231),
         16#1B#           =>  --  01681B
          (0, 0, 25232, 25232),
         16#1C#           =>  --  01681C
          (0, 0, 25233, 25233),
         16#1D#           =>  --  01681D
          (0, 0, 25234, 25234),
         16#1E#           =>  --  01681E
          (0, 0, 25235, 25235),
         16#1F#           =>  --  01681F
          (0, 0, 25236, 25236),
         16#20#           =>  --  016820
          (0, 0, 25237, 25237),
         16#21#           =>  --  016821
          (0, 0, 25238, 25238),
         16#22#           =>  --  016822
          (0, 0, 25239, 25239),
         16#23#           =>  --  016823
          (0, 0, 25240, 25240),
         16#24#           =>  --  016824
          (0, 0, 25241, 25241),
         16#25#           =>  --  016825
          (0, 0, 25242, 25242),
         16#26#           =>  --  016826
          (0, 0, 25243, 25243),
         16#27#           =>  --  016827
          (0, 0, 25244, 25244),
         16#28#           =>  --  016828
          (0, 0, 25245, 25245),
         16#29#           =>  --  016829
          (0, 0, 25246, 25246),
         16#2A#           =>  --  01682A
          (0, 0, 25247, 25247),
         16#2B#           =>  --  01682B
          (0, 0, 25248, 25248),
         16#2C#           =>  --  01682C
          (0, 0, 25249, 25249),
         16#2D#           =>  --  01682D
          (0, 0, 25250, 25250),
         16#2E#           =>  --  01682E
          (0, 0, 25251, 25251),
         16#2F#           =>  --  01682F
          (0, 0, 25252, 25252),
         16#30#           =>  --  016830
          (0, 0, 25253, 25253),
         16#31#           =>  --  016831
          (0, 0, 25254, 25254),
         16#32#           =>  --  016832
          (0, 0, 25255, 25255),
         16#33#           =>  --  016833
          (0, 0, 25256, 25256),
         16#34#           =>  --  016834
          (0, 0, 25257, 25257),
         16#35#           =>  --  016835
          (0, 0, 25258, 25258),
         16#36#           =>  --  016836
          (0, 0, 25259, 25259),
         16#37#           =>  --  016837
          (0, 0, 25260, 25260),
         16#38#           =>  --  016838
          (0, 0, 25261, 25261),
         16#39#           =>  --  016839
          (0, 0, 25262, 25262),
         16#3A#           =>  --  01683A
          (0, 0, 25263, 25263),
         16#3B#           =>  --  01683B
          (0, 0, 25264, 25264),
         16#3C#           =>  --  01683C
          (0, 0, 25265, 25265),
         16#3D#           =>  --  01683D
          (0, 0, 25266, 25266),
         16#3E#           =>  --  01683E
          (0, 0, 25267, 25267),
         16#3F#           =>  --  01683F
          (0, 0, 25268, 25268),
         16#40#           =>  --  016840
          (0, 0, 25269, 25269),
         16#41#           =>  --  016841
          (0, 0, 25270, 25270),
         16#42#           =>  --  016842
          (0, 0, 25271, 25271),
         16#43#           =>  --  016843
          (0, 0, 25272, 25272),
         16#44#           =>  --  016844
          (0, 0, 25273, 25273),
         16#45#           =>  --  016845
          (0, 0, 25274, 25274),
         16#46#           =>  --  016846
          (0, 0, 25275, 25275),
         16#47#           =>  --  016847
          (0, 0, 25276, 25276),
         16#48#           =>  --  016848
          (0, 0, 25277, 25277),
         16#49#           =>  --  016849
          (0, 0, 25278, 25278),
         16#4A#           =>  --  01684A
          (0, 0, 25279, 25279),
         16#4B#           =>  --  01684B
          (0, 0, 25280, 25280),
         16#4C#           =>  --  01684C
          (0, 0, 25281, 25281),
         16#4D#           =>  --  01684D
          (0, 0, 25282, 25282),
         16#4E#           =>  --  01684E
          (0, 0, 25283, 25283),
         16#4F#           =>  --  01684F
          (0, 0, 25284, 25284),
         16#50#           =>  --  016850
          (0, 0, 25285, 25285),
         16#51#           =>  --  016851
          (0, 0, 25286, 25286),
         16#52#           =>  --  016852
          (0, 0, 25287, 25287),
         16#53#           =>  --  016853
          (0, 0, 25288, 25288),
         16#54#           =>  --  016854
          (0, 0, 25289, 25289),
         16#55#           =>  --  016855
          (0, 0, 25290, 25290),
         16#56#           =>  --  016856
          (0, 0, 25291, 25291),
         16#57#           =>  --  016857
          (0, 0, 25292, 25292),
         16#58#           =>  --  016858
          (0, 0, 25293, 25293),
         16#59#           =>  --  016859
          (0, 0, 25294, 25294),
         16#5A#           =>  --  01685A
          (0, 0, 25295, 25295),
         16#5B#           =>  --  01685B
          (0, 0, 25296, 25296),
         16#5C#           =>  --  01685C
          (0, 0, 25297, 25297),
         16#5D#           =>  --  01685D
          (0, 0, 25298, 25298),
         16#5E#           =>  --  01685E
          (0, 0, 25299, 25299),
         16#5F#           =>  --  01685F
          (0, 0, 25300, 25300),
         16#60#           =>  --  016860
          (0, 0, 25301, 25301),
         16#61#           =>  --  016861
          (0, 0, 25302, 25302),
         16#62#           =>  --  016862
          (0, 0, 25303, 25303),
         16#63#           =>  --  016863
          (0, 0, 25304, 25304),
         16#64#           =>  --  016864
          (0, 0, 25305, 25305),
         16#65#           =>  --  016865
          (0, 0, 25306, 25306),
         16#66#           =>  --  016866
          (0, 0, 25307, 25307),
         16#67#           =>  --  016867
          (0, 0, 25308, 25308),
         16#68#           =>  --  016868
          (0, 0, 25309, 25309),
         16#69#           =>  --  016869
          (0, 0, 25310, 25310),
         16#6A#           =>  --  01686A
          (0, 0, 25311, 25311),
         16#6B#           =>  --  01686B
          (0, 0, 25312, 25312),
         16#6C#           =>  --  01686C
          (0, 0, 25313, 25313),
         16#6D#           =>  --  01686D
          (0, 0, 25314, 25314),
         16#6E#           =>  --  01686E
          (0, 0, 25315, 25315),
         16#6F#           =>  --  01686F
          (0, 0, 25316, 25316),
         16#70#           =>  --  016870
          (0, 0, 25317, 25317),
         16#71#           =>  --  016871
          (0, 0, 25318, 25318),
         16#72#           =>  --  016872
          (0, 0, 25319, 25319),
         16#73#           =>  --  016873
          (0, 0, 25320, 25320),
         16#74#           =>  --  016874
          (0, 0, 25321, 25321),
         16#75#           =>  --  016875
          (0, 0, 25322, 25322),
         16#76#           =>  --  016876
          (0, 0, 25323, 25323),
         16#77#           =>  --  016877
          (0, 0, 25324, 25324),
         16#78#           =>  --  016878
          (0, 0, 25325, 25325),
         16#79#           =>  --  016879
          (0, 0, 25326, 25326),
         16#7A#           =>  --  01687A
          (0, 0, 25327, 25327),
         16#7B#           =>  --  01687B
          (0, 0, 25328, 25328),
         16#7C#           =>  --  01687C
          (0, 0, 25329, 25329),
         16#7D#           =>  --  01687D
          (0, 0, 25330, 25330),
         16#7E#           =>  --  01687E
          (0, 0, 25331, 25331),
         16#7F#           =>  --  01687F
          (0, 0, 25332, 25332),
         16#80#           =>  --  016880
          (0, 0, 25333, 25333),
         16#81#           =>  --  016881
          (0, 0, 25334, 25334),
         16#82#           =>  --  016882
          (0, 0, 25335, 25335),
         16#83#           =>  --  016883
          (0, 0, 25336, 25336),
         16#84#           =>  --  016884
          (0, 0, 25337, 25337),
         16#85#           =>  --  016885
          (0, 0, 25338, 25338),
         16#86#           =>  --  016886
          (0, 0, 25339, 25339),
         16#87#           =>  --  016887
          (0, 0, 25340, 25340),
         16#88#           =>  --  016888
          (0, 0, 25341, 25341),
         16#89#           =>  --  016889
          (0, 0, 25342, 25342),
         16#8A#           =>  --  01688A
          (0, 0, 25343, 25343),
         16#8B#           =>  --  01688B
          (0, 0, 25344, 25344),
         16#8C#           =>  --  01688C
          (0, 0, 25345, 25345),
         16#8D#           =>  --  01688D
          (0, 0, 25346, 25346),
         16#8E#           =>  --  01688E
          (0, 0, 25347, 25347),
         16#8F#           =>  --  01688F
          (0, 0, 25348, 25348),
         16#90#           =>  --  016890
          (0, 0, 25349, 25349),
         16#91#           =>  --  016891
          (0, 0, 25350, 25350),
         16#92#           =>  --  016892
          (0, 0, 25351, 25351),
         16#93#           =>  --  016893
          (0, 0, 25352, 25352),
         16#94#           =>  --  016894
          (0, 0, 25353, 25353),
         16#95#           =>  --  016895
          (0, 0, 25354, 25354),
         16#96#           =>  --  016896
          (0, 0, 25355, 25355),
         16#97#           =>  --  016897
          (0, 0, 25356, 25356),
         16#98#           =>  --  016898
          (0, 0, 25357, 25357),
         16#99#           =>  --  016899
          (0, 0, 25358, 25358),
         16#9A#           =>  --  01689A
          (0, 0, 25359, 25359),
         16#9B#           =>  --  01689B
          (0, 0, 25360, 25360),
         16#9C#           =>  --  01689C
          (0, 0, 25361, 25361),
         16#9D#           =>  --  01689D
          (0, 0, 25362, 25362),
         16#9E#           =>  --  01689E
          (0, 0, 25363, 25363),
         16#9F#           =>  --  01689F
          (0, 0, 25364, 25364),
         16#A0#           =>  --  0168A0
          (0, 0, 25365, 25365),
         16#A1#           =>  --  0168A1
          (0, 0, 25366, 25366),
         16#A2#           =>  --  0168A2
          (0, 0, 25367, 25367),
         16#A3#           =>  --  0168A3
          (0, 0, 25368, 25368),
         16#A4#           =>  --  0168A4
          (0, 0, 25369, 25369),
         16#A5#           =>  --  0168A5
          (0, 0, 25370, 25370),
         16#A6#           =>  --  0168A6
          (0, 0, 25371, 25371),
         16#A7#           =>  --  0168A7
          (0, 0, 25372, 25372),
         16#A8#           =>  --  0168A8
          (0, 0, 25373, 25373),
         16#A9#           =>  --  0168A9
          (0, 0, 25374, 25374),
         16#AA#           =>  --  0168AA
          (0, 0, 25375, 25375),
         16#AB#           =>  --  0168AB
          (0, 0, 25376, 25376),
         16#AC#           =>  --  0168AC
          (0, 0, 25377, 25377),
         16#AD#           =>  --  0168AD
          (0, 0, 25378, 25378),
         16#AE#           =>  --  0168AE
          (0, 0, 25379, 25379),
         16#AF#           =>  --  0168AF
          (0, 0, 25380, 25380),
         16#B0#           =>  --  0168B0
          (0, 0, 25381, 25381),
         16#B1#           =>  --  0168B1
          (0, 0, 25382, 25382),
         16#B2#           =>  --  0168B2
          (0, 0, 25383, 25383),
         16#B3#           =>  --  0168B3
          (0, 0, 25384, 25384),
         16#B4#           =>  --  0168B4
          (0, 0, 25385, 25385),
         16#B5#           =>  --  0168B5
          (0, 0, 25386, 25386),
         16#B6#           =>  --  0168B6
          (0, 0, 25387, 25387),
         16#B7#           =>  --  0168B7
          (0, 0, 25388, 25388),
         16#B8#           =>  --  0168B8
          (0, 0, 25389, 25389),
         16#B9#           =>  --  0168B9
          (0, 0, 25390, 25390),
         16#BA#           =>  --  0168BA
          (0, 0, 25391, 25391),
         16#BB#           =>  --  0168BB
          (0, 0, 25392, 25392),
         16#BC#           =>  --  0168BC
          (0, 0, 25393, 25393),
         16#BD#           =>  --  0168BD
          (0, 0, 25394, 25394),
         16#BE#           =>  --  0168BE
          (0, 0, 25395, 25395),
         16#BF#           =>  --  0168BF
          (0, 0, 25396, 25396),
         16#C0#           =>  --  0168C0
          (0, 0, 25397, 25397),
         16#C1#           =>  --  0168C1
          (0, 0, 25398, 25398),
         16#C2#           =>  --  0168C2
          (0, 0, 25399, 25399),
         16#C3#           =>  --  0168C3
          (0, 0, 25400, 25400),
         16#C4#           =>  --  0168C4
          (0, 0, 25401, 25401),
         16#C5#           =>  --  0168C5
          (0, 0, 25402, 25402),
         16#C6#           =>  --  0168C6
          (0, 0, 25403, 25403),
         16#C7#           =>  --  0168C7
          (0, 0, 25404, 25404),
         16#C8#           =>  --  0168C8
          (0, 0, 25405, 25405),
         16#C9#           =>  --  0168C9
          (0, 0, 25406, 25406),
         16#CA#           =>  --  0168CA
          (0, 0, 25407, 25407),
         16#CB#           =>  --  0168CB
          (0, 0, 25408, 25408),
         16#CC#           =>  --  0168CC
          (0, 0, 25409, 25409),
         16#CD#           =>  --  0168CD
          (0, 0, 25410, 25410),
         16#CE#           =>  --  0168CE
          (0, 0, 25411, 25411),
         16#CF#           =>  --  0168CF
          (0, 0, 25412, 25412),
         16#D0#           =>  --  0168D0
          (0, 0, 25413, 25413),
         16#D1#           =>  --  0168D1
          (0, 0, 25414, 25414),
         16#D2#           =>  --  0168D2
          (0, 0, 25415, 25415),
         16#D3#           =>  --  0168D3
          (0, 0, 25416, 25416),
         16#D4#           =>  --  0168D4
          (0, 0, 25417, 25417),
         16#D5#           =>  --  0168D5
          (0, 0, 25418, 25418),
         16#D6#           =>  --  0168D6
          (0, 0, 25419, 25419),
         16#D7#           =>  --  0168D7
          (0, 0, 25420, 25420),
         16#D8#           =>  --  0168D8
          (0, 0, 25421, 25421),
         16#D9#           =>  --  0168D9
          (0, 0, 25422, 25422),
         16#DA#           =>  --  0168DA
          (0, 0, 25423, 25423),
         16#DB#           =>  --  0168DB
          (0, 0, 25424, 25424),
         16#DC#           =>  --  0168DC
          (0, 0, 25425, 25425),
         16#DD#           =>  --  0168DD
          (0, 0, 25426, 25426),
         16#DE#           =>  --  0168DE
          (0, 0, 25427, 25427),
         16#DF#           =>  --  0168DF
          (0, 0, 25428, 25428),
         16#E0#           =>  --  0168E0
          (0, 0, 25429, 25429),
         16#E1#           =>  --  0168E1
          (0, 0, 25430, 25430),
         16#E2#           =>  --  0168E2
          (0, 0, 25431, 25431),
         16#E3#           =>  --  0168E3
          (0, 0, 25432, 25432),
         16#E4#           =>  --  0168E4
          (0, 0, 25433, 25433),
         16#E5#           =>  --  0168E5
          (0, 0, 25434, 25434),
         16#E6#           =>  --  0168E6
          (0, 0, 25435, 25435),
         16#E7#           =>  --  0168E7
          (0, 0, 25436, 25436),
         16#E8#           =>  --  0168E8
          (0, 0, 25437, 25437),
         16#E9#           =>  --  0168E9
          (0, 0, 25438, 25438),
         16#EA#           =>  --  0168EA
          (0, 0, 25439, 25439),
         16#EB#           =>  --  0168EB
          (0, 0, 25440, 25440),
         16#EC#           =>  --  0168EC
          (0, 0, 25441, 25441),
         16#ED#           =>  --  0168ED
          (0, 0, 25442, 25442),
         16#EE#           =>  --  0168EE
          (0, 0, 25443, 25443),
         16#EF#           =>  --  0168EF
          (0, 0, 25444, 25444),
         16#F0#           =>  --  0168F0
          (0, 0, 25445, 25445),
         16#F1#           =>  --  0168F1
          (0, 0, 25446, 25446),
         16#F2#           =>  --  0168F2
          (0, 0, 25447, 25447),
         16#F3#           =>  --  0168F3
          (0, 0, 25448, 25448),
         16#F4#           =>  --  0168F4
          (0, 0, 25449, 25449),
         16#F5#           =>  --  0168F5
          (0, 0, 25450, 25450),
         16#F6#           =>  --  0168F6
          (0, 0, 25451, 25451),
         16#F7#           =>  --  0168F7
          (0, 0, 25452, 25452),
         16#F8#           =>  --  0168F8
          (0, 0, 25453, 25453),
         16#F9#           =>  --  0168F9
          (0, 0, 25454, 25454),
         16#FA#           =>  --  0168FA
          (0, 0, 25455, 25455),
         16#FB#           =>  --  0168FB
          (0, 0, 25456, 25456),
         16#FC#           =>  --  0168FC
          (0, 0, 25457, 25457),
         16#FD#           =>  --  0168FD
          (0, 0, 25458, 25458),
         16#FE#           =>  --  0168FE
          (0, 0, 25459, 25459),
         16#FF#           =>  --  0168FF
          (0, 0, 25460, 25460),
         others           =>
          (0, 0, 0, 0));

   Group_0169 : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  016900
          (0, 0, 25461, 25461),
         16#01#           =>  --  016901
          (0, 0, 25462, 25462),
         16#02#           =>  --  016902
          (0, 0, 25463, 25463),
         16#03#           =>  --  016903
          (0, 0, 25464, 25464),
         16#04#           =>  --  016904
          (0, 0, 25465, 25465),
         16#05#           =>  --  016905
          (0, 0, 25466, 25466),
         16#06#           =>  --  016906
          (0, 0, 25467, 25467),
         16#07#           =>  --  016907
          (0, 0, 25468, 25468),
         16#08#           =>  --  016908
          (0, 0, 25469, 25469),
         16#09#           =>  --  016909
          (0, 0, 25470, 25470),
         16#0A#           =>  --  01690A
          (0, 0, 25471, 25471),
         16#0B#           =>  --  01690B
          (0, 0, 25472, 25472),
         16#0C#           =>  --  01690C
          (0, 0, 25473, 25473),
         16#0D#           =>  --  01690D
          (0, 0, 25474, 25474),
         16#0E#           =>  --  01690E
          (0, 0, 25475, 25475),
         16#0F#           =>  --  01690F
          (0, 0, 25476, 25476),
         16#10#           =>  --  016910
          (0, 0, 25477, 25477),
         16#11#           =>  --  016911
          (0, 0, 25478, 25478),
         16#12#           =>  --  016912
          (0, 0, 25479, 25479),
         16#13#           =>  --  016913
          (0, 0, 25480, 25480),
         16#14#           =>  --  016914
          (0, 0, 25481, 25481),
         16#15#           =>  --  016915
          (0, 0, 25482, 25482),
         16#16#           =>  --  016916
          (0, 0, 25483, 25483),
         16#17#           =>  --  016917
          (0, 0, 25484, 25484),
         16#18#           =>  --  016918
          (0, 0, 25485, 25485),
         16#19#           =>  --  016919
          (0, 0, 25486, 25486),
         16#1A#           =>  --  01691A
          (0, 0, 25487, 25487),
         16#1B#           =>  --  01691B
          (0, 0, 25488, 25488),
         16#1C#           =>  --  01691C
          (0, 0, 25489, 25489),
         16#1D#           =>  --  01691D
          (0, 0, 25490, 25490),
         16#1E#           =>  --  01691E
          (0, 0, 25491, 25491),
         16#1F#           =>  --  01691F
          (0, 0, 25492, 25492),
         16#20#           =>  --  016920
          (0, 0, 25493, 25493),
         16#21#           =>  --  016921
          (0, 0, 25494, 25494),
         16#22#           =>  --  016922
          (0, 0, 25495, 25495),
         16#23#           =>  --  016923
          (0, 0, 25496, 25496),
         16#24#           =>  --  016924
          (0, 0, 25497, 25497),
         16#25#           =>  --  016925
          (0, 0, 25498, 25498),
         16#26#           =>  --  016926
          (0, 0, 25499, 25499),
         16#27#           =>  --  016927
          (0, 0, 25500, 25500),
         16#28#           =>  --  016928
          (0, 0, 25501, 25501),
         16#29#           =>  --  016929
          (0, 0, 25502, 25502),
         16#2A#           =>  --  01692A
          (0, 0, 25503, 25503),
         16#2B#           =>  --  01692B
          (0, 0, 25504, 25504),
         16#2C#           =>  --  01692C
          (0, 0, 25505, 25505),
         16#2D#           =>  --  01692D
          (0, 0, 25506, 25506),
         16#2E#           =>  --  01692E
          (0, 0, 25507, 25507),
         16#2F#           =>  --  01692F
          (0, 0, 25508, 25508),
         16#30#           =>  --  016930
          (0, 0, 25509, 25509),
         16#31#           =>  --  016931
          (0, 0, 25510, 25510),
         16#32#           =>  --  016932
          (0, 0, 25511, 25511),
         16#33#           =>  --  016933
          (0, 0, 25512, 25512),
         16#34#           =>  --  016934
          (0, 0, 25513, 25513),
         16#35#           =>  --  016935
          (0, 0, 25514, 25514),
         16#36#           =>  --  016936
          (0, 0, 25515, 25515),
         16#37#           =>  --  016937
          (0, 0, 25516, 25516),
         16#38#           =>  --  016938
          (0, 0, 25517, 25517),
         16#39#           =>  --  016939
          (0, 0, 25518, 25518),
         16#3A#           =>  --  01693A
          (0, 0, 25519, 25519),
         16#3B#           =>  --  01693B
          (0, 0, 25520, 25520),
         16#3C#           =>  --  01693C
          (0, 0, 25521, 25521),
         16#3D#           =>  --  01693D
          (0, 0, 25522, 25522),
         16#3E#           =>  --  01693E
          (0, 0, 25523, 25523),
         16#3F#           =>  --  01693F
          (0, 0, 25524, 25524),
         16#40#           =>  --  016940
          (0, 0, 25525, 25525),
         16#41#           =>  --  016941
          (0, 0, 25526, 25526),
         16#42#           =>  --  016942
          (0, 0, 25527, 25527),
         16#43#           =>  --  016943
          (0, 0, 25528, 25528),
         16#44#           =>  --  016944
          (0, 0, 25529, 25529),
         16#45#           =>  --  016945
          (0, 0, 25530, 25530),
         16#46#           =>  --  016946
          (0, 0, 25531, 25531),
         16#47#           =>  --  016947
          (0, 0, 25532, 25532),
         16#48#           =>  --  016948
          (0, 0, 25533, 25533),
         16#49#           =>  --  016949
          (0, 0, 25534, 25534),
         16#4A#           =>  --  01694A
          (0, 0, 25535, 25535),
         16#4B#           =>  --  01694B
          (0, 0, 25536, 25536),
         16#4C#           =>  --  01694C
          (0, 0, 25537, 25537),
         16#4D#           =>  --  01694D
          (0, 0, 25538, 25538),
         16#4E#           =>  --  01694E
          (0, 0, 25539, 25539),
         16#4F#           =>  --  01694F
          (0, 0, 25540, 25540),
         16#50#           =>  --  016950
          (0, 0, 25541, 25541),
         16#51#           =>  --  016951
          (0, 0, 25542, 25542),
         16#52#           =>  --  016952
          (0, 0, 25543, 25543),
         16#53#           =>  --  016953
          (0, 0, 25544, 25544),
         16#54#           =>  --  016954
          (0, 0, 25545, 25545),
         16#55#           =>  --  016955
          (0, 0, 25546, 25546),
         16#56#           =>  --  016956
          (0, 0, 25547, 25547),
         16#57#           =>  --  016957
          (0, 0, 25548, 25548),
         16#58#           =>  --  016958
          (0, 0, 25549, 25549),
         16#59#           =>  --  016959
          (0, 0, 25550, 25550),
         16#5A#           =>  --  01695A
          (0, 0, 25551, 25551),
         16#5B#           =>  --  01695B
          (0, 0, 25552, 25552),
         16#5C#           =>  --  01695C
          (0, 0, 25553, 25553),
         16#5D#           =>  --  01695D
          (0, 0, 25554, 25554),
         16#5E#           =>  --  01695E
          (0, 0, 25555, 25555),
         16#5F#           =>  --  01695F
          (0, 0, 25556, 25556),
         16#60#           =>  --  016960
          (0, 0, 25557, 25557),
         16#61#           =>  --  016961
          (0, 0, 25558, 25558),
         16#62#           =>  --  016962
          (0, 0, 25559, 25559),
         16#63#           =>  --  016963
          (0, 0, 25560, 25560),
         16#64#           =>  --  016964
          (0, 0, 25561, 25561),
         16#65#           =>  --  016965
          (0, 0, 25562, 25562),
         16#66#           =>  --  016966
          (0, 0, 25563, 25563),
         16#67#           =>  --  016967
          (0, 0, 25564, 25564),
         16#68#           =>  --  016968
          (0, 0, 25565, 25565),
         16#69#           =>  --  016969
          (0, 0, 25566, 25566),
         16#6A#           =>  --  01696A
          (0, 0, 25567, 25567),
         16#6B#           =>  --  01696B
          (0, 0, 25568, 25568),
         16#6C#           =>  --  01696C
          (0, 0, 25569, 25569),
         16#6D#           =>  --  01696D
          (0, 0, 25570, 25570),
         16#6E#           =>  --  01696E
          (0, 0, 25571, 25571),
         16#6F#           =>  --  01696F
          (0, 0, 25572, 25572),
         16#70#           =>  --  016970
          (0, 0, 25573, 25573),
         16#71#           =>  --  016971
          (0, 0, 25574, 25574),
         16#72#           =>  --  016972
          (0, 0, 25575, 25575),
         16#73#           =>  --  016973
          (0, 0, 25576, 25576),
         16#74#           =>  --  016974
          (0, 0, 25577, 25577),
         16#75#           =>  --  016975
          (0, 0, 25578, 25578),
         16#76#           =>  --  016976
          (0, 0, 25579, 25579),
         16#77#           =>  --  016977
          (0, 0, 25580, 25580),
         16#78#           =>  --  016978
          (0, 0, 25581, 25581),
         16#79#           =>  --  016979
          (0, 0, 25582, 25582),
         16#7A#           =>  --  01697A
          (0, 0, 25583, 25583),
         16#7B#           =>  --  01697B
          (0, 0, 25584, 25584),
         16#7C#           =>  --  01697C
          (0, 0, 25585, 25585),
         16#7D#           =>  --  01697D
          (0, 0, 25586, 25586),
         16#7E#           =>  --  01697E
          (0, 0, 25587, 25587),
         16#7F#           =>  --  01697F
          (0, 0, 25588, 25588),
         16#80#           =>  --  016980
          (0, 0, 25589, 25589),
         16#81#           =>  --  016981
          (0, 0, 25590, 25590),
         16#82#           =>  --  016982
          (0, 0, 25591, 25591),
         16#83#           =>  --  016983
          (0, 0, 25592, 25592),
         16#84#           =>  --  016984
          (0, 0, 25593, 25593),
         16#85#           =>  --  016985
          (0, 0, 25594, 25594),
         16#86#           =>  --  016986
          (0, 0, 25595, 25595),
         16#87#           =>  --  016987
          (0, 0, 25596, 25596),
         16#88#           =>  --  016988
          (0, 0, 25597, 25597),
         16#89#           =>  --  016989
          (0, 0, 25598, 25598),
         16#8A#           =>  --  01698A
          (0, 0, 25599, 25599),
         16#8B#           =>  --  01698B
          (0, 0, 25600, 25600),
         16#8C#           =>  --  01698C
          (0, 0, 25601, 25601),
         16#8D#           =>  --  01698D
          (0, 0, 25602, 25602),
         16#8E#           =>  --  01698E
          (0, 0, 25603, 25603),
         16#8F#           =>  --  01698F
          (0, 0, 25604, 25604),
         16#90#           =>  --  016990
          (0, 0, 25605, 25605),
         16#91#           =>  --  016991
          (0, 0, 25606, 25606),
         16#92#           =>  --  016992
          (0, 0, 25607, 25607),
         16#93#           =>  --  016993
          (0, 0, 25608, 25608),
         16#94#           =>  --  016994
          (0, 0, 25609, 25609),
         16#95#           =>  --  016995
          (0, 0, 25610, 25610),
         16#96#           =>  --  016996
          (0, 0, 25611, 25611),
         16#97#           =>  --  016997
          (0, 0, 25612, 25612),
         16#98#           =>  --  016998
          (0, 0, 25613, 25613),
         16#99#           =>  --  016999
          (0, 0, 25614, 25614),
         16#9A#           =>  --  01699A
          (0, 0, 25615, 25615),
         16#9B#           =>  --  01699B
          (0, 0, 25616, 25616),
         16#9C#           =>  --  01699C
          (0, 0, 25617, 25617),
         16#9D#           =>  --  01699D
          (0, 0, 25618, 25618),
         16#9E#           =>  --  01699E
          (0, 0, 25619, 25619),
         16#9F#           =>  --  01699F
          (0, 0, 25620, 25620),
         16#A0#           =>  --  0169A0
          (0, 0, 25621, 25621),
         16#A1#           =>  --  0169A1
          (0, 0, 25622, 25622),
         16#A2#           =>  --  0169A2
          (0, 0, 25623, 25623),
         16#A3#           =>  --  0169A3
          (0, 0, 25624, 25624),
         16#A4#           =>  --  0169A4
          (0, 0, 25625, 25625),
         16#A5#           =>  --  0169A5
          (0, 0, 25626, 25626),
         16#A6#           =>  --  0169A6
          (0, 0, 25627, 25627),
         16#A7#           =>  --  0169A7
          (0, 0, 25628, 25628),
         16#A8#           =>  --  0169A8
          (0, 0, 25629, 25629),
         16#A9#           =>  --  0169A9
          (0, 0, 25630, 25630),
         16#AA#           =>  --  0169AA
          (0, 0, 25631, 25631),
         16#AB#           =>  --  0169AB
          (0, 0, 25632, 25632),
         16#AC#           =>  --  0169AC
          (0, 0, 25633, 25633),
         16#AD#           =>  --  0169AD
          (0, 0, 25634, 25634),
         16#AE#           =>  --  0169AE
          (0, 0, 25635, 25635),
         16#AF#           =>  --  0169AF
          (0, 0, 25636, 25636),
         16#B0#           =>  --  0169B0
          (0, 0, 25637, 25637),
         16#B1#           =>  --  0169B1
          (0, 0, 25638, 25638),
         16#B2#           =>  --  0169B2
          (0, 0, 25639, 25639),
         16#B3#           =>  --  0169B3
          (0, 0, 25640, 25640),
         16#B4#           =>  --  0169B4
          (0, 0, 25641, 25641),
         16#B5#           =>  --  0169B5
          (0, 0, 25642, 25642),
         16#B6#           =>  --  0169B6
          (0, 0, 25643, 25643),
         16#B7#           =>  --  0169B7
          (0, 0, 25644, 25644),
         16#B8#           =>  --  0169B8
          (0, 0, 25645, 25645),
         16#B9#           =>  --  0169B9
          (0, 0, 25646, 25646),
         16#BA#           =>  --  0169BA
          (0, 0, 25647, 25647),
         16#BB#           =>  --  0169BB
          (0, 0, 25648, 25648),
         16#BC#           =>  --  0169BC
          (0, 0, 25649, 25649),
         16#BD#           =>  --  0169BD
          (0, 0, 25650, 25650),
         16#BE#           =>  --  0169BE
          (0, 0, 25651, 25651),
         16#BF#           =>  --  0169BF
          (0, 0, 25652, 25652),
         16#C0#           =>  --  0169C0
          (0, 0, 25653, 25653),
         16#C1#           =>  --  0169C1
          (0, 0, 25654, 25654),
         16#C2#           =>  --  0169C2
          (0, 0, 25655, 25655),
         16#C3#           =>  --  0169C3
          (0, 0, 25656, 25656),
         16#C4#           =>  --  0169C4
          (0, 0, 25657, 25657),
         16#C5#           =>  --  0169C5
          (0, 0, 25658, 25658),
         16#C6#           =>  --  0169C6
          (0, 0, 25659, 25659),
         16#C7#           =>  --  0169C7
          (0, 0, 25660, 25660),
         16#C8#           =>  --  0169C8
          (0, 0, 25661, 25661),
         16#C9#           =>  --  0169C9
          (0, 0, 25662, 25662),
         16#CA#           =>  --  0169CA
          (0, 0, 25663, 25663),
         16#CB#           =>  --  0169CB
          (0, 0, 25664, 25664),
         16#CC#           =>  --  0169CC
          (0, 0, 25665, 25665),
         16#CD#           =>  --  0169CD
          (0, 0, 25666, 25666),
         16#CE#           =>  --  0169CE
          (0, 0, 25667, 25667),
         16#CF#           =>  --  0169CF
          (0, 0, 25668, 25668),
         16#D0#           =>  --  0169D0
          (0, 0, 25669, 25669),
         16#D1#           =>  --  0169D1
          (0, 0, 25670, 25670),
         16#D2#           =>  --  0169D2
          (0, 0, 25671, 25671),
         16#D3#           =>  --  0169D3
          (0, 0, 25672, 25672),
         16#D4#           =>  --  0169D4
          (0, 0, 25673, 25673),
         16#D5#           =>  --  0169D5
          (0, 0, 25674, 25674),
         16#D6#           =>  --  0169D6
          (0, 0, 25675, 25675),
         16#D7#           =>  --  0169D7
          (0, 0, 25676, 25676),
         16#D8#           =>  --  0169D8
          (0, 0, 25677, 25677),
         16#D9#           =>  --  0169D9
          (0, 0, 25678, 25678),
         16#DA#           =>  --  0169DA
          (0, 0, 25679, 25679),
         16#DB#           =>  --  0169DB
          (0, 0, 25680, 25680),
         16#DC#           =>  --  0169DC
          (0, 0, 25681, 25681),
         16#DD#           =>  --  0169DD
          (0, 0, 25682, 25682),
         16#DE#           =>  --  0169DE
          (0, 0, 25683, 25683),
         16#DF#           =>  --  0169DF
          (0, 0, 25684, 25684),
         16#E0#           =>  --  0169E0
          (0, 0, 25685, 25685),
         16#E1#           =>  --  0169E1
          (0, 0, 25686, 25686),
         16#E2#           =>  --  0169E2
          (0, 0, 25687, 25687),
         16#E3#           =>  --  0169E3
          (0, 0, 25688, 25688),
         16#E4#           =>  --  0169E4
          (0, 0, 25689, 25689),
         16#E5#           =>  --  0169E5
          (0, 0, 25690, 25690),
         16#E6#           =>  --  0169E6
          (0, 0, 25691, 25691),
         16#E7#           =>  --  0169E7
          (0, 0, 25692, 25692),
         16#E8#           =>  --  0169E8
          (0, 0, 25693, 25693),
         16#E9#           =>  --  0169E9
          (0, 0, 25694, 25694),
         16#EA#           =>  --  0169EA
          (0, 0, 25695, 25695),
         16#EB#           =>  --  0169EB
          (0, 0, 25696, 25696),
         16#EC#           =>  --  0169EC
          (0, 0, 25697, 25697),
         16#ED#           =>  --  0169ED
          (0, 0, 25698, 25698),
         16#EE#           =>  --  0169EE
          (0, 0, 25699, 25699),
         16#EF#           =>  --  0169EF
          (0, 0, 25700, 25700),
         16#F0#           =>  --  0169F0
          (0, 0, 25701, 25701),
         16#F1#           =>  --  0169F1
          (0, 0, 25702, 25702),
         16#F2#           =>  --  0169F2
          (0, 0, 25703, 25703),
         16#F3#           =>  --  0169F3
          (0, 0, 25704, 25704),
         16#F4#           =>  --  0169F4
          (0, 0, 25705, 25705),
         16#F5#           =>  --  0169F5
          (0, 0, 25706, 25706),
         16#F6#           =>  --  0169F6
          (0, 0, 25707, 25707),
         16#F7#           =>  --  0169F7
          (0, 0, 25708, 25708),
         16#F8#           =>  --  0169F8
          (0, 0, 25709, 25709),
         16#F9#           =>  --  0169F9
          (0, 0, 25710, 25710),
         16#FA#           =>  --  0169FA
          (0, 0, 25711, 25711),
         16#FB#           =>  --  0169FB
          (0, 0, 25712, 25712),
         16#FC#           =>  --  0169FC
          (0, 0, 25713, 25713),
         16#FD#           =>  --  0169FD
          (0, 0, 25714, 25714),
         16#FE#           =>  --  0169FE
          (0, 0, 25715, 25715),
         16#FF#           =>  --  0169FF
          (0, 0, 25716, 25716),
         others           =>
          (0, 0, 0, 0));

   Group_016A : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  016A00
          (0, 0, 25717, 25717),
         16#01#           =>  --  016A01
          (0, 0, 25718, 25718),
         16#02#           =>  --  016A02
          (0, 0, 25719, 25719),
         16#03#           =>  --  016A03
          (0, 0, 25720, 25720),
         16#04#           =>  --  016A04
          (0, 0, 25721, 25721),
         16#05#           =>  --  016A05
          (0, 0, 25722, 25722),
         16#06#           =>  --  016A06
          (0, 0, 25723, 25723),
         16#07#           =>  --  016A07
          (0, 0, 25724, 25724),
         16#08#           =>  --  016A08
          (0, 0, 25725, 25725),
         16#09#           =>  --  016A09
          (0, 0, 25726, 25726),
         16#0A#           =>  --  016A0A
          (0, 0, 25727, 25727),
         16#0B#           =>  --  016A0B
          (0, 0, 25728, 25728),
         16#0C#           =>  --  016A0C
          (0, 0, 25729, 25729),
         16#0D#           =>  --  016A0D
          (0, 0, 25730, 25730),
         16#0E#           =>  --  016A0E
          (0, 0, 25731, 25731),
         16#0F#           =>  --  016A0F
          (0, 0, 25732, 25732),
         16#10#           =>  --  016A10
          (0, 0, 25733, 25733),
         16#11#           =>  --  016A11
          (0, 0, 25734, 25734),
         16#12#           =>  --  016A12
          (0, 0, 25735, 25735),
         16#13#           =>  --  016A13
          (0, 0, 25736, 25736),
         16#14#           =>  --  016A14
          (0, 0, 25737, 25737),
         16#15#           =>  --  016A15
          (0, 0, 25738, 25738),
         16#16#           =>  --  016A16
          (0, 0, 25739, 25739),
         16#17#           =>  --  016A17
          (0, 0, 25740, 25740),
         16#18#           =>  --  016A18
          (0, 0, 25741, 25741),
         16#19#           =>  --  016A19
          (0, 0, 25742, 25742),
         16#1A#           =>  --  016A1A
          (0, 0, 25743, 25743),
         16#1B#           =>  --  016A1B
          (0, 0, 25744, 25744),
         16#1C#           =>  --  016A1C
          (0, 0, 25745, 25745),
         16#1D#           =>  --  016A1D
          (0, 0, 25746, 25746),
         16#1E#           =>  --  016A1E
          (0, 0, 25747, 25747),
         16#1F#           =>  --  016A1F
          (0, 0, 25748, 25748),
         16#20#           =>  --  016A20
          (0, 0, 25749, 25749),
         16#21#           =>  --  016A21
          (0, 0, 25750, 25750),
         16#22#           =>  --  016A22
          (0, 0, 25751, 25751),
         16#23#           =>  --  016A23
          (0, 0, 25752, 25752),
         16#24#           =>  --  016A24
          (0, 0, 25753, 25753),
         16#25#           =>  --  016A25
          (0, 0, 25754, 25754),
         16#26#           =>  --  016A26
          (0, 0, 25755, 25755),
         16#27#           =>  --  016A27
          (0, 0, 25756, 25756),
         16#28#           =>  --  016A28
          (0, 0, 25757, 25757),
         16#29#           =>  --  016A29
          (0, 0, 25758, 25758),
         16#2A#           =>  --  016A2A
          (0, 0, 25759, 25759),
         16#2B#           =>  --  016A2B
          (0, 0, 25760, 25760),
         16#2C#           =>  --  016A2C
          (0, 0, 25761, 25761),
         16#2D#           =>  --  016A2D
          (0, 0, 25762, 25762),
         16#2E#           =>  --  016A2E
          (0, 0, 25763, 25763),
         16#2F#           =>  --  016A2F
          (0, 0, 25764, 25764),
         16#30#           =>  --  016A30
          (0, 0, 25765, 25765),
         16#31#           =>  --  016A31
          (0, 0, 25766, 25766),
         16#32#           =>  --  016A32
          (0, 0, 25767, 25767),
         16#33#           =>  --  016A33
          (0, 0, 25768, 25768),
         16#34#           =>  --  016A34
          (0, 0, 25769, 25769),
         16#35#           =>  --  016A35
          (0, 0, 25770, 25770),
         16#36#           =>  --  016A36
          (0, 0, 25771, 25771),
         16#37#           =>  --  016A37
          (0, 0, 25772, 25772),
         16#38#           =>  --  016A38
          (0, 0, 25773, 25773),
         16#40#           =>  --  016A40
          (0, 0, 25774, 25774),
         16#41#           =>  --  016A41
          (0, 0, 25775, 25775),
         16#42#           =>  --  016A42
          (0, 0, 25776, 25776),
         16#43#           =>  --  016A43
          (0, 0, 25777, 25777),
         16#44#           =>  --  016A44
          (0, 0, 25778, 25778),
         16#45#           =>  --  016A45
          (0, 0, 25779, 25779),
         16#46#           =>  --  016A46
          (0, 0, 25780, 25780),
         16#47#           =>  --  016A47
          (0, 0, 25781, 25781),
         16#48#           =>  --  016A48
          (0, 0, 25782, 25782),
         16#49#           =>  --  016A49
          (0, 0, 25783, 25783),
         16#4A#           =>  --  016A4A
          (0, 0, 25784, 25784),
         16#4B#           =>  --  016A4B
          (0, 0, 25785, 25785),
         16#4C#           =>  --  016A4C
          (0, 0, 25786, 25786),
         16#4D#           =>  --  016A4D
          (0, 0, 25787, 25787),
         16#4E#           =>  --  016A4E
          (0, 0, 25788, 25788),
         16#4F#           =>  --  016A4F
          (0, 0, 25789, 25789),
         16#50#           =>  --  016A50
          (0, 0, 25790, 25790),
         16#51#           =>  --  016A51
          (0, 0, 25791, 25791),
         16#52#           =>  --  016A52
          (0, 0, 25792, 25792),
         16#53#           =>  --  016A53
          (0, 0, 25793, 25793),
         16#54#           =>  --  016A54
          (0, 0, 25794, 25794),
         16#55#           =>  --  016A55
          (0, 0, 25795, 25795),
         16#56#           =>  --  016A56
          (0, 0, 25796, 25796),
         16#57#           =>  --  016A57
          (0, 0, 25797, 25797),
         16#58#           =>  --  016A58
          (0, 0, 25798, 25798),
         16#59#           =>  --  016A59
          (0, 0, 25799, 25799),
         16#5A#           =>  --  016A5A
          (0, 0, 25800, 25800),
         16#5B#           =>  --  016A5B
          (0, 0, 25801, 25801),
         16#5C#           =>  --  016A5C
          (0, 0, 25802, 25802),
         16#5D#           =>  --  016A5D
          (0, 0, 25803, 25803),
         16#5E#           =>  --  016A5E
          (0, 0, 25804, 25804),
         16#60#           =>  --  016A60
          (0, 0, 23, 23),
         16#61#           =>  --  016A61
          (0, 0, 24, 24),
         16#62#           =>  --  016A62
          (0, 0, 25, 25),
         16#63#           =>  --  016A63
          (0, 0, 26, 26),
         16#64#           =>  --  016A64
          (0, 0, 27, 27),
         16#65#           =>  --  016A65
          (0, 0, 28, 28),
         16#66#           =>  --  016A66
          (0, 0, 29, 29),
         16#67#           =>  --  016A67
          (0, 0, 30, 30),
         16#68#           =>  --  016A68
          (0, 0, 31, 31),
         16#69#           =>  --  016A69
          (0, 0, 32, 32),
         16#6E#           =>  --  016A6E
          (0, 0, 25805, 25805),
         16#6F#           =>  --  016A6F
          (0, 0, 25806, 25806),
         16#D0#           =>  --  016AD0
          (0, 0, 25807, 25807),
         16#D1#           =>  --  016AD1
          (0, 0, 25808, 25808),
         16#D2#           =>  --  016AD2
          (0, 0, 25809, 25809),
         16#D3#           =>  --  016AD3
          (0, 0, 25810, 25810),
         16#D4#           =>  --  016AD4
          (0, 0, 25811, 25811),
         16#D5#           =>  --  016AD5
          (0, 0, 25812, 25812),
         16#D6#           =>  --  016AD6
          (0, 0, 25813, 25813),
         16#D7#           =>  --  016AD7
          (0, 0, 25814, 25814),
         16#D8#           =>  --  016AD8
          (0, 0, 25815, 25815),
         16#D9#           =>  --  016AD9
          (0, 0, 25816, 25816),
         16#DA#           =>  --  016ADA
          (0, 0, 25817, 25817),
         16#DB#           =>  --  016ADB
          (0, 0, 25818, 25818),
         16#DC#           =>  --  016ADC
          (0, 0, 25819, 25819),
         16#DD#           =>  --  016ADD
          (0, 0, 25820, 25820),
         16#DE#           =>  --  016ADE
          (0, 0, 25821, 25821),
         16#DF#           =>  --  016ADF
          (0, 0, 25822, 25822),
         16#E0#           =>  --  016AE0
          (0, 0, 25823, 25823),
         16#E1#           =>  --  016AE1
          (0, 0, 25824, 25824),
         16#E2#           =>  --  016AE2
          (0, 0, 25825, 25825),
         16#E3#           =>  --  016AE3
          (0, 0, 25826, 25826),
         16#E4#           =>  --  016AE4
          (0, 0, 25827, 25827),
         16#E5#           =>  --  016AE5
          (0, 0, 25828, 25828),
         16#E6#           =>  --  016AE6
          (0, 0, 25829, 25829),
         16#E7#           =>  --  016AE7
          (0, 0, 25830, 25830),
         16#E8#           =>  --  016AE8
          (0, 0, 25831, 25831),
         16#E9#           =>  --  016AE9
          (0, 0, 25832, 25832),
         16#EA#           =>  --  016AEA
          (0, 0, 25833, 25833),
         16#EB#           =>  --  016AEB
          (0, 0, 25834, 25834),
         16#EC#           =>  --  016AEC
          (0, 0, 25835, 25835),
         16#ED#           =>  --  016AED
          (0, 0, 25836, 25836),
         16#F0#           =>  --  016AF0
          (0, 0, 25837, 25837),
         16#F1#           =>  --  016AF1
          (0, 0, 25838, 25838),
         16#F2#           =>  --  016AF2
          (0, 0, 25839, 25839),
         16#F3#           =>  --  016AF3
          (0, 0, 25840, 25840),
         16#F4#           =>  --  016AF4
          (0, 0, 25841, 25841),
         16#F5#           =>  --  016AF5
          (0, 0, 25842, 25842),
         others           =>
          (0, 0, 0, 0));

   Group_016B : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  016B00
          (0, 0, 25843, 25843),
         16#01#           =>  --  016B01
          (0, 0, 25844, 25844),
         16#02#           =>  --  016B02
          (0, 0, 25845, 25845),
         16#03#           =>  --  016B03
          (0, 0, 25846, 25846),
         16#04#           =>  --  016B04
          (0, 0, 25847, 25847),
         16#05#           =>  --  016B05
          (0, 0, 25848, 25848),
         16#06#           =>  --  016B06
          (0, 0, 25849, 25849),
         16#07#           =>  --  016B07
          (0, 0, 25850, 25850),
         16#08#           =>  --  016B08
          (0, 0, 25851, 25851),
         16#09#           =>  --  016B09
          (0, 0, 25852, 25852),
         16#0A#           =>  --  016B0A
          (0, 0, 25853, 25853),
         16#0B#           =>  --  016B0B
          (0, 0, 25854, 25854),
         16#0C#           =>  --  016B0C
          (0, 0, 25855, 25855),
         16#0D#           =>  --  016B0D
          (0, 0, 25856, 25856),
         16#0E#           =>  --  016B0E
          (0, 0, 25857, 25857),
         16#0F#           =>  --  016B0F
          (0, 0, 25858, 25858),
         16#10#           =>  --  016B10
          (0, 0, 25859, 25859),
         16#11#           =>  --  016B11
          (0, 0, 25860, 25860),
         16#12#           =>  --  016B12
          (0, 0, 25861, 25861),
         16#13#           =>  --  016B13
          (0, 0, 25862, 25862),
         16#14#           =>  --  016B14
          (0, 0, 25863, 25863),
         16#15#           =>  --  016B15
          (0, 0, 25864, 25864),
         16#16#           =>  --  016B16
          (0, 0, 25865, 25865),
         16#17#           =>  --  016B17
          (0, 0, 25866, 25866),
         16#18#           =>  --  016B18
          (0, 0, 25867, 25867),
         16#19#           =>  --  016B19
          (0, 0, 25868, 25868),
         16#1A#           =>  --  016B1A
          (0, 0, 25869, 25869),
         16#1B#           =>  --  016B1B
          (0, 0, 25870, 25870),
         16#1C#           =>  --  016B1C
          (0, 0, 25871, 25871),
         16#1D#           =>  --  016B1D
          (0, 0, 25872, 25872),
         16#1E#           =>  --  016B1E
          (0, 0, 25873, 25873),
         16#1F#           =>  --  016B1F
          (0, 0, 25874, 25874),
         16#20#           =>  --  016B20
          (0, 0, 25875, 25875),
         16#21#           =>  --  016B21
          (0, 0, 25876, 25876),
         16#22#           =>  --  016B22
          (0, 0, 25877, 25877),
         16#23#           =>  --  016B23
          (0, 0, 25878, 25878),
         16#24#           =>  --  016B24
          (0, 0, 25879, 25879),
         16#25#           =>  --  016B25
          (0, 0, 25880, 25880),
         16#26#           =>  --  016B26
          (0, 0, 25881, 25881),
         16#27#           =>  --  016B27
          (0, 0, 25882, 25882),
         16#28#           =>  --  016B28
          (0, 0, 25883, 25883),
         16#29#           =>  --  016B29
          (0, 0, 25884, 25884),
         16#2A#           =>  --  016B2A
          (0, 0, 25885, 25885),
         16#2B#           =>  --  016B2B
          (0, 0, 25886, 25886),
         16#2C#           =>  --  016B2C
          (0, 0, 25887, 25887),
         16#2D#           =>  --  016B2D
          (0, 0, 25888, 25888),
         16#2E#           =>  --  016B2E
          (0, 0, 25889, 25889),
         16#2F#           =>  --  016B2F
          (0, 0, 25890, 25890),
         16#30#           =>  --  016B30
          (0, 0, 25891, 25891),
         16#31#           =>  --  016B31
          (0, 0, 25892, 25892),
         16#32#           =>  --  016B32
          (0, 0, 25893, 25893),
         16#33#           =>  --  016B33
          (0, 0, 25894, 25894),
         16#34#           =>  --  016B34
          (0, 0, 25895, 25895),
         16#35#           =>  --  016B35
          (0, 0, 25896, 25896),
         16#36#           =>  --  016B36
          (0, 0, 25897, 25897),
         16#37#           =>  --  016B37
          (0, 0, 25898, 25898),
         16#38#           =>  --  016B38
          (0, 0, 25899, 25899),
         16#39#           =>  --  016B39
          (0, 0, 25900, 25900),
         16#3A#           =>  --  016B3A
          (0, 0, 25901, 25901),
         16#3B#           =>  --  016B3B
          (0, 0, 25902, 25902),
         16#3C#           =>  --  016B3C
          (0, 0, 25903, 25903),
         16#3D#           =>  --  016B3D
          (0, 0, 25904, 25904),
         16#3E#           =>  --  016B3E
          (0, 0, 25905, 25905),
         16#3F#           =>  --  016B3F
          (0, 0, 25906, 25906),
         16#40#           =>  --  016B40
          (0, 0, 25907, 25907),
         16#41#           =>  --  016B41
          (0, 0, 25908, 25908),
         16#42#           =>  --  016B42
          (0, 0, 25909, 25909),
         16#43#           =>  --  016B43
          (0, 0, 25910, 25910),
         16#44#           =>  --  016B44
          (0, 0, 25911, 25911),
         16#45#           =>  --  016B45
          (0, 0, 25912, 25912),
         16#50#           =>  --  016B50
          (0, 0, 23, 23),
         16#51#           =>  --  016B51
          (0, 0, 24, 24),
         16#52#           =>  --  016B52
          (0, 0, 25, 25),
         16#53#           =>  --  016B53
          (0, 0, 26, 26),
         16#54#           =>  --  016B54
          (0, 0, 27, 27),
         16#55#           =>  --  016B55
          (0, 0, 28, 28),
         16#56#           =>  --  016B56
          (0, 0, 29, 29),
         16#57#           =>  --  016B57
          (0, 0, 30, 30),
         16#58#           =>  --  016B58
          (0, 0, 31, 31),
         16#59#           =>  --  016B59
          (0, 0, 32, 32),
         16#5B#           =>  --  016B5B
          (0, 0, 25913, 25913),
         16#5C#           =>  --  016B5C
          (0, 0, 25914, 25914),
         16#5D#           =>  --  016B5D
          (0, 0, 25915, 25915),
         16#5E#           =>  --  016B5E
          (0, 0, 25916, 25916),
         16#5F#           =>  --  016B5F
          (0, 0, 25917, 25917),
         16#60#           =>  --  016B60
          (0, 0, 25918, 25918),
         16#61#           =>  --  016B61
          (0, 0, 25919, 25919),
         16#63#           =>  --  016B63
          (0, 0, 25920, 25920),
         16#64#           =>  --  016B64
          (0, 0, 25921, 25921),
         16#65#           =>  --  016B65
          (0, 0, 25922, 25922),
         16#66#           =>  --  016B66
          (0, 0, 25923, 25923),
         16#67#           =>  --  016B67
          (0, 0, 25924, 25924),
         16#68#           =>  --  016B68
          (0, 0, 25925, 25925),
         16#69#           =>  --  016B69
          (0, 0, 25926, 25926),
         16#6A#           =>  --  016B6A
          (0, 0, 25927, 25927),
         16#6B#           =>  --  016B6B
          (0, 0, 25928, 25928),
         16#6C#           =>  --  016B6C
          (0, 0, 25929, 25929),
         16#6D#           =>  --  016B6D
          (0, 0, 25930, 25930),
         16#6E#           =>  --  016B6E
          (0, 0, 25931, 25931),
         16#6F#           =>  --  016B6F
          (0, 0, 25932, 25932),
         16#70#           =>  --  016B70
          (0, 0, 25933, 25933),
         16#71#           =>  --  016B71
          (0, 0, 25934, 25934),
         16#72#           =>  --  016B72
          (0, 0, 25935, 25935),
         16#73#           =>  --  016B73
          (0, 0, 25936, 25936),
         16#74#           =>  --  016B74
          (0, 0, 25937, 25937),
         16#75#           =>  --  016B75
          (0, 0, 25938, 25938),
         16#76#           =>  --  016B76
          (0, 0, 25939, 25939),
         16#77#           =>  --  016B77
          (0, 0, 25940, 25940),
         16#7D#           =>  --  016B7D
          (0, 0, 25941, 25941),
         16#7E#           =>  --  016B7E
          (0, 0, 25942, 25942),
         16#7F#           =>  --  016B7F
          (0, 0, 25943, 25943),
         16#80#           =>  --  016B80
          (0, 0, 25944, 25944),
         16#81#           =>  --  016B81
          (0, 0, 25945, 25945),
         16#82#           =>  --  016B82
          (0, 0, 25946, 25946),
         16#83#           =>  --  016B83
          (0, 0, 25947, 25947),
         16#84#           =>  --  016B84
          (0, 0, 25948, 25948),
         16#85#           =>  --  016B85
          (0, 0, 25949, 25949),
         16#86#           =>  --  016B86
          (0, 0, 25950, 25950),
         16#87#           =>  --  016B87
          (0, 0, 25951, 25951),
         16#88#           =>  --  016B88
          (0, 0, 25952, 25952),
         16#89#           =>  --  016B89
          (0, 0, 25953, 25953),
         16#8A#           =>  --  016B8A
          (0, 0, 25954, 25954),
         16#8B#           =>  --  016B8B
          (0, 0, 25955, 25955),
         16#8C#           =>  --  016B8C
          (0, 0, 25956, 25956),
         16#8D#           =>  --  016B8D
          (0, 0, 25957, 25957),
         16#8E#           =>  --  016B8E
          (0, 0, 25958, 25958),
         16#8F#           =>  --  016B8F
          (0, 0, 25959, 25959),
         others           =>
          (0, 0, 0, 0));

   Group_016F : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  016F00
          (0, 0, 25960, 25960),
         16#01#           =>  --  016F01
          (0, 0, 25961, 25961),
         16#02#           =>  --  016F02
          (0, 0, 25962, 25962),
         16#03#           =>  --  016F03
          (0, 0, 25963, 25963),
         16#04#           =>  --  016F04
          (0, 0, 25964, 25964),
         16#05#           =>  --  016F05
          (0, 0, 25965, 25965),
         16#06#           =>  --  016F06
          (0, 0, 25966, 25966),
         16#07#           =>  --  016F07
          (0, 0, 25967, 25967),
         16#08#           =>  --  016F08
          (0, 0, 25968, 25968),
         16#09#           =>  --  016F09
          (0, 0, 25969, 25969),
         16#0A#           =>  --  016F0A
          (0, 0, 25970, 25970),
         16#0B#           =>  --  016F0B
          (0, 0, 25971, 25971),
         16#0C#           =>  --  016F0C
          (0, 0, 25972, 25972),
         16#0D#           =>  --  016F0D
          (0, 0, 25973, 25973),
         16#0E#           =>  --  016F0E
          (0, 0, 25974, 25974),
         16#0F#           =>  --  016F0F
          (0, 0, 25975, 25975),
         16#10#           =>  --  016F10
          (0, 0, 25976, 25976),
         16#11#           =>  --  016F11
          (0, 0, 25977, 25977),
         16#12#           =>  --  016F12
          (0, 0, 25978, 25978),
         16#13#           =>  --  016F13
          (0, 0, 25979, 25979),
         16#14#           =>  --  016F14
          (0, 0, 25980, 25980),
         16#15#           =>  --  016F15
          (0, 0, 25981, 25981),
         16#16#           =>  --  016F16
          (0, 0, 25982, 25982),
         16#17#           =>  --  016F17
          (0, 0, 25983, 25983),
         16#18#           =>  --  016F18
          (0, 0, 25984, 25984),
         16#19#           =>  --  016F19
          (0, 0, 25985, 25985),
         16#1A#           =>  --  016F1A
          (0, 0, 25986, 25986),
         16#1B#           =>  --  016F1B
          (0, 0, 25987, 25987),
         16#1C#           =>  --  016F1C
          (0, 0, 25988, 25988),
         16#1D#           =>  --  016F1D
          (0, 0, 25989, 25989),
         16#1E#           =>  --  016F1E
          (0, 0, 25990, 25990),
         16#1F#           =>  --  016F1F
          (0, 0, 25991, 25991),
         16#20#           =>  --  016F20
          (0, 0, 25992, 25992),
         16#21#           =>  --  016F21
          (0, 0, 25993, 25993),
         16#22#           =>  --  016F22
          (0, 0, 25994, 25994),
         16#23#           =>  --  016F23
          (0, 0, 25995, 25995),
         16#24#           =>  --  016F24
          (0, 0, 25996, 25996),
         16#25#           =>  --  016F25
          (0, 0, 25997, 25997),
         16#26#           =>  --  016F26
          (0, 0, 25998, 25998),
         16#27#           =>  --  016F27
          (0, 0, 25999, 25999),
         16#28#           =>  --  016F28
          (0, 0, 26000, 26000),
         16#29#           =>  --  016F29
          (0, 0, 26001, 26001),
         16#2A#           =>  --  016F2A
          (0, 0, 26002, 26002),
         16#2B#           =>  --  016F2B
          (0, 0, 26003, 26003),
         16#2C#           =>  --  016F2C
          (0, 0, 26004, 26004),
         16#2D#           =>  --  016F2D
          (0, 0, 26005, 26005),
         16#2E#           =>  --  016F2E
          (0, 0, 26006, 26006),
         16#2F#           =>  --  016F2F
          (0, 0, 26007, 26007),
         16#30#           =>  --  016F30
          (0, 0, 26008, 26008),
         16#31#           =>  --  016F31
          (0, 0, 26009, 26009),
         16#32#           =>  --  016F32
          (0, 0, 26010, 26010),
         16#33#           =>  --  016F33
          (0, 0, 26011, 26011),
         16#34#           =>  --  016F34
          (0, 0, 26012, 26012),
         16#35#           =>  --  016F35
          (0, 0, 26013, 26013),
         16#36#           =>  --  016F36
          (0, 0, 26014, 26014),
         16#37#           =>  --  016F37
          (0, 0, 26015, 26015),
         16#38#           =>  --  016F38
          (0, 0, 26016, 26016),
         16#39#           =>  --  016F39
          (0, 0, 26017, 26017),
         16#3A#           =>  --  016F3A
          (0, 0, 26018, 26018),
         16#3B#           =>  --  016F3B
          (0, 0, 26019, 26019),
         16#3C#           =>  --  016F3C
          (0, 0, 26020, 26020),
         16#3D#           =>  --  016F3D
          (0, 0, 26021, 26021),
         16#3E#           =>  --  016F3E
          (0, 0, 26022, 26022),
         16#3F#           =>  --  016F3F
          (0, 0, 26023, 26023),
         16#40#           =>  --  016F40
          (0, 0, 26024, 26024),
         16#41#           =>  --  016F41
          (0, 0, 26025, 26025),
         16#42#           =>  --  016F42
          (0, 0, 26026, 26026),
         16#43#           =>  --  016F43
          (0, 0, 26027, 26027),
         16#44#           =>  --  016F44
          (0, 0, 26028, 26028),
         16#50#           =>  --  016F50
          (0, 0, 26029, 26029),
         16#51#           =>  --  016F51
          (0, 0, 26030, 26030),
         16#52#           =>  --  016F52
          (0, 0, 26031, 26031),
         16#53#           =>  --  016F53
          (0, 0, 26032, 26032),
         16#54#           =>  --  016F54
          (0, 0, 26033, 26033),
         16#55#           =>  --  016F55
          (0, 0, 26034, 26034),
         16#56#           =>  --  016F56
          (0, 0, 26035, 26035),
         16#57#           =>  --  016F57
          (0, 0, 26036, 26036),
         16#58#           =>  --  016F58
          (0, 0, 26037, 26037),
         16#59#           =>  --  016F59
          (0, 0, 26038, 26038),
         16#5A#           =>  --  016F5A
          (0, 0, 26039, 26039),
         16#5B#           =>  --  016F5B
          (0, 0, 26040, 26040),
         16#5C#           =>  --  016F5C
          (0, 0, 26041, 26041),
         16#5D#           =>  --  016F5D
          (0, 0, 26042, 26042),
         16#5E#           =>  --  016F5E
          (0, 0, 26043, 26043),
         16#5F#           =>  --  016F5F
          (0, 0, 26044, 26044),
         16#60#           =>  --  016F60
          (0, 0, 26045, 26045),
         16#61#           =>  --  016F61
          (0, 0, 26046, 26046),
         16#62#           =>  --  016F62
          (0, 0, 26047, 26047),
         16#63#           =>  --  016F63
          (0, 0, 26048, 26048),
         16#64#           =>  --  016F64
          (0, 0, 26049, 26049),
         16#65#           =>  --  016F65
          (0, 0, 26050, 26050),
         16#66#           =>  --  016F66
          (0, 0, 26051, 26051),
         16#67#           =>  --  016F67
          (0, 0, 26052, 26052),
         16#68#           =>  --  016F68
          (0, 0, 26053, 26053),
         16#69#           =>  --  016F69
          (0, 0, 26054, 26054),
         16#6A#           =>  --  016F6A
          (0, 0, 26055, 26055),
         16#6B#           =>  --  016F6B
          (0, 0, 26056, 26056),
         16#6C#           =>  --  016F6C
          (0, 0, 26057, 26057),
         16#6D#           =>  --  016F6D
          (0, 0, 26058, 26058),
         16#6E#           =>  --  016F6E
          (0, 0, 26059, 26059),
         16#6F#           =>  --  016F6F
          (0, 0, 26060, 26060),
         16#70#           =>  --  016F70
          (0, 0, 26061, 26061),
         16#71#           =>  --  016F71
          (0, 0, 26062, 26062),
         16#72#           =>  --  016F72
          (0, 0, 26063, 26063),
         16#73#           =>  --  016F73
          (0, 0, 26064, 26064),
         16#74#           =>  --  016F74
          (0, 0, 26065, 26065),
         16#75#           =>  --  016F75
          (0, 0, 26066, 26066),
         16#76#           =>  --  016F76
          (0, 0, 26067, 26067),
         16#77#           =>  --  016F77
          (0, 0, 26068, 26068),
         16#78#           =>  --  016F78
          (0, 0, 26069, 26069),
         16#79#           =>  --  016F79
          (0, 0, 26070, 26070),
         16#7A#           =>  --  016F7A
          (0, 0, 26071, 26071),
         16#7B#           =>  --  016F7B
          (0, 0, 26072, 26072),
         16#7C#           =>  --  016F7C
          (0, 0, 26073, 26073),
         16#7D#           =>  --  016F7D
          (0, 0, 26074, 26074),
         16#7E#           =>  --  016F7E
          (0, 0, 26075, 26075),
         16#8F#           =>  --  016F8F
          (0, 0, 26076, 26076),
         16#90#           =>  --  016F90
          (0, 0, 26077, 26077),
         16#91#           =>  --  016F91
          (0, 0, 26078, 26078),
         16#92#           =>  --  016F92
          (0, 0, 26079, 26079),
         16#93#           =>  --  016F93
          (0, 0, 26080, 26080),
         16#94#           =>  --  016F94
          (0, 0, 26081, 26081),
         16#95#           =>  --  016F95
          (0, 0, 26082, 26082),
         16#96#           =>  --  016F96
          (0, 0, 26083, 26083),
         16#97#           =>  --  016F97
          (0, 0, 26084, 26084),
         16#98#           =>  --  016F98
          (0, 0, 26085, 26085),
         16#99#           =>  --  016F99
          (0, 0, 26086, 26086),
         16#9A#           =>  --  016F9A
          (0, 0, 26087, 26087),
         16#9B#           =>  --  016F9B
          (0, 0, 26088, 26088),
         16#9C#           =>  --  016F9C
          (0, 0, 26089, 26089),
         16#9D#           =>  --  016F9D
          (0, 0, 26090, 26090),
         16#9E#           =>  --  016F9E
          (0, 0, 26091, 26091),
         16#9F#           =>  --  016F9F
          (0, 0, 26092, 26092),
         others           =>
          (0, 0, 0, 0));

   Group_01B0 : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  01B000
          (0, 0, 26093, 26093),
         16#01#           =>  --  01B001
          (0, 0, 26094, 26094),
         others           =>
          (0, 0, 0, 0));

   Group_01BC : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  01BC00
          (0, 0, 26095, 26095),
         16#01#           =>  --  01BC01
          (0, 0, 26096, 26096),
         16#02#           =>  --  01BC02
          (0, 0, 26097, 26097),
         16#03#           =>  --  01BC03
          (0, 0, 26098, 26098),
         16#04#           =>  --  01BC04
          (0, 0, 26099, 26099),
         16#05#           =>  --  01BC05
          (0, 0, 26100, 26100),
         16#06#           =>  --  01BC06
          (0, 0, 26101, 26101),
         16#07#           =>  --  01BC07
          (0, 0, 26102, 26102),
         16#08#           =>  --  01BC08
          (0, 0, 26103, 26103),
         16#09#           =>  --  01BC09
          (0, 0, 26104, 26104),
         16#0A#           =>  --  01BC0A
          (0, 0, 26105, 26105),
         16#0B#           =>  --  01BC0B
          (0, 0, 26106, 26106),
         16#0C#           =>  --  01BC0C
          (0, 0, 26107, 26107),
         16#0D#           =>  --  01BC0D
          (0, 0, 26108, 26108),
         16#0E#           =>  --  01BC0E
          (0, 0, 26109, 26109),
         16#0F#           =>  --  01BC0F
          (0, 0, 26110, 26110),
         16#10#           =>  --  01BC10
          (0, 0, 26111, 26111),
         16#11#           =>  --  01BC11
          (0, 0, 26112, 26112),
         16#12#           =>  --  01BC12
          (0, 0, 26113, 26113),
         16#13#           =>  --  01BC13
          (0, 0, 26114, 26114),
         16#14#           =>  --  01BC14
          (0, 0, 26115, 26115),
         16#15#           =>  --  01BC15
          (0, 0, 26116, 26116),
         16#16#           =>  --  01BC16
          (0, 0, 26117, 26117),
         16#17#           =>  --  01BC17
          (0, 0, 26118, 26118),
         16#18#           =>  --  01BC18
          (0, 0, 26119, 26119),
         16#19#           =>  --  01BC19
          (0, 0, 26120, 26120),
         16#1A#           =>  --  01BC1A
          (0, 0, 26121, 26121),
         16#1B#           =>  --  01BC1B
          (0, 0, 26122, 26122),
         16#1C#           =>  --  01BC1C
          (0, 0, 26123, 26123),
         16#1D#           =>  --  01BC1D
          (0, 0, 26124, 26124),
         16#1E#           =>  --  01BC1E
          (0, 0, 26125, 26125),
         16#1F#           =>  --  01BC1F
          (0, 0, 26126, 26126),
         16#20#           =>  --  01BC20
          (0, 0, 26127, 26127),
         16#21#           =>  --  01BC21
          (0, 0, 26128, 26128),
         16#22#           =>  --  01BC22
          (0, 0, 26129, 26129),
         16#23#           =>  --  01BC23
          (0, 0, 26130, 26130),
         16#24#           =>  --  01BC24
          (0, 0, 26131, 26131),
         16#25#           =>  --  01BC25
          (0, 0, 26132, 26132),
         16#26#           =>  --  01BC26
          (0, 0, 26133, 26133),
         16#27#           =>  --  01BC27
          (0, 0, 26134, 26134),
         16#28#           =>  --  01BC28
          (0, 0, 26135, 26135),
         16#29#           =>  --  01BC29
          (0, 0, 26136, 26136),
         16#2A#           =>  --  01BC2A
          (0, 0, 26137, 26137),
         16#2B#           =>  --  01BC2B
          (0, 0, 26138, 26138),
         16#2C#           =>  --  01BC2C
          (0, 0, 26139, 26139),
         16#2D#           =>  --  01BC2D
          (0, 0, 26140, 26140),
         16#2E#           =>  --  01BC2E
          (0, 0, 26141, 26141),
         16#2F#           =>  --  01BC2F
          (0, 0, 26142, 26142),
         16#30#           =>  --  01BC30
          (0, 0, 26143, 26143),
         16#31#           =>  --  01BC31
          (0, 0, 26144, 26144),
         16#32#           =>  --  01BC32
          (0, 0, 26145, 26145),
         16#33#           =>  --  01BC33
          (0, 0, 26146, 26146),
         16#34#           =>  --  01BC34
          (0, 0, 26147, 26147),
         16#35#           =>  --  01BC35
          (0, 0, 26148, 26148),
         16#36#           =>  --  01BC36
          (0, 0, 26149, 26149),
         16#37#           =>  --  01BC37
          (0, 0, 26150, 26150),
         16#38#           =>  --  01BC38
          (0, 0, 26151, 26151),
         16#39#           =>  --  01BC39
          (0, 0, 26152, 26152),
         16#3A#           =>  --  01BC3A
          (0, 0, 26153, 26153),
         16#3B#           =>  --  01BC3B
          (0, 0, 26154, 26154),
         16#3C#           =>  --  01BC3C
          (0, 0, 26155, 26155),
         16#3D#           =>  --  01BC3D
          (0, 0, 26156, 26156),
         16#3E#           =>  --  01BC3E
          (0, 0, 26157, 26157),
         16#3F#           =>  --  01BC3F
          (0, 0, 26158, 26158),
         16#40#           =>  --  01BC40
          (0, 0, 26159, 26159),
         16#41#           =>  --  01BC41
          (0, 0, 26160, 26160),
         16#42#           =>  --  01BC42
          (0, 0, 26161, 26161),
         16#43#           =>  --  01BC43
          (0, 0, 26162, 26162),
         16#44#           =>  --  01BC44
          (0, 0, 26163, 26163),
         16#45#           =>  --  01BC45
          (0, 0, 26164, 26164),
         16#46#           =>  --  01BC46
          (0, 0, 26165, 26165),
         16#47#           =>  --  01BC47
          (0, 0, 26166, 26166),
         16#48#           =>  --  01BC48
          (0, 0, 26167, 26167),
         16#49#           =>  --  01BC49
          (0, 0, 26168, 26168),
         16#4A#           =>  --  01BC4A
          (0, 0, 26169, 26169),
         16#4B#           =>  --  01BC4B
          (0, 0, 26170, 26170),
         16#4C#           =>  --  01BC4C
          (0, 0, 26171, 26171),
         16#4D#           =>  --  01BC4D
          (0, 0, 26172, 26172),
         16#4E#           =>  --  01BC4E
          (0, 0, 26173, 26173),
         16#4F#           =>  --  01BC4F
          (0, 0, 26174, 26174),
         16#50#           =>  --  01BC50
          (0, 0, 26175, 26175),
         16#51#           =>  --  01BC51
          (0, 0, 26176, 26176),
         16#52#           =>  --  01BC52
          (0, 0, 26177, 26177),
         16#53#           =>  --  01BC53
          (0, 0, 26178, 26178),
         16#54#           =>  --  01BC54
          (0, 0, 26179, 26179),
         16#55#           =>  --  01BC55
          (0, 0, 26180, 26180),
         16#56#           =>  --  01BC56
          (0, 0, 26181, 26181),
         16#57#           =>  --  01BC57
          (0, 0, 26182, 26182),
         16#58#           =>  --  01BC58
          (0, 0, 26183, 26183),
         16#59#           =>  --  01BC59
          (0, 0, 26184, 26184),
         16#5A#           =>  --  01BC5A
          (0, 0, 26185, 26185),
         16#5B#           =>  --  01BC5B
          (0, 0, 26186, 26186),
         16#5C#           =>  --  01BC5C
          (0, 0, 26187, 26187),
         16#5D#           =>  --  01BC5D
          (0, 0, 26188, 26188),
         16#5E#           =>  --  01BC5E
          (0, 0, 26189, 26189),
         16#5F#           =>  --  01BC5F
          (0, 0, 26190, 26190),
         16#60#           =>  --  01BC60
          (0, 0, 26191, 26191),
         16#61#           =>  --  01BC61
          (0, 0, 26192, 26192),
         16#62#           =>  --  01BC62
          (0, 0, 26193, 26193),
         16#63#           =>  --  01BC63
          (0, 0, 26194, 26194),
         16#64#           =>  --  01BC64
          (0, 0, 26195, 26195),
         16#65#           =>  --  01BC65
          (0, 0, 26196, 26196),
         16#66#           =>  --  01BC66
          (0, 0, 26197, 26197),
         16#67#           =>  --  01BC67
          (0, 0, 26198, 26198),
         16#68#           =>  --  01BC68
          (0, 0, 26199, 26199),
         16#69#           =>  --  01BC69
          (0, 0, 26200, 26200),
         16#6A#           =>  --  01BC6A
          (0, 0, 26201, 26201),
         16#70#           =>  --  01BC70
          (0, 0, 26202, 26202),
         16#71#           =>  --  01BC71
          (0, 0, 26203, 26203),
         16#72#           =>  --  01BC72
          (0, 0, 26204, 26204),
         16#73#           =>  --  01BC73
          (0, 0, 26205, 26205),
         16#74#           =>  --  01BC74
          (0, 0, 26206, 26206),
         16#75#           =>  --  01BC75
          (0, 0, 26207, 26207),
         16#76#           =>  --  01BC76
          (0, 0, 26208, 26208),
         16#77#           =>  --  01BC77
          (0, 0, 26209, 26209),
         16#78#           =>  --  01BC78
          (0, 0, 26210, 26210),
         16#79#           =>  --  01BC79
          (0, 0, 26211, 26211),
         16#7A#           =>  --  01BC7A
          (0, 0, 26212, 26212),
         16#7B#           =>  --  01BC7B
          (0, 0, 26213, 26213),
         16#7C#           =>  --  01BC7C
          (0, 0, 26214, 26214),
         16#80#           =>  --  01BC80
          (0, 0, 26215, 26215),
         16#81#           =>  --  01BC81
          (0, 0, 26216, 26216),
         16#82#           =>  --  01BC82
          (0, 0, 26217, 26217),
         16#83#           =>  --  01BC83
          (0, 0, 26218, 26218),
         16#84#           =>  --  01BC84
          (0, 0, 26219, 26219),
         16#85#           =>  --  01BC85
          (0, 0, 26220, 26220),
         16#86#           =>  --  01BC86
          (0, 0, 26221, 26221),
         16#87#           =>  --  01BC87
          (0, 0, 26222, 26222),
         16#88#           =>  --  01BC88
          (0, 0, 26223, 26223),
         16#90#           =>  --  01BC90
          (0, 0, 26224, 26224),
         16#91#           =>  --  01BC91
          (0, 0, 26225, 26225),
         16#92#           =>  --  01BC92
          (0, 0, 26226, 26226),
         16#93#           =>  --  01BC93
          (0, 0, 26227, 26227),
         16#94#           =>  --  01BC94
          (0, 0, 26228, 26228),
         16#95#           =>  --  01BC95
          (0, 0, 26229, 26229),
         16#96#           =>  --  01BC96
          (0, 0, 26230, 26230),
         16#97#           =>  --  01BC97
          (0, 0, 26231, 26231),
         16#98#           =>  --  01BC98
          (0, 0, 26232, 26232),
         16#99#           =>  --  01BC99
          (0, 0, 26233, 26233),
         16#9C#           =>  --  01BC9C
          (0, 0, 26234, 26234),
         16#9D#           =>  --  01BC9D
          (0, 0, 1041, 1041),
         16#9E#           =>  --  01BC9E
          (0, 0, 1057, 1057),
         16#9F#           =>  --  01BC9F
          (0, 0, 26235, 26235),
         16#A0# .. 16#A3# =>  --  01BCA0 .. 01BCA3
          (0, 0, 1, 1),
         others           =>
          (0, 0, 0, 0));

   Group_01D0 : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  01D000
          (0, 0, 26236, 26236),
         16#01#           =>  --  01D001
          (0, 0, 26237, 26237),
         16#02#           =>  --  01D002
          (0, 0, 26238, 26238),
         16#03#           =>  --  01D003
          (0, 0, 26239, 26239),
         16#04#           =>  --  01D004
          (0, 0, 26240, 26240),
         16#05#           =>  --  01D005
          (0, 0, 26241, 26241),
         16#06#           =>  --  01D006
          (0, 0, 26242, 26242),
         16#07#           =>  --  01D007
          (0, 0, 26243, 26243),
         16#08#           =>  --  01D008
          (0, 0, 26244, 26244),
         16#09#           =>  --  01D009
          (0, 0, 26245, 26245),
         16#0A#           =>  --  01D00A
          (0, 0, 26246, 26246),
         16#0B#           =>  --  01D00B
          (0, 0, 26247, 26247),
         16#0C#           =>  --  01D00C
          (0, 0, 26248, 26248),
         16#0D#           =>  --  01D00D
          (0, 0, 26249, 26249),
         16#0E#           =>  --  01D00E
          (0, 0, 26250, 26250),
         16#0F#           =>  --  01D00F
          (0, 0, 26251, 26251),
         16#10#           =>  --  01D010
          (0, 0, 26252, 26252),
         16#11#           =>  --  01D011
          (0, 0, 26253, 26253),
         16#12#           =>  --  01D012
          (0, 0, 26254, 26254),
         16#13#           =>  --  01D013
          (0, 0, 26255, 26255),
         16#14#           =>  --  01D014
          (0, 0, 26256, 26256),
         16#15#           =>  --  01D015
          (0, 0, 26257, 26257),
         16#16#           =>  --  01D016
          (0, 0, 26258, 26258),
         16#17#           =>  --  01D017
          (0, 0, 26259, 26259),
         16#18#           =>  --  01D018
          (0, 0, 26260, 26260),
         16#19#           =>  --  01D019
          (0, 0, 26261, 26261),
         16#1A#           =>  --  01D01A
          (0, 0, 26262, 26262),
         16#1B#           =>  --  01D01B
          (0, 0, 26263, 26263),
         16#1C#           =>  --  01D01C
          (0, 0, 26264, 26264),
         16#1D#           =>  --  01D01D
          (0, 0, 26265, 26265),
         16#1E#           =>  --  01D01E
          (0, 0, 26266, 26266),
         16#1F#           =>  --  01D01F
          (0, 0, 26267, 26267),
         16#20#           =>  --  01D020
          (0, 0, 26268, 26268),
         16#21#           =>  --  01D021
          (0, 0, 26269, 26269),
         16#22#           =>  --  01D022
          (0, 0, 26270, 26270),
         16#23#           =>  --  01D023
          (0, 0, 26271, 26271),
         16#24#           =>  --  01D024
          (0, 0, 26272, 26272),
         16#25#           =>  --  01D025
          (0, 0, 26273, 26273),
         16#26#           =>  --  01D026
          (0, 0, 26274, 26274),
         16#27#           =>  --  01D027
          (0, 0, 26275, 26275),
         16#28#           =>  --  01D028
          (0, 0, 26276, 26276),
         16#29#           =>  --  01D029
          (0, 0, 26277, 26277),
         16#2A#           =>  --  01D02A
          (0, 0, 26278, 26278),
         16#2B#           =>  --  01D02B
          (0, 0, 26279, 26279),
         16#2C#           =>  --  01D02C
          (0, 0, 26280, 26280),
         16#2D#           =>  --  01D02D
          (0, 0, 26281, 26281),
         16#2E#           =>  --  01D02E
          (0, 0, 26282, 26282),
         16#2F#           =>  --  01D02F
          (0, 0, 26283, 26283),
         16#30#           =>  --  01D030
          (0, 0, 26284, 26284),
         16#31#           =>  --  01D031
          (0, 0, 26285, 26285),
         16#32#           =>  --  01D032
          (0, 0, 26286, 26286),
         16#33#           =>  --  01D033
          (0, 0, 26287, 26287),
         16#34#           =>  --  01D034
          (0, 0, 26288, 26288),
         16#35#           =>  --  01D035
          (0, 0, 26289, 26289),
         16#36#           =>  --  01D036
          (0, 0, 26290, 26290),
         16#37#           =>  --  01D037
          (0, 0, 26291, 26291),
         16#38#           =>  --  01D038
          (0, 0, 26292, 26292),
         16#39#           =>  --  01D039
          (0, 0, 26293, 26293),
         16#3A#           =>  --  01D03A
          (0, 0, 26294, 26294),
         16#3B#           =>  --  01D03B
          (0, 0, 26295, 26295),
         16#3C#           =>  --  01D03C
          (0, 0, 26296, 26296),
         16#3D#           =>  --  01D03D
          (0, 0, 26297, 26297),
         16#3E#           =>  --  01D03E
          (0, 0, 26298, 26298),
         16#3F#           =>  --  01D03F
          (0, 0, 26299, 26299),
         16#40#           =>  --  01D040
          (0, 0, 26300, 26300),
         16#41#           =>  --  01D041
          (0, 0, 26301, 26301),
         16#42#           =>  --  01D042
          (0, 0, 26302, 26302),
         16#43#           =>  --  01D043
          (0, 0, 26303, 26303),
         16#44#           =>  --  01D044
          (0, 0, 26304, 26304),
         16#45#           =>  --  01D045
          (0, 0, 26305, 26305),
         16#46#           =>  --  01D046
          (0, 0, 26306, 26306),
         16#47#           =>  --  01D047
          (0, 0, 26307, 26307),
         16#48#           =>  --  01D048
          (0, 0, 26308, 26308),
         16#49#           =>  --  01D049
          (0, 0, 26309, 26309),
         16#4A#           =>  --  01D04A
          (0, 0, 26310, 26310),
         16#4B#           =>  --  01D04B
          (0, 0, 26311, 26311),
         16#4C#           =>  --  01D04C
          (0, 0, 26312, 26312),
         16#4D#           =>  --  01D04D
          (0, 0, 26313, 26313),
         16#4E#           =>  --  01D04E
          (0, 0, 26314, 26314),
         16#4F#           =>  --  01D04F
          (0, 0, 26315, 26315),
         16#50#           =>  --  01D050
          (0, 0, 26316, 26316),
         16#51#           =>  --  01D051
          (0, 0, 26317, 26317),
         16#52#           =>  --  01D052
          (0, 0, 26318, 26318),
         16#53#           =>  --  01D053
          (0, 0, 26319, 26319),
         16#54#           =>  --  01D054
          (0, 0, 26320, 26320),
         16#55#           =>  --  01D055
          (0, 0, 26321, 26321),
         16#56#           =>  --  01D056
          (0, 0, 26322, 26322),
         16#57#           =>  --  01D057
          (0, 0, 26323, 26323),
         16#58#           =>  --  01D058
          (0, 0, 26324, 26324),
         16#59#           =>  --  01D059
          (0, 0, 26325, 26325),
         16#5A#           =>  --  01D05A
          (0, 0, 26326, 26326),
         16#5B#           =>  --  01D05B
          (0, 0, 26327, 26327),
         16#5C#           =>  --  01D05C
          (0, 0, 26328, 26328),
         16#5D#           =>  --  01D05D
          (0, 0, 26329, 26329),
         16#5E#           =>  --  01D05E
          (0, 0, 26330, 26330),
         16#5F#           =>  --  01D05F
          (0, 0, 26331, 26331),
         16#60#           =>  --  01D060
          (0, 0, 26332, 26332),
         16#61#           =>  --  01D061
          (0, 0, 26333, 26333),
         16#62#           =>  --  01D062
          (0, 0, 26334, 26334),
         16#63#           =>  --  01D063
          (0, 0, 26335, 26335),
         16#64#           =>  --  01D064
          (0, 0, 26336, 26336),
         16#65#           =>  --  01D065
          (0, 0, 26337, 26337),
         16#66#           =>  --  01D066
          (0, 0, 26338, 26338),
         16#67#           =>  --  01D067
          (0, 0, 26339, 26339),
         16#68#           =>  --  01D068
          (0, 0, 26340, 26340),
         16#69#           =>  --  01D069
          (0, 0, 26341, 26341),
         16#6A#           =>  --  01D06A
          (0, 0, 26342, 26342),
         16#6B#           =>  --  01D06B
          (0, 0, 26343, 26343),
         16#6C#           =>  --  01D06C
          (0, 0, 26344, 26344),
         16#6D#           =>  --  01D06D
          (0, 0, 26345, 26345),
         16#6E#           =>  --  01D06E
          (0, 0, 26346, 26346),
         16#6F#           =>  --  01D06F
          (0, 0, 26347, 26347),
         16#70#           =>  --  01D070
          (0, 0, 26348, 26348),
         16#71#           =>  --  01D071
          (0, 0, 26349, 26349),
         16#72#           =>  --  01D072
          (0, 0, 26350, 26350),
         16#73#           =>  --  01D073
          (0, 0, 26351, 26351),
         16#74#           =>  --  01D074
          (0, 0, 26352, 26352),
         16#75#           =>  --  01D075
          (0, 0, 26353, 26353),
         16#76#           =>  --  01D076
          (0, 0, 26354, 26354),
         16#77#           =>  --  01D077
          (0, 0, 26355, 26355),
         16#78#           =>  --  01D078
          (0, 0, 26356, 26356),
         16#79#           =>  --  01D079
          (0, 0, 26357, 26357),
         16#7A#           =>  --  01D07A
          (0, 0, 26358, 26358),
         16#7B#           =>  --  01D07B
          (0, 0, 26359, 26359),
         16#7C#           =>  --  01D07C
          (0, 0, 26360, 26360),
         16#7D#           =>  --  01D07D
          (0, 0, 26361, 26361),
         16#7E#           =>  --  01D07E
          (0, 0, 26362, 26362),
         16#7F#           =>  --  01D07F
          (0, 0, 26363, 26363),
         16#80#           =>  --  01D080
          (0, 0, 26364, 26364),
         16#81#           =>  --  01D081
          (0, 0, 26365, 26365),
         16#82#           =>  --  01D082
          (0, 0, 26366, 26366),
         16#83#           =>  --  01D083
          (0, 0, 26367, 26367),
         16#84#           =>  --  01D084
          (0, 0, 26368, 26368),
         16#85#           =>  --  01D085
          (0, 0, 26369, 26369),
         16#86#           =>  --  01D086
          (0, 0, 26370, 26370),
         16#87#           =>  --  01D087
          (0, 0, 26371, 26371),
         16#88#           =>  --  01D088
          (0, 0, 26372, 26372),
         16#89#           =>  --  01D089
          (0, 0, 26373, 26373),
         16#8A#           =>  --  01D08A
          (0, 0, 26374, 26374),
         16#8B#           =>  --  01D08B
          (0, 0, 26375, 26375),
         16#8C#           =>  --  01D08C
          (0, 0, 26376, 26376),
         16#8D#           =>  --  01D08D
          (0, 0, 26377, 26377),
         16#8E#           =>  --  01D08E
          (0, 0, 26378, 26378),
         16#8F#           =>  --  01D08F
          (0, 0, 26379, 26379),
         16#90#           =>  --  01D090
          (0, 0, 26380, 26380),
         16#91#           =>  --  01D091
          (0, 0, 26381, 26381),
         16#92#           =>  --  01D092
          (0, 0, 26382, 26382),
         16#93#           =>  --  01D093
          (0, 0, 26383, 26383),
         16#94#           =>  --  01D094
          (0, 0, 26384, 26384),
         16#95#           =>  --  01D095
          (0, 0, 26385, 26385),
         16#96#           =>  --  01D096
          (0, 0, 26386, 26386),
         16#97#           =>  --  01D097
          (0, 0, 26387, 26387),
         16#98#           =>  --  01D098
          (0, 0, 26388, 26388),
         16#99#           =>  --  01D099
          (0, 0, 26389, 26389),
         16#9A#           =>  --  01D09A
          (0, 0, 26390, 26390),
         16#9B#           =>  --  01D09B
          (0, 0, 26391, 26391),
         16#9C#           =>  --  01D09C
          (0, 0, 26392, 26392),
         16#9D#           =>  --  01D09D
          (0, 0, 26393, 26393),
         16#9E#           =>  --  01D09E
          (0, 0, 26394, 26394),
         16#9F#           =>  --  01D09F
          (0, 0, 26395, 26395),
         16#A0#           =>  --  01D0A0
          (0, 0, 26396, 26396),
         16#A1#           =>  --  01D0A1
          (0, 0, 26397, 26397),
         16#A2#           =>  --  01D0A2
          (0, 0, 26398, 26398),
         16#A3#           =>  --  01D0A3
          (0, 0, 26399, 26399),
         16#A4#           =>  --  01D0A4
          (0, 0, 26400, 26400),
         16#A5#           =>  --  01D0A5
          (0, 0, 26401, 26401),
         16#A6#           =>  --  01D0A6
          (0, 0, 26402, 26402),
         16#A7#           =>  --  01D0A7
          (0, 0, 26403, 26403),
         16#A8#           =>  --  01D0A8
          (0, 0, 26404, 26404),
         16#A9#           =>  --  01D0A9
          (0, 0, 26405, 26405),
         16#AA#           =>  --  01D0AA
          (0, 0, 26406, 26406),
         16#AB#           =>  --  01D0AB
          (0, 0, 26407, 26407),
         16#AC#           =>  --  01D0AC
          (0, 0, 26408, 26408),
         16#AD#           =>  --  01D0AD
          (0, 0, 26409, 26409),
         16#AE#           =>  --  01D0AE
          (0, 0, 26410, 26410),
         16#AF#           =>  --  01D0AF
          (0, 0, 26411, 26411),
         16#B0#           =>  --  01D0B0
          (0, 0, 26412, 26412),
         16#B1#           =>  --  01D0B1
          (0, 0, 26413, 26413),
         16#B2#           =>  --  01D0B2
          (0, 0, 26414, 26414),
         16#B3#           =>  --  01D0B3
          (0, 0, 26415, 26415),
         16#B4#           =>  --  01D0B4
          (0, 0, 26416, 26416),
         16#B5#           =>  --  01D0B5
          (0, 0, 26417, 26417),
         16#B6#           =>  --  01D0B6
          (0, 0, 26418, 26418),
         16#B7#           =>  --  01D0B7
          (0, 0, 26419, 26419),
         16#B8#           =>  --  01D0B8
          (0, 0, 26420, 26420),
         16#B9#           =>  --  01D0B9
          (0, 0, 26421, 26421),
         16#BA#           =>  --  01D0BA
          (0, 0, 26422, 26422),
         16#BB#           =>  --  01D0BB
          (0, 0, 26423, 26423),
         16#BC#           =>  --  01D0BC
          (0, 0, 26424, 26424),
         16#BD#           =>  --  01D0BD
          (0, 0, 26425, 26425),
         16#BE#           =>  --  01D0BE
          (0, 0, 26426, 26426),
         16#BF#           =>  --  01D0BF
          (0, 0, 26427, 26427),
         16#C0#           =>  --  01D0C0
          (0, 0, 26428, 26428),
         16#C1#           =>  --  01D0C1
          (0, 0, 26429, 26429),
         16#C2#           =>  --  01D0C2
          (0, 0, 26430, 26430),
         16#C3#           =>  --  01D0C3
          (0, 0, 26431, 26431),
         16#C4#           =>  --  01D0C4
          (0, 0, 26432, 26432),
         16#C5#           =>  --  01D0C5
          (0, 0, 26433, 26433),
         16#C6#           =>  --  01D0C6
          (0, 0, 26434, 26434),
         16#C7#           =>  --  01D0C7
          (0, 0, 26435, 26435),
         16#C8#           =>  --  01D0C8
          (0, 0, 26436, 26436),
         16#C9#           =>  --  01D0C9
          (0, 0, 26437, 26437),
         16#CA#           =>  --  01D0CA
          (0, 0, 26438, 26438),
         16#CB#           =>  --  01D0CB
          (0, 0, 26439, 26439),
         16#CC#           =>  --  01D0CC
          (0, 0, 26440, 26440),
         16#CD#           =>  --  01D0CD
          (0, 0, 26441, 26441),
         16#CE#           =>  --  01D0CE
          (0, 0, 26442, 26442),
         16#CF#           =>  --  01D0CF
          (0, 0, 26443, 26443),
         16#D0#           =>  --  01D0D0
          (0, 0, 26444, 26444),
         16#D1#           =>  --  01D0D1
          (0, 0, 26445, 26445),
         16#D2#           =>  --  01D0D2
          (0, 0, 26446, 26446),
         16#D3#           =>  --  01D0D3
          (0, 0, 26447, 26447),
         16#D4#           =>  --  01D0D4
          (0, 0, 26448, 26448),
         16#D5#           =>  --  01D0D5
          (0, 0, 26449, 26449),
         16#D6#           =>  --  01D0D6
          (0, 0, 26450, 26450),
         16#D7#           =>  --  01D0D7
          (0, 0, 26451, 26451),
         16#D8#           =>  --  01D0D8
          (0, 0, 26452, 26452),
         16#D9#           =>  --  01D0D9
          (0, 0, 26453, 26453),
         16#DA#           =>  --  01D0DA
          (0, 0, 26454, 26454),
         16#DB#           =>  --  01D0DB
          (0, 0, 26455, 26455),
         16#DC#           =>  --  01D0DC
          (0, 0, 26456, 26456),
         16#DD#           =>  --  01D0DD
          (0, 0, 26457, 26457),
         16#DE#           =>  --  01D0DE
          (0, 0, 26458, 26458),
         16#DF#           =>  --  01D0DF
          (0, 0, 26459, 26459),
         16#E0#           =>  --  01D0E0
          (0, 0, 26460, 26460),
         16#E1#           =>  --  01D0E1
          (0, 0, 26461, 26461),
         16#E2#           =>  --  01D0E2
          (0, 0, 26462, 26462),
         16#E3#           =>  --  01D0E3
          (0, 0, 26463, 26463),
         16#E4#           =>  --  01D0E4
          (0, 0, 26464, 26464),
         16#E5#           =>  --  01D0E5
          (0, 0, 26465, 26465),
         16#E6#           =>  --  01D0E6
          (0, 0, 26466, 26466),
         16#E7#           =>  --  01D0E7
          (0, 0, 26467, 26467),
         16#E8#           =>  --  01D0E8
          (0, 0, 26468, 26468),
         16#E9#           =>  --  01D0E9
          (0, 0, 26469, 26469),
         16#EA#           =>  --  01D0EA
          (0, 0, 26470, 26470),
         16#EB#           =>  --  01D0EB
          (0, 0, 26471, 26471),
         16#EC#           =>  --  01D0EC
          (0, 0, 26472, 26472),
         16#ED#           =>  --  01D0ED
          (0, 0, 26473, 26473),
         16#EE#           =>  --  01D0EE
          (0, 0, 26474, 26474),
         16#EF#           =>  --  01D0EF
          (0, 0, 26475, 26475),
         16#F0#           =>  --  01D0F0
          (0, 0, 26476, 26476),
         16#F1#           =>  --  01D0F1
          (0, 0, 26477, 26477),
         16#F2#           =>  --  01D0F2
          (0, 0, 26478, 26478),
         16#F3#           =>  --  01D0F3
          (0, 0, 26479, 26479),
         16#F4#           =>  --  01D0F4
          (0, 0, 26480, 26480),
         16#F5#           =>  --  01D0F5
          (0, 0, 26481, 26481),
         others           =>
          (0, 0, 0, 0));

   Group_01D1 : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  01D100
          (0, 0, 26482, 26482),
         16#01#           =>  --  01D101
          (0, 0, 26483, 26483),
         16#02#           =>  --  01D102
          (0, 0, 26484, 26484),
         16#03#           =>  --  01D103
          (0, 0, 26485, 26485),
         16#04#           =>  --  01D104
          (0, 0, 26486, 26486),
         16#05#           =>  --  01D105
          (0, 0, 26487, 26487),
         16#06#           =>  --  01D106
          (0, 0, 26488, 26488),
         16#07#           =>  --  01D107
          (0, 0, 26489, 26489),
         16#08#           =>  --  01D108
          (0, 0, 26490, 26490),
         16#09#           =>  --  01D109
          (0, 0, 26491, 26491),
         16#0A#           =>  --  01D10A
          (0, 0, 26492, 26492),
         16#0B#           =>  --  01D10B
          (0, 0, 26493, 26493),
         16#0C#           =>  --  01D10C
          (0, 0, 26494, 26494),
         16#0D#           =>  --  01D10D
          (0, 0, 26495, 26495),
         16#0E#           =>  --  01D10E
          (0, 0, 26496, 26496),
         16#0F#           =>  --  01D10F
          (0, 0, 26497, 26497),
         16#10#           =>  --  01D110
          (0, 0, 26498, 26498),
         16#11#           =>  --  01D111
          (0, 0, 26499, 26499),
         16#12#           =>  --  01D112
          (0, 0, 26500, 26500),
         16#13#           =>  --  01D113
          (0, 0, 26501, 26501),
         16#14#           =>  --  01D114
          (0, 0, 26502, 26502),
         16#15#           =>  --  01D115
          (0, 0, 26503, 26503),
         16#16#           =>  --  01D116
          (0, 0, 26504, 26504),
         16#17#           =>  --  01D117
          (0, 0, 26505, 26505),
         16#18#           =>  --  01D118
          (0, 0, 26506, 26506),
         16#19#           =>  --  01D119
          (0, 0, 26507, 26507),
         16#1A#           =>  --  01D11A
          (0, 0, 26508, 26508),
         16#1B#           =>  --  01D11B
          (0, 0, 26509, 26509),
         16#1C#           =>  --  01D11C
          (0, 0, 26510, 26510),
         16#1D#           =>  --  01D11D
          (0, 0, 26511, 26511),
         16#1E#           =>  --  01D11E
          (0, 0, 26512, 26512),
         16#1F#           =>  --  01D11F
          (0, 0, 26513, 26513),
         16#20#           =>  --  01D120
          (0, 0, 26514, 26514),
         16#21#           =>  --  01D121
          (0, 0, 26515, 26515),
         16#22#           =>  --  01D122
          (0, 0, 26516, 26516),
         16#23#           =>  --  01D123
          (0, 0, 26517, 26517),
         16#24#           =>  --  01D124
          (0, 0, 26518, 26518),
         16#25#           =>  --  01D125
          (0, 0, 26519, 26519),
         16#26#           =>  --  01D126
          (0, 0, 26520, 26520),
         16#27# .. 16#28# =>  --  01D127 .. 01D128
          (0, 0, 0, 0),
         16#29#           =>  --  01D129
          (0, 0, 26521, 26521),
         16#2A#           =>  --  01D12A
          (0, 0, 26522, 26522),
         16#2B#           =>  --  01D12B
          (0, 0, 26523, 26523),
         16#2C#           =>  --  01D12C
          (0, 0, 26524, 26524),
         16#2D#           =>  --  01D12D
          (0, 0, 26525, 26525),
         16#2E#           =>  --  01D12E
          (0, 0, 26526, 26526),
         16#2F#           =>  --  01D12F
          (0, 0, 26527, 26527),
         16#30#           =>  --  01D130
          (0, 0, 26528, 26528),
         16#31#           =>  --  01D131
          (0, 0, 26529, 26529),
         16#32#           =>  --  01D132
          (0, 0, 26530, 26530),
         16#33#           =>  --  01D133
          (0, 0, 26531, 26531),
         16#34#           =>  --  01D134
          (0, 0, 26532, 26532),
         16#35#           =>  --  01D135
          (0, 0, 26533, 26533),
         16#36#           =>  --  01D136
          (0, 0, 26534, 26534),
         16#37#           =>  --  01D137
          (0, 0, 26535, 26535),
         16#38#           =>  --  01D138
          (0, 0, 26536, 26536),
         16#39#           =>  --  01D139
          (0, 0, 26537, 26537),
         16#3A#           =>  --  01D13A
          (0, 0, 26538, 26538),
         16#3B#           =>  --  01D13B
          (0, 0, 26539, 26539),
         16#3C#           =>  --  01D13C
          (0, 0, 26540, 26540),
         16#3D#           =>  --  01D13D
          (0, 0, 26541, 26541),
         16#3E#           =>  --  01D13E
          (0, 0, 26542, 26542),
         16#3F#           =>  --  01D13F
          (0, 0, 26543, 26543),
         16#40#           =>  --  01D140
          (0, 0, 26544, 26544),
         16#41#           =>  --  01D141
          (0, 0, 26545, 26545),
         16#42#           =>  --  01D142
          (0, 0, 26546, 26546),
         16#43#           =>  --  01D143
          (0, 0, 26547, 26547),
         16#44#           =>  --  01D144
          (0, 0, 26548, 26548),
         16#45#           =>  --  01D145
          (0, 0, 26549, 26549),
         16#46#           =>  --  01D146
          (0, 0, 26550, 26550),
         16#47#           =>  --  01D147
          (0, 0, 26551, 26551),
         16#48#           =>  --  01D148
          (0, 0, 26552, 26552),
         16#49#           =>  --  01D149
          (0, 0, 26553, 26553),
         16#4A#           =>  --  01D14A
          (0, 0, 26554, 26554),
         16#4B#           =>  --  01D14B
          (0, 0, 26555, 26555),
         16#4C#           =>  --  01D14C
          (0, 0, 26556, 26556),
         16#4D#           =>  --  01D14D
          (0, 0, 26557, 26557),
         16#4E#           =>  --  01D14E
          (0, 0, 26558, 26558),
         16#4F#           =>  --  01D14F
          (0, 0, 26559, 26559),
         16#50#           =>  --  01D150
          (0, 0, 26560, 26560),
         16#51#           =>  --  01D151
          (0, 0, 26561, 26561),
         16#52#           =>  --  01D152
          (0, 0, 26562, 26562),
         16#53#           =>  --  01D153
          (0, 0, 26563, 26563),
         16#54#           =>  --  01D154
          (0, 0, 26564, 26564),
         16#55#           =>  --  01D155
          (0, 0, 26565, 26565),
         16#56#           =>  --  01D156
          (0, 0, 26566, 26566),
         16#57#           =>  --  01D157
          (0, 0, 26567, 26567),
         16#58#           =>  --  01D158
          (0, 0, 26568, 26568),
         16#59#           =>  --  01D159
          (0, 0, 26569, 26569),
         16#5A#           =>  --  01D15A
          (0, 0, 26570, 26570),
         16#5B#           =>  --  01D15B
          (0, 0, 26571, 26571),
         16#5C#           =>  --  01D15C
          (0, 0, 26572, 26572),
         16#5D#           =>  --  01D15D
          (0, 0, 26573, 26573),
         16#5E#           =>  --  01D15E
          (0, 0, 26567, 26567),
         16#5F# .. 16#64# =>  --  01D15F .. 01D164
          (0, 0, 26568, 26568),
         16#6A#           =>  --  01D16A
          (0, 0, 26574, 26574),
         16#6B#           =>  --  01D16B
          (0, 0, 26575, 26575),
         16#6C#           =>  --  01D16C
          (0, 0, 26576, 26576),
         16#83#           =>  --  01D183
          (0, 0, 26577, 26577),
         16#84#           =>  --  01D184
          (0, 0, 26578, 26578),
         16#8C#           =>  --  01D18C
          (0, 0, 26579, 26579),
         16#8D#           =>  --  01D18D
          (0, 0, 26580, 26580),
         16#8E#           =>  --  01D18E
          (0, 0, 26581, 26581),
         16#8F#           =>  --  01D18F
          (0, 0, 26582, 26582),
         16#90#           =>  --  01D190
          (0, 0, 26583, 26583),
         16#91#           =>  --  01D191
          (0, 0, 26584, 26584),
         16#92#           =>  --  01D192
          (0, 0, 26585, 26585),
         16#93#           =>  --  01D193
          (0, 0, 26586, 26586),
         16#94#           =>  --  01D194
          (0, 0, 26587, 26587),
         16#95#           =>  --  01D195
          (0, 0, 26588, 26588),
         16#96#           =>  --  01D196
          (0, 0, 26589, 26589),
         16#97#           =>  --  01D197
          (0, 0, 26590, 26590),
         16#98#           =>  --  01D198
          (0, 0, 26591, 26591),
         16#99#           =>  --  01D199
          (0, 0, 26592, 26592),
         16#9A#           =>  --  01D19A
          (0, 0, 26593, 26593),
         16#9B#           =>  --  01D19B
          (0, 0, 26594, 26594),
         16#9C#           =>  --  01D19C
          (0, 0, 26595, 26595),
         16#9D#           =>  --  01D19D
          (0, 0, 26596, 26596),
         16#9E#           =>  --  01D19E
          (0, 0, 26597, 26597),
         16#9F#           =>  --  01D19F
          (0, 0, 26598, 26598),
         16#A0#           =>  --  01D1A0
          (0, 0, 26599, 26599),
         16#A1#           =>  --  01D1A1
          (0, 0, 26600, 26600),
         16#A2#           =>  --  01D1A2
          (0, 0, 26601, 26601),
         16#A3#           =>  --  01D1A3
          (0, 0, 26602, 26602),
         16#A4#           =>  --  01D1A4
          (0, 0, 26603, 26603),
         16#A5#           =>  --  01D1A5
          (0, 0, 26604, 26604),
         16#A6#           =>  --  01D1A6
          (0, 0, 26605, 26605),
         16#A7#           =>  --  01D1A7
          (0, 0, 26606, 26606),
         16#A8#           =>  --  01D1A8
          (0, 0, 26607, 26607),
         16#A9#           =>  --  01D1A9
          (0, 0, 26608, 26608),
         16#AE#           =>  --  01D1AE
          (0, 0, 26609, 26609),
         16#AF#           =>  --  01D1AF
          (0, 0, 26610, 26610),
         16#B0#           =>  --  01D1B0
          (0, 0, 26611, 26611),
         16#B1#           =>  --  01D1B1
          (0, 0, 26612, 26612),
         16#B2#           =>  --  01D1B2
          (0, 0, 26613, 26613),
         16#B3#           =>  --  01D1B3
          (0, 0, 26614, 26614),
         16#B4#           =>  --  01D1B4
          (0, 0, 26615, 26615),
         16#B5#           =>  --  01D1B5
          (0, 0, 26616, 26616),
         16#B6#           =>  --  01D1B6
          (0, 0, 26617, 26617),
         16#B7#           =>  --  01D1B7
          (0, 0, 26618, 26618),
         16#B8#           =>  --  01D1B8
          (0, 0, 26619, 26619),
         16#B9#           =>  --  01D1B9
          (0, 0, 26620, 26620),
         16#BA#           =>  --  01D1BA
          (0, 0, 26621, 26621),
         16#BB#           =>  --  01D1BB
          (0, 0, 26620, 26620),
         16#BC#           =>  --  01D1BC
          (0, 0, 26621, 26621),
         16#BD#           =>  --  01D1BD
          (0, 0, 26620, 26620),
         16#BE#           =>  --  01D1BE
          (0, 0, 26621, 26621),
         16#BF#           =>  --  01D1BF
          (0, 0, 26620, 26620),
         16#C0#           =>  --  01D1C0
          (0, 0, 26621, 26621),
         16#C1#           =>  --  01D1C1
          (0, 0, 26622, 26622),
         16#C2#           =>  --  01D1C2
          (0, 0, 26623, 26623),
         16#C3#           =>  --  01D1C3
          (0, 0, 26624, 26624),
         16#C4#           =>  --  01D1C4
          (0, 0, 26625, 26625),
         16#C5#           =>  --  01D1C5
          (0, 0, 26626, 26626),
         16#C6#           =>  --  01D1C6
          (0, 0, 26627, 26627),
         16#C7#           =>  --  01D1C7
          (0, 0, 26628, 26628),
         16#C8#           =>  --  01D1C8
          (0, 0, 26629, 26629),
         16#C9#           =>  --  01D1C9
          (0, 0, 26630, 26630),
         16#CA#           =>  --  01D1CA
          (0, 0, 26631, 26631),
         16#CB#           =>  --  01D1CB
          (0, 0, 26632, 26632),
         16#CC#           =>  --  01D1CC
          (0, 0, 26633, 26633),
         16#CD#           =>  --  01D1CD
          (0, 0, 26634, 26634),
         16#CE#           =>  --  01D1CE
          (0, 0, 26635, 26635),
         16#CF#           =>  --  01D1CF
          (0, 0, 26636, 26636),
         16#D0#           =>  --  01D1D0
          (0, 0, 26637, 26637),
         16#D1#           =>  --  01D1D1
          (0, 0, 26638, 26638),
         16#D2#           =>  --  01D1D2
          (0, 0, 26639, 26639),
         16#D3#           =>  --  01D1D3
          (0, 0, 26640, 26640),
         16#D4#           =>  --  01D1D4
          (0, 0, 26641, 26641),
         16#D5#           =>  --  01D1D5
          (0, 0, 26642, 26642),
         16#D6#           =>  --  01D1D6
          (0, 0, 26643, 26643),
         16#D7#           =>  --  01D1D7
          (0, 0, 26644, 26644),
         16#D8#           =>  --  01D1D8
          (0, 0, 26645, 26645),
         16#D9#           =>  --  01D1D9
          (0, 0, 26646, 26646),
         16#DA#           =>  --  01D1DA
          (0, 0, 26647, 26647),
         16#DB#           =>  --  01D1DB
          (0, 0, 26648, 26648),
         16#DC#           =>  --  01D1DC
          (0, 0, 26649, 26649),
         16#DD#           =>  --  01D1DD
          (0, 0, 26650, 26650),
         16#DE# .. 16#FF# =>  --  01D1DE .. 01D1FF
          (0, 0, 0, 0),
         others           =>
          (0, 0, 1, 1));

   Group_01D2 : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  01D200
          (0, 0, 26651, 26651),
         16#01#           =>  --  01D201
          (0, 0, 26652, 26652),
         16#02#           =>  --  01D202
          (0, 0, 26653, 26653),
         16#03#           =>  --  01D203
          (0, 0, 26654, 26654),
         16#04#           =>  --  01D204
          (0, 0, 26655, 26655),
         16#05#           =>  --  01D205
          (0, 0, 26656, 26656),
         16#06#           =>  --  01D206
          (0, 0, 26657, 26657),
         16#07#           =>  --  01D207
          (0, 0, 26658, 26658),
         16#08#           =>  --  01D208
          (0, 0, 26659, 26659),
         16#09#           =>  --  01D209
          (0, 0, 26660, 26660),
         16#0A#           =>  --  01D20A
          (0, 0, 26661, 26661),
         16#0B#           =>  --  01D20B
          (0, 0, 26662, 26662),
         16#0C#           =>  --  01D20C
          (0, 0, 26663, 26663),
         16#0D#           =>  --  01D20D
          (0, 0, 26664, 26664),
         16#0E#           =>  --  01D20E
          (0, 0, 26665, 26665),
         16#0F#           =>  --  01D20F
          (0, 0, 26666, 26666),
         16#10#           =>  --  01D210
          (0, 0, 26667, 26667),
         16#11#           =>  --  01D211
          (0, 0, 26668, 26668),
         16#12#           =>  --  01D212
          (0, 0, 26669, 26669),
         16#13#           =>  --  01D213
          (0, 0, 26670, 26670),
         16#14#           =>  --  01D214
          (0, 0, 26671, 26671),
         16#15#           =>  --  01D215
          (0, 0, 26672, 26672),
         16#16#           =>  --  01D216
          (0, 0, 26673, 26673),
         16#17#           =>  --  01D217
          (0, 0, 26674, 26674),
         16#18#           =>  --  01D218
          (0, 0, 26675, 26675),
         16#19#           =>  --  01D219
          (0, 0, 26676, 26676),
         16#1A#           =>  --  01D21A
          (0, 0, 26677, 26677),
         16#1B#           =>  --  01D21B
          (0, 0, 26678, 26678),
         16#1C#           =>  --  01D21C
          (0, 0, 26679, 26679),
         16#1D#           =>  --  01D21D
          (0, 0, 26680, 26680),
         16#1E#           =>  --  01D21E
          (0, 0, 26681, 26681),
         16#1F#           =>  --  01D21F
          (0, 0, 26682, 26682),
         16#20#           =>  --  01D220
          (0, 0, 26683, 26683),
         16#21#           =>  --  01D221
          (0, 0, 26684, 26684),
         16#22#           =>  --  01D222
          (0, 0, 26685, 26685),
         16#23#           =>  --  01D223
          (0, 0, 26686, 26686),
         16#24#           =>  --  01D224
          (0, 0, 26687, 26687),
         16#25#           =>  --  01D225
          (0, 0, 26688, 26688),
         16#26#           =>  --  01D226
          (0, 0, 26689, 26689),
         16#27#           =>  --  01D227
          (0, 0, 26690, 26690),
         16#28#           =>  --  01D228
          (0, 0, 26691, 26691),
         16#29#           =>  --  01D229
          (0, 0, 26692, 26692),
         16#2A#           =>  --  01D22A
          (0, 0, 26693, 26693),
         16#2B#           =>  --  01D22B
          (0, 0, 26694, 26694),
         16#2C#           =>  --  01D22C
          (0, 0, 26695, 26695),
         16#2D#           =>  --  01D22D
          (0, 0, 26696, 26696),
         16#2E#           =>  --  01D22E
          (0, 0, 26697, 26697),
         16#2F#           =>  --  01D22F
          (0, 0, 26698, 26698),
         16#30#           =>  --  01D230
          (0, 0, 26699, 26699),
         16#31#           =>  --  01D231
          (0, 0, 26700, 26700),
         16#32#           =>  --  01D232
          (0, 0, 26701, 26701),
         16#33#           =>  --  01D233
          (0, 0, 26702, 26702),
         16#34#           =>  --  01D234
          (0, 0, 26703, 26703),
         16#35#           =>  --  01D235
          (0, 0, 26704, 26704),
         16#36#           =>  --  01D236
          (0, 0, 26705, 26705),
         16#37#           =>  --  01D237
          (0, 0, 26706, 26706),
         16#38#           =>  --  01D238
          (0, 0, 26707, 26707),
         16#39#           =>  --  01D239
          (0, 0, 26708, 26708),
         16#3A#           =>  --  01D23A
          (0, 0, 26709, 26709),
         16#3B#           =>  --  01D23B
          (0, 0, 26710, 26710),
         16#3C#           =>  --  01D23C
          (0, 0, 26711, 26711),
         16#3D#           =>  --  01D23D
          (0, 0, 26712, 26712),
         16#3E#           =>  --  01D23E
          (0, 0, 26713, 26713),
         16#3F#           =>  --  01D23F
          (0, 0, 26714, 26714),
         16#40#           =>  --  01D240
          (0, 0, 26715, 26715),
         16#41#           =>  --  01D241
          (0, 0, 26716, 26716),
         16#42# .. 16#44# =>  --  01D242 .. 01D244
          (0, 0, 1, 1),
         16#45#           =>  --  01D245
          (0, 0, 26717, 26717),
         others           =>
          (0, 0, 0, 0));

   Group_01D3 : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  01D300
          (0, 0, 26718, 26718),
         16#01#           =>  --  01D301
          (0, 0, 26719, 26719),
         16#02#           =>  --  01D302
          (0, 0, 26720, 26720),
         16#03#           =>  --  01D303
          (0, 0, 26721, 26721),
         16#04#           =>  --  01D304
          (0, 0, 26722, 26722),
         16#05#           =>  --  01D305
          (0, 0, 26723, 26723),
         16#06#           =>  --  01D306
          (0, 0, 26724, 26724),
         16#07#           =>  --  01D307
          (0, 0, 26725, 26725),
         16#08#           =>  --  01D308
          (0, 0, 26726, 26726),
         16#09#           =>  --  01D309
          (0, 0, 26727, 26727),
         16#0A#           =>  --  01D30A
          (0, 0, 26728, 26728),
         16#0B#           =>  --  01D30B
          (0, 0, 26729, 26729),
         16#0C#           =>  --  01D30C
          (0, 0, 26730, 26730),
         16#0D#           =>  --  01D30D
          (0, 0, 26731, 26731),
         16#0E#           =>  --  01D30E
          (0, 0, 26732, 26732),
         16#0F#           =>  --  01D30F
          (0, 0, 26733, 26733),
         16#10#           =>  --  01D310
          (0, 0, 26734, 26734),
         16#11#           =>  --  01D311
          (0, 0, 26735, 26735),
         16#12#           =>  --  01D312
          (0, 0, 26736, 26736),
         16#13#           =>  --  01D313
          (0, 0, 26737, 26737),
         16#14#           =>  --  01D314
          (0, 0, 26738, 26738),
         16#15#           =>  --  01D315
          (0, 0, 26739, 26739),
         16#16#           =>  --  01D316
          (0, 0, 26740, 26740),
         16#17#           =>  --  01D317
          (0, 0, 26741, 26741),
         16#18#           =>  --  01D318
          (0, 0, 26742, 26742),
         16#19#           =>  --  01D319
          (0, 0, 26743, 26743),
         16#1A#           =>  --  01D31A
          (0, 0, 26744, 26744),
         16#1B#           =>  --  01D31B
          (0, 0, 26745, 26745),
         16#1C#           =>  --  01D31C
          (0, 0, 26746, 26746),
         16#1D#           =>  --  01D31D
          (0, 0, 26747, 26747),
         16#1E#           =>  --  01D31E
          (0, 0, 26748, 26748),
         16#1F#           =>  --  01D31F
          (0, 0, 26749, 26749),
         16#20#           =>  --  01D320
          (0, 0, 26750, 26750),
         16#21#           =>  --  01D321
          (0, 0, 26751, 26751),
         16#22#           =>  --  01D322
          (0, 0, 26752, 26752),
         16#23#           =>  --  01D323
          (0, 0, 26753, 26753),
         16#24#           =>  --  01D324
          (0, 0, 26754, 26754),
         16#25#           =>  --  01D325
          (0, 0, 26755, 26755),
         16#26#           =>  --  01D326
          (0, 0, 26756, 26756),
         16#27#           =>  --  01D327
          (0, 0, 26757, 26757),
         16#28#           =>  --  01D328
          (0, 0, 26758, 26758),
         16#29#           =>  --  01D329
          (0, 0, 26759, 26759),
         16#2A#           =>  --  01D32A
          (0, 0, 26760, 26760),
         16#2B#           =>  --  01D32B
          (0, 0, 26761, 26761),
         16#2C#           =>  --  01D32C
          (0, 0, 26762, 26762),
         16#2D#           =>  --  01D32D
          (0, 0, 26763, 26763),
         16#2E#           =>  --  01D32E
          (0, 0, 26764, 26764),
         16#2F#           =>  --  01D32F
          (0, 0, 26765, 26765),
         16#30#           =>  --  01D330
          (0, 0, 26766, 26766),
         16#31#           =>  --  01D331
          (0, 0, 26767, 26767),
         16#32#           =>  --  01D332
          (0, 0, 26768, 26768),
         16#33#           =>  --  01D333
          (0, 0, 26769, 26769),
         16#34#           =>  --  01D334
          (0, 0, 26770, 26770),
         16#35#           =>  --  01D335
          (0, 0, 26771, 26771),
         16#36#           =>  --  01D336
          (0, 0, 26772, 26772),
         16#37#           =>  --  01D337
          (0, 0, 26773, 26773),
         16#38#           =>  --  01D338
          (0, 0, 26774, 26774),
         16#39#           =>  --  01D339
          (0, 0, 26775, 26775),
         16#3A#           =>  --  01D33A
          (0, 0, 26776, 26776),
         16#3B#           =>  --  01D33B
          (0, 0, 26777, 26777),
         16#3C#           =>  --  01D33C
          (0, 0, 26778, 26778),
         16#3D#           =>  --  01D33D
          (0, 0, 26779, 26779),
         16#3E#           =>  --  01D33E
          (0, 0, 26780, 26780),
         16#3F#           =>  --  01D33F
          (0, 0, 26781, 26781),
         16#40#           =>  --  01D340
          (0, 0, 26782, 26782),
         16#41#           =>  --  01D341
          (0, 0, 26783, 26783),
         16#42#           =>  --  01D342
          (0, 0, 26784, 26784),
         16#43#           =>  --  01D343
          (0, 0, 26785, 26785),
         16#44#           =>  --  01D344
          (0, 0, 26786, 26786),
         16#45#           =>  --  01D345
          (0, 0, 26787, 26787),
         16#46#           =>  --  01D346
          (0, 0, 26788, 26788),
         16#47#           =>  --  01D347
          (0, 0, 26789, 26789),
         16#48#           =>  --  01D348
          (0, 0, 26790, 26790),
         16#49#           =>  --  01D349
          (0, 0, 26791, 26791),
         16#4A#           =>  --  01D34A
          (0, 0, 26792, 26792),
         16#4B#           =>  --  01D34B
          (0, 0, 26793, 26793),
         16#4C#           =>  --  01D34C
          (0, 0, 26794, 26794),
         16#4D#           =>  --  01D34D
          (0, 0, 26795, 26795),
         16#4E#           =>  --  01D34E
          (0, 0, 26796, 26796),
         16#4F#           =>  --  01D34F
          (0, 0, 26797, 26797),
         16#50#           =>  --  01D350
          (0, 0, 26798, 26798),
         16#51#           =>  --  01D351
          (0, 0, 26799, 26799),
         16#52#           =>  --  01D352
          (0, 0, 26800, 26800),
         16#53#           =>  --  01D353
          (0, 0, 26801, 26801),
         16#54#           =>  --  01D354
          (0, 0, 26802, 26802),
         16#55#           =>  --  01D355
          (0, 0, 26803, 26803),
         16#56#           =>  --  01D356
          (0, 0, 26804, 26804),
         16#60#           =>  --  01D360
          (0, 0, 24, 24),
         16#61#           =>  --  01D361
          (0, 0, 25, 25),
         16#62#           =>  --  01D362
          (0, 0, 26, 26),
         16#63#           =>  --  01D363
          (0, 0, 27, 27),
         16#64#           =>  --  01D364
          (0, 0, 28, 28),
         16#65#           =>  --  01D365
          (0, 0, 29, 29),
         16#66#           =>  --  01D366
          (0, 0, 30, 30),
         16#67#           =>  --  01D367
          (0, 0, 31, 31),
         16#68#           =>  --  01D368
          (0, 0, 32, 32),
         16#69#           =>  --  01D369
          (0, 0, 26805, 26805),
         16#6A#           =>  --  01D36A
          (0, 0, 26806, 26806),
         16#6B#           =>  --  01D36B
          (0, 0, 26807, 26807),
         16#6C#           =>  --  01D36C
          (0, 0, 26808, 26808),
         16#6D#           =>  --  01D36D
          (0, 0, 26809, 26809),
         16#6E#           =>  --  01D36E
          (0, 0, 26810, 26810),
         16#6F#           =>  --  01D36F
          (0, 0, 26811, 26811),
         16#70#           =>  --  01D370
          (0, 0, 26812, 26812),
         16#71#           =>  --  01D371
          (0, 0, 26813, 26813),
         others           =>
          (0, 0, 0, 0));

   Group_01D4 : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  01D400
          (0, 0, 26814, 26814),
         16#01#           =>  --  01D401
          (0, 0, 8568, 8568),
         16#02#           =>  --  01D402
          (0, 0, 8525, 8525),
         16#03#           =>  --  01D403
          (0, 0, 8594, 8594),
         16#04#           =>  --  01D404
          (0, 0, 8571, 8571),
         16#05#           =>  --  01D405
          (0, 0, 8572, 8572),
         16#06#           =>  --  01D406
          (0, 0, 26815, 26815),
         16#07#           =>  --  01D407
          (0, 0, 8540, 8540),
         16#08#           =>  --  01D408
          (0, 0, 8542, 8542),
         16#09#           =>  --  01D409
          (0, 0, 26816, 26816),
         16#0A#           =>  --  01D40A
          (0, 0, 26817, 26817),
         16#0B#           =>  --  01D40B
          (0, 0, 8543, 8543),
         16#0C#           =>  --  01D40C
          (0, 0, 8574, 8574),
         16#0D#           =>  --  01D40D
          (0, 0, 8546, 8546),
         16#0E#           =>  --  01D40E
          (0, 0, 26818, 26818),
         16#0F#           =>  --  01D40F
          (0, 0, 8551, 8551),
         16#10#           =>  --  01D410
          (0, 0, 8552, 8552),
         16#11#           =>  --  01D411
          (0, 0, 8553, 8553),
         16#12#           =>  --  01D412
          (0, 0, 26819, 26819),
         16#13#           =>  --  01D413
          (0, 0, 26820, 26820),
         16#14#           =>  --  01D414
          (0, 0, 26821, 26821),
         16#15#           =>  --  01D415
          (0, 0, 26822, 26822),
         16#16#           =>  --  01D416
          (0, 0, 26823, 26823),
         16#17#           =>  --  01D417
          (0, 0, 26824, 26824),
         16#18#           =>  --  01D418
          (0, 0, 26825, 26825),
         16#19#           =>  --  01D419
          (0, 0, 8564, 8564),
         16#1A#           =>  --  01D41A
          (0, 0, 26826, 26826),
         16#1B#           =>  --  01D41B
          (0, 0, 26827, 26827),
         16#1C#           =>  --  01D41C
          (0, 0, 26828, 26828),
         16#1D#           =>  --  01D41D
          (0, 0, 8595, 8595),
         16#1E#           =>  --  01D41E
          (0, 0, 8570, 8570),
         16#1F#           =>  --  01D41F
          (0, 0, 26829, 26829),
         16#20#           =>  --  01D420
          (0, 0, 8539, 8539),
         16#21#           =>  --  01D421
          (0, 0, 8541, 8541),
         16#22#           =>  --  01D422
          (0, 0, 8580, 8580),
         16#23#           =>  --  01D423
          (0, 0, 8596, 8596),
         16#24#           =>  --  01D424
          (0, 0, 26830, 26830),
         16#25#           =>  --  01D425
          (0, 0, 8544, 8544),
         16#26#           =>  --  01D426
          (0, 0, 26831, 26831),
         16#27#           =>  --  01D427
          (0, 0, 26832, 26832),
         16#28#           =>  --  01D428
          (0, 0, 8575, 8575),
         16#29#           =>  --  01D429
          (0, 0, 26833, 26833),
         16#2A#           =>  --  01D42A
          (0, 0, 26834, 26834),
         16#2B#           =>  --  01D42B
          (0, 0, 26835, 26835),
         16#2C#           =>  --  01D42C
          (0, 0, 26836, 26836),
         16#2D#           =>  --  01D42D
          (0, 0, 26837, 26837),
         16#2E#           =>  --  01D42E
          (0, 0, 26838, 26838),
         16#2F#           =>  --  01D42F
          (0, 0, 26839, 26839),
         16#30#           =>  --  01D430
          (0, 0, 26840, 26840),
         16#31#           =>  --  01D431
          (0, 0, 26841, 26841),
         16#32#           =>  --  01D432
          (0, 0, 26842, 26842),
         16#33#           =>  --  01D433
          (0, 0, 26843, 26843),
         16#34#           =>  --  01D434
          (0, 0, 26814, 26814),
         16#35#           =>  --  01D435
          (0, 0, 8568, 8568),
         16#36#           =>  --  01D436
          (0, 0, 8525, 8525),
         16#37#           =>  --  01D437
          (0, 0, 8594, 8594),
         16#38#           =>  --  01D438
          (0, 0, 8571, 8571),
         16#39#           =>  --  01D439
          (0, 0, 8572, 8572),
         16#3A#           =>  --  01D43A
          (0, 0, 26815, 26815),
         16#3B#           =>  --  01D43B
          (0, 0, 8540, 8540),
         16#3C#           =>  --  01D43C
          (0, 0, 8542, 8542),
         16#3D#           =>  --  01D43D
          (0, 0, 26816, 26816),
         16#3E#           =>  --  01D43E
          (0, 0, 26817, 26817),
         16#3F#           =>  --  01D43F
          (0, 0, 8543, 8543),
         16#40#           =>  --  01D440
          (0, 0, 8574, 8574),
         16#41#           =>  --  01D441
          (0, 0, 8546, 8546),
         16#42#           =>  --  01D442
          (0, 0, 26818, 26818),
         16#43#           =>  --  01D443
          (0, 0, 8551, 8551),
         16#44#           =>  --  01D444
          (0, 0, 8552, 8552),
         16#45#           =>  --  01D445
          (0, 0, 8553, 8553),
         16#46#           =>  --  01D446
          (0, 0, 26819, 26819),
         16#47#           =>  --  01D447
          (0, 0, 26820, 26820),
         16#48#           =>  --  01D448
          (0, 0, 26821, 26821),
         16#49#           =>  --  01D449
          (0, 0, 26822, 26822),
         16#4A#           =>  --  01D44A
          (0, 0, 26823, 26823),
         16#4B#           =>  --  01D44B
          (0, 0, 26824, 26824),
         16#4C#           =>  --  01D44C
          (0, 0, 26825, 26825),
         16#4D#           =>  --  01D44D
          (0, 0, 8564, 8564),
         16#4E#           =>  --  01D44E
          (0, 0, 26826, 26826),
         16#4F#           =>  --  01D44F
          (0, 0, 26827, 26827),
         16#50#           =>  --  01D450
          (0, 0, 26828, 26828),
         16#51#           =>  --  01D451
          (0, 0, 8595, 8595),
         16#52#           =>  --  01D452
          (0, 0, 8570, 8570),
         16#53#           =>  --  01D453
          (0, 0, 26829, 26829),
         16#54#           =>  --  01D454
          (0, 0, 8539, 8539),
         16#56#           =>  --  01D456
          (0, 0, 8580, 8580),
         16#57#           =>  --  01D457
          (0, 0, 8596, 8596),
         16#58#           =>  --  01D458
          (0, 0, 26830, 26830),
         16#59#           =>  --  01D459
          (0, 0, 8544, 8544),
         16#5A#           =>  --  01D45A
          (0, 0, 26831, 26831),
         16#5B#           =>  --  01D45B
          (0, 0, 26832, 26832),
         16#5C#           =>  --  01D45C
          (0, 0, 8575, 8575),
         16#5D#           =>  --  01D45D
          (0, 0, 26833, 26833),
         16#5E#           =>  --  01D45E
          (0, 0, 26834, 26834),
         16#5F#           =>  --  01D45F
          (0, 0, 26835, 26835),
         16#60#           =>  --  01D460
          (0, 0, 26836, 26836),
         16#61#           =>  --  01D461
          (0, 0, 26837, 26837),
         16#62#           =>  --  01D462
          (0, 0, 26838, 26838),
         16#63#           =>  --  01D463
          (0, 0, 26839, 26839),
         16#64#           =>  --  01D464
          (0, 0, 26840, 26840),
         16#65#           =>  --  01D465
          (0, 0, 26841, 26841),
         16#66#           =>  --  01D466
          (0, 0, 26842, 26842),
         16#67#           =>  --  01D467
          (0, 0, 26843, 26843),
         16#68#           =>  --  01D468
          (0, 0, 26814, 26814),
         16#69#           =>  --  01D469
          (0, 0, 8568, 8568),
         16#6A#           =>  --  01D46A
          (0, 0, 8525, 8525),
         16#6B#           =>  --  01D46B
          (0, 0, 8594, 8594),
         16#6C#           =>  --  01D46C
          (0, 0, 8571, 8571),
         16#6D#           =>  --  01D46D
          (0, 0, 8572, 8572),
         16#6E#           =>  --  01D46E
          (0, 0, 26815, 26815),
         16#6F#           =>  --  01D46F
          (0, 0, 8540, 8540),
         16#70#           =>  --  01D470
          (0, 0, 8542, 8542),
         16#71#           =>  --  01D471
          (0, 0, 26816, 26816),
         16#72#           =>  --  01D472
          (0, 0, 26817, 26817),
         16#73#           =>  --  01D473
          (0, 0, 8543, 8543),
         16#74#           =>  --  01D474
          (0, 0, 8574, 8574),
         16#75#           =>  --  01D475
          (0, 0, 8546, 8546),
         16#76#           =>  --  01D476
          (0, 0, 26818, 26818),
         16#77#           =>  --  01D477
          (0, 0, 8551, 8551),
         16#78#           =>  --  01D478
          (0, 0, 8552, 8552),
         16#79#           =>  --  01D479
          (0, 0, 8553, 8553),
         16#7A#           =>  --  01D47A
          (0, 0, 26819, 26819),
         16#7B#           =>  --  01D47B
          (0, 0, 26820, 26820),
         16#7C#           =>  --  01D47C
          (0, 0, 26821, 26821),
         16#7D#           =>  --  01D47D
          (0, 0, 26822, 26822),
         16#7E#           =>  --  01D47E
          (0, 0, 26823, 26823),
         16#7F#           =>  --  01D47F
          (0, 0, 26824, 26824),
         16#80#           =>  --  01D480
          (0, 0, 26825, 26825),
         16#81#           =>  --  01D481
          (0, 0, 8564, 8564),
         16#82#           =>  --  01D482
          (0, 0, 26826, 26826),
         16#83#           =>  --  01D483
          (0, 0, 26827, 26827),
         16#84#           =>  --  01D484
          (0, 0, 26828, 26828),
         16#85#           =>  --  01D485
          (0, 0, 8595, 8595),
         16#86#           =>  --  01D486
          (0, 0, 8570, 8570),
         16#87#           =>  --  01D487
          (0, 0, 26829, 26829),
         16#88#           =>  --  01D488
          (0, 0, 8539, 8539),
         16#89#           =>  --  01D489
          (0, 0, 8541, 8541),
         16#8A#           =>  --  01D48A
          (0, 0, 8580, 8580),
         16#8B#           =>  --  01D48B
          (0, 0, 8596, 8596),
         16#8C#           =>  --  01D48C
          (0, 0, 26830, 26830),
         16#8D#           =>  --  01D48D
          (0, 0, 8544, 8544),
         16#8E#           =>  --  01D48E
          (0, 0, 26831, 26831),
         16#8F#           =>  --  01D48F
          (0, 0, 26832, 26832),
         16#90#           =>  --  01D490
          (0, 0, 8575, 8575),
         16#91#           =>  --  01D491
          (0, 0, 26833, 26833),
         16#92#           =>  --  01D492
          (0, 0, 26834, 26834),
         16#93#           =>  --  01D493
          (0, 0, 26835, 26835),
         16#94#           =>  --  01D494
          (0, 0, 26836, 26836),
         16#95#           =>  --  01D495
          (0, 0, 26837, 26837),
         16#96#           =>  --  01D496
          (0, 0, 26838, 26838),
         16#97#           =>  --  01D497
          (0, 0, 26839, 26839),
         16#98#           =>  --  01D498
          (0, 0, 26840, 26840),
         16#99#           =>  --  01D499
          (0, 0, 26841, 26841),
         16#9A#           =>  --  01D49A
          (0, 0, 26842, 26842),
         16#9B#           =>  --  01D49B
          (0, 0, 26843, 26843),
         16#9C#           =>  --  01D49C
          (0, 0, 26814, 26814),
         16#9E#           =>  --  01D49E
          (0, 0, 8525, 8525),
         16#9F#           =>  --  01D49F
          (0, 0, 8594, 8594),
         16#A2#           =>  --  01D4A2
          (0, 0, 26815, 26815),
         16#A5#           =>  --  01D4A5
          (0, 0, 26816, 26816),
         16#A6#           =>  --  01D4A6
          (0, 0, 26817, 26817),
         16#A9#           =>  --  01D4A9
          (0, 0, 8546, 8546),
         16#AA#           =>  --  01D4AA
          (0, 0, 26818, 26818),
         16#AB#           =>  --  01D4AB
          (0, 0, 8551, 8551),
         16#AC#           =>  --  01D4AC
          (0, 0, 8552, 8552),
         16#AE#           =>  --  01D4AE
          (0, 0, 26819, 26819),
         16#AF#           =>  --  01D4AF
          (0, 0, 26820, 26820),
         16#B0#           =>  --  01D4B0
          (0, 0, 26821, 26821),
         16#B1#           =>  --  01D4B1
          (0, 0, 26822, 26822),
         16#B2#           =>  --  01D4B2
          (0, 0, 26823, 26823),
         16#B3#           =>  --  01D4B3
          (0, 0, 26824, 26824),
         16#B4#           =>  --  01D4B4
          (0, 0, 26825, 26825),
         16#B5#           =>  --  01D4B5
          (0, 0, 8564, 8564),
         16#B6#           =>  --  01D4B6
          (0, 0, 26826, 26826),
         16#B7#           =>  --  01D4B7
          (0, 0, 26827, 26827),
         16#B8#           =>  --  01D4B8
          (0, 0, 26828, 26828),
         16#B9#           =>  --  01D4B9
          (0, 0, 8595, 8595),
         16#BB#           =>  --  01D4BB
          (0, 0, 26829, 26829),
         16#BD#           =>  --  01D4BD
          (0, 0, 8541, 8541),
         16#BE#           =>  --  01D4BE
          (0, 0, 8580, 8580),
         16#BF#           =>  --  01D4BF
          (0, 0, 8596, 8596),
         16#C0#           =>  --  01D4C0
          (0, 0, 26830, 26830),
         16#C1#           =>  --  01D4C1
          (0, 0, 8544, 8544),
         16#C2#           =>  --  01D4C2
          (0, 0, 26831, 26831),
         16#C3#           =>  --  01D4C3
          (0, 0, 26832, 26832),
         16#C5#           =>  --  01D4C5
          (0, 0, 26833, 26833),
         16#C6#           =>  --  01D4C6
          (0, 0, 26834, 26834),
         16#C7#           =>  --  01D4C7
          (0, 0, 26835, 26835),
         16#C8#           =>  --  01D4C8
          (0, 0, 26836, 26836),
         16#C9#           =>  --  01D4C9
          (0, 0, 26837, 26837),
         16#CA#           =>  --  01D4CA
          (0, 0, 26838, 26838),
         16#CB#           =>  --  01D4CB
          (0, 0, 26839, 26839),
         16#CC#           =>  --  01D4CC
          (0, 0, 26840, 26840),
         16#CD#           =>  --  01D4CD
          (0, 0, 26841, 26841),
         16#CE#           =>  --  01D4CE
          (0, 0, 26842, 26842),
         16#CF#           =>  --  01D4CF
          (0, 0, 26843, 26843),
         16#D0#           =>  --  01D4D0
          (0, 0, 26814, 26814),
         16#D1#           =>  --  01D4D1
          (0, 0, 8568, 8568),
         16#D2#           =>  --  01D4D2
          (0, 0, 8525, 8525),
         16#D3#           =>  --  01D4D3
          (0, 0, 8594, 8594),
         16#D4#           =>  --  01D4D4
          (0, 0, 8571, 8571),
         16#D5#           =>  --  01D4D5
          (0, 0, 8572, 8572),
         16#D6#           =>  --  01D4D6
          (0, 0, 26815, 26815),
         16#D7#           =>  --  01D4D7
          (0, 0, 8540, 8540),
         16#D8#           =>  --  01D4D8
          (0, 0, 8542, 8542),
         16#D9#           =>  --  01D4D9
          (0, 0, 26816, 26816),
         16#DA#           =>  --  01D4DA
          (0, 0, 26817, 26817),
         16#DB#           =>  --  01D4DB
          (0, 0, 8543, 8543),
         16#DC#           =>  --  01D4DC
          (0, 0, 8574, 8574),
         16#DD#           =>  --  01D4DD
          (0, 0, 8546, 8546),
         16#DE#           =>  --  01D4DE
          (0, 0, 26818, 26818),
         16#DF#           =>  --  01D4DF
          (0, 0, 8551, 8551),
         16#E0#           =>  --  01D4E0
          (0, 0, 8552, 8552),
         16#E1#           =>  --  01D4E1
          (0, 0, 8553, 8553),
         16#E2#           =>  --  01D4E2
          (0, 0, 26819, 26819),
         16#E3#           =>  --  01D4E3
          (0, 0, 26820, 26820),
         16#E4#           =>  --  01D4E4
          (0, 0, 26821, 26821),
         16#E5#           =>  --  01D4E5
          (0, 0, 26822, 26822),
         16#E6#           =>  --  01D4E6
          (0, 0, 26823, 26823),
         16#E7#           =>  --  01D4E7
          (0, 0, 26824, 26824),
         16#E8#           =>  --  01D4E8
          (0, 0, 26825, 26825),
         16#E9#           =>  --  01D4E9
          (0, 0, 8564, 8564),
         16#EA#           =>  --  01D4EA
          (0, 0, 26826, 26826),
         16#EB#           =>  --  01D4EB
          (0, 0, 26827, 26827),
         16#EC#           =>  --  01D4EC
          (0, 0, 26828, 26828),
         16#ED#           =>  --  01D4ED
          (0, 0, 8595, 8595),
         16#EE#           =>  --  01D4EE
          (0, 0, 8570, 8570),
         16#EF#           =>  --  01D4EF
          (0, 0, 26829, 26829),
         16#F0#           =>  --  01D4F0
          (0, 0, 8539, 8539),
         16#F1#           =>  --  01D4F1
          (0, 0, 8541, 8541),
         16#F2#           =>  --  01D4F2
          (0, 0, 8580, 8580),
         16#F3#           =>  --  01D4F3
          (0, 0, 8596, 8596),
         16#F4#           =>  --  01D4F4
          (0, 0, 26830, 26830),
         16#F5#           =>  --  01D4F5
          (0, 0, 8544, 8544),
         16#F6#           =>  --  01D4F6
          (0, 0, 26831, 26831),
         16#F7#           =>  --  01D4F7
          (0, 0, 26832, 26832),
         16#F8#           =>  --  01D4F8
          (0, 0, 8575, 8575),
         16#F9#           =>  --  01D4F9
          (0, 0, 26833, 26833),
         16#FA#           =>  --  01D4FA
          (0, 0, 26834, 26834),
         16#FB#           =>  --  01D4FB
          (0, 0, 26835, 26835),
         16#FC#           =>  --  01D4FC
          (0, 0, 26836, 26836),
         16#FD#           =>  --  01D4FD
          (0, 0, 26837, 26837),
         16#FE#           =>  --  01D4FE
          (0, 0, 26838, 26838),
         16#FF#           =>  --  01D4FF
          (0, 0, 26839, 26839),
         others           =>
          (0, 0, 0, 0));

   Group_01D5 : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  01D500
          (0, 0, 26840, 26840),
         16#01#           =>  --  01D501
          (0, 0, 26841, 26841),
         16#02#           =>  --  01D502
          (0, 0, 26842, 26842),
         16#03#           =>  --  01D503
          (0, 0, 26843, 26843),
         16#04#           =>  --  01D504
          (0, 0, 26814, 26814),
         16#05#           =>  --  01D505
          (0, 0, 8568, 8568),
         16#07#           =>  --  01D507
          (0, 0, 8594, 8594),
         16#08#           =>  --  01D508
          (0, 0, 8571, 8571),
         16#09#           =>  --  01D509
          (0, 0, 8572, 8572),
         16#0A#           =>  --  01D50A
          (0, 0, 26815, 26815),
         16#0D#           =>  --  01D50D
          (0, 0, 26816, 26816),
         16#0E#           =>  --  01D50E
          (0, 0, 26817, 26817),
         16#0F#           =>  --  01D50F
          (0, 0, 8543, 8543),
         16#10#           =>  --  01D510
          (0, 0, 8574, 8574),
         16#11#           =>  --  01D511
          (0, 0, 8546, 8546),
         16#12#           =>  --  01D512
          (0, 0, 26818, 26818),
         16#13#           =>  --  01D513
          (0, 0, 8551, 8551),
         16#14#           =>  --  01D514
          (0, 0, 8552, 8552),
         16#16#           =>  --  01D516
          (0, 0, 26819, 26819),
         16#17#           =>  --  01D517
          (0, 0, 26820, 26820),
         16#18#           =>  --  01D518
          (0, 0, 26821, 26821),
         16#19#           =>  --  01D519
          (0, 0, 26822, 26822),
         16#1A#           =>  --  01D51A
          (0, 0, 26823, 26823),
         16#1B#           =>  --  01D51B
          (0, 0, 26824, 26824),
         16#1C#           =>  --  01D51C
          (0, 0, 26825, 26825),
         16#1E#           =>  --  01D51E
          (0, 0, 26826, 26826),
         16#1F#           =>  --  01D51F
          (0, 0, 26827, 26827),
         16#20#           =>  --  01D520
          (0, 0, 26828, 26828),
         16#21#           =>  --  01D521
          (0, 0, 8595, 8595),
         16#22#           =>  --  01D522
          (0, 0, 8570, 8570),
         16#23#           =>  --  01D523
          (0, 0, 26829, 26829),
         16#24#           =>  --  01D524
          (0, 0, 8539, 8539),
         16#25#           =>  --  01D525
          (0, 0, 8541, 8541),
         16#26#           =>  --  01D526
          (0, 0, 8580, 8580),
         16#27#           =>  --  01D527
          (0, 0, 8596, 8596),
         16#28#           =>  --  01D528
          (0, 0, 26830, 26830),
         16#29#           =>  --  01D529
          (0, 0, 8544, 8544),
         16#2A#           =>  --  01D52A
          (0, 0, 26831, 26831),
         16#2B#           =>  --  01D52B
          (0, 0, 26832, 26832),
         16#2C#           =>  --  01D52C
          (0, 0, 8575, 8575),
         16#2D#           =>  --  01D52D
          (0, 0, 26833, 26833),
         16#2E#           =>  --  01D52E
          (0, 0, 26834, 26834),
         16#2F#           =>  --  01D52F
          (0, 0, 26835, 26835),
         16#30#           =>  --  01D530
          (0, 0, 26836, 26836),
         16#31#           =>  --  01D531
          (0, 0, 26837, 26837),
         16#32#           =>  --  01D532
          (0, 0, 26838, 26838),
         16#33#           =>  --  01D533
          (0, 0, 26839, 26839),
         16#34#           =>  --  01D534
          (0, 0, 26840, 26840),
         16#35#           =>  --  01D535
          (0, 0, 26841, 26841),
         16#36#           =>  --  01D536
          (0, 0, 26842, 26842),
         16#37#           =>  --  01D537
          (0, 0, 26843, 26843),
         16#38#           =>  --  01D538
          (0, 0, 26814, 26814),
         16#39#           =>  --  01D539
          (0, 0, 8568, 8568),
         16#3B#           =>  --  01D53B
          (0, 0, 8594, 8594),
         16#3C#           =>  --  01D53C
          (0, 0, 8571, 8571),
         16#3D#           =>  --  01D53D
          (0, 0, 8572, 8572),
         16#3E#           =>  --  01D53E
          (0, 0, 26815, 26815),
         16#40#           =>  --  01D540
          (0, 0, 8542, 8542),
         16#41#           =>  --  01D541
          (0, 0, 26816, 26816),
         16#42#           =>  --  01D542
          (0, 0, 26817, 26817),
         16#43#           =>  --  01D543
          (0, 0, 8543, 8543),
         16#44#           =>  --  01D544
          (0, 0, 8574, 8574),
         16#46#           =>  --  01D546
          (0, 0, 26818, 26818),
         16#4A#           =>  --  01D54A
          (0, 0, 26819, 26819),
         16#4B#           =>  --  01D54B
          (0, 0, 26820, 26820),
         16#4C#           =>  --  01D54C
          (0, 0, 26821, 26821),
         16#4D#           =>  --  01D54D
          (0, 0, 26822, 26822),
         16#4E#           =>  --  01D54E
          (0, 0, 26823, 26823),
         16#4F#           =>  --  01D54F
          (0, 0, 26824, 26824),
         16#50#           =>  --  01D550
          (0, 0, 26825, 26825),
         16#52#           =>  --  01D552
          (0, 0, 26826, 26826),
         16#53#           =>  --  01D553
          (0, 0, 26827, 26827),
         16#54#           =>  --  01D554
          (0, 0, 26828, 26828),
         16#55#           =>  --  01D555
          (0, 0, 8595, 8595),
         16#56#           =>  --  01D556
          (0, 0, 8570, 8570),
         16#57#           =>  --  01D557
          (0, 0, 26829, 26829),
         16#58#           =>  --  01D558
          (0, 0, 8539, 8539),
         16#59#           =>  --  01D559
          (0, 0, 8541, 8541),
         16#5A#           =>  --  01D55A
          (0, 0, 8580, 8580),
         16#5B#           =>  --  01D55B
          (0, 0, 8596, 8596),
         16#5C#           =>  --  01D55C
          (0, 0, 26830, 26830),
         16#5D#           =>  --  01D55D
          (0, 0, 8544, 8544),
         16#5E#           =>  --  01D55E
          (0, 0, 26831, 26831),
         16#5F#           =>  --  01D55F
          (0, 0, 26832, 26832),
         16#60#           =>  --  01D560
          (0, 0, 8575, 8575),
         16#61#           =>  --  01D561
          (0, 0, 26833, 26833),
         16#62#           =>  --  01D562
          (0, 0, 26834, 26834),
         16#63#           =>  --  01D563
          (0, 0, 26835, 26835),
         16#64#           =>  --  01D564
          (0, 0, 26836, 26836),
         16#65#           =>  --  01D565
          (0, 0, 26837, 26837),
         16#66#           =>  --  01D566
          (0, 0, 26838, 26838),
         16#67#           =>  --  01D567
          (0, 0, 26839, 26839),
         16#68#           =>  --  01D568
          (0, 0, 26840, 26840),
         16#69#           =>  --  01D569
          (0, 0, 26841, 26841),
         16#6A#           =>  --  01D56A
          (0, 0, 26842, 26842),
         16#6B#           =>  --  01D56B
          (0, 0, 26843, 26843),
         16#6C#           =>  --  01D56C
          (0, 0, 26814, 26814),
         16#6D#           =>  --  01D56D
          (0, 0, 8568, 8568),
         16#6E#           =>  --  01D56E
          (0, 0, 8525, 8525),
         16#6F#           =>  --  01D56F
          (0, 0, 8594, 8594),
         16#70#           =>  --  01D570
          (0, 0, 8571, 8571),
         16#71#           =>  --  01D571
          (0, 0, 8572, 8572),
         16#72#           =>  --  01D572
          (0, 0, 26815, 26815),
         16#73#           =>  --  01D573
          (0, 0, 8540, 8540),
         16#74#           =>  --  01D574
          (0, 0, 8542, 8542),
         16#75#           =>  --  01D575
          (0, 0, 26816, 26816),
         16#76#           =>  --  01D576
          (0, 0, 26817, 26817),
         16#77#           =>  --  01D577
          (0, 0, 8543, 8543),
         16#78#           =>  --  01D578
          (0, 0, 8574, 8574),
         16#79#           =>  --  01D579
          (0, 0, 8546, 8546),
         16#7A#           =>  --  01D57A
          (0, 0, 26818, 26818),
         16#7B#           =>  --  01D57B
          (0, 0, 8551, 8551),
         16#7C#           =>  --  01D57C
          (0, 0, 8552, 8552),
         16#7D#           =>  --  01D57D
          (0, 0, 8553, 8553),
         16#7E#           =>  --  01D57E
          (0, 0, 26819, 26819),
         16#7F#           =>  --  01D57F
          (0, 0, 26820, 26820),
         16#80#           =>  --  01D580
          (0, 0, 26821, 26821),
         16#81#           =>  --  01D581
          (0, 0, 26822, 26822),
         16#82#           =>  --  01D582
          (0, 0, 26823, 26823),
         16#83#           =>  --  01D583
          (0, 0, 26824, 26824),
         16#84#           =>  --  01D584
          (0, 0, 26825, 26825),
         16#85#           =>  --  01D585
          (0, 0, 8564, 8564),
         16#86#           =>  --  01D586
          (0, 0, 26826, 26826),
         16#87#           =>  --  01D587
          (0, 0, 26827, 26827),
         16#88#           =>  --  01D588
          (0, 0, 26828, 26828),
         16#89#           =>  --  01D589
          (0, 0, 8595, 8595),
         16#8A#           =>  --  01D58A
          (0, 0, 8570, 8570),
         16#8B#           =>  --  01D58B
          (0, 0, 26829, 26829),
         16#8C#           =>  --  01D58C
          (0, 0, 8539, 8539),
         16#8D#           =>  --  01D58D
          (0, 0, 8541, 8541),
         16#8E#           =>  --  01D58E
          (0, 0, 8580, 8580),
         16#8F#           =>  --  01D58F
          (0, 0, 8596, 8596),
         16#90#           =>  --  01D590
          (0, 0, 26830, 26830),
         16#91#           =>  --  01D591
          (0, 0, 8544, 8544),
         16#92#           =>  --  01D592
          (0, 0, 26831, 26831),
         16#93#           =>  --  01D593
          (0, 0, 26832, 26832),
         16#94#           =>  --  01D594
          (0, 0, 8575, 8575),
         16#95#           =>  --  01D595
          (0, 0, 26833, 26833),
         16#96#           =>  --  01D596
          (0, 0, 26834, 26834),
         16#97#           =>  --  01D597
          (0, 0, 26835, 26835),
         16#98#           =>  --  01D598
          (0, 0, 26836, 26836),
         16#99#           =>  --  01D599
          (0, 0, 26837, 26837),
         16#9A#           =>  --  01D59A
          (0, 0, 26838, 26838),
         16#9B#           =>  --  01D59B
          (0, 0, 26839, 26839),
         16#9C#           =>  --  01D59C
          (0, 0, 26840, 26840),
         16#9D#           =>  --  01D59D
          (0, 0, 26841, 26841),
         16#9E#           =>  --  01D59E
          (0, 0, 26842, 26842),
         16#9F#           =>  --  01D59F
          (0, 0, 26843, 26843),
         16#A0#           =>  --  01D5A0
          (0, 0, 26814, 26814),
         16#A1#           =>  --  01D5A1
          (0, 0, 8568, 8568),
         16#A2#           =>  --  01D5A2
          (0, 0, 8525, 8525),
         16#A3#           =>  --  01D5A3
          (0, 0, 8594, 8594),
         16#A4#           =>  --  01D5A4
          (0, 0, 8571, 8571),
         16#A5#           =>  --  01D5A5
          (0, 0, 8572, 8572),
         16#A6#           =>  --  01D5A6
          (0, 0, 26815, 26815),
         16#A7#           =>  --  01D5A7
          (0, 0, 8540, 8540),
         16#A8#           =>  --  01D5A8
          (0, 0, 8542, 8542),
         16#A9#           =>  --  01D5A9
          (0, 0, 26816, 26816),
         16#AA#           =>  --  01D5AA
          (0, 0, 26817, 26817),
         16#AB#           =>  --  01D5AB
          (0, 0, 8543, 8543),
         16#AC#           =>  --  01D5AC
          (0, 0, 8574, 8574),
         16#AD#           =>  --  01D5AD
          (0, 0, 8546, 8546),
         16#AE#           =>  --  01D5AE
          (0, 0, 26818, 26818),
         16#AF#           =>  --  01D5AF
          (0, 0, 8551, 8551),
         16#B0#           =>  --  01D5B0
          (0, 0, 8552, 8552),
         16#B1#           =>  --  01D5B1
          (0, 0, 8553, 8553),
         16#B2#           =>  --  01D5B2
          (0, 0, 26819, 26819),
         16#B3#           =>  --  01D5B3
          (0, 0, 26820, 26820),
         16#B4#           =>  --  01D5B4
          (0, 0, 26821, 26821),
         16#B5#           =>  --  01D5B5
          (0, 0, 26822, 26822),
         16#B6#           =>  --  01D5B6
          (0, 0, 26823, 26823),
         16#B7#           =>  --  01D5B7
          (0, 0, 26824, 26824),
         16#B8#           =>  --  01D5B8
          (0, 0, 26825, 26825),
         16#B9#           =>  --  01D5B9
          (0, 0, 8564, 8564),
         16#BA#           =>  --  01D5BA
          (0, 0, 26826, 26826),
         16#BB#           =>  --  01D5BB
          (0, 0, 26827, 26827),
         16#BC#           =>  --  01D5BC
          (0, 0, 26828, 26828),
         16#BD#           =>  --  01D5BD
          (0, 0, 8595, 8595),
         16#BE#           =>  --  01D5BE
          (0, 0, 8570, 8570),
         16#BF#           =>  --  01D5BF
          (0, 0, 26829, 26829),
         16#C0#           =>  --  01D5C0
          (0, 0, 8539, 8539),
         16#C1#           =>  --  01D5C1
          (0, 0, 8541, 8541),
         16#C2#           =>  --  01D5C2
          (0, 0, 8580, 8580),
         16#C3#           =>  --  01D5C3
          (0, 0, 8596, 8596),
         16#C4#           =>  --  01D5C4
          (0, 0, 26830, 26830),
         16#C5#           =>  --  01D5C5
          (0, 0, 8544, 8544),
         16#C6#           =>  --  01D5C6
          (0, 0, 26831, 26831),
         16#C7#           =>  --  01D5C7
          (0, 0, 26832, 26832),
         16#C8#           =>  --  01D5C8
          (0, 0, 8575, 8575),
         16#C9#           =>  --  01D5C9
          (0, 0, 26833, 26833),
         16#CA#           =>  --  01D5CA
          (0, 0, 26834, 26834),
         16#CB#           =>  --  01D5CB
          (0, 0, 26835, 26835),
         16#CC#           =>  --  01D5CC
          (0, 0, 26836, 26836),
         16#CD#           =>  --  01D5CD
          (0, 0, 26837, 26837),
         16#CE#           =>  --  01D5CE
          (0, 0, 26838, 26838),
         16#CF#           =>  --  01D5CF
          (0, 0, 26839, 26839),
         16#D0#           =>  --  01D5D0
          (0, 0, 26840, 26840),
         16#D1#           =>  --  01D5D1
          (0, 0, 26841, 26841),
         16#D2#           =>  --  01D5D2
          (0, 0, 26842, 26842),
         16#D3#           =>  --  01D5D3
          (0, 0, 26843, 26843),
         16#D4#           =>  --  01D5D4
          (0, 0, 26814, 26814),
         16#D5#           =>  --  01D5D5
          (0, 0, 8568, 8568),
         16#D6#           =>  --  01D5D6
          (0, 0, 8525, 8525),
         16#D7#           =>  --  01D5D7
          (0, 0, 8594, 8594),
         16#D8#           =>  --  01D5D8
          (0, 0, 8571, 8571),
         16#D9#           =>  --  01D5D9
          (0, 0, 8572, 8572),
         16#DA#           =>  --  01D5DA
          (0, 0, 26815, 26815),
         16#DB#           =>  --  01D5DB
          (0, 0, 8540, 8540),
         16#DC#           =>  --  01D5DC
          (0, 0, 8542, 8542),
         16#DD#           =>  --  01D5DD
          (0, 0, 26816, 26816),
         16#DE#           =>  --  01D5DE
          (0, 0, 26817, 26817),
         16#DF#           =>  --  01D5DF
          (0, 0, 8543, 8543),
         16#E0#           =>  --  01D5E0
          (0, 0, 8574, 8574),
         16#E1#           =>  --  01D5E1
          (0, 0, 8546, 8546),
         16#E2#           =>  --  01D5E2
          (0, 0, 26818, 26818),
         16#E3#           =>  --  01D5E3
          (0, 0, 8551, 8551),
         16#E4#           =>  --  01D5E4
          (0, 0, 8552, 8552),
         16#E5#           =>  --  01D5E5
          (0, 0, 8553, 8553),
         16#E6#           =>  --  01D5E6
          (0, 0, 26819, 26819),
         16#E7#           =>  --  01D5E7
          (0, 0, 26820, 26820),
         16#E8#           =>  --  01D5E8
          (0, 0, 26821, 26821),
         16#E9#           =>  --  01D5E9
          (0, 0, 26822, 26822),
         16#EA#           =>  --  01D5EA
          (0, 0, 26823, 26823),
         16#EB#           =>  --  01D5EB
          (0, 0, 26824, 26824),
         16#EC#           =>  --  01D5EC
          (0, 0, 26825, 26825),
         16#ED#           =>  --  01D5ED
          (0, 0, 8564, 8564),
         16#EE#           =>  --  01D5EE
          (0, 0, 26826, 26826),
         16#EF#           =>  --  01D5EF
          (0, 0, 26827, 26827),
         16#F0#           =>  --  01D5F0
          (0, 0, 26828, 26828),
         16#F1#           =>  --  01D5F1
          (0, 0, 8595, 8595),
         16#F2#           =>  --  01D5F2
          (0, 0, 8570, 8570),
         16#F3#           =>  --  01D5F3
          (0, 0, 26829, 26829),
         16#F4#           =>  --  01D5F4
          (0, 0, 8539, 8539),
         16#F5#           =>  --  01D5F5
          (0, 0, 8541, 8541),
         16#F6#           =>  --  01D5F6
          (0, 0, 8580, 8580),
         16#F7#           =>  --  01D5F7
          (0, 0, 8596, 8596),
         16#F8#           =>  --  01D5F8
          (0, 0, 26830, 26830),
         16#F9#           =>  --  01D5F9
          (0, 0, 8544, 8544),
         16#FA#           =>  --  01D5FA
          (0, 0, 26831, 26831),
         16#FB#           =>  --  01D5FB
          (0, 0, 26832, 26832),
         16#FC#           =>  --  01D5FC
          (0, 0, 8575, 8575),
         16#FD#           =>  --  01D5FD
          (0, 0, 26833, 26833),
         16#FE#           =>  --  01D5FE
          (0, 0, 26834, 26834),
         16#FF#           =>  --  01D5FF
          (0, 0, 26835, 26835),
         others           =>
          (0, 0, 0, 0));

   Group_01D6 : aliased constant Collation_Second_Stage
     := (16#01#           =>  --  01D601
          (0, 0, 26837, 26837),
         16#02#           =>  --  01D602
          (0, 0, 26838, 26838),
         16#03#           =>  --  01D603
          (0, 0, 26839, 26839),
         16#04#           =>  --  01D604
          (0, 0, 26840, 26840),
         16#05#           =>  --  01D605
          (0, 0, 26841, 26841),
         16#06#           =>  --  01D606
          (0, 0, 26842, 26842),
         16#07#           =>  --  01D607
          (0, 0, 26843, 26843),
         16#08#           =>  --  01D608
          (0, 0, 26814, 26814),
         16#09#           =>  --  01D609
          (0, 0, 8568, 8568),
         16#0A#           =>  --  01D60A
          (0, 0, 8525, 8525),
         16#0B#           =>  --  01D60B
          (0, 0, 8594, 8594),
         16#0C#           =>  --  01D60C
          (0, 0, 8571, 8571),
         16#0D#           =>  --  01D60D
          (0, 0, 8572, 8572),
         16#0E#           =>  --  01D60E
          (0, 0, 26815, 26815),
         16#0F#           =>  --  01D60F
          (0, 0, 8540, 8540),
         16#10#           =>  --  01D610
          (0, 0, 8542, 8542),
         16#11#           =>  --  01D611
          (0, 0, 26816, 26816),
         16#12#           =>  --  01D612
          (0, 0, 26817, 26817),
         16#13#           =>  --  01D613
          (0, 0, 8543, 8543),
         16#14#           =>  --  01D614
          (0, 0, 8574, 8574),
         16#15#           =>  --  01D615
          (0, 0, 8546, 8546),
         16#16#           =>  --  01D616
          (0, 0, 26818, 26818),
         16#17#           =>  --  01D617
          (0, 0, 8551, 8551),
         16#18#           =>  --  01D618
          (0, 0, 8552, 8552),
         16#19#           =>  --  01D619
          (0, 0, 8553, 8553),
         16#1A#           =>  --  01D61A
          (0, 0, 26819, 26819),
         16#1B#           =>  --  01D61B
          (0, 0, 26820, 26820),
         16#1C#           =>  --  01D61C
          (0, 0, 26821, 26821),
         16#1D#           =>  --  01D61D
          (0, 0, 26822, 26822),
         16#1E#           =>  --  01D61E
          (0, 0, 26823, 26823),
         16#1F#           =>  --  01D61F
          (0, 0, 26824, 26824),
         16#20#           =>  --  01D620
          (0, 0, 26825, 26825),
         16#21#           =>  --  01D621
          (0, 0, 8564, 8564),
         16#22#           =>  --  01D622
          (0, 0, 26826, 26826),
         16#23#           =>  --  01D623
          (0, 0, 26827, 26827),
         16#24#           =>  --  01D624
          (0, 0, 26828, 26828),
         16#25#           =>  --  01D625
          (0, 0, 8595, 8595),
         16#26#           =>  --  01D626
          (0, 0, 8570, 8570),
         16#27#           =>  --  01D627
          (0, 0, 26829, 26829),
         16#28#           =>  --  01D628
          (0, 0, 8539, 8539),
         16#29#           =>  --  01D629
          (0, 0, 8541, 8541),
         16#2A#           =>  --  01D62A
          (0, 0, 8580, 8580),
         16#2B#           =>  --  01D62B
          (0, 0, 8596, 8596),
         16#2C#           =>  --  01D62C
          (0, 0, 26830, 26830),
         16#2D#           =>  --  01D62D
          (0, 0, 8544, 8544),
         16#2E#           =>  --  01D62E
          (0, 0, 26831, 26831),
         16#2F#           =>  --  01D62F
          (0, 0, 26832, 26832),
         16#30#           =>  --  01D630
          (0, 0, 8575, 8575),
         16#31#           =>  --  01D631
          (0, 0, 26833, 26833),
         16#32#           =>  --  01D632
          (0, 0, 26834, 26834),
         16#33#           =>  --  01D633
          (0, 0, 26835, 26835),
         16#35#           =>  --  01D635
          (0, 0, 26837, 26837),
         16#36#           =>  --  01D636
          (0, 0, 26838, 26838),
         16#37#           =>  --  01D637
          (0, 0, 26839, 26839),
         16#38#           =>  --  01D638
          (0, 0, 26840, 26840),
         16#39#           =>  --  01D639
          (0, 0, 26841, 26841),
         16#3A#           =>  --  01D63A
          (0, 0, 26842, 26842),
         16#3B#           =>  --  01D63B
          (0, 0, 26843, 26843),
         16#3C#           =>  --  01D63C
          (0, 0, 26814, 26814),
         16#3D#           =>  --  01D63D
          (0, 0, 8568, 8568),
         16#3E#           =>  --  01D63E
          (0, 0, 8525, 8525),
         16#3F#           =>  --  01D63F
          (0, 0, 8594, 8594),
         16#40#           =>  --  01D640
          (0, 0, 8571, 8571),
         16#41#           =>  --  01D641
          (0, 0, 8572, 8572),
         16#42#           =>  --  01D642
          (0, 0, 26815, 26815),
         16#43#           =>  --  01D643
          (0, 0, 8540, 8540),
         16#44#           =>  --  01D644
          (0, 0, 8542, 8542),
         16#45#           =>  --  01D645
          (0, 0, 26816, 26816),
         16#46#           =>  --  01D646
          (0, 0, 26817, 26817),
         16#47#           =>  --  01D647
          (0, 0, 8543, 8543),
         16#48#           =>  --  01D648
          (0, 0, 8574, 8574),
         16#49#           =>  --  01D649
          (0, 0, 8546, 8546),
         16#4A#           =>  --  01D64A
          (0, 0, 26818, 26818),
         16#4B#           =>  --  01D64B
          (0, 0, 8551, 8551),
         16#4C#           =>  --  01D64C
          (0, 0, 8552, 8552),
         16#4D#           =>  --  01D64D
          (0, 0, 8553, 8553),
         16#4E#           =>  --  01D64E
          (0, 0, 26819, 26819),
         16#4F#           =>  --  01D64F
          (0, 0, 26820, 26820),
         16#50#           =>  --  01D650
          (0, 0, 26821, 26821),
         16#51#           =>  --  01D651
          (0, 0, 26822, 26822),
         16#52#           =>  --  01D652
          (0, 0, 26823, 26823),
         16#53#           =>  --  01D653
          (0, 0, 26824, 26824),
         16#54#           =>  --  01D654
          (0, 0, 26825, 26825),
         16#55#           =>  --  01D655
          (0, 0, 8564, 8564),
         16#56#           =>  --  01D656
          (0, 0, 26826, 26826),
         16#57#           =>  --  01D657
          (0, 0, 26827, 26827),
         16#58#           =>  --  01D658
          (0, 0, 26828, 26828),
         16#59#           =>  --  01D659
          (0, 0, 8595, 8595),
         16#5A#           =>  --  01D65A
          (0, 0, 8570, 8570),
         16#5B#           =>  --  01D65B
          (0, 0, 26829, 26829),
         16#5C#           =>  --  01D65C
          (0, 0, 8539, 8539),
         16#5D#           =>  --  01D65D
          (0, 0, 8541, 8541),
         16#5E#           =>  --  01D65E
          (0, 0, 8580, 8580),
         16#5F#           =>  --  01D65F
          (0, 0, 8596, 8596),
         16#60#           =>  --  01D660
          (0, 0, 26830, 26830),
         16#61#           =>  --  01D661
          (0, 0, 8544, 8544),
         16#62#           =>  --  01D662
          (0, 0, 26831, 26831),
         16#63#           =>  --  01D663
          (0, 0, 26832, 26832),
         16#64#           =>  --  01D664
          (0, 0, 8575, 8575),
         16#65#           =>  --  01D665
          (0, 0, 26833, 26833),
         16#66#           =>  --  01D666
          (0, 0, 26834, 26834),
         16#67#           =>  --  01D667
          (0, 0, 26835, 26835),
         16#69#           =>  --  01D669
          (0, 0, 26837, 26837),
         16#6A#           =>  --  01D66A
          (0, 0, 26838, 26838),
         16#6B#           =>  --  01D66B
          (0, 0, 26839, 26839),
         16#6C#           =>  --  01D66C
          (0, 0, 26840, 26840),
         16#6D#           =>  --  01D66D
          (0, 0, 26841, 26841),
         16#6E#           =>  --  01D66E
          (0, 0, 26842, 26842),
         16#6F#           =>  --  01D66F
          (0, 0, 26843, 26843),
         16#70#           =>  --  01D670
          (0, 0, 26814, 26814),
         16#71#           =>  --  01D671
          (0, 0, 8568, 8568),
         16#72#           =>  --  01D672
          (0, 0, 8525, 8525),
         16#73#           =>  --  01D673
          (0, 0, 8594, 8594),
         16#74#           =>  --  01D674
          (0, 0, 8571, 8571),
         16#75#           =>  --  01D675
          (0, 0, 8572, 8572),
         16#76#           =>  --  01D676
          (0, 0, 26815, 26815),
         16#77#           =>  --  01D677
          (0, 0, 8540, 8540),
         16#78#           =>  --  01D678
          (0, 0, 8542, 8542),
         16#79#           =>  --  01D679
          (0, 0, 26816, 26816),
         16#7A#           =>  --  01D67A
          (0, 0, 26817, 26817),
         16#7B#           =>  --  01D67B
          (0, 0, 8543, 8543),
         16#7C#           =>  --  01D67C
          (0, 0, 8574, 8574),
         16#7D#           =>  --  01D67D
          (0, 0, 8546, 8546),
         16#7E#           =>  --  01D67E
          (0, 0, 26818, 26818),
         16#7F#           =>  --  01D67F
          (0, 0, 8551, 8551),
         16#80#           =>  --  01D680
          (0, 0, 8552, 8552),
         16#81#           =>  --  01D681
          (0, 0, 8553, 8553),
         16#82#           =>  --  01D682
          (0, 0, 26819, 26819),
         16#83#           =>  --  01D683
          (0, 0, 26820, 26820),
         16#84#           =>  --  01D684
          (0, 0, 26821, 26821),
         16#85#           =>  --  01D685
          (0, 0, 26822, 26822),
         16#86#           =>  --  01D686
          (0, 0, 26823, 26823),
         16#87#           =>  --  01D687
          (0, 0, 26824, 26824),
         16#88#           =>  --  01D688
          (0, 0, 26825, 26825),
         16#89#           =>  --  01D689
          (0, 0, 8564, 8564),
         16#8A#           =>  --  01D68A
          (0, 0, 26826, 26826),
         16#8B#           =>  --  01D68B
          (0, 0, 26827, 26827),
         16#8C#           =>  --  01D68C
          (0, 0, 26828, 26828),
         16#8D#           =>  --  01D68D
          (0, 0, 8595, 8595),
         16#8E#           =>  --  01D68E
          (0, 0, 8570, 8570),
         16#8F#           =>  --  01D68F
          (0, 0, 26829, 26829),
         16#90#           =>  --  01D690
          (0, 0, 8539, 8539),
         16#91#           =>  --  01D691
          (0, 0, 8541, 8541),
         16#92#           =>  --  01D692
          (0, 0, 8580, 8580),
         16#93#           =>  --  01D693
          (0, 0, 8596, 8596),
         16#94#           =>  --  01D694
          (0, 0, 26830, 26830),
         16#95#           =>  --  01D695
          (0, 0, 8544, 8544),
         16#96#           =>  --  01D696
          (0, 0, 26831, 26831),
         16#97#           =>  --  01D697
          (0, 0, 26832, 26832),
         16#98#           =>  --  01D698
          (0, 0, 8575, 8575),
         16#99#           =>  --  01D699
          (0, 0, 26833, 26833),
         16#9A#           =>  --  01D69A
          (0, 0, 26834, 26834),
         16#9B#           =>  --  01D69B
          (0, 0, 26835, 26835),
         16#9D#           =>  --  01D69D
          (0, 0, 26837, 26837),
         16#9E#           =>  --  01D69E
          (0, 0, 26838, 26838),
         16#9F#           =>  --  01D69F
          (0, 0, 26839, 26839),
         16#A0#           =>  --  01D6A0
          (0, 0, 26840, 26840),
         16#A1#           =>  --  01D6A1
          (0, 0, 26841, 26841),
         16#A2#           =>  --  01D6A2
          (0, 0, 26842, 26842),
         16#A3#           =>  --  01D6A3
          (0, 0, 26843, 26843),
         16#A4#           =>  --  01D6A4
          (0, 0, 26844, 26844),
         16#A5#           =>  --  01D6A5
          (0, 0, 26845, 26845),
         16#A6# .. 16#A7# =>  --  01D6A6 .. 01D6A7
          (0, 0, 0, 0),
         16#A8#           =>  --  01D6A8
          (0, 0, 26846, 26846),
         16#A9#           =>  --  01D6A9
          (0, 0, 26847, 26847),
         16#AA#           =>  --  01D6AA
          (0, 0, 8587, 8587),
         16#AB#           =>  --  01D6AB
          (0, 0, 26848, 26848),
         16#AC#           =>  --  01D6AC
          (0, 0, 26849, 26849),
         16#AD#           =>  --  01D6AD
          (0, 0, 26850, 26850),
         16#AE#           =>  --  01D6AE
          (0, 0, 26851, 26851),
         16#AF#           =>  --  01D6AF
          (0, 0, 26852, 26852),
         16#B0#           =>  --  01D6B0
          (0, 0, 26853, 26853),
         16#B1#           =>  --  01D6B1
          (0, 0, 26854, 26854),
         16#B2#           =>  --  01D6B2
          (0, 0, 26855, 26855),
         16#B3#           =>  --  01D6B3
          (0, 0, 26856, 26856),
         16#B4#           =>  --  01D6B4
          (0, 0, 26857, 26857),
         16#B5#           =>  --  01D6B5
          (0, 0, 26858, 26858),
         16#B6#           =>  --  01D6B6
          (0, 0, 26859, 26859),
         16#B7#           =>  --  01D6B7
          (0, 0, 8588, 8588),
         16#B8#           =>  --  01D6B8
          (0, 0, 26860, 26860),
         16#B9#           =>  --  01D6B9
          (0, 0, 26852, 26852),
         16#BA#           =>  --  01D6BA
          (0, 0, 26861, 26861),
         16#BB#           =>  --  01D6BB
          (0, 0, 26862, 26862),
         16#BC#           =>  --  01D6BC
          (0, 0, 26863, 26863),
         16#BD#           =>  --  01D6BD
          (0, 0, 26864, 26864),
         16#BE#           =>  --  01D6BE
          (0, 0, 26865, 26865),
         16#BF#           =>  --  01D6BF
          (0, 0, 26866, 26866),
         16#C0#           =>  --  01D6C0
          (0, 0, 26867, 26867),
         16#C1#           =>  --  01D6C1
          (0, 0, 26868, 26868),
         16#C2#           =>  --  01D6C2
          (0, 0, 26869, 26869),
         16#C3#           =>  --  01D6C3
          (0, 0, 26870, 26870),
         16#C4#           =>  --  01D6C4
          (0, 0, 8586, 8586),
         16#C5#           =>  --  01D6C5
          (0, 0, 26871, 26871),
         16#C6#           =>  --  01D6C6
          (0, 0, 26872, 26872),
         16#C7#           =>  --  01D6C7
          (0, 0, 26873, 26873),
         16#C8#           =>  --  01D6C8
          (0, 0, 26874, 26874),
         16#C9#           =>  --  01D6C9
          (0, 0, 26875, 26875),
         16#CA#           =>  --  01D6CA
          (0, 0, 26876, 26876),
         16#CB#           =>  --  01D6CB
          (0, 0, 26877, 26877),
         16#CC#           =>  --  01D6CC
          (0, 0, 26878, 26878),
         16#CD#           =>  --  01D6CD
          (0, 0, 26879, 26879),
         16#CE#           =>  --  01D6CE
          (0, 0, 26880, 26880),
         16#CF#           =>  --  01D6CF
          (0, 0, 26881, 26881),
         16#D0#           =>  --  01D6D0
          (0, 0, 26882, 26882),
         16#D1#           =>  --  01D6D1
          (0, 0, 8585, 8585),
         16#D2#           =>  --  01D6D2
          (0, 0, 26883, 26883),
         16#D3# .. 16#D4# =>  --  01D6D3 .. 01D6D4
          (0, 0, 26884, 26884),
         16#D5#           =>  --  01D6D5
          (0, 0, 26885, 26885),
         16#D6#           =>  --  01D6D6
          (0, 0, 26886, 26886),
         16#D7#           =>  --  01D6D7
          (0, 0, 26887, 26887),
         16#D8#           =>  --  01D6D8
          (0, 0, 26888, 26888),
         16#D9#           =>  --  01D6D9
          (0, 0, 26889, 26889),
         16#DA#           =>  --  01D6DA
          (0, 0, 26890, 26890),
         16#DB#           =>  --  01D6DB
          (0, 0, 26891, 26891),
         16#DC#           =>  --  01D6DC
          (0, 0, 26872, 26872),
         16#DD#           =>  --  01D6DD
          (0, 0, 26875, 26875),
         16#DE#           =>  --  01D6DE
          (0, 0, 26877, 26877),
         16#DF#           =>  --  01D6DF
          (0, 0, 26887, 26887),
         16#E0#           =>  --  01D6E0
          (0, 0, 26883, 26883),
         16#E1#           =>  --  01D6E1
          (0, 0, 8585, 8585),
         16#E2#           =>  --  01D6E2
          (0, 0, 26846, 26846),
         16#E3#           =>  --  01D6E3
          (0, 0, 26847, 26847),
         16#E4#           =>  --  01D6E4
          (0, 0, 8587, 8587),
         16#E5#           =>  --  01D6E5
          (0, 0, 26848, 26848),
         16#E6#           =>  --  01D6E6
          (0, 0, 26849, 26849),
         16#E7#           =>  --  01D6E7
          (0, 0, 26850, 26850),
         16#E8#           =>  --  01D6E8
          (0, 0, 26851, 26851),
         16#E9#           =>  --  01D6E9
          (0, 0, 26852, 26852),
         16#EA#           =>  --  01D6EA
          (0, 0, 26853, 26853),
         16#EB#           =>  --  01D6EB
          (0, 0, 26854, 26854),
         16#EC#           =>  --  01D6EC
          (0, 0, 26855, 26855),
         16#ED#           =>  --  01D6ED
          (0, 0, 26856, 26856),
         16#EE#           =>  --  01D6EE
          (0, 0, 26857, 26857),
         16#EF#           =>  --  01D6EF
          (0, 0, 26858, 26858),
         16#F0#           =>  --  01D6F0
          (0, 0, 26859, 26859),
         16#F1#           =>  --  01D6F1
          (0, 0, 8588, 8588),
         16#F2#           =>  --  01D6F2
          (0, 0, 26860, 26860),
         16#F3#           =>  --  01D6F3
          (0, 0, 26852, 26852),
         16#F4#           =>  --  01D6F4
          (0, 0, 26861, 26861),
         16#F5#           =>  --  01D6F5
          (0, 0, 26862, 26862),
         16#F6#           =>  --  01D6F6
          (0, 0, 26863, 26863),
         16#F7#           =>  --  01D6F7
          (0, 0, 26864, 26864),
         16#F8#           =>  --  01D6F8
          (0, 0, 26865, 26865),
         16#F9#           =>  --  01D6F9
          (0, 0, 26866, 26866),
         16#FA#           =>  --  01D6FA
          (0, 0, 26867, 26867),
         16#FB#           =>  --  01D6FB
          (0, 0, 26868, 26868),
         16#FC#           =>  --  01D6FC
          (0, 0, 26869, 26869),
         16#FD#           =>  --  01D6FD
          (0, 0, 26870, 26870),
         16#FE#           =>  --  01D6FE
          (0, 0, 8586, 8586),
         16#FF#           =>  --  01D6FF
          (0, 0, 26871, 26871),
         others           =>
          (0, 0, 26836, 26836));

   Group_01D7 : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  01D700
          (0, 0, 26872, 26872),
         16#01#           =>  --  01D701
          (0, 0, 26873, 26873),
         16#02#           =>  --  01D702
          (0, 0, 26874, 26874),
         16#03#           =>  --  01D703
          (0, 0, 26875, 26875),
         16#04#           =>  --  01D704
          (0, 0, 26876, 26876),
         16#05#           =>  --  01D705
          (0, 0, 26877, 26877),
         16#06#           =>  --  01D706
          (0, 0, 26878, 26878),
         16#07#           =>  --  01D707
          (0, 0, 26879, 26879),
         16#08#           =>  --  01D708
          (0, 0, 26880, 26880),
         16#09#           =>  --  01D709
          (0, 0, 26881, 26881),
         16#0A#           =>  --  01D70A
          (0, 0, 26882, 26882),
         16#0B#           =>  --  01D70B
          (0, 0, 8585, 8585),
         16#0C#           =>  --  01D70C
          (0, 0, 26883, 26883),
         16#0F#           =>  --  01D70F
          (0, 0, 26885, 26885),
         16#10#           =>  --  01D710
          (0, 0, 26886, 26886),
         16#11#           =>  --  01D711
          (0, 0, 26887, 26887),
         16#12#           =>  --  01D712
          (0, 0, 26888, 26888),
         16#13#           =>  --  01D713
          (0, 0, 26889, 26889),
         16#14#           =>  --  01D714
          (0, 0, 26890, 26890),
         16#15#           =>  --  01D715
          (0, 0, 26891, 26891),
         16#16#           =>  --  01D716
          (0, 0, 26872, 26872),
         16#17#           =>  --  01D717
          (0, 0, 26875, 26875),
         16#18#           =>  --  01D718
          (0, 0, 26877, 26877),
         16#19#           =>  --  01D719
          (0, 0, 26887, 26887),
         16#1A#           =>  --  01D71A
          (0, 0, 26883, 26883),
         16#1B#           =>  --  01D71B
          (0, 0, 8585, 8585),
         16#1C#           =>  --  01D71C
          (0, 0, 26846, 26846),
         16#1D#           =>  --  01D71D
          (0, 0, 26847, 26847),
         16#1E#           =>  --  01D71E
          (0, 0, 8587, 8587),
         16#1F#           =>  --  01D71F
          (0, 0, 26848, 26848),
         16#20#           =>  --  01D720
          (0, 0, 26849, 26849),
         16#21#           =>  --  01D721
          (0, 0, 26850, 26850),
         16#22#           =>  --  01D722
          (0, 0, 26851, 26851),
         16#23#           =>  --  01D723
          (0, 0, 26852, 26852),
         16#24#           =>  --  01D724
          (0, 0, 26853, 26853),
         16#25#           =>  --  01D725
          (0, 0, 26854, 26854),
         16#26#           =>  --  01D726
          (0, 0, 26855, 26855),
         16#27#           =>  --  01D727
          (0, 0, 26856, 26856),
         16#28#           =>  --  01D728
          (0, 0, 26857, 26857),
         16#29#           =>  --  01D729
          (0, 0, 26858, 26858),
         16#2A#           =>  --  01D72A
          (0, 0, 26859, 26859),
         16#2B#           =>  --  01D72B
          (0, 0, 8588, 8588),
         16#2C#           =>  --  01D72C
          (0, 0, 26860, 26860),
         16#2D#           =>  --  01D72D
          (0, 0, 26852, 26852),
         16#2E#           =>  --  01D72E
          (0, 0, 26861, 26861),
         16#2F#           =>  --  01D72F
          (0, 0, 26862, 26862),
         16#30#           =>  --  01D730
          (0, 0, 26863, 26863),
         16#31#           =>  --  01D731
          (0, 0, 26864, 26864),
         16#32#           =>  --  01D732
          (0, 0, 26865, 26865),
         16#33#           =>  --  01D733
          (0, 0, 26866, 26866),
         16#34#           =>  --  01D734
          (0, 0, 26867, 26867),
         16#35#           =>  --  01D735
          (0, 0, 26868, 26868),
         16#36#           =>  --  01D736
          (0, 0, 26869, 26869),
         16#37#           =>  --  01D737
          (0, 0, 26870, 26870),
         16#38#           =>  --  01D738
          (0, 0, 8586, 8586),
         16#39#           =>  --  01D739
          (0, 0, 26871, 26871),
         16#3A#           =>  --  01D73A
          (0, 0, 26872, 26872),
         16#3B#           =>  --  01D73B
          (0, 0, 26873, 26873),
         16#3C#           =>  --  01D73C
          (0, 0, 26874, 26874),
         16#3D#           =>  --  01D73D
          (0, 0, 26875, 26875),
         16#3E#           =>  --  01D73E
          (0, 0, 26876, 26876),
         16#3F#           =>  --  01D73F
          (0, 0, 26877, 26877),
         16#40#           =>  --  01D740
          (0, 0, 26878, 26878),
         16#41#           =>  --  01D741
          (0, 0, 26879, 26879),
         16#42#           =>  --  01D742
          (0, 0, 26880, 26880),
         16#43#           =>  --  01D743
          (0, 0, 26881, 26881),
         16#44#           =>  --  01D744
          (0, 0, 26882, 26882),
         16#45#           =>  --  01D745
          (0, 0, 8585, 8585),
         16#46#           =>  --  01D746
          (0, 0, 26883, 26883),
         16#49#           =>  --  01D749
          (0, 0, 26885, 26885),
         16#4A#           =>  --  01D74A
          (0, 0, 26886, 26886),
         16#4B#           =>  --  01D74B
          (0, 0, 26887, 26887),
         16#4C#           =>  --  01D74C
          (0, 0, 26888, 26888),
         16#4D#           =>  --  01D74D
          (0, 0, 26889, 26889),
         16#4E#           =>  --  01D74E
          (0, 0, 26890, 26890),
         16#4F#           =>  --  01D74F
          (0, 0, 26891, 26891),
         16#50#           =>  --  01D750
          (0, 0, 26872, 26872),
         16#51#           =>  --  01D751
          (0, 0, 26875, 26875),
         16#52#           =>  --  01D752
          (0, 0, 26877, 26877),
         16#53#           =>  --  01D753
          (0, 0, 26887, 26887),
         16#54#           =>  --  01D754
          (0, 0, 26883, 26883),
         16#55#           =>  --  01D755
          (0, 0, 8585, 8585),
         16#56#           =>  --  01D756
          (0, 0, 26846, 26846),
         16#57#           =>  --  01D757
          (0, 0, 26847, 26847),
         16#58#           =>  --  01D758
          (0, 0, 8587, 8587),
         16#59#           =>  --  01D759
          (0, 0, 26848, 26848),
         16#5A#           =>  --  01D75A
          (0, 0, 26849, 26849),
         16#5B#           =>  --  01D75B
          (0, 0, 26850, 26850),
         16#5C#           =>  --  01D75C
          (0, 0, 26851, 26851),
         16#5D#           =>  --  01D75D
          (0, 0, 26852, 26852),
         16#5E#           =>  --  01D75E
          (0, 0, 26853, 26853),
         16#5F#           =>  --  01D75F
          (0, 0, 26854, 26854),
         16#60#           =>  --  01D760
          (0, 0, 26855, 26855),
         16#61#           =>  --  01D761
          (0, 0, 26856, 26856),
         16#62#           =>  --  01D762
          (0, 0, 26857, 26857),
         16#63#           =>  --  01D763
          (0, 0, 26858, 26858),
         16#64#           =>  --  01D764
          (0, 0, 26859, 26859),
         16#65#           =>  --  01D765
          (0, 0, 8588, 8588),
         16#66#           =>  --  01D766
          (0, 0, 26860, 26860),
         16#67#           =>  --  01D767
          (0, 0, 26852, 26852),
         16#68#           =>  --  01D768
          (0, 0, 26861, 26861),
         16#69#           =>  --  01D769
          (0, 0, 26862, 26862),
         16#6A#           =>  --  01D76A
          (0, 0, 26863, 26863),
         16#6B#           =>  --  01D76B
          (0, 0, 26864, 26864),
         16#6C#           =>  --  01D76C
          (0, 0, 26865, 26865),
         16#6D#           =>  --  01D76D
          (0, 0, 26866, 26866),
         16#6E#           =>  --  01D76E
          (0, 0, 26867, 26867),
         16#6F#           =>  --  01D76F
          (0, 0, 26868, 26868),
         16#70#           =>  --  01D770
          (0, 0, 26869, 26869),
         16#71#           =>  --  01D771
          (0, 0, 26870, 26870),
         16#72#           =>  --  01D772
          (0, 0, 8586, 8586),
         16#73#           =>  --  01D773
          (0, 0, 26871, 26871),
         16#74#           =>  --  01D774
          (0, 0, 26872, 26872),
         16#75#           =>  --  01D775
          (0, 0, 26873, 26873),
         16#76#           =>  --  01D776
          (0, 0, 26874, 26874),
         16#77#           =>  --  01D777
          (0, 0, 26875, 26875),
         16#78#           =>  --  01D778
          (0, 0, 26876, 26876),
         16#79#           =>  --  01D779
          (0, 0, 26877, 26877),
         16#7A#           =>  --  01D77A
          (0, 0, 26878, 26878),
         16#7B#           =>  --  01D77B
          (0, 0, 26879, 26879),
         16#7C#           =>  --  01D77C
          (0, 0, 26880, 26880),
         16#7D#           =>  --  01D77D
          (0, 0, 26881, 26881),
         16#7E#           =>  --  01D77E
          (0, 0, 26882, 26882),
         16#7F#           =>  --  01D77F
          (0, 0, 8585, 8585),
         16#80#           =>  --  01D780
          (0, 0, 26883, 26883),
         16#83#           =>  --  01D783
          (0, 0, 26885, 26885),
         16#84#           =>  --  01D784
          (0, 0, 26886, 26886),
         16#85#           =>  --  01D785
          (0, 0, 26887, 26887),
         16#86#           =>  --  01D786
          (0, 0, 26888, 26888),
         16#87#           =>  --  01D787
          (0, 0, 26889, 26889),
         16#88#           =>  --  01D788
          (0, 0, 26890, 26890),
         16#89#           =>  --  01D789
          (0, 0, 26891, 26891),
         16#8A#           =>  --  01D78A
          (0, 0, 26872, 26872),
         16#8B#           =>  --  01D78B
          (0, 0, 26875, 26875),
         16#8C#           =>  --  01D78C
          (0, 0, 26877, 26877),
         16#8D#           =>  --  01D78D
          (0, 0, 26887, 26887),
         16#8E#           =>  --  01D78E
          (0, 0, 26883, 26883),
         16#8F#           =>  --  01D78F
          (0, 0, 8585, 8585),
         16#90#           =>  --  01D790
          (0, 0, 26846, 26846),
         16#91#           =>  --  01D791
          (0, 0, 26847, 26847),
         16#92#           =>  --  01D792
          (0, 0, 8587, 8587),
         16#93#           =>  --  01D793
          (0, 0, 26848, 26848),
         16#94#           =>  --  01D794
          (0, 0, 26849, 26849),
         16#95#           =>  --  01D795
          (0, 0, 26850, 26850),
         16#96#           =>  --  01D796
          (0, 0, 26851, 26851),
         16#97#           =>  --  01D797
          (0, 0, 26852, 26852),
         16#98#           =>  --  01D798
          (0, 0, 26853, 26853),
         16#99#           =>  --  01D799
          (0, 0, 26854, 26854),
         16#9A#           =>  --  01D79A
          (0, 0, 26855, 26855),
         16#9B#           =>  --  01D79B
          (0, 0, 26856, 26856),
         16#9C#           =>  --  01D79C
          (0, 0, 26857, 26857),
         16#9D#           =>  --  01D79D
          (0, 0, 26858, 26858),
         16#9E#           =>  --  01D79E
          (0, 0, 26859, 26859),
         16#9F#           =>  --  01D79F
          (0, 0, 8588, 8588),
         16#A0#           =>  --  01D7A0
          (0, 0, 26860, 26860),
         16#A1#           =>  --  01D7A1
          (0, 0, 26852, 26852),
         16#A2#           =>  --  01D7A2
          (0, 0, 26861, 26861),
         16#A3#           =>  --  01D7A3
          (0, 0, 26862, 26862),
         16#A4#           =>  --  01D7A4
          (0, 0, 26863, 26863),
         16#A5#           =>  --  01D7A5
          (0, 0, 26864, 26864),
         16#A6#           =>  --  01D7A6
          (0, 0, 26865, 26865),
         16#A7#           =>  --  01D7A7
          (0, 0, 26866, 26866),
         16#A8#           =>  --  01D7A8
          (0, 0, 26867, 26867),
         16#A9#           =>  --  01D7A9
          (0, 0, 26868, 26868),
         16#AA#           =>  --  01D7AA
          (0, 0, 26869, 26869),
         16#AB#           =>  --  01D7AB
          (0, 0, 26870, 26870),
         16#AC#           =>  --  01D7AC
          (0, 0, 8586, 8586),
         16#AD#           =>  --  01D7AD
          (0, 0, 26871, 26871),
         16#AE#           =>  --  01D7AE
          (0, 0, 26872, 26872),
         16#AF#           =>  --  01D7AF
          (0, 0, 26873, 26873),
         16#B0#           =>  --  01D7B0
          (0, 0, 26874, 26874),
         16#B1#           =>  --  01D7B1
          (0, 0, 26875, 26875),
         16#B2#           =>  --  01D7B2
          (0, 0, 26876, 26876),
         16#B3#           =>  --  01D7B3
          (0, 0, 26877, 26877),
         16#B4#           =>  --  01D7B4
          (0, 0, 26878, 26878),
         16#B5#           =>  --  01D7B5
          (0, 0, 26879, 26879),
         16#B6#           =>  --  01D7B6
          (0, 0, 26880, 26880),
         16#B7#           =>  --  01D7B7
          (0, 0, 26881, 26881),
         16#B8#           =>  --  01D7B8
          (0, 0, 26882, 26882),
         16#B9#           =>  --  01D7B9
          (0, 0, 8585, 8585),
         16#BA#           =>  --  01D7BA
          (0, 0, 26883, 26883),
         16#BD#           =>  --  01D7BD
          (0, 0, 26885, 26885),
         16#BE#           =>  --  01D7BE
          (0, 0, 26886, 26886),
         16#BF#           =>  --  01D7BF
          (0, 0, 26887, 26887),
         16#C0#           =>  --  01D7C0
          (0, 0, 26888, 26888),
         16#C1#           =>  --  01D7C1
          (0, 0, 26889, 26889),
         16#C2#           =>  --  01D7C2
          (0, 0, 26890, 26890),
         16#C3#           =>  --  01D7C3
          (0, 0, 26891, 26891),
         16#C4#           =>  --  01D7C4
          (0, 0, 26872, 26872),
         16#C5#           =>  --  01D7C5
          (0, 0, 26875, 26875),
         16#C6#           =>  --  01D7C6
          (0, 0, 26877, 26877),
         16#C7#           =>  --  01D7C7
          (0, 0, 26887, 26887),
         16#C8#           =>  --  01D7C8
          (0, 0, 26883, 26883),
         16#C9#           =>  --  01D7C9
          (0, 0, 8585, 8585),
         16#CA#           =>  --  01D7CA
          (0, 0, 26892, 26892),
         16#CB#           =>  --  01D7CB
          (0, 0, 26893, 26893),
         16#CC# .. 16#CD# =>  --  01D7CC .. 01D7CD
          (0, 0, 0, 0),
         16#CE#           =>  --  01D7CE
          (0, 0, 26894, 26894),
         16#CF#           =>  --  01D7CF
          (0, 0, 26895, 26895),
         16#D0#           =>  --  01D7D0
          (0, 0, 26896, 26896),
         16#D1#           =>  --  01D7D1
          (0, 0, 26897, 26897),
         16#D2#           =>  --  01D7D2
          (0, 0, 26898, 26898),
         16#D3#           =>  --  01D7D3
          (0, 0, 26899, 26899),
         16#D4#           =>  --  01D7D4
          (0, 0, 26900, 26900),
         16#D5#           =>  --  01D7D5
          (0, 0, 26901, 26901),
         16#D6#           =>  --  01D7D6
          (0, 0, 26902, 26902),
         16#D7#           =>  --  01D7D7
          (0, 0, 26903, 26903),
         16#D8#           =>  --  01D7D8
          (0, 0, 26894, 26894),
         16#D9#           =>  --  01D7D9
          (0, 0, 26895, 26895),
         16#DA#           =>  --  01D7DA
          (0, 0, 26896, 26896),
         16#DB#           =>  --  01D7DB
          (0, 0, 26897, 26897),
         16#DC#           =>  --  01D7DC
          (0, 0, 26898, 26898),
         16#DD#           =>  --  01D7DD
          (0, 0, 26899, 26899),
         16#DE#           =>  --  01D7DE
          (0, 0, 26900, 26900),
         16#DF#           =>  --  01D7DF
          (0, 0, 26901, 26901),
         16#E0#           =>  --  01D7E0
          (0, 0, 26902, 26902),
         16#E1#           =>  --  01D7E1
          (0, 0, 26903, 26903),
         16#E2#           =>  --  01D7E2
          (0, 0, 26894, 26894),
         16#E3#           =>  --  01D7E3
          (0, 0, 26895, 26895),
         16#E4#           =>  --  01D7E4
          (0, 0, 26896, 26896),
         16#E5#           =>  --  01D7E5
          (0, 0, 26897, 26897),
         16#E6#           =>  --  01D7E6
          (0, 0, 26898, 26898),
         16#E7#           =>  --  01D7E7
          (0, 0, 26899, 26899),
         16#E8#           =>  --  01D7E8
          (0, 0, 26900, 26900),
         16#E9#           =>  --  01D7E9
          (0, 0, 26901, 26901),
         16#EA#           =>  --  01D7EA
          (0, 0, 26902, 26902),
         16#EB#           =>  --  01D7EB
          (0, 0, 26903, 26903),
         16#EC#           =>  --  01D7EC
          (0, 0, 26894, 26894),
         16#ED#           =>  --  01D7ED
          (0, 0, 26895, 26895),
         16#EE#           =>  --  01D7EE
          (0, 0, 26896, 26896),
         16#EF#           =>  --  01D7EF
          (0, 0, 26897, 26897),
         16#F0#           =>  --  01D7F0
          (0, 0, 26898, 26898),
         16#F1#           =>  --  01D7F1
          (0, 0, 26899, 26899),
         16#F2#           =>  --  01D7F2
          (0, 0, 26900, 26900),
         16#F3#           =>  --  01D7F3
          (0, 0, 26901, 26901),
         16#F4#           =>  --  01D7F4
          (0, 0, 26902, 26902),
         16#F5#           =>  --  01D7F5
          (0, 0, 26903, 26903),
         16#F6#           =>  --  01D7F6
          (0, 0, 26894, 26894),
         16#F7#           =>  --  01D7F7
          (0, 0, 26895, 26895),
         16#F8#           =>  --  01D7F8
          (0, 0, 26896, 26896),
         16#F9#           =>  --  01D7F9
          (0, 0, 26897, 26897),
         16#FA#           =>  --  01D7FA
          (0, 0, 26898, 26898),
         16#FB#           =>  --  01D7FB
          (0, 0, 26899, 26899),
         16#FC#           =>  --  01D7FC
          (0, 0, 26900, 26900),
         16#FD#           =>  --  01D7FD
          (0, 0, 26901, 26901),
         16#FE#           =>  --  01D7FE
          (0, 0, 26902, 26902),
         16#FF#           =>  --  01D7FF
          (0, 0, 26903, 26903),
         others           =>
          (0, 0, 26884, 26884));

   Group_01E8 : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  01E800
          (0, 0, 26904, 26904),
         16#01#           =>  --  01E801
          (0, 0, 26905, 26905),
         16#02#           =>  --  01E802
          (0, 0, 26906, 26906),
         16#03#           =>  --  01E803
          (0, 0, 26907, 26907),
         16#04#           =>  --  01E804
          (0, 0, 26908, 26908),
         16#05#           =>  --  01E805
          (0, 0, 26909, 26909),
         16#06#           =>  --  01E806
          (0, 0, 26910, 26910),
         16#07#           =>  --  01E807
          (0, 0, 26911, 26911),
         16#08#           =>  --  01E808
          (0, 0, 26912, 26912),
         16#09#           =>  --  01E809
          (0, 0, 26913, 26913),
         16#0A#           =>  --  01E80A
          (0, 0, 26914, 26914),
         16#0B#           =>  --  01E80B
          (0, 0, 26915, 26915),
         16#0C#           =>  --  01E80C
          (0, 0, 26916, 26916),
         16#0D#           =>  --  01E80D
          (0, 0, 26917, 26917),
         16#0E#           =>  --  01E80E
          (0, 0, 26918, 26918),
         16#0F#           =>  --  01E80F
          (0, 0, 26919, 26919),
         16#10#           =>  --  01E810
          (0, 0, 26920, 26920),
         16#11#           =>  --  01E811
          (0, 0, 26921, 26921),
         16#12#           =>  --  01E812
          (0, 0, 26922, 26922),
         16#13#           =>  --  01E813
          (0, 0, 26923, 26923),
         16#14#           =>  --  01E814
          (0, 0, 26924, 26924),
         16#15#           =>  --  01E815
          (0, 0, 26925, 26925),
         16#16#           =>  --  01E816
          (0, 0, 26926, 26926),
         16#17#           =>  --  01E817
          (0, 0, 26927, 26927),
         16#18#           =>  --  01E818
          (0, 0, 26928, 26928),
         16#19#           =>  --  01E819
          (0, 0, 26929, 26929),
         16#1A#           =>  --  01E81A
          (0, 0, 26930, 26930),
         16#1B#           =>  --  01E81B
          (0, 0, 26931, 26931),
         16#1C#           =>  --  01E81C
          (0, 0, 26932, 26932),
         16#1D#           =>  --  01E81D
          (0, 0, 26933, 26933),
         16#1E#           =>  --  01E81E
          (0, 0, 26934, 26934),
         16#1F#           =>  --  01E81F
          (0, 0, 26935, 26935),
         16#20#           =>  --  01E820
          (0, 0, 26936, 26936),
         16#21#           =>  --  01E821
          (0, 0, 26937, 26937),
         16#22#           =>  --  01E822
          (0, 0, 26938, 26938),
         16#23#           =>  --  01E823
          (0, 0, 26939, 26939),
         16#24#           =>  --  01E824
          (0, 0, 26940, 26940),
         16#25#           =>  --  01E825
          (0, 0, 26941, 26941),
         16#26#           =>  --  01E826
          (0, 0, 26942, 26942),
         16#27#           =>  --  01E827
          (0, 0, 26943, 26943),
         16#28#           =>  --  01E828
          (0, 0, 26944, 26944),
         16#29#           =>  --  01E829
          (0, 0, 26945, 26945),
         16#2A#           =>  --  01E82A
          (0, 0, 26946, 26946),
         16#2B#           =>  --  01E82B
          (0, 0, 26947, 26947),
         16#2C#           =>  --  01E82C
          (0, 0, 26948, 26948),
         16#2D#           =>  --  01E82D
          (0, 0, 26949, 26949),
         16#2E#           =>  --  01E82E
          (0, 0, 26950, 26950),
         16#2F#           =>  --  01E82F
          (0, 0, 26951, 26951),
         16#30#           =>  --  01E830
          (0, 0, 26952, 26952),
         16#31#           =>  --  01E831
          (0, 0, 26953, 26953),
         16#32#           =>  --  01E832
          (0, 0, 26954, 26954),
         16#33#           =>  --  01E833
          (0, 0, 26955, 26955),
         16#34#           =>  --  01E834
          (0, 0, 26956, 26956),
         16#35#           =>  --  01E835
          (0, 0, 26957, 26957),
         16#36#           =>  --  01E836
          (0, 0, 26958, 26958),
         16#37#           =>  --  01E837
          (0, 0, 26959, 26959),
         16#38#           =>  --  01E838
          (0, 0, 26960, 26960),
         16#39#           =>  --  01E839
          (0, 0, 26961, 26961),
         16#3A#           =>  --  01E83A
          (0, 0, 26962, 26962),
         16#3B#           =>  --  01E83B
          (0, 0, 26963, 26963),
         16#3C#           =>  --  01E83C
          (0, 0, 26964, 26964),
         16#3D#           =>  --  01E83D
          (0, 0, 26965, 26965),
         16#3E#           =>  --  01E83E
          (0, 0, 26966, 26966),
         16#3F#           =>  --  01E83F
          (0, 0, 26967, 26967),
         16#40#           =>  --  01E840
          (0, 0, 26968, 26968),
         16#41#           =>  --  01E841
          (0, 0, 26969, 26969),
         16#42#           =>  --  01E842
          (0, 0, 26970, 26970),
         16#43#           =>  --  01E843
          (0, 0, 26971, 26971),
         16#44#           =>  --  01E844
          (0, 0, 26972, 26972),
         16#45#           =>  --  01E845
          (0, 0, 26973, 26973),
         16#46#           =>  --  01E846
          (0, 0, 26974, 26974),
         16#47#           =>  --  01E847
          (0, 0, 26975, 26975),
         16#48#           =>  --  01E848
          (0, 0, 26976, 26976),
         16#49#           =>  --  01E849
          (0, 0, 26977, 26977),
         16#4A#           =>  --  01E84A
          (0, 0, 26978, 26978),
         16#4B#           =>  --  01E84B
          (0, 0, 26979, 26979),
         16#4C#           =>  --  01E84C
          (0, 0, 26980, 26980),
         16#4D#           =>  --  01E84D
          (0, 0, 26981, 26981),
         16#4E#           =>  --  01E84E
          (0, 0, 26982, 26982),
         16#4F#           =>  --  01E84F
          (0, 0, 26983, 26983),
         16#50#           =>  --  01E850
          (0, 0, 26984, 26984),
         16#51#           =>  --  01E851
          (0, 0, 26985, 26985),
         16#52#           =>  --  01E852
          (0, 0, 26986, 26986),
         16#53#           =>  --  01E853
          (0, 0, 26987, 26987),
         16#54#           =>  --  01E854
          (0, 0, 26988, 26988),
         16#55#           =>  --  01E855
          (0, 0, 26989, 26989),
         16#56#           =>  --  01E856
          (0, 0, 26990, 26990),
         16#57#           =>  --  01E857
          (0, 0, 26991, 26991),
         16#58#           =>  --  01E858
          (0, 0, 26992, 26992),
         16#59#           =>  --  01E859
          (0, 0, 26993, 26993),
         16#5A#           =>  --  01E85A
          (0, 0, 26994, 26994),
         16#5B#           =>  --  01E85B
          (0, 0, 26995, 26995),
         16#5C#           =>  --  01E85C
          (0, 0, 26996, 26996),
         16#5D#           =>  --  01E85D
          (0, 0, 26997, 26997),
         16#5E#           =>  --  01E85E
          (0, 0, 26998, 26998),
         16#5F#           =>  --  01E85F
          (0, 0, 26999, 26999),
         16#60#           =>  --  01E860
          (0, 0, 27000, 27000),
         16#61#           =>  --  01E861
          (0, 0, 27001, 27001),
         16#62#           =>  --  01E862
          (0, 0, 27002, 27002),
         16#63#           =>  --  01E863
          (0, 0, 27003, 27003),
         16#64#           =>  --  01E864
          (0, 0, 27004, 27004),
         16#65#           =>  --  01E865
          (0, 0, 27005, 27005),
         16#66#           =>  --  01E866
          (0, 0, 27006, 27006),
         16#67#           =>  --  01E867
          (0, 0, 27007, 27007),
         16#68#           =>  --  01E868
          (0, 0, 27008, 27008),
         16#69#           =>  --  01E869
          (0, 0, 27009, 27009),
         16#6A#           =>  --  01E86A
          (0, 0, 27010, 27010),
         16#6B#           =>  --  01E86B
          (0, 0, 27011, 27011),
         16#6C#           =>  --  01E86C
          (0, 0, 27012, 27012),
         16#6D#           =>  --  01E86D
          (0, 0, 27013, 27013),
         16#6E#           =>  --  01E86E
          (0, 0, 27014, 27014),
         16#6F#           =>  --  01E86F
          (0, 0, 27015, 27015),
         16#70#           =>  --  01E870
          (0, 0, 27016, 27016),
         16#71#           =>  --  01E871
          (0, 0, 27017, 27017),
         16#72#           =>  --  01E872
          (0, 0, 27018, 27018),
         16#73#           =>  --  01E873
          (0, 0, 27019, 27019),
         16#74#           =>  --  01E874
          (0, 0, 27020, 27020),
         16#75#           =>  --  01E875
          (0, 0, 27021, 27021),
         16#76#           =>  --  01E876
          (0, 0, 27022, 27022),
         16#77#           =>  --  01E877
          (0, 0, 27023, 27023),
         16#78#           =>  --  01E878
          (0, 0, 27024, 27024),
         16#79#           =>  --  01E879
          (0, 0, 27025, 27025),
         16#7A#           =>  --  01E87A
          (0, 0, 27026, 27026),
         16#7B#           =>  --  01E87B
          (0, 0, 27027, 27027),
         16#7C#           =>  --  01E87C
          (0, 0, 27028, 27028),
         16#7D#           =>  --  01E87D
          (0, 0, 27029, 27029),
         16#7E#           =>  --  01E87E
          (0, 0, 27030, 27030),
         16#7F#           =>  --  01E87F
          (0, 0, 27031, 27031),
         16#80#           =>  --  01E880
          (0, 0, 27032, 27032),
         16#81#           =>  --  01E881
          (0, 0, 27033, 27033),
         16#82#           =>  --  01E882
          (0, 0, 27034, 27034),
         16#83#           =>  --  01E883
          (0, 0, 27035, 27035),
         16#84#           =>  --  01E884
          (0, 0, 27036, 27036),
         16#85#           =>  --  01E885
          (0, 0, 27037, 27037),
         16#86#           =>  --  01E886
          (0, 0, 27038, 27038),
         16#87#           =>  --  01E887
          (0, 0, 27039, 27039),
         16#88#           =>  --  01E888
          (0, 0, 27040, 27040),
         16#89#           =>  --  01E889
          (0, 0, 27041, 27041),
         16#8A#           =>  --  01E88A
          (0, 0, 27042, 27042),
         16#8B#           =>  --  01E88B
          (0, 0, 27043, 27043),
         16#8C#           =>  --  01E88C
          (0, 0, 27044, 27044),
         16#8D#           =>  --  01E88D
          (0, 0, 27045, 27045),
         16#8E#           =>  --  01E88E
          (0, 0, 27046, 27046),
         16#8F#           =>  --  01E88F
          (0, 0, 27047, 27047),
         16#90#           =>  --  01E890
          (0, 0, 27048, 27048),
         16#91#           =>  --  01E891
          (0, 0, 27049, 27049),
         16#92#           =>  --  01E892
          (0, 0, 27050, 27050),
         16#93#           =>  --  01E893
          (0, 0, 27051, 27051),
         16#94#           =>  --  01E894
          (0, 0, 27052, 27052),
         16#95#           =>  --  01E895
          (0, 0, 27053, 27053),
         16#96#           =>  --  01E896
          (0, 0, 27054, 27054),
         16#97#           =>  --  01E897
          (0, 0, 27055, 27055),
         16#98#           =>  --  01E898
          (0, 0, 27056, 27056),
         16#99#           =>  --  01E899
          (0, 0, 27057, 27057),
         16#9A#           =>  --  01E89A
          (0, 0, 27058, 27058),
         16#9B#           =>  --  01E89B
          (0, 0, 27059, 27059),
         16#9C#           =>  --  01E89C
          (0, 0, 27060, 27060),
         16#9D#           =>  --  01E89D
          (0, 0, 27061, 27061),
         16#9E#           =>  --  01E89E
          (0, 0, 27062, 27062),
         16#9F#           =>  --  01E89F
          (0, 0, 27063, 27063),
         16#A0#           =>  --  01E8A0
          (0, 0, 27064, 27064),
         16#A1#           =>  --  01E8A1
          (0, 0, 27065, 27065),
         16#A2#           =>  --  01E8A2
          (0, 0, 27066, 27066),
         16#A3#           =>  --  01E8A3
          (0, 0, 27067, 27067),
         16#A4#           =>  --  01E8A4
          (0, 0, 27068, 27068),
         16#A5#           =>  --  01E8A5
          (0, 0, 27069, 27069),
         16#A6#           =>  --  01E8A6
          (0, 0, 27070, 27070),
         16#A7#           =>  --  01E8A7
          (0, 0, 27071, 27071),
         16#A8#           =>  --  01E8A8
          (0, 0, 27072, 27072),
         16#A9#           =>  --  01E8A9
          (0, 0, 27073, 27073),
         16#AA#           =>  --  01E8AA
          (0, 0, 27074, 27074),
         16#AB#           =>  --  01E8AB
          (0, 0, 27075, 27075),
         16#AC#           =>  --  01E8AC
          (0, 0, 27076, 27076),
         16#AD#           =>  --  01E8AD
          (0, 0, 27077, 27077),
         16#AE#           =>  --  01E8AE
          (0, 0, 27078, 27078),
         16#AF#           =>  --  01E8AF
          (0, 0, 27079, 27079),
         16#B0#           =>  --  01E8B0
          (0, 0, 27080, 27080),
         16#B1#           =>  --  01E8B1
          (0, 0, 27081, 27081),
         16#B2#           =>  --  01E8B2
          (0, 0, 27082, 27082),
         16#B3#           =>  --  01E8B3
          (0, 0, 27083, 27083),
         16#B4#           =>  --  01E8B4
          (0, 0, 27084, 27084),
         16#B5#           =>  --  01E8B5
          (0, 0, 27085, 27085),
         16#B6#           =>  --  01E8B6
          (0, 0, 27086, 27086),
         16#B7#           =>  --  01E8B7
          (0, 0, 27087, 27087),
         16#B8#           =>  --  01E8B8
          (0, 0, 27088, 27088),
         16#B9#           =>  --  01E8B9
          (0, 0, 27089, 27089),
         16#BA#           =>  --  01E8BA
          (0, 0, 27090, 27090),
         16#BB#           =>  --  01E8BB
          (0, 0, 27091, 27091),
         16#BC#           =>  --  01E8BC
          (0, 0, 27092, 27092),
         16#BD#           =>  --  01E8BD
          (0, 0, 27093, 27093),
         16#BE#           =>  --  01E8BE
          (0, 0, 27094, 27094),
         16#BF#           =>  --  01E8BF
          (0, 0, 27095, 27095),
         16#C0#           =>  --  01E8C0
          (0, 0, 27096, 27096),
         16#C1#           =>  --  01E8C1
          (0, 0, 27097, 27097),
         16#C2#           =>  --  01E8C2
          (0, 0, 27098, 27098),
         16#C3#           =>  --  01E8C3
          (0, 0, 27099, 27099),
         16#C4#           =>  --  01E8C4
          (0, 0, 27100, 27100),
         16#C7#           =>  --  01E8C7
          (0, 0, 24, 24),
         16#C8#           =>  --  01E8C8
          (0, 0, 25, 25),
         16#C9#           =>  --  01E8C9
          (0, 0, 26, 26),
         16#CA#           =>  --  01E8CA
          (0, 0, 27, 27),
         16#CB#           =>  --  01E8CB
          (0, 0, 28, 28),
         16#CC#           =>  --  01E8CC
          (0, 0, 29, 29),
         16#CD#           =>  --  01E8CD
          (0, 0, 30, 30),
         16#CE#           =>  --  01E8CE
          (0, 0, 31, 31),
         16#CF#           =>  --  01E8CF
          (0, 0, 32, 32),
         16#D0# .. 16#D6# =>  --  01E8D0 .. 01E8D6
          (0, 0, 1, 1),
         others           =>
          (0, 0, 0, 0));

   Group_01EE : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  01EE00
          (0, 0, 27101, 27101),
         16#01#           =>  --  01EE01
          (0, 0, 27102, 27102),
         16#02#           =>  --  01EE02
          (0, 0, 27103, 27103),
         16#03#           =>  --  01EE03
          (0, 0, 27104, 27104),
         16#05#           =>  --  01EE05
          (0, 0, 27105, 27105),
         16#06#           =>  --  01EE06
          (0, 0, 27106, 27106),
         16#07#           =>  --  01EE07
          (0, 0, 27107, 27107),
         16#08#           =>  --  01EE08
          (0, 0, 27108, 27108),
         16#09#           =>  --  01EE09
          (0, 0, 27109, 27109),
         16#0A#           =>  --  01EE0A
          (0, 0, 27110, 27110),
         16#0B#           =>  --  01EE0B
          (0, 0, 27111, 27111),
         16#0C#           =>  --  01EE0C
          (0, 0, 27112, 27112),
         16#0D#           =>  --  01EE0D
          (0, 0, 27113, 27113),
         16#0E#           =>  --  01EE0E
          (0, 0, 27114, 27114),
         16#0F#           =>  --  01EE0F
          (0, 0, 27115, 27115),
         16#10#           =>  --  01EE10
          (0, 0, 27116, 27116),
         16#11#           =>  --  01EE11
          (0, 0, 27117, 27117),
         16#12#           =>  --  01EE12
          (0, 0, 27118, 27118),
         16#13#           =>  --  01EE13
          (0, 0, 27119, 27119),
         16#14#           =>  --  01EE14
          (0, 0, 27120, 27120),
         16#15#           =>  --  01EE15
          (0, 0, 27121, 27121),
         16#16#           =>  --  01EE16
          (0, 0, 27122, 27122),
         16#17#           =>  --  01EE17
          (0, 0, 27123, 27123),
         16#18#           =>  --  01EE18
          (0, 0, 27124, 27124),
         16#19#           =>  --  01EE19
          (0, 0, 27125, 27125),
         16#1A#           =>  --  01EE1A
          (0, 0, 27126, 27126),
         16#1B#           =>  --  01EE1B
          (0, 0, 27127, 27127),
         16#1C#           =>  --  01EE1C
          (0, 0, 27128, 27128),
         16#1D#           =>  --  01EE1D
          (0, 0, 27129, 27129),
         16#1E#           =>  --  01EE1E
          (0, 0, 27130, 27130),
         16#1F#           =>  --  01EE1F
          (0, 0, 27131, 27131),
         16#21#           =>  --  01EE21
          (0, 0, 27102, 27102),
         16#22#           =>  --  01EE22
          (0, 0, 27103, 27103),
         16#24#           =>  --  01EE24
          (0, 0, 27132, 27132),
         16#27#           =>  --  01EE27
          (0, 0, 27107, 27107),
         16#29#           =>  --  01EE29
          (0, 0, 27109, 27109),
         16#2A#           =>  --  01EE2A
          (0, 0, 27110, 27110),
         16#2B#           =>  --  01EE2B
          (0, 0, 27111, 27111),
         16#2C#           =>  --  01EE2C
          (0, 0, 27112, 27112),
         16#2D#           =>  --  01EE2D
          (0, 0, 27113, 27113),
         16#2E#           =>  --  01EE2E
          (0, 0, 27114, 27114),
         16#2F#           =>  --  01EE2F
          (0, 0, 27115, 27115),
         16#30#           =>  --  01EE30
          (0, 0, 27116, 27116),
         16#31#           =>  --  01EE31
          (0, 0, 27117, 27117),
         16#32#           =>  --  01EE32
          (0, 0, 27118, 27118),
         16#34#           =>  --  01EE34
          (0, 0, 27120, 27120),
         16#35#           =>  --  01EE35
          (0, 0, 27121, 27121),
         16#36#           =>  --  01EE36
          (0, 0, 27122, 27122),
         16#37#           =>  --  01EE37
          (0, 0, 27123, 27123),
         16#39#           =>  --  01EE39
          (0, 0, 27125, 27125),
         16#3B#           =>  --  01EE3B
          (0, 0, 27127, 27127),
         16#42#           =>  --  01EE42
          (0, 0, 27103, 27103),
         16#47#           =>  --  01EE47
          (0, 0, 27107, 27107),
         16#49#           =>  --  01EE49
          (0, 0, 27109, 27109),
         16#4B#           =>  --  01EE4B
          (0, 0, 27111, 27111),
         16#4D#           =>  --  01EE4D
          (0, 0, 27113, 27113),
         16#4E#           =>  --  01EE4E
          (0, 0, 27114, 27114),
         16#4F#           =>  --  01EE4F
          (0, 0, 27115, 27115),
         16#51#           =>  --  01EE51
          (0, 0, 27117, 27117),
         16#52#           =>  --  01EE52
          (0, 0, 27118, 27118),
         16#54#           =>  --  01EE54
          (0, 0, 27120, 27120),
         16#57#           =>  --  01EE57
          (0, 0, 27123, 27123),
         16#59#           =>  --  01EE59
          (0, 0, 27125, 27125),
         16#5B#           =>  --  01EE5B
          (0, 0, 27127, 27127),
         16#5D#           =>  --  01EE5D
          (0, 0, 27129, 27129),
         16#5F#           =>  --  01EE5F
          (0, 0, 27131, 27131),
         16#61#           =>  --  01EE61
          (0, 0, 27102, 27102),
         16#62#           =>  --  01EE62
          (0, 0, 27103, 27103),
         16#64#           =>  --  01EE64
          (0, 0, 27132, 27132),
         16#67#           =>  --  01EE67
          (0, 0, 27107, 27107),
         16#68#           =>  --  01EE68
          (0, 0, 27108, 27108),
         16#69#           =>  --  01EE69
          (0, 0, 27109, 27109),
         16#6A#           =>  --  01EE6A
          (0, 0, 27110, 27110),
         16#6C#           =>  --  01EE6C
          (0, 0, 27112, 27112),
         16#6D#           =>  --  01EE6D
          (0, 0, 27113, 27113),
         16#6E#           =>  --  01EE6E
          (0, 0, 27114, 27114),
         16#6F#           =>  --  01EE6F
          (0, 0, 27115, 27115),
         16#70#           =>  --  01EE70
          (0, 0, 27116, 27116),
         16#71#           =>  --  01EE71
          (0, 0, 27117, 27117),
         16#72#           =>  --  01EE72
          (0, 0, 27118, 27118),
         16#74#           =>  --  01EE74
          (0, 0, 27120, 27120),
         16#75#           =>  --  01EE75
          (0, 0, 27121, 27121),
         16#76#           =>  --  01EE76
          (0, 0, 27122, 27122),
         16#77#           =>  --  01EE77
          (0, 0, 27123, 27123),
         16#79#           =>  --  01EE79
          (0, 0, 27125, 27125),
         16#7A#           =>  --  01EE7A
          (0, 0, 27126, 27126),
         16#7B#           =>  --  01EE7B
          (0, 0, 27127, 27127),
         16#7C#           =>  --  01EE7C
          (0, 0, 27128, 27128),
         16#7E#           =>  --  01EE7E
          (0, 0, 27130, 27130),
         16#80#           =>  --  01EE80
          (0, 0, 27101, 27101),
         16#81#           =>  --  01EE81
          (0, 0, 27102, 27102),
         16#82#           =>  --  01EE82
          (0, 0, 27103, 27103),
         16#83#           =>  --  01EE83
          (0, 0, 27104, 27104),
         16#84#           =>  --  01EE84
          (0, 0, 27132, 27132),
         16#85#           =>  --  01EE85
          (0, 0, 27105, 27105),
         16#86#           =>  --  01EE86
          (0, 0, 27106, 27106),
         16#87#           =>  --  01EE87
          (0, 0, 27107, 27107),
         16#88#           =>  --  01EE88
          (0, 0, 27108, 27108),
         16#89#           =>  --  01EE89
          (0, 0, 27109, 27109),
         16#8B#           =>  --  01EE8B
          (0, 0, 27111, 27111),
         16#8C#           =>  --  01EE8C
          (0, 0, 27112, 27112),
         16#8D#           =>  --  01EE8D
          (0, 0, 27113, 27113),
         16#8E#           =>  --  01EE8E
          (0, 0, 27114, 27114),
         16#8F#           =>  --  01EE8F
          (0, 0, 27115, 27115),
         16#90#           =>  --  01EE90
          (0, 0, 27116, 27116),
         16#91#           =>  --  01EE91
          (0, 0, 27117, 27117),
         16#92#           =>  --  01EE92
          (0, 0, 27118, 27118),
         16#93#           =>  --  01EE93
          (0, 0, 27119, 27119),
         16#94#           =>  --  01EE94
          (0, 0, 27120, 27120),
         16#95#           =>  --  01EE95
          (0, 0, 27121, 27121),
         16#96#           =>  --  01EE96
          (0, 0, 27122, 27122),
         16#97#           =>  --  01EE97
          (0, 0, 27123, 27123),
         16#98#           =>  --  01EE98
          (0, 0, 27124, 27124),
         16#99#           =>  --  01EE99
          (0, 0, 27125, 27125),
         16#9A#           =>  --  01EE9A
          (0, 0, 27126, 27126),
         16#9B#           =>  --  01EE9B
          (0, 0, 27127, 27127),
         16#A1#           =>  --  01EEA1
          (0, 0, 27102, 27102),
         16#A2#           =>  --  01EEA2
          (0, 0, 27103, 27103),
         16#A3#           =>  --  01EEA3
          (0, 0, 27104, 27104),
         16#A5#           =>  --  01EEA5
          (0, 0, 27105, 27105),
         16#A6#           =>  --  01EEA6
          (0, 0, 27106, 27106),
         16#A7#           =>  --  01EEA7
          (0, 0, 27107, 27107),
         16#A8#           =>  --  01EEA8
          (0, 0, 27108, 27108),
         16#A9#           =>  --  01EEA9
          (0, 0, 27109, 27109),
         16#AB#           =>  --  01EEAB
          (0, 0, 27111, 27111),
         16#AC#           =>  --  01EEAC
          (0, 0, 27112, 27112),
         16#AD#           =>  --  01EEAD
          (0, 0, 27113, 27113),
         16#AE#           =>  --  01EEAE
          (0, 0, 27114, 27114),
         16#AF#           =>  --  01EEAF
          (0, 0, 27115, 27115),
         16#B0#           =>  --  01EEB0
          (0, 0, 27116, 27116),
         16#B1#           =>  --  01EEB1
          (0, 0, 27117, 27117),
         16#B2#           =>  --  01EEB2
          (0, 0, 27118, 27118),
         16#B3#           =>  --  01EEB3
          (0, 0, 27119, 27119),
         16#B4#           =>  --  01EEB4
          (0, 0, 27120, 27120),
         16#B5#           =>  --  01EEB5
          (0, 0, 27121, 27121),
         16#B6#           =>  --  01EEB6
          (0, 0, 27122, 27122),
         16#B7#           =>  --  01EEB7
          (0, 0, 27123, 27123),
         16#B8#           =>  --  01EEB8
          (0, 0, 27124, 27124),
         16#B9#           =>  --  01EEB9
          (0, 0, 27125, 27125),
         16#BA#           =>  --  01EEBA
          (0, 0, 27126, 27126),
         16#BB#           =>  --  01EEBB
          (0, 0, 27127, 27127),
         16#F0#           =>  --  01EEF0
          (0, 0, 27133, 27133),
         16#F1#           =>  --  01EEF1
          (0, 0, 27134, 27134),
         others           =>
          (0, 0, 0, 0));

   Group_01F0 : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  01F000
          (0, 0, 27135, 27135),
         16#01#           =>  --  01F001
          (0, 0, 27136, 27136),
         16#02#           =>  --  01F002
          (0, 0, 27137, 27137),
         16#03#           =>  --  01F003
          (0, 0, 27138, 27138),
         16#04#           =>  --  01F004
          (0, 0, 27139, 27139),
         16#05#           =>  --  01F005
          (0, 0, 27140, 27140),
         16#06#           =>  --  01F006
          (0, 0, 27141, 27141),
         16#07#           =>  --  01F007
          (0, 0, 27142, 27142),
         16#08#           =>  --  01F008
          (0, 0, 27143, 27143),
         16#09#           =>  --  01F009
          (0, 0, 27144, 27144),
         16#0A#           =>  --  01F00A
          (0, 0, 27145, 27145),
         16#0B#           =>  --  01F00B
          (0, 0, 27146, 27146),
         16#0C#           =>  --  01F00C
          (0, 0, 27147, 27147),
         16#0D#           =>  --  01F00D
          (0, 0, 27148, 27148),
         16#0E#           =>  --  01F00E
          (0, 0, 27149, 27149),
         16#0F#           =>  --  01F00F
          (0, 0, 27150, 27150),
         16#10#           =>  --  01F010
          (0, 0, 27151, 27151),
         16#11#           =>  --  01F011
          (0, 0, 27152, 27152),
         16#12#           =>  --  01F012
          (0, 0, 27153, 27153),
         16#13#           =>  --  01F013
          (0, 0, 27154, 27154),
         16#14#           =>  --  01F014
          (0, 0, 27155, 27155),
         16#15#           =>  --  01F015
          (0, 0, 27156, 27156),
         16#16#           =>  --  01F016
          (0, 0, 27157, 27157),
         16#17#           =>  --  01F017
          (0, 0, 27158, 27158),
         16#18#           =>  --  01F018
          (0, 0, 27159, 27159),
         16#19#           =>  --  01F019
          (0, 0, 27160, 27160),
         16#1A#           =>  --  01F01A
          (0, 0, 27161, 27161),
         16#1B#           =>  --  01F01B
          (0, 0, 27162, 27162),
         16#1C#           =>  --  01F01C
          (0, 0, 27163, 27163),
         16#1D#           =>  --  01F01D
          (0, 0, 27164, 27164),
         16#1E#           =>  --  01F01E
          (0, 0, 27165, 27165),
         16#1F#           =>  --  01F01F
          (0, 0, 27166, 27166),
         16#20#           =>  --  01F020
          (0, 0, 27167, 27167),
         16#21#           =>  --  01F021
          (0, 0, 27168, 27168),
         16#22#           =>  --  01F022
          (0, 0, 27169, 27169),
         16#23#           =>  --  01F023
          (0, 0, 27170, 27170),
         16#24#           =>  --  01F024
          (0, 0, 27171, 27171),
         16#25#           =>  --  01F025
          (0, 0, 27172, 27172),
         16#26#           =>  --  01F026
          (0, 0, 27173, 27173),
         16#27#           =>  --  01F027
          (0, 0, 27174, 27174),
         16#28#           =>  --  01F028
          (0, 0, 27175, 27175),
         16#29#           =>  --  01F029
          (0, 0, 27176, 27176),
         16#2A#           =>  --  01F02A
          (0, 0, 27177, 27177),
         16#2B#           =>  --  01F02B
          (0, 0, 27178, 27178),
         16#30#           =>  --  01F030
          (0, 0, 27179, 27179),
         16#31#           =>  --  01F031
          (0, 0, 27180, 27180),
         16#32#           =>  --  01F032
          (0, 0, 27181, 27181),
         16#33#           =>  --  01F033
          (0, 0, 27182, 27182),
         16#34#           =>  --  01F034
          (0, 0, 27183, 27183),
         16#35#           =>  --  01F035
          (0, 0, 27184, 27184),
         16#36#           =>  --  01F036
          (0, 0, 27185, 27185),
         16#37#           =>  --  01F037
          (0, 0, 27186, 27186),
         16#38#           =>  --  01F038
          (0, 0, 27187, 27187),
         16#39#           =>  --  01F039
          (0, 0, 27188, 27188),
         16#3A#           =>  --  01F03A
          (0, 0, 27189, 27189),
         16#3B#           =>  --  01F03B
          (0, 0, 27190, 27190),
         16#3C#           =>  --  01F03C
          (0, 0, 27191, 27191),
         16#3D#           =>  --  01F03D
          (0, 0, 27192, 27192),
         16#3E#           =>  --  01F03E
          (0, 0, 27193, 27193),
         16#3F#           =>  --  01F03F
          (0, 0, 27194, 27194),
         16#40#           =>  --  01F040
          (0, 0, 27195, 27195),
         16#41#           =>  --  01F041
          (0, 0, 27196, 27196),
         16#42#           =>  --  01F042
          (0, 0, 27197, 27197),
         16#43#           =>  --  01F043
          (0, 0, 27198, 27198),
         16#44#           =>  --  01F044
          (0, 0, 27199, 27199),
         16#45#           =>  --  01F045
          (0, 0, 27200, 27200),
         16#46#           =>  --  01F046
          (0, 0, 27201, 27201),
         16#47#           =>  --  01F047
          (0, 0, 27202, 27202),
         16#48#           =>  --  01F048
          (0, 0, 27203, 27203),
         16#49#           =>  --  01F049
          (0, 0, 27204, 27204),
         16#4A#           =>  --  01F04A
          (0, 0, 27205, 27205),
         16#4B#           =>  --  01F04B
          (0, 0, 27206, 27206),
         16#4C#           =>  --  01F04C
          (0, 0, 27207, 27207),
         16#4D#           =>  --  01F04D
          (0, 0, 27208, 27208),
         16#4E#           =>  --  01F04E
          (0, 0, 27209, 27209),
         16#4F#           =>  --  01F04F
          (0, 0, 27210, 27210),
         16#50#           =>  --  01F050
          (0, 0, 27211, 27211),
         16#51#           =>  --  01F051
          (0, 0, 27212, 27212),
         16#52#           =>  --  01F052
          (0, 0, 27213, 27213),
         16#53#           =>  --  01F053
          (0, 0, 27214, 27214),
         16#54#           =>  --  01F054
          (0, 0, 27215, 27215),
         16#55#           =>  --  01F055
          (0, 0, 27216, 27216),
         16#56#           =>  --  01F056
          (0, 0, 27217, 27217),
         16#57#           =>  --  01F057
          (0, 0, 27218, 27218),
         16#58#           =>  --  01F058
          (0, 0, 27219, 27219),
         16#59#           =>  --  01F059
          (0, 0, 27220, 27220),
         16#5A#           =>  --  01F05A
          (0, 0, 27221, 27221),
         16#5B#           =>  --  01F05B
          (0, 0, 27222, 27222),
         16#5C#           =>  --  01F05C
          (0, 0, 27223, 27223),
         16#5D#           =>  --  01F05D
          (0, 0, 27224, 27224),
         16#5E#           =>  --  01F05E
          (0, 0, 27225, 27225),
         16#5F#           =>  --  01F05F
          (0, 0, 27226, 27226),
         16#60#           =>  --  01F060
          (0, 0, 27227, 27227),
         16#61#           =>  --  01F061
          (0, 0, 27228, 27228),
         16#62#           =>  --  01F062
          (0, 0, 27229, 27229),
         16#63#           =>  --  01F063
          (0, 0, 27230, 27230),
         16#64#           =>  --  01F064
          (0, 0, 27231, 27231),
         16#65#           =>  --  01F065
          (0, 0, 27232, 27232),
         16#66#           =>  --  01F066
          (0, 0, 27233, 27233),
         16#67#           =>  --  01F067
          (0, 0, 27234, 27234),
         16#68#           =>  --  01F068
          (0, 0, 27235, 27235),
         16#69#           =>  --  01F069
          (0, 0, 27236, 27236),
         16#6A#           =>  --  01F06A
          (0, 0, 27237, 27237),
         16#6B#           =>  --  01F06B
          (0, 0, 27238, 27238),
         16#6C#           =>  --  01F06C
          (0, 0, 27239, 27239),
         16#6D#           =>  --  01F06D
          (0, 0, 27240, 27240),
         16#6E#           =>  --  01F06E
          (0, 0, 27241, 27241),
         16#6F#           =>  --  01F06F
          (0, 0, 27242, 27242),
         16#70#           =>  --  01F070
          (0, 0, 27243, 27243),
         16#71#           =>  --  01F071
          (0, 0, 27244, 27244),
         16#72#           =>  --  01F072
          (0, 0, 27245, 27245),
         16#73#           =>  --  01F073
          (0, 0, 27246, 27246),
         16#74#           =>  --  01F074
          (0, 0, 27247, 27247),
         16#75#           =>  --  01F075
          (0, 0, 27248, 27248),
         16#76#           =>  --  01F076
          (0, 0, 27249, 27249),
         16#77#           =>  --  01F077
          (0, 0, 27250, 27250),
         16#78#           =>  --  01F078
          (0, 0, 27251, 27251),
         16#79#           =>  --  01F079
          (0, 0, 27252, 27252),
         16#7A#           =>  --  01F07A
          (0, 0, 27253, 27253),
         16#7B#           =>  --  01F07B
          (0, 0, 27254, 27254),
         16#7C#           =>  --  01F07C
          (0, 0, 27255, 27255),
         16#7D#           =>  --  01F07D
          (0, 0, 27256, 27256),
         16#7E#           =>  --  01F07E
          (0, 0, 27257, 27257),
         16#7F#           =>  --  01F07F
          (0, 0, 27258, 27258),
         16#80#           =>  --  01F080
          (0, 0, 27259, 27259),
         16#81#           =>  --  01F081
          (0, 0, 27260, 27260),
         16#82#           =>  --  01F082
          (0, 0, 27261, 27261),
         16#83#           =>  --  01F083
          (0, 0, 27262, 27262),
         16#84#           =>  --  01F084
          (0, 0, 27263, 27263),
         16#85#           =>  --  01F085
          (0, 0, 27264, 27264),
         16#86#           =>  --  01F086
          (0, 0, 27265, 27265),
         16#87#           =>  --  01F087
          (0, 0, 27266, 27266),
         16#88#           =>  --  01F088
          (0, 0, 27267, 27267),
         16#89#           =>  --  01F089
          (0, 0, 27268, 27268),
         16#8A#           =>  --  01F08A
          (0, 0, 27269, 27269),
         16#8B#           =>  --  01F08B
          (0, 0, 27270, 27270),
         16#8C#           =>  --  01F08C
          (0, 0, 27271, 27271),
         16#8D#           =>  --  01F08D
          (0, 0, 27272, 27272),
         16#8E#           =>  --  01F08E
          (0, 0, 27273, 27273),
         16#8F#           =>  --  01F08F
          (0, 0, 27274, 27274),
         16#90#           =>  --  01F090
          (0, 0, 27275, 27275),
         16#91#           =>  --  01F091
          (0, 0, 27276, 27276),
         16#92#           =>  --  01F092
          (0, 0, 27277, 27277),
         16#93#           =>  --  01F093
          (0, 0, 27278, 27278),
         16#A0#           =>  --  01F0A0
          (0, 0, 27279, 27279),
         16#A1#           =>  --  01F0A1
          (0, 0, 27280, 27280),
         16#A2#           =>  --  01F0A2
          (0, 0, 27281, 27281),
         16#A3#           =>  --  01F0A3
          (0, 0, 27282, 27282),
         16#A4#           =>  --  01F0A4
          (0, 0, 27283, 27283),
         16#A5#           =>  --  01F0A5
          (0, 0, 27284, 27284),
         16#A6#           =>  --  01F0A6
          (0, 0, 27285, 27285),
         16#A7#           =>  --  01F0A7
          (0, 0, 27286, 27286),
         16#A8#           =>  --  01F0A8
          (0, 0, 27287, 27287),
         16#A9#           =>  --  01F0A9
          (0, 0, 27288, 27288),
         16#AA#           =>  --  01F0AA
          (0, 0, 27289, 27289),
         16#AB#           =>  --  01F0AB
          (0, 0, 27290, 27290),
         16#AC#           =>  --  01F0AC
          (0, 0, 27291, 27291),
         16#AD#           =>  --  01F0AD
          (0, 0, 27292, 27292),
         16#AE#           =>  --  01F0AE
          (0, 0, 27293, 27293),
         16#B1#           =>  --  01F0B1
          (0, 0, 27294, 27294),
         16#B2#           =>  --  01F0B2
          (0, 0, 27295, 27295),
         16#B3#           =>  --  01F0B3
          (0, 0, 27296, 27296),
         16#B4#           =>  --  01F0B4
          (0, 0, 27297, 27297),
         16#B5#           =>  --  01F0B5
          (0, 0, 27298, 27298),
         16#B6#           =>  --  01F0B6
          (0, 0, 27299, 27299),
         16#B7#           =>  --  01F0B7
          (0, 0, 27300, 27300),
         16#B8#           =>  --  01F0B8
          (0, 0, 27301, 27301),
         16#B9#           =>  --  01F0B9
          (0, 0, 27302, 27302),
         16#BA#           =>  --  01F0BA
          (0, 0, 27303, 27303),
         16#BB#           =>  --  01F0BB
          (0, 0, 27304, 27304),
         16#BC#           =>  --  01F0BC
          (0, 0, 27305, 27305),
         16#BD#           =>  --  01F0BD
          (0, 0, 27306, 27306),
         16#BE#           =>  --  01F0BE
          (0, 0, 27307, 27307),
         16#BF#           =>  --  01F0BF
          (0, 0, 27308, 27308),
         16#C1#           =>  --  01F0C1
          (0, 0, 27309, 27309),
         16#C2#           =>  --  01F0C2
          (0, 0, 27310, 27310),
         16#C3#           =>  --  01F0C3
          (0, 0, 27311, 27311),
         16#C4#           =>  --  01F0C4
          (0, 0, 27312, 27312),
         16#C5#           =>  --  01F0C5
          (0, 0, 27313, 27313),
         16#C6#           =>  --  01F0C6
          (0, 0, 27314, 27314),
         16#C7#           =>  --  01F0C7
          (0, 0, 27315, 27315),
         16#C8#           =>  --  01F0C8
          (0, 0, 27316, 27316),
         16#C9#           =>  --  01F0C9
          (0, 0, 27317, 27317),
         16#CA#           =>  --  01F0CA
          (0, 0, 27318, 27318),
         16#CB#           =>  --  01F0CB
          (0, 0, 27319, 27319),
         16#CC#           =>  --  01F0CC
          (0, 0, 27320, 27320),
         16#CD#           =>  --  01F0CD
          (0, 0, 27321, 27321),
         16#CE#           =>  --  01F0CE
          (0, 0, 27322, 27322),
         16#CF#           =>  --  01F0CF
          (0, 0, 27323, 27323),
         16#D1#           =>  --  01F0D1
          (0, 0, 27324, 27324),
         16#D2#           =>  --  01F0D2
          (0, 0, 27325, 27325),
         16#D3#           =>  --  01F0D3
          (0, 0, 27326, 27326),
         16#D4#           =>  --  01F0D4
          (0, 0, 27327, 27327),
         16#D5#           =>  --  01F0D5
          (0, 0, 27328, 27328),
         16#D6#           =>  --  01F0D6
          (0, 0, 27329, 27329),
         16#D7#           =>  --  01F0D7
          (0, 0, 27330, 27330),
         16#D8#           =>  --  01F0D8
          (0, 0, 27331, 27331),
         16#D9#           =>  --  01F0D9
          (0, 0, 27332, 27332),
         16#DA#           =>  --  01F0DA
          (0, 0, 27333, 27333),
         16#DB#           =>  --  01F0DB
          (0, 0, 27334, 27334),
         16#DC#           =>  --  01F0DC
          (0, 0, 27335, 27335),
         16#DD#           =>  --  01F0DD
          (0, 0, 27336, 27336),
         16#DE#           =>  --  01F0DE
          (0, 0, 27337, 27337),
         16#DF#           =>  --  01F0DF
          (0, 0, 27338, 27338),
         16#E0#           =>  --  01F0E0
          (0, 0, 27339, 27339),
         16#E1#           =>  --  01F0E1
          (0, 0, 27340, 27340),
         16#E2#           =>  --  01F0E2
          (0, 0, 27341, 27341),
         16#E3#           =>  --  01F0E3
          (0, 0, 27342, 27342),
         16#E4#           =>  --  01F0E4
          (0, 0, 27343, 27343),
         16#E5#           =>  --  01F0E5
          (0, 0, 27344, 27344),
         16#E6#           =>  --  01F0E6
          (0, 0, 27345, 27345),
         16#E7#           =>  --  01F0E7
          (0, 0, 27346, 27346),
         16#E8#           =>  --  01F0E8
          (0, 0, 27347, 27347),
         16#E9#           =>  --  01F0E9
          (0, 0, 27348, 27348),
         16#EA#           =>  --  01F0EA
          (0, 0, 27349, 27349),
         16#EB#           =>  --  01F0EB
          (0, 0, 27350, 27350),
         16#EC#           =>  --  01F0EC
          (0, 0, 27351, 27351),
         16#ED#           =>  --  01F0ED
          (0, 0, 27352, 27352),
         16#EE#           =>  --  01F0EE
          (0, 0, 27353, 27353),
         16#EF#           =>  --  01F0EF
          (0, 0, 27354, 27354),
         16#F0#           =>  --  01F0F0
          (0, 0, 27355, 27355),
         16#F1#           =>  --  01F0F1
          (0, 0, 27356, 27356),
         16#F2#           =>  --  01F0F2
          (0, 0, 27357, 27357),
         16#F3#           =>  --  01F0F3
          (0, 0, 27358, 27358),
         16#F4#           =>  --  01F0F4
          (0, 0, 27359, 27359),
         16#F5#           =>  --  01F0F5
          (0, 0, 27360, 27360),
         others           =>
          (0, 0, 0, 0));

   Group_01F1 : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  01F100
          (0, 0, 9544, 9545),
         16#01#           =>  --  01F101
          (0, 0, 27361, 27362),
         16#02#           =>  --  01F102
          (0, 0, 27363, 27364),
         16#03#           =>  --  01F103
          (0, 0, 27365, 27366),
         16#04#           =>  --  01F104
          (0, 0, 27367, 27368),
         16#05#           =>  --  01F105
          (0, 0, 27369, 27370),
         16#06#           =>  --  01F106
          (0, 0, 27371, 27372),
         16#07#           =>  --  01F107
          (0, 0, 27373, 27374),
         16#08#           =>  --  01F108
          (0, 0, 27375, 27376),
         16#09#           =>  --  01F109
          (0, 0, 27377, 27378),
         16#0A#           =>  --  01F10A
          (0, 0, 27379, 27380),
         16#0B# .. 16#0C# =>  --  01F10B .. 01F10C
          (0, 0, 9435, 9435),
         16#10#           =>  --  01F110
          (0, 0, 27381, 27383),
         16#11#           =>  --  01F111
          (0, 0, 27384, 27386),
         16#12#           =>  --  01F112
          (0, 0, 27387, 27389),
         16#13#           =>  --  01F113
          (0, 0, 27390, 27392),
         16#14#           =>  --  01F114
          (0, 0, 27393, 27395),
         16#15#           =>  --  01F115
          (0, 0, 27396, 27398),
         16#16#           =>  --  01F116
          (0, 0, 27399, 27401),
         16#17#           =>  --  01F117
          (0, 0, 27402, 27404),
         16#18#           =>  --  01F118
          (0, 0, 27405, 27407),
         16#19#           =>  --  01F119
          (0, 0, 27408, 27410),
         16#1A#           =>  --  01F11A
          (0, 0, 27411, 27413),
         16#1B#           =>  --  01F11B
          (0, 0, 27414, 27416),
         16#1C#           =>  --  01F11C
          (0, 0, 27417, 27419),
         16#1D#           =>  --  01F11D
          (0, 0, 27420, 27422),
         16#1E#           =>  --  01F11E
          (0, 0, 27423, 27425),
         16#1F#           =>  --  01F11F
          (0, 0, 27426, 27428),
         16#20#           =>  --  01F120
          (0, 0, 27429, 27431),
         16#21#           =>  --  01F121
          (0, 0, 27432, 27434),
         16#22#           =>  --  01F122
          (0, 0, 27435, 27437),
         16#23#           =>  --  01F123
          (0, 0, 27438, 27440),
         16#24#           =>  --  01F124
          (0, 0, 27441, 27443),
         16#25#           =>  --  01F125
          (0, 0, 27444, 27446),
         16#26#           =>  --  01F126
          (0, 0, 27447, 27449),
         16#27#           =>  --  01F127
          (0, 0, 27450, 27452),
         16#28#           =>  --  01F128
          (0, 0, 27453, 27455),
         16#29#           =>  --  01F129
          (0, 0, 27456, 27458),
         16#2A#           =>  --  01F12A
          (0, 0, 27459, 27461),
         16#2B#           =>  --  01F12B
          (0, 0, 9656, 9656),
         16#2C#           =>  --  01F12C
          (0, 0, 9671, 9671),
         16#2D#           =>  --  01F12D
          (0, 0, 9656, 9657),
         16#2E#           =>  --  01F12E
          (0, 0, 27462, 27463),
         16#30#           =>  --  01F130
          (0, 0, 6982, 6982),
         16#31#           =>  --  01F131
          (0, 0, 6986, 6986),
         16#32#           =>  --  01F132
          (0, 0, 14343, 14343),
         16#33#           =>  --  01F133
          (0, 0, 6988, 6988),
         16#34#           =>  --  01F134
          (0, 0, 6989, 6989),
         16#35#           =>  --  01F135
          (0, 0, 14206, 14206),
         16#36#           =>  --  01F136
          (0, 0, 6991, 6991),
         16#37#           =>  --  01F137
          (0, 0, 6992, 6992),
         16#38#           =>  --  01F138
          (0, 0, 6993, 6993),
         16#39#           =>  --  01F139
          (0, 0, 6994, 6994),
         16#3A#           =>  --  01F13A
          (0, 0, 6995, 6995),
         16#3B#           =>  --  01F13B
          (0, 0, 6996, 6996),
         16#3C#           =>  --  01F13C
          (0, 0, 6997, 6997),
         16#3D#           =>  --  01F13D
          (0, 0, 6998, 6998),
         16#3E#           =>  --  01F13E
          (0, 0, 7000, 7000),
         16#3F#           =>  --  01F13F
          (0, 0, 7002, 7002),
         16#40#           =>  --  01F140
          (0, 0, 27464, 27464),
         16#41#           =>  --  01F141
          (0, 0, 7003, 7003),
         16#42#           =>  --  01F142
          (0, 0, 14390, 14390),
         16#43#           =>  --  01F143
          (0, 0, 7004, 7004),
         16#44#           =>  --  01F144
          (0, 0, 7005, 7005),
         16#45#           =>  --  01F145
          (0, 0, 11538, 11538),
         16#46#           =>  --  01F146
          (0, 0, 7006, 7006),
         16#47#           =>  --  01F147
          (0, 0, 27465, 27465),
         16#48#           =>  --  01F148
          (0, 0, 27466, 27466),
         16#49#           =>  --  01F149
          (0, 0, 27467, 27467),
         16#4A#           =>  --  01F14A
          (0, 0, 27468, 27469),
         16#4B#           =>  --  01F14B
          (0, 0, 14317, 14318),
         16#4C#           =>  --  01F14C
          (0, 0, 27470, 27471),
         16#4D#           =>  --  01F14D
          (0, 0, 27472, 27473),
         16#4E#           =>  --  01F14E
          (0, 0, 27474, 27476),
         16#4F#           =>  --  01F14F
          (0, 0, 27477, 27478),
         16#50#           =>  --  01F150
          (0, 0, 9654, 9654),
         16#51#           =>  --  01F151
          (0, 0, 9655, 9655),
         16#52#           =>  --  01F152
          (0, 0, 9656, 9656),
         16#53#           =>  --  01F153
          (0, 0, 9657, 9657),
         16#54#           =>  --  01F154
          (0, 0, 9658, 9658),
         16#55#           =>  --  01F155
          (0, 0, 9659, 9659),
         16#56#           =>  --  01F156
          (0, 0, 9660, 9660),
         16#57#           =>  --  01F157
          (0, 0, 9661, 9661),
         16#58#           =>  --  01F158
          (0, 0, 9662, 9662),
         16#59#           =>  --  01F159
          (0, 0, 9663, 9663),
         16#5A#           =>  --  01F15A
          (0, 0, 9664, 9664),
         16#5B#           =>  --  01F15B
          (0, 0, 9665, 9665),
         16#5C#           =>  --  01F15C
          (0, 0, 9666, 9666),
         16#5D#           =>  --  01F15D
          (0, 0, 9667, 9667),
         16#5E#           =>  --  01F15E
          (0, 0, 9668, 9668),
         16#5F#           =>  --  01F15F
          (0, 0, 9669, 9669),
         16#60#           =>  --  01F160
          (0, 0, 9670, 9670),
         16#61#           =>  --  01F161
          (0, 0, 9671, 9671),
         16#62#           =>  --  01F162
          (0, 0, 9672, 9672),
         16#63#           =>  --  01F163
          (0, 0, 9673, 9673),
         16#64#           =>  --  01F164
          (0, 0, 9674, 9674),
         16#65#           =>  --  01F165
          (0, 0, 9675, 9675),
         16#66#           =>  --  01F166
          (0, 0, 9676, 9676),
         16#67#           =>  --  01F167
          (0, 0, 9677, 9677),
         16#68#           =>  --  01F168
          (0, 0, 9678, 9678),
         16#69#           =>  --  01F169
          (0, 0, 9679, 9679),
         16#6A#           =>  --  01F16A
          (0, 0, 27479, 27480),
         16#6B#           =>  --  01F16B
          (0, 0, 27481, 27482),
         16#70#           =>  --  01F170
          (0, 0, 6982, 6982),
         16#71#           =>  --  01F171
          (0, 0, 6986, 6986),
         16#72#           =>  --  01F172
          (0, 0, 14343, 14343),
         16#73#           =>  --  01F173
          (0, 0, 6988, 6988),
         16#74#           =>  --  01F174
          (0, 0, 6989, 6989),
         16#75#           =>  --  01F175
          (0, 0, 14206, 14206),
         16#76#           =>  --  01F176
          (0, 0, 6991, 6991),
         16#77#           =>  --  01F177
          (0, 0, 6992, 6992),
         16#78#           =>  --  01F178
          (0, 0, 6993, 6993),
         16#79#           =>  --  01F179
          (0, 0, 6994, 6994),
         16#7A#           =>  --  01F17A
          (0, 0, 6995, 6995),
         16#7B#           =>  --  01F17B
          (0, 0, 6996, 6996),
         16#7C#           =>  --  01F17C
          (0, 0, 6997, 6997),
         16#7D#           =>  --  01F17D
          (0, 0, 6998, 6998),
         16#7E#           =>  --  01F17E
          (0, 0, 7000, 7000),
         16#7F#           =>  --  01F17F
          (0, 0, 7002, 7002),
         16#80#           =>  --  01F180
          (0, 0, 27464, 27464),
         16#81#           =>  --  01F181
          (0, 0, 7003, 7003),
         16#82#           =>  --  01F182
          (0, 0, 14390, 14390),
         16#83#           =>  --  01F183
          (0, 0, 7004, 7004),
         16#84#           =>  --  01F184
          (0, 0, 7005, 7005),
         16#85#           =>  --  01F185
          (0, 0, 11538, 11538),
         16#86#           =>  --  01F186
          (0, 0, 7006, 7006),
         16#87#           =>  --  01F187
          (0, 0, 27465, 27465),
         16#88#           =>  --  01F188
          (0, 0, 27466, 27466),
         16#89#           =>  --  01F189
          (0, 0, 27467, 27467),
         16#8A#           =>  --  01F18A
          (0, 0, 7002, 7002),
         16#8B#           =>  --  01F18B
          (0, 0, 27483, 27484),
         16#8C#           =>  --  01F18C
          (0, 0, 27485, 27486),
         16#8D#           =>  --  01F18D
          (0, 0, 27487, 27488),
         16#8E#           =>  --  01F18E
          (0, 0, 27489, 27490),
         16#8F#           =>  --  01F18F
          (0, 0, 27477, 27478),
         16#90#           =>  --  01F190
          (0, 0, 27491, 27492),
         16#91#           =>  --  01F191
          (0, 0, 27493, 27494),
         16#92#           =>  --  01F192
          (0, 0, 27495, 27498),
         16#93#           =>  --  01F193
          (0, 0, 27499, 27502),
         16#94#           =>  --  01F194
          (0, 0, 27503, 27504),
         16#95#           =>  --  01F195
          (0, 0, 27505, 27507),
         16#96#           =>  --  01F196
          (0, 0, 27508, 27509),
         16#97#           =>  --  01F197
          (0, 0, 27510, 27511),
         16#98#           =>  --  01F198
          (0, 0, 27512, 27514),
         16#99#           =>  --  01F199
          (0, 0, 27515, 27517),
         16#9A#           =>  --  01F19A
          (0, 0, 27469, 27470),
         16#E6#           =>  --  01F1E6
          (0, 0, 27518, 27518),
         16#E7#           =>  --  01F1E7
          (0, 0, 27519, 27519),
         16#E8#           =>  --  01F1E8
          (0, 0, 27520, 27520),
         16#E9#           =>  --  01F1E9
          (0, 0, 27521, 27521),
         16#EA#           =>  --  01F1EA
          (0, 0, 27522, 27522),
         16#EB#           =>  --  01F1EB
          (0, 0, 27523, 27523),
         16#EC#           =>  --  01F1EC
          (0, 0, 27524, 27524),
         16#ED#           =>  --  01F1ED
          (0, 0, 27525, 27525),
         16#EE#           =>  --  01F1EE
          (0, 0, 27526, 27526),
         16#EF#           =>  --  01F1EF
          (0, 0, 27527, 27527),
         16#F0#           =>  --  01F1F0
          (0, 0, 27528, 27528),
         16#F1#           =>  --  01F1F1
          (0, 0, 27529, 27529),
         16#F2#           =>  --  01F1F2
          (0, 0, 27530, 27530),
         16#F3#           =>  --  01F1F3
          (0, 0, 27531, 27531),
         16#F4#           =>  --  01F1F4
          (0, 0, 27532, 27532),
         16#F5#           =>  --  01F1F5
          (0, 0, 27533, 27533),
         16#F6#           =>  --  01F1F6
          (0, 0, 27534, 27534),
         16#F7#           =>  --  01F1F7
          (0, 0, 27535, 27535),
         16#F8#           =>  --  01F1F8
          (0, 0, 27536, 27536),
         16#F9#           =>  --  01F1F9
          (0, 0, 27537, 27537),
         16#FA#           =>  --  01F1FA
          (0, 0, 27538, 27538),
         16#FB#           =>  --  01F1FB
          (0, 0, 27539, 27539),
         16#FC#           =>  --  01F1FC
          (0, 0, 27540, 27540),
         16#FD#           =>  --  01F1FD
          (0, 0, 27541, 27541),
         16#FE#           =>  --  01F1FE
          (0, 0, 27542, 27542),
         16#FF#           =>  --  01F1FF
          (0, 0, 27543, 27543),
         others           =>
          (0, 0, 0, 0));

   Group_01F2 : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  01F200
          (0, 0, 27544, 27545),
         16#01#           =>  --  01F201
          (0, 0, 27546, 27547),
         16#02#           =>  --  01F202
          (0, 0, 13835, 13835),
         16#10#           =>  --  01F210
          (0, 0, 27548, 27549),
         16#11#           =>  --  01F211
          (0, 0, 27550, 27551),
         16#12#           =>  --  01F212
          (0, 0, 27552, 27553),
         16#13#           =>  --  01F213
          (0, 0, 13859, 13860),
         16#14#           =>  --  01F214
          (0, 0, 27554, 27555),
         16#15#           =>  --  01F215
          (0, 0, 27556, 27557),
         16#16#           =>  --  01F216
          (0, 0, 27558, 27559),
         16#17#           =>  --  01F217
          (0, 0, 27560, 27561),
         16#18#           =>  --  01F218
          (0, 0, 27562, 27563),
         16#19#           =>  --  01F219
          (0, 0, 27564, 27565),
         16#1A#           =>  --  01F21A
          (0, 0, 27566, 27567),
         16#1B#           =>  --  01F21B
          (0, 0, 27568, 27569),
         16#1C#           =>  --  01F21C
          (0, 0, 27570, 27571),
         16#1D#           =>  --  01F21D
          (0, 0, 27572, 27573),
         16#1E#           =>  --  01F21E
          (0, 0, 27574, 27575),
         16#1F#           =>  --  01F21F
          (0, 0, 27576, 27577),
         16#20#           =>  --  01F220
          (0, 0, 27578, 27579),
         16#21#           =>  --  01F221
          (0, 0, 27580, 27581),
         16#22#           =>  --  01F222
          (0, 0, 27582, 27583),
         16#23#           =>  --  01F223
          (0, 0, 27584, 27585),
         16#24#           =>  --  01F224
          (0, 0, 27586, 27587),
         16#25#           =>  --  01F225
          (0, 0, 27588, 27589),
         16#26#           =>  --  01F226
          (0, 0, 27590, 27591),
         16#27#           =>  --  01F227
          (0, 0, 27592, 27593),
         16#28#           =>  --  01F228
          (0, 0, 27594, 27595),
         16#29#           =>  --  01F229
          (0, 0, 27596, 27597),
         16#2A#           =>  --  01F22A
          (0, 0, 27598, 27599),
         16#2B#           =>  --  01F22B
          (0, 0, 27600, 27601),
         16#2C#           =>  --  01F22C
          (0, 0, 27602, 27603),
         16#2D#           =>  --  01F22D
          (0, 0, 27604, 27605),
         16#2E#           =>  --  01F22E
          (0, 0, 27606, 27607),
         16#2F#           =>  --  01F22F
          (0, 0, 27608, 27609),
         16#30#           =>  --  01F230
          (0, 0, 27610, 27611),
         16#31#           =>  --  01F231
          (0, 0, 27612, 27613),
         16#32#           =>  --  01F232
          (0, 0, 27614, 27615),
         16#33#           =>  --  01F233
          (0, 0, 27616, 27617),
         16#34#           =>  --  01F234
          (0, 0, 27618, 27619),
         16#35#           =>  --  01F235
          (0, 0, 27620, 27621),
         16#36#           =>  --  01F236
          (0, 0, 27622, 27623),
         16#37#           =>  --  01F237
          (0, 0, 27624, 27625),
         16#38#           =>  --  01F238
          (0, 0, 27626, 27627),
         16#39#           =>  --  01F239
          (0, 0, 27628, 27629),
         16#3A#           =>  --  01F23A
          (0, 0, 27630, 27631),
         16#40#           =>  --  01F240
          (0, 0, 27632, 27635),
         16#41#           =>  --  01F241
          (0, 0, 27636, 27639),
         16#42#           =>  --  01F242
          (0, 0, 27640, 27643),
         16#43#           =>  --  01F243
          (0, 0, 27644, 27647),
         16#44#           =>  --  01F244
          (0, 0, 27648, 27651),
         16#45#           =>  --  01F245
          (0, 0, 27652, 27655),
         16#46#           =>  --  01F246
          (0, 0, 27656, 27659),
         16#47#           =>  --  01F247
          (0, 0, 27660, 27663),
         16#48#           =>  --  01F248
          (0, 0, 27664, 27667),
         16#50#           =>  --  01F250
          (0, 0, 27668, 27669),
         16#51#           =>  --  01F251
          (0, 0, 27670, 27671),
         others           =>
          (0, 0, 0, 0));

   Group_01F3 : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  01F300
          (0, 0, 27672, 27672),
         16#01#           =>  --  01F301
          (0, 0, 27673, 27673),
         16#02#           =>  --  01F302
          (0, 0, 27674, 27674),
         16#03#           =>  --  01F303
          (0, 0, 27675, 27675),
         16#04#           =>  --  01F304
          (0, 0, 27676, 27676),
         16#05#           =>  --  01F305
          (0, 0, 27677, 27677),
         16#06#           =>  --  01F306
          (0, 0, 27678, 27678),
         16#07#           =>  --  01F307
          (0, 0, 27679, 27679),
         16#08#           =>  --  01F308
          (0, 0, 27680, 27680),
         16#09#           =>  --  01F309
          (0, 0, 27681, 27681),
         16#0A#           =>  --  01F30A
          (0, 0, 27682, 27682),
         16#0B#           =>  --  01F30B
          (0, 0, 27683, 27683),
         16#0C#           =>  --  01F30C
          (0, 0, 27684, 27684),
         16#0D#           =>  --  01F30D
          (0, 0, 27685, 27685),
         16#0E#           =>  --  01F30E
          (0, 0, 27686, 27686),
         16#0F#           =>  --  01F30F
          (0, 0, 27687, 27687),
         16#10#           =>  --  01F310
          (0, 0, 27688, 27688),
         16#11#           =>  --  01F311
          (0, 0, 27689, 27689),
         16#12#           =>  --  01F312
          (0, 0, 27690, 27690),
         16#13#           =>  --  01F313
          (0, 0, 27691, 27691),
         16#14#           =>  --  01F314
          (0, 0, 27692, 27692),
         16#15#           =>  --  01F315
          (0, 0, 27693, 27693),
         16#16#           =>  --  01F316
          (0, 0, 27694, 27694),
         16#17#           =>  --  01F317
          (0, 0, 27695, 27695),
         16#18#           =>  --  01F318
          (0, 0, 27696, 27696),
         16#19#           =>  --  01F319
          (0, 0, 27697, 27697),
         16#1A#           =>  --  01F31A
          (0, 0, 27698, 27698),
         16#1B#           =>  --  01F31B
          (0, 0, 27699, 27699),
         16#1C#           =>  --  01F31C
          (0, 0, 27700, 27700),
         16#1D#           =>  --  01F31D
          (0, 0, 27701, 27701),
         16#1E#           =>  --  01F31E
          (0, 0, 27702, 27702),
         16#1F#           =>  --  01F31F
          (0, 0, 27703, 27703),
         16#20#           =>  --  01F320
          (0, 0, 27704, 27704),
         16#21#           =>  --  01F321
          (0, 0, 27705, 27705),
         16#22#           =>  --  01F322
          (0, 0, 27706, 27706),
         16#23#           =>  --  01F323
          (0, 0, 27707, 27707),
         16#24#           =>  --  01F324
          (0, 0, 27708, 27708),
         16#25#           =>  --  01F325
          (0, 0, 27709, 27709),
         16#26#           =>  --  01F326
          (0, 0, 27710, 27710),
         16#27#           =>  --  01F327
          (0, 0, 27711, 27711),
         16#28#           =>  --  01F328
          (0, 0, 27712, 27712),
         16#29#           =>  --  01F329
          (0, 0, 27713, 27713),
         16#2A#           =>  --  01F32A
          (0, 0, 27714, 27714),
         16#2B#           =>  --  01F32B
          (0, 0, 27715, 27715),
         16#2C#           =>  --  01F32C
          (0, 0, 27716, 27716),
         16#30#           =>  --  01F330
          (0, 0, 27717, 27717),
         16#31#           =>  --  01F331
          (0, 0, 27718, 27718),
         16#32#           =>  --  01F332
          (0, 0, 27719, 27719),
         16#33#           =>  --  01F333
          (0, 0, 27720, 27720),
         16#34#           =>  --  01F334
          (0, 0, 27721, 27721),
         16#35#           =>  --  01F335
          (0, 0, 27722, 27722),
         16#36#           =>  --  01F336
          (0, 0, 27723, 27723),
         16#37#           =>  --  01F337
          (0, 0, 27724, 27724),
         16#38#           =>  --  01F338
          (0, 0, 27725, 27725),
         16#39#           =>  --  01F339
          (0, 0, 27726, 27726),
         16#3A#           =>  --  01F33A
          (0, 0, 27727, 27727),
         16#3B#           =>  --  01F33B
          (0, 0, 27728, 27728),
         16#3C#           =>  --  01F33C
          (0, 0, 27729, 27729),
         16#3D#           =>  --  01F33D
          (0, 0, 27730, 27730),
         16#3E#           =>  --  01F33E
          (0, 0, 27731, 27731),
         16#3F#           =>  --  01F33F
          (0, 0, 27732, 27732),
         16#40#           =>  --  01F340
          (0, 0, 27733, 27733),
         16#41#           =>  --  01F341
          (0, 0, 27734, 27734),
         16#42#           =>  --  01F342
          (0, 0, 27735, 27735),
         16#43#           =>  --  01F343
          (0, 0, 27736, 27736),
         16#44#           =>  --  01F344
          (0, 0, 27737, 27737),
         16#45#           =>  --  01F345
          (0, 0, 27738, 27738),
         16#46#           =>  --  01F346
          (0, 0, 27739, 27739),
         16#47#           =>  --  01F347
          (0, 0, 27740, 27740),
         16#48#           =>  --  01F348
          (0, 0, 27741, 27741),
         16#49#           =>  --  01F349
          (0, 0, 27742, 27742),
         16#4A#           =>  --  01F34A
          (0, 0, 27743, 27743),
         16#4B#           =>  --  01F34B
          (0, 0, 27744, 27744),
         16#4C#           =>  --  01F34C
          (0, 0, 27745, 27745),
         16#4D#           =>  --  01F34D
          (0, 0, 27746, 27746),
         16#4E#           =>  --  01F34E
          (0, 0, 27747, 27747),
         16#4F#           =>  --  01F34F
          (0, 0, 27748, 27748),
         16#50#           =>  --  01F350
          (0, 0, 27749, 27749),
         16#51#           =>  --  01F351
          (0, 0, 27750, 27750),
         16#52#           =>  --  01F352
          (0, 0, 27751, 27751),
         16#53#           =>  --  01F353
          (0, 0, 27752, 27752),
         16#54#           =>  --  01F354
          (0, 0, 27753, 27753),
         16#55#           =>  --  01F355
          (0, 0, 27754, 27754),
         16#56#           =>  --  01F356
          (0, 0, 27755, 27755),
         16#57#           =>  --  01F357
          (0, 0, 27756, 27756),
         16#58#           =>  --  01F358
          (0, 0, 27757, 27757),
         16#59#           =>  --  01F359
          (0, 0, 27758, 27758),
         16#5A#           =>  --  01F35A
          (0, 0, 27759, 27759),
         16#5B#           =>  --  01F35B
          (0, 0, 27760, 27760),
         16#5C#           =>  --  01F35C
          (0, 0, 27761, 27761),
         16#5D#           =>  --  01F35D
          (0, 0, 27762, 27762),
         16#5E#           =>  --  01F35E
          (0, 0, 27763, 27763),
         16#5F#           =>  --  01F35F
          (0, 0, 27764, 27764),
         16#60#           =>  --  01F360
          (0, 0, 27765, 27765),
         16#61#           =>  --  01F361
          (0, 0, 27766, 27766),
         16#62#           =>  --  01F362
          (0, 0, 27767, 27767),
         16#63#           =>  --  01F363
          (0, 0, 27768, 27768),
         16#64#           =>  --  01F364
          (0, 0, 27769, 27769),
         16#65#           =>  --  01F365
          (0, 0, 27770, 27770),
         16#66#           =>  --  01F366
          (0, 0, 27771, 27771),
         16#67#           =>  --  01F367
          (0, 0, 27772, 27772),
         16#68#           =>  --  01F368
          (0, 0, 27773, 27773),
         16#69#           =>  --  01F369
          (0, 0, 27774, 27774),
         16#6A#           =>  --  01F36A
          (0, 0, 27775, 27775),
         16#6B#           =>  --  01F36B
          (0, 0, 27776, 27776),
         16#6C#           =>  --  01F36C
          (0, 0, 27777, 27777),
         16#6D#           =>  --  01F36D
          (0, 0, 27778, 27778),
         16#6E#           =>  --  01F36E
          (0, 0, 27779, 27779),
         16#6F#           =>  --  01F36F
          (0, 0, 27780, 27780),
         16#70#           =>  --  01F370
          (0, 0, 27781, 27781),
         16#71#           =>  --  01F371
          (0, 0, 27782, 27782),
         16#72#           =>  --  01F372
          (0, 0, 27783, 27783),
         16#73#           =>  --  01F373
          (0, 0, 27784, 27784),
         16#74#           =>  --  01F374
          (0, 0, 27785, 27785),
         16#75#           =>  --  01F375
          (0, 0, 27786, 27786),
         16#76#           =>  --  01F376
          (0, 0, 27787, 27787),
         16#77#           =>  --  01F377
          (0, 0, 27788, 27788),
         16#78#           =>  --  01F378
          (0, 0, 27789, 27789),
         16#79#           =>  --  01F379
          (0, 0, 27790, 27790),
         16#7A#           =>  --  01F37A
          (0, 0, 27791, 27791),
         16#7B#           =>  --  01F37B
          (0, 0, 27792, 27792),
         16#7C#           =>  --  01F37C
          (0, 0, 27793, 27793),
         16#7D#           =>  --  01F37D
          (0, 0, 27794, 27794),
         16#80#           =>  --  01F380
          (0, 0, 27795, 27795),
         16#81#           =>  --  01F381
          (0, 0, 27796, 27796),
         16#82#           =>  --  01F382
          (0, 0, 27797, 27797),
         16#83#           =>  --  01F383
          (0, 0, 27798, 27798),
         16#84#           =>  --  01F384
          (0, 0, 27799, 27799),
         16#85#           =>  --  01F385
          (0, 0, 27800, 27800),
         16#86#           =>  --  01F386
          (0, 0, 27801, 27801),
         16#87#           =>  --  01F387
          (0, 0, 27802, 27802),
         16#88#           =>  --  01F388
          (0, 0, 27803, 27803),
         16#89#           =>  --  01F389
          (0, 0, 27804, 27804),
         16#8A#           =>  --  01F38A
          (0, 0, 27805, 27805),
         16#8B#           =>  --  01F38B
          (0, 0, 27806, 27806),
         16#8C#           =>  --  01F38C
          (0, 0, 27807, 27807),
         16#8D#           =>  --  01F38D
          (0, 0, 27808, 27808),
         16#8E#           =>  --  01F38E
          (0, 0, 27809, 27809),
         16#8F#           =>  --  01F38F
          (0, 0, 27810, 27810),
         16#90#           =>  --  01F390
          (0, 0, 27811, 27811),
         16#91#           =>  --  01F391
          (0, 0, 27812, 27812),
         16#92#           =>  --  01F392
          (0, 0, 27813, 27813),
         16#93#           =>  --  01F393
          (0, 0, 27814, 27814),
         16#94#           =>  --  01F394
          (0, 0, 27815, 27815),
         16#95#           =>  --  01F395
          (0, 0, 27816, 27816),
         16#96#           =>  --  01F396
          (0, 0, 27817, 27817),
         16#97#           =>  --  01F397
          (0, 0, 27818, 27818),
         16#98#           =>  --  01F398
          (0, 0, 27819, 27819),
         16#99#           =>  --  01F399
          (0, 0, 27820, 27820),
         16#9A#           =>  --  01F39A
          (0, 0, 27821, 27821),
         16#9B#           =>  --  01F39B
          (0, 0, 27822, 27822),
         16#9C#           =>  --  01F39C
          (0, 0, 27823, 27823),
         16#9D#           =>  --  01F39D
          (0, 0, 27824, 27824),
         16#9E#           =>  --  01F39E
          (0, 0, 27825, 27825),
         16#9F#           =>  --  01F39F
          (0, 0, 27826, 27826),
         16#A0#           =>  --  01F3A0
          (0, 0, 27827, 27827),
         16#A1#           =>  --  01F3A1
          (0, 0, 27828, 27828),
         16#A2#           =>  --  01F3A2
          (0, 0, 27829, 27829),
         16#A3#           =>  --  01F3A3
          (0, 0, 27830, 27830),
         16#A4#           =>  --  01F3A4
          (0, 0, 27831, 27831),
         16#A5#           =>  --  01F3A5
          (0, 0, 27832, 27832),
         16#A6#           =>  --  01F3A6
          (0, 0, 27833, 27833),
         16#A7#           =>  --  01F3A7
          (0, 0, 27834, 27834),
         16#A8#           =>  --  01F3A8
          (0, 0, 27835, 27835),
         16#A9#           =>  --  01F3A9
          (0, 0, 27836, 27836),
         16#AA#           =>  --  01F3AA
          (0, 0, 27837, 27837),
         16#AB#           =>  --  01F3AB
          (0, 0, 27838, 27838),
         16#AC#           =>  --  01F3AC
          (0, 0, 27839, 27839),
         16#AD#           =>  --  01F3AD
          (0, 0, 27840, 27840),
         16#AE#           =>  --  01F3AE
          (0, 0, 27841, 27841),
         16#AF#           =>  --  01F3AF
          (0, 0, 27842, 27842),
         16#B0#           =>  --  01F3B0
          (0, 0, 27843, 27843),
         16#B1#           =>  --  01F3B1
          (0, 0, 27844, 27844),
         16#B2#           =>  --  01F3B2
          (0, 0, 27845, 27845),
         16#B3#           =>  --  01F3B3
          (0, 0, 27846, 27846),
         16#B4#           =>  --  01F3B4
          (0, 0, 27847, 27847),
         16#B5#           =>  --  01F3B5
          (0, 0, 27848, 27848),
         16#B6#           =>  --  01F3B6
          (0, 0, 27849, 27849),
         16#B7#           =>  --  01F3B7
          (0, 0, 27850, 27850),
         16#B8#           =>  --  01F3B8
          (0, 0, 27851, 27851),
         16#B9#           =>  --  01F3B9
          (0, 0, 27852, 27852),
         16#BA#           =>  --  01F3BA
          (0, 0, 27853, 27853),
         16#BB#           =>  --  01F3BB
          (0, 0, 27854, 27854),
         16#BC#           =>  --  01F3BC
          (0, 0, 27855, 27855),
         16#BD#           =>  --  01F3BD
          (0, 0, 27856, 27856),
         16#BE#           =>  --  01F3BE
          (0, 0, 27857, 27857),
         16#BF#           =>  --  01F3BF
          (0, 0, 27858, 27858),
         16#C0#           =>  --  01F3C0
          (0, 0, 27859, 27859),
         16#C1#           =>  --  01F3C1
          (0, 0, 27860, 27860),
         16#C2#           =>  --  01F3C2
          (0, 0, 27861, 27861),
         16#C3#           =>  --  01F3C3
          (0, 0, 27862, 27862),
         16#C4#           =>  --  01F3C4
          (0, 0, 27863, 27863),
         16#C5#           =>  --  01F3C5
          (0, 0, 27864, 27864),
         16#C6#           =>  --  01F3C6
          (0, 0, 27865, 27865),
         16#C7#           =>  --  01F3C7
          (0, 0, 27866, 27866),
         16#C8#           =>  --  01F3C8
          (0, 0, 27867, 27867),
         16#C9#           =>  --  01F3C9
          (0, 0, 27868, 27868),
         16#CA#           =>  --  01F3CA
          (0, 0, 27869, 27869),
         16#CB#           =>  --  01F3CB
          (0, 0, 27870, 27870),
         16#CC#           =>  --  01F3CC
          (0, 0, 27871, 27871),
         16#CD#           =>  --  01F3CD
          (0, 0, 27872, 27872),
         16#CE#           =>  --  01F3CE
          (0, 0, 27873, 27873),
         16#D4#           =>  --  01F3D4
          (0, 0, 27874, 27874),
         16#D5#           =>  --  01F3D5
          (0, 0, 27875, 27875),
         16#D6#           =>  --  01F3D6
          (0, 0, 27876, 27876),
         16#D7#           =>  --  01F3D7
          (0, 0, 27877, 27877),
         16#D8#           =>  --  01F3D8
          (0, 0, 27878, 27878),
         16#D9#           =>  --  01F3D9
          (0, 0, 27879, 27879),
         16#DA#           =>  --  01F3DA
          (0, 0, 27880, 27880),
         16#DB#           =>  --  01F3DB
          (0, 0, 27881, 27881),
         16#DC#           =>  --  01F3DC
          (0, 0, 27882, 27882),
         16#DD#           =>  --  01F3DD
          (0, 0, 27883, 27883),
         16#DE#           =>  --  01F3DE
          (0, 0, 27884, 27884),
         16#DF#           =>  --  01F3DF
          (0, 0, 27885, 27885),
         16#E0#           =>  --  01F3E0
          (0, 0, 27886, 27886),
         16#E1#           =>  --  01F3E1
          (0, 0, 27887, 27887),
         16#E2#           =>  --  01F3E2
          (0, 0, 27888, 27888),
         16#E3#           =>  --  01F3E3
          (0, 0, 27889, 27889),
         16#E4#           =>  --  01F3E4
          (0, 0, 27890, 27890),
         16#E5#           =>  --  01F3E5
          (0, 0, 27891, 27891),
         16#E6#           =>  --  01F3E6
          (0, 0, 27892, 27892),
         16#E7#           =>  --  01F3E7
          (0, 0, 27893, 27893),
         16#E8#           =>  --  01F3E8
          (0, 0, 27894, 27894),
         16#E9#           =>  --  01F3E9
          (0, 0, 27895, 27895),
         16#EA#           =>  --  01F3EA
          (0, 0, 27896, 27896),
         16#EB#           =>  --  01F3EB
          (0, 0, 27897, 27897),
         16#EC#           =>  --  01F3EC
          (0, 0, 27898, 27898),
         16#ED#           =>  --  01F3ED
          (0, 0, 27899, 27899),
         16#EE#           =>  --  01F3EE
          (0, 0, 27900, 27900),
         16#EF#           =>  --  01F3EF
          (0, 0, 27901, 27901),
         16#F0#           =>  --  01F3F0
          (0, 0, 27902, 27902),
         16#F1#           =>  --  01F3F1
          (0, 0, 27903, 27903),
         16#F2#           =>  --  01F3F2
          (0, 0, 27904, 27904),
         16#F3#           =>  --  01F3F3
          (0, 0, 27905, 27905),
         16#F4#           =>  --  01F3F4
          (0, 0, 27906, 27906),
         16#F5#           =>  --  01F3F5
          (0, 0, 27907, 27907),
         16#F6#           =>  --  01F3F6
          (0, 0, 27908, 27908),
         16#F7#           =>  --  01F3F7
          (0, 0, 27909, 27909),
         others           =>
          (0, 0, 0, 0));

   Group_01F4 : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  01F400
          (0, 0, 27910, 27910),
         16#01#           =>  --  01F401
          (0, 0, 27911, 27911),
         16#02#           =>  --  01F402
          (0, 0, 27912, 27912),
         16#03#           =>  --  01F403
          (0, 0, 27913, 27913),
         16#04#           =>  --  01F404
          (0, 0, 27914, 27914),
         16#05#           =>  --  01F405
          (0, 0, 27915, 27915),
         16#06#           =>  --  01F406
          (0, 0, 27916, 27916),
         16#07#           =>  --  01F407
          (0, 0, 27917, 27917),
         16#08#           =>  --  01F408
          (0, 0, 27918, 27918),
         16#09#           =>  --  01F409
          (0, 0, 27919, 27919),
         16#0A#           =>  --  01F40A
          (0, 0, 27920, 27920),
         16#0B#           =>  --  01F40B
          (0, 0, 27921, 27921),
         16#0C#           =>  --  01F40C
          (0, 0, 27922, 27922),
         16#0D#           =>  --  01F40D
          (0, 0, 27923, 27923),
         16#0E#           =>  --  01F40E
          (0, 0, 27924, 27924),
         16#0F#           =>  --  01F40F
          (0, 0, 27925, 27925),
         16#10#           =>  --  01F410
          (0, 0, 27926, 27926),
         16#11#           =>  --  01F411
          (0, 0, 27927, 27927),
         16#12#           =>  --  01F412
          (0, 0, 27928, 27928),
         16#13#           =>  --  01F413
          (0, 0, 27929, 27929),
         16#14#           =>  --  01F414
          (0, 0, 27930, 27930),
         16#15#           =>  --  01F415
          (0, 0, 27931, 27931),
         16#16#           =>  --  01F416
          (0, 0, 27932, 27932),
         16#17#           =>  --  01F417
          (0, 0, 27933, 27933),
         16#18#           =>  --  01F418
          (0, 0, 27934, 27934),
         16#19#           =>  --  01F419
          (0, 0, 27935, 27935),
         16#1A#           =>  --  01F41A
          (0, 0, 27936, 27936),
         16#1B#           =>  --  01F41B
          (0, 0, 27937, 27937),
         16#1C#           =>  --  01F41C
          (0, 0, 27938, 27938),
         16#1D#           =>  --  01F41D
          (0, 0, 27939, 27939),
         16#1E#           =>  --  01F41E
          (0, 0, 27940, 27940),
         16#1F#           =>  --  01F41F
          (0, 0, 27941, 27941),
         16#20#           =>  --  01F420
          (0, 0, 27942, 27942),
         16#21#           =>  --  01F421
          (0, 0, 27943, 27943),
         16#22#           =>  --  01F422
          (0, 0, 27944, 27944),
         16#23#           =>  --  01F423
          (0, 0, 27945, 27945),
         16#24#           =>  --  01F424
          (0, 0, 27946, 27946),
         16#25#           =>  --  01F425
          (0, 0, 27947, 27947),
         16#26#           =>  --  01F426
          (0, 0, 27948, 27948),
         16#27#           =>  --  01F427
          (0, 0, 27949, 27949),
         16#28#           =>  --  01F428
          (0, 0, 27950, 27950),
         16#29#           =>  --  01F429
          (0, 0, 27951, 27951),
         16#2A#           =>  --  01F42A
          (0, 0, 27952, 27952),
         16#2B#           =>  --  01F42B
          (0, 0, 27953, 27953),
         16#2C#           =>  --  01F42C
          (0, 0, 27954, 27954),
         16#2D#           =>  --  01F42D
          (0, 0, 27955, 27955),
         16#2E#           =>  --  01F42E
          (0, 0, 27956, 27956),
         16#2F#           =>  --  01F42F
          (0, 0, 27957, 27957),
         16#30#           =>  --  01F430
          (0, 0, 27958, 27958),
         16#31#           =>  --  01F431
          (0, 0, 27959, 27959),
         16#32#           =>  --  01F432
          (0, 0, 27960, 27960),
         16#33#           =>  --  01F433
          (0, 0, 27961, 27961),
         16#34#           =>  --  01F434
          (0, 0, 27962, 27962),
         16#35#           =>  --  01F435
          (0, 0, 27963, 27963),
         16#36#           =>  --  01F436
          (0, 0, 27964, 27964),
         16#37#           =>  --  01F437
          (0, 0, 27965, 27965),
         16#38#           =>  --  01F438
          (0, 0, 27966, 27966),
         16#39#           =>  --  01F439
          (0, 0, 27967, 27967),
         16#3A#           =>  --  01F43A
          (0, 0, 27968, 27968),
         16#3B#           =>  --  01F43B
          (0, 0, 27969, 27969),
         16#3C#           =>  --  01F43C
          (0, 0, 27970, 27970),
         16#3D#           =>  --  01F43D
          (0, 0, 27971, 27971),
         16#3E#           =>  --  01F43E
          (0, 0, 27972, 27972),
         16#3F#           =>  --  01F43F
          (0, 0, 27973, 27973),
         16#40#           =>  --  01F440
          (0, 0, 27974, 27974),
         16#41#           =>  --  01F441
          (0, 0, 27975, 27975),
         16#42#           =>  --  01F442
          (0, 0, 27976, 27976),
         16#43#           =>  --  01F443
          (0, 0, 27977, 27977),
         16#44#           =>  --  01F444
          (0, 0, 27978, 27978),
         16#45#           =>  --  01F445
          (0, 0, 27979, 27979),
         16#46#           =>  --  01F446
          (0, 0, 27980, 27980),
         16#47#           =>  --  01F447
          (0, 0, 27981, 27981),
         16#48#           =>  --  01F448
          (0, 0, 27982, 27982),
         16#49#           =>  --  01F449
          (0, 0, 27983, 27983),
         16#4A#           =>  --  01F44A
          (0, 0, 27984, 27984),
         16#4B#           =>  --  01F44B
          (0, 0, 27985, 27985),
         16#4C#           =>  --  01F44C
          (0, 0, 27986, 27986),
         16#4D#           =>  --  01F44D
          (0, 0, 27987, 27987),
         16#4E#           =>  --  01F44E
          (0, 0, 27988, 27988),
         16#4F#           =>  --  01F44F
          (0, 0, 27989, 27989),
         16#50#           =>  --  01F450
          (0, 0, 27990, 27990),
         16#51#           =>  --  01F451
          (0, 0, 27991, 27991),
         16#52#           =>  --  01F452
          (0, 0, 27992, 27992),
         16#53#           =>  --  01F453
          (0, 0, 27993, 27993),
         16#54#           =>  --  01F454
          (0, 0, 27994, 27994),
         16#55#           =>  --  01F455
          (0, 0, 27995, 27995),
         16#56#           =>  --  01F456
          (0, 0, 27996, 27996),
         16#57#           =>  --  01F457
          (0, 0, 27997, 27997),
         16#58#           =>  --  01F458
          (0, 0, 27998, 27998),
         16#59#           =>  --  01F459
          (0, 0, 27999, 27999),
         16#5A#           =>  --  01F45A
          (0, 0, 28000, 28000),
         16#5B#           =>  --  01F45B
          (0, 0, 28001, 28001),
         16#5C#           =>  --  01F45C
          (0, 0, 28002, 28002),
         16#5D#           =>  --  01F45D
          (0, 0, 28003, 28003),
         16#5E#           =>  --  01F45E
          (0, 0, 28004, 28004),
         16#5F#           =>  --  01F45F
          (0, 0, 28005, 28005),
         16#60#           =>  --  01F460
          (0, 0, 28006, 28006),
         16#61#           =>  --  01F461
          (0, 0, 28007, 28007),
         16#62#           =>  --  01F462
          (0, 0, 28008, 28008),
         16#63#           =>  --  01F463
          (0, 0, 28009, 28009),
         16#64#           =>  --  01F464
          (0, 0, 28010, 28010),
         16#65#           =>  --  01F465
          (0, 0, 28011, 28011),
         16#66#           =>  --  01F466
          (0, 0, 28012, 28012),
         16#67#           =>  --  01F467
          (0, 0, 28013, 28013),
         16#68#           =>  --  01F468
          (0, 0, 28014, 28014),
         16#69#           =>  --  01F469
          (0, 0, 28015, 28015),
         16#6A#           =>  --  01F46A
          (0, 0, 28016, 28016),
         16#6B#           =>  --  01F46B
          (0, 0, 28017, 28017),
         16#6C#           =>  --  01F46C
          (0, 0, 28018, 28018),
         16#6D#           =>  --  01F46D
          (0, 0, 28019, 28019),
         16#6E#           =>  --  01F46E
          (0, 0, 28020, 28020),
         16#6F#           =>  --  01F46F
          (0, 0, 28021, 28021),
         16#70#           =>  --  01F470
          (0, 0, 28022, 28022),
         16#71#           =>  --  01F471
          (0, 0, 28023, 28023),
         16#72#           =>  --  01F472
          (0, 0, 28024, 28024),
         16#73#           =>  --  01F473
          (0, 0, 28025, 28025),
         16#74#           =>  --  01F474
          (0, 0, 28026, 28026),
         16#75#           =>  --  01F475
          (0, 0, 28027, 28027),
         16#76#           =>  --  01F476
          (0, 0, 28028, 28028),
         16#77#           =>  --  01F477
          (0, 0, 28029, 28029),
         16#78#           =>  --  01F478
          (0, 0, 28030, 28030),
         16#79#           =>  --  01F479
          (0, 0, 28031, 28031),
         16#7A#           =>  --  01F47A
          (0, 0, 28032, 28032),
         16#7B#           =>  --  01F47B
          (0, 0, 28033, 28033),
         16#7C#           =>  --  01F47C
          (0, 0, 28034, 28034),
         16#7D#           =>  --  01F47D
          (0, 0, 28035, 28035),
         16#7E#           =>  --  01F47E
          (0, 0, 28036, 28036),
         16#7F#           =>  --  01F47F
          (0, 0, 28037, 28037),
         16#80#           =>  --  01F480
          (0, 0, 28038, 28038),
         16#81#           =>  --  01F481
          (0, 0, 28039, 28039),
         16#82#           =>  --  01F482
          (0, 0, 28040, 28040),
         16#83#           =>  --  01F483
          (0, 0, 28041, 28041),
         16#84#           =>  --  01F484
          (0, 0, 28042, 28042),
         16#85#           =>  --  01F485
          (0, 0, 28043, 28043),
         16#86#           =>  --  01F486
          (0, 0, 28044, 28044),
         16#87#           =>  --  01F487
          (0, 0, 28045, 28045),
         16#88#           =>  --  01F488
          (0, 0, 28046, 28046),
         16#89#           =>  --  01F489
          (0, 0, 28047, 28047),
         16#8A#           =>  --  01F48A
          (0, 0, 28048, 28048),
         16#8B#           =>  --  01F48B
          (0, 0, 28049, 28049),
         16#8C#           =>  --  01F48C
          (0, 0, 28050, 28050),
         16#8D#           =>  --  01F48D
          (0, 0, 28051, 28051),
         16#8E#           =>  --  01F48E
          (0, 0, 28052, 28052),
         16#8F#           =>  --  01F48F
          (0, 0, 28053, 28053),
         16#90#           =>  --  01F490
          (0, 0, 28054, 28054),
         16#91#           =>  --  01F491
          (0, 0, 28055, 28055),
         16#92#           =>  --  01F492
          (0, 0, 28056, 28056),
         16#93#           =>  --  01F493
          (0, 0, 28057, 28057),
         16#94#           =>  --  01F494
          (0, 0, 28058, 28058),
         16#95#           =>  --  01F495
          (0, 0, 28059, 28059),
         16#96#           =>  --  01F496
          (0, 0, 28060, 28060),
         16#97#           =>  --  01F497
          (0, 0, 28061, 28061),
         16#98#           =>  --  01F498
          (0, 0, 28062, 28062),
         16#99#           =>  --  01F499
          (0, 0, 28063, 28063),
         16#9A#           =>  --  01F49A
          (0, 0, 28064, 28064),
         16#9B#           =>  --  01F49B
          (0, 0, 28065, 28065),
         16#9C#           =>  --  01F49C
          (0, 0, 28066, 28066),
         16#9D#           =>  --  01F49D
          (0, 0, 28067, 28067),
         16#9E#           =>  --  01F49E
          (0, 0, 28068, 28068),
         16#9F#           =>  --  01F49F
          (0, 0, 28069, 28069),
         16#A0#           =>  --  01F4A0
          (0, 0, 28070, 28070),
         16#A1#           =>  --  01F4A1
          (0, 0, 28071, 28071),
         16#A2#           =>  --  01F4A2
          (0, 0, 28072, 28072),
         16#A3#           =>  --  01F4A3
          (0, 0, 28073, 28073),
         16#A4#           =>  --  01F4A4
          (0, 0, 28074, 28074),
         16#A5#           =>  --  01F4A5
          (0, 0, 28075, 28075),
         16#A6#           =>  --  01F4A6
          (0, 0, 28076, 28076),
         16#A7#           =>  --  01F4A7
          (0, 0, 28077, 28077),
         16#A8#           =>  --  01F4A8
          (0, 0, 28078, 28078),
         16#A9#           =>  --  01F4A9
          (0, 0, 28079, 28079),
         16#AA#           =>  --  01F4AA
          (0, 0, 28080, 28080),
         16#AB#           =>  --  01F4AB
          (0, 0, 28081, 28081),
         16#AC#           =>  --  01F4AC
          (0, 0, 28082, 28082),
         16#AD#           =>  --  01F4AD
          (0, 0, 28083, 28083),
         16#AE#           =>  --  01F4AE
          (0, 0, 28084, 28084),
         16#AF#           =>  --  01F4AF
          (0, 0, 28085, 28085),
         16#B0#           =>  --  01F4B0
          (0, 0, 28086, 28086),
         16#B1#           =>  --  01F4B1
          (0, 0, 28087, 28087),
         16#B2#           =>  --  01F4B2
          (0, 0, 28088, 28088),
         16#B3#           =>  --  01F4B3
          (0, 0, 28089, 28089),
         16#B4#           =>  --  01F4B4
          (0, 0, 28090, 28090),
         16#B5#           =>  --  01F4B5
          (0, 0, 28091, 28091),
         16#B6#           =>  --  01F4B6
          (0, 0, 28092, 28092),
         16#B7#           =>  --  01F4B7
          (0, 0, 28093, 28093),
         16#B8#           =>  --  01F4B8
          (0, 0, 28094, 28094),
         16#B9#           =>  --  01F4B9
          (0, 0, 28095, 28095),
         16#BA#           =>  --  01F4BA
          (0, 0, 28096, 28096),
         16#BB#           =>  --  01F4BB
          (0, 0, 28097, 28097),
         16#BC#           =>  --  01F4BC
          (0, 0, 28098, 28098),
         16#BD#           =>  --  01F4BD
          (0, 0, 28099, 28099),
         16#BE#           =>  --  01F4BE
          (0, 0, 28100, 28100),
         16#BF#           =>  --  01F4BF
          (0, 0, 28101, 28101),
         16#C0#           =>  --  01F4C0
          (0, 0, 28102, 28102),
         16#C1#           =>  --  01F4C1
          (0, 0, 28103, 28103),
         16#C2#           =>  --  01F4C2
          (0, 0, 28104, 28104),
         16#C3#           =>  --  01F4C3
          (0, 0, 28105, 28105),
         16#C4#           =>  --  01F4C4
          (0, 0, 28106, 28106),
         16#C5#           =>  --  01F4C5
          (0, 0, 28107, 28107),
         16#C6#           =>  --  01F4C6
          (0, 0, 28108, 28108),
         16#C7#           =>  --  01F4C7
          (0, 0, 28109, 28109),
         16#C8#           =>  --  01F4C8
          (0, 0, 28110, 28110),
         16#C9#           =>  --  01F4C9
          (0, 0, 28111, 28111),
         16#CA#           =>  --  01F4CA
          (0, 0, 28112, 28112),
         16#CB#           =>  --  01F4CB
          (0, 0, 28113, 28113),
         16#CC#           =>  --  01F4CC
          (0, 0, 28114, 28114),
         16#CD#           =>  --  01F4CD
          (0, 0, 28115, 28115),
         16#CE#           =>  --  01F4CE
          (0, 0, 28116, 28116),
         16#CF#           =>  --  01F4CF
          (0, 0, 28117, 28117),
         16#D0#           =>  --  01F4D0
          (0, 0, 28118, 28118),
         16#D1#           =>  --  01F4D1
          (0, 0, 28119, 28119),
         16#D2#           =>  --  01F4D2
          (0, 0, 28120, 28120),
         16#D3#           =>  --  01F4D3
          (0, 0, 28121, 28121),
         16#D4#           =>  --  01F4D4
          (0, 0, 28122, 28122),
         16#D5#           =>  --  01F4D5
          (0, 0, 28123, 28123),
         16#D6#           =>  --  01F4D6
          (0, 0, 28124, 28124),
         16#D7#           =>  --  01F4D7
          (0, 0, 28125, 28125),
         16#D8#           =>  --  01F4D8
          (0, 0, 28126, 28126),
         16#D9#           =>  --  01F4D9
          (0, 0, 28127, 28127),
         16#DA#           =>  --  01F4DA
          (0, 0, 28128, 28128),
         16#DB#           =>  --  01F4DB
          (0, 0, 28129, 28129),
         16#DC#           =>  --  01F4DC
          (0, 0, 28130, 28130),
         16#DD#           =>  --  01F4DD
          (0, 0, 28131, 28131),
         16#DE#           =>  --  01F4DE
          (0, 0, 28132, 28132),
         16#DF#           =>  --  01F4DF
          (0, 0, 28133, 28133),
         16#E0#           =>  --  01F4E0
          (0, 0, 28134, 28134),
         16#E1#           =>  --  01F4E1
          (0, 0, 28135, 28135),
         16#E2#           =>  --  01F4E2
          (0, 0, 28136, 28136),
         16#E3#           =>  --  01F4E3
          (0, 0, 28137, 28137),
         16#E4#           =>  --  01F4E4
          (0, 0, 28138, 28138),
         16#E5#           =>  --  01F4E5
          (0, 0, 28139, 28139),
         16#E6#           =>  --  01F4E6
          (0, 0, 28140, 28140),
         16#E7#           =>  --  01F4E7
          (0, 0, 28141, 28141),
         16#E8#           =>  --  01F4E8
          (0, 0, 28142, 28142),
         16#E9#           =>  --  01F4E9
          (0, 0, 28143, 28143),
         16#EA#           =>  --  01F4EA
          (0, 0, 28144, 28144),
         16#EB#           =>  --  01F4EB
          (0, 0, 28145, 28145),
         16#EC#           =>  --  01F4EC
          (0, 0, 28146, 28146),
         16#ED#           =>  --  01F4ED
          (0, 0, 28147, 28147),
         16#EE#           =>  --  01F4EE
          (0, 0, 28148, 28148),
         16#EF#           =>  --  01F4EF
          (0, 0, 28149, 28149),
         16#F0#           =>  --  01F4F0
          (0, 0, 28150, 28150),
         16#F1#           =>  --  01F4F1
          (0, 0, 28151, 28151),
         16#F2#           =>  --  01F4F2
          (0, 0, 28152, 28152),
         16#F3#           =>  --  01F4F3
          (0, 0, 28153, 28153),
         16#F4#           =>  --  01F4F4
          (0, 0, 28154, 28154),
         16#F5#           =>  --  01F4F5
          (0, 0, 28155, 28155),
         16#F6#           =>  --  01F4F6
          (0, 0, 28156, 28156),
         16#F7#           =>  --  01F4F7
          (0, 0, 28157, 28157),
         16#F8#           =>  --  01F4F8
          (0, 0, 28158, 28158),
         16#F9#           =>  --  01F4F9
          (0, 0, 28159, 28159),
         16#FA#           =>  --  01F4FA
          (0, 0, 28160, 28160),
         16#FB#           =>  --  01F4FB
          (0, 0, 28161, 28161),
         16#FC#           =>  --  01F4FC
          (0, 0, 28162, 28162),
         16#FD#           =>  --  01F4FD
          (0, 0, 28163, 28163),
         16#FE#           =>  --  01F4FE
          (0, 0, 28164, 28164),
         others           =>
          (0, 0, 0, 0));

   Group_01F5 : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  01F500
          (0, 0, 28165, 28165),
         16#01#           =>  --  01F501
          (0, 0, 28166, 28166),
         16#02#           =>  --  01F502
          (0, 0, 28167, 28167),
         16#03#           =>  --  01F503
          (0, 0, 28168, 28168),
         16#04#           =>  --  01F504
          (0, 0, 28169, 28169),
         16#05#           =>  --  01F505
          (0, 0, 28170, 28170),
         16#06#           =>  --  01F506
          (0, 0, 28171, 28171),
         16#07#           =>  --  01F507
          (0, 0, 28172, 28172),
         16#08#           =>  --  01F508
          (0, 0, 28173, 28173),
         16#09#           =>  --  01F509
          (0, 0, 28174, 28174),
         16#0A#           =>  --  01F50A
          (0, 0, 28175, 28175),
         16#0B#           =>  --  01F50B
          (0, 0, 28176, 28176),
         16#0C#           =>  --  01F50C
          (0, 0, 28177, 28177),
         16#0D#           =>  --  01F50D
          (0, 0, 28178, 28178),
         16#0E#           =>  --  01F50E
          (0, 0, 28179, 28179),
         16#0F#           =>  --  01F50F
          (0, 0, 28180, 28180),
         16#10#           =>  --  01F510
          (0, 0, 28181, 28181),
         16#11#           =>  --  01F511
          (0, 0, 28182, 28182),
         16#12#           =>  --  01F512
          (0, 0, 28183, 28183),
         16#13#           =>  --  01F513
          (0, 0, 28184, 28184),
         16#14#           =>  --  01F514
          (0, 0, 28185, 28185),
         16#15#           =>  --  01F515
          (0, 0, 28186, 28186),
         16#16#           =>  --  01F516
          (0, 0, 28187, 28187),
         16#17#           =>  --  01F517
          (0, 0, 28188, 28188),
         16#18#           =>  --  01F518
          (0, 0, 28189, 28189),
         16#19#           =>  --  01F519
          (0, 0, 28190, 28190),
         16#1A#           =>  --  01F51A
          (0, 0, 28191, 28191),
         16#1B#           =>  --  01F51B
          (0, 0, 28192, 28192),
         16#1C#           =>  --  01F51C
          (0, 0, 28193, 28193),
         16#1D#           =>  --  01F51D
          (0, 0, 28194, 28194),
         16#1E#           =>  --  01F51E
          (0, 0, 28195, 28195),
         16#1F#           =>  --  01F51F
          (0, 0, 28196, 28196),
         16#20#           =>  --  01F520
          (0, 0, 28197, 28197),
         16#21#           =>  --  01F521
          (0, 0, 28198, 28198),
         16#22#           =>  --  01F522
          (0, 0, 28199, 28199),
         16#23#           =>  --  01F523
          (0, 0, 28200, 28200),
         16#24#           =>  --  01F524
          (0, 0, 28201, 28201),
         16#25#           =>  --  01F525
          (0, 0, 28202, 28202),
         16#26#           =>  --  01F526
          (0, 0, 28203, 28203),
         16#27#           =>  --  01F527
          (0, 0, 28204, 28204),
         16#28#           =>  --  01F528
          (0, 0, 28205, 28205),
         16#29#           =>  --  01F529
          (0, 0, 28206, 28206),
         16#2A#           =>  --  01F52A
          (0, 0, 28207, 28207),
         16#2B#           =>  --  01F52B
          (0, 0, 28208, 28208),
         16#2C#           =>  --  01F52C
          (0, 0, 28209, 28209),
         16#2D#           =>  --  01F52D
          (0, 0, 28210, 28210),
         16#2E#           =>  --  01F52E
          (0, 0, 28211, 28211),
         16#2F#           =>  --  01F52F
          (0, 0, 28212, 28212),
         16#30#           =>  --  01F530
          (0, 0, 28213, 28213),
         16#31#           =>  --  01F531
          (0, 0, 28214, 28214),
         16#32#           =>  --  01F532
          (0, 0, 28215, 28215),
         16#33#           =>  --  01F533
          (0, 0, 28216, 28216),
         16#34#           =>  --  01F534
          (0, 0, 28217, 28217),
         16#35#           =>  --  01F535
          (0, 0, 28218, 28218),
         16#36#           =>  --  01F536
          (0, 0, 28219, 28219),
         16#37#           =>  --  01F537
          (0, 0, 28220, 28220),
         16#38#           =>  --  01F538
          (0, 0, 28221, 28221),
         16#39#           =>  --  01F539
          (0, 0, 28222, 28222),
         16#3A#           =>  --  01F53A
          (0, 0, 28223, 28223),
         16#3B#           =>  --  01F53B
          (0, 0, 28224, 28224),
         16#3C#           =>  --  01F53C
          (0, 0, 28225, 28225),
         16#3D#           =>  --  01F53D
          (0, 0, 28226, 28226),
         16#3E#           =>  --  01F53E
          (0, 0, 28227, 28227),
         16#3F#           =>  --  01F53F
          (0, 0, 28228, 28228),
         16#40#           =>  --  01F540
          (0, 0, 28229, 28229),
         16#41#           =>  --  01F541
          (0, 0, 28230, 28230),
         16#42#           =>  --  01F542
          (0, 0, 28231, 28231),
         16#43#           =>  --  01F543
          (0, 0, 28232, 28232),
         16#44#           =>  --  01F544
          (0, 0, 28233, 28233),
         16#45#           =>  --  01F545
          (0, 0, 28234, 28234),
         16#46#           =>  --  01F546
          (0, 0, 28235, 28235),
         16#47#           =>  --  01F547
          (0, 0, 28236, 28236),
         16#48#           =>  --  01F548
          (0, 0, 28237, 28237),
         16#49#           =>  --  01F549
          (0, 0, 28238, 28238),
         16#4A#           =>  --  01F54A
          (0, 0, 28239, 28239),
         16#50#           =>  --  01F550
          (0, 0, 28240, 28240),
         16#51#           =>  --  01F551
          (0, 0, 28241, 28241),
         16#52#           =>  --  01F552
          (0, 0, 28242, 28242),
         16#53#           =>  --  01F553
          (0, 0, 28243, 28243),
         16#54#           =>  --  01F554
          (0, 0, 28244, 28244),
         16#55#           =>  --  01F555
          (0, 0, 28245, 28245),
         16#56#           =>  --  01F556
          (0, 0, 28246, 28246),
         16#57#           =>  --  01F557
          (0, 0, 28247, 28247),
         16#58#           =>  --  01F558
          (0, 0, 28248, 28248),
         16#59#           =>  --  01F559
          (0, 0, 28249, 28249),
         16#5A#           =>  --  01F55A
          (0, 0, 28250, 28250),
         16#5B#           =>  --  01F55B
          (0, 0, 28251, 28251),
         16#5C#           =>  --  01F55C
          (0, 0, 28252, 28252),
         16#5D#           =>  --  01F55D
          (0, 0, 28253, 28253),
         16#5E#           =>  --  01F55E
          (0, 0, 28254, 28254),
         16#5F#           =>  --  01F55F
          (0, 0, 28255, 28255),
         16#60#           =>  --  01F560
          (0, 0, 28256, 28256),
         16#61#           =>  --  01F561
          (0, 0, 28257, 28257),
         16#62#           =>  --  01F562
          (0, 0, 28258, 28258),
         16#63#           =>  --  01F563
          (0, 0, 28259, 28259),
         16#64#           =>  --  01F564
          (0, 0, 28260, 28260),
         16#65#           =>  --  01F565
          (0, 0, 28261, 28261),
         16#66#           =>  --  01F566
          (0, 0, 28262, 28262),
         16#67#           =>  --  01F567
          (0, 0, 28263, 28263),
         16#68#           =>  --  01F568
          (0, 0, 28264, 28264),
         16#69#           =>  --  01F569
          (0, 0, 28265, 28265),
         16#6A#           =>  --  01F56A
          (0, 0, 28266, 28266),
         16#6B#           =>  --  01F56B
          (0, 0, 28267, 28267),
         16#6C#           =>  --  01F56C
          (0, 0, 28268, 28268),
         16#6D#           =>  --  01F56D
          (0, 0, 28269, 28269),
         16#6E#           =>  --  01F56E
          (0, 0, 28270, 28270),
         16#6F#           =>  --  01F56F
          (0, 0, 28271, 28271),
         16#70#           =>  --  01F570
          (0, 0, 28272, 28272),
         16#71#           =>  --  01F571
          (0, 0, 28273, 28273),
         16#72#           =>  --  01F572
          (0, 0, 28274, 28274),
         16#73#           =>  --  01F573
          (0, 0, 28275, 28275),
         16#74#           =>  --  01F574
          (0, 0, 28276, 28276),
         16#75#           =>  --  01F575
          (0, 0, 28277, 28277),
         16#76#           =>  --  01F576
          (0, 0, 28278, 28278),
         16#77#           =>  --  01F577
          (0, 0, 28279, 28279),
         16#78#           =>  --  01F578
          (0, 0, 28280, 28280),
         16#79#           =>  --  01F579
          (0, 0, 28281, 28281),
         16#7B#           =>  --  01F57B
          (0, 0, 28282, 28282),
         16#7C#           =>  --  01F57C
          (0, 0, 28283, 28283),
         16#7D#           =>  --  01F57D
          (0, 0, 28284, 28284),
         16#7E#           =>  --  01F57E
          (0, 0, 28285, 28285),
         16#7F#           =>  --  01F57F
          (0, 0, 28286, 28286),
         16#80#           =>  --  01F580
          (0, 0, 28287, 28287),
         16#81#           =>  --  01F581
          (0, 0, 28288, 28288),
         16#82#           =>  --  01F582
          (0, 0, 28289, 28289),
         16#83#           =>  --  01F583
          (0, 0, 28290, 28290),
         16#84#           =>  --  01F584
          (0, 0, 28291, 28291),
         16#85#           =>  --  01F585
          (0, 0, 28292, 28292),
         16#86#           =>  --  01F586
          (0, 0, 28293, 28293),
         16#87#           =>  --  01F587
          (0, 0, 28294, 28294),
         16#88#           =>  --  01F588
          (0, 0, 28295, 28295),
         16#89#           =>  --  01F589
          (0, 0, 28296, 28296),
         16#8A#           =>  --  01F58A
          (0, 0, 28297, 28297),
         16#8B#           =>  --  01F58B
          (0, 0, 28298, 28298),
         16#8C#           =>  --  01F58C
          (0, 0, 28299, 28299),
         16#8D#           =>  --  01F58D
          (0, 0, 28300, 28300),
         16#8E#           =>  --  01F58E
          (0, 0, 28301, 28301),
         16#8F#           =>  --  01F58F
          (0, 0, 28302, 28302),
         16#90#           =>  --  01F590
          (0, 0, 28303, 28303),
         16#91#           =>  --  01F591
          (0, 0, 28304, 28304),
         16#92#           =>  --  01F592
          (0, 0, 28305, 28305),
         16#93#           =>  --  01F593
          (0, 0, 28306, 28306),
         16#94#           =>  --  01F594
          (0, 0, 28307, 28307),
         16#95#           =>  --  01F595
          (0, 0, 28308, 28308),
         16#96#           =>  --  01F596
          (0, 0, 28309, 28309),
         16#97#           =>  --  01F597
          (0, 0, 28310, 28310),
         16#98#           =>  --  01F598
          (0, 0, 28311, 28311),
         16#99#           =>  --  01F599
          (0, 0, 28312, 28312),
         16#9A#           =>  --  01F59A
          (0, 0, 28313, 28313),
         16#9B#           =>  --  01F59B
          (0, 0, 28314, 28314),
         16#9C#           =>  --  01F59C
          (0, 0, 28315, 28315),
         16#9D#           =>  --  01F59D
          (0, 0, 28316, 28316),
         16#9E#           =>  --  01F59E
          (0, 0, 28317, 28317),
         16#9F#           =>  --  01F59F
          (0, 0, 28318, 28318),
         16#A0#           =>  --  01F5A0
          (0, 0, 28319, 28319),
         16#A1#           =>  --  01F5A1
          (0, 0, 28320, 28320),
         16#A2#           =>  --  01F5A2
          (0, 0, 28321, 28321),
         16#A3#           =>  --  01F5A3
          (0, 0, 28322, 28322),
         16#A5#           =>  --  01F5A5
          (0, 0, 28323, 28323),
         16#A6#           =>  --  01F5A6
          (0, 0, 28324, 28324),
         16#A7#           =>  --  01F5A7
          (0, 0, 28325, 28325),
         16#A8#           =>  --  01F5A8
          (0, 0, 28326, 28326),
         16#A9#           =>  --  01F5A9
          (0, 0, 28327, 28327),
         16#AA#           =>  --  01F5AA
          (0, 0, 28328, 28328),
         16#AB#           =>  --  01F5AB
          (0, 0, 28329, 28329),
         16#AC#           =>  --  01F5AC
          (0, 0, 28330, 28330),
         16#AD#           =>  --  01F5AD
          (0, 0, 28331, 28331),
         16#AE#           =>  --  01F5AE
          (0, 0, 28332, 28332),
         16#AF#           =>  --  01F5AF
          (0, 0, 28333, 28333),
         16#B0#           =>  --  01F5B0
          (0, 0, 28334, 28334),
         16#B1#           =>  --  01F5B1
          (0, 0, 28335, 28335),
         16#B2#           =>  --  01F5B2
          (0, 0, 28336, 28336),
         16#B3#           =>  --  01F5B3
          (0, 0, 28337, 28337),
         16#B4#           =>  --  01F5B4
          (0, 0, 28338, 28338),
         16#B5#           =>  --  01F5B5
          (0, 0, 28339, 28339),
         16#B6#           =>  --  01F5B6
          (0, 0, 28340, 28340),
         16#B7#           =>  --  01F5B7
          (0, 0, 28341, 28341),
         16#B8#           =>  --  01F5B8
          (0, 0, 28342, 28342),
         16#B9#           =>  --  01F5B9
          (0, 0, 28343, 28343),
         16#BA#           =>  --  01F5BA
          (0, 0, 28344, 28344),
         16#BB#           =>  --  01F5BB
          (0, 0, 28345, 28345),
         16#BC#           =>  --  01F5BC
          (0, 0, 28346, 28346),
         16#BD#           =>  --  01F5BD
          (0, 0, 28347, 28347),
         16#BE#           =>  --  01F5BE
          (0, 0, 28348, 28348),
         16#BF#           =>  --  01F5BF
          (0, 0, 28349, 28349),
         16#C0#           =>  --  01F5C0
          (0, 0, 28350, 28350),
         16#C1#           =>  --  01F5C1
          (0, 0, 28351, 28351),
         16#C2#           =>  --  01F5C2
          (0, 0, 28352, 28352),
         16#C3#           =>  --  01F5C3
          (0, 0, 28353, 28353),
         16#C4#           =>  --  01F5C4
          (0, 0, 28354, 28354),
         16#C5#           =>  --  01F5C5
          (0, 0, 28355, 28355),
         16#C6#           =>  --  01F5C6
          (0, 0, 28356, 28356),
         16#C7#           =>  --  01F5C7
          (0, 0, 28357, 28357),
         16#C8#           =>  --  01F5C8
          (0, 0, 28358, 28358),
         16#C9#           =>  --  01F5C9
          (0, 0, 28359, 28359),
         16#CA#           =>  --  01F5CA
          (0, 0, 28360, 28360),
         16#CB#           =>  --  01F5CB
          (0, 0, 28361, 28361),
         16#CC#           =>  --  01F5CC
          (0, 0, 28362, 28362),
         16#CD#           =>  --  01F5CD
          (0, 0, 28363, 28363),
         16#CE#           =>  --  01F5CE
          (0, 0, 28364, 28364),
         16#CF#           =>  --  01F5CF
          (0, 0, 28365, 28365),
         16#D0#           =>  --  01F5D0
          (0, 0, 28366, 28366),
         16#D1#           =>  --  01F5D1
          (0, 0, 28367, 28367),
         16#D2#           =>  --  01F5D2
          (0, 0, 28368, 28368),
         16#D3#           =>  --  01F5D3
          (0, 0, 28369, 28369),
         16#D4#           =>  --  01F5D4
          (0, 0, 28370, 28370),
         16#D5#           =>  --  01F5D5
          (0, 0, 28371, 28371),
         16#D6#           =>  --  01F5D6
          (0, 0, 28372, 28372),
         16#D7#           =>  --  01F5D7
          (0, 0, 28373, 28373),
         16#D8#           =>  --  01F5D8
          (0, 0, 28374, 28374),
         16#D9#           =>  --  01F5D9
          (0, 0, 28375, 28375),
         16#DA#           =>  --  01F5DA
          (0, 0, 28376, 28376),
         16#DB#           =>  --  01F5DB
          (0, 0, 28377, 28377),
         16#DC#           =>  --  01F5DC
          (0, 0, 28378, 28378),
         16#DD#           =>  --  01F5DD
          (0, 0, 28379, 28379),
         16#DE#           =>  --  01F5DE
          (0, 0, 28380, 28380),
         16#DF#           =>  --  01F5DF
          (0, 0, 28381, 28381),
         16#E0#           =>  --  01F5E0
          (0, 0, 28382, 28382),
         16#E1#           =>  --  01F5E1
          (0, 0, 28383, 28383),
         16#E2#           =>  --  01F5E2
          (0, 0, 28384, 28384),
         16#E3#           =>  --  01F5E3
          (0, 0, 28385, 28385),
         16#E4#           =>  --  01F5E4
          (0, 0, 28386, 28386),
         16#E5#           =>  --  01F5E5
          (0, 0, 28387, 28387),
         16#E6#           =>  --  01F5E6
          (0, 0, 28388, 28388),
         16#E7#           =>  --  01F5E7
          (0, 0, 28389, 28389),
         16#E8#           =>  --  01F5E8
          (0, 0, 28390, 28390),
         16#E9#           =>  --  01F5E9
          (0, 0, 28391, 28391),
         16#EA#           =>  --  01F5EA
          (0, 0, 28392, 28392),
         16#EB#           =>  --  01F5EB
          (0, 0, 28393, 28393),
         16#EC#           =>  --  01F5EC
          (0, 0, 28394, 28394),
         16#ED#           =>  --  01F5ED
          (0, 0, 28395, 28395),
         16#EE#           =>  --  01F5EE
          (0, 0, 28396, 28396),
         16#EF#           =>  --  01F5EF
          (0, 0, 28397, 28397),
         16#F0#           =>  --  01F5F0
          (0, 0, 28398, 28398),
         16#F1#           =>  --  01F5F1
          (0, 0, 28399, 28399),
         16#F2#           =>  --  01F5F2
          (0, 0, 28400, 28400),
         16#F3#           =>  --  01F5F3
          (0, 0, 28401, 28401),
         16#F4#           =>  --  01F5F4
          (0, 0, 28402, 28402),
         16#F5#           =>  --  01F5F5
          (0, 0, 28403, 28403),
         16#F6#           =>  --  01F5F6
          (0, 0, 28404, 28404),
         16#F7#           =>  --  01F5F7
          (0, 0, 28405, 28405),
         16#F8#           =>  --  01F5F8
          (0, 0, 28406, 28406),
         16#F9#           =>  --  01F5F9
          (0, 0, 28407, 28407),
         16#FA#           =>  --  01F5FA
          (0, 0, 28408, 28408),
         16#FB#           =>  --  01F5FB
          (0, 0, 28409, 28409),
         16#FC#           =>  --  01F5FC
          (0, 0, 28410, 28410),
         16#FD#           =>  --  01F5FD
          (0, 0, 28411, 28411),
         16#FE#           =>  --  01F5FE
          (0, 0, 28412, 28412),
         16#FF#           =>  --  01F5FF
          (0, 0, 28413, 28413),
         others           =>
          (0, 0, 0, 0));

   Group_01F6 : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  01F600
          (0, 0, 28414, 28414),
         16#01#           =>  --  01F601
          (0, 0, 28415, 28415),
         16#02#           =>  --  01F602
          (0, 0, 28416, 28416),
         16#03#           =>  --  01F603
          (0, 0, 28417, 28417),
         16#04#           =>  --  01F604
          (0, 0, 28418, 28418),
         16#05#           =>  --  01F605
          (0, 0, 28419, 28419),
         16#06#           =>  --  01F606
          (0, 0, 28420, 28420),
         16#07#           =>  --  01F607
          (0, 0, 28421, 28421),
         16#08#           =>  --  01F608
          (0, 0, 28422, 28422),
         16#09#           =>  --  01F609
          (0, 0, 28423, 28423),
         16#0A#           =>  --  01F60A
          (0, 0, 28424, 28424),
         16#0B#           =>  --  01F60B
          (0, 0, 28425, 28425),
         16#0C#           =>  --  01F60C
          (0, 0, 28426, 28426),
         16#0D#           =>  --  01F60D
          (0, 0, 28427, 28427),
         16#0E#           =>  --  01F60E
          (0, 0, 28428, 28428),
         16#0F#           =>  --  01F60F
          (0, 0, 28429, 28429),
         16#10#           =>  --  01F610
          (0, 0, 28430, 28430),
         16#11#           =>  --  01F611
          (0, 0, 28431, 28431),
         16#12#           =>  --  01F612
          (0, 0, 28432, 28432),
         16#13#           =>  --  01F613
          (0, 0, 28433, 28433),
         16#14#           =>  --  01F614
          (0, 0, 28434, 28434),
         16#15#           =>  --  01F615
          (0, 0, 28435, 28435),
         16#16#           =>  --  01F616
          (0, 0, 28436, 28436),
         16#17#           =>  --  01F617
          (0, 0, 28437, 28437),
         16#18#           =>  --  01F618
          (0, 0, 28438, 28438),
         16#19#           =>  --  01F619
          (0, 0, 28439, 28439),
         16#1A#           =>  --  01F61A
          (0, 0, 28440, 28440),
         16#1B#           =>  --  01F61B
          (0, 0, 28441, 28441),
         16#1C#           =>  --  01F61C
          (0, 0, 28442, 28442),
         16#1D#           =>  --  01F61D
          (0, 0, 28443, 28443),
         16#1E#           =>  --  01F61E
          (0, 0, 28444, 28444),
         16#1F#           =>  --  01F61F
          (0, 0, 28445, 28445),
         16#20#           =>  --  01F620
          (0, 0, 28446, 28446),
         16#21#           =>  --  01F621
          (0, 0, 28447, 28447),
         16#22#           =>  --  01F622
          (0, 0, 28448, 28448),
         16#23#           =>  --  01F623
          (0, 0, 28449, 28449),
         16#24#           =>  --  01F624
          (0, 0, 28450, 28450),
         16#25#           =>  --  01F625
          (0, 0, 28451, 28451),
         16#26#           =>  --  01F626
          (0, 0, 28452, 28452),
         16#27#           =>  --  01F627
          (0, 0, 28453, 28453),
         16#28#           =>  --  01F628
          (0, 0, 28454, 28454),
         16#29#           =>  --  01F629
          (0, 0, 28455, 28455),
         16#2A#           =>  --  01F62A
          (0, 0, 28456, 28456),
         16#2B#           =>  --  01F62B
          (0, 0, 28457, 28457),
         16#2C#           =>  --  01F62C
          (0, 0, 28458, 28458),
         16#2D#           =>  --  01F62D
          (0, 0, 28459, 28459),
         16#2E#           =>  --  01F62E
          (0, 0, 28460, 28460),
         16#2F#           =>  --  01F62F
          (0, 0, 28461, 28461),
         16#30#           =>  --  01F630
          (0, 0, 28462, 28462),
         16#31#           =>  --  01F631
          (0, 0, 28463, 28463),
         16#32#           =>  --  01F632
          (0, 0, 28464, 28464),
         16#33#           =>  --  01F633
          (0, 0, 28465, 28465),
         16#34#           =>  --  01F634
          (0, 0, 28466, 28466),
         16#35#           =>  --  01F635
          (0, 0, 28467, 28467),
         16#36#           =>  --  01F636
          (0, 0, 28468, 28468),
         16#37#           =>  --  01F637
          (0, 0, 28469, 28469),
         16#38#           =>  --  01F638
          (0, 0, 28470, 28470),
         16#39#           =>  --  01F639
          (0, 0, 28471, 28471),
         16#3A#           =>  --  01F63A
          (0, 0, 28472, 28472),
         16#3B#           =>  --  01F63B
          (0, 0, 28473, 28473),
         16#3C#           =>  --  01F63C
          (0, 0, 28474, 28474),
         16#3D#           =>  --  01F63D
          (0, 0, 28475, 28475),
         16#3E#           =>  --  01F63E
          (0, 0, 28476, 28476),
         16#3F#           =>  --  01F63F
          (0, 0, 28477, 28477),
         16#40#           =>  --  01F640
          (0, 0, 28478, 28478),
         16#41#           =>  --  01F641
          (0, 0, 28479, 28479),
         16#42#           =>  --  01F642
          (0, 0, 28480, 28480),
         16#45#           =>  --  01F645
          (0, 0, 28481, 28481),
         16#46#           =>  --  01F646
          (0, 0, 28482, 28482),
         16#47#           =>  --  01F647
          (0, 0, 28483, 28483),
         16#48#           =>  --  01F648
          (0, 0, 28484, 28484),
         16#49#           =>  --  01F649
          (0, 0, 28485, 28485),
         16#4A#           =>  --  01F64A
          (0, 0, 28486, 28486),
         16#4B#           =>  --  01F64B
          (0, 0, 28487, 28487),
         16#4C#           =>  --  01F64C
          (0, 0, 28488, 28488),
         16#4D#           =>  --  01F64D
          (0, 0, 28489, 28489),
         16#4E#           =>  --  01F64E
          (0, 0, 28490, 28490),
         16#4F#           =>  --  01F64F
          (0, 0, 28491, 28491),
         16#50#           =>  --  01F650
          (0, 0, 28492, 28492),
         16#51#           =>  --  01F651
          (0, 0, 28493, 28493),
         16#52#           =>  --  01F652
          (0, 0, 28494, 28494),
         16#53#           =>  --  01F653
          (0, 0, 28495, 28495),
         16#54#           =>  --  01F654
          (0, 0, 28496, 28496),
         16#55#           =>  --  01F655
          (0, 0, 28497, 28497),
         16#56#           =>  --  01F656
          (0, 0, 28498, 28498),
         16#57#           =>  --  01F657
          (0, 0, 28499, 28499),
         16#58#           =>  --  01F658
          (0, 0, 28500, 28500),
         16#59#           =>  --  01F659
          (0, 0, 28501, 28501),
         16#5A#           =>  --  01F65A
          (0, 0, 28502, 28502),
         16#5B#           =>  --  01F65B
          (0, 0, 28503, 28503),
         16#5C#           =>  --  01F65C
          (0, 0, 28504, 28504),
         16#5D#           =>  --  01F65D
          (0, 0, 28505, 28505),
         16#5E#           =>  --  01F65E
          (0, 0, 28506, 28506),
         16#5F#           =>  --  01F65F
          (0, 0, 28507, 28507),
         16#60#           =>  --  01F660
          (0, 0, 28508, 28508),
         16#61#           =>  --  01F661
          (0, 0, 28509, 28509),
         16#62#           =>  --  01F662
          (0, 0, 28510, 28510),
         16#63#           =>  --  01F663
          (0, 0, 28511, 28511),
         16#64#           =>  --  01F664
          (0, 0, 28512, 28512),
         16#65#           =>  --  01F665
          (0, 0, 28513, 28513),
         16#66#           =>  --  01F666
          (0, 0, 28514, 28514),
         16#67#           =>  --  01F667
          (0, 0, 28515, 28515),
         16#68#           =>  --  01F668
          (0, 0, 28516, 28516),
         16#69#           =>  --  01F669
          (0, 0, 28517, 28517),
         16#6A#           =>  --  01F66A
          (0, 0, 28518, 28518),
         16#6B#           =>  --  01F66B
          (0, 0, 28519, 28519),
         16#6C#           =>  --  01F66C
          (0, 0, 28520, 28520),
         16#6D#           =>  --  01F66D
          (0, 0, 28521, 28521),
         16#6E#           =>  --  01F66E
          (0, 0, 28522, 28522),
         16#6F#           =>  --  01F66F
          (0, 0, 28523, 28523),
         16#70#           =>  --  01F670
          (0, 0, 28524, 28524),
         16#71#           =>  --  01F671
          (0, 0, 28525, 28525),
         16#72#           =>  --  01F672
          (0, 0, 28526, 28526),
         16#73#           =>  --  01F673
          (0, 0, 28527, 28527),
         16#74#           =>  --  01F674
          (0, 0, 28528, 28528),
         16#75#           =>  --  01F675
          (0, 0, 28529, 28529),
         16#76#           =>  --  01F676
          (0, 0, 28530, 28530),
         16#77#           =>  --  01F677
          (0, 0, 28531, 28531),
         16#78#           =>  --  01F678
          (0, 0, 28532, 28532),
         16#79#           =>  --  01F679
          (0, 0, 28533, 28533),
         16#7A#           =>  --  01F67A
          (0, 0, 28534, 28534),
         16#7B#           =>  --  01F67B
          (0, 0, 28535, 28535),
         16#7C#           =>  --  01F67C
          (0, 0, 28536, 28536),
         16#7D#           =>  --  01F67D
          (0, 0, 28537, 28537),
         16#7E#           =>  --  01F67E
          (0, 0, 28538, 28538),
         16#7F#           =>  --  01F67F
          (0, 0, 28539, 28539),
         16#80#           =>  --  01F680
          (0, 0, 28540, 28540),
         16#81#           =>  --  01F681
          (0, 0, 28541, 28541),
         16#82#           =>  --  01F682
          (0, 0, 28542, 28542),
         16#83#           =>  --  01F683
          (0, 0, 28543, 28543),
         16#84#           =>  --  01F684
          (0, 0, 28544, 28544),
         16#85#           =>  --  01F685
          (0, 0, 28545, 28545),
         16#86#           =>  --  01F686
          (0, 0, 28546, 28546),
         16#87#           =>  --  01F687
          (0, 0, 28547, 28547),
         16#88#           =>  --  01F688
          (0, 0, 28548, 28548),
         16#89#           =>  --  01F689
          (0, 0, 28549, 28549),
         16#8A#           =>  --  01F68A
          (0, 0, 28550, 28550),
         16#8B#           =>  --  01F68B
          (0, 0, 28551, 28551),
         16#8C#           =>  --  01F68C
          (0, 0, 28552, 28552),
         16#8D#           =>  --  01F68D
          (0, 0, 28553, 28553),
         16#8E#           =>  --  01F68E
          (0, 0, 28554, 28554),
         16#8F#           =>  --  01F68F
          (0, 0, 28555, 28555),
         16#90#           =>  --  01F690
          (0, 0, 28556, 28556),
         16#91#           =>  --  01F691
          (0, 0, 28557, 28557),
         16#92#           =>  --  01F692
          (0, 0, 28558, 28558),
         16#93#           =>  --  01F693
          (0, 0, 28559, 28559),
         16#94#           =>  --  01F694
          (0, 0, 28560, 28560),
         16#95#           =>  --  01F695
          (0, 0, 28561, 28561),
         16#96#           =>  --  01F696
          (0, 0, 28562, 28562),
         16#97#           =>  --  01F697
          (0, 0, 28563, 28563),
         16#98#           =>  --  01F698
          (0, 0, 28564, 28564),
         16#99#           =>  --  01F699
          (0, 0, 28565, 28565),
         16#9A#           =>  --  01F69A
          (0, 0, 28566, 28566),
         16#9B#           =>  --  01F69B
          (0, 0, 28567, 28567),
         16#9C#           =>  --  01F69C
          (0, 0, 28568, 28568),
         16#9D#           =>  --  01F69D
          (0, 0, 28569, 28569),
         16#9E#           =>  --  01F69E
          (0, 0, 28570, 28570),
         16#9F#           =>  --  01F69F
          (0, 0, 28571, 28571),
         16#A0#           =>  --  01F6A0
          (0, 0, 28572, 28572),
         16#A1#           =>  --  01F6A1
          (0, 0, 28573, 28573),
         16#A2#           =>  --  01F6A2
          (0, 0, 28574, 28574),
         16#A3#           =>  --  01F6A3
          (0, 0, 28575, 28575),
         16#A4#           =>  --  01F6A4
          (0, 0, 28576, 28576),
         16#A5#           =>  --  01F6A5
          (0, 0, 28577, 28577),
         16#A6#           =>  --  01F6A6
          (0, 0, 28578, 28578),
         16#A7#           =>  --  01F6A7
          (0, 0, 28579, 28579),
         16#A8#           =>  --  01F6A8
          (0, 0, 28580, 28580),
         16#A9#           =>  --  01F6A9
          (0, 0, 28581, 28581),
         16#AA#           =>  --  01F6AA
          (0, 0, 28582, 28582),
         16#AB#           =>  --  01F6AB
          (0, 0, 28583, 28583),
         16#AC#           =>  --  01F6AC
          (0, 0, 28584, 28584),
         16#AD#           =>  --  01F6AD
          (0, 0, 28585, 28585),
         16#AE#           =>  --  01F6AE
          (0, 0, 28586, 28586),
         16#AF#           =>  --  01F6AF
          (0, 0, 28587, 28587),
         16#B0#           =>  --  01F6B0
          (0, 0, 28588, 28588),
         16#B1#           =>  --  01F6B1
          (0, 0, 28589, 28589),
         16#B2#           =>  --  01F6B2
          (0, 0, 28590, 28590),
         16#B3#           =>  --  01F6B3
          (0, 0, 28591, 28591),
         16#B4#           =>  --  01F6B4
          (0, 0, 28592, 28592),
         16#B5#           =>  --  01F6B5
          (0, 0, 28593, 28593),
         16#B6#           =>  --  01F6B6
          (0, 0, 28594, 28594),
         16#B7#           =>  --  01F6B7
          (0, 0, 28595, 28595),
         16#B8#           =>  --  01F6B8
          (0, 0, 28596, 28596),
         16#B9#           =>  --  01F6B9
          (0, 0, 28597, 28597),
         16#BA#           =>  --  01F6BA
          (0, 0, 28598, 28598),
         16#BB#           =>  --  01F6BB
          (0, 0, 28599, 28599),
         16#BC#           =>  --  01F6BC
          (0, 0, 28600, 28600),
         16#BD#           =>  --  01F6BD
          (0, 0, 28601, 28601),
         16#BE#           =>  --  01F6BE
          (0, 0, 28602, 28602),
         16#BF#           =>  --  01F6BF
          (0, 0, 28603, 28603),
         16#C0#           =>  --  01F6C0
          (0, 0, 28604, 28604),
         16#C1#           =>  --  01F6C1
          (0, 0, 28605, 28605),
         16#C2#           =>  --  01F6C2
          (0, 0, 28606, 28606),
         16#C3#           =>  --  01F6C3
          (0, 0, 28607, 28607),
         16#C4#           =>  --  01F6C4
          (0, 0, 28608, 28608),
         16#C5#           =>  --  01F6C5
          (0, 0, 28609, 28609),
         16#C6#           =>  --  01F6C6
          (0, 0, 28610, 28610),
         16#C7#           =>  --  01F6C7
          (0, 0, 28611, 28611),
         16#C8#           =>  --  01F6C8
          (0, 0, 28612, 28612),
         16#C9#           =>  --  01F6C9
          (0, 0, 28613, 28613),
         16#CA#           =>  --  01F6CA
          (0, 0, 28614, 28614),
         16#CB#           =>  --  01F6CB
          (0, 0, 28615, 28615),
         16#CC#           =>  --  01F6CC
          (0, 0, 28616, 28616),
         16#CD#           =>  --  01F6CD
          (0, 0, 28617, 28617),
         16#CE#           =>  --  01F6CE
          (0, 0, 28618, 28618),
         16#CF#           =>  --  01F6CF
          (0, 0, 28619, 28619),
         16#E0#           =>  --  01F6E0
          (0, 0, 28620, 28620),
         16#E1#           =>  --  01F6E1
          (0, 0, 28621, 28621),
         16#E2#           =>  --  01F6E2
          (0, 0, 28622, 28622),
         16#E3#           =>  --  01F6E3
          (0, 0, 28623, 28623),
         16#E4#           =>  --  01F6E4
          (0, 0, 28624, 28624),
         16#E5#           =>  --  01F6E5
          (0, 0, 28625, 28625),
         16#E6#           =>  --  01F6E6
          (0, 0, 28626, 28626),
         16#E7#           =>  --  01F6E7
          (0, 0, 28627, 28627),
         16#E8#           =>  --  01F6E8
          (0, 0, 28628, 28628),
         16#E9#           =>  --  01F6E9
          (0, 0, 28629, 28629),
         16#EA#           =>  --  01F6EA
          (0, 0, 28630, 28630),
         16#EB#           =>  --  01F6EB
          (0, 0, 28631, 28631),
         16#EC#           =>  --  01F6EC
          (0, 0, 28632, 28632),
         16#F0#           =>  --  01F6F0
          (0, 0, 28633, 28633),
         16#F1#           =>  --  01F6F1
          (0, 0, 28634, 28634),
         16#F2#           =>  --  01F6F2
          (0, 0, 28635, 28635),
         16#F3#           =>  --  01F6F3
          (0, 0, 28636, 28636),
         others           =>
          (0, 0, 0, 0));

   Group_01F7 : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  01F700
          (0, 0, 28637, 28637),
         16#01#           =>  --  01F701
          (0, 0, 28638, 28638),
         16#02#           =>  --  01F702
          (0, 0, 28639, 28639),
         16#03#           =>  --  01F703
          (0, 0, 28640, 28640),
         16#04#           =>  --  01F704
          (0, 0, 28641, 28641),
         16#05#           =>  --  01F705
          (0, 0, 28642, 28642),
         16#06#           =>  --  01F706
          (0, 0, 28643, 28643),
         16#07#           =>  --  01F707
          (0, 0, 28644, 28644),
         16#08#           =>  --  01F708
          (0, 0, 28645, 28645),
         16#09#           =>  --  01F709
          (0, 0, 28646, 28646),
         16#0A#           =>  --  01F70A
          (0, 0, 28647, 28647),
         16#0B#           =>  --  01F70B
          (0, 0, 28648, 28648),
         16#0C#           =>  --  01F70C
          (0, 0, 28649, 28649),
         16#0D#           =>  --  01F70D
          (0, 0, 28650, 28650),
         16#0E#           =>  --  01F70E
          (0, 0, 28651, 28651),
         16#0F#           =>  --  01F70F
          (0, 0, 28652, 28652),
         16#10#           =>  --  01F710
          (0, 0, 28653, 28653),
         16#11#           =>  --  01F711
          (0, 0, 28654, 28654),
         16#12#           =>  --  01F712
          (0, 0, 28655, 28655),
         16#13#           =>  --  01F713
          (0, 0, 28656, 28656),
         16#14#           =>  --  01F714
          (0, 0, 28657, 28657),
         16#15#           =>  --  01F715
          (0, 0, 28658, 28658),
         16#16#           =>  --  01F716
          (0, 0, 28659, 28659),
         16#17#           =>  --  01F717
          (0, 0, 28660, 28660),
         16#18#           =>  --  01F718
          (0, 0, 28661, 28661),
         16#19#           =>  --  01F719
          (0, 0, 28662, 28662),
         16#1A#           =>  --  01F71A
          (0, 0, 28663, 28663),
         16#1B#           =>  --  01F71B
          (0, 0, 28664, 28664),
         16#1C#           =>  --  01F71C
          (0, 0, 28665, 28665),
         16#1D#           =>  --  01F71D
          (0, 0, 28666, 28666),
         16#1E#           =>  --  01F71E
          (0, 0, 28667, 28667),
         16#1F#           =>  --  01F71F
          (0, 0, 28668, 28668),
         16#20#           =>  --  01F720
          (0, 0, 28669, 28669),
         16#21#           =>  --  01F721
          (0, 0, 28670, 28670),
         16#22#           =>  --  01F722
          (0, 0, 28671, 28671),
         16#23#           =>  --  01F723
          (0, 0, 28672, 28672),
         16#24#           =>  --  01F724
          (0, 0, 28673, 28673),
         16#25#           =>  --  01F725
          (0, 0, 28674, 28674),
         16#26#           =>  --  01F726
          (0, 0, 28675, 28675),
         16#27#           =>  --  01F727
          (0, 0, 28676, 28676),
         16#28#           =>  --  01F728
          (0, 0, 28677, 28677),
         16#29#           =>  --  01F729
          (0, 0, 28678, 28678),
         16#2A#           =>  --  01F72A
          (0, 0, 28679, 28679),
         16#2B#           =>  --  01F72B
          (0, 0, 28680, 28680),
         16#2C#           =>  --  01F72C
          (0, 0, 28681, 28681),
         16#2D#           =>  --  01F72D
          (0, 0, 28682, 28682),
         16#2E#           =>  --  01F72E
          (0, 0, 28683, 28683),
         16#2F#           =>  --  01F72F
          (0, 0, 28684, 28684),
         16#30#           =>  --  01F730
          (0, 0, 28685, 28685),
         16#31#           =>  --  01F731
          (0, 0, 28686, 28686),
         16#32#           =>  --  01F732
          (0, 0, 28687, 28687),
         16#33#           =>  --  01F733
          (0, 0, 28688, 28688),
         16#34#           =>  --  01F734
          (0, 0, 28689, 28689),
         16#35#           =>  --  01F735
          (0, 0, 28690, 28690),
         16#36#           =>  --  01F736
          (0, 0, 28691, 28691),
         16#37#           =>  --  01F737
          (0, 0, 28692, 28692),
         16#38#           =>  --  01F738
          (0, 0, 28693, 28693),
         16#39#           =>  --  01F739
          (0, 0, 28694, 28694),
         16#3A#           =>  --  01F73A
          (0, 0, 28695, 28695),
         16#3B#           =>  --  01F73B
          (0, 0, 28696, 28696),
         16#3C#           =>  --  01F73C
          (0, 0, 28697, 28697),
         16#3D#           =>  --  01F73D
          (0, 0, 28698, 28698),
         16#3E#           =>  --  01F73E
          (0, 0, 28699, 28699),
         16#3F#           =>  --  01F73F
          (0, 0, 28700, 28700),
         16#40#           =>  --  01F740
          (0, 0, 28701, 28701),
         16#41#           =>  --  01F741
          (0, 0, 28702, 28702),
         16#42#           =>  --  01F742
          (0, 0, 28703, 28703),
         16#43#           =>  --  01F743
          (0, 0, 28704, 28704),
         16#44#           =>  --  01F744
          (0, 0, 28705, 28705),
         16#45#           =>  --  01F745
          (0, 0, 28706, 28706),
         16#46#           =>  --  01F746
          (0, 0, 28707, 28707),
         16#47#           =>  --  01F747
          (0, 0, 28708, 28708),
         16#48#           =>  --  01F748
          (0, 0, 28709, 28709),
         16#49#           =>  --  01F749
          (0, 0, 28710, 28710),
         16#4A#           =>  --  01F74A
          (0, 0, 28711, 28711),
         16#4B#           =>  --  01F74B
          (0, 0, 28712, 28712),
         16#4C#           =>  --  01F74C
          (0, 0, 28713, 28713),
         16#4D#           =>  --  01F74D
          (0, 0, 28714, 28714),
         16#4E#           =>  --  01F74E
          (0, 0, 28715, 28715),
         16#4F#           =>  --  01F74F
          (0, 0, 28716, 28716),
         16#50#           =>  --  01F750
          (0, 0, 28717, 28717),
         16#51#           =>  --  01F751
          (0, 0, 28718, 28718),
         16#52#           =>  --  01F752
          (0, 0, 28719, 28719),
         16#53#           =>  --  01F753
          (0, 0, 28720, 28720),
         16#54#           =>  --  01F754
          (0, 0, 28721, 28721),
         16#55#           =>  --  01F755
          (0, 0, 28722, 28722),
         16#56#           =>  --  01F756
          (0, 0, 28723, 28723),
         16#57#           =>  --  01F757
          (0, 0, 28724, 28724),
         16#58#           =>  --  01F758
          (0, 0, 28725, 28725),
         16#59#           =>  --  01F759
          (0, 0, 28726, 28726),
         16#5A#           =>  --  01F75A
          (0, 0, 28727, 28727),
         16#5B#           =>  --  01F75B
          (0, 0, 28728, 28728),
         16#5C#           =>  --  01F75C
          (0, 0, 28729, 28729),
         16#5D#           =>  --  01F75D
          (0, 0, 28730, 28730),
         16#5E#           =>  --  01F75E
          (0, 0, 28731, 28731),
         16#5F#           =>  --  01F75F
          (0, 0, 28732, 28732),
         16#60#           =>  --  01F760
          (0, 0, 28733, 28733),
         16#61#           =>  --  01F761
          (0, 0, 28734, 28734),
         16#62#           =>  --  01F762
          (0, 0, 28735, 28735),
         16#63#           =>  --  01F763
          (0, 0, 28736, 28736),
         16#64#           =>  --  01F764
          (0, 0, 28737, 28737),
         16#65#           =>  --  01F765
          (0, 0, 28738, 28738),
         16#66#           =>  --  01F766
          (0, 0, 28739, 28739),
         16#67#           =>  --  01F767
          (0, 0, 28740, 28740),
         16#68#           =>  --  01F768
          (0, 0, 28741, 28741),
         16#69#           =>  --  01F769
          (0, 0, 28742, 28742),
         16#6A#           =>  --  01F76A
          (0, 0, 28743, 28743),
         16#6B#           =>  --  01F76B
          (0, 0, 28744, 28744),
         16#6C#           =>  --  01F76C
          (0, 0, 28745, 28745),
         16#6D#           =>  --  01F76D
          (0, 0, 28746, 28746),
         16#6E#           =>  --  01F76E
          (0, 0, 28747, 28747),
         16#6F#           =>  --  01F76F
          (0, 0, 28748, 28748),
         16#70#           =>  --  01F770
          (0, 0, 28749, 28749),
         16#71#           =>  --  01F771
          (0, 0, 28750, 28750),
         16#72#           =>  --  01F772
          (0, 0, 28751, 28751),
         16#73#           =>  --  01F773
          (0, 0, 28752, 28752),
         16#80#           =>  --  01F780
          (0, 0, 28753, 28753),
         16#81#           =>  --  01F781
          (0, 0, 28754, 28754),
         16#82#           =>  --  01F782
          (0, 0, 28755, 28755),
         16#83#           =>  --  01F783
          (0, 0, 28756, 28756),
         16#84#           =>  --  01F784
          (0, 0, 28757, 28757),
         16#85#           =>  --  01F785
          (0, 0, 28758, 28758),
         16#86#           =>  --  01F786
          (0, 0, 28759, 28759),
         16#87#           =>  --  01F787
          (0, 0, 28760, 28760),
         16#88#           =>  --  01F788
          (0, 0, 28761, 28761),
         16#89#           =>  --  01F789
          (0, 0, 28762, 28762),
         16#8A#           =>  --  01F78A
          (0, 0, 28763, 28763),
         16#8B#           =>  --  01F78B
          (0, 0, 28764, 28764),
         16#8C#           =>  --  01F78C
          (0, 0, 28765, 28765),
         16#8D#           =>  --  01F78D
          (0, 0, 28766, 28766),
         16#8E#           =>  --  01F78E
          (0, 0, 28767, 28767),
         16#8F#           =>  --  01F78F
          (0, 0, 28768, 28768),
         16#90#           =>  --  01F790
          (0, 0, 28769, 28769),
         16#91#           =>  --  01F791
          (0, 0, 28770, 28770),
         16#92#           =>  --  01F792
          (0, 0, 28771, 28771),
         16#93#           =>  --  01F793
          (0, 0, 28772, 28772),
         16#94#           =>  --  01F794
          (0, 0, 28773, 28773),
         16#95#           =>  --  01F795
          (0, 0, 28774, 28774),
         16#96#           =>  --  01F796
          (0, 0, 28775, 28775),
         16#97#           =>  --  01F797
          (0, 0, 28776, 28776),
         16#98#           =>  --  01F798
          (0, 0, 28777, 28777),
         16#99#           =>  --  01F799
          (0, 0, 28778, 28778),
         16#9A#           =>  --  01F79A
          (0, 0, 28779, 28779),
         16#9B#           =>  --  01F79B
          (0, 0, 28780, 28780),
         16#9C#           =>  --  01F79C
          (0, 0, 28781, 28781),
         16#9D#           =>  --  01F79D
          (0, 0, 28782, 28782),
         16#9E#           =>  --  01F79E
          (0, 0, 28783, 28783),
         16#9F#           =>  --  01F79F
          (0, 0, 28784, 28784),
         16#A0#           =>  --  01F7A0
          (0, 0, 28785, 28785),
         16#A1#           =>  --  01F7A1
          (0, 0, 28786, 28786),
         16#A2#           =>  --  01F7A2
          (0, 0, 28787, 28787),
         16#A3#           =>  --  01F7A3
          (0, 0, 28788, 28788),
         16#A4#           =>  --  01F7A4
          (0, 0, 28789, 28789),
         16#A5#           =>  --  01F7A5
          (0, 0, 28790, 28790),
         16#A6#           =>  --  01F7A6
          (0, 0, 28791, 28791),
         16#A7#           =>  --  01F7A7
          (0, 0, 28792, 28792),
         16#A8#           =>  --  01F7A8
          (0, 0, 28793, 28793),
         16#A9#           =>  --  01F7A9
          (0, 0, 28794, 28794),
         16#AA#           =>  --  01F7AA
          (0, 0, 28795, 28795),
         16#AB#           =>  --  01F7AB
          (0, 0, 28796, 28796),
         16#AC#           =>  --  01F7AC
          (0, 0, 28797, 28797),
         16#AD#           =>  --  01F7AD
          (0, 0, 28798, 28798),
         16#AE#           =>  --  01F7AE
          (0, 0, 28799, 28799),
         16#AF#           =>  --  01F7AF
          (0, 0, 28800, 28800),
         16#B0#           =>  --  01F7B0
          (0, 0, 28801, 28801),
         16#B1#           =>  --  01F7B1
          (0, 0, 28802, 28802),
         16#B2#           =>  --  01F7B2
          (0, 0, 28803, 28803),
         16#B3#           =>  --  01F7B3
          (0, 0, 28804, 28804),
         16#B4#           =>  --  01F7B4
          (0, 0, 28805, 28805),
         16#B5#           =>  --  01F7B5
          (0, 0, 28806, 28806),
         16#B6#           =>  --  01F7B6
          (0, 0, 28807, 28807),
         16#B7#           =>  --  01F7B7
          (0, 0, 28808, 28808),
         16#B8#           =>  --  01F7B8
          (0, 0, 28809, 28809),
         16#B9#           =>  --  01F7B9
          (0, 0, 28810, 28810),
         16#BA#           =>  --  01F7BA
          (0, 0, 28811, 28811),
         16#BB#           =>  --  01F7BB
          (0, 0, 28812, 28812),
         16#BC#           =>  --  01F7BC
          (0, 0, 28813, 28813),
         16#BD#           =>  --  01F7BD
          (0, 0, 28814, 28814),
         16#BE#           =>  --  01F7BE
          (0, 0, 28815, 28815),
         16#BF#           =>  --  01F7BF
          (0, 0, 28816, 28816),
         16#C0#           =>  --  01F7C0
          (0, 0, 28817, 28817),
         16#C1#           =>  --  01F7C1
          (0, 0, 28818, 28818),
         16#C2#           =>  --  01F7C2
          (0, 0, 28819, 28819),
         16#C3#           =>  --  01F7C3
          (0, 0, 28820, 28820),
         16#C4#           =>  --  01F7C4
          (0, 0, 28821, 28821),
         16#C5#           =>  --  01F7C5
          (0, 0, 28822, 28822),
         16#C6#           =>  --  01F7C6
          (0, 0, 28823, 28823),
         16#C7#           =>  --  01F7C7
          (0, 0, 28824, 28824),
         16#C8#           =>  --  01F7C8
          (0, 0, 28825, 28825),
         16#C9#           =>  --  01F7C9
          (0, 0, 28826, 28826),
         16#CA#           =>  --  01F7CA
          (0, 0, 28827, 28827),
         16#CB#           =>  --  01F7CB
          (0, 0, 28828, 28828),
         16#CC#           =>  --  01F7CC
          (0, 0, 28829, 28829),
         16#CD#           =>  --  01F7CD
          (0, 0, 28830, 28830),
         16#CE#           =>  --  01F7CE
          (0, 0, 28831, 28831),
         16#CF#           =>  --  01F7CF
          (0, 0, 28832, 28832),
         16#D0#           =>  --  01F7D0
          (0, 0, 28833, 28833),
         16#D1#           =>  --  01F7D1
          (0, 0, 28834, 28834),
         16#D2#           =>  --  01F7D2
          (0, 0, 28835, 28835),
         16#D3#           =>  --  01F7D3
          (0, 0, 28836, 28836),
         16#D4#           =>  --  01F7D4
          (0, 0, 28837, 28837),
         others           =>
          (0, 0, 0, 0));

   Group_01F8 : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  01F800
          (0, 0, 28838, 28838),
         16#01#           =>  --  01F801
          (0, 0, 28839, 28839),
         16#02#           =>  --  01F802
          (0, 0, 28840, 28840),
         16#03#           =>  --  01F803
          (0, 0, 28841, 28841),
         16#04#           =>  --  01F804
          (0, 0, 28842, 28842),
         16#05#           =>  --  01F805
          (0, 0, 28843, 28843),
         16#06#           =>  --  01F806
          (0, 0, 28844, 28844),
         16#07#           =>  --  01F807
          (0, 0, 28845, 28845),
         16#08#           =>  --  01F808
          (0, 0, 28846, 28846),
         16#09#           =>  --  01F809
          (0, 0, 28847, 28847),
         16#0A#           =>  --  01F80A
          (0, 0, 28848, 28848),
         16#0B#           =>  --  01F80B
          (0, 0, 28849, 28849),
         16#10#           =>  --  01F810
          (0, 0, 28850, 28850),
         16#11#           =>  --  01F811
          (0, 0, 28851, 28851),
         16#12#           =>  --  01F812
          (0, 0, 28852, 28852),
         16#13#           =>  --  01F813
          (0, 0, 28853, 28853),
         16#14#           =>  --  01F814
          (0, 0, 28854, 28854),
         16#15#           =>  --  01F815
          (0, 0, 28855, 28855),
         16#16#           =>  --  01F816
          (0, 0, 28856, 28856),
         16#17#           =>  --  01F817
          (0, 0, 28857, 28857),
         16#18#           =>  --  01F818
          (0, 0, 28858, 28858),
         16#19#           =>  --  01F819
          (0, 0, 28859, 28859),
         16#1A#           =>  --  01F81A
          (0, 0, 28860, 28860),
         16#1B#           =>  --  01F81B
          (0, 0, 28861, 28861),
         16#1C#           =>  --  01F81C
          (0, 0, 28862, 28862),
         16#1D#           =>  --  01F81D
          (0, 0, 28863, 28863),
         16#1E#           =>  --  01F81E
          (0, 0, 28864, 28864),
         16#1F#           =>  --  01F81F
          (0, 0, 28865, 28865),
         16#20#           =>  --  01F820
          (0, 0, 28866, 28866),
         16#21#           =>  --  01F821
          (0, 0, 28867, 28867),
         16#22#           =>  --  01F822
          (0, 0, 28868, 28868),
         16#23#           =>  --  01F823
          (0, 0, 28869, 28869),
         16#24#           =>  --  01F824
          (0, 0, 28870, 28870),
         16#25#           =>  --  01F825
          (0, 0, 28871, 28871),
         16#26#           =>  --  01F826
          (0, 0, 28872, 28872),
         16#27#           =>  --  01F827
          (0, 0, 28873, 28873),
         16#28#           =>  --  01F828
          (0, 0, 28874, 28874),
         16#29#           =>  --  01F829
          (0, 0, 28875, 28875),
         16#2A#           =>  --  01F82A
          (0, 0, 28876, 28876),
         16#2B#           =>  --  01F82B
          (0, 0, 28877, 28877),
         16#2C#           =>  --  01F82C
          (0, 0, 28878, 28878),
         16#2D#           =>  --  01F82D
          (0, 0, 28879, 28879),
         16#2E#           =>  --  01F82E
          (0, 0, 28880, 28880),
         16#2F#           =>  --  01F82F
          (0, 0, 28881, 28881),
         16#30#           =>  --  01F830
          (0, 0, 28882, 28882),
         16#31#           =>  --  01F831
          (0, 0, 28883, 28883),
         16#32#           =>  --  01F832
          (0, 0, 28884, 28884),
         16#33#           =>  --  01F833
          (0, 0, 28885, 28885),
         16#34#           =>  --  01F834
          (0, 0, 28886, 28886),
         16#35#           =>  --  01F835
          (0, 0, 28887, 28887),
         16#36#           =>  --  01F836
          (0, 0, 28888, 28888),
         16#37#           =>  --  01F837
          (0, 0, 28889, 28889),
         16#38#           =>  --  01F838
          (0, 0, 28890, 28890),
         16#39#           =>  --  01F839
          (0, 0, 28891, 28891),
         16#3A#           =>  --  01F83A
          (0, 0, 28892, 28892),
         16#3B#           =>  --  01F83B
          (0, 0, 28893, 28893),
         16#3C#           =>  --  01F83C
          (0, 0, 28894, 28894),
         16#3D#           =>  --  01F83D
          (0, 0, 28895, 28895),
         16#3E#           =>  --  01F83E
          (0, 0, 28896, 28896),
         16#3F#           =>  --  01F83F
          (0, 0, 28897, 28897),
         16#40#           =>  --  01F840
          (0, 0, 28898, 28898),
         16#41#           =>  --  01F841
          (0, 0, 28899, 28899),
         16#42#           =>  --  01F842
          (0, 0, 28900, 28900),
         16#43#           =>  --  01F843
          (0, 0, 28901, 28901),
         16#44#           =>  --  01F844
          (0, 0, 28902, 28902),
         16#45#           =>  --  01F845
          (0, 0, 28903, 28903),
         16#46#           =>  --  01F846
          (0, 0, 28904, 28904),
         16#47#           =>  --  01F847
          (0, 0, 28905, 28905),
         16#50#           =>  --  01F850
          (0, 0, 28906, 28906),
         16#51#           =>  --  01F851
          (0, 0, 28907, 28907),
         16#52#           =>  --  01F852
          (0, 0, 28908, 28908),
         16#53#           =>  --  01F853
          (0, 0, 28909, 28909),
         16#54#           =>  --  01F854
          (0, 0, 28910, 28910),
         16#55#           =>  --  01F855
          (0, 0, 28911, 28911),
         16#56#           =>  --  01F856
          (0, 0, 28912, 28912),
         16#57#           =>  --  01F857
          (0, 0, 28913, 28913),
         16#58#           =>  --  01F858
          (0, 0, 28914, 28914),
         16#59#           =>  --  01F859
          (0, 0, 28915, 28915),
         16#60#           =>  --  01F860
          (0, 0, 28916, 28916),
         16#61#           =>  --  01F861
          (0, 0, 28917, 28917),
         16#62#           =>  --  01F862
          (0, 0, 28918, 28918),
         16#63#           =>  --  01F863
          (0, 0, 28919, 28919),
         16#64#           =>  --  01F864
          (0, 0, 28920, 28920),
         16#65#           =>  --  01F865
          (0, 0, 28921, 28921),
         16#66#           =>  --  01F866
          (0, 0, 28922, 28922),
         16#67#           =>  --  01F867
          (0, 0, 28923, 28923),
         16#68#           =>  --  01F868
          (0, 0, 28924, 28924),
         16#69#           =>  --  01F869
          (0, 0, 28925, 28925),
         16#6A#           =>  --  01F86A
          (0, 0, 28926, 28926),
         16#6B#           =>  --  01F86B
          (0, 0, 28927, 28927),
         16#6C#           =>  --  01F86C
          (0, 0, 28928, 28928),
         16#6D#           =>  --  01F86D
          (0, 0, 28929, 28929),
         16#6E#           =>  --  01F86E
          (0, 0, 28930, 28930),
         16#6F#           =>  --  01F86F
          (0, 0, 28931, 28931),
         16#70#           =>  --  01F870
          (0, 0, 28932, 28932),
         16#71#           =>  --  01F871
          (0, 0, 28933, 28933),
         16#72#           =>  --  01F872
          (0, 0, 28934, 28934),
         16#73#           =>  --  01F873
          (0, 0, 28935, 28935),
         16#74#           =>  --  01F874
          (0, 0, 28936, 28936),
         16#75#           =>  --  01F875
          (0, 0, 28937, 28937),
         16#76#           =>  --  01F876
          (0, 0, 28938, 28938),
         16#77#           =>  --  01F877
          (0, 0, 28939, 28939),
         16#78#           =>  --  01F878
          (0, 0, 28940, 28940),
         16#79#           =>  --  01F879
          (0, 0, 28941, 28941),
         16#7A#           =>  --  01F87A
          (0, 0, 28942, 28942),
         16#7B#           =>  --  01F87B
          (0, 0, 28943, 28943),
         16#7C#           =>  --  01F87C
          (0, 0, 28944, 28944),
         16#7D#           =>  --  01F87D
          (0, 0, 28945, 28945),
         16#7E#           =>  --  01F87E
          (0, 0, 28946, 28946),
         16#7F#           =>  --  01F87F
          (0, 0, 28947, 28947),
         16#80#           =>  --  01F880
          (0, 0, 28948, 28948),
         16#81#           =>  --  01F881
          (0, 0, 28949, 28949),
         16#82#           =>  --  01F882
          (0, 0, 28950, 28950),
         16#83#           =>  --  01F883
          (0, 0, 28951, 28951),
         16#84#           =>  --  01F884
          (0, 0, 28952, 28952),
         16#85#           =>  --  01F885
          (0, 0, 28953, 28953),
         16#86#           =>  --  01F886
          (0, 0, 28954, 28954),
         16#87#           =>  --  01F887
          (0, 0, 28955, 28955),
         16#90#           =>  --  01F890
          (0, 0, 28956, 28956),
         16#91#           =>  --  01F891
          (0, 0, 28957, 28957),
         16#92#           =>  --  01F892
          (0, 0, 28958, 28958),
         16#93#           =>  --  01F893
          (0, 0, 28959, 28959),
         16#94#           =>  --  01F894
          (0, 0, 28960, 28960),
         16#95#           =>  --  01F895
          (0, 0, 28961, 28961),
         16#96#           =>  --  01F896
          (0, 0, 28962, 28962),
         16#97#           =>  --  01F897
          (0, 0, 28963, 28963),
         16#98#           =>  --  01F898
          (0, 0, 28964, 28964),
         16#99#           =>  --  01F899
          (0, 0, 28965, 28965),
         16#9A#           =>  --  01F89A
          (0, 0, 28966, 28966),
         16#9B#           =>  --  01F89B
          (0, 0, 28967, 28967),
         16#9C#           =>  --  01F89C
          (0, 0, 28968, 28968),
         16#9D#           =>  --  01F89D
          (0, 0, 28969, 28969),
         16#9E#           =>  --  01F89E
          (0, 0, 28970, 28970),
         16#9F#           =>  --  01F89F
          (0, 0, 28971, 28971),
         16#A0#           =>  --  01F8A0
          (0, 0, 28972, 28972),
         16#A1#           =>  --  01F8A1
          (0, 0, 28973, 28973),
         16#A2#           =>  --  01F8A2
          (0, 0, 28974, 28974),
         16#A3#           =>  --  01F8A3
          (0, 0, 28975, 28975),
         16#A4#           =>  --  01F8A4
          (0, 0, 28976, 28976),
         16#A5#           =>  --  01F8A5
          (0, 0, 28977, 28977),
         16#A6#           =>  --  01F8A6
          (0, 0, 28978, 28978),
         16#A7#           =>  --  01F8A7
          (0, 0, 28979, 28979),
         16#A8#           =>  --  01F8A8
          (0, 0, 28980, 28980),
         16#A9#           =>  --  01F8A9
          (0, 0, 28981, 28981),
         16#AA#           =>  --  01F8AA
          (0, 0, 28982, 28982),
         16#AB#           =>  --  01F8AB
          (0, 0, 28983, 28983),
         16#AC#           =>  --  01F8AC
          (0, 0, 28984, 28984),
         16#AD#           =>  --  01F8AD
          (0, 0, 28985, 28985),
         others           =>
          (0, 0, 0, 0));

   Group_02F8 : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  02F800
          (0, 0, 28986, 28987),
         16#01#           =>  --  02F801
          (0, 0, 28988, 28989),
         16#02#           =>  --  02F802
          (0, 0, 28990, 28991),
         16#03#           =>  --  02F803
          (0, 0, 28992, 28993),
         16#04#           =>  --  02F804
          (0, 0, 28994, 28995),
         16#05#           =>  --  02F805
          (0, 0, 18403, 18404),
         16#06#           =>  --  02F806
          (0, 0, 28996, 28997),
         16#07#           =>  --  02F807
          (0, 0, 28998, 28999),
         16#08#           =>  --  02F808
          (0, 0, 29000, 29001),
         16#09#           =>  --  02F809
          (0, 0, 29002, 29003),
         16#0A#           =>  --  02F80A
          (0, 0, 18405, 18406),
         16#0B#           =>  --  02F80B
          (0, 0, 29004, 29005),
         16#0C#           =>  --  02F80C
          (0, 0, 29006, 29007),
         16#0D#           =>  --  02F80D
          (0, 0, 29008, 29009),
         16#0E#           =>  --  02F80E
          (0, 0, 18407, 18408),
         16#0F#           =>  --  02F80F
          (0, 0, 29010, 29011),
         16#10#           =>  --  02F810
          (0, 0, 29012, 29013),
         16#11#           =>  --  02F811
          (0, 0, 29014, 29015),
         16#12#           =>  --  02F812
          (0, 0, 29016, 29017),
         16#13#           =>  --  02F813
          (0, 0, 29018, 29019),
         16#14#           =>  --  02F814
          (0, 0, 29020, 29021),
         16#15#           =>  --  02F815
          (0, 0, 29022, 29023),
         16#16#           =>  --  02F816
          (0, 0, 29024, 29025),
         16#17#           =>  --  02F817
          (0, 0, 29026, 29027),
         16#18#           =>  --  02F818
          (0, 0, 29028, 29029),
         16#19#           =>  --  02F819
          (0, 0, 29030, 29031),
         16#1A#           =>  --  02F81A
          (0, 0, 29032, 29033),
         16#1B#           =>  --  02F81B
          (0, 0, 18523, 18524),
         16#1C#           =>  --  02F81C
          (0, 0, 29034, 29035),
         16#1D#           =>  --  02F81D
          (0, 0, 29036, 29037),
         16#1E#           =>  --  02F81E
          (0, 0, 29038, 29039),
         16#1F#           =>  --  02F81F
          (0, 0, 29040, 29041),
         16#20#           =>  --  02F820
          (0, 0, 29042, 29043),
         16#21#           =>  --  02F821
          (0, 0, 29044, 29045),
         16#22#           =>  --  02F822
          (0, 0, 29046, 29047),
         16#23#           =>  --  02F823
          (0, 0, 29048, 29049),
         16#24#           =>  --  02F824
          (0, 0, 29050, 29051),
         16#25#           =>  --  02F825
          (0, 0, 18533, 18534),
         16#26#           =>  --  02F826
          (0, 0, 18409, 18410),
         16#27#           =>  --  02F827
          (0, 0, 18411, 18412),
         16#28#           =>  --  02F828
          (0, 0, 18535, 18536),
         16#29#           =>  --  02F829
          (0, 0, 29052, 29053),
         16#2A#           =>  --  02F82A
          (0, 0, 29054, 29055),
         16#2B#           =>  --  02F82B
          (0, 0, 18001, 18002),
         16#2C#           =>  --  02F82C
          (0, 0, 29056, 29057),
         16#2D#           =>  --  02F82D
          (0, 0, 18413, 18414),
         16#2E#           =>  --  02F82E
          (0, 0, 29058, 29059),
         16#2F#           =>  --  02F82F
          (0, 0, 29060, 29061),
         16#30#           =>  --  02F830
          (0, 0, 29062, 29063),
         16#34#           =>  --  02F834
          (0, 0, 29066, 29067),
         16#35#           =>  --  02F835
          (0, 0, 29068, 29069),
         16#36#           =>  --  02F836
          (0, 0, 29070, 29071),
         16#37#           =>  --  02F837
          (0, 0, 29072, 29073),
         16#38#           =>  --  02F838
          (0, 0, 29074, 29075),
         16#39#           =>  --  02F839
          (0, 0, 29076, 29077),
         16#3A#           =>  --  02F83A
          (0, 0, 29078, 29079),
         16#3B#           =>  --  02F83B
          (0, 0, 29080, 29081),
         16#3C#           =>  --  02F83C
          (0, 0, 29082, 29083),
         16#3D#           =>  --  02F83D
          (0, 0, 29084, 29085),
         16#3E#           =>  --  02F83E
          (0, 0, 29086, 29087),
         16#3F#           =>  --  02F83F
          (0, 0, 29088, 29089),
         16#40#           =>  --  02F840
          (0, 0, 29090, 29091),
         16#41#           =>  --  02F841
          (0, 0, 29092, 29093),
         16#42#           =>  --  02F842
          (0, 0, 29094, 29095),
         16#43#           =>  --  02F843
          (0, 0, 29096, 29097),
         16#44#           =>  --  02F844
          (0, 0, 29098, 29099),
         16#45# .. 16#46# =>  --  02F845 .. 02F846
          (0, 0, 29100, 29101),
         16#47#           =>  --  02F847
          (0, 0, 18539, 18540),
         16#48#           =>  --  02F848
          (0, 0, 29102, 29103),
         16#49#           =>  --  02F849
          (0, 0, 29104, 29105),
         16#4A#           =>  --  02F84A
          (0, 0, 29106, 29107),
         16#4B#           =>  --  02F84B
          (0, 0, 29108, 29109),
         16#4C#           =>  --  02F84C
          (0, 0, 18417, 18418),
         16#4D#           =>  --  02F84D
          (0, 0, 29110, 29111),
         16#4E#           =>  --  02F84E
          (0, 0, 29112, 29113),
         16#4F#           =>  --  02F84F
          (0, 0, 29114, 29115),
         16#50#           =>  --  02F850
          (0, 0, 18307, 18308),
         16#51#           =>  --  02F851
          (0, 0, 29116, 29117),
         16#52#           =>  --  02F852
          (0, 0, 29118, 29119),
         16#53#           =>  --  02F853
          (0, 0, 29120, 29121),
         16#54#           =>  --  02F854
          (0, 0, 29122, 29123),
         16#55#           =>  --  02F855
          (0, 0, 29124, 29125),
         16#56#           =>  --  02F856
          (0, 0, 29126, 29127),
         16#57#           =>  --  02F857
          (0, 0, 29128, 29129),
         16#58#           =>  --  02F858
          (0, 0, 29130, 29131),
         16#59#           =>  --  02F859
          (0, 0, 29132, 29133),
         16#5A#           =>  --  02F85A
          (0, 0, 29134, 29135),
         16#5B#           =>  --  02F85B
          (0, 0, 29136, 29137),
         16#5C#           =>  --  02F85C
          (0, 0, 29138, 29139),
         16#5D#           =>  --  02F85D
          (0, 0, 29140, 29141),
         16#5E#           =>  --  02F85E
          (0, 0, 29142, 29143),
         16#5F#           =>  --  02F85F
          (0, 0, 29144, 29145),
         16#60#           =>  --  02F860
          (0, 0, 29146, 29147),
         16#61#           =>  --  02F861
          (0, 0, 29148, 29149),
         16#62#           =>  --  02F862
          (0, 0, 29150, 29151),
         16#63#           =>  --  02F863
          (0, 0, 29152, 29153),
         16#64#           =>  --  02F864
          (0, 0, 29154, 29155),
         16#65#           =>  --  02F865
          (0, 0, 29156, 29157),
         16#66#           =>  --  02F866
          (0, 0, 29158, 29159),
         16#67#           =>  --  02F867
          (0, 0, 29160, 29161),
         16#68#           =>  --  02F868
          (0, 0, 29162, 29163),
         16#69#           =>  --  02F869
          (0, 0, 29164, 29165),
         16#6A# .. 16#6B# =>  --  02F86A .. 02F86B
          (0, 0, 29166, 29167),
         16#6C#           =>  --  02F86C
          (0, 0, 29168, 29169),
         16#6D#           =>  --  02F86D
          (0, 0, 29170, 29171),
         16#6E#           =>  --  02F86E
          (0, 0, 29172, 29173),
         16#6F#           =>  --  02F86F
          (0, 0, 17993, 17994),
         16#70#           =>  --  02F870
          (0, 0, 29174, 29175),
         16#71#           =>  --  02F871
          (0, 0, 29176, 29177),
         16#72#           =>  --  02F872
          (0, 0, 29178, 29179),
         16#73#           =>  --  02F873
          (0, 0, 29180, 29181),
         16#74#           =>  --  02F874
          (0, 0, 29182, 29183),
         16#75#           =>  --  02F875
          (0, 0, 29184, 29185),
         16#76#           =>  --  02F876
          (0, 0, 29186, 29187),
         16#77#           =>  --  02F877
          (0, 0, 29188, 29189),
         16#78#           =>  --  02F878
          (0, 0, 18427, 18428),
         16#79#           =>  --  02F879
          (0, 0, 29190, 29191),
         16#7A#           =>  --  02F87A
          (0, 0, 29192, 29193),
         16#7B#           =>  --  02F87B
          (0, 0, 29194, 29195),
         16#7C#           =>  --  02F87C
          (0, 0, 29196, 29197),
         16#7D#           =>  --  02F87D
          (0, 0, 29198, 29199),
         16#7E#           =>  --  02F87E
          (0, 0, 29200, 29201),
         16#7F#           =>  --  02F87F
          (0, 0, 29202, 29203),
         16#80#           =>  --  02F880
          (0, 0, 29204, 29205),
         16#81#           =>  --  02F881
          (0, 0, 29206, 29207),
         16#82#           =>  --  02F882
          (0, 0, 29208, 29209),
         16#83#           =>  --  02F883
          (0, 0, 29210, 29211),
         16#84#           =>  --  02F884
          (0, 0, 29212, 29213),
         16#85#           =>  --  02F885
          (0, 0, 29214, 29215),
         16#86#           =>  --  02F886
          (0, 0, 29216, 29217),
         16#87#           =>  --  02F887
          (0, 0, 29218, 29219),
         16#88#           =>  --  02F888
          (0, 0, 29220, 29221),
         16#89#           =>  --  02F889
          (0, 0, 29222, 29223),
         16#8A#           =>  --  02F88A
          (0, 0, 29224, 29225),
         16#8B#           =>  --  02F88B
          (0, 0, 29226, 29227),
         16#8C#           =>  --  02F88C
          (0, 0, 29228, 29229),
         16#8D#           =>  --  02F88D
          (0, 0, 29230, 29231),
         16#8E#           =>  --  02F88E
          (0, 0, 17885, 17886),
         16#8F#           =>  --  02F88F
          (0, 0, 29232, 29233),
         16#90#           =>  --  02F890
          (0, 0, 29234, 29235),
         16#91# .. 16#92# =>  --  02F891 .. 02F892
          (0, 0, 29236, 29237),
         16#93#           =>  --  02F893
          (0, 0, 29238, 29239),
         16#94# .. 16#95# =>  --  02F894 .. 02F895
          (0, 0, 29240, 29241),
         16#96#           =>  --  02F896
          (0, 0, 29242, 29243),
         16#97#           =>  --  02F897
          (0, 0, 29244, 29245),
         16#98#           =>  --  02F898
          (0, 0, 29246, 29247),
         16#99#           =>  --  02F899
          (0, 0, 29248, 29249),
         16#9A#           =>  --  02F89A
          (0, 0, 29250, 29251),
         16#9B#           =>  --  02F89B
          (0, 0, 29252, 29253),
         16#9C#           =>  --  02F89C
          (0, 0, 29254, 29255),
         16#9D#           =>  --  02F89D
          (0, 0, 29256, 29257),
         16#9E#           =>  --  02F89E
          (0, 0, 29258, 29259),
         16#9F#           =>  --  02F89F
          (0, 0, 29260, 29261),
         16#A0#           =>  --  02F8A0
          (0, 0, 29262, 29263),
         16#A1#           =>  --  02F8A1
          (0, 0, 29264, 29265),
         16#A2#           =>  --  02F8A2
          (0, 0, 29266, 29267),
         16#A3#           =>  --  02F8A3
          (0, 0, 18429, 18430),
         16#A4#           =>  --  02F8A4
          (0, 0, 29268, 29269),
         16#A5#           =>  --  02F8A5
          (0, 0, 29270, 29271),
         16#A6#           =>  --  02F8A6
          (0, 0, 29272, 29273),
         16#A7#           =>  --  02F8A7
          (0, 0, 29274, 29275),
         16#A8#           =>  --  02F8A8
          (0, 0, 18563, 18564),
         16#A9#           =>  --  02F8A9
          (0, 0, 29274, 29275),
         16#AA#           =>  --  02F8AA
          (0, 0, 29276, 29277),
         16#AB#           =>  --  02F8AB
          (0, 0, 18433, 18434),
         16#AC#           =>  --  02F8AC
          (0, 0, 29278, 29279),
         16#AD#           =>  --  02F8AD
          (0, 0, 29280, 29281),
         16#AE#           =>  --  02F8AE
          (0, 0, 29282, 29283),
         16#AF#           =>  --  02F8AF
          (0, 0, 29284, 29285),
         16#B0#           =>  --  02F8B0
          (0, 0, 18435, 18436),
         16#B1#           =>  --  02F8B1
          (0, 0, 17831, 17832),
         16#B2#           =>  --  02F8B2
          (0, 0, 29286, 29287),
         16#B3#           =>  --  02F8B3
          (0, 0, 29288, 29289),
         16#B4#           =>  --  02F8B4
          (0, 0, 29290, 29291),
         16#B5#           =>  --  02F8B5
          (0, 0, 29292, 29293),
         16#B6#           =>  --  02F8B6
          (0, 0, 29294, 29295),
         16#B7#           =>  --  02F8B7
          (0, 0, 29296, 29297),
         16#B8#           =>  --  02F8B8
          (0, 0, 29298, 29299),
         16#B9#           =>  --  02F8B9
          (0, 0, 29300, 29301),
         16#BA#           =>  --  02F8BA
          (0, 0, 29302, 29303),
         16#BB#           =>  --  02F8BB
          (0, 0, 29304, 29305),
         16#BC#           =>  --  02F8BC
          (0, 0, 29306, 29307),
         16#BD#           =>  --  02F8BD
          (0, 0, 29308, 29309),
         16#BE#           =>  --  02F8BE
          (0, 0, 29310, 29311),
         16#BF#           =>  --  02F8BF
          (0, 0, 29312, 29313),
         16#C0#           =>  --  02F8C0
          (0, 0, 29314, 29315),
         16#C1#           =>  --  02F8C1
          (0, 0, 29316, 29317),
         16#C2#           =>  --  02F8C2
          (0, 0, 29318, 29319),
         16#C3#           =>  --  02F8C3
          (0, 0, 29320, 29321),
         16#C4#           =>  --  02F8C4
          (0, 0, 29322, 29323),
         16#C5#           =>  --  02F8C5
          (0, 0, 29324, 29325),
         16#C6#           =>  --  02F8C6
          (0, 0, 29326, 29327),
         16#C7#           =>  --  02F8C7
          (0, 0, 29328, 29329),
         16#C8#           =>  --  02F8C8
          (0, 0, 18437, 18438),
         16#C9#           =>  --  02F8C9
          (0, 0, 29330, 29331),
         16#CA#           =>  --  02F8CA
          (0, 0, 29332, 29333),
         16#CB#           =>  --  02F8CB
          (0, 0, 29334, 29335),
         16#CC#           =>  --  02F8CC
          (0, 0, 29336, 29337),
         16#CD#           =>  --  02F8CD
          (0, 0, 29338, 29339),
         16#CE#           =>  --  02F8CE
          (0, 0, 29340, 29341),
         16#CF#           =>  --  02F8CF
          (0, 0, 18441, 18442),
         16#D0#           =>  --  02F8D0
          (0, 0, 29342, 29343),
         16#D1#           =>  --  02F8D1
          (0, 0, 29344, 29345),
         16#D2#           =>  --  02F8D2
          (0, 0, 29346, 29347),
         16#D3#           =>  --  02F8D3
          (0, 0, 29348, 29349),
         16#D4#           =>  --  02F8D4
          (0, 0, 29350, 29351),
         16#D5#           =>  --  02F8D5
          (0, 0, 29352, 29353),
         16#D6#           =>  --  02F8D6
          (0, 0, 29354, 29355),
         16#D7#           =>  --  02F8D7
          (0, 0, 29356, 29357),
         16#D8#           =>  --  02F8D8
          (0, 0, 17887, 17888),
         16#D9#           =>  --  02F8D9
          (0, 0, 18579, 18580),
         16#DA#           =>  --  02F8DA
          (0, 0, 29358, 29359),
         16#DB#           =>  --  02F8DB
          (0, 0, 29360, 29361),
         16#DC#           =>  --  02F8DC
          (0, 0, 29362, 29363),
         16#DD#           =>  --  02F8DD
          (0, 0, 29364, 29365),
         16#DE#           =>  --  02F8DE
          (0, 0, 29366, 29367),
         16#DF#           =>  --  02F8DF
          (0, 0, 29368, 29369),
         16#E0#           =>  --  02F8E0
          (0, 0, 29370, 29371),
         16#E1#           =>  --  02F8E1
          (0, 0, 29372, 29373),
         16#E2#           =>  --  02F8E2
          (0, 0, 18443, 18444),
         16#E3#           =>  --  02F8E3
          (0, 0, 29374, 29375),
         16#E4#           =>  --  02F8E4
          (0, 0, 29376, 29377),
         16#E5#           =>  --  02F8E5
          (0, 0, 29378, 29379),
         16#E6#           =>  --  02F8E6
          (0, 0, 29380, 29381),
         16#E7#           =>  --  02F8E7
          (0, 0, 18665, 18666),
         16#E8#           =>  --  02F8E8
          (0, 0, 29382, 29383),
         16#E9#           =>  --  02F8E9
          (0, 0, 29384, 29385),
         16#EA#           =>  --  02F8EA
          (0, 0, 29386, 29387),
         16#EB#           =>  --  02F8EB
          (0, 0, 29388, 29389),
         16#EC#           =>  --  02F8EC
          (0, 0, 29390, 29391),
         16#ED#           =>  --  02F8ED
          (0, 0, 29392, 29393),
         16#EE#           =>  --  02F8EE
          (0, 0, 29394, 29395),
         16#EF#           =>  --  02F8EF
          (0, 0, 29396, 29397),
         16#F0#           =>  --  02F8F0
          (0, 0, 29398, 29399),
         16#F1#           =>  --  02F8F1
          (0, 0, 29400, 29401),
         16#F2#           =>  --  02F8F2
          (0, 0, 29402, 29403),
         16#F3#           =>  --  02F8F3
          (0, 0, 29404, 29405),
         16#F4#           =>  --  02F8F4
          (0, 0, 29406, 29407),
         16#F5#           =>  --  02F8F5
          (0, 0, 18027, 18028),
         16#F6#           =>  --  02F8F6
          (0, 0, 29408, 29409),
         16#F7#           =>  --  02F8F7
          (0, 0, 29410, 29411),
         16#F8#           =>  --  02F8F8
          (0, 0, 29412, 29413),
         16#F9#           =>  --  02F8F9
          (0, 0, 29414, 29415),
         16#FA#           =>  --  02F8FA
          (0, 0, 29416, 29417),
         16#FB#           =>  --  02F8FB
          (0, 0, 29418, 29419),
         16#FC#           =>  --  02F8FC
          (0, 0, 29420, 29421),
         16#FD#           =>  --  02F8FD
          (0, 0, 29422, 29423),
         16#FE#           =>  --  02F8FE
          (0, 0, 29424, 29425),
         16#FF#           =>  --  02F8FF
          (0, 0, 29426, 29427),
         others           =>
          (0, 0, 29064, 29065));

   Group_02F9 : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  02F900
          (0, 0, 29428, 29429),
         16#01#           =>  --  02F901
          (0, 0, 18445, 18446),
         16#02#           =>  --  02F902
          (0, 0, 18201, 18202),
         16#03#           =>  --  02F903
          (0, 0, 29430, 29431),
         16#04#           =>  --  02F904
          (0, 0, 29432, 29433),
         16#05#           =>  --  02F905
          (0, 0, 29434, 29435),
         16#06#           =>  --  02F906
          (0, 0, 29436, 29437),
         16#07#           =>  --  02F907
          (0, 0, 29438, 29439),
         16#08#           =>  --  02F908
          (0, 0, 29440, 29441),
         16#09#           =>  --  02F909
          (0, 0, 29442, 29443),
         16#0A#           =>  --  02F90A
          (0, 0, 29444, 29445),
         16#0B#           =>  --  02F90B
          (0, 0, 18587, 18588),
         16#0C#           =>  --  02F90C
          (0, 0, 29446, 29447),
         16#0D#           =>  --  02F90D
          (0, 0, 29448, 29449),
         16#0E#           =>  --  02F90E
          (0, 0, 29450, 29451),
         16#0F#           =>  --  02F90F
          (0, 0, 29452, 29453),
         16#10#           =>  --  02F910
          (0, 0, 29454, 29455),
         16#11#           =>  --  02F911
          (0, 0, 29456, 29457),
         16#12#           =>  --  02F912
          (0, 0, 29458, 29459),
         16#13#           =>  --  02F913
          (0, 0, 29460, 29461),
         16#14#           =>  --  02F914
          (0, 0, 18589, 18590),
         16#15#           =>  --  02F915
          (0, 0, 29462, 29463),
         16#16#           =>  --  02F916
          (0, 0, 29464, 29465),
         16#17#           =>  --  02F917
          (0, 0, 29466, 29467),
         16#18#           =>  --  02F918
          (0, 0, 29468, 29469),
         16#19#           =>  --  02F919
          (0, 0, 29470, 29471),
         16#1A#           =>  --  02F91A
          (0, 0, 29472, 29473),
         16#1B#           =>  --  02F91B
          (0, 0, 29474, 29475),
         16#1C#           =>  --  02F91C
          (0, 0, 29476, 29477),
         16#1D#           =>  --  02F91D
          (0, 0, 29478, 29479),
         16#1E#           =>  --  02F91E
          (0, 0, 29480, 29481),
         16#1F#           =>  --  02F91F
          (0, 0, 29482, 29483),
         16#20#           =>  --  02F920
          (0, 0, 29484, 29485),
         16#21#           =>  --  02F921
          (0, 0, 18593, 18594),
         16#22#           =>  --  02F922
          (0, 0, 29486, 29487),
         16#23#           =>  --  02F923
          (0, 0, 29488, 29489),
         16#24#           =>  --  02F924
          (0, 0, 29490, 29491),
         16#25#           =>  --  02F925
          (0, 0, 29492, 29493),
         16#26#           =>  --  02F926
          (0, 0, 29494, 29495),
         16#27#           =>  --  02F927
          (0, 0, 29496, 29497),
         16#28#           =>  --  02F928
          (0, 0, 29498, 29499),
         16#29#           =>  --  02F929
          (0, 0, 29500, 29501),
         16#2A#           =>  --  02F92A
          (0, 0, 29502, 29503),
         16#2B#           =>  --  02F92B
          (0, 0, 29504, 29505),
         16#2E#           =>  --  02F92E
          (0, 0, 29508, 29509),
         16#2F#           =>  --  02F92F
          (0, 0, 29510, 29511),
         16#30#           =>  --  02F930
          (0, 0, 18597, 18598),
         16#31#           =>  --  02F931
          (0, 0, 29512, 29513),
         16#32#           =>  --  02F932
          (0, 0, 29514, 29515),
         16#33#           =>  --  02F933
          (0, 0, 29516, 29517),
         16#34#           =>  --  02F934
          (0, 0, 29518, 29519),
         16#35#           =>  --  02F935
          (0, 0, 29520, 29521),
         16#36#           =>  --  02F936
          (0, 0, 29522, 29523),
         16#37#           =>  --  02F937
          (0, 0, 29524, 29525),
         16#38#           =>  --  02F938
          (0, 0, 17999, 18000),
         16#39#           =>  --  02F939
          (0, 0, 29526, 29527),
         16#3A#           =>  --  02F93A
          (0, 0, 29528, 29529),
         16#3B#           =>  --  02F93B
          (0, 0, 29530, 29531),
         16#3C#           =>  --  02F93C
          (0, 0, 29532, 29533),
         16#3D#           =>  --  02F93D
          (0, 0, 29534, 29535),
         16#3E#           =>  --  02F93E
          (0, 0, 29536, 29537),
         16#3F#           =>  --  02F93F
          (0, 0, 29538, 29539),
         16#40#           =>  --  02F940
          (0, 0, 18609, 18610),
         16#41#           =>  --  02F941
          (0, 0, 29540, 29541),
         16#42#           =>  --  02F942
          (0, 0, 29542, 29543),
         16#43#           =>  --  02F943
          (0, 0, 29544, 29545),
         16#44#           =>  --  02F944
          (0, 0, 29546, 29547),
         16#45#           =>  --  02F945
          (0, 0, 29548, 29549),
         16#46# .. 16#47# =>  --  02F946 .. 02F947
          (0, 0, 29550, 29551),
         16#48#           =>  --  02F948
          (0, 0, 18611, 18612),
         16#49#           =>  --  02F949
          (0, 0, 18669, 18670),
         16#4A#           =>  --  02F94A
          (0, 0, 29552, 29553),
         16#4B#           =>  --  02F94B
          (0, 0, 29554, 29555),
         16#4C#           =>  --  02F94C
          (0, 0, 29556, 29557),
         16#4D#           =>  --  02F94D
          (0, 0, 29558, 29559),
         16#4E#           =>  --  02F94E
          (0, 0, 29560, 29561),
         16#4F#           =>  --  02F94F
          (0, 0, 17923, 17924),
         16#50#           =>  --  02F950
          (0, 0, 18615, 18616),
         16#51#           =>  --  02F951
          (0, 0, 29562, 29563),
         16#52#           =>  --  02F952
          (0, 0, 29564, 29565),
         16#53#           =>  --  02F953
          (0, 0, 18467, 18468),
         16#54#           =>  --  02F954
          (0, 0, 29566, 29567),
         16#55#           =>  --  02F955
          (0, 0, 29568, 29569),
         16#56#           =>  --  02F956
          (0, 0, 18361, 18362),
         16#57#           =>  --  02F957
          (0, 0, 29570, 29571),
         16#58#           =>  --  02F958
          (0, 0, 29572, 29573),
         16#59#           =>  --  02F959
          (0, 0, 18475, 18476),
         16#5A#           =>  --  02F95A
          (0, 0, 29574, 29575),
         16#5B#           =>  --  02F95B
          (0, 0, 29576, 29577),
         16#5C#           =>  --  02F95C
          (0, 0, 29578, 29579),
         16#5D# .. 16#5E# =>  --  02F95D .. 02F95E
          (0, 0, 29580, 29581),
         16#5F#           =>  --  02F95F
          (0, 0, 29582, 29583),
         16#60#           =>  --  02F960
          (0, 0, 29584, 29585),
         16#61#           =>  --  02F961
          (0, 0, 29586, 29587),
         16#62#           =>  --  02F962
          (0, 0, 29588, 29589),
         16#63#           =>  --  02F963
          (0, 0, 29590, 29591),
         16#64#           =>  --  02F964
          (0, 0, 29592, 29593),
         16#65#           =>  --  02F965
          (0, 0, 29594, 29595),
         16#66#           =>  --  02F966
          (0, 0, 29596, 29597),
         16#67#           =>  --  02F967
          (0, 0, 29598, 29599),
         16#68#           =>  --  02F968
          (0, 0, 29600, 29601),
         16#69#           =>  --  02F969
          (0, 0, 29602, 29603),
         16#6A#           =>  --  02F96A
          (0, 0, 29604, 29605),
         16#6B#           =>  --  02F96B
          (0, 0, 29606, 29607),
         16#6C#           =>  --  02F96C
          (0, 0, 29608, 29609),
         16#6D#           =>  --  02F96D
          (0, 0, 29610, 29611),
         16#6E#           =>  --  02F96E
          (0, 0, 29612, 29613),
         16#6F#           =>  --  02F96F
          (0, 0, 29614, 29615),
         16#70#           =>  --  02F970
          (0, 0, 29616, 29617),
         16#71#           =>  --  02F971
          (0, 0, 29618, 29619),
         16#72#           =>  --  02F972
          (0, 0, 29620, 29621),
         16#73#           =>  --  02F973
          (0, 0, 29622, 29623),
         16#74#           =>  --  02F974
          (0, 0, 29624, 29625),
         16#75#           =>  --  02F975
          (0, 0, 29626, 29627),
         16#76#           =>  --  02F976
          (0, 0, 29628, 29629),
         16#77#           =>  --  02F977
          (0, 0, 29630, 29631),
         16#78#           =>  --  02F978
          (0, 0, 29632, 29633),
         16#79#           =>  --  02F979
          (0, 0, 29634, 29635),
         16#7A#           =>  --  02F97A
          (0, 0, 18487, 18488),
         16#7B#           =>  --  02F97B
          (0, 0, 29636, 29637),
         16#7C#           =>  --  02F97C
          (0, 0, 29638, 29639),
         16#7D#           =>  --  02F97D
          (0, 0, 29640, 29641),
         16#7E#           =>  --  02F97E
          (0, 0, 29642, 29643),
         16#7F#           =>  --  02F97F
          (0, 0, 29644, 29645),
         16#80#           =>  --  02F980
          (0, 0, 29646, 29647),
         16#81#           =>  --  02F981
          (0, 0, 29648, 29649),
         16#82#           =>  --  02F982
          (0, 0, 29650, 29651),
         16#83#           =>  --  02F983
          (0, 0, 29652, 29653),
         16#84#           =>  --  02F984
          (0, 0, 29654, 29655),
         16#85#           =>  --  02F985
          (0, 0, 29656, 29657),
         16#86#           =>  --  02F986
          (0, 0, 29658, 29659),
         16#87#           =>  --  02F987
          (0, 0, 29660, 29661),
         16#88#           =>  --  02F988
          (0, 0, 29662, 29663),
         16#89#           =>  --  02F989
          (0, 0, 29664, 29665),
         16#8A#           =>  --  02F98A
          (0, 0, 29666, 29667),
         16#8B#           =>  --  02F98B
          (0, 0, 29238, 29239),
         16#8C#           =>  --  02F98C
          (0, 0, 29668, 29669),
         16#8D#           =>  --  02F98D
          (0, 0, 29670, 29671),
         16#8E#           =>  --  02F98E
          (0, 0, 29672, 29673),
         16#8F#           =>  --  02F98F
          (0, 0, 29674, 29675),
         16#90#           =>  --  02F990
          (0, 0, 29676, 29677),
         16#91#           =>  --  02F991
          (0, 0, 29678, 29679),
         16#92#           =>  --  02F992
          (0, 0, 29680, 29681),
         16#93#           =>  --  02F993
          (0, 0, 29682, 29683),
         16#94#           =>  --  02F994
          (0, 0, 29684, 29685),
         16#95#           =>  --  02F995
          (0, 0, 29686, 29687),
         16#96#           =>  --  02F996
          (0, 0, 29688, 29689),
         16#97#           =>  --  02F997
          (0, 0, 29690, 29691),
         16#98#           =>  --  02F998
          (0, 0, 18035, 18036),
         16#99#           =>  --  02F999
          (0, 0, 29692, 29693),
         16#9A#           =>  --  02F99A
          (0, 0, 29694, 29695),
         16#9B#           =>  --  02F99B
          (0, 0, 29696, 29697),
         16#9C#           =>  --  02F99C
          (0, 0, 29698, 29699),
         16#9D#           =>  --  02F99D
          (0, 0, 29700, 29701),
         16#9E#           =>  --  02F99E
          (0, 0, 29702, 29703),
         16#9F#           =>  --  02F99F
          (0, 0, 18493, 18494),
         16#A0#           =>  --  02F9A0
          (0, 0, 29704, 29705),
         16#A1#           =>  --  02F9A1
          (0, 0, 29706, 29707),
         16#A2#           =>  --  02F9A2
          (0, 0, 29708, 29709),
         16#A3#           =>  --  02F9A3
          (0, 0, 29710, 29711),
         16#A4#           =>  --  02F9A4
          (0, 0, 29712, 29713),
         16#A5#           =>  --  02F9A5
          (0, 0, 29714, 29715),
         16#A6#           =>  --  02F9A6
          (0, 0, 29716, 29717),
         16#A7#           =>  --  02F9A7
          (0, 0, 29718, 29719),
         16#A8#           =>  --  02F9A8
          (0, 0, 29720, 29721),
         16#A9#           =>  --  02F9A9
          (0, 0, 29722, 29723),
         16#AA#           =>  --  02F9AA
          (0, 0, 29724, 29725),
         16#AB#           =>  --  02F9AB
          (0, 0, 29726, 29727),
         16#AC#           =>  --  02F9AC
          (0, 0, 29728, 29729),
         16#AD#           =>  --  02F9AD
          (0, 0, 29730, 29731),
         16#AE#           =>  --  02F9AE
          (0, 0, 29732, 29733),
         16#AF#           =>  --  02F9AF
          (0, 0, 29734, 29735),
         16#B0#           =>  --  02F9B0
          (0, 0, 29736, 29737),
         16#B1#           =>  --  02F9B1
          (0, 0, 29738, 29739),
         16#B2#           =>  --  02F9B2
          (0, 0, 29740, 29741),
         16#B3#           =>  --  02F9B3
          (0, 0, 29742, 29743),
         16#B4#           =>  --  02F9B4
          (0, 0, 17913, 17914),
         16#B5#           =>  --  02F9B5
          (0, 0, 29744, 29745),
         16#B6#           =>  --  02F9B6
          (0, 0, 29746, 29747),
         16#B7#           =>  --  02F9B7
          (0, 0, 29748, 29749),
         16#B8#           =>  --  02F9B8
          (0, 0, 29750, 29751),
         16#B9#           =>  --  02F9B9
          (0, 0, 29752, 29753),
         16#BA#           =>  --  02F9BA
          (0, 0, 29754, 29755),
         16#BB#           =>  --  02F9BB
          (0, 0, 18629, 18630),
         16#BC#           =>  --  02F9BC
          (0, 0, 29756, 29757),
         16#BD#           =>  --  02F9BD
          (0, 0, 29758, 29759),
         16#BE#           =>  --  02F9BE
          (0, 0, 29760, 29761),
         16#BF#           =>  --  02F9BF
          (0, 0, 29762, 29763),
         16#C0#           =>  --  02F9C0
          (0, 0, 29764, 29765),
         16#C1#           =>  --  02F9C1
          (0, 0, 29766, 29767),
         16#C2#           =>  --  02F9C2
          (0, 0, 29768, 29769),
         16#C3#           =>  --  02F9C3
          (0, 0, 29770, 29771),
         16#C4#           =>  --  02F9C4
          (0, 0, 29772, 29773),
         16#C5#           =>  --  02F9C5
          (0, 0, 29774, 29775),
         16#C6#           =>  --  02F9C6
          (0, 0, 29776, 29777),
         16#C7#           =>  --  02F9C7
          (0, 0, 29778, 29779),
         16#C8#           =>  --  02F9C8
          (0, 0, 29780, 29781),
         16#C9#           =>  --  02F9C9
          (0, 0, 29782, 29783),
         16#CA#           =>  --  02F9CA
          (0, 0, 29784, 29785),
         16#CB#           =>  --  02F9CB
          (0, 0, 29786, 29787),
         16#CC#           =>  --  02F9CC
          (0, 0, 29788, 29789),
         16#CD#           =>  --  02F9CD
          (0, 0, 29790, 29791),
         16#CE#           =>  --  02F9CE
          (0, 0, 29792, 29793),
         16#CF#           =>  --  02F9CF
          (0, 0, 29794, 29795),
         16#D0#           =>  --  02F9D0
          (0, 0, 18639, 18640),
         16#D1#           =>  --  02F9D1
          (0, 0, 18641, 18642),
         16#D2#           =>  --  02F9D2
          (0, 0, 29796, 29797),
         16#D3#           =>  --  02F9D3
          (0, 0, 29798, 29799),
         16#D4#           =>  --  02F9D4
          (0, 0, 29800, 29801),
         16#D5#           =>  --  02F9D5
          (0, 0, 29802, 29803),
         16#D6#           =>  --  02F9D6
          (0, 0, 29804, 29805),
         16#D7#           =>  --  02F9D7
          (0, 0, 29806, 29807),
         16#D8#           =>  --  02F9D8
          (0, 0, 29808, 29809),
         16#D9#           =>  --  02F9D9
          (0, 0, 29810, 29811),
         16#DA#           =>  --  02F9DA
          (0, 0, 29812, 29813),
         16#DB#           =>  --  02F9DB
          (0, 0, 29814, 29815),
         16#DC#           =>  --  02F9DC
          (0, 0, 29816, 29817),
         16#DD#           =>  --  02F9DD
          (0, 0, 29818, 29819),
         16#DE#           =>  --  02F9DE
          (0, 0, 29820, 29821),
         16#DF#           =>  --  02F9DF
          (0, 0, 18643, 18644),
         16#E0#           =>  --  02F9E0
          (0, 0, 29822, 29823),
         16#E1#           =>  --  02F9E1
          (0, 0, 29824, 29825),
         16#E2#           =>  --  02F9E2
          (0, 0, 29826, 29827),
         16#E3#           =>  --  02F9E3
          (0, 0, 29828, 29829),
         16#E4#           =>  --  02F9E4
          (0, 0, 29830, 29831),
         16#E5#           =>  --  02F9E5
          (0, 0, 29832, 29833),
         16#E6#           =>  --  02F9E6
          (0, 0, 29834, 29835),
         16#E7#           =>  --  02F9E7
          (0, 0, 29836, 29837),
         16#E8#           =>  --  02F9E8
          (0, 0, 29838, 29839),
         16#E9#           =>  --  02F9E9
          (0, 0, 29840, 29841),
         16#EA#           =>  --  02F9EA
          (0, 0, 29842, 29843),
         16#EB#           =>  --  02F9EB
          (0, 0, 29844, 29845),
         16#EC#           =>  --  02F9EC
          (0, 0, 29846, 29847),
         16#ED#           =>  --  02F9ED
          (0, 0, 29848, 29849),
         16#EE#           =>  --  02F9EE
          (0, 0, 29850, 29851),
         16#EF#           =>  --  02F9EF
          (0, 0, 29852, 29853),
         16#F0#           =>  --  02F9F0
          (0, 0, 29854, 29855),
         16#F1#           =>  --  02F9F1
          (0, 0, 29856, 29857),
         16#F2#           =>  --  02F9F2
          (0, 0, 29858, 29859),
         16#F3#           =>  --  02F9F3
          (0, 0, 29860, 29861),
         16#F4#           =>  --  02F9F4
          (0, 0, 29862, 29863),
         16#F5#           =>  --  02F9F5
          (0, 0, 29864, 29865),
         16#F6#           =>  --  02F9F6
          (0, 0, 29866, 29867),
         16#F7#           =>  --  02F9F7
          (0, 0, 29868, 29869),
         16#F8#           =>  --  02F9F8
          (0, 0, 29870, 29871),
         16#F9#           =>  --  02F9F9
          (0, 0, 29872, 29873),
         16#FA#           =>  --  02F9FA
          (0, 0, 29874, 29875),
         16#FB#           =>  --  02F9FB
          (0, 0, 29876, 29877),
         16#FC#           =>  --  02F9FC
          (0, 0, 29878, 29879),
         16#FD#           =>  --  02F9FD
          (0, 0, 29880, 29881),
         16#FE# .. 16#FF# =>  --  02F9FE .. 02F9FF
          (0, 0, 18655, 18656),
         others           =>
          (0, 0, 29506, 29507));

   Group_02FA : aliased constant Collation_Second_Stage
     := (16#00#           =>  --  02FA00
          (0, 0, 29882, 29883),
         16#01#           =>  --  02FA01
          (0, 0, 29884, 29885),
         16#02#           =>  --  02FA02
          (0, 0, 29886, 29887),
         16#03#           =>  --  02FA03
          (0, 0, 29888, 29889),
         16#04#           =>  --  02FA04
          (0, 0, 29890, 29891),
         16#05#           =>  --  02FA05
          (0, 0, 29892, 29893),
         16#06#           =>  --  02FA06
          (0, 0, 29894, 29895),
         16#07#           =>  --  02FA07
          (0, 0, 29896, 29897),
         16#08#           =>  --  02FA08
          (0, 0, 29898, 29899),
         16#09#           =>  --  02FA09
          (0, 0, 29900, 29901),
         16#0A#           =>  --  02FA0A
          (0, 0, 18657, 18658),
         16#0B#           =>  --  02FA0B
          (0, 0, 29902, 29903),
         16#0C#           =>  --  02FA0C
          (0, 0, 29904, 29905),
         16#0D#           =>  --  02FA0D
          (0, 0, 29906, 29907),
         16#0E#           =>  --  02FA0E
          (0, 0, 29908, 29909),
         16#0F#           =>  --  02FA0F
          (0, 0, 29910, 29911),
         16#10#           =>  --  02FA10
          (0, 0, 29912, 29913),
         16#11#           =>  --  02FA11
          (0, 0, 29914, 29915),
         16#12#           =>  --  02FA12
          (0, 0, 29916, 29917),
         16#13#           =>  --  02FA13
          (0, 0, 29918, 29919),
         16#14#           =>  --  02FA14
          (0, 0, 29920, 29921),
         16#15#           =>  --  02FA15
          (0, 0, 29922, 29923),
         16#16#           =>  --  02FA16
          (0, 0, 29924, 29925),
         16#17#           =>  --  02FA17
          (0, 0, 29926, 29927),
         16#18#           =>  --  02FA18
          (0, 0, 29928, 29929),
         16#19#           =>  --  02FA19
          (0, 0, 29930, 29931),
         16#1A#           =>  --  02FA1A
          (0, 0, 29932, 29933),
         16#1B#           =>  --  02FA1B
          (0, 0, 29934, 29935),
         16#1C#           =>  --  02FA1C
          (0, 0, 29936, 29937),
         16#1D#           =>  --  02FA1D
          (0, 0, 29938, 29939),
         others           =>
          (0, 0, 0, 0));

   Group_0E00 : aliased constant Collation_Second_Stage
     := (16#01#           =>  --  0E0001
          (0, 0, 1, 1),
         16#20# .. 16#7F# =>  --  0E0020 .. 0E007F
          (0, 0, 1, 1),
         others           =>
          (0, 0, 0, 0));

   Group_0E01 : aliased constant Collation_Second_Stage
     := (16#F0# .. 16#FF# =>  --  0E01F0 .. 0E01FF
          (0, 0, 0, 0),
         others           =>
          (0, 0, 1, 1));

   Collation : aliased constant Collation_First_Stage
     := (16#0000# => Group_0000'Access, 16#0001# => Group_0001'Access,
         16#0002# => Group_0002'Access, 16#0003# => Group_0003'Access,
         16#0004# => Group_0004'Access, 16#0005# => Group_0005'Access,
         16#0006# => Group_0006'Access, 16#0007# => Group_0007'Access,
         16#0008# => Group_0008'Access, 16#0009# => Group_0009'Access,
         16#000A# => Group_000A'Access, 16#000B# => Group_000B'Access,
         16#000C# => Group_000C'Access, 16#000D# => Group_000D'Access,
         16#000E# => Group_000E'Access, 16#000F# => Group_000F'Access,
         16#0010# => Group_0010'Access, 16#0011# => Group_0011'Access,
         16#0012# => Group_0012'Access, 16#0013# => Group_0013'Access,
         16#0014# => Group_0014'Access, 16#0015# => Group_0015'Access,
         16#0016# => Group_0016'Access, 16#0017# => Group_0017'Access,
         16#0018# => Group_0018'Access, 16#0019# => Group_0019'Access,
         16#001A# => Group_001A'Access, 16#001B# => Group_001B'Access,
         16#001C# => Group_001C'Access, 16#001D# => Group_001D'Access,
         16#001E# => Group_001E'Access, 16#001F# => Group_001F'Access,
         16#0020# => Group_0020'Access, 16#0021# => Group_0021'Access,
         16#0022# => Group_0022'Access, 16#0023# => Group_0023'Access,
         16#0024# => Group_0024'Access, 16#0025# => Group_0025'Access,
         16#0026# => Group_0026'Access, 16#0027# => Group_0027'Access,
         16#0028# => Group_0028'Access, 16#0029# => Group_0029'Access,
         16#002A# => Group_002A'Access, 16#002B# => Group_002B'Access,
         16#002C# => Group_002C'Access, 16#002D# => Group_002D'Access,
         16#002E# => Group_002E'Access, 16#002F# => Group_002F'Access,
         16#0030# => Group_0030'Access, 16#0031# => Group_0031'Access,
         16#0032# => Group_0032'Access, 16#0033# => Group_0033'Access,
         16#004D# => Group_004D'Access, 16#00A0# => Group_00A0'Access,
         16#00A1# => Group_00A1'Access, 16#00A2# => Group_00A2'Access,
         16#00A3# => Group_00A3'Access, 16#00A4# => Group_00A4'Access,
         16#00A5# => Group_00A5'Access, 16#00A6# => Group_00A6'Access,
         16#00A7# => Group_00A7'Access, 16#00A8# => Group_00A8'Access,
         16#00A9# => Group_00A9'Access, 16#00AA# => Group_00AA'Access,
         16#00AB# => Group_00AB'Access, 16#00D7# => Group_00D7'Access,
         16#00F9# => Group_00F9'Access, 16#00FA# => Group_00FA'Access,
         16#00FB# => Group_00FB'Access, 16#00FC# => Group_00FC'Access,
         16#00FD# => Group_00FD'Access, 16#00FE# => Group_00FE'Access,
         16#00FF# => Group_00FF'Access, 16#0100# => Group_0100'Access,
         16#0101# => Group_0101'Access, 16#0102# => Group_0102'Access,
         16#0103# => Group_0103'Access, 16#0104# => Group_0104'Access,
         16#0105# => Group_0105'Access, 16#0106# => Group_0106'Access,
         16#0107# => Group_0107'Access, 16#0108# => Group_0108'Access,
         16#0109# => Group_0109'Access, 16#010A# => Group_010A'Access,
         16#010B# => Group_010B'Access, 16#010C# => Group_010C'Access,
         16#010E# => Group_010E'Access, 16#0110# => Group_0110'Access,
         16#0111# => Group_0111'Access, 16#0112# => Group_0112'Access,
         16#0113# => Group_0113'Access, 16#0114# => Group_0114'Access,
         16#0115# => Group_0115'Access, 16#0116# => Group_0116'Access,
         16#0118# => Group_0118'Access, 16#011A# => Group_011A'Access,
         16#0120# => Group_0120'Access, 16#0121# => Group_0121'Access,
         16#0122# => Group_0122'Access, 16#0123# => Group_0123'Access,
         16#0124# => Group_0124'Access, 16#0130# => Group_0130'Access,
         16#0131# => Group_0131'Access, 16#0132# => Group_0132'Access,
         16#0133# => Group_0133'Access, 16#0134# => Group_0134'Access,
         16#0168# => Group_0168'Access, 16#0169# => Group_0169'Access,
         16#016A# => Group_016A'Access, 16#016B# => Group_016B'Access,
         16#016F# => Group_016F'Access, 16#01B0# => Group_01B0'Access,
         16#01BC# => Group_01BC'Access, 16#01D0# => Group_01D0'Access,
         16#01D1# => Group_01D1'Access, 16#01D2# => Group_01D2'Access,
         16#01D3# => Group_01D3'Access, 16#01D4# => Group_01D4'Access,
         16#01D5# => Group_01D5'Access, 16#01D6# => Group_01D6'Access,
         16#01D7# => Group_01D7'Access, 16#01E8# => Group_01E8'Access,
         16#01EE# => Group_01EE'Access, 16#01F0# => Group_01F0'Access,
         16#01F1# => Group_01F1'Access, 16#01F2# => Group_01F2'Access,
         16#01F3# => Group_01F3'Access, 16#01F4# => Group_01F4'Access,
         16#01F5# => Group_01F5'Access, 16#01F6# => Group_01F6'Access,
         16#01F7# => Group_01F7'Access, 16#01F8# => Group_01F8'Access,
         16#02F8# => Group_02F8'Access, 16#02F9# => Group_02F9'Access,
         16#02FA# => Group_02FA'Access, 16#0E00# => Group_0E00'Access,
         16#0E01# => Group_0E01'Access, others   => Group_0034'Access);

end Matreshka.Internals.Unicode.Ucd.Colls;
