------------------------------------------------------------------------------
--                                                                          --
--                            Matreshka Project                             --
--                                                                          --
--        Localization, Internationalization, Globalization for Ada         --
--                                                                          --
--                        Runtime Library Component                         --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2009-2015, Vadim Godunko <vgodunko@gmail.com>                --
-- All rights reserved.                                                     --
--                                                                          --
-- Redistribution and use in source and binary forms, with or without       --
-- modification, are permitted provided that the following conditions       --
-- are met:                                                                 --
--                                                                          --
--  * Redistributions of source code must retain the above copyright        --
--    notice, this list of conditions and the following disclaimer.         --
--                                                                          --
--  * Redistributions in binary form must reproduce the above copyright     --
--    notice, this list of conditions and the following disclaimer in the   --
--    documentation and/or other materials provided with the distribution.  --
--                                                                          --
--  * Neither the name of the Vadim Godunko, IE nor the names of its        --
--    contributors may be used to endorse or promote products derived from  --
--    this software without specific prior written permission.              --
--                                                                          --
-- THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS      --
-- "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT        --
-- LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR    --
-- A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT     --
-- HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,   --
-- SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED --
-- TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR   --
-- PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF   --
-- LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING     --
-- NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS       --
-- SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.             --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 5318 $ $Date: 2015-05-16 01:29:51 +0200 (Sat, 16 May 2015) $
------------------------------------------------------------------------------

package Matreshka.Internals.Unicode.Ucd.Norms is

   pragma Preelaborate;

   Decomposition_Data : aliased constant Code_Point_Sequence
     := (16#000020#, 16#000020#, 16#000308#, 16#000061#, 16#000020#,
         16#000304#, 16#000032#, 16#000033#, 16#000020#, 16#000301#,
         16#0003BC#, 16#000020#, 16#000327#, 16#000031#, 16#00006F#,
         16#000031#, 16#002044#, 16#000034#, 16#000031#, 16#002044#,
         16#000032#, 16#000033#, 16#002044#, 16#000034#, 16#000041#,
         16#000300#, 16#000041#, 16#000301#, 16#000041#, 16#000302#,
         16#000041#, 16#000303#, 16#000041#, 16#000308#, 16#000041#,
         16#00030A#, 16#000043#, 16#000327#, 16#000045#, 16#000300#,
         16#000045#, 16#000301#, 16#000045#, 16#000302#, 16#000045#,
         16#000308#, 16#000049#, 16#000300#, 16#000049#, 16#000301#,
         16#000049#, 16#000302#, 16#000049#, 16#000308#, 16#00004E#,
         16#000303#, 16#00004F#, 16#000300#, 16#00004F#, 16#000301#,
         16#00004F#, 16#000302#, 16#00004F#, 16#000303#, 16#00004F#,
         16#000308#, 16#000055#, 16#000300#, 16#000055#, 16#000301#,
         16#000055#, 16#000302#, 16#000055#, 16#000308#, 16#000059#,
         16#000301#, 16#000061#, 16#000300#, 16#000061#, 16#000301#,
         16#000061#, 16#000302#, 16#000061#, 16#000303#, 16#000061#,
         16#000308#, 16#000061#, 16#00030A#, 16#000063#, 16#000327#,
         16#000065#, 16#000300#, 16#000065#, 16#000301#, 16#000065#,
         16#000302#, 16#000065#, 16#000308#, 16#000069#, 16#000300#,
         16#000069#, 16#000301#, 16#000069#, 16#000302#, 16#000069#,
         16#000308#, 16#00006E#, 16#000303#, 16#00006F#, 16#000300#,
         16#00006F#, 16#000301#, 16#00006F#, 16#000302#, 16#00006F#,
         16#000303#, 16#00006F#, 16#000308#, 16#000075#, 16#000300#,
         16#000075#, 16#000301#, 16#000075#, 16#000302#, 16#000075#,
         16#000308#, 16#000079#, 16#000301#, 16#000079#, 16#000308#,
         16#000041#, 16#000304#, 16#000061#, 16#000304#, 16#000041#,
         16#000306#, 16#000061#, 16#000306#, 16#000041#, 16#000328#,
         16#000061#, 16#000328#, 16#000043#, 16#000301#, 16#000063#,
         16#000301#, 16#000043#, 16#000302#, 16#000063#, 16#000302#,
         16#000043#, 16#000307#, 16#000063#, 16#000307#, 16#000043#,
         16#00030C#, 16#000063#, 16#00030C#, 16#000044#, 16#00030C#,
         16#000064#, 16#00030C#, 16#000045#, 16#000304#, 16#000065#,
         16#000304#, 16#000045#, 16#000306#, 16#000065#, 16#000306#,
         16#000045#, 16#000307#, 16#000065#, 16#000307#, 16#000045#,
         16#000328#, 16#000065#, 16#000328#, 16#000045#, 16#00030C#,
         16#000065#, 16#00030C#, 16#000047#, 16#000302#, 16#000067#,
         16#000302#, 16#000047#, 16#000306#, 16#000067#, 16#000306#,
         16#000047#, 16#000307#, 16#000067#, 16#000307#, 16#000047#,
         16#000327#, 16#000067#, 16#000327#, 16#000048#, 16#000302#,
         16#000068#, 16#000302#, 16#000049#, 16#000303#, 16#000069#,
         16#000303#, 16#000049#, 16#000304#, 16#000069#, 16#000304#,
         16#000049#, 16#000306#, 16#000069#, 16#000306#, 16#000049#,
         16#000328#, 16#000069#, 16#000328#, 16#000049#, 16#000307#,
         16#000049#, 16#00004A#, 16#000069#, 16#00006A#, 16#00004A#,
         16#000302#, 16#00006A#, 16#000302#, 16#00004B#, 16#000327#,
         16#00006B#, 16#000327#, 16#00004C#, 16#000301#, 16#00006C#,
         16#000301#, 16#00004C#, 16#000327#, 16#00006C#, 16#000327#,
         16#00004C#, 16#00030C#, 16#00006C#, 16#00030C#, 16#00004C#,
         16#0000B7#, 16#00006C#, 16#0000B7#, 16#00004E#, 16#000301#,
         16#00006E#, 16#000301#, 16#00004E#, 16#000327#, 16#00006E#,
         16#000327#, 16#00004E#, 16#00030C#, 16#00006E#, 16#00030C#,
         16#0002BC#, 16#00006E#, 16#00004F#, 16#000304#, 16#00006F#,
         16#000304#, 16#00004F#, 16#000306#, 16#00006F#, 16#000306#,
         16#00004F#, 16#00030B#, 16#00006F#, 16#00030B#, 16#000052#,
         16#000301#, 16#000072#, 16#000301#, 16#000052#, 16#000327#,
         16#000072#, 16#000327#, 16#000052#, 16#00030C#, 16#000072#,
         16#00030C#, 16#000053#, 16#000301#, 16#000073#, 16#000301#,
         16#000053#, 16#000302#, 16#000073#, 16#000302#, 16#000053#,
         16#000327#, 16#000073#, 16#000327#, 16#000053#, 16#00030C#,
         16#000073#, 16#00030C#, 16#000054#, 16#000327#, 16#000074#,
         16#000327#, 16#000054#, 16#00030C#, 16#000074#, 16#00030C#,
         16#000055#, 16#000303#, 16#000075#, 16#000303#, 16#000055#,
         16#000304#, 16#000075#, 16#000304#, 16#000055#, 16#000306#,
         16#000075#, 16#000306#, 16#000055#, 16#00030A#, 16#000075#,
         16#00030A#, 16#000055#, 16#00030B#, 16#000075#, 16#00030B#,
         16#000055#, 16#000328#, 16#000075#, 16#000328#, 16#000057#,
         16#000302#, 16#000077#, 16#000302#, 16#000059#, 16#000302#,
         16#000079#, 16#000302#, 16#000059#, 16#000308#, 16#00005A#,
         16#000301#, 16#00007A#, 16#000301#, 16#00005A#, 16#000307#,
         16#00007A#, 16#000307#, 16#00005A#, 16#00030C#, 16#00007A#,
         16#00030C#, 16#00004F#, 16#00031B#, 16#00006F#, 16#00031B#,
         16#000055#, 16#00031B#, 16#000075#, 16#00031B#, 16#000044#,
         16#00005A#, 16#00030C#, 16#000044#, 16#00007A#, 16#00030C#,
         16#000064#, 16#00007A#, 16#00030C#, 16#00004C#, 16#00004A#,
         16#00004C#, 16#00006A#, 16#00006C#, 16#00006A#, 16#00004E#,
         16#00004A#, 16#00004E#, 16#00006A#, 16#00006E#, 16#00006A#,
         16#000041#, 16#00030C#, 16#000061#, 16#00030C#, 16#000049#,
         16#00030C#, 16#000069#, 16#00030C#, 16#00004F#, 16#00030C#,
         16#00006F#, 16#00030C#, 16#000055#, 16#00030C#, 16#000075#,
         16#00030C#, 16#000055#, 16#000308#, 16#000304#, 16#000075#,
         16#000308#, 16#000304#, 16#000055#, 16#000308#, 16#000301#,
         16#000075#, 16#000308#, 16#000301#, 16#000055#, 16#000308#,
         16#00030C#, 16#000075#, 16#000308#, 16#00030C#, 16#000055#,
         16#000308#, 16#000300#, 16#000075#, 16#000308#, 16#000300#,
         16#000041#, 16#000308#, 16#000304#, 16#000061#, 16#000308#,
         16#000304#, 16#000041#, 16#000307#, 16#000304#, 16#000061#,
         16#000307#, 16#000304#, 16#0000C6#, 16#000304#, 16#0000E6#,
         16#000304#, 16#000047#, 16#00030C#, 16#000067#, 16#00030C#,
         16#00004B#, 16#00030C#, 16#00006B#, 16#00030C#, 16#00004F#,
         16#000328#, 16#00006F#, 16#000328#, 16#00004F#, 16#000328#,
         16#000304#, 16#00006F#, 16#000328#, 16#000304#, 16#0001B7#,
         16#00030C#, 16#000292#, 16#00030C#, 16#00006A#, 16#00030C#,
         16#000047#, 16#000301#, 16#000067#, 16#000301#, 16#00004E#,
         16#000300#, 16#00006E#, 16#000300#, 16#000041#, 16#00030A#,
         16#000301#, 16#000061#, 16#00030A#, 16#000301#, 16#0000C6#,
         16#000301#, 16#0000E6#, 16#000301#, 16#0000D8#, 16#000301#,
         16#0000F8#, 16#000301#, 16#000041#, 16#00030F#, 16#000061#,
         16#00030F#, 16#000041#, 16#000311#, 16#000061#, 16#000311#,
         16#000045#, 16#00030F#, 16#000065#, 16#00030F#, 16#000045#,
         16#000311#, 16#000065#, 16#000311#, 16#000049#, 16#00030F#,
         16#000069#, 16#00030F#, 16#000049#, 16#000311#, 16#000069#,
         16#000311#, 16#00004F#, 16#00030F#, 16#00006F#, 16#00030F#,
         16#00004F#, 16#000311#, 16#00006F#, 16#000311#, 16#000052#,
         16#00030F#, 16#000072#, 16#00030F#, 16#000052#, 16#000311#,
         16#000072#, 16#000311#, 16#000055#, 16#00030F#, 16#000075#,
         16#00030F#, 16#000055#, 16#000311#, 16#000075#, 16#000311#,
         16#000053#, 16#000326#, 16#000073#, 16#000326#, 16#000054#,
         16#000326#, 16#000074#, 16#000326#, 16#000048#, 16#00030C#,
         16#000068#, 16#00030C#, 16#000045#, 16#000327#, 16#000065#,
         16#000327#, 16#00004F#, 16#000308#, 16#000304#, 16#00006F#,
         16#000308#, 16#000304#, 16#00004F#, 16#000303#, 16#000304#,
         16#00006F#, 16#000303#, 16#000304#, 16#00004F#, 16#000307#,
         16#00006F#, 16#000307#, 16#00004F#, 16#000307#, 16#000304#,
         16#00006F#, 16#000307#, 16#000304#, 16#000059#, 16#000304#,
         16#000079#, 16#000304#, 16#000266#, 16#000279#, 16#00027B#,
         16#000281#, 16#000020#, 16#000306#, 16#000020#, 16#000307#,
         16#000020#, 16#00030A#, 16#000020#, 16#000328#, 16#000020#,
         16#000303#, 16#000020#, 16#00030B#, 16#000263#, 16#000078#,
         16#000295#, 16#000313#, 16#0002B9#, 16#000020#, 16#000345#,
         16#00003B#, 16#000020#, 16#000308#, 16#000301#, 16#0000A8#,
         16#000301#, 16#000391#, 16#000301#, 16#000395#, 16#000301#,
         16#000397#, 16#000301#, 16#000399#, 16#000301#, 16#00039F#,
         16#000301#, 16#0003A5#, 16#000301#, 16#0003A9#, 16#000301#,
         16#0003B9#, 16#000308#, 16#000301#, 16#000399#, 16#000308#,
         16#0003A5#, 16#000308#, 16#0003B1#, 16#000301#, 16#0003B5#,
         16#000301#, 16#0003B7#, 16#000301#, 16#0003B9#, 16#000301#,
         16#0003C5#, 16#000308#, 16#000301#, 16#0003BF#, 16#000301#,
         16#0003C5#, 16#000301#, 16#0003C9#, 16#000301#, 16#0003B2#,
         16#0003B8#, 16#0003D2#, 16#000301#, 16#0003D2#, 16#000308#,
         16#0003C6#, 16#0003C0#, 16#0003BA#, 16#0003C1#, 16#0003C2#,
         16#000398#, 16#0003A3#, 16#000415#, 16#000300#, 16#000415#,
         16#000308#, 16#000413#, 16#000301#, 16#000406#, 16#000308#,
         16#00041A#, 16#000301#, 16#000418#, 16#000300#, 16#000423#,
         16#000306#, 16#000418#, 16#000306#, 16#000438#, 16#000306#,
         16#000435#, 16#000300#, 16#000435#, 16#000308#, 16#000433#,
         16#000301#, 16#000456#, 16#000308#, 16#00043A#, 16#000301#,
         16#000438#, 16#000300#, 16#000443#, 16#000306#, 16#000474#,
         16#00030F#, 16#000475#, 16#00030F#, 16#000416#, 16#000306#,
         16#000436#, 16#000306#, 16#000410#, 16#000306#, 16#000430#,
         16#000306#, 16#000410#, 16#000308#, 16#000430#, 16#000308#,
         16#000415#, 16#000306#, 16#000435#, 16#000306#, 16#0004D8#,
         16#000308#, 16#0004D9#, 16#000308#, 16#000416#, 16#000308#,
         16#000436#, 16#000308#, 16#000417#, 16#000308#, 16#000437#,
         16#000308#, 16#000418#, 16#000304#, 16#000438#, 16#000304#,
         16#000418#, 16#000308#, 16#000438#, 16#000308#, 16#00041E#,
         16#000308#, 16#00043E#, 16#000308#, 16#0004E8#, 16#000308#,
         16#0004E9#, 16#000308#, 16#00042D#, 16#000308#, 16#00044D#,
         16#000308#, 16#000423#, 16#000304#, 16#000443#, 16#000304#,
         16#000423#, 16#000308#, 16#000443#, 16#000308#, 16#000423#,
         16#00030B#, 16#000443#, 16#00030B#, 16#000427#, 16#000308#,
         16#000447#, 16#000308#, 16#00042B#, 16#000308#, 16#00044B#,
         16#000308#, 16#000565#, 16#000582#, 16#000627#, 16#000653#,
         16#000627#, 16#000654#, 16#000648#, 16#000654#, 16#000627#,
         16#000655#, 16#00064A#, 16#000654#, 16#000627#, 16#000674#,
         16#000648#, 16#000674#, 16#0006C7#, 16#000674#, 16#00064A#,
         16#000674#, 16#0006D5#, 16#000654#, 16#0006C1#, 16#000654#,
         16#0006D2#, 16#000654#, 16#000928#, 16#00093C#, 16#000930#,
         16#00093C#, 16#000933#, 16#00093C#, 16#000915#, 16#00093C#,
         16#000916#, 16#00093C#, 16#000917#, 16#00093C#, 16#00091C#,
         16#00093C#, 16#000921#, 16#00093C#, 16#000922#, 16#00093C#,
         16#00092B#, 16#00093C#, 16#00092F#, 16#00093C#, 16#0009C7#,
         16#0009BE#, 16#0009C7#, 16#0009D7#, 16#0009A1#, 16#0009BC#,
         16#0009A2#, 16#0009BC#, 16#0009AF#, 16#0009BC#, 16#000A32#,
         16#000A3C#, 16#000A38#, 16#000A3C#, 16#000A16#, 16#000A3C#,
         16#000A17#, 16#000A3C#, 16#000A1C#, 16#000A3C#, 16#000A2B#,
         16#000A3C#, 16#000B47#, 16#000B56#, 16#000B47#, 16#000B3E#,
         16#000B47#, 16#000B57#, 16#000B21#, 16#000B3C#, 16#000B22#,
         16#000B3C#, 16#000B92#, 16#000BD7#, 16#000BC6#, 16#000BBE#,
         16#000BC7#, 16#000BBE#, 16#000BC6#, 16#000BD7#, 16#000C46#,
         16#000C56#, 16#000CBF#, 16#000CD5#, 16#000CC6#, 16#000CD5#,
         16#000CC6#, 16#000CD6#, 16#000CC6#, 16#000CC2#, 16#000CC6#,
         16#000CC2#, 16#000CD5#, 16#000D46#, 16#000D3E#, 16#000D47#,
         16#000D3E#, 16#000D46#, 16#000D57#, 16#000DD9#, 16#000DCA#,
         16#000DD9#, 16#000DCF#, 16#000DD9#, 16#000DCF#, 16#000DCA#,
         16#000DD9#, 16#000DDF#, 16#000E4D#, 16#000E32#, 16#000ECD#,
         16#000EB2#, 16#000EAB#, 16#000E99#, 16#000EAB#, 16#000EA1#,
         16#000F0B#, 16#000F42#, 16#000FB7#, 16#000F4C#, 16#000FB7#,
         16#000F51#, 16#000FB7#, 16#000F56#, 16#000FB7#, 16#000F5B#,
         16#000FB7#, 16#000F40#, 16#000FB5#, 16#000F71#, 16#000F72#,
         16#000F71#, 16#000F74#, 16#000FB2#, 16#000F80#, 16#000FB2#,
         16#000F71#, 16#000F80#, 16#000FB3#, 16#000F80#, 16#000FB3#,
         16#000F71#, 16#000F80#, 16#000F92#, 16#000FB7#, 16#000F9C#,
         16#000FB7#, 16#000FA1#, 16#000FB7#, 16#000FA6#, 16#000FB7#,
         16#000FAB#, 16#000FB7#, 16#000F90#, 16#000FB5#, 16#001025#,
         16#00102E#, 16#0010DC#, 16#001B05#, 16#001B35#, 16#001B07#,
         16#001B35#, 16#001B09#, 16#001B35#, 16#001B0B#, 16#001B35#,
         16#001B0D#, 16#001B35#, 16#001B11#, 16#001B35#, 16#001B3A#,
         16#001B35#, 16#001B3C#, 16#001B35#, 16#001B3E#, 16#001B35#,
         16#001B3F#, 16#001B35#, 16#001B42#, 16#001B35#, 16#000042#,
         16#00018E#, 16#00004D#, 16#000222#, 16#000050#, 16#000250#,
         16#000251#, 16#001D02#, 16#000062#, 16#000259#, 16#00025B#,
         16#00025C#, 16#00006D#, 16#00014B#, 16#000254#, 16#001D16#,
         16#001D17#, 16#000070#, 16#001D1D#, 16#00026F#, 16#000076#,
         16#001D25#, 16#0003B3#, 16#0003B4#, 16#0003C7#, 16#00043D#,
         16#000252#, 16#000255#, 16#0000F0#, 16#000066#, 16#00025F#,
         16#000261#, 16#000265#, 16#000268#, 16#000269#, 16#00026A#,
         16#001D7B#, 16#00029D#, 16#00026D#, 16#001D85#, 16#00029F#,
         16#000271#, 16#000270#, 16#000272#, 16#000273#, 16#000274#,
         16#000275#, 16#000278#, 16#000282#, 16#000283#, 16#0001AB#,
         16#000289#, 16#00028A#, 16#001D1C#, 16#00028B#, 16#00028C#,
         16#000290#, 16#000291#, 16#000041#, 16#000325#, 16#000061#,
         16#000325#, 16#000042#, 16#000307#, 16#000062#, 16#000307#,
         16#000042#, 16#000323#, 16#000062#, 16#000323#, 16#000042#,
         16#000331#, 16#000062#, 16#000331#, 16#000043#, 16#000327#,
         16#000301#, 16#000063#, 16#000327#, 16#000301#, 16#000044#,
         16#000307#, 16#000064#, 16#000307#, 16#000044#, 16#000323#,
         16#000064#, 16#000323#, 16#000044#, 16#000331#, 16#000064#,
         16#000331#, 16#000044#, 16#000327#, 16#000064#, 16#000327#,
         16#000044#, 16#00032D#, 16#000064#, 16#00032D#, 16#000045#,
         16#000304#, 16#000300#, 16#000065#, 16#000304#, 16#000300#,
         16#000045#, 16#000304#, 16#000301#, 16#000065#, 16#000304#,
         16#000301#, 16#000045#, 16#00032D#, 16#000065#, 16#00032D#,
         16#000045#, 16#000330#, 16#000065#, 16#000330#, 16#000045#,
         16#000327#, 16#000306#, 16#000065#, 16#000327#, 16#000306#,
         16#000046#, 16#000307#, 16#000066#, 16#000307#, 16#000047#,
         16#000304#, 16#000067#, 16#000304#, 16#000048#, 16#000307#,
         16#000068#, 16#000307#, 16#000048#, 16#000323#, 16#000068#,
         16#000323#, 16#000048#, 16#000308#, 16#000068#, 16#000308#,
         16#000048#, 16#000327#, 16#000068#, 16#000327#, 16#000048#,
         16#00032E#, 16#000068#, 16#00032E#, 16#000049#, 16#000330#,
         16#000069#, 16#000330#, 16#000049#, 16#000308#, 16#000301#,
         16#000069#, 16#000308#, 16#000301#, 16#00004B#, 16#000301#,
         16#00006B#, 16#000301#, 16#00004B#, 16#000323#, 16#00006B#,
         16#000323#, 16#00004B#, 16#000331#, 16#00006B#, 16#000331#,
         16#00004C#, 16#000323#, 16#00006C#, 16#000323#, 16#00004C#,
         16#000323#, 16#000304#, 16#00006C#, 16#000323#, 16#000304#,
         16#00004C#, 16#000331#, 16#00006C#, 16#000331#, 16#00004C#,
         16#00032D#, 16#00006C#, 16#00032D#, 16#00004D#, 16#000301#,
         16#00006D#, 16#000301#, 16#00004D#, 16#000307#, 16#00006D#,
         16#000307#, 16#00004D#, 16#000323#, 16#00006D#, 16#000323#,
         16#00004E#, 16#000307#, 16#00006E#, 16#000307#, 16#00004E#,
         16#000323#, 16#00006E#, 16#000323#, 16#00004E#, 16#000331#,
         16#00006E#, 16#000331#, 16#00004E#, 16#00032D#, 16#00006E#,
         16#00032D#, 16#00004F#, 16#000303#, 16#000301#, 16#00006F#,
         16#000303#, 16#000301#, 16#00004F#, 16#000303#, 16#000308#,
         16#00006F#, 16#000303#, 16#000308#, 16#00004F#, 16#000304#,
         16#000300#, 16#00006F#, 16#000304#, 16#000300#, 16#00004F#,
         16#000304#, 16#000301#, 16#00006F#, 16#000304#, 16#000301#,
         16#000050#, 16#000301#, 16#000070#, 16#000301#, 16#000050#,
         16#000307#, 16#000070#, 16#000307#, 16#000052#, 16#000307#,
         16#000072#, 16#000307#, 16#000052#, 16#000323#, 16#000072#,
         16#000323#, 16#000052#, 16#000323#, 16#000304#, 16#000072#,
         16#000323#, 16#000304#, 16#000052#, 16#000331#, 16#000072#,
         16#000331#, 16#000053#, 16#000307#, 16#000073#, 16#000307#,
         16#000053#, 16#000323#, 16#000073#, 16#000323#, 16#000053#,
         16#000301#, 16#000307#, 16#000073#, 16#000301#, 16#000307#,
         16#000053#, 16#00030C#, 16#000307#, 16#000073#, 16#00030C#,
         16#000307#, 16#000053#, 16#000323#, 16#000307#, 16#000073#,
         16#000323#, 16#000307#, 16#000054#, 16#000307#, 16#000074#,
         16#000307#, 16#000054#, 16#000323#, 16#000074#, 16#000323#,
         16#000054#, 16#000331#, 16#000074#, 16#000331#, 16#000054#,
         16#00032D#, 16#000074#, 16#00032D#, 16#000055#, 16#000324#,
         16#000075#, 16#000324#, 16#000055#, 16#000330#, 16#000075#,
         16#000330#, 16#000055#, 16#00032D#, 16#000075#, 16#00032D#,
         16#000055#, 16#000303#, 16#000301#, 16#000075#, 16#000303#,
         16#000301#, 16#000055#, 16#000304#, 16#000308#, 16#000075#,
         16#000304#, 16#000308#, 16#000056#, 16#000303#, 16#000076#,
         16#000303#, 16#000056#, 16#000323#, 16#000076#, 16#000323#,
         16#000057#, 16#000300#, 16#000077#, 16#000300#, 16#000057#,
         16#000301#, 16#000077#, 16#000301#, 16#000057#, 16#000308#,
         16#000077#, 16#000308#, 16#000057#, 16#000307#, 16#000077#,
         16#000307#, 16#000057#, 16#000323#, 16#000077#, 16#000323#,
         16#000058#, 16#000307#, 16#000078#, 16#000307#, 16#000058#,
         16#000308#, 16#000078#, 16#000308#, 16#000059#, 16#000307#,
         16#000079#, 16#000307#, 16#00005A#, 16#000302#, 16#00007A#,
         16#000302#, 16#00005A#, 16#000323#, 16#00007A#, 16#000323#,
         16#00005A#, 16#000331#, 16#00007A#, 16#000331#, 16#000068#,
         16#000331#, 16#000074#, 16#000308#, 16#000077#, 16#00030A#,
         16#000079#, 16#00030A#, 16#000061#, 16#0002BE#, 16#00017F#,
         16#000307#, 16#000041#, 16#000323#, 16#000061#, 16#000323#,
         16#000041#, 16#000309#, 16#000061#, 16#000309#, 16#000041#,
         16#000302#, 16#000301#, 16#000061#, 16#000302#, 16#000301#,
         16#000041#, 16#000302#, 16#000300#, 16#000061#, 16#000302#,
         16#000300#, 16#000041#, 16#000302#, 16#000309#, 16#000061#,
         16#000302#, 16#000309#, 16#000041#, 16#000302#, 16#000303#,
         16#000061#, 16#000302#, 16#000303#, 16#000041#, 16#000323#,
         16#000302#, 16#000061#, 16#000323#, 16#000302#, 16#000041#,
         16#000306#, 16#000301#, 16#000061#, 16#000306#, 16#000301#,
         16#000041#, 16#000306#, 16#000300#, 16#000061#, 16#000306#,
         16#000300#, 16#000041#, 16#000306#, 16#000309#, 16#000061#,
         16#000306#, 16#000309#, 16#000041#, 16#000306#, 16#000303#,
         16#000061#, 16#000306#, 16#000303#, 16#000041#, 16#000323#,
         16#000306#, 16#000061#, 16#000323#, 16#000306#, 16#000045#,
         16#000323#, 16#000065#, 16#000323#, 16#000045#, 16#000309#,
         16#000065#, 16#000309#, 16#000045#, 16#000303#, 16#000065#,
         16#000303#, 16#000045#, 16#000302#, 16#000301#, 16#000065#,
         16#000302#, 16#000301#, 16#000045#, 16#000302#, 16#000300#,
         16#000065#, 16#000302#, 16#000300#, 16#000045#, 16#000302#,
         16#000309#, 16#000065#, 16#000302#, 16#000309#, 16#000045#,
         16#000302#, 16#000303#, 16#000065#, 16#000302#, 16#000303#,
         16#000045#, 16#000323#, 16#000302#, 16#000065#, 16#000323#,
         16#000302#, 16#000049#, 16#000309#, 16#000069#, 16#000309#,
         16#000049#, 16#000323#, 16#000069#, 16#000323#, 16#00004F#,
         16#000323#, 16#00006F#, 16#000323#, 16#00004F#, 16#000309#,
         16#00006F#, 16#000309#, 16#00004F#, 16#000302#, 16#000301#,
         16#00006F#, 16#000302#, 16#000301#, 16#00004F#, 16#000302#,
         16#000300#, 16#00006F#, 16#000302#, 16#000300#, 16#00004F#,
         16#000302#, 16#000309#, 16#00006F#, 16#000302#, 16#000309#,
         16#00004F#, 16#000302#, 16#000303#, 16#00006F#, 16#000302#,
         16#000303#, 16#00004F#, 16#000323#, 16#000302#, 16#00006F#,
         16#000323#, 16#000302#, 16#00004F#, 16#00031B#, 16#000301#,
         16#00006F#, 16#00031B#, 16#000301#, 16#00004F#, 16#00031B#,
         16#000300#, 16#00006F#, 16#00031B#, 16#000300#, 16#00004F#,
         16#00031B#, 16#000309#, 16#00006F#, 16#00031B#, 16#000309#,
         16#00004F#, 16#00031B#, 16#000303#, 16#00006F#, 16#00031B#,
         16#000303#, 16#00004F#, 16#00031B#, 16#000323#, 16#00006F#,
         16#00031B#, 16#000323#, 16#000055#, 16#000323#, 16#000075#,
         16#000323#, 16#000055#, 16#000309#, 16#000075#, 16#000309#,
         16#000055#, 16#00031B#, 16#000301#, 16#000075#, 16#00031B#,
         16#000301#, 16#000055#, 16#00031B#, 16#000300#, 16#000075#,
         16#00031B#, 16#000300#, 16#000055#, 16#00031B#, 16#000309#,
         16#000075#, 16#00031B#, 16#000309#, 16#000055#, 16#00031B#,
         16#000303#, 16#000075#, 16#00031B#, 16#000303#, 16#000055#,
         16#00031B#, 16#000323#, 16#000075#, 16#00031B#, 16#000323#,
         16#000059#, 16#000300#, 16#000079#, 16#000300#, 16#000059#,
         16#000323#, 16#000079#, 16#000323#, 16#000059#, 16#000309#,
         16#000079#, 16#000309#, 16#000059#, 16#000303#, 16#000079#,
         16#000303#, 16#0003B1#, 16#000313#, 16#0003B1#, 16#000314#,
         16#0003B1#, 16#000313#, 16#000300#, 16#0003B1#, 16#000314#,
         16#000300#, 16#0003B1#, 16#000313#, 16#000301#, 16#0003B1#,
         16#000314#, 16#000301#, 16#0003B1#, 16#000313#, 16#000342#,
         16#0003B1#, 16#000314#, 16#000342#, 16#000391#, 16#000313#,
         16#000391#, 16#000314#, 16#000391#, 16#000313#, 16#000300#,
         16#000391#, 16#000314#, 16#000300#, 16#000391#, 16#000313#,
         16#000301#, 16#000391#, 16#000314#, 16#000301#, 16#000391#,
         16#000313#, 16#000342#, 16#000391#, 16#000314#, 16#000342#,
         16#0003B5#, 16#000313#, 16#0003B5#, 16#000314#, 16#0003B5#,
         16#000313#, 16#000300#, 16#0003B5#, 16#000314#, 16#000300#,
         16#0003B5#, 16#000313#, 16#000301#, 16#0003B5#, 16#000314#,
         16#000301#, 16#000395#, 16#000313#, 16#000395#, 16#000314#,
         16#000395#, 16#000313#, 16#000300#, 16#000395#, 16#000314#,
         16#000300#, 16#000395#, 16#000313#, 16#000301#, 16#000395#,
         16#000314#, 16#000301#, 16#0003B7#, 16#000313#, 16#0003B7#,
         16#000314#, 16#0003B7#, 16#000313#, 16#000300#, 16#0003B7#,
         16#000314#, 16#000300#, 16#0003B7#, 16#000313#, 16#000301#,
         16#0003B7#, 16#000314#, 16#000301#, 16#0003B7#, 16#000313#,
         16#000342#, 16#0003B7#, 16#000314#, 16#000342#, 16#000397#,
         16#000313#, 16#000397#, 16#000314#, 16#000397#, 16#000313#,
         16#000300#, 16#000397#, 16#000314#, 16#000300#, 16#000397#,
         16#000313#, 16#000301#, 16#000397#, 16#000314#, 16#000301#,
         16#000397#, 16#000313#, 16#000342#, 16#000397#, 16#000314#,
         16#000342#, 16#0003B9#, 16#000313#, 16#0003B9#, 16#000314#,
         16#0003B9#, 16#000313#, 16#000300#, 16#0003B9#, 16#000314#,
         16#000300#, 16#0003B9#, 16#000313#, 16#000301#, 16#0003B9#,
         16#000314#, 16#000301#, 16#0003B9#, 16#000313#, 16#000342#,
         16#0003B9#, 16#000314#, 16#000342#, 16#000399#, 16#000313#,
         16#000399#, 16#000314#, 16#000399#, 16#000313#, 16#000300#,
         16#000399#, 16#000314#, 16#000300#, 16#000399#, 16#000313#,
         16#000301#, 16#000399#, 16#000314#, 16#000301#, 16#000399#,
         16#000313#, 16#000342#, 16#000399#, 16#000314#, 16#000342#,
         16#0003BF#, 16#000313#, 16#0003BF#, 16#000314#, 16#0003BF#,
         16#000313#, 16#000300#, 16#0003BF#, 16#000314#, 16#000300#,
         16#0003BF#, 16#000313#, 16#000301#, 16#0003BF#, 16#000314#,
         16#000301#, 16#00039F#, 16#000313#, 16#00039F#, 16#000314#,
         16#00039F#, 16#000313#, 16#000300#, 16#00039F#, 16#000314#,
         16#000300#, 16#00039F#, 16#000313#, 16#000301#, 16#00039F#,
         16#000314#, 16#000301#, 16#0003C5#, 16#000313#, 16#0003C5#,
         16#000314#, 16#0003C5#, 16#000313#, 16#000300#, 16#0003C5#,
         16#000314#, 16#000300#, 16#0003C5#, 16#000313#, 16#000301#,
         16#0003C5#, 16#000314#, 16#000301#, 16#0003C5#, 16#000313#,
         16#000342#, 16#0003C5#, 16#000314#, 16#000342#, 16#0003A5#,
         16#000314#, 16#0003A5#, 16#000314#, 16#000300#, 16#0003A5#,
         16#000314#, 16#000301#, 16#0003A5#, 16#000314#, 16#000342#,
         16#0003C9#, 16#000313#, 16#0003C9#, 16#000314#, 16#0003C9#,
         16#000313#, 16#000300#, 16#0003C9#, 16#000314#, 16#000300#,
         16#0003C9#, 16#000313#, 16#000301#, 16#0003C9#, 16#000314#,
         16#000301#, 16#0003C9#, 16#000313#, 16#000342#, 16#0003C9#,
         16#000314#, 16#000342#, 16#0003A9#, 16#000313#, 16#0003A9#,
         16#000314#, 16#0003A9#, 16#000313#, 16#000300#, 16#0003A9#,
         16#000314#, 16#000300#, 16#0003A9#, 16#000313#, 16#000301#,
         16#0003A9#, 16#000314#, 16#000301#, 16#0003A9#, 16#000313#,
         16#000342#, 16#0003A9#, 16#000314#, 16#000342#, 16#0003B1#,
         16#000300#, 16#0003B5#, 16#000300#, 16#0003B7#, 16#000300#,
         16#0003B9#, 16#000300#, 16#0003BF#, 16#000300#, 16#0003C5#,
         16#000300#, 16#0003C9#, 16#000300#, 16#0003B1#, 16#000313#,
         16#000345#, 16#0003B1#, 16#000314#, 16#000345#, 16#0003B1#,
         16#000313#, 16#000300#, 16#000345#, 16#0003B1#, 16#000314#,
         16#000300#, 16#000345#, 16#0003B1#, 16#000313#, 16#000301#,
         16#000345#, 16#0003B1#, 16#000314#, 16#000301#, 16#000345#,
         16#0003B1#, 16#000313#, 16#000342#, 16#000345#, 16#0003B1#,
         16#000314#, 16#000342#, 16#000345#, 16#000391#, 16#000313#,
         16#000345#, 16#000391#, 16#000314#, 16#000345#, 16#000391#,
         16#000313#, 16#000300#, 16#000345#, 16#000391#, 16#000314#,
         16#000300#, 16#000345#, 16#000391#, 16#000313#, 16#000301#,
         16#000345#, 16#000391#, 16#000314#, 16#000301#, 16#000345#,
         16#000391#, 16#000313#, 16#000342#, 16#000345#, 16#000391#,
         16#000314#, 16#000342#, 16#000345#, 16#0003B7#, 16#000313#,
         16#000345#, 16#0003B7#, 16#000314#, 16#000345#, 16#0003B7#,
         16#000313#, 16#000300#, 16#000345#, 16#0003B7#, 16#000314#,
         16#000300#, 16#000345#, 16#0003B7#, 16#000313#, 16#000301#,
         16#000345#, 16#0003B7#, 16#000314#, 16#000301#, 16#000345#,
         16#0003B7#, 16#000313#, 16#000342#, 16#000345#, 16#0003B7#,
         16#000314#, 16#000342#, 16#000345#, 16#000397#, 16#000313#,
         16#000345#, 16#000397#, 16#000314#, 16#000345#, 16#000397#,
         16#000313#, 16#000300#, 16#000345#, 16#000397#, 16#000314#,
         16#000300#, 16#000345#, 16#000397#, 16#000313#, 16#000301#,
         16#000345#, 16#000397#, 16#000314#, 16#000301#, 16#000345#,
         16#000397#, 16#000313#, 16#000342#, 16#000345#, 16#000397#,
         16#000314#, 16#000342#, 16#000345#, 16#0003C9#, 16#000313#,
         16#000345#, 16#0003C9#, 16#000314#, 16#000345#, 16#0003C9#,
         16#000313#, 16#000300#, 16#000345#, 16#0003C9#, 16#000314#,
         16#000300#, 16#000345#, 16#0003C9#, 16#000313#, 16#000301#,
         16#000345#, 16#0003C9#, 16#000314#, 16#000301#, 16#000345#,
         16#0003C9#, 16#000313#, 16#000342#, 16#000345#, 16#0003C9#,
         16#000314#, 16#000342#, 16#000345#, 16#0003A9#, 16#000313#,
         16#000345#, 16#0003A9#, 16#000314#, 16#000345#, 16#0003A9#,
         16#000313#, 16#000300#, 16#000345#, 16#0003A9#, 16#000314#,
         16#000300#, 16#000345#, 16#0003A9#, 16#000313#, 16#000301#,
         16#000345#, 16#0003A9#, 16#000314#, 16#000301#, 16#000345#,
         16#0003A9#, 16#000313#, 16#000342#, 16#000345#, 16#0003A9#,
         16#000314#, 16#000342#, 16#000345#, 16#0003B1#, 16#000306#,
         16#0003B1#, 16#000304#, 16#0003B1#, 16#000300#, 16#000345#,
         16#0003B1#, 16#000345#, 16#0003B1#, 16#000301#, 16#000345#,
         16#0003B1#, 16#000342#, 16#0003B1#, 16#000342#, 16#000345#,
         16#000391#, 16#000306#, 16#000391#, 16#000304#, 16#000391#,
         16#000300#, 16#000391#, 16#000345#, 16#000020#, 16#000313#,
         16#000020#, 16#000342#, 16#000020#, 16#000308#, 16#000342#,
         16#0000A8#, 16#000342#, 16#0003B7#, 16#000300#, 16#000345#,
         16#0003B7#, 16#000345#, 16#0003B7#, 16#000301#, 16#000345#,
         16#0003B7#, 16#000342#, 16#0003B7#, 16#000342#, 16#000345#,
         16#000395#, 16#000300#, 16#000397#, 16#000300#, 16#000397#,
         16#000345#, 16#000020#, 16#000313#, 16#000300#, 16#001FBF#,
         16#000300#, 16#000020#, 16#000313#, 16#000301#, 16#001FBF#,
         16#000301#, 16#000020#, 16#000313#, 16#000342#, 16#001FBF#,
         16#000342#, 16#0003B9#, 16#000306#, 16#0003B9#, 16#000304#,
         16#0003B9#, 16#000308#, 16#000300#, 16#0003B9#, 16#000342#,
         16#0003B9#, 16#000308#, 16#000342#, 16#000399#, 16#000306#,
         16#000399#, 16#000304#, 16#000399#, 16#000300#, 16#000020#,
         16#000314#, 16#000300#, 16#001FFE#, 16#000300#, 16#000020#,
         16#000314#, 16#000301#, 16#001FFE#, 16#000301#, 16#000020#,
         16#000314#, 16#000342#, 16#001FFE#, 16#000342#, 16#0003C5#,
         16#000306#, 16#0003C5#, 16#000304#, 16#0003C5#, 16#000308#,
         16#000300#, 16#0003C1#, 16#000313#, 16#0003C1#, 16#000314#,
         16#0003C5#, 16#000342#, 16#0003C5#, 16#000308#, 16#000342#,
         16#0003A5#, 16#000306#, 16#0003A5#, 16#000304#, 16#0003A5#,
         16#000300#, 16#0003A1#, 16#000314#, 16#000020#, 16#000308#,
         16#000300#, 16#0000A8#, 16#000300#, 16#000060#, 16#0003C9#,
         16#000300#, 16#000345#, 16#0003C9#, 16#000345#, 16#0003C9#,
         16#000301#, 16#000345#, 16#0003C9#, 16#000342#, 16#0003C9#,
         16#000342#, 16#000345#, 16#00039F#, 16#000300#, 16#0003A9#,
         16#000300#, 16#0003A9#, 16#000345#, 16#0000B4#, 16#002002#,
         16#002003#, 16#002010#, 16#000020#, 16#000333#, 16#00002E#,
         16#00002E#, 16#00002E#, 16#002032#, 16#002032#, 16#002032#,
         16#002032#, 16#002032#, 16#002035#, 16#002035#, 16#002035#,
         16#002035#, 16#002035#, 16#000021#, 16#000021#, 16#000020#,
         16#000305#, 16#00003F#, 16#00003F#, 16#00003F#, 16#000021#,
         16#000021#, 16#00003F#, 16#000030#, 16#000035#, 16#000036#,
         16#000037#, 16#000038#, 16#000039#, 16#00002B#, 16#002212#,
         16#00003D#, 16#000028#, 16#000029#, 16#000052#, 16#000073#,
         16#000061#, 16#00002F#, 16#000063#, 16#000061#, 16#00002F#,
         16#000073#, 16#0000B0#, 16#000043#, 16#000063#, 16#00002F#,
         16#00006F#, 16#000063#, 16#00002F#, 16#000075#, 16#000190#,
         16#0000B0#, 16#000046#, 16#000127#, 16#00004E#, 16#00006F#,
         16#000051#, 16#000053#, 16#00004D#, 16#000054#, 16#000045#,
         16#00004C#, 16#000054#, 16#00004D#, 16#0005D0#, 16#0005D1#,
         16#0005D2#, 16#0005D3#, 16#000046#, 16#000041#, 16#000058#,
         16#000393#, 16#0003A0#, 16#002211#, 16#000031#, 16#002044#,
         16#000037#, 16#000031#, 16#002044#, 16#000039#, 16#000031#,
         16#002044#, 16#000031#, 16#000030#, 16#000031#, 16#002044#,
         16#000033#, 16#000032#, 16#002044#, 16#000033#, 16#000031#,
         16#002044#, 16#000035#, 16#000032#, 16#002044#, 16#000035#,
         16#000033#, 16#002044#, 16#000035#, 16#000034#, 16#002044#,
         16#000035#, 16#000031#, 16#002044#, 16#000036#, 16#000035#,
         16#002044#, 16#000036#, 16#000031#, 16#002044#, 16#000038#,
         16#000033#, 16#002044#, 16#000038#, 16#000035#, 16#002044#,
         16#000038#, 16#000037#, 16#002044#, 16#000038#, 16#000049#,
         16#000049#, 16#000049#, 16#000049#, 16#000049#, 16#000049#,
         16#000056#, 16#000056#, 16#000049#, 16#000056#, 16#000049#,
         16#000049#, 16#000056#, 16#000049#, 16#000049#, 16#000049#,
         16#000049#, 16#000058#, 16#000058#, 16#000049#, 16#000058#,
         16#000049#, 16#000049#, 16#000069#, 16#000069#, 16#000069#,
         16#000069#, 16#000069#, 16#000069#, 16#000076#, 16#000076#,
         16#000069#, 16#000076#, 16#000069#, 16#000069#, 16#000076#,
         16#000069#, 16#000069#, 16#000069#, 16#000069#, 16#000078#,
         16#000078#, 16#000069#, 16#000078#, 16#000069#, 16#000069#,
         16#000030#, 16#002044#, 16#000033#, 16#002190#, 16#000338#,
         16#002192#, 16#000338#, 16#002194#, 16#000338#, 16#0021D0#,
         16#000338#, 16#0021D4#, 16#000338#, 16#0021D2#, 16#000338#,
         16#002203#, 16#000338#, 16#002208#, 16#000338#, 16#00220B#,
         16#000338#, 16#002223#, 16#000338#, 16#002225#, 16#000338#,
         16#00222B#, 16#00222B#, 16#00222B#, 16#00222B#, 16#00222B#,
         16#00222E#, 16#00222E#, 16#00222E#, 16#00222E#, 16#00222E#,
         16#00223C#, 16#000338#, 16#002243#, 16#000338#, 16#002245#,
         16#000338#, 16#002248#, 16#000338#, 16#00003D#, 16#000338#,
         16#002261#, 16#000338#, 16#00224D#, 16#000338#, 16#00003C#,
         16#000338#, 16#00003E#, 16#000338#, 16#002264#, 16#000338#,
         16#002265#, 16#000338#, 16#002272#, 16#000338#, 16#002273#,
         16#000338#, 16#002276#, 16#000338#, 16#002277#, 16#000338#,
         16#00227A#, 16#000338#, 16#00227B#, 16#000338#, 16#002282#,
         16#000338#, 16#002283#, 16#000338#, 16#002286#, 16#000338#,
         16#002287#, 16#000338#, 16#0022A2#, 16#000338#, 16#0022A8#,
         16#000338#, 16#0022A9#, 16#000338#, 16#0022AB#, 16#000338#,
         16#00227C#, 16#000338#, 16#00227D#, 16#000338#, 16#002291#,
         16#000338#, 16#002292#, 16#000338#, 16#0022B2#, 16#000338#,
         16#0022B3#, 16#000338#, 16#0022B4#, 16#000338#, 16#0022B5#,
         16#000338#, 16#003008#, 16#003009#, 16#000031#, 16#000031#,
         16#000031#, 16#000032#, 16#000031#, 16#000033#, 16#000031#,
         16#000034#, 16#000031#, 16#000035#, 16#000031#, 16#000036#,
         16#000031#, 16#000037#, 16#000031#, 16#000038#, 16#000031#,
         16#000039#, 16#000032#, 16#000030#, 16#000028#, 16#000031#,
         16#000029#, 16#000028#, 16#000032#, 16#000029#, 16#000028#,
         16#000033#, 16#000029#, 16#000028#, 16#000034#, 16#000029#,
         16#000028#, 16#000035#, 16#000029#, 16#000028#, 16#000036#,
         16#000029#, 16#000028#, 16#000037#, 16#000029#, 16#000028#,
         16#000038#, 16#000029#, 16#000028#, 16#000039#, 16#000029#,
         16#000028#, 16#000031#, 16#000030#, 16#000029#, 16#000028#,
         16#000031#, 16#000031#, 16#000029#, 16#000028#, 16#000031#,
         16#000032#, 16#000029#, 16#000028#, 16#000031#, 16#000033#,
         16#000029#, 16#000028#, 16#000031#, 16#000034#, 16#000029#,
         16#000028#, 16#000031#, 16#000035#, 16#000029#, 16#000028#,
         16#000031#, 16#000036#, 16#000029#, 16#000028#, 16#000031#,
         16#000037#, 16#000029#, 16#000028#, 16#000031#, 16#000038#,
         16#000029#, 16#000028#, 16#000031#, 16#000039#, 16#000029#,
         16#000028#, 16#000032#, 16#000030#, 16#000029#, 16#000031#,
         16#00002E#, 16#000032#, 16#00002E#, 16#000033#, 16#00002E#,
         16#000034#, 16#00002E#, 16#000035#, 16#00002E#, 16#000036#,
         16#00002E#, 16#000037#, 16#00002E#, 16#000038#, 16#00002E#,
         16#000039#, 16#00002E#, 16#000031#, 16#000030#, 16#00002E#,
         16#000031#, 16#000031#, 16#00002E#, 16#000031#, 16#000032#,
         16#00002E#, 16#000031#, 16#000033#, 16#00002E#, 16#000031#,
         16#000034#, 16#00002E#, 16#000031#, 16#000035#, 16#00002E#,
         16#000031#, 16#000036#, 16#00002E#, 16#000031#, 16#000037#,
         16#00002E#, 16#000031#, 16#000038#, 16#00002E#, 16#000031#,
         16#000039#, 16#00002E#, 16#000032#, 16#000030#, 16#00002E#,
         16#000028#, 16#000061#, 16#000029#, 16#000028#, 16#000062#,
         16#000029#, 16#000028#, 16#000063#, 16#000029#, 16#000028#,
         16#000064#, 16#000029#, 16#000028#, 16#000065#, 16#000029#,
         16#000028#, 16#000066#, 16#000029#, 16#000028#, 16#000067#,
         16#000029#, 16#000028#, 16#000068#, 16#000029#, 16#000028#,
         16#000069#, 16#000029#, 16#000028#, 16#00006A#, 16#000029#,
         16#000028#, 16#00006B#, 16#000029#, 16#000028#, 16#00006C#,
         16#000029#, 16#000028#, 16#00006D#, 16#000029#, 16#000028#,
         16#00006E#, 16#000029#, 16#000028#, 16#00006F#, 16#000029#,
         16#000028#, 16#000070#, 16#000029#, 16#000028#, 16#000071#,
         16#000029#, 16#000028#, 16#000072#, 16#000029#, 16#000028#,
         16#000073#, 16#000029#, 16#000028#, 16#000074#, 16#000029#,
         16#000028#, 16#000075#, 16#000029#, 16#000028#, 16#000076#,
         16#000029#, 16#000028#, 16#000077#, 16#000029#, 16#000028#,
         16#000078#, 16#000029#, 16#000028#, 16#000079#, 16#000029#,
         16#000028#, 16#00007A#, 16#000029#, 16#00003A#, 16#00003A#,
         16#00003D#, 16#00003D#, 16#00003D#, 16#002ADD#, 16#000338#,
         16#002D61#, 16#006BCD#, 16#009F9F#, 16#004E00#, 16#004E28#,
         16#004E36#, 16#004E3F#, 16#004E59#, 16#004E85#, 16#004E8C#,
         16#004EA0#, 16#004EBA#, 16#00513F#, 16#005165#, 16#00516B#,
         16#005182#, 16#005196#, 16#0051AB#, 16#0051E0#, 16#0051F5#,
         16#005200#, 16#00529B#, 16#0052F9#, 16#005315#, 16#00531A#,
         16#005338#, 16#005341#, 16#00535C#, 16#005369#, 16#005382#,
         16#0053B6#, 16#0053C8#, 16#0053E3#, 16#0056D7#, 16#00571F#,
         16#0058EB#, 16#005902#, 16#00590A#, 16#005915#, 16#005927#,
         16#005973#, 16#005B50#, 16#005B80#, 16#005BF8#, 16#005C0F#,
         16#005C22#, 16#005C38#, 16#005C6E#, 16#005C71#, 16#005DDB#,
         16#005DE5#, 16#005DF1#, 16#005DFE#, 16#005E72#, 16#005E7A#,
         16#005E7F#, 16#005EF4#, 16#005EFE#, 16#005F0B#, 16#005F13#,
         16#005F50#, 16#005F61#, 16#005F73#, 16#005FC3#, 16#006208#,
         16#006236#, 16#00624B#, 16#00652F#, 16#006534#, 16#006587#,
         16#006597#, 16#0065A4#, 16#0065B9#, 16#0065E0#, 16#0065E5#,
         16#0066F0#, 16#006708#, 16#006728#, 16#006B20#, 16#006B62#,
         16#006B79#, 16#006BB3#, 16#006BCB#, 16#006BD4#, 16#006BDB#,
         16#006C0F#, 16#006C14#, 16#006C34#, 16#00706B#, 16#00722A#,
         16#007236#, 16#00723B#, 16#00723F#, 16#007247#, 16#007259#,
         16#00725B#, 16#0072AC#, 16#007384#, 16#007389#, 16#0074DC#,
         16#0074E6#, 16#007518#, 16#00751F#, 16#007528#, 16#007530#,
         16#00758B#, 16#007592#, 16#007676#, 16#00767D#, 16#0076AE#,
         16#0076BF#, 16#0076EE#, 16#0077DB#, 16#0077E2#, 16#0077F3#,
         16#00793A#, 16#0079B8#, 16#0079BE#, 16#007A74#, 16#007ACB#,
         16#007AF9#, 16#007C73#, 16#007CF8#, 16#007F36#, 16#007F51#,
         16#007F8A#, 16#007FBD#, 16#008001#, 16#00800C#, 16#008012#,
         16#008033#, 16#00807F#, 16#008089#, 16#0081E3#, 16#0081EA#,
         16#0081F3#, 16#0081FC#, 16#00820C#, 16#00821B#, 16#00821F#,
         16#00826E#, 16#008272#, 16#008278#, 16#00864D#, 16#00866B#,
         16#008840#, 16#00884C#, 16#008863#, 16#00897E#, 16#00898B#,
         16#0089D2#, 16#008A00#, 16#008C37#, 16#008C46#, 16#008C55#,
         16#008C78#, 16#008C9D#, 16#008D64#, 16#008D70#, 16#008DB3#,
         16#008EAB#, 16#008ECA#, 16#008F9B#, 16#008FB0#, 16#008FB5#,
         16#009091#, 16#009149#, 16#0091C6#, 16#0091CC#, 16#0091D1#,
         16#009577#, 16#009580#, 16#00961C#, 16#0096B6#, 16#0096B9#,
         16#0096E8#, 16#009751#, 16#00975E#, 16#009762#, 16#009769#,
         16#0097CB#, 16#0097ED#, 16#0097F3#, 16#009801#, 16#0098A8#,
         16#0098DB#, 16#0098DF#, 16#009996#, 16#009999#, 16#0099AC#,
         16#009AA8#, 16#009AD8#, 16#009ADF#, 16#009B25#, 16#009B2F#,
         16#009B32#, 16#009B3C#, 16#009B5A#, 16#009CE5#, 16#009E75#,
         16#009E7F#, 16#009EA5#, 16#009EBB#, 16#009EC3#, 16#009ECD#,
         16#009ED1#, 16#009EF9#, 16#009EFD#, 16#009F0E#, 16#009F13#,
         16#009F20#, 16#009F3B#, 16#009F4A#, 16#009F52#, 16#009F8D#,
         16#009F9C#, 16#009FA0#, 16#003012#, 16#005344#, 16#005345#,
         16#00304B#, 16#003099#, 16#00304D#, 16#003099#, 16#00304F#,
         16#003099#, 16#003051#, 16#003099#, 16#003053#, 16#003099#,
         16#003055#, 16#003099#, 16#003057#, 16#003099#, 16#003059#,
         16#003099#, 16#00305B#, 16#003099#, 16#00305D#, 16#003099#,
         16#00305F#, 16#003099#, 16#003061#, 16#003099#, 16#003064#,
         16#003099#, 16#003066#, 16#003099#, 16#003068#, 16#003099#,
         16#00306F#, 16#003099#, 16#00306F#, 16#00309A#, 16#003072#,
         16#003099#, 16#003072#, 16#00309A#, 16#003075#, 16#003099#,
         16#003075#, 16#00309A#, 16#003078#, 16#003099#, 16#003078#,
         16#00309A#, 16#00307B#, 16#003099#, 16#00307B#, 16#00309A#,
         16#003046#, 16#003099#, 16#000020#, 16#003099#, 16#000020#,
         16#00309A#, 16#00309D#, 16#003099#, 16#003088#, 16#00308A#,
         16#0030AB#, 16#003099#, 16#0030AD#, 16#003099#, 16#0030AF#,
         16#003099#, 16#0030B1#, 16#003099#, 16#0030B3#, 16#003099#,
         16#0030B5#, 16#003099#, 16#0030B7#, 16#003099#, 16#0030B9#,
         16#003099#, 16#0030BB#, 16#003099#, 16#0030BD#, 16#003099#,
         16#0030BF#, 16#003099#, 16#0030C1#, 16#003099#, 16#0030C4#,
         16#003099#, 16#0030C6#, 16#003099#, 16#0030C8#, 16#003099#,
         16#0030CF#, 16#003099#, 16#0030CF#, 16#00309A#, 16#0030D2#,
         16#003099#, 16#0030D2#, 16#00309A#, 16#0030D5#, 16#003099#,
         16#0030D5#, 16#00309A#, 16#0030D8#, 16#003099#, 16#0030D8#,
         16#00309A#, 16#0030DB#, 16#003099#, 16#0030DB#, 16#00309A#,
         16#0030A6#, 16#003099#, 16#0030EF#, 16#003099#, 16#0030F0#,
         16#003099#, 16#0030F1#, 16#003099#, 16#0030F2#, 16#003099#,
         16#0030FD#, 16#003099#, 16#0030B3#, 16#0030C8#, 16#001100#,
         16#001101#, 16#0011AA#, 16#001102#, 16#0011AC#, 16#0011AD#,
         16#001103#, 16#001104#, 16#001105#, 16#0011B0#, 16#0011B1#,
         16#0011B2#, 16#0011B3#, 16#0011B4#, 16#0011B5#, 16#00111A#,
         16#001106#, 16#001107#, 16#001108#, 16#001121#, 16#001109#,
         16#00110A#, 16#00110B#, 16#00110C#, 16#00110D#, 16#00110E#,
         16#00110F#, 16#001110#, 16#001111#, 16#001112#, 16#001161#,
         16#001162#, 16#001163#, 16#001164#, 16#001165#, 16#001166#,
         16#001167#, 16#001168#, 16#001169#, 16#00116A#, 16#00116B#,
         16#00116C#, 16#00116D#, 16#00116E#, 16#00116F#, 16#001170#,
         16#001171#, 16#001172#, 16#001173#, 16#001174#, 16#001175#,
         16#001160#, 16#001114#, 16#001115#, 16#0011C7#, 16#0011C8#,
         16#0011CC#, 16#0011CE#, 16#0011D3#, 16#0011D7#, 16#0011D9#,
         16#00111C#, 16#0011DD#, 16#0011DF#, 16#00111D#, 16#00111E#,
         16#001120#, 16#001122#, 16#001123#, 16#001127#, 16#001129#,
         16#00112B#, 16#00112C#, 16#00112D#, 16#00112E#, 16#00112F#,
         16#001132#, 16#001136#, 16#001140#, 16#001147#, 16#00114C#,
         16#0011F1#, 16#0011F2#, 16#001157#, 16#001158#, 16#001159#,
         16#001184#, 16#001185#, 16#001188#, 16#001191#, 16#001192#,
         16#001194#, 16#00119E#, 16#0011A1#, 16#004E09#, 16#0056DB#,
         16#004E0A#, 16#004E2D#, 16#004E0B#, 16#007532#, 16#004E19#,
         16#004E01#, 16#005929#, 16#005730#, 16#000028#, 16#001100#,
         16#000029#, 16#000028#, 16#001102#, 16#000029#, 16#000028#,
         16#001103#, 16#000029#, 16#000028#, 16#001105#, 16#000029#,
         16#000028#, 16#001106#, 16#000029#, 16#000028#, 16#001107#,
         16#000029#, 16#000028#, 16#001109#, 16#000029#, 16#000028#,
         16#00110B#, 16#000029#, 16#000028#, 16#00110C#, 16#000029#,
         16#000028#, 16#00110E#, 16#000029#, 16#000028#, 16#00110F#,
         16#000029#, 16#000028#, 16#001110#, 16#000029#, 16#000028#,
         16#001111#, 16#000029#, 16#000028#, 16#001112#, 16#000029#,
         16#000028#, 16#001100#, 16#001161#, 16#000029#, 16#000028#,
         16#001102#, 16#001161#, 16#000029#, 16#000028#, 16#001103#,
         16#001161#, 16#000029#, 16#000028#, 16#001105#, 16#001161#,
         16#000029#, 16#000028#, 16#001106#, 16#001161#, 16#000029#,
         16#000028#, 16#001107#, 16#001161#, 16#000029#, 16#000028#,
         16#001109#, 16#001161#, 16#000029#, 16#000028#, 16#00110B#,
         16#001161#, 16#000029#, 16#000028#, 16#00110C#, 16#001161#,
         16#000029#, 16#000028#, 16#00110E#, 16#001161#, 16#000029#,
         16#000028#, 16#00110F#, 16#001161#, 16#000029#, 16#000028#,
         16#001110#, 16#001161#, 16#000029#, 16#000028#, 16#001111#,
         16#001161#, 16#000029#, 16#000028#, 16#001112#, 16#001161#,
         16#000029#, 16#000028#, 16#00110C#, 16#00116E#, 16#000029#,
         16#000028#, 16#00110B#, 16#001169#, 16#00110C#, 16#001165#,
         16#0011AB#, 16#000029#, 16#000028#, 16#00110B#, 16#001169#,
         16#001112#, 16#00116E#, 16#000029#, 16#000028#, 16#004E00#,
         16#000029#, 16#000028#, 16#004E8C#, 16#000029#, 16#000028#,
         16#004E09#, 16#000029#, 16#000028#, 16#0056DB#, 16#000029#,
         16#000028#, 16#004E94#, 16#000029#, 16#000028#, 16#00516D#,
         16#000029#, 16#000028#, 16#004E03#, 16#000029#, 16#000028#,
         16#00516B#, 16#000029#, 16#000028#, 16#004E5D#, 16#000029#,
         16#000028#, 16#005341#, 16#000029#, 16#000028#, 16#006708#,
         16#000029#, 16#000028#, 16#00706B#, 16#000029#, 16#000028#,
         16#006C34#, 16#000029#, 16#000028#, 16#006728#, 16#000029#,
         16#000028#, 16#0091D1#, 16#000029#, 16#000028#, 16#00571F#,
         16#000029#, 16#000028#, 16#0065E5#, 16#000029#, 16#000028#,
         16#00682A#, 16#000029#, 16#000028#, 16#006709#, 16#000029#,
         16#000028#, 16#00793E#, 16#000029#, 16#000028#, 16#00540D#,
         16#000029#, 16#000028#, 16#007279#, 16#000029#, 16#000028#,
         16#008CA1#, 16#000029#, 16#000028#, 16#00795D#, 16#000029#,
         16#000028#, 16#0052B4#, 16#000029#, 16#000028#, 16#004EE3#,
         16#000029#, 16#000028#, 16#00547C#, 16#000029#, 16#000028#,
         16#005B66#, 16#000029#, 16#000028#, 16#0076E3#, 16#000029#,
         16#000028#, 16#004F01#, 16#000029#, 16#000028#, 16#008CC7#,
         16#000029#, 16#000028#, 16#005354#, 16#000029#, 16#000028#,
         16#00796D#, 16#000029#, 16#000028#, 16#004F11#, 16#000029#,
         16#000028#, 16#0081EA#, 16#000029#, 16#000028#, 16#0081F3#,
         16#000029#, 16#00554F#, 16#005E7C#, 16#007B8F#, 16#000050#,
         16#000054#, 16#000045#, 16#000032#, 16#000032#, 16#000032#,
         16#000034#, 16#000032#, 16#000035#, 16#000032#, 16#000036#,
         16#000032#, 16#000037#, 16#000032#, 16#000038#, 16#000032#,
         16#000039#, 16#000033#, 16#000030#, 16#000033#, 16#000033#,
         16#000033#, 16#000034#, 16#000033#, 16#000035#, 16#00110E#,
         16#001161#, 16#0011B7#, 16#001100#, 16#001169#, 16#00110C#,
         16#00116E#, 16#00110B#, 16#001174#, 16#00110B#, 16#00116E#,
         16#0079D8#, 16#007537#, 16#009069#, 16#00512A#, 16#005370#,
         16#006CE8#, 16#009805#, 16#005199#, 16#006B63#, 16#005DE6#,
         16#0053F3#, 16#00533B#, 16#005B97#, 16#00591C#, 16#000033#,
         16#000036#, 16#000033#, 16#000037#, 16#000033#, 16#000038#,
         16#000033#, 16#000039#, 16#000034#, 16#000030#, 16#000034#,
         16#000034#, 16#000034#, 16#000035#, 16#000034#, 16#000036#,
         16#000034#, 16#000037#, 16#000034#, 16#000038#, 16#000034#,
         16#000039#, 16#000035#, 16#000030#, 16#000031#, 16#006708#,
         16#000032#, 16#006708#, 16#000033#, 16#006708#, 16#000034#,
         16#006708#, 16#000035#, 16#006708#, 16#000036#, 16#006708#,
         16#000037#, 16#006708#, 16#000038#, 16#006708#, 16#000039#,
         16#006708#, 16#000031#, 16#000030#, 16#006708#, 16#000031#,
         16#000031#, 16#006708#, 16#000031#, 16#000032#, 16#006708#,
         16#000048#, 16#000067#, 16#000065#, 16#000072#, 16#000067#,
         16#000065#, 16#000056#, 16#00004C#, 16#000054#, 16#000044#,
         16#0030A2#, 16#0030A4#, 16#0030A8#, 16#0030AA#, 16#0030CA#,
         16#0030CB#, 16#0030CC#, 16#0030CD#, 16#0030CE#, 16#0030DE#,
         16#0030DF#, 16#0030E0#, 16#0030E1#, 16#0030E2#, 16#0030E4#,
         16#0030E6#, 16#0030E8#, 16#0030E9#, 16#0030EA#, 16#0030EB#,
         16#0030EC#, 16#0030ED#, 16#0030A2#, 16#0030CF#, 16#00309A#,
         16#0030FC#, 16#0030C8#, 16#0030A2#, 16#0030EB#, 16#0030D5#,
         16#0030A1#, 16#0030A2#, 16#0030F3#, 16#0030D8#, 16#00309A#,
         16#0030A2#, 16#0030A2#, 16#0030FC#, 16#0030EB#, 16#0030A4#,
         16#0030CB#, 16#0030F3#, 16#0030AF#, 16#003099#, 16#0030A4#,
         16#0030F3#, 16#0030C1#, 16#0030A6#, 16#0030A9#, 16#0030F3#,
         16#0030A8#, 16#0030B9#, 16#0030AF#, 16#0030FC#, 16#0030C8#,
         16#003099#, 16#0030A8#, 16#0030FC#, 16#0030AB#, 16#0030FC#,
         16#0030AA#, 16#0030F3#, 16#0030B9#, 16#0030AA#, 16#0030FC#,
         16#0030E0#, 16#0030AB#, 16#0030A4#, 16#0030EA#, 16#0030AB#,
         16#0030E9#, 16#0030C3#, 16#0030C8#, 16#0030AB#, 16#0030ED#,
         16#0030EA#, 16#0030FC#, 16#0030AB#, 16#003099#, 16#0030ED#,
         16#0030F3#, 16#0030AB#, 16#003099#, 16#0030F3#, 16#0030DE#,
         16#0030AD#, 16#003099#, 16#0030AB#, 16#003099#, 16#0030AD#,
         16#003099#, 16#0030CB#, 16#0030FC#, 16#0030AD#, 16#0030E5#,
         16#0030EA#, 16#0030FC#, 16#0030AD#, 16#003099#, 16#0030EB#,
         16#0030BF#, 16#003099#, 16#0030FC#, 16#0030AD#, 16#0030ED#,
         16#0030AD#, 16#0030ED#, 16#0030AF#, 16#003099#, 16#0030E9#,
         16#0030E0#, 16#0030AD#, 16#0030ED#, 16#0030E1#, 16#0030FC#,
         16#0030C8#, 16#0030EB#, 16#0030AD#, 16#0030ED#, 16#0030EF#,
         16#0030C3#, 16#0030C8#, 16#0030AF#, 16#003099#, 16#0030E9#,
         16#0030E0#, 16#0030C8#, 16#0030F3#, 16#0030AF#, 16#0030EB#,
         16#0030BB#, 16#003099#, 16#0030A4#, 16#0030ED#, 16#0030AF#,
         16#0030ED#, 16#0030FC#, 16#0030CD#, 16#0030B1#, 16#0030FC#,
         16#0030B9#, 16#0030B3#, 16#0030EB#, 16#0030CA#, 16#0030B3#,
         16#0030FC#, 16#0030DB#, 16#00309A#, 16#0030B5#, 16#0030A4#,
         16#0030AF#, 16#0030EB#, 16#0030B5#, 16#0030F3#, 16#0030C1#,
         16#0030FC#, 16#0030E0#, 16#0030B7#, 16#0030EA#, 16#0030F3#,
         16#0030AF#, 16#003099#, 16#0030BB#, 16#0030F3#, 16#0030C1#,
         16#0030BB#, 16#0030F3#, 16#0030C8#, 16#0030BF#, 16#003099#,
         16#0030FC#, 16#0030B9#, 16#0030C6#, 16#003099#, 16#0030B7#,
         16#0030C8#, 16#003099#, 16#0030EB#, 16#0030CA#, 16#0030CE#,
         16#0030CE#, 16#0030C3#, 16#0030C8#, 16#0030CF#, 16#0030A4#,
         16#0030C4#, 16#0030CF#, 16#00309A#, 16#0030FC#, 16#0030BB#,
         16#0030F3#, 16#0030C8#, 16#0030CF#, 16#00309A#, 16#0030FC#,
         16#0030C4#, 16#0030CF#, 16#003099#, 16#0030FC#, 16#0030EC#,
         16#0030EB#, 16#0030D2#, 16#00309A#, 16#0030A2#, 16#0030B9#,
         16#0030C8#, 16#0030EB#, 16#0030D2#, 16#00309A#, 16#0030AF#,
         16#0030EB#, 16#0030D2#, 16#00309A#, 16#0030B3#, 16#0030D2#,
         16#003099#, 16#0030EB#, 16#0030D5#, 16#0030A1#, 16#0030E9#,
         16#0030C3#, 16#0030C8#, 16#003099#, 16#0030D5#, 16#0030A3#,
         16#0030FC#, 16#0030C8#, 16#0030D5#, 16#003099#, 16#0030C3#,
         16#0030B7#, 16#0030A7#, 16#0030EB#, 16#0030D5#, 16#0030E9#,
         16#0030F3#, 16#0030D8#, 16#0030AF#, 16#0030BF#, 16#0030FC#,
         16#0030EB#, 16#0030D8#, 16#00309A#, 16#0030BD#, 16#0030D8#,
         16#00309A#, 16#0030CB#, 16#0030D2#, 16#0030D8#, 16#0030EB#,
         16#0030C4#, 16#0030D8#, 16#00309A#, 16#0030F3#, 16#0030B9#,
         16#0030D8#, 16#00309A#, 16#0030FC#, 16#0030B7#, 16#003099#,
         16#0030D8#, 16#003099#, 16#0030FC#, 16#0030BF#, 16#0030DB#,
         16#00309A#, 16#0030A4#, 16#0030F3#, 16#0030C8#, 16#0030DB#,
         16#003099#, 16#0030EB#, 16#0030C8#, 16#0030DB#, 16#0030F3#,
         16#0030DB#, 16#00309A#, 16#0030F3#, 16#0030C8#, 16#003099#,
         16#0030DB#, 16#0030FC#, 16#0030EB#, 16#0030DB#, 16#0030FC#,
         16#0030F3#, 16#0030DE#, 16#0030A4#, 16#0030AF#, 16#0030ED#,
         16#0030DE#, 16#0030A4#, 16#0030EB#, 16#0030DE#, 16#0030C3#,
         16#0030CF#, 16#0030DE#, 16#0030EB#, 16#0030AF#, 16#0030DE#,
         16#0030F3#, 16#0030B7#, 16#0030E7#, 16#0030F3#, 16#0030DF#,
         16#0030AF#, 16#0030ED#, 16#0030F3#, 16#0030DF#, 16#0030EA#,
         16#0030DF#, 16#0030EA#, 16#0030CF#, 16#003099#, 16#0030FC#,
         16#0030EB#, 16#0030E1#, 16#0030AB#, 16#003099#, 16#0030E1#,
         16#0030AB#, 16#003099#, 16#0030C8#, 16#0030F3#, 16#0030E4#,
         16#0030FC#, 16#0030C8#, 16#003099#, 16#0030E4#, 16#0030FC#,
         16#0030EB#, 16#0030E6#, 16#0030A2#, 16#0030F3#, 16#0030EA#,
         16#0030C3#, 16#0030C8#, 16#0030EB#, 16#0030EA#, 16#0030E9#,
         16#0030EB#, 16#0030D2#, 16#00309A#, 16#0030FC#, 16#0030EB#,
         16#0030FC#, 16#0030D5#, 16#003099#, 16#0030EB#, 16#0030EC#,
         16#0030E0#, 16#0030EC#, 16#0030F3#, 16#0030C8#, 16#0030B1#,
         16#003099#, 16#0030F3#, 16#000030#, 16#0070B9#, 16#000031#,
         16#0070B9#, 16#000032#, 16#0070B9#, 16#000033#, 16#0070B9#,
         16#000034#, 16#0070B9#, 16#000035#, 16#0070B9#, 16#000036#,
         16#0070B9#, 16#000037#, 16#0070B9#, 16#000038#, 16#0070B9#,
         16#000039#, 16#0070B9#, 16#000031#, 16#000030#, 16#0070B9#,
         16#000031#, 16#000031#, 16#0070B9#, 16#000031#, 16#000032#,
         16#0070B9#, 16#000031#, 16#000033#, 16#0070B9#, 16#000031#,
         16#000034#, 16#0070B9#, 16#000031#, 16#000035#, 16#0070B9#,
         16#000031#, 16#000036#, 16#0070B9#, 16#000031#, 16#000037#,
         16#0070B9#, 16#000031#, 16#000038#, 16#0070B9#, 16#000031#,
         16#000039#, 16#0070B9#, 16#000032#, 16#000030#, 16#0070B9#,
         16#000032#, 16#000031#, 16#0070B9#, 16#000032#, 16#000032#,
         16#0070B9#, 16#000032#, 16#000033#, 16#0070B9#, 16#000032#,
         16#000034#, 16#0070B9#, 16#000068#, 16#000050#, 16#000061#,
         16#000064#, 16#000061#, 16#000041#, 16#000055#, 16#000062#,
         16#000061#, 16#000072#, 16#00006F#, 16#000056#, 16#000070#,
         16#000063#, 16#000064#, 16#00006D#, 16#000064#, 16#00006D#,
         16#000032#, 16#000064#, 16#00006D#, 16#000033#, 16#000049#,
         16#000055#, 16#005E73#, 16#006210#, 16#00662D#, 16#00548C#,
         16#005927#, 16#006B63#, 16#00660E#, 16#006CBB#, 16#00682A#,
         16#005F0F#, 16#004F1A#, 16#00793E#, 16#000070#, 16#000041#,
         16#00006E#, 16#000041#, 16#0003BC#, 16#000041#, 16#00006D#,
         16#000041#, 16#00006B#, 16#000041#, 16#00004B#, 16#000042#,
         16#00004D#, 16#000042#, 16#000047#, 16#000042#, 16#000063#,
         16#000061#, 16#00006C#, 16#00006B#, 16#000063#, 16#000061#,
         16#00006C#, 16#000070#, 16#000046#, 16#00006E#, 16#000046#,
         16#0003BC#, 16#000046#, 16#0003BC#, 16#000067#, 16#00006D#,
         16#000067#, 16#00006B#, 16#000067#, 16#000048#, 16#00007A#,
         16#00006B#, 16#000048#, 16#00007A#, 16#00004D#, 16#000048#,
         16#00007A#, 16#000047#, 16#000048#, 16#00007A#, 16#000054#,
         16#000048#, 16#00007A#, 16#0003BC#, 16#00006C#, 16#00006D#,
         16#00006C#, 16#000064#, 16#00006C#, 16#00006B#, 16#00006C#,
         16#000066#, 16#00006D#, 16#00006E#, 16#00006D#, 16#0003BC#,
         16#00006D#, 16#00006D#, 16#00006D#, 16#000063#, 16#00006D#,
         16#00006B#, 16#00006D#, 16#00006D#, 16#00006D#, 16#000032#,
         16#000063#, 16#00006D#, 16#000032#, 16#00006B#, 16#00006D#,
         16#000032#, 16#00006D#, 16#00006D#, 16#000033#, 16#000063#,
         16#00006D#, 16#000033#, 16#00006B#, 16#00006D#, 16#000033#,
         16#00006D#, 16#002215#, 16#000073#, 16#00006D#, 16#002215#,
         16#000073#, 16#000032#, 16#00006B#, 16#000050#, 16#000061#,
         16#00004D#, 16#000050#, 16#000061#, 16#000047#, 16#000050#,
         16#000061#, 16#000072#, 16#000061#, 16#000064#, 16#000072#,
         16#000061#, 16#000064#, 16#002215#, 16#000073#, 16#000072#,
         16#000061#, 16#000064#, 16#002215#, 16#000073#, 16#000032#,
         16#000070#, 16#000073#, 16#00006E#, 16#000073#, 16#0003BC#,
         16#000073#, 16#00006D#, 16#000073#, 16#000070#, 16#000056#,
         16#00006E#, 16#000056#, 16#0003BC#, 16#000056#, 16#00006D#,
         16#000056#, 16#00006B#, 16#000056#, 16#00004D#, 16#000056#,
         16#000070#, 16#000057#, 16#00006E#, 16#000057#, 16#0003BC#,
         16#000057#, 16#00006D#, 16#000057#, 16#00006B#, 16#000057#,
         16#00004D#, 16#000057#, 16#00006B#, 16#0003A9#, 16#00004D#,
         16#0003A9#, 16#000061#, 16#00002E#, 16#00006D#, 16#00002E#,
         16#000042#, 16#000071#, 16#000063#, 16#000063#, 16#000043#,
         16#002215#, 16#00006B#, 16#000067#, 16#000043#, 16#00006F#,
         16#00002E#, 16#000064#, 16#000042#, 16#000047#, 16#000079#,
         16#000068#, 16#000061#, 16#000048#, 16#000050#, 16#000069#,
         16#00006E#, 16#00004B#, 16#00004B#, 16#00004B#, 16#00004D#,
         16#00006B#, 16#000074#, 16#00006C#, 16#00006E#, 16#00006C#,
         16#00006F#, 16#000067#, 16#00006C#, 16#000078#, 16#00006D#,
         16#000062#, 16#00006D#, 16#000069#, 16#00006C#, 16#00006D#,
         16#00006F#, 16#00006C#, 16#000050#, 16#000048#, 16#000070#,
         16#00002E#, 16#00006D#, 16#00002E#, 16#000050#, 16#000050#,
         16#00004D#, 16#000050#, 16#000052#, 16#000053#, 16#000076#,
         16#000057#, 16#000062#, 16#000056#, 16#002215#, 16#00006D#,
         16#000041#, 16#002215#, 16#00006D#, 16#000031#, 16#0065E5#,
         16#000032#, 16#0065E5#, 16#000033#, 16#0065E5#, 16#000034#,
         16#0065E5#, 16#000035#, 16#0065E5#, 16#000036#, 16#0065E5#,
         16#000037#, 16#0065E5#, 16#000038#, 16#0065E5#, 16#000039#,
         16#0065E5#, 16#000031#, 16#000030#, 16#0065E5#, 16#000031#,
         16#000031#, 16#0065E5#, 16#000031#, 16#000032#, 16#0065E5#,
         16#000031#, 16#000033#, 16#0065E5#, 16#000031#, 16#000034#,
         16#0065E5#, 16#000031#, 16#000035#, 16#0065E5#, 16#000031#,
         16#000036#, 16#0065E5#, 16#000031#, 16#000037#, 16#0065E5#,
         16#000031#, 16#000038#, 16#0065E5#, 16#000031#, 16#000039#,
         16#0065E5#, 16#000032#, 16#000030#, 16#0065E5#, 16#000032#,
         16#000031#, 16#0065E5#, 16#000032#, 16#000032#, 16#0065E5#,
         16#000032#, 16#000033#, 16#0065E5#, 16#000032#, 16#000034#,
         16#0065E5#, 16#000032#, 16#000035#, 16#0065E5#, 16#000032#,
         16#000036#, 16#0065E5#, 16#000032#, 16#000037#, 16#0065E5#,
         16#000032#, 16#000038#, 16#0065E5#, 16#000032#, 16#000039#,
         16#0065E5#, 16#000033#, 16#000030#, 16#0065E5#, 16#000033#,
         16#000031#, 16#0065E5#, 16#000067#, 16#000061#, 16#00006C#,
         16#00044A#, 16#00044C#, 16#00A76F#, 16#000126#, 16#000153#,
         16#00A727#, 16#00AB37#, 16#00026B#, 16#00AB52#, 16#008C48#,
         16#0066F4#, 16#008CC8#, 16#006ED1#, 16#004E32#, 16#0053E5#,
         16#005951#, 16#005587#, 16#005948#, 16#0061F6#, 16#007669#,
         16#007F85#, 16#00863F#, 16#0087BA#, 16#0088F8#, 16#00908F#,
         16#006A02#, 16#006D1B#, 16#0070D9#, 16#0073DE#, 16#00843D#,
         16#00916A#, 16#0099F1#, 16#004E82#, 16#005375#, 16#006B04#,
         16#00721B#, 16#00862D#, 16#009E1E#, 16#005D50#, 16#006FEB#,
         16#0085CD#, 16#008964#, 16#0062C9#, 16#0081D8#, 16#00881F#,
         16#005ECA#, 16#006717#, 16#006D6A#, 16#0072FC#, 16#0090CE#,
         16#004F86#, 16#0051B7#, 16#0052DE#, 16#0064C4#, 16#006AD3#,
         16#007210#, 16#0076E7#, 16#008606#, 16#00865C#, 16#008DEF#,
         16#009732#, 16#009B6F#, 16#009DFA#, 16#00788C#, 16#00797F#,
         16#007DA0#, 16#0083C9#, 16#009304#, 16#008AD6#, 16#0058DF#,
         16#005F04#, 16#007C60#, 16#00807E#, 16#007262#, 16#0078CA#,
         16#008CC2#, 16#0096F7#, 16#0058D8#, 16#005C62#, 16#006A13#,
         16#006DDA#, 16#006F0F#, 16#007D2F#, 16#007E37#, 16#00964B#,
         16#0052D2#, 16#00808B#, 16#0051DC#, 16#0051CC#, 16#007A1C#,
         16#007DBE#, 16#0083F1#, 16#009675#, 16#008B80#, 16#0062CF#,
         16#008AFE#, 16#004E39#, 16#005BE7#, 16#006012#, 16#007387#,
         16#007570#, 16#005317#, 16#0078FB#, 16#004FBF#, 16#005FA9#,
         16#004E0D#, 16#006CCC#, 16#006578#, 16#007D22#, 16#0053C3#,
         16#00585E#, 16#007701#, 16#008449#, 16#008AAA#, 16#006BBA#,
         16#006C88#, 16#0062FE#, 16#0082E5#, 16#0063A0#, 16#007565#,
         16#004EAE#, 16#005169#, 16#0051C9#, 16#006881#, 16#007CE7#,
         16#00826F#, 16#008AD2#, 16#0091CF#, 16#0052F5#, 16#005442#,
         16#005EEC#, 16#0065C5#, 16#006FFE#, 16#00792A#, 16#0095AD#,
         16#009A6A#, 16#009E97#, 16#009ECE#, 16#0066C6#, 16#006B77#,
         16#008F62#, 16#005E74#, 16#006190#, 16#006200#, 16#00649A#,
         16#006F23#, 16#007149#, 16#007489#, 16#0079CA#, 16#007DF4#,
         16#00806F#, 16#008F26#, 16#0084EE#, 16#009023#, 16#00934A#,
         16#005217#, 16#0052A3#, 16#0054BD#, 16#0070C8#, 16#0088C2#,
         16#005EC9#, 16#005FF5#, 16#00637B#, 16#006BAE#, 16#007C3E#,
         16#007375#, 16#004EE4#, 16#0056F9#, 16#005DBA#, 16#00601C#,
         16#0073B2#, 16#007469#, 16#007F9A#, 16#008046#, 16#009234#,
         16#0096F6#, 16#009748#, 16#009818#, 16#004F8B#, 16#0079AE#,
         16#0091B4#, 16#0096B8#, 16#0060E1#, 16#004E86#, 16#0050DA#,
         16#005BEE#, 16#005C3F#, 16#006599#, 16#0071CE#, 16#007642#,
         16#0084FC#, 16#00907C#, 16#006688#, 16#00962E#, 16#005289#,
         16#00677B#, 16#0067F3#, 16#006D41#, 16#006E9C#, 16#007409#,
         16#007559#, 16#00786B#, 16#007D10#, 16#00985E#, 16#00622E#,
         16#009678#, 16#00502B#, 16#005D19#, 16#006DEA#, 16#008F2A#,
         16#005F8B#, 16#006144#, 16#006817#, 16#009686#, 16#005229#,
         16#00540F#, 16#005C65#, 16#006613#, 16#00674E#, 16#0068A8#,
         16#006CE5#, 16#007406#, 16#0075E2#, 16#007F79#, 16#0088CF#,
         16#0088E1#, 16#0096E2#, 16#00533F#, 16#006EBA#, 16#00541D#,
         16#0071D0#, 16#007498#, 16#0085FA#, 16#0096A3#, 16#009C57#,
         16#009E9F#, 16#006797#, 16#006DCB#, 16#0081E8#, 16#007B20#,
         16#007C92#, 16#0072C0#, 16#007099#, 16#008B58#, 16#004EC0#,
         16#008336#, 16#00523A#, 16#005207#, 16#005EA6#, 16#0062D3#,
         16#007CD6#, 16#005B85#, 16#006D1E#, 16#0066B4#, 16#008F3B#,
         16#00964D#, 16#005ED3#, 16#005140#, 16#0055C0#, 16#00585A#,
         16#006674#, 16#0051DE#, 16#00732A#, 16#0076CA#, 16#00793C#,
         16#00795E#, 16#007965#, 16#00798F#, 16#009756#, 16#007CBE#,
         16#008612#, 16#008AF8#, 16#009038#, 16#0090FD#, 16#0098EF#,
         16#0098FC#, 16#009928#, 16#009DB4#, 16#0090DE#, 16#0096B7#,
         16#004FAE#, 16#0050E7#, 16#00514D#, 16#0052C9#, 16#0052E4#,
         16#005351#, 16#00559D#, 16#005606#, 16#005668#, 16#005840#,
         16#0058A8#, 16#005C64#, 16#006094#, 16#006168#, 16#00618E#,
         16#0061F2#, 16#00654F#, 16#0065E2#, 16#006691#, 16#006885#,
         16#006D77#, 16#006E1A#, 16#006F22#, 16#00716E#, 16#00722B#,
         16#007422#, 16#007891#, 16#007949#, 16#007948#, 16#007950#,
         16#007956#, 16#00798D#, 16#00798E#, 16#007A40#, 16#007A81#,
         16#007BC0#, 16#007E09#, 16#007E41#, 16#007F72#, 16#008005#,
         16#0081ED#, 16#008279#, 16#008457#, 16#008910#, 16#008996#,
         16#008B01#, 16#008B39#, 16#008CD3#, 16#008D08#, 16#008FB6#,
         16#0096E3#, 16#0097FF#, 16#00983B#, 16#006075#, 16#0242EE#,
         16#008218#, 16#004E26#, 16#0051B5#, 16#005168#, 16#004F80#,
         16#005145#, 16#005180#, 16#0052C7#, 16#0052FA#, 16#005555#,
         16#005599#, 16#0055E2#, 16#0058B3#, 16#005944#, 16#005954#,
         16#005A62#, 16#005B28#, 16#005ED2#, 16#005ED9#, 16#005F69#,
         16#005FAD#, 16#0060D8#, 16#00614E#, 16#006108#, 16#006160#,
         16#006234#, 16#0063C4#, 16#00641C#, 16#006452#, 16#006556#,
         16#00671B#, 16#006756#, 16#006EDB#, 16#006ECB#, 16#00701E#,
         16#0077A7#, 16#007235#, 16#0072AF#, 16#007471#, 16#007506#,
         16#00753B#, 16#00761D#, 16#00761F#, 16#0076DB#, 16#0076F4#,
         16#00774A#, 16#007740#, 16#0078CC#, 16#007AB1#, 16#007C7B#,
         16#007D5B#, 16#007F3E#, 16#008352#, 16#0083EF#, 16#008779#,
         16#008941#, 16#008986#, 16#008ABF#, 16#008ACB#, 16#008AED#,
         16#008B8A#, 16#008F38#, 16#009072#, 16#009199#, 16#009276#,
         16#00967C#, 16#0097DB#, 16#00980B#, 16#009B12#, 16#02284A#,
         16#022844#, 16#0233D5#, 16#003B9D#, 16#004018#, 16#004039#,
         16#025249#, 16#025CD0#, 16#027ED3#, 16#009F43#, 16#009F8E#,
         16#000066#, 16#000066#, 16#000066#, 16#000069#, 16#000066#,
         16#00006C#, 16#000066#, 16#000066#, 16#00006C#, 16#000073#,
         16#000074#, 16#000574#, 16#000576#, 16#000574#, 16#000565#,
         16#000574#, 16#00056B#, 16#00057E#, 16#000576#, 16#000574#,
         16#00056D#, 16#0005D9#, 16#0005B4#, 16#0005F2#, 16#0005B7#,
         16#0005E2#, 16#0005D4#, 16#0005DB#, 16#0005DC#, 16#0005DD#,
         16#0005E8#, 16#0005EA#, 16#0005E9#, 16#0005C1#, 16#0005E9#,
         16#0005C2#, 16#0005E9#, 16#0005BC#, 16#0005C1#, 16#0005E9#,
         16#0005BC#, 16#0005C2#, 16#0005D0#, 16#0005B7#, 16#0005D0#,
         16#0005B8#, 16#0005D0#, 16#0005BC#, 16#0005D1#, 16#0005BC#,
         16#0005D2#, 16#0005BC#, 16#0005D3#, 16#0005BC#, 16#0005D4#,
         16#0005BC#, 16#0005D5#, 16#0005BC#, 16#0005D6#, 16#0005BC#,
         16#0005D8#, 16#0005BC#, 16#0005D9#, 16#0005BC#, 16#0005DA#,
         16#0005BC#, 16#0005DB#, 16#0005BC#, 16#0005DC#, 16#0005BC#,
         16#0005DE#, 16#0005BC#, 16#0005E0#, 16#0005BC#, 16#0005E1#,
         16#0005BC#, 16#0005E3#, 16#0005BC#, 16#0005E4#, 16#0005BC#,
         16#0005E6#, 16#0005BC#, 16#0005E7#, 16#0005BC#, 16#0005E8#,
         16#0005BC#, 16#0005EA#, 16#0005BC#, 16#0005D5#, 16#0005B9#,
         16#0005D1#, 16#0005BF#, 16#0005DB#, 16#0005BF#, 16#0005E4#,
         16#0005BF#, 16#0005D0#, 16#0005DC#, 16#000671#, 16#00067B#,
         16#00067E#, 16#000680#, 16#00067A#, 16#00067F#, 16#000679#,
         16#0006A4#, 16#0006A6#, 16#000684#, 16#000683#, 16#000686#,
         16#000687#, 16#00068D#, 16#00068C#, 16#00068E#, 16#000688#,
         16#000698#, 16#000691#, 16#0006A9#, 16#0006AF#, 16#0006B3#,
         16#0006B1#, 16#0006BA#, 16#0006BB#, 16#0006BE#, 16#0006AD#,
         16#0006C6#, 16#0006C8#, 16#0006CB#, 16#0006C5#, 16#0006C9#,
         16#0006D0#, 16#000649#, 16#00064A#, 16#000654#, 16#0006D5#,
         16#00064A#, 16#000654#, 16#000648#, 16#00064A#, 16#000654#,
         16#0006C7#, 16#00064A#, 16#000654#, 16#0006C6#, 16#00064A#,
         16#000654#, 16#0006C8#, 16#00064A#, 16#000654#, 16#0006D0#,
         16#00064A#, 16#000654#, 16#000649#, 16#0006CC#, 16#00064A#,
         16#000654#, 16#00062C#, 16#00064A#, 16#000654#, 16#00062D#,
         16#00064A#, 16#000654#, 16#000645#, 16#00064A#, 16#000654#,
         16#00064A#, 16#000628#, 16#00062C#, 16#000628#, 16#00062D#,
         16#000628#, 16#00062E#, 16#000628#, 16#000645#, 16#000628#,
         16#000649#, 16#000628#, 16#00064A#, 16#00062A#, 16#00062C#,
         16#00062A#, 16#00062D#, 16#00062A#, 16#00062E#, 16#00062A#,
         16#000645#, 16#00062A#, 16#000649#, 16#00062A#, 16#00064A#,
         16#00062B#, 16#00062C#, 16#00062B#, 16#000645#, 16#00062B#,
         16#000649#, 16#00062B#, 16#00064A#, 16#00062C#, 16#00062D#,
         16#00062C#, 16#000645#, 16#00062D#, 16#000645#, 16#00062E#,
         16#00062C#, 16#00062E#, 16#00062D#, 16#00062E#, 16#000645#,
         16#000633#, 16#00062C#, 16#000633#, 16#00062D#, 16#000633#,
         16#00062E#, 16#000633#, 16#000645#, 16#000635#, 16#00062D#,
         16#000635#, 16#000645#, 16#000636#, 16#00062C#, 16#000636#,
         16#00062D#, 16#000636#, 16#00062E#, 16#000636#, 16#000645#,
         16#000637#, 16#00062D#, 16#000637#, 16#000645#, 16#000638#,
         16#000645#, 16#000639#, 16#00062C#, 16#000639#, 16#000645#,
         16#00063A#, 16#00062C#, 16#00063A#, 16#000645#, 16#000641#,
         16#00062C#, 16#000641#, 16#00062D#, 16#000641#, 16#00062E#,
         16#000641#, 16#000645#, 16#000641#, 16#000649#, 16#000641#,
         16#00064A#, 16#000642#, 16#00062D#, 16#000642#, 16#000645#,
         16#000642#, 16#000649#, 16#000642#, 16#00064A#, 16#000643#,
         16#000627#, 16#000643#, 16#00062C#, 16#000643#, 16#00062D#,
         16#000643#, 16#00062E#, 16#000643#, 16#000644#, 16#000643#,
         16#000645#, 16#000643#, 16#000649#, 16#000643#, 16#00064A#,
         16#000644#, 16#00062C#, 16#000644#, 16#00062D#, 16#000644#,
         16#00062E#, 16#000644#, 16#000645#, 16#000644#, 16#000649#,
         16#000644#, 16#00064A#, 16#000645#, 16#00062C#, 16#000645#,
         16#000645#, 16#000645#, 16#000649#, 16#000646#, 16#00062C#,
         16#000646#, 16#00062D#, 16#000646#, 16#00062E#, 16#000646#,
         16#000645#, 16#000646#, 16#000649#, 16#000646#, 16#00064A#,
         16#000647#, 16#00062C#, 16#000647#, 16#000645#, 16#000647#,
         16#000649#, 16#000647#, 16#00064A#, 16#00064A#, 16#00062D#,
         16#00064A#, 16#00062E#, 16#00064A#, 16#000649#, 16#000630#,
         16#000670#, 16#000631#, 16#000670#, 16#000649#, 16#000670#,
         16#000020#, 16#00064C#, 16#000651#, 16#000020#, 16#00064D#,
         16#000651#, 16#000020#, 16#00064E#, 16#000651#, 16#000020#,
         16#00064F#, 16#000651#, 16#000020#, 16#000650#, 16#000651#,
         16#000020#, 16#000651#, 16#000670#, 16#00064A#, 16#000654#,
         16#000631#, 16#00064A#, 16#000654#, 16#000632#, 16#00064A#,
         16#000654#, 16#000646#, 16#000628#, 16#000631#, 16#000628#,
         16#000632#, 16#000628#, 16#000646#, 16#00062A#, 16#000631#,
         16#00062A#, 16#000632#, 16#00062A#, 16#000646#, 16#00062B#,
         16#000631#, 16#00062B#, 16#000632#, 16#00062B#, 16#000646#,
         16#000645#, 16#000627#, 16#000646#, 16#000631#, 16#000646#,
         16#000632#, 16#000646#, 16#000646#, 16#00064A#, 16#000631#,
         16#00064A#, 16#000632#, 16#00064A#, 16#000646#, 16#00064A#,
         16#000654#, 16#00062E#, 16#00064A#, 16#000654#, 16#000647#,
         16#000628#, 16#000647#, 16#00062A#, 16#000647#, 16#000635#,
         16#00062E#, 16#000644#, 16#000647#, 16#000646#, 16#000647#,
         16#000647#, 16#000670#, 16#00062B#, 16#000647#, 16#000633#,
         16#000647#, 16#000634#, 16#000645#, 16#000634#, 16#000647#,
         16#000640#, 16#00064E#, 16#000651#, 16#000640#, 16#00064F#,
         16#000651#, 16#000640#, 16#000650#, 16#000651#, 16#000637#,
         16#000649#, 16#000637#, 16#00064A#, 16#000639#, 16#000649#,
         16#000639#, 16#00064A#, 16#00063A#, 16#000649#, 16#00063A#,
         16#00064A#, 16#000633#, 16#000649#, 16#000633#, 16#00064A#,
         16#000634#, 16#000649#, 16#000634#, 16#00064A#, 16#00062D#,
         16#000649#, 16#00062C#, 16#000649#, 16#00062E#, 16#000649#,
         16#000635#, 16#000649#, 16#000635#, 16#00064A#, 16#000636#,
         16#000649#, 16#000636#, 16#00064A#, 16#000634#, 16#00062C#,
         16#000634#, 16#00062D#, 16#000634#, 16#00062E#, 16#000634#,
         16#000631#, 16#000633#, 16#000631#, 16#000635#, 16#000631#,
         16#000636#, 16#000631#, 16#000627#, 16#00064B#, 16#00062A#,
         16#00062C#, 16#000645#, 16#00062A#, 16#00062D#, 16#00062C#,
         16#00062A#, 16#00062D#, 16#000645#, 16#00062A#, 16#00062E#,
         16#000645#, 16#00062A#, 16#000645#, 16#00062C#, 16#00062A#,
         16#000645#, 16#00062D#, 16#00062A#, 16#000645#, 16#00062E#,
         16#00062D#, 16#000645#, 16#00064A#, 16#00062D#, 16#000645#,
         16#000649#, 16#000633#, 16#00062D#, 16#00062C#, 16#000633#,
         16#00062C#, 16#00062D#, 16#000633#, 16#00062C#, 16#000649#,
         16#000633#, 16#000645#, 16#00062D#, 16#000633#, 16#000645#,
         16#00062C#, 16#000633#, 16#000645#, 16#000645#, 16#000635#,
         16#00062D#, 16#00062D#, 16#000635#, 16#000645#, 16#000645#,
         16#000634#, 16#00062D#, 16#000645#, 16#000634#, 16#00062C#,
         16#00064A#, 16#000634#, 16#000645#, 16#00062E#, 16#000634#,
         16#000645#, 16#000645#, 16#000636#, 16#00062D#, 16#000649#,
         16#000636#, 16#00062E#, 16#000645#, 16#000637#, 16#000645#,
         16#00062D#, 16#000637#, 16#000645#, 16#000645#, 16#000637#,
         16#000645#, 16#00064A#, 16#000639#, 16#00062C#, 16#000645#,
         16#000639#, 16#000645#, 16#000645#, 16#000639#, 16#000645#,
         16#000649#, 16#00063A#, 16#000645#, 16#000645#, 16#00063A#,
         16#000645#, 16#00064A#, 16#00063A#, 16#000645#, 16#000649#,
         16#000641#, 16#00062E#, 16#000645#, 16#000642#, 16#000645#,
         16#00062D#, 16#000642#, 16#000645#, 16#000645#, 16#000644#,
         16#00062D#, 16#000645#, 16#000644#, 16#00062D#, 16#00064A#,
         16#000644#, 16#00062D#, 16#000649#, 16#000644#, 16#00062C#,
         16#00062C#, 16#000644#, 16#00062E#, 16#000645#, 16#000644#,
         16#000645#, 16#00062D#, 16#000645#, 16#00062D#, 16#00062C#,
         16#000645#, 16#00062D#, 16#00064A#, 16#000645#, 16#00062C#,
         16#00062D#, 16#000645#, 16#00062E#, 16#000645#, 16#000645#,
         16#00062C#, 16#00062E#, 16#000647#, 16#000645#, 16#00062C#,
         16#000647#, 16#000645#, 16#000645#, 16#000646#, 16#00062D#,
         16#000645#, 16#000646#, 16#00062D#, 16#000649#, 16#000646#,
         16#00062C#, 16#000645#, 16#000646#, 16#00062C#, 16#000649#,
         16#000646#, 16#000645#, 16#00064A#, 16#000646#, 16#000645#,
         16#000649#, 16#00064A#, 16#000645#, 16#000645#, 16#000628#,
         16#00062E#, 16#00064A#, 16#00062A#, 16#00062C#, 16#00064A#,
         16#00062A#, 16#00062C#, 16#000649#, 16#00062A#, 16#00062E#,
         16#00064A#, 16#00062A#, 16#00062E#, 16#000649#, 16#00062A#,
         16#000645#, 16#00064A#, 16#00062A#, 16#000645#, 16#000649#,
         16#00062C#, 16#000645#, 16#00064A#, 16#00062C#, 16#00062D#,
         16#000649#, 16#00062C#, 16#000645#, 16#000649#, 16#000633#,
         16#00062E#, 16#000649#, 16#000635#, 16#00062D#, 16#00064A#,
         16#000634#, 16#00062D#, 16#00064A#, 16#000636#, 16#00062D#,
         16#00064A#, 16#000644#, 16#00062C#, 16#00064A#, 16#000644#,
         16#000645#, 16#00064A#, 16#00064A#, 16#00062C#, 16#00064A#,
         16#00064A#, 16#000645#, 16#00064A#, 16#000645#, 16#000645#,
         16#00064A#, 16#000642#, 16#000645#, 16#00064A#, 16#000646#,
         16#00062D#, 16#00064A#, 16#000639#, 16#000645#, 16#00064A#,
         16#000643#, 16#000645#, 16#00064A#, 16#000646#, 16#00062C#,
         16#00062D#, 16#000645#, 16#00062E#, 16#00064A#, 16#000644#,
         16#00062C#, 16#000645#, 16#000643#, 16#000645#, 16#000645#,
         16#00062C#, 16#00062D#, 16#00064A#, 16#00062D#, 16#00062C#,
         16#00064A#, 16#000645#, 16#00062C#, 16#00064A#, 16#000641#,
         16#000645#, 16#00064A#, 16#000628#, 16#00062D#, 16#00064A#,
         16#000633#, 16#00062E#, 16#00064A#, 16#000646#, 16#00062C#,
         16#00064A#, 16#000635#, 16#000644#, 16#0006D2#, 16#000642#,
         16#000644#, 16#0006D2#, 16#000627#, 16#000644#, 16#000644#,
         16#000647#, 16#000627#, 16#000643#, 16#000628#, 16#000631#,
         16#000645#, 16#00062D#, 16#000645#, 16#00062F#, 16#000635#,
         16#000644#, 16#000639#, 16#000645#, 16#000631#, 16#000633#,
         16#000648#, 16#000644#, 16#000639#, 16#000644#, 16#00064A#,
         16#000647#, 16#000648#, 16#000633#, 16#000644#, 16#000645#,
         16#000635#, 16#000644#, 16#000649#, 16#000635#, 16#000644#,
         16#000649#, 16#000020#, 16#000627#, 16#000644#, 16#000644#,
         16#000647#, 16#000020#, 16#000639#, 16#000644#, 16#00064A#,
         16#000647#, 16#000020#, 16#000648#, 16#000633#, 16#000644#,
         16#000645#, 16#00062C#, 16#000644#, 16#000020#, 16#00062C#,
         16#000644#, 16#000627#, 16#000644#, 16#000647#, 16#000631#,
         16#0006CC#, 16#000627#, 16#000644#, 16#00002C#, 16#003001#,
         16#003002#, 16#003016#, 16#003017#, 16#002014#, 16#002013#,
         16#00005F#, 16#00007B#, 16#00007D#, 16#003014#, 16#003015#,
         16#003010#, 16#003011#, 16#00300A#, 16#00300B#, 16#00300C#,
         16#00300D#, 16#00300E#, 16#00300F#, 16#00005B#, 16#00005D#,
         16#000023#, 16#000026#, 16#00002A#, 16#00002D#, 16#00005C#,
         16#000024#, 16#000025#, 16#000040#, 16#000020#, 16#00064B#,
         16#000640#, 16#00064B#, 16#000640#, 16#000651#, 16#000020#,
         16#000652#, 16#000640#, 16#000652#, 16#000621#, 16#000629#,
         16#000644#, 16#000627#, 16#000653#, 16#000644#, 16#000627#,
         16#000654#, 16#000644#, 16#000627#, 16#000655#, 16#000022#,
         16#000027#, 16#00005E#, 16#00007C#, 16#00007E#, 16#002985#,
         16#002986#, 16#0030FB#, 16#0030A5#, 16#0030E3#, 16#0000A2#,
         16#0000A3#, 16#0000AC#, 16#0000A6#, 16#0000A5#, 16#0020A9#,
         16#002502#, 16#002191#, 16#002193#, 16#0025A0#, 16#0025CB#,
         16#011099#, 16#0110BA#, 16#01109B#, 16#0110BA#, 16#0110A5#,
         16#0110BA#, 16#011131#, 16#011127#, 16#011132#, 16#011127#,
         16#011347#, 16#01133E#, 16#011347#, 16#011357#, 16#0114B9#,
         16#0114BA#, 16#0114B9#, 16#0114B0#, 16#0114B9#, 16#0114BD#,
         16#0115B8#, 16#0115AF#, 16#0115B9#, 16#0115AF#, 16#01D157#,
         16#01D165#, 16#01D158#, 16#01D165#, 16#01D158#, 16#01D165#,
         16#01D16E#, 16#01D158#, 16#01D165#, 16#01D16F#, 16#01D158#,
         16#01D165#, 16#01D170#, 16#01D158#, 16#01D165#, 16#01D171#,
         16#01D158#, 16#01D165#, 16#01D172#, 16#01D1B9#, 16#01D165#,
         16#01D1BA#, 16#01D165#, 16#01D1B9#, 16#01D165#, 16#01D16E#,
         16#01D1BA#, 16#01D165#, 16#01D16E#, 16#01D1B9#, 16#01D165#,
         16#01D16F#, 16#01D1BA#, 16#01D165#, 16#01D16F#, 16#000131#,
         16#000237#, 16#000392#, 16#000394#, 16#000396#, 16#00039A#,
         16#00039B#, 16#00039C#, 16#00039D#, 16#00039E#, 16#0003A4#,
         16#0003A6#, 16#0003A7#, 16#0003A8#, 16#002207#, 16#0003B6#,
         16#0003BB#, 16#0003BD#, 16#0003BE#, 16#0003C3#, 16#0003C4#,
         16#0003C8#, 16#002202#, 16#0003DC#, 16#0003DD#, 16#00066E#,
         16#0006A1#, 16#00066F#, 16#000030#, 16#00002C#, 16#000031#,
         16#00002C#, 16#000032#, 16#00002C#, 16#000033#, 16#00002C#,
         16#000034#, 16#00002C#, 16#000035#, 16#00002C#, 16#000036#,
         16#00002C#, 16#000037#, 16#00002C#, 16#000038#, 16#00002C#,
         16#000039#, 16#00002C#, 16#000028#, 16#000041#, 16#000029#,
         16#000028#, 16#000042#, 16#000029#, 16#000028#, 16#000043#,
         16#000029#, 16#000028#, 16#000044#, 16#000029#, 16#000028#,
         16#000045#, 16#000029#, 16#000028#, 16#000046#, 16#000029#,
         16#000028#, 16#000047#, 16#000029#, 16#000028#, 16#000048#,
         16#000029#, 16#000028#, 16#000049#, 16#000029#, 16#000028#,
         16#00004A#, 16#000029#, 16#000028#, 16#00004B#, 16#000029#,
         16#000028#, 16#00004C#, 16#000029#, 16#000028#, 16#00004D#,
         16#000029#, 16#000028#, 16#00004E#, 16#000029#, 16#000028#,
         16#00004F#, 16#000029#, 16#000028#, 16#000050#, 16#000029#,
         16#000028#, 16#000051#, 16#000029#, 16#000028#, 16#000052#,
         16#000029#, 16#000028#, 16#000053#, 16#000029#, 16#000028#,
         16#000054#, 16#000029#, 16#000028#, 16#000055#, 16#000029#,
         16#000028#, 16#000056#, 16#000029#, 16#000028#, 16#000057#,
         16#000029#, 16#000028#, 16#000058#, 16#000029#, 16#000028#,
         16#000059#, 16#000029#, 16#000028#, 16#00005A#, 16#000029#,
         16#003014#, 16#000053#, 16#003015#, 16#000043#, 16#000044#,
         16#000057#, 16#00005A#, 16#000048#, 16#000056#, 16#000053#,
         16#000044#, 16#000053#, 16#000053#, 16#000050#, 16#000050#,
         16#000056#, 16#000057#, 16#000043#, 16#00004D#, 16#000043#,
         16#00004D#, 16#000044#, 16#000044#, 16#00004A#, 16#00307B#,
         16#00304B#, 16#0030B3#, 16#0030B3#, 16#005B57#, 16#0053CC#,
         16#00591A#, 16#0089E3#, 16#004EA4#, 16#006620#, 16#007121#,
         16#00524D#, 16#005F8C#, 16#00518D#, 16#0065B0#, 16#00521D#,
         16#007D42#, 16#008CA9#, 16#0058F0#, 16#005439#, 16#006F14#,
         16#006295#, 16#006355#, 16#00904A#, 16#006307#, 16#006253#,
         16#007981#, 16#007A7A#, 16#005408#, 16#006E80#, 16#007533#,
         16#005272#, 16#0055B6#, 16#003014#, 16#00672C#, 16#003015#,
         16#003014#, 16#004E09#, 16#003015#, 16#003014#, 16#004E8C#,
         16#003015#, 16#003014#, 16#005B89#, 16#003015#, 16#003014#,
         16#0070B9#, 16#003015#, 16#003014#, 16#006253#, 16#003015#,
         16#003014#, 16#0076D7#, 16#003015#, 16#003014#, 16#0052DD#,
         16#003015#, 16#003014#, 16#006557#, 16#003015#, 16#005F97#,
         16#0053EF#, 16#004E3D#, 16#004E38#, 16#004E41#, 16#020122#,
         16#004F60#, 16#004FBB#, 16#005002#, 16#00507A#, 16#005099#,
         16#0050CF#, 16#00349E#, 16#02063A#, 16#005154#, 16#005164#,
         16#005177#, 16#02051C#, 16#0034B9#, 16#005167#, 16#02054B#,
         16#005197#, 16#0051A4#, 16#004ECC#, 16#0051AC#, 16#0291DF#,
         16#005203#, 16#0034DF#, 16#00523B#, 16#005246#, 16#005277#,
         16#003515#, 16#005305#, 16#005306#, 16#005349#, 16#00535A#,
         16#005373#, 16#00537D#, 16#00537F#, 16#020A2C#, 16#007070#,
         16#0053CA#, 16#0053DF#, 16#020B63#, 16#0053EB#, 16#0053F1#,
         16#005406#, 16#00549E#, 16#005438#, 16#005448#, 16#005468#,
         16#0054A2#, 16#0054F6#, 16#005510#, 16#005553#, 16#005563#,
         16#005584#, 16#0055AB#, 16#0055B3#, 16#0055C2#, 16#005716#,
         16#005717#, 16#005651#, 16#005674#, 16#0058EE#, 16#0057CE#,
         16#0057F4#, 16#00580D#, 16#00578B#, 16#005832#, 16#005831#,
         16#0058AC#, 16#0214E4#, 16#0058F2#, 16#0058F7#, 16#005906#,
         16#005922#, 16#005962#, 16#0216A8#, 16#0216EA#, 16#0059EC#,
         16#005A1B#, 16#005A27#, 16#0059D8#, 16#005A66#, 16#0036EE#,
         16#0036FC#, 16#005B08#, 16#005B3E#, 16#0219C8#, 16#005BC3#,
         16#005BD8#, 16#005BF3#, 16#021B18#, 16#005BFF#, 16#005C06#,
         16#005F53#, 16#003781#, 16#005C60#, 16#005CC0#, 16#005C8D#,
         16#021DE4#, 16#005D43#, 16#021DE6#, 16#005D6E#, 16#005D6B#,
         16#005D7C#, 16#005DE1#, 16#005DE2#, 16#00382F#, 16#005DFD#,
         16#005E28#, 16#005E3D#, 16#005E69#, 16#003862#, 16#022183#,
         16#00387C#, 16#005EB0#, 16#005EB3#, 16#005EB6#, 16#02A392#,
         16#022331#, 16#008201#, 16#005F22#, 16#0038C7#, 16#0232B8#,
         16#0261DA#, 16#005F62#, 16#005F6B#, 16#0038E3#, 16#005F9A#,
         16#005FCD#, 16#005FD7#, 16#005FF9#, 16#006081#, 16#00393A#,
         16#00391C#, 16#0226D4#, 16#0060C7#, 16#006148#, 16#00614C#,
         16#00617A#, 16#0061B2#, 16#0061A4#, 16#0061AF#, 16#0061DE#,
         16#00621B#, 16#00625D#, 16#0062B1#, 16#0062D4#, 16#006350#,
         16#022B0C#, 16#00633D#, 16#0062FC#, 16#006368#, 16#006383#,
         16#0063E4#, 16#022BF1#, 16#006422#, 16#0063C5#, 16#0063A9#,
         16#003A2E#, 16#006469#, 16#00647E#, 16#00649D#, 16#006477#,
         16#003A6C#, 16#00656C#, 16#02300A#, 16#0065E3#, 16#0066F8#,
         16#006649#, 16#003B19#, 16#003B08#, 16#003AE4#, 16#005192#,
         16#005195#, 16#006700#, 16#00669C#, 16#0080AD#, 16#0043D9#,
         16#006721#, 16#00675E#, 16#006753#, 16#0233C3#, 16#003B49#,
         16#0067FA#, 16#006785#, 16#006852#, 16#02346D#, 16#00688E#,
         16#00681F#, 16#006914#, 16#006942#, 16#0069A3#, 16#0069EA#,
         16#006AA8#, 16#0236A3#, 16#006ADB#, 16#003C18#, 16#006B21#,
         16#0238A7#, 16#006B54#, 16#003C4E#, 16#006B72#, 16#006B9F#,
         16#006BBB#, 16#023A8D#, 16#021D0B#, 16#023AFA#, 16#006C4E#,
         16#023CBC#, 16#006CBF#, 16#006CCD#, 16#006C67#, 16#006D16#,
         16#006D3E#, 16#006D69#, 16#006D78#, 16#006D85#, 16#023D1E#,
         16#006D34#, 16#006E2F#, 16#006E6E#, 16#003D33#, 16#006EC7#,
         16#023ED1#, 16#006DF9#, 16#006F6E#, 16#023F5E#, 16#023F8E#,
         16#006FC6#, 16#007039#, 16#00701B#, 16#003D96#, 16#00704A#,
         16#00707D#, 16#007077#, 16#0070AD#, 16#020525#, 16#007145#,
         16#024263#, 16#00719C#, 16#0243AB#, 16#007228#, 16#007250#,
         16#024608#, 16#007280#, 16#007295#, 16#024735#, 16#024814#,
         16#00737A#, 16#00738B#, 16#003EAC#, 16#0073A5#, 16#003EB8#,
         16#007447#, 16#00745C#, 16#007485#, 16#0074CA#, 16#003F1B#,
         16#007524#, 16#024C36#, 16#00753E#, 16#024C92#, 16#02219F#,
         16#007610#, 16#024FA1#, 16#024FB8#, 16#025044#, 16#003FFC#,
         16#004008#, 16#0250F3#, 16#0250F2#, 16#025119#, 16#025133#,
         16#00771E#, 16#00771F#, 16#00778B#, 16#004046#, 16#004096#,
         16#02541D#, 16#00784E#, 16#0040E3#, 16#025626#, 16#02569A#,
         16#0256C5#, 16#0079EB#, 16#00412F#, 16#007A4A#, 16#007A4F#,
         16#02597C#, 16#025AA7#, 16#007AEE#, 16#004202#, 16#025BAB#,
         16#007BC6#, 16#007BC9#, 16#004227#, 16#025C80#, 16#007CD2#,
         16#0042A0#, 16#007CE8#, 16#007CE3#, 16#007D00#, 16#025F86#,
         16#007D63#, 16#004301#, 16#007DC7#, 16#007E02#, 16#007E45#,
         16#004334#, 16#026228#, 16#026247#, 16#004359#, 16#0262D9#,
         16#007F7A#, 16#02633E#, 16#007F95#, 16#007FFA#, 16#0264DA#,
         16#026523#, 16#008060#, 16#0265A8#, 16#008070#, 16#02335F#,
         16#0043D5#, 16#0080B2#, 16#008103#, 16#00440B#, 16#00813E#,
         16#005AB5#, 16#0267A7#, 16#0267B5#, 16#023393#, 16#02339C#,
         16#008204#, 16#008F9E#, 16#00446B#, 16#008291#, 16#00828B#,
         16#00829D#, 16#0052B3#, 16#0082B1#, 16#0082B3#, 16#0082BD#,
         16#0082E6#, 16#026B3C#, 16#00831D#, 16#008363#, 16#0083AD#,
         16#008323#, 16#0083BD#, 16#0083E7#, 16#008353#, 16#0083CA#,
         16#0083CC#, 16#0083DC#, 16#026C36#, 16#026D6B#, 16#026CD5#,
         16#00452B#, 16#0084F1#, 16#0084F3#, 16#008516#, 16#0273CA#,
         16#008564#, 16#026F2C#, 16#00455D#, 16#004561#, 16#026FB1#,
         16#0270D2#, 16#00456B#, 16#008650#, 16#008667#, 16#008669#,
         16#0086A9#, 16#008688#, 16#00870E#, 16#0086E2#, 16#008728#,
         16#00876B#, 16#008786#, 16#0045D7#, 16#0087E1#, 16#008801#,
         16#0045F9#, 16#008860#, 16#027667#, 16#0088D7#, 16#0088DE#,
         16#004635#, 16#0088FA#, 16#0034BB#, 16#0278AE#, 16#027966#,
         16#0046BE#, 16#0046C7#, 16#008AA0#, 16#027CA8#, 16#008CAB#,
         16#008CC1#, 16#008D1B#, 16#008D77#, 16#027F2F#, 16#020804#,
         16#008DCB#, 16#008DBC#, 16#008DF0#, 16#0208DE#, 16#008ED4#,
         16#0285D2#, 16#0285ED#, 16#009094#, 16#0090F1#, 16#009111#,
         16#02872E#, 16#00911B#, 16#009238#, 16#0092D7#, 16#0092D8#,
         16#00927C#, 16#0093F9#, 16#009415#, 16#028BFA#, 16#00958B#,
         16#004995#, 16#0095B7#, 16#028D77#, 16#0049E6#, 16#0096C3#,
         16#005DB2#, 16#009723#, 16#029145#, 16#02921A#, 16#004A6E#,
         16#004A76#, 16#0097E0#, 16#02940A#, 16#004AB2#, 16#029496#,
         16#009829#, 16#0295B6#, 16#0098E2#, 16#004B33#, 16#009929#,
         16#0099A7#, 16#0099C2#, 16#0099FE#, 16#004BCE#, 16#029B30#,
         16#009C40#, 16#009CFD#, 16#004CCE#, 16#004CED#, 16#009D67#,
         16#02A0CE#, 16#004CF8#, 16#02A105#, 16#02A20E#, 16#02A291#,
         16#004D56#, 16#009EFE#, 16#009F05#, 16#009F0F#, 16#009F16#,
         16#02A600#);

   Composition_Data : aliased constant Composition_Mapping (1 .. 376, 1 .. 62)
     := (1 => (1 => 16#0000C0#, 2 => 16#0000C1#, 3 => 16#0000C2#,
               4 => 16#0000C3#, 5 => 16#0000C4#, 6 => 16#0000C5#,
               8 => 16#000100#, 9 => 16#000102#, 10 => 16#000104#,
               11 => 16#000226#, 12 => 16#0001CD#, 15 => 16#000200#,
               16 => 16#000202#, 40 => 16#001E00#, 41 => 16#001EA0#,
               47 => 16#001EA2#, others => 16#00FFFF#),
         2 => (2 => 16#000106#, 3 => 16#000108#, 7 => 16#0000C7#,
               11 => 16#00010A#, 12 => 16#00010C#, others => 16#00FFFF#),
         3 => (1 => 16#0000C8#, 2 => 16#0000C9#, 3 => 16#0000CA#,
               4 => 16#001EBC#, 5 => 16#0000CB#, 7 => 16#000228#,
               8 => 16#000112#, 9 => 16#000114#, 10 => 16#000118#,
               11 => 16#000116#, 12 => 16#00011A#, 15 => 16#000204#,
               16 => 16#000206#, 41 => 16#001EB8#, 43 => 16#001E18#,
               44 => 16#001E1A#, 47 => 16#001EBA#, others => 16#00FFFF#),
         4 => (1 => 16#0000CC#, 2 => 16#0000CD#, 3 => 16#0000CE#,
               4 => 16#000128#, 5 => 16#0000CF#, 8 => 16#00012A#,
               9 => 16#00012C#, 10 => 16#00012E#, 11 => 16#000130#,
               12 => 16#0001CF#, 15 => 16#000208#, 16 => 16#00020A#,
               41 => 16#001ECA#, 44 => 16#001E2C#, 47 => 16#001EC8#,
               others => 16#00FFFF#),
         5 => (1 => 16#0001F8#, 2 => 16#000143#, 4 => 16#0000D1#,
               7 => 16#000145#, 11 => 16#001E44#, 12 => 16#000147#,
               41 => 16#001E46#, 42 => 16#001E48#, 43 => 16#001E4A#,
               others => 16#00FFFF#),
         6 => (1 => 16#0000D2#, 2 => 16#0000D3#, 3 => 16#0000D4#,
               4 => 16#0000D5#, 5 => 16#0000D6#, 8 => 16#00014C#,
               9 => 16#00014E#, 10 => 16#0001EA#, 11 => 16#00022E#,
               12 => 16#0001D1#, 13 => 16#000150#, 14 => 16#0001A0#,
               15 => 16#00020C#, 16 => 16#00020E#, 41 => 16#001ECC#,
               47 => 16#001ECE#, others => 16#00FFFF#),
         7 => (1 => 16#0000D9#, 2 => 16#0000DA#, 3 => 16#0000DB#,
               4 => 16#000168#, 5 => 16#0000DC#, 6 => 16#00016E#,
               8 => 16#00016A#, 9 => 16#00016C#, 10 => 16#000172#,
               12 => 16#0001D3#, 13 => 16#000170#, 14 => 16#0001AF#,
               15 => 16#000214#, 16 => 16#000216#, 41 => 16#001EE4#,
               43 => 16#001E76#, 44 => 16#001E74#, 46 => 16#001E72#,
               47 => 16#001EE6#, others => 16#00FFFF#),
         8 => (1 => 16#001EF2#, 2 => 16#0000DD#, 3 => 16#000176#,
               4 => 16#001EF8#, 5 => 16#000178#, 8 => 16#000232#,
               11 => 16#001E8E#, 41 => 16#001EF4#, 47 => 16#001EF6#,
               others => 16#00FFFF#),
         9 => (1 => 16#0000E0#, 2 => 16#0000E1#, 3 => 16#0000E2#,
               4 => 16#0000E3#, 5 => 16#0000E4#, 6 => 16#0000E5#,
               8 => 16#000101#, 9 => 16#000103#, 10 => 16#000105#,
               11 => 16#000227#, 12 => 16#0001CE#, 15 => 16#000201#,
               16 => 16#000203#, 40 => 16#001E01#, 41 => 16#001EA1#,
               47 => 16#001EA3#, others => 16#00FFFF#),
         10 => (2 => 16#000107#, 3 => 16#000109#, 7 => 16#0000E7#,
               11 => 16#00010B#, 12 => 16#00010D#, others => 16#00FFFF#),
         11 => (1 => 16#0000E8#, 2 => 16#0000E9#, 3 => 16#0000EA#,
               4 => 16#001EBD#, 5 => 16#0000EB#, 7 => 16#000229#,
               8 => 16#000113#, 9 => 16#000115#, 10 => 16#000119#,
               11 => 16#000117#, 12 => 16#00011B#, 15 => 16#000205#,
               16 => 16#000207#, 41 => 16#001EB9#, 43 => 16#001E19#,
               44 => 16#001E1B#, 47 => 16#001EBB#, others => 16#00FFFF#),
         12 => (1 => 16#0000EC#, 2 => 16#0000ED#, 3 => 16#0000EE#,
               4 => 16#000129#, 5 => 16#0000EF#, 8 => 16#00012B#,
               9 => 16#00012D#, 10 => 16#00012F#, 12 => 16#0001D0#,
               15 => 16#000209#, 16 => 16#00020B#, 41 => 16#001ECB#,
               44 => 16#001E2D#, 47 => 16#001EC9#, others => 16#00FFFF#),
         13 => (1 => 16#0001F9#, 2 => 16#000144#, 4 => 16#0000F1#,
               7 => 16#000146#, 11 => 16#001E45#, 12 => 16#000148#,
               41 => 16#001E47#, 42 => 16#001E49#, 43 => 16#001E4B#,
               others => 16#00FFFF#),
         14 => (1 => 16#0000F2#, 2 => 16#0000F3#, 3 => 16#0000F4#,
               4 => 16#0000F5#, 5 => 16#0000F6#, 8 => 16#00014D#,
               9 => 16#00014F#, 10 => 16#0001EB#, 11 => 16#00022F#,
               12 => 16#0001D2#, 13 => 16#000151#, 14 => 16#0001A1#,
               15 => 16#00020D#, 16 => 16#00020F#, 41 => 16#001ECD#,
               47 => 16#001ECF#, others => 16#00FFFF#),
         15 => (1 => 16#0000F9#, 2 => 16#0000FA#, 3 => 16#0000FB#,
               4 => 16#000169#, 5 => 16#0000FC#, 6 => 16#00016F#,
               8 => 16#00016B#, 9 => 16#00016D#, 10 => 16#000173#,
               12 => 16#0001D4#, 13 => 16#000171#, 14 => 16#0001B0#,
               15 => 16#000215#, 16 => 16#000217#, 41 => 16#001EE5#,
               43 => 16#001E77#, 44 => 16#001E75#, 46 => 16#001E73#,
               47 => 16#001EE7#, others => 16#00FFFF#),
         16 => (1 => 16#001EF3#, 2 => 16#0000FD#, 3 => 16#000177#,
               4 => 16#001EF9#, 5 => 16#0000FF#, 6 => 16#001E99#,
               8 => 16#000233#, 11 => 16#001E8F#, 41 => 16#001EF5#,
               47 => 16#001EF7#, others => 16#00FFFF#),
         17 => (7 => 16#001E10#, 11 => 16#001E0A#, 12 => 16#00010E#,
               41 => 16#001E0C#, 42 => 16#001E0E#, 43 => 16#001E12#,
               others => 16#00FFFF#),
         18 => (7 => 16#001E11#, 11 => 16#001E0B#, 12 => 16#00010F#,
               41 => 16#001E0D#, 42 => 16#001E0F#, 43 => 16#001E13#,
               others => 16#00FFFF#),
         19 => (2 => 16#0001F4#, 3 => 16#00011C#, 7 => 16#000122#,
               8 => 16#001E20#, 9 => 16#00011E#, 11 => 16#000120#,
               12 => 16#0001E6#, others => 16#00FFFF#),
         20 => (2 => 16#0001F5#, 3 => 16#00011D#, 7 => 16#000123#,
               8 => 16#001E21#, 9 => 16#00011F#, 11 => 16#000121#,
               12 => 16#0001E7#, others => 16#00FFFF#),
         21 => (3 => 16#000124#, 5 => 16#001E26#, 7 => 16#001E28#,
               11 => 16#001E22#, 12 => 16#00021E#, 41 => 16#001E24#,
               45 => 16#001E2A#, others => 16#00FFFF#),
         22 => (3 => 16#000125#, 5 => 16#001E27#, 7 => 16#001E29#,
               11 => 16#001E23#, 12 => 16#00021F#, 41 => 16#001E25#,
               42 => 16#001E96#, 45 => 16#001E2B#, others => 16#00FFFF#),
         23 => (3 => 16#000134#, others => 16#00FFFF#),
         24 => (3 => 16#000135#, 12 => 16#0001F0#, others => 16#00FFFF#),
         25 => (2 => 16#001E30#, 7 => 16#000136#, 12 => 16#0001E8#,
               41 => 16#001E32#, 42 => 16#001E34#, others => 16#00FFFF#),
         26 => (2 => 16#001E31#, 7 => 16#000137#, 12 => 16#0001E9#,
               41 => 16#001E33#, 42 => 16#001E35#, others => 16#00FFFF#),
         27 => (2 => 16#000139#, 7 => 16#00013B#, 12 => 16#00013D#,
               41 => 16#001E36#, 42 => 16#001E3A#, 43 => 16#001E3C#,
               others => 16#00FFFF#),
         28 => (2 => 16#00013A#, 7 => 16#00013C#, 12 => 16#00013E#,
               41 => 16#001E37#, 42 => 16#001E3B#, 43 => 16#001E3D#,
               others => 16#00FFFF#),
         29 => (2 => 16#000154#, 7 => 16#000156#, 11 => 16#001E58#,
               12 => 16#000158#, 15 => 16#000210#, 16 => 16#000212#,
               41 => 16#001E5A#, 42 => 16#001E5E#, others => 16#00FFFF#),
         30 => (2 => 16#000155#, 7 => 16#000157#, 11 => 16#001E59#,
               12 => 16#000159#, 15 => 16#000211#, 16 => 16#000213#,
               41 => 16#001E5B#, 42 => 16#001E5F#, others => 16#00FFFF#),
         31 => (2 => 16#00015A#, 3 => 16#00015C#, 7 => 16#00015E#,
               11 => 16#001E60#, 12 => 16#000160#, 17 => 16#000218#,
               41 => 16#001E62#, others => 16#00FFFF#),
         32 => (2 => 16#00015B#, 3 => 16#00015D#, 7 => 16#00015F#,
               11 => 16#001E61#, 12 => 16#000161#, 17 => 16#000219#,
               41 => 16#001E63#, others => 16#00FFFF#),
         33 => (7 => 16#000162#, 11 => 16#001E6A#, 12 => 16#000164#,
               17 => 16#00021A#, 41 => 16#001E6C#, 42 => 16#001E6E#,
               43 => 16#001E70#, others => 16#00FFFF#),
         34 => (5 => 16#001E97#, 7 => 16#000163#, 11 => 16#001E6B#,
               12 => 16#000165#, 17 => 16#00021B#, 41 => 16#001E6D#,
               42 => 16#001E6F#, 43 => 16#001E71#, others => 16#00FFFF#),
         35 => (1 => 16#001E80#, 2 => 16#001E82#, 3 => 16#000174#,
               5 => 16#001E84#, 11 => 16#001E86#, 41 => 16#001E88#,
               others => 16#00FFFF#),
         36 => (1 => 16#001E81#, 2 => 16#001E83#, 3 => 16#000175#,
               5 => 16#001E85#, 6 => 16#001E98#, 11 => 16#001E87#,
               41 => 16#001E89#, others => 16#00FFFF#),
         37 => (2 => 16#000179#, 3 => 16#001E90#, 11 => 16#00017B#,
               12 => 16#00017D#, 41 => 16#001E92#, 42 => 16#001E94#,
               others => 16#00FFFF#),
         38 => (2 => 16#00017A#, 3 => 16#001E91#, 11 => 16#00017C#,
               12 => 16#00017E#, 41 => 16#001E93#, 42 => 16#001E95#,
               others => 16#00FFFF#),
         39 => (1 => 16#0001DB#, 2 => 16#0001D7#, 8 => 16#0001D5#,
               12 => 16#0001D9#, others => 16#00FFFF#),
         40 => (1 => 16#0001DC#, 2 => 16#0001D8#, 8 => 16#0001D6#,
               12 => 16#0001DA#, others => 16#00FFFF#),
         41 => (8 => 16#0001DE#, others => 16#00FFFF#),
         42 => (8 => 16#0001DF#, others => 16#00FFFF#),
         43 => (8 => 16#0001E0#, others => 16#00FFFF#),
         44 => (8 => 16#0001E1#, others => 16#00FFFF#),
         45 => (2 => 16#0001FC#, 8 => 16#0001E2#, others => 16#00FFFF#),
         46 => (2 => 16#0001FD#, 8 => 16#0001E3#, others => 16#00FFFF#),
         47 => (8 => 16#0001EC#, others => 16#00FFFF#),
         48 => (8 => 16#0001ED#, others => 16#00FFFF#),
         49 => (12 => 16#0001EE#, others => 16#00FFFF#),
         50 => (12 => 16#0001EF#, others => 16#00FFFF#),
         51 => (2 => 16#0001FA#, others => 16#00FFFF#),
         52 => (2 => 16#0001FB#, others => 16#00FFFF#),
         53 => (2 => 16#0001FE#, others => 16#00FFFF#),
         54 => (2 => 16#0001FF#, others => 16#00FFFF#),
         55 => (8 => 16#00022A#, others => 16#00FFFF#),
         56 => (8 => 16#00022B#, others => 16#00FFFF#),
         57 => (2 => 16#001E4C#, 5 => 16#001E4E#, 8 => 16#00022C#,
               others => 16#00FFFF#),
         58 => (2 => 16#001E4D#, 5 => 16#001E4F#, 8 => 16#00022D#,
               others => 16#00FFFF#),
         59 => (8 => 16#000230#, others => 16#00FFFF#),
         60 => (8 => 16#000231#, others => 16#00FFFF#),
         61 => (1 => 16#001FED#, 2 => 16#000385#, 50 => 16#001FC1#,
               others => 16#00FFFF#),
         62 => (1 => 16#001FBA#, 2 => 16#000386#, 8 => 16#001FB9#,
               9 => 16#001FB8#, 48 => 16#001F08#, 49 => 16#001F09#,
               51 => 16#001FBC#, others => 16#00FFFF#),
         63 => (1 => 16#001FC8#, 2 => 16#000388#, 48 => 16#001F18#,
               49 => 16#001F19#, others => 16#00FFFF#),
         64 => (1 => 16#001FCA#, 2 => 16#000389#, 48 => 16#001F28#,
               49 => 16#001F29#, 51 => 16#001FCC#, others => 16#00FFFF#),
         65 => (1 => 16#001FDA#, 2 => 16#00038A#, 5 => 16#0003AA#,
               8 => 16#001FD9#, 9 => 16#001FD8#, 48 => 16#001F38#,
               49 => 16#001F39#, others => 16#00FFFF#),
         66 => (1 => 16#001FF8#, 2 => 16#00038C#, 48 => 16#001F48#,
               49 => 16#001F49#, others => 16#00FFFF#),
         67 => (1 => 16#001FEA#, 2 => 16#00038E#, 5 => 16#0003AB#,
               8 => 16#001FE9#, 9 => 16#001FE8#, 49 => 16#001F59#,
               others => 16#00FFFF#),
         68 => (1 => 16#001FFA#, 2 => 16#00038F#, 48 => 16#001F68#,
               49 => 16#001F69#, 51 => 16#001FFC#, others => 16#00FFFF#),
         69 => (1 => 16#001FD2#, 2 => 16#000390#, 50 => 16#001FD7#,
               others => 16#00FFFF#),
         70 => (1 => 16#001F70#, 2 => 16#0003AC#, 8 => 16#001FB1#,
               9 => 16#001FB0#, 48 => 16#001F00#, 49 => 16#001F01#,
               50 => 16#001FB6#, 51 => 16#001FB3#, others => 16#00FFFF#),
         71 => (1 => 16#001F72#, 2 => 16#0003AD#, 48 => 16#001F10#,
               49 => 16#001F11#, others => 16#00FFFF#),
         72 => (1 => 16#001F74#, 2 => 16#0003AE#, 48 => 16#001F20#,
               49 => 16#001F21#, 50 => 16#001FC6#, 51 => 16#001FC3#,
               others => 16#00FFFF#),
         73 => (1 => 16#001F76#, 2 => 16#0003AF#, 5 => 16#0003CA#,
               8 => 16#001FD1#, 9 => 16#001FD0#, 48 => 16#001F30#,
               49 => 16#001F31#, 50 => 16#001FD6#, others => 16#00FFFF#),
         74 => (1 => 16#001FE2#, 2 => 16#0003B0#, 50 => 16#001FE7#,
               others => 16#00FFFF#),
         75 => (1 => 16#001F7A#, 2 => 16#0003CD#, 5 => 16#0003CB#,
               8 => 16#001FE1#, 9 => 16#001FE0#, 48 => 16#001F50#,
               49 => 16#001F51#, 50 => 16#001FE6#, others => 16#00FFFF#),
         76 => (1 => 16#001F78#, 2 => 16#0003CC#, 48 => 16#001F40#,
               49 => 16#001F41#, others => 16#00FFFF#),
         77 => (1 => 16#001F7C#, 2 => 16#0003CE#, 48 => 16#001F60#,
               49 => 16#001F61#, 50 => 16#001FF6#, 51 => 16#001FF3#,
               others => 16#00FFFF#),
         78 => (2 => 16#0003D3#, 5 => 16#0003D4#, others => 16#00FFFF#),
         79 => (1 => 16#000400#, 5 => 16#000401#, 9 => 16#0004D6#,
               others => 16#00FFFF#),
         80 => (2 => 16#000403#, others => 16#00FFFF#),
         81 => (5 => 16#000407#, others => 16#00FFFF#),
         82 => (2 => 16#00040C#, others => 16#00FFFF#),
         83 => (1 => 16#00040D#, 5 => 16#0004E4#, 8 => 16#0004E2#,
               9 => 16#000419#, others => 16#00FFFF#),
         84 => (5 => 16#0004F0#, 8 => 16#0004EE#, 9 => 16#00040E#,
               13 => 16#0004F2#, others => 16#00FFFF#),
         85 => (1 => 16#00045D#, 5 => 16#0004E5#, 8 => 16#0004E3#,
               9 => 16#000439#, others => 16#00FFFF#),
         86 => (1 => 16#000450#, 5 => 16#000451#, 9 => 16#0004D7#,
               others => 16#00FFFF#),
         87 => (2 => 16#000453#, others => 16#00FFFF#),
         88 => (5 => 16#000457#, others => 16#00FFFF#),
         89 => (2 => 16#00045C#, others => 16#00FFFF#),
         90 => (5 => 16#0004F1#, 8 => 16#0004EF#, 9 => 16#00045E#,
               13 => 16#0004F3#, others => 16#00FFFF#),
         91 => (15 => 16#000476#, others => 16#00FFFF#),
         92 => (15 => 16#000477#, others => 16#00FFFF#),
         93 => (5 => 16#0004DC#, 9 => 16#0004C1#, others => 16#00FFFF#),
         94 => (5 => 16#0004DD#, 9 => 16#0004C2#, others => 16#00FFFF#),
         95 => (5 => 16#0004D2#, 9 => 16#0004D0#, others => 16#00FFFF#),
         96 => (5 => 16#0004D3#, 9 => 16#0004D1#, others => 16#00FFFF#),
         97 => (5 => 16#0004DA#, others => 16#00FFFF#),
         98 => (5 => 16#0004DB#, others => 16#00FFFF#),
         99 => (5 => 16#0004DE#, others => 16#00FFFF#),
         100 => (5 => 16#0004DF#, others => 16#00FFFF#),
         101 => (5 => 16#0004E6#, others => 16#00FFFF#),
         102 => (5 => 16#0004E7#, others => 16#00FFFF#),
         103 => (5 => 16#0004EA#, others => 16#00FFFF#),
         104 => (5 => 16#0004EB#, others => 16#00FFFF#),
         105 => (5 => 16#0004EC#, others => 16#00FFFF#),
         106 => (5 => 16#0004ED#, others => 16#00FFFF#),
         107 => (5 => 16#0004F4#, others => 16#00FFFF#),
         108 => (5 => 16#0004F5#, others => 16#00FFFF#),
         109 => (5 => 16#0004F8#, others => 16#00FFFF#),
         110 => (5 => 16#0004F9#, others => 16#00FFFF#),
         111 => (18 => 16#000622#, 19 => 16#000623#, 20 => 16#000625#,
               others => 16#00FFFF#),
         112 => (19 => 16#000624#, others => 16#00FFFF#),
         113 => (19 => 16#000626#, others => 16#00FFFF#),
         114 => (19 => 16#0006C0#, others => 16#00FFFF#),
         115 => (19 => 16#0006C2#, others => 16#00FFFF#),
         116 => (19 => 16#0006D3#, others => 16#00FFFF#),
         117 => (21 => 16#000929#, others => 16#00FFFF#),
         118 => (21 => 16#000931#, others => 16#00FFFF#),
         119 => (21 => 16#000934#, others => 16#00FFFF#),
         120 => (22 => 16#0009CB#, 23 => 16#0009CC#, others => 16#00FFFF#),
         121 => (24 => 16#000B48#, 25 => 16#000B4B#, 26 => 16#000B4C#,
               others => 16#00FFFF#),
         122 => (27 => 16#000B94#, others => 16#00FFFF#),
         123 => (27 => 16#000BCC#, 28 => 16#000BCA#, others => 16#00FFFF#),
         124 => (28 => 16#000BCB#, others => 16#00FFFF#),
         125 => (29 => 16#000C48#, others => 16#00FFFF#),
         126 => (30 => 16#000CC0#, others => 16#00FFFF#),
         127 => (30 => 16#000CC7#, 31 => 16#000CC8#, 32 => 16#000CCA#,
               others => 16#00FFFF#),
         128 => (30 => 16#000CCB#, others => 16#00FFFF#),
         129 => (33 => 16#000D4A#, 34 => 16#000D4C#, others => 16#00FFFF#),
         130 => (33 => 16#000D4B#, others => 16#00FFFF#),
         131 => (35 => 16#000DDA#, 36 => 16#000DDC#, 37 => 16#000DDE#,
               others => 16#00FFFF#),
         132 => (35 => 16#000DDD#, others => 16#00FFFF#),
         133 => (38 => 16#001026#, others => 16#00FFFF#),
         134 => (39 => 16#001B06#, others => 16#00FFFF#),
         135 => (39 => 16#001B08#, others => 16#00FFFF#),
         136 => (39 => 16#001B0A#, others => 16#00FFFF#),
         137 => (39 => 16#001B0C#, others => 16#00FFFF#),
         138 => (39 => 16#001B0E#, others => 16#00FFFF#),
         139 => (39 => 16#001B12#, others => 16#00FFFF#),
         140 => (39 => 16#001B3B#, others => 16#00FFFF#),
         141 => (39 => 16#001B3D#, others => 16#00FFFF#),
         142 => (39 => 16#001B40#, others => 16#00FFFF#),
         143 => (39 => 16#001B41#, others => 16#00FFFF#),
         144 => (39 => 16#001B43#, others => 16#00FFFF#),
         145 => (11 => 16#001E02#, 41 => 16#001E04#, 42 => 16#001E06#,
               others => 16#00FFFF#),
         146 => (11 => 16#001E03#, 41 => 16#001E05#, 42 => 16#001E07#,
               others => 16#00FFFF#),
         147 => (2 => 16#001E08#, others => 16#00FFFF#),
         148 => (2 => 16#001E09#, others => 16#00FFFF#),
         149 => (1 => 16#001E14#, 2 => 16#001E16#, others => 16#00FFFF#),
         150 => (1 => 16#001E15#, 2 => 16#001E17#, others => 16#00FFFF#),
         151 => (9 => 16#001E1C#, others => 16#00FFFF#),
         152 => (9 => 16#001E1D#, others => 16#00FFFF#),
         153 => (11 => 16#001E1E#, others => 16#00FFFF#),
         154 => (11 => 16#001E1F#, others => 16#00FFFF#),
         155 => (2 => 16#001E2E#, others => 16#00FFFF#),
         156 => (2 => 16#001E2F#, others => 16#00FFFF#),
         157 => (8 => 16#001E38#, others => 16#00FFFF#),
         158 => (8 => 16#001E39#, others => 16#00FFFF#),
         159 => (2 => 16#001E3E#, 11 => 16#001E40#, 41 => 16#001E42#,
               others => 16#00FFFF#),
         160 => (2 => 16#001E3F#, 11 => 16#001E41#, 41 => 16#001E43#,
               others => 16#00FFFF#),
         161 => (1 => 16#001E50#, 2 => 16#001E52#, others => 16#00FFFF#),
         162 => (1 => 16#001E51#, 2 => 16#001E53#, others => 16#00FFFF#),
         163 => (2 => 16#001E54#, 11 => 16#001E56#, others => 16#00FFFF#),
         164 => (2 => 16#001E55#, 11 => 16#001E57#, others => 16#00FFFF#),
         165 => (8 => 16#001E5C#, others => 16#00FFFF#),
         166 => (8 => 16#001E5D#, others => 16#00FFFF#),
         167 => (11 => 16#001E64#, others => 16#00FFFF#),
         168 => (11 => 16#001E65#, others => 16#00FFFF#),
         169 => (11 => 16#001E66#, others => 16#00FFFF#),
         170 => (11 => 16#001E67#, others => 16#00FFFF#),
         171 => (11 => 16#001E68#, others => 16#00FFFF#),
         172 => (11 => 16#001E69#, others => 16#00FFFF#),
         173 => (2 => 16#001E78#, others => 16#00FFFF#),
         174 => (2 => 16#001E79#, others => 16#00FFFF#),
         175 => (5 => 16#001E7A#, others => 16#00FFFF#),
         176 => (5 => 16#001E7B#, others => 16#00FFFF#),
         177 => (4 => 16#001E7C#, 41 => 16#001E7E#, others => 16#00FFFF#),
         178 => (4 => 16#001E7D#, 41 => 16#001E7F#, others => 16#00FFFF#),
         179 => (5 => 16#001E8C#, 11 => 16#001E8A#, others => 16#00FFFF#),
         180 => (5 => 16#001E8D#, 11 => 16#001E8B#, others => 16#00FFFF#),
         181 => (11 => 16#001E9B#, others => 16#00FFFF#),
         182 => (1 => 16#001EA6#, 2 => 16#001EA4#, 4 => 16#001EAA#,
               47 => 16#001EA8#, others => 16#00FFFF#),
         183 => (1 => 16#001EA7#, 2 => 16#001EA5#, 4 => 16#001EAB#,
               47 => 16#001EA9#, others => 16#00FFFF#),
         184 => (3 => 16#001EAC#, 9 => 16#001EB6#, others => 16#00FFFF#),
         185 => (3 => 16#001EAD#, 9 => 16#001EB7#, others => 16#00FFFF#),
         186 => (1 => 16#001EB0#, 2 => 16#001EAE#, 4 => 16#001EB4#,
               47 => 16#001EB2#, others => 16#00FFFF#),
         187 => (1 => 16#001EB1#, 2 => 16#001EAF#, 4 => 16#001EB5#,
               47 => 16#001EB3#, others => 16#00FFFF#),
         188 => (1 => 16#001EC0#, 2 => 16#001EBE#, 4 => 16#001EC4#,
               47 => 16#001EC2#, others => 16#00FFFF#),
         189 => (1 => 16#001EC1#, 2 => 16#001EBF#, 4 => 16#001EC5#,
               47 => 16#001EC3#, others => 16#00FFFF#),
         190 => (3 => 16#001EC6#, others => 16#00FFFF#),
         191 => (3 => 16#001EC7#, others => 16#00FFFF#),
         192 => (1 => 16#001ED2#, 2 => 16#001ED0#, 4 => 16#001ED6#,
               47 => 16#001ED4#, others => 16#00FFFF#),
         193 => (1 => 16#001ED3#, 2 => 16#001ED1#, 4 => 16#001ED7#,
               47 => 16#001ED5#, others => 16#00FFFF#),
         194 => (3 => 16#001ED8#, others => 16#00FFFF#),
         195 => (3 => 16#001ED9#, others => 16#00FFFF#),
         196 => (1 => 16#001EDC#, 2 => 16#001EDA#, 4 => 16#001EE0#,
               41 => 16#001EE2#, 47 => 16#001EDE#, others => 16#00FFFF#),
         197 => (1 => 16#001EDD#, 2 => 16#001EDB#, 4 => 16#001EE1#,
               41 => 16#001EE3#, 47 => 16#001EDF#, others => 16#00FFFF#),
         198 => (1 => 16#001EEA#, 2 => 16#001EE8#, 4 => 16#001EEE#,
               41 => 16#001EF0#, 47 => 16#001EEC#, others => 16#00FFFF#),
         199 => (1 => 16#001EEB#, 2 => 16#001EE9#, 4 => 16#001EEF#,
               41 => 16#001EF1#, 47 => 16#001EED#, others => 16#00FFFF#),
         200 => (1 => 16#001F02#, 2 => 16#001F04#, 50 => 16#001F06#,
               51 => 16#001F80#, others => 16#00FFFF#),
         201 => (1 => 16#001F03#, 2 => 16#001F05#, 50 => 16#001F07#,
               51 => 16#001F81#, others => 16#00FFFF#),
         202 => (1 => 16#001F0A#, 2 => 16#001F0C#, 50 => 16#001F0E#,
               51 => 16#001F88#, others => 16#00FFFF#),
         203 => (1 => 16#001F0B#, 2 => 16#001F0D#, 50 => 16#001F0F#,
               51 => 16#001F89#, others => 16#00FFFF#),
         204 => (1 => 16#001F12#, 2 => 16#001F14#, others => 16#00FFFF#),
         205 => (1 => 16#001F13#, 2 => 16#001F15#, others => 16#00FFFF#),
         206 => (1 => 16#001F1A#, 2 => 16#001F1C#, others => 16#00FFFF#),
         207 => (1 => 16#001F1B#, 2 => 16#001F1D#, others => 16#00FFFF#),
         208 => (1 => 16#001F22#, 2 => 16#001F24#, 50 => 16#001F26#,
               51 => 16#001F90#, others => 16#00FFFF#),
         209 => (1 => 16#001F23#, 2 => 16#001F25#, 50 => 16#001F27#,
               51 => 16#001F91#, others => 16#00FFFF#),
         210 => (1 => 16#001F2A#, 2 => 16#001F2C#, 50 => 16#001F2E#,
               51 => 16#001F98#, others => 16#00FFFF#),
         211 => (1 => 16#001F2B#, 2 => 16#001F2D#, 50 => 16#001F2F#,
               51 => 16#001F99#, others => 16#00FFFF#),
         212 => (1 => 16#001F32#, 2 => 16#001F34#, 50 => 16#001F36#,
               others => 16#00FFFF#),
         213 => (1 => 16#001F33#, 2 => 16#001F35#, 50 => 16#001F37#,
               others => 16#00FFFF#),
         214 => (1 => 16#001F3A#, 2 => 16#001F3C#, 50 => 16#001F3E#,
               others => 16#00FFFF#),
         215 => (1 => 16#001F3B#, 2 => 16#001F3D#, 50 => 16#001F3F#,
               others => 16#00FFFF#),
         216 => (1 => 16#001F42#, 2 => 16#001F44#, others => 16#00FFFF#),
         217 => (1 => 16#001F43#, 2 => 16#001F45#, others => 16#00FFFF#),
         218 => (1 => 16#001F4A#, 2 => 16#001F4C#, others => 16#00FFFF#),
         219 => (1 => 16#001F4B#, 2 => 16#001F4D#, others => 16#00FFFF#),
         220 => (1 => 16#001F52#, 2 => 16#001F54#, 50 => 16#001F56#,
               others => 16#00FFFF#),
         221 => (1 => 16#001F53#, 2 => 16#001F55#, 50 => 16#001F57#,
               others => 16#00FFFF#),
         222 => (1 => 16#001F5B#, 2 => 16#001F5D#, 50 => 16#001F5F#,
               others => 16#00FFFF#),
         223 => (1 => 16#001F62#, 2 => 16#001F64#, 50 => 16#001F66#,
               51 => 16#001FA0#, others => 16#00FFFF#),
         224 => (1 => 16#001F63#, 2 => 16#001F65#, 50 => 16#001F67#,
               51 => 16#001FA1#, others => 16#00FFFF#),
         225 => (1 => 16#001F6A#, 2 => 16#001F6C#, 50 => 16#001F6E#,
               51 => 16#001FA8#, others => 16#00FFFF#),
         226 => (1 => 16#001F6B#, 2 => 16#001F6D#, 50 => 16#001F6F#,
               51 => 16#001FA9#, others => 16#00FFFF#),
         227 => (51 => 16#001F82#, others => 16#00FFFF#),
         228 => (51 => 16#001F83#, others => 16#00FFFF#),
         229 => (51 => 16#001F84#, others => 16#00FFFF#),
         230 => (51 => 16#001F85#, others => 16#00FFFF#),
         231 => (51 => 16#001F86#, others => 16#00FFFF#),
         232 => (51 => 16#001F87#, others => 16#00FFFF#),
         233 => (51 => 16#001F8A#, others => 16#00FFFF#),
         234 => (51 => 16#001F8B#, others => 16#00FFFF#),
         235 => (51 => 16#001F8C#, others => 16#00FFFF#),
         236 => (51 => 16#001F8D#, others => 16#00FFFF#),
         237 => (51 => 16#001F8E#, others => 16#00FFFF#),
         238 => (51 => 16#001F8F#, others => 16#00FFFF#),
         239 => (51 => 16#001F92#, others => 16#00FFFF#),
         240 => (51 => 16#001F93#, others => 16#00FFFF#),
         241 => (51 => 16#001F94#, others => 16#00FFFF#),
         242 => (51 => 16#001F95#, others => 16#00FFFF#),
         243 => (51 => 16#001F96#, others => 16#00FFFF#),
         244 => (51 => 16#001F97#, others => 16#00FFFF#),
         245 => (51 => 16#001F9A#, others => 16#00FFFF#),
         246 => (51 => 16#001F9B#, others => 16#00FFFF#),
         247 => (51 => 16#001F9C#, others => 16#00FFFF#),
         248 => (51 => 16#001F9D#, others => 16#00FFFF#),
         249 => (51 => 16#001F9E#, others => 16#00FFFF#),
         250 => (51 => 16#001F9F#, others => 16#00FFFF#),
         251 => (51 => 16#001FA2#, others => 16#00FFFF#),
         252 => (51 => 16#001FA3#, others => 16#00FFFF#),
         253 => (51 => 16#001FA4#, others => 16#00FFFF#),
         254 => (51 => 16#001FA5#, others => 16#00FFFF#),
         255 => (51 => 16#001FA6#, others => 16#00FFFF#),
         256 => (51 => 16#001FA7#, others => 16#00FFFF#),
         257 => (51 => 16#001FAA#, others => 16#00FFFF#),
         258 => (51 => 16#001FAB#, others => 16#00FFFF#),
         259 => (51 => 16#001FAC#, others => 16#00FFFF#),
         260 => (51 => 16#001FAD#, others => 16#00FFFF#),
         261 => (51 => 16#001FAE#, others => 16#00FFFF#),
         262 => (51 => 16#001FAF#, others => 16#00FFFF#),
         263 => (51 => 16#001FB2#, others => 16#00FFFF#),
         264 => (51 => 16#001FB4#, others => 16#00FFFF#),
         265 => (51 => 16#001FB7#, others => 16#00FFFF#),
         266 => (51 => 16#001FC2#, others => 16#00FFFF#),
         267 => (51 => 16#001FC4#, others => 16#00FFFF#),
         268 => (51 => 16#001FC7#, others => 16#00FFFF#),
         269 => (1 => 16#001FCD#, 2 => 16#001FCE#, 50 => 16#001FCF#,
               others => 16#00FFFF#),
         270 => (1 => 16#001FDD#, 2 => 16#001FDE#, 50 => 16#001FDF#,
               others => 16#00FFFF#),
         271 => (48 => 16#001FE4#, 49 => 16#001FE5#, others => 16#00FFFF#),
         272 => (49 => 16#001FEC#, others => 16#00FFFF#),
         273 => (51 => 16#001FF2#, others => 16#00FFFF#),
         274 => (51 => 16#001FF4#, others => 16#00FFFF#),
         275 => (51 => 16#001FF7#, others => 16#00FFFF#),
         276 => (52 => 16#00219A#, others => 16#00FFFF#),
         277 => (52 => 16#00219B#, others => 16#00FFFF#),
         278 => (52 => 16#0021AE#, others => 16#00FFFF#),
         279 => (52 => 16#0021CD#, others => 16#00FFFF#),
         280 => (52 => 16#0021CE#, others => 16#00FFFF#),
         281 => (52 => 16#0021CF#, others => 16#00FFFF#),
         282 => (52 => 16#002204#, others => 16#00FFFF#),
         283 => (52 => 16#002209#, others => 16#00FFFF#),
         284 => (52 => 16#00220C#, others => 16#00FFFF#),
         285 => (52 => 16#002224#, others => 16#00FFFF#),
         286 => (52 => 16#002226#, others => 16#00FFFF#),
         287 => (52 => 16#002241#, others => 16#00FFFF#),
         288 => (52 => 16#002244#, others => 16#00FFFF#),
         289 => (52 => 16#002247#, others => 16#00FFFF#),
         290 => (52 => 16#002249#, others => 16#00FFFF#),
         291 => (52 => 16#002260#, others => 16#00FFFF#),
         292 => (52 => 16#002262#, others => 16#00FFFF#),
         293 => (52 => 16#00226D#, others => 16#00FFFF#),
         294 => (52 => 16#00226E#, others => 16#00FFFF#),
         295 => (52 => 16#00226F#, others => 16#00FFFF#),
         296 => (52 => 16#002270#, others => 16#00FFFF#),
         297 => (52 => 16#002271#, others => 16#00FFFF#),
         298 => (52 => 16#002274#, others => 16#00FFFF#),
         299 => (52 => 16#002275#, others => 16#00FFFF#),
         300 => (52 => 16#002278#, others => 16#00FFFF#),
         301 => (52 => 16#002279#, others => 16#00FFFF#),
         302 => (52 => 16#002280#, others => 16#00FFFF#),
         303 => (52 => 16#002281#, others => 16#00FFFF#),
         304 => (52 => 16#002284#, others => 16#00FFFF#),
         305 => (52 => 16#002285#, others => 16#00FFFF#),
         306 => (52 => 16#002288#, others => 16#00FFFF#),
         307 => (52 => 16#002289#, others => 16#00FFFF#),
         308 => (52 => 16#0022AC#, others => 16#00FFFF#),
         309 => (52 => 16#0022AD#, others => 16#00FFFF#),
         310 => (52 => 16#0022AE#, others => 16#00FFFF#),
         311 => (52 => 16#0022AF#, others => 16#00FFFF#),
         312 => (52 => 16#0022E0#, others => 16#00FFFF#),
         313 => (52 => 16#0022E1#, others => 16#00FFFF#),
         314 => (52 => 16#0022E2#, others => 16#00FFFF#),
         315 => (52 => 16#0022E3#, others => 16#00FFFF#),
         316 => (52 => 16#0022EA#, others => 16#00FFFF#),
         317 => (52 => 16#0022EB#, others => 16#00FFFF#),
         318 => (52 => 16#0022EC#, others => 16#00FFFF#),
         319 => (52 => 16#0022ED#, others => 16#00FFFF#),
         320 => (53 => 16#00304C#, others => 16#00FFFF#),
         321 => (53 => 16#00304E#, others => 16#00FFFF#),
         322 => (53 => 16#003050#, others => 16#00FFFF#),
         323 => (53 => 16#003052#, others => 16#00FFFF#),
         324 => (53 => 16#003054#, others => 16#00FFFF#),
         325 => (53 => 16#003056#, others => 16#00FFFF#),
         326 => (53 => 16#003058#, others => 16#00FFFF#),
         327 => (53 => 16#00305A#, others => 16#00FFFF#),
         328 => (53 => 16#00305C#, others => 16#00FFFF#),
         329 => (53 => 16#00305E#, others => 16#00FFFF#),
         330 => (53 => 16#003060#, others => 16#00FFFF#),
         331 => (53 => 16#003062#, others => 16#00FFFF#),
         332 => (53 => 16#003065#, others => 16#00FFFF#),
         333 => (53 => 16#003067#, others => 16#00FFFF#),
         334 => (53 => 16#003069#, others => 16#00FFFF#),
         335 => (53 => 16#003070#, 54 => 16#003071#, others => 16#00FFFF#),
         336 => (53 => 16#003073#, 54 => 16#003074#, others => 16#00FFFF#),
         337 => (53 => 16#003076#, 54 => 16#003077#, others => 16#00FFFF#),
         338 => (53 => 16#003079#, 54 => 16#00307A#, others => 16#00FFFF#),
         339 => (53 => 16#00307C#, 54 => 16#00307D#, others => 16#00FFFF#),
         340 => (53 => 16#003094#, others => 16#00FFFF#),
         341 => (53 => 16#00309E#, others => 16#00FFFF#),
         342 => (53 => 16#0030AC#, others => 16#00FFFF#),
         343 => (53 => 16#0030AE#, others => 16#00FFFF#),
         344 => (53 => 16#0030B0#, others => 16#00FFFF#),
         345 => (53 => 16#0030B2#, others => 16#00FFFF#),
         346 => (53 => 16#0030B4#, others => 16#00FFFF#),
         347 => (53 => 16#0030B6#, others => 16#00FFFF#),
         348 => (53 => 16#0030B8#, others => 16#00FFFF#),
         349 => (53 => 16#0030BA#, others => 16#00FFFF#),
         350 => (53 => 16#0030BC#, others => 16#00FFFF#),
         351 => (53 => 16#0030BE#, others => 16#00FFFF#),
         352 => (53 => 16#0030C0#, others => 16#00FFFF#),
         353 => (53 => 16#0030C2#, others => 16#00FFFF#),
         354 => (53 => 16#0030C5#, others => 16#00FFFF#),
         355 => (53 => 16#0030C7#, others => 16#00FFFF#),
         356 => (53 => 16#0030C9#, others => 16#00FFFF#),
         357 => (53 => 16#0030D0#, 54 => 16#0030D1#, others => 16#00FFFF#),
         358 => (53 => 16#0030D3#, 54 => 16#0030D4#, others => 16#00FFFF#),
         359 => (53 => 16#0030D6#, 54 => 16#0030D7#, others => 16#00FFFF#),
         360 => (53 => 16#0030D9#, 54 => 16#0030DA#, others => 16#00FFFF#),
         361 => (53 => 16#0030DC#, 54 => 16#0030DD#, others => 16#00FFFF#),
         362 => (53 => 16#0030F4#, others => 16#00FFFF#),
         363 => (53 => 16#0030F7#, others => 16#00FFFF#),
         364 => (53 => 16#0030F8#, others => 16#00FFFF#),
         365 => (53 => 16#0030F9#, others => 16#00FFFF#),
         366 => (53 => 16#0030FA#, others => 16#00FFFF#),
         367 => (53 => 16#0030FE#, others => 16#00FFFF#),
         368 => (55 => 16#01109A#, others => 16#00FFFF#),
         369 => (55 => 16#01109C#, others => 16#00FFFF#),
         370 => (55 => 16#0110AB#, others => 16#00FFFF#),
         371 => (56 => 16#01112E#, others => 16#00FFFF#),
         372 => (56 => 16#01112F#, others => 16#00FFFF#),
         373 => (57 => 16#01134B#, 58 => 16#01134C#, others => 16#00FFFF#),
         374 => (59 => 16#0114BB#, 60 => 16#0114BC#, 61 => 16#0114BE#,
               others => 16#00FFFF#),
         375 => (62 => 16#0115BA#, others => 16#00FFFF#),
         376 => (62 => 16#0115BB#, others => 16#00FFFF#));

   Group_0000 : aliased constant Normalization_Mapping_Second_Stage
     := (16#3C#           =>  --  003C
          (((0, 0), (0, 0)), (294, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#3D#           =>  --  003D
          (((0, 0), (0, 0)), (291, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#3E#           =>  --  003E
          (((0, 0), (0, 0)), (295, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#41#           =>  --  0041
          (((0, 0), (0, 0)), (1, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#42#           =>  --  0042
          (((0, 0), (0, 0)), (145, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#43#           =>  --  0043
          (((0, 0), (0, 0)), (2, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#44#           =>  --  0044
          (((0, 0), (0, 0)), (17, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#45#           =>  --  0045
          (((0, 0), (0, 0)), (3, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#46#           =>  --  0046
          (((0, 0), (0, 0)), (153, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#47#           =>  --  0047
          (((0, 0), (0, 0)), (19, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#48#           =>  --  0048
          (((0, 0), (0, 0)), (21, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#49#           =>  --  0049
          (((0, 0), (0, 0)), (4, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#4A#           =>  --  004A
          (((0, 0), (0, 0)), (23, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#4B#           =>  --  004B
          (((0, 0), (0, 0)), (25, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#4C#           =>  --  004C
          (((0, 0), (0, 0)), (27, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#4D#           =>  --  004D
          (((0, 0), (0, 0)), (159, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#4E#           =>  --  004E
          (((0, 0), (0, 0)), (5, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#4F#           =>  --  004F
          (((0, 0), (0, 0)), (6, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#50#           =>  --  0050
          (((0, 0), (0, 0)), (163, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#52#           =>  --  0052
          (((0, 0), (0, 0)), (29, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#53#           =>  --  0053
          (((0, 0), (0, 0)), (31, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#54#           =>  --  0054
          (((0, 0), (0, 0)), (33, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#55#           =>  --  0055
          (((0, 0), (0, 0)), (7, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#56#           =>  --  0056
          (((0, 0), (0, 0)), (177, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#57#           =>  --  0057
          (((0, 0), (0, 0)), (35, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#58#           =>  --  0058
          (((0, 0), (0, 0)), (179, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#59#           =>  --  0059
          (((0, 0), (0, 0)), (8, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#5A#           =>  --  005A
          (((0, 0), (0, 0)), (37, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#61#           =>  --  0061
          (((0, 0), (0, 0)), (9, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#62#           =>  --  0062
          (((0, 0), (0, 0)), (146, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#63#           =>  --  0063
          (((0, 0), (0, 0)), (10, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#64#           =>  --  0064
          (((0, 0), (0, 0)), (18, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#65#           =>  --  0065
          (((0, 0), (0, 0)), (11, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#66#           =>  --  0066
          (((0, 0), (0, 0)), (154, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#67#           =>  --  0067
          (((0, 0), (0, 0)), (20, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#68#           =>  --  0068
          (((0, 0), (0, 0)), (22, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#69#           =>  --  0069
          (((0, 0), (0, 0)), (12, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#6A#           =>  --  006A
          (((0, 0), (0, 0)), (24, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#6B#           =>  --  006B
          (((0, 0), (0, 0)), (26, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#6C#           =>  --  006C
          (((0, 0), (0, 0)), (28, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#6D#           =>  --  006D
          (((0, 0), (0, 0)), (160, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#6E#           =>  --  006E
          (((0, 0), (0, 0)), (13, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#6F#           =>  --  006F
          (((0, 0), (0, 0)), (14, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#70#           =>  --  0070
          (((0, 0), (0, 0)), (164, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#72#           =>  --  0072
          (((0, 0), (0, 0)), (30, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#73#           =>  --  0073
          (((0, 0), (0, 0)), (32, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#74#           =>  --  0074
          (((0, 0), (0, 0)), (34, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#75#           =>  --  0075
          (((0, 0), (0, 0)), (15, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#76#           =>  --  0076
          (((0, 0), (0, 0)), (178, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#77#           =>  --  0077
          (((0, 0), (0, 0)), (36, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#78#           =>  --  0078
          (((0, 0), (0, 0)), (180, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#79#           =>  --  0079
          (((0, 0), (0, 0)), (16, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#7A#           =>  --  007A
          (((0, 0), (0, 0)), (38, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#A0#           =>  --  00A0
          (((0, 0), (1, 1)), (0, 0), 0, (Yes, Yes, No, No), No_Break,
           (others => False)),
         16#A8#           =>  --  00A8
          (((0, 0), (2, 3)), (61, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#AA#           =>  --  00AA
          (((0, 0), (4, 4)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#AF#           =>  --  00AF
          (((0, 0), (5, 6)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#B2#           =>  --  00B2
          (((0, 0), (7, 7)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#B3#           =>  --  00B3
          (((0, 0), (8, 8)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#B4#           =>  --  00B4
          (((0, 0), (9, 10)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#B5#           =>  --  00B5
          (((0, 0), (11, 11)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#B8#           =>  --  00B8
          (((0, 0), (12, 13)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#B9#           =>  --  00B9
          (((0, 0), (14, 14)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#BA#           =>  --  00BA
          (((0, 0), (15, 15)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#BC#           =>  --  00BC
          (((0, 0), (16, 18)), (0, 0), 0, (Yes, Yes, No, No), Fraction,
           (Expands_On_NFKD => True,
            others => False)),
         16#BD#           =>  --  00BD
          (((0, 0), (19, 21)), (0, 0), 0, (Yes, Yes, No, No), Fraction,
           (Expands_On_NFKD => True,
            others => False)),
         16#BE#           =>  --  00BE
          (((0, 0), (22, 24)), (0, 0), 0, (Yes, Yes, No, No), Fraction,
           (Expands_On_NFKD => True,
            others => False)),
         16#C0#           =>  --  00C0
          (((25, 26), (25, 26)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#C1#           =>  --  00C1
          (((27, 28), (27, 28)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#C2#           =>  --  00C2
          (((29, 30), (29, 30)), (182, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#C3#           =>  --  00C3
          (((31, 32), (31, 32)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#C4#           =>  --  00C4
          (((33, 34), (33, 34)), (41, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#C5#           =>  --  00C5
          (((35, 36), (35, 36)), (51, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#C6#           =>  --  00C6
          (((0, 0), (0, 0)), (45, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#C7#           =>  --  00C7
          (((37, 38), (37, 38)), (147, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#C8#           =>  --  00C8
          (((39, 40), (39, 40)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#C9#           =>  --  00C9
          (((41, 42), (41, 42)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#CA#           =>  --  00CA
          (((43, 44), (43, 44)), (188, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#CB#           =>  --  00CB
          (((45, 46), (45, 46)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#CC#           =>  --  00CC
          (((47, 48), (47, 48)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#CD#           =>  --  00CD
          (((49, 50), (49, 50)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#CE#           =>  --  00CE
          (((51, 52), (51, 52)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#CF#           =>  --  00CF
          (((53, 54), (53, 54)), (155, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#D1#           =>  --  00D1
          (((55, 56), (55, 56)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#D2#           =>  --  00D2
          (((57, 58), (57, 58)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#D3#           =>  --  00D3
          (((59, 60), (59, 60)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#D4#           =>  --  00D4
          (((61, 62), (61, 62)), (192, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#D5#           =>  --  00D5
          (((63, 64), (63, 64)), (57, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#D6#           =>  --  00D6
          (((65, 66), (65, 66)), (55, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#D8#           =>  --  00D8
          (((0, 0), (0, 0)), (53, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#D9#           =>  --  00D9
          (((67, 68), (67, 68)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#DA#           =>  --  00DA
          (((69, 70), (69, 70)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#DB#           =>  --  00DB
          (((71, 72), (71, 72)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#DC#           =>  --  00DC
          (((73, 74), (73, 74)), (39, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#DD#           =>  --  00DD
          (((75, 76), (75, 76)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#E0#           =>  --  00E0
          (((77, 78), (77, 78)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#E1#           =>  --  00E1
          (((79, 80), (79, 80)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#E2#           =>  --  00E2
          (((81, 82), (81, 82)), (183, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#E3#           =>  --  00E3
          (((83, 84), (83, 84)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#E4#           =>  --  00E4
          (((85, 86), (85, 86)), (42, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#E5#           =>  --  00E5
          (((87, 88), (87, 88)), (52, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#E6#           =>  --  00E6
          (((0, 0), (0, 0)), (46, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#E7#           =>  --  00E7
          (((89, 90), (89, 90)), (148, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#E8#           =>  --  00E8
          (((91, 92), (91, 92)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#E9#           =>  --  00E9
          (((93, 94), (93, 94)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#EA#           =>  --  00EA
          (((95, 96), (95, 96)), (189, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#EB#           =>  --  00EB
          (((97, 98), (97, 98)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#EC#           =>  --  00EC
          (((99, 100), (99, 100)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#ED#           =>  --  00ED
          (((101, 102), (101, 102)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#EE#           =>  --  00EE
          (((103, 104), (103, 104)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#EF#           =>  --  00EF
          (((105, 106), (105, 106)), (156, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#F1#           =>  --  00F1
          (((107, 108), (107, 108)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#F2#           =>  --  00F2
          (((109, 110), (109, 110)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#F3#           =>  --  00F3
          (((111, 112), (111, 112)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#F4#           =>  --  00F4
          (((113, 114), (113, 114)), (193, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#F5#           =>  --  00F5
          (((115, 116), (115, 116)), (58, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#F6#           =>  --  00F6
          (((117, 118), (117, 118)), (56, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#F8#           =>  --  00F8
          (((0, 0), (0, 0)), (54, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#F9#           =>  --  00F9
          (((119, 120), (119, 120)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#FA#           =>  --  00FA
          (((121, 122), (121, 122)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#FB#           =>  --  00FB
          (((123, 124), (123, 124)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#FC#           =>  --  00FC
          (((125, 126), (125, 126)), (40, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#FD#           =>  --  00FD
          (((127, 128), (127, 128)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#FF#           =>  --  00FF
          (((129, 130), (129, 130)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         others           =>
          (((0, 0), (0, 0)), (0, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)));

   Group_0001 : aliased constant Normalization_Mapping_Second_Stage
     := (16#00#           =>  --  0100
          (((131, 132), (131, 132)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#01#           =>  --  0101
          (((133, 134), (133, 134)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#02#           =>  --  0102
          (((135, 136), (135, 136)), (186, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#03#           =>  --  0103
          (((137, 138), (137, 138)), (187, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#04#           =>  --  0104
          (((139, 140), (139, 140)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#05#           =>  --  0105
          (((141, 142), (141, 142)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#06#           =>  --  0106
          (((143, 144), (143, 144)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#07#           =>  --  0107
          (((145, 146), (145, 146)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#08#           =>  --  0108
          (((147, 148), (147, 148)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#09#           =>  --  0109
          (((149, 150), (149, 150)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#0A#           =>  --  010A
          (((151, 152), (151, 152)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#0B#           =>  --  010B
          (((153, 154), (153, 154)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#0C#           =>  --  010C
          (((155, 156), (155, 156)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#0D#           =>  --  010D
          (((157, 158), (157, 158)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#0E#           =>  --  010E
          (((159, 160), (159, 160)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#0F#           =>  --  010F
          (((161, 162), (161, 162)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#12#           =>  --  0112
          (((163, 164), (163, 164)), (149, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#13#           =>  --  0113
          (((165, 166), (165, 166)), (150, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#14#           =>  --  0114
          (((167, 168), (167, 168)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#15#           =>  --  0115
          (((169, 170), (169, 170)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#16#           =>  --  0116
          (((171, 172), (171, 172)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#17#           =>  --  0117
          (((173, 174), (173, 174)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#18#           =>  --  0118
          (((175, 176), (175, 176)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#19#           =>  --  0119
          (((177, 178), (177, 178)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#1A#           =>  --  011A
          (((179, 180), (179, 180)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#1B#           =>  --  011B
          (((181, 182), (181, 182)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#1C#           =>  --  011C
          (((183, 184), (183, 184)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#1D#           =>  --  011D
          (((185, 186), (185, 186)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#1E#           =>  --  011E
          (((187, 188), (187, 188)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#1F#           =>  --  011F
          (((189, 190), (189, 190)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#20#           =>  --  0120
          (((191, 192), (191, 192)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#21#           =>  --  0121
          (((193, 194), (193, 194)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#22#           =>  --  0122
          (((195, 196), (195, 196)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#23#           =>  --  0123
          (((197, 198), (197, 198)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#24#           =>  --  0124
          (((199, 200), (199, 200)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#25#           =>  --  0125
          (((201, 202), (201, 202)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#28#           =>  --  0128
          (((203, 204), (203, 204)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#29#           =>  --  0129
          (((205, 206), (205, 206)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#2A#           =>  --  012A
          (((207, 208), (207, 208)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#2B#           =>  --  012B
          (((209, 210), (209, 210)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#2C#           =>  --  012C
          (((211, 212), (211, 212)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#2D#           =>  --  012D
          (((213, 214), (213, 214)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#2E#           =>  --  012E
          (((215, 216), (215, 216)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#2F#           =>  --  012F
          (((217, 218), (217, 218)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#30#           =>  --  0130
          (((219, 220), (219, 220)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#32#           =>  --  0132
          (((0, 0), (221, 222)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#33#           =>  --  0133
          (((0, 0), (223, 224)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#34#           =>  --  0134
          (((225, 226), (225, 226)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#35#           =>  --  0135
          (((227, 228), (227, 228)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#36#           =>  --  0136
          (((229, 230), (229, 230)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#37#           =>  --  0137
          (((231, 232), (231, 232)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#39#           =>  --  0139
          (((233, 234), (233, 234)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#3A#           =>  --  013A
          (((235, 236), (235, 236)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#3B#           =>  --  013B
          (((237, 238), (237, 238)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#3C#           =>  --  013C
          (((239, 240), (239, 240)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#3D#           =>  --  013D
          (((241, 242), (241, 242)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#3E#           =>  --  013E
          (((243, 244), (243, 244)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#3F#           =>  --  013F
          (((0, 0), (245, 246)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#40#           =>  --  0140
          (((0, 0), (247, 248)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#43#           =>  --  0143
          (((249, 250), (249, 250)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#44#           =>  --  0144
          (((251, 252), (251, 252)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#45#           =>  --  0145
          (((253, 254), (253, 254)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#46#           =>  --  0146
          (((255, 256), (255, 256)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#47#           =>  --  0147
          (((257, 258), (257, 258)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#48#           =>  --  0148
          (((259, 260), (259, 260)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#49#           =>  --  0149
          (((0, 0), (261, 262)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#4C#           =>  --  014C
          (((263, 264), (263, 264)), (161, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#4D#           =>  --  014D
          (((265, 266), (265, 266)), (162, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#4E#           =>  --  014E
          (((267, 268), (267, 268)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#4F#           =>  --  014F
          (((269, 270), (269, 270)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#50#           =>  --  0150
          (((271, 272), (271, 272)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#51#           =>  --  0151
          (((273, 274), (273, 274)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#54#           =>  --  0154
          (((275, 276), (275, 276)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#55#           =>  --  0155
          (((277, 278), (277, 278)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#56#           =>  --  0156
          (((279, 280), (279, 280)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#57#           =>  --  0157
          (((281, 282), (281, 282)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#58#           =>  --  0158
          (((283, 284), (283, 284)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#59#           =>  --  0159
          (((285, 286), (285, 286)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#5A#           =>  --  015A
          (((287, 288), (287, 288)), (167, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#5B#           =>  --  015B
          (((289, 290), (289, 290)), (168, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#5C#           =>  --  015C
          (((291, 292), (291, 292)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#5D#           =>  --  015D
          (((293, 294), (293, 294)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#5E#           =>  --  015E
          (((295, 296), (295, 296)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#5F#           =>  --  015F
          (((297, 298), (297, 298)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#60#           =>  --  0160
          (((299, 300), (299, 300)), (169, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#61#           =>  --  0161
          (((301, 302), (301, 302)), (170, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#62#           =>  --  0162
          (((303, 304), (303, 304)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#63#           =>  --  0163
          (((305, 306), (305, 306)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#64#           =>  --  0164
          (((307, 308), (307, 308)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#65#           =>  --  0165
          (((309, 310), (309, 310)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#68#           =>  --  0168
          (((311, 312), (311, 312)), (173, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#69#           =>  --  0169
          (((313, 314), (313, 314)), (174, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#6A#           =>  --  016A
          (((315, 316), (315, 316)), (175, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#6B#           =>  --  016B
          (((317, 318), (317, 318)), (176, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#6C#           =>  --  016C
          (((319, 320), (319, 320)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#6D#           =>  --  016D
          (((321, 322), (321, 322)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#6E#           =>  --  016E
          (((323, 324), (323, 324)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#6F#           =>  --  016F
          (((325, 326), (325, 326)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#70#           =>  --  0170
          (((327, 328), (327, 328)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#71#           =>  --  0171
          (((329, 330), (329, 330)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#72#           =>  --  0172
          (((331, 332), (331, 332)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#73#           =>  --  0173
          (((333, 334), (333, 334)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#74#           =>  --  0174
          (((335, 336), (335, 336)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#75#           =>  --  0175
          (((337, 338), (337, 338)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#76#           =>  --  0176
          (((339, 340), (339, 340)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#77#           =>  --  0177
          (((341, 342), (341, 342)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#78#           =>  --  0178
          (((343, 344), (343, 344)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#79#           =>  --  0179
          (((345, 346), (345, 346)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#7A#           =>  --  017A
          (((347, 348), (347, 348)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#7B#           =>  --  017B
          (((349, 350), (349, 350)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#7C#           =>  --  017C
          (((351, 352), (351, 352)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#7D#           =>  --  017D
          (((353, 354), (353, 354)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#7E#           =>  --  017E
          (((355, 356), (355, 356)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#7F#           =>  --  017F
          (((0, 0), (289, 289)), (181, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#A0#           =>  --  01A0
          (((357, 358), (357, 358)), (196, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#A1#           =>  --  01A1
          (((359, 360), (359, 360)), (197, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#AF#           =>  --  01AF
          (((361, 362), (361, 362)), (198, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#B0#           =>  --  01B0
          (((363, 364), (363, 364)), (199, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#B7#           =>  --  01B7
          (((0, 0), (0, 0)), (49, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#C4#           =>  --  01C4
          (((0, 0), (365, 367)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#C5#           =>  --  01C5
          (((0, 0), (368, 370)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#C6#           =>  --  01C6
          (((0, 0), (371, 373)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#C7#           =>  --  01C7
          (((0, 0), (374, 375)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#C8#           =>  --  01C8
          (((0, 0), (376, 377)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#C9#           =>  --  01C9
          (((0, 0), (378, 379)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#CA#           =>  --  01CA
          (((0, 0), (380, 381)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#CB#           =>  --  01CB
          (((0, 0), (382, 383)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#CC#           =>  --  01CC
          (((0, 0), (384, 385)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#CD#           =>  --  01CD
          (((386, 387), (386, 387)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#CE#           =>  --  01CE
          (((388, 389), (388, 389)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#CF#           =>  --  01CF
          (((390, 391), (390, 391)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#D0#           =>  --  01D0
          (((392, 393), (392, 393)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#D1#           =>  --  01D1
          (((394, 395), (394, 395)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#D2#           =>  --  01D2
          (((396, 397), (396, 397)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#D3#           =>  --  01D3
          (((398, 399), (398, 399)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#D4#           =>  --  01D4
          (((400, 401), (400, 401)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#D5#           =>  --  01D5
          (((402, 404), (402, 404)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#D6#           =>  --  01D6
          (((405, 407), (405, 407)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#D7#           =>  --  01D7
          (((408, 410), (408, 410)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#D8#           =>  --  01D8
          (((411, 413), (411, 413)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#D9#           =>  --  01D9
          (((414, 416), (414, 416)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#DA#           =>  --  01DA
          (((417, 419), (417, 419)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#DB#           =>  --  01DB
          (((420, 422), (420, 422)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#DC#           =>  --  01DC
          (((423, 425), (423, 425)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#DE#           =>  --  01DE
          (((426, 428), (426, 428)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#DF#           =>  --  01DF
          (((429, 431), (429, 431)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#E0#           =>  --  01E0
          (((432, 434), (432, 434)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#E1#           =>  --  01E1
          (((435, 437), (435, 437)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#E2#           =>  --  01E2
          (((438, 439), (438, 439)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#E3#           =>  --  01E3
          (((440, 441), (440, 441)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#E6#           =>  --  01E6
          (((442, 443), (442, 443)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#E7#           =>  --  01E7
          (((444, 445), (444, 445)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#E8#           =>  --  01E8
          (((446, 447), (446, 447)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#E9#           =>  --  01E9
          (((448, 449), (448, 449)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#EA#           =>  --  01EA
          (((450, 451), (450, 451)), (47, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#EB#           =>  --  01EB
          (((452, 453), (452, 453)), (48, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#EC#           =>  --  01EC
          (((454, 456), (454, 456)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#ED#           =>  --  01ED
          (((457, 459), (457, 459)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#EE#           =>  --  01EE
          (((460, 461), (460, 461)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#EF#           =>  --  01EF
          (((462, 463), (462, 463)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#F0#           =>  --  01F0
          (((464, 465), (464, 465)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#F1#           =>  --  01F1
          (((0, 0), (365, 366)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#F2#           =>  --  01F2
          (((0, 0), (368, 369)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#F3#           =>  --  01F3
          (((0, 0), (371, 372)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#F4#           =>  --  01F4
          (((466, 467), (466, 467)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#F5#           =>  --  01F5
          (((468, 469), (468, 469)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#F8#           =>  --  01F8
          (((470, 471), (470, 471)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#F9#           =>  --  01F9
          (((472, 473), (472, 473)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#FA#           =>  --  01FA
          (((474, 476), (474, 476)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#FB#           =>  --  01FB
          (((477, 479), (477, 479)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#FC#           =>  --  01FC
          (((480, 481), (480, 481)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#FD#           =>  --  01FD
          (((482, 483), (482, 483)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#FE#           =>  --  01FE
          (((484, 485), (484, 485)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#FF#           =>  --  01FF
          (((486, 487), (486, 487)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         others           =>
          (((0, 0), (0, 0)), (0, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)));

   Group_0002 : aliased constant Normalization_Mapping_Second_Stage
     := (16#00#           =>  --  0200
          (((488, 489), (488, 489)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#01#           =>  --  0201
          (((490, 491), (490, 491)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#02#           =>  --  0202
          (((492, 493), (492, 493)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#03#           =>  --  0203
          (((494, 495), (494, 495)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#04#           =>  --  0204
          (((496, 497), (496, 497)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#05#           =>  --  0205
          (((498, 499), (498, 499)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#06#           =>  --  0206
          (((500, 501), (500, 501)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#07#           =>  --  0207
          (((502, 503), (502, 503)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#08#           =>  --  0208
          (((504, 505), (504, 505)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#09#           =>  --  0209
          (((506, 507), (506, 507)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#0A#           =>  --  020A
          (((508, 509), (508, 509)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#0B#           =>  --  020B
          (((510, 511), (510, 511)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#0C#           =>  --  020C
          (((512, 513), (512, 513)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#0D#           =>  --  020D
          (((514, 515), (514, 515)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#0E#           =>  --  020E
          (((516, 517), (516, 517)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#0F#           =>  --  020F
          (((518, 519), (518, 519)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#10#           =>  --  0210
          (((520, 521), (520, 521)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#11#           =>  --  0211
          (((522, 523), (522, 523)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#12#           =>  --  0212
          (((524, 525), (524, 525)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#13#           =>  --  0213
          (((526, 527), (526, 527)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#14#           =>  --  0214
          (((528, 529), (528, 529)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#15#           =>  --  0215
          (((530, 531), (530, 531)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#16#           =>  --  0216
          (((532, 533), (532, 533)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#17#           =>  --  0217
          (((534, 535), (534, 535)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#18#           =>  --  0218
          (((536, 537), (536, 537)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#19#           =>  --  0219
          (((538, 539), (538, 539)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#1A#           =>  --  021A
          (((540, 541), (540, 541)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#1B#           =>  --  021B
          (((542, 543), (542, 543)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#1E#           =>  --  021E
          (((544, 545), (544, 545)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#1F#           =>  --  021F
          (((546, 547), (546, 547)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#26#           =>  --  0226
          (((432, 433), (432, 433)), (43, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#27#           =>  --  0227
          (((435, 436), (435, 436)), (44, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#28#           =>  --  0228
          (((548, 549), (548, 549)), (151, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#29#           =>  --  0229
          (((550, 551), (550, 551)), (152, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#2A#           =>  --  022A
          (((552, 554), (552, 554)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#2B#           =>  --  022B
          (((555, 557), (555, 557)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#2C#           =>  --  022C
          (((558, 560), (558, 560)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#2D#           =>  --  022D
          (((561, 563), (561, 563)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#2E#           =>  --  022E
          (((564, 565), (564, 565)), (59, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#2F#           =>  --  022F
          (((566, 567), (566, 567)), (60, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#30#           =>  --  0230
          (((568, 570), (568, 570)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#31#           =>  --  0231
          (((571, 573), (571, 573)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#32#           =>  --  0232
          (((574, 575), (574, 575)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#33#           =>  --  0233
          (((576, 577), (576, 577)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#92#           =>  --  0292
          (((0, 0), (0, 0)), (50, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#B0#           =>  --  02B0
          (((0, 0), (201, 201)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#B1#           =>  --  02B1
          (((0, 0), (578, 578)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#B2#           =>  --  02B2
          (((0, 0), (224, 224)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#B3#           =>  --  02B3
          (((0, 0), (277, 277)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#B4#           =>  --  02B4
          (((0, 0), (579, 579)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#B5#           =>  --  02B5
          (((0, 0), (580, 580)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#B6#           =>  --  02B6
          (((0, 0), (581, 581)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#B7#           =>  --  02B7
          (((0, 0), (337, 337)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#B8#           =>  --  02B8
          (((0, 0), (127, 127)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#D8#           =>  --  02D8
          (((0, 0), (582, 583)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#D9#           =>  --  02D9
          (((0, 0), (584, 585)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#DA#           =>  --  02DA
          (((0, 0), (586, 587)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#DB#           =>  --  02DB
          (((0, 0), (588, 589)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#DC#           =>  --  02DC
          (((0, 0), (590, 591)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#DD#           =>  --  02DD
          (((0, 0), (592, 593)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#E0#           =>  --  02E0
          (((0, 0), (594, 594)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#E1#           =>  --  02E1
          (((0, 0), (235, 235)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#E2#           =>  --  02E2
          (((0, 0), (289, 289)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#E3#           =>  --  02E3
          (((0, 0), (595, 595)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#E4#           =>  --  02E4
          (((0, 0), (596, 596)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         others           =>
          (((0, 0), (0, 0)), (0, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)));

   Group_0003 : aliased constant Normalization_Mapping_Second_Stage
     := (16#00#           =>  --  0300
          (((0, 0), (0, 0)), (0, 1), 230, (Maybe, Yes, Maybe, Yes), None,
           (others => False)),
         16#01#           =>  --  0301
          (((0, 0), (0, 0)), (0, 2), 230, (Maybe, Yes, Maybe, Yes), None,
           (others => False)),
         16#02#           =>  --  0302
          (((0, 0), (0, 0)), (0, 3), 230, (Maybe, Yes, Maybe, Yes), None,
           (others => False)),
         16#03#           =>  --  0303
          (((0, 0), (0, 0)), (0, 4), 230, (Maybe, Yes, Maybe, Yes), None,
           (others => False)),
         16#04#           =>  --  0304
          (((0, 0), (0, 0)), (0, 8), 230, (Maybe, Yes, Maybe, Yes), None,
           (others => False)),
         16#05#           =>  --  0305
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#06#           =>  --  0306
          (((0, 0), (0, 0)), (0, 9), 230, (Maybe, Yes, Maybe, Yes), None,
           (others => False)),
         16#07#           =>  --  0307
          (((0, 0), (0, 0)), (0, 11), 230, (Maybe, Yes, Maybe, Yes), None,
           (others => False)),
         16#08#           =>  --  0308
          (((0, 0), (0, 0)), (0, 5), 230, (Maybe, Yes, Maybe, Yes), None,
           (others => False)),
         16#09#           =>  --  0309
          (((0, 0), (0, 0)), (0, 47), 230, (Maybe, Yes, Maybe, Yes), None,
           (others => False)),
         16#0A#           =>  --  030A
          (((0, 0), (0, 0)), (0, 6), 230, (Maybe, Yes, Maybe, Yes), None,
           (others => False)),
         16#0B#           =>  --  030B
          (((0, 0), (0, 0)), (0, 13), 230, (Maybe, Yes, Maybe, Yes), None,
           (others => False)),
         16#0C#           =>  --  030C
          (((0, 0), (0, 0)), (0, 12), 230, (Maybe, Yes, Maybe, Yes), None,
           (others => False)),
         16#0D# .. 16#0E# =>  --  030D .. 030E
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#0F#           =>  --  030F
          (((0, 0), (0, 0)), (0, 15), 230, (Maybe, Yes, Maybe, Yes), None,
           (others => False)),
         16#10#           =>  --  0310
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#11#           =>  --  0311
          (((0, 0), (0, 0)), (0, 16), 230, (Maybe, Yes, Maybe, Yes), None,
           (others => False)),
         16#12#           =>  --  0312
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#13#           =>  --  0313
          (((0, 0), (0, 0)), (0, 48), 230, (Maybe, Yes, Maybe, Yes), None,
           (others => False)),
         16#14#           =>  --  0314
          (((0, 0), (0, 0)), (0, 49), 230, (Maybe, Yes, Maybe, Yes), None,
           (others => False)),
         16#15#           =>  --  0315
          (((0, 0), (0, 0)), (0, 0), 232, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#16# .. 16#19# =>  --  0316 .. 0319
          (((0, 0), (0, 0)), (0, 0), 220, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#1A#           =>  --  031A
          (((0, 0), (0, 0)), (0, 0), 232, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#1B#           =>  --  031B
          (((0, 0), (0, 0)), (0, 14), 216, (Maybe, Yes, Maybe, Yes), None,
           (others => False)),
         16#1C# .. 16#20# =>  --  031C .. 0320
          (((0, 0), (0, 0)), (0, 0), 220, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#21# .. 16#22# =>  --  0321 .. 0322
          (((0, 0), (0, 0)), (0, 0), 202, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#23#           =>  --  0323
          (((0, 0), (0, 0)), (0, 41), 220, (Maybe, Yes, Maybe, Yes), None,
           (others => False)),
         16#24#           =>  --  0324
          (((0, 0), (0, 0)), (0, 46), 220, (Maybe, Yes, Maybe, Yes), None,
           (others => False)),
         16#25#           =>  --  0325
          (((0, 0), (0, 0)), (0, 40), 220, (Maybe, Yes, Maybe, Yes), None,
           (others => False)),
         16#26#           =>  --  0326
          (((0, 0), (0, 0)), (0, 17), 220, (Maybe, Yes, Maybe, Yes), None,
           (others => False)),
         16#27#           =>  --  0327
          (((0, 0), (0, 0)), (0, 7), 202, (Maybe, Yes, Maybe, Yes), None,
           (others => False)),
         16#28#           =>  --  0328
          (((0, 0), (0, 0)), (0, 10), 202, (Maybe, Yes, Maybe, Yes), None,
           (others => False)),
         16#29# .. 16#2C# =>  --  0329 .. 032C
          (((0, 0), (0, 0)), (0, 0), 220, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#2D#           =>  --  032D
          (((0, 0), (0, 0)), (0, 43), 220, (Maybe, Yes, Maybe, Yes), None,
           (others => False)),
         16#2E#           =>  --  032E
          (((0, 0), (0, 0)), (0, 45), 220, (Maybe, Yes, Maybe, Yes), None,
           (others => False)),
         16#2F#           =>  --  032F
          (((0, 0), (0, 0)), (0, 0), 220, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#30#           =>  --  0330
          (((0, 0), (0, 0)), (0, 44), 220, (Maybe, Yes, Maybe, Yes), None,
           (others => False)),
         16#31#           =>  --  0331
          (((0, 0), (0, 0)), (0, 42), 220, (Maybe, Yes, Maybe, Yes), None,
           (others => False)),
         16#32# .. 16#33# =>  --  0332 .. 0333
          (((0, 0), (0, 0)), (0, 0), 220, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#34# .. 16#37# =>  --  0334 .. 0337
          (((0, 0), (0, 0)), (0, 0), 1, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#38#           =>  --  0338
          (((0, 0), (0, 0)), (0, 52), 1, (Maybe, Yes, Maybe, Yes), None,
           (others => False)),
         16#39# .. 16#3C# =>  --  0339 .. 033C
          (((0, 0), (0, 0)), (0, 0), 220, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#3D# .. 16#3F# =>  --  033D .. 033F
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#40#           =>  --  0340
          (((26, 26), (26, 26)), (0, 0), 230, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#41#           =>  --  0341
          (((10, 10), (10, 10)), (0, 0), 230, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#42#           =>  --  0342
          (((0, 0), (0, 0)), (0, 50), 230, (Maybe, Yes, Maybe, Yes), None,
           (others => False)),
         16#43#           =>  --  0343
          (((597, 597), (597, 597)), (0, 0), 230, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#44#           =>  --  0344
          (((409, 410), (409, 410)), (0, 0), 230, (No, No, No, No), Canonical,
           (Composition_Exclusion
              | Expands_On_NFKC => False,
            others => True)),
         16#45#           =>  --  0345
          (((0, 0), (0, 0)), (0, 51), 240, (Maybe, Yes, Maybe, Yes), None,
           (others => False)),
         16#46#           =>  --  0346
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#47# .. 16#49# =>  --  0347 .. 0349
          (((0, 0), (0, 0)), (0, 0), 220, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#4A# .. 16#4C# =>  --  034A .. 034C
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#4D# .. 16#4E# =>  --  034D .. 034E
          (((0, 0), (0, 0)), (0, 0), 220, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#50# .. 16#52# =>  --  0350 .. 0352
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#53# .. 16#56# =>  --  0353 .. 0356
          (((0, 0), (0, 0)), (0, 0), 220, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#57#           =>  --  0357
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#58#           =>  --  0358
          (((0, 0), (0, 0)), (0, 0), 232, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#59# .. 16#5A# =>  --  0359 .. 035A
          (((0, 0), (0, 0)), (0, 0), 220, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#5B#           =>  --  035B
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#5C#           =>  --  035C
          (((0, 0), (0, 0)), (0, 0), 233, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#5D# .. 16#5E# =>  --  035D .. 035E
          (((0, 0), (0, 0)), (0, 0), 234, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#5F#           =>  --  035F
          (((0, 0), (0, 0)), (0, 0), 233, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#60# .. 16#61# =>  --  0360 .. 0361
          (((0, 0), (0, 0)), (0, 0), 234, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#62#           =>  --  0362
          (((0, 0), (0, 0)), (0, 0), 233, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#63# .. 16#6F# =>  --  0363 .. 036F
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#74#           =>  --  0374
          (((598, 598), (598, 598)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#7A#           =>  --  037A
          (((0, 0), (599, 600)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#7E#           =>  --  037E
          (((601, 601), (601, 601)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#84#           =>  --  0384
          (((0, 0), (9, 10)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#85#           =>  --  0385
          (((605, 606), (602, 604)), (0, 0), 0, (Yes, No, No, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#86#           =>  --  0386
          (((607, 608), (607, 608)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#87#           =>  --  0387
          (((246, 246), (246, 246)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#88#           =>  --  0388
          (((609, 610), (609, 610)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#89#           =>  --  0389
          (((611, 612), (611, 612)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#8A#           =>  --  038A
          (((613, 614), (613, 614)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#8C#           =>  --  038C
          (((615, 616), (615, 616)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#8E#           =>  --  038E
          (((617, 618), (617, 618)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#8F#           =>  --  038F
          (((619, 620), (619, 620)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#90#           =>  --  0390
          (((621, 623), (621, 623)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#91#           =>  --  0391
          (((0, 0), (0, 0)), (62, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#95#           =>  --  0395
          (((0, 0), (0, 0)), (63, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#97#           =>  --  0397
          (((0, 0), (0, 0)), (64, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#99#           =>  --  0399
          (((0, 0), (0, 0)), (65, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#9F#           =>  --  039F
          (((0, 0), (0, 0)), (66, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#A1#           =>  --  03A1
          (((0, 0), (0, 0)), (272, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#A5#           =>  --  03A5
          (((0, 0), (0, 0)), (67, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#A9#           =>  --  03A9
          (((0, 0), (0, 0)), (68, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#AA#           =>  --  03AA
          (((624, 625), (624, 625)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#AB#           =>  --  03AB
          (((626, 627), (626, 627)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#AC#           =>  --  03AC
          (((628, 629), (628, 629)), (264, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#AD#           =>  --  03AD
          (((630, 631), (630, 631)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#AE#           =>  --  03AE
          (((632, 633), (632, 633)), (267, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#AF#           =>  --  03AF
          (((634, 635), (634, 635)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#B0#           =>  --  03B0
          (((636, 638), (636, 638)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#B1#           =>  --  03B1
          (((0, 0), (0, 0)), (70, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#B5#           =>  --  03B5
          (((0, 0), (0, 0)), (71, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#B7#           =>  --  03B7
          (((0, 0), (0, 0)), (72, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#B9#           =>  --  03B9
          (((0, 0), (0, 0)), (73, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#BF#           =>  --  03BF
          (((0, 0), (0, 0)), (76, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#C1#           =>  --  03C1
          (((0, 0), (0, 0)), (271, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#C5#           =>  --  03C5
          (((0, 0), (0, 0)), (75, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#C9#           =>  --  03C9
          (((0, 0), (0, 0)), (77, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#CA#           =>  --  03CA
          (((621, 622), (621, 622)), (69, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#CB#           =>  --  03CB
          (((636, 637), (636, 637)), (74, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#CC#           =>  --  03CC
          (((639, 640), (639, 640)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#CD#           =>  --  03CD
          (((641, 642), (641, 642)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#CE#           =>  --  03CE
          (((643, 644), (643, 644)), (274, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#D0#           =>  --  03D0
          (((0, 0), (645, 645)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#D1#           =>  --  03D1
          (((0, 0), (646, 646)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#D2#           =>  --  03D2
          (((0, 0), (617, 617)), (78, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#D3#           =>  --  03D3
          (((647, 648), (617, 618)), (0, 0), 0, (Yes, No, No, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#D4#           =>  --  03D4
          (((649, 650), (626, 627)), (0, 0), 0, (Yes, No, No, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#D5#           =>  --  03D5
          (((0, 0), (651, 651)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#D6#           =>  --  03D6
          (((0, 0), (652, 652)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#F0#           =>  --  03F0
          (((0, 0), (653, 653)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#F1#           =>  --  03F1
          (((0, 0), (654, 654)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#F2#           =>  --  03F2
          (((0, 0), (655, 655)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#F4#           =>  --  03F4
          (((0, 0), (656, 656)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#F5#           =>  --  03F5
          (((0, 0), (630, 630)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#F9#           =>  --  03F9
          (((0, 0), (657, 657)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         others           =>
          (((0, 0), (0, 0)), (0, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)));

   Group_0004 : aliased constant Normalization_Mapping_Second_Stage
     := (16#00#           =>  --  0400
          (((658, 659), (658, 659)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#01#           =>  --  0401
          (((660, 661), (660, 661)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#03#           =>  --  0403
          (((662, 663), (662, 663)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#06#           =>  --  0406
          (((0, 0), (0, 0)), (81, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#07#           =>  --  0407
          (((664, 665), (664, 665)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#0C#           =>  --  040C
          (((666, 667), (666, 667)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#0D#           =>  --  040D
          (((668, 669), (668, 669)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#0E#           =>  --  040E
          (((670, 671), (670, 671)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#10#           =>  --  0410
          (((0, 0), (0, 0)), (95, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#13#           =>  --  0413
          (((0, 0), (0, 0)), (80, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#15#           =>  --  0415
          (((0, 0), (0, 0)), (79, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#16#           =>  --  0416
          (((0, 0), (0, 0)), (93, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#17#           =>  --  0417
          (((0, 0), (0, 0)), (99, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#18#           =>  --  0418
          (((0, 0), (0, 0)), (83, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#19#           =>  --  0419
          (((672, 673), (672, 673)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#1A#           =>  --  041A
          (((0, 0), (0, 0)), (82, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#1E#           =>  --  041E
          (((0, 0), (0, 0)), (101, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#23#           =>  --  0423
          (((0, 0), (0, 0)), (84, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#27#           =>  --  0427
          (((0, 0), (0, 0)), (107, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#2B#           =>  --  042B
          (((0, 0), (0, 0)), (109, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#2D#           =>  --  042D
          (((0, 0), (0, 0)), (105, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#30#           =>  --  0430
          (((0, 0), (0, 0)), (96, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#33#           =>  --  0433
          (((0, 0), (0, 0)), (87, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#35#           =>  --  0435
          (((0, 0), (0, 0)), (86, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#36#           =>  --  0436
          (((0, 0), (0, 0)), (94, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#37#           =>  --  0437
          (((0, 0), (0, 0)), (100, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#38#           =>  --  0438
          (((0, 0), (0, 0)), (85, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#39#           =>  --  0439
          (((674, 675), (674, 675)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#3A#           =>  --  043A
          (((0, 0), (0, 0)), (89, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#3E#           =>  --  043E
          (((0, 0), (0, 0)), (102, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#43#           =>  --  0443
          (((0, 0), (0, 0)), (90, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#47#           =>  --  0447
          (((0, 0), (0, 0)), (108, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#4B#           =>  --  044B
          (((0, 0), (0, 0)), (110, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#4D#           =>  --  044D
          (((0, 0), (0, 0)), (106, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#50#           =>  --  0450
          (((676, 677), (676, 677)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#51#           =>  --  0451
          (((678, 679), (678, 679)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#53#           =>  --  0453
          (((680, 681), (680, 681)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#56#           =>  --  0456
          (((0, 0), (0, 0)), (88, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#57#           =>  --  0457
          (((682, 683), (682, 683)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#5C#           =>  --  045C
          (((684, 685), (684, 685)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#5D#           =>  --  045D
          (((686, 687), (686, 687)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#5E#           =>  --  045E
          (((688, 689), (688, 689)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#74#           =>  --  0474
          (((0, 0), (0, 0)), (91, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#75#           =>  --  0475
          (((0, 0), (0, 0)), (92, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#76#           =>  --  0476
          (((690, 691), (690, 691)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#77#           =>  --  0477
          (((692, 693), (692, 693)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#83# .. 16#87# =>  --  0483 .. 0487
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#C1#           =>  --  04C1
          (((694, 695), (694, 695)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#C2#           =>  --  04C2
          (((696, 697), (696, 697)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#D0#           =>  --  04D0
          (((698, 699), (698, 699)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#D1#           =>  --  04D1
          (((700, 701), (700, 701)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#D2#           =>  --  04D2
          (((702, 703), (702, 703)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#D3#           =>  --  04D3
          (((704, 705), (704, 705)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#D6#           =>  --  04D6
          (((706, 707), (706, 707)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#D7#           =>  --  04D7
          (((708, 709), (708, 709)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#D8#           =>  --  04D8
          (((0, 0), (0, 0)), (97, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#D9#           =>  --  04D9
          (((0, 0), (0, 0)), (98, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#DA#           =>  --  04DA
          (((710, 711), (710, 711)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#DB#           =>  --  04DB
          (((712, 713), (712, 713)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#DC#           =>  --  04DC
          (((714, 715), (714, 715)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#DD#           =>  --  04DD
          (((716, 717), (716, 717)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#DE#           =>  --  04DE
          (((718, 719), (718, 719)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#DF#           =>  --  04DF
          (((720, 721), (720, 721)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#E2#           =>  --  04E2
          (((722, 723), (722, 723)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#E3#           =>  --  04E3
          (((724, 725), (724, 725)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#E4#           =>  --  04E4
          (((726, 727), (726, 727)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#E5#           =>  --  04E5
          (((728, 729), (728, 729)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#E6#           =>  --  04E6
          (((730, 731), (730, 731)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#E7#           =>  --  04E7
          (((732, 733), (732, 733)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#E8#           =>  --  04E8
          (((0, 0), (0, 0)), (103, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#E9#           =>  --  04E9
          (((0, 0), (0, 0)), (104, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#EA#           =>  --  04EA
          (((734, 735), (734, 735)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#EB#           =>  --  04EB
          (((736, 737), (736, 737)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#EC#           =>  --  04EC
          (((738, 739), (738, 739)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#ED#           =>  --  04ED
          (((740, 741), (740, 741)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#EE#           =>  --  04EE
          (((742, 743), (742, 743)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#EF#           =>  --  04EF
          (((744, 745), (744, 745)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#F0#           =>  --  04F0
          (((746, 747), (746, 747)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#F1#           =>  --  04F1
          (((748, 749), (748, 749)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#F2#           =>  --  04F2
          (((750, 751), (750, 751)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#F3#           =>  --  04F3
          (((752, 753), (752, 753)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#F4#           =>  --  04F4
          (((754, 755), (754, 755)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#F5#           =>  --  04F5
          (((756, 757), (756, 757)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#F8#           =>  --  04F8
          (((758, 759), (758, 759)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#F9#           =>  --  04F9
          (((760, 761), (760, 761)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         others           =>
          (((0, 0), (0, 0)), (0, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)));

   Group_0005 : aliased constant Normalization_Mapping_Second_Stage
     := (16#87#           =>  --  0587
          (((0, 0), (762, 763)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#91#           =>  --  0591
          (((0, 0), (0, 0)), (0, 0), 220, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#92# .. 16#95# =>  --  0592 .. 0595
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#96#           =>  --  0596
          (((0, 0), (0, 0)), (0, 0), 220, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#97# .. 16#99# =>  --  0597 .. 0599
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#9A#           =>  --  059A
          (((0, 0), (0, 0)), (0, 0), 222, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#9B#           =>  --  059B
          (((0, 0), (0, 0)), (0, 0), 220, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#9C# .. 16#A1# =>  --  059C .. 05A1
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#A2# .. 16#A7# =>  --  05A2 .. 05A7
          (((0, 0), (0, 0)), (0, 0), 220, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#A8# .. 16#A9# =>  --  05A8 .. 05A9
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#AA#           =>  --  05AA
          (((0, 0), (0, 0)), (0, 0), 220, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#AB# .. 16#AC# =>  --  05AB .. 05AC
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#AD#           =>  --  05AD
          (((0, 0), (0, 0)), (0, 0), 222, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#AE#           =>  --  05AE
          (((0, 0), (0, 0)), (0, 0), 228, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#AF#           =>  --  05AF
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#B0#           =>  --  05B0
          (((0, 0), (0, 0)), (0, 0), 10, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#B1#           =>  --  05B1
          (((0, 0), (0, 0)), (0, 0), 11, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#B2#           =>  --  05B2
          (((0, 0), (0, 0)), (0, 0), 12, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#B3#           =>  --  05B3
          (((0, 0), (0, 0)), (0, 0), 13, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#B4#           =>  --  05B4
          (((0, 0), (0, 0)), (0, 0), 14, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#B5#           =>  --  05B5
          (((0, 0), (0, 0)), (0, 0), 15, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#B6#           =>  --  05B6
          (((0, 0), (0, 0)), (0, 0), 16, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#B7#           =>  --  05B7
          (((0, 0), (0, 0)), (0, 0), 17, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#B8#           =>  --  05B8
          (((0, 0), (0, 0)), (0, 0), 18, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#B9# .. 16#BA# =>  --  05B9 .. 05BA
          (((0, 0), (0, 0)), (0, 0), 19, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#BB#           =>  --  05BB
          (((0, 0), (0, 0)), (0, 0), 20, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#BC#           =>  --  05BC
          (((0, 0), (0, 0)), (0, 0), 21, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#BD#           =>  --  05BD
          (((0, 0), (0, 0)), (0, 0), 22, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#BF#           =>  --  05BF
          (((0, 0), (0, 0)), (0, 0), 23, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#C1#           =>  --  05C1
          (((0, 0), (0, 0)), (0, 0), 24, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#C2#           =>  --  05C2
          (((0, 0), (0, 0)), (0, 0), 25, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#C4#           =>  --  05C4
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#C5#           =>  --  05C5
          (((0, 0), (0, 0)), (0, 0), 220, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#C7#           =>  --  05C7
          (((0, 0), (0, 0)), (0, 0), 18, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         others           =>
          (((0, 0), (0, 0)), (0, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)));

   Group_0006 : aliased constant Normalization_Mapping_Second_Stage
     := (16#10# .. 16#17# =>  --  0610 .. 0617
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#18#           =>  --  0618
          (((0, 0), (0, 0)), (0, 0), 30, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#19#           =>  --  0619
          (((0, 0), (0, 0)), (0, 0), 31, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#1A#           =>  --  061A
          (((0, 0), (0, 0)), (0, 0), 32, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#22#           =>  --  0622
          (((764, 765), (764, 765)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#23#           =>  --  0623
          (((766, 767), (766, 767)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#24#           =>  --  0624
          (((768, 769), (768, 769)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#25#           =>  --  0625
          (((770, 771), (770, 771)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#26#           =>  --  0626
          (((772, 773), (772, 773)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#27#           =>  --  0627
          (((0, 0), (0, 0)), (111, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#48#           =>  --  0648
          (((0, 0), (0, 0)), (112, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#4A#           =>  --  064A
          (((0, 0), (0, 0)), (113, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#4B#           =>  --  064B
          (((0, 0), (0, 0)), (0, 0), 27, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#4C#           =>  --  064C
          (((0, 0), (0, 0)), (0, 0), 28, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#4D#           =>  --  064D
          (((0, 0), (0, 0)), (0, 0), 29, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#4E#           =>  --  064E
          (((0, 0), (0, 0)), (0, 0), 30, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#4F#           =>  --  064F
          (((0, 0), (0, 0)), (0, 0), 31, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#50#           =>  --  0650
          (((0, 0), (0, 0)), (0, 0), 32, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#51#           =>  --  0651
          (((0, 0), (0, 0)), (0, 0), 33, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#52#           =>  --  0652
          (((0, 0), (0, 0)), (0, 0), 34, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#53#           =>  --  0653
          (((0, 0), (0, 0)), (0, 18), 230, (Maybe, Yes, Maybe, Yes), None,
           (others => False)),
         16#54#           =>  --  0654
          (((0, 0), (0, 0)), (0, 19), 230, (Maybe, Yes, Maybe, Yes), None,
           (others => False)),
         16#55#           =>  --  0655
          (((0, 0), (0, 0)), (0, 20), 220, (Maybe, Yes, Maybe, Yes), None,
           (others => False)),
         16#56#           =>  --  0656
          (((0, 0), (0, 0)), (0, 0), 220, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#57# .. 16#5B# =>  --  0657 .. 065B
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#5C#           =>  --  065C
          (((0, 0), (0, 0)), (0, 0), 220, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#5D# .. 16#5E# =>  --  065D .. 065E
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#5F#           =>  --  065F
          (((0, 0), (0, 0)), (0, 0), 220, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#70#           =>  --  0670
          (((0, 0), (0, 0)), (0, 0), 35, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#75#           =>  --  0675
          (((0, 0), (774, 775)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#76#           =>  --  0676
          (((0, 0), (776, 777)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#77#           =>  --  0677
          (((0, 0), (778, 779)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#78#           =>  --  0678
          (((0, 0), (780, 781)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#C0#           =>  --  06C0
          (((782, 783), (782, 783)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#C1#           =>  --  06C1
          (((0, 0), (0, 0)), (115, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#C2#           =>  --  06C2
          (((784, 785), (784, 785)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#D2#           =>  --  06D2
          (((0, 0), (0, 0)), (116, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#D3#           =>  --  06D3
          (((786, 787), (786, 787)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#D5#           =>  --  06D5
          (((0, 0), (0, 0)), (114, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#D6# .. 16#DC# =>  --  06D6 .. 06DC
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#DF# .. 16#E2# =>  --  06DF .. 06E2
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#E3#           =>  --  06E3
          (((0, 0), (0, 0)), (0, 0), 220, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#E4#           =>  --  06E4
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#E7# .. 16#E8# =>  --  06E7 .. 06E8
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#EA#           =>  --  06EA
          (((0, 0), (0, 0)), (0, 0), 220, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#EB# .. 16#EC# =>  --  06EB .. 06EC
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#ED#           =>  --  06ED
          (((0, 0), (0, 0)), (0, 0), 220, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         others           =>
          (((0, 0), (0, 0)), (0, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)));

   Group_0007 : aliased constant Normalization_Mapping_Second_Stage
     := (16#11#           =>  --  0711
          (((0, 0), (0, 0)), (0, 0), 36, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#30#           =>  --  0730
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#31#           =>  --  0731
          (((0, 0), (0, 0)), (0, 0), 220, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#32# .. 16#33# =>  --  0732 .. 0733
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#34#           =>  --  0734
          (((0, 0), (0, 0)), (0, 0), 220, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#35# .. 16#36# =>  --  0735 .. 0736
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#37# .. 16#39# =>  --  0737 .. 0739
          (((0, 0), (0, 0)), (0, 0), 220, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#3A#           =>  --  073A
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#3B# .. 16#3C# =>  --  073B .. 073C
          (((0, 0), (0, 0)), (0, 0), 220, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#3D#           =>  --  073D
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#3E#           =>  --  073E
          (((0, 0), (0, 0)), (0, 0), 220, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#3F# .. 16#41# =>  --  073F .. 0741
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#42#           =>  --  0742
          (((0, 0), (0, 0)), (0, 0), 220, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#43#           =>  --  0743
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#44#           =>  --  0744
          (((0, 0), (0, 0)), (0, 0), 220, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#45#           =>  --  0745
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#46#           =>  --  0746
          (((0, 0), (0, 0)), (0, 0), 220, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#47#           =>  --  0747
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#48#           =>  --  0748
          (((0, 0), (0, 0)), (0, 0), 220, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#49# .. 16#4A# =>  --  0749 .. 074A
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#EB# .. 16#F1# =>  --  07EB .. 07F1
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#F2#           =>  --  07F2
          (((0, 0), (0, 0)), (0, 0), 220, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#F3#           =>  --  07F3
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         others           =>
          (((0, 0), (0, 0)), (0, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)));

   Group_0008 : aliased constant Normalization_Mapping_Second_Stage
     := (16#16# .. 16#19# =>  --  0816 .. 0819
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#1B# .. 16#23# =>  --  081B .. 0823
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#25# .. 16#27# =>  --  0825 .. 0827
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#29# .. 16#2D# =>  --  0829 .. 082D
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#59# .. 16#5B# =>  --  0859 .. 085B
          (((0, 0), (0, 0)), (0, 0), 220, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#E4# .. 16#E5# =>  --  08E4 .. 08E5
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#E6#           =>  --  08E6
          (((0, 0), (0, 0)), (0, 0), 220, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#E7# .. 16#E8# =>  --  08E7 .. 08E8
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#E9#           =>  --  08E9
          (((0, 0), (0, 0)), (0, 0), 220, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#EA# .. 16#EC# =>  --  08EA .. 08EC
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#ED# .. 16#EF# =>  --  08ED .. 08EF
          (((0, 0), (0, 0)), (0, 0), 220, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#F0#           =>  --  08F0
          (((0, 0), (0, 0)), (0, 0), 27, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#F1#           =>  --  08F1
          (((0, 0), (0, 0)), (0, 0), 28, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#F2#           =>  --  08F2
          (((0, 0), (0, 0)), (0, 0), 29, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#F3# .. 16#F5# =>  --  08F3 .. 08F5
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#F6#           =>  --  08F6
          (((0, 0), (0, 0)), (0, 0), 220, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#F7# .. 16#F8# =>  --  08F7 .. 08F8
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#F9# .. 16#FA# =>  --  08F9 .. 08FA
          (((0, 0), (0, 0)), (0, 0), 220, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#FB# .. 16#FF# =>  --  08FB .. 08FF
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         others           =>
          (((0, 0), (0, 0)), (0, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)));

   Group_0009 : aliased constant Normalization_Mapping_Second_Stage
     := (16#28#           =>  --  0928
          (((0, 0), (0, 0)), (117, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#29#           =>  --  0929
          (((788, 789), (788, 789)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#30#           =>  --  0930
          (((0, 0), (0, 0)), (118, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#31#           =>  --  0931
          (((790, 791), (790, 791)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#33#           =>  --  0933
          (((0, 0), (0, 0)), (119, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#34#           =>  --  0934
          (((792, 793), (792, 793)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#3C#           =>  --  093C
          (((0, 0), (0, 0)), (0, 21), 7, (Maybe, Yes, Maybe, Yes), None,
           (others => False)),
         16#4D#           =>  --  094D
          (((0, 0), (0, 0)), (0, 0), 9, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#51#           =>  --  0951
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#52#           =>  --  0952
          (((0, 0), (0, 0)), (0, 0), 220, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#53# .. 16#54# =>  --  0953 .. 0954
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#58#           =>  --  0958
          (((794, 795), (794, 795)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFKC => False,
            others => True)),
         16#59#           =>  --  0959
          (((796, 797), (796, 797)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFKC => False,
            others => True)),
         16#5A#           =>  --  095A
          (((798, 799), (798, 799)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFKC => False,
            others => True)),
         16#5B#           =>  --  095B
          (((800, 801), (800, 801)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFKC => False,
            others => True)),
         16#5C#           =>  --  095C
          (((802, 803), (802, 803)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFKC => False,
            others => True)),
         16#5D#           =>  --  095D
          (((804, 805), (804, 805)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFKC => False,
            others => True)),
         16#5E#           =>  --  095E
          (((806, 807), (806, 807)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFKC => False,
            others => True)),
         16#5F#           =>  --  095F
          (((808, 809), (808, 809)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFKC => False,
            others => True)),
         16#BC#           =>  --  09BC
          (((0, 0), (0, 0)), (0, 0), 7, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#BE#           =>  --  09BE
          (((0, 0), (0, 0)), (0, 22), 0, (Maybe, Yes, Maybe, Yes), None,
           (others => False)),
         16#C7#           =>  --  09C7
          (((0, 0), (0, 0)), (120, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#CB#           =>  --  09CB
          (((810, 811), (810, 811)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#CC#           =>  --  09CC
          (((812, 813), (812, 813)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#CD#           =>  --  09CD
          (((0, 0), (0, 0)), (0, 0), 9, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#D7#           =>  --  09D7
          (((0, 0), (0, 0)), (0, 23), 0, (Maybe, Yes, Maybe, Yes), None,
           (others => False)),
         16#DC#           =>  --  09DC
          (((814, 815), (814, 815)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFKC => False,
            others => True)),
         16#DD#           =>  --  09DD
          (((816, 817), (816, 817)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFKC => False,
            others => True)),
         16#DF#           =>  --  09DF
          (((818, 819), (818, 819)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFKC => False,
            others => True)),
         others           =>
          (((0, 0), (0, 0)), (0, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)));

   Group_000A : aliased constant Normalization_Mapping_Second_Stage
     := (16#33#           =>  --  0A33
          (((820, 821), (820, 821)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFKC => False,
            others => True)),
         16#36#           =>  --  0A36
          (((822, 823), (822, 823)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFKC => False,
            others => True)),
         16#3C#           =>  --  0A3C
          (((0, 0), (0, 0)), (0, 0), 7, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#4D#           =>  --  0A4D
          (((0, 0), (0, 0)), (0, 0), 9, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#59#           =>  --  0A59
          (((824, 825), (824, 825)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFKC => False,
            others => True)),
         16#5A#           =>  --  0A5A
          (((826, 827), (826, 827)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFKC => False,
            others => True)),
         16#5B#           =>  --  0A5B
          (((828, 829), (828, 829)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFKC => False,
            others => True)),
         16#5E#           =>  --  0A5E
          (((830, 831), (830, 831)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFKC => False,
            others => True)),
         16#BC#           =>  --  0ABC
          (((0, 0), (0, 0)), (0, 0), 7, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#CD#           =>  --  0ACD
          (((0, 0), (0, 0)), (0, 0), 9, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         others           =>
          (((0, 0), (0, 0)), (0, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)));

   Group_000B : aliased constant Normalization_Mapping_Second_Stage
     := (16#3C#           =>  --  0B3C
          (((0, 0), (0, 0)), (0, 0), 7, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#3E#           =>  --  0B3E
          (((0, 0), (0, 0)), (0, 25), 0, (Maybe, Yes, Maybe, Yes), None,
           (others => False)),
         16#47#           =>  --  0B47
          (((0, 0), (0, 0)), (121, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#48#           =>  --  0B48
          (((832, 833), (832, 833)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#4B#           =>  --  0B4B
          (((834, 835), (834, 835)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#4C#           =>  --  0B4C
          (((836, 837), (836, 837)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#4D#           =>  --  0B4D
          (((0, 0), (0, 0)), (0, 0), 9, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#56#           =>  --  0B56
          (((0, 0), (0, 0)), (0, 24), 0, (Maybe, Yes, Maybe, Yes), None,
           (others => False)),
         16#57#           =>  --  0B57
          (((0, 0), (0, 0)), (0, 26), 0, (Maybe, Yes, Maybe, Yes), None,
           (others => False)),
         16#5C#           =>  --  0B5C
          (((838, 839), (838, 839)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFKC => False,
            others => True)),
         16#5D#           =>  --  0B5D
          (((840, 841), (840, 841)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFKC => False,
            others => True)),
         16#92#           =>  --  0B92
          (((0, 0), (0, 0)), (122, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#94#           =>  --  0B94
          (((842, 843), (842, 843)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#BE#           =>  --  0BBE
          (((0, 0), (0, 0)), (0, 28), 0, (Maybe, Yes, Maybe, Yes), None,
           (others => False)),
         16#C6#           =>  --  0BC6
          (((0, 0), (0, 0)), (123, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#C7#           =>  --  0BC7
          (((0, 0), (0, 0)), (124, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#CA#           =>  --  0BCA
          (((844, 845), (844, 845)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#CB#           =>  --  0BCB
          (((846, 847), (846, 847)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#CC#           =>  --  0BCC
          (((848, 849), (848, 849)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#CD#           =>  --  0BCD
          (((0, 0), (0, 0)), (0, 0), 9, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#D7#           =>  --  0BD7
          (((0, 0), (0, 0)), (0, 27), 0, (Maybe, Yes, Maybe, Yes), None,
           (others => False)),
         others           =>
          (((0, 0), (0, 0)), (0, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)));

   Group_000C : aliased constant Normalization_Mapping_Second_Stage
     := (16#46#           =>  --  0C46
          (((0, 0), (0, 0)), (125, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#48#           =>  --  0C48
          (((850, 851), (850, 851)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#4D#           =>  --  0C4D
          (((0, 0), (0, 0)), (0, 0), 9, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#55#           =>  --  0C55
          (((0, 0), (0, 0)), (0, 0), 84, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#56#           =>  --  0C56
          (((0, 0), (0, 0)), (0, 29), 91, (Maybe, Yes, Maybe, Yes), None,
           (others => False)),
         16#BC#           =>  --  0CBC
          (((0, 0), (0, 0)), (0, 0), 7, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#BF#           =>  --  0CBF
          (((0, 0), (0, 0)), (126, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#C0#           =>  --  0CC0
          (((852, 853), (852, 853)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#C2#           =>  --  0CC2
          (((0, 0), (0, 0)), (0, 32), 0, (Maybe, Yes, Maybe, Yes), None,
           (others => False)),
         16#C6#           =>  --  0CC6
          (((0, 0), (0, 0)), (127, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#C7#           =>  --  0CC7
          (((854, 855), (854, 855)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#C8#           =>  --  0CC8
          (((856, 857), (856, 857)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#CA#           =>  --  0CCA
          (((858, 859), (858, 859)), (128, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#CB#           =>  --  0CCB
          (((860, 862), (860, 862)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#CD#           =>  --  0CCD
          (((0, 0), (0, 0)), (0, 0), 9, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#D5#           =>  --  0CD5
          (((0, 0), (0, 0)), (0, 30), 0, (Maybe, Yes, Maybe, Yes), None,
           (others => False)),
         16#D6#           =>  --  0CD6
          (((0, 0), (0, 0)), (0, 31), 0, (Maybe, Yes, Maybe, Yes), None,
           (others => False)),
         others           =>
          (((0, 0), (0, 0)), (0, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)));

   Group_000D : aliased constant Normalization_Mapping_Second_Stage
     := (16#3E#           =>  --  0D3E
          (((0, 0), (0, 0)), (0, 33), 0, (Maybe, Yes, Maybe, Yes), None,
           (others => False)),
         16#46#           =>  --  0D46
          (((0, 0), (0, 0)), (129, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#47#           =>  --  0D47
          (((0, 0), (0, 0)), (130, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#4A#           =>  --  0D4A
          (((863, 864), (863, 864)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#4B#           =>  --  0D4B
          (((865, 866), (865, 866)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#4C#           =>  --  0D4C
          (((867, 868), (867, 868)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#4D#           =>  --  0D4D
          (((0, 0), (0, 0)), (0, 0), 9, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#57#           =>  --  0D57
          (((0, 0), (0, 0)), (0, 34), 0, (Maybe, Yes, Maybe, Yes), None,
           (others => False)),
         16#CA#           =>  --  0DCA
          (((0, 0), (0, 0)), (0, 35), 9, (Maybe, Yes, Maybe, Yes), None,
           (others => False)),
         16#CF#           =>  --  0DCF
          (((0, 0), (0, 0)), (0, 36), 0, (Maybe, Yes, Maybe, Yes), None,
           (others => False)),
         16#D9#           =>  --  0DD9
          (((0, 0), (0, 0)), (131, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#DA#           =>  --  0DDA
          (((869, 870), (869, 870)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#DC#           =>  --  0DDC
          (((871, 872), (871, 872)), (132, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#DD#           =>  --  0DDD
          (((873, 875), (873, 875)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#DE#           =>  --  0DDE
          (((876, 877), (876, 877)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#DF#           =>  --  0DDF
          (((0, 0), (0, 0)), (0, 37), 0, (Maybe, Yes, Maybe, Yes), None,
           (others => False)),
         others           =>
          (((0, 0), (0, 0)), (0, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)));

   Group_000E : aliased constant Normalization_Mapping_Second_Stage
     := (16#33#           =>  --  0E33
          (((0, 0), (878, 879)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#38# .. 16#39# =>  --  0E38 .. 0E39
          (((0, 0), (0, 0)), (0, 0), 103, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#3A#           =>  --  0E3A
          (((0, 0), (0, 0)), (0, 0), 9, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#48# .. 16#4B# =>  --  0E48 .. 0E4B
          (((0, 0), (0, 0)), (0, 0), 107, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#B3#           =>  --  0EB3
          (((0, 0), (880, 881)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#B8# .. 16#B9# =>  --  0EB8 .. 0EB9
          (((0, 0), (0, 0)), (0, 0), 118, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#C8# .. 16#CB# =>  --  0EC8 .. 0ECB
          (((0, 0), (0, 0)), (0, 0), 122, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#DC#           =>  --  0EDC
          (((0, 0), (882, 883)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#DD#           =>  --  0EDD
          (((0, 0), (884, 885)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         others           =>
          (((0, 0), (0, 0)), (0, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)));

   Group_000F : aliased constant Normalization_Mapping_Second_Stage
     := (16#0C#           =>  --  0F0C
          (((0, 0), (886, 886)), (0, 0), 0, (Yes, Yes, No, No), No_Break,
           (others => False)),
         16#18# .. 16#19# =>  --  0F18 .. 0F19
          (((0, 0), (0, 0)), (0, 0), 220, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#35#           =>  --  0F35
          (((0, 0), (0, 0)), (0, 0), 220, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#37#           =>  --  0F37
          (((0, 0), (0, 0)), (0, 0), 220, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#39#           =>  --  0F39
          (((0, 0), (0, 0)), (0, 0), 216, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#43#           =>  --  0F43
          (((887, 888), (887, 888)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFKC => False,
            others => True)),
         16#4D#           =>  --  0F4D
          (((889, 890), (889, 890)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFKC => False,
            others => True)),
         16#52#           =>  --  0F52
          (((891, 892), (891, 892)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFKC => False,
            others => True)),
         16#57#           =>  --  0F57
          (((893, 894), (893, 894)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFKC => False,
            others => True)),
         16#5C#           =>  --  0F5C
          (((895, 896), (895, 896)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFKC => False,
            others => True)),
         16#69#           =>  --  0F69
          (((897, 898), (897, 898)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFKC => False,
            others => True)),
         16#71#           =>  --  0F71
          (((0, 0), (0, 0)), (0, 0), 129, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#72#           =>  --  0F72
          (((0, 0), (0, 0)), (0, 0), 130, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#73#           =>  --  0F73
          (((899, 900), (899, 900)), (0, 0), 0, (No, No, No, No), Canonical,
           (Composition_Exclusion
              | Expands_On_NFKC => False,
            others => True)),
         16#74#           =>  --  0F74
          (((0, 0), (0, 0)), (0, 0), 132, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#75#           =>  --  0F75
          (((901, 902), (901, 902)), (0, 0), 0, (No, No, No, No), Canonical,
           (Composition_Exclusion
              | Expands_On_NFKC => False,
            others => True)),
         16#76#           =>  --  0F76
          (((903, 904), (903, 904)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFKC => False,
            others => True)),
         16#77#           =>  --  0F77
          (((0, 0), (905, 907)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#78#           =>  --  0F78
          (((908, 909), (908, 909)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFKC => False,
            others => True)),
         16#79#           =>  --  0F79
          (((0, 0), (910, 912)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#7A# .. 16#7D# =>  --  0F7A .. 0F7D
          (((0, 0), (0, 0)), (0, 0), 130, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#80#           =>  --  0F80
          (((0, 0), (0, 0)), (0, 0), 130, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#81#           =>  --  0F81
          (((906, 907), (906, 907)), (0, 0), 0, (No, No, No, No), Canonical,
           (Composition_Exclusion
              | Expands_On_NFKC => False,
            others => True)),
         16#82# .. 16#83# =>  --  0F82 .. 0F83
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#84#           =>  --  0F84
          (((0, 0), (0, 0)), (0, 0), 9, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#86# .. 16#87# =>  --  0F86 .. 0F87
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#93#           =>  --  0F93
          (((913, 914), (913, 914)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFKC => False,
            others => True)),
         16#9D#           =>  --  0F9D
          (((915, 916), (915, 916)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFKC => False,
            others => True)),
         16#A2#           =>  --  0FA2
          (((917, 918), (917, 918)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFKC => False,
            others => True)),
         16#A7#           =>  --  0FA7
          (((919, 920), (919, 920)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFKC => False,
            others => True)),
         16#AC#           =>  --  0FAC
          (((921, 922), (921, 922)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFKC => False,
            others => True)),
         16#B9#           =>  --  0FB9
          (((923, 924), (923, 924)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFKC => False,
            others => True)),
         16#C6#           =>  --  0FC6
          (((0, 0), (0, 0)), (0, 0), 220, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         others           =>
          (((0, 0), (0, 0)), (0, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)));

   Group_0010 : aliased constant Normalization_Mapping_Second_Stage
     := (16#25#           =>  --  1025
          (((0, 0), (0, 0)), (133, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#26#           =>  --  1026
          (((925, 926), (925, 926)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#2E#           =>  --  102E
          (((0, 0), (0, 0)), (0, 38), 0, (Maybe, Yes, Maybe, Yes), None,
           (others => False)),
         16#37#           =>  --  1037
          (((0, 0), (0, 0)), (0, 0), 7, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#39# .. 16#3A# =>  --  1039 .. 103A
          (((0, 0), (0, 0)), (0, 0), 9, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#8D#           =>  --  108D
          (((0, 0), (0, 0)), (0, 0), 220, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#FC#           =>  --  10FC
          (((0, 0), (927, 927)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         others           =>
          (((0, 0), (0, 0)), (0, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)));

   Group_0011 : aliased constant Normalization_Mapping_Second_Stage
     := (16#61# .. 16#75# =>  --  1161 .. 1175
          (((0, 0), (0, 0)), (0, 0), 0, (Maybe, Yes, Maybe, Yes), None,
           (others => False)),
         16#A8# .. 16#C2# =>  --  11A8 .. 11C2
          (((0, 0), (0, 0)), (0, 0), 0, (Maybe, Yes, Maybe, Yes), None,
           (others => False)),
         others           =>
          (((0, 0), (0, 0)), (0, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)));

   Group_0012 : aliased constant Normalization_Mapping_Second_Stage
     := (others           =>
          (((0, 0), (0, 0)), (0, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)));

   Group_0013 : aliased constant Normalization_Mapping_Second_Stage
     := (16#5D# .. 16#5F# =>  --  135D .. 135F
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         others           =>
          (((0, 0), (0, 0)), (0, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)));

   Group_0017 : aliased constant Normalization_Mapping_Second_Stage
     := (16#14#           =>  --  1714
          (((0, 0), (0, 0)), (0, 0), 9, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#34#           =>  --  1734
          (((0, 0), (0, 0)), (0, 0), 9, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#D2#           =>  --  17D2
          (((0, 0), (0, 0)), (0, 0), 9, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#DD#           =>  --  17DD
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         others           =>
          (((0, 0), (0, 0)), (0, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)));

   Group_0018 : aliased constant Normalization_Mapping_Second_Stage
     := (16#A9#           =>  --  18A9
          (((0, 0), (0, 0)), (0, 0), 228, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         others           =>
          (((0, 0), (0, 0)), (0, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)));

   Group_0019 : aliased constant Normalization_Mapping_Second_Stage
     := (16#39#           =>  --  1939
          (((0, 0), (0, 0)), (0, 0), 222, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#3A#           =>  --  193A
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#3B#           =>  --  193B
          (((0, 0), (0, 0)), (0, 0), 220, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         others           =>
          (((0, 0), (0, 0)), (0, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)));

   Group_001A : aliased constant Normalization_Mapping_Second_Stage
     := (16#17#           =>  --  1A17
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#18#           =>  --  1A18
          (((0, 0), (0, 0)), (0, 0), 220, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#60#           =>  --  1A60
          (((0, 0), (0, 0)), (0, 0), 9, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#75# .. 16#7C# =>  --  1A75 .. 1A7C
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#7F#           =>  --  1A7F
          (((0, 0), (0, 0)), (0, 0), 220, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#B0# .. 16#B4# =>  --  1AB0 .. 1AB4
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#B5# .. 16#BA# =>  --  1AB5 .. 1ABA
          (((0, 0), (0, 0)), (0, 0), 220, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#BB# .. 16#BC# =>  --  1ABB .. 1ABC
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#BD#           =>  --  1ABD
          (((0, 0), (0, 0)), (0, 0), 220, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         others           =>
          (((0, 0), (0, 0)), (0, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)));

   Group_001B : aliased constant Normalization_Mapping_Second_Stage
     := (16#05#           =>  --  1B05
          (((0, 0), (0, 0)), (134, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#06#           =>  --  1B06
          (((928, 929), (928, 929)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#07#           =>  --  1B07
          (((0, 0), (0, 0)), (135, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#08#           =>  --  1B08
          (((930, 931), (930, 931)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#09#           =>  --  1B09
          (((0, 0), (0, 0)), (136, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#0A#           =>  --  1B0A
          (((932, 933), (932, 933)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#0B#           =>  --  1B0B
          (((0, 0), (0, 0)), (137, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#0C#           =>  --  1B0C
          (((934, 935), (934, 935)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#0D#           =>  --  1B0D
          (((0, 0), (0, 0)), (138, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#0E#           =>  --  1B0E
          (((936, 937), (936, 937)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#11#           =>  --  1B11
          (((0, 0), (0, 0)), (139, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#12#           =>  --  1B12
          (((938, 939), (938, 939)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#34#           =>  --  1B34
          (((0, 0), (0, 0)), (0, 0), 7, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#35#           =>  --  1B35
          (((0, 0), (0, 0)), (0, 39), 0, (Maybe, Yes, Maybe, Yes), None,
           (others => False)),
         16#3A#           =>  --  1B3A
          (((0, 0), (0, 0)), (140, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#3B#           =>  --  1B3B
          (((940, 941), (940, 941)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#3C#           =>  --  1B3C
          (((0, 0), (0, 0)), (141, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#3D#           =>  --  1B3D
          (((942, 943), (942, 943)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#3E#           =>  --  1B3E
          (((0, 0), (0, 0)), (142, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#3F#           =>  --  1B3F
          (((0, 0), (0, 0)), (143, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#40#           =>  --  1B40
          (((944, 945), (944, 945)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#41#           =>  --  1B41
          (((946, 947), (946, 947)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#42#           =>  --  1B42
          (((0, 0), (0, 0)), (144, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#43#           =>  --  1B43
          (((948, 949), (948, 949)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#44#           =>  --  1B44
          (((0, 0), (0, 0)), (0, 0), 9, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#6B#           =>  --  1B6B
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#6C#           =>  --  1B6C
          (((0, 0), (0, 0)), (0, 0), 220, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#6D# .. 16#73# =>  --  1B6D .. 1B73
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#AA# .. 16#AB# =>  --  1BAA .. 1BAB
          (((0, 0), (0, 0)), (0, 0), 9, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#E6#           =>  --  1BE6
          (((0, 0), (0, 0)), (0, 0), 7, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#F2# .. 16#F3# =>  --  1BF2 .. 1BF3
          (((0, 0), (0, 0)), (0, 0), 9, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         others           =>
          (((0, 0), (0, 0)), (0, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)));

   Group_001C : aliased constant Normalization_Mapping_Second_Stage
     := (16#37#           =>  --  1C37
          (((0, 0), (0, 0)), (0, 0), 7, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#D0# .. 16#D2# =>  --  1CD0 .. 1CD2
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#D4#           =>  --  1CD4
          (((0, 0), (0, 0)), (0, 0), 1, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#D5# .. 16#D9# =>  --  1CD5 .. 1CD9
          (((0, 0), (0, 0)), (0, 0), 220, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#DA# .. 16#DB# =>  --  1CDA .. 1CDB
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#DC# .. 16#DF# =>  --  1CDC .. 1CDF
          (((0, 0), (0, 0)), (0, 0), 220, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#E0#           =>  --  1CE0
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#E2# .. 16#E8# =>  --  1CE2 .. 1CE8
          (((0, 0), (0, 0)), (0, 0), 1, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#ED#           =>  --  1CED
          (((0, 0), (0, 0)), (0, 0), 220, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#F4#           =>  --  1CF4
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#F8# .. 16#F9# =>  --  1CF8 .. 1CF9
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         others           =>
          (((0, 0), (0, 0)), (0, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)));

   Group_001D : aliased constant Normalization_Mapping_Second_Stage
     := (16#2C#           =>  --  1D2C
          (((0, 0), (25, 25)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#2D#           =>  --  1D2D
          (((0, 0), (438, 438)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#2E#           =>  --  1D2E
          (((0, 0), (950, 950)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#30#           =>  --  1D30
          (((0, 0), (159, 159)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#31#           =>  --  1D31
          (((0, 0), (39, 39)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#32#           =>  --  1D32
          (((0, 0), (951, 951)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#33#           =>  --  1D33
          (((0, 0), (183, 183)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#34#           =>  --  1D34
          (((0, 0), (199, 199)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#35#           =>  --  1D35
          (((0, 0), (47, 47)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#36#           =>  --  1D36
          (((0, 0), (222, 222)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#37#           =>  --  1D37
          (((0, 0), (229, 229)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#38#           =>  --  1D38
          (((0, 0), (233, 233)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#39#           =>  --  1D39
          (((0, 0), (952, 952)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#3A#           =>  --  1D3A
          (((0, 0), (55, 55)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#3C#           =>  --  1D3C
          (((0, 0), (57, 57)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#3D#           =>  --  1D3D
          (((0, 0), (953, 953)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#3E#           =>  --  1D3E
          (((0, 0), (954, 954)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#3F#           =>  --  1D3F
          (((0, 0), (275, 275)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#40#           =>  --  1D40
          (((0, 0), (303, 303)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#41#           =>  --  1D41
          (((0, 0), (67, 67)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#42#           =>  --  1D42
          (((0, 0), (335, 335)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#43#           =>  --  1D43
          (((0, 0), (4, 4)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#44#           =>  --  1D44
          (((0, 0), (955, 955)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#45#           =>  --  1D45
          (((0, 0), (956, 956)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#46#           =>  --  1D46
          (((0, 0), (957, 957)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#47#           =>  --  1D47
          (((0, 0), (958, 958)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#48#           =>  --  1D48
          (((0, 0), (161, 161)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#49#           =>  --  1D49
          (((0, 0), (91, 91)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#4A#           =>  --  1D4A
          (((0, 0), (959, 959)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#4B#           =>  --  1D4B
          (((0, 0), (960, 960)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#4C#           =>  --  1D4C
          (((0, 0), (961, 961)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#4D#           =>  --  1D4D
          (((0, 0), (185, 185)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#4F#           =>  --  1D4F
          (((0, 0), (231, 231)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#50#           =>  --  1D50
          (((0, 0), (962, 962)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#51#           =>  --  1D51
          (((0, 0), (963, 963)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#52#           =>  --  1D52
          (((0, 0), (15, 15)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#53#           =>  --  1D53
          (((0, 0), (964, 964)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#54#           =>  --  1D54
          (((0, 0), (965, 965)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#55#           =>  --  1D55
          (((0, 0), (966, 966)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#56#           =>  --  1D56
          (((0, 0), (967, 967)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#57#           =>  --  1D57
          (((0, 0), (305, 305)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#58#           =>  --  1D58
          (((0, 0), (119, 119)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#59#           =>  --  1D59
          (((0, 0), (968, 968)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#5A#           =>  --  1D5A
          (((0, 0), (969, 969)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#5B#           =>  --  1D5B
          (((0, 0), (970, 970)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#5C#           =>  --  1D5C
          (((0, 0), (971, 971)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#5D#           =>  --  1D5D
          (((0, 0), (645, 645)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#5E#           =>  --  1D5E
          (((0, 0), (972, 972)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#5F#           =>  --  1D5F
          (((0, 0), (973, 973)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#60#           =>  --  1D60
          (((0, 0), (651, 651)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#61#           =>  --  1D61
          (((0, 0), (974, 974)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#62#           =>  --  1D62
          (((0, 0), (99, 99)), (0, 0), 0, (Yes, Yes, No, No), Sub,
           (others => False)),
         16#63#           =>  --  1D63
          (((0, 0), (277, 277)), (0, 0), 0, (Yes, Yes, No, No), Sub,
           (others => False)),
         16#64#           =>  --  1D64
          (((0, 0), (119, 119)), (0, 0), 0, (Yes, Yes, No, No), Sub,
           (others => False)),
         16#65#           =>  --  1D65
          (((0, 0), (970, 970)), (0, 0), 0, (Yes, Yes, No, No), Sub,
           (others => False)),
         16#66#           =>  --  1D66
          (((0, 0), (645, 645)), (0, 0), 0, (Yes, Yes, No, No), Sub,
           (others => False)),
         16#67#           =>  --  1D67
          (((0, 0), (972, 972)), (0, 0), 0, (Yes, Yes, No, No), Sub,
           (others => False)),
         16#68#           =>  --  1D68
          (((0, 0), (654, 654)), (0, 0), 0, (Yes, Yes, No, No), Sub,
           (others => False)),
         16#69#           =>  --  1D69
          (((0, 0), (651, 651)), (0, 0), 0, (Yes, Yes, No, No), Sub,
           (others => False)),
         16#6A#           =>  --  1D6A
          (((0, 0), (974, 974)), (0, 0), 0, (Yes, Yes, No, No), Sub,
           (others => False)),
         16#78#           =>  --  1D78
          (((0, 0), (975, 975)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#9B#           =>  --  1D9B
          (((0, 0), (976, 976)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#9C#           =>  --  1D9C
          (((0, 0), (89, 89)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#9D#           =>  --  1D9D
          (((0, 0), (977, 977)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#9E#           =>  --  1D9E
          (((0, 0), (978, 978)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#9F#           =>  --  1D9F
          (((0, 0), (961, 961)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#A0#           =>  --  1DA0
          (((0, 0), (979, 979)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#A1#           =>  --  1DA1
          (((0, 0), (980, 980)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#A2#           =>  --  1DA2
          (((0, 0), (981, 981)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#A3#           =>  --  1DA3
          (((0, 0), (982, 982)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#A4#           =>  --  1DA4
          (((0, 0), (983, 983)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#A5#           =>  --  1DA5
          (((0, 0), (984, 984)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#A6#           =>  --  1DA6
          (((0, 0), (985, 985)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#A7#           =>  --  1DA7
          (((0, 0), (986, 986)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#A8#           =>  --  1DA8
          (((0, 0), (987, 987)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#A9#           =>  --  1DA9
          (((0, 0), (988, 988)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#AA#           =>  --  1DAA
          (((0, 0), (989, 989)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#AB#           =>  --  1DAB
          (((0, 0), (990, 990)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#AC#           =>  --  1DAC
          (((0, 0), (991, 991)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#AD#           =>  --  1DAD
          (((0, 0), (992, 992)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#AE#           =>  --  1DAE
          (((0, 0), (993, 993)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#AF#           =>  --  1DAF
          (((0, 0), (994, 994)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#B0#           =>  --  1DB0
          (((0, 0), (995, 995)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#B1#           =>  --  1DB1
          (((0, 0), (996, 996)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#B2#           =>  --  1DB2
          (((0, 0), (997, 997)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#B3#           =>  --  1DB3
          (((0, 0), (998, 998)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#B4#           =>  --  1DB4
          (((0, 0), (999, 999)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#B5#           =>  --  1DB5
          (((0, 0), (1000, 1000)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#B6#           =>  --  1DB6
          (((0, 0), (1001, 1001)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#B7#           =>  --  1DB7
          (((0, 0), (1002, 1002)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#B8#           =>  --  1DB8
          (((0, 0), (1003, 1003)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#B9#           =>  --  1DB9
          (((0, 0), (1004, 1004)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#BA#           =>  --  1DBA
          (((0, 0), (1005, 1005)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#BB#           =>  --  1DBB
          (((0, 0), (347, 347)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#BC#           =>  --  1DBC
          (((0, 0), (1006, 1006)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#BD#           =>  --  1DBD
          (((0, 0), (1007, 1007)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#BE#           =>  --  1DBE
          (((0, 0), (462, 462)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#BF#           =>  --  1DBF
          (((0, 0), (646, 646)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#C0# .. 16#C1# =>  --  1DC0 .. 1DC1
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#C2#           =>  --  1DC2
          (((0, 0), (0, 0)), (0, 0), 220, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#C3# .. 16#C9# =>  --  1DC3 .. 1DC9
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#CA#           =>  --  1DCA
          (((0, 0), (0, 0)), (0, 0), 220, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#CB# .. 16#CC# =>  --  1DCB .. 1DCC
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#CD#           =>  --  1DCD
          (((0, 0), (0, 0)), (0, 0), 234, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#CE#           =>  --  1DCE
          (((0, 0), (0, 0)), (0, 0), 214, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#CF#           =>  --  1DCF
          (((0, 0), (0, 0)), (0, 0), 220, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#D0#           =>  --  1DD0
          (((0, 0), (0, 0)), (0, 0), 202, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#D1# .. 16#F5# =>  --  1DD1 .. 1DF5
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#FC#           =>  --  1DFC
          (((0, 0), (0, 0)), (0, 0), 233, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#FD#           =>  --  1DFD
          (((0, 0), (0, 0)), (0, 0), 220, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#FE#           =>  --  1DFE
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#FF#           =>  --  1DFF
          (((0, 0), (0, 0)), (0, 0), 220, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         others           =>
          (((0, 0), (0, 0)), (0, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)));

   Group_001E : aliased constant Normalization_Mapping_Second_Stage
     := (16#00#           =>  --  1E00
          (((1008, 1009), (1008, 1009)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#01#           =>  --  1E01
          (((1010, 1011), (1010, 1011)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#02#           =>  --  1E02
          (((1012, 1013), (1012, 1013)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#03#           =>  --  1E03
          (((1014, 1015), (1014, 1015)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#04#           =>  --  1E04
          (((1016, 1017), (1016, 1017)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#05#           =>  --  1E05
          (((1018, 1019), (1018, 1019)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#06#           =>  --  1E06
          (((1020, 1021), (1020, 1021)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#07#           =>  --  1E07
          (((1022, 1023), (1022, 1023)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#08#           =>  --  1E08
          (((1024, 1026), (1024, 1026)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#09#           =>  --  1E09
          (((1027, 1029), (1027, 1029)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#0A#           =>  --  1E0A
          (((1030, 1031), (1030, 1031)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#0B#           =>  --  1E0B
          (((1032, 1033), (1032, 1033)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#0C#           =>  --  1E0C
          (((1034, 1035), (1034, 1035)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#0D#           =>  --  1E0D
          (((1036, 1037), (1036, 1037)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#0E#           =>  --  1E0E
          (((1038, 1039), (1038, 1039)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#0F#           =>  --  1E0F
          (((1040, 1041), (1040, 1041)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#10#           =>  --  1E10
          (((1042, 1043), (1042, 1043)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#11#           =>  --  1E11
          (((1044, 1045), (1044, 1045)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#12#           =>  --  1E12
          (((1046, 1047), (1046, 1047)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#13#           =>  --  1E13
          (((1048, 1049), (1048, 1049)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#14#           =>  --  1E14
          (((1050, 1052), (1050, 1052)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#15#           =>  --  1E15
          (((1053, 1055), (1053, 1055)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#16#           =>  --  1E16
          (((1056, 1058), (1056, 1058)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#17#           =>  --  1E17
          (((1059, 1061), (1059, 1061)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#18#           =>  --  1E18
          (((1062, 1063), (1062, 1063)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#19#           =>  --  1E19
          (((1064, 1065), (1064, 1065)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#1A#           =>  --  1E1A
          (((1066, 1067), (1066, 1067)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#1B#           =>  --  1E1B
          (((1068, 1069), (1068, 1069)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#1C#           =>  --  1E1C
          (((1070, 1072), (1070, 1072)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#1D#           =>  --  1E1D
          (((1073, 1075), (1073, 1075)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#1E#           =>  --  1E1E
          (((1076, 1077), (1076, 1077)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#1F#           =>  --  1E1F
          (((1078, 1079), (1078, 1079)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#20#           =>  --  1E20
          (((1080, 1081), (1080, 1081)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#21#           =>  --  1E21
          (((1082, 1083), (1082, 1083)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#22#           =>  --  1E22
          (((1084, 1085), (1084, 1085)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#23#           =>  --  1E23
          (((1086, 1087), (1086, 1087)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#24#           =>  --  1E24
          (((1088, 1089), (1088, 1089)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#25#           =>  --  1E25
          (((1090, 1091), (1090, 1091)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#26#           =>  --  1E26
          (((1092, 1093), (1092, 1093)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#27#           =>  --  1E27
          (((1094, 1095), (1094, 1095)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#28#           =>  --  1E28
          (((1096, 1097), (1096, 1097)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#29#           =>  --  1E29
          (((1098, 1099), (1098, 1099)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#2A#           =>  --  1E2A
          (((1100, 1101), (1100, 1101)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#2B#           =>  --  1E2B
          (((1102, 1103), (1102, 1103)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#2C#           =>  --  1E2C
          (((1104, 1105), (1104, 1105)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#2D#           =>  --  1E2D
          (((1106, 1107), (1106, 1107)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#2E#           =>  --  1E2E
          (((1108, 1110), (1108, 1110)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#2F#           =>  --  1E2F
          (((1111, 1113), (1111, 1113)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#30#           =>  --  1E30
          (((1114, 1115), (1114, 1115)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#31#           =>  --  1E31
          (((1116, 1117), (1116, 1117)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#32#           =>  --  1E32
          (((1118, 1119), (1118, 1119)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#33#           =>  --  1E33
          (((1120, 1121), (1120, 1121)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#34#           =>  --  1E34
          (((1122, 1123), (1122, 1123)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#35#           =>  --  1E35
          (((1124, 1125), (1124, 1125)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#36#           =>  --  1E36
          (((1126, 1127), (1126, 1127)), (157, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#37#           =>  --  1E37
          (((1128, 1129), (1128, 1129)), (158, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#38#           =>  --  1E38
          (((1130, 1132), (1130, 1132)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#39#           =>  --  1E39
          (((1133, 1135), (1133, 1135)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#3A#           =>  --  1E3A
          (((1136, 1137), (1136, 1137)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#3B#           =>  --  1E3B
          (((1138, 1139), (1138, 1139)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#3C#           =>  --  1E3C
          (((1140, 1141), (1140, 1141)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#3D#           =>  --  1E3D
          (((1142, 1143), (1142, 1143)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#3E#           =>  --  1E3E
          (((1144, 1145), (1144, 1145)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#3F#           =>  --  1E3F
          (((1146, 1147), (1146, 1147)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#40#           =>  --  1E40
          (((1148, 1149), (1148, 1149)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#41#           =>  --  1E41
          (((1150, 1151), (1150, 1151)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#42#           =>  --  1E42
          (((1152, 1153), (1152, 1153)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#43#           =>  --  1E43
          (((1154, 1155), (1154, 1155)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#44#           =>  --  1E44
          (((1156, 1157), (1156, 1157)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#45#           =>  --  1E45
          (((1158, 1159), (1158, 1159)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#46#           =>  --  1E46
          (((1160, 1161), (1160, 1161)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#47#           =>  --  1E47
          (((1162, 1163), (1162, 1163)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#48#           =>  --  1E48
          (((1164, 1165), (1164, 1165)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#49#           =>  --  1E49
          (((1166, 1167), (1166, 1167)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#4A#           =>  --  1E4A
          (((1168, 1169), (1168, 1169)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#4B#           =>  --  1E4B
          (((1170, 1171), (1170, 1171)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#4C#           =>  --  1E4C
          (((1172, 1174), (1172, 1174)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#4D#           =>  --  1E4D
          (((1175, 1177), (1175, 1177)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#4E#           =>  --  1E4E
          (((1178, 1180), (1178, 1180)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#4F#           =>  --  1E4F
          (((1181, 1183), (1181, 1183)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#50#           =>  --  1E50
          (((1184, 1186), (1184, 1186)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#51#           =>  --  1E51
          (((1187, 1189), (1187, 1189)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#52#           =>  --  1E52
          (((1190, 1192), (1190, 1192)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#53#           =>  --  1E53
          (((1193, 1195), (1193, 1195)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#54#           =>  --  1E54
          (((1196, 1197), (1196, 1197)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#55#           =>  --  1E55
          (((1198, 1199), (1198, 1199)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#56#           =>  --  1E56
          (((1200, 1201), (1200, 1201)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#57#           =>  --  1E57
          (((1202, 1203), (1202, 1203)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#58#           =>  --  1E58
          (((1204, 1205), (1204, 1205)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#59#           =>  --  1E59
          (((1206, 1207), (1206, 1207)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#5A#           =>  --  1E5A
          (((1208, 1209), (1208, 1209)), (165, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#5B#           =>  --  1E5B
          (((1210, 1211), (1210, 1211)), (166, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#5C#           =>  --  1E5C
          (((1212, 1214), (1212, 1214)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#5D#           =>  --  1E5D
          (((1215, 1217), (1215, 1217)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#5E#           =>  --  1E5E
          (((1218, 1219), (1218, 1219)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#5F#           =>  --  1E5F
          (((1220, 1221), (1220, 1221)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#60#           =>  --  1E60
          (((1222, 1223), (1222, 1223)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#61#           =>  --  1E61
          (((1224, 1225), (1224, 1225)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#62#           =>  --  1E62
          (((1226, 1227), (1226, 1227)), (171, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#63#           =>  --  1E63
          (((1228, 1229), (1228, 1229)), (172, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#64#           =>  --  1E64
          (((1230, 1232), (1230, 1232)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#65#           =>  --  1E65
          (((1233, 1235), (1233, 1235)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#66#           =>  --  1E66
          (((1236, 1238), (1236, 1238)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#67#           =>  --  1E67
          (((1239, 1241), (1239, 1241)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#68#           =>  --  1E68
          (((1242, 1244), (1242, 1244)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#69#           =>  --  1E69
          (((1245, 1247), (1245, 1247)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#6A#           =>  --  1E6A
          (((1248, 1249), (1248, 1249)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#6B#           =>  --  1E6B
          (((1250, 1251), (1250, 1251)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#6C#           =>  --  1E6C
          (((1252, 1253), (1252, 1253)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#6D#           =>  --  1E6D
          (((1254, 1255), (1254, 1255)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#6E#           =>  --  1E6E
          (((1256, 1257), (1256, 1257)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#6F#           =>  --  1E6F
          (((1258, 1259), (1258, 1259)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#70#           =>  --  1E70
          (((1260, 1261), (1260, 1261)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#71#           =>  --  1E71
          (((1262, 1263), (1262, 1263)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#72#           =>  --  1E72
          (((1264, 1265), (1264, 1265)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#73#           =>  --  1E73
          (((1266, 1267), (1266, 1267)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#74#           =>  --  1E74
          (((1268, 1269), (1268, 1269)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#75#           =>  --  1E75
          (((1270, 1271), (1270, 1271)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#76#           =>  --  1E76
          (((1272, 1273), (1272, 1273)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#77#           =>  --  1E77
          (((1274, 1275), (1274, 1275)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#78#           =>  --  1E78
          (((1276, 1278), (1276, 1278)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#79#           =>  --  1E79
          (((1279, 1281), (1279, 1281)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#7A#           =>  --  1E7A
          (((1282, 1284), (1282, 1284)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#7B#           =>  --  1E7B
          (((1285, 1287), (1285, 1287)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#7C#           =>  --  1E7C
          (((1288, 1289), (1288, 1289)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#7D#           =>  --  1E7D
          (((1290, 1291), (1290, 1291)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#7E#           =>  --  1E7E
          (((1292, 1293), (1292, 1293)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#7F#           =>  --  1E7F
          (((1294, 1295), (1294, 1295)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#80#           =>  --  1E80
          (((1296, 1297), (1296, 1297)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#81#           =>  --  1E81
          (((1298, 1299), (1298, 1299)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#82#           =>  --  1E82
          (((1300, 1301), (1300, 1301)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#83#           =>  --  1E83
          (((1302, 1303), (1302, 1303)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#84#           =>  --  1E84
          (((1304, 1305), (1304, 1305)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#85#           =>  --  1E85
          (((1306, 1307), (1306, 1307)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#86#           =>  --  1E86
          (((1308, 1309), (1308, 1309)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#87#           =>  --  1E87
          (((1310, 1311), (1310, 1311)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#88#           =>  --  1E88
          (((1312, 1313), (1312, 1313)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#89#           =>  --  1E89
          (((1314, 1315), (1314, 1315)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#8A#           =>  --  1E8A
          (((1316, 1317), (1316, 1317)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#8B#           =>  --  1E8B
          (((1318, 1319), (1318, 1319)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#8C#           =>  --  1E8C
          (((1320, 1321), (1320, 1321)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#8D#           =>  --  1E8D
          (((1322, 1323), (1322, 1323)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#8E#           =>  --  1E8E
          (((1324, 1325), (1324, 1325)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#8F#           =>  --  1E8F
          (((1326, 1327), (1326, 1327)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#90#           =>  --  1E90
          (((1328, 1329), (1328, 1329)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#91#           =>  --  1E91
          (((1330, 1331), (1330, 1331)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#92#           =>  --  1E92
          (((1332, 1333), (1332, 1333)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#93#           =>  --  1E93
          (((1334, 1335), (1334, 1335)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#94#           =>  --  1E94
          (((1336, 1337), (1336, 1337)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#95#           =>  --  1E95
          (((1338, 1339), (1338, 1339)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#96#           =>  --  1E96
          (((1340, 1341), (1340, 1341)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#97#           =>  --  1E97
          (((1342, 1343), (1342, 1343)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#98#           =>  --  1E98
          (((1344, 1345), (1344, 1345)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#99#           =>  --  1E99
          (((1346, 1347), (1346, 1347)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#9A#           =>  --  1E9A
          (((0, 0), (1348, 1349)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#9B#           =>  --  1E9B
          (((1350, 1351), (1224, 1225)), (0, 0), 0, (Yes, No, No, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#A0#           =>  --  1EA0
          (((1352, 1353), (1352, 1353)), (184, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#A1#           =>  --  1EA1
          (((1354, 1355), (1354, 1355)), (185, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#A2#           =>  --  1EA2
          (((1356, 1357), (1356, 1357)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#A3#           =>  --  1EA3
          (((1358, 1359), (1358, 1359)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#A4#           =>  --  1EA4
          (((1360, 1362), (1360, 1362)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#A5#           =>  --  1EA5
          (((1363, 1365), (1363, 1365)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#A6#           =>  --  1EA6
          (((1366, 1368), (1366, 1368)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#A7#           =>  --  1EA7
          (((1369, 1371), (1369, 1371)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#A8#           =>  --  1EA8
          (((1372, 1374), (1372, 1374)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#A9#           =>  --  1EA9
          (((1375, 1377), (1375, 1377)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#AA#           =>  --  1EAA
          (((1378, 1380), (1378, 1380)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#AB#           =>  --  1EAB
          (((1381, 1383), (1381, 1383)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#AC#           =>  --  1EAC
          (((1384, 1386), (1384, 1386)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#AD#           =>  --  1EAD
          (((1387, 1389), (1387, 1389)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#AE#           =>  --  1EAE
          (((1390, 1392), (1390, 1392)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#AF#           =>  --  1EAF
          (((1393, 1395), (1393, 1395)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#B0#           =>  --  1EB0
          (((1396, 1398), (1396, 1398)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#B1#           =>  --  1EB1
          (((1399, 1401), (1399, 1401)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#B2#           =>  --  1EB2
          (((1402, 1404), (1402, 1404)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#B3#           =>  --  1EB3
          (((1405, 1407), (1405, 1407)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#B4#           =>  --  1EB4
          (((1408, 1410), (1408, 1410)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#B5#           =>  --  1EB5
          (((1411, 1413), (1411, 1413)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#B6#           =>  --  1EB6
          (((1414, 1416), (1414, 1416)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#B7#           =>  --  1EB7
          (((1417, 1419), (1417, 1419)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#B8#           =>  --  1EB8
          (((1420, 1421), (1420, 1421)), (190, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#B9#           =>  --  1EB9
          (((1422, 1423), (1422, 1423)), (191, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#BA#           =>  --  1EBA
          (((1424, 1425), (1424, 1425)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#BB#           =>  --  1EBB
          (((1426, 1427), (1426, 1427)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#BC#           =>  --  1EBC
          (((1428, 1429), (1428, 1429)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#BD#           =>  --  1EBD
          (((1430, 1431), (1430, 1431)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#BE#           =>  --  1EBE
          (((1432, 1434), (1432, 1434)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#BF#           =>  --  1EBF
          (((1435, 1437), (1435, 1437)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#C0#           =>  --  1EC0
          (((1438, 1440), (1438, 1440)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#C1#           =>  --  1EC1
          (((1441, 1443), (1441, 1443)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#C2#           =>  --  1EC2
          (((1444, 1446), (1444, 1446)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#C3#           =>  --  1EC3
          (((1447, 1449), (1447, 1449)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#C4#           =>  --  1EC4
          (((1450, 1452), (1450, 1452)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#C5#           =>  --  1EC5
          (((1453, 1455), (1453, 1455)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#C6#           =>  --  1EC6
          (((1456, 1458), (1456, 1458)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#C7#           =>  --  1EC7
          (((1459, 1461), (1459, 1461)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#C8#           =>  --  1EC8
          (((1462, 1463), (1462, 1463)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#C9#           =>  --  1EC9
          (((1464, 1465), (1464, 1465)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#CA#           =>  --  1ECA
          (((1466, 1467), (1466, 1467)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#CB#           =>  --  1ECB
          (((1468, 1469), (1468, 1469)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#CC#           =>  --  1ECC
          (((1470, 1471), (1470, 1471)), (194, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#CD#           =>  --  1ECD
          (((1472, 1473), (1472, 1473)), (195, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#CE#           =>  --  1ECE
          (((1474, 1475), (1474, 1475)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#CF#           =>  --  1ECF
          (((1476, 1477), (1476, 1477)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#D0#           =>  --  1ED0
          (((1478, 1480), (1478, 1480)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#D1#           =>  --  1ED1
          (((1481, 1483), (1481, 1483)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#D2#           =>  --  1ED2
          (((1484, 1486), (1484, 1486)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#D3#           =>  --  1ED3
          (((1487, 1489), (1487, 1489)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#D4#           =>  --  1ED4
          (((1490, 1492), (1490, 1492)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#D5#           =>  --  1ED5
          (((1493, 1495), (1493, 1495)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#D6#           =>  --  1ED6
          (((1496, 1498), (1496, 1498)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#D7#           =>  --  1ED7
          (((1499, 1501), (1499, 1501)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#D8#           =>  --  1ED8
          (((1502, 1504), (1502, 1504)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#D9#           =>  --  1ED9
          (((1505, 1507), (1505, 1507)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#DA#           =>  --  1EDA
          (((1508, 1510), (1508, 1510)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#DB#           =>  --  1EDB
          (((1511, 1513), (1511, 1513)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#DC#           =>  --  1EDC
          (((1514, 1516), (1514, 1516)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#DD#           =>  --  1EDD
          (((1517, 1519), (1517, 1519)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#DE#           =>  --  1EDE
          (((1520, 1522), (1520, 1522)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#DF#           =>  --  1EDF
          (((1523, 1525), (1523, 1525)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#E0#           =>  --  1EE0
          (((1526, 1528), (1526, 1528)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#E1#           =>  --  1EE1
          (((1529, 1531), (1529, 1531)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#E2#           =>  --  1EE2
          (((1532, 1534), (1532, 1534)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#E3#           =>  --  1EE3
          (((1535, 1537), (1535, 1537)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#E4#           =>  --  1EE4
          (((1538, 1539), (1538, 1539)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#E5#           =>  --  1EE5
          (((1540, 1541), (1540, 1541)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#E6#           =>  --  1EE6
          (((1542, 1543), (1542, 1543)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#E7#           =>  --  1EE7
          (((1544, 1545), (1544, 1545)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#E8#           =>  --  1EE8
          (((1546, 1548), (1546, 1548)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#E9#           =>  --  1EE9
          (((1549, 1551), (1549, 1551)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#EA#           =>  --  1EEA
          (((1552, 1554), (1552, 1554)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#EB#           =>  --  1EEB
          (((1555, 1557), (1555, 1557)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#EC#           =>  --  1EEC
          (((1558, 1560), (1558, 1560)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#ED#           =>  --  1EED
          (((1561, 1563), (1561, 1563)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#EE#           =>  --  1EEE
          (((1564, 1566), (1564, 1566)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#EF#           =>  --  1EEF
          (((1567, 1569), (1567, 1569)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#F0#           =>  --  1EF0
          (((1570, 1572), (1570, 1572)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#F1#           =>  --  1EF1
          (((1573, 1575), (1573, 1575)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#F2#           =>  --  1EF2
          (((1576, 1577), (1576, 1577)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#F3#           =>  --  1EF3
          (((1578, 1579), (1578, 1579)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#F4#           =>  --  1EF4
          (((1580, 1581), (1580, 1581)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#F5#           =>  --  1EF5
          (((1582, 1583), (1582, 1583)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#F6#           =>  --  1EF6
          (((1584, 1585), (1584, 1585)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#F7#           =>  --  1EF7
          (((1586, 1587), (1586, 1587)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#F8#           =>  --  1EF8
          (((1588, 1589), (1588, 1589)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#F9#           =>  --  1EF9
          (((1590, 1591), (1590, 1591)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         others           =>
          (((0, 0), (0, 0)), (0, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)));

   Group_001F : aliased constant Normalization_Mapping_Second_Stage
     := (16#00#           =>  --  1F00
          (((1592, 1593), (1592, 1593)), (200, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#01#           =>  --  1F01
          (((1594, 1595), (1594, 1595)), (201, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#02#           =>  --  1F02
          (((1596, 1598), (1596, 1598)), (227, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#03#           =>  --  1F03
          (((1599, 1601), (1599, 1601)), (228, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#04#           =>  --  1F04
          (((1602, 1604), (1602, 1604)), (229, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#05#           =>  --  1F05
          (((1605, 1607), (1605, 1607)), (230, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#06#           =>  --  1F06
          (((1608, 1610), (1608, 1610)), (231, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#07#           =>  --  1F07
          (((1611, 1613), (1611, 1613)), (232, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#08#           =>  --  1F08
          (((1614, 1615), (1614, 1615)), (202, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#09#           =>  --  1F09
          (((1616, 1617), (1616, 1617)), (203, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#0A#           =>  --  1F0A
          (((1618, 1620), (1618, 1620)), (233, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#0B#           =>  --  1F0B
          (((1621, 1623), (1621, 1623)), (234, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#0C#           =>  --  1F0C
          (((1624, 1626), (1624, 1626)), (235, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#0D#           =>  --  1F0D
          (((1627, 1629), (1627, 1629)), (236, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#0E#           =>  --  1F0E
          (((1630, 1632), (1630, 1632)), (237, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#0F#           =>  --  1F0F
          (((1633, 1635), (1633, 1635)), (238, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#10#           =>  --  1F10
          (((1636, 1637), (1636, 1637)), (204, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#11#           =>  --  1F11
          (((1638, 1639), (1638, 1639)), (205, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#12#           =>  --  1F12
          (((1640, 1642), (1640, 1642)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#13#           =>  --  1F13
          (((1643, 1645), (1643, 1645)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#14#           =>  --  1F14
          (((1646, 1648), (1646, 1648)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#15#           =>  --  1F15
          (((1649, 1651), (1649, 1651)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#18#           =>  --  1F18
          (((1652, 1653), (1652, 1653)), (206, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#19#           =>  --  1F19
          (((1654, 1655), (1654, 1655)), (207, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#1A#           =>  --  1F1A
          (((1656, 1658), (1656, 1658)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#1B#           =>  --  1F1B
          (((1659, 1661), (1659, 1661)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#1C#           =>  --  1F1C
          (((1662, 1664), (1662, 1664)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#1D#           =>  --  1F1D
          (((1665, 1667), (1665, 1667)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#20#           =>  --  1F20
          (((1668, 1669), (1668, 1669)), (208, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#21#           =>  --  1F21
          (((1670, 1671), (1670, 1671)), (209, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#22#           =>  --  1F22
          (((1672, 1674), (1672, 1674)), (239, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#23#           =>  --  1F23
          (((1675, 1677), (1675, 1677)), (240, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#24#           =>  --  1F24
          (((1678, 1680), (1678, 1680)), (241, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#25#           =>  --  1F25
          (((1681, 1683), (1681, 1683)), (242, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#26#           =>  --  1F26
          (((1684, 1686), (1684, 1686)), (243, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#27#           =>  --  1F27
          (((1687, 1689), (1687, 1689)), (244, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#28#           =>  --  1F28
          (((1690, 1691), (1690, 1691)), (210, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#29#           =>  --  1F29
          (((1692, 1693), (1692, 1693)), (211, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#2A#           =>  --  1F2A
          (((1694, 1696), (1694, 1696)), (245, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#2B#           =>  --  1F2B
          (((1697, 1699), (1697, 1699)), (246, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#2C#           =>  --  1F2C
          (((1700, 1702), (1700, 1702)), (247, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#2D#           =>  --  1F2D
          (((1703, 1705), (1703, 1705)), (248, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#2E#           =>  --  1F2E
          (((1706, 1708), (1706, 1708)), (249, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#2F#           =>  --  1F2F
          (((1709, 1711), (1709, 1711)), (250, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#30#           =>  --  1F30
          (((1712, 1713), (1712, 1713)), (212, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#31#           =>  --  1F31
          (((1714, 1715), (1714, 1715)), (213, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#32#           =>  --  1F32
          (((1716, 1718), (1716, 1718)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#33#           =>  --  1F33
          (((1719, 1721), (1719, 1721)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#34#           =>  --  1F34
          (((1722, 1724), (1722, 1724)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#35#           =>  --  1F35
          (((1725, 1727), (1725, 1727)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#36#           =>  --  1F36
          (((1728, 1730), (1728, 1730)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#37#           =>  --  1F37
          (((1731, 1733), (1731, 1733)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#38#           =>  --  1F38
          (((1734, 1735), (1734, 1735)), (214, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#39#           =>  --  1F39
          (((1736, 1737), (1736, 1737)), (215, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#3A#           =>  --  1F3A
          (((1738, 1740), (1738, 1740)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#3B#           =>  --  1F3B
          (((1741, 1743), (1741, 1743)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#3C#           =>  --  1F3C
          (((1744, 1746), (1744, 1746)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#3D#           =>  --  1F3D
          (((1747, 1749), (1747, 1749)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#3E#           =>  --  1F3E
          (((1750, 1752), (1750, 1752)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#3F#           =>  --  1F3F
          (((1753, 1755), (1753, 1755)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#40#           =>  --  1F40
          (((1756, 1757), (1756, 1757)), (216, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#41#           =>  --  1F41
          (((1758, 1759), (1758, 1759)), (217, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#42#           =>  --  1F42
          (((1760, 1762), (1760, 1762)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#43#           =>  --  1F43
          (((1763, 1765), (1763, 1765)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#44#           =>  --  1F44
          (((1766, 1768), (1766, 1768)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#45#           =>  --  1F45
          (((1769, 1771), (1769, 1771)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#48#           =>  --  1F48
          (((1772, 1773), (1772, 1773)), (218, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#49#           =>  --  1F49
          (((1774, 1775), (1774, 1775)), (219, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#4A#           =>  --  1F4A
          (((1776, 1778), (1776, 1778)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#4B#           =>  --  1F4B
          (((1779, 1781), (1779, 1781)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#4C#           =>  --  1F4C
          (((1782, 1784), (1782, 1784)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#4D#           =>  --  1F4D
          (((1785, 1787), (1785, 1787)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#50#           =>  --  1F50
          (((1788, 1789), (1788, 1789)), (220, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#51#           =>  --  1F51
          (((1790, 1791), (1790, 1791)), (221, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#52#           =>  --  1F52
          (((1792, 1794), (1792, 1794)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#53#           =>  --  1F53
          (((1795, 1797), (1795, 1797)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#54#           =>  --  1F54
          (((1798, 1800), (1798, 1800)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#55#           =>  --  1F55
          (((1801, 1803), (1801, 1803)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#56#           =>  --  1F56
          (((1804, 1806), (1804, 1806)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#57#           =>  --  1F57
          (((1807, 1809), (1807, 1809)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#59#           =>  --  1F59
          (((1810, 1811), (1810, 1811)), (222, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#5B#           =>  --  1F5B
          (((1812, 1814), (1812, 1814)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#5D#           =>  --  1F5D
          (((1815, 1817), (1815, 1817)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#5F#           =>  --  1F5F
          (((1818, 1820), (1818, 1820)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#60#           =>  --  1F60
          (((1821, 1822), (1821, 1822)), (223, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#61#           =>  --  1F61
          (((1823, 1824), (1823, 1824)), (224, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#62#           =>  --  1F62
          (((1825, 1827), (1825, 1827)), (251, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#63#           =>  --  1F63
          (((1828, 1830), (1828, 1830)), (252, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#64#           =>  --  1F64
          (((1831, 1833), (1831, 1833)), (253, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#65#           =>  --  1F65
          (((1834, 1836), (1834, 1836)), (254, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#66#           =>  --  1F66
          (((1837, 1839), (1837, 1839)), (255, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#67#           =>  --  1F67
          (((1840, 1842), (1840, 1842)), (256, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#68#           =>  --  1F68
          (((1843, 1844), (1843, 1844)), (225, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#69#           =>  --  1F69
          (((1845, 1846), (1845, 1846)), (226, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#6A#           =>  --  1F6A
          (((1847, 1849), (1847, 1849)), (257, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#6B#           =>  --  1F6B
          (((1850, 1852), (1850, 1852)), (258, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#6C#           =>  --  1F6C
          (((1853, 1855), (1853, 1855)), (259, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#6D#           =>  --  1F6D
          (((1856, 1858), (1856, 1858)), (260, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#6E#           =>  --  1F6E
          (((1859, 1861), (1859, 1861)), (261, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#6F#           =>  --  1F6F
          (((1862, 1864), (1862, 1864)), (262, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#70#           =>  --  1F70
          (((1865, 1866), (1865, 1866)), (263, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#71#           =>  --  1F71
          (((628, 629), (628, 629)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD
              | Full_Composition_Exclusion => True,
            others => False)),
         16#72#           =>  --  1F72
          (((1867, 1868), (1867, 1868)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#73#           =>  --  1F73
          (((630, 631), (630, 631)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD
              | Full_Composition_Exclusion => True,
            others => False)),
         16#74#           =>  --  1F74
          (((1869, 1870), (1869, 1870)), (266, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#75#           =>  --  1F75
          (((632, 633), (632, 633)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD
              | Full_Composition_Exclusion => True,
            others => False)),
         16#76#           =>  --  1F76
          (((1871, 1872), (1871, 1872)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#77#           =>  --  1F77
          (((634, 635), (634, 635)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD
              | Full_Composition_Exclusion => True,
            others => False)),
         16#78#           =>  --  1F78
          (((1873, 1874), (1873, 1874)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#79#           =>  --  1F79
          (((639, 640), (639, 640)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD
              | Full_Composition_Exclusion => True,
            others => False)),
         16#7A#           =>  --  1F7A
          (((1875, 1876), (1875, 1876)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#7B#           =>  --  1F7B
          (((641, 642), (641, 642)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD
              | Full_Composition_Exclusion => True,
            others => False)),
         16#7C#           =>  --  1F7C
          (((1877, 1878), (1877, 1878)), (273, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#7D#           =>  --  1F7D
          (((643, 644), (643, 644)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD
              | Full_Composition_Exclusion => True,
            others => False)),
         16#80#           =>  --  1F80
          (((1879, 1881), (1879, 1881)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#81#           =>  --  1F81
          (((1882, 1884), (1882, 1884)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#82#           =>  --  1F82
          (((1885, 1888), (1885, 1888)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#83#           =>  --  1F83
          (((1889, 1892), (1889, 1892)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#84#           =>  --  1F84
          (((1893, 1896), (1893, 1896)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#85#           =>  --  1F85
          (((1897, 1900), (1897, 1900)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#86#           =>  --  1F86
          (((1901, 1904), (1901, 1904)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#87#           =>  --  1F87
          (((1905, 1908), (1905, 1908)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#88#           =>  --  1F88
          (((1909, 1911), (1909, 1911)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#89#           =>  --  1F89
          (((1912, 1914), (1912, 1914)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#8A#           =>  --  1F8A
          (((1915, 1918), (1915, 1918)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#8B#           =>  --  1F8B
          (((1919, 1922), (1919, 1922)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#8C#           =>  --  1F8C
          (((1923, 1926), (1923, 1926)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#8D#           =>  --  1F8D
          (((1927, 1930), (1927, 1930)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#8E#           =>  --  1F8E
          (((1931, 1934), (1931, 1934)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#8F#           =>  --  1F8F
          (((1935, 1938), (1935, 1938)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#90#           =>  --  1F90
          (((1939, 1941), (1939, 1941)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#91#           =>  --  1F91
          (((1942, 1944), (1942, 1944)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#92#           =>  --  1F92
          (((1945, 1948), (1945, 1948)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#93#           =>  --  1F93
          (((1949, 1952), (1949, 1952)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#94#           =>  --  1F94
          (((1953, 1956), (1953, 1956)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#95#           =>  --  1F95
          (((1957, 1960), (1957, 1960)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#96#           =>  --  1F96
          (((1961, 1964), (1961, 1964)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#97#           =>  --  1F97
          (((1965, 1968), (1965, 1968)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#98#           =>  --  1F98
          (((1969, 1971), (1969, 1971)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#99#           =>  --  1F99
          (((1972, 1974), (1972, 1974)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#9A#           =>  --  1F9A
          (((1975, 1978), (1975, 1978)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#9B#           =>  --  1F9B
          (((1979, 1982), (1979, 1982)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#9C#           =>  --  1F9C
          (((1983, 1986), (1983, 1986)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#9D#           =>  --  1F9D
          (((1987, 1990), (1987, 1990)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#9E#           =>  --  1F9E
          (((1991, 1994), (1991, 1994)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#9F#           =>  --  1F9F
          (((1995, 1998), (1995, 1998)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#A0#           =>  --  1FA0
          (((1999, 2001), (1999, 2001)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#A1#           =>  --  1FA1
          (((2002, 2004), (2002, 2004)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#A2#           =>  --  1FA2
          (((2005, 2008), (2005, 2008)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#A3#           =>  --  1FA3
          (((2009, 2012), (2009, 2012)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#A4#           =>  --  1FA4
          (((2013, 2016), (2013, 2016)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#A5#           =>  --  1FA5
          (((2017, 2020), (2017, 2020)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#A6#           =>  --  1FA6
          (((2021, 2024), (2021, 2024)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#A7#           =>  --  1FA7
          (((2025, 2028), (2025, 2028)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#A8#           =>  --  1FA8
          (((2029, 2031), (2029, 2031)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#A9#           =>  --  1FA9
          (((2032, 2034), (2032, 2034)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#AA#           =>  --  1FAA
          (((2035, 2038), (2035, 2038)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#AB#           =>  --  1FAB
          (((2039, 2042), (2039, 2042)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#AC#           =>  --  1FAC
          (((2043, 2046), (2043, 2046)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#AD#           =>  --  1FAD
          (((2047, 2050), (2047, 2050)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#AE#           =>  --  1FAE
          (((2051, 2054), (2051, 2054)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#AF#           =>  --  1FAF
          (((2055, 2058), (2055, 2058)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#B0#           =>  --  1FB0
          (((2059, 2060), (2059, 2060)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#B1#           =>  --  1FB1
          (((2061, 2062), (2061, 2062)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#B2#           =>  --  1FB2
          (((2063, 2065), (2063, 2065)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#B3#           =>  --  1FB3
          (((2066, 2067), (2066, 2067)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#B4#           =>  --  1FB4
          (((2068, 2070), (2068, 2070)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#B6#           =>  --  1FB6
          (((2071, 2072), (2071, 2072)), (265, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#B7#           =>  --  1FB7
          (((2073, 2075), (2073, 2075)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#B8#           =>  --  1FB8
          (((2076, 2077), (2076, 2077)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#B9#           =>  --  1FB9
          (((2078, 2079), (2078, 2079)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#BA#           =>  --  1FBA
          (((2080, 2081), (2080, 2081)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#BB#           =>  --  1FBB
          (((607, 608), (607, 608)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD
              | Full_Composition_Exclusion => True,
            others => False)),
         16#BC#           =>  --  1FBC
          (((2082, 2083), (2082, 2083)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#BD#           =>  --  1FBD
          (((0, 0), (2084, 2085)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#BE#           =>  --  1FBE
          (((621, 621), (621, 621)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#BF#           =>  --  1FBF
          (((0, 0), (2084, 2085)), (269, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#C0#           =>  --  1FC0
          (((0, 0), (2086, 2087)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#C1#           =>  --  1FC1
          (((2091, 2092), (2088, 2090)), (0, 0), 0, (Yes, No, No, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#C2#           =>  --  1FC2
          (((2093, 2095), (2093, 2095)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#C3#           =>  --  1FC3
          (((2096, 2097), (2096, 2097)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#C4#           =>  --  1FC4
          (((2098, 2100), (2098, 2100)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#C6#           =>  --  1FC6
          (((2101, 2102), (2101, 2102)), (268, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#C7#           =>  --  1FC7
          (((2103, 2105), (2103, 2105)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#C8#           =>  --  1FC8
          (((2106, 2107), (2106, 2107)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#C9#           =>  --  1FC9
          (((609, 610), (609, 610)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD
              | Full_Composition_Exclusion => True,
            others => False)),
         16#CA#           =>  --  1FCA
          (((2108, 2109), (2108, 2109)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#CB#           =>  --  1FCB
          (((611, 612), (611, 612)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD
              | Full_Composition_Exclusion => True,
            others => False)),
         16#CC#           =>  --  1FCC
          (((2110, 2111), (2110, 2111)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#CD#           =>  --  1FCD
          (((2115, 2116), (2112, 2114)), (0, 0), 0, (Yes, No, No, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#CE#           =>  --  1FCE
          (((2120, 2121), (2117, 2119)), (0, 0), 0, (Yes, No, No, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#CF#           =>  --  1FCF
          (((2125, 2126), (2122, 2124)), (0, 0), 0, (Yes, No, No, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#D0#           =>  --  1FD0
          (((2127, 2128), (2127, 2128)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#D1#           =>  --  1FD1
          (((2129, 2130), (2129, 2130)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#D2#           =>  --  1FD2
          (((2131, 2133), (2131, 2133)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#D3#           =>  --  1FD3
          (((621, 623), (621, 623)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD
              | Full_Composition_Exclusion => True,
            others => False)),
         16#D6#           =>  --  1FD6
          (((2134, 2135), (2134, 2135)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#D7#           =>  --  1FD7
          (((2136, 2138), (2136, 2138)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#D8#           =>  --  1FD8
          (((2139, 2140), (2139, 2140)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#D9#           =>  --  1FD9
          (((2141, 2142), (2141, 2142)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#DA#           =>  --  1FDA
          (((2143, 2144), (2143, 2144)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#DB#           =>  --  1FDB
          (((613, 614), (613, 614)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD
              | Full_Composition_Exclusion => True,
            others => False)),
         16#DD#           =>  --  1FDD
          (((2148, 2149), (2145, 2147)), (0, 0), 0, (Yes, No, No, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#DE#           =>  --  1FDE
          (((2153, 2154), (2150, 2152)), (0, 0), 0, (Yes, No, No, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#DF#           =>  --  1FDF
          (((2158, 2159), (2155, 2157)), (0, 0), 0, (Yes, No, No, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#E0#           =>  --  1FE0
          (((2160, 2161), (2160, 2161)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#E1#           =>  --  1FE1
          (((2162, 2163), (2162, 2163)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#E2#           =>  --  1FE2
          (((2164, 2166), (2164, 2166)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#E3#           =>  --  1FE3
          (((636, 638), (636, 638)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD
              | Full_Composition_Exclusion => True,
            others => False)),
         16#E4#           =>  --  1FE4
          (((2167, 2168), (2167, 2168)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#E5#           =>  --  1FE5
          (((2169, 2170), (2169, 2170)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#E6#           =>  --  1FE6
          (((2171, 2172), (2171, 2172)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#E7#           =>  --  1FE7
          (((2173, 2175), (2173, 2175)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#E8#           =>  --  1FE8
          (((2176, 2177), (2176, 2177)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#E9#           =>  --  1FE9
          (((2178, 2179), (2178, 2179)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#EA#           =>  --  1FEA
          (((2180, 2181), (2180, 2181)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#EB#           =>  --  1FEB
          (((617, 618), (617, 618)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD
              | Full_Composition_Exclusion => True,
            others => False)),
         16#EC#           =>  --  1FEC
          (((2182, 2183), (2182, 2183)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#ED#           =>  --  1FED
          (((2187, 2188), (2184, 2186)), (0, 0), 0, (Yes, No, No, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#EE#           =>  --  1FEE
          (((605, 606), (602, 604)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD
              | Full_Composition_Exclusion => True,
            others => False)),
         16#EF#           =>  --  1FEF
          (((2189, 2189), (2189, 2189)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#F2#           =>  --  1FF2
          (((2190, 2192), (2190, 2192)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#F3#           =>  --  1FF3
          (((2193, 2194), (2193, 2194)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#F4#           =>  --  1FF4
          (((2195, 2197), (2195, 2197)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#F6#           =>  --  1FF6
          (((2198, 2199), (2198, 2199)), (275, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#F7#           =>  --  1FF7
          (((2200, 2202), (2200, 2202)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#F8#           =>  --  1FF8
          (((2203, 2204), (2203, 2204)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#F9#           =>  --  1FF9
          (((615, 616), (615, 616)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD
              | Full_Composition_Exclusion => True,
            others => False)),
         16#FA#           =>  --  1FFA
          (((2205, 2206), (2205, 2206)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#FB#           =>  --  1FFB
          (((619, 620), (619, 620)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD
              | Full_Composition_Exclusion => True,
            others => False)),
         16#FC#           =>  --  1FFC
          (((2207, 2208), (2207, 2208)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#FD#           =>  --  1FFD
          (((2209, 2209), (9, 10)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFKD
              | Full_Composition_Exclusion => True,
            others => False)),
         16#FE#           =>  --  1FFE
          (((0, 0), (2145, 2146)), (270, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         others           =>
          (((0, 0), (0, 0)), (0, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)));

   Group_0020 : aliased constant Normalization_Mapping_Second_Stage
     := (16#00#           =>  --  2000
          (((2210, 2210), (1, 1)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#01#           =>  --  2001
          (((2211, 2211), (1, 1)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#02# .. 16#06# =>  --  2002 .. 2006
          (((0, 0), (1, 1)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#07#           =>  --  2007
          (((0, 0), (1, 1)), (0, 0), 0, (Yes, Yes, No, No), No_Break,
           (others => False)),
         16#08# .. 16#0A# =>  --  2008 .. 200A
          (((0, 0), (1, 1)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#11#           =>  --  2011
          (((0, 0), (2212, 2212)), (0, 0), 0, (Yes, Yes, No, No), No_Break,
           (others => False)),
         16#17#           =>  --  2017
          (((0, 0), (2213, 2214)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#24#           =>  --  2024
          (((0, 0), (2215, 2215)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#25#           =>  --  2025
          (((0, 0), (2216, 2217)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#26#           =>  --  2026
          (((0, 0), (2215, 2217)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#2F#           =>  --  202F
          (((0, 0), (1, 1)), (0, 0), 0, (Yes, Yes, No, No), No_Break,
           (others => False)),
         16#33#           =>  --  2033
          (((0, 0), (2218, 2219)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#34#           =>  --  2034
          (((0, 0), (2220, 2222)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#36#           =>  --  2036
          (((0, 0), (2223, 2224)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#37#           =>  --  2037
          (((0, 0), (2225, 2227)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#3C#           =>  --  203C
          (((0, 0), (2228, 2229)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#3E#           =>  --  203E
          (((0, 0), (2230, 2231)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#47#           =>  --  2047
          (((0, 0), (2232, 2233)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#48#           =>  --  2048
          (((0, 0), (2234, 2235)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#49#           =>  --  2049
          (((0, 0), (2236, 2237)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#57#           =>  --  2057
          (((0, 0), (2218, 2221)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#5F#           =>  --  205F
          (((0, 0), (1, 1)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#70#           =>  --  2070
          (((0, 0), (2238, 2238)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#71#           =>  --  2071
          (((0, 0), (99, 99)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#74#           =>  --  2074
          (((0, 0), (18, 18)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#75#           =>  --  2075
          (((0, 0), (2239, 2239)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#76#           =>  --  2076
          (((0, 0), (2240, 2240)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#77#           =>  --  2077
          (((0, 0), (2241, 2241)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#78#           =>  --  2078
          (((0, 0), (2242, 2242)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#79#           =>  --  2079
          (((0, 0), (2243, 2243)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#7A#           =>  --  207A
          (((0, 0), (2244, 2244)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#7B#           =>  --  207B
          (((0, 0), (2245, 2245)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#7C#           =>  --  207C
          (((0, 0), (2246, 2246)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#7D#           =>  --  207D
          (((0, 0), (2247, 2247)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#7E#           =>  --  207E
          (((0, 0), (2248, 2248)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#7F#           =>  --  207F
          (((0, 0), (107, 107)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#80#           =>  --  2080
          (((0, 0), (2238, 2238)), (0, 0), 0, (Yes, Yes, No, No), Sub,
           (others => False)),
         16#81#           =>  --  2081
          (((0, 0), (14, 14)), (0, 0), 0, (Yes, Yes, No, No), Sub,
           (others => False)),
         16#82#           =>  --  2082
          (((0, 0), (7, 7)), (0, 0), 0, (Yes, Yes, No, No), Sub,
           (others => False)),
         16#83#           =>  --  2083
          (((0, 0), (8, 8)), (0, 0), 0, (Yes, Yes, No, No), Sub,
           (others => False)),
         16#84#           =>  --  2084
          (((0, 0), (18, 18)), (0, 0), 0, (Yes, Yes, No, No), Sub,
           (others => False)),
         16#85#           =>  --  2085
          (((0, 0), (2239, 2239)), (0, 0), 0, (Yes, Yes, No, No), Sub,
           (others => False)),
         16#86#           =>  --  2086
          (((0, 0), (2240, 2240)), (0, 0), 0, (Yes, Yes, No, No), Sub,
           (others => False)),
         16#87#           =>  --  2087
          (((0, 0), (2241, 2241)), (0, 0), 0, (Yes, Yes, No, No), Sub,
           (others => False)),
         16#88#           =>  --  2088
          (((0, 0), (2242, 2242)), (0, 0), 0, (Yes, Yes, No, No), Sub,
           (others => False)),
         16#89#           =>  --  2089
          (((0, 0), (2243, 2243)), (0, 0), 0, (Yes, Yes, No, No), Sub,
           (others => False)),
         16#8A#           =>  --  208A
          (((0, 0), (2244, 2244)), (0, 0), 0, (Yes, Yes, No, No), Sub,
           (others => False)),
         16#8B#           =>  --  208B
          (((0, 0), (2245, 2245)), (0, 0), 0, (Yes, Yes, No, No), Sub,
           (others => False)),
         16#8C#           =>  --  208C
          (((0, 0), (2246, 2246)), (0, 0), 0, (Yes, Yes, No, No), Sub,
           (others => False)),
         16#8D#           =>  --  208D
          (((0, 0), (2247, 2247)), (0, 0), 0, (Yes, Yes, No, No), Sub,
           (others => False)),
         16#8E#           =>  --  208E
          (((0, 0), (2248, 2248)), (0, 0), 0, (Yes, Yes, No, No), Sub,
           (others => False)),
         16#90#           =>  --  2090
          (((0, 0), (4, 4)), (0, 0), 0, (Yes, Yes, No, No), Sub,
           (others => False)),
         16#91#           =>  --  2091
          (((0, 0), (91, 91)), (0, 0), 0, (Yes, Yes, No, No), Sub,
           (others => False)),
         16#92#           =>  --  2092
          (((0, 0), (15, 15)), (0, 0), 0, (Yes, Yes, No, No), Sub,
           (others => False)),
         16#93#           =>  --  2093
          (((0, 0), (595, 595)), (0, 0), 0, (Yes, Yes, No, No), Sub,
           (others => False)),
         16#94#           =>  --  2094
          (((0, 0), (959, 959)), (0, 0), 0, (Yes, Yes, No, No), Sub,
           (others => False)),
         16#95#           =>  --  2095
          (((0, 0), (201, 201)), (0, 0), 0, (Yes, Yes, No, No), Sub,
           (others => False)),
         16#96#           =>  --  2096
          (((0, 0), (231, 231)), (0, 0), 0, (Yes, Yes, No, No), Sub,
           (others => False)),
         16#97#           =>  --  2097
          (((0, 0), (235, 235)), (0, 0), 0, (Yes, Yes, No, No), Sub,
           (others => False)),
         16#98#           =>  --  2098
          (((0, 0), (962, 962)), (0, 0), 0, (Yes, Yes, No, No), Sub,
           (others => False)),
         16#99#           =>  --  2099
          (((0, 0), (107, 107)), (0, 0), 0, (Yes, Yes, No, No), Sub,
           (others => False)),
         16#9A#           =>  --  209A
          (((0, 0), (967, 967)), (0, 0), 0, (Yes, Yes, No, No), Sub,
           (others => False)),
         16#9B#           =>  --  209B
          (((0, 0), (289, 289)), (0, 0), 0, (Yes, Yes, No, No), Sub,
           (others => False)),
         16#9C#           =>  --  209C
          (((0, 0), (305, 305)), (0, 0), 0, (Yes, Yes, No, No), Sub,
           (others => False)),
         16#A8#           =>  --  20A8
          (((0, 0), (2249, 2250)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#D0# .. 16#D1# =>  --  20D0 .. 20D1
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#D2# .. 16#D3# =>  --  20D2 .. 20D3
          (((0, 0), (0, 0)), (0, 0), 1, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#D4# .. 16#D7# =>  --  20D4 .. 20D7
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#D8# .. 16#DA# =>  --  20D8 .. 20DA
          (((0, 0), (0, 0)), (0, 0), 1, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#DB# .. 16#DC# =>  --  20DB .. 20DC
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#E1#           =>  --  20E1
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#E5# .. 16#E6# =>  --  20E5 .. 20E6
          (((0, 0), (0, 0)), (0, 0), 1, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#E7#           =>  --  20E7
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#E8#           =>  --  20E8
          (((0, 0), (0, 0)), (0, 0), 220, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#E9#           =>  --  20E9
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#EA# .. 16#EB# =>  --  20EA .. 20EB
          (((0, 0), (0, 0)), (0, 0), 1, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#EC# .. 16#EF# =>  --  20EC .. 20EF
          (((0, 0), (0, 0)), (0, 0), 220, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#F0#           =>  --  20F0
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         others           =>
          (((0, 0), (0, 0)), (0, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)));

   Group_0021 : aliased constant Normalization_Mapping_Second_Stage
     := (16#00#           =>  --  2100
          (((0, 0), (2251, 2253)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#01#           =>  --  2101
          (((0, 0), (2254, 2256)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#02#           =>  --  2102
          (((0, 0), (37, 37)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#03#           =>  --  2103
          (((0, 0), (2257, 2258)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#05#           =>  --  2105
          (((0, 0), (2259, 2261)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#06#           =>  --  2106
          (((0, 0), (2262, 2264)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#07#           =>  --  2107
          (((0, 0), (2265, 2265)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#09#           =>  --  2109
          (((0, 0), (2266, 2267)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#0A#           =>  --  210A
          (((0, 0), (185, 185)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#0B# .. 16#0D# =>  --  210B .. 210D
          (((0, 0), (199, 199)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#0E#           =>  --  210E
          (((0, 0), (201, 201)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#0F#           =>  --  210F
          (((0, 0), (2268, 2268)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#10# .. 16#11# =>  --  2110 .. 2111
          (((0, 0), (47, 47)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#12#           =>  --  2112
          (((0, 0), (233, 233)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#13#           =>  --  2113
          (((0, 0), (235, 235)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#15#           =>  --  2115
          (((0, 0), (55, 55)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#16#           =>  --  2116
          (((0, 0), (2269, 2270)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#19#           =>  --  2119
          (((0, 0), (954, 954)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#1A#           =>  --  211A
          (((0, 0), (2271, 2271)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#1B# .. 16#1D# =>  --  211B .. 211D
          (((0, 0), (275, 275)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#20#           =>  --  2120
          (((0, 0), (2272, 2273)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (Expands_On_NFKD => True,
            others => False)),
         16#21#           =>  --  2121
          (((0, 0), (2274, 2276)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#22#           =>  --  2122
          (((0, 0), (2277, 2278)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (Expands_On_NFKD => True,
            others => False)),
         16#24#           =>  --  2124
          (((0, 0), (345, 345)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#26#           =>  --  2126
          (((619, 619), (619, 619)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#28#           =>  --  2128
          (((0, 0), (345, 345)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#2A#           =>  --  212A
          (((229, 229), (229, 229)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#2B#           =>  --  212B
          (((35, 36), (35, 36)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD
              | Full_Composition_Exclusion => True,
            others => False)),
         16#2C#           =>  --  212C
          (((0, 0), (950, 950)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#2D#           =>  --  212D
          (((0, 0), (37, 37)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#2F#           =>  --  212F
          (((0, 0), (91, 91)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#30#           =>  --  2130
          (((0, 0), (39, 39)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#31#           =>  --  2131
          (((0, 0), (1076, 1076)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#33#           =>  --  2133
          (((0, 0), (952, 952)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#34#           =>  --  2134
          (((0, 0), (15, 15)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#35#           =>  --  2135
          (((0, 0), (2279, 2279)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#36#           =>  --  2136
          (((0, 0), (2280, 2280)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#37#           =>  --  2137
          (((0, 0), (2281, 2281)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#38#           =>  --  2138
          (((0, 0), (2282, 2282)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#39#           =>  --  2139
          (((0, 0), (99, 99)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#3B#           =>  --  213B
          (((0, 0), (2283, 2285)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#3C#           =>  --  213C
          (((0, 0), (652, 652)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#3D#           =>  --  213D
          (((0, 0), (972, 972)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#3E#           =>  --  213E
          (((0, 0), (2286, 2286)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#3F#           =>  --  213F
          (((0, 0), (2287, 2287)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#40#           =>  --  2140
          (((0, 0), (2288, 2288)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#45#           =>  --  2145
          (((0, 0), (159, 159)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#46#           =>  --  2146
          (((0, 0), (161, 161)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#47#           =>  --  2147
          (((0, 0), (91, 91)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#48#           =>  --  2148
          (((0, 0), (99, 99)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#49#           =>  --  2149
          (((0, 0), (224, 224)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#50#           =>  --  2150
          (((0, 0), (2289, 2291)), (0, 0), 0, (Yes, Yes, No, No), Fraction,
           (Expands_On_NFKD => True,
            others => False)),
         16#51#           =>  --  2151
          (((0, 0), (2292, 2294)), (0, 0), 0, (Yes, Yes, No, No), Fraction,
           (Expands_On_NFKD => True,
            others => False)),
         16#52#           =>  --  2152
          (((0, 0), (2295, 2298)), (0, 0), 0, (Yes, Yes, No, No), Fraction,
           (Expands_On_NFKD => True,
            others => False)),
         16#53#           =>  --  2153
          (((0, 0), (2299, 2301)), (0, 0), 0, (Yes, Yes, No, No), Fraction,
           (Expands_On_NFKD => True,
            others => False)),
         16#54#           =>  --  2154
          (((0, 0), (2302, 2304)), (0, 0), 0, (Yes, Yes, No, No), Fraction,
           (Expands_On_NFKD => True,
            others => False)),
         16#55#           =>  --  2155
          (((0, 0), (2305, 2307)), (0, 0), 0, (Yes, Yes, No, No), Fraction,
           (Expands_On_NFKD => True,
            others => False)),
         16#56#           =>  --  2156
          (((0, 0), (2308, 2310)), (0, 0), 0, (Yes, Yes, No, No), Fraction,
           (Expands_On_NFKD => True,
            others => False)),
         16#57#           =>  --  2157
          (((0, 0), (2311, 2313)), (0, 0), 0, (Yes, Yes, No, No), Fraction,
           (Expands_On_NFKD => True,
            others => False)),
         16#58#           =>  --  2158
          (((0, 0), (2314, 2316)), (0, 0), 0, (Yes, Yes, No, No), Fraction,
           (Expands_On_NFKD => True,
            others => False)),
         16#59#           =>  --  2159
          (((0, 0), (2317, 2319)), (0, 0), 0, (Yes, Yes, No, No), Fraction,
           (Expands_On_NFKD => True,
            others => False)),
         16#5A#           =>  --  215A
          (((0, 0), (2320, 2322)), (0, 0), 0, (Yes, Yes, No, No), Fraction,
           (Expands_On_NFKD => True,
            others => False)),
         16#5B#           =>  --  215B
          (((0, 0), (2323, 2325)), (0, 0), 0, (Yes, Yes, No, No), Fraction,
           (Expands_On_NFKD => True,
            others => False)),
         16#5C#           =>  --  215C
          (((0, 0), (2326, 2328)), (0, 0), 0, (Yes, Yes, No, No), Fraction,
           (Expands_On_NFKD => True,
            others => False)),
         16#5D#           =>  --  215D
          (((0, 0), (2329, 2331)), (0, 0), 0, (Yes, Yes, No, No), Fraction,
           (Expands_On_NFKD => True,
            others => False)),
         16#5E#           =>  --  215E
          (((0, 0), (2332, 2334)), (0, 0), 0, (Yes, Yes, No, No), Fraction,
           (Expands_On_NFKD => True,
            others => False)),
         16#5F#           =>  --  215F
          (((0, 0), (16, 17)), (0, 0), 0, (Yes, Yes, No, No), Fraction,
           (Expands_On_NFKD => True,
            others => False)),
         16#60#           =>  --  2160
          (((0, 0), (47, 47)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#61#           =>  --  2161
          (((0, 0), (2335, 2336)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#62#           =>  --  2162
          (((0, 0), (2337, 2339)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#63#           =>  --  2163
          (((0, 0), (2340, 2341)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#64#           =>  --  2164
          (((0, 0), (1288, 1288)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#65#           =>  --  2165
          (((0, 0), (2342, 2343)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#66#           =>  --  2166
          (((0, 0), (2344, 2346)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#67#           =>  --  2167
          (((0, 0), (2347, 2350)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#68#           =>  --  2168
          (((0, 0), (2351, 2352)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#69#           =>  --  2169
          (((0, 0), (1316, 1316)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#6A#           =>  --  216A
          (((0, 0), (2353, 2354)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#6B#           =>  --  216B
          (((0, 0), (2355, 2357)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#6C#           =>  --  216C
          (((0, 0), (233, 233)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#6D#           =>  --  216D
          (((0, 0), (37, 37)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#6E#           =>  --  216E
          (((0, 0), (159, 159)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#6F#           =>  --  216F
          (((0, 0), (952, 952)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#70#           =>  --  2170
          (((0, 0), (99, 99)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#71#           =>  --  2171
          (((0, 0), (2358, 2359)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#72#           =>  --  2172
          (((0, 0), (2360, 2362)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#73#           =>  --  2173
          (((0, 0), (2363, 2364)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#74#           =>  --  2174
          (((0, 0), (970, 970)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#75#           =>  --  2175
          (((0, 0), (2365, 2366)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#76#           =>  --  2176
          (((0, 0), (2367, 2369)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#77#           =>  --  2177
          (((0, 0), (2370, 2373)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#78#           =>  --  2178
          (((0, 0), (2374, 2375)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#79#           =>  --  2179
          (((0, 0), (595, 595)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#7A#           =>  --  217A
          (((0, 0), (2376, 2377)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#7B#           =>  --  217B
          (((0, 0), (2378, 2380)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#7C#           =>  --  217C
          (((0, 0), (235, 235)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#7D#           =>  --  217D
          (((0, 0), (89, 89)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#7E#           =>  --  217E
          (((0, 0), (161, 161)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#7F#           =>  --  217F
          (((0, 0), (962, 962)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#89#           =>  --  2189
          (((0, 0), (2381, 2383)), (0, 0), 0, (Yes, Yes, No, No), Fraction,
           (Expands_On_NFKD => True,
            others => False)),
         16#90#           =>  --  2190
          (((0, 0), (0, 0)), (276, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#92#           =>  --  2192
          (((0, 0), (0, 0)), (277, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#94#           =>  --  2194
          (((0, 0), (0, 0)), (278, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#9A#           =>  --  219A
          (((2384, 2385), (2384, 2385)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#9B#           =>  --  219B
          (((2386, 2387), (2386, 2387)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#AE#           =>  --  21AE
          (((2388, 2389), (2388, 2389)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#CD#           =>  --  21CD
          (((2390, 2391), (2390, 2391)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#CE#           =>  --  21CE
          (((2392, 2393), (2392, 2393)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#CF#           =>  --  21CF
          (((2394, 2395), (2394, 2395)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#D0#           =>  --  21D0
          (((0, 0), (0, 0)), (279, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#D2#           =>  --  21D2
          (((0, 0), (0, 0)), (281, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#D4#           =>  --  21D4
          (((0, 0), (0, 0)), (280, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         others           =>
          (((0, 0), (0, 0)), (0, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)));

   Group_0022 : aliased constant Normalization_Mapping_Second_Stage
     := (16#03#           =>  --  2203
          (((0, 0), (0, 0)), (282, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#04#           =>  --  2204
          (((2396, 2397), (2396, 2397)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#08#           =>  --  2208
          (((0, 0), (0, 0)), (283, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#09#           =>  --  2209
          (((2398, 2399), (2398, 2399)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#0B#           =>  --  220B
          (((0, 0), (0, 0)), (284, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#0C#           =>  --  220C
          (((2400, 2401), (2400, 2401)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#23#           =>  --  2223
          (((0, 0), (0, 0)), (285, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#24#           =>  --  2224
          (((2402, 2403), (2402, 2403)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#25#           =>  --  2225
          (((0, 0), (0, 0)), (286, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#26#           =>  --  2226
          (((2404, 2405), (2404, 2405)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#2C#           =>  --  222C
          (((0, 0), (2406, 2407)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#2D#           =>  --  222D
          (((0, 0), (2408, 2410)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#2F#           =>  --  222F
          (((0, 0), (2411, 2412)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#30#           =>  --  2230
          (((0, 0), (2413, 2415)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#3C#           =>  --  223C
          (((0, 0), (0, 0)), (287, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#41#           =>  --  2241
          (((2416, 2417), (2416, 2417)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#43#           =>  --  2243
          (((0, 0), (0, 0)), (288, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#44#           =>  --  2244
          (((2418, 2419), (2418, 2419)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#45#           =>  --  2245
          (((0, 0), (0, 0)), (289, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#47#           =>  --  2247
          (((2420, 2421), (2420, 2421)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#48#           =>  --  2248
          (((0, 0), (0, 0)), (290, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#49#           =>  --  2249
          (((2422, 2423), (2422, 2423)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#4D#           =>  --  224D
          (((0, 0), (0, 0)), (293, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#60#           =>  --  2260
          (((2424, 2425), (2424, 2425)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#61#           =>  --  2261
          (((0, 0), (0, 0)), (292, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#62#           =>  --  2262
          (((2426, 2427), (2426, 2427)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#64#           =>  --  2264
          (((0, 0), (0, 0)), (296, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#65#           =>  --  2265
          (((0, 0), (0, 0)), (297, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#6D#           =>  --  226D
          (((2428, 2429), (2428, 2429)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#6E#           =>  --  226E
          (((2430, 2431), (2430, 2431)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#6F#           =>  --  226F
          (((2432, 2433), (2432, 2433)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#70#           =>  --  2270
          (((2434, 2435), (2434, 2435)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#71#           =>  --  2271
          (((2436, 2437), (2436, 2437)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#72#           =>  --  2272
          (((0, 0), (0, 0)), (298, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#73#           =>  --  2273
          (((0, 0), (0, 0)), (299, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#74#           =>  --  2274
          (((2438, 2439), (2438, 2439)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#75#           =>  --  2275
          (((2440, 2441), (2440, 2441)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#76#           =>  --  2276
          (((0, 0), (0, 0)), (300, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#77#           =>  --  2277
          (((0, 0), (0, 0)), (301, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#78#           =>  --  2278
          (((2442, 2443), (2442, 2443)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#79#           =>  --  2279
          (((2444, 2445), (2444, 2445)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#7A#           =>  --  227A
          (((0, 0), (0, 0)), (302, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#7B#           =>  --  227B
          (((0, 0), (0, 0)), (303, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#7C#           =>  --  227C
          (((0, 0), (0, 0)), (312, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#7D#           =>  --  227D
          (((0, 0), (0, 0)), (313, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#80#           =>  --  2280
          (((2446, 2447), (2446, 2447)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#81#           =>  --  2281
          (((2448, 2449), (2448, 2449)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#82#           =>  --  2282
          (((0, 0), (0, 0)), (304, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#83#           =>  --  2283
          (((0, 0), (0, 0)), (305, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#84#           =>  --  2284
          (((2450, 2451), (2450, 2451)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#85#           =>  --  2285
          (((2452, 2453), (2452, 2453)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#86#           =>  --  2286
          (((0, 0), (0, 0)), (306, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#87#           =>  --  2287
          (((0, 0), (0, 0)), (307, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#88#           =>  --  2288
          (((2454, 2455), (2454, 2455)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#89#           =>  --  2289
          (((2456, 2457), (2456, 2457)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#91#           =>  --  2291
          (((0, 0), (0, 0)), (314, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#92#           =>  --  2292
          (((0, 0), (0, 0)), (315, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#A2#           =>  --  22A2
          (((0, 0), (0, 0)), (308, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#A8#           =>  --  22A8
          (((0, 0), (0, 0)), (309, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#A9#           =>  --  22A9
          (((0, 0), (0, 0)), (310, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#AB#           =>  --  22AB
          (((0, 0), (0, 0)), (311, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#AC#           =>  --  22AC
          (((2458, 2459), (2458, 2459)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#AD#           =>  --  22AD
          (((2460, 2461), (2460, 2461)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#AE#           =>  --  22AE
          (((2462, 2463), (2462, 2463)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#AF#           =>  --  22AF
          (((2464, 2465), (2464, 2465)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#B2#           =>  --  22B2
          (((0, 0), (0, 0)), (316, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#B3#           =>  --  22B3
          (((0, 0), (0, 0)), (317, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#B4#           =>  --  22B4
          (((0, 0), (0, 0)), (318, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#B5#           =>  --  22B5
          (((0, 0), (0, 0)), (319, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#E0#           =>  --  22E0
          (((2466, 2467), (2466, 2467)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#E1#           =>  --  22E1
          (((2468, 2469), (2468, 2469)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#E2#           =>  --  22E2
          (((2470, 2471), (2470, 2471)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#E3#           =>  --  22E3
          (((2472, 2473), (2472, 2473)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#EA#           =>  --  22EA
          (((2474, 2475), (2474, 2475)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#EB#           =>  --  22EB
          (((2476, 2477), (2476, 2477)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#EC#           =>  --  22EC
          (((2478, 2479), (2478, 2479)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#ED#           =>  --  22ED
          (((2480, 2481), (2480, 2481)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         others           =>
          (((0, 0), (0, 0)), (0, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)));

   Group_0023 : aliased constant Normalization_Mapping_Second_Stage
     := (16#29#           =>  --  2329
          (((2482, 2482), (2482, 2482)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#2A#           =>  --  232A
          (((2483, 2483), (2483, 2483)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         others           =>
          (((0, 0), (0, 0)), (0, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)));

   Group_0024 : aliased constant Normalization_Mapping_Second_Stage
     := (16#60#           =>  --  2460
          (((0, 0), (14, 14)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#61#           =>  --  2461
          (((0, 0), (7, 7)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#62#           =>  --  2462
          (((0, 0), (8, 8)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#63#           =>  --  2463
          (((0, 0), (18, 18)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#64#           =>  --  2464
          (((0, 0), (2239, 2239)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#65#           =>  --  2465
          (((0, 0), (2240, 2240)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#66#           =>  --  2466
          (((0, 0), (2241, 2241)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#67#           =>  --  2467
          (((0, 0), (2242, 2242)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#68#           =>  --  2468
          (((0, 0), (2243, 2243)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#69#           =>  --  2469
          (((0, 0), (2297, 2298)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (Expands_On_NFKD => True,
            others => False)),
         16#6A#           =>  --  246A
          (((0, 0), (2484, 2485)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (Expands_On_NFKD => True,
            others => False)),
         16#6B#           =>  --  246B
          (((0, 0), (2486, 2487)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (Expands_On_NFKD => True,
            others => False)),
         16#6C#           =>  --  246C
          (((0, 0), (2488, 2489)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (Expands_On_NFKD => True,
            others => False)),
         16#6D#           =>  --  246D
          (((0, 0), (2490, 2491)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (Expands_On_NFKD => True,
            others => False)),
         16#6E#           =>  --  246E
          (((0, 0), (2492, 2493)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (Expands_On_NFKD => True,
            others => False)),
         16#6F#           =>  --  246F
          (((0, 0), (2494, 2495)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (Expands_On_NFKD => True,
            others => False)),
         16#70#           =>  --  2470
          (((0, 0), (2496, 2497)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (Expands_On_NFKD => True,
            others => False)),
         16#71#           =>  --  2471
          (((0, 0), (2498, 2499)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (Expands_On_NFKD => True,
            others => False)),
         16#72#           =>  --  2472
          (((0, 0), (2500, 2501)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (Expands_On_NFKD => True,
            others => False)),
         16#73#           =>  --  2473
          (((0, 0), (2502, 2503)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (Expands_On_NFKD => True,
            others => False)),
         16#74#           =>  --  2474
          (((0, 0), (2504, 2506)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#75#           =>  --  2475
          (((0, 0), (2507, 2509)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#76#           =>  --  2476
          (((0, 0), (2510, 2512)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#77#           =>  --  2477
          (((0, 0), (2513, 2515)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#78#           =>  --  2478
          (((0, 0), (2516, 2518)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#79#           =>  --  2479
          (((0, 0), (2519, 2521)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#7A#           =>  --  247A
          (((0, 0), (2522, 2524)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#7B#           =>  --  247B
          (((0, 0), (2525, 2527)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#7C#           =>  --  247C
          (((0, 0), (2528, 2530)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#7D#           =>  --  247D
          (((0, 0), (2531, 2534)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#7E#           =>  --  247E
          (((0, 0), (2535, 2538)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#7F#           =>  --  247F
          (((0, 0), (2539, 2542)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#80#           =>  --  2480
          (((0, 0), (2543, 2546)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#81#           =>  --  2481
          (((0, 0), (2547, 2550)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#82#           =>  --  2482
          (((0, 0), (2551, 2554)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#83#           =>  --  2483
          (((0, 0), (2555, 2558)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#84#           =>  --  2484
          (((0, 0), (2559, 2562)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#85#           =>  --  2485
          (((0, 0), (2563, 2566)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#86#           =>  --  2486
          (((0, 0), (2567, 2570)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#87#           =>  --  2487
          (((0, 0), (2571, 2574)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#88#           =>  --  2488
          (((0, 0), (2575, 2576)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#89#           =>  --  2489
          (((0, 0), (2577, 2578)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#8A#           =>  --  248A
          (((0, 0), (2579, 2580)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#8B#           =>  --  248B
          (((0, 0), (2581, 2582)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#8C#           =>  --  248C
          (((0, 0), (2583, 2584)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#8D#           =>  --  248D
          (((0, 0), (2585, 2586)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#8E#           =>  --  248E
          (((0, 0), (2587, 2588)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#8F#           =>  --  248F
          (((0, 0), (2589, 2590)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#90#           =>  --  2490
          (((0, 0), (2591, 2592)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#91#           =>  --  2491
          (((0, 0), (2593, 2595)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#92#           =>  --  2492
          (((0, 0), (2596, 2598)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#93#           =>  --  2493
          (((0, 0), (2599, 2601)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#94#           =>  --  2494
          (((0, 0), (2602, 2604)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#95#           =>  --  2495
          (((0, 0), (2605, 2607)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#96#           =>  --  2496
          (((0, 0), (2608, 2610)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#97#           =>  --  2497
          (((0, 0), (2611, 2613)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#98#           =>  --  2498
          (((0, 0), (2614, 2616)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#99#           =>  --  2499
          (((0, 0), (2617, 2619)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#9A#           =>  --  249A
          (((0, 0), (2620, 2622)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#9B#           =>  --  249B
          (((0, 0), (2623, 2625)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#9C#           =>  --  249C
          (((0, 0), (2626, 2628)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#9D#           =>  --  249D
          (((0, 0), (2629, 2631)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#9E#           =>  --  249E
          (((0, 0), (2632, 2634)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#9F#           =>  --  249F
          (((0, 0), (2635, 2637)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#A0#           =>  --  24A0
          (((0, 0), (2638, 2640)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#A1#           =>  --  24A1
          (((0, 0), (2641, 2643)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#A2#           =>  --  24A2
          (((0, 0), (2644, 2646)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#A3#           =>  --  24A3
          (((0, 0), (2647, 2649)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#A4#           =>  --  24A4
          (((0, 0), (2650, 2652)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#A5#           =>  --  24A5
          (((0, 0), (2653, 2655)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#A6#           =>  --  24A6
          (((0, 0), (2656, 2658)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#A7#           =>  --  24A7
          (((0, 0), (2659, 2661)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#A8#           =>  --  24A8
          (((0, 0), (2662, 2664)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#A9#           =>  --  24A9
          (((0, 0), (2665, 2667)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#AA#           =>  --  24AA
          (((0, 0), (2668, 2670)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#AB#           =>  --  24AB
          (((0, 0), (2671, 2673)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#AC#           =>  --  24AC
          (((0, 0), (2674, 2676)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#AD#           =>  --  24AD
          (((0, 0), (2677, 2679)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#AE#           =>  --  24AE
          (((0, 0), (2680, 2682)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#AF#           =>  --  24AF
          (((0, 0), (2683, 2685)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#B0#           =>  --  24B0
          (((0, 0), (2686, 2688)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#B1#           =>  --  24B1
          (((0, 0), (2689, 2691)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#B2#           =>  --  24B2
          (((0, 0), (2692, 2694)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#B3#           =>  --  24B3
          (((0, 0), (2695, 2697)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#B4#           =>  --  24B4
          (((0, 0), (2698, 2700)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#B5#           =>  --  24B5
          (((0, 0), (2701, 2703)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#B6#           =>  --  24B6
          (((0, 0), (25, 25)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#B7#           =>  --  24B7
          (((0, 0), (950, 950)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#B8#           =>  --  24B8
          (((0, 0), (37, 37)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#B9#           =>  --  24B9
          (((0, 0), (159, 159)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#BA#           =>  --  24BA
          (((0, 0), (39, 39)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#BB#           =>  --  24BB
          (((0, 0), (1076, 1076)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#BC#           =>  --  24BC
          (((0, 0), (183, 183)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#BD#           =>  --  24BD
          (((0, 0), (199, 199)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#BE#           =>  --  24BE
          (((0, 0), (47, 47)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#BF#           =>  --  24BF
          (((0, 0), (222, 222)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#C0#           =>  --  24C0
          (((0, 0), (229, 229)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#C1#           =>  --  24C1
          (((0, 0), (233, 233)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#C2#           =>  --  24C2
          (((0, 0), (952, 952)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#C3#           =>  --  24C3
          (((0, 0), (55, 55)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#C4#           =>  --  24C4
          (((0, 0), (57, 57)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#C5#           =>  --  24C5
          (((0, 0), (954, 954)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#C6#           =>  --  24C6
          (((0, 0), (2271, 2271)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#C7#           =>  --  24C7
          (((0, 0), (275, 275)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#C8#           =>  --  24C8
          (((0, 0), (287, 287)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#C9#           =>  --  24C9
          (((0, 0), (303, 303)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#CA#           =>  --  24CA
          (((0, 0), (67, 67)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#CB#           =>  --  24CB
          (((0, 0), (1288, 1288)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#CC#           =>  --  24CC
          (((0, 0), (335, 335)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#CD#           =>  --  24CD
          (((0, 0), (1316, 1316)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#CE#           =>  --  24CE
          (((0, 0), (75, 75)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#CF#           =>  --  24CF
          (((0, 0), (345, 345)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#D0#           =>  --  24D0
          (((0, 0), (4, 4)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#D1#           =>  --  24D1
          (((0, 0), (958, 958)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#D2#           =>  --  24D2
          (((0, 0), (89, 89)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#D3#           =>  --  24D3
          (((0, 0), (161, 161)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#D4#           =>  --  24D4
          (((0, 0), (91, 91)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#D5#           =>  --  24D5
          (((0, 0), (979, 979)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#D6#           =>  --  24D6
          (((0, 0), (185, 185)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#D7#           =>  --  24D7
          (((0, 0), (201, 201)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#D8#           =>  --  24D8
          (((0, 0), (99, 99)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#D9#           =>  --  24D9
          (((0, 0), (224, 224)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#DA#           =>  --  24DA
          (((0, 0), (231, 231)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#DB#           =>  --  24DB
          (((0, 0), (235, 235)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#DC#           =>  --  24DC
          (((0, 0), (962, 962)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#DD#           =>  --  24DD
          (((0, 0), (107, 107)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#DE#           =>  --  24DE
          (((0, 0), (15, 15)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#DF#           =>  --  24DF
          (((0, 0), (967, 967)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#E0#           =>  --  24E0
          (((0, 0), (2675, 2675)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#E1#           =>  --  24E1
          (((0, 0), (277, 277)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#E2#           =>  --  24E2
          (((0, 0), (289, 289)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#E3#           =>  --  24E3
          (((0, 0), (305, 305)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#E4#           =>  --  24E4
          (((0, 0), (119, 119)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#E5#           =>  --  24E5
          (((0, 0), (970, 970)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#E6#           =>  --  24E6
          (((0, 0), (337, 337)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#E7#           =>  --  24E7
          (((0, 0), (595, 595)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#E8#           =>  --  24E8
          (((0, 0), (127, 127)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#E9#           =>  --  24E9
          (((0, 0), (347, 347)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#EA#           =>  --  24EA
          (((0, 0), (2238, 2238)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         others           =>
          (((0, 0), (0, 0)), (0, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)));

   Group_002A : aliased constant Normalization_Mapping_Second_Stage
     := (16#0C#           =>  --  2A0C
          (((0, 0), (2406, 2409)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#74#           =>  --  2A74
          (((0, 0), (2704, 2706)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#75#           =>  --  2A75
          (((0, 0), (2707, 2708)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#76#           =>  --  2A76
          (((0, 0), (2706, 2708)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#DC#           =>  --  2ADC
          (((2709, 2710), (2709, 2710)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFKC => False,
            others => True)),
         others           =>
          (((0, 0), (0, 0)), (0, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)));

   Group_002C : aliased constant Normalization_Mapping_Second_Stage
     := (16#7C#           =>  --  2C7C
          (((0, 0), (224, 224)), (0, 0), 0, (Yes, Yes, No, No), Sub,
           (others => False)),
         16#7D#           =>  --  2C7D
          (((0, 0), (1288, 1288)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#EF# .. 16#F1# =>  --  2CEF .. 2CF1
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         others           =>
          (((0, 0), (0, 0)), (0, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)));

   Group_002D : aliased constant Normalization_Mapping_Second_Stage
     := (16#6F#           =>  --  2D6F
          (((0, 0), (2711, 2711)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#7F#           =>  --  2D7F
          (((0, 0), (0, 0)), (0, 0), 9, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#E0# .. 16#FF# =>  --  2DE0 .. 2DFF
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         others           =>
          (((0, 0), (0, 0)), (0, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)));

   Group_002E : aliased constant Normalization_Mapping_Second_Stage
     := (16#9F#           =>  --  2E9F
          (((0, 0), (2712, 2712)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#F3#           =>  --  2EF3
          (((0, 0), (2713, 2713)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         others           =>
          (((0, 0), (0, 0)), (0, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)));

   Group_002F : aliased constant Normalization_Mapping_Second_Stage
     := (16#00#           =>  --  2F00
          (((0, 0), (2714, 2714)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#01#           =>  --  2F01
          (((0, 0), (2715, 2715)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#02#           =>  --  2F02
          (((0, 0), (2716, 2716)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#03#           =>  --  2F03
          (((0, 0), (2717, 2717)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#04#           =>  --  2F04
          (((0, 0), (2718, 2718)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#05#           =>  --  2F05
          (((0, 0), (2719, 2719)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#06#           =>  --  2F06
          (((0, 0), (2720, 2720)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#07#           =>  --  2F07
          (((0, 0), (2721, 2721)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#08#           =>  --  2F08
          (((0, 0), (2722, 2722)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#09#           =>  --  2F09
          (((0, 0), (2723, 2723)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#0A#           =>  --  2F0A
          (((0, 0), (2724, 2724)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#0B#           =>  --  2F0B
          (((0, 0), (2725, 2725)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#0C#           =>  --  2F0C
          (((0, 0), (2726, 2726)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#0D#           =>  --  2F0D
          (((0, 0), (2727, 2727)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#0E#           =>  --  2F0E
          (((0, 0), (2728, 2728)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#0F#           =>  --  2F0F
          (((0, 0), (2729, 2729)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#10#           =>  --  2F10
          (((0, 0), (2730, 2730)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#11#           =>  --  2F11
          (((0, 0), (2731, 2731)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#12#           =>  --  2F12
          (((0, 0), (2732, 2732)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#13#           =>  --  2F13
          (((0, 0), (2733, 2733)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#14#           =>  --  2F14
          (((0, 0), (2734, 2734)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#15#           =>  --  2F15
          (((0, 0), (2735, 2735)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#16#           =>  --  2F16
          (((0, 0), (2736, 2736)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#17#           =>  --  2F17
          (((0, 0), (2737, 2737)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#18#           =>  --  2F18
          (((0, 0), (2738, 2738)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#19#           =>  --  2F19
          (((0, 0), (2739, 2739)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#1A#           =>  --  2F1A
          (((0, 0), (2740, 2740)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#1B#           =>  --  2F1B
          (((0, 0), (2741, 2741)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#1C#           =>  --  2F1C
          (((0, 0), (2742, 2742)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#1D#           =>  --  2F1D
          (((0, 0), (2743, 2743)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#1E#           =>  --  2F1E
          (((0, 0), (2744, 2744)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#1F#           =>  --  2F1F
          (((0, 0), (2745, 2745)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#20#           =>  --  2F20
          (((0, 0), (2746, 2746)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#21#           =>  --  2F21
          (((0, 0), (2747, 2747)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#22#           =>  --  2F22
          (((0, 0), (2748, 2748)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#23#           =>  --  2F23
          (((0, 0), (2749, 2749)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#24#           =>  --  2F24
          (((0, 0), (2750, 2750)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#25#           =>  --  2F25
          (((0, 0), (2751, 2751)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#26#           =>  --  2F26
          (((0, 0), (2752, 2752)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#27#           =>  --  2F27
          (((0, 0), (2753, 2753)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#28#           =>  --  2F28
          (((0, 0), (2754, 2754)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#29#           =>  --  2F29
          (((0, 0), (2755, 2755)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#2A#           =>  --  2F2A
          (((0, 0), (2756, 2756)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#2B#           =>  --  2F2B
          (((0, 0), (2757, 2757)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#2C#           =>  --  2F2C
          (((0, 0), (2758, 2758)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#2D#           =>  --  2F2D
          (((0, 0), (2759, 2759)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#2E#           =>  --  2F2E
          (((0, 0), (2760, 2760)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#2F#           =>  --  2F2F
          (((0, 0), (2761, 2761)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#30#           =>  --  2F30
          (((0, 0), (2762, 2762)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#31#           =>  --  2F31
          (((0, 0), (2763, 2763)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#32#           =>  --  2F32
          (((0, 0), (2764, 2764)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#33#           =>  --  2F33
          (((0, 0), (2765, 2765)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#34#           =>  --  2F34
          (((0, 0), (2766, 2766)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#35#           =>  --  2F35
          (((0, 0), (2767, 2767)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#36#           =>  --  2F36
          (((0, 0), (2768, 2768)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#37#           =>  --  2F37
          (((0, 0), (2769, 2769)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#38#           =>  --  2F38
          (((0, 0), (2770, 2770)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#39#           =>  --  2F39
          (((0, 0), (2771, 2771)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#3A#           =>  --  2F3A
          (((0, 0), (2772, 2772)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#3B#           =>  --  2F3B
          (((0, 0), (2773, 2773)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#3C#           =>  --  2F3C
          (((0, 0), (2774, 2774)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#3D#           =>  --  2F3D
          (((0, 0), (2775, 2775)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#3E#           =>  --  2F3E
          (((0, 0), (2776, 2776)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#3F#           =>  --  2F3F
          (((0, 0), (2777, 2777)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#40#           =>  --  2F40
          (((0, 0), (2778, 2778)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#41#           =>  --  2F41
          (((0, 0), (2779, 2779)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#42#           =>  --  2F42
          (((0, 0), (2780, 2780)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#43#           =>  --  2F43
          (((0, 0), (2781, 2781)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#44#           =>  --  2F44
          (((0, 0), (2782, 2782)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#45#           =>  --  2F45
          (((0, 0), (2783, 2783)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#46#           =>  --  2F46
          (((0, 0), (2784, 2784)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#47#           =>  --  2F47
          (((0, 0), (2785, 2785)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#48#           =>  --  2F48
          (((0, 0), (2786, 2786)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#49#           =>  --  2F49
          (((0, 0), (2787, 2787)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#4A#           =>  --  2F4A
          (((0, 0), (2788, 2788)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#4B#           =>  --  2F4B
          (((0, 0), (2789, 2789)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#4C#           =>  --  2F4C
          (((0, 0), (2790, 2790)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#4D#           =>  --  2F4D
          (((0, 0), (2791, 2791)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#4E#           =>  --  2F4E
          (((0, 0), (2792, 2792)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#4F#           =>  --  2F4F
          (((0, 0), (2793, 2793)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#50#           =>  --  2F50
          (((0, 0), (2794, 2794)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#51#           =>  --  2F51
          (((0, 0), (2795, 2795)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#52#           =>  --  2F52
          (((0, 0), (2796, 2796)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#53#           =>  --  2F53
          (((0, 0), (2797, 2797)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#54#           =>  --  2F54
          (((0, 0), (2798, 2798)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#55#           =>  --  2F55
          (((0, 0), (2799, 2799)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#56#           =>  --  2F56
          (((0, 0), (2800, 2800)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#57#           =>  --  2F57
          (((0, 0), (2801, 2801)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#58#           =>  --  2F58
          (((0, 0), (2802, 2802)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#59#           =>  --  2F59
          (((0, 0), (2803, 2803)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#5A#           =>  --  2F5A
          (((0, 0), (2804, 2804)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#5B#           =>  --  2F5B
          (((0, 0), (2805, 2805)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#5C#           =>  --  2F5C
          (((0, 0), (2806, 2806)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#5D#           =>  --  2F5D
          (((0, 0), (2807, 2807)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#5E#           =>  --  2F5E
          (((0, 0), (2808, 2808)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#5F#           =>  --  2F5F
          (((0, 0), (2809, 2809)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#60#           =>  --  2F60
          (((0, 0), (2810, 2810)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#61#           =>  --  2F61
          (((0, 0), (2811, 2811)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#62#           =>  --  2F62
          (((0, 0), (2812, 2812)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#63#           =>  --  2F63
          (((0, 0), (2813, 2813)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#64#           =>  --  2F64
          (((0, 0), (2814, 2814)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#65#           =>  --  2F65
          (((0, 0), (2815, 2815)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#66#           =>  --  2F66
          (((0, 0), (2816, 2816)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#67#           =>  --  2F67
          (((0, 0), (2817, 2817)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#68#           =>  --  2F68
          (((0, 0), (2818, 2818)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#69#           =>  --  2F69
          (((0, 0), (2819, 2819)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#6A#           =>  --  2F6A
          (((0, 0), (2820, 2820)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#6B#           =>  --  2F6B
          (((0, 0), (2821, 2821)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#6C#           =>  --  2F6C
          (((0, 0), (2822, 2822)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#6D#           =>  --  2F6D
          (((0, 0), (2823, 2823)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#6E#           =>  --  2F6E
          (((0, 0), (2824, 2824)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#6F#           =>  --  2F6F
          (((0, 0), (2825, 2825)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#70#           =>  --  2F70
          (((0, 0), (2826, 2826)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#71#           =>  --  2F71
          (((0, 0), (2827, 2827)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#72#           =>  --  2F72
          (((0, 0), (2828, 2828)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#73#           =>  --  2F73
          (((0, 0), (2829, 2829)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#74#           =>  --  2F74
          (((0, 0), (2830, 2830)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#75#           =>  --  2F75
          (((0, 0), (2831, 2831)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#76#           =>  --  2F76
          (((0, 0), (2832, 2832)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#77#           =>  --  2F77
          (((0, 0), (2833, 2833)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#78#           =>  --  2F78
          (((0, 0), (2834, 2834)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#79#           =>  --  2F79
          (((0, 0), (2835, 2835)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#7A#           =>  --  2F7A
          (((0, 0), (2836, 2836)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#7B#           =>  --  2F7B
          (((0, 0), (2837, 2837)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#7C#           =>  --  2F7C
          (((0, 0), (2838, 2838)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#7D#           =>  --  2F7D
          (((0, 0), (2839, 2839)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#7E#           =>  --  2F7E
          (((0, 0), (2840, 2840)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#7F#           =>  --  2F7F
          (((0, 0), (2841, 2841)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#80#           =>  --  2F80
          (((0, 0), (2842, 2842)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#81#           =>  --  2F81
          (((0, 0), (2843, 2843)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#82#           =>  --  2F82
          (((0, 0), (2844, 2844)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#83#           =>  --  2F83
          (((0, 0), (2845, 2845)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#84#           =>  --  2F84
          (((0, 0), (2846, 2846)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#85#           =>  --  2F85
          (((0, 0), (2847, 2847)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#86#           =>  --  2F86
          (((0, 0), (2848, 2848)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#87#           =>  --  2F87
          (((0, 0), (2849, 2849)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#88#           =>  --  2F88
          (((0, 0), (2850, 2850)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#89#           =>  --  2F89
          (((0, 0), (2851, 2851)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#8A#           =>  --  2F8A
          (((0, 0), (2852, 2852)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#8B#           =>  --  2F8B
          (((0, 0), (2853, 2853)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#8C#           =>  --  2F8C
          (((0, 0), (2854, 2854)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#8D#           =>  --  2F8D
          (((0, 0), (2855, 2855)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#8E#           =>  --  2F8E
          (((0, 0), (2856, 2856)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#8F#           =>  --  2F8F
          (((0, 0), (2857, 2857)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#90#           =>  --  2F90
          (((0, 0), (2858, 2858)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#91#           =>  --  2F91
          (((0, 0), (2859, 2859)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#92#           =>  --  2F92
          (((0, 0), (2860, 2860)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#93#           =>  --  2F93
          (((0, 0), (2861, 2861)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#94#           =>  --  2F94
          (((0, 0), (2862, 2862)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#95#           =>  --  2F95
          (((0, 0), (2863, 2863)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#96#           =>  --  2F96
          (((0, 0), (2864, 2864)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#97#           =>  --  2F97
          (((0, 0), (2865, 2865)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#98#           =>  --  2F98
          (((0, 0), (2866, 2866)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#99#           =>  --  2F99
          (((0, 0), (2867, 2867)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#9A#           =>  --  2F9A
          (((0, 0), (2868, 2868)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#9B#           =>  --  2F9B
          (((0, 0), (2869, 2869)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#9C#           =>  --  2F9C
          (((0, 0), (2870, 2870)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#9D#           =>  --  2F9D
          (((0, 0), (2871, 2871)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#9E#           =>  --  2F9E
          (((0, 0), (2872, 2872)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#9F#           =>  --  2F9F
          (((0, 0), (2873, 2873)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#A0#           =>  --  2FA0
          (((0, 0), (2874, 2874)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#A1#           =>  --  2FA1
          (((0, 0), (2875, 2875)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#A2#           =>  --  2FA2
          (((0, 0), (2876, 2876)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#A3#           =>  --  2FA3
          (((0, 0), (2877, 2877)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#A4#           =>  --  2FA4
          (((0, 0), (2878, 2878)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#A5#           =>  --  2FA5
          (((0, 0), (2879, 2879)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#A6#           =>  --  2FA6
          (((0, 0), (2880, 2880)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#A7#           =>  --  2FA7
          (((0, 0), (2881, 2881)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#A8#           =>  --  2FA8
          (((0, 0), (2882, 2882)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#A9#           =>  --  2FA9
          (((0, 0), (2883, 2883)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#AA#           =>  --  2FAA
          (((0, 0), (2884, 2884)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#AB#           =>  --  2FAB
          (((0, 0), (2885, 2885)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#AC#           =>  --  2FAC
          (((0, 0), (2886, 2886)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#AD#           =>  --  2FAD
          (((0, 0), (2887, 2887)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#AE#           =>  --  2FAE
          (((0, 0), (2888, 2888)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#AF#           =>  --  2FAF
          (((0, 0), (2889, 2889)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#B0#           =>  --  2FB0
          (((0, 0), (2890, 2890)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#B1#           =>  --  2FB1
          (((0, 0), (2891, 2891)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#B2#           =>  --  2FB2
          (((0, 0), (2892, 2892)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#B3#           =>  --  2FB3
          (((0, 0), (2893, 2893)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#B4#           =>  --  2FB4
          (((0, 0), (2894, 2894)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#B5#           =>  --  2FB5
          (((0, 0), (2895, 2895)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#B6#           =>  --  2FB6
          (((0, 0), (2896, 2896)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#B7#           =>  --  2FB7
          (((0, 0), (2897, 2897)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#B8#           =>  --  2FB8
          (((0, 0), (2898, 2898)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#B9#           =>  --  2FB9
          (((0, 0), (2899, 2899)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#BA#           =>  --  2FBA
          (((0, 0), (2900, 2900)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#BB#           =>  --  2FBB
          (((0, 0), (2901, 2901)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#BC#           =>  --  2FBC
          (((0, 0), (2902, 2902)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#BD#           =>  --  2FBD
          (((0, 0), (2903, 2903)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#BE#           =>  --  2FBE
          (((0, 0), (2904, 2904)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#BF#           =>  --  2FBF
          (((0, 0), (2905, 2905)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#C0#           =>  --  2FC0
          (((0, 0), (2906, 2906)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#C1#           =>  --  2FC1
          (((0, 0), (2907, 2907)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#C2#           =>  --  2FC2
          (((0, 0), (2908, 2908)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#C3#           =>  --  2FC3
          (((0, 0), (2909, 2909)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#C4#           =>  --  2FC4
          (((0, 0), (2910, 2910)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#C5#           =>  --  2FC5
          (((0, 0), (2911, 2911)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#C6#           =>  --  2FC6
          (((0, 0), (2912, 2912)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#C7#           =>  --  2FC7
          (((0, 0), (2913, 2913)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#C8#           =>  --  2FC8
          (((0, 0), (2914, 2914)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#C9#           =>  --  2FC9
          (((0, 0), (2915, 2915)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#CA#           =>  --  2FCA
          (((0, 0), (2916, 2916)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#CB#           =>  --  2FCB
          (((0, 0), (2917, 2917)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#CC#           =>  --  2FCC
          (((0, 0), (2918, 2918)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#CD#           =>  --  2FCD
          (((0, 0), (2919, 2919)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#CE#           =>  --  2FCE
          (((0, 0), (2920, 2920)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#CF#           =>  --  2FCF
          (((0, 0), (2921, 2921)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#D0#           =>  --  2FD0
          (((0, 0), (2922, 2922)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#D1#           =>  --  2FD1
          (((0, 0), (2923, 2923)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#D2#           =>  --  2FD2
          (((0, 0), (2924, 2924)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#D3#           =>  --  2FD3
          (((0, 0), (2925, 2925)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#D4#           =>  --  2FD4
          (((0, 0), (2926, 2926)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#D5#           =>  --  2FD5
          (((0, 0), (2927, 2927)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         others           =>
          (((0, 0), (0, 0)), (0, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)));

   Group_0030 : aliased constant Normalization_Mapping_Second_Stage
     := (16#00#           =>  --  3000
          (((0, 0), (1, 1)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#2A#           =>  --  302A
          (((0, 0), (0, 0)), (0, 0), 218, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#2B#           =>  --  302B
          (((0, 0), (0, 0)), (0, 0), 228, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#2C#           =>  --  302C
          (((0, 0), (0, 0)), (0, 0), 232, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#2D#           =>  --  302D
          (((0, 0), (0, 0)), (0, 0), 222, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#2E# .. 16#2F# =>  --  302E .. 302F
          (((0, 0), (0, 0)), (0, 0), 224, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#36#           =>  --  3036
          (((0, 0), (2928, 2928)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#38#           =>  --  3038
          (((0, 0), (2737, 2737)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#39#           =>  --  3039
          (((0, 0), (2929, 2929)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#3A#           =>  --  303A
          (((0, 0), (2930, 2930)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#46#           =>  --  3046
          (((0, 0), (0, 0)), (340, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#4B#           =>  --  304B
          (((0, 0), (0, 0)), (320, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#4C#           =>  --  304C
          (((2931, 2932), (2931, 2932)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#4D#           =>  --  304D
          (((0, 0), (0, 0)), (321, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#4E#           =>  --  304E
          (((2933, 2934), (2933, 2934)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#4F#           =>  --  304F
          (((0, 0), (0, 0)), (322, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#50#           =>  --  3050
          (((2935, 2936), (2935, 2936)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#51#           =>  --  3051
          (((0, 0), (0, 0)), (323, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#52#           =>  --  3052
          (((2937, 2938), (2937, 2938)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#53#           =>  --  3053
          (((0, 0), (0, 0)), (324, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#54#           =>  --  3054
          (((2939, 2940), (2939, 2940)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#55#           =>  --  3055
          (((0, 0), (0, 0)), (325, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#56#           =>  --  3056
          (((2941, 2942), (2941, 2942)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#57#           =>  --  3057
          (((0, 0), (0, 0)), (326, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#58#           =>  --  3058
          (((2943, 2944), (2943, 2944)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#59#           =>  --  3059
          (((0, 0), (0, 0)), (327, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#5A#           =>  --  305A
          (((2945, 2946), (2945, 2946)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#5B#           =>  --  305B
          (((0, 0), (0, 0)), (328, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#5C#           =>  --  305C
          (((2947, 2948), (2947, 2948)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#5D#           =>  --  305D
          (((0, 0), (0, 0)), (329, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#5E#           =>  --  305E
          (((2949, 2950), (2949, 2950)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#5F#           =>  --  305F
          (((0, 0), (0, 0)), (330, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#60#           =>  --  3060
          (((2951, 2952), (2951, 2952)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#61#           =>  --  3061
          (((0, 0), (0, 0)), (331, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#62#           =>  --  3062
          (((2953, 2954), (2953, 2954)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#64#           =>  --  3064
          (((0, 0), (0, 0)), (332, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#65#           =>  --  3065
          (((2955, 2956), (2955, 2956)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#66#           =>  --  3066
          (((0, 0), (0, 0)), (333, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#67#           =>  --  3067
          (((2957, 2958), (2957, 2958)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#68#           =>  --  3068
          (((0, 0), (0, 0)), (334, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#69#           =>  --  3069
          (((2959, 2960), (2959, 2960)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#6F#           =>  --  306F
          (((0, 0), (0, 0)), (335, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#70#           =>  --  3070
          (((2961, 2962), (2961, 2962)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#71#           =>  --  3071
          (((2963, 2964), (2963, 2964)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#72#           =>  --  3072
          (((0, 0), (0, 0)), (336, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#73#           =>  --  3073
          (((2965, 2966), (2965, 2966)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#74#           =>  --  3074
          (((2967, 2968), (2967, 2968)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#75#           =>  --  3075
          (((0, 0), (0, 0)), (337, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#76#           =>  --  3076
          (((2969, 2970), (2969, 2970)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#77#           =>  --  3077
          (((2971, 2972), (2971, 2972)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#78#           =>  --  3078
          (((0, 0), (0, 0)), (338, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#79#           =>  --  3079
          (((2973, 2974), (2973, 2974)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#7A#           =>  --  307A
          (((2975, 2976), (2975, 2976)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#7B#           =>  --  307B
          (((0, 0), (0, 0)), (339, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#7C#           =>  --  307C
          (((2977, 2978), (2977, 2978)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#7D#           =>  --  307D
          (((2979, 2980), (2979, 2980)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#94#           =>  --  3094
          (((2981, 2982), (2981, 2982)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#99#           =>  --  3099
          (((0, 0), (0, 0)), (0, 53), 8, (Maybe, Yes, Maybe, Yes), None,
           (others => False)),
         16#9A#           =>  --  309A
          (((0, 0), (0, 0)), (0, 54), 8, (Maybe, Yes, Maybe, Yes), None,
           (others => False)),
         16#9B#           =>  --  309B
          (((0, 0), (2983, 2984)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#9C#           =>  --  309C
          (((0, 0), (2985, 2986)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#9D#           =>  --  309D
          (((0, 0), (0, 0)), (341, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#9E#           =>  --  309E
          (((2987, 2988), (2987, 2988)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#9F#           =>  --  309F
          (((0, 0), (2989, 2990)), (0, 0), 0, (Yes, Yes, No, No), Vertical,
           (Expands_On_NFKD => True,
            others => False)),
         16#A6#           =>  --  30A6
          (((0, 0), (0, 0)), (362, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#AB#           =>  --  30AB
          (((0, 0), (0, 0)), (342, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#AC#           =>  --  30AC
          (((2991, 2992), (2991, 2992)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#AD#           =>  --  30AD
          (((0, 0), (0, 0)), (343, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#AE#           =>  --  30AE
          (((2993, 2994), (2993, 2994)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#AF#           =>  --  30AF
          (((0, 0), (0, 0)), (344, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#B0#           =>  --  30B0
          (((2995, 2996), (2995, 2996)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#B1#           =>  --  30B1
          (((0, 0), (0, 0)), (345, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#B2#           =>  --  30B2
          (((2997, 2998), (2997, 2998)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#B3#           =>  --  30B3
          (((0, 0), (0, 0)), (346, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#B4#           =>  --  30B4
          (((2999, 3000), (2999, 3000)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#B5#           =>  --  30B5
          (((0, 0), (0, 0)), (347, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#B6#           =>  --  30B6
          (((3001, 3002), (3001, 3002)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#B7#           =>  --  30B7
          (((0, 0), (0, 0)), (348, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#B8#           =>  --  30B8
          (((3003, 3004), (3003, 3004)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#B9#           =>  --  30B9
          (((0, 0), (0, 0)), (349, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#BA#           =>  --  30BA
          (((3005, 3006), (3005, 3006)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#BB#           =>  --  30BB
          (((0, 0), (0, 0)), (350, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#BC#           =>  --  30BC
          (((3007, 3008), (3007, 3008)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#BD#           =>  --  30BD
          (((0, 0), (0, 0)), (351, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#BE#           =>  --  30BE
          (((3009, 3010), (3009, 3010)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#BF#           =>  --  30BF
          (((0, 0), (0, 0)), (352, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#C0#           =>  --  30C0
          (((3011, 3012), (3011, 3012)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#C1#           =>  --  30C1
          (((0, 0), (0, 0)), (353, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#C2#           =>  --  30C2
          (((3013, 3014), (3013, 3014)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#C4#           =>  --  30C4
          (((0, 0), (0, 0)), (354, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#C5#           =>  --  30C5
          (((3015, 3016), (3015, 3016)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#C6#           =>  --  30C6
          (((0, 0), (0, 0)), (355, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#C7#           =>  --  30C7
          (((3017, 3018), (3017, 3018)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#C8#           =>  --  30C8
          (((0, 0), (0, 0)), (356, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#C9#           =>  --  30C9
          (((3019, 3020), (3019, 3020)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#CF#           =>  --  30CF
          (((0, 0), (0, 0)), (357, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#D0#           =>  --  30D0
          (((3021, 3022), (3021, 3022)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#D1#           =>  --  30D1
          (((3023, 3024), (3023, 3024)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#D2#           =>  --  30D2
          (((0, 0), (0, 0)), (358, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#D3#           =>  --  30D3
          (((3025, 3026), (3025, 3026)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#D4#           =>  --  30D4
          (((3027, 3028), (3027, 3028)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#D5#           =>  --  30D5
          (((0, 0), (0, 0)), (359, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#D6#           =>  --  30D6
          (((3029, 3030), (3029, 3030)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#D7#           =>  --  30D7
          (((3031, 3032), (3031, 3032)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#D8#           =>  --  30D8
          (((0, 0), (0, 0)), (360, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#D9#           =>  --  30D9
          (((3033, 3034), (3033, 3034)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#DA#           =>  --  30DA
          (((3035, 3036), (3035, 3036)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#DB#           =>  --  30DB
          (((0, 0), (0, 0)), (361, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#DC#           =>  --  30DC
          (((3037, 3038), (3037, 3038)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#DD#           =>  --  30DD
          (((3039, 3040), (3039, 3040)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#EF#           =>  --  30EF
          (((0, 0), (0, 0)), (363, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#F0#           =>  --  30F0
          (((0, 0), (0, 0)), (364, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#F1#           =>  --  30F1
          (((0, 0), (0, 0)), (365, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#F2#           =>  --  30F2
          (((0, 0), (0, 0)), (366, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#F4#           =>  --  30F4
          (((3041, 3042), (3041, 3042)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#F7#           =>  --  30F7
          (((3043, 3044), (3043, 3044)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#F8#           =>  --  30F8
          (((3045, 3046), (3045, 3046)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#F9#           =>  --  30F9
          (((3047, 3048), (3047, 3048)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#FA#           =>  --  30FA
          (((3049, 3050), (3049, 3050)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#FD#           =>  --  30FD
          (((0, 0), (0, 0)), (367, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#FE#           =>  --  30FE
          (((3051, 3052), (3051, 3052)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#FF#           =>  --  30FF
          (((0, 0), (3053, 3054)), (0, 0), 0, (Yes, Yes, No, No), Vertical,
           (Expands_On_NFKD => True,
            others => False)),
         others           =>
          (((0, 0), (0, 0)), (0, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)));

   Group_0031 : aliased constant Normalization_Mapping_Second_Stage
     := (16#31#           =>  --  3131
          (((0, 0), (3055, 3055)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#32#           =>  --  3132
          (((0, 0), (3056, 3056)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#33#           =>  --  3133
          (((0, 0), (3057, 3057)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#34#           =>  --  3134
          (((0, 0), (3058, 3058)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#35#           =>  --  3135
          (((0, 0), (3059, 3059)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#36#           =>  --  3136
          (((0, 0), (3060, 3060)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#37#           =>  --  3137
          (((0, 0), (3061, 3061)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#38#           =>  --  3138
          (((0, 0), (3062, 3062)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#39#           =>  --  3139
          (((0, 0), (3063, 3063)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#3A#           =>  --  313A
          (((0, 0), (3064, 3064)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#3B#           =>  --  313B
          (((0, 0), (3065, 3065)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#3C#           =>  --  313C
          (((0, 0), (3066, 3066)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#3D#           =>  --  313D
          (((0, 0), (3067, 3067)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#3E#           =>  --  313E
          (((0, 0), (3068, 3068)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#3F#           =>  --  313F
          (((0, 0), (3069, 3069)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#40#           =>  --  3140
          (((0, 0), (3070, 3070)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#41#           =>  --  3141
          (((0, 0), (3071, 3071)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#42#           =>  --  3142
          (((0, 0), (3072, 3072)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#43#           =>  --  3143
          (((0, 0), (3073, 3073)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#44#           =>  --  3144
          (((0, 0), (3074, 3074)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#45#           =>  --  3145
          (((0, 0), (3075, 3075)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#46#           =>  --  3146
          (((0, 0), (3076, 3076)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#47#           =>  --  3147
          (((0, 0), (3077, 3077)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#48#           =>  --  3148
          (((0, 0), (3078, 3078)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#49#           =>  --  3149
          (((0, 0), (3079, 3079)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#4A#           =>  --  314A
          (((0, 0), (3080, 3080)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#4B#           =>  --  314B
          (((0, 0), (3081, 3081)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#4C#           =>  --  314C
          (((0, 0), (3082, 3082)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#4D#           =>  --  314D
          (((0, 0), (3083, 3083)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#4E#           =>  --  314E
          (((0, 0), (3084, 3084)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#4F#           =>  --  314F
          (((0, 0), (3085, 3085)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#50#           =>  --  3150
          (((0, 0), (3086, 3086)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#51#           =>  --  3151
          (((0, 0), (3087, 3087)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#52#           =>  --  3152
          (((0, 0), (3088, 3088)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#53#           =>  --  3153
          (((0, 0), (3089, 3089)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#54#           =>  --  3154
          (((0, 0), (3090, 3090)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#55#           =>  --  3155
          (((0, 0), (3091, 3091)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#56#           =>  --  3156
          (((0, 0), (3092, 3092)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#57#           =>  --  3157
          (((0, 0), (3093, 3093)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#58#           =>  --  3158
          (((0, 0), (3094, 3094)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#59#           =>  --  3159
          (((0, 0), (3095, 3095)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#5A#           =>  --  315A
          (((0, 0), (3096, 3096)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#5B#           =>  --  315B
          (((0, 0), (3097, 3097)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#5C#           =>  --  315C
          (((0, 0), (3098, 3098)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#5D#           =>  --  315D
          (((0, 0), (3099, 3099)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#5E#           =>  --  315E
          (((0, 0), (3100, 3100)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#5F#           =>  --  315F
          (((0, 0), (3101, 3101)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#60#           =>  --  3160
          (((0, 0), (3102, 3102)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#61#           =>  --  3161
          (((0, 0), (3103, 3103)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#62#           =>  --  3162
          (((0, 0), (3104, 3104)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#63#           =>  --  3163
          (((0, 0), (3105, 3105)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#64#           =>  --  3164
          (((0, 0), (3106, 3106)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#65#           =>  --  3165
          (((0, 0), (3107, 3107)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#66#           =>  --  3166
          (((0, 0), (3108, 3108)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#67#           =>  --  3167
          (((0, 0), (3109, 3109)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#68#           =>  --  3168
          (((0, 0), (3110, 3110)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#69#           =>  --  3169
          (((0, 0), (3111, 3111)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#6A#           =>  --  316A
          (((0, 0), (3112, 3112)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#6B#           =>  --  316B
          (((0, 0), (3113, 3113)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#6C#           =>  --  316C
          (((0, 0), (3114, 3114)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#6D#           =>  --  316D
          (((0, 0), (3115, 3115)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#6E#           =>  --  316E
          (((0, 0), (3116, 3116)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#6F#           =>  --  316F
          (((0, 0), (3117, 3117)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#70#           =>  --  3170
          (((0, 0), (3118, 3118)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#71#           =>  --  3171
          (((0, 0), (3119, 3119)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#72#           =>  --  3172
          (((0, 0), (3120, 3120)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#73#           =>  --  3173
          (((0, 0), (3121, 3121)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#74#           =>  --  3174
          (((0, 0), (3122, 3122)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#75#           =>  --  3175
          (((0, 0), (3123, 3123)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#76#           =>  --  3176
          (((0, 0), (3124, 3124)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#77#           =>  --  3177
          (((0, 0), (3125, 3125)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#78#           =>  --  3178
          (((0, 0), (3126, 3126)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#79#           =>  --  3179
          (((0, 0), (3127, 3127)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#7A#           =>  --  317A
          (((0, 0), (3128, 3128)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#7B#           =>  --  317B
          (((0, 0), (3129, 3129)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#7C#           =>  --  317C
          (((0, 0), (3130, 3130)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#7D#           =>  --  317D
          (((0, 0), (3131, 3131)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#7E#           =>  --  317E
          (((0, 0), (3132, 3132)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#7F#           =>  --  317F
          (((0, 0), (3133, 3133)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#80#           =>  --  3180
          (((0, 0), (3134, 3134)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#81#           =>  --  3181
          (((0, 0), (3135, 3135)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#82#           =>  --  3182
          (((0, 0), (3136, 3136)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#83#           =>  --  3183
          (((0, 0), (3137, 3137)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#84#           =>  --  3184
          (((0, 0), (3138, 3138)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#85#           =>  --  3185
          (((0, 0), (3139, 3139)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#86#           =>  --  3186
          (((0, 0), (3140, 3140)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#87#           =>  --  3187
          (((0, 0), (3141, 3141)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#88#           =>  --  3188
          (((0, 0), (3142, 3142)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#89#           =>  --  3189
          (((0, 0), (3143, 3143)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#8A#           =>  --  318A
          (((0, 0), (3144, 3144)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#8B#           =>  --  318B
          (((0, 0), (3145, 3145)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#8C#           =>  --  318C
          (((0, 0), (3146, 3146)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#8D#           =>  --  318D
          (((0, 0), (3147, 3147)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#8E#           =>  --  318E
          (((0, 0), (3148, 3148)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#92#           =>  --  3192
          (((0, 0), (2714, 2714)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#93#           =>  --  3193
          (((0, 0), (2720, 2720)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#94#           =>  --  3194
          (((0, 0), (3149, 3149)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#95#           =>  --  3195
          (((0, 0), (3150, 3150)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#96#           =>  --  3196
          (((0, 0), (3151, 3151)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#97#           =>  --  3197
          (((0, 0), (3152, 3152)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#98#           =>  --  3198
          (((0, 0), (3153, 3153)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#99#           =>  --  3199
          (((0, 0), (3154, 3154)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#9A#           =>  --  319A
          (((0, 0), (2718, 2718)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#9B#           =>  --  319B
          (((0, 0), (3155, 3155)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#9C#           =>  --  319C
          (((0, 0), (3156, 3156)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#9D#           =>  --  319D
          (((0, 0), (3157, 3157)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#9E#           =>  --  319E
          (((0, 0), (3158, 3158)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#9F#           =>  --  319F
          (((0, 0), (2722, 2722)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         others           =>
          (((0, 0), (0, 0)), (0, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)));

   Group_0032 : aliased constant Normalization_Mapping_Second_Stage
     := (16#00#           =>  --  3200
          (((0, 0), (3159, 3161)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#01#           =>  --  3201
          (((0, 0), (3162, 3164)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#02#           =>  --  3202
          (((0, 0), (3165, 3167)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#03#           =>  --  3203
          (((0, 0), (3168, 3170)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#04#           =>  --  3204
          (((0, 0), (3171, 3173)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#05#           =>  --  3205
          (((0, 0), (3174, 3176)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#06#           =>  --  3206
          (((0, 0), (3177, 3179)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#07#           =>  --  3207
          (((0, 0), (3180, 3182)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#08#           =>  --  3208
          (((0, 0), (3183, 3185)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#09#           =>  --  3209
          (((0, 0), (3186, 3188)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#0A#           =>  --  320A
          (((0, 0), (3189, 3191)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#0B#           =>  --  320B
          (((0, 0), (3192, 3194)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#0C#           =>  --  320C
          (((0, 0), (3195, 3197)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#0D#           =>  --  320D
          (((0, 0), (3198, 3200)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#0E#           =>  --  320E
          (((0, 0), (3201, 3204)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#0F#           =>  --  320F
          (((0, 0), (3205, 3208)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#10#           =>  --  3210
          (((0, 0), (3209, 3212)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#11#           =>  --  3211
          (((0, 0), (3213, 3216)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#12#           =>  --  3212
          (((0, 0), (3217, 3220)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#13#           =>  --  3213
          (((0, 0), (3221, 3224)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#14#           =>  --  3214
          (((0, 0), (3225, 3228)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#15#           =>  --  3215
          (((0, 0), (3229, 3232)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#16#           =>  --  3216
          (((0, 0), (3233, 3236)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#17#           =>  --  3217
          (((0, 0), (3237, 3240)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#18#           =>  --  3218
          (((0, 0), (3241, 3244)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#19#           =>  --  3219
          (((0, 0), (3245, 3248)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#1A#           =>  --  321A
          (((0, 0), (3249, 3252)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#1B#           =>  --  321B
          (((0, 0), (3253, 3256)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#1C#           =>  --  321C
          (((0, 0), (3257, 3260)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#1D#           =>  --  321D
          (((0, 0), (3261, 3267)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#1E#           =>  --  321E
          (((0, 0), (3268, 3273)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#20#           =>  --  3220
          (((0, 0), (3274, 3276)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#21#           =>  --  3221
          (((0, 0), (3277, 3279)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#22#           =>  --  3222
          (((0, 0), (3280, 3282)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#23#           =>  --  3223
          (((0, 0), (3283, 3285)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#24#           =>  --  3224
          (((0, 0), (3286, 3288)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#25#           =>  --  3225
          (((0, 0), (3289, 3291)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#26#           =>  --  3226
          (((0, 0), (3292, 3294)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#27#           =>  --  3227
          (((0, 0), (3295, 3297)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#28#           =>  --  3228
          (((0, 0), (3298, 3300)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#29#           =>  --  3229
          (((0, 0), (3301, 3303)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#2A#           =>  --  322A
          (((0, 0), (3304, 3306)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#2B#           =>  --  322B
          (((0, 0), (3307, 3309)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#2C#           =>  --  322C
          (((0, 0), (3310, 3312)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#2D#           =>  --  322D
          (((0, 0), (3313, 3315)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#2E#           =>  --  322E
          (((0, 0), (3316, 3318)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#2F#           =>  --  322F
          (((0, 0), (3319, 3321)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#30#           =>  --  3230
          (((0, 0), (3322, 3324)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#31#           =>  --  3231
          (((0, 0), (3325, 3327)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#32#           =>  --  3232
          (((0, 0), (3328, 3330)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#33#           =>  --  3233
          (((0, 0), (3331, 3333)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#34#           =>  --  3234
          (((0, 0), (3334, 3336)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#35#           =>  --  3235
          (((0, 0), (3337, 3339)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#36#           =>  --  3236
          (((0, 0), (3340, 3342)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#37#           =>  --  3237
          (((0, 0), (3343, 3345)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#38#           =>  --  3238
          (((0, 0), (3346, 3348)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#39#           =>  --  3239
          (((0, 0), (3349, 3351)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#3A#           =>  --  323A
          (((0, 0), (3352, 3354)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#3B#           =>  --  323B
          (((0, 0), (3355, 3357)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#3C#           =>  --  323C
          (((0, 0), (3358, 3360)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#3D#           =>  --  323D
          (((0, 0), (3361, 3363)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#3E#           =>  --  323E
          (((0, 0), (3364, 3366)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#3F#           =>  --  323F
          (((0, 0), (3367, 3369)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#40#           =>  --  3240
          (((0, 0), (3370, 3372)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#41#           =>  --  3241
          (((0, 0), (3373, 3375)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#42#           =>  --  3242
          (((0, 0), (3376, 3378)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#43#           =>  --  3243
          (((0, 0), (3379, 3381)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#44#           =>  --  3244
          (((0, 0), (3382, 3382)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#45#           =>  --  3245
          (((0, 0), (3383, 3383)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#46#           =>  --  3246
          (((0, 0), (2780, 2780)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#47#           =>  --  3247
          (((0, 0), (3384, 3384)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#50#           =>  --  3250
          (((0, 0), (3385, 3387)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#51#           =>  --  3251
          (((0, 0), (2487, 2488)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (Expands_On_NFKD => True,
            others => False)),
         16#52#           =>  --  3252
          (((0, 0), (3388, 3389)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (Expands_On_NFKD => True,
            others => False)),
         16#53#           =>  --  3253
          (((0, 0), (7, 8)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (Expands_On_NFKD => True,
            others => False)),
         16#54#           =>  --  3254
          (((0, 0), (3390, 3391)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (Expands_On_NFKD => True,
            others => False)),
         16#55#           =>  --  3255
          (((0, 0), (3392, 3393)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (Expands_On_NFKD => True,
            others => False)),
         16#56#           =>  --  3256
          (((0, 0), (3394, 3395)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (Expands_On_NFKD => True,
            others => False)),
         16#57#           =>  --  3257
          (((0, 0), (3396, 3397)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (Expands_On_NFKD => True,
            others => False)),
         16#58#           =>  --  3258
          (((0, 0), (3398, 3399)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (Expands_On_NFKD => True,
            others => False)),
         16#59#           =>  --  3259
          (((0, 0), (3400, 3401)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (Expands_On_NFKD => True,
            others => False)),
         16#5A#           =>  --  325A
          (((0, 0), (3402, 3403)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (Expands_On_NFKD => True,
            others => False)),
         16#5B#           =>  --  325B
          (((0, 0), (2304, 2305)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (Expands_On_NFKD => True,
            others => False)),
         16#5C#           =>  --  325C
          (((0, 0), (2301, 2302)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (Expands_On_NFKD => True,
            others => False)),
         16#5D#           =>  --  325D
          (((0, 0), (3404, 3405)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (Expands_On_NFKD => True,
            others => False)),
         16#5E#           =>  --  325E
          (((0, 0), (3406, 3407)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (Expands_On_NFKD => True,
            others => False)),
         16#5F#           =>  --  325F
          (((0, 0), (3408, 3409)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (Expands_On_NFKD => True,
            others => False)),
         16#60#           =>  --  3260
          (((0, 0), (3055, 3055)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#61#           =>  --  3261
          (((0, 0), (3058, 3058)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#62#           =>  --  3262
          (((0, 0), (3061, 3061)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#63#           =>  --  3263
          (((0, 0), (3063, 3063)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#64#           =>  --  3264
          (((0, 0), (3071, 3071)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#65#           =>  --  3265
          (((0, 0), (3072, 3072)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#66#           =>  --  3266
          (((0, 0), (3075, 3075)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#67#           =>  --  3267
          (((0, 0), (3077, 3077)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#68#           =>  --  3268
          (((0, 0), (3078, 3078)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#69#           =>  --  3269
          (((0, 0), (3080, 3080)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#6A#           =>  --  326A
          (((0, 0), (3081, 3081)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#6B#           =>  --  326B
          (((0, 0), (3082, 3082)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#6C#           =>  --  326C
          (((0, 0), (3083, 3083)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#6D#           =>  --  326D
          (((0, 0), (3084, 3084)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#6E#           =>  --  326E
          (((0, 0), (3202, 3203)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (Expands_On_NFKD => True,
            others => False)),
         16#6F#           =>  --  326F
          (((0, 0), (3206, 3207)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (Expands_On_NFKD => True,
            others => False)),
         16#70#           =>  --  3270
          (((0, 0), (3210, 3211)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (Expands_On_NFKD => True,
            others => False)),
         16#71#           =>  --  3271
          (((0, 0), (3214, 3215)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (Expands_On_NFKD => True,
            others => False)),
         16#72#           =>  --  3272
          (((0, 0), (3218, 3219)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (Expands_On_NFKD => True,
            others => False)),
         16#73#           =>  --  3273
          (((0, 0), (3222, 3223)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (Expands_On_NFKD => True,
            others => False)),
         16#74#           =>  --  3274
          (((0, 0), (3226, 3227)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (Expands_On_NFKD => True,
            others => False)),
         16#75#           =>  --  3275
          (((0, 0), (3230, 3231)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (Expands_On_NFKD => True,
            others => False)),
         16#76#           =>  --  3276
          (((0, 0), (3234, 3235)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (Expands_On_NFKD => True,
            others => False)),
         16#77#           =>  --  3277
          (((0, 0), (3238, 3239)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (Expands_On_NFKD => True,
            others => False)),
         16#78#           =>  --  3278
          (((0, 0), (3242, 3243)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (Expands_On_NFKD => True,
            others => False)),
         16#79#           =>  --  3279
          (((0, 0), (3246, 3247)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (Expands_On_NFKD => True,
            others => False)),
         16#7A#           =>  --  327A
          (((0, 0), (3250, 3251)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (Expands_On_NFKD => True,
            others => False)),
         16#7B#           =>  --  327B
          (((0, 0), (3084, 3085)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (Expands_On_NFKD => True,
            others => False)),
         16#7C#           =>  --  327C
          (((0, 0), (3410, 3414)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (Expands_On_NFKD => True,
            others => False)),
         16#7D#           =>  --  327D
          (((0, 0), (3415, 3418)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (Expands_On_NFKD => True,
            others => False)),
         16#7E#           =>  --  327E
          (((0, 0), (3419, 3420)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (Expands_On_NFKD => True,
            others => False)),
         16#80#           =>  --  3280
          (((0, 0), (2714, 2714)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#81#           =>  --  3281
          (((0, 0), (2720, 2720)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#82#           =>  --  3282
          (((0, 0), (3149, 3149)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#83#           =>  --  3283
          (((0, 0), (3150, 3150)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#84#           =>  --  3284
          (((0, 0), (3287, 3287)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#85#           =>  --  3285
          (((0, 0), (3290, 3290)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#86#           =>  --  3286
          (((0, 0), (3293, 3293)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#87#           =>  --  3287
          (((0, 0), (2725, 2725)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#88#           =>  --  3288
          (((0, 0), (3299, 3299)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#89#           =>  --  3289
          (((0, 0), (2737, 2737)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#8A#           =>  --  328A
          (((0, 0), (2787, 2787)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#8B#           =>  --  328B
          (((0, 0), (2799, 2799)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#8C#           =>  --  328C
          (((0, 0), (2798, 2798)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#8D#           =>  --  328D
          (((0, 0), (2788, 2788)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#8E#           =>  --  328E
          (((0, 0), (2880, 2880)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#8F#           =>  --  328F
          (((0, 0), (2745, 2745)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#90#           =>  --  3290
          (((0, 0), (2785, 2785)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#91#           =>  --  3291
          (((0, 0), (3326, 3326)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#92#           =>  --  3292
          (((0, 0), (3329, 3329)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#93#           =>  --  3293
          (((0, 0), (3332, 3332)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#94#           =>  --  3294
          (((0, 0), (3335, 3335)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#95#           =>  --  3295
          (((0, 0), (3338, 3338)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#96#           =>  --  3296
          (((0, 0), (3341, 3341)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#97#           =>  --  3297
          (((0, 0), (3344, 3344)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#98#           =>  --  3298
          (((0, 0), (3347, 3347)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#99#           =>  --  3299
          (((0, 0), (3421, 3421)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#9A#           =>  --  329A
          (((0, 0), (3422, 3422)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#9B#           =>  --  329B
          (((0, 0), (2751, 2751)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#9C#           =>  --  329C
          (((0, 0), (3423, 3423)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#9D#           =>  --  329D
          (((0, 0), (3424, 3424)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#9E#           =>  --  329E
          (((0, 0), (3425, 3425)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#9F#           =>  --  329F
          (((0, 0), (3426, 3426)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#A0#           =>  --  32A0
          (((0, 0), (3427, 3427)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#A1#           =>  --  32A1
          (((0, 0), (3374, 3374)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#A2#           =>  --  32A2
          (((0, 0), (3428, 3428)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#A3#           =>  --  32A3
          (((0, 0), (3429, 3429)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#A4#           =>  --  32A4
          (((0, 0), (3151, 3151)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#A5#           =>  --  32A5
          (((0, 0), (3152, 3152)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#A6#           =>  --  32A6
          (((0, 0), (3153, 3153)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#A7#           =>  --  32A7
          (((0, 0), (3430, 3430)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#A8#           =>  --  32A8
          (((0, 0), (3431, 3431)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#A9#           =>  --  32A9
          (((0, 0), (3432, 3432)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#AA#           =>  --  32AA
          (((0, 0), (3433, 3433)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#AB#           =>  --  32AB
          (((0, 0), (3356, 3356)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#AC#           =>  --  32AC
          (((0, 0), (3359, 3359)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#AD#           =>  --  32AD
          (((0, 0), (3362, 3362)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#AE#           =>  --  32AE
          (((0, 0), (3365, 3365)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#AF#           =>  --  32AF
          (((0, 0), (3368, 3368)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#B0#           =>  --  32B0
          (((0, 0), (3434, 3434)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#B1#           =>  --  32B1
          (((0, 0), (3435, 3436)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (Expands_On_NFKD => True,
            others => False)),
         16#B2#           =>  --  32B2
          (((0, 0), (3437, 3438)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (Expands_On_NFKD => True,
            others => False)),
         16#B3#           =>  --  32B3
          (((0, 0), (3439, 3440)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (Expands_On_NFKD => True,
            others => False)),
         16#B4#           =>  --  32B4
          (((0, 0), (3441, 3442)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (Expands_On_NFKD => True,
            others => False)),
         16#B5#           =>  --  32B5
          (((0, 0), (3443, 3444)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (Expands_On_NFKD => True,
            others => False)),
         16#B6#           =>  --  32B6
          (((0, 0), (18, 19)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (Expands_On_NFKD => True,
            others => False)),
         16#B7#           =>  --  32B7
          (((0, 0), (3391, 3392)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (Expands_On_NFKD => True,
            others => False)),
         16#B8#           =>  --  32B8
          (((0, 0), (3407, 3408)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (Expands_On_NFKD => True,
            others => False)),
         16#B9#           =>  --  32B9
          (((0, 0), (3445, 3446)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (Expands_On_NFKD => True,
            others => False)),
         16#BA#           =>  --  32BA
          (((0, 0), (3447, 3448)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (Expands_On_NFKD => True,
            others => False)),
         16#BB#           =>  --  32BB
          (((0, 0), (3449, 3450)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (Expands_On_NFKD => True,
            others => False)),
         16#BC#           =>  --  32BC
          (((0, 0), (3451, 3452)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (Expands_On_NFKD => True,
            others => False)),
         16#BD#           =>  --  32BD
          (((0, 0), (3453, 3454)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (Expands_On_NFKD => True,
            others => False)),
         16#BE#           =>  --  32BE
          (((0, 0), (3455, 3456)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (Expands_On_NFKD => True,
            others => False)),
         16#BF#           =>  --  32BF
          (((0, 0), (3457, 3458)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (Expands_On_NFKD => True,
            others => False)),
         16#C0#           =>  --  32C0
          (((0, 0), (3459, 3460)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#C1#           =>  --  32C1
          (((0, 0), (3461, 3462)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#C2#           =>  --  32C2
          (((0, 0), (3463, 3464)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#C3#           =>  --  32C3
          (((0, 0), (3465, 3466)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#C4#           =>  --  32C4
          (((0, 0), (3467, 3468)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#C5#           =>  --  32C5
          (((0, 0), (3469, 3470)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#C6#           =>  --  32C6
          (((0, 0), (3471, 3472)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#C7#           =>  --  32C7
          (((0, 0), (3473, 3474)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#C8#           =>  --  32C8
          (((0, 0), (3475, 3476)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#C9#           =>  --  32C9
          (((0, 0), (3477, 3479)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#CA#           =>  --  32CA
          (((0, 0), (3480, 3482)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#CB#           =>  --  32CB
          (((0, 0), (3483, 3485)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#CC#           =>  --  32CC
          (((0, 0), (3486, 3487)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#CD#           =>  --  32CD
          (((0, 0), (3488, 3490)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#CE#           =>  --  32CE
          (((0, 0), (3491, 3492)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#CF#           =>  --  32CF
          (((0, 0), (3493, 3495)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#D0#           =>  --  32D0
          (((0, 0), (3496, 3496)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#D1#           =>  --  32D1
          (((0, 0), (3497, 3497)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#D2#           =>  --  32D2
          (((0, 0), (3041, 3041)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#D3#           =>  --  32D3
          (((0, 0), (3498, 3498)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#D4#           =>  --  32D4
          (((0, 0), (3499, 3499)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#D5#           =>  --  32D5
          (((0, 0), (2991, 2991)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#D6#           =>  --  32D6
          (((0, 0), (2993, 2993)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#D7#           =>  --  32D7
          (((0, 0), (2995, 2995)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#D8#           =>  --  32D8
          (((0, 0), (2997, 2997)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#D9#           =>  --  32D9
          (((0, 0), (2999, 2999)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#DA#           =>  --  32DA
          (((0, 0), (3001, 3001)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#DB#           =>  --  32DB
          (((0, 0), (3003, 3003)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#DC#           =>  --  32DC
          (((0, 0), (3005, 3005)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#DD#           =>  --  32DD
          (((0, 0), (3007, 3007)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#DE#           =>  --  32DE
          (((0, 0), (3009, 3009)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#DF#           =>  --  32DF
          (((0, 0), (3011, 3011)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#E0#           =>  --  32E0
          (((0, 0), (3013, 3013)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#E1#           =>  --  32E1
          (((0, 0), (3015, 3015)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#E2#           =>  --  32E2
          (((0, 0), (3017, 3017)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#E3#           =>  --  32E3
          (((0, 0), (3019, 3019)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#E4#           =>  --  32E4
          (((0, 0), (3500, 3500)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#E5#           =>  --  32E5
          (((0, 0), (3501, 3501)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#E6#           =>  --  32E6
          (((0, 0), (3502, 3502)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#E7#           =>  --  32E7
          (((0, 0), (3503, 3503)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#E8#           =>  --  32E8
          (((0, 0), (3504, 3504)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#E9#           =>  --  32E9
          (((0, 0), (3021, 3021)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#EA#           =>  --  32EA
          (((0, 0), (3025, 3025)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#EB#           =>  --  32EB
          (((0, 0), (3029, 3029)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#EC#           =>  --  32EC
          (((0, 0), (3033, 3033)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#ED#           =>  --  32ED
          (((0, 0), (3037, 3037)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#EE#           =>  --  32EE
          (((0, 0), (3505, 3505)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#EF#           =>  --  32EF
          (((0, 0), (3506, 3506)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#F0#           =>  --  32F0
          (((0, 0), (3507, 3507)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#F1#           =>  --  32F1
          (((0, 0), (3508, 3508)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#F2#           =>  --  32F2
          (((0, 0), (3509, 3509)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#F3#           =>  --  32F3
          (((0, 0), (3510, 3510)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#F4#           =>  --  32F4
          (((0, 0), (3511, 3511)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#F5#           =>  --  32F5
          (((0, 0), (3512, 3512)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#F6#           =>  --  32F6
          (((0, 0), (3513, 3513)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#F7#           =>  --  32F7
          (((0, 0), (3514, 3514)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#F8#           =>  --  32F8
          (((0, 0), (3515, 3515)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#F9#           =>  --  32F9
          (((0, 0), (3516, 3516)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#FA#           =>  --  32FA
          (((0, 0), (3517, 3517)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#FB#           =>  --  32FB
          (((0, 0), (3043, 3043)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#FC#           =>  --  32FC
          (((0, 0), (3045, 3045)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#FD#           =>  --  32FD
          (((0, 0), (3047, 3047)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#FE#           =>  --  32FE
          (((0, 0), (3049, 3049)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         others           =>
          (((0, 0), (0, 0)), (0, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)));

   Group_0033 : aliased constant Normalization_Mapping_Second_Stage
     := (16#00#           =>  --  3300
          (((0, 0), (3518, 3522)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#01#           =>  --  3301
          (((0, 0), (3523, 3526)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#02#           =>  --  3302
          (((0, 0), (3527, 3531)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#03#           =>  --  3303
          (((0, 0), (3532, 3534)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#04#           =>  --  3304
          (((0, 0), (3535, 3539)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#05#           =>  --  3305
          (((0, 0), (3540, 3542)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#06#           =>  --  3306
          (((0, 0), (3543, 3545)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#07#           =>  --  3307
          (((0, 0), (3546, 3551)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#08#           =>  --  3308
          (((0, 0), (3552, 3555)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#09#           =>  --  3309
          (((0, 0), (3556, 3558)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#0A#           =>  --  330A
          (((0, 0), (3559, 3561)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#0B#           =>  --  330B
          (((0, 0), (3562, 3564)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#0C#           =>  --  330C
          (((0, 0), (3565, 3568)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#0D#           =>  --  330D
          (((0, 0), (3569, 3572)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#0E#           =>  --  330E
          (((0, 0), (3573, 3576)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#0F#           =>  --  330F
          (((0, 0), (3577, 3580)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#10#           =>  --  3310
          (((0, 0), (3581, 3584)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#11#           =>  --  3311
          (((0, 0), (3585, 3588)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#12#           =>  --  3312
          (((0, 0), (3589, 3592)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#13#           =>  --  3313
          (((0, 0), (3593, 3598)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#14#           =>  --  3314
          (((0, 0), (3599, 3600)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#15#           =>  --  3315
          (((0, 0), (3601, 3606)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#16#           =>  --  3316
          (((0, 0), (3607, 3612)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#17#           =>  --  3317
          (((0, 0), (3613, 3617)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#18#           =>  --  3318
          (((0, 0), (3603, 3606)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#19#           =>  --  3319
          (((0, 0), (3618, 3623)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#1A#           =>  --  331A
          (((0, 0), (3624, 3629)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#1B#           =>  --  331B
          (((0, 0), (3630, 3633)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#1C#           =>  --  331C
          (((0, 0), (3634, 3636)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#1D#           =>  --  331D
          (((0, 0), (3637, 3639)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#1E#           =>  --  331E
          (((0, 0), (3640, 3643)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#1F#           =>  --  331F
          (((0, 0), (3644, 3647)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#20#           =>  --  3320
          (((0, 0), (3648, 3652)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#21#           =>  --  3321
          (((0, 0), (3653, 3657)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#22#           =>  --  3322
          (((0, 0), (3658, 3660)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#23#           =>  --  3323
          (((0, 0), (3661, 3663)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#24#           =>  --  3324
          (((0, 0), (3664, 3667)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#25#           =>  --  3325
          (((0, 0), (3668, 3670)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#26#           =>  --  3326
          (((0, 0), (3671, 3673)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#27#           =>  --  3327
          (((0, 0), (3622, 3623)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#28#           =>  --  3328
          (((0, 0), (3674, 3675)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#29#           =>  --  3329
          (((0, 0), (3676, 3678)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#2A#           =>  --  332A
          (((0, 0), (3679, 3681)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#2B#           =>  --  332B
          (((0, 0), (3682, 3687)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#2C#           =>  --  332C
          (((0, 0), (3688, 3691)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#2D#           =>  --  332D
          (((0, 0), (3692, 3696)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#2E#           =>  --  332E
          (((0, 0), (3697, 3702)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#2F#           =>  --  332F
          (((0, 0), (3703, 3706)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#30#           =>  --  3330
          (((0, 0), (3707, 3709)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#31#           =>  --  3331
          (((0, 0), (3710, 3712)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#32#           =>  --  3332
          (((0, 0), (3713, 3718)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#33#           =>  --  3333
          (((0, 0), (3719, 3722)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#34#           =>  --  3334
          (((0, 0), (3723, 3728)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#35#           =>  --  3335
          (((0, 0), (3729, 3731)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#36#           =>  --  3336
          (((0, 0), (3732, 3736)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#37#           =>  --  3337
          (((0, 0), (3737, 3739)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#38#           =>  --  3338
          (((0, 0), (3740, 3743)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#39#           =>  --  3339
          (((0, 0), (3744, 3746)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#3A#           =>  --  333A
          (((0, 0), (3747, 3750)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#3B#           =>  --  333B
          (((0, 0), (3751, 3755)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#3C#           =>  --  333C
          (((0, 0), (3756, 3759)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#3D#           =>  --  333D
          (((0, 0), (3760, 3764)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#3E#           =>  --  333E
          (((0, 0), (3765, 3768)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#3F#           =>  --  333F
          (((0, 0), (3769, 3770)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#40#           =>  --  3340
          (((0, 0), (3771, 3775)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#41#           =>  --  3341
          (((0, 0), (3776, 3778)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#42#           =>  --  3342
          (((0, 0), (3779, 3781)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#43#           =>  --  3343
          (((0, 0), (3782, 3785)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#44#           =>  --  3344
          (((0, 0), (3786, 3788)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#45#           =>  --  3345
          (((0, 0), (3789, 3791)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#46#           =>  --  3346
          (((0, 0), (3792, 3794)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#47#           =>  --  3347
          (((0, 0), (3795, 3799)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#48#           =>  --  3348
          (((0, 0), (3800, 3803)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#49#           =>  --  3349
          (((0, 0), (3804, 3805)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#4A#           =>  --  334A
          (((0, 0), (3806, 3811)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#4B#           =>  --  334B
          (((0, 0), (3812, 3814)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#4C#           =>  --  334C
          (((0, 0), (3815, 3819)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#4D#           =>  --  334D
          (((0, 0), (3609, 3612)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#4E#           =>  --  334E
          (((0, 0), (3820, 3823)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#4F#           =>  --  334F
          (((0, 0), (3824, 3826)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#50#           =>  --  3350
          (((0, 0), (3827, 3829)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#51#           =>  --  3351
          (((0, 0), (3830, 3833)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#52#           =>  --  3352
          (((0, 0), (3834, 3835)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#53#           =>  --  3353
          (((0, 0), (3836, 3839)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#54#           =>  --  3354
          (((0, 0), (3840, 3844)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#55#           =>  --  3355
          (((0, 0), (3845, 3846)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#56#           =>  --  3356
          (((0, 0), (3847, 3852)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#57#           =>  --  3357
          (((0, 0), (3615, 3617)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#58#           =>  --  3358
          (((0, 0), (3853, 3854)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#59#           =>  --  3359
          (((0, 0), (3855, 3856)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#5A#           =>  --  335A
          (((0, 0), (3857, 3858)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#5B#           =>  --  335B
          (((0, 0), (3859, 3860)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#5C#           =>  --  335C
          (((0, 0), (3861, 3862)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#5D#           =>  --  335D
          (((0, 0), (3863, 3864)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#5E#           =>  --  335E
          (((0, 0), (3865, 3866)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#5F#           =>  --  335F
          (((0, 0), (3867, 3868)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#60#           =>  --  3360
          (((0, 0), (3869, 3870)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#61#           =>  --  3361
          (((0, 0), (3871, 3872)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#62#           =>  --  3362
          (((0, 0), (3873, 3875)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#63#           =>  --  3363
          (((0, 0), (3876, 3878)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#64#           =>  --  3364
          (((0, 0), (3879, 3881)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#65#           =>  --  3365
          (((0, 0), (3882, 3884)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#66#           =>  --  3366
          (((0, 0), (3885, 3887)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#67#           =>  --  3367
          (((0, 0), (3888, 3890)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#68#           =>  --  3368
          (((0, 0), (3891, 3893)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#69#           =>  --  3369
          (((0, 0), (3894, 3896)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#6A#           =>  --  336A
          (((0, 0), (3897, 3899)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#6B#           =>  --  336B
          (((0, 0), (3900, 3902)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#6C#           =>  --  336C
          (((0, 0), (3903, 3905)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#6D#           =>  --  336D
          (((0, 0), (3906, 3908)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#6E#           =>  --  336E
          (((0, 0), (3909, 3911)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#6F#           =>  --  336F
          (((0, 0), (3912, 3914)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#70#           =>  --  3370
          (((0, 0), (3915, 3917)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#71#           =>  --  3371
          (((0, 0), (3918, 3920)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#72#           =>  --  3372
          (((0, 0), (3921, 3922)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#73#           =>  --  3373
          (((0, 0), (3923, 3924)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#74#           =>  --  3374
          (((0, 0), (3925, 3927)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#75#           =>  --  3375
          (((0, 0), (3928, 3929)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#76#           =>  --  3376
          (((0, 0), (3930, 3931)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#77#           =>  --  3377
          (((0, 0), (3932, 3933)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#78#           =>  --  3378
          (((0, 0), (3934, 3936)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#79#           =>  --  3379
          (((0, 0), (3937, 3939)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#7A#           =>  --  337A
          (((0, 0), (3940, 3941)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#7B#           =>  --  337B
          (((0, 0), (3942, 3943)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#7C#           =>  --  337C
          (((0, 0), (3944, 3945)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#7D#           =>  --  337D
          (((0, 0), (3946, 3947)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#7E#           =>  --  337E
          (((0, 0), (3948, 3949)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#7F#           =>  --  337F
          (((0, 0), (3950, 3953)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#80#           =>  --  3380
          (((0, 0), (3954, 3955)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#81#           =>  --  3381
          (((0, 0), (3956, 3957)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#82#           =>  --  3382
          (((0, 0), (3958, 3959)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#83#           =>  --  3383
          (((0, 0), (3960, 3961)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#84#           =>  --  3384
          (((0, 0), (3962, 3963)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#85#           =>  --  3385
          (((0, 0), (3964, 3965)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#86#           =>  --  3386
          (((0, 0), (3966, 3967)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#87#           =>  --  3387
          (((0, 0), (3968, 3969)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#88#           =>  --  3388
          (((0, 0), (3970, 3972)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#89#           =>  --  3389
          (((0, 0), (3973, 3976)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#8A#           =>  --  338A
          (((0, 0), (3977, 3978)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#8B#           =>  --  338B
          (((0, 0), (3979, 3980)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#8C#           =>  --  338C
          (((0, 0), (3981, 3982)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#8D#           =>  --  338D
          (((0, 0), (3983, 3984)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#8E#           =>  --  338E
          (((0, 0), (3985, 3986)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#8F#           =>  --  338F
          (((0, 0), (3987, 3988)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#90#           =>  --  3390
          (((0, 0), (3989, 3990)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#91#           =>  --  3391
          (((0, 0), (3991, 3993)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#92#           =>  --  3392
          (((0, 0), (3994, 3996)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#93#           =>  --  3393
          (((0, 0), (3997, 3999)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#94#           =>  --  3394
          (((0, 0), (4000, 4002)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#95#           =>  --  3395
          (((0, 0), (4003, 4004)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#96#           =>  --  3396
          (((0, 0), (4005, 4006)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#97#           =>  --  3397
          (((0, 0), (4007, 4008)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#98#           =>  --  3398
          (((0, 0), (4009, 4010)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#99#           =>  --  3399
          (((0, 0), (4011, 4012)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#9A#           =>  --  339A
          (((0, 0), (4013, 4014)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#9B#           =>  --  339B
          (((0, 0), (4015, 4016)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#9C#           =>  --  339C
          (((0, 0), (4017, 4018)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#9D#           =>  --  339D
          (((0, 0), (4019, 4020)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#9E#           =>  --  339E
          (((0, 0), (4021, 4022)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#9F#           =>  --  339F
          (((0, 0), (4023, 4025)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#A0#           =>  --  33A0
          (((0, 0), (4026, 4028)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#A1#           =>  --  33A1
          (((0, 0), (3935, 3936)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#A2#           =>  --  33A2
          (((0, 0), (4029, 4031)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#A3#           =>  --  33A3
          (((0, 0), (4032, 4034)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#A4#           =>  --  33A4
          (((0, 0), (4035, 4037)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#A5#           =>  --  33A5
          (((0, 0), (3938, 3939)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#A6#           =>  --  33A6
          (((0, 0), (4038, 4040)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#A7#           =>  --  33A7
          (((0, 0), (4041, 4043)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#A8#           =>  --  33A8
          (((0, 0), (4044, 4047)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#A9#           =>  --  33A9
          (((0, 0), (3919, 3920)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#AA#           =>  --  33AA
          (((0, 0), (4048, 4050)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#AB#           =>  --  33AB
          (((0, 0), (4051, 4053)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#AC#           =>  --  33AC
          (((0, 0), (4054, 4056)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#AD#           =>  --  33AD
          (((0, 0), (4057, 4059)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#AE#           =>  --  33AE
          (((0, 0), (4060, 4064)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#AF#           =>  --  33AF
          (((0, 0), (4065, 4070)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#B0#           =>  --  33B0
          (((0, 0), (4071, 4072)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#B1#           =>  --  33B1
          (((0, 0), (4073, 4074)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#B2#           =>  --  33B2
          (((0, 0), (4075, 4076)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#B3#           =>  --  33B3
          (((0, 0), (4077, 4078)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#B4#           =>  --  33B4
          (((0, 0), (4079, 4080)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#B5#           =>  --  33B5
          (((0, 0), (4081, 4082)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#B6#           =>  --  33B6
          (((0, 0), (4083, 4084)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#B7#           =>  --  33B7
          (((0, 0), (4085, 4086)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#B8#           =>  --  33B8
          (((0, 0), (4087, 4088)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#B9#           =>  --  33B9
          (((0, 0), (4089, 4090)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#BA#           =>  --  33BA
          (((0, 0), (4091, 4092)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#BB#           =>  --  33BB
          (((0, 0), (4093, 4094)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#BC#           =>  --  33BC
          (((0, 0), (4095, 4096)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#BD#           =>  --  33BD
          (((0, 0), (4097, 4098)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#BE#           =>  --  33BE
          (((0, 0), (4099, 4100)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#BF#           =>  --  33BF
          (((0, 0), (4101, 4102)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#C0#           =>  --  33C0
          (((0, 0), (4103, 4104)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#C1#           =>  --  33C1
          (((0, 0), (4105, 4106)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#C2#           =>  --  33C2
          (((0, 0), (4107, 4110)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#C3#           =>  --  33C3
          (((0, 0), (4111, 4112)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#C4#           =>  --  33C4
          (((0, 0), (4113, 4114)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#C5#           =>  --  33C5
          (((0, 0), (3931, 3932)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#C6#           =>  --  33C6
          (((0, 0), (4115, 4118)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#C7#           =>  --  33C7
          (((0, 0), (4119, 4121)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#C8#           =>  --  33C8
          (((0, 0), (4122, 4123)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#C9#           =>  --  33C9
          (((0, 0), (4124, 4125)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#CA#           =>  --  33CA
          (((0, 0), (4126, 4127)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#CB#           =>  --  33CB
          (((0, 0), (4128, 4129)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#CC#           =>  --  33CC
          (((0, 0), (4130, 4131)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#CD#           =>  --  33CD
          (((0, 0), (4132, 4133)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#CE#           =>  --  33CE
          (((0, 0), (4134, 4135)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#CF#           =>  --  33CF
          (((0, 0), (4136, 4137)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#D0#           =>  --  33D0
          (((0, 0), (4004, 4005)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#D1#           =>  --  33D1
          (((0, 0), (4138, 4139)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#D2#           =>  --  33D2
          (((0, 0), (4140, 4142)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#D3#           =>  --  33D3
          (((0, 0), (4143, 4144)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#D4#           =>  --  33D4
          (((0, 0), (4145, 4146)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#D5#           =>  --  33D5
          (((0, 0), (4147, 4149)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#D6#           =>  --  33D6
          (((0, 0), (4150, 4152)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#D7#           =>  --  33D7
          (((0, 0), (4153, 4154)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#D8#           =>  --  33D8
          (((0, 0), (4155, 4158)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#D9#           =>  --  33D9
          (((0, 0), (4159, 4161)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#DA#           =>  --  33DA
          (((0, 0), (4162, 4163)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#DB#           =>  --  33DB
          (((0, 0), (4064, 4065)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#DC#           =>  --  33DC
          (((0, 0), (4164, 4165)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#DD#           =>  --  33DD
          (((0, 0), (4166, 4167)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#DE#           =>  --  33DE
          (((0, 0), (4168, 4170)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#DF#           =>  --  33DF
          (((0, 0), (4171, 4173)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#E0#           =>  --  33E0
          (((0, 0), (4174, 4175)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#E1#           =>  --  33E1
          (((0, 0), (4176, 4177)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#E2#           =>  --  33E2
          (((0, 0), (4178, 4179)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#E3#           =>  --  33E3
          (((0, 0), (4180, 4181)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#E4#           =>  --  33E4
          (((0, 0), (4182, 4183)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#E5#           =>  --  33E5
          (((0, 0), (4184, 4185)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#E6#           =>  --  33E6
          (((0, 0), (4186, 4187)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#E7#           =>  --  33E7
          (((0, 0), (4188, 4189)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#E8#           =>  --  33E8
          (((0, 0), (4190, 4191)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#E9#           =>  --  33E9
          (((0, 0), (4192, 4194)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#EA#           =>  --  33EA
          (((0, 0), (4195, 4197)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#EB#           =>  --  33EB
          (((0, 0), (4198, 4200)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#EC#           =>  --  33EC
          (((0, 0), (4201, 4203)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#ED#           =>  --  33ED
          (((0, 0), (4204, 4206)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#EE#           =>  --  33EE
          (((0, 0), (4207, 4209)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#EF#           =>  --  33EF
          (((0, 0), (4210, 4212)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#F0#           =>  --  33F0
          (((0, 0), (4213, 4215)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#F1#           =>  --  33F1
          (((0, 0), (4216, 4218)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#F2#           =>  --  33F2
          (((0, 0), (4219, 4221)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#F3#           =>  --  33F3
          (((0, 0), (4222, 4224)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#F4#           =>  --  33F4
          (((0, 0), (4225, 4227)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#F5#           =>  --  33F5
          (((0, 0), (4228, 4230)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#F6#           =>  --  33F6
          (((0, 0), (4231, 4233)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#F7#           =>  --  33F7
          (((0, 0), (4234, 4236)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#F8#           =>  --  33F8
          (((0, 0), (4237, 4239)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#F9#           =>  --  33F9
          (((0, 0), (4240, 4242)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#FA#           =>  --  33FA
          (((0, 0), (4243, 4245)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#FB#           =>  --  33FB
          (((0, 0), (4246, 4248)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#FC#           =>  --  33FC
          (((0, 0), (4249, 4251)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#FD#           =>  --  33FD
          (((0, 0), (4252, 4254)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#FE#           =>  --  33FE
          (((0, 0), (4255, 4257)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#FF#           =>  --  33FF
          (((0, 0), (4258, 4260)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         others           =>
          (((0, 0), (0, 0)), (0, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)));

   Group_00A6 : aliased constant Normalization_Mapping_Second_Stage
     := (16#6F#           =>  --  A66F
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#74# .. 16#7D# =>  --  A674 .. A67D
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#9C#           =>  --  A69C
          (((0, 0), (4261, 4261)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#9D#           =>  --  A69D
          (((0, 0), (4262, 4262)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#9F#           =>  --  A69F
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#F0# .. 16#F1# =>  --  A6F0 .. A6F1
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         others           =>
          (((0, 0), (0, 0)), (0, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)));

   Group_00A7 : aliased constant Normalization_Mapping_Second_Stage
     := (16#70#           =>  --  A770
          (((0, 0), (4263, 4263)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#F8#           =>  --  A7F8
          (((0, 0), (4264, 4264)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#F9#           =>  --  A7F9
          (((0, 0), (4265, 4265)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         others           =>
          (((0, 0), (0, 0)), (0, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)));

   Group_00A8 : aliased constant Normalization_Mapping_Second_Stage
     := (16#06#           =>  --  A806
          (((0, 0), (0, 0)), (0, 0), 9, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#C4#           =>  --  A8C4
          (((0, 0), (0, 0)), (0, 0), 9, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#E0# .. 16#F1# =>  --  A8E0 .. A8F1
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         others           =>
          (((0, 0), (0, 0)), (0, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)));

   Group_00A9 : aliased constant Normalization_Mapping_Second_Stage
     := (16#2B# .. 16#2D# =>  --  A92B .. A92D
          (((0, 0), (0, 0)), (0, 0), 220, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#53#           =>  --  A953
          (((0, 0), (0, 0)), (0, 0), 9, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#B3#           =>  --  A9B3
          (((0, 0), (0, 0)), (0, 0), 7, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#C0#           =>  --  A9C0
          (((0, 0), (0, 0)), (0, 0), 9, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         others           =>
          (((0, 0), (0, 0)), (0, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)));

   Group_00AA : aliased constant Normalization_Mapping_Second_Stage
     := (16#B0#           =>  --  AAB0
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#B2# .. 16#B3# =>  --  AAB2 .. AAB3
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#B4#           =>  --  AAB4
          (((0, 0), (0, 0)), (0, 0), 220, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#B7# .. 16#B8# =>  --  AAB7 .. AAB8
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#BE# .. 16#BF# =>  --  AABE .. AABF
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#C1#           =>  --  AAC1
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#F6#           =>  --  AAF6
          (((0, 0), (0, 0)), (0, 0), 9, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         others           =>
          (((0, 0), (0, 0)), (0, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)));

   Group_00AB : aliased constant Normalization_Mapping_Second_Stage
     := (16#5C#           =>  --  AB5C
          (((0, 0), (4266, 4266)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#5D#           =>  --  AB5D
          (((0, 0), (4267, 4267)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#5E#           =>  --  AB5E
          (((0, 0), (4268, 4268)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#5F#           =>  --  AB5F
          (((0, 0), (4269, 4269)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (others => False)),
         16#ED#           =>  --  ABED
          (((0, 0), (0, 0)), (0, 0), 9, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         others           =>
          (((0, 0), (0, 0)), (0, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)));

   Group_00AC : aliased constant Normalization_Mapping_Second_Stage
     := (others           =>
          (((0, 0), (0, 0)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)));

   Group_00D7 : aliased constant Normalization_Mapping_Second_Stage
     := (16#A4# .. 16#FF# =>  --  D7A4 .. D7FF
          (((0, 0), (0, 0)), (0, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         others           =>
          (((0, 0), (0, 0)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)));

   Group_00F9 : aliased constant Normalization_Mapping_Second_Stage
     := (16#00#           =>  --  F900
          (((4270, 4270), (4270, 4270)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#01#           =>  --  F901
          (((4271, 4271), (4271, 4271)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#02#           =>  --  F902
          (((2872, 2872), (2872, 2872)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#03#           =>  --  F903
          (((4272, 4272), (4272, 4272)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#04#           =>  --  F904
          (((4273, 4273), (4273, 4273)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#05#           =>  --  F905
          (((4274, 4274), (4274, 4274)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#06#           =>  --  F906
          (((4275, 4275), (4275, 4275)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#07# .. 16#08# =>  --  F907 .. F908
          (((2926, 2926), (2926, 2926)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#09#           =>  --  F909
          (((4276, 4276), (4276, 4276)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#0A#           =>  --  F90A
          (((2880, 2880), (2880, 2880)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#0B#           =>  --  F90B
          (((4277, 4277), (4277, 4277)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#0C#           =>  --  F90C
          (((4278, 4278), (4278, 4278)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#0D#           =>  --  F90D
          (((4279, 4279), (4279, 4279)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#0E#           =>  --  F90E
          (((4280, 4280), (4280, 4280)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#0F#           =>  --  F90F
          (((4281, 4281), (4281, 4281)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#10#           =>  --  F910
          (((4282, 4282), (4282, 4282)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#11#           =>  --  F911
          (((4283, 4283), (4283, 4283)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#12#           =>  --  F912
          (((4284, 4284), (4284, 4284)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#13#           =>  --  F913
          (((4285, 4285), (4285, 4285)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#15#           =>  --  F915
          (((4287, 4287), (4287, 4287)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#16#           =>  --  F916
          (((4288, 4288), (4288, 4288)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#17#           =>  --  F917
          (((4289, 4289), (4289, 4289)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#18#           =>  --  F918
          (((4290, 4290), (4290, 4290)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#19#           =>  --  F919
          (((4291, 4291), (4291, 4291)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#1A#           =>  --  F91A
          (((4292, 4292), (4292, 4292)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#1B#           =>  --  F91B
          (((4293, 4293), (4293, 4293)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#1C#           =>  --  F91C
          (((4294, 4294), (4294, 4294)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#1D#           =>  --  F91D
          (((4295, 4295), (4295, 4295)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#1E#           =>  --  F91E
          (((4296, 4296), (4296, 4296)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#1F#           =>  --  F91F
          (((4297, 4297), (4297, 4297)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#20#           =>  --  F920
          (((4298, 4298), (4298, 4298)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#21#           =>  --  F921
          (((4299, 4299), (4299, 4299)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#22#           =>  --  F922
          (((4300, 4300), (4300, 4300)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#23#           =>  --  F923
          (((4301, 4301), (4301, 4301)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#24#           =>  --  F924
          (((4302, 4302), (4302, 4302)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#25#           =>  --  F925
          (((4303, 4303), (4303, 4303)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#26#           =>  --  F926
          (((4304, 4304), (4304, 4304)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#27#           =>  --  F927
          (((4305, 4305), (4305, 4305)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#28#           =>  --  F928
          (((4306, 4306), (4306, 4306)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#29#           =>  --  F929
          (((4307, 4307), (4307, 4307)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#2A#           =>  --  F92A
          (((4308, 4308), (4308, 4308)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#2B#           =>  --  F92B
          (((4309, 4309), (4309, 4309)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#2C#           =>  --  F92C
          (((4310, 4310), (4310, 4310)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#2D#           =>  --  F92D
          (((4311, 4311), (4311, 4311)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#2E#           =>  --  F92E
          (((4312, 4312), (4312, 4312)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#2F#           =>  --  F92F
          (((4313, 4313), (4313, 4313)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#30#           =>  --  F930
          (((4314, 4314), (4314, 4314)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#31#           =>  --  F931
          (((4315, 4315), (4315, 4315)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#32#           =>  --  F932
          (((4316, 4316), (4316, 4316)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#33#           =>  --  F933
          (((4317, 4317), (4317, 4317)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#34#           =>  --  F934
          (((2838, 2838), (2838, 2838)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#35#           =>  --  F935
          (((4318, 4318), (4318, 4318)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#36#           =>  --  F936
          (((4319, 4319), (4319, 4319)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#37#           =>  --  F937
          (((4320, 4320), (4320, 4320)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#38#           =>  --  F938
          (((4321, 4321), (4321, 4321)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#39#           =>  --  F939
          (((4322, 4322), (4322, 4322)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#3A#           =>  --  F93A
          (((4323, 4323), (4323, 4323)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#3B#           =>  --  F93B
          (((4324, 4324), (4324, 4324)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#3C#           =>  --  F93C
          (((4325, 4325), (4325, 4325)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#3D#           =>  --  F93D
          (((4326, 4326), (4326, 4326)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#3E#           =>  --  F93E
          (((4327, 4327), (4327, 4327)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#3F#           =>  --  F93F
          (((4328, 4328), (4328, 4328)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#40#           =>  --  F940
          (((2911, 2911), (2911, 2911)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#41#           =>  --  F941
          (((4329, 4329), (4329, 4329)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#42#           =>  --  F942
          (((4330, 4330), (4330, 4330)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#43#           =>  --  F943
          (((4331, 4331), (4331, 4331)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#44#           =>  --  F944
          (((4332, 4332), (4332, 4332)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#45#           =>  --  F945
          (((4333, 4333), (4333, 4333)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#46#           =>  --  F946
          (((4334, 4334), (4334, 4334)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#47#           =>  --  F947
          (((4335, 4335), (4335, 4335)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#48#           =>  --  F948
          (((4336, 4336), (4336, 4336)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#49#           =>  --  F949
          (((4337, 4337), (4337, 4337)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#4A#           =>  --  F94A
          (((4338, 4338), (4338, 4338)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#4B#           =>  --  F94B
          (((4339, 4339), (4339, 4339)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#4C#           =>  --  F94C
          (((4340, 4340), (4340, 4340)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#4D#           =>  --  F94D
          (((4341, 4341), (4341, 4341)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#4E#           =>  --  F94E
          (((4342, 4342), (4342, 4342)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#4F#           =>  --  F94F
          (((4343, 4343), (4343, 4343)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#50#           =>  --  F950
          (((4344, 4344), (4344, 4344)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#51#           =>  --  F951
          (((4345, 4345), (4345, 4345)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#52#           =>  --  F952
          (((4346, 4346), (4346, 4346)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#53#           =>  --  F953
          (((4347, 4347), (4347, 4347)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#54#           =>  --  F954
          (((4348, 4348), (4348, 4348)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#55#           =>  --  F955
          (((4349, 4349), (4349, 4349)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#56#           =>  --  F956
          (((4350, 4350), (4350, 4350)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#57#           =>  --  F957
          (((4351, 4351), (4351, 4351)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#58#           =>  --  F958
          (((4352, 4352), (4352, 4352)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#59#           =>  --  F959
          (((4353, 4353), (4353, 4353)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#5A#           =>  --  F95A
          (((4354, 4354), (4354, 4354)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#5B#           =>  --  F95B
          (((4355, 4355), (4355, 4355)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#5D#           =>  --  F95D
          (((4356, 4356), (4356, 4356)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#5E#           =>  --  F95E
          (((4357, 4357), (4357, 4357)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#5F#           =>  --  F95F
          (((4358, 4358), (4358, 4358)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#60#           =>  --  F960
          (((4359, 4359), (4359, 4359)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#61#           =>  --  F961
          (((4360, 4360), (4360, 4360)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#62#           =>  --  F962
          (((4361, 4361), (4361, 4361)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#63#           =>  --  F963
          (((4362, 4362), (4362, 4362)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#64#           =>  --  F964
          (((4363, 4363), (4363, 4363)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#65#           =>  --  F965
          (((4364, 4364), (4364, 4364)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#66#           =>  --  F966
          (((4365, 4365), (4365, 4365)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#67#           =>  --  F967
          (((4366, 4366), (4366, 4366)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#68#           =>  --  F968
          (((4367, 4367), (4367, 4367)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#69#           =>  --  F969
          (((4368, 4368), (4368, 4368)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#6A#           =>  --  F96A
          (((4369, 4369), (4369, 4369)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#6B#           =>  --  F96B
          (((4370, 4370), (4370, 4370)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#6C#           =>  --  F96C
          (((4371, 4371), (4371, 4371)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#6D#           =>  --  F96D
          (((4372, 4372), (4372, 4372)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#6E#           =>  --  F96E
          (((4373, 4373), (4373, 4373)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#6F#           =>  --  F96F
          (((4374, 4374), (4374, 4374)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#70#           =>  --  F970
          (((4375, 4375), (4375, 4375)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#71#           =>  --  F971
          (((2874, 2874), (2874, 2874)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#72#           =>  --  F972
          (((4376, 4376), (4376, 4376)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#73#           =>  --  F973
          (((4377, 4377), (4377, 4377)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#74#           =>  --  F974
          (((4378, 4378), (4378, 4378)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#75#           =>  --  F975
          (((4379, 4379), (4379, 4379)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#76#           =>  --  F976
          (((4380, 4380), (4380, 4380)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#77#           =>  --  F977
          (((4381, 4381), (4381, 4381)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#78#           =>  --  F978
          (((4382, 4382), (4382, 4382)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#79#           =>  --  F979
          (((4383, 4383), (4383, 4383)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#7A#           =>  --  F97A
          (((4384, 4384), (4384, 4384)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#7B#           =>  --  F97B
          (((4385, 4385), (4385, 4385)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#7C#           =>  --  F97C
          (((4386, 4386), (4386, 4386)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#7D#           =>  --  F97D
          (((4387, 4387), (4387, 4387)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#7E#           =>  --  F97E
          (((4388, 4388), (4388, 4388)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#7F#           =>  --  F97F
          (((4389, 4389), (4389, 4389)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#80#           =>  --  F980
          (((4390, 4390), (4390, 4390)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#81#           =>  --  F981
          (((2751, 2751), (2751, 2751)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#82#           =>  --  F982
          (((4391, 4391), (4391, 4391)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#83#           =>  --  F983
          (((4392, 4392), (4392, 4392)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#84#           =>  --  F984
          (((4393, 4393), (4393, 4393)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#85#           =>  --  F985
          (((4394, 4394), (4394, 4394)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#86#           =>  --  F986
          (((4395, 4395), (4395, 4395)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#87#           =>  --  F987
          (((4396, 4396), (4396, 4396)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#88#           =>  --  F988
          (((4397, 4397), (4397, 4397)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#89#           =>  --  F989
          (((4398, 4398), (4398, 4398)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#8A#           =>  --  F98A
          (((2732, 2732), (2732, 2732)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#8B#           =>  --  F98B
          (((4399, 4399), (4399, 4399)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#8C#           =>  --  F98C
          (((4400, 4400), (4400, 4400)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#8D#           =>  --  F98D
          (((4401, 4401), (4401, 4401)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#8E#           =>  --  F98E
          (((4402, 4402), (4402, 4402)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#8F#           =>  --  F98F
          (((4403, 4403), (4403, 4403)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#90#           =>  --  F990
          (((4404, 4404), (4404, 4404)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#91#           =>  --  F991
          (((4405, 4405), (4405, 4405)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#92#           =>  --  F992
          (((4406, 4406), (4406, 4406)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#93#           =>  --  F993
          (((4407, 4407), (4407, 4407)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#94#           =>  --  F994
          (((4408, 4408), (4408, 4408)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#95#           =>  --  F995
          (((4409, 4409), (4409, 4409)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#96#           =>  --  F996
          (((4410, 4410), (4410, 4410)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#97#           =>  --  F997
          (((4411, 4411), (4411, 4411)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#98#           =>  --  F998
          (((4412, 4412), (4412, 4412)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#99#           =>  --  F999
          (((4413, 4413), (4413, 4413)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#9A#           =>  --  F99A
          (((4414, 4414), (4414, 4414)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#9B#           =>  --  F99B
          (((4415, 4415), (4415, 4415)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#9C#           =>  --  F99C
          (((4416, 4416), (4416, 4416)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#9D#           =>  --  F99D
          (((4417, 4417), (4417, 4417)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#9E#           =>  --  F99E
          (((4418, 4418), (4418, 4418)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#9F#           =>  --  F99F
          (((4419, 4419), (4419, 4419)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#A0#           =>  --  F9A0
          (((4420, 4420), (4420, 4420)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#A1#           =>  --  F9A1
          (((4374, 4374), (4374, 4374)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#A2#           =>  --  F9A2
          (((4421, 4421), (4421, 4421)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#A3#           =>  --  F9A3
          (((4422, 4422), (4422, 4422)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#A4#           =>  --  F9A4
          (((4423, 4423), (4423, 4423)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#A5#           =>  --  F9A5
          (((4424, 4424), (4424, 4424)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#A6#           =>  --  F9A6
          (((4425, 4425), (4425, 4425)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#A7#           =>  --  F9A7
          (((4426, 4426), (4426, 4426)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#A8#           =>  --  F9A8
          (((4427, 4427), (4427, 4427)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#A9#           =>  --  F9A9
          (((4428, 4428), (4428, 4428)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#AA#           =>  --  F9AA
          (((4358, 4358), (4358, 4358)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#AB#           =>  --  F9AB
          (((4429, 4429), (4429, 4429)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#AC#           =>  --  F9AC
          (((4430, 4430), (4430, 4430)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#AD#           =>  --  F9AD
          (((4431, 4431), (4431, 4431)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#AE#           =>  --  F9AE
          (((4432, 4432), (4432, 4432)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#AF#           =>  --  F9AF
          (((4433, 4433), (4433, 4433)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#B0#           =>  --  F9B0
          (((4434, 4434), (4434, 4434)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#B1#           =>  --  F9B1
          (((4435, 4435), (4435, 4435)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#B2#           =>  --  F9B2
          (((4436, 4436), (4436, 4436)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#B3#           =>  --  F9B3
          (((4437, 4437), (4437, 4437)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#B4#           =>  --  F9B4
          (((4438, 4438), (4438, 4438)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#B5#           =>  --  F9B5
          (((4439, 4439), (4439, 4439)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#B6#           =>  --  F9B6
          (((4440, 4440), (4440, 4440)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#B7#           =>  --  F9B7
          (((4441, 4441), (4441, 4441)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#B8#           =>  --  F9B8
          (((4442, 4442), (4442, 4442)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#B9#           =>  --  F9B9
          (((4443, 4443), (4443, 4443)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#BA#           =>  --  F9BA
          (((4444, 4444), (4444, 4444)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#BB#           =>  --  F9BB
          (((4445, 4445), (4445, 4445)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#BC#           =>  --  F9BC
          (((4446, 4446), (4446, 4446)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#BD#           =>  --  F9BD
          (((4447, 4447), (4447, 4447)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#BE#           =>  --  F9BE
          (((4448, 4448), (4448, 4448)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#C0#           =>  --  F9C0
          (((4449, 4449), (4449, 4449)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#C1#           =>  --  F9C1
          (((4450, 4450), (4450, 4450)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#C2#           =>  --  F9C2
          (((4451, 4451), (4451, 4451)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#C3#           =>  --  F9C3
          (((4452, 4452), (4452, 4452)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#C4#           =>  --  F9C4
          (((2925, 2925), (2925, 2925)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#C5#           =>  --  F9C5
          (((4453, 4453), (4453, 4453)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#C6#           =>  --  F9C6
          (((4454, 4454), (4454, 4454)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#C7#           =>  --  F9C7
          (((4455, 4455), (4455, 4455)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#C8#           =>  --  F9C8
          (((4456, 4456), (4456, 4456)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#C9#           =>  --  F9C9
          (((4457, 4457), (4457, 4457)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#CA#           =>  --  F9CA
          (((4458, 4458), (4458, 4458)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#CB#           =>  --  F9CB
          (((4459, 4459), (4459, 4459)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#CC#           =>  --  F9CC
          (((4460, 4460), (4460, 4460)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#CD#           =>  --  F9CD
          (((4461, 4461), (4461, 4461)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#CE#           =>  --  F9CE
          (((4462, 4462), (4462, 4462)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#CF#           =>  --  F9CF
          (((4463, 4463), (4463, 4463)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#D0#           =>  --  F9D0
          (((4464, 4464), (4464, 4464)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#D1#           =>  --  F9D1
          (((3290, 3290), (3290, 3290)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#D2#           =>  --  F9D2
          (((4465, 4465), (4465, 4465)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#D3#           =>  --  F9D3
          (((4466, 4466), (4466, 4466)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#D4#           =>  --  F9D4
          (((4467, 4467), (4467, 4467)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#D5#           =>  --  F9D5
          (((4468, 4468), (4468, 4468)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#D6#           =>  --  F9D6
          (((4469, 4469), (4469, 4469)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#D7#           =>  --  F9D7
          (((4470, 4470), (4470, 4470)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#D8#           =>  --  F9D8
          (((4471, 4471), (4471, 4471)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#D9#           =>  --  F9D9
          (((4472, 4472), (4472, 4472)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#DA#           =>  --  F9DA
          (((4473, 4473), (4473, 4473)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#DB#           =>  --  F9DB
          (((4360, 4360), (4360, 4360)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#DC#           =>  --  F9DC
          (((4474, 4474), (4474, 4474)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#DD#           =>  --  F9DD
          (((4475, 4475), (4475, 4475)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#DE#           =>  --  F9DE
          (((4476, 4476), (4476, 4476)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#DF#           =>  --  F9DF
          (((4477, 4477), (4477, 4477)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#E0#           =>  --  F9E0
          (((4478, 4478), (4478, 4478)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#E1#           =>  --  F9E1
          (((4479, 4479), (4479, 4479)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#E2#           =>  --  F9E2
          (((4480, 4480), (4480, 4480)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#E3#           =>  --  F9E3
          (((4481, 4481), (4481, 4481)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#E4#           =>  --  F9E4
          (((4482, 4482), (4482, 4482)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#E5#           =>  --  F9E5
          (((4483, 4483), (4483, 4483)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#E6#           =>  --  F9E6
          (((4484, 4484), (4484, 4484)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#E7#           =>  --  F9E7
          (((4485, 4485), (4485, 4485)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#E8#           =>  --  F9E8
          (((4486, 4486), (4486, 4486)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#E9#           =>  --  F9E9
          (((2879, 2879), (2879, 2879)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#EA#           =>  --  F9EA
          (((4487, 4487), (4487, 4487)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#EB#           =>  --  F9EB
          (((4488, 4488), (4488, 4488)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#EC#           =>  --  F9EC
          (((4489, 4489), (4489, 4489)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#ED#           =>  --  F9ED
          (((4490, 4490), (4490, 4490)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#EE#           =>  --  F9EE
          (((4491, 4491), (4491, 4491)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#EF#           =>  --  F9EF
          (((4492, 4492), (4492, 4492)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#F0#           =>  --  F9F0
          (((4493, 4493), (4493, 4493)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#F1#           =>  --  F9F1
          (((4494, 4494), (4494, 4494)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#F2#           =>  --  F9F2
          (((4495, 4495), (4495, 4495)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#F3#           =>  --  F9F3
          (((4496, 4496), (4496, 4496)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#F4#           =>  --  F9F4
          (((4497, 4497), (4497, 4497)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#F5#           =>  --  F9F5
          (((4498, 4498), (4498, 4498)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#F6#           =>  --  F9F6
          (((4499, 4499), (4499, 4499)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#F7#           =>  --  F9F7
          (((2830, 2830), (2830, 2830)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#F8#           =>  --  F9F8
          (((4500, 4500), (4500, 4500)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#F9#           =>  --  F9F9
          (((4501, 4501), (4501, 4501)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#FA#           =>  --  F9FA
          (((4502, 4502), (4502, 4502)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#FB#           =>  --  F9FB
          (((4503, 4503), (4503, 4503)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#FC#           =>  --  F9FC
          (((4504, 4504), (4504, 4504)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#FD#           =>  --  F9FD
          (((4505, 4505), (4505, 4505)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#FE#           =>  --  F9FE
          (((4506, 4506), (4506, 4506)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#FF#           =>  --  F9FF
          (((4507, 4507), (4507, 4507)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         others           =>
          (((4286, 4286), (4286, 4286)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)));

   Group_00FA : aliased constant Normalization_Mapping_Second_Stage
     := (16#00#           =>  --  FA00
          (((4508, 4508), (4508, 4508)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#01#           =>  --  FA01
          (((4509, 4509), (4509, 4509)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#02#           =>  --  FA02
          (((4510, 4510), (4510, 4510)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#03#           =>  --  FA03
          (((4511, 4511), (4511, 4511)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#04#           =>  --  FA04
          (((4512, 4512), (4512, 4512)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#05#           =>  --  FA05
          (((4513, 4513), (4513, 4513)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#06#           =>  --  FA06
          (((4514, 4514), (4514, 4514)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#07#           =>  --  FA07
          (((4515, 4515), (4515, 4515)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#08#           =>  --  FA08
          (((2857, 2857), (2857, 2857)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#09#           =>  --  FA09
          (((4516, 4516), (4516, 4516)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#0A#           =>  --  FA0A
          (((2860, 2860), (2860, 2860)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#0B#           =>  --  FA0B
          (((4517, 4517), (4517, 4517)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#0C#           =>  --  FA0C
          (((4518, 4518), (4518, 4518)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#0D#           =>  --  FA0D
          (((4519, 4519), (4519, 4519)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#10#           =>  --  FA10
          (((4520, 4520), (4520, 4520)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#12#           =>  --  FA12
          (((4521, 4521), (4521, 4521)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#15#           =>  --  FA15
          (((4522, 4522), (4522, 4522)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#16#           =>  --  FA16
          (((4523, 4523), (4523, 4523)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#17#           =>  --  FA17
          (((4524, 4524), (4524, 4524)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#18#           =>  --  FA18
          (((4525, 4525), (4525, 4525)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#19#           =>  --  FA19
          (((4526, 4526), (4526, 4526)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#1A#           =>  --  FA1A
          (((4527, 4527), (4527, 4527)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#1B#           =>  --  FA1B
          (((4528, 4528), (4528, 4528)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#1C#           =>  --  FA1C
          (((4529, 4529), (4529, 4529)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#1D#           =>  --  FA1D
          (((4530, 4530), (4530, 4530)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#1E#           =>  --  FA1E
          (((2837, 2837), (2837, 2837)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#20#           =>  --  FA20
          (((4531, 4531), (4531, 4531)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#22#           =>  --  FA22
          (((4532, 4532), (4532, 4532)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#25#           =>  --  FA25
          (((4533, 4533), (4533, 4533)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#26#           =>  --  FA26
          (((4534, 4534), (4534, 4534)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#2A#           =>  --  FA2A
          (((4535, 4535), (4535, 4535)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#2B#           =>  --  FA2B
          (((4536, 4536), (4536, 4536)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#2C#           =>  --  FA2C
          (((4537, 4537), (4537, 4537)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#2D#           =>  --  FA2D
          (((4538, 4538), (4538, 4538)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#2E#           =>  --  FA2E
          (((4539, 4539), (4539, 4539)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#2F#           =>  --  FA2F
          (((4540, 4540), (4540, 4540)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#30#           =>  --  FA30
          (((4541, 4541), (4541, 4541)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#31#           =>  --  FA31
          (((4542, 4542), (4542, 4542)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#32#           =>  --  FA32
          (((4543, 4543), (4543, 4543)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#33#           =>  --  FA33
          (((4544, 4544), (4544, 4544)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#34#           =>  --  FA34
          (((4545, 4545), (4545, 4545)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#35#           =>  --  FA35
          (((4546, 4546), (4546, 4546)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#36#           =>  --  FA36
          (((4547, 4547), (4547, 4547)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#37#           =>  --  FA37
          (((4548, 4548), (4548, 4548)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#38#           =>  --  FA38
          (((4549, 4549), (4549, 4549)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#39#           =>  --  FA39
          (((4550, 4550), (4550, 4550)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#3A#           =>  --  FA3A
          (((4551, 4551), (4551, 4551)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#3B#           =>  --  FA3B
          (((4552, 4552), (4552, 4552)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#3C#           =>  --  FA3C
          (((2758, 2758), (2758, 2758)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#3D#           =>  --  FA3D
          (((4553, 4553), (4553, 4553)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#3E#           =>  --  FA3E
          (((4554, 4554), (4554, 4554)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#3F#           =>  --  FA3F
          (((4555, 4555), (4555, 4555)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#40#           =>  --  FA40
          (((4556, 4556), (4556, 4556)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#41#           =>  --  FA41
          (((4557, 4557), (4557, 4557)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#42#           =>  --  FA42
          (((4558, 4558), (4558, 4558)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#43#           =>  --  FA43
          (((4559, 4559), (4559, 4559)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#44#           =>  --  FA44
          (((4560, 4560), (4560, 4560)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#45#           =>  --  FA45
          (((4561, 4561), (4561, 4561)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#46#           =>  --  FA46
          (((4562, 4562), (4562, 4562)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#47#           =>  --  FA47
          (((4563, 4563), (4563, 4563)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#48#           =>  --  FA48
          (((4564, 4564), (4564, 4564)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#49#           =>  --  FA49
          (((4565, 4565), (4565, 4565)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#4A#           =>  --  FA4A
          (((4566, 4566), (4566, 4566)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#4B#           =>  --  FA4B
          (((4567, 4567), (4567, 4567)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#4C#           =>  --  FA4C
          (((3332, 3332), (3332, 3332)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#4D#           =>  --  FA4D
          (((4568, 4568), (4568, 4568)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#4E#           =>  --  FA4E
          (((4569, 4569), (4569, 4569)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#4F#           =>  --  FA4F
          (((4570, 4570), (4570, 4570)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#50#           =>  --  FA50
          (((4571, 4571), (4571, 4571)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#51#           =>  --  FA51
          (((3344, 3344), (3344, 3344)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#52#           =>  --  FA52
          (((4572, 4572), (4572, 4572)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#53#           =>  --  FA53
          (((4573, 4573), (4573, 4573)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#54#           =>  --  FA54
          (((4574, 4574), (4574, 4574)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#55#           =>  --  FA55
          (((4575, 4575), (4575, 4575)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#56#           =>  --  FA56
          (((4576, 4576), (4576, 4576)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#57#           =>  --  FA57
          (((4410, 4410), (4410, 4410)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#58#           =>  --  FA58
          (((4577, 4577), (4577, 4577)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#59#           =>  --  FA59
          (((4578, 4578), (4578, 4578)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#5A#           =>  --  FA5A
          (((4579, 4579), (4579, 4579)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#5B#           =>  --  FA5B
          (((4580, 4580), (4580, 4580)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#5C#           =>  --  FA5C
          (((4581, 4581), (4581, 4581)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#5D# .. 16#5E# =>  --  FA5D .. FA5E
          (((4582, 4582), (4582, 4582)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#5F#           =>  --  FA5F
          (((4583, 4583), (4583, 4583)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#60#           =>  --  FA60
          (((4584, 4584), (4584, 4584)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#61#           =>  --  FA61
          (((4585, 4585), (4585, 4585)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#62#           =>  --  FA62
          (((4586, 4586), (4586, 4586)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#63#           =>  --  FA63
          (((4587, 4587), (4587, 4587)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#64#           =>  --  FA64
          (((4588, 4588), (4588, 4588)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#65#           =>  --  FA65
          (((4589, 4589), (4589, 4589)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#66#           =>  --  FA66
          (((4590, 4590), (4590, 4590)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#67#           =>  --  FA67
          (((4533, 4533), (4533, 4533)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#68#           =>  --  FA68
          (((4591, 4591), (4591, 4591)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#69#           =>  --  FA69
          (((4592, 4592), (4592, 4592)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#6A#           =>  --  FA6A
          (((4593, 4593), (4593, 4593)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#6B#           =>  --  FA6B
          (((4594, 4594), (4594, 4594)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#6C#           =>  --  FA6C
          (((4595, 4595), (4595, 4595)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#6D#           =>  --  FA6D
          (((4596, 4596), (4596, 4596)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#70#           =>  --  FA70
          (((4597, 4597), (4597, 4597)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#71#           =>  --  FA71
          (((4598, 4598), (4598, 4598)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#72#           =>  --  FA72
          (((4599, 4599), (4599, 4599)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#73#           =>  --  FA73
          (((4600, 4600), (4600, 4600)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#74#           =>  --  FA74
          (((4601, 4601), (4601, 4601)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#75#           =>  --  FA75
          (((4602, 4602), (4602, 4602)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#76#           =>  --  FA76
          (((4603, 4603), (4603, 4603)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#77#           =>  --  FA77
          (((4604, 4604), (4604, 4604)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#78#           =>  --  FA78
          (((4547, 4547), (4547, 4547)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#79#           =>  --  FA79
          (((4605, 4605), (4605, 4605)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#7A#           =>  --  FA7A
          (((4606, 4606), (4606, 4606)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#7B#           =>  --  FA7B
          (((4607, 4607), (4607, 4607)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#7C#           =>  --  FA7C
          (((4520, 4520), (4520, 4520)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#7D#           =>  --  FA7D
          (((4608, 4608), (4608, 4608)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#7E#           =>  --  FA7E
          (((4609, 4609), (4609, 4609)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#7F#           =>  --  FA7F
          (((4610, 4610), (4610, 4610)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#80#           =>  --  FA80
          (((4611, 4611), (4611, 4611)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#81#           =>  --  FA81
          (((4612, 4612), (4612, 4612)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#82#           =>  --  FA82
          (((4613, 4613), (4613, 4613)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#83#           =>  --  FA83
          (((4614, 4614), (4614, 4614)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#84#           =>  --  FA84
          (((4615, 4615), (4615, 4615)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#85#           =>  --  FA85
          (((4616, 4616), (4616, 4616)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#86#           =>  --  FA86
          (((4617, 4617), (4617, 4617)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#87#           =>  --  FA87
          (((4618, 4618), (4618, 4618)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#88#           =>  --  FA88
          (((4619, 4619), (4619, 4619)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#89#           =>  --  FA89
          (((4555, 4555), (4555, 4555)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#8A#           =>  --  FA8A
          (((4620, 4620), (4620, 4620)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#8B#           =>  --  FA8B
          (((4556, 4556), (4556, 4556)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#8C#           =>  --  FA8C
          (((4621, 4621), (4621, 4621)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#8D#           =>  --  FA8D
          (((4622, 4622), (4622, 4622)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#8E#           =>  --  FA8E
          (((4623, 4623), (4623, 4623)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#8F#           =>  --  FA8F
          (((4624, 4624), (4624, 4624)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#90#           =>  --  FA90
          (((4625, 4625), (4625, 4625)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#91#           =>  --  FA91
          (((4521, 4521), (4521, 4521)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#92#           =>  --  FA92
          (((4307, 4307), (4307, 4307)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#93#           =>  --  FA93
          (((4626, 4626), (4626, 4626)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#94#           =>  --  FA94
          (((4627, 4627), (4627, 4627)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#95#           =>  --  FA95
          (((2791, 2791), (2791, 2791)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#96#           =>  --  FA96
          (((4375, 4375), (4375, 4375)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#97#           =>  --  FA97
          (((4458, 4458), (4458, 4458)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#98#           =>  --  FA98
          (((4628, 4628), (4628, 4628)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#99#           =>  --  FA99
          (((4629, 4629), (4629, 4629)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#9A#           =>  --  FA9A
          (((4563, 4563), (4563, 4563)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#9B#           =>  --  FA9B
          (((4630, 4630), (4630, 4630)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#9C#           =>  --  FA9C
          (((4564, 4564), (4564, 4564)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#9D#           =>  --  FA9D
          (((4631, 4631), (4631, 4631)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#9E#           =>  --  FA9E
          (((4632, 4632), (4632, 4632)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#9F#           =>  --  FA9F
          (((4633, 4633), (4633, 4633)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#A0#           =>  --  FAA0
          (((4523, 4523), (4523, 4523)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#A1#           =>  --  FAA1
          (((4634, 4634), (4634, 4634)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#A2#           =>  --  FAA2
          (((4635, 4635), (4635, 4635)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#A3#           =>  --  FAA3
          (((4636, 4636), (4636, 4636)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#A4#           =>  --  FAA4
          (((4637, 4637), (4637, 4637)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#A5#           =>  --  FAA5
          (((4638, 4638), (4638, 4638)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#A6#           =>  --  FAA6
          (((4524, 4524), (4524, 4524)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#A7#           =>  --  FAA7
          (((4639, 4639), (4639, 4639)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#A8#           =>  --  FAA8
          (((4640, 4640), (4640, 4640)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#A9#           =>  --  FAA9
          (((4641, 4641), (4641, 4641)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#AA#           =>  --  FAAA
          (((4642, 4642), (4642, 4642)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#AB#           =>  --  FAAB
          (((4643, 4643), (4643, 4643)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#AC#           =>  --  FAAC
          (((4644, 4644), (4644, 4644)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#AD#           =>  --  FAAD
          (((4576, 4576), (4576, 4576)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#AE#           =>  --  FAAE
          (((4645, 4645), (4645, 4645)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#AF#           =>  --  FAAF
          (((4646, 4646), (4646, 4646)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#B0#           =>  --  FAB0
          (((4410, 4410), (4410, 4410)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#B1#           =>  --  FAB1
          (((4647, 4647), (4647, 4647)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#B2#           =>  --  FAB2
          (((4580, 4580), (4580, 4580)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#B3#           =>  --  FAB3
          (((4648, 4648), (4648, 4648)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#B4#           =>  --  FAB4
          (((4649, 4649), (4649, 4649)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#B5#           =>  --  FAB5
          (((4650, 4650), (4650, 4650)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#B6#           =>  --  FAB6
          (((4651, 4651), (4651, 4651)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#B7#           =>  --  FAB7
          (((4652, 4652), (4652, 4652)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#B8#           =>  --  FAB8
          (((4585, 4585), (4585, 4585)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#B9#           =>  --  FAB9
          (((4653, 4653), (4653, 4653)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#BA#           =>  --  FABA
          (((4532, 4532), (4532, 4532)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#BB#           =>  --  FABB
          (((4654, 4654), (4654, 4654)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#BC#           =>  --  FABC
          (((4586, 4586), (4586, 4586)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#BD#           =>  --  FABD
          (((4356, 4356), (4356, 4356)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#BE#           =>  --  FABE
          (((4655, 4655), (4655, 4655)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#BF#           =>  --  FABF
          (((4587, 4587), (4587, 4587)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#C0#           =>  --  FAC0
          (((4656, 4656), (4656, 4656)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#C1#           =>  --  FAC1
          (((4589, 4589), (4589, 4589)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#C2#           =>  --  FAC2
          (((4657, 4657), (4657, 4657)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#C3#           =>  --  FAC3
          (((4658, 4658), (4658, 4658)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#C4#           =>  --  FAC4
          (((4659, 4659), (4659, 4659)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#C5#           =>  --  FAC5
          (((4660, 4660), (4660, 4660)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#C6#           =>  --  FAC6
          (((4661, 4661), (4661, 4661)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#C7#           =>  --  FAC7
          (((4591, 4591), (4591, 4591)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#C8#           =>  --  FAC8
          (((4529, 4529), (4529, 4529)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#C9#           =>  --  FAC9
          (((4662, 4662), (4662, 4662)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#CA#           =>  --  FACA
          (((4592, 4592), (4592, 4592)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#CB#           =>  --  FACB
          (((4663, 4663), (4663, 4663)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#CC#           =>  --  FACC
          (((4593, 4593), (4593, 4593)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#CD#           =>  --  FACD
          (((4664, 4664), (4664, 4664)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#CE#           =>  --  FACE
          (((2926, 2926), (2926, 2926)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#CF#           =>  --  FACF
          (((4665, 4665), (4665, 4665)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#D0#           =>  --  FAD0
          (((4666, 4666), (4666, 4666)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#D1#           =>  --  FAD1
          (((4667, 4667), (4667, 4667)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#D2#           =>  --  FAD2
          (((4668, 4668), (4668, 4668)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#D3#           =>  --  FAD3
          (((4669, 4669), (4669, 4669)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#D4#           =>  --  FAD4
          (((4670, 4670), (4670, 4670)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#D5#           =>  --  FAD5
          (((4671, 4671), (4671, 4671)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#D6#           =>  --  FAD6
          (((4672, 4672), (4672, 4672)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#D7#           =>  --  FAD7
          (((4673, 4673), (4673, 4673)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#D8#           =>  --  FAD8
          (((4674, 4674), (4674, 4674)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#D9#           =>  --  FAD9
          (((4675, 4675), (4675, 4675)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         others           =>
          (((0, 0), (0, 0)), (0, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)));

   Group_00FB : aliased constant Normalization_Mapping_Second_Stage
     := (16#00#           =>  --  FB00
          (((0, 0), (4676, 4677)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#01#           =>  --  FB01
          (((0, 0), (4678, 4679)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#02#           =>  --  FB02
          (((0, 0), (4680, 4681)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#03#           =>  --  FB03
          (((0, 0), (4677, 4679)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#04#           =>  --  FB04
          (((0, 0), (4682, 4684)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#05# .. 16#06# =>  --  FB05 .. FB06
          (((0, 0), (4685, 4686)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#13#           =>  --  FB13
          (((0, 0), (4687, 4688)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#14#           =>  --  FB14
          (((0, 0), (4689, 4690)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#15#           =>  --  FB15
          (((0, 0), (4691, 4692)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#16#           =>  --  FB16
          (((0, 0), (4693, 4694)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#17#           =>  --  FB17
          (((0, 0), (4695, 4696)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#1D#           =>  --  FB1D
          (((4697, 4698), (4697, 4698)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFKC => False,
            others => True)),
         16#1E#           =>  --  FB1E
          (((0, 0), (0, 0)), (0, 0), 26, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#1F#           =>  --  FB1F
          (((4699, 4700), (4699, 4700)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFKC => False,
            others => True)),
         16#20#           =>  --  FB20
          (((0, 0), (4701, 4701)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#21#           =>  --  FB21
          (((0, 0), (2279, 2279)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#22#           =>  --  FB22
          (((0, 0), (2282, 2282)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#23#           =>  --  FB23
          (((0, 0), (4702, 4702)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#24#           =>  --  FB24
          (((0, 0), (4703, 4703)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#25#           =>  --  FB25
          (((0, 0), (4704, 4704)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#26#           =>  --  FB26
          (((0, 0), (4705, 4705)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#27#           =>  --  FB27
          (((0, 0), (4706, 4706)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#28#           =>  --  FB28
          (((0, 0), (4707, 4707)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#29#           =>  --  FB29
          (((0, 0), (2244, 2244)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#2A#           =>  --  FB2A
          (((4708, 4709), (4708, 4709)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFKC => False,
            others => True)),
         16#2B#           =>  --  FB2B
          (((4710, 4711), (4710, 4711)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFKC => False,
            others => True)),
         16#2C#           =>  --  FB2C
          (((4712, 4714), (4712, 4714)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFKC => False,
            others => True)),
         16#2D#           =>  --  FB2D
          (((4715, 4717), (4715, 4717)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFKC => False,
            others => True)),
         16#2E#           =>  --  FB2E
          (((4718, 4719), (4718, 4719)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFKC => False,
            others => True)),
         16#2F#           =>  --  FB2F
          (((4720, 4721), (4720, 4721)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFKC => False,
            others => True)),
         16#30#           =>  --  FB30
          (((4722, 4723), (4722, 4723)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFKC => False,
            others => True)),
         16#31#           =>  --  FB31
          (((4724, 4725), (4724, 4725)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFKC => False,
            others => True)),
         16#32#           =>  --  FB32
          (((4726, 4727), (4726, 4727)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFKC => False,
            others => True)),
         16#33#           =>  --  FB33
          (((4728, 4729), (4728, 4729)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFKC => False,
            others => True)),
         16#34#           =>  --  FB34
          (((4730, 4731), (4730, 4731)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFKC => False,
            others => True)),
         16#35#           =>  --  FB35
          (((4732, 4733), (4732, 4733)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFKC => False,
            others => True)),
         16#36#           =>  --  FB36
          (((4734, 4735), (4734, 4735)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFKC => False,
            others => True)),
         16#38#           =>  --  FB38
          (((4736, 4737), (4736, 4737)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFKC => False,
            others => True)),
         16#39#           =>  --  FB39
          (((4738, 4739), (4738, 4739)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFKC => False,
            others => True)),
         16#3A#           =>  --  FB3A
          (((4740, 4741), (4740, 4741)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFKC => False,
            others => True)),
         16#3B#           =>  --  FB3B
          (((4742, 4743), (4742, 4743)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFKC => False,
            others => True)),
         16#3C#           =>  --  FB3C
          (((4744, 4745), (4744, 4745)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFKC => False,
            others => True)),
         16#3E#           =>  --  FB3E
          (((4746, 4747), (4746, 4747)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFKC => False,
            others => True)),
         16#40#           =>  --  FB40
          (((4748, 4749), (4748, 4749)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFKC => False,
            others => True)),
         16#41#           =>  --  FB41
          (((4750, 4751), (4750, 4751)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFKC => False,
            others => True)),
         16#43#           =>  --  FB43
          (((4752, 4753), (4752, 4753)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFKC => False,
            others => True)),
         16#44#           =>  --  FB44
          (((4754, 4755), (4754, 4755)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFKC => False,
            others => True)),
         16#46#           =>  --  FB46
          (((4756, 4757), (4756, 4757)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFKC => False,
            others => True)),
         16#47#           =>  --  FB47
          (((4758, 4759), (4758, 4759)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFKC => False,
            others => True)),
         16#48#           =>  --  FB48
          (((4760, 4761), (4760, 4761)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFKC => False,
            others => True)),
         16#49#           =>  --  FB49
          (((4712, 4713), (4712, 4713)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFKC => False,
            others => True)),
         16#4A#           =>  --  FB4A
          (((4762, 4763), (4762, 4763)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFKC => False,
            others => True)),
         16#4B#           =>  --  FB4B
          (((4764, 4765), (4764, 4765)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFKC => False,
            others => True)),
         16#4C#           =>  --  FB4C
          (((4766, 4767), (4766, 4767)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFKC => False,
            others => True)),
         16#4D#           =>  --  FB4D
          (((4768, 4769), (4768, 4769)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFKC => False,
            others => True)),
         16#4E#           =>  --  FB4E
          (((4770, 4771), (4770, 4771)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFKC => False,
            others => True)),
         16#4F#           =>  --  FB4F
          (((0, 0), (4772, 4773)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#50#           =>  --  FB50
          (((0, 0), (4774, 4774)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (others => False)),
         16#51#           =>  --  FB51
          (((0, 0), (4774, 4774)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (others => False)),
         16#52#           =>  --  FB52
          (((0, 0), (4775, 4775)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (others => False)),
         16#53#           =>  --  FB53
          (((0, 0), (4775, 4775)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (others => False)),
         16#54#           =>  --  FB54
          (((0, 0), (4775, 4775)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (others => False)),
         16#55#           =>  --  FB55
          (((0, 0), (4775, 4775)), (0, 0), 0, (Yes, Yes, No, No), Medial,
           (others => False)),
         16#56#           =>  --  FB56
          (((0, 0), (4776, 4776)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (others => False)),
         16#57#           =>  --  FB57
          (((0, 0), (4776, 4776)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (others => False)),
         16#58#           =>  --  FB58
          (((0, 0), (4776, 4776)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (others => False)),
         16#59#           =>  --  FB59
          (((0, 0), (4776, 4776)), (0, 0), 0, (Yes, Yes, No, No), Medial,
           (others => False)),
         16#5A#           =>  --  FB5A
          (((0, 0), (4777, 4777)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (others => False)),
         16#5B#           =>  --  FB5B
          (((0, 0), (4777, 4777)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (others => False)),
         16#5C#           =>  --  FB5C
          (((0, 0), (4777, 4777)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (others => False)),
         16#5D#           =>  --  FB5D
          (((0, 0), (4777, 4777)), (0, 0), 0, (Yes, Yes, No, No), Medial,
           (others => False)),
         16#5E#           =>  --  FB5E
          (((0, 0), (4778, 4778)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (others => False)),
         16#5F#           =>  --  FB5F
          (((0, 0), (4778, 4778)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (others => False)),
         16#60#           =>  --  FB60
          (((0, 0), (4778, 4778)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (others => False)),
         16#61#           =>  --  FB61
          (((0, 0), (4778, 4778)), (0, 0), 0, (Yes, Yes, No, No), Medial,
           (others => False)),
         16#62#           =>  --  FB62
          (((0, 0), (4779, 4779)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (others => False)),
         16#63#           =>  --  FB63
          (((0, 0), (4779, 4779)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (others => False)),
         16#64#           =>  --  FB64
          (((0, 0), (4779, 4779)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (others => False)),
         16#65#           =>  --  FB65
          (((0, 0), (4779, 4779)), (0, 0), 0, (Yes, Yes, No, No), Medial,
           (others => False)),
         16#66#           =>  --  FB66
          (((0, 0), (4780, 4780)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (others => False)),
         16#67#           =>  --  FB67
          (((0, 0), (4780, 4780)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (others => False)),
         16#68#           =>  --  FB68
          (((0, 0), (4780, 4780)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (others => False)),
         16#69#           =>  --  FB69
          (((0, 0), (4780, 4780)), (0, 0), 0, (Yes, Yes, No, No), Medial,
           (others => False)),
         16#6A#           =>  --  FB6A
          (((0, 0), (4781, 4781)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (others => False)),
         16#6B#           =>  --  FB6B
          (((0, 0), (4781, 4781)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (others => False)),
         16#6C#           =>  --  FB6C
          (((0, 0), (4781, 4781)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (others => False)),
         16#6D#           =>  --  FB6D
          (((0, 0), (4781, 4781)), (0, 0), 0, (Yes, Yes, No, No), Medial,
           (others => False)),
         16#6E#           =>  --  FB6E
          (((0, 0), (4782, 4782)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (others => False)),
         16#6F#           =>  --  FB6F
          (((0, 0), (4782, 4782)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (others => False)),
         16#70#           =>  --  FB70
          (((0, 0), (4782, 4782)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (others => False)),
         16#71#           =>  --  FB71
          (((0, 0), (4782, 4782)), (0, 0), 0, (Yes, Yes, No, No), Medial,
           (others => False)),
         16#72#           =>  --  FB72
          (((0, 0), (4783, 4783)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (others => False)),
         16#73#           =>  --  FB73
          (((0, 0), (4783, 4783)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (others => False)),
         16#74#           =>  --  FB74
          (((0, 0), (4783, 4783)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (others => False)),
         16#75#           =>  --  FB75
          (((0, 0), (4783, 4783)), (0, 0), 0, (Yes, Yes, No, No), Medial,
           (others => False)),
         16#76#           =>  --  FB76
          (((0, 0), (4784, 4784)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (others => False)),
         16#77#           =>  --  FB77
          (((0, 0), (4784, 4784)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (others => False)),
         16#78#           =>  --  FB78
          (((0, 0), (4784, 4784)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (others => False)),
         16#79#           =>  --  FB79
          (((0, 0), (4784, 4784)), (0, 0), 0, (Yes, Yes, No, No), Medial,
           (others => False)),
         16#7A#           =>  --  FB7A
          (((0, 0), (4785, 4785)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (others => False)),
         16#7B#           =>  --  FB7B
          (((0, 0), (4785, 4785)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (others => False)),
         16#7C#           =>  --  FB7C
          (((0, 0), (4785, 4785)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (others => False)),
         16#7D#           =>  --  FB7D
          (((0, 0), (4785, 4785)), (0, 0), 0, (Yes, Yes, No, No), Medial,
           (others => False)),
         16#7E#           =>  --  FB7E
          (((0, 0), (4786, 4786)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (others => False)),
         16#7F#           =>  --  FB7F
          (((0, 0), (4786, 4786)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (others => False)),
         16#80#           =>  --  FB80
          (((0, 0), (4786, 4786)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (others => False)),
         16#81#           =>  --  FB81
          (((0, 0), (4786, 4786)), (0, 0), 0, (Yes, Yes, No, No), Medial,
           (others => False)),
         16#82#           =>  --  FB82
          (((0, 0), (4787, 4787)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (others => False)),
         16#83#           =>  --  FB83
          (((0, 0), (4787, 4787)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (others => False)),
         16#84#           =>  --  FB84
          (((0, 0), (4788, 4788)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (others => False)),
         16#85#           =>  --  FB85
          (((0, 0), (4788, 4788)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (others => False)),
         16#86#           =>  --  FB86
          (((0, 0), (4789, 4789)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (others => False)),
         16#87#           =>  --  FB87
          (((0, 0), (4789, 4789)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (others => False)),
         16#88#           =>  --  FB88
          (((0, 0), (4790, 4790)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (others => False)),
         16#89#           =>  --  FB89
          (((0, 0), (4790, 4790)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (others => False)),
         16#8A#           =>  --  FB8A
          (((0, 0), (4791, 4791)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (others => False)),
         16#8B#           =>  --  FB8B
          (((0, 0), (4791, 4791)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (others => False)),
         16#8C#           =>  --  FB8C
          (((0, 0), (4792, 4792)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (others => False)),
         16#8D#           =>  --  FB8D
          (((0, 0), (4792, 4792)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (others => False)),
         16#8E#           =>  --  FB8E
          (((0, 0), (4793, 4793)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (others => False)),
         16#8F#           =>  --  FB8F
          (((0, 0), (4793, 4793)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (others => False)),
         16#90#           =>  --  FB90
          (((0, 0), (4793, 4793)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (others => False)),
         16#91#           =>  --  FB91
          (((0, 0), (4793, 4793)), (0, 0), 0, (Yes, Yes, No, No), Medial,
           (others => False)),
         16#92#           =>  --  FB92
          (((0, 0), (4794, 4794)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (others => False)),
         16#93#           =>  --  FB93
          (((0, 0), (4794, 4794)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (others => False)),
         16#94#           =>  --  FB94
          (((0, 0), (4794, 4794)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (others => False)),
         16#95#           =>  --  FB95
          (((0, 0), (4794, 4794)), (0, 0), 0, (Yes, Yes, No, No), Medial,
           (others => False)),
         16#96#           =>  --  FB96
          (((0, 0), (4795, 4795)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (others => False)),
         16#97#           =>  --  FB97
          (((0, 0), (4795, 4795)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (others => False)),
         16#98#           =>  --  FB98
          (((0, 0), (4795, 4795)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (others => False)),
         16#99#           =>  --  FB99
          (((0, 0), (4795, 4795)), (0, 0), 0, (Yes, Yes, No, No), Medial,
           (others => False)),
         16#9A#           =>  --  FB9A
          (((0, 0), (4796, 4796)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (others => False)),
         16#9B#           =>  --  FB9B
          (((0, 0), (4796, 4796)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (others => False)),
         16#9C#           =>  --  FB9C
          (((0, 0), (4796, 4796)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (others => False)),
         16#9D#           =>  --  FB9D
          (((0, 0), (4796, 4796)), (0, 0), 0, (Yes, Yes, No, No), Medial,
           (others => False)),
         16#9E#           =>  --  FB9E
          (((0, 0), (4797, 4797)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (others => False)),
         16#9F#           =>  --  FB9F
          (((0, 0), (4797, 4797)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (others => False)),
         16#A0#           =>  --  FBA0
          (((0, 0), (4798, 4798)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (others => False)),
         16#A1#           =>  --  FBA1
          (((0, 0), (4798, 4798)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (others => False)),
         16#A2#           =>  --  FBA2
          (((0, 0), (4798, 4798)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (others => False)),
         16#A3#           =>  --  FBA3
          (((0, 0), (4798, 4798)), (0, 0), 0, (Yes, Yes, No, No), Medial,
           (others => False)),
         16#A4#           =>  --  FBA4
          (((0, 0), (782, 783)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#A5#           =>  --  FBA5
          (((0, 0), (782, 783)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#A6#           =>  --  FBA6
          (((0, 0), (784, 784)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (others => False)),
         16#A7#           =>  --  FBA7
          (((0, 0), (784, 784)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (others => False)),
         16#A8#           =>  --  FBA8
          (((0, 0), (784, 784)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (others => False)),
         16#A9#           =>  --  FBA9
          (((0, 0), (784, 784)), (0, 0), 0, (Yes, Yes, No, No), Medial,
           (others => False)),
         16#AA#           =>  --  FBAA
          (((0, 0), (4799, 4799)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (others => False)),
         16#AB#           =>  --  FBAB
          (((0, 0), (4799, 4799)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (others => False)),
         16#AC#           =>  --  FBAC
          (((0, 0), (4799, 4799)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (others => False)),
         16#AD#           =>  --  FBAD
          (((0, 0), (4799, 4799)), (0, 0), 0, (Yes, Yes, No, No), Medial,
           (others => False)),
         16#AE#           =>  --  FBAE
          (((0, 0), (786, 786)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (others => False)),
         16#AF#           =>  --  FBAF
          (((0, 0), (786, 786)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (others => False)),
         16#B0#           =>  --  FBB0
          (((0, 0), (786, 787)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#B1#           =>  --  FBB1
          (((0, 0), (786, 787)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#D3#           =>  --  FBD3
          (((0, 0), (4800, 4800)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (others => False)),
         16#D4#           =>  --  FBD4
          (((0, 0), (4800, 4800)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (others => False)),
         16#D5#           =>  --  FBD5
          (((0, 0), (4800, 4800)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (others => False)),
         16#D6#           =>  --  FBD6
          (((0, 0), (4800, 4800)), (0, 0), 0, (Yes, Yes, No, No), Medial,
           (others => False)),
         16#D7#           =>  --  FBD7
          (((0, 0), (778, 778)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (others => False)),
         16#D8#           =>  --  FBD8
          (((0, 0), (778, 778)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (others => False)),
         16#D9#           =>  --  FBD9
          (((0, 0), (4801, 4801)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (others => False)),
         16#DA#           =>  --  FBDA
          (((0, 0), (4801, 4801)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (others => False)),
         16#DB#           =>  --  FBDB
          (((0, 0), (4802, 4802)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (others => False)),
         16#DC#           =>  --  FBDC
          (((0, 0), (4802, 4802)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (others => False)),
         16#DD#           =>  --  FBDD
          (((0, 0), (778, 779)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#DE#           =>  --  FBDE
          (((0, 0), (4803, 4803)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (others => False)),
         16#DF#           =>  --  FBDF
          (((0, 0), (4803, 4803)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (others => False)),
         16#E0#           =>  --  FBE0
          (((0, 0), (4804, 4804)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (others => False)),
         16#E1#           =>  --  FBE1
          (((0, 0), (4804, 4804)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (others => False)),
         16#E2#           =>  --  FBE2
          (((0, 0), (4805, 4805)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (others => False)),
         16#E3#           =>  --  FBE3
          (((0, 0), (4805, 4805)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (others => False)),
         16#E4#           =>  --  FBE4
          (((0, 0), (4806, 4806)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (others => False)),
         16#E5#           =>  --  FBE5
          (((0, 0), (4806, 4806)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (others => False)),
         16#E6#           =>  --  FBE6
          (((0, 0), (4806, 4806)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (others => False)),
         16#E7#           =>  --  FBE7
          (((0, 0), (4806, 4806)), (0, 0), 0, (Yes, Yes, No, No), Medial,
           (others => False)),
         16#E8#           =>  --  FBE8
          (((0, 0), (4807, 4807)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (others => False)),
         16#E9#           =>  --  FBE9
          (((0, 0), (4807, 4807)), (0, 0), 0, (Yes, Yes, No, No), Medial,
           (others => False)),
         16#EA#           =>  --  FBEA
          (((0, 0), (772, 774)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#EB#           =>  --  FBEB
          (((0, 0), (772, 774)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#EC#           =>  --  FBEC
          (((0, 0), (4808, 4810)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#ED#           =>  --  FBED
          (((0, 0), (4808, 4810)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#EE#           =>  --  FBEE
          (((0, 0), (4811, 4813)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#EF#           =>  --  FBEF
          (((0, 0), (4811, 4813)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#F0#           =>  --  FBF0
          (((0, 0), (4814, 4816)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#F1#           =>  --  FBF1
          (((0, 0), (4814, 4816)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#F2#           =>  --  FBF2
          (((0, 0), (4817, 4819)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#F3#           =>  --  FBF3
          (((0, 0), (4817, 4819)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#F4#           =>  --  FBF4
          (((0, 0), (4820, 4822)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#F5#           =>  --  FBF5
          (((0, 0), (4820, 4822)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#F6#           =>  --  FBF6
          (((0, 0), (4823, 4825)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#F7#           =>  --  FBF7
          (((0, 0), (4823, 4825)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#F8#           =>  --  FBF8
          (((0, 0), (4823, 4825)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#F9#           =>  --  FBF9
          (((0, 0), (4826, 4828)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#FA#           =>  --  FBFA
          (((0, 0), (4826, 4828)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#FB#           =>  --  FBFB
          (((0, 0), (4826, 4828)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#FC#           =>  --  FBFC
          (((0, 0), (4829, 4829)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (others => False)),
         16#FD#           =>  --  FBFD
          (((0, 0), (4829, 4829)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (others => False)),
         16#FE#           =>  --  FBFE
          (((0, 0), (4829, 4829)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (others => False)),
         16#FF#           =>  --  FBFF
          (((0, 0), (4829, 4829)), (0, 0), 0, (Yes, Yes, No, No), Medial,
           (others => False)),
         others           =>
          (((0, 0), (0, 0)), (0, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)));

   Group_00FC : aliased constant Normalization_Mapping_Second_Stage
     := (16#00#           =>  --  FC00
          (((0, 0), (4830, 4832)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#01#           =>  --  FC01
          (((0, 0), (4833, 4835)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#02#           =>  --  FC02
          (((0, 0), (4836, 4838)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#03#           =>  --  FC03
          (((0, 0), (4826, 4828)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#04#           =>  --  FC04
          (((0, 0), (4839, 4841)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#05#           =>  --  FC05
          (((0, 0), (4842, 4843)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#06#           =>  --  FC06
          (((0, 0), (4844, 4845)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#07#           =>  --  FC07
          (((0, 0), (4846, 4847)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#08#           =>  --  FC08
          (((0, 0), (4848, 4849)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#09#           =>  --  FC09
          (((0, 0), (4850, 4851)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#0A#           =>  --  FC0A
          (((0, 0), (4852, 4853)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#0B#           =>  --  FC0B
          (((0, 0), (4854, 4855)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#0C#           =>  --  FC0C
          (((0, 0), (4856, 4857)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#0D#           =>  --  FC0D
          (((0, 0), (4858, 4859)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#0E#           =>  --  FC0E
          (((0, 0), (4860, 4861)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#0F#           =>  --  FC0F
          (((0, 0), (4862, 4863)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#10#           =>  --  FC10
          (((0, 0), (4864, 4865)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#11#           =>  --  FC11
          (((0, 0), (4866, 4867)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#12#           =>  --  FC12
          (((0, 0), (4868, 4869)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#13#           =>  --  FC13
          (((0, 0), (4870, 4871)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#14#           =>  --  FC14
          (((0, 0), (4872, 4873)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#15#           =>  --  FC15
          (((0, 0), (4874, 4875)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#16#           =>  --  FC16
          (((0, 0), (4876, 4877)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#17#           =>  --  FC17
          (((0, 0), (4875, 4876)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#18#           =>  --  FC18
          (((0, 0), (4878, 4879)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#19#           =>  --  FC19
          (((0, 0), (4880, 4881)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#1A#           =>  --  FC1A
          (((0, 0), (4882, 4883)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#1B#           =>  --  FC1B
          (((0, 0), (4884, 4885)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#1C#           =>  --  FC1C
          (((0, 0), (4886, 4887)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#1D#           =>  --  FC1D
          (((0, 0), (4888, 4889)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#1E#           =>  --  FC1E
          (((0, 0), (4890, 4891)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#1F#           =>  --  FC1F
          (((0, 0), (4892, 4893)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#20#           =>  --  FC20
          (((0, 0), (4894, 4895)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#21#           =>  --  FC21
          (((0, 0), (4896, 4897)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#22#           =>  --  FC22
          (((0, 0), (4898, 4899)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#23#           =>  --  FC23
          (((0, 0), (4900, 4901)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#24#           =>  --  FC24
          (((0, 0), (4902, 4903)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#25#           =>  --  FC25
          (((0, 0), (4904, 4905)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#26#           =>  --  FC26
          (((0, 0), (4906, 4907)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#27#           =>  --  FC27
          (((0, 0), (4908, 4909)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#28#           =>  --  FC28
          (((0, 0), (4910, 4911)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#29#           =>  --  FC29
          (((0, 0), (4912, 4913)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#2A#           =>  --  FC2A
          (((0, 0), (4914, 4915)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#2B#           =>  --  FC2B
          (((0, 0), (4916, 4917)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#2C#           =>  --  FC2C
          (((0, 0), (4918, 4919)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#2D#           =>  --  FC2D
          (((0, 0), (4920, 4921)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#2E#           =>  --  FC2E
          (((0, 0), (4922, 4923)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#2F#           =>  --  FC2F
          (((0, 0), (4924, 4925)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#30#           =>  --  FC30
          (((0, 0), (4926, 4927)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#31#           =>  --  FC31
          (((0, 0), (4928, 4929)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#32#           =>  --  FC32
          (((0, 0), (4930, 4931)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#33#           =>  --  FC33
          (((0, 0), (4932, 4933)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#34#           =>  --  FC34
          (((0, 0), (4934, 4935)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#35#           =>  --  FC35
          (((0, 0), (4936, 4937)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#36#           =>  --  FC36
          (((0, 0), (4938, 4939)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#37#           =>  --  FC37
          (((0, 0), (4940, 4941)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#38#           =>  --  FC38
          (((0, 0), (4942, 4943)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#39#           =>  --  FC39
          (((0, 0), (4944, 4945)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#3A#           =>  --  FC3A
          (((0, 0), (4946, 4947)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#3B#           =>  --  FC3B
          (((0, 0), (4948, 4949)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#3C#           =>  --  FC3C
          (((0, 0), (4950, 4951)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#3D#           =>  --  FC3D
          (((0, 0), (4952, 4953)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#3E#           =>  --  FC3E
          (((0, 0), (4954, 4955)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#3F#           =>  --  FC3F
          (((0, 0), (4956, 4957)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#40#           =>  --  FC40
          (((0, 0), (4958, 4959)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#41#           =>  --  FC41
          (((0, 0), (4960, 4961)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#42#           =>  --  FC42
          (((0, 0), (4962, 4963)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#43#           =>  --  FC43
          (((0, 0), (4964, 4965)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#44#           =>  --  FC44
          (((0, 0), (4966, 4967)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#45#           =>  --  FC45
          (((0, 0), (4968, 4969)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#46#           =>  --  FC46
          (((0, 0), (4877, 4878)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#47#           =>  --  FC47
          (((0, 0), (4879, 4880)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#48#           =>  --  FC48
          (((0, 0), (4970, 4971)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#49#           =>  --  FC49
          (((0, 0), (4972, 4973)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#4A#           =>  --  FC4A
          (((0, 0), (4838, 4839)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#4B#           =>  --  FC4B
          (((0, 0), (4974, 4975)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#4C#           =>  --  FC4C
          (((0, 0), (4976, 4977)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#4D#           =>  --  FC4D
          (((0, 0), (4978, 4979)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#4E#           =>  --  FC4E
          (((0, 0), (4980, 4981)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#4F#           =>  --  FC4F
          (((0, 0), (4982, 4983)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#50#           =>  --  FC50
          (((0, 0), (4984, 4985)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#51#           =>  --  FC51
          (((0, 0), (4986, 4987)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#52#           =>  --  FC52
          (((0, 0), (4988, 4989)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#53#           =>  --  FC53
          (((0, 0), (4990, 4991)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#54#           =>  --  FC54
          (((0, 0), (4992, 4993)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#55#           =>  --  FC55
          (((0, 0), (4873, 4874)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#56#           =>  --  FC56
          (((0, 0), (4994, 4995)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#57#           =>  --  FC57
          (((0, 0), (4996, 4997)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#58#           =>  --  FC58
          (((0, 0), (4967, 4968)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#59#           =>  --  FC59
          (((0, 0), (4998, 4999)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#5A#           =>  --  FC5A
          (((0, 0), (4993, 4994)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#5B#           =>  --  FC5B
          (((0, 0), (5000, 5001)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#5C#           =>  --  FC5C
          (((0, 0), (5002, 5003)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#5D#           =>  --  FC5D
          (((0, 0), (5004, 5005)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#5E#           =>  --  FC5E
          (((0, 0), (5006, 5008)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#5F#           =>  --  FC5F
          (((0, 0), (5009, 5011)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#60#           =>  --  FC60
          (((0, 0), (5012, 5014)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#61#           =>  --  FC61
          (((0, 0), (5015, 5017)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#62#           =>  --  FC62
          (((0, 0), (5018, 5020)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#63#           =>  --  FC63
          (((0, 0), (5021, 5023)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#64#           =>  --  FC64
          (((0, 0), (5024, 5026)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#65#           =>  --  FC65
          (((0, 0), (5027, 5029)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#66#           =>  --  FC66
          (((0, 0), (4836, 4838)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#67#           =>  --  FC67
          (((0, 0), (5030, 5032)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#68#           =>  --  FC68
          (((0, 0), (4826, 4828)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#69#           =>  --  FC69
          (((0, 0), (4839, 4841)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#6A#           =>  --  FC6A
          (((0, 0), (5033, 5034)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#6B#           =>  --  FC6B
          (((0, 0), (5035, 5036)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#6C#           =>  --  FC6C
          (((0, 0), (4848, 4849)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#6D#           =>  --  FC6D
          (((0, 0), (5037, 5038)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#6E#           =>  --  FC6E
          (((0, 0), (4850, 4851)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#6F#           =>  --  FC6F
          (((0, 0), (4852, 4853)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#70#           =>  --  FC70
          (((0, 0), (5039, 5040)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#71#           =>  --  FC71
          (((0, 0), (5041, 5042)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#72#           =>  --  FC72
          (((0, 0), (4860, 4861)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#73#           =>  --  FC73
          (((0, 0), (5043, 5044)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#74#           =>  --  FC74
          (((0, 0), (4862, 4863)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#75#           =>  --  FC75
          (((0, 0), (4864, 4865)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#76#           =>  --  FC76
          (((0, 0), (5045, 5046)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#77#           =>  --  FC77
          (((0, 0), (5047, 5048)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#78#           =>  --  FC78
          (((0, 0), (4868, 4869)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#79#           =>  --  FC79
          (((0, 0), (5049, 5050)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#7A#           =>  --  FC7A
          (((0, 0), (4870, 4871)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#7B#           =>  --  FC7B
          (((0, 0), (4872, 4873)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#7C#           =>  --  FC7C
          (((0, 0), (4928, 4929)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#7D#           =>  --  FC7D
          (((0, 0), (4930, 4931)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#7E#           =>  --  FC7E
          (((0, 0), (4936, 4937)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#7F#           =>  --  FC7F
          (((0, 0), (4938, 4939)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#80#           =>  --  FC80
          (((0, 0), (4940, 4941)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#81#           =>  --  FC81
          (((0, 0), (4948, 4949)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#82#           =>  --  FC82
          (((0, 0), (4950, 4951)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#83#           =>  --  FC83
          (((0, 0), (4952, 4953)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#84#           =>  --  FC84
          (((0, 0), (4954, 4955)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#85#           =>  --  FC85
          (((0, 0), (4962, 4963)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#86#           =>  --  FC86
          (((0, 0), (4964, 4965)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#87#           =>  --  FC87
          (((0, 0), (4966, 4967)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#88#           =>  --  FC88
          (((0, 0), (5051, 5052)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#89#           =>  --  FC89
          (((0, 0), (4970, 4971)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#8A#           =>  --  FC8A
          (((0, 0), (5053, 5054)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#8B#           =>  --  FC8B
          (((0, 0), (5055, 5056)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#8C#           =>  --  FC8C
          (((0, 0), (4980, 4981)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#8D#           =>  --  FC8D
          (((0, 0), (5057, 5058)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#8E#           =>  --  FC8E
          (((0, 0), (4982, 4983)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#8F#           =>  --  FC8F
          (((0, 0), (4984, 4985)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#90#           =>  --  FC90
          (((0, 0), (5004, 5005)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#91#           =>  --  FC91
          (((0, 0), (5059, 5060)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#92#           =>  --  FC92
          (((0, 0), (5061, 5062)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#93#           =>  --  FC93
          (((0, 0), (4967, 4968)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#94#           =>  --  FC94
          (((0, 0), (5063, 5064)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#95#           =>  --  FC95
          (((0, 0), (4998, 4999)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#96#           =>  --  FC96
          (((0, 0), (4993, 4994)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#97#           =>  --  FC97
          (((0, 0), (4830, 4832)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#98#           =>  --  FC98
          (((0, 0), (4833, 4835)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#99#           =>  --  FC99
          (((0, 0), (5065, 5067)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#9A#           =>  --  FC9A
          (((0, 0), (4836, 4838)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#9B#           =>  --  FC9B
          (((0, 0), (5068, 5070)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#9C#           =>  --  FC9C
          (((0, 0), (4842, 4843)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#9D#           =>  --  FC9D
          (((0, 0), (4844, 4845)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#9E#           =>  --  FC9E
          (((0, 0), (4846, 4847)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#9F#           =>  --  FC9F
          (((0, 0), (4848, 4849)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#A0#           =>  --  FCA0
          (((0, 0), (5071, 5072)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#A1#           =>  --  FCA1
          (((0, 0), (4854, 4855)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#A2#           =>  --  FCA2
          (((0, 0), (4856, 4857)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#A3#           =>  --  FCA3
          (((0, 0), (4858, 4859)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#A4#           =>  --  FCA4
          (((0, 0), (4860, 4861)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#A5#           =>  --  FCA5
          (((0, 0), (5073, 5074)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#A6#           =>  --  FCA6
          (((0, 0), (4868, 4869)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#A7#           =>  --  FCA7
          (((0, 0), (4874, 4875)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#A8#           =>  --  FCA8
          (((0, 0), (4876, 4877)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#A9#           =>  --  FCA9
          (((0, 0), (4875, 4876)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#AA#           =>  --  FCAA
          (((0, 0), (4878, 4879)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#AB#           =>  --  FCAB
          (((0, 0), (4880, 4881)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#AC#           =>  --  FCAC
          (((0, 0), (4884, 4885)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#AD#           =>  --  FCAD
          (((0, 0), (4886, 4887)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#AE#           =>  --  FCAE
          (((0, 0), (4888, 4889)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#AF#           =>  --  FCAF
          (((0, 0), (4890, 4891)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#B0#           =>  --  FCB0
          (((0, 0), (4892, 4893)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#B1#           =>  --  FCB1
          (((0, 0), (4894, 4895)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#B2#           =>  --  FCB2
          (((0, 0), (5075, 5076)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#B3#           =>  --  FCB3
          (((0, 0), (4896, 4897)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#B4#           =>  --  FCB4
          (((0, 0), (4898, 4899)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#B5#           =>  --  FCB5
          (((0, 0), (4900, 4901)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#B6#           =>  --  FCB6
          (((0, 0), (4902, 4903)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#B7#           =>  --  FCB7
          (((0, 0), (4904, 4905)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#B8#           =>  --  FCB8
          (((0, 0), (4906, 4907)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#B9#           =>  --  FCB9
          (((0, 0), (4910, 4911)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#BA#           =>  --  FCBA
          (((0, 0), (4912, 4913)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#BB#           =>  --  FCBB
          (((0, 0), (4914, 4915)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#BC#           =>  --  FCBC
          (((0, 0), (4916, 4917)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#BD#           =>  --  FCBD
          (((0, 0), (4918, 4919)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#BE#           =>  --  FCBE
          (((0, 0), (4920, 4921)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#BF#           =>  --  FCBF
          (((0, 0), (4922, 4923)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#C0#           =>  --  FCC0
          (((0, 0), (4924, 4925)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#C1#           =>  --  FCC1
          (((0, 0), (4926, 4927)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#C2#           =>  --  FCC2
          (((0, 0), (4932, 4933)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#C3#           =>  --  FCC3
          (((0, 0), (4934, 4935)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#C4#           =>  --  FCC4
          (((0, 0), (4942, 4943)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#C5#           =>  --  FCC5
          (((0, 0), (4944, 4945)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#C6#           =>  --  FCC6
          (((0, 0), (4946, 4947)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#C7#           =>  --  FCC7
          (((0, 0), (4948, 4949)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#C8#           =>  --  FCC8
          (((0, 0), (4950, 4951)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#C9#           =>  --  FCC9
          (((0, 0), (4956, 4957)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#CA#           =>  --  FCCA
          (((0, 0), (4958, 4959)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#CB#           =>  --  FCCB
          (((0, 0), (4960, 4961)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#CC#           =>  --  FCCC
          (((0, 0), (4962, 4963)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#CD#           =>  --  FCCD
          (((0, 0), (5077, 5078)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#CE#           =>  --  FCCE
          (((0, 0), (4968, 4969)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#CF#           =>  --  FCCF
          (((0, 0), (4877, 4878)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#D0#           =>  --  FCD0
          (((0, 0), (4879, 4880)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#D1#           =>  --  FCD1
          (((0, 0), (4970, 4971)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#D2#           =>  --  FCD2
          (((0, 0), (4974, 4975)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#D3#           =>  --  FCD3
          (((0, 0), (4976, 4977)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#D4#           =>  --  FCD4
          (((0, 0), (4978, 4979)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#D5#           =>  --  FCD5
          (((0, 0), (4980, 4981)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#D6#           =>  --  FCD6
          (((0, 0), (5079, 5080)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#D7#           =>  --  FCD7
          (((0, 0), (4986, 4987)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#D8#           =>  --  FCD8
          (((0, 0), (4988, 4989)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#D9#           =>  --  FCD9
          (((0, 0), (5081, 5082)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#DA#           =>  --  FCDA
          (((0, 0), (4873, 4874)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#DB#           =>  --  FCDB
          (((0, 0), (4994, 4995)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#DC#           =>  --  FCDC
          (((0, 0), (4996, 4997)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#DD#           =>  --  FCDD
          (((0, 0), (4967, 4968)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#DE#           =>  --  FCDE
          (((0, 0), (4985, 4986)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#DF#           =>  --  FCDF
          (((0, 0), (4836, 4838)), (0, 0), 0, (Yes, Yes, No, No), Medial,
           (Expands_On_NFKD => True,
            others => False)),
         16#E0#           =>  --  FCE0
          (((0, 0), (5068, 5070)), (0, 0), 0, (Yes, Yes, No, No), Medial,
           (Expands_On_NFKD => True,
            others => False)),
         16#E1#           =>  --  FCE1
          (((0, 0), (4848, 4849)), (0, 0), 0, (Yes, Yes, No, No), Medial,
           (Expands_On_NFKD => True,
            others => False)),
         16#E2#           =>  --  FCE2
          (((0, 0), (5071, 5072)), (0, 0), 0, (Yes, Yes, No, No), Medial,
           (Expands_On_NFKD => True,
            others => False)),
         16#E3#           =>  --  FCE3
          (((0, 0), (4860, 4861)), (0, 0), 0, (Yes, Yes, No, No), Medial,
           (Expands_On_NFKD => True,
            others => False)),
         16#E4#           =>  --  FCE4
          (((0, 0), (5073, 5074)), (0, 0), 0, (Yes, Yes, No, No), Medial,
           (Expands_On_NFKD => True,
            others => False)),
         16#E5#           =>  --  FCE5
          (((0, 0), (4868, 4869)), (0, 0), 0, (Yes, Yes, No, No), Medial,
           (Expands_On_NFKD => True,
            others => False)),
         16#E6#           =>  --  FCE6
          (((0, 0), (5083, 5084)), (0, 0), 0, (Yes, Yes, No, No), Medial,
           (Expands_On_NFKD => True,
            others => False)),
         16#E7#           =>  --  FCE7
          (((0, 0), (4892, 4893)), (0, 0), 0, (Yes, Yes, No, No), Medial,
           (Expands_On_NFKD => True,
            others => False)),
         16#E8#           =>  --  FCE8
          (((0, 0), (5085, 5086)), (0, 0), 0, (Yes, Yes, No, No), Medial,
           (Expands_On_NFKD => True,
            others => False)),
         16#E9#           =>  --  FCE9
          (((0, 0), (5087, 5088)), (0, 0), 0, (Yes, Yes, No, No), Medial,
           (Expands_On_NFKD => True,
            others => False)),
         16#EA#           =>  --  FCEA
          (((0, 0), (5089, 5090)), (0, 0), 0, (Yes, Yes, No, No), Medial,
           (Expands_On_NFKD => True,
            others => False)),
         16#EB#           =>  --  FCEB
          (((0, 0), (4948, 4949)), (0, 0), 0, (Yes, Yes, No, No), Medial,
           (Expands_On_NFKD => True,
            others => False)),
         16#EC#           =>  --  FCEC
          (((0, 0), (4950, 4951)), (0, 0), 0, (Yes, Yes, No, No), Medial,
           (Expands_On_NFKD => True,
            others => False)),
         16#ED#           =>  --  FCED
          (((0, 0), (4962, 4963)), (0, 0), 0, (Yes, Yes, No, No), Medial,
           (Expands_On_NFKD => True,
            others => False)),
         16#EE#           =>  --  FCEE
          (((0, 0), (4980, 4981)), (0, 0), 0, (Yes, Yes, No, No), Medial,
           (Expands_On_NFKD => True,
            others => False)),
         16#EF#           =>  --  FCEF
          (((0, 0), (5079, 5080)), (0, 0), 0, (Yes, Yes, No, No), Medial,
           (Expands_On_NFKD => True,
            others => False)),
         16#F0#           =>  --  FCF0
          (((0, 0), (4967, 4968)), (0, 0), 0, (Yes, Yes, No, No), Medial,
           (Expands_On_NFKD => True,
            others => False)),
         16#F1#           =>  --  FCF1
          (((0, 0), (4985, 4986)), (0, 0), 0, (Yes, Yes, No, No), Medial,
           (Expands_On_NFKD => True,
            others => False)),
         16#F2#           =>  --  FCF2
          (((0, 0), (5091, 5093)), (0, 0), 0, (Yes, Yes, No, No), Medial,
           (Expands_On_NFKD => True,
            others => False)),
         16#F3#           =>  --  FCF3
          (((0, 0), (5094, 5096)), (0, 0), 0, (Yes, Yes, No, No), Medial,
           (Expands_On_NFKD => True,
            others => False)),
         16#F4#           =>  --  FCF4
          (((0, 0), (5097, 5099)), (0, 0), 0, (Yes, Yes, No, No), Medial,
           (Expands_On_NFKD => True,
            others => False)),
         16#F5#           =>  --  FCF5
          (((0, 0), (5100, 5101)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#F6#           =>  --  FCF6
          (((0, 0), (5102, 5103)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#F7#           =>  --  FCF7
          (((0, 0), (5104, 5105)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#F8#           =>  --  FCF8
          (((0, 0), (5106, 5107)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#F9#           =>  --  FCF9
          (((0, 0), (5108, 5109)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#FA#           =>  --  FCFA
          (((0, 0), (5110, 5111)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#FB#           =>  --  FCFB
          (((0, 0), (5112, 5113)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#FC#           =>  --  FCFC
          (((0, 0), (5114, 5115)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#FD#           =>  --  FCFD
          (((0, 0), (5116, 5117)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#FE#           =>  --  FCFE
          (((0, 0), (5118, 5119)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#FF#           =>  --  FCFF
          (((0, 0), (5120, 5121)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         others           =>
          (((0, 0), (0, 0)), (0, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)));

   Group_00FD : aliased constant Normalization_Mapping_Second_Stage
     := (16#00#           =>  --  FD00
          (((0, 0), (4835, 4836)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#01#           =>  --  FD01
          (((0, 0), (5122, 5123)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#02#           =>  --  FD02
          (((0, 0), (4832, 4833)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#03#           =>  --  FD03
          (((0, 0), (5124, 5125)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#04#           =>  --  FD04
          (((0, 0), (4997, 4998)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#05#           =>  --  FD05
          (((0, 0), (5126, 5127)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#06#           =>  --  FD06
          (((0, 0), (5128, 5129)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#07#           =>  --  FD07
          (((0, 0), (5130, 5131)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#08#           =>  --  FD08
          (((0, 0), (5132, 5133)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#09#           =>  --  FD09
          (((0, 0), (5134, 5135)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#0A#           =>  --  FD0A
          (((0, 0), (5136, 5137)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#0B#           =>  --  FD0B
          (((0, 0), (5138, 5139)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#0C#           =>  --  FD0C
          (((0, 0), (5087, 5088)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#0D#           =>  --  FD0D
          (((0, 0), (5140, 5141)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#0E#           =>  --  FD0E
          (((0, 0), (5142, 5143)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#0F#           =>  --  FD0F
          (((0, 0), (5144, 5145)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#10#           =>  --  FD10
          (((0, 0), (5146, 5147)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#11#           =>  --  FD11
          (((0, 0), (5100, 5101)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#12#           =>  --  FD12
          (((0, 0), (5102, 5103)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#13#           =>  --  FD13
          (((0, 0), (5104, 5105)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#14#           =>  --  FD14
          (((0, 0), (5106, 5107)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#15#           =>  --  FD15
          (((0, 0), (5108, 5109)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#16#           =>  --  FD16
          (((0, 0), (5110, 5111)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#17#           =>  --  FD17
          (((0, 0), (5112, 5113)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#18#           =>  --  FD18
          (((0, 0), (5114, 5115)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#19#           =>  --  FD19
          (((0, 0), (5116, 5117)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#1A#           =>  --  FD1A
          (((0, 0), (5118, 5119)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#1B#           =>  --  FD1B
          (((0, 0), (5120, 5121)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#1C#           =>  --  FD1C
          (((0, 0), (4835, 4836)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#1D#           =>  --  FD1D
          (((0, 0), (5122, 5123)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#1E#           =>  --  FD1E
          (((0, 0), (4832, 4833)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#1F#           =>  --  FD1F
          (((0, 0), (5124, 5125)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#20#           =>  --  FD20
          (((0, 0), (4997, 4998)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#21#           =>  --  FD21
          (((0, 0), (5126, 5127)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#22#           =>  --  FD22
          (((0, 0), (5128, 5129)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#23#           =>  --  FD23
          (((0, 0), (5130, 5131)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#24#           =>  --  FD24
          (((0, 0), (5132, 5133)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#25#           =>  --  FD25
          (((0, 0), (5134, 5135)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#26#           =>  --  FD26
          (((0, 0), (5136, 5137)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#27#           =>  --  FD27
          (((0, 0), (5138, 5139)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#28#           =>  --  FD28
          (((0, 0), (5087, 5088)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#29#           =>  --  FD29
          (((0, 0), (5140, 5141)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#2A#           =>  --  FD2A
          (((0, 0), (5142, 5143)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#2B#           =>  --  FD2B
          (((0, 0), (5144, 5145)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#2C#           =>  --  FD2C
          (((0, 0), (5146, 5147)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#2D#           =>  --  FD2D
          (((0, 0), (5134, 5135)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#2E#           =>  --  FD2E
          (((0, 0), (5136, 5137)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#2F#           =>  --  FD2F
          (((0, 0), (5138, 5139)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#30#           =>  --  FD30
          (((0, 0), (5087, 5088)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#31#           =>  --  FD31
          (((0, 0), (5085, 5086)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#32#           =>  --  FD32
          (((0, 0), (5089, 5090)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#33#           =>  --  FD33
          (((0, 0), (4908, 4909)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#34#           =>  --  FD34
          (((0, 0), (4886, 4887)), (0, 0), 0, (Yes, Yes, No, No), Medial,
           (Expands_On_NFKD => True,
            others => False)),
         16#35#           =>  --  FD35
          (((0, 0), (4888, 4889)), (0, 0), 0, (Yes, Yes, No, No), Medial,
           (Expands_On_NFKD => True,
            others => False)),
         16#36#           =>  --  FD36
          (((0, 0), (4890, 4891)), (0, 0), 0, (Yes, Yes, No, No), Medial,
           (Expands_On_NFKD => True,
            others => False)),
         16#37#           =>  --  FD37
          (((0, 0), (5134, 5135)), (0, 0), 0, (Yes, Yes, No, No), Medial,
           (Expands_On_NFKD => True,
            others => False)),
         16#38#           =>  --  FD38
          (((0, 0), (5136, 5137)), (0, 0), 0, (Yes, Yes, No, No), Medial,
           (Expands_On_NFKD => True,
            others => False)),
         16#39#           =>  --  FD39
          (((0, 0), (5138, 5139)), (0, 0), 0, (Yes, Yes, No, No), Medial,
           (Expands_On_NFKD => True,
            others => False)),
         16#3A#           =>  --  FD3A
          (((0, 0), (4908, 4909)), (0, 0), 0, (Yes, Yes, No, No), Medial,
           (Expands_On_NFKD => True,
            others => False)),
         16#3B#           =>  --  FD3B
          (((0, 0), (4910, 4911)), (0, 0), 0, (Yes, Yes, No, No), Medial,
           (Expands_On_NFKD => True,
            others => False)),
         16#3C#           =>  --  FD3C
          (((0, 0), (5148, 5149)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#3D#           =>  --  FD3D
          (((0, 0), (5148, 5149)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#50#           =>  --  FD50
          (((0, 0), (5150, 5152)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#51#           =>  --  FD51
          (((0, 0), (5153, 5155)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#52#           =>  --  FD52
          (((0, 0), (5153, 5155)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#53#           =>  --  FD53
          (((0, 0), (5156, 5158)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#54#           =>  --  FD54
          (((0, 0), (5159, 5161)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#55#           =>  --  FD55
          (((0, 0), (5162, 5164)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#56#           =>  --  FD56
          (((0, 0), (5165, 5167)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#57#           =>  --  FD57
          (((0, 0), (5168, 5170)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#58#           =>  --  FD58
          (((0, 0), (4876, 4878)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#59#           =>  --  FD59
          (((0, 0), (4876, 4878)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#5A#           =>  --  FD5A
          (((0, 0), (5171, 5173)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#5B#           =>  --  FD5B
          (((0, 0), (5174, 5176)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#5C#           =>  --  FD5C
          (((0, 0), (5177, 5179)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#5D#           =>  --  FD5D
          (((0, 0), (5180, 5182)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#5E#           =>  --  FD5E
          (((0, 0), (5183, 5185)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#5F#           =>  --  FD5F
          (((0, 0), (5186, 5188)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#60#           =>  --  FD60
          (((0, 0), (5186, 5188)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#61#           =>  --  FD61
          (((0, 0), (5189, 5191)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#62#           =>  --  FD62
          (((0, 0), (5192, 5194)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#63#           =>  --  FD63
          (((0, 0), (5192, 5194)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#64#           =>  --  FD64
          (((0, 0), (5195, 5197)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#65#           =>  --  FD65
          (((0, 0), (5195, 5197)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#66#           =>  --  FD66
          (((0, 0), (5198, 5200)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#67#           =>  --  FD67
          (((0, 0), (5201, 5203)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#68#           =>  --  FD68
          (((0, 0), (5201, 5203)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#69#           =>  --  FD69
          (((0, 0), (5204, 5206)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#6A#           =>  --  FD6A
          (((0, 0), (5207, 5209)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#6B#           =>  --  FD6B
          (((0, 0), (5207, 5209)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#6C#           =>  --  FD6C
          (((0, 0), (5210, 5212)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#6D#           =>  --  FD6D
          (((0, 0), (5210, 5212)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#6E#           =>  --  FD6E
          (((0, 0), (5213, 5215)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#6F#           =>  --  FD6F
          (((0, 0), (5216, 5218)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#70#           =>  --  FD70
          (((0, 0), (5216, 5218)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#71#           =>  --  FD71
          (((0, 0), (5219, 5221)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#72#           =>  --  FD72
          (((0, 0), (5219, 5221)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#73#           =>  --  FD73
          (((0, 0), (5222, 5224)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#74#           =>  --  FD74
          (((0, 0), (5225, 5227)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#75#           =>  --  FD75
          (((0, 0), (5228, 5230)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#76#           =>  --  FD76
          (((0, 0), (5231, 5233)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#77#           =>  --  FD77
          (((0, 0), (5231, 5233)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#78#           =>  --  FD78
          (((0, 0), (5234, 5236)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#79#           =>  --  FD79
          (((0, 0), (5237, 5239)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#7A#           =>  --  FD7A
          (((0, 0), (5240, 5242)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#7B#           =>  --  FD7B
          (((0, 0), (5243, 5245)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#7C#           =>  --  FD7C
          (((0, 0), (5246, 5248)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#7D#           =>  --  FD7D
          (((0, 0), (5246, 5248)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#7E#           =>  --  FD7E
          (((0, 0), (5249, 5251)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#7F#           =>  --  FD7F
          (((0, 0), (5252, 5254)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#80#           =>  --  FD80
          (((0, 0), (5255, 5257)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#81#           =>  --  FD81
          (((0, 0), (5258, 5260)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#82#           =>  --  FD82
          (((0, 0), (5261, 5263)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#83#           =>  --  FD83
          (((0, 0), (5264, 5266)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#84#           =>  --  FD84
          (((0, 0), (5264, 5266)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#85#           =>  --  FD85
          (((0, 0), (5267, 5269)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#86#           =>  --  FD86
          (((0, 0), (5267, 5269)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#87#           =>  --  FD87
          (((0, 0), (5270, 5272)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#88#           =>  --  FD88
          (((0, 0), (5270, 5272)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#89#           =>  --  FD89
          (((0, 0), (5273, 5275)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#8A#           =>  --  FD8A
          (((0, 0), (4877, 4879)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#8B#           =>  --  FD8B
          (((0, 0), (5276, 5278)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#8C#           =>  --  FD8C
          (((0, 0), (5279, 5281)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#8D#           =>  --  FD8D
          (((0, 0), (4968, 4970)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#8E#           =>  --  FD8E
          (((0, 0), (4879, 4881)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#8F#           =>  --  FD8F
          (((0, 0), (5282, 5284)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#92#           =>  --  FD92
          (((0, 0), (5285, 5287)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#93#           =>  --  FD93
          (((0, 0), (5288, 5290)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#94#           =>  --  FD94
          (((0, 0), (5291, 5293)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#95#           =>  --  FD95
          (((0, 0), (5294, 5296)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#96#           =>  --  FD96
          (((0, 0), (5297, 5299)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#97#           =>  --  FD97
          (((0, 0), (5300, 5302)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#98#           =>  --  FD98
          (((0, 0), (5300, 5302)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#99#           =>  --  FD99
          (((0, 0), (5303, 5305)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#9A#           =>  --  FD9A
          (((0, 0), (5306, 5308)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#9B#           =>  --  FD9B
          (((0, 0), (5309, 5311)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#9C#           =>  --  FD9C
          (((0, 0), (5312, 5314)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#9D#           =>  --  FD9D
          (((0, 0), (5312, 5314)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#9E#           =>  --  FD9E
          (((0, 0), (5315, 5317)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#9F#           =>  --  FD9F
          (((0, 0), (5318, 5320)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#A0#           =>  --  FDA0
          (((0, 0), (5321, 5323)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#A1#           =>  --  FDA1
          (((0, 0), (5324, 5326)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#A2#           =>  --  FDA2
          (((0, 0), (5327, 5329)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#A3#           =>  --  FDA3
          (((0, 0), (5330, 5332)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#A4#           =>  --  FDA4
          (((0, 0), (5333, 5335)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#A5#           =>  --  FDA5
          (((0, 0), (5336, 5338)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#A6#           =>  --  FDA6
          (((0, 0), (5339, 5341)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#A7#           =>  --  FDA7
          (((0, 0), (5342, 5344)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#A8#           =>  --  FDA8
          (((0, 0), (5345, 5347)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#A9#           =>  --  FDA9
          (((0, 0), (5348, 5350)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#AA#           =>  --  FDAA
          (((0, 0), (5351, 5353)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#AB#           =>  --  FDAB
          (((0, 0), (5354, 5356)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#AC#           =>  --  FDAC
          (((0, 0), (5357, 5359)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#AD#           =>  --  FDAD
          (((0, 0), (5360, 5362)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#AE#           =>  --  FDAE
          (((0, 0), (4994, 4996)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#AF#           =>  --  FDAF
          (((0, 0), (5363, 5365)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#B0#           =>  --  FDB0
          (((0, 0), (5366, 5368)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#B1#           =>  --  FDB1
          (((0, 0), (5369, 5371)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#B2#           =>  --  FDB2
          (((0, 0), (5372, 5374)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#B3#           =>  --  FDB3
          (((0, 0), (5375, 5377)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#B4#           =>  --  FDB4
          (((0, 0), (5249, 5251)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#B5#           =>  --  FDB5
          (((0, 0), (5255, 5257)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#B6#           =>  --  FDB6
          (((0, 0), (5378, 5380)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#B7#           =>  --  FDB7
          (((0, 0), (5381, 5383)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#B8#           =>  --  FDB8
          (((0, 0), (5384, 5386)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#B9#           =>  --  FDB9
          (((0, 0), (5387, 5389)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#BA#           =>  --  FDBA
          (((0, 0), (5390, 5392)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#BB#           =>  --  FDBB
          (((0, 0), (5393, 5395)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#BC#           =>  --  FDBC
          (((0, 0), (5390, 5392)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#BD#           =>  --  FDBD
          (((0, 0), (5384, 5386)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#BE#           =>  --  FDBE
          (((0, 0), (5396, 5398)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#BF#           =>  --  FDBF
          (((0, 0), (5399, 5401)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#C0#           =>  --  FDC0
          (((0, 0), (5402, 5404)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#C1#           =>  --  FDC1
          (((0, 0), (5405, 5407)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#C2#           =>  --  FDC2
          (((0, 0), (5408, 5410)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#C3#           =>  --  FDC3
          (((0, 0), (5393, 5395)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#C4#           =>  --  FDC4
          (((0, 0), (5228, 5230)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#C5#           =>  --  FDC5
          (((0, 0), (5198, 5200)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#C6#           =>  --  FDC6
          (((0, 0), (5411, 5413)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#C7#           =>  --  FDC7
          (((0, 0), (5414, 5416)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#F0#           =>  --  FDF0
          (((0, 0), (5417, 5419)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#F1#           =>  --  FDF1
          (((0, 0), (5420, 5422)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#F2#           =>  --  FDF2
          (((0, 0), (5423, 5426)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#F3#           =>  --  FDF3
          (((0, 0), (5427, 5430)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#F4#           =>  --  FDF4
          (((0, 0), (5431, 5434)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#F5#           =>  --  FDF5
          (((0, 0), (5435, 5438)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#F6#           =>  --  FDF6
          (((0, 0), (5439, 5442)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#F7#           =>  --  FDF7
          (((0, 0), (5443, 5446)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#F8#           =>  --  FDF8
          (((0, 0), (5447, 5450)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#F9#           =>  --  FDF9
          (((0, 0), (5451, 5453)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#FA#           =>  --  FDFA
          (((0, 0), (5454, 5471)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#FB#           =>  --  FDFB
          (((0, 0), (5472, 5479)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#FC#           =>  --  FDFC
          (((0, 0), (5480, 5483)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         others           =>
          (((0, 0), (0, 0)), (0, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)));

   Group_00FE : aliased constant Normalization_Mapping_Second_Stage
     := (16#10#           =>  --  FE10
          (((0, 0), (5484, 5484)), (0, 0), 0, (Yes, Yes, No, No), Vertical,
           (others => False)),
         16#11#           =>  --  FE11
          (((0, 0), (5485, 5485)), (0, 0), 0, (Yes, Yes, No, No), Vertical,
           (others => False)),
         16#12#           =>  --  FE12
          (((0, 0), (5486, 5486)), (0, 0), 0, (Yes, Yes, No, No), Vertical,
           (others => False)),
         16#13#           =>  --  FE13
          (((0, 0), (2704, 2704)), (0, 0), 0, (Yes, Yes, No, No), Vertical,
           (others => False)),
         16#14#           =>  --  FE14
          (((0, 0), (601, 601)), (0, 0), 0, (Yes, Yes, No, No), Vertical,
           (others => False)),
         16#15#           =>  --  FE15
          (((0, 0), (2228, 2228)), (0, 0), 0, (Yes, Yes, No, No), Vertical,
           (others => False)),
         16#16#           =>  --  FE16
          (((0, 0), (2232, 2232)), (0, 0), 0, (Yes, Yes, No, No), Vertical,
           (others => False)),
         16#17#           =>  --  FE17
          (((0, 0), (5487, 5487)), (0, 0), 0, (Yes, Yes, No, No), Vertical,
           (others => False)),
         16#18#           =>  --  FE18
          (((0, 0), (5488, 5488)), (0, 0), 0, (Yes, Yes, No, No), Vertical,
           (others => False)),
         16#19#           =>  --  FE19
          (((0, 0), (2215, 2217)), (0, 0), 0, (Yes, Yes, No, No), Vertical,
           (Expands_On_NFKD => True,
            others => False)),
         16#20# .. 16#26# =>  --  FE20 .. FE26
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#27# .. 16#2D# =>  --  FE27 .. FE2D
          (((0, 0), (0, 0)), (0, 0), 220, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#30#           =>  --  FE30
          (((0, 0), (2215, 2216)), (0, 0), 0, (Yes, Yes, No, No), Vertical,
           (Expands_On_NFKD => True,
            others => False)),
         16#31#           =>  --  FE31
          (((0, 0), (5489, 5489)), (0, 0), 0, (Yes, Yes, No, No), Vertical,
           (others => False)),
         16#32#           =>  --  FE32
          (((0, 0), (5490, 5490)), (0, 0), 0, (Yes, Yes, No, No), Vertical,
           (others => False)),
         16#33# .. 16#34# =>  --  FE33 .. FE34
          (((0, 0), (5491, 5491)), (0, 0), 0, (Yes, Yes, No, No), Vertical,
           (others => False)),
         16#35#           =>  --  FE35
          (((0, 0), (2247, 2247)), (0, 0), 0, (Yes, Yes, No, No), Vertical,
           (others => False)),
         16#36#           =>  --  FE36
          (((0, 0), (2248, 2248)), (0, 0), 0, (Yes, Yes, No, No), Vertical,
           (others => False)),
         16#37#           =>  --  FE37
          (((0, 0), (5492, 5492)), (0, 0), 0, (Yes, Yes, No, No), Vertical,
           (others => False)),
         16#38#           =>  --  FE38
          (((0, 0), (5493, 5493)), (0, 0), 0, (Yes, Yes, No, No), Vertical,
           (others => False)),
         16#39#           =>  --  FE39
          (((0, 0), (5494, 5494)), (0, 0), 0, (Yes, Yes, No, No), Vertical,
           (others => False)),
         16#3A#           =>  --  FE3A
          (((0, 0), (5495, 5495)), (0, 0), 0, (Yes, Yes, No, No), Vertical,
           (others => False)),
         16#3B#           =>  --  FE3B
          (((0, 0), (5496, 5496)), (0, 0), 0, (Yes, Yes, No, No), Vertical,
           (others => False)),
         16#3C#           =>  --  FE3C
          (((0, 0), (5497, 5497)), (0, 0), 0, (Yes, Yes, No, No), Vertical,
           (others => False)),
         16#3D#           =>  --  FE3D
          (((0, 0), (5498, 5498)), (0, 0), 0, (Yes, Yes, No, No), Vertical,
           (others => False)),
         16#3E#           =>  --  FE3E
          (((0, 0), (5499, 5499)), (0, 0), 0, (Yes, Yes, No, No), Vertical,
           (others => False)),
         16#3F#           =>  --  FE3F
          (((0, 0), (2482, 2482)), (0, 0), 0, (Yes, Yes, No, No), Vertical,
           (others => False)),
         16#40#           =>  --  FE40
          (((0, 0), (2483, 2483)), (0, 0), 0, (Yes, Yes, No, No), Vertical,
           (others => False)),
         16#41#           =>  --  FE41
          (((0, 0), (5500, 5500)), (0, 0), 0, (Yes, Yes, No, No), Vertical,
           (others => False)),
         16#42#           =>  --  FE42
          (((0, 0), (5501, 5501)), (0, 0), 0, (Yes, Yes, No, No), Vertical,
           (others => False)),
         16#43#           =>  --  FE43
          (((0, 0), (5502, 5502)), (0, 0), 0, (Yes, Yes, No, No), Vertical,
           (others => False)),
         16#44#           =>  --  FE44
          (((0, 0), (5503, 5503)), (0, 0), 0, (Yes, Yes, No, No), Vertical,
           (others => False)),
         16#47#           =>  --  FE47
          (((0, 0), (5504, 5504)), (0, 0), 0, (Yes, Yes, No, No), Vertical,
           (others => False)),
         16#48#           =>  --  FE48
          (((0, 0), (5505, 5505)), (0, 0), 0, (Yes, Yes, No, No), Vertical,
           (others => False)),
         16#49# .. 16#4C# =>  --  FE49 .. FE4C
          (((0, 0), (2230, 2231)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#4D# .. 16#4F# =>  --  FE4D .. FE4F
          (((0, 0), (5491, 5491)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (others => False)),
         16#50#           =>  --  FE50
          (((0, 0), (5484, 5484)), (0, 0), 0, (Yes, Yes, No, No), Small,
           (others => False)),
         16#51#           =>  --  FE51
          (((0, 0), (5485, 5485)), (0, 0), 0, (Yes, Yes, No, No), Small,
           (others => False)),
         16#52#           =>  --  FE52
          (((0, 0), (2215, 2215)), (0, 0), 0, (Yes, Yes, No, No), Small,
           (others => False)),
         16#54#           =>  --  FE54
          (((0, 0), (601, 601)), (0, 0), 0, (Yes, Yes, No, No), Small,
           (others => False)),
         16#55#           =>  --  FE55
          (((0, 0), (2704, 2704)), (0, 0), 0, (Yes, Yes, No, No), Small,
           (others => False)),
         16#56#           =>  --  FE56
          (((0, 0), (2232, 2232)), (0, 0), 0, (Yes, Yes, No, No), Small,
           (others => False)),
         16#57#           =>  --  FE57
          (((0, 0), (2228, 2228)), (0, 0), 0, (Yes, Yes, No, No), Small,
           (others => False)),
         16#58#           =>  --  FE58
          (((0, 0), (5489, 5489)), (0, 0), 0, (Yes, Yes, No, No), Small,
           (others => False)),
         16#59#           =>  --  FE59
          (((0, 0), (2247, 2247)), (0, 0), 0, (Yes, Yes, No, No), Small,
           (others => False)),
         16#5A#           =>  --  FE5A
          (((0, 0), (2248, 2248)), (0, 0), 0, (Yes, Yes, No, No), Small,
           (others => False)),
         16#5B#           =>  --  FE5B
          (((0, 0), (5492, 5492)), (0, 0), 0, (Yes, Yes, No, No), Small,
           (others => False)),
         16#5C#           =>  --  FE5C
          (((0, 0), (5493, 5493)), (0, 0), 0, (Yes, Yes, No, No), Small,
           (others => False)),
         16#5D#           =>  --  FE5D
          (((0, 0), (5494, 5494)), (0, 0), 0, (Yes, Yes, No, No), Small,
           (others => False)),
         16#5E#           =>  --  FE5E
          (((0, 0), (5495, 5495)), (0, 0), 0, (Yes, Yes, No, No), Small,
           (others => False)),
         16#5F#           =>  --  FE5F
          (((0, 0), (5506, 5506)), (0, 0), 0, (Yes, Yes, No, No), Small,
           (others => False)),
         16#60#           =>  --  FE60
          (((0, 0), (5507, 5507)), (0, 0), 0, (Yes, Yes, No, No), Small,
           (others => False)),
         16#61#           =>  --  FE61
          (((0, 0), (5508, 5508)), (0, 0), 0, (Yes, Yes, No, No), Small,
           (others => False)),
         16#62#           =>  --  FE62
          (((0, 0), (2244, 2244)), (0, 0), 0, (Yes, Yes, No, No), Small,
           (others => False)),
         16#63#           =>  --  FE63
          (((0, 0), (5509, 5509)), (0, 0), 0, (Yes, Yes, No, No), Small,
           (others => False)),
         16#64#           =>  --  FE64
          (((0, 0), (2430, 2430)), (0, 0), 0, (Yes, Yes, No, No), Small,
           (others => False)),
         16#65#           =>  --  FE65
          (((0, 0), (2432, 2432)), (0, 0), 0, (Yes, Yes, No, No), Small,
           (others => False)),
         16#66#           =>  --  FE66
          (((0, 0), (2246, 2246)), (0, 0), 0, (Yes, Yes, No, No), Small,
           (others => False)),
         16#68#           =>  --  FE68
          (((0, 0), (5510, 5510)), (0, 0), 0, (Yes, Yes, No, No), Small,
           (others => False)),
         16#69#           =>  --  FE69
          (((0, 0), (5511, 5511)), (0, 0), 0, (Yes, Yes, No, No), Small,
           (others => False)),
         16#6A#           =>  --  FE6A
          (((0, 0), (5512, 5512)), (0, 0), 0, (Yes, Yes, No, No), Small,
           (others => False)),
         16#6B#           =>  --  FE6B
          (((0, 0), (5513, 5513)), (0, 0), 0, (Yes, Yes, No, No), Small,
           (others => False)),
         16#70#           =>  --  FE70
          (((0, 0), (5514, 5515)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#71#           =>  --  FE71
          (((0, 0), (5516, 5517)), (0, 0), 0, (Yes, Yes, No, No), Medial,
           (Expands_On_NFKD => True,
            others => False)),
         16#72#           =>  --  FE72
          (((0, 0), (5006, 5007)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#74#           =>  --  FE74
          (((0, 0), (5009, 5010)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#76#           =>  --  FE76
          (((0, 0), (5012, 5013)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#77#           =>  --  FE77
          (((0, 0), (5091, 5092)), (0, 0), 0, (Yes, Yes, No, No), Medial,
           (Expands_On_NFKD => True,
            others => False)),
         16#78#           =>  --  FE78
          (((0, 0), (5015, 5016)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#79#           =>  --  FE79
          (((0, 0), (5094, 5095)), (0, 0), 0, (Yes, Yes, No, No), Medial,
           (Expands_On_NFKD => True,
            others => False)),
         16#7A#           =>  --  FE7A
          (((0, 0), (5018, 5019)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#7B#           =>  --  FE7B
          (((0, 0), (5097, 5098)), (0, 0), 0, (Yes, Yes, No, No), Medial,
           (Expands_On_NFKD => True,
            others => False)),
         16#7C#           =>  --  FE7C
          (((0, 0), (5021, 5022)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#7D#           =>  --  FE7D
          (((0, 0), (5518, 5519)), (0, 0), 0, (Yes, Yes, No, No), Medial,
           (Expands_On_NFKD => True,
            others => False)),
         16#7E#           =>  --  FE7E
          (((0, 0), (5520, 5521)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#7F#           =>  --  FE7F
          (((0, 0), (5522, 5523)), (0, 0), 0, (Yes, Yes, No, No), Medial,
           (Expands_On_NFKD => True,
            others => False)),
         16#80#           =>  --  FE80
          (((0, 0), (5524, 5524)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (others => False)),
         16#81#           =>  --  FE81
          (((0, 0), (764, 765)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#82#           =>  --  FE82
          (((0, 0), (764, 765)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#83#           =>  --  FE83
          (((0, 0), (766, 767)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#84#           =>  --  FE84
          (((0, 0), (766, 767)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#85#           =>  --  FE85
          (((0, 0), (768, 769)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#86#           =>  --  FE86
          (((0, 0), (768, 769)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#87#           =>  --  FE87
          (((0, 0), (770, 771)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#88#           =>  --  FE88
          (((0, 0), (770, 771)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#89#           =>  --  FE89
          (((0, 0), (772, 773)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#8A#           =>  --  FE8A
          (((0, 0), (772, 773)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#8B#           =>  --  FE8B
          (((0, 0), (772, 773)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (Expands_On_NFKD => True,
            others => False)),
         16#8C#           =>  --  FE8C
          (((0, 0), (772, 773)), (0, 0), 0, (Yes, Yes, No, No), Medial,
           (Expands_On_NFKD => True,
            others => False)),
         16#8D#           =>  --  FE8D
          (((0, 0), (764, 764)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (others => False)),
         16#8E#           =>  --  FE8E
          (((0, 0), (764, 764)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (others => False)),
         16#8F#           =>  --  FE8F
          (((0, 0), (4842, 4842)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (others => False)),
         16#90#           =>  --  FE90
          (((0, 0), (4842, 4842)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (others => False)),
         16#91#           =>  --  FE91
          (((0, 0), (4842, 4842)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (others => False)),
         16#92#           =>  --  FE92
          (((0, 0), (4842, 4842)), (0, 0), 0, (Yes, Yes, No, No), Medial,
           (others => False)),
         16#93#           =>  --  FE93
          (((0, 0), (5525, 5525)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (others => False)),
         16#94#           =>  --  FE94
          (((0, 0), (5525, 5525)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (others => False)),
         16#95#           =>  --  FE95
          (((0, 0), (4854, 4854)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (others => False)),
         16#96#           =>  --  FE96
          (((0, 0), (4854, 4854)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (others => False)),
         16#97#           =>  --  FE97
          (((0, 0), (4854, 4854)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (others => False)),
         16#98#           =>  --  FE98
          (((0, 0), (4854, 4854)), (0, 0), 0, (Yes, Yes, No, No), Medial,
           (others => False)),
         16#99#           =>  --  FE99
          (((0, 0), (4866, 4866)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (others => False)),
         16#9A#           =>  --  FE9A
          (((0, 0), (4866, 4866)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (others => False)),
         16#9B#           =>  --  FE9B
          (((0, 0), (4866, 4866)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (others => False)),
         16#9C#           =>  --  FE9C
          (((0, 0), (4866, 4866)), (0, 0), 0, (Yes, Yes, No, No), Medial,
           (others => False)),
         16#9D#           =>  --  FE9D
          (((0, 0), (4832, 4832)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (others => False)),
         16#9E#           =>  --  FE9E
          (((0, 0), (4832, 4832)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (others => False)),
         16#9F#           =>  --  FE9F
          (((0, 0), (4832, 4832)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (others => False)),
         16#A0#           =>  --  FEA0
          (((0, 0), (4832, 4832)), (0, 0), 0, (Yes, Yes, No, No), Medial,
           (others => False)),
         16#A1#           =>  --  FEA1
          (((0, 0), (4835, 4835)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (others => False)),
         16#A2#           =>  --  FEA2
          (((0, 0), (4835, 4835)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (others => False)),
         16#A3#           =>  --  FEA3
          (((0, 0), (4835, 4835)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (others => False)),
         16#A4#           =>  --  FEA4
          (((0, 0), (4835, 4835)), (0, 0), 0, (Yes, Yes, No, No), Medial,
           (others => False)),
         16#A5#           =>  --  FEA5
          (((0, 0), (4847, 4847)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (others => False)),
         16#A6#           =>  --  FEA6
          (((0, 0), (4847, 4847)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (others => False)),
         16#A7#           =>  --  FEA7
          (((0, 0), (4847, 4847)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (others => False)),
         16#A8#           =>  --  FEA8
          (((0, 0), (4847, 4847)), (0, 0), 0, (Yes, Yes, No, No), Medial,
           (others => False)),
         16#A9#           =>  --  FEA9
          (((0, 0), (5434, 5434)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (others => False)),
         16#AA#           =>  --  FEAA
          (((0, 0), (5434, 5434)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (others => False)),
         16#AB#           =>  --  FEAB
          (((0, 0), (5000, 5000)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (others => False)),
         16#AC#           =>  --  FEAC
          (((0, 0), (5000, 5000)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (others => False)),
         16#AD#           =>  --  FEAD
          (((0, 0), (5002, 5002)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (others => False)),
         16#AE#           =>  --  FEAE
          (((0, 0), (5002, 5002)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (others => False)),
         16#AF#           =>  --  FEAF
          (((0, 0), (5029, 5029)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (others => False)),
         16#B0#           =>  --  FEB0
          (((0, 0), (5029, 5029)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (others => False)),
         16#B1#           =>  --  FEB1
          (((0, 0), (4886, 4886)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (others => False)),
         16#B2#           =>  --  FEB2
          (((0, 0), (4886, 4886)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (others => False)),
         16#B3#           =>  --  FEB3
          (((0, 0), (4886, 4886)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (others => False)),
         16#B4#           =>  --  FEB4
          (((0, 0), (4886, 4886)), (0, 0), 0, (Yes, Yes, No, No), Medial,
           (others => False)),
         16#B5#           =>  --  FEB5
          (((0, 0), (5087, 5087)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (others => False)),
         16#B6#           =>  --  FEB6
          (((0, 0), (5087, 5087)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (others => False)),
         16#B7#           =>  --  FEB7
          (((0, 0), (5087, 5087)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (others => False)),
         16#B8#           =>  --  FEB8
          (((0, 0), (5087, 5087)), (0, 0), 0, (Yes, Yes, No, No), Medial,
           (others => False)),
         16#B9#           =>  --  FEB9
          (((0, 0), (4894, 4894)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (others => False)),
         16#BA#           =>  --  FEBA
          (((0, 0), (4894, 4894)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (others => False)),
         16#BB#           =>  --  FEBB
          (((0, 0), (4894, 4894)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (others => False)),
         16#BC#           =>  --  FEBC
          (((0, 0), (4894, 4894)), (0, 0), 0, (Yes, Yes, No, No), Medial,
           (others => False)),
         16#BD#           =>  --  FEBD
          (((0, 0), (4898, 4898)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (others => False)),
         16#BE#           =>  --  FEBE
          (((0, 0), (4898, 4898)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (others => False)),
         16#BF#           =>  --  FEBF
          (((0, 0), (4898, 4898)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (others => False)),
         16#C0#           =>  --  FEC0
          (((0, 0), (4898, 4898)), (0, 0), 0, (Yes, Yes, No, No), Medial,
           (others => False)),
         16#C1#           =>  --  FEC1
          (((0, 0), (4906, 4906)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (others => False)),
         16#C2#           =>  --  FEC2
          (((0, 0), (4906, 4906)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (others => False)),
         16#C3#           =>  --  FEC3
          (((0, 0), (4906, 4906)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (others => False)),
         16#C4#           =>  --  FEC4
          (((0, 0), (4906, 4906)), (0, 0), 0, (Yes, Yes, No, No), Medial,
           (others => False)),
         16#C5#           =>  --  FEC5
          (((0, 0), (4910, 4910)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (others => False)),
         16#C6#           =>  --  FEC6
          (((0, 0), (4910, 4910)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (others => False)),
         16#C7#           =>  --  FEC7
          (((0, 0), (4910, 4910)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (others => False)),
         16#C8#           =>  --  FEC8
          (((0, 0), (4910, 4910)), (0, 0), 0, (Yes, Yes, No, No), Medial,
           (others => False)),
         16#C9#           =>  --  FEC9
          (((0, 0), (4912, 4912)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (others => False)),
         16#CA#           =>  --  FECA
          (((0, 0), (4912, 4912)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (others => False)),
         16#CB#           =>  --  FECB
          (((0, 0), (4912, 4912)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (others => False)),
         16#CC#           =>  --  FECC
          (((0, 0), (4912, 4912)), (0, 0), 0, (Yes, Yes, No, No), Medial,
           (others => False)),
         16#CD#           =>  --  FECD
          (((0, 0), (4916, 4916)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (others => False)),
         16#CE#           =>  --  FECE
          (((0, 0), (4916, 4916)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (others => False)),
         16#CF#           =>  --  FECF
          (((0, 0), (4916, 4916)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (others => False)),
         16#D0#           =>  --  FED0
          (((0, 0), (4916, 4916)), (0, 0), 0, (Yes, Yes, No, No), Medial,
           (others => False)),
         16#D1#           =>  --  FED1
          (((0, 0), (4920, 4920)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (others => False)),
         16#D2#           =>  --  FED2
          (((0, 0), (4920, 4920)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (others => False)),
         16#D3#           =>  --  FED3
          (((0, 0), (4920, 4920)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (others => False)),
         16#D4#           =>  --  FED4
          (((0, 0), (4920, 4920)), (0, 0), 0, (Yes, Yes, No, No), Medial,
           (others => False)),
         16#D5#           =>  --  FED5
          (((0, 0), (4932, 4932)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (others => False)),
         16#D6#           =>  --  FED6
          (((0, 0), (4932, 4932)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (others => False)),
         16#D7#           =>  --  FED7
          (((0, 0), (4932, 4932)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (others => False)),
         16#D8#           =>  --  FED8
          (((0, 0), (4932, 4932)), (0, 0), 0, (Yes, Yes, No, No), Medial,
           (others => False)),
         16#D9#           =>  --  FED9
          (((0, 0), (4940, 4940)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (others => False)),
         16#DA#           =>  --  FEDA
          (((0, 0), (4940, 4940)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (others => False)),
         16#DB#           =>  --  FEDB
          (((0, 0), (4940, 4940)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (others => False)),
         16#DC#           =>  --  FEDC
          (((0, 0), (4940, 4940)), (0, 0), 0, (Yes, Yes, No, No), Medial,
           (others => False)),
         16#DD#           =>  --  FEDD
          (((0, 0), (4949, 4949)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (others => False)),
         16#DE#           =>  --  FEDE
          (((0, 0), (4949, 4949)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (others => False)),
         16#DF#           =>  --  FEDF
          (((0, 0), (4949, 4949)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (others => False)),
         16#E0#           =>  --  FEE0
          (((0, 0), (4949, 4949)), (0, 0), 0, (Yes, Yes, No, No), Medial,
           (others => False)),
         16#E1#           =>  --  FEE1
          (((0, 0), (4838, 4838)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (others => False)),
         16#E2#           =>  --  FEE2
          (((0, 0), (4838, 4838)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (others => False)),
         16#E3#           =>  --  FEE3
          (((0, 0), (4838, 4838)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (others => False)),
         16#E4#           =>  --  FEE4
          (((0, 0), (4838, 4838)), (0, 0), 0, (Yes, Yes, No, No), Medial,
           (others => False)),
         16#E5#           =>  --  FEE5
          (((0, 0), (4974, 4974)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (others => False)),
         16#E6#           =>  --  FEE6
          (((0, 0), (4974, 4974)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (others => False)),
         16#E7#           =>  --  FEE7
          (((0, 0), (4974, 4974)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (others => False)),
         16#E8#           =>  --  FEE8
          (((0, 0), (4974, 4974)), (0, 0), 0, (Yes, Yes, No, No), Medial,
           (others => False)),
         16#E9#           =>  --  FEE9
          (((0, 0), (4986, 4986)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (others => False)),
         16#EA#           =>  --  FEEA
          (((0, 0), (4986, 4986)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (others => False)),
         16#EB#           =>  --  FEEB
          (((0, 0), (4986, 4986)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (others => False)),
         16#EC#           =>  --  FEEC
          (((0, 0), (4986, 4986)), (0, 0), 0, (Yes, Yes, No, No), Medial,
           (others => False)),
         16#ED#           =>  --  FEED
          (((0, 0), (768, 768)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (others => False)),
         16#EE#           =>  --  FEEE
          (((0, 0), (768, 768)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (others => False)),
         16#EF#           =>  --  FEEF
          (((0, 0), (4807, 4807)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (others => False)),
         16#F0#           =>  --  FEF0
          (((0, 0), (4807, 4807)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (others => False)),
         16#F1#           =>  --  FEF1
          (((0, 0), (772, 772)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (others => False)),
         16#F2#           =>  --  FEF2
          (((0, 0), (772, 772)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (others => False)),
         16#F3#           =>  --  FEF3
          (((0, 0), (772, 772)), (0, 0), 0, (Yes, Yes, No, No), Initial,
           (others => False)),
         16#F4#           =>  --  FEF4
          (((0, 0), (772, 772)), (0, 0), 0, (Yes, Yes, No, No), Medial,
           (others => False)),
         16#F5#           =>  --  FEF5
          (((0, 0), (5526, 5528)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#F6#           =>  --  FEF6
          (((0, 0), (5526, 5528)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#F7#           =>  --  FEF7
          (((0, 0), (5529, 5531)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#F8#           =>  --  FEF8
          (((0, 0), (5529, 5531)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#F9#           =>  --  FEF9
          (((0, 0), (5532, 5534)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#FA#           =>  --  FEFA
          (((0, 0), (5532, 5534)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         16#FB#           =>  --  FEFB
          (((0, 0), (5476, 5477)), (0, 0), 0, (Yes, Yes, No, No), Isolated,
           (Expands_On_NFKD => True,
            others => False)),
         16#FC#           =>  --  FEFC
          (((0, 0), (5476, 5477)), (0, 0), 0, (Yes, Yes, No, No), Final,
           (Expands_On_NFKD => True,
            others => False)),
         others           =>
          (((0, 0), (0, 0)), (0, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)));

   Group_00FF : aliased constant Normalization_Mapping_Second_Stage
     := (16#01#           =>  --  FF01
          (((0, 0), (2228, 2228)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#02#           =>  --  FF02
          (((0, 0), (5535, 5535)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#03#           =>  --  FF03
          (((0, 0), (5506, 5506)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#04#           =>  --  FF04
          (((0, 0), (5511, 5511)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#05#           =>  --  FF05
          (((0, 0), (5512, 5512)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#06#           =>  --  FF06
          (((0, 0), (5507, 5507)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#07#           =>  --  FF07
          (((0, 0), (5536, 5536)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#08#           =>  --  FF08
          (((0, 0), (2247, 2247)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#09#           =>  --  FF09
          (((0, 0), (2248, 2248)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#0A#           =>  --  FF0A
          (((0, 0), (5508, 5508)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#0B#           =>  --  FF0B
          (((0, 0), (2244, 2244)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#0C#           =>  --  FF0C
          (((0, 0), (5484, 5484)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#0D#           =>  --  FF0D
          (((0, 0), (5509, 5509)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#0E#           =>  --  FF0E
          (((0, 0), (2215, 2215)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#0F#           =>  --  FF0F
          (((0, 0), (2252, 2252)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#10#           =>  --  FF10
          (((0, 0), (2238, 2238)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#11#           =>  --  FF11
          (((0, 0), (14, 14)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#12#           =>  --  FF12
          (((0, 0), (7, 7)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#13#           =>  --  FF13
          (((0, 0), (8, 8)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#14#           =>  --  FF14
          (((0, 0), (18, 18)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#15#           =>  --  FF15
          (((0, 0), (2239, 2239)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#16#           =>  --  FF16
          (((0, 0), (2240, 2240)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#17#           =>  --  FF17
          (((0, 0), (2241, 2241)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#18#           =>  --  FF18
          (((0, 0), (2242, 2242)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#19#           =>  --  FF19
          (((0, 0), (2243, 2243)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#1A#           =>  --  FF1A
          (((0, 0), (2704, 2704)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#1B#           =>  --  FF1B
          (((0, 0), (601, 601)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#1C#           =>  --  FF1C
          (((0, 0), (2430, 2430)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#1D#           =>  --  FF1D
          (((0, 0), (2246, 2246)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#1E#           =>  --  FF1E
          (((0, 0), (2432, 2432)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#1F#           =>  --  FF1F
          (((0, 0), (2232, 2232)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#20#           =>  --  FF20
          (((0, 0), (5513, 5513)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#21#           =>  --  FF21
          (((0, 0), (25, 25)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#22#           =>  --  FF22
          (((0, 0), (950, 950)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#23#           =>  --  FF23
          (((0, 0), (37, 37)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#24#           =>  --  FF24
          (((0, 0), (159, 159)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#25#           =>  --  FF25
          (((0, 0), (39, 39)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#26#           =>  --  FF26
          (((0, 0), (1076, 1076)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#27#           =>  --  FF27
          (((0, 0), (183, 183)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#28#           =>  --  FF28
          (((0, 0), (199, 199)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#29#           =>  --  FF29
          (((0, 0), (47, 47)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#2A#           =>  --  FF2A
          (((0, 0), (222, 222)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#2B#           =>  --  FF2B
          (((0, 0), (229, 229)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#2C#           =>  --  FF2C
          (((0, 0), (233, 233)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#2D#           =>  --  FF2D
          (((0, 0), (952, 952)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#2E#           =>  --  FF2E
          (((0, 0), (55, 55)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#2F#           =>  --  FF2F
          (((0, 0), (57, 57)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#30#           =>  --  FF30
          (((0, 0), (954, 954)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#31#           =>  --  FF31
          (((0, 0), (2271, 2271)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#32#           =>  --  FF32
          (((0, 0), (275, 275)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#33#           =>  --  FF33
          (((0, 0), (287, 287)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#34#           =>  --  FF34
          (((0, 0), (303, 303)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#35#           =>  --  FF35
          (((0, 0), (67, 67)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#36#           =>  --  FF36
          (((0, 0), (1288, 1288)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#37#           =>  --  FF37
          (((0, 0), (335, 335)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#38#           =>  --  FF38
          (((0, 0), (1316, 1316)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#39#           =>  --  FF39
          (((0, 0), (75, 75)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#3A#           =>  --  FF3A
          (((0, 0), (345, 345)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#3B#           =>  --  FF3B
          (((0, 0), (5504, 5504)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#3C#           =>  --  FF3C
          (((0, 0), (5510, 5510)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#3D#           =>  --  FF3D
          (((0, 0), (5505, 5505)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#3E#           =>  --  FF3E
          (((0, 0), (5537, 5537)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#3F#           =>  --  FF3F
          (((0, 0), (5491, 5491)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#40#           =>  --  FF40
          (((0, 0), (2189, 2189)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#41#           =>  --  FF41
          (((0, 0), (4, 4)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#42#           =>  --  FF42
          (((0, 0), (958, 958)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#43#           =>  --  FF43
          (((0, 0), (89, 89)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#44#           =>  --  FF44
          (((0, 0), (161, 161)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#45#           =>  --  FF45
          (((0, 0), (91, 91)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#46#           =>  --  FF46
          (((0, 0), (979, 979)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#47#           =>  --  FF47
          (((0, 0), (185, 185)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#48#           =>  --  FF48
          (((0, 0), (201, 201)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#49#           =>  --  FF49
          (((0, 0), (99, 99)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#4A#           =>  --  FF4A
          (((0, 0), (224, 224)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#4B#           =>  --  FF4B
          (((0, 0), (231, 231)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#4C#           =>  --  FF4C
          (((0, 0), (235, 235)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#4D#           =>  --  FF4D
          (((0, 0), (962, 962)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#4E#           =>  --  FF4E
          (((0, 0), (107, 107)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#4F#           =>  --  FF4F
          (((0, 0), (15, 15)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#50#           =>  --  FF50
          (((0, 0), (967, 967)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#51#           =>  --  FF51
          (((0, 0), (2675, 2675)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#52#           =>  --  FF52
          (((0, 0), (277, 277)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#53#           =>  --  FF53
          (((0, 0), (289, 289)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#54#           =>  --  FF54
          (((0, 0), (305, 305)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#55#           =>  --  FF55
          (((0, 0), (119, 119)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#56#           =>  --  FF56
          (((0, 0), (970, 970)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#57#           =>  --  FF57
          (((0, 0), (337, 337)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#58#           =>  --  FF58
          (((0, 0), (595, 595)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#59#           =>  --  FF59
          (((0, 0), (127, 127)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#5A#           =>  --  FF5A
          (((0, 0), (347, 347)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#5B#           =>  --  FF5B
          (((0, 0), (5492, 5492)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#5C#           =>  --  FF5C
          (((0, 0), (5538, 5538)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#5D#           =>  --  FF5D
          (((0, 0), (5493, 5493)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#5E#           =>  --  FF5E
          (((0, 0), (5539, 5539)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#5F#           =>  --  FF5F
          (((0, 0), (5540, 5540)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#60#           =>  --  FF60
          (((0, 0), (5541, 5541)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#61#           =>  --  FF61
          (((0, 0), (5486, 5486)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#62#           =>  --  FF62
          (((0, 0), (5500, 5500)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#63#           =>  --  FF63
          (((0, 0), (5501, 5501)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#64#           =>  --  FF64
          (((0, 0), (5485, 5485)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#65#           =>  --  FF65
          (((0, 0), (5542, 5542)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#66#           =>  --  FF66
          (((0, 0), (3049, 3049)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#67#           =>  --  FF67
          (((0, 0), (3526, 3526)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#68#           =>  --  FF68
          (((0, 0), (3720, 3720)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#69#           =>  --  FF69
          (((0, 0), (5543, 5543)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#6A#           =>  --  FF6A
          (((0, 0), (3727, 3727)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#6B#           =>  --  FF6B
          (((0, 0), (3544, 3544)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#6C#           =>  --  FF6C
          (((0, 0), (5544, 5544)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#6D#           =>  --  FF6D
          (((0, 0), (3590, 3590)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#6E#           =>  --  FF6E
          (((0, 0), (3798, 3798)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#6F#           =>  --  FF6F
          (((0, 0), (3567, 3567)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#70#           =>  --  FF70
          (((0, 0), (3521, 3521)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#71#           =>  --  FF71
          (((0, 0), (3496, 3496)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#72#           =>  --  FF72
          (((0, 0), (3497, 3497)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#73#           =>  --  FF73
          (((0, 0), (3041, 3041)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#74#           =>  --  FF74
          (((0, 0), (3498, 3498)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#75#           =>  --  FF75
          (((0, 0), (3499, 3499)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#76#           =>  --  FF76
          (((0, 0), (2991, 2991)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#77#           =>  --  FF77
          (((0, 0), (2993, 2993)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#78#           =>  --  FF78
          (((0, 0), (2995, 2995)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#79#           =>  --  FF79
          (((0, 0), (2997, 2997)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#7A#           =>  --  FF7A
          (((0, 0), (2999, 2999)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#7B#           =>  --  FF7B
          (((0, 0), (3001, 3001)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#7C#           =>  --  FF7C
          (((0, 0), (3003, 3003)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#7D#           =>  --  FF7D
          (((0, 0), (3005, 3005)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#7E#           =>  --  FF7E
          (((0, 0), (3007, 3007)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#7F#           =>  --  FF7F
          (((0, 0), (3009, 3009)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#80#           =>  --  FF80
          (((0, 0), (3011, 3011)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#81#           =>  --  FF81
          (((0, 0), (3013, 3013)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#82#           =>  --  FF82
          (((0, 0), (3015, 3015)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#83#           =>  --  FF83
          (((0, 0), (3017, 3017)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#84#           =>  --  FF84
          (((0, 0), (3019, 3019)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#85#           =>  --  FF85
          (((0, 0), (3500, 3500)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#86#           =>  --  FF86
          (((0, 0), (3501, 3501)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#87#           =>  --  FF87
          (((0, 0), (3502, 3502)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#88#           =>  --  FF88
          (((0, 0), (3503, 3503)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#89#           =>  --  FF89
          (((0, 0), (3504, 3504)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#8A#           =>  --  FF8A
          (((0, 0), (3021, 3021)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#8B#           =>  --  FF8B
          (((0, 0), (3025, 3025)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#8C#           =>  --  FF8C
          (((0, 0), (3029, 3029)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#8D#           =>  --  FF8D
          (((0, 0), (3033, 3033)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#8E#           =>  --  FF8E
          (((0, 0), (3037, 3037)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#8F#           =>  --  FF8F
          (((0, 0), (3505, 3505)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#90#           =>  --  FF90
          (((0, 0), (3506, 3506)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#91#           =>  --  FF91
          (((0, 0), (3507, 3507)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#92#           =>  --  FF92
          (((0, 0), (3508, 3508)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#93#           =>  --  FF93
          (((0, 0), (3509, 3509)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#94#           =>  --  FF94
          (((0, 0), (3510, 3510)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#95#           =>  --  FF95
          (((0, 0), (3511, 3511)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#96#           =>  --  FF96
          (((0, 0), (3512, 3512)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#97#           =>  --  FF97
          (((0, 0), (3513, 3513)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#98#           =>  --  FF98
          (((0, 0), (3514, 3514)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#99#           =>  --  FF99
          (((0, 0), (3515, 3515)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#9A#           =>  --  FF9A
          (((0, 0), (3516, 3516)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#9B#           =>  --  FF9B
          (((0, 0), (3517, 3517)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#9C#           =>  --  FF9C
          (((0, 0), (3043, 3043)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#9D#           =>  --  FF9D
          (((0, 0), (3528, 3528)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#9E#           =>  --  FF9E
          (((0, 0), (2932, 2932)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#9F#           =>  --  FF9F
          (((0, 0), (2964, 2964)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#A0#           =>  --  FFA0
          (((0, 0), (3106, 3106)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#A1#           =>  --  FFA1
          (((0, 0), (3055, 3055)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#A2#           =>  --  FFA2
          (((0, 0), (3056, 3056)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#A3#           =>  --  FFA3
          (((0, 0), (3057, 3057)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#A4#           =>  --  FFA4
          (((0, 0), (3058, 3058)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#A5#           =>  --  FFA5
          (((0, 0), (3059, 3059)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#A6#           =>  --  FFA6
          (((0, 0), (3060, 3060)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#A7#           =>  --  FFA7
          (((0, 0), (3061, 3061)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#A8#           =>  --  FFA8
          (((0, 0), (3062, 3062)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#A9#           =>  --  FFA9
          (((0, 0), (3063, 3063)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#AA#           =>  --  FFAA
          (((0, 0), (3064, 3064)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#AB#           =>  --  FFAB
          (((0, 0), (3065, 3065)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#AC#           =>  --  FFAC
          (((0, 0), (3066, 3066)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#AD#           =>  --  FFAD
          (((0, 0), (3067, 3067)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#AE#           =>  --  FFAE
          (((0, 0), (3068, 3068)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#AF#           =>  --  FFAF
          (((0, 0), (3069, 3069)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#B0#           =>  --  FFB0
          (((0, 0), (3070, 3070)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#B1#           =>  --  FFB1
          (((0, 0), (3071, 3071)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#B2#           =>  --  FFB2
          (((0, 0), (3072, 3072)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#B3#           =>  --  FFB3
          (((0, 0), (3073, 3073)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#B4#           =>  --  FFB4
          (((0, 0), (3074, 3074)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#B5#           =>  --  FFB5
          (((0, 0), (3075, 3075)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#B6#           =>  --  FFB6
          (((0, 0), (3076, 3076)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#B7#           =>  --  FFB7
          (((0, 0), (3077, 3077)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#B8#           =>  --  FFB8
          (((0, 0), (3078, 3078)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#B9#           =>  --  FFB9
          (((0, 0), (3079, 3079)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#BA#           =>  --  FFBA
          (((0, 0), (3080, 3080)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#BB#           =>  --  FFBB
          (((0, 0), (3081, 3081)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#BC#           =>  --  FFBC
          (((0, 0), (3082, 3082)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#BD#           =>  --  FFBD
          (((0, 0), (3083, 3083)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#BE#           =>  --  FFBE
          (((0, 0), (3084, 3084)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#C2#           =>  --  FFC2
          (((0, 0), (3085, 3085)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#C3#           =>  --  FFC3
          (((0, 0), (3086, 3086)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#C4#           =>  --  FFC4
          (((0, 0), (3087, 3087)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#C5#           =>  --  FFC5
          (((0, 0), (3088, 3088)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#C6#           =>  --  FFC6
          (((0, 0), (3089, 3089)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#C7#           =>  --  FFC7
          (((0, 0), (3090, 3090)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#CA#           =>  --  FFCA
          (((0, 0), (3091, 3091)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#CB#           =>  --  FFCB
          (((0, 0), (3092, 3092)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#CC#           =>  --  FFCC
          (((0, 0), (3093, 3093)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#CD#           =>  --  FFCD
          (((0, 0), (3094, 3094)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#CE#           =>  --  FFCE
          (((0, 0), (3095, 3095)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#CF#           =>  --  FFCF
          (((0, 0), (3096, 3096)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#D2#           =>  --  FFD2
          (((0, 0), (3097, 3097)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#D3#           =>  --  FFD3
          (((0, 0), (3098, 3098)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#D4#           =>  --  FFD4
          (((0, 0), (3099, 3099)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#D5#           =>  --  FFD5
          (((0, 0), (3100, 3100)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#D6#           =>  --  FFD6
          (((0, 0), (3101, 3101)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#D7#           =>  --  FFD7
          (((0, 0), (3102, 3102)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#DA#           =>  --  FFDA
          (((0, 0), (3103, 3103)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#DB#           =>  --  FFDB
          (((0, 0), (3104, 3104)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#DC#           =>  --  FFDC
          (((0, 0), (3105, 3105)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#E0#           =>  --  FFE0
          (((0, 0), (5545, 5545)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#E1#           =>  --  FFE1
          (((0, 0), (5546, 5546)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#E2#           =>  --  FFE2
          (((0, 0), (5547, 5547)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#E3#           =>  --  FFE3
          (((0, 0), (5, 6)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (Expands_On_NFKD => True,
            others => False)),
         16#E4#           =>  --  FFE4
          (((0, 0), (5548, 5548)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#E5#           =>  --  FFE5
          (((0, 0), (5549, 5549)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#E6#           =>  --  FFE6
          (((0, 0), (5550, 5550)), (0, 0), 0, (Yes, Yes, No, No), Wide,
           (others => False)),
         16#E8#           =>  --  FFE8
          (((0, 0), (5551, 5551)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#E9#           =>  --  FFE9
          (((0, 0), (2384, 2384)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#EA#           =>  --  FFEA
          (((0, 0), (5552, 5552)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#EB#           =>  --  FFEB
          (((0, 0), (2386, 2386)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#EC#           =>  --  FFEC
          (((0, 0), (5553, 5553)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#ED#           =>  --  FFED
          (((0, 0), (5554, 5554)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         16#EE#           =>  --  FFEE
          (((0, 0), (5555, 5555)), (0, 0), 0, (Yes, Yes, No, No), Narrow,
           (others => False)),
         others           =>
          (((0, 0), (0, 0)), (0, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)));

   Group_0101 : aliased constant Normalization_Mapping_Second_Stage
     := (16#FD#           =>  --  0101FD
          (((0, 0), (0, 0)), (0, 0), 220, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         others           =>
          (((0, 0), (0, 0)), (0, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)));

   Group_0102 : aliased constant Normalization_Mapping_Second_Stage
     := (16#E0#           =>  --  0102E0
          (((0, 0), (0, 0)), (0, 0), 220, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         others           =>
          (((0, 0), (0, 0)), (0, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)));

   Group_0103 : aliased constant Normalization_Mapping_Second_Stage
     := (16#76# .. 16#7A# =>  --  010376 .. 01037A
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         others           =>
          (((0, 0), (0, 0)), (0, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)));

   Group_010A : aliased constant Normalization_Mapping_Second_Stage
     := (16#0D#           =>  --  010A0D
          (((0, 0), (0, 0)), (0, 0), 220, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#0F#           =>  --  010A0F
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#38#           =>  --  010A38
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#39#           =>  --  010A39
          (((0, 0), (0, 0)), (0, 0), 1, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#3A#           =>  --  010A3A
          (((0, 0), (0, 0)), (0, 0), 220, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#3F#           =>  --  010A3F
          (((0, 0), (0, 0)), (0, 0), 9, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#E5#           =>  --  010AE5
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#E6#           =>  --  010AE6
          (((0, 0), (0, 0)), (0, 0), 220, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         others           =>
          (((0, 0), (0, 0)), (0, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)));

   Group_0110 : aliased constant Normalization_Mapping_Second_Stage
     := (16#46#           =>  --  011046
          (((0, 0), (0, 0)), (0, 0), 9, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#7F#           =>  --  01107F
          (((0, 0), (0, 0)), (0, 0), 9, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#99#           =>  --  011099
          (((0, 0), (0, 0)), (368, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#9A#           =>  --  01109A
          (((5556, 5557), (5556, 5557)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#9B#           =>  --  01109B
          (((0, 0), (0, 0)), (369, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#9C#           =>  --  01109C
          (((5558, 5559), (5558, 5559)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#A5#           =>  --  0110A5
          (((0, 0), (0, 0)), (370, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#AB#           =>  --  0110AB
          (((5560, 5561), (5560, 5561)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#B9#           =>  --  0110B9
          (((0, 0), (0, 0)), (0, 0), 9, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#BA#           =>  --  0110BA
          (((0, 0), (0, 0)), (0, 55), 7, (Maybe, Yes, Maybe, Yes), None,
           (others => False)),
         others           =>
          (((0, 0), (0, 0)), (0, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)));

   Group_0111 : aliased constant Normalization_Mapping_Second_Stage
     := (16#00# .. 16#02# =>  --  011100 .. 011102
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#27#           =>  --  011127
          (((0, 0), (0, 0)), (0, 56), 0, (Maybe, Yes, Maybe, Yes), None,
           (others => False)),
         16#2E#           =>  --  01112E
          (((5562, 5563), (5562, 5563)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#2F#           =>  --  01112F
          (((5564, 5565), (5564, 5565)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#31#           =>  --  011131
          (((0, 0), (0, 0)), (371, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#32#           =>  --  011132
          (((0, 0), (0, 0)), (372, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#33# .. 16#34# =>  --  011133 .. 011134
          (((0, 0), (0, 0)), (0, 0), 9, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#73#           =>  --  011173
          (((0, 0), (0, 0)), (0, 0), 7, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#C0#           =>  --  0111C0
          (((0, 0), (0, 0)), (0, 0), 9, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         others           =>
          (((0, 0), (0, 0)), (0, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)));

   Group_0112 : aliased constant Normalization_Mapping_Second_Stage
     := (16#35#           =>  --  011235
          (((0, 0), (0, 0)), (0, 0), 9, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#36#           =>  --  011236
          (((0, 0), (0, 0)), (0, 0), 7, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#E9#           =>  --  0112E9
          (((0, 0), (0, 0)), (0, 0), 7, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#EA#           =>  --  0112EA
          (((0, 0), (0, 0)), (0, 0), 9, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         others           =>
          (((0, 0), (0, 0)), (0, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)));

   Group_0113 : aliased constant Normalization_Mapping_Second_Stage
     := (16#3C#           =>  --  01133C
          (((0, 0), (0, 0)), (0, 0), 7, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#3E#           =>  --  01133E
          (((0, 0), (0, 0)), (0, 57), 0, (Maybe, Yes, Maybe, Yes), None,
           (others => False)),
         16#47#           =>  --  011347
          (((0, 0), (0, 0)), (373, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#4B#           =>  --  01134B
          (((5566, 5567), (5566, 5567)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#4C#           =>  --  01134C
          (((5568, 5569), (5568, 5569)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#4D#           =>  --  01134D
          (((0, 0), (0, 0)), (0, 0), 9, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#57#           =>  --  011357
          (((0, 0), (0, 0)), (0, 58), 0, (Maybe, Yes, Maybe, Yes), None,
           (others => False)),
         16#66# .. 16#6C# =>  --  011366 .. 01136C
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#70# .. 16#74# =>  --  011370 .. 011374
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         others           =>
          (((0, 0), (0, 0)), (0, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)));

   Group_0114 : aliased constant Normalization_Mapping_Second_Stage
     := (16#B0#           =>  --  0114B0
          (((0, 0), (0, 0)), (0, 60), 0, (Maybe, Yes, Maybe, Yes), None,
           (others => False)),
         16#B9#           =>  --  0114B9
          (((0, 0), (0, 0)), (374, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#BA#           =>  --  0114BA
          (((0, 0), (0, 0)), (0, 59), 0, (Maybe, Yes, Maybe, Yes), None,
           (others => False)),
         16#BB#           =>  --  0114BB
          (((5570, 5571), (5570, 5571)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#BC#           =>  --  0114BC
          (((5572, 5573), (5572, 5573)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#BD#           =>  --  0114BD
          (((0, 0), (0, 0)), (0, 61), 0, (Maybe, Yes, Maybe, Yes), None,
           (others => False)),
         16#BE#           =>  --  0114BE
          (((5574, 5575), (5574, 5575)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#C2#           =>  --  0114C2
          (((0, 0), (0, 0)), (0, 0), 9, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#C3#           =>  --  0114C3
          (((0, 0), (0, 0)), (0, 0), 7, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         others           =>
          (((0, 0), (0, 0)), (0, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)));

   Group_0115 : aliased constant Normalization_Mapping_Second_Stage
     := (16#AF#           =>  --  0115AF
          (((0, 0), (0, 0)), (0, 62), 0, (Maybe, Yes, Maybe, Yes), None,
           (others => False)),
         16#B8#           =>  --  0115B8
          (((0, 0), (0, 0)), (375, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#B9#           =>  --  0115B9
          (((0, 0), (0, 0)), (376, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#BA#           =>  --  0115BA
          (((5576, 5577), (5576, 5577)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#BB#           =>  --  0115BB
          (((5578, 5579), (5578, 5579)), (0, 0), 0, (Yes, No, Yes, No), Canonical,
           (Expands_On_NFD
              | Expands_On_NFKD => True,
            others => False)),
         16#BF#           =>  --  0115BF
          (((0, 0), (0, 0)), (0, 0), 9, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#C0#           =>  --  0115C0
          (((0, 0), (0, 0)), (0, 0), 7, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         others           =>
          (((0, 0), (0, 0)), (0, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)));

   Group_0116 : aliased constant Normalization_Mapping_Second_Stage
     := (16#3F#           =>  --  01163F
          (((0, 0), (0, 0)), (0, 0), 9, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#B6#           =>  --  0116B6
          (((0, 0), (0, 0)), (0, 0), 9, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#B7#           =>  --  0116B7
          (((0, 0), (0, 0)), (0, 0), 7, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         others           =>
          (((0, 0), (0, 0)), (0, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)));

   Group_016A : aliased constant Normalization_Mapping_Second_Stage
     := (16#F0# .. 16#F4# =>  --  016AF0 .. 016AF4
          (((0, 0), (0, 0)), (0, 0), 1, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         others           =>
          (((0, 0), (0, 0)), (0, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)));

   Group_016B : aliased constant Normalization_Mapping_Second_Stage
     := (16#30# .. 16#36# =>  --  016B30 .. 016B36
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         others           =>
          (((0, 0), (0, 0)), (0, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)));

   Group_01BC : aliased constant Normalization_Mapping_Second_Stage
     := (16#9E#           =>  --  01BC9E
          (((0, 0), (0, 0)), (0, 0), 1, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         others           =>
          (((0, 0), (0, 0)), (0, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)));

   Group_01D1 : aliased constant Normalization_Mapping_Second_Stage
     := (16#5E#           =>  --  01D15E
          (((5580, 5581), (5580, 5581)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFKC => False,
            others => True)),
         16#5F#           =>  --  01D15F
          (((5582, 5583), (5582, 5583)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFKC => False,
            others => True)),
         16#60#           =>  --  01D160
          (((5584, 5586), (5584, 5586)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFKC => False,
            others => True)),
         16#61#           =>  --  01D161
          (((5587, 5589), (5587, 5589)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFKC => False,
            others => True)),
         16#62#           =>  --  01D162
          (((5590, 5592), (5590, 5592)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFKC => False,
            others => True)),
         16#63#           =>  --  01D163
          (((5593, 5595), (5593, 5595)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFKC => False,
            others => True)),
         16#64#           =>  --  01D164
          (((5596, 5598), (5596, 5598)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFKC => False,
            others => True)),
         16#65# .. 16#66# =>  --  01D165 .. 01D166
          (((0, 0), (0, 0)), (0, 0), 216, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#67# .. 16#69# =>  --  01D167 .. 01D169
          (((0, 0), (0, 0)), (0, 0), 1, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#6D#           =>  --  01D16D
          (((0, 0), (0, 0)), (0, 0), 226, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#6E# .. 16#72# =>  --  01D16E .. 01D172
          (((0, 0), (0, 0)), (0, 0), 216, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#7B# .. 16#82# =>  --  01D17B .. 01D182
          (((0, 0), (0, 0)), (0, 0), 220, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#85# .. 16#89# =>  --  01D185 .. 01D189
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#8A# .. 16#8B# =>  --  01D18A .. 01D18B
          (((0, 0), (0, 0)), (0, 0), 220, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#AA# .. 16#AD# =>  --  01D1AA .. 01D1AD
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#BB#           =>  --  01D1BB
          (((5599, 5600), (5599, 5600)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFKC => False,
            others => True)),
         16#BC#           =>  --  01D1BC
          (((5601, 5602), (5601, 5602)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFKC => False,
            others => True)),
         16#BD#           =>  --  01D1BD
          (((5603, 5605), (5603, 5605)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFKC => False,
            others => True)),
         16#BE#           =>  --  01D1BE
          (((5606, 5608), (5606, 5608)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFKC => False,
            others => True)),
         16#BF#           =>  --  01D1BF
          (((5609, 5611), (5609, 5611)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFKC => False,
            others => True)),
         16#C0#           =>  --  01D1C0
          (((5612, 5614), (5612, 5614)), (0, 0), 0, (No, No, No, No), Canonical,
           (Expands_On_NFKC => False,
            others => True)),
         others           =>
          (((0, 0), (0, 0)), (0, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)));

   Group_01D2 : aliased constant Normalization_Mapping_Second_Stage
     := (16#42# .. 16#44# =>  --  01D242 .. 01D244
          (((0, 0), (0, 0)), (0, 0), 230, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         others           =>
          (((0, 0), (0, 0)), (0, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)));

   Group_01D4 : aliased constant Normalization_Mapping_Second_Stage
     := (16#00#           =>  --  01D400
          (((0, 0), (25, 25)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#01#           =>  --  01D401
          (((0, 0), (950, 950)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#02#           =>  --  01D402
          (((0, 0), (37, 37)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#03#           =>  --  01D403
          (((0, 0), (159, 159)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#04#           =>  --  01D404
          (((0, 0), (39, 39)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#05#           =>  --  01D405
          (((0, 0), (1076, 1076)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#06#           =>  --  01D406
          (((0, 0), (183, 183)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#07#           =>  --  01D407
          (((0, 0), (199, 199)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#08#           =>  --  01D408
          (((0, 0), (47, 47)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#09#           =>  --  01D409
          (((0, 0), (222, 222)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#0A#           =>  --  01D40A
          (((0, 0), (229, 229)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#0B#           =>  --  01D40B
          (((0, 0), (233, 233)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#0C#           =>  --  01D40C
          (((0, 0), (952, 952)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#0D#           =>  --  01D40D
          (((0, 0), (55, 55)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#0E#           =>  --  01D40E
          (((0, 0), (57, 57)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#0F#           =>  --  01D40F
          (((0, 0), (954, 954)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#10#           =>  --  01D410
          (((0, 0), (2271, 2271)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#11#           =>  --  01D411
          (((0, 0), (275, 275)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#12#           =>  --  01D412
          (((0, 0), (287, 287)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#13#           =>  --  01D413
          (((0, 0), (303, 303)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#14#           =>  --  01D414
          (((0, 0), (67, 67)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#15#           =>  --  01D415
          (((0, 0), (1288, 1288)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#16#           =>  --  01D416
          (((0, 0), (335, 335)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#17#           =>  --  01D417
          (((0, 0), (1316, 1316)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#18#           =>  --  01D418
          (((0, 0), (75, 75)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#19#           =>  --  01D419
          (((0, 0), (345, 345)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#1A#           =>  --  01D41A
          (((0, 0), (4, 4)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#1B#           =>  --  01D41B
          (((0, 0), (958, 958)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#1C#           =>  --  01D41C
          (((0, 0), (89, 89)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#1D#           =>  --  01D41D
          (((0, 0), (161, 161)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#1E#           =>  --  01D41E
          (((0, 0), (91, 91)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#1F#           =>  --  01D41F
          (((0, 0), (979, 979)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#20#           =>  --  01D420
          (((0, 0), (185, 185)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#21#           =>  --  01D421
          (((0, 0), (201, 201)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#22#           =>  --  01D422
          (((0, 0), (99, 99)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#23#           =>  --  01D423
          (((0, 0), (224, 224)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#24#           =>  --  01D424
          (((0, 0), (231, 231)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#25#           =>  --  01D425
          (((0, 0), (235, 235)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#26#           =>  --  01D426
          (((0, 0), (962, 962)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#27#           =>  --  01D427
          (((0, 0), (107, 107)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#28#           =>  --  01D428
          (((0, 0), (15, 15)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#29#           =>  --  01D429
          (((0, 0), (967, 967)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#2A#           =>  --  01D42A
          (((0, 0), (2675, 2675)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#2B#           =>  --  01D42B
          (((0, 0), (277, 277)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#2C#           =>  --  01D42C
          (((0, 0), (289, 289)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#2D#           =>  --  01D42D
          (((0, 0), (305, 305)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#2E#           =>  --  01D42E
          (((0, 0), (119, 119)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#2F#           =>  --  01D42F
          (((0, 0), (970, 970)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#30#           =>  --  01D430
          (((0, 0), (337, 337)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#31#           =>  --  01D431
          (((0, 0), (595, 595)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#32#           =>  --  01D432
          (((0, 0), (127, 127)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#33#           =>  --  01D433
          (((0, 0), (347, 347)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#34#           =>  --  01D434
          (((0, 0), (25, 25)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#35#           =>  --  01D435
          (((0, 0), (950, 950)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#36#           =>  --  01D436
          (((0, 0), (37, 37)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#37#           =>  --  01D437
          (((0, 0), (159, 159)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#38#           =>  --  01D438
          (((0, 0), (39, 39)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#39#           =>  --  01D439
          (((0, 0), (1076, 1076)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#3A#           =>  --  01D43A
          (((0, 0), (183, 183)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#3B#           =>  --  01D43B
          (((0, 0), (199, 199)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#3C#           =>  --  01D43C
          (((0, 0), (47, 47)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#3D#           =>  --  01D43D
          (((0, 0), (222, 222)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#3E#           =>  --  01D43E
          (((0, 0), (229, 229)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#3F#           =>  --  01D43F
          (((0, 0), (233, 233)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#40#           =>  --  01D440
          (((0, 0), (952, 952)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#41#           =>  --  01D441
          (((0, 0), (55, 55)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#42#           =>  --  01D442
          (((0, 0), (57, 57)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#43#           =>  --  01D443
          (((0, 0), (954, 954)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#44#           =>  --  01D444
          (((0, 0), (2271, 2271)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#45#           =>  --  01D445
          (((0, 0), (275, 275)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#46#           =>  --  01D446
          (((0, 0), (287, 287)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#47#           =>  --  01D447
          (((0, 0), (303, 303)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#48#           =>  --  01D448
          (((0, 0), (67, 67)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#49#           =>  --  01D449
          (((0, 0), (1288, 1288)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#4A#           =>  --  01D44A
          (((0, 0), (335, 335)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#4B#           =>  --  01D44B
          (((0, 0), (1316, 1316)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#4C#           =>  --  01D44C
          (((0, 0), (75, 75)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#4D#           =>  --  01D44D
          (((0, 0), (345, 345)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#4E#           =>  --  01D44E
          (((0, 0), (4, 4)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#4F#           =>  --  01D44F
          (((0, 0), (958, 958)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#50#           =>  --  01D450
          (((0, 0), (89, 89)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#51#           =>  --  01D451
          (((0, 0), (161, 161)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#52#           =>  --  01D452
          (((0, 0), (91, 91)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#53#           =>  --  01D453
          (((0, 0), (979, 979)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#54#           =>  --  01D454
          (((0, 0), (185, 185)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#56#           =>  --  01D456
          (((0, 0), (99, 99)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#57#           =>  --  01D457
          (((0, 0), (224, 224)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#58#           =>  --  01D458
          (((0, 0), (231, 231)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#59#           =>  --  01D459
          (((0, 0), (235, 235)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#5A#           =>  --  01D45A
          (((0, 0), (962, 962)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#5B#           =>  --  01D45B
          (((0, 0), (107, 107)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#5C#           =>  --  01D45C
          (((0, 0), (15, 15)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#5D#           =>  --  01D45D
          (((0, 0), (967, 967)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#5E#           =>  --  01D45E
          (((0, 0), (2675, 2675)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#5F#           =>  --  01D45F
          (((0, 0), (277, 277)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#60#           =>  --  01D460
          (((0, 0), (289, 289)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#61#           =>  --  01D461
          (((0, 0), (305, 305)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#62#           =>  --  01D462
          (((0, 0), (119, 119)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#63#           =>  --  01D463
          (((0, 0), (970, 970)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#64#           =>  --  01D464
          (((0, 0), (337, 337)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#65#           =>  --  01D465
          (((0, 0), (595, 595)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#66#           =>  --  01D466
          (((0, 0), (127, 127)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#67#           =>  --  01D467
          (((0, 0), (347, 347)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#68#           =>  --  01D468
          (((0, 0), (25, 25)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#69#           =>  --  01D469
          (((0, 0), (950, 950)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#6A#           =>  --  01D46A
          (((0, 0), (37, 37)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#6B#           =>  --  01D46B
          (((0, 0), (159, 159)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#6C#           =>  --  01D46C
          (((0, 0), (39, 39)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#6D#           =>  --  01D46D
          (((0, 0), (1076, 1076)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#6E#           =>  --  01D46E
          (((0, 0), (183, 183)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#6F#           =>  --  01D46F
          (((0, 0), (199, 199)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#70#           =>  --  01D470
          (((0, 0), (47, 47)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#71#           =>  --  01D471
          (((0, 0), (222, 222)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#72#           =>  --  01D472
          (((0, 0), (229, 229)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#73#           =>  --  01D473
          (((0, 0), (233, 233)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#74#           =>  --  01D474
          (((0, 0), (952, 952)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#75#           =>  --  01D475
          (((0, 0), (55, 55)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#76#           =>  --  01D476
          (((0, 0), (57, 57)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#77#           =>  --  01D477
          (((0, 0), (954, 954)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#78#           =>  --  01D478
          (((0, 0), (2271, 2271)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#79#           =>  --  01D479
          (((0, 0), (275, 275)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#7A#           =>  --  01D47A
          (((0, 0), (287, 287)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#7B#           =>  --  01D47B
          (((0, 0), (303, 303)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#7C#           =>  --  01D47C
          (((0, 0), (67, 67)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#7D#           =>  --  01D47D
          (((0, 0), (1288, 1288)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#7E#           =>  --  01D47E
          (((0, 0), (335, 335)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#7F#           =>  --  01D47F
          (((0, 0), (1316, 1316)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#80#           =>  --  01D480
          (((0, 0), (75, 75)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#81#           =>  --  01D481
          (((0, 0), (345, 345)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#82#           =>  --  01D482
          (((0, 0), (4, 4)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#83#           =>  --  01D483
          (((0, 0), (958, 958)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#84#           =>  --  01D484
          (((0, 0), (89, 89)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#85#           =>  --  01D485
          (((0, 0), (161, 161)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#86#           =>  --  01D486
          (((0, 0), (91, 91)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#87#           =>  --  01D487
          (((0, 0), (979, 979)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#88#           =>  --  01D488
          (((0, 0), (185, 185)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#89#           =>  --  01D489
          (((0, 0), (201, 201)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#8A#           =>  --  01D48A
          (((0, 0), (99, 99)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#8B#           =>  --  01D48B
          (((0, 0), (224, 224)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#8C#           =>  --  01D48C
          (((0, 0), (231, 231)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#8D#           =>  --  01D48D
          (((0, 0), (235, 235)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#8E#           =>  --  01D48E
          (((0, 0), (962, 962)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#8F#           =>  --  01D48F
          (((0, 0), (107, 107)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#90#           =>  --  01D490
          (((0, 0), (15, 15)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#91#           =>  --  01D491
          (((0, 0), (967, 967)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#92#           =>  --  01D492
          (((0, 0), (2675, 2675)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#93#           =>  --  01D493
          (((0, 0), (277, 277)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#94#           =>  --  01D494
          (((0, 0), (289, 289)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#95#           =>  --  01D495
          (((0, 0), (305, 305)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#96#           =>  --  01D496
          (((0, 0), (119, 119)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#97#           =>  --  01D497
          (((0, 0), (970, 970)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#98#           =>  --  01D498
          (((0, 0), (337, 337)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#99#           =>  --  01D499
          (((0, 0), (595, 595)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#9A#           =>  --  01D49A
          (((0, 0), (127, 127)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#9B#           =>  --  01D49B
          (((0, 0), (347, 347)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#9C#           =>  --  01D49C
          (((0, 0), (25, 25)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#9E#           =>  --  01D49E
          (((0, 0), (37, 37)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#9F#           =>  --  01D49F
          (((0, 0), (159, 159)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#A2#           =>  --  01D4A2
          (((0, 0), (183, 183)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#A5#           =>  --  01D4A5
          (((0, 0), (222, 222)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#A6#           =>  --  01D4A6
          (((0, 0), (229, 229)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#A9#           =>  --  01D4A9
          (((0, 0), (55, 55)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#AA#           =>  --  01D4AA
          (((0, 0), (57, 57)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#AB#           =>  --  01D4AB
          (((0, 0), (954, 954)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#AC#           =>  --  01D4AC
          (((0, 0), (2271, 2271)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#AE#           =>  --  01D4AE
          (((0, 0), (287, 287)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#AF#           =>  --  01D4AF
          (((0, 0), (303, 303)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#B0#           =>  --  01D4B0
          (((0, 0), (67, 67)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#B1#           =>  --  01D4B1
          (((0, 0), (1288, 1288)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#B2#           =>  --  01D4B2
          (((0, 0), (335, 335)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#B3#           =>  --  01D4B3
          (((0, 0), (1316, 1316)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#B4#           =>  --  01D4B4
          (((0, 0), (75, 75)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#B5#           =>  --  01D4B5
          (((0, 0), (345, 345)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#B6#           =>  --  01D4B6
          (((0, 0), (4, 4)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#B7#           =>  --  01D4B7
          (((0, 0), (958, 958)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#B8#           =>  --  01D4B8
          (((0, 0), (89, 89)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#B9#           =>  --  01D4B9
          (((0, 0), (161, 161)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#BB#           =>  --  01D4BB
          (((0, 0), (979, 979)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#BD#           =>  --  01D4BD
          (((0, 0), (201, 201)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#BE#           =>  --  01D4BE
          (((0, 0), (99, 99)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#BF#           =>  --  01D4BF
          (((0, 0), (224, 224)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#C0#           =>  --  01D4C0
          (((0, 0), (231, 231)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#C1#           =>  --  01D4C1
          (((0, 0), (235, 235)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#C2#           =>  --  01D4C2
          (((0, 0), (962, 962)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#C3#           =>  --  01D4C3
          (((0, 0), (107, 107)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#C5#           =>  --  01D4C5
          (((0, 0), (967, 967)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#C6#           =>  --  01D4C6
          (((0, 0), (2675, 2675)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#C7#           =>  --  01D4C7
          (((0, 0), (277, 277)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#C8#           =>  --  01D4C8
          (((0, 0), (289, 289)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#C9#           =>  --  01D4C9
          (((0, 0), (305, 305)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#CA#           =>  --  01D4CA
          (((0, 0), (119, 119)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#CB#           =>  --  01D4CB
          (((0, 0), (970, 970)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#CC#           =>  --  01D4CC
          (((0, 0), (337, 337)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#CD#           =>  --  01D4CD
          (((0, 0), (595, 595)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#CE#           =>  --  01D4CE
          (((0, 0), (127, 127)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#CF#           =>  --  01D4CF
          (((0, 0), (347, 347)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#D0#           =>  --  01D4D0
          (((0, 0), (25, 25)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#D1#           =>  --  01D4D1
          (((0, 0), (950, 950)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#D2#           =>  --  01D4D2
          (((0, 0), (37, 37)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#D3#           =>  --  01D4D3
          (((0, 0), (159, 159)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#D4#           =>  --  01D4D4
          (((0, 0), (39, 39)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#D5#           =>  --  01D4D5
          (((0, 0), (1076, 1076)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#D6#           =>  --  01D4D6
          (((0, 0), (183, 183)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#D7#           =>  --  01D4D7
          (((0, 0), (199, 199)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#D8#           =>  --  01D4D8
          (((0, 0), (47, 47)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#D9#           =>  --  01D4D9
          (((0, 0), (222, 222)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#DA#           =>  --  01D4DA
          (((0, 0), (229, 229)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#DB#           =>  --  01D4DB
          (((0, 0), (233, 233)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#DC#           =>  --  01D4DC
          (((0, 0), (952, 952)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#DD#           =>  --  01D4DD
          (((0, 0), (55, 55)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#DE#           =>  --  01D4DE
          (((0, 0), (57, 57)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#DF#           =>  --  01D4DF
          (((0, 0), (954, 954)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#E0#           =>  --  01D4E0
          (((0, 0), (2271, 2271)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#E1#           =>  --  01D4E1
          (((0, 0), (275, 275)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#E2#           =>  --  01D4E2
          (((0, 0), (287, 287)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#E3#           =>  --  01D4E3
          (((0, 0), (303, 303)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#E4#           =>  --  01D4E4
          (((0, 0), (67, 67)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#E5#           =>  --  01D4E5
          (((0, 0), (1288, 1288)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#E6#           =>  --  01D4E6
          (((0, 0), (335, 335)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#E7#           =>  --  01D4E7
          (((0, 0), (1316, 1316)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#E8#           =>  --  01D4E8
          (((0, 0), (75, 75)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#E9#           =>  --  01D4E9
          (((0, 0), (345, 345)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#EA#           =>  --  01D4EA
          (((0, 0), (4, 4)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#EB#           =>  --  01D4EB
          (((0, 0), (958, 958)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#EC#           =>  --  01D4EC
          (((0, 0), (89, 89)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#ED#           =>  --  01D4ED
          (((0, 0), (161, 161)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#EE#           =>  --  01D4EE
          (((0, 0), (91, 91)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#EF#           =>  --  01D4EF
          (((0, 0), (979, 979)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#F0#           =>  --  01D4F0
          (((0, 0), (185, 185)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#F1#           =>  --  01D4F1
          (((0, 0), (201, 201)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#F2#           =>  --  01D4F2
          (((0, 0), (99, 99)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#F3#           =>  --  01D4F3
          (((0, 0), (224, 224)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#F4#           =>  --  01D4F4
          (((0, 0), (231, 231)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#F5#           =>  --  01D4F5
          (((0, 0), (235, 235)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#F6#           =>  --  01D4F6
          (((0, 0), (962, 962)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#F7#           =>  --  01D4F7
          (((0, 0), (107, 107)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#F8#           =>  --  01D4F8
          (((0, 0), (15, 15)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#F9#           =>  --  01D4F9
          (((0, 0), (967, 967)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#FA#           =>  --  01D4FA
          (((0, 0), (2675, 2675)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#FB#           =>  --  01D4FB
          (((0, 0), (277, 277)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#FC#           =>  --  01D4FC
          (((0, 0), (289, 289)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#FD#           =>  --  01D4FD
          (((0, 0), (305, 305)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#FE#           =>  --  01D4FE
          (((0, 0), (119, 119)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#FF#           =>  --  01D4FF
          (((0, 0), (970, 970)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         others           =>
          (((0, 0), (0, 0)), (0, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)));

   Group_01D5 : aliased constant Normalization_Mapping_Second_Stage
     := (16#00#           =>  --  01D500
          (((0, 0), (337, 337)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#01#           =>  --  01D501
          (((0, 0), (595, 595)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#02#           =>  --  01D502
          (((0, 0), (127, 127)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#03#           =>  --  01D503
          (((0, 0), (347, 347)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#04#           =>  --  01D504
          (((0, 0), (25, 25)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#05#           =>  --  01D505
          (((0, 0), (950, 950)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#07#           =>  --  01D507
          (((0, 0), (159, 159)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#08#           =>  --  01D508
          (((0, 0), (39, 39)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#09#           =>  --  01D509
          (((0, 0), (1076, 1076)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#0A#           =>  --  01D50A
          (((0, 0), (183, 183)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#0D#           =>  --  01D50D
          (((0, 0), (222, 222)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#0E#           =>  --  01D50E
          (((0, 0), (229, 229)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#0F#           =>  --  01D50F
          (((0, 0), (233, 233)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#10#           =>  --  01D510
          (((0, 0), (952, 952)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#11#           =>  --  01D511
          (((0, 0), (55, 55)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#12#           =>  --  01D512
          (((0, 0), (57, 57)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#13#           =>  --  01D513
          (((0, 0), (954, 954)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#14#           =>  --  01D514
          (((0, 0), (2271, 2271)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#16#           =>  --  01D516
          (((0, 0), (287, 287)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#17#           =>  --  01D517
          (((0, 0), (303, 303)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#18#           =>  --  01D518
          (((0, 0), (67, 67)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#19#           =>  --  01D519
          (((0, 0), (1288, 1288)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#1A#           =>  --  01D51A
          (((0, 0), (335, 335)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#1B#           =>  --  01D51B
          (((0, 0), (1316, 1316)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#1C#           =>  --  01D51C
          (((0, 0), (75, 75)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#1E#           =>  --  01D51E
          (((0, 0), (4, 4)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#1F#           =>  --  01D51F
          (((0, 0), (958, 958)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#20#           =>  --  01D520
          (((0, 0), (89, 89)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#21#           =>  --  01D521
          (((0, 0), (161, 161)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#22#           =>  --  01D522
          (((0, 0), (91, 91)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#23#           =>  --  01D523
          (((0, 0), (979, 979)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#24#           =>  --  01D524
          (((0, 0), (185, 185)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#25#           =>  --  01D525
          (((0, 0), (201, 201)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#26#           =>  --  01D526
          (((0, 0), (99, 99)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#27#           =>  --  01D527
          (((0, 0), (224, 224)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#28#           =>  --  01D528
          (((0, 0), (231, 231)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#29#           =>  --  01D529
          (((0, 0), (235, 235)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#2A#           =>  --  01D52A
          (((0, 0), (962, 962)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#2B#           =>  --  01D52B
          (((0, 0), (107, 107)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#2C#           =>  --  01D52C
          (((0, 0), (15, 15)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#2D#           =>  --  01D52D
          (((0, 0), (967, 967)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#2E#           =>  --  01D52E
          (((0, 0), (2675, 2675)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#2F#           =>  --  01D52F
          (((0, 0), (277, 277)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#30#           =>  --  01D530
          (((0, 0), (289, 289)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#31#           =>  --  01D531
          (((0, 0), (305, 305)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#32#           =>  --  01D532
          (((0, 0), (119, 119)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#33#           =>  --  01D533
          (((0, 0), (970, 970)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#34#           =>  --  01D534
          (((0, 0), (337, 337)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#35#           =>  --  01D535
          (((0, 0), (595, 595)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#36#           =>  --  01D536
          (((0, 0), (127, 127)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#37#           =>  --  01D537
          (((0, 0), (347, 347)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#38#           =>  --  01D538
          (((0, 0), (25, 25)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#39#           =>  --  01D539
          (((0, 0), (950, 950)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#3B#           =>  --  01D53B
          (((0, 0), (159, 159)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#3C#           =>  --  01D53C
          (((0, 0), (39, 39)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#3D#           =>  --  01D53D
          (((0, 0), (1076, 1076)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#3E#           =>  --  01D53E
          (((0, 0), (183, 183)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#40#           =>  --  01D540
          (((0, 0), (47, 47)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#41#           =>  --  01D541
          (((0, 0), (222, 222)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#42#           =>  --  01D542
          (((0, 0), (229, 229)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#43#           =>  --  01D543
          (((0, 0), (233, 233)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#44#           =>  --  01D544
          (((0, 0), (952, 952)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#46#           =>  --  01D546
          (((0, 0), (57, 57)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#4A#           =>  --  01D54A
          (((0, 0), (287, 287)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#4B#           =>  --  01D54B
          (((0, 0), (303, 303)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#4C#           =>  --  01D54C
          (((0, 0), (67, 67)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#4D#           =>  --  01D54D
          (((0, 0), (1288, 1288)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#4E#           =>  --  01D54E
          (((0, 0), (335, 335)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#4F#           =>  --  01D54F
          (((0, 0), (1316, 1316)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#50#           =>  --  01D550
          (((0, 0), (75, 75)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#52#           =>  --  01D552
          (((0, 0), (4, 4)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#53#           =>  --  01D553
          (((0, 0), (958, 958)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#54#           =>  --  01D554
          (((0, 0), (89, 89)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#55#           =>  --  01D555
          (((0, 0), (161, 161)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#56#           =>  --  01D556
          (((0, 0), (91, 91)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#57#           =>  --  01D557
          (((0, 0), (979, 979)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#58#           =>  --  01D558
          (((0, 0), (185, 185)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#59#           =>  --  01D559
          (((0, 0), (201, 201)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#5A#           =>  --  01D55A
          (((0, 0), (99, 99)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#5B#           =>  --  01D55B
          (((0, 0), (224, 224)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#5C#           =>  --  01D55C
          (((0, 0), (231, 231)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#5D#           =>  --  01D55D
          (((0, 0), (235, 235)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#5E#           =>  --  01D55E
          (((0, 0), (962, 962)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#5F#           =>  --  01D55F
          (((0, 0), (107, 107)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#60#           =>  --  01D560
          (((0, 0), (15, 15)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#61#           =>  --  01D561
          (((0, 0), (967, 967)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#62#           =>  --  01D562
          (((0, 0), (2675, 2675)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#63#           =>  --  01D563
          (((0, 0), (277, 277)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#64#           =>  --  01D564
          (((0, 0), (289, 289)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#65#           =>  --  01D565
          (((0, 0), (305, 305)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#66#           =>  --  01D566
          (((0, 0), (119, 119)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#67#           =>  --  01D567
          (((0, 0), (970, 970)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#68#           =>  --  01D568
          (((0, 0), (337, 337)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#69#           =>  --  01D569
          (((0, 0), (595, 595)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#6A#           =>  --  01D56A
          (((0, 0), (127, 127)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#6B#           =>  --  01D56B
          (((0, 0), (347, 347)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#6C#           =>  --  01D56C
          (((0, 0), (25, 25)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#6D#           =>  --  01D56D
          (((0, 0), (950, 950)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#6E#           =>  --  01D56E
          (((0, 0), (37, 37)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#6F#           =>  --  01D56F
          (((0, 0), (159, 159)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#70#           =>  --  01D570
          (((0, 0), (39, 39)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#71#           =>  --  01D571
          (((0, 0), (1076, 1076)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#72#           =>  --  01D572
          (((0, 0), (183, 183)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#73#           =>  --  01D573
          (((0, 0), (199, 199)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#74#           =>  --  01D574
          (((0, 0), (47, 47)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#75#           =>  --  01D575
          (((0, 0), (222, 222)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#76#           =>  --  01D576
          (((0, 0), (229, 229)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#77#           =>  --  01D577
          (((0, 0), (233, 233)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#78#           =>  --  01D578
          (((0, 0), (952, 952)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#79#           =>  --  01D579
          (((0, 0), (55, 55)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#7A#           =>  --  01D57A
          (((0, 0), (57, 57)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#7B#           =>  --  01D57B
          (((0, 0), (954, 954)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#7C#           =>  --  01D57C
          (((0, 0), (2271, 2271)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#7D#           =>  --  01D57D
          (((0, 0), (275, 275)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#7E#           =>  --  01D57E
          (((0, 0), (287, 287)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#7F#           =>  --  01D57F
          (((0, 0), (303, 303)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#80#           =>  --  01D580
          (((0, 0), (67, 67)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#81#           =>  --  01D581
          (((0, 0), (1288, 1288)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#82#           =>  --  01D582
          (((0, 0), (335, 335)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#83#           =>  --  01D583
          (((0, 0), (1316, 1316)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#84#           =>  --  01D584
          (((0, 0), (75, 75)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#85#           =>  --  01D585
          (((0, 0), (345, 345)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#86#           =>  --  01D586
          (((0, 0), (4, 4)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#87#           =>  --  01D587
          (((0, 0), (958, 958)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#88#           =>  --  01D588
          (((0, 0), (89, 89)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#89#           =>  --  01D589
          (((0, 0), (161, 161)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#8A#           =>  --  01D58A
          (((0, 0), (91, 91)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#8B#           =>  --  01D58B
          (((0, 0), (979, 979)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#8C#           =>  --  01D58C
          (((0, 0), (185, 185)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#8D#           =>  --  01D58D
          (((0, 0), (201, 201)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#8E#           =>  --  01D58E
          (((0, 0), (99, 99)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#8F#           =>  --  01D58F
          (((0, 0), (224, 224)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#90#           =>  --  01D590
          (((0, 0), (231, 231)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#91#           =>  --  01D591
          (((0, 0), (235, 235)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#92#           =>  --  01D592
          (((0, 0), (962, 962)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#93#           =>  --  01D593
          (((0, 0), (107, 107)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#94#           =>  --  01D594
          (((0, 0), (15, 15)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#95#           =>  --  01D595
          (((0, 0), (967, 967)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#96#           =>  --  01D596
          (((0, 0), (2675, 2675)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#97#           =>  --  01D597
          (((0, 0), (277, 277)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#98#           =>  --  01D598
          (((0, 0), (289, 289)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#99#           =>  --  01D599
          (((0, 0), (305, 305)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#9A#           =>  --  01D59A
          (((0, 0), (119, 119)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#9B#           =>  --  01D59B
          (((0, 0), (970, 970)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#9C#           =>  --  01D59C
          (((0, 0), (337, 337)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#9D#           =>  --  01D59D
          (((0, 0), (595, 595)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#9E#           =>  --  01D59E
          (((0, 0), (127, 127)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#9F#           =>  --  01D59F
          (((0, 0), (347, 347)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#A0#           =>  --  01D5A0
          (((0, 0), (25, 25)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#A1#           =>  --  01D5A1
          (((0, 0), (950, 950)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#A2#           =>  --  01D5A2
          (((0, 0), (37, 37)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#A3#           =>  --  01D5A3
          (((0, 0), (159, 159)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#A4#           =>  --  01D5A4
          (((0, 0), (39, 39)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#A5#           =>  --  01D5A5
          (((0, 0), (1076, 1076)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#A6#           =>  --  01D5A6
          (((0, 0), (183, 183)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#A7#           =>  --  01D5A7
          (((0, 0), (199, 199)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#A8#           =>  --  01D5A8
          (((0, 0), (47, 47)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#A9#           =>  --  01D5A9
          (((0, 0), (222, 222)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#AA#           =>  --  01D5AA
          (((0, 0), (229, 229)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#AB#           =>  --  01D5AB
          (((0, 0), (233, 233)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#AC#           =>  --  01D5AC
          (((0, 0), (952, 952)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#AD#           =>  --  01D5AD
          (((0, 0), (55, 55)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#AE#           =>  --  01D5AE
          (((0, 0), (57, 57)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#AF#           =>  --  01D5AF
          (((0, 0), (954, 954)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#B0#           =>  --  01D5B0
          (((0, 0), (2271, 2271)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#B1#           =>  --  01D5B1
          (((0, 0), (275, 275)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#B2#           =>  --  01D5B2
          (((0, 0), (287, 287)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#B3#           =>  --  01D5B3
          (((0, 0), (303, 303)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#B4#           =>  --  01D5B4
          (((0, 0), (67, 67)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#B5#           =>  --  01D5B5
          (((0, 0), (1288, 1288)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#B6#           =>  --  01D5B6
          (((0, 0), (335, 335)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#B7#           =>  --  01D5B7
          (((0, 0), (1316, 1316)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#B8#           =>  --  01D5B8
          (((0, 0), (75, 75)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#B9#           =>  --  01D5B9
          (((0, 0), (345, 345)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#BA#           =>  --  01D5BA
          (((0, 0), (4, 4)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#BB#           =>  --  01D5BB
          (((0, 0), (958, 958)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#BC#           =>  --  01D5BC
          (((0, 0), (89, 89)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#BD#           =>  --  01D5BD
          (((0, 0), (161, 161)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#BE#           =>  --  01D5BE
          (((0, 0), (91, 91)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#BF#           =>  --  01D5BF
          (((0, 0), (979, 979)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#C0#           =>  --  01D5C0
          (((0, 0), (185, 185)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#C1#           =>  --  01D5C1
          (((0, 0), (201, 201)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#C2#           =>  --  01D5C2
          (((0, 0), (99, 99)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#C3#           =>  --  01D5C3
          (((0, 0), (224, 224)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#C4#           =>  --  01D5C4
          (((0, 0), (231, 231)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#C5#           =>  --  01D5C5
          (((0, 0), (235, 235)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#C6#           =>  --  01D5C6
          (((0, 0), (962, 962)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#C7#           =>  --  01D5C7
          (((0, 0), (107, 107)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#C8#           =>  --  01D5C8
          (((0, 0), (15, 15)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#C9#           =>  --  01D5C9
          (((0, 0), (967, 967)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#CA#           =>  --  01D5CA
          (((0, 0), (2675, 2675)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#CB#           =>  --  01D5CB
          (((0, 0), (277, 277)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#CC#           =>  --  01D5CC
          (((0, 0), (289, 289)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#CD#           =>  --  01D5CD
          (((0, 0), (305, 305)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#CE#           =>  --  01D5CE
          (((0, 0), (119, 119)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#CF#           =>  --  01D5CF
          (((0, 0), (970, 970)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#D0#           =>  --  01D5D0
          (((0, 0), (337, 337)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#D1#           =>  --  01D5D1
          (((0, 0), (595, 595)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#D2#           =>  --  01D5D2
          (((0, 0), (127, 127)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#D3#           =>  --  01D5D3
          (((0, 0), (347, 347)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#D4#           =>  --  01D5D4
          (((0, 0), (25, 25)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#D5#           =>  --  01D5D5
          (((0, 0), (950, 950)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#D6#           =>  --  01D5D6
          (((0, 0), (37, 37)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#D7#           =>  --  01D5D7
          (((0, 0), (159, 159)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#D8#           =>  --  01D5D8
          (((0, 0), (39, 39)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#D9#           =>  --  01D5D9
          (((0, 0), (1076, 1076)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#DA#           =>  --  01D5DA
          (((0, 0), (183, 183)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#DB#           =>  --  01D5DB
          (((0, 0), (199, 199)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#DC#           =>  --  01D5DC
          (((0, 0), (47, 47)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#DD#           =>  --  01D5DD
          (((0, 0), (222, 222)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#DE#           =>  --  01D5DE
          (((0, 0), (229, 229)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#DF#           =>  --  01D5DF
          (((0, 0), (233, 233)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#E0#           =>  --  01D5E0
          (((0, 0), (952, 952)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#E1#           =>  --  01D5E1
          (((0, 0), (55, 55)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#E2#           =>  --  01D5E2
          (((0, 0), (57, 57)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#E3#           =>  --  01D5E3
          (((0, 0), (954, 954)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#E4#           =>  --  01D5E4
          (((0, 0), (2271, 2271)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#E5#           =>  --  01D5E5
          (((0, 0), (275, 275)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#E6#           =>  --  01D5E6
          (((0, 0), (287, 287)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#E7#           =>  --  01D5E7
          (((0, 0), (303, 303)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#E8#           =>  --  01D5E8
          (((0, 0), (67, 67)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#E9#           =>  --  01D5E9
          (((0, 0), (1288, 1288)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#EA#           =>  --  01D5EA
          (((0, 0), (335, 335)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#EB#           =>  --  01D5EB
          (((0, 0), (1316, 1316)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#EC#           =>  --  01D5EC
          (((0, 0), (75, 75)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#ED#           =>  --  01D5ED
          (((0, 0), (345, 345)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#EE#           =>  --  01D5EE
          (((0, 0), (4, 4)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#EF#           =>  --  01D5EF
          (((0, 0), (958, 958)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#F0#           =>  --  01D5F0
          (((0, 0), (89, 89)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#F1#           =>  --  01D5F1
          (((0, 0), (161, 161)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#F2#           =>  --  01D5F2
          (((0, 0), (91, 91)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#F3#           =>  --  01D5F3
          (((0, 0), (979, 979)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#F4#           =>  --  01D5F4
          (((0, 0), (185, 185)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#F5#           =>  --  01D5F5
          (((0, 0), (201, 201)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#F6#           =>  --  01D5F6
          (((0, 0), (99, 99)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#F7#           =>  --  01D5F7
          (((0, 0), (224, 224)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#F8#           =>  --  01D5F8
          (((0, 0), (231, 231)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#F9#           =>  --  01D5F9
          (((0, 0), (235, 235)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#FA#           =>  --  01D5FA
          (((0, 0), (962, 962)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#FB#           =>  --  01D5FB
          (((0, 0), (107, 107)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#FC#           =>  --  01D5FC
          (((0, 0), (15, 15)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#FD#           =>  --  01D5FD
          (((0, 0), (967, 967)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#FE#           =>  --  01D5FE
          (((0, 0), (2675, 2675)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#FF#           =>  --  01D5FF
          (((0, 0), (277, 277)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         others           =>
          (((0, 0), (0, 0)), (0, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)));

   Group_01D6 : aliased constant Normalization_Mapping_Second_Stage
     := (16#01#           =>  --  01D601
          (((0, 0), (305, 305)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#02#           =>  --  01D602
          (((0, 0), (119, 119)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#03#           =>  --  01D603
          (((0, 0), (970, 970)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#04#           =>  --  01D604
          (((0, 0), (337, 337)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#05#           =>  --  01D605
          (((0, 0), (595, 595)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#06#           =>  --  01D606
          (((0, 0), (127, 127)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#07#           =>  --  01D607
          (((0, 0), (347, 347)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#08#           =>  --  01D608
          (((0, 0), (25, 25)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#09#           =>  --  01D609
          (((0, 0), (950, 950)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#0A#           =>  --  01D60A
          (((0, 0), (37, 37)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#0B#           =>  --  01D60B
          (((0, 0), (159, 159)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#0C#           =>  --  01D60C
          (((0, 0), (39, 39)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#0D#           =>  --  01D60D
          (((0, 0), (1076, 1076)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#0E#           =>  --  01D60E
          (((0, 0), (183, 183)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#0F#           =>  --  01D60F
          (((0, 0), (199, 199)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#10#           =>  --  01D610
          (((0, 0), (47, 47)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#11#           =>  --  01D611
          (((0, 0), (222, 222)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#12#           =>  --  01D612
          (((0, 0), (229, 229)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#13#           =>  --  01D613
          (((0, 0), (233, 233)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#14#           =>  --  01D614
          (((0, 0), (952, 952)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#15#           =>  --  01D615
          (((0, 0), (55, 55)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#16#           =>  --  01D616
          (((0, 0), (57, 57)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#17#           =>  --  01D617
          (((0, 0), (954, 954)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#18#           =>  --  01D618
          (((0, 0), (2271, 2271)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#19#           =>  --  01D619
          (((0, 0), (275, 275)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#1A#           =>  --  01D61A
          (((0, 0), (287, 287)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#1B#           =>  --  01D61B
          (((0, 0), (303, 303)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#1C#           =>  --  01D61C
          (((0, 0), (67, 67)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#1D#           =>  --  01D61D
          (((0, 0), (1288, 1288)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#1E#           =>  --  01D61E
          (((0, 0), (335, 335)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#1F#           =>  --  01D61F
          (((0, 0), (1316, 1316)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#20#           =>  --  01D620
          (((0, 0), (75, 75)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#21#           =>  --  01D621
          (((0, 0), (345, 345)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#22#           =>  --  01D622
          (((0, 0), (4, 4)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#23#           =>  --  01D623
          (((0, 0), (958, 958)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#24#           =>  --  01D624
          (((0, 0), (89, 89)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#25#           =>  --  01D625
          (((0, 0), (161, 161)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#26#           =>  --  01D626
          (((0, 0), (91, 91)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#27#           =>  --  01D627
          (((0, 0), (979, 979)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#28#           =>  --  01D628
          (((0, 0), (185, 185)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#29#           =>  --  01D629
          (((0, 0), (201, 201)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#2A#           =>  --  01D62A
          (((0, 0), (99, 99)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#2B#           =>  --  01D62B
          (((0, 0), (224, 224)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#2C#           =>  --  01D62C
          (((0, 0), (231, 231)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#2D#           =>  --  01D62D
          (((0, 0), (235, 235)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#2E#           =>  --  01D62E
          (((0, 0), (962, 962)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#2F#           =>  --  01D62F
          (((0, 0), (107, 107)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#30#           =>  --  01D630
          (((0, 0), (15, 15)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#31#           =>  --  01D631
          (((0, 0), (967, 967)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#32#           =>  --  01D632
          (((0, 0), (2675, 2675)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#33#           =>  --  01D633
          (((0, 0), (277, 277)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#35#           =>  --  01D635
          (((0, 0), (305, 305)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#36#           =>  --  01D636
          (((0, 0), (119, 119)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#37#           =>  --  01D637
          (((0, 0), (970, 970)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#38#           =>  --  01D638
          (((0, 0), (337, 337)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#39#           =>  --  01D639
          (((0, 0), (595, 595)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#3A#           =>  --  01D63A
          (((0, 0), (127, 127)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#3B#           =>  --  01D63B
          (((0, 0), (347, 347)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#3C#           =>  --  01D63C
          (((0, 0), (25, 25)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#3D#           =>  --  01D63D
          (((0, 0), (950, 950)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#3E#           =>  --  01D63E
          (((0, 0), (37, 37)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#3F#           =>  --  01D63F
          (((0, 0), (159, 159)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#40#           =>  --  01D640
          (((0, 0), (39, 39)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#41#           =>  --  01D641
          (((0, 0), (1076, 1076)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#42#           =>  --  01D642
          (((0, 0), (183, 183)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#43#           =>  --  01D643
          (((0, 0), (199, 199)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#44#           =>  --  01D644
          (((0, 0), (47, 47)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#45#           =>  --  01D645
          (((0, 0), (222, 222)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#46#           =>  --  01D646
          (((0, 0), (229, 229)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#47#           =>  --  01D647
          (((0, 0), (233, 233)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#48#           =>  --  01D648
          (((0, 0), (952, 952)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#49#           =>  --  01D649
          (((0, 0), (55, 55)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#4A#           =>  --  01D64A
          (((0, 0), (57, 57)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#4B#           =>  --  01D64B
          (((0, 0), (954, 954)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#4C#           =>  --  01D64C
          (((0, 0), (2271, 2271)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#4D#           =>  --  01D64D
          (((0, 0), (275, 275)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#4E#           =>  --  01D64E
          (((0, 0), (287, 287)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#4F#           =>  --  01D64F
          (((0, 0), (303, 303)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#50#           =>  --  01D650
          (((0, 0), (67, 67)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#51#           =>  --  01D651
          (((0, 0), (1288, 1288)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#52#           =>  --  01D652
          (((0, 0), (335, 335)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#53#           =>  --  01D653
          (((0, 0), (1316, 1316)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#54#           =>  --  01D654
          (((0, 0), (75, 75)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#55#           =>  --  01D655
          (((0, 0), (345, 345)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#56#           =>  --  01D656
          (((0, 0), (4, 4)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#57#           =>  --  01D657
          (((0, 0), (958, 958)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#58#           =>  --  01D658
          (((0, 0), (89, 89)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#59#           =>  --  01D659
          (((0, 0), (161, 161)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#5A#           =>  --  01D65A
          (((0, 0), (91, 91)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#5B#           =>  --  01D65B
          (((0, 0), (979, 979)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#5C#           =>  --  01D65C
          (((0, 0), (185, 185)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#5D#           =>  --  01D65D
          (((0, 0), (201, 201)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#5E#           =>  --  01D65E
          (((0, 0), (99, 99)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#5F#           =>  --  01D65F
          (((0, 0), (224, 224)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#60#           =>  --  01D660
          (((0, 0), (231, 231)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#61#           =>  --  01D661
          (((0, 0), (235, 235)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#62#           =>  --  01D662
          (((0, 0), (962, 962)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#63#           =>  --  01D663
          (((0, 0), (107, 107)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#64#           =>  --  01D664
          (((0, 0), (15, 15)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#65#           =>  --  01D665
          (((0, 0), (967, 967)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#66#           =>  --  01D666
          (((0, 0), (2675, 2675)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#67#           =>  --  01D667
          (((0, 0), (277, 277)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#69#           =>  --  01D669
          (((0, 0), (305, 305)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#6A#           =>  --  01D66A
          (((0, 0), (119, 119)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#6B#           =>  --  01D66B
          (((0, 0), (970, 970)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#6C#           =>  --  01D66C
          (((0, 0), (337, 337)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#6D#           =>  --  01D66D
          (((0, 0), (595, 595)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#6E#           =>  --  01D66E
          (((0, 0), (127, 127)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#6F#           =>  --  01D66F
          (((0, 0), (347, 347)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#70#           =>  --  01D670
          (((0, 0), (25, 25)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#71#           =>  --  01D671
          (((0, 0), (950, 950)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#72#           =>  --  01D672
          (((0, 0), (37, 37)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#73#           =>  --  01D673
          (((0, 0), (159, 159)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#74#           =>  --  01D674
          (((0, 0), (39, 39)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#75#           =>  --  01D675
          (((0, 0), (1076, 1076)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#76#           =>  --  01D676
          (((0, 0), (183, 183)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#77#           =>  --  01D677
          (((0, 0), (199, 199)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#78#           =>  --  01D678
          (((0, 0), (47, 47)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#79#           =>  --  01D679
          (((0, 0), (222, 222)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#7A#           =>  --  01D67A
          (((0, 0), (229, 229)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#7B#           =>  --  01D67B
          (((0, 0), (233, 233)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#7C#           =>  --  01D67C
          (((0, 0), (952, 952)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#7D#           =>  --  01D67D
          (((0, 0), (55, 55)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#7E#           =>  --  01D67E
          (((0, 0), (57, 57)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#7F#           =>  --  01D67F
          (((0, 0), (954, 954)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#80#           =>  --  01D680
          (((0, 0), (2271, 2271)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#81#           =>  --  01D681
          (((0, 0), (275, 275)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#82#           =>  --  01D682
          (((0, 0), (287, 287)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#83#           =>  --  01D683
          (((0, 0), (303, 303)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#84#           =>  --  01D684
          (((0, 0), (67, 67)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#85#           =>  --  01D685
          (((0, 0), (1288, 1288)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#86#           =>  --  01D686
          (((0, 0), (335, 335)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#87#           =>  --  01D687
          (((0, 0), (1316, 1316)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#88#           =>  --  01D688
          (((0, 0), (75, 75)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#89#           =>  --  01D689
          (((0, 0), (345, 345)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#8A#           =>  --  01D68A
          (((0, 0), (4, 4)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#8B#           =>  --  01D68B
          (((0, 0), (958, 958)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#8C#           =>  --  01D68C
          (((0, 0), (89, 89)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#8D#           =>  --  01D68D
          (((0, 0), (161, 161)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#8E#           =>  --  01D68E
          (((0, 0), (91, 91)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#8F#           =>  --  01D68F
          (((0, 0), (979, 979)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#90#           =>  --  01D690
          (((0, 0), (185, 185)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#91#           =>  --  01D691
          (((0, 0), (201, 201)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#92#           =>  --  01D692
          (((0, 0), (99, 99)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#93#           =>  --  01D693
          (((0, 0), (224, 224)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#94#           =>  --  01D694
          (((0, 0), (231, 231)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#95#           =>  --  01D695
          (((0, 0), (235, 235)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#96#           =>  --  01D696
          (((0, 0), (962, 962)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#97#           =>  --  01D697
          (((0, 0), (107, 107)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#98#           =>  --  01D698
          (((0, 0), (15, 15)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#99#           =>  --  01D699
          (((0, 0), (967, 967)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#9A#           =>  --  01D69A
          (((0, 0), (2675, 2675)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#9B#           =>  --  01D69B
          (((0, 0), (277, 277)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#9D#           =>  --  01D69D
          (((0, 0), (305, 305)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#9E#           =>  --  01D69E
          (((0, 0), (119, 119)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#9F#           =>  --  01D69F
          (((0, 0), (970, 970)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#A0#           =>  --  01D6A0
          (((0, 0), (337, 337)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#A1#           =>  --  01D6A1
          (((0, 0), (595, 595)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#A2#           =>  --  01D6A2
          (((0, 0), (127, 127)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#A3#           =>  --  01D6A3
          (((0, 0), (347, 347)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#A4#           =>  --  01D6A4
          (((0, 0), (5615, 5615)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#A5#           =>  --  01D6A5
          (((0, 0), (5616, 5616)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#A6# .. 16#A7# =>  --  01D6A6 .. 01D6A7
          (((0, 0), (0, 0)), (0, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#A8#           =>  --  01D6A8
          (((0, 0), (607, 607)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#A9#           =>  --  01D6A9
          (((0, 0), (5617, 5617)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#AA#           =>  --  01D6AA
          (((0, 0), (2286, 2286)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#AB#           =>  --  01D6AB
          (((0, 0), (5618, 5618)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#AC#           =>  --  01D6AC
          (((0, 0), (609, 609)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#AD#           =>  --  01D6AD
          (((0, 0), (5619, 5619)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#AE#           =>  --  01D6AE
          (((0, 0), (611, 611)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#AF#           =>  --  01D6AF
          (((0, 0), (656, 656)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#B0#           =>  --  01D6B0
          (((0, 0), (613, 613)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#B1#           =>  --  01D6B1
          (((0, 0), (5620, 5620)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#B2#           =>  --  01D6B2
          (((0, 0), (5621, 5621)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#B3#           =>  --  01D6B3
          (((0, 0), (5622, 5622)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#B4#           =>  --  01D6B4
          (((0, 0), (5623, 5623)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#B5#           =>  --  01D6B5
          (((0, 0), (5624, 5624)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#B6#           =>  --  01D6B6
          (((0, 0), (615, 615)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#B7#           =>  --  01D6B7
          (((0, 0), (2287, 2287)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#B8#           =>  --  01D6B8
          (((0, 0), (2182, 2182)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#B9#           =>  --  01D6B9
          (((0, 0), (656, 656)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#BA#           =>  --  01D6BA
          (((0, 0), (657, 657)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#BB#           =>  --  01D6BB
          (((0, 0), (5625, 5625)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#BC#           =>  --  01D6BC
          (((0, 0), (617, 617)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#BD#           =>  --  01D6BD
          (((0, 0), (5626, 5626)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#BE#           =>  --  01D6BE
          (((0, 0), (5627, 5627)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#BF#           =>  --  01D6BF
          (((0, 0), (5628, 5628)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#C0#           =>  --  01D6C0
          (((0, 0), (619, 619)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#C1#           =>  --  01D6C1
          (((0, 0), (5629, 5629)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#C2#           =>  --  01D6C2
          (((0, 0), (628, 628)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#C3#           =>  --  01D6C3
          (((0, 0), (645, 645)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#C4#           =>  --  01D6C4
          (((0, 0), (972, 972)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#C5#           =>  --  01D6C5
          (((0, 0), (973, 973)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#C6#           =>  --  01D6C6
          (((0, 0), (630, 630)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#C7#           =>  --  01D6C7
          (((0, 0), (5630, 5630)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#C8#           =>  --  01D6C8
          (((0, 0), (632, 632)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#C9#           =>  --  01D6C9
          (((0, 0), (646, 646)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#CA#           =>  --  01D6CA
          (((0, 0), (621, 621)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#CB#           =>  --  01D6CB
          (((0, 0), (653, 653)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#CC#           =>  --  01D6CC
          (((0, 0), (5631, 5631)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#CD#           =>  --  01D6CD
          (((0, 0), (11, 11)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#CE#           =>  --  01D6CE
          (((0, 0), (5632, 5632)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#CF#           =>  --  01D6CF
          (((0, 0), (5633, 5633)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#D0#           =>  --  01D6D0
          (((0, 0), (639, 639)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#D1#           =>  --  01D6D1
          (((0, 0), (652, 652)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#D2#           =>  --  01D6D2
          (((0, 0), (654, 654)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#D3#           =>  --  01D6D3
          (((0, 0), (655, 655)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#D4#           =>  --  01D6D4
          (((0, 0), (5634, 5634)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#D5#           =>  --  01D6D5
          (((0, 0), (5635, 5635)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#D6#           =>  --  01D6D6
          (((0, 0), (636, 636)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#D7#           =>  --  01D6D7
          (((0, 0), (651, 651)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#D8#           =>  --  01D6D8
          (((0, 0), (974, 974)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#D9#           =>  --  01D6D9
          (((0, 0), (5636, 5636)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#DA#           =>  --  01D6DA
          (((0, 0), (643, 643)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#DB#           =>  --  01D6DB
          (((0, 0), (5637, 5637)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#DC#           =>  --  01D6DC
          (((0, 0), (630, 630)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#DD#           =>  --  01D6DD
          (((0, 0), (646, 646)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#DE#           =>  --  01D6DE
          (((0, 0), (653, 653)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#DF#           =>  --  01D6DF
          (((0, 0), (651, 651)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#E0#           =>  --  01D6E0
          (((0, 0), (654, 654)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#E1#           =>  --  01D6E1
          (((0, 0), (652, 652)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#E2#           =>  --  01D6E2
          (((0, 0), (607, 607)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#E3#           =>  --  01D6E3
          (((0, 0), (5617, 5617)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#E4#           =>  --  01D6E4
          (((0, 0), (2286, 2286)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#E5#           =>  --  01D6E5
          (((0, 0), (5618, 5618)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#E6#           =>  --  01D6E6
          (((0, 0), (609, 609)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#E7#           =>  --  01D6E7
          (((0, 0), (5619, 5619)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#E8#           =>  --  01D6E8
          (((0, 0), (611, 611)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#E9#           =>  --  01D6E9
          (((0, 0), (656, 656)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#EA#           =>  --  01D6EA
          (((0, 0), (613, 613)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#EB#           =>  --  01D6EB
          (((0, 0), (5620, 5620)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#EC#           =>  --  01D6EC
          (((0, 0), (5621, 5621)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#ED#           =>  --  01D6ED
          (((0, 0), (5622, 5622)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#EE#           =>  --  01D6EE
          (((0, 0), (5623, 5623)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#EF#           =>  --  01D6EF
          (((0, 0), (5624, 5624)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#F0#           =>  --  01D6F0
          (((0, 0), (615, 615)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#F1#           =>  --  01D6F1
          (((0, 0), (2287, 2287)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#F2#           =>  --  01D6F2
          (((0, 0), (2182, 2182)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#F3#           =>  --  01D6F3
          (((0, 0), (656, 656)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#F4#           =>  --  01D6F4
          (((0, 0), (657, 657)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#F5#           =>  --  01D6F5
          (((0, 0), (5625, 5625)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#F6#           =>  --  01D6F6
          (((0, 0), (617, 617)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#F7#           =>  --  01D6F7
          (((0, 0), (5626, 5626)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#F8#           =>  --  01D6F8
          (((0, 0), (5627, 5627)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#F9#           =>  --  01D6F9
          (((0, 0), (5628, 5628)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#FA#           =>  --  01D6FA
          (((0, 0), (619, 619)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#FB#           =>  --  01D6FB
          (((0, 0), (5629, 5629)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#FC#           =>  --  01D6FC
          (((0, 0), (628, 628)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#FD#           =>  --  01D6FD
          (((0, 0), (645, 645)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#FE#           =>  --  01D6FE
          (((0, 0), (972, 972)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#FF#           =>  --  01D6FF
          (((0, 0), (973, 973)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         others           =>
          (((0, 0), (289, 289)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)));

   Group_01D7 : aliased constant Normalization_Mapping_Second_Stage
     := (16#01#           =>  --  01D701
          (((0, 0), (5630, 5630)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#02#           =>  --  01D702
          (((0, 0), (632, 632)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#03#           =>  --  01D703
          (((0, 0), (646, 646)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#04#           =>  --  01D704
          (((0, 0), (621, 621)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#05#           =>  --  01D705
          (((0, 0), (653, 653)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#06#           =>  --  01D706
          (((0, 0), (5631, 5631)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#07#           =>  --  01D707
          (((0, 0), (11, 11)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#08#           =>  --  01D708
          (((0, 0), (5632, 5632)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#09#           =>  --  01D709
          (((0, 0), (5633, 5633)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#0A#           =>  --  01D70A
          (((0, 0), (639, 639)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#0B#           =>  --  01D70B
          (((0, 0), (652, 652)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#0C#           =>  --  01D70C
          (((0, 0), (654, 654)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#0D#           =>  --  01D70D
          (((0, 0), (655, 655)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#0E#           =>  --  01D70E
          (((0, 0), (5634, 5634)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#0F#           =>  --  01D70F
          (((0, 0), (5635, 5635)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#10#           =>  --  01D710
          (((0, 0), (636, 636)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#11#           =>  --  01D711
          (((0, 0), (651, 651)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#12#           =>  --  01D712
          (((0, 0), (974, 974)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#13#           =>  --  01D713
          (((0, 0), (5636, 5636)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#14#           =>  --  01D714
          (((0, 0), (643, 643)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#15#           =>  --  01D715
          (((0, 0), (5637, 5637)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#17#           =>  --  01D717
          (((0, 0), (646, 646)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#18#           =>  --  01D718
          (((0, 0), (653, 653)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#19#           =>  --  01D719
          (((0, 0), (651, 651)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#1A#           =>  --  01D71A
          (((0, 0), (654, 654)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#1B#           =>  --  01D71B
          (((0, 0), (652, 652)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#1C#           =>  --  01D71C
          (((0, 0), (607, 607)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#1D#           =>  --  01D71D
          (((0, 0), (5617, 5617)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#1E#           =>  --  01D71E
          (((0, 0), (2286, 2286)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#1F#           =>  --  01D71F
          (((0, 0), (5618, 5618)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#20#           =>  --  01D720
          (((0, 0), (609, 609)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#21#           =>  --  01D721
          (((0, 0), (5619, 5619)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#22#           =>  --  01D722
          (((0, 0), (611, 611)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#23#           =>  --  01D723
          (((0, 0), (656, 656)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#24#           =>  --  01D724
          (((0, 0), (613, 613)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#25#           =>  --  01D725
          (((0, 0), (5620, 5620)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#26#           =>  --  01D726
          (((0, 0), (5621, 5621)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#27#           =>  --  01D727
          (((0, 0), (5622, 5622)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#28#           =>  --  01D728
          (((0, 0), (5623, 5623)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#29#           =>  --  01D729
          (((0, 0), (5624, 5624)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#2A#           =>  --  01D72A
          (((0, 0), (615, 615)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#2B#           =>  --  01D72B
          (((0, 0), (2287, 2287)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#2C#           =>  --  01D72C
          (((0, 0), (2182, 2182)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#2D#           =>  --  01D72D
          (((0, 0), (656, 656)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#2E#           =>  --  01D72E
          (((0, 0), (657, 657)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#2F#           =>  --  01D72F
          (((0, 0), (5625, 5625)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#30#           =>  --  01D730
          (((0, 0), (617, 617)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#31#           =>  --  01D731
          (((0, 0), (5626, 5626)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#32#           =>  --  01D732
          (((0, 0), (5627, 5627)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#33#           =>  --  01D733
          (((0, 0), (5628, 5628)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#34#           =>  --  01D734
          (((0, 0), (619, 619)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#35#           =>  --  01D735
          (((0, 0), (5629, 5629)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#36#           =>  --  01D736
          (((0, 0), (628, 628)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#37#           =>  --  01D737
          (((0, 0), (645, 645)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#38#           =>  --  01D738
          (((0, 0), (972, 972)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#39#           =>  --  01D739
          (((0, 0), (973, 973)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#3B#           =>  --  01D73B
          (((0, 0), (5630, 5630)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#3C#           =>  --  01D73C
          (((0, 0), (632, 632)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#3D#           =>  --  01D73D
          (((0, 0), (646, 646)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#3E#           =>  --  01D73E
          (((0, 0), (621, 621)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#3F#           =>  --  01D73F
          (((0, 0), (653, 653)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#40#           =>  --  01D740
          (((0, 0), (5631, 5631)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#41#           =>  --  01D741
          (((0, 0), (11, 11)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#42#           =>  --  01D742
          (((0, 0), (5632, 5632)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#43#           =>  --  01D743
          (((0, 0), (5633, 5633)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#44#           =>  --  01D744
          (((0, 0), (639, 639)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#45#           =>  --  01D745
          (((0, 0), (652, 652)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#46#           =>  --  01D746
          (((0, 0), (654, 654)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#47#           =>  --  01D747
          (((0, 0), (655, 655)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#48#           =>  --  01D748
          (((0, 0), (5634, 5634)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#49#           =>  --  01D749
          (((0, 0), (5635, 5635)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#4A#           =>  --  01D74A
          (((0, 0), (636, 636)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#4B#           =>  --  01D74B
          (((0, 0), (651, 651)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#4C#           =>  --  01D74C
          (((0, 0), (974, 974)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#4D#           =>  --  01D74D
          (((0, 0), (5636, 5636)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#4E#           =>  --  01D74E
          (((0, 0), (643, 643)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#4F#           =>  --  01D74F
          (((0, 0), (5637, 5637)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#51#           =>  --  01D751
          (((0, 0), (646, 646)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#52#           =>  --  01D752
          (((0, 0), (653, 653)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#53#           =>  --  01D753
          (((0, 0), (651, 651)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#54#           =>  --  01D754
          (((0, 0), (654, 654)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#55#           =>  --  01D755
          (((0, 0), (652, 652)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#56#           =>  --  01D756
          (((0, 0), (607, 607)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#57#           =>  --  01D757
          (((0, 0), (5617, 5617)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#58#           =>  --  01D758
          (((0, 0), (2286, 2286)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#59#           =>  --  01D759
          (((0, 0), (5618, 5618)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#5A#           =>  --  01D75A
          (((0, 0), (609, 609)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#5B#           =>  --  01D75B
          (((0, 0), (5619, 5619)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#5C#           =>  --  01D75C
          (((0, 0), (611, 611)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#5D#           =>  --  01D75D
          (((0, 0), (656, 656)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#5E#           =>  --  01D75E
          (((0, 0), (613, 613)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#5F#           =>  --  01D75F
          (((0, 0), (5620, 5620)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#60#           =>  --  01D760
          (((0, 0), (5621, 5621)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#61#           =>  --  01D761
          (((0, 0), (5622, 5622)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#62#           =>  --  01D762
          (((0, 0), (5623, 5623)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#63#           =>  --  01D763
          (((0, 0), (5624, 5624)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#64#           =>  --  01D764
          (((0, 0), (615, 615)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#65#           =>  --  01D765
          (((0, 0), (2287, 2287)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#66#           =>  --  01D766
          (((0, 0), (2182, 2182)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#67#           =>  --  01D767
          (((0, 0), (656, 656)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#68#           =>  --  01D768
          (((0, 0), (657, 657)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#69#           =>  --  01D769
          (((0, 0), (5625, 5625)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#6A#           =>  --  01D76A
          (((0, 0), (617, 617)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#6B#           =>  --  01D76B
          (((0, 0), (5626, 5626)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#6C#           =>  --  01D76C
          (((0, 0), (5627, 5627)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#6D#           =>  --  01D76D
          (((0, 0), (5628, 5628)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#6E#           =>  --  01D76E
          (((0, 0), (619, 619)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#6F#           =>  --  01D76F
          (((0, 0), (5629, 5629)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#70#           =>  --  01D770
          (((0, 0), (628, 628)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#71#           =>  --  01D771
          (((0, 0), (645, 645)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#72#           =>  --  01D772
          (((0, 0), (972, 972)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#73#           =>  --  01D773
          (((0, 0), (973, 973)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#75#           =>  --  01D775
          (((0, 0), (5630, 5630)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#76#           =>  --  01D776
          (((0, 0), (632, 632)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#77#           =>  --  01D777
          (((0, 0), (646, 646)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#78#           =>  --  01D778
          (((0, 0), (621, 621)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#79#           =>  --  01D779
          (((0, 0), (653, 653)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#7A#           =>  --  01D77A
          (((0, 0), (5631, 5631)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#7B#           =>  --  01D77B
          (((0, 0), (11, 11)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#7C#           =>  --  01D77C
          (((0, 0), (5632, 5632)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#7D#           =>  --  01D77D
          (((0, 0), (5633, 5633)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#7E#           =>  --  01D77E
          (((0, 0), (639, 639)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#7F#           =>  --  01D77F
          (((0, 0), (652, 652)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#80#           =>  --  01D780
          (((0, 0), (654, 654)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#81#           =>  --  01D781
          (((0, 0), (655, 655)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#82#           =>  --  01D782
          (((0, 0), (5634, 5634)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#83#           =>  --  01D783
          (((0, 0), (5635, 5635)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#84#           =>  --  01D784
          (((0, 0), (636, 636)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#85#           =>  --  01D785
          (((0, 0), (651, 651)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#86#           =>  --  01D786
          (((0, 0), (974, 974)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#87#           =>  --  01D787
          (((0, 0), (5636, 5636)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#88#           =>  --  01D788
          (((0, 0), (643, 643)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#89#           =>  --  01D789
          (((0, 0), (5637, 5637)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#8B#           =>  --  01D78B
          (((0, 0), (646, 646)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#8C#           =>  --  01D78C
          (((0, 0), (653, 653)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#8D#           =>  --  01D78D
          (((0, 0), (651, 651)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#8E#           =>  --  01D78E
          (((0, 0), (654, 654)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#8F#           =>  --  01D78F
          (((0, 0), (652, 652)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#90#           =>  --  01D790
          (((0, 0), (607, 607)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#91#           =>  --  01D791
          (((0, 0), (5617, 5617)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#92#           =>  --  01D792
          (((0, 0), (2286, 2286)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#93#           =>  --  01D793
          (((0, 0), (5618, 5618)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#94#           =>  --  01D794
          (((0, 0), (609, 609)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#95#           =>  --  01D795
          (((0, 0), (5619, 5619)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#96#           =>  --  01D796
          (((0, 0), (611, 611)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#97#           =>  --  01D797
          (((0, 0), (656, 656)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#98#           =>  --  01D798
          (((0, 0), (613, 613)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#99#           =>  --  01D799
          (((0, 0), (5620, 5620)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#9A#           =>  --  01D79A
          (((0, 0), (5621, 5621)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#9B#           =>  --  01D79B
          (((0, 0), (5622, 5622)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#9C#           =>  --  01D79C
          (((0, 0), (5623, 5623)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#9D#           =>  --  01D79D
          (((0, 0), (5624, 5624)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#9E#           =>  --  01D79E
          (((0, 0), (615, 615)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#9F#           =>  --  01D79F
          (((0, 0), (2287, 2287)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#A0#           =>  --  01D7A0
          (((0, 0), (2182, 2182)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#A1#           =>  --  01D7A1
          (((0, 0), (656, 656)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#A2#           =>  --  01D7A2
          (((0, 0), (657, 657)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#A3#           =>  --  01D7A3
          (((0, 0), (5625, 5625)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#A4#           =>  --  01D7A4
          (((0, 0), (617, 617)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#A5#           =>  --  01D7A5
          (((0, 0), (5626, 5626)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#A6#           =>  --  01D7A6
          (((0, 0), (5627, 5627)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#A7#           =>  --  01D7A7
          (((0, 0), (5628, 5628)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#A8#           =>  --  01D7A8
          (((0, 0), (619, 619)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#A9#           =>  --  01D7A9
          (((0, 0), (5629, 5629)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#AA#           =>  --  01D7AA
          (((0, 0), (628, 628)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#AB#           =>  --  01D7AB
          (((0, 0), (645, 645)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#AC#           =>  --  01D7AC
          (((0, 0), (972, 972)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#AD#           =>  --  01D7AD
          (((0, 0), (973, 973)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#AF#           =>  --  01D7AF
          (((0, 0), (5630, 5630)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#B0#           =>  --  01D7B0
          (((0, 0), (632, 632)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#B1#           =>  --  01D7B1
          (((0, 0), (646, 646)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#B2#           =>  --  01D7B2
          (((0, 0), (621, 621)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#B3#           =>  --  01D7B3
          (((0, 0), (653, 653)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#B4#           =>  --  01D7B4
          (((0, 0), (5631, 5631)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#B5#           =>  --  01D7B5
          (((0, 0), (11, 11)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#B6#           =>  --  01D7B6
          (((0, 0), (5632, 5632)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#B7#           =>  --  01D7B7
          (((0, 0), (5633, 5633)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#B8#           =>  --  01D7B8
          (((0, 0), (639, 639)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#B9#           =>  --  01D7B9
          (((0, 0), (652, 652)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#BA#           =>  --  01D7BA
          (((0, 0), (654, 654)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#BB#           =>  --  01D7BB
          (((0, 0), (655, 655)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#BC#           =>  --  01D7BC
          (((0, 0), (5634, 5634)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#BD#           =>  --  01D7BD
          (((0, 0), (5635, 5635)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#BE#           =>  --  01D7BE
          (((0, 0), (636, 636)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#BF#           =>  --  01D7BF
          (((0, 0), (651, 651)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#C0#           =>  --  01D7C0
          (((0, 0), (974, 974)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#C1#           =>  --  01D7C1
          (((0, 0), (5636, 5636)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#C2#           =>  --  01D7C2
          (((0, 0), (643, 643)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#C3#           =>  --  01D7C3
          (((0, 0), (5637, 5637)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#C5#           =>  --  01D7C5
          (((0, 0), (646, 646)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#C6#           =>  --  01D7C6
          (((0, 0), (653, 653)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#C7#           =>  --  01D7C7
          (((0, 0), (651, 651)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#C8#           =>  --  01D7C8
          (((0, 0), (654, 654)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#C9#           =>  --  01D7C9
          (((0, 0), (652, 652)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#CA#           =>  --  01D7CA
          (((0, 0), (5638, 5638)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#CB#           =>  --  01D7CB
          (((0, 0), (5639, 5639)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#CC# .. 16#CD# =>  --  01D7CC .. 01D7CD
          (((0, 0), (0, 0)), (0, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         16#CE#           =>  --  01D7CE
          (((0, 0), (2238, 2238)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#CF#           =>  --  01D7CF
          (((0, 0), (14, 14)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#D0#           =>  --  01D7D0
          (((0, 0), (7, 7)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#D1#           =>  --  01D7D1
          (((0, 0), (8, 8)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#D2#           =>  --  01D7D2
          (((0, 0), (18, 18)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#D3#           =>  --  01D7D3
          (((0, 0), (2239, 2239)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#D4#           =>  --  01D7D4
          (((0, 0), (2240, 2240)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#D5#           =>  --  01D7D5
          (((0, 0), (2241, 2241)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#D6#           =>  --  01D7D6
          (((0, 0), (2242, 2242)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#D7#           =>  --  01D7D7
          (((0, 0), (2243, 2243)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#D8#           =>  --  01D7D8
          (((0, 0), (2238, 2238)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#D9#           =>  --  01D7D9
          (((0, 0), (14, 14)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#DA#           =>  --  01D7DA
          (((0, 0), (7, 7)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#DB#           =>  --  01D7DB
          (((0, 0), (8, 8)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#DC#           =>  --  01D7DC
          (((0, 0), (18, 18)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#DD#           =>  --  01D7DD
          (((0, 0), (2239, 2239)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#DE#           =>  --  01D7DE
          (((0, 0), (2240, 2240)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#DF#           =>  --  01D7DF
          (((0, 0), (2241, 2241)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#E0#           =>  --  01D7E0
          (((0, 0), (2242, 2242)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#E1#           =>  --  01D7E1
          (((0, 0), (2243, 2243)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#E2#           =>  --  01D7E2
          (((0, 0), (2238, 2238)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#E3#           =>  --  01D7E3
          (((0, 0), (14, 14)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#E4#           =>  --  01D7E4
          (((0, 0), (7, 7)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#E5#           =>  --  01D7E5
          (((0, 0), (8, 8)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#E6#           =>  --  01D7E6
          (((0, 0), (18, 18)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#E7#           =>  --  01D7E7
          (((0, 0), (2239, 2239)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#E8#           =>  --  01D7E8
          (((0, 0), (2240, 2240)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#E9#           =>  --  01D7E9
          (((0, 0), (2241, 2241)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#EA#           =>  --  01D7EA
          (((0, 0), (2242, 2242)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#EB#           =>  --  01D7EB
          (((0, 0), (2243, 2243)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#EC#           =>  --  01D7EC
          (((0, 0), (2238, 2238)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#ED#           =>  --  01D7ED
          (((0, 0), (14, 14)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#EE#           =>  --  01D7EE
          (((0, 0), (7, 7)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#EF#           =>  --  01D7EF
          (((0, 0), (8, 8)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#F0#           =>  --  01D7F0
          (((0, 0), (18, 18)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#F1#           =>  --  01D7F1
          (((0, 0), (2239, 2239)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#F2#           =>  --  01D7F2
          (((0, 0), (2240, 2240)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#F3#           =>  --  01D7F3
          (((0, 0), (2241, 2241)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#F4#           =>  --  01D7F4
          (((0, 0), (2242, 2242)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#F5#           =>  --  01D7F5
          (((0, 0), (2243, 2243)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#F6#           =>  --  01D7F6
          (((0, 0), (2238, 2238)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#F7#           =>  --  01D7F7
          (((0, 0), (14, 14)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#F8#           =>  --  01D7F8
          (((0, 0), (7, 7)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#F9#           =>  --  01D7F9
          (((0, 0), (8, 8)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#FA#           =>  --  01D7FA
          (((0, 0), (18, 18)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#FB#           =>  --  01D7FB
          (((0, 0), (2239, 2239)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#FC#           =>  --  01D7FC
          (((0, 0), (2240, 2240)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#FD#           =>  --  01D7FD
          (((0, 0), (2241, 2241)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#FE#           =>  --  01D7FE
          (((0, 0), (2242, 2242)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#FF#           =>  --  01D7FF
          (((0, 0), (2243, 2243)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         others           =>
          (((0, 0), (630, 630)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)));

   Group_01E8 : aliased constant Normalization_Mapping_Second_Stage
     := (16#D0# .. 16#D6# =>  --  01E8D0 .. 01E8D6
          (((0, 0), (0, 0)), (0, 0), 220, (Yes, Yes, Yes, Yes), None,
           (others => False)),
         others           =>
          (((0, 0), (0, 0)), (0, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)));

   Group_01EE : aliased constant Normalization_Mapping_Second_Stage
     := (16#00#           =>  --  01EE00
          (((0, 0), (764, 764)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#01#           =>  --  01EE01
          (((0, 0), (4842, 4842)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#02#           =>  --  01EE02
          (((0, 0), (4832, 4832)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#03#           =>  --  01EE03
          (((0, 0), (5434, 5434)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#05#           =>  --  01EE05
          (((0, 0), (768, 768)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#06#           =>  --  01EE06
          (((0, 0), (5029, 5029)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#07#           =>  --  01EE07
          (((0, 0), (4835, 4835)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#08#           =>  --  01EE08
          (((0, 0), (4906, 4906)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#09#           =>  --  01EE09
          (((0, 0), (772, 772)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#0A#           =>  --  01EE0A
          (((0, 0), (4940, 4940)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#0B#           =>  --  01EE0B
          (((0, 0), (4949, 4949)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#0C#           =>  --  01EE0C
          (((0, 0), (4838, 4838)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#0D#           =>  --  01EE0D
          (((0, 0), (4974, 4974)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#0E#           =>  --  01EE0E
          (((0, 0), (4886, 4886)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#0F#           =>  --  01EE0F
          (((0, 0), (4912, 4912)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#10#           =>  --  01EE10
          (((0, 0), (4920, 4920)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#11#           =>  --  01EE11
          (((0, 0), (4894, 4894)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#12#           =>  --  01EE12
          (((0, 0), (4932, 4932)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#13#           =>  --  01EE13
          (((0, 0), (5002, 5002)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#14#           =>  --  01EE14
          (((0, 0), (5087, 5087)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#15#           =>  --  01EE15
          (((0, 0), (4854, 4854)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#16#           =>  --  01EE16
          (((0, 0), (4866, 4866)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#17#           =>  --  01EE17
          (((0, 0), (4847, 4847)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#18#           =>  --  01EE18
          (((0, 0), (5000, 5000)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#19#           =>  --  01EE19
          (((0, 0), (4898, 4898)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#1A#           =>  --  01EE1A
          (((0, 0), (4910, 4910)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#1B#           =>  --  01EE1B
          (((0, 0), (4916, 4916)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#1C#           =>  --  01EE1C
          (((0, 0), (5640, 5640)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#1D#           =>  --  01EE1D
          (((0, 0), (4797, 4797)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#1E#           =>  --  01EE1E
          (((0, 0), (5641, 5641)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#1F#           =>  --  01EE1F
          (((0, 0), (5642, 5642)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#21#           =>  --  01EE21
          (((0, 0), (4842, 4842)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#22#           =>  --  01EE22
          (((0, 0), (4832, 4832)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#24#           =>  --  01EE24
          (((0, 0), (4986, 4986)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#27#           =>  --  01EE27
          (((0, 0), (4835, 4835)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#29#           =>  --  01EE29
          (((0, 0), (772, 772)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#2A#           =>  --  01EE2A
          (((0, 0), (4940, 4940)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#2B#           =>  --  01EE2B
          (((0, 0), (4949, 4949)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#2C#           =>  --  01EE2C
          (((0, 0), (4838, 4838)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#2D#           =>  --  01EE2D
          (((0, 0), (4974, 4974)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#2E#           =>  --  01EE2E
          (((0, 0), (4886, 4886)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#2F#           =>  --  01EE2F
          (((0, 0), (4912, 4912)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#30#           =>  --  01EE30
          (((0, 0), (4920, 4920)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#31#           =>  --  01EE31
          (((0, 0), (4894, 4894)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#32#           =>  --  01EE32
          (((0, 0), (4932, 4932)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#34#           =>  --  01EE34
          (((0, 0), (5087, 5087)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#35#           =>  --  01EE35
          (((0, 0), (4854, 4854)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#36#           =>  --  01EE36
          (((0, 0), (4866, 4866)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#37#           =>  --  01EE37
          (((0, 0), (4847, 4847)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#39#           =>  --  01EE39
          (((0, 0), (4898, 4898)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#3B#           =>  --  01EE3B
          (((0, 0), (4916, 4916)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#42#           =>  --  01EE42
          (((0, 0), (4832, 4832)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#47#           =>  --  01EE47
          (((0, 0), (4835, 4835)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#49#           =>  --  01EE49
          (((0, 0), (772, 772)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#4B#           =>  --  01EE4B
          (((0, 0), (4949, 4949)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#4D#           =>  --  01EE4D
          (((0, 0), (4974, 4974)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#4E#           =>  --  01EE4E
          (((0, 0), (4886, 4886)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#4F#           =>  --  01EE4F
          (((0, 0), (4912, 4912)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#51#           =>  --  01EE51
          (((0, 0), (4894, 4894)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#52#           =>  --  01EE52
          (((0, 0), (4932, 4932)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#54#           =>  --  01EE54
          (((0, 0), (5087, 5087)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#57#           =>  --  01EE57
          (((0, 0), (4847, 4847)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#59#           =>  --  01EE59
          (((0, 0), (4898, 4898)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#5B#           =>  --  01EE5B
          (((0, 0), (4916, 4916)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#5D#           =>  --  01EE5D
          (((0, 0), (4797, 4797)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#5F#           =>  --  01EE5F
          (((0, 0), (5642, 5642)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#61#           =>  --  01EE61
          (((0, 0), (4842, 4842)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#62#           =>  --  01EE62
          (((0, 0), (4832, 4832)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#64#           =>  --  01EE64
          (((0, 0), (4986, 4986)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#67#           =>  --  01EE67
          (((0, 0), (4835, 4835)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#68#           =>  --  01EE68
          (((0, 0), (4906, 4906)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#69#           =>  --  01EE69
          (((0, 0), (772, 772)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#6A#           =>  --  01EE6A
          (((0, 0), (4940, 4940)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#6C#           =>  --  01EE6C
          (((0, 0), (4838, 4838)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#6D#           =>  --  01EE6D
          (((0, 0), (4974, 4974)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#6E#           =>  --  01EE6E
          (((0, 0), (4886, 4886)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#6F#           =>  --  01EE6F
          (((0, 0), (4912, 4912)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#70#           =>  --  01EE70
          (((0, 0), (4920, 4920)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#71#           =>  --  01EE71
          (((0, 0), (4894, 4894)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#72#           =>  --  01EE72
          (((0, 0), (4932, 4932)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#74#           =>  --  01EE74
          (((0, 0), (5087, 5087)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#75#           =>  --  01EE75
          (((0, 0), (4854, 4854)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#76#           =>  --  01EE76
          (((0, 0), (4866, 4866)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#77#           =>  --  01EE77
          (((0, 0), (4847, 4847)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#79#           =>  --  01EE79
          (((0, 0), (4898, 4898)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#7A#           =>  --  01EE7A
          (((0, 0), (4910, 4910)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#7B#           =>  --  01EE7B
          (((0, 0), (4916, 4916)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#7C#           =>  --  01EE7C
          (((0, 0), (5640, 5640)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#7E#           =>  --  01EE7E
          (((0, 0), (5641, 5641)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#80#           =>  --  01EE80
          (((0, 0), (764, 764)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#81#           =>  --  01EE81
          (((0, 0), (4842, 4842)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#82#           =>  --  01EE82
          (((0, 0), (4832, 4832)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#83#           =>  --  01EE83
          (((0, 0), (5434, 5434)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#84#           =>  --  01EE84
          (((0, 0), (4986, 4986)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#85#           =>  --  01EE85
          (((0, 0), (768, 768)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#86#           =>  --  01EE86
          (((0, 0), (5029, 5029)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#87#           =>  --  01EE87
          (((0, 0), (4835, 4835)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#88#           =>  --  01EE88
          (((0, 0), (4906, 4906)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#89#           =>  --  01EE89
          (((0, 0), (772, 772)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#8B#           =>  --  01EE8B
          (((0, 0), (4949, 4949)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#8C#           =>  --  01EE8C
          (((0, 0), (4838, 4838)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#8D#           =>  --  01EE8D
          (((0, 0), (4974, 4974)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#8E#           =>  --  01EE8E
          (((0, 0), (4886, 4886)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#8F#           =>  --  01EE8F
          (((0, 0), (4912, 4912)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#90#           =>  --  01EE90
          (((0, 0), (4920, 4920)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#91#           =>  --  01EE91
          (((0, 0), (4894, 4894)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#92#           =>  --  01EE92
          (((0, 0), (4932, 4932)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#93#           =>  --  01EE93
          (((0, 0), (5002, 5002)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#94#           =>  --  01EE94
          (((0, 0), (5087, 5087)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#95#           =>  --  01EE95
          (((0, 0), (4854, 4854)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#96#           =>  --  01EE96
          (((0, 0), (4866, 4866)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#97#           =>  --  01EE97
          (((0, 0), (4847, 4847)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#98#           =>  --  01EE98
          (((0, 0), (5000, 5000)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#99#           =>  --  01EE99
          (((0, 0), (4898, 4898)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#9A#           =>  --  01EE9A
          (((0, 0), (4910, 4910)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#9B#           =>  --  01EE9B
          (((0, 0), (4916, 4916)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#A1#           =>  --  01EEA1
          (((0, 0), (4842, 4842)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#A2#           =>  --  01EEA2
          (((0, 0), (4832, 4832)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#A3#           =>  --  01EEA3
          (((0, 0), (5434, 5434)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#A5#           =>  --  01EEA5
          (((0, 0), (768, 768)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#A6#           =>  --  01EEA6
          (((0, 0), (5029, 5029)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#A7#           =>  --  01EEA7
          (((0, 0), (4835, 4835)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#A8#           =>  --  01EEA8
          (((0, 0), (4906, 4906)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#A9#           =>  --  01EEA9
          (((0, 0), (772, 772)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#AB#           =>  --  01EEAB
          (((0, 0), (4949, 4949)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#AC#           =>  --  01EEAC
          (((0, 0), (4838, 4838)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#AD#           =>  --  01EEAD
          (((0, 0), (4974, 4974)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#AE#           =>  --  01EEAE
          (((0, 0), (4886, 4886)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#AF#           =>  --  01EEAF
          (((0, 0), (4912, 4912)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#B0#           =>  --  01EEB0
          (((0, 0), (4920, 4920)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#B1#           =>  --  01EEB1
          (((0, 0), (4894, 4894)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#B2#           =>  --  01EEB2
          (((0, 0), (4932, 4932)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#B3#           =>  --  01EEB3
          (((0, 0), (5002, 5002)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#B4#           =>  --  01EEB4
          (((0, 0), (5087, 5087)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#B5#           =>  --  01EEB5
          (((0, 0), (4854, 4854)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#B6#           =>  --  01EEB6
          (((0, 0), (4866, 4866)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#B7#           =>  --  01EEB7
          (((0, 0), (4847, 4847)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#B8#           =>  --  01EEB8
          (((0, 0), (5000, 5000)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#B9#           =>  --  01EEB9
          (((0, 0), (4898, 4898)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#BA#           =>  --  01EEBA
          (((0, 0), (4910, 4910)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         16#BB#           =>  --  01EEBB
          (((0, 0), (4916, 4916)), (0, 0), 0, (Yes, Yes, No, No), Font,
           (others => False)),
         others           =>
          (((0, 0), (0, 0)), (0, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)));

   Group_01F1 : aliased constant Normalization_Mapping_Second_Stage
     := (16#00#           =>  --  01F100
          (((0, 0), (2594, 2595)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#01#           =>  --  01F101
          (((0, 0), (5643, 5644)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#02#           =>  --  01F102
          (((0, 0), (5645, 5646)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#03#           =>  --  01F103
          (((0, 0), (5647, 5648)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#04#           =>  --  01F104
          (((0, 0), (5649, 5650)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#05#           =>  --  01F105
          (((0, 0), (5651, 5652)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#06#           =>  --  01F106
          (((0, 0), (5653, 5654)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#07#           =>  --  01F107
          (((0, 0), (5655, 5656)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#08#           =>  --  01F108
          (((0, 0), (5657, 5658)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#09#           =>  --  01F109
          (((0, 0), (5659, 5660)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#0A#           =>  --  01F10A
          (((0, 0), (5661, 5662)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#10#           =>  --  01F110
          (((0, 0), (5663, 5665)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#11#           =>  --  01F111
          (((0, 0), (5666, 5668)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#12#           =>  --  01F112
          (((0, 0), (5669, 5671)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#13#           =>  --  01F113
          (((0, 0), (5672, 5674)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#14#           =>  --  01F114
          (((0, 0), (5675, 5677)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#15#           =>  --  01F115
          (((0, 0), (5678, 5680)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#16#           =>  --  01F116
          (((0, 0), (5681, 5683)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#17#           =>  --  01F117
          (((0, 0), (5684, 5686)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#18#           =>  --  01F118
          (((0, 0), (5687, 5689)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#19#           =>  --  01F119
          (((0, 0), (5690, 5692)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#1A#           =>  --  01F11A
          (((0, 0), (5693, 5695)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#1B#           =>  --  01F11B
          (((0, 0), (5696, 5698)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#1C#           =>  --  01F11C
          (((0, 0), (5699, 5701)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#1D#           =>  --  01F11D
          (((0, 0), (5702, 5704)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#1E#           =>  --  01F11E
          (((0, 0), (5705, 5707)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#1F#           =>  --  01F11F
          (((0, 0), (5708, 5710)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#20#           =>  --  01F120
          (((0, 0), (5711, 5713)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#21#           =>  --  01F121
          (((0, 0), (5714, 5716)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#22#           =>  --  01F122
          (((0, 0), (5717, 5719)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#23#           =>  --  01F123
          (((0, 0), (5720, 5722)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#24#           =>  --  01F124
          (((0, 0), (5723, 5725)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#25#           =>  --  01F125
          (((0, 0), (5726, 5728)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#26#           =>  --  01F126
          (((0, 0), (5729, 5731)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#27#           =>  --  01F127
          (((0, 0), (5732, 5734)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#28#           =>  --  01F128
          (((0, 0), (5735, 5737)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#29#           =>  --  01F129
          (((0, 0), (5738, 5740)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#2A#           =>  --  01F12A
          (((0, 0), (5741, 5743)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#2B#           =>  --  01F12B
          (((0, 0), (37, 37)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#2C#           =>  --  01F12C
          (((0, 0), (275, 275)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#2D#           =>  --  01F12D
          (((0, 0), (5744, 5745)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (Expands_On_NFKD => True,
            others => False)),
         16#2E#           =>  --  01F12E
          (((0, 0), (5746, 5747)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (Expands_On_NFKD => True,
            others => False)),
         16#30#           =>  --  01F130
          (((0, 0), (25, 25)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (others => False)),
         16#31#           =>  --  01F131
          (((0, 0), (950, 950)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (others => False)),
         16#32#           =>  --  01F132
          (((0, 0), (37, 37)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (others => False)),
         16#33#           =>  --  01F133
          (((0, 0), (159, 159)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (others => False)),
         16#34#           =>  --  01F134
          (((0, 0), (39, 39)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (others => False)),
         16#35#           =>  --  01F135
          (((0, 0), (1076, 1076)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (others => False)),
         16#36#           =>  --  01F136
          (((0, 0), (183, 183)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (others => False)),
         16#37#           =>  --  01F137
          (((0, 0), (199, 199)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (others => False)),
         16#38#           =>  --  01F138
          (((0, 0), (47, 47)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (others => False)),
         16#39#           =>  --  01F139
          (((0, 0), (222, 222)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (others => False)),
         16#3A#           =>  --  01F13A
          (((0, 0), (229, 229)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (others => False)),
         16#3B#           =>  --  01F13B
          (((0, 0), (233, 233)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (others => False)),
         16#3C#           =>  --  01F13C
          (((0, 0), (952, 952)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (others => False)),
         16#3D#           =>  --  01F13D
          (((0, 0), (55, 55)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (others => False)),
         16#3E#           =>  --  01F13E
          (((0, 0), (57, 57)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (others => False)),
         16#3F#           =>  --  01F13F
          (((0, 0), (954, 954)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (others => False)),
         16#40#           =>  --  01F140
          (((0, 0), (2271, 2271)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (others => False)),
         16#41#           =>  --  01F141
          (((0, 0), (275, 275)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (others => False)),
         16#42#           =>  --  01F142
          (((0, 0), (287, 287)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (others => False)),
         16#43#           =>  --  01F143
          (((0, 0), (303, 303)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (others => False)),
         16#44#           =>  --  01F144
          (((0, 0), (67, 67)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (others => False)),
         16#45#           =>  --  01F145
          (((0, 0), (1288, 1288)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (others => False)),
         16#46#           =>  --  01F146
          (((0, 0), (335, 335)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (others => False)),
         16#47#           =>  --  01F147
          (((0, 0), (1316, 1316)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (others => False)),
         16#48#           =>  --  01F148
          (((0, 0), (75, 75)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (others => False)),
         16#49#           =>  --  01F149
          (((0, 0), (345, 345)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (others => False)),
         16#4A#           =>  --  01F14A
          (((0, 0), (5748, 5749)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#4B#           =>  --  01F14B
          (((0, 0), (4089, 4090)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#4C#           =>  --  01F14C
          (((0, 0), (5750, 5751)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#4D#           =>  --  01F14D
          (((0, 0), (5752, 5753)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#4E#           =>  --  01F14E
          (((0, 0), (5754, 5756)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#4F#           =>  --  01F14F
          (((0, 0), (5757, 5758)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#6A#           =>  --  01F16A
          (((0, 0), (5759, 5760)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (Expands_On_NFKD => True,
            others => False)),
         16#6B#           =>  --  01F16B
          (((0, 0), (5761, 5762)), (0, 0), 0, (Yes, Yes, No, No), Super,
           (Expands_On_NFKD => True,
            others => False)),
         16#90#           =>  --  01F190
          (((0, 0), (5763, 5764)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         others           =>
          (((0, 0), (0, 0)), (0, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)));

   Group_01F2 : aliased constant Normalization_Mapping_Second_Stage
     := (16#00#           =>  --  01F200
          (((0, 0), (5765, 5766)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#01#           =>  --  01F201
          (((0, 0), (5767, 5768)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#02#           =>  --  01F202
          (((0, 0), (3001, 3001)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (others => False)),
         16#10#           =>  --  01F210
          (((0, 0), (2777, 2777)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (others => False)),
         16#11#           =>  --  01F211
          (((0, 0), (5769, 5769)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (others => False)),
         16#12#           =>  --  01F212
          (((0, 0), (5770, 5770)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (others => False)),
         16#13#           =>  --  01F213
          (((0, 0), (3017, 3018)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (Expands_On_NFKD => True,
            others => False)),
         16#14#           =>  --  01F214
          (((0, 0), (2720, 2720)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (others => False)),
         16#15#           =>  --  01F215
          (((0, 0), (5771, 5771)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (others => False)),
         16#16#           =>  --  01F216
          (((0, 0), (5772, 5772)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (others => False)),
         16#17#           =>  --  01F217
          (((0, 0), (3157, 3157)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (others => False)),
         16#18#           =>  --  01F218
          (((0, 0), (5773, 5773)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (others => False)),
         16#19#           =>  --  01F219
          (((0, 0), (5774, 5774)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (others => False)),
         16#1A#           =>  --  01F21A
          (((0, 0), (5775, 5775)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (others => False)),
         16#1B#           =>  --  01F21B
          (((0, 0), (4448, 4448)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (others => False)),
         16#1C#           =>  --  01F21C
          (((0, 0), (5776, 5776)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (others => False)),
         16#1D#           =>  --  01F21D
          (((0, 0), (5777, 5777)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (others => False)),
         16#1E#           =>  --  01F21E
          (((0, 0), (5778, 5778)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (others => False)),
         16#1F#           =>  --  01F21F
          (((0, 0), (5779, 5779)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (others => False)),
         16#20#           =>  --  01F220
          (((0, 0), (5780, 5780)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (others => False)),
         16#21#           =>  --  01F221
          (((0, 0), (5781, 5781)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (others => False)),
         16#22#           =>  --  01F222
          (((0, 0), (2813, 2813)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (others => False)),
         16#23#           =>  --  01F223
          (((0, 0), (5782, 5782)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (others => False)),
         16#24#           =>  --  01F224
          (((0, 0), (5783, 5783)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (others => False)),
         16#25#           =>  --  01F225
          (((0, 0), (5784, 5784)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (others => False)),
         16#26#           =>  --  01F226
          (((0, 0), (5785, 5785)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (others => False)),
         16#27#           =>  --  01F227
          (((0, 0), (5786, 5786)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (others => False)),
         16#28#           =>  --  01F228
          (((0, 0), (5787, 5787)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (others => False)),
         16#29#           =>  --  01F229
          (((0, 0), (2714, 2714)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (others => False)),
         16#2A#           =>  --  01F22A
          (((0, 0), (3149, 3149)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (others => False)),
         16#2B#           =>  --  01F22B
          (((0, 0), (5788, 5788)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (others => False)),
         16#2C#           =>  --  01F22C
          (((0, 0), (3430, 3430)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (others => False)),
         16#2D#           =>  --  01F22D
          (((0, 0), (3152, 3152)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (others => False)),
         16#2E#           =>  --  01F22E
          (((0, 0), (3431, 3431)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (others => False)),
         16#2F#           =>  --  01F22F
          (((0, 0), (5789, 5789)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (others => False)),
         16#30#           =>  --  01F230
          (((0, 0), (2869, 2869)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (others => False)),
         16#31#           =>  --  01F231
          (((0, 0), (5790, 5790)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (others => False)),
         16#32#           =>  --  01F232
          (((0, 0), (5791, 5791)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (others => False)),
         16#33#           =>  --  01F233
          (((0, 0), (5792, 5792)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (others => False)),
         16#34#           =>  --  01F234
          (((0, 0), (5793, 5793)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (others => False)),
         16#35#           =>  --  01F235
          (((0, 0), (5794, 5794)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (others => False)),
         16#36#           =>  --  01F236
          (((0, 0), (3329, 3329)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (others => False)),
         16#37#           =>  --  01F237
          (((0, 0), (2787, 2787)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (others => False)),
         16#38#           =>  --  01F238
          (((0, 0), (5795, 5795)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (others => False)),
         16#39#           =>  --  01F239
          (((0, 0), (5796, 5796)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (others => False)),
         16#3A#           =>  --  01F23A
          (((0, 0), (5797, 5797)), (0, 0), 0, (Yes, Yes, No, No), Square,
           (others => False)),
         16#40#           =>  --  01F240
          (((0, 0), (5798, 5800)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#41#           =>  --  01F241
          (((0, 0), (5801, 5803)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#42#           =>  --  01F242
          (((0, 0), (5804, 5806)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#43#           =>  --  01F243
          (((0, 0), (5807, 5809)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#44#           =>  --  01F244
          (((0, 0), (5810, 5812)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#45#           =>  --  01F245
          (((0, 0), (5813, 5815)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#46#           =>  --  01F246
          (((0, 0), (5816, 5818)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#47#           =>  --  01F247
          (((0, 0), (5819, 5821)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#48#           =>  --  01F248
          (((0, 0), (5822, 5824)), (0, 0), 0, (Yes, Yes, No, No), Compat,
           (Expands_On_NFKD => True,
            others => False)),
         16#50#           =>  --  01F250
          (((0, 0), (5825, 5825)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         16#51#           =>  --  01F251
          (((0, 0), (5826, 5826)), (0, 0), 0, (Yes, Yes, No, No), Circle,
           (others => False)),
         others           =>
          (((0, 0), (0, 0)), (0, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)));

   Group_02F8 : aliased constant Normalization_Mapping_Second_Stage
     := (16#00#           =>  --  02F800
          (((5827, 5827), (5827, 5827)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#01#           =>  --  02F801
          (((5828, 5828), (5828, 5828)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#02#           =>  --  02F802
          (((5829, 5829), (5829, 5829)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#03#           =>  --  02F803
          (((5830, 5830), (5830, 5830)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#04#           =>  --  02F804
          (((5831, 5831), (5831, 5831)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#05#           =>  --  02F805
          (((4541, 4541), (4541, 4541)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#06#           =>  --  02F806
          (((5832, 5832), (5832, 5832)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#07#           =>  --  02F807
          (((5833, 5833), (5833, 5833)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#08#           =>  --  02F808
          (((5834, 5834), (5834, 5834)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#09#           =>  --  02F809
          (((5835, 5835), (5835, 5835)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#0A#           =>  --  02F80A
          (((4542, 4542), (4542, 4542)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#0B#           =>  --  02F80B
          (((5836, 5836), (5836, 5836)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#0C#           =>  --  02F80C
          (((5837, 5837), (5837, 5837)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#0D#           =>  --  02F80D
          (((5838, 5838), (5838, 5838)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#0E#           =>  --  02F80E
          (((4543, 4543), (4543, 4543)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#0F#           =>  --  02F80F
          (((5839, 5839), (5839, 5839)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#10#           =>  --  02F810
          (((5840, 5840), (5840, 5840)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#11#           =>  --  02F811
          (((5841, 5841), (5841, 5841)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#12#           =>  --  02F812
          (((5842, 5842), (5842, 5842)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#13#           =>  --  02F813
          (((5843, 5843), (5843, 5843)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#14#           =>  --  02F814
          (((5844, 5844), (5844, 5844)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#15#           =>  --  02F815
          (((5778, 5778), (5778, 5778)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#16#           =>  --  02F816
          (((5845, 5845), (5845, 5845)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#17#           =>  --  02F817
          (((5846, 5846), (5846, 5846)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#18#           =>  --  02F818
          (((5847, 5847), (5847, 5847)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#19#           =>  --  02F819
          (((5848, 5848), (5848, 5848)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#1A#           =>  --  02F81A
          (((5849, 5849), (5849, 5849)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#1B#           =>  --  02F81B
          (((4598, 4598), (4598, 4598)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#1C#           =>  --  02F81C
          (((5850, 5850), (5850, 5850)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#1D#           =>  --  02F81D
          (((2730, 2730), (2730, 2730)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#1E#           =>  --  02F81E
          (((5851, 5851), (5851, 5851)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#1F#           =>  --  02F81F
          (((5852, 5852), (5852, 5852)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#20#           =>  --  02F820
          (((5853, 5853), (5853, 5853)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#21#           =>  --  02F821
          (((5854, 5854), (5854, 5854)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#22#           =>  --  02F822
          (((5796, 5796), (5796, 5796)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#23#           =>  --  02F823
          (((5855, 5855), (5855, 5855)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#24#           =>  --  02F824
          (((5856, 5856), (5856, 5856)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#25#           =>  --  02F825
          (((4603, 4603), (4603, 4603)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#26#           =>  --  02F826
          (((4544, 4544), (4544, 4544)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#27#           =>  --  02F827
          (((4545, 4545), (4545, 4545)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#28#           =>  --  02F828
          (((4604, 4604), (4604, 4604)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#29#           =>  --  02F829
          (((5857, 5857), (5857, 5857)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#2A#           =>  --  02F82A
          (((5858, 5858), (5858, 5858)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#2B#           =>  --  02F82B
          (((4362, 4362), (4362, 4362)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#2C#           =>  --  02F82C
          (((5859, 5859), (5859, 5859)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#2D#           =>  --  02F82D
          (((4546, 4546), (4546, 4546)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#2E#           =>  --  02F82E
          (((5860, 5860), (5860, 5860)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#2F#           =>  --  02F82F
          (((5861, 5861), (5861, 5861)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#30#           =>  --  02F830
          (((5862, 5862), (5862, 5862)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#34#           =>  --  02F834
          (((5864, 5864), (5864, 5864)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#35#           =>  --  02F835
          (((5865, 5865), (5865, 5865)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#36#           =>  --  02F836
          (((5866, 5866), (5866, 5866)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#37#           =>  --  02F837
          (((5867, 5867), (5867, 5867)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#38#           =>  --  02F838
          (((5868, 5868), (5868, 5868)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#39#           =>  --  02F839
          (((5869, 5869), (5869, 5869)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#3A#           =>  --  02F83A
          (((5870, 5870), (5870, 5870)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#3B#           =>  --  02F83B
          (((5871, 5871), (5871, 5871)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#3C#           =>  --  02F83C
          (((5872, 5872), (5872, 5872)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#3D#           =>  --  02F83D
          (((5873, 5873), (5873, 5873)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#3E#           =>  --  02F83E
          (((5874, 5874), (5874, 5874)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#3F#           =>  --  02F83F
          (((5875, 5875), (5875, 5875)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#40#           =>  --  02F840
          (((5876, 5876), (5876, 5876)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#41#           =>  --  02F841
          (((5877, 5877), (5877, 5877)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#42#           =>  --  02F842
          (((5878, 5878), (5878, 5878)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#43#           =>  --  02F843
          (((5879, 5879), (5879, 5879)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#44#           =>  --  02F844
          (((5880, 5880), (5880, 5880)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#45# .. 16#46# =>  --  02F845 .. 02F846
          (((5881, 5881), (5881, 5881)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#47#           =>  --  02F847
          (((4606, 4606), (4606, 4606)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#48#           =>  --  02F848
          (((5882, 5882), (5882, 5882)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#49#           =>  --  02F849
          (((5883, 5883), (5883, 5883)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#4A#           =>  --  02F84A
          (((5884, 5884), (5884, 5884)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#4B#           =>  --  02F84B
          (((5885, 5885), (5885, 5885)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#4C#           =>  --  02F84C
          (((4548, 4548), (4548, 4548)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#4D#           =>  --  02F84D
          (((5886, 5886), (5886, 5886)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#4E#           =>  --  02F84E
          (((5887, 5887), (5887, 5887)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#4F#           =>  --  02F84F
          (((5888, 5888), (5888, 5888)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#50#           =>  --  02F850
          (((4508, 4508), (4508, 4508)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#51#           =>  --  02F851
          (((5889, 5889), (5889, 5889)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#52#           =>  --  02F852
          (((5890, 5890), (5890, 5890)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#53#           =>  --  02F853
          (((5891, 5891), (5891, 5891)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#54#           =>  --  02F854
          (((5892, 5892), (5892, 5892)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#55#           =>  --  02F855
          (((5893, 5893), (5893, 5893)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#56#           =>  --  02F856
          (((5894, 5894), (5894, 5894)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#57#           =>  --  02F857
          (((5895, 5895), (5895, 5895)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#58#           =>  --  02F858
          (((5896, 5896), (5896, 5896)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#59#           =>  --  02F859
          (((5897, 5897), (5897, 5897)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#5A#           =>  --  02F85A
          (((5898, 5898), (5898, 5898)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#5B#           =>  --  02F85B
          (((5899, 5899), (5899, 5899)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#5C#           =>  --  02F85C
          (((5900, 5900), (5900, 5900)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#5D#           =>  --  02F85D
          (((5771, 5771), (5771, 5771)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#5E#           =>  --  02F85E
          (((5901, 5901), (5901, 5901)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#5F#           =>  --  02F85F
          (((5902, 5902), (5902, 5902)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#60#           =>  --  02F860
          (((5903, 5903), (5903, 5903)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#61#           =>  --  02F861
          (((5904, 5904), (5904, 5904)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#62#           =>  --  02F862
          (((5905, 5905), (5905, 5905)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#63#           =>  --  02F863
          (((5906, 5906), (5906, 5906)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#64#           =>  --  02F864
          (((5907, 5907), (5907, 5907)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#65#           =>  --  02F865
          (((5908, 5908), (5908, 5908)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#66#           =>  --  02F866
          (((5909, 5909), (5909, 5909)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#67#           =>  --  02F867
          (((5910, 5910), (5910, 5910)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#68#           =>  --  02F868
          (((5911, 5911), (5911, 5911)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#69#           =>  --  02F869
          (((5912, 5912), (5912, 5912)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#6A# .. 16#6B# =>  --  02F86A .. 02F86B
          (((5913, 5913), (5913, 5913)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#6C#           =>  --  02F86C
          (((5914, 5914), (5914, 5914)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#6D#           =>  --  02F86D
          (((5915, 5915), (5915, 5915)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#6E#           =>  --  02F86E
          (((5916, 5916), (5916, 5916)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#6F#           =>  --  02F86F
          (((4358, 4358), (4358, 4358)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#70#           =>  --  02F870
          (((5917, 5917), (5917, 5917)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#71#           =>  --  02F871
          (((5918, 5918), (5918, 5918)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#72#           =>  --  02F872
          (((5919, 5919), (5919, 5919)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#73#           =>  --  02F873
          (((5920, 5920), (5920, 5920)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#74#           =>  --  02F874
          (((5921, 5921), (5921, 5921)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#75#           =>  --  02F875
          (((2756, 2756), (2756, 2756)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#76#           =>  --  02F876
          (((5922, 5922), (5922, 5922)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#77#           =>  --  02F877
          (((5923, 5923), (5923, 5923)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#78#           =>  --  02F878
          (((2758, 2758), (2758, 2758)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#79#           =>  --  02F879
          (((5924, 5924), (5924, 5924)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#7A#           =>  --  02F87A
          (((5925, 5925), (5925, 5925)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#7B#           =>  --  02F87B
          (((5926, 5926), (5926, 5926)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#7C#           =>  --  02F87C
          (((5927, 5927), (5927, 5927)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#7D#           =>  --  02F87D
          (((5928, 5928), (5928, 5928)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#7E#           =>  --  02F87E
          (((5929, 5929), (5929, 5929)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#7F#           =>  --  02F87F
          (((5930, 5930), (5930, 5930)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#80#           =>  --  02F880
          (((5931, 5931), (5931, 5931)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#81#           =>  --  02F881
          (((5932, 5932), (5932, 5932)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#82#           =>  --  02F882
          (((5933, 5933), (5933, 5933)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#83#           =>  --  02F883
          (((5934, 5934), (5934, 5934)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#84#           =>  --  02F884
          (((5935, 5935), (5935, 5935)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#85#           =>  --  02F885
          (((5936, 5936), (5936, 5936)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#86#           =>  --  02F886
          (((5937, 5937), (5937, 5937)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#87#           =>  --  02F887
          (((5938, 5938), (5938, 5938)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#88#           =>  --  02F888
          (((5939, 5939), (5939, 5939)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#89#           =>  --  02F889
          (((5940, 5940), (5940, 5940)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#8A#           =>  --  02F88A
          (((5941, 5941), (5941, 5941)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#8B#           =>  --  02F88B
          (((5942, 5942), (5942, 5942)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#8C#           =>  --  02F88C
          (((5943, 5943), (5943, 5943)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#8D#           =>  --  02F88D
          (((5944, 5944), (5944, 5944)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#8E#           =>  --  02F88E
          (((4306, 4306), (4306, 4306)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#8F#           =>  --  02F88F
          (((5945, 5945), (5945, 5945)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#90#           =>  --  02F890
          (((2768, 2768), (2768, 2768)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#91# .. 16#92# =>  --  02F891 .. 02F892
          (((5946, 5946), (5946, 5946)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#93#           =>  --  02F893
          (((5947, 5947), (5947, 5947)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#94# .. 16#95# =>  --  02F894 .. 02F895
          (((5948, 5948), (5948, 5948)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#96#           =>  --  02F896
          (((5949, 5949), (5949, 5949)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#97#           =>  --  02F897
          (((5950, 5950), (5950, 5950)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#98#           =>  --  02F898
          (((5951, 5951), (5951, 5951)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#99#           =>  --  02F899
          (((5952, 5952), (5952, 5952)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#9A#           =>  --  02F89A
          (((5953, 5953), (5953, 5953)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#9B#           =>  --  02F89B
          (((5954, 5954), (5954, 5954)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#9C#           =>  --  02F89C
          (((5955, 5955), (5955, 5955)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#9D#           =>  --  02F89D
          (((5956, 5956), (5956, 5956)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#9E#           =>  --  02F89E
          (((5957, 5957), (5957, 5957)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#9F#           =>  --  02F89F
          (((5958, 5958), (5958, 5958)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#A0#           =>  --  02F8A0
          (((5959, 5959), (5959, 5959)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#A1#           =>  --  02F8A1
          (((5960, 5960), (5960, 5960)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#A2#           =>  --  02F8A2
          (((5961, 5961), (5961, 5961)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#A3#           =>  --  02F8A3
          (((4553, 4553), (4553, 4553)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#A4#           =>  --  02F8A4
          (((5962, 5962), (5962, 5962)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#A5#           =>  --  02F8A5
          (((5963, 5963), (5963, 5963)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#A6#           =>  --  02F8A6
          (((5964, 5964), (5964, 5964)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#A7#           =>  --  02F8A7
          (((5965, 5965), (5965, 5965)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#A8#           =>  --  02F8A8
          (((4618, 4618), (4618, 4618)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#A9#           =>  --  02F8A9
          (((5965, 5965), (5965, 5965)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#AA#           =>  --  02F8AA
          (((5966, 5966), (5966, 5966)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#AB#           =>  --  02F8AB
          (((4555, 4555), (4555, 4555)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#AC#           =>  --  02F8AC
          (((5967, 5967), (5967, 5967)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#AD#           =>  --  02F8AD
          (((5968, 5968), (5968, 5968)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#AE#           =>  --  02F8AE
          (((5969, 5969), (5969, 5969)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#AF#           =>  --  02F8AF
          (((5970, 5970), (5970, 5970)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#B0#           =>  --  02F8B0
          (((4556, 4556), (4556, 4556)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#B1#           =>  --  02F8B1
          (((4279, 4279), (4279, 4279)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#B2#           =>  --  02F8B2
          (((3943, 3943), (3943, 3943)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#B3#           =>  --  02F8B3
          (((5971, 5971), (5971, 5971)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#B4#           =>  --  02F8B4
          (((5972, 5972), (5972, 5972)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#B5#           =>  --  02F8B5
          (((5973, 5973), (5973, 5973)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#B6#           =>  --  02F8B6
          (((5974, 5974), (5974, 5974)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#B7#           =>  --  02F8B7
          (((5975, 5975), (5975, 5975)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#B8#           =>  --  02F8B8
          (((5976, 5976), (5976, 5976)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#B9#           =>  --  02F8B9
          (((5977, 5977), (5977, 5977)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#BA#           =>  --  02F8BA
          (((5978, 5978), (5978, 5978)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#BB#           =>  --  02F8BB
          (((5979, 5979), (5979, 5979)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#BC#           =>  --  02F8BC
          (((5980, 5980), (5980, 5980)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#BD#           =>  --  02F8BD
          (((5981, 5981), (5981, 5981)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#BE#           =>  --  02F8BE
          (((5982, 5982), (5982, 5982)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#BF#           =>  --  02F8BF
          (((5983, 5983), (5983, 5983)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#C0#           =>  --  02F8C0
          (((5984, 5984), (5984, 5984)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#C1#           =>  --  02F8C1
          (((5985, 5985), (5985, 5985)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#C2#           =>  --  02F8C2
          (((5986, 5986), (5986, 5986)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#C3#           =>  --  02F8C3
          (((5987, 5987), (5987, 5987)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#C4#           =>  --  02F8C4
          (((5988, 5988), (5988, 5988)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#C5#           =>  --  02F8C5
          (((5989, 5989), (5989, 5989)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#C6#           =>  --  02F8C6
          (((5990, 5990), (5990, 5990)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#C7#           =>  --  02F8C7
          (((5991, 5991), (5991, 5991)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#C8#           =>  --  02F8C8
          (((4557, 4557), (4557, 4557)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#C9#           =>  --  02F8C9
          (((5992, 5992), (5992, 5992)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#CA#           =>  --  02F8CA
          (((5993, 5993), (5993, 5993)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#CB#           =>  --  02F8CB
          (((5994, 5994), (5994, 5994)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#CC#           =>  --  02F8CC
          (((5995, 5995), (5995, 5995)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#CD#           =>  --  02F8CD
          (((5996, 5996), (5996, 5996)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#CE#           =>  --  02F8CE
          (((5997, 5997), (5997, 5997)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#CF#           =>  --  02F8CF
          (((4559, 4559), (4559, 4559)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#D0#           =>  --  02F8D0
          (((5998, 5998), (5998, 5998)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#D1#           =>  --  02F8D1
          (((5999, 5999), (5999, 5999)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#D2#           =>  --  02F8D2
          (((6000, 6000), (6000, 6000)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#D3#           =>  --  02F8D3
          (((6001, 6001), (6001, 6001)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#D4#           =>  --  02F8D4
          (((6002, 6002), (6002, 6002)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#D5#           =>  --  02F8D5
          (((6003, 6003), (6003, 6003)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#D6#           =>  --  02F8D6
          (((6004, 6004), (6004, 6004)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#D7#           =>  --  02F8D7
          (((6005, 6005), (6005, 6005)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#D8#           =>  --  02F8D8
          (((4307, 4307), (4307, 4307)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#D9#           =>  --  02F8D9
          (((4626, 4626), (4626, 4626)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#DA#           =>  --  02F8DA
          (((6006, 6006), (6006, 6006)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#DB#           =>  --  02F8DB
          (((6007, 6007), (6007, 6007)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#DC#           =>  --  02F8DC
          (((6008, 6008), (6008, 6008)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#DD#           =>  --  02F8DD
          (((6009, 6009), (6009, 6009)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#DE#           =>  --  02F8DE
          (((6010, 6010), (6010, 6010)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#DF#           =>  --  02F8DF
          (((6011, 6011), (6011, 6011)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#E0#           =>  --  02F8E0
          (((6012, 6012), (6012, 6012)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#E1#           =>  --  02F8E1
          (((6013, 6013), (6013, 6013)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#E2#           =>  --  02F8E2
          (((4560, 4560), (4560, 4560)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#E3#           =>  --  02F8E3
          (((6014, 6014), (6014, 6014)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#E4#           =>  --  02F8E4
          (((6015, 6015), (6015, 6015)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#E5#           =>  --  02F8E5
          (((6016, 6016), (6016, 6016)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#E6#           =>  --  02F8E6
          (((6017, 6017), (6017, 6017)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#E7#           =>  --  02F8E7
          (((4668, 4668), (4668, 4668)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#E8#           =>  --  02F8E8
          (((6018, 6018), (6018, 6018)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#E9#           =>  --  02F8E9
          (((6019, 6019), (6019, 6019)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#EA#           =>  --  02F8EA
          (((6020, 6020), (6020, 6020)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#EB#           =>  --  02F8EB
          (((6021, 6021), (6021, 6021)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#EC#           =>  --  02F8EC
          (((6022, 6022), (6022, 6022)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#ED#           =>  --  02F8ED
          (((6023, 6023), (6023, 6023)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#EE#           =>  --  02F8EE
          (((6024, 6024), (6024, 6024)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#EF#           =>  --  02F8EF
          (((6025, 6025), (6025, 6025)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#F0#           =>  --  02F8F0
          (((6026, 6026), (6026, 6026)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#F1#           =>  --  02F8F1
          (((6027, 6027), (6027, 6027)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#F2#           =>  --  02F8F2
          (((6028, 6028), (6028, 6028)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#F3#           =>  --  02F8F3
          (((6029, 6029), (6029, 6029)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#F4#           =>  --  02F8F4
          (((6030, 6030), (6030, 6030)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#F5#           =>  --  02F8F5
          (((4375, 4375), (4375, 4375)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#F6#           =>  --  02F8F6
          (((6031, 6031), (6031, 6031)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#F7#           =>  --  02F8F7
          (((6032, 6032), (6032, 6032)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#F8#           =>  --  02F8F8
          (((6033, 6033), (6033, 6033)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#F9#           =>  --  02F8F9
          (((6034, 6034), (6034, 6034)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#FA#           =>  --  02F8FA
          (((6035, 6035), (6035, 6035)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#FB#           =>  --  02F8FB
          (((6036, 6036), (6036, 6036)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#FC#           =>  --  02F8FC
          (((6037, 6037), (6037, 6037)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#FD#           =>  --  02F8FD
          (((6038, 6038), (6038, 6038)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#FE#           =>  --  02F8FE
          (((6039, 6039), (6039, 6039)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#FF#           =>  --  02F8FF
          (((6040, 6040), (6040, 6040)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         others           =>
          (((5863, 5863), (5863, 5863)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)));

   Group_02F9 : aliased constant Normalization_Mapping_Second_Stage
     := (16#00#           =>  --  02F900
          (((6041, 6041), (6041, 6041)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#01#           =>  --  02F901
          (((4561, 4561), (4561, 4561)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#02#           =>  --  02F902
          (((4458, 4458), (4458, 4458)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#03#           =>  --  02F903
          (((6042, 6042), (6042, 6042)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#04#           =>  --  02F904
          (((6043, 6043), (6043, 6043)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#05#           =>  --  02F905
          (((6044, 6044), (6044, 6044)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#06#           =>  --  02F906
          (((6045, 6045), (6045, 6045)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#07#           =>  --  02F907
          (((6046, 6046), (6046, 6046)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#08#           =>  --  02F908
          (((6047, 6047), (6047, 6047)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#09#           =>  --  02F909
          (((6048, 6048), (6048, 6048)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#0A#           =>  --  02F90A
          (((6049, 6049), (6049, 6049)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#0B#           =>  --  02F90B
          (((4629, 4629), (4629, 4629)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#0C#           =>  --  02F90C
          (((6050, 6050), (6050, 6050)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#0D#           =>  --  02F90D
          (((6051, 6051), (6051, 6051)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#0E#           =>  --  02F90E
          (((6052, 6052), (6052, 6052)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#0F#           =>  --  02F90F
          (((6053, 6053), (6053, 6053)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#10#           =>  --  02F910
          (((6054, 6054), (6054, 6054)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#11#           =>  --  02F911
          (((6055, 6055), (6055, 6055)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#12#           =>  --  02F912
          (((6056, 6056), (6056, 6056)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#13#           =>  --  02F913
          (((6057, 6057), (6057, 6057)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#14#           =>  --  02F914
          (((4630, 4630), (4630, 4630)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#15#           =>  --  02F915
          (((6058, 6058), (6058, 6058)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#16#           =>  --  02F916
          (((6059, 6059), (6059, 6059)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#17#           =>  --  02F917
          (((6060, 6060), (6060, 6060)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#18#           =>  --  02F918
          (((6061, 6061), (6061, 6061)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#19#           =>  --  02F919
          (((6062, 6062), (6062, 6062)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#1A#           =>  --  02F91A
          (((6063, 6063), (6063, 6063)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#1B#           =>  --  02F91B
          (((6064, 6064), (6064, 6064)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#1C#           =>  --  02F91C
          (((6065, 6065), (6065, 6065)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#1D#           =>  --  02F91D
          (((6066, 6066), (6066, 6066)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#1E#           =>  --  02F91E
          (((6067, 6067), (6067, 6067)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#1F#           =>  --  02F91F
          (((6068, 6068), (6068, 6068)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#20#           =>  --  02F920
          (((6069, 6069), (6069, 6069)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#21#           =>  --  02F921
          (((4632, 4632), (4632, 4632)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#22#           =>  --  02F922
          (((6070, 6070), (6070, 6070)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#23#           =>  --  02F923
          (((6071, 6071), (6071, 6071)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#24#           =>  --  02F924
          (((6072, 6072), (6072, 6072)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#25#           =>  --  02F925
          (((6073, 6073), (6073, 6073)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#26#           =>  --  02F926
          (((6074, 6074), (6074, 6074)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#27#           =>  --  02F927
          (((6075, 6075), (6075, 6075)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#28#           =>  --  02F928
          (((6076, 6076), (6076, 6076)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#29#           =>  --  02F929
          (((6077, 6077), (6077, 6077)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#2A#           =>  --  02F92A
          (((6078, 6078), (6078, 6078)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#2B#           =>  --  02F92B
          (((6079, 6079), (6079, 6079)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#2E#           =>  --  02F92E
          (((6081, 6081), (6081, 6081)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#2F#           =>  --  02F92F
          (((6082, 6082), (6082, 6082)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#30#           =>  --  02F930
          (((4634, 4634), (4634, 4634)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#31#           =>  --  02F931
          (((6083, 6083), (6083, 6083)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#32#           =>  --  02F932
          (((6084, 6084), (6084, 6084)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#33#           =>  --  02F933
          (((6085, 6085), (6085, 6085)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#34#           =>  --  02F934
          (((6086, 6086), (6086, 6086)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#35#           =>  --  02F935
          (((6087, 6087), (6087, 6087)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#36#           =>  --  02F936
          (((6088, 6088), (6088, 6088)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#37#           =>  --  02F937
          (((6089, 6089), (6089, 6089)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#38#           =>  --  02F938
          (((4361, 4361), (4361, 4361)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#39#           =>  --  02F939
          (((6090, 6090), (6090, 6090)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#3A#           =>  --  02F93A
          (((6091, 6091), (6091, 6091)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#3B#           =>  --  02F93B
          (((6092, 6092), (6092, 6092)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#3C#           =>  --  02F93C
          (((6093, 6093), (6093, 6093)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#3D#           =>  --  02F93D
          (((6094, 6094), (6094, 6094)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#3E#           =>  --  02F93E
          (((6095, 6095), (6095, 6095)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#3F#           =>  --  02F93F
          (((6096, 6096), (6096, 6096)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#40#           =>  --  02F940
          (((4640, 4640), (4640, 4640)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#41#           =>  --  02F941
          (((6097, 6097), (6097, 6097)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#42#           =>  --  02F942
          (((6098, 6098), (6098, 6098)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#43#           =>  --  02F943
          (((6099, 6099), (6099, 6099)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#44#           =>  --  02F944
          (((6100, 6100), (6100, 6100)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#45#           =>  --  02F945
          (((6101, 6101), (6101, 6101)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#46# .. 16#47# =>  --  02F946 .. 02F947
          (((6102, 6102), (6102, 6102)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#48#           =>  --  02F948
          (((4641, 4641), (4641, 4641)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#49#           =>  --  02F949
          (((4670, 4670), (4670, 4670)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#4A#           =>  --  02F94A
          (((6103, 6103), (6103, 6103)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#4B#           =>  --  02F94B
          (((6104, 6104), (6104, 6104)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#4C#           =>  --  02F94C
          (((6105, 6105), (6105, 6105)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#4D#           =>  --  02F94D
          (((6106, 6106), (6106, 6106)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#4E#           =>  --  02F94E
          (((6107, 6107), (6107, 6107)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#4F#           =>  --  02F94F
          (((4324, 4324), (4324, 4324)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#50#           =>  --  02F950
          (((4643, 4643), (4643, 4643)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#51#           =>  --  02F951
          (((6108, 6108), (6108, 6108)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#52#           =>  --  02F952
          (((6109, 6109), (6109, 6109)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#53#           =>  --  02F953
          (((4571, 4571), (4571, 4571)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#54#           =>  --  02F954
          (((6110, 6110), (6110, 6110)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#55#           =>  --  02F955
          (((6111, 6111), (6111, 6111)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#56#           =>  --  02F956
          (((4528, 4528), (4528, 4528)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#57#           =>  --  02F957
          (((6112, 6112), (6112, 6112)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#58#           =>  --  02F958
          (((6113, 6113), (6113, 6113)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#59#           =>  --  02F959
          (((4574, 4574), (4574, 4574)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#5A#           =>  --  02F95A
          (((6114, 6114), (6114, 6114)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#5B#           =>  --  02F95B
          (((6115, 6115), (6115, 6115)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#5C#           =>  --  02F95C
          (((6116, 6116), (6116, 6116)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#5D# .. 16#5E# =>  --  02F95D .. 02F95E
          (((6117, 6117), (6117, 6117)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#5F#           =>  --  02F95F
          (((6118, 6118), (6118, 6118)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#60#           =>  --  02F960
          (((6119, 6119), (6119, 6119)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#61#           =>  --  02F961
          (((6120, 6120), (6120, 6120)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#62#           =>  --  02F962
          (((6121, 6121), (6121, 6121)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#63#           =>  --  02F963
          (((6122, 6122), (6122, 6122)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#64#           =>  --  02F964
          (((6123, 6123), (6123, 6123)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#65#           =>  --  02F965
          (((6124, 6124), (6124, 6124)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#66#           =>  --  02F966
          (((6125, 6125), (6125, 6125)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#67#           =>  --  02F967
          (((6126, 6126), (6126, 6126)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#68#           =>  --  02F968
          (((6127, 6127), (6127, 6127)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#69#           =>  --  02F969
          (((6128, 6128), (6128, 6128)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#6A#           =>  --  02F96A
          (((6129, 6129), (6129, 6129)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#6B#           =>  --  02F96B
          (((6130, 6130), (6130, 6130)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#6C#           =>  --  02F96C
          (((6131, 6131), (6131, 6131)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#6D#           =>  --  02F96D
          (((6132, 6132), (6132, 6132)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#6E#           =>  --  02F96E
          (((6133, 6133), (6133, 6133)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#6F#           =>  --  02F96F
          (((6134, 6134), (6134, 6134)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#70#           =>  --  02F970
          (((6135, 6135), (6135, 6135)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#71#           =>  --  02F971
          (((6136, 6136), (6136, 6136)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#72#           =>  --  02F972
          (((6137, 6137), (6137, 6137)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#73#           =>  --  02F973
          (((6138, 6138), (6138, 6138)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#74#           =>  --  02F974
          (((6139, 6139), (6139, 6139)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#75#           =>  --  02F975
          (((6140, 6140), (6140, 6140)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#76#           =>  --  02F976
          (((6141, 6141), (6141, 6141)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#77#           =>  --  02F977
          (((6142, 6142), (6142, 6142)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#78#           =>  --  02F978
          (((6143, 6143), (6143, 6143)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#79#           =>  --  02F979
          (((6144, 6144), (6144, 6144)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#7A#           =>  --  02F97A
          (((4580, 4580), (4580, 4580)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#7B#           =>  --  02F97B
          (((6145, 6145), (6145, 6145)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#7C#           =>  --  02F97C
          (((6146, 6146), (6146, 6146)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#7D#           =>  --  02F97D
          (((6147, 6147), (6147, 6147)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#7E#           =>  --  02F97E
          (((6148, 6148), (6148, 6148)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#7F#           =>  --  02F97F
          (((6149, 6149), (6149, 6149)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#80#           =>  --  02F980
          (((6150, 6150), (6150, 6150)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#81#           =>  --  02F981
          (((6151, 6151), (6151, 6151)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#82#           =>  --  02F982
          (((6152, 6152), (6152, 6152)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#83#           =>  --  02F983
          (((6153, 6153), (6153, 6153)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#84#           =>  --  02F984
          (((6154, 6154), (6154, 6154)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#85#           =>  --  02F985
          (((6155, 6155), (6155, 6155)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#86#           =>  --  02F986
          (((6156, 6156), (6156, 6156)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#87#           =>  --  02F987
          (((6157, 6157), (6157, 6157)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#88#           =>  --  02F988
          (((6158, 6158), (6158, 6158)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#89#           =>  --  02F989
          (((6159, 6159), (6159, 6159)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#8A#           =>  --  02F98A
          (((6160, 6160), (6160, 6160)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#8B#           =>  --  02F98B
          (((5947, 5947), (5947, 5947)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#8C#           =>  --  02F98C
          (((6161, 6161), (6161, 6161)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#8D#           =>  --  02F98D
          (((6162, 6162), (6162, 6162)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#8E#           =>  --  02F98E
          (((6163, 6163), (6163, 6163)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#8F#           =>  --  02F98F
          (((6164, 6164), (6164, 6164)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#90#           =>  --  02F990
          (((6165, 6165), (6165, 6165)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#91#           =>  --  02F991
          (((6166, 6166), (6166, 6166)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#92#           =>  --  02F992
          (((6167, 6167), (6167, 6167)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#93#           =>  --  02F993
          (((6168, 6168), (6168, 6168)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#94#           =>  --  02F994
          (((6169, 6169), (6169, 6169)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#95#           =>  --  02F995
          (((6170, 6170), (6170, 6170)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#96#           =>  --  02F996
          (((6171, 6171), (6171, 6171)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#97#           =>  --  02F997
          (((6172, 6172), (6172, 6172)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#98#           =>  --  02F998
          (((4378, 4378), (4378, 4378)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#99#           =>  --  02F999
          (((6173, 6173), (6173, 6173)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#9A#           =>  --  02F99A
          (((6174, 6174), (6174, 6174)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#9B#           =>  --  02F99B
          (((6175, 6175), (6175, 6175)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#9C#           =>  --  02F99C
          (((6176, 6176), (6176, 6176)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#9D#           =>  --  02F99D
          (((6177, 6177), (6177, 6177)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#9E#           =>  --  02F99E
          (((6178, 6178), (6178, 6178)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#9F#           =>  --  02F99F
          (((4583, 4583), (4583, 4583)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#A0#           =>  --  02F9A0
          (((6179, 6179), (6179, 6179)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#A1#           =>  --  02F9A1
          (((6180, 6180), (6180, 6180)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#A2#           =>  --  02F9A2
          (((6181, 6181), (6181, 6181)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#A3#           =>  --  02F9A3
          (((6182, 6182), (6182, 6182)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#A4#           =>  --  02F9A4
          (((6183, 6183), (6183, 6183)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#A5#           =>  --  02F9A5
          (((6184, 6184), (6184, 6184)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#A6#           =>  --  02F9A6
          (((6185, 6185), (6185, 6185)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#A7#           =>  --  02F9A7
          (((6186, 6186), (6186, 6186)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#A8#           =>  --  02F9A8
          (((6187, 6187), (6187, 6187)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#A9#           =>  --  02F9A9
          (((6188, 6188), (6188, 6188)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#AA#           =>  --  02F9AA
          (((6189, 6189), (6189, 6189)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#AB#           =>  --  02F9AB
          (((6190, 6190), (6190, 6190)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#AC#           =>  --  02F9AC
          (((6191, 6191), (6191, 6191)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#AD#           =>  --  02F9AD
          (((6192, 6192), (6192, 6192)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#AE#           =>  --  02F9AE
          (((6193, 6193), (6193, 6193)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#AF#           =>  --  02F9AF
          (((6194, 6194), (6194, 6194)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#B0#           =>  --  02F9B0
          (((6195, 6195), (6195, 6195)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#B1#           =>  --  02F9B1
          (((6196, 6196), (6196, 6196)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#B2#           =>  --  02F9B2
          (((6197, 6197), (6197, 6197)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#B3#           =>  --  02F9B3
          (((6198, 6198), (6198, 6198)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#B4#           =>  --  02F9B4
          (((4319, 4319), (4319, 4319)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#B5#           =>  --  02F9B5
          (((6199, 6199), (6199, 6199)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#B6#           =>  --  02F9B6
          (((6200, 6200), (6200, 6200)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#B7#           =>  --  02F9B7
          (((6201, 6201), (6201, 6201)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#B8#           =>  --  02F9B8
          (((6202, 6202), (6202, 6202)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#B9#           =>  --  02F9B9
          (((6203, 6203), (6203, 6203)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#BA#           =>  --  02F9BA
          (((6204, 6204), (6204, 6204)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#BB#           =>  --  02F9BB
          (((4650, 4650), (4650, 4650)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#BC#           =>  --  02F9BC
          (((6205, 6205), (6205, 6205)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#BD#           =>  --  02F9BD
          (((6206, 6206), (6206, 6206)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#BE#           =>  --  02F9BE
          (((6207, 6207), (6207, 6207)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#BF#           =>  --  02F9BF
          (((6208, 6208), (6208, 6208)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#C0#           =>  --  02F9C0
          (((6209, 6209), (6209, 6209)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#C1#           =>  --  02F9C1
          (((6210, 6210), (6210, 6210)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#C2#           =>  --  02F9C2
          (((6211, 6211), (6211, 6211)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#C3#           =>  --  02F9C3
          (((6212, 6212), (6212, 6212)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#C4#           =>  --  02F9C4
          (((2858, 2858), (2858, 2858)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#C5#           =>  --  02F9C5
          (((6213, 6213), (6213, 6213)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#C6#           =>  --  02F9C6
          (((6214, 6214), (6214, 6214)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#C7#           =>  --  02F9C7
          (((6215, 6215), (6215, 6215)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#C8#           =>  --  02F9C8
          (((6216, 6216), (6216, 6216)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#C9#           =>  --  02F9C9
          (((6217, 6217), (6217, 6217)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#CA#           =>  --  02F9CA
          (((6218, 6218), (6218, 6218)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#CB#           =>  --  02F9CB
          (((6219, 6219), (6219, 6219)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#CC#           =>  --  02F9CC
          (((6220, 6220), (6220, 6220)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#CD#           =>  --  02F9CD
          (((6221, 6221), (6221, 6221)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#CE#           =>  --  02F9CE
          (((6222, 6222), (6222, 6222)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#CF#           =>  --  02F9CF
          (((6223, 6223), (6223, 6223)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#D0#           =>  --  02F9D0
          (((4655, 4655), (4655, 4655)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#D1#           =>  --  02F9D1
          (((4656, 4656), (4656, 4656)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#D2#           =>  --  02F9D2
          (((2865, 2865), (2865, 2865)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#D3#           =>  --  02F9D3
          (((6224, 6224), (6224, 6224)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#D4#           =>  --  02F9D4
          (((6225, 6225), (6225, 6225)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#D5#           =>  --  02F9D5
          (((6226, 6226), (6226, 6226)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#D6#           =>  --  02F9D6
          (((6227, 6227), (6227, 6227)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#D7#           =>  --  02F9D7
          (((6228, 6228), (6228, 6228)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#D8#           =>  --  02F9D8
          (((6229, 6229), (6229, 6229)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#D9#           =>  --  02F9D9
          (((6230, 6230), (6230, 6230)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#DA#           =>  --  02F9DA
          (((6231, 6231), (6231, 6231)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#DB#           =>  --  02F9DB
          (((6232, 6232), (6232, 6232)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#DC#           =>  --  02F9DC
          (((6233, 6233), (6233, 6233)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#DD#           =>  --  02F9DD
          (((6234, 6234), (6234, 6234)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#DE#           =>  --  02F9DE
          (((6235, 6235), (6235, 6235)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#DF#           =>  --  02F9DF
          (((4657, 4657), (4657, 4657)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#E0#           =>  --  02F9E0
          (((6236, 6236), (6236, 6236)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#E1#           =>  --  02F9E1
          (((6237, 6237), (6237, 6237)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#E2#           =>  --  02F9E2
          (((6238, 6238), (6238, 6238)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#E3#           =>  --  02F9E3
          (((6239, 6239), (6239, 6239)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#E4#           =>  --  02F9E4
          (((6240, 6240), (6240, 6240)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#E5#           =>  --  02F9E5
          (((6241, 6241), (6241, 6241)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#E6#           =>  --  02F9E6
          (((6242, 6242), (6242, 6242)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#E7#           =>  --  02F9E7
          (((6243, 6243), (6243, 6243)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#E8#           =>  --  02F9E8
          (((6244, 6244), (6244, 6244)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#E9#           =>  --  02F9E9
          (((6245, 6245), (6245, 6245)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#EA#           =>  --  02F9EA
          (((6246, 6246), (6246, 6246)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#EB#           =>  --  02F9EB
          (((6247, 6247), (6247, 6247)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#EC#           =>  --  02F9EC
          (((6248, 6248), (6248, 6248)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#ED#           =>  --  02F9ED
          (((6249, 6249), (6249, 6249)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#EE#           =>  --  02F9EE
          (((6250, 6250), (6250, 6250)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#EF#           =>  --  02F9EF
          (((6251, 6251), (6251, 6251)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#F0#           =>  --  02F9F0
          (((6252, 6252), (6252, 6252)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#F1#           =>  --  02F9F1
          (((6253, 6253), (6253, 6253)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#F2#           =>  --  02F9F2
          (((6254, 6254), (6254, 6254)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#F3#           =>  --  02F9F3
          (((6255, 6255), (6255, 6255)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#F4#           =>  --  02F9F4
          (((6256, 6256), (6256, 6256)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#F5#           =>  --  02F9F5
          (((6257, 6257), (6257, 6257)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#F6#           =>  --  02F9F6
          (((6258, 6258), (6258, 6258)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#F7#           =>  --  02F9F7
          (((6259, 6259), (6259, 6259)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#F8#           =>  --  02F9F8
          (((6260, 6260), (6260, 6260)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#F9#           =>  --  02F9F9
          (((6261, 6261), (6261, 6261)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#FA#           =>  --  02F9FA
          (((6262, 6262), (6262, 6262)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#FB#           =>  --  02F9FB
          (((6263, 6263), (6263, 6263)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#FC#           =>  --  02F9FC
          (((6264, 6264), (6264, 6264)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#FD#           =>  --  02F9FD
          (((6265, 6265), (6265, 6265)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#FE# .. 16#FF# =>  --  02F9FE .. 02F9FF
          (((4663, 4663), (4663, 4663)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         others           =>
          (((6080, 6080), (6080, 6080)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)));

   Group_02FA : aliased constant Normalization_Mapping_Second_Stage
     := (16#00#           =>  --  02FA00
          (((6266, 6266), (6266, 6266)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#01#           =>  --  02FA01
          (((6267, 6267), (6267, 6267)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#02#           =>  --  02FA02
          (((6268, 6268), (6268, 6268)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#03#           =>  --  02FA03
          (((6269, 6269), (6269, 6269)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#04#           =>  --  02FA04
          (((6270, 6270), (6270, 6270)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#05#           =>  --  02FA05
          (((6271, 6271), (6271, 6271)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#06#           =>  --  02FA06
          (((6272, 6272), (6272, 6272)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#07#           =>  --  02FA07
          (((6273, 6273), (6273, 6273)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#08#           =>  --  02FA08
          (((6274, 6274), (6274, 6274)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#09#           =>  --  02FA09
          (((6275, 6275), (6275, 6275)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#0A#           =>  --  02FA0A
          (((4664, 4664), (4664, 4664)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#0B#           =>  --  02FA0B
          (((6276, 6276), (6276, 6276)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#0C#           =>  --  02FA0C
          (((6277, 6277), (6277, 6277)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#0D#           =>  --  02FA0D
          (((6278, 6278), (6278, 6278)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#0E#           =>  --  02FA0E
          (((6279, 6279), (6279, 6279)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#0F#           =>  --  02FA0F
          (((6280, 6280), (6280, 6280)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#10#           =>  --  02FA10
          (((6281, 6281), (6281, 6281)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#11#           =>  --  02FA11
          (((6282, 6282), (6282, 6282)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#12#           =>  --  02FA12
          (((6283, 6283), (6283, 6283)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#13#           =>  --  02FA13
          (((6284, 6284), (6284, 6284)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#14#           =>  --  02FA14
          (((6285, 6285), (6285, 6285)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#15#           =>  --  02FA15
          (((2913, 2913), (2913, 2913)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#16#           =>  --  02FA16
          (((6286, 6286), (6286, 6286)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#17#           =>  --  02FA17
          (((2917, 2917), (2917, 2917)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#18#           =>  --  02FA18
          (((6287, 6287), (6287, 6287)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#19#           =>  --  02FA19
          (((6288, 6288), (6288, 6288)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#1A#           =>  --  02FA1A
          (((6289, 6289), (6289, 6289)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#1B#           =>  --  02FA1B
          (((6290, 6290), (6290, 6290)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#1C#           =>  --  02FA1C
          (((2922, 2922), (2922, 2922)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         16#1D#           =>  --  02FA1D
          (((6291, 6291), (6291, 6291)), (0, 0), 0, (No, No, No, No), Canonical,
           (Full_Composition_Exclusion => True,
            others => False)),
         others           =>
          (((0, 0), (0, 0)), (0, 0), 0, (Yes, Yes, Yes, Yes), None,
           (others => False)));

   Mapping : aliased constant Normalization_Mapping_First_Stage
     := (16#0000# => Group_0000'Access, 16#0001# => Group_0001'Access,
         16#0002# => Group_0002'Access, 16#0003# => Group_0003'Access,
         16#0004# => Group_0004'Access, 16#0005# => Group_0005'Access,
         16#0006# => Group_0006'Access, 16#0007# => Group_0007'Access,
         16#0008# => Group_0008'Access, 16#0009# => Group_0009'Access,
         16#000A# => Group_000A'Access, 16#000B# => Group_000B'Access,
         16#000C# => Group_000C'Access, 16#000D# => Group_000D'Access,
         16#000E# => Group_000E'Access, 16#000F# => Group_000F'Access,
         16#0010# => Group_0010'Access, 16#0011# => Group_0011'Access,
         16#0013# => Group_0013'Access, 16#0017# => Group_0017'Access,
         16#0018# => Group_0018'Access, 16#0019# => Group_0019'Access,
         16#001A# => Group_001A'Access, 16#001B# => Group_001B'Access,
         16#001C# => Group_001C'Access, 16#001D# => Group_001D'Access,
         16#001E# => Group_001E'Access, 16#001F# => Group_001F'Access,
         16#0020# => Group_0020'Access, 16#0021# => Group_0021'Access,
         16#0022# => Group_0022'Access, 16#0023# => Group_0023'Access,
         16#0024# => Group_0024'Access, 16#002A# => Group_002A'Access,
         16#002C# => Group_002C'Access, 16#002D# => Group_002D'Access,
         16#002E# => Group_002E'Access, 16#002F# => Group_002F'Access,
         16#0030# => Group_0030'Access, 16#0031# => Group_0031'Access,
         16#0032# => Group_0032'Access, 16#0033# => Group_0033'Access,
         16#00A6# => Group_00A6'Access, 16#00A7# => Group_00A7'Access,
         16#00A8# => Group_00A8'Access, 16#00A9# => Group_00A9'Access,
         16#00AA# => Group_00AA'Access, 16#00AB# => Group_00AB'Access,
         16#00AC# => Group_00AC'Access, 16#00AD# => Group_00AC'Access,
         16#00AE# => Group_00AC'Access, 16#00AF# => Group_00AC'Access,
         16#00B0# => Group_00AC'Access, 16#00B1# => Group_00AC'Access,
         16#00B2# => Group_00AC'Access, 16#00B3# => Group_00AC'Access,
         16#00B4# => Group_00AC'Access, 16#00B5# => Group_00AC'Access,
         16#00B6# => Group_00AC'Access, 16#00B7# => Group_00AC'Access,
         16#00B8# => Group_00AC'Access, 16#00B9# => Group_00AC'Access,
         16#00BA# => Group_00AC'Access, 16#00BB# => Group_00AC'Access,
         16#00BC# => Group_00AC'Access, 16#00BD# => Group_00AC'Access,
         16#00BE# => Group_00AC'Access, 16#00BF# => Group_00AC'Access,
         16#00C0# => Group_00AC'Access, 16#00C1# => Group_00AC'Access,
         16#00C2# => Group_00AC'Access, 16#00C3# => Group_00AC'Access,
         16#00C4# => Group_00AC'Access, 16#00C5# => Group_00AC'Access,
         16#00C6# => Group_00AC'Access, 16#00C7# => Group_00AC'Access,
         16#00C8# => Group_00AC'Access, 16#00C9# => Group_00AC'Access,
         16#00CA# => Group_00AC'Access, 16#00CB# => Group_00AC'Access,
         16#00CC# => Group_00AC'Access, 16#00CD# => Group_00AC'Access,
         16#00CE# => Group_00AC'Access, 16#00CF# => Group_00AC'Access,
         16#00D0# => Group_00AC'Access, 16#00D1# => Group_00AC'Access,
         16#00D2# => Group_00AC'Access, 16#00D3# => Group_00AC'Access,
         16#00D4# => Group_00AC'Access, 16#00D5# => Group_00AC'Access,
         16#00D6# => Group_00AC'Access, 16#00D7# => Group_00D7'Access,
         16#00F9# => Group_00F9'Access, 16#00FA# => Group_00FA'Access,
         16#00FB# => Group_00FB'Access, 16#00FC# => Group_00FC'Access,
         16#00FD# => Group_00FD'Access, 16#00FE# => Group_00FE'Access,
         16#00FF# => Group_00FF'Access, 16#0101# => Group_0101'Access,
         16#0102# => Group_0102'Access, 16#0103# => Group_0103'Access,
         16#010A# => Group_010A'Access, 16#0110# => Group_0110'Access,
         16#0111# => Group_0111'Access, 16#0112# => Group_0112'Access,
         16#0113# => Group_0113'Access, 16#0114# => Group_0114'Access,
         16#0115# => Group_0115'Access, 16#0116# => Group_0116'Access,
         16#016A# => Group_016A'Access, 16#016B# => Group_016B'Access,
         16#01BC# => Group_01BC'Access, 16#01D1# => Group_01D1'Access,
         16#01D2# => Group_01D2'Access, 16#01D4# => Group_01D4'Access,
         16#01D5# => Group_01D5'Access, 16#01D6# => Group_01D6'Access,
         16#01D7# => Group_01D7'Access, 16#01E8# => Group_01E8'Access,
         16#01EE# => Group_01EE'Access, 16#01F1# => Group_01F1'Access,
         16#01F2# => Group_01F2'Access, 16#02F8# => Group_02F8'Access,
         16#02F9# => Group_02F9'Access, 16#02FA# => Group_02FA'Access,
         others   => Group_0012'Access);

end Matreshka.Internals.Unicode.Ucd.Norms;
